/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(B){for(var t=[],P=0,F=B.length;P<F;P++)t[P]=ie[B[P]];return t};const Ve=this,ze=typeof global=="object"?global:{};var fe;(function(B){B.global=Ve;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}B.Environment=t})(fe||(fe={}));var fe;(function(B){class t{constructor(f,w,h){this.type=f,this.detail=w,this.timestamp=h}}B.LoaderEvent=t;class P{constructor(f){this._events=[new t(1,"",f)]}record(f,w){this._events.push(new t(f,w,B.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}B.LoaderEventRecorder=P;class F{record(f,w){}getEvents(){return[]}}F.INSTANCE=new F,B.NullLoaderEventRecorder=F})(fe||(fe={}));var fe;(function(B){class t{static fileUriToFilePath(F,r){if(r=decodeURI(r).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(F,r){return F.length>=r.length&&F.substr(0,r.length)===r}static endsWith(F,r){return F.length>=r.length&&F.substr(F.length-r.length)===r}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,r){if(F){let f;for(f in F)F.hasOwnProperty(f)&&r(f,F[f])}}static isEmpty(F){let r=!0;return t.forEachProperty(F,()=>{r=!1}),r}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let r=Array.isArray(F)?[]:{};return t.forEachProperty(F,(f,w)=>{w&&typeof w=="object"?r[f]=t.recursiveClone(w):r[f]=w}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,B.Utilities=t})(fe||(fe={}));var fe;(function(B){function t(r){if(r instanceof Error)return r;const f=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(f.stack=r.stack),f}B.ensureError=t;class P{static validateConfigurationOptions(f){function w(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=w),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(B.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,w=null){let h=B.Utilities.recursiveClone(w||{});return B.Utilities.forEachProperty(f,(u,l)=>{u==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(l):u==="paths"&&typeof h.paths<"u"?B.Utilities.forEachProperty(l,(g,N)=>h.paths[g]=N):u==="config"&&typeof h.config<"u"?B.Utilities.forEachProperty(l,(g,N)=>h.config[g]=N):h[u]=B.Utilities.recursiveClone(l)}),P.validateConfigurationOptions(h)}}B.ConfigurationOptionsUtil=P;class F{constructor(f,w){if(this._env=f,this.options=P.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,u=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,u+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,(f,w)=>{Array.isArray(w)?this.sortedPathsRules.push({from:f,to:w}):this.sortedPathsRules.push({from:f,to:[w]})}),this.sortedPathsRules.sort((f,w)=>w.from.length-f.from.length)}cloneAndMerge(f){return new F(this._env,P.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let w;for(let h=0,u=this.sortedPathsRules.length;h<u;h++)if(w=this.sortedPathsRules[h],B.Utilities.startsWith(f,w.from)){let l=[];for(let g=0,N=w.to.length;g<N;g++)l.push(w.to[g]+f.substr(w.from.length));return l}return[f]}_addUrlArgsToUrl(f){return B.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let w=0,h=f.length;w<h;w++)f[w]=this._addUrlArgsToUrl(f[w]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let w=f,h;if(!B.Utilities.endsWith(w,".js")&&!B.Utilities.isAbsolutePath(w)){h=this._applyPaths(w);for(let u=0,l=h.length;u<l;u++)this.isBuild()&&h[u]==="empty:"||(B.Utilities.isAbsolutePath(h[u])||(h[u]=this.options.baseUrl+h[u]),!B.Utilities.endsWith(h[u],".js")&&!B.Utilities.containsQueryString(h[u])&&(h[u]=h[u]+".js"))}else!B.Utilities.endsWith(w,".js")&&!B.Utilities.containsQueryString(w)&&(w=w+".js"),h=[w];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let w=f;return B.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],B.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}B.Configuration=F})(fe||(fe={}));var fe;(function(B){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,g,N,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new P:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new P;let m={callback:N,errorback:b};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(m);return}this._callbackMap[g]=[m],this._scriptLoader.load(l,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(l){let g=this._callbackMap[l];delete this._callbackMap[l];for(let N=0;N<g.length;N++)g[N].callback()}triggerErrorback(l,g){let N=this._callbackMap[l];delete this._callbackMap[l];for(let b=0;b<N.length;b++)N[b].errorback(g)}}class P{attachListeners(l,g,N){let b=()=>{l.removeEventListener("load",m),l.removeEventListener("error",e)},m=p=>{b(),g()},e=p=>{b(),N(p)};l.addEventListener("load",m),l.addEventListener("error",e)}load(l,g,N,b){if(/^node\|/.test(g)){let m=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),m.nodeRequire||B.global.nodeRequire),p=g.split("|"),E=null;try{E=e(p[1])}catch(M){b(M);return}l.enqueueDefineAnonymousModule([],()=>E),N()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,N,b);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),m.setAttribute("src",g);const{cspNonce:p}=l.getConfig().getOptionsLiteral();p&&m.setAttribute("nonce",p),document.getElementsByTagName("head")[0].appendChild(m)}}}function F(u){const{trustedTypesPolicy:l}=u.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(l)),this._cachedCanUseEval}load(l,g,N,b){if(/^node\|/.test(g)){const m=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),m.nodeRequire||B.global.nodeRequire),p=g.split("|");let E=null;try{E=e(p[1])}catch(M){b(M);return}l.enqueueDefineAnonymousModule([],function(){return E}),N()}else{const{trustedTypesPolicy:m}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(g).then(p=>{if(p.status!==200)throw new Error(p.statusText);return p.text()}).then(p=>{p=`${p}
//# sourceURL=${g}`,(m?self.eval(m.createScript("",p)):new Function(p)).call(self),N()}).then(void 0,b);return}try{m&&(g=m.createScriptURL(g)),importScripts(g),N()}catch(p){b(p)}}}}class f{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,g){const{nodeCachedData:N}=g.getConfig().getOptionsLiteral();if(!N||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,m=l("module");function e(p){const E=p.constructor;let M=function(c){try{return p.require(c)}finally{}};return M.resolve=function(c,o){return E._resolveFilename(c,p,!1,o)},M.resolve.paths=function(c){return E._resolveLookupPaths(c,p)},M.main=process.mainModule,M.extensions=E._extensions,M.cache=E._cache,M}m.prototype._compile=function(p,E){const M=m.wrap(p.replace(/^#!.*/,"")),_=g.getRecorder(),c=b._getCachedDataPath(N,E),o={filename:E};let s;try{const R=b._fs.readFileSync(c);s=R.slice(0,16),o.cachedData=R.slice(16),_.record(60,c)}catch{_.record(61,c)}const i=new b._vm.Script(M,o),a=i.runInThisContext(o),v=b._path.dirname(E),d=e(this),L=[this.exports,d,this,E,v,process,ze,Buffer],A=a.apply(this.exports,L);return b._handleCachedData(i,M,c,!o.cachedData,g),b._verifyCachedData(i,M,c,s,g),A}}load(l,g,N,b){const m=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),m.nodeRequire||B.global.nodeRequire),p=m.nodeInstrumenter||function(M){return M};this._init(e),this._initNodeRequire(e,l);let E=l.getRecorder();if(/^node\|/.test(g)){let M=g.split("|"),_=null;try{_=e(M[1])}catch(c){b(c);return}l.enqueueDefineAnonymousModule([],()=>_),N()}else{g=B.Utilities.fileUriToFilePath(this._env.isWindows,g);const M=this._path.normalize(g),_=this._getElectronRendererScriptPathOrUri(M),c=!!m.nodeCachedData,o=c?this._getCachedDataPath(m.nodeCachedData,g):void 0;this._readSourceAndCachedData(M,o,E,(s,i,a,v)=>{if(s){b(s);return}let d;i.charCodeAt(0)===f._BOM?d=f._PREFIX+i.substring(1)+f._SUFFIX:d=f._PREFIX+i+f._SUFFIX,d=p(d,M);const L={filename:_,cachedData:a},A=this._createAndEvalScript(l,d,L,N,b);this._handleCachedData(A,d,o,c&&!a,l),this._verifyCachedData(A,d,o,v,l)})}}_createAndEvalScript(l,g,N,b,m){const e=l.getRecorder();e.record(31,N.filename);const p=new this._vm.Script(g,N),E=p.runInThisContext(N),M=l.getGlobalAMDDefineFunc();let _=!1;const c=function(){return _=!0,M.apply(null,arguments)};return c.amd=M.amd,E.call(B.global,l.getGlobalAMDRequireFunc(),c,N.filename,this._path.dirname(N.filename)),e.record(32,N.filename),_?b():m(new Error(`Didn't receive define call in ${N.filename}!`)),p}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let g=l.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,g){const N=this._crypto.createHash("md5").update(g,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(g).replace(/\.js$/,"");return this._path.join(l.path,`${b}-${N}.code`)}_handleCachedData(l,g,N,b,m){l.cachedDataRejected?this._fs.unlink(N,e=>{m.getRecorder().record(62,N),this._createAndWriteCachedData(l,g,N,m),e&&m.getConfig().onError(e)}):b&&this._createAndWriteCachedData(l,g,N,m)}_createAndWriteCachedData(l,g,N,b){let m=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,p=0,E;const M=()=>{setTimeout(()=>{E||(E=this._crypto.createHash("md5").update(g,"utf8").digest());const _=l.createCachedData();if(!(_.length===0||_.length===e||p>=5)){if(_.length<e){M();return}e=_.length,this._fs.writeFile(N,Buffer.concat([E,_]),c=>{c&&b.getConfig().onError(c),b.getRecorder().record(63,N),M()})}},m*Math.pow(4,p++))};M()}_readSourceAndCachedData(l,g,N,b){if(!g)this._fs.readFile(l,{encoding:"utf8"},b);else{let m,e,p,E=2;const M=_=>{_?b(_):--E===0&&b(void 0,m,e,p)};this._fs.readFile(l,{encoding:"utf8"},(_,c)=>{m=c,M(_)}),this._fs.readFile(g,(_,c)=>{!_&&c&&c.length>0?(p=c.slice(0,16),e=c.slice(16),N.record(60,g)):N.record(61,g),M()})}}_verifyCachedData(l,g,N,b,m){b&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();b.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${N}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(N,p=>{p&&m.getConfig().onError(p)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function w(u,l){if(l.__$__isRecorded)return l;const g=function(b){u.record(33,b);try{return l(b)}finally{u.record(34,b)}};return g.__$__isRecorded=!0,g}B.ensureRecordedNodeRequire=w;function h(u){return new t(u)}B.createScriptLoader=h})(fe||(fe={}));var fe;(function(B){class t{constructor(u){let l=u.lastIndexOf("/");l!==-1?this.fromModulePath=u.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(u){let l=u,g;for(g=/\/\.\//;g.test(l);)l=l.replace(g,"/");for(l=l.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(l);)l=l.replace(g,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(u){let l=u;return B.Utilities.isAbsolutePath(l)||(B.Utilities.startsWith(l,"./")||B.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),B.ModuleIdResolver=t;class P{constructor(u,l,g,N,b,m){this.id=u,this.strId=l,this.dependencies=g,this._callback=N,this._errorback=b,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(u,l){try{return{returnedValue:u.apply(B.global,l),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(u,l,g,N){return u.shouldInvokeFactory(l)?u.shouldCatchError()?this._safeInvokeFunction(g,N):{returnedValue:g.apply(B.global,N),producedError:null}:{returnedValue:null,producedError:null}}complete(u,l,g,N){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);let m=P._invokeFactory(l,this.strId,this._callback,g);b=m.producedError,u.record(22,this.strId),!b&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(b){let m=B.ensureError(b);m.phase="factory",m.moduleId=this.strId,m.neededBy=N(this.id),this.error=m,l.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1}isComplete(){return this._isComplete}}B.Module=P;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(u){let l=this._strModuleIdToIntModuleId.get(u);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(u,l),this._intModuleIdToStrModuleId[l]=u),l}getStrModuleId(u){return this._intModuleIdToStrModuleId[u]}}class r{constructor(u){this.id=u}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),B.RegularDependency=r;class f{constructor(u,l,g){this.id=u,this.pluginId=l,this.pluginParam=g}}B.PluginDependency=f;class w{constructor(u,l,g,N,b=0){this._env=u,this._scriptLoader=l,this._loaderAvailableTimestamp=b,this._defineFunc=g,this._requireFunc=N,this._moduleIdProvider=new F,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new w(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(u,l){let g=m=>m.replace(/\\/g,"/"),N=g(u),b=l.split(/\n/);for(let m=0;m<b.length;m++){let e=b[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let p=e[1],E=e[2],M=e[3],_=Math.max(p.lastIndexOf(" ")+1,p.lastIndexOf("(")+1);if(p=p.substr(_),p=g(p),p===N){let c={line:parseInt(E,10),col:parseInt(M,10)};return c.line===1&&(c.col-=53),c}}}throw new Error("Could not correlate define call site for needle "+u)}getBuildInfo(){if(!this._config.isBuild())return null;let u=[],l=0;for(let g=0,N=this._modules2.length;g<N;g++){let b=this._modules2[g];if(!b)continue;let m=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,p=this._buildInfoDependencies[b.id];u[l++]={id:b.strId,path:m,defineLocation:m&&e?w._findRelevantLocationInStack(m,e):null,dependencies:p,shim:null,exports:b.exports}}return u}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(u,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:u,callback:l}}defineModule(u,l,g,N,b,m=new t(u)){let e=this._moduleIdProvider.getModuleId(u);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}let p=new P(e,u,this._normalizeDependencies(l,m),g,N,m);this._modules2[e]=p,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(p.dependencies||[]).map(E=>this._moduleIdProvider.getStrModuleId(E.id))),this._resolve(p)}_normalizeDependency(u,l){if(u==="exports")return r.EXPORTS;if(u==="module")return r.MODULE;if(u==="require")return r.REQUIRE;let g=u.indexOf("!");if(g>=0){let N=l.resolveModule(u.substr(0,g)),b=l.resolveModule(u.substr(g+1)),m=this._moduleIdProvider.getModuleId(N+"!"+b),e=this._moduleIdProvider.getModuleId(N);return new f(m,e,b)}return new r(this._moduleIdProvider.getModuleId(l.resolveModule(u)))}_normalizeDependencies(u,l){let g=[],N=0;for(let b=0,m=u.length;b<m;b++)g[N++]=this._normalizeDependency(u[b],l);return g}_relativeRequire(u,l,g,N){if(typeof l=="string")return this.synchronousRequire(l,u);this.defineModule(B.Utilities.generateAnonymousModule(),l,g,N,null,u)}synchronousRequire(u,l=new t(u)){let g=this._normalizeDependency(u,l),N=this._modules2[g.id];if(!N)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!N.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(N.error)throw N.error;return N.exports}configure(u,l){let g=this._config.shouldRecordStats();l?this._config=new B.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(u){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),l.dependencies,l.callback,null,l.stack)}}_createLoadError(u,l){let g=this._moduleIdProvider.getStrModuleId(u),N=(this._inverseDependencies2[u]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const b=B.ensureError(l);return b.phase="loading",b.moduleId=g,b.neededBy=N,b}_onLoadError(u,l){const g=this._createLoadError(u,l);this._modules2[u]||(this._modules2[u]=new P(u,this._moduleIdProvider.getStrModuleId(u),[],()=>{},null,null));let N=[];for(let e=0,p=this._moduleIdProvider.getMaxModuleId();e<p;e++)N[e]=!1;let b=!1,m=[];for(m.push(u),N[u]=!0;m.length>0;){let e=m.shift(),p=this._modules2[e];p&&(b=p.onDependencyError(g)||b);let E=this._inverseDependencies2[e];if(E)for(let M=0,_=E.length;M<_;M++){let c=E[M];N[c]||(m.push(c),N[c]=!0)}}b||this._config.onError(g)}_hasDependencyPath(u,l){let g=this._modules2[u];if(!g)return!1;let N=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)N[m]=!1;let b=[];for(b.push(g),N[u]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let p=0,E=e.length;p<E;p++){let M=e[p];if(M.id===l)return!0;let _=this._modules2[M.id];_&&!N[M.id]&&(N[M.id]=!0,b.push(_))}}return!1}_findCyclePath(u,l,g){if(u===l||g===50)return[u];let N=this._modules2[u];if(!N)return null;let b=N.dependencies;if(b)for(let m=0,e=b.length;m<e;m++){let p=this._findCyclePath(b[m].id,l,g+1);if(p!==null)return p.push(u),p}return null}_createRequire(u){let l=(g,N,b)=>this._relativeRequire(u,g,N,b);return l.toUrl=g=>this._config.requireToUrl(u.resolveModule(g)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(g,N=!1)=>{this.configure(g,N)},l.__$__nodeRequire=B.global.nodeRequire,l}_loadModule(u){if(this._modules2[u]||this._knownModules2[u])return;this._knownModules2[u]=!0;let l=this._moduleIdProvider.getStrModuleId(u),g=this._config.moduleIdToPaths(l),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||N.test(l))&&g.push("node|"+l);let b=-1,m=e=>{if(b++,b>=g.length)this._onLoadError(u,e);else{let p=g[b],E=this.getRecorder();if(this._config.isBuild()&&p==="empty:"){this._buildInfoPath[u]=p,this.defineModule(this._moduleIdProvider.getStrModuleId(u),[],null,null,null),this._onLoad(u);return}E.record(10,p),this._scriptLoader.load(this,p,()=>{this._config.isBuild()&&(this._buildInfoPath[u]=p),E.record(11,p),this._onLoad(u)},M=>{E.record(12,p),m(M)})}};m(null)}_loadPluginDependency(u,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let g=N=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],N,null,null)};g.error=N=>{this._config.onError(this._createLoadError(l.id,N))},u.load(l.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(u){let l=u.dependencies;if(l)for(let g=0,N=l.length;g<N;g++){let b=l[g];if(b===r.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(b===r.MODULE){u.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){u.unresolvedDependenciesCount--;continue}let m=this._modules2[b.id];if(m&&m.isComplete()){if(m.error){u.onDependencyError(m.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,u.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(p=>this._moduleIdProvider.getStrModuleId(p)).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(u.id),b instanceof f){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let p=this._inversePluginDependencies2.get(b.pluginId);p||(p=[],this._inversePluginDependencies2.set(b.pluginId,p)),p.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}_onModuleComplete(u){let l=this.getRecorder();if(u.isComplete())return;let g=u.dependencies,N=[];if(g)for(let p=0,E=g.length;p<E;p++){let M=g[p];if(M===r.EXPORTS){N[p]=u.exports;continue}if(M===r.MODULE){N[p]={id:u.strId,config:()=>this._config.getConfigForModule(u.strId)};continue}if(M===r.REQUIRE){N[p]=this._createRequire(u.moduleIdResolver);continue}let _=this._modules2[M.id];if(_){N[p]=_.exports;continue}N[p]=null}const b=p=>(this._inverseDependencies2[p]||[]).map(E=>this._moduleIdProvider.getStrModuleId(E));u.complete(l,this._config,N,b);let m=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,m)for(let p=0,E=m.length;p<E;p++){let M=m[p],_=this._modules2[M];_.unresolvedDependenciesCount--,_.unresolvedDependenciesCount===0&&this._onModuleComplete(_)}let e=this._inversePluginDependencies2.get(u.id);if(e){this._inversePluginDependencies2.delete(u.id);for(let p=0,E=e.length;p<E;p++)this._loadPluginDependency(u.exports,e[p])}}}B.ModuleManager=w})(fe||(fe={}));var ne,fe;(function(B){const t=new B.Environment;let P=null;const F=function(h,u,l){typeof h!="string"&&(l=u,u=h,h=null),(typeof u!="object"||!Array.isArray(u))&&(l=u,u=null),u||(u=["require","exports","module"]),h?P.defineModule(h,u,l,null,null):P.enqueueDefineAnonymousModule(u,l)};F.amd={jQuery:!0};const r=function(h,u=!1){P.configure(h,u)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=r,f.getConfig=function(){return P.getConfig().getOptionsLiteral()},f.reset=function(){P=P.reset()},f.getBuildInfo=function(){return P.getBuildInfo()},f.getStats=function(){return P.getLoaderEvents()},f.define=F;function w(){if(typeof B.global.require<"u"||typeof require<"u"){const h=B.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const u=B.ensureRecordedNodeRequire(P.getRecorder(),h);B.global.nodeRequire=u,f.nodeRequire=u,f.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(B.global.define=F),B.global.require=f)}B.init=w,(typeof B.global.define!="function"||!B.global.define.amd)&&(P=new B.ModuleManager(t,B.createScriptLoader(t),F,f,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&f.config(B.global.require),ne=function(){return F.apply(null,arguments)},ne.amd=F.amd,typeof doNotInitLoader>"u"&&w())})(fe||(fe={})),ne(ie[69],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function P(h,u,l,g){if(g=g||{},(g["vs/css"]||{}).disabled){l({});return}const b=u.toUrl(h+".css");F(h,b,()=>{l({})},m=>{typeof l.error=="function"&&l.error("Could not find "+b+".")})}t.load=P;function F(h,u,l,g){if(r(h,u)){l();return}f(h,u,l,g)}function r(h,u){const l=document.getElementsByTagName("link");for(let g=0,N=l.length;g<N;g++){const b=l[g].getAttribute("data-name"),m=l[g].getAttribute("href");if(b===h||m===u)return!0}return!1}function f(h,u,l,g){const N=document.createElement("link");N.setAttribute("rel","stylesheet"),N.setAttribute("type","text/css"),N.setAttribute("data-name",h),w(h,N,l,g),N.setAttribute("href",u),(document.head||document.getElementsByTagName("head")[0]).appendChild(N)}function w(h,u,l,g){const N=()=>{u.removeEventListener("load",b),u.removeEventListener("error",m)},b=e=>{N(),l()},m=e=>{N(),g(e)};u.addEventListener("load",b),u.addEventListener("error",m)}}),ne("vs/nls",["require","exports"],function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let P=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function r(E,M){let _;return M.length===0?_=E:_=E.replace(/\{(\d+)\}/g,(c,o)=>{const s=o[0],i=M[s];let a=c;return typeof i=="string"?a=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(a=String(i)),a}),P&&(_="\uFF3B"+_.replace(/[aouei]/g,"$&$&")+"\uFF3D"),_}function f(E,M){let _=E[M];return _||(_=E["*"],_)?_:null}function w(E){return E.charAt(E.length-1)==="/"?E:E+"/"}async function h(E,M,_){const c=w(E)+w(M)+"vscode/"+w(_),o=await fetch(c);if(o.ok)return await o.json();throw new Error(`${o.status} - ${o.statusText}`)}function u(E){return function(M,_){const c=Array.prototype.slice.call(arguments,2);return r(E[M],c)}}function l(E){return(M,_,...c)=>({value:r(E[M],c),original:r(_,c)})}function g(E,M,..._){return r(M,_)}t.localize=g;function N(E,M,..._){const c=r(M,_);return{value:c,original:c}}t.localize2=N;function b(E){}t.getConfiguredDefaultLocale=b;function m(E){P=E}t.setPseudoTranslation=m;function e(E,M){return{localize:u(M[E]),localize2:l(M[E]),getConfiguredDefaultLocale:M.getConfiguredDefaultLocale??(_=>{})}}t.create=e;function p(E,M,_,c){const o=c["vs/nls"]??{};if(!E||E.length===0)return _({localize:g,localize2:N,getConfiguredDefaultLocale:()=>o.availableLanguages?.["*"]});const s=o.availableLanguages?f(o.availableLanguages,E):null,i=s===null||s===F;let a=".nls";i||(a=a+"."+s);const v=d=>{Array.isArray(d)?(d.localize=u(d),d.localize2=l(d)):(d.localize=u(d[E]),d.localize2=l(d[E])),d.getConfiguredDefaultLocale=()=>o.availableLanguages?.["*"],_(d)};typeof o.loadBundle=="function"?o.loadBundle(E,s,(d,L)=>{d?M([E+".nls"],v):v(L)}):o.translationServiceUrl&&!i?(async()=>{try{const d=await h(o.translationServiceUrl,s,E);return v(d)}catch(d){if(!s.includes("-"))return console.error(d),M([E+".nls"],v);try{const L=s.split("-")[0],A=await h(o.translationServiceUrl,L,E);return o.availableLanguages??={},o.availableLanguages["*"]=L,v(A)}catch(L){return console.error(L),M([E+".nls"],v)}}})():M([E+a],v,d=>{if(a===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${s}. Falling back to the default language:`,d),M([E+".nls"],v)})}t.load=p}),function(){const B=globalThis.MonacoEnvironment,t=B&&B.baseUrl?B.baseUrl:"../../../";function P(g,N){if(B?.createTrustedTypesPolicy)try{return B.createTrustedTypesPolicy(g,N)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(g,N)}catch(b){console.warn(b);return}}const F=P("amdLoader",{createScriptURL:g=>g,createScript:(g,...N)=>{const b=N.slice(0,-1).join(","),m=N.pop().toString();return`(function anonymous(${b}) { ${m}
})`}});function r(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((g,N)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,N);return}F?importScripts(F.createScriptURL(b)):importScripts(b),g()})}function w(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function h(g){f().then(()=>{w(),require([g],function(N){setTimeout(function(){const b=N.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>b.onmessage(m.data,m.ports);l.length>0;){const m=l.shift();b.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&w();let u=!0;const l=[];globalThis.onmessage=g=>{if(!u){l.push(g);return}u=!1,h(g.data)}}(),ne(ie[9],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFindFirst=t.findMaxIdxBy=t.findFirstMinBy=t.findLastMaxBy=t.findFirstMaxBy=t.MonotonousArray=t.findFirstIdxMonotonous=t.findFirstIdxMonotonousOrArrLen=t.findFirstMonotonous=t.findLastIdxMonotonous=t.findLastMonotonous=t.findLastIdx=t.findLast=void 0;function P(p,E,M){const _=F(p,E);if(_!==-1)return p[_]}t.findLast=P;function F(p,E,M=p.length-1){for(let _=M;_>=0;_--){const c=p[_];if(E(c))return _}return-1}t.findLastIdx=F;function r(p,E){const M=f(p,E);return M===-1?void 0:p[M]}t.findLastMonotonous=r;function f(p,E,M=0,_=p.length){let c=M,o=_;for(;c<o;){const s=Math.floor((c+o)/2);E(p[s])?c=s+1:o=s}return c-1}t.findLastIdxMonotonous=f;function w(p,E){const M=h(p,E);return M===p.length?void 0:p[M]}t.findFirstMonotonous=w;function h(p,E,M=0,_=p.length){let c=M,o=_;for(;c<o;){const s=Math.floor((c+o)/2);E(p[s])?o=s:c=s+1}return c}t.findFirstIdxMonotonousOrArrLen=h;function u(p,E,M=0,_=p.length){const c=h(p,E,M,_);return c===p.length?-1:c}t.findFirstIdxMonotonous=u;class l{static{this.assertInvariants=!1}constructor(E){this._array=E,this._findLastMonotonousLastIdx=0}findLastMonotonous(E){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const _ of this._array)if(this._prevFindLastPredicate(_)&&!E(_))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=E}const M=f(this._array,E,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=M+1,M===-1?void 0:this._array[M]}}t.MonotonousArray=l;function g(p,E){if(p.length===0)return;let M=p[0];for(let _=1;_<p.length;_++){const c=p[_];E(c,M)>0&&(M=c)}return M}t.findFirstMaxBy=g;function N(p,E){if(p.length===0)return;let M=p[0];for(let _=1;_<p.length;_++){const c=p[_];E(c,M)>=0&&(M=c)}return M}t.findLastMaxBy=N;function b(p,E){return g(p,(M,_)=>-E(M,_))}t.findFirstMinBy=b;function m(p,E){if(p.length===0)return-1;let M=0;for(let _=1;_<p.length;_++){const c=p[_];E(c,p[M])>0&&(M=_)}return M}t.findMaxIdxBy=m;function e(p,E){for(const M of p){const _=E(M);if(_!==void 0)return _}}t.mapFindFirst=e}),ne(ie[34],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.intersection=t.diffMaps=t.diffSets=t.groupBy=void 0;function P(w,h){const u=Object.create(null);for(const l of w){const g=h(l);let N=u[g];N||(N=u[g]=[]),N.push(l)}return u}t.groupBy=P;function F(w,h){const u=[],l=[];for(const g of w)h.has(g)||u.push(g);for(const g of h)w.has(g)||l.push(g);return{removed:u,added:l}}t.diffSets=F;function r(w,h){const u=[],l=[];for(const[g,N]of w)h.has(g)||u.push(N);for(const[g,N]of h)w.has(g)||l.push(N);return{removed:u,added:l}}t.diffMaps=r;function f(w,h){const u=new Set;for(const l of h)w.has(l)&&u.add(l);return u}t.intersection=f}),ne(ie[35],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function P(h,u){const l=Math.pow(10,u);return Math.round(h*l)/l}class F{constructor(u,l,g,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=P(Math.max(Math.min(1,N),0),3)}static equals(u,l){return u.r===l.r&&u.g===l.g&&u.b===l.b&&u.a===l.a}}t.RGBA=F;class r{constructor(u,l,g,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,N),0),3)}static equals(u,l){return u.h===l.h&&u.s===l.s&&u.l===l.l&&u.a===l.a}static fromRGBA(u){const l=u.r/255,g=u.g/255,N=u.b/255,b=u.a,m=Math.max(l,g,N),e=Math.min(l,g,N);let p=0,E=0;const M=(e+m)/2,_=m-e;if(_>0){switch(E=Math.min(M<=.5?_/(2*M):_/(2-2*M),1),m){case l:p=(g-N)/_+(g<N?6:0);break;case g:p=(N-l)/_+2;break;case N:p=(l-g)/_+4;break}p*=60,p=Math.round(p)}return new r(p,E,M,b)}static _hue2rgb(u,l,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?u+(l-u)*6*g:g<1/2?l:g<2/3?u+(l-u)*(2/3-g)*6:u}static toRGBA(u){const l=u.h/360,{s:g,l:N,a:b}=u;let m,e,p;if(g===0)m=e=p=N;else{const E=N<.5?N*(1+g):N+g-N*g,M=2*N-E;m=r._hue2rgb(M,E,l+1/3),e=r._hue2rgb(M,E,l),p=r._hue2rgb(M,E,l-1/3)}return new F(Math.round(m*255),Math.round(e*255),Math.round(p*255),b)}}t.HSLA=r;class f{constructor(u,l,g,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,N),0),3)}static equals(u,l){return u.h===l.h&&u.s===l.s&&u.v===l.v&&u.a===l.a}static fromRGBA(u){const l=u.r/255,g=u.g/255,N=u.b/255,b=Math.max(l,g,N),m=Math.min(l,g,N),e=b-m,p=b===0?0:e/b;let E;return e===0?E=0:b===l?E=((g-N)/e%6+6)%6:b===g?E=(N-l)/e+2:E=(l-g)/e+4,new f(Math.round(E*60),p,b,u.a)}static toRGBA(u){const{h:l,s:g,v:N,a:b}=u,m=N*g,e=m*(1-Math.abs(l/60%2-1)),p=N-m;let[E,M,_]=[0,0,0];return l<60?(E=m,M=e):l<120?(E=e,M=m):l<180?(M=m,_=e):l<240?(M=e,_=m):l<300?(E=e,_=m):l<=360&&(E=m,_=e),E=Math.round((E+p)*255),M=Math.round((M+p)*255),_=Math.round((_+p)*255),new F(E,M,_,b)}}t.HSVA=f;class w{static fromHex(u){return w.Format.CSS.parseHex(u)||w.red}static equals(u,l){return!u&&!l?!0:!u||!l?!1:u.equals(l)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:f.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof F)this.rgba=u;else if(u instanceof r)this._hsla=u,this.rgba=r.toRGBA(u);else if(u instanceof f)this._hsva=u,this.rgba=f.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&F.equals(this.rgba,u.rgba)&&r.equals(this.hsla,u.hsla)&&f.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=w._relativeLuminanceForComponent(this.rgba.r),l=w._relativeLuminanceForComponent(this.rgba.g),g=w._relativeLuminanceForComponent(this.rgba.b),N=.2126*u+.7152*l+.0722*g;return P(N,4)}static _relativeLuminanceForComponent(u){const l=u/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(u){const l=this.getRelativeLuminance(),g=u.getRelativeLuminance();return l>g?(l+.05)/(g+.05):(g+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const l=this.getRelativeLuminance(),g=u.getRelativeLuminance();return l>g}isDarkerThan(u){const l=this.getRelativeLuminance(),g=u.getRelativeLuminance();return l<g}lighten(u){return new w(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new w(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:l,g,b:N,a:b}=this.rgba;return new w(new F(l,g,N,b*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const l=u.rgba,g=this.rgba.a,N=l.a,b=g+N*(1-g);if(b<1e-6)return w.transparent;const m=this.rgba.r*g/b+l.r*N*(1-g)/b,e=this.rgba.g*g/b+l.g*N*(1-g)/b,p=this.rgba.b*g/b+l.b*N*(1-g)/b;return new w(new F(m,e,p,b))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:l,g,b:N,a:b}=this.rgba;return new w(new F(u.rgba.r-b*(u.rgba.r-l),u.rgba.g-b*(u.rgba.g-g),u.rgba.b-b*(u.rgba.b-N),1))}flatten(...u){const l=u.reduceRight((g,N)=>w._flatten(N,g));return w._flatten(this,l)}static _flatten(u,l){const g=1-u.rgba.a;return new w(new F(g*l.rgba.r+u.rgba.a*u.rgba.r,g*l.rgba.g+u.rgba.a*u.rgba.g,g*l.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=w.Format.CSS.format(this)),this._toString}static getLighterColor(u,l,g){if(u.isLighterThan(l))return u;g=g||.5;const N=u.getRelativeLuminance(),b=l.getRelativeLuminance();return g=g*(b-N)/b,u.lighten(g)}static getDarkerColor(u,l,g){if(u.isDarkerThan(l))return u;g=g||.5;const N=u.getRelativeLuminance(),b=l.getRelativeLuminance();return g=g*(N-b)/N,u.darken(g)}static{this.white=new w(new F(255,255,255,1))}static{this.black=new w(new F(0,0,0,1))}static{this.red=new w(new F(255,0,0,1))}static{this.blue=new w(new F(0,0,255,1))}static{this.green=new w(new F(0,255,0,1))}static{this.cyan=new w(new F(0,255,255,1))}static{this.lightgrey=new w(new F(211,211,211,1))}static{this.transparent=new w(new F(0,0,0,0))}}t.Color=w,function(h){let u;(function(l){let g;(function(N){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:h.Format.CSS.formatRGBA(i)}N.formatRGB=b;function m(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}N.formatRGBA=m;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(i)}N.formatHSL=e;function p(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}N.formatHSLA=p;function E(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function M(i){return`#${E(i.rgba.r)}${E(i.rgba.g)}${E(i.rgba.b)}`}N.formatHex=M;function _(i,a=!1){return a&&i.rgba.a===1?h.Format.CSS.formatHex(i):`#${E(i.rgba.r)}${E(i.rgba.g)}${E(i.rgba.b)}${E(Math.round(i.rgba.a*255))}`}N.formatHexA=_;function c(i){return i.isOpaque()?h.Format.CSS.formatHex(i):h.Format.CSS.formatRGBA(i)}N.format=c;function o(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const v=16*s(i.charCodeAt(1))+s(i.charCodeAt(2)),d=16*s(i.charCodeAt(3))+s(i.charCodeAt(4)),L=16*s(i.charCodeAt(5))+s(i.charCodeAt(6));return new h(new F(v,d,L,1))}if(a===9){const v=16*s(i.charCodeAt(1))+s(i.charCodeAt(2)),d=16*s(i.charCodeAt(3))+s(i.charCodeAt(4)),L=16*s(i.charCodeAt(5))+s(i.charCodeAt(6)),A=16*s(i.charCodeAt(7))+s(i.charCodeAt(8));return new h(new F(v,d,L,A/255))}if(a===4){const v=s(i.charCodeAt(1)),d=s(i.charCodeAt(2)),L=s(i.charCodeAt(3));return new h(new F(16*v+v,16*d+d,16*L+L))}if(a===5){const v=s(i.charCodeAt(1)),d=s(i.charCodeAt(2)),L=s(i.charCodeAt(3)),A=s(i.charCodeAt(4));return new h(new F(16*v+v,16*d+d,16*L+L,(16*A+A)/255))}return null}N.parseHex=o;function s(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=l.CSS||(l.CSS={}))})(u=h.Format||(h.Format={}))}(w||(t.Color=w={}))}),ne(ie[36],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class P{constructor(r,f,w,h){this.originalStart=r,this.originalLength=f,this.modifiedStart=w,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=P}),ne(ie[3],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.ReadonlyError=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?c.isErrorNoTelemetry(i)?new c(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}t.ErrorHandler=P,t.errorHandler=new P;function F(s){t.errorHandler.setUnexpectedErrorHandler(s)}t.setUnexpectedErrorHandler=F;function r(s){if(!s||typeof s!="object")return!1;const i=s;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=r;function f(s){l(s)||t.errorHandler.onUnexpectedError(s)}t.onUnexpectedError=f;function w(s){l(s)||t.errorHandler.onUnexpectedExternalError(s)}t.onUnexpectedExternalError=w;function h(s){if(s instanceof Error){const{name:i,message:a}=s,v=s.stacktrace||s.stack;return{$isError:!0,name:i,message:a,stack:v,noTelemetry:c.isErrorNoTelemetry(s)}}return s}t.transformErrorForSerialization=h;const u="Canceled";function l(s){return s instanceof g?!0:s instanceof Error&&s.name===u&&s.message===u}t.isCancellationError=l;class g extends Error{constructor(){super(u),this.name=this.message}}t.CancellationError=g;function N(){const s=new Error(u);return s.name=s.message,s}t.canceled=N;function b(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}t.illegalArgument=b;function m(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}t.illegalState=m;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=e;function p(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}t.getErrorMessage=p;class E extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.NotImplementedError=E;class M extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.NotSupportedError=M;class _ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=_;class c extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof c)return i;const a=new c;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.ErrorNoTelemetry=c;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.BugIndicatingError=o}),ne(ie[6],re([0,1,3,9]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.reverseOrder=t.booleanComparator=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.forEachWithNeighbors=t.forEachAdjacent=t.groupAdjacentBy=t.groupBy=t.quickSelect=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function r(x,z=0){return x[x.length-(1+z)]}t.tail=r;function f(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}t.tail2=f;function w(x,z,W=(X,ee)=>X===ee){if(x===z)return!0;if(!x||!z||x.length!==z.length)return!1;for(let X=0,ee=x.length;X<ee;X++)if(!W(x[X],z[X]))return!1;return!0}t.equals=w;function h(x,z){const W=x.length-1;z<W&&(x[z]=x[W]),x.pop()}t.removeFastWithoutKeepingOrder=h;function u(x,z,W){return l(x.length,X=>W(x[X],z))}t.binarySearch=u;function l(x,z){let W=0,X=x-1;for(;W<=X;){const ee=(W+X)/2|0,Q=z(ee);if(Q<0)W=ee+1;else if(Q>0)X=ee-1;else return ee}return-(W+1)}t.binarySearch2=l;function g(x,z,W){if(x=x|0,x>=z.length)throw new TypeError("invalid index");const X=z[Math.floor(z.length*Math.random())],ee=[],Q=[],G=[];for(const K of z){const J=W(K,X);J<0?ee.push(K):J>0?Q.push(K):G.push(K)}return x<ee.length?g(x,ee,W):x<ee.length+G.length?G[0]:g(x-(ee.length+G.length),Q,W)}t.quickSelect=g;function N(x,z){const W=[];let X;for(const ee of x.slice(0).sort(z))!X||z(X[0],ee)!==0?(X=[ee],W.push(X)):X.push(ee);return W}t.groupBy=N;function*b(x,z){let W,X;for(const ee of x)X!==void 0&&z(X,ee)?W.push(ee):(W&&(yield W),W=[ee]),X=ee;W&&(yield W)}t.groupAdjacentBy=b;function m(x,z){for(let W=0;W<=x.length;W++)z(W===0?void 0:x[W-1],W===x.length?void 0:x[W])}t.forEachAdjacent=m;function e(x,z){for(let W=0;W<x.length;W++)z(W===0?void 0:x[W-1],x[W],W+1===x.length?void 0:x[W+1])}t.forEachWithNeighbors=e;function p(x,z,W){const X=[];function ee(K,J,se){if(J===0&&se.length===0)return;const le=X[X.length-1];le&&le.start+le.deleteCount===K?(le.deleteCount+=J,le.toInsert.push(...se)):X.push({start:K,deleteCount:J,toInsert:se})}let Q=0,G=0;for(;;){if(Q===x.length){ee(Q,0,z.slice(G));break}if(G===z.length){ee(Q,x.length-Q,[]);break}const K=x[Q],J=z[G],se=W(K,J);se===0?(Q+=1,G+=1):se<0?(ee(Q,1,[]),Q+=1):se>0&&(ee(Q,0,[J]),G+=1)}return X}t.sortedDiff=p;function E(x,z,W){const X=p(x,z,W),ee=[],Q=[];for(const G of X)ee.push(...x.slice(G.start,G.start+G.deleteCount)),Q.push(...G.toInsert);return{removed:ee,added:Q}}t.delta=E;function M(x,z,W){if(W===0)return[];const X=x.slice(0,W).sort(z);return c(x,z,X,W,x.length),X}t.top=M;function _(x,z,W,X,ee){return W===0?Promise.resolve([]):new Promise((Q,G)=>{(async()=>{const K=x.length,J=x.slice(0,W).sort(z);for(let se=W,le=Math.min(W+X,K);se<K;se=le,le=Math.min(le+X,K)){if(se>W&&await new Promise(ce=>setTimeout(ce)),ee&&ee.isCancellationRequested)throw new P.CancellationError;c(x,z,J,se,le)}return J})().then(Q,G)})}t.topAsync=_;function c(x,z,W,X,ee){for(const Q=W.length;X<ee;X++){const G=x[X];if(z(G,W[Q-1])<0){W.pop();const K=(0,F.findFirstIdxMonotonousOrArrLen)(W,J=>z(G,J)<0);W.splice(K,0,G)}}}function o(x){return x.filter(z=>!!z)}t.coalesce=o;function s(x){let z=0;for(let W=0;W<x.length;W++)x[W]&&(x[z]=x[W],z+=1);x.length=z}t.coalesceInPlace=s;function i(x,z,W){x.splice(W,0,x.splice(z,1)[0])}t.move=i;function a(x){return!Array.isArray(x)||x.length===0}t.isFalsyOrEmpty=a;function v(x){return Array.isArray(x)&&x.length>0}t.isNonEmptyArray=v;function d(x,z=W=>W){const W=new Set;return x.filter(X=>{const ee=z(X);return W.has(ee)?!1:(W.add(ee),!0)})}t.distinct=d;function L(x){const z=new Set;return W=>{const X=x(W);return z.has(X)?!1:(z.add(X),!0)}}t.uniqueFilter=L;function A(x,z){return x.length>0?x[0]:z}t.firstOrDefault=A;function R(x,z){return x.length>0?x[x.length-1]:z}t.lastOrDefault=R;function D(x,z,W=(X,ee)=>X===ee){let X=0;for(let ee=0,Q=Math.min(x.length,z.length);ee<Q&&W(x[ee],z[ee]);ee++)X++;return X}t.commonPrefixLength=D;function k(x){return[].concat(...x)}t.flatten=k;function y(x,z){let W=typeof z=="number"?x:0;typeof z=="number"?W=x:(W=0,z=x);const X=[];if(W<=z)for(let ee=W;ee<z;ee++)X.push(ee);else for(let ee=W;ee>z;ee--)X.push(ee);return X}t.range=y;function S(x,z,W){return x.reduce((X,ee)=>(X[z(ee)]=W?W(ee):ee,X),Object.create(null))}t.index=S;function C(x,z){return x.push(z),()=>O(x,z)}t.insert=C;function O(x,z){const W=x.indexOf(z);if(W>-1)return x.splice(W,1),z}t.remove=O;function H(x,z,W){const X=x.slice(0,z),ee=x.slice(z);return X.concat(W,ee)}t.arrayInsert=H;function T(x,z){let W;if(typeof z=="number"){let X=z;W=()=>{const ee=Math.sin(X++)*179426549;return ee-Math.floor(ee)}}else W=Math.random;for(let X=x.length-1;X>0;X-=1){const ee=Math.floor(W()*(X+1)),Q=x[X];x[X]=x[ee],x[ee]=Q}}t.shuffle=T;function q(x,z){const W=x.indexOf(z);W>-1&&(x.splice(W,1),x.unshift(z))}t.pushToStart=q;function $(x,z){const W=x.indexOf(z);W>-1&&(x.splice(W,1),x.push(z))}t.pushToEnd=$;function V(x,z){for(const W of z)x.push(W)}t.pushMany=V;function Y(x,z){return Array.isArray(x)?x.map(z):z(x)}t.mapArrayOrNot=Y;function n(x){return Array.isArray(x)?x:[x]}t.asArray=n;function te(x){return x[Math.floor(Math.random()*x.length)]}t.getRandomElement=te;function oe(x,z,W){const X=pe(x,z),ee=x.length,Q=W.length;x.length=ee+Q;for(let G=ee-1;G>=X;G--)x[G+Q]=x[G];for(let G=0;G<Q;G++)x[G+X]=W[G]}t.insertInto=oe;function ge(x,z,W,X){const ee=pe(x,z);let Q=x.splice(ee,W);return Q===void 0&&(Q=[]),oe(x,ee,X),Q}t.splice=ge;function pe(x,z){return z<0?Math.max(z+x.length,0):Math.min(z,x.length)}var Le;(function(x){function z(Q){return Q<0}x.isLessThan=z;function W(Q){return Q<=0}x.isLessThanOrEqual=W;function X(Q){return Q>0}x.isGreaterThan=X;function ee(Q){return Q===0}x.isNeitherLessOrGreaterThan=ee,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(Le||(t.CompareResult=Le={}));function _e(x,z){return(W,X)=>z(x(W),x(X))}t.compareBy=_e;function we(...x){return(z,W)=>{for(const X of x){const ee=X(z,W);if(!Le.isNeitherLessOrGreaterThan(ee))return ee}return Le.neitherLessOrGreaterThan}}t.tieBreakComparators=we;const Te=(x,z)=>x-z;t.numberComparator=Te;const ke=(x,z)=>(0,t.numberComparator)(x?1:0,z?1:0);t.booleanComparator=ke;function Ie(x){return(z,W)=>-x(z,W)}t.reverseOrder=Ie;class Ce{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let W=this.firstIdx;for(;W<this.items.length&&z(this.items[W]);)W++;const X=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,X}takeFromEndWhile(z){let W=this.lastIdx;for(;W>=0&&z(this.items[W]);)W--;const X=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,X}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const W=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,W}}t.ArrayQueue=Ce;class Me{static{this.empty=new Me(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(W=>(z(W),!0))}toArray(){const z=[];return this.iterate(W=>(z.push(W),!0)),z}filter(z){return new Me(W=>this.iterate(X=>z(X)?W(X):!0))}map(z){return new Me(W=>this.iterate(X=>W(z(X))))}some(z){let W=!1;return this.iterate(X=>(W=z(X),!W)),W}findFirst(z){let W;return this.iterate(X=>z(X)?(W=X,!1):!0),W}findLast(z){let W;return this.iterate(X=>(z(X)&&(W=X),!0)),W}findLastMaxBy(z){let W,X=!0;return this.iterate(ee=>((X||Le.isGreaterThan(z(ee,W)))&&(X=!1,W=ee),!0)),W}}t.CallbackIterable=Me}),ne(ie[13],re([0,1,3]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function F(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=F;function r(u,l="Unreachable"){throw new Error(l)}t.assertNever=r;function f(u){if(!u)throw new P.BugIndicatingError("Assertion Failed")}t.assert=f;function w(u){if(!u()){debugger;u(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}t.assertFn=w;function h(u,l){let g=0;for(;g<u.length-1;){const N=u[g],b=u[g+1];if(!l(N,b))return!1;g++}return!0}t.checkAdjacentItems=h}),ne(ie[19],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=void 0;function P(F){const r=this;let f=!1,w;return function(){return f||(f=!0,w=F.apply(r,arguments)),w}}t.createSingleCallFunction=P}),ne(ie[20],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(F){function r(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}F.is=r;const f=Object.freeze([]);function w(){return f}F.empty=w;function*h(s){yield s}F.single=h;function u(s){return r(s)?s:h(s)}F.wrap=u;function l(s){return s||f}F.from=l;function*g(s){for(let i=s.length-1;i>=0;i--)yield s[i]}F.reverse=g;function N(s){return!s||s[Symbol.iterator]().next().done===!0}F.isEmpty=N;function b(s){return s[Symbol.iterator]().next().value}F.first=b;function m(s,i){for(const a of s)if(i(a))return!0;return!1}F.some=m;function e(s,i){for(const a of s)if(i(a))return a}F.find=e;function*p(s,i){for(const a of s)i(a)&&(yield a)}F.filter=p;function*E(s,i){let a=0;for(const v of s)yield i(v,a++)}F.map=E;function*M(...s){for(const i of s)for(const a of i)yield a}F.concat=M;function _(s,i,a){let v=a;for(const d of s)v=i(v,d);return v}F.reduce=_;function*c(s,i,a=s.length){for(i<0&&(i+=s.length),a<0?a+=s.length:a>s.length&&(a=s.length);i<a;i++)yield s[i]}F.slice=c;function o(s,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,s];const v=s[Symbol.iterator]();for(let d=0;d<i;d++){const L=v.next();if(L.done)return[a,F.empty()];a.push(L.value)}return[a,{[Symbol.iterator](){return v}}]}F.consume=o})(P||(t.Iterable=P={}))}),ne(ie[37],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(P||(t.KeyCode=P={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(p,E){this._keyCodeToStr[p]=E,this._strToKeyCode[E.toLowerCase()]=p}keyCodeToStr(p){return this._keyCodeToStr[p]}strToKeyCode(p){return this._strToKeyCode[p.toLowerCase()]||0}}const f=new r,w=new r,h=new r;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const u=[],l=Object.create(null),g=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>l[e]||0,toString:e=>u[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",p=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],E=[],M=[];for(const _ of p){const[c,o,s,i,a,v,d,L,A]=_;if(M[o]||(M[o]=!0,u[o]=s,l[s]=o,g[s.toLowerCase()]=o,c&&(t.IMMUTABLE_CODE_TO_KEY_CODE[o]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[i]=o))),!E[i]){if(E[i]=!0,!a)throw new Error(`String representation missing for key code ${i} around scan code ${s}`);f.define(i,a),w.define(i,L||a),h.define(i,A||L||a)}v&&(t.EVENT_KEY_CODE_MAP[v]=i),d&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[d]=i)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var N;(function(e){function p(s){return f.keyCodeToStr(s)}e.toString=p;function E(s){return f.strToKeyCode(s)}e.fromString=E;function M(s){return w.keyCodeToStr(s)}e.toUserSettingsUS=M;function _(s){return h.keyCodeToStr(s)}e.toUserSettingsGeneral=_;function c(s){return w.strToKeyCode(s)||h.strToKeyCode(s)}e.fromUserSettings=c;function o(s){if(s>=98&&s<=113)return null;switch(s){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(s)}e.toElectronAccelerator=o})(N||(t.KeyCodeUtils=N={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,p){const E=(p&65535)<<16>>>0;return(e|E)>>>0}t.KeyChord=m}),ne(ie[38],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class P{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=P}),ne(ie[21],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class P{static{this.Undefined=new P(void 0)}constructor(f){this.element=f,this.next=P.Undefined,this.prev=P.Undefined}}class F{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let f=this._first;for(;f!==P.Undefined;){const w=f.next;f.prev=P.Undefined,f.next=P.Undefined,f=w}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(f){return this._insert(f,!1)}push(f){return this._insert(f,!0)}_insert(f,w){const h=new P(f);if(this._first===P.Undefined)this._first=h,this._last=h;else if(w){const l=this._last;this._last=h,h.prev=l,l.next=h}else{const l=this._first;this._first=h,h.next=l,l.prev=h}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(h))}}shift(){if(this._first!==P.Undefined){const f=this._first.element;return this._remove(this._first),f}}pop(){if(this._last!==P.Undefined){const f=this._last.element;return this._remove(this._last),f}}_remove(f){if(f.prev!==P.Undefined&&f.next!==P.Undefined){const w=f.prev;w.next=f.next,f.next.prev=w}else f.prev===P.Undefined&&f.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):f.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):f.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let f=this._first;for(;f!==P.Undefined;)yield f.element,f=f.next}}t.LinkedList=F}),ne(ie[22],re([0,1]),function(B,t){"use strict";var P,F,r;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function f(_,c,o){let s=_.get(c);return s===void 0&&(s=o,_.set(c,s)),s}t.getOrSet=f;function w(_){const c=[];return _.forEach((o,s)=>{c.push(`${s} => ${o}`)}),`Map(${_.size}) {${c.join(", ")}}`}t.mapToString=w;function h(_){const c=[];return _.forEach(o=>{c.push(o)}),`Set(${_.size}) {${c.join(", ")}}`}t.setToString=h;class u{constructor(c,o){this.uri=c,this.value=o}}function l(_){return Array.isArray(_)}class g{static{this.defaultToKey=c=>c.toString()}constructor(c,o){if(this[P]="ResourceMap",c instanceof g)this.map=new Map(c.map),this.toKey=o??g.defaultToKey;else if(l(c)){this.map=new Map,this.toKey=o??g.defaultToKey;for(const[s,i]of c)this.set(s,i)}else this.map=new Map,this.toKey=c??g.defaultToKey}set(c,o){return this.map.set(this.toKey(c),new u(c,o)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,o){typeof o<"u"&&(c=c.bind(o));for(const[s,i]of this.map)c(i.value,i.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}t.ResourceMap=g;class N{constructor(c,o){this[F]="ResourceSet",!c||typeof c=="function"?this._map=new g(c):(this._map=new g(o),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,o){this._map.forEach((s,i)=>c.call(o,i,i,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=N;var b;(function(_){_[_.None=0]="None",_[_.AsOld=1]="AsOld",_[_.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,o=0){const s=this._map.get(c);if(s)return o!==0&&this.touch(s,o),s.value}set(c,o,s=0){let i=this._map.get(c);if(i)i.value=o,s!==0&&this.touch(i,s);else{switch(i={key:c,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(i);break;case 1:this.addItemFirst(i);break;case 2:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(c,i),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const o=this._map.get(c);if(o)return this._map.delete(c),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,o){const s=this._state;let i=this._head;for(;i;){if(o?c.bind(o)(i.value,i.key,this):c(i.value,i.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const c=this,o=this._state;let s=this._head;const i={[Symbol.iterator](){return i},next(){if(c._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const a={value:s.key,done:!1};return s=s.next,a}else return{value:void 0,done:!0}}};return i}values(){const c=this,o=this._state;let s=this._head;const i={[Symbol.iterator](){return i},next(){if(c._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const a={value:s.value,done:!1};return s=s.next,a}else return{value:void 0,done:!0}}};return i}entries(){const c=this,o=this._state;let s=this._head;const i={[Symbol.iterator](){return i},next(){if(c._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const a={value:[s.key,s.value],done:!1};return s=s.next,a}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>c;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const o=c.next,s=c.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}c.next=void 0,c.previous=void 0,this._state++}touch(c,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(c===this._head)return;const s=c.next,i=c.previous;c===this._tail?(i.next=void 0,this._tail=i):(s.previous=i,i.next=s),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(o===2){if(c===this._tail)return;const s=c.next,i=c.previous;c===this._head?(s.previous=void 0,this._head=s):(s.previous=i,i.next=s),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((o,s)=>{c.push([s,o])}),c}fromJSON(c){this.clear();for(const[o,s]of c)this.set(o,s)}}t.LinkedMap=m;class e extends m{constructor(c,o=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,o=2){return super.get(c,o)}peek(c){return super.get(c,0)}set(c,o){return super.set(c,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=e;class p{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let o=this.map.get(c)||0;return o===0?!1:(o--,o===0?this.map.delete(c):this.map.set(c,o),!0)}has(c){return this.map.has(c)}}t.CounterSet=p;class E{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[o,s]of c)this.set(o,s)}clear(){this._m1.clear(),this._m2.clear()}set(c,o){this._m1.set(c,o),this._m2.set(o,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const o=this._m1.get(c);return o===void 0?!1:(this._m1.delete(c),this._m2.delete(o),!0)}forEach(c,o){this._m1.forEach((s,i)=>{c.call(o,s,i,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=E;class M{constructor(){this.map=new Map}add(c,o){let s=this.map.get(c);s||(s=new Set,this.map.set(c,s)),s.add(o)}delete(c,o){const s=this.map.get(c);s&&(s.delete(o),s.size===0&&this.map.delete(c))}forEach(c,o){const s=this.map.get(c);s&&s.forEach(o)}get(c){const o=this.map.get(c);return o||new Set}}t.SetMap=M}),ne(ie[10],re([0,1,6,34,22,19,20]),function(B,t,P,F,r,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.markAsDisposed=t.trackDisposable=t.setDisposableTracker=t.DisposableTracker=void 0;const h=!1;let u=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(S){let C=this.livingDisposables.get(S);return C||(C={parent:null,source:null,isSingleton:!1,value:S,idx:l.idx++},this.livingDisposables.set(S,C)),C}trackDisposable(S){const C=this.getDisposableData(S);C.source||(C.source=new Error().stack)}setParent(S,C){const O=this.getDisposableData(S);O.parent=C}markAsDisposed(S){this.livingDisposables.delete(S)}markAsSingleton(S){this.getDisposableData(S).isSingleton=!0}getRootParent(S,C){const O=C.get(S);if(O)return O;const H=S.parent?this.getRootParent(this.getDisposableData(S.parent),C):S;return C.set(S,H),H}getTrackedDisposables(){const S=new Map;return[...this.livingDisposables.entries()].filter(([,O])=>O.source!==null&&!this.getRootParent(O,S).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(S=10,C){let O;if(C)O=C;else{const V=new Map,Y=[...this.livingDisposables.values()].filter(te=>te.source!==null&&!this.getRootParent(te,V).isSingleton);if(Y.length===0)return;const n=new Set(Y.map(te=>te.value));if(O=Y.filter(te=>!(te.parent&&n.has(te.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function H(V){function Y(te,oe){for(;te.length>0&&oe.some(ge=>typeof ge=="string"?ge===te[0]:te[0].match(ge));)te.shift()}const n=V.source.split(`
`).map(te=>te.trim().replace("at ","")).filter(te=>te!=="");return Y(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const T=new r.SetMap;for(const V of O){const Y=H(V);for(let n=0;n<=Y.length;n++)T.add(Y.slice(0,n).join(`
`),V)}O.sort((0,P.compareBy)(V=>V.idx,P.numberComparator));let q="",$=0;for(const V of O.slice(0,S)){$++;const Y=H(V),n=[];for(let te=0;te<Y.length;te++){let oe=Y[te];oe=`(shared with ${T.get(Y.slice(0,te+1).join(`
`)).size}/${O.length} leaks) at ${oe}`;const pe=T.get(Y.slice(0,te).join(`
`)),Le=(0,F.groupBy)([...pe].map(_e=>H(_e)[te]),_e=>_e);delete Le[Y[te]];for(const[_e,we]of Object.entries(Le))n.unshift(`    - stacktraces of ${we.length} other leaks continue with ${_e}`);n.unshift(oe)}q+=`


==================== Leaking disposable ${$}/${O.length}: ${V.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return O.length>S&&(q+=`


... and ${O.length-S} more leaking disposables

`),{leaks:O,details:q}}}t.DisposableTracker=l;function g(y){u=y}if(t.setDisposableTracker=g,h){const y="__is_disposable_tracked__";g(new class{trackDisposable(S){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{S[y]||console.log(C)},3e3)}setParent(S,C){if(S&&S!==i.None)try{S[y]=!0}catch{}}markAsDisposed(S){if(S&&S!==i.None)try{S[y]=!0}catch{}}markAsSingleton(S){}})}function N(y){return u?.trackDisposable(y),y}t.trackDisposable=N;function b(y){u?.markAsDisposed(y)}t.markAsDisposed=b;function m(y,S){u?.setParent(y,S)}function e(y,S){if(u)for(const C of y)u.setParent(C,S)}function p(y){return u?.markAsSingleton(y),y}t.markAsSingleton=p;function E(y){return typeof y.dispose=="function"&&y.dispose.length===0}t.isDisposable=E;function M(y){if(w.Iterable.is(y)){const S=[];for(const C of y)if(C)try{C.dispose()}catch(O){S.push(O)}if(S.length===1)throw S[0];if(S.length>1)throw new AggregateError(S,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}t.dispose=M;function _(y){for(const S of y)E(S)&&S.dispose();return[]}t.disposeIfDisposable=_;function c(...y){const S=o(()=>M(y));return e(y,S),S}t.combinedDisposable=c;function o(y){const S=N({dispose:(0,f.createSingleCallFunction)(()=>{b(S),y()})});return S}t.toDisposable=o;class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,N(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{M(this._toDispose)}finally{this._toDispose.clear()}}add(S){if(!S)return S;if(S===this)throw new Error("Cannot register a disposable on itself!");return m(S,this),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(S),S}delete(S){if(S){if(S===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(S),S.dispose()}}deleteAndLeak(S){S&&this._toDispose.has(S)&&(this._toDispose.delete(S),m(S,null))}}t.DisposableStore=s;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new s,N(this),m(this._store,this)}dispose(){b(this),this._store.dispose()}_register(S){if(S===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(S)}}t.Disposable=i;class a{constructor(){this._isDisposed=!1,N(this)}get value(){return this._isDisposed?void 0:this._value}set value(S){this._isDisposed||S===this._value||(this._value?.dispose(),S&&m(S,this),this._value=S)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const S=this._value;return this._value=void 0,S&&m(S,null),S}}t.MutableDisposable=a;class v{constructor(S){this._disposable=S,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=v;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,N(this)}set(S){let C=S;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,b(this))},this}}t.SafeDisposable=d;class L{constructor(){this.references=new Map}acquire(S,...C){let O=this.references.get(S);O||(O={counter:0,object:this.createReferencedObject(S,...C)},this.references.set(S,O));const{object:H}=O,T=(0,f.createSingleCallFunction)(()=>{--O.counter===0&&(this.destroyReferencedObject(S,O.object),this.references.delete(S))});return O.counter++,{object:H,dispose:T}}}t.ReferenceCollection=L;class A{constructor(S){this.referenceCollection=S}async acquire(S,...C){const O=this.referenceCollection.acquire(S,...C);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(H){throw O.dispose(),H}}}t.AsyncReferenceCollection=A;class R{constructor(S){this.object=S}dispose(){}}t.ImmortalReference=R;function D(y){const S=new s;try{y(S)}finally{S.dispose()}}t.disposeOnReturn=D;class k{constructor(){this._store=new Map,this._isDisposed=!1,N(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{M(this._store.values())}finally{this._store.clear()}}has(S){return this._store.has(S)}get size(){return this._store.size}get(S){return this._store.get(S)}set(S,C,O=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this._store.get(S)?.dispose(),this._store.set(S,C)}deleteAndDispose(S){this._store.get(S)?.dispose(),this._store.delete(S)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=k}),ne(ie[23],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(f){return new F(f)}constructor(f){this._now=P&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=F}),ne(ie[11],re([0,1,3,19,10,21,23]),function(B,t,P,F,r,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const h=!1,u=!1;var l;(function(k){k.None=()=>r.Disposable.None;function y(Q){if(u){const{onDidAddListener:G}=Q,K=e.create();let J=0;Q.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),G?.()}}}function S(Q,G){return te(Q,()=>{},0,void 0,!0,void 0,G)}k.defer=S;function C(Q){return(G,K=null,J)=>{let se=!1,le;return le=Q(ce=>{if(!se)return le?le.dispose():se=!0,G.call(K,ce)},null,J),se&&le.dispose(),le}}k.once=C;function O(Q,G,K){return Y((J,se=null,le)=>Q(ce=>J.call(se,G(ce)),null,le),K)}k.map=O;function H(Q,G,K){return Y((J,se=null,le)=>Q(ce=>{G(ce),J.call(se,ce)},null,le),K)}k.forEach=H;function T(Q,G,K){return Y((J,se=null,le)=>Q(ce=>G(ce)&&J.call(se,ce),null,le),K)}k.filter=T;function q(Q){return Q}k.signal=q;function $(...Q){return(G,K=null,J)=>{const se=(0,r.combinedDisposable)(...Q.map(le=>le(ce=>G.call(K,ce))));return n(se,J)}}k.any=$;function V(Q,G,K,J){let se=K;return O(Q,le=>(se=G(se,le),se),J)}k.reduce=V;function Y(Q,G){let K;const J={onWillAddFirstListener(){K=Q(se.fire,se)},onDidRemoveLastListener(){K?.dispose()}};G||y(J);const se=new c(J);return G?.add(se),se.event}function n(Q,G){return G instanceof Array?G.push(Q):G&&G.add(Q),Q}function te(Q,G,K=100,J=!1,se=!1,le,ce){let me,he,Re,ve=0,Se;const xe={leakWarningThreshold:le,onWillAddFirstListener(){me=Q(qe=>{ve++,he=G(he,qe),J&&!Re&&(Fe.fire(he),he=void 0),Se=()=>{const Ue=he;he=void 0,Re=void 0,(!J||ve>1)&&Fe.fire(Ue),ve=0},typeof K=="number"?(clearTimeout(Re),Re=setTimeout(Se,K)):Re===void 0&&(Re=0,queueMicrotask(Se))})},onWillRemoveListener(){se&&ve>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,me.dispose()}};ce||y(xe);const Fe=new c(xe);return ce?.add(Fe),Fe.event}k.debounce=te;function oe(Q,G=0,K){return k.debounce(Q,(J,se)=>J?(J.push(se),J):[se],G,void 0,!0,void 0,K)}k.accumulate=oe;function ge(Q,G=(J,se)=>J===se,K){let J=!0,se;return T(Q,le=>{const ce=J||!G(le,se);return J=!1,se=le,ce},K)}k.latch=ge;function pe(Q,G,K){return[k.filter(Q,G,K),k.filter(Q,J=>!G(J),K)]}k.split=pe;function Le(Q,G=!1,K=[],J){let se=K.slice(),le=Q(he=>{se?se.push(he):me.fire(he)});J&&J.add(le);const ce=()=>{se?.forEach(he=>me.fire(he)),se=null},me=new c({onWillAddFirstListener(){le||(le=Q(he=>me.fire(he)),J&&J.add(le))},onDidAddFirstListener(){se&&(G?setTimeout(ce):ce())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return J&&J.add(me),me.event}k.buffer=Le;function _e(Q,G){return(J,se,le)=>{const ce=G(new Te);return Q(function(me){const he=ce.evaluate(me);he!==we&&J.call(se,he)},void 0,le)}}k.chain=_e;const we=Symbol("HaltChainable");class Te{constructor(){this.steps=[]}map(G){return this.steps.push(G),this}forEach(G){return this.steps.push(K=>(G(K),K)),this}filter(G){return this.steps.push(K=>G(K)?K:we),this}reduce(G,K){let J=K;return this.steps.push(se=>(J=G(J,se),J)),this}latch(G=(K,J)=>K===J){let K=!0,J;return this.steps.push(se=>{const le=K||!G(se,J);return K=!1,J=se,le?se:we}),this}evaluate(G){for(const K of this.steps)if(G=K(G),G===we)break;return G}}function ke(Q,G,K=J=>J){const J=(...me)=>ce.fire(K(...me)),se=()=>Q.on(G,J),le=()=>Q.removeListener(G,J),ce=new c({onWillAddFirstListener:se,onDidRemoveLastListener:le});return ce.event}k.fromNodeEventEmitter=ke;function Ie(Q,G,K=J=>J){const J=(...me)=>ce.fire(K(...me)),se=()=>Q.addEventListener(G,J),le=()=>Q.removeEventListener(G,J),ce=new c({onWillAddFirstListener:se,onDidRemoveLastListener:le});return ce.event}k.fromDOMEventEmitter=Ie;function Ce(Q){return new Promise(G=>C(Q)(G))}k.toPromise=Ce;function Me(Q){const G=new c;return Q.then(K=>{G.fire(K)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}k.fromPromise=Me;function x(Q,G,K){return G(K),Q(J=>G(J))}k.runAndSubscribe=x;function z(Q,G){let K=null;function J(le){K?.dispose(),K=new r.DisposableStore,G(le,K)}J(void 0);const se=Q(le=>J(le));return(0,r.toDisposable)(()=>{se.dispose(),K?.dispose()})}k.runAndSubscribeWithStore=z;class W{constructor(G,K){this._observable=G,this._counter=0,this._hasChanged=!1;const J={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};K||y(J),this.emitter=new c(J),K&&K.add(this.emitter)}beginUpdate(G){this._counter++}handlePossibleChange(G){}handleChange(G,K){this._hasChanged=!0}endUpdate(G){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function X(Q,G){return new W(Q,G).emitter.event}k.fromObservable=X;function ee(Q){return G=>{let K=0,J=!1;const se={beginUpdate(){K++},endUpdate(){K--,K===0&&(Q.reportChanges(),J&&(J=!1,G()))},handlePossibleChange(){},handleChange(){J=!0}};return Q.addObserver(se),Q.reportChanges(),{dispose(){Q.removeObserver(se)}}}}k.fromObservableLight=ee})(l||(t.Event=l={}));class g{static{this.all=new Set}static{this._idPool=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${g._idPool++}`,g.all.add(this)}start(y){this._stopWatch=new w.StopWatch,this.listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=g;let N=-1;function b(k){const y=N;return N=k,{dispose(){N=y}}}t.setGlobalLeakWarningThreshold=b;class m{constructor(y,S=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=S,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(y,S){const C=this.threshold;if(C<=0||S<C)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(y.value)||0;if(this._stacks.set(y.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=C*.5;let H,T=0;for(const[q,$]of this._stacks)(!H||T<$)&&(H=q,T=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${T}):`),console.warn(H)}return()=>{const H=this._stacks.get(y.value)||0;this._stacks.set(y.value,H-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class E{constructor(y){this.value=y,this.id=p++}}const M=2,_=(k,y)=>{if(k instanceof E)y(k);else for(let S=0;S<k.length;S++){const C=k[S];C&&y(C)}};class c{constructor(y){this._size=0,this._options=y,this._leakageMon=N>0||this._options?.leakWarningThreshold?new m(this._options?.leakWarningThreshold??N):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(h){const y=this._listeners;queueMicrotask(()=>{_(y,S=>S.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(y,S,C)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;S&&(y=y.bind(S));const O=new E(y);let H,T;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(O.stack=e.create(),H=this._leakageMon.check(O.stack,this._size+1)),h&&(O.stack=T??e.create()),this._listeners?this._listeners instanceof E?(this._deliveryQueue??=new s,this._listeners=[this._listeners,O]):this._listeners.push(O):(this._options?.onWillAddFirstListener?.(this),this._listeners=O,this._options?.onDidAddFirstListener?.(this)),this._size++;const q=(0,r.toDisposable)(()=>{H?.(),this._removeListener(O)});return C instanceof r.DisposableStore?C.add(q):Array.isArray(C)&&C.push(q),q},this._event}_removeListener(y){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const S=this._listeners,C=S.indexOf(y);if(C===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,S[C]=void 0;const O=this._deliveryQueue.current===this;if(this._size*M<=S.length){let H=0;for(let T=0;T<S.length;T++)S[T]?S[H++]=S[T]:O&&(this._deliveryQueue.end--,H<this._deliveryQueue.i&&this._deliveryQueue.i--);S.length=H}}_deliver(y,S){if(!y)return;const C=this._options?.onListenerError||P.onUnexpectedError;if(!C){y.value(S);return}try{y.value(S)}catch(O){C(O)}}_deliverQueue(y){const S=y.current._listeners;for(;y.i<y.end;)this._deliver(S[y.i++],y.value);y.reset()}fire(y){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof E)this._deliver(this._listeners,y);else{const S=this._deliveryQueue;S.enqueue(this,y,this._listeners.length),this._deliverQueue(S)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=c;const o=()=>new s;t.createEventDeliveryQueue=o;class s{constructor(){this.i=-1,this.end=0}enqueue(y,S,C){this.i=0,this.end=C,this.current=y,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends c{async fireAsync(y,S,C){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new f.LinkedList),_(this._listeners,O=>this._asyncDeliveryQueue.push([O.value,y]));this._asyncDeliveryQueue.size>0&&!S.isCancellationRequested;){const[O,H]=this._asyncDeliveryQueue.shift(),T=[],q={...H,token:S,waitUntil:$=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");C&&($=C($,O)),T.push($)}};try{O(q)}catch($){(0,P.onUnexpectedError)($);continue}Object.freeze(T),await Promise.allSettled(T).then($=>{for(const V of $)V.status==="rejected"&&(0,P.onUnexpectedError)(V.reason)})}}}t.AsyncEmitter=i;class a extends c{get isPaused(){return this._isPaused!==0}constructor(y){super(y),this._isPaused=0,this._eventQueue=new f.LinkedList,this._mergeFn=y?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._size&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}t.PauseableEmitter=a;class v extends a{constructor(y){super(y),this._delay=y.delay??100}fire(y){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(y)}}t.DebounceEmitter=v;class d extends c{constructor(y){super(y),this._queuedEvents=[],this._mergeFn=y?.merge}fire(y){this.hasListeners()&&(this._queuedEvents.push(y),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(S=>super.fire(S)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=d;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const S={event:y,listener:null};this.events.push(S),this.hasListeners&&this.hook(S);const C=()=>{this.hasListeners&&this.unhook(S);const O=this.events.indexOf(S);this.events.splice(O,1)};return(0,r.toDisposable)((0,F.createSingleCallFunction)(C))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(S=>this.emitter.fire(S))}unhook(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=L;class A{constructor(y,S,C,O){this._store=new r.DisposableStore;const H=this._store.add(new L),T=this._store.add(new r.DisposableMap);function q($){T.set($,H.add(O($)))}for(const $ of y)q($);this._store.add(S($=>{q($)})),this._store.add(C($=>{T.deleteAndDispose($)})),this.event=H.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=A;class R{constructor(){this.buffers=[]}wrapEvent(y){return(S,C,O)=>y(H=>{const T=this.buffers[this.buffers.length-1];T?T.push(()=>S.call(C,H)):S.call(C,H)},void 0,O)}bufferEvents(y){const S=[];this.buffers.push(S);const C=y();return this.buffers.pop(),S.forEach(O=>O()),C}}t.EventBufferer=R;class D{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=r.Disposable.None,this.emitter=new c({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=D}),ne(ie[24],re([0,1,11]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const F=Object.freeze(function(h,u){const l=setTimeout(h.bind(u),0);return{dispose(){clearTimeout(l)}}});var r;(function(h){function u(l){return l===h.None||l===h.Cancelled||l instanceof f?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}h.isCancellationToken=u,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(r||(t.CancellationToken=r={}));class f{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class w{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new f),this._token}cancel(){this._token?this._token instanceof f&&this._token.cancel():this._token=r.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof f&&this._token.dispose():this._token=r.None}}t.CancellationTokenSource=w}),ne(ie[39],re([0,1,24]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class F{constructor(h){this.task=h,this.result=null}get(){if(this.result)return this.result;const h=new P.CancellationTokenSource,u=this.task(h.token);return this.result={promise:u,dispose:()=>{this.result=null,h.cancel(),h.dispose()}},this.result}}t.Cache=F;class r{constructor(h){this.fn=h,this.lastCache=void 0,this.lastArgKey=void 0}get(h){const u=JSON.stringify(h);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(h)),this.lastCache}}t.LRUCachedFunction=r;class f{get cachedValues(){return this._map}constructor(h){this.fn=h,this._map=new Map}get(h){if(this._map.has(h))return this._map.get(h);const u=this.fn(h);return this._map.set(h,u),u}}t.CachedFunction=f}),ne(ie[7],re([0,1,39,38]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function r(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.isFalsyOrWhitespace=r;const f=/{(\d+)}/g;function w(I,...U){return U.length===0?I:I.replace(f,function(j,Z){const ae=parseInt(Z,10);return isNaN(ae)||ae<0||ae>=U.length?j:U[ae]})}t.format=w;const h=/{([^}]+)}/g;function u(I,U){return Object.keys(U).length===0?I:I.replace(h,(j,Z)=>U[Z]??j)}t.format2=u;function l(I){return I.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}t.escape=l;function g(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=g;function N(I,U){let j=0;const Z=U.charCodeAt(0);for(let ae=I.length-1;ae>=0;ae--)I.charCodeAt(ae)===Z&&j++;return j}t.count=N;function b(I,U,j="\u2026"){return I.length<=U?I:`${I.substr(0,U)}${j}`}t.truncate=b;function m(I,U=" "){const j=e(I,U);return p(j,U)}t.trim=m;function e(I,U){if(!I||!U)return I;const j=U.length;if(j===0||I.length===0)return I;let Z=0;for(;I.indexOf(U,Z)===Z;)Z=Z+j;return I.substring(Z)}t.ltrim=e;function p(I,U){if(!I||!U)return I;const j=U.length,Z=I.length;if(j===0||Z===0)return I;let ae=Z,ue=-1;for(;ue=I.lastIndexOf(U,ae-1),!(ue===-1||ue+j!==ae);){if(ue===0)return"";ae=ue}return I.substring(0,ae)}t.rtrim=p;function E(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=E;function M(I){return I.replace(/\*/g,"")}t.stripWildcards=M;function _(I,U,j={}){if(!I)throw new Error("Cannot create regex from empty string");U||(I=g(I)),j.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let Z="";return j.global&&(Z+="g"),j.matchCase||(Z+="i"),j.multiline&&(Z+="m"),j.unicode&&(Z+="u"),new RegExp(I,Z)}t.createRegExp=_;function c(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.regExpLeadsToEndlessLoop=c;function o(I){return I.split(/\r\n|\r|\n/)}t.splitLines=o;function s(I){for(let U=0,j=I.length;U<j;U++){const Z=I.charCodeAt(U);if(Z!==32&&Z!==9)return U}return-1}t.firstNonWhitespaceIndex=s;function i(I,U=0,j=I.length){for(let Z=U;Z<j;Z++){const ae=I.charCodeAt(Z);if(ae!==32&&ae!==9)return I.substring(U,Z)}return I.substring(U,j)}t.getLeadingWhitespace=i;function a(I,U=I.length-1){for(let j=U;j>=0;j--){const Z=I.charCodeAt(j);if(Z!==32&&Z!==9)return j}return-1}t.lastNonWhitespaceIndex=a;function v(I,U,j){const Z=[];let ae=0;for(const ue of I.matchAll(U)){if(Z.push(I.slice(ae,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");ae=ue.index+ue[0].length,Z.push(j(ue[0],...ue.slice(1),ue.index,I,ue.groups))}return Z.push(I.slice(ae)),Promise.all(Z).then(ue=>ue.join(""))}t.replaceAsync=v;function d(I,U){return I<U?-1:I>U?1:0}t.compare=d;function L(I,U,j=0,Z=I.length,ae=0,ue=U.length){for(;j<Z&&ae<ue;j++,ae++){const Ne=I.charCodeAt(j),Ee=U.charCodeAt(ae);if(Ne<Ee)return-1;if(Ne>Ee)return 1}const de=Z-j,ye=ue-ae;return de<ye?-1:de>ye?1:0}t.compareSubstring=L;function A(I,U){return R(I,U,0,I.length,0,U.length)}t.compareIgnoreCase=A;function R(I,U,j=0,Z=I.length,ae=0,ue=U.length){for(;j<Z&&ae<ue;j++,ae++){let Ne=I.charCodeAt(j),Ee=U.charCodeAt(ae);if(Ne===Ee)continue;if(Ne>=128||Ee>=128)return L(I.toLowerCase(),U.toLowerCase(),j,Z,ae,ue);k(Ne)&&(Ne-=32),k(Ee)&&(Ee-=32);const be=Ne-Ee;if(be!==0)return be}const de=Z-j,ye=ue-ae;return de<ye?-1:de>ye?1:0}t.compareSubstringIgnoreCase=R;function D(I){return I>=48&&I<=57}t.isAsciiDigit=D;function k(I){return I>=97&&I<=122}t.isLowerAsciiLetter=k;function y(I){return I>=65&&I<=90}t.isUpperAsciiLetter=y;function S(I,U){return I.length===U.length&&R(I,U)===0}t.equalsIgnoreCase=S;function C(I,U){const j=U.length;return U.length>I.length?!1:R(I,U,0,j)===0}t.startsWithIgnoreCase=C;function O(I,U){const j=Math.min(I.length,U.length);let Z;for(Z=0;Z<j;Z++)if(I.charCodeAt(Z)!==U.charCodeAt(Z))return Z;return j}t.commonPrefixLength=O;function H(I,U){const j=Math.min(I.length,U.length);let Z;const ae=I.length-1,ue=U.length-1;for(Z=0;Z<j;Z++)if(I.charCodeAt(ae-Z)!==U.charCodeAt(ue-Z))return Z;return j}t.commonSuffixLength=H;function T(I){return 55296<=I&&I<=56319}t.isHighSurrogate=T;function q(I){return 56320<=I&&I<=57343}t.isLowSurrogate=q;function $(I,U){return(I-55296<<10)+(U-56320)+65536}t.computeCodePoint=$;function V(I,U,j){const Z=I.charCodeAt(j);if(T(Z)&&j+1<U){const ae=I.charCodeAt(j+1);if(q(ae))return $(Z,ae)}return Z}t.getNextCodePoint=V;function Y(I,U){const j=I.charCodeAt(U-1);if(q(j)&&U>1){const Z=I.charCodeAt(U-2);if(T(Z))return $(Z,j)}return j}class n{get offset(){return this._offset}constructor(U,j=0){this._str=U,this._len=U.length,this._offset=j}setOffset(U){this._offset=U}prevCodePoint(){const U=Y(this._str,this._offset);return this._offset-=U>=65536?2:1,U}nextCodePoint(){const U=V(this._str,this._len,this._offset);return this._offset+=U>=65536?2:1,U}eol(){return this._offset>=this._len}}t.CodePointIterator=n;class te{get offset(){return this._iterator.offset}constructor(U,j=0){this._iterator=new n(U,j)}nextGraphemeLength(){const U=ve.getInstance(),j=this._iterator,Z=j.offset;let ae=U.getGraphemeBreakType(j.nextCodePoint());for(;!j.eol();){const ue=j.offset,de=U.getGraphemeBreakType(j.nextCodePoint());if(he(ae,de)){j.setOffset(ue);break}ae=de}return j.offset-Z}prevGraphemeLength(){const U=ve.getInstance(),j=this._iterator,Z=j.offset;let ae=U.getGraphemeBreakType(j.prevCodePoint());for(;j.offset>0;){const ue=j.offset,de=U.getGraphemeBreakType(j.prevCodePoint());if(he(de,ae)){j.setOffset(ue);break}ae=de}return Z-j.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=te;function oe(I,U){return new te(I,U).nextGraphemeLength()}t.nextCharLength=oe;function ge(I,U){return new te(I,U).prevGraphemeLength()}t.prevCharLength=ge;function pe(I,U){U>0&&q(I.charCodeAt(U))&&U--;const j=U+oe(I,U);return[j-ge(I,j),j]}t.getCharContainingOffset=pe;function Le(I){const U=new te(I);let j=0;for(;!U.eol();)j++,U.nextGraphemeLength();return j}t.charCount=Le;let _e;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Te(I){return _e||(_e=we()),_e.test(I)}t.containsRTL=Te;const ke=/^[\t\n\r\x20-\x7E]*$/;function Ie(I){return ke.test(I)}t.isBasicASCII=Ie,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ce(I){return t.UNUSUAL_LINE_TERMINATORS.test(I)}t.containsUnusualLineTerminators=Ce;function Me(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.isFullWidthCharacter=Me;function x(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.isEmojiImprecise=x;function z(I,U){if(I.length<U)return I;const j=/\b/g;let Z=0;for(;j.test(I)&&!(I.length-j.lastIndex<U);)Z=j.lastIndex,j.lastIndex+=1;return I.substring(Z).replace(/^\s/,"")}t.lcut=z;const W=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,X=/\x1b\].*?\x07/g;function ee(I){return I&&(I=I.replace(W,"").replace(X,"")),I}t.removeAnsiEscapeCodes=ee,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.startsWithUTF8BOM=Q;function G(I){return Q(I)?I.substr(1):I}t.stripUTF8BOM=G;function K(I,U){if(!I||!U||I.length<U.length)return!1;const j=U.length,Z=I.toLowerCase();let ae=0,ue=-1;for(;ae<j;){const de=Z.indexOf(U[ae],ue+1);if(de<0)return!1;ue=de,ae++}return!0}t.fuzzyContains=K;function J(I,U=!1){return I?(U&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.containsUppercaseCharacter=J;function se(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.uppercaseFirstLetter=se;function le(I,U=1){if(U===0)return"";let j=-1;do j=I.indexOf(`
`,j+1),U--;while(U>0&&j>=0);return j===-1?I:(I[j-1]==="\r"&&j--,I.substr(0,j))}t.getNLines=le;function ce(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.singleLetterHash=ce;function me(I){return ve.getInstance().getGraphemeBreakType(I)}t.getGraphemeBreakType=me;function he(I,U){return I===0?U!==5&&U!==7:I===2&&U===3?!1:I===4||I===2||I===3||U===4||U===2||U===3?!0:!(I===8&&(U===8||U===9||U===11||U===12)||(I===11||I===9)&&(U===9||U===10)||(I===12||I===10)&&U===10||U===5||U===13||U===7||I===1||I===13&&U===14||I===6&&U===6)}var Re;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(t.GraphemeBreakType=Re={}));class ve{static{this._INSTANCE=null}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}constructor(){this._data=Se()}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const j=this._data,Z=j.length/3;let ae=1;for(;ae<=Z;)if(U<j[3*ae])ae=2*ae;else if(U>j[3*ae+1])ae=2*ae+1;else return j[3*ae+2];return 0}}function Se(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(I,U){if(I===0)return 0;const j=Fe(I,U);if(j!==void 0)return j;const Z=new n(U,I);return Z.prevCodePoint(),Z.offset}t.getLeftDeleteOffset=xe;function Fe(I,U){const j=new n(U,I);let Z=j.prevCodePoint();for(;qe(Z)||Z===65039||Z===8419;){if(j.offset===0)return;Z=j.prevCodePoint()}if(!x(Z))return;let ae=j.offset;return ae>0&&j.prevCodePoint()===8205&&(ae=j.offset),ae}function qe(I){return 127995<=I&&I<=127999}var Ue;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.noBreakWhitespace="\xA0";class Pe{static{this.ambiguousCharacterData=new F.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new P.LRUCachedFunction(U=>{function j(be){const De=new Map;for(let Ae=0;Ae<be.length;Ae+=2)De.set(be[Ae],be[Ae+1]);return De}function Z(be,De){const Ae=new Map(be);for(const[Be,We]of De)Ae.set(Be,We);return Ae}function ae(be,De){if(!be)return De;const Ae=new Map;for(const[Be,We]of be)De.has(Be)&&Ae.set(Be,We);return Ae}const ue=this.ambiguousCharacterData.value;let de=U.filter(be=>!be.startsWith("_")&&be in ue);de.length===0&&(de=["_default"]);let ye;for(const be of de){const De=j(ue[be]);ye=ae(ye,De)}const Ne=j(ue._common),Ee=Z(Ne,ye);return new Pe(Ee)})}static getInstance(U){return Pe.cache.get(Array.from(U))}static{this._locales=new F.Lazy(()=>Object.keys(Pe.ambiguousCharacterData.value).filter(U=>!U.startsWith("_")))}static getLocales(){return Pe._locales.value}constructor(U){this.confusableDictionary=U}isAmbiguous(U){return this.confusableDictionary.has(U)}getPrimaryConfusable(U){return this.confusableDictionary.get(U)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Pe;class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(U){return Oe.getData().has(U)}static get codePoints(){return Oe.getData()}}t.InvisibleCharacters=Oe}),ne(ie[40],re([0,1,7]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function F(M){return r(M,0)}t.hash=F;function r(M,_){switch(typeof M){case"object":return M===null?f(349,_):Array.isArray(M)?u(M,_):l(M,_);case"string":return h(M,_);case"boolean":return w(M,_);case"number":return f(M,_);case"undefined":return f(937,_);default:return f(617,_)}}t.doHash=r;function f(M,_){return(_<<5)-_+M|0}t.numberHash=f;function w(M,_){return f(M?433:863,_)}function h(M,_){_=f(149417,_);for(let c=0,o=M.length;c<o;c++)_=f(M.charCodeAt(c),_);return _}t.stringHash=h;function u(M,_){return _=f(104579,_),M.reduce((c,o)=>r(o,c),_)}function l(M,_){return _=f(181387,_),Object.keys(M).sort().reduce((c,o)=>(c=h(o,c),r(M[o],c)),_)}class g{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=r(_,this._value),this._value}}t.Hasher=g;var N;(function(M){M[M.BLOCK_SIZE=64]="BLOCK_SIZE",M[M.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function b(M,_,c=32){const o=c-_,s=~((1<<o)-1);return(M<<_|(s&M)>>>o)>>>0}function m(M,_=0,c=M.byteLength,o=0){for(let s=0;s<c;s++)M[_+s]=o}function e(M,_,c="0"){for(;M.length<_;)M=c+M;return M}function p(M,_=32){return M instanceof ArrayBuffer?Array.from(new Uint8Array(M)).map(c=>c.toString(16).padStart(2,"0")).join(""):e((M>>>0).toString(16),_/4)}t.toHexString=p;class E{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const c=_.length;if(c===0)return;const o=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,a,v;for(i!==0?(a=i,v=-1,i=0):(a=_.charCodeAt(0),v=0);;){let d=a;if(P.isHighSurrogate(a))if(v+1<c){const L=_.charCodeAt(v+1);P.isLowSurrogate(L)?(v++,d=P.computeCodePoint(a,L)):d=65533}else{i=a;break}else P.isLowSurrogate(a)&&(d=65533);if(s=this._push(o,s,d),v++,v<c)a=_.charCodeAt(v);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(_,c,o){return o<128?_[c++]=o:o<2048?(_[c++]=192|(o&1984)>>>6,_[c++]=128|(o&63)>>>0):o<65536?(_[c++]=224|(o&61440)>>>12,_[c++]=128|(o&4032)>>>6,_[c++]=128|(o&63)>>>0):(_[c++]=240|(o&1835008)>>>18,_[c++]=128|(o&258048)>>>12,_[c++]=128|(o&4032)>>>6,_[c++]=128|(o&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=E._bigBlock32,c=this._buffDV;for(let R=0;R<64;R+=4)_.setUint32(R,c.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)_.setUint32(R,b(_.getUint32(R-12,!1)^_.getUint32(R-32,!1)^_.getUint32(R-56,!1)^_.getUint32(R-64,!1),1),!1);let o=this._h0,s=this._h1,i=this._h2,a=this._h3,v=this._h4,d,L,A;for(let R=0;R<80;R++)R<20?(d=s&i|~s&a,L=1518500249):R<40?(d=s^i^a,L=1859775393):R<60?(d=s&i|s&a|i&a,L=2400959708):(d=s^i^a,L=3395469782),A=b(o,5)+d+v+L+_.getUint32(R*4,!1)&4294967295,v=a,a=i,i=b(s,30),s=o,o=A;this._h0=this._h0+o&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+v&4294967295}}t.StringSHA1=E}),ne(ie[25],re([0,1,36,40]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class r{constructor(b){this.source=b}getElements(){const b=this.source,m=new Int32Array(b.length);for(let e=0,p=b.length;e<p;e++)m[e]=b.charCodeAt(e);return m}}t.StringDiffSequence=r;function f(N,b,m){return new g(new r(N),new r(b)).ComputeDiff(m).changes}t.stringDiff=f;class w{static Assert(b,m){if(!b)throw new Error(m)}}class h{static Copy(b,m,e,p,E){for(let M=0;M<E;M++)e[p+M]=b[m+M]}static Copy2(b,m,e,p,E){for(let M=0;M<E;M++)e[p+M]=b[m+M]}}var u;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(b,m){this.m_originalStart=Math.min(this.m_originalStart,b),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(b,m){this.m_originalStart=Math.min(this.m_originalStart,b),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class g{constructor(b,m,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=b,this._modifiedSequence=m;const[p,E,M]=g._getElements(b),[_,c,o]=g._getElements(m);this._hasStrings=M&&o,this._originalStringElements=p,this._originalElementsOrHash=E,this._modifiedStringElements=_,this._modifiedElementsOrHash=c,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(b){return b.length>0&&typeof b[0]=="string"}static _getElements(b){const m=b.getElements();if(g._isStringArray(m)){const e=new Int32Array(m.length);for(let p=0,E=m.length;p<E;p++)e[p]=(0,F.stringHash)(m[p],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(b,m){return this._originalElementsOrHash[b]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[b]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(b,m){if(!this.ElementsAreEqual(b,m))return!1;const e=g._getStrictElement(this._originalSequence,b),p=g._getStrictElement(this._modifiedSequence,m);return e===p}static _getStrictElement(b,m){return typeof b.getStrictElement=="function"?b.getStrictElement(m):null}OriginalElementsAreEqual(b,m){return this._originalElementsOrHash[b]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[b]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(b,m){return this._modifiedElementsOrHash[b]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[b]===this._modifiedStringElements[m]:!0}ComputeDiff(b){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,b)}_ComputeDiff(b,m,e,p,E){const M=[!1];let _=this.ComputeDiffRecursive(b,m,e,p,M);return E&&(_=this.PrettifyChanges(_)),{quitEarly:M[0],changes:_}}ComputeDiffRecursive(b,m,e,p,E){for(E[0]=!1;b<=m&&e<=p&&this.ElementsAreEqual(b,e);)b++,e++;for(;m>=b&&p>=e&&this.ElementsAreEqual(m,p);)m--,p--;if(b>m||e>p){let i;return e<=p?(w.Assert(b===m+1,"originalStart should only be one more than originalEnd"),i=[new P.DiffChange(b,0,e,p-e+1)]):b<=m?(w.Assert(e===p+1,"modifiedStart should only be one more than modifiedEnd"),i=[new P.DiffChange(b,m-b+1,e,0)]):(w.Assert(b===m+1,"originalStart should only be one more than originalEnd"),w.Assert(e===p+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const M=[0],_=[0],c=this.ComputeRecursionPoint(b,m,e,p,M,_,E),o=M[0],s=_[0];if(c!==null)return c;if(!E[0]){const i=this.ComputeDiffRecursive(b,o,e,s,E);let a=[];return E[0]?a=[new P.DiffChange(o+1,m-(o+1)+1,s+1,p-(s+1)+1)]:a=this.ComputeDiffRecursive(o+1,m,s+1,p,E),this.ConcatenateChanges(i,a)}return[new P.DiffChange(b,m-b+1,e,p-e+1)]}WALKTRACE(b,m,e,p,E,M,_,c,o,s,i,a,v,d,L,A,R,D){let k=null,y=null,S=new l,C=m,O=e,H=v[0]-A[0]-p,T=-1073741824,q=this.m_forwardHistory.length-1;do{const $=H+b;$===C||$<O&&o[$-1]<o[$+1]?(i=o[$+1],d=i-H-p,i<T&&S.MarkNextChange(),T=i,S.AddModifiedElement(i+1,d),H=$+1-b):(i=o[$-1]+1,d=i-H-p,i<T&&S.MarkNextChange(),T=i-1,S.AddOriginalElement(i,d+1),H=$-1-b),q>=0&&(o=this.m_forwardHistory[q],b=o[0],C=1,O=o.length-1)}while(--q>=-1);if(k=S.getReverseChanges(),D[0]){let $=v[0]+1,V=A[0]+1;if(k!==null&&k.length>0){const Y=k[k.length-1];$=Math.max($,Y.getOriginalEnd()),V=Math.max(V,Y.getModifiedEnd())}y=[new P.DiffChange($,a-$+1,V,L-V+1)]}else{S=new l,C=M,O=_,H=v[0]-A[0]-c,T=1073741824,q=R?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const $=H+E;$===C||$<O&&s[$-1]>=s[$+1]?(i=s[$+1]-1,d=i-H-c,i>T&&S.MarkNextChange(),T=i+1,S.AddOriginalElement(i+1,d+1),H=$+1-E):(i=s[$-1],d=i-H-c,i>T&&S.MarkNextChange(),T=i,S.AddModifiedElement(i+1,d+1),H=$-1-E),q>=0&&(s=this.m_reverseHistory[q],E=s[0],C=1,O=s.length-1)}while(--q>=-1);y=S.getChanges()}return this.ConcatenateChanges(k,y)}ComputeRecursionPoint(b,m,e,p,E,M,_){let c=0,o=0,s=0,i=0,a=0,v=0;b--,e--,E[0]=0,M[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=m-b+(p-e),L=d+1,A=new Int32Array(L),R=new Int32Array(L),D=p-e,k=m-b,y=b-e,S=m-p,O=(k-D)%2===0;A[D]=b,R[k]=m,_[0]=!1;for(let H=1;H<=d/2+1;H++){let T=0,q=0;s=this.ClipDiagonalBound(D-H,H,D,L),i=this.ClipDiagonalBound(D+H,H,D,L);for(let V=s;V<=i;V+=2){V===s||V<i&&A[V-1]<A[V+1]?c=A[V+1]:c=A[V-1]+1,o=c-(V-D)-y;const Y=c;for(;c<m&&o<p&&this.ElementsAreEqual(c+1,o+1);)c++,o++;if(A[V]=c,c+o>T+q&&(T=c,q=o),!O&&Math.abs(V-k)<=H-1&&c>=R[V])return E[0]=c,M[0]=o,Y<=R[V]&&1447>0&&H<=1447+1?this.WALKTRACE(D,s,i,y,k,a,v,S,A,R,c,m,E,o,p,M,O,_):null}const $=(T-b+(q-e)-H)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(T,$))return _[0]=!0,E[0]=T,M[0]=q,$>0&&1447>0&&H<=1447+1?this.WALKTRACE(D,s,i,y,k,a,v,S,A,R,c,m,E,o,p,M,O,_):(b++,e++,[new P.DiffChange(b,m-b+1,e,p-e+1)]);a=this.ClipDiagonalBound(k-H,H,k,L),v=this.ClipDiagonalBound(k+H,H,k,L);for(let V=a;V<=v;V+=2){V===a||V<v&&R[V-1]>=R[V+1]?c=R[V+1]-1:c=R[V-1],o=c-(V-k)-S;const Y=c;for(;c>b&&o>e&&this.ElementsAreEqual(c,o);)c--,o--;if(R[V]=c,O&&Math.abs(V-D)<=H&&c<=A[V])return E[0]=c,M[0]=o,Y>=A[V]&&1447>0&&H<=1447+1?this.WALKTRACE(D,s,i,y,k,a,v,S,A,R,c,m,E,o,p,M,O,_):null}if(H<=1447){let V=new Int32Array(i-s+2);V[0]=D-s+1,h.Copy2(A,s,V,1,i-s+1),this.m_forwardHistory.push(V),V=new Int32Array(v-a+2),V[0]=k-a+1,h.Copy2(R,a,V,1,v-a+1),this.m_reverseHistory.push(V)}}return this.WALKTRACE(D,s,i,y,k,a,v,S,A,R,c,m,E,o,p,M,O,_)}PrettifyChanges(b){for(let m=0;m<b.length;m++){const e=b[m],p=m<b.length-1?b[m+1].originalStart:this._originalElementsOrHash.length,E=m<b.length-1?b[m+1].modifiedStart:this._modifiedElementsOrHash.length,M=e.originalLength>0,_=e.modifiedLength>0;for(;e.originalStart+e.originalLength<p&&e.modifiedStart+e.modifiedLength<E&&(!M||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!_||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const c=[null];if(m<b.length-1&&this.ChangesOverlap(b[m],b[m+1],c)){b[m]=c[0],b.splice(m+1,1),m--;continue}}for(let m=b.length-1;m>=0;m--){const e=b[m];let p=0,E=0;if(m>0){const i=b[m-1];p=i.originalStart+i.originalLength,E=i.modifiedStart+i.modifiedLength}const M=e.originalLength>0,_=e.modifiedLength>0;let c=0,o=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const a=e.originalStart-i,v=e.modifiedStart-i;if(a<p||v<E||M&&!this.OriginalElementsAreEqual(a,a+e.originalLength)||_&&!this.ModifiedElementsAreEqual(v,v+e.modifiedLength))break;const L=(a===p&&v===E?5:0)+this._boundaryScore(a,e.originalLength,v,e.modifiedLength);L>o&&(o=L,c=i)}e.originalStart-=c,e.modifiedStart-=c;const s=[null];if(m>0&&this.ChangesOverlap(b[m-1],b[m],s)){b[m-1]=s[0],b.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,e=b.length;m<e;m++){const p=b[m-1],E=b[m],M=E.originalStart-p.originalStart-p.originalLength,_=p.originalStart,c=E.originalStart+E.originalLength,o=c-_,s=p.modifiedStart,i=E.modifiedStart+E.modifiedLength,a=i-s;if(M<5&&o<20&&a<20){const v=this._findBetterContiguousSequence(_,o,s,a,M);if(v){const[d,L]=v;(d!==p.originalStart+p.originalLength||L!==p.modifiedStart+p.modifiedLength)&&(p.originalLength=d-p.originalStart,p.modifiedLength=L-p.modifiedStart,E.originalStart=d+M,E.modifiedStart=L+M,E.originalLength=c-E.originalStart,E.modifiedLength=i-E.modifiedStart)}}}return b}_findBetterContiguousSequence(b,m,e,p,E){if(m<E||p<E)return null;const M=b+m-E+1,_=e+p-E+1;let c=0,o=0,s=0;for(let i=b;i<M;i++)for(let a=e;a<_;a++){const v=this._contiguousSequenceScore(i,a,E);v>0&&v>c&&(c=v,o=i,s=a)}return c>0?[o,s]:null}_contiguousSequenceScore(b,m,e){let p=0;for(let E=0;E<e;E++){if(!this.ElementsAreEqual(b+E,m+E))return 0;p+=this._originalStringElements[b+E].length}return p}_OriginalIsBoundary(b){return b<=0||b>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[b])}_OriginalRegionIsBoundary(b,m){if(this._OriginalIsBoundary(b)||this._OriginalIsBoundary(b-1))return!0;if(m>0){const e=b+m;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(b){return b<=0||b>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[b])}_ModifiedRegionIsBoundary(b,m){if(this._ModifiedIsBoundary(b)||this._ModifiedIsBoundary(b-1))return!0;if(m>0){const e=b+m;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(b,m,e,p){const E=this._OriginalRegionIsBoundary(b,m)?1:0,M=this._ModifiedRegionIsBoundary(e,p)?1:0;return E+M}ConcatenateChanges(b,m){const e=[];if(b.length===0||m.length===0)return m.length>0?m:b;if(this.ChangesOverlap(b[b.length-1],m[0],e)){const p=new Array(b.length+m.length-1);return h.Copy(b,0,p,0,b.length-1),p[b.length-1]=e[0],h.Copy(m,1,p,b.length,m.length-1),p}else{const p=new Array(b.length+m.length);return h.Copy(b,0,p,0,b.length),h.Copy(m,0,p,b.length,m.length),p}}ChangesOverlap(b,m,e){if(w.Assert(b.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),w.Assert(b.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=m.originalStart||b.modifiedStart+b.modifiedLength>=m.modifiedStart){const p=b.originalStart;let E=b.originalLength;const M=b.modifiedStart;let _=b.modifiedLength;return b.originalStart+b.originalLength>=m.originalStart&&(E=m.originalStart+m.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=m.modifiedStart&&(_=m.modifiedStart+m.modifiedLength-b.modifiedStart),e[0]=new P.DiffChange(p,E,M,_),!0}else return e[0]=null,!1}ClipDiagonalBound(b,m,e,p){if(b>=0&&b<p)return b;const E=e,M=p-e-1,_=m%2===0;if(b<0){const c=E%2===0;return _===c?0:1}else{const c=M%2===0;return _===c?p-1:p-2}}}t.LcsDiff=g}),ne(ie[26],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function P(s){return typeof s=="string"}t.isString=P;function F(s){return Array.isArray(s)&&s.every(i=>P(i))}t.isStringArray=F;function r(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.isObject=r;function f(s){const i=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof i}t.isTypedArray=f;function w(s){return typeof s=="number"&&!isNaN(s)}t.isNumber=w;function h(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.isIterable=h;function u(s){return s===!0||s===!1}t.isBoolean=u;function l(s){return typeof s>"u"}t.isUndefined=l;function g(s){return!N(s)}t.isDefined=g;function N(s){return l(s)||s===null}t.isUndefinedOrNull=N;function b(s,i){if(!s)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.assertType=b;function m(s){if(N(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.assertIsDefined=m;function e(...s){const i=[];for(let a=0;a<s.length;a++){const v=s[a];if(N(v))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(v)}return i}t.assertAllDefined=e;const p=Object.prototype.hasOwnProperty;function E(s){if(!r(s))return!1;for(const i in s)if(p.call(s,i))return!1;return!0}t.isEmptyObject=E;function M(s){return typeof s=="function"}t.isFunction=M;function _(...s){return s.length>0&&s.every(M)}t.areFunctions=_;function c(s,i){const a=Math.min(s.length,i.length);for(let v=0;v<a;v++)o(s[v],i[v])}t.validateConstraints=c;function o(s,i){if(P(i)){if(typeof s!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(M(i)){try{if(s instanceof i)return}catch{}if(!N(s)&&s.constructor===i||i.length===1&&i.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=o}),ne(ie[41],re([0,1,26]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const F=Object.create(null);function r(h,u){if((0,P.isString)(u)){const l=F[u];if(l===void 0)throw new Error(`${h} references an unknown codicon: ${u}`);u=l}return F[h]=u,{id:h}}function f(){return F}t.getCodiconFontCharacters=f;function w(){return Object.values(t.Codicon)}t.getAllCodicons=w,t.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),ne(ie[14],re([0,1,26]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ensureOptionalStringValue=t.ensureOptionalNumberValue=t.ensureOptionalBooleanValue=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const s=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,a])=>{s[i]=a&&typeof a=="object"?F(a):a}),s}t.deepClone=F;function r(o){if(!o||typeof o!="object")return o;const s=[o];for(;s.length>0;){const i=s.shift();Object.freeze(i);for(const a in i)if(f.call(i,a)){const v=i[a];typeof v=="object"&&!Object.isFrozen(v)&&!(0,P.isTypedArray)(v)&&s.push(v)}}return o}t.deepFreeze=r;const f=Object.prototype.hasOwnProperty;function w(o,s){return h(o,s,new Set)}t.cloneAndChange=w;function h(o,s,i){if((0,P.isUndefinedOrNull)(o))return o;const a=s(o);if(typeof a<"u")return a;if(Array.isArray(o)){const v=[];for(const d of o)v.push(h(d,s,i));return v}if((0,P.isObject)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const v={};for(const d in o)f.call(o,d)&&(v[d]=h(o[d],s,i));return i.delete(o),v}return o}function u(o,s,i=!0){return(0,P.isObject)(o)?((0,P.isObject)(s)&&Object.keys(s).forEach(a=>{a in o?i&&((0,P.isObject)(o[a])&&(0,P.isObject)(s[a])?u(o[a],s[a],i):o[a]=s[a]):o[a]=s[a]}),o):s}t.mixin=u;function l(o,s){if(o===s)return!0;if(o==null||s===null||s===void 0||typeof o!=typeof s||typeof o!="object"||Array.isArray(o)!==Array.isArray(s))return!1;let i,a;if(Array.isArray(o)){if(o.length!==s.length)return!1;for(i=0;i<o.length;i++)if(!l(o[i],s[i]))return!1}else{const v=[];for(a in o)v.push(a);v.sort();const d=[];for(a in s)d.push(a);if(d.sort(),!l(v,d))return!1;for(i=0;i<v.length;i++)if(!l(o[v[i]],s[v[i]]))return!1}return!0}t.equals=l;function g(o){const s=new Set;return JSON.stringify(o,(i,a)=>{if((0,P.isObject)(a)||Array.isArray(a)){if(s.has(a))return"[Circular]";s.add(a)}return a})}t.safeStringify=g;function N(o,s){const i=Object.create(null);return!o||!s||Object.keys(s).forEach(v=>{const d=o[v],L=s[v];l(d,L)||(i[v]=L)}),i}t.distinct=N;function b(o,s){const i=s.toLowerCase(),a=Object.keys(o).find(v=>v.toLowerCase()===i);return a?o[a]:o[s]}t.getCaseInsensitive=b;function m(o,s){const i=Object.create(null);for(const[a,v]of Object.entries(o))s(a,v)&&(i[a]=v);return i}t.filter=m;function e(o){let s=[];for(;Object.prototype!==o;)s=s.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return s}t.getAllPropertyNames=e;function p(o){const s=[];for(const i of e(o))typeof o[i]=="function"&&s.push(i);return s}t.getAllMethodNames=p;function E(o,s){const i=v=>function(){const d=Array.prototype.slice.call(arguments,0);return s(v,d)},a={};for(const v of o)a[v]=i(v);return a}t.createProxyObject=E;function M(o,s,i){typeof s=="string"&&o[s]!==void 0&&typeof o[s]!="boolean"&&(o[s]=i)}t.ensureOptionalBooleanValue=M;function _(o,s,i){typeof s=="string"&&o[s]!==void 0&&typeof o[s]!="number"&&(o[s]=i)}t.ensureOptionalNumberValue=_;function c(o,s,i,a){if(typeof s!="string")return;const v=o[s];v!==void 0&&(typeof v!="string"||!i.includes(v))&&(o[s]=a)}t.ensureOptionalStringValue=c}),ne(ie[27],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var P;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(t.Constants=P={}));function F(f){return f<0?0:f>255?255:f|0}t.toUint8=F;function r(f){return f<0?0:f>4294967295?4294967295:f|0}t.toUint32=r}),ne(ie[28],re([0,1,27]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class F{constructor(h){const u=(0,P.toUint8)(h);this._defaultValue=u,this._asciiMap=F._createAsciiMap(u),this._map=new Map}static _createAsciiMap(h){const u=new Uint8Array(256);return u.fill(h),u}set(h,u){const l=(0,P.toUint8)(u);h>=0&&h<256?this._asciiMap[h]=l:this._map.set(h,l)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=F;var r;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(r||(r={}));class f{constructor(){this._actual=new F(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}clear(){return this._actual.clear()}}t.CharacterSet=f}),ne(ie[4],re([0,1,3]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRangeSet=t.OffsetRange=void 0;class F{static addRange(w,h){let u=0;for(;u<h.length&&h[u].endExclusive<w.start;)u++;let l=u;for(;l<h.length&&h[l].start<=w.endExclusive;)l++;if(u===l)h.splice(u,0,w);else{const g=Math.min(w.start,h[u].start),N=Math.max(w.endExclusive,h[l-1].endExclusive);h.splice(u,l-u,new F(g,N))}}static tryCreate(w,h){if(!(w>h))return new F(w,h)}static ofLength(w){return new F(0,w)}constructor(w,h){if(this.start=w,this.endExclusive=h,w>h)throw new P.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(w){return new F(this.start+w,this.endExclusive+w)}deltaStart(w){return new F(this.start+w,this.endExclusive)}deltaEnd(w){return new F(this.start,this.endExclusive+w)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(w){return this.start===w.start&&this.endExclusive===w.endExclusive}containsRange(w){return this.start<=w.start&&w.endExclusive<=this.endExclusive}contains(w){return this.start<=w&&w<this.endExclusive}join(w){return new F(Math.min(this.start,w.start),Math.max(this.endExclusive,w.endExclusive))}intersect(w){const h=Math.max(this.start,w.start),u=Math.min(this.endExclusive,w.endExclusive);if(h<=u)return new F(h,u)}intersectsOrTouches(w){const h=Math.max(this.start,w.start),u=Math.min(this.endExclusive,w.endExclusive);return h<=u}slice(w){return w.slice(this.start,this.endExclusive)}clip(w){if(this.isEmpty)throw new P.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,w))}clipCyclic(w){if(this.isEmpty)throw new P.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return w<this.start?this.endExclusive-(this.start-w)%this.length:w>=this.endExclusive?this.start+(w-this.start)%this.length:w}map(w){const h=[];for(let u=this.start;u<this.endExclusive;u++)h.push(w(u));return h}forEach(w){for(let h=this.start;h<this.endExclusive;h++)w(h)}}t.OffsetRange=F;class r{constructor(){this._sortedRanges=[]}addRange(w){let h=0;for(;h<this._sortedRanges.length&&this._sortedRanges[h].endExclusive<w.start;)h++;let u=h;for(;u<this._sortedRanges.length&&this._sortedRanges[u].start<=w.endExclusive;)u++;if(h===u)this._sortedRanges.splice(h,0,w);else{const l=Math.min(w.start,this._sortedRanges[h].start),g=Math.max(w.endExclusive,this._sortedRanges[u-1].endExclusive);this._sortedRanges.splice(h,u-h,new F(l,g))}}toString(){return this._sortedRanges.map(w=>w.toString()).join(", ")}intersectsStrict(w){let h=0;for(;h<this._sortedRanges.length&&this._sortedRanges[h].endExclusive<=w.start;)h++;return h<this._sortedRanges.length&&this._sortedRanges[h].start<w.endExclusive}intersectWithRange(w){const h=new r;for(const u of this._sortedRanges){const l=u.intersect(w);l&&h.addRange(l)}return h}intersectWithRangeLength(w){return this.intersectWithRange(w).length}get length(){return this._sortedRanges.reduce((w,h)=>w+h.length,0)}}t.OffsetRangeSet=r}),ne(ie[5],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class P{constructor(r,f){this.lineNumber=r,this.column=f}with(r=this.lineNumber,f=this.column){return r===this.lineNumber&&f===this.column?this:new P(r,f)}delta(r=0,f=0){return this.with(this.lineNumber+r,this.column+f)}equals(r){return P.equals(this,r)}static equals(r,f){return!r&&!f?!0:!!r&&!!f&&r.lineNumber===f.lineNumber&&r.column===f.column}isBefore(r){return P.isBefore(this,r)}static isBefore(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<f.column}isBeforeOrEqual(r){return P.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<=f.column}static compare(r,f){const w=r.lineNumber|0,h=f.lineNumber|0;if(w===h){const u=r.column|0,l=f.column|0;return u-l}return w-h}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new P(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.Position=P}),ne(ie[2],re([0,1,5]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class F{constructor(f,w,h,u){f>h||f===h&&w>u?(this.startLineNumber=h,this.startColumn=u,this.endLineNumber=f,this.endColumn=w):(this.startLineNumber=f,this.startColumn=w,this.endLineNumber=h,this.endColumn=u)}isEmpty(){return F.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return F.containsPosition(this,f)}static containsPosition(f,w){return!(w.lineNumber<f.startLineNumber||w.lineNumber>f.endLineNumber||w.lineNumber===f.startLineNumber&&w.column<f.startColumn||w.lineNumber===f.endLineNumber&&w.column>f.endColumn)}static strictContainsPosition(f,w){return!(w.lineNumber<f.startLineNumber||w.lineNumber>f.endLineNumber||w.lineNumber===f.startLineNumber&&w.column<=f.startColumn||w.lineNumber===f.endLineNumber&&w.column>=f.endColumn)}containsRange(f){return F.containsRange(this,f)}static containsRange(f,w){return!(w.startLineNumber<f.startLineNumber||w.endLineNumber<f.startLineNumber||w.startLineNumber>f.endLineNumber||w.endLineNumber>f.endLineNumber||w.startLineNumber===f.startLineNumber&&w.startColumn<f.startColumn||w.endLineNumber===f.endLineNumber&&w.endColumn>f.endColumn)}strictContainsRange(f){return F.strictContainsRange(this,f)}static strictContainsRange(f,w){return!(w.startLineNumber<f.startLineNumber||w.endLineNumber<f.startLineNumber||w.startLineNumber>f.endLineNumber||w.endLineNumber>f.endLineNumber||w.startLineNumber===f.startLineNumber&&w.startColumn<=f.startColumn||w.endLineNumber===f.endLineNumber&&w.endColumn>=f.endColumn)}plusRange(f){return F.plusRange(this,f)}static plusRange(f,w){let h,u,l,g;return w.startLineNumber<f.startLineNumber?(h=w.startLineNumber,u=w.startColumn):w.startLineNumber===f.startLineNumber?(h=w.startLineNumber,u=Math.min(w.startColumn,f.startColumn)):(h=f.startLineNumber,u=f.startColumn),w.endLineNumber>f.endLineNumber?(l=w.endLineNumber,g=w.endColumn):w.endLineNumber===f.endLineNumber?(l=w.endLineNumber,g=Math.max(w.endColumn,f.endColumn)):(l=f.endLineNumber,g=f.endColumn),new F(h,u,l,g)}intersectRanges(f){return F.intersectRanges(this,f)}static intersectRanges(f,w){let h=f.startLineNumber,u=f.startColumn,l=f.endLineNumber,g=f.endColumn;const N=w.startLineNumber,b=w.startColumn,m=w.endLineNumber,e=w.endColumn;return h<N?(h=N,u=b):h===N&&(u=Math.max(u,b)),l>m?(l=m,g=e):l===m&&(g=Math.min(g,e)),h>l||h===l&&u>g?null:new F(h,u,l,g)}equalsRange(f){return F.equalsRange(this,f)}static equalsRange(f,w){return!f&&!w?!0:!!f&&!!w&&f.startLineNumber===w.startLineNumber&&f.startColumn===w.startColumn&&f.endLineNumber===w.endLineNumber&&f.endColumn===w.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(f){return new P.Position(f.endLineNumber,f.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(f){return new P.Position(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,w){return new F(this.startLineNumber,this.startColumn,f,w)}setStartPosition(f,w){return new F(f,w,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(f){return new F(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(f){return new F(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new F(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,w=f){return new F(f.lineNumber,f.column,w.lineNumber,w.column)}static lift(f){return f?new F(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,w){return!(f.endLineNumber<w.startLineNumber||f.endLineNumber===w.startLineNumber&&f.endColumn<w.startColumn||w.endLineNumber<f.startLineNumber||w.endLineNumber===f.startLineNumber&&w.endColumn<f.startColumn)}static areIntersecting(f,w){return!(f.endLineNumber<w.startLineNumber||f.endLineNumber===w.startLineNumber&&f.endColumn<=w.startColumn||w.endLineNumber<f.startLineNumber||w.endLineNumber===f.startLineNumber&&w.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,w){if(f&&w){const l=f.startLineNumber|0,g=w.startLineNumber|0;if(l===g){const N=f.startColumn|0,b=w.startColumn|0;if(N===b){const m=f.endLineNumber|0,e=w.endLineNumber|0;if(m===e){const p=f.endColumn|0,E=w.endColumn|0;return p-E}return m-e}return N-b}return l-g}return(f?1:0)-(w?1:0)}static compareRangesUsingEnds(f,w){return f.endLineNumber===w.endLineNumber?f.endColumn===w.endColumn?f.startLineNumber===w.startLineNumber?f.startColumn-w.startColumn:f.startLineNumber-w.startLineNumber:f.endColumn-w.endColumn:f.endLineNumber-w.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.Range=F}),ne(ie[42],re([0,1,2]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditOperation=void 0;class F{static insert(f,w){return{range:new P.Range(f.lineNumber,f.column,f.lineNumber,f.column),text:w,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,w){return{range:f,text:w}}static replaceMove(f,w){return{range:f,text:w,forceMoveMarkers:!0}}}t.EditOperation=F}),ne(ie[12],re([0,1,3,4,2,9]),function(B,t,P,F,r,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeSet=t.LineRange=void 0;class w{static fromRange(l){return new w(l.startLineNumber,l.endLineNumber)}static subtract(l,g){return g?l.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<l.endLineNumberExclusive?[new w(l.startLineNumber,g.startLineNumber),new w(g.endLineNumberExclusive,l.endLineNumberExclusive)]:g.startLineNumber<=l.startLineNumber&&l.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<l.endLineNumberExclusive?[new w(Math.max(g.endLineNumberExclusive,l.startLineNumber),l.endLineNumberExclusive)]:[new w(l.startLineNumber,Math.min(g.startLineNumber,l.endLineNumberExclusive))]:[l]}static joinMany(l){if(l.length===0)return[];let g=new h(l[0].slice());for(let N=1;N<l.length;N++)g=g.getUnion(new h(l[N].slice()));return g.ranges}static ofLength(l,g){return new w(l,l+g)}static deserialize(l){return new w(l[0],l[1])}constructor(l,g){if(l>g)throw new P.BugIndicatingError(`startLineNumber ${l} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=l,this.endLineNumberExclusive=g}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new w(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new w(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new w(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const g=Math.max(this.startLineNumber,l.startLineNumber),N=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(g<=N)return new w(g,N)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const g=[];for(let N=this.startLineNumber;N<this.endLineNumberExclusive;N++)g.push(l(N));return g}forEach(l){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)l(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new F.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.LineRange=w;class h{constructor(l=[]){this._normalizedRanges=l}get ranges(){return this._normalizedRanges}addRange(l){if(l.length===0)return;const g=(0,f.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,b=>b.endLineNumberExclusive>=l.startLineNumber),N=(0,f.findLastIdxMonotonous)(this._normalizedRanges,b=>b.startLineNumber<=l.endLineNumberExclusive)+1;if(g===N)this._normalizedRanges.splice(g,0,l);else if(g===N-1){const b=this._normalizedRanges[g];this._normalizedRanges[g]=b.join(l)}else{const b=this._normalizedRanges[g].join(this._normalizedRanges[N-1]).join(l);this._normalizedRanges.splice(g,N-g,b)}}contains(l){const g=(0,f.findLastMonotonous)(this._normalizedRanges,N=>N.startLineNumber<=l);return!!g&&g.endLineNumberExclusive>l}intersects(l){const g=(0,f.findLastMonotonous)(this._normalizedRanges,N=>N.startLineNumber<l.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this._normalizedRanges.length===0)return l;if(l._normalizedRanges.length===0)return this;const g=[];let N=0,b=0,m=null;for(;N<this._normalizedRanges.length||b<l._normalizedRanges.length;){let e=null;if(N<this._normalizedRanges.length&&b<l._normalizedRanges.length){const p=this._normalizedRanges[N],E=l._normalizedRanges[b];p.startLineNumber<E.startLineNumber?(e=p,N++):(e=E,b++)}else N<this._normalizedRanges.length?(e=this._normalizedRanges[N],N++):(e=l._normalizedRanges[b],b++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new w(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push(m),m=e)}return m!==null&&g.push(m),new h(g)}subtractFrom(l){const g=(0,f.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,e=>e.endLineNumberExclusive>=l.startLineNumber),N=(0,f.findLastIdxMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=l.endLineNumberExclusive)+1;if(g===N)return new h([l]);const b=[];let m=l.startLineNumber;for(let e=g;e<N;e++){const p=this._normalizedRanges[e];p.startLineNumber>m&&b.push(new w(m,p.startLineNumber)),m=p.endLineNumberExclusive}return m<l.endLineNumberExclusive&&b.push(new w(m,l.endLineNumberExclusive)),new h(b)}toString(){return this._normalizedRanges.map(l=>l.toString()).join(", ")}getIntersection(l){const g=[];let N=0,b=0;for(;N<this._normalizedRanges.length&&b<l._normalizedRanges.length;){const m=this._normalizedRanges[N],e=l._normalizedRanges[b],p=m.intersect(e);p&&!p.isEmpty&&g.push(p),m.endLineNumberExclusive<e.endLineNumberExclusive?N++:b++}return new h(g)}getWithDelta(l){return new h(this._normalizedRanges.map(g=>g.delta(l)))}}t.LineRangeSet=h}),ne(ie[43],re([0,1,5,2]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var r;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class f extends F.Range{constructor(h,u,l,g){super(h,u,l,g),this.selectionStartLineNumber=h,this.selectionStartColumn=u,this.positionLineNumber=l,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,u){return h.selectionStartLineNumber===u.selectionStartLineNumber&&h.selectionStartColumn===u.selectionStartColumn&&h.positionLineNumber===u.positionLineNumber&&h.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,u){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,u):new f(h,u,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,u){return this.getDirection()===0?new f(h,u,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,u)}static fromPositions(h,u=h){return new f(h.lineNumber,h.column,u.lineNumber,u.column)}static fromRange(h,u){return u===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,u){if(h&&!u||!h&&u)return!1;if(!h&&!u)return!0;if(h.length!==u.length)return!1;for(let l=0,g=h.length;l<g;l++)if(!this.selectionsEqual(h[l],u[l]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,u,l,g,N){return N===0?new f(h,u,l,g):new f(l,g,h,u)}}t.Selection=f}),ne(ie[44],re([0,1,28]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var F;(function(w){w[w.Regular=0]="Regular",w[w.Whitespace=1]="Whitespace",w[w.WordSeparator=2]="WordSeparator"})(F||(t.WordCharacterClass=F={}));class r extends P.CharacterClassifier{constructor(h){super(0);for(let u=0,l=h.length;u<l;u++)this.set(h.charCodeAt(u),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=r;function f(w){const h={};return u=>(h.hasOwnProperty(u)||(h[u]=w(u)),h[u])}t.getMapForWordSeparators=f(w=>new r(w))}),ne(ie[29],re([0,1,20,10,21]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(N=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.USUAL_WORD_SEPARATORS)N.indexOf(m)>=0||(b+="\\"+m);return b+="\\s]+)",new RegExp(b,"g")}t.DEFAULT_WORD_REGEXP=f();function w(N){let b=t.DEFAULT_WORD_REGEXP;if(N&&N instanceof RegExp)if(N.global)b=N;else{let m="g";N.ignoreCase&&(m+="i"),N.multiline&&(m+="m"),N.unicode&&(m+="u"),b=new RegExp(N.source,m)}return b.lastIndex=0,b}t.ensureValidWordDefinition=w;const h=new r.LinkedList;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function u(N){const b=h.unshift(N);return(0,F.toDisposable)(b)}t.setDefaultGetWordAtTextConfig=u;function l(N,b,m,e,p){if(p||(p=P.Iterable.first(h)),m.length>p.maxLen){let o=N-p.maxLen/2;return o<0?o=0:e+=o,m=m.substring(o,N+p.maxLen/2),l(N,b,m,e,p)}const E=Date.now(),M=N-1-e;let _=-1,c=null;for(let o=1;!(Date.now()-E>=p.timeBudget);o++){const s=M-p.windowSize*o;b.lastIndex=Math.max(0,s);const i=g(b,m,M,_);if(!i&&c||(c=i,s<=0))break;_=s}if(c){const o={word:c[0],startColumn:e+1+c.index,endColumn:e+1+c.index+c[0].length};return b.lastIndex=0,o}return null}t.getWordAtText=l;function g(N,b,m,e){let p;for(;p=N.exec(b);){const E=p.index||0;if(E<=m&&N.lastIndex>=m)return p;if(e>0&&E>e)return null}return null}}),ne(ie[8],re([0,1,6,3,4]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.OffsetPair=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class f{static trivial(N,b){return new f([new w(r.OffsetRange.ofLength(N.length),r.OffsetRange.ofLength(b.length))],!1)}static trivialTimedOut(N,b){return new f([new w(r.OffsetRange.ofLength(N.length),r.OffsetRange.ofLength(b.length))],!0)}constructor(N,b){this.diffs=N,this.hitTimeout=b}}t.DiffAlgorithmResult=f;class w{static invert(N,b){const m=[];return(0,P.forEachAdjacent)(N,(e,p)=>{m.push(w.fromOffsetPairs(e?e.getEndExclusives():h.zero,p?p.getStarts():new h(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),m}static fromOffsetPairs(N,b){return new w(new r.OffsetRange(N.offset1,b.offset1),new r.OffsetRange(N.offset2,b.offset2))}constructor(N,b){this.seq1Range=N,this.seq2Range=b}swap(){return new w(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(N){return new w(this.seq1Range.join(N.seq1Range),this.seq2Range.join(N.seq2Range))}delta(N){return N===0?this:new w(this.seq1Range.delta(N),this.seq2Range.delta(N))}deltaStart(N){return N===0?this:new w(this.seq1Range.deltaStart(N),this.seq2Range.deltaStart(N))}deltaEnd(N){return N===0?this:new w(this.seq1Range.deltaEnd(N),this.seq2Range.deltaEnd(N))}intersectsOrTouches(N){return this.seq1Range.intersectsOrTouches(N.seq1Range)||this.seq2Range.intersectsOrTouches(N.seq2Range)}intersect(N){const b=this.seq1Range.intersect(N.seq1Range),m=this.seq2Range.intersect(N.seq2Range);if(!(!b||!m))return new w(b,m)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.SequenceDiff=w;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(N,b){this.offset1=N,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.OffsetPair=h;class u{static{this.instance=new u}isValid(){return!0}}t.InfiniteTimeout=u;class l{constructor(N){if(this.timeout=N,this.startTime=Date.now(),this.valid=!0,N<=0)throw new F.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=l}),ne(ie[30],re([0,1,4,8]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class r{compute(l,g,N=F.InfiniteTimeout.instance){if(l.length===0||g.length===0)return F.DiffAlgorithmResult.trivial(l,g);const b=l,m=g;function e(a,v){for(;a<b.length&&v<m.length&&b.getElement(a)===m.getElement(v);)a++,v++;return a}let p=0;const E=new w;E.set(0,e(0,0));const M=new h;M.set(0,E.get(0)===0?null:new f(null,0,0,E.get(0)));let _=0;e:for(;;){if(p++,!N.isValid())return F.DiffAlgorithmResult.trivialTimedOut(b,m);const a=-Math.min(p,m.length+p%2),v=Math.min(p,b.length+p%2);for(_=a;_<=v;_+=2){let d=0;const L=_===v?-1:E.get(_+1),A=_===a?-1:E.get(_-1)+1;d++;const R=Math.min(Math.max(L,A),b.length),D=R-_;if(d++,R>b.length||D>m.length)continue;const k=e(R,D);E.set(_,k);const y=R===L?M.get(_+1):M.get(_-1);if(M.set(_,k!==R?new f(y,R,D,k-R):y),E.get(_)===b.length&&E.get(_)-_===m.length)break e}}let c=M.get(_);const o=[];let s=b.length,i=m.length;for(;;){const a=c?c.x+c.length:0,v=c?c.y+c.length:0;if((a!==s||v!==i)&&o.push(new F.SequenceDiff(new P.OffsetRange(a,s),new P.OffsetRange(v,i))),!c)break;s=c.x,i=c.y,c=c.prev}return o.reverse(),new F.DiffAlgorithmResult(o,!1)}}t.MyersDiffAlgorithm=r;class f{constructor(l,g,N,b){this.prev=l,this.x=g,this.y=N,this.length=b}}class w{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,g){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const N=this.negativeArr;this.negativeArr=new Int32Array(N.length*2),this.negativeArr.set(N)}this.negativeArr[l]=g}else{if(l>=this.positiveArr.length){const N=this.positiveArr;this.positiveArr=new Int32Array(N.length*2),this.positiveArr.set(N)}this.positiveArr[l]=g}}}class h{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,g){l<0?(l=-l-1,this.negativeArr[l]=g):this.positiveArr[l]=g}}}),ne(ie[45],re([0,1,6,4,8]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeVeryShortMatchingTextBetweenLongDiffs=t.removeVeryShortMatchingLinesBetweenDiffs=t.extendDiffsToEntireWordIfAppropriate=t.removeShortMatches=t.optimizeSequenceDiffs=void 0;function f(e,p,E){let M=E;return M=w(e,p,M),M=w(e,p,M),M=h(e,p,M),M}t.optimizeSequenceDiffs=f;function w(e,p,E){if(E.length===0)return E;const M=[];M.push(E[0]);for(let c=1;c<E.length;c++){const o=M[M.length-1];let s=E[c];if(s.seq1Range.isEmpty||s.seq2Range.isEmpty){const i=s.seq1Range.start-o.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(e.getElement(s.seq1Range.start-a)!==e.getElement(s.seq1Range.endExclusive-a)||p.getElement(s.seq2Range.start-a)!==p.getElement(s.seq2Range.endExclusive-a));a++);if(a--,a===i){M[M.length-1]=new r.SequenceDiff(new F.OffsetRange(o.seq1Range.start,s.seq1Range.endExclusive-i),new F.OffsetRange(o.seq2Range.start,s.seq2Range.endExclusive-i));continue}s=s.delta(-a)}M.push(s)}const _=[];for(let c=0;c<M.length-1;c++){const o=M[c+1];let s=M[c];if(s.seq1Range.isEmpty||s.seq2Range.isEmpty){const i=o.seq1Range.start-s.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!e.isStronglyEqual(s.seq1Range.start+a,s.seq1Range.endExclusive+a)||!p.isStronglyEqual(s.seq2Range.start+a,s.seq2Range.endExclusive+a));a++);if(a===i){M[c+1]=new r.SequenceDiff(new F.OffsetRange(s.seq1Range.start+i,o.seq1Range.endExclusive),new F.OffsetRange(s.seq2Range.start+i,o.seq2Range.endExclusive));continue}a>0&&(s=s.delta(a))}_.push(s)}return M.length>0&&_.push(M[M.length-1]),_}function h(e,p,E){if(!e.getBoundaryScore||!p.getBoundaryScore)return E;for(let M=0;M<E.length;M++){const _=M>0?E[M-1]:void 0,c=E[M],o=M+1<E.length?E[M+1]:void 0,s=new F.OffsetRange(_?_.seq1Range.start+1:0,o?o.seq1Range.endExclusive-1:e.length),i=new F.OffsetRange(_?_.seq2Range.start+1:0,o?o.seq2Range.endExclusive-1:p.length);c.seq1Range.isEmpty?E[M]=u(c,e,p,s,i):c.seq2Range.isEmpty&&(E[M]=u(c.swap(),p,e,i,s).swap())}return E}function u(e,p,E,M,_){let o=1;for(;e.seq1Range.start-o>=M.start&&e.seq2Range.start-o>=_.start&&E.isStronglyEqual(e.seq2Range.start-o,e.seq2Range.endExclusive-o)&&o<100;)o++;o--;let s=0;for(;e.seq1Range.start+s<M.endExclusive&&e.seq2Range.endExclusive+s<_.endExclusive&&E.isStronglyEqual(e.seq2Range.start+s,e.seq2Range.endExclusive+s)&&s<100;)s++;if(o===0&&s===0)return e;let i=0,a=-1;for(let v=-o;v<=s;v++){const d=e.seq2Range.start+v,L=e.seq2Range.endExclusive+v,A=e.seq1Range.start+v,R=p.getBoundaryScore(A)+E.getBoundaryScore(d)+E.getBoundaryScore(L);R>a&&(a=R,i=v)}return e.delta(i)}function l(e,p,E){const M=[];for(const _ of E){const c=M[M.length-1];if(!c){M.push(_);continue}_.seq1Range.start-c.seq1Range.endExclusive<=2||_.seq2Range.start-c.seq2Range.endExclusive<=2?M[M.length-1]=new r.SequenceDiff(c.seq1Range.join(_.seq1Range),c.seq2Range.join(_.seq2Range)):M.push(_)}return M}t.removeShortMatches=l;function g(e,p,E){const M=[];let _;function c(){if(!_)return;const s=_.s1Range.length-_.deleted,i=_.s2Range.length-_.added;Math.max(_.deleted,_.added)+(_.count-1)>s&&M.push(new r.SequenceDiff(_.s1Range,_.s2Range)),_=void 0}for(const s of E){let i=function(A,R){if(!_||!_.s1Range.containsRange(A)||!_.s2Range.containsRange(R))if(_&&!(_.s1Range.endExclusive<A.start&&_.s2Range.endExclusive<R.start)){const y=F.OffsetRange.tryCreate(_.s1Range.endExclusive,A.start),S=F.OffsetRange.tryCreate(_.s2Range.endExclusive,R.start);_.deleted+=y?.length??0,_.added+=S?.length??0,_.s1Range=_.s1Range.join(A),_.s2Range=_.s2Range.join(R)}else c(),_={added:0,deleted:0,count:0,s1Range:A,s2Range:R};const D=A.intersect(s.seq1Range),k=R.intersect(s.seq2Range);_.count++,_.deleted+=D?.length??0,_.added+=k?.length??0};const a=e.findWordContaining(s.seq1Range.start-1),v=p.findWordContaining(s.seq2Range.start-1),d=e.findWordContaining(s.seq1Range.endExclusive),L=p.findWordContaining(s.seq2Range.endExclusive);a&&d&&v&&L&&a.equals(d)&&v.equals(L)?i(a,v):(a&&v&&i(a,v),d&&L&&i(d,L))}return c(),N(E,M)}t.extendDiffsToEntireWordIfAppropriate=g;function N(e,p){const E=[];for(;e.length>0||p.length>0;){const M=e[0],_=p[0];let c;M&&(!_||M.seq1Range.start<_.seq1Range.start)?c=e.shift():c=p.shift(),E.length>0&&E[E.length-1].seq1Range.endExclusive>=c.seq1Range.start?E[E.length-1]=E[E.length-1].join(c):E.push(c)}return E}function b(e,p,E){let M=E;if(M.length===0)return M;let _=0,c;do{c=!1;const o=[M[0]];for(let s=1;s<M.length;s++){let v=function(L,A){const R=new F.OffsetRange(a.seq1Range.endExclusive,i.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(L.seq1Range.length+L.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const i=M[s],a=o[o.length-1];v(a,i)?(c=!0,o[o.length-1]=o[o.length-1].join(i)):o.push(i)}M=o}while(_++<10&&c);return M}t.removeVeryShortMatchingLinesBetweenDiffs=b;function m(e,p,E){let M=E;if(M.length===0)return M;let _=0,c;do{c=!1;const s=[M[0]];for(let i=1;i<M.length;i++){let d=function(A,R){const D=new F.OffsetRange(v.seq1Range.endExclusive,a.seq1Range.start);if(e.countLinesIn(D)>5||D.length>500)return!1;const y=e.getText(D).trim();if(y.length>20||y.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(A.seq1Range),C=A.seq1Range.length,O=p.countLinesIn(A.seq2Range),H=A.seq2Range.length,T=e.countLinesIn(R.seq1Range),q=R.seq1Range.length,$=p.countLinesIn(R.seq2Range),V=R.seq2Range.length,Y=2*40+50;function n(te){return Math.min(te,Y)}return Math.pow(Math.pow(n(S*40+C),1.5)+Math.pow(n(O*40+H),1.5),1.5)+Math.pow(Math.pow(n(T*40+q),1.5)+Math.pow(n($*40+V),1.5),1.5)>(Y**1.5)**1.5*1.3};const a=M[i],v=s[s.length-1];d(v,a)?(c=!0,s[s.length-1]=s[s.length-1].join(a)):s.push(a)}M=s}while(_++<10&&c);const o=[];return(0,P.forEachWithNeighbors)(M,(s,i,a)=>{let v=i;function d(y){return y.length>0&&y.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const L=e.extendToFullLines(i.seq1Range),A=e.getText(new F.OffsetRange(L.start,i.seq1Range.start));d(A)&&(v=v.deltaStart(-A.length));const R=e.getText(new F.OffsetRange(i.seq1Range.endExclusive,L.endExclusive));d(R)&&(v=v.deltaEnd(R.length));const D=r.SequenceDiff.fromOffsetPairs(s?s.getEndExclusives():r.OffsetPair.zero,a?a.getStarts():r.OffsetPair.max),k=v.intersect(D);o.push(k)}),o}t.removeVeryShortMatchingTextBetweenLongDiffs=m}),ne(ie[46],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=void 0;class P{constructor(f,w){this.trimmedHash=f,this.lines=w}getElement(f){return this.trimmedHash[f]}get length(){return this.trimmedHash.length}getBoundaryScore(f){const w=f===0?0:F(this.lines[f-1]),h=f===this.lines.length?0:F(this.lines[f]);return 1e3-(w+h)}getText(f){return this.lines.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,w){return this.lines[f]===this.lines[w]}}t.LineSequence=P;function F(r){let f=0;for(;f<r.length&&(r.charCodeAt(f)===32||r.charCodeAt(f)===9);)f++;return f}}),ne(ie[15],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeFragment=t.isSpace=t.Array2D=void 0;class P{constructor(w,h){this.width=w,this.height=h,this.array=[],this.array=new Array(w*h)}get(w,h){return this.array[w+h*this.width]}set(w,h,u){this.array[w+h*this.width]=u}}t.Array2D=P;function F(f){return f===32||f===9}t.isSpace=F;class r{static{this.chrKeys=new Map}static getKey(w){let h=this.chrKeys.get(w);return h===void 0&&(h=this.chrKeys.size,this.chrKeys.set(w,h)),h}constructor(w,h,u){this.range=w,this.lines=h,this.source=u,this.histogram=[];let l=0;for(let g=w.startLineNumber-1;g<w.endLineNumberExclusive-1;g++){const N=h[g];for(let m=0;m<N.length;m++){l++;const e=N[m],p=r.getKey(e);this.histogram[p]=(this.histogram[p]||0)+1}l++;const b=r.getKey(`
`);this.histogram[b]=(this.histogram[b]||0)+1}this.totalCount=l}computeSimilarity(w){let h=0;const u=Math.max(this.histogram.length,w.histogram.length);for(let l=0;l<u;l++)h+=Math.abs((this.histogram[l]??0)-(w.histogram[l]??0));return 1-h/(this.totalCount+w.totalCount)}}t.LineRangeFragment=r}),ne(ie[47],re([0,1,4,8,15]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class f{compute(h,u,l=F.InfiniteTimeout.instance,g){if(h.length===0||u.length===0)return F.DiffAlgorithmResult.trivial(h,u);const N=new r.Array2D(h.length,u.length),b=new r.Array2D(h.length,u.length),m=new r.Array2D(h.length,u.length);for(let o=0;o<h.length;o++)for(let s=0;s<u.length;s++){if(!l.isValid())return F.DiffAlgorithmResult.trivialTimedOut(h,u);const i=o===0?0:N.get(o-1,s),a=s===0?0:N.get(o,s-1);let v;h.getElement(o)===u.getElement(s)?(o===0||s===0?v=0:v=N.get(o-1,s-1),o>0&&s>0&&b.get(o-1,s-1)===3&&(v+=m.get(o-1,s-1)),v+=g?g(o,s):1):v=-1;const d=Math.max(i,a,v);if(d===v){const L=o>0&&s>0?m.get(o-1,s-1):0;m.set(o,s,L+1),b.set(o,s,3)}else d===i?(m.set(o,s,0),b.set(o,s,1)):d===a&&(m.set(o,s,0),b.set(o,s,2));N.set(o,s,d)}const e=[];let p=h.length,E=u.length;function M(o,s){(o+1!==p||s+1!==E)&&e.push(new F.SequenceDiff(new P.OffsetRange(o+1,p),new P.OffsetRange(s+1,E))),p=o,E=s}let _=h.length-1,c=u.length-1;for(;_>=0&&c>=0;)b.get(_,c)===3?(M(_,c),_--,c--):b.get(_,c)===1?_--:c--;return M(-1,-1),e.reverse(),new F.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=f}),ne(ie[31],re([0,1,9,4,5,2,15]),function(B,t,P,F,r,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinesSliceCharSequence=void 0;class h{constructor(e,p,E){this.lines=e,this.considerWhitespaceChanges=E,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let M=!1;p.start>0&&p.endExclusive>=e.length&&(p=new F.OffsetRange(p.start-1,p.endExclusive),M=!0),this.lineRange=p,this.firstCharOffsetByLine[0]=0;for(let _=this.lineRange.start;_<this.lineRange.endExclusive;_++){let c=e[_],o=0;if(M)o=c.length,c="",M=!1;else if(!E){const s=c.trimStart();o=c.length-s.length,c=s.trimEnd()}this.additionalOffsetByLine.push(o);for(let s=0;s<c.length;s++)this.elements.push(c.charCodeAt(s));_<e.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLine[_-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.OffsetRange(0,this.length))}getText(e){return this.elements.slice(e.start,e.endExclusive).map(p=>String.fromCharCode(p)).join("")}getElement(e){return this.elements[e]}get length(){return this.elements.length}getBoundaryScore(e){const p=b(e>0?this.elements[e-1]:-1),E=b(e<this.elements.length?this.elements[e]:-1);if(p===7&&E===8)return 0;let M=0;return p!==E&&(M+=10,p===0&&E===1&&(M+=1)),M+=N(p),M+=N(E),M}translateOffset(e){if(this.lineRange.isEmpty)return new r.Position(this.lineRange.start+1,1);const p=(0,P.findLastIdxMonotonous)(this.firstCharOffsetByLine,E=>E<=e);return new r.Position(this.lineRange.start+p+1,e-this.firstCharOffsetByLine[p]+this.additionalOffsetByLine[p]+1)}translateRange(e){return f.Range.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.elements.length||!u(this.elements[e]))return;let p=e;for(;p>0&&u(this.elements[p-1]);)p--;let E=e;for(;E<this.elements.length&&u(this.elements[E]);)E++;return new F.OffsetRange(p,E)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,p){return this.elements[e]===this.elements[p]}extendToFullLines(e){const p=(0,P.findLastMonotonous)(this.firstCharOffsetByLine,M=>M<=e.start)??0,E=(0,P.findFirstMonotonous)(this.firstCharOffsetByLine,M=>e.endExclusive<=M)??this.elements.length;return new F.OffsetRange(p,E)}}t.LinesSliceCharSequence=h;function u(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var l;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(l||(l={}));const g={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:3,[7]:10,[8]:10};function N(m){return g[m]}function b(m){return m===10?8:m===13?7:(0,w.isSpace)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),ne(ie[32],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.LinesDiff=void 0;class P{constructor(f,w,h){this.changes=f,this.moves=w,this.hitTimeout=h}}t.LinesDiff=P;class F{constructor(f,w){this.lineRangeMapping=f,this.changes=w}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.MovedText=F}),ne(ie[16],re([0,1,12]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.DetailedLineRangeMapping=t.LineRangeMapping=void 0;class F{static inverse(h,u,l){const g=[];let N=1,b=1;for(const e of h){const p=new r(new P.LineRange(N,e.original.startLineNumber),new P.LineRange(b,e.modified.startLineNumber),void 0);p.modified.isEmpty||g.push(p),N=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const m=new r(new P.LineRange(N,u+1),new P.LineRange(b,l+1),void 0);return m.modified.isEmpty||g.push(m),g}constructor(h,u){this.original=h,this.modified=u}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(h){return new F(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.LineRangeMapping=F;class r extends F{constructor(h,u,l){super(h,u),this.innerChanges=l}flip(){return new r(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.DetailedLineRangeMapping=r;class f{constructor(h,u){this.originalRange=h,this.modifiedRange=u}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.RangeMapping=f}),ne(ie[48],re([0,1,8,16,6,9,22,12,4,31,15,30]),function(B,t,P,F,r,f,w,h,u,l,g,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeMovedLines=void 0;function b(c,o,s,i,a,v){let{moves:d,excludedChanges:L}=e(c,o,s,v);if(!v.isValid())return[];const A=c.filter(D=>!L.has(D)),R=p(A,i,a,o,s,v);return(0,r.pushMany)(d,R),d=M(d),d=d.filter(D=>{const k=D.original.toOffsetRange().slice(o).map(S=>S.trim());return k.join(`
`).length>=15&&m(k,S=>S.length>=2)>=2}),d=_(c,d),d}t.computeMovedLines=b;function m(c,o){let s=0;for(const i of c)o(i)&&s++;return s}function e(c,o,s,i){const a=[],v=c.filter(A=>A.modified.isEmpty&&A.original.length>=3).map(A=>new g.LineRangeFragment(A.original,o,A)),d=new Set(c.filter(A=>A.original.isEmpty&&A.modified.length>=3).map(A=>new g.LineRangeFragment(A.modified,s,A))),L=new Set;for(const A of v){let R=-1,D;for(const k of d){const y=A.computeSimilarity(k);y>R&&(R=y,D=k)}if(R>.9&&D&&(d.delete(D),a.push(new F.LineRangeMapping(A.range,D.range)),L.add(A.source),L.add(D.source)),!i.isValid())return{moves:a,excludedChanges:L}}return{moves:a,excludedChanges:L}}function p(c,o,s,i,a,v){const d=[],L=new w.SetMap;for(const y of c)for(let S=y.original.startLineNumber;S<y.original.endLineNumberExclusive-2;S++){const C=`${o[S-1]}:${o[S+1-1]}:${o[S+2-1]}`;L.add(C,{range:new h.LineRange(S,S+3)})}const A=[];c.sort((0,r.compareBy)(y=>y.modified.startLineNumber,r.numberComparator));for(const y of c){let S=[];for(let C=y.modified.startLineNumber;C<y.modified.endLineNumberExclusive-2;C++){const O=`${s[C-1]}:${s[C+1-1]}:${s[C+2-1]}`,H=new h.LineRange(C,C+3),T=[];L.forEach(O,({range:q})=>{for(const V of S)if(V.originalLineRange.endLineNumberExclusive+1===q.endLineNumberExclusive&&V.modifiedLineRange.endLineNumberExclusive+1===H.endLineNumberExclusive){V.originalLineRange=new h.LineRange(V.originalLineRange.startLineNumber,q.endLineNumberExclusive),V.modifiedLineRange=new h.LineRange(V.modifiedLineRange.startLineNumber,H.endLineNumberExclusive),T.push(V);return}const $={modifiedLineRange:H,originalLineRange:q};A.push($),T.push($)}),S=T}if(!v.isValid())return[]}A.sort((0,r.reverseOrder)((0,r.compareBy)(y=>y.modifiedLineRange.length,r.numberComparator)));const R=new h.LineRangeSet,D=new h.LineRangeSet;for(const y of A){const S=y.modifiedLineRange.startLineNumber-y.originalLineRange.startLineNumber,C=R.subtractFrom(y.modifiedLineRange),O=D.subtractFrom(y.originalLineRange).getWithDelta(S),H=C.getIntersection(O);for(const T of H.ranges){if(T.length<3)continue;const q=T,$=T.delta(-S);d.push(new F.LineRangeMapping($,q)),R.addRange(q),D.addRange($)}}d.sort((0,r.compareBy)(y=>y.original.startLineNumber,r.numberComparator));const k=new f.MonotonousArray(c);for(let y=0;y<d.length;y++){const S=d[y],C=k.findLastMonotonous(n=>n.original.startLineNumber<=S.original.startLineNumber),O=(0,f.findLastMonotonous)(c,n=>n.modified.startLineNumber<=S.modified.startLineNumber),H=Math.max(S.original.startLineNumber-C.original.startLineNumber,S.modified.startLineNumber-O.modified.startLineNumber),T=k.findLastMonotonous(n=>n.original.startLineNumber<S.original.endLineNumberExclusive),q=(0,f.findLastMonotonous)(c,n=>n.modified.startLineNumber<S.modified.endLineNumberExclusive),$=Math.max(T.original.endLineNumberExclusive-S.original.endLineNumberExclusive,q.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let V;for(V=0;V<H;V++){const n=S.original.startLineNumber-V-1,te=S.modified.startLineNumber-V-1;if(n>i.length||te>a.length||R.contains(te)||D.contains(n)||!E(i[n-1],a[te-1],v))break}V>0&&(D.addRange(new h.LineRange(S.original.startLineNumber-V,S.original.startLineNumber)),R.addRange(new h.LineRange(S.modified.startLineNumber-V,S.modified.startLineNumber)));let Y;for(Y=0;Y<$;Y++){const n=S.original.endLineNumberExclusive+Y,te=S.modified.endLineNumberExclusive+Y;if(n>i.length||te>a.length||R.contains(te)||D.contains(n)||!E(i[n-1],a[te-1],v))break}Y>0&&(D.addRange(new h.LineRange(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+Y)),R.addRange(new h.LineRange(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+Y))),(V>0||Y>0)&&(d[y]=new F.LineRangeMapping(new h.LineRange(S.original.startLineNumber-V,S.original.endLineNumberExclusive+Y),new h.LineRange(S.modified.startLineNumber-V,S.modified.endLineNumberExclusive+Y)))}return d}function E(c,o,s){if(c.trim()===o.trim())return!0;if(c.length>300&&o.length>300)return!1;const a=new N.MyersDiffAlgorithm().compute(new l.LinesSliceCharSequence([c],new u.OffsetRange(0,1),!1),new l.LinesSliceCharSequence([o],new u.OffsetRange(0,1),!1),s);let v=0;const d=P.SequenceDiff.invert(a.diffs,c.length);for(const D of d)D.seq1Range.forEach(k=>{(0,g.isSpace)(c.charCodeAt(k))||v++});function L(D){let k=0;for(let y=0;y<c.length;y++)(0,g.isSpace)(D.charCodeAt(y))||k++;return k}const A=L(c.length>o.length?c:o);return v/A>.6&&A>10}function M(c){if(c.length===0)return c;c.sort((0,r.compareBy)(s=>s.original.startLineNumber,r.numberComparator));const o=[c[0]];for(let s=1;s<c.length;s++){const i=o[o.length-1],a=c[s],v=a.original.startLineNumber-i.original.endLineNumberExclusive,d=a.modified.startLineNumber-i.modified.endLineNumberExclusive;if(v>=0&&d>=0&&v+d<=2){o[o.length-1]=i.join(a);continue}o.push(a)}return o}function _(c,o){const s=new f.MonotonousArray(c);return o=o.filter(i=>{const a=s.findLastMonotonous(L=>L.original.startLineNumber<i.original.endLineNumberExclusive)||new F.LineRangeMapping(new h.LineRange(1,1),new h.LineRange(1,1)),v=(0,f.findLastMonotonous)(c,L=>L.modified.startLineNumber<i.modified.endLineNumberExclusive);return a!==v}),o}}),ne(ie[49],re([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(B,t,P,F,r,f,w,h,u,l,g,N,b,m,e,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.DefaultLinesDiffComputer=void 0;class E{constructor(){this.dynamicProgrammingDiffing=new u.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new l.MyersDiffAlgorithm}computeDiff(o,s,i){if(o.length<=1&&(0,P.equals)(o,s,(Y,n)=>Y===n))return new b.LinesDiff([],[],!1);if(o.length===1&&o[0].length===0||s.length===1&&s[0].length===0)return new b.LinesDiff([new m.DetailedLineRangeMapping(new r.LineRange(1,o.length+1),new r.LineRange(1,s.length+1),[new m.RangeMapping(new w.Range(1,1,o.length,o[0].length+1),new w.Range(1,1,s.length,s[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?h.InfiniteTimeout.instance:new h.DateTimeout(i.maxComputationTimeMs),v=!i.ignoreTrimWhitespace,d=new Map;function L(Y){let n=d.get(Y);return n===void 0&&(n=d.size,d.set(Y,n)),n}const A=o.map(Y=>L(Y.trim())),R=s.map(Y=>L(Y.trim())),D=new p.LineSequence(A,o),k=new p.LineSequence(R,s),y=(()=>D.length+k.length<1700?this.dynamicProgrammingDiffing.compute(D,k,a,(Y,n)=>o[Y]===s[n]?s[n].length===0?.1:1+Math.log(1+s[n].length):.99):this.myersDiffingAlgorithm.compute(D,k))();let S=y.diffs,C=y.hitTimeout;S=(0,N.optimizeSequenceDiffs)(D,k,S),S=(0,N.removeVeryShortMatchingLinesBetweenDiffs)(D,k,S);const O=[],H=Y=>{if(v)for(let n=0;n<Y;n++){const te=T+n,oe=q+n;if(o[te]!==s[oe]){const ge=this.refineDiff(o,s,new h.SequenceDiff(new f.OffsetRange(te,te+1),new f.OffsetRange(oe,oe+1)),a,v);for(const pe of ge.mappings)O.push(pe);ge.hitTimeout&&(C=!0)}}};let T=0,q=0;for(const Y of S){(0,F.assertFn)(()=>Y.seq1Range.start-T===Y.seq2Range.start-q);const n=Y.seq1Range.start-T;H(n),T=Y.seq1Range.endExclusive,q=Y.seq2Range.endExclusive;const te=this.refineDiff(o,s,Y,a,v);te.hitTimeout&&(C=!0);for(const oe of te.mappings)O.push(oe)}H(o.length-T);const $=M(O,o,s);let V=[];return i.computeMoves&&(V=this.computeMoves($,o,s,A,R,a,v)),(0,F.assertFn)(()=>{function Y(te,oe){if(te.lineNumber<1||te.lineNumber>oe.length)return!1;const ge=oe[te.lineNumber-1];return!(te.column<1||te.column>ge.length+1)}function n(te,oe){return!(te.startLineNumber<1||te.startLineNumber>oe.length+1||te.endLineNumberExclusive<1||te.endLineNumberExclusive>oe.length+1)}for(const te of $){if(!te.innerChanges)return!1;for(const oe of te.innerChanges)if(!(Y(oe.modifiedRange.getStartPosition(),s)&&Y(oe.modifiedRange.getEndPosition(),s)&&Y(oe.originalRange.getStartPosition(),o)&&Y(oe.originalRange.getEndPosition(),o)))return!1;if(!n(te.modified,s)||!n(te.original,o))return!1}return!0}),new b.LinesDiff($,V,C)}computeMoves(o,s,i,a,v,d,L){return(0,g.computeMovedLines)(o,s,i,a,v,d).map(D=>{const k=this.refineDiff(s,i,new h.SequenceDiff(D.original.toOffsetRange(),D.modified.toOffsetRange()),d,L),y=M(k.mappings,s,i,!0);return new b.MovedText(D,y)})}refineDiff(o,s,i,a,v){const d=new e.LinesSliceCharSequence(o,i.seq1Range,v),L=new e.LinesSliceCharSequence(s,i.seq2Range,v),A=d.length+L.length<500?this.dynamicProgrammingDiffing.compute(d,L,a):this.myersDiffingAlgorithm.compute(d,L,a);let R=A.diffs;return R=(0,N.optimizeSequenceDiffs)(d,L,R),R=(0,N.extendDiffsToEntireWordIfAppropriate)(d,L,R),R=(0,N.removeShortMatches)(d,L,R),R=(0,N.removeVeryShortMatchingTextBetweenLongDiffs)(d,L,R),{mappings:R.map(k=>new m.RangeMapping(d.translateRange(k.seq1Range),L.translateRange(k.seq2Range))),hitTimeout:A.hitTimeout}}}t.DefaultLinesDiffComputer=E;function M(c,o,s,i=!1){const a=[];for(const v of(0,P.groupAdjacentBy)(c.map(d=>_(d,o,s)),(d,L)=>d.original.overlapOrTouch(L.original)||d.modified.overlapOrTouch(L.modified))){const d=v[0],L=v[v.length-1];a.push(new m.DetailedLineRangeMapping(d.original.join(L.original),d.modified.join(L.modified),v.map(A=>A.innerChanges[0])))}return(0,F.assertFn)(()=>!i&&a.length>0&&a[0].original.startLineNumber!==a[0].modified.startLineNumber?!1:(0,F.checkAdjacentItems)(a,(v,d)=>d.original.startLineNumber-v.original.endLineNumberExclusive===d.modified.startLineNumber-v.modified.endLineNumberExclusive&&v.original.endLineNumberExclusive<d.original.startLineNumber&&v.modified.endLineNumberExclusive<d.modified.startLineNumber)),a}t.lineRangeMappingFromRangeMappings=M;function _(c,o,s){let i=0,a=0;c.modifiedRange.endColumn===1&&c.originalRange.endColumn===1&&c.originalRange.startLineNumber+i<=c.originalRange.endLineNumber&&c.modifiedRange.startLineNumber+i<=c.modifiedRange.endLineNumber&&(a=-1),c.modifiedRange.startColumn-1>=s[c.modifiedRange.startLineNumber-1].length&&c.originalRange.startColumn-1>=o[c.originalRange.startLineNumber-1].length&&c.originalRange.startLineNumber<=c.originalRange.endLineNumber+a&&c.modifiedRange.startLineNumber<=c.modifiedRange.endLineNumber+a&&(i=1);const v=new r.LineRange(c.originalRange.startLineNumber+i,c.originalRange.endLineNumber+1+a),d=new r.LineRange(c.modifiedRange.startLineNumber+i,c.modifiedRange.endLineNumber+1+a);return new m.DetailedLineRangeMapping(v,d,[c])}t.getLineRangeMapping=_}),ne(ie[33],re([0,1,25,32,16,7,2,13,12]),function(B,t,P,F,r,f,w,h,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.LegacyLinesDiffComputer=void 0;const l=3;class g{computeDiff(i,a,v){const L=new M(i,a,{maxComputationTime:v.maxComputationTimeMs,shouldIgnoreTrimWhitespace:v.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let R=null;for(const D of L.changes){let k;D.originalEndLineNumber===0?k=new u.LineRange(D.originalStartLineNumber+1,D.originalStartLineNumber+1):k=new u.LineRange(D.originalStartLineNumber,D.originalEndLineNumber+1);let y;D.modifiedEndLineNumber===0?y=new u.LineRange(D.modifiedStartLineNumber+1,D.modifiedStartLineNumber+1):y=new u.LineRange(D.modifiedStartLineNumber,D.modifiedEndLineNumber+1);let S=new r.DetailedLineRangeMapping(k,y,D.charChanges?.map(C=>new r.RangeMapping(new w.Range(C.originalStartLineNumber,C.originalStartColumn,C.originalEndLineNumber,C.originalEndColumn),new w.Range(C.modifiedStartLineNumber,C.modifiedStartColumn,C.modifiedEndLineNumber,C.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===S.modified.startLineNumber||R.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new r.DetailedLineRangeMapping(R.original.join(S.original),R.modified.join(S.modified),R.innerChanges&&S.innerChanges?R.innerChanges.concat(S.innerChanges):void 0),A.pop()),A.push(S),R=S}return(0,h.assertFn)(()=>(0,h.checkAdjacentItems)(A,(D,k)=>k.original.startLineNumber-D.original.endLineNumberExclusive===k.modified.startLineNumber-D.modified.endLineNumberExclusive&&D.original.endLineNumberExclusive<k.original.startLineNumber&&D.modified.endLineNumberExclusive<k.modified.startLineNumber)),new F.LinesDiff(A,[],L.quitEarly)}}t.LegacyLinesDiffComputer=g;function N(s,i,a,v){return new P.LcsDiff(s,i,a).ComputeDiff(v)}class b{constructor(i){const a=[],v=[];for(let d=0,L=i.length;d<L;d++)a[d]=_(i[d],1),v[d]=c(i[d],1);this.lines=i,this._startColumns=a,this._endColumns=v}getElements(){const i=[];for(let a=0,v=this.lines.length;a<v;a++)i[a]=this.lines[a].substring(this._startColumns[a]-1,this._endColumns[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,v){const d=[],L=[],A=[];let R=0;for(let D=a;D<=v;D++){const k=this.lines[D],y=i?this._startColumns[D]:1,S=i?this._endColumns[D]:k.length+1;for(let C=y;C<S;C++)d[R]=k.charCodeAt(C-1),L[R]=D+1,A[R]=C,R++;!i&&D<v&&(d[R]=10,L[R]=D+1,A[R]=k.length+1,R++)}return new m(d,L,A)}}class m{constructor(i,a,v){this._charCodes=i,this._lineNumbers=a,this._columns=v}toString(){return"["+this._charCodes.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[a]},${this._columns[a]})`).join(", ")+"]"}_assertIndex(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class e{constructor(i,a,v,d,L,A,R,D){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=v,this.originalEndColumn=d,this.modifiedStartLineNumber=L,this.modifiedStartColumn=A,this.modifiedEndLineNumber=R,this.modifiedEndColumn=D}static createFromDiffChange(i,a,v){const d=a.getStartLineNumber(i.originalStart),L=a.getStartColumn(i.originalStart),A=a.getEndLineNumber(i.originalStart+i.originalLength-1),R=a.getEndColumn(i.originalStart+i.originalLength-1),D=v.getStartLineNumber(i.modifiedStart),k=v.getStartColumn(i.modifiedStart),y=v.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),S=v.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,L,A,R,D,k,y,S)}}function p(s){if(s.length<=1)return s;const i=[s[0]];let a=i[0];for(let v=1,d=s.length;v<d;v++){const L=s[v],A=L.originalStart-(a.originalStart+a.originalLength),R=L.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(A,R)<l?(a.originalLength=L.originalStart+L.originalLength-a.originalStart,a.modifiedLength=L.modifiedStart+L.modifiedLength-a.modifiedStart):(i.push(L),a=L)}return i}class E{constructor(i,a,v,d,L){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=v,this.modifiedEndLineNumber=d,this.charChanges=L}static createFromDiffResult(i,a,v,d,L,A,R){let D,k,y,S,C;if(a.originalLength===0?(D=v.getStartLineNumber(a.originalStart)-1,k=0):(D=v.getStartLineNumber(a.originalStart),k=v.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(y=d.getStartLineNumber(a.modifiedStart)-1,S=0):(y=d.getStartLineNumber(a.modifiedStart),S=d.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),A&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&L()){const O=v.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),H=d.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(O.getElements().length>0&&H.getElements().length>0){let T=N(O,H,L,!0).changes;R&&(T=p(T)),C=[];for(let q=0,$=T.length;q<$;q++)C.push(e.createFromDiffChange(T[q],O,H))}}return new E(D,k,y,S,C)}}class M{constructor(i,a,v){this.shouldComputeCharChanges=v.shouldComputeCharChanges,this.shouldPostProcessCharChanges=v.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=v.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=v.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=a,this.original=new b(i),this.modified=new b(a),this.continueLineDiff=o(v.maxComputationTime),this.continueCharDiff=o(v.maxComputationTime===0?0:Math.min(v.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=N(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),a=i.changes,v=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const R=[];for(let D=0,k=a.length;D<k;D++)R.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a[D],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:v,changes:R}}const d=[];let L=0,A=0;for(let R=-1,D=a.length;R<D;R++){const k=R+1<D?a[R+1]:null,y=k?k.originalStart:this.originalLines.length,S=k?k.modifiedStart:this.modifiedLines.length;for(;L<y&&A<S;){const C=this.originalLines[L],O=this.modifiedLines[A];if(C!==O){{let H=_(C,1),T=_(O,1);for(;H>1&&T>1;){const q=C.charCodeAt(H-2),$=O.charCodeAt(T-2);if(q!==$)break;H--,T--}(H>1||T>1)&&this._pushTrimWhitespaceCharChange(d,L+1,1,H,A+1,1,T)}{let H=c(C,1),T=c(O,1);const q=C.length+1,$=O.length+1;for(;H<q&&T<$;){const V=C.charCodeAt(H-1),Y=C.charCodeAt(T-1);if(V!==Y)break;H++,T++}(H<q||T<$)&&this._pushTrimWhitespaceCharChange(d,L+1,H,q,A+1,T,$)}}L++,A++}k&&(d.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,k,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),L+=k.originalLength,A+=k.modifiedLength)}return{quitEarly:v,changes:d}}_pushTrimWhitespaceCharChange(i,a,v,d,L,A,R){if(this._mergeTrimWhitespaceCharChange(i,a,v,d,L,A,R))return;let D;this.shouldComputeCharChanges&&(D=[new e(a,v,a,d,L,A,L,R)]),i.push(new E(a,a,L,L,D))}_mergeTrimWhitespaceCharChange(i,a,v,d,L,A,R){const D=i.length;if(D===0)return!1;const k=i[D-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===a&&k.modifiedEndLineNumber===L?(this.shouldComputeCharChanges&&k.charChanges&&k.charChanges.push(new e(a,v,a,d,L,A,L,R)),!0):k.originalEndLineNumber+1===a&&k.modifiedEndLineNumber+1===L?(k.originalEndLineNumber=a,k.modifiedEndLineNumber=L,this.shouldComputeCharChanges&&k.charChanges&&k.charChanges.push(new e(a,v,a,d,L,A,L,R)),!0):!1}}t.DiffComputer=M;function _(s,i){const a=f.firstNonWhitespaceIndex(s);return a===-1?i:a+1}function c(s,i){const a=f.lastNonWhitespaceIndex(s);return a===-1?i:a+2}function o(s){if(s===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<s}}),ne(ie[50],re([0,1,33,49]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new P.LegacyLinesDiffComputer,getDefault:()=>new F.DefaultLinesDiffComputer}}),ne(ie[51],re([0,1,35]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function F(b){const m=[];for(const e of b){const p=Number(e);(p||p===0&&e.replace(/\s/g,"")!=="")&&m.push(p)}return m}function r(b,m,e,p){return{red:b/255,blue:e/255,green:m/255,alpha:p}}function f(b,m){const e=m.index,p=m[0].length;if(!e)return;const E=b.positionAt(e);return{startLineNumber:E.lineNumber,startColumn:E.column,endLineNumber:E.lineNumber,endColumn:E.column+p}}function w(b,m){if(!b)return;const e=P.Color.Format.CSS.parseHex(m);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(b,m,e){if(!b||m.length!==1)return;const E=m[0].values(),M=F(E);return{range:b,color:r(M[0],M[1],M[2],e?M[3]:1)}}function u(b,m,e){if(!b||m.length!==1)return;const E=m[0].values(),M=F(E),_=new P.Color(new P.HSLA(M[0],M[1]/100,M[2]/100,e?M[3]:1));return{range:b,color:r(_.rgba.r,_.rgba.g,_.rgba.b,_.rgba.a)}}function l(b,m){return typeof b=="string"?[...b.matchAll(m)]:b.findMatches(m)}function g(b){const m=[],p=l(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(p.length>0)for(const E of p){const M=E.filter(s=>s!==void 0),_=M[1],c=M[2];if(!c)continue;let o;if(_==="rgb"){const s=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;o=h(f(b,E),l(c,s),!1)}else if(_==="rgba"){const s=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=h(f(b,E),l(c,s),!0)}else if(_==="hsl"){const s=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;o=u(f(b,E),l(c,s),!1)}else if(_==="hsla"){const s=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=u(f(b,E),l(c,s),!0)}else _==="#"&&(o=w(f(b,E),_+c));o&&m.push(o)}return m}function N(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:g(b)}t.computeDefaultDocumentColors=N}),ne(ie[52],re([0,1,28]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var F;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class r{constructor(e,p,E){const M=new Uint8Array(e*p);for(let _=0,c=e*p;_<c;_++)M[_]=E;this._data=M,this.rows=e,this.cols=p}get(e,p){return this._data[e*this.cols+p]}set(e,p,E){this._data[e*this.cols+p]=E}}class f{constructor(e){let p=0,E=0;for(let _=0,c=e.length;_<c;_++){const[o,s,i]=e[_];s>p&&(p=s),o>E&&(E=o),i>E&&(E=i)}p++,E++;const M=new r(E,p,0);for(let _=0,c=e.length;_<c;_++){const[o,s,i]=e[_];M.set(o,s,i)}this._states=M,this._maxCharCode=p}nextState(e,p){return p<0||p>=this._maxCharCode?0:this._states.get(e,p)}}t.StateMachine=f;let w=null;function h(){return w===null&&(w=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),w}var u;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let l=null;function g(){if(l===null){l=new P.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<m.length;p++)l.set(m.charCodeAt(p),1);const e=".,;:";for(let p=0;p<e.length;p++)l.set(e.charCodeAt(p),2)}return l}class N{static _createLink(e,p,E,M,_){let c=_-1;do{const o=p.charCodeAt(c);if(e.get(o)!==2)break;c--}while(c>M);if(M>0){const o=p.charCodeAt(M-1),s=p.charCodeAt(c);(o===40&&s===41||o===91&&s===93||o===123&&s===125)&&c--}return{range:{startLineNumber:E,startColumn:M+1,endLineNumber:E,endColumn:c+2},url:p.substring(M,c+1)}}static computeLinks(e,p=h()){const E=g(),M=[];for(let _=1,c=e.getLineCount();_<=c;_++){const o=e.getLineContent(_),s=o.length;let i=0,a=0,v=0,d=1,L=!1,A=!1,R=!1,D=!1;for(;i<s;){let k=!1;const y=o.charCodeAt(i);if(d===13){let S;switch(y){case 40:L=!0,S=0;break;case 41:S=L?0:1;break;case 91:R=!0,A=!0,S=0;break;case 93:R=!1,S=A?0:1;break;case 123:D=!0,S=0;break;case 125:S=D?0:1;break;case 39:case 34:case 96:v===y?S=1:v===39||v===34||v===96?S=0:S=1;break;case 42:S=v===42?1:0;break;case 124:S=v===124?1:0;break;case 32:S=R?0:1;break;default:S=E.get(y)}S===1&&(M.push(N._createLink(E,o,_,a,i)),k=!0)}else if(d===12){let S;y===91?(A=!0,S=0):S=E.get(y),S===1?k=!0:d=13}else d=p.nextState(d,y),d===0&&(k=!0);k&&(d=1,L=!1,A=!1,D=!1,a=i+1,v=y),i++}d===13&&M.push(N._createLink(E,o,_,a,s))}return M}}t.LinkComputer=N;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:N.computeLinks(m)}t.computeLinks=b}),ne(ie[53],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new P}navigateValueSet(r,f,w,h,u){if(r&&f){const l=this.doNavigateValueSet(f,u);if(l)return{range:r,value:l}}if(w&&h){const l=this.doNavigateValueSet(h,u);if(l)return{range:w,value:l}}return null}doNavigateValueSet(r,f){const w=this.numberReplace(r,f);return w!==null?w:this.textReplace(r,f)}numberReplace(r,f){const w=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let h=Number(r);const u=parseFloat(r);return!isNaN(h)&&!isNaN(u)&&h===u?h===0&&!f?null:(h=Math.floor(h*w),h+=f?w:-w,String(h/w)):null}textReplace(r,f){return this.valueSetsReplace(this._defaultValueSet,r,f)}valueSetsReplace(r,f,w){let h=null;for(let u=0,l=r.length;h===null&&u<l;u++)h=this.valueSetReplace(r[u],f,w);return h}valueSetReplace(r,f,w){let h=r.indexOf(f);return h>=0?(h+=w?1:-1,h<0?h=r.length-1:h%=r.length,r[h]):null}}t.BasicInplaceReplace=P}),ne(ie[54],re([0,1,14]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var F;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var r;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var f;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var w;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(w||(t.InjectedTextCursorStops=w={}));var h;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var u;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var l;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));class g{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),s.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,s.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!s.insertSpaces,this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=!!s.trimAutoWhitespace,this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this._indentSizeIsTabSize===s._indentSizeIsTabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,P.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}t.TextModelResolvedOptions=g;class N{constructor(s,i){this._findMatchBrand=void 0,this.range=s,this.matches=i}}t.FindMatch=N;var b;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function m(o){return o&&typeof o.read=="function"}t.isITextSnapshot=m;var e;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var p;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(t.ModelConstants=p={}));class E{constructor(s,i,a,v,d,L){this.identifier=s,this.range=i,this.text=a,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=d,this._isTracked=L}}t.ValidAnnotatedEditOperation=E;class M{constructor(s,i,a){this.regex=s,this.wordSeparators=i,this.simpleSearch=a}}t.SearchData=M;class _{constructor(s,i,a){this.reverseEdits=s,this.changes=i,this.trimAutoWhitespaceLineNumbers=a}}t.ApplyEditsResult=_;function c(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}t.shouldSynchronizeModel=c}),ne(ie[55],re([0,1,6,27]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class r{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(u,l){u=(0,F.toUint32)(u);const g=this.values,N=this.prefixSum,b=l.length;return b===0?!1:(this.values=new Uint32Array(g.length+b),this.values.set(g.subarray(0,u),0),this.values.set(g.subarray(u),u+b),this.values.set(l,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(N.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,l){return u=(0,F.toUint32)(u),l=(0,F.toUint32)(l),this.values[u]===l?!1:(this.values[u]=l,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,l){u=(0,F.toUint32)(u),l=(0,F.toUint32)(l);const g=this.values,N=this.prefixSum;if(u>=g.length)return!1;const b=g.length-u;return l>=b&&(l=b),l===0?!1:(this.values=new Uint32Array(g.length-l),this.values.set(g.subarray(0,u),0),this.values.set(g.subarray(u+l),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(N.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,F.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),u>=this.values.length&&(u=this.values.length-1);for(let g=l;g<=u;g++)this.prefixSum[g]=this.prefixSum[g-1]+this.values[g];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let l=0,g=this.values.length-1,N=0,b=0,m=0;for(;l<=g;)if(N=l+(g-l)/2|0,b=this.prefixSum[N],m=b-this.values[N],u<m)g=N-1;else if(u>=b)l=N+1;else break;return new w(N,u-m)}}t.PrefixSumComputer=r;class f{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const l=this._indexBySum[u],g=l>0?this._prefixSum[l-1]:0;return new w(l,u-g)}removeValues(u,l){this._values.splice(u,l),this._invalidate(u)}insertValues(u,l){this._values=(0,P.arrayInsert)(this._values,u,l),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,l=this._values.length;u<l;u++){const g=this._values[u],N=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=N+g;for(let b=0;b<g;b++)this._indexBySum[N+b]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,l){this._values[u]!==l&&(this._values[u]=l,this._invalidate(u))}}t.ConstantTimePrefixSumComputer=f;class w{constructor(u,l){this.index=u,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=l}}t.PrefixSumIndexOfResult=w}),ne(ie[56],re([0,1,7,5,55]),function(B,t,P,F,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class f{constructor(h,u,l,g){this._uri=h,this._lines=u,this._eol=l,this._versionId=g,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(h){h.eol&&h.eol!==this._eol&&(this._eol=h.eol,this._lineStarts=null);const u=h.changes;for(const l of u)this._acceptDeleteRange(l.range),this._acceptInsertText(new F.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=h.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const h=this._eol.length,u=this._lines.length,l=new Uint32Array(u);for(let g=0;g<u;g++)l[g]=this._lines[g].length+h;this._lineStarts=new r.PrefixSumComputer(l)}}_setLineText(h,u){this._lines[h]=u,this._lineStarts&&this._lineStarts.setValue(h,this._lines[h].length+this._eol.length)}_acceptDeleteRange(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.startLineNumber-1].substring(h.endColumn-1));return}this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.endLineNumber-1].substring(h.endColumn-1)),this._lines.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}_acceptInsertText(h,u){if(u.length===0)return;const l=(0,P.splitLines)(u);if(l.length===1){this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+l[0]+this._lines[h.lineNumber-1].substring(h.column-1));return}l[l.length-1]+=this._lines[h.lineNumber-1].substring(h.column-1),this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+l[0]);const g=new Uint32Array(l.length-1);for(let N=1;N<l.length;N++)this._lines.splice(h.lineNumber+N-1,0,l[N]),g[N-1]=l[N].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(h.lineNumber,g)}}t.MirrorTextModel=f}),ne(ie[57],re([0,1,7,44,5,2,54]),function(B,t,P,F,r,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const h=999;class u{constructor(_,c,o,s){this.searchString=_,this.isRegex=c,this.matchCase=o,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=l(this.searchString):_=this.searchString.indexOf(`
`)>=0;let c=null;try{c=P.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!c)return null;let o=!this.isRegex&&!_;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new w.SearchData(c,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}t.SearchParams=u;function l(M){if(!M||M.length===0)return!1;for(let _=0,c=M.length;_<c;_++){const o=M.charCodeAt(_);if(o===10)return!0;if(o===92){if(_++,_>=c)break;const s=M.charCodeAt(_);if(s===110||s===114||s===87)return!0}}return!1}t.isMultilineRegexSource=l;function g(M,_,c){if(!c)return new w.FindMatch(M,null);const o=[];for(let s=0,i=_.length;s<i;s++)o[s]=_[s];return new w.FindMatch(M,o)}t.createFindMatch=g;class N{constructor(_){const c=[];let o=0;for(let s=0,i=_.length;s<i;s++)_.charCodeAt(s)===10&&(c[o++]=s);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(_){const c=this._lineFeedsOffsets;let o=0,s=c.length-1;if(s===-1||_<=c[0])return 0;for(;o<s;){const i=o+((s-o)/2>>0);c[i]>=_?s=i-1:c[i+1]>=_?(o=i,s=i):o=i+1}return o+1}}class b{static findMatches(_,c,o,s,i){const a=c.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(_,o,new E(a.wordSeparators,a.regex),s,i):this._doFindMatchesLineByLine(_,o,a,s,i):[]}static _getMultilineMatchRange(_,c,o,s,i,a){let v,d=0;s?(d=s.findLineFeedCountBeforeOffset(i),v=c+i+d):v=c+i;let L;if(s){const k=s.findLineFeedCountBeforeOffset(i+a.length)-d;L=v+a.length+k}else L=v+a.length;const A=_.getPositionAt(v),R=_.getPositionAt(L);return new f.Range(A.lineNumber,A.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(_,c,o,s,i){const a=_.getOffsetAt(c.getStartPosition()),v=_.getValueInRange(c,1),d=_.getEOL()===`\r
`?new N(v):null,L=[];let A=0,R;for(o.reset(0);R=o.next(v);)if(L[A++]=g(this._getMultilineMatchRange(_,a,v,d,R.index,R[0]),R,s),A>=i)return L;return L}static _doFindMatchesLineByLine(_,c,o,s,i){const a=[];let v=0;if(c.startLineNumber===c.endLineNumber){const L=_.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return v=this._findMatchesInLine(o,L,c.startLineNumber,c.startColumn-1,v,a,s,i),a}const d=_.getLineContent(c.startLineNumber).substring(c.startColumn-1);v=this._findMatchesInLine(o,d,c.startLineNumber,c.startColumn-1,v,a,s,i);for(let L=c.startLineNumber+1;L<c.endLineNumber&&v<i;L++)v=this._findMatchesInLine(o,_.getLineContent(L),L,0,v,a,s,i);if(v<i){const L=_.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);v=this._findMatchesInLine(o,L,c.endLineNumber,0,v,a,s,i)}return a}static _findMatchesInLine(_,c,o,s,i,a,v,d){const L=_.wordSeparators;if(!v&&_.simpleSearch){const D=_.simpleSearch,k=D.length,y=c.length;let S=-k;for(;(S=c.indexOf(D,S+k))!==-1;)if((!L||p(L,c,y,S,k))&&(a[i++]=new w.FindMatch(new f.Range(o,S+1+s,o,S+1+k+s),null),i>=d))return i;return i}const A=new E(_.wordSeparators,_.regex);let R;A.reset(0);do if(R=A.next(c),R&&(a[i++]=g(new f.Range(o,R.index+1+s,o,R.index+1+R[0].length+s),R,v),i>=d))return i;while(R);return i}static findNextMatch(_,c,o,s){const i=c.parseSearchRequest();if(!i)return null;const a=new E(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(_,o,a,s):this._doFindNextMatchLineByLine(_,o,a,s)}static _doFindNextMatchMultiline(_,c,o,s){const i=new r.Position(c.lineNumber,1),a=_.getOffsetAt(i),v=_.getLineCount(),d=_.getValueInRange(new f.Range(i.lineNumber,i.column,v,_.getLineMaxColumn(v)),1),L=_.getEOL()===`\r
`?new N(d):null;o.reset(c.column-1);const A=o.next(d);return A?g(this._getMultilineMatchRange(_,a,d,L,A.index,A[0]),A,s):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(_,new r.Position(1,1),o,s):null}static _doFindNextMatchLineByLine(_,c,o,s){const i=_.getLineCount(),a=c.lineNumber,v=_.getLineContent(a),d=this._findFirstMatchInLine(o,v,a,c.column,s);if(d)return d;for(let L=1;L<=i;L++){const A=(a+L-1)%i,R=_.getLineContent(A+1),D=this._findFirstMatchInLine(o,R,A+1,1,s);if(D)return D}return null}static _findFirstMatchInLine(_,c,o,s,i){_.reset(s-1);const a=_.next(c);return a?g(new f.Range(o,a.index+1,o,a.index+1+a[0].length),a,i):null}static findPreviousMatch(_,c,o,s){const i=c.parseSearchRequest();if(!i)return null;const a=new E(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(_,o,a,s):this._doFindPreviousMatchLineByLine(_,o,a,s)}static _doFindPreviousMatchMultiline(_,c,o,s){const i=this._doFindMatchesMultiline(_,new f.Range(1,1,c.lineNumber,c.column),o,s,10*h);if(i.length>0)return i[i.length-1];const a=_.getLineCount();return c.lineNumber!==a||c.column!==_.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(_,new r.Position(a,_.getLineMaxColumn(a)),o,s):null}static _doFindPreviousMatchLineByLine(_,c,o,s){const i=_.getLineCount(),a=c.lineNumber,v=_.getLineContent(a).substring(0,c.column-1),d=this._findLastMatchInLine(o,v,a,s);if(d)return d;for(let L=1;L<=i;L++){const A=(i+a-L-1)%i,R=_.getLineContent(A+1),D=this._findLastMatchInLine(o,R,A+1,s);if(D)return D}return null}static _findLastMatchInLine(_,c,o,s){let i=null,a;for(_.reset(0);a=_.next(c);)i=g(new f.Range(o,a.index+1,o,a.index+1+a[0].length),a,s);return i}}t.TextModelSearch=b;function m(M,_,c,o,s){if(o===0)return!0;const i=_.charCodeAt(o-1);if(M.get(i)!==0||i===13||i===10)return!0;if(s>0){const a=_.charCodeAt(o);if(M.get(a)!==0)return!0}return!1}function e(M,_,c,o,s){if(o+s===c)return!0;const i=_.charCodeAt(o+s);if(M.get(i)!==0||i===13||i===10)return!0;if(s>0){const a=_.charCodeAt(o+s-1);if(M.get(a)!==0)return!0}return!1}function p(M,_,c,o,s){return m(M,_,c,o,s)&&e(M,_,c,o,s)}t.isValidMatch=p;class E{constructor(_,c){this._wordSeparators=_,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const c=_.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(o=this._searchRegex.exec(_),!o))return null;const s=o.index,i=o[0].length;if(s===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){P.getNextCodePoint(_,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=s,this._prevMatchLength=i,!this._wordSeparators||p(this._wordSeparators,_,c,s,i))return o}while(o);return null}}t.Searcher=E}),ne(ie[58],re([0,1,2,57,7,13,29]),function(B,t,P,F,r,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class h{static computeUnicodeHighlights(e,p,E){const M=E?E.startLineNumber:1,_=E?E.endLineNumber:e.getLineCount(),c=new g(p),o=c.getCandidateCodePoints();let s;o==="allNonBasicAscii"?s=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):s=new RegExp(`${u(Array.from(o))}`,"g");const i=new F.Searcher(null,s),a=[];let v=!1,d,L=0,A=0,R=0;e:for(let D=M,k=_;D<=k;D++){const y=e.getLineContent(D),S=y.length;i.reset(0);do if(d=i.next(y),d){let C=d.index,O=d.index+d[0].length;if(C>0){const $=y.charCodeAt(C-1);r.isHighSurrogate($)&&C--}if(O+1<S){const $=y.charCodeAt(O-1);r.isHighSurrogate($)&&O++}const H=y.substring(C,O);let T=(0,w.getWordAtText)(C+1,w.DEFAULT_WORD_REGEXP,y,0);T&&T.endColumn<=C+1&&(T=null);const q=c.shouldHighlightNonBasicASCII(H,T?T.word:null);if(q!==0){q===3?L++:q===2?A++:q===1?R++:(0,f.assertNever)(q);const $=1e3;if(a.length>=$){v=!0;break e}a.push(new P.Range(D,C+1,D,O+1))}}while(d)}return{ranges:a,hasMore:v,ambiguousCharacterCount:L,invisibleCharacterCount:A,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,p){const E=new g(p);switch(E.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const _=e.codePointAt(0),c=E.ambiguousCharacters.getPrimaryConfusable(_),o=r.AmbiguousCharacters.getLocales().filter(s=>!r.AmbiguousCharacters.getInstance(new Set([...p.allowedLocales,s])).isAmbiguous(_));return{kind:0,confusableWith:String.fromCodePoint(c),notAmbiguousInLocales:o}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=h;function u(m,e){return`[${r.escapeRegExpCharacters(m.map(E=>String.fromCodePoint(E)).join(""))}]`}var l;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(l||(t.UnicodeHighlighterReasonKind=l={}));class g{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const p of r.InvisibleCharacters.codePoints)N(String.fromCodePoint(p))||e.add(p);if(this.options.ambiguousCharacters)for(const p of this.ambiguousCharacters.getConfusableCodePoints())e.add(p);for(const p of this.allowedCodePoints)e.delete(p);return e}shouldHighlightNonBasicASCII(e,p){const E=e.codePointAt(0);if(this.allowedCodePoints.has(E))return 0;if(this.options.nonBasicASCII)return 1;let M=!1,_=!1;if(p)for(const c of p){const o=c.codePointAt(0),s=r.isBasicASCII(c);M=M||s,!s&&!this.ambiguousCharacters.isAmbiguous(o)&&!r.InvisibleCharacters.isInvisibleCharacter(o)&&(_=!0)}return!M&&_?0:this.options.invisibleCharacters&&!N(e)&&r.InvisibleCharacters.isInvisibleCharacter(E)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(E)?3:0}}function N(m){return m===" "||m===`
`||m==="	"}var b;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(b||(b={}))}),ne(ie[59],re([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var P;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(P||(t.AccessibilitySupport=P={}));var F;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var w;(function(n){n[n.Deprecated=1]="Deprecated"})(w||(t.CompletionItemTag=w={}));var h;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var u;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(u||(t.ContentWidgetPositionPreference=u={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var N;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(N||(t.DocumentHighlightKind=N={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var m;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",n[n.occurrencesHighlight=81]="occurrencesHighlight",n[n.overviewRulerBorder=82]="overviewRulerBorder",n[n.overviewRulerLanes=83]="overviewRulerLanes",n[n.padding=84]="padding",n[n.pasteAs=85]="pasteAs",n[n.parameterHints=86]="parameterHints",n[n.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",n[n.quickSuggestions=89]="quickSuggestions",n[n.quickSuggestionsDelay=90]="quickSuggestionsDelay",n[n.readOnly=91]="readOnly",n[n.readOnlyMessage=92]="readOnlyMessage",n[n.renameOnType=93]="renameOnType",n[n.renderControlCharacters=94]="renderControlCharacters",n[n.renderFinalNewline=95]="renderFinalNewline",n[n.renderLineHighlight=96]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=98]="renderValidationDecorations",n[n.renderWhitespace=99]="renderWhitespace",n[n.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",n[n.roundedSelection=101]="roundedSelection",n[n.rulers=102]="rulers",n[n.scrollbar=103]="scrollbar",n[n.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=105]="scrollBeyondLastLine",n[n.scrollPredominantAxis=106]="scrollPredominantAxis",n[n.selectionClipboard=107]="selectionClipboard",n[n.selectionHighlight=108]="selectionHighlight",n[n.selectOnLineNumbers=109]="selectOnLineNumbers",n[n.showFoldingControls=110]="showFoldingControls",n[n.showUnused=111]="showUnused",n[n.snippetSuggestions=112]="snippetSuggestions",n[n.smartSelect=113]="smartSelect",n[n.smoothScrolling=114]="smoothScrolling",n[n.stickyScroll=115]="stickyScroll",n[n.stickyTabStops=116]="stickyTabStops",n[n.stopRenderingLineAfter=117]="stopRenderingLineAfter",n[n.suggest=118]="suggest",n[n.suggestFontSize=119]="suggestFontSize",n[n.suggestLineHeight=120]="suggestLineHeight",n[n.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",n[n.suggestSelection=122]="suggestSelection",n[n.tabCompletion=123]="tabCompletion",n[n.tabIndex=124]="tabIndex",n[n.unicodeHighlighting=125]="unicodeHighlighting",n[n.unusualLineTerminators=126]="unusualLineTerminators",n[n.useShadowDOM=127]="useShadowDOM",n[n.useTabStops=128]="useTabStops",n[n.wordBreak=129]="wordBreak",n[n.wordSeparators=130]="wordSeparators",n[n.wordWrap=131]="wordWrap",n[n.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=134]="wordWrapColumn",n[n.wordWrapOverride1=135]="wordWrapOverride1",n[n.wordWrapOverride2=136]="wordWrapOverride2",n[n.wrappingIndent=137]="wrappingIndent",n[n.wrappingStrategy=138]="wrappingStrategy",n[n.showDeprecated=139]="showDeprecated",n[n.inlayHints=140]="inlayHints",n[n.editorClassName=141]="editorClassName",n[n.pixelRatio=142]="pixelRatio",n[n.tabFocusMode=143]="tabFocusMode",n[n.layoutInfo=144]="layoutInfo",n[n.wrappingInfo=145]="wrappingInfo",n[n.defaultColorDecorators=146]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var p;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(p||(t.EndOfLineSequence=p={}));var E;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(E||(t.GlyphMarginLane=E={}));var M;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(M||(t.IndentAction=M={}));var _;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(_||(t.InjectedTextCursorStops=_={}));var c;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(c||(t.InlayHintKind=c={}));var o;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(o||(t.InlineCompletionTriggerKind=o={}));var s;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var v;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(v||(t.MinimapPosition=v={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var L;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(L||(t.OverlayWidgetPositionPreference=L={}));var A;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(A||(t.OverviewRulerLane=A={}));var R;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(R||(t.PositionAffinity=R={}));var D;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(D||(t.RenderLineNumbersType=D={}));var k;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(k||(t.RenderMinimap=k={}));var y;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(y||(t.ScrollType=y={}));var S;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(S||(t.ScrollbarVisibility=S={}));var C;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(C||(t.SelectionDirection=C={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O||(t.SignatureHelpTriggerKind=O={}));var H;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(H||(t.SymbolKind=H={}));var T;(function(n){n[n.Deprecated=1]="Deprecated"})(T||(t.SymbolTag=T={}));var q;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(q||(t.TextEditorCursorBlinkingStyle=q={}));var $;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})($||(t.TextEditorCursorStyle=$={}));var V;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(V||(t.TrackedRangeStickiness=V={}));var Y;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(Y||(t.WrappingIndent=Y={}))}),ne(ie[60],re([0,1,11,10]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class r{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(h){this._onDidChange.fire({changedLanguages:h,changedColorMap:!1})}register(h,u){return this._tokenizationSupports.set(h,u),this.handleChange([h]),(0,F.toDisposable)(()=>{this._tokenizationSupports.get(h)===u&&(this._tokenizationSupports.delete(h),this.handleChange([h]))})}get(h){return this._tokenizationSupports.get(h)||null}registerFactory(h,u){this._factories.get(h)?.dispose();const l=new f(this,h,u);return this._factories.set(h,l),(0,F.toDisposable)(()=>{const g=this._factories.get(h);!g||g!==l||(this._factories.delete(h),g.dispose())})}async getOrCreate(h){const u=this.get(h);if(u)return u;const l=this._factories.get(h);return!l||l.isResolved?null:(await l.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const l=this._factories.get(h);return!!(!l||l.isResolved)}setColorMap(h){this._colorMap=h,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=r;class f extends F.Disposable{get isResolved(){return this._isResolved}constructor(h,u,l){super(),this._registry=h,this._languageId=u,this._factory=l,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const h=await this._factory.tokenizationSupport;this._isResolved=!0,h&&!this._isDisposed&&this._register(this._registry.register(this._languageId,h))}}}),ne(ie[61],re([62,63]),function(B,t){return B.create("vs/base/common/platform",t)}),ne(ie[17],re([0,1,61]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let F=!1,r=!1,f=!1,w=!1,h=!1,u=!1,l=!1,g=!1,N=!1,b=!1,m,e=t.LANGUAGE_DEFAULT,p=t.LANGUAGE_DEFAULT,E,M;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?_=t.globals.vscode.process:typeof process<"u"&&(_=process);const c=typeof _?.versions?.electron=="string",o=c&&_?.type==="renderer";if(typeof navigator=="object"&&!o)M=navigator.userAgent,F=M.indexOf("Windows")>=0,r=M.indexOf("Macintosh")>=0,g=(M.indexOf("Macintosh")>=0||M.indexOf("iPad")>=0||M.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=M.indexOf("Linux")>=0,b=M?.indexOf("Mobi")>=0,u=!0,m=P.getConfiguredDefaultLocale(P.localize(0,null))||t.LANGUAGE_DEFAULT,e=m,p=navigator.language;else if(typeof _=="object"){F=_.platform==="win32",r=_.platform==="darwin",f=_.platform==="linux",w=f&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,l=c,N=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const D=_.env.VSCODE_NLS_CONFIG;if(D)try{const k=JSON.parse(D),y=k.availableLanguages["*"];m=k.locale,p=k.osLocale,e=y||t.LANGUAGE_DEFAULT,E=k._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var s;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(s||(t.Platform=s={}));function i(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=i;let a=0;r?a=1:F?a=3:f&&(a=2),t.isWindows=F,t.isMacintosh=r,t.isLinux=f,t.isLinuxSnap=w,t.isNative=h,t.isElectron=l,t.isWeb=u,t.isWebWorker=u&&typeof t.globals.importScripts=="function",t.isIOS=g,t.isMobile=b,t.isCI=N,t.platform=a,t.userAgent=M,t.language=e;var v;(function(D){function k(){return t.language}D.value=k;function y(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}D.isDefaultVariant=y;function S(){return t.language==="en"}D.isDefault=S})(v||(t.Language=v={})),t.locale=m,t.platformLocale=p,t.translationsConfigFile=E,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const D=[];t.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let S=0,C=D.length;S<C;S++){const O=D[S];if(O.id===y.data.vscodeScheduleAsyncWork){D.splice(S,1),O.callback();return}}});let k=0;return y=>{const S=++k;D.push({id:S,callback:y}),t.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return D=>setTimeout(D)})();var d;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(d||(t.OperatingSystem=d={})),t.OS=r||g?2:F?1:3;let L=!0,A=!1;function R(){if(!A){A=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,L=new Uint16Array(D.buffer)[0]===(2<<8)+1}return L}t.isLittleEndian=R,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),ne(ie[64],re([0,1,17]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let F;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.process<"u"){const r=P.globals.vscode.process;F={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.platform=F.platform,t.arch=F.arch}),ne(ie[65],re([0,1,64]),function(B,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const F=65,r=97,f=90,w=122,h=46,u=47,l=92,g=58,N=63;class b extends Error{constructor(a,v,d){let L;typeof v=="string"&&v.indexOf("not ")===0?(L="must not be",v=v.replace(/^not /,"")):L="must be";const A=a.indexOf(".")!==-1?"property":"argument";let R=`The "${a}" ${A} ${L} of type ${v}`;R+=`. Received type ${typeof d}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function m(i,a){if(i===null||typeof i!="object")throw new b(a,"Object",i)}function e(i,a){if(typeof i!="string")throw new b(a,"string",i)}const p=P.platform==="win32";function E(i){return i===u||i===l}function M(i){return i===u}function _(i){return i>=F&&i<=f||i>=r&&i<=w}function c(i,a,v,d){let L="",A=0,R=-1,D=0,k=0;for(let y=0;y<=i.length;++y){if(y<i.length)k=i.charCodeAt(y);else{if(d(k))break;k=u}if(d(k)){if(!(R===y-1||D===1))if(D===2){if(L.length<2||A!==2||L.charCodeAt(L.length-1)!==h||L.charCodeAt(L.length-2)!==h){if(L.length>2){const S=L.lastIndexOf(v);S===-1?(L="",A=0):(L=L.slice(0,S),A=L.length-1-L.lastIndexOf(v)),R=y,D=0;continue}else if(L.length!==0){L="",A=0,R=y,D=0;continue}}a&&(L+=L.length>0?`${v}..`:"..",A=2)}else L.length>0?L+=`${v}${i.slice(R+1,y)}`:L=i.slice(R+1,y),A=y-R-1;R=y,D=0}else k===h&&D!==-1?++D:D=-1}return L}function o(i,a){m(a,"pathObject");const v=a.dir||a.root,d=a.base||`${a.name||""}${a.ext||""}`;return v?v===a.root?`${v}${d}`:`${v}${i}${d}`:d}t.win32={resolve(...i){let a="",v="",d=!1;for(let L=i.length-1;L>=-1;L--){let A;if(L>=0){if(A=i[L],e(A,"path"),A.length===0)continue}else a.length===0?A=P.cwd():(A=P.env[`=${a}`]||P.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==a.toLowerCase()&&A.charCodeAt(2)===l)&&(A=`${a}\\`));const R=A.length;let D=0,k="",y=!1;const S=A.charCodeAt(0);if(R===1)E(S)&&(D=1,y=!0);else if(E(S))if(y=!0,E(A.charCodeAt(1))){let C=2,O=C;for(;C<R&&!E(A.charCodeAt(C));)C++;if(C<R&&C!==O){const H=A.slice(O,C);for(O=C;C<R&&E(A.charCodeAt(C));)C++;if(C<R&&C!==O){for(O=C;C<R&&!E(A.charCodeAt(C));)C++;(C===R||C!==O)&&(k=`\\\\${H}\\${A.slice(O,C)}`,D=C)}}}else D=1;else _(S)&&A.charCodeAt(1)===g&&(k=A.slice(0,2),D=2,R>2&&E(A.charCodeAt(2))&&(y=!0,D=3));if(k.length>0)if(a.length>0){if(k.toLowerCase()!==a.toLowerCase())continue}else a=k;if(d){if(a.length>0)break}else if(v=`${A.slice(D)}\\${v}`,d=y,y&&a.length>0)break}return v=c(v,!d,"\\",E),d?`${a}\\${v}`:`${a}${v}`||"."},normalize(i){e(i,"path");const a=i.length;if(a===0)return".";let v=0,d,L=!1;const A=i.charCodeAt(0);if(a===1)return M(A)?"\\":i;if(E(A))if(L=!0,E(i.charCodeAt(1))){let D=2,k=D;for(;D<a&&!E(i.charCodeAt(D));)D++;if(D<a&&D!==k){const y=i.slice(k,D);for(k=D;D<a&&E(i.charCodeAt(D));)D++;if(D<a&&D!==k){for(k=D;D<a&&!E(i.charCodeAt(D));)D++;if(D===a)return`\\\\${y}\\${i.slice(k)}\\`;D!==k&&(d=`\\\\${y}\\${i.slice(k,D)}`,v=D)}}}else v=1;else _(A)&&i.charCodeAt(1)===g&&(d=i.slice(0,2),v=2,a>2&&E(i.charCodeAt(2))&&(L=!0,v=3));let R=v<a?c(i.slice(v),!L,"\\",E):"";return R.length===0&&!L&&(R="."),R.length>0&&E(i.charCodeAt(a-1))&&(R+="\\"),d===void 0?L?`\\${R}`:R:L?`${d}\\${R}`:`${d}${R}`},isAbsolute(i){e(i,"path");const a=i.length;if(a===0)return!1;const v=i.charCodeAt(0);return E(v)||a>2&&_(v)&&i.charCodeAt(1)===g&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,v;for(let A=0;A<i.length;++A){const R=i[A];e(R,"path"),R.length>0&&(a===void 0?a=v=R:a+=`\\${R}`)}if(a===void 0)return".";let d=!0,L=0;if(typeof v=="string"&&E(v.charCodeAt(0))){++L;const A=v.length;A>1&&E(v.charCodeAt(1))&&(++L,A>2&&(E(v.charCodeAt(2))?++L:d=!1))}if(d){for(;L<a.length&&E(a.charCodeAt(L));)L++;L>=2&&(a=`\\${a.slice(L)}`)}return t.win32.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a)return"";const v=t.win32.resolve(i),d=t.win32.resolve(a);if(v===d||(i=v.toLowerCase(),a=d.toLowerCase(),i===a))return"";let L=0;for(;L<i.length&&i.charCodeAt(L)===l;)L++;let A=i.length;for(;A-1>L&&i.charCodeAt(A-1)===l;)A--;const R=A-L;let D=0;for(;D<a.length&&a.charCodeAt(D)===l;)D++;let k=a.length;for(;k-1>D&&a.charCodeAt(k-1)===l;)k--;const y=k-D,S=R<y?R:y;let C=-1,O=0;for(;O<S;O++){const T=i.charCodeAt(L+O);if(T!==a.charCodeAt(D+O))break;T===l&&(C=O)}if(O!==S){if(C===-1)return d}else{if(y>S){if(a.charCodeAt(D+O)===l)return d.slice(D+O+1);if(O===2)return d.slice(D+O)}R>S&&(i.charCodeAt(L+O)===l?C=O:O===2&&(C=3)),C===-1&&(C=0)}let H="";for(O=L+C+1;O<=A;++O)(O===A||i.charCodeAt(O)===l)&&(H+=H.length===0?"..":"\\..");return D+=C,H.length>0?`${H}${d.slice(D,k)}`:(d.charCodeAt(D)===l&&++D,d.slice(D,k))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=t.win32.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const v=a.charCodeAt(2);if(v!==N&&v!==h)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(_(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return i},dirname(i){e(i,"path");const a=i.length;if(a===0)return".";let v=-1,d=0;const L=i.charCodeAt(0);if(a===1)return E(L)?i:".";if(E(L)){if(v=d=1,E(i.charCodeAt(1))){let D=2,k=D;for(;D<a&&!E(i.charCodeAt(D));)D++;if(D<a&&D!==k){for(k=D;D<a&&E(i.charCodeAt(D));)D++;if(D<a&&D!==k){for(k=D;D<a&&!E(i.charCodeAt(D));)D++;if(D===a)return i;D!==k&&(v=d=D+1)}}}}else _(L)&&i.charCodeAt(1)===g&&(v=a>2&&E(i.charCodeAt(2))?3:2,d=v);let A=-1,R=!0;for(let D=a-1;D>=d;--D)if(E(i.charCodeAt(D))){if(!R){A=D;break}}else R=!1;if(A===-1){if(v===-1)return".";A=v}return i.slice(0,A)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let v=0,d=-1,L=!0,A;if(i.length>=2&&_(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(v=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,D=-1;for(A=i.length-1;A>=v;--A){const k=i.charCodeAt(A);if(E(k)){if(!L){v=A+1;break}}else D===-1&&(L=!1,D=A+1),R>=0&&(k===a.charCodeAt(R)?--R===-1&&(d=A):(R=-1,d=D))}return v===d?d=D:d===-1&&(d=i.length),i.slice(v,d)}for(A=i.length-1;A>=v;--A)if(E(i.charCodeAt(A))){if(!L){v=A+1;break}}else d===-1&&(L=!1,d=A+1);return d===-1?"":i.slice(v,d)},extname(i){e(i,"path");let a=0,v=-1,d=0,L=-1,A=!0,R=0;i.length>=2&&i.charCodeAt(1)===g&&_(i.charCodeAt(0))&&(a=d=2);for(let D=i.length-1;D>=a;--D){const k=i.charCodeAt(D);if(E(k)){if(!A){d=D+1;break}continue}L===-1&&(A=!1,L=D+1),k===h?v===-1?v=D:R!==1&&(R=1):v!==-1&&(R=-1)}return v===-1||L===-1||R===0||R===1&&v===L-1&&v===d+1?"":i.slice(v,L)},format:o.bind(null,"\\"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const v=i.length;let d=0,L=i.charCodeAt(0);if(v===1)return E(L)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(E(L)){if(d=1,E(i.charCodeAt(1))){let C=2,O=C;for(;C<v&&!E(i.charCodeAt(C));)C++;if(C<v&&C!==O){for(O=C;C<v&&E(i.charCodeAt(C));)C++;if(C<v&&C!==O){for(O=C;C<v&&!E(i.charCodeAt(C));)C++;C===v?d=C:C!==O&&(d=C+1)}}}}else if(_(L)&&i.charCodeAt(1)===g){if(v<=2)return a.root=a.dir=i,a;if(d=2,E(i.charCodeAt(2))){if(v===3)return a.root=a.dir=i,a;d=3}}d>0&&(a.root=i.slice(0,d));let A=-1,R=d,D=-1,k=!0,y=i.length-1,S=0;for(;y>=d;--y){if(L=i.charCodeAt(y),E(L)){if(!k){R=y+1;break}continue}D===-1&&(k=!1,D=y+1),L===h?A===-1?A=y:S!==1&&(S=1):A!==-1&&(S=-1)}return D!==-1&&(A===-1||S===0||S===1&&A===D-1&&A===R+1?a.base=a.name=i.slice(R,D):(a.name=i.slice(R,A),a.base=i.slice(R,D),a.ext=i.slice(A,D))),R>0&&R!==d?a.dir=i.slice(0,R-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(p){const i=/\\/g;return()=>{const a=P.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>P.cwd()})();t.posix={resolve(...i){let a="",v=!1;for(let d=i.length-1;d>=-1&&!v;d--){const L=d>=0?i[d]:s();e(L,"path"),L.length!==0&&(a=`${L}/${a}`,v=L.charCodeAt(0)===u)}return a=c(a,!v,"/",M),v?`/${a}`:a.length>0?a:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===u,v=i.charCodeAt(i.length-1)===u;return i=c(i,!a,"/",M),i.length===0?a?"/":v?"./":".":(v&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let a;for(let v=0;v<i.length;++v){const d=i[v];e(d,"path"),d.length>0&&(a===void 0?a=d:a+=`/${d}`)}return a===void 0?".":t.posix.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a||(i=t.posix.resolve(i),a=t.posix.resolve(a),i===a))return"";const v=1,d=i.length,L=d-v,A=1,R=a.length-A,D=L<R?L:R;let k=-1,y=0;for(;y<D;y++){const C=i.charCodeAt(v+y);if(C!==a.charCodeAt(A+y))break;C===u&&(k=y)}if(y===D)if(R>D){if(a.charCodeAt(A+y)===u)return a.slice(A+y+1);if(y===0)return a.slice(A+y)}else L>D&&(i.charCodeAt(v+y)===u?k=y:y===0&&(k=0));let S="";for(y=v+k+1;y<=d;++y)(y===d||i.charCodeAt(y)===u)&&(S+=S.length===0?"..":"/..");return`${S}${a.slice(A+k)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===u;let v=-1,d=!0;for(let L=i.length-1;L>=1;--L)if(i.charCodeAt(L)===u){if(!d){v=L;break}}else d=!1;return v===-1?a?"/":".":a&&v===1?"//":i.slice(0,v)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let v=0,d=-1,L=!0,A;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,D=-1;for(A=i.length-1;A>=0;--A){const k=i.charCodeAt(A);if(k===u){if(!L){v=A+1;break}}else D===-1&&(L=!1,D=A+1),R>=0&&(k===a.charCodeAt(R)?--R===-1&&(d=A):(R=-1,d=D))}return v===d?d=D:d===-1&&(d=i.length),i.slice(v,d)}for(A=i.length-1;A>=0;--A)if(i.charCodeAt(A)===u){if(!L){v=A+1;break}}else d===-1&&(L=!1,d=A+1);return d===-1?"":i.slice(v,d)},extname(i){e(i,"path");let a=-1,v=0,d=-1,L=!0,A=0;for(let R=i.length-1;R>=0;--R){const D=i.charCodeAt(R);if(D===u){if(!L){v=R+1;break}continue}d===-1&&(L=!1,d=R+1),D===h?a===-1?a=R:A!==1&&(A=1):a!==-1&&(A=-1)}return a===-1||d===-1||A===0||A===1&&a===d-1&&a===v+1?"":i.slice(a,d)},format:o.bind(null,"/"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const v=i.charCodeAt(0)===u;let d;v?(a.root="/",d=1):d=0;let L=-1,A=0,R=-1,D=!0,k=i.length-1,y=0;for(;k>=d;--k){const S=i.charCodeAt(k);if(S===u){if(!D){A=k+1;break}continue}R===-1&&(D=!1,R=k+1),S===h?L===-1?L=k:y!==1&&(y=1):L!==-1&&(y=-1)}if(R!==-1){const S=A===0&&v?1:A;L===-1||y===0||y===1&&L===R-1&&L===A+1?a.base=a.name=i.slice(S,R):(a.name=i.slice(S,L),a.base=i.slice(S,R),a.ext=i.slice(L,R))}return A>0?a.dir=i.slice(0,A-1):v&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=p?t.win32.normalize:t.posix.normalize,t.isAbsolute=p?t.win32.isAbsolute:t.posix.isAbsolute,t.join=p?t.win32.join:t.posix.join,t.resolve=p?t.win32.resolve:t.posix.resolve,t.relative=p?t.win32.relative:t.posix.relative,t.dirname=p?t.win32.dirname:t.posix.dirname,t.basename=p?t.win32.basename:t.posix.basename,t.extname=p?t.win32.extname:t.posix.extname,t.format=p?t.win32.format:t.posix.format,t.parse=p?t.win32.parse:t.posix.parse,t.toNamespacedPath=p?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=p?t.win32.sep:t.posix.sep,t.delimiter=p?t.win32.delimiter:t.posix.delimiter}),ne(ie[18],re([0,1,65,17]),function(B,t,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,f=/^\//,w=/^\/\//;function h(d,L){if(!d.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!f.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(d,L){return!d&&!L?"file":d}function l(d,L){switch(d){case"https":case"http":case"file":L?L[0]!==N&&(L=N+L):L=N;break}return L}const g="",N="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(L){return L instanceof m?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,A,R,D,k,y=!1){typeof L=="object"?(this.scheme=L.scheme||g,this.authority=L.authority||g,this.path=L.path||g,this.query=L.query||g,this.fragment=L.fragment||g):(this.scheme=u(L,y),this.authority=A||g,this.path=l(this.scheme,R||g),this.query=D||g,this.fragment=k||g,h(this,y))}get fsPath(){return o(this,!1)}with(L){if(!L)return this;let{scheme:A,authority:R,path:D,query:k,fragment:y}=L;return A===void 0?A=this.scheme:A===null&&(A=g),R===void 0?R=this.authority:R===null&&(R=g),D===void 0?D=this.path:D===null&&(D=g),k===void 0?k=this.query:k===null&&(k=g),y===void 0?y=this.fragment:y===null&&(y=g),A===this.scheme&&R===this.authority&&D===this.path&&k===this.query&&y===this.fragment?this:new E(A,R,D,k,y)}static parse(L,A=!1){const R=b.exec(L);return R?new E(R[2]||g,v(R[4]||g),v(R[5]||g),v(R[7]||g),v(R[9]||g),A):new E(g,g,g,g,g)}static file(L){let A=g;if(F.isWindows&&(L=L.replace(/\\/g,N)),L[0]===N&&L[1]===N){const R=L.indexOf(N,2);R===-1?(A=L.substring(2),L=N):(A=L.substring(2,R),L=L.substring(R)||N)}return new E("file",A,L,g,g)}static from(L,A){return new E(L.scheme,L.authority,L.path,L.query,L.fragment,A)}static joinPath(L,...A){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return F.isWindows&&L.scheme==="file"?R=m.file(P.win32.join(o(L,!0),...A)).path:R=P.posix.join(L.path,...A),L.with({path:R})}toString(L=!1){return s(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof m)return L;{const A=new E(L);return A._formatted=L.external??null,A._fsPath=L._sep===p?L.fsPath??null:null,A}}else return L}}t.URI=m;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.isUriComponents=e;const p=F.isWindows?1:void 0;class E extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(L=!1){return L?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=p),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const M={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(d,L,A){let R,D=-1;for(let k=0;k<d.length;k++){const y=d.charCodeAt(k);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||L&&y===47||A&&y===91||A&&y===93||A&&y===58)D!==-1&&(R+=encodeURIComponent(d.substring(D,k)),D=-1),R!==void 0&&(R+=d.charAt(k));else{R===void 0&&(R=d.substr(0,k));const S=M[y];S!==void 0?(D!==-1&&(R+=encodeURIComponent(d.substring(D,k)),D=-1),R+=S):D===-1&&(D=k)}}return D!==-1&&(R+=encodeURIComponent(d.substring(D))),R!==void 0?R:d}function c(d){let L;for(let A=0;A<d.length;A++){const R=d.charCodeAt(A);R===35||R===63?(L===void 0&&(L=d.substr(0,A)),L+=M[R]):L!==void 0&&(L+=d[A])}return L!==void 0?L:d}function o(d,L){let A;return d.authority&&d.path.length>1&&d.scheme==="file"?A=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?L?A=d.path.substr(1):A=d.path[1].toLowerCase()+d.path.substr(2):A=d.path,F.isWindows&&(A=A.replace(/\//g,"\\")),A}t.uriToFsPath=o;function s(d,L){const A=L?c:_;let R="",{scheme:D,authority:k,path:y,query:S,fragment:C}=d;if(D&&(R+=D,R+=":"),(k||D==="file")&&(R+=N,R+=N),k){let O=k.indexOf("@");if(O!==-1){const H=k.substr(0,O);k=k.substr(O+1),O=H.lastIndexOf(":"),O===-1?R+=A(H,!1,!1):(R+=A(H.substr(0,O),!1,!1),R+=":",R+=A(H.substr(O+1),!1,!0)),R+="@"}k=k.toLowerCase(),O=k.lastIndexOf(":"),O===-1?R+=A(k,!1,!0):(R+=A(k.substr(0,O),!1,!0),R+=k.substr(O))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const O=y.charCodeAt(1);O>=65&&O<=90&&(y=`/${String.fromCharCode(O+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const O=y.charCodeAt(0);O>=65&&O<=90&&(y=`${String.fromCharCode(O+32)}:${y.substr(2)}`)}R+=A(y,!0,!1)}return S&&(R+="?",R+=A(S,!1,!1)),C&&(R+="#",R+=L?C:_(C,!1,!1)),R}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(d){return d.match(a)?d.replace(a,L=>i(L)):d}}),ne(ie[70],re([0,1,3,11,10,14,17,7]),function(B,t,P,F,r,f,w,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const u="$initialize";let l=!1;function g(v){w.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(v.message))}t.logOnceWebWorkerWarning=g;var N;(function(v){v[v.Request=0]="Request",v[v.Reply=1]="Reply",v[v.SubscribeEvent=2]="SubscribeEvent",v[v.Event=3]="Event",v[v.UnsubscribeEvent=4]="UnsubscribeEvent"})(N||(N={}));class b{constructor(d,L,A,R){this.vsWorker=d,this.req=L,this.method=A,this.args=R,this.type=0}}class m{constructor(d,L,A,R){this.vsWorker=d,this.seq=L,this.res=A,this.err=R,this.type=1}}class e{constructor(d,L,A,R){this.vsWorker=d,this.req=L,this.eventName=A,this.arg=R,this.type=2}}class p{constructor(d,L,A){this.vsWorker=d,this.req=L,this.event=A,this.type=3}}class E{constructor(d,L){this.vsWorker=d,this.req=L,this.type=4}}class M{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,L){const A=String(++this._lastSentReq);return new Promise((R,D)=>{this._pendingReplies[A]={resolve:R,reject:D},this._send(new b(this._workerId,A,d,L))})}listen(d,L){let A=null;const R=new F.Emitter({onWillAddFirstListener:()=>{A=String(++this._lastSentReq),this._pendingEmitters.set(A,R),this._send(new e(this._workerId,A,d,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(A),this._send(new E(this._workerId,A)),A=null}});return R.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let A=d.err;d.err.$isError&&(A=new Error,A.name=d.err.name,A.message=d.err.message,A.stack=d.err.stack),L.reject(A);return}L.resolve(d.res)}_handleRequestMessage(d){const L=d.req;this._handler.handleMessage(d.method,d.args).then(R=>{this._send(new m(this._workerId,L,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,P.transformErrorForSerialization)(R.detail)),this._send(new m(this._workerId,L,void 0,(0,P.transformErrorForSerialization)(R)))})}_handleSubscribeEventMessage(d){const L=d.req,A=this._handler.handleEvent(d.eventName,d.arg)(R=>{this._send(new p(this._workerId,L,R))});this._pendingEvents.set(L,A)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){const L=[];if(d.type===0)for(let A=0;A<d.args.length;A++)d.args[A]instanceof ArrayBuffer&&L.push(d.args[A]);else d.type===1&&d.res instanceof ArrayBuffer&&L.push(d.res);this._handler.sendMessage(d,L)}}class _ extends r.Disposable{constructor(d,L,A){super();let R=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",O=>{this._protocol.handleMessage(O)},O=>{R?.(O)})),this._protocol=new M({sendMessage:(O,H)=>{this._worker.postMessage(O,H)},handleMessage:(O,H)=>{if(typeof A[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(A[O].apply(A,H))}catch(T){return Promise.reject(T)}},handleEvent:(O,H)=>{if(o(O)){const T=A[O].call(A,H);if(typeof T!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return T}if(c(O)){const T=A[O];if(typeof T!="function")throw new Error(`Missing event ${O} on main thread host.`);return T}throw new Error(`Malformed event name ${O}`)}}),this._protocol.setWorkerId(this._worker.getId());let D=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?D=k.getConfig():typeof globalThis.requirejs<"u"&&(D=globalThis.requirejs.s.contexts._.config);const y=(0,f.getAllMethodNames)(A);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(D)),L,y]);const S=(O,H)=>this._request(O,H),C=(O,H)=>this._protocol.listen(O,H);this._lazyProxy=new Promise((O,H)=>{R=H,this._onModuleLoaded.then(T=>{O(s(T,S,C))},T=>{H(T),this._onError("Worker failed to load "+L,T)})})}getProxyObject(){return this._lazyProxy}_request(d,L){return new Promise((A,R)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,L).then(A,R)},R)})}_onError(d,L){console.error(d),console.info(L)}}t.SimpleWorkerClient=_;function c(v){return v[0]==="o"&&v[1]==="n"&&h.isUpperAsciiLetter(v.charCodeAt(2))}function o(v){return/^onDynamic/.test(v)&&h.isUpperAsciiLetter(v.charCodeAt(9))}function s(v,d,L){const A=k=>function(){const y=Array.prototype.slice.call(arguments,0);return d(k,y)},R=k=>function(y){return L(k,y)},D={};for(const k of v){if(o(k)){D[k]=R(k);continue}if(c(k)){D[k]=L(k,void 0);continue}D[k]=A(k)}return D}class i{constructor(d,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new M({sendMessage:(A,R)=>{d(A,R)},handleMessage:(A,R)=>this._handleMessage(A,R),handleEvent:(A,R)=>this._handleEvent(A,R)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,L){if(d===u)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,L))}catch(A){return Promise.reject(A)}}_handleEvent(d,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(o(d)){const A=this._requestHandler[d].call(this._requestHandler,L);if(typeof A!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return A}if(c(d)){const A=this._requestHandler[d];if(typeof A!="function")throw new Error(`Missing event ${d} on request handler.`);return A}throw new Error(`Malformed event name ${d}`)}initialize(d,L,A,R){this._protocol.setWorkerId(d);const y=s(R,(S,C)=>this._protocol.sendMessage(S,C),(S,C)=>this._protocol.listen(S,C));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(y),Promise.resolve((0,f.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((S,C)=>{(globalThis.require||B)([A],H=>{if(this._requestHandler=H.create(y),!this._requestHandler){C(new Error("No RequestHandler!"));return}S((0,f.getAllMethodNames)(this._requestHandler))},C)}))}}t.SimpleWorkerServer=i;function a(v){return new i(v,null)}t.create=a}),ne(ie[66],re([62,63]),function(B,t){return B.create("vs/editor/common/languages",t)}),ne(ie[67],re([0,1,41,18,42,2,60,66]),function(B,t,P,F,r,f,w,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.SymbolTag=t.getAriaLabelForSymbol=t.symbolKindNames=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class u{constructor(q,$,V){this.offset=q,this.type=$,this.language=V,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=u;class l{constructor(q,$){this.tokens=q,this.endState=$,this._tokenizationResultBrand=void 0}}t.TokenizationResult=l;class g{constructor(q,$){this.tokens=q,this.endState=$,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=g;var N;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(N||(t.CompletionItemKind=N={}));var b;(function(T){const q=new Map;q.set(0,P.Codicon.symbolMethod),q.set(1,P.Codicon.symbolFunction),q.set(2,P.Codicon.symbolConstructor),q.set(3,P.Codicon.symbolField),q.set(4,P.Codicon.symbolVariable),q.set(5,P.Codicon.symbolClass),q.set(6,P.Codicon.symbolStruct),q.set(7,P.Codicon.symbolInterface),q.set(8,P.Codicon.symbolModule),q.set(9,P.Codicon.symbolProperty),q.set(10,P.Codicon.symbolEvent),q.set(11,P.Codicon.symbolOperator),q.set(12,P.Codicon.symbolUnit),q.set(13,P.Codicon.symbolValue),q.set(15,P.Codicon.symbolEnum),q.set(14,P.Codicon.symbolConstant),q.set(15,P.Codicon.symbolEnum),q.set(16,P.Codicon.symbolEnumMember),q.set(17,P.Codicon.symbolKeyword),q.set(27,P.Codicon.symbolSnippet),q.set(18,P.Codicon.symbolText),q.set(19,P.Codicon.symbolColor),q.set(20,P.Codicon.symbolFile),q.set(21,P.Codicon.symbolReference),q.set(22,P.Codicon.symbolCustomColor),q.set(23,P.Codicon.symbolFolder),q.set(24,P.Codicon.symbolTypeParameter),q.set(25,P.Codicon.account),q.set(26,P.Codicon.issues);function $(n){let te=q.get(n);return te||(console.info("No codicon found for CompletionItemKind "+n),te=P.Codicon.symbolProperty),te}T.toIcon=$;const V=new Map;V.set("method",0),V.set("function",1),V.set("constructor",2),V.set("field",3),V.set("variable",4),V.set("class",5),V.set("struct",6),V.set("interface",7),V.set("module",8),V.set("property",9),V.set("event",10),V.set("operator",11),V.set("unit",12),V.set("value",13),V.set("constant",14),V.set("enum",15),V.set("enum-member",16),V.set("enumMember",16),V.set("keyword",17),V.set("snippet",27),V.set("text",18),V.set("color",19),V.set("file",20),V.set("reference",21),V.set("customcolor",22),V.set("folder",23),V.set("type-parameter",24),V.set("typeParameter",24),V.set("account",25),V.set("issue",26);function Y(n,te){let oe=V.get(n);return typeof oe>"u"&&!te&&(oe=9),oe}T.fromString=Y})(b||(t.CompletionItemKinds=b={}));var m;(function(T){T[T.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var p;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(t.CompletionTriggerKind=p={}));var E;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(E||(t.InlineCompletionTriggerKind=E={}));class M{constructor(q,$,V,Y){this.range=q,this.text=$,this.completionKind=V,this.isSnippetText=Y}equals(q){return f.Range.lift(this.range).equalsRange(q.range)&&this.text===q.text&&this.completionKind===q.completionKind&&this.isSnippetText===q.isSnippetText}}t.SelectedSuggestionInfo=M;var _;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(_||(t.CodeActionTriggerType=_={}));var c;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(c||(t.SignatureHelpTriggerKind=c={}));var o;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(o||(t.DocumentHighlightKind=o={}));function s(T){return T&&F.URI.isUri(T.uri)&&f.Range.isIRange(T.range)&&(f.Range.isIRange(T.originSelectionRange)||f.Range.isIRange(T.targetSelectionRange))}t.isLocationLink=s;var i;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.symbolKindNames={[17]:(0,h.localize)(0,null),[16]:(0,h.localize)(1,null),[4]:(0,h.localize)(2,null),[13]:(0,h.localize)(3,null),[8]:(0,h.localize)(4,null),[9]:(0,h.localize)(5,null),[21]:(0,h.localize)(6,null),[23]:(0,h.localize)(7,null),[7]:(0,h.localize)(8,null),[0]:(0,h.localize)(9,null),[11]:(0,h.localize)(10,null),[10]:(0,h.localize)(11,null),[19]:(0,h.localize)(12,null),[5]:(0,h.localize)(13,null),[1]:(0,h.localize)(14,null),[2]:(0,h.localize)(15,null),[20]:(0,h.localize)(16,null),[15]:(0,h.localize)(17,null),[18]:(0,h.localize)(18,null),[24]:(0,h.localize)(19,null),[3]:(0,h.localize)(20,null),[6]:(0,h.localize)(21,null),[14]:(0,h.localize)(22,null),[22]:(0,h.localize)(23,null),[25]:(0,h.localize)(24,null),[12]:(0,h.localize)(25,null)};function a(T,q){return(0,h.localize)(26,null,T,t.symbolKindNames[q])}t.getAriaLabelForSymbol=a;var v;(function(T){T[T.Deprecated=1]="Deprecated"})(v||(t.SymbolTag=v={}));var d;(function(T){const q=new Map;q.set(0,P.Codicon.symbolFile),q.set(1,P.Codicon.symbolModule),q.set(2,P.Codicon.symbolNamespace),q.set(3,P.Codicon.symbolPackage),q.set(4,P.Codicon.symbolClass),q.set(5,P.Codicon.symbolMethod),q.set(6,P.Codicon.symbolProperty),q.set(7,P.Codicon.symbolField),q.set(8,P.Codicon.symbolConstructor),q.set(9,P.Codicon.symbolEnum),q.set(10,P.Codicon.symbolInterface),q.set(11,P.Codicon.symbolFunction),q.set(12,P.Codicon.symbolVariable),q.set(13,P.Codicon.symbolConstant),q.set(14,P.Codicon.symbolString),q.set(15,P.Codicon.symbolNumber),q.set(16,P.Codicon.symbolBoolean),q.set(17,P.Codicon.symbolArray),q.set(18,P.Codicon.symbolObject),q.set(19,P.Codicon.symbolKey),q.set(20,P.Codicon.symbolNull),q.set(21,P.Codicon.symbolEnumMember),q.set(22,P.Codicon.symbolStruct),q.set(23,P.Codicon.symbolEvent),q.set(24,P.Codicon.symbolOperator),q.set(25,P.Codicon.symbolTypeParameter);function $(V){let Y=q.get(V);return Y||(console.info("No codicon found for SymbolKind "+V),Y=P.Codicon.symbolProperty),Y}T.toIcon=$})(d||(t.SymbolKinds=d={}));class L{static asEditOperation(q){return r.EditOperation.replace(f.Range.lift(q.range),q.text)}}t.TextEdit=L;class A{static{this.Comment=new A("comment")}static{this.Imports=new A("imports")}static{this.Region=new A("region")}static fromValue(q){switch(q){case"comment":return A.Comment;case"imports":return A.Imports;case"region":return A.Region}return new A(q)}constructor(q){this.value=q}}t.FoldingRangeKind=A;var R;(function(T){function q($){return!$||typeof $!="object"?!1:typeof $.id=="string"&&typeof $.title=="string"}T.is=q})(R||(t.Command=R={}));var D;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(D||(t.CommentThreadCollapsibleState=D={}));var k;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(k||(t.CommentThreadState=k={}));var y;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(y||(t.CommentMode=y={}));var S;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(S||(t.CommentState=S={}));var C;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(C||(t.InlayHintKind=C={}));class O{constructor(q){this.createSupport=q,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(q=>{q&&q.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=O,t.TokenizationRegistry=new w.TokenizationRegistry;var H;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(H||(t.ExternalUriOpenerPriority=H={}))}),ne(ie[68],re([0,1,24,11,37,18,5,2,43,67,59]),function(B,t,P,F,r,f,w,h,u,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class N{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,p){return(0,r.KeyChord)(e,p)}}t.KeyMod=N;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:F.Emitter,KeyCode:g.KeyCode,KeyMod:N,Position:w.Position,Range:h.Range,Selection:u.Selection,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:f.URI,Token:l.Token}}t.createMonacoBaseAPI=b}),ne(ie[71],re([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(B,t,P,F,r,f,w,h,u,l,g,N,b,m,e,p,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class _ extends w.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(i){const a=[];for(let v=0;v<this._lines.length;v++){const d=this._lines[v],L=this.offsetAt(new r.Position(v+1,1)),A=d.matchAll(i);for(const R of A)(R.index||R.index===0)&&(R.index=R.index+L),a.push(R)}return a}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,a){const v=(0,h.getWordAtText)(i.column,(0,h.ensureValidWordDefinition)(a),this._lines[i.lineNumber-1],0);return v?new f.Range(i.lineNumber,v.startColumn,i.lineNumber,v.endColumn):null}getWordUntilPosition(i,a){const v=this.getWordAtPosition(i,a);return v?{word:this._lines[i.lineNumber-1].substring(v.startColumn-1,i.column-1),startColumn:v.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const a=this._lines,v=this._wordenize.bind(this);let d=0,L="",A=0,R=[];return{*[Symbol.iterator](){for(;;)if(A<R.length){const D=L.substring(R[A].start,R[A].end);A+=1,yield D}else if(d<a.length)L=a[d],R=v(L,i),A=0,d+=1;else break}}}getLineWords(i,a){const v=this._lines[i-1],d=this._wordenize(v,a),L=[];for(const A of d)L.push({word:v.substring(A.start,A.end),startColumn:A.start+1,endColumn:A.end+1});return L}_wordenize(i,a){const v=[];let d;for(a.lastIndex=0;(d=a.exec(i))&&d[0].length!==0;)v.push({start:d.index,end:d.index+d[0].length});return v}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const a=this._eol,v=i.startLineNumber-1,d=i.endLineNumber-1,L=[];L.push(this._lines[v].substring(i.startColumn-1));for(let A=v+1;A<d;A++)L.push(this._lines[A]);return L.push(this._lines[d].substring(0,i.endColumn-1)),L.join(a)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const a=this._lineStarts.getIndexOf(i),v=this._lines[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,v)}}_validateRange(i){const a=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),v=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return a.lineNumber!==i.startLineNumber||a.column!==i.startColumn||v.lineNumber!==i.endLineNumber||v.column!==i.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:v.lineNumber,endColumn:v.column}:i}_validatePosition(i){if(!r.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:a,column:v}=i,d=!1;if(a<1)a=1,v=1,d=!0;else if(a>this._lines.length)a=this._lines.length,v=this._lines[a-1].length+1,d=!0;else{const L=this._lines[a-1].length+1;v<1?(v=1,d=!0):v>L&&(v=L,d=!0)}return d?{lineNumber:a,column:v}:i}}class c{constructor(i,a){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=a,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(a=>i.push(this._models[a])),i}acceptNewModel(i){this._models[i.url]=new _(F.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,a){if(!this._models[i])return;this._models[i].onEvents(a)}acceptRemovedModel(i){this._models[i]&&delete this._models[i]}async computeUnicodeHighlights(i,a,v){const d=this._getModel(i);return d?b.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,a,v):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,a,v,d){const L=this._getModel(i),A=this._getModel(a);return!L||!A?null:c.computeDiff(L,A,v,d)}static computeDiff(i,a,v,d){const L=d==="advanced"?e.linesDiffComputers.getDefault():e.linesDiffComputers.getLegacy(),A=i.getLinesContent(),R=a.getLinesContent(),D=L.computeDiff(A,R,v),k=D.changes.length>0?!1:this._modelsAreIdentical(i,a);function y(S){return S.map(C=>[C.original.startLineNumber,C.original.endLineNumberExclusive,C.modified.startLineNumber,C.modified.endLineNumberExclusive,C.innerChanges?.map(O=>[O.originalRange.startLineNumber,O.originalRange.startColumn,O.originalRange.endLineNumber,O.originalRange.endColumn,O.modifiedRange.startLineNumber,O.modifiedRange.startColumn,O.modifiedRange.endLineNumber,O.modifiedRange.endColumn])])}return{identical:k,quitEarly:D.hitTimeout,changes:y(D.changes),moves:D.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,y(S.changes)])}}static _modelsAreIdentical(i,a){const v=i.getLineCount(),d=a.getLineCount();if(v!==d)return!1;for(let L=1;L<=v;L++){const A=i.getLineContent(L),R=a.getLineContent(L);if(A!==R)return!1}return!0}async computeDirtyDiff(i,a,v){const d=this._getModel(i),L=this._getModel(a);if(!d||!L)return null;const A=d.getLinesContent(),R=L.getLinesContent();return new m.DiffComputer(A,R,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:v,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(i,a,v){const d=this._getModel(i);if(!d)return a;const L=[];let A;a=a.slice(0).sort((D,k)=>{if(D.range&&k.range)return f.Range.compareRangesUsingStarts(D.range,k.range);const y=D.range?0:1,S=k.range?0:1;return y-S});let R=0;for(let D=1;D<a.length;D++)f.Range.getEndPosition(a[R].range).equals(f.Range.getStartPosition(a[D].range))?(a[R].range=f.Range.fromPositions(f.Range.getStartPosition(a[R].range),f.Range.getEndPosition(a[D].range)),a[R].text+=a[D].text):(R++,a[R]=a[D]);a.length=R+1;for(let{range:D,text:k,eol:y}of a){if(typeof y=="number"&&(A=y),f.Range.isEmpty(D)&&!k)continue;const S=d.getValueInRange(D);if(k=k.replace(/\r\n|\n|\r/g,d.eol),S===k)continue;if(Math.max(k.length,S.length)>c._diffLimit){L.push({range:D,text:k});continue}const C=(0,P.stringDiff)(S,k,v),O=d.offsetAt(f.Range.lift(D).getStartPosition());for(const H of C){const T=d.positionAt(O+H.originalStart),q=d.positionAt(O+H.originalStart+H.originalLength),$={text:k.substr(H.modifiedStart,H.modifiedLength),range:{startLineNumber:T.lineNumber,startColumn:T.column,endLineNumber:q.lineNumber,endColumn:q.column}};d.getValueInRange($.range)!==$.text&&L.push($)}}return typeof A=="number"&&L.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}computeHumanReadableDiff(i,a,v){const d=this._getModel(i);if(!d)return a;const L=[];let A;a=a.slice(0).sort((R,D)=>{if(R.range&&D.range)return f.Range.compareRangesUsingStarts(R.range,D.range);const k=R.range?0:1,y=D.range?0:1;return k-y});for(let{range:R,text:D,eol:k}of a){let T=function($,V){return new r.Position($.lineNumber+V.lineNumber-1,V.lineNumber===1?$.column+V.column-1:V.column)},q=function($,V){const Y=[];for(let n=V.startLineNumber;n<=V.endLineNumber;n++){const te=$[n-1];n===V.startLineNumber&&n===V.endLineNumber?Y.push(te.substring(V.startColumn-1,V.endColumn-1)):n===V.startLineNumber?Y.push(te.substring(V.startColumn-1)):n===V.endLineNumber?Y.push(te.substring(0,V.endColumn-1)):Y.push(te)}return Y};if(typeof k=="number"&&(A=k),f.Range.isEmpty(R)&&!D)continue;const y=d.getValueInRange(R);if(D=D.replace(/\r\n|\n|\r/g,d.eol),y===D)continue;if(Math.max(D.length,y.length)>c._diffLimit){L.push({range:R,text:D});continue}const S=y.split(/\r\n|\n|\r/),C=D.split(/\r\n|\n|\r/),O=e.linesDiffComputers.getDefault().computeDiff(S,C,v),H=f.Range.lift(R).getStartPosition();for(const $ of O.changes)if($.innerChanges)for(const V of $.innerChanges)L.push({range:f.Range.fromPositions(T(H,V.originalRange.getStartPosition()),T(H,V.originalRange.getEndPosition())),text:q(C,V.modifiedRange).join(d.eol)});else throw new E.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof A=="number"&&L.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(i){const a=this._getModel(i);return a?(0,u.computeLinks)(a):null}async computeDefaultDocumentColors(i){const a=this._getModel(i);return a?(0,M.computeDefaultDocumentColors)(a):null}static{this._suggestionsLimit=1e4}async textualSuggest(i,a,v,d){const L=new N.StopWatch,A=new RegExp(v,d),R=new Set;e:for(const D of i){const k=this._getModel(D);if(k){for(const y of k.words(A))if(!(y===a||!isNaN(Number(y)))&&(R.add(y),R.size>c._suggestionsLimit))break e}}return{words:Array.from(R),duration:L.elapsed()}}async computeWordRanges(i,a,v,d){const L=this._getModel(i);if(!L)return Object.create(null);const A=new RegExp(v,d),R=Object.create(null);for(let D=a.startLineNumber;D<a.endLineNumber;D++){const k=L.getLineWords(D,A);for(const y of k){if(!isNaN(Number(y.word)))continue;let S=R[y.word];S||(S=[],R[y.word]=S),S.push({startLineNumber:D,startColumn:y.startColumn,endLineNumber:D,endColumn:y.endColumn})}}return R}async navigateValueSet(i,a,v,d,L){const A=this._getModel(i);if(!A)return null;const R=new RegExp(d,L);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const D=A.getValueInRange(a),k=A.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},R);if(!k)return null;const y=A.getValueInRange(k);return l.BasicInplaceReplace.INSTANCE.navigateValueSet(a,D,k,y,v)}loadForeignModule(i,a,v){const d=(R,D)=>this._host.fhr(R,D),A={host:(0,p.createProxyObject)(v,d),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(A,a),Promise.resolve((0,p.getAllMethodNames)(this._foreignModule))):new Promise((R,D)=>{B([i],k=>{this._foreignModule=k.create(A,a),R((0,p.getAllMethodNames)(this._foreignModule))},D)})}fmr(i,a){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,a))}catch(v){return Promise.reject(v)}}}t.EditorSimpleWorker=c;function o(s){return new c(s,null)}t.create=o,typeof importScripts=="function"&&(globalThis.monaco=(0,g.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dd29bdcb71634f9cd7c1792bb2bdfde5b18ee8e8/core/vs/base/worker/workerMain.js.map
