/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ne=function(G){for(var e=[],C=0,L=G.length;C<L;C++)e[C]=ie[G[C]];return e};define(ie[134],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function C(p,v,m){const f=L(p,v);if(f!==-1)return p[f]}e.findLast=C;function L(p,v,m=p.length-1){for(let f=m;f>=0;f--){const d=p[f];if(v(d))return f}return-1}e.findLastIdx=L;function r(p,v){const m=A(p,v);return m===-1?void 0:p[m]}e.findLastMonotonous=r;function A(p,v,m=0,f=p.length){let d=m,E=f;for(;d<E;){const c=Math.floor((d+E)/2);v(p[c])?d=c+1:E=c}return d-1}e.findLastIdxMonotonous=A;function R(p,v){const m=I(p,v);return m===p.length?void 0:p[m]}e.findFirstMonotonous=R;function I(p,v,m=0,f=p.length){let d=m,E=f;for(;d<E;){const c=Math.floor((d+E)/2);v(p[c])?E=c:d=c+1}return d}e.findFirstIdxMonotonousOrArrLen=I;function u(p,v,m=0,f=p.length){const d=I(p,v,m,f);return d===p.length?-1:d}e.findFirstIdxMonotonous=u;class a{static{this.assertInvariants=!1}constructor(v){this._array=v,this._findLastMonotonousLastIdx=0}findLastMonotonous(v){if(a.assertInvariants){if(this._prevFindLastPredicate){for(const f of this._array)if(this._prevFindLastPredicate(f)&&!v(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=v}const m=A(this._array,v,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=m+1,m===-1?void 0:this._array[m]}}e.MonotonousArray=a;function g(p,v){if(p.length===0)return;let m=p[0];for(let f=1;f<p.length;f++){const d=p[f];v(d,m)>0&&(m=d)}return m}e.findFirstMaxBy=g;function w(p,v){if(p.length===0)return;let m=p[0];for(let f=1;f<p.length;f++){const d=p[f];v(d,m)>=0&&(m=d)}return m}e.findLastMaxBy=w;function y(p,v){return g(p,(m,f)=>-v(m,f))}e.findFirstMinBy=y;function h(p,v){if(p.length===0)return-1;let m=0;for(let f=1;f<p.length;f++){const d=p[f];v(d,p[m])>0&&(m=f)}return m}e.findMaxIdxBy=h;function b(p,v){for(const m of p){const f=v(m);if(f!==void 0)return f}}e.mapFindFirst=b}),define(ie[135],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function C(R,I){const u=Object.create(null);for(const a of R){const g=I(a);let w=u[g];w||(w=u[g]=[]),w.push(a)}return u}e.groupBy=C;function L(R,I){const u=[],a=[];for(const g of R)I.has(g)||u.push(g);for(const g of I)R.has(g)||a.push(g);return{removed:u,added:a}}e.diffSets=L;function r(R,I){const u=[],a=[];for(const[g,w]of R)I.has(g)||u.push(w);for(const[g,w]of I)R.has(g)||a.push(w);return{removed:u,added:a}}e.diffMaps=r;function A(R,I){const u=new Set;for(const a of I)R.has(a)&&u.add(a);return u}e.intersection=A}),define(ie[136],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function C(I,u){const a=Math.pow(10,u);return Math.round(I*a)/a}class L{constructor(u,a,g,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=C(Math.max(Math.min(1,w),0),3)}static equals(u,a){return u.r===a.r&&u.g===a.g&&u.b===a.b&&u.a===a.a}}e.RGBA=L;class r{constructor(u,a,g,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=C(Math.max(Math.min(1,a),0),3),this.l=C(Math.max(Math.min(1,g),0),3),this.a=C(Math.max(Math.min(1,w),0),3)}static equals(u,a){return u.h===a.h&&u.s===a.s&&u.l===a.l&&u.a===a.a}static fromRGBA(u){const a=u.r/255,g=u.g/255,w=u.b/255,y=u.a,h=Math.max(a,g,w),b=Math.min(a,g,w);let p=0,v=0;const m=(b+h)/2,f=h-b;if(f>0){switch(v=Math.min(m<=.5?f/(2*m):f/(2-2*m),1),h){case a:p=(g-w)/f+(g<w?6:0);break;case g:p=(w-a)/f+2;break;case w:p=(a-g)/f+4;break}p*=60,p=Math.round(p)}return new r(p,v,m,y)}static _hue2rgb(u,a,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?u+(a-u)*6*g:g<1/2?a:g<2/3?u+(a-u)*(2/3-g)*6:u}static toRGBA(u){const a=u.h/360,{s:g,l:w,a:y}=u;let h,b,p;if(g===0)h=b=p=w;else{const v=w<.5?w*(1+g):w+g-w*g,m=2*w-v;h=r._hue2rgb(m,v,a+1/3),b=r._hue2rgb(m,v,a),p=r._hue2rgb(m,v,a-1/3)}return new L(Math.round(h*255),Math.round(b*255),Math.round(p*255),y)}}e.HSLA=r;class A{constructor(u,a,g,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=C(Math.max(Math.min(1,a),0),3),this.v=C(Math.max(Math.min(1,g),0),3),this.a=C(Math.max(Math.min(1,w),0),3)}static equals(u,a){return u.h===a.h&&u.s===a.s&&u.v===a.v&&u.a===a.a}static fromRGBA(u){const a=u.r/255,g=u.g/255,w=u.b/255,y=Math.max(a,g,w),h=Math.min(a,g,w),b=y-h,p=y===0?0:b/y;let v;return b===0?v=0:y===a?v=((g-w)/b%6+6)%6:y===g?v=(w-a)/b+2:v=(a-g)/b+4,new A(Math.round(v*60),p,y,u.a)}static toRGBA(u){const{h:a,s:g,v:w,a:y}=u,h=w*g,b=h*(1-Math.abs(a/60%2-1)),p=w-h;let[v,m,f]=[0,0,0];return a<60?(v=h,m=b):a<120?(v=b,m=h):a<180?(m=h,f=b):a<240?(m=b,f=h):a<300?(v=b,f=h):a<=360&&(v=h,f=b),v=Math.round((v+p)*255),m=Math.round((m+p)*255),f=Math.round((f+p)*255),new L(v,m,f,y)}}e.HSVA=A;class R{static fromHex(u){return R.Format.CSS.parseHex(u)||R.red}static equals(u,a){return!u&&!a?!0:!u||!a?!1:u.equals(a)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:A.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof L)this.rgba=u;else if(u instanceof r)this._hsla=u,this.rgba=r.toRGBA(u);else if(u instanceof A)this._hsva=u,this.rgba=A.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&L.equals(this.rgba,u.rgba)&&r.equals(this.hsla,u.hsla)&&A.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=R._relativeLuminanceForComponent(this.rgba.r),a=R._relativeLuminanceForComponent(this.rgba.g),g=R._relativeLuminanceForComponent(this.rgba.b),w=.2126*u+.7152*a+.0722*g;return C(w,4)}static _relativeLuminanceForComponent(u){const a=u/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(u){const a=this.getRelativeLuminance(),g=u.getRelativeLuminance();return a>g?(a+.05)/(g+.05):(g+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const a=this.getRelativeLuminance(),g=u.getRelativeLuminance();return a>g}isDarkerThan(u){const a=this.getRelativeLuminance(),g=u.getRelativeLuminance();return a<g}lighten(u){return new R(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new R(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:a,g,b:w,a:y}=this.rgba;return new R(new L(a,g,w,y*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const a=u.rgba,g=this.rgba.a,w=a.a,y=g+w*(1-g);if(y<1e-6)return R.transparent;const h=this.rgba.r*g/y+a.r*w*(1-g)/y,b=this.rgba.g*g/y+a.g*w*(1-g)/y,p=this.rgba.b*g/y+a.b*w*(1-g)/y;return new R(new L(h,b,p,y))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:a,g,b:w,a:y}=this.rgba;return new R(new L(u.rgba.r-y*(u.rgba.r-a),u.rgba.g-y*(u.rgba.g-g),u.rgba.b-y*(u.rgba.b-w),1))}flatten(...u){const a=u.reduceRight((g,w)=>R._flatten(w,g));return R._flatten(this,a)}static _flatten(u,a){const g=1-u.rgba.a;return new R(new L(g*a.rgba.r+u.rgba.a*u.rgba.r,g*a.rgba.g+u.rgba.a*u.rgba.g,g*a.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=R.Format.CSS.format(this)),this._toString}static getLighterColor(u,a,g){if(u.isLighterThan(a))return u;g=g||.5;const w=u.getRelativeLuminance(),y=a.getRelativeLuminance();return g=g*(y-w)/y,u.lighten(g)}static getDarkerColor(u,a,g){if(u.isDarkerThan(a))return u;g=g||.5;const w=u.getRelativeLuminance(),y=a.getRelativeLuminance();return g=g*(w-y)/w,u.darken(g)}static{this.white=new R(new L(255,255,255,1))}static{this.black=new R(new L(0,0,0,1))}static{this.red=new R(new L(255,0,0,1))}static{this.blue=new R(new L(0,0,255,1))}static{this.green=new R(new L(0,255,0,1))}static{this.cyan=new R(new L(0,255,255,1))}static{this.lightgrey=new R(new L(211,211,211,1))}static{this.transparent=new R(new L(0,0,0,0))}}e.Color=R,function(I){let u;(function(a){let g;(function(w){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:I.Format.CSS.formatRGBA(i)}w.formatRGB=y;function h(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}w.formatRGBA=h;function b(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(i)}w.formatHSL=b;function p(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}w.formatHSLA=p;function v(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function m(i){return`#${v(i.rgba.r)}${v(i.rgba.g)}${v(i.rgba.b)}`}w.formatHex=m;function f(i,o=!1){return o&&i.rgba.a===1?I.Format.CSS.formatHex(i):`#${v(i.rgba.r)}${v(i.rgba.g)}${v(i.rgba.b)}${v(Math.round(i.rgba.a*255))}`}w.formatHexA=f;function d(i){return i.isOpaque()?I.Format.CSS.formatHex(i):I.Format.CSS.formatRGBA(i)}w.format=d;function E(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const s=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),t=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),n=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new I(new L(s,t,n,1))}if(o===9){const s=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),t=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),n=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),l=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new I(new L(s,t,n,l/255))}if(o===4){const s=c(i.charCodeAt(1)),t=c(i.charCodeAt(2)),n=c(i.charCodeAt(3));return new I(new L(16*s+s,16*t+t,16*n+n))}if(o===5){const s=c(i.charCodeAt(1)),t=c(i.charCodeAt(2)),n=c(i.charCodeAt(3)),l=c(i.charCodeAt(4));return new I(new L(16*s+s,16*t+t,16*n+n,(16*l+l)/255))}return null}w.parseHex=E;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=a.CSS||(a.CSS={}))})(u=I.Format||(I.Format={}))}(R||(e.Color=R={}))}),define(ie[54],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function C(R){return(I,u,a)=>{let g=null,w=null;if(typeof a.value=="function"?(g="value",w=a.value):typeof a.get=="function"&&(g="get",w=a.get),!w)throw new Error("not supported");a[g]=R(w,u)}}function L(R,I,u){let a=null,g=null;if(typeof u.value=="function"?(a="value",g=u.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",g=u.get),!g)throw new Error("not supported");const w=`$memoize$${I}`;u[a]=function(...y){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,y)}),this[w]}}e.memoize=L;function r(R,I,u){return C((a,g)=>{const w=`$debounce$${g}`,y=`$debounce$result$${g}`;return function(...h){this[y]||(this[y]=u?u():void 0),clearTimeout(this[w]),I&&(this[y]=I(this[y],...h),h=[this[y]]),this[w]=setTimeout(()=>{a.apply(this,h),this[y]=u?u():void 0},R)}})}e.debounce=r;function A(R,I,u){return C((a,g)=>{const w=`$throttle$timer$${g}`,y=`$throttle$result$${g}`,h=`$throttle$lastRun$${g}`,b=`$throttle$pending$${g}`;return function(...p){if(this[y]||(this[y]=u?u():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[y]=I(this[y],...p)),this[b])return;const v=this[h]+R;v<=Date.now()?(this[h]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0):(this[b]=!0,this[w]=setTimeout(()=>{this[b]=!1,this[h]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0},v-Date.now()))}})}e.throttle=A}),define(ie[14],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class C{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=C,e.errorHandler=new C;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function r(c){if(!c||typeof c!="object")return!1;const i=c;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function A(c){a(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=A;function R(c){a(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function I(c){if(c instanceof Error){const{name:i,message:o}=c,s=c.stacktrace||c.stack;return{$isError:!0,name:i,message:o,stack:s,noTelemetry:d.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=I;const u="Canceled";function a(c){return c instanceof g?!0:c instanceof Error&&c.name===u&&c.message===u}e.isCancellationError=a;class g extends Error{constructor(){super(u),this.name=this.message}}e.CancellationError=g;function w(){const c=new Error(u);return c.name=c.message,c}e.canceled=w;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=y;function h(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=h;class b extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=b;function p(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=p;class v extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=v;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const o=new d;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=d;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.BugIndicatingError=E}),define(ie[23],ne([0,1,14,134]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(T,$=0){return T[T.length-(1+$)]}e.tail=r;function A(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=A;function R(T,$,x=(ae,fe)=>ae===fe){if(T===$)return!0;if(!T||!$||T.length!==$.length)return!1;for(let ae=0,fe=T.length;ae<fe;ae++)if(!x(T[ae],$[ae]))return!1;return!0}e.equals=R;function I(T,$){const x=T.length-1;$<x&&(T[$]=T[x]),T.pop()}e.removeFastWithoutKeepingOrder=I;function u(T,$,x){return a(T.length,ae=>x(T[ae],$))}e.binarySearch=u;function a(T,$){let x=0,ae=T-1;for(;x<=ae;){const fe=(x+ae)/2|0,ue=$(fe);if(ue<0)x=fe+1;else if(ue>0)ae=fe-1;else return fe}return-(x+1)}e.binarySearch2=a;function g(T,$,x){if(T=T|0,T>=$.length)throw new TypeError("invalid index");const ae=$[Math.floor($.length*Math.random())],fe=[],ue=[],de=[];for(const be of $){const we=x(be,ae);we<0?fe.push(be):we>0?ue.push(be):de.push(be)}return T<fe.length?g(T,fe,x):T<fe.length+de.length?de[0]:g(T-(fe.length+de.length),ue,x)}e.quickSelect=g;function w(T,$){const x=[];let ae;for(const fe of T.slice(0).sort($))!ae||$(ae[0],fe)!==0?(ae=[fe],x.push(ae)):ae.push(fe);return x}e.groupBy=w;function*y(T,$){let x,ae;for(const fe of T)ae!==void 0&&$(ae,fe)?x.push(fe):(x&&(yield x),x=[fe]),ae=fe;x&&(yield x)}e.groupAdjacentBy=y;function h(T,$){for(let x=0;x<=T.length;x++)$(x===0?void 0:T[x-1],x===T.length?void 0:T[x])}e.forEachAdjacent=h;function b(T,$){for(let x=0;x<T.length;x++)$(x===0?void 0:T[x-1],T[x],x+1===T.length?void 0:T[x+1])}e.forEachWithNeighbors=b;function p(T,$,x){const ae=[];function fe(be,we,ye){if(we===0&&ye.length===0)return;const ke=ae[ae.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=we,ke.toInsert.push(...ye)):ae.push({start:be,deleteCount:we,toInsert:ye})}let ue=0,de=0;for(;;){if(ue===T.length){fe(ue,0,$.slice(de));break}if(de===$.length){fe(ue,T.length-ue,[]);break}const be=T[ue],we=$[de],ye=x(be,we);ye===0?(ue+=1,de+=1):ye<0?(fe(ue,1,[]),ue+=1):ye>0&&(fe(ue,0,[we]),de+=1)}return ae}e.sortedDiff=p;function v(T,$,x){const ae=p(T,$,x),fe=[],ue=[];for(const de of ae)fe.push(...T.slice(de.start,de.start+de.deleteCount)),ue.push(...de.toInsert);return{removed:fe,added:ue}}e.delta=v;function m(T,$,x){if(x===0)return[];const ae=T.slice(0,x).sort($);return d(T,$,ae,x,T.length),ae}e.top=m;function f(T,$,x,ae,fe){return x===0?Promise.resolve([]):new Promise((ue,de)=>{(async()=>{const be=T.length,we=T.slice(0,x).sort($);for(let ye=x,ke=Math.min(x+ae,be);ye<be;ye=ke,ke=Math.min(ke+ae,be)){if(ye>x&&await new Promise(Be=>setTimeout(Be)),fe&&fe.isCancellationRequested)throw new C.CancellationError;d(T,$,we,ye,ke)}return we})().then(ue,de)})}e.topAsync=f;function d(T,$,x,ae,fe){for(const ue=x.length;ae<fe;ae++){const de=T[ae];if($(de,x[ue-1])<0){x.pop();const be=(0,L.findFirstIdxMonotonousOrArrLen)(x,we=>$(de,we)<0);x.splice(be,0,de)}}}function E(T){return T.filter($=>!!$)}e.coalesce=E;function c(T){let $=0;for(let x=0;x<T.length;x++)T[x]&&(T[$]=T[x],$+=1);T.length=$}e.coalesceInPlace=c;function i(T,$,x){T.splice(x,0,T.splice($,1)[0])}e.move=i;function o(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=o;function s(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=s;function t(T,$=x=>x){const x=new Set;return T.filter(ae=>{const fe=$(ae);return x.has(fe)?!1:(x.add(fe),!0)})}e.distinct=t;function n(T){const $=new Set;return x=>{const ae=T(x);return $.has(ae)?!1:($.add(ae),!0)}}e.uniqueFilter=n;function l(T,$){return T.length>0?T[0]:$}e.firstOrDefault=l;function S(T,$){return T.length>0?T[T.length-1]:$}e.lastOrDefault=S;function D(T,$,x=(ae,fe)=>ae===fe){let ae=0;for(let fe=0,ue=Math.min(T.length,$.length);fe<ue&&x(T[fe],$[fe]);fe++)ae++;return ae}e.commonPrefixLength=D;function M(T){return[].concat(...T)}e.flatten=M;function P(T,$){let x=typeof $=="number"?T:0;typeof $=="number"?x=T:(x=0,$=T);const ae=[];if(x<=$)for(let fe=x;fe<$;fe++)ae.push(fe);else for(let fe=x;fe>$;fe--)ae.push(fe);return ae}e.range=P;function k(T,$,x){return T.reduce((ae,fe)=>(ae[$(fe)]=x?x(fe):fe,ae),Object.create(null))}e.index=k;function O(T,$){return T.push($),()=>F(T,$)}e.insert=O;function F(T,$){const x=T.indexOf($);if(x>-1)return T.splice(x,1),$}e.remove=F;function z(T,$,x){const ae=T.slice(0,$),fe=T.slice($);return ae.concat(x,fe)}e.arrayInsert=z;function Y(T,$){let x;if(typeof $=="number"){let ae=$;x=()=>{const fe=Math.sin(ae++)*179426549;return fe-Math.floor(fe)}}else x=Math.random;for(let ae=T.length-1;ae>0;ae-=1){const fe=Math.floor(x()*(ae+1)),ue=T[ae];T[ae]=T[fe],T[fe]=ue}}e.shuffle=Y;function J(T,$){const x=T.indexOf($);x>-1&&(T.splice(x,1),T.unshift($))}e.pushToStart=J;function oe(T,$){const x=T.indexOf($);x>-1&&(T.splice(x,1),T.push($))}e.pushToEnd=oe;function re(T,$){for(const x of $)T.push(x)}e.pushMany=re;function ce(T,$){return Array.isArray(T)?T.map($):$(T)}e.mapArrayOrNot=ce;function Q(T){return Array.isArray(T)?T:[T]}e.asArray=Q;function K(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=K;function V(T,$,x){const ae=N(T,$),fe=T.length,ue=x.length;T.length=fe+ue;for(let de=fe-1;de>=ae;de--)T[de+ue]=T[de];for(let de=0;de<ue;de++)T[de+ae]=x[de]}e.insertInto=V;function q(T,$,x,ae){const fe=N(T,$);let ue=T.splice(fe,x);return ue===void 0&&(ue=[]),V(T,fe,ae),ue}e.splice=q;function N(T,$){return $<0?Math.max($+T.length,0):Math.min($,T.length)}var j;(function(T){function $(ue){return ue<0}T.isLessThan=$;function x(ue){return ue<=0}T.isLessThanOrEqual=x;function ae(ue){return ue>0}T.isGreaterThan=ae;function fe(ue){return ue===0}T.isNeitherLessOrGreaterThan=fe,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(j||(e.CompareResult=j={}));function H(T,$){return(x,ae)=>$(T(x),T(ae))}e.compareBy=H;function X(...T){return($,x)=>{for(const ae of T){const fe=ae($,x);if(!j.isNeitherLessOrGreaterThan(fe))return fe}return j.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const se=(T,$)=>T-$;e.numberComparator=se;const W=(T,$)=>(0,e.numberComparator)(T?1:0,$?1:0);e.booleanComparator=W;function _(T){return($,x)=>-T($,x)}e.reverseOrder=_;class U{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let x=this.firstIdx;for(;x<this.items.length&&$(this.items[x]);)x++;const ae=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,ae}takeFromEndWhile($){let x=this.lastIdx;for(;x>=0&&$(this.items[x]);)x--;const ae=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,ae}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}removeLast(){const $=this.items[this.lastIdx];return this.lastIdx--,$}takeCount($){const x=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,x}}e.ArrayQueue=U;class B{static{this.empty=new B($=>{})}constructor($){this.iterate=$}forEach($){this.iterate(x=>($(x),!0))}toArray(){const $=[];return this.iterate(x=>($.push(x),!0)),$}filter($){return new B(x=>this.iterate(ae=>$(ae)?x(ae):!0))}map($){return new B(x=>this.iterate(ae=>x($(ae))))}some($){let x=!1;return this.iterate(ae=>(x=$(ae),!x)),x}findFirst($){let x;return this.iterate(ae=>$(ae)?(x=ae,!1):!0),x}findLast($){let x;return this.iterate(ae=>($(ae)&&(x=ae),!0)),x}findLastMaxBy($){let x,ae=!0;return this.iterate(fe=>((ae||j.isGreaterThan($(fe,x)))&&(ae=!1,x=fe),!0)),x}}e.CallbackIterable=B}),define(ie[137],ne([0,1,14]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(u,a){if(!u)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=L;function r(u,a="Unreachable"){throw new Error(a)}e.assertNever=r;function A(u){if(!u)throw new C.BugIndicatingError("Assertion Failed")}e.assert=A;function R(u){if(!u()){debugger;u(),(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function I(u,a){let g=0;for(;g<u.length-1;){const w=u[g],y=u[g+1];if(!a(w,y))return!1;g++}return!0}e.checkAdjacentItems=I}),define(ie[84],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function C(L){const r=this;let A=!1,R;return function(){return A||(A=!0,R=L.apply(r,arguments)),R}}e.createSingleCallFunction=C}),define(ie[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(L){function r(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=r;const A=Object.freeze([]);function R(){return A}L.empty=R;function*I(c){yield c}L.single=I;function u(c){return r(c)?c:I(c)}L.wrap=u;function a(c){return c||A}L.from=a;function*g(c){for(let i=c.length-1;i>=0;i--)yield c[i]}L.reverse=g;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function y(c){return c[Symbol.iterator]().next().value}L.first=y;function h(c,i){for(const o of c)if(i(o))return!0;return!1}L.some=h;function b(c,i){for(const o of c)if(i(o))return o}L.find=b;function*p(c,i){for(const o of c)i(o)&&(yield o)}L.filter=p;function*v(c,i){let o=0;for(const s of c)yield i(s,o++)}L.map=v;function*m(...c){for(const i of c)for(const o of i)yield o}L.concat=m;function f(c,i,o){let s=o;for(const t of c)s=i(s,t);return s}L.reduce=f;function*d(c,i,o=c.length){for(i<0&&(i+=c.length),o<0?o+=c.length:o>c.length&&(o=c.length);i<o;i++)yield c[i]}L.slice=d;function E(c,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,c];const s=c[Symbol.iterator]();for(let t=0;t<i;t++){const n=s.next();if(n.done)return[o,L.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return s}}]}L.consume=E})(C||(e.Iterable=C={}))}),define(ie[44],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var r;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(i,o=!1){let s=0;const t=i.length;let n="",l=0,S=16,D=0;function M(J){let oe=0,re=0;for(;oe<J;){const ce=i.charCodeAt(s);if(ce>=48&&ce<=57)re=re*16+ce-48;else if(ce>=65&&ce<=70)re=re*16+ce-65+10;else if(ce>=97&&ce<=102)re=re*16+ce-97+10;else break;s++,oe++}return oe<J&&(re=-1),re}function P(J){s=J,n="",l=0,S=16,D=0}function k(){const J=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&a(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&a(i.charCodeAt(s)))for(s++;s<i.length&&a(i.charCodeAt(s));)s++;else return D=3,i.substring(J,s);let oe=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&a(i.charCodeAt(s))){for(s++;s<i.length&&a(i.charCodeAt(s));)s++;oe=s}else D=3;return i.substring(J,oe)}function O(){let J="",oe=s;for(;;){if(s>=t){J+=i.substring(oe,s),D=2;break}const re=i.charCodeAt(s);if(re===34){J+=i.substring(oe,s),s++;break}if(re===92){if(J+=i.substring(oe,s),s++,s>=t){D=2;break}switch(i.charCodeAt(s++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const Q=M(4);Q>=0?J+=String.fromCharCode(Q):D=4;break}default:D=5}oe=s;continue}if(re>=0&&re<=31)if(u(re)){J+=i.substring(oe,s),D=2;break}else D=6;s++}return J}function F(){if(n="",D=0,l=s,s>=t)return l=t,S=17;let J=i.charCodeAt(s);if(I(J)){do s++,n+=String.fromCharCode(J),J=i.charCodeAt(s);while(I(J));return S=15}if(u(J))return s++,n+=String.fromCharCode(J),J===13&&i.charCodeAt(s)===10&&(s++,n+=`
`),S=14;switch(J){case 123:return s++,S=1;case 125:return s++,S=2;case 91:return s++,S=3;case 93:return s++,S=4;case 58:return s++,S=6;case 44:return s++,S=5;case 34:return s++,n=O(),S=10;case 47:{const oe=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<t&&!u(i.charCodeAt(s));)s++;return n=i.substring(oe,s),S=12}if(i.charCodeAt(s+1)===42){s+=2;const re=t-1;let ce=!1;for(;s<re;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,ce=!0;break}s++}return ce||(s++,D=1),n=i.substring(oe,s),S=13}return n+=String.fromCharCode(J),s++,S=16}case 45:if(n+=String.fromCharCode(J),s++,s===t||!a(i.charCodeAt(s)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=k(),S=11;default:for(;s<t&&z(J);)s++,J=i.charCodeAt(s);if(l!==s){switch(n=i.substring(l,s),n){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return n+=String.fromCharCode(J),s++,S=16}}function z(J){if(I(J)||u(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let J;do J=F();while(J>=12&&J<=15);return J}return{setPosition:P,getPosition:()=>s,scan:o?Y:F,getToken:()=>S,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>D}}e.createScanner=R;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function w(i,o){const s=[],t=new Object;let n;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(M,P,k,O){l.value=M,l.offset=P,l.length=k,l.type=O,l.colonOffset=void 0,n=l}try{d(i,{onObjectBegin:(M,P)=>{if(o<=M)throw t;n=void 0,S=o>M,s.push("")},onObjectProperty:(M,P,k)=>{if(o<P||(D(M,P,k,"property"),s[s.length-1]=M,o<=P+k))throw t},onObjectEnd:(M,P)=>{if(o<=M)throw t;n=void 0,s.pop()},onArrayBegin:(M,P)=>{if(o<=M)throw t;n=void 0,s.push(0)},onArrayEnd:(M,P)=>{if(o<=M)throw t;n=void 0,s.pop()},onLiteralValue:(M,P,k)=>{if(o<P||(D(M,P,k,c(M)),o<=P+k))throw t},onSeparator:(M,P,k)=>{if(o<=P)throw t;if(M===":"&&n&&n.type==="property")n.colonOffset=P,S=!1,n=void 0;else if(M===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(S=!0,s[s.length-1]=""),n=void 0}}})}catch(M){if(M!==t)throw M}return{path:s,previousNode:n,isAtPropertyKey:S,matches:M=>{let P=0;for(let k=0;P<M.length&&k<s.length;k++)if(M[P]===s[k]||M[P]==="*")P++;else if(M[P]!=="**")return!1;return P===M.length}}}e.getLocation=w;function y(i,o=[],s=A.DEFAULT){let t=null,n=[];const l=[];function S(M){Array.isArray(n)?n.push(M):t!==null&&(n[t]=M)}return d(i,{onObjectBegin:()=>{const M={};S(M),l.push(n),n=M,t=null},onObjectProperty:M=>{t=M},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{const M=[];S(M),l.push(n),n=M,t=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:S,onError:(M,P,k)=>{o.push({error:M,offset:P,length:k})}},s),n[0]}e.parse=y;function h(i,o=[],s=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(M){t.type==="property"&&(t.length=M-t.offset,t=t.parent)}function l(M){return t.children.push(M),M}d(i,{onObjectBegin:M=>{t=l({type:"object",offset:M,length:-1,parent:t,children:[]})},onObjectProperty:(M,P,k)=>{t=l({type:"property",offset:P,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:M,offset:P,length:k,parent:t})},onObjectEnd:(M,P)=>{t.length=M+P-t.offset,t=t.parent,n(M+P)},onArrayBegin:(M,P)=>{t=l({type:"array",offset:M,length:-1,parent:t,children:[]})},onArrayEnd:(M,P)=>{t.length=M+P-t.offset,t=t.parent,n(M+P)},onLiteralValue:(M,P,k)=>{l({type:c(M),offset:P,length:k,parent:t,value:M}),n(P+k)},onSeparator:(M,P,k)=>{t.type==="property"&&(M===":"?t.colonOffset=P:M===","&&n(P))},onError:(M,P,k)=>{o.push({error:M,offset:P,length:k})}},s);const D=t.children[0];return D&&delete D.parent,D}e.parseTree=h;function b(i,o){if(!i)return;let s=i;for(const t of o)if(typeof t=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===t){s=l.children[1],n=!0;break}if(!n)return}else{const n=t;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}e.findNodeAtLocation=b;function p(i){if(!i.parent||!i.parent.children)return[];const o=p(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}e.getNodePath=p;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const o=Object.create(null);for(const s of i.children){const t=s.children[1];t&&(o[s.children[0].value]=v(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function m(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}e.contains=m;function f(i,o,s=!1){if(m(i,o,s)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=o;n++){const l=f(t[n],o,s);if(l)return l}return i}}e.findNodeAtOffset=f;function d(i,o,s=A.DEFAULT){const t=R(i,!1);function n(H){return H?()=>H(t.getTokenOffset(),t.getTokenLength()):()=>!0}function l(H){return H?X=>H(X,t.getTokenOffset(),t.getTokenLength()):()=>!0}const S=n(o.onObjectBegin),D=l(o.onObjectProperty),M=n(o.onObjectEnd),P=n(o.onArrayBegin),k=n(o.onArrayEnd),O=l(o.onLiteralValue),F=l(o.onSeparator),z=n(o.onComment),Y=l(o.onError),J=s&&s.disallowComments,oe=s&&s.allowTrailingComma;function re(){for(;;){const H=t.scan();switch(t.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:J||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(H){case 12:case 13:J?ce(10):z();break;case 16:ce(1);break;case 15:case 14:break;default:return H}}}function ce(H,X=[],se=[]){if(Y(H),X.length+se.length>0){let W=t.getToken();for(;W!==17;){if(X.indexOf(W)!==-1){re();break}else if(se.indexOf(W)!==-1)break;W=re()}}}function Q(H){const X=t.getTokenValue();return H?O(X):D(X),re(),!0}function K(){switch(t.getToken()){case 11:{let H=0;try{H=JSON.parse(t.getTokenValue()),typeof H!="number"&&(ce(2),H=0)}catch{ce(2)}O(H);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return re(),!0}function V(){return t.getToken()!==10?(ce(3,[],[2,5]),!1):(Q(!1),t.getToken()===6?(F(":"),re(),j()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function q(){S(),re();let H=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(H||ce(4,[],[]),F(","),re(),t.getToken()===2&&oe)break}else H&&ce(6,[],[]);V()||ce(4,[],[2,5]),H=!0}return M(),t.getToken()!==2?ce(7,[2],[]):re(),!0}function N(){P(),re();let H=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(H||ce(4,[],[]),F(","),re(),t.getToken()===4&&oe)break}else H&&ce(6,[],[]);j()||ce(4,[],[4,5]),H=!0}return k(),t.getToken()!==4?ce(8,[4],[]):re(),!0}function j(){switch(t.getToken()){case 3:return N();case 1:return q();case 10:return Q(!0);default:return K()}}return re(),t.getToken()===17?s.allowEmptyContent?!0:(ce(4,[],[]),!1):j()?(t.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=d;function E(i,o){const s=R(i),t=[];let n,l=0,S;do switch(S=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:l!==S&&t.push(i.substring(l,S)),o!==void 0&&t.push(s.getTokenValue().replace(/[^\r\n]/g,o)),l=s.getPosition();break}while(n!==17);return t.join("")}e.stripComments=E;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ie[138],ne([0,1,44]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(a,g,w){let y,h,b,p,v;if(g){for(p=g.offset,v=p+g.length,b=p;b>0&&!u(a,b-1);)b--;let S=v;for(;S<a.length&&!u(a,S);)S++;h=a.substring(b,S),y=R(h,w)}else h=a,y=0,b=0,p=0,v=a.length;const m=I(w,a);let f=!1,d=0,E;w.insertSpaces?E=A(" ",w.tabSize||4):E="	";const c=(0,C.createScanner)(h,!1);let i=!1;function o(){return m+A(E,y+d)}function s(){let S=c.scan();for(f=!1;S===15||S===14;)f=f||S===14,S=c.scan();return i=S===16||c.getTokenError()!==0,S}const t=[];function n(S,D,M){!i&&D<v&&M>p&&a.substring(D,M)!==S&&t.push({offset:D,length:M-D,content:S})}let l=s();if(l!==17){const S=c.getTokenOffset()+b,D=A(E,y);n(D,b,S)}for(;l!==17;){let S=c.getTokenOffset()+c.getTokenLength()+b,D=s(),M="";for(;!f&&(D===12||D===13);){const k=c.getTokenOffset()+b;n(" ",S,k),S=c.getTokenOffset()+c.getTokenLength()+b,M=D===12?o():"",D=s()}if(D===2)l!==1&&(d--,M=o());else if(D===4)l!==3&&(d--,M=o());else{switch(l){case 3:case 1:d++,M=o();break;case 5:case 12:M=o();break;case 13:f?M=o():M=" ";break;case 6:M=" ";break;case 10:if(D===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?M=" ":D!==5&&D!==17&&(i=!0);break;case 16:i=!0;break}f&&(D===12||D===13)&&(M=o())}const P=c.getTokenOffset()+b;n(M,S,P),l=D}return t}e.format=L;function r(a,g){const w=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?w.replace(/\r\n|\r|\n/g,g.eol):w}e.toFormattedString=r;function A(a,g){let w="";for(let y=0;y<g;y++)w+=a;return w}function R(a,g){let w=0,y=0;const h=g.tabSize||4;for(;w<a.length;){const b=a.charAt(w);if(b===" ")y++;else if(b==="	")y+=h;else break;w++}return Math.floor(y/h)}function I(a,g){for(let w=0;w<g.length;w++){const y=g.charAt(w);if(y==="\r")return w+1<g.length&&g.charAt(w+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}e.getEOL=I;function u(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}e.isEOL=u}),define(ie[139],ne([0,1,44,138]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(a,g,w){return A(a,g,void 0,w)}e.removeProperty=r;function A(a,g,w,y,h){const b=g.slice(),p=[],v=(0,C.parseTree)(a,p);let m,f;for(;b.length>0&&(f=b.pop(),m=(0,C.findNodeAtLocation)(v,b),m===void 0&&w!==void 0);)typeof f=="string"?w={[f]:w}:w=[w];if(m)if(m.type==="object"&&typeof f=="string"&&Array.isArray(m.children)){const d=(0,C.findNodeAtLocation)(m,[f]);if(d!==void 0)if(w===void 0){if(!d.parent)throw new Error("Malformed AST");const E=m.children.indexOf(d.parent);let c,i=d.parent.offset+d.parent.length;if(E>0){const o=m.children[E-1];c=o.offset+o.length}else c=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return R(a,{offset:c,length:i-c,content:""},y)}else return R(a,{offset:d.offset,length:d.length,content:JSON.stringify(w)},y);else{if(w===void 0)return[];const E=`${JSON.stringify(f)}: ${JSON.stringify(w)}`,c=h?h(m.children.map(o=>o.children[0].value)):m.children.length;let i;if(c>0){const o=m.children[c-1];i={offset:o.offset+o.length,length:0,content:","+E}}else m.children.length===0?i={offset:m.offset+1,length:0,content:E}:i={offset:m.offset+1,length:0,content:E+","};return R(a,i,y)}}else if(m.type==="array"&&typeof f=="number"&&Array.isArray(m.children))if(w!==void 0){const d=`${JSON.stringify(w)}`;let E;if(m.children.length===0||f===0)E={offset:m.offset+1,length:0,content:m.children.length===0?d:d+","};else{const c=f===-1||f>m.children.length?m.children.length:f,i=m.children[c-1];E={offset:i.offset+i.length,length:0,content:","+d}}return R(a,E,y)}else{const d=f,E=m.children[d];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===d){const i=m.children[d-1],o=i.offset+i.length,s=m.offset+m.length;c={offset:o,length:s-2-o,content:""}}else c={offset:E.offset,length:m.children[d+1].offset-E.offset,content:""};return R(a,c,y)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return R(a,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(w)},y)}}e.setProperty=A;function R(a,g,w){let y=I(a,g),h=g.offset,b=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;h>0&&!(0,L.isEOL)(y,h-1);)h--;for(;b<y.length&&!(0,L.isEOL)(y,b);)b++}const p=(0,L.format)(y,{offset:h,length:b-h},w);for(let m=p.length-1;m>=0;m--){const f=p[m];y=I(y,f),h=Math.min(h,f.offset),b=Math.max(b,f.offset+f.length),b+=f.content.length-f.length}const v=a.length-(y.length-b)-h;return[{offset:h,length:v,content:y.substring(h,b)}]}e.withFormatting=R;function I(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}e.applyEdit=I;function u(a,g){const w=g.slice(0).sort((h,b)=>{const p=h.offset-b.offset;return p===0?h.length-b.length:p});let y=a.length;for(let h=w.length-1;h>=0;h--){const b=w[h];if(b.offset+b.length<=y)a=I(a,b);else throw new Error("Overlapping edit");y=b.offset}return a}e.applyEdits=u}),define(ie[71],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class C{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=C}),define(ie[101],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class C{static{this.Undefined=new C(void 0)}constructor(A){this.element=A,this.next=C.Undefined,this.prev=C.Undefined}}class L{constructor(){this._first=C.Undefined,this._last=C.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===C.Undefined}clear(){let A=this._first;for(;A!==C.Undefined;){const R=A.next;A.prev=C.Undefined,A.next=C.Undefined,A=R}this._first=C.Undefined,this._last=C.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,R){const I=new C(A);if(this._first===C.Undefined)this._first=I,this._last=I;else if(R){const a=this._last;this._last=I,I.prev=a,a.next=I}else{const a=this._first;this._first=I,I.next=a,a.prev=I}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(I))}}shift(){if(this._first!==C.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==C.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==C.Undefined&&A.next!==C.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===C.Undefined&&A.next===C.Undefined?(this._first=C.Undefined,this._last=C.Undefined):A.next===C.Undefined?(this._last=this._last.prev,this._last.next=C.Undefined):A.prev===C.Undefined&&(this._first=this._first.next,this._first.prev=C.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==C.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(ie[31],ne([0,1]),function(G,e){"use strict";var C,L,r;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(f,d,E){let c=f.get(d);return c===void 0&&(c=E,f.set(d,c)),c}e.getOrSet=A;function R(f){const d=[];return f.forEach((E,c)=>{d.push(`${c} => ${E}`)}),`Map(${f.size}) {${d.join(", ")}}`}e.mapToString=R;function I(f){const d=[];return f.forEach(E=>{d.push(E)}),`Set(${f.size}) {${d.join(", ")}}`}e.setToString=I;class u{constructor(d,E){this.uri=d,this.value=E}}function a(f){return Array.isArray(f)}class g{static{this.defaultToKey=d=>d.toString()}constructor(d,E){if(this[C]="ResourceMap",d instanceof g)this.map=new Map(d.map),this.toKey=E??g.defaultToKey;else if(a(d)){this.map=new Map,this.toKey=E??g.defaultToKey;for(const[c,i]of d)this.set(c,i)}else this.map=new Map,this.toKey=d??g.defaultToKey}set(d,E){return this.map.set(this.toKey(d),new u(d,E)),this}get(d){return this.map.get(this.toKey(d))?.value}has(d){return this.map.has(this.toKey(d))}get size(){return this.map.size}clear(){this.map.clear()}delete(d){return this.map.delete(this.toKey(d))}forEach(d,E){typeof E<"u"&&(d=d.bind(E));for(const[c,i]of this.map)d(i.value,i.uri,this)}*values(){for(const d of this.map.values())yield d.value}*keys(){for(const d of this.map.values())yield d.uri}*entries(){for(const d of this.map.values())yield[d.uri,d.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.map)yield[d.uri,d.value]}}e.ResourceMap=g;class w{constructor(d,E){this[L]="ResourceSet",!d||typeof d=="function"?this._map=new g(d):(this._map=new g(E),d.forEach(this.add,this))}get size(){return this._map.size}add(d){return this._map.set(d,d),this}clear(){this._map.clear()}delete(d){return this._map.delete(d)}forEach(d,E){this._map.forEach((c,i)=>d.call(E,i,i,this))}has(d){return this._map.has(d)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=w;var y;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class h{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(d){return this._map.has(d)}get(d,E=0){const c=this._map.get(d);if(c)return E!==0&&this.touch(c,E),c.value}set(d,E,c=0){let i=this._map.get(d);if(i)i.value=E,c!==0&&this.touch(i,c);else{switch(i={key:d,value:E,next:void 0,previous:void 0},c){case 0:this.addItemLast(i);break;case 1:this.addItemFirst(i);break;case 2:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(d,i),this._size++}return this}delete(d){return!!this.remove(d)}remove(d){const E=this._map.get(d);if(E)return this._map.delete(d),this.removeItem(E),this._size--,E.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const d=this._head;return this._map.delete(d.key),this.removeItem(d),this._size--,d.value}forEach(d,E){const c=this._state;let i=this._head;for(;i;){if(E?d.bind(E)(i.value,i.key,this):d(i.value,i.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const d=this,E=this._state;let c=this._head;const i={[Symbol.iterator](){return i},next(){if(d._state!==E)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:c.key,done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}values(){const d=this,E=this._state;let c=this._head;const i={[Symbol.iterator](){return i},next(){if(d._state!==E)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:c.value,done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}entries(){const d=this,E=this._state;let c=this._head;const i={[Symbol.iterator](){return i},next(){if(d._state!==E)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:[c.key,c.value],done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(d){if(d>=this.size)return;if(d===0){this.clear();return}let E=this._head,c=this.size;for(;E&&c>d;)this._map.delete(E.key),E=E.next,c--;this._head=E,this._size=c,E&&(E.previous=void 0),this._state++}addItemFirst(d){if(!this._head&&!this._tail)this._tail=d;else if(this._head)d.next=this._head,this._head.previous=d;else throw new Error("Invalid list");this._head=d,this._state++}addItemLast(d){if(!this._head&&!this._tail)this._head=d;else if(this._tail)d.previous=this._tail,this._tail.next=d;else throw new Error("Invalid list");this._tail=d,this._state++}removeItem(d){if(d===this._head&&d===this._tail)this._head=void 0,this._tail=void 0;else if(d===this._head){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this._head=d.next}else if(d===this._tail){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this._tail=d.previous}else{const E=d.next,c=d.previous;if(!E||!c)throw new Error("Invalid list");E.previous=c,c.next=E}d.next=void 0,d.previous=void 0,this._state++}touch(d,E){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(d===this._head)return;const c=d.next,i=d.previous;d===this._tail?(i.next=void 0,this._tail=i):(c.previous=i,i.next=c),d.previous=void 0,d.next=this._head,this._head.previous=d,this._head=d,this._state++}else if(E===2){if(d===this._tail)return;const c=d.next,i=d.previous;d===this._head?(c.previous=void 0,this._head=c):(c.previous=i,i.next=c),d.next=void 0,d.previous=this._tail,this._tail.next=d,this._tail=d,this._state++}}}toJSON(){const d=[];return this.forEach((E,c)=>{d.push([c,E])}),d}fromJSON(d){this.clear();for(const[E,c]of d)this.set(E,c)}}e.LinkedMap=h;class b extends h{constructor(d,E=1){super(),this._limit=d,this._ratio=Math.min(Math.max(0,E),1)}get limit(){return this._limit}set limit(d){this._limit=d,this.checkTrim()}get ratio(){return this._ratio}set ratio(d){this._ratio=Math.min(Math.max(0,d),1),this.checkTrim()}get(d,E=2){return super.get(d,E)}peek(d){return super.get(d,0)}set(d,E){return super.set(d,E,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=b;class p{constructor(){this.map=new Map}add(d){return this.map.set(d,(this.map.get(d)||0)+1),this}delete(d){let E=this.map.get(d)||0;return E===0?!1:(E--,E===0?this.map.delete(d):this.map.set(d,E),!0)}has(d){return this.map.has(d)}}e.CounterSet=p;class v{constructor(d){if(this._m1=new Map,this._m2=new Map,d)for(const[E,c]of d)this.set(E,c)}clear(){this._m1.clear(),this._m2.clear()}set(d,E){this._m1.set(d,E),this._m2.set(E,d)}get(d){return this._m1.get(d)}getKey(d){return this._m2.get(d)}delete(d){const E=this._m1.get(d);return E===void 0?!1:(this._m1.delete(d),this._m2.delete(E),!0)}forEach(d,E){this._m1.forEach((c,i)=>{d.call(E,c,i,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=v;class m{constructor(){this.map=new Map}add(d,E){let c=this.map.get(d);c||(c=new Set,this.map.set(d,c)),c.add(E)}delete(d,E){const c=this.map.get(d);c&&(c.delete(E),c.size===0&&this.map.delete(d))}forEach(d,E){const c=this.map.get(d);c&&c.forEach(E)}get(d){const E=this.map.get(d);return E||new Set}}e.SetMap=m}),define(ie[2],ne([0,1,23,135,31,84,70]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const I=!1;let u=null;class a{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(k){let O=this.livingDisposables.get(k);return O||(O={parent:null,source:null,isSingleton:!1,value:k,idx:a.idx++},this.livingDisposables.set(k,O)),O}trackDisposable(k){const O=this.getDisposableData(k);O.source||(O.source=new Error().stack)}setParent(k,O){const F=this.getDisposableData(k);F.parent=O}markAsDisposed(k){this.livingDisposables.delete(k)}markAsSingleton(k){this.getDisposableData(k).isSingleton=!0}getRootParent(k,O){const F=O.get(k);if(F)return F;const z=k.parent?this.getRootParent(this.getDisposableData(k.parent),O):k;return O.set(k,z),z}getTrackedDisposables(){const k=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,k).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(k=10,O){let F;if(O)F=O;else{const re=new Map,ce=[...this.livingDisposables.values()].filter(K=>K.source!==null&&!this.getRootParent(K,re).isSingleton);if(ce.length===0)return;const Q=new Set(ce.map(K=>K.value));if(F=ce.filter(K=>!(K.parent&&Q.has(K.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function z(re){function ce(K,V){for(;K.length>0&&V.some(q=>typeof q=="string"?q===K[0]:K[0].match(q));)K.shift()}const Q=re.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return ce(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const Y=new r.SetMap;for(const re of F){const ce=z(re);for(let Q=0;Q<=ce.length;Q++)Y.add(ce.slice(0,Q).join(`
`),re)}F.sort((0,C.compareBy)(re=>re.idx,C.numberComparator));let J="",oe=0;for(const re of F.slice(0,k)){oe++;const ce=z(re),Q=[];for(let K=0;K<ce.length;K++){let V=ce[K];V=`(shared with ${Y.get(ce.slice(0,K+1).join(`
`)).size}/${F.length} leaks) at ${V}`;const N=Y.get(ce.slice(0,K).join(`
`)),j=(0,L.groupBy)([...N].map(H=>z(H)[K]),H=>H);delete j[ce[K]];for(const[H,X]of Object.entries(j))Q.unshift(`    - stacktraces of ${X.length} other leaks continue with ${H}`);Q.unshift(V)}J+=`


==================== Leaking disposable ${oe}/${F.length}: ${re.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return F.length>k&&(J+=`


... and ${F.length-k} more leaking disposables

`),{leaks:F,details:J}}}e.DisposableTracker=a;function g(P){u=P}if(e.setDisposableTracker=g,I){const P="__is_disposable_tracked__";g(new class{trackDisposable(k){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[P]||console.log(O)},3e3)}setParent(k,O){if(k&&k!==i.None)try{k[P]=!0}catch{}}markAsDisposed(k){if(k&&k!==i.None)try{k[P]=!0}catch{}}markAsSingleton(k){}})}function w(P){return u?.trackDisposable(P),P}e.trackDisposable=w;function y(P){u?.markAsDisposed(P)}e.markAsDisposed=y;function h(P,k){u?.setParent(P,k)}function b(P,k){if(u)for(const O of P)u.setParent(O,k)}function p(P){return u?.markAsSingleton(P),P}e.markAsSingleton=p;function v(P){return typeof P.dispose=="function"&&P.dispose.length===0}e.isDisposable=v;function m(P){if(R.Iterable.is(P)){const k=[];for(const O of P)if(O)try{O.dispose()}catch(F){k.push(F)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}e.dispose=m;function f(P){for(const k of P)v(k)&&k.dispose();return[]}e.disposeIfDisposable=f;function d(...P){const k=E(()=>m(P));return b(P,k),k}e.combinedDisposable=d;function E(P){const k=w({dispose:(0,A.createSingleCallFunction)(()=>{y(k),P()})});return k}e.toDisposable=E;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return h(k,this),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(k),k.dispose()}}deleteAndLeak(k){k&&this._toDispose.has(k)&&(this._toDispose.delete(k),h(k,null))}}e.DisposableStore=c;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new c,w(this),h(this._store,this)}dispose(){y(this),this._store.dispose()}_register(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(k)}}e.Disposable=i;class o{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(k){this._isDisposed||k===this._value||(this._value?.dispose(),k&&h(k,this),this._value=k)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const k=this._value;return this._value=void 0,k&&h(k,null),k}}e.MutableDisposable=o;class s{constructor(k){this._disposable=k,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(k){let O=k;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,y(this))},this}}e.SafeDisposable=t;class n{constructor(){this.references=new Map}acquire(k,...O){let F=this.references.get(k);F||(F={counter:0,object:this.createReferencedObject(k,...O)},this.references.set(k,F));const{object:z}=F,Y=(0,A.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(k,F.object),this.references.delete(k))});return F.counter++,{object:z,dispose:Y}}}e.ReferenceCollection=n;class l{constructor(k){this.referenceCollection=k}async acquire(k,...O){const F=this.referenceCollection.acquire(k,...O);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(z){throw F.dispose(),z}}}e.AsyncReferenceCollection=l;class S{constructor(k){this.object=k}dispose(){}}e.ImmortalReference=S;function D(P){const k=new c;try{P(k)}finally{k.dispose()}}e.disposeOnReturn=D;class M{constructor(){this._store=new Map,this._isDisposed=!1,w(this)}dispose(){y(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(k){return this._store.has(k)}get size(){return this._store.size}get(k){return this._store.get(k)}set(k,O,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(k)?.dispose(),this._store.set(k,O)}deleteAndDispose(k){this._store.get(k)?.dispose(),this._store.delete(k)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=M}),define(ie[85],ne([0,1,31]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new C.LRUCache(1e4);function r(a){return u(a,"NFC",L)}e.normalizeNFC=r;const A=new C.LRUCache(1e4);function R(a){return u(a,"NFD",A)}e.normalizeNFD=R;const I=/[^\u0000-\u0080]/;function u(a,g,w){if(!a)return a;const y=w.get(a);if(y)return y;let h;return I.test(a)?h=a.normalize(g):h=a,w.set(a,h),h}e.removeAccents=function(){const a=/[\u0300-\u036f]/g;return function(g){return R(g).replace(a,"")}}()}),define(ie[140],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function C(I,u,a){return Math.min(Math.max(I,u),a)}e.clamp=C;function L(I,u){return(u+I%u)%u}e.rot=L;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class A{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class R{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const a=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=a,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function G(r){const A=[];typeof r=="number"&&A.push("code/timeOrigin",r);function R(u){A.push(u,Date.now())}function I(){const u=[];for(let a=0;a<A.length;a+=2)u.push({name:A[a],startTime:A[a+1]});return u}return{mark:R,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(r+R.startTime)});return A}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function C(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=C(L))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var L in C)(typeof exports=="object"?exports:G)[L]=C[L]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function C(L){if(e[L])return e[L].exports;var r=e[L]={i:L,l:!1,exports:{}};return G[L].call(r.exports,r,r.exports,C),r.l=!0,r.exports}return C.m=G,C.c=e,C.d=function(L,r,A){C.o(L,r)||Object.defineProperty(L,r,{enumerable:!0,get:A})},C.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},C.t=function(L,r){if(1&r&&(L=C(L)),8&r||4&r&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(C.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&r&&typeof L!="string")for(var R in L)C.d(A,R,function(I){return L[I]}.bind(null,R));return A},C.n=function(L){var r=L&&L.__esModule?function(){return L.default}:function(){return L};return C.d(r,"a",r),r},C.o=function(L,r){return Object.prototype.hasOwnProperty.call(L,r)},C.p="",C(C.s=0)}([function(G,e,C){(function(L){var r;e=G.exports=se,r=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],u=e.src=[],a=0,g=a++;u[g]="0|[1-9]\\d*";var w=a++;u[w]="[0-9]+";var y=a++;u[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=a++;u[h]="("+u[g]+")\\.("+u[g]+")\\.("+u[g]+")";var b=a++;u[b]="("+u[w]+")\\.("+u[w]+")\\.("+u[w]+")";var p=a++;u[p]="(?:"+u[g]+"|"+u[y]+")";var v=a++;u[v]="(?:"+u[w]+"|"+u[y]+")";var m=a++;u[m]="(?:-("+u[p]+"(?:\\."+u[p]+")*))";var f=a++;u[f]="(?:-?("+u[v]+"(?:\\."+u[v]+")*))";var d=a++;u[d]="[0-9A-Za-z-]+";var E=a++;u[E]="(?:\\+("+u[d]+"(?:\\."+u[d]+")*))";var c=a++,i="v?"+u[h]+u[m]+"?"+u[E]+"?";u[c]="^"+i+"$";var o="[v=\\s]*"+u[b]+u[f]+"?"+u[E]+"?",s=a++;u[s]="^"+o+"$";var t=a++;u[t]="((?:<|>)?=?)";var n=a++;u[n]=u[w]+"|x|X|\\*";var l=a++;u[l]=u[g]+"|x|X|\\*";var S=a++;u[S]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[m]+")?"+u[E]+"?)?)?";var D=a++;u[D]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[E]+"?)?)?";var M=a++;u[M]="^"+u[t]+"\\s*"+u[S]+"$";var P=a++;u[P]="^"+u[t]+"\\s*"+u[D]+"$";var k=a++;u[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=a++;u[O]="(?:~>?)";var F=a++;u[F]="(\\s*)"+u[O]+"\\s+",I[F]=new RegExp(u[F],"g");var z=a++;u[z]="^"+u[O]+u[S]+"$";var Y=a++;u[Y]="^"+u[O]+u[D]+"$";var J=a++;u[J]="(?:\\^)";var oe=a++;u[oe]="(\\s*)"+u[J]+"\\s+",I[oe]=new RegExp(u[oe],"g");var re=a++;u[re]="^"+u[J]+u[S]+"$";var ce=a++;u[ce]="^"+u[J]+u[D]+"$";var Q=a++;u[Q]="^"+u[t]+"\\s*("+o+")$|^$";var K=a++;u[K]="^"+u[t]+"\\s*("+i+")$|^$";var V=a++;u[V]="(\\s*)"+u[t]+"\\s*("+o+"|"+u[S]+")",I[V]=new RegExp(u[V],"g");var q=a++;u[q]="^\\s*("+u[S]+")\\s+-\\s+("+u[S]+")\\s*$";var N=a++;u[N]="^\\s*("+u[D]+")\\s+-\\s+("+u[D]+")\\s*$";var j=a++;u[j]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)r(H,u[H]),I[H]||(I[H]=new RegExp(u[H]));function X(Z,le){if(Z instanceof se)return Z;if(typeof Z!="string"||Z.length>A||!(le?I[s]:I[c]).test(Z))return null;try{return new se(Z,le)}catch{return null}}function se(Z,le){if(Z instanceof se){if(Z.loose===le)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof se))return new se(Z,le);r("SemVer",Z,le),this.loose=le;var ge=Z.trim().match(le?I[s]:I[c]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(De){if(/^[0-9]+$/.test(De)){var Re=+De;if(Re>=0&&Re<R)return Re}return De}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=X,e.valid=function(Z,le){var ge=X(Z,le);return ge?ge.version:null},e.clean=function(Z,le){var ge=X(Z.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(Z){return r("SemVer.compare",this.version,this.loose,Z),Z instanceof se||(Z=new se(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},se.prototype.compareMain=function(Z){return Z instanceof se||(Z=new se(Z,this.loose)),_(this.major,Z.major)||_(this.minor,Z.minor)||_(this.patch,Z.patch)},se.prototype.comparePre=function(Z){if(Z instanceof se||(Z=new se(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],De=Z.prerelease[le];if(r("prerelease compare",le,ge,De),ge===void 0&&De===void 0)return 0;if(De===void 0)return 1;if(ge===void 0)return-1;if(ge!==De)return _(ge,De)}while(++le)},se.prototype.inc=function(Z,le){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,le,ge,De){typeof ge=="string"&&(De=ge,ge=void 0);try{return new se(Z,ge).inc(le,De).version}catch{return null}},e.diff=function(Z,le){if($(Z,le))return null;var ge=X(Z),De=X(le);if(ge.prerelease.length||De.prerelease.length){for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==De[Re])return"pre"+Re;return"prerelease"}for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==De[Re])return Re},e.compareIdentifiers=_;var W=/^[0-9]+$/;function _(Z,le){var ge=W.test(Z),De=W.test(le);return ge&&De&&(Z=+Z,le=+le),ge&&!De?-1:De&&!ge?1:Z<le?-1:Z>le?1:0}function U(Z,le,ge){return new se(Z,ge).compare(new se(le,ge))}function B(Z,le,ge){return U(Z,le,ge)>0}function T(Z,le,ge){return U(Z,le,ge)<0}function $(Z,le,ge){return U(Z,le,ge)===0}function x(Z,le,ge){return U(Z,le,ge)!==0}function ae(Z,le,ge){return U(Z,le,ge)>=0}function fe(Z,le,ge){return U(Z,le,ge)<=0}function ue(Z,le,ge,De){var Re;switch(le){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Re=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Re=Z!==ge;break;case"":case"=":case"==":Re=$(Z,ge,De);break;case"!=":Re=x(Z,ge,De);break;case">":Re=B(Z,ge,De);break;case">=":Re=ae(Z,ge,De);break;case"<":Re=T(Z,ge,De);break;case"<=":Re=fe(Z,ge,De);break;default:throw new TypeError("Invalid operator: "+le)}return Re}function de(Z,le){if(Z instanceof de){if(Z.loose===le)return Z;Z=Z.value}if(!(this instanceof de))return new de(Z,le);r("comparator",Z,le),this.loose=le,this.parse(Z),this.semver===be?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(Z,le){return _(le,Z)},e.major=function(Z,le){return new se(Z,le).major},e.minor=function(Z,le){return new se(Z,le).minor},e.patch=function(Z,le){return new se(Z,le).patch},e.compare=U,e.compareLoose=function(Z,le){return U(Z,le,!0)},e.rcompare=function(Z,le,ge){return U(le,Z,ge)},e.sort=function(Z,le){return Z.sort(function(ge,De){return e.compare(ge,De,le)})},e.rsort=function(Z,le){return Z.sort(function(ge,De){return e.rcompare(ge,De,le)})},e.gt=B,e.lt=T,e.eq=$,e.neq=x,e.gte=ae,e.lte=fe,e.cmp=ue,e.Comparator=de;var be={};function we(Z,le){if(Z instanceof we)return Z.loose===le?Z:new we(Z.raw,le);if(Z instanceof de)return new we(Z.value,le);if(!(this instanceof we))return new we(Z,le);if(this.loose=le,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function ye(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function ke(Z,le,ge,De,Re,We,Ae,He,ze,ee,he,me,Ee){return((le=ye(ge)?"":ye(De)?">="+ge+".0.0":ye(Re)?">="+ge+"."+De+".0":">="+le)+" "+(He=ye(ze)?"":ye(ee)?"<"+(+ze+1)+".0.0":ye(he)?"<"+ze+"."+(+ee+1)+".0":me?"<="+ze+"."+ee+"."+he+"-"+me:"<="+He)).trim()}function Be(Z,le){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<Z.length;ge++)if(r(Z[ge].semver),Z[ge].semver!==be&&Z[ge].semver.prerelease.length>0){var De=Z[ge].semver;if(De.major===le.major&&De.minor===le.minor&&De.patch===le.patch)return!0}return!1}return!0}function pe(Z,le,ge){try{le=new we(le,ge)}catch{return!1}return le.test(Z)}function ve(Z,le,ge,De){var Re,We,Ae,He,ze;switch(Z=new se(Z,De),le=new we(le,De),ge){case">":Re=B,We=fe,Ae=T,He=">",ze=">=";break;case"<":Re=T,We=ae,Ae=B,He="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(Z,le,De))return!1;for(var ee=0;ee<le.set.length;++ee){var he=le.set[ee],me=null,Ee=null;if(he.forEach(function(Me){Me.semver===be&&(Me=new de(">=0.0.0")),me=me||Me,Ee=Ee||Me,Re(Me.semver,me.semver,De)?me=Me:Ae(Me.semver,Ee.semver,De)&&(Ee=Me)}),me.operator===He||me.operator===ze||(!Ee.operator||Ee.operator===He)&&We(Z,Ee.semver)||Ee.operator===ze&&Ae(Z,Ee.semver))return!1}return!0}de.prototype.parse=function(Z){var le=this.loose?I[Q]:I[K],ge=Z.match(le);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new se(ge[2],this.loose):this.semver=be},de.prototype.toString=function(){return this.value},de.prototype.test=function(Z){return r("Comparator.test",Z,this.loose),this.semver===be||(typeof Z=="string"&&(Z=new se(Z,this.loose)),ue(Z,this.operator,this.semver,this.loose))},de.prototype.intersects=function(Z,le){if(!(Z instanceof de))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new we(Z.value,le),pe(this.value,ge,le);if(Z.operator==="")return ge=new we(this.value,le),pe(Z.semver,ge,le);var De=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),We=this.semver.version===Z.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),He=ue(this.semver,"<",Z.semver,le)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),ze=ue(this.semver,">",Z.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return De||Re||We&&Ae||He||ze},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Z){var le=this.loose;Z=Z.trim(),r("range",Z,le);var ge=le?I[N]:I[q];Z=Z.replace(ge,ke),r("hyphen replace",Z),Z=Z.replace(I[V],"$1$2$3"),r("comparator trim",Z,I[V]),Z=(Z=(Z=Z.replace(I[F],"$1~")).replace(I[oe],"$1^")).split(/\s+/).join(" ");var De=le?I[Q]:I[K],Re=Z.split(" ").map(function(We){return function(Ae,He){return r("comp",Ae),Ae=function(ze,ee){return ze.trim().split(/\s+/).map(function(he){return function(me,Ee){r("caret",me,Ee);var Me=Ee?I[ce]:I[re];return me.replace(Me,function(Ue,Oe,Te,xe,je){var Ve;return r("caret",me,Ue,Oe,Te,xe,je),ye(Oe)?Ve="":ye(Te)?Ve=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":ye(xe)?Ve=Oe==="0"?">="+Oe+"."+Te+".0 <"+Oe+"."+(+Te+1)+".0":">="+Oe+"."+Te+".0 <"+(+Oe+1)+".0.0":je?(r("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Ve=Oe==="0"?Te==="0"?">="+Oe+"."+Te+"."+xe+je+" <"+Oe+"."+Te+"."+(+xe+1):">="+Oe+"."+Te+"."+xe+je+" <"+Oe+"."+(+Te+1)+".0":">="+Oe+"."+Te+"."+xe+je+" <"+(+Oe+1)+".0.0"):(r("no pr"),Ve=Oe==="0"?Te==="0"?">="+Oe+"."+Te+"."+xe+" <"+Oe+"."+Te+"."+(+xe+1):">="+Oe+"."+Te+"."+xe+" <"+Oe+"."+(+Te+1)+".0":">="+Oe+"."+Te+"."+xe+" <"+(+Oe+1)+".0.0"),r("caret return",Ve),Ve})}(he,ee)}).join(" ")}(Ae,He),r("caret",Ae),Ae=function(ze,ee){return ze.trim().split(/\s+/).map(function(he){return function(me,Ee){var Me=Ee?I[Y]:I[z];return me.replace(Me,function(Ue,Oe,Te,xe,je){var Ve;return r("tilde",me,Ue,Oe,Te,xe,je),ye(Oe)?Ve="":ye(Te)?Ve=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":ye(xe)?Ve=">="+Oe+"."+Te+".0 <"+Oe+"."+(+Te+1)+".0":je?(r("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Ve=">="+Oe+"."+Te+"."+xe+je+" <"+Oe+"."+(+Te+1)+".0"):Ve=">="+Oe+"."+Te+"."+xe+" <"+Oe+"."+(+Te+1)+".0",r("tilde return",Ve),Ve})}(he,ee)}).join(" ")}(Ae,He),r("tildes",Ae),Ae=function(ze,ee){return r("replaceXRanges",ze,ee),ze.split(/\s+/).map(function(he){return function(me,Ee){me=me.trim();var Me=Ee?I[P]:I[M];return me.replace(Me,function(Ue,Oe,Te,xe,je,Ve){r("xRange",me,Ue,Oe,Te,xe,je,Ve);var Xe=ye(Te),Ye=Xe||ye(xe),it=Ye||ye(je);return Oe==="="&&it&&(Oe=""),Xe?Ue=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&it?(Ye&&(xe=0),it&&(je=0),Oe===">"?(Oe=">=",Ye?(Te=+Te+1,xe=0,je=0):it&&(xe=+xe+1,je=0)):Oe==="<="&&(Oe="<",Ye?Te=+Te+1:xe=+xe+1),Ue=Oe+Te+"."+xe+"."+je):Ye?Ue=">="+Te+".0.0 <"+(+Te+1)+".0.0":it&&(Ue=">="+Te+"."+xe+".0 <"+Te+"."+(+xe+1)+".0"),r("xRange return",Ue),Ue})}(he,ee)}).join(" ")}(Ae,He),r("xrange",Ae),Ae=function(ze,ee){return r("replaceStars",ze,ee),ze.trim().replace(I[j],"")}(Ae,He),r("stars",Ae),Ae}(We,le)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(We){return!!We.match(De)})),Re=Re.map(function(We){return new de(We,le)})},we.prototype.intersects=function(Z,le){if(!(Z instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(De){return Z.set.some(function(Re){return Re.every(function(We){return De.intersects(We,le)})})})})},e.toComparators=function(Z,le){return new we(Z,le).set.map(function(ge){return ge.map(function(De){return De.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new se(Z,this.loose));for(var le=0;le<this.set.length;le++)if(Be(this.set[le],Z))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(Z,le,ge){var De=null,Re=null;try{var We=new we(le,ge)}catch{return null}return Z.forEach(function(Ae){We.test(Ae)&&(De&&Re.compare(Ae)!==-1||(Re=new se(De=Ae,ge)))}),De},e.minSatisfying=function(Z,le,ge){var De=null,Re=null;try{var We=new we(le,ge)}catch{return null}return Z.forEach(function(Ae){We.test(Ae)&&(De&&Re.compare(Ae)!==1||(Re=new se(De=Ae,ge)))}),De},e.validRange=function(Z,le){try{return new we(Z,le).range||"*"}catch{return null}},e.ltr=function(Z,le,ge){return ve(Z,le,"<",ge)},e.gtr=function(Z,le,ge){return ve(Z,le,">",ge)},e.outside=ve,e.prerelease=function(Z,le){var ge=X(Z,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,le,ge){return Z=new we(Z,ge),le=new we(le,ge),Z.intersects(le)},e.coerce=function(Z){if(Z instanceof se)return Z;if(typeof Z!="string")return null;var le=Z.match(I[k]);return le==null?null:X((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,C(1))},function(G,e){var C,L,r=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function I(v){if(C===setTimeout)return setTimeout(v,0);if((C===A||!C)&&setTimeout)return C=setTimeout,setTimeout(v,0);try{return C(v,0)}catch{try{return C.call(null,v,0)}catch{return C.call(this,v,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:A}catch{C=A}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var u,a=[],g=!1,w=-1;function y(){g&&u&&(g=!1,u.length?a=u.concat(a):w=-1,a.length&&h())}function h(){if(!g){var v=I(y);g=!0;for(var m=a.length;m;){for(u=a,a=[];++w<m;)u&&u[w].run();w=-1,m=a.length}u=null,g=!1,function(f){if(L===clearTimeout)return clearTimeout(f);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(f);try{L(f)}catch{try{return L.call(null,f)}catch{return L.call(this,f)}}}(v)}}function b(v,m){this.fun=v,this.array=m}function p(){}r.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)m[f-1]=arguments[f];a.push(new b(v,m)),a.length!==1||g||I(h)},b.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=p,r.addListener=p,r.once=p,r.off=p,r.removeListener=p,r.removeAllListeners=p,r.emit=p,r.prependListener=p,r.prependOnceListener=p,r.listeners=function(v){return[]},r.binding=function(v){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(v){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(ie[141],ne([0,1]),function(G,e){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(I,u,a){this.level=I,this.key=u,this.value=a,this.forward=[]}}const r=void 0;class A{constructor(I,u=2**16){this.comparator=I,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new L(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,r,r),this._size=0}has(I){return!!A._search(this,I,this.comparator)}get(I){return A._search(this,I,this.comparator)?.value}set(I,u){return A._insert(this,I,u,this.comparator)&&(this._size+=1),this}delete(I){const u=A._delete(this,I,this.comparator);return u&&(this._size-=1),u}forEach(I,u){let a=this._header.forward[0];for(;a;)I.call(u,a.value,a.key,this),a=a.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",u=this._header.forward[0];for(;u;)I+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return I}static _search(I,u,a){let g=I._header;for(let w=I._level-1;w>=0;w--)for(;g.forward[w]&&a(g.forward[w].key,u)<0;)g=g.forward[w];if(g=g.forward[0],g&&a(g.key,u)===0)return g}static _insert(I,u,a,g){const w=[];let y=I._header;for(let h=I._level-1;h>=0;h--){for(;y.forward[h]&&g(y.forward[h].key,u)<0;)y=y.forward[h];w[h]=y}if(y=y.forward[0],y&&g(y.key,u)===0)return y.value=a,!1;{const h=A._randomLevel(I);if(h>I._level){for(let b=I._level;b<h;b++)w[b]=I._header;I._level=h}y=new L(h,u,a);for(let b=0;b<h;b++)y.forward[b]=w[b].forward[b],w[b].forward[b]=y;return!0}}static _randomLevel(I,u=.5){let a=1;for(;Math.random()<u&&a<I._maxLevel;)a+=1;return a}static _delete(I,u,a){const g=[];let w=I._header;for(let y=I._level-1;y>=0;y--){for(;w.forward[y]&&a(w.forward[y].key,u)<0;)w=w.forward[y];g[y]=w}if(w=w.forward[0],!w||a(w.key,u)!==0)return!1;for(let y=0;y<I._level&&g[y].forward[y]===w;y++)g[y].forward[y]=w.forward[y];for(;I._level>0&&I._header.forward[I._level-1]===r;)I._level-=1;return!0}}e.SkipList=A}),define(ie[72],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this._now=C&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(ie[3],ne([0,1,14,84,2,101,72]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,u=!1;var a;(function(M){M.None=()=>r.Disposable.None;function P(ue){if(u){const{onDidAddListener:de}=ue,be=b.create();let we=0;ue.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),de?.()}}}function k(ue,de){return K(ue,()=>{},0,void 0,!0,void 0,de)}M.defer=k;function O(ue){return(de,be=null,we)=>{let ye=!1,ke;return ke=ue(Be=>{if(!ye)return ke?ke.dispose():ye=!0,de.call(be,Be)},null,we),ye&&ke.dispose(),ke}}M.once=O;function F(ue,de,be){return ce((we,ye=null,ke)=>ue(Be=>we.call(ye,de(Be)),null,ke),be)}M.map=F;function z(ue,de,be){return ce((we,ye=null,ke)=>ue(Be=>{de(Be),we.call(ye,Be)},null,ke),be)}M.forEach=z;function Y(ue,de,be){return ce((we,ye=null,ke)=>ue(Be=>de(Be)&&we.call(ye,Be),null,ke),be)}M.filter=Y;function J(ue){return ue}M.signal=J;function oe(...ue){return(de,be=null,we)=>{const ye=(0,r.combinedDisposable)(...ue.map(ke=>ke(Be=>de.call(be,Be))));return Q(ye,we)}}M.any=oe;function re(ue,de,be,we){let ye=be;return F(ue,ke=>(ye=de(ye,ke),ye),we)}M.reduce=re;function ce(ue,de){let be;const we={onWillAddFirstListener(){be=ue(ye.fire,ye)},onDidRemoveLastListener(){be?.dispose()}};de||P(we);const ye=new d(we);return de?.add(ye),ye.event}function Q(ue,de){return de instanceof Array?de.push(ue):de&&de.add(ue),ue}function K(ue,de,be=100,we=!1,ye=!1,ke,Be){let pe,ve,Z,le=0,ge;const De={leakWarningThreshold:ke,onWillAddFirstListener(){pe=ue(We=>{le++,ve=de(ve,We),we&&!Z&&(Re.fire(ve),ve=void 0),ge=()=>{const Ae=ve;ve=void 0,Z=void 0,(!we||le>1)&&Re.fire(Ae),le=0},typeof be=="number"?(clearTimeout(Z),Z=setTimeout(ge,be)):Z===void 0&&(Z=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,pe.dispose()}};Be||P(De);const Re=new d(De);return Be?.add(Re),Re.event}M.debounce=K;function V(ue,de=0,be){return M.debounce(ue,(we,ye)=>we?(we.push(ye),we):[ye],de,void 0,!0,void 0,be)}M.accumulate=V;function q(ue,de=(we,ye)=>we===ye,be){let we=!0,ye;return Y(ue,ke=>{const Be=we||!de(ke,ye);return we=!1,ye=ke,Be},be)}M.latch=q;function N(ue,de,be){return[M.filter(ue,de,be),M.filter(ue,we=>!de(we),be)]}M.split=N;function j(ue,de=!1,be=[],we){let ye=be.slice(),ke=ue(ve=>{ye?ye.push(ve):pe.fire(ve)});we&&we.add(ke);const Be=()=>{ye?.forEach(ve=>pe.fire(ve)),ye=null},pe=new d({onWillAddFirstListener(){ke||(ke=ue(ve=>pe.fire(ve)),we&&we.add(ke))},onDidAddFirstListener(){ye&&(de?setTimeout(Be):Be())},onDidRemoveLastListener(){ke&&ke.dispose(),ke=null}});return we&&we.add(pe),pe.event}M.buffer=j;function H(ue,de){return(we,ye,ke)=>{const Be=de(new se);return ue(function(pe){const ve=Be.evaluate(pe);ve!==X&&we.call(ye,ve)},void 0,ke)}}M.chain=H;const X=Symbol("HaltChainable");class se{constructor(){this.steps=[]}map(de){return this.steps.push(de),this}forEach(de){return this.steps.push(be=>(de(be),be)),this}filter(de){return this.steps.push(be=>de(be)?be:X),this}reduce(de,be){let we=be;return this.steps.push(ye=>(we=de(we,ye),we)),this}latch(de=(be,we)=>be===we){let be=!0,we;return this.steps.push(ye=>{const ke=be||!de(ye,we);return be=!1,we=ye,ke?ye:X}),this}evaluate(de){for(const be of this.steps)if(de=be(de),de===X)break;return de}}function W(ue,de,be=we=>we){const we=(...pe)=>Be.fire(be(...pe)),ye=()=>ue.on(de,we),ke=()=>ue.removeListener(de,we),Be=new d({onWillAddFirstListener:ye,onDidRemoveLastListener:ke});return Be.event}M.fromNodeEventEmitter=W;function _(ue,de,be=we=>we){const we=(...pe)=>Be.fire(be(...pe)),ye=()=>ue.addEventListener(de,we),ke=()=>ue.removeEventListener(de,we),Be=new d({onWillAddFirstListener:ye,onDidRemoveLastListener:ke});return Be.event}M.fromDOMEventEmitter=_;function U(ue){return new Promise(de=>O(ue)(de))}M.toPromise=U;function B(ue){const de=new d;return ue.then(be=>{de.fire(be)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}M.fromPromise=B;function T(ue,de,be){return de(be),ue(we=>de(we))}M.runAndSubscribe=T;function $(ue,de){let be=null;function we(ke){be?.dispose(),be=new r.DisposableStore,de(ke,be)}we(void 0);const ye=ue(ke=>we(ke));return(0,r.toDisposable)(()=>{ye.dispose(),be?.dispose()})}M.runAndSubscribeWithStore=$;class x{constructor(de,be){this._observable=de,this._counter=0,this._hasChanged=!1;const we={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};be||P(we),this.emitter=new d(we),be&&be.add(this.emitter)}beginUpdate(de){this._counter++}handlePossibleChange(de){}handleChange(de,be){this._hasChanged=!0}endUpdate(de){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ae(ue,de){return new x(ue,de).emitter.event}M.fromObservable=ae;function fe(ue){return de=>{let be=0,we=!1;const ye={beginUpdate(){be++},endUpdate(){be--,be===0&&(ue.reportChanges(),we&&(we=!1,de()))},handlePossibleChange(){},handleChange(){we=!0}};return ue.addObserver(ye),ue.reportChanges(),{dispose(){ue.removeObserver(ye)}}}}M.fromObservableLight=fe})(a||(e.Event=a={}));class g{static{this.all=new Set}static{this._idPool=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${g._idPool++}`,g.all.add(this)}start(P){this._stopWatch=new R.StopWatch,this.listenerCount=P}stop(){if(this._stopWatch){const P=this._stopWatch.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=g;let w=-1;function y(M){const P=w;return w=M,{dispose(){w=P}}}e.setGlobalLeakWarningThreshold=y;class h{constructor(P,k=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=k,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(P,k){const O=this.threshold;if(O<=0||k<O)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(P.value)||0;if(this._stacks.set(P.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=O*.5;let z,Y=0;for(const[J,oe]of this._stacks)(!z||Y<oe)&&(z=J,Y=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${Y}):`),console.warn(z)}return()=>{const z=this._stacks.get(P.value)||0;this._stacks.set(P.value,z-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class v{constructor(P){this.value=P,this.id=p++}}const m=2,f=(M,P)=>{if(M instanceof v)P(M);else for(let k=0;k<M.length;k++){const O=M[k];O&&P(O)}};class d{constructor(P){this._size=0,this._options=P,this._leakageMon=w>0||this._options?.leakWarningThreshold?new h(this._options?.leakWarningThreshold??w):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(I){const P=this._listeners;queueMicrotask(()=>{f(P,k=>k.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(P,k,O)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;k&&(P=P.bind(k));const F=new v(P);let z,Y;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(F.stack=b.create(),z=this._leakageMon.check(F.stack,this._size+1)),I&&(F.stack=Y??b.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new c,this._listeners=[this._listeners,F]):this._listeners.push(F):(this._options?.onWillAddFirstListener?.(this),this._listeners=F,this._options?.onDidAddFirstListener?.(this)),this._size++;const J=(0,r.toDisposable)(()=>{z?.(),this._removeListener(F)});return O instanceof r.DisposableStore?O.add(J):Array.isArray(O)&&O.push(J),J},this._event}_removeListener(P){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const k=this._listeners,O=k.indexOf(P);if(O===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,k[O]=void 0;const F=this._deliveryQueue.current===this;if(this._size*m<=k.length){let z=0;for(let Y=0;Y<k.length;Y++)k[Y]?k[z++]=k[Y]:F&&(this._deliveryQueue.end--,z<this._deliveryQueue.i&&this._deliveryQueue.i--);k.length=z}}_deliver(P,k){if(!P)return;const O=this._options?.onListenerError||C.onUnexpectedError;if(!O){P.value(k);return}try{P.value(k)}catch(F){O(F)}}_deliverQueue(P){const k=P.current._listeners;for(;P.i<P.end;)this._deliver(k[P.i++],P.value);P.reset()}fire(P){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,P);else{const k=this._deliveryQueue;k.enqueue(this,P,this._listeners.length),this._deliverQueue(k)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=d;const E=()=>new c;e.createEventDeliveryQueue=E;class c{constructor(){this.i=-1,this.end=0}enqueue(P,k,O){this.i=0,this.end=O,this.current=P,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends d{async fireAsync(P,k,O){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),f(this._listeners,F=>this._asyncDeliveryQueue.push([F.value,P]));this._asyncDeliveryQueue.size>0&&!k.isCancellationRequested;){const[F,z]=this._asyncDeliveryQueue.shift(),Y=[],J={...z,token:k,waitUntil:oe=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");O&&(oe=O(oe,F)),Y.push(oe)}};try{F(J)}catch(oe){(0,C.onUnexpectedError)(oe);continue}Object.freeze(Y),await Promise.allSettled(Y).then(oe=>{for(const re of oe)re.status==="rejected"&&(0,C.onUnexpectedError)(re.reason)})}}}e.AsyncEmitter=i;class o extends d{get isPaused(){return this._isPaused!==0}constructor(P){super(P),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=P?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const P=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(P))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(P){this._size&&(this._isPaused!==0?this._eventQueue.push(P):super.fire(P))}}e.PauseableEmitter=o;class s extends o{constructor(P){super(P),this._delay=P.delay??100}fire(P){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(P)}}e.DebounceEmitter=s;class t extends d{constructor(P){super(P),this._queuedEvents=[],this._mergeFn=P?.merge}fire(P){this.hasListeners()&&(this._queuedEvents.push(P),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(k=>super.fire(k)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=t;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(P){const k={event:P,listener:null};this.events.push(k),this.hasListeners&&this.hook(k);const O=()=>{this.hasListeners&&this.unhook(k);const F=this.events.indexOf(k);this.events.splice(F,1)};return(0,r.toDisposable)((0,L.createSingleCallFunction)(O))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(P=>this.hook(P))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(P=>this.unhook(P))}hook(P){P.listener=P.event(k=>this.emitter.fire(k))}unhook(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class l{constructor(P,k,O,F){this._store=new r.DisposableStore;const z=this._store.add(new n),Y=this._store.add(new r.DisposableMap);function J(oe){Y.set(oe,z.add(F(oe)))}for(const oe of P)J(oe);this._store.add(k(oe=>{J(oe)})),this._store.add(O(oe=>{Y.deleteAndDispose(oe)})),this.event=z.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=l;class S{constructor(){this.buffers=[]}wrapEvent(P){return(k,O,F)=>P(z=>{const Y=this.buffers[this.buffers.length-1];Y?Y.push(()=>k.call(O,z)):k.call(O,z)},void 0,F)}bufferEvents(P){const k=[];this.buffers.push(k);const O=P();return this.buffers.pop(),k.forEach(F=>F()),O}}e.EventBufferer=S;class D{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=r.Disposable.None,this.emitter=new d({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(P){this.inputEvent=P,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=P(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(ie[22],ne([0,1,3]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(I,u){const a=setTimeout(I.bind(u),0);return{dispose(){clearTimeout(a)}}});var r;(function(I){function u(a){return a===I.None||a===I.Cancelled||a instanceof A?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}I.isCancellationToken=u,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(r||(e.CancellationToken=r={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new C.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=r.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=R}),define(ie[142],ne([0,1,22]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new C.CancellationTokenSource,u=this.task(I.token);return this.result={promise:u,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=L;class r{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const u=JSON.stringify(I);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=r;class A{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const u=this.fn(I);return this._map.set(I,u),u}}e.CachedFunction=A}),define(ie[61],ne([0,1,14,2]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(E){const c=E;return c?typeof c.read=="function":!1}e.isReadable=r;function A(E){const c=E;return c?[c.on,c.pause,c.resume,c.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function R(E){const c=E;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=R;function I(E,c){return new u(E,c)}e.newWriteableStream=I;class u{constructor(c,i){this.reducer=c,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(i=>i(c))}emitError(c){this.listeners.error.length===0?(0,C.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(i=>i(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,i){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(c,i){if(this.state.destroyed)return;let o;switch(c){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(E,c){const i=[];let o;for(;(o=E.read())!==null;)i.push(o);return c(i)}e.consumeReadable=a;function g(E,c,i){const o=[];let s;for(;(s=E.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const t=s;return s=void 0,t}return E.read()}}}e.peekReadable=g;function w(E,c){return new Promise((i,o)=>{const s=[];y(E,{onData:t=>{c&&s.push(t)},onError:t=>{c?o(t):i(void 0)},onEnd:()=>{i(c?c(s):void 0)}})})}e.consumeStream=w;function y(E,c,i){E.on("error",o=>{i?.isCancellationRequested||c.onError(o)}),E.on("end",()=>{i?.isCancellationRequested||c.onEnd()}),E.on("data",o=>{i?.isCancellationRequested||c.onData(o)})}e.listenStream=y;function h(E,c){return new Promise((i,o)=>{const s=new L.DisposableStore,t=[],n=D=>{if(t.push(D),t.length>c)return s.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},l=D=>(s.dispose(),o(D)),S=()=>(s.dispose(),i({stream:E,buffer:t,ended:!0}));s.add((0,L.toDisposable)(()=>E.removeListener("error",l))),E.on("error",l),s.add((0,L.toDisposable)(()=>E.removeListener("end",S))),E.on("end",S),s.add((0,L.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}e.peekStream=h;function b(E,c){const i=I(c);return i.end(E),i}e.toStream=b;function p(){const E=I(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=p;function v(E){let c=!1;return{read:()=>c?null:(c=!0,E)}}e.toReadable=v;function m(E,c,i){const o=I(i);return y(E,{onData:s=>o.write(c.data(s)),onError:s=>o.error(c.error?c.error(s):s),onEnd:()=>o.end()}),o}e.transform=m;function f(E,c,i){let o=!1;return{read:()=>{const s=c.read();return o?s:(o=!0,s!==null?i([E,s]):E)}}}e.prefixedReadable=f;function d(E,c,i){let o=!1;const s=I(i);return y(c,{onData:t=>o?s.write(t):(o=!0,s.write(i([E,t]))),onError:t=>s.error(t),onEnd:()=>{o||(o=!0,s.write(E)),s.end()}}),s}e.prefixedStream=d}),define(ie[17],ne([0,1,71,61]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const r=typeof Buffer<"u",A=new C.Lazy(()=>new Uint8Array(256));let R,I;class u{static alloc(k){return r?new u(Buffer.allocUnsafe(k)):new u(new Uint8Array(k))}static wrap(k){return r&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new u(k)}static fromString(k,O){return!(O?.dontUseNodeBuffer||!1)&&r?new u(Buffer.from(k)):(R||(R=new TextEncoder),new u(R.encode(k)))}static fromByteArray(k){const O=u.alloc(k.length);for(let F=0,z=k.length;F<z;F++)O.buffer[F]=k[F];return O}static concat(k,O){if(typeof O>"u"){O=0;for(let Y=0,J=k.length;Y<J;Y++)O+=k[Y].byteLength}const F=u.alloc(O);let z=0;for(let Y=0,J=k.length;Y<J;Y++){const oe=k[Y];F.set(oe,z),z+=oe.byteLength}return F}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=u.alloc(this.byteLength);return k.set(this),k}toString(){return r?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(k,O){return new u(this.buffer.subarray(k,O))}set(k,O){if(k instanceof u)this.buffer.set(k.buffer,O);else if(k instanceof Uint8Array)this.buffer.set(k,O);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),O);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return y(this.buffer,k)}writeUInt32BE(k,O){h(this.buffer,k,O)}readUInt32LE(k){return b(this.buffer,k)}writeUInt32LE(k,O){p(this.buffer,k,O)}readUInt8(k){return v(this.buffer,k)}writeUInt8(k,O){m(this.buffer,k,O)}indexOf(k,O=0){return a(this.buffer,k instanceof u?k.buffer:k,O)}}e.VSBuffer=u;function a(P,k,O=0){const F=k.byteLength,z=P.byteLength;if(F===0)return 0;if(F===1)return P.indexOf(k[0]);if(F>z-O)return-1;const Y=A.value;Y.fill(k.length);for(let ce=0;ce<k.length;ce++)Y[k[ce]]=k.length-ce-1;let J=O+k.length-1,oe=J,re=-1;for(;J<z;)if(P[J]===k[oe]){if(oe===0){re=J;break}J--,oe--}else J+=Math.max(k.length-oe,Y[P[J]]),oe=k.length-1;return re}e.binaryIndexOf=a;function g(P,k){return P[k+0]<<0>>>0|P[k+1]<<8>>>0}e.readUInt16LE=g;function w(P,k,O){P[O+0]=k&255,k=k>>>8,P[O+1]=k&255}e.writeUInt16LE=w;function y(P,k){return P[k]*2**24+P[k+1]*2**16+P[k+2]*2**8+P[k+3]}e.readUInt32BE=y;function h(P,k,O){P[O+3]=k,k=k>>>8,P[O+2]=k,k=k>>>8,P[O+1]=k,k=k>>>8,P[O]=k}e.writeUInt32BE=h;function b(P,k){return P[k+0]<<0>>>0|P[k+1]<<8>>>0|P[k+2]<<16>>>0|P[k+3]<<24>>>0}e.readUInt32LE=b;function p(P,k,O){P[O+0]=k&255,k=k>>>8,P[O+1]=k&255,k=k>>>8,P[O+2]=k&255,k=k>>>8,P[O+3]=k&255}e.writeUInt32LE=p;function v(P,k){return P[k]}e.readUInt8=v;function m(P,k,O){P[O]=k}e.writeUInt8=m;function f(P){return L.consumeReadable(P,k=>u.concat(k))}e.readableToBuffer=f;function d(P){return L.toReadable(P)}e.bufferToReadable=d;function E(P){return L.consumeStream(P,k=>u.concat(k))}e.streamToBuffer=E;async function c(P){return P.ended?u.concat(P.buffer):u.concat([...P.buffer,await E(P.stream)])}e.bufferedStreamToBuffer=c;function i(P){return L.toStream(P,k=>u.concat(k))}e.bufferToStream=i;function o(P){return L.transform(P,{data:k=>typeof k=="string"?u.fromString(k):u.wrap(k)},k=>u.concat(k))}e.streamToBufferReadableStream=o;function s(P){return L.newWriteableStream(k=>u.concat(k),P)}e.newWriteableBufferStream=s;function t(P,k){return L.prefixedReadable(P,k,O=>u.concat(O))}e.prefixedBufferReadable=t;function n(P,k){return L.prefixedStream(P,k,O=>u.concat(O))}e.prefixedBufferStream=n;function l(P){let k=0,O=0,F=0;const z=new Uint8Array(Math.floor(P.length/4*3)),Y=oe=>{switch(O){case 3:z[F++]=k|oe,O=0;break;case 2:z[F++]=k|oe>>>2,k=oe<<6,O=3;break;case 1:z[F++]=k|oe>>>4,k=oe<<4,O=2;break;default:k=oe<<2,O=1}};for(let oe=0;oe<P.length;oe++){const re=P.charCodeAt(oe);if(re>=65&&re<=90)Y(re-65);else if(re>=97&&re<=122)Y(re-97+26);else if(re>=48&&re<=57)Y(re-48+52);else if(re===43||re===45)Y(62);else if(re===47||re===95)Y(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${P[oe]}`)}}const J=F;for(;O>0;)Y(0);return u.wrap(z).slice(0,J)}e.decodeBase64=l;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:P},k=!0,O=!1){const F=O?D:S;let z="";const Y=P.byteLength%3;let J=0;for(;J<P.byteLength-Y;J+=3){const oe=P[J+0],re=P[J+1],ce=P[J+2];z+=F[oe>>>2],z+=F[(oe<<4|re>>>4)&63],z+=F[(re<<2|ce>>>6)&63],z+=F[ce&63]}if(Y===1){const oe=P[J+0];z+=F[oe>>>2],z+=F[oe<<4&63],k&&(z+="==")}else if(Y===2){const oe=P[J+0],re=P[J+1];z+=F[oe>>>2],z+=F[(oe<<4|re>>>4)&63],z+=F[re<<2&63],k&&(z+="=")}return z}e.encodeBase64=M}),define(ie[27],ne([0,1,142,71]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function r(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=r;const A=/{(\d+)}/g;function R(ee,...he){return he.length===0?ee:ee.replace(A,function(me,Ee){const Me=parseInt(Ee,10);return isNaN(Me)||Me<0||Me>=he.length?me:he[Me]})}e.format=R;const I=/{([^}]+)}/g;function u(ee,he){return Object.keys(he).length===0?ee:ee.replace(I,(me,Ee)=>he[Ee]??me)}e.format2=u;function a(ee){return ee.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=a;function g(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=g;function w(ee,he){let me=0;const Ee=he.charCodeAt(0);for(let Me=ee.length-1;Me>=0;Me--)ee.charCodeAt(Me)===Ee&&me++;return me}e.count=w;function y(ee,he,me="\u2026"){return ee.length<=he?ee:`${ee.substr(0,he)}${me}`}e.truncate=y;function h(ee,he=" "){const me=b(ee,he);return p(me,he)}e.trim=h;function b(ee,he){if(!ee||!he)return ee;const me=he.length;if(me===0||ee.length===0)return ee;let Ee=0;for(;ee.indexOf(he,Ee)===Ee;)Ee=Ee+me;return ee.substring(Ee)}e.ltrim=b;function p(ee,he){if(!ee||!he)return ee;const me=he.length,Ee=ee.length;if(me===0||Ee===0)return ee;let Me=Ee,Ue=-1;for(;Ue=ee.lastIndexOf(he,Me-1),!(Ue===-1||Ue+me!==Me);){if(Ue===0)return"";Me=Ue}return ee.substring(0,Me)}e.rtrim=p;function v(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function m(ee){return ee.replace(/\*/g,"")}e.stripWildcards=m;function f(ee,he,me={}){if(!ee)throw new Error("Cannot create regex from empty string");he||(ee=g(ee)),me.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let Ee="";return me.global&&(Ee+="g"),me.matchCase||(Ee+="i"),me.multiline&&(Ee+="m"),me.unicode&&(Ee+="u"),new RegExp(ee,Ee)}e.createRegExp=f;function d(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function E(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=E;function c(ee){for(let he=0,me=ee.length;he<me;he++){const Ee=ee.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}e.firstNonWhitespaceIndex=c;function i(ee,he=0,me=ee.length){for(let Ee=he;Ee<me;Ee++){const Me=ee.charCodeAt(Ee);if(Me!==32&&Me!==9)return ee.substring(he,Ee)}return ee.substring(he,me)}e.getLeadingWhitespace=i;function o(ee,he=ee.length-1){for(let me=he;me>=0;me--){const Ee=ee.charCodeAt(me);if(Ee!==32&&Ee!==9)return me}return-1}e.lastNonWhitespaceIndex=o;function s(ee,he,me){const Ee=[];let Me=0;for(const Ue of ee.matchAll(he)){if(Ee.push(ee.slice(Me,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Me=Ue.index+Ue[0].length,Ee.push(me(Ue[0],...Ue.slice(1),Ue.index,ee,Ue.groups))}return Ee.push(ee.slice(Me)),Promise.all(Ee).then(Ue=>Ue.join(""))}e.replaceAsync=s;function t(ee,he){return ee<he?-1:ee>he?1:0}e.compare=t;function n(ee,he,me=0,Ee=ee.length,Me=0,Ue=he.length){for(;me<Ee&&Me<Ue;me++,Me++){const xe=ee.charCodeAt(me),je=he.charCodeAt(Me);if(xe<je)return-1;if(xe>je)return 1}const Oe=Ee-me,Te=Ue-Me;return Oe<Te?-1:Oe>Te?1:0}e.compareSubstring=n;function l(ee,he){return S(ee,he,0,ee.length,0,he.length)}e.compareIgnoreCase=l;function S(ee,he,me=0,Ee=ee.length,Me=0,Ue=he.length){for(;me<Ee&&Me<Ue;me++,Me++){let xe=ee.charCodeAt(me),je=he.charCodeAt(Me);if(xe===je)continue;if(xe>=128||je>=128)return n(ee.toLowerCase(),he.toLowerCase(),me,Ee,Me,Ue);M(xe)&&(xe-=32),M(je)&&(je-=32);const Ve=xe-je;if(Ve!==0)return Ve}const Oe=Ee-me,Te=Ue-Me;return Oe<Te?-1:Oe>Te?1:0}e.compareSubstringIgnoreCase=S;function D(ee){return ee>=48&&ee<=57}e.isAsciiDigit=D;function M(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=M;function P(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=P;function k(ee,he){return ee.length===he.length&&S(ee,he)===0}e.equalsIgnoreCase=k;function O(ee,he){const me=he.length;return he.length>ee.length?!1:S(ee,he,0,me)===0}e.startsWithIgnoreCase=O;function F(ee,he){const me=Math.min(ee.length,he.length);let Ee;for(Ee=0;Ee<me;Ee++)if(ee.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return me}e.commonPrefixLength=F;function z(ee,he){const me=Math.min(ee.length,he.length);let Ee;const Me=ee.length-1,Ue=he.length-1;for(Ee=0;Ee<me;Ee++)if(ee.charCodeAt(Me-Ee)!==he.charCodeAt(Ue-Ee))return Ee;return me}e.commonSuffixLength=z;function Y(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=Y;function J(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=J;function oe(ee,he){return(ee-55296<<10)+(he-56320)+65536}e.computeCodePoint=oe;function re(ee,he,me){const Ee=ee.charCodeAt(me);if(Y(Ee)&&me+1<he){const Me=ee.charCodeAt(me+1);if(J(Me))return oe(Ee,Me)}return Ee}e.getNextCodePoint=re;function ce(ee,he){const me=ee.charCodeAt(he-1);if(J(me)&&he>1){const Ee=ee.charCodeAt(he-2);if(Y(Ee))return oe(Ee,me)}return me}class Q{get offset(){return this._offset}constructor(he,me=0){this._str=he,this._len=he.length,this._offset=me}setOffset(he){this._offset=he}prevCodePoint(){const he=ce(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=re(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(he,me=0){this._iterator=new Q(he,me)}nextGraphemeLength(){const he=le.getInstance(),me=this._iterator,Ee=me.offset;let Me=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ue=me.offset,Oe=he.getGraphemeBreakType(me.nextCodePoint());if(ve(Me,Oe)){me.setOffset(Ue);break}Me=Oe}return me.offset-Ee}prevGraphemeLength(){const he=le.getInstance(),me=this._iterator,Ee=me.offset;let Me=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ue=me.offset,Oe=he.getGraphemeBreakType(me.prevCodePoint());if(ve(Oe,Me)){me.setOffset(Ue);break}Me=Oe}return Ee-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function V(ee,he){return new K(ee,he).nextGraphemeLength()}e.nextCharLength=V;function q(ee,he){return new K(ee,he).prevGraphemeLength()}e.prevCharLength=q;function N(ee,he){he>0&&J(ee.charCodeAt(he))&&he--;const me=he+V(ee,he);return[me-q(ee,me),me]}e.getCharContainingOffset=N;function j(ee){const he=new K(ee);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=j;let H;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function se(ee){return H||(H=X()),H.test(ee)}e.containsRTL=se;const W=/^[\t\n\r\x20-\x7E]*$/;function _(ee){return W.test(ee)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=U;function B(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=B;function T(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=T;function $(ee,he){if(ee.length<he)return ee;const me=/\b/g;let Ee=0;for(;me.test(ee)&&!(ee.length-me.lastIndex<he);)Ee=me.lastIndex,me.lastIndex+=1;return ee.substring(Ee).replace(/^\s/,"")}e.lcut=$;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function fe(ee){return ee&&(ee=ee.replace(x,"").replace(ae,"")),ee}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(ee){return ue(ee)?ee.substr(1):ee}e.stripUTF8BOM=de;function be(ee,he){if(!ee||!he||ee.length<he.length)return!1;const me=he.length,Ee=ee.toLowerCase();let Me=0,Ue=-1;for(;Me<me;){const Oe=Ee.indexOf(he[Me],Ue+1);if(Oe<0)return!1;Ue=Oe,Me++}return!0}e.fuzzyContains=be;function we(ee,he=!1){return ee?(he&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=we;function ye(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=ye;function ke(ee,he=1){if(he===0)return"";let me=-1;do me=ee.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?ee:(ee[me-1]==="\r"&&me--,ee.substr(0,me))}e.getNLines=ke;function Be(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.singleLetterHash=Be;function pe(ee){return le.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=pe;function ve(ee,he){return ee===0?he!==5&&he!==7:ee===2&&he===3?!1:ee===4||ee===2||ee===3||he===4||he===2||he===3?!0:!(ee===8&&(he===8||he===9||he===11||he===12)||(ee===11||ee===9)&&(he===9||he===10)||(ee===12||ee===10)&&he===10||he===5||he===13||he===7||ee===1||ee===13&&he===14||ee===6&&he===6)}var Z;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class le{static{this._INSTANCE=null}static getInstance(){return le._INSTANCE||(le._INSTANCE=new le),le._INSTANCE}constructor(){this._data=ge()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this._data,Ee=me.length/3;let Me=1;for(;Me<=Ee;)if(he<me[3*Me])Me=2*Me;else if(he>me[3*Me+1])Me=2*Me+1;else return me[3*Me+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(ee,he){if(ee===0)return 0;const me=Re(ee,he);if(me!==void 0)return me;const Ee=new Q(he,ee);return Ee.prevCodePoint(),Ee.offset}e.getLeftDeleteOffset=De;function Re(ee,he){const me=new Q(he,ee);let Ee=me.prevCodePoint();for(;We(Ee)||Ee===65039||Ee===8419;){if(me.offset===0)return;Ee=me.prevCodePoint()}if(!T(Ee))return;let Me=me.offset;return Me>0&&me.prevCodePoint()===8205&&(Me=me.offset),Me}function We(ee){return 127995<=ee&&ee<=127999}var Ae;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class He{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new C.LRUCachedFunction(he=>{function me(Ve){const Xe=new Map;for(let Ye=0;Ye<Ve.length;Ye+=2)Xe.set(Ve[Ye],Ve[Ye+1]);return Xe}function Ee(Ve,Xe){const Ye=new Map(Ve);for(const[it,nt]of Xe)Ye.set(it,nt);return Ye}function Me(Ve,Xe){if(!Ve)return Xe;const Ye=new Map;for(const[it,nt]of Ve)Xe.has(it)&&Ye.set(it,nt);return Ye}const Ue=this.ambiguousCharacterData.value;let Oe=he.filter(Ve=>!Ve.startsWith("_")&&Ve in Ue);Oe.length===0&&(Oe=["_default"]);let Te;for(const Ve of Oe){const Xe=me(Ue[Ve]);Te=Me(Te,Xe)}const xe=me(Ue._common),je=Ee(xe,Te);return new He(je)})}static getInstance(he){return He.cache.get(Array.from(he))}static{this._locales=new L.Lazy(()=>Object.keys(He.ambiguousCharacterData.value).filter(he=>!he.startsWith("_")))}static getLocales(){return He._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He;class ze{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(ze.getRawData())),this._data}static isInvisibleCharacter(he){return ze.getData().has(he)}static get codePoints(){return ze.getData()}}e.InvisibleCharacters=ze}),define(ie[55],ne([0,1,27]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(m){return r(m,0)}e.hash=L;function r(m,f){switch(typeof m){case"object":return m===null?A(349,f):Array.isArray(m)?u(m,f):a(m,f);case"string":return I(m,f);case"boolean":return R(m,f);case"number":return A(m,f);case"undefined":return A(937,f);default:return A(617,f)}}e.doHash=r;function A(m,f){return(f<<5)-f+m|0}e.numberHash=A;function R(m,f){return A(m?433:863,f)}function I(m,f){f=A(149417,f);for(let d=0,E=m.length;d<E;d++)f=A(m.charCodeAt(d),f);return f}e.stringHash=I;function u(m,f){return f=A(104579,f),m.reduce((d,E)=>r(E,d),f)}function a(m,f){return f=A(181387,f),Object.keys(m).sort().reduce((d,E)=>(d=I(E,d),r(m[E],d)),f)}class g{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=r(f,this._value),this._value}}e.Hasher=g;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function y(m,f,d=32){const E=d-f,c=~((1<<E)-1);return(m<<f|(c&m)>>>E)>>>0}function h(m,f=0,d=m.byteLength,E=0){for(let c=0;c<d;c++)m[f+c]=E}function b(m,f,d="0"){for(;m.length<f;)m=d+m;return m}function p(m,f=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(d=>d.toString(16).padStart(2,"0")).join(""):b((m>>>0).toString(16),f/4)}e.toHexString=p;class v{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const d=f.length;if(d===0)return;const E=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,o,s;for(i!==0?(o=i,s=-1,i=0):(o=f.charCodeAt(0),s=0);;){let t=o;if(C.isHighSurrogate(o))if(s+1<d){const n=f.charCodeAt(s+1);C.isLowSurrogate(n)?(s++,t=C.computeCodePoint(o,n)):t=65533}else{i=o;break}else C.isLowSurrogate(o)&&(t=65533);if(c=this._push(E,c,t),s++,s<d)o=f.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(f,d,E){return E<128?f[d++]=E:E<2048?(f[d++]=192|(E&1984)>>>6,f[d++]=128|(E&63)>>>0):E<65536?(f[d++]=224|(E&61440)>>>12,f[d++]=128|(E&4032)>>>6,f[d++]=128|(E&63)>>>0):(f[d++]=240|(E&1835008)>>>18,f[d++]=128|(E&258048)>>>12,f[d++]=128|(E&4032)>>>6,f[d++]=128|(E&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=v._bigBlock32,d=this._buffDV;for(let S=0;S<64;S+=4)f.setUint32(S,d.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)f.setUint32(S,y(f.getUint32(S-12,!1)^f.getUint32(S-32,!1)^f.getUint32(S-56,!1)^f.getUint32(S-64,!1),1),!1);let E=this._h0,c=this._h1,i=this._h2,o=this._h3,s=this._h4,t,n,l;for(let S=0;S<80;S++)S<20?(t=c&i|~c&o,n=1518500249):S<40?(t=c^i^o,n=1859775393):S<60?(t=c&i|c&o|i&o,n=2400959708):(t=c^i^o,n=3395469782),l=y(E,5)+t+s+n+f.getUint32(S*4,!1)&4294967295,s=o,o=i,i=y(c,30),c=E,E=l;this._h0=this._h0+E&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=v}),define(ie[73],ne([0,1,27]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(L||(L={})),function(r){const A="error",R="warning",I="warn",u="info",a="ignore";function g(y){return y?C.equalsIgnoreCase(A,y)?r.Error:C.equalsIgnoreCase(R,y)||C.equalsIgnoreCase(I,y)?r.Warning:C.equalsIgnoreCase(u,y)?r.Info:r.Ignore:r.Ignore}r.fromValue=g;function w(y){switch(y){case r.Error:return A;case r.Warning:return R;case r.Info:return u;default:return a}}r.toString=w}(L||(L={})),e.default=L}),define(ie[143],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ie[56],ne([0,1,23,27]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const b=h.charCodeAt(0),p=this._value.charCodeAt(this._pos);return b-p}value(){return this._value[this._pos]}}e.StringIterator=r;class A{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,L.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class R{constructor(h=!0,b=!0){this._splitOnBackslash=h,this._caseSensitive=b}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let b=h.length-1;b>=0;b--,this._valueLen--){const p=this._value.charCodeAt(b);if(!(p===47||this._splitOnBackslash&&p===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const b=this._value.charCodeAt(this._to);if(b===47||this._splitOnBackslash&&b===92)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,L.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var I;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(I||(I={}));class u{constructor(h,b){this._ignorePathCasing=h,this._ignoreQueryAndFragment=b,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===4)return(0,L.compare)(h,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(g||(g={}));class w{static forUris(h=()=>!1,b=()=>!1){return new w(new u(h,b))}static forPaths(h=!1){return new w(new R(void 0,!h))}static forStrings(){return new w(new r)}static forConfigKeys(){return new w(new A)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,b){if(b){const p=b.slice(0);(0,C.shuffle)(p);for(const v of p)this.set(v,h)}else{const p=h.slice(0);(0,C.shuffle)(p);for(const v of p)this.set(v[0],v[1])}}set(h,b){const p=this._iter.reset(h);let v;this._root||(this._root=new a,this._root.segment=p.value());const m=[];for(v=this._root;;){const d=p.cmp(v.segment);if(d>0)v.left||(v.left=new a,v.left.segment=p.value()),m.push([-1,v]),v=v.left;else if(d<0)v.right||(v.right=new a,v.right.segment=p.value()),m.push([1,v]),v=v.right;else if(p.hasNext())p.next(),v.mid||(v.mid=new a,v.mid.segment=p.value()),m.push([0,v]),v=v.mid;else break}const f=v.value;v.value=b,v.key=h;for(let d=m.length-1;d>=0;d--){const E=m[d][1];E.updateHeight();const c=E.balanceFactor();if(c<-1||c>1){const i=m[d][0],o=m[d+1][0];if(i===1&&o===1)m[d][1]=E.rotateLeft();else if(i===-1&&o===-1)m[d][1]=E.rotateRight();else if(i===1&&o===-1)E.right=m[d+1][1]=m[d+1][1].rotateRight(),m[d][1]=E.rotateLeft();else if(i===-1&&o===1)E.left=m[d+1][1]=m[d+1][1].rotateLeft(),m[d][1]=E.rotateRight();else throw new Error;if(d>0)switch(m[d-1][0]){case-1:m[d-1][1].left=m[d][1];break;case 1:m[d-1][1].right=m[d][1];break;case 0:m[d-1][1].mid=m[d][1];break}else this._root=m[0][1]}}return f}get(h){return this._getNode(h)?.value}_getNode(h){const b=this._iter.reset(h);let p=this._root;for(;p;){const v=b.cmp(p.segment);if(v>0)p=p.left;else if(v<0)p=p.right;else if(b.hasNext())b.next(),p=p.mid;else break}return p}has(h){const b=this._getNode(h);return!(b?.value===void 0&&b?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,b){const p=this._iter.reset(h),v=[];let m=this._root;for(;m;){const f=p.cmp(m.segment);if(f>0)v.push([-1,m]),m=m.left;else if(f<0)v.push([1,m]),m=m.right;else if(p.hasNext())p.next(),v.push([0,m]),m=m.mid;else break}if(m){if(b?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const f=this._min(m.right);if(f.key){const{key:d,value:E,segment:c}=f;this._delete(f.key,!1),m.key=d,m.value=E,m.segment=c}}else{const f=m.left??m.right;if(v.length>0){const[d,E]=v[v.length-1];switch(d){case-1:E.left=f;break;case 0:E.mid=f;break;case 1:E.right=f;break}}else this._root=f}for(let f=v.length-1;f>=0;f--){const d=v[f][1];d.updateHeight();const E=d.balanceFactor();if(E>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),v[f][1]=d.rotateLeft()):E<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),v[f][1]=d.rotateRight()),f>0)switch(v[f-1][0]){case-1:v[f-1][1].left=v[f][1];break;case 1:v[f-1][1].right=v[f][1];break;case 0:v[f-1][1].mid=v[f][1];break}else this._root=v[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const b=this._iter.reset(h);let p=this._root,v;for(;p;){const m=b.cmp(p.segment);if(m>0)p=p.left;else if(m<0)p=p.right;else if(b.hasNext())b.next(),v=p.value||v,p=p.mid;else break}return p&&p.value||v}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,b){const p=this._iter.reset(h);let v=this._root;for(;v;){const m=p.cmp(v.segment);if(m>0)v=v.left;else if(m<0)v=v.right;else if(p.hasNext())p.next(),v=v.mid;else return v.mid?this._entries(v.mid):b?v.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[b,p]of this)h(p,b)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const b=[];return this._dfsEntries(h,b),b[Symbol.iterator]()}_dfsEntries(h,b){h&&(h.left&&this._dfsEntries(h.left,b),h.value&&b.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,b),h.right&&this._dfsEntries(h.right,b))}_isBalanced(){const h=b=>{if(!b)return!0;const p=b.balanceFactor();return p<-1||p>1?!1:h(b.left)&&h(b.right)};return h(this._root)}}e.TernarySearchTree=w}),define(ie[12],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function C(c){return typeof c=="string"}e.isString=C;function L(c){return Array.isArray(c)&&c.every(i=>C(i))}e.isStringArray=L;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=r;function A(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.isTypedArray=A;function R(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=R;function I(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=I;function u(c){return c===!0||c===!1}e.isBoolean=u;function a(c){return typeof c>"u"}e.isUndefined=a;function g(c){return!w(c)}e.isDefined=g;function w(c){return a(c)||c===null}e.isUndefinedOrNull=w;function y(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function h(c){if(w(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=h;function b(...c){const i=[];for(let o=0;o<c.length;o++){const s=c[o];if(w(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(s)}return i}e.assertAllDefined=b;const p=Object.prototype.hasOwnProperty;function v(c){if(!r(c))return!1;for(const i in c)if(p.call(c,i))return!1;return!0}e.isEmptyObject=v;function m(c){return typeof c=="function"}e.isFunction=m;function f(...c){return c.length>0&&c.every(m)}e.areFunctions=f;function d(c,i){const o=Math.min(c.length,i.length);for(let s=0;s<o;s++)E(c[s],i[s])}e.validateConstraints=d;function E(c,i){if(C(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(m(i)){try{if(c instanceof i)return}catch{}if(!w(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E}),define(ie[74],ne([0,1,12]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function r(I,u){if((0,C.isString)(u)){const a=L[u];if(a===void 0)throw new Error(`${I} references an unknown codicon: ${u}`);u=a}return L[I]=u,{id:I}}function A(){return L}e.getCodiconFontCharacters=A;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(ie[37],ne([0,1,12]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ensureOptionalStringValue=e.ensureOptionalNumberValue=e.ensureOptionalBooleanValue=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const c=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([i,o])=>{c[i]=o&&typeof o=="object"?L(o):o}),c}e.deepClone=L;function r(E){if(!E||typeof E!="object")return E;const c=[E];for(;c.length>0;){const i=c.shift();Object.freeze(i);for(const o in i)if(A.call(i,o)){const s=i[o];typeof s=="object"&&!Object.isFrozen(s)&&!(0,C.isTypedArray)(s)&&c.push(s)}}return E}e.deepFreeze=r;const A=Object.prototype.hasOwnProperty;function R(E,c){return I(E,c,new Set)}e.cloneAndChange=R;function I(E,c,i){if((0,C.isUndefinedOrNull)(E))return E;const o=c(E);if(typeof o<"u")return o;if(Array.isArray(E)){const s=[];for(const t of E)s.push(I(t,c,i));return s}if((0,C.isObject)(E)){if(i.has(E))throw new Error("Cannot clone recursive data-structure");i.add(E);const s={};for(const t in E)A.call(E,t)&&(s[t]=I(E[t],c,i));return i.delete(E),s}return E}function u(E,c,i=!0){return(0,C.isObject)(E)?((0,C.isObject)(c)&&Object.keys(c).forEach(o=>{o in E?i&&((0,C.isObject)(E[o])&&(0,C.isObject)(c[o])?u(E[o],c[o],i):E[o]=c[o]):E[o]=c[o]}),E):c}e.mixin=u;function a(E,c){if(E===c)return!0;if(E==null||c===null||c===void 0||typeof E!=typeof c||typeof E!="object"||Array.isArray(E)!==Array.isArray(c))return!1;let i,o;if(Array.isArray(E)){if(E.length!==c.length)return!1;for(i=0;i<E.length;i++)if(!a(E[i],c[i]))return!1}else{const s=[];for(o in E)s.push(o);s.sort();const t=[];for(o in c)t.push(o);if(t.sort(),!a(s,t))return!1;for(i=0;i<s.length;i++)if(!a(E[s[i]],c[s[i]]))return!1}return!0}e.equals=a;function g(E){const c=new Set;return JSON.stringify(E,(i,o)=>{if((0,C.isObject)(o)||Array.isArray(o)){if(c.has(o))return"[Circular]";c.add(o)}return o})}e.safeStringify=g;function w(E,c){const i=Object.create(null);return!E||!c||Object.keys(c).forEach(s=>{const t=E[s],n=c[s];a(t,n)||(i[s]=n)}),i}e.distinct=w;function y(E,c){const i=c.toLowerCase(),o=Object.keys(E).find(s=>s.toLowerCase()===i);return o?E[o]:E[c]}e.getCaseInsensitive=y;function h(E,c){const i=Object.create(null);for(const[o,s]of Object.entries(E))c(o,s)&&(i[o]=s);return i}e.filter=h;function b(E){let c=[];for(;Object.prototype!==E;)c=c.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return c}e.getAllPropertyNames=b;function p(E){const c=[];for(const i of b(E))typeof E[i]=="function"&&c.push(i);return c}e.getAllMethodNames=p;function v(E,c){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return c(s,t)},o={};for(const s of E)o[s]=i(s);return o}e.createProxyObject=v;function m(E,c,i){typeof c=="string"&&E[c]!==void 0&&typeof E[c]!="boolean"&&(E[c]=i)}e.ensureOptionalBooleanValue=m;function f(E,c,i){typeof c=="string"&&E[c]!==void 0&&typeof E[c]!="number"&&(E[c]=i)}e.ensureOptionalNumberValue=f;function d(E,c,i,o){if(typeof c!="string")return;const s=E[c];s!==void 0&&(typeof s!="string"||!i.includes(s))&&(E[c]=o)}e.ensureOptionalStringValue=d}),define(ie[102],ne([0,1,74]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(R){function I(u){return u&&typeof u=="object"&&typeof u.id=="string"}R.isThemeColor=I})(L||(e.ThemeColor=L={}));function r(R){return{id:R}}e.themeColorFromId=r;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function u(f){const d=I.exec(f.id);if(!d)return u(C.Codicon.error);const[,E,c]=d,i=["codicon","codicon-"+E];return c&&i.push("codicon-modifier-"+c.substring(1)),i}R.asClassNameArray=u;function a(f){return u(f).join(" ")}R.asClassName=a;function g(f){return"."+u(f).join(".")}R.asCSSSelector=g;function w(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||L.isThemeColor(f.color))}R.isThemeIcon=w;const y=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function h(f){const d=y.exec(f);if(!d)return;const[,E]=d;return{id:E}}R.fromString=h;function b(f){return{id:f}}R.fromId=b;function p(f,d){let E=f.id;const c=E.lastIndexOf("~");return c!==-1&&(E=E.substring(0,c)),d&&(E=`${E}~${d}`),{id:E}}R.modify=p;function v(f){const d=f.id.lastIndexOf("~");if(d!==-1)return f.id.substring(d+1)}R.getModifier=v;function m(f,d){return f.id===d.id&&f.color?.id===d.color?.id}R.isEqual=m})(A||(e.ThemeIcon=A={}))}),define(ie[32],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(r){return C.test(r)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(I){for(let u=0;u<I.length;u++)I[u]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),R=[];for(let I=0;I<256;I++)R.push(I.toString(16).padStart(2,"0"));return function(){r(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,a="";return a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a}}()}),define(ie[144],ne([0,1,86,45,84]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function A(R,I){if(await new Promise((g,w)=>{const y=L.createReadStream(R),h=C.createHash("sha1");y.pipe(h);const b=(0,r.createSingleCallFunction)((p,v)=>{y.removeAllListeners(),h.removeAllListeners(),p?w(p):g(v)});y.once("error",b),y.once("end",b),h.once("error",b),h.once("data",p=>b(void 0,p.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=A}),define(ie[145],ne([0,1,28]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(R){const I=R.replace(/\-/g,":").toLowerCase();return!L.has(I)}function A(){const R=(0,C.networkInterfaces)();for(const I in R){const u=R[I];if(u){for(const{mac:a}of u)if(r(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ie[103],ne([0,1,87]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(I,u,a,g=1){let w=!1;return new Promise(y=>{const h=setTimeout(()=>{if(!w)return w=!0,y(0)},a);r(I,u,g,b=>{if(!w)return w=!0,clearTimeout(h),y(b)})})}e.findFreePort=L;function r(I,u,a,g){if(u===0)return g(0);const w=new C.Socket;w.once("connect",()=>(R(w),r(I+a,u-1,a,g))),w.once("data",()=>{}),w.once("error",y=>(R(w),y.code!=="ECONNREFUSED"?r(I+a,u-1,a,g):g(I))),w.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,u,a,g="127.0.0.1"){let w=!1,y,h=1;const b=C.createServer({pauseOnConnect:!0});function p(v,m){w||(w=!0,b.removeAllListeners(),b.close(),y&&clearTimeout(y),m(v))}return new Promise(v=>{y=setTimeout(()=>{p(0,v)},a),b.on("listening",()=>{p(I,v)}),b.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&h<u?(I++,h++,b.listen(I,g)):p(0,v)}),b.on("close",()=>{p(0,v)}),b.listen(I,g)})}e.findFreePortFaster=A;function R(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(u){console.error(u)}}}),function(){function G(){function e(){return process.uncHostAllowlist}function C(u){const a=new Set;if(Array.isArray(u))for(const g of u)typeof g=="string"&&a.add(g);return Array.from(a)}function L(){const u=e();return u?Array.from(u):[]}function r(u){if(process.platform!=="win32")return;const a=e();if(a)if(typeof u=="string")a.add(u.toLowerCase());else for(const g of C(u))r(g)}function A(u){if(typeof u!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const w of a){if(u.indexOf(w)!==0)continue;const h=u.indexOf("\\",w.length);if(h===-1)continue;const b=u.substring(w.length,h);if(b){g=b;break}}return g}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:r,getUNCHost:A,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return G()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=G():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ie[146],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ie[147],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class C{constructor(r,A){this.sender=r,this.onMessage=A}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=C}),define(ie[148],ne([11,10]),function(G,e){return G.create("vs/base/common/date",e)}),define(ie[149],ne([0,1,148]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,r=L*60,A=r*24,R=A*7,I=A*30,u=A*365;function a(w,y,h,b){typeof w!="number"&&(w=w.getTime());const p=Math.round((new Date().getTime()-w)/1e3);if(p<-30)return(0,C.localize)(0,null,a(new Date().getTime()+p*1e3,!1));if(!b&&p<30)return(0,C.localize)(1,null);let v;return p<L?(v=p,y?v===1?h?(0,C.localize)(2,null,v):(0,C.localize)(3,null,v):h?(0,C.localize)(4,null,v):(0,C.localize)(5,null,v):v===1?h?(0,C.localize)(6,null,v):(0,C.localize)(7,null,v):h?(0,C.localize)(8,null,v):(0,C.localize)(9,null,v)):p<r?(v=Math.floor(p/L),y?v===1?h?(0,C.localize)(10,null,v):(0,C.localize)(11,null,v):h?(0,C.localize)(12,null,v):(0,C.localize)(13,null,v):v===1?h?(0,C.localize)(14,null,v):(0,C.localize)(15,null,v):h?(0,C.localize)(16,null,v):(0,C.localize)(17,null,v)):p<A?(v=Math.floor(p/r),y?v===1?h?(0,C.localize)(18,null,v):(0,C.localize)(19,null,v):h?(0,C.localize)(20,null,v):(0,C.localize)(21,null,v):v===1?h?(0,C.localize)(22,null,v):(0,C.localize)(23,null,v):h?(0,C.localize)(24,null,v):(0,C.localize)(25,null,v)):p<R?(v=Math.floor(p/A),y?v===1?(0,C.localize)(26,null,v):(0,C.localize)(27,null,v):v===1?(0,C.localize)(28,null,v):(0,C.localize)(29,null,v)):p<I?(v=Math.floor(p/R),y?v===1?h?(0,C.localize)(30,null,v):(0,C.localize)(31,null,v):h?(0,C.localize)(32,null,v):(0,C.localize)(33,null,v):v===1?h?(0,C.localize)(34,null,v):(0,C.localize)(35,null,v):h?(0,C.localize)(36,null,v):(0,C.localize)(37,null,v)):p<u?(v=Math.floor(p/I),y?v===1?h?(0,C.localize)(38,null,v):(0,C.localize)(39,null,v):h?(0,C.localize)(40,null,v):(0,C.localize)(41,null,v):v===1?h?(0,C.localize)(42,null,v):(0,C.localize)(43,null,v):h?(0,C.localize)(44,null,v):(0,C.localize)(45,null,v)):(v=Math.floor(p/u),y?v===1?h?(0,C.localize)(46,null,v):(0,C.localize)(47,null,v):h?(0,C.localize)(48,null,v):(0,C.localize)(49,null,v):v===1?h?(0,C.localize)(50,null,v):(0,C.localize)(51,null,v):h?(0,C.localize)(52,null,v):(0,C.localize)(53,null,v))}e.fromNow=a;function g(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=g}),define(ie[150],ne([11,10]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ie[49],ne([0,1,23,12,150]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(w,y){return y&&(w.stack||w.stacktrace)?r.localize(0,null,I(w),R(w.stack)||R(w.stacktrace)):I(w)}function R(w){return Array.isArray(w)?w.join(`
`):w}function I(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?r.localize(1,null,w.message):w.message||r.localize(2,null)}function u(w=null,y=!1){if(!w)return r.localize(3,null);if(Array.isArray(w)){const h=C.coalesce(w),b=u(h[0],y);return h.length>1?r.localize(4,null,b,h.length):b}if(L.isString(w))return w;if(w.detail){const h=w.detail;if(h.error)return A(h.error,y);if(h.exception)return A(h.exception,y)}return w.stack?A(w,y):w.message?w.message:r.localize(5,null)}e.toErrorMessage=u;function a(w){const y=w;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=a;function g(w,y){let h;return typeof w=="string"?h=new Error(w):h=w,h.actions=y,h}e.createErrorWithActions=g}),define(ie[151],ne([11,10]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ie[152],ne([0,1,151]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(r){switch(r){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ie[153],ne([11,10]),function(G,e){return G.create("vs/base/common/platform",e)}),define(ie[4],ne([0,1,153]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,r=!1,A=!1,R=!1,I=!1,u=!1,a=!1,g=!1,w=!1,y=!1,h,b=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT,v,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const d=typeof f?.versions?.electron=="string",E=d&&f?.type==="renderer";if(typeof navigator=="object"&&!E)m=navigator.userAgent,L=m.indexOf("Windows")>=0,r=m.indexOf("Macintosh")>=0,g=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=m.indexOf("Linux")>=0,y=m?.indexOf("Mobi")>=0,u=!0,h=C.getConfiguredDefaultLocale(C.localize(0,null))||e.LANGUAGE_DEFAULT,b=h,p=navigator.language;else if(typeof f=="object"){L=f.platform==="win32",r=f.platform==="darwin",A=f.platform==="linux",R=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,a=d,w=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT;const D=f.env.VSCODE_NLS_CONFIG;if(D)try{const M=JSON.parse(D),P=M.availableLanguages["*"];h=M.locale,p=M.osLocale,b=P||e.LANGUAGE_DEFAULT,v=M._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var c;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(c||(e.Platform=c={}));function i(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let o=0;r?o=1:L?o=3:A&&(o=2),e.isWindows=L,e.isMacintosh=r,e.isLinux=A,e.isLinuxSnap=R,e.isNative=I,e.isElectron=a,e.isWeb=u,e.isWebWorker=u&&typeof e.globals.importScripts=="function",e.isIOS=g,e.isMobile=y,e.isCI=w,e.platform=o,e.userAgent=m,e.language=b;var s;(function(D){function M(){return e.language}D.value=M;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}D.isDefaultVariant=P;function k(){return e.language==="en"}D.isDefault=k})(s||(e.Language=s={})),e.locale=h,e.platformLocale=p,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const D=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let k=0,O=D.length;k<O;k++){const F=D[k];if(F.id===P.data.vscodeScheduleAsyncWork){D.splice(k,1),F.callback();return}}});let M=0;return P=>{const k=++M;D.push({id:k,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return D=>setTimeout(D)})();var t;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=r||g?2:L?1:3;let n=!0,l=!1;function S(){if(!l){l=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,n=new Uint16Array(D.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=S,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ie[35],ne([0,1,4]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof C.globals.vscode<"u"&&typeof C.globals.vscode.process<"u"){const r=C.globals.vscode.process;L={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return C.isWindows?"win32":C.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ie[9],ne([0,1,35]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,r=97,A=90,R=122,I=46,u=47,a=92,g=58,w=63;class y extends Error{constructor(o,s,t){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const l=o.indexOf(".")!==-1?"property":"argument";let S=`The "${o}" ${l} ${n} of type ${s}`;S+=`. Received type ${typeof t}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,o){if(i===null||typeof i!="object")throw new y(o,"Object",i)}function b(i,o){if(typeof i!="string")throw new y(o,"string",i)}const p=C.platform==="win32";function v(i){return i===u||i===a}function m(i){return i===u}function f(i){return i>=L&&i<=A||i>=r&&i<=R}function d(i,o,s,t){let n="",l=0,S=-1,D=0,M=0;for(let P=0;P<=i.length;++P){if(P<i.length)M=i.charCodeAt(P);else{if(t(M))break;M=u}if(t(M)){if(!(S===P-1||D===1))if(D===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const k=n.lastIndexOf(s);k===-1?(n="",l=0):(n=n.slice(0,k),l=n.length-1-n.lastIndexOf(s)),S=P,D=0;continue}else if(n.length!==0){n="",l=0,S=P,D=0;continue}}o&&(n+=n.length>0?`${s}..`:"..",l=2)}else n.length>0?n+=`${s}${i.slice(S+1,P)}`:n=i.slice(S+1,P),l=P-S-1;S=P,D=0}else M===I&&D!==-1?++D:D=-1}return n}function E(i,o){h(o,"pathObject");const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${i}${t}`:t}e.win32={resolve(...i){let o="",s="",t=!1;for(let n=i.length-1;n>=-1;n--){let l;if(n>=0){if(l=i[n],b(l,"path"),l.length===0)continue}else o.length===0?l=C.cwd():(l=C.env[`=${o}`]||C.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===a)&&(l=`${o}\\`));const S=l.length;let D=0,M="",P=!1;const k=l.charCodeAt(0);if(S===1)v(k)&&(D=1,P=!0);else if(v(k))if(P=!0,v(l.charCodeAt(1))){let O=2,F=O;for(;O<S&&!v(l.charCodeAt(O));)O++;if(O<S&&O!==F){const z=l.slice(F,O);for(F=O;O<S&&v(l.charCodeAt(O));)O++;if(O<S&&O!==F){for(F=O;O<S&&!v(l.charCodeAt(O));)O++;(O===S||O!==F)&&(M=`\\\\${z}\\${l.slice(F,O)}`,D=O)}}}else D=1;else f(k)&&l.charCodeAt(1)===g&&(M=l.slice(0,2),D=2,S>2&&v(l.charCodeAt(2))&&(P=!0,D=3));if(M.length>0)if(o.length>0){if(M.toLowerCase()!==o.toLowerCase())continue}else o=M;if(t){if(o.length>0)break}else if(s=`${l.slice(D)}\\${s}`,t=P,P&&o.length>0)break}return s=d(s,!t,"\\",v),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){b(i,"path");const o=i.length;if(o===0)return".";let s=0,t,n=!1;const l=i.charCodeAt(0);if(o===1)return m(l)?"\\":i;if(v(l))if(n=!0,v(i.charCodeAt(1))){let D=2,M=D;for(;D<o&&!v(i.charCodeAt(D));)D++;if(D<o&&D!==M){const P=i.slice(M,D);for(M=D;D<o&&v(i.charCodeAt(D));)D++;if(D<o&&D!==M){for(M=D;D<o&&!v(i.charCodeAt(D));)D++;if(D===o)return`\\\\${P}\\${i.slice(M)}\\`;D!==M&&(t=`\\\\${P}\\${i.slice(M,D)}`,s=D)}}}else s=1;else f(l)&&i.charCodeAt(1)===g&&(t=i.slice(0,2),s=2,o>2&&v(i.charCodeAt(2))&&(n=!0,s=3));let S=s<o?d(i.slice(s),!n,"\\",v):"";return S.length===0&&!n&&(S="."),S.length>0&&v(i.charCodeAt(o-1))&&(S+="\\"),t===void 0?n?`\\${S}`:S:n?`${t}\\${S}`:`${t}${S}`},isAbsolute(i){b(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return v(s)||o>2&&f(s)&&i.charCodeAt(1)===g&&v(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let l=0;l<i.length;++l){const S=i[l];b(S,"path"),S.length>0&&(o===void 0?o=s=S:o+=`\\${S}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++n;const l=s.length;l>1&&v(s.charCodeAt(1))&&(++n,l>2&&(v(s.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&v(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.win32.normalize(o)},relative(i,o){if(b(i,"from"),b(o,"to"),i===o)return"";const s=e.win32.resolve(i),t=e.win32.resolve(o);if(s===t||(i=s.toLowerCase(),o=t.toLowerCase(),i===o))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===a;)n++;let l=i.length;for(;l-1>n&&i.charCodeAt(l-1)===a;)l--;const S=l-n;let D=0;for(;D<o.length&&o.charCodeAt(D)===a;)D++;let M=o.length;for(;M-1>D&&o.charCodeAt(M-1)===a;)M--;const P=M-D,k=S<P?S:P;let O=-1,F=0;for(;F<k;F++){const Y=i.charCodeAt(n+F);if(Y!==o.charCodeAt(D+F))break;Y===a&&(O=F)}if(F!==k){if(O===-1)return t}else{if(P>k){if(o.charCodeAt(D+F)===a)return t.slice(D+F+1);if(F===2)return t.slice(D+F)}S>k&&(i.charCodeAt(n+F)===a?O=F:F===2&&(O=3)),O===-1&&(O=0)}let z="";for(F=n+O+1;F<=l;++F)(F===l||i.charCodeAt(F)===a)&&(z+=z.length===0?"..":"\\..");return D+=O,z.length>0?`${z}${t.slice(D,M)}`:(t.charCodeAt(D)===a&&++D,t.slice(D,M))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===a){if(o.charCodeAt(1)===a){const s=o.charCodeAt(2);if(s!==w&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===a)return`\\\\?\\${o}`;return i},dirname(i){b(i,"path");const o=i.length;if(o===0)return".";let s=-1,t=0;const n=i.charCodeAt(0);if(o===1)return v(n)?i:".";if(v(n)){if(s=t=1,v(i.charCodeAt(1))){let D=2,M=D;for(;D<o&&!v(i.charCodeAt(D));)D++;if(D<o&&D!==M){for(M=D;D<o&&v(i.charCodeAt(D));)D++;if(D<o&&D!==M){for(M=D;D<o&&!v(i.charCodeAt(D));)D++;if(D===o)return i;D!==M&&(s=t=D+1)}}}}else f(n)&&i.charCodeAt(1)===g&&(s=o>2&&v(i.charCodeAt(2))?3:2,t=s);let l=-1,S=!0;for(let D=o-1;D>=t;--D)if(v(i.charCodeAt(D))){if(!S){l=D;break}}else S=!1;if(l===-1){if(s===-1)return".";l=s}return i.slice(0,l)},basename(i,o){o!==void 0&&b(o,"ext"),b(i,"path");let s=0,t=-1,n=!0,l;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let S=o.length-1,D=-1;for(l=i.length-1;l>=s;--l){const M=i.charCodeAt(l);if(v(M)){if(!n){s=l+1;break}}else D===-1&&(n=!1,D=l+1),S>=0&&(M===o.charCodeAt(S)?--S===-1&&(t=l):(S=-1,t=D))}return s===t?t=D:t===-1&&(t=i.length),i.slice(s,t)}for(l=i.length-1;l>=s;--l)if(v(i.charCodeAt(l))){if(!n){s=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":i.slice(s,t)},extname(i){b(i,"path");let o=0,s=-1,t=0,n=-1,l=!0,S=0;i.length>=2&&i.charCodeAt(1)===g&&f(i.charCodeAt(0))&&(o=t=2);for(let D=i.length-1;D>=o;--D){const M=i.charCodeAt(D);if(v(M)){if(!l){t=D+1;break}continue}n===-1&&(l=!1,n=D+1),M===I?s===-1?s=D:S!==1&&(S=1):s!==-1&&(S=-1)}return s===-1||n===-1||S===0||S===1&&s===n-1&&s===t+1?"":i.slice(s,n)},format:E.bind(null,"\\"),parse(i){b(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let t=0,n=i.charCodeAt(0);if(s===1)return v(n)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(v(n)){if(t=1,v(i.charCodeAt(1))){let O=2,F=O;for(;O<s&&!v(i.charCodeAt(O));)O++;if(O<s&&O!==F){for(F=O;O<s&&v(i.charCodeAt(O));)O++;if(O<s&&O!==F){for(F=O;O<s&&!v(i.charCodeAt(O));)O++;O===s?t=O:O!==F&&(t=O+1)}}}}else if(f(n)&&i.charCodeAt(1)===g){if(s<=2)return o.root=o.dir=i,o;if(t=2,v(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let l=-1,S=t,D=-1,M=!0,P=i.length-1,k=0;for(;P>=t;--P){if(n=i.charCodeAt(P),v(n)){if(!M){S=P+1;break}continue}D===-1&&(M=!1,D=P+1),n===I?l===-1?l=P:k!==1&&(k=1):l!==-1&&(k=-1)}return D!==-1&&(l===-1||k===0||k===1&&l===D-1&&l===S+1?o.base=o.name=i.slice(S,D):(o.name=i.slice(S,l),o.base=i.slice(S,D),o.ext=i.slice(l,D))),S>0&&S!==t?o.dir=i.slice(0,S-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(p){const i=/\\/g;return()=>{const o=C.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>C.cwd()})();e.posix={resolve(...i){let o="",s=!1;for(let t=i.length-1;t>=-1&&!s;t--){const n=t>=0?i[t]:c();b(n,"path"),n.length!==0&&(o=`${n}/${o}`,s=n.charCodeAt(0)===u)}return o=d(o,!s,"/",m),s?`/${o}`:o.length>0?o:"."},normalize(i){if(b(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===u,s=i.charCodeAt(i.length-1)===u;return i=d(i,!o,"/",m),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return b(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const t=i[s];b(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(b(i,"from"),b(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const s=1,t=i.length,n=t-s,l=1,S=o.length-l,D=n<S?n:S;let M=-1,P=0;for(;P<D;P++){const O=i.charCodeAt(s+P);if(O!==o.charCodeAt(l+P))break;O===u&&(M=P)}if(P===D)if(S>D){if(o.charCodeAt(l+P)===u)return o.slice(l+P+1);if(P===0)return o.slice(l+P)}else n>D&&(i.charCodeAt(s+P)===u?M=P:P===0&&(M=0));let k="";for(P=s+M+1;P<=t;++P)(P===t||i.charCodeAt(P)===u)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(l+M)}`},toNamespacedPath(i){return i},dirname(i){if(b(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===u;let s=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===u){if(!t){s=n;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&b(o,"ext"),b(i,"path");let s=0,t=-1,n=!0,l;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let S=o.length-1,D=-1;for(l=i.length-1;l>=0;--l){const M=i.charCodeAt(l);if(M===u){if(!n){s=l+1;break}}else D===-1&&(n=!1,D=l+1),S>=0&&(M===o.charCodeAt(S)?--S===-1&&(t=l):(S=-1,t=D))}return s===t?t=D:t===-1&&(t=i.length),i.slice(s,t)}for(l=i.length-1;l>=0;--l)if(i.charCodeAt(l)===u){if(!n){s=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":i.slice(s,t)},extname(i){b(i,"path");let o=-1,s=0,t=-1,n=!0,l=0;for(let S=i.length-1;S>=0;--S){const D=i.charCodeAt(S);if(D===u){if(!n){s=S+1;break}continue}t===-1&&(n=!1,t=S+1),D===I?o===-1?o=S:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||t===-1||l===0||l===1&&o===t-1&&o===s+1?"":i.slice(o,t)},format:E.bind(null,"/"),parse(i){b(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===u;let t;s?(o.root="/",t=1):t=0;let n=-1,l=0,S=-1,D=!0,M=i.length-1,P=0;for(;M>=t;--M){const k=i.charCodeAt(M);if(k===u){if(!D){l=M+1;break}continue}S===-1&&(D=!1,S=M+1),k===I?n===-1?n=M:P!==1&&(P=1):n!==-1&&(P=-1)}if(S!==-1){const k=l===0&&s?1:l;n===-1||P===0||P===1&&n===S-1&&n===l+1?o.base=o.name=i.slice(k,S):(o.name=i.slice(k,n),o.base=i.slice(k,S),o.ext=i.slice(n,S))}return l>0?o.dir=i.slice(0,l-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(ie[33],ne([0,1,9,4,27,12]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(l){return l===47||l===92}e.isPathSeparator=R;function I(l){return l.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=I;function u(l){return l.indexOf("/")===-1&&(l=I(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=u;function a(l,S=C.posix.sep){if(!l)return"";const D=l.length,M=l.charCodeAt(0);if(R(M)){if(R(l.charCodeAt(1))&&!R(l.charCodeAt(2))){let k=3;const O=k;for(;k<D&&!R(l.charCodeAt(k));k++);if(O!==k&&!R(l.charCodeAt(k+1))){for(k+=1;k<D;k++)if(R(l.charCodeAt(k)))return l.slice(0,k+1).replace(/[\\/]/g,S)}}return S}else if(m(M)&&l.charCodeAt(1)===58)return R(l.charCodeAt(2))?l.slice(0,2)+S:l.slice(0,2);let P=l.indexOf("://");if(P!==-1){for(P+=3;P<D;P++)if(R(l.charCodeAt(P)))return l.slice(0,P+1)}return""}e.getRoot=a;function g(l){if(!L.isWindows||!l||l.length<5)return!1;let S=l.charCodeAt(0);if(S!==92||(S=l.charCodeAt(1),S!==92))return!1;let D=2;const M=D;for(;D<l.length&&(S=l.charCodeAt(D),S!==92);D++);return!(M===D||(S=l.charCodeAt(D+1),isNaN(S)||S===92))}e.isUNC=g;const w=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(l,S=L.isWindows){const D=S?w:y;return!(!l||l.length===0||/^\s+$/.test(l)||(D.lastIndex=0,D.test(l))||S&&h.test(l)||l==="."||l===".."||S&&l[l.length-1]==="."||S&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=b;function p(l,S,D){const M=l===S;return!D||M?M:!l||!S?!1:(0,r.equalsIgnoreCase)(l,S)}e.isEqual=p;function v(l,S,D,M=C.sep){if(l===S)return!0;if(!l||!S||S.length>l.length)return!1;if(D){if(!(0,r.startsWithIgnoreCase)(l,S))return!1;if(S.length===l.length)return!0;let k=S.length;return S.charAt(S.length-1)===M&&k--,l.charAt(k)===M}return S.charAt(S.length-1)!==M&&(S+=M),l.indexOf(S)===0}e.isEqualOrParent=v;function m(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=m;function f(l,S){return L.isWindows&&l.endsWith(":")&&(l+=C.sep),(0,C.isAbsolute)(l)||(l=(0,C.join)(S,l)),l=(0,C.normalize)(l),L.isWindows?(l=(0,r.rtrim)(l,C.sep),l.endsWith(":")&&(l+=C.sep)):(l=(0,r.rtrim)(l,C.sep),l||(l=C.sep)),l}e.sanitizeFilePath=f;function d(l){const S=(0,C.normalize)(l);return L.isWindows?l.length>3?!1:E(S)&&(l.length===2||S.charCodeAt(2)===92):S===C.posix.sep}e.isRootOrDriveLetter=d;function E(l,S=L.isWindows){return S?m(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function c(l,S=L.isWindows){return E(l,S)?l[0]:void 0}e.getDriveLetter=c;function i(l,S,D){return S.length>l.length?-1:l===S?0:(D&&(l=l.toLowerCase(),S=S.toLowerCase()),l.indexOf(S))}e.indexOfPath=i;function o(l){const S=l.split(":");let D,M,P;for(const k of S){const O=Number(k);(0,A.isNumber)(O)?M===void 0?M=O:P===void 0&&(P=O):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:M!==void 0?M:void 0,column:P!==void 0?P:M!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(l,S,D=8){let M="";for(let k=0;k<D;k++){let O;k===0&&L.isWindows&&!S&&(D===3||D===4)?O=t:O=s,M+=O.charAt(Math.floor(Math.random()*O.length))}let P;return S?P=`${S}-${M}`:P=M,l?(0,C.join)(l,P):P}e.randomPath=n}),define(ie[75],ne([0,1,4]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L||(e.Source=L={}));var r;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function A(I,...u){const a=u.reduce((y,h)=>(y[h]=!0,y),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(y=>!a[y]).forEach(y=>{for(let h=0;h<g.length;h++)if(y.search(g[h])!==-1){delete I[y];break}})}e.sanitizeProcessEnvironment=A;function R(I){I&&(delete I.DEBUG,C.isMacintosh&&delete I.DYLD_LIBRARY_PATH,C.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(ie[7],ne([0,1,9,4]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function I(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!r.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(t,n){return!t&&!n?"file":t}function a(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const g="",w="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,l,S,D,M,P=!1){typeof n=="object"?(this.scheme=n.scheme||g,this.authority=n.authority||g,this.path=n.path||g,this.query=n.query||g,this.fragment=n.fragment||g):(this.scheme=u(n,P),this.authority=l||g,this.path=a(this.scheme,S||g),this.query=D||g,this.fragment=M||g,I(this,P))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:S,path:D,query:M,fragment:P}=n;return l===void 0?l=this.scheme:l===null&&(l=g),S===void 0?S=this.authority:S===null&&(S=g),D===void 0?D=this.path:D===null&&(D=g),M===void 0?M=this.query:M===null&&(M=g),P===void 0?P=this.fragment:P===null&&(P=g),l===this.scheme&&S===this.authority&&D===this.path&&M===this.query&&P===this.fragment?this:new v(l,S,D,M,P)}static parse(n,l=!1){const S=y.exec(n);return S?new v(S[2]||g,s(S[4]||g),s(S[5]||g),s(S[7]||g),s(S[9]||g),l):new v(g,g,g,g,g)}static file(n){let l=g;if(L.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const S=n.indexOf(w,2);S===-1?(l=n.substring(2),n=w):(l=n.substring(2,S),n=n.substring(S)||w)}return new v("file",l,n,g,g)}static from(n,l){return new v(n.scheme,n.authority,n.path,n.query,n.fragment,l)}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return L.isWindows&&n.scheme==="file"?S=h.file(C.win32.join(E(n,!0),...l)).path:S=C.posix.join(n.path,...l),n.with({path:S})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const l=new v(n);return l._formatted=n.external??null,l._fsPath=n._sep===p?n.fsPath??null:null,l}}else return n}}e.URI=h;function b(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.isUriComponents=b;const p=L.isWindows?1:void 0;class v extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=p),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(t,n,l){let S,D=-1;for(let M=0;M<t.length;M++){const P=t.charCodeAt(M);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47||l&&P===91||l&&P===93||l&&P===58)D!==-1&&(S+=encodeURIComponent(t.substring(D,M)),D=-1),S!==void 0&&(S+=t.charAt(M));else{S===void 0&&(S=t.substr(0,M));const k=m[P];k!==void 0?(D!==-1&&(S+=encodeURIComponent(t.substring(D,M)),D=-1),S+=k):D===-1&&(D=M)}}return D!==-1&&(S+=encodeURIComponent(t.substring(D))),S!==void 0?S:t}function d(t){let n;for(let l=0;l<t.length;l++){const S=t.charCodeAt(l);S===35||S===63?(n===void 0&&(n=t.substr(0,l)),n+=m[S]):n!==void 0&&(n+=t[l])}return n!==void 0?n:t}function E(t,n){let l;return t.authority&&t.path.length>1&&t.scheme==="file"?l=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?l=t.path.substr(1):l=t.path[1].toLowerCase()+t.path.substr(2):l=t.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=E;function c(t,n){const l=n?d:f;let S="",{scheme:D,authority:M,path:P,query:k,fragment:O}=t;if(D&&(S+=D,S+=":"),(M||D==="file")&&(S+=w,S+=w),M){let F=M.indexOf("@");if(F!==-1){const z=M.substr(0,F);M=M.substr(F+1),F=z.lastIndexOf(":"),F===-1?S+=l(z,!1,!1):(S+=l(z.substr(0,F),!1,!1),S+=":",S+=l(z.substr(F+1),!1,!0)),S+="@"}M=M.toLowerCase(),F=M.lastIndexOf(":"),F===-1?S+=l(M,!1,!0):(S+=l(M.substr(0,F),!1,!0),S+=M.substr(F))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const F=P.charCodeAt(1);F>=65&&F<=90&&(P=`/${String.fromCharCode(F+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const F=P.charCodeAt(0);F>=65&&F<=90&&(P=`${String.fromCharCode(F+32)}:${P.substr(2)}`)}S+=l(P,!0,!1)}return k&&(S+="?",S+=l(k,!1,!1)),O&&(S+="#",S+=n?O:f(O,!1,!1)),S}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(o)?t.replace(o,n=>i(n)):t}}),define(ie[154],ne([0,1,7]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.isRemoteConsoleLog=L;function r(a){const g=[];let w;try{const y=JSON.parse(a.arguments),h=y[y.length-1];h&&h.__$stack&&(y.pop(),w=h.__$stack),g.push(...y)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:w}}e.parse=r;function A(a){if(typeof a!="string")return A(r(a).stack);const g=a;if(g){const w=R(g),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(y&&y.length===4)return{uri:C.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=A;function R(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function I(a,g){const{args:w,stack:y}=r(a),h=typeof w[0]=="string"&&w.length===1;let b=R(y);b&&(b=`(${b.trim()})`);let p=[];if(typeof w[0]=="string"?b&&h?p=[`%c[${g}] %c${w[0]} %c${b}`,u("blue"),u(""),u("grey")]:p=[`%c[${g}] %c${w[0]}`,u("blue"),u(""),...w.slice(1)]:p=[`%c[${g}]%`,u("blue"),...w],b&&!h&&p.push(b),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,p)}e.log=I;function u(a){return`color: ${a}`}}),define(ie[76],ne([0,1,17,7]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function r(u){return JSON.stringify(u,R)}e.stringify=r;function A(u){let a=JSON.parse(u);return a=I(a),a}e.parse=A;function R(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function I(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return L.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof C.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let g=0;g<u.length;++g)u[g]=I(u[g],a+1);else for(const g in u)Object.hasOwnProperty.call(u,g)&&(u[g]=I(u[g],a+1))}return u}e.revive=I}),define(ie[13],ne([0,1,14,4,7]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g){this._remoteResourcesPath=`${g}/${A.vscodeRemoteResource}`}set(g,w,y){this._hosts[g]=w,this._ports[g]=y}setConnectionToken(g,w){this._connectionTokens[g]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)try{return this._delegate(g)}catch(v){return C.onUnexpectedError(v),g}const w=g.authority;let y=this._hosts[w];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const h=this._ports[w],b=this._connectionTokens[w];let p=`path=${encodeURIComponent(g.path)}`;return typeof b=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),r.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${y}:${h}`,path:this._remoteResourcesPath,query:p})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class I{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(g){const w=this.toUri(g,G);return this.uriToBrowserUri(w)}uriToBrowserUri(g){return g.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(g):g.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?g.with({scheme:A.vscodeFileResource,authority:g.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(g){const w=this.toUri(g,G);return this.uriToFileUri(w)}uriToFileUri(g){return g.scheme===A.vscodeFileResource?g.with({scheme:A.file,authority:g.authority!==I.FALLBACK_AUTHORITY?g.authority:null,query:null,fragment:null}):g}toUri(g,w){return r.URI.isUri(g)?g:r.URI.parse(w.toUrl(g))}}e.FileAccess=new I;var u;(function(a){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(g.get("3"));const w="vscode-coi";function y(b){let p;typeof b=="string"?p=new URL(b).searchParams:b instanceof URL?p=b.searchParams:r.URI.isUri(b)&&(p=new URL(b.toString(!0)).searchParams);const v=p?.get(w);if(v)return g.get(v)}a.getHeadersFromQuery=y;function h(b,p,v){if(!globalThis.crossOriginIsolated)return;const m=p&&v?"3":v?"2":"1";b instanceof URLSearchParams?b.set(w,m):b[w]=m}a.addSearchParam=h})(u||(e.COI=u={}))}),define(ie[19],ne([0,1,33,13,9,4,27,7]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(h){return(0,I.uriToFsPath)(h,!0)}e.originalFSPath=u;class a{constructor(b){this._ignorePathCasing=b}compare(b,p,v=!1){return b===p?0:(0,R.compare)(this.getComparisonKey(b,v),this.getComparisonKey(p,v))}isEqual(b,p,v=!1){return b===p?!0:!b||!p?!1:this.getComparisonKey(b,v)===this.getComparisonKey(p,v)}getComparisonKey(b,p=!1){return b.with({path:this._ignorePathCasing(b)?b.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(b){return this._ignorePathCasing(b)}isEqualOrParent(b,p,v=!1){if(b.scheme===p.scheme){if(b.scheme===L.Schemas.file)return C.isEqualOrParent(u(b),u(p),this._ignorePathCasing(b))&&b.query===p.query&&(v||b.fragment===p.fragment);if((0,e.isEqualAuthority)(b.authority,p.authority))return C.isEqualOrParent(b.path,p.path,this._ignorePathCasing(b),"/")&&b.query===p.query&&(v||b.fragment===p.fragment)}return!1}joinPath(b,...p){return I.URI.joinPath(b,...p)}basenameOrAuthority(b){return(0,e.basename)(b)||b.authority}basename(b){return r.posix.basename(b.path)}extname(b){return r.posix.extname(b.path)}dirname(b){if(b.path.length===0)return b;let p;return b.scheme===L.Schemas.file?p=I.URI.file(r.dirname(u(b))).path:(p=r.posix.dirname(b.path),b.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),p="/")),b.with({path:p})}normalizePath(b){if(!b.path.length)return b;let p;return b.scheme===L.Schemas.file?p=I.URI.file(r.normalize(u(b))).path:p=r.posix.normalize(b.path),b.with({path:p})}relativePath(b,p){if(b.scheme!==p.scheme||!(0,e.isEqualAuthority)(b.authority,p.authority))return;if(b.scheme===L.Schemas.file){const f=r.relative(u(b),u(p));return A.isWindows?C.toSlashes(f):f}let v=b.path||"/";const m=p.path||"/";if(this._ignorePathCasing(b)){let f=0;for(const d=Math.min(v.length,m.length);f<d&&!(v.charCodeAt(f)!==m.charCodeAt(f)&&v.charAt(f).toLowerCase()!==m.charAt(f).toLowerCase());f++);v=m.substr(0,f)+v.substr(f)}return r.posix.relative(v,m)}resolvePath(b,p){if(b.scheme===L.Schemas.file){const v=I.URI.file(r.resolve(u(b),p));return b.with({authority:v.authority,path:v.path})}return p=C.toPosixPath(p),b.with({path:r.posix.resolve(b.path,p)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,p){return b===p||b!==void 0&&p!==void 0&&(0,R.equalsIgnoreCase)(b,p)}hasTrailingPathSeparator(b,p=r.sep){if(b.scheme===L.Schemas.file){const v=u(b);return v.length>C.getRoot(v).length&&v[v.length-1]===p}else{const v=b.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,p=r.sep){return(0,e.hasTrailingPathSeparator)(b,p)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,p=r.sep){let v=!1;if(b.scheme===L.Schemas.file){const m=u(b);v=m!==void 0&&m.length===C.getRoot(m).length&&m[m.length-1]===p}else{p="/";const m=b.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(b,p)?b.with({path:b.path+"/"}):b}}e.ExtUri=a,e.extUri=new a(()=>!1),e.extUriBiasedIgnorePathCase=new a(h=>h.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new a(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function g(h,b){const p=[];for(let v=0;v<h.length;v++){const m=b(h[v]);h.some((f,d)=>d===v?!1:(0,e.isEqualOrParent)(m,b(f)))||p.push(h[v])}return p}e.distinctParents=g;var w;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function b(p){const v=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(d=>{const[E,c]=d.split(":");E&&c&&v.set(E,c)});const f=p.path.substring(0,p.path.indexOf(";"));return f&&v.set(h.META_DATA_MIME,f),v}h.parseMetaData=b})(w||(e.DataUri=w={}));function y(h,b,p){if(b){let v=h.path;return v&&v[0]!==r.posix.sep&&(v=r.posix.sep+v),h.with({scheme:p,authority:b,path:v})}return h.with({scheme:p})}e.toLocalResource=y}),define(ie[8],ne([0,1,22,14,3,2,19,4,143]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function a(U){return!!U&&typeof U.then=="function"}e.isThenable=a;function g(U){const B=new C.CancellationTokenSource,T=U(B.token),$=new Promise((x,ae)=>{const fe=B.token.onCancellationRequested(()=>{fe.dispose(),B.dispose(),ae(new L.CancellationError)});Promise.resolve(T).then(ue=>{fe.dispose(),B.dispose(),x(ue)},ue=>{fe.dispose(),B.dispose(),ae(ue)})});return new class{cancel(){B.cancel()}then(x,ae){return $.then(x,ae)}catch(x){return this.then(void 0,x)}finally(x){return $.finally(x)}}}e.createCancelablePromise=g;function w(U,B,T){return new Promise(($,x)=>{const ae=B.onCancellationRequested(()=>{ae.dispose(),$(T)});U.then($,x).finally(()=>ae.dispose())})}e.raceCancellation=w;function y(U,B){return new Promise((T,$)=>{const x=B.onCancellationRequested(()=>{x.dispose(),$(new L.CancellationError)});U.then(T,$).finally(()=>x.dispose())})}e.raceCancellationError=y;async function h(U){let B=-1;const T=U.map(($,x)=>$.then(ae=>(B=x,ae)));try{return await Promise.race(T)}finally{U.forEach(($,x)=>{x!==B&&$.cancel()})}}e.raceCancellablePromises=h;function b(U,B,T){let $;const x=setTimeout(()=>{$?.(void 0),T?.()},B);return Promise.race([U.finally(()=>clearTimeout(x)),new Promise(ae=>$=ae)])}e.raceTimeout=b;function p(U){return new Promise((B,T)=>{const $=U();a($)?$.then(B,T):B($)})}e.asPromise=p;class v{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const T=()=>{if(this.queuedPromise=null,this.isDisposed)return;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(T,T).then($)})}return new Promise((T,$)=>{this.queuedPromise.then(T,$)})}return this.activePromise=B(),new Promise((T,$)=>{this.activePromise.then(x=>{this.activePromise=null,T(x)},x=>{this.activePromise=null,$(x)})})}dispose(){this.isDisposed=!0}}e.Throttler=v;class m{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=m;class f{constructor(){this.promiseMap=new Map}queue(B,T){const x=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(B)===x&&this.promiseMap.delete(B)});return this.promiseMap.set(B,x),x}}e.SequencerByKey=f;const d=(U,B)=>{let T=!0;const $=setTimeout(()=>{T=!1,B()},U);return{isTriggered:()=>T,dispose:()=>{clearTimeout($),T=!1}}},E=U=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,U())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class c{constructor(B){this.defaultDelay=B,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,T=this.defaultDelay){this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,ae)=>{this.doResolve=x,this.doReject=ae}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}}));const $=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===u.MicrotaskDelay?E($):d(T,$),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class i{constructor(B){this.delayer=new c(B),this.throttler=new v}trigger(B,T){return this.delayer.trigger(()=>this.throttler.queue(B),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this._isOpen=!1,this._promise=new Promise((B,T)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class s extends o{constructor(B){super(),this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function t(U,B){return B?new Promise((T,$)=>{const x=setTimeout(()=>{ae.dispose(),T()},U),ae=B.onCancellationRequested(()=>{clearTimeout(x),ae.dispose(),$(new L.CancellationError)})}):g(T=>t(U,T))}e.timeout=t;function n(U,B=0,T){const $=setTimeout(()=>{U(),T&&x.dispose()},B),x=(0,A.toDisposable)(()=>{clearTimeout($),T?.deleteAndLeak(x)});return T?.add(x),x}e.disposableTimeout=n;function l(U){const B=[];let T=0;const $=U.length;function x(){return T<$?U[T++]():null}function ae(fe){fe!=null&&B.push(fe);const ue=x();return ue?ue.then(ae):Promise.resolve(B)}return Promise.resolve(null).then(ae)}e.sequence=l;function S(U,B=$=>!!$,T=null){let $=0;const x=U.length,ae=()=>{if($>=x)return Promise.resolve(T);const fe=U[$++];return Promise.resolve(fe()).then(de=>B(de)?Promise.resolve(de):ae())};return ae()}e.first=S;function D(U,B=$=>!!$,T=null){if(U.length===0)return Promise.resolve(T);let $=U.length;const x=()=>{$=-1;for(const ae of U)ae.cancel?.()};return new Promise((ae,fe)=>{for(const ue of U)ue.then(de=>{--$>=0&&B(de)?(x(),ae(de)):$===0&&ae(T)}).catch(de=>{--$>=0&&(x(),fe(de))})})}e.firstParallel=D;class M{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(B){return this._size++,new Promise((T,$)=>{this.outstandingPromises.push({factory:B,c:T,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const T=B.factory();T.then(B.c,B.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=M;class P extends M{constructor(){super(1)}}e.Queue=P;class k{constructor(){this.sequentializer=new K,this.tasks=0}queue(B){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,B())):this.sequentializer.run(this.tasks++,B())}}e.LimitedQueue=k;class O{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const B=new N;return this.drainers.add(B),B.p}isDrained(){for(const[,B]of this.queues)if(B.size>0)return!1;return!0}queueFor(B,T=R.extUri){const $=T.getComparisonKey(B);let x=this.queues.get($);if(!x){x=new P;const ae=this.drainListenerCount++,fe=r.Event.once(x.onDrained)(()=>{x?.dispose(),this.queues.delete($),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ae),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(ae,fe),this.queues.set($,x)}return x}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const B of this.drainers)B.complete();this.drainers.clear()}dispose(){for(const[,B]of this.queues)B.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=O;class F{constructor(B,T){this._token=-1,typeof B=="function"&&typeof T=="number"&&this.setIfNotSet(B,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},T)}setIfNotSet(B,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},T))}}e.TimeoutTimer=F;class z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,T){this.cancel(),this._token=setInterval(()=>{B()},T)}}e.IntervalTimer=z;class Y{constructor(B,T){this.timeoutToken=-1,this.runner=B,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Y;class J{constructor(B,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=J;class oe extends Y{constructor(B,T){super(B,T),this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner?.(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class re extends A.Disposable{constructor(B,T){super(),this.options=B,this.handler=T,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.options.maxBufferedWork)return!1}else if(this.pending+B.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of B)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Y(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,I.setTimeout0)(()=>{if(B)return;const T=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e.runWhenIdle=(U,B)=>{const T=requestIdleCallback(U,typeof B=="number"?{timeout:B}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(T))}}}}();class ce{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ce;async function Q(U,B,T){let $;for(let x=0;x<T;x++)try{return await U()}catch(ae){$=ae,await t(B)}throw $}e.retry=Q;class K{isRunning(B){return typeof B=="number"?this._running?.taskId===B:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(B,T,$){return this._running={taskId:B,cancel:()=>$?.(),promise:T},T.then(()=>this.doneRunning(B),()=>this.doneRunning(B)),T}doneRunning(B){this._running&&B===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const B=this._queued;this._queued=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this._queued)this._queued.run=B;else{let T,$;const x=new Promise((ae,fe)=>{T=ae,$=fe});this._queued={run:B,promise:x,promiseResolve:T,promiseReject:$}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=K;class V{constructor(B,T=()=>Date.now()){this.interval=B,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const B=this.nowFn();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=V;var q;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(q||(q={}));class N{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((B,T)=>{this.completeCallback=B,this.errorCallback=T})}complete(B){return new Promise(T=>{this.completeCallback(B),this.outcome={outcome:0,value:B},T()})}error(B){return new Promise(T=>{this.errorCallback(B),this.outcome={outcome:1,value:B},T()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=N;var j;(function(U){async function B($){let x;const ae=await Promise.all($.map(fe=>fe.then(ue=>ue,ue=>{x||(x=ue)})));if(typeof x<"u")throw x;return ae}U.settled=B;function T($){return new Promise(async(x,ae)=>{try{await $(x,ae)}catch(fe){ae(fe)}})}U.withAsyncBody=T})(j||(e.Promises=j={}));var H;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(H||(H={}));class X{static fromArray(B){return new X(T=>{T.emitMany(B)})}static fromPromise(B){return new X(async T=>{T.emitMany(await B)})}static fromPromises(B){return new X(async T=>{await Promise.all(B.map(async $=>T.emitOne(await $)))})}static merge(B){return new X(async T=>{await Promise.all(B.map(async $=>{for await(const x of $)T.emitOne(x)}))})}static{this.EMPTY=X.fromArray([])}constructor(B){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const T={emitOne:$=>this.emitOne($),emitMany:$=>this.emitMany($),reject:$=>this.reject($)};try{await Promise.resolve(B(T)),this.resolve()}catch($){this.reject($)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(B<this._results.length)return{done:!1,value:this._results[B++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(B,T){return new X(async $=>{for await(const x of B)$.emitOne(T(x))})}map(B){return X.map(this,B)}static filter(B,T){return new X(async $=>{for await(const x of B)T(x)&&$.emitOne(x)})}filter(B){return X.filter(this,B)}static coalesce(B){return X.filter(B,T=>!!T)}coalesce(){return X.coalesce(this)}static async toPromise(B){const T=[];for await(const $ of B)T.push($);return T}toPromise(){return X.toPromise(this)}emitOne(B){this._state===0&&(this._results.push(B),this._onStateChanged.fire())}emitMany(B){this._state===0&&(this._results=this._results.concat(B),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(B){this._state===0&&(this._state=2,this._error=B,this._onStateChanged.fire())}}e.AsyncIterableObject=X;class se extends X{constructor(B,T){super(T),this._source=B}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function W(U){const B=new C.CancellationTokenSource,T=U(B.token);return new se(B,async $=>{const x=B.token.onCancellationRequested(()=>{x.dispose(),B.dispose(),$.reject(new L.CancellationError)});try{for await(const ae of T){if(B.token.isCancellationRequested)return;$.emitOne(ae)}x.dispose(),B.dispose()}catch(ae){x.dispose(),B.dispose(),$.reject(ae)}})}e.createCancelableAsyncIterable=W;class _{constructor(){this._deferred=new N,this._asyncIterable=new X($=>{if(B){$.reject(B);return}return T&&$.emitMany(T),this._errorFn=x=>$.reject(x),this._emitFn=x=>$.emitOne(x),this._deferred.p});let B,T;this._emitFn=$=>{T||(T=[]),T.push($)},this._errorFn=$=>{B||(B=$)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(B){this._errorFn(B),this._deferred.complete()}emitOne(B){this._emitFn(B)}}e.AsyncIterableSource=_}),define(ie[104],ne([0,1,23,8,33,31,9,4,27]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function a(){return Object.create(null)}e.getEmptyExpression=a,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const g="[/\\\\]",w="[^/\\\\]",y=/\//g;function h(K,V){switch(K){case 0:return"";case 1:return`${w}*?`;default:return`(?:${g}|${w}+${g}${V?`|${g}${w}+`:""})*?`}}function b(K,V){if(!K)return[];const q=[];let N=!1,j=!1,H="";for(const X of K){switch(X){case V:if(!N&&!j){q.push(H),H="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":j=!0;break;case"]":j=!1;break}H+=X}return H&&q.push(H),q}e.splitGlobAware=b;function p(K){if(!K)return"";let V="";const q=b(K,e.GLOB_SPLIT);if(q.every(N=>N===e.GLOBSTAR))V=".*";else{let N=!1;q.forEach((j,H)=>{if(j===e.GLOBSTAR){if(N)return;V+=h(2,H===q.length-1)}else{let X=!1,se="",W=!1,_="";for(const U of j){if(U!=="}"&&X){se+=U;continue}if(W&&(U!=="]"||!_)){let B;U==="-"?B=U:(U==="^"||U==="!")&&!_?B="^":U===e.GLOB_SPLIT?B="":B=(0,u.escapeRegExpCharacters)(U),_+=B;continue}switch(U){case"{":X=!0;continue;case"[":W=!0;continue;case"}":{const T=`(?:${b(se,",").map($=>p($)).join("|")})`;V+=T,X=!1,se="";break}case"]":{V+="["+_+"]",W=!1,_="";break}case"?":V+=w;continue;case"*":V+=h(1);continue;default:V+=(0,u.escapeRegExpCharacters)(U)}}H<q.length-1&&(q[H+1]!==e.GLOBSTAR||H+2<q.length)&&(V+=g)}N=j===e.GLOBSTAR})}return V}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.LRUCache(1e4),o=function(){return!1},s=function(){return null};function t(K,V){if(!K)return s;let q;typeof K!="string"?q=K.pattern:q=K,q=q.trim();const N=`${q}_${!!V.trimForExclusions}`;let j=i.get(N);if(j)return n(j,K);let H;return v.test(q)?j=S(q.substr(4),q):(H=m.exec(l(q,V)))?j=D(H[1],q):(V.trimForExclusions?d:f).test(q)?j=M(q,V):(H=E.exec(l(q,V)))?j=P(H[1].substr(1),q,!0):(H=c.exec(l(q,V)))?j=P(H[1],q,!1):j=k(q),i.set(N,j),n(j,K)}function n(K,V){if(typeof V=="string")return K;const q=function(N,j){return(0,r.isEqualOrParent)(N,V.base,!I.isLinux)?K((0,u.ltrim)(N.substr(V.base.length),R.sep),j):null};return q.allBasenames=K.allBasenames,q.allPaths=K.allPaths,q.basenames=K.basenames,q.patterns=K.patterns,q}function l(K,V){return V.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function S(K,V){return function(q,N){return typeof q=="string"&&q.endsWith(K)?V:null}}function D(K,V){const q=`/${K}`,N=`\\${K}`,j=function(X,se){return typeof X!="string"?null:se?se===K?V:null:X===K||X.endsWith(q)||X.endsWith(N)?V:null},H=[K];return j.basenames=H,j.patterns=[V],j.allBasenames=H,j}function M(K,V){const q=ce(K.slice(1,-1).split(",").map(se=>t(se,V)).filter(se=>se!==s),K),N=q.length;if(!N)return s;if(N===1)return q[0];const j=function(se,W){for(let _=0,U=q.length;_<U;_++)if(q[_](se,W))return K;return null},H=q.find(se=>!!se.allBasenames);H&&(j.allBasenames=H.allBasenames);const X=q.reduce((se,W)=>W.allPaths?se.concat(W.allPaths):se,[]);return X.length&&(j.allPaths=X),j}function P(K,V,q){const N=R.sep===R.posix.sep,j=N?K:K.replace(y,R.sep),H=R.sep+j,X=R.posix.sep+K;let se;return q?se=function(W,_){return typeof W=="string"&&(W===j||W.endsWith(H)||!N&&(W===K||W.endsWith(X)))?V:null}:se=function(W,_){return typeof W=="string"&&(W===j||!N&&W===K)?V:null},se.allPaths=[(q?"*/":"./")+K],se}function k(K){try{const V=new RegExp(`^${p(K)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?K:null}}catch{return s}}function O(K,V,q){return!K||typeof V!="string"?!1:F(K)(V,void 0,q)}e.match=O;function F(K,V={}){if(!K)return o;if(typeof K=="string"||z(K)){const q=t(K,V);if(q===s)return o;const N=function(j,H){return!!q(j,H)};return q.allBasenames&&(N.allBasenames=q.allBasenames),q.allPaths&&(N.allPaths=q.allPaths),N}return oe(K,V)}e.parse=F;function z(K){const V=K;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=z;function Y(K){return K.allBasenames||[]}e.getBasenameTerms=Y;function J(K){return K.allPaths||[]}e.getPathTerms=J;function oe(K,V){const q=ce(Object.getOwnPropertyNames(K).map(se=>re(se,K[se],V)).filter(se=>se!==s)),N=q.length;if(!N)return s;if(!q.some(se=>!!se.requiresSiblings)){if(N===1)return q[0];const se=function(U,B){let T;for(let $=0,x=q.length;$<x;$++){const ae=q[$](U,B);if(typeof ae=="string")return ae;(0,L.isThenable)(ae)&&(T||(T=[]),T.push(ae))}return T?(async()=>{for(const $ of T){const x=await $;if(typeof x=="string")return x}return null})():null},W=q.find(U=>!!U.allBasenames);W&&(se.allBasenames=W.allBasenames);const _=q.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return _.length&&(se.allPaths=_),se}const j=function(se,W,_){let U,B;for(let T=0,$=q.length;T<$;T++){const x=q[T];x.requiresSiblings&&_&&(W||(W=(0,R.basename)(se)),U||(U=W.substr(0,W.length-(0,R.extname)(se).length)));const ae=x(se,W,U,_);if(typeof ae=="string")return ae;(0,L.isThenable)(ae)&&(B||(B=[]),B.push(ae))}return B?(async()=>{for(const T of B){const $=await T;if(typeof $=="string")return $}return null})():null},H=q.find(se=>!!se.allBasenames);H&&(j.allBasenames=H.allBasenames);const X=q.reduce((se,W)=>W.allPaths?se.concat(W.allPaths):se,[]);return X.length&&(j.allPaths=X),j}function re(K,V,q){if(V===!1)return s;const N=t(K,q);if(N===s)return s;if(typeof V=="boolean")return N;if(V){const j=V.when;if(typeof j=="string"){const H=(X,se,W,_)=>{if(!_||!N(X,se))return null;const U=j.replace("$(basename)",()=>W),B=_(U);return(0,L.isThenable)(B)?B.then(T=>T?K:null):B?K:null};return H.requiresSiblings=!0,H}}return N}function ce(K,V){const q=K.filter(se=>!!se.basenames);if(q.length<2)return K;const N=q.reduce((se,W)=>{const _=W.basenames;return _?se.concat(_):se},[]);let j;if(V){j=[];for(let se=0,W=N.length;se<W;se++)j.push(V)}else j=q.reduce((se,W)=>{const _=W.patterns;return _?se.concat(_):se},[]);const H=function(se,W){if(typeof se!="string")return null;if(!W){let U;for(U=se.length;U>0;U--){const B=se.charCodeAt(U-1);if(B===47||B===92)break}W=se.substr(U)}const _=N.indexOf(W);return _!==-1?j[_]:null};H.basenames=N,H.patterns=j,H.allBasenames=N;const X=K.filter(se=>!se.basenames);return X.push(H),X}function Q(K,V){return(0,C.equals)(K,V,(q,N)=>typeof q=="string"&&typeof N=="string"?q===N:typeof q!="string"&&typeof N!="string"?q.base===N.base&&q.pattern===N.pattern:!1)}e.patternsEquals=Q}),define(ie[46],ne([0,1,23,33,9,4,19,27]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function u(t,n){const{os:l,tildify:S,relative:D}=n;if(D){const k=a(t,D,l);if(typeof k=="string")return k}let M=t.fsPath;if(l===1&&!A.isWindows?M=M.replace(/\//g,"\\"):l!==1&&A.isWindows&&(M=M.replace(/\\/g,"/")),l!==1&&S?.userHome){const k=S.userHome.fsPath;let O;t.scheme!==S.userHome.scheme&&t.path.startsWith(r.posix.sep)?O=S.userHome.with({path:t.path}).fsPath:O=t.fsPath,M=y(O,k,l)}return(l===1?r.win32:r.posix).normalize(g(M,l===1))}e.getPathLabel=u;function a(t,n,l){const S=l===1?r.win32:r.posix,D=l===3?R.extUri:R.extUriIgnorePathCase,M=n.getWorkspace(),P=(0,C.firstOrDefault)(M.folders);if(!P)return;t.scheme!==P.uri.scheme&&t.path.startsWith(r.posix.sep)&&(t=P.uri.with({path:t.path}));const k=n.getWorkspaceFolder(t);if(!k)return;let O;if(D.isEqual(k.uri,t)?O="":O=D.relativePath(k.uri,t)??"",O&&(O=S.normalize(O)),M.folders.length>1&&!n.noPrefix){const F=k.name?k.name:D.basenameOrAuthority(k.uri);O=O?`${F} \u2022 ${O}`:F}return O}function g(t,n=A.isWindows){return(0,L.hasDriveLetter)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=g;let w=Object.create(null);function y(t,n,l=A.OS){if(l===1||!t||!n)return t;let S=w.original===n?w.normalized:void 0;S||(S=n,A.isWindows&&(S=(0,L.toSlashes)(S)),S=`${(0,I.rtrim)(S,r.posix.sep)}${r.posix.sep}`,w={original:n,normalized:S});let D=t;return A.isWindows&&(D=(0,L.toSlashes)(D)),(l===3?D.startsWith(S):(0,I.startsWithIgnoreCase)(D,S))?`~/${D.substr(S.length)}`:t}e.tildify=y;function h(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=h;const b="\u2026",p="\\\\",v="~";function m(t,n=r.sep){const l=new Array(t.length);let S=!1;for(let D=0;D<t.length;D++){const M=t[D];if(M===""){l[D]=`.${n}`;continue}if(!M){l[D]=M;continue}S=!0;let P="",k=M;k.indexOf(p)===0?(P=k.substr(0,k.indexOf(p)+p.length),k=k.substr(k.indexOf(p)+p.length)):k.indexOf(n)===0?(P=k.substr(0,k.indexOf(n)+n.length),k=k.substr(k.indexOf(n)+n.length)):k.indexOf(v)===0&&(P=k.substr(0,k.indexOf(v)+v.length),k=k.substr(k.indexOf(v)+v.length));const O=k.split(n);for(let F=1;S&&F<=O.length;F++)for(let z=O.length-F;S&&z>=0;z--){S=!1;let Y=O.slice(z,z+F).join(n);for(let J=0;!S&&J<t.length;J++)if(J!==D&&t[J]&&t[J].indexOf(Y)>-1){const oe=z+F===O.length,re=z>0&&t[J].indexOf(n)>-1?n+Y:Y,ce=t[J].endsWith(re);S=!oe||ce}if(!S){let J="";(O[0].endsWith(":")||P!=="")&&(z===1&&(z=0,F++,Y=O[0]+n+Y),z>0&&(J=O[0]+n),J=P+J),z>0&&(J=J+b+n),J=J+Y,z+F<O.length&&(J=J+n+b),l[D]=J}}S&&(l[D]=M)}return l}e.shorten=m;var f;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function d(t,n=Object.create(null)){const l=[];let S=!1,D="";for(const M of t)if(M==="$"||S&&M==="{")D&&l.push({value:D,type:f.TEXT}),D="",S=!0;else if(M==="}"&&S){const P=n[D];if(typeof P=="string")P.length&&l.push({value:P,type:f.VARIABLE});else if(P){const k=l[l.length-1];(!k||k.type!==f.SEPARATOR)&&l.push({value:P.label,type:f.SEPARATOR})}D="",S=!1}else D+=M;return D&&!S&&l.push({value:D,type:f.TEXT}),l.filter((M,P)=>{if(M.type===f.SEPARATOR){const k=l[P-1],O=l[P+1];return[k,O].every(F=>F&&(F.type===f.VARIABLE||F.type===f.TEXT)&&F.value.length>0)}return!0}).map(M=>M.value).join("")}e.template=d;function E(t,n){return A.isMacintosh||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function c(t,n){return A.isMacintosh||n?t.replace(/\(&&\w\)|&&/g,""):A.isWindows?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function i(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const l=s(t.substring(0,n));return{name:l.name,parentPath:l.parentPath+t.substring(n)}}}return s(t)}e.splitRecentLabel=o;function s(t){const n=t.indexOf("/")!==-1?r.posix:r.win32,l=n.basename(t),S=n.dirname(t);return l.length?{name:l,parentPath:S}:{name:S,parentPath:""}}}),define(ie[155],ne([0,1,17,7]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(w){return w.toJSON()}class A{constructor(y){this._uriTransformer=y}transformIncoming(y){const h=this._uriTransformer.transformIncoming(y);return h===y?y:r(L.URI.from(h))}transformOutgoing(y){const h=this._uriTransformer.transformOutgoing(y);return h===y?y:r(L.URI.from(h))}transformOutgoingURI(y){const h=this._uriTransformer.transformOutgoing(y);return h===y?y:L.URI.from(h)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function R(w,y,h){if(!w||h>200)return null;if(typeof w=="object"){if(w instanceof L.URI)return y.transformOutgoing(w);for(const b in w)if(Object.hasOwnProperty.call(w,b)){const p=R(w[b],y,h+1);p!==null&&(w[b]=p)}}return null}function I(w,y){const h=R(w,y,0);return h===null?w:h}e.transformOutgoingURIs=I;function u(w,y,h,b){if(!w||b>200)return null;if(typeof w=="object"){if(w.$mid===1)return h?L.URI.revive(y.transformIncoming(w)):y.transformIncoming(w);if(w instanceof C.VSBuffer)return null;for(const p in w)if(Object.hasOwnProperty.call(w,p)){const v=u(w[p],y,h,b+1);v!==null&&(w[p]=v)}}return null}function a(w,y){const h=u(w,y,!1,0);return h===null?w:h}e.transformIncomingURIs=a;function g(w,y){const h=u(w,y,!0,0);return h===null?w:h}e.transformAndReviveIncomingURIs=g}),define(ie[88],ne([0,1,28,56,32,145,4]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,h=0;const b=(0,C.networkInterfaces)();for(const p in b){const v=b[p];if(v)for(const{mac:m,internal:f}of v)f||(h+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(y+=1))}this._value=h>0?y/h:0}return this._value}};let I;async function u(y){return I||(I=(async()=>await a(y)||r.generateUuid())()),I}e.getMachineId=u;async function a(y){try{const h=await new Promise((p,v)=>{G(["crypto"],p,v)}),b=(0,A.getMac)();return h.createHash("sha256").update(b,"utf8").digest("hex")}catch(h){y(h);return}}const g="Software\\Microsoft\\SQMClient";async function w(y){if(R.isWindows){const h=await new Promise((b,p)=>{G(["@vscode/windows-registry"],b,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(b){return y(b),""}}return""}e.getSqmMachineId=w}),define(ie[21],ne([0,1,45,28,156,8,33,85,9,4,19,7]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function h(re,ce=y.UNLINK,Q){if((0,R.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?p(re):b(re,Q)}async function b(re,ce=(0,R.randomPath)((0,L.tmpdir)())){try{try{await C.promises.rename(re,ce)}catch(Q){return Q.code==="ENOENT"?void 0:p(re)}p(ce).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function p(re){return(0,r.promisify)(C.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function v(re){if((0,R.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function m(re,ce){return E(await(ce?f(re):(0,r.promisify)(C.readdir)(re)))}async function f(re){try{return await(0,r.promisify)(C.readdir)(re,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ce=[],Q=await m(re);for(const K of Q){let V=!1,q=!1,N=!1;try{const j=await e.Promises.lstat((0,u.join)(re,K));V=j.isFile(),q=j.isDirectory(),N=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}ce.push({name:K,isFile:()=>V,isDirectory:()=>q,isSymbolicLink:()=>N})}return ce}function d(re){return E(C.readdirSync(re))}e.readdirSync=d;function E(re){return re.map(ce=>typeof ce=="string"?a.isMacintosh?(0,I.normalizeNFC)(ce):ce:(ce.name=a.isMacintosh?(0,I.normalizeNFC)(ce.name):ce.name,ce))}async function c(re){const ce=await m(re),Q=[];for(const K of ce)await o.existsDirectory((0,u.join)(re,K))&&Q.push(K);return Q}function i(re,ce=1e3){return new Promise(Q=>{let K=!1;const V=setInterval(()=>{K||(K=!0,C.access(re,q=>{K=!1,q&&(clearInterval(V),Q(void 0))}))},ce)})}e.whenDeleted=i;var o;(function(re){async function ce(V){let q;try{if(q=await e.Promises.lstat(V),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(a.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw j}throw N}}re.stat=ce;async function Q(V){try{const{stat:q,symbolicLink:N}=await re.stat(V);return q.isFile()&&N?.dangling!==!0}catch{}return!1}re.existsFile=Q;async function K(V){try{const{stat:q,symbolicLink:N}=await re.stat(V);return q.isDirectory()&&N?.dangling!==!0}catch{}return!1}re.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const s=new A.ResourceQueue;function t(re,ce,Q){return s.queueFor(w.URI.file(re),g.extUriBiasedIgnorePathCase).queue(()=>{const K=M(Q);return new Promise((V,q)=>S(re,ce,K,N=>N?q(N):V()))})}let n=!0;function l(re){n=re}e.configureFlushOnWrite=l;function S(re,ce,Q,K){if(!n)return C.writeFile(re,ce,{mode:Q.mode,flag:Q.flag},K);C.open(re,Q.flag,Q.mode,(V,q)=>{if(V)return K(V);C.writeFile(q,ce,N=>{if(N)return C.close(q,()=>K(N));C.fdatasync(q,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),l(!1)),C.close(q,H=>K(H))))})})}function D(re,ce,Q){const K=M(Q);if(!n)return C.writeFileSync(re,ce,{mode:K.mode,flag:K.flag});const V=C.openSync(re,K.flag,K.mode);try{C.writeFileSync(V,ce);try{C.fdatasyncSync(V)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{C.closeSync(V)}}e.writeFileSync=D;function M(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function P(re,ce,Q=6e4){if(re!==ce)try{a.isWindows&&typeof Q=="number"?await k(re,ce,Date.now(),Q):await(0,r.promisify)(C.rename)(re,ce)}catch(K){if(re.toLowerCase()!==ce.toLowerCase()&&K.code==="EXDEV"||re.endsWith("."))await O(re,ce,{preserveSymlinks:!1}),await h(re,y.MOVE);else throw K}}async function k(re,ce,Q,K,V=0){try{return await(0,r.promisify)(C.rename)(re,ce)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-Q>=K)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${q}`),q;if(V===0){let N=!1;try{const{stat:j}=await o.stat(ce);j.isFile()||(N=!0)}catch{}if(N)throw q}return await(0,A.timeout)(Math.min(100,V*10)),k(re,ce,Q,K,V+1)}}async function O(re,ce,Q){return z(re,ce,{root:{source:re,target:ce},options:Q,handledSourcePaths:new Set})}const F=511;async function z(re,ce,Q){if(Q.handledSourcePaths.has(re))return;Q.handledSourcePaths.add(re);const{stat:K,symbolicLink:V}=await o.stat(re);if(V){if(Q.options.preserveSymlinks)try{return await oe(re,ce,Q)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(V.dangling)return}return K.isDirectory()?Y(re,ce,K.mode&F,Q):J(re,ce,K.mode&F)}async function Y(re,ce,Q,K){await e.Promises.mkdir(ce,{recursive:!0,mode:Q});const V=await m(re);for(const q of V)await z((0,u.join)(re,q),(0,u.join)(ce,q),K)}async function J(re,ce,Q){await e.Promises.copyFile(re,ce),await e.Promises.chmod(ce,Q)}async function oe(re,ce,Q){let K=await e.Promises.readlink(re);(0,R.isEqualOrParent)(K,Q.root.source,!a.isLinux)&&(K=(0,u.join)(Q.root.target,K.substr(Q.root.source.length+1))),await e.Promises.symlink(K,ce)}e.Promises=new class{get access(){return(0,r.promisify)(C.access)}get stat(){return(0,r.promisify)(C.stat)}get lstat(){return(0,r.promisify)(C.lstat)}get utimes(){return(0,r.promisify)(C.utimes)}get read(){return(re,ce,Q,K,V)=>new Promise((q,N)=>{C.read(re,ce,Q,K,V,(j,H,X)=>j?N(j):q({bytesRead:H,buffer:X}))})}get readFile(){return(0,r.promisify)(C.readFile)}get write(){return(re,ce,Q,K,V)=>new Promise((q,N)=>{C.write(re,ce,Q,K,V,(j,H,X)=>j?N(j):q({bytesWritten:H,buffer:X}))})}get appendFile(){return(0,r.promisify)(C.appendFile)}get fdatasync(){return(0,r.promisify)(C.fdatasync)}get truncate(){return(0,r.promisify)(C.truncate)}get copyFile(){return(0,r.promisify)(C.copyFile)}get open(){return(0,r.promisify)(C.open)}get close(){return(0,r.promisify)(C.close)}get symlink(){return(0,r.promisify)(C.symlink)}get readlink(){return(0,r.promisify)(C.readlink)}get chmod(){return(0,r.promisify)(C.chmod)}get mkdir(){return(0,r.promisify)(C.mkdir)}get unlink(){return(0,r.promisify)(C.unlink)}get rmdir(){return(0,r.promisify)(C.rmdir)}get realpath(){return(0,r.promisify)(C.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return h}get rename(){return P}get copy(){return O}}}),define(ie[105],ne([0,1,45,9,4,27,21]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(y){if(r.isLinux)return y;const h=(0,L.dirname)(y);if(y===h)return y;const b=((0,L.basename)(y)||y).toLowerCase();try{const v=(0,R.readdirSync)(h).filter(m=>m.toLowerCase()===b);if(v.length===1){const m=I(h);if(m)return(0,L.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(b);if(m>=0){const f=I(h);if(f)return(0,L.join)(f,v[m])}}}catch{}return null}e.realcaseSync=I;async function u(y){if(r.isLinux)return y;const h=(0,L.dirname)(y);if(y===h)return y;const b=((0,L.basename)(y)||y).toLowerCase();try{const v=(await R.Promises.readdir(h)).filter(m=>m.toLowerCase()===b);if(v.length===1){const m=await u(h);if(m)return(0,L.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(b);if(m>=0){const f=await u(h);if(f)return(0,L.join)(f,v[m])}}}catch{}return null}e.realcase=u;async function a(y){try{return await R.Promises.realpath(y)}catch{const b=w(y);return await R.Promises.access(b,C.constants.R_OK),b}}e.realpath=a;function g(y){try{return C.realpathSync(y)}catch{const b=w(y);return C.accessSync(b,C.constants.R_OK),b}}e.realpathSync=g;function w(y){return(0,A.rtrim)((0,L.normalize)(y),L.sep)}}),define(ie[106],ne([0,1,28,9,21]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,R=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var u;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class w{constructor(c,i,o){this.exePath=c,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:E=!1}={}){return E?a===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:E=!1,findPreview:c=!1}={}){const i=y({useAlternateBitness:E});if(!i)return null;const o=L.join(i,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(o))return null;let s=-1,t=null;for(const S of await r.Promises.readdir(o)){let D=-1;if(c){const P=S.indexOf("-");if(P<0)continue;const k=S.substring(0,P);if(!A.test(k)||S.substring(P+1)!=="preview")continue;D=parseInt(k,10)}else{if(!A.test(S))continue;D=parseInt(S,10)}if(D<=s)continue;const M=L.join(o,S,"pwsh.exe");await r.SymlinkSupport.existsFile(M)&&(t=M,s=D)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",l=c?" Preview":"";return new w(t,`PowerShell${l}${n}`,!0)}async function b({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=E?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(c))if(i.test(s)){const t=L.join(c,s,"pwsh.exe");return new w(t,o)}return null}function p(){const E=L.join(C.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function v(){const E=L.join(process.env.windir,a===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*m(){let E=await h();E&&(yield E),E=await h({useAlternateBitness:!0}),E&&(yield E),E=await b(),E&&(yield E),E=p(),E&&(yield E),E=await h({findPreview:!0}),E&&(yield E),E=await b({findPreview:!0}),E&&(yield E),E=await h({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=v(),E&&(yield E)}async function*f(){for await(const E of m())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=f;async function d(){for await(const E of f())return E;return null}e.getFirstAvailablePowerShellInstallation=d}),define(ie[89],ne([0,1,9,4,35,75,12,21]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(w=r.env){return w.comspec||"cmd.exe"}e.getWindowsShell=u;function a(w){let y=[],h=!1;const b=function(p){if(h){y.push(p);return}(!w.send(p,m=>{if(m&&console.error(m),h=!1,y.length>0){const f=y.slice(0);y=[],f.forEach(d=>b(d))}})||L.isWindows)&&(h=!0)};return{send:b}}e.createQueuedSender=a;var g;(function(w){async function y(h,b,p){if(C.isAbsolute(h))return h;if(b===void 0&&(b=r.cwd()),C.dirname(h)!=="."||(p===void 0&&R.isString(r.env.PATH)&&(p=r.env.PATH.split(C.delimiter)),p===void 0||p.length===0))return C.join(b,h);async function m(f){if(await I.Promises.exists(f)){let d;try{d=await I.Promises.stat(f)}catch(E){E.message.startsWith("EACCES")&&(d=await I.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(const f of p){let d;if(C.isAbsolute(f)?d=C.join(f,h):d=C.join(b,f,h),await m(d))return d;let E=d+".com";if(await m(E)||(E=d+".exe",await m(E)))return E}return C.join(b,h)}w.findExecutable=y})(g||(e.win32=g={}))}),define(ie[107],ne([0,1,47,13]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(R){return new Promise((I,u)=>{let a;const g=new Map;function w(h,b,p,v,m){const f=g.get(b);if(h===R||f){const d={name:y(p),cmd:p,pid:h,ppid:b,load:v,mem:m};g.set(h,d),h===R&&(a=d),f&&(f.children||(f.children=[]),f.children.push(d),f.children.length>1&&(f.children=f.children.sort((E,c)=>E.pid-c.pid)))}}function y(h){const b=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,v=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(v.exec(h))return"electron-crash-reporter";if(m.exec(h))return"winpty-agent";if(f.exec(h))return"conpty-agent";let E=d.exec(h);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?b.exec(h)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const c=/[a-zA-Z-]+\.js/g;let i="";do E=c.exec(h),E&&(i+=E+" ");while(E);return i&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${i})`:p.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=b=>b.indexOf("\\\\?\\")===0||b.indexOf("\\??\\")===0?b.substring(4):b.indexOf('"\\\\?\\')===0||b.indexOf('"\\??\\')===0?'"'+b.substring(5):b;new Promise((b,p)=>{G(["@vscode/windows-process-tree"],b,p)}).then(b=>{b.getProcessList(R,p=>{if(!p){u(new Error(`Root process ${R} not found`));return}b.getProcessCpuUsage(p,v=>{const m=new Map;v.forEach(f=>{const d=h(f.commandLine||"");m.set(f.pid,{name:y(d),cmd:d,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),a=m.get(R),a?(m.forEach(f=>{const d=m.get(f.ppid);d&&(d.children||(d.children=[]),d.children.push(f))}),m.forEach(f=>{f.children&&(f.children=f.children.sort((d,E)=>d.pid-E.pid))}),I(a)):u(new Error(`Root process ${R} not found`))})},b.ProcessDataFlag.CommandLine|b.ProcessDataFlag.Memory)})}else{let h=function(){let b=[a];const p=[];for(;b.length;){const m=b.shift();m&&(p.push(m.pid),m.children&&(b=b.concat(m.children)))}let v=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+p.join(" "),(0,C.exec)(v,{},(m,f,d)=>{if(m||d)u(m||new Error(d.toString()));else{const E=f.toString().split(`
`);for(let c=0;c<p.length;c++){const i=g.get(p[c]);i.load=parseFloat(E[c])}if(!a){u(new Error(`Root process ${R} not found`));return}I(a)}})};(0,C.exec)("which ps",{},(b,p,v)=>{if(b||v)if(process.platform!=="linux")u(b||new Error(v.toString()));else{const m=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,C.exec)(m,{},(f,d,E)=>{f||E?u(f||new Error(E.toString())):(A(d,w),h())})}else{const m=p.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,C.exec)(`${m} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,E,c)=>{d||c&&!c.includes("screen size is bogus")?u(d||new Error(c.toString())):(A(E,w),process.platform==="linux"?h():a?I(a):u(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=r;function A(R,I){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=R.toString().split(`
`);for(const g of a){const w=u.exec(g.trim());w&&w.length===6&&I(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ie[108],ne([0,1,28,4,106,89]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(w,y){return w===1?L.isWindows?g():A.getWindowsShell(y):u(w,y)}e.getSystemShell=R;let I=null;function u(w,y){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!I){let h;if(L.isWindows)h="/bin/bash";else{if(h=y.SHELL,!h)try{h=(0,C.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}I=h}return I}let a=null;async function g(){return a||(a=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),a}});var Pe=this&&this.__decorate||function(G,e,C,L){var r=arguments.length,A=r<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,C):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,C,L);else for(var I=G.length-1;I>=0;I--)(R=G[I])&&(A=(r<3?R(A):r>3?R(e,C,A):R(e,C))||A);return r>3&&A&&Object.defineProperty(e,C,A),A};define(ie[42],ne([0,1,23,8,17,22,54,14,3,2,76,27,12]),function(G,e,C,L,r,A,R,I,u,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(h||(h={}));function b(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(p||(p={}));function v(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(m||(m={}));function f(V){let q=0;for(let N=0;;N+=7){const j=V.read(1);if(q|=(j.buffer[0]&127)<<N,!(j.buffer[0]&128))return q}}const d=s(0);function E(V,q){if(q===0){V.write(d);return}let N=0;for(let H=q;H!==0;H=H>>>7)N++;const j=r.VSBuffer.alloc(N);for(let H=0;q!==0;H++)j.buffer[H]=q&127,q=q>>>7,q>0&&(j.buffer[H]|=128);V.write(j)}class c{constructor(q){this.buffer=q,this.pos=0}read(q){const N=this.buffer.slice(this.pos,this.pos+q);return this.pos+=N.byteLength,N}}e.BufferReader=c;class i{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function s(V){const q=r.VSBuffer.alloc(1);return q.writeUInt8(V,0),q}const t={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},n=typeof Buffer<"u";function l(V,q){if(typeof q>"u")V.write(t.Undefined);else if(typeof q=="string"){const N=r.VSBuffer.fromString(q);V.write(t.String),E(V,N.byteLength),V.write(N)}else if(n&&Buffer.isBuffer(q)){const N=r.VSBuffer.wrap(q);V.write(t.Buffer),E(V,N.byteLength),V.write(N)}else if(q instanceof r.VSBuffer)V.write(t.VSBuffer),E(V,q.byteLength),V.write(q);else if(Array.isArray(q)){V.write(t.Array),E(V,q.length);for(const N of q)l(V,N)}else if(typeof q=="number"&&(q|0)===q)V.write(t.Uint),E(V,q);else{const N=r.VSBuffer.fromString(JSON.stringify(q));V.write(t.Object),E(V,N.byteLength),V.write(N)}}e.serialize=l;function S(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(f(V)).toString();case o.Buffer:return V.read(f(V)).buffer;case o.VSBuffer:return V.read(f(V));case o.Array:{const N=f(V),j=[];for(let H=0;H<N;H++)j.push(S(V));return j}case o.Object:return JSON.parse(V.read(f(V)).toString());case o.Int:return f(V)}}e.deserialize=S;class D{constructor(q,N,j=null,H=1e3){this.protocol=q,this.ctx=N,this.logger=j,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(q,N){this.channels.set(q,N),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const N=this.send([q.type]);this.logger?.logOutgoing(N,0,1,v(q.type));return}case 201:case 202:case 204:case 203:{const N=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(N,q.id,1,v(q.type),q.data);return}}}send(q,N=void 0){const j=new i;return l(j,q),l(j,N),this.sendBuffer(j.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const N=new c(q),j=S(N),H=S(N),X=j[0];switch(X){case 100:return this.logger?.logIncoming(q.byteLength,j[1],1,`${b(X)}: ${j[2]}.${j[3]}`,H),this.onPromise({type:X,id:j[1],channelName:j[2],name:j[3],arg:H});case 102:return this.logger?.logIncoming(q.byteLength,j[1],1,`${b(X)}: ${j[2]}.${j[3]}`,H),this.onEventListen({type:X,id:j[1],channelName:j[2],name:j[3],arg:H});case 101:return this.logger?.logIncoming(q.byteLength,j[1],1,`${b(X)}`),this.disposeActiveRequest({type:X,id:j[1]});case 103:return this.logger?.logIncoming(q.byteLength,j[1],1,`${b(X)}`),this.disposeActiveRequest({type:X,id:j[1]})}}onPromise(q){const N=this.channels.get(q.channelName);if(!N){this.collectPendingRequest(q);return}const j=new A.CancellationTokenSource;let H;try{H=N.call(this.ctx,q.name,q.arg,j.token)}catch(W){H=Promise.reject(W)}const X=q.id;H.then(W=>{this.sendResponse({id:X,data:W,type:201})},W=>{W instanceof Error?this.sendResponse({id:X,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:X,data:W,type:203})}).finally(()=>{se.dispose(),this.activeRequests.delete(q.id)});const se=(0,a.toDisposable)(()=>j.cancel());this.activeRequests.set(q.id,se)}onEventListen(q){const N=this.channels.get(q.channelName);if(!N){this.collectPendingRequest(q);return}const j=q.id,X=N.listen(this.ctx,q.name,q.arg)(se=>this.sendResponse({id:j,data:se,type:204}));this.activeRequests.set(q.id,X)}disposeActiveRequest(q){const N=this.activeRequests.get(q.id);N&&(N.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let N=this.pendingRequests.get(q.channelName);N||(N=[],this.pendingRequests.set(q.channelName,N));const j=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);N.push({request:q,timeoutTimer:j})}flushPendingRequests(q){const N=this.pendingRequests.get(q);if(N){for(const j of N)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var M;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class P{constructor(q,N=null){this.protocol=q,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=N}getChannel(q){const N=this;return{call(j,H,X){return N.isDisposed?Promise.reject(new I.CancellationError):N.requestPromise(q,j,H,X)},listen(j,H){return N.isDisposed?u.Event.None:N.requestEvent(q,j,H)}}}requestPromise(q,N,j,H=A.CancellationToken.None){const X=this.lastRequestId++,W={id:X,type:100,channelName:q,name:N,arg:j};if(H.isCancellationRequested)return Promise.reject(new I.CancellationError);let _;return new Promise((B,T)=>{if(H.isCancellationRequested)return T(new I.CancellationError);const $=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(X),B(de.data);break;case 202:{this.handlers.delete(X);const be=new Error(de.data.message);be.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,be.name=de.data.name,T(be);break}case 203:this.handlers.delete(X),T(de.data);break}};this.handlers.set(X,ue),this.sendRequest(W)};let x=null;this.state===m.Idle?$():(x=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),x.then(()=>{x=null,$()}));const ae=()=>{x?(x.cancel(),x=null):this.sendRequest({id:X,type:101}),T(new I.CancellationError)},fe=H.onCancellationRequested(ae);_=(0,a.combinedDisposable)((0,a.toDisposable)(ae),fe),this.activeRequests.add(_)}).finally(()=>{_.dispose(),this.activeRequests.delete(_)})}requestEvent(q,N,j){const H=this.lastRequestId++,se={id:H,type:102,channelName:q,name:N,arg:j};let W=null;const _=new u.Emitter({onWillAddFirstListener:()=>{W=(0,L.createCancelablePromise)(B=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(_),this.sendRequest(se)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(_),this.sendRequest({id:H,type:103}))}}),U=B=>_.fire(B.data);return this.handlers.set(H,U),_.event}sendRequest(q){switch(q.type){case 100:case 102:{const N=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(N,q.id,0,`${b(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const N=this.send([q.type,q.id]);this.logger?.logOutgoing(N,q.id,0,b(q.type));return}}}send(q,N=void 0){const j=new i;return l(j,q),l(j,N),this.sendBuffer(j.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const N=new c(q),j=S(N),H=S(N),X=j[0];switch(X){case 200:return this.logger?.logIncoming(q.byteLength,0,0,v(X)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,j[1],0,v(X),H),this.onResponse({type:j[0],id:j[1],data:H})}}onResponse(q){if(q.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=P,Pe([R.memoize],P.prototype,"onDidInitializePromise",null);class k{get connections(){const q=[];return this._connections.forEach(N=>q.push(N)),q}constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(q(({protocol:N,onDidClientDisconnect:j})=>{const H=u.Event.once(N.onMessage);this.disposables.add(H(X=>{const se=new c(X),W=S(se),_=new D(N,W),U=new P(N);this.channels.forEach((T,$)=>_.registerChannel($,T));const B={channelServer:_,channelClient:U,ctx:W};this._connections.add(B),this._onDidAddConnection.fire(B),this.disposables.add(j(()=>{_.dispose(),U.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)}))}))}))}getChannel(q,N){const j=this;return{call(H,X,se){let W;if((0,y.isFunction)(N)){const U=(0,C.getRandomElement)(j.connections.filter(N));W=U?Promise.resolve(U):u.Event.toPromise(u.Event.filter(j.onDidAddConnection,N))}else W=N.routeCall(j,H,X);const _=W.then(U=>U.channelClient.getChannel(q));return F(_).call(H,X,se)},listen(H,X){if((0,y.isFunction)(N))return j.getMulticastEvent(q,N,H,X);const se=N.routeEvent(j,H,X).then(W=>W.channelClient.getChannel(q));return F(se).listen(H,X)}}}getMulticastEvent(q,N,j,H){const X=this;let se;const W=new u.Emitter({onWillAddFirstListener:()=>{se=new a.DisposableStore;const _=new u.EventMultiplexer,U=new Map,B=$=>{const ae=$.channelClient.getChannel(q).listen(j,H),fe=_.add(ae);U.set($,fe)},T=$=>{const x=U.get($);x&&(x.dispose(),U.delete($))};X.connections.filter(N).forEach(B),u.Event.filter(X.onDidAddConnection,N)(B,void 0,se),X.onDidRemoveConnection(T,void 0,se),_.event(W.fire,W,se),se.add(_)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return W.event}registerChannel(q,N){this.channels.set(q,N);for(const j of this._connections)j.channelServer.registerChannel(q,N)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class O{constructor(q,N,j=null){const H=new i;l(H,N),q.send(H.buffer),this.channelClient=new P(q,j),this.channelServer=new D(q,N,j)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,N){this.channelServer.registerChannel(q,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function F(V){return{call(q,N,j){return V.then(H=>H.call(q,N,j))},listen(q,N){const j=new u.Relay;return V.then(H=>j.input=H.listen(q,N)),j.event}}}e.getDelayedChannel=F;function z(V){let q=!1;return{call(N,j,H){return q?V.call(N,j,H):(0,L.timeout)(0).then(()=>q=!0).then(()=>V.call(N,j,H))},listen(N,j){if(q)return V.listen(N,j);const H=new u.Relay;return(0,L.timeout)(0).then(()=>q=!0).then(()=>H.input=V.listen(N,j)),H.event}}}e.getNextTickChannel=z;class Y{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const N of q.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await u.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=Y;var J;(function(V){function q(X,se,W){const _=X,U=W&&W.disableMarshalling,B=new Map;for(const T in _)j(T)&&B.set(T,u.Event.buffer(_[T],!0,void 0,se));return new class{listen(T,$,x){const ae=B.get($);if(ae)return ae;if(H($)){const fe=_[$];if(typeof fe=="function")return fe.call(_,x)}throw new I.ErrorNoTelemetry(`Event not found: ${$}`)}call(T,$,x){const ae=_[$];if(typeof ae=="function"){if(!U&&Array.isArray(x))for(let ue=0;ue<x.length;ue++)x[ue]=(0,g.revive)(x[ue]);let fe=ae.apply(_,x);return fe instanceof Promise||(fe=Promise.resolve(fe)),fe}throw new I.ErrorNoTelemetry(`Method not found: ${$}`)}}}V.fromService=q;function N(X,se){const W=se&&se.disableMarshalling;return new Proxy({},{get(_,U){if(typeof U=="string")return se?.properties?.has(U)?se.properties.get(U):H(U)?function(B){return X.listen(U,B)}:j(U)?X.listen(U):async function(...B){let T;se&&!(0,y.isUndefinedOrNull)(se.context)?T=[se.context,...B]:T=B;const $=await X.call(U,T);return W?$:(0,g.revive)($)};throw new I.ErrorNoTelemetry(`Property not found: ${String(U)}`)}})}V.toService=N;function j(X){return X[0]==="o"&&X[1]==="n"&&w.isUpperAsciiLetter(X.charCodeAt(2))}function H(X){return/^onDynamic/.test(X)&&w.isUpperAsciiLetter(X.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const q=V.toString();if(q!=="[object Object]")return q}return V}function ce(V){return Array.isArray(V)?V.map(re):re(V)}function Q(V,q,N,j,H,X,se){se=ce(se);const W=oe[H],_=W[j%W.length];let U=[`%c[${V}]%c[${String(q).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(X)?(U=U.concat(se),U.push(")")):U.push(se),console.log.apply(console,U)}class K{constructor(q,N){this._outgoingPrefix=q,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,N,j,H,X){this._totalOutgoing+=q,Q(this._outgoingPrefix,this._totalOutgoing,q,N,j,H,X)}logIncoming(q,N,j,H,X){this._totalIncoming+=q,Q(this._incomingPrefix,this._totalIncoming,q,N,j,H,X)}}e.IPCLogger=K}),define(ie[157],ne([0,1,17,3,42]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(u){this.port=u,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",a=>C.VSBuffer.wrap(a.data)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class R extends r.IPCClient{constructor(u,a){const g=new A(u);super(g,a),this.protocol=g}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=R}),define(ie[109],ne([0,1,17,3,2,42]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var I;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let l=0;function S(M,P){if(!n.has(M)){const k=String(++l);n.set(M,k)}return n.get(M)}function D(M,P,k,O){if(!t.enableDiagnostics)return;const F=S(M,P);if(O instanceof C.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const z=C.VSBuffer.alloc(O.byteLength);z.set(O),t.records.push({timestamp:Date.now(),id:F,label:P,type:k,buff:z})}else t.records.push({timestamp:Date.now(),id:F,label:P,type:k,data:O})}t.traceSocketEvent=D})(I||(e.SocketDiagnostics=I={}));var u;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u||(e.SocketCloseEventType=u={}));let a=null;function g(){return a||(a=C.VSBuffer.alloc(0)),a}class w{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,l){if(n===0)return g();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const P=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=n),P}if(this._chunks[0].byteLength>n){const P=this._chunks[0].slice(0,n);return l&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),P}const S=C.VSBuffer.alloc(n);let D=0,M=0;for(;n>0;){const P=this._chunks[M];if(P.byteLength>n){const k=P.slice(0,n);S.set(k,D),D+=n,l&&(this._chunks[M]=P.slice(n),this._totalLength-=n),n-=n}else S.set(P,D),D+=P.byteLength,l?(this._chunks.shift(),this._totalLength-=P.byteLength):M++,n-=P.byteLength}return S}}e.ChunkStream=w;var y;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(y||(y={}));function h(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var b;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class p{constructor(n,l,S,D){this.type=n,this.id=l,this.ack=S,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends r.Disposable{constructor(n){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:h(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const S=this._state.messageType,D=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new p(S,D,M,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=C.VSBuffer.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:h(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(l,n.data)}_bufferAdd(n,l){const S=this._totalLength===0;return this._data.push(n,l),this._totalLength+=n.byteLength+l.byteLength,S}_bufferTake(){const n=C.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,l){this._bufferAdd(n,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class f extends r.Disposable{constructor(n){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new p(1,0,0,n))}}e.Protocol=f;class d extends A.IPCClient{static fromSocket(n,l){return new d(new f(n),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,l,S=null){super(n,l,S),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=d;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class c{constructor(n){this.data=n,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let n=0,l=this._first;for(;l;)l=l.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let l=0,S=this._first;for(;S;)n[l++]=S.data,S=S.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const l=new c(n);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let l=0;l<o._HISTORY_LENGTH;l++)this.lastRuns[l]=n-1e3*l;setInterval(()=>{for(let l=o._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),l=(1+o._HISTORY_LENGTH)*1e3;let S=0;for(let D=0;D<o._HISTORY_LENGTH;D++)n-this.lastRuns[D]<=l&&S++;return 1-S/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new r.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new v(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.add(this._socket.onClose(l=>this._onSocketClose.fire(l))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new p(5,0,0,g());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new p(7,0,0,g());this._socketWriter.write(n)}sendResume(){const n=new p(8,0,0,g());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,l){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new r.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new v(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.add(this._socket.onClose(S=>this._onSocketClose.fire(S))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new p(3,0,this._incomingAckId,g());this._socketWriter.write(n);const l=this._outgoingUnackMsg.toArray();for(let S=0,D=l.length;S<D;S++)this._socketWriter.write(l[S]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new p(6,0,0,g())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let S=0,D=l.length;S<D;S++)this._socketWriter.write(l[S]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const S=new p(1,l,this._incomingAckId,n);this._outgoingUnackMsg.push(S),this._isReconnecting||(this._socketWriter.write(S),this._recvAckCheck())}sendControl(n){const l=new p(2,0,0,n);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),l=Date.now()-n.writtenTime,S=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&S>=2e4&&D>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:S});return}const M=Math.max(2e4-l,2e4-S,2e4-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new p(3,0,this._incomingAckId,g());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new p(9,0,this._incomingAckId,g());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(ie[38],ne([0,1,15,14,13]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class A{constructor(){this.mapListenerToWrapper=new WeakMap}on(I,u){const a=(g,...w)=>{this.validateEvent(I,g)&&u(g,...w)};return this.mapListenerToWrapper.set(u,a),C.ipcMain.on(I,a),this}once(I,u){return C.ipcMain.once(I,(a,...g)=>{this.validateEvent(I,a)&&u(a,...g)}),this}handle(I,u){return C.ipcMain.handle(I,(a,...g)=>this.validateEvent(I,a)?u(a,...g):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return C.ipcMain.removeHandler(I),this}removeListener(I,u){const a=this.mapListenerToWrapper.get(u);return a&&(C.ipcMain.removeListener(I,a),this.mapListenerToWrapper.delete(u)),this}validateEvent(I,u){if(!I||!I.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const a=u.senderFrame,g=a.url;if(!g||g==="about:blank")return!0;let w="unknown";try{w=new URL(g).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${g}'.`),!1}return w!==r.VSCODE_AUTHORITY?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${w}'.`),!1):a.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new A}),define(ie[158],ne([0,1,15,38,146]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){L.validatedIpcMain.on(r.CONTEXT_MENU_CHANNEL,(I,u,a,g,w)=>{const y=R(I,g,a);y.popup({x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{y&&I.sender.send(r.CONTEXT_MENU_CLOSE_CHANNEL,u)}})})}e.registerContextMenuListener=A;function R(I,u,a){const g=new C.Menu;return a.forEach(w=>{let y;w.type==="separator"?y=new C.MenuItem({type:w.type}):Array.isArray(w.submenu)?y=new C.MenuItem({submenu:R(I,u,w.submenu),label:w.label}):y=new C.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(h,b,p)=>I.sender.send(u,w.id,p)}),g.append(y)}),g}}),define(ie[159],ne([0,1,38,17,3,2,42,147]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function u(g,w){const y=r.Event.fromNodeEventEmitter(C.validatedIpcMain,w,(b,p)=>({event:b,message:p})),h=r.Event.filter(y,({event:b})=>b.sender.id===g);return r.Event.map(h,({message:b})=>b&&L.VSBuffer.wrap(b))}class a extends R.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const w=r.Event.fromNodeEventEmitter(C.validatedIpcMain,"vscode:hello",({sender:y})=>y);return r.Event.map(w,y=>{const h=y.id;a.Clients.get(h)?.dispose();const p=new r.Emitter;a.Clients.set(h,(0,A.toDisposable)(()=>p.fire()));const v=u(h,"vscode:message"),m=r.Event.any(r.Event.signal(u(h,"vscode:disconnect")),p.event);return{protocol:new I.Protocol(y,v),onDidClientDisconnect:m}})}constructor(){super(a.getOnDidClientConnect())}}e.Server=a}),define(ie[110],ne([0,1,38,3,32,157]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends A.Client{constructor(a,g){super({addEventListener:(w,y)=>a.addListener(w,y),removeEventListener:(w,y)=>a.removeListener(w,y),postMessage:w=>a.postMessage(w),start:()=>a.start(),close:()=>a.close()},g)}}e.Client=R;async function I(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,r.generateUuid)();u.webContents.send("vscode:createMessageChannel",a);const g=L.Event.fromNodeEventEmitter(C.validatedIpcMain,"vscode:createMessageChannelResult",(y,h)=>({nonce:h,port:y.ports[0]})),{port:w}=await L.Event.toPromise(L.Event.once(L.Event.filter(g,y=>y.nonce===a)));return w}e.connect=I}),define(ie[160],ne([0,1,47,8,17,22,154,14,3,2,37,89,75,42]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class b extends h.ChannelServer{constructor(m){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>r.VSBuffer.wrap(Buffer.from(f,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=b;class p{constructor(m,f){this.modulePath=m,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new L.Delayer(d),this.child=null,this._client=null}getChannel(m){const f=this;return{call(d,E,c){return f.requestPromise(m,d,E,c)},listen(d,E){return f.requestEvent(m,d,E)}}}requestPromise(m,f,d,E=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(m),i=(0,L.createCancelablePromise)(t=>c.call(f,d,t)),o=E.onCancellationRequested(()=>i.cancel()),s=(0,a.toDisposable)(()=>i.cancel());return this.activeRequests.add(s),i.finally(()=>{o.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(m,f,d){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let E;const c=new u.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(m).listen(f,d)(c.fire,c),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,g.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.removeDangerousEnvVariables)(f.env),this.child=(0,C.fork)(this.modulePath,m,f);const d=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,R.isRemoteConsoleLog)(n)){(0,R.log)(n,`IPC Library: ${this.options.serverName}`);return}d.fire(r.VSBuffer.wrap(Buffer.from(n,"base64")))});const c=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,i=n=>this.child&&this.child.connected&&c.send(n.buffer.toString("base64")),o=d.event,s={send:i,onMessage:o};this._client=new h.ChannelClient(s);const t=()=>this.disposeClient();process.once("exit",t),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,l)=>{process.removeListener("exit",t),this.activeRequests.forEach(S=>(0,a.dispose)(S)),this.activeRequests.clear(),n!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:l})})}return this._client}getCachedChannel(m){let f=this.channels.get(m);return f||(f=this.client.getChannel(m),this.channels.set(m,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(ie[111],ne([0,1,8,3,2,76,12]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function u(y){const h=y;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=u;var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends r.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(h,b=Object.create(null)){super(),this.database=h,this.options=b,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new C.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){this._onDidChangeStorage.pause();try{h.changed?.forEach((b,p)=>this.acceptExternal(p,b)),h.deleted?.forEach(b=>this.acceptExternal(b,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(h,b){if(this.state===a.Closed)return;let p=!1;(0,R.isUndefinedOrNull)(b)?p=this.cache.delete(h):this.cache.get(h)!==b&&(this.cache.set(h,b),p=!0),p&&this._onDidChangeStorage.fire({key:h,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,b){const p=this.cache.get(h);return(0,R.isUndefinedOrNull)(p)?b:p}getBoolean(h,b){const p=this.get(h);return(0,R.isUndefinedOrNull)(p)?b:p==="true"}getNumber(h,b){const p=this.get(h);return(0,R.isUndefinedOrNull)(p)?b:parseInt(p,10)}getObject(h,b){const p=this.get(h);return(0,R.isUndefinedOrNull)(p)?b:(0,A.parse)(p)}async set(h,b,p=!1){if(this.state===a.Closed)return;if((0,R.isUndefinedOrNull)(b))return this.delete(h,p);const v=(0,R.isObject)(b)||Array.isArray(b)?(0,A.stringify)(b):String(b);if(this.cache.get(h)!==v)return this.cache.set(h,v),this.pendingInserts.set(h,v),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire({key:h,external:p}),this.doFlush()}async delete(h,b=!1){if(!(this.state===a.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire({key:h,external:b}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(this.hasPending)return this.doFlush(h)}async doFlush(h){return this.options.hint===I.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}isInMemory(){return this.options.hint===I.STORAGE_IN_MEMORY}}e.Storage=g;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((b,p)=>this.items.set(p,b)),h.delete?.forEach(b=>this.items.delete(b))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=w}),define(ie[161],ne([0,1,8,3,31,9,21]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return L.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(g,w=Object.create(null)){this.path=g,this.options=w,this.name=(0,A.basename)(this.path),this.logger=new u(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const g=await this.whenConnected,w=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(h=>w.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${w.size} rows`),w}async updateItems(g){const w=await this.whenConnected;return this.doUpdateItems(w,g)}doUpdateItems(g,w){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${w.insert?(0,r.mapToString)(w.insert):"0"}), delete(${w.delete?(0,r.setToString)(w.delete):"0"})`),this.transaction(g,()=>{const y=w.insert,h=w.delete;if(y&&y.size>0){const b=[];b.push([]);let p=0;y.forEach((v,m)=>{let f=b[p];f.length>I.MAX_HOST_PARAMETERS&&(p++,f=[],b.push(f)),f.push(m,v)}),b.forEach(v=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(v.length/2).fill("(?,?)").join(",")}`,m=>m.run(v),()=>{const m=[];let f=0;return y.forEach((d,E)=>{m.push(E),f+=d.length}),`Keys: ${m.join(", ")} Length: ${f}`})})}if(h&&h.size){const b=[];b.push([]);let p=0;h.forEach(v=>{let m=b[p];m.length>I.MAX_HOST_PARAMETERS&&(p++,m=[],b.push(m)),m.push(v)}),b.forEach(v=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(v.length).fill("?").join(",")})`,m=>m.run(v),()=>{const m=[];return h.forEach(f=>{m.push(f)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const g=await this.whenConnected;return this.exec(g,"VACUUM")}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const w=await this.whenConnected;return this.doClose(w,g)}doClose(g,w){return new Promise((y,h)=>{g.db.close(b=>(b&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${b}`),this.path===I.IN_MEMORY_PATH?y():!g.isErroneous&&!g.isInMemory?this.backup().then(y,p=>(this.logger.error(`[storage ${this.name}] backup(): ${p}`),y())):typeof w=="function"?R.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(p=>{const v=()=>this.doClose(p,void 0);return this.doUpdateItems(p,{insert:w()}).then(()=>v(),m=>(v(),Promise.reject(m)))})).then(y,h):h(b||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return R.Promises.copy(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const w=await this.whenConnected,y=await this.get(w,g?"PRAGMA integrity_check":"PRAGMA quick_check"),h=g?y.integrity_check:y.quick_check;return w.isErroneous?`${h} (last error: ${w.lastError})`:w.isInMemory?`${h} (in-memory!)`:h}async connect(g,w=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${w})`);try{return await this.doConnect(g)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&w)return await(0,C.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await R.Promises.unlink(g);try{await R.Promises.rename(this.toBackupPath(g),g,!1)}catch{}return await this.doConnect(g)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(g,w){g.isErroneous=!0,g.lastError=w,this.logger.error(w)}doConnect(g){return new Promise((w,y)=>{new Promise((h,b)=>{G(["@vscode/sqlite3"],h,b)}).then(h=>{const b={db:new(this.logger.isTracing?h.verbose().Database:h.Database)(g,p=>p?b.db&&p.code!=="SQLITE_CANTOPEN"?b.db.close(()=>y(p)):y(p):this.exec(b,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(b),v=>b.db.close(()=>y(v)))),isInMemory:g===I.IN_MEMORY_PATH};b.db.on("error",p=>this.handleSQLiteError(b,`[storage ${this.name}] Error (event): ${p}`)),this.logger.isTracing&&b.db.on("trace",p=>this.logger.trace(`[storage ${this.name}] Trace (event): ${p}`))},y)})}exec(g,w){return new Promise((y,h)=>{g.db.exec(w,b=>b?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${b}`),h(b)):y())})}get(g,w){return new Promise((y,h)=>{g.db.get(w,(b,p)=>b?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${b}`),h(b)):y(p))})}all(g,w){return new Promise((y,h)=>{g.db.all(w,(b,p)=>b?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${b}`),h(b)):y(p))})}transaction(g,w){return new Promise((y,h)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),w(),g.db.run("END TRANSACTION",b=>b?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${b}`),h(b)):y())})})}prepare(g,w,y,h){const b=g.db.prepare(w),p=v=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${v} (${w}). Details: ${h()}`)};b.on("error",p),y(b),b.finalize(v=>{v&&p(v),b.removeListener("error",p)})}}e.SQLiteStorageDatabase=I;class u{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[u.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace?.(g)}error(g){this.logError?.(g)}}}),define(ie[162],ne([11,10]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(ie[163],ne([11,10]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[164],ne([11,10]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[165],ne([11,10]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ie[166],ne([11,10]),function(G,e){return G.create("vs/platform/dialogs/common/dialogs",e)}),define(ie[167],ne([11,10]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[168],ne([11,10]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(ie[169],ne([11,10]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(ie[170],ne([11,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[171],ne([11,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[172],ne([11,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[173],ne([11,10]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[174],ne([11,10]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[175],ne([11,10]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ie[176],ne([11,10]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ie[177],ne([11,10]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ie[178],ne([11,10]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[179],ne([11,10]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[180],ne([11,10]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[181],ne([11,10]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[182],ne([11,10]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[183],ne([11,10]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ie[184],ne([11,10]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ie[185],ne([11,10]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[186],ne([11,10]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ie[187],ne([11,10]),function(G,e){return G.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ie[188],ne([11,10]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[189],ne([11,10]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[190],ne([11,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[191],ne([11,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[192],ne([11,10]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ie[193],ne([11,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[194],ne([11,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[195],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function C(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=C;function L(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ie[196],ne([0,1,7]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function r(R){let I=[];try{Array.isArray(R.workspaces)&&(I=R.workspaces.map(u=>({workspace:{id:u.id,configPath:C.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=r;function A(R){let I=[];try{Array.isArray(R.folders)&&(I=R.folders.map(u=>({folderUri:C.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=A}),define(ie[197],ne([0,1,14,165]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(r||(e.TokenType=r={}));function A(...a){switch(a.length){case 1:return(0,L.localize)(0,null,a[0]);case 2:return(0,L.localize)(1,null,a[0],a[1]);case 3:return(0,L.localize)(2,null,a[0],a[1],a[2]);default:return}}const R=(0,L.localize)(3,null),I=(0,L.localize)(4,null);class u{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,C.illegalState)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(g){return this._input=g,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const w=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:w})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const w=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:w})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(g){return this._isAtEnd()||this._input.charCodeAt(this._current)!==g?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(g){this._tokens.push({type:g,offset:this._start})}_error(g){const w=this._start,y=this._input.substring(this._start,this._current),h={type:19,offset:this._start,lexeme:y};this._errors.push({offset:w,lexeme:y,additionalInfo:g}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const g=this.stringRe.exec(this._input);if(g){this._current=this._start+g[0].length;const w=this._input.substring(this._start,this._current),y=u._keywords.get(w);y?this._addToken(y):this._tokens.push({type:17,lexeme:w,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let g=this._current,w=!1,y=!1;for(;;){if(g>=this._input.length){this._current=g,this._error(I);return}const b=this._input.charCodeAt(g);if(w)w=!1;else if(b===47&&!y){g++;break}else b===91?y=!0:b===92?w=!0:b===93&&(y=!1);g++}for(;g<this._input.length&&u._regexFlags.has(this._input.charCodeAt(g));)g++;this._current=g;const h=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=u}),define(ie[198],ne([0,1,3,2]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new C.Emitter,this._onReloadEmitter=new C.Emitter,this._onTerminateEmitter=new C.Emitter,this._onAttachEmitter=new C.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(I,u,a){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(I,u,a){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r;class A extends L.Disposable{constructor(I){super(),this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,u,a){this.channel.call("attach",[I,u,a])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,u){this.channel.call("terminate",[I,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,u){return this.channel.call("openExtensionDevelopmentHostWindow",[I,u])}}e.ExtensionHostDebugChannelClient=A}),define(ie[199],ne([0,1,149,54,13,9,35,19,7]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,A.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(u.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=R.env.VSCODE_PORTABLE;return h?u.URI.file((0,A.join)(h,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?u.URI.file((0,A.resolve)(h)):u.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const b=R.env.VSCODE_EXTENSIONS;if(b)return b;const p=R.env.VSCODE_PORTABLE;return p?(0,A.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(b=>/^[^:/?#]+?:\/\//.test(b)?u.URI.parse(b):u.URI.file((0,A.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?u.URI.parse(h):u.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const b of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=R.env.VSCODE_PORTABLE;return h?u.URI.file((0,A.join)(h,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,b,p){this._args=h,this.paths=b,this.productService=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,Pe([L.memoize],a.prototype,"appRoot",null),Pe([L.memoize],a.prototype,"userHome",null),Pe([L.memoize],a.prototype,"userDataPath",null),Pe([L.memoize],a.prototype,"appSettingsHome",null),Pe([L.memoize],a.prototype,"tmpDir",null),Pe([L.memoize],a.prototype,"cacheHome",null),Pe([L.memoize],a.prototype,"stateResource",null),Pe([L.memoize],a.prototype,"userRoamingDataHome",null),Pe([L.memoize],a.prototype,"userDataSyncHome",null),Pe([L.memoize],a.prototype,"sync",null),Pe([L.memoize],a.prototype,"machineSettingsResource",null),Pe([L.memoize],a.prototype,"workspaceStorageHome",null),Pe([L.memoize],a.prototype,"localHistoryHome",null),Pe([L.memoize],a.prototype,"keyboardLayoutResource",null),Pe([L.memoize],a.prototype,"argvResource",null),Pe([L.memoize],a.prototype,"isExtensionDevelopment",null),Pe([L.memoize],a.prototype,"untitledWorkspacesHome",null),Pe([L.memoize],a.prototype,"builtinExtensionsPath",null),Pe([L.memoize],a.prototype,"extensionsPath",null),Pe([L.memoize],a.prototype,"extensionDevelopmentLocationURI",null),Pe([L.memoize],a.prototype,"extensionDevelopmentKind",null),Pe([L.memoize],a.prototype,"extensionTestsLocationURI",null),Pe([L.memoize],a.prototype,"debugExtensionHost",null),Pe([L.memoize],a.prototype,"logLevel",null),Pe([L.memoize],a.prototype,"extensionLogLevel",null),Pe([L.memoize],a.prototype,"serviceMachineIdResource",null),Pe([L.memoize],a.prototype,"disableTelemetry",null),Pe([L.memoize],a.prototype,"disableWorkspaceTrust",null),Pe([L.memoize],a.prototype,"useInMemorySecretStorage",null),Pe([L.memoize],a.prototype,"policyFile",null);function g(y,h){return w(y["inspect-extensions"],y["inspect-brk-extensions"],5870,h,y.debugId,y.extensionEnvironment)}e.parseExtensionHostDebugPort=g;function w(y,h,b,p,v,m){const d=Number(h||y)||(p?null:b),E=d?!!h:!1;let c;if(m)try{c=JSON.parse(m)}catch{}return{port:d,break:E,debugId:v,env:c}}e.parseDebugParams=w}),define(ie[112],ne([0,1,309,4,168]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const A={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(p,v,m=R){const f=p.find(l=>l.length>0&&l[0]!=="-"),d={},E=["_"],c=[],i={};let o;for(const l in v){const S=v[l];S.type==="subcommand"?l===f&&(o=S):(S.alias&&(d[l]=S.alias),S.type==="string"||S.type==="string[]"?(E.push(l),S.deprecates&&E.push(...S.deprecates)):S.type==="boolean"&&(c.push(l),S.deprecates&&c.push(...S.deprecates)),S.global&&(i[l]=S))}if(o&&f){const l=i;for(const P in o.options)l[P]=o.options[P];const S=p.filter(P=>P!==f),D=m.getSubcommandReporter?m.getSubcommandReporter(f):void 0,M=I(S,l,D);return{[f]:M,_:[]}}const s=C(p,{string:E,boolean:c,alias:d}),t={},n=s;t._=s._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(const l in v){const S=v[l];if(S.type==="subcommand")continue;S.alias&&delete n[S.alias];let D=n[l];if(S.deprecates)for(const M of S.deprecates)n.hasOwnProperty(M)&&(D||(D=n[M],D&&m.onDeprecatedOption(M,S.deprecationMessage||(0,r.localize)(37,null,l))),delete n[M]);if(typeof D<"u"){if(S.type==="string[]"){if(Array.isArray(D)||(D=[D]),!S.allowEmptyValue){const M=D.filter(P=>P.length>0);M.length!==D.length&&(m.onEmptyValue(l),D=M.length>0?M:void 0)}}else S.type==="string"&&(Array.isArray(D)?(D=D.pop(),m.onMultipleValues(l,D)):!D&&!S.allowEmptyValue&&(m.onEmptyValue(l),D=void 0));t[l]=D,S.deprecationMessage&&m.onDeprecatedOption(l,S.deprecationMessage)}delete n[l]}for(const l in n)m.onUnknownOption(l);return t}e.parseArgs=I;function u(p,v){let m="";return v.args&&(Array.isArray(v.args)?m=` <${v.args.join("> <")}>`:m=` <${v.args}>`),v.alias?`-${v.alias} --${p}${m}`:`--${p}${m}`}function a(p,v){const m=[];for(const f in p){const d=p[f],E=u(f,d);m.push([E,d.description])}return g(m,v)}e.formatOptions=a;function g(p,v){const f=p.reduce((c,i)=>Math.max(c,i[0].length),12)+2+1;if(v-f<25)return p.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const d=v-f-1,E=[];for(const c of p){const i=c[0],o=y(c[1],d),s=w(f-i.length-2);E.push("  "+i+s+o[0]);for(let t=1;t<o.length;t++)E.push(w(f)+o[t])}return E}function w(p){return" ".repeat(p)}function y(p,v){const m=[];for(;p.length;){const f=p.length<v?p.length:p.lastIndexOf(" ",v),d=p.slice(0,f).trim();p=p.slice(f),m.push(d)}return m}function h(p,v,m,f,d){const E=process.stdout.isTTY&&process.stdout.columns||80,c=d?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",i=[`${p} ${m}`];i.push(""),i.push(`${(0,r.localize)(39,null)}: ${v} [${(0,r.localize)(40,null)}]${c}`),i.push(""),d?.noPipe!==!0&&(L.isWindows?i.push((0,r.localize)(41,null,v)):i.push((0,r.localize)(42,null,v)),i.push(""));const o={},s=[];for(const t in f){const n=f[t];if(n.type==="subcommand")n.description&&s.push({command:t,description:n.description});else if(n.description&&n.cat){let l=o[n.cat];l||(o[n.cat]=l={}),l[t]=n}}for(const t in o){const n=t,l=o[n];l&&(i.push(A[n]),i.push(...a(l,E)),i.push(""))}return s.length&&(i.push((0,r.localize)(43,null)),i.push(...g(s.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.buildHelpMessage=h;function b(p,v){return`${p||(0,r.localize)(44,null)}
${v||(0,r.localize)(45,null)}
${process.arch}`}e.buildVersionMessage=b}),define(ie[200],ne([0,1,87,198,112]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends L.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.windowsMainService=I}call(I,u,a){return u==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(a[0],a[1]):super.call(I,u,a)}async openExtensionDevelopmentHostWindow(I,u){const a=(0,r.parseArgs)(I,r.OPTIONS);a.debugRenderer=u;const g=a.extensionDevelopmentPath;if(!g)return{success:!1};const[w]=await this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!u)return{success:!0};const y=w.win;if(!y)return{success:!0};const h=y.webContents.debugger;let b=h.isAttached()?1/0:0;const p=(0,C.createServer)(v=>{b++===0&&h.attach();let m=!1;const f=c=>{m||v.write(JSON.stringify(c)+"\0")},d=(c,i,o,s)=>f({method:i,params:o,sessionId:s});y.on("close",()=>{h.removeListener("message",d),v.end(),m=!0}),h.addListener("message",d);let E=Buffer.alloc(0);v.on("data",c=>{E=Buffer.concat([E,c]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let o;try{const s=E.slice(0,i).toString("utf8");E=E.slice(i+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}h.sendCommand(o.method,o.params,o.sessionId).then(s=>f({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),v.on("error",c=>{console.error("error on cdp pipe:",c)}),v.on("close",()=>{m=!0,--b===0&&h.detach()})});return await new Promise(v=>p.listen(0,v)),y.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(ie[62],ne([0,1,310,169,112]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(w,y){const h=(d,E)=>{console.warn((0,L.localize)(0,null,d,E))},b=d=>{console.warn((0,L.localize)(1,null,d))},p=(d,E)=>{console.warn((0,L.localize)(2,null,d,E))},v=d=>({onUnknownOption:E=>{r.NATIVE_CLI_COMMANDS.includes(d)||console.warn((0,L.localize)(3,null,E,d))},onMultipleValues:h,onEmptyValue:b,onDeprecatedOption:p,getSubcommandReporter:r.NATIVE_CLI_COMMANDS.includes(d)?v:void 0}),m={onUnknownOption:d=>{console.warn((0,L.localize)(4,null,d))},onMultipleValues:h,onEmptyValue:b,onDeprecatedOption:p,getSubcommandReporter:v},f=(0,r.parseArgs)(w,r.OPTIONS,y?m:void 0);return f.goto&&f._.forEach(d=>C(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,L.localize)(5,null))),f}function R(w){const y=w.findIndex(h=>!/^-/.test(h));if(y>-1)return[...w.slice(0,y),...w.slice(y+1)]}function I(w){let[,...y]=w;process.env.VSCODE_DEV&&(y=R(y)||[]);const h=!g(process.env);return A(y,h)}e.parseMainProcessArgv=I;function u(w){let[,,...y]=w;return process.env.VSCODE_DEV&&(y=R(y)||[]),A(y,!0)}e.parseCLIProcessArgv=u;function a(w,...y){const h=w.indexOf("--");return h===-1?w.push(...y):w.splice(h,0,...y),w}e.addArg=a;function g(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),function(){"use strict";function G(e,C,L){function r(R,I){const u=A(R,I),a=[u];return e.isAbsolute(u)||a.unshift(L),e.resolve(...a)}function A(R,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,I);const g=R["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(w,"AppData","Roaming")}break;case"darwin":a=e.join(C.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,I)}return{getUserDataPath:r}}if(typeof define=="function")define(ie[201],ne([113,28,35]),function(e,C,L){return G(e,C,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),C=require("os");module.exports=G(e,C,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[90],ne([0,1,28,199,201]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(a,g){super(a,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,r.getUserDataPath)(a,g.nameShort)},g)}}e.NativeEnvironmentService=A;function R(u,a){return(0,L.parseDebugParams)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}e.parsePtyHostDebugPort=R;function I(u,a){return(0,L.parseDebugParams)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(ie[202],ne([0,1,45,28,33]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function A(R){const I=(0,r.randomPath)((0,L.tmpdir)());try{return(0,C.writeFileSync)(I,""),R&&console.log(`Marker file for --wait created: ${I}`),I}catch(u){R&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.createWaitMarkerFileSync=A}),define(ie[203],ne([0,1,12,171]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(R,I,u,a){try{A(R,I,u,a)}catch(g){R.error(g?.message??g)}return I}e.localizeManifest=r;function A(R,I,u,a){const g=(w,y,h)=>{const b=w[y];if((0,C.isString)(b)){const p=b,v=p.length;if(v>1&&p[0]==="%"&&p[v-1]==="%"){const m=p.substr(1,v-2);let f=u[m];f===void 0&&a&&(f=a[m]);const d=typeof f=="string"?f:f?.message,E=a?.[m],c=typeof E=="string"?E:E?.message;if(!d){c||R.warn(`[${I.name}]: ${(0,L.localize)(0,null,m)}`);return}if(h&&(y==="title"||y==="category")&&c&&c!==d){const i={value:d,original:c};w[y]=i}else w[y]=d}}else if((0,C.isObject)(b))for(const p in b)b.hasOwnProperty(p)&&(p==="commands"?g(b,p,!0):g(b,p,h));else if(Array.isArray(b))for(let p=0;p<b.length;p++)g(b,p,h)};for(const w in I)I.hasOwnProperty(w)&&g(I,w)}}),define(ie[204],ne([0,1,19,73,173,205]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function u(m){return m=m.trim(),m==="*"||R.test(m)}e.isValidVersionStr=u;function a(m){if(!u(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=m.match(R);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=a;function g(m){if(!m)return null;const f=m.majorBase,d=m.majorMustEqual,E=m.minorBase;let c=m.minorMustEqual;const i=m.patchBase;let o=m.patchMustEqual;m.hasCaret&&(f===0||(c=!1),o=!1);let s=0;if(m.preRelease){const t=I.exec(m.preRelease);if(t){const[,n,l,S]=t;s=Date.UTC(Number(n),Number(l)-1,Number(S))}}return{majorBase:f,majorMustEqual:d,minorBase:E,minorMustEqual:c,patchBase:i,patchMustEqual:o,isMinimum:m.hasGreaterEquals,notBefore:s}}e.normalizeVersion=g;function w(m,f,d){let E;typeof m=="string"?E=g(a(m)):E=m;let c;f instanceof Date?c=f.getTime():typeof f=="string"&&(c=new Date(f).getTime());let i;if(typeof d=="string"?i=g(a(d)):i=d,!E||!i)return!1;const o=E.majorBase,s=E.minorBase,t=E.patchBase;let n=i.majorBase,l=i.minorBase,S=i.patchBase;const D=i.notBefore;let M=i.majorMustEqual,P=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:s>l?!0:s<l||c&&c<D?!1:t>=S:(o===1&&n===0&&(!M||!P||!k)&&(n=1,l=0,S=0,M=!0,P=!1,k=!1),o<n?!1:o>n?!M:s<l?!1:s>l?!P:t<S?!1:t>S?!k:!(c&&c<D))}e.isValidVersion=w;function y(m,f,d,E,c){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([L.default.Error,r.localize(0,null)]),i;if(typeof E.name!="string")return i.push([L.default.Error,r.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([L.default.Error,r.localize(2,null,"version")]),i;if(!E.engines)return i.push([L.default.Error,r.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([L.default.Error,r.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!v(E.extensionDependencies))return i.push([L.default.Error,r.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!v(E.activationEvents))return i.push([L.default.Error,r.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([L.default.Error,r.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([L.default.Warning,r.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([L.default.Error,r.localize(9,null,"main")]),i;{const t=(0,C.joinPath)(d,E.main);(0,C.isEqualOrParent)(t,d)||i.push([L.default.Warning,r.localize(10,null,t.path,d.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([L.default.Error,r.localize(11,null,"browser")]),i;{const t=(0,C.joinPath)(d,E.browser);(0,C.isEqualOrParent)(t,d)||i.push([L.default.Warning,r.localize(12,null,t.path,d.path)])}}if(!A.valid(E.version))return i.push([L.default.Error,r.localize(13,null)]),i;const o=[];if(!h(m,f,E,c,o))for(const t of o)i.push([L.default.Error,t]);return i}e.validateExtensionManifest=y;function h(m,f,d,E,c){return E||typeof d.main>"u"&&typeof d.browser>"u"?!0:p(m,f,d.engines.vscode,c)}e.isValidExtensionVersion=h;function b(m,f,d){return m==="*"||p(f,d,m)}e.isEngineValid=b;function p(m,f,d,E=[]){const c=g(a(d));if(!c)return E.push(r.localize(14,null,d)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return E.push(r.localize(15,null,d)),!1}else if(!c.majorMustEqual)return E.push(r.localize(16,null,d)),!1;return w(m,f,c)?!0:(E.push(r.localize(17,null,m,d)),!1)}function v(m){if(!Array.isArray(m))return!1;for(let f=0,d=m.length;f<d;f++)if(typeof m[f]!="string")return!1;return!0}}),define(ie[206],ne([0,1,17,32]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(A,R,I){let u=I&&I.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const g=(await R.readFile(A.serviceMachineIdResource)).value.toString();u=(0,L.isUUID)(g)?g:null}catch{u=null}if(!u){u=(0,L.generateUuid)();try{await R.writeFile(A.serviceMachineIdResource,C.VSBuffer.fromString(u))}catch{}}return I?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=r}),define(ie[77],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class C{constructor(r,A=[],R=!1){this.ctor=r,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=C}),define(ie[207],ne([0,1,77]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var r;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function A(I,u,a){u instanceof C.SyncDescriptor||(u=new C.SyncDescriptor(u,[],!!a)),L.push([I,u])}e.registerSingleton=A;function R(){return L}e.getSingletonServiceDescriptors=R}),define(ie[208],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class C{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=C;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const I=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(R);I.outgoing.set(u.key,u),u.incoming.set(I.key,I)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(const I of this._nodes.values())I.outgoing.delete(R),I.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let I=this._nodes.get(R);return I||(I=new C(R,A),this._nodes.set(R,I)),I}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[R,I]of this._nodes)A.push(`${R}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this._nodes){const I=new Set([A]),u=this._findCycle(R,I);if(u)return u}}_findCycle(A,R){for(const[I,u]of A.outgoing){if(R.has(I))return[...R,I].join(" -> ");R.add(I);const a=this._findCycle(u,R);if(a)return a;R.delete(I)}}}e.Graph=L}),define(ie[5],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var C;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function I(u){return u[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=I})(C||(e._util=C={})),e.IInstantiationService=r("instantiationService");function L(R,I,u){I[C.DI_TARGET]===I?I[C.DI_DEPENDENCIES].push({id:R,index:u}):(I[C.DI_DEPENDENCIES]=[{id:R,index:u}],I[C.DI_TARGET]=I)}function r(R){if(C.serviceIds.has(R))return C.serviceIds.get(R);const I=function(u,a,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(I,u,g)};return I.toString=()=>R,C.serviceIds.set(R,I),I}e.createDecorator=r;function A(R){return R}e.refineServiceDecorator=A}),define(ie[78],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,C.createDecorator)("auxiliaryWindowsMainService")}),define(ie[63],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,C.createDecorator)("backupMainService")}),define(ie[18],ne([0,1,12,7,5]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof L.URI)}e.isConfigurationOverrides=A;function R(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=R;var I;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function u(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function a(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}e.isConfigured=a;function g(m,f){const d=Object.create(null);for(const E in m)w(d,E,m[E],f);return d}e.toValuesTree=g;function w(m,f,d,E){const c=f.split("."),i=c.pop();let o=m;for(let s=0;s<c.length;s++){const t=c[s];let n=o[t];switch(typeof n){case"undefined":n=o[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${f} as ${c.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=d}catch{E(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=w;function y(m,f){const d=f.split(".");h(m,d)}e.removeFromValueTree=y;function h(m,f){const d=f.shift();if(f.length===0){delete m[d];return}if(Object.keys(m).indexOf(d)!==-1){const E=m[d];typeof E=="object"&&!Array.isArray(E)&&(h(E,f),Object.keys(E).length===0&&delete m[d])}}function b(m,f,d){function E(o,s){let t=o;for(const n of s){if(typeof t!="object"||t===null)return;t=t[n]}return t}const c=f.split("."),i=E(m,c);return typeof i>"u"?d:i}e.getConfigurationValue=b;function p(m,f,d){Object.keys(f).forEach(E=>{E!=="__proto__"&&(E in m?C.isObject(m[E])&&C.isObject(f[E])?p(m[E],f[E],d):d&&(m[E]=f[E]):m[E]=f[E])})}e.merge=p;function v(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(ie[114],ne([0,1,4,27,197,5,164,14]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",C.isMacintosh),u.set("isLinux",C.isLinux),u.set("isWindows",C.isWindows),u.set("isWeb",C.isWeb),u.set("isMacNative",C.isMacintosh&&!C.isWeb),u.set("isEdge",C.isEdge),u.set("isFirefox",C.isFirefox),u.set("isChrome",C.isChrome),u.set("isSafari",C.isSafari);function a(W,_){if(u.get(W)!==void 0)throw(0,I.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(W,_)}e.setConstant=a;const g=Object.prototype.hasOwnProperty;var w;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const y={regexParsingWithErrorRecovery:!0},h=(0,R.localize)(0,null),b=(0,R.localize)(1,null),p=(0,R.localize)(2,null),v=(0,R.localize)(3,null),m=(0,R.localize)(4,null),f=(0,R.localize)(5,null),d=(0,R.localize)(6,null),E=(0,R.localize)(7,null);class c{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(_=y){this._config=_,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(_){if(_===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:b});return}this._tokens=this._scanner.reset(_).scan(),this._current=0,this._parsingErrors=[];try{const U=this._expr();if(!this._isAtEnd()){const B=this._peek(),T=B.type===17?f:void 0;throw this._parsingErrors.push({message:m,offset:B.offset,lexeme:r.Scanner.getLexeme(B),additionalInfo:T}),c._parseError}return U}catch(U){if(U!==c._parseError)throw U;return}}_expr(){return this._or()}_or(){const _=[this._and()];for(;this._matchOne(16);){const U=this._and();_.push(U)}return _.length===1?_[0]:i.or(..._)}_and(){const _=[this._term()];for(;this._matchOne(15);){const U=this._term();_.push(U)}return _.length===1?_[0]:i.and(..._)}_term(){if(this._matchOne(2)){const _=this._peek();switch(_.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),l.INSTANCE;case 0:{this._advance();const U=this._expr();return this._consume(1,v),U?.negate()}case 17:return this._advance(),O.create(_.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",_)}}return this._primary()}_primary(){const _=this._peek();switch(_.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const U=this._expr();return this._consume(1,v),U}case 17:{const U=_.lexeme;if(this._advance(),this._matchOne(9)){const T=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),T.type!==10)throw this._errExpectedButGot("REGEX",T);const $=T.lexeme,x=$.lastIndexOf("/"),ae=x===$.length-1?void 0:this._removeFlagsGY($.substring(x+1));let fe;try{fe=new RegExp($.substring(1,x),ae)}catch{throw this._errExpectedButGot("REGEX",T)}return re.create(U,fe)}switch(T.type){case 10:case 19:{const $=[T.lexeme];this._advance();let x=this._peek(),ae=0;for(let we=0;we<T.lexeme.length;we++)T.lexeme.charCodeAt(we)===40?ae++:T.lexeme.charCodeAt(we)===41&&ae--;for(;!this._isAtEnd()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let we=0;we<x.lexeme.length;we++)x.lexeme.charCodeAt(we)===40?ae++:T.lexeme.charCodeAt(we)===41&&ae--}if(ae<0)break;$.push(r.Scanner.getLexeme(x)),this._advance(),x=this._peek()}const fe=$.join(""),ue=fe.lastIndexOf("/"),de=ue===fe.length-1?void 0:this._removeFlagsGY(fe.substring(ue+1));let be;try{be=new RegExp(fe.substring(1,ue),de)}catch{throw this._errExpectedButGot("REGEX",T)}return i.regex(U,be)}case 18:{const $=T.lexeme;this._advance();let x=null;if(!(0,L.isFalsyOrWhitespace)($)){const ae=$.indexOf("/"),fe=$.lastIndexOf("/");if(ae!==fe&&ae>=0){const ue=$.slice(ae+1,fe),de=$[fe+1]==="i"?"i":"";try{x=new RegExp(ue,de)}catch{throw this._errExpectedButGot("REGEX",T)}}}if(x===null)throw this._errExpectedButGot("REGEX",T);return re.create(U,x)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,p);const T=this._value();return i.notIn(U,T)}switch(this._peek().type){case 3:{this._advance();const T=this._value();if(this._previous().type===18)return i.equals(U,T);switch(T){case"true":return i.has(U);case"false":return i.not(U);default:return i.equals(U,T)}}case 4:{this._advance();const T=this._value();if(this._previous().type===18)return i.notEquals(U,T);switch(T){case"true":return i.not(U);case"false":return i.has(U);default:return i.notEquals(U,T)}}case 5:return this._advance(),J.create(U,this._value());case 6:return this._advance(),oe.create(U,this._value());case 7:return this._advance(),z.create(U,this._value());case 8:return this._advance(),Y.create(U,this._value());case 13:return this._advance(),i.in(U,this._value());default:return i.has(U)}}case 20:throw this._parsingErrors.push({message:d,offset:_.offset,lexeme:"",additionalInfo:E}),c._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const _=this._peek();switch(_.type){case 17:case 18:return this._advance(),_.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(_){return _.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(_){return this._check(_)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(_,U){if(this._check(_))return this._advance();throw this._errExpectedButGot(U,this._peek())}_errExpectedButGot(_,U,B){const T=(0,R.localize)(8,null,_,r.Scanner.getLexeme(U)),$=U.offset,x=r.Scanner.getLexeme(U);return this._parsingErrors.push({message:T,offset:$,lexeme:x,additionalInfo:B}),c._parseError}_check(_){return this._peek().type===_}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=c;class i{static false(){return n.INSTANCE}static true(){return l.INSTANCE}static has(_){return S.create(_)}static equals(_,U){return D.create(_,U)}static notEquals(_,U){return k.create(_,U)}static regex(_,U){return re.create(_,U)}static in(_,U){return M.create(_,U)}static notIn(_,U){return P.create(_,U)}static not(_){return O.create(_)}static and(..._){return K.create(_,null,!0)}static or(..._){return V.create(_,null,!0)}static greater(_,U){return z.create(_,U)}static greaterEquals(_,U){return Y.create(_,U)}static smaller(_,U){return J.create(_,U)}static smallerEquals(_,U){return oe.create(_,U)}static{this._parser=new c({regexParsingWithErrorRecovery:!1})}static deserialize(_){return _==null?void 0:this._parser.parse(_)}}e.ContextKeyExpr=i;function o(W){const _=new c({regexParsingWithErrorRecovery:!1});return W.map(U=>(_.parse(U),_.lexingErrors.length>0?_.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,R.localize)(9,null,B.additionalInfo):(0,R.localize)(10,null),offset:B.offset,length:B.lexeme.length})):_.parsingErrors.length>0?_.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.validateWhenClauses=o;function s(W,_){const U=W?W.substituteConstants():void 0,B=_?_.substituteConstants():void 0;return!U&&!B?!0:!U||!B?!1:U.equals(B)}e.expressionsAreEqualWithConstantSubstitution=s;function t(W,_){return W.cmp(_)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=n;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=l;class S{static create(_,U=null){const B=u.get(_);return typeof B=="boolean"?B?l.INSTANCE:n.INSTANCE:new S(_,U)}constructor(_,U){this.key=_,this.negated=U,this.type=2}cmp(_){return _.type!==this.type?this.type-_.type:N(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=u.get(this.key);return typeof _=="boolean"?_?l.INSTANCE:n.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class D{static create(_,U,B=null){if(typeof U=="boolean")return U?S.create(_,B):O.create(_,B);const T=u.get(_);return typeof T=="boolean"?U===(T?"true":"false")?l.INSTANCE:n.INSTANCE:new D(_,U,B)}constructor(_,U,B){this.key=_,this.value=U,this.negated=B,this.type=4}cmp(_){return _.type!==this.type?this.type-_.type:j(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=u.get(this.key);if(typeof _=="boolean"){const U=_?"true":"false";return this.value===U?l.INSTANCE:n.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class M{static create(_,U){return new M(_,U)}constructor(_,U){this.key=_,this.valueKey=U,this.type=10,this.negated=null}cmp(_){return _.type!==this.type?this.type-_.type:j(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const U=_.getValue(this.valueKey),B=_.getValue(this.key);return Array.isArray(U)?U.includes(B):typeof B=="string"&&typeof U=="object"&&U!==null?g.call(U,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=M;class P{static create(_,U){return new P(_,U)}constructor(_,U){this.key=_,this.valueKey=U,this.type=11,this._negated=M.create(_,U)}cmp(_){return _.type!==this.type?this.type-_.type:this._negated.cmp(_._negated)}equals(_){return _.type===this.type?this._negated.equals(_._negated):!1}substituteConstants(){return this}evaluate(_){return!this._negated.evaluate(_)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(_){return _.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=P;class k{static create(_,U,B=null){if(typeof U=="boolean")return U?O.create(_,B):S.create(_,B);const T=u.get(_);return typeof T=="boolean"?U===(T?"true":"false")?n.INSTANCE:l.INSTANCE:new k(_,U,B)}constructor(_,U,B){this.key=_,this.value=U,this.negated=B,this.type=5}cmp(_){return _.type!==this.type?this.type-_.type:j(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=u.get(this.key);if(typeof _=="boolean"){const U=_?"true":"false";return this.value===U?n.INSTANCE:l.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class O{static create(_,U=null){const B=u.get(_);return typeof B=="boolean"?B?n.INSTANCE:l.INSTANCE:new O(_,U)}constructor(_,U){this.key=_,this.negated=U,this.type=3}cmp(_){return _.type!==this.type?this.type-_.type:N(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=u.get(this.key);return typeof _=="boolean"?_?n.INSTANCE:l.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function F(W,_){if(typeof W=="string"){const U=parseFloat(W);isNaN(U)||(W=U)}return typeof W=="string"||typeof W=="number"?_(W):n.INSTANCE}class z{static create(_,U,B=null){return F(U,T=>new z(_,T,B))}constructor(_,U,B){this.key=_,this.value=U,this.negated=B,this.type=12}cmp(_){return _.type!==this.type?this.type-_.type:j(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=oe.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=z;class Y{static create(_,U,B=null){return F(U,T=>new Y(_,T,B))}constructor(_,U,B){this.key=_,this.value=U,this.negated=B,this.type=13}cmp(_){return _.type!==this.type?this.type-_.type:j(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=Y;class J{static create(_,U,B=null){return F(U,T=>new J(_,T,B))}constructor(_,U,B){this.key=_,this.value=U,this.negated=B,this.type=14}cmp(_){return _.type!==this.type?this.type-_.type:j(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=J;class oe{static create(_,U,B=null){return F(U,T=>new oe(_,T,B))}constructor(_,U,B){this.key=_,this.value=U,this.negated=B,this.type=15}cmp(_){return _.type!==this.type?this.type-_.type:j(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=oe;class re{static create(_,U){return new re(_,U)}constructor(_,U){this.key=_,this.regexp=U,this.type=7,this.negated=null}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const U=this.regexp?this.regexp.source:"",B=_.regexp?_.regexp.source:"";return U<B?-1:U>B?1:0}equals(_){if(_.type===this.type){const U=this.regexp?this.regexp.source:"",B=_.regexp?_.regexp.source:"";return this.key===_.key&&U===B}return!1}substituteConstants(){return this}evaluate(_){const U=_.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ce.create(this)),this.negated}}e.ContextKeyRegexExpr=re;class ce{static create(_){return new ce(_)}constructor(_){this._actual=_,this.type=8}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(_){return new ce(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ce;function Q(W){let _=null;for(let U=0,B=W.length;U<B;U++){const T=W[U].substituteConstants();if(W[U]!==T&&_===null){_=[];for(let $=0;$<U;$++)_[$]=W[$]}_!==null&&(_[U]=T)}return _===null?W:_}class K{static create(_,U,B){return K._normalizeArr(_,U,B)}constructor(_,U){this.expr=_,this.negated=U,this.type=6}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const T=t(this.expr[U],_.expr[U]);if(T!==0)return T}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(_.expr[U]))return!1;return!0}return!1}substituteConstants(){const _=Q(this.expr);return _===this.expr?this:K.create(_,this.negated,!1)}evaluate(_){for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].evaluate(_))return!1;return!0}static _normalizeArr(_,U,B){const T=[];let $=!1;for(const x of _)if(x){if(x.type===1){$=!0;continue}if(x.type===0)return n.INSTANCE;if(x.type===6){T.push(...x.expr);continue}T.push(x)}if(T.length===0&&$)return l.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(t);for(let x=1;x<T.length;x++)T[x-1].equals(T[x])&&(T.splice(x,1),x--);if(T.length===1)return T[0];for(;T.length>1;){const x=T[T.length-1];if(x.type!==9)break;T.pop();const ae=T.pop(),fe=T.length===0,ue=V.create(x.expr.map(de=>K.create([de,ae],null,B)),null,fe);ue&&(T.push(ue),T.sort(t))}if(T.length===1)return T[0];if(B){for(let x=0;x<T.length;x++)for(let ae=x+1;ae<T.length;ae++)if(T[x].negate().equals(T[ae]))return n.INSTANCE;if(T.length===1)return T[0]}return new K(T,U)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(const U of this.expr)_.push(...U.keys());return _}map(_){return new K(this.expr.map(U=>U.map(_)),null)}negate(){if(!this.negated){const _=[];for(const U of this.expr)_.push(U.negate());this.negated=V.create(_,this,!0)}return this.negated}}e.ContextKeyAndExpr=K;class V{static create(_,U,B){return V._normalizeArr(_,U,B)}constructor(_,U){this.expr=_,this.negated=U,this.type=9}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const T=t(this.expr[U],_.expr[U]);if(T!==0)return T}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(_.expr[U]))return!1;return!0}return!1}substituteConstants(){const _=Q(this.expr);return _===this.expr?this:V.create(_,this.negated,!1)}evaluate(_){for(let U=0,B=this.expr.length;U<B;U++)if(this.expr[U].evaluate(_))return!0;return!1}static _normalizeArr(_,U,B){let T=[],$=!1;if(_){for(let x=0,ae=_.length;x<ae;x++){const fe=_[x];if(fe){if(fe.type===0){$=!0;continue}if(fe.type===1)return l.INSTANCE;if(fe.type===9){T=T.concat(fe.expr);continue}T.push(fe)}}if(T.length===0&&$)return n.INSTANCE;T.sort(t)}if(T.length!==0){if(T.length===1)return T[0];for(let x=1;x<T.length;x++)T[x-1].equals(T[x])&&(T.splice(x,1),x--);if(T.length===1)return T[0];if(B){for(let x=0;x<T.length;x++)for(let ae=x+1;ae<T.length;ae++)if(T[x].negate().equals(T[ae]))return l.INSTANCE;if(T.length===1)return T[0]}return new V(T,U)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(const U of this.expr)_.push(...U.keys());return _}map(_){return new V(this.expr.map(U=>U.map(_)),null)}negate(){if(!this.negated){const _=[];for(const U of this.expr)_.push(U.negate());for(;_.length>1;){const U=_.shift(),B=_.shift(),T=[];for(const $ of se(U))for(const x of se(B))T.push(K.create([$,x],null,!1));_.unshift(V.create(T,null,!1))}this.negated=V.create(_,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class q extends S{static{this._info=[]}static all(){return q._info.values()}constructor(_,U,B){super(_,null),this._defaultValue=U,typeof B=="object"?q._info.push({...B,key:_}):B!==!0&&q._info.push({key:_,description:B,type:U!=null?typeof U:void 0})}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return D.create(this.key,_)}notEqualsTo(_){return k.create(this.key,_)}}e.RawContextKey=q,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function N(W,_){return W<_?-1:W>_?1:0}function j(W,_,U,B){return W<U?-1:W>U?1:_<B?-1:_>B?1:0}function H(W,_){if(W.type===0||_.type===1)return!0;if(W.type===9)return _.type===9?X(W.expr,_.expr):!1;if(_.type===9){for(const U of _.expr)if(H(W,U))return!0;return!1}if(W.type===6){if(_.type===6)return X(_.expr,W.expr);for(const U of W.expr)if(H(U,_))return!0;return!1}return W.equals(_)}e.implies=H;function X(W,_){let U=0,B=0;for(;U<W.length&&B<_.length;){const T=W[U].cmp(_[B]);if(T<0)return!1;T===0&&U++,B++}return U===W.length}function se(W){return W.type===9?W.expr:[W]}}),define(ie[91],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,C.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class r{async getPerformanceInfo(R,I){return{}}async getSystemInfo(R,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,I){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=r}),define(ie[115],ne([0,1,19,73,166,5,46,4,37]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,A.createDecorator)("dialogService");var a;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(a||(a={}));class g{getConfirmationButtons(v){return this.getButtons(v,a.Confirmation)}getPromptButtons(v){return this.getButtons(v,a.Prompt)}getInputButtons(v){return this.getButtons(v,a.Input)}getButtons(v,m){const f=[];switch(m){case a.Confirmation:{const d=v;d.primaryButton?f.push(d.primaryButton):f.push((0,r.localize)(0,null)),d.cancelButton?f.push(d.cancelButton):f.push((0,r.localize)(1,null));break}case a.Prompt:{const d=v;Array.isArray(d.buttons)&&d.buttons.length>0&&f.push(...d.buttons.map(E=>E.label)),d.cancelButton&&(d.cancelButton===!0?f.push((0,r.localize)(2,null)):typeof d.cancelButton=="string"?f.push(d.cancelButton):d.cancelButton.label?f.push(d.cancelButton.label):f.push((0,r.localize)(3,null))),f.length===0&&f.push((0,r.localize)(4,null));break}case a.Input:{const d=v;d.primaryButton?f.push(d.primaryButton):f.push((0,r.localize)(5,null)),d.cancelButton?f.push(d.cancelButton):f.push((0,r.localize)(6,null));break}}return f}getDialogType(v){if(typeof v=="string")return v;if(typeof v=="number")return v===L.default.Info?"info":v===L.default.Error?"error":v===L.default.Warning?"warning":"none"}getPromptResult(v,m,f){const d=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&d.push(v.cancelButton);let E=d[m]?.run({checkboxChecked:f});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:f}}}e.AbstractDialogHandler=g,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var w;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const y=10;function h(p){const v=[];return v.push(...p.slice(0,y).map(m=>typeof m=="string"?m:(0,C.basename)(m))),p.length>y&&(p.length-y===1?v.push((0,r.localize)(7,null)):v.push((0,r.localize)(8,null,p.length-y))),v.push(""),v.join(`
`)}e.getFileNamesMessage=h;function b(p,v){const m=(0,u.deepClone)(p);let f=(m.buttons??[]).map(i=>(0,R.mnemonicButtonLabel)(i)),d=(p.buttons||[]).map((i,o)=>o),E=0,c=m.cancelId??f.length-1;if(f.length>1){const i=typeof c=="number"?f[c]:void 0;if(I.isLinux||I.isMacintosh){if(typeof i=="string"&&f.length>1&&c!==1){f.splice(c,1),f.splice(1,0,i);const o=d[c];d.splice(c,1),d.splice(1,0,o),c=1}I.isLinux&&f.length>1&&(f=f.reverse(),d=d.reverse(),E=f.length-1,typeof i=="string"&&(c=E-1))}else if(I.isWindows&&typeof i=="string"&&f.length>1&&c!==f.length-1){f.splice(c,1),f.push(i);const o=d[c];d.splice(c,1),d.push(o),c=f.length-1}}return m.buttons=f,m.defaultId=E,m.cancelId=c,m.noLink=!0,m.title=m.title||v.nameLong,{options:m,buttonIndeces:d}}e.massageMessageBoxOptions=b}),define(ie[116],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,C.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,C.createDecorator)("encryptionMainService");var L;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnome="gnome",I.gnomeKeyring="gnome-keyring",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(L||(e.PasswordStoreCLIOption=L={}));var r;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(r||(e.KnownStorageProvider=r={}));function A(I){return I==="kwallet"||I==="kwallet5"||I==="kwallet6"}e.isKwallet=A;function R(I){return I==="gnome_any"||I==="gnome_libsecret"||I==="gnome_keyring"}e.isGnome=R}),define(ie[36],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,C.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,C.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[117],ne([0,1,170,5]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function r(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function A(m){switch(m){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function R(m,f){switch(m){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":f==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function I(m,f){return f==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function u(m,f,d){return I(f,d)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===d}e.isTargetPlatformCompatible=u;function a(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=a;var g;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var w;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var y;(function(m){m.Install="install",m.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var h;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var b;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Signature="Signature",m.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var p;(function(m){m.UnknownError="UnknownError",m.PackageIsInvalidZip="PackageIsInvalidZip",m.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class v extends Error{constructor(f,d){super(f),this.code=d,this.name=d}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,C.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,C.localize)(1,null),original:"Preferences"}}),define(ie[209],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,C.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ie[210],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,C.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ie[211],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,C.createDecorator)("externalTerminal")}),define(ie[212],ne([0,1,47,13,9,4,75,21,89,174,210]),function(G,e,C,L,r,A,R,I,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const w=a.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends y{static{this.CMD="cmd.exe"}openTerminal(E,c){return this.spawnTerminal(C,E,u.getWindowsShell(),c)}spawnTerminal(E,c,i,o){const s=c.windowsExec||h.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=r.basename(s,".exe").toLowerCase();if(t==="cmder")return E.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return s.indexOf(" ")>=0&&n.push('""'),n.push(s),t==="wt"&&n.push("-d ."),new Promise((l,S)=>{const D=v(process),M=E.spawn(i,n,{cwd:o,env:D});M.on("error",S),M.on("exit",()=>l())})}runInTerminal(E,c,i,o,s){const t="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows();return new Promise((n,l)=>{const S=`"${c} - ${w}"`,D=`""${i.join('" "')}" & pause"`,M=Object.assign({},v(process),o);Object.keys(M).filter(z=>M[z]===null).forEach(z=>delete M[z]);const P={cwd:c,env:M,windowsVerbatimArguments:!0};let k,O;r.basename(t,".exe")==="wt"?(k=t,O=["-d",".",h.CMD,"/c",D]):(k=h.CMD,O=["/c","start",S,"/wait",t,"/c",D]),C.spawn(k,O,P).on("error",z=>{l(m(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h;class b extends y{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(E,c){return this.spawnTerminal(C,E,c)}runInTerminal(E,c,i,o,s){const t=s.osxExec||g.DEFAULT_TERMINAL_OSX;return new Promise((n,l)=>{if(t===g.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const S=t===g.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",E||w,"-w",c];for(const O of i)M.push("-a"),M.push(O);if(o){const O=Object.assign({},v(process),o);for(const F in O){const z=O[F];z===null?(M.push("-u"),M.push(F)):(M.push("-e"),M.push(`${F}=${z}`))}}let P="";const k=C.spawn(b.OSASCRIPT,M);k.on("error",O=>{l(m(O))}),k.stderr.on("data",O=>{P+=O.toString()}),k.on("exit",O=>{if(O===0)n(void 0);else if(P){const F=P.split(`
`,1);l(new Error(F[0]))}else l(new Error(a.localize(1,null,S,O)))})}else l(new Error(a.localize(2,null,t)))})}spawnTerminal(E,c,i){const o=c.osxExec||g.DEFAULT_TERMINAL_OSX;return new Promise((s,t)=>{const n=["-a",o];i&&n.push(i);const l=v(process),S=E.spawn("/usr/bin/open",n,{cwd:i,env:l});S.on("error",t),S.on("exit",()=>s())})}}e.MacExternalTerminalService=b;class p extends y{static{this.WAIT_MESSAGE=a.localize(3,null)}openTerminal(E,c){return this.spawnTerminal(C,E,c)}runInTerminal(E,c,i,o,s){const t=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,l)=>{const S=[];t.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const M=`${f(i)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;S.push(`''${M}''`);const P=Object.assign({},v(process),o);Object.keys(P).filter(z=>P[z]===null).forEach(z=>delete P[z]);const k={cwd:c,env:P};let O="";const F=C.spawn(D,S,k);F.on("error",z=>{l(m(z))}),F.stderr.on("data",z=>{O+=z.toString()}),F.on("exit",z=>{if(z===0)n(void 0);else if(O){const Y=O.split(`
`,1);l(new Error(Y[0]))}else l(new Error(a.localize(4,null,D,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const E=await I.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{E?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(E,c,i){const o=c.linuxExec?Promise.resolve(c.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,t)=>{o.then(n=>{const l=v(process),S=E.spawn(n,[],{cwd:i,env:l});S.on("error",t),S.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=p;function v(d){const E={...d.env};return(0,R.sanitizeProcessEnvironment)(E),E}function m(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(a.localize(5,null,d.path)):d}function f(d){let E="";for(const c of d)c.indexOf(" ")>=0?E+='"'+c+'"':E+=c,E+=" ";return E}}),define(ie[16],ne([0,1,56,9,27,12,7,176,5,4,13,71]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,u.createDecorator)("fileService");function y(H){return H.create===!0}e.isFileOpenForWriteOptions=y;var h;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var b;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function p(H){const X=H;return!!X&&typeof X.onDidChange=="function"}e.isFileSystemWatcher=p;var v;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function m(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=m;function f(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=f;function d(H){return!!(H.capabilities&131072)}e.hasFileCloneCapability=d;function E(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function c(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=c;function i(H){return m(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=i;function o(H){return m(H)?!!(H.capabilities&32768):!1}e.hasFileAtomicWriteCapability=o;function s(H){return!!(H.capabilities&65536)}e.hasFileAtomicDeleteCapability=s;function t(H){return!!(H.capabilities&2048)}e.hasReadonlyCapability=t;var n;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class l extends Error{static create(X,se){const W=new l(X.toString(),se);return M(W,se),W}constructor(X,se){super(X),this.code=se}}e.FileSystemProviderError=l;function S(H,X){return l.create(H,X)}e.createFileSystemProviderError=S;function D(H){return H||S((0,I.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=D;function M(H,X){return H.name=X?`${X} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=M;function P(H){if(!H)return n.Unknown;if(H instanceof l)return H.code;const X=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!X)return n.Unknown;switch(X[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=P;function k(H){if(H instanceof oe)return H.fileOperationResult;switch(P(H)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=k;var O;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class F{constructor(X,se,W){this.resource=X,this.operation=se,this.target=W}isOperation(X){return this.operation===X}}e.FileOperationEvent=F;var z;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class Y{static{this.MIXED_CORRELATION=null}constructor(X,se){this.ignorePathCasing=se,this.correlationId=void 0,this.added=new w.Lazy(()=>{const W=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawAdded.map(_=>[_,!0])),W}),this.updated=new w.Lazy(()=>{const W=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawUpdated.map(_=>[_,!0])),W}),this.deleted=new w.Lazy(()=>{const W=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawDeleted.map(_=>[_,!0])),W}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const W of X){switch(W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}this.correlationId!==Y.MIXED_CORRELATION&&(typeof W.cId=="number"?this.correlationId===void 0?this.correlationId=W.cId:this.correlationId!==W.cId&&(this.correlationId=Y.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=Y.MIXED_CORRELATION))}}contains(X,...se){return this.doContains(X,{includeChildren:!1},...se)}affects(X,...se){return this.doContains(X,{includeChildren:!0},...se)}doContains(X,se,...W){if(!X)return!1;const _=W.length>0;return!!((!_||W.includes(1))&&(this.added.value.get(X)||se.includeChildren&&this.added.value.findSuperstr(X))||(!_||W.includes(0))&&(this.updated.value.get(X)||se.includeChildren&&this.updated.value.findSuperstr(X))||(!_||W.includes(2))&&(this.deleted.value.findSubstr(X)||se.includeChildren&&this.deleted.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.correlationId===X}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=Y;function J(H,X,se){return!H||!X||H===X||X.length>H.length?!1:(X.charAt(X.length-1)!==L.sep&&(X+=L.sep),se?(0,r.startsWithIgnoreCase)(H,X):H.indexOf(X)===0)}e.isParent=J;class oe extends Error{constructor(X,se,W){super(X),this.fileOperationResult=se,this.options=W}}e.FileOperationError=oe;class re extends oe{constructor(X,se,W,_){super(X,se,_),this.fileOperationResult=se,this.size=W}}e.TooLargeFileOperationError=re;class ce extends oe{constructor(X,se,W){super(X,2,W),this.stat=se}}e.NotModifiedSinceFileOperationError=ce;var Q;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var K;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.ETAG_DISABLED="";function V(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=V;async function q(H,X){if(!X.hasProvider(R.URI.from({scheme:H.scheme})))return new Promise(se=>{const W=X.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===H.scheme&&_.added&&(W.dispose(),se())})})}e.whenProviderRegistered=q;class N{static{this.KB=1024}static{this.MB=N.KB*N.KB}static{this.GB=N.MB*N.KB}static{this.TB=N.GB*N.KB}static formatSize(X){return(0,A.isNumber)(X)||(X=0),X<N.KB?(0,I.localize)(1,null,X.toFixed(0)):X<N.MB?(0,I.localize)(2,null,(X/N.KB).toFixed(2)):X<N.GB?(0,I.localize)(3,null,(X/N.MB).toFixed(2)):X<N.TB?(0,I.localize)(4,null,(X/N.GB).toFixed(2)):(0,I.localize)(5,null,(X/N.TB).toFixed(2))}}e.ByteSize=N;function j(H){const X=typeof H=="string"||H?.scheme===g.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===g.Schemas.file?1024*N.MB:X?10*N.MB:a.isWeb?50*N.MB:1024*N.MB}e.getLargeFileConfirmationLimit=j}),define(ie[118],ne([0,1,17,14,177,16]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(g,w,y,h,b,p){let v;try{await I(g,w,y,h,b,p)}catch(m){v=m}finally{v&&b.errorTransformer&&(v=b.errorTransformer(v)),typeof v<"u"&&y.error(v),y.end()}}e.readFileIntoStream=R;async function I(g,w,y,h,b,p){u(p);const v=await g.open(w,{create:!1});try{u(p);let m=0,f=0,d=b&&typeof b.length=="number"?b.length:void 0,E=C.VSBuffer.alloc(Math.min(b.bufferSize,typeof d=="number"?d:b.bufferSize)),c=b&&typeof b.position=="number"?b.position:0,i=0;do f=await g.read(v,c,E.buffer,i,E.byteLength-i),c+=f,i+=f,m+=f,typeof d=="number"&&(d-=f),i===E.byteLength&&(await y.write(h(E)),E=C.VSBuffer.alloc(Math.min(b.bufferSize,typeof d=="number"?d:b.bufferSize)),i=0);while(f>0&&(typeof d!="number"||d>0)&&u(p)&&a(m,b));if(i>0){let o=i;typeof d=="number"&&(o=Math.min(i,d)),y.write(h(E.slice(0,o)))}}catch(m){throw(0,A.ensureFileSystemProviderError)(m)}finally{await g.close(v)}}function u(g){if(g.isCancellationRequested)throw(0,L.canceled)();return!0}function a(g,w){if(typeof w?.limits?.size=="number"&&g>w.limits.size)throw(0,A.createFileSystemProviderError)((0,r.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[64],ne([0,1,104,2,9,4,7,16]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function u(m){return m.recursive===!0}e.isRecursiveWatchRequest=u;class a extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(f,d,E,c){super(),this.onFileChanges=f,this.onLogMessage=d,this.verboseLogging=E,this.options=c,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const f=new L.DisposableStore;this.watcherDisposables.value=f,this.watcher=this.createWatcher(f),this.watcher.setVerboseLogging(this.verboseLogging),f.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),f.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),f.add(this.watcher.onDidError(d=>this.onError(d)))}onError(f){this.options.restartOnError?this.restartCounter<a.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${f}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${f}`):this.error(f)}restart(f){this.restartCounter++,this.init(),this.watch(f)}async watch(f){this.requests=f,await this.watcher?.watch(f)}async setVerboseLogging(f){this.verboseLogging=f,await this.watcher?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${f}`})}trace(f){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${f}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=a;class g extends a{constructor(f,d,E){super(f,d,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=g;class w extends a{constructor(f,d,E){super(f,d,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function y(m){return m.map(f=>({type:f.type,resource:R.URI.revive(f.resource),cId:f.cId}))}e.reviveFileChanges=y;function h(m){const f=new v;for(const d of m)f.processEvent(d);return f.coalesce()}e.coalesceEvents=h;function b(m,f){return typeof f=="string"&&!f.startsWith(C.GLOBSTAR)&&!(0,r.isAbsolute)(f)?{base:m,pattern:f}:f}e.normalizeWatcherPattern=b;function p(m,f){const d=[];for(const E of f)d.push((0,C.parse)(b(m,E)));return d}e.parseWatcherPatterns=p;class v{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(f){return A.isLinux?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const d=this.mapPathToChange.get(this.toKey(f));let E=!1;if(d){const c=d.type,i=f.type;d.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?E=!0:c===1&&i===2?(this.mapPathToChange.delete(this.toKey(f)),this.coalesced.delete(d)):c===2&&i===1?d.type=0:c===1&&i===0||(d.type=i)}else E=!0;E&&(this.coalesced.add(f),this.mapPathToChange.set(this.toKey(f),f))}coalesce(){const f=[],d=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(f.push(E),!1):!0).sort((E,c)=>E.resource.fsPath.length-c.resource.fsPath.length).filter(E=>d.some(c=>(0,I.isParent)(E.resource.fsPath,c,!A.isLinux))?!1:(d.push(E.resource.fsPath),!0)).concat(f)}}}),define(ie[213],ne([0,1,17,49,14,3,2,61,32,16,64]),function(G,e,C,L,r,A,R,I,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends R.Disposable{constructor(h,b){super(),this.channel=h,this.extraCapabilities=b,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,u.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(h){return this.channel.call("stat",[h])}readdir(h){return this.channel.call("readdir",[h])}async readFile(h,b){const{buffer:p}=await this.channel.call("readFile",[h,b]);return p}readFileStream(h,b,p){const v=(0,I.newWriteableStream)(f=>C.VSBuffer.concat(f.map(d=>C.VSBuffer.wrap(d))).buffer),m=new R.DisposableStore;return m.add(this.channel.listen("readFileStream",[h,b])(f=>{if(f instanceof C.VSBuffer)v.write(f.buffer);else{if(f==="end")v.end();else{let d;if(f instanceof Error)d=f;else{const E=f;d=(0,a.createFileSystemProviderError)(E.message??(0,L.toErrorMessage)(E),E.code??a.FileSystemProviderErrorCode.Unknown)}v.error(d),v.end()}m.dispose()}})),m.add(p.onCancellationRequested(()=>{v.error((0,r.canceled)()),v.end(),m.dispose()})),v}writeFile(h,b,p){return this.channel.call("writeFile",[h,C.VSBuffer.wrap(b),p])}open(h,b){return this.channel.call("open",[h,b])}close(h){return this.channel.call("close",[h])}async read(h,b,p,v,m){const[f,d]=await this.channel.call("read",[h,b,m]);return p.set(f.buffer.slice(0,d),v),d}write(h,b,p,v,m){return this.channel.call("write",[h,b,C.VSBuffer.wrap(p),v,m])}mkdir(h){return this.channel.call("mkdir",[h])}delete(h,b){return this.channel.call("delete",[h,b])}rename(h,b,p){return this.channel.call("rename",[h,b,p])}copy(h,b,p){return this.channel.call("copy",[h,b,p])}cloneFile(h,b){return this.channel.call("cloneFile",[h,b])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(h=>{if(Array.isArray(h)){const b=h;this._onDidChange.fire((0,g.reviveFileChanges)(b))}else{const b=h;this._onDidWatchError.fire(b)}}))}watch(h,b){const p=(0,u.generateUuid)();return this.channel.call("watch",[this.sessionId,p,h,b]),(0,R.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=w}),define(ie[214],ne([0,1,45,8,22,33,2,85,9,4,19,7,105,21,64]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends R.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(f,d,E,c){super(),this.request=f,this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=c,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.onDidFilesChange(i))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(i=>this.handleFileChanges(i),p.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,b.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,b.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const f=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await h.Promises.stat(f);this._register(await this.doWatch(f,d.isDirectory()))}catch(f){f.code!=="ENOENT"?this.error(f):this.trace(f)}}async normalizePath(f){let d=f.path;try{d=await h.Promises.realpath(f.path),f.path===d&&(d=await(0,y.realcase)(f.path)??f.path),f.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${d})`)}catch{}return d}async doWatch(f,d){if(a.isMacintosh&&(0,A.isEqualOrParent)(f,"/Volumes/",!0))return this.error(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const E=new r.CancellationTokenSource(this.cts.token),c=new R.DisposableStore;try{const i=w.URI.file(this.request.path),o=(0,u.basename)(f),s=(0,C.watch)(f);c.add((0,R.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${f}'`);const t=new Set;if(d)try{for(const l of await h.Promises.readdir(f))t.add(l)}catch(l){this.error(l)}const n=new Map;c.add((0,R.toDisposable)(()=>{for(const[,l]of n)l.dispose();n.clear()})),s.on("error",(l,S)=>{this.error(`Failed to watch ${f} for changes using fs.watch() (${l}, ${S})`),this.dispose()}),s.on("change",(l,S)=>{if(E.token.isCancellationRequested)return;this.trace(`[raw] ["${l}"] ${S}`);let D="";if(S&&(D=S.toString(),a.isMacintosh&&(D=(0,I.normalizeNFC)(D))),!(!D||l!=="change"&&l!=="rename"))if(d)if(l==="rename"){n.get(D)?.dispose();const M=setTimeout(async()=>{if(n.delete(D),D===o&&!await h.Promises.exists(f)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const P=await this.existsChildStrictCase((0,u.join)(f,D));if(E.token.isCancellationRequested)return;let k;P?t.has(D)?k=0:(k=1,t.add(D)):(t.delete(D),k=2),this.onFileChange({resource:(0,g.joinPath)(i,D),type:k,cId:this.request.correlationId})},p.FILE_DELETE_HANDLER_DELAY);n.set(D,(0,R.toDisposable)(()=>clearTimeout(M)))}else{let M;t.has(D)?M=0:(M=1,t.add(D)),this.onFileChange({resource:(0,g.joinPath)(i,D),type:M,cId:this.request.correlationId})}else if(l==="rename"||D!==o){const M=setTimeout(async()=>{const P=await h.Promises.exists(f);E.token.isCancellationRequested||(P?(this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0),c.add(await this.doWatch(f,!1))):(this.onFileChange({resource:i,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},p.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,R.toDisposable)(()=>clearTimeout(M)))}else this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0)})}catch(i){await h.Promises.exists(f)&&!E.token.isCancellationRequested&&this.error(`Failed to watch ${f} for changes using fs.watch() (${i.toString()})`)}return(0,R.toDisposable)(()=>{E.dispose(!0),c.dispose()})}onFileChange(f,d=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!d&&this.excludes.some(E=>E(f.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${f.resource.fsPath}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(E=>E(f.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${f.resource.fsPath}`):this.fileChangesAggregator.work(f))}handleFileChanges(f){const d=(0,b.coalesceEvents)(f);if(d.length>0){if(this.verboseLogging)for(const c of d)this.trace(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.throttledFileChangesEmitter.work(d)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(f){if(a.isLinux)return h.Promises.exists(f);try{const d=(0,u.basename)(f);return(await h.Promises.readdir((0,u.dirname)(f))).some(c=>c===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(f){this.verboseLogging=f}error(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}warn(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}trace(f){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p;async function v(m,f,d,E,c=512){const i=await h.Promises.open(m,"r"),o=Buffer.allocUnsafe(c),s=new r.CancellationTokenSource(E);let t,n=!1;const l={path:m,excludes:[],recursive:!1},S=new p(l,D=>{(async()=>{for(const{type:M}of D)if(M===0){if(n)return;n=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:P}=await h.Promises.read(i,o,0,c,null);if(!P||s.token.isCancellationRequested)break;f(o.slice(0,P))}}catch(P){t=new Error(P),s.dispose(!0)}finally{n=!1}}})()});return await S.ready,d(),new Promise((D,M)=>{s.token.onCancellationRequested(async()=>{S.dispose();try{await h.Promises.close(i)}catch(P){t=new Error(P)}t?M(t):D()})})}e.watchFileContents=v}),define(ie[215],ne([0,1,3,104,2,4,214]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(a){const g=this.normalizeRequests(a),w=g.filter(h=>{const b=this.watchers.get(h.path);return b?!(0,L.patternsEquals)(b.request.excludes,h.excludes)||!(0,L.patternsEquals)(b.request.includes,h.includes):!0}),y=Array.from(this.watchers.values()).filter(({request:h})=>!g.find(b=>b.path===h.path&&(0,L.patternsEquals)(b.excludes,h.excludes)&&(0,L.patternsEquals)(b.includes,h.includes))).map(({request:h})=>h.path);w.length&&this.trace(`Request to start watching: ${w.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const h of y)this.stopWatching(h);for(const h of w)this.startWatching(h)}startWatching(a){const g=new R.NodeJSFileWatcherLibrary(a,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),w={request:a,instance:g};this.watchers.set(a.path,w)}async stop(){for(const[a]of this.watchers)this.stopWatching(a);this.watchers.clear()}stopWatching(a){const g=this.watchers.get(a);g&&(this.watchers.delete(a),g.instance.dispose())}normalizeRequests(a){const g=new Map;for(const w of a){const y=A.isLinux?w.path:w.path.toLowerCase();let h=g.get(w.correlationId);h||(h=new Map,g.set(w.correlationId,h)),h.set(y,w)}return Array.from(g.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(a){this.verboseLogging=a;for(const[,g]of this.watchers)g.instance.setVerboseLogging(a)}trace(a){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(a)})}toMessage(a,g){return g?`[File Watcher (node.js)] ${a} (path: ${g.request.path})`:`[File Watcher (node.js)] ${a}`}}e.NodeJSWatcher=I}),define(ie[216],ne([0,1,64,215]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends C.AbstractNonRecursiveWatcherClient{constructor(R,I,u){super(R,I,u),this.init()}createWatcher(R){return R.add(new L.NodeJSWatcher)}}e.NodeJSWatcherClient=r}),define(ie[217],ne([0,1,13,42,160,64]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends A.AbstractUniversalWatcherClient{constructor(u,a,g){super(u,a,g),this.init()}createWatcher(u){const a=u.add(new r.Client(C.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:g,signal:w})=>this.onError(`terminated by itself with code ${g}, signal: ${w}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ie[92],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class C{constructor(...r){this._entries=new Map;for(const[A,R]of r)this.set(A,R)}set(r,A){const R=this._entries.get(r);return this._entries.set(r,A),R}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=C}),define(ie[218],ne([0,1,8,14,2,77,208,5,92,101]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const g=!1;class w extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class y{constructor(v=new u.ServiceCollection,m=!1,f,d=g){this._services=v,this._strict=m,this._parent=f,this._enableTracing=d,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=d?f?._globalGraph??new R.Graph(E=>E):void 0}createChild(v){return new y(v,this._strict,this,this._enableTracing)}invokeFunction(v,...m){const f=b.traceInvocation(this._enableTracing,v);let d=!1;try{return v({get:c=>{if(d)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(c,f);if(!i)throw new Error(`[invokeFunction] unknown service '${c}'`);return i}},...m)}finally{d=!0,f.stop()}}createInstance(v,...m){let f,d;return v instanceof A.SyncDescriptor?(f=b.traceCreation(this._enableTracing,v.ctor),d=this._createInstance(v.ctor,v.staticArguments.concat(m),f)):(f=b.traceCreation(this._enableTracing,v),d=this._createInstance(v,m,f)),f.stop(),d}_createInstance(v,m=[],f){const d=I._util.getServiceDependencies(v).sort((i,o)=>i.index-o.index),E=[];for(const i of d){const o=this._getOrCreateServiceInstance(i.id,f);o||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(o)}const c=d.length>0?d[0].index:m.length;if(m.length!==c){console.trace(`[createInstance] First service dependency of ${v.name} at position ${c+1} conflicts with ${m.length} static arguments`);const i=c-m.length;i>0?m=m.concat(new Array(i)):m=m.slice(0,c)}return Reflect.construct(v,m.concat(E))}_setServiceInstance(v,m){if(this._services.get(v)instanceof A.SyncDescriptor)this._services.set(v,m);else if(this._parent)this._parent._setServiceInstance(v,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const m=this._services.get(v);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):m}_getOrCreateServiceInstance(v,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const f=this._getServiceInstanceOrDescriptor(v);return f instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,f,m.branch(v,!0)):(m.branch(v,!1),f)}_safeCreateAndCacheServiceInstance(v,m,f){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,m,f)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,m,f){const d=new R.Graph(i=>i.id.toString());let E=0;const c=[{id:v,desc:m,_trace:f}];for(;c.length;){const i=c.pop();if(d.lookupOrInsertNode(i),E++>1e3)throw new w(d);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(o.id);if(s||this._throwIfStrict(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof A.SyncDescriptor){const t={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};d.insertEdge(i,t),c.push(t)}}}for(;;){const i=d.roots();if(i.length===0){if(!d.isEmpty())throw new w(d);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const t=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,t)}d.removeNode(o)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,m,f=[],d,E){if(this._services.get(v)instanceof A.SyncDescriptor)return this._createServiceInstance(v,m,f,d,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,m,f,d,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(v,m,f=[],d,E){if(d){const c=new y(void 0,this._strict,this,this._enableTracing);c._globalGraphImplicitDependency=String(v);const i=new Map,o=new C.IdleValue(()=>{const s=c._createInstance(m,f,E);for(const[t,n]of i){const l=s[t];if(typeof l=="function")for(const S of n)l.apply(s,S)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let S=i.get(t);return S||(S=new a.LinkedList,i.set(t,S)),(M,P,k)=>{const O=S.push([M,P,k]);return(0,r.toDisposable)(O)}}if(t in s)return s[t];const n=o.value;let l=n[t];return typeof l!="function"||(l=l.bind(n),s[t]=l),l},set(s,t,n){return o.value[t]=n,!0},getPrototypeOf(s){return m.prototype}})}else return this._createInstance(m,f,E)}_throwIfStrict(v,m){if(m&&console.warn(v),this._strict)throw new Error(v)}}e.InstantiationService=y;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class b{static{this.all=new Set}static{this._None=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(v,m){return v?new b(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b._None}static traceCreation(v,m){return v?new b(1,m.name):b._None}static{this._totals=0}constructor(v,m){this.type=v,this.name=m,this._start=Date.now(),this._dep=[]}branch(v,m){const f=new b(3,v.toString());return this._dep.push([v,m,f]),f}stop(){const v=Date.now()-this._start;b._totals+=v;let m=!1;function f(E,c){const i=[],o=new Array(E+1).join("	");for(const[s,t,n]of c._dep)if(t&&n){m=!0,i.push(`${o}CREATES -> ${s}`);const l=f(E+1,n);l&&i.push(l)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(v>2||m)&&b.all.add(d.join(`
`))}}e.Trace=b}),define(ie[219],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,C.createDecorator)("issueService")}),define(ie[6],ne([0,1,49,3,55,2,31,4,19,12,7,114,5]),function(G,e,C,L,r,A,R,I,u,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function h(){return new Date().toISOString()}function b(M){return(0,a.isNumber)(M)}e.isLogLevel=b;var p;(function(M){M[M.Off=0]="Off",M[M.Trace=1]="Trace",M[M.Debug=2]="Debug",M[M.Info=3]="Info",M[M.Warning=4]="Warning",M[M.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function v(M,P,k){switch(P){case p.Trace:M.trace(k);break;case p.Debug:M.debug(k);break;case p.Info:M.info(k);break;case p.Warning:M.warn(k);break;case p.Error:M.error(k);break;case p.Off:break;default:throw new Error(`Invalid log level ${P}`)}}e.log=v;function m(M,P=!1){let k="";for(let O=0;O<M.length;O++){let F=M[O];if(F instanceof Error&&(F=(0,C.toErrorMessage)(F,P)),typeof F=="object")try{F=JSON.stringify(F)}catch{}k+=(O>0?" ":"")+F}return k}class f extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==p.Off&&this.level<=P}}e.AbstractLogger=f;class d extends f{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...k){this.checkLogLevel(p.Trace)&&this.log(p.Trace,m([P,...k],!0))}debug(P,...k){this.checkLogLevel(p.Debug)&&this.log(p.Debug,m([P,...k]))}info(P,...k){this.checkLogLevel(p.Info)&&this.log(p.Info,m([P,...k]))}warn(P,...k){this.checkLogLevel(p.Warning)&&this.log(p.Warning,m([P,...k]))}error(P,...k){if(this.checkLogLevel(p.Error))if(P instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=P.stack,this.log(p.Error,m(O))}else this.log(p.Error,m([P,...k]))}flush(){}}e.AbstractMessageLogger=d;class E extends f{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!I.isWindows}trace(P,...k){this.checkLogLevel(p.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...k):console.log(`[main ${h()}]`,P,...k))}debug(P,...k){this.checkLogLevel(p.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...k):console.log(`[main ${h()}]`,P,...k))}info(P,...k){this.checkLogLevel(p.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...k):console.log(`[main ${h()}]`,P,...k))}warn(P,...k){this.checkLogLevel(p.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,P,...k):console.warn(`[main ${h()}]`,P,...k))}error(P,...k){this.checkLogLevel(p.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,P,...k):console.error(`[main ${h()}]`,P,...k))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class c extends f{constructor(P=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(P)}trace(P,...k){this.checkLogLevel(p.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...k):console.log(P,...k))}debug(P,...k){this.checkLogLevel(p.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...k):console.log(P,...k))}info(P,...k){this.checkLogLevel(p.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...k):console.log(P,...k))}warn(P,...k){this.checkLogLevel(p.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...k):console.log(P,...k))}error(P,...k){this.checkLogLevel(p.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...k):console.error(P,...k))}dispose(){}flush(){}}e.ConsoleLogger=c;class i extends f{constructor(P,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(k)}trace(P,...k){this.checkLogLevel(p.Trace)&&this.adapter.log(p.Trace,[this.extractMessage(P),...k])}debug(P,...k){this.checkLogLevel(p.Debug)&&this.adapter.log(p.Debug,[this.extractMessage(P),...k])}info(P,...k){this.checkLogLevel(p.Info)&&this.adapter.log(p.Info,[this.extractMessage(P),...k])}warn(P,...k){this.checkLogLevel(p.Warning)&&this.adapter.log(p.Warning,[this.extractMessage(P),...k])}error(P,...k){this.checkLogLevel(p.Error)&&this.adapter.log(p.Error,[this.extractMessage(P),...k])}extractMessage(P){return typeof P=="string"?P:(0,C.toErrorMessage)(P,this.checkLogLevel(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class o extends f{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const k of this.loggers)k.setLevel(P);super.setLevel(P)}trace(P,...k){for(const O of this.loggers)O.trace(P,...k)}debug(P,...k){for(const O of this.loggers)O.debug(P,...k)}info(P,...k){for(const O of this.loggers)O.info(P,...k)}warn(P,...k){for(const O of this.loggers)O.warn(P,...k)}error(P,...k){for(const O of this.loggers)O.error(P,...k)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose()}}e.MultiplexLogger=o;class s extends A.Disposable{constructor(P,k,O){if(super(),this.logLevel=P,this.logsHome=k,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,O)for(const F of O)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(P){return(0,a.isString)(P)?[...this._loggers.values()].find(k=>k.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,k){const O=this.toResource(P),F=(0,a.isString)(P)?P:k?.id??(0,r.hash)(O.toString()).toString(16);let z=this._loggers.get(O)?.logger;const Y=k?.logLevel==="always"?p.Trace:k?.logLevel;z||(z=this.doCreateLogger(O,Y??this.getLogLevel(O)??this.logLevel,{...k,id:F}));const J={logger:z,info:{resource:O,id:F,logLevel:Y,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(J.info),this._loggers.set(O,J),z}toResource(P){return(0,a.isString)(P)?(0,u.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,k){if(g.URI.isUri(P)){const O=P,F=k,z=this._loggers.get(O);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.logLevel?void 0:F,z.logger?.setLevel(F),this._loggers.set(z.info.resource,z),this._onDidChangeLogLevel.fire([O,F]))}else{this.logLevel=P;for(const[O,F]of this._loggers.entries())this._loggers.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,k){const O=this.getLoggerEntry(P);O&&k!==!O.info.hidden&&(O.info.hidden=!k,this._loggers.set(O.info.resource,O),this._onDidChangeVisibility.fire([O.info.resource,k]))}getLogLevel(P){let k;return P&&(k=this._loggers.get(P)?.info.logLevel),k??this.logLevel}registerLogger(P){const k=this._loggers.get(P.resource);k?k.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const k=this._loggers.get(P);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class t{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(P){}getLevel(){return p.Info}trace(P,...k){}debug(P,...k){}info(P,...k){}warn(P,...k){}error(P,...k){}critical(P,...k){}dispose(){}flush(){}}e.NullLogger=t;class n extends t{}e.NullLogService=n;function l(M){if(M.verbose)return p.Trace;if(typeof M.logLevel=="string"){const P=D(M.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function S(M){switch(M){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=S;function D(M){switch(M){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new w.RawContextKey("logLevel",S(p.Info))});var te=this&&this.__param||function(G,e){return function(C,L){e(C,L,G)}};define(ie[220],ne([0,1,15,4,6]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const A=C.safeStorage;let R=class{constructor(u){this.logService=u,C.app.commandLine.getSwitchValue("password-store")==="basic"&&A.setUsePlainTextEncryption?.(!0)}async encrypt(u){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(A.encryptString(u));return this.logService.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.logService.error(a),a}}async decrypt(u){let a;try{if(a=JSON.parse(u),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${u}`);const g=Buffer.from(a.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const w=A.decryptString(g);return this.logService.trace("[EncryptionMainService] Decrypted value."),w}catch(g){throw this.logService.error(g),g}}isEncryptionAvailable(){return Promise.resolve(A.isEncryptionAvailable())}getKeyStorageProvider(){if(L.isWindows)return Promise.resolve("dpapi");if(L.isMacintosh)return Promise.resolve("keychain_access");if(A.getSelectedStorageBackend)try{const u=A.getSelectedStorageBackend();return Promise.resolve(u)}catch(u){this.logService.error(u)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(L.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(L.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!A.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");A.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=R,e.EncryptionMainService=R=Pe([te(0,r.ILogService)],R)}),define(ie[221],ne([0,1,23,8,14,3,2,9,64,6]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class g extends R.Disposable{constructor(y,h){super(),this.logService=y,this.options=h,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(y,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,h):this.watchNonRecursive(y,h)}watchUniversal(y,h){const b={path:this.toFilePath(y),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},p=(0,C.insert)(this.universalPathsToWatch,b);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,r.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,u.reviveFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const h of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const h of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(h)&&y.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,h){const b={path:this.toFilePath(y),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},p=(0,C.insert)(this.nonRecursivePathsToWatch,b);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,r.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,u.reviveFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,I.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=g}),define(ie[222],ne([0,1,23,8,17,22,3,55,70,2,56,13,65,19,61,175,16,118,6,14]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends a.Disposable{static{E=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new R.Emitter),this._onDidUncorrelatedFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${o}`);const t=new a.DisposableStore;return this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s}),t.add(s.onDidChangeFile(n=>{const l=new v.FileChangesEvent(n,!this.isPathCaseSensitive(s));this.internalOnDidFilesChange.fire(l),l.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(l)})),typeof s.onDidWatchError=="function"&&t.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,a.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){s.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return u.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new v.FileOperationError((0,p.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const t=new d.ErrorNoTelemetry;throw t.message=(0,p.localize)(1,null,o.toString()),t}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(s)||(0,v.hasReadWriteCapability)(s)||(0,v.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(s)||(0,v.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(t){throw(0,v.toFileSystemProviderErrorCode)(t)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,p.localize)(2,null,this.resourceForError(o)),1):(0,v.ensureFileSystemProviderError)(t)}}async doResolveFile(o,s){const t=await this.withProvider(o),n=this.isPathCaseSensitive(t),l=s?.resolveTo,S=s?.resolveSingleChildDescendants,D=s?.resolveMetadata,M=await t.stat(o);let P;return this.toFileStat(t,o,M,void 0,!!D,(k,O)=>(P||(P=g.TernarySearchTree.forUris(()=>!n),P.set(o,!0),l&&P.fill(!0,l)),P.get(k.resource)||P.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&S?O===1:!1))}async toFileStat(o,s,t,n,l,S){const{providerExtUri:D}=this.getExtUri(o),M={resource:s,name:D.basename(s),isFile:(t.type&v.FileType.File)!==0,isDirectory:(t.type&v.FileType.Directory)!==0,isSymbolicLink:(t.type&v.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&v.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((t.permissions??0)&v.FilePermission.Locked),etag:(0,v.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(M.isDirectory&&S(M,n)){try{const P=await o.readdir(s),k=await L.Promises.settled(P.map(async([O,F])=>{try{const z=D.joinPath(s,O),Y=l?await o.stat(z):{type:F};return await this.toFileStat(o,z,Y,P.length,l,S)}catch(z){return this.logService.trace(z),null}}));M.children=(0,C.coalesce)(k)}catch(P){this.logService.trace(P),M.children=[]}return M}return M}async resolveAll(o){return L.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.withProvider(o),t=await s.stat(o);return this.toFileStat(s,o,t,void 0,!0,()=>!1)}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(t){return t}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new v.FileOperationError((0,p.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=r.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const n=await this.writeFile(o,s);return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,n)),n}async writeFile(o,s,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:l}=this.getExtUri(n);let S=t;if((0,v.hasFileAtomicWriteCapability)(n)&&!S?.atomic){const D=n.enforceAtomicWriteFile?.(o);D&&(S={...t,atomic:D})}try{await this.validateWriteFile(n,o,S)||await this.mkdirp(n,l.dirname(o));let M;if((0,v.hasReadWriteCapability)(n)&&!(s instanceof r.VSBuffer))if((0,b.isReadableStream)(s)){const P=await(0,b.peekStream)(s,3);P.ended?M=r.VSBuffer.concat(P.buffer):M=P}else M=(0,b.peekReadable)(s,P=>r.VSBuffer.concat(P),3);else M=s;!(0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)&&M instanceof r.VSBuffer||(0,v.hasReadWriteCapability)(n)&&(0,v.hasFileAtomicWriteCapability)(n)&&S?.atomic?await this.doWriteUnbuffered(n,o,S,M):await this.doWriteBuffered(n,o,S,M instanceof r.VSBuffer?(0,r.bufferToReadable)(M):M),this._onDidRunOperation.fire(new v.FileOperationEvent(o,4))}catch(D){throw new v.FileOperationError((0,p.localize)(4,null,this.resourceForError(o),(0,v.ensureFileSystemProviderError)(D).toString()),(0,v.toFileOperationResult)(D),S)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,t){const n=!!t?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(s)));if(!!t?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.resourceForError(s)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.resourceForError(s)));if(n)throw new Error((0,p.localize)(8,null,this.resourceForError(s)))}let S;try{S=await o.stat(s)}catch{return}if(S.type&v.FileType.Directory)throw new v.FileOperationError((0,p.localize)(9,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,S),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==v.ETAG_DISABLED&&typeof S.mtime=="number"&&typeof S.size=="number"&&t.mtime<S.mtime&&t.etag!==(0,v.etag)({mtime:t.mtime,size:S.size}))throw new v.FileOperationError((0,p.localize)(10,null),3,t);return S}async readFile(o,s,t){const n=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(n,o,s,t):this.doReadFile(n,o,s,t)}async doReadFileAtomic(o,s,t,n){return new Promise((l,S)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const D=await this.doReadFile(o,s,t,n);l(D)}catch(D){S(D)}})})}async doReadFile(o,s,t,n){const l=await this.doReadFileStream(o,s,{...t,preferUnbuffered:!0},n);return{...l,value:await(0,r.streamToBuffer)(l.value)}}async readFileStream(o,s,t){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,s,t)}async doReadFileStream(o,s,t,n){const l=new A.CancellationTokenSource(n);let S=t;(0,v.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(s)&&(S={...t,atomic:!0});const D=this.validateReadFile(s,S).then(P=>P,P=>{throw l.dispose(!0),P});let M;try{return typeof S?.etag=="string"&&S.etag!==v.ETAG_DISABLED&&await D,S?.atomic&&(0,v.hasFileAtomicReadCapability)(o)||!((0,v.hasOpenReadWriteCloseCapability)(o)||(0,v.hasFileReadStreamCapability)(o))||(0,v.hasReadWriteCapability)(o)&&S?.preferUnbuffered?M=this.readFileUnbuffered(o,s,S):(0,v.hasFileReadStreamCapability)(o)?M=this.readFileStreamed(o,s,l.token,S):M=this.readFileBuffered(o,s,l.token,S),M.on("end",()=>l.dispose()),M.on("error",()=>l.dispose()),{...await D,value:M}}catch(P){throw M&&await(0,b.consumeStream)(M),this.restoreReadError(P,s,S)}}restoreReadError(o,s,t){const n=(0,p.localize)(11,null,this.resourceForError(s),(0,v.ensureFileSystemProviderError)(o).toString());return o instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(n,o.stat,t):o instanceof v.TooLargeFileOperationError?new v.TooLargeFileOperationError(n,o.fileOperationResult,o.size,o.options):new v.FileOperationError(n,(0,v.toFileOperationResult)(o),t)}readFileStreamed(o,s,t,n=Object.create(null)){const l=o.readFileStream(s,n,t);return(0,b.transform)(l,{data:S=>S instanceof r.VSBuffer?S:r.VSBuffer.wrap(S),error:S=>this.restoreReadError(S,s,n)},S=>r.VSBuffer.concat(S))}readFileBuffered(o,s,t,n=Object.create(null)){const l=(0,r.newWriteableBufferStream)();return(0,m.readFileIntoStream)(o,s,l,S=>S,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:S=>this.restoreReadError(S,s,n)},t),l}readFileUnbuffered(o,s,t){const n=(0,b.newWriteableStream)(l=>r.VSBuffer.concat(l));return(async()=>{try{let l;t?.atomic&&(0,v.hasFileAtomicReadCapability)(o)?l=await o.readFile(s,{atomic:!0}):l=await o.readFile(s),typeof t?.position=="number"&&(l=l.slice(t.position)),typeof t?.length=="number"&&(l=l.slice(0,t.length)),this.validateReadFileLimits(s,l.byteLength,t),n.end(r.VSBuffer.wrap(l))}catch(l){n.error(l),n.end()}})(),n}async validateReadFile(o,s){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new v.FileOperationError((0,p.localize)(12,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==v.ETAG_DISABLED&&s.etag===t.etag)throw new v.NotModifiedSinceFileOperationError((0,p.localize)(13,null),t,s);return this.validateReadFileLimits(o,t.size,s),t}validateReadFileLimits(o,s,t){if(typeof t?.limits?.size=="number"&&s>t.limits.size)throw new v.TooLargeFileOperationError((0,p.localize)(14,null,this.resourceForError(o)),7,s,t)}async canMove(o,s,t){return this.doCanMoveCopy(o,s,"move",t)}async canCopy(o,s,t){return this.doCanMoveCopy(o,s,"copy",t)}async doCanMoveCopy(o,s,t,n){if(o.toString()!==s.toString())try{const l=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),S=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(l,o,S,s,t,n)}catch(l){return l}return!0}async move(o,s,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),S=await this.doMoveCopy(n,o,l,s,"move",!!t),D=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,S==="move"?2:3,D)),D}async copy(o,s,t){const n=await this.withReadProvider(o),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),S=await this.doMoveCopy(n,o,l,s,"copy",!!t),D=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,S==="copy"?3:2,D)),D}async doMoveCopy(o,s,t,n,l,S){if(s.toString()===n.toString())return l;const{exists:D,isSameResourceWithDifferentPathCase:M}=await this.doValidateMoveCopy(o,s,t,n,l,S);if(D&&!M&&S&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),l==="copy"){if(o===t&&(0,v.hasFileFolderCopyCapability)(o))await o.copy(s,n,{overwrite:S});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(o,P,t,n):await this.doCopyFile(o,s,t,n)}return l}else return o===t?(await o.rename(s,n,{overwrite:S}),l):(await this.doMoveCopy(o,s,t,n,"copy",S),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,t,n){if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,s,t,n);if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,s,t,n);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,s,t,n);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,s,t,n)}async doCopyFolder(o,s,t,n){await t.mkdir(n),Array.isArray(s.children)&&await L.Promises.settled(s.children.map(async l=>{const S=this.getExtUri(t).providerExtUri.joinPath(n,l.name);return l.isDirectory?this.doCopyFolder(o,await this.resolve(l.resource),t,S):this.doCopyFile(o,l.resource,t,S)}))}async doValidateMoveCopy(o,s,t,n,l,S){let D=!1;if(o===t){const{providerExtUri:P,isPathCaseSensitive:k}=this.getExtUri(o);if(k||(D=P.isEqual(s,n)),D&&l==="copy")throw new Error((0,p.localize)(15,null,this.resourceForError(s),this.resourceForError(n)));if(!D&&P.isEqualOrParent(n,s))throw new Error((0,p.localize)(16,null,this.resourceForError(s),this.resourceForError(n)))}const M=await this.exists(n);if(M&&!D){if(!S)throw new v.FileOperationError((0,p.localize)(17,null,this.resourceForError(s),this.resourceForError(n)),4);if(o===t){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(s,n))throw new Error((0,p.localize)(18,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:M,isSameResourceWithDifferentPathCase:D}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,t)),t}async mkdirp(o,s){const t=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await o.stat(s)).type&v.FileType.Directory))throw new Error((0,p.localize)(19,null,this.resourceForError(s)));break}catch(l){if((0,v.toFileSystemProviderErrorCode)(l)!==v.FileSystemProviderErrorCode.FileNotFound)throw l;t.push(n.basename(s)),s=n.dirname(s)}for(let l=t.length-1;l>=0;l--){s=n.joinPath(s,t[l]);try{await o.mkdir(s)}catch(S){if((0,v.toFileSystemProviderErrorCode)(S)!==v.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(t){return t}return!0}async doValidateDelete(o,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),n=!!s?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,p.localize)(20,null,this.resourceForError(o)));const l=s?.atomic;if(l&&!(t.capabilities&65536))throw new Error((0,p.localize)(21,null,this.resourceForError(o)));if(n&&l)throw new Error((0,p.localize)(22,null,this.resourceForError(o)));let S;try{S=await t.stat(o)}catch{}if(S)this.throwIfFileIsReadonly(o,S);else throw new v.FileOperationError((0,p.localize)(23,null,this.resourceForError(o)),1);if(!!!s?.recursive){const M=await this.resolve(o);if(M.isDirectory&&Array.isArray(M.children)&&M.children.length>0)throw new Error((0,p.localize)(24,null,this.resourceForError(o)))}return t}async del(o,s){const t=await this.doValidateDelete(o,s);let n=s;if((0,v.hasFileAtomicDeleteCapability)(t)&&!n?.atomic){const M=t.enforceAtomicDelete?.(o);M&&(n={...s,atomic:M})}const l=!!n?.useTrash,S=!!n?.recursive,D=n?.atomic??!1;await t.delete(o,{recursive:S,useTrash:l,atomic:D}),this._onDidRunOperation.fire(new v.FileOperationEvent(o,1))}async cloneFile(o,s){const t=await this.withProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(t===n&&this.getExtUri(t).providerExtUri.isEqual(o,s))return;if(t===n&&(0,v.hasFileCloneCapability)(t))return t.cloneFile(o,s);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s));const l=this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri);return t===n&&(0,v.hasFileFolderCopyCapability)(t)?l.queue(()=>t.copy(o,s,{overwrite:!0})):l.queue(()=>this.doCopyFile(t,o,n,s))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:E.WATCHER_CORRELATION_IDS++})}watch(o,s={recursive:!1,excludes:[]}){const t=new a.DisposableStore;let n=!1,l=()=>{n=!0};t.add((0,a.toDisposable)(()=>l())),(async()=>{try{const D=await this.doWatch(o,s);n?(0,a.dispose)(D):l=()=>(0,a.dispose)(D)}catch(D){this.logService.error(D)}})();const S=s.correlationId;if(typeof S=="number"){const D=t.add(new R.Emitter);return t.add(this.internalOnDidFilesChange.event(P=>{P.correlates(S)&&D.fire(P)})),{onDidChange:D.event,dispose:()=>t.dispose()}}return t}async doWatch(o,s){const t=await this.withProvider(o),n=(0,I.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(o),s]);let l=this.activeWatchers.get(n);return l||(l={count:0,disposable:t.watch(o,s)},this.activeWatchers.set(n,l)),l.count+=1,(0,a.toDisposable)(()=>{l&&(l.count--,l.count===0&&((0,a.dispose)(l.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,a.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,t,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const l=await o.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,b.isReadableStream)(n)||(0,b.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,l,n):await this.doWriteReadableBufferedQueued(o,l,n)}catch(S){throw(0,v.ensureFileSystemProviderError)(S)}finally{await o.close(l)}})}async doWriteStreamBufferedQueued(o,s,t){let n=0,l;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const S=r.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,s,S,S.byteLength,n,0),n+=S.byteLength}if(t.ended)return;l=t.stream}else l=t;return new Promise((S,D)=>{(0,b.listenStream)(l,{onData:async M=>{l.pause();try{await this.doWriteBuffer(o,s,M,M.byteLength,n,0)}catch(P){return D(P)}n+=M.byteLength,setTimeout(()=>l.resume())},onError:M=>D(M),onEnd:()=>S()})})}async doWriteReadableBufferedQueued(o,s,t){let n=0,l;for(;(l=t.read())!==null;)await this.doWriteBuffer(o,s,l,l.byteLength,n,0),n+=l.byteLength}async doWriteBuffer(o,s,t,n,l,S){let D=0;for(;D<n;){const M=await o.write(s,l+D,t.buffer,S+D,n-D);D+=M}}async doWriteUnbuffered(o,s,t,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,t,n))}async doWriteUnbufferedQueued(o,s,t,n){let l;n instanceof r.VSBuffer?l=n:(0,b.isReadableStream)(n)?l=await(0,r.streamToBuffer)(n):(0,b.isReadableBufferedStream)(n)?l=await(0,r.bufferedStreamToBuffer)(n):l=(0,r.readableToBuffer)(n),await o.writeFile(s,l.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async doPipeBuffered(o,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,t,n))}async doPipeBufferedQueued(o,s,t,n){let l,S;try{l=await o.open(s,{create:!1}),S=await t.open(n,{create:!0,unlock:!1});const D=r.VSBuffer.alloc(this.BUFFER_SIZE);let M=0,P=0,k=0;do k=await o.read(l,M,D.buffer,P,D.byteLength-P),await this.doWriteBuffer(t,S,D,k,M,P),M+=k,P+=k,P===D.byteLength&&(P=0);while(k>0)}catch(D){throw(0,v.ensureFileSystemProviderError)(D)}finally{await L.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof S=="number"?t.close(S):Promise.resolve()])}}async doPipeUnbuffered(o,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,t,n))}async doPipeUnbufferedQueued(o,s,t,n){return t.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,t,n))}async doPipeUnbufferedToBufferedQueued(o,s,t,n){const l=await t.open(n,{create:!0,unlock:!1});try{const S=await o.readFile(s);await this.doWriteBuffer(t,l,r.VSBuffer.wrap(S),S.byteLength,0,0)}catch(S){throw(0,v.ensureFileSystemProviderError)(S)}finally{await t.close(l)}}async doPipeBufferedToUnbuffered(o,s,t,n){const l=await(0,r.streamToBuffer)(this.readFileBuffered(o,s,A.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,l)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new v.FileOperationError((0,p.localize)(25,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,p.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===w.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=c,e.FileService=c=E=Pe([te(0,f.ILogService)],c)}),define(ie[93],ne([0,1,45,311,8,31,17,3,33,2,9,4,19,61,21,179,16,118,221,49,217,216]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(C)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(o)}`)}})();class i extends f.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,t){super(s,t),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new A.ResourceMap(n=>y.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:t,symbolicLink:n}=await b.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:v.FilePermission.Locked}}catch(t){throw this.toFileSystemProviderError(t)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const t=await b.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async l=>{try{let S;l.isSymbolicLink()?S=(await this.stat((0,y.joinPath)(s,l.name))).type:S=this.toType(l),n.push([l.name,S])}catch(S){this.logService.trace(S)}})),n}catch(t){throw this.toFileSystemProviderError(t)}}toType(s,t){let n;return t?.dangling?n=v.FileType.Unknown:s.isFile()?n=v.FileType.File:s.isDirectory()?n=v.FileType.Directory:n=v.FileType.Unknown,t&&(n|=v.FileType.SymbolicLink),n}async createResourceLock(s){const t=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const l=new r.Barrier;return this.resourceLocks.set(s,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,a.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(s)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),l.open()})}async readFile(s,t){let n;try{t?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),n=await this.createResourceLock(s));const l=this.toFilePath(s);return await b.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{n?.dispose()}}traceLock(s){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,t,n){const l=(0,h.newWriteableStream)(S=>R.VSBuffer.concat(S.map(D=>R.VSBuffer.wrap(D))).buffer);return(0,m.readFileIntoStream)(this,s,l,S=>S.buffer,{...t,bufferSize:256*1024},n),l}async writeFile(s,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,y.joinPath)((0,y.dirname)(s),`${(0,y.basename)(s)}${n.atomic.postfix}`),t,n):this.doWriteFile(s,t,n)}async canWriteFileAtomic(s){try{const t=this.toFilePath(s),{symbolicLink:n}=await b.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async doWriteFileAtomic(s,t,n,l){const S=new a.DisposableStore;try{S.add(await this.createResourceLock(s)),S.add(await this.createResourceLock(t)),await this.doWriteFile(t,n,l,!0);try{await this.rename(t,s,{overwrite:!0})}catch(D){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{S.dispose()}}async doWriteFile(s,t,n,l){let S;try{const D=this.toFilePath(s);if(!n.create||!n.overwrite){if(await b.Promises.exists(D)){if(!n.overwrite)throw(0,v.createFileSystemProviderError)((0,p.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,v.createFileSystemProviderError)((0,p.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:n.unlock},l),await this.write(S,0,t,0,t.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof S=="number"&&await this.close(S)}}static{this.canFlush=!0}static configureFlushOnWrite(s){i.canFlush=s}async open(s,t,n){const l=this.toFilePath(s);let S;(0,v.isFileOpenForWriteOptions)(t)&&!n&&(S=await this.createResourceLock(s));let D;try{if((0,v.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:P}=await b.SymlinkSupport.stat(l);P.mode&128||await b.Promises.chmod(l,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}let M;if((0,v.isFileOpenForWriteOptions)(t)){if(w.isWindows)try{await b.Promises.truncate(l,0),M="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}M||(M="w")}else M="r";D=await b.Promises.open(l,M)}catch(M){throw S?.dispose(),(0,v.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(s,M):this.toFileSystemProviderError(M)}if(this.mapHandleToPos.set(D,0),(0,v.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(D,s),S){const M=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${l})`),this.mapHandleToLock.set(D,S),M&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${l})`),M.dispose())}return D}async close(s){const t=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&i.canFlush)try{await b.Promises.fdatasync(s)}catch(n){i.configureFlushOnWrite(!1),this.logService.error(n)}return await b.Promises.close(s)}catch(n){throw this.toFileSystemProviderError(n)}finally{t&&(this.mapHandleToLock.get(s)===t&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),t.dispose())}}async read(s,t,n,l,S){const D=this.normalizePos(s,t);let M=null;try{M=(await b.Promises.read(s,n,l,S,D)).bytesRead}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(s,D,M)}return M}normalizePos(s,t){return t===this.mapHandleToPos.get(s)?null:t}updatePos(s,t,n){const l=this.mapHandleToPos.get(s);typeof l=="number"&&(typeof t=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,l+n):this.mapHandleToPos.delete(s)))}async write(s,t,n,l,S){return(0,r.retry)(()=>this.doWrite(s,t,n,l,S),100,3)}async doWrite(s,t,n,l,S){const D=this.normalizePos(s,t);let M=null;try{M=(await b.Promises.write(s,n,l,S,D)).bytesWritten}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),P)}finally{this.updatePos(s,D,M)}return M}async mkdir(s){try{await b.Promises.mkdir(this.toFilePath(s))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(s,t){try{const n=this.toFilePath(s);if(t.recursive){let l;t?.atomic!==!1&&t.atomic.postfix&&(l=(0,g.join)((0,g.dirname)(n),`${(0,g.basename)(n)}${t.atomic.postfix}`)),await b.Promises.rm(n,b.RimRafMode.MOVE,l)}else try{await b.Promises.unlink(n)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let S=!1;try{const{stat:D,symbolicLink:M}=await b.SymlinkSupport.stat(n);S=D.isDirectory()&&!M}catch{}if(S)await b.Promises.rmdir(n);else throw l}else throw l}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(s,t,n){const l=this.toFilePath(s),S=this.toFilePath(t);if(l!==S)try{await this.validateMoveCopy(s,t,"move",n.overwrite),await b.Promises.rename(l,S)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(2,null,(0,g.basename)(l),(0,g.basename)((0,g.dirname)(S)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(s,t,n){const l=this.toFilePath(s),S=this.toFilePath(t);if(l!==S)try{await this.validateMoveCopy(s,t,"copy",n.overwrite),await b.Promises.copy(l,S,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(3,null,(0,g.basename)(l),(0,g.basename)((0,g.dirname)(S)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(s,t,n,l){const S=this.toFilePath(s),D=this.toFilePath(t);let M=!1;if(!!(this.capabilities&1024)||(M=(0,u.isEqual)(S,D,!0)),M){if(n==="copy")throw(0,v.createFileSystemProviderError)((0,p.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const k=await this.statIgnoreError(s);if(!k)throw(0,v.createFileSystemProviderError)((0,p.localize)(5,null),v.FileSystemProviderErrorCode.FileNotFound);const O=await this.statIgnoreError(t);if(O){if(!l)throw(0,v.createFileSystemProviderError)((0,p.localize)(6,null),v.FileSystemProviderErrorCode.FileExists);k.type&v.FileType.File&&O.type&v.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,t){return this.doCloneFile(s,t,!1)}async doCloneFile(s,t,n){const l=this.toFilePath(s),S=this.toFilePath(t),D=!!(this.capabilities&1024);if((0,u.isEqual)(l,S,!D))return;const M=new a.DisposableStore;try{M.add(await this.createResourceLock(s)),M.add(await this.createResourceLock(t)),n&&await b.Promises.mkdir((0,g.dirname)(S),{recursive:!0}),await b.Promises.copyFile(l,S)}catch(P){if(P.code==="ENOENT"&&!n)return this.doCloneFile(s,t,!0);throw this.toFileSystemProviderError(P)}finally{M.dispose()}}createUniversalWatcher(s,t,n){return new E.UniversalWatcherClient(l=>s(l),l=>t(l),n)}createNonRecursiveWatcher(s,t,n){return new c.NodeJSWatcherClient(l=>s(l),l=>t(l),n)}toFileSystemProviderError(s){if(s instanceof v.FileSystemProviderError)return s;let t=s,n;switch(s.code){case"ENOENT":n=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=v.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=v.FileSystemProviderErrorCode.Unknown;break;default:n=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(s,t){let n=this.toFileSystemProviderError(t);if(s&&n.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await b.SymlinkSupport.stat(this.toFilePath(s));l.mode&128||(n=(0,v.createFileSystemProviderError)(t,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return n}}e.DiskFileSystemProvider=i}),define(ie[223],ne([0,1,3,93,2,17,61,22]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class u extends r.Disposable{constructor(w,y){super(),this.provider=w,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(w,y,h){const b=this.getUriTransformer(w);switch(y){case"stat":return this.stat(b,h[0]);case"readdir":return this.readdir(b,h[0]);case"open":return this.open(b,h[0],h[1]);case"close":return this.close(h[0]);case"read":return this.read(h[0],h[1],h[2]);case"readFile":return this.readFile(b,h[0],h[1]);case"write":return this.write(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.writeFile(b,h[0],h[1],h[2]);case"rename":return this.rename(b,h[0],h[1],h[2]);case"copy":return this.copy(b,h[0],h[1],h[2]);case"cloneFile":return this.cloneFile(b,h[0],h[1]);case"mkdir":return this.mkdir(b,h[0]);case"delete":return this.delete(b,h[0],h[1]);case"watch":return this.watch(b,h[0],h[1],h[2],h[3]);case"unwatch":return this.unwatch(h[0],h[1])}throw new Error(`IPC Command ${y} not found`)}listen(w,y,h){const b=this.getUriTransformer(w);switch(y){case"fileChange":return this.onFileChange(b,h[0]);case"readFileStream":return this.onReadFileStream(b,h[0],h[1])}throw new Error(`Unknown event ${y}`)}stat(w,y){const h=this.transformIncoming(w,y,!0);return this.provider.stat(h)}readdir(w,y){const h=this.transformIncoming(w,y);return this.provider.readdir(h)}async readFile(w,y,h){const b=this.transformIncoming(w,y,!0),p=await this.provider.readFile(b,h);return A.VSBuffer.wrap(p)}onReadFileStream(w,y,h){const b=this.transformIncoming(w,y,!0),p=new I.CancellationTokenSource,v=new C.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),m=this.provider.readFileStream(b,h,p.token);return(0,R.listenStream)(m,{onData:f=>v.fire(A.VSBuffer.wrap(f)),onError:f=>v.fire(f),onEnd:()=>{v.fire("end"),v.dispose(),p.dispose()}}),v.event}writeFile(w,y,h,b){const p=this.transformIncoming(w,y);return this.provider.writeFile(p,h.buffer,b)}open(w,y,h){const b=this.transformIncoming(w,y,!0);return this.provider.open(b,h)}close(w){return this.provider.close(w)}async read(w,y,h){const b=A.VSBuffer.alloc(h),p=0,v=await this.provider.read(w,y,b.buffer,p,h);return[b,v]}write(w,y,h,b,p){return this.provider.write(w,y,h.buffer,b,p)}mkdir(w,y){const h=this.transformIncoming(w,y);return this.provider.mkdir(h)}delete(w,y,h){const b=this.transformIncoming(w,y);return this.provider.delete(b,h)}rename(w,y,h,b){const p=this.transformIncoming(w,y),v=this.transformIncoming(w,h);return this.provider.rename(p,v,b)}copy(w,y,h,b){const p=this.transformIncoming(w,y),v=this.transformIncoming(w,h);return this.provider.copy(p,v,b)}cloneFile(w,y,h){const b=this.transformIncoming(w,y),p=this.transformIncoming(w,h);return this.provider.cloneFile(b,p)}onFileChange(w,y){const h=new C.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(w,h))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return h.event}async watch(w,y,h,b,p){const v=this.sessionToWatcher.get(y);if(v){const m=this.transformIncoming(w,b),f=v.watch(h,m,p);this.watchRequests.set(y+h,f)}}async unwatch(w,y){const h=w+y,b=this.watchRequests.get(h);b&&((0,r.dispose)(b),this.watchRequests.delete(h))}dispose(){super.dispose();for(const[,w]of this.watchRequests)w.dispose();this.watchRequests.clear();for(const[,w]of this.sessionToWatcher)w.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=u;class a extends r.Disposable{constructor(w,y,h,b){super(),this.uriTransformer=w,this.logService=h,this.environmentService=b,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(w){const y=this._register(new C.Emitter);this._register(y.event(h=>{w.fire(h.map(b=>({resource:this.uriTransformer.transformOutgoingURI(b.resource),type:b.type,cId:b.cId})))})),this._register(this.fileWatcher.onDidChangeFile(h=>y.fire(h))),this._register(this.fileWatcher.onDidWatchError(h=>w.fire(h)))}getRecursiveWatcherOptions(w){}getExtraExcludes(w){}watch(w,y,h){const b=this.getExtraExcludes(this.environmentService);return Array.isArray(b)&&(h.excludes=[...h.excludes,...b]),this.watcherRequests.set(w,this.fileWatcher.watch(y,h)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(w)),this.watcherRequests.delete(w)})}dispose(){for(const[,w]of this.watcherRequests)w.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=a}),define(ie[224],ne([0,1,15,178,4,7,16,9,223,155]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class g extends u.AbstractDiskFileSystemProviderChannel{constructor(h,b,p){super(h,b),this.environmentService=p}getUriTransformer(h){return a.DefaultURITransformer}transformIncoming(h,b){return A.URI.revive(b)}async delete(h,b,p){if(!p.useTrash)return super.delete(h,b,p);const v=this.transformIncoming(h,b),m=(0,I.normalize)(v.fsPath);try{await C.shell.trashItem(m)}catch{throw(0,R.createFileSystemProviderError)(r.isWindows?(0,L.localize)(0,null,(0,I.basename)(m)):(0,L.localize)(1,null,(0,I.basename)(m)),R.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(h,b){return new w(h,b,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=g;class w extends u.AbstractSessionFileWatcher{watch(h,b,p){if(p.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(h,b,p)}}}),define(ie[225],ne([0,1,6]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends C.AbstractMessageLogger{constructor(A=C.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(A),this._register(this.onDidChangeLogLevel(R=>{this._logger?.setLevel(R)}))}set logger(A){this._logger=A;for(const{level:R,message:I}of this.buffer)(0,C.log)(A,R,I);this.buffer=[]}log(A,R){this._logger?(0,C.log)(this._logger,A,R):this.getLevel()<=A&&this.buffer.push({level:A,message:R})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(ie[226],ne([0,1,7,3,6,2]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class R extends r.AbstractLoggerService{constructor(w,y,h,b,p){super(y,h,b),this.windowId=w,this.channel=p,this._register(p.listen("onDidChangeLogLevel",w)(v=>{(0,r.isLogLevel)(v)?super.setLogLevel(v):super.setLogLevel(C.URI.revive(v[0]),v[1])})),this._register(p.listen("onDidChangeVisibility",w)(([v,m])=>super.setVisibility(C.URI.revive(v),m))),this._register(p.listen("onDidChangeLoggers",w)(({added:v,removed:m})=>{for(const f of v)super.registerLogger({...f,resource:C.URI.revive(f.resource)});for(const f of m)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new r.AdapterLogger({log:(w,y)=>{this.channel.call("consoleLog",[w,y])}})}registerLogger(w){super.registerLogger(w),this.channel.call("registerLogger",[w,this.windowId])}deregisterLogger(w){super.deregisterLogger(w),this.channel.call("deregisterLogger",[w,this.windowId])}setLogLevel(w,y){super.setLogLevel(w,y),this.channel.call("setLogLevel",[w,y])}setVisibility(w,y){super.setVisibility(w,y),this.channel.call("setVisibility",[this.toResource(w),y])}doCreateLogger(w,y,h){return new I(this.channel,w,y,h,this.windowId)}static setLogLevel(w,y,h){return w.call("setLogLevel",[y,h])}}e.LoggerChannelClient=R;class I extends r.AbstractMessageLogger{constructor(w,y,h,b,p){super(b?.logLevel==="always"),this.channel=w,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[y,b,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,y){const h=[[w,y]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(w){this.channel.call("log",[this.file,w])}}class u{constructor(w,y){this.loggerService=w,this.getUriTransformer=y}listen(w,y){const h=this.getUriTransformer(w);switch(y){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,b=>({added:[...b.added].map(p=>this.transformLogger(p,h)),removed:[...b.removed].map(p=>this.transformLogger(p,h))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,b=>[h.transformOutgoingURI(b[0]),b[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,b=>(0,r.isLogLevel)(b)?b:[h.transformOutgoingURI(b[0]),b[1]])}throw new Error(`Event not found: ${y}`)}async call(w,y,h){const b=this.getUriTransformer(w);switch(y){case"setLogLevel":return(0,r.isLogLevel)(h[0])?this.loggerService.setLogLevel(h[0]):this.loggerService.setLogLevel(C.URI.revive(b.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(p=>this.transformLogger(p,b)))}throw new Error(`Call not found: ${y}`)}transformLogger(w,y){return{...w,resource:y.transformOutgoingURI(w.resource)}}}e.LoggerChannel=u;class a extends A.Disposable{constructor(w,y){super(),y.call("setLogLevel",[w.getLogLevel()]),this._register(w.onDidChangeLogLevel(h=>y.call("setLogLevel",[h]))),y.call("getRegisteredLoggers").then(h=>{for(const b of h)w.registerLogger({...b,resource:C.URI.revive(b.resource)})}),this._register(y.listen("onDidChangeVisibility")(([h,b])=>w.setVisibility(C.URI.revive(h),b))),this._register(y.listen("onDidChangeLoggers")(({added:h,removed:b})=>{for(const p of h)w.registerLogger({...p,resource:C.URI.revive(p.resource)});for(const p of b)w.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=a}),define(ie[227],ne([0,1,2,6]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends C.Disposable{constructor(R,I=[]){super(),this.logger=new L.MultiplexLogger([R,...I]),this._register(R.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...I){this.logger.trace(R,...I)}debug(R,...I){this.logger.debug(R,...I)}info(R,...I){this.logger.info(R,...I)}warn(R,...I){this.logger.warn(R,...I)}error(R,...I){this.logger.error(R,...I)}flush(){this.logger.flush()}}e.LogService=r}),define(ie[228],ne([0,1,31,7,6]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class A{constructor(I){this.loggerService=I,this.loggers=new C.ResourceMap}listen(I,u,a){switch(u){case"onDidChangeLoggers":return a?this.loggerService.getOnDidChangeLoggersEvent(a):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.loggerService.getOnDidChangeLogLevelEvent(a):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.loggerService.getOnDidChangeVisibilityEvent(a):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(I,u,a){switch(u){case"createLogger":this.createLogger(L.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.log(L.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1]);case"setLogLevel":return(0,r.isLogLevel)(a[0])?this.loggerService.setLogLevel(a[0]):this.loggerService.setLogLevel(L.URI.revive(a[0]),a[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(a[0]),a[1]);case"registerLogger":return this.loggerService.registerLogger({...a[0],resource:L.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(a[0]))}throw new Error(`Call not found: ${u}`)}createLogger(I,u,a){this.loggers.set(I,this.loggerService.createLogger(I,u,a))}consoleLog(I,u){let a=console.log;switch(I){case r.LogLevel.Error:a=console.error;break;case r.LogLevel.Warning:a=console.warn;break;case r.LogLevel.Info:a=console.info;break}a.call(console,...u)}log(I,u){const a=this.loggers.get(I);if(!a)throw new Error("Create the logger before logging");for(const[g,w]of u)(0,r.log)(a,g,w)}}e.LoggerChannel=A}),define(ie[229],ne([0,1,16,6]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(r||(r={}));async function A(a,g,w,y,h){try{const b=await new Promise((v,m)=>{G(["@vscode/spdlog"],v,m)});b.setFlushOn(r.Trace);const p=await b.createAsyncRotatingLogger(a,g,w,y);return h?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(b){console.error(b)}return null}function R(a,g,w){switch(g){case L.LogLevel.Trace:a.trace(w);break;case L.LogLevel.Debug:a.debug(w);break;case L.LogLevel.Info:a.info(w);break;case L.LogLevel.Warning:a.warn(w);break;case L.LogLevel.Error:a.error(w);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function I(a,g){switch(g){case L.LogLevel.Trace:a.setLevel(r.Trace);break;case L.LogLevel.Debug:a.setLevel(r.Debug);break;case L.LogLevel.Info:a.setLevel(r.Info);break;case L.LogLevel.Warning:a.setLevel(r.Warning);break;case L.LogLevel.Error:a.setLevel(r.Error);break;case L.LogLevel.Off:a.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class u extends L.AbstractMessageLogger{constructor(g,w,y,h,b){super(),this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(g,w,y,h),this._register(this.onDidChangeLogLevel(p=>{this._logger&&I(this._logger,p)}))}async _createSpdLogLogger(g,w,y,h){const b=y?6:1,p=30/b*C.ByteSize.MB,v=await A(g,w,p,b,h);if(v){this._logger=v,I(this._logger,this.getLevel());for(const{level:m,message:f}of this.buffer)R(this._logger,m,f);this.buffer=[]}}log(g,w){this._logger?R(this._logger,g,w):this.getLevel()<=g&&this.buffer.push({level:g,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=u}),define(ie[230],ne([0,1,32,6,229]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{doCreateLogger(I,u,a){return new r.SpdLogLogger((0,C.generateUuid)(),I.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.LoggerService=A}),define(ie[66],ne([0,1,31,3,5,6,230]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(A.ILoggerService);class I extends R.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new C.ResourceMap}createLogger(a,g,w){w!==void 0&&this.loggerResourcesByWindow.set(this.toResource(a),w);try{return super.createLogger(a,g)}catch(y){throw this.loggerResourcesByWindow.delete(this.toResource(a)),y}}registerLogger(a,g){g!==void 0&&this.loggerResourcesByWindow.set(a.resource,g),super.registerLogger(a)}deregisterLogger(a){this.loggerResourcesByWindow.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const g=[];for(const w of super.getRegisteredLoggers())a===this.loggerResourcesByWindow.get(w.resource)&&g.push(w);return g}getOnDidChangeLogLevelEvent(a){return L.Event.filter(this.onDidChangeLogLevel,g=>(0,A.isLogLevel)(g)||this.isInterestedLoggerResource(g[0],a))}getOnDidChangeVisibilityEvent(a){return L.Event.filter(this.onDidChangeVisibility,([g])=>this.isInterestedLoggerResource(g,a))}getOnDidChangeLoggersEvent(a){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(y=>this.isInterestedLoggerResource(y.resource,a)),removed:[...g.removed].filter(y=>this.isInterestedLoggerResource(y.resource,a))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(a){for(const[g,w]of this.loggerResourcesByWindow)w===a&&this.deregisterLogger(g)}isInterestedLoggerResource(a,g){const w=this.loggerResourcesByWindow.get(a);return w===void 0||w===g}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=I}),define(ie[231],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function C(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=C;function L(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function r(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function A(R){return!C(R)&&!L(R)&&!r(R)}e.isMenubarMenuItemAction=A}),define(ie[39],ne([0,1,3,70,2,5]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class R extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const g=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},g!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),L.Iterable.reduce(this.policies.entries(),(w,[y,h])=>({...w,[y]:h}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[g,w])=>({...a,[g]:{definition:w,value:this.policies.get(g)}}),{})}}e.AbstractPolicyService=R;class I{constructor(){this.onDidChange=C.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ie[232],ne([0,1,8,3,70,12,16,6,39]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(w,y){const h=[];for(const b of new Set(r.Iterable.concat(w.keys(),y.keys())))w.get(b)!==y.get(b)&&h.push(b);return h}let g=class extends u.AbstractPolicyService{constructor(y,h,b){super(),this.file=y,this.fileService=h,this.logService=b,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const p=L.Event.filter(h.onDidFilesChange,v=>v.affects(y));this._register(h.watch(y)),this._register(p(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const y=new Map;try{const h=await this.fileService.readFile(this.file),b=JSON.parse(h.value.toString());if(!(0,A.isObject)(b))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(b))this.policyDefinitions[p]&&y.set(p,b[p])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return y}async refresh(){const y=await this.read(),h=a(this.policies,y);this.policies=y,h.length>0&&this._onDidChange.fire(h)}};e.FilePolicyService=g,e.FilePolicyService=g=Pe([te(1,R.IFileService),te(2,I.ILogService)],g)}),define(ie[233],ne([0,1,3,2,39]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(u){this.service=u,this.disposables=new L.DisposableStore}listen(u,a){switch(a){case"onDidChange":return C.Event.map(this.service.onDidChange,g=>g.reduce((w,y)=>({...w,[y]:this.service.getPolicyValue(y)??null}),{}),this.disposables)}throw new Error(`Event not found: ${a}`)}call(u,a,g){switch(a){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${a}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class R extends r.AbstractPolicyService{constructor(u,a){super(),this.channel=a;for(const g in u){const{definition:w,value:y}=u[g];this.policyDefinitions[g]=w,y!==void 0&&this.policies.set(g,y)}this.channel.listen("onDidChange")(g=>{for(const w in g){const y=g[w];y===null?this.policies.delete(w):this.policies.set(w,y)}this._onDidChange.fire(Object.keys(g))})}async _updatePolicyDefinitions(u){const a=await this.channel.call("updatePolicyDefinitions",u);for(const g in a)this.policies.set(g,a[g])}}e.PolicyChannelClient=R}),define(ie[234],ne([0,1,39,8,312,2,6]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends C.AbstractPolicyService{constructor(a,g){super(),this.logService=a,this.productName=g,this.throttler=new L.Throttler,this.watcher=this._register(new A.MutableDisposable)}async _updatePolicyDefinitions(a){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.throttler.queue(()=>new Promise((g,w)=>{try{this.watcher.value=(0,r.createWatcher)(this.productName,a,y=>{this._onDidPolicyChange(y),g()})}catch(y){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),w(y)}}))}_onDidPolicyChange(a){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const g in a){const w=a[g];w===void 0?this.policies.delete(g):this.policies.set(g,w)}this._onDidChange.fire(Object.keys(a))}};e.NativePolicyService=I,e.NativePolicyService=I=Pe([te(0,R.ILogService)],I)}),define(ie[79],ne([0,1,4,35]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof C.globals.vscode<"u"&&typeof C.globals.vscode.context<"u"){const A=C.globals.vscode.context.configuration();if(A)r=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){r=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:R,itemUrl:I,controlUrl:u}=r.extensionsGallery||{};Object.assign(r,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||I,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||u}});try{const a=(...w)=>w.reduce((y,h)=>(Object.keys(h).forEach(b=>{Array.isArray(y[b])&&Array.isArray(h[b])?y[b]=h[b]:typeof y[b]=="object"&&typeof h[b]=="object"?y[b]=a(y[b],h[b]):y[b]=h[b]}),y),{}),g=globalThis._VSCODE_USER_PRODUCT_JSON||{};r=a(r,g)}catch{}if(L.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const a=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:a.version,release:a.release})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ie[25],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,C.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[235],ne([0,1,8,6]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=class{constructor(R,I,u){this._window=R,this._sessionId=I,this._logService=u}async inspect(R){await this._connect();const I=this._window.webContents.debugger;await I.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,C.timeout)(R);const u=await I.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),u.profile}async _connect(){const R=this._window.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async _disconnect(){const R=this._window.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};e.WindowProfiler=r,e.WindowProfiler=r=Pe([te(2,L.ILogService)],r)}),define(ie[80],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,C.createDecorator)("protocolMainService")}),define(ie[43],ne([0,1,137,12]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(R,I){C.ok(L.isString(R)),C.ok(L.isObject(I)),C.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,I)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new r}),define(ie[236],ne([0,1,3,43]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,a){this.schemasById[r(u)]=a,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;L.Registry.add(e.Extensions.JSONContribution,R)}),define(ie[57],ne([0,1,23,3,12,163,18,236,43]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var a;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var g;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=u.Registry.as(I.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.doRegisterConfigurations(i,o,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.doDeregisterConfigurations(i,o),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.doDeregisterConfigurations(o,s),this.doRegisterConfigurations(i,!1,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.doRegisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,o){const s=[];for(const{overrides:t,source:n}of i)for(const l in t)if(o.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const S=this.configurationDefaultsOverrides.get(l),D=S?.valuesSources??new Map;if(n)for(const O of Object.keys(t[l]))D.set(O,n);const M={...S?.value||{},...t[l]};this.configurationDefaultsOverrides.set(l,{source:n,value:M,valuesSources:D});const P=(0,R.getLanguageTagSettingPlainKey)(l),k={type:"object",default:M,description:A.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:r.isString(n)?void 0:n,defaultValueSource:n};s.push(...p(l)),this.configurationProperties[l]=k,this.defaultLanguageConfigurationOverridesNode.properties[l]=k}else{this.configurationDefaultsOverrides.set(l,{value:t[l],source:n});const S=this.configurationProperties[l];S&&(this.updatePropertyDefaultValue(l,S),this.updateSchema(l,S))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(i){const o=new Set;this.doDeregisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,o){for(const{overrides:s,source:t}of i)for(const n in s){const l=this.configurationDefaultsOverrides.get(n),S=r.isString(t)?t:t?.id,D=r.isString(l?.source)?l?.source:l?.source?.id;if(S===D)if(o.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const M=this.configurationProperties[n];M&&(this.updatePropertyDefaultValue(n,M),this.updateSchema(n,M))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,s),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o,s){i.forEach(t=>{this.validateAndRegisterProperties(t,o,t.extensionInfo,t.restrictedProperties,void 0,s),this.configurationContributors.push(t),this.registerJSONConfiguration(t)})}doDeregisterConfigurations(i,o){const s=t=>{if(t.properties)for(const n in t.properties){o.add(n);const l=this.configurationProperties[n];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,t.properties[n])}t.allOf?.forEach(n=>s(n))};for(const t of i){s(t);const n=this.configurationContributors.indexOf(t);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(i,o=!0,s,t,n=3,l){n=r.isUndefinedOrNull(i.scope)?n:i.scope;const S=i.properties;if(S)for(const M in S){const P=S[M];if(o&&d(M,P)){delete S[M];continue}if(P.source=s,P.defaultDefaultValue=S[M].default,this.updatePropertyDefaultValue(M,P),e.OVERRIDE_PROPERTY_REGEX.test(M)?P.scope=void 0:(P.scope=r.isUndefinedOrNull(P.scope)?n:P.scope,P.restricted=r.isUndefinedOrNull(P.restricted)?!!t?.includes(M):P.restricted),S[M].hasOwnProperty("included")&&!S[M].included){this.excludedConfigurationProperties[M]=S[M],delete S[M];continue}else this.configurationProperties[M]=S[M],S[M].policy?.name&&this.policyConfigurations.set(S[M].policy.name,M);!S[M].deprecationMessage&&S[M].markdownDeprecationMessage&&(S[M].deprecationMessage=S[M].markdownDeprecationMessage),l.add(M)}const D=i.allOf;if(D)for(const M of D)this.validateAndRegisterProperties(M,o,s,t,n,l)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=s=>{const t=s.properties;if(t)for(const l in t)this.updateSchema(l,t[l]);s.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}registerOverridePropertyPatternKey(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const s=this.configurationDefaultsOverrides.get(i);let t=s?.value,n=s?.source;r.isUndefined(t)&&(t=o.defaultDefaultValue,n=void 0),r.isUndefined(t)&&(t=m(o.type)),o.default=t,o.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",b=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(c){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let o=b.exec(c);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=b.exec(c)}}return(0,C.distinct)(i)}e.overrideIdentifiersFromKey=p;function v(c){return c.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=v;function m(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const f=new y;u.Registry.add(e.Extensions.Configuration,f);function d(c,i){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?A.localize(7,null,c):f.getConfigurationProperties()[c]!==void 0?A.localize(8,null,c):i.policy?.name&&f.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,c,i.policy?.name,f.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.validateProperty=d;function E(){const c=[],i=f.getConfigurationProperties();for(const o of Object.keys(i))c.push([o,i[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=E}),define(ie[119],ne([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(G,e,C,L,r,A,R,I,u,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(o){return Object.isFrozen(o)?o:I.deepFreeze(o)}class b{constructor(s={},t=[],n=[],l){this._contents=s,this._keys=t,this._overrides=n,this.raw=l,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(t=>{if(t instanceof b)return t;const n=new p("");return n.parseRaw(t),n.configurationModel});this._rawConfiguration=s.reduce((t,n)=>n===t?n:t.merge(n),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,g.getConfigurationValue)(this.contents,s):this.contents}inspect(s,t){const n=this.rawConfiguration.getValue(s),l=t?this.rawConfiguration.getOverrideValue(s,t):void 0,S=t?this.rawConfiguration.override(t).getValue(s):n;return{value:n,override:l,merged:S}}getOverrideValue(s,t){const n=this.getContentsForOverrideIdentifer(t);return n?s?(0,g.getConfigurationValue)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const t=[];for(const n of this.overrides)n.identifiers.includes(s)&&t.push(...n.keys);return C.distinct(t)}getAllOverrideIdentifiers(){const s=[];for(const t of this.overrides)s.push(...t.identifiers);return C.distinct(s)}override(s){let t=this.overrideConfigurations.get(s);return t||(t=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,t)),t}merge(...s){const t=I.deepClone(this.contents),n=I.deepClone(this.overrides),l=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const D of s)if(S.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(t,D.contents);for(const M of D.overrides){const[P]=n.filter(k=>C.equals(k.identifiers,M.identifiers));P?(this.mergeContents(P.contents,M.contents),P.keys.push(...M.keys),P.keys=C.distinct(P.keys)):n.push(I.deepClone(M))}for(const M of D.keys)l.indexOf(M)===-1&&l.push(M)}return new b(t,l,n,S.every(D=>D instanceof b)?void 0:S)}createOverrideConfigurationModel(s){const t=this.getContentsForOverrideIdentifer(s);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const l of C.distinct([...Object.keys(this.contents),...Object.keys(t)])){let S=this.contents[l];const D=t[l];D&&(typeof S=="object"&&typeof D=="object"?(S=I.deepClone(S),this.mergeContents(S,D)):S=D),n[l]=S}return new b(n,this.keys,this.overrides)}mergeContents(s,t){for(const n of Object.keys(t)){if(n in s&&u.isObject(s[n])&&u.isObject(t[n])){this.mergeContents(s[n],t[n]);continue}s[n]=I.deepClone(t[n])}}getContentsForOverrideIdentifer(s){let t=null,n=null;const l=S=>{S&&(n?this.mergeContents(n,S):n=I.deepClone(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===s?t=S.contents:S.identifiers.includes(s)&&l(S.contents);return l(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,t){this.updateValue(s,t,!0)}setValue(s,t){this.updateValue(s,t,!1)}removeValue(s){const t=this.keys.indexOf(s);t!==-1&&(this.keys.splice(t,1),(0,g.removeFromValueTree)(this.contents,s),w.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(n=>C.equals(n.identifiers,(0,w.overrideIdentifiersFromKey)(s))),1))}updateValue(s,t,n){(0,g.addToValueTree)(this.contents,s,t,l=>console.error(l)),n=n||this.keys.indexOf(s)===-1,n&&this.keys.push(s),w.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,g.toValuesTree)(this.contents[s],l=>console.error(l))})}}e.ConfigurationModel=b;class p{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,t){if(!u.isUndefinedOrNull(s)){const n=this.doParseContent(s);this.parseRaw(n,t)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,t){this._raw=s;const{contents:n,keys:l,overrides:S,restricted:D,hasExcludedProperties:M}=this.doParseRaw(s,t);this._configurationModel=new b(n,l,S,M?[s]:void 0),this._restrictedConfigurations=D||[]}doParseContent(s){let t={},n=null,l=[];const S=[],D=[];function M(k){Array.isArray(l)?l.push(k):n!==null&&(l[n]=k)}const P={onObjectBegin:()=>{const k={};M(k),S.push(l),l=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{l=S.pop()},onArrayBegin:()=>{const k=[];M(k),S.push(l),l=k,n=null},onArrayEnd:()=>{l=S.pop()},onLiteralValue:M,onError:(k,O,F)=>{D.push({error:k,offset:O,length:F})}};if(s)try{r.visit(s,P),t=l[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return t}doParseRaw(s,t){const n=y.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),l=this.filter(s,n,!0,t);s=l.raw;const S=(0,g.toValuesTree)(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),D=Object.keys(s),M=this.toOverrides(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:S,keys:D,overrides:M,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(s,t,n,l){let S=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:S};const D={},M=[];for(const P in s)if(w.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const k=this.filter(s[P],t,!1,l);D[P]=k.raw,S=S||k.hasExcludedProperties,M.push(...k.restricted)}else{const k=t[P],O=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&M.push(P),!l.exclude?.includes(P)&&(l.include?.includes(P)||(O===void 0||l.scopes===void 0||l.scopes.includes(O))&&!(l.skipRestricted&&k?.restricted))?D[P]=s[P]:S=!0}return{raw:D,restricted:M,hasExcludedProperties:S}}toOverrides(s,t){const n=[];for(const l of Object.keys(s))if(w.OVERRIDE_PROPERTY_REGEX.test(l)){const S={};for(const D in s[l])S[D]=s[l][D];n.push({identifiers:(0,w.overrideIdentifiersFromKey)(l),keys:Object.keys(S),contents:(0,g.toValuesTree)(S,t)})}return n}}e.ConfigurationModelParser=p;class v extends A.Disposable{constructor(s,t,n,l){super(),this.userSettingsResource=s,this.parseOptions=t,this.fileService=l,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,S=>S.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&n.isEqual(S.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class m{constructor(s,t,n,l,S,D,M,P,k,O,F,z,Y){this.key=s,this.overrides=t,this._value=n,this.overrideIdentifiers=l,this.defaultConfiguration=S,this.policyConfiguration=D,this.applicationConfiguration=M,this.userConfiguration=P,this.localUserConfiguration=k,this.remoteUserConfiguration=O,this.workspaceConfiguration=F,this.folderConfigurationModel=z,this.memoryConfigurationModel=Y}get value(){return h(this._value)}inspect(s,t,n){const l=s.inspect(t,n);return{get value(){return h(l.value)},get override(){return h(l.override)},get merged(){return h(l.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class f{constructor(s,t,n,l,S=new b,D=new b,M=new R.ResourceMap,P=new b,k=new R.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=t,this._applicationConfiguration=n,this._localUserConfiguration=l,this._remoteUserConfiguration=S,this._workspaceConfiguration=D,this._folderConfigurations=M,this._memoryConfiguration=P,this._memoryConfigurationByResource=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(s,t,n){return this.getConsolidatedConfigurationModel(s,t,n).getValue(s)}updateValue(s,t,n={}){let l;n.resource?(l=this._memoryConfigurationByResource.get(n.resource),l||(l=new b,this._memoryConfigurationByResource.set(n.resource,l))):l=this._memoryConfiguration,t===void 0?l.removeValue(s):l.setValue(s,t),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,t,n){const l=this.getConsolidatedConfigurationModel(s,t,n),S=this.getFolderConfigurationModelForResource(t.resource,n),D=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,M=new Set;for(const P of l.overrides)for(const k of P.identifiers)l.getOverrideValue(s,k)!==void 0&&M.add(k);return new m(s,t,l.getValue(s),M.size?[...M]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,S||void 0,D)}keys(s){const t=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,t){this._folderConfigurations.set(s,t),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,t){const n=[];if(!t){const{added:l,updated:S,removed:D}=c(this._defaultConfiguration,s);t=[...l,...S,...D]}for(const l of t)for(const S of(0,w.overrideIdentifiersFromKey)(l)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(S),M=s.getKeysForOverrideIdentifier(S),P=[...M.filter(k=>D.indexOf(k)===-1),...D.filter(k=>M.indexOf(k)===-1),...D.filter(k=>!I.equals(this._defaultConfiguration.override(S).getValue(k),s.override(S).getValue(k)))];n.push([S,P])}return this.updateDefaultConfiguration(s),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(s){const{added:t,updated:n,removed:l}=c(this._policyConfiguration,s),S=[...t,...n,...l];return S.length&&this.updatePolicyConfiguration(s),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:t,updated:n,removed:l,overrides:S}=c(this.applicationConfiguration,s),D=[...t,...n,...l];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:S}}compareAndUpdateLocalUserConfiguration(s){const{added:t,updated:n,removed:l,overrides:S}=c(this.localUserConfiguration,s),D=[...t,...n,...l];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:S}}compareAndUpdateRemoteUserConfiguration(s){const{added:t,updated:n,removed:l,overrides:S}=c(this.remoteUserConfiguration,s),D=[...t,...n,...l];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:S}}compareAndUpdateWorkspaceConfiguration(s){const{added:t,updated:n,removed:l,overrides:S}=c(this.workspaceConfiguration,s),D=[...t,...n,...l];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:S}}compareAndUpdateFolderConfiguration(s,t){const n=this.folderConfigurations.get(s),{added:l,updated:S,removed:D,overrides:M}=c(n,t),P=[...l,...S,...D];return(P.length||!n)&&this.updateFolderConfiguration(s,t),{keys:P,overrides:M}}compareAndDeleteFolderConfiguration(s){const t=this.folderConfigurations.get(s);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:l,removed:S,overrides:D}=c(t,void 0);return{keys:[...n,...l,...S],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,t,n){let l=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier&&(l=l.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:s},t){let n=this.getWorkspaceConsolidatedConfiguration();if(t&&s){const l=t.getFolder(s);l&&(n=this.getFolderConsolidatedConfiguration(l.uri)||n);const S=this._memoryConfigurationByResource.get(s);S&&(n=n.merge(S))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let t=this._foldersConsolidatedConfigurations.get(s);if(!t){const n=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(s);l?(t=n.merge(l),this._foldersConsolidatedConfigurations.set(s,t)):t=n}return t}getFolderConfigurationModelForResource(s,t){if(t&&s){const n=t.getFolder(s);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,t)=>{const{contents:n,overrides:l,keys:S}=this._folderConfigurations.get(t);return s.push([t,{contents:n,overrides:l,keys:S}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(t=>s.add(t)),this.userConfiguration.keys.forEach(t=>s.add(t)),this._workspaceConfiguration.keys.forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.keys.forEach(n=>s.add(n))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>t.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(l=>t.add(l))),[...t.values()]}static parse(s){const t=this.parseConfigurationModel(s.defaults),n=this.parseConfigurationModel(s.policy),l=this.parseConfigurationModel(s.application),S=this.parseConfigurationModel(s.user),D=this.parseConfigurationModel(s.workspace),M=s.folders.reduce((P,k)=>(P.set(a.URI.revive(k[0]),this.parseConfigurationModel(k[1])),P),new R.ResourceMap);return new f(t,n,l,S,new b,D,M,new b,new R.ResourceMap)}static parseConfigurationModel(s){return new b(s.contents,s.keys,s.overrides)}}e.Configuration=f;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,t=new Map;for(const l of o)l.keys.forEach(S=>s.add(S)),l.overrides.forEach(([S,D])=>{const M=(0,R.getOrSet)(t,S,new Set);D.forEach(P=>M.add(P))});const n=[];return t.forEach((l,S)=>n.push([S,[...l.values()]])),{keys:[...s.values()],overrides:n}}e.mergeChanges=d;class E{constructor(s,t,n,l){this.change=s,this.previous=t,this.currentConfiguraiton=n,this.currentWorkspace=l,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const S of s.keys)this.affectedKeys.add(S);for(const[,S]of s.overrides)for(const D of S)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const S of this.affectedKeys)this._affectsConfigStr+=S+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,t){const n=this._marker+s,l=this._affectsConfigStr.indexOf(n);if(l<0)return!1;const S=l+n.length;if(S>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(S);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(t){const M=this.previousConfiguration?this.previousConfiguration.getValue(s,t,this.previous?.workspace):void 0,P=this.currentConfiguraiton.getValue(s,t,this.currentWorkspace);return!I.equals(M,P)}return!0}}e.ConfigurationChangeEvent=E;function c(o,s){const{added:t,removed:n,updated:l}=i(s?.rawConfiguration,o?.rawConfiguration),S=[],D=o?.getAllOverrideIdentifiers()||[],M=s?.getAllOverrideIdentifiers()||[];if(s){const P=M.filter(k=>!D.includes(k));for(const k of P)S.push([k,s.getKeysForOverrideIdentifier(k)])}if(o){const P=D.filter(k=>!M.includes(k));for(const k of P)S.push([k,o.getKeysForOverrideIdentifier(k)])}if(s&&o){for(const P of D)if(M.includes(P)){const k=i({contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)},{contents:s.getOverrideValue(void 0,P)||{},keys:s.getKeysForOverrideIdentifier(P)});S.push([P,[...k.added,...k.removed,...k.updated]])}}return{added:t,removed:n,updated:l,overrides:S}}function i(o,s){const t=o?s?o.keys.filter(S=>s.keys.indexOf(S)===-1):[...o.keys]:[],n=s?o?s.keys.filter(S=>o.keys.indexOf(S)===-1):[...s.keys]:[],l=[];if(o&&s){for(const S of s.keys)if(o.keys.indexOf(S)!==-1){const D=(0,g.getConfigurationValue)(s.contents,S),M=(0,g.getConfigurationValue)(o.contents,S);I.equals(D,M)||l.push(S)}}return{added:t,removed:n,updated:l}}}),define(ie[237],ne([0,1,23,3,2,37,12,119,57,6,39,43]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(w.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:m})=>this.onDidUpdateConfiguration(Array.from(v),m))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(v,m){this.updateConfigurationModel(v,w.Registry.as(u.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const v=w.Registry.as(u.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(v),v)}updateConfigurationModel(v,m){const f=this.getConfigurationDefaultOverrides();for(const d of v){const E=f[d],c=m[d];E!==void 0?this._configurationModel.addValue(d,E):c?this._configurationModel.addValue(d,c.default):this._configurationModel.removeValue(d)}}}e.DefaultConfiguration=y;class h{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let b=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(v,m,f){super(),this.defaultConfiguration=v,this.policyService=m,this.logService=f,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.updatePolicyDefinitions(v),!0))),this._configurationModel}async updatePolicyDefinitions(v){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",v);const m={},f=[],d=w.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const E of v){const c=d[E];if(!c){f.push(E);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.logService.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}f.push(E),m[c.policy.name]={type:c.type}}}return(0,R.isEmptyObject)(m)||await this.policyService.updatePolicyDefinitions(m),f}onDidChangePolicies(v){this.logService.trace("PolicyConfiguration#onDidChangePolicies",v);const m=w.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),f=(0,C.coalesce)(v.map(d=>m.get(d)));this.update(f,!0)}update(v,m){this.logService.trace("PolicyConfiguration#update",v);const f=w.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),d=[],E=this._configurationModel.isEmpty();for(const c of v){const i=f[c]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(E?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(c),o))&&d.push([c,o])}else this._configurationModel.getValue(c)!==void 0&&d.push([c,void 0])}if(d.length){this.logService.trace("PolicyConfiguration#changed",d);const c=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const i of c.keys)this._configurationModel.setValue(i,c.getValue(i));for(const[i,o]of d)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=b,e.PolicyConfiguration=b=Pe([te(1,g.IPolicyService),te(2,a.ILogService)],b)}),define(ie[238],ne([0,1,8,3,2,19,18,119,237,39]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class g extends r.Disposable{constructor(y,h,b,p){super(),this.settingsResource=y,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=b instanceof a.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,b,p)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,{},A.extUriBiasedIgnorePathCase,h)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:v,properties:m})=>this.onDidDefaultConfigurationChange(v,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(v=>this.onDidPolicyConfigurationChange(v))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[y,h,b]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(y,h,new I.ConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(y,h){const b=typeof y=="string"?y:void 0,p=(0,R.isConfigurationOverrides)(y)?y:(0,R.isConfigurationOverrides)(h)?h:{};return this.configuration.getValue(b,p,void 0)}updateValue(y,h,b,p){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const h=this.configuration.toData(),b=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(b,h,2)}onDidDefaultConfigurationChange(y,h){const b=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(y,h);this.trigger(p,b,7)}onDidPolicyConfigurationChange(y){const h=this.configuration.toData(),b=this.configuration.compareAndUpdatePolicyConfiguration(y);this.trigger(b,h,7)}trigger(y,h,b){const p=new I.ConfigurationChangeEvent(y,{data:h},this.configuration);p.source=b,p.sourceConfig=this.getTargetConfiguration(b),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(y){switch(y){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=g}),define(ie[239],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class C{async routeCall(r,A,R){if(A!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${A}`);const I=R[0];if(I?.authority){const u=r.connections.find(a=>a.ctx===I.authority);if(u)return u}throw new Error("Caller not found")}routeEvent(r,A){throw new Error(`Event not found: ${A}`)}}e.NodeRemoteResourceRouter=C}),define(ie[240],ne([0,1,14,5]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var r;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class A{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class R{constructor(w,y){this.host=w,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var I;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class u extends C.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof u&&w._code===I.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof u&&w._code===I.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof u&&w._code===I.NoResolverFound}static isInvalidAuthority(w){return w instanceof u&&w._code===I.InvalidAuthority}static isHandled(w){return w instanceof u&&w.isHandled}constructor(w,y=I.Unknown,h){super(w),this._message=w,this._code=y,this._detail=h,this.isHandled=y===I.NotAvailable&&h===!0,Object.setPrototypeOf(this,u.prototype)}}e.RemoteAuthorityResolverError=u;function a(g){const w=g.indexOf("+");return w===-1?g:g.substring(0,w)}e.getRemoteAuthorityPrefix=a}),define(ie[58],ne([0,1,13]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(a){return a.scheme===C.Schemas.vscodeRemote?a.authority:void 0}e.getRemoteAuthority=L;function r(a){if(!a)return;const g=a.indexOf("+");return g<0?a:a.substr(0,g)}e.getRemoteName=r;function A(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.getRemoteServerRootPath=A;function R(a){const{host:g,port:w}=u(a);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:g,port:w}}e.parseAuthorityWithPort=R;function I(a,g){let{host:w,port:y}=u(a);return typeof y>"u"&&(y=g),{host:w,port:y}}e.parseAuthorityWithOptionalPort=I;function u(a){const g=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const w=a.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const y=a.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:a,port:void 0}}}),define(ie[120],ne([0,1,27,5,58]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(R||(e.ExtensionType=R={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class u{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,m){if(typeof v>"u"||v===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof v=="string"||typeof m=="string"){const f=typeof v=="string"?v:v.value,d=typeof m=="string"?m:m.value;return C.equalsIgnoreCase(f,d)}return v._lower===m._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=u;class a{get size(){return this._set.size}constructor(v){if(this._set=new Set,v)for(const m of v)this.add(m)}add(v){this._set.add(u.toKey(v))}delete(v){return this._set.delete(u.toKey(v))}has(v){return this._set.has(u.toKey(v))}}e.ExtensionIdentifierSet=a;class g{constructor(){this._map=new Map}clear(){this._map.clear()}delete(v){this._map.delete(u.toKey(v))}get(v){return this._map.get(u.toKey(v))}has(v){return this._map.has(u.toKey(v))}set(v,m){this._map.set(u.toKey(v),m)}values(){return this._map.values()}forEach(v){this._map.forEach(v)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=g;function w(p){return y(p)}e.isApplicationScopedExtension=w;function y(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function b(p,v){if(v){const m=`onResolveRemoteAuthority:${(0,r.getRemoteName)(v)}`;return!!p.activationEvents?.includes(m)}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[241],ne([0,1,8,17,22,14,3,2,65,72,32,109,240,58]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var p;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function v(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(W){const _=new r.CancellationTokenSource;return setTimeout(()=>_.cancel(),W),_.token}function f(W,_){if(W.isCancellationRequested||_.isCancellationRequested)return r.CancellationToken.Cancelled;const U=new r.CancellationTokenSource;return W.onCancellationRequested(()=>U.cancel()),_.onCancellationRequested(()=>U.cancel()),U.token}class d{get didTimeout(){return this._state==="timedout"}constructor(_){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((U,B)=>{this._resolvePromise=U,this._rejectPromise=B}),_.isCancellationRequested?this._timeout():this._disposables.add(_.onCancellationRequested(()=>this._timeout()))}registerDisposable(_){this._state==="pending"?this._disposables.add(_):_.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(_))}reject(_){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(_))}}function E(W,_){const U=new d(_);return U.registerDisposable(W.onControlMessage(B=>{const T=JSON.parse(B.toString()),$=q(T);$?U.reject($):U.resolve(T)})),U.promise}function c(W,_,U,B,T,$,x,ae){const fe=new d(ae),ue=a.StopWatch.create(!1);return W.info(`Creating a socket (${x})...`),u.mark(`code/willCreateSocket/${$}`),_.connect(U,B,T,x).then(de=>{fe.didTimeout?(u.mark(`code/didCreateSocketError/${$}`),W.info(`Creating a socket (${x}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(u.mark(`code/didCreateSocketOK/${$}`),W.info(`Creating a socket (${x}) was successful after ${ue.elapsed()} ms.`),fe.resolve(de))},de=>{u.mark(`code/didCreateSocketError/${$}`),W.info(`Creating a socket (${x}) returned an error after ${ue.elapsed()} ms.`),W.error(de),fe.reject(de)}),fe.promise}function i(W,_){const U=new d(_);return W.then(B=>{U.didTimeout||U.resolve(B)},B=>{U.didTimeout||U.reject(B)}),U.promise}async function o(W,_,U,B){const T=X(W,_);W.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let $;try{$=await c(W.logService,W.remoteSocketFactoryService,W.connectTo,(0,h.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,v(_),`renderer-${v(_)}-${W.reconnectionToken}`,B)}catch(de){throw W.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),W.logService.error(de),de}W.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let x,ae;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection($,null),x=W.reconnectionProtocol,ae=!1):(x=new w.PersistentProtocol({socket:$}),ae=!0),W.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const fe=await i(W.signService.createNewMessage((0,g.generateUuid)()),B),ue={type:"auth",auth:W.connectionToken||"00000000000000000000",data:fe.data};x.sendControl(L.VSBuffer.fromString(JSON.stringify(ue)));try{const de=await E(x,f(B,m(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(W.logService.trace(`${T} 4/6. received SignRequest control message.`),!await i(W.signService.validate(fe,de.signedData),B)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const we=await i(W.signService.sign(de.data),B),ye={type:"connectionType",commit:W.commit,signedData:we,desiredConnectionType:_};return U&&(ye.args=U),W.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(L.VSBuffer.fromString(JSON.stringify(ye))),{protocol:x,ownsProtocol:ae}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(W.logService.error(`${T} the handshake timed out. Error:`),W.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${T} received error control message when negotiating connection. Error:`),W.logService.error(de)),ae&&V(x),de}}async function s(W,_,U,B){const T=Date.now(),$=X(W,_),{protocol:x,ownsProtocol:ae}=await o(W,_,U,B),fe=new d(B);return fe.registerDisposable(x.onControlMessage(ue=>{const de=JSON.parse(ue.toString()),be=q(de);be?(W.logService.error(`${$} received error control message when negotiating connection. Error:`),W.logService.error(be),ae&&V(x),fe.reject(be)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${se(T)}!`),fe.resolve({protocol:x,firstMessage:de}))})),fe.promise}async function t(W,_){const{protocol:U}=await s(W,1,void 0,_);return{protocol:U}}async function n(W,_,U){const{protocol:B,firstMessage:T}=await s(W,2,_,U),$=T&&T.debugPort;return{protocol:B,debugPort:$}}async function l(W,_,U){const B=Date.now(),T=X(W,3),{protocol:$}=await o(W,3,_,U);return W.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${se(B)}!`),$}async function S(W,_,U){const{connectTo:B,connectionToken:T}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,connectTo:B,connectionToken:T,reconnectionToken:_,reconnectionProtocol:U,remoteSocketFactoryService:W.remoteSocketFactoryService,signService:W.signService,logService:W.logService}}async function D(W,_,U){return P(W,async B=>{const{protocol:T}=await t(B,r.CancellationToken.None);return new Q(W,_,U,B.reconnectionToken,T)})}e.connectRemoteAgentManagement=D;async function M(W,_){return P(W,async U=>{const{protocol:B,debugPort:T}=await n(U,_,r.CancellationToken.None);return new K(W,_,U.reconnectionToken,B,T)})}e.connectRemoteAgentExtensionHost=M;async function P(W,_){for(let B=1;;B++)try{const T=(0,g.generateUuid)(),$=await S(W,T,null);return await _($)}catch(T){if(B<5)W.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(T);else throw W.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(T),ce.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(T)),T}}async function k(W,_,U){const B=await S(W,(0,g.generateUuid)(),null);return await l(B,{host:_,port:U},r.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function O(W){return(0,C.createCancelablePromise)(_=>new Promise((U,B)=>{const T=setTimeout(U,W*1e3);_.onCancellationRequested(()=>{clearTimeout(T),U()})}))}var F;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class z{constructor(_,U){this.reconnectionToken=_,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=z;class Y{constructor(_,U,B,T){this.reconnectionToken=_,this.millisSinceLastIncomingData=U,this.durationSeconds=B,this.cancellableTimer=T,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=Y;class J{constructor(_,U,B){this.reconnectionToken=_,this.millisSinceLastIncomingData=U,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=J;class oe{constructor(_,U,B){this.reconnectionToken=_,this.millisSinceLastIncomingData=U,this.attempt=B,this.type=4}}e.ConnectionGainEvent=oe;class re{constructor(_,U,B,T){this.reconnectionToken=_,this.millisSinceLastIncomingData=U,this.attempt=B,this.handled=T,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class ce extends I.Disposable{static triggerPermanentFailure(_,U,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=_,this._permanentFailureAttempt=U,this._permanentFailureHandled=B,this._instances.forEach(T=>T._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(_=>_._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(_=>_._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||ce._permanentFailure}constructor(_,U,B,T,$){super(),this._connectionType=_,this._options=U,this.reconnectionToken=B,this.protocol=T,this._reconnectionFailureIsFatal=$,this._onDidStateChange=this._register(new R.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new oe(this.reconnectionToken,0,0)),this._register(T.onSocketClose(x=>{const ae=H(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${ae} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${ae} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${ae} received socket close event.`),this._beginReconnecting()})),this._register(T.onSocketTimeout(x=>{const ae=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ae} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ce._instances.push(this),this._register((0,I.toDisposable)(()=>{const x=ce._instances.indexOf(this);x>=0&&ce._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ce._permanentFailureMillisSinceLastIncomingData,ce._permanentFailureAttempt,ce._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const _=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const T=B<U.length?U[B]:U[U.length-1];try{if(T>0){const x=O(T);this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,x)),this._options.logService.info(`${_} waiting for ${T} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${_} resolving connection...`);const $=await S(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${_} connecting to ${$.connectTo}...`),await this._reconnect($,m(b)),this._options.logService.info(`${_} reconnected!`),this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,A.isCancellationError)($)){this._options.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,y.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(_,U,B){this._reconnectionFailureIsFatal?ce.triggerPermanentFailure(_,U,B):this._gotoPermanentFailure(_,U,B)}_gotoPermanentFailure(_,U,B){this._onDidStateChange.fire(new re(this.reconnectionToken,_,U,B)),V(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ce;class Q extends ce{constructor(_,U,B,T,$){super(1,_,T,$,!0),this.client=this._register(new w.Client($,{remoteAuthority:U,clientId:B},_.ipcLogger))}async _reconnect(_,U){await t(_,U)}}e.ManagementPersistentConnection=Q;class K extends ce{constructor(_,U,B,T,$){super(2,_,B,T,!1),this._startArguments=U,this.debugPort=$}async _reconnect(_,U){await n(_,this._startArguments,U)}}e.ExtensionHostPersistentConnection=K;function V(W){try{W.acceptDisconnect();const _=W.getSocket();W.dispose(),_.dispose()}catch(_){(0,A.onUnexpectedError)(_)}}function q(W){if(W&&W.type==="error"){const _=new Error(`Connection error: ${W.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function N(W,_){for(;W.length<_;)W+=" ";return W}function j(W,_){return`[remote-connection][${N(v(W),13)}][${_.substr(0,5)}\u2026]`}function H(W,_,U){return`${j(W,_)}[${U?"reconnect":"initial"}]`}function X(W,_){return`${H(_,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.connectTo}]`}function se(W){return`${Date.now()-W} ms`}}),define(ie[242],ne([0,1,2,5]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class r{constructor(){this.factories={}}register(R,I){return this.factories[R]??=[],this.factories[R].push(I),(0,C.toDisposable)(()=>{const u=this.factories[R]?.indexOf(I);typeof u=="number"&&u>=0&&this.factories[R]?.splice(u,1)})}getSocketFactory(R){return(this.factories[R.type]||[]).find(u=>u.supports(R))}connect(R,I,u,a){const g=this.getSocketFactory(R);if(!g)throw new Error(`No socket factory found for ${R}`);return g.connect(R,I,u,a)}}e.RemoteSocketFactoryService=r}),define(ie[243],ne([0,1,28,47,21,113]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let R;async function I(h=!1){return(R===void 0||h)&&(R=u()),R}e.hasWSLFeatureInstalled=I;async function u(){const h=a();if(h===void 0)return!1;if(h>=22e3){const b=w();if(b)return new Promise(p=>{L.execFile(b,["--status"],v=>p(!v))})}else{const b=y();if(b)try{if((await r.Promises.stat(b)).isFile())return!0}catch{}}return!1}function a(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(C.release());if(h)return parseInt(h[3])}function g(h){const b=process.env.SystemRoot;if(b){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(b,p?"Sysnative":"System32",h)}}function w(){return g("wsl.exe")}function y(){return g("lxss\\LxssManager.dll")}}),define(ie[50],ne([0,1,17,14,2,183,57,5,6,43]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class g{constructor(c){this.original=c}toJSON(){if(!this.headers){const c=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?c[i]="*****":c[i]=this.original[i];this.headers=c}return this.headers}}class w extends r.Disposable{constructor(c){super(),this.counter=0,this.logger=c.createLogger("network",{name:(0,A.localize)(0,null),when:u.CONTEXT_LOG_LEVEL.isEqualTo((0,u.LogLevelToString)(u.LogLevel.Trace)).serialize()})}async logAndRequest(c,i,o){const s=`${c} #${++this.counter}: ${i.url}`;this.logger.trace(`${s} - begin`,i.type,new g(i.headers??{}));try{const t=await o();return this.logger.trace(`${s} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.logger.error(`${s} - error`,i.type,(0,L.getErrorMessage)(t)),t}}}e.AbstractRequestService=w;function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=y;function h(E){return E.res.statusCode===204}e.hasNoContent=h;async function b(E){return h(E)?null:(await(0,C.streamToBuffer)(E.stream)).toString()}e.asText=b;async function p(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return b(E)}e.asTextOrError=p;async function v(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(h(E))return null;const i=(await(0,C.streamToBuffer)(E.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.asJson=v;function m(E){d(E)}e.updateProxyConfigurationsScope=m;let f;function d(E){const c=a.Registry.as(R.Extensions.Configuration),i=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},c.updateConfigurations({add:[f],remove:i?[i]:[]})}d(1)}),define(ie[244],ne([0,1,17,22]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(I){this.service=I}listen(I,u){throw new Error("Invalid listen")}call(I,u,a,g=L.CancellationToken.None){switch(u){case"request":return this.service.request(a[0],g).then(async({res:w,stream:y})=>{const h=await(0,C.streamToBuffer)(y);return[{statusCode:w.statusCode,headers:w.headers},h]});case"resolveProxy":return this.service.resolveProxy(a[0])}throw new Error("Invalid call")}}e.RequestChannel=r;class A{constructor(I){this.channel=I}async request(I,u){const[a,g]=await this.channel.call("request",[I],u);return{res:a,stream:(0,C.bufferToStream)(g)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=A}),define(ie[245],ne([0,1,246,12]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(R,I){return R.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:R.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function A(R,I,u={}){const a=(0,C.parse)(R),g=u.proxyUrl||r(a,I);if(!g)return null;const w=(0,C.parse)(g);if(!/^https?:$/.test(w.protocol||""))return null;const y={host:w.hostname||"",port:(w.port?+w.port:0)||(w.protocol==="https"?443:80),auth:w.auth,rejectUnauthorized:(0,L.isBoolean)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((h,b)=>{G(["http-proxy-agent"],h,b)})).HttpProxyAgent(g,y):new(await new Promise((h,b)=>{G(["https-proxy-agent"],h,b)})).HttpsProxyAgent(g,y)}e.getProxyAgent=A}),define(ie[247],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ie[94],ne([0,1,47,9,184,22,49,14,4,32,108,62,8,140]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let b;async function p(m,f,d,E){return d["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(E)&&!d["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(E)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=y.Promises.withAsyncBody(async(c,i)=>{const o=new A.CancellationTokenSource;let s=1e4;const t=m.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(s=(0,h.clamp)(t,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,r.localize)(0,null)))},s);try{c(await v(f,o.token))}catch(l){!(0,I.isCancellationError)(l)&&!o.token.isCancellationRequested?i(new Error((0,r.localize)(1,null,(0,R.toErrorMessage)(l)))):c({})}finally{clearTimeout(n),o.dispose()}})),b)}e.getResolvedShellEnv=p;async function v(m,f){const d=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",d);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",E);const c=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"({.*})"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",o);const s=await(0,g.getSystemShell)(u.OS,o);return m.trace("getUnixShellEnvironment#shell",s),new Promise((t,n)=>{if(f.isCancellationRequested)return n(new I.CancellationError);const l=(0,L.basename)(s);let S,D;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(S=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,D=["-Login","-Command"]):l==="nu"?(S=`^'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,D=["-i","-l","-c"]):(S=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"||l==="csh"?D=["-ic"]:D=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),S);const P=(0,C.spawn)(s,[...D,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(P.kill(),n(new I.CancellationError))),P.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(F)),n(F)});const k=[];P.stdout.on("data",F=>k.push(F));const O=[];P.stderr.on("data",F=>O.push(F)),P.on("close",(F,z)=>{const Y=Buffer.concat(k).toString("utf8");m.trace("getUnixShellEnvironment#raw",Y);const J=Buffer.concat(O).toString("utf8");if(J.trim()&&m.trace("getUnixShellEnvironment#stderr",J),F||z)return n(new Error((0,r.localize)(2,null,F,z)));const oe=i.exec(Y),re=oe?oe[1]:"{}";try{const ce=JSON.parse(re);d?ce.ELECTRON_RUN_AS_NODE=d:delete ce.ELECTRON_RUN_AS_NODE,E?ce.ELECTRON_NO_ATTACH_CONSOLE=E:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",ce),t(ce)}catch(ce){m.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ce)),n(ce)}})})}}),define(ie[248],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class C{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(r){try{const A=await this.getValidator();if(A){const R=String(C._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,A){if(!r.id)return!0;const R=this.validators.get(r.id);if(!R)return!1;this.validators.delete(r.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(r){try{return await this.signValue(r)}catch{}return r}}e.AbstractSignService=C}),define(ie[95],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,C.createDecorator)(e.SIGN_SERVICE_ID)}),define(ie[249],ne([0,1,248]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends C.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(R=>new R.signer().sign(A))}vsda(){return new Promise((A,R)=>G(["vsda"],A,R))}}e.SignService=L}),define(ie[34],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,C.createDecorator)("stateReadService"),e.IStateService=(0,C.createDecorator)("stateService")}),define(ie[121],ne([0,1,8,17,2,12,36,16,6]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends r.Disposable{constructor(b,p,v,m){super(),this.storagePath=b,this.logService=v,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=p===0?void 0:this._register(new C.ThrottledDelayer(100))}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}}getItem(b,p){const v=this.storage[b];return(0,A.isUndefinedOrNull)(v)?p:v}setItem(b,p){this.setItems([{key:b,data:p}])}setItems(b){let p=!1;for(const{key:v,data:m}of b)this.storage[v]!==m&&((0,A.isUndefinedOrNull)(m)?(0,A.isUndefined)(this.storage[v])||(this.storage[v]=void 0,p=!0):(this.storage[v]=m,p=!0));p&&this.save()}removeItem(b){(0,A.isUndefined)(this.storage[b])||(this.storage[b]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const b=JSON.stringify(this.storage,null,4);if(b!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(b),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=b}catch(p){this.logService.error(p)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=g;let w=class extends r.Disposable{constructor(b,p,v,m){super(),this.fileStorage=this._register(new g(p.stateResource,b,v,m))}async init(){await this.fileStorage.init()}getItem(b,p){return this.fileStorage.getItem(b,p)}};e.StateReadonlyService=w,e.StateReadonlyService=w=Pe([te(1,R.IEnvironmentService),te(2,u.ILogService),te(3,I.IFileService)],w);class y extends w{setItem(b,p){this.fileStorage.setItem(b,p)}setItems(b){this.fileStorage.setItems(b)}removeItem(b){this.fileStorage.removeItem(b)}close(){return this.fileStorage.close()}}e.StateService=y}),define(ie[122],ne([0,1,4,35,32]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(u){if(C.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function R(u,a,g,w,y,h,b,p,v){const m=Object.create(null);m["common.machineId"]=h,m["common.sqmId"]=b,m.sessionID=(0,r.generateUuid)()+Date.now(),m.commitHash=w,m.version=y,m["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,C.PlatformToString)(C.platform),m["common.nodePlatform"]=L.platform,m["common.nodeArch"]=g,m["common.product"]=v||"desktop",p&&(m["common.msftInternal"]=p);let f=0;const d=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),C.isLinuxSnap&&(m["common.snap"]="true");const E=A(a);return E&&(m["common.platformDetail"]=E),m}e.resolveCommonProperties=R;function I(u){const a=L.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return u.some(w=>g===w)}e.verifyMicrosoftInternalDomain=I}),define(ie[26],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,C.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var r;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(ie[250],ne([0,1,28,8,44,13,9,4,7,88,21,107,91,16,25,26]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function m(i,o){const s=`${i}::${o.join(":")}`,t=v.get(s);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,S=new Map,D=2e4;function M(k,O,F,z){const Y=O.substring(k.length+1);return L.Promises.withAsyncBody(async J=>{let oe;try{oe=await g.Promises.readdir(O,{withFileTypes:!0})}catch{J();return}if(z.count>=D){z.count+=oe.length,z.maxReached=!0,J();return}let re=oe.length;if(re===0){J();return}let ce=oe;z.count+oe.length>D&&(z.maxReached=!0,re=D-z.count,ce=oe.slice(0,re)),z.count+=oe.length;for(const Q of ce)if(Q.isDirectory()){if(F.includes(Q.name)||await M(k,(0,R.join)(O,Q.name),F,z),--re===0){J();return}}else{const K=Q.name.lastIndexOf(".");if(K>=0){const V=Q.name.substring(K+1);V&&l.set(V,(l.get(V)??0)+1)}for(const V of n)V.relativePathPattern?.test(Y)!==!1&&V.filePattern.test(Q.name)&&S.set(V.tag,(S.get(V.tag)??0)+1);if(--re===0){J();return}}})}const P=L.Promises.withAsyncBody(async k=>{const O={count:0,maxReached:!1};await M(i,i,o,O);const F=await E(i);k({configFiles:f(S),fileTypes:f(l),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:F})});return v.set(s,P),P}e.collectWorkspaceStats=m;function f(i){return Array.from(i.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function d(){const i={os:`${C.type()} ${C.arch()} ${C.release()}`,memory:`${(C.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(C.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.virtualMachineHint.value()*100)}%`},o=C.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.getMachineInfo=d;async function E(i){try{const o=new Map,s=(0,R.join)(i,".vscode","launch.json"),t=await g.Promises.readFile(s),n=[],l=(0,r.parse)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${s}`),[];if((0,r.getNodeType)(l)==="object"&&l.configurations)for(const S of l.configurations){const D=S.type;D&&(o.has(D)?o.set(D,o.get(D)+1):o.set(D,1))}return f(o)}catch{return[]}}e.collectLaunchConfigs=E;let c=class{constructor(o,s){this.telemetryService=o,this.productService=s}formatMachineInfo(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}formatEnvironment(o){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${C.type()} ${C.arch()} ${C.release()}`);const t=C.cpus();return t&&t.length>0&&s.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),s.push(`Memory (System):  ${(C.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(C.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||s.push(`Load (avg):       ${C.loadavg().map(n=>Math.round(n)).join(", ")}`),s.push(`VM:               ${Math.round(a.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,w.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async t=>{let[n,l]=t,S=this.formatProcessList(o,n);return s.forEach(D=>{if((0,y.isRemoteDiagnosticError)(D))S+=`
${D.errorMessage}`,l+=`
${D.errorMessage}`;else if(S+=`

Remote: ${D.hostName}`,D.processes&&(S+=`
${this.formatProcessList(o,D.processes)}`),D.workspaceMetadata){l+=`
|  Remote: ${D.hostName}`;for(const M of Object.keys(D.workspaceMetadata)){const P=D.workspaceMetadata[M];let k=`${P.fileCount} files`;P.maxFilesReached&&(k=`more than ${k}`),l+=`|    Folder (${M}): ${k}`,l+=this.formatWorkspaceStats(P)}}}),{processInfo:S,workspaceInfo:l}})}async getSystemInfo(o,s){const{memory:t,vmHint:n,os:l,cpus:S}=d(),D={os:l,memory:t,cpus:S,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return I.isWindows||(D.load=`${C.loadavg().map(M=>Math.round(M)).join(", ")}`),I.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(o,s){const t=[];return(0,w.listProcesses)(o.mainPID).then(async n=>(t.push(""),t.push(this.formatEnvironment(o)),t.push(""),t.push(this.formatProcessList(o,n)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(o))),s.forEach(l=>{if((0,y.isRemoteDiagnosticError)(l))t.push(`
${l.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${l.hostName}`),t.push(this.formatMachineInfo(l.machineInfo)),l.processes&&t.push(this.formatProcessList(o,l.processes)),l.workspaceMetadata)for(const S of Object.keys(l.workspaceMetadata)){const D=l.workspaceMetadata[S];let M=`${D.fileCount} files`;D.maxFilesReached&&(M=`more than ${M}`),t.push(`Folder (${S}): ${M}`),t.push(this.formatWorkspaceStats(D))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(o){const s=[];let n=0;const l=(P,k)=>{const O=` ${P}(${k})`;n+O.length>60?(s.push(S),S="|                 ",n=S.length):n+=O.length,S+=O};let S="|      File types:";const D=10,M=o.fileTypes.length>D?D:o.fileTypes.length;for(let P=0;P<M;P++){const k=o.fileTypes[P];l(k.name,k.count)}if(s.push(S),o.configFiles.length>=0&&(S="|      Conf files:",n=0,o.configFiles.forEach(P=>{l(P.name,P.count)}),s.push(S)),o.launchConfigFiles.length>0){let P="|      Launch Configs:";o.launchConfigFiles.forEach(k=>{const O=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;P+=O}),s.push(P)}return s.join(`
`)}expandGPUFeatures(o){const s=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(s-t.length)}  ${o[t]}`).join(`
                  `)}formatWorkspaceMetadata(o){const s=[],t=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(s.push(`|  Window (${n.title})`),n.folderURIs.forEach(l=>{const S=u.URI.revive(l);if(S.scheme===A.Schemas.file){const D=S.fsPath;t.push(m(D,["node_modules",".git"]).then(M=>{let P=`${M.fileCount} files`;M.maxFilesReached&&(P=`more than ${P}`),s.push(`|    Folder (${(0,R.basename)(D)}): ${P}`),s.push(this.formatWorkspaceStats(M))}).catch(M=>{s.push(`|      Error: Unable to collect workspace stats for folder ${D} (${M.toString()})`)}))}else s.push(`|    Folder (${S.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>s.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(o,s){const t=new Map;o.windows.forEach(l=>t.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:S})=>t.set(l,S));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(o.mainPID,t,n,s,0),n.join(`
`)}formatProcessItem(o,s,t,n,l){const S=l===0;let D;S?D=n.pid===o?`${this.productService.applicationName} main`:"remote agent":s.has(n.pid)?D=s.get(n.pid):D=`${"  ".repeat(l)} ${n.name}`;const M=process.platform==="win32"?n.mem:C.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(M/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(n.children)&&n.children.forEach(P=>this.formatProcessItem(o,s,t,P,l+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:t}of o.folders){const n=u.URI.revive(t);if(n.scheme!==A.Schemas.file)continue;const l=n.fsPath;try{(await m(l,["node_modules",".git"])).fileTypes.forEach(D=>s.add(D.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const t=u.URI.revive(s);if(t.scheme!==A.Schemas.file)continue;const n=t.fsPath;try{const l=await m(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})}),l.launchConfigFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})}),l.configFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})})}catch{}}}};e.DiagnosticsService=c,e.DiagnosticsService=c=Pe([te(0,p.ITelemetryService),te(1,b.IProductService)],c)}),define(ie[251],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class C{constructor(A){this.appenders=A}listen(A,R){throw new Error(`Event not found: ${R}`)}call(A,R,{eventName:I,data:u}){return this.appenders.forEach(a=>a.log(I,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=C;class L{constructor(A){this.channel=A}log(A,R){return this.channel.call("log",{eventName:A,data:R}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ie[51],ne([0,1,37,12,3,18,58,122,26]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=a;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=g,e.NullTelemetryService=new g;class w{async publicLog(n,l,S){}async publicLogError(n,l,S){}}e.NullEndpointTelemetryService=w,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,n){return r.Event.debounce(n.onDidChangeConfiguration,(S,D)=>{const M=S?new Set([...S.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:M}},1e3,!0)(S=>{S.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.configurationTelemetry=y;function h(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.supportsTelemetry=h;function b(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=b;function p(t){const n=t.getValue(u.TELEMETRY_SETTING_ID),l=t.getValue(u.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(u.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function v(t){const n={},l={},S={};d(t,S);for(let D in S){D=D.length>150?D.substr(D.length-149):D;const M=S[D];typeof M=="number"?l[D]=M:typeof M=="boolean"?l[D]=M?1:0:typeof M=="string"?(M.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${M.length}`),n[D]=M.substring(0,8191)):typeof M<"u"&&M!==null&&(n[D]=M)}return{properties:n,measurements:l}}e.validateTelemetryData=v;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(t){if(!t)return"none";const n=(0,R.getRemoteName)(t);return m.has(n)?n:"other"}e.cleanRemoteAuthority=f;function d(t,n,l=0,S){if(t)for(const D of Object.getOwnPropertyNames(t)){const M=t[D],P=S?S+D:D;Array.isArray(M)?n[P]=(0,C.safeStringify)(M):M instanceof Date?n[P]=M.toISOString():(0,L.isObject)(M)?l<2?d(M,n,l+1,P+"."):n[P]=(0,C.safeStringify)(M):n[P]=M}}function E(t,n){const l=t.msftInternalDomains||[],S=n.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(l)||S}e.isInternalTelemetry=E;function c(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=c;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let l=t;const S=[];for(const k of n)for(;;){const O=k.exec(t);if(!O)break;S.push([O.index,k.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,M=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(l="";;){const k=M.exec(t);if(!k)break;const O=S.some(([F,z])=>k.index<z&&F<M.lastIndex);!D.test(k[0])&&!O&&(l+=t.substring(P,k.index)+"<REDACTED: user-file-path>",P=M.lastIndex)}return P<t.length&&(l+=t.substr(P)),l}function o(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of n)if(l.regex.test(t))return`<REDACTED: ${l.label}>`;return t}function s(t,n){return(0,C.cloneAndChange)(t,l=>{if(l instanceof a||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let S=l.replaceAll("%20"," ");S=i(S,n);for(const D of n)S=S.replace(D,"");return S=o(S),S}})}e.cleanData=s}),define(ie[123],ne([0,1,27,117,120,4,7,14,35,51]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function g(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,C.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=g;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const n=t.manifest?t.manifest.version:t.version,l=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,n,l)}static parse(t){const n=w.exec(t);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,l="undefined"){this.version=n,this.targetPlatform=l,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?g(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=y;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(s){const t=h.exec(s);return t&&t[1]?[v(t[1]),t[2]]:[v(s),void 0]}e.getIdAndVersion=b;function p(s,t){return`${s}.${t}`}e.getExtensionId=p;function v(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=v;function m(s,t){return v(p(s??r.UNDEFINED_PUBLISHER,t))}e.getGalleryExtensionId=m;function f(s,t){const n=[],l=S=>{for(const D of n)if(D.some(M=>g(t(M),t(S))))return D;return null};for(const S of s){const D=l(S);D?D.push(S):n.push([S])}return n}e.groupByExtension=f;function d(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function E(s){return{id:new a.TelemetryTrustedValue(s.identifier.id),name:new a.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function c(s,t){const n=[],l=t.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const S=l.shift();if(S&&n.every(D=>!g(D.identifier,{id:S}))){const D=s.filter(M=>g(M.identifier,{id:S}));D.length===1&&(n.push(D[0]),l.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=c;async function i(s,t){if(!A.isLinux)return!1;let n;try{n=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(S))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,t){const n=await i(s,t),l=(0,L.getTargetPlatform)(n?"alpine":A.platform,u.arch);return t.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=o}),define(ie[252],ne([0,1,206,51]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(A,R,I,u,a,g,w){const y={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,L.supportsTelemetry)(R,I)&&(0,L.getTelemetryLevel)(u)===3){const h=await(0,C.getServiceMachineId)(I,a,g);y["X-Market-User-Id"]=h,y["VSCode-SessionId"]=w.machineId||h}return y}e.resolveMarketplaceHeaders=r}),define(ie[253],ne([0,1,2,37,4,27,185,18,57,79,25,43,26,51]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,f,d){this._configurationService=f,this._productService=d,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.TELEMETRY_SETTING_ID)||E.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(m,f){this._experimentProperties[m]=f}_updateTelemetryLevel(){let m=(0,h.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const d=f.usage?3:f.error?2:0;m=Math.min(m,d)}this._telemetryLevel=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(m,f,d){this._telemetryLevel<f||(d=(0,L.mixin)(d,this._experimentProperties),d=(0,h.cleanData)(d,this._cleanupPatterns),d=(0,L.mixin)(d,this._commonProperties),this._appenders.forEach(E=>E.log(m,d)))}publicLog(m,f){this._log(m,3,f)}publicLog2(m,f){this.publicLog(m,f)}publicLogError(m,f){this._sendErrorTelemetry&&this._log(m,2,f)}publicLogError2(m,f){this.publicLogError(m,f)}};e.TelemetryService=b,e.TelemetryService=b=Pe([te(1,I.IConfigurationService),te(2,g.IProductService)],b);function p(){const v=(0,R.localize)(0,null,a.default.nameLong),m=a.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=r.isWeb?"":(0,R.localize)(3,null),d=(0,R.localize)(4,null),E=(0,R.localize)(5,null),c=(0,R.localize)(6,null),i=(0,R.localize)(7,null),o=`
|       | ${d} | ${E} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,R.localize)(8,null);return`
${v} ${m} ${f}

&nbsp;

${i}
${o}

&nbsp;

${s}
`}w.Registry.as(u.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:p(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(u.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,R.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,R.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[254],ne([0,1,4,88,26]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function A(I,u){let a=I.getItem(r.machineIdKey);return(typeof a!="string"||C.isMacintosh&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,L.getMachineId)(u.error.bind(u))),a}e.resolveMachineId=A;async function R(I,u){let a=I.getItem(r.sqmIdKey);return typeof a!="string"&&(a=await(0,L.getSqmMachineId)(u.error.bind(u))),a}e.resolveSqmId=R}),define(ie[255],ne([0,1,26,254]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function r(R,I){const u=await(0,L.resolveMachineId)(R,I);return R.setItem(C.machineIdKey,u),u}e.resolveMachineId=r;async function A(R,I){const u=await(0,L.resolveSqmId)(R,I);return R.setItem(C.sqmIdKey,u),u}e.resolveSqmId=A}),define(ie[124],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var C;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(C||(e.EnvironmentVariableMutatorType=C={}))}),define(ie[256],ne([0,1,4,124]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const r=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(g){this.collections=g,this.map=new Map,this.descriptionMap=new Map,g.forEach((w,y)=>{this.populateDescriptionMap(w,y);const h=w.map.entries();let b=h.next();for(;!b.done;){const p=b.value[1],v=b.value[0];let m=this.map.get(v);if(m||(m=[],this.map.set(v,m)),m.length>0&&m[0].type===L.EnvironmentVariableMutatorType.Replace){b=h.next();continue}const f={extensionIdentifier:y,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};f.scope||delete f.scope,m.unshift(f),b=h.next()}})}async applyToProcessEnvironment(g,w,y){let h;C.isWindows&&(h={},Object.keys(g).forEach(b=>h[b.toLowerCase()]=b));for(const[b,p]of this.getVariableMap(w)){const v=C.isWindows&&h[b.toLowerCase()]||b;for(const m of p){const f=y?await y(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case L.EnvironmentVariableMutatorType.Append:g[v]=(g[v]||"")+f;break;case L.EnvironmentVariableMutatorType.Prepend:g[v]=f+(g[v]||"");break;case L.EnvironmentVariableMutatorType.Replace:g[v]=f;break}if(m.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${r.get(m.type)}`;g[d]=(g[d]?g[d]+":":"")+b+"="+this._encodeColons(f)}}}}_encodeColons(g){return g.replaceAll(":","\\x3a")}diff(g,w){const y=new Map,h=new Map,b=new Map;if(g.getVariableMap(w).forEach((p,v)=>{const m=this.getVariableMap(w).get(v),f=I(p,m);f&&y.set(v,f)}),this.getVariableMap(w).forEach((p,v)=>{const m=g.getVariableMap(w).get(v),f=I(p,m);f&&b.set(v,f)}),this.getVariableMap(w).forEach((p,v)=>{const m=g.getVariableMap(w).get(v),f=u(p,m);f&&h.set(v,f)}),!(y.size===0&&h.size===0&&b.size===0))return{added:y,changed:h,removed:b}}getVariableMap(g){const w=new Map;for(const y of this.map.values()){const h=y.filter(b=>R(b,g));h.length>0&&w.set(h[0].variable,h)}return w}getDescriptionMap(g){const w=new Map;for(const y of this.descriptionMap.values()){const h=y.filter(b=>R(b,g,!0));for(const b of h)w.set(b.extensionIdentifier,b.description)}return w}populateDescriptionMap(g,w){if(!g.descriptionMap)return;const y=g.descriptionMap.entries();let h=y.next();for(;!h.done;){const b=h.value[1],p=h.value[0];let v=this.descriptionMap.get(p);v||(v=[],this.descriptionMap.set(p,v));const m={extensionIdentifier:w,scope:b.scope,description:b.description};m.scope||delete m.scope,v.push(m),h=y.next()}}}e.MergedEnvironmentVariableCollection=A;function R(a,g,w=!1){return a.scope?!!(a.scope.workspaceFolder&&g?.workspaceFolder&&a.scope.workspaceFolder.index===g.workspaceFolder.index):w?g===a.scope:!0}function I(a,g){if(!g)return a;const w=new Set;g.forEach(h=>w.add(h.extensionIdentifier));const y=[];return a.forEach(h=>{w.has(h.extensionIdentifier)||y.push(h)}),y.length===0?void 0:y}function u(a,g){if(!g)return;const w=new Map;g.forEach(h=>w.set(h.extensionIdentifier,h));const y=[];return a.forEach(h=>{const b=w.get(h.extensionIdentifier);b&&(h.type!==b.type||h.value!==b.value||h.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index)&&y.push(b)}),y.length===0?void 0:y}}),define(ie[257],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function C(u){return[...u.entries()]}e.serializeEnvironmentVariableCollection=C;function L(u){return u?[...u.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function r(u){return new Map(u)}e.deserializeEnvironmentVariableCollection=r;function A(u){return new Map(u??[])}e.deserializeEnvironmentDescriptionMap=A;function R(u){return Array.from(u.entries()).map(a=>[a[0],C(a[1].map),L(a[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=R;function I(u){return new Map(u.map(a=>[a[0],{map:r(a[1]),descriptionMap:A(a[2])}]))}e.deserializeEnvironmentVariableCollections=I}),define(ie[258],ne([0,1,8,22,3,2,6]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends A.Disposable{constructor(a,g){super(),this._logService=g,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new r.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=a===void 0?15e3:a,this._register((0,A.toDisposable)(()=>{for(const w of this._pendingRequestDisposables.values())(0,A.dispose)(w)}))}createRequest(a){return new Promise((g,w)=>{const y=++this._lastRequestId;this._pendingRequests.set(y,g),this._onCreateRequest.fire({requestId:y,...a});const h=new L.CancellationTokenSource;(0,C.timeout)(this._timeout,h.token).then(()=>w(`Request ${y} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(y,[(0,A.toDisposable)(()=>h.cancel())])})}acceptReply(a,g){const w=this._pendingRequests.get(a);w?(this._pendingRequests.delete(a),(0,A.dispose)(this._pendingRequestDisposables.get(a)||[]),this._pendingRequestDisposables.delete(a),w(g)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.RequestStore=I,e.RequestStore=I=Pe([te(1,R.ILogService)],I)}),define(ie[125],ne([0,1,5,114,43]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var A;(function(c){c.AutomationProfile="terminal.integrated.automationProfile.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var R;(function(c){c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.TabStopWidth="terminal.integrated.tabStopWidth",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorStyleInactive="terminal.integrated.cursorStyleInactive",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.TabFocusMode="terminal.integrated.tabFocusMode",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.HideOnStartup="terminal.integrated.hideOnStartup",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",c.EnableImages="terminal.integrated.enableImages",c.SmoothScrolling="terminal.integrated.smoothScrolling",c.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",c.FocusAfterRun="terminal.integrated.focusAfterRun",c.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",c.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",c.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",c.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var I;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(I||(e.PosixShellType=I={}));var u;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(u||(e.WindowsShellType=u={}));var a;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var g;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.PtyHostWindow="ptyHostWindow",c.Logger="logger",c.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var w;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.IPtyService=(0,C.createDecorator)("ptyService");var y;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var h;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var b;(function(c){c.TerminalView="view",c.Editor="editor"})(b||(e.TerminalLocationString=b={}));var p;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var v;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var m;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var f;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var d;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(i){const o=this._sanitizeRemoteAuthority(i.remoteAuthority);if(this._backends.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this._backends.set(o,i)}getTerminalBackend(i){return this._backends.get(this._sanitizeRemoteAuthority(i))}_sanitizeRemoteAuthority(i){return i?.toLowerCase()??""}}r.Registry.add(e.TerminalExtensions.Backend,new E),e.ILocalPtyService=(0,C.createDecorator)("localPtyService"),e.ITerminalLogService=(0,C.createDecorator)("terminalLogService")}),define(ie[259],ne([0,1,74,7,187,102]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function R(y,h){const b=[{name:null,description:(0,r.localize)(0,null)}];return b.push(...y.map(p=>({name:p.profileName,description:I(p)}))),h&&b.push(...h.map(p=>({name:p.title,description:u(p)}))),{values:b.map(p=>p.name),markdownDescriptions:b.map(p=>p.description)}}e.createProfileSchemaEnums=R;function I(y){let h=`$(${A.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:C.Codicon.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?h+=`
- args: "${y.args}"`:h+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(h+=`
- overrideName: ${y.overrideName}`),y.color&&(h+=`
- color: ${y.color}`),y.env&&(h+=`
- env: ${JSON.stringify(y.env)}`),h}function u(y){return`$(${A.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:C.Codicon.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function a(y,h){if(!y&&!h)return!0;if(typeof y=="string"&&typeof h=="string")return y===h;if(Array.isArray(y)&&Array.isArray(h)){if(y.length!==h.length)return!1;for(let b=0;b<y.length;b++)if(y[b]!==h[b])return!1;return!0}return!1}e.terminalProfileArgsMatch=a;function g(y,h){if(!y&&!h)return!0;if(!y||!h)return!1;if(A.ThemeIcon.isThemeIcon(y)&&A.ThemeIcon.isThemeIcon(h))return y.id===h.id&&y.color===h.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof h=="object"&&"light"in h&&"dark"in h){const b=y,p=h;if((L.URI.isUri(b.light)||w(b.light))&&(L.URI.isUri(b.dark)||w(b.dark))&&(L.URI.isUri(p.light)||w(p.light))&&(L.URI.isUri(p.dark)||w(p.dark)))return b.light.path===p.light.path&&b.dark.path===p.dark.path}if(L.URI.isUri(y)&&L.URI.isUri(h)||w(y)||w(h)){const b=y,p=h;return b.path===p.path&&b.scheme===p.scheme}return!1}e.terminalIconsEqual=g;function w(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.isUriComponents=w}),define(ie[260],ne([0,1,74,4,186,57,43,259]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,C.getAllCodicons)(),v=>v.id),markdownEnumDescriptions:Array.from((0,C.getAllCodicons)(),v=>`$(${v.id})`)};const u={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...u}},g={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...u}};function w(v){const m=v===2?"linux":v===1?"osx":"windows";return(0,r.localize)(7,null,(0,L.PlatformToString)(v),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...u}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){R.Registry.as(A.Extensions.Configuration).registerConfiguration(y),p()}e.registerTerminalPlatformConfiguration=h;let b;function p(v,m){const f=R.Registry.as(A.Extensions.Configuration);let d;v&&(d=(0,I.createProfileSchemaEnums)(v?.profiles,m));const E=b;b={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:v?.os===3?d?.values:void 0,markdownEnumDescriptions:v?.os===3?d?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:v?.os===2?d?.values:void 0,markdownEnumDescriptions:v?.os===2?d?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:v?.os===1?d?.values:void 0,markdownEnumDescriptions:v?.os===1?d?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[b],remove:E?[E]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(ie[261],ne([0,1,28,13,37,9,4,35,27,12,21,124,257,256]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(C.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.getWindowsBuildNumber=b;async function p(t,n,l,S=I.env,D=g.Promises.exists){if(A.isAbsolute(t))return await D(t)?t:void 0;if(n===void 0&&(n=I.cwd()),A.dirname(t)!=="."){const O=A.join(n,t);return await D(O)?O:void 0}const P=(0,r.getCaseInsensitive)(S,"PATH");if(l===void 0&&(0,a.isString)(P)&&(l=P.split(A.delimiter)),l===void 0||l.length===0){const O=A.join(n,t);return await D(O)?O:void 0}for(const O of l){let F;if(A.isAbsolute(O)?F=A.join(O,t):F=A.join(n,O,t),await D(F))return F;if(R.isWindows){let z=F+".com";if(await D(z)||(z=F+".exe",await D(z)))return z}}const k=A.join(n,t);return await D(k)?k:void 0}e.findExecutable=p;function v(t,n,l,S,D){const M=R.isWindows&&(!n.windowsEnableConpty||b()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||M)return;const P=t.args,k=I.platform==="win32"?A.basename(t.executable).toLowerCase():A.basename(t.executable),O=A.dirname(L.FileAccess.asFileUri("").fsPath);let F;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),R.isWindows){if(k==="pwsh.exe"||k==="powershell.exe")return!P||o(P)?F=d.get(f.WindowsPwsh):i(P)&&(F=d.get(f.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,u.format)(F[F.length-1],O,""),{newArgs:F,envMixin:z}):void 0;S.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(k){case"bash":return!P||P.length===0?F=d.get(f.Bash):s(P)&&(z.VSCODE_SHELL_LOGIN="1",m(n,z),F=d.get(f.Bash)),F?(F=[...F],F[F.length-1]=(0,u.format)(F[F.length-1],O),{newArgs:F,envMixin:z}):void 0;case"fish":{const Y=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=A.join(O,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${Y}:${J}`,m(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!P||o(P)?F=d.get(f.Pwsh):i(P)&&(F=d.get(f.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,u.format)(F[F.length-1],O,""),{newArgs:F,envMixin:z}):void 0;case"zsh":{if(!P||P.length===0?F=d.get(f.Zsh):s(P)?(F=d.get(f.ZshLogin),m(n,z)):(P===d.get(f.Zsh)||P===d.get(f.ZshLogin))&&(F=P),!F)return;F=[...F],F[F.length-1]=(0,u.format)(F[F.length-1],O);let Y;try{Y=C.userInfo().username}catch{Y="unknown"}const J=A.join(C.tmpdir(),`${Y}-${D.applicationName}-zsh`);z.ZDOTDIR=J;const oe=l?.ZDOTDIR??C.homedir()??"~";z.USER_ZDOTDIR=oe;const re=[];return re.push({source:A.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(J,".zshrc")}),re.push({source:A.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(J,".zprofile")}),re.push({source:A.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(J,".zshenv")}),re.push({source:A.join(O,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(J,".zlogin")}),{newArgs:F,envMixin:z,filesToCopy:re}}}S.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.getShellIntegrationInjection=v;function m(t,n){if(R.isMacintosh&&t.environmentVariableCollections){const l=(0,y.deserializeEnvironmentVariableCollections)(t.environmentVariableCollections),D=new h.MergedEnvironmentVariableCollection(l).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),M=[];if(D)for(const P of D)P.type===w.EnvironmentVariableMutatorType.Prepend&&M.push(P.value);M.length>0&&(n.VSCODE_PATH_PREFIX=M.join(""))}}var f;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(f||(f={}));const d=new Map;d.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(f.Zsh,["-i"]),d.set(f.ZshLogin,["-il"]),d.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],c=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(c.includes(t[0].toLowerCase())||c.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?c.includes(t.toLowerCase()):t.length===0||t?.length===1&&c.includes(t[0].toLowerCase())}function s(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(ie[262],ne([0,1,47,74,9,4,12,21,106,261,113]),function(G,e,C,L,r,A,R,I,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let w,y=!0;function h(n,l,S,D,M=process.env,P,k,O,F){return P=P||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},A.isWindows?b(S,P,M,k,D.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:D.getValue("terminal.integrated.profiles.windows"),typeof l=="string"?l:D.getValue("terminal.integrated.defaultProfile.windows"),F,O):o(P,k,S,n&&typeof n=="object"?{...n}:D.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof l=="string"?l:D.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,O,M)}e.detectAvailableProfiles=h;async function b(n,l,S,D,M,P,k,O,F){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let J=!1;(0,a.getWindowsBuildNumber)()>=16299&&(J=!0),await f(O);const oe=new Map;if(n){oe.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),oe.set("Windows PowerShell",{path:`${Y}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),oe.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),oe.set("Command Prompt",{path:`${Y}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),oe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),oe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const ce=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;oe.set("Cmder",{path:`${Y}\\cmd.exe`,args:["/K",ce],requiresPath:process.env.CMDER_ROOT?ce:{path:ce,isUnsafe:!0},isAutoDetected:!0})}s(P,oe);const re=await p(oe.entries(),k,l,S,D,F);if(n&&M)try{const ce=await c(`${Y}\\${J?"wsl":"bash"}.exe`,k);for(const Q of ce)(!P||!(Q.profileName in P))&&re.push(Q)}catch{y&&(D?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return re}async function p(n,l,S,D=process.env,M,P){const k=[];for(const[O,F]of n)k.push(v(O,F,l,S,D,M,P));return(await Promise.all(k)).filter(O=>!!O)}async function v(n,l,S,D,M=process.env,P,k){if(l===null)return;let O,F,z;if("source"in l&&!("path"in l)){const re=w?.get(l.source);if(!re)return;O=re.paths,F=l.args||re.args,l.icon?z=m(l.icon):re.icon&&(z=re.icon)}else O=Array.isArray(l.path)?l.path:[l.path],F=A.isWindows||Array.isArray(l.args)?l.args:void 0,z=m(l.icon);let Y;if(k){const re=O.map(Q=>typeof Q=="string"?Q:Q.path),ce=await k(re);Y=new Array(O.length);for(let Q=0;Q<O.length;Q++)typeof O[Q]=="string"?Y[Q]=ce[Q]:Y[Q]={path:ce[Q],isUnsafe:!0}}else Y=O.slice();let J;if(l.requiresPath){let re;if((0,R.isString)(l.requiresPath)?re=l.requiresPath:(re=l.requiresPath.path,l.requiresPath.isUnsafe&&(J=re)),!await D.existsFile(re))return}const oe=await t(n,S,Y,D,M,F,l.env,l.overrideName,l.isAutoDetected,J);if(!oe){P?.debug("Terminal profile not validated",n,O);return}return oe.isAutoDetected=l.isAutoDetected,oe.icon=z,oe.color=l.color,oe}function m(n){return typeof n=="string"?{id:n}:n}async function f(n){if(w&&!n)return;const[l,S]=await Promise.all([d(),n||E()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:l,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:S,icon:L.Codicon.terminalPowershell})}async function d(){const n=new Set,l=await(0,a.findExecutable)("git.exe");if(l){const M=(0,g.dirname)(l);n.add((0,g.resolve)(M,"../.."))}function S(M,P){P&&M.add(P)}S(n,process.env.ProgramW6432),S(n,process.env.ProgramFiles),S(n,process.env["ProgramFiles(X86)"]),S(n,`${process.env.LocalAppData}\\Program`);const D=[];for(const M of n)D.push(`${M}\\Git\\bin\\bash.exe`,`${M}\\Git\\usr\\bin\\bash.exe`,`${M}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function E(){const n=[];for await(const l of(0,u.enumeratePowerShellInstallations)())n.push(l.exePath);return n}async function c(n,l){const S=[],D=await new Promise((k,O)=>{C.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,z)=>{if(F)return O("Problem occurred when getting wsl distros");k(z)})});if(!D)return[];const M=new RegExp(/[\r?\n]/),P=D.split(M).filter(k=>k.trim().length>0&&k!=="");for(const k of P){if(k===""||k.startsWith("docker-desktop"))continue;const O=`${k} (WSL)`,F={profileName:O,path:n,args:["-d",`${k}`],isDefault:O===l,icon:i(k),isAutoDetected:!1};S.push(F)}return S}function i(n){return n.includes("Ubuntu")?L.Codicon.terminalUbuntu:n.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function o(n,l,S,D,M,P,k,O){const F=new Map;if(S){const z=(await n.readFile("/etc/shells")).toString(),Y=(P||z.split(`
`)).map(oe=>{const re=oe.indexOf("#");return re===-1?oe:oe.substring(0,re)}).filter(oe=>oe.trim().length>0),J=new Map;for(const oe of Y){let re=(0,r.basename)(oe),ce=J.get(re)||0;ce++,ce>1&&(re=`${re} (${ce})`),J.set(re,ce),F.set(re,{path:oe,isAutoDetected:!0})}}return s(D,F),await p(F.entries(),M,n,O,l,k)}function s(n,l){if(n)for(const[S,D]of Object.entries(n))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?l.delete(S):(D.icon=D.icon||l.get(S)?.icon,l.set(S,D))}async function t(n,l,S,D,M,P,k,O,F,z){if(S.length===0)return Promise.resolve(void 0);const Y=S.shift();if(Y==="")return t(n,l,S,D,M,P,k,O,F);const J=typeof Y!="string"&&Y.isUnsafe,oe=typeof Y=="string"?Y:Y.path,re={profileName:n,path:oe,args:P,env:k,overrideName:O,isAutoDetected:F,isDefault:n===l,isUnsafePath:J,requiresUnsafePath:z};if((0,r.basename)(oe)===oe){const Q=M.PATH?M.PATH.split(r.delimiter):void 0,K=await(0,a.findExecutable)(oe,void 0,Q,void 0,D.existsFile);return K?(re.path=K,re.isFromPath=!0,re):t(n,l,S,D,M,P)}return await D.existsFile((0,r.normalize)(oe))?re:t(n,l,S,D,M,P,k,O,F)}}),define(ie[263],ne([0,1,3,2,4,42,18,6,226,94,258,125,260,262,108,72]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var v;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let m=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(d,E,c,i){super(),this._ptyHostStarter=d,this._configurationService=E,this._logService=c,this._loggerService=i,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new C.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new C.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new C.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new C.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new C.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new C.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new C.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new C.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new C.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new C.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new C.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new C.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new g.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&C.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(r.isWindows)return process.env;try{return await(0,a.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(d){return this._logService.error("ptyHost was unable to resolve shell environment",d),{}}}_startPtyHost(){const d=this._ptyHostStarter.start(),E=d.client;this._logService.getLevel()===I.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),A.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(d.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=v.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const i=A.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this._register(i.onProcessData(o=>this._onProcessData.fire(o))),this._register(i.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(i.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(i.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(i.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(i.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(i.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),this._register(new u.RemoteLoggerChannelClient(this._loggerService,E.getChannel(w.TerminalIpcChannels.Logger))),this.__connection=d,this.__proxy=i,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[d,i]}async createProcess(d,E,c,i,o,s,t,n,l,S,D){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),w.HeartbeatConstants.CreateProcessTimeout),P=await this._proxy.createProcess(d,E,c,i,o,s,t,n,l,S,D);return clearTimeout(M),P}updateTitle(d,E,c){return this._proxy.updateTitle(d,E,c)}updateIcon(d,E,c,i){return this._proxy.updateIcon(d,E,c,i)}attachToProcess(d){return this._proxy.attachToProcess(d)}detachFromProcess(d,E){return this._proxy.detachFromProcess(d,E)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(d){return this._proxy.start(d)}shutdown(d,E){return this._proxy.shutdown(d,E)}input(d,E){return this._proxy.input(d,E)}processBinary(d,E){return this._proxy.processBinary(d,E)}resize(d,E,c){return this._proxy.resize(d,E,c)}clearBuffer(d){return this._proxy.clearBuffer(d)}acknowledgeDataEvent(d,E){return this._proxy.acknowledgeDataEvent(d,E)}setUnicodeVersion(d,E){return this._proxy.setUnicodeVersion(d,E)}getInitialCwd(d){return this._proxy.getInitialCwd(d)}getCwd(d){return this._proxy.getCwd(d)}async getLatency(){const d=new p.StopWatch,E=await this._proxy.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...E]}orphanQuestionReply(d){return this._proxy.orphanQuestionReply(d)}installAutoReply(d,E){return this._proxy.installAutoReply(d,E)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(d){return this._proxy.uninstallAutoReply(d)}getDefaultSystemShell(d){return this._optionalProxy?.getDefaultSystemShell(d)??(0,b.getSystemShell)(d??r.OS,process.env)}async getProfiles(d,E,c,i=!1){const o=await this._resolveShellEnv();return(0,h.detectAvailableProfiles)(E,c,i,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,d))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(d,E){return this._proxy.getWslPath(d,E)}getRevivedPtyNewId(d,E){return this._proxy.getRevivedPtyNewId(d,E)}setTerminalLayoutInfo(d){return this._proxy.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this._optionalProxy?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,E){return this._proxy.requestDetachInstance(d,E)}async acceptDetachInstanceReply(d,E){return this._proxy.acceptDetachInstanceReply(d,E)}async freePortKillProcess(d){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(d)}async serializeTerminalState(d){return this._proxy.serializeTerminalState(d)}async reviveTerminalProcesses(d,E,c){return this._proxy.reviveTerminalProcesses(d,E,c)}async refreshProperty(d,E){return this._proxy.refreshProperty(d,E)}async updateProperty(d,E,c){return this._proxy.updateProperty(d,E,c)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(d){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(d,E){return this._resolveVariablesRequestStore.createRequest({workspaceId:d,originalText:E})}async acceptPtyHostResolvedVariables(d,E){this._resolveVariablesRequestStore.acceptReply(d,E)}};e.PtyHostService=m,e.PtyHostService=m=Pe([te(1,R.IConfigurationService),te(2,I.ILogService),te(3,I.ILoggerService)],m)}),define(ie[67],ne([0,1,15,3,2,4,18,5,34]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const a="#FFFFFF",g="#1E1E1E",w="#000000",y="#FFFFFF",h="theme",b="themeBackground",p="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let v=class extends r.Disposable{constructor(f,d){super(),this.stateService=f,this.configurationService=d,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,C.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(A.isWindows){if(C.nativeTheme.shouldUseHighContrastColors)return{dark:C.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(C.nativeTheme.shouldUseInvertedColorScheme||C.nativeTheme.shouldUseHighContrastColors)return{dark:C.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&C.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:C.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return f.dark?w:y;let d=this.stateService.getItem(b,null);if(!d)switch(this.stateService.getItem(h,"vs-dark").split(" ")[0]){case"vs":d=a;break;case"hc-black":d=w;break;case"hc-light":d=y;break;default:d=g}return A.isMacintosh&&d.toUpperCase()===g&&(d="#171717"),d}saveWindowSplash(f,d){this.stateService.setItems([{key:h,data:d.baseTheme},{key:b,data:d.colorInfo.background},{key:p,data:d}]),typeof f=="number"&&this.updateBackgroundColor(f,d)}updateBackgroundColor(f,d){for(const E of C.BrowserWindow.getAllWindows())if(E.id===f){E.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(p)}};e.ThemeMainService=v,e.ThemeMainService=v=Pe([te(0,u.IStateService),te(1,R.IConfigurationService)],v)}),define(ie[126],ne([0,1,3,18,5,6]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var R;(function(v){v.Http="http",v.Https="https"})(R||(e.TunnelProtocol=R={}));var I;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(I||(e.TunnelPrivacyId=I={}));function u(v){return!!v.forwardPort}e.isTunnelProvider=u;var a;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function g(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=y;function h(v,m,f,d){if(f===1)return!1;if(f===2&&y(m)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(E?.length===4&&parseInt(E[1])>=18)return!1}return v<1024}e.isPortPrivileged=h;class b{constructor(m,f,d){this.remoteAddress=m,this.localAddress=f,this._dispose=d,this._onDispose=new C.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=b;let p=class{constructor(m,f){this.logService=m,this.configurationService=f,this._onTunnelOpened=new C.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new C.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new C.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],f=Array.from(this._tunnels.values());for(const d of f){const E=Array.from(d.values());for(const c of E){const i=await c.value;i&&typeof i!="string"&&m.push(i)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:f}of m.values())await f.then(d=>typeof d!="string"?d?.dispose():void 0);m.clear()}this._tunnels.clear()}setEnvironmentTunnel(m,f,d,E,c){this.addTunnelToMap(m,f,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:f,localAddress:d,privacy:E,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,f){(y(m)||w(m))&&(m=e.LOCALHOST_ADDRESSES[0]);const d=this.getTunnelFromMap(m,f);if(d)return++d.refcount,d.value}openTunnel(m,f,d,E,c,i=!1,o,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${d} on local port ${c}.`);const t=this._tunnelProvider??m;if(!t)return;if(f||(f="localhost"),E||(E=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(d)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(t,f,d,E,c,i,o,s);return n?n.then(l=>{if(l){if(typeof l=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(f,d),l}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(f,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.makeTunnel(l);return(l.tunnelRemoteHost!==f||l.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&l.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(S),S}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const f=this._tunnels.get(m.tunnelRemoteHost);if(f){const d=f.get(m.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,d))}}}}async tryDisposeTunnel(m,f,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${f}.`);const E=d.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(f),E}}async closeTunnel(m,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${f} `);const d=this._tunnels.get(m);if(d&&d.has(f)){const E=d.get(f);E.refcount=0,await this.tryDisposeTunnel(m,f,E)}}addTunnelToMap(m,f,d){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(f,{refcount:1,value:d})}async removeEmptyOrErrorTunnelFromMap(m,f){const d=this._tunnels.get(m);if(d){const E=d.get(f),c=E?await E.value:void 0;(!c||typeof c=="string")&&d.delete(f),d.size===0&&this._tunnels.delete(m)}}getTunnelFromMap(m,f){const d=[m];w(m)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):y(m)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const E=d.map(c=>this._tunnels.get(c));for(const c of E){const i=c?.get(f);if(i)return i}}canTunnel(m){return!!g(m)}createWithProvider(m,f,d,E,c,i,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${d} on local port ${E}.`);const s=d;this._factoryInProgress.add(s);const t=E===void 0?d:E,n={elevationRequired:c?this.isPortPrivileged(t):!1},l={remoteAddress:{host:f,port:d},localAddressPort:E,privacy:i,public:i?i!==I.Private:void 0,protocol:o},S=m.forwardPort(l,n);return S?(this.addTunnelToMap(f,d,S),S.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),S}};e.AbstractTunnelService=p,e.AbstractTunnelService=p=Pe([te(0,A.ILogService),te(1,L.IConfigurationService)],p)}),define(ie[48],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var L;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.Disabled="disabled",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(L||(e.StateType=L={}));var r;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap",R[R.WindowsInstaller=3]="WindowsInstaller"})(r||(e.UpdateType=r={}));var A;(function(R){R[R.NotBuilt=0]="NotBuilt",R[R.DisabledByEnvironment=1]="DisabledByEnvironment",R[R.ManuallyDisabled=2]="ManuallyDisabled",R[R.MissingConfiguration=3]="MissingConfiguration",R[R.InvalidConfiguration=4]="InvalidConfiguration",R[R.RunningAsAdmin=5]="RunningAsAdmin"})(A||(e.DisablementReason=A={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:R=>({type:"disabled",reason:R}),Idle:(R,I)=>({type:"idle",updateType:R,error:I}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,C.createDecorator)("updateService")}),define(ie[264],ne([0,1,4,188,57,43]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:C.isWindows&&!C.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[265],ne([0,1,3,48]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(I){this.service=I}listen(I,u){switch(u){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${u}`)}call(I,u,a){switch(u){case"checkForUpdates":return this.service.checkForUpdates(a);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(a)}throw new Error(`Call not found: ${u}`)}}e.UpdateChannel=r;class A{get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}constructor(I){this.channel=I,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(u=>this.state=u),this.channel.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(I){return this.channel.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=A}),define(ie[40],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(ie[266],ne([0,1,40,207,16,19,141,3,2]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(y){this._fileService=y,this._dispooables=new u.DisposableStore,this._limit=2**16;const h=new Map,b=p=>{let v=h.get(p.scheme);return v===void 0&&(v=y.hasProvider(p)&&!this._fileService.hasCapability(p,1024),h.set(p.scheme,v)),v};this._dispooables.add(I.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new A.ExtUri(b),this._canonicalUris=new R.SkipList((p,v)=>this.extUri.compare(p,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(y){this._fileService.hasProvider(y)&&(y=(0,A.normalizePath)(y));const h=this._canonicalUris.get(y);return h?h.touch().uri.with({fragment:y.fragment}):(this._canonicalUris.set(y,new a(y)),this._checkTrim(),y)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const y=[...this._canonicalUris.entries()].sort((b,p)=>b[1].time<p[1].time?1:b[1].time>p[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let b=0;b<h;b++)this._canonicalUris.set(y[b][0],y[b][1].touch())}};e.UriIdentityService=g,e.UriIdentityService=g=Pe([te(0,r.IFileService)],g),(0,L.registerSingleton)(C.IUriIdentityService,g,1)}),define(ie[127],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,C.createDecorator)("urlService")}),define(ie[267],ne([0,1,7]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(I){this.handler=I}listen(I,u){throw new Error(`Event not found: ${u}`)}call(I,u,a){switch(u){case"handleURL":return this.handler.handleURL(C.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${u}`)}}e.URLHandlerChannel=L;class r{constructor(I){this.channel=I}handleURL(I,u){return this.channel.call("handleURL",[I.toJSON(),u])}}e.URLHandlerChannelClient=r;class A{constructor(I,u){this.next=I,this.logService=u}async routeCall(I,u,a,g){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(a)&&a.length>0){const w=C.URI.revive(a[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const y=/\bwindowId=(\d+)/.exec(w.query);if(y){const h=y[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,w.toString(!0));const b=new RegExp(`window:${h}`),p=I.connections.find(v=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),b.test(v.ctx)));if(p)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),p;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(I,u,a,g)}routeEvent(I,u){throw new Error(`Event not found: ${u}`)}}e.URLHandlerRouter=A}),define(ie[268],ne([0,1,8,2,7,25]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(a,g){const w=[...this.handlers.values()];return(0,C.first)(w.map(y=>()=>y.handleURL(a,g)),void 0,!1).then(y=>y||!1)}registerHandler(a){return this.handlers.add(a),(0,L.toDisposable)(()=>this.handlers.delete(a))}}e.AbstractURLService=R;let I=class extends R{constructor(a){super(),this.productService=a}create(a){let{authority:g,path:w,query:y,fragment:h}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&w&&w.indexOf("/")!==0&&(w=`/${w}`),r.URI.from({scheme:this.productService.urlProtocol,authority:g,path:w,query:y,fragment:h})}};e.NativeURLService=I,e.NativeURLService=I=Pe([te(0,A.IProductService)],I)}),define(ie[269],ne([0,1,15,8,3,2,4,7]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class u extends A.Disposable{constructor(g,w,y,h,b,p){if(super(),this.urlService=w,this.logService=p,this.uris=[],this.retryCount=0,g&&(p.trace("ElectronURLListener initialUrisToHandle:",g.map(f=>f.originalUrl)),this.uris=g),R.isWindows){const f=h.isBuilt?[]:[`"${h.appRoot}"`];f.push("--open-url","--"),C.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,f)}const v=r.Event.map(r.Event.fromNodeEventEmitter(C.app,"open-url",(f,d)=>({event:f,url:d})),({event:f,url:d})=>(f.preventDefault(),d));this._register(v(f=>{const d=this.uriFromRawUrl(f);d&&this.urlService.open(d,{originalUrl:f})})),y.getWindows().filter(f=>f.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(r.Event.once(y.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(g){try{return I.URI.parse(g)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const w of this.uris)await this.urlService.open(w.uri,{originalUrl:w.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),g.push(w));g.length!==0&&(this.uris=g,(0,L.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=u}),define(ie[270],ne([0,1,3,2,16,56,31]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends L.Disposable{constructor(a,g,w,y,h,b){super(),this.fileSystemScheme=a,this.fileSystemProvider=g,this.userDataScheme=w,this.userDataProfilesService=y,this.uriIdentityService=h,this.logService=b,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new R.ResourceSet(p=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(p))),this.updateAtomicReadWritesResources(),this._register(y.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,g){return this.fileSystemProvider.open(this.toFileSystemResource(a),g)}close(a){return this.fileSystemProvider.close(a)}read(a,g,w,y,h){return this.fileSystemProvider.read(a,g,w,y,h)}write(a,g,w,y,h){return this.fileSystemProvider.write(a,g,w,y,h)}watch(a,g){this.watchResources.set(a,a);const w=this.fileSystemProvider.watch(this.toFileSystemResource(a),g);return(0,L.toDisposable)(()=>{this.watchResources.delete(a),w.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,g,w){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(g),w)}readFile(a,g){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),g)}readFileStream(a,g,w){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),g,w)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,g,w){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),g,w)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.fileSystemProvider.delete(this.toFileSystemResource(a),g)}copy(a,g,w){if((0,r.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(g),w);throw new Error("copy not supported")}cloneFile(a,g){if((0,r.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(g));throw new Error("clone not supported")}handleFileChanges(a){const g=[];for(const w of a){if(w.resource.scheme!==this.fileSystemScheme)continue;const y=this.toUserDataResource(w.resource);this.watchResources.findSubstr(y)&&g.push({resource:y,type:w.type,cId:w.cId})}g.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(g))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(ie[271],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ie[272],ne([0,1,5]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,C.createDecorator)("webviewManagerService")}),define(ie[273],ne([0,1,15,2,13,7]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends L.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const u=this.handleWebviewRequest.bind(this);C.protocol.registerFileProtocol(r.Schemas.vscodeWebview,u)}handleWebviewRequest(u,a){try{const g=A.URI.parse(u.url),w=R.validWebviewFilePaths.get(g.path);if(typeof w=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${w}`,h=r.FileAccess.asFileUri(y);return a({path:h.fsPath,headers:{...r.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.WebviewProtocolProvider=R}),define(ie[68],ne([0,1,4]),function(G,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(g){return!!g.workspaceUri}e.isWorkspaceToOpen=L;function r(g){return!!g.folderUri}e.isFolderToOpen=r;function A(g){return!!g.fileUri}e.isFileToOpen=A;function R(g){const w=I(g),y=g.getValue("window.menuBarVisibility");return y==="default"||w==="native"&&y==="compact"||C.isMacintosh&&C.isNative?"classic":y}e.getMenuBarVisibility=R;function I(g){if(C.isWeb)return"custom";const w=g.getValue("window");if(w){if(C.isMacintosh&&w.nativeTabs===!0||C.isMacintosh&&w.nativeFullScreen===!1)return"native";const b=w.titleBarStyle;if(b==="native"||b==="custom")return b}return C.isLinux?"native":"custom"}e.getTitleBarStyle=I;function u(g){return!(!C.isWindows||C.isWeb||I(g)==="native")}e.useWindowControlsOverlay=u;function a(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=a}),define(ie[128],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var C;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(C||(e.LoadReason=C={}));var L;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const r=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=r;var A;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(A||(e.WindowMode=A={}));var R;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(R||(e.WindowError=R={}))}),define(ie[274],ne([0,1,8,3,2]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends r.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:u,getActiveWindowId:a}){super(),this.disposables=this._register(new r.DisposableStore),L.Event.latch(L.Event.any(I,u))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,C.createCancelablePromise)(()=>a()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(ie[30],ne([0,1,192,9,56,19,7,5,13]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function a(t){const n=t;return typeof n?.id=="string"&&R.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=a;function g(t){return typeof t?.id=="string"&&!a(t)&&!y(t)}e.isEmptyWorkspaceIdentifier=g,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,L.basename)(t)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=t;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=w;function y(t){const n=t;return typeof n?.id=="string"&&R.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=y;function h(t){const n=t;if(n?.uri)return{id:n.id,uri:R.URI.revive(n.uri)};const l=t;if(l?.configPath)return{id:l.id,configPath:R.URI.revive(l.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=h;var b;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=p;function v(t){const n=t;return!!(n&&typeof n=="object"&&R.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=v;class m{constructor(n,l,S,D,M){this._id=n,this._transient=S,this._configuration=D,this._ignorePathCasing=M,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class f{constructor(n,l){this.raw=l,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function d(t){return new f({uri:t,index:0,name:(0,A.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(t,n){return A.extUriBiasedIgnorePathCase.isEqualOrParent(t,n.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function c(t){let n;return R.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=c,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function o(t,n){return!E(t,n)&&!c(t)}e.isSavedWorkspace=o;function s(t){return(typeof t=="string"?(0,L.extname)(t):(0,A.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ie[59],ne([0,1,15,8,55,46,2,85,4,21,167,115,5,6,25,30]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let v=class{constructor(f,d){this.logService=f,this.productService=d,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(f,d){return this.doPick({...f,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},d)}pickFolder(f,d){return this.doPick({...f,pickFolders:!0,title:(0,g.localize)(1,null)},d)}pickFile(f,d){return this.doPick({...f,pickFiles:!0,title:(0,g.localize)(2,null)},d)}pickWorkspace(f,d){const E=(0,g.localize)(3,null),c=(0,A.mnemonicButtonLabel)((0,g.localize)(4,null)),i=p.WORKSPACE_FILTER;return this.doPick({...f,pickFiles:!0,title:E,filters:i,buttonLabel:c},d)}async doPick(f,d){const E={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(E.properties=void 0,f.pickFiles&&f.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),u.isMacintosh&&E.properties.push("treatPackageAsDirectory");const c=await this.showOpenDialog(E,(d||C.BrowserWindow.getFocusedWindow())??void 0);if(c&&c.filePaths&&c.filePaths.length>0)return c.filePaths}getWindowDialogQueue(f){if(f){let d=this.windowDialogQueues.get(f.id);return d||(d=new L.Queue,this.windowDialogQueues.set(f.id,d)),d}else return this.noWindowDialogueQueue}showMessageBox(f,d){return this.getWindowDialogQueue(d).queue(async()=>{const{options:E,buttonIndeces:c}=(0,w.massageMessageBoxOptions)(f,this.productService);let i;return d?i=await C.dialog.showMessageBox(d,E):i=await C.dialog.showMessageBox(E),{response:c[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(f,d){const E=this.acquireFileDialogLock(f,d);if(!E)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(d).queue(async()=>{let c;return d?c=await C.dialog.showSaveDialog(d,f):c=await C.dialog.showSaveDialog(f),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,R.dispose)(E)}}normalizePath(f){return f&&u.isMacintosh&&(f=(0,I.normalizeNFC)(f)),f}normalizePaths(f){return f.map(d=>this.normalizePath(d))}async showOpenDialog(f,d){f.defaultPath&&(await a.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const E=this.acquireFileDialogLock(f,d);if(!E)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(d).queue(async()=>{let c;return d?c=await C.dialog.showOpenDialog(d,f):c=await C.dialog.showOpenDialog(f),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,R.dispose)(E)}}acquireFileDialogLock(f,d){if(!d)return R.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",f);let E=this.windowFileDialogLocks.get(d.id);E||(E=new Set,this.windowFileDialogLocks.set(d.id,E));const c=(0,r.hash)(f);if(!E.has(c))return this.logService.trace("[DialogMainService]: new file dialog lock created",f),E.add(c),(0,R.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",f),E?.delete(c),E?.size===0&&this.windowFileDialogLocks.delete(d.id)})}};e.DialogMainService=v,e.DialogMainService=v=Pe([te(0,h.ILogService),te(1,b.IProductService)],v)}),define(ie[275],ne([0,1,3,2,76,30]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class R extends L.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(u,a){super(),this.logService=u,this.storageMainService=a,this.onDidChangeApplicationStorageEmitter=this._register(new C.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(a.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(u,a){this._register(C.Event.debounce(u.onDidChangeStorage,(g,w)=>(g?g.push(w):g=[w],g),R.STORAGE_CHANGE_DEBOUNCE_TIME)(g=>{g.length&&a.fire(this.serializeStorageChangeEvents(g,u))}))}serializeStorageChangeEvents(u,a){const g=new Map,w=new Set;return u.forEach(y=>{const h=a.get(y.key);typeof h=="string"?g.set(y.key,h):w.add(y.key)}),{changed:Array.from(g.entries()),deleted:Array.from(w.values())}}listen(u,a,g){switch(a){case"onDidChangeStorage":{const w=g.profile?(0,r.revive)(g.profile):void 0;if(!w)return this.onDidChangeApplicationStorageEmitter.event;let y=this.mapProfileToOnDidChangeProfileStorageEmitter.get(w.id);return y||(y=this._register(new C.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(w),y),this.mapProfileToOnDidChangeProfileStorageEmitter.set(w.id,y)),y.event}}throw new Error(`Event not found: ${a}`)}async call(u,a,g){const w=g.profile?(0,r.revive)(g.profile):void 0,y=(0,A.reviveIdentifier)(g.workspace),h=await this.withStorageInitialized(w,y);switch(a){case"getItems":return Array.from(h.items.entries());case"updateItems":{const b=g;if(b.insert)for(const[p,v]of b.insert)h.set(p,v);b.delete?.forEach(p=>h.delete(p));break}case"optimize":return h.optimize();case"isUsed":{const b=g.payload;if(typeof b=="string")return this.storageMainService.isUsed(b)}default:throw new Error(`Call not found: ${a}`)}}async withStorageInitialized(u,a){let g;a?g=this.storageMainService.workspaceStorage(a):u?g=this.storageMainService.profileStorage(u):g=this.storageMainService.applicationStorage;try{await g.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${a?"workspace":u?"profile":"application"} storage due to ${w}`)}return g}}e.StorageDatabaseChannel=R}),define(ie[41],ne([0,1,55,3,2,19,7,189,36,16,5,6,30,31,40,8,32,27,12]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var d;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&R.URI.isUri(n.location)&&R.URI.isUri(n.globalStorageHome)&&R.URI.isUri(n.settingsResource)&&R.URI.isUri(n.keybindingsResource)&&R.URI.isUri(n.tasksResource)&&R.URI.isUri(n.snippetsHome)&&R.URI.isUri(n.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,g.createDecorator)("IUserDataProfilesService");function c(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:R.URI.revive(t.location).with({scheme:n}),globalStorageHome:R.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:R.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:R.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:R.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:R.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:R.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:R.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=c;function i(t,n,l,S,D,M){return{id:t,name:n,location:l,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:M&&D?.useDefaultFlags?.globalState?M.globalStorageHome:(0,A.joinPath)(l,"globalStorage"),settingsResource:M&&D?.useDefaultFlags?.settings?M.settingsResource:(0,A.joinPath)(l,"settings.json"),keybindingsResource:M&&D?.useDefaultFlags?.keybindings?M.keybindingsResource:(0,A.joinPath)(l,"keybindings.json"),tasksResource:M&&D?.useDefaultFlags?.tasks?M.tasksResource:(0,A.joinPath)(l,"tasks.json"),snippetsHome:M&&D?.useDefaultFlags?.snippets?M.snippetsHome:(0,A.joinPath)(l,"snippets"),extensionsResource:M&&D?.useDefaultFlags?.extensions?M.extensionsResource:(0,A.joinPath)(l,"extensions.json"),cacheHome:(0,A.joinPath)(S,t),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=i;let o=class extends r.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,l,S,D){super(),this.environmentService=n,this.fileService=l,this.uriIdentityService=S,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),l=[n];if(this.enabled)try{for(const M of this.getStoredProfiles()){if(!M.name||!(0,f.isString)(M.name)||!M.location){this.logService.warn("Skipping the invalid stored profile",M.location||M.name);continue}l.push(i((0,A.basename)(M.location),M.name,M.location,this.profilesCacheHome,{shortName:M.shortName,icon:M.icon,useDefaultFlags:M.useDefaultFlags},n))}}catch(M){this.logService.error(M)}const S=new h.ResourceMap,D=new Map;if(l.length)try{const M=this.getStoredProfileAssociations();if(M.workspaces)for(const[P,k]of Object.entries(M.workspaces)){const O=R.URI.parse(P),F=l.find(z=>z.id===k);F&&S.set(O,F)}if(M.emptyWindows)for(const[P,k]of Object.entries(M.emptyWindows)){const O=l.find(F=>F.id===k);O&&D.set(P,O)}}catch(M){this.logService.error(M)}this._profilesObject={profiles:l,workspaces:S,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const n=i("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const l="Temp",S=new RegExp(`${(0,m.escapeRegExpCharacters)(l)}\\s(\\d+)`);let D=0;for(const P of this.profiles){const k=S.exec(P.name),O=k?parseInt(k[1]):0;D=O>D?O:D}const M=`${l} ${D+1}`;return this.createProfile((0,C.hash)((0,v.generateUuid)()).toString(16),M,{transient:!0},n)}async createNamedProfile(n,l,S){return this.createProfile((0,C.hash)((0,v.generateUuid)()).toString(16),n,l,S)}async createProfile(n,l,S,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const M=await this.doCreateProfile(n,l,S);return D&&await this.setProfileForWorkspace(D,M),M}async doCreateProfile(n,l,S){if(!(0,f.isString)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(l);return D||(D=(async()=>{try{const M=this.profiles.find(O=>O.name===l||O.id===n);if(M)return M;const P=i(n,l,(0,A.joinPath)(this.profilesHome,n),this.profilesCacheHome,S,this.defaultProfile);await this.fileService.createFolder(P.location);const k=[];return this._onWillCreateProfile.fire({profile:P,join(O){k.push(O)}}),await p.Promises.settled(k),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(l)}})(),this.profileCreationPromises.set(l,D)),D}async updateProfile(n,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(D=>D.id===n.id);if(!S)throw new Error(`Profile '${n.name}' does not exist`);return S=i(S.id,l.name??S.name,S.location,this.profilesCacheHome,{shortName:l.shortName??S.shortName,icon:l.icon===null?void 0:l.icon??S.icon,transient:l.transient??S.isTransient,useDefaultFlags:l.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[S]),S}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(D=>D.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);const S=[];this._onWillRemoveProfile.fire({profile:l,join(D){S.push(D)}});try{await Promise.allSettled(S)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])l.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])l.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[l],[]);try{await this.fileService.del(l.cacheHome,{recursive:!0})}catch(D){(0,a.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(n,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(D=>D.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);this.updateWorkspaceAssociation(n,S)}unsetWorkspace(n,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,l)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(l=>l.isDirectory&&this.profiles.every(S=>!this.uriIdentityService.extUri.isEqual(S.location,l.resource))).map(l=>this.fileService.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(l=>!this.isProfileAssociatedToWorkspace(l));await Promise.allSettled(n.map(l=>this.removeProfile(l)))}getProfileForWorkspace(n){const l=this.getWorkspace(n);return R.URI.isUri(l)?this.transientProfilesObject.workspaces.get(l)??this.profilesObject.workspaces.get(l):this.transientProfilesObject.emptyWindows.get(l)??this.profilesObject.emptyWindows.get(l)}getWorkspace(n){return(0,y.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,y.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,n.location))||[...this.profilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,n.location)))}updateProfiles(n,l,S){const D=[...this.profiles,...n],M=[];this.transientProfilesObject.profiles=[];for(let P of D)P.isDefault||l.some(k=>P.id===k.id)||(P=S.find(k=>P.id===k.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):M.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(M),this._profilesObject=void 0,this.triggerProfilesChanges(n,l,S)}triggerProfilesChanges(n,l,S){this._onDidChangeProfiles.fire({added:n,removed:l,updated:S,all:this.profiles})}updateWorkspaceAssociation(n,l,S){S=l?.isTransient?!0:S,S||this.updateWorkspaceAssociation(n,void 0,!0);const D=this.getWorkspace(n),M=S?this.transientProfilesObject:this.profilesObject;R.URI.isUri(D)?(M.workspaces.delete(D),l&&M.workspaces.set(D,l)):(M.emptyWindows.delete(D),l&&M.emptyWindows.set(D,l)),S||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[S,D]of this.profilesObject.workspaces.entries())n[S.toString()]=D.id;const l={};for(const[S,D]of this.profilesObject.emptyWindows.entries())l[S.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:l}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const l={},S=this.createDefaultProfile();if(n.workspaces)for(const[M,P]of Object.entries(n.workspaces)){const k=R.URI.parse(P);l[M]=this.uriIdentityService.extUri.isEqual(k,S.location)?S.id:this.uriIdentityService.extUri.basename(k)}const D={};if(n.emptyWindows)for(const[M,P]of Object.entries(n.emptyWindows)){const k=R.URI.parse(P);D[M]=this.uriIdentityService.extUri.isEqual(k,S.location)?S.id:this.uriIdentityService.extUri.basename(k)}return{workspaces:l,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=Pe([te(0,u.IEnvironmentService),te(1,a.IFileService),te(2,b.IUriIdentityService),te(3,w.ILogService)],o);class s extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(ie[81],ne([0,1,8,17,2,3,31,7,117,123,16,5,6,41,40,12,14,26]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class d extends Error{constructor(s,t){super(s),this.code=t}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let E=class extends r.Disposable{constructor(s,t,n,l,S,D){super(),this.extensionsLocation=s,this.fileService=t,this.userDataProfilesService=n,this.uriIdentityService=l,this.telemetryService=S,this.logService=D,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(s,t){return this.withProfileExtensions(s,void 0,t)}async addExtensionsToProfile(s,t){const n=[],l=[];try{return await this.withProfileExtensions(t,S=>{const D=[];for(const M of S)s.some(([P])=>(0,a.areSameExtensions)(P.identifier,M.identifier)&&P.manifest.version!==M.version)?n.push(M):D.push(M);for(const[M,P]of s){const k=D.findIndex(F=>(0,a.areSameExtensions)(F.identifier,M.identifier)&&F.version===M.manifest.version),O={identifier:M.identifier,version:M.manifest.version,location:M.location,metadata:P};k===-1?(l.push(O),D.push(O)):D.splice(k,1,O)}return l.length&&this._onAddExtensions.fire({extensions:l,profileLocation:t}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:t}),D}),l.length&&this._onDidAddExtensions.fire({extensions:l,profileLocation:t}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:t}),l}catch(S){throw l.length&&this._onDidAddExtensions.fire({extensions:l,error:S,profileLocation:t}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:S,profileLocation:t}),S}}async updateMetadata(s,t){const n=[];return await this.withProfileExtensions(t,l=>{const S=[];for(const D of l){const M=s.find(([P])=>(0,a.areSameExtensions)(P.identifier,D.identifier)&&P.manifest.version===D.version);M&&(D.metadata={...D.metadata,...M[1]},n.push(D)),S.push(D)}return S}),n}async removeExtensionFromProfile(s,t){const n=[];try{await this.withProfileExtensions(t,l=>{const S=[];for(const D of l)(0,a.areSameExtensions)(D.identifier,s.identifier)?n.push(D):S.push(D);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:t}),S}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:t})}catch(l){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:l,profileLocation:t}),l}}async withProfileExtensions(s,t,n){return this.getResourceAccessQueue(s).queue(async()=>{let l=[],S;try{const D=await this.fileService.readFile(s);S=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,g.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(S=await this.migrateFromOldDefaultProfileExtensionsLocation()),!S&&n?.bailOutWhenFileNotFound)throw new d((0,v.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(S){Array.isArray(S)||this.reportAndThrowInvalidConentError(s);let D=!1;for(const M of S){c(M)||this.reportAndThrowInvalidConentError(s);let P;if((0,p.isString)(M.relativeLocation)&&M.relativeLocation)P=this.resolveExtensionLocation(M.relativeLocation);else if((0,p.isString)(M.location))P=this.resolveExtensionLocation(M.location),D=!0,M.relativeLocation=M.location,M.location=P.toJSON();else{P=I.URI.revive(M.location);const k=this.toRelativePath(P);k&&(D=!0,M.relativeLocation=k)}l.push({identifier:M.identifier,location:P,version:M.version,metadata:M.metadata})}D&&await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(S)))}if(t){l=t(l);const D=l.map(M=>({identifier:M.identifier,version:M.version,location:M.location.toJSON(),relativeLocation:this.toRelativePath(M.location),metadata:M.metadata}));await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(D)))}return l})}reportAndThrowInvalidConentError(s){const t=new d(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),t=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(s)).value.toString()}catch(S){if((0,g.toFileOperationResult)(S)===1)return;throw S}this.logService.info("Migrating extensions from old default profile location",s.toString());let l;try{const S=JSON.parse(n);Array.isArray(S)&&S.every(D=>c(D))?l=S:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.logService.error(S)}if(l)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(S){if((0,g.toFileOperationResult)(S)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw S}try{await this.fileService.del(s)}catch(S){(0,g.toFileOperationResult)(S)!==1&&this.logService.error(S)}try{await this.fileService.del(t)}catch(S){(0,g.toFileOperationResult)(S)!==1&&this.logService.error(S)}return l})()),this._migrationPromise}getResourceAccessQueue(s){let t=this.resourcesAccessQueueMap.get(s);return t||(t=new C.Queue,this.resourcesAccessQueueMap.set(s,t)),t}};e.AbstractExtensionsProfileScannerService=E,e.AbstractExtensionsProfileScannerService=E=Pe([te(1,g.IFileService),te(2,h.IUserDataProfilesService),te(3,b.IUriIdentityService),te(4,m.ITelemetryService),te(5,y.ILogService)],E);function c(o){return(0,p.isObject)(o)&&(0,u.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,p.isString)(o.location)&&o.location)&&((0,p.isUndefined)(o.relativeLocation)||(0,p.isString)(o.relativeLocation))&&o.version&&(0,p.isString)(o.version)}function i(o){return o?(0,p.isString)(o.path)&&(0,p.isString)(o.scheme):!1}}),define(ie[129],ne([0,1,23,8,37,17,14,44,152,2,13,9,4,19,205,73,12,7,172,36,123,120,204,16,5,6,25,3,76,81,41,40,203]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i,o,s,t,n,l,S,D,M,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(ce){function Q(K,V){if(K===V)return!0;const q=Object.keys(K),N=new Set;for(const j of Object.keys(V))N.add(j);if(q.length!==N.size)return!1;for(const j of q){if(K[j]!==V[j])return!1;N.delete(j)}return N.size===0}ce.equals=Q})(O||(e.Translations=O={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let F=class extends a.Disposable{constructor(Q,K,V,q,N,j,H,X,se,W,_,U){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=K,this.extensionsControlLocation=V,this.currentProfile=q,this.userDataProfilesService=N,this.extensionsProfileScannerService=j,this.fileService=H,this.logService=X,this.environmentService=se,this.productService=W,this.uriIdentityService=_,this.instantiationService=U,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(Y,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(Q,K,V){const[q,N]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(K)]),j=V?await this.scanExtensionsUnderDevelopment(Q,[...q,...N]):[];return this.dedupExtensions(q,N,j,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const K=[];K.push(this.scanDefaultSystemExtensions(!!Q.useCache,Q.language)),K.push(this.scanDevSystemExtensions(Q.language,!!Q.checkControlFile));const[V,q]=await Promise.all(K);return this.applyScanOptions([...V,...q],0,Q,!1)}async scanUserExtensions(Q){const K=Q.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",K);const V=this.uriIdentityService.extUri.isEqual(Q.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.createExtensionScannerInput(K,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,V),N=Q.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let j;try{j=await N.scanExtensions(q)}catch(H){if(H instanceof D.ExtensionsProfileScanningError&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),j=await N.scanExtensions(q);else throw H}return j=await this.applyScanOptions(j,1,Q,!0),this.logService.trace("Scanned user extensions:",j.length),j}async scanExtensionsUnderDevelopment(Q,K){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===g.Schemas.file).map(async q=>{const N=await this.createExtensionScannerInput(q,!1,1,!0,Q.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(N)).map(H=>(H.type=K.find(X=>(0,E.areSameExtensions)(X.identifier,H.identifier))?.type??H.type,this.extensionsScanner.validate(H,N)))}))).flat();return this.applyScanOptions(V,"development",Q,!0)}return[]}async scanExistingExtension(Q,K,V){const q=await this.createExtensionScannerInput(Q,!1,K,!0,V.language,!0,void 0),N=await this.extensionsScanner.scanExtension(q);return!N||!V.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Q,K,V){const q=await this.createExtensionScannerInput(Q,!1,K,!0,V.language,!0,void 0),N=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(N,K,V,!0)}async scanMetadata(Q){const K=(0,h.joinPath)(Q,"package.json"),V=(await this.fileService.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(Q,K){const V=(0,h.joinPath)(Q,"package.json"),q=(await this.fileService.readFile(V)).value.toString(),N=JSON.parse(q);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,N.__metadata={...N.__metadata,...K},await this.fileService.writeFile((0,h.joinPath)(Q,"package.json"),A.VSBuffer.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof D.ExtensionsProfileScanningError&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw Q}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.extensionsProfileScannerService.addExtensionsToProfile(Q.map(K=>[K,K.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(K){(0,o.toFileOperationResult)(K)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(K))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.logService.error(Q)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(Q,K,V,q){return V.includeAllVersions||(Q=this.dedupExtensions(K===0?Q:void 0,K===1?Q:void 0,K==="development"?Q:void 0,await this.getTargetPlatform(),q)),V.includeInvalid||(Q=Q.filter(N=>N.isValid)),Q.sort((N,j)=>{const H=w.basename(N.location.fsPath),X=w.basename(j.location.fsPath);return H<X?-1:H>X?1:0})}dedupExtensions(Q,K,V,q,N){const j=(X,se,W)=>{if(X.isValid&&!se.isValid)return!1;if(X.isValid===se.isValid){if(N&&b.gt(X.manifest.version,se.manifest.version))return this.logService.debug(`Skipping extension ${se.location.path} with lower version ${se.manifest.version} in favour of ${X.location.path} with version ${X.manifest.version}`),!1;if(b.eq(X.manifest.version,se.manifest.version)){if(X.type===0)return this.logService.debug(`Skipping extension ${se.location.path} in favour of system extension ${X.location.path} with same version`),!1;if(X.targetPlatform===q)return this.logService.debug(`Skipping extension ${se.location.path} from different target platform ${se.targetPlatform}`),!1}}return W?this.logService.warn(`Overwriting user extension ${X.location.path} with ${se.location.path}.`):this.logService.debug(`Overwriting user extension ${X.location.path} with ${se.location.path}.`),!0},H=new c.ExtensionIdentifierMap;return Q?.forEach(X=>{const se=H.get(X.identifier.id);(!se||j(se,X,!1))&&H.set(X.identifier.id,X)}),K?.forEach(X=>{const se=H.get(X.identifier.id);if(!se&&Q&&X.type===0){this.logService.debug(`Skipping obsolete system extension ${X.location.path}.`);return}(!se||j(se,X,!1))&&H.set(X.identifier.id,X)}),V?.forEach(X=>{const se=H.get(X.identifier.id);(!se||j(se,X,!0))&&H.set(X.identifier.id,X),H.set(X.identifier.id,X)}),[...H.values()]}async scanDefaultSystemExtensions(Q,K){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),N=await(Q&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",N.length),N}async scanDevSystemExtensions(Q,K){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=K?await this.getBuiltInExtensionControl():{},N=[],j=m.URI.file(w.normalize(w.join(g.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const X of V){const se=q[X.name]||"marketplace";switch(se){case"disabled":break;case"marketplace":N.push((0,h.joinPath)(j,X.name));break;default:N.push(m.URI.file(se));break}}const H=await Promise.all(N.map(async X=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(X,!1,0,!0,Q,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",H.length),(0,C.coalesce)(H)}async getBuiltInExtensionControl(){try{const Q=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(Q.value.toString())}catch{return{}}}async createExtensionScannerInput(Q,K,V,q,N,j,H){const X=await this.getTranslations(N??y.language),se=await this.getMtime(Q),W=K&&!this.uriIdentityService.extUri.isEqual(Q,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,_=W?await this.getMtime(W):void 0;return new z(Q,se,W,_,K,H,V,q,j,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,N,X)}async getMtime(Q){try{const K=await this.fileService.stat(Q);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.AbstractExtensionsScannerService=F,e.AbstractExtensionsScannerService=F=Pe([te(4,M.IUserDataProfilesService),te(5,D.IExtensionsProfileScannerService),te(6,o.IFileService),te(7,t.ILogService),te(8,d.IEnvironmentService),te(9,n.IProductService),te(10,P.IUriIdentityService),te(11,s.IInstantiationService)],F);class z{constructor(Q,K,V,q,N,j,H,X,se,W,_,U,B,T,$){this.location=Q,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=q,this.profile=N,this.profileScanOptions=j,this.type=H,this.excludeObsolete=X,this.validate=se,this.productVersion=W,this.productDate=_,this.productCommit=U,this.devMode=B,this.language=T,this.translations=$}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,K){return(0,h.isEqual)(Q.location,K.location)&&Q.mtime===K.mtime&&(0,h.isEqual)(Q.applicationExtensionslocation,K.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&Q.profile===K.profile&&r.equals(Q.profileScanOptions,K.profileScanOptions)&&Q.type===K.type&&Q.excludeObsolete===K.excludeObsolete&&Q.validate===K.validate&&Q.productVersion===K.productVersion&&Q.productDate===K.productDate&&Q.productCommit===K.productCommit&&Q.devMode===K.devMode&&Q.language===K.language&&O.equals(Q.translations,K.translations)}}e.ExtensionScannerInput=z;let Y=class extends a.Disposable{constructor(Q,K,V,q,N){super(),this.obsoleteFile=Q,this.extensionsProfileScannerService=K,this.uriIdentityService=V,this.fileService=q,this.logService=N}async scanExtensions(Q){const K=Q.profile?await this.scanExtensionsFromProfile(Q):await this.scanExtensionsFromLocation(Q);let V={};if(Q.excludeObsolete&&Q.type===1)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(q)}catch{}return(0,v.isEmptyObject)(V)?K:K.filter(q=>!V[E.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(Q){const K=await this.fileService.resolve(Q.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async q=>{if(!q.isDirectory||Q.type===1&&(0,h.basename)(q.resource).indexOf(".")===0)return null;const N=new z(q.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(N)}));return(0,C.coalesce)(V).sort((q,N)=>q.location.path<N.location.path?-1:1)}async scanExtensionsFromProfile(Q){let K=await this.scanExtensionsFromProfileResource(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){K=K.filter(q=>!q.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(Q.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,Q);K.push(...V)}return K}async scanExtensionsFromProfileResource(Q,K,V){const q=await this.extensionsProfileScannerService.scanProfileExtensions(Q,V.profileScanOptions);if(!q.length)return[];const N=await Promise.all(q.map(async j=>{if(K(j)){const H=new z(j.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(H,j.metadata)}return null}));return(0,C.coalesce)(N)}async scanOneOrMultipleExtensions(Q){try{if(await this.fileService.exists((0,h.joinPath)(Q.location,"package.json"))){const K=await this.scanExtension(Q);return K?[K]:[]}else return await this.scanExtensions(Q)}catch(K){return this.logService.error(`Error scanning extensions at ${Q.location.path}:`,(0,R.getErrorMessage)(K)),[]}}async scanExtension(Q,K){try{let V=await this.scanExtensionManifest(Q.location);if(V){V.publisher||(V.publisher=c.UNDEFINED_PUBLISHER),K=K??V.__metadata,delete V.__metadata;const q=(0,E.getGalleryExtensionId)(V.publisher,V.name),N=K?.id?{id:q,uuid:K.id}:{id:q},j=K?.isSystem?0:Q.type,H=j===0||!!K?.isBuiltin;V=await this.translateManifest(Q.location,V,z.createNlsConfiguration(Q));const X={type:j,identifier:N,manifest:V,location:Q.location,isBuiltin:H,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return Q.validate?this.validate(X,Q):X}}catch(V){Q.type!==0&&this.logService.error(V)}return null}validate(Q,K){let V=!0;const q=(0,i.validateExtensionManifest)(K.productVersion,K.productDate,K.location,Q.manifest,Q.isBuiltin);for(const[N,j]of q)N===p.default.Error&&(V=!1,this.logService.error(this.formatMessage(K.location,j)));return Q.isValid=V,Q.validations=q,Q}async scanExtensionManifest(Q){const K=(0,h.joinPath)(Q,"package.json");let V;try{V=(await this.fileService.readFile(K)).value.toString()}catch(N){return(0,o.toFileOperationResult)(N)!==1&&this.logService.error(this.formatMessage(Q,(0,f.localize)(0,null,K.path,N.message))),null}let q;try{q=JSON.parse(V)}catch{const j=[];(0,I.parse)(V,j);for(const H of j)this.logService.error(this.formatMessage(Q,(0,f.localize)(1,null,K.path,H.offset,H.length,(0,u.getParseErrorMessage)(H.error))));return null}return(0,I.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(Q,(0,f.localize)(2,null,K.path))),null):q}async translateManifest(Q,K,V){const q=await this.getLocalizedMessages(Q,K,V);if(q)try{const N=[],j=await this.resolveOriginalMessageBundle(q.default,N);if(N.length>0)return N.forEach(X=>{this.logService.error(this.formatMessage(Q,(0,f.localize)(3,null,q.default?.path,(0,u.getParseErrorMessage)(X.error))))}),K;if((0,I.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(Q,(0,f.localize)(4,null,q.default?.path))),K;const H=q.values||Object.create(null);return(0,k.localizeManifest)(this.logService,K,H,j)}catch{}return K}async getLocalizedMessages(Q,K,V){const q=(0,h.joinPath)(Q,"package.nls.json"),N=(se,W)=>{W.forEach(_=>{this.logService.error(this.formatMessage(Q,(0,f.localize)(5,null,se?.path,(0,u.getParseErrorMessage)(_.error))))})},j=se=>{this.logService.error(this.formatMessage(Q,(0,f.localize)(6,null,se?.path)))},H=`${K.publisher}.${K.name}`,X=V.translations[H];if(X)try{const se=m.URI.file(X),W=(await this.fileService.readFile(se)).value.toString(),_=[],U=(0,I.parse)(W,_);return _.length>0?(N(se,_),{values:void 0,default:q}):(0,I.getNodeType)(U)!=="object"?(j(se),{values:void 0,default:q}):{values:U.contents?U.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let W;try{W=await this.findMessageBundles(Q,V)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const _=(await this.fileService.readFile(W.localized)).value.toString(),U=[],B=(0,I.parse)(_,U);return U.length>0?(N(W.localized,U),{values:void 0,default:W.original}):(0,I.getNodeType)(B)!=="object"?(j(W.localized),{values:void 0,default:W.original}):{values:B,default:W.original}}catch{return{values:void 0,default:W.original}}}}async resolveOriginalMessageBundle(Q,K){if(Q)try{const V=(await this.fileService.readFile(Q)).value.toString();return(0,I.parse)(V,K)}catch{}}findMessageBundles(Q,K){return new Promise((V,q)=>{const N=j=>{const H=(0,h.joinPath)(Q,`package.nls.${j}.json`);this.fileService.exists(H).then(X=>{X&&V({localized:H,original:(0,h.joinPath)(Q,"package.nls.json")});const se=j.lastIndexOf("-");se===-1?V({localized:(0,h.joinPath)(Q,"package.nls.json"),original:null}):(j=j.substring(0,se),N(j))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,h.joinPath)(Q,"package.nls.json"),original:null});N(K.language)})}formatMessage(Q,K){return`[${Q.path}]: ${K}`}};Y=Pe([te(1,D.IExtensionsProfileScannerService),te(2,P.IUriIdentityService),te(3,o.IFileService),te(4,t.ILogService)],Y);let J=class extends Y{constructor(Q,K,V,q,N,j,H){super(K,q,N,j,H),this.currentProfile=Q,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(Q){const K=this.getCacheFile(Q),V=await this.readExtensionCache(K);if(this.input=Q,V&&V.input&&z.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",Q.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(N=>(N.location=m.URI.revive(N.location),N));const q=await super.scanExtensions(Q);return await this.writeExtensionCache(K,{input:Q,result:q}),q}async readExtensionCache(Q){try{const K=await this.fileService.readFile(Q),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,S.revive)(V.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",Q.path,(0,R.getErrorMessage)(K))}return null}async writeExtensionCache(Q,K){try{await this.fileService.writeFile(Q,A.VSBuffer.fromString(JSON.stringify(K)))}catch(V){this.logService.debug("Error while writing the extension cache file:",Q.path,(0,R.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const Q=this.getCacheFile(this.input),K=await this.readExtensionCache(Q);if(!K)return;const V=K.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(q,V))try{this.logService.info("Invalidating Cache",V,q),await this.fileService.del(Q),this._onDidChangeCache.fire()}catch(N){this.logService.error(N)}}getCacheFile(Q){const K=this.getProfile(Q);return this.uriIdentityService.extUri.joinPath(K.cacheHome,Q.type===0?c.BUILTIN_MANIFEST_CACHE_FILE:c.USER_MANIFEST_CACHE_FILE)}getProfile(Q){return Q.type===0?this.userDataProfilesService.defaultProfile:Q.profile?this.uriIdentityService.extUri.isEqual(Q.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(K=>this.uriIdentityService.extUri.isEqual(Q.location,K.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};J=Pe([te(2,M.IUserDataProfilesService),te(3,D.IExtensionsProfileScannerService),te(4,P.IUriIdentityService),te(5,o.IFileService),te(6,t.ILogService)],J);function oe(ce,Q){const K=(0,E.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:K,identifier:new c.ExtensionIdentifier(K),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:Q,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=oe;class re extends F{constructor(Q,K,V,q,N,j,H,X,se,W,_,U){super(Q,K,(0,h.joinPath)(V,".vscode-oss-dev","extensions","control.json"),q,N,j,H,X,se,W,_,U),this.translationsPromise=(async()=>{if(y.translationsConfigFile)try{const B=await this.fileService.readFile(m.URI.file(y.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(Q){return this.translationsPromise}}e.NativeExtensionsScannerService=re}),define(ie[276],ne([0,1,6,41,40,26,81,16,36,7]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let g=class extends R.AbstractExtensionsProfileScannerService{constructor(y,h,b,p,v,m){super(a.URI.file(y.extensionsPath),h,b,p,v,m)}};e.ExtensionsProfileScannerService=g,e.ExtensionsProfileScannerService=g=Pe([te(0,u.INativeEnvironmentService),te(1,I.IFileService),te(2,L.IUserDataProfilesService),te(3,r.IUriIdentityService),te(4,A.ITelemetryService),te(5,C.ILogService)],g)}),define(ie[277],ne([0,1,7,36,81,129,16,5,6,25,40,41]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends A.NativeExtensionsScannerService{constructor(b,p,v,m,f,d,E,c){super(C.URI.file(f.builtinExtensionsPath),C.URI.file(f.extensionsPath),f.userHome,b.defaultProfile,b,p,v,m,f,d,E,c)}};e.ExtensionsScannerService=y,e.ExtensionsScannerService=y=Pe([te(0,w.IUserDataProfilesService),te(1,r.IExtensionsProfileScannerService),te(2,R.IFileService),te(3,u.ILogService),te(4,L.INativeEnvironmentService),te(5,a.IProductService),te(6,g.IUriIdentityService),te(7,I.IInstantiationService)],y)}),define(ie[278],ne([0,1,15,2,13,9,4,56,7,32,38,36,6,41]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends L.Disposable{constructor(v,m,f){super(),this.environmentService=v,this.logService=f,this.validRoots=I.TernarySearchTree.forPaths(!R.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:r.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:r.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:v}=C.session;v.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(m,f)=>this.handleResourceRequest(m,f)),v.protocol.interceptFileProtocol(r.Schemas.file,(m,f)=>this.handleFileRequest(m,f)),this._register((0,L.toDisposable)(()=>{v.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(v){const m=(0,A.normalize)(v);return this.validRoots.get(m)?L.Disposable.None:(this.validRoots.set(m,!0),(0,L.toDisposable)(()=>this.validRoots.delete(m)))}handleFileRequest(v,m){const f=u.URI.parse(v.url);return this.logService.error(`Refused to load resource ${f.fsPath} from ${r.Schemas.file}: protocol (original URL: ${v.url})`),m({error:-3})}handleResourceRequest(v,m){const f=this.requestToNormalizedFilePath(v);let d;return this.environmentService.crossOriginIsolated&&((0,A.basename)(f)==="workbench.html"||(0,A.basename)(f)==="workbench-dev.html"?d=r.COI.CoopAndCoep:d=r.COI.getHeadersFromQuery(v.url)),this.validRoots.findSubstr(f)?m({path:f,headers:d}):this.validExtensions.has((0,A.extname)(f).toLowerCase())?m({path:f}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),m({error:-3}))}requestToNormalizedFilePath(v){const m=u.URI.parse(v.url),f=r.FileAccess.uriToFileUri(m);return(0,A.normalize)(f.fsPath)}createIPCObjectUrl(){let v;const m=u.URI.from({scheme:"vscode",path:(0,a.generateUuid)()}),f=m.toString(),d=async()=>v;return g.validatedIpcMain.handle(f,d),this.logService.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:m,update:E=>v=E,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${f}.`),g.validatedIpcMain.removeHandler(f)}}}};e.ProtocolMainService=b,e.ProtocolMainService=b=Pe([te(0,w.INativeEnvironmentService),te(1,h.IUserDataProfilesService),te(2,y.ILogService)],b)}),define(ie[96],ne([0,1,8,3,2,65,12,111,5,41]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var g;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var w;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var y;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function h(f){const d=f.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=h;class b extends r.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(d={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super(),this.options=d,this._onDidChangeValue=this._register(new L.PauseableEmitter),this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(d,E,c){return L.Event.filter(this._onDidChangeValue.event,i=>i.scope===d&&(E===void 0||i.key===E),c)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,E){const{key:c,external:i}=E;if(c===e.TARGET_KEY){switch(d){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:d})}else this._onDidChangeValue.fire({scope:d,key:c,target:this.getKeyTargets(d)[c],external:i})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,E,c){return this.getStorage(E)?.get(d,c)}getBoolean(d,E,c){return this.getStorage(E)?.getBoolean(d,c)}getNumber(d,E,c){return this.getStorage(E)?.getNumber(d,c)}getObject(d,E,c){return this.getStorage(E)?.getObject(d,c)}storeAll(d,E){this.withPausedEmitters(()=>{for(const c of d)this.store(c.key,c.value,c.scope,c.target,E)})}store(d,E,c,i,o=!1){if((0,R.isUndefinedOrNull)(E)){this.remove(d,c,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,c,i),this.getStorage(c)?.set(d,E,o)})}remove(d,E,c=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(d,E,void 0),this.getStorage(E)?.delete(d,c)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,E){const c=[],i=this.getKeyTargets(d);for(const o of Object.keys(i))i[o]===E&&c.push(o);return c}updateKeyTarget(d,E,c,i=!1){const o=this.getKeyTargets(E);typeof c=="number"?o[d]!==c&&(o[d]=c,this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(o),i)):typeof o[d]=="number"&&(delete o[d],this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(o),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(d){switch(d){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(d){const E=this.getStorage(d);return E?h(E):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=g.NONE){this._onWillSaveState.fire({reason:d});const E=this.getStorage(-1),c=this.getStorage(0),i=this.getStorage(1);switch(d){case g.NONE:await C.Promises.settled([E?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await C.Promises.settled([E?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.getStorage(-1)?.items??new Map,E=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return m(d,E,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(d){return await this.flush(),this.getStorage(d)?.optimize()}async switch(d,E){return this.emitWillSaveState(g.NONE),(0,a.isUserDataProfile)(d)?this.switchToProfile(d,E):this.switchToWorkspace(d,E)}canSwitchProfile(d,E){return!(d.id===E.id||p(E)&&p(d))}switchData(d,E,c){this.withPausedEmitters(()=>{const i=new Set;for(const[o,s]of d)i.add(o),E.get(o)!==s&&this.emitDidChangeValue(c,{key:o,external:!0});for(const[o]of E.items)i.has(o)||this.emitDidChangeValue(c,{key:o,external:!0})})}}e.AbstractStorageService=b;function p(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=p;class v extends b{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.profileStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),this._register(this.applicationStorage.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d)))}getStorage(d){switch(d){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(d){return!1}}e.InMemoryStorageService=v;async function m(f,d,E,c,i,o){const s=O=>{try{return JSON.parse(O)}catch{return O}},t=new Map,n=new Map;f.forEach((O,F)=>{t.set(F,O),n.set(F,s(O))});const l=new Map,S=new Map;d.forEach((O,F)=>{l.set(F,O),S.set(F,s(O))});const D=new Map,M=new Map;E.forEach((O,F)=>{D.set(F,O),M.set(F,s(O))}),console.group(c!==i?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const P=[];if(t.forEach((O,F)=>{P.push({key:F,value:O})}),console.table(P),console.groupEnd(),console.log(n),c!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const O=[];l.forEach((F,z)=>{O.push({key:z,value:F})}),console.table(O),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${o})`);const k=[];D.forEach((O,F)=>{k.push({key:F,value:O})}),console.table(k),console.groupEnd(),console.log(M)}e.logStorage=m}),define(ie[279],ne([0,1,23,8,3,2,9,72,7,21,111,161,6,96,26,30,13]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class m extends A.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(s,t){super(),this.logService=s,this.fileService=t,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new g.Storage(new g.InMemoryStorageDatabase,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=g.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===g.StorageState.None)try{const s=this._register(await this.doCreate());this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(n=>this._onDidChangeStorage.fire(n))),await this.doInit(s);const t=s.getBoolean(h.IS_NEW_KEY);t===void 0?s.set(h.IS_NEW_KEY,!0):t&&s.set(h.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=g.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,t){return this._storage.get(s,t)}set(s,t){return this._storage.set(s,t)}delete(s){return this._storage.delete(s)}optimize(){return this._storage.optimize()}async close(){const s=new I.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>m.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(this.path)try{const t=(0,C.top)(Array.from(this._storage.items.entries()).map(([l,S])=>({key:l,length:S.length})),(l,S)=>S.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),n=(await this.fileService.stat(u.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=g.StorageState.Closed,await this._storage.close()}}class f extends m{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.profile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,f.STORAGE_NAME)}constructor(s,t,n,l){super(n,l),this.profile=s,this.options=t}async doCreate(){return new g.Storage(new w.SQLiteStorageDatabase(this.path??w.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class d extends f{constructor(s,t,n,l){super(s,t,n,l)}}e.ProfileStorageMain=d;class E extends f{constructor(s,t,n,l){super(t.defaultProfile,s,n,l)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(b.firstSessionDateStorageKey,void 0)===void 0&&s.set(b.firstSessionDateStorageKey,new Date().toUTCString());const n=s.get(b.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();s.set(b.lastSessionDateStorageKey,typeof n>"u"?null:n),s.set(b.currentSessionDateStorageKey,l)}}e.ApplicationStorageMain=E;class c extends m{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.environmentService.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,this.workspace.id,c.WORKSPACE_STORAGE_NAME)}constructor(s,t,n,l,S){super(n,S),this.workspace=s,this.options=t,this.environmentService=l}async doCreate(){const{storageFilePath:s,wasCreated:t}=await this.prepareWorkspaceStorageFolder();return new g.Storage(new w.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:t?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:w.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,R.join)(this.environmentService.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,this.workspace.id),t=(0,R.join)(s,c.WORKSPACE_STORAGE_NAME);return await a.Promises.exists(s)?{storageFilePath:t,wasCreated:!1}:(await a.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:t,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let t;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?t={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(t={workspace:this.workspace.configPath.toString()}),t)try{const n=(0,R.join)(s,c.WORKSPACE_META_NAME);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=c;class i extends m{get path(){}async doCreate(){return new g.Storage(new g.InMemoryStorageDatabase,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=i}),define(ie[280],ne([0,1,3,2,96]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends L.Disposable{constructor(I,u,a){super(),this.storageMainService=I,this.userDataProfilesService=u,this.logService=a;const g=this._register(new L.MutableDisposable);this._onDidChange=this._register(new C.Emitter({onWillAddFirstListener:()=>g.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>g.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new L.DisposableStore;return I.add(C.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(u,a)=>(u?u.push(a.key):u=[a.key],u),100)(u=>this.onDidChangeApplicationStorage(u))),I.add(C.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(u,a)=>{u||(u=new Map);let g=u.get(a.profile.id);return g||u.set(a.profile.id,g={profile:a.profile,keys:[],storage:a.storage}),g.keys.push(a.key),u},100)(u=>this.onDidChangeProfileStorage(u))),I}onDidChangeApplicationStorage(I){const u=I.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],a=[];if(I=I.filter(g=>g!==r.TARGET_KEY),I.length){const g=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);a.push({profile:this.userDataProfilesService.defaultProfile,changes:I.map(w=>({key:w,scope:0,target:g[w]}))})}this.triggerEvents(u,a)}onDidChangeProfileStorage(I){const u=[],a=new Map;for(const[g,w]of I.entries()){w.keys.includes(r.TARGET_KEY)&&u.push(w.profile);const y=w.keys.filter(h=>h!==r.TARGET_KEY);if(y.length){const h=(0,r.loadKeyTargets)(w.storage.storage);a.set(g,{profile:w.profile,changes:y.map(b=>({key:b,scope:0,target:h[b]}))})}}this.triggerEvents(u,[...a.values()])}triggerEvents(I,u){(I.length||u.length)&&this._onDidChange.fire({valueChanges:u,targetChanges:I})}listen(I,u,a){switch(u){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${u}`)}async call(I,u){throw new Error(`Call not found: ${u}`)}}e.ProfileStorageChangesListenerChannel=A}),define(ie[281],ne([0,1,7,36,16,6,34,40,41,12,121]),function(G,e,C,L,r,A,R,I,u,a,g){"use strict";var w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let h=class extends u.UserDataProfilesService{static{w=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(m,f,d,E,c){super(d,E,f,c),this.stateReadonlyService=m,this.nativeEnvironmentService=d}getStoredProfiles(){return this.stateReadonlyService.getItem(w.PROFILES_KEY,[]).map(f=>({...f,location:(0,a.isString)(f.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,f.location):C.URI.revive(f.location)}))}getStoredProfileAssociations(){const m=this.stateReadonlyService.getItem(w.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(w.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?m:this.migrateStoredProfileAssociations(m)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(C.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=h,e.UserDataProfilesReadonlyService=h=w=Pe([te(0,R.IStateReadService),te(1,I.IUriIdentityService),te(2,L.INativeEnvironmentService),te(3,r.IFileService),te(4,A.ILogService)],h);let b=y=class extends h{constructor(m,f,d,E,c){super(m,f,d,E,c),this.stateService=m}saveStoredProfiles(m){m.length?this.stateService.setItem(y.PROFILES_KEY,m.map(f=>({...f,location:this.uriIdentityService.extUri.basename(f.location)}))):this.stateService.removeItem(y.PROFILES_KEY)}getStoredProfiles(){const m=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(m),this.stateService.setItem("userDataProfilesMigration",!0)),m}saveStoredProfileAssociations(m){m.emptyWindows||m.workspaces?this.stateService.setItem(y.PROFILE_ASSOCIATIONS_KEY,m):this.stateService.removeItem(y.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const m="workspaceAndProfileInfo",f=this.stateService.getItem(m,void 0);if(f){this.stateService.removeItem(m);const E=f.reduce((c,{workspace:i,profile:o})=>(c[C.URI.revive(i).toString()]=C.URI.revive(o).toString(),c),{});this.stateService.setItem(y.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}const d=super.getStoredProfileAssociations();return this.stateService.getItem(y.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(d),this.stateService.setItem(y.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),d}};e.UserDataProfilesService=b,e.UserDataProfilesService=b=y=Pe([te(0,R.IStateService),te(1,I.IUriIdentityService),te(2,L.INativeEnvironmentService),te(3,r.IFileService),te(4,A.ILogService)],b);let p=class extends b{constructor(m,f,d,E){super(new g.StateService(0,f,E,d),m,f,d,E)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=p,e.ServerUserDataProfilesService=p=Pe([te(0,I.IUriIdentityService),te(1,L.INativeEnvironmentService),te(2,r.IFileService),te(3,A.ILogService)],p)}),define(ie[52],ne([0,1,36,16,5,6,40,41,281,34]),function(G,e,C,L,r,A,R,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(I.IUserDataProfilesService);let g=class extends u.UserDataProfilesService{constructor(y,h,b,p,v){super(y,h,b,p,v)}getAssociatedEmptyWindows(){const y=[];for(const h of this.profilesObject.emptyWindows.keys())y.push({id:h});return y}};e.UserDataProfilesMainService=g,e.UserDataProfilesMainService=g=Pe([te(0,a.IStateService),te(1,R.IUriIdentityService),te(2,C.INativeEnvironmentService),te(3,L.IFileService),te(4,A.ILogService)],g)}),define(ie[130],ne([0,1,19,7,30]),function(G,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function A(u,a,g){for(const y of u){const h=y.openedWorkspace;if((0,r.isWorkspaceIdentifier)(h)){const b=await g(h);if(b){if(b.folders.some(p=>C.extUriBiasedIgnorePathCase.isEqualOrParent(a,p.uri)))return y}else if(C.extUriBiasedIgnorePathCase.isEqualOrParent(a,h.configPath))return y}}const w=u.filter(y=>(0,r.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqualOrParent(a,y.openedWorkspace.uri));if(w.length)return w.sort((y,h)=>-(y.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=A;function R(u,a){for(const g of u)if((0,r.isWorkspaceIdentifier)(g.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqual(g.openedWorkspace.configPath,a)||(0,r.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqual(g.openedWorkspace.uri,a))return g}e.findWindowOnWorkspaceOrFolder=R;function I(u,a){const g=w=>a.some(y=>C.extUriBiasedIgnorePathCase.isEqual(L.URI.file(y),L.URI.file(w)));for(const w of u)if(w.config?.extensionDevelopmentPath?.some(y=>g(y)))return w}e.findWindowOnExtensionDevelopmentPath=I}),define(ie[97],ne([0,1,33,44,139,46,13,9,4,19,7,5,58,30]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function b(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function p(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=p;function v(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=v;function m(M){return f(M)||d(M)}e.isStoredWorkspaceFolder=m;function f(M){const P=M;return typeof P?.path=="string"&&(!P.name||typeof P.name=="string")}function d(M){const P=M;return typeof P?.uri=="string"&&(!P.name||typeof P.name=="string")}function E(M,P,k,O,F){if(M.scheme!==O.scheme)return{name:k,uri:M.toString(!0)};let z=P?void 0:F.relativePath(O,M);if(z!==void 0)z.length===0?z=".":u.isWindows&&(z=c(z));else if(M.scheme===R.Schemas.file)z=M.fsPath,u.isWindows&&(z=c(z));else if(F.isEqualAuthority(M.authority,O.authority))z=M.path;else return{name:k,uri:M.toString(!0)};return{name:k,path:z}}e.getStoredWorkspaceFolder=E;function c(M){return M=(0,A.normalizeDriveLetter)(M),(0,C.isUNC)(M)||(M=(0,C.toSlashes)(M)),M}function i(M,P,k){const O=[],F=new Set,z=k.dirname(P);for(const Y of M){let J;if(f(Y))Y.path&&(J=k.resolvePath(z,Y.path));else if(d(Y))try{J=g.URI.parse(Y.uri),J.path[0]!==I.posix.sep&&(J=J.with({path:I.posix.sep+J.path}))}catch(oe){console.warn(oe)}if(J){const oe=k.getComparisonKey(J);if(!F.has(oe)){F.add(oe);const re=Y.name||k.basenameOrAuthority(J);O.push(new h.WorkspaceFolder({uri:J,name:re,index:O.length},Y))}}}return O}e.toWorkspaceFolders=i;function o(M,P,k,O,F){const z=s(P,M),Y=F.dirname(P),J=F.dirname(O),oe=[];for(const K of z.folders){const V=f(K)?F.resolvePath(Y,K.path):g.URI.parse(K.uri);let q;k?q=!1:q=!f(K)||(0,I.isAbsolute)(K.path),oe.push(E(V,q,K.name,J,F))}const re={insertSpaces:!1,tabSize:4,eol:u.isLinux||u.isMacintosh?`
`:`\r
`},ce=r.setProperty(M,["folders"],oe,re);let Q=r.applyEdits(M,ce);return(0,a.isEqualAuthority)(z.remoteAuthority,(0,y.getRemoteAuthority)(O))&&(Q=r.applyEdits(Q,r.removeProperty(Q,["remoteAuthority"],re))),Q}e.rewriteWorkspaceFileForNewLocation=o;function s(M,P){const k=L.parse(P);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(O=>m(O));else throw new Error(`${M} looks like an invalid workspace file.`);return k}function t(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function n(M){return typeof M.folderUri=="string"}function l(M){return typeof M.fileUri=="string"}function S(M,P){const k={workspaces:[],files:[]};if(M){const O=function(z,Y){for(let J=0;J<z.length;J++)try{Y(z[J],J)}catch(oe){P.warn(`Error restoring recent entry ${JSON.stringify(z[J])}: ${oe.toString()}. Skip entry.`)}},F=M;Array.isArray(F.entries)&&O(F.entries,z=>{const Y=z.label,J=z.remoteAuthority;t(z)?k.workspaces.push({label:Y,remoteAuthority:J,workspace:{id:z.workspace.id,configPath:g.URI.parse(z.workspace.configPath)}}):n(z)?k.workspaces.push({label:Y,remoteAuthority:J,folderUri:g.URI.parse(z.folderUri)}):l(z)&&k.files.push({label:Y,remoteAuthority:J,fileUri:g.URI.parse(z.fileUri)})})}return k}e.restoreRecentlyOpened=S;function D(M){const P={entries:[]};for(const k of M.workspaces)p(k)?P.entries.push({folderUri:k.folderUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority}):P.entries.push({workspace:{id:k.workspace.id,configPath:k.workspace.configPath.toString()},label:k.label,remoteAuthority:k.remoteAuthority});for(const k of M.files)P.entries.push({fileUri:k.fileUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority});return P}e.toStoreData=D}),define(ie[98],ne([0,1,86,13,4,19]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function R(a){function g(){let w=a.scheme===L.Schemas.file?(0,A.originalFSPath)(a):a.toString();return r.isLinux||(w=w.toLowerCase()),(0,C.createHash)("md5").update(w).digest("hex")}return{id:g(),configPath:a}}e.getWorkspaceIdentifier=R;function I(a,g){function w(){if(a.scheme!==L.Schemas.file)return(0,C.createHash)("md5").update(a.toString()).digest("hex");if(!g)return;let h;return r.isLinux?h=g.ino:r.isMacintosh?h=g.birthtime.getTime():r.isWindows&&(typeof g.birthtimeMs=="number"?h=Math.floor(g.birthtimeMs):h=g.birthtime.getTime()),(0,C.createHash)("md5").update(a.fsPath).update(h?String(h):"").digest("hex")}const y=w();if(typeof y=="string")return{id:y,uri:a}}e.getSingleFolderWorkspaceIdentifier=I;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=u}),define(ie[99],ne([0,1,86,87,28,282,17,14,3,2,9,4,32,42,109]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{traceSocketEvent(P,k){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,k)}constructor(P,k=""){this._canWrite=!0,this.debugLabel=k,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,I.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener),this._closeListener=O=>{this.traceSocketEvent("close",{hadError:O}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(P){const k=O=>{this.traceSocketEvent("read",O),P(R.VSBuffer.wrap(O))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(P){const k=O=>{P({type:0,hadError:O,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(P){const k=()=>{P()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(P){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,I.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,I.onUnexpectedError)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=p;var v;(function(M){M[M.MinHeaderByteSize=2]="MinHeaderByteSize",M[M.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(v||(v={}));var m;(function(M){M[M.PeekHeader=1]="PeekHeader",M[M.ReadHeader=2]="ReadHeader",M[M.ReadBody=3]="ReadBody",M[M.Fin=4]="Fin"})(m||(m={}));class f extends a.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,k){this.socket.traceSocketEvent(P,k)}constructor(P,k,O,F){super(),this._onData=this._register(new u.Emitter),this._onClose=this._register(new u.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new d(this,k,O,F,this._onData,(z,Y)=>this._write(z,Y))),this._register(this._flowManager.onError(z=>{console.error(z),(0,I.onUnexpectedError)(z),this._onClose.fire({type:0,hadError:!0,error:z})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(z=>this._acceptChunk(z))),this._register(this.socket.onClose(async z=>{this._flowManager.isProcessingReadQueue()&&await u.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(z)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let k=0;for(;k<P.byteLength;)this._flowManager.writeMessage(P.slice(k,Math.min(k+262144,P.byteLength)),{compressed:!0,opcode:2}),k+=262144}_write(P,{compressed:k,opcode:O}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let F=2;P.byteLength<126?F+=0:P.byteLength<2**16?F+=2:F+=8;const z=R.VSBuffer.alloc(F),Y=k?64:0,J=O&15;if(z.writeUInt8(128|Y|J,0),P.byteLength<126)z.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){z.writeUInt8(126,1);let oe=1;z.writeUInt8(P.byteLength>>>8&255,++oe),z.writeUInt8(P.byteLength>>>0&255,++oe)}else{z.writeUInt8(127,1);let oe=1;z.writeUInt8(0,++oe),z.writeUInt8(0,++oe),z.writeUInt8(0,++oe),z.writeUInt8(0,++oe),z.writeUInt8(P.byteLength>>>24&255,++oe),z.writeUInt8(P.byteLength>>>16&255,++oe),z.writeUInt8(P.byteLength>>>8&255,++oe),z.writeUInt8(P.byteLength>>>0&255,++oe)}this.socket.write(R.VSBuffer.concat([z,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),O=k.readUInt8(0),F=(O&128)>>>7,z=(O&64)>>>6,Y=O&15,J=k.readUInt8(1),oe=(J&128)>>>7,re=J&127;this._state.state=2,this._state.readLen=2+(oe?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!z),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this._state.opcode=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),O=k.readUInt8(1),F=(O&128)>>>7;let z=O&127,Y=1;z===126?z=k.readUInt8(++Y)*2**8+k.readUInt8(++Y):z===127&&(z=k.readUInt8(++Y)*0+k.readUInt8(++Y)*0+k.readUInt8(++Y)*0+k.readUInt8(++Y)*0+k.readUInt8(++Y)*2**24+k.readUInt8(++Y)*2**16+k.readUInt8(++Y)*2**8+k.readUInt8(++Y));let J=0;F&&(J=k.readUInt8(++Y)*2**24+k.readUInt8(++Y)*2**16+k.readUInt8(++Y)*2**8+k.readUInt8(++Y)),this._state.state=3,this._state.readLen=z,this._state.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),i(k,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(k,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await u.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class d extends a.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(P,k,O,F,z,Y){super(),this._tracer=P,this._onData=z,this._writeFn=Y,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new u.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new u.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,k?(this._zlibInflateStream=this._register(new E(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(J=>this._onError.fire(J))),this._register(this._zlibDeflateStream.onError(J=>this._onError.fire(J)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(P,k){this._writeQueue.push({data:P,options:k}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:P,options:k}=this._writeQueue.shift();if(this._zlibDeflateStream&&k.compressed){const O=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(O,k)}else this._writeFn(P,{...k,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,k){return new Promise((O,F)=>{P.write(k),P.flush(z=>O(z))})}acceptFrame(P,k,O){this._readQueue.push({data:P,isCompressed:k,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const k=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(k)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(P,k,O){return new Promise((F,z)=>{P.write(k),O&&P.write(R.VSBuffer.fromByteArray([0,0,255,255])),P.flush(Y=>F(Y))})}}class E extends a.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(P,k,O,F){super(),this._tracer=P,this._recordInflateBytes=k,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(F),this._zlibInflate.on("error",z=>{this._tracer.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibInflate.on("data",z=>{this._tracer.traceSocketEvent("zlibInflateData",z),this._pendingInflateData.push(R.VSBuffer.wrap(z))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const k=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(k)})}}class c extends a.Disposable{constructor(P,k){super(),this._tracer=P,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(R.VSBuffer.wrap(O))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let k=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.byteLength-4),P(k)})}}function i(M,P){if(P===0)return;const k=M.byteLength>>>2;for(let oe=0;oe<k;oe++){const re=M.readUInt32BE(oe*4);M.writeUInt32BE(re^P,oe*4)}const O=k*4,F=M.byteLength-O,z=P>>>24&255,Y=P>>>16&255,J=P>>>8&255;F>=1&&M.writeUInt8(M.readUInt8(O)^z,O),F>=2&&M.writeUInt8(M.readUInt8(O+1)^Y,O+1),F>=3&&M.writeUInt8(M.readUInt8(O+2)^J,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const M=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${M}-sock`;const P=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),k=(0,g.join)(P,`vscode-ipc-${M}.sock`);return n(k),k}e.createRandomIPCHandle=s;function t(M,P,k){const O=(0,C.createHash)("md5").update(M).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${k}-${P}-sock`;const F=k.substr(0,4),z=P.substr(0,6),Y=O.substr(0,8);let J;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?J=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-${Y}-${F}-${z}.sock`):J=(0,g.join)(M,`${F}-${z}.sock`),n(J),J}e.createStaticIPCHandle=t;function n(M){const P=o[w.platform];typeof P=="number"&&M.length>=P&&console.warn(`WARNING: IPC handle "${M}" is longer than ${P} chars, try a shorter --user-data-dir`)}class l extends h.IPCServer{static toClientConnectionEvent(P){const k=u.Event.fromNodeEventEmitter(P,"connection");return u.Event.map(k,O=>({protocol:new b.Protocol(new p(O,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(O,"close"))}))}constructor(P){super(l.toClientConnectionEvent(P)),this.server=P}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=l;function S(M){return new Promise((P,k)=>{const O=(0,L.createServer)();O.on("error",k),O.listen(M,()=>{O.removeListener("error",k),P(new l(O))})})}e.serve=S;function D(M,P){return new Promise((k,O)=>{const F=(0,L.createConnection)(M,()=>{F.removeListener("error",O),k(b.Client.fromSocket(new p(F,`ipc-client${P}`),P))});F.once("error",O)})}e.connect=D}),define(ie[24],ne([0,1,54,9,4,99,36,90,5]),function(G,e,C,L,r,A,R,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,u.refineServiceDecorator)(R.IEnvironmentService);class a extends I.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,A.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.isLinux){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const y=w.slice(0,-17);if(this._snapEnv[y])continue;process.env[y]&&(this._snapEnv[y]=process.env[y]),process.env[w]?process.env[y]=process.env[w]:delete process.env[y]}}}restoreSnapExportedVariables(){if(r.isLinux)for(const w in this._snapEnv)process.env[w]=this._snapEnv[w],delete this._snapEnv[w]}}e.EnvironmentMainService=a,Pe([C.memoize],a.prototype,"cachedLanguagesPath",null),Pe([C.memoize],a.prototype,"backupHome",null),Pe([C.memoize],a.prototype,"mainIPCHandle",null),Pe([C.memoize],a.prototype,"mainLockfile",null),Pe([C.memoize],a.prototype,"disableUpdates",null),Pe([C.memoize],a.prototype,"crossOriginIsolated",null),Pe([C.memoize],a.prototype,"codeCachePath",null),Pe([C.memoize],a.prototype,"useCodeCache",null)}),define(ie[283],ne([0,1,86,33,13,9,4,19,21,196,18,24,34,16,6,195,30,98]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let d=class{static{f=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(c,i,o,s){this.environmentMainService=c,this.configurationService=i,this.logService=o,this.stateService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,n)=>(0,L.isEqual)(t,n,!R.isLinux)}}async initialize(){const c=this.stateService.getItem(f.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWindows),this.workspaces=await this.validateWorkspaces((0,a.deserializeWorkspaceInfos)(c)),this.folders=await this.validateFolders((0,a.deserializeFolderInfos)(c)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(c,i){this.workspaces.some(s=>c.workspace.id===s.workspace.id)||(this.workspaces.push(c),this.storeWorkspacesMetadata());const o=(0,A.join)(this.backupHome,c.workspace.id);return i?this.moveBackupFolder(o,i).then(()=>o):o}async moveBackupFolder(c,i){if(await u.Promises.exists(c)&&await this.convertToEmptyWindowBackup(c),await u.Promises.exists(i))try{await u.Promises.rename(i,c,!1)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(c){return this.folders.some(i=>this.backupUriComparer.isEqual(c.folderUri,i.folderUri))||(this.folders.push(c),this.storeWorkspacesMetadata()),(0,A.join)(this.backupHome,this.getFolderHash(c))}registerEmptyWindowBackup(c){return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,c.backupFolder))||(this.emptyWindows.push(c),this.storeWorkspacesMetadata()),(0,A.join)(this.backupHome,c.backupFolder)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const i=new Set,o=[];for(const s of c){const t=s.workspace;if(!(0,v.isWorkspaceIdentifier)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,A.join)(this.backupHome,t.id);await this.doHasBackups(n)?t.configPath.scheme!==r.Schemas.file||await u.Promises.exists(t.configPath.fsPath)?o.push(s):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return o}async validateFolders(c){if(!Array.isArray(c))return[];const i=[],o=new Set;for(const s of c){const t=s.folderUri,n=this.backupUriComparer.getComparisonKey(t);if(!o.has(n)){o.add(n);const l=(0,A.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(l)?t.scheme!==r.Schemas.file||await u.Promises.exists(t.fsPath)?i.push(s):await this.convertToEmptyWindowBackup(l):await this.deleteStaleBackup(l)}}return i}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const i=[],o=new Set;for(const s of c){const t=s.backupFolder;if(typeof t!="string")return[];if(!o.has(t)){o.add(t);const n=(0,A.join)(this.backupHome,t);await this.doHasBackups(n)?i.push(s):await this.deleteStaleBackup(n)}}return i}async deleteStaleBackup(c){try{await u.Promises.rm(c,u.RimRafMode.MOVE)}catch(i){this.logService.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}prepareNewEmptyWindowBackup(){let c=(0,m.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,c.id));)c=(0,m.createEmptyWorkspaceIdentifier)();return{backupFolder:c.id}}async convertToEmptyWindowBackup(c){const i=this.prepareNewEmptyWindowBackup(),o=(0,A.join)(this.backupHome,i.backupFolder);try{await u.Promises.rename(c,o,!1)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(i),!0}async getDirtyWorkspaces(){const c=[];for(const i of this.workspaces)await this.hasBackups(i)&&c.push(i);for(const i of this.folders)await this.hasBackups(i)&&c.push(i);return c}hasBackups(c){let i;return(0,a.isEmptyWindowBackupInfo)(c)?i=(0,A.join)(this.backupHome,c.backupFolder):(0,p.isFolderBackupInfo)(c)?i=(0,A.join)(this.backupHome,this.getFolderHash(c)):i=(0,A.join)(this.backupHome,c.workspace.id),this.doHasBackups(i)}async doHasBackups(c){try{const i=await u.Promises.readdir(c);for(const o of i)try{if((await u.Promises.readdir((0,A.join)(c,o))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const c={workspaces:this.workspaces.map(({workspace:i,remoteAuthority:o})=>{const s={id:i.id,configURIPath:i.configPath.toString()};return o&&(s.remoteAuthority=o),s}),folders:this.folders.map(({folderUri:i,remoteAuthority:o})=>{const s={folderUri:i.toString()};return o&&(s.remoteAuthority=o),s}),emptyWindows:this.emptyWindows.map(({backupFolder:i,remoteAuthority:o})=>{const s={backupFolder:i};return o&&(s.remoteAuthority=o),s})};this.stateService.setItem(f.backupWorkspacesMetadataStorageKey,c)}getFolderHash(c){const i=c.folderUri;let o;return i.scheme===r.Schemas.file?o=R.isLinux?i.fsPath:i.fsPath.toLowerCase():o=i.toString().toLowerCase(),(0,C.createHash)("md5").update(o).digest("hex")}};e.BackupMainService=d,e.BackupMainService=d=f=Pe([te(0,w.IEnvironmentMainService),te(1,g.IConfigurationService),te(2,b.ILogService),te(3,y.IStateService)],d)}),define(ie[20],ne([0,1,15,38,8,3,2,4,35,12,5,6,34,24]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,g.createDecorator)("lifecycleMainService");var p;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(p||(e.ShutdownReason=p={}));var v;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(v||(e.LifecycleMainPhase=v={}));let m=class extends R.Disposable{static{b=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(d,E,c){super(),this.logService=d,this.stateService=E,this.environmentMainService=c,this._onBeforeShutdown=this._register(new A.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new A.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new A.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new A.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(b.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(b.QUIT_AND_RESTART_KEY)}registerListeners(){const d=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};C.app.addListener("before-quit",d);const E=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&C.app.quit()};C.app.addListener("window-all-closed",E),C.app.once("will-quit",c=>{this.trace("Lifecycle#app.on(will-quit) - begin"),c.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),C.app.removeListener("before-quit",d),C.app.removeListener("window-all-closed",E),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),C.app.quit()})})}fireOnWillShutdown(d){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const E=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const c=[];return this._onWillShutdown.fire({reason:d,join(i,o){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),c.push(o.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(c)}catch(i){this.logService.error(i)}try{await this.stateService.close()}catch(i){this.logService.error(i)}})(),this.pendingWillShutdownPromise}set phase(d){if(d<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===d)return;this.trace(`lifecycle (main): phase changed (value: ${d})`),this._phase=d;const E=this.phaseWhen.get(this._phase);E&&(E.open(),this.phaseWhen.delete(this._phase))}async when(d){if(d<=this._phase)return;let E=this.phaseWhen.get(d);E||(E=new r.Barrier,this.phaseWhen.set(d,E)),await E.wait()}registerWindow(d){const E=new R.DisposableStore;this.windowCounter++,E.add(d.onWillLoad(i=>this._onWillLoadWindow.fire({window:d,workspace:i.workspace,reason:i.reason})));const c=(0,a.assertIsDefined)(d.win);c.on("close",i=>{const o=d.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.trace(`Lifecycle#window.on('close') - window ID ${d.id}`),i.preventDefault(),this.unload(d,1).then(s=>{if(s){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(d),d.close()})}),c.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${d.id}`),this.windowCounter--,E.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(d,E){await this.unload(d,3)||d.reload(E)}unload(d,E){const c=this.mapWindowIdToPendingUnload.get(d.id);if(c)return c;const i=this.doUnload(d,E).finally(()=>{this.mapWindowIdToPendingUnload.delete(d.id)});return this.mapWindowIdToPendingUnload.set(d.id,i),i}async doUnload(d,E){if(!d.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${d.id}`);const c=this._quitRequested?2:E,i=await this.onBeforeUnloadWindowInRenderer(d,c);return i?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${d.id})`),this.handleWindowUnloadVeto(i)):(await this.onWillUnloadWindowInRenderer(d,c),!1)}handleWindowUnloadVeto(d){return d?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(d){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(d),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(d,E){return new Promise(c=>{const i=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${i}`,s=`vscode:cancel${i}`;L.validatedIpcMain.once(o,()=>{c(!1)}),L.validatedIpcMain.once(s,()=>{c(!0)}),d.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:E})})}onWillUnloadWindowInRenderer(d,E){return new Promise(c=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(o,()=>c()),d.send("vscode:onWillUnload",{replyChannel:o,reason:E})})}quit(d){return this.doQuit(d).then(E=>{if(!E&&d)try{if(I.isWindows){const c=(0,u.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}return E})}doQuit(d){return this.trace(`Lifecycle#quit() - begin (willRestart: ${d})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(d&&this.stateService.setItem(b.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(E=>{this.pendingQuitPromiseResolve=E,this.trace("Lifecycle#quit() - calling app.quit()"),C.app.quit()}),this.pendingQuitPromise)}trace(d){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(d):this.logService.trace(d)}setRelaunchHandler(d){this.relaunchHandler=d}async relaunch(d){this.trace("Lifecycle#relaunch()");const E=process.argv.slice(1);if(d?.addArgs&&E.push(...d.addArgs),d?.removeArgs)for(const o of d.removeArgs){const s=E.indexOf(o);s>=0&&E.splice(s,1)}const c=()=>{this.relaunchHandler?.handleRelaunch(d)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),C.app.relaunch({args:E}))};C.app.once("quit",c),await this.quit(!0)&&C.app.removeListener("quit",c)}async kill(d){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const E of C.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let c;E.webContents&&!E.webContents.isDestroyed()?c=new Promise(i=>E.once("closed",i)):c=Promise.resolve(),E.destroy(),await c}})()]),C.app.exit(d)}};e.LifecycleMainService=m,e.LifecycleMainService=m=b=Pe([te(0,w.ILogService),te(1,y.IStateService),te(2,h.IEnvironmentMainService)],m)}),define(ie[284],ne([0,1,4,3,2,5,20]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let I=class extends r.Disposable{constructor(g){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,g.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const g=await new Promise((w,y)=>{G(["native-keymap"],w,y)});this._keyboardLayoutData=u(g),C.isCI||g.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=u(g),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=I,e.KeyboardLayoutMainService=I=Pe([te(0,R.ILifecycleMainService)],I);function u(a){const g=a.getKeyMap(),w=a.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:w}}}),define(ie[285],ne([0,1,246,8,17,14,12,18,36,94,6,50,245,282]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let b=class extends w.AbstractRequestService{constructor(f,d,E,c){super(c),this.configurationService=f,this.environmentService=d,this.logService=E,this.configure(),this._register(f.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.configure()}))}configure(){const f=this.configurationService.getValue("http");this.proxyUrl=f?.proxy,this.strictSSL=!!f?.proxyStrictSSL,this.authorization=f?.proxyAuthorization}async request(f,d){const{proxyUrl:E,strictSSL:c}=this;let i;try{i=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(t){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(t)))}const o={...process.env,...i},s=f.agent?f.agent:await(0,y.getProxyAgent)(f.url||"",o,{proxyUrl:E,strictSSL:c});return f.agent=s,f.strictSSL=c,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(f.isChromiumNetwork?"electron":"node",f,()=>v(f,d))}async resolveProxy(f){}};e.RequestService=b,e.RequestService=b=Pe([te(0,I.IConfigurationService),te(1,u.INativeEnvironmentService),te(2,g.ILogService),te(3,g.ILoggerService)],b);async function p(m){return((0,C.parse)(m.url).protocol==="https:"?await new Promise((E,c)=>{G(["https"],E,c)}):await new Promise((E,c)=>{G(["http"],E,c)})).request}async function v(m,f){return L.Promises.withAsyncBody(async(d,E)=>{const c=(0,C.parse)(m.url),i=m.getRawRequest?m.getRawRequest(m):await p(m),o={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,R.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(o.auth=m.user+":"+m.password);const s=i(o,t=>{const n=(0,R.isNumber)(m.followRedirects)?m.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)v({...m,url:t.headers.location,followRedirects:n-1},f).then(d,E);else{let l=t;!m.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(l=t.pipe((0,h.createGunzip)())),d({res:t,stream:(0,r.streamToBufferReadableStream)(l)})}});s.on("error",E),m.timeout&&s.setTimeout(m.timeout),m.isChromiumNetwork&&s.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&s.write(m.data),s.end(),f.onCancellationRequested(()=>{s.abort(),E(new A.CancellationError)})})}e.nodeRequest=v}),define(ie[286],ne([0,1,15,285]),function(G,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(R){return C.net.request}class A extends L.RequestService{request(I,u){return super.request({...I||{},getRawRequest:r,isChromiumNetwork:!0},u)}}e.RequestMainService=A}),define(ie[82],ne([0,1,7,3,2,36,16,5,20,6,96,279,41,52,40,13]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,I.createDecorator)("storageMainService");let v=class extends r.Disposable{constructor(d,E,c,i,o,s){super(),this.logService=d,this.environmentService=E,this.userDataProfilesService=c,this.lifecycleMainService=i,this.fileService=o,this.uriIdentityService=s,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new L.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(d=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=d.reason,d.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.mapProfileToStorage)d.join("profileStorage",E.close());for(const[,E]of this.mapWorkspaceToStorage)d.join("workspaceStorage",E.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(d=>{d.join((async()=>{await this.fileService.exists(d.profile.globalStorageHome)||await this.fileService.createFolder(d.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(d=>{const E=this.mapProfileToStorage.get(d.profile.id);E&&d.join(E.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const d=new w.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(L.Event.once(d.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),d}profileStorage(d){if((0,g.isProfileUsingDefaultStorage)(d))return this.applicationStorage;let E=this.mapProfileToStorage.get(d.id);if(!E){this.logService.trace(`StorageMainService: creating profile storage (${d.name})`),E=this._register(this.createProfileStorage(d)),this.mapProfileToStorage.set(d.id,E);const c=this._register(E.onDidChangeStorage(i=>this._onDidChangeProfileStorage.fire({...i,storage:E,profile:d})));this._register(L.Event.once(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${d.name})`),this.mapProfileToStorage.delete(d.id),c.dispose()}))}return E}createProfileStorage(d){return this.shutdownReason===2?new w.InMemoryStorageMain(this.logService,this.fileService):new w.ProfileStorageMain(d,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(d){let E=this.mapWorkspaceToStorage.get(d.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${d.id})`),E=this._register(this.createWorkspaceStorage(d)),this.mapWorkspaceToStorage.set(d.id,E),this._register(L.Event.once(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${d.id})`),this.mapWorkspaceToStorage.delete(d.id)}))),E}createWorkspaceStorage(d){return this.shutdownReason===2?new w.InMemoryStorageMain(this.logService,this.fileService):new w.WorkspaceStorageMain(d,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(d){const E=C.URI.file(d);for(const c of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(c.path&&this.uriIdentityService.extUri.isEqualOrParent(C.URI.file(c.path),E))return!0;return!1}};e.StorageMainService=v,e.StorageMainService=v=Pe([te(0,a.ILogService),te(1,A.IEnvironmentService),te(2,h.IUserDataProfilesMainService),te(3,u.ILifecycleMainService),te(4,R.IFileService),te(5,b.IUriIdentityService)],v),e.IApplicationStorageMainService=(0,I.createDecorator)("applicationStorageMainService");let m=class extends g.AbstractStorageService{constructor(d,E){super(),this.userDataProfilesService=d,this.storageMainService=E,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(d){if(d===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(d){if(d===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=m,e.ApplicationStorageMainService=m=Pe([te(0,y.IUserDataProfilesService),te(1,e.IStorageMainService)],m)}),define(ie[287],ne([0,1,87,28,103,99,8,2,4,18,6,25,241,242,95,126,17]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function m(i,o,s,t,n){let l;for(let S=3;S&&(l?.dispose(),l=await new f(i,o,s,t,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));S--);return l}class f extends I.Disposable{constructor(o,s,t,n,l){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=l,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=C.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=S=>this._onConnection(S),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,p.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let t=await(0,r.findFreePortFaster)(o,2,1e3,s),n=null;return this._server.listen(t,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(t=0,this._server.listen(t,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(o){o.pause();const s=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,y.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),n=t.getSocket(),l=t.readEntireBuffer();t.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),n instanceof A.NodeSocket?n.socket.destroy():n.end()}),n instanceof A.NodeSocket?this._mirrorNodeSocket(o,n):this._mirrorGenericSocket(o,n),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),n.end()})}_mirrorGenericSocket(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(t=>o.write(t.buffer)),o.on("data",t=>s.write(v.VSBuffer.wrap(t))),o.resume()}_mirrorNodeSocket(o,s){const t=s.socket;t.on("end",()=>o.end()),t.on("close",()=>o.end()),t.on("error",()=>{o.destroy()}),t.pipe(o),o.pipe(t)}}e.NodeRemoteTunnel=f;let d=class extends p.AbstractTunnelService{constructor(o,s,t,n,l){super(s,l),this.remoteSocketFactoryService=o,this.signService=t,this.productService=n}isPortPrivileged(o){return(0,p.isPortPrivileged)(o,this.defaultTunnelHost,u.OS,L.release())}retainOrCreateTunnel(o,s,t,n,l,S,D,M){const P=this.getTunnelFromMap(s,t);if(P)return++P.refcount,P.value;if((0,p.isTunnelProvider)(o))return this.createWithProvider(o,s,t,l,S,D,M);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${t} on local port ${l}.`);const k={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},O=m(k,n,s,t,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,t,O),O}}};e.BaseTunnelService=d,e.BaseTunnelService=d=Pe([te(0,h.IRemoteSocketFactoryService),te(1,g.ILogService),te(2,b.ISignService),te(3,w.IProductService),te(4,a.IConfigurationService)],d);let E=class extends d{constructor(o,s,t,n,l){super(o,s,t,n,l)}};e.TunnelService=E,e.TunnelService=E=Pe([te(0,h.IRemoteSocketFactoryService),te(1,g.ILogService),te(2,b.ISignService),te(3,w.IProductService),te(4,a.IConfigurationService)],E);let c=class extends I.Disposable{constructor(o,s,t,n,l){super(),this.remoteSocketFactoryService=o,this.logService=s,this.productService=t,this.signService=n,this.configurationService=l,this._tunnelServices=new Map}async openTunnel(o,s,t,n,l,S,D,M,P){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${S}.`),!this._tunnelServices.has(o)){const k=new E(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(k),this._tunnelServices.set(o,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(s,t,n,l,S,D,M,P)}};e.SharedTunnelsService=c,e.SharedTunnelsService=c=Pe([te(0,h.IRemoteSocketFactoryService),te(1,g.ILogService),te(2,w.IProductService),te(3,b.ISignService),te(4,a.IConfigurationService)],c)}),define(ie[100],ne([0,1,8,22,3,18,24,20,6,25,50,48]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(b,p,v){return`${v.updateUrl}/api/update/${b}/${p}/${v.commit}`}e.createUpdateURL=y;let h=class{get state(){return this._state}setState(p){this.logService.info("update#setState",p.type),this._state=p,this._onStateChange.fire(p)}constructor(p,v,m,f,d,E){this.lifecycleMainService=p,this.configurationService=v,this.environmentMainService=m,this.requestService=f,this.logService=d,this.productService=E,this._state=w.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,p.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(w.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(w.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(w.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.configurationService.getValue("update.mode"),v=this.getProductQuality(p);if(!v){this.setState(w.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(v),!this.url){this.setState(w.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(w.State.Idle(this.getUpdateType())),p==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}getProductQuality(p){return p==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(p=60*60*1e3){return(0,C.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(p){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(p)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(p){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(p=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(v){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(v);return}}async _applySpecificUpdate(p){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=h,e.AbstractUpdateService=h=Pe([te(0,I.ILifecycleMainService),te(1,A.IConfigurationService),te(2,R.IEnvironmentMainService),te(3,g.IRequestService),te(4,u.ILogService),te(5,a.IProductService)],h)}),define(ie[288],ne([0,1,15,54,3,2,18,24,20,6,25,50,26,48,100]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=class extends b.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"error",(m,f)=>f)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-available",(m,f,d)=>({url:f,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-downloaded",(m,f,d,E)=>({releaseNotes:f,version:d,productVersion:d,date:E}))}constructor(m,f,d,E,c,i,o){super(m,f,E,c,i,o),this.telemetryService=d,this.disposables=new A.DisposableStore,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(m){this.logService.error("UpdateService error:",m);const f=this.state.type==="checking for updates"&&this.state.explicit?m:void 0;this.setState(h.State.Idle(1,f))}buildUpdateFeedUrl(m){let f;this.productService.darwinUniversalAssetId?f=this.productService.darwinUniversalAssetId:f=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,b.createUpdateURL)(f,m,this.productService);try{C.autoUpdater.setFeedURL({url:d})}catch(E){this.logService.error("Failed to set update feed URL",E);return}return d}doCheckForUpdates(m){this.setState(h.State.CheckingForUpdates(m)),C.autoUpdater.checkForUpdates()}onUpdateAvailable(m){this.state.type==="checking for updates"&&this.setState(h.State.Downloading(m))}onUpdateDownloaded(m){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:m.version}),this.setState(h.State.Ready(m)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(h.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),C.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=p,Pe([L.memoize],p.prototype,"onRawError",null),Pe([L.memoize],p.prototype,"onRawUpdateNotAvailable",null),Pe([L.memoize],p.prototype,"onRawUpdateAvailable",null),Pe([L.memoize],p.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=p=Pe([te(0,u.ILifecycleMainService),te(1,R.IConfigurationService),te(2,y.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,w.IRequestService),te(5,a.ILogService),te(6,g.IProductService)],p)}),define(ie[289],ne([0,1,47,45,8,3,9,24,20,6,26,48]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this._state}setState(p){this.logService.info("update#setState",p.type),this._state=p,this._onStateChange.fire(p)}constructor(p,v,m){if(this.lifecycleMainService=p,this.logService=m,this._state=w.State.Uninitialized,this._onStateChange=new A.Emitter,this.onStateChange=this._onStateChange.event,v.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(w.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,f=>this.logService.error(f))}scheduleCheckForUpdates(p=60*60*1e3){return(0,r.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(p){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(p)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(p){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(p=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(p){}};y=Pe([te(0,u.ILifecycleMainService),te(1,I.IEnvironmentMainService),te(2,a.ILogService)],y);let h=class extends y{constructor(p,v,m,f,d,E){super(m,f,d),this.snap=p,this.snapRevision=v,this.telemetryService=E;const c=(0,L.watch)(R.dirname(this.snap)),i=A.Event.fromNodeEventEmitter(c,"change",(n,l)=>l),o=A.Event.filter(i,n=>n==="current"),t=A.Event.debounce(o,(n,l)=>l,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{t.dispose(),c.close()})}doCheckForUpdates(){this.setState(w.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(p=>{p?this.setState(w.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(w.State.Idle(2)))},p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(w.State.Idle(2,p.message||p))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,C.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const p=await new Promise((m,f)=>(0,L.realpath)(`${R.dirname(this.snap)}/current`,(d,E)=>d?f(d):m(E))),v=R.basename(p);return this.snapRevision!==v}isLatestVersion(){return this.isUpdateAvailable().then(void 0,p=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=h,e.SnapUpdateService=h=Pe([te(2,u.ILifecycleMainService),te(3,I.IEnvironmentMainService),te(4,a.ILogService),te(5,g.ITelemetryService)],h)}),define(ie[29],ne([0,1,4,5,68,67,25,18,24,9,78]),function(G,e,C,L,r,A,R,I,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLastFocused=e.getFocusedOrLastActiveWindow=e.defaultBrowserWindowOptions=e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,L.createDecorator)("windowsMainService");var w;(function(p){p[p.CLI=0]="CLI",p[p.DOCK=1]="DOCK",p[p.MENU=2]="MENU",p[p.DIALOG=3]="DIALOG",p[p.DESKTOP=4]="DESKTOP",p[p.API=5]="API"})(w||(e.OpenContext=w={}));function y(p,v,m){const f=p.get(A.IThemeMainService),d=p.get(R.IProductService),E=p.get(I.IConfigurationService),c=p.get(u.IEnvironmentMainService),i=E.getValue("window"),o={backgroundColor:f.getBackgroundColor(),minWidth:r.WindowMinimumSize.WIDTH,minHeight:r.WindowMinimumSize.HEIGHT,title:d.nameLong,...m,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,r.zoomLevelToZoomFactor)(i?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...m?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return v&&(o.x=v.x,o.y=v.y,o.width=v.width,o.height=v.height),C.isLinux?o.icon=(0,a.join)(c.appRoot,"resources/linux/code.png"):C.isWindows&&!c.isBuilt&&(o.icon=(0,a.join)(c.appRoot,"resources/win32/code_150x150.png")),C.isMacintosh&&(o.acceptFirstMouse=!0,i?.clickThroughInactive===!1&&(o.acceptFirstMouse=!1)),o}e.defaultBrowserWindowOptions=y;function h(p){const v=p.get(e.IWindowsMainService),m=p.get(g.IAuxiliaryWindowsMainService),f=v.getFocusedWindow()??m.getFocusedWindow();if(f)return f;const d=v.getLastActiveWindow(),E=m.getLastActiveWindow();return d&&E?d.lastFocusTime<E.lastFocusTime?E:d:d??E}e.getFocusedOrLastActiveWindow=h;function b(p){let v,m=Number.MIN_VALUE;for(const f of p)f.lastFocusTime>m&&(m=f.lastFocusTime,v=f);return v}e.getLastFocused=b}),define(ie[290],ne([0,1,15,22,3,55,2,32,116,6,82,29]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let h=class extends R.Disposable{constructor(p,v,m,f){super(),this.logService=p,this.windowsMainService=v,this.encryptionMainService=m,this.applicationStorageMainService=f,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const p=r.Event.fromNodeEventEmitter(C.app,"login",(v,m,f,d,E)=>({event:v,webContents:m,req:f,authInfo:d,callback:E}));this._register(p(this.onLogin,this))}async onLogin({event:p,authInfo:v,req:m,callback:f}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&m.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let d;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),d=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{d=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(d?.username,d?.password)}async resolveProxyCredentials(p){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(p);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(p){this.logService.trace("auth#doResolveProxyCredentials - enter",p);const v=String((0,A.hash)({scheme:p.scheme,host:p.host,port:p.port}));let m,f;try{const i=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+v,-1);if(i){const o=JSON.parse(await this.encryptionMainService.decrypt(i));m=o.username,f=o.password}}catch(i){this.logService.error(i)}if(this.state!==y.StoredCredentialsUsed&&typeof m=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:m,password:f};const d=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!d){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${d.id} to handle proxy login`);const E={authInfo:p,username:this.sessionCredentials?.username??m,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};d.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,E),this.state=y.LoginDialogShown;const c=await new Promise(i=>{const o=async(s,t,n)=>{if(t===E.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${d.id}`),d.win?.webContents.off("ipc-message",o),n){const l={username:n.username,password:n.password};try{if(n.remember){const S=await this.encryptionMainService.encrypt(JSON.stringify(l));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+v,S,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+v,-1)}catch(S){this.logService.error(S)}i({username:l.username,password:l.password})}else i(void 0)};d.win?.webContents.on("ipc-message",o)});return this.sessionCredentials=c,c}};e.ProxyAuthHandler=h,e.ProxyAuthHandler=h=Pe([te(0,a.ILogService),te(1,w.IWindowsMainService),te(2,u.IEncryptionMainService),te(3,g.IApplicationStorageMainService)],h)}),define(ie[291],ne([0,1,15,23,4,7,21,18,62,5,6,127,29]),function(G,e,C,L,r,A,R,I,u,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,a.createDecorator)(e.ID);let h=class{constructor(p,v,m,f){this.logService=p,this.windowsMainService=v,this.urlService=m,this.configurationService=f}async start(p,v){this.logService.trace("Received data from other instance: ",p,v),r.isMacintosh&&C.app.focus({steal:!0});const m=this.parseOpenUrl(p);if(m.length){let f=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const d=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));d&&(f=d.ready())}f.then(()=>{for(const{uri:d,originalUrl:E}of m)this.urlService.open(d,{originalUrl:E})})}else return this.startOpenWindow(p,v)}parseOpenUrl(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,L.coalesce)(p._urls.map(v=>{try{return{uri:A.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async startOpenWindow(p,v){const m=(0,u.isLaunchedFromCli)(v)?0:4;let f=[];const d=p.wait&&p.waitMarkerFilePath?A.URI.file(p.waitMarkerFilePath):void 0,E=p.remote||void 0,c={context:m,cli:p,userEnv:v,waitMarkerFileURI:d,remoteAuthority:E,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,c);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let i=!1;if(p["new-window"]||p["unity-launch"]||c.forceProfile||c.forceTempProfile)i=!0;else if(p["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!r.isMacintosh}if(i)f=await this.windowsMainService.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,c),f=[o]):f=await this.windowsMainService.open({...c,forceEmpty:!0})}}else f=await this.windowsMainService.open({...c,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(d&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,R.whenDeleted)(d.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=h,e.LaunchMainService=h=Pe([te(0,g.ILogService),te(1,y.IWindowsMainService),te(2,w.IURLService),te(3,I.IConfigurationService)],h)}),define(ie[292],ne([0,1,2,20,52,30,8,29]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let u=class extends C.Disposable{constructor(g,w,y){super(),this.userDataProfilesService=w,this.windowsMainService=y,this._register(g.onWillLoadWindow(h=>{h.reason===2&&this.unsetProfileForWorkspace(h.window)})),this._register(g.onBeforeCloseWindow(h=>this.unsetProfileForWorkspace(h))),this._register(new R.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(g){const w=this.getWorkspace(g),y=this.userDataProfilesService.getProfileForWorkspace(w);y?.isTransient&&(this.userDataProfilesService.unsetWorkspace(w,y.isTransient),y.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(g){return g.openedWorkspace??(0,A.toWorkspaceIdentifier)(g.backupPath,g.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const g=this.userDataProfilesService.getAssociatedEmptyWindows();if(g.length===0)return;const w=this.windowsMainService.getWindows().map(y=>this.getWorkspace(y));for(const y of g)w.some(h=>h.id===y.id)||this.userDataProfilesService.unsetWorkspace(y,!1)}};e.UserDataProfilesHandler=u,e.UserDataProfilesHandler=u=Pe([te(0,L.ILifecycleMainService),te(1,r.IUserDataProfilesMainService),te(2,I.IWindowsMainService)],u)}),define(ie[60],ne([0,1,15,2,3,6,313,8,13,29,73,26,20,75,37,4,131]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function f(c){return typeof c.responseWindowId=="number"}let d=class extends L.Disposable{static{m=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(m.all.values())}constructor(i,o,s){super(),this.logService=i,this.telemetryService=o,this.lifecycleMainService=s,this.id=String(++m.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(i,o){let s;switch(this.configuration?.correlationId?s=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${i}`:s=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${i}`,o){case g.default.Error:this.logService.error(s);break;case g.default.Warning:this.logService.warn(s);break;case g.default.Info:this.logService.trace(s);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(i){const o=this.doStart(i);return o&&i.payload&&this.postMessage(i.payload),o}doStart(i){if(!this.validateCanStart())return!1;this.configuration=i;const o=`${this.configuration.type}-${this.id}`,s=u.FileAccess.asFileUri("bootstrap-fork.js").fsPath,t=this.configuration.args??[],n=this.configuration.execArgv??[],l=this.configuration.allowLoadingUnsignedLibraries,S=this.configuration.forceAllocationsToV8Sandbox,D="pipe",M=this.createEnv(i);return this.log("creating new...",g.default.Info),this.process=C.utilityProcess.fork(s,t,{serviceName:o,env:M,execArgv:n,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:S,stdio:D}),this.registerListeners(this.process,this.configuration,o),!0}createEnv(i){const o=i.env?{...i.env}:{...(0,b.deepClone)(process.env)};o.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,p.isWindows&&((0,v.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,h.removeDangerousEnvVariables)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}registerListeners(i,o,s){if(i.stdout){const t=new R.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this._onStdout.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new R.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this._onStderr.fire(typeof n=="string"?n:t.write(n))))}this._register(r.Event.fromNodeEventEmitter(i,"message")(t=>this._onMessage.fire(t))),this._register(r.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.processPid=i.pid,typeof i.pid=="number"&&m.all.set(i.pid,{pid:i.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.log("successfully created",g.default.Info)})),this._register(r.Event.fromNodeEventEmitter(i,"exit")(t=>{this.log(`received exit event with code ${t}`,g.default.Info),this._onExit.fire({pid:this.processPid,code:t,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(C.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===s&&(this.log(`crashed with code ${t.exitCode} and reason '${t.reason}'`,g.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:o.type,reason:t.reason,code:t.exitCode}),this._onCrash.fire({pid:this.processPid,code:t.exitCode,reason:t.reason}),this.onDidExitOrCrashOrKill())}))}once(i,o){const s=this._register(this._onMessage.event(t=>{t===i&&(s.dispose(),o())}))}postMessage(i,o){this.process&&this.process.postMessage(i,o)}connect(i){const{port1:o,port2:s}=new C.MessageChannelMain;return this.postMessage(i,[s]),o}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",g.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",g.default.Info),this.process.kill()?(this.log("successfully killed the process",g.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",g.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&m.all.delete(this.processPid),this.process=void 0}async waitForExit(i){this.process&&(this.log("waiting to exit...",g.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,I.timeout)(i)]),this.process&&(this.log(`did not exit within ${i}ms, will kill it now...`,g.default.Info),this.kill()))}};e.UtilityProcess=d,e.UtilityProcess=d=m=Pe([te(0,A.ILogService),te(1,w.ITelemetryService),te(2,y.ILifecycleMainService)],d);let E=class extends d{constructor(i,o,s,t){super(i,s,t),this.windowsMainService=o}start(i){const o=this.windowsMainService.getWindowById(i.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.doStart(i))return!1;this.registerWindowListeners(o.win,i);const t=this.connect(i.payload);return o.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}registerWindowListeners(i,o){o.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===i)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=E,e.WindowUtilityProcess=E=Pe([te(0,A.ILogService),te(1,a.IWindowsMainService),te(2,w.ITelemetryService),te(3,y.ILifecycleMainService)],E)}),define(ie[293],ne([0,1,14,6,20,8,60,29,26]),function(G,e,C,L,r,A,R,I,u){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let g=class{static{a=this}static{this._lastId=0}constructor(y,h,b,p){this._logService=y,this._lifecycleMainService=h,this._windowsMainService=b,this._telemetryService=p,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(v=>{this._shutdown=!0,v.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(y){const h=this._extHosts.get(y);if(!h)throw new Error("Unknown extension host!");return h}onDynamicStdout(y){return this._getExtHost(y).onStdout}onDynamicStderr(y){return this._getExtHost(y).onStderr}onDynamicMessage(y){return this._getExtHost(y).onMessage}onDynamicExit(y){return this._getExtHost(y).onExit}async createExtensionHost(){if(this._shutdown)throw(0,C.canceled)();const y=String(++a._lastId),h=new R.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(y,h),h.onExit(({pid:b,code:p,signal:v})=>{this._logService.info(`Extension host with pid ${b} exited with code: ${p}, signal: ${v}.`),setTimeout(()=>{h.dispose(),this._extHosts.delete(y)}),setTimeout(()=>{try{process.kill(b,0),this._logService.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)}),{id:y}}async start(y,h){if(this._shutdown)throw(0,C.canceled)();this._getExtHost(y).start({...h,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:h.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this._shutdown)throw(0,C.canceled)();const h=this._extHosts.get(y);return h?h.enableInspectPort():!1}async kill(y){if(this._shutdown)throw(0,C.canceled)();const h=this._extHosts.get(y);h&&h.kill()}async _killAllNow(){for(const[,y]of this._extHosts)y.kill()}async _waitForAllExit(y){const h=[];for(const[,b]of this._extHosts)h.push(b.waitForExit(y));return A.Promises.settled(h).then(()=>{})}};e.ExtensionHostStarter=g,e.ExtensionHostStarter=g=a=Pe([te(0,L.ILogService),te(1,r.ILifecycleMainService),te(2,I.IWindowsMainService),te(3,u.ITelemetryService)],g)}),define(ie[294],ne([0,1,38,8,2,24,20,6,41,39,66,60,51,90,12,247]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let v=class extends r.Disposable{constructor(f,d,E,c,i,o,s,t){super(),this.machineId=f,this.sqmId=d,this.environmentMainService=E,this.userDataProfilesService=c,this.lifecycleMainService=i,this.logService=o,this.loggerMainService=s,this.policyService=t,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){C.validatedIpcMain.on(p.SharedProcessChannelConnection.request,(f,d)=>this.onWindowConnection(f,d,p.SharedProcessChannelConnection.response)),C.validatedIpcMain.on(p.SharedProcessRawConnection.request,(f,d)=>this.onWindowConnection(f,d,p.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(f,d,E){this.logService.trace(`[SharedProcess] onWindowConnection for: ${E}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect(E);if(f.sender.isDestroyed())return c.close();f.sender.postMessage(E,d,[c])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(p.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const f=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(p.SharedProcessLifecycle.initDone,()=>f.complete()):C.validatedIpcMain.once(p.SharedProcessLifecycle.initDone,()=>f.complete()),await f.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const f=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(p.SharedProcessLifecycle.ipcReady,()=>f.complete()):C.validatedIpcMain.once(p.SharedProcessLifecycle.ipcReady,()=>f.complete()),await f.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new w.UtilityProcess(this.logService,y.NullTelemetryService,this.lifecycleMainService));const f=(0,h.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let d;f.port&&(d=["--nolazy"],f.break?d.push(`--inspect-brk=${f.port}`):d.push(`--inspect=${f.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:d})}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(f){return await this.whenIpcReady,(0,b.assertIsDefined)(this.utilityProcess).connect(f)}};e.SharedProcess=v,e.SharedProcess=v=Pe([te(2,A.IEnvironmentMainService),te(3,u.IUserDataProfilesService),te(4,R.ILifecycleMainService),te(5,I.ILogService),te(6,g.ILoggerMainService),te(7,a.IPolicyService)],v)}),define(ie[295],ne([0,1,24,90,20,6,51,60,110,38,2,3,37,18,13]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let p=class extends g.Disposable{constructor(m,f,d,E,c){super(),this._reconnectConstants=m,this._configurationService=f,this._environmentMainService=d,this._lifecycleMainService=E,this._logService=c,this.utilityProcess=void 0,this._onRequestConnection=new w.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new w.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),a.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(i,o)=>this._onWindowConnection(i,o)),this._register((0,g.toDisposable)(()=>{a.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new I.UtilityProcess(this._logService,R.NullTelemetryService,this._lifecycleMainService);const m=(0,L.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),f=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:b.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const d=this.utilityProcess.connect(),E=new u.Client(d,"ptyHost"),c=new g.DisposableStore;return c.add(E),c.add((0,g.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:E,store:c,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const m={...(0,y.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},f=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(m.VSCODE_LATENCY=String(f));const d=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return d&&typeof d=="number"&&(m.VSCODE_STARTUP_DELAY=String(d)),this._environmentMainService.restoreSnapExportedVariables(),m}_onWindowConnection(m,f){this._onRequestConnection.fire();const d=this.utilityProcess.connect();if(m.sender.isDestroyed()){d.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[d])}};e.ElectronPtyHostStarter=p,e.ElectronPtyHostStarter=p=Pe([te(1,h.IConfigurationService),te(2,C.IEnvironmentMainService),te(3,r.ILifecycleMainService),te(4,A.ILogService)],p)}),define(ie[296],ne([0,1,2,5,6,29,60,26,55,3,8,20]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let y=class extends C.Disposable{constructor(p,v,m,f){super(),this.logService=p,this.windowsMainService=v,this.telemetryService=m,this.lifecycleMainService=f,this.workers=new Map}async createWorker(p){const v=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${v})`);const m=this.hash(p);this.workers.has(m)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(p));const f=new h(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,p);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(m,f);const d=new g.DeferredPromise;return a.Event.once(f.onDidTerminate)(E=>{E.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.workers.delete(m),d.complete({reason:E})}),d.p}hash(p){return(0,u.hash)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const v=this.hash(p),m=this.workers.get(v);m&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),m.kill(),this.workers.delete(v))}};e.UtilityProcessWorkerMainService=y,e.UtilityProcessWorkerMainService=y=Pe([te(0,r.ILogService),te(1,A.IWindowsMainService),te(2,I.ITelemetryService),te(3,w.ILifecycleMainService)],y);let h=class extends C.Disposable{constructor(p,v,m,f,d){super(),this.logService=p,this.windowsMainService=v,this.telemetryService=m,this.lifecycleMainService=f,this.configuration=d,this._onDidTerminate=this._register(new a.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new R.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(p=>this._onDidTerminate.fire({code:p.code,signal:p.signal}))),this._register(this.utilityProcess.onCrash(p=>this._onDidTerminate.fire({code:p.code,signal:"ECRASH"})))}spawn(){const v=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};h=Pe([te(0,r.ILogService),te(1,A.IWindowsMainService),te(2,I.ITelemetryService),te(3,w.ILifecycleMainService)],h)}),define(ie[297],ne([0,1,15,3,2,273,29]),function(G,e,C,L,r,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends r.Disposable{constructor(a){super(),this.windowsMainService=a,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(a,g){let w;if(typeof a.windowId=="number"){const{windowId:y}=a,h=this.windowsMainService.getWindowById(y);if(!h?.win)throw new Error(`Invalid windowId: ${y}`);w=h.win.webContents}else{const{webContentsId:y}=a;if(w=C.webContents.fromId(y),!w)throw new Error(`Invalid webContentsId: ${y}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(g)}async findInFrame(a,g,w,y){const b=this.getFrameByName(a,g);if(typeof b.findInFrame=="function"){b.findInFrame(w,{findNext:y.findNext,forward:y.forward});const p=(v,m)=>{m.finalUpdate&&(this._onFoundInFrame.fire(m),b.removeListener("found-in-frame",p))};b.on("found-in-frame",p)}}async stopFindInFrame(a,g,w){const h=this.getFrameByName(a,g);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}getFrameByName(a,g){const w=this.windowsMainService.getWindowById(a.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${a}`);const y=w.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===g);if(!y)throw new Error(`Unknown frame: ${g}`);return y}};e.WebviewMainService=I,e.WebviewMainService=I=Pe([te(0,R.IWindowsMainService)],I)}),define(ie[298],ne([0,1,15,2,4,19,7,18,20,6,34,29,128,30]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class extends L.Disposable{static{b=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(c,i,o,s,t){super(),this.windowsMainService=c,this.stateService=i,this.lifecycleMainService=o,this.logService=s,this.configurationService=t,this._state=v(this.stateService.getItem(b.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){C.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!i.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.toWindowState(t),i.lastActiveWindow.uiState.mode===3&&c.add(i.lastActiveWindow.uiState.display))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(i.lastPluginDevelopmentHostWindow=this.toWindowState(o),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(c.has(i.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!o.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):c.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(i.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.toWindowState(t);return n.uiState.mode===3&&(c.has(n.uiState.display)?r.isMacintosh&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):c.add(n.uiState.display)),n}));const s=f(i);this.stateService.setItem(b.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const i=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=i:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(o=>{const s=(0,h.isWorkspaceIdentifier)(c.openedWorkspace)&&o.workspace?.id===c.openedWorkspace.id,t=(0,h.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&o.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(o.folderUri,c.openedWorkspace.uri);(s||t)&&(o.uiState=i.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=i)}toWindowState(c){return{windowId:c.id,workspace:(0,h.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const i=this.doGetNewWindowState(c),o=this.configurationService.getValue("window");if(i.mode===3){let s;i.hasDefaultState?s=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||o?.restoreFullscreen),s||(i.mode=1)}return i}doGetNewWindowState(c){const i=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=c.workspace;if((0,h.isWorkspaceIdentifier)(S)){const M=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===S.id).map(P=>P.uiState);if(M.length)return M[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(S)){const M=this.state.openedWindows.filter(P=>P.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(P.folderUri,S.uri)).map(P=>P.uiState);if(M.length)return M[0]}else if(c.backupPath){const M=this.state.openedWindows.filter(P=>P.backupPath===c.backupPath).map(P=>P.uiState);if(M.length)return M[0]}const D=this.lastClosedState||this.state.lastActiveWindow;if(!i&&D)return D.uiState}let o;const s=C.screen.getAllDisplays();if(s.length===1)o=s[0];else{if(r.isMacintosh){const S=C.screen.getCursorScreenPoint();o=C.screen.getDisplayNearestPoint(S)}!o&&i&&(o=C.screen.getDisplayMatching(i.getBounds())),o||(o=C.screen.getPrimaryDisplay()||s[0])}let t=(0,y.defaultWindowState)();t.x=Math.round(o.bounds.x+o.bounds.width/2-t.width/2),t.y=Math.round(o.bounds.y+o.bounds.height/2-t.height/2);const n=this.configurationService.getValue("window");let l=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,l=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,l=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const S=i.serializeWindowState();S.mode===3?t.mode=3:t=S,l=t.mode!==3&&n.newWindowDimensions==="offset"}}return l&&(t=this.ensureNoOverlap(t)),t.hasDefaultState=!0,t}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const i=this.windowsMainService.getWindows().map(o=>o.getBounds());for(;i.some(o=>o.x===c.x||o.y===c.y);)c.x+=30,c.y+=30;return c}};e.WindowsStateHandler=p,e.WindowsStateHandler=p=b=Pe([te(0,w.IWindowsMainService),te(1,g.IStateService),te(2,u.ILifecycleMainService),te(3,a.ILogService),te(4,I.IConfigurationService)],p);function v(E){const c={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(c.lastActiveWindow=m(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=m(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(c.openedWindows=i.openedWindows.map(o=>m(o))),c}e.restoreWindowsState=v;function m(E){const c={uiState:E.uiState};return E.backupPath&&(c.backupPath=E.backupPath),E.remoteAuthority&&(c.remoteAuthority=E.remoteAuthority),E.folder&&(c.folderUri=R.URI.parse(E.folder)),E.workspaceIdentifier&&(c.workspace={id:E.workspaceIdentifier.id,configPath:R.URI.parse(E.workspaceIdentifier.configURIPath)}),c}function f(E){return{lastActiveWindow:E.lastActiveWindow&&d(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&d(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(c=>d(c))}}e.getWindowsStateStoreData=f;function d(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(ie[53],ne([0,1,15,3,44,2,13,9,19,21,194,63,59,24,5,6,52,130,30,97,98]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let c=class extends A.Disposable{constructor(o,s,t,n,l){super(),this.environmentMainService=o,this.logService=s,this.userDataProfilesMainService=t,this.backupMainService=n,this.dialogMainService=l,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const o=(await a.Promises.readdir(this.untitledWorkspacesHome.with({scheme:R.Schemas.file}).fsPath)).map(s=>(0,u.joinPath)(this.untitledWorkspacesHome,s,f.UNTITLED_WORKSPACE_NAME));for(const s of o){const t=(0,E.getWorkspaceIdentifier)(s),n=await this.resolveLocalWorkspace(s);n?this.untitledWorkspaces.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(o){o.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${o}).`)}}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,s=>a.Promises.readFile(s,"utf8"))}doResolveLocalWorkspace(o,s){if(this.isWorkspacePath(o)&&o.scheme===R.Schemas.file)try{const t=s(o.fsPath);return t instanceof Promise?t.then(n=>this.doResolveWorkspace(o,n),n=>{}):this.doResolveWorkspace(o,t)}catch{return}}isWorkspacePath(o){return(0,f.isUntitledWorkspace)(o,this.environmentMainService)||(0,f.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,s){try{const t=this.doParseStoredWorkspace(o,s),n=(0,E.getWorkspaceIdentifier)(o);return{id:n.id,configPath:n.configPath,folders:(0,d.toWorkspaceFolders)(t.folders,n.configPath,u.extUriBiasedIgnorePathCase),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.logService.warn(t.toString())}}doParseStoredWorkspace(o,s){const t=(0,r.parse)(s);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,d.isStoredWorkspaceFolder)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(o,s){const{workspace:t,storedWorkspace:n}=this.newUntitledWorkspace(o,s),l=t.configPath.fsPath;return await a.Promises.mkdir((0,I.dirname)(l),{recursive:!0}),await a.Promises.writeFile(l,JSON.stringify(n,null,"	")),this.untitledWorkspaces.push({workspace:t,remoteAuthority:s}),t}newUntitledWorkspace(o=[],s){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,u.joinPath)(this.untitledWorkspacesHome,t),l=(0,u.joinPath)(n,f.UNTITLED_WORKSPACE_NAME),S=[];for(const D of o)S.push((0,d.getStoredWorkspaceFolder)(D.uri,!0,D.name,n,u.extUriBiasedIgnorePathCase));return{workspace:(0,E.getWorkspaceIdentifier)(l),storedWorkspace:{folders:S,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,E.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,f.isUntitledWorkspace)(o.configPath,this.environmentMainService)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.doDeleteUntitledWorkspace(o),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(o),this._onDidDeleteUntitledWorkspace.fire(o))}async doDeleteUntitledWorkspace(o){const s=(0,u.originalFSPath)(o.configPath);try{await a.Promises.rm((0,I.dirname)(s));const t=(0,I.join)(this.environmentMainService.workspaceStorageHome.with({scheme:R.Schemas.file}).fsPath,o.id);await a.Promises.exists(t)&&await a.Promises.writeFile((0,I.join)(t,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(n=>n.workspace.id!==o.id)}catch(t){this.logService.warn(`Unable to delete untitled workspace ${s} (${t}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(o,s,t){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,s,t))return;const l=await this.doEnterWorkspace(o,(0,E.getWorkspaceIdentifier)(t));if(l)return this._onDidEnterWorkspace.fire({window:o,workspace:l.workspace}),l}async isValidTargetWorkspacePath(o,s,t){return t?(0,f.isWorkspaceIdentifier)(o.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,t)?!1:(0,m.findWindowOnWorkspaceOrFolder)(s,t)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,u.basename)(t)),detail:(0,g.localize)(2,null)},C.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(o,s){if(!o.config)return;o.focus();let t;return o.config.extensionDevelopmentPath||(o.config.backupPath?t=await this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):t=this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,f.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=t,{workspace:s,backupPath:t}}};e.WorkspacesManagementMainService=c,e.WorkspacesManagementMainService=c=Pe([te(0,h.IEnvironmentMainService),te(1,p.ILogService),te(2,v.IUserDataProfilesMainService),te(3,w.IBackupMainService),te(4,y.IDialogMainService)],c)}),define(ie[132],ne([0,1,15,38,22,5,29,30,53,12,6,60]),function(G,e,C,L,r,A,R,I,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let y=class{constructor(b,p,v){this.windowsMainService=b,this.workspacesManagementMainService=p,this.logService=v}async getRemoteDiagnostics(b){const p=this.windowsMainService.getWindows();return(await Promise.all(p.map(async m=>{const f=m.remoteAuthority;if(!f)return;const d=`vscode:getDiagnosticInfoResponse${m.id}`,E={includeProcesses:b.includeProcesses,folders:b.includeWorkspaceMetadata?await this.getFolderURIs(m):void 0};return new Promise(c=>{m.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:d,args:E}),L.validatedIpcMain.once(d,(i,o)=>{o||c({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),c(o)}),setTimeout(()=>{c({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const b=[];for(const v of C.BrowserWindow.getAllWindows()){const m=this.windowsMainService.getWindowById(v.id);m?b.push(await this.codeWindowToInfo(m)):b.push(this.browserWindowToInfo(v))}const p=[];for(const{pid:v,name:m}of w.UtilityProcess.getAll())p.push({pid:v,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:b,pidToNames:p,screenReader:!!C.app.accessibilitySupportEnabled,gpuFeatureStatus:C.app.getGPUFeatureStatus()}}async codeWindowToInfo(b){const p=await this.getFolderURIs(b),v=(0,a.assertIsDefined)(b.win);return this.browserWindowToInfo(v,p,b.remoteAuthority)}browserWindowToInfo(b,p=[],v){return{id:b.id,pid:b.webContents.getOSProcessId(),title:b.getTitle(),folderURIs:p,remoteAuthority:v}}async getFolderURIs(b){const p=[],v=b.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(v))p.push(v.uri);else if((0,I.isWorkspaceIdentifier)(v)){const m=await this.workspacesManagementMainService.resolveLocalWorkspace(v.configPath);m&&m.folders.forEach(d=>{p.push(d.uri)})}return p}};e.DiagnosticsMainService=y,e.DiagnosticsMainService=y=Pe([te(0,R.IWindowsMainService),te(1,u.IWorkspacesManagementMainService),te(2,g.ILogService)],y)}),define(ie[69],ne([0,1,47,15,28,156,54,3,2,13,9,4,7,105,88,21,103,182,59,24,5,20,6,25,67,29,30,53,17,243,235,78]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i,o,s,t,n,l,S,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let k=class extends u.Disposable{constructor(F,z,Y,J,oe,re,ce,Q,K,V){super(),this.windowsMainService=F,this.auxiliaryWindowsMainService=z,this.dialogMainService=Y,this.lifecycleMainService=J,this.environmentMainService=oe,this.logService=re,this.productService=ce,this.themeMainService=Q,this.workspacesManagementMainService=K,this.instantiationService=V,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,q=>q.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:q,x:N,y:j})=>({windowId:q.id,x:N,y:j})),({windowId:q})=>!!this.windowsMainService.getWindowById(q)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(q,N)=>N.id),q=>!!this.windowsMainService.getWindowById(q)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(q,N)=>N.id),q=>!!this.windowsMainService.getWindowById(q)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(q,N)=>N.id),q=>!!this.windowsMainService.getWindowById(q)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),q=>!!q),q=>q.id),I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(q,N)=>N.id),q=>!!this.windowsMainService.getWindowById(q))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(q,N,j)=>j),q=>!(Array.isArray(q)&&q.length===1&&q[0]==="workArea")),I.Event.fromNodeEventEmitter(L.screen,"display-added"),I.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(z=>({id:z.id,workspace:z.openedWorkspace??(0,n.toWorkspaceIdentifier)(z.backupPath,z.isExtensionDevelopmentHost),title:z.win?.getTitle()??"",filename:z.getRepresentedFilename(),dirty:z.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const z=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(z)return z.id}openWindow(F,z,Y){return Array.isArray(z)?this.doOpenWindow(F,z,Y):this.doOpenEmptyWindow(F,z)}async doOpenWindow(F,z,Y=Object.create(null)){z.length>0&&await this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:z,cli:this.environmentMainService.args,forceNewWindow:Y.forceNewWindow,forceReuseWindow:Y.forceReuseWindow,preferNewWindow:Y.preferNewWindow,diffMode:Y.diffMode,mergeMode:Y.mergeMode,addMode:Y.addMode,gotoLineMode:Y.gotoLineMode,noRecentEntry:Y.noRecentEntry,waitMarkerFileURI:Y.waitMarkerFileURI,remoteAuthority:Y.remoteAuthority||void 0,forceProfile:Y.forceProfile,forceTempProfile:Y.forceTempProfile})}async doOpenEmptyWindow(F,z){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},z)}async toggleFullScreen(F){this.codeWindowById(F)?.toggleFullScreen()}async handleTitleDoubleClick(F){this.codeWindowById(F)?.handleTitleDoubleClick()}async isMaximized(F){const z=this.codeWindowById(F);return z?.win?z.win.isMaximized():!1}async maximizeWindow(F){const z=this.codeWindowById(F);z?.win&&z.win.maximize()}async unmaximizeWindow(F){const z=this.codeWindowById(F);z?.win&&z.win.unmaximize()}async minimizeWindow(F){const z=this.codeWindowById(F);z?.win&&z.win.minimize()}async moveWindowTop(F,z){const Y=this.windowById(z?.targetWindowId)??this.codeWindowById(F);Y?.win&&Y.win.moveTop()}async positionWindow(F,z,Y){const J=this.windowById(Y?.targetWindowId)??this.codeWindowById(F);if(J?.win){if(J.win.isFullScreen()){const oe=I.Event.toPromise(I.Event.once(I.Event.fromNodeEventEmitter(J.win,"leave-full-screen")));J.win.setFullScreen(!1),await oe}J.win.setBounds(z)}}async updateWindowControls(F,z){const Y=this.codeWindowById(F);Y&&Y.updateWindowControls(z)}async focusWindow(F,z){(this.windowById(z?.targetWindowId)??this.codeWindowById(F))?.focus({force:z?.force??!1})}async setMinimumSize(F,z,Y){const J=this.codeWindowById(F);if(J?.win){const[oe,re]=J.win.getSize(),[ce,Q]=J.win.getMinimumSize(),[K,V]=[z??ce,Y??Q],[q,N]=[Math.max(oe,K),Math.max(re,V)];(ce!==K||Q!==V)&&J.win.setMinimumSize(K,V),(oe!==q||re!==N)&&J.win.setSize(q,N)}}async saveWindowSplash(F,z){this.themeMainService.saveWindowSplash(F,z)}async installShellCommand(F){const{source:z,target:Y}=await this.getShellCommandLink();try{const{symbolicLink:J}=await p.SymlinkSupport.stat(z);if(J&&!J.dangling){const oe=await(0,h.realpath)(z);if(Y===oe)return}await p.Promises.unlink(z)}catch(J){if(J.code!=="ENOENT")throw J}try{await p.Promises.symlink(Y,z)}catch(J){if(J.code!=="EACCES"&&J.code!=="ENOENT")throw J;const{response:oe}=await this.showMessageBox(F,{type:"info",message:(0,m.localize)(0,null,this.productService.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(oe===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Y}' '${z}'\\" with administrator privileges"`;await(0,A.promisify)(C.exec)(re)}catch{throw new Error((0,m.localize)(3,null,z))}}}async uninstallShellCommand(F){const{source:z}=await this.getShellCommandLink();try{await p.Promises.unlink(z)}catch(Y){switch(Y.code){case"EACCES":{const{response:J}=await this.showMessageBox(F,{type:"info",message:(0,m.localize)(4,null,this.productService.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(J===0)try{const oe=`osascript -e "do shell script \\"rm '${z}'\\" with administrator privileges"`;await(0,A.promisify)(C.exec)(oe)}catch{throw new Error((0,m.localize)(7,null,z))}break}case"ENOENT":break;default:throw Y}}}async getShellCommandLink(){const F=(0,g.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),z=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.Promises.exists(F))throw new Error((0,m.localize)(8,null,F));return{source:z,target:F}}async showMessageBox(F,z){const Y=this.getTargetWindow(F);return this.dialogMainService.showMessageBox(z,Y?.win??void 0)}async showSaveDialog(F,z){const Y=this.getTargetWindow(F);return this.dialogMainService.showSaveDialog(z,Y?.win??void 0)}async showOpenDialog(F,z){const Y=this.getTargetWindow(F);return this.dialogMainService.showOpenDialog(z,Y?.win??void 0)}async pickFileFolderAndOpen(F,z){const Y=await this.dialogMainService.pickFileFolder(z);Y&&await this.doOpenPicked(await Promise.all(Y.map(async J=>await p.SymlinkSupport.existsDirectory(J)?{folderUri:y.URI.file(J)}:{fileUri:y.URI.file(J)})),z,F)}async pickFolderAndOpen(F,z){const Y=await this.dialogMainService.pickFolder(z);Y&&await this.doOpenPicked(Y.map(J=>({folderUri:y.URI.file(J)})),z,F)}async pickFileAndOpen(F,z){const Y=await this.dialogMainService.pickFile(z);Y&&await this.doOpenPicked(Y.map(J=>({fileUri:y.URI.file(J)})),z,F)}async pickWorkspaceAndOpen(F,z){const Y=await this.dialogMainService.pickWorkspace(z);Y&&await this.doOpenPicked(Y.map(J=>({workspaceUri:y.URI.file(J)})),z,F)}async doOpenPicked(F,z,Y){await this.windowsMainService.open({context:3,contextWindowId:Y,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:z.forceNewWindow})}async showItemInFolder(F,z){L.shell.showItemInFolder(z)}async setRepresentedFilename(F,z){this.codeWindowById(F)?.setRepresentedFilename(z)}async setDocumentEdited(F,z){this.codeWindowById(F)?.setDocumentEdited(z)}async openExternal(F,z){return this.environmentMainService.unsetSnapExportedVariables(),L.shell.openExternal(z),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(F,z){return L.shell.trashItem(z)}async isAdmin(){let F;return w.isWindows?F=(await new Promise((z,Y)=>{G(["native-is-elevated"],z,Y)}))():F=process.getuid?.()===0,F}async writeElevated(F,z,Y,J){const oe=await new Promise((re,ce)=>{G(["@vscode/sudo-prompt"],re,ce)});return new Promise((re,ce)=>{const Q=[`"${this.cliPath}"`];J?.unlock&&Q.push("--file-chmod"),Q.push("--file-write",`"${z.fsPath}"`,`"${Y.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:w.isMacintosh&&this.environmentMainService.isBuilt?(0,g.join)((0,g.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(Q.join(" "),K,(V,q,N)=>{q&&this.logService.trace(`[sudo-prompt] received stdout: ${q}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),V?ce(V):re(void 0)})})}async isRunningUnderARM64Translation(){return w.isLinux||w.isWindows?!1:L.app.runningUnderARM64Translation}get cliPath(){return w.isWindows?this.environmentMainService.isBuilt?(0,g.join)((0,g.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,g.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):w.isLinux?this.environmentMainService.isBuilt?(0,g.join)((0,g.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,g.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,g.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,g.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return b.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return w.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(F,z,Y){process.kill(z,Y)}async readClipboardText(F,z){return L.clipboard.readText(z)}async writeClipboardText(F,z,Y){return L.clipboard.writeText(z,Y)}async readClipboardFindText(F){return L.clipboard.readFindText()}async writeClipboardFindText(F,z){return L.clipboard.writeFindText(z)}async writeClipboardBuffer(F,z,Y,J){return L.clipboard.writeBuffer(z,Buffer.from(Y.buffer),J)}async readClipboardBuffer(F,z){return S.VSBuffer.wrap(L.clipboard.readBuffer(z))}async hasClipboard(F,z,Y){return L.clipboard.has(z,Y)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,z){this.codeWindowById(F)?.updateTouchBar(z)}async notifyReady(F){this.codeWindowById(F)?.setReady()}async relaunch(F,z){return this.lifecycleMainService.relaunch(z)}async reload(F,z){const Y=this.codeWindowById(F);if(Y){if((0,n.isWorkspaceIdentifier)(Y.openedWorkspace)){const J=Y.openedWorkspace.configPath;if(J.scheme===a.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(J))?.transient)return this.openWindow(Y.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Y,z?.disableExtensions!==void 0?{_:[],"disable-extensions":z.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,z){return(this.windowById(z)??this.codeWindowById(z))?.win?.close()}async quit(F){const z=this.windowsMainService.getLastActiveWindow();z?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&z.win?z.win.close():this.lifecycleMainService.quit()}async exit(F,z){await this.lifecycleMainService.kill(z)}async resolveProxy(F,z){return this.codeWindowById(F)?.win?.webContents?.session?.resolveProxy(z)}findFreePort(F,z,Y,J,oe=1){return(0,v.findFreePort)(z,Y,J,oe)}async openDevTools(F,z){this.getTargetWindow(F)?.win?.webContents.openDevTools(z)}async toggleDevTools(F){this.getTargetWindow(F)?.win?.webContents.toggleDevTools()}async sendInputEvent(F,z){const Y=this.codeWindowById(F);Y?.win&&(z.type==="mouseDown"||z.type==="mouseUp")&&Y.win.webContents.sendInputEvent(z)}async profileRenderer(F,z,Y){const J=this.codeWindowById(F);if(!J||!J.win)throw new Error;return await new M.WindowProfiler(J.win,z,this.logService).inspect(Y)}async windowsGetStringRegKey(F,z,Y,J){if(!w.isWindows)return;const oe=await new Promise((re,ce)=>{G(["@vscode/windows-registry"],re,ce)});try{return oe.GetStringRegKey(z,Y,J)}catch{return}}windowById(F){return this.codeWindowById(F)??this.auxiliaryWindowById(F)}codeWindowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}auxiliaryWindowById(F){if(typeof F=="number")return this.auxiliaryWindowsMainService.getWindowById(F)}getTargetWindow(F){let z=this.instantiationService.invokeFunction(t.getFocusedOrLastActiveWindow);return z||(z=this.windowById(F)),z}};e.NativeHostMainService=k,Pe([R.memoize],k.prototype,"cliPath",null),e.NativeHostMainService=k=Pe([te(0,t.IWindowsMainService),te(1,P.IAuxiliaryWindowsMainService),te(2,f.IDialogMainService),te(3,c.ILifecycleMainService),te(4,d.IEnvironmentMainService),te(5,i.ILogService),te(6,o.IProductService),te(7,s.IThemeMainService),te(8,l.IWorkspacesManagementMainService),te(9,E.IInstantiationService)],k)}),define(ie[299],ne([0,1,15,28,8,22,33,2,13,4,7,107,38,180,91,132,59,24,6,69,79,25,80,34,60,68,29]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i,o,s,t,n){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const S="issue.processExplorerWindowState";let D=class{static{l=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(k,O,F,z,Y,J,oe,re,ce,Q,K){this.userEnv=k,this.environmentMainService=O,this.logService=F,this.diagnosticsService=z,this.diagnosticsMainService=Y,this.dialogMainService=J,this.nativeHostMainService=oe,this.protocolMainService=re,this.productService=ce,this.stateService=Q,this.windowsMainService=K,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){y.validatedIpcMain.on("vscode:listProcesses",async k=>{const O=[];try{O.push({name:(0,h.localize)(0,null),rootProcess:await(0,w.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,b.isRemoteDiagnosticError)(z)?O.push({name:z.hostName,rootProcess:z}):z.processes&&O.push({name:z.hostName,rootProcess:z.processes})})}catch(F){this.logService.error(`Listing processes failed: ${F}`)}this.safeSend(k,"vscode:listProcessesResponse",O)}),y.validatedIpcMain.on("vscode:workbenchCommand",(k,O)=>{const{id:F,from:z,args:Y}=O;let J;switch(z){case"processExplorer":J=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${z}`)}J?.webContents.send("vscode:runAction",{id:F,from:z,args:Y})}),y.validatedIpcMain.on("vscode:closeProcessExplorer",k=>{this.processExplorerWindow?.close()}),y.validatedIpcMain.on("vscode:pidToNameRequest",async k=>{const O=await this.diagnosticsMainService.getMainDiagnostics(),F=[];for(const z of O.windows)F.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:Y}of s.UtilityProcess.getAll())F.push([z,Y]);this.safeSend(k,"vscode:pidToNameResponse",F)})}async openReporter(k){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=C.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const O=new I.DisposableStore,F=O.add(this.protocolMainService.createIPCObjectUrl()),z=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(z,F,{backgroundColor:k.styles.backgroundColor,title:(0,h.localize)(1,null),zoomLevel:k.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:k,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:E.default}),this.issueReporterWindow.loadURL(u.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,O.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,O.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(k){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=C.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const O=new I.DisposableStore,F=O.add(this.protocolMainService.createIPCObjectUrl()),z=this.stateService.getItem(S,void 0),Y=M(z)?z:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(Y,F,{backgroundColor:k.styles.backgroundColor,title:(0,h.localize)(2,null),zoomLevel:k.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:k,product:E.default}),this.processExplorerWindow.loadURL(u.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,O.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,O.dispose())});const J=()=>{if(!this.processExplorerWindow)return;const oe=this.processExplorerWindow.getSize(),re=this.processExplorerWindow.getPosition();if(!oe||!re)return;const ce={width:oe[0],height:oe[1],x:re[0],y:re[1]};this.stateService.setItem(S,ce)};this.processExplorerWindow.on("moved",J),this.processExplorerWindow.on("resized",J)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const k=await C.contentTracing.stopRecording(`${(0,R.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null,k),buttons:[(0,h.localize)(5,null)]},C.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,k)}async getSystemStatus(){const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(k,O)}async $getSystemInfo(){const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(k,O)}async $getPerformanceInfo(){try{const[k,O]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(k,O)}catch(k){throw this.logService.warn("issueService#getPerformanceInfo ",k.message),k}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(k){this.logService.error(k)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:k}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,h.localize)(6,null),buttons:[(0,h.localize)(7,null),(0,h.localize)(8,null)]},this.issueReporterWindow);k===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:k}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,h.localize)(9,null),buttons:[(0,h.localize)(10,null),(0,h.localize)(11,null)]},this.issueReporterWindow);return k===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const k=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!k)throw new Error("Window not found");return k}async $getIssueReporterUri(k){const O=this.issueReporterWindowCheck(),F=`vscode:triggerIssueUriRequestHandlerResponse${O.id}`;return r.Promises.withAsyncBody(async(z,Y)=>{const J=new A.CancellationTokenSource;O.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:F,extensionId:k}),y.validatedIpcMain.once(F,(oe,re)=>{z(g.URI.parse(re))});try{await(0,r.timeout)(5e3),J.cancel(),Y(new Error("Timed out waiting for issue reporter URI"))}finally{y.validatedIpcMain.removeHandler(F)}})}async $getIssueReporterData(k){const O=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataProviderResponse${O.id}`;return r.Promises.withAsyncBody(async z=>{const Y=new A.CancellationTokenSource;O.sendWhenReady("vscode:triggerIssueDataProvider",Y.token,{replyChannel:F,extensionId:k}),y.validatedIpcMain.once(F,(J,oe)=>{z(oe)});try{await(0,r.timeout)(5e3),Y.cancel(),z("Error: Extension timed out waiting for issue reporter data")}finally{y.validatedIpcMain.removeHandler(F)}})}async $getIssueReporterTemplate(k){const O=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataTemplateResponse${O.id}`;return r.Promises.withAsyncBody(async z=>{const Y=new A.CancellationTokenSource;O.sendWhenReady("vscode:triggerIssueDataTemplate",Y.token,{replyChannel:F,extensionId:k}),y.validatedIpcMain.once(F,(J,oe)=>{z(oe)});try{await(0,r.timeout)(5e3),Y.cancel(),z("Error: Extension timed out waiting for issue reporter template")}finally{y.validatedIpcMain.removeHandler(F)}})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(k){k.isMinimized()&&k.restore(),k.focus()}safeSend(k,O,...F){k.sender.isDestroyed()||k.sender.send(O,...F)}createBrowserWindow(k,O,F,z){const Y=new C.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:k.width,height:k.height,minWidth:300,minHeight:200,x:k.x,y:k.y,title:F.title,backgroundColor:F.backgroundColor||l.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:u.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.zoomLevelToZoomFactor)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return Y.setMenuBarVisibility(!1),Y}getWindowPosition(k,O,F){let z;const Y=C.screen.getAllDisplays();if(Y.length===1)z=Y[0];else{if(a.isMacintosh){const re=C.screen.getCursorScreenPoint();z=C.screen.getDisplayNearestPoint(re)}!z&&k&&(z=C.screen.getDisplayMatching(k.getBounds())),z||(z=C.screen.getPrimaryDisplay()||Y[0])}const J=z.bounds,oe={width:O,height:F,x:J.x+J.width/2-O/2,y:J.y+J.height/2-F/2};return J.width>0&&J.height>0&&(oe.x<J.x&&(oe.x=J.x),oe.y<J.y&&(oe.y=J.y),oe.x>J.x+J.width&&(oe.x=J.x),oe.y>J.y+J.height&&(oe.y=J.y),oe.width>J.width&&(oe.width=J.width),oe.height>J.height&&(oe.height=J.height)),oe}};e.IssueMainService=D,e.IssueMainService=D=l=Pe([te(1,m.IEnvironmentMainService),te(2,f.ILogService),te(3,b.IDiagnosticsService),te(4,p.IDiagnosticsMainService),te(5,v.IDialogMainService),te(6,d.INativeHostMainService),te(7,i.IProtocolMainService),te(8,c.IProductService),te(9,o.IStateService),te(10,n.IWindowsMainService)],D);function M(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(ie[300],ne([0,1,22,18,24,20,6,69,25,50,26,48,100]),function(G,e,C,L,r,A,R,I,u,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends y.AbstractUpdateService{constructor(p,v,m,f,d,E,c,i){super(p,v,f,d,E,i),this.telemetryService=m,this.nativeHostMainService=c}buildUpdateFeedUrl(p){return(0,y.createUpdateURL)(`linux-${process.arch}`,p,this.productService)}doCheckForUpdates(p){this.url&&(this.setState(w.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},C.CancellationToken.None).then(a.asJson).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(w.State.Idle(1))):this.setState(w.State.AvailableForDownload(v))}).then(void 0,v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p});const m=p?v.message||v:void 0;this.setState(w.State.Idle(1,m))}))}async doDownloadUpdate(p){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(w.State.Idle(1))}};e.LinuxUpdateService=h,e.LinuxUpdateService=h=Pe([te(0,A.ILifecycleMainService),te(1,L.IConfigurationService),te(2,g.ITelemetryService),te(3,r.IEnvironmentMainService),te(4,a.IRequestService),te(5,R.ILogService),te(6,I.INativeHostMainService),te(7,u.IProductService)],h)}),define(ie[301],ne([0,1,47,45,28,8,22,54,9,7,144,21,18,24,16,20,6,69,25,50,26,48,100]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(l,S=1e3){for(;!l();)await(0,A.timeout)(S)}let s;function t(){return typeof s>"u"&&(L.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?s=0:u.basename(u.normalize(u.join(process.execPath,"..","..")))==="Program Files"?s=3:s=1),s}let n=class extends i.AbstractUpdateService{get cachePath(){const S=u.join((0,r.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return w.Promises.mkdir(S,{recursive:!0}).then(()=>S)}constructor(S,D,M,P,k,O,F,z,Y){super(S,D,P,k,O,Y),this.telemetryService=M,this.fileService=F,this.nativeHostMainService=z,S.setRelaunchHandler(this)}handleRelaunch(S){return S?.addArgs||S?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(c.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(S){let D=`win32-${process.arch}`;switch(t()){case 1:D+="-archive";break;case 3:D+="-msi";break;default:this.productService.target==="user"?D+="-user":D+="-system"}return(0,i.createUpdateURL)(D,S,this.productService)}doCheckForUpdates(S){this.url&&(this.setState(c.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},R.CancellationToken.None).then(d.asJson).then(D=>{const M=t();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(c.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(P=>w.Promises.exists(P).then(k=>{if(k)return Promise.resolve(P);const O=D.url,F=D.hash,z=`${P}.tmp`;return this.requestService.request({url:O},R.CancellationToken.None).then(Y=>this.fileService.writeFile(a.URI.file(z),Y.stream)).then(F?()=>(0,g.checksum)(z,D.hash):()=>{}).then(()=>w.Promises.rename(z,P,!1)).then(()=>P)})).then(P=>{const k=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:P},k?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(D)):this.setState(c.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const M=S?D.message||D:void 0;this.setState(c.State.Idle(t(),M))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(c.State.Idle(t()))}async getUpdatePackagePath(S){const D=await this.cachePath;return u.join(D,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const D=S?O=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(O):()=>!0,M=await this.cachePath,k=(await w.Promises.readdir(M)).filter(D).map(async O=>{try{await w.Promises.unlink(u.join(M,O))}catch{}});await Promise.all(k)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(c.State.Updating(S));const D=await this.cachePath;this.availableUpdate.updateFilePath=u.join(D,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await w.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,C.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(t()))});const P=`${this.productService.win32MutexName}-ready`,k=await new Promise((O,F)=>{G(["@vscode/windows-mutex"],O,F)});o(()=>k.isActive(P)).then(()=>this.setState(c.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):t()==3?(0,C.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,C.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return t()}async _applySpecificUpdate(S){if(this.state.type!=="idle")return;const D=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown"};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:S},D?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};e.Win32UpdateService=n,Pe([I.memoize],n.prototype,"cachePath",null),e.Win32UpdateService=n=Pe([te(0,p.ILifecycleMainService),te(1,y.IConfigurationService),te(2,E.ITelemetryService),te(3,h.IEnvironmentMainService),te(4,d.IRequestService),te(5,v.ILogService),te(6,b.IFileService),te(7,m.INativeHostMainService),te(8,f.IProductService)],n)}),define(ie[133],ne([0,1,15,8,22,49,3,2,13,65,4,7,190,63,18,59,24,62,16,20,6,25,80,252,82,26,102,67,68,29,30,53,128,136,39,34,52,66,23,5]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i,o,s,t,n,l,S,D,M,P,k,O,F,z,Y,J,oe,re){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0;var Q;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(Q||(Q={}));class K extends I.Disposable{focus(N){g.isMacintosh&&N?.force&&C.app.focus({steal:!0});const j=this.getWin();j&&(j.isMinimized()&&j.restore(),j.focus())}}e.BaseWindow=K;let V=class extends K{static{ce=this}static{this.windowControlHeightStateStorageKey="windowControlHeight"}get id(){return this._id}get win(){return this._win}getWin(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const N=this.userDataProfilesService.profiles.find(j=>j.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&N?N:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,M.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(N,j,H,X,se,W,_,U,B,T,$,x,ae,fe,ue,de,be,we,ye,ke,Be){super(),this.logService=j,this.loggerMainService=H,this.environmentMainService=X,this.policyService=se,this.userDataProfilesService=W,this.fileService=_,this.applicationStorageMainService=U,this.storageMainService=B,this.configurationService=T,this.themeMainService=$,this.workspacesManagementMainService=x,this.backupMainService=ae,this.telemetryService=fe,this.dialogMainService=ue,this.lifecycleMainService=de,this.productService=be,this.protocolMainService=we,this.windowsMainService=ye,this.stateService=ke,this._onWillLoad=this._register(new R.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new R.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new R.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new R.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new R.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[pe,ve]=this.restoreWindowState(N.state);this.windowState=pe,this.logService.trace("window#ctor: using window state",pe);const Z=this.windowState.mode===0||this.windowState.mode===3,le=this.configurationService.getValue("window"),ge=Be.invokeFunction(D.defaultBrowserWindowOptions,this.windowState,{show:!Z,webPreferences:{preload:u.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"}});g.isMacintosh&&!this.useNativeFullScreen()&&(ge.fullscreenable=!1);const De=g.isMacintosh&&le?.nativeTabs===!0;De&&(ge.tabbingIdentifier=this.productService.nameShort);const Re=(0,S.getTitleBarStyle)(this.configurationService)==="custom";if(Re&&(ge.titleBarStyle="hidden",g.isMacintosh||(ge.frame=!1),(0,S.useWindowControlsOverlay)(this.configurationService))){const We=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Ae=O.Color.fromHex(We).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:We,symbolColor:Ae},this.hasWindowControlOverlay=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this._win=new C.BrowserWindow(ge),(0,a.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,g.isMacintosh&&Re&&this._win.setSheetOffset(22),Re&&(g.isWindows&&(0,S.useWindowControlsOverlay)(this.configurationService)||g.isMacintosh)){const We=this.stateService.getItem(ce.windowControlHeightStateStorageKey);We&&this.updateWindowControls({height:We})}g.isWindows&&Re&&this._win.hookWindowMessage(278,()=>{const[Ae,He]=this._win.getPosition(),ze=C.screen.getCursorScreenPoint(),ee=ze.x-Ae,he=ze.y-He;return(()=>!(ee>30&&he>=0&&he<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:ee,y:he})),0}),(g.isMacintosh||g.isWindows)&&ve&&(!De||C.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(We=>typeof We=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Z&&((0,a.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3?(this.logConditionally("WindowMode.Fullscreen"),this.setFullScreen(!0)):this.logConditionally("WindowMode.Maximized"),this._win.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}logConditionally(N){this.configurationService.getValue("window.logFullScreenTransitions")&&this.logService.info(`window-fullscreen-bug: ${N})`)}setRepresentedFilename(N){g.isMacintosh?this._win.setRepresentedFilename(N):this.representedFilename=N}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(N){g.isMacintosh&&this._win.setDocumentEdited(N),this.documentEdited=N}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.whenReadyCallbacks.push(N)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(N=>{function j(){H.dispose(),X.dispose(),N()}const H=this.onDidClose(()=>j()),X=this.onWillLoad(()=>j())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(j,H)=>this.onWindowError(2,{...H})),this._win.webContents.on("did-fail-load",(j,H,X)=>this.onWindowError(3,{reason:X,exitCode:H})),this._win.webContents.on("will-prevent-unload",j=>{j.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",j=>{this._config&&(this._config.maximized=!0),C.app.emit("browser-window-maximize",j,this._win)}),this._win.on("unmaximize",j=>{this._config&&(this._config.maximized=!1),C.app.emit("browser-window-unmaximize",j,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.logConditionally(`enter-full-screen: ${Date.now()}`),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.logConditionally(`leave-full-screen: ${Date.now()}`),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(j=>this.onConfigurationUpdated(j))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(j=>this.onDidDeleteUntitledWorkspace(j)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(j,H)=>{const X=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(j.requestHeaders,X)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,o.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(N,j){switch(N){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${j?.reason||"<unknown>"}, code: ${j?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${j?.reason||"<unknown>"}, code: ${j?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:N,reason:j?.reason,code:j?.exitCode}),N){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:X}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this._config?.workspace?(0,y.localize)(5,null):void 0},this._win);if(H!==2){const se=H===0;await this.destroyWindow(se,X)}}else if(N===2){let H;j?H=(0,y.localize)(7,null,j.reason,j.exitCode??"<unknown>"):H=(0,y.localize)(6,null);const{response:X,checkboxChecked:se}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:H,detail:this._config?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this._config?.workspace?(0,y.localize)(13,null):void 0},this._win),W=X===0;await this.destroyWindow(W,se)}break}}async destroyWindow(N,j){const H=this._config?.workspace;if(j&&H)try{const X=this.storageMainService.workspaceStorage(H);await X.init(),X.delete("memento/workbench.parts.editor"),await X.close()}catch(X){this.logService.error(X)}if(this._onDidDestroy.fire(),this._win?.destroy(),N&&this._config){let X,se;(0,M.isSingleFolderWorkspaceIdentifier)(H)?X={folderUri:H.uri}:(0,M.isWorkspaceIdentifier)(H)?X={workspaceUri:H.configPath}:se=!0,(0,oe.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:se,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(N){this._config?.workspace?.id===N.id&&(this._config.workspace=void 0)}onConfigurationUpdated(N){if(!N||N.affectsConfiguration("window.menuBarVisibility")){const j=this.getMenuBarVisibility();j!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=j,this.setMenuBarVisibility(j))}if(!N||N.affectsConfiguration("http.proxy")){let j=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;j?.endsWith("/")&&(j=j.substr(0,j.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((j||"").indexOf("@")===-1&&(j!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=j,this.currentNoProxy=H;const X=j||"",se=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${X}', bypassing '${se}'`),this._win.webContents.session.setProxy({proxyRules:X,proxyBypassRules:se,pacScript:""})}}}addTabbedWindow(N){g.isMacintosh&&N.win&&this._win.addTabbedWindow(N.win)}load(N,j=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!j.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),j.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(N,j),this.readyState===0?this._config=N:this.pendingLoadConfig=N,this.readyState=1,this._win.loadURL(u.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:N.workspace,reason:j.isReload?3:H?2:1})}updateConfiguration(N,j){const H=(this._config??this.pendingLoadConfig)?.userEnv;if(H){const X=(0,m.isLaunchedFromCli)(H)&&!(0,m.isLaunchedFromCli)(N.userEnv),se=this.isExtensionDevelopmentHost;(X||se)&&(N.userEnv={...H,...N.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),j.disableExtensions!==void 0&&(N["disable-extensions"]=j.disableExtensions),N.fullscreen=this.isFullScreen,N.maximized=this._win.isMaximized(),N.partsSplash=this.themeMainService.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),N.perfMarks=(0,a.getMarks)(),this.configObjectUrl.update(N)}async reload(N){const j=Object.assign({},this._config);j.workspace=await this.validateWorkspaceBeforeReload(j),delete j.filesToOpenOrCreate,delete j.filesToDiff,delete j.filesToMerge,delete j.filesToWait,this.isExtensionDevelopmentHost&&N&&(j.verbose=N.verbose,j.debugId=N.debugId,j.extensionEnvironment=N.extensionEnvironment,j["inspect-extensions"]=N["inspect-extensions"],j["inspect-brk-extensions"]=N["inspect-brk-extensions"],j["extensions-dir"]=N["extensions-dir"]),j.accessibilitySupport=C.app.isAccessibilitySupportEnabled(),j.isInitialStartup=!1,j.policiesData=this.policyService.serialize(),j.continueOn=this.environmentMainService.continueOn,j.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},j.logLevel=this.loggerMainService.getLogLevel(),j.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(j,{isReload:!0,disableExtensions:N?.["disable-extensions"]})}async validateWorkspaceBeforeReload(N){if((0,M.isWorkspaceIdentifier)(N.workspace)){const j=N.workspace.configPath;if(j.scheme===u.Schemas.file&&!await this.fileService.exists(j))return}else if((0,M.isSingleFolderWorkspaceIdentifier)(N.workspace)){const j=N.workspace.uri;if(j.scheme===u.Schemas.file&&!await this.fileService.exists(j))return}return N.workspace}serializeWindowState(){if(!this._win)return(0,k.defaultWindowState)();if(this.isFullScreen){let H;try{H=C.screen.getDisplayMatching(this.getBounds())}catch{}const X=(0,k.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||X.width,height:this.windowState.height||X.height,x:this.windowState.x||0,y:this.windowState.y||0}}const N=Object.create(null);let j;if(!g.isMacintosh&&this._win.isMaximized()?j=0:j=1,j===0?N.mode=0:N.mode=1,j===1||j===0){let H;j===1?H=this.getBounds():H=this._win.getNormalBounds(),N.x=H.x,N.y=H.y,N.width=H.width,N.height=H.height}return N}updateWindowControls(N){if(N.height&&this.stateService.setItem(ce.windowControlHeightStateStorageKey,N.height),g.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:N.backgroundColor?.trim()===""?void 0:N.backgroundColor,symbolColor:N.foregroundColor?.trim()===""?void 0:N.foregroundColor,height:N.height?N.height-1:void 0});else if(g.isMacintosh&&N.height!==void 0){const j=(N.height-15)/2;j?this._win.setWindowButtonPosition({x:j,y:j}):this._win.setWindowButtonPosition(null)}}restoreWindowState(N){(0,a.mark)("code/willRestoreCodeWindowState");let j=!1;if(N)try{const H=C.screen.getAllDisplays();j=H.length>1,N=this.validateWindowState(N,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[N||(0,k.defaultWindowState)(),j]}validateWindowState(N,j){if(this.logService.trace(`window#validateWindowState: validating window state on ${j.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(j.length===1){const se=this.getWorkingArea(j[0]);if(se){let W=function(){!N||typeof N.x!="number"||typeof N.y!="number"||!se||(N.x<se.x&&(N.x=se.x),N.y<se.y&&(N.y=se.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",se),W(),N.width>se.width&&(N.width=se.width),N.height>se.height&&(N.height=se.height),N.x>se.x+se.width-128&&(N.x=se.x+se.width-N.width),N.y>se.y+se.height-128&&(N.y=se.y+se.height-N.height),W()}return N}if(N.display&&N.mode===3){const se=j.find(W=>W.id===N.display);if(se&&typeof se.bounds?.x=="number"&&typeof se.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=(0,k.defaultWindowState)(3);return W.x=se.bounds.x,W.y=se.bounds.y,W}}let H,X;try{H=C.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),X=this.getWorkingArea(H)}catch{}if(H&&X&&N.x+N.width>X.x&&N.y+N.height>X.y&&N.x<X.x+X.width&&N.y<X.y+X.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",X),N}getWorkingArea(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,j]=this._win.getPosition(),[H,X]=this._win.getSize();return{x:N,y:j,width:H,height:X}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(N){this.useNativeFullScreen()?this.setNativeFullScreen(N):this.setSimpleFullScreen(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){if(this.logConditionally(`isFullScreen(): begin at ${Date.now()}`),g.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.logConditionally(`isFullScreen(): returning transientIsNativeFullScreen = ${this.transientIsNativeFullScreen}`),this.transientIsNativeFullScreen;const N=this._win.isFullScreen(),j=this._win.isSimpleFullScreen();return this.logConditionally(`isFullScreen(): returning natively, isFullScreen = ${N}, isSimpleFullScreen = ${j}`),N||j}setNativeFullScreen(N){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(N)}doSetNativeFullScreen(N){g.isMacintosh&&(this.logConditionally(`doSetNativeFullScreen(${N}): begin at ${Date.now()}`),this.transientIsNativeFullScreen=N,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e4)]).finally(()=>{this.logConditionally(`doSetNativeFullScreen(${N}): finish at ${Date.now()}`),this.transientIsNativeFullScreen=void 0})),this._win.setFullScreen(N)}setSimpleFullScreen(N){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(N),this._win.webContents.focus()}useNativeFullScreen(){const N=this.configurationService.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let N=(0,S.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}setMenuBarVisibility(N,j=!0){g.isMacintosh||(N==="toggle"&&j&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),N==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(N)}):this.doSetMenuBarVisibility(N))}doSetMenuBarVisibility(N){const j=this.isFullScreen;switch(N){case"classic":this._win.setMenuBarVisibility(!j),this._win.autoHideMenuBar=j;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(C.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(N,j,...H){this.isReady?this.send(N,...H):this.ready().then(()=>{j.isCancellationRequested||this.send(N,...H)})}send(N,...j){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${N}' for window that is destroyed`);return}try{this._win.webContents.send(N,...j)}catch(H){this.logService.warn(`Error sending IPC message to channel '${N}' of window ${this._id}: ${(0,A.toErrorMessage)(H)}`)}}}updateTouchBar(N){g.isMacintosh&&this.touchBarGroups.forEach((j,H)=>{const X=N[H];j.segments=this.createTouchBarGroupSegments(X)})}createTouchBar(){if(g.isMacintosh){for(let N=0;N<10;N++){const j=this.createTouchBarGroup();this.touchBarGroups.push(j)}this._win.setTouchBar(new C.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(N=[]){const j=this.createTouchBarGroupSegments(N),H=new C.TouchBar.TouchBarSegmentedControl({segments:j,mode:"buttons",segmentStyle:"automatic",change:X=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:H.segments[X].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(N=[]){return N.map(H=>{let X;H.icon&&!n.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===u.Schemas.file&&(X=C.nativeImage.createFromPath(w.URI.revive(H.icon.dark).fsPath),X.isEmpty()&&(X=void 0));let se;return typeof H.title=="string"?se=H.title:se=H.title.value,{id:H.id,label:X?void 0:se,icon:X}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};e.CodeWindow=V,e.CodeWindow=V=ce=Pe([te(1,E.ILogService),te(2,J.ILoggerMainService),te(3,v.IEnvironmentMainService),te(4,F.IPolicyService),te(5,Y.IUserDataProfilesMainService),te(6,f.IFileService),te(7,s.IApplicationStorageMainService),te(8,s.IStorageMainService),te(9,b.IConfigurationService),te(10,l.IThemeMainService),te(11,P.IWorkspacesManagementMainService),te(12,h.IBackupMainService),te(13,t.ITelemetryService),te(14,p.IDialogMainService),te(15,d.ILifecycleMainService),te(16,c.IProductService),te(17,i.IProtocolMainService),te(18,D.IWindowsMainService),te(19,z.IStateService),te(20,re.IInstantiationService)],V)}),define(ie[302],ne([0,1,15,3,24,133]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let R=class extends A.BaseWindow{get win(){return this._win||this.tryClaimWindow(),this._win}getWin(){return this.win}get lastFocusTime(){return this._lastFocusTime}constructor(u,a){super(),this.contents=u,this.environmentMainService=a,this.id=this.contents.id,this._onDidClose=this._register(new L.Emitter),this.onDidClose=this._onDidClose.event,this._win=null,this._lastFocusTime=Date.now(),this.create()}create(){this.environmentMainService.args["open-devtools"]===!0&&this.contents.openDevTools({mode:"bottom"}),this.tryClaimWindow()}tryClaimWindow(){if(this._win||this._store.isDisposed||this.contents.isDestroyed())return;const u=C.BrowserWindow.fromWebContents(this.contents);u&&(this._win=u,u.setMenu(null),this.registerWindowListeners(u))}registerWindowListeners(u){u.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),u.on("focus",()=>{this._lastFocusTime=Date.now()})}dispose(){super.dispose(),this._win=null}};e.AuxiliaryWindow=R,e.AuxiliaryWindow=R=Pe([te(1,r.IEnvironmentMainService)],R)}),define(ie[303],ne([0,1,15,3,13,302,5,29]),function(G,e,C,L,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let u=class{constructor(g){this.instantiationService=g,this.windows=new Map,this.registerListeners()}registerListeners(){C.app.on("browser-window-created",(g,w)=>{const y=this.getWindowById(w.id);y&&y.tryClaimWindow()})}createWindow(){return this.instantiationService.invokeFunction(I.defaultBrowserWindowOptions,void 0,{webPreferences:{preload:r.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}registerWindow(g){const w=this.instantiationService.createInstance(A.AuxiliaryWindow,g);this.windows.set(w.id,w),L.Event.once(w.onDidClose)(()=>this.windows.delete(w.id))}getWindowById(g){return this.windows.get(g)}getFocusedWindow(){const g=C.BrowserWindow.getFocusedWindow();if(g)return this.getWindowById(g.id)}getLastActiveWindow(){return(0,I.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=u,e.AuxiliaryWindowsMainService=u=Pe([te(0,R.IInstantiationService)],u)}),define(ie[83],ne([0,1,15,23,8,3,46,2,13,4,19,7,21,193,5,20,6,82,97,30,53,31]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,b.createDecorator)("workspacesHistoryMainService");let o=class extends I.Disposable{static{i=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(t,n,l,S){super(),this.logService=t,this.workspacesManagementMainService=n,this.lifecycleMainService=l,this.applicationStorageMainService=S,this._onDidChangeRecentlyOpened=this._register(new A.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(t=>this.addRecentlyOpened([{workspace:t.workspace,remoteAuthority:t.window.remoteAuthority}])))}async addRecentlyOpened(t){let n=[],l=[];for(const D of t)if((0,f.isRecentWorkspace)(D))!this.workspacesManagementMainService.isUntitledWorkspace(D.workspace)&&!this.containsWorkspace(n,D.workspace)&&n.push(D);else if((0,f.isRecentFolder)(D))this.containsFolder(n,D.folderUri)||n.push(D);else{const M=this.containsFile(l,D.fileUri),P=D.fileUri.scheme===u.Schemas.file&&i.COMMON_FILES_FILTER.indexOf((0,g.basename)(D.fileUri))>=0;!M&&!P&&(l.push(D),a.isWindows&&D.fileUri.scheme===u.Schemas.file&&C.app.addRecentDocument(D.fileUri.fsPath))}const S=await this.mergeEntriesFromStorage({workspaces:n,files:l});n=S.workspaces,l=S.files,n.length>i.MAX_TOTAL_RECENT_ENTRIES&&(n.length=i.MAX_TOTAL_RECENT_ENTRIES),l.length>i.MAX_TOTAL_RECENT_ENTRIES&&(l.length=i.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:l}),this._onDidChangeRecentlyOpened.fire(),a.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(t){const n=M=>{const P=this.location(M);for(const k of t)if(g.extUriBiasedIgnorePathCase.isEqual(k,P))return!1;return!0},l=await this.getRecentlyOpened(),S=l.workspaces.filter(n),D=l.files.filter(n);(S.length!==l.workspaces.length||D.length!==l.files.length)&&(await this.saveRecentlyOpened({files:D,workspaces:S}),this._onDidChangeRecentlyOpened.fire(),a.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),C.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(t){const n=new c.ResourceMap(D=>g.extUriBiasedIgnorePathCase.getComparisonKey(D));if(t?.workspaces)for(const D of t.workspaces)n.set(this.location(D),D);const l=new c.ResourceMap(D=>g.extUriBiasedIgnorePathCase.getComparisonKey(D));if(t?.files)for(const D of t.files)l.set(this.location(D),D);const S=await this.getRecentlyOpenedFromStorage();for(const D of S.workspaces){const M=n.get(this.location(D));M?M.label=M.label??D.label:n.set(this.location(D),D)}for(const D of S.files){const M=l.get(this.location(D));M?M.label=M.label??D.label:l.set(this.location(D),D)}return{workspaces:[...n.values()],files:[...l.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let t;const n=this.applicationStorageMainService.get(i.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{t=JSON.parse(n)}catch(l){this.logService.error("Unexpected error parsing opened paths list",l)}return(0,f.restoreRecentlyOpened)(t,this.logService)}async saveRecentlyOpened(t){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(i.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,f.toStoreData)(t)),-1,1)}location(t){return(0,f.isRecentFolder)(t)?t.folderUri:(0,f.isRecentFile)(t)?t.fileUri:t.workspace.configPath}containsWorkspace(t,n){return!!t.find(l=>(0,f.isRecentWorkspace)(l)&&l.workspace.id===n.id)}containsFolder(t,n){return!!t.find(l=>(0,f.isRecentFolder)(l)&&g.extUriBiasedIgnorePathCase.isEqual(l.folderUri,n))}containsFile(t,n){return!!t.find(l=>g.extUriBiasedIgnorePathCase.isEqual(l.fileUri,n))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){a.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!a.isWindows)return;const t=[];if(t.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const D of C.app.getJumpListSettings().removedItems){const M=D.args;if(M){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(M);P&&n.push(w.URI.parse(P[2]))}}await this.removeRecentlyOpened(n);let l=!1;const S=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,i.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(D=>{const M=(0,f.isRecentWorkspace)(D)?D.workspace:D.folderUri,{title:P,description:k}=this.getWindowsJumpListLabel(M,D.label);let O;return w.URI.isUri(M)?O=`--folder-uri "${M.toString()}"`:(l=!0,O=`--file-uri "${M.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:k.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));S.length>0&&t.push({type:"custom",name:l?(0,h.localize)(2,null):(0,h.localize)(3,null),items:S})}t.push({type:"recent"});try{const n=C.app.setJumpList(t);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(t,n){if(n)return{title:(0,R.splitRecentLabel)(n).name,description:n};if(w.URI.isUri(t))return{title:(0,g.basename)(t),description:this.renderJumpListPathDescription(t)};if(this.workspacesManagementMainService.isUntitledWorkspace(t))return{title:(0,h.localize)(4,null),description:""};let l=(0,g.basename)(t.configPath);return l.endsWith(d.WORKSPACE_EXTENSION)&&(l=l.substr(0,l.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,l),description:this.renderJumpListPathDescription(t.configPath)}}renderJumpListPathDescription(t){return t.scheme==="file"?(0,R.normalizeDriveLetter)(t.fsPath):t.toString()}async updateMacOSRecentDocuments(){if(!a.isMacintosh)return;C.app.clearRecentDocuments();const t=await this.getRecentlyOpened(),n=[];let l=0;for(let D=0;D<t.workspaces.length&&l<i.MAX_MACOS_DOCK_RECENT_WORKSPACES;D++){const M=this.location(t.workspaces[D]);if(M.scheme===u.Schemas.file){const P=(0,g.originalFSPath)(M);await y.Promises.exists(P)&&(n.push(P),l++)}}const S=[];for(let D=0;D<t.files.length&&l<i.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;D++){const M=this.location(t.files[D]);if(M.scheme===u.Schemas.file){const P=(0,g.originalFSPath)(M);if(i.COMMON_FILES_FILTER.includes((0,g.basename)(M))||n.includes(P))continue;await y.Promises.exists(P)&&(S.push(P),l++)}}S.reverse().forEach(D=>C.app.addRecentDocument(D)),n.reverse().forEach(D=>C.app.addRecentDocument(D))}};e.WorkspacesHistoryMainService=o,e.WorkspacesHistoryMainService=o=i=Pe([te(0,v.ILogService),te(1,E.IWorkspacesManagementMainService),te(2,p.ILifecycleMainService),te(3,m.IApplicationStorageMainService)],o)}),define(ie[304],ne([0,1,15,8,22,46,4,7,181,78,18,24,20,6,231,69,25,34,26,48,68,29,83]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let t=class{static{o=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(S,D,M,P,k,O,F,z,Y,J,oe,re){this.updateService=S,this.configurationService=D,this.windowsMainService=M,this.environmentMainService=P,this.telemetryService=k,this.workspacesHistoryMainService=O,this.stateService=F,this.lifecycleMainService=z,this.logService=Y,this.nativeHostMainService=J,this.productService=oe,this.auxiliaryWindowsMainService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,E.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const S=this.stateService.getItem(o.lastKnownMenubarStorageKey);S&&(S.menus&&(this.menubarMenus=S.menus),S.keybindings&&(this.keybindings=S.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(O,F,z)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(O,F,z)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(O,F,z)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(O,F,z)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(O,F,z)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const S=this.productService.youTubeUrl;S&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(S,"openYouTubeUrl"));const D=this.productService.requestFeatureUrl;D&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(D,"openUserVoiceUrl"));const M=this.productService.reportIssueUrl;M&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(M,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const O=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${O}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const k=this.productService.privacyStatementUrl;k&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(k,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(S=>this.onDidChangeWindowsCount(S)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const S=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof S!="boolean"?!0:S}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;const S=this.configurationService.getValue("window.nativeTabs");return typeof S!="boolean"?!1:S}updateMenu(S,D){this.menubarMenus=S.menus,this.keybindings=S.keybindings,this.stateService.setItem(o.lastKnownMenubarStorageKey,S),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(S){R.isMacintosh&&(S.oldCount===0&&S.newCount>0||S.oldCount>0&&S.newCount===0)&&(this.closedLastWindow=S.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){R.isMacintosh&&(this.noActiveWindow=!C.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const S=C.Menu.getApplicationMenu();if(S&&this.oldMenus.push(S),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(R.isMacintosh?new C.Menu:null);return}const D=new C.Menu;let M;if(R.isMacintosh){const k=new C.Menu;M=new C.MenuItem({label:this.productService.nameShort,submenu:k}),this.setMacApplicationMenu(k),D.append(M)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const k=new C.Menu;k.append(new C.MenuItem({label:this.mnemonicLabel(u.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),C.app.dock.setMenu(k)}if(this.shouldDrawMenu("File")){const k=new C.Menu,O=new C.MenuItem({label:this.mnemonicLabel(u.localize(1,null)),submenu:k});this.setMenuById(k,"File"),D.append(O)}if(this.shouldDrawMenu("Edit")){const k=new C.Menu,O=new C.MenuItem({label:this.mnemonicLabel(u.localize(2,null)),submenu:k});this.setMenuById(k,"Edit"),D.append(O)}if(this.shouldDrawMenu("Selection")){const k=new C.Menu,O=new C.MenuItem({label:this.mnemonicLabel(u.localize(3,null)),submenu:k});this.setMenuById(k,"Selection"),D.append(O)}if(this.shouldDrawMenu("View")){const k=new C.Menu,O=new C.MenuItem({label:this.mnemonicLabel(u.localize(4,null)),submenu:k});this.setMenuById(k,"View"),D.append(O)}if(this.shouldDrawMenu("Go")){const k=new C.Menu,O=new C.MenuItem({label:this.mnemonicLabel(u.localize(5,null)),submenu:k});this.setMenuById(k,"Go"),D.append(O)}if(this.shouldDrawMenu("Run")){const k=new C.Menu,O=new C.MenuItem({label:this.mnemonicLabel(u.localize(6,null)),submenu:k});this.setMenuById(k,"Run"),D.append(O)}if(this.shouldDrawMenu("Terminal")){const k=new C.Menu,O=new C.MenuItem({label:this.mnemonicLabel(u.localize(7,null)),submenu:k});this.setMenuById(k,"Terminal"),D.append(O)}let P;if(this.shouldDrawMenu("Window")){const k=new C.Menu;P=new C.MenuItem({label:this.mnemonicLabel(u.localize(8,null)),submenu:k,role:"window"}),this.setMacWindowMenu(k)}if(P&&D.append(P),this.shouldDrawMenu("Help")){const k=new C.Menu,O=new C.MenuItem({label:this.mnemonicLabel(u.localize(9,null)),submenu:k,role:"help"});this.setMenuById(k,"Help"),D.append(O)}D.items&&D.items.length>0?this.doSetApplicationMenu(D):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(S){C.Menu.setApplicationMenu(S);for(const D of this.auxiliaryWindowsMainService.getWindows())D.win?.setMenu(null)}setMacApplicationMenu(S){const D=this.createMenuItem(u.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),M=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const re=new C.Menu;this.setMenuById(re,"Preferences"),P=new C.MenuItem({label:this.mnemonicLabel(u.localize(11,null)),submenu:re})}const k=new C.Menu,O=new C.MenuItem({label:u.localize(12,null),role:"services",submenu:k}),F=new C.MenuItem({label:u.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),z=new C.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Y=new C.MenuItem({label:u.localize(15,null),role:"unhide"}),J=new C.MenuItem(this.likeAction("workbench.action.quit",{label:u.localize(16,null,this.productService.nameLong),click:async(re,ce,Q)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||C.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(Q)&&this.nativeHostMainService.quit(void 0)}})),oe=[D];oe.push(...M),P&&oe.push(n(),P),oe.push(n(),O,n(),F,z,Y,n(),J),oe.forEach(re=>S.append(re))}async confirmBeforeQuit(S){if(this.windowsMainService.getWindowCount()===0)return!0;const D=this.configurationService.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.isKeyboardEvent(S)){const{response:M}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return M===0}return!0}shouldDrawMenu(S){if(!R.isMacintosh&&(0,E.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(S){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[S];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[S]}}setMenu(S,D){D.forEach(M=>{if((0,b.isMenubarMenuItemSeparator)(M))S.append(n());else if((0,b.isMenubarMenuItemSubmenu)(M)){const P=new C.Menu,k=new C.MenuItem({label:this.mnemonicLabel(M.label),submenu:P});this.setMenu(P,M.submenu.items),S.append(k)}else(0,b.isMenubarMenuItemRecentAction)(M)?S.append(this.createOpenRecentMenuItem(M)):(0,b.isMenubarMenuItemAction)(M)&&(M.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(S),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[M.id]?S.append(new C.MenuItem(this.likeAction(M.id,{label:this.mnemonicLabel(M.label),click:this.fallbackMenuHandlers[M.id]}))):S.append(this.createMenuItem(M.label,M.id,!1,M.checked)):S.append(this.createMenuItem(M.label,M.id,M.enabled!==!1,!!M.checked)):S.append(this.createMenuItem(M.label,M.id,M.enabled!==!1,!!M.checked)))})}setMenuById(S,D){this.menubarMenus&&this.menubarMenus[D]&&this.setMenu(S,this.menubarMenus[D].items)}insertCheckForUpdatesItems(S){const D=this.getUpdateMenuItems();D.length&&(D.forEach(M=>S.append(M)),S.append(n()))}createOpenRecentMenuItem(S){const D=I.URI.revive(S.uri),M=S.id,P=M==="openRecentFile"?{fileUri:D}:M==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new C.MenuItem(this.likeAction(M,{label:S.label,click:async(k,O,F)=>{const z=this.isOptionClick(F);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:z,gotoLineMode:!1,remoteAuthority:S.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([D])}},!1))}isOptionClick(S){return!!(S&&(!R.isMacintosh&&(S.ctrlKey||S.shiftKey)||R.isMacintosh&&(S.metaKey||S.altKey)))}isKeyboardEvent(S){return!!(S.triggeredByAccelerator||S.altKey||S.ctrlKey||S.metaKey||S.shiftKey)}createRoleMenuItem(S,D,M){const P={label:this.mnemonicLabel(S),role:M,enabled:!0};return new C.MenuItem(this.withKeybinding(D,P))}setMacWindowMenu(S){const D=new C.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),M=new C.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new C.MenuItem({label:u.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),k=this.createMenuItem(u.localize(23,null),"workbench.action.switchWindow"),O=[];this.currentEnableNativeTabs&&(O.push(n()),O.push(this.createMenuItem(u.localize(24,null),"workbench.action.newWindowTab")),O.push(this.createRoleMenuItem(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),O.push(this.createRoleMenuItem(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),O.push(this.createRoleMenuItem(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),O.push(this.createRoleMenuItem(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,M,n(),k,...O,n(),P].forEach(F=>S.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new C.MenuItem({label:this.mnemonicLabel(u.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new C.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new C.MenuItem({label:this.mnemonicLabel(u.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new C.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new C.MenuItem({label:this.mnemonicLabel(u.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new C.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new C.MenuItem({label:this.mnemonicLabel(u.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(S,D,M,P){const k=this.mnemonicLabel(S),O=typeof D=="function"?D:(oe,re,ce)=>{const Q=oe?oe.userSettingsLabel:null;let K=D;Array.isArray(D)&&(K=this.isOptionClick(ce)?D[1]:D[0]),Q&&ce.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:Q}):this.runActionInRenderer({type:"commandId",commandId:K})},F=typeof M=="boolean"?M:this.windowsMainService.getWindowCount()>0,z=typeof P=="boolean"?P:!1,Y={label:k,click:O,enabled:F};z&&(Y.type="checkbox",Y.checked=z);let J;return typeof D=="string"?J=D:Array.isArray(D)&&(J=D[0]),R.isMacintosh&&(J==="editor.action.clipboardCutAction"?Y.role="cut":J==="editor.action.clipboardCopyAction"?Y.role="copy":J==="editor.action.clipboardPasteAction"&&(Y.role="paste"),J==="undo"?Y.click=this.makeContextAwareClickHandler(O,{inDevTools:oe=>oe.undo(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?Y.click=this.makeContextAwareClickHandler(O,{inDevTools:oe=>oe.redo(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(Y.click=this.makeContextAwareClickHandler(O,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("selectAll:")}))),new C.MenuItem(this.withKeybinding(J,Y))}makeContextAwareClickHandler(S,D){return(M,P,k)=>{const O=C.BrowserWindow.getFocusedWindow();if(!O)return D.inNoWindow();if(O.webContents.isDevToolsFocused()&&O.webContents.devToolsWebContents)return D.inDevTools(O.webContents.devToolsWebContents);S(M,P||O,k)}}runActionInRenderer(S){let D=C.BrowserWindow.getFocusedWindow();if(!D){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(D=P.win)}const M=D?this.windowsMainService.getWindowById(D.id):void 0;if(M){if(this.logService.trace("menubar#runActionInRenderer",S),R.isMacintosh&&!this.environmentMainService.isBuilt&&!M.isReady&&(S.type==="commandId"&&S.commandId==="workbench.action.toggleDevTools"||S.type!=="commandId"&&S.userSettingsLabel==="alt+cmd+i"))return;if(S.type==="commandId"){const P={id:S.commandId,from:"menu"};M.sendWhenReady("vscode:runAction",r.CancellationToken.None,P)}else{const P={userSettingsLabel:S.userSettingsLabel};M.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",S)}withKeybinding(S,D){const M=typeof S=="string"?this.keybindings[S]:void 0;if(M?.label){if(M.isNative!==!1)D.accelerator=M.label,D.userSettingsLabel=M.userSettingsLabel;else if(typeof D.label=="string"){const P=D.label.indexOf("[");P>=0?D.label=`${D.label.substr(0,P)} [${M.label}]`:D.label=`${D.label} [${M.label}]`}}else D.accelerator=void 0;return D}likeAction(S,D,M=!D.accelerator){M&&(D=this.withKeybinding(S,D));const P=D.click;return D.click=(k,O,F)=>{this.reportMenuActionTelemetry(S),P?.(k,O,F)},D}openUrl(S,D){this.nativeHostMainService.openExternal(void 0,S),this.reportMenuActionTelemetry(D)}reportMenuActionTelemetry(S){this.telemetryService.publicLog2("workbenchActionExecuted",{id:S,from:s})}mnemonicLabel(S){return(0,A.mnemonicMenuLabel)(S,!this.currentEnableMenuBarMnemonics)}};e.Menubar=t,e.Menubar=t=o=Pe([te(0,d.IUpdateService),te(1,g.IConfigurationService),te(2,c.IWindowsMainService),te(3,w.IEnvironmentMainService),te(4,f.ITelemetryService),te(5,i.IWorkspacesHistoryMainService),te(6,m.IStateService),te(7,y.ILifecycleMainService),te(8,h.ILogService),te(9,p.INativeHostMainService),te(10,v.IProductService),te(11,a.IAuxiliaryWindowsMainService)],t);function n(){return new C.MenuItem({type:"separator"})}}),define(ie[305],ne([0,1,5,20,6,304]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,C.createDecorator)("menubarMainService");let R=class{constructor(u,a,g){this.instantiationService=u,this.lifecycleMainService=a,this.logService=g,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(A.Menubar)}async updateMenubar(u,a){this.logService.trace("menubarService#updateMenubar",u),(await this.menubar).updateMenu(a,u)}};e.MenubarMainService=R,e.MenubarMainService=R=Pe([te(0,C.IInstantiationService),te(1,L.ILifecycleMainService),te(2,r.ILogService)],R)}),define(ie[306],ne([0,1,15,21,131,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,191,63,18,59,24,16,5,20,6,79,80,58,34,68,133,29,130,298,30,98,83,53,67,39,52,66]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i,o,s,t,n,l,S,D,M,P,k,O,F,z,Y,J,oe,re,ce,Q,K,V,q,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function j(se){return(0,oe.isWorkspaceIdentifier)(se?.workspace)}function H(se){return(0,oe.isSingleFolderWorkspaceIdentifier)(se?.workspace)}let X=class extends w.Disposable{constructor(W,_,U,B,T,$,x,ae,fe,ue,de,be,we,ye,ke,Be,pe,ve,Z){super(),this.machineId=W,this.sqmId=_,this.initialUserEnv=U,this.logService=B,this.loggerService=T,this.stateService=$,this.policyService=x,this.environmentMainService=ae,this.userDataProfilesMainService=fe,this.lifecycleMainService=ue,this.backupMainService=de,this.configurationService=be,this.workspacesHistoryMainService=we,this.workspacesManagementMainService=ye,this.instantiationService=ke,this.dialogMainService=Be,this.fileService=pe,this.protocolMainService=ve,this.themeMainService=Z,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new u.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new J.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(W=>this._onDidSignalReadyWindow.fire(W.window))),this._register(this.onDidSignalReadyWindow(W=>{if(W.config?.extensionDevelopmentPath||W.config?.extensionTestsPath){const _=new w.DisposableStore;if(_.add(u.Event.any(W.onDidClose,W.onDidDestroy)(()=>_.dispose())),W.config.extensionDevelopmentPath)for(const U of W.config.extensionDevelopmentPath)_.add(this.protocolMainService.addValidFileRoot(U));W.config.extensionTestsPath&&_.add(this.protocolMainService.addValidFileRoot(W.config.extensionTestsPath))}}))}openEmptyWindow(W,_){const U=this.environmentMainService.args,B=_?.remoteAuthority||void 0,T=!0,$=_?.forceReuseWindow,x=!$;return this.open({...W,cli:U,forceEmpty:T,forceNewWindow:x,forceReuseWindow:$,remoteAuthority:B})}openExistingWindow(W,_){W.focus(),this.handleWaitMarkerFile(_,[W])}async open(W){this.logService.trace("windowsManager#open"),W.addMode&&(W.initialStartup||!this.getLastActiveWindow())&&(W.addMode=!1);const _=[],U=[],B=[],T=[],$=[];let x,ae=0;const fe=await this.getPathsToOpen(W);this.logService.trace("windowsManager#open pathsToOpen",fe);for(const ye of fe)H(ye)?W.addMode?_.push(ye):U.push(ye):j(ye)?B.push(ye):ye.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ye.remoteAuthority}),x.filesToOpenOrCreate.push(ye)):ye.backupPath?$.push({backupFolder:(0,h.basename)(ye.backupPath),remoteAuthority:ye.remoteAuthority}):ae++;W.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),W.mergeMode&&x&&x.filesToOpenOrCreate.length===4&&(x.filesToMerge=x.filesToOpenOrCreate.slice(0,4),x.filesToOpenOrCreate=[],x.filesToDiff=[]),x&&W.waitMarkerFileURI&&(x.filesToWait={paths:(0,R.coalesce)([...x.filesToDiff,x.filesToMerge[3],...x.filesToOpenOrCreate]),waitMarkerFileUri:W.waitMarkerFileURI}),W.initialStartup?(T.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),B.push(...T),$.push(...this.backupMainService.getEmptyWindowBackups())):$.length=0;const{windows:ue,filesOpenedInWindow:de}=await this.doOpen(W,B,U,$,ae,x,_);if(this.logService.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${U.length}, emptyToRestore: ${$.length}, emptyToOpen: ${ae})`),ue.length>1)if(de)de.focus();else{const ye=this.windowsStateHandler.state.lastActiveWindow&&!W.forceEmpty&&!W.cli._.length&&!W.cli["file-uri"]&&!W.cli["folder-uri"]&&!(W.urisToOpen&&W.urisToOpen.length);let ke=!0,Be=!0;if(ye){const pe=ue.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),ke=!1,Be=!1)}if(ke)for(let pe=ue.length-1;pe>=0;pe--){const ve=ue[pe];if(!(ve.openedWorkspace&&T.some(Z=>ve.openedWorkspace&&Z.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&$.some(Z=>ve.backupPath&&Z.backupFolder===(0,h.basename)(ve.backupPath)))){ve.focus(),Be=!1;break}}Be&&ue[ue.length-1].focus()}const be=x&&x.filesToDiff.length>0,we=x&&x.filesToMerge.length>0;if(!ue.some(ye=>ye.isExtensionDevelopmentHost)&&!be&&!we&&!W.noRecentEntry){const ye=[];for(const ke of fe)j(ke)&&!ke.transient?ye.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):H(ke)?ye.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&ye.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ye)}return this.handleWaitMarkerFile(W,ue),ue}handleWaitMarkerFile(W,_){const U=W.waitMarkerFileURI;W.context===0&&U&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.fileService.del(U)}catch{}})()}async doOpen(W,_,U,B,T,$,x){const ae=[];let fe;function ue(pe,ve){ae.push(pe),ve&&(fe=pe,$=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:be}=this.shouldOpenNewWindow(W);if(!W.initialStartup&&x.length>0){const pe=x[0].remoteAuthority,ve=this.getLastActiveWindowForAuthority(pe);ve&&ue(this.doAddFoldersToExistingWindow(ve,x.map(Z=>Z.workspace.uri)))}const we=U.length+_.length+B.length;if($&&we===0){const pe=$.filesToOpenOrCreate[0]||$.filesToDiff[0]||$.filesToMerge[3],ve=this.getWindows().filter(le=>$&&(0,m.isEqualAuthority)(le.remoteAuthority,$.remoteAuthority));let Z;pe?.fileUri&&!be&&((W.context===4||W.context===0||W.context===1)&&(Z=await(0,Y.findWindowOnFile)(ve,pe.fileUri,async le=>le.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(le.configPath):void 0)),Z||(Z=this.doGetLastActiveWindow(ve))),Z?(0,oe.isWorkspaceIdentifier)(Z.openedWorkspace)?_.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(Z.openedWorkspace)?U.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):ue(this.doOpenFilesInExistingWindow(W,Z,$),!0):ue(await this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,filesToOpen:$,forceNewWindow:!0,remoteAuthority:$.remoteAuthority,forceNewTabbedWindow:W.forceNewTabbedWindow,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile}),!0)}const ye=(0,R.distinct)(_,pe=>pe.workspace.id);if(ye.length>0){const pe=(0,R.coalesce)(ye.map(ve=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.configPath)));if(pe.length>0){const ve=pe[0],Z=(0,m.isEqualAuthority)($?.remoteAuthority,ve.remoteAuthority)?$:void 0;ue(this.doOpenFilesInExistingWindow(W,ve,Z),!!Z),de=!0}for(const ve of ye){if(pe.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===ve.workspace.id))continue;const Z=ve.remoteAuthority,le=(0,m.isEqualAuthority)($?.remoteAuthority,Z)?$:void 0;ue(await this.doOpenFolderOrWorkspace(W,ve,de,le),!!le),de=!0}}const ke=(0,R.distinct)(U,pe=>m.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(ke.length>0){const pe=(0,R.coalesce)(ke.map(ve=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.uri)));if(pe.length>0){const ve=pe[0],Z=(0,m.isEqualAuthority)($?.remoteAuthority,ve.remoteAuthority)?$:void 0;ue(this.doOpenFilesInExistingWindow(W,ve,Z),!!Z),de=!0}for(const ve of ke){if(pe.some(ge=>(0,oe.isSingleFolderWorkspaceIdentifier)(ge.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(ge.openedWorkspace.uri,ve.workspace.uri)))continue;const Z=ve.remoteAuthority,le=(0,m.isEqualAuthority)($?.remoteAuthority,Z)?$:void 0;ue(await this.doOpenFolderOrWorkspace(W,ve,de,le),!!le),de=!0}}const Be=(0,R.distinct)(B,pe=>pe.backupFolder);if(Be.length>0)for(const pe of Be){const ve=pe.remoteAuthority,Z=(0,m.isEqualAuthority)($?.remoteAuthority,ve)?$:void 0;ue(await this.doOpenEmpty(W,!0,ve,Z,pe),!!Z),de=!0}if(ae.length===0||$){$&&!T&&T++;const pe=$?$.remoteAuthority:W.remoteAuthority;for(let ve=0;ve<T;ve++)ue(await this.doOpenEmpty(W,de,pe,$),!!$),de=!0}return{windows:(0,R.distinct)(ae),filesOpenedInWindow:fe}}doOpenFilesInExistingWindow(W,_,U){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),_.focus();const B={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:W?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",I.CancellationToken.None,B),_}doAddFoldersToExistingWindow(W,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:_}),W.focus();const U={foldersToAdd:_};return W.sendWhenReady("vscode:addFolders",I.CancellationToken.None,U),W}doOpenEmpty(W,_,U,B,T){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!T,remoteAuthority:U,filesToOpen:B,forceNewWindow:_});let $;return!_&&typeof W.contextWindowId=="number"&&($=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:U,forceNewWindow:_,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:B,windowToUse:$,emptyWindowBackupInfo:T,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile})}doOpenFolderOrWorkspace(W,_,U,B,T){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:_,filesToOpen:B}),!U&&!T&&typeof W.contextWindowId=="number"&&(T=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:B,windowToUse:T,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile})}async getPathsToOpen(W){let _,U=!1,B=!1;if(W.urisToOpen&&W.urisToOpen.length>0?(_=await this.doExtractPathsFromAPI(W),U=!0):W.forceEmpty?_=[Object.create(null)]:W.cli._.length||W.cli["folder-uri"]||W.cli["file-uri"]?(_=await this.doExtractPathsFromCLI(W.cli),_.length===0&&_.push(Object.create(null)),U=!0):(_=await this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),B=!0),!W.addMode&&U){const T=_.filter($=>H($));if(T.length>1){const $=T[0].remoteAuthority;if(T.every(x=>(0,m.isEqualAuthority)(x.remoteAuthority,$))){const x=await this.workspacesManagementMainService.createUntitledWorkspace(T.map(ae=>({uri:ae.workspace.uri})));_.push({workspace:x,remoteAuthority:$}),_=_.filter(ae=>!H(ae))}}}if(W.initialStartup&&!B&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const T=await this.doGetPathsFromLastSession();_.unshift(...T.filter($=>j($)||H($)||$.backupPath))}return _}async doExtractPathsFromAPI(W){const _={gotoLineMode:W.gotoLineMode,remoteAuthority:W.remoteAuthority},U=await Promise.all((0,R.coalesce)(W.urisToOpen||[]).map(async B=>{const T=await this.resolveOpenable(B,_);if(T)return T.label=B.label,T;const $=this.resourceFromOpenable(B);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:$.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:$.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,g.getPathLabel)($,{os:p.OS,tildify:this.environmentMainService})):(0,E.localize)(4,null,$.toString(!0))},C.BrowserWindow.getFocusedWindow()??void 0)}));return(0,R.coalesce)(U)}async doExtractPathsFromCLI(W){const _=[],U={ignoreFileNotFound:!0,gotoLineMode:W.goto,remoteAuthority:W.remote||void 0,forceOpenWorkspaceAsFile:W.diff&&W._.length===2||W.merge&&W._.length===4},B=W["folder-uri"];if(B){const x=await Promise.all(B.map(ae=>{const fe=this.cliArgToUri(ae);if(fe)return this.resolveOpenable({folderUri:fe},U)}));_.push(...(0,R.coalesce)(x))}const T=W["file-uri"];if(T){const x=await Promise.all(T.map(ae=>{const fe=this.cliArgToUri(ae);if(fe)return this.resolveOpenable((0,oe.hasWorkspaceFileExtension)(ae)?{workspaceUri:fe}:{fileUri:fe},U)}));_.push(...(0,R.coalesce)(x))}const $=await Promise.all(W._.map(x=>U.remoteAuthority?this.doResolveRemotePath(x,U):this.doResolveFilePath(x,U)));return _.push(...(0,R.coalesce)($)),_}cliArgToUri(W){try{const _=d.URI.parse(W);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${W}`);return}return _.path?_:_.with({path:"/"})}catch(_){this.logService.error(`Invalid URI input string: ${W}, ${_.message}`)}}async doGetPathsFromLastSession(){const W=this.getRestoreWindowsSetting();switch(W){case"none":return[];case"one":case"all":case"preserve":case"folders":{const _=[];W!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const U=await Promise.all(_.map(async B=>{if(B.workspace){const T=await this.resolveOpenable({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if(j(T))return T}else if(B.folderUri){const T=await this.resolveOpenable({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(H(T))return T}else if(W!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,R.coalesce)(U)}}}getRestoreWindowsSetting(){let W;return this.lifecycleMainService.wasRestarted?W="all":(W=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(W)||(W="all")),W}async resolveOpenable(W,_=Object.create(null)){const U=this.resourceFromOpenable(W);return U.scheme===y.Schemas.file?((0,O.isFileToOpen)(W)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(U.fsPath,_)):this.doResolveRemoteOpenable(W,_)}doResolveRemoteOpenable(W,_){let U=this.resourceFromOpenable(W);const B=(0,P.getRemoteAuthority)(U)||_.remoteAuthority;if(U=(0,m.removeTrailingPathSeparator)((0,m.normalizePath)(U)),(0,O.isFileToOpen)(W)){if(_.gotoLineMode){const{path:T,line:$,column:x}=(0,a.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:T}),options:{selection:$?{startLineNumber:$,startColumn:x||1}:void 0},remoteAuthority:B}}return{fileUri:U,remoteAuthority:B}}else if((0,O.isWorkspaceToOpen)(W))return{workspace:(0,re.getWorkspaceIdentifier)(U),remoteAuthority:B};return{workspace:(0,re.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:B}}resourceFromOpenable(W){return(0,O.isWorkspaceToOpen)(W)?W.workspaceUri:(0,O.isFolderToOpen)(W)?W.folderUri:W.fileUri}async doResolveFilePath(W,_,U){let B,T;_.gotoLineMode&&({path:W,line:B,column:T}=(0,a.parseLineAndColumnAware)(W)),W=(0,a.sanitizeFilePath)((0,h.normalize)(W),(0,v.cwd)());try{const $=await L.Promises.stat(W);if($.isFile()){if(!_.forceOpenWorkspaceAsFile){const x=await this.workspacesManagementMainService.resolveLocalWorkspace(d.URI.file(W));if(x)return x.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:t.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:d.URI.file(W),type:t.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:T||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,re.getSingleFolderWorkspaceIdentifier)(d.URI.file(W),$),type:t.FileType.Directory,exists:!0};if(!p.isWindows&&W==="/dev/null")return{fileUri:d.URI.file(W),type:t.FileType.File,exists:!0}}}catch($){if($.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!U)return this.onUNCHostNotAllowed(W,_);const x=d.URI.file(W);if(this.workspacesHistoryMainService.removeRecentlyOpened([x]),_.ignoreFileNotFound)return{fileUri:x,type:t.FileType.File,exists:!1}}}async onUNCHostNotAllowed(W,_){const U=d.URI.file(W),{response:B,checkboxChecked:T}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,U.authority),detail:(0,E.localize)(9,null,(0,g.getPathLabel)(U,{os:p.OS,tildify:this.environmentMainService})),checkboxLabel:(0,E.localize)(10,null,U.authority),cancelId:1});if(B===0){if((0,r.addUNCHostToAllowlist)(U.authority),T){const $={channel:"vscode:configureAllowedUNCHost",args:U.authority};this.sendToFocused($.channel,$.args),this.sendToOpeningWindow($.channel,$.args)}return this.doResolveFilePath(W,_,!0)}if(B===2)return C.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(W,_)}doResolveRemotePath(W,_){const U=W.charCodeAt(0),B=_.remoteAuthority;let T,$;_.gotoLineMode&&({path:W,line:T,column:$}=(0,a.parseLineAndColumnAware)(W)),U!==47&&((0,a.isWindowsDriveLetter)(U)&&W.charCodeAt(W.charCodeAt(1))===58&&(W=(0,a.toSlashes)(W)),W=`/${W}`);const x=d.URI.from({scheme:y.Schemas.vscodeRemote,authority:B,path:W});if(W.charCodeAt(W.length-1)!==47){if((0,oe.hasWorkspaceFileExtension)(W))return _.forceOpenWorkspaceAsFile?{fileUri:x,options:{selection:T?{startLineNumber:T,startColumn:$||1}:void 0},remoteAuthority:_.remoteAuthority}:{workspace:(0,re.getWorkspaceIdentifier)(x),remoteAuthority:B};if(_.gotoLineMode||h.posix.basename(W).indexOf(".")!==-1)return{fileUri:x,options:{selection:T?{startLineNumber:T,startColumn:$||1}:void 0},remoteAuthority:B}}return{workspace:(0,re.getSingleFolderWorkspaceIdentifier)(x),remoteAuthority:B}}shouldOpenNewWindow(W){const _=this.configurationService.getValue("window"),U=_?.openFoldersInNewWindow||"default",B=_?.openFilesInNewWindow||"off";let T=(W.preferNewWindow||W.forceNewWindow)&&!W.forceReuseWindow;!W.forceNewWindow&&!W.forceReuseWindow&&(U==="on"||U==="off")&&(T=U==="on");let $=!1;return W.forceNewWindow||W.forceReuseWindow?$=!!W.forceNewWindow&&!W.forceReuseWindow:(p.isMacintosh?W.context===1&&($=!0):W.context!==3&&W.context!==2&&!(W.userEnv&&W.userEnv.TERM_PROGRAM==="vscode")&&($=!0),!W.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&($=B==="on")),{openFolderInNewWindow:!!T,openFilesInNewWindow:$}}async openExtensionDevelopmentHostWindow(W,_){const U=(0,Y.findWindowOnExtensionDevelopmentPath)(this.getWindows(),W);if(U)return this.lifecycleMainService.reload(U,_.cli),U.focus(),[U];let B=_.cli["folder-uri"]||[],T=_.cli["file-uri"]||[],$=_.cli._;if(!$.length&&!B.length&&!T.length&&!_.cli.extensionTestsPath){const fe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ue=fe?.workspace??fe?.folderUri;ue&&(d.URI.isUri(ue)?ue.scheme===y.Schemas.file?$=[ue.fsPath]:B=[ue.toString()]:ue.configPath.scheme===y.Schemas.file?$=[(0,m.originalFSPath)(ue.configPath)]:T=[ue.configPath.toString()])}let x=_.remoteAuthority;for(const fe of W)if(fe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=d.URI.parse(fe),de=(0,P.getRemoteAuthority)(ue);de&&(x?(0,m.isEqualAuthority)(de,x)||this.logService.error("more than one extension development path authority"):x=de)}$=$.filter(fe=>{const ue=d.URI.file(fe);return(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:(0,m.isEqualAuthority)((0,P.getRemoteAuthority)(ue),x)}),B=B.filter(fe=>{const ue=this.cliArgToUri(fe);return ue&&(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,m.isEqualAuthority)((0,P.getRemoteAuthority)(ue),x):!1}),T=T.filter(fe=>{const ue=this.cliArgToUri(fe);return ue&&(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ue)?!1:ue?(0,m.isEqualAuthority)((0,P.getRemoteAuthority)(ue),x):!1}),_.cli._=$,_.cli["folder-uri"]=B,_.cli["file-uri"]=T;const ae={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:!$.length&&!B.length&&!T.length,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:x,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile};return this.open(ae)}async openInBrowserWindow(W){const _=this.configurationService.getValue("window"),U=this.getLastActiveWindow(),B=U?.profile??this.userDataProfilesMainService.defaultProfile;let T;!W.forceNewWindow&&!W.forceNewTabbedWindow&&(T=W.windowToUse||U,T&&T.focus());const $={...this.environmentMainService.args,...W.cli,machineId:this.machineId,sqmId:this.sqmId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:W.emptyWindowBackupInfo?(0,h.join)(this.environmentMainService.backupHome,W.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:B},homeDir:this.environmentMainService.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:W.remoteAuthority,workspace:W.workspace,userEnv:{...this.initialUserEnv,...W.userEnv},filesToOpenOrCreate:W.filesToOpen?.filesToOpenOrCreate,filesToDiff:W.filesToOpen?.filesToDiff,filesToMerge:W.filesToOpen?.filesToMerge,filesToWait:W.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:y.Schemas.file}).fsPath,product:D.default,isInitialStartup:W.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)(),arch:(0,A.arch)()},zoomLevel:typeof _?.zoomLevel=="number"?_.zoomLevel:void 0,autoDetectHighContrast:_?.autoDetectHighContrast??!0,autoDetectColorScheme:_?.autoDetectColorScheme??!1,accessibilitySupport:C.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(T){const x=T.config;!$.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&($.extensionDevelopmentPath=x.extensionDevelopmentPath,$.extensionDevelopmentKind=x.extensionDevelopmentKind,$["enable-proposed-api"]=x["enable-proposed-api"],$.verbose=x.verbose,$["inspect-extensions"]=x["inspect-extensions"],$["inspect-brk-extensions"]=x["inspect-brk-extensions"],$.debugId=x.debugId,$.extensionEnvironment=x.extensionEnvironment,$["extensions-dir"]=x["extensions-dir"],$["disable-extensions"]=x["disable-extensions"]),$.loggers={global:$.loggers.global,window:x?.loggers.window??$.loggers.window}}else{const x=this.windowsStateHandler.getNewWindowState($);(0,b.mark)("code/willCreateCodeWindow");const ae=T=this.instantiationService.createInstance(F.CodeWindow,{state:x,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});(0,b.mark)("code/didCreateCodeWindow"),W.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ae),this.windows.set(ae.id,ae),this._onDidOpenWindow.fire(ae),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const fe=new w.DisposableStore;fe.add(ae.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(ae))),fe.add(u.Event.once(ae.onDidClose)(()=>this.onWindowClosed(ae,fe))),fe.add(u.Event.once(ae.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ae))),fe.add(ae.onDidTriggerSystemContextMenu(({x:de,y:be})=>this._onDidTriggerSystemContextMenu.fire({window:ae,x:de,y:be})));const ue=(0,f.assertIsDefined)(ae.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ae)),this.lifecycleMainService.registerWindow(ae)}return $.windowId=T.id,T.isReady?this.lifecycleMainService.unload(T,4).then(async x=>{x||await this.doOpenInBrowserWindow(T,$,W,B)}):await this.doOpenInBrowserWindow(T,$,W,B),T}async doOpenInBrowserWindow(W,_,U,B){if(_.extensionDevelopmentPath||((0,oe.isWorkspaceIdentifier)(_.workspace)?_.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:_.workspace,remoteAuthority:_.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(_.workspace)?_.backupPath=this.backupMainService.registerFolderBackup({folderUri:_.workspace.uri,remoteAuthority:_.remoteAuthority}):_.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,re.createEmptyWorkspaceIdentifier)().id,remoteAuthority:_.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const T=_.workspace??(0,oe.toWorkspaceIdentifier)(_.backupPath,!1),$=this.resolveProfileForBrowserWindow(U,T,B),x=$ instanceof Promise?await $:$;_.profiles.profile=x,_.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(T,x)}W.load(_)}resolveProfileForBrowserWindow(W,_,U){return W.forceProfile?this.userDataProfilesMainService.profiles.find(B=>B.name===W.forceProfile)??this.userDataProfilesMainService.createNamedProfile(W.forceProfile):W.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(_)??U}onWindowClosed(W,_){this.windows.delete(W.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),_.dispose()}getFocusedWindow(){const W=C.BrowserWindow.getFocusedWindow();if(W)return this.getWindowById(W.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(W){return this.doGetLastActiveWindow(this.getWindows().filter(_=>(0,m.isEqualAuthority)(_.remoteAuthority,W)))}doGetLastActiveWindow(W){return(0,z.getLastFocused)(W)}sendToFocused(W,..._){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(W,I.CancellationToken.None,..._)}sendToOpeningWindow(W,..._){this._register(u.Event.once(this.onDidSignalReadyWindow)(U=>{U.sendWhenReady(W,I.CancellationToken.None,..._)}))}sendToAll(W,_,U){for(const B of this.getWindows())U&&U.indexOf(B.id)>=0||B.sendWhenReady(W,I.CancellationToken.None,_)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(W){return this.windows.get(W)}getWindowByWebContents(W){const _=C.BrowserWindow.fromWebContents(W);if(_)return this.getWindowById(_.id)}};e.WindowsMainService=X,e.WindowsMainService=X=Pe([te(3,S.ILogService),te(4,N.ILoggerMainService),te(5,k.IStateService),te(6,V.IPolicyService),te(7,s.IEnvironmentMainService),te(8,q.IUserDataProfilesMainService),te(9,l.ILifecycleMainService),te(10,c.IBackupMainService),te(11,i.IConfigurationService),te(12,ce.IWorkspacesHistoryMainService),te(13,Q.IWorkspacesManagementMainService),te(14,n.IInstantiationService),te(15,o.IDialogMainService),te(16,t.IFileService),te(17,M.IProtocolMainService),te(18,K.IThemeMainService)],X)}),define(ie[307],ne([0,1,63,29,83,53]),function(G,e,C,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=class{constructor(u,a,g,w){this.workspacesManagementMainService=u,this.windowsMainService=a,this.workspacesHistoryMainService=g,this.backupMainService=w,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(u,a){const g=this.windowsMainService.getWindowById(u);if(g)return this.workspacesManagementMainService.enterWorkspace(g,this.windowsMainService.getWindows(),a)}createUntitledWorkspace(u,a,g){return this.workspacesManagementMainService.createUntitledWorkspace(a,g)}deleteUntitledWorkspace(u,a){return this.workspacesManagementMainService.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(u,a){return this.workspacesManagementMainService.getWorkspaceIdentifier(a)}getRecentlyOpened(u){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(u,a){return this.workspacesHistoryMainService.addRecentlyOpened(a)}removeRecentlyOpened(u,a){return this.workspacesHistoryMainService.removeRecentlyOpened(a)}clearRecentlyOpened(u){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=R,e.WorkspacesMainService=R=Pe([te(0,A.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,r.IWorkspacesHistoryMainService),te(3,C.IBackupMainService)],R)}),define(ie[308],ne([0,1,15,131,38,28,17,49,14,33,3,44,46,2,13,9,4,12,7,32,158,42,159,110,290,162,63,283,18,200,91,132,59,116,220,24,62,94,209,293,211,212,213,16,224,93,77,5,92,219,299,284,291,20,6,305,69,25,58,294,95,34,275,82,122,26,251,253,51,48,265,288,300,289,301,127,267,268,269,272,297,29,306,274,30,97,83,307,53,39,233,52,244,50,81,129,277,292,280,8,255,276,228,66,296,271,23,125,295,263,239,71,78,303]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i,o,s,t,n,l,S,D,M,P,k,O,F,z,Y,J,oe,re,ce,Q,K,V,q,N,j,H,X,se,W,_,U,B,T,$,x,ae,fe,ue,de,be,we,ye,ke,Be,pe,ve,Z,le,ge,De,Re,We,Ae,He,ze,ee,he,me,Ee,Me,Ue,Oe,Te,xe,je,Ve,Xe,Ye,it,nt,vt,wt,St,yt,bt,Et,Pt,st,dt,It,Ct,kt,ot,Dt,ht,at,Mt,Rt,ct,Lt,ft,At){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ut=class extends h.Disposable{static{lt=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[b.Schemas.file]:"security.promptForLocalFileProtocolHandling",[b.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ie,Ce,Le,Se,_e,Fe,$e,Ge,qe,Ne,Ke,Qe){super(),this.mainProcessNodeIpcServer=Ie,this.userEnv=Ce,this.mainInstantiationService=Le,this.logService=Se,this.loggerService=_e,this.environmentMainService=Fe,this.lifecycleMainService=$e,this.configurationService=Ge,this.stateService=qe,this.fileService=Ne,this.productService=Ke,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const Ie=qe=>qe?.startsWith(`${b.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);C.session.defaultSession.setPermissionRequestHandler((qe,Ne,Ke,Qe)=>Ie(Qe.requestingUrl)?Ke(Ce.has(Ne)):Ke(!1)),C.session.defaultSession.setPermissionCheckHandler((qe,Ne,Ke,Qe)=>Ie(Qe.requestingUrl)?Ce.has(Ne):!1);const Le=new Set([b.Schemas.file,b.Schemas.vscodeFileResource,b.Schemas.vscodeRemoteResource,b.Schemas.vscodeManagedRemoteResource,"devtools"]),Se=qe=>{for(let Ne=qe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${b.Schemas.vscodeWebview}://`))return!0;return!1},_e=qe=>qe.resourceType==="xhr"||Se(qe.frame),Fe=qe=>{const Ne=qe.frame;if(!Ne||!this.windowsMainService)return!1;const Ke=C.BrowserWindow.getAllWindows();for(const Qe of Ke)if(Ne.processId===Qe.webContents.mainFrame.processId)return!0;return!1},$e=(qe,Ne)=>{if(qe.path!=="/index.html")return!0;const Ke=Ne.frame;if(!Ke||!this.windowsMainService)return!1;for(const Qe of this.windowsMainService.getWindows())if(Qe.win&&Ke.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};C.session.defaultSession.webRequest.onBeforeRequest((qe,Ne)=>{const Ke=f.URI.parse(qe.url);return Ke.scheme===b.Schemas.vscodeWebview&&!$e(Ke,qe)?(this.logService.error("Blocked vscode-webview request",qe.url),Ne({cancel:!0})):Ke.scheme===b.Schemas.vscodeFileResource&&!Fe(qe)?(this.logService.error("Blocked vscode-file request",qe.url),Ne({cancel:!0})):Ke.path.endsWith(".svg")&&!Le.has(Ke.scheme)?Ne({cancel:!_e(qe)}):Ne({cancel:!1})}),C.session.defaultSession.webRequest.onHeadersReceived((qe,Ne)=>{const Ke=qe.responseHeaders,Qe=Ke["content-type"]||Ke["Content-Type"];if(Qe&&Array.isArray(Qe)){const Je=f.URI.parse(qe.url);if(Je.path.endsWith(".svg")&&Le.has(Je.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:Ke});if(!Je.path.endsWith(b.Schemas.vscodeRemoteResource)&&Qe.some(et=>et.toLowerCase().includes("image/svg")))return Ne({cancel:!_e(qe)})}return Ne({cancel:!1})});const Ge=C.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ge.setCodeCachePath((0,p.join)(this.environmentMainService.codeCachePath,"chrome")),v.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,u.setUnexpectedErrorHandler)(Le=>this.onUnexpectedError(Le)),process.on("uncaughtException",Le=>{(0,u.isSigPipeError)(Le)||(0,u.onUnexpectedError)(Le)}),process.on("unhandledRejection",Le=>(0,u.onUnexpectedError)(Le)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,E.registerContextMenuListener)(),C.app.on("accessibility-support-changed",(Le,Se)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Se)}),C.app.on("activate",async(Le,Se)=>{this.logService.trace("app#activate"),Se||await this.windowsMainService?.openEmptyWindow({context:1})}),C.app.on("web-contents-created",(Le,Se)=>{Se?.opener?.url.startsWith(`${b.Schemas.vscodeFileResource}://${b.VSCODE_AUTHORITY}/`)&&this.auxiliaryWindowsMainService?.registerWindow(Se),Se.on("will-navigate",Fe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Se.setWindowOpenHandler(Fe=>Fe.url==="about:blank"?(this.logService.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow()}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Fe.url}}`),this.nativeHostMainService?.openExternal(void 0,Fe.url),{action:"deny"}))});let Ie=[],Ce;C.app.on("open-file",(Le,Se)=>{this.logService.trace("app#open-file: ",Se),Le.preventDefault(),Ie.push((0,Te.hasWorkspaceFileExtension)(Se)?{workspaceUri:f.URI.file(Se)}:{fileUri:f.URI.file(Se)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Ce=void 0},100)}),C.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:getWindowId",Le=>Promise.resolve(Le.sender.id)),r.validatedIpcMain.handle("vscode:fetchShellEnv",Le=>{const Se=this.windowsMainService?.getWindowByWebContents(Le.sender);let _e,Fe;return Se?.config?(_e=Se.config,Fe={...process.env,...Se.config.userEnv}):(_e=this.environmentMainService.args,Fe=process.env),this.resolveShellEnvironment(_e,Fe,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(Le,Se,_e)=>{const Fe=this.validateNlsPath([Se]);if(!Fe||typeof _e!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Fe,R.VSBuffer.fromString(_e))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(Le,...Se)=>{const _e=this.validateNlsPath(Se);if(!_e)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(_e)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",Le=>Le.sender.reload())}validateNlsPath(Ie){let Ce;for(const Le of Ie)typeof Le=="string"&&(typeof Ce!="string"?Ce=Le:Ce=(0,p.join)(Ce,Le));if(!(typeof Ce!="string"||!(0,p.isAbsolute)(Ce)||!(0,a.isEqualOrParent)(Ce,this.environmentMainService.cachedLanguagesPath,!v.isLinux)))return f.URI.file(Ce)}onUnexpectedError(Ie){if(Ie){const Ce={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.logService.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.logService.error(Ie.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ie=this.productService.win32AppUserModelId;v.isWindows&&Ie&&C.app.setAppUserModelId(Ie);try{v.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!C.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&C.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.logService.error(Ne)}const Ce=new i.Server;this.lifecycleMainService.onWillShutdown(Ne=>{Ne.reason===2&&Ce.dispose()}),this.logService.trace("Resolving machine identifier...");const[Le,Se]=await Promise.all([(0,dt.resolveMachineId)(this.stateService,this.logService),(0,dt.resolveSqmId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:_e,sharedProcessClient:Fe}=this.setupSharedProcess(Le,Se),$e=await this.initServices(Le,Se,_e);this._register($e.createInstance(s.ProxyAuthHandler)),this._register($e.createInstance(Et.UserDataProfilesHandler)),$e.invokeFunction(Ne=>this.initChannels(Ne,Ce,Fe));const Ge=await $e.invokeFunction(Ne=>this.setupProtocolUrlHandlers(Ne,Ce));this.setupManagedRemoteResourceUrlHandler(Ce),this.lifecycleMainService.phase=2,await $e.invokeFunction(Ne=>this.openFirstWindow(Ne,Ge)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new st.RunOnceScheduler(()=>{this._register((0,st.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}async setupProtocolUrlHandlers(Ie,Ce){const Le=this.windowsMainService=Ie.get(Me.IWindowsMainService),Se=Ie.get(He.IURLService),_e=this.nativeHostMainService=Ie.get(x.INativeHostMainService),Fe=Ie.get(k.IDialogMainService),$e=this;Se.registerHandler({async handleURL(Je,et){return $e.handleProtocolUrl(Le,Fe,Se,Je,et)}});const Ge=this._register(new Oe.ActiveWindowManager({onDidOpenWindow:_e.onDidOpenWindow,onDidFocusWindow:_e.onDidFocusWindow,getActiveWindowId:()=>_e.getActiveWindowId(-1)})),qe=new c.StaticRouter(Je=>Ge.getActiveClientId().then(et=>Je===et)),Ne=new ze.URLHandlerRouter(qe,this.logService),Ke=Ce.getChannel("urlHandler",Ne);Se.registerHandler(new ze.URLHandlerChannelClient(Ke));const Qe=await this.resolveInitialProtocolUrls(Le,Fe);return this._register(new he.ElectronURLListener(Qe?.urls,Se,Le,this.environmentMainService,this.productService,this.logService)),Qe}setupManagedRemoteResourceUrlHandler(Ie){const Ce=()=>({statusCode:404,data:"Not found"}),Le=new Lt.Lazy(()=>Ie.getChannel(ct.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new ct.NodeRemoteResourceRouter));C.protocol.registerBufferProtocol(b.Schemas.vscodeManagedRemoteResource,(Se,_e)=>{const Fe=f.URI.parse(Se.url);if(!Fe.authority.startsWith("window:"))return _e(Ce());Le.value.call(ct.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Fe]).then($e=>_e({...$e,data:Buffer.from($e.body,"base64")}),$e=>{this.logService.warn("error dispatching remote resource call",$e),_e({statusCode:500,data:String($e)})})})}async resolveInitialProtocolUrls(Ie,Ce){const Le=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Le.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Le.length+Se.length===0)return;const _e=[...Le,...Se].map(Ge=>{try{return{uri:f.URI.parse(Ge),originalUrl:Ge}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),Fe=[],$e=[];for(const Ge of _e){if(!Ge)continue;if(await this.shouldBlockURI(Ge.uri,Ie,Ce)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}const qe=this.getWindowOpenableFromProtocolUrl(Ge.uri);qe?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),qe),Fe.push(qe)):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),$e.push(Ge))}return{urls:$e,openables:Fe}}async shouldBlockURI(Ie,Ce,Le){if(Ie.authority!==b.Schemas.file&&Ie.authority!==b.Schemas.vscodeRemote||this.configurationService.getValue(lt.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[Ie.authority])===!1)return!1;const{response:_e,checkboxChecked:Fe}=await Le.showMessageBox({type:"warning",buttons:[(0,t.localize)(0,null),(0,t.localize)(1,null)],message:(0,t.localize)(2,null,Ie.authority===b.Schemas.file?(0,y.getPathLabel)(Ie,{os:v.OS,tildify:this.environmentMainService}):Ie.toString(!0),this.productService.nameShort),detail:(0,t.localize)(3,null),checkboxLabel:Ie.authority===b.Schemas.file?(0,t.localize)(4,null):(0,t.localize)(5,null),cancelId:1});if(_e!==0)return!0;if(Fe){const $e={channel:"vscode:disablePromptForProtocolHandling",args:Ie.authority===b.Schemas.file?"local":"remote"};Ce.sendToFocused($e.channel,$e.args),Ce.sendToOpeningWindow($e.channel,$e.args)}return!1}getWindowOpenableFromProtocolUrl(Ie){if(Ie.path){if(Ie.authority===b.Schemas.file){const Ce=f.URI.file(Ie.fsPath);return(0,Te.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(Ie.authority===b.Schemas.vscodeRemote){const Ce=Ie.path.indexOf(p.posix.sep,1);if(Ce!==-1){const Le=Ie.path.substring(1,Ce),Se=Ie.path.substring(Ce);let _e=Ie.query;const Fe=new URLSearchParams(Ie.query);Fe.get("windowId")==="_blank"&&(Fe.delete("windowId"),_e=Fe.toString());const $e=f.URI.from({scheme:b.Schemas.vscodeRemote,authority:Le,path:Se,query:_e,fragment:Ie.fragment});return(0,Te.hasWorkspaceFileExtension)(Se)?{workspaceUri:$e}:/:[\d]+$/.test(Se)?{fileUri:$e}:{folderUri:$e}}}}}async handleProtocolUrl(Ie,Ce,Le,Se,_e){if(this.logService.trace("app#handleProtocolUrl():",Se.toString(!0),_e),Se.scheme===this.productService.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:f.URI.parse(Se.query).path,query:""})),await this.shouldBlockURI(Se,Ie,Ce))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0;let Fe=!1;const $e=new URLSearchParams(Se.query);$e.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),$e.delete("windowId"),Se=Se.with({query:$e.toString()}),Fe=!0):v.isMacintosh&&Ie.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Fe=!0);const Ge=$e.get("continueOn");Ge!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),$e.delete("continueOn"),Se=Se.with({query:$e.toString()}),this.environmentMainService.continueOn=Ge??void 0);const qe=this.getWindowOpenableFromProtocolUrl(Se);return qe?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",qe,Se.toString(!0)),(0,ht.firstOrDefault)(await Ie.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[qe],forceNewWindow:Fe,gotoLineMode:!0}))?.focus(),!0):Fe?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,ht.firstOrDefault)(await Ie.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.getRemoteAuthority)(Se)}))?.ready(),Le.open(Se,_e)):(this.logService.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),_e),!1)}setupSharedProcess(Ie,Ce){const Le=this._register(this.mainInstantiationService.createInstance(ue.SharedProcess,Ie,Ce)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Fe=await Le.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Fe,"main")})();return{sharedProcessReady:(async()=>(await Le.whenReady(),Se))(),sharedProcessClient:Se}}async initServices(Ie,Ce,Le){const Se=new X.ServiceCollection;switch(process.platform){case"win32":Se.set(le.IUpdateService,new j.SyncDescriptor(Ae.Win32UpdateService));break;case"linux":v.isLinuxSnap?Se.set(le.IUpdateService,new j.SyncDescriptor(We.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(le.IUpdateService,new j.SyncDescriptor(Re.LinuxUpdateService));break;case"darwin":Se.set(le.IUpdateService,new j.SyncDescriptor(De.DarwinUpdateService));break}Se.set(Me.IWindowsMainService,new j.SyncDescriptor(Ue.WindowsMainService,[Ie,Ce,this.userEnv],!1)),Se.set(ft.IAuxiliaryWindowsMainService,new j.SyncDescriptor(At.AuxiliaryWindowsMainService,void 0,!1));const _e=new k.DialogMainService(this.logService,this.productService);Se.set(k.IDialogMainService,_e),Se.set(U.ILaunchMainService,new j.SyncDescriptor(U.LaunchMainService,void 0,!1)),Se.set(P.IDiagnosticsMainService,new j.SyncDescriptor(P.DiagnosticsMainService,void 0,!1)),Se.set(M.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(Le.then(Ne=>Ne.getChannel("diagnostics"))))),Se.set(se.IIssueMainService,new j.SyncDescriptor(W.IssueMainService,[this.userEnv])),Se.set(O.IEncryptionMainService,new j.SyncDescriptor(F.EncryptionMainService)),Se.set(_.IKeyboardLayoutMainService,new j.SyncDescriptor(_.KeyboardLayoutMainService)),Se.set(x.INativeHostMainService,new j.SyncDescriptor(x.NativeHostMainService,void 0,!1)),Se.set(me.IWebviewManagerService,new j.SyncDescriptor(Ee.WebviewMainService)),Se.set($.IMenubarMainService,new j.SyncDescriptor($.MenubarMainService)),Se.set(oe.IExtensionHostStarter,new j.SyncDescriptor(re.ExtensionHostStarter)),Se.set(ye.IStorageMainService,new j.SyncDescriptor(ye.StorageMainService)),Se.set(ye.IApplicationStorageMainService,new j.SyncDescriptor(ye.ApplicationStorageMainService));const Fe=new Mt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),$e=new Rt.PtyHostService(Fe,this.configurationService,this.logService,this.loggerService);Se.set(at.ILocalPtyService,$e),v.isWindows?Se.set(ce.IExternalTerminalMainService,new j.SyncDescriptor(Q.WindowsExternalTerminalService)):v.isMacintosh?Se.set(ce.IExternalTerminalMainService,new j.SyncDescriptor(Q.MacExternalTerminalService)):v.isLinux&&Se.set(ce.IExternalTerminalMainService,new j.SyncDescriptor(Q.LinuxExternalTerminalService));const Ge=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);Se.set(n.IBackupMainService,Ge);const qe=new Xe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ge,_e);if(Se.set(Xe.IWorkspacesManagementMainService,qe),Se.set(xe.IWorkspacesService,new j.SyncDescriptor(Ve.WorkspacesMainService,void 0,!1)),Se.set(je.IWorkspacesHistoryMainService,new j.SyncDescriptor(je.WorkspacesHistoryMainService,void 0,!1)),Se.set(He.IURLService,new j.SyncDescriptor(ee.NativeURLService,void 0,!1)),(0,Z.supportsTelemetry)(this.productService,this.environmentMainService)){const Ne=(0,Z.isInternalTelemetry)(this.productService,this.configurationService),Ke=(0,c.getDelayedChannel)(Le.then(rt=>rt.getChannel("telemetryAppender"))),Qe=new pe.TelemetryAppenderClient(Ke),Je=(0,ke.resolveCommonProperties)((0,A.release)(),(0,A.hostname)(),process.arch,this.productService.commit,this.productService.version,Ie,Ce,Ne),et=(0,Z.getPiiPathsFromEnvironment)(this.environmentMainService),tt={appenders:[Qe],commonProperties:Je,piiPaths:et,sendErrorTelemetry:!0};Se.set(Be.ITelemetryService,new j.SyncDescriptor(ve.TelemetryService,[tt],!1))}else Se.set(Be.ITelemetryService,Z.NullTelemetryService);return Se.set(St.IExtensionsProfileScannerService,new j.SyncDescriptor(It.ExtensionsProfileScannerService,void 0,!0)),Se.set(yt.IExtensionsScannerService,new j.SyncDescriptor(bt.ExtensionsScannerService,void 0,!0)),Se.set(ot.IUtilityProcessWorkerMainService,new j.SyncDescriptor(ot.UtilityProcessWorkerMainService,void 0,!0)),await st.Promises.settled([Ge.initialize(),qe.initialize()]),this.mainInstantiationService.createChild(Se)}initChannels(Ie,Ce,Le){const Se=this._register(new h.DisposableStore),_e=c.ProxyChannel.fromService(Ie.get(U.ILaunchMainService),Se,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",_e);const Fe=c.ProxyChannel.fromService(Ie.get(P.IDiagnosticsMainService),Se,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Fe);const $e=new it.PolicyChannel(Ie.get(Ye.IPolicyService));Ce.registerChannel("policy",$e),Le.then(Ze=>Ze.registerChannel("policy",$e));const Ge=this.fileService.getProvider(b.Schemas.file);(0,m.assertType)(Ge instanceof N.DiskFileSystemProvider);const qe=new q.DiskFileSystemProviderChannel(Ge,this.logService,this.environmentMainService);Ce.registerChannel(K.LOCAL_FILE_SYSTEM_CHANNEL_NAME,qe),Le.then(Ze=>Ze.registerChannel(K.LOCAL_FILE_SYSTEM_CHANNEL_NAME,qe));const Ne=c.ProxyChannel.fromService(Ie.get(nt.IUserDataProfilesMainService),Se);Ce.registerChannel("userDataProfiles",Ne),Le.then(Ze=>Ze.registerChannel("userDataProfiles",Ne));const Ke=new vt.RequestChannel(Ie.get(wt.IRequestService));Le.then(Ze=>Ze.registerChannel("request",Ke));const Qe=new ge.UpdateChannel(Ie.get(le.IUpdateService));Ce.registerChannel("update",Qe);const Je=c.ProxyChannel.fromService(Ie.get(se.IIssueMainService),Se);Ce.registerChannel("issue",Je);const et=c.ProxyChannel.fromService(Ie.get(O.IEncryptionMainService),Se);Ce.registerChannel("encryption",et);const tt=c.ProxyChannel.fromService(Ie.get(de.ISignService),Se);Ce.registerChannel("sign",tt);const rt=c.ProxyChannel.fromService(Ie.get(_.IKeyboardLayoutMainService),Se);Ce.registerChannel("keyboardLayout",rt),this.nativeHostMainService=Ie.get(x.INativeHostMainService);const gt=c.ProxyChannel.fromService(this.nativeHostMainService,Se);Ce.registerChannel("nativeHost",gt),Le.then(Ze=>Ze.registerChannel("nativeHost",gt));const _t=c.ProxyChannel.fromService(Ie.get(xe.IWorkspacesService),Se);Ce.registerChannel("workspaces",_t);const Ot=c.ProxyChannel.fromService(Ie.get($.IMenubarMainService),Se);Ce.registerChannel("menubar",Ot);const Wt=c.ProxyChannel.fromService(Ie.get(He.IURLService),Se);Ce.registerChannel("url",Wt);const Tt=c.ProxyChannel.fromService(Ie.get(me.IWebviewManagerService),Se);Ce.registerChannel("webview",Tt);const mt=this._register(new we.StorageDatabaseChannel(this.logService,Ie.get(ye.IStorageMainService)));Ce.registerChannel("storage",mt),Le.then(Ze=>Ze.registerChannel("storage",mt));const Ft=this._register(new Pt.ProfileStorageChangesListenerChannel(Ie.get(ye.IStorageMainService),Ie.get(nt.IUserDataProfilesMainService),this.logService));Le.then(Ze=>Ze.registerChannel("profileStorageListener",Ft));const Ut=c.ProxyChannel.fromService(Ie.get(at.ILocalPtyService),Se);Ce.registerChannel(at.TerminalIpcChannels.LocalPty,Ut);const Nt=c.ProxyChannel.fromService(Ie.get(ce.IExternalTerminalMainService),Se);Ce.registerChannel("externalTerminal",Nt);const pt=new Ct.LoggerChannel(Ie.get(kt.ILoggerMainService));Ce.registerChannel("logger",pt),Le.then(Ze=>Ze.registerChannel("logger",pt));const Bt=new D.ElectronExtensionHostDebugBroadcastChannel(Ie.get(Me.IWindowsMainService));Ce.registerChannel("extensionhostdebugservice",Bt);const zt=c.ProxyChannel.fromService(Ie.get(oe.IExtensionHostStarter),Se);Ce.registerChannel(oe.ipcExtensionHostStarterChannelName,zt);const $t=c.ProxyChannel.fromService(Ie.get(ot.IUtilityProcessWorkerMainService),Se);Ce.registerChannel(Dt.ipcUtilityProcessWorkerChannelName,$t)}async openFirstWindow(Ie,Ce){const Le=this.windowsMainService=Ie.get(Me.IWindowsMainService);this.auxiliaryWindowsMainService=Ie.get(ft.IAuxiliaryWindowsMainService);const Se=(0,Y.isLaunchedFromCli)(process.env)?0:4,_e=this.environmentMainService.args;if(Ce){if(Ce.openables.length>0)return Le.open({context:Se,cli:_e,urisToOpen:Ce.openables,gotoLineMode:!0,initialStartup:!0});if(Ce.urls.length>0)for(const tt of Ce.urls){const rt=new URLSearchParams(tt.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:rt.toString()}),Le.open({context:Se,cli:_e,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Fe=global.macOpenFiles,$e=_e._.length,Ge=!!_e["folder-uri"],qe=!!_e["file-uri"],Ne=_e["skip-add-to-recently-opened"]===!0,Ke=_e.wait&&_e.waitMarkerFilePath?f.URI.file(_e.waitMarkerFilePath):void 0,Qe=_e.remote||void 0,Je=_e.profile,et=_e["profile-temp"];if(!$e&&!Ge&&!qe){if(_e["new-window"]||Je||et)return Le.open({context:Se,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:Ke,initialStartup:!0,remoteAuthority:Qe,forceProfile:Je,forceTempProfile:et});if(Fe.length)return Le.open({context:1,cli:_e,urisToOpen:Fe.map(tt=>(0,Te.hasWorkspaceFileExtension)(tt)?{workspaceUri:f.URI.file(tt)}:{fileUri:f.URI.file(tt)}),noRecentEntry:Ne,waitMarkerFileURI:Ke,initialStartup:!0})}return Le.open({context:Se,cli:_e,forceNewWindow:_e["new-window"]||!$e&&_e["unity-launch"],diffMode:_e.diff,mergeMode:_e.merge,noRecentEntry:Ne,waitMarkerFileURI:Ke,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:Je,forceTempProfile:et})}afterWindowOpen(){this.installMutex(),C.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(Ie,Ce)=>{Ce({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),v.isMacintosh&&C.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Ie=this.productService.win32MutexName;if(v.isWindows&&Ie)try{const Ce=await new Promise((Se,_e)=>{G(["@vscode/windows-mutex"],Se,_e)}),Le=new Ce.Mutex(Ie);g.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Ce){this.logService.error(Ce)}}async resolveShellEnvironment(Ie,Ce,Le){try{return await(0,J.getResolvedShellEnv)(this.configurationService,this.logService,Ie,Ce)}catch(Se){const _e=(0,I.toErrorMessage)(Se);Le?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",_e):this.logService.error(_e)}return{}}async updateCrashReporterEnablement(){try{const Ce=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Le=JSON.parse((0,w.stripComments)(Ce)),_e=(0,Z.getTelemetryLevel)(this.configurationService)>=1;if(Le["enable-crash-reporter"]===void 0){const Fe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.generateUuid)()}"`,"}"],$e=Ce.substring(0,Ce.length-2).concat(`,
`,Fe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString($e))}else{const Fe=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${_e},`);Fe!==Ce&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Fe))}}catch(Ie){this.logService.error(Ie)}}};e.CodeApplication=ut,e.CodeApplication=ut=lt=Pe([te(2,H.IInstantiationService),te(3,T.ILogService),te(4,T.ILoggerService),te(5,z.IEnvironmentMainService),te(6,B.ILifecycleMainService),te(7,S.IConfigurationService),te(8,be.IStateService),te(9,V.IFileService),te(10,ae.IProductService),te(11,nt.IUserDataProfilesMainService)],ut)}),define(ie[314],ne([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,308,10,18,238,250,24,62,202,16,222,93,77,218,92,20,225,6,79,25,80,278,126,287,50,286,95,249,34,51,67,52,39,234,232,2,40,266,66,227,115,121,270,264]),function(G,e,C,L,r,A,R,I,u,a,g,w,y,h,b,p,v,m,f,d,E,c,i,o,s,t,n,l,S,D,M,P,k,O,F,z,Y,J,oe,re,ce,Q,K,V,q,N,j,H,X,se,W,_,U,B,T,$,x,ae,fe,ue,de,be,we){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.startup()}catch(pe){console.error(pe.message),C.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[pe,ve,Z,le,ge,De,Re,We]=this.createServices();try{try{await this.initServices(Z,We,le,ge,Re)}catch(Ae){throw this.handleStartupDataDirError(Z,Re,Ae),Ae}await pe.invokeFunction(async Ae=>{const He=Ae.get(J.ILogService),ze=Ae.get(z.ILifecycleMainService),ee=Ae.get(D.IFileService),he=Ae.get(J.ILoggerService),me=await this.claimInstance(He,Z,ze,pe,Re,!0);return f.Promises.writeFile(Z.mainLockfile,String(process.pid)).catch(Ee=>{He.warn(`app#startup(): Error writing main lockfile: ${Ee.stack}`)}),De.logger=he.createLogger("main",{name:(0,i.localize)(0,null)}),g.Event.once(ze.onWillShutdown)(Ee=>{ee.dispose(),le.dispose(),Ee.join("instanceLockfile",f.Promises.unlink(Z.mainLockfile).catch(()=>{}))}),pe.createInstance(c.CodeApplication,me,ve).startup()})}catch(Ae){pe.invokeFunction(this.quit,Ae)}}createServices(){const pe=new F.ServiceCollection,ve=new $.DisposableStore;process.once("exit",()=>ve.dispose());const Z={_serviceBrand:void 0,...oe.default};pe.set(re.IProductService,Z);const le=new n.EnvironmentMainService(this.resolveArgs(),Z),ge=this.patchEnvironment(le);pe.set(n.IEnvironmentMainService,le);const De=new fe.LoggerMainService((0,J.getLogLevel)(le),le.logsHome);pe.set(fe.ILoggerMainService,De);const Re=new Y.BufferLogger(De.getLogLevel()),We=ve.add(new ue.LogService(Re,[new J.ConsoleMainLogger(De.getLogLevel())]));pe.set(J.ILogService,We);const Ae=new M.FileService(We);pe.set(D.IFileService,Ae);const He=new P.DiskFileSystemProvider(We);Ae.registerProvider(y.Schemas.file,He);const ze=new ae.UriIdentityService(Ae);pe.set(x.IUriIdentityService,ze);const ee=new be.StateService(1,le,We,Ae);pe.set(X.IStateReadService,ee),pe.set(X.IStateService,ee);const he=new _.UserDataProfilesMainService(ee,ze,le,Ae,We);pe.set(_.IUserDataProfilesMainService,he),Ae.registerProvider(y.Schemas.vscodeUserData,new we.FileUserDataProvider(y.Schemas.file,He,y.Schemas.vscodeUserData,he,ze,We));const me=p.isWindows&&Z.win32RegValueName?ve.add(new B.NativePolicyService(We,Z.win32RegValueName)):le.policyFile?ve.add(new T.FilePolicyService(le.policyFile,Ae,We)):new U.NullPolicyService;pe.set(U.IPolicyService,me);const Ee=new s.ConfigurationService(he.defaultProfile.settingsResource,Ae,me,We);return pe.set(o.IConfigurationService,Ee),pe.set(z.ILifecycleMainService,new k.SyncDescriptor(z.LifecycleMainService,void 0,!1)),pe.set(q.IRequestService,new k.SyncDescriptor(N.RequestMainService,void 0,!0)),pe.set(W.IThemeMainService,new k.SyncDescriptor(W.ThemeMainService)),pe.set(j.ISignService,new k.SyncDescriptor(H.SignService,void 0,!1)),pe.set(K.ITunnelService,new k.SyncDescriptor(V.TunnelService)),pe.set(ce.IProtocolMainService,new Q.ProtocolMainService(le,he,We)),[new O.InstantiationService(pe,!0),ge,le,Ee,ee,Re,Z,he]}patchEnvironment(pe){const ve={VSCODE_IPC_HOOK:pe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Z=>{const le=process.env[Z];typeof le=="string"&&(ve[Z]=le)}),Object.assign(process.env,ve),ve}async initServices(pe,ve,Z,le,ge){await R.Promises.settled([Promise.all([pe.extensionsPath,pe.codeCachePath,pe.logsHome.with({scheme:y.Schemas.file}).fsPath,ve.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,pe.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,pe.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,pe.backupHome].map(De=>De?f.Promises.mkdir(De,{recursive:!0}):void 0)),le.init(),Z.initialize()]),ve.init()}async claimInstance(pe,ve,Z,le,ge,De){let Re;try{(0,b.mark)("code/willStartMainServer"),Re=await(0,E.serve)(ve.mainIPCHandle),(0,b.mark)("code/didStartMainServer"),g.Event.once(Z.onWillShutdown)(()=>Re.dispose())}catch(We){if(We.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ve,ge,We),We;let Ae;try{Ae=await(0,E.connect)(ve.mainIPCHandle,"main")}catch(he){if(!De||p.isWindows||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.showStartupWarningDialog((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),he;try{(0,L.unlinkSync)(ve.mainIPCHandle)}catch(me){throw pe.warn("Could not delete obsolete instance handle",me),me}return this.claimInstance(pe,ve,Z,le,ge,!1)}if(ve.extensionTestsLocationURI&&!ve.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw pe.error(he),Ae.dispose(),new Error(he)}let He;!ve.args.wait&&!ve.args.status&&(He=setTimeout(()=>{this.showStartupWarningDialog((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=d.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),ee=d.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(ve.args.status)return le.invokeFunction(async()=>{const he=new t.DiagnosticsService(se.NullTelemetryService,ge),me=await ee.getMainDiagnostics(),Ee=await ee.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Me=await he.getDiagnostics(me,Ee);throw console.log(Me),new u.ExpectedError});throw p.isWindows&&await this.windowsAllowSetForegroundWindow(ze,pe),pe.trace("Sending env to running instance..."),await ze.start(ve.args,process.env),Ae.dispose(),He&&clearTimeout(He),new u.ExpectedError("Sent env to running instance. Terminating...")}if(ve.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}handleStartupDataDirError(pe,ve,Z){if(Z.code==="EACCES"||Z.code==="EPERM"){const le=(0,A.coalesce)([pe.userDataPath,pe.extensionsPath,E.XDG_RUNTIME_DIR]).map(ge=>(0,w.getPathLabel)(r.URI.file(ge),{os:p.OS,tildify:pe}));this.showStartupWarningDialog((0,i.localize)(6,null),(0,i.localize)(7,null,(0,I.toErrorMessage)(Z),le.join(`
`)),ve)}}showStartupWarningDialog(pe,ve,Z){C.dialog.showMessageBoxSync((0,de.massageMessageBoxOptions)({type:"warning",buttons:[(0,i.localize)(8,null)],message:pe,detail:ve},Z).options)}async windowsAllowSetForegroundWindow(pe,ve){if(p.isWindows){const Z=await pe.getMainProcessId();ve.trace("Sending some foreground love to the running instance:",Z);try{(await new Promise((le,ge)=>{G(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(Z)}catch(le){ve.error(le)}}}quit(pe,ve){const Z=pe.get(J.ILogService),le=pe.get(z.ILifecycleMainService);let ge=0;ve&&(ve.isExpected?ve.message&&Z.trace(ve.message):(ge=1,ve.stack?Z.error(ve.stack):Z.error(`Startup error: ${ve.toString()}`))),le.kill(ge)}resolveArgs(){const pe=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(pe.wait&&!pe.waitMarkerFilePath){const ve=(0,S.createWaitMarkerFileSync)(pe.verbose);ve&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",ve),pe.waitMarkerFilePath=ve)}return pe}validatePaths(pe){if(pe["open-url"]&&(pe._urls=pe._,pe._=[]),!pe.remote){const ve=this.doValidatePaths(pe._,pe.goto);pe._=ve}return pe}doValidatePaths(pe,ve){const Z=(0,v.cwd)(),le=pe.map(Re=>{let We=String(Re),Ae;ve&&(Ae=(0,a.parseLineAndColumnAware)(We),We=Ae.path),We&&(We=this.preparePath(Z,We));const He=(0,a.sanitizeFilePath)(We,Z),ze=(0,h.basename)(He);return ze&&!(0,a.isValidBasename)(ze)?null:ve&&Ae?(Ae.path=He,this.toPath(Ae)):He}),ge=p.isWindows||p.isMacintosh,De=(0,A.distinct)(le,Re=>Re&&ge?Re.toLowerCase():Re||"");return(0,A.coalesce)(De)}preparePath(pe,ve){return p.isWindows&&(ve=(0,m.rtrim)(ve,'"')),ve=(0,m.trim)((0,m.trim)(ve," "),"	"),p.isWindows&&(ve=(0,h.resolve)(pe,ve),ve=(0,m.rtrim)(ve,".")),ve}toPath(pe){const ve=[pe.path];return typeof pe.line=="number"&&ve.push(String(pe.line)),typeof pe.column=="number"&&ve.push(String(pe.column)),ve.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dd29bdcb71634f9cd7c1792bb2bdfde5b18ee8e8/core/vs/code/electron-main/main.js.map
