/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],N=0,O=G.length;N<O;N++)e[N]=te[G[N]];return e};define(te[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class N{static get(){const k=new Map,A=new Map,T=new Map,w=new Map;function u(h,I){h.has(I.detail)||h.set(I.detail,-I.timestamp)}function l(h,I){const y=h.get(I.detail);y&&(y>=0||h.set(I.detail,y+I.timestamp))}let b=[];typeof G=="function"&&typeof G.getStats=="function"&&(b=G.getStats().slice(0).sort((h,I)=>h.timestamp-I.timestamp));for(const h of b)switch(h.type){case 10:u(k,h);break;case 11:case 12:l(k,h);break;case 21:u(A,h);break;case 22:l(A,h);break;case 33:u(T,h);break;case 34:l(T,h);break;case 31:u(w,h);break;case 32:l(w,h);break}let C=0;T.forEach(h=>C+=h);function g(h){const I=[];return h.forEach((y,p)=>I.push([p,y])),I}return{amdLoad:g(k),amdInvoke:g(A),nodeRequire:g(T),nodeEval:g(w),nodeRequireTotal:C}}static toMarkdownTable(k,A){let T="";const w=[];return k.forEach((u,l)=>{w[l]=u.length}),A.forEach(u=>{u.forEach((l,b)=>{typeof l>"u"&&(l=u[b]="-");const C=l.toString().length;w[b]=Math.max(C,w[b])})}),k.forEach((u,l)=>{T+=`| ${u+" ".repeat(w[l]-u.toString().length)} `}),T+=`|
`,k.forEach((u,l)=>{T+=`| ${"-".repeat(w[l])} `}),T+=`|
`,A.forEach(u=>{u.forEach((l,b)=>{typeof l<"u"&&(T+=`| ${l+" ".repeat(w[b]-l.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=N}),define(te[52],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function N(T){return(w,u,l)=>{let b=null,C=null;if(typeof l.value=="function"?(b="value",C=l.value):typeof l.get=="function"&&(b="get",C=l.get),!C)throw new Error("not supported");l[b]=T(C,u)}}function O(T,w,u){let l=null,b=null;if(typeof u.value=="function"?(l="value",b=u.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",b=u.get),!b)throw new Error("not supported");const C=`$memoize$${w}`;u[l]=function(...g){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,g)}),this[C]}}e.memoize=O;function k(T,w,u){return N((l,b)=>{const C=`$debounce$${b}`,g=`$debounce$result$${b}`;return function(...h){this[g]||(this[g]=u?u():void 0),clearTimeout(this[C]),w&&(this[g]=w(this[g],...h),h=[this[g]]),this[C]=setTimeout(()=>{l.apply(this,h),this[g]=u?u():void 0},T)}})}e.debounce=k;function A(T,w,u){return N((l,b)=>{const C=`$throttle$timer$${b}`,g=`$throttle$result$${b}`,h=`$throttle$lastRun$${b}`,I=`$throttle$pending$${b}`;return function(...y){if(this[g]||(this[g]=u?u():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),w&&(this[g]=w(this[g],...y)),this[I])return;const p=this[h]+T;p<=Date.now()?(this[h]=Date.now(),l.apply(this,[this[g]]),this[g]=u?u():void 0):(this[I]=!0,this[C]=setTimeout(()=>{this[I]=!1,this[h]=Date.now(),l.apply(this,[this[g]]),this[g]=u?u():void 0},p-Date.now()))}})}e.throttle=A}),define(te[71],ne([0,1,9]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=O;function k(u,l="Unreachable"){throw new Error(l)}e.assertNever=k;function A(u){if(!u)throw new N.BugIndicatingError("Assertion Failed")}e.assert=A;function T(u){if(!u()){debugger;u(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function w(u,l){let b=0;for(;b<u.length-1;){const C=u[b],g=u[b+1];if(!l(C,g))return!1;b++}return!0}e.checkAdjacentItems=w}),define(te[53],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var O;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(r){r.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(r,s=!1){let t=0;const i=r.length;let n="",o=0,c=16,D=0;function P(re){let ue=0,le=0;for(;ue<re;){const se=r.charCodeAt(t);if(se>=48&&se<=57)le=le*16+se-48;else if(se>=65&&se<=70)le=le*16+se-65+10;else if(se>=97&&se<=102)le=le*16+se-97+10;else break;t++,ue++}return ue<re&&(le=-1),le}function v(re){t=re,n="",o=0,c=16,D=0}function R(){const re=t;if(r.charCodeAt(t)===48)t++;else for(t++;t<r.length&&l(r.charCodeAt(t));)t++;if(t<r.length&&r.charCodeAt(t)===46)if(t++,t<r.length&&l(r.charCodeAt(t)))for(t++;t<r.length&&l(r.charCodeAt(t));)t++;else return D=3,r.substring(re,t);let ue=t;if(t<r.length&&(r.charCodeAt(t)===69||r.charCodeAt(t)===101))if(t++,(t<r.length&&r.charCodeAt(t)===43||r.charCodeAt(t)===45)&&t++,t<r.length&&l(r.charCodeAt(t))){for(t++;t<r.length&&l(r.charCodeAt(t));)t++;ue=t}else D=3;return r.substring(re,ue)}function z(){let re="",ue=t;for(;;){if(t>=i){re+=r.substring(ue,t),D=2;break}const le=r.charCodeAt(t);if(le===34){re+=r.substring(ue,t),t++;break}if(le===92){if(re+=r.substring(ue,t),t++,t>=i){D=2;break}switch(r.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const W=P(4);W>=0?re+=String.fromCharCode(W):D=4;break}default:D=5}ue=t;continue}if(le>=0&&le<=31)if(u(le)){re+=r.substring(ue,t),D=2;break}else D=6;t++}return re}function Z(){if(n="",D=0,o=t,t>=i)return o=i,c=17;let re=r.charCodeAt(t);if(w(re)){do t++,n+=String.fromCharCode(re),re=r.charCodeAt(t);while(w(re));return c=15}if(u(re))return t++,n+=String.fromCharCode(re),re===13&&r.charCodeAt(t)===10&&(t++,n+=`
`),c=14;switch(re){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,n=z(),c=10;case 47:{const ue=t-1;if(r.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(r.charCodeAt(t));)t++;return n=r.substring(ue,t),c=12}if(r.charCodeAt(t+1)===42){t+=2;const le=i-1;let se=!1;for(;t<le;){if(r.charCodeAt(t)===42&&r.charCodeAt(t+1)===47){t+=2,se=!0;break}t++}return se||(t++,D=1),n=r.substring(ue,t),c=13}return n+=String.fromCharCode(re),t++,c=16}case 45:if(n+=String.fromCharCode(re),t++,t===i||!l(r.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),c=11;default:for(;t<i&&ee(re);)t++,re=r.charCodeAt(t);if(o!==t){switch(n=r.substring(o,t),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(re),t++,c=16}}function ee(re){if(w(re)||u(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=Z();while(re>=12&&re<=15);return re}return{setPosition:v,getPosition:()=>t,scan:s?oe:Z,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>D}}e.createScanner=T;function w(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function u(r){return r===10||r===13||r===8232||r===8233}function l(r){return r>=48&&r<=57}var b;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(b||(b={}));function C(r,s){const t=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function D(P,v,R,z){o.value=P,o.offset=v,o.length=R,o.type=z,o.colonOffset=void 0,n=o}try{L(r,{onObjectBegin:(P,v)=>{if(s<=P)throw i;n=void 0,c=s>P,t.push("")},onObjectProperty:(P,v,R)=>{if(s<v||(D(P,v,R,"property"),t[t.length-1]=P,s<=v+R))throw i},onObjectEnd:(P,v)=>{if(s<=P)throw i;n=void 0,t.pop()},onArrayBegin:(P,v)=>{if(s<=P)throw i;n=void 0,t.push(0)},onArrayEnd:(P,v)=>{if(s<=P)throw i;n=void 0,t.pop()},onLiteralValue:(P,v,R)=>{if(s<v||(D(P,v,R,S(P)),s<=v+R))throw i},onSeparator:(P,v,R)=>{if(s<=v)throw i;if(P===":"&&n&&n.type==="property")n.colonOffset=v,c=!1,n=void 0;else if(P===","){const z=t[t.length-1];typeof z=="number"?t[t.length-1]=z+1:(c=!0,t[t.length-1]=""),n=void 0}}})}catch(P){if(P!==i)throw P}return{path:t,previousNode:n,isAtPropertyKey:c,matches:P=>{let v=0;for(let R=0;v<P.length&&R<t.length;R++)if(P[v]===t[R]||P[v]==="*")v++;else if(P[v]!=="**")return!1;return v===P.length}}}e.getLocation=C;function g(r,s=[],t=A.DEFAULT){let i=null,n=[];const o=[];function c(P){Array.isArray(n)?n.push(P):i!==null&&(n[i]=P)}return L(r,{onObjectBegin:()=>{const P={};c(P),o.push(n),n=P,i=null},onObjectProperty:P=>{i=P},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const P=[];c(P),o.push(n),n=P,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:c,onError:(P,v,R)=>{s.push({error:P,offset:v,length:R})}},t),n[0]}e.parse=g;function h(r,s=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(P){i.type==="property"&&(i.length=P-i.offset,i=i.parent)}function o(P){return i.children.push(P),P}L(r,{onObjectBegin:P=>{i=o({type:"object",offset:P,length:-1,parent:i,children:[]})},onObjectProperty:(P,v,R)=>{i=o({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:P,offset:v,length:R,parent:i})},onObjectEnd:(P,v)=>{i.length=P+v-i.offset,i=i.parent,n(P+v)},onArrayBegin:(P,v)=>{i=o({type:"array",offset:P,length:-1,parent:i,children:[]})},onArrayEnd:(P,v)=>{i.length=P+v-i.offset,i=i.parent,n(P+v)},onLiteralValue:(P,v,R)=>{o({type:S(P),offset:v,length:R,parent:i,value:P}),n(v+R)},onSeparator:(P,v,R)=>{i.type==="property"&&(P===":"?i.colonOffset=v:P===","&&n(v))},onError:(P,v,R)=>{s.push({error:P,offset:v,length:R})}},t);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=h;function I(r,s){if(!r)return;let t=r;for(const i of s)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.findNodeAtLocation=I;function y(r){if(!r.parent||!r.parent.children)return[];const s=y(r.parent);if(r.parent.type==="property"){const t=r.parent.children[0].value;s.push(t)}else if(r.parent.type==="array"){const t=r.parent.children.indexOf(r);t!==-1&&s.push(t)}return s}e.getNodePath=y;function p(r){switch(r.type){case"array":return r.children.map(p);case"object":{const s=Object.create(null);for(const t of r.children){const i=t.children[1];i&&(s[t.children[0].value]=p(i))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=p;function f(r,s,t=!1){return s>=r.offset&&s<r.offset+r.length||t&&s===r.offset+r.length}e.contains=f;function E(r,s,t=!1){if(f(r,s,t)){const i=r.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const o=E(i[n],s,t);if(o)return o}return r}}e.findNodeAtOffset=E;function L(r,s,t=A.DEFAULT){const i=T(r,!1);function n(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(X){return X?J=>X(J,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=n(s.onObjectBegin),D=o(s.onObjectProperty),P=n(s.onObjectEnd),v=n(s.onArrayBegin),R=n(s.onArrayEnd),z=o(s.onLiteralValue),Z=o(s.onSeparator),ee=n(s.onComment),oe=o(s.onError),re=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function le(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:re||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(X){case 12:case 13:re?se(10):ee();break;case 16:se(1);break;case 15:case 14:break;default:return X}}}function se(X,J=[],M=[]){if(oe(X),J.length+M.length>0){let F=i.getToken();for(;F!==17;){if(J.indexOf(F)!==-1){le();break}else if(M.indexOf(F)!==-1)break;F=le()}}}function W(X){const J=i.getTokenValue();return X?z(J):D(J),le(),!0}function K(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(se(2),X=0)}catch{se(2)}z(X);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return le(),!0}function V(){return i.getToken()!==10?(se(3,[],[2,5]),!1):(W(!1),i.getToken()===6?(Z(":"),le(),B()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function _(){c(),le();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||se(4,[],[]),Z(","),le(),i.getToken()===2&&ue)break}else X&&se(6,[],[]);V()||se(4,[],[2,5]),X=!0}return P(),i.getToken()!==2?se(7,[2],[]):le(),!0}function $(){v(),le();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||se(4,[],[]),Z(","),le(),i.getToken()===4&&ue)break}else X&&se(6,[],[]);B()||se(4,[],[4,5]),X=!0}return R(),i.getToken()!==4?se(8,[4],[]):le(),!0}function B(){switch(i.getToken()){case 3:return $();case 1:return _();case 10:return W(!0);default:return K()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(se(4,[],[]),!1):B()?(i.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=L;function d(r,s){const t=T(r),i=[];let n,o=0,c;do switch(c=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:o!==c&&i.push(r.substring(o,c)),s!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,s)),o=t.getPosition();break}while(n!==17);return i.join("")}e.stripComments=d;function S(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),define(te[72],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function N(w,u,l){return Math.min(Math.max(w,u),l)}e.clamp=N;function O(w,u){return(u+w%u)%u}e.rot=O;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class A{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const l=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function G(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function T(u){A.push(u,Date.now())}function w(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:T,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(k+T.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function N(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=N(O))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var O in N)(typeof exports=="object"?exports:G)[O]=N[O]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function N(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return G[O].call(k.exports,k,k.exports,N),k.l=!0,k.exports}return N.m=G,N.c=e,N.d=function(O,k,A){N.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:A})},N.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},N.t=function(O,k){if(1&k&&(O=N(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(N.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var T in O)N.d(A,T,function(w){return O[w]}.bind(null,T));return A},N.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return N.d(k,"a",k),k},N.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},N.p="",N(N.s=0)}([function(G,e,N){(function(O){var k;e=G.exports=M,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],u=e.src=[],l=0,b=l++;u[b]="0|[1-9]\\d*";var C=l++;u[C]="[0-9]+";var g=l++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=l++;u[h]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var I=l++;u[I]="("+u[C]+")\\.("+u[C]+")\\.("+u[C]+")";var y=l++;u[y]="(?:"+u[b]+"|"+u[g]+")";var p=l++;u[p]="(?:"+u[C]+"|"+u[g]+")";var f=l++;u[f]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var E=l++;u[E]="(?:-?("+u[p]+"(?:\\."+u[p]+")*))";var L=l++;u[L]="[0-9A-Za-z-]+";var d=l++;u[d]="(?:\\+("+u[L]+"(?:\\."+u[L]+")*))";var S=l++,r="v?"+u[h]+u[f]+"?"+u[d]+"?";u[S]="^"+r+"$";var s="[v=\\s]*"+u[I]+u[E]+"?"+u[d]+"?",t=l++;u[t]="^"+s+"$";var i=l++;u[i]="((?:<|>)?=?)";var n=l++;u[n]=u[C]+"|x|X|\\*";var o=l++;u[o]=u[b]+"|x|X|\\*";var c=l++;u[c]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[f]+")?"+u[d]+"?)?)?";var D=l++;u[D]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[E]+")?"+u[d]+"?)?)?";var P=l++;u[P]="^"+u[i]+"\\s*"+u[c]+"$";var v=l++;u[v]="^"+u[i]+"\\s*"+u[D]+"$";var R=l++;u[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=l++;u[z]="(?:~>?)";var Z=l++;u[Z]="(\\s*)"+u[z]+"\\s+",w[Z]=new RegExp(u[Z],"g");var ee=l++;u[ee]="^"+u[z]+u[c]+"$";var oe=l++;u[oe]="^"+u[z]+u[D]+"$";var re=l++;u[re]="(?:\\^)";var ue=l++;u[ue]="(\\s*)"+u[re]+"\\s+",w[ue]=new RegExp(u[ue],"g");var le=l++;u[le]="^"+u[re]+u[c]+"$";var se=l++;u[se]="^"+u[re]+u[D]+"$";var W=l++;u[W]="^"+u[i]+"\\s*("+s+")$|^$";var K=l++;u[K]="^"+u[i]+"\\s*("+r+")$|^$";var V=l++;u[V]="(\\s*)"+u[i]+"\\s*("+s+"|"+u[c]+")",w[V]=new RegExp(u[V],"g");var _=l++;u[_]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var $=l++;u[$]="^\\s*("+u[D]+")\\s+-\\s+("+u[D]+")\\s*$";var B=l++;u[B]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)k(X,u[X]),w[X]||(w[X]=new RegExp(u[X]));function J(j,Y){if(j instanceof M)return j;if(typeof j!="string"||j.length>A||!(Y?w[t]:w[S]).test(j))return null;try{return new M(j,Y)}catch{return null}}function M(j,Y){if(j instanceof M){if(j.loose===Y)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof M))return new M(j,Y);k("SemVer",j,Y),this.loose=Y;var Q=j.trim().match(Y?w[t]:w[S]);if(!Q)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ye=+pe;if(ye>=0&&ye<T)return ye}return pe}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=J,e.valid=function(j,Y){var Q=J(j,Y);return Q?Q.version:null},e.clean=function(j,Y){var Q=J(j.trim().replace(/^[=v]+/,""),Y);return Q?Q.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(j){return k("SemVer.compare",this.version,this.loose,j),j instanceof M||(j=new M(j,this.loose)),this.compareMain(j)||this.comparePre(j)},M.prototype.compareMain=function(j){return j instanceof M||(j=new M(j,this.loose)),a(this.major,j.major)||a(this.minor,j.minor)||a(this.patch,j.patch)},M.prototype.comparePre=function(j){if(j instanceof M||(j=new M(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Y=0;do{var Q=this.prerelease[Y],pe=j.prerelease[Y];if(k("prerelease compare",Y,Q,pe),Q===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(Q===void 0)return-1;if(Q!==pe)return a(Q,pe)}while(++Y)},M.prototype.inc=function(j,Y){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Y,Q,pe){typeof Q=="string"&&(pe=Q,Q=void 0);try{return new M(j,Q).inc(Y,pe).version}catch{return null}},e.diff=function(j,Y){if(H(j,Y))return null;var Q=J(j),pe=J(Y);if(Q.prerelease.length||pe.prerelease.length){for(var ye in Q)if((ye==="major"||ye==="minor"||ye==="patch")&&Q[ye]!==pe[ye])return"pre"+ye;return"prerelease"}for(var ye in Q)if((ye==="major"||ye==="minor"||ye==="patch")&&Q[ye]!==pe[ye])return ye},e.compareIdentifiers=a;var F=/^[0-9]+$/;function a(j,Y){var Q=F.test(j),pe=F.test(Y);return Q&&pe&&(j=+j,Y=+Y),Q&&!pe?-1:pe&&!Q?1:j<Y?-1:j>Y?1:0}function m(j,Y,Q){return new M(j,Q).compare(new M(Y,Q))}function x(j,Y,Q){return m(j,Y,Q)>0}function U(j,Y,Q){return m(j,Y,Q)<0}function H(j,Y,Q){return m(j,Y,Q)===0}function q(j,Y,Q){return m(j,Y,Q)!==0}function ce(j,Y,Q){return m(j,Y,Q)>=0}function ae(j,Y,Q){return m(j,Y,Q)<=0}function me(j,Y,Q,pe){var ye;switch(Y){case"===":typeof j=="object"&&(j=j.version),typeof Q=="object"&&(Q=Q.version),ye=j===Q;break;case"!==":typeof j=="object"&&(j=j.version),typeof Q=="object"&&(Q=Q.version),ye=j!==Q;break;case"":case"=":case"==":ye=H(j,Q,pe);break;case"!=":ye=q(j,Q,pe);break;case">":ye=x(j,Q,pe);break;case">=":ye=ce(j,Q,pe);break;case"<":ye=U(j,Q,pe);break;case"<=":ye=ae(j,Q,pe);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(j,Y){if(j instanceof de){if(j.loose===Y)return j;j=j.value}if(!(this instanceof de))return new de(j,Y);k("comparator",j,Y),this.loose=Y,this.parse(j),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(j,Y){return a(Y,j)},e.major=function(j,Y){return new M(j,Y).major},e.minor=function(j,Y){return new M(j,Y).minor},e.patch=function(j,Y){return new M(j,Y).patch},e.compare=m,e.compareLoose=function(j,Y){return m(j,Y,!0)},e.rcompare=function(j,Y,Q){return m(Y,j,Q)},e.sort=function(j,Y){return j.sort(function(Q,pe){return e.compare(Q,pe,Y)})},e.rsort=function(j,Y){return j.sort(function(Q,pe){return e.rcompare(Q,pe,Y)})},e.gt=x,e.lt=U,e.eq=H,e.neq=q,e.gte=ce,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function he(j,Y){if(j instanceof he)return j.loose===Y?j:new he(j.raw,Y);if(j instanceof de)return new he(j.value,Y);if(!(this instanceof he))return new he(j,Y);if(this.loose=Y,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function fe(j){return!j||j.toLowerCase()==="x"||j==="*"}function Se(j,Y,Q,pe,ye,Le,Ie,Ne,Ce,Te,_e,Re,Oe){return((Y=fe(Q)?"":fe(pe)?">="+Q+".0.0":fe(ye)?">="+Q+"."+pe+".0":">="+Y)+" "+(Ne=fe(Ce)?"":fe(Te)?"<"+(+Ce+1)+".0.0":fe(_e)?"<"+Ce+"."+(+Te+1)+".0":Re?"<="+Ce+"."+Te+"."+_e+"-"+Re:"<="+Ne)).trim()}function we(j,Y){for(var Q=0;Q<j.length;Q++)if(!j[Q].test(Y))return!1;if(Y.prerelease.length){for(Q=0;Q<j.length;Q++)if(k(j[Q].semver),j[Q].semver!==ge&&j[Q].semver.prerelease.length>0){var pe=j[Q].semver;if(pe.major===Y.major&&pe.minor===Y.minor&&pe.patch===Y.patch)return!0}return!1}return!0}function be(j,Y,Q){try{Y=new he(Y,Q)}catch{return!1}return Y.test(j)}function Me(j,Y,Q,pe){var ye,Le,Ie,Ne,Ce;switch(j=new M(j,pe),Y=new he(Y,pe),Q){case">":ye=x,Le=ae,Ie=U,Ne=">",Ce=">=";break;case"<":ye=U,Le=ce,Ie=x,Ne="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(j,Y,pe))return!1;for(var Te=0;Te<Y.set.length;++Te){var _e=Y.set[Te],Re=null,Oe=null;if(_e.forEach(function(xe){xe.semver===ge&&(xe=new de(">=0.0.0")),Re=Re||xe,Oe=Oe||xe,ye(xe.semver,Re.semver,pe)?Re=xe:Ie(xe.semver,Oe.semver,pe)&&(Oe=xe)}),Re.operator===Ne||Re.operator===Ce||(!Oe.operator||Oe.operator===Ne)&&Le(j,Oe.semver)||Oe.operator===Ce&&Ie(j,Oe.semver))return!1}return!0}de.prototype.parse=function(j){var Y=this.loose?w[W]:w[K],Q=j.match(Y);if(!Q)throw new TypeError("Invalid comparator: "+j);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new M(Q[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(j){return k("Comparator.test",j,this.loose),this.semver===ge||(typeof j=="string"&&(j=new M(j,this.loose)),me(j,this.operator,this.semver,this.loose))},de.prototype.intersects=function(j,Y){if(!(j instanceof de))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new he(j.value,Y),be(this.value,Q,Y);if(j.operator==="")return Q=new he(this.value,Y),be(j.semver,Q,Y);var pe=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Le=this.semver.version===j.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ne=me(this.semver,"<",j.semver,Y)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),Ce=me(this.semver,">",j.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return pe||ye||Le&&Ie||Ne||Ce},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(j){var Y=this.loose;j=j.trim(),k("range",j,Y);var Q=Y?w[$]:w[_];j=j.replace(Q,Se),k("hyphen replace",j),j=j.replace(w[V],"$1$2$3"),k("comparator trim",j,w[V]),j=(j=(j=j.replace(w[Z],"$1~")).replace(w[ue],"$1^")).split(/\s+/).join(" ");var pe=Y?w[W]:w[K],ye=j.split(" ").map(function(Le){return function(Ie,Ne){return k("comp",Ie),Ie=function(Ce,Te){return Ce.trim().split(/\s+/).map(function(_e){return function(Re,Oe){k("caret",Re,Oe);var xe=Oe?w[se]:w[le];return Re.replace(xe,function(Ae,Ee,Pe,De,ke){var Fe;return k("caret",Re,Ae,Ee,Pe,De,ke),fe(Ee)?Fe="":fe(Pe)?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(De)?Fe=Ee==="0"?">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+".0 <"+(+Ee+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Fe=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+Pe+"."+(+De+1):">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+De+ke+" <"+(+Ee+1)+".0.0"):(k("no pr"),Fe=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+Pe+"."+(+De+1):">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+De+" <"+(+Ee+1)+".0.0"),k("caret return",Fe),Fe})}(_e,Te)}).join(" ")}(Ie,Ne),k("caret",Ie),Ie=function(Ce,Te){return Ce.trim().split(/\s+/).map(function(_e){return function(Re,Oe){var xe=Oe?w[oe]:w[ee];return Re.replace(xe,function(Ae,Ee,Pe,De,ke){var Fe;return k("tilde",Re,Ae,Ee,Pe,De,ke),fe(Ee)?Fe="":fe(Pe)?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(De)?Fe=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Fe=">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+(+Pe+1)+".0"):Fe=">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+(+Pe+1)+".0",k("tilde return",Fe),Fe})}(_e,Te)}).join(" ")}(Ie,Ne),k("tildes",Ie),Ie=function(Ce,Te){return k("replaceXRanges",Ce,Te),Ce.split(/\s+/).map(function(_e){return function(Re,Oe){Re=Re.trim();var xe=Oe?w[v]:w[P];return Re.replace(xe,function(Ae,Ee,Pe,De,ke,Fe){k("xRange",Re,Ae,Ee,Pe,De,ke,Fe);var We=fe(Pe),Ue=We||fe(De),Ve=Ue||fe(ke);return Ee==="="&&Ve&&(Ee=""),We?Ae=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(Ue&&(De=0),Ve&&(ke=0),Ee===">"?(Ee=">=",Ue?(Pe=+Pe+1,De=0,ke=0):Ve&&(De=+De+1,ke=0)):Ee==="<="&&(Ee="<",Ue?Pe=+Pe+1:De=+De+1),Ae=Ee+Pe+"."+De+"."+ke):Ue?Ae=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ve&&(Ae=">="+Pe+"."+De+".0 <"+Pe+"."+(+De+1)+".0"),k("xRange return",Ae),Ae})}(_e,Te)}).join(" ")}(Ie,Ne),k("xrange",Ie),Ie=function(Ce,Te){return k("replaceStars",Ce,Te),Ce.trim().replace(w[B],"")}(Ie,Ne),k("stars",Ie),Ie}(Le,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Le){return!!Le.match(pe)})),ye=ye.map(function(Le){return new de(Le,Y)})},he.prototype.intersects=function(j,Y){if(!(j instanceof he))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(pe){return j.set.some(function(ye){return ye.every(function(Le){return pe.intersects(Le,Y)})})})})},e.toComparators=function(j,Y){return new he(j,Y).set.map(function(Q){return Q.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},he.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new M(j,this.loose));for(var Y=0;Y<this.set.length;Y++)if(we(this.set[Y],j))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(j,Y,Q){var pe=null,ye=null;try{var Le=new he(Y,Q)}catch{return null}return j.forEach(function(Ie){Le.test(Ie)&&(pe&&ye.compare(Ie)!==-1||(ye=new M(pe=Ie,Q)))}),pe},e.minSatisfying=function(j,Y,Q){var pe=null,ye=null;try{var Le=new he(Y,Q)}catch{return null}return j.forEach(function(Ie){Le.test(Ie)&&(pe&&ye.compare(Ie)!==1||(ye=new M(pe=Ie,Q)))}),pe},e.validRange=function(j,Y){try{return new he(j,Y).range||"*"}catch{return null}},e.ltr=function(j,Y,Q){return Me(j,Y,"<",Q)},e.gtr=function(j,Y,Q){return Me(j,Y,">",Q)},e.outside=Me,e.prerelease=function(j,Y){var Q=J(j,Y);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(j,Y,Q){return j=new he(j,Q),Y=new he(Y,Q),j.intersects(Y)},e.coerce=function(j){if(j instanceof M)return j;if(typeof j!="string")return null;var Y=j.match(w[R]);return Y==null?null:J((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,N(1))},function(G,e){var N,O,k=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function w(p){if(N===setTimeout)return setTimeout(p,0);if((N===A||!N)&&setTimeout)return N=setTimeout,setTimeout(p,0);try{return N(p,0)}catch{try{return N.call(null,p,0)}catch{return N.call(this,p,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:A}catch{N=A}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var u,l=[],b=!1,C=-1;function g(){b&&u&&(b=!1,u.length?l=u.concat(l):C=-1,l.length&&h())}function h(){if(!b){var p=w(g);b=!0;for(var f=l.length;f;){for(u=l,l=[];++C<f;)u&&u[C].run();C=-1,f=l.length}u=null,b=!1,function(E){if(O===clearTimeout)return clearTimeout(E);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(E);try{O(E)}catch{try{return O.call(null,E)}catch{return O.call(this,E)}}}(p)}}function I(p,f){this.fun=p,this.array=f}function y(){}k.nextTick=function(p){var f=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)f[E-1]=arguments[E];l.push(new I(p,f)),l.length!==1||b||w(h)},I.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(p){return[]},k.binding=function(p){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(p){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(G,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(w,u,l){this.level=w,this.key=u,this.value=l,this.forward=[]}}const k=void 0;class A{constructor(w,u=2**16){this.comparator=w,this[N]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new O(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,k,k),this._size=0}has(w){return!!A._search(this,w,this.comparator)}get(w){return A._search(this,w,this.comparator)?.value}set(w,u){return A._insert(this,w,u,this.comparator)&&(this._size+=1),this}delete(w){const u=A._delete(this,w,this.comparator);return u&&(this._size-=1),u}forEach(w,u){let l=this._header.forward[0];for(;l;)w.call(u,l.value,l.key,this),l=l.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",u=this._header.forward[0];for(;u;)w+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return w}static _search(w,u,l){let b=w._header;for(let C=w._level-1;C>=0;C--)for(;b.forward[C]&&l(b.forward[C].key,u)<0;)b=b.forward[C];if(b=b.forward[0],b&&l(b.key,u)===0)return b}static _insert(w,u,l,b){const C=[];let g=w._header;for(let h=w._level-1;h>=0;h--){for(;g.forward[h]&&b(g.forward[h].key,u)<0;)g=g.forward[h];C[h]=g}if(g=g.forward[0],g&&b(g.key,u)===0)return g.value=l,!1;{const h=A._randomLevel(w);if(h>w._level){for(let I=w._level;I<h;I++)C[I]=w._header;w._level=h}g=new O(h,u,l);for(let I=0;I<h;I++)g.forward[I]=C[I].forward[I],C[I].forward[I]=g;return!0}}static _randomLevel(w,u=.5){let l=1;for(;Math.random()<u&&l<w._maxLevel;)l+=1;return l}static _delete(w,u,l){const b=[];let C=w._header;for(let g=w._level-1;g>=0;g--){for(;C.forward[g]&&l(C.forward[g].key,u)<0;)C=C.forward[g];b[g]=C}if(C=C.forward[0],!C||l(C.key,u)!==0)return!1;for(let g=0;g<w._level&&b[g].forward[g]===C;g++)b[g].forward[g]=C.forward[g];for(;w._level>0&&w._header.forward[w._level-1]===k;)w._level-=1;return!0}}e.SkipList=A}),define(te[45],ne([0,1,9,2]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(d){const S=d;return S?typeof S.read=="function":!1}e.isReadable=k;function A(d){const S=d;return S?[S.on,S.pause,S.resume,S.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=A;function T(d){const S=d;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=T;function w(d,S){return new u(d,S)}e.newWriteableStream=w;class u{constructor(S,r){this.reducer=S,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S<"u"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(r=>r(S))}emitError(S){this.listeners.error.length===0?(0,N.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(r=>r(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,r){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(S,r){if(this.state.destroyed)return;let s;switch(S){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(r);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(d,S){const r=[];let s;for(;(s=d.read())!==null;)r.push(s);return S(r)}e.consumeReadable=l;function b(d,S,r){const s=[];let t;for(;(t=d.read())!==null&&s.length<r;)s.push(t);return t===null&&s.length>0?S(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return d.read()}}}e.peekReadable=b;function C(d,S){return new Promise((r,s)=>{const t=[];g(d,{onData:i=>{S&&t.push(i)},onError:i=>{S?s(i):r(void 0)},onEnd:()=>{r(S?S(t):void 0)}})})}e.consumeStream=C;function g(d,S,r){d.on("error",s=>{r?.isCancellationRequested||S.onError(s)}),d.on("end",()=>{r?.isCancellationRequested||S.onEnd()}),d.on("data",s=>{r?.isCancellationRequested||S.onData(s)})}e.listenStream=g;function h(d,S){return new Promise((r,s)=>{const t=new O.DisposableStore,i=[],n=D=>{if(i.push(D),i.length>S)return t.dispose(),d.pause(),r({stream:d,buffer:i,ended:!1})},o=D=>(t.dispose(),s(D)),c=()=>(t.dispose(),r({stream:d,buffer:i,ended:!0}));t.add((0,O.toDisposable)(()=>d.removeListener("error",o))),d.on("error",o),t.add((0,O.toDisposable)(()=>d.removeListener("end",c))),d.on("end",c),t.add((0,O.toDisposable)(()=>d.removeListener("data",n))),d.on("data",n)})}e.peekStream=h;function I(d,S){const r=w(S);return r.end(d),r}e.toStream=I;function y(){const d=w(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=y;function p(d){let S=!1;return{read:()=>S?null:(S=!0,d)}}e.toReadable=p;function f(d,S,r){const s=w(r);return g(d,{onData:t=>s.write(S.data(t)),onError:t=>s.error(S.error?S.error(t):t),onEnd:()=>s.end()}),s}e.transform=f;function E(d,S,r){let s=!1;return{read:()=>{const t=S.read();return s?t:(s=!0,t!==null?r([d,t]):d)}}}e.prefixedReadable=E;function L(d,S,r){let s=!1;const t=w(r);return g(S,{onData:i=>s?t.write(i):(s=!0,t.write(r([d,i]))),onError:i=>t.error(i),onEnd:()=>{s||(s=!0,t.write(d)),t.end()}}),t}e.prefixedStream=L}),define(te[14],ne([0,1,164,45]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",A=new N.Lazy(()=>new Uint8Array(256));let T,w;class u{static alloc(R){return k?new u(Buffer.allocUnsafe(R)):new u(new Uint8Array(R))}static wrap(R){return k&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new u(R)}static fromString(R,z){return!(z?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(R)):(T||(T=new TextEncoder),new u(T.encode(R)))}static fromByteArray(R){const z=u.alloc(R.length);for(let Z=0,ee=R.length;Z<ee;Z++)z.buffer[Z]=R[Z];return z}static concat(R,z){if(typeof z>"u"){z=0;for(let oe=0,re=R.length;oe<re;oe++)z+=R[oe].byteLength}const Z=u.alloc(z);let ee=0;for(let oe=0,re=R.length;oe<re;oe++){const ue=R[oe];Z.set(ue,ee),ee+=ue.byteLength}return Z}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=u.alloc(this.byteLength);return R.set(this),R}toString(){return k?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(R,z){return new u(this.buffer.subarray(R,z))}set(R,z){if(R instanceof u)this.buffer.set(R.buffer,z);else if(R instanceof Uint8Array)this.buffer.set(R,z);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),z);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return g(this.buffer,R)}writeUInt32BE(R,z){h(this.buffer,R,z)}readUInt32LE(R){return I(this.buffer,R)}writeUInt32LE(R,z){y(this.buffer,R,z)}readUInt8(R){return p(this.buffer,R)}writeUInt8(R,z){f(this.buffer,R,z)}indexOf(R,z=0){return l(this.buffer,R instanceof u?R.buffer:R,z)}}e.VSBuffer=u;function l(v,R,z=0){const Z=R.byteLength,ee=v.byteLength;if(Z===0)return 0;if(Z===1)return v.indexOf(R[0]);if(Z>ee-z)return-1;const oe=A.value;oe.fill(R.length);for(let se=0;se<R.length;se++)oe[R[se]]=R.length-se-1;let re=z+R.length-1,ue=re,le=-1;for(;re<ee;)if(v[re]===R[ue]){if(ue===0){le=re;break}re--,ue--}else re+=Math.max(R.length-ue,oe[v[re]]),ue=R.length-1;return le}e.binaryIndexOf=l;function b(v,R){return v[R+0]<<0>>>0|v[R+1]<<8>>>0}e.readUInt16LE=b;function C(v,R,z){v[z+0]=R&255,R=R>>>8,v[z+1]=R&255}e.writeUInt16LE=C;function g(v,R){return v[R]*2**24+v[R+1]*2**16+v[R+2]*2**8+v[R+3]}e.readUInt32BE=g;function h(v,R,z){v[z+3]=R,R=R>>>8,v[z+2]=R,R=R>>>8,v[z+1]=R,R=R>>>8,v[z]=R}e.writeUInt32BE=h;function I(v,R){return v[R+0]<<0>>>0|v[R+1]<<8>>>0|v[R+2]<<16>>>0|v[R+3]<<24>>>0}e.readUInt32LE=I;function y(v,R,z){v[z+0]=R&255,R=R>>>8,v[z+1]=R&255,R=R>>>8,v[z+2]=R&255,R=R>>>8,v[z+3]=R&255}e.writeUInt32LE=y;function p(v,R){return v[R]}e.readUInt8=p;function f(v,R,z){v[z]=R}e.writeUInt8=f;function E(v){return O.consumeReadable(v,R=>u.concat(R))}e.readableToBuffer=E;function L(v){return O.toReadable(v)}e.bufferToReadable=L;function d(v){return O.consumeStream(v,R=>u.concat(R))}e.streamToBuffer=d;async function S(v){return v.ended?u.concat(v.buffer):u.concat([...v.buffer,await d(v.stream)])}e.bufferedStreamToBuffer=S;function r(v){return O.toStream(v,R=>u.concat(R))}e.bufferToStream=r;function s(v){return O.transform(v,{data:R=>typeof R=="string"?u.fromString(R):u.wrap(R)},R=>u.concat(R))}e.streamToBufferReadableStream=s;function t(v){return O.newWriteableStream(R=>u.concat(R),v)}e.newWriteableBufferStream=t;function i(v,R){return O.prefixedReadable(v,R,z=>u.concat(z))}e.prefixedBufferReadable=i;function n(v,R){return O.prefixedStream(v,R,z=>u.concat(z))}e.prefixedBufferStream=n;function o(v){let R=0,z=0,Z=0;const ee=new Uint8Array(Math.floor(v.length/4*3)),oe=ue=>{switch(z){case 3:ee[Z++]=R|ue,z=0;break;case 2:ee[Z++]=R|ue>>>2,R=ue<<6,z=3;break;case 1:ee[Z++]=R|ue>>>4,R=ue<<4,z=2;break;default:R=ue<<2,z=1}};for(let ue=0;ue<v.length;ue++){const le=v.charCodeAt(ue);if(le>=65&&le<=90)oe(le-65);else if(le>=97&&le<=122)oe(le-97+26);else if(le>=48&&le<=57)oe(le-48+52);else if(le===43||le===45)oe(62);else if(le===47||le===95)oe(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${v[ue]}`)}}const re=Z;for(;z>0;)oe(0);return u.wrap(ee).slice(0,re)}e.decodeBase64=o;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:v},R=!0,z=!1){const Z=z?D:c;let ee="";const oe=v.byteLength%3;let re=0;for(;re<v.byteLength-oe;re+=3){const ue=v[re+0],le=v[re+1],se=v[re+2];ee+=Z[ue>>>2],ee+=Z[(ue<<4|le>>>4)&63],ee+=Z[(le<<2|se>>>6)&63],ee+=Z[se&63]}if(oe===1){const ue=v[re+0];ee+=Z[ue>>>2],ee+=Z[ue<<4&63],R&&(ee+="==")}else if(oe===2){const ue=v[re+0],le=v[re+1];ee+=Z[ue>>>2],ee+=Z[(ue<<4|le>>>4)&63],ee+=Z[le<<2&63],R&&(ee+="=")}return ee}e.encodeBase64=P}),define(te[41],ne([0,1,29]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(f){return k(f,0)}e.hash=O;function k(f,E){switch(typeof f){case"object":return f===null?A(349,E):Array.isArray(f)?u(f,E):l(f,E);case"string":return w(f,E);case"boolean":return T(f,E);case"number":return A(f,E);case"undefined":return A(937,E);default:return A(617,E)}}e.doHash=k;function A(f,E){return(E<<5)-E+f|0}e.numberHash=A;function T(f,E){return A(f?433:863,E)}function w(f,E){E=A(149417,E);for(let L=0,d=f.length;L<d;L++)E=A(f.charCodeAt(L),E);return E}e.stringHash=w;function u(f,E){return E=A(104579,E),f.reduce((L,d)=>k(d,L),E)}function l(f,E){return E=A(181387,E),Object.keys(f).sort().reduce((L,d)=>(L=w(d,L),k(f[d],L)),E)}class b{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=k(E,this._value),this._value}}e.Hasher=b;var C;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function g(f,E,L=32){const d=L-E,S=~((1<<d)-1);return(f<<E|(S&f)>>>d)>>>0}function h(f,E=0,L=f.byteLength,d=0){for(let S=0;S<L;S++)f[E+S]=d}function I(f,E,L="0"){for(;f.length<E;)f=L+f;return f}function y(f,E=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(L=>L.toString(16).padStart(2,"0")).join(""):I((f>>>0).toString(16),E/4)}e.toHexString=y;class p{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const L=E.length;if(L===0)return;const d=this._buff;let S=this._buffLen,r=this._leftoverHighSurrogate,s,t;for(r!==0?(s=r,t=-1,r=0):(s=E.charCodeAt(0),t=0);;){let i=s;if(N.isHighSurrogate(s))if(t+1<L){const n=E.charCodeAt(t+1);N.isLowSurrogate(n)?(t++,i=N.computeCodePoint(s,n)):i=65533}else{r=s;break}else N.isLowSurrogate(s)&&(i=65533);if(S=this._push(d,S,i),t++,t<L)s=E.charCodeAt(t);else break}this._buffLen=S,this._leftoverHighSurrogate=r}_push(E,L,d){return d<128?E[L++]=d:d<2048?(E[L++]=192|(d&1984)>>>6,E[L++]=128|(d&63)>>>0):d<65536?(E[L++]=224|(d&61440)>>>12,E[L++]=128|(d&4032)>>>6,E[L++]=128|(d&63)>>>0):(E[L++]=240|(d&1835008)>>>18,E[L++]=128|(d&258048)>>>12,E[L++]=128|(d&4032)>>>6,E[L++]=128|(d&63)>>>0),L>=64&&(this._step(),L-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),L}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,L=this._buffDV;for(let c=0;c<64;c+=4)E.setUint32(c,L.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)E.setUint32(c,g(E.getUint32(c-12,!1)^E.getUint32(c-32,!1)^E.getUint32(c-56,!1)^E.getUint32(c-64,!1),1),!1);let d=this._h0,S=this._h1,r=this._h2,s=this._h3,t=this._h4,i,n,o;for(let c=0;c<80;c++)c<20?(i=S&r|~S&s,n=1518500249):c<40?(i=S^r^s,n=1859775393):c<60?(i=S&r|S&s|r&s,n=2400959708):(i=S^r^s,n=3395469782),o=g(d,5)+i+t+n+E.getUint32(c*4,!1)&4294967295,t=s,s=r,r=g(S,30),S=d,d=o;this._h0=this._h0+d&4294967295,this._h1=this._h1+S&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=p}),define(te[54],ne([0,1,29]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const A="error",T="warning",w="warn",u="info",l="ignore";function b(g){return g?N.equalsIgnoreCase(A,g)?k.Error:N.equalsIgnoreCase(T,g)||N.equalsIgnoreCase(w,g)?k.Warning:N.equalsIgnoreCase(u,g)?k.Info:k.Ignore:k.Ignore}k.fromValue=b;function C(g){switch(g){case k.Error:return A;case k.Warning:return T;case k.Info:return u;default:return l}}k.toString=C}(O||(O={})),e.default=O}),define(te[30],ne([0,1,3]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ensureOptionalStringValue=e.ensureOptionalNumberValue=e.ensureOptionalBooleanValue=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const S=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([r,s])=>{S[r]=s&&typeof s=="object"?O(s):s}),S}e.deepClone=O;function k(d){if(!d||typeof d!="object")return d;const S=[d];for(;S.length>0;){const r=S.shift();Object.freeze(r);for(const s in r)if(A.call(r,s)){const t=r[s];typeof t=="object"&&!Object.isFrozen(t)&&!(0,N.isTypedArray)(t)&&S.push(t)}}return d}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function T(d,S){return w(d,S,new Set)}e.cloneAndChange=T;function w(d,S,r){if((0,N.isUndefinedOrNull)(d))return d;const s=S(d);if(typeof s<"u")return s;if(Array.isArray(d)){const t=[];for(const i of d)t.push(w(i,S,r));return t}if((0,N.isObject)(d)){if(r.has(d))throw new Error("Cannot clone recursive data-structure");r.add(d);const t={};for(const i in d)A.call(d,i)&&(t[i]=w(d[i],S,r));return r.delete(d),t}return d}function u(d,S,r=!0){return(0,N.isObject)(d)?((0,N.isObject)(S)&&Object.keys(S).forEach(s=>{s in d?r&&((0,N.isObject)(d[s])&&(0,N.isObject)(S[s])?u(d[s],S[s],r):d[s]=S[s]):d[s]=S[s]}),d):S}e.mixin=u;function l(d,S){if(d===S)return!0;if(d==null||S===null||S===void 0||typeof d!=typeof S||typeof d!="object"||Array.isArray(d)!==Array.isArray(S))return!1;let r,s;if(Array.isArray(d)){if(d.length!==S.length)return!1;for(r=0;r<d.length;r++)if(!l(d[r],S[r]))return!1}else{const t=[];for(s in d)t.push(s);t.sort();const i=[];for(s in S)i.push(s);if(i.sort(),!l(t,i))return!1;for(r=0;r<t.length;r++)if(!l(d[t[r]],S[t[r]]))return!1}return!0}e.equals=l;function b(d){const S=new Set;return JSON.stringify(d,(r,s)=>{if((0,N.isObject)(s)||Array.isArray(s)){if(S.has(s))return"[Circular]";S.add(s)}return s})}e.safeStringify=b;function C(d,S){const r=Object.create(null);return!d||!S||Object.keys(S).forEach(t=>{const i=d[t],n=S[t];l(i,n)||(r[t]=n)}),r}e.distinct=C;function g(d,S){const r=S.toLowerCase(),s=Object.keys(d).find(t=>t.toLowerCase()===r);return s?d[s]:d[S]}e.getCaseInsensitive=g;function h(d,S){const r=Object.create(null);for(const[s,t]of Object.entries(d))S(s,t)&&(r[s]=t);return r}e.filter=h;function I(d){let S=[];for(;Object.prototype!==d;)S=S.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return S}e.getAllPropertyNames=I;function y(d){const S=[];for(const r of I(d))typeof d[r]=="function"&&S.push(r);return S}e.getAllMethodNames=y;function p(d,S){const r=t=>function(){const i=Array.prototype.slice.call(arguments,0);return S(t,i)},s={};for(const t of d)s[t]=r(t);return s}e.createProxyObject=p;function f(d,S,r){typeof S=="string"&&d[S]!==void 0&&typeof d[S]!="boolean"&&(d[S]=r)}e.ensureOptionalBooleanValue=f;function E(d,S,r){typeof S=="string"&&d[S]!==void 0&&typeof d[S]!="number"&&(d[S]=r)}e.ensureOptionalNumberValue=E;function L(d,S,r,s){if(typeof S!="string")return;const t=d[S];t!==void 0&&(typeof t!="string"||!r.includes(t))&&(d[S]=s)}e.ensureOptionalStringValue=L}),define(te[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return N.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(w){for(let u=0;u<w.length;u++)w[u]=Math.floor(Math.random()*256);return w};const A=new Uint8Array(16),T=[];for(let w=0;w<256;w++)T.push(w.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+="-",l+=T[A[u++]],l+=T[A[u++]],l+="-",l+=T[A[u++]],l+=T[A[u++]],l+="-",l+=T[A[u++]],l+=T[A[u++]],l+="-",l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l+=T[A[u++]],l}}()}),define(te[74],ne([0,1,33]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const w=T.replace(/\-/g,":").toLowerCase();return!O.has(w)}function A(){const T=(0,N.networkInterfaces)();for(const w in T){const u=T[w];if(u){for(const{mac:l}of u)if(k(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(te[75],ne([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,k=O*60,A=k*24,T=A*7,w=A*30,u=A*365;function l(C,g,h,I){typeof C!="number"&&(C=C.getTime());const y=Math.round((new Date().getTime()-C)/1e3);if(y<-30)return(0,N.localize)(0,null,l(new Date().getTime()+y*1e3,!1));if(!I&&y<30)return(0,N.localize)(1,null);let p;return y<O?(p=y,g?p===1?h?(0,N.localize)(2,null,p):(0,N.localize)(3,null,p):h?(0,N.localize)(4,null,p):(0,N.localize)(5,null,p):p===1?h?(0,N.localize)(6,null,p):(0,N.localize)(7,null,p):h?(0,N.localize)(8,null,p):(0,N.localize)(9,null,p)):y<k?(p=Math.floor(y/O),g?p===1?h?(0,N.localize)(10,null,p):(0,N.localize)(11,null,p):h?(0,N.localize)(12,null,p):(0,N.localize)(13,null,p):p===1?h?(0,N.localize)(14,null,p):(0,N.localize)(15,null,p):h?(0,N.localize)(16,null,p):(0,N.localize)(17,null,p)):y<A?(p=Math.floor(y/k),g?p===1?h?(0,N.localize)(18,null,p):(0,N.localize)(19,null,p):h?(0,N.localize)(20,null,p):(0,N.localize)(21,null,p):p===1?h?(0,N.localize)(22,null,p):(0,N.localize)(23,null,p):h?(0,N.localize)(24,null,p):(0,N.localize)(25,null,p)):y<T?(p=Math.floor(y/A),g?p===1?(0,N.localize)(26,null,p):(0,N.localize)(27,null,p):p===1?(0,N.localize)(28,null,p):(0,N.localize)(29,null,p)):y<w?(p=Math.floor(y/T),g?p===1?h?(0,N.localize)(30,null,p):(0,N.localize)(31,null,p):h?(0,N.localize)(32,null,p):(0,N.localize)(33,null,p):p===1?h?(0,N.localize)(34,null,p):(0,N.localize)(35,null,p):h?(0,N.localize)(36,null,p):(0,N.localize)(37,null,p)):y<u?(p=Math.floor(y/w),g?p===1?h?(0,N.localize)(38,null,p):(0,N.localize)(39,null,p):h?(0,N.localize)(40,null,p):(0,N.localize)(41,null,p):p===1?h?(0,N.localize)(42,null,p):(0,N.localize)(43,null,p):h?(0,N.localize)(44,null,p):(0,N.localize)(45,null,p)):(p=Math.floor(y/u),g?p===1?h?(0,N.localize)(46,null,p):(0,N.localize)(47,null,p):h?(0,N.localize)(48,null,p):(0,N.localize)(49,null,p):p===1?h?(0,N.localize)(50,null,p):(0,N.localize)(51,null,p):h?(0,N.localize)(52,null,p):(0,N.localize)(53,null,p))}e.fromNow=l;function b(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(te[77],ne([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(C,g){return g&&(C.stack||C.stacktrace)?k.localize(0,null,w(C),T(C.stack)||T(C.stacktrace)):w(C)}function T(C){return Array.isArray(C)?C.join(`
`):C}function w(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?k.localize(1,null,C.message):C.message||k.localize(2,null)}function u(C=null,g=!1){if(!C)return k.localize(3,null);if(Array.isArray(C)){const h=N.coalesce(C),I=u(h[0],g);return h.length>1?k.localize(4,null,I,h.length):I}if(O.isString(C))return C;if(C.detail){const h=C.detail;if(h.error)return A(h.error,g);if(h.exception)return A(h.exception,g)}return C.stack?A(C,g):C.message?C.message:k.localize(5,null)}e.toErrorMessage=u;function l(C){const g=C;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=l;function b(C,g){let h;return typeof C=="string"?h=new Error(C):h=C,h.actions=g,h}e.createErrorWithActions=b}),define(te[78],ne([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(te[55],ne([0,1,13]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(O||(e.Source=O={}));var k;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(w,...u){const l=u.reduce((g,h)=>(g[h]=!0,g),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(g=>!l[g]).forEach(g=>{for(let h=0;h<b.length;h++)if(g.search(b[h])!==-1){delete w[g];break}})}e.sanitizeProcessEnvironment=A;function T(w){w&&(delete w.DEBUG,N.isMacintosh&&delete w.DYLD_LIBRARY_PATH,N.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(te[80],ne([0,1,11]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(l){const b=l;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=O;function k(l){const b=[];let C;try{const g=JSON.parse(l.arguments),h=g[g.length-1];h&&h.__$stack&&(g.pop(),C=h.__$stack),b.push(...g)}catch{b.push("Unable to log remote console arguments",l.arguments)}return{args:b,stack:C}}e.parse=k;function A(l){if(typeof l!="string")return A(k(l).stack);const b=l;if(b){const C=T(b),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(g&&g.length===4)return{uri:N.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=A;function T(l){if(!l)return l;const b=l.indexOf(`
`);return b===-1?l:l.substring(0,b)}function w(l,b){const{args:C,stack:g}=k(l),h=typeof C[0]=="string"&&C.length===1;let I=T(g);I&&(I=`(${I.trim()})`);let y=[];if(typeof C[0]=="string"?I&&h?y=[`%c[${b}] %c${C[0]} %c${I}`,u("blue"),u(""),u("grey")]:y=[`%c[${b}] %c${C[0]}`,u("blue"),u(""),...C.slice(1)]:y=[`%c[${b}]%`,u("blue"),...C],I&&!h&&y.push(I),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,y)}e.log=w;function u(l){return`color: ${l}`}}),define(te[46],ne([0,1,14,11]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(u){return JSON.stringify(u,T)}e.stringify=k;function A(u){let l=JSON.parse(u);return l=w(l),l}e.parse=A;function T(u,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function w(u,l=0){if(!u||l>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return O.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof N.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let b=0;b<u.length;++b)u[b]=w(u[b],l+1);else for(const b in u)Object.hasOwnProperty.call(u,b)&&(u[b]=w(u[b],l+1))}return u}e.revive=w}),define(te[81],ne([0,1,70,15,13,11]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(g,h,I){this.id=g,this.dependencies=h,this.callback=I}}class w{static{this.INSTANCE=new w}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,h,I)=>{typeof g!="string"&&(I=h,h=g,g=null),(typeof h!="object"||!Array.isArray(h))&&(I=h,h=null),this._defineCalls.push(new T(g,h,I))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const h=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!h)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}_rendererLoadScript(g){return new Promise((h,I)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const p=()=>{y.removeEventListener("load",f),y.removeEventListener("error",E)},f=L=>{p(),h(this._defineCalls.pop())},E=L=>{p(),I(L)};y.addEventListener("load",f),y.addEventListener("error",E),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),y.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(y)})}_workerLoadScript(g){return new Promise((h,I)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),h(this._defineCalls.pop())}catch(y){I(y)}})}async _nodeJSLoadScript(g){try{const h=globalThis._VSCODE_NODE_MODULES.fs,I=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,p=A.URI.parse(g).fsPath,f=h.readFileSync(p).toString(),E=y.wrap(f.replace(/^#!.*/,""));return new I.Script(E).runInThisContext().apply(),this._defineCalls.pop()}catch(h){throw h}}}const u=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function b(C,g,h){if(N.isESM){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[C]&&(C=l[C]);const I=`${C}/${g}`;if(u.has(I))return u.get(I);let y;if(/^\w[\w\d+.-]*:\/\//.test(I))y=I;else{const L=`${h&&!k.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${I}`;y=O.FileAccess.asBrowserUri(L).toString(!0)}const p=w.INSTANCE.load(y);return u.set(I,p),p}else return await new Promise((I,y)=>{G([C],I,y)})}e.importAMDNodeModule=b}),define(te[82],ne([0,1,33,47,28,74,13]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(g){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(g)}value(){if(this._value===void 0){let g=0,h=0;const I=(0,N.networkInterfaces)();for(const y in I){const p=I[y];if(p)for(const{mac:f,internal:E}of p)E||(h+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(g+=1))}this._value=h>0?g/h:0}return this._value}};let w;async function u(g){return w||(w=(async()=>await l(g)||k.generateUuid())()),w}e.getMachineId=u;async function l(g){try{const h=await new Promise((y,p)=>{G(["crypto"],y,p)}),I=(0,A.getMac)();return h.createHash("sha256").update(I,"utf8").digest("hex")}catch(h){g(h);return}}const b="Software\\Microsoft\\SQMClient";async function C(g){if(T.isWindows){const h=await new Promise((I,y)=>{G(["@vscode/windows-registry"],I,y)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",b,"MachineId")||""}catch(I){return g(I),""}}return""}e.getSqmMachineId=C}),define(te[83],ne([0,1,33,16,24]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var u;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class C{constructor(S,r,s){this.exePath=S,this.displayName=r,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:d=!1}={}){return d?l===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:d=!1,findPreview:S=!1}={}){const r=g({useAlternateBitness:d});if(!r)return null;const s=O.join(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let t=-1,i=null;for(const c of await k.Promises.readdir(s)){let D=-1;if(S){const v=c.indexOf("-");if(v<0)continue;const R=c.substring(0,v);if(!A.test(R)||c.substring(v+1)!=="preview")continue;D=parseInt(R,10)}else{if(!A.test(c))continue;D=parseInt(c,10)}if(D<=t)continue;const P=O.join(s,c,"pwsh.exe");await k.SymlinkSupport.existsFile(P)&&(i=P,t=D)}if(!i)return null;const n=r.includes("x86")?" (x86)":"",o=S?" Preview":"";return new C(i,`PowerShell${o}${n}`,!0)}async function I({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const S=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(S))return null;const{pwshMsixDirRegex:r,pwshMsixName:s}=d?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(S))if(r.test(t)){const i=O.join(S,t,"pwsh.exe");return new C(i,s)}return null}function y(){const d=O.join(N.homedir(),".dotnet","tools","pwsh.exe");return new C(d,".NET Core PowerShell Global Tool")}function p(){const d=O.join(process.env.windir,l===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(d,"Windows PowerShell",!0)}async function*f(){let d=await h();d&&(yield d),d=await h({useAlternateBitness:!0}),d&&(yield d),d=await I(),d&&(yield d),d=y(),d&&(yield d),d=await h({findPreview:!0}),d&&(yield d),d=await I({findPreview:!0}),d&&(yield d),d=await h({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=p(),d&&(yield d)}async function*E(){for await(const d of f())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=E;async function L(){for await(const d of E())return d;return null}e.getFirstAvailablePowerShellInstallation=L}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(G,e,N,O,k,A,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(C=k.env){return C.comspec||"cmd.exe"}e.getWindowsShell=u;function l(C){let g=[],h=!1;const I=function(y){if(h){g.push(y);return}(!C.send(y,f=>{if(f&&console.error(f),h=!1,g.length>0){const E=g.slice(0);g=[],E.forEach(L=>I(L))}})||O.isWindows)&&(h=!0)};return{send:I}}e.createQueuedSender=l;var b;(function(C){async function g(h,I,y){if(N.isAbsolute(h))return h;if(I===void 0&&(I=k.cwd()),N.dirname(h)!=="."||(y===void 0&&T.isString(k.env.PATH)&&(y=k.env.PATH.split(N.delimiter)),y===void 0||y.length===0))return N.join(I,h);async function f(E){if(await w.Promises.exists(E)){let L;try{L=await w.Promises.stat(E)}catch(d){d.message.startsWith("EACCES")&&(L=await w.Promises.lstat(E))}return L?!L.isDirectory():!1}return!1}for(const E of y){let L;if(N.isAbsolute(E)?L=N.join(E,h):L=N.join(I,E,h),await f(L))return L;let d=L+".com";if(await f(d)||(d=L+".exe",await f(d)))return d}return N.join(I,h)}C.findExecutable=g})(b||(e.win32=b={}))}),define(te[84],ne([0,1,33,13,83,56]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(C,g){return C===1?O.isWindows?b():A.getWindowsShell(g):u(C,g)}e.getSystemShell=T;let w=null;function u(C,g){if(O.isLinux&&C===2||O.isMacintosh&&C===3)return"/bin/bash";if(!w){let h;if(O.isWindows)h="/bin/bash";else{if(h=g.SHELL,!h)try{h=(0,N.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}w=h}return w}let l=null;async function b(){return l||(l=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ve=this&&this.__decorate||function(G,e,N,O){var k=arguments.length,A=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,N):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,N,O);else for(var w=G.length-1;w>=0;w--)(T=G[w])&&(A=(k<3?T(A):k>3?T(e,N,A):T(e,N))||A);return k>3&&A&&Object.defineProperty(e,N,A),A};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(G,e,N,O,k,A,T,w,u,l,b,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(h||(h={}));function I(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(y||(y={}));function p(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function E(V){let _=0;for(let $=0;;$+=7){const B=V.read(1);if(_|=(B.buffer[0]&127)<<$,!(B.buffer[0]&128))return _}}const L=t(0);function d(V,_){if(_===0){V.write(L);return}let $=0;for(let X=_;X!==0;X=X>>>7)$++;const B=k.VSBuffer.alloc($);for(let X=0;_!==0;X++)B.buffer[X]=_&127,_=_>>>7,_>0&&(B.buffer[X]|=128);V.write(B)}class S{constructor(_){this.buffer=_,this.pos=0}read(_){const $=this.buffer.slice(this.pos,this.pos+_);return this.pos+=$.byteLength,$}}e.BufferReader=S;class r{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}e.BufferWriter=r;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function t(V){const _=k.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const i={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object),Uint:t(s.Int)},n=typeof Buffer<"u";function o(V,_){if(typeof _>"u")V.write(i.Undefined);else if(typeof _=="string"){const $=k.VSBuffer.fromString(_);V.write(i.String),d(V,$.byteLength),V.write($)}else if(n&&Buffer.isBuffer(_)){const $=k.VSBuffer.wrap(_);V.write(i.Buffer),d(V,$.byteLength),V.write($)}else if(_ instanceof k.VSBuffer)V.write(i.VSBuffer),d(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(i.Array),d(V,_.length);for(const $ of _)o(V,$)}else if(typeof _=="number"&&(_|0)===_)V.write(i.Uint),d(V,_);else{const $=k.VSBuffer.fromString(JSON.stringify(_));V.write(i.Object),d(V,$.byteLength),V.write($)}}e.serialize=o;function c(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(E(V)).toString();case s.Buffer:return V.read(E(V)).buffer;case s.VSBuffer:return V.read(E(V));case s.Array:{const $=E(V),B=[];for(let X=0;X<$;X++)B.push(c(V));return B}case s.Object:return JSON.parse(V.read(E(V)).toString());case s.Int:return E(V)}}e.deserialize=c;class D{constructor(_,$,B=null,X=1e3){this.protocol=_,this.ctx=$,this.logger=B,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(_,$){this.channels.set(_,$),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const $=this.send([_.type]);this.logger?.logOutgoing($,0,1,p(_.type));return}case 201:case 202:case 204:case 203:{const $=this.send([_.type,_.id],_.data);this.logger?.logOutgoing($,_.id,1,p(_.type),_.data);return}}}send(_,$=void 0){const B=new r;return o(B,_),o(B,$),this.sendBuffer(B.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onRawMessage(_){const $=new S(_),B=c($),X=c($),J=B[0];switch(J){case 100:return this.logger?.logIncoming(_.byteLength,B[1],1,`${I(J)}: ${B[2]}.${B[3]}`,X),this.onPromise({type:J,id:B[1],channelName:B[2],name:B[3],arg:X});case 102:return this.logger?.logIncoming(_.byteLength,B[1],1,`${I(J)}: ${B[2]}.${B[3]}`,X),this.onEventListen({type:J,id:B[1],channelName:B[2],name:B[3],arg:X});case 101:return this.logger?.logIncoming(_.byteLength,B[1],1,`${I(J)}`),this.disposeActiveRequest({type:J,id:B[1]});case 103:return this.logger?.logIncoming(_.byteLength,B[1],1,`${I(J)}`),this.disposeActiveRequest({type:J,id:B[1]})}}onPromise(_){const $=this.channels.get(_.channelName);if(!$){this.collectPendingRequest(_);return}const B=new A.CancellationTokenSource;let X;try{X=$.call(this.ctx,_.name,_.arg,B.token)}catch(F){X=Promise.reject(F)}const J=_.id;X.then(F=>{this.sendResponse({id:J,data:F,type:201})},F=>{F instanceof Error?this.sendResponse({id:J,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:J,data:F,type:203})}).finally(()=>{M.dispose(),this.activeRequests.delete(_.id)});const M=(0,l.toDisposable)(()=>B.cancel());this.activeRequests.set(_.id,M)}onEventListen(_){const $=this.channels.get(_.channelName);if(!$){this.collectPendingRequest(_);return}const B=_.id,J=$.listen(this.ctx,_.name,_.arg)(M=>this.sendResponse({id:B,data:M,type:204}));this.activeRequests.set(_.id,J)}disposeActiveRequest(_){const $=this.activeRequests.get(_.id);$&&($.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let $=this.pendingRequests.get(_.channelName);$||($=[],this.pendingRequests.set(_.channelName,$));const B=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:_,timeoutTimer:B})}flushPendingRequests(_){const $=this.pendingRequests.get(_);if($){for(const B of $)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var P;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class v{constructor(_,$=null){this.protocol=_,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=$}getChannel(_){const $=this;return{call(B,X,J){return $.isDisposed?Promise.reject(new w.CancellationError):$.requestPromise(_,B,X,J)},listen(B,X){return $.isDisposed?u.Event.None:$.requestEvent(_,B,X)}}}requestPromise(_,$,B,X=A.CancellationToken.None){const J=this.lastRequestId++,F={id:J,type:100,channelName:_,name:$,arg:B};if(X.isCancellationRequested)return Promise.reject(new w.CancellationError);let a;return new Promise((x,U)=>{if(X.isCancellationRequested)return U(new w.CancellationError);const H=()=>{const me=de=>{switch(de.type){case 201:this.handlers.delete(J),x(de.data);break;case 202:{this.handlers.delete(J);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.handlers.delete(J),U(de.data);break}};this.handlers.set(J,me),this.sendRequest(F)};let q=null;this.state===f.Idle?H():(q=(0,O.createCancelablePromise)(me=>this.whenInitialized()),q.then(()=>{q=null,H()}));const ce=()=>{q?(q.cancel(),q=null):this.sendRequest({id:J,type:101}),U(new w.CancellationError)},ae=X.onCancellationRequested(ce);a=(0,l.combinedDisposable)((0,l.toDisposable)(ce),ae),this.activeRequests.add(a)}).finally(()=>{a.dispose(),this.activeRequests.delete(a)})}requestEvent(_,$,B){const X=this.lastRequestId++,M={id:X,type:102,channelName:_,name:$,arg:B};let F=null;const a=new u.Emitter({onWillAddFirstListener:()=>{F=(0,O.createCancelablePromise)(x=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(a),this.sendRequest(M)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(a),this.sendRequest({id:X,type:103}))}}),m=x=>a.fire(x.data);return this.handlers.set(X,m),a.event}sendRequest(_){switch(_.type){case 100:case 102:{const $=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger?.logOutgoing($,_.id,0,`${I(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const $=this.send([_.type,_.id]);this.logger?.logOutgoing($,_.id,0,I(_.type));return}}}send(_,$=void 0){const B=new r;return o(B,_),o(B,$),this.sendBuffer(B.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onBuffer(_){const $=new S(_),B=c($),X=c($),J=B[0];switch(J){case 200:return this.logger?.logIncoming(_.byteLength,0,0,p(J)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(_.byteLength,B[1],0,p(J),X),this.onResponse({type:B[0],id:B[1],data:X})}}onResponse(_){if(_.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(_.id)?.(_)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=v,ve([T.memoize],v.prototype,"onDidInitializePromise",null);class R{get connections(){const _=[];return this._connections.forEach($=>_.push($)),_}constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(_(({protocol:$,onDidClientDisconnect:B})=>{const X=u.Event.once($.onMessage);this.disposables.add(X(J=>{const M=new S(J),F=c(M),a=new D($,F),m=new v($);this.channels.forEach((U,H)=>a.registerChannel(H,U));const x={channelServer:a,channelClient:m,ctx:F};this._connections.add(x),this._onDidAddConnection.fire(x),this.disposables.add(B(()=>{a.dispose(),m.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)}))}))}))}getChannel(_,$){const B=this;return{call(X,J,M){let F;if((0,g.isFunction)($)){const m=(0,N.getRandomElement)(B.connections.filter($));F=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(B.onDidAddConnection,$))}else F=$.routeCall(B,X,J);const a=F.then(m=>m.channelClient.getChannel(_));return Z(a).call(X,J,M)},listen(X,J){if((0,g.isFunction)($))return B.getMulticastEvent(_,$,X,J);const M=$.routeEvent(B,X,J).then(F=>F.channelClient.getChannel(_));return Z(M).listen(X,J)}}}getMulticastEvent(_,$,B,X){const J=this;let M;const F=new u.Emitter({onWillAddFirstListener:()=>{M=new l.DisposableStore;const a=new u.EventMultiplexer,m=new Map,x=H=>{const ce=H.channelClient.getChannel(_).listen(B,X),ae=a.add(ce);m.set(H,ae)},U=H=>{const q=m.get(H);q&&(q.dispose(),m.delete(H))};J.connections.filter($).forEach(x),u.Event.filter(J.onDidAddConnection,$)(x,void 0,M),J.onDidRemoveConnection(U,void 0,M),a.event(F.fire,F,M),M.add(a)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return F.event}registerChannel(_,$){this.channels.set(_,$);for(const B of this._connections)B.channelServer.registerChannel(_,$)}dispose(){this.disposables.dispose();for(const _ of this._connections)_.channelClient.dispose(),_.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class z{constructor(_,$,B=null){const X=new r;o(X,$),_.send(X.buffer),this.channelClient=new v(_,B),this.channelServer=new D(_,$,B)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,$){this.channelServer.registerChannel(_,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=z;function Z(V){return{call(_,$,B){return V.then(X=>X.call(_,$,B))},listen(_,$){const B=new u.Relay;return V.then(X=>B.input=X.listen(_,$)),B.event}}}e.getDelayedChannel=Z;function ee(V){let _=!1;return{call($,B,X){return _?V.call($,B,X):(0,O.timeout)(0).then(()=>_=!0).then(()=>V.call($,B,X))},listen($,B){if(_)return V.listen($,B);const X=new u.Relay;return(0,O.timeout)(0).then(()=>_=!0).then(()=>X.input=V.listen($,B)),X.event}}}e.getNextTickChannel=ee;class oe{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const $ of _.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await u.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=oe;var re;(function(V){function _(J,M,F){const a=J,m=F&&F.disableMarshalling,x=new Map;for(const U in a)B(U)&&x.set(U,u.Event.buffer(a[U],!0,void 0,M));return new class{listen(U,H,q){const ce=x.get(H);if(ce)return ce;if(X(H)){const ae=a[H];if(typeof ae=="function")return ae.call(a,q)}throw new w.ErrorNoTelemetry(`Event not found: ${H}`)}call(U,H,q){const ce=a[H];if(typeof ce=="function"){if(!m&&Array.isArray(q))for(let me=0;me<q.length;me++)q[me]=(0,b.revive)(q[me]);let ae=ce.apply(a,q);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new w.ErrorNoTelemetry(`Method not found: ${H}`)}}}V.fromService=_;function $(J,M){const F=M&&M.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return M?.properties?.has(m)?M.properties.get(m):X(m)?function(x){return J.listen(m,x)}:B(m)?J.listen(m):async function(...x){let U;M&&!(0,g.isUndefinedOrNull)(M.context)?U=[M.context,...x]:U=x;const H=await J.call(m,U);return F?H:(0,b.revive)(H)};throw new w.ErrorNoTelemetry(`Property not found: ${String(m)}`)}})}V.toService=$;function B(J){return J[0]==="o"&&J[1]==="n"&&C.isUpperAsciiLetter(J.charCodeAt(2))}function X(J){return/^onDynamic/.test(J)&&C.isUpperAsciiLetter(J.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function se(V){return Array.isArray(V)?V.map(le):le(V)}function W(V,_,$,B,X,J,M){M=se(M);const F=ue[X],a=F[B%F.length];let m=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(J)?(m=m.concat(M),m.push(")")):m.push(M),console.log.apply(console,m)}class K{constructor(_,$){this._outgoingPrefix=_,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,$,B,X,J){this._totalOutgoing+=_,W(this._outgoingPrefix,this._totalOutgoing,_,$,B,X,J)}logIncoming(_,$,B,X,J){this._totalIncoming+=_,W(this._incomingPrefix,this._totalIncoming,_,$,B,X,J)}}e.IPCLogger=K}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class I extends h.ChannelServer{constructor(f){super({send:E=>{try{process.send?.(E.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",E=>k.VSBuffer.wrap(Buffer.from(E,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=I;class y{constructor(f,E){this.modulePath=f,this.options=E,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const L=E&&E.timeout?E.timeout:6e4;this.disposeDelayer=new O.Delayer(L),this.child=null,this._client=null}getChannel(f){const E=this;return{call(L,d,S){return E.requestPromise(f,L,d,S)},listen(L,d){return E.requestEvent(f,L,d)}}}requestPromise(f,E,L,d=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(f),r=(0,O.createCancelablePromise)(i=>S.call(E,L,i)),s=d.onCancellationRequested(()=>r.cancel()),t=(0,l.toDisposable)(()=>r.cancel());return this.activeRequests.add(t),r.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(f,E,L){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let d;const S=new u.Emitter({onWillAddFirstListener:()=>{d=this.getCachedChannel(f).listen(E,L)(S.fire,S),this.activeRequests.add(d)},onDidRemoveLastListener:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],E=Object.create(null);E.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(E.env={...E.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(E.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(E.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(E.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),E.execArgv===void 0&&(E.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(E.env),this.child=(0,N.fork)(this.modulePath,f,E);const L=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,T.isRemoteConsoleLog)(n)){(0,T.log)(n,`IPC Library: ${this.options.serverName}`);return}L.fire(k.VSBuffer.wrap(Buffer.from(n,"base64")))});const S=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,r=n=>this.child&&this.child.connected&&S.send(n.buffer.toString("base64")),s=L.event,t={send:r,onMessage:s};this._client=new h.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(c=>(0,l.dispose)(c)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(f){let E=this.channels.get(f);return E||(E=this.client.getChannel(f),this.channels.set(f,E)),E}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(te[86],ne([0,1,8,4,2,46,3]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var w;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function u(g){const h=g;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=u;var l;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(l||(e.StorageState=l={}));class b extends k.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(h,I=Object.create(null)){super(),this.database=h,this.options=I,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new N.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){this._onDidChangeStorage.pause();try{h.changed?.forEach((I,y)=>this.acceptExternal(y,I)),h.deleted?.forEach(I=>this.acceptExternal(I,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(h,I){if(this.state===l.Closed)return;let y=!1;(0,T.isUndefinedOrNull)(I)?y=this.cache.delete(h):this.cache.get(h)!==I&&(this.cache.set(h,I),y=!0),y&&this._onDidChangeStorage.fire({key:h,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,I){const y=this.cache.get(h);return(0,T.isUndefinedOrNull)(y)?I:y}getBoolean(h,I){const y=this.get(h);return(0,T.isUndefinedOrNull)(y)?I:y==="true"}getNumber(h,I){const y=this.get(h);return(0,T.isUndefinedOrNull)(y)?I:parseInt(y,10)}getObject(h,I){const y=this.get(h);return(0,T.isUndefinedOrNull)(y)?I:(0,A.parse)(y)}async set(h,I,y=!1){if(this.state===l.Closed)return;if((0,T.isUndefinedOrNull)(I))return this.delete(h,y);const p=(0,T.isObject)(I)||Array.isArray(I)?(0,A.stringify)(I):String(I);if(this.cache.get(h)!==p)return this.cache.set(h,p),this.pendingInserts.set(h,p),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire({key:h,external:y}),this.doFlush()}async delete(h,I=!1){if(!(this.state===l.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire({key:h,external:I}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(this.hasPending)return this.doFlush(h)}async doFlush(h){return this.options.hint===w.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}isInMemory(){return this.options.hint===w.STORAGE_IN_MEMORY}}e.Storage=b;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((I,y)=>this.items.set(y,I)),h.delete?.forEach(I=>this.items.delete(I))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=C}),define(te[87],ne([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(te[88],ne([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[89],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(te[90],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(te[91],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[92],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[93],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[94],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[95],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[96],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[97],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[98],ne([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[99],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(te[100],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(te[101],ne([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[102],ne([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[103],ne([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(te[104],ne([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(te[105],ne([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[106],ne([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[107],ne([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(te[108],ne([0,1,9,90]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...l){switch(l.length){case 1:return(0,O.localize)(0,null,l[0]);case 2:return(0,O.localize)(1,null,l[0],l[1]);case 3:return(0,O.localize)(2,null,l[0],l[1],l[2]);default:return}}const T=(0,O.localize)(3,null),w=(0,O.localize)(4,null);class u{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,N.illegalState)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(b){return this._input=b,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const C=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:C})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const C=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:C})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(b){return this._isAtEnd()||this._input.charCodeAt(this._current)!==b?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(b){this._tokens.push({type:b,offset:this._start})}_error(b){const C=this._start,g=this._input.substring(this._start,this._current),h={type:19,offset:this._start,lexeme:g};this._errors.push({offset:C,lexeme:g,additionalInfo:b}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const b=this.stringRe.exec(this._input);if(b){this._current=this._start+b[0].length;const C=this._input.substring(this._start,this._current),g=u._keywords.get(C);g?this._addToken(g):this._tokens.push({type:17,lexeme:C,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let b=this._current,C=!1,g=!1;for(;;){if(b>=this._input.length){this._current=b,this._error(w);return}const I=this._input.charCodeAt(b);if(C)C=!1;else if(I===47&&!g){b++;break}else I===91?g=!0:I===92?C=!0:I===93&&(g=!1);b++}for(;b<this._input.length&&u._regexFlags.has(this._input.charCodeAt(b));)b++;this._current=b;const h=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=u}),define(te[109],ne([0,1,76,52,15,16,35,17,11]),function(G,e,N,O,k,A,T,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,w.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,N.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(u.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?u.URI.file((0,A.join)(h,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?u.URI.file((0,A.resolve)(h)):u.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const I=T.env.VSCODE_EXTENSIONS;if(I)return I;const y=T.env.VSCODE_PORTABLE;return y?(0,A.join)(y,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(I=>/^[^:/?#]+?:\/\//.test(I)?u.URI.parse(I):u.URI.file((0,A.normalize)(I)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?u.URI.parse(h):u.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const I of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(I);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,w.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=T.env.VSCODE_PORTABLE;return h?u.URI.file((0,A.join)(h,"policy.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,I,y){this._args=h,this.paths=I,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ve([O.memoize],l.prototype,"appRoot",null),ve([O.memoize],l.prototype,"userHome",null),ve([O.memoize],l.prototype,"userDataPath",null),ve([O.memoize],l.prototype,"appSettingsHome",null),ve([O.memoize],l.prototype,"tmpDir",null),ve([O.memoize],l.prototype,"cacheHome",null),ve([O.memoize],l.prototype,"stateResource",null),ve([O.memoize],l.prototype,"userRoamingDataHome",null),ve([O.memoize],l.prototype,"userDataSyncHome",null),ve([O.memoize],l.prototype,"sync",null),ve([O.memoize],l.prototype,"machineSettingsResource",null),ve([O.memoize],l.prototype,"workspaceStorageHome",null),ve([O.memoize],l.prototype,"localHistoryHome",null),ve([O.memoize],l.prototype,"keyboardLayoutResource",null),ve([O.memoize],l.prototype,"argvResource",null),ve([O.memoize],l.prototype,"isExtensionDevelopment",null),ve([O.memoize],l.prototype,"untitledWorkspacesHome",null),ve([O.memoize],l.prototype,"builtinExtensionsPath",null),ve([O.memoize],l.prototype,"extensionsPath",null),ve([O.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ve([O.memoize],l.prototype,"extensionDevelopmentKind",null),ve([O.memoize],l.prototype,"extensionTestsLocationURI",null),ve([O.memoize],l.prototype,"debugExtensionHost",null),ve([O.memoize],l.prototype,"logLevel",null),ve([O.memoize],l.prototype,"extensionLogLevel",null),ve([O.memoize],l.prototype,"serviceMachineIdResource",null),ve([O.memoize],l.prototype,"disableTelemetry",null),ve([O.memoize],l.prototype,"disableWorkspaceTrust",null),ve([O.memoize],l.prototype,"useInMemorySecretStorage",null),ve([O.memoize],l.prototype,"policyFile",null);function b(g,h){return C(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId,g.extensionEnvironment)}e.parseExtensionHostDebugPort=b;function C(g,h,I,y,p,f){const L=Number(h||g)||(y?null:I),d=L?!!h:!1;let S;if(f)try{S=JSON.parse(f)}catch{}return{port:L,break:d,debugId:p,env:S}}e.parseDebugParams=C}),function(){"use strict";function G(e,N,O){function k(T,w){const u=A(T,w),l=[u];return e.isAbsolute(u)||l.unshift(O),e.resolve(...l)}function A(T,w){process.env.VSCODE_DEV&&(w="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,w);const b=T["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(C,"AppData","Roaming")}break;case"darwin":l=e.join(N.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,w)}return{getUserDataPath:k}}if(typeof define=="function")define(te[110],ne([165,33,35]),function(e,N,O){return G(e,N,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=G(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[111],ne([0,1,33,109,110]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(l,b){super(l,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,k.getUserDataPath)(l,b.nameShort)},b)}}e.NativeEnvironmentService=A;function T(u,l){return(0,O.parseDebugParams)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.parsePtyHostDebugPort=T;function w(u,l){return(0,O.parseDebugParams)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.parseSharedProcessDebugPort=w}),define(te[112],ne([0,1,3,94]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(T,w,u,l){try{A(T,w,u,l)}catch(b){T.error(b?.message??b)}return w}e.localizeManifest=k;function A(T,w,u,l){const b=(C,g,h)=>{const I=C[g];if((0,N.isString)(I)){const y=I,p=y.length;if(p>1&&y[0]==="%"&&y[p-1]==="%"){const f=y.substr(1,p-2);let E=u[f];E===void 0&&l&&(E=l[f]);const L=typeof E=="string"?E:E?.message,d=l?.[f],S=typeof d=="string"?d:d?.message;if(!L){S||T.warn(`[${w.name}]: ${(0,O.localize)(0,null,f)}`);return}if(h&&(g==="title"||g==="category")&&S&&S!==L){const r={value:L,original:S};C[g]=r}else C[g]=L}}else if((0,N.isObject)(I))for(const y in I)I.hasOwnProperty(y)&&(y==="commands"?b(I,y,!0):b(I,y,h));else if(Array.isArray(I))for(let y=0;y<I.length;y++)b(I,y,h)};for(const C in w)w.hasOwnProperty(C)&&b(w,C)}}),define(te[48],ne([0,1,17,54,98,42]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function u(f){return f=f.trim(),f==="*"||T.test(f)}e.isValidVersionStr=u;function l(f){if(!u(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const E=f.match(T);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=l;function b(f){if(!f)return null;const E=f.majorBase,L=f.majorMustEqual,d=f.minorBase;let S=f.minorMustEqual;const r=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(E===0||(S=!1),s=!1);let t=0;if(f.preRelease){const i=w.exec(f.preRelease);if(i){const[,n,o,c]=i;t=Date.UTC(Number(n),Number(o)-1,Number(c))}}return{majorBase:E,majorMustEqual:L,minorBase:d,minorMustEqual:S,patchBase:r,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:t}}e.normalizeVersion=b;function C(f,E,L){let d;typeof f=="string"?d=b(l(f)):d=f;let S;E instanceof Date?S=E.getTime():typeof E=="string"&&(S=new Date(E).getTime());let r;if(typeof L=="string"?r=b(l(L)):r=L,!d||!r)return!1;const s=d.majorBase,t=d.minorBase,i=d.patchBase;let n=r.majorBase,o=r.minorBase,c=r.patchBase;const D=r.notBefore;let P=r.majorMustEqual,v=r.minorMustEqual,R=r.patchMustEqual;return r.isMinimum?s>n?!0:s<n?!1:t>o?!0:t<o||S&&S<D?!1:i>=c:(s===1&&n===0&&(!P||!v||!R)&&(n=1,o=0,c=0,P=!0,v=!1,R=!1),s<n?!1:s>n?!P:t<o?!1:t>o?!v:i<c?!1:i>c?!R:!(S&&S<D))}e.isValidVersion=C;function g(f,E,L,d,S){const r=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return r.push([O.default.Error,k.localize(0,null)]),r;if(typeof d.name!="string")return r.push([O.default.Error,k.localize(1,null,"name")]),r;if(typeof d.version!="string")return r.push([O.default.Error,k.localize(2,null,"version")]),r;if(!d.engines)return r.push([O.default.Error,k.localize(3,null,"engines")]),r;if(typeof d.engines.vscode!="string")return r.push([O.default.Error,k.localize(4,null,"engines.vscode")]),r;if(typeof d.extensionDependencies<"u"&&!p(d.extensionDependencies))return r.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),r;if(typeof d.activationEvents<"u"){if(!p(d.activationEvents))return r.push([O.default.Error,k.localize(6,null,"activationEvents")]),r;if(typeof d.main>"u"&&typeof d.browser>"u")return r.push([O.default.Error,k.localize(7,null,"activationEvents","main","browser")]),r}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&r.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return r.push([O.default.Error,k.localize(9,null,"main")]),r;{const i=(0,N.joinPath)(L,d.main);(0,N.isEqualOrParent)(i,L)||r.push([O.default.Warning,k.localize(10,null,i.path,L.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return r.push([O.default.Error,k.localize(11,null,"browser")]),r;{const i=(0,N.joinPath)(L,d.browser);(0,N.isEqualOrParent)(i,L)||r.push([O.default.Warning,k.localize(12,null,i.path,L.path)])}}if(!A.valid(d.version))return r.push([O.default.Error,k.localize(13,null)]),r;const s=[];if(!h(f,E,d,S,s))for(const i of s)r.push([O.default.Error,i]);return r}e.validateExtensionManifest=g;function h(f,E,L,d,S){return d||typeof L.main>"u"&&typeof L.browser>"u"?!0:y(f,E,L.engines.vscode,S)}e.isValidExtensionVersion=h;function I(f,E,L){return f==="*"||y(E,L,f)}e.isEngineValid=I;function y(f,E,L,d=[]){const S=b(l(L));if(!S)return d.push(k.localize(14,null,L)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return d.push(k.localize(15,null,L)),!1}else if(!S.majorMustEqual)return d.push(k.localize(16,null,L)),!1;return C(f,E,S)?!0:(d.push(k.localize(17,null,f,L)),!1)}function p(f){if(!Array.isArray(f))return!1;for(let E=0,L=f.length;E<L;E++)if(typeof f[E]!="string")return!1;return!0}}),define(te[113],ne([0,1,14,28]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(A,T,w){let u=w&&w.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const b=(await T.readFile(A.serviceMachineIdResource)).value.toString();u=(0,O.isUUID)(b)?b:null}catch{u=null}if(!u){u=(0,O.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,N.VSBuffer.fromString(u))}catch{}}return w?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=k}),define(te[49],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class N{constructor(k,A=[],T=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=N}),define(te[114],ne([0,1,49]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(w,u,l){u instanceof N.SyncDescriptor||(u=new N.SyncDescriptor(u,[],!!l)),O.push([w,u])}e.registerSingleton=A;function T(){return O}e.getSingletonServiceDescriptors=T}),define(te[115],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class N{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=N;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const w=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(T);w.outgoing.set(u.key,u),u.incoming.set(w.key,w)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const w of this._nodes.values())w.outgoing.delete(T),w.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let w=this._nodes.get(T);return w||(w=new N(T,A),this._nodes.set(T,w)),w}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,w]of this._nodes)A.push(`${T}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const w=new Set([A]),u=this._findCycle(T,w);if(u)return u}}_findCycle(A,T){for(const[w,u]of A.outgoing){if(T.has(w))return[...T,w].join(" -> ");T.add(w);const l=this._findCycle(u,T);if(l)return l;T.delete(w)}}}e.Graph=O}),define(te[25],ne([0,1,3,11,10]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof O.URI)}e.isConfigurationOverrides=A;function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var w;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function u(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function l(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.isConfigured=l;function b(f,E){const L=Object.create(null);for(const d in f)C(L,d,f[d],E);return L}e.toValuesTree=b;function C(f,E,L,d){const S=E.split("."),r=S.pop();let s=f;for(let t=0;t<S.length;t++){const i=S[t];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${E} as ${S.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[r]=L}catch{d(`Ignoring ${E} as ${S.join(".")} is ${JSON.stringify(s)}`)}else d(`Ignoring ${E} as ${S.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=C;function g(f,E){const L=E.split(".");h(f,L)}e.removeFromValueTree=g;function h(f,E){const L=E.shift();if(E.length===0){delete f[L];return}if(Object.keys(f).indexOf(L)!==-1){const d=f[L];typeof d=="object"&&!Array.isArray(d)&&(h(d,E),Object.keys(d).length===0&&delete f[L])}}function I(f,E,L){function d(s,t){let i=s;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const S=E.split("."),r=d(f,S);return typeof r>"u"?L:r}e.getConfigurationValue=I;function y(f,E,L){Object.keys(E).forEach(d=>{d!=="__proto__"&&(d in f?N.isObject(f[d])&&N.isObject(E[d])?y(f[d],E[d],L):L&&(f[d]=E[d]):f[d]=E[d])})}e.merge=y;function p(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(te[116],ne([0,1,13,29,108,10,89,9]),function(G,e,N,O,k,A,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",N.isMacintosh),u.set("isLinux",N.isLinux),u.set("isWindows",N.isWindows),u.set("isWeb",N.isWeb),u.set("isMacNative",N.isMacintosh&&!N.isWeb),u.set("isEdge",N.isEdge),u.set("isFirefox",N.isFirefox),u.set("isChrome",N.isChrome),u.set("isSafari",N.isSafari);function l(F,a){if(u.get(F)!==void 0)throw(0,w.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(F,a)}e.setConstant=l;const b=Object.prototype.hasOwnProperty;var C;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const g={regexParsingWithErrorRecovery:!0},h=(0,T.localize)(0,null),I=(0,T.localize)(1,null),y=(0,T.localize)(2,null),p=(0,T.localize)(3,null),f=(0,T.localize)(4,null),E=(0,T.localize)(5,null),L=(0,T.localize)(6,null),d=(0,T.localize)(7,null);class S{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(a=g){this._config=a,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(a){if(a===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:I});return}this._tokens=this._scanner.reset(a).scan(),this._current=0,this._parsingErrors=[];try{const m=this._expr();if(!this._isAtEnd()){const x=this._peek(),U=x.type===17?E:void 0;throw this._parsingErrors.push({message:f,offset:x.offset,lexeme:k.Scanner.getLexeme(x),additionalInfo:U}),S._parseError}return m}catch(m){if(m!==S._parseError)throw m;return}}_expr(){return this._or()}_or(){const a=[this._and()];for(;this._matchOne(16);){const m=this._and();a.push(m)}return a.length===1?a[0]:r.or(...a)}_and(){const a=[this._term()];for(;this._matchOne(15);){const m=this._term();a.push(m)}return a.length===1?a[0]:r.and(...a)}_term(){if(this._matchOne(2)){const a=this._peek();switch(a.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const m=this._expr();return this._consume(1,p),m?.negate()}case 17:return this._advance(),z.create(a.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",a)}}return this._primary()}_primary(){const a=this._peek();switch(a.type){case 11:return this._advance(),r.true();case 12:return this._advance(),r.false();case 0:{this._advance();const m=this._expr();return this._consume(1,p),m}case 17:{const m=a.lexeme;if(this._advance(),this._matchOne(9)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==10)throw this._errExpectedButGot("REGEX",U);const H=U.lexeme,q=H.lastIndexOf("/"),ce=q===H.length-1?void 0:this._removeFlagsGY(H.substring(q+1));let ae;try{ae=new RegExp(H.substring(1,q),ce)}catch{throw this._errExpectedButGot("REGEX",U)}return le.create(m,ae)}switch(U.type){case 10:case 19:{const H=[U.lexeme];this._advance();let q=this._peek(),ce=0;for(let he=0;he<U.lexeme.length;he++)U.lexeme.charCodeAt(he)===40?ce++:U.lexeme.charCodeAt(he)===41&&ce--;for(;!this._isAtEnd()&&q.type!==15&&q.type!==16;){switch(q.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let he=0;he<q.lexeme.length;he++)q.lexeme.charCodeAt(he)===40?ce++:U.lexeme.charCodeAt(he)===41&&ce--}if(ce<0)break;H.push(k.Scanner.getLexeme(q)),this._advance(),q=this._peek()}const ae=H.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this._removeFlagsGY(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this._errExpectedButGot("REGEX",U)}return r.regex(m,ge)}case 18:{const H=U.lexeme;this._advance();let q=null;if(!(0,O.isFalsyOrWhitespace)(H)){const ce=H.indexOf("/"),ae=H.lastIndexOf("/");if(ce!==ae&&ce>=0){const me=H.slice(ce+1,ae),de=H[ae+1]==="i"?"i":"";try{q=new RegExp(me,de)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(q===null)throw this._errExpectedButGot("REGEX",U);return le.create(m,q)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const U=this._value();return r.notIn(m,U)}switch(this._peek().type){case 3:{this._advance();const U=this._value();if(this._previous().type===18)return r.equals(m,U);switch(U){case"true":return r.has(m);case"false":return r.not(m);default:return r.equals(m,U)}}case 4:{this._advance();const U=this._value();if(this._previous().type===18)return r.notEquals(m,U);switch(U){case"true":return r.not(m);case"false":return r.has(m);default:return r.notEquals(m,U)}}case 5:return this._advance(),re.create(m,this._value());case 6:return this._advance(),ue.create(m,this._value());case 7:return this._advance(),ee.create(m,this._value());case 8:return this._advance(),oe.create(m,this._value());case 13:return this._advance(),r.in(m,this._value());default:return r.has(m)}}case 20:throw this._parsingErrors.push({message:L,offset:a.offset,lexeme:"",additionalInfo:d}),S._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const a=this._peek();switch(a.type){case 17:case 18:return this._advance(),a.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(a){return a.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(a){return this._check(a)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(a,m){if(this._check(a))return this._advance();throw this._errExpectedButGot(m,this._peek())}_errExpectedButGot(a,m,x){const U=(0,T.localize)(8,null,a,k.Scanner.getLexeme(m)),H=m.offset,q=k.Scanner.getLexeme(m);return this._parsingErrors.push({message:U,offset:H,lexeme:q,additionalInfo:x}),S._parseError}_check(a){return this._peek().type===a}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=S;class r{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(a){return c.create(a)}static equals(a,m){return D.create(a,m)}static notEquals(a,m){return R.create(a,m)}static regex(a,m){return le.create(a,m)}static in(a,m){return P.create(a,m)}static notIn(a,m){return v.create(a,m)}static not(a){return z.create(a)}static and(...a){return K.create(a,null,!0)}static or(...a){return V.create(a,null,!0)}static greater(a,m){return ee.create(a,m)}static greaterEquals(a,m){return oe.create(a,m)}static smaller(a,m){return re.create(a,m)}static smallerEquals(a,m){return ue.create(a,m)}static{this._parser=new S({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this._parser.parse(a)}}e.ContextKeyExpr=r;function s(F){const a=new S({regexParsingWithErrorRecovery:!1});return F.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,T.localize)(9,null,x.additionalInfo):(0,T.localize)(10,null),offset:x.offset,length:x.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.validateWhenClauses=s;function t(F,a){const m=F?F.substituteConstants():void 0,x=a?a.substituteConstants():void 0;return!m&&!x?!0:!m||!x?!1:m.equals(x)}e.expressionsAreEqualWithConstantSubstitution=t;function i(F,a){return F.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=o;class c{static create(a,m=null){const x=u.get(a);return typeof x=="boolean"?x?o.INSTANCE:n.INSTANCE:new c(a,m)}constructor(a,m){this.key=a,this.negated=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:$(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?o.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.negated||(this.negated=z.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class D{static create(a,m,x=null){if(typeof m=="boolean")return m?c.create(a,x):z.create(a,x);const U=u.get(a);return typeof U=="boolean"?m===(U?"true":"false")?o.INSTANCE:n.INSTANCE:new D(a,m,x)}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){const a=u.get(this.key);if(typeof a=="boolean"){const m=a?"true":"false";return this.value===m?o.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class P{static create(a,m){return new P(a,m)}constructor(a,m){this.key=a,this.valueKey=m,this.type=10,this.negated=null}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.valueKey),x=a.getValue(this.key);return Array.isArray(m)?m.includes(x):typeof x=="string"&&typeof m=="object"&&m!==null?b.call(m,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=P;class v{static create(a,m){return new v(a,m)}constructor(a,m){this.key=a,this.valueKey=m,this.type=11,this._negated=P.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this._negated.cmp(a._negated)}equals(a){return a.type===this.type?this._negated.equals(a._negated):!1}substituteConstants(){return this}evaluate(a){return!this._negated.evaluate(a)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(a){return a.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=v;class R{static create(a,m,x=null){if(typeof m=="boolean")return m?z.create(a,x):c.create(a,x);const U=u.get(a);return typeof U=="boolean"?m===(U?"true":"false")?n.INSTANCE:o.INSTANCE:new R(a,m,x)}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){const a=u.get(this.key);if(typeof a=="boolean"){const m=a?"true":"false";return this.value===m?n.INSTANCE:o.INSTANCE}return this}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=R;class z{static create(a,m=null){const x=u.get(a);return typeof x=="boolean"?x?n.INSTANCE:o.INSTANCE:new z(a,m)}constructor(a,m){this.key=a,this.negated=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:$(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?n.INSTANCE:o.INSTANCE:this}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=z;function Z(F,a){if(typeof F=="string"){const m=parseFloat(F);isNaN(m)||(F=m)}return typeof F=="string"||typeof F=="number"?a(F):n.INSTANCE}class ee{static create(a,m,x=null){return Z(m,U=>new ee(a,U,x))}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=ee;class oe{static create(a,m,x=null){return Z(m,U=>new oe(a,U,x))}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=oe;class re{static create(a,m,x=null){return Z(m,U=>new re(a,U,x))}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=oe.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=re;class ue{static create(a,m,x=null){return Z(m,U=>new ue(a,U,x))}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ee.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ue;class le{static create(a,m){return new le(a,m)}constructor(a,m){this.key=a,this.regexp=m,this.type=7,this.negated=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const m=this.regexp?this.regexp.source:"",x=a.regexp?a.regexp.source:"";return m<x?-1:m>x?1:0}equals(a){if(a.type===this.type){const m=this.regexp?this.regexp.source:"",x=a.regexp?a.regexp.source:"";return this.key===a.key&&m===x}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.key);return this.regexp?this.regexp.test(m):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=le;class se{static create(a){return new se(a)}constructor(a){this._actual=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}substituteConstants(){return this}evaluate(a){return!this._actual.evaluate(a)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(a){return new se(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function W(F){let a=null;for(let m=0,x=F.length;m<x;m++){const U=F[m].substituteConstants();if(F[m]!==U&&a===null){a=[];for(let H=0;H<m;H++)a[H]=F[H]}a!==null&&(a[m]=U)}return a===null?F:a}class K{static create(a,m,x){return K._normalizeArr(a,m,x)}constructor(a,m){this.expr=a,this.negated=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,x=this.expr.length;m<x;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,x=this.expr.length;m<x;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=W(this.expr);return a===this.expr?this:K.create(a,this.negated,!1)}evaluate(a){for(let m=0,x=this.expr.length;m<x;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static _normalizeArr(a,m,x){const U=[];let H=!1;for(const q of a)if(q){if(q.type===1){H=!0;continue}if(q.type===0)return n.INSTANCE;if(q.type===6){U.push(...q.expr);continue}U.push(q)}if(U.length===0&&H)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let q=1;q<U.length;q++)U[q-1].equals(U[q])&&(U.splice(q,1),q--);if(U.length===1)return U[0];for(;U.length>1;){const q=U[U.length-1];if(q.type!==9)break;U.pop();const ce=U.pop(),ae=U.length===0,me=V.create(q.expr.map(de=>K.create([de,ce],null,x)),null,ae);me&&(U.push(me),U.sort(i))}if(U.length===1)return U[0];if(x){for(let q=0;q<U.length;q++)for(let ce=q+1;ce<U.length;ce++)if(U[q].negate().equals(U[ce]))return n.INSTANCE;if(U.length===1)return U[0]}return new K(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new K(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.negated){const a=[];for(const m of this.expr)a.push(m.negate());this.negated=V.create(a,this,!0)}return this.negated}}e.ContextKeyAndExpr=K;class V{static create(a,m,x){return V._normalizeArr(a,m,x)}constructor(a,m){this.expr=a,this.negated=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,x=this.expr.length;m<x;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,x=this.expr.length;m<x;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=W(this.expr);return a===this.expr?this:V.create(a,this.negated,!1)}evaluate(a){for(let m=0,x=this.expr.length;m<x;m++)if(this.expr[m].evaluate(a))return!0;return!1}static _normalizeArr(a,m,x){let U=[],H=!1;if(a){for(let q=0,ce=a.length;q<ce;q++){const ae=a[q];if(ae){if(ae.type===0){H=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&H)return n.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let q=1;q<U.length;q++)U[q-1].equals(U[q])&&(U.splice(q,1),q--);if(U.length===1)return U[0];if(x){for(let q=0;q<U.length;q++)for(let ce=q+1;ce<U.length;ce++)if(U[q].negate().equals(U[ce]))return o.INSTANCE;if(U.length===1)return U[0]}return new V(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new V(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.negated){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),x=a.shift(),U=[];for(const H of M(m))for(const q of M(x))U.push(K.create([H,q],null,!1));a.unshift(V.create(U,null,!1))}this.negated=V.create(a,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class _ extends c{static{this._info=[]}static all(){return _._info.values()}constructor(a,m,x){super(a,null),this._defaultValue=m,typeof x=="object"?_._info.push({...x,key:a}):x!==!0&&_._info.push({key:a,description:x,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return D.create(this.key,a)}notEqualsTo(a){return R.create(this.key,a)}}e.RawContextKey=_,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function $(F,a){return F<a?-1:F>a?1:0}function B(F,a,m,x){return F<m?-1:F>m?1:a<x?-1:a>x?1:0}function X(F,a){if(F.type===0||a.type===1)return!0;if(F.type===9)return a.type===9?J(F.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(X(F,m))return!0;return!1}if(F.type===6){if(a.type===6)return J(a.expr,F.expr);for(const m of F.expr)if(X(m,a))return!0;return!1}return F.equals(a)}e.implies=X;function J(F,a){let m=0,x=0;for(;m<F.length&&x<a.length;){const U=F[m].cmp(a[x]);if(U<0)return!1;U===0&&m++,x++}return m===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(te[59],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,N.createDecorator)("downloadService")}),define(te[18],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,N.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,N.refineServiceDecorator)(e.IEnvironmentService)}),define(te[21],ne([0,1,92,10]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function k(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(f,E){switch(f){case 3:return E==="x64"?"win32-x64":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":E==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function w(f,E){return E==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function u(f,E,L){return w(E,L)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===L}e.isTargetPlatformCompatible=u;function l(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=l;var b;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var C;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var g;(function(f){f.Install="install",f.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var h;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var I;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));var y;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class p extends Error{constructor(E,L){super(E),this.code=L,this.name=L}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,N.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,N.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,N.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,T)=>G(["node-vsce-sign"],async w=>A(w),T))),this.moduleLoadingPromise}async verify(A,T,w){let u;try{u=await this.vsceSign()}catch{return!1}return u.verify(A,T,w)}}e.ExtensionSignatureVerificationService=O}),define(te[61],ne([0,1,14,9,100,12]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(b,C,g,h,I,y){let p;try{await w(b,C,g,h,I,y)}catch(f){p=f}finally{p&&I.errorTransformer&&(p=I.errorTransformer(p)),typeof p<"u"&&g.error(p),g.end()}}e.readFileIntoStream=T;async function w(b,C,g,h,I,y){u(y);const p=await b.open(C,{create:!1});try{u(y);let f=0,E=0,L=I&&typeof I.length=="number"?I.length:void 0,d=N.VSBuffer.alloc(Math.min(I.bufferSize,typeof L=="number"?L:I.bufferSize)),S=I&&typeof I.position=="number"?I.position:0,r=0;do E=await b.read(p,S,d.buffer,r,d.byteLength-r),S+=E,r+=E,f+=E,typeof L=="number"&&(L-=E),r===d.byteLength&&(await g.write(h(d)),d=N.VSBuffer.alloc(Math.min(I.bufferSize,typeof L=="number"?L:I.bufferSize)),r=0);while(E>0&&(typeof L!="number"||L>0)&&u(y)&&l(f,I));if(r>0){let s=r;typeof L=="number"&&(s=Math.min(r,L)),g.write(h(d.slice(0,s)))}}catch(f){throw(0,A.ensureFileSystemProviderError)(f)}finally{await b.close(p)}}function u(b){if(b.isCancellationRequested)throw(0,O.canceled)();return!0}function l(b,C){if(typeof C?.limits?.size=="number"&&b>C.limits.size)throw(0,A.createFileSystemProviderError)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[117],ne([0,1,4,166,2,13,167]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new N.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=N.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const b=this.normalizeRequests(l),C=b.filter(h=>{const I=this.watchers.get(h.path);return I?!(0,O.patternsEquals)(I.request.excludes,h.excludes)||!(0,O.patternsEquals)(I.request.includes,h.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:h})=>!b.find(I=>I.path===h.path&&(0,O.patternsEquals)(I.excludes,h.excludes)&&(0,O.patternsEquals)(I.includes,h.includes))).map(({request:h})=>h.path);C.length&&this.trace(`Request to start watching: ${C.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const h of g)this.stopWatching(h);for(const h of C)this.startWatching(h)}startWatching(l){const b=new T.NodeJSFileWatcherLibrary(l,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),C={request:l,instance:b};this.watchers.set(l.path,C)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const b=this.watchers.get(l);b&&(this.watchers.delete(l),b.instance.dispose())}normalizeRequests(l){const b=new Map;for(const C of l){const g=A.isLinux?C.path:C.path.toLowerCase();let h=b.get(C.correlationId);h||(h=new Map,b.set(C.correlationId,h)),h.set(g,C)}return Array.from(b.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(l){this.verboseLogging=l;for(const[,b]of this.watchers)b.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,b){return b?`[File Watcher (node.js)] ${l} (path: ${b.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=w}),define(te[118],ne([0,1,62,117]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends N.AbstractNonRecursiveWatcherClient{constructor(T,w,u){super(T,w,u),this.init()}createWatcher(T){return T.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=k}),define(te[119],ne([0,1,15,57,85,62]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(u,l,b){super(u,l,b),this.init()}createWatcher(u){const l=u.add(new k.Client(N.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:b,signal:C})=>this.onError(`terminated by itself with code ${b}, signal: ${C}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(te[63],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class N{constructor(...k){this._entries=new Map;for(const[A,T]of k)this.set(A,T)}set(k,A){const T=this._entries.get(k);return this._entries.set(k,A),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=N}),define(te[120],ne([0,1,8,9,2,49,115,10,63,168]),function(G,e,N,O,k,A,T,w,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class g{constructor(p=new u.ServiceCollection,f=!1,E,L=b){this._services=p,this._strict=f,this._parent=E,this._enableTracing=L,this._activeInstantiations=new Set,this._services.set(w.IInstantiationService,this),this._globalGraph=L?E?._globalGraph??new T.Graph(d=>d):void 0}createChild(p){return new g(p,this._strict,this,this._enableTracing)}invokeFunction(p,...f){const E=I.traceInvocation(this._enableTracing,p);let L=!1;try{return p({get:S=>{if(L)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(S,E);if(!r)throw new Error(`[invokeFunction] unknown service '${S}'`);return r}},...f)}finally{L=!0,E.stop()}}createInstance(p,...f){let E,L;return p instanceof A.SyncDescriptor?(E=I.traceCreation(this._enableTracing,p.ctor),L=this._createInstance(p.ctor,p.staticArguments.concat(f),E)):(E=I.traceCreation(this._enableTracing,p),L=this._createInstance(p,f,E)),E.stop(),L}_createInstance(p,f=[],E){const L=w._util.getServiceDependencies(p).sort((r,s)=>r.index-s.index),d=[];for(const r of L){const s=this._getOrCreateServiceInstance(r.id,E);s||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${r.id}.`,!1),d.push(s)}const S=L.length>0?L[0].index:f.length;if(f.length!==S){console.trace(`[createInstance] First service dependency of ${p.name} at position ${S+1} conflicts with ${f.length} static arguments`);const r=S-f.length;r>0?f=f.concat(new Array(r)):f=f.slice(0,S)}return Reflect.construct(p,f.concat(d))}_setServiceInstance(p,f){if(this._services.get(p)instanceof A.SyncDescriptor)this._services.set(p,f);else if(this._parent)this._parent._setServiceInstance(p,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const f=this._services.get(p);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):f}_getOrCreateServiceInstance(p,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const E=this._getServiceInstanceOrDescriptor(p);return E instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,E,f.branch(p,!0)):(f.branch(p,!1),E)}_safeCreateAndCacheServiceInstance(p,f,E){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,f,E)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,f,E){const L=new T.Graph(r=>r.id.toString());let d=0;const S=[{id:p,desc:f,_trace:E}];for(;S.length;){const r=S.pop();if(L.lookupOrInsertNode(r),d++>1e3)throw new C(L);for(const s of w._util.getServiceDependencies(r.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${p} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),t instanceof A.SyncDescriptor){const i={id:s.id,desc:t,_trace:r._trace.branch(s.id,!0)};L.insertEdge(r,i),S.push(i)}}}for(;;){const r=L.roots();if(r.length===0){if(!L.isEmpty())throw new C(L);break}for(const{data:s}of r){if(this._getServiceInstanceOrDescriptor(s.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}L.removeNode(s)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,f,E=[],L,d){if(this._services.get(p)instanceof A.SyncDescriptor)return this._createServiceInstance(p,f,E,L,d);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,f,E,L,d);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(p,f,E=[],L,d){if(L){const S=new g(void 0,this._strict,this,this._enableTracing);S._globalGraphImplicitDependency=String(p);const r=new Map,s=new N.IdleValue(()=>{const t=S._createInstance(f,E,d);for(const[i,n]of r){const o=t[i];if(typeof o=="function")for(const c of n)o.apply(t,c)}return r.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!s.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=r.get(i);return c||(c=new l.LinkedList,r.set(i,c)),(P,v,R)=>{const z=c.push([P,v,R]);return(0,k.toDisposable)(z)}}if(i in t)return t[i];const n=s.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),t[i]=o),o},set(t,i,n){return s.value[i]=n,!0},getPrototypeOf(t){return f.prototype}})}else return this._createInstance(f,E,d)}_throwIfStrict(p,f){if(f&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=g;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class I{static{this.all=new Set}static{this._None=new class extends I{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,f){return p?new I(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):I._None}static traceCreation(p,f){return p?new I(1,f.name):I._None}static{this._totals=0}constructor(p,f){this.type=p,this.name=f,this._start=Date.now(),this._dep=[]}branch(p,f){const E=new I(3,p.toString());return this._dep.push([p,f,E]),E}stop(){const p=Date.now()-this._start;I._totals+=p;let f=!1;function E(d,S){const r=[],s=new Array(d+1).join("	");for(const[t,i,n]of S._dep)if(i&&n){f=!0,r.push(`${s}CREATES -> ${t}`);const o=E(d+1,n);o&&r.push(o)}else r.push(`${s}uses -> ${t}`);return r.join(`
`)}const L=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(p>2||f)&&I.all.add(L.join(`
`))}}e.Trace=I});var ie=this&&this.__param||function(G,e){return function(N,O){e(N,O,G)}};define(te[64],ne([0,1,20,2,13,102,21,10]),function(G,e,N,O,k,A,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function u(b){return b.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=u,e.ILanguagePackService=(0,w.createDecorator)("languagePackService");let l=class extends O.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new N.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let g;try{g=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const I=g.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(p=>p.startsWith("lp-"))).map(y=>{const p=y.properties.localizedLanguages?.[0],f=u(y);return{...this.createQuickPickItem(f,p,y),extensionId:y.identifier.id,galleryExtension:y}});return I.push(this.createQuickPickItem("en","English")),I}createQuickPickItem(C,g,h){const I=g??C;let y;if(I!==C&&(y=`(${C})`),C.toLowerCase()===k.language.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),h?.installCount){y??="";const p=h.installCount;let f;p>1e6?f=`${Math.floor(p/1e5)/10}M`:p>1e3?f=`${Math.floor(p/1e3)}K`:f=String(p),y+=` $(cloud-download) ${f}`}return{id:C,label:I,description:y}}};e.LanguagePackBaseService=l,e.LanguagePackBaseService=l=ve([ie(0,T.IExtensionGalleryService)],l)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(G,e,N,O,k,A,T,w,u,l,b,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function h(){return new Date().toISOString()}function I(P){return(0,l.isNumber)(P)}e.isLogLevel=I;var y;(function(P){P[P.Off=0]="Off",P[P.Trace=1]="Trace",P[P.Debug=2]="Debug",P[P.Info=3]="Info",P[P.Warning=4]="Warning",P[P.Error=5]="Error"})(y||(e.LogLevel=y={})),e.DEFAULT_LOG_LEVEL=y.Info;function p(P,v,R){switch(v){case y.Trace:P.trace(R);break;case y.Debug:P.debug(R);break;case y.Info:P.info(R);break;case y.Warning:P.warn(R);break;case y.Error:P.error(R);break;case y.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=p;function f(P,v=!1){let R="";for(let z=0;z<P.length;z++){let Z=P[z];if(Z instanceof Error&&(Z=(0,N.toErrorMessage)(Z,v)),typeof Z=="object")try{Z=JSON.stringify(Z)}catch{}R+=(z>0?" ":"")+Z}return R}class E extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(v){this.level!==v&&(this.level=v,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(v){return this.level!==y.Off&&this.level<=v}}e.AbstractLogger=E;class L extends E{constructor(v){super(),this.logAlways=v}checkLogLevel(v){return this.logAlways||super.checkLogLevel(v)}trace(v,...R){this.checkLogLevel(y.Trace)&&this.log(y.Trace,f([v,...R],!0))}debug(v,...R){this.checkLogLevel(y.Debug)&&this.log(y.Debug,f([v,...R]))}info(v,...R){this.checkLogLevel(y.Info)&&this.log(y.Info,f([v,...R]))}warn(v,...R){this.checkLogLevel(y.Warning)&&this.log(y.Warning,f([v,...R]))}error(v,...R){if(this.checkLogLevel(y.Error))if(v instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=v.stack,this.log(y.Error,f(z))}else this.log(y.Error,f([v,...R]))}flush(){}}e.AbstractMessageLogger=L;class d extends E{constructor(v=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(v),this.useColors=!w.isWindows}trace(v,...R){this.checkLogLevel(y.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,v,...R):console.log(`[main ${h()}]`,v,...R))}debug(v,...R){this.checkLogLevel(y.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,v,...R):console.log(`[main ${h()}]`,v,...R))}info(v,...R){this.checkLogLevel(y.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,v,...R):console.log(`[main ${h()}]`,v,...R))}warn(v,...R){this.checkLogLevel(y.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,v,...R):console.warn(`[main ${h()}]`,v,...R))}error(v,...R){this.checkLogLevel(y.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,v,...R):console.error(`[main ${h()}]`,v,...R))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class S extends E{constructor(v=e.DEFAULT_LOG_LEVEL,R=!0){super(),this.useColors=R,this.setLevel(v)}trace(v,...R){this.checkLogLevel(y.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",v,...R):console.log(v,...R))}debug(v,...R){this.checkLogLevel(y.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",v,...R):console.log(v,...R))}info(v,...R){this.checkLogLevel(y.Info)&&(this.useColors?console.log("%c INFO","color: #33f",v,...R):console.log(v,...R))}warn(v,...R){this.checkLogLevel(y.Warning)&&(this.useColors?console.log("%c WARN","color: #993",v,...R):console.log(v,...R))}error(v,...R){this.checkLogLevel(y.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",v,...R):console.error(v,...R))}dispose(){}flush(){}}e.ConsoleLogger=S;class r extends E{constructor(v,R=e.DEFAULT_LOG_LEVEL){super(),this.adapter=v,this.setLevel(R)}trace(v,...R){this.checkLogLevel(y.Trace)&&this.adapter.log(y.Trace,[this.extractMessage(v),...R])}debug(v,...R){this.checkLogLevel(y.Debug)&&this.adapter.log(y.Debug,[this.extractMessage(v),...R])}info(v,...R){this.checkLogLevel(y.Info)&&this.adapter.log(y.Info,[this.extractMessage(v),...R])}warn(v,...R){this.checkLogLevel(y.Warning)&&this.adapter.log(y.Warning,[this.extractMessage(v),...R])}error(v,...R){this.checkLogLevel(y.Error)&&this.adapter.log(y.Error,[this.extractMessage(v),...R])}extractMessage(v){return typeof v=="string"?v:(0,N.toErrorMessage)(v,this.checkLogLevel(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=r;class s extends E{constructor(v){super(),this.loggers=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const R of this.loggers)R.setLevel(v);super.setLevel(v)}trace(v,...R){for(const z of this.loggers)z.trace(v,...R)}debug(v,...R){for(const z of this.loggers)z.debug(v,...R)}info(v,...R){for(const z of this.loggers)z.info(v,...R)}warn(v,...R){for(const z of this.loggers)z.warn(v,...R)}error(v,...R){for(const z of this.loggers)z.error(v,...R)}flush(){for(const v of this.loggers)v.flush()}dispose(){for(const v of this.loggers)v.dispose()}}e.MultiplexLogger=s;class t extends A.Disposable{constructor(v,R,z){if(super(),this.logLevel=v,this.logsHome=R,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,z)for(const Z of z)this._loggers.set(Z.resource,{logger:void 0,info:Z})}getLoggerEntry(v){return(0,l.isString)(v)?[...this._loggers.values()].find(R=>R.info.id===v):this._loggers.get(v)}getLogger(v){return this.getLoggerEntry(v)?.logger}createLogger(v,R){const z=this.toResource(v),Z=(0,l.isString)(v)?v:R?.id??(0,k.hash)(z.toString()).toString(16);let ee=this._loggers.get(z)?.logger;const oe=R?.logLevel==="always"?y.Trace:R?.logLevel;ee||(ee=this.doCreateLogger(z,oe??this.getLogLevel(z)??this.logLevel,{...R,id:Z}));const re={logger:ee,info:{resource:z,id:Z,logLevel:oe,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(re.info),this._loggers.set(z,re),ee}toResource(v){return(0,l.isString)(v)?(0,u.joinPath)(this.logsHome,`${v}.log`):v}setLogLevel(v,R){if(b.URI.isUri(v)){const z=v,Z=R,ee=this._loggers.get(z);ee&&Z!==ee.info.logLevel&&(ee.info.logLevel=Z===this.logLevel?void 0:Z,ee.logger?.setLevel(Z),this._loggers.set(ee.info.resource,ee),this._onDidChangeLogLevel.fire([z,Z]))}else{this.logLevel=v;for(const[z,Z]of this._loggers.entries())this._loggers.get(z)?.info.logLevel===void 0&&Z.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(v,R){const z=this.getLoggerEntry(v);z&&R!==!z.info.hidden&&(z.info.hidden=!R,this._loggers.set(z.info.resource,z),this._onDidChangeVisibility.fire([z.info.resource,R]))}getLogLevel(v){let R;return v&&(R=this._loggers.get(v)?.info.logLevel),R??this.logLevel}registerLogger(v){const R=this._loggers.get(v.resource);R?R.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this._loggers.set(v.resource,{info:v,logger:void 0}),this._onDidChangeLoggers.fire({added:[v],removed:[]}))}deregisterLogger(v){const R=this._loggers.get(v);R&&(R.logger&&R.logger.dispose(),this._loggers.delete(v),this._onDidChangeLoggers.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const v of this._loggers.values())yield v.info}getRegisteredLogger(v){return this._loggers.get(v)?.info}dispose(){this._loggers.forEach(v=>v.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class i{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(v){}getLevel(){return y.Info}trace(v,...R){}debug(v,...R){}info(v,...R){}warn(v,...R){}error(v,...R){}critical(v,...R){}dispose(){}flush(){}}e.NullLogger=i;class n extends i{}e.NullLogService=n;function o(P){if(P.verbose)return y.Trace;if(typeof P.logLevel=="string"){const v=D(P.logLevel.toLowerCase());if(v!==void 0)return v}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(P){switch(P){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=c;function D(P){switch(P){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new C.RawContextKey("logLevel",c(y.Info))}),define(te[121],ne([0,1,19,8,9,4,2,16,62,6]),function(G,e,N,O,k,A,T,w,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends T.Disposable{constructor(g,h){super(),this.logService=g,this.options=h,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(g,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,h):this.watchNonRecursive(g,h)}watchUniversal(g,h){const I={path:this.toFilePath(g),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},y=(0,N.insert)(this.universalPathsToWatch,I);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,k.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,u.reviveFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const h of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const h of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(h)&&g.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,h){const I={path:this.toFilePath(g),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},y=(0,N.insert)(this.nonRecursivePathsToWatch,I);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,k.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,u.reviveFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,w.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(te[122],ne([0,1,19,8,14,20,4,41,65,2,47,15,123,17,45,99,12,61,6,9]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E,L){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends l.Disposable{static{d=this}constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new T.Emitter),this._onDidUncorrelatedFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${s}`);const i=new l.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),i.add(t.onDidChangeFile(n=>{const o=new p.FileChangesEvent(n,!this.isPathCaseSensitive(t));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,l.dispose)(i)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(i){t.push(i)}}),!this.provider.has(s)&&await O.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const i=this.provider.get(s.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,h.isAbsolutePath)(s))throw new p.FileOperationError((0,y.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const i=new L.ErrorNoTelemetry;throw i.message=(0,y.localize)(1,null,s.toString()),i}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasReadWriteCapability)(t)||(0,p.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(i){throw(0,p.toFileSystemProviderErrorCode)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,y.localize)(2,null,this.resourceForError(s)),1):(0,p.ensureFileSystemProviderError)(i)}}async doResolveFile(s,t){const i=await this.withProvider(s),n=this.isPathCaseSensitive(i),o=t?.resolveTo,c=t?.resolveSingleChildDescendants,D=t?.resolveMetadata,P=await i.stat(s);let v;return this.toFileStat(i,s,P,void 0,!!D,(R,z)=>(v||(v=b.TernarySearchTree.forUris(()=>!n),v.set(s,!0),o&&v.fill(!0,o)),v.get(R.resource)||v.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&c?z===1:!1))}async toFileStat(s,t,i,n,o,c){const{providerExtUri:D}=this.getExtUri(s),P={resource:t,name:D.basename(t),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(s.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(P.isDirectory&&c(P,n)){try{const v=await s.readdir(t),R=await O.Promises.settled(v.map(async([z,Z])=>{try{const ee=D.joinPath(t,z),oe=o?await s.stat(ee):{type:Z};return await this.toFileStat(s,ee,oe,v.length,o,c)}catch(ee){return this.logService.trace(ee),null}}));P.children=(0,N.coalesce)(R)}catch(v){this.logService.trace(v),P.children=[]}return P}return P}async resolveAll(s){return O.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),i=await t.stat(s);return this.toFileStat(t,s,i,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(i){return i}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new p.FileOperationError((0,y.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(s,i);const n=await this.writeFile(s,t);return this._onDidRunOperation.fire(new p.FileOperationEvent(s,0,n)),n}async writeFile(s,t,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:o}=this.getExtUri(n);let c=i;if((0,p.hasFileAtomicWriteCapability)(n)&&!c?.atomic){const D=n.enforceAtomicWriteFile?.(s);D&&(c={...i,atomic:D})}try{await this.validateWriteFile(n,s,c)||await this.mkdirp(n,o.dirname(s));let P;if((0,p.hasReadWriteCapability)(n)&&!(t instanceof k.VSBuffer))if((0,I.isReadableStream)(t)){const v=await(0,I.peekStream)(t,3);v.ended?P=k.VSBuffer.concat(v.buffer):P=v}else P=(0,I.peekReadable)(t,v=>k.VSBuffer.concat(v),3);else P=t;!(0,p.hasOpenReadWriteCloseCapability)(n)||(0,p.hasReadWriteCapability)(n)&&P instanceof k.VSBuffer||(0,p.hasReadWriteCapability)(n)&&(0,p.hasFileAtomicWriteCapability)(n)&&c?.atomic?await this.doWriteUnbuffered(n,s,c,P):await this.doWriteBuffered(n,s,c,P instanceof k.VSBuffer?(0,k.bufferToReadable)(P):P),this._onDidRunOperation.fire(new p.FileOperationEvent(s,4))}catch(D){throw new p.FileOperationError((0,y.localize)(4,null,this.resourceForError(s),(0,p.ensureFileSystemProviderError)(D).toString()),(0,p.toFileOperationResult)(D),c)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,i){const n=!!i?.unlock;if(n&&!(s.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(t)));if(!!i?.atomic){if(!(s.capabilities&32768))throw new Error((0,y.localize)(6,null,this.resourceForError(t)));if(!(s.capabilities&2))throw new Error((0,y.localize)(7,null,this.resourceForError(t)));if(n)throw new Error((0,y.localize)(8,null,this.resourceForError(t)))}let c;try{c=await s.stat(t)}catch{return}if(c.type&p.FileType.Directory)throw new p.FileOperationError((0,y.localize)(9,null,this.resourceForError(t)),0,i);if(this.throwIfFileIsReadonly(t,c),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.ETAG_DISABLED&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==(0,p.etag)({mtime:i.mtime,size:c.size}))throw new p.FileOperationError((0,y.localize)(10,null),3,i);return c}async readFile(s,t,i){const n=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(n,s,t,i):this.doReadFile(n,s,t,i)}async doReadFileAtomic(s,t,i,n){return new Promise((o,c)=>{this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{try{const D=await this.doReadFile(s,t,i,n);o(D)}catch(D){c(D)}})})}async doReadFile(s,t,i,n){const o=await this.doReadFileStream(s,t,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(s,t,i){const n=await this.withReadProvider(s);return this.doReadFileStream(n,s,t,i)}async doReadFileStream(s,t,i,n){const o=new A.CancellationTokenSource(n);let c=i;(0,p.hasFileAtomicReadCapability)(s)&&s.enforceAtomicReadFile?.(t)&&(c={...i,atomic:!0});const D=this.validateReadFile(t,c).then(v=>v,v=>{throw o.dispose(!0),v});let P;try{return typeof c?.etag=="string"&&c.etag!==p.ETAG_DISABLED&&await D,c?.atomic&&(0,p.hasFileAtomicReadCapability)(s)||!((0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasFileReadStreamCapability)(s))||(0,p.hasReadWriteCapability)(s)&&c?.preferUnbuffered?P=this.readFileUnbuffered(s,t,c):(0,p.hasFileReadStreamCapability)(s)?P=this.readFileStreamed(s,t,o.token,c):P=this.readFileBuffered(s,t,o.token,c),P.on("end",()=>o.dispose()),P.on("error",()=>o.dispose()),{...await D,value:P}}catch(v){throw P&&await(0,I.consumeStream)(P),this.restoreReadError(v,t,c)}}restoreReadError(s,t,i){const n=(0,y.localize)(11,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(s).toString());return s instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(n,s.stat,i):s instanceof p.TooLargeFileOperationError?new p.TooLargeFileOperationError(n,s.fileOperationResult,s.size,s.options):new p.FileOperationError(n,(0,p.toFileOperationResult)(s),i)}readFileStreamed(s,t,i,n=Object.create(null)){const o=s.readFileStream(t,n,i);return(0,I.transform)(o,{data:c=>c instanceof k.VSBuffer?c:k.VSBuffer.wrap(c),error:c=>this.restoreReadError(c,t,n)},c=>k.VSBuffer.concat(c))}readFileBuffered(s,t,i,n=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,f.readFileIntoStream)(s,t,o,c=>c,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>this.restoreReadError(c,t,n)},i),o}readFileUnbuffered(s,t,i){const n=(0,I.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,p.hasFileAtomicReadCapability)(s)?o=await s.readFile(t,{atomic:!0}):o=await s.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.validateReadFileLimits(t,o.byteLength,i),n.end(k.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async validateReadFile(s,t){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new p.FileOperationError((0,y.localize)(12,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==p.ETAG_DISABLED&&t.etag===i.etag)throw new p.NotModifiedSinceFileOperationError((0,y.localize)(13,null),i,t);return this.validateReadFileLimits(s,i.size,t),i}validateReadFileLimits(s,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new p.TooLargeFileOperationError((0,y.localize)(14,null,this.resourceForError(s)),7,t,i)}async canMove(s,t,i){return this.doCanMoveCopy(s,t,"move",i)}async canCopy(s,t,i){return this.doCanMoveCopy(s,t,"copy",i)}async doCanMoveCopy(s,t,i,n){if(s.toString()!==t.toString())try{const o=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(o,s,c,t,i,n)}catch(o){return o}return!0}async move(s,t,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(n,s,o,t,"move",!!i),D=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,c==="move"?2:3,D)),D}async copy(s,t,i){const n=await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(n,s,o,t,"copy",!!i),D=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,c==="copy"?3:2,D)),D}async doMoveCopy(s,t,i,n,o,c){if(t.toString()===n.toString())return o;const{exists:D,isSameResourceWithDifferentPathCase:P}=await this.doValidateMoveCopy(s,t,i,n,o,c);if(D&&!P&&c&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),o==="copy"){if(s===i&&(0,p.hasFileFolderCopyCapability)(s))await s.copy(t,n,{overwrite:c});else{const v=await this.resolve(t);v.isDirectory?await this.doCopyFolder(s,v,i,n):await this.doCopyFile(s,t,i,n)}return o}else return s===i?(await s.rename(t,n,{overwrite:c}),o):(await this.doMoveCopy(s,t,i,n,"copy",c),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,i,n){if((0,p.hasOpenReadWriteCloseCapability)(s)&&(0,p.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(s,t,i,n);if((0,p.hasOpenReadWriteCloseCapability)(s)&&(0,p.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(s,t,i,n);if((0,p.hasReadWriteCapability)(s)&&(0,p.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(s,t,i,n);if((0,p.hasReadWriteCapability)(s)&&(0,p.hasReadWriteCapability)(i))return this.doPipeUnbuffered(s,t,i,n)}async doCopyFolder(s,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await O.Promises.settled(t.children.map(async o=>{const c=this.getExtUri(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.doCopyFolder(s,await this.resolve(o.resource),i,c):this.doCopyFile(s,o.resource,i,c)}))}async doValidateMoveCopy(s,t,i,n,o,c){let D=!1;if(s===i){const{providerExtUri:v,isPathCaseSensitive:R}=this.getExtUri(s);if(R||(D=v.isEqual(t,n)),D&&o==="copy")throw new Error((0,y.localize)(15,null,this.resourceForError(t),this.resourceForError(n)));if(!D&&v.isEqualOrParent(n,t))throw new Error((0,y.localize)(16,null,this.resourceForError(t),this.resourceForError(n)))}const P=await this.exists(n);if(P&&!D){if(!c)throw new p.FileOperationError((0,y.localize)(17,null,this.resourceForError(t),this.resourceForError(n)),4);if(s===i){const{providerExtUri:v}=this.getExtUri(s);if(v.isEqualOrParent(t,n))throw new Error((0,y.localize)(18,null,this.resourceForError(t),this.resourceForError(n)))}}return{exists:P,isSameResourceWithDifferentPathCase:D}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const i=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,0,i)),i}async mkdirp(s,t){const i=[],{providerExtUri:n}=this.getExtUri(s);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await s.stat(t)).type&p.FileType.Directory))throw new Error((0,y.localize)(19,null,this.resourceForError(t)));break}catch(o){if((0,p.toFileSystemProviderErrorCode)(o)!==p.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(t)),t=n.dirname(t)}for(let o=i.length-1;o>=0;o--){t=n.joinPath(t,i[o]);try{await s.mkdir(t)}catch(c){if((0,p.toFileSystemProviderErrorCode)(c)!==p.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(i){return i}return!0}async doValidateDelete(s,t){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.resourceForError(s)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.resourceForError(s)));if(n&&o)throw new Error((0,y.localize)(22,null,this.resourceForError(s)));let c;try{c=await i.stat(s)}catch{}if(c)this.throwIfFileIsReadonly(s,c);else throw new p.FileOperationError((0,y.localize)(23,null,this.resourceForError(s)),1);if(!!!t?.recursive){const P=await this.resolve(s);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,y.localize)(24,null,this.resourceForError(s)))}return i}async del(s,t){const i=await this.doValidateDelete(s,t);let n=t;if((0,p.hasFileAtomicDeleteCapability)(i)&&!n?.atomic){const P=i.enforceAtomicDelete?.(s);P&&(n={...t,atomic:P})}const o=!!n?.useTrash,c=!!n?.recursive,D=n?.atomic??!1;await i.delete(s,{recursive:c,useTrash:o,atomic:D}),this._onDidRunOperation.fire(new p.FileOperationEvent(s,1))}async cloneFile(s,t){const i=await this.withProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(i===n&&this.getExtUri(i).providerExtUri.isEqual(s,t))return;if(i===n&&(0,p.hasFileCloneCapability)(i))return i.cloneFile(s,t);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t));const o=this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri);return i===n&&(0,p.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(s,t,{overwrite:!0})):o.queue(()=>this.doCopyFile(i,s,n,t))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(s,t){return this.watch(s,{...t,correlationId:d.WATCHER_CORRELATION_IDS++})}watch(s,t={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let n=!1,o=()=>{n=!0};i.add((0,l.toDisposable)(()=>o())),(async()=>{try{const D=await this.doWatch(s,t);n?(0,l.dispose)(D):o=()=>(0,l.dispose)(D)}catch(D){this.logService.error(D)}})();const c=t.correlationId;if(typeof c=="number"){const D=i.add(new T.Emitter);return i.add(this.internalOnDidFilesChange.event(v=>{v.correlates(c)&&D.fire(v)})),{onDidChange:D.event,dispose:()=>i.dispose()}}return i}async doWatch(s,t){const i=await this.withProvider(s),n=(0,w.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(s),t]);let o=this.activeWatchers.get(n);return o||(o={count:0,disposable:i.watch(s,t)},this.activeWatchers.set(n,o)),o.count+=1,(0,l.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,l.dispose)(o.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,l.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,i,n){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{const o=await s.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,I.isReadableStream)(n)||(0,I.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(s,o,n):await this.doWriteReadableBufferedQueued(s,o,n)}catch(c){throw(0,p.ensureFileSystemProviderError)(c)}finally{await s.close(o)}})}async doWriteStreamBufferedQueued(s,t,i){let n=0,o;if((0,I.isReadableBufferedStream)(i)){if(i.buffer.length>0){const c=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(s,t,c,c.byteLength,n,0),n+=c.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((c,D)=>{(0,I.listenStream)(o,{onData:async P=>{o.pause();try{await this.doWriteBuffer(s,t,P,P.byteLength,n,0)}catch(v){return D(v)}n+=P.byteLength,setTimeout(()=>o.resume())},onError:P=>D(P),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(s,t,i){let n=0,o;for(;(o=i.read())!==null;)await this.doWriteBuffer(s,t,o,o.byteLength,n,0),n+=o.byteLength}async doWriteBuffer(s,t,i,n,o,c){let D=0;for(;D<n;){const P=await s.write(t,o+D,i.buffer,c+D,n-D);D+=P}}async doWriteUnbuffered(s,t,i,n){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,t,i,n))}async doWriteUnbufferedQueued(s,t,i,n){let o;n instanceof k.VSBuffer?o=n:(0,I.isReadableStream)(n)?o=await(0,k.streamToBuffer)(n):(0,I.isReadableBufferedStream)(n)?o=await(0,k.bufferedStreamToBuffer)(n):o=(0,k.readableToBuffer)(n),await s.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(s,t,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,t,i,n))}async doPipeBufferedQueued(s,t,i,n){let o,c;try{o=await s.open(t,{create:!1}),c=await i.open(n,{create:!0,unlock:!1});const D=k.VSBuffer.alloc(this.BUFFER_SIZE);let P=0,v=0,R=0;do R=await s.read(o,P,D.buffer,v,D.byteLength-v),await this.doWriteBuffer(i,c,D,R,P,v),P+=R,v+=R,v===D.byteLength&&(v=0);while(R>0)}catch(D){throw(0,p.ensureFileSystemProviderError)(D)}finally{await O.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof c=="number"?i.close(c):Promise.resolve()])}}async doPipeUnbuffered(s,t,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,t,i,n))}async doPipeUnbufferedQueued(s,t,i,n){return i.writeFile(n,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(s,t,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,t,i,n))}async doPipeUnbufferedToBufferedQueued(s,t,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const c=await s.readFile(t);await this.doWriteBuffer(i,o,k.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,p.ensureFileSystemProviderError)(c)}finally{await i.close(o)}}async doPipeBufferedToUnbuffered(s,t,i,n){const o=await(0,k.streamToBuffer)(this.readFileBuffered(s,t,A.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,o)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new p.FileOperationError((0,y.localize)(25,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,y.localize)(26,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===C.Schemas.file?s.fsPath:s.toString(!0)}};e.FileService=S,e.FileService=S=d=ve([ie(0,E.ILogService)],S)}),define(te[124],ne([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E,L,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(N)}catch(s){console.error(`Error enabling graceful-fs: ${(0,L.toErrorMessage)(s)}`)}})();class r extends E.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=w.Event.None,this.resourceLocks=new A.ResourceMap(n=>g.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:n}=await I.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await I.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,g.joinPath)(t,o.name))).type:c=this.toType(o),n.push([o.name,c])}catch(c){this.logService.trace(c)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let n;return i?.dangling?n=p.FileType.Unknown:t.isFile()?n=p.FileType.File:t.isDirectory()?n=p.FileType.Directory:n=p.FileType.Unknown,i&&(n|=p.FileType.SymbolicLink),n}async createResourceLock(t){const i=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new k.Barrier;return this.resourceLocks.set(t,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),n=await this.createResourceLock(t));const o=this.toFilePath(t);return await I.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{n?.dispose()}}traceLock(t){r.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,i,n){const o=(0,h.newWriteableStream)(c=>T.VSBuffer.concat(c.map(D=>T.VSBuffer.wrap(D))).buffer);return(0,f.readFileIntoStream)(this,t,o,c=>c.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,g.joinPath)((0,g.dirname)(t),`${(0,g.basename)(t)}${n.atomic.postfix}`),i,n):this.doWriteFile(t,i,n)}async canWriteFileAtomic(t){try{const i=this.toFilePath(t),{symbolicLink:n}=await I.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(t,i,n,o){const c=new l.DisposableStore;try{c.add(await this.createResourceLock(t)),c.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(D){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{c.dispose()}}async doWriteFile(t,i,n,o){let c;try{const D=this.toFilePath(t);if(!n.create||!n.overwrite){if(await I.Promises.exists(D)){if(!n.overwrite)throw(0,p.createFileSystemProviderError)((0,y.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,p.createFileSystemProviderError)((0,y.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:n.unlock},o),await this.write(c,0,i,0,i.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(t,D)}finally{typeof c=="number"&&await this.close(c)}}static{this.canFlush=!0}static configureFlushOnWrite(t){r.canFlush=t}async open(t,i,n){const o=this.toFilePath(t);let c;(0,p.isFileOpenForWriteOptions)(i)&&!n&&(c=await this.createResourceLock(t));let D;try{if((0,p.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:v}=await I.SymlinkSupport.stat(o);v.mode&128||await I.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}let P;if((0,p.isFileOpenForWriteOptions)(i)){if(C.isWindows)try{await I.Promises.truncate(o,0),P="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}P||(P="w")}else P="r";D=await I.Promises.open(o,P)}catch(P){throw c?.dispose(),(0,p.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(D,0),(0,p.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(D,t),c){const P=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${o})`),this.mapHandleToLock.set(D,c),P&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${o})`),P.dispose())}return D}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&r.canFlush)try{await I.Promises.fdatasync(t)}catch(n){r.configureFlushOnWrite(!1),this.logService.error(n)}return await I.Promises.close(t)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,o,c){const D=this.normalizePos(t,i);let P=null;try{P=(await I.Promises.read(t,n,o,c,D)).bytesRead}catch(v){throw this.toFileSystemProviderError(v)}finally{this.updatePos(t,D,P)}return P}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,n){const o=this.mapHandleToPos.get(t);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(t,o+n):this.mapHandleToPos.delete(t)))}async write(t,i,n,o,c){return(0,k.retry)(()=>this.doWrite(t,i,n,o,c),100,3)}async doWrite(t,i,n,o,c){const D=this.normalizePos(t,i);let P=null;try{P=(await I.Promises.write(t,n,o,c,D)).bytesWritten}catch(v){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),v)}finally{this.updatePos(t,D,P)}return P}async mkdir(t){try{await I.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const n=this.toFilePath(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,b.join)((0,b.dirname)(n),`${(0,b.basename)(n)}${i.atomic.postfix}`)),await I.Promises.rm(n,I.RimRafMode.MOVE,o)}else try{await I.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let c=!1;try{const{stat:D,symbolicLink:P}=await I.SymlinkSupport.stat(n);c=D.isDirectory()&&!P}catch{}if(c)await I.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(t,i,n){const o=this.toFilePath(t),c=this.toFilePath(i);if(o!==c)try{await this.validateMoveCopy(t,i,"move",n.overwrite),await I.Promises.rename(o,c)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,y.localize)(2,null,(0,b.basename)(o),(0,b.basename)((0,b.dirname)(c)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(t,i,n){const o=this.toFilePath(t),c=this.toFilePath(i);if(o!==c)try{await this.validateMoveCopy(t,i,"copy",n.overwrite),await I.Promises.copy(o,c,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,y.localize)(3,null,(0,b.basename)(o),(0,b.basename)((0,b.dirname)(c)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(t,i,n,o){const c=this.toFilePath(t),D=this.toFilePath(i);let P=!1;if(!!(this.capabilities&1024)||(P=(0,u.isEqual)(c,D,!0)),P){if(n==="copy")throw(0,p.createFileSystemProviderError)((0,y.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.statIgnoreError(t);if(!R)throw(0,p.createFileSystemProviderError)((0,y.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const z=await this.statIgnoreError(i);if(z){if(!o)throw(0,p.createFileSystemProviderError)((0,y.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);R.type&p.FileType.File&&z.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,n){const o=this.toFilePath(t),c=this.toFilePath(i),D=!!(this.capabilities&1024);if((0,u.isEqual)(o,c,!D))return;const P=new l.DisposableStore;try{P.add(await this.createResourceLock(t)),P.add(await this.createResourceLock(i)),n&&await I.Promises.mkdir((0,b.dirname)(c),{recursive:!0}),await I.Promises.copyFile(o,c)}catch(v){if(v.code==="ENOENT"&&!n)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(v)}finally{P.dispose()}}createUniversalWatcher(t,i,n){return new d.UniversalWatcherClient(o=>t(o),o=>i(o),n)}createNonRecursiveWatcher(t,i,n){return new S.NodeJSWatcherClient(o=>t(o),o=>i(o),n)}toFileSystemProviderError(t){if(t instanceof p.FileSystemProviderError)return t;let i=t,n;switch(t.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=p.FileSystemProviderErrorCode.Unknown;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(t,i){let n=this.toFileSystemProviderError(i);if(t&&n.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await I.SymlinkSupport.stat(this.toFilePath(t));o.mode&128||(n=(0,p.createFileSystemProviderError)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}e.DiskFileSystemProvider=r}),define(te[126],ne([0,1,2,6]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends N.Disposable{constructor(T,w=[]){super(),this.logger=new O.MultiplexLogger([T,...w]),this._register(T.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...w){this.logger.trace(T,...w)}debug(T,...w){this.logger.debug(T,...w)}info(T,...w){this.logger.info(T,...w)}warn(T,...w){this.logger.warn(T,...w)}error(T,...w){this.logger.error(T,...w)}flush(){this.logger.flush()}}e.LogService=k}),define(te[127],ne([0,1,12,6]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(k||(k={}));async function A(l,b,C,g,h){try{const I=await new Promise((p,f)=>{G(["@vscode/spdlog"],p,f)});I.setFlushOn(k.Trace);const y=await I.createAsyncRotatingLogger(l,b,C,g);return h?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(I){console.error(I)}return null}function T(l,b,C){switch(b){case O.LogLevel.Trace:l.trace(C);break;case O.LogLevel.Debug:l.debug(C);break;case O.LogLevel.Info:l.info(C);break;case O.LogLevel.Warning:l.warn(C);break;case O.LogLevel.Error:l.error(C);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function w(l,b){switch(b){case O.LogLevel.Trace:l.setLevel(k.Trace);break;case O.LogLevel.Debug:l.setLevel(k.Debug);break;case O.LogLevel.Info:l.setLevel(k.Info);break;case O.LogLevel.Warning:l.setLevel(k.Warning);break;case O.LogLevel.Error:l.setLevel(k.Error);break;case O.LogLevel.Off:l.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class u extends O.AbstractMessageLogger{constructor(b,C,g,h,I){super(),this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(b,C,g,h),this._register(this.onDidChangeLogLevel(y=>{this._logger&&w(this._logger,y)}))}async _createSpdLogLogger(b,C,g,h){const I=g?6:1,y=30/I*N.ByteSize.MB,p=await A(b,C,y,I,h);if(p){this._logger=p,w(this._logger,this.getLevel());for(const{level:f,message:E}of this.buffer)T(this._logger,f,E);this.buffer=[]}}log(b,C){this._logger?T(this._logger,b,C):this.getLevel()<=b&&this.buffer.push({level:b,message:C})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=u}),define(te[128],ne([0,1,28,6,127]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends O.AbstractLoggerService{doCreateLogger(w,u,l){return new k.SpdLogLogger((0,N.generateUuid)(),w.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.LoggerService=A}),define(te[38],ne([0,1,4,65,2,10]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class T extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new N.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),O.Iterable.reduce(this.policies.entries(),(C,[g,h])=>({...C,[g]:h}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[b,C])=>({...l,[b]:{definition:C,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=T;class w{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=w}),define(te[129],ne([0,1,8,4,65,3,12,6,38]),function(G,e,N,O,k,A,T,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(C,g){const h=[];for(const I of new Set(k.Iterable.concat(C.keys(),g.keys())))C.get(I)!==g.get(I)&&h.push(I);return h}let b=class extends u.AbstractPolicyService{constructor(g,h,I){super(),this.file=g,this.fileService=h,this.logService=I,this.throttledDelayer=this._register(new N.ThrottledDelayer(500));const y=O.Event.filter(h.onDidFilesChange,p=>p.affects(g));this._register(h.watch(g)),this._register(y(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const g=new Map;try{const h=await this.fileService.readFile(this.file),I=JSON.parse(h.value.toString());if(!(0,A.isObject)(I))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(I))this.policyDefinitions[y]&&g.set(y,I[y])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return g}async refresh(){const g=await this.read(),h=l(this.policies,g);this.policies=g,h.length>0&&this._onDidChange.fire(h)}};e.FilePolicyService=b,e.FilePolicyService=b=ve([ie(1,T.IFileService),ie(2,w.ILogService)],b)}),define(te[130],ne([0,1,38,8,171,2,6]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let w=class extends N.AbstractPolicyService{constructor(l,b){super(),this.logService=l,this.productName=b,this.throttler=new O.Throttler,this.watcher=this._register(new A.MutableDisposable)}async _updatePolicyDefinitions(l){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.throttler.queue(()=>new Promise((b,C)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,l,g=>{this._onDidPolicyChange(g),b()})}catch(g){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),C(g)}}))}_onDidPolicyChange(l){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const b in l){const C=l[b];C===void 0?this.policies.delete(b):this.policies.set(b,C)}this._onDidChange.fire(Object.keys(l))}};e.NativePolicyService=w,e.NativePolicyService=w=ve([ie(0,T.ILogService)],w)}),define(te[32],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,N.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,w){N.ok(O.isString(T)),N.ok(O.isObject(w)),N.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,w)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(te[131],ne([0,1,4,36]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class A{constructor(){this._onDidChangeSchema=new N.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,l){this.schemasById[k(u)]=l,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;O.Registry.add(e.Extensions.JSONContribution,T)}),define(te[43],ne([0,1,19,4,3,88,25,131,36]),function(G,e,N,O,k,A,T,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=u.Registry.as(w.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const t=new Set;this.doRegisterConfigurations(r,s,t),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(r){const s=new Set;this.doDeregisterConfigurations(r,s),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:r,remove:s}){const t=new Set;this.doDeregisterConfigurations(s,t),this.doRegisterConfigurations(r,!1,t),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(r){const s=new Set;this.doRegisterDefaultConfigurations(r,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(r,s){const t=[];for(const{overrides:i,source:n}of r)for(const o in i)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.configurationDefaultsOverrides.get(o),D=c?.valuesSources??new Map;if(n)for(const z of Object.keys(i[o]))D.set(z,n);const P={...c?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:n,value:P,valuesSources:D});const v=(0,T.getLanguageTagSettingPlainKey)(o),R={type:"object",default:P,description:A.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:k.isString(n)?void 0:n,defaultValueSource:n};t.push(...y(o)),this.configurationProperties[o]=R,this.defaultLanguageConfigurationOverridesNode.properties[o]=R}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:n});const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(r){const s=new Set;this.doDeregisterDefaultConfigurations(r,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(r,s){for(const{overrides:t,source:i}of r)for(const n in t){const o=this.configurationDefaultsOverrides.get(n),c=k.isString(i)?i:i?.id,D=k.isString(o?.source)?o?.source:o?.source?.id;if(c===D)if(s.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const P=this.configurationProperties[n];P&&(this.updatePropertyDefaultValue(n,P),this.updateSchema(n,P))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(r){let s=!1;const t=new Set;r.removedDefaults&&(this.doDeregisterDefaultConfigurations(r.removedDefaults,t),s=!0),r.addedDefaults&&(this.doRegisterDefaultConfigurations(r.addedDefaults,t),s=!0),r.removedConfigurations&&this.doDeregisterConfigurations(r.removedConfigurations,t),r.addedConfigurations&&this.doRegisterConfigurations(r.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){this.doRegisterOverrideIdentifiers(r),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(r){for(const s of r)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,s,t){r.forEach(i=>{this.validateAndRegisterProperties(i,s,i.extensionInfo,i.restrictedProperties,void 0,t),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(r,s){const t=i=>{if(i.properties)for(const n in i.properties){s.add(n);const o=this.configurationProperties[n];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of r){t(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(r,s=!0,t,i,n=3,o){n=k.isUndefinedOrNull(r.scope)?n:r.scope;const c=r.properties;if(c)for(const P in c){const v=c[P];if(s&&L(P,v)){delete c[P];continue}if(v.source=t,v.defaultDefaultValue=c[P].default,this.updatePropertyDefaultValue(P,v),e.OVERRIDE_PROPERTY_REGEX.test(P)?v.scope=void 0:(v.scope=k.isUndefinedOrNull(v.scope)?n:v.scope,v.restricted=k.isUndefinedOrNull(v.restricted)?!!i?.includes(P):v.restricted),c[P].hasOwnProperty("included")&&!c[P].included){this.excludedConfigurationProperties[P]=c[P],delete c[P];continue}else this.configurationProperties[P]=c[P],c[P].policy?.name&&this.policyConfigurations.set(c[P].policy.name,P);!c[P].deprecationMessage&&c[P].markdownDeprecationMessage&&(c[P].deprecationMessage=c[P].markdownDeprecationMessage),o.add(P)}const D=r.allOf;if(D)for(const P of D)this.validateAndRegisterProperties(P,s,t,i,n,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const s=t=>{const i=t.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);t.allOf?.forEach(s)};s(r)}updateSchema(r,s){switch(e.allSettings.properties[r]=s,s.scope){case 1:e.applicationSettings.properties[r]=s;break;case 2:e.machineSettings.properties[r]=s;break;case 6:e.machineOverridableSettings.properties[r]=s;break;case 3:e.windowSettings.properties[r]=s;break;case 4:e.resourceSettings.properties[r]=s;break;case 5:e.resourceSettings.properties[r]=s,this.resourceLanguageSettingsSchema.properties[r]=s;break}}removeFromSchema(r,s){switch(delete e.allSettings.properties[r],s.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const s=`[${r}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}}registerOverridePropertyPatternKey(){const r={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,s){const t=this.configurationDefaultsOverrides.get(r);let i=t?.value,n=t?.source;k.isUndefined(i)&&(i=s.defaultDefaultValue,n=void 0),k.isUndefined(i)&&(i=f(s.type)),s.default=i,s.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",I=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(S){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let s=I.exec(S);for(;s?.length;){const t=s[1].trim();t&&r.push(t),s=I.exec(S)}}return(0,N.distinct)(r)}e.overrideIdentifiersFromKey=y;function p(S){return S.reduce((r,s)=>`${r}[${s}]`,"")}e.keyFromOverrideIdentifiers=p;function f(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const E=new g;u.Registry.add(e.Extensions.Configuration,E);function L(S,r){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?A.localize(7,null,S):E.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):r.policy?.name&&E.getPolicyConfigurations().get(r.policy?.name)!==void 0?A.localize(9,null,S,r.policy?.name,E.getPolicyConfigurations().get(r.policy?.name)):null:A.localize(6,null)}e.validateProperty=L;function d(){const S=[],r=E.getConfigurationProperties();for(const s of Object.keys(r))S.push([s,r[s].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=d}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(G,e,N,O,k,A,T,w,u,l,b,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(s){return Object.isFrozen(s)?s:w.deepFreeze(s)}class I{constructor(t={},i=[],n=[],o){this._contents=t,this._keys=i,this._overrides=n,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof I)return i;const n=new y("");return n.parseRaw(i),n.configurationModel});this._rawConfiguration=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,b.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),o=i?this.rawConfiguration.getOverrideValue(t,i):void 0,c=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:o,merged:c}}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?(0,b.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return N.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return N.distinct(t)}override(t){let i=this.overrideConfigurations.get(t);return i||(i=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,i)),i}merge(...t){const i=w.deepClone(this.contents),n=w.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const D of t)if(c.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(i,D.contents);for(const P of D.overrides){const[v]=n.filter(R=>N.equals(R.identifiers,P.identifiers));v?(this.mergeContents(v.contents,P.contents),v.keys.push(...P.keys),v.keys=N.distinct(v.keys)):n.push(w.deepClone(P))}for(const P of D.keys)o.indexOf(P)===-1&&o.push(P)}return new I(i,o,n,c.every(D=>D instanceof I)?void 0:c)}createOverrideConfigurationModel(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of N.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const D=i[o];D&&(typeof c=="object"&&typeof D=="object"?(c=w.deepClone(c),this.mergeContents(c,D)):c=D),n[o]=c}return new I(n,this.keys,this.overrides)}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&u.isObject(t[n])&&u.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=w.deepClone(i[n])}}getContentsForOverrideIdentifer(t){let i=null,n=null;const o=c=>{c&&(n?this.mergeContents(n,c):n=w.deepClone(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===t?i=c.contents:c.identifiers.includes(t)&&o(c.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.updateValue(t,i,!0)}setValue(t,i){this.updateValue(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,b.removeFromValueTree)(this.contents,t),C.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>N.equals(n.identifiers,(0,C.overrideIdentifiersFromKey)(t))),1))}updateValue(t,i,n){(0,b.addToValueTree)(this.contents,t,i,o=>console.error(o)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),C.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,C.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,b.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=I;class y{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!u.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:o,overrides:c,restricted:D,hasExcludedProperties:P}=this.doParseRaw(t,i);this._configurationModel=new I(n,o,c,P?[t]:void 0),this._restrictedConfigurations=D||[]}doParseContent(t){let i={},n=null,o=[];const c=[],D=[];function P(R){Array.isArray(o)?o.push(R):n!==null&&(o[n]=R)}const v={onObjectBegin:()=>{const R={};P(R),c.push(o),o=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const R=[];P(R),c.push(o),o=R,n=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:P,onError:(R,z,Z)=>{D.push({error:R,offset:z,length:Z})}};if(t)try{k.visit(t,v),i=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return i}doParseRaw(t,i){const n=g.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,n,!0,i);t=o.raw;const c=(0,b.toValuesTree)(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),D=Object.keys(t),P=this.toOverrides(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:c,keys:D,overrides:P,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,i,n,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:c};const D={},P=[];for(const v in t)if(C.OVERRIDE_PROPERTY_REGEX.test(v)&&n){const R=this.filter(t[v],i,!1,o);D[v]=R.raw,c=c||R.hasExcludedProperties,P.push(...R.restricted)}else{const R=i[v],z=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&P.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(z===void 0||o.scopes===void 0||o.scopes.includes(z))&&!(o.skipRestricted&&R?.restricted))?D[v]=t[v]:c=!0}return{raw:D,restricted:P,hasExcludedProperties:c}}toOverrides(t,i){const n=[];for(const o of Object.keys(t))if(C.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const D in t[o])c[D]=t[o][D];n.push({identifiers:(0,C.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,b.toValuesTree)(c,i)})}return n}}e.ConfigurationModelParser=y;class p extends A.Disposable{constructor(t,i,n,o){super(),this.userSettingsResource=t,this.parseOptions=i,this.fileService=o,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&n.isEqual(c.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class f{constructor(t,i,n,o,c,D,P,v,R,z,Z,ee,oe){this.key=t,this.overrides=i,this._value=n,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=D,this.applicationConfiguration=P,this.userConfiguration=v,this.localUserConfiguration=R,this.remoteUserConfiguration=z,this.workspaceConfiguration=Z,this.folderConfigurationModel=ee,this.memoryConfigurationModel=oe}get value(){return h(this._value)}inspect(t,i,n){const o=t.inspect(i,n);return{get value(){return h(o.value)},get override(){return h(o.override)},get merged(){return h(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class E{constructor(t,i,n,o,c=new I,D=new I,P=new T.ResourceMap,v=new I,R=new T.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=D,this._folderConfigurations=P,this._memoryConfiguration=v,this._memoryConfigurationByResource=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidatedConfigurationModel(t,i,n).getValue(t)}updateValue(t,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new I,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const o=this.getConsolidatedConfigurationModel(t,i,n),c=this.getFolderConfigurationModelForResource(i.resource,n),D=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=new Set;for(const v of o.overrides)for(const R of v.identifiers)o.getOverrideValue(t,R)!==void 0&&P.add(R);return new f(t,i,o.getValue(t),P.size?[...P]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,c||void 0,D)}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:o,updated:c,removed:D}=S(this._defaultConfiguration,t);i=[...o,...c,...D]}for(const o of i)for(const c of(0,C.overrideIdentifiersFromKey)(o)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(c),P=t.getKeysForOverrideIdentifier(c),v=[...P.filter(R=>D.indexOf(R)===-1),...D.filter(R=>P.indexOf(R)===-1),...D.filter(R=>!w.equals(this._defaultConfiguration.override(c).getValue(R),t.override(c).getValue(R)))];n.push([c,v])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:o}=S(this._policyConfiguration,t),c=[...i,...n,...o];return c.length&&this.updatePolicyConfiguration(t),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:o,overrides:c}=S(this.applicationConfiguration,t),D=[...i,...n,...o];return D.length&&this.updateApplicationConfiguration(t),{keys:D,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:c}=S(this.localUserConfiguration,t),D=[...i,...n,...o];return D.length&&this.updateLocalUserConfiguration(t),{keys:D,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:c}=S(this.remoteUserConfiguration,t),D=[...i,...n,...o];return D.length&&this.updateRemoteUserConfiguration(t),{keys:D,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:o,overrides:c}=S(this.workspaceConfiguration,t),D=[...i,...n,...o];return D.length&&this.updateWorkspaceConfiguration(t),{keys:D,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:o,updated:c,removed:D,overrides:P}=S(n,i),v=[...o,...c,...D];return(v.length||!n)&&this.updateFolderConfiguration(t,i),{keys:v,overrides:P}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:o,removed:c,overrides:D}=S(i,void 0);return{keys:[...n,...o,...c],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const c=this._memoryConfigurationByResource.get(t);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=n.merge(o),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:o,keys:c}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this._workspaceConfiguration.keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.policy),o=this.parseConfigurationModel(t.application),c=this.parseConfigurationModel(t.user),D=this.parseConfigurationModel(t.workspace),P=t.folders.reduce((v,R)=>(v.set(l.URI.revive(R[0]),this.parseConfigurationModel(R[1])),v),new T.ResourceMap);return new E(i,n,o,c,new I,D,P,new I,new T.ResourceMap)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides)}}e.Configuration=E;function L(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const o of s)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,D])=>{const P=(0,T.getOrSet)(i,c,new Set);D.forEach(v=>P.add(v))});const n=[];return i.forEach((o,c)=>n.push([c,[...o.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=L;class d{constructor(t,i,n,o){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of t.keys)this.affectedKeys.add(c);for(const[,c]of t.overrides)for(const D of c)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){const n=this._marker+t,o=this._affectsConfigStr.indexOf(n);if(o<0)return!1;const c=o+n.length;if(c>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(c);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(i){const P=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.previous?.workspace):void 0,v=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!w.equals(P,v)}return!0}}e.ConfigurationChangeEvent=d;function S(s,t){const{added:i,removed:n,updated:o}=r(t?.rawConfiguration,s?.rawConfiguration),c=[],D=s?.getAllOverrideIdentifiers()||[],P=t?.getAllOverrideIdentifiers()||[];if(t){const v=P.filter(R=>!D.includes(R));for(const R of v)c.push([R,t.getKeysForOverrideIdentifier(R)])}if(s){const v=D.filter(R=>!P.includes(R));for(const R of v)c.push([R,s.getKeysForOverrideIdentifier(R)])}if(t&&s){for(const v of D)if(P.includes(v)){const R=r({contents:s.getOverrideValue(void 0,v)||{},keys:s.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});c.push([v,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:n,updated:o,overrides:c}}function r(s,t){const i=s?t?s.keys.filter(c=>t.keys.indexOf(c)===-1):[...s.keys]:[],n=t?s?t.keys.filter(c=>s.keys.indexOf(c)===-1):[...t.keys]:[],o=[];if(s&&t){for(const c of t.keys)if(s.keys.indexOf(c)!==-1){const D=(0,b.getConfigurationValue)(t.contents,c),P=(0,b.getConfigurationValue)(s.contents,c);w.equals(D,P)||o.push(c)}}return{added:i,removed:n,updated:o}}}),define(te[132],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(G,e,N,O,k,A,T,w,u,l,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new w.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(C.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:f})=>this.onDidUpdateConfiguration(Array.from(p),f))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(p,f){this.updateConfigurationModel(p,C.Registry.as(u.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new w.ConfigurationModel;const p=C.Registry.as(u.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(p),p)}updateConfigurationModel(p,f){const E=this.getConfigurationDefaultOverrides();for(const L of p){const d=E[L],S=f[L];d!==void 0?this._configurationModel.addValue(L,d):S?this._configurationModel.addValue(L,S.default):this._configurationModel.removeValue(L)}}}e.DefaultConfiguration=g;class h{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let I=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(p,f,E){super(),this.defaultConfiguration=p,this.policyService=f,this.logService=E,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new w.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.updatePolicyDefinitions(p),!0))),this._configurationModel}async updatePolicyDefinitions(p){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",p);const f={},E=[],L=C.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const d of p){const S=L[d];if(!S){E.push(d);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.logService.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}E.push(d),f[S.policy.name]={type:S.type}}}return(0,T.isEmptyObject)(f)||await this.policyService.updatePolicyDefinitions(f),E}onDidChangePolicies(p){this.logService.trace("PolicyConfiguration#onDidChangePolicies",p);const f=C.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),E=(0,N.coalesce)(p.map(L=>f.get(L)));this.update(E,!0)}update(p,f){this.logService.trace("PolicyConfiguration#update",p);const E=C.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),L=[],d=this._configurationModel.isEmpty();for(const S of p){const r=E[S]?.policy?.name;if(r){const s=this.policyService.getPolicyValue(r);(d?s!==void 0:!(0,A.equals)(this._configurationModel.getValue(S),s))&&L.push([S,s])}else this._configurationModel.getValue(S)!==void 0&&L.push([S,void 0])}if(L.length){this.logService.trace("PolicyConfiguration#changed",L);const S=this._configurationModel;this._configurationModel=new w.ConfigurationModel;for(const r of S.keys)this._configurationModel.setValue(r,S.getValue(r));for(const[r,s]of L)s===void 0?this._configurationModel.removeValue(r):this._configurationModel.setValue(r,s);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=I,e.PolicyConfiguration=I=ve([ie(1,b.IPolicyService),ie(2,l.ILogService)],I)}),define(te[133],ne([0,1,8,4,2,17,25,66,132,38]),function(G,e,N,O,k,A,T,w,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends k.Disposable{constructor(g,h,I,y){super(),this.settingsResource=g,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=I instanceof l.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,I,y)),this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,{},A.extUriBiasedIgnorePathCase,h)),this.configuration=new w.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new w.ConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new N.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:p,properties:f})=>this.onDidDefaultConfigurationChange(p,f))),this._register(this.policyConfiguration.onDidChangeConfiguration(p=>this.onDidPolicyConfigurationChange(p))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,h,I]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new w.Configuration(g,h,new w.ConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(g,h){const I=typeof g=="string"?g:void 0,y=(0,T.isConfigurationOverrides)(g)?g:(0,T.isConfigurationOverrides)(h)?h:{};return this.configuration.getValue(I,y,void 0)}updateValue(g,h,I,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const h=this.configuration.toData(),I=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(I,h,2)}onDidDefaultConfigurationChange(g,h){const I=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(g,h);this.trigger(y,I,7)}onDidPolicyConfigurationChange(g){const h=this.configuration.toData(),I=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(I,h,7)}trigger(g,h,I){const y=new w.ConfigurationChangeEvent(g,{data:h},this.configuration);y.source=I,y.sourceConfig=this.getTargetConfiguration(I),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(g){switch(g){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(te[67],ne([0,1,15]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(l){return l.scheme===N.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=O;function k(l){if(!l)return;const b=l.indexOf("+");return b<0?l:l.substr(0,b)}e.getRemoteName=k;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(l){const{host:b,port:C}=u(l);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:C}}e.parseAuthorityWithPort=T;function w(l,b){let{host:C,port:g}=u(l);return typeof g>"u"&&(g=b),{host:C,port:g}}e.parseAuthorityWithOptionalPort=w;function u(l){const b=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const C=l.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const g=l.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:l,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(T||(e.ExtensionType=T={}));var w;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class u{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,f){if(typeof p>"u"||p===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof p=="string"||typeof f=="string"){const E=typeof p=="string"?p:p.value,L=typeof f=="string"?f:f.value;return N.equalsIgnoreCase(E,L)}return p._lower===f._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=u;class l{get size(){return this._set.size}constructor(p){if(this._set=new Set,p)for(const f of p)this.add(f)}add(p){this._set.add(u.toKey(p))}delete(p){return this._set.delete(u.toKey(p))}has(p){return this._set.has(u.toKey(p))}}e.ExtensionIdentifierSet=l;class b{constructor(){this._map=new Map}clear(){this._map.clear()}delete(p){this._map.delete(u.toKey(p))}get(p){return this._map.get(u.toKey(p))}has(p){return this._map.has(u.toKey(p))}set(p,f){this._map.set(u.toKey(p),f)}values(){return this._map.values()}forEach(p){this._map.forEach(p)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=b;function C(y){return g(y)}e.isApplicationScopedExtension=C;function g(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function I(y,p){if(p){const f=`onResolveRemoteAuthority:${(0,k.getRemoteName)(p)}`;return!!y.activationEvents?.includes(f)}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[134],ne([0,1,2,37,12]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends N.Disposable{constructor(w,u,l,b,C){super(),this.userDataProfilesService=w,this.fileService=u,this.uriIdentityService=l,this.logService=C,this._register(b.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(b.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(w){for(const u of w)u.local&&this.invalidate(u.profileLocation)}onDidUnInstallExtension(w){w.error||this.invalidate(w.profileLocation)}async invalidate(w){if(w)for(const u of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(u.extensionsResource,w)&&await this.deleteUserCacheFile(u);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(w){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(w.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(u){(0,k.toFileOperationResult)(u)!==1&&this.logService.error(u)}}}e.ExtensionsManifestCache=A}),define(te[44],ne([0,1,14,9,2,103,43,10,6,36]),function(G,e,N,O,k,A,T,w,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,w.createDecorator)("requestService");class b{constructor(S){this.original=S}toJSON(){if(!this.headers){const S=Object.create(null);for(const r in this.original)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?S[r]="*****":S[r]=this.original[r];this.headers=S}return this.headers}}class C extends k.Disposable{constructor(S){super(),this.counter=0,this.logger=S.createLogger("network",{name:(0,A.localize)(0,null),when:u.CONTEXT_LOG_LEVEL.isEqualTo((0,u.LogLevelToString)(u.LogLevel.Trace)).serialize()})}async logAndRequest(S,r,s){const t=`${S} #${++this.counter}: ${r.url}`;this.logger.trace(`${t} - begin`,r.type,new b(r.headers??{}));try{const i=await s();return this.logger.trace(`${t} - end`,r.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${t} - error`,r.type,(0,O.getErrorMessage)(i)),i}}}e.AbstractRequestService=C;function g(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=g;function h(d){return d.res.statusCode===204}e.hasNoContent=h;async function I(d){return h(d)?null:(await(0,N.streamToBuffer)(d.stream)).toString()}e.asText=I;async function y(d){if(!g(d))throw new Error("Server returned "+d.res.statusCode);return I(d)}e.asTextOrError=y;async function p(d){if(!g(d))throw new Error("Server returned "+d.res.statusCode);if(h(d))return null;const r=(await(0,N.streamToBuffer)(d.stream)).toString();try{return JSON.parse(r)}catch(s){throw s.message+=`:
`+r,s}}e.asJson=p;function f(d){L(d)}e.updateProxyConfigurationsScope=f;let E;function L(d){const S=l.Registry.as(T.Extensions.Configuration),r=E;E={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[E],remove:r?[r]:[]})}L(1)}),define(te[135],ne([0,1,20,15,12,44]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(u,l){this.requestService=u,this.fileService=l}async download(u,l,b=N.CancellationToken.None){if(u.scheme===O.Schemas.file||u.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(u,l);return}const C={type:"GET",url:u.toString(!0)},g=await this.requestService.request(C,b);if(g.res.statusCode===200)await this.fileService.writeFile(l,g.stream);else{const h=await(0,A.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${h}`)}}};e.DownloadService=T,e.DownloadService=T=ve([ie(0,A.IRequestService),ie(1,k.IFileService)],T)}),define(te[136],ne([0,1,137,3]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(T,w){return T.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:T.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function A(T,w,u={}){const l=(0,N.parse)(T),b=u.proxyUrl||k(l,w);if(!b)return null;const C=(0,N.parse)(b);if(!/^https?:$/.test(C.protocol||""))return null;const g={host:C.hostname||"",port:(C.port?+C.port:0)||(C.protocol==="https"?443:80),auth:C.auth,rejectUnauthorized:(0,O.isBoolean)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((h,I)=>{G(["http-proxy-agent"],h,I)})).HttpProxyAgent(b,g):new(await new Promise((h,I)=>{G(["https-proxy-agent"],h,I)})).HttpsProxyAgent(b,g)}e.getProxyAgent=A}),define(te[138],ne([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let I;async function y(f,E,L,d){return L["force-disable-user-env"]?(E.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(E.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(d)&&!L["force-user-env"]?(E.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(d)?E.trace("resolveShellEnv(): running (--force-user-env)"):E.trace("resolveShellEnv(): running (macOS/Linux)"),I||(I=g.Promises.withAsyncBody(async(S,r)=>{const s=new A.CancellationTokenSource;let t=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,h.clamp)(i,1,120)*1e3);const n=setTimeout(()=>{s.dispose(!0),r(new Error((0,k.localize)(0,null)))},t);try{S(await p(E,s.token))}catch(o){!(0,w.isCancellationError)(o)&&!s.token.isCancellationRequested?r(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(o)))):S({})}finally{clearTimeout(n),s.dispose()}})),I)}e.getResolvedShellEnv=y;async function p(f,E){const L=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",L);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",d);const S=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(S+"({.*})"+S),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const t=await(0,b.getSystemShell)(u.OS,s);return f.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(E.isCancellationRequested)return n(new w.CancellationError);const o=(0,O.basename)(t);let c,D;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${P} -p '''${S}'' + JSON.stringify(process.env) + ''${S}'''`,D=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${P} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,D=["-i","-l","-c"]):(c=`'${process.execPath}' ${P} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,o==="tcsh"||o==="csh"?D=["-ic"]:D=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),c);const v=(0,N.spawn)(t,[...D,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});E.onCancellationRequested(()=>(v.kill(),n(new w.CancellationError))),v.on("error",Z=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Z)),n(Z)});const R=[];v.stdout.on("data",Z=>R.push(Z));const z=[];v.stderr.on("data",Z=>z.push(Z)),v.on("close",(Z,ee)=>{const oe=Buffer.concat(R).toString("utf8");f.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(z).toString("utf8");if(re.trim()&&f.trace("getUnixShellEnvironment#stderr",re),Z||ee)return n(new Error((0,k.localize)(2,null,Z,ee)));const ue=r.exec(oe),le=ue?ue[1]:"{}";try{const se=JSON.parse(le);L?se.ELECTRON_RUN_AS_NODE=L:delete se.ELECTRON_RUN_AS_NODE,d?se.ELECTRON_NO_ATTACH_CONSOLE=d:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",se),i(se)}catch(se){f.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(se)),n(se)}})})}}),define(te[139],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,N.createDecorator)("stateReadService"),e.IStateService=(0,N.createDecorator)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(G,e,N,O,k,A,T,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var l;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class b extends k.Disposable{constructor(I,y,p,f){super(),this.storagePath=I,this.logService=p,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=y===0?void 0:this._register(new N.ThrottledDelayer(100))}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,y){const p=this.storage[I];return(0,A.isUndefinedOrNull)(p)?y:p}setItem(I,y){this.setItems([{key:I,data:y}])}setItems(I){let y=!1;for(const{key:p,data:f}of I)this.storage[p]!==f&&((0,A.isUndefinedOrNull)(f)?(0,A.isUndefined)(this.storage[p])||(this.storage[p]=void 0,y=!0):(this.storage[p]=f,y=!0));y&&this.save()}removeItem(I){(0,A.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,O.VSBuffer.fromString(I),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=I}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=b;let C=class extends k.Disposable{constructor(I,y,p,f){super(),this.fileStorage=this._register(new b(y.stateResource,I,p,f))}async init(){await this.fileStorage.init()}getItem(I,y){return this.fileStorage.getItem(I,y)}};e.StateReadonlyService=C,e.StateReadonlyService=C=ve([ie(1,T.IEnvironmentService),ie(2,u.ILogService),ie(3,w.IFileService)],C);class g extends C{setItem(I,y){this.fileStorage.setItem(I,y)}setItems(I){this.fileStorage.setItems(I)}removeItem(I){this.fileStorage.removeItem(I)}close(){return this.fileStorage.close()}}e.StateService=g}),define(te[69],ne([0,1,13,35,28]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(u){if(N.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function T(u,l,b,C,g,h,I,y,p){const f=Object.create(null);f["common.machineId"]=h,f["common.sqmId"]=I,f.sessionID=(0,k.generateUuid)()+Date.now(),f.commitHash=C,f.version=g,f["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,N.PlatformToString)(N.platform),f["common.nodePlatform"]=O.platform,f["common.nodeArch"]=b,f["common.product"]=p||"desktop",y&&(f["common.msftInternal"]=y);let E=0;const L=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-L,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),N.isLinuxSnap&&(f["common.snap"]="true");const d=A(l);return d&&(f["common.platformDetail"]=d),f}e.resolveCommonProperties=T;function w(u){const l=O.env.USERDNSDOMAIN;if(!l)return!1;const b=l.toLowerCase();return u.some(C=>b===C)}e.verifyMicrosoftInternalDomain=w}),define(te[26],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,N.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,N.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(G,e,N,O,k,A,T,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class C{async publicLog(n,o,c){}async publicLogError(n,o,c){}}e.NullEndpointTelemetryService=C,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(i,n){return k.Event.debounce(n.onDidChangeConfiguration,(c,D)=>{const P=c?new Set([...c.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:P}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=g;function h(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=h;function I(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=I;function y(i){const n=i.getValue(u.TELEMETRY_SETTING_ID),o=i.getValue(u.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(u.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function p(i){const n={},o={},c={};L(i,c);for(let D in c){D=D.length>150?D.substr(D.length-149):D;const P=c[D];typeof P=="number"?o[D]=P:typeof P=="boolean"?o[D]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${P.length}`),n[D]=P.substring(0,8191)):typeof P<"u"&&P!==null&&(n[D]=P)}return{properties:n,measurements:o}}e.validateTelemetryData=p;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function E(i){if(!i)return"none";const n=(0,T.getRemoteName)(i);return f.has(n)?n:"other"}e.cleanRemoteAuthority=E;function L(i,n,o=0,c){if(i)for(const D of Object.getOwnPropertyNames(i)){const P=i[D],v=c?c+D:D;Array.isArray(P)?n[v]=(0,N.safeStringify)(P):P instanceof Date?n[v]=P.toISOString():(0,O.isObject)(P)?o<2?L(P,n,o+1,v+"."):n[v]=(0,N.safeStringify)(P):n[v]=P}}function d(i,n){const o=i.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,w.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=d;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=S;function r(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const c=[];for(const R of n)for(;;){const z=R.exec(i);if(!z)break;c.push([z.index,R.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(o="";;){const R=P.exec(i);if(!R)break;const z=c.some(([Z,ee])=>R.index<ee&&Z<P.lastIndex);!D.test(R[0])&&!z&&(o+=i.substring(v,R.index)+"<REDACTED: user-file-path>",v=P.lastIndex)}return v<i.length&&(o+=i.substr(v)),o}function s(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function t(i,n){return(0,N.cloneAndChange)(i,o=>{if(o instanceof l||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let c=o.replaceAll("%20"," ");c=r(c,n);for(const D of n)c=c.replace(D,"");return c=s(c),c}})}e.cleanData=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(G,e,N,O,k,A,T,w,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,N.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=b;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new g(i.identifier,n,o)}static parse(i){const n=C.exec(i);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof g?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=g;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(t){const i=h.exec(t);return i&&i[1]?[p(i[1]),i[2]]:[p(t),void 0]}e.getIdAndVersion=I;function y(t,i){return`${t}.${i}`}e.getExtensionId=y;function p(t){return t.toLowerCase()}e.adoptToGalleryExtensionId=p;function f(t,i){return p(y(t??k.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=f;function E(t,i){const n=[],o=c=>{for(const D of n)if(D.some(P=>b(i(P),i(c))))return D;return null};for(const c of t){const D=o(c);D?D.push(c):n.push([c])}return n}e.groupByExtension=E;function L(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function d(t){return{id:new l.TelemetryTrustedValue(t.identifier.id),name:new l.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function S(t,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&n.every(D=>!b(D.identifier,{id:c}))){const D=t.filter(P=>b(P.identifier,{id:c}));D.length===1&&(n.push(D[0]),o.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=S;async function r(t,i){if(!A.isLinux)return!1;let n;try{n=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(t,i){const n=await r(t,i),o=(0,O.getTargetPlatform)(n?"alpine":A.platform,u.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(te[140],ne([0,1,20,9,15,17,42,11,93,21,27,37]),function(G,e,N,O,k,A,T,w,u,l,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const g=p=>(0,u.localize)(0,null,p),h=(0,u.localize)(1,null,"ms-dotnettools.csharp");function I(p,f){return f?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}let y=class{constructor(f,E,L){this.logger=f,this.extensionManagementService=E,this.extensionGalleryService=L}get location(){}async listExtensions(f,E,L){let d=await this.extensionManagementService.getInstalled(1,L);const S=C.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(E&&E!==""){if(S.indexOf(E.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}d=d.filter(s=>s.manifest.categories?s.manifest.categories.map(i=>i.toLowerCase()).indexOf(E.toLowerCase())>-1:!1)}else if(E===""){this.logger.info("Possible Categories: "),S.forEach(s=>{this.logger.info(s)});return}this.location&&this.logger.info((0,u.localize)(2,null,this.location)),d=d.sort((s,t)=>s.identifier.id.localeCompare(t.identifier.id));let r;for(const s of d)r!==s.identifier.id&&(r=s.identifier.id,this.logger.info(I(s.manifest,f)))}async installExtensions(f,E,L,d){const S=[];try{const r=[];f.length&&this.logger.info(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const s=[];let t=[];const i=(o,c,D)=>{t.push({id:o,version:c!=="prerelease"?c:void 0,installOptions:{...L,isBuiltin:D,installPreReleaseVersion:c==="prerelease"||L.installPreReleaseVersion}})};for(const o of f)if(o instanceof w.URI)s.push({vsix:o,installOptions:L});else{const[c,D]=(0,b.getIdAndVersion)(o);i(c,D,!1)}for(const o of E)if(o instanceof w.URI)s.push({vsix:o,installOptions:{...L,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,D]=(0,b.getIdAndVersion)(o);i(c,D,!0)}const n=await this.extensionManagementService.getInstalled(1,L.profileLocation);if(s.length&&await Promise.all(s.map(async({vsix:o,installOptions:c})=>{try{const D=await this.installVSIX(o,c,d,n);D&&r.push(D)}catch(D){this.logger.error(D),S.push(o.toString())}})),t.length&&(t=t.filter(({id:o,version:c})=>{const D=n.find(P=>(0,b.areSameExtensions)(P.identifier,{id:o}));if(D){if(!d&&(!c||c==="prerelease"&&D.preRelease))return this.logger.info((0,u.localize)(5,null,o,D.manifest.version,o)),!1;if(c&&D.manifest.version===c)return this.logger.info((0,u.localize)(6,null,`${o}@${c}`)),!1}return!0}),t.length)){const o=await this.getGalleryExtensions(t);await Promise.all(t.map(async c=>{const D=o.get(c.id.toLowerCase());if(D)try{const P=await this.installFromGallery(c,D,n);P&&r.push(P)}catch(P){this.logger.error(P.message||P.stack||P),S.push(c.id)}else this.logger.error(`${g(c.version?`${c.id}@${c.version}`:c.id)}
${h}`),S.push(c.id)}))}}catch(r){throw this.logger.error((0,u.localize)(7,null,(0,O.getErrorMessage)(r))),r}if(S.length)throw new Error((0,u.localize)(8,null,S.join(", ")))}async installVSIX(f,E,L,d){const S=await this.extensionManagementService.getManifest(f);if(!S)throw new Error("Invalid vsix");if(await this.validateVSIX(S,L,E.profileLocation,d))try{return await this.extensionManagementService.install(f,E),this.logger.info((0,u.localize)(9,null,(0,A.basename)(f))),S}catch(s){if((0,O.isCancellationError)(s))return this.logger.info((0,u.localize)(10,null,(0,A.basename)(f))),null;throw s}return null}async getGalleryExtensions(f){const E=new Map,L=f.some(r=>r.installOptions.installPreReleaseVersion),d=await this.extensionManagementService.getTargetPlatform(),S=[];for(const r of f)l.EXTENSION_IDENTIFIER_REGEX.test(r.id)&&S.push({...r,preRelease:L});if(S.length){const r=await this.extensionGalleryService.getExtensions(S,{targetPlatform:d},N.CancellationToken.None);for(const s of r)E.set(s.identifier.id.toLowerCase(),s)}return E}async installFromGallery({id:f,version:E,installOptions:L},d,S){const r=await this.extensionGalleryService.getManifest(d,N.CancellationToken.None);if(r&&!this.validateExtensionKind(r))return null;const s=S.find(t=>(0,b.areSameExtensions)(t.identifier,d.identifier));if(s){if(d.version===s.manifest.version)return this.logger.info((0,u.localize)(11,null,E?`${f}@${E}`:f)),null;this.logger.info((0,u.localize)(12,null,f,d.version))}try{L.isBuiltin?this.logger.info(E?(0,u.localize)(13,null,f,E):(0,u.localize)(14,null,f)):this.logger.info(E?(0,u.localize)(15,null,f,E):(0,u.localize)(16,null,f));const t=await this.extensionManagementService.installFromGallery(d,{...L,installGivenVersion:!!E});return this.logger.info((0,u.localize)(17,null,f,t.manifest.version)),r}catch(t){if((0,O.isCancellationError)(t))return this.logger.info((0,u.localize)(18,null,f)),null;throw t}}validateExtensionKind(f){return!0}async validateVSIX(f,E,L,d){if(!E){const S={id:(0,b.getGalleryExtensionId)(f.publisher,f.name)},r=d.find(s=>(0,b.areSameExtensions)(S,s.identifier)&&(0,T.gt)(s.manifest.version,f.version));if(r)return this.logger.info((0,u.localize)(19,null,r.identifier.id,r.manifest.version,f.version)),!1}return this.validateExtensionKind(f)}async uninstallExtensions(f,E,L){const d=async r=>{if(r instanceof w.URI){const s=await this.extensionManagementService.getManifest(r);return I(s)}return r},S=[];for(const r of f){const s=await d(r),i=(await this.extensionManagementService.getInstalled(void 0,L)).filter(n=>(0,b.areSameExtensions)(n.identifier,{id:s}));if(!i.length)throw new Error(`${this.notInstalled(s)}
${h}`);if(i.some(n=>n.type===0)){this.logger.info((0,u.localize)(20,null,s));return}if(!E&&i.some(n=>n.isBuiltin)){this.logger.info((0,u.localize)(21,null,s));return}this.logger.info((0,u.localize)(22,null,s));for(const n of i)await this.extensionManagementService.uninstall(n,{profileLocation:L}),S.push(n);this.location?this.logger.info((0,u.localize)(23,null,s,this.location)):this.logger.info((0,u.localize)(24,null,s))}}async locateExtension(f){const E=await this.extensionManagementService.getInstalled();f.forEach(L=>{E.forEach(d=>{if(d.identifier.id===L&&d.location.scheme===k.Schemas.file){this.logger.info(d.location.fsPath);return}})})}notInstalled(f){return this.location?(0,u.localize)(25,null,f,this.location):(0,u.localize)(26,null,f)}};e.ExtensionManagementCLI=y,e.ExtensionManagementCLI=y=ve([ie(1,l.IExtensionManagementService),ie(2,l.IExtensionGalleryService)],y)}),define(te[141],ne([0,1,4,2,31,27,37]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class w extends O.Disposable{constructor(l,b,C,g,h,I,y){super(),this.extensionManagementService=l,this.extensionsScannerService=b,this.userDataProfilesService=C,this.extensionsProfileScannerService=g,this.uriIdentityService=h,this.fileService=I,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new N.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,p=>y.error(p))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(l=>this.onDidChangeProfiles(l.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(l=>this.onAddExtensions(l))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(l=>this.onDidAddExtensions(l))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(l=>this.onRemoveExtensions(l))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(l=>this.onDidRemoveExtensions(l))),this._register(this.fileService.onDidFilesChange(l=>this.onDidFilesChange(l)))}async onDidChangeProfiles(l){try{l.length&&await Promise.all(l.map(b=>(this.extensionsProfileWatchDisposables.set(b.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(b.extensionsResource)),this.fileService.watch(b.extensionsResource))),this.populateExtensionsFromProfile(b.extensionsResource))))}catch(b){throw this.logService.error(b),b}}async onAddExtensions(l){for(const b of l.extensions)this.addExtensionWithKey(this.getKey(b.identifier,b.version),l.profileLocation)}async onDidAddExtensions(l){for(const b of l.extensions){const C=this.getKey(b.identifier,b.version);l.error?this.removeExtensionWithKey(C,l.profileLocation):this.addExtensionWithKey(C,l.profileLocation)}}async onRemoveExtensions(l){for(const b of l.extensions)this.removeExtensionWithKey(this.getKey(b.identifier,b.version),l.profileLocation)}async onDidRemoveExtensions(l){const b=[],C=[];for(const g of l.extensions){const h=this.getKey(g.identifier,g.version);l.error?this.addExtensionWithKey(h,l.profileLocation):(this.removeExtensionWithKey(h,l.profileLocation),this.allExtensions.has(h)||(this.logService.debug("Extension is removed from all profiles",g.identifier.id,g.version),C.push(this.extensionManagementService.scanInstalledExtensionAtLocation(g.location).then(I=>{I?b.push(I):this.logService.info("Extension not found at the location",g.location.toString())},I=>this.logService.error(I)))))}try{await Promise.all(C),b.length&&await this.uninstallExtensionsNotInProfiles(b)}catch(g){this.logService.error(g)}}onDidFilesChange(l){for(const b of this.userDataProfilesService.profiles)l.contains(b.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(b.extensionsResource)}async onDidExtensionsProfileChange(l){const b=[],C=[],g=await this.extensionsProfileScannerService.scanProfileExtensions(l),h=new Set,I=new Set;for(const[y,p]of this.allExtensions)p.has(l)&&I.add(y);for(const y of g){const p=this.getKey(y.identifier,y.version);h.add(p),I.has(p)||(b.push(y.identifier),this.addExtensionWithKey(p,l))}for(const y of I)if(!h.has(y)){const p=this.fromKey(y);p&&(C.push(p.identifier),this.removeExtensionWithKey(y,l))}(b.length||C.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b.length?{extensions:b,profileLocation:l}:void 0,removed:C.length?{extensions:C,profileLocation:l}:void 0})}async populateExtensionsFromProfile(l){const b=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const C of b)this.addExtensionWithKey(this.getKey(C.identifier,C.version),l)}async uninstallExtensionsNotInProfiles(l){l||(l=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(C=>!this.allExtensions.has(this.getKey(C.identifier,C.manifest.version)))),l.length&&await this.extensionManagementService.markAsUninstalled(...l)}addExtensionWithKey(l,b){let C=this.allExtensions.get(l);C||this.allExtensions.set(l,C=new k.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(g))),C.add(b)}removeExtensionWithKey(l,b){const C=this.allExtensions.get(l);C&&C.delete(b),C?.size||this.allExtensions.delete(l)}getKey(l,b){return`${T.ExtensionIdentifier.toKey(l.id)}@${b}`}fromKey(l){const[b,C]=(0,A.getIdAndVersion)(l);return C?{identifier:{id:b},version:C}:void 0}}e.ExtensionsWatcher=w}),define(te[142],ne([0,1,113,39]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(A,T,w,u,l,b,C){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${T.nameShort})`};if((0,O.supportsTelemetry)(T,w)&&(0,O.getTelemetryLevel)(u)===3){const h=await(0,N.getServiceMachineId)(w,l,b);g["X-Market-User-Id"]=h,g["VSCode-SessionId"]=C.machineId||h}return g}e.resolveMarketplaceHeaders=k}),define(te[143],ne([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends h.LanguagePackBaseService{constructor(L,d,S,r){super(S),this.extensionManagementService=L,this.logService=r,this.cache=this._register(new p(d,r)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getBuiltInExtensionTranslationsUri(L,d){const r=(await this.cache.getLanguagePacks())[d];if(!r){this.logService.warn(`No language pack found for ${d}`);return}const s=r.translations[L];return s?I.URI.file(s):void 0}async getInstalledLanguages(){const L=await this.cache.getLanguagePacks(),d=Object.keys(L).map(S=>{const r=L[S];return{...this.createQuickPickItem(S,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return d.push(this.createQuickPickItem("en","English")),d.sort((S,r)=>S.label.localeCompare(r.label)),d}async postInstallExtension(L){L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",L.identifier.id),await this.update())}async postUninstallExtension(L){const d=await this.cache.getLanguagePacks();Object.keys(d).some(S=>d[S]&&d[S].extensions.some(r=>(0,C.areSameExtensions)(r.extensionIdentifier,L.identifier)))&&(this.logService.info("Removing language packs from the extension",L.identifier.id),await this.update())}async update(){const[L,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),S=await this.cache.update(d);return!(0,O.equals)(Object.keys(L),Object.keys(S))}};e.NativeLanguagePackService=y,e.NativeLanguagePackService=y=ve([ie(0,b.IExtensionManagementService),ie(1,l.INativeEnvironmentService),ie(2,b.IExtensionGalleryService),ie(3,g.ILogService)],y);let p=class extends A.Disposable{constructor(L,d){super(),this.logService=d,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(L.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(L){return this.withLanguagePacks(d=>{Object.keys(d).forEach(S=>delete d[S]),this.createLanguagePacksFromExtensions(d,...L)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(L,...d){for(const S of d)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(L,S);Object.keys(L).forEach(S=>this.updateHash(L[S]))}createLanguagePacksFromExtension(L,d){const S=d.identifier,r=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const s of r)if(d.location.scheme===T.Schemas.file&&f(s)){let t=L[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},L[s.languageId]=t);const i=t.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,S))[0];i?i.version=d.manifest.version:t.extensions.push({extensionIdentifier:S,version:d.manifest.version});for(const n of s.translations)t.translations[n.id]=(0,w.join)(d.location.fsPath,n.path)}}updateHash(L){if(L){const d=(0,N.createHash)("md5");for(const S of L.extensions)d.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);L.hash=d.digest("hex")}}withLanguagePacks(L=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(d=L(S),S)).then(S=>{for(const s of Object.keys(S))S[s]||delete S[s];this.languagePacks=S,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),u.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>d,S=>this.logService.error(S))})}};p=ve([ie(0,l.INativeEnvironmentService),ie(1,g.ILogService)],p);function f(E){if(typeof E.languageId!="string"||!Array.isArray(E.translations)||E.translations.length===0)return!1;for(const L of E.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(E.languageName&&typeof E.languageName!="string"||E.localizedLanguageName&&typeof E.localizedLanguageName!="string")}}),define(te[144],ne([0,1,81,9,30,39]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://0.0.0.0/OneCollector/1.0",w="https://0.0.0.0/ping";async function u(b,C,g){const h=await(0,N.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),I=await(0,N.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new h.AppInsightsCore,p=new I.PostChannel,f={instrumentationKey:b,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(g){f.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:g};f.extensionConfig[p.identifier]=E}return y.initialize(f,[]),y.addTelemetryInitializer(E=>{C&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),y}class l{constructor(C,g,h,I,y){this._isInternalTelemetry=C,this._eventPrefix=g,this._defaultData=h,this._xhrOverride=y,this.endPointUrl=T,this.endPointHealthUrl=w,this._defaultData||(this._defaultData={}),typeof I=="function"?this._aiCoreOrKey=I():this._aiCoreOrKey=I,this._asyncAiCore=null}_withAIClient(C){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){C(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=u(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(g=>{C(g)},g=>{(0,O.onUnexpectedError)(g),console.error(g)})}}log(C,g){if(!this._aiCoreOrKey)return;g=(0,k.mixin)(g,this._defaultData),g=(0,A.validateTelemetryData)(g);const h=this._eventPrefix+"/"+C;try{this._withAIClient(I=>{I.pluginVersionString=g?.properties.version??"Unknown",I.track({name:h,baseData:{name:h,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(C=>{this._withAIClient(g=>{g.unload(!0,()=>{this._aiCoreOrKey=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=l}),define(te[145],ne([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,E,L){this._configurationService=E,this._productService=L,this._experimentProperties={},this._disposables=new N.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(d),"gi")),d.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(d.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(d=>{(d.affectsConfiguration(g.TELEMETRY_SETTING_ID)||d.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||d.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(f,E){this._experimentProperties[f]=E}_updateTelemetryLevel(){let f=(0,h.getTelemetryLevel)(this._configurationService);const E=this._productService.enabledTelemetryLevels;if(E){this._sendErrorTelemetry=this.sendErrorTelemetry?E.error:!1;const L=E.usage?3:E.error?2:0;f=Math.min(f,L)}this._telemetryLevel=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(f,E,L){this._telemetryLevel<E||(L=(0,O.mixin)(L,this._experimentProperties),L=(0,h.cleanData)(L,this._cleanupPatterns),L=(0,O.mixin)(L,this._commonProperties),this._appenders.forEach(d=>d.log(f,L)))}publicLog(f,E){this._log(f,3,E)}publicLog2(f,E){this.publicLog(f,E)}publicLogError(f,E){this._sendErrorTelemetry&&this._log(f,2,E)}publicLogError2(f,E){this.publicLogError(f,E)}};e.TelemetryService=I,e.TelemetryService=I=ve([ie(1,w.IConfigurationService),ie(2,b.IProductService)],I);function y(){const p=(0,T.localize)(0,null,l.default.nameLong),f=l.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),E=k.isWeb?"":(0,T.localize)(3,null),L=(0,T.localize)(4,null),d=(0,T.localize)(5,null),S=(0,T.localize)(6,null),r=(0,T.localize)(7,null),s=`
|       | ${L} | ${d} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${p} ${f} ${E}

&nbsp;

${r}
${s}

&nbsp;

${t}
`}C.Registry.as(u.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(u.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,T.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,T.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[147],ne([0,1,14,20,174,144]),function(G,e,N,O,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function T(b,C){const g=await C.request(b,O.CancellationToken.None),h=(await(0,N.streamToBuffer)(g.stream)).toString(),I=g.res.statusCode??200;return{headers:g.res.headers,statusCode:I,responseData:h}}async function w(b){const C={method:b.type,headers:b.headers};return new Promise((h,I)=>{const y=k.request(b.url??"",C,p=>{p.on("data",function(f){h({headers:p.headers,statusCode:p.statusCode??200,responseData:f.toString()})}),p.on("error",function(f){I(f)})});y.write(b.data,p=>{p&&I(p)}),y.end()})}async function u(b,C,g){const h=typeof C.data=="string"?C.data:new TextDecoder().decode(C.data),I={type:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data).toString()},url:C.urlString,data:h};try{const y=b?await T(I,b):await w(I);g(y.statusCode,y.headers,y.responseData)}catch{g(0,{})}}class l extends A.AbstractOneDataSystemAppender{constructor(C,g,h,I,y){const p={sendPOST:(f,E)=>{u(C,f,E)}};super(g,h,I,y,p)}}e.OneDataSystemAppender=l}),define(te[148],ne([0,1,16,24]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(A,T){const w=Object.create(null),u=(b,C)=>{const g=JSON.parse(b);w[C]=g};if(T){const b=[],C=await O.Promises.readdir(T);for(const h of C)try{(await O.Promises.stat((0,N.join)(T,h))).isDirectory()&&b.push(h)}catch{}const g=[];for(const h of b)(await O.Promises.readdir((0,N.join)(T,h))).filter(y=>y==="telemetry.json").length===1&&g.push(h);for(const h of g){const I=(await O.Promises.readFile((0,N.join)(T,h,"telemetry.json"))).toString();u(I,h)}}let l=(await O.Promises.readFile((0,N.join)(A,"telemetry-core.json"))).toString();return u(l,"vscode-core"),l=(await O.Promises.readFile((0,N.join)(A,"telemetry-extensions.json"))).toString(),u(l,"vscode-extensions"),JSON.stringify(w,null,4)}e.buildTelemetryMessage=k}),define(te[149],ne([0,1,13,82,26]),function(G,e,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function A(w,u){let l=w.getItem(k.machineIdKey);return(typeof l!="string"||N.isMacintosh&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,O.getMachineId)(u.error.bind(u))),l}e.resolveMachineId=A;async function T(w,u){let l=w.getItem(k.sqmIdKey);return typeof l!="string"&&(l=await(0,O.getSqmMachineId)(u.error.bind(u))),l}e.resolveSqmId=T}),define(te[22],ne([0,1,10]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,N.createDecorator)("IUriIdentityService")}),define(te[150],ne([0,1,22,114,12,17,73,4,2]),function(G,e,N,O,k,A,T,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{static{this._clock=0}constructor(g){this.uri=g,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let b=class{constructor(g){this._fileService=g,this._dispooables=new u.DisposableStore,this._limit=2**16;const h=new Map,I=y=>{let p=h.get(y.scheme);return p===void 0&&(p=g.hasProvider(y)&&!this._fileService.hasCapability(y,1024),h.set(y.scheme,p)),p};this._dispooables.add(w.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new A.ExtUri(I),this._canonicalUris=new T.SkipList((y,p)=>this.extUri.compare(y,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,A.normalizePath)(g));const h=this._canonicalUris.get(g);return h?h.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new l(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((I,y)=>I[1].time<y[1].time?1:I[1].time>y[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let I=0;I<h;I++)this._canonicalUris.set(g[I][0],g[I][1].touch())}};e.UriIdentityService=b,e.UriIdentityService=b=ve([ie(0,k.IFileService)],b),(0,O.registerSingleton)(N.IUriIdentityService,b,1)}),define(te[151],ne([0,1,4,2,12,47,31]),function(G,e,N,O,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class w extends O.Disposable{constructor(l,b,C,g,h,I){super(),this.fileSystemScheme=l,this.fileSystemProvider=b,this.userDataScheme=C,this.userDataProfilesService=g,this.uriIdentityService=h,this.logService=I,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new T.ResourceSet(y=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(y))),this.updateAtomicReadWritesResources(),this._register(g.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const l of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(l.settingsResource),this.atomicReadWriteResources.add(l.keybindingsResource),this.atomicReadWriteResources.add(l.tasksResource),this.atomicReadWriteResources.add(l.extensionsResource)}open(l,b){return this.fileSystemProvider.open(this.toFileSystemResource(l),b)}close(l){return this.fileSystemProvider.close(l)}read(l,b,C,g,h){return this.fileSystemProvider.read(l,b,C,g,h)}write(l,b,C,g,h){return this.fileSystemProvider.write(l,b,C,g,h)}watch(l,b){this.watchResources.set(l,l);const C=this.fileSystemProvider.watch(this.toFileSystemResource(l),b);return(0,O.toDisposable)(()=>{this.watchResources.delete(l),C.dispose()})}stat(l){return this.fileSystemProvider.stat(this.toFileSystemResource(l))}mkdir(l){return this.fileSystemProvider.mkdir(this.toFileSystemResource(l))}rename(l,b,C){return this.fileSystemProvider.rename(this.toFileSystemResource(l),this.toFileSystemResource(b),C)}readFile(l,b){return this.fileSystemProvider.readFile(this.toFileSystemResource(l),b)}readFileStream(l,b,C){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(l),b,C)}readdir(l){return this.fileSystemProvider.readdir(this.toFileSystemResource(l))}enforceAtomicReadFile(l){return this.atomicReadWriteResources.has(l)}writeFile(l,b,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(l),b,C)}enforceAtomicWriteFile(l){return this.atomicReadWriteResources.has(l)?{postfix:".vsctmp"}:!1}delete(l,b){return this.fileSystemProvider.delete(this.toFileSystemResource(l),b)}copy(l,b,C){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(l),this.toFileSystemResource(b),C);throw new Error("copy not supported")}cloneFile(l,b){if((0,k.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(l),this.toFileSystemResource(b));throw new Error("clone not supported")}handleFileChanges(l){const b=[];for(const C of l){if(C.resource.scheme!==this.fileSystemScheme)continue;const g=this.toUserDataResource(C.resource);this.watchResources.findSubstr(g)&&b.push({resource:g,type:C.type,cId:C.cId})}b.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(b))}toFileSystemResource(l){return l.with({scheme:this.fileSystemScheme})}toUserDataResource(l){return l.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=w}),define(te[152],ne([0,1,107,16,47,17,11,10,15]),function(G,e,N,O,k,A,T,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=l;function b(i){return typeof i?.id=="string"&&!l(i)&&!g(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function C(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=C;function g(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=g;function h(i){const n=i;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=h;var I;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(I||(e.WorkbenchState=I={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=y;function p(i){const n=i;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=p;class f{constructor(n,o,c,D,P){this._id=n,this._transient=c,this._configuration=D,this._ignorePathCasing=P,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class E{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=E;function L(i){return new E({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=L,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,N.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(i,n){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function S(i){let n;return T.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=S,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=r;function s(i,n){return!d(i,n)&&!S(i)}e.isSavedWorkspace=s;function t(i){return(typeof i=="string"?(0,O.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(te[23],ne([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var L;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(L||(e.ProfileResourceType=L={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&T.URI.isUri(n.location)&&T.URI.isUri(n.globalStorageHome)&&T.URI.isUri(n.settingsResource)&&T.URI.isUri(n.keybindingsResource)&&T.URI.isUri(n.tasksResource)&&T.URI.isUri(n.snippetsHome)&&T.URI.isUri(n.extensionsResource))}e.isUserDataProfile=d,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function S(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:T.URI.revive(i.location).with({scheme:n}),globalStorageHome:T.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:T.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:T.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:T.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:T.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:T.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:T.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=S;function r(i,n,o,c,D,P){return{id:i,name:n,location:o,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:P&&D?.useDefaultFlags?.globalState?P.globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:P&&D?.useDefaultFlags?.settings?P.settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:P&&D?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:P&&D?.useDefaultFlags?.tasks?P.tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:P&&D?.useDefaultFlags?.snippets?P.snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:P&&D?.useDefaultFlags?.extensions?P.extensionsResource:(0,A.joinPath)(o,"extensions.json"),cacheHome:(0,A.joinPath)(c,i),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=r;let s=class extends k.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,c,D){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=c,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),o=[n];if(this.enabled)try{for(const P of this.getStoredProfiles()){if(!P.name||!(0,E.isString)(P.name)||!P.location){this.logService.warn("Skipping the invalid stored profile",P.location||P.name);continue}o.push(r((0,A.basename)(P.location),P.name,P.location,this.profilesCacheHome,{shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags},n))}}catch(P){this.logService.error(P)}const c=new h.ResourceMap,D=new Map;if(o.length)try{const P=this.getStoredProfileAssociations();if(P.workspaces)for(const[v,R]of Object.entries(P.workspaces)){const z=T.URI.parse(v),Z=o.find(ee=>ee.id===R);Z&&c.set(z,Z)}if(P.emptyWindows)for(const[v,R]of Object.entries(P.emptyWindows)){const z=o.find(Z=>Z.id===R);z&&D.set(v,z)}}catch(P){this.logService.error(P)}this._profilesObject={profiles:o,workspaces:c,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const n=r("__default__profile__",(0,w.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",c=new RegExp(`${(0,f.escapeRegExpCharacters)(o)}\\s(\\d+)`);let D=0;for(const v of this.profiles){const R=c.exec(v.name),z=R?parseInt(R[1]):0;D=z>D?z:D}const P=`${o} ${D+1}`;return this.createProfile((0,N.hash)((0,p.generateUuid)()).toString(16),P,{transient:!0},n)}async createNamedProfile(n,o,c){return this.createProfile((0,N.hash)((0,p.generateUuid)()).toString(16),n,o,c)}async createProfile(n,o,c,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const P=await this.doCreateProfile(n,o,c);return D&&await this.setProfileForWorkspace(D,P),P}async doCreateProfile(n,o,c){if(!(0,E.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(o);return D||(D=(async()=>{try{const P=this.profiles.find(z=>z.name===o||z.id===n);if(P)return P;const v=r(n,o,(0,A.joinPath)(this.profilesHome,n),this.profilesCacheHome,c,this.defaultProfile);await this.fileService.createFolder(v.location);const R=[];return this._onWillCreateProfile.fire({profile:v,join(z){R.push(z)}}),await y.Promises.settled(R),this.updateProfiles([v],[],[]),v}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,D)),D}async updateProfile(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(D=>D.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=r(c.id,o.name??c.name,c.location,this.profilesCacheHome,{shortName:o.shortName??c.shortName,icon:o.icon===null?void 0:o.icon??c.icon,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[c]),c}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(D=>D.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:o,join(D){c.push(D)}});try{await Promise.allSettled(c)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(D){(0,l.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(D=>D.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,c)}unsetWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return T.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,c){const D=[...this.profiles,...n],P=[];this.transientProfilesObject.profiles=[];for(let v of D)v.isDefault||o.some(R=>v.id===R.id)||(v=c.find(R=>v.id===R.id)??v,v.isTransient?this.transientProfilesObject.profiles.push(v):P.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.saveStoredProfiles(P),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,c)}triggerProfilesChanges(n,o,c){this._onDidChangeProfiles.fire({added:n,removed:o,updated:c,all:this.profiles})}updateWorkspaceAssociation(n,o,c){c=o?.isTransient?!0:c,c||this.updateWorkspaceAssociation(n,void 0,!0);const D=this.getWorkspace(n),P=c?this.transientProfilesObject:this.profilesObject;T.URI.isUri(D)?(P.workspaces.delete(D),o&&P.workspaces.set(D,o)):(P.emptyWindows.delete(D),o&&P.emptyWindows.set(D,o)),c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[c,D]of this.profilesObject.workspaces.entries())n[c.toString()]=D.id;const o={};for(const[c,D]of this.profilesObject.emptyWindows.entries())o[c.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const o={},c=this.createDefaultProfile();if(n.workspaces)for(const[P,v]of Object.entries(n.workspaces)){const R=T.URI.parse(v);o[P]=this.uriIdentityService.extUri.isEqual(R,c.location)?c.id:this.uriIdentityService.extUri.basename(R)}const D={};if(n.emptyWindows)for(const[P,v]of Object.entries(n.emptyWindows)){const R=T.URI.parse(v);D[P]=this.uriIdentityService.extUri.isEqual(R,c.location)?c.id:this.uriIdentityService.extUri.basename(R)}return{workspaces:o,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=s,e.UserDataProfilesService=s=ve([ie(0,u.IEnvironmentService),ie(1,l.IFileService),ie(2,I.IUriIdentityService),ie(3,C.ILogService)],s);class t extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=t}),define(te[153],ne([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends w.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(n,o,c,D,P,v){super(),this.galleryService=n,this.telemetryService=o,this.uriIdentityService=c,this.logService=D,this.productService=P,this.userDataProfilesService=v,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this._onDidUpdateExtensionMetadata=this._register(new T.Emitter),this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(({task:R})=>R.cancel()),this.uninstallingExtensions.forEach(R=>R.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(c=>(0,g.isTargetPlatformCompatible)(c,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const D=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:P})=>(0,h.areSameExtensions)(P,n.identifier));if(D?.local)return D?.local;throw D?.error?D.error:r(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(c){throw r(c)}}async installGalleryExtensions(n){if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(C.localize(0,null),g.ExtensionManagementErrorCode.Internal);const o=[],c=[];await Promise.allSettled(n.map(async({extension:D,options:P})=>{try{const v=await this.checkAndGetCompatibleVersion(D,!!P?.installGivenVersion,!!P?.installPreReleaseVersion);c.push({...v,options:P})}catch(v){o.push({identifier:D.identifier,operation:2,source:D,error:v})}})),c.length&&o.push(...await this.installExtensions(c));for(const D of o)D.error&&(this.logService.error("Failed to install extension.",D.identifier.id),this.logService.error(D.error),D.source&&!b.URI.isUri(D.source)&&s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(D.source),error:D.error}));return o}async uninstall(n,o={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,o)}async toggleAppliationScope(n,o){if((0,I.isApplicationScopedExtension)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let c=await this.updateMetadata(n,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)||(c=await this.copyExtension(n,this.userDataProfilesService.defaultProfile.extensionsResource,o));for(const D of this.userDataProfilesService.profiles){const P=(await this.getInstalled(1,D.extensionsResource)).find(v=>(0,h.areSameExtensions)(v.identifier,n.identifier));P?this._onDidUpdateExtensionMetadata.fire(P):this._onDidUninstallExtension.fire({identifier:n.identifier,profileLocation:D.extensionsResource})}return c}else{const c=this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(n,o,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtensions(n){const o=[];return await Promise.allSettled(n.map(async c=>{try{const D=await this.installExtension(c,(P,v)=>n.some(R=>(0,h.adoptToGalleryExtensionId)(v.identifier.id)===(0,h.getGalleryExtensionId)(R.manifest.publisher,R.manifest.name))?!1:this.canWaitForTask(P,v));o.push(...D)}catch(D){o.push({identifier:{id:(0,h.getGalleryExtensionId)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:D})}})),this._onDidInstallExtensions.fire(o),o}async installExtension({manifest:n,extension:o,options:c},D){const P=c.isApplicationScoped||c.isBuiltin||(0,I.isApplicationScopedExtension)(n),v={...c,installOnlyNewlyAddedFromExtensionPack:b.URI.isUri(o)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.userDataProfilesService.defaultProfile.extensionsResource:c.profileLocation??this.getCurrentExtensionsManifestLocation()},R=ue=>`${h.ExtensionKey.create(ue).toString()}${v.profileLocation?`-${v.profileLocation.toString()}`:""}`;if(!b.URI.isUri(o)){const ue=this.installingExtensions.get(R(o));if(ue)return this.logService.info("Extensions is already requested to install",o.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const z=[],Z=[],ee=[],oe=this.createInstallExtensionTask(n,o,v);b.URI.isUri(o)||this.installingExtensions.set(R(o),{task:oe,waitingTasks:[]}),this._onInstallExtension.fire({identifier:oe.identifier,source:o,profileLocation:v.profileLocation}),this.logService.info("Installing extension:",oe.identifier.id),z.push({task:oe,manifest:n});let re=!1;try{if(v.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const le=await this.getAllDepsAndPackExtensions(oe.identifier,n,!!v.installOnlyNewlyAddedFromExtensionPack,!!v.installPreReleaseVersion,v.profileLocation),se=await this.getInstalled(void 0,v.profileLocation),W={...v,donotIncludePackAndDependencies:!0,context:{...v.context,[g.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:K,manifest:V}of(0,N.distinct)(le,({gallery:_})=>_.identifier.id)){re=re||!!V.extensionDependencies?.some(B=>(0,h.areSameExtensions)({id:B},oe.identifier));const _=R(K),$=this.installingExtensions.get(_);if($){if(D(oe,$.task)){const B=$.task.identifier;this.logService.info("Waiting for already requested installing extension",B.id,oe.identifier.id),$.waitingTasks.push(oe),Z.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,X=>X.some(J=>(0,h.areSameExtensions)(J.identifier,B)))).then(X=>{if(this.logService.info("Finished waiting for already requested installing extension",B.id,oe.identifier.id),!X.find(M=>(0,h.areSameExtensions)(M.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!se.some(({identifier:B})=>(0,h.areSameExtensions)(B,K.identifier))){const B=this.createInstallExtensionTask(V,K,W);this.installingExtensions.set(_,{task:B,waitingTasks:[oe]}),this._onInstallExtension.fire({identifier:B.identifier,source:K,profileLocation:v.profileLocation}),this.logService.info("Installing extension:",B.identifier.id,oe.identifier.id),z.push({task:B,manifest:V})}}}catch(le){if(b.URI.isUri(oe.source))(0,N.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",oe.identifier.id,le.message),(0,N.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",oe.identifier.id,le.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),le}const ue=z.reduce((le,{task:se,manifest:W})=>(le.set(se.identifier.id.toLowerCase(),{task:se,manifest:W}),le),new Map);for(;ue.size;){let le;const se=[...ue.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(K=>ue.has(K.toLowerCase())));se.length?le=ue.size===1?se:se.filter(({task:W})=>!(W===oe&&!re)):(this.logService.info("Found extensions with circular dependencies",se.map(({task:W})=>W.identifier.id)),le=[...ue.values()]),await this.joinAllSettled(le.map(async({task:W})=>{const K=new Date().getTime();try{const V=await W.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(V,W.source,v,k.CancellationToken.None))),!b.URI.isUri(W.source)){const _=W.operation===3,$=_?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(s(this.telemetryService,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-K,durationSinceUpdate:$}),u.isWeb&&W.operation!==3)try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}ee.push({local:V,identifier:W.identifier,operation:W.operation,source:W.source,context:W.options.context,profileLocation:W.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw b.URI.isUri(W.source)||s(this.telemetryService,W.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-K,error:V}),this.logService.error("Error while installing the extension:",W.identifier.id),V}finally{ue.delete(W.identifier.id.toLowerCase())}}))}return Z.length&&await this.joinAllSettled(Z),ee.forEach(({identifier:le})=>this.logService.info("Extension installed successfully:",le.id)),ee}catch(ue){if(z.forEach(({task:le})=>le.cancel()),ee.length)try{const le=await Promise.allSettled(ee.map(({local:se})=>this.createUninstallExtensionTask(se,{versionOnly:!0,profileLocation:v.profileLocation}).run()));for(let se=0;se<le.length;se++){const W=le[se],{identifier:K}=ee[se];W.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",K.id):this.logService.warn("Rollback: Error while uninstalling extension",K.id,(0,A.getErrorMessage)(W.reason))}}catch(le){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(le),ee.map(({identifier:se})=>se.id))}return z.map(({task:le})=>({identifier:le.identifier,operation:2,source:le.source,context:v.context,profileLocation:v.profileLocation,error:ue}))}finally{for(const{task:ue}of z)ue.source&&!b.URI.isUri(ue.source)&&this.installingExtensions.delete(R(ue.source))}}canWaitForTask(n,o){for(const[,{task:c,waitingTasks:D}]of this.installingExtensions.entries())if(c===n&&(D.includes(o)||D.some(P=>this.canWaitForTask(P,o)))||c===o&&D[0]&&!this.canWaitForTask(n,D[0]))return!1;return!0}async joinAllSettled(n){const o=[],c=[],D=await Promise.allSettled(n);for(const P of D)P.status==="fulfilled"?o.push(P.value):c.push(P.reason);if(c.length)throw S(c);return o}async getAllDepsAndPackExtensions(n,o,c,D,P){if(!this.galleryService.isEnabled())return[];const v=await this.getInstalled(void 0,P),R=[],z=[],Z=async(ee,oe)=>{R.push(ee);const re=oe.extensionDependencies||[],ue=[...re];if(oe.extensionPack){const le=c?v.find(se=>(0,h.areSameExtensions)(se.identifier,ee)):void 0;for(const se of oe.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(W=>(0,h.areSameExtensions)({id:W},{id:se}))||ue.every(W=>!(0,h.areSameExtensions)({id:W},{id:se}))&&ue.push(se)}if(ue.length){const le=ue.filter(se=>R.every(W=>!(0,h.areSameExtensions)(W,{id:se})));if(le.length){const se=await this.galleryService.getExtensions(le.map(W=>({id:W,preRelease:D})),k.CancellationToken.None);for(const W of se){if(R.find(_=>(0,h.areSameExtensions)(_,W.identifier)))continue;const K=re.some(_=>(0,h.areSameExtensions)({id:_},W.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(W,!1,D)}catch(_){if(K)throw _;this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,A.getErrorMessage)(_));continue}z.push({gallery:V.extension,manifest:V.manifest}),await Z(V.extension.identifier,V.manifest)}}}};return await Z(n,o),z}async checkAndGetCompatibleVersion(n,o,c){let D;const P=await this.getExtensionsControlManifest();if(P.malicious.some(z=>(0,h.areSameExtensions)(n.identifier,z)))throw new g.ExtensionManagementError(C.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const v=P.deprecated[n.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.logService.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),D=(await this.galleryService.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0],!D)throw new g.ExtensionManagementError(C.localize(2,null,n.identifier.id,v.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const z=await this.getTargetPlatform();throw new g.ExtensionManagementError(C.localize(3,null,n.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(z)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(D=await this.getCompatibleVersion(n,o,c),!D)throw!c&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],k.CancellationToken.None))[0]?new g.ExtensionManagementError(C.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.ExtensionManagementError(C.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",D.identifier.id);const R=await this.galleryService.getManifest(D,k.CancellationToken.None);if(R===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${D.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(R.version!==D.version)throw new g.ExtensionManagementError(`Cannot install '${D.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:D,manifest:R}}async getCompatibleVersion(n,o,c){const D=await this.getTargetPlatform();let P=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==c&&(P=(await this.galleryService.getExtensions([{...n.identifier,preRelease:c}],{targetPlatform:D,compatible:!0},k.CancellationToken.None))[0]||null),!P&&await this.galleryService.isExtensionCompatible(n,c,D)&&(P=n),P||(o?P=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:D,compatible:!0},k.CancellationToken.None))[0]||null:P=await this.galleryService.getCompatibleExtension(n,c,D)),P}async uninstallExtension(n,o){const c={...o,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},D=ee=>`${ee.id.toLowerCase()}${c.versionOnly?`-${n.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,P=this.uninstallingExtensions.get(D(n.identifier));if(P)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),P.waitUntilTaskIsFinished();const v=ee=>{const oe=this.createUninstallExtensionTask(ee,c);return this.uninstallingExtensions.set(D(oe.extension.identifier),oe),c.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,c.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this._onUninstallExtension.fire({identifier:ee.identifier,profileLocation:c.profileLocation,applicationScoped:ee.isApplicationScoped}),oe},R=(ee,oe)=>{oe?c.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,c.profileLocation.toString(),oe.message):this.logService.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,oe.message):c.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,c.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(ee),error:oe}),this._onDidUninstallExtension.fire({identifier:ee.identifier,error:oe?.code,profileLocation:c.profileLocation,applicationScoped:ee.isApplicationScoped})},z=[],Z=[];try{z.push(v(n));const ee=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const oe=this.getAllPackExtensionsToUninstall(n,ee);for(const re of oe)this.uninstallingExtensions.has(D(re.identifier))?this.logService.info("Extensions is already requested to uninstall",re.identifier.id):z.push(v(re))}c.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(z.map(oe=>oe.extension),ee,n),await this.joinAllSettled(z.map(async oe=>{try{if(await oe.run(),await this.joinAllSettled(this.participants.map(re=>re.postUninstall(oe.extension,c,k.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.galleryService.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}R(oe.extension)}catch(re){const ue=re instanceof g.ExtensionManagementError?re:new g.ExtensionManagementError((0,A.getErrorMessage)(re),g.ExtensionManagementErrorCode.Internal);throw R(oe.extension,ue),ue}finally{Z.push(oe)}}))}catch(ee){const oe=ee instanceof g.ExtensionManagementError?ee:new g.ExtensionManagementError((0,A.getErrorMessage)(ee),g.ExtensionManagementErrorCode.Internal);for(const re of z){try{re.cancel()}catch{}Z.includes(re)||R(re.extension,oe)}throw oe}finally{for(const ee of z)this.uninstallingExtensions.delete(D(ee.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}checkForDependents(n,o,c){for(const D of n){const P=this.getDependents(D,o);if(P.length){const v=P.filter(R=>!n.some(z=>(0,h.areSameExtensions)(z.identifier,R.identifier)));if(v.length)throw new Error(this.getDependentsErrorMessage(D,v,c))}}}getDependentsErrorMessage(n,o,c){return c===n?o.length===1?C.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?C.localize(9,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(10,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(11,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(n,o,c=[]){if(c.indexOf(n)!==-1)return[];c.push(n);const D=n.manifest.extensionPack?n.manifest.extensionPack:[];if(D.length){const P=o.filter(R=>!R.isBuiltin&&D.some(z=>(0,h.areSameExtensions)({id:z},R.identifier))),v=[];for(const R of P)v.push(...this.getAllPackExtensionsToUninstall(R,o,c));return[...P,...v]}return[]}getDependents(n,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(D=>(0,h.areSameExtensions)({id:D},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=d,e.AbstractExtensionManagementService=d=ve([ie(0,g.IExtensionGalleryService),ie(1,f.ITelemetryService),ie(2,E.IUriIdentityService),ie(3,y.ILogService),ie(4,p.IProductService),ie(5,L.IUserDataProfilesService)],d);function S(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=S;function r(i){if(i instanceof g.ExtensionManagementError)return i;const n=new g.ExtensionManagementError(i.message,g.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.toExtensionManagementError=r;function s(i,n,{extensionData:o,verificationStatus:c,duration:D,error:P,durationSinceUpdate:v}){let R,z;(0,l.isDefined)(c)&&(c===!0?c="Verified":(c===!1||(R=g.ExtensionManagementErrorCode.Signature,z=c),c="Unverified")),P&&(P instanceof g.ExtensionManagementError?(R=P.code,P.code===g.ExtensionManagementErrorCode.Signature&&(z=P.message)):R=g.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...o,verificationStatus:c,success:!P,duration:D,errorcode:R,errorcodeDetail:z,durationSinceUpdate:v})}class t{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(n=>new Promise((o,c)=>{const D=n.onCancellationRequested(()=>{D.dispose(),c(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var E;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(E||(e.ExtensionsProfileScanningErrorCode=E={}));class L extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=L,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let d=class extends k.Disposable{constructor(t,i,n,o,c,D){super(),this.extensionsLocation=t,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=o,this.telemetryService=c,this.logService=D,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(t,i){return this.withProfileExtensions(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],o=[];try{return await this.withProfileExtensions(i,c=>{const D=[];for(const P of c)t.some(([v])=>(0,l.areSameExtensions)(v.identifier,P.identifier)&&v.manifest.version!==P.version)?n.push(P):D.push(P);for(const[P,v]of t){const R=D.findIndex(Z=>(0,l.areSameExtensions)(Z.identifier,P.identifier)&&Z.version===P.manifest.version),z={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:v};R===-1?(o.push(z),D.push(z)):D.splice(R,1,z)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:i}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),D}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i}),o}catch(c){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:c,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:c,profileLocation:i}),c}}async updateMetadata(t,i){const n=[];return await this.withProfileExtensions(i,o=>{const c=[];for(const D of o){const P=t.find(([v])=>(0,l.areSameExtensions)(v.identifier,D.identifier)&&v.manifest.version===D.version);P&&(D.metadata={...D.metadata,...P[1]},n.push(D)),c.push(D)}return c}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.withProfileExtensions(i,o=>{const c=[];for(const D of o)(0,l.areSameExtensions)(D.identifier,t.identifier)?n.push(D):c.push(D);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),c}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:o,profileLocation:i}),o}}async withProfileExtensions(t,i,n){return this.getResourceAccessQueue(t).queue(async()=>{let o=[],c;try{const D=await this.fileService.readFile(t);c=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,b.toFileOperationResult)(D)!==1)throw D;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&n?.bailOutWhenFileNotFound)throw new L((0,p.getErrorMessage)(D),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(t);let D=!1;for(const P of c){S(P)||this.reportAndThrowInvalidConentError(t);let v;if((0,y.isString)(P.relativeLocation)&&P.relativeLocation)v=this.resolveExtensionLocation(P.relativeLocation);else if((0,y.isString)(P.location))v=this.resolveExtensionLocation(P.location),D=!0,P.relativeLocation=P.location,P.location=v.toJSON();else{v=w.URI.revive(P.location);const R=this.toRelativePath(v);R&&(D=!0,P.relativeLocation=R)}o.push({identifier:P.identifier,location:v,version:P.version,metadata:P.metadata})}D&&await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(c)))}if(i){o=i(o);const D=o.map(P=>({identifier:P.identifier,version:P.version,location:P.location.toJSON(),relativeLocation:this.toRelativePath(P.location),metadata:P.metadata}));await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(D)))}return o})}reportAndThrowInvalidConentError(t){const i=new L(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(t)).value.toString()}catch(c){if((0,b.toFileOperationResult)(c)===1)return;throw c}this.logService.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(n);Array.isArray(c)&&c.every(D=>S(D))?o=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,b.toFileOperationResult)(c)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(t)}catch(c){(0,b.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{await this.fileService.del(i)}catch(c){(0,b.toFileOperationResult)(c)!==1&&this.logService.error(c)}return o})()),this._migrationPromise}getResourceAccessQueue(t){let i=this.resourcesAccessQueueMap.get(t);return i||(i=new N.Queue,this.resourcesAccessQueueMap.set(t,i)),i}};e.AbstractExtensionsProfileScannerService=d,e.AbstractExtensionsProfileScannerService=d=ve([ie(1,b.IFileService),ie(2,h.IUserDataProfilesService),ie(3,I.IUriIdentityService),ie(4,f.ITelemetryService),ie(5,g.ILogService)],d);function S(s){return(0,y.isObject)(s)&&(0,u.isIExtensionIdentifier)(s.identifier)&&(r(s.location)||(0,y.isString)(s.location)&&s.location)&&((0,y.isUndefined)(s.relativeLocation)||(0,y.isString)(s.relativeLocation))&&s.version&&(0,y.isString)(s.version)}function r(s){return s?(0,y.isString)(s.path)&&(0,y.isString)(s.scheme):!1}}),define(te[50],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,46,40,23,22,112]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E,L,d,S,r,s,t,i,n,o,c,D,P,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var z;(function(se){function W(K,V){if(K===V)return!0;const _=Object.keys(K),$=new Set;for(const B of Object.keys(V))$.add(B);if(_.length!==$.size)return!1;for(const B of _){if(K[B]!==V[B])return!1;$.delete(B)}return $.size===0}se.equals=W})(z||(e.Translations=z={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let Z=class extends l.Disposable{constructor(W,K,V,_,$,B,X,J,M,F,a,m){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=K,this.extensionsControlLocation=V,this.currentProfile=_,this.userDataProfilesService=$,this.extensionsProfileScannerService=B,this.fileService=X,this.logService=J,this.environmentService=M,this.productService=F,this.uriIdentityService=a,this.instantiationService=m,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,K,V){const[_,$]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(K)]),B=V?await this.scanExtensionsUnderDevelopment(W,[..._,...$]):[];return this.dedupExtensions(_,$,B,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const K=[];K.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),K.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[V,_]=await Promise.all(K);return this.applyScanOptions([...V,..._],0,W,!1)}async scanUserExtensions(W){const K=W.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",K);const V=this.uriIdentityService.extUri.isEqual(W.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,_=await this.createExtensionScannerInput(K,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V),$=W.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let B;try{B=await $.scanExtensions(_)}catch(X){if(X instanceof D.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),B=await $.scanExtensions(_);else throw X}return B=await this.applyScanOptions(B,1,W,!0),this.logService.trace("Scanned user extensions:",B.length),B}async scanExtensionsUnderDevelopment(W,K){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(_=>_.scheme===b.Schemas.file).map(async _=>{const $=await this.createExtensionScannerInput(_,!1,1,!0,W.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(X=>(X.type=K.find(J=>(0,d.areSameExtensions)(J.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,$)))}))).flat();return this.applyScanOptions(V,"development",W,!0)}return[]}async scanExistingExtension(W,K,V){const _=await this.createExtensionScannerInput(W,!1,K,!0,V.language,!0,void 0),$=await this.extensionsScanner.scanExtension(_);return!$||!V.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(W,K,V){const _=await this.createExtensionScannerInput(W,!1,K,!0,V.language,!0,void 0),$=await this.extensionsScanner.scanOneOrMultipleExtensions(_);return this.applyScanOptions($,K,V,!0)}async scanMetadata(W){const K=(0,h.joinPath)(W,"package.json"),V=(await this.fileService.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,K){const V=(0,h.joinPath)(W,"package.json"),_=(await this.fileService.readFile(V)).value.toString(),$=JSON.parse(_);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,$.__metadata={...$.__metadata,...K},await this.fileService.writeFile((0,h.joinPath)(W,"package.json"),A.VSBuffer.fromString(JSON.stringify($,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof D.ExtensionsProfileScanningError&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw W}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.extensionsProfileScannerService.addExtensionsToProfile(W.map(K=>[K,K.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(K){(0,s.toFileOperationResult)(K)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(K))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.logService.error(W)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(W,K,V,_){return V.includeAllVersions||(W=this.dedupExtensions(K===0?W:void 0,K===1?W:void 0,K==="development"?W:void 0,await this.getTargetPlatform(),_)),V.includeInvalid||(W=W.filter($=>$.isValid)),W.sort(($,B)=>{const X=C.basename($.location.fsPath),J=C.basename(B.location.fsPath);return X<J?-1:X>J?1:0})}dedupExtensions(W,K,V,_,$){const B=(J,M,F)=>{if(J.isValid&&!M.isValid)return!1;if(J.isValid===M.isValid){if($&&I.gt(J.manifest.version,M.manifest.version))return this.logService.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(I.eq(J.manifest.version,M.manifest.version)){if(J.type===0)return this.logService.debug(`Skipping extension ${M.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===_)return this.logService.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return F?this.logService.warn(`Overwriting user extension ${J.location.path} with ${M.location.path}.`):this.logService.debug(`Overwriting user extension ${J.location.path} with ${M.location.path}.`),!0},X=new S.ExtensionIdentifierMap;return W?.forEach(J=>{const M=X.get(J.identifier.id);(!M||B(M,J,!1))&&X.set(J.identifier.id,J)}),K?.forEach(J=>{const M=X.get(J.identifier.id);if(!M&&W&&J.type===0){this.logService.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!M||B(M,J,!1))&&X.set(J.identifier.id,J)}),V?.forEach(J=>{const M=X.get(J.identifier.id);(!M||B(M,J,!0))&&X.set(J.identifier.id,J),X.set(J.identifier.id,J)}),[...X.values()]}async scanDefaultSystemExtensions(W,K){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),$=await(W&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(W,K){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const _=K?await this.getBuiltInExtensionControl():{},$=[],B=f.URI.file(C.normalize(C.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of V){const M=_[J.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":$.push((0,h.joinPath)(B,J.name));break;default:$.push(f.URI.file(M));break}}const X=await Promise.all($.map(async J=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(J,!1,0,!0,W,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,N.coalesce)(X)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,K,V,_,$,B,X){const J=await this.getTranslations($??g.language),M=await this.getMtime(W),F=K&&!this.uriIdentityService.extUri.isEqual(W,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,a=F?await this.getMtime(F):void 0;return new ee(W,M,F,a,K,X,V,_,B,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,J)}async getMtime(W){try{const K=await this.fileService.stat(W);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.AbstractExtensionsScannerService=Z,e.AbstractExtensionsScannerService=Z=ve([ie(4,P.IUserDataProfilesService),ie(5,D.IExtensionsProfileScannerService),ie(6,s.IFileService),ie(7,i.ILogService),ie(8,L.IEnvironmentService),ie(9,n.IProductService),ie(10,v.IUriIdentityService),ie(11,t.IInstantiationService)],Z);class ee{constructor(W,K,V,_,$,B,X,J,M,F,a,m,x,U,H){this.location=W,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=_,this.profile=$,this.profileScanOptions=B,this.type=X,this.excludeObsolete=J,this.validate=M,this.productVersion=F,this.productDate=a,this.productCommit=m,this.devMode=x,this.language=U,this.translations=H}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,K){return(0,h.isEqual)(W.location,K.location)&&W.mtime===K.mtime&&(0,h.isEqual)(W.applicationExtensionslocation,K.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&W.profile===K.profile&&k.equals(W.profileScanOptions,K.profileScanOptions)&&W.type===K.type&&W.excludeObsolete===K.excludeObsolete&&W.validate===K.validate&&W.productVersion===K.productVersion&&W.productDate===K.productDate&&W.productCommit===K.productCommit&&W.devMode===K.devMode&&W.language===K.language&&z.equals(W.translations,K.translations)}}e.ExtensionScannerInput=ee;let oe=class extends l.Disposable{constructor(W,K,V,_,$){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=K,this.uriIdentityService=V,this.fileService=_,this.logService=$}async scanExtensions(W){const K=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let V={};if(W.excludeObsolete&&W.type===1)try{const _=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(_)}catch{}return(0,p.isEmptyObject)(V)?K:K.filter(_=>!V[d.ExtensionKey.create(_).toString()])}async scanExtensionsFromLocation(W){const K=await this.fileService.resolve(W.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async _=>{if(!_.isDirectory||W.type===1&&(0,h.basename)(_.resource).indexOf(".")===0)return null;const $=new ee(_.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension($)}));return(0,N.coalesce)(V).sort((_,$)=>_.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(W){let K=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){K=K.filter(_=>!_.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,_=>!!_.metadata?.isBuiltin||!!_.metadata?.isApplicationScoped,W);K.push(...V)}return K}async scanExtensionsFromProfileResource(W,K,V){const _=await this.extensionsProfileScannerService.scanProfileExtensions(W,V.profileScanOptions);if(!_.length)return[];const $=await Promise.all(_.map(async B=>{if(K(B)){const X=new ee(B.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(X,B.metadata)}return null}));return(0,N.coalesce)($)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,h.joinPath)(W.location,"package.json"))){const K=await this.scanExtension(W);return K?[K]:[]}else return await this.scanExtensions(W)}catch(K){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,T.getErrorMessage)(K)),[]}}async scanExtension(W,K){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=S.UNDEFINED_PUBLISHER),K=K??V.__metadata,delete V.__metadata;const _=(0,d.getGalleryExtensionId)(V.publisher,V.name),$=K?.id?{id:_,uuid:K.id}:{id:_},B=K?.isSystem?0:W.type,X=B===0||!!K?.isBuiltin;V=await this.translateManifest(W.location,V,ee.createNlsConfiguration(W));const J={type:B,identifier:$,manifest:V,location:W.location,isBuiltin:X,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return W.validate?this.validate(J,W):J}}catch(V){W.type!==0&&this.logService.error(V)}return null}validate(W,K){let V=!0;const _=(0,r.validateExtensionManifest)(K.productVersion,K.productDate,K.location,W.manifest,W.isBuiltin);for(const[$,B]of _)$===y.default.Error&&(V=!1,this.logService.error(this.formatMessage(K.location,B)));return W.isValid=V,W.validations=_,W}async scanExtensionManifest(W){const K=(0,h.joinPath)(W,"package.json");let V;try{V=(await this.fileService.readFile(K)).value.toString()}catch($){return(0,s.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(W,(0,E.localize)(0,null,K.path,$.message))),null}let _;try{_=JSON.parse(V)}catch{const B=[];(0,w.parse)(V,B);for(const X of B)this.logService.error(this.formatMessage(W,(0,E.localize)(1,null,K.path,X.offset,X.length,(0,u.getParseErrorMessage)(X.error))));return null}return(0,w.getNodeType)(_)!=="object"?(this.logService.error(this.formatMessage(W,(0,E.localize)(2,null,K.path))),null):_}async translateManifest(W,K,V){const _=await this.getLocalizedMessages(W,K,V);if(_)try{const $=[],B=await this.resolveOriginalMessageBundle(_.default,$);if($.length>0)return $.forEach(J=>{this.logService.error(this.formatMessage(W,(0,E.localize)(3,null,_.default?.path,(0,u.getParseErrorMessage)(J.error))))}),K;if((0,w.getNodeType)(_)!=="object")return this.logService.error(this.formatMessage(W,(0,E.localize)(4,null,_.default?.path))),K;const X=_.values||Object.create(null);return(0,R.localizeManifest)(this.logService,K,X,B)}catch{}return K}async getLocalizedMessages(W,K,V){const _=(0,h.joinPath)(W,"package.nls.json"),$=(M,F)=>{F.forEach(a=>{this.logService.error(this.formatMessage(W,(0,E.localize)(5,null,M?.path,(0,u.getParseErrorMessage)(a.error))))})},B=M=>{this.logService.error(this.formatMessage(W,(0,E.localize)(6,null,M?.path)))},X=`${K.publisher}.${K.name}`,J=V.translations[X];if(J)try{const M=f.URI.file(J),F=(await this.fileService.readFile(M)).value.toString(),a=[],m=(0,w.parse)(F,a);return a.length>0?($(M,a),{values:void 0,default:_}):(0,w.getNodeType)(m)!=="object"?(B(M),{values:void 0,default:_}):{values:m.contents?m.contents.package:void 0,default:_}}catch{return{values:void 0,default:_}}else{if(!await this.fileService.exists(_))return;let F;try{F=await this.findMessageBundles(W,V)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const a=(await this.fileService.readFile(F.localized)).value.toString(),m=[],x=(0,w.parse)(a,m);return m.length>0?($(F.localized,m),{values:void 0,default:F.original}):(0,w.getNodeType)(x)!=="object"?(B(F.localized),{values:void 0,default:F.original}):{values:x,default:F.original}}catch{return{values:void 0,default:F.original}}}}async resolveOriginalMessageBundle(W,K){if(W)try{const V=(await this.fileService.readFile(W)).value.toString();return(0,w.parse)(V,K)}catch{}}findMessageBundles(W,K){return new Promise((V,_)=>{const $=B=>{const X=(0,h.joinPath)(W,`package.nls.${B}.json`);this.fileService.exists(X).then(J=>{J&&V({localized:X,original:(0,h.joinPath)(W,"package.nls.json")});const M=B.lastIndexOf("-");M===-1?V({localized:(0,h.joinPath)(W,"package.nls.json"),original:null}):(B=B.substring(0,M),$(B))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,h.joinPath)(W,"package.nls.json"),original:null});$(K.language)})}formatMessage(W,K){return`[${W.path}]: ${K}`}};oe=ve([ie(1,D.IExtensionsProfileScannerService),ie(2,v.IUriIdentityService),ie(3,s.IFileService),ie(4,i.ILogService)],oe);let re=class extends oe{constructor(W,K,V,_,$,B,X){super(K,_,$,B,X),this.currentProfile=W,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const K=this.getCacheFile(W),V=await this.readExtensionCache(K);if(this.input=W,V&&V.input&&ee.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",W.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map($=>($.location=f.URI.revive($.location),$));const _=await super.scanExtensions(W);return await this.writeExtensionCache(K,{input:W,result:_}),_}async readExtensionCache(W){try{const K=await this.fileService.readFile(W),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,c.revive)(V.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",W.path,(0,T.getErrorMessage)(K))}return null}async writeExtensionCache(W,K){try{await this.fileService.writeFile(W,A.VSBuffer.fromString(JSON.stringify(K)))}catch(V){this.logService.debug("Error while writing the extension cache file:",W.path,(0,T.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const W=this.getCacheFile(this.input),K=await this.readExtensionCache(W);if(!K)return;const V=K.result,_=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(_,V))try{this.logService.info("Invalidating Cache",V,_),await this.fileService.del(W),this._onDidChangeCache.fire()}catch($){this.logService.error($)}}getCacheFile(W){const K=this.getProfile(W);return this.uriIdentityService.extUri.joinPath(K.cacheHome,W.type===0?S.BUILTIN_MANIFEST_CACHE_FILE:S.USER_MANIFEST_CACHE_FILE)}getProfile(W){return W.type===0?this.userDataProfilesService.defaultProfile:W.profile?this.uriIdentityService.extUri.isEqual(W.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(K=>this.uriIdentityService.extUri.isEqual(W.location,K.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};re=ve([ie(2,P.IUserDataProfilesService),ie(3,D.IExtensionsProfileScannerService),ie(4,v.IUriIdentityService),ie(5,s.IFileService),ie(6,i.ILogService)],re);function ue(se,W){const K=(0,d.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:K,identifier:new S.ExtensionIdentifier(K),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:W,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.toExtensionDescription=ue;class le extends Z{constructor(W,K,V,_,$,B,X,J,M,F,a,m){super(W,K,(0,h.joinPath)(V,".vscode-oss-dev","extensions","control.json"),_,$,B,X,J,M,F,a,m),this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const x=await this.fileService.readFile(f.URI.file(g.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=le}),define(te[154],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(G,e,N,O,k,A,T,w,u,l,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends T.Disposable{constructor(I,y){super(),this.userDataProfilesService=I,this.logService=y,this.processesLimiter=new O.Limiter(5)}async postUninstall(I){const y=this.parseScript(I,"uninstall");y&&(this.logService.info(I.identifier.id,I.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(y.script,"uninstall",y.args,!0,I),this.logService.info("Finished running post uninstall script",I.identifier.id,I.manifest.version)}catch(p){this.logService.error("Failed to run post uninstall script",I.identifier.id,I.manifest.version),this.logService.error(p)}}));try{await l.Promises.rm(this.getExtensionStoragePath(I))}catch(p){this.logService.error("Error while removing extension storage path",I.identifier.id),this.logService.error(p)}}parseScript(I,y){const p=`vscode:${y}`;if(I.location.scheme===w.Schemas.file&&I.manifest&&I.manifest.scripts&&typeof I.manifest.scripts[p]=="string"){const f=I.manifest.scripts[p].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(I.identifier.id,I.manifest.version,`${p} should be a node script`),null):{script:(0,u.join)(I.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(I,y,p,f,E){return new Promise((L,d)=>{const S=this.start(I,y,p,E);let r;const s=t=>{r&&(clearTimeout(r),r=null),t?d(t):L(void 0)};S.on("error",t=>{s((0,k.toErrorMessage)(t)||"Unknown")}),S.on("exit",(t,i)=>{s(t?`post-${y} process exited with code ${t}`:void 0)}),f&&(r=setTimeout(()=>{r=null,S.kill(),d("timed out")},5e3))})}start(I,y,p,f){const E={silent:!0,execArgv:void 0},L=(0,N.fork)(I,[`--type=extension-post-${y}`,...p],E);L.stdout.setEncoding("utf8"),L.stderr.setEncoding("utf8");const d=A.Event.fromNodeEventEmitter(L.stdout,"data"),S=A.Event.fromNodeEventEmitter(L.stderr,"data");d(t=>this.logService.info(f.identifier.id,f.manifest.version,`post-${y}`,t)),S(t=>this.logService.error(f.identifier.id,f.manifest.version,`post-${y}`,t));const r=A.Event.any(A.Event.map(d,t=>({data:`%c${t}`,format:[""]})),A.Event.map(S,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(r,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(f.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),L}getExtensionStoragePath(I){return(0,u.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,I.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=g,e.ExtensionsLifecycle=g=ve([ie(0,C.IUserDataProfilesService),ie(1,b.ILogService)],g)}),define(te[155],ne([0,1,6,23,22,26,40,12,18,11]),function(G,e,N,O,k,A,T,w,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends T.AbstractExtensionsProfileScannerService{constructor(g,h,I,y,p,f){super(l.URI.file(g.extensionsPath),h,I,y,p,f)}};e.ExtensionsProfileScannerService=b,e.ExtensionsProfileScannerService=b=ve([ie(0,u.INativeEnvironmentService),ie(1,w.IFileService),ie(2,O.IUserDataProfilesService),ie(3,k.IUriIdentityService),ie(4,A.ITelemetryService),ie(5,N.ILogService)],b)}),define(te[156],ne([0,1,11,18,40,50,12,10,6,32,22,23]),function(G,e,N,O,k,A,T,w,u,l,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends A.NativeExtensionsScannerService{constructor(I,y,p,f,E,L,d,S){super(N.URI.file(E.builtinExtensionsPath),N.URI.file(E.extensionsPath),E.userHome,I.defaultProfile,I,y,p,f,E,L,d,S)}};e.ExtensionsScannerService=g,e.ExtensionsScannerService=g=ve([ie(0,C.IUserDataProfilesService),ie(1,k.IExtensionsProfileScannerService),ie(2,T.IFileService),ie(3,u.ILogService),ie(4,O.INativeEnvironmentService),ie(5,l.IProductService),ie(6,b.IUriIdentityService),ie(7,w.IInstantiationService)],g)}),define(te[157],ne([0,1,8,4,2,123,3,86,10,23]),function(G,e,N,O,k,A,T,w,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var b;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var C;(function(E){E[E.APPLICATION=-1]="APPLICATION",E[E.PROFILE=0]="PROFILE",E[E.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var g;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function h(E){const L=E.get(e.TARGET_KEY);if(L)try{return JSON.parse(L)}catch{}return Object.create(null)}e.loadKeyTargets=h;class I extends k.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(L={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super(),this.options=L,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new N.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(L,d,S){return O.Event.filter(this._onDidChangeValue.event,r=>r.scope===L&&(d===void 0||r.key===d),S)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,N.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(L,d){const{key:S,external:r}=d;if(S===e.TARGET_KEY){switch(L){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:L})}else this._onDidChangeValue.fire({scope:L,key:S,target:this.getKeyTargets(L)[S],external:r})}emitWillSaveState(L){this._onWillSaveState.fire({reason:L})}get(L,d,S){return this.getStorage(d)?.get(L,S)}getBoolean(L,d,S){return this.getStorage(d)?.getBoolean(L,S)}getNumber(L,d,S){return this.getStorage(d)?.getNumber(L,S)}getObject(L,d,S){return this.getStorage(d)?.getObject(L,S)}storeAll(L,d){this.withPausedEmitters(()=>{for(const S of L)this.store(S.key,S.value,S.scope,S.target,d)})}store(L,d,S,r,s=!1){if((0,T.isUndefinedOrNull)(d)){this.remove(L,S,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(L,S,r),this.getStorage(S)?.set(L,d,s)})}remove(L,d,S=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(L,d,void 0),this.getStorage(d)?.delete(L,S)})}withPausedEmitters(L){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{L()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(L,d){const S=[],r=this.getKeyTargets(L);for(const s of Object.keys(r))r[s]===d&&S.push(s);return S}updateKeyTarget(L,d,S,r=!1){const s=this.getKeyTargets(d);typeof S=="number"?s[L]!==S&&(s[L]=S,this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(s),r)):typeof s[L]=="number"&&(delete s[L],this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(s),r))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(L){switch(L){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(L){const d=this.getStorage(L);return d?h(d):Object.create(null)}isNew(L){return this.getBoolean(e.IS_NEW_KEY,L)===!0}async flush(L=b.NONE){this._onWillSaveState.fire({reason:L});const d=this.getStorage(-1),S=this.getStorage(0),r=this.getStorage(1);switch(L){case b.NONE:await N.Promises.settled([d?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await N.Promises.settled([d?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const L=this.getStorage(-1)?.items??new Map,d=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return f(L,d,S,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(L){return await this.flush(),this.getStorage(L)?.optimize()}async switch(L,d){return this.emitWillSaveState(b.NONE),(0,l.isUserDataProfile)(L)?this.switchToProfile(L,d):this.switchToWorkspace(L,d)}canSwitchProfile(L,d){return!(L.id===d.id||y(d)&&y(L))}switchData(L,d,S){this.withPausedEmitters(()=>{const r=new Set;for(const[s,t]of L)r.add(s),d.get(s)!==t&&this.emitDidChangeValue(S,{key:s,external:!0});for(const[s]of d.items)r.has(s)||this.emitDidChangeValue(S,{key:s,external:!0})})}}e.AbstractStorageService=I;function y(E){return E.isDefault||!!E.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=y;class p extends I{constructor(){super(),this.applicationStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(L=>this.emitDidChangeValue(1,L))),this._register(this.profileStorage.onDidChangeStorage(L=>this.emitDidChangeValue(0,L))),this._register(this.applicationStorage.onDidChangeStorage(L=>this.emitDidChangeValue(-1,L)))}getStorage(L){switch(L){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(L){switch(L){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(L){return!1}}e.InMemoryStorageService=p;async function f(E,L,d,S,r,s){const t=z=>{try{return JSON.parse(z)}catch{return z}},i=new Map,n=new Map;E.forEach((z,Z)=>{i.set(Z,z),n.set(Z,t(z))});const o=new Map,c=new Map;L.forEach((z,Z)=>{o.set(Z,z),c.set(Z,t(z))});const D=new Map,P=new Map;d.forEach((z,Z)=>{D.set(Z,z),P.set(Z,t(z))}),console.group(S!==r?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const v=[];if(i.forEach((z,Z)=>{v.push({key:Z,value:z})}),console.table(v),console.groupEnd(),console.log(n),S!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const z=[];o.forEach((Z,ee)=>{z.push({key:ee,value:Z})}),console.table(z),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${s})`);const R=[];D.forEach((z,Z)=>{R.push({key:Z,value:z})}),console.table(R),console.groupEnd(),console.log(P)}e.logStorage=f}),define(te[158],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E,L,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=A.isWeb?"web":(0,C.getTargetPlatform)(A.platform,T.arch),s="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((m,x)=>m|x,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class v{constructor(m=P){this.state=m}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(m,x=this.state.pageSize){return new v({...this.state,pageNumber:m,pageSize:x})}withFilter(m,...x){const U=[...this.state.criteria,...x.length?x.map(H=>({filterType:m,value:H})):[{filterType:m}]];return new v({...this.state,criteria:U})}withSortBy(m){return new v({...this.state,sortBy:m})}withSortOrder(m){return new v({...this.state,sortOrder:m})}withFlags(...m){return new v({...this.state,flags:m.reduce((x,U)=>x|U,0)})}withAssetTypes(...m){return new v({...this.state,assetTypes:m})}withSource(m){return new v({...this.state,source:m})}get raw(){const{criteria:m,pageNumber:x,pageSize:U,sortBy:H,sortOrder:q,flags:ce,assetTypes:ae}=this.state;return{filters:[{criteria:m,pageNumber:x,pageSize:U,sortBy:H,sortOrder:q}],assetTypes:ae,flags:ce}}get searchText(){const m=this.state.criteria.filter(x=>x.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(m=>String(m.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function R(a,m){const x=(a||[]).filter(U=>U.statisticName===m)[0];return x?x.value:0}function z(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(U=>U.assetType.indexOf(m)===0).reduce((U,H)=>{const q=oe(a,H.assetType);return q&&U.push([H.assetType.substring(m.length),q]),U},[])}function Z(a){if(a.properties){const m=a.properties.filter(H=>H.key===o.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=m.filter(H=>x.test(H.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return oe(a,o.Repository)}function ee(a){return{uri:`${a.fallbackAssetUri}/${o.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${o.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function oe(a,m){return a.files.filter(U=>U.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function re(a,m){const x=a.properties?a.properties.filter(H=>H.key===m):[],U=x.length>0&&x[0].value;return U?U.split(",").map(H=>(0,g.adoptToGalleryExtensionId)(H)):[]}function ue(a){const m=a.properties?a.properties.filter(x=>x.key===c.Engine):[];return m.length>0&&m[0].value||""}function le(a){const m=a.properties?a.properties.filter(x=>x.key===c.PreRelease):[];return m.length>0&&m[0].value==="true"}function se(a){const m=a.properties?a.properties.filter(U=>U.key===c.LocalizedLanguages):[],x=m.length>0&&m[0].value||"";return x?x.split(","):[]}function W(a){return a.properties?.find(m=>m.key===c.SponsorLink)?.value}function K(a){return a.indexOf("preview")!==-1}function V(a){return a.targetPlatform?(0,C.toTargetPlatform)(a.targetPlatform):"undefined"}function _(a){const m=(0,N.distinct)(a.versions.map(V)),x=!!a.tags?.includes(C.WEB_EXTENSION_TAG),U=m.indexOf("web");return x?U===-1&&m.push("web"):U!==-1&&m.splice(U,1),m}function $(a,m){for(let x=0;x<a.length;x++){const U=a[x];if(U.version===a[x-1]?.version){let H=x;if(V(U)===m)for(;H>0&&a[H-1].version===U.version;)H--;H!==x&&(a.splice(x,1),a.splice(H,0,U))}}return a}e.sortExtensionVersions=$;function B(a,m,x){a.telemetryData={index:m,querySource:x,queryActivityId:a.queryContext?.[s]}}function X(a,m,x,U){const H=a.versions[0],q={manifest:oe(m,o.Manifest),readme:oe(m,o.Details),changelog:oe(m,o.Changelog),license:oe(m,o.License),repository:Z(m),download:ee(m),icon:oe(m,o.Icon),signature:oe(m,o.Signature),coreTranslations:z(m)};return{identifier:{id:(0,g.getGalleryExtensionId)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(H),description:a.shortDescription||"",installCount:R(a.statistics,"install"),rating:R(a.statistics,"averagerating"),ratingCount:R(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:x,assets:q,properties:{dependencies:re(m,c.Dependency),extensionPack:re(m,c.ExtensionPack),engine:ue(m),localizedLanguages:se(m),targetPlatform:V(m),isPreReleaseVersion:le(m)},hasPreReleaseVersion:le(H),hasReleaseVersion:!0,preview:K(a.flags),isSigned:!!q.signature,queryContext:U}}let J=class{constructor(m,x,U,H,q,ce,ae,me){this.requestService=x,this.logService=U,this.environmentService=H,this.telemetryService=q,this.fileService=ce,this.productService=ae,this.configurationService=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ge?de.servicePPEUrl:de?.serviceUrl,this.extensionsGallerySearchUrl=ge?void 0:de?.searchUrl,this.extensionsControlUrl=de?.controlUrl,this.commonHeadersPromise=(0,E.resolveMarketplaceHeaders)(ae.version,ae,this.environmentService,this.configurationService,this.fileService,m,this.telemetryService)}api(m=""){return`${this.extensionsGalleryUrl}${m}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(m,x,U){const H=O.CancellationToken.isCancellationToken(x)?{}:x,q=O.CancellationToken.isCancellationToken(x)?x:U,ce=[],ae=[],me=[],de=[];let ge=!0;for(const Se of m){Se.uuid?ae.push(Se.uuid):ce.push(Se.id);const we=!!(Se.version||Se.preRelease);me.push({id:Se.id,uuid:Se.uuid,includePreRelease:we}),Se.version&&de.push({id:Se.id,uuid:Se.uuid,version:Se.version}),ge=ge&&!!Se.hasPreRelease&&!we}if(!ae.length&&!ce.length)return[];let he=new v().withPage(1,m.length);ae.length&&(he=he.withFilter(n.ExtensionId,...ae)),ce.length&&(he=he.withFilter(n.ExtensionName,...ce)),(H.queryAllVersions||ge)&&(he=he.withFlags(he.flags,t.IncludeVersions)),H.source&&(he=he.withSource(H.source));const{extensions:fe}=await this.queryGalleryExtensions(he,{targetPlatform:H.targetPlatform??r,includePreRelease:me,versions:de,compatible:!!H.compatible},q);return H.source&&fe.forEach((Se,we)=>B(Se,we,H.source)),fe}async getCompatibleExtension(m,x,U){if((0,C.isNotWebExtensionInWebTargetPlatform)(m.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(m,x,U))return m;const H=new v().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:q}=await this.queryGalleryExtensions(H,{targetPlatform:U,compatible:!0,includePreRelease:x},O.CancellationToken.None);return q[0]||null}async isExtensionCompatible(m,x,U){if(!(0,C.isTargetPlatformCompatible)(m.properties.targetPlatform,m.allTargetPlatforms,U)||!x&&m.properties.isPreReleaseVersion)return!1;let H=m.properties.engine;if(!H){const q=await this.getManifest(m,O.CancellationToken.None);if(!q)throw new Error("Manifest was not found");H=q.engines.vscode}return(0,h.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(m,x,U,H,q){if(!(0,C.isTargetPlatformCompatible)(V(m),H,q)||x!=="any"&&le(m)!==(x==="prerelease"))return!1;if(U)try{const ce=await this.getEngine(m);if(!(0,h.isEngineValid)(ce,this.productService.version,this.productService.date))return!1}catch(ce){return this.logService.error(`Error while getting the engine for the version ${m.version}.`,(0,k.getErrorMessage)(ce)),!1}return!0}async query(m,x){let U=m.text||"";const H=m.pageSize??50;let q=new v().withPage(1,H);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,he,fe)=>(q=q.withFilter(n.Category,fe||he),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,he,fe)=>(q=q.withFilter(n.Tag,fe||he),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(q=q.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),q=q.withFilter(n.SearchText,U)),q=q.withSortBy(0)):m.ids?q=q.withFilter(n.ExtensionId,...m.ids):m.names?q=q.withFilter(n.ExtensionName,...m.names):q=q.withSortBy(4),typeof m.sortBy=="number"&&(q=q.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(q=q.withSortOrder(m.sortOrder)),m.source&&(q=q.withSource(m.source));const ce=async(ge,he)=>{const{extensions:fe,total:Se}=await this.queryGalleryExtensions(ge,{targetPlatform:r,compatible:!1,includePreRelease:!!m.includePreRelease},he);return fe.forEach((we,be)=>B(we,(ge.pageNumber-1)*ge.pageSize+be,m.source)),{extensions:fe,total:Se}},{extensions:ae,total:me}=await ce(q,x),de=async(ge,he)=>{if(he.isCancellationRequested)throw new k.CancellationError;const{extensions:fe}=await ce(q.withPage(ge+1),he);return fe};return{firstPage:ae,total:me,pageSize:q.pageSize,getPage:de}}async queryGalleryExtensions(m,x,U){const H=m.flags;m.flags&t.IncludeLatestVersionOnly&&m.flags&t.IncludeVersions&&(m=m.withFlags(m.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(m.flags&t.IncludeLatestVersionOnly)&&!(m.flags&t.IncludeVersions)&&(m=m.withFlags(m.flags,t.IncludeLatestVersionOnly)),x.versions?.length&&(m=m.withFlags(m.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),m=m.withFlags(m.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:q,total:ce,context:ae}=await this.queryRawGalleryExtensions(m,U);if(!(m.flags&t.IncludeLatestVersionOnly)){const he=[];for(const fe of q){const Se=await this.toGalleryExtensionWithCriteria(fe,x,ae);Se&&he.push(Se)}return{extensions:he,total:ce}}const de=[],ge=new Map;for(let he=0;he<q.length;he++){const fe=q[he],Se={id:(0,g.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),uuid:fe.extensionId},we=(0,w.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Me=>(0,g.areSameExtensions)(Me,Se))?.includePreRelease;if(x.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(_(fe),x.targetPlatform))continue;const be=await this.toGalleryExtensionWithCriteria(fe,x,ae);!be||be.properties.isPreReleaseVersion&&(!we||!be.hasReleaseVersion)||!be.properties.isPreReleaseVersion&&be.properties.targetPlatform!==x.targetPlatform&&be.hasPreReleaseVersion?ge.set(fe.extensionId,he):de.push([he,be])}if(ge.size){const he=new S.StopWatch,fe=new v().withFlags(H&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:Se}=await this.queryGalleryExtensions(fe,x,U);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:he.elapsed(),count:ge.size});for(const we of Se){const be=ge.get(we.identifier.uuid);de.push([be,we])}}return{extensions:de.sort((he,fe)=>he[0]-fe[0]).map(([,he])=>he),total:ce}}async toGalleryExtensionWithCriteria(m,x,U){const H={id:(0,g.getGalleryExtensionId)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},q=x.versions?.find(de=>(0,g.areSameExtensions)(de,H))?.version,ce=(0,w.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(de=>(0,g.areSameExtensions)(de,H))?.includePreRelease,ae=_(m),me=$(m.versions,x.targetPlatform);if(x.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(ae,x.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(q&&ge.version!==q)){if(await this.isValidVersion(ge,ce?"any":"release",x.compatible,ae,x.targetPlatform))return X(m,ge,ae,U);if(q&&ge.version===q)return null}}return q||x.compatible?null:X(m,m.versions[0],ae)}async queryRawGalleryExtensions(m,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const U=await this.commonHeadersPromise,H=JSON.stringify(m.raw),q={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ce=new S.StopWatch;let ae,me,de=0;try{if(ae=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&m.criteria.some(he=>he.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:H,headers:q},x),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,f.asJson)(ae);if(ge){const he=ge.results[0],fe=he.extensions,Se=he.resultMetadata&&he.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return de=Se&&Se.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:de,context:{[s]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(H.length),duration:ce.elapsed(),success:!!ae&&(0,f.isSuccess)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,k.isCancellationError)(me)?"canceled":(0,k.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,x,U,H){if(!this.isEnabled())return;const q=A.isWeb?this.api(`/itemName/${m}.${x}/version/${U}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${m}/extensions/${x}/${U}/stats?statType=${H}`),ce=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:q,headers:me},O.CancellationToken.None)}catch{}}async download(m,x,U){this.logService.trace("ExtensionGalleryService#download",m.identifier.id);const H=(0,g.getGalleryExtensionTelemetryData)(m),q=new Date().getTime(),ce=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:he}),ae=U===2?"install":U===3?"update":"",me=ae?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:m.assets.download,de=m.queryContext?.[s]?{[s]:m.queryContext[s]}:void 0,ge=await this.getAsset(me,de?{headers:de}:void 0);await this.fileService.writeFile(x,ge.stream),ce(new Date().getTime()-q)}async downloadSignatureArchive(m,x){if(!m.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const U=await this.getAsset(m.assets.signature);await this.fileService.writeFile(x,U.stream)}async getReadme(m,x){if(m.assets.readme){const U=await this.getAsset(m.assets.readme,{},x);return await(0,f.asTextOrError)(U)||""}return""}async getManifest(m,x){if(m.assets.manifest){const U=await this.getAsset(m.assets.manifest,{},x),H=await(0,f.asTextOrError)(U);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(m,x){const U=oe(m,o.Manifest);if(!U)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},q=await this.getAsset(U,{headers:H});return await(0,f.asJson)(q)}async getCoreTranslation(m,x){const U=m.assets.coreTranslations.filter(H=>H[0]===x.toUpperCase())[0];if(U){const H=await this.getAsset(U[1]),q=await(0,f.asTextOrError)(H);return q?JSON.parse(q):null}return null}async getChangelog(m,x){if(m.assets.changelog){const U=await this.getAsset(m.assets.changelog,{},x);return await(0,f.asTextOrError)(U)||""}return""}async getAllCompatibleVersions(m,x,U){let H=new v().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?H=H.withFilter(n.ExtensionId,m.identifier.uuid):H=H.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:q}=await this.queryRawGalleryExtensions(H,O.CancellationToken.None);if(!q.length)return[];const ce=_(q[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(ce,U))return[];const ae=[];await Promise.all(q[0].versions.map(async ge=>{try{await this.isValidVersion(ge,x?"any":"release",!0,ce,U)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of $(ae,U))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return me}async getAsset(m,x={},U=O.CancellationToken.None){const H=await this.commonHeadersPromise,q={type:"GET"},ce={...H,...x.headers||{}};x={...x,...q,headers:ce};const ae=m.uri,me=m.fallbackUri,de={...x,url:ae};try{const ge=await this.requestService.request(de,U);if(ge.res.statusCode===200)return ge;const he=await(0,f.asTextOrError)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${he}`)}catch(ge){if((0,k.isCancellationError)(ge))throw ge;const he=(0,k.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:he});const fe={...x,url:me};return this.requestService.request(fe,U)}}async getEngine(m){let x=ue(m);if(!x){const U=await this.getManifestFromRawExtensionVersion(m,O.CancellationToken.None);if(!U)throw new Error("Manifest was not found");x=U.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const m=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,f.asJson)(m),U=[],H={},q=[];if(x){for(const ce of x.malicious)U.push({id:ce});if(x.migrateToPreRelease)for(const[ce,ae]of Object.entries(x.migrateToPreRelease))(!ae.engine||(0,h.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(H[ce.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[ce,ae]of Object.entries(x.deprecated))ae&&(H[ce.toLowerCase()]=(0,w.isBoolean)(ae)?{}:ae);if(x.search)for(const ce of x.search)q.push(ce)}return{malicious:U,deprecated:H,search:q}}};J=ve([ie(1,f.IRequestService),ie(2,y.ILogService),ie(3,b.IEnvironmentService),ie(4,d.ITelemetryService),ie(5,I.IFileService),ie(6,p.IProductService),ie(7,l.IConfigurationService)],J);let M=class extends J{constructor(m,x,U,H,q,ce,ae,me){super(m,x,U,H,q,ce,ae,me)}};e.ExtensionGalleryService=M,e.ExtensionGalleryService=M=ve([ie(0,L.IStorageService),ie(1,f.IRequestService),ie(2,y.ILogService),ie(3,b.IEnvironmentService),ie(4,d.ITelemetryService),ie(5,I.IFileService),ie(6,p.IProductService),ie(7,l.IConfigurationService)],M);let F=class extends J{constructor(m,x,U,H,q,ce,ae){super(void 0,m,x,U,H,q,ce,ae)}};e.ExtensionGalleryServiceWithNoStorageService=F,e.ExtensionGalleryServiceWithNoStorageService=F=ve([ie(0,f.IRequestService),ie(1,y.ILogService),ie(2,b.IEnvironmentService),ie(3,d.ITelemetryService),ie(4,I.IFileService),ie(5,p.IProductService),ie(6,l.IConfigurationService)],F)}),define(te[159],ne([0,1,11,18,12,6,139,22,23,3,68]),function(G,e,N,O,k,A,T,w,u,l,b){"use strict";var C,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let h=class extends u.UserDataProfilesService{static{C=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(f,E,L,d,S){super(L,d,E,S),this.stateReadonlyService=f,this.nativeEnvironmentService=L}getStoredProfiles(){return this.stateReadonlyService.getItem(C.PROFILES_KEY,[]).map(E=>({...E,location:(0,l.isString)(E.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,E.location):N.URI.revive(E.location)}))}getStoredProfileAssociations(){const f=this.stateReadonlyService.getItem(C.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(C.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?f:this.migrateStoredProfileAssociations(f)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(N.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=h,e.UserDataProfilesReadonlyService=h=C=ve([ie(0,T.IStateReadService),ie(1,w.IUriIdentityService),ie(2,O.INativeEnvironmentService),ie(3,k.IFileService),ie(4,A.ILogService)],h);let I=g=class extends h{constructor(f,E,L,d,S){super(f,E,L,d,S),this.stateService=f}saveStoredProfiles(f){f.length?this.stateService.setItem(g.PROFILES_KEY,f.map(E=>({...E,location:this.uriIdentityService.extUri.basename(E.location)}))):this.stateService.removeItem(g.PROFILES_KEY)}getStoredProfiles(){const f=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(f),this.stateService.setItem("userDataProfilesMigration",!0)),f}saveStoredProfileAssociations(f){f.emptyWindows||f.workspaces?this.stateService.setItem(g.PROFILE_ASSOCIATIONS_KEY,f):this.stateService.removeItem(g.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",E=this.stateService.getItem(f,void 0);if(E){this.stateService.removeItem(f);const d=E.reduce((S,{workspace:r,profile:s})=>(S[N.URI.revive(r).toString()]=N.URI.revive(s).toString(),S),{});this.stateService.setItem(g.PROFILE_ASSOCIATIONS_KEY,{workspaces:d})}const L=super.getStoredProfileAssociations();return this.stateService.getItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(L),this.stateService.setItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),L}};e.UserDataProfilesService=I,e.UserDataProfilesService=I=g=ve([ie(0,T.IStateService),ie(1,w.IUriIdentityService),ie(2,O.INativeEnvironmentService),ie(3,k.IFileService),ie(4,A.ILogService)],I);let y=class extends I{constructor(f,E,L,d){super(new b.StateService(0,E,d,L),f,E,L,d)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=y,e.ServerUserDataProfilesService=y=ve([ie(0,w.IUriIdentityService),ie(1,O.INativeEnvironmentService),ie(2,k.IFileService),ie(3,A.ILogService)],y)}),define(te[51],ne([0,1,125,8,16,3,24,87,176,177]),function(G,e,N,O,k,A,T,w,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const b=new RegExp(e.CorruptZipMessage);class C extends Error{constructor(s,t){let i=t.message;switch(s){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=s,this.cause=t}}e.ExtractError=C;function g(r){const s=r.externalFileAttributes>>16||33188;return[448,56,7].map(t=>s&t).reduce((t,i)=>t+i,s&61440)}function h(r){if(r instanceof C)return r;let s;return b.test(r.message)&&(s="CorruptZip"),new C(s,r)}function I(r,s,t,i,n,o){const c=k.dirname(s),D=k.join(i,c);if(!D.startsWith(i))return Promise.reject(new Error(w.localize(0,null,s)));const P=k.join(i,s);let v;return o.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(T.Promises.mkdir(D,{recursive:!0})).then(()=>new Promise((R,z)=>{if(!o.isCancellationRequested)try{v=(0,N.createWriteStream)(P,{mode:t}),v.once("close",()=>R()),v.once("error",z),r.once("error",z),r.pipe(v)}catch(Z){z(Z)}}))}function y(r,s,t,i){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),o=0;const c=i.onCancellationRequested(()=>{n.cancel(),r.close()});return new Promise((D,P)=>{const v=new O.Sequencer,R=z=>{z.isCancellationRequested||(o++,r.readEntry())};r.once("error",P),r.once("close",()=>n.then(()=>{i.isCancellationRequested||r.entryCount===o?D():P(new C("Incomplete",new Error(w.localize(1,null,o,r.entryCount))))},P)),r.readEntry(),r.on("entry",z=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(z.fileName)){R(i);return}const Z=z.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(Z)){const re=k.join(s,Z);n=(0,O.createCancelablePromise)(ue=>T.Promises.mkdir(re,{recursive:!0}).then(()=>R(ue)).then(void 0,P));return}const ee=f(r,z),oe=g(z);n=(0,O.createCancelablePromise)(re=>v.queue(()=>ee.then(ue=>I(ue,Z,oe,s,t,re).then(()=>R(re)))).then(null,P))})}).finally(()=>c.dispose())}function p(r,s=!1){return new Promise((t,i)=>{(0,u.open)(r,s?{lazyEntries:!0}:void 0,(n,o)=>{n?i(h(n)):t((0,A.assertIsDefined)(o))})})}function f(r,s){return new Promise((t,i)=>{r.openReadStream(s,(n,o)=>{n?i(h(n)):t((0,A.assertIsDefined)(o))})})}function E(r,s){return new Promise((t,i)=>{const n=new l.ZipFile;s.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const o=(0,N.createWriteStream)(r);n.outputStream.pipe(o),n.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>t(r))})}e.zip=E;function L(r,s,t={},i){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let o=p(r,!0);return t.overwrite&&(o=o.then(c=>T.Promises.rm(s).then(()=>c))),o.then(c=>y(c,s,{sourcePathRegex:n},i))}e.extract=L;function d(r,s){return p(r).then(t=>new Promise((i,n)=>{t.on("entry",o=>{o.fileName===s&&f(t,o).then(c=>i(c),c=>n(c))}),t.once("close",()=>n(new Error(w.localize(2,null,s))))}))}function S(r,s){return d(r,s).then(t=>new Promise((i,n)=>{const o=[];t.once("error",n),t.on("data",c=>o.push(c)),t.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=S}),define(te[160],ne([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class extends k.Disposable{static{L=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(r,s,t,i,n,o){super(),this.fileService=s,this.extensionGalleryService=t,this.configurationService=i,this.extensionSignatureVerificationService=n,this.logService=o,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(r,s,t){await this.cleanUpPromise;const i=(0,T.joinPath)(this.extensionsDownloadDir,this.getName(r));try{await this.downloadFile(r,i,o=>this.extensionGalleryService.download(r,o,s))}catch(o){throw new I.ExtensionManagementError(o.message,I.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.shouldVerifySignature(r)){const o=await this.downloadSignatureArchive(r);try{n=await this.extensionSignatureVerificationService.verify(i.fsPath,o.fsPath,this.logService.getLevel()===E.LogLevel.Trace)}catch(c){const D=c;if(n=D.code,D.output&&this.logService.trace(`Extension signature verification details for ${r.identifier.id} ${r.version}:
${D.output}`),n===I.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===I.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new I.ExtensionManagementError(C.CorruptZipMessage,I.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(c){this.logService.error(c)}}}return n===!0?this.logService.info(`Extension signature is verified: ${r.identifier.id}`):n===!1?this.logService.info(`Extension signature verification is not done: ${r.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${n}': ${r.identifier.id}`),{location:i,verificationStatus:n}}shouldVerifySignature(r){if(!r.isSigned)return!1;const s=this.configurationService.getValue("extensions.verifySignature");return(0,u.isBoolean)(s)?s:!0}async downloadSignatureArchive(r){await this.cleanUpPromise;const s=(0,T.joinPath)(this.extensionsDownloadDir,`${this.getName(r)}${L.SignatureArchiveExtension}`);return await this.downloadFile(r,s,t=>this.extensionGalleryService.downloadSignatureArchive(r,t)),s}async downloadFile(r,s,t){if(await this.fileService.exists(s))return;if(s.scheme!==A.Schemas.file){await t(s);return}const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,l.generateUuid)()}`);await this.fileService.exists(i)||await t(i);try{await b.Promises.rename(i.fsPath,s.fsPath,2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",r.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(r){await this.cleanUpPromise,await this.fileService.del(r)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const r=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(r.children){const s=[],t=[],i=[];for(const c of r.children)if(c.name.endsWith(L.SignatureArchiveExtension))i.push(c.resource);else{const D=y.ExtensionKey.parse(c.name);D&&t.push([D,c])}const n=(0,y.groupByExtension)(t,([c])=>c),o=[];for(const c of n)c.sort((D,P)=>w.rcompare(D[0].version,P[0].version)),s.push(...c.slice(1).map(D=>D[1].resource)),o.push(c[0][1]);o.sort((c,D)=>c.mtime-D.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(c=>c.resource)),s.push(...i),await N.Promises.settled(s.map(c=>(this.logService.trace("Deleting from cache",c.path),this.fileService.del(c))))}}catch(r){this.logService.error(r)}}getName(r){return this.cache?y.ExtensionKey.create(r).toString().toLowerCase():(0,l.generateUuid)()}};e.ExtensionsDownloader=d,e.ExtensionsDownloader=d=L=ve([ie(0,h.INativeEnvironmentService),ie(1,f.IFileService),ie(2,I.IExtensionGalleryService),ie(3,g.IConfigurationService),ie(4,p.IExtensionSignatureVerificationService),ie(5,E.ILogService)],d)}),define(te[161],ne([0,1,51,97]),function(G,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(A){return(0,N.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(te[162],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E,L,d,S,r,s,t,i,n,o,c,D,P,v,R,z,Z,ee,oe,re,ue,le,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(t.IExtensionManagementService);const W=".vsctmp";let K=class extends s.AbstractExtensionManagementService{constructor(M,F,a,m,x,U,H,q,ce,ae,me,de){super(M,F,me,a,ae,de),this.extensionsScannerService=x,this.extensionsProfileScannerService=U,this.downloadService=H,this.fileService=ce,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new b.ResourceSet;const ge=this._register(q.createInstance(D.ExtensionsLifecycle));this.extensionsScanner=this._register(q.createInstance(V,fe=>ge.postUninstall(fe))),this.manifestCache=this._register(new v.ExtensionsManifestCache(de,ce,me,this,this.logService)),this.extensionsDownloader=this._register(q.createInstance(c.ExtensionsDownloader));const he=this._register(new R.ExtensionsWatcher(this,this.extensionsScannerService,de,U,me,ce,a));this._register(he.onDidChangeExtensionsByAnotherSource(fe=>this.onDidChangeExtensionsFromAnotherSource(fe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.collectFiles(M),a=await(0,L.zip)((0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,F);return p.URI.file(a)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:F,cleanup:a}=await this.downloadVsix(M),m=g.resolve(F.fsPath);try{return await(0,P.getManifest)(m)}finally{await a()}}getInstalled(M,F=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(M??null,F)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.extensionsScanner.scanUserExtensionAtLocation(M)}async install(M,F={}){this.logService.trace("ExtensionManagementService#install",M.toString());const{location:a,cleanup:m}=await this.downloadVsix(M);try{const x=await(0,P.getManifest)(g.resolve(a.fsPath)),U=(0,i.getGalleryExtensionId)(x.publisher,x.name);if(x.engines&&x.engines.vscode&&!(0,z.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(d.localize(0,null,U,this.productService.version));const q=(await this.installExtensions([{manifest:x,extension:a,options:F}])).find(({identifier:ce})=>(0,i.areSameExtensions)(ce,{id:U}));if(q?.local)return q.local;throw q?.error?q.error:(0,s.toExtensionManagementError)(new Error(`Unknown error while installing extension ${U}`))}finally{await m()}}async installFromLocation(M,F){this.logService.trace("ExtensionManagementService#installFromLocation",M.toString());const a=await this.extensionsScanner.scanUserExtensionAtLocation(M);if(!a)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.addExtensionsToProfile([[a,void 0]],F),this.logService.info("Successfully installed extension",a.identifier.id,F.toString()),a}async installExtensionsFromProfile(M,F,a){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",M,F.toString(),a.toString());const m=(await this.extensionsScanner.scanExtensions(1,F)).filter(x=>M.some(U=>(0,i.areSameExtensions)(U,x.identifier)));if(m.length){const x=await Promise.all(m.map(U=>this.extensionsScanner.scanMetadata(U,F)));await this.addExtensionsToProfile(m.map((U,H)=>[U,x[H]]),a),this.logService.info("Successfully installed extensions",m.map(U=>U.identifier.id),a.toString())}return m}async updateMetadata(M,F,a=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),M=await this.extensionsScanner.updateMetadata(M,F,a),this.manifestCache.invalidate(a),this._onDidUpdateExtensionMetadata.fire(M),M}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(d.localize(1,null));const F=await this.getTargetPlatform(),[a]=await this.galleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!a)throw new Error(d.localize(2,null));await this.extensionsScanner.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(m){throw new Error(d.localize(3,null,(0,A.toErrorMessage)(m)))}return this.installFromGallery(a)}copyExtension(M,F,a,m){return this.extensionsScanner.copyExtension(M,F,a,m)}copyExtensions(M,F){return this.extensionsScanner.copyExtensions(M,F)}markAsUninstalled(...M){return this.extensionsScanner.setUninstalled(...M)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(M){this.logService.error(M)}}async download(M,F,a){const{location:m}=await this.extensionsDownloader.download(M,F,!a);return m}async downloadVsix(M){if(M.scheme===C.Schemas.file)return{location:M,async cleanup(){}};this.logService.trace("Downloading extension from",M.toString());const F=(0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)());return await this.downloadService.download(M,F),this.logService.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.fileService.del(F)}catch(m){this.logService.error(m)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(M,F,a){if(p.URI.isUri(F))return new B(M,F,a,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const m=i.ExtensionKey.create(F).toString();let x=this.installGalleryExtensionsTasks.get(m);return x||(this.installGalleryExtensionsTasks.set(m,x=new $(M,F,a,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),x.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(m))),x}createUninstallExtensionTask(M,F){return new X(M,F.profileLocation,this.extensionsProfileScannerService)}async collectFiles(M){const F=async m=>{let x=await E.Promises.readdir(m);x=x.map(q=>g.join(m,q));const U=await Promise.all(x.map(q=>E.Promises.stat(q)));let H=Promise.resolve([]);return U.forEach((q,ce)=>{const ae=x[ce];q.isFile()&&(H=H.then(me=>[...me,ae])),q.isDirectory()&&(H=H.then(me=>F(ae).then(de=>[...me,...de])))}),H};return(await F(M.location.fsPath)).map(m=>({path:`extension/${g.relative(M.location.fsPath,m)}`,localPath:m}))}async onDidChangeExtensionsFromAnotherSource({added:M,removed:F}){if(F){const a=M&&this.uriIdentityService.extUri.isEqual(F.profileLocation,M.profileLocation)?F.extensions.filter(m=>M.extensions.every(x=>!(0,i.areSameExtensions)(x,m))):F.extensions;for(const m of a)this.logService.info("Extensions removed from another source",m.id,F.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:m,profileLocation:F.profileLocation})}if(M){const m=(await this.extensionsScanner.scanExtensions(1,M.profileLocation)).filter(x=>M.extensions.some(U=>(0,i.areSameExtensions)(U,x.identifier)));this._onDidInstallExtensions.fire(m.map(x=>(this.logService.info("Extensions added from another source",x.identifier.id,M.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:M.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(F=>this.knownDirectories.add(F)));const M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const F of M.children??[])F.isDirectory&&this.knownDirectories.add(F.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(F=>this.onDidFilesChange(F)))}async onDidFilesChange(M){if(!M.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const F=[];for(const a of M.rawAdded){if(this.knownDirectories.has(a)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(a),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(a,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(a).startsWith(".")||!(await this.fileService.stat(a)).isDirectory)continue;const m=await this.extensionsScanner.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.knownDirectories.add(a),F.push(m))}F.length&&(await this.addExtensionsToProfile(F.map(a=>[a,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",F.map(a=>a.identifier.id)))}async addExtensionsToProfile(M,F){const a=M.map(m=>m[0]);await this.setInstalled(a),await this.extensionsProfileScannerService.addExtensionsToProfile(M,F),this._onDidInstallExtensions.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:F})))}async setInstalled(M){const F=await this.extensionsScanner.getUninstalledExtensions();for(const a of M){const m=i.ExtensionKey.create(a);F[m.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",m.id),await this.extensionsScanner.setInstalled(m),this.logService.info("Removed the extension from uninstalled list:",m.id))}}};e.ExtensionManagementService=K,e.ExtensionManagementService=K=ve([ie(0,t.IExtensionGalleryService),ie(1,ue.ITelemetryService),ie(2,oe.ILogService),ie(3,r.INativeEnvironmentService),ie(4,o.IExtensionsScannerService),ie(5,n.IExtensionsProfileScannerService),ie(6,S.IDownloadService),ie(7,ee.IInstantiationService),ie(8,Z.IFileService),ie(9,re.IProductService),ie(10,le.IUriIdentityService),ie(11,se.IUserDataProfilesService)],K);let V=class extends l.Disposable{constructor(M,F,a,m,x,U){super(),this.beforeRemovingExtension=M,this.fileService=F,this.extensionsScannerService=a,this.extensionsProfileScannerService=m,this.uriIdentityService=x,this.logService=U,this._onExtract=this._register(new w.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new N.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(M,F){const a={includeInvalid:!0,profileLocation:F};let m=[];return M===null||M===0?m.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},a,!1)):M===1&&m.push(...await this.extensionsScannerService.scanUserExtensions(a)),m=M!==null?m.filter(x=>x.type===M):m,Promise.all(m.map(x=>this.toLocalExtension(x)))}async scanAllUserExtensions(M){const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(F.map(a=>this.toLocalExtension(a)))}async scanUserExtensionAtLocation(M){try{const F=await this.extensionsScannerService.scanExistingExtension(M,1,{includeInvalid:!0});if(F)return await this.toLocalExtension(F)}catch(F){this.logService.error(F)}return null}async extractUserExtension(M,F,a,m,x){const U=M.toString(),H=p.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`)),q=p.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U));let ce=await this.fileService.exists(q);if(ce&&m){try{await this.deleteExtensionFromLocation(M.id,q,"removeExisting")}catch{throw new t.ExtensionManagementError(d.localize(4,null,q.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.logService.trace(`Started extracting the extension from ${F} to ${q.fsPath}`),await(0,L.extract)(F,H.fsPath,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${q}:`,M.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof L.ExtractError&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(ae.message,me)}await this.extensionsScannerService.updateMetadata(H,a);try{this.logService.trace(`Started renaming the extension from ${H.fsPath} to ${q.fsPath}`),await this.rename(H.fsPath,q.fsPath),this.logService.info("Renamed to",q.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(ae)}. Deleted from extracted location`,H),ae}this._onExtract.fire(q)}catch(ae){try{await this.fileService.del(H,{recursive:!0})}catch{}throw ae}return this.scanLocalExtension(q,1)}async scanMetadata(M,F){return F?(await this.getScannedExtension(M,F))?.metadata:this.extensionsScannerService.scanMetadata(M.location)}async getScannedExtension(M,F){return(await this.extensionsProfileScannerService.scanProfileExtensions(F)).find(m=>(0,i.areSameExtensions)(m.identifier,M.identifier))}async updateMetadata(M,F,a){return a?await this.extensionsProfileScannerService.updateMetadata([[M,F]],a):await this.extensionsScannerService.updateMetadata(M.location,F),this.scanLocalExtension(M.location,M.type,a)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...M){const F=M.map(a=>i.ExtensionKey.create(a));await this.withUninstalledExtensions(a=>F.forEach(m=>{a[m.toString()]=!0,this.logService.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(M){await this.withUninstalledExtensions(F=>delete F[M.toString()])}async removeExtension(M,F){if(this.uriIdentityService.extUri.isEqualOrParent(M.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(M.identifier.id,M.location,F)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.withUninstalledExtensions(F=>delete F[i.ExtensionKey.create(M).toString()])}async copyExtension(M,F,a,m){const x=await this.getScannedExtension(M,F),U=await this.getScannedExtension(M,a);return m={...x?.metadata,...m},U?await this.extensionsProfileScannerService.updateMetadata([[M,{...U.metadata,...m}]],a):await this.extensionsProfileScannerService.addExtensionsToProfile([[M,m]],a),this.scanLocalExtension(M.location,M.type,a)}async copyExtensions(M,F){const a=await this.scanExtensions(1,M),m=await Promise.all(a.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,M)]));await this.extensionsProfileScannerService.addExtensionsToProfile(m,F)}async deleteExtensionFromLocation(M,F,a){this.logService.trace(`Deleting ${a} extension from disk`,M,F.fsPath);const m=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(F),`${this.uriIdentityService.extUri.basename(F)}.${(0,u.hash)((0,f.generateUuid)()).toString(16)}${W}`);await this.rename(F.fsPath,m.fsPath),await this.fileService.del(m,{recursive:!0}),this.logService.info(`Deleted ${a} extension from disk`,M,F.fsPath)}async withUninstalledExtensions(M){return this.uninstalledFileLimiter.queue(async()=>{let F;try{F=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(m){if((0,Z.toFileOperationResult)(m)!==1)throw m}let a={};if(F)try{a=JSON.parse(F)}catch{}return M&&(M(a),Object.keys(a).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(a))):await this.fileService.del(this.uninstalledResource)),a})}async rename(M,F){try{await E.Promises.rename(M,F,2*60*1e3)}catch(a){throw new t.ExtensionManagementError(a.message||d.localize(5,null,M,F),a.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(M,F,a){if(a){const x=(await this.extensionsScannerService.scanUserExtensions({profileLocation:a})).find(U=>this.uriIdentityService.extUri.isEqual(U.location,M));if(x)return this.toLocalExtension(x)}else{const m=await this.extensionsScannerService.scanExistingExtension(M,F,{includeInvalid:!0});if(m)return this.toLocalExtension(m)}throw new Error(d.localize(6,null,M.path))}async toLocalExtension(M){const F=await this.fileService.resolve(M.location);let a,m;return F.children&&(a=F.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,m=F.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned}}async removeUninstalledExtensions(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(M));const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const x of F)M[i.ExtensionKey.create(x).toString()]||a.add(x.identifier.id.toLowerCase());try{const x=(0,i.groupByExtension)(F,U=>U.identifier);await N.Promises.settled(x.map(async U=>{const H=U.sort((q,ce)=>I.rcompare(q.manifest.version,ce.manifest.version))[0];a.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}))}catch(x){this.logService.error(x)}const m=F.filter(x=>x.metadata&&M[i.ExtensionKey.create(x).toString()]);await Promise.allSettled(m.map(x=>this.removeUninstalledExtension(x)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(F){(0,Z.toFileOperationResult)(F)!==1&&this.logService.error(F);return}if(M?.children)try{await Promise.allSettled(M.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(W))){this.logService.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.fileService.del(F.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(a){(0,Z.toFileOperationResult)(a)!==1&&this.logService.error(a)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=ve([ie(1,Z.IFileService),ie(2,o.IExtensionsScannerService),ie(3,n.IExtensionsProfileScannerService),ie(4,le.IUriIdentityService),ie(5,oe.ILogService)],V);class _ extends s.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,y.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(M,F,a,m,x,U,H,q,ce){super(),this.identifier=M,this.source=F,this.options=a,this.extensionsScanner=m,this.uriIdentityService=x,this.userDataProfilesService=U,this.extensionsScannerService=H,this.extensionsProfileScannerService=q,this.logService=ce,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(M){const[F,a]=await this.install(M);return this._profileLocation=F.isBuiltin||F.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,a]],this._profileLocation),F}async extractExtension({zipPath:M,key:F,metadata:a},m,x){let U=await this.unsetIfUninstalled(F);return U||(this.logService.trace("Extracting extension...",F.id),U=await this.extensionsScanner.extractUserExtension(F,M,a,m,x),this.logService.info("Extracting extension completed.",F.id)),U}async unsetIfUninstalled(M){return await this.isUninstalled(M)?(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.extensionsScanner.setInstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(m=>i.ExtensionKey.create(m).equals(M))):void 0}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.toString()]}}class $ extends _{constructor(M,F,a,m,x,U,H,q,ce,ae){super(F.identifier,F,a,x,U,H,q,ce,ae),this.gallery=F,this.extensionsDownloader=m}async install(M){const a=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,i.areSameExtensions)(H.identifier,this.gallery.identifier));a&&(this._operation=3);const m={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,y.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(a,m),m];const{location:x,verificationStatus:U}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=U,this.validateManifest(x.fsPath),[await this.extractExtension({zipPath:x.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:m},!1,M),m]}catch(H){try{await this.extensionsDownloader.delete(x)}catch(q){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,T.getErrorMessage)(q))}throw H}}async validateManifest(M){try{await(0,P.getManifest)(M)}catch(F){throw new t.ExtensionManagementError((0,s.joinErrors)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=$;class B extends _{constructor(M,F,a,m,x,U,H,q,ce,ae){super({id:(0,i.getGalleryExtensionId)(M.publisher,M.name)},F,a,x,U,H,q,ce,ae),this.manifest=M,this.location=F,this.galleryService=m}async doRun(M){const F=await super.doRun(M);return this.updateMetadata(F,M),F}async install(M){const F=new i.ExtensionKey(this.identifier,this.manifest.version),m=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,i.areSameExtensions)(this.identifier,H.identifier)),x={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this._operation=3,F.equals(new i.ExtensionKey(m.identifier,m.manifest.version)))try{await this.extensionsScanner.removeExtension(m,"existing")}catch{throw new Error(d.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(m.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(m);else{const H=await this.unsetIfUninstalled(F);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(d.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:g.resolve(this.location.fsPath),key:F,metadata:x},!0,M),x]}async updateMetadata(M,F){try{let[a]=await this.galleryService.getExtensions([{id:M.identifier.id,version:M.manifest.version}],F);if(a||([a]=await this.galleryService.getExtensions([{id:M.identifier.id}],F)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(M,m,this.options.profileLocation)}}catch{}}}class X extends s.AbstractExtensionTask{constructor(M,F,a){super(),this.extension=M,this.profileLocation=F,this.extensionsProfileScannerService=a}async doRun(M){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(te[163],ne([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let I=class extends C.AbstractRequestService{constructor(E,L,d,S){super(S),this.configurationService=E,this.environmentService=L,this.logService=d,this.configure(),this._register(E.onDidChangeConfiguration(r=>{r.affectsConfiguration("http")&&this.configure()}))}configure(){const E=this.configurationService.getValue("http");this.proxyUrl=E?.proxy,this.strictSSL=!!E?.proxyStrictSSL,this.authorization=E?.proxyAuthorization}async request(E,L){const{proxyUrl:d,strictSSL:S}=this;let r;try{r=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const s={...process.env,...r},t=E.agent?E.agent:await(0,g.getProxyAgent)(E.url||"",s,{proxyUrl:d,strictSSL:S});return E.agent=t,E.strictSSL=S,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(E.isChromiumNetwork?"electron":"node",E,()=>p(E,L))}async resolveProxy(E){}};e.RequestService=I,e.RequestService=I=ve([ie(0,w.IConfigurationService),ie(1,u.INativeEnvironmentService),ie(2,b.ILogService),ie(3,b.ILoggerService)],I);async function y(f){return((0,N.parse)(f.url).protocol==="https:"?await new Promise((d,S)=>{G(["https"],d,S)}):await new Promise((d,S)=>{G(["http"],d,S)})).request}async function p(f,E){return O.Promises.withAsyncBody(async(L,d)=>{const S=(0,N.parse)(f.url),r=f.getRawRequest?f.getRawRequest(f):await y(f),s={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,T.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(s.auth=f.user+":"+f.password);const t=r(s,i=>{const n=(0,T.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)p({...f,url:i.headers.location,followRedirects:n-1},E).then(L,d);else{let o=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,h.createGunzip)())),L({res:i,stream:(0,k.streamToBufferReadableStream)(o)})}});t.on("error",d),f.timeout&&t.setTimeout(f.timeout),f.isChromiumNetwork&&t.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&t.write(f.data),t.end(),E.onCancellationRequested(()=>{t.abort(),d(new A.CancellationError)})})}e.nodeRequest=p}),define(te[179],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(G,e,N,O,k,A,T,w,u,l,b,C,g,h,I,y,p,f,E,L,d,S,r,s,t,i,n,o,c,D,P,v,R,z,Z,ee,oe,re,ue,le,se,W,K,V,_,$,B,X,J,M,F,a,m,x,U,H,q,ce,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends T.Disposable{constructor(fe){super(),this.argv=fe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[fe,Se]=await this.initServices();return fe.invokeFunction(async we=>{const be=we.get(ee.ILogService),Me=we.get(o.IFileService),j=we.get(f.INativeEnvironmentService),Y=we.get(m.IUserDataProfilesService);be.info("CLI main",this.argv),this.registerErrorHandler(be),await this.doRun(j,Me,Y,fe),await Promise.all(Se.map(Q=>{(0,O.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const fe=new R.ServiceCollection,Se={_serviceBrand:void 0,...le.default};fe.set(se.IProductService,Se);const we=new E.NativeEnvironmentService(this.argv,Se);fe.set(f.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.with({scheme:w.Schemas.file}).fsPath,we.extensionsPath].map(Ae=>Ae?g.Promises.mkdir(Ae,{recursive:!0}):void 0));const be=new ce.LoggerService((0,ee.getLogLevel)(we),we.logsHome);fe.set(ee.ILoggerService,be);const Me=this._register(be.createLogger("cli",{name:(0,ae.localize)(0,null)})),j=[];be.getLogLevel()===ee.LogLevel.Trace&&j.push(new ee.ConsoleLogger(be.getLogLevel()));const Y=this._register(new q.LogService(Me,j));fe.set(ee.ILogService,Y);const Q=this._register(new c.FileService(Y));fe.set(o.IFileService,Q);const pe=this._register(new D.DiskFileSystemProvider(Y));Q.registerProvider(w.Schemas.file,pe);const ye=new a.UriIdentityService(Q);fe.set(F.IUriIdentityService,ye);const Le=new V.StateReadonlyService(1,we,Y,Q),Ie=new x.UserDataProfilesReadonlyService(Le,ye,we,Q,Y);fe.set(m.IUserDataProfilesService,Ie),Q.registerProvider(w.Schemas.vscodeUserData,new me.FileUserDataProvider(w.Schemas.file,pe,w.Schemas.vscodeUserData,Ie,ye,Y));const Ne=l.isWindows&&Se.win32RegValueName?this._register(new ue.NativePolicyService(Y,Se.win32RegValueName)):we.policyFile?this._register(new oe.FilePolicyService(we.policyFile,Q,Y)):new re.NullPolicyService;fe.set(re.IPolicyService,Ne);const Ce=this._register(new I.ConfigurationService(Ie.defaultProfile.settingsResource,Q,Ne,Y));fe.set(h.IConfigurationService,Ce),await Promise.all([Le.init(),Ce.initialize()]);let Te;try{Te=await(0,U.resolveMachineId)(Le,Y)}catch(Ae){Ae.code!=="ENOENT"&&Y.error(Ae)}const _e=await(0,U.resolveSqmId)(Le,Y);Ie.init(),fe.set(F.IUriIdentityService,new a.UriIdentityService(Q));const Re=new K.RequestService(Ce,we,Y,be);fe.set(W.IRequestService,Re),fe.set(y.IDownloadService,new P.SyncDescriptor(p.DownloadService,void 0,!0)),fe.set(s.IExtensionsProfileScannerService,new P.SyncDescriptor(H.ExtensionsProfileScannerService,void 0,!0)),fe.set(t.IExtensionsScannerService,new P.SyncDescriptor(n.ExtensionsScannerService,void 0,!0)),fe.set(S.IExtensionSignatureVerificationService,new P.SyncDescriptor(S.ExtensionSignatureVerificationService,void 0,!0)),fe.set(i.INativeServerExtensionManagementService,new P.SyncDescriptor(i.ExtensionManagementService,void 0,!0)),fe.set(d.IExtensionGalleryService,new P.SyncDescriptor(L.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),fe.set(z.ILanguagePackService,new P.SyncDescriptor(Z.NativeLanguagePackService,void 0,!1));const Oe=[],xe=(0,X.isInternalTelemetry)(Se,Ce);if((0,X.supportsTelemetry)(Se,we)){Se.aiConfig&&Se.aiConfig.ariaKey&&Oe.push(new J.OneDataSystemAppender(Re,xe,"monacoworkbench",null,Se.aiConfig.ariaKey));const Ae={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,_.resolveCommonProperties)((0,N.release)(),(0,N.hostname)(),process.arch,Se.commit,Se.version,Te,_e,xe),piiPaths:(0,X.getPiiPathsFromEnvironment)(we)};fe.set($.ITelemetryService,new P.SyncDescriptor(B.TelemetryService,[Ae],!1))}else fe.set($.ITelemetryService,X.NullTelemetryService);return[new v.InstantiationService(fe),Oe]}registerErrorHandler(fe){(0,A.setUnexpectedErrorHandler)(Se=>{const we=(0,k.toErrorMessage)(Se,!0);we&&fe.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",Se=>{(0,A.isSigPipeError)(Se)||(0,A.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,A.onUnexpectedError)(Se))}async doRun(fe,Se,we,be){let Me;if(fe.args.profile&&(Me=we.profiles.find(Y=>Y.name===fe.args.profile),!Me))throw new Error(`Profile '${fe.args.profile}' not found.`);const j=(Me??we.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return be.createInstance(r.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,j);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Y={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:j};return be.createInstance(r.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),Y,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return be.createInstance(r.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,j);if(this.argv["locate-extension"])return be.createInstance(r.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(fe.appRoot,fe.extensionsPath))}}asExtensionIdOrVSIX(fe){return fe.map(Se=>/\.vsix$/i.test(Se)?C.URI.file((0,u.isAbsolute)(Se)?Se:(0,u.join)((0,b.cwd)(),Se)):Se)}}async function ge(he){const fe=new de(he);try{await fe.run()}finally{fe.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dd29bdcb71634f9cd7c1792bb2bdfde5b18ee8e8/core/vs/code/node/cliProcessMain.js.map
