/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],k=0,U=te.length;k<U;k++)e[k]=oe[te[k]];return e};define(oe[123],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class k{static get(){const A=new Map,O=new Map,L=new Map,R=new Map;function I(c,m){c.has(m.detail)||c.set(m.detail,-m.timestamp)}function g(c,m){const E=c.get(m.detail);E&&(E>=0||c.set(m.detail,E+m.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((c,m)=>c.timestamp-m.timestamp));for(const c of P)switch(c.type){case 10:I(A,c);break;case 11:case 12:g(A,c);break;case 21:I(O,c);break;case 22:g(O,c);break;case 33:I(L,c);break;case 34:g(L,c);break;case 31:I(R,c);break;case 32:g(R,c);break}let b=0;L.forEach(c=>b+=c);function v(c){const m=[];return c.forEach((E,y)=>m.push([y,E])),m}return{amdLoad:v(A),amdInvoke:v(O),nodeRequire:v(L),nodeEval:v(R),nodeRequireTotal:b}}static toMarkdownTable(A,O){let L="";const R=[];return A.forEach((I,g)=>{R[g]=I.length}),O.forEach(I=>{I.forEach((g,P)=>{typeof g>"u"&&(g=I[P]="-");const b=g.toString().length;R[P]=Math.max(b,R[P])})}),A.forEach((I,g)=>{L+=`| ${I+" ".repeat(R[g]-I.toString().length)} `}),L+=`|
`,A.forEach((I,g)=>{L+=`| ${"-".repeat(R[g])} `}),L+=`|
`,O.forEach(I=>{I.forEach((g,P)=>{typeof g<"u"&&(L+=`| ${g+" ".repeat(R[P]-g.toString().length)} `)}),L+=`|
`}),L}}e.LoaderStats=k}),define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function k(E,y,u){const d=U(E,y);if(d!==-1)return E[d]}e.findLast=k;function U(E,y,u=E.length-1){for(let d=u;d>=0;d--){const h=E[d];if(y(h))return d}return-1}e.findLastIdx=U;function A(E,y){const u=O(E,y);return u===-1?void 0:E[u]}e.findLastMonotonous=A;function O(E,y,u=0,d=E.length){let h=u,f=d;for(;h<f;){const C=Math.floor((h+f)/2);y(E[C])?h=C+1:f=C}return h-1}e.findLastIdxMonotonous=O;function L(E,y){const u=R(E,y);return u===E.length?void 0:E[u]}e.findFirstMonotonous=L;function R(E,y,u=0,d=E.length){let h=u,f=d;for(;h<f;){const C=Math.floor((h+f)/2);y(E[C])?f=C:h=C+1}return h}e.findFirstIdxMonotonousOrArrLen=R;function I(E,y,u=0,d=E.length){const h=R(E,y,u,d);return h===E.length?-1:h}e.findFirstIdxMonotonous=I;class g{static{this.assertInvariants=!1}constructor(y){this._array=y,this._findLastMonotonousLastIdx=0}findLastMonotonous(y){if(g.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!y(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=y}const u=O(this._array,y,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=u+1,u===-1?void 0:this._array[u]}}e.MonotonousArray=g;function P(E,y){if(E.length===0)return;let u=E[0];for(let d=1;d<E.length;d++){const h=E[d];y(h,u)>0&&(u=h)}return u}e.findFirstMaxBy=P;function b(E,y){if(E.length===0)return;let u=E[0];for(let d=1;d<E.length;d++){const h=E[d];y(h,u)>=0&&(u=h)}return u}e.findLastMaxBy=b;function v(E,y){return P(E,(u,d)=>-y(u,d))}e.findFirstMinBy=v;function c(E,y){if(E.length===0)return-1;let u=0;for(let d=1;d<E.length;d++){const h=E[d];y(h,E[u])>0&&(u=d)}return u}e.findMaxIdxBy=c;function m(E,y){for(const u of E){const d=y(u);if(d!==void 0)return d}}e.mapFindFirst=m}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function k(L,R){const I=Object.create(null);for(const g of L){const P=R(g);let b=I[P];b||(b=I[P]=[]),b.push(g)}return I}e.groupBy=k;function U(L,R){const I=[],g=[];for(const P of L)R.has(P)||I.push(P);for(const P of R)L.has(P)||g.push(P);return{removed:I,added:g}}e.diffSets=U;function A(L,R){const I=[],g=[];for(const[P,b]of L)R.has(P)||I.push(b);for(const[P,b]of R)L.has(P)||g.push(b);return{removed:I,added:g}}e.diffMaps=A;function O(L,R){const I=new Set;for(const g of R)L.has(g)&&I.add(g);return I}e.intersection=O}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(L){return(R,I,g)=>{let P=null,b=null;if(typeof g.value=="function"?(P="value",b=g.value):typeof g.get=="function"&&(P="get",b=g.get),!b)throw new Error("not supported");g[P]=L(b,I)}}function U(L,R,I){let g=null,P=null;if(typeof I.value=="function"?(g="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(g="get",P=I.get),!P)throw new Error("not supported");const b=`$memoize$${R}`;I[g]=function(...v){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,v)}),this[b]}}e.memoize=U;function A(L,R,I){return k((g,P)=>{const b=`$debounce$${P}`,v=`$debounce$result$${P}`;return function(...c){this[v]||(this[v]=I?I():void 0),clearTimeout(this[b]),R&&(this[v]=R(this[v],...c),c=[this[v]]),this[b]=setTimeout(()=>{g.apply(this,c),this[v]=I?I():void 0},L)}})}e.debounce=A;function O(L,R,I){return k((g,P)=>{const b=`$throttle$timer$${P}`,v=`$throttle$result$${P}`,c=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...E){if(this[v]||(this[v]=I?I():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),R&&(this[v]=R(this[v],...E)),this[m])return;const y=this[c]+L;y<=Date.now()?(this[c]=Date.now(),g.apply(this,[this[v]]),this[v]=I?I():void 0):(this[m]=!0,this[b]=setTimeout(()=>{this[m]=!1,this[c]=Date.now(),g.apply(this,[this[v]]),this[v]=I?I():void 0},y-Date.now()))}})}e.throttle=O}),define(oe[7],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?h.isErrorNoTelemetry(s)?new h(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(o=>{o(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=k,e.errorHandler=new k;function U(C){e.errorHandler.setUnexpectedErrorHandler(C)}e.setUnexpectedErrorHandler=U;function A(C){if(!C||typeof C!="object")return!1;const s=C;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=A;function O(C){g(C)||e.errorHandler.onUnexpectedError(C)}e.onUnexpectedError=O;function L(C){g(C)||e.errorHandler.onUnexpectedExternalError(C)}e.onUnexpectedExternalError=L;function R(C){if(C instanceof Error){const{name:s,message:o}=C,n=C.stacktrace||C.stack;return{$isError:!0,name:s,message:o,stack:n,noTelemetry:h.isErrorNoTelemetry(C)}}return C}e.transformErrorForSerialization=R;const I="Canceled";function g(C){return C instanceof P?!0:C instanceof Error&&C.name===I&&C.message===I}e.isCancellationError=g;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function b(){const C=new Error(I);return C.name=C.message,C}e.canceled=b;function v(C){return C?new Error(`Illegal argument: ${C}`):new Error("Illegal argument")}e.illegalArgument=v;function c(C){return C?new Error(`Illegal state: ${C}`):new Error("Illegal state")}e.illegalState=c;class m extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=m;function E(C){return C?C.message?C.message:C.stack?C.stack.split(`
`)[0]:String(C):"Error"}e.getErrorMessage=E;class y extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=y;class u extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=u;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class h extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof h)return s;const o=new h;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=h;class f extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.BugIndicatingError=f}),define(oe[18],ae([0,1,7,124]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(F,V=0){return F[F.length-(1+V)]}e.tail=A;function O(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=O;function L(F,V,H=(re,ce)=>re===ce){if(F===V)return!0;if(!F||!V||F.length!==V.length)return!1;for(let re=0,ce=F.length;re<ce;re++)if(!H(F[re],V[re]))return!1;return!0}e.equals=L;function R(F,V){const H=F.length-1;V<H&&(F[V]=F[H]),F.pop()}e.removeFastWithoutKeepingOrder=R;function I(F,V,H){return g(F.length,re=>H(F[re],V))}e.binarySearch=I;function g(F,V){let H=0,re=F-1;for(;H<=re;){const ce=(H+re)/2|0,he=V(ce);if(he<0)H=ce+1;else if(he>0)re=ce-1;else return ce}return-(H+1)}e.binarySearch2=g;function P(F,V,H){if(F=F|0,F>=V.length)throw new TypeError("invalid index");const re=V[Math.floor(V.length*Math.random())],ce=[],he=[],ue=[];for(const me of V){const fe=H(me,re);fe<0?ce.push(me):fe>0?he.push(me):ue.push(me)}return F<ce.length?P(F,ce,H):F<ce.length+ue.length?ue[0]:P(F-(ce.length+ue.length),he,H)}e.quickSelect=P;function b(F,V){const H=[];let re;for(const ce of F.slice(0).sort(V))!re||V(re[0],ce)!==0?(re=[ce],H.push(re)):re.push(ce);return H}e.groupBy=b;function*v(F,V){let H,re;for(const ce of F)re!==void 0&&V(re,ce)?H.push(ce):(H&&(yield H),H=[ce]),re=ce;H&&(yield H)}e.groupAdjacentBy=v;function c(F,V){for(let H=0;H<=F.length;H++)V(H===0?void 0:F[H-1],H===F.length?void 0:F[H])}e.forEachAdjacent=c;function m(F,V){for(let H=0;H<F.length;H++)V(H===0?void 0:F[H-1],F[H],H+1===F.length?void 0:F[H+1])}e.forEachWithNeighbors=m;function E(F,V,H){const re=[];function ce(me,fe,pe){if(fe===0&&pe.length===0)return;const we=re[re.length-1];we&&we.start+we.deleteCount===me?(we.deleteCount+=fe,we.toInsert.push(...pe)):re.push({start:me,deleteCount:fe,toInsert:pe})}let he=0,ue=0;for(;;){if(he===F.length){ce(he,0,V.slice(ue));break}if(ue===V.length){ce(he,F.length-he,[]);break}const me=F[he],fe=V[ue],pe=H(me,fe);pe===0?(he+=1,ue+=1):pe<0?(ce(he,1,[]),he+=1):pe>0&&(ce(he,0,[fe]),ue+=1)}return re}e.sortedDiff=E;function y(F,V,H){const re=E(F,V,H),ce=[],he=[];for(const ue of re)ce.push(...F.slice(ue.start,ue.start+ue.deleteCount)),he.push(...ue.toInsert);return{removed:ce,added:he}}e.delta=y;function u(F,V,H){if(H===0)return[];const re=F.slice(0,H).sort(V);return h(F,V,re,H,F.length),re}e.top=u;function d(F,V,H,re,ce){return H===0?Promise.resolve([]):new Promise((he,ue)=>{(async()=>{const me=F.length,fe=F.slice(0,H).sort(V);for(let pe=H,we=Math.min(H+re,me);pe<me;pe=we,we=Math.min(we+re,me)){if(pe>H&&await new Promise(Le=>setTimeout(Le)),ce&&ce.isCancellationRequested)throw new k.CancellationError;h(F,V,fe,pe,we)}return fe})().then(he,ue)})}e.topAsync=d;function h(F,V,H,re,ce){for(const he=H.length;re<ce;re++){const ue=F[re];if(V(ue,H[he-1])<0){H.pop();const me=(0,U.findFirstIdxMonotonousOrArrLen)(H,fe=>V(ue,fe)<0);H.splice(me,0,ue)}}}function f(F){return F.filter(V=>!!V)}e.coalesce=f;function C(F){let V=0;for(let H=0;H<F.length;H++)F[H]&&(F[V]=F[H],V+=1);F.length=V}e.coalesceInPlace=C;function s(F,V,H){F.splice(H,0,F.splice(V,1)[0])}e.move=s;function o(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=o;function n(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=n;function i(F,V=H=>H){const H=new Set;return F.filter(re=>{const ce=V(re);return H.has(ce)?!1:(H.add(ce),!0)})}e.distinct=i;function t(F){const V=new Set;return H=>{const re=F(H);return V.has(re)?!1:(V.add(re),!0)}}e.uniqueFilter=t;function r(F,V){return F.length>0?F[0]:V}e.firstOrDefault=r;function a(F,V){return F.length>0?F[F.length-1]:V}e.lastOrDefault=a;function w(F,V,H=(re,ce)=>re===ce){let re=0;for(let ce=0,he=Math.min(F.length,V.length);ce<he&&H(F[ce],V[ce]);ce++)re++;return re}e.commonPrefixLength=w;function p(F){return[].concat(...F)}e.flatten=p;function l(F,V){let H=typeof V=="number"?F:0;typeof V=="number"?H=F:(H=0,V=F);const re=[];if(H<=V)for(let ce=H;ce<V;ce++)re.push(ce);else for(let ce=H;ce>V;ce--)re.push(ce);return re}e.range=l;function S(F,V,H){return F.reduce((re,ce)=>(re[V(ce)]=H?H(ce):ce,re),Object.create(null))}e.index=S;function _(F,V){return F.push(V),()=>N(F,V)}e.insert=_;function N(F,V){const H=F.indexOf(V);if(H>-1)return F.splice(H,1),V}e.remove=N;function $(F,V,H){const re=F.slice(0,V),ce=F.slice(V);return re.concat(H,ce)}e.arrayInsert=$;function W(F,V){let H;if(typeof V=="number"){let re=V;H=()=>{const ce=Math.sin(re++)*179426549;return ce-Math.floor(ce)}}else H=Math.random;for(let re=F.length-1;re>0;re-=1){const ce=Math.floor(H()*(re+1)),he=F[re];F[re]=F[ce],F[ce]=he}}e.shuffle=W;function q(F,V){const H=F.indexOf(V);H>-1&&(F.splice(H,1),F.unshift(V))}e.pushToStart=q;function Q(F,V){const H=F.indexOf(V);H>-1&&(F.splice(H,1),F.push(V))}e.pushToEnd=Q;function G(F,V){for(const H of V)F.push(H)}e.pushMany=G;function X(F,V){return Array.isArray(F)?F.map(V):V(F)}e.mapArrayOrNot=X;function x(F){return Array.isArray(F)?F:[F]}e.asArray=x;function Y(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=Y;function B(F,V,H){const re=ee(F,V),ce=F.length,he=H.length;F.length=ce+he;for(let ue=ce-1;ue>=re;ue--)F[ue+he]=F[ue];for(let ue=0;ue<he;ue++)F[ue+re]=H[ue]}e.insertInto=B;function z(F,V,H,re){const ce=ee(F,V);let he=F.splice(ce,H);return he===void 0&&(he=[]),B(F,ce,re),he}e.splice=z;function ee(F,V){return V<0?Math.max(V+F.length,0):Math.min(V,F.length)}var ie;(function(F){function V(he){return he<0}F.isLessThan=V;function H(he){return he<=0}F.isLessThanOrEqual=H;function re(he){return he>0}F.isGreaterThan=re;function ce(he){return he===0}F.isNeitherLessOrGreaterThan=ce,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function Z(F,V){return(H,re)=>V(F(H),F(re))}e.compareBy=Z;function ne(...F){return(V,H)=>{for(const re of F){const ce=re(V,H);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=ne;const K=(F,V)=>F-V;e.numberComparator=K;const j=(F,V)=>(0,e.numberComparator)(F?1:0,V?1:0);e.booleanComparator=j;function D(F){return(V,H)=>-F(V,H)}e.reverseOrder=D;class T{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let H=this.firstIdx;for(;H<this.items.length&&V(this.items[H]);)H++;const re=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,re}takeFromEndWhile(V){let H=this.lastIdx;for(;H>=0&&V(this.items[H]);)H--;const re=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,re}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const V=this.items[this.firstIdx];return this.firstIdx++,V}removeLast(){const V=this.items[this.lastIdx];return this.lastIdx--,V}takeCount(V){const H=this.items.slice(this.firstIdx,this.firstIdx+V);return this.firstIdx+=V,H}}e.ArrayQueue=T;class M{static{this.empty=new M(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(H=>(V(H),!0))}toArray(){const V=[];return this.iterate(H=>(V.push(H),!0)),V}filter(V){return new M(H=>this.iterate(re=>V(re)?H(re):!0))}map(V){return new M(H=>this.iterate(re=>H(V(re))))}some(V){let H=!1;return this.iterate(re=>(H=V(re),!H)),H}findFirst(V){let H;return this.iterate(re=>V(re)?(H=re,!1):!0),H}findLast(V){let H;return this.iterate(re=>(V(re)&&(H=re),!0)),H}findLastMaxBy(V){let H,re=!0;return this.iterate(ce=>((re||ie.isGreaterThan(V(ce,H)))&&(re=!1,H=ce),!0)),H}}e.CallbackIterable=M}),define(oe[126],ae([0,1,7]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function U(I,g){if(!I)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=U;function A(I,g="Unreachable"){throw new Error(g)}e.assertNever=A;function O(I){if(!I)throw new k.BugIndicatingError("Assertion Failed")}e.assert=O;function L(I){if(!I()){debugger;I(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function R(I,g){let P=0;for(;P<I.length-1;){const b=I[P],v=I[P+1];if(!g(b,v))return!1;P++}return!0}e.checkAdjacentItems=R}),define(oe[85],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function k(U){const A=this;let O=!1,L;return function(){return O||(O=!0,L=U.apply(A,arguments)),L}}e.createSingleCallFunction=k}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(U){function A(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}U.is=A;const O=Object.freeze([]);function L(){return O}U.empty=L;function*R(C){yield C}U.single=R;function I(C){return A(C)?C:R(C)}U.wrap=I;function g(C){return C||O}U.from=g;function*P(C){for(let s=C.length-1;s>=0;s--)yield C[s]}U.reverse=P;function b(C){return!C||C[Symbol.iterator]().next().done===!0}U.isEmpty=b;function v(C){return C[Symbol.iterator]().next().value}U.first=v;function c(C,s){for(const o of C)if(s(o))return!0;return!1}U.some=c;function m(C,s){for(const o of C)if(s(o))return o}U.find=m;function*E(C,s){for(const o of C)s(o)&&(yield o)}U.filter=E;function*y(C,s){let o=0;for(const n of C)yield s(n,o++)}U.map=y;function*u(...C){for(const s of C)for(const o of s)yield o}U.concat=u;function d(C,s,o){let n=o;for(const i of C)n=s(n,i);return n}U.reduce=d;function*h(C,s,o=C.length){for(s<0&&(s+=C.length),o<0?o+=C.length:o>C.length&&(o=C.length);s<o;s++)yield C[s]}U.slice=h;function f(C,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,C];const n=C[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[o,U.empty()];o.push(t.value)}return[o,{[Symbol.iterator](){return n}}]}U.consume=f})(k||(e.Iterable=k={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var U;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(U||(e.SyntaxKind=U={}));var A;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var O;(function(s){s.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function L(s,o=!1){let n=0;const i=s.length;let t="",r=0,a=16,w=0;function p(q){let Q=0,G=0;for(;Q<q;){const X=s.charCodeAt(n);if(X>=48&&X<=57)G=G*16+X-48;else if(X>=65&&X<=70)G=G*16+X-65+10;else if(X>=97&&X<=102)G=G*16+X-97+10;else break;n++,Q++}return Q<q&&(G=-1),G}function l(q){n=q,t="",r=0,a=16,w=0}function S(){const q=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&g(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&g(s.charCodeAt(n)))for(n++;n<s.length&&g(s.charCodeAt(n));)n++;else return w=3,s.substring(q,n);let Q=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&g(s.charCodeAt(n))){for(n++;n<s.length&&g(s.charCodeAt(n));)n++;Q=n}else w=3;return s.substring(q,Q)}function _(){let q="",Q=n;for(;;){if(n>=i){q+=s.substring(Q,n),w=2;break}const G=s.charCodeAt(n);if(G===34){q+=s.substring(Q,n),n++;break}if(G===92){if(q+=s.substring(Q,n),n++,n>=i){w=2;break}switch(s.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const x=p(4);x>=0?q+=String.fromCharCode(x):w=4;break}default:w=5}Q=n;continue}if(G>=0&&G<=31)if(I(G)){q+=s.substring(Q,n),w=2;break}else w=6;n++}return q}function N(){if(t="",w=0,r=n,n>=i)return r=i,a=17;let q=s.charCodeAt(n);if(R(q)){do n++,t+=String.fromCharCode(q),q=s.charCodeAt(n);while(R(q));return a=15}if(I(q))return n++,t+=String.fromCharCode(q),q===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=_(),a=10;case 47:{const Q=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!I(s.charCodeAt(n));)n++;return t=s.substring(Q,n),a=12}if(s.charCodeAt(n+1)===42){n+=2;const G=i-1;let X=!1;for(;n<G;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,w=1),t=s.substring(Q,n),a=13}return t+=String.fromCharCode(q),n++,a=16}case 45:if(t+=String.fromCharCode(q),n++,n===i||!g(s.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=S(),a=11;default:for(;n<i&&$(q);)n++,q=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(q),n++,a=16}}function $(q){if(R(q)||I(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=N();while(q>=12&&q<=15);return q}return{setPosition:l,getPosition:()=>n,scan:o?W:N,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>w}}e.createScanner=L;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function I(s){return s===10||s===13||s===8232||s===8233}function g(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function b(s,o){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function w(p,l,S,_){r.value=p,r.offset=l,r.length=S,r.type=_,r.colonOffset=void 0,t=r}try{h(s,{onObjectBegin:(p,l)=>{if(o<=p)throw i;t=void 0,a=o>p,n.push("")},onObjectProperty:(p,l,S)=>{if(o<l||(w(p,l,S,"property"),n[n.length-1]=p,o<=l+S))throw i},onObjectEnd:(p,l)=>{if(o<=p)throw i;t=void 0,n.pop()},onArrayBegin:(p,l)=>{if(o<=p)throw i;t=void 0,n.push(0)},onArrayEnd:(p,l)=>{if(o<=p)throw i;t=void 0,n.pop()},onLiteralValue:(p,l,S)=>{if(o<l||(w(p,l,S,C(p)),o<=l+S))throw i},onSeparator:(p,l,S)=>{if(o<=l)throw i;if(p===":"&&t&&t.type==="property")t.colonOffset=l,a=!1,t=void 0;else if(p===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(p){if(p!==i)throw p}return{path:n,previousNode:t,isAtPropertyKey:a,matches:p=>{let l=0;for(let S=0;l<p.length&&S<n.length;S++)if(p[l]===n[S]||p[l]==="*")l++;else if(p[l]!=="**")return!1;return l===p.length}}}e.getLocation=b;function v(s,o=[],n=O.DEFAULT){let i=null,t=[];const r=[];function a(p){Array.isArray(t)?t.push(p):i!==null&&(t[i]=p)}return h(s,{onObjectBegin:()=>{const p={};a(p),r.push(t),t=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const p=[];a(p),r.push(t),t=p,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(p,l,S)=>{o.push({error:p,offset:l,length:S})}},n),t[0]}e.parse=v;function c(s,o=[],n=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function r(p){return i.children.push(p),p}h(s,{onObjectBegin:p=>{i=r({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,l,S)=>{i=r({type:"property",offset:l,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:l,length:S,parent:i})},onObjectEnd:(p,l)=>{i.length=p+l-i.offset,i=i.parent,t(p+l)},onArrayBegin:(p,l)=>{i=r({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,l)=>{i.length=p+l-i.offset,i=i.parent,t(p+l)},onLiteralValue:(p,l,S)=>{r({type:C(p),offset:l,length:S,parent:i,value:p}),t(l+S)},onSeparator:(p,l,S)=>{i.type==="property"&&(p===":"?i.colonOffset=l:p===","&&t(l))},onError:(p,l,S)=>{o.push({error:p,offset:l,length:S})}},n);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=c;function m(s,o){if(!s)return;let n=s;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.findNodeAtLocation=m;function E(s){if(!s.parent||!s.parent.children)return[];const o=E(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;o.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&o.push(n)}return o}e.getNodePath=E;function y(s){switch(s.type){case"array":return s.children.map(y);case"object":{const o=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(o[n.children[0].value]=y(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=y;function u(s,o,n=!1){return o>=s.offset&&o<s.offset+s.length||n&&o===s.offset+s.length}e.contains=u;function d(s,o,n=!1){if(u(s,o,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=o;t++){const r=d(i[t],o,n);if(r)return r}return s}}e.findNodeAtOffset=d;function h(s,o,n=O.DEFAULT){const i=L(s,!1);function t(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Z){return Z?ne=>Z(ne,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),w=r(o.onObjectProperty),p=t(o.onObjectEnd),l=t(o.onArrayBegin),S=t(o.onArrayEnd),_=r(o.onLiteralValue),N=r(o.onSeparator),$=t(o.onComment),W=r(o.onError),q=n&&n.disallowComments,Q=n&&n.allowTrailingComma;function G(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:q||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(Z){case 12:case 13:q?X(10):$();break;case 16:X(1);break;case 15:case 14:break;default:return Z}}}function X(Z,ne=[],K=[]){if(W(Z),ne.length+K.length>0){let j=i.getToken();for(;j!==17;){if(ne.indexOf(j)!==-1){G();break}else if(K.indexOf(j)!==-1)break;j=G()}}}function x(Z){const ne=i.getTokenValue();return Z?_(ne):w(ne),G(),!0}function Y(){switch(i.getToken()){case 11:{let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(X(2),Z=0)}catch{X(2)}_(Z);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return G(),!0}function B(){return i.getToken()!==10?(X(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(N(":"),G(),ie()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function z(){a(),G();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||X(4,[],[]),N(","),G(),i.getToken()===2&&Q)break}else Z&&X(6,[],[]);B()||X(4,[],[2,5]),Z=!0}return p(),i.getToken()!==2?X(7,[2],[]):G(),!0}function ee(){l(),G();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||X(4,[],[]),N(","),G(),i.getToken()===4&&Q)break}else Z&&X(6,[],[]);ie()||X(4,[],[4,5]),Z=!0}return S(),i.getToken()!==4?X(8,[4],[]):G(),!0}function ie(){switch(i.getToken()){case 3:return ee();case 1:return z();case 10:return x(!0);default:return Y()}}return G(),i.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):ie()?(i.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=h;function f(s,o){const n=L(s),i=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&i.push(s.substring(r,a)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return i.join("")}e.stripComments=f;function C(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(oe[41],ae([0,1,35]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function U(g,P,b){let v,c,m,E,y;if(P){for(E=P.offset,y=E+P.length,m=E;m>0&&!I(g,m-1);)m--;let a=y;for(;a<g.length&&!I(g,a);)a++;c=g.substring(m,a),v=L(c,b)}else c=g,v=0,m=0,E=0,y=g.length;const u=R(b,g);let d=!1,h=0,f;b.insertSpaces?f=O(" ",b.tabSize||4):f="	";const C=(0,k.createScanner)(c,!1);let s=!1;function o(){return u+O(f,v+h)}function n(){let a=C.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=C.scan();return s=a===16||C.getTokenError()!==0,a}const i=[];function t(a,w,p){!s&&w<y&&p>E&&g.substring(w,p)!==a&&i.push({offset:w,length:p-w,content:a})}let r=n();if(r!==17){const a=C.getTokenOffset()+m,w=O(f,v);t(w,m,a)}for(;r!==17;){let a=C.getTokenOffset()+C.getTokenLength()+m,w=n(),p="";for(;!d&&(w===12||w===13);){const S=C.getTokenOffset()+m;t(" ",a,S),a=C.getTokenOffset()+C.getTokenLength()+m,p=w===12?o():"",w=n()}if(w===2)r!==1&&(h--,p=o());else if(w===4)r!==3&&(h--,p=o());else{switch(r){case 3:case 1:h++,p=o();break;case 5:case 12:p=o();break;case 13:d?p=o():p=" ";break;case 6:p=" ";break;case 10:if(w===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?p=" ":w!==5&&w!==17&&(s=!0);break;case 16:s=!0;break}d&&(w===12||w===13)&&(p=o())}const l=C.getTokenOffset()+m;t(p,a,l),r=w}return i}e.format=U;function A(g,P){const b=JSON.stringify(g,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?b.replace(/\r\n|\r|\n/g,P.eol):b}e.toFormattedString=A;function O(g,P){let b="";for(let v=0;v<P;v++)b+=g;return b}function L(g,P){let b=0,v=0;const c=P.tabSize||4;for(;b<g.length;){const m=g.charAt(b);if(m===" ")v++;else if(m==="	")v+=c;else break;b++}return Math.floor(v/c)}function R(g,P){for(let b=0;b<P.length;b++){const v=P.charAt(b);if(v==="\r")return b+1<P.length&&P.charAt(b+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=R;function I(g,P){return`\r
`.indexOf(g.charAt(P))!==-1}e.isEOL=I}),define(oe[86],ae([0,1,35,41]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(g,P,b){return O(g,P,void 0,b)}e.removeProperty=A;function O(g,P,b,v,c){const m=P.slice(),E=[],y=(0,k.parseTree)(g,E);let u,d;for(;m.length>0&&(d=m.pop(),u=(0,k.findNodeAtLocation)(y,m),u===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const h=(0,k.findNodeAtLocation)(u,[d]);if(h!==void 0)if(b===void 0){if(!h.parent)throw new Error("Malformed AST");const f=u.children.indexOf(h.parent);let C,s=h.parent.offset+h.parent.length;if(f>0){const o=u.children[f-1];C=o.offset+o.length}else C=u.offset+1,u.children.length>1&&(s=u.children[1].offset);return L(g,{offset:C,length:s-C,content:""},v)}else return L(g,{offset:h.offset,length:h.length,content:JSON.stringify(b)},v);else{if(b===void 0)return[];const f=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,C=c?c(u.children.map(o=>o.children[0].value)):u.children.length;let s;if(C>0){const o=u.children[C-1];s={offset:o.offset+o.length,length:0,content:","+f}}else u.children.length===0?s={offset:u.offset+1,length:0,content:f}:s={offset:u.offset+1,length:0,content:f+","};return L(g,s,v)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(b!==void 0){const h=`${JSON.stringify(b)}`;let f;if(u.children.length===0||d===0)f={offset:u.offset+1,length:0,content:u.children.length===0?h:h+","};else{const C=d===-1||d>u.children.length?u.children.length:d,s=u.children[C-1];f={offset:s.offset+s.length,length:0,content:","+h}}return L(g,f,v)}else{const h=d,f=u.children[h];let C;if(u.children.length===1)C={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===h){const s=u.children[h-1],o=s.offset+s.length,n=u.offset+u.length;C={offset:o,length:n-2-o,content:""}}else C={offset:f.offset,length:u.children[h+1].offset-f.offset,content:""};return L(g,C,v)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return L(g,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(b)},v)}}e.setProperty=O;function L(g,P,b){let v=R(g,P),c=P.offset,m=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;c>0&&!(0,U.isEOL)(v,c-1);)c--;for(;m<v.length&&!(0,U.isEOL)(v,m);)m++}const E=(0,U.format)(v,{offset:c,length:m-c},b);for(let u=E.length-1;u>=0;u--){const d=E[u];v=R(v,d),c=Math.min(c,d.offset),m=Math.max(m,d.offset+d.length),m+=d.content.length-d.length}const y=g.length-(v.length-m)-c;return[{offset:c,length:y,content:v.substring(c,m)}]}e.withFormatting=L;function R(g,P){return g.substring(0,P.offset)+P.content+g.substring(P.offset+P.length)}e.applyEdit=R;function I(g,P){const b=P.slice(0).sort((c,m)=>{const E=c.offset-m.offset;return E===0?c.length-m.length:E});let v=g.length;for(let c=b.length-1;c>=0;c--){const m=b[c];if(m.offset+m.length<=v)g=R(g,m);else throw new Error("Overlapping edit");v=m.offset}return g}e.applyEdits=I}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(A){this.executor=A,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=k}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{static{this.Undefined=new k(void 0)}constructor(O){this.element=O,this.next=k.Undefined,this.prev=k.Undefined}}class U{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let O=this._first;for(;O!==k.Undefined;){const L=O.next;O.prev=k.Undefined,O.next=k.Undefined,O=L}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,L){const R=new k(O);if(this._first===k.Undefined)this._first=R,this._last=R;else if(L){const g=this._last;this._last=R,R.prev=g,g.next=R}else{const g=this._first;this._first=R,R.next=g,g.prev=R}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(R))}}shift(){if(this._first!==k.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==k.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==k.Undefined&&O.next!==k.Undefined){const L=O.prev;L.next=O.next,O.next.prev=L}else O.prev===k.Undefined&&O.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):O.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):O.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==k.Undefined;)yield O.element,O=O.next}}e.LinkedList=U}),define(oe[34],ae([0,1]),function(te,e){"use strict";var k,U,A;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(d,h,f){let C=d.get(h);return C===void 0&&(C=f,d.set(h,C)),C}e.getOrSet=O;function L(d){const h=[];return d.forEach((f,C)=>{h.push(`${C} => ${f}`)}),`Map(${d.size}) {${h.join(", ")}}`}e.mapToString=L;function R(d){const h=[];return d.forEach(f=>{h.push(f)}),`Set(${d.size}) {${h.join(", ")}}`}e.setToString=R;class I{constructor(h,f){this.uri=h,this.value=f}}function g(d){return Array.isArray(d)}class P{static{this.defaultToKey=h=>h.toString()}constructor(h,f){if(this[k]="ResourceMap",h instanceof P)this.map=new Map(h.map),this.toKey=f??P.defaultToKey;else if(g(h)){this.map=new Map,this.toKey=f??P.defaultToKey;for(const[C,s]of h)this.set(C,s)}else this.map=new Map,this.toKey=h??P.defaultToKey}set(h,f){return this.map.set(this.toKey(h),new I(h,f)),this}get(h){return this.map.get(this.toKey(h))?.value}has(h){return this.map.has(this.toKey(h))}get size(){return this.map.size}clear(){this.map.clear()}delete(h){return this.map.delete(this.toKey(h))}forEach(h,f){typeof f<"u"&&(h=h.bind(f));for(const[C,s]of this.map)h(s.value,s.uri,this)}*values(){for(const h of this.map.values())yield h.value}*keys(){for(const h of this.map.values())yield h.uri}*entries(){for(const h of this.map.values())yield[h.uri,h.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.map)yield[h.uri,h.value]}}e.ResourceMap=P;class b{constructor(h,f){this[U]="ResourceSet",!h||typeof h=="function"?this._map=new P(h):(this._map=new P(f),h.forEach(this.add,this))}get size(){return this._map.size}add(h){return this._map.set(h,h),this}clear(){this._map.clear()}delete(h){return this._map.delete(h)}forEach(h,f){this._map.forEach((C,s)=>h.call(f,s,s,this))}has(h){return this._map.has(h)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var v;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class c{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(h){return this._map.has(h)}get(h,f=0){const C=this._map.get(h);if(C)return f!==0&&this.touch(C,f),C.value}set(h,f,C=0){let s=this._map.get(h);if(s)s.value=f,C!==0&&this.touch(s,C);else{switch(s={key:h,value:f,next:void 0,previous:void 0},C){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(h,s),this._size++}return this}delete(h){return!!this.remove(h)}remove(h){const f=this._map.get(h);if(f)return this._map.delete(h),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const h=this._head;return this._map.delete(h.key),this.removeItem(h),this._size--,h.value}forEach(h,f){const C=this._state;let s=this._head;for(;s;){if(f?h.bind(f)(s.value,s.key,this):h(s.value,s.key,this),this._state!==C)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,f=this._state;let C=this._head;const s={[Symbol.iterator](){return s},next(){if(h._state!==f)throw new Error("LinkedMap got modified during iteration.");if(C){const o={value:C.key,done:!1};return C=C.next,o}else return{value:void 0,done:!0}}};return s}values(){const h=this,f=this._state;let C=this._head;const s={[Symbol.iterator](){return s},next(){if(h._state!==f)throw new Error("LinkedMap got modified during iteration.");if(C){const o={value:C.value,done:!1};return C=C.next,o}else return{value:void 0,done:!0}}};return s}entries(){const h=this,f=this._state;let C=this._head;const s={[Symbol.iterator](){return s},next(){if(h._state!==f)throw new Error("LinkedMap got modified during iteration.");if(C){const o={value:[C.key,C.value],done:!1};return C=C.next,o}else return{value:void 0,done:!0}}};return s}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(h){if(h>=this.size)return;if(h===0){this.clear();return}let f=this._head,C=this.size;for(;f&&C>h;)this._map.delete(f.key),f=f.next,C--;this._head=f,this._size=C,f&&(f.previous=void 0),this._state++}addItemFirst(h){if(!this._head&&!this._tail)this._tail=h;else if(this._head)h.next=this._head,this._head.previous=h;else throw new Error("Invalid list");this._head=h,this._state++}addItemLast(h){if(!this._head&&!this._tail)this._head=h;else if(this._tail)h.previous=this._tail,this._tail.next=h;else throw new Error("Invalid list");this._tail=h,this._state++}removeItem(h){if(h===this._head&&h===this._tail)this._head=void 0,this._tail=void 0;else if(h===this._head){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this._head=h.next}else if(h===this._tail){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this._tail=h.previous}else{const f=h.next,C=h.previous;if(!f||!C)throw new Error("Invalid list");f.previous=C,C.next=f}h.next=void 0,h.previous=void 0,this._state++}touch(h,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(h===this._head)return;const C=h.next,s=h.previous;h===this._tail?(s.next=void 0,this._tail=s):(C.previous=s,s.next=C),h.previous=void 0,h.next=this._head,this._head.previous=h,this._head=h,this._state++}else if(f===2){if(h===this._tail)return;const C=h.next,s=h.previous;h===this._head?(C.previous=void 0,this._head=C):(C.previous=s,s.next=C),h.next=void 0,h.previous=this._tail,this._tail.next=h,this._tail=h,this._state++}}}toJSON(){const h=[];return this.forEach((f,C)=>{h.push([C,f])}),h}fromJSON(h){this.clear();for(const[f,C]of h)this.set(f,C)}}e.LinkedMap=c;class m extends c{constructor(h,f=1){super(),this._limit=h,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(h){this._limit=h,this.checkTrim()}get ratio(){return this._ratio}set ratio(h){this._ratio=Math.min(Math.max(0,h),1),this.checkTrim()}get(h,f=2){return super.get(h,f)}peek(h){return super.get(h,0)}set(h,f){return super.set(h,f,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class E{constructor(){this.map=new Map}add(h){return this.map.set(h,(this.map.get(h)||0)+1),this}delete(h){let f=this.map.get(h)||0;return f===0?!1:(f--,f===0?this.map.delete(h):this.map.set(h,f),!0)}has(h){return this.map.has(h)}}e.CounterSet=E;class y{constructor(h){if(this._m1=new Map,this._m2=new Map,h)for(const[f,C]of h)this.set(f,C)}clear(){this._m1.clear(),this._m2.clear()}set(h,f){this._m1.set(h,f),this._m2.set(f,h)}get(h){return this._m1.get(h)}getKey(h){return this._m2.get(h)}delete(h){const f=this._m1.get(h);return f===void 0?!1:(this._m1.delete(h),this._m2.delete(f),!0)}forEach(h,f){this._m1.forEach((C,s)=>{h.call(f,C,s,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=y;class u{constructor(){this.map=new Map}add(h,f){let C=this.map.get(h);C||(C=new Set,this.map.set(h,C)),C.add(f)}delete(h,f){const C=this.map.get(h);C&&(C.delete(f),C.size===0&&this.map.delete(h))}forEach(h,f){const C=this.map.get(h);C&&C.forEach(f)}get(h){const f=this.map.get(h);return f||new Set}}e.SetMap=u}),define(oe[2],ae([0,1,18,125,34,85,59]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const R=!1;let I=null;class g{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(S){let _=this.livingDisposables.get(S);return _||(_={parent:null,source:null,isSingleton:!1,value:S,idx:g.idx++},this.livingDisposables.set(S,_)),_}trackDisposable(S){const _=this.getDisposableData(S);_.source||(_.source=new Error().stack)}setParent(S,_){const N=this.getDisposableData(S);N.parent=_}markAsDisposed(S){this.livingDisposables.delete(S)}markAsSingleton(S){this.getDisposableData(S).isSingleton=!0}getRootParent(S,_){const N=_.get(S);if(N)return N;const $=S.parent?this.getRootParent(this.getDisposableData(S.parent),_):S;return _.set(S,$),$}getTrackedDisposables(){const S=new Map;return[...this.livingDisposables.entries()].filter(([,N])=>N.source!==null&&!this.getRootParent(N,S).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(S=10,_){let N;if(_)N=_;else{const G=new Map,X=[...this.livingDisposables.values()].filter(Y=>Y.source!==null&&!this.getRootParent(Y,G).isSingleton);if(X.length===0)return;const x=new Set(X.map(Y=>Y.value));if(N=X.filter(Y=>!(Y.parent&&x.has(Y.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function $(G){function X(Y,B){for(;Y.length>0&&B.some(z=>typeof z=="string"?z===Y[0]:Y[0].match(z));)Y.shift()}const x=G.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return X(x,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),x.reverse()}const W=new A.SetMap;for(const G of N){const X=$(G);for(let x=0;x<=X.length;x++)W.add(X.slice(0,x).join(`
`),G)}N.sort((0,k.compareBy)(G=>G.idx,k.numberComparator));let q="",Q=0;for(const G of N.slice(0,S)){Q++;const X=$(G),x=[];for(let Y=0;Y<X.length;Y++){let B=X[Y];B=`(shared with ${W.get(X.slice(0,Y+1).join(`
`)).size}/${N.length} leaks) at ${B}`;const ee=W.get(X.slice(0,Y).join(`
`)),ie=(0,U.groupBy)([...ee].map(Z=>$(Z)[Y]),Z=>Z);delete ie[X[Y]];for(const[Z,ne]of Object.entries(ie))x.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${Z}`);x.unshift(B)}q+=`


==================== Leaking disposable ${Q}/${N.length}: ${G.value.constructor.name} ====================
${x.join(`
`)}
============================================================

`}return N.length>S&&(q+=`


... and ${N.length-S} more leaking disposables

`),{leaks:N,details:q}}}e.DisposableTracker=g;function P(l){I=l}if(e.setDisposableTracker=P,R){const l="__is_disposable_tracked__";P(new class{trackDisposable(S){const _=new Error("Potentially leaked disposable").stack;setTimeout(()=>{S[l]||console.log(_)},3e3)}setParent(S,_){if(S&&S!==s.None)try{S[l]=!0}catch{}}markAsDisposed(S){if(S&&S!==s.None)try{S[l]=!0}catch{}}markAsSingleton(S){}})}function b(l){return I?.trackDisposable(l),l}e.trackDisposable=b;function v(l){I?.markAsDisposed(l)}e.markAsDisposed=v;function c(l,S){I?.setParent(l,S)}function m(l,S){if(I)for(const _ of l)I.setParent(_,S)}function E(l){return I?.markAsSingleton(l),l}e.markAsSingleton=E;function y(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=y;function u(l){if(L.Iterable.is(l)){const S=[];for(const _ of l)if(_)try{_.dispose()}catch(N){S.push(N)}if(S.length===1)throw S[0];if(S.length>1)throw new AggregateError(S,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=u;function d(l){for(const S of l)y(S)&&S.dispose();return[]}e.disposeIfDisposable=d;function h(...l){const S=f(()=>u(l));return m(l,S),S}e.combinedDisposable=h;function f(l){const S=b({dispose:(0,O.createSingleCallFunction)(()=>{v(S),l()})});return S}e.toDisposable=f;class C{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(S){if(!S)return S;if(S===this)throw new Error("Cannot register a disposable on itself!");return c(S,this),this._isDisposed?C.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(S),S}delete(S){if(S){if(S===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(S),S.dispose()}}deleteAndLeak(S){S&&this._toDispose.has(S)&&(this._toDispose.delete(S),c(S,null))}}e.DisposableStore=C;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new C,b(this),c(this._store,this)}dispose(){v(this),this._store.dispose()}_register(S){if(S===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(S)}}e.Disposable=s;class o{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(S){this._isDisposed||S===this._value||(this._value?.dispose(),S&&c(S,this),this._value=S)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const S=this._value;return this._value=void 0,S&&c(S,null),S}}e.MutableDisposable=o;class n{constructor(S){this._disposable=S,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(S){let _=S;return this.unset=()=>_=void 0,this.isset=()=>_!==void 0,this.dispose=()=>{_&&(_(),_=void 0,v(this))},this}}e.SafeDisposable=i;class t{constructor(){this.references=new Map}acquire(S,..._){let N=this.references.get(S);N||(N={counter:0,object:this.createReferencedObject(S,..._)},this.references.set(S,N));const{object:$}=N,W=(0,O.createSingleCallFunction)(()=>{--N.counter===0&&(this.destroyReferencedObject(S,N.object),this.references.delete(S))});return N.counter++,{object:$,dispose:W}}}e.ReferenceCollection=t;class r{constructor(S){this.referenceCollection=S}async acquire(S,..._){const N=this.referenceCollection.acquire(S,..._);try{return{object:await N.object,dispose:()=>N.dispose()}}catch($){throw N.dispose(),$}}}e.AsyncReferenceCollection=r;class a{constructor(S){this.object=S}dispose(){}}e.ImmortalReference=a;function w(l){const S=new C;try{l(S)}finally{S.dispose()}}e.disposeOnReturn=w;class p{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){v(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(S){return this._store.has(S)}get size(){return this._store.size}get(S){return this._store.get(S)}set(S,_,N=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this._store.get(S)?.dispose(),this._store.set(S,_)}deleteAndDispose(S){this._store.get(S)?.dispose(),this._store.delete(S)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=p}),define(oe[88],ae([0,1,34]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const U=new k.LRUCache(1e4);function A(g){return I(g,"NFC",U)}e.normalizeNFC=A;const O=new k.LRUCache(1e4);function L(g){return I(g,"NFD",O)}e.normalizeNFD=L;const R=/[^\u0000-\u0080]/;function I(g,P,b){if(!g)return g;const v=b.get(g);if(v)return v;let c;return R.test(g)?c=g.normalize(P):c=g,b.set(g,c),c}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(P){return L(P).replace(g,"")}}()}),function(){function te(A){const O=[];typeof A=="number"&&O.push("code/timeOrigin",A);function L(I){O.push(I,Date.now())}function R(){const I=[];for(let g=0;g<O.length;g+=2)I.push({name:O[g],startTime:O[g+1]});return I}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const L of performance.getEntriesByType("mark"))O.push({name:L.name,startTime:Math.round(A+L.startTime)});return O}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function k(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=k(U))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var U in k)(typeof exports=="object"?exports:te)[U]=k[U]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function k(U){if(e[U])return e[U].exports;var A=e[U]={i:U,l:!1,exports:{}};return te[U].call(A.exports,A,A.exports,k),A.l=!0,A.exports}return k.m=te,k.c=e,k.d=function(U,A,O){k.o(U,A)||Object.defineProperty(U,A,{enumerable:!0,get:O})},k.r=function(U){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},k.t=function(U,A){if(1&A&&(U=k(U)),8&A||4&A&&typeof U=="object"&&U&&U.__esModule)return U;var O=Object.create(null);if(k.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:U}),2&A&&typeof U!="string")for(var L in U)k.d(O,L,function(R){return U[R]}.bind(null,L));return O},k.n=function(U){var A=U&&U.__esModule?function(){return U.default}:function(){return U};return k.d(A,"a",A),A},k.o=function(U,A){return Object.prototype.hasOwnProperty.call(U,A)},k.p="",k(k.s=0)}([function(te,e,k){(function(U){var A;e=te.exports=K,A=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],I=e.src=[],g=0,P=g++;I[P]="0|[1-9]\\d*";var b=g++;I[b]="[0-9]+";var v=g++;I[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=g++;I[c]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var m=g++;I[m]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var E=g++;I[E]="(?:"+I[P]+"|"+I[v]+")";var y=g++;I[y]="(?:"+I[b]+"|"+I[v]+")";var u=g++;I[u]="(?:-("+I[E]+"(?:\\."+I[E]+")*))";var d=g++;I[d]="(?:-?("+I[y]+"(?:\\."+I[y]+")*))";var h=g++;I[h]="[0-9A-Za-z-]+";var f=g++;I[f]="(?:\\+("+I[h]+"(?:\\."+I[h]+")*))";var C=g++,s="v?"+I[c]+I[u]+"?"+I[f]+"?";I[C]="^"+s+"$";var o="[v=\\s]*"+I[m]+I[d]+"?"+I[f]+"?",n=g++;I[n]="^"+o+"$";var i=g++;I[i]="((?:<|>)?=?)";var t=g++;I[t]=I[b]+"|x|X|\\*";var r=g++;I[r]=I[P]+"|x|X|\\*";var a=g++;I[a]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[u]+")?"+I[f]+"?)?)?";var w=g++;I[w]="[v=\\s]*("+I[t]+")(?:\\.("+I[t]+")(?:\\.("+I[t]+")(?:"+I[d]+")?"+I[f]+"?)?)?";var p=g++;I[p]="^"+I[i]+"\\s*"+I[a]+"$";var l=g++;I[l]="^"+I[i]+"\\s*"+I[w]+"$";var S=g++;I[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=g++;I[_]="(?:~>?)";var N=g++;I[N]="(\\s*)"+I[_]+"\\s+",R[N]=new RegExp(I[N],"g");var $=g++;I[$]="^"+I[_]+I[a]+"$";var W=g++;I[W]="^"+I[_]+I[w]+"$";var q=g++;I[q]="(?:\\^)";var Q=g++;I[Q]="(\\s*)"+I[q]+"\\s+",R[Q]=new RegExp(I[Q],"g");var G=g++;I[G]="^"+I[q]+I[a]+"$";var X=g++;I[X]="^"+I[q]+I[w]+"$";var x=g++;I[x]="^"+I[i]+"\\s*("+o+")$|^$";var Y=g++;I[Y]="^"+I[i]+"\\s*("+s+")$|^$";var B=g++;I[B]="(\\s*)"+I[i]+"\\s*("+o+"|"+I[a]+")",R[B]=new RegExp(I[B],"g");var z=g++;I[z]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var ee=g++;I[ee]="^\\s*("+I[w]+")\\s+-\\s+("+I[w]+")\\s*$";var ie=g++;I[ie]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)A(Z,I[Z]),R[Z]||(R[Z]=new RegExp(I[Z]));function ne(le,ge){if(le instanceof K)return le;if(typeof le!="string"||le.length>O||!(ge?R[n]:R[C]).test(le))return null;try{return new K(le,ge)}catch{return null}}function K(le,ge){if(le instanceof K){if(le.loose===ge)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof K))return new K(le,ge);A("SemVer",le,ge),this.loose=ge;var ve=le.trim().match(ge?R[n]:R[C]);if(!ve)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var De=+Ie;if(De>=0&&De<L)return De}return Ie}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=ne,e.valid=function(le,ge){var ve=ne(le,ge);return ve?ve.version:null},e.clean=function(le,ge){var ve=ne(le.trim().replace(/^[=v]+/,""),ge);return ve?ve.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(le){return A("SemVer.compare",this.version,this.loose,le),le instanceof K||(le=new K(le,this.loose)),this.compareMain(le)||this.comparePre(le)},K.prototype.compareMain=function(le){return le instanceof K||(le=new K(le,this.loose)),D(this.major,le.major)||D(this.minor,le.minor)||D(this.patch,le.patch)},K.prototype.comparePre=function(le){if(le instanceof K||(le=new K(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ge=0;do{var ve=this.prerelease[ge],Ie=le.prerelease[ge];if(A("prerelease compare",ge,ve,Ie),ve===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ie)return D(ve,Ie)}while(++ge)},K.prototype.inc=function(le,ge){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ge,ve,Ie){typeof ve=="string"&&(Ie=ve,ve=void 0);try{return new K(le,ve).inc(ge,Ie).version}catch{return null}},e.diff=function(le,ge){if(V(le,ge))return null;var ve=ne(le),Ie=ne(ge);if(ve.prerelease.length||Ie.prerelease.length){for(var De in ve)if((De==="major"||De==="minor"||De==="patch")&&ve[De]!==Ie[De])return"pre"+De;return"prerelease"}for(var De in ve)if((De==="major"||De==="minor"||De==="patch")&&ve[De]!==Ie[De])return De},e.compareIdentifiers=D;var j=/^[0-9]+$/;function D(le,ge){var ve=j.test(le),Ie=j.test(ge);return ve&&Ie&&(le=+le,ge=+ge),ve&&!Ie?-1:Ie&&!ve?1:le<ge?-1:le>ge?1:0}function T(le,ge,ve){return new K(le,ve).compare(new K(ge,ve))}function M(le,ge,ve){return T(le,ge,ve)>0}function F(le,ge,ve){return T(le,ge,ve)<0}function V(le,ge,ve){return T(le,ge,ve)===0}function H(le,ge,ve){return T(le,ge,ve)!==0}function re(le,ge,ve){return T(le,ge,ve)>=0}function ce(le,ge,ve){return T(le,ge,ve)<=0}function he(le,ge,ve,Ie){var De;switch(ge){case"===":typeof le=="object"&&(le=le.version),typeof ve=="object"&&(ve=ve.version),De=le===ve;break;case"!==":typeof le=="object"&&(le=le.version),typeof ve=="object"&&(ve=ve.version),De=le!==ve;break;case"":case"=":case"==":De=V(le,ve,Ie);break;case"!=":De=H(le,ve,Ie);break;case">":De=M(le,ve,Ie);break;case">=":De=re(le,ve,Ie);break;case"<":De=F(le,ve,Ie);break;case"<=":De=ce(le,ve,Ie);break;default:throw new TypeError("Invalid operator: "+ge)}return De}function ue(le,ge){if(le instanceof ue){if(le.loose===ge)return le;le=le.value}if(!(this instanceof ue))return new ue(le,ge);A("comparator",le,ge),this.loose=ge,this.parse(le),this.semver===me?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(le,ge){return D(ge,le)},e.major=function(le,ge){return new K(le,ge).major},e.minor=function(le,ge){return new K(le,ge).minor},e.patch=function(le,ge){return new K(le,ge).patch},e.compare=T,e.compareLoose=function(le,ge){return T(le,ge,!0)},e.rcompare=function(le,ge,ve){return T(ge,le,ve)},e.sort=function(le,ge){return le.sort(function(ve,Ie){return e.compare(ve,Ie,ge)})},e.rsort=function(le,ge){return le.sort(function(ve,Ie){return e.rcompare(ve,Ie,ge)})},e.gt=M,e.lt=F,e.eq=V,e.neq=H,e.gte=re,e.lte=ce,e.cmp=he,e.Comparator=ue;var me={};function fe(le,ge){if(le instanceof fe)return le.loose===ge?le:new fe(le.raw,ge);if(le instanceof ue)return new fe(le.value,ge);if(!(this instanceof fe))return new fe(le,ge);if(this.loose=ge,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function pe(le){return!le||le.toLowerCase()==="x"||le==="*"}function we(le,ge,ve,Ie,De,$e,Te,We,Fe,se,de,Se,Ee){return((ge=pe(ve)?"":pe(Ie)?">="+ve+".0.0":pe(De)?">="+ve+"."+Ie+".0":">="+ge)+" "+(We=pe(Fe)?"":pe(se)?"<"+(+Fe+1)+".0.0":pe(de)?"<"+Fe+"."+(+se+1)+".0":Se?"<="+Fe+"."+se+"."+de+"-"+Se:"<="+We)).trim()}function Le(le,ge){for(var ve=0;ve<le.length;ve++)if(!le[ve].test(ge))return!1;if(ge.prerelease.length){for(ve=0;ve<le.length;ve++)if(A(le[ve].semver),le[ve].semver!==me&&le[ve].semver.prerelease.length>0){var Ie=le[ve].semver;if(Ie.major===ge.major&&Ie.minor===ge.minor&&Ie.patch===ge.patch)return!0}return!1}return!0}function Ue(le,ge,ve){try{ge=new fe(ge,ve)}catch{return!1}return ge.test(le)}function Me(le,ge,ve,Ie){var De,$e,Te,We,Fe;switch(le=new K(le,Ie),ge=new fe(ge,Ie),ve){case">":De=M,$e=ce,Te=F,We=">",Fe=">=";break;case"<":De=F,$e=re,Te=M,We="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(le,ge,Ie))return!1;for(var se=0;se<ge.set.length;++se){var de=ge.set[se],Se=null,Ee=null;if(de.forEach(function(be){be.semver===me&&(be=new ue(">=0.0.0")),Se=Se||be,Ee=Ee||be,De(be.semver,Se.semver,Ie)?Se=be:Te(be.semver,Ee.semver,Ie)&&(Ee=be)}),Se.operator===We||Se.operator===Fe||(!Ee.operator||Ee.operator===We)&&$e(le,Ee.semver)||Ee.operator===Fe&&Te(le,Ee.semver))return!1}return!0}ue.prototype.parse=function(le){var ge=this.loose?R[x]:R[Y],ve=le.match(ge);if(!ve)throw new TypeError("Invalid comparator: "+le);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new K(ve[2],this.loose):this.semver=me},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(le){return A("Comparator.test",le,this.loose),this.semver===me||(typeof le=="string"&&(le=new K(le,this.loose)),he(le,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(le,ge){if(!(le instanceof ue))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new fe(le.value,ge),Ue(this.value,ve,ge);if(le.operator==="")return ve=new fe(this.value,ge),Ue(le.semver,ve,ge);var Ie=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),$e=this.semver.version===le.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),We=he(this.semver,"<",le.semver,ge)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Fe=he(this.semver,">",le.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Ie||De||$e&&Te||We||Fe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(le){var ge=this.loose;le=le.trim(),A("range",le,ge);var ve=ge?R[ee]:R[z];le=le.replace(ve,we),A("hyphen replace",le),le=le.replace(R[B],"$1$2$3"),A("comparator trim",le,R[B]),le=(le=(le=le.replace(R[N],"$1~")).replace(R[Q],"$1^")).split(/\s+/).join(" ");var Ie=ge?R[x]:R[Y],De=le.split(" ").map(function($e){return function(Te,We){return A("comp",Te),Te=function(Fe,se){return Fe.trim().split(/\s+/).map(function(de){return function(Se,Ee){A("caret",Se,Ee);var be=Ee?R[X]:R[G];return Se.replace(be,function(Re,Pe,ke,_e,Oe){var Ne;return A("caret",Se,Re,Pe,ke,_e,Oe),pe(Pe)?Ne="":pe(ke)?Ne=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":pe(_e)?Ne=Pe==="0"?">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0":">="+Pe+"."+ke+".0 <"+(+Pe+1)+".0.0":Oe?(A("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=Pe==="0"?ke==="0"?">="+Pe+"."+ke+"."+_e+Oe+" <"+Pe+"."+ke+"."+(+_e+1):">="+Pe+"."+ke+"."+_e+Oe+" <"+Pe+"."+(+ke+1)+".0":">="+Pe+"."+ke+"."+_e+Oe+" <"+(+Pe+1)+".0.0"):(A("no pr"),Ne=Pe==="0"?ke==="0"?">="+Pe+"."+ke+"."+_e+" <"+Pe+"."+ke+"."+(+_e+1):">="+Pe+"."+ke+"."+_e+" <"+Pe+"."+(+ke+1)+".0":">="+Pe+"."+ke+"."+_e+" <"+(+Pe+1)+".0.0"),A("caret return",Ne),Ne})}(de,se)}).join(" ")}(Te,We),A("caret",Te),Te=function(Fe,se){return Fe.trim().split(/\s+/).map(function(de){return function(Se,Ee){var be=Ee?R[W]:R[$];return Se.replace(be,function(Re,Pe,ke,_e,Oe){var Ne;return A("tilde",Se,Re,Pe,ke,_e,Oe),pe(Pe)?Ne="":pe(ke)?Ne=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":pe(_e)?Ne=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0":Oe?(A("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=">="+Pe+"."+ke+"."+_e+Oe+" <"+Pe+"."+(+ke+1)+".0"):Ne=">="+Pe+"."+ke+"."+_e+" <"+Pe+"."+(+ke+1)+".0",A("tilde return",Ne),Ne})}(de,se)}).join(" ")}(Te,We),A("tildes",Te),Te=function(Fe,se){return A("replaceXRanges",Fe,se),Fe.split(/\s+/).map(function(de){return function(Se,Ee){Se=Se.trim();var be=Ee?R[l]:R[p];return Se.replace(be,function(Re,Pe,ke,_e,Oe,Ne){A("xRange",Se,Re,Pe,ke,_e,Oe,Ne);var qe=pe(ke),je=qe||pe(_e),xe=je||pe(Oe);return Pe==="="&&xe&&(Pe=""),qe?Re=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&xe?(je&&(_e=0),xe&&(Oe=0),Pe===">"?(Pe=">=",je?(ke=+ke+1,_e=0,Oe=0):xe&&(_e=+_e+1,Oe=0)):Pe==="<="&&(Pe="<",je?ke=+ke+1:_e=+_e+1),Re=Pe+ke+"."+_e+"."+Oe):je?Re=">="+ke+".0.0 <"+(+ke+1)+".0.0":xe&&(Re=">="+ke+"."+_e+".0 <"+ke+"."+(+_e+1)+".0"),A("xRange return",Re),Re})}(de,se)}).join(" ")}(Te,We),A("xrange",Te),Te=function(Fe,se){return A("replaceStars",Fe,se),Fe.trim().replace(R[ie],"")}(Te,We),A("stars",Te),Te}($e,ge)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function($e){return!!$e.match(Ie)})),De=De.map(function($e){return new ue($e,ge)})},fe.prototype.intersects=function(le,ge){if(!(le instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ie){return le.set.some(function(De){return De.every(function($e){return Ie.intersects($e,ge)})})})})},e.toComparators=function(le,ge){return new fe(le,ge).set.map(function(ve){return ve.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new K(le,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Le(this.set[ge],le))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(le,ge,ve){var Ie=null,De=null;try{var $e=new fe(ge,ve)}catch{return null}return le.forEach(function(Te){$e.test(Te)&&(Ie&&De.compare(Te)!==-1||(De=new K(Ie=Te,ve)))}),Ie},e.minSatisfying=function(le,ge,ve){var Ie=null,De=null;try{var $e=new fe(ge,ve)}catch{return null}return le.forEach(function(Te){$e.test(Te)&&(Ie&&De.compare(Te)!==1||(De=new K(Ie=Te,ve)))}),Ie},e.validRange=function(le,ge){try{return new fe(le,ge).range||"*"}catch{return null}},e.ltr=function(le,ge,ve){return Me(le,ge,"<",ve)},e.gtr=function(le,ge,ve){return Me(le,ge,">",ve)},e.outside=Me,e.prerelease=function(le,ge){var ve=ne(le,ge);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(le,ge,ve){return le=new fe(le,ve),ge=new fe(ge,ve),le.intersects(ge)},e.coerce=function(le){if(le instanceof K)return le;if(typeof le!="string")return null;var ge=le.match(R[S]);return ge==null?null:ne((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,k(1))},function(te,e){var k,U,A=te.exports={};function O(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(y){if(k===setTimeout)return setTimeout(y,0);if((k===O||!k)&&setTimeout)return k=setTimeout,setTimeout(y,0);try{return k(y,0)}catch{try{return k.call(null,y,0)}catch{return k.call(this,y,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:O}catch{k=O}try{U=typeof clearTimeout=="function"?clearTimeout:L}catch{U=L}})();var I,g=[],P=!1,b=-1;function v(){P&&I&&(P=!1,I.length?g=I.concat(g):b=-1,g.length&&c())}function c(){if(!P){var y=R(v);P=!0;for(var u=g.length;u;){for(I=g,g=[];++b<u;)I&&I[b].run();b=-1,u=g.length}I=null,P=!1,function(d){if(U===clearTimeout)return clearTimeout(d);if((U===L||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(d);try{U(d)}catch{try{return U.call(null,d)}catch{return U.call(this,d)}}}(y)}}function m(y,u){this.fun=y,this.array=u}function E(){}A.nextTick=function(y){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];g.push(new m(y,u)),g.length!==1||P||R(c)},m.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=E,A.addListener=E,A.once=E,A.off=E,A.removeListener=E,A.removeAllListeners=E,A.emit=E,A.prependListener=E,A.prependOnceListener=E,A.listeners=function(y){return[]},A.binding=function(y){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(y){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(oe[127],ae([0,1]),function(te,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class U{constructor(R,I,g){this.level=R,this.key=I,this.value=g,this.forward=[]}}const A=void 0;class O{constructor(R,I=2**16){this.comparator=R,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new U(this._maxLevel,A,A)}get size(){return this._size}clear(){this._header=new U(this._maxLevel,A,A),this._size=0}has(R){return!!O._search(this,R,this.comparator)}get(R){return O._search(this,R,this.comparator)?.value}set(R,I){return O._insert(this,R,I,this.comparator)&&(this._size+=1),this}delete(R){const I=O._delete(this,R,this.comparator);return I&&(this._size-=1),I}forEach(R,I){let g=this._header.forward[0];for(;g;)R.call(I,g.value,g.key,this),g=g.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",I=this._header.forward[0];for(;I;)R+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return R}static _search(R,I,g){let P=R._header;for(let b=R._level-1;b>=0;b--)for(;P.forward[b]&&g(P.forward[b].key,I)<0;)P=P.forward[b];if(P=P.forward[0],P&&g(P.key,I)===0)return P}static _insert(R,I,g,P){const b=[];let v=R._header;for(let c=R._level-1;c>=0;c--){for(;v.forward[c]&&P(v.forward[c].key,I)<0;)v=v.forward[c];b[c]=v}if(v=v.forward[0],v&&P(v.key,I)===0)return v.value=g,!1;{const c=O._randomLevel(R);if(c>R._level){for(let m=R._level;m<c;m++)b[m]=R._header;R._level=c}v=new U(c,I,g);for(let m=0;m<c;m++)v.forward[m]=b[m].forward[m],b[m].forward[m]=v;return!0}}static _randomLevel(R,I=.5){let g=1;for(;Math.random()<I&&g<R._maxLevel;)g+=1;return g}static _delete(R,I,g){const P=[];let b=R._header;for(let v=R._level-1;v>=0;v--){for(;b.forward[v]&&g(b.forward[v].key,I)<0;)b=b.forward[v];P[v]=b}if(b=b.forward[0],!b||g(b.key,I)!==0)return!1;for(let v=0;v<R._level&&P[v].forward[v]===b;v++)P[v].forward[v]=b.forward[v];for(;R._level>0&&R._header.forward[R._level-1]===A;)R._level-=1;return!0}}e.SkipList=O}),define(oe[61],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class U{static create(O){return new U(O)}constructor(O){this._now=k&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=U}),define(oe[3],ae([0,1,7,85,2,87,61]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,I=!1;var g;(function(p){p.None=()=>A.Disposable.None;function l(he){if(I){const{onDidAddListener:ue}=he,me=m.create();let fe=0;he.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),ue?.()}}}function S(he,ue){return Y(he,()=>{},0,void 0,!0,void 0,ue)}p.defer=S;function _(he){return(ue,me=null,fe)=>{let pe=!1,we;return we=he(Le=>{if(!pe)return we?we.dispose():pe=!0,ue.call(me,Le)},null,fe),pe&&we.dispose(),we}}p.once=_;function N(he,ue,me){return X((fe,pe=null,we)=>he(Le=>fe.call(pe,ue(Le)),null,we),me)}p.map=N;function $(he,ue,me){return X((fe,pe=null,we)=>he(Le=>{ue(Le),fe.call(pe,Le)},null,we),me)}p.forEach=$;function W(he,ue,me){return X((fe,pe=null,we)=>he(Le=>ue(Le)&&fe.call(pe,Le),null,we),me)}p.filter=W;function q(he){return he}p.signal=q;function Q(...he){return(ue,me=null,fe)=>{const pe=(0,A.combinedDisposable)(...he.map(we=>we(Le=>ue.call(me,Le))));return x(pe,fe)}}p.any=Q;function G(he,ue,me,fe){let pe=me;return N(he,we=>(pe=ue(pe,we),pe),fe)}p.reduce=G;function X(he,ue){let me;const fe={onWillAddFirstListener(){me=he(pe.fire,pe)},onDidRemoveLastListener(){me?.dispose()}};ue||l(fe);const pe=new h(fe);return ue?.add(pe),pe.event}function x(he,ue){return ue instanceof Array?ue.push(he):ue&&ue.add(he),he}function Y(he,ue,me=100,fe=!1,pe=!1,we,Le){let Ue,Me,le,ge=0,ve;const Ie={leakWarningThreshold:we,onWillAddFirstListener(){Ue=he($e=>{ge++,Me=ue(Me,$e),fe&&!le&&(De.fire(Me),Me=void 0),ve=()=>{const Te=Me;Me=void 0,le=void 0,(!fe||ge>1)&&De.fire(Te),ge=0},typeof me=="number"?(clearTimeout(le),le=setTimeout(ve,me)):le===void 0&&(le=0,queueMicrotask(ve))})},onWillRemoveListener(){pe&&ge>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,Ue.dispose()}};Le||l(Ie);const De=new h(Ie);return Le?.add(De),De.event}p.debounce=Y;function B(he,ue=0,me){return p.debounce(he,(fe,pe)=>fe?(fe.push(pe),fe):[pe],ue,void 0,!0,void 0,me)}p.accumulate=B;function z(he,ue=(fe,pe)=>fe===pe,me){let fe=!0,pe;return W(he,we=>{const Le=fe||!ue(we,pe);return fe=!1,pe=we,Le},me)}p.latch=z;function ee(he,ue,me){return[p.filter(he,ue,me),p.filter(he,fe=>!ue(fe),me)]}p.split=ee;function ie(he,ue=!1,me=[],fe){let pe=me.slice(),we=he(Me=>{pe?pe.push(Me):Ue.fire(Me)});fe&&fe.add(we);const Le=()=>{pe?.forEach(Me=>Ue.fire(Me)),pe=null},Ue=new h({onWillAddFirstListener(){we||(we=he(Me=>Ue.fire(Me)),fe&&fe.add(we))},onDidAddFirstListener(){pe&&(ue?setTimeout(Le):Le())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return fe&&fe.add(Ue),Ue.event}p.buffer=ie;function Z(he,ue){return(fe,pe,we)=>{const Le=ue(new K);return he(function(Ue){const Me=Le.evaluate(Ue);Me!==ne&&fe.call(pe,Me)},void 0,we)}}p.chain=Z;const ne=Symbol("HaltChainable");class K{constructor(){this.steps=[]}map(ue){return this.steps.push(ue),this}forEach(ue){return this.steps.push(me=>(ue(me),me)),this}filter(ue){return this.steps.push(me=>ue(me)?me:ne),this}reduce(ue,me){let fe=me;return this.steps.push(pe=>(fe=ue(fe,pe),fe)),this}latch(ue=(me,fe)=>me===fe){let me=!0,fe;return this.steps.push(pe=>{const we=me||!ue(pe,fe);return me=!1,fe=pe,we?pe:ne}),this}evaluate(ue){for(const me of this.steps)if(ue=me(ue),ue===ne)break;return ue}}function j(he,ue,me=fe=>fe){const fe=(...Ue)=>Le.fire(me(...Ue)),pe=()=>he.on(ue,fe),we=()=>he.removeListener(ue,fe),Le=new h({onWillAddFirstListener:pe,onDidRemoveLastListener:we});return Le.event}p.fromNodeEventEmitter=j;function D(he,ue,me=fe=>fe){const fe=(...Ue)=>Le.fire(me(...Ue)),pe=()=>he.addEventListener(ue,fe),we=()=>he.removeEventListener(ue,fe),Le=new h({onWillAddFirstListener:pe,onDidRemoveLastListener:we});return Le.event}p.fromDOMEventEmitter=D;function T(he){return new Promise(ue=>_(he)(ue))}p.toPromise=T;function M(he){const ue=new h;return he.then(me=>{ue.fire(me)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}p.fromPromise=M;function F(he,ue,me){return ue(me),he(fe=>ue(fe))}p.runAndSubscribe=F;function V(he,ue){let me=null;function fe(we){me?.dispose(),me=new A.DisposableStore,ue(we,me)}fe(void 0);const pe=he(we=>fe(we));return(0,A.toDisposable)(()=>{pe.dispose(),me?.dispose()})}p.runAndSubscribeWithStore=V;class H{constructor(ue,me){this._observable=ue,this._counter=0,this._hasChanged=!1;const fe={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};me||l(fe),this.emitter=new h(fe),me&&me.add(this.emitter)}beginUpdate(ue){this._counter++}handlePossibleChange(ue){}handleChange(ue,me){this._hasChanged=!0}endUpdate(ue){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function re(he,ue){return new H(he,ue).emitter.event}p.fromObservable=re;function ce(he){return ue=>{let me=0,fe=!1;const pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(he.reportChanges(),fe&&(fe=!1,ue()))},handlePossibleChange(){},handleChange(){fe=!0}};return he.addObserver(pe),he.reportChanges(),{dispose(){he.removeObserver(pe)}}}}p.fromObservableLight=ce})(g||(e.Event=g={}));class P{static{this.all=new Set}static{this._idPool=0}constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${P._idPool++}`,P.all.add(this)}start(l){this._stopWatch=new L.StopWatch,this.listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P;let b=-1;function v(p){const l=b;return b=p,{dispose(){b=l}}}e.setGlobalLeakWarningThreshold=v;class c{constructor(l,S=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=S,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(l,S){const _=this.threshold;if(_<=0||S<_)return;this._stacks||(this._stacks=new Map);const N=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,N+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let $,W=0;for(const[q,Q]of this._stacks)(!$||W<Q)&&($=q,W=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${W}):`),console.warn($)}return()=>{const $=this._stacks.get(l.value)||0;this._stacks.set(l.value,$-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class y{constructor(l){this.value=l,this.id=E++}}const u=2,d=(p,l)=>{if(p instanceof y)l(p);else for(let S=0;S<p.length;S++){const _=p[S];_&&l(_)}};class h{constructor(l){this._size=0,this._options=l,this._leakageMon=b>0||this._options?.leakWarningThreshold?new c(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(R){const l=this._listeners;queueMicrotask(()=>{d(l,S=>S.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(l,S,_)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;if(this._disposed)return A.Disposable.None;S&&(l=l.bind(S));const N=new y(l);let $,W;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(N.stack=m.create(),$=this._leakageMon.check(N.stack,this._size+1)),R&&(N.stack=W??m.create()),this._listeners?this._listeners instanceof y?(this._deliveryQueue??=new C,this._listeners=[this._listeners,N]):this._listeners.push(N):(this._options?.onWillAddFirstListener?.(this),this._listeners=N,this._options?.onDidAddFirstListener?.(this)),this._size++;const q=(0,A.toDisposable)(()=>{$?.(),this._removeListener(N)});return _ instanceof A.DisposableStore?_.add(q):Array.isArray(_)&&_.push(q),q},this._event}_removeListener(l){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const S=this._listeners,_=S.indexOf(l);if(_===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,S[_]=void 0;const N=this._deliveryQueue.current===this;if(this._size*u<=S.length){let $=0;for(let W=0;W<S.length;W++)S[W]?S[$++]=S[W]:N&&(this._deliveryQueue.end--,$<this._deliveryQueue.i&&this._deliveryQueue.i--);S.length=$}}_deliver(l,S){if(!l)return;const _=this._options?.onListenerError||k.onUnexpectedError;if(!_){l.value(S);return}try{l.value(S)}catch(N){_(N)}}_deliverQueue(l){const S=l.current._listeners;for(;l.i<l.end;)this._deliver(S[l.i++],l.value);l.reset()}fire(l){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof y)this._deliver(this._listeners,l);else{const S=this._deliveryQueue;S.enqueue(this,l,this._listeners.length),this._deliverQueue(S)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=h;const f=()=>new C;e.createEventDeliveryQueue=f;class C{constructor(){this.i=-1,this.end=0}enqueue(l,S,_){this.i=0,this.end=_,this.current=l,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends h{async fireAsync(l,S,_){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList),d(this._listeners,N=>this._asyncDeliveryQueue.push([N.value,l]));this._asyncDeliveryQueue.size>0&&!S.isCancellationRequested;){const[N,$]=this._asyncDeliveryQueue.shift(),W=[],q={...$,token:S,waitUntil:Q=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");_&&(Q=_(Q,N)),W.push(Q)}};try{N(q)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(W),await Promise.allSettled(W).then(Q=>{for(const G of Q)G.status==="rejected"&&(0,k.onUnexpectedError)(G.reason)})}}}e.AsyncEmitter=s;class o extends h{get isPaused(){return this._isPaused!==0}constructor(l){super(l),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._size&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=o;class n extends o{constructor(l){super(l),this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=n;class i extends h{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this.hasListeners()&&(this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(S=>super.fire(S)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const S={event:l,listener:null};this.events.push(S),this.hasListeners&&this.hook(S);const _=()=>{this.hasListeners&&this.unhook(S);const N=this.events.indexOf(S);this.events.splice(N,1)};return(0,A.toDisposable)((0,U.createSingleCallFunction)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(S=>this.emitter.fire(S))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class r{constructor(l,S,_,N){this._store=new A.DisposableStore;const $=this._store.add(new t),W=this._store.add(new A.DisposableMap);function q(Q){W.set(Q,$.add(N(Q)))}for(const Q of l)q(Q);this._store.add(S(Q=>{q(Q)})),this._store.add(_(Q=>{W.deleteAndDispose(Q)})),this.event=$.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(l){return(S,_,N)=>l($=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>S.call(_,$)):S.call(_,$)},void 0,N)}bufferEvents(l){const S=[];this.buffers.push(S);const _=l();return this.buffers.pop(),S.forEach(N=>N()),_}}e.EventBufferer=a;class w{constructor(){this.listening=!1,this.inputEvent=g.None,this.inputEventListener=A.Disposable.None,this.emitter=new h({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(oe[26],ae([0,1,3]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const U=Object.freeze(function(R,I){const g=setTimeout(R.bind(I),0);return{dispose(){clearTimeout(g)}}});var A;(function(R){function I(g){return g===R.None||g===R.Cancelled||g instanceof O?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=I,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(A||(e.CancellationToken=A={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?U:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=A.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=L}),define(oe[128],ae([0,1,26]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class U{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new k.CancellationTokenSource,I=this.task(R.token);return this.result={promise:I,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=U;class A{constructor(R){this.fn=R,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const I=JSON.stringify(R);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(R)),this.lastCache}}e.LRUCachedFunction=A;class O{get cachedValues(){return this._map}constructor(R){this.fn=R,this._map=new Map}get(R){if(this._map.has(R))return this._map.get(R);const I=this.fn(R);return this._map.set(R,I),I}}e.CachedFunction=O}),define(oe[46],ae([0,1,7,2]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function A(f){const C=f;return C?typeof C.read=="function":!1}e.isReadable=A;function O(f){const C=f;return C?[C.on,C.pause,C.resume,C.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=O;function L(f){const C=f;return C?O(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=L;function R(f,C){return new I(f,C)}e.newWriteableStream=R;class I{constructor(C,s){this.reducer=C,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(C){if(!this.state.destroyed){if(this.state.flowing)this.emitData(C);else if(this.buffer.data.push(C),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(C){this.state.destroyed||(this.state.flowing?this.emitError(C):this.buffer.error.push(C))}end(C){this.state.destroyed||(typeof C<"u"&&this.write(C),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(C){this.listeners.data.slice(0).forEach(s=>s(C))}emitError(C){this.listeners.error.length===0?(0,k.onUnexpectedError)(C):this.listeners.error.slice(0).forEach(s=>s(C))}emitEnd(){this.listeners.end.slice(0).forEach(C=>C())}on(C,s){if(!this.state.destroyed)switch(C){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(C,s){if(this.state.destroyed)return;let o;switch(C){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(s);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const C=this.reducer(this.buffer.data);this.emitData(C),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const C of this.buffer.error)this.emitError(C);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(f,C){const s=[];let o;for(;(o=f.read())!==null;)s.push(o);return C(s)}e.consumeReadable=g;function P(f,C,s){const o=[];let n;for(;(n=f.read())!==null&&o.length<s;)o.push(n);return n===null&&o.length>0?C(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return f.read()}}}e.peekReadable=P;function b(f,C){return new Promise((s,o)=>{const n=[];v(f,{onData:i=>{C&&n.push(i)},onError:i=>{C?o(i):s(void 0)},onEnd:()=>{s(C?C(n):void 0)}})})}e.consumeStream=b;function v(f,C,s){f.on("error",o=>{s?.isCancellationRequested||C.onError(o)}),f.on("end",()=>{s?.isCancellationRequested||C.onEnd()}),f.on("data",o=>{s?.isCancellationRequested||C.onData(o)})}e.listenStream=v;function c(f,C){return new Promise((s,o)=>{const n=new U.DisposableStore,i=[],t=w=>{if(i.push(w),i.length>C)return n.dispose(),f.pause(),s({stream:f,buffer:i,ended:!1})},r=w=>(n.dispose(),o(w)),a=()=>(n.dispose(),s({stream:f,buffer:i,ended:!0}));n.add((0,U.toDisposable)(()=>f.removeListener("error",r))),f.on("error",r),n.add((0,U.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),n.add((0,U.toDisposable)(()=>f.removeListener("data",t))),f.on("data",t)})}e.peekStream=c;function m(f,C){const s=R(C);return s.end(f),s}e.toStream=m;function E(){const f=R(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=E;function y(f){let C=!1;return{read:()=>C?null:(C=!0,f)}}e.toReadable=y;function u(f,C,s){const o=R(s);return v(f,{onData:n=>o.write(C.data(n)),onError:n=>o.error(C.error?C.error(n):n),onEnd:()=>o.end()}),o}e.transform=u;function d(f,C,s){let o=!1;return{read:()=>{const n=C.read();return o?n:(o=!0,n!==null?s([f,n]):f)}}}e.prefixedReadable=d;function h(f,C,s){let o=!1;const n=R(s);return v(C,{onData:i=>o?n.write(i):(o=!0,n.write(s([f,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(f)),n.end()}}),n}e.prefixedStream=h}),define(oe[15],ae([0,1,60,46]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const A=typeof Buffer<"u",O=new k.Lazy(()=>new Uint8Array(256));let L,R;class I{static alloc(S){return A?new I(Buffer.allocUnsafe(S)):new I(new Uint8Array(S))}static wrap(S){return A&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new I(S)}static fromString(S,_){return!(_?.dontUseNodeBuffer||!1)&&A?new I(Buffer.from(S)):(L||(L=new TextEncoder),new I(L.encode(S)))}static fromByteArray(S){const _=I.alloc(S.length);for(let N=0,$=S.length;N<$;N++)_.buffer[N]=S[N];return _}static concat(S,_){if(typeof _>"u"){_=0;for(let W=0,q=S.length;W<q;W++)_+=S[W].byteLength}const N=I.alloc(_);let $=0;for(let W=0,q=S.length;W<q;W++){const Q=S[W];N.set(Q,$),$+=Q.byteLength}return N}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=I.alloc(this.byteLength);return S.set(this),S}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(S,_){return new I(this.buffer.subarray(S,_))}set(S,_){if(S instanceof I)this.buffer.set(S.buffer,_);else if(S instanceof Uint8Array)this.buffer.set(S,_);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),_);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return v(this.buffer,S)}writeUInt32BE(S,_){c(this.buffer,S,_)}readUInt32LE(S){return m(this.buffer,S)}writeUInt32LE(S,_){E(this.buffer,S,_)}readUInt8(S){return y(this.buffer,S)}writeUInt8(S,_){u(this.buffer,S,_)}indexOf(S,_=0){return g(this.buffer,S instanceof I?S.buffer:S,_)}}e.VSBuffer=I;function g(l,S,_=0){const N=S.byteLength,$=l.byteLength;if(N===0)return 0;if(N===1)return l.indexOf(S[0]);if(N>$-_)return-1;const W=O.value;W.fill(S.length);for(let X=0;X<S.length;X++)W[S[X]]=S.length-X-1;let q=_+S.length-1,Q=q,G=-1;for(;q<$;)if(l[q]===S[Q]){if(Q===0){G=q;break}q--,Q--}else q+=Math.max(S.length-Q,W[l[q]]),Q=S.length-1;return G}e.binaryIndexOf=g;function P(l,S){return l[S+0]<<0>>>0|l[S+1]<<8>>>0}e.readUInt16LE=P;function b(l,S,_){l[_+0]=S&255,S=S>>>8,l[_+1]=S&255}e.writeUInt16LE=b;function v(l,S){return l[S]*2**24+l[S+1]*2**16+l[S+2]*2**8+l[S+3]}e.readUInt32BE=v;function c(l,S,_){l[_+3]=S,S=S>>>8,l[_+2]=S,S=S>>>8,l[_+1]=S,S=S>>>8,l[_]=S}e.writeUInt32BE=c;function m(l,S){return l[S+0]<<0>>>0|l[S+1]<<8>>>0|l[S+2]<<16>>>0|l[S+3]<<24>>>0}e.readUInt32LE=m;function E(l,S,_){l[_+0]=S&255,S=S>>>8,l[_+1]=S&255,S=S>>>8,l[_+2]=S&255,S=S>>>8,l[_+3]=S&255}e.writeUInt32LE=E;function y(l,S){return l[S]}e.readUInt8=y;function u(l,S,_){l[_]=S}e.writeUInt8=u;function d(l){return U.consumeReadable(l,S=>I.concat(S))}e.readableToBuffer=d;function h(l){return U.toReadable(l)}e.bufferToReadable=h;function f(l){return U.consumeStream(l,S=>I.concat(S))}e.streamToBuffer=f;async function C(l){return l.ended?I.concat(l.buffer):I.concat([...l.buffer,await f(l.stream)])}e.bufferedStreamToBuffer=C;function s(l){return U.toStream(l,S=>I.concat(S))}e.bufferToStream=s;function o(l){return U.transform(l,{data:S=>typeof S=="string"?I.fromString(S):I.wrap(S)},S=>I.concat(S))}e.streamToBufferReadableStream=o;function n(l){return U.newWriteableStream(S=>I.concat(S),l)}e.newWriteableBufferStream=n;function i(l,S){return U.prefixedReadable(l,S,_=>I.concat(_))}e.prefixedBufferReadable=i;function t(l,S){return U.prefixedStream(l,S,_=>I.concat(_))}e.prefixedBufferStream=t;function r(l){let S=0,_=0,N=0;const $=new Uint8Array(Math.floor(l.length/4*3)),W=Q=>{switch(_){case 3:$[N++]=S|Q,_=0;break;case 2:$[N++]=S|Q>>>2,S=Q<<6,_=3;break;case 1:$[N++]=S|Q>>>4,S=Q<<4,_=2;break;default:S=Q<<2,_=1}};for(let Q=0;Q<l.length;Q++){const G=l.charCodeAt(Q);if(G>=65&&G<=90)W(G-65);else if(G>=97&&G<=122)W(G-97+26);else if(G>=48&&G<=57)W(G-48+52);else if(G===43||G===45)W(62);else if(G===47||G===95)W(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${l[Q]}`)}}const q=N;for(;_>0;)W(0);return I.wrap($).slice(0,q)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:l},S=!0,_=!1){const N=_?w:a;let $="";const W=l.byteLength%3;let q=0;for(;q<l.byteLength-W;q+=3){const Q=l[q+0],G=l[q+1],X=l[q+2];$+=N[Q>>>2],$+=N[(Q<<4|G>>>4)&63],$+=N[(G<<2|X>>>6)&63],$+=N[X&63]}if(W===1){const Q=l[q+0];$+=N[Q>>>2],$+=N[Q<<4&63],S&&($+="==")}else if(W===2){const Q=l[q+0],G=l[q+1];$+=N[Q>>>2],$+=N[(Q<<4|G>>>4)&63],$+=N[G<<2&63],S&&($+="=")}return $}e.encodeBase64=p}),define(oe[27],ae([0,1,128,60]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.isFalsyOrWhitespace=A;const O=/{(\d+)}/g;function L(se,...de){return de.length===0?se:se.replace(O,function(Se,Ee){const be=parseInt(Ee,10);return isNaN(be)||be<0||be>=de.length?Se:de[be]})}e.format=L;const R=/{([^}]+)}/g;function I(se,de){return Object.keys(de).length===0?se:se.replace(R,(Se,Ee)=>de[Ee]??Se)}e.format2=I;function g(se){return se.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.escape=g;function P(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function b(se,de){let Se=0;const Ee=de.charCodeAt(0);for(let be=se.length-1;be>=0;be--)se.charCodeAt(be)===Ee&&Se++;return Se}e.count=b;function v(se,de,Se="\u2026"){return se.length<=de?se:`${se.substr(0,de)}${Se}`}e.truncate=v;function c(se,de=" "){const Se=m(se,de);return E(Se,de)}e.trim=c;function m(se,de){if(!se||!de)return se;const Se=de.length;if(Se===0||se.length===0)return se;let Ee=0;for(;se.indexOf(de,Ee)===Ee;)Ee=Ee+Se;return se.substring(Ee)}e.ltrim=m;function E(se,de){if(!se||!de)return se;const Se=de.length,Ee=se.length;if(Se===0||Ee===0)return se;let be=Ee,Re=-1;for(;Re=se.lastIndexOf(de,be-1),!(Re===-1||Re+Se!==be);){if(Re===0)return"";be=Re}return se.substring(0,be)}e.rtrim=E;function y(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function u(se){return se.replace(/\*/g,"")}e.stripWildcards=u;function d(se,de,Se={}){if(!se)throw new Error("Cannot create regex from empty string");de||(se=P(se)),Se.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let Ee="";return Se.global&&(Ee+="g"),Se.matchCase||(Ee+="i"),Se.multiline&&(Ee+="m"),Se.unicode&&(Ee+="u"),new RegExp(se,Ee)}e.createRegExp=d;function h(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function f(se){return se.split(/\r\n|\r|\n/)}e.splitLines=f;function C(se){for(let de=0,Se=se.length;de<Se;de++){const Ee=se.charCodeAt(de);if(Ee!==32&&Ee!==9)return de}return-1}e.firstNonWhitespaceIndex=C;function s(se,de=0,Se=se.length){for(let Ee=de;Ee<Se;Ee++){const be=se.charCodeAt(Ee);if(be!==32&&be!==9)return se.substring(de,Ee)}return se.substring(de,Se)}e.getLeadingWhitespace=s;function o(se,de=se.length-1){for(let Se=de;Se>=0;Se--){const Ee=se.charCodeAt(Se);if(Ee!==32&&Ee!==9)return Se}return-1}e.lastNonWhitespaceIndex=o;function n(se,de,Se){const Ee=[];let be=0;for(const Re of se.matchAll(de)){if(Ee.push(se.slice(be,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");be=Re.index+Re[0].length,Ee.push(Se(Re[0],...Re.slice(1),Re.index,se,Re.groups))}return Ee.push(se.slice(be)),Promise.all(Ee).then(Re=>Re.join(""))}e.replaceAsync=n;function i(se,de){return se<de?-1:se>de?1:0}e.compare=i;function t(se,de,Se=0,Ee=se.length,be=0,Re=de.length){for(;Se<Ee&&be<Re;Se++,be++){const _e=se.charCodeAt(Se),Oe=de.charCodeAt(be);if(_e<Oe)return-1;if(_e>Oe)return 1}const Pe=Ee-Se,ke=Re-be;return Pe<ke?-1:Pe>ke?1:0}e.compareSubstring=t;function r(se,de){return a(se,de,0,se.length,0,de.length)}e.compareIgnoreCase=r;function a(se,de,Se=0,Ee=se.length,be=0,Re=de.length){for(;Se<Ee&&be<Re;Se++,be++){let _e=se.charCodeAt(Se),Oe=de.charCodeAt(be);if(_e===Oe)continue;if(_e>=128||Oe>=128)return t(se.toLowerCase(),de.toLowerCase(),Se,Ee,be,Re);p(_e)&&(_e-=32),p(Oe)&&(Oe-=32);const Ne=_e-Oe;if(Ne!==0)return Ne}const Pe=Ee-Se,ke=Re-be;return Pe<ke?-1:Pe>ke?1:0}e.compareSubstringIgnoreCase=a;function w(se){return se>=48&&se<=57}e.isAsciiDigit=w;function p(se){return se>=97&&se<=122}e.isLowerAsciiLetter=p;function l(se){return se>=65&&se<=90}e.isUpperAsciiLetter=l;function S(se,de){return se.length===de.length&&a(se,de)===0}e.equalsIgnoreCase=S;function _(se,de){const Se=de.length;return de.length>se.length?!1:a(se,de,0,Se)===0}e.startsWithIgnoreCase=_;function N(se,de){const Se=Math.min(se.length,de.length);let Ee;for(Ee=0;Ee<Se;Ee++)if(se.charCodeAt(Ee)!==de.charCodeAt(Ee))return Ee;return Se}e.commonPrefixLength=N;function $(se,de){const Se=Math.min(se.length,de.length);let Ee;const be=se.length-1,Re=de.length-1;for(Ee=0;Ee<Se;Ee++)if(se.charCodeAt(be-Ee)!==de.charCodeAt(Re-Ee))return Ee;return Se}e.commonSuffixLength=$;function W(se){return 55296<=se&&se<=56319}e.isHighSurrogate=W;function q(se){return 56320<=se&&se<=57343}e.isLowSurrogate=q;function Q(se,de){return(se-55296<<10)+(de-56320)+65536}e.computeCodePoint=Q;function G(se,de,Se){const Ee=se.charCodeAt(Se);if(W(Ee)&&Se+1<de){const be=se.charCodeAt(Se+1);if(q(be))return Q(Ee,be)}return Ee}e.getNextCodePoint=G;function X(se,de){const Se=se.charCodeAt(de-1);if(q(Se)&&de>1){const Ee=se.charCodeAt(de-2);if(W(Ee))return Q(Ee,Se)}return Se}class x{get offset(){return this._offset}constructor(de,Se=0){this._str=de,this._len=de.length,this._offset=Se}setOffset(de){this._offset=de}prevCodePoint(){const de=X(this._str,this._offset);return this._offset-=de>=65536?2:1,de}nextCodePoint(){const de=G(this._str,this._len,this._offset);return this._offset+=de>=65536?2:1,de}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class Y{get offset(){return this._iterator.offset}constructor(de,Se=0){this._iterator=new x(de,Se)}nextGraphemeLength(){const de=ge.getInstance(),Se=this._iterator,Ee=Se.offset;let be=de.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Re=Se.offset,Pe=de.getGraphemeBreakType(Se.nextCodePoint());if(Me(be,Pe)){Se.setOffset(Re);break}be=Pe}return Se.offset-Ee}prevGraphemeLength(){const de=ge.getInstance(),Se=this._iterator,Ee=Se.offset;let be=de.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Re=Se.offset,Pe=de.getGraphemeBreakType(Se.prevCodePoint());if(Me(Pe,be)){Se.setOffset(Re);break}be=Pe}return Ee-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function B(se,de){return new Y(se,de).nextGraphemeLength()}e.nextCharLength=B;function z(se,de){return new Y(se,de).prevGraphemeLength()}e.prevCharLength=z;function ee(se,de){de>0&&q(se.charCodeAt(de))&&de--;const Se=de+B(se,de);return[Se-z(se,Se),Se]}e.getCharContainingOffset=ee;function ie(se){const de=new Y(se);let Se=0;for(;!de.eol();)Se++,de.nextGraphemeLength();return Se}e.charCount=ie;let Z;function ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(se){return Z||(Z=ne()),Z.test(se)}e.containsRTL=K;const j=/^[\t\n\r\x20-\x7E]*$/;function D(se){return j.test(se)}e.isBasicASCII=D,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function T(se){return e.UNUSUAL_LINE_TERMINATORS.test(se)}e.containsUnusualLineTerminators=T;function M(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.isFullWidthCharacter=M;function F(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.isEmojiImprecise=F;function V(se,de){if(se.length<de)return se;const Se=/\b/g;let Ee=0;for(;Se.test(se)&&!(se.length-Se.lastIndex<de);)Ee=Se.lastIndex,Se.lastIndex+=1;return se.substring(Ee).replace(/^\s/,"")}e.lcut=V;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function ce(se){return se&&(se=se.replace(H,"").replace(re,"")),se}e.removeAnsiEscapeCodes=ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function ue(se){return he(se)?se.substr(1):se}e.stripUTF8BOM=ue;function me(se,de){if(!se||!de||se.length<de.length)return!1;const Se=de.length,Ee=se.toLowerCase();let be=0,Re=-1;for(;be<Se;){const Pe=Ee.indexOf(de[be],Re+1);if(Pe<0)return!1;Re=Pe,be++}return!0}e.fuzzyContains=me;function fe(se,de=!1){return se?(de&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.containsUppercaseCharacter=fe;function pe(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.uppercaseFirstLetter=pe;function we(se,de=1){if(de===0)return"";let Se=-1;do Se=se.indexOf(`
`,Se+1),de--;while(de>0&&Se>=0);return Se===-1?se:(se[Se-1]==="\r"&&Se--,se.substr(0,Se))}e.getNLines=we;function Le(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.singleLetterHash=Le;function Ue(se){return ge.getInstance().getGraphemeBreakType(se)}e.getGraphemeBreakType=Ue;function Me(se,de){return se===0?de!==5&&de!==7:se===2&&de===3?!1:se===4||se===2||se===3||de===4||de===2||de===3?!0:!(se===8&&(de===8||de===9||de===11||de===12)||(se===11||se===9)&&(de===9||de===10)||(se===12||se===10)&&de===10||de===5||de===13||de===7||se===1||se===13&&de===14||se===6&&de===6)}var le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class ge{static{this._INSTANCE=null}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}constructor(){this._data=ve()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const Se=this._data,Ee=Se.length/3;let be=1;for(;be<=Ee;)if(de<Se[3*be])be=2*be;else if(de>Se[3*be+1])be=2*be+1;else return Se[3*be+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(se,de){if(se===0)return 0;const Se=De(se,de);if(Se!==void 0)return Se;const Ee=new x(de,se);return Ee.prevCodePoint(),Ee.offset}e.getLeftDeleteOffset=Ie;function De(se,de){const Se=new x(de,se);let Ee=Se.prevCodePoint();for(;$e(Ee)||Ee===65039||Ee===8419;){if(Se.offset===0)return;Ee=Se.prevCodePoint()}if(!F(Ee))return;let be=Se.offset;return be>0&&Se.prevCodePoint()===8205&&(be=Se.offset),be}function $e(se){return 127995<=se&&se<=127999}var Te;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class We{static{this.ambiguousCharacterData=new U.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new k.LRUCachedFunction(de=>{function Se(Ne){const qe=new Map;for(let je=0;je<Ne.length;je+=2)qe.set(Ne[je],Ne[je+1]);return qe}function Ee(Ne,qe){const je=new Map(Ne);for(const[xe,Ze]of qe)je.set(xe,Ze);return je}function be(Ne,qe){if(!Ne)return qe;const je=new Map;for(const[xe,Ze]of Ne)qe.has(xe)&&je.set(xe,Ze);return je}const Re=this.ambiguousCharacterData.value;let Pe=de.filter(Ne=>!Ne.startsWith("_")&&Ne in Re);Pe.length===0&&(Pe=["_default"]);let ke;for(const Ne of Pe){const qe=Se(Re[Ne]);ke=be(ke,qe)}const _e=Se(Re._common),Oe=Ee(_e,ke);return new We(Oe)})}static getInstance(de){return We.cache.get(Array.from(de))}static{this._locales=new U.Lazy(()=>Object.keys(We.ambiguousCharacterData.value).filter(de=>!de.startsWith("_")))}static getLocales(){return We._locales.value}constructor(de){this.confusableDictionary=de}isAmbiguous(de){return this.confusableDictionary.has(de)}getPrimaryConfusable(de){return this.confusableDictionary.get(de)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=We;class Fe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Fe.getRawData())),this._data}static isInvisibleCharacter(de){return Fe.getData().has(de)}static get codePoints(){return Fe.getData()}}e.InvisibleCharacters=Fe}),define(oe[52],ae([0,1,27]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function U(u){return A(u,0)}e.hash=U;function A(u,d){switch(typeof u){case"object":return u===null?O(349,d):Array.isArray(u)?I(u,d):g(u,d);case"string":return R(u,d);case"boolean":return L(u,d);case"number":return O(u,d);case"undefined":return O(937,d);default:return O(617,d)}}e.doHash=A;function O(u,d){return(d<<5)-d+u|0}e.numberHash=O;function L(u,d){return O(u?433:863,d)}function R(u,d){d=O(149417,d);for(let h=0,f=u.length;h<f;h++)d=O(u.charCodeAt(h),d);return d}e.stringHash=R;function I(u,d){return d=O(104579,d),u.reduce((h,f)=>A(f,h),d)}function g(u,d){return d=O(181387,d),Object.keys(u).sort().reduce((h,f)=>(h=R(f,h),A(u[f],h)),d)}class P{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=A(d,this._value),this._value}}e.Hasher=P;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function v(u,d,h=32){const f=h-d,C=~((1<<f)-1);return(u<<d|(C&u)>>>f)>>>0}function c(u,d=0,h=u.byteLength,f=0){for(let C=0;C<h;C++)u[d+C]=f}function m(u,d,h="0"){for(;u.length<d;)u=h+u;return u}function E(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(h=>h.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),d/4)}e.toHexString=E;class y{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const h=d.length;if(h===0)return;const f=this._buff;let C=this._buffLen,s=this._leftoverHighSurrogate,o,n;for(s!==0?(o=s,n=-1,s=0):(o=d.charCodeAt(0),n=0);;){let i=o;if(k.isHighSurrogate(o))if(n+1<h){const t=d.charCodeAt(n+1);k.isLowSurrogate(t)?(n++,i=k.computeCodePoint(o,t)):i=65533}else{s=o;break}else k.isLowSurrogate(o)&&(i=65533);if(C=this._push(f,C,i),n++,n<h)o=d.charCodeAt(n);else break}this._buffLen=C,this._leftoverHighSurrogate=s}_push(d,h,f){return f<128?d[h++]=f:f<2048?(d[h++]=192|(f&1984)>>>6,d[h++]=128|(f&63)>>>0):f<65536?(d[h++]=224|(f&61440)>>>12,d[h++]=128|(f&4032)>>>6,d[h++]=128|(f&63)>>>0):(d[h++]=240|(f&1835008)>>>18,d[h++]=128|(f&258048)>>>12,d[h++]=128|(f&4032)>>>6,d[h++]=128|(f&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=y._bigBlock32,h=this._buffDV;for(let a=0;a<64;a+=4)d.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,v(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let f=this._h0,C=this._h1,s=this._h2,o=this._h3,n=this._h4,i,t,r;for(let a=0;a<80;a++)a<20?(i=C&s|~C&o,t=1518500249):a<40?(i=C^s^o,t=1859775393):a<60?(i=C&s|C&o|s&o,t=2400959708):(i=C^s^o,t=3395469782),r=v(f,5)+i+n+t+d.getUint32(a*4,!1)&4294967295,n=o,o=s,s=v(C,30),C=f,f=r;this._h0=this._h0+f&4294967295,this._h1=this._h1+C&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y}),define(oe[89],ae([0,1,27]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var U;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(U||(U={})),function(A){const O="error",L="warning",R="warn",I="info",g="ignore";function P(v){return v?k.equalsIgnoreCase(O,v)?A.Error:k.equalsIgnoreCase(L,v)||k.equalsIgnoreCase(R,v)?A.Warning:k.equalsIgnoreCase(I,v)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function b(v){switch(v){case A.Error:return O;case A.Warning:return L;case A.Info:return I;default:return g}}A.toString=b}(U||(U={})),e.default=U}),define(oe[129],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class A{constructor(){this._value="",this._pos=0}reset(c){return this._value=c,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(c){const m=c.charCodeAt(0),E=this._value.charCodeAt(this._pos);return m-E}value(){return this._value[this._pos]}}e.StringIterator=A;class O{constructor(c=!0){this._caseSensitive=c}reset(c){return this._value=c,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let c=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(c)this._from++;else break;else c=!1;return this}cmp(c){return this._caseSensitive?(0,U.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class L{constructor(c=!0,m=!0){this._splitOnBackslash=c,this._caseSensitive=m}reset(c){this._from=0,this._to=0,this._value=c,this._valueLen=c.length;for(let m=c.length-1;m>=0;m--,this._valueLen--){const E=this._value.charCodeAt(m);if(!(E===47||this._splitOnBackslash&&E===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let c=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(c)this._from++;else break;else c=!1}return this}cmp(c){return this._caseSensitive?(0,U.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=L;var R;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(R||(R={}));class I{constructor(c,m){this._ignorePathCasing=c,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(c){return this._value=c,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new L(!1,!this._ignorePathCasing(c)),this._pathIterator.reset(c.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(c)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(c){if(this._states[this._stateIdx]===1)return(0,U.compareIgnoreCase)(c,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,U.compareIgnoreCase)(c,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(c);if(this._states[this._stateIdx]===4)return(0,U.compare)(c,this._value.query);if(this._states[this._stateIdx]===5)return(0,U.compare)(c,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(P||(P={}));class b{static forUris(c=()=>!1,m=()=>!1){return new b(new I(c,m))}static forPaths(c=!1){return new b(new L(void 0,!c))}static forStrings(){return new b(new A)}static forConfigKeys(){return new b(new O)}constructor(c){this._iter=c}clear(){this._root=void 0}fill(c,m){if(m){const E=m.slice(0);(0,k.shuffle)(E);for(const y of E)this.set(y,c)}else{const E=c.slice(0);(0,k.shuffle)(E);for(const y of E)this.set(y[0],y[1])}}set(c,m){const E=this._iter.reset(c);let y;this._root||(this._root=new g,this._root.segment=E.value());const u=[];for(y=this._root;;){const h=E.cmp(y.segment);if(h>0)y.left||(y.left=new g,y.left.segment=E.value()),u.push([-1,y]),y=y.left;else if(h<0)y.right||(y.right=new g,y.right.segment=E.value()),u.push([1,y]),y=y.right;else if(E.hasNext())E.next(),y.mid||(y.mid=new g,y.mid.segment=E.value()),u.push([0,y]),y=y.mid;else break}const d=y.value;y.value=m,y.key=c;for(let h=u.length-1;h>=0;h--){const f=u[h][1];f.updateHeight();const C=f.balanceFactor();if(C<-1||C>1){const s=u[h][0],o=u[h+1][0];if(s===1&&o===1)u[h][1]=f.rotateLeft();else if(s===-1&&o===-1)u[h][1]=f.rotateRight();else if(s===1&&o===-1)f.right=u[h+1][1]=u[h+1][1].rotateRight(),u[h][1]=f.rotateLeft();else if(s===-1&&o===1)f.left=u[h+1][1]=u[h+1][1].rotateLeft(),u[h][1]=f.rotateRight();else throw new Error;if(h>0)switch(u[h-1][0]){case-1:u[h-1][1].left=u[h][1];break;case 1:u[h-1][1].right=u[h][1];break;case 0:u[h-1][1].mid=u[h][1];break}else this._root=u[0][1]}}return d}get(c){return this._getNode(c)?.value}_getNode(c){const m=this._iter.reset(c);let E=this._root;for(;E;){const y=m.cmp(E.segment);if(y>0)E=E.left;else if(y<0)E=E.right;else if(m.hasNext())m.next(),E=E.mid;else break}return E}has(c){const m=this._getNode(c);return!(m?.value===void 0&&m?.mid===void 0)}delete(c){return this._delete(c,!1)}deleteSuperstr(c){return this._delete(c,!0)}_delete(c,m){const E=this._iter.reset(c),y=[];let u=this._root;for(;u;){const d=E.cmp(u.segment);if(d>0)y.push([-1,u]),u=u.left;else if(d<0)y.push([1,u]),u=u.right;else if(E.hasNext())E.next(),y.push([0,u]),u=u.mid;else break}if(u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this._min(u.right);if(d.key){const{key:h,value:f,segment:C}=d;this._delete(d.key,!1),u.key=h,u.value=f,u.segment=C}}else{const d=u.left??u.right;if(y.length>0){const[h,f]=y[y.length-1];switch(h){case-1:f.left=d;break;case 0:f.mid=d;break;case 1:f.right=d;break}}else this._root=d}for(let d=y.length-1;d>=0;d--){const h=y[d][1];h.updateHeight();const f=h.balanceFactor();if(f>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),y[d][1]=h.rotateLeft()):f<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),y[d][1]=h.rotateRight()),d>0)switch(y[d-1][0]){case-1:y[d-1][1].left=y[d][1];break;case 1:y[d-1][1].right=y[d][1];break;case 0:y[d-1][1].mid=y[d][1];break}else this._root=y[0][1]}}}_min(c){for(;c.left;)c=c.left;return c}findSubstr(c){const m=this._iter.reset(c);let E=this._root,y;for(;E;){const u=m.cmp(E.segment);if(u>0)E=E.left;else if(u<0)E=E.right;else if(m.hasNext())m.next(),y=E.value||y,E=E.mid;else break}return E&&E.value||y}findSuperstr(c){return this._findSuperstrOrElement(c,!1)}_findSuperstrOrElement(c,m){const E=this._iter.reset(c);let y=this._root;for(;y;){const u=E.cmp(y.segment);if(u>0)y=y.left;else if(u<0)y=y.right;else if(E.hasNext())E.next(),y=y.mid;else return y.mid?this._entries(y.mid):m?y.value:void 0}}hasElementOrSubtree(c){return this._findSuperstrOrElement(c,!0)!==void 0}forEach(c){for(const[m,E]of this)c(E,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(c){const m=[];return this._dfsEntries(c,m),m[Symbol.iterator]()}_dfsEntries(c,m){c&&(c.left&&this._dfsEntries(c.left,m),c.value&&m.push([c.key,c.value]),c.mid&&this._dfsEntries(c.mid,m),c.right&&this._dfsEntries(c.right,m))}_isBalanced(){const c=m=>{if(!m)return!0;const E=m.balanceFactor();return E<-1||E>1?!1:c(m.left)&&c(m.right)};return c(this._root)}}e.TernarySearchTree=b}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(C){return typeof C=="string"}e.isString=k;function U(C){return Array.isArray(C)&&C.every(s=>k(s))}e.isStringArray=U;function A(C){return typeof C=="object"&&C!==null&&!Array.isArray(C)&&!(C instanceof RegExp)&&!(C instanceof Date)}e.isObject=A;function O(C){const s=Object.getPrototypeOf(Uint8Array);return typeof C=="object"&&C instanceof s}e.isTypedArray=O;function L(C){return typeof C=="number"&&!isNaN(C)}e.isNumber=L;function R(C){return!!C&&typeof C[Symbol.iterator]=="function"}e.isIterable=R;function I(C){return C===!0||C===!1}e.isBoolean=I;function g(C){return typeof C>"u"}e.isUndefined=g;function P(C){return!b(C)}e.isDefined=P;function b(C){return g(C)||C===null}e.isUndefinedOrNull=b;function v(C,s){if(!C)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=v;function c(C){if(b(C))throw new Error("Assertion Failed: argument is undefined or null");return C}e.assertIsDefined=c;function m(...C){const s=[];for(let o=0;o<C.length;o++){const n=C[o];if(b(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);s.push(n)}return s}e.assertAllDefined=m;const E=Object.prototype.hasOwnProperty;function y(C){if(!A(C))return!1;for(const s in C)if(E.call(C,s))return!1;return!0}e.isEmptyObject=y;function u(C){return typeof C=="function"}e.isFunction=u;function d(...C){return C.length>0&&C.every(u)}e.areFunctions=d;function h(C,s){const o=Math.min(C.length,s.length);for(let n=0;n<o;n++)f(C[n],s[n])}e.validateConstraints=h;function f(C,s){if(k(s)){if(typeof C!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(u(s)){try{if(C instanceof s)return}catch{}if(!b(C)&&C.constructor===s||s.length===1&&s.call(void 0,C)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f}),define(oe[30],ae([0,1,12]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ensureOptionalStringValue=e.ensureOptionalNumberValue=e.ensureOptionalBooleanValue=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function U(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const C=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([s,o])=>{C[s]=o&&typeof o=="object"?U(o):o}),C}e.deepClone=U;function A(f){if(!f||typeof f!="object")return f;const C=[f];for(;C.length>0;){const s=C.shift();Object.freeze(s);for(const o in s)if(O.call(s,o)){const n=s[o];typeof n=="object"&&!Object.isFrozen(n)&&!(0,k.isTypedArray)(n)&&C.push(n)}}return f}e.deepFreeze=A;const O=Object.prototype.hasOwnProperty;function L(f,C){return R(f,C,new Set)}e.cloneAndChange=L;function R(f,C,s){if((0,k.isUndefinedOrNull)(f))return f;const o=C(f);if(typeof o<"u")return o;if(Array.isArray(f)){const n=[];for(const i of f)n.push(R(i,C,s));return n}if((0,k.isObject)(f)){if(s.has(f))throw new Error("Cannot clone recursive data-structure");s.add(f);const n={};for(const i in f)O.call(f,i)&&(n[i]=R(f[i],C,s));return s.delete(f),n}return f}function I(f,C,s=!0){return(0,k.isObject)(f)?((0,k.isObject)(C)&&Object.keys(C).forEach(o=>{o in f?s&&((0,k.isObject)(f[o])&&(0,k.isObject)(C[o])?I(f[o],C[o],s):f[o]=C[o]):f[o]=C[o]}),f):C}e.mixin=I;function g(f,C){if(f===C)return!0;if(f==null||C===null||C===void 0||typeof f!=typeof C||typeof f!="object"||Array.isArray(f)!==Array.isArray(C))return!1;let s,o;if(Array.isArray(f)){if(f.length!==C.length)return!1;for(s=0;s<f.length;s++)if(!g(f[s],C[s]))return!1}else{const n=[];for(o in f)n.push(o);n.sort();const i=[];for(o in C)i.push(o);if(i.sort(),!g(n,i))return!1;for(s=0;s<n.length;s++)if(!g(f[n[s]],C[n[s]]))return!1}return!0}e.equals=g;function P(f){const C=new Set;return JSON.stringify(f,(s,o)=>{if((0,k.isObject)(o)||Array.isArray(o)){if(C.has(o))return"[Circular]";C.add(o)}return o})}e.safeStringify=P;function b(f,C){const s=Object.create(null);return!f||!C||Object.keys(C).forEach(n=>{const i=f[n],t=C[n];g(i,t)||(s[n]=t)}),s}e.distinct=b;function v(f,C){const s=C.toLowerCase(),o=Object.keys(f).find(n=>n.toLowerCase()===s);return o?f[o]:f[C]}e.getCaseInsensitive=v;function c(f,C){const s=Object.create(null);for(const[o,n]of Object.entries(f))C(o,n)&&(s[o]=n);return s}e.filter=c;function m(f){let C=[];for(;Object.prototype!==f;)C=C.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return C}e.getAllPropertyNames=m;function E(f){const C=[];for(const s of m(f))typeof f[s]=="function"&&C.push(s);return C}e.getAllMethodNames=E;function y(f,C){const s=n=>function(){const i=Array.prototype.slice.call(arguments,0);return C(n,i)},o={};for(const n of f)o[n]=s(n);return o}e.createProxyObject=y;function u(f,C,s){typeof C=="string"&&f[C]!==void 0&&typeof f[C]!="boolean"&&(f[C]=s)}e.ensureOptionalBooleanValue=u;function d(f,C,s){typeof C=="string"&&f[C]!==void 0&&typeof f[C]!="number"&&(f[C]=s)}e.ensureOptionalNumberValue=d;function h(f,C,s,o){if(typeof C!="string")return;const n=f[C];n!==void 0&&(typeof n!="string"||!s.includes(n))&&(f[C]=o)}e.ensureOptionalStringValue=h}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(A){return k.test(A)}e.isUUID=U,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(R){for(let I=0;I<R.length;I++)R[I]=Math.floor(Math.random()*256);return R};const O=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){A(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let I=0,g="";return g+=L[O[I++]],g+=L[O[I++]],g+=L[O[I++]],g+=L[O[I++]],g+="-",g+=L[O[I++]],g+=L[O[I++]],g+="-",g+=L[O[I++]],g+=L[O[I++]],g+="-",g+=L[O[I++]],g+=L[O[I++]],g+="-",g+=L[O[I++]],g+=L[O[I++]],g+=L[O[I++]],g+=L[O[I++]],g+=L[O[I++]],g+=L[O[I++]],g}}()}),define(oe[130],ae([0,1,36]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(L){const R=L.replace(/\-/g,":").toLowerCase();return!U.has(R)}function O(){const L=(0,k.networkInterfaces)();for(const R in L){const I=L[R];if(I){for(const{mac:g}of I)if(A(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(oe[131],ae([0,1,266,15]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class A extends k.Transform{constructor(L){if(super(),typeof L=="number")this.splitter=L,this.spitterLen=1;else{const R=Buffer.isBuffer(L)?L:Buffer.from(L);this.splitter=R.length===1?R[0]:R,this.spitterLen=R.length}}_transform(L,R,I){this.buffer?this.buffer=Buffer.concat([this.buffer,L]):this.buffer=L;let g=0;for(;g<this.buffer.length;){const P=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,g):(0,U.binaryIndexOf)(this.buffer,this.splitter,g);if(P===-1)break;this.push(this.buffer.slice(g,P+this.spitterLen)),g=P+this.spitterLen}this.buffer=g===this.buffer.length?void 0:this.buffer.slice(g),I()}_flush(L){this.buffer&&this.push(this.buffer),L()}}e.StreamSplitter=A}),define(oe[132],ae([0,1,62]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function U(R,I,g,P=1){let b=!1;return new Promise(v=>{const c=setTimeout(()=>{if(!b)return b=!0,v(0)},g);A(R,I,P,m=>{if(!b)return b=!0,clearTimeout(c),v(m)})})}e.findFreePort=U;function A(R,I,g,P){if(I===0)return P(0);const b=new k.Socket;b.once("connect",()=>(L(b),A(R+g,I-1,g,P))),b.once("data",()=>{}),b.once("error",v=>(L(b),v.code!=="ECONNREFUSED"?A(R+g,I-1,g,P):P(R))),b.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(R,I,g,P="127.0.0.1"){let b=!1,v,c=1;const m=k.createServer({pauseOnConnect:!0});function E(y,u){b||(b=!0,m.removeAllListeners(),m.close(),v&&clearTimeout(v),u(y))}return new Promise(y=>{v=setTimeout(()=>{E(0,y)},g),m.on("listening",()=>{E(R,y)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&c<I?(R++,c++,m.listen(R,P)):E(0,y)}),m.on("close",()=>{E(0,y)}),m.listen(R,P)})}e.findFreePortFaster=O;function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(I){console.error(I)}}}),define(oe[133],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function k(U){return!!U.parentPort}e.isUtilityProcess=k}),define(oe[134],ae([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[63],ae([0,1,134]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const U=60,A=U*60,O=A*24,L=O*7,R=O*30,I=O*365;function g(b,v,c,m){typeof b!="number"&&(b=b.getTime());const E=Math.round((new Date().getTime()-b)/1e3);if(E<-30)return(0,k.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(!m&&E<30)return(0,k.localize)(1,null);let y;return E<U?(y=E,v?y===1?c?(0,k.localize)(2,null,y):(0,k.localize)(3,null,y):c?(0,k.localize)(4,null,y):(0,k.localize)(5,null,y):y===1?c?(0,k.localize)(6,null,y):(0,k.localize)(7,null,y):c?(0,k.localize)(8,null,y):(0,k.localize)(9,null,y)):E<A?(y=Math.floor(E/U),v?y===1?c?(0,k.localize)(10,null,y):(0,k.localize)(11,null,y):c?(0,k.localize)(12,null,y):(0,k.localize)(13,null,y):y===1?c?(0,k.localize)(14,null,y):(0,k.localize)(15,null,y):c?(0,k.localize)(16,null,y):(0,k.localize)(17,null,y)):E<O?(y=Math.floor(E/A),v?y===1?c?(0,k.localize)(18,null,y):(0,k.localize)(19,null,y):c?(0,k.localize)(20,null,y):(0,k.localize)(21,null,y):y===1?c?(0,k.localize)(22,null,y):(0,k.localize)(23,null,y):c?(0,k.localize)(24,null,y):(0,k.localize)(25,null,y)):E<L?(y=Math.floor(E/O),v?y===1?(0,k.localize)(26,null,y):(0,k.localize)(27,null,y):y===1?(0,k.localize)(28,null,y):(0,k.localize)(29,null,y)):E<R?(y=Math.floor(E/L),v?y===1?c?(0,k.localize)(30,null,y):(0,k.localize)(31,null,y):c?(0,k.localize)(32,null,y):(0,k.localize)(33,null,y):y===1?c?(0,k.localize)(34,null,y):(0,k.localize)(35,null,y):c?(0,k.localize)(36,null,y):(0,k.localize)(37,null,y)):E<I?(y=Math.floor(E/R),v?y===1?c?(0,k.localize)(38,null,y):(0,k.localize)(39,null,y):c?(0,k.localize)(40,null,y):(0,k.localize)(41,null,y):y===1?c?(0,k.localize)(42,null,y):(0,k.localize)(43,null,y):c?(0,k.localize)(44,null,y):(0,k.localize)(45,null,y)):(y=Math.floor(E/I),v?y===1?c?(0,k.localize)(46,null,y):(0,k.localize)(47,null,y):c?(0,k.localize)(48,null,y):(0,k.localize)(49,null,y):y===1?c?(0,k.localize)(50,null,y):(0,k.localize)(51,null,y):c?(0,k.localize)(52,null,y):(0,k.localize)(53,null,y))}e.fromNow=g;function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(oe[135],ae([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,135]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(b,v){return v&&(b.stack||b.stacktrace)?A.localize(0,null,R(b),L(b.stack)||L(b.stacktrace)):R(b)}function L(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?A.localize(1,null,b.message):b.message||A.localize(2,null)}function I(b=null,v=!1){if(!b)return A.localize(3,null);if(Array.isArray(b)){const c=k.coalesce(b),m=I(c[0],v);return c.length>1?A.localize(4,null,m,c.length):m}if(U.isString(b))return b;if(b.detail){const c=b.detail;if(c.error)return O(c.error,v);if(c.exception)return O(c.exception,v)}return b.stack?O(b,v):b.message?b.message:A.localize(5,null)}e.toErrorMessage=I;function g(b){const v=b;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=g;function P(b,v){let c;return typeof b=="string"?c=new Error(b):c=b,c.actions=v,c}e.createErrorWithActions=P}),define(oe[136],ae([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[137],ae([0,1,136]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function U(A){switch(A){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=U}),define(oe[138],ae([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,138]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let U=!1,A=!1,O=!1,L=!1,R=!1,I=!1,g=!1,P=!1,b=!1,v=!1,c,m=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT,y,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const h=typeof d?.versions?.electron=="string",f=h&&d?.type==="renderer";if(typeof navigator=="object"&&!f)u=navigator.userAgent,U=u.indexOf("Windows")>=0,A=u.indexOf("Macintosh")>=0,P=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=u.indexOf("Linux")>=0,v=u?.indexOf("Mobi")>=0,I=!0,c=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,m=c,E=navigator.language;else if(typeof d=="object"){U=d.platform==="win32",A=d.platform==="darwin",O=d.platform==="linux",L=O&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,g=h,b=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const w=d.env.VSCODE_NLS_CONFIG;if(w)try{const p=JSON.parse(w),l=p.availableLanguages["*"];c=p.locale,E=p.osLocale,m=l||e.LANGUAGE_DEFAULT,y=p._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var C;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(C||(e.Platform=C={}));function s(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=s;let o=0;A?o=1:U?o=3:O&&(o=2),e.isWindows=U,e.isMacintosh=A,e.isLinux=O,e.isLinuxSnap=L,e.isNative=R,e.isElectron=g,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=v,e.isCI=b,e.platform=o,e.userAgent=u,e.language=m;var n;(function(w){function p(){return e.language}w.value=p;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}w.isDefaultVariant=l;function S(){return e.language==="en"}w.isDefault=S})(n||(e.Language=n={})),e.locale=c,e.platformLocale=E,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const w=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let S=0,_=w.length;S<_;S++){const N=w[S];if(N.id===l.data.vscodeScheduleAsyncWork){w.splice(S,1),N.callback();return}}});let p=0;return l=>{const S=++p;w.push({id:S,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return w=>setTimeout(w)})();var i;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=A||P?2:U?1:3;let t=!0,r=!1;function a(){if(!r){r=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,t=new Uint16Array(w.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let U;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const A=k.globals.vscode.process;U={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?U={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:U={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.arch=U.arch}),define(oe[16],ae([0,1,37]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,A=97,O=90,L=122,R=46,I=47,g=92,P=58,b=63;class v extends Error{constructor(o,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,o){if(s===null||typeof s!="object")throw new v(o,"Object",s)}function m(s,o){if(typeof s!="string")throw new v(o,"string",s)}const E=k.platform==="win32";function y(s){return s===I||s===g}function u(s){return s===I}function d(s){return s>=U&&s<=O||s>=A&&s<=L}function h(s,o,n,i){let t="",r=0,a=-1,w=0,p=0;for(let l=0;l<=s.length;++l){if(l<s.length)p=s.charCodeAt(l);else{if(i(p))break;p=I}if(i(p)){if(!(a===l-1||w===1))if(w===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const S=t.lastIndexOf(n);S===-1?(t="",r=0):(t=t.slice(0,S),r=t.length-1-t.lastIndexOf(n)),a=l,w=0;continue}else if(t.length!==0){t="",r=0,a=l,w=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(a+1,l)}`:t=s.slice(a+1,l),r=l-a-1;a=l,w=0}else p===R&&w!==-1?++w:w=-1}return t}function f(s,o){c(o,"pathObject");const n=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${i}`:`${n}${s}${i}`:i}e.win32={resolve(...s){let o="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],m(r,"path"),r.length===0)continue}else o.length===0?r=k.cwd():(r=k.env[`=${o}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let w=0,p="",l=!1;const S=r.charCodeAt(0);if(a===1)y(S)&&(w=1,l=!0);else if(y(S))if(l=!0,y(r.charCodeAt(1))){let _=2,N=_;for(;_<a&&!y(r.charCodeAt(_));)_++;if(_<a&&_!==N){const $=r.slice(N,_);for(N=_;_<a&&y(r.charCodeAt(_));)_++;if(_<a&&_!==N){for(N=_;_<a&&!y(r.charCodeAt(_));)_++;(_===a||_!==N)&&(p=`\\\\${$}\\${r.slice(N,_)}`,w=_)}}}else w=1;else d(S)&&r.charCodeAt(1)===P&&(p=r.slice(0,2),w=2,a>2&&y(r.charCodeAt(2))&&(l=!0,w=3));if(p.length>0)if(o.length>0){if(p.toLowerCase()!==o.toLowerCase())continue}else o=p;if(i){if(o.length>0)break}else if(n=`${r.slice(w)}\\${n}`,i=l,l&&o.length>0)break}return n=h(n,!i,"\\",y),i?`${o}\\${n}`:`${o}${n}`||"."},normalize(s){m(s,"path");const o=s.length;if(o===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(o===1)return u(r)?"\\":s;if(y(r))if(t=!0,y(s.charCodeAt(1))){let w=2,p=w;for(;w<o&&!y(s.charCodeAt(w));)w++;if(w<o&&w!==p){const l=s.slice(p,w);for(p=w;w<o&&y(s.charCodeAt(w));)w++;if(w<o&&w!==p){for(p=w;w<o&&!y(s.charCodeAt(w));)w++;if(w===o)return`\\\\${l}\\${s.slice(p)}\\`;w!==p&&(i=`\\\\${l}\\${s.slice(p,w)}`,n=w)}}}else n=1;else d(r)&&s.charCodeAt(1)===P&&(i=s.slice(0,2),n=2,o>2&&y(s.charCodeAt(2))&&(t=!0,n=3));let a=n<o?h(s.slice(n),!t,"\\",y):"";return a.length===0&&!t&&(a="."),a.length>0&&y(s.charCodeAt(o-1))&&(a+="\\"),i===void 0?t?`\\${a}`:a:t?`${i}\\${a}`:`${i}${a}`},isAbsolute(s){m(s,"path");const o=s.length;if(o===0)return!1;const n=s.charCodeAt(0);return y(n)||o>2&&d(n)&&s.charCodeAt(1)===P&&y(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,n;for(let r=0;r<s.length;++r){const a=s[r];m(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&y(n.charCodeAt(0))){++t;const r=n.length;r>1&&y(n.charCodeAt(1))&&(++t,r>2&&(y(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<o.length&&y(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.win32.normalize(o)},relative(s,o){if(m(s,"from"),m(o,"to"),s===o)return"";const n=e.win32.resolve(s),i=e.win32.resolve(o);if(n===i||(s=n.toLowerCase(),o=i.toLowerCase(),s===o))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===g;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===g;)r--;const a=r-t;let w=0;for(;w<o.length&&o.charCodeAt(w)===g;)w++;let p=o.length;for(;p-1>w&&o.charCodeAt(p-1)===g;)p--;const l=p-w,S=a<l?a:l;let _=-1,N=0;for(;N<S;N++){const W=s.charCodeAt(t+N);if(W!==o.charCodeAt(w+N))break;W===g&&(_=N)}if(N!==S){if(_===-1)return i}else{if(l>S){if(o.charCodeAt(w+N)===g)return i.slice(w+N+1);if(N===2)return i.slice(w+N)}a>S&&(s.charCodeAt(t+N)===g?_=N:N===2&&(_=3)),_===-1&&(_=0)}let $="";for(N=t+_+1;N<=r;++N)(N===r||s.charCodeAt(N)===g)&&($+=$.length===0?"..":"\\..");return w+=_,$.length>0?`${$}${i.slice(w,p)}`:(i.charCodeAt(w)===g&&++w,i.slice(w,p))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=e.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==b&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return s},dirname(s){m(s,"path");const o=s.length;if(o===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(o===1)return y(t)?s:".";if(y(t)){if(n=i=1,y(s.charCodeAt(1))){let w=2,p=w;for(;w<o&&!y(s.charCodeAt(w));)w++;if(w<o&&w!==p){for(p=w;w<o&&y(s.charCodeAt(w));)w++;if(w<o&&w!==p){for(p=w;w<o&&!y(s.charCodeAt(w));)w++;if(w===o)return s;w!==p&&(n=i=w+1)}}}}else d(t)&&s.charCodeAt(1)===P&&(n=o>2&&y(s.charCodeAt(2))?3:2,i=n);let r=-1,a=!0;for(let w=o-1;w>=i;--w)if(y(s.charCodeAt(w))){if(!a){r=w;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,o){o!==void 0&&m(o,"ext"),m(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&d(s.charCodeAt(0))&&s.charCodeAt(1)===P&&(n=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,w=-1;for(r=s.length-1;r>=n;--r){const p=s.charCodeAt(r);if(y(p)){if(!t){n=r+1;break}}else w===-1&&(t=!1,w=r+1),a>=0&&(p===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=w))}return n===i?i=w:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(y(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){m(s,"path");let o=0,n=-1,i=0,t=-1,r=!0,a=0;s.length>=2&&s.charCodeAt(1)===P&&d(s.charCodeAt(0))&&(o=i=2);for(let w=s.length-1;w>=o;--w){const p=s.charCodeAt(w);if(y(p)){if(!r){i=w+1;break}continue}t===-1&&(r=!1,t=w+1),p===R?n===-1?n=w:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:f.bind(null,"\\"),parse(s){m(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return y(t)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(y(t)){if(i=1,y(s.charCodeAt(1))){let _=2,N=_;for(;_<n&&!y(s.charCodeAt(_));)_++;if(_<n&&_!==N){for(N=_;_<n&&y(s.charCodeAt(_));)_++;if(_<n&&_!==N){for(N=_;_<n&&!y(s.charCodeAt(_));)_++;_===n?i=_:_!==N&&(i=_+1)}}}}else if(d(t)&&s.charCodeAt(1)===P){if(n<=2)return o.root=o.dir=s,o;if(i=2,y(s.charCodeAt(2))){if(n===3)return o.root=o.dir=s,o;i=3}}i>0&&(o.root=s.slice(0,i));let r=-1,a=i,w=-1,p=!0,l=s.length-1,S=0;for(;l>=i;--l){if(t=s.charCodeAt(l),y(t)){if(!p){a=l+1;break}continue}w===-1&&(p=!1,w=l+1),t===R?r===-1?r=l:S!==1&&(S=1):r!==-1&&(S=-1)}return w!==-1&&(r===-1||S===0||S===1&&r===w-1&&r===a+1?o.base=o.name=s.slice(a,w):(o.name=s.slice(a,r),o.base=s.slice(a,w),o.ext=s.slice(r,w))),a>0&&a!==i?o.dir=s.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(E){const s=/\\/g;return()=>{const o=k.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...s){let o="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:C();m(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===I)}return o=h(o,!n,"/",u),n?`/${o}`:o.length>0?o:"."},normalize(s){if(m(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===I,n=s.charCodeAt(s.length-1)===I;return s=h(s,!o,"/",u),s.length===0?o?"/":n?"./":".":(n&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return m(s,"path"),s.length>0&&s.charCodeAt(0)===I},join(...s){if(s.length===0)return".";let o;for(let n=0;n<s.length;++n){const i=s[n];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(s,o){if(m(s,"from"),m(o,"to"),s===o||(s=e.posix.resolve(s),o=e.posix.resolve(o),s===o))return"";const n=1,i=s.length,t=i-n,r=1,a=o.length-r,w=t<a?t:a;let p=-1,l=0;for(;l<w;l++){const _=s.charCodeAt(n+l);if(_!==o.charCodeAt(r+l))break;_===I&&(p=l)}if(l===w)if(a>w){if(o.charCodeAt(r+l)===I)return o.slice(r+l+1);if(l===0)return o.slice(r+l)}else t>w&&(s.charCodeAt(n+l)===I?p=l:l===0&&(p=0));let S="";for(l=n+p+1;l<=i;++l)(l===i||s.charCodeAt(l)===I)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(r+p)}`},toNamespacedPath(s){return s},dirname(s){if(m(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===I;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===I){if(!i){n=t;break}}else i=!1;return n===-1?o?"/":".":o&&n===1?"//":s.slice(0,n)},basename(s,o){o!==void 0&&m(o,"ext"),m(s,"path");let n=0,i=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,w=-1;for(r=s.length-1;r>=0;--r){const p=s.charCodeAt(r);if(p===I){if(!t){n=r+1;break}}else w===-1&&(t=!1,w=r+1),a>=0&&(p===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=w))}return n===i?i=w:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===I){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){m(s,"path");let o=-1,n=0,i=-1,t=!0,r=0;for(let a=s.length-1;a>=0;--a){const w=s.charCodeAt(a);if(w===I){if(!t){n=a+1;break}continue}i===-1&&(t=!1,i=a+1),w===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===n+1?"":s.slice(o,i)},format:f.bind(null,"/"),parse(s){m(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.charCodeAt(0)===I;let i;n?(o.root="/",i=1):i=0;let t=-1,r=0,a=-1,w=!0,p=s.length-1,l=0;for(;p>=i;--p){const S=s.charCodeAt(p);if(S===I){if(!w){r=p+1;break}continue}a===-1&&(w=!1,a=p+1),S===R?t===-1?t=p:l!==1&&(l=1):t!==-1&&(l=-1)}if(a!==-1){const S=r===0&&n?1:r;t===-1||l===0||l===1&&t===a-1&&t===r+1?o.base=o.name=s.slice(S,a):(o.name=s.slice(S,t),o.base=s.slice(S,a),o.ext=s.slice(t,a))}return r>0?o.dir=s.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(oe[48],ae([0,1,16,5,27,12]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(r){return r===47||r===92}e.isPathSeparator=L;function R(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function I(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function g(r,a=k.posix.sep){if(!r)return"";const w=r.length,p=r.charCodeAt(0);if(L(p)){if(L(r.charCodeAt(1))&&!L(r.charCodeAt(2))){let S=3;const _=S;for(;S<w&&!L(r.charCodeAt(S));S++);if(_!==S&&!L(r.charCodeAt(S+1))){for(S+=1;S<w;S++)if(L(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,a)}}return a}else if(u(p)&&r.charCodeAt(1)===58)return L(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let l=r.indexOf("://");if(l!==-1){for(l+=3;l<w;l++)if(L(r.charCodeAt(l)))return r.slice(0,l+1)}return""}e.getRoot=g;function P(r){if(!U.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let w=2;const p=w;for(;w<r.length&&(a=r.charCodeAt(w),a!==92);w++);return!(p===w||(a=r.charCodeAt(w+1),isNaN(a)||a===92))}e.isUNC=P;const b=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(r,a=U.isWindows){const w=a?b:v;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||a&&c.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=m;function E(r,a,w){const p=r===a;return!w||p?p:!r||!a?!1:(0,A.equalsIgnoreCase)(r,a)}e.isEqual=E;function y(r,a,w,p=k.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(w){if(!(0,A.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let S=a.length;return a.charAt(a.length-1)===p&&S--,r.charAt(S)===p}return a.charAt(a.length-1)!==p&&(a+=p),r.indexOf(a)===0}e.isEqualOrParent=y;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function d(r,a){return U.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(a,r)),r=(0,k.normalize)(r),U.isWindows?(r=(0,A.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,A.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=d;function h(r){const a=(0,k.normalize)(r);return U.isWindows?r.length>3?!1:f(a)&&(r.length===2||a.charCodeAt(2)===92):a===k.posix.sep}e.isRootOrDriveLetter=h;function f(r,a=U.isWindows){return a?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function C(r,a=U.isWindows){return f(r,a)?r[0]:void 0}e.getDriveLetter=C;function s(r,a,w){return a.length>r.length?-1:r===a?0:(w&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=s;function o(r){const a=r.split(":");let w,p,l;for(const S of a){const _=Number(S);(0,O.isNumber)(_)?p===void 0?p=_:l===void 0&&(l=_):w=w?[w,S].join(":"):S}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:p!==void 0?p:void 0,column:l!==void 0?l:p!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,w=8){let p="";for(let S=0;S<w;S++){let _;S===0&&U.isWindows&&!a&&(w===3||w===4)?_=i:_=n,p+=_.charAt(Math.floor(Math.random()*_.length))}let l;return a?l=`${a}-${p}`:l=p,r?(0,k.join)(r,l):l}e.randomPath=t}),define(oe[139],ae([0,1,16]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const U={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(P){const b=(0,k.extname)(P),v=U[b.toLowerCase()];return v!==void 0?v:L(P)}e.getMediaOrTextMime=O;function L(P){const b=(0,k.extname)(P);return A[b.toLowerCase()]}e.getMediaMime=L;function R(P){for(const b in A)if(A[b]===P)return b}e.getExtensionForMimeType=R;const I=/^(.+)\/(.+?)(;.+)?$/;function g(P,b){const v=I.exec(P);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:b?void 0:P}e.normalizeMimeType=g}),define(oe[90],ae([0,1,5]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var U;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(U||(e.Source=U={}));var A;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function O(R,...I){const g=I.reduce((v,c)=>(v[c]=!0,v),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(v=>!g[v]).forEach(v=>{for(let c=0;c<P.length;c++)if(v.search(P[c])!==-1){delete R[v];break}})}e.sanitizeProcessEnvironment=O;function L(R){R&&(delete R.DEBUG,k.isMacintosh&&delete R.DYLD_LIBRARY_PATH,k.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(oe[10],ae([0,1,16,5]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,O=/^\//,L=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!A.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(i,t){return!i&&!t?"file":i}function g(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const P="",b="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,w,p,l=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=I(t,l),this.authority=r||P,this.path=g(this.scheme,a||P),this.query=w||P,this.fragment=p||P,R(this,l))}get fsPath(){return f(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:w,query:p,fragment:l}=t;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),w===void 0?w=this.path:w===null&&(w=P),p===void 0?p=this.query:p===null&&(p=P),l===void 0?l=this.fragment:l===null&&(l=P),r===this.scheme&&a===this.authority&&w===this.path&&p===this.query&&l===this.fragment?this:new y(r,a,w,p,l)}static parse(t,r=!1){const a=v.exec(t);return a?new y(a[2]||P,n(a[4]||P),n(a[5]||P),n(a[7]||P),n(a[9]||P),r):new y(P,P,P,P,P)}static file(t){let r=P;if(U.isWindows&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const a=t.indexOf(b,2);a===-1?(r=t.substring(2),t=b):(r=t.substring(2,a),t=t.substring(a)||b)}return new y("file",r,t,P,P)}static from(t,r){return new y(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return U.isWindows&&t.scheme==="file"?a=c.file(k.win32.join(f(t,!0),...r)).path:a=k.posix.join(t.path,...r),t.with({path:a})}toString(t=!1){return C(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new y(t);return r._formatted=t.external??null,r._fsPath=t._sep===E?t.fsPath??null:null,r}}else return t}}e.URI=c;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=m;const E=U.isWindows?1:void 0;class y extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(t=!1){return t?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=E),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,t,r){let a,w=-1;for(let p=0;p<i.length;p++){const l=i.charCodeAt(p);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||t&&l===47||r&&l===91||r&&l===93||r&&l===58)w!==-1&&(a+=encodeURIComponent(i.substring(w,p)),w=-1),a!==void 0&&(a+=i.charAt(p));else{a===void 0&&(a=i.substr(0,p));const S=u[l];S!==void 0?(w!==-1&&(a+=encodeURIComponent(i.substring(w,p)),w=-1),a+=S):w===-1&&(w=p)}}return w!==-1&&(a+=encodeURIComponent(i.substring(w))),a!==void 0?a:i}function h(i){let t;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(t===void 0&&(t=i.substr(0,r)),t+=u[a]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function f(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,U.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=f;function C(i,t){const r=t?h:d;let a="",{scheme:w,authority:p,path:l,query:S,fragment:_}=i;if(w&&(a+=w,a+=":"),(p||w==="file")&&(a+=b,a+=b),p){let N=p.indexOf("@");if(N!==-1){const $=p.substr(0,N);p=p.substr(N+1),N=$.lastIndexOf(":"),N===-1?a+=r($,!1,!1):(a+=r($.substr(0,N),!1,!1),a+=":",a+=r($.substr(N+1),!1,!0)),a+="@"}p=p.toLowerCase(),N=p.lastIndexOf(":"),N===-1?a+=r(p,!1,!0):(a+=r(p.substr(0,N),!1,!0),a+=p.substr(N))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const N=l.charCodeAt(1);N>=65&&N<=90&&(l=`/${String.fromCharCode(N+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const N=l.charCodeAt(0);N>=65&&N<=90&&(l=`${String.fromCharCode(N+32)}:${l.substr(2)}`)}a+=r(l,!0,!1)}return S&&(a+="?",a+=r(S,!1,!1)),_&&(a+="#",a+=t?_:d(_,!1,!1)),a}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(o)?i.replace(o,t=>s(t)):i}}),define(oe[140],ae([0,1,10]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function U(g){const P=g;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=U;function A(g){const P=[];let b;try{const v=JSON.parse(g.arguments),c=v[v.length-1];c&&c.__$stack&&(v.pop(),b=c.__$stack),P.push(...v)}catch{P.push("Unable to log remote console arguments",g.arguments)}return{args:P,stack:b}}e.parse=A;function O(g){if(typeof g!="string")return O(A(g).stack);const P=g;if(P){const b=L(P),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(v&&v.length===4)return{uri:k.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=O;function L(g){if(!g)return g;const P=g.indexOf(`
`);return P===-1?g:g.substring(0,P)}function R(g,P){const{args:b,stack:v}=A(g),c=typeof b[0]=="string"&&b.length===1;let m=L(v);m&&(m=`(${m.trim()})`);let E=[];if(typeof b[0]=="string"?m&&c?E=[`%c[${P}] %c${b[0]} %c${m}`,I("blue"),I(""),I("grey")]:E=[`%c[${P}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:E=[`%c[${P}]%`,I("blue"),...b],m&&!c&&E.push(m),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,E)}e.log=R;function I(g){return`color: ${g}`}}),define(oe[64],ae([0,1,15,10]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(I){return JSON.stringify(I,L)}e.stringify=A;function O(I){let g=JSON.parse(I);return g=R(g),g}e.parse=O;function L(I,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(I,g=0){if(!I||g>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return U.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 17:return new Date(I.source)}if(I instanceof k.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let P=0;P<I.length;++P)I[P]=R(I[P],g+1);else for(const P in I)Object.hasOwnProperty.call(I,P)&&(I[P]=R(I[P],g+1))}return I}e.revive=R}),define(oe[23],ae([0,1,7,5,10]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var O;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${O.vscodeRemoteResource}`}set(P,b,v){this._hosts[P]=b,this._ports[P]=v}setConnectionToken(P,b){this._connectionTokens[P]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)try{return this._delegate(P)}catch(y){return k.onUnexpectedError(y),P}const b=P.authority;let v=this._hosts[b];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const c=this._ports[b],m=this._connectionTokens[b];let E=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),A.URI.from({scheme:U.isWeb?this._preferredWebSchema:O.vscodeRemoteResource,authority:`${v}:${c}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class R{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(P){const b=this.toUri(P,te);return this.uriToBrowserUri(b)}uriToBrowserUri(P){return P.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===O.file&&(U.isNative||U.isWebWorker&&U.globals.origin===`${O.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?P.with({scheme:O.vscodeFileResource,authority:P.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(P){const b=this.toUri(P,te);return this.uriToFileUri(b)}uriToFileUri(P){return P.scheme===O.vscodeFileResource?P.with({scheme:O.file,authority:P.authority!==R.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(P,b){return A.URI.isUri(P)?P:A.URI.parse(b.toUrl(P))}}e.FileAccess=new R;var I;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const b="vscode-coi";function v(m){let E;typeof m=="string"?E=new URL(m).searchParams:m instanceof URL?E=m.searchParams:A.URI.isUri(m)&&(E=new URL(m.toString(!0)).searchParams);const y=E?.get(b);if(y)return P.get(y)}g.getHeadersFromQuery=v;function c(m,E,y){if(!globalThis.crossOriginIsolated)return;const u=E&&y?"3":y?"2":"1";m instanceof URLSearchParams?m.set(b,u):m[b]=u}g.addSearchParam=c})(I||(e.COI=I={}))}),define(oe[141],ae([0,1,123,23,5,10]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class L{constructor(v,c,m){this.id=v,this.dependencies=c,this.callback=m}}class R{static{this.INSTANCE=new R}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(v,c,m)=>{typeof v!="string"&&(m=c,c=v,v=null),(typeof c!="object"||!Array.isArray(c))&&(m=c,c=null),this._defineCalls.push(new L(v,c,m))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this._initialize();const c=await(this._isWebWorker?this._workerLoadScript(v):this._isRenderer?this._rendererLoadScript(v):this._nodeJSLoadScript(v));if(!c)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}_rendererLoadScript(v){return new Promise((c,m)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const y=()=>{E.removeEventListener("load",u),E.removeEventListener("error",d)},u=h=>{y(),c(this._defineCalls.pop())},d=h=>{y(),m(h)};E.addEventListener("load",u),E.addEventListener("error",d),this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),E.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(E)})}_workerLoadScript(v){return new Promise((c,m)=>{try{this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),importScripts(v),c(this._defineCalls.pop())}catch(E){m(E)}})}async _nodeJSLoadScript(v){try{const c=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,y=O.URI.parse(v).fsPath,u=c.readFileSync(y).toString(),d=E.wrap(u.replace(/^#!.*/,""));return new m.Script(d).runInThisContext().apply(),this._defineCalls.pop()}catch(c){throw c}}}const I=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function P(b,v,c){if(k.isESM){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[b]&&(b=g[b]);const m=`${b}/${v}`;if(I.has(m))return I.get(m);let E;if(/^\w[\w\d+.-]*:\/\//.test(m))E=m;else{const h=`${c&&!A.isWeb?U.nodeModulesAsarPath:U.nodeModulesPath}/${m}`;E=U.FileAccess.asBrowserUri(h).toString(!0)}const y=R.INSTANCE.load(E);return I.set(m,y),y}else return await new Promise((m,E)=>{te([b],m,E)})}e.importAMDNodeModule=P}),define(oe[19],ae([0,1,48,23,16,5,27,10]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(c){return(0,R.uriToFsPath)(c,!0)}e.originalFSPath=I;class g{constructor(m){this._ignorePathCasing=m}compare(m,E,y=!1){return m===E?0:(0,L.compare)(this.getComparisonKey(m,y),this.getComparisonKey(E,y))}isEqual(m,E,y=!1){return m===E?!0:!m||!E?!1:this.getComparisonKey(m,y)===this.getComparisonKey(E,y)}getComparisonKey(m,E=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,E,y=!1){if(m.scheme===E.scheme){if(m.scheme===U.Schemas.file)return k.isEqualOrParent(I(m),I(E),this._ignorePathCasing(m))&&m.query===E.query&&(y||m.fragment===E.fragment);if((0,e.isEqualAuthority)(m.authority,E.authority))return k.isEqualOrParent(m.path,E.path,this._ignorePathCasing(m),"/")&&m.query===E.query&&(y||m.fragment===E.fragment)}return!1}joinPath(m,...E){return R.URI.joinPath(m,...E)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return A.posix.basename(m.path)}extname(m){return A.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let E;return m.scheme===U.Schemas.file?E=R.URI.file(A.dirname(I(m))).path:(E=A.posix.dirname(m.path),m.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),E="/")),m.with({path:E})}normalizePath(m){if(!m.path.length)return m;let E;return m.scheme===U.Schemas.file?E=R.URI.file(A.normalize(I(m))).path:E=A.posix.normalize(m.path),m.with({path:E})}relativePath(m,E){if(m.scheme!==E.scheme||!(0,e.isEqualAuthority)(m.authority,E.authority))return;if(m.scheme===U.Schemas.file){const d=A.relative(I(m),I(E));return O.isWindows?k.toSlashes(d):d}let y=m.path||"/";const u=E.path||"/";if(this._ignorePathCasing(m)){let d=0;for(const h=Math.min(y.length,u.length);d<h&&!(y.charCodeAt(d)!==u.charCodeAt(d)&&y.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);y=u.substr(0,d)+y.substr(d)}return A.posix.relative(y,u)}resolvePath(m,E){if(m.scheme===U.Schemas.file){const y=R.URI.file(A.resolve(I(m),E));return m.with({authority:y.authority,path:y.path})}return E=k.toPosixPath(E),m.with({path:A.posix.resolve(m.path,E)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,E){return m===E||m!==void 0&&E!==void 0&&(0,L.equalsIgnoreCase)(m,E)}hasTrailingPathSeparator(m,E=A.sep){if(m.scheme===U.Schemas.file){const y=I(m);return y.length>k.getRoot(y).length&&y[y.length-1]===E}else{const y=m.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,E=A.sep){return(0,e.hasTrailingPathSeparator)(m,E)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,E=A.sep){let y=!1;if(m.scheme===U.Schemas.file){const u=I(m);y=u!==void 0&&u.length===k.getRoot(u).length&&u[u.length-1]===E}else{E="/";const u=m.path;y=u.length===1&&u.charCodeAt(u.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(m,E)?m.with({path:m.path+"/"}):m}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(c=>c.scheme===U.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new g(c=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(c,m){const E=[];for(let y=0;y<c.length;y++){const u=m(c[y]);c.some((d,h)=>h===y?!1:(0,e.isEqualOrParent)(u,m(d)))||E.push(c[y])}return E}e.distinctParents=P;var b;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function m(E){const y=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(h=>{const[f,C]=h.split(":");f&&C&&y.set(f,C)});const d=E.path.substring(0,E.path.indexOf(";"));return d&&y.set(c.META_DATA_MIME,d),y}c.parseMetaData=m})(b||(e.DataUri=b={}));function v(c,m,E){if(m){let y=c.path;return y&&y[0]!==A.posix.sep&&(y=A.posix.sep+y),c.with({scheme:E,authority:m,path:y})}return c.with({scheme:E})}e.toLocalResource=v}),define(oe[6],ae([0,1,26,7,3,2,19,5,129]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(T){return!!T&&typeof T.then=="function"}e.isThenable=g;function P(T){const M=new k.CancellationTokenSource,F=T(M.token),V=new Promise((H,re)=>{const ce=M.token.onCancellationRequested(()=>{ce.dispose(),M.dispose(),re(new U.CancellationError)});Promise.resolve(F).then(he=>{ce.dispose(),M.dispose(),H(he)},he=>{ce.dispose(),M.dispose(),re(he)})});return new class{cancel(){M.cancel()}then(H,re){return V.then(H,re)}catch(H){return this.then(void 0,H)}finally(H){return V.finally(H)}}}e.createCancelablePromise=P;function b(T,M,F){return new Promise((V,H)=>{const re=M.onCancellationRequested(()=>{re.dispose(),V(F)});T.then(V,H).finally(()=>re.dispose())})}e.raceCancellation=b;function v(T,M){return new Promise((F,V)=>{const H=M.onCancellationRequested(()=>{H.dispose(),V(new U.CancellationError)});T.then(F,V).finally(()=>H.dispose())})}e.raceCancellationError=v;async function c(T){let M=-1;const F=T.map((V,H)=>V.then(re=>(M=H,re)));try{return await Promise.race(F)}finally{T.forEach((V,H)=>{H!==M&&V.cancel()})}}e.raceCancellablePromises=c;function m(T,M,F){let V;const H=setTimeout(()=>{V?.(void 0),F?.()},M);return Promise.race([T.finally(()=>clearTimeout(H)),new Promise(re=>V=re)])}e.raceTimeout=m;function E(T){return new Promise((M,F)=>{const V=T();g(V)?V.then(M,F):M(V)})}e.asPromise=E;class y{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const F=()=>{if(this.queuedPromise=null,this.isDisposed)return;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(F,F).then(V)})}return new Promise((F,V)=>{this.queuedPromise.then(F,V)})}return this.activePromise=M(),new Promise((F,V)=>{this.activePromise.then(H=>{this.activePromise=null,F(H)},H=>{this.activePromise=null,V(H)})})}dispose(){this.isDisposed=!0}}e.Throttler=y;class u{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=u;class d{constructor(){this.promiseMap=new Map}queue(M,F){const H=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(M)===H&&this.promiseMap.delete(M)});return this.promiseMap.set(M,H),H}}e.SequencerByKey=d;const h=(T,M)=>{let F=!0;const V=setTimeout(()=>{F=!1,M()},T);return{isTriggered:()=>F,dispose:()=>{clearTimeout(V),F=!1}}},f=T=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,T())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class C{constructor(M){this.defaultDelay=M,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,F=this.defaultDelay){this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,re)=>{this.doResolve=H,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=F===I.MicrotaskDelay?f(V):h(F,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new U.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=C;class s{constructor(M){this.delayer=new C(M),this.throttler=new y}trigger(M,F){return this.delayer.trigger(()=>this.throttler.queue(M),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class o{constructor(){this._isOpen=!1,this._promise=new Promise((M,F)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class n extends o{constructor(M){super(),this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function i(T,M){return M?new Promise((F,V)=>{const H=setTimeout(()=>{re.dispose(),F()},T),re=M.onCancellationRequested(()=>{clearTimeout(H),re.dispose(),V(new U.CancellationError)})}):P(F=>i(T,F))}e.timeout=i;function t(T,M=0,F){const V=setTimeout(()=>{T(),F&&H.dispose()},M),H=(0,O.toDisposable)(()=>{clearTimeout(V),F?.deleteAndLeak(H)});return F?.add(H),H}e.disposableTimeout=t;function r(T){const M=[];let F=0;const V=T.length;function H(){return F<V?T[F++]():null}function re(ce){ce!=null&&M.push(ce);const he=H();return he?he.then(re):Promise.resolve(M)}return Promise.resolve(null).then(re)}e.sequence=r;function a(T,M=V=>!!V,F=null){let V=0;const H=T.length,re=()=>{if(V>=H)return Promise.resolve(F);const ce=T[V++];return Promise.resolve(ce()).then(ue=>M(ue)?Promise.resolve(ue):re())};return re()}e.first=a;function w(T,M=V=>!!V,F=null){if(T.length===0)return Promise.resolve(F);let V=T.length;const H=()=>{V=-1;for(const re of T)re.cancel?.()};return new Promise((re,ce)=>{for(const he of T)he.then(ue=>{--V>=0&&M(ue)?(H(),re(ue)):V===0&&re(F)}).catch(ue=>{--V>=0&&(H(),ce(ue))})})}e.firstParallel=w;class p{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new A.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(M){return this._size++,new Promise((F,V)=>{this.outstandingPromises.push({factory:M,c:F,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const F=M.factory();F.then(M.c,M.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=p;class l extends p{constructor(){super(1)}}e.Queue=l;class S{constructor(){this.sequentializer=new Y,this.tasks=0}queue(M){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,M())):this.sequentializer.run(this.tasks++,M())}}e.LimitedQueue=S;class _{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const M=new ee;return this.drainers.add(M),M.p}isDrained(){for(const[,M]of this.queues)if(M.size>0)return!1;return!0}queueFor(M,F=L.extUri){const V=F.getComparisonKey(M);let H=this.queues.get(V);if(!H){H=new l;const re=this.drainListenerCount++,ce=A.Event.once(H.onDrained)(()=>{H?.dispose(),this.queues.delete(V),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(re),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(re,ce),this.queues.set(V,H)}return H}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const M of this.drainers)M.complete();this.drainers.clear()}dispose(){for(const[,M]of this.queues)M.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=_;class N{constructor(M,F){this._token=-1,typeof M=="function"&&typeof F=="number"&&this.setIfNotSet(M,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},F)}setIfNotSet(M,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},F))}}e.TimeoutTimer=N;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,F){this.cancel(),this._token=setInterval(()=>{M()},F)}}e.IntervalTimer=$;class W{constructor(M,F){this.timeoutToken=-1,this.runner=M,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=W;class q{constructor(M,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.runner=M,this.timeout=F,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(M=this.timeout){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(M/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=q;class Q extends W{constructor(M,F){super(M,F),this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner?.(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class G extends O.Disposable{constructor(M,F){super(),this.options=M,this.handler=F,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.options.maxBufferedWork)return!1}else if(this.pending+M.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const F of M)this.pendingWork.push(F);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=G,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,R.setTimeout0)(()=>{if(M)return;const F=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(T,M)=>{const F=requestIdleCallback(T,typeof M=="number"?{timeout:M}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(F))}}}}();class X{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=X;async function x(T,M,F){let V;for(let H=0;H<F;H++)try{return await T()}catch(re){V=re,await i(M)}throw V}e.retry=x;class Y{isRunning(M){return typeof M=="number"?this._running?.taskId===M:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(M,F,V){return this._running={taskId:M,cancel:()=>V?.(),promise:F},F.then(()=>this.doneRunning(M),()=>this.doneRunning(M)),F}doneRunning(M){this._running&&M===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const M=this._queued;this._queued=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}queue(M){if(this._queued)this._queued.run=M;else{let F,V;const H=new Promise((re,ce)=>{F=re,V=ce});this._queued={run:M,promise:H,promiseResolve:F,promiseReject:V}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Y;class B{constructor(M,F=()=>Date.now()){this.interval=M,this.nowFn=F,this.lastIncrementTime=0,this.value=0}increment(){const M=this.nowFn();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=B;var z;(function(T){T[T.Resolved=0]="Resolved",T[T.Rejected=1]="Rejected"})(z||(z={}));class ee{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((M,F)=>{this.completeCallback=M,this.errorCallback=F})}complete(M){return new Promise(F=>{this.completeCallback(M),this.outcome={outcome:0,value:M},F()})}error(M){return new Promise(F=>{this.errorCallback(M),this.outcome={outcome:1,value:M},F()})}cancel(){return this.error(new U.CancellationError)}}e.DeferredPromise=ee;var ie;(function(T){async function M(V){let H;const re=await Promise.all(V.map(ce=>ce.then(he=>he,he=>{H||(H=he)})));if(typeof H<"u")throw H;return re}T.settled=M;function F(V){return new Promise(async(H,re)=>{try{await V(H,re)}catch(ce){re(ce)}})}T.withAsyncBody=F})(ie||(e.Promises=ie={}));var Z;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(Z||(Z={}));class ne{static fromArray(M){return new ne(F=>{F.emitMany(M)})}static fromPromise(M){return new ne(async F=>{F.emitMany(await M)})}static fromPromises(M){return new ne(async F=>{await Promise.all(M.map(async V=>F.emitOne(await V)))})}static merge(M){return new ne(async F=>{await Promise.all(M.map(async V=>{for await(const H of V)F.emitOne(H)}))})}static{this.EMPTY=ne.fromArray([])}constructor(M){this._state=0,this._results=[],this._error=null,this._onStateChanged=new A.Emitter,queueMicrotask(async()=>{const F={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(M(F)),this.resolve()}catch(V){this.reject(V)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(M<this._results.length)return{done:!1,value:this._results[M++]};if(this._state===1)return{done:!0,value:void 0};await A.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(M,F){return new ne(async V=>{for await(const H of M)V.emitOne(F(H))})}map(M){return ne.map(this,M)}static filter(M,F){return new ne(async V=>{for await(const H of M)F(H)&&V.emitOne(H)})}filter(M){return ne.filter(this,M)}static coalesce(M){return ne.filter(M,F=>!!F)}coalesce(){return ne.coalesce(this)}static async toPromise(M){const F=[];for await(const V of M)F.push(V);return F}toPromise(){return ne.toPromise(this)}emitOne(M){this._state===0&&(this._results.push(M),this._onStateChanged.fire())}emitMany(M){this._state===0&&(this._results=this._results.concat(M),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(M){this._state===0&&(this._state=2,this._error=M,this._onStateChanged.fire())}}e.AsyncIterableObject=ne;class K extends ne{constructor(M,F){super(F),this._source=M}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function j(T){const M=new k.CancellationTokenSource,F=T(M.token);return new K(M,async V=>{const H=M.token.onCancellationRequested(()=>{H.dispose(),M.dispose(),V.reject(new U.CancellationError)});try{for await(const re of F){if(M.token.isCancellationRequested)return;V.emitOne(re)}H.dispose(),M.dispose()}catch(re){H.dispose(),M.dispose(),V.reject(re)}})}e.createCancelableAsyncIterable=j;class D{constructor(){this._deferred=new ee,this._asyncIterable=new ne(V=>{if(M){V.reject(M);return}return F&&V.emitMany(F),this._errorFn=H=>V.reject(H),this._emitFn=H=>V.emitOne(H),this._deferred.p});let M,F;this._emitFn=V=>{F||(F=[]),F.push(V)},this._errorFn=V=>{M||(M=V)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(M){this._errorFn(M),this._deferred.complete()}emitOne(M){this._emitFn(M)}}e.AsyncIterableSource=D}),define(oe[91],ae([0,1,18,6,48,34,16,5,27]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",b="[^/\\\\]",v=/\//g;function c(Y,B){switch(Y){case 0:return"";case 1:return`${b}*?`;default:return`(?:${P}|${b}+${P}${B?`|${P}${b}+`:""})*?`}}function m(Y,B){if(!Y)return[];const z=[];let ee=!1,ie=!1,Z="";for(const ne of Y){switch(ne){case B:if(!ee&&!ie){z.push(Z),Z="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}Z+=ne}return Z&&z.push(Z),z}e.splitGlobAware=m;function E(Y){if(!Y)return"";let B="";const z=m(Y,e.GLOB_SPLIT);if(z.every(ee=>ee===e.GLOBSTAR))B=".*";else{let ee=!1;z.forEach((ie,Z)=>{if(ie===e.GLOBSTAR){if(ee)return;B+=c(2,Z===z.length-1)}else{let ne=!1,K="",j=!1,D="";for(const T of ie){if(T!=="}"&&ne){K+=T;continue}if(j&&(T!=="]"||!D)){let M;T==="-"?M=T:(T==="^"||T==="!")&&!D?M="^":T===e.GLOB_SPLIT?M="":M=(0,I.escapeRegExpCharacters)(T),D+=M;continue}switch(T){case"{":ne=!0;continue;case"[":j=!0;continue;case"}":{const F=`(?:${m(K,",").map(V=>E(V)).join("|")})`;B+=F,ne=!1,K="";break}case"]":{B+="["+D+"]",j=!1,D="";break}case"?":B+=b;continue;case"*":B+=c(1);continue;default:B+=(0,I.escapeRegExpCharacters)(T)}}Z<z.length-1&&(z[Z+1]!==e.GLOBSTAR||Z+2<z.length)&&(B+=P)}ee=ie===e.GLOBSTAR})}return B}const y=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new O.LRUCache(1e4),o=function(){return!1},n=function(){return null};function i(Y,B){if(!Y)return n;let z;typeof Y!="string"?z=Y.pattern:z=Y,z=z.trim();const ee=`${z}_${!!B.trimForExclusions}`;let ie=s.get(ee);if(ie)return t(ie,Y);let Z;return y.test(z)?ie=a(z.substr(4),z):(Z=u.exec(r(z,B)))?ie=w(Z[1],z):(B.trimForExclusions?h:d).test(z)?ie=p(z,B):(Z=f.exec(r(z,B)))?ie=l(Z[1].substr(1),z,!0):(Z=C.exec(r(z,B)))?ie=l(Z[1],z,!1):ie=S(z),s.set(ee,ie),t(ie,Y)}function t(Y,B){if(typeof B=="string")return Y;const z=function(ee,ie){return(0,A.isEqualOrParent)(ee,B.base,!R.isLinux)?Y((0,I.ltrim)(ee.substr(B.base.length),L.sep),ie):null};return z.allBasenames=Y.allBasenames,z.allPaths=Y.allPaths,z.basenames=Y.basenames,z.patterns=Y.patterns,z}function r(Y,B){return B.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function a(Y,B){return function(z,ee){return typeof z=="string"&&z.endsWith(Y)?B:null}}function w(Y,B){const z=`/${Y}`,ee=`\\${Y}`,ie=function(ne,K){return typeof ne!="string"?null:K?K===Y?B:null:ne===Y||ne.endsWith(z)||ne.endsWith(ee)?B:null},Z=[Y];return ie.basenames=Z,ie.patterns=[B],ie.allBasenames=Z,ie}function p(Y,B){const z=X(Y.slice(1,-1).split(",").map(K=>i(K,B)).filter(K=>K!==n),Y),ee=z.length;if(!ee)return n;if(ee===1)return z[0];const ie=function(K,j){for(let D=0,T=z.length;D<T;D++)if(z[D](K,j))return Y;return null},Z=z.find(K=>!!K.allBasenames);Z&&(ie.allBasenames=Z.allBasenames);const ne=z.reduce((K,j)=>j.allPaths?K.concat(j.allPaths):K,[]);return ne.length&&(ie.allPaths=ne),ie}function l(Y,B,z){const ee=L.sep===L.posix.sep,ie=ee?Y:Y.replace(v,L.sep),Z=L.sep+ie,ne=L.posix.sep+Y;let K;return z?K=function(j,D){return typeof j=="string"&&(j===ie||j.endsWith(Z)||!ee&&(j===Y||j.endsWith(ne)))?B:null}:K=function(j,D){return typeof j=="string"&&(j===ie||!ee&&j===Y)?B:null},K.allPaths=[(z?"*/":"./")+Y],K}function S(Y){try{const B=new RegExp(`^${E(Y)}$`);return function(z){return B.lastIndex=0,typeof z=="string"&&B.test(z)?Y:null}}catch{return n}}function _(Y,B,z){return!Y||typeof B!="string"?!1:N(Y)(B,void 0,z)}e.match=_;function N(Y,B={}){if(!Y)return o;if(typeof Y=="string"||$(Y)){const z=i(Y,B);if(z===n)return o;const ee=function(ie,Z){return!!z(ie,Z)};return z.allBasenames&&(ee.allBasenames=z.allBasenames),z.allPaths&&(ee.allPaths=z.allPaths),ee}return Q(Y,B)}e.parse=N;function $(Y){const B=Y;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=$;function W(Y){return Y.allBasenames||[]}e.getBasenameTerms=W;function q(Y){return Y.allPaths||[]}e.getPathTerms=q;function Q(Y,B){const z=X(Object.getOwnPropertyNames(Y).map(K=>G(K,Y[K],B)).filter(K=>K!==n)),ee=z.length;if(!ee)return n;if(!z.some(K=>!!K.requiresSiblings)){if(ee===1)return z[0];const K=function(T,M){let F;for(let V=0,H=z.length;V<H;V++){const re=z[V](T,M);if(typeof re=="string")return re;(0,U.isThenable)(re)&&(F||(F=[]),F.push(re))}return F?(async()=>{for(const V of F){const H=await V;if(typeof H=="string")return H}return null})():null},j=z.find(T=>!!T.allBasenames);j&&(K.allBasenames=j.allBasenames);const D=z.reduce((T,M)=>M.allPaths?T.concat(M.allPaths):T,[]);return D.length&&(K.allPaths=D),K}const ie=function(K,j,D){let T,M;for(let F=0,V=z.length;F<V;F++){const H=z[F];H.requiresSiblings&&D&&(j||(j=(0,L.basename)(K)),T||(T=j.substr(0,j.length-(0,L.extname)(K).length)));const re=H(K,j,T,D);if(typeof re=="string")return re;(0,U.isThenable)(re)&&(M||(M=[]),M.push(re))}return M?(async()=>{for(const F of M){const V=await F;if(typeof V=="string")return V}return null})():null},Z=z.find(K=>!!K.allBasenames);Z&&(ie.allBasenames=Z.allBasenames);const ne=z.reduce((K,j)=>j.allPaths?K.concat(j.allPaths):K,[]);return ne.length&&(ie.allPaths=ne),ie}function G(Y,B,z){if(B===!1)return n;const ee=i(Y,z);if(ee===n)return n;if(typeof B=="boolean")return ee;if(B){const ie=B.when;if(typeof ie=="string"){const Z=(ne,K,j,D)=>{if(!D||!ee(ne,K))return null;const T=ie.replace("$(basename)",()=>j),M=D(T);return(0,U.isThenable)(M)?M.then(F=>F?Y:null):M?Y:null};return Z.requiresSiblings=!0,Z}}return ee}function X(Y,B){const z=Y.filter(K=>!!K.basenames);if(z.length<2)return Y;const ee=z.reduce((K,j)=>{const D=j.basenames;return D?K.concat(D):K},[]);let ie;if(B){ie=[];for(let K=0,j=ee.length;K<j;K++)ie.push(B)}else ie=z.reduce((K,j)=>{const D=j.patterns;return D?K.concat(D):K},[]);const Z=function(K,j){if(typeof K!="string")return null;if(!j){let T;for(T=K.length;T>0;T--){const M=K.charCodeAt(T-1);if(M===47||M===92)break}j=K.substr(T)}const D=ee.indexOf(j);return D!==-1?ie[D]:null};Z.basenames=ee,Z.patterns=ie,Z.allBasenames=ee;const ne=Y.filter(K=>!K.basenames);return ne.push(Z),ne}function x(Y,B){return(0,k.equals)(Y,B,(z,ee)=>typeof z=="string"&&typeof ee=="string"?z===ee:typeof z!="string"&&typeof ee!="string"?z.base===ee.base&&z.pattern===ee.pattern:!1)}e.patternsEquals=x}),define(oe[92],ae([0,1,15,10]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(b){return b.toJSON()}class O{constructor(v){this._uriTransformer=v}transformIncoming(v){const c=this._uriTransformer.transformIncoming(v);return c===v?v:A(U.URI.from(c))}transformOutgoing(v){const c=this._uriTransformer.transformOutgoing(v);return c===v?v:A(U.URI.from(c))}transformOutgoingURI(v){const c=this._uriTransformer.transformOutgoing(v);return c===v?v:U.URI.from(c)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function L(b,v,c){if(!b||c>200)return null;if(typeof b=="object"){if(b instanceof U.URI)return v.transformOutgoing(b);for(const m in b)if(Object.hasOwnProperty.call(b,m)){const E=L(b[m],v,c+1);E!==null&&(b[m]=E)}}return null}function R(b,v){const c=L(b,v,0);return c===null?b:c}e.transformOutgoingURIs=R;function I(b,v,c,m){if(!b||m>200)return null;if(typeof b=="object"){if(b.$mid===1)return c?U.URI.revive(v.transformIncoming(b)):v.transformIncoming(b);if(b instanceof k.VSBuffer)return null;for(const E in b)if(Object.hasOwnProperty.call(b,E)){const y=I(b[E],v,c,m+1);y!==null&&(b[E]=y)}}return null}function g(b,v){const c=I(b,v,!1,0);return c===null?b:c}e.transformIncomingURIs=g;function P(b,v){const c=I(b,v,!0,0);return c===null?b:c}e.transformAndReviveIncomingURIs=P}),define(oe[142],ae([0,1,36,47,32,130,5]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(v){return this._virtualMachineOUIs||(this._virtualMachineOUIs=U.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(v)}value(){if(this._value===void 0){let v=0,c=0;const m=(0,k.networkInterfaces)();for(const E in m){const y=m[E];if(y)for(const{mac:u,internal:d}of y)d||(c+=1,this._isVirtualMachineMacAddress(u.toUpperCase())&&(v+=1))}this._value=c>0?v/c:0}return this._value}};let R;async function I(v){return R||(R=(async()=>await g(v)||A.generateUuid())()),R}e.getMachineId=I;async function g(v){try{const c=await new Promise((E,y)=>{te(["crypto"],E,y)}),m=(0,O.getMac)();return c.createHash("sha256").update(m,"utf8").digest("hex")}catch(c){v(c);return}}const P="Software\\Microsoft\\SQMClient";async function b(v){if(L.isWindows){const c=await new Promise((m,E)=>{te(["@vscode/windows-registry"],m,E)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(m){return v(m),""}}return""}e.getSqmMachineId=b}),define(oe[31],ae([0,1,53,36,267,6,48,88,16,5,19,10]),function(te,e,k,U,A,O,L,R,I,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function c(G,X=v.UNLINK,x){if((0,L.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");return X===v.UNLINK?E(G):m(G,x)}async function m(G,X=(0,L.randomPath)((0,U.tmpdir)())){try{try{await k.promises.rename(G,X)}catch(x){return x.code==="ENOENT"?void 0:E(G)}E(X).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function E(G){return(0,A.promisify)(k.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function y(G){if((0,L.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function u(G,X){return f(await(X?d(G):(0,A.promisify)(k.readdir)(G)))}async function d(G){try{return await(0,A.promisify)(k.readdir)(G,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const X=[],x=await u(G);for(const Y of x){let B=!1,z=!1,ee=!1;try{const ie=await e.Promises.lstat((0,I.join)(G,Y));B=ie.isFile(),z=ie.isDirectory(),ee=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}X.push({name:Y,isFile:()=>B,isDirectory:()=>z,isSymbolicLink:()=>ee})}return X}function h(G){return f(k.readdirSync(G))}e.readdirSync=h;function f(G){return G.map(X=>typeof X=="string"?g.isMacintosh?(0,R.normalizeNFC)(X):X:(X.name=g.isMacintosh?(0,R.normalizeNFC)(X.name):X.name,X))}async function C(G){const X=await u(G),x=[];for(const Y of X)await o.existsDirectory((0,I.join)(G,Y))&&x.push(Y);return x}function s(G,X=1e3){return new Promise(x=>{let Y=!1;const B=setInterval(()=>{Y||(Y=!0,k.access(G,z=>{Y=!1,z&&(clearInterval(B),x(void 0))}))},X)})}e.whenDeleted=s;var o;(function(G){async function X(B){let z;try{if(z=await e.Promises.lstat(B),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(g.isWindows&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ie}throw ee}}G.stat=X;async function x(B){try{const{stat:z,symbolicLink:ee}=await G.stat(B);return z.isFile()&&ee?.dangling!==!0}catch{}return!1}G.existsFile=x;async function Y(B){try{const{stat:z,symbolicLink:ee}=await G.stat(B);return z.isDirectory()&&ee?.dangling!==!0}catch{}return!1}G.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const n=new O.ResourceQueue;function i(G,X,x){return n.queueFor(b.URI.file(G),P.extUriBiasedIgnorePathCase).queue(()=>{const Y=p(x);return new Promise((B,z)=>a(G,X,Y,ee=>ee?z(ee):B()))})}let t=!0;function r(G){t=G}e.configureFlushOnWrite=r;function a(G,X,x,Y){if(!t)return k.writeFile(G,X,{mode:x.mode,flag:x.flag},Y);k.open(G,x.flag,x.mode,(B,z)=>{if(B)return Y(B);k.writeFile(z,X,ee=>{if(ee)return k.close(z,()=>Y(ee));k.fdatasync(z,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),r(!1)),k.close(z,Z=>Y(Z))))})})}function w(G,X,x){const Y=p(x);if(!t)return k.writeFileSync(G,X,{mode:Y.mode,flag:Y.flag});const B=k.openSync(G,Y.flag,Y.mode);try{k.writeFileSync(B,X);try{k.fdatasyncSync(B)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r(!1)}}finally{k.closeSync(B)}}e.writeFileSync=w;function p(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function l(G,X,x=6e4){if(G!==X)try{g.isWindows&&typeof x=="number"?await S(G,X,Date.now(),x):await(0,A.promisify)(k.rename)(G,X)}catch(Y){if(G.toLowerCase()!==X.toLowerCase()&&Y.code==="EXDEV"||G.endsWith("."))await _(G,X,{preserveSymlinks:!1}),await c(G,v.MOVE);else throw Y}}async function S(G,X,x,Y,B=0){try{return await(0,A.promisify)(k.rename)(G,X)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-x>=Y)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${z}`),z;if(B===0){let ee=!1;try{const{stat:ie}=await o.stat(X);ie.isFile()||(ee=!0)}catch{}if(ee)throw z}return await(0,O.timeout)(Math.min(100,B*10)),S(G,X,x,Y,B+1)}}async function _(G,X,x){return $(G,X,{root:{source:G,target:X},options:x,handledSourcePaths:new Set})}const N=511;async function $(G,X,x){if(x.handledSourcePaths.has(G))return;x.handledSourcePaths.add(G);const{stat:Y,symbolicLink:B}=await o.stat(G);if(B){if(x.options.preserveSymlinks)try{return await Q(G,X,x)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(B.dangling)return}return Y.isDirectory()?W(G,X,Y.mode&N,x):q(G,X,Y.mode&N)}async function W(G,X,x,Y){await e.Promises.mkdir(X,{recursive:!0,mode:x});const B=await u(G);for(const z of B)await $((0,I.join)(G,z),(0,I.join)(X,z),Y)}async function q(G,X,x){await e.Promises.copyFile(G,X),await e.Promises.chmod(X,x)}async function Q(G,X,x){let Y=await e.Promises.readlink(G);(0,L.isEqualOrParent)(Y,x.root.source,!g.isLinux)&&(Y=(0,I.join)(x.root.target,Y.substr(x.root.source.length+1))),await e.Promises.symlink(Y,X)}e.Promises=new class{get access(){return(0,A.promisify)(k.access)}get stat(){return(0,A.promisify)(k.stat)}get lstat(){return(0,A.promisify)(k.lstat)}get utimes(){return(0,A.promisify)(k.utimes)}get read(){return(G,X,x,Y,B)=>new Promise((z,ee)=>{k.read(G,X,x,Y,B,(ie,Z,ne)=>ie?ee(ie):z({bytesRead:Z,buffer:ne}))})}get readFile(){return(0,A.promisify)(k.readFile)}get write(){return(G,X,x,Y,B)=>new Promise((z,ee)=>{k.write(G,X,x,Y,B,(ie,Z,ne)=>ie?ee(ie):z({bytesWritten:Z,buffer:ne}))})}get appendFile(){return(0,A.promisify)(k.appendFile)}get fdatasync(){return(0,A.promisify)(k.fdatasync)}get truncate(){return(0,A.promisify)(k.truncate)}get copyFile(){return(0,A.promisify)(k.copyFile)}get open(){return(0,A.promisify)(k.open)}get close(){return(0,A.promisify)(k.close)}get symlink(){return(0,A.promisify)(k.symlink)}get readlink(){return(0,A.promisify)(k.readlink)}get chmod(){return(0,A.promisify)(k.chmod)}get mkdir(){return(0,A.promisify)(k.mkdir)}get unlink(){return(0,A.promisify)(k.unlink)}get rmdir(){return(0,A.promisify)(k.rmdir)}get realpath(){return(0,A.promisify)(k.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return C}get writeFile(){return i}get rm(){return c}get rename(){return l}get copy(){return _}}}),define(oe[143],ae([0,1,53,16,5,27,31]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(v){if(A.isLinux)return v;const c=(0,U.dirname)(v);if(v===c)return v;const m=((0,U.basename)(v)||v).toLowerCase();try{const y=(0,L.readdirSync)(c).filter(u=>u.toLowerCase()===m);if(y.length===1){const u=R(c);if(u)return(0,U.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(m);if(u>=0){const d=R(c);if(d)return(0,U.join)(d,y[u])}}}catch{}return null}e.realcaseSync=R;async function I(v){if(A.isLinux)return v;const c=(0,U.dirname)(v);if(v===c)return v;const m=((0,U.basename)(v)||v).toLowerCase();try{const y=(await L.Promises.readdir(c)).filter(u=>u.toLowerCase()===m);if(y.length===1){const u=await I(c);if(u)return(0,U.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(m);if(u>=0){const d=await I(c);if(d)return(0,U.join)(d,y[u])}}}catch{}return null}e.realcase=I;async function g(v){try{return await L.Promises.realpath(v)}catch{const m=b(v);return await L.Promises.access(m,k.constants.R_OK),m}}e.realpath=g;function P(v){try{return k.realpathSync(v)}catch{const m=b(v);return k.accessSync(m,k.constants.R_OK),m}}e.realpathSync=P;function b(v){return(0,O.rtrim)((0,U.normalize)(v),U.sep)}}),define(oe[144],ae([0,1,16,5,37,90,12,31]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function I(b=A.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function g(b){let v=[],c=!1;const m=function(E){if(c){v.push(E);return}(!b.send(E,u=>{if(u&&console.error(u),c=!1,v.length>0){const d=v.slice(0);v=[],d.forEach(h=>m(h))}})||U.isWindows)&&(c=!0)};return{send:m}}e.createQueuedSender=g;var P;(function(b){async function v(c,m,E){if(k.isAbsolute(c))return c;if(m===void 0&&(m=A.cwd()),k.dirname(c)!=="."||(E===void 0&&L.isString(A.env.PATH)&&(E=A.env.PATH.split(k.delimiter)),E===void 0||E.length===0))return k.join(m,c);async function u(d){if(await R.Promises.exists(d)){let h;try{h=await R.Promises.stat(d)}catch(f){f.message.startsWith("EACCES")&&(h=await R.Promises.lstat(d))}return h?!h.isDirectory():!1}return!1}for(const d of E){let h;if(k.isAbsolute(d)?h=k.join(d,c):h=k.join(m,d,c),await u(h))return h;let f=h+".com";if(await u(f)||(f=h+".exe",await u(f)))return f}return k.join(m,c)}b.findExecutable=v})(P||(e.win32=P={}))}),define(oe[145],ae([0,1,65,23]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(L){return new Promise((R,I)=>{let g;const P=new Map;function b(c,m,E,y,u){const d=P.get(m);if(c===L||d){const h={name:v(E),cmd:E,pid:c,ppid:m,load:y,mem:u};P.set(c,h),c===L&&(g=h),d&&(d.children||(d.children=[]),d.children.push(h),d.children.length>1&&(d.children=d.children.sort((f,C)=>f.pid-C.pid)))}}function v(c){const m=/--utility-sub-type=network/i,E=/--ms-enable-electron-run-as-node/i,y=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(y.exec(c))return"electron-crash-reporter";if(u.exec(c))return"winpty-agent";if(d.exec(c))return"conpty-agent";let f=h.exec(c);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?m.exec(c)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const C=/[a-zA-Z-]+\.js/g;let s="";do f=C.exec(c),f&&(s+=f+" ");while(f);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:E.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,E)=>{te(["@vscode/windows-process-tree"],m,E)}).then(m=>{m.getProcessList(L,E=>{if(!E){I(new Error(`Root process ${L} not found`));return}m.getProcessCpuUsage(E,y=>{const u=new Map;y.forEach(d=>{const h=c(d.commandLine||"");u.set(d.pid,{name:v(h),cmd:h,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),g=u.get(L),g?(u.forEach(d=>{const h=u.get(d.ppid);h&&(h.children||(h.children=[]),h.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((h,f)=>h.pid-f.pid))}),R(g)):I(new Error(`Root process ${L} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let c=function(){let m=[g];const E=[];for(;m.length;){const u=m.shift();u&&(E.push(u.pid),u.children&&(m=m.concat(u.children)))}let y=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+E.join(" "),(0,k.exec)(y,{},(u,d,h)=>{if(u||h)I(u||new Error(h.toString()));else{const f=d.toString().split(`
`);for(let C=0;C<E.length;C++){const s=P.get(E[C]);s.load=parseFloat(f[C])}if(!g){I(new Error(`Root process ${L} not found`));return}R(g)}})};(0,k.exec)("which ps",{},(m,E,y)=>{if(m||y)if(process.platform!=="linux")I(m||new Error(y.toString()));else{const u=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(u,{},(d,h,f)=>{d||f?I(d||new Error(f.toString())):(O(h,b),c())})}else{const u=E.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${u} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,f,C)=>{h||C&&!C.includes("screen size is bogus")?I(h||new Error(C.toString())):(O(f,b),process.platform==="linux"?c():g?R(g):I(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=A;function O(L,R){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=L.toString().split(`
`);for(const P of g){const b=I.exec(P.trim());b&&b.length===6&&R(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var ye=this&&this.__decorate||function(te,e,k,U){var A=arguments.length,O=A<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,k):U,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(te,e,k,U);else for(var R=te.length-1;R>=0;R--)(L=te[R])&&(O=(A<3?L(O):A>3?L(e,k,O):L(e,k))||O);return A>3&&O&&Object.defineProperty(e,k,O),O};define(oe[42],ae([0,1,18,6,15,26,84,7,3,2,64,27,12]),function(te,e,k,U,A,O,L,R,I,g,P,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var c;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(c||(c={}));function m(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(E||(E={}));function y(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(u||(u={}));function d(B){let z=0;for(let ee=0;;ee+=7){const ie=B.read(1);if(z|=(ie.buffer[0]&127)<<ee,!(ie.buffer[0]&128))return z}}const h=n(0);function f(B,z){if(z===0){B.write(h);return}let ee=0;for(let Z=z;Z!==0;Z=Z>>>7)ee++;const ie=A.VSBuffer.alloc(ee);for(let Z=0;z!==0;Z++)ie.buffer[Z]=z&127,z=z>>>7,z>0&&(ie.buffer[Z]|=128);B.write(ie)}class C{constructor(z){this.buffer=z,this.pos=0}read(z){const ee=this.buffer.slice(this.pos,this.pos+z);return this.pos+=ee.byteLength,ee}}e.BufferReader=C;class s{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}e.BufferWriter=s;var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(o||(o={}));function n(B){const z=A.VSBuffer.alloc(1);return z.writeUInt8(B,0),z}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(B,z){if(typeof z>"u")B.write(i.Undefined);else if(typeof z=="string"){const ee=A.VSBuffer.fromString(z);B.write(i.String),f(B,ee.byteLength),B.write(ee)}else if(t&&Buffer.isBuffer(z)){const ee=A.VSBuffer.wrap(z);B.write(i.Buffer),f(B,ee.byteLength),B.write(ee)}else if(z instanceof A.VSBuffer)B.write(i.VSBuffer),f(B,z.byteLength),B.write(z);else if(Array.isArray(z)){B.write(i.Array),f(B,z.length);for(const ee of z)r(B,ee)}else if(typeof z=="number"&&(z|0)===z)B.write(i.Uint),f(B,z);else{const ee=A.VSBuffer.fromString(JSON.stringify(z));B.write(i.Object),f(B,ee.byteLength),B.write(ee)}}e.serialize=r;function a(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(d(B)).toString();case o.Buffer:return B.read(d(B)).buffer;case o.VSBuffer:return B.read(d(B));case o.Array:{const ee=d(B),ie=[];for(let Z=0;Z<ee;Z++)ie.push(a(B));return ie}case o.Object:return JSON.parse(B.read(d(B)).toString());case o.Int:return d(B)}}e.deserialize=a;class w{constructor(z,ee,ie=null,Z=1e3){this.protocol=z,this.ctx=ee,this.logger=ie,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:200})}registerChannel(z,ee){this.channels.set(z,ee),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const ee=this.send([z.type]);this.logger?.logOutgoing(ee,0,1,y(z.type));return}case 201:case 202:case 204:case 203:{const ee=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(ee,z.id,1,y(z.type),z.data);return}}}send(z,ee=void 0){const ie=new s;return r(ie,z),r(ie,ee),this.sendBuffer(ie.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const ee=new C(z),ie=a(ee),Z=a(ee),ne=ie[0];switch(ne){case 100:return this.logger?.logIncoming(z.byteLength,ie[1],1,`${m(ne)}: ${ie[2]}.${ie[3]}`,Z),this.onPromise({type:ne,id:ie[1],channelName:ie[2],name:ie[3],arg:Z});case 102:return this.logger?.logIncoming(z.byteLength,ie[1],1,`${m(ne)}: ${ie[2]}.${ie[3]}`,Z),this.onEventListen({type:ne,id:ie[1],channelName:ie[2],name:ie[3],arg:Z});case 101:return this.logger?.logIncoming(z.byteLength,ie[1],1,`${m(ne)}`),this.disposeActiveRequest({type:ne,id:ie[1]});case 103:return this.logger?.logIncoming(z.byteLength,ie[1],1,`${m(ne)}`),this.disposeActiveRequest({type:ne,id:ie[1]})}}onPromise(z){const ee=this.channels.get(z.channelName);if(!ee){this.collectPendingRequest(z);return}const ie=new O.CancellationTokenSource;let Z;try{Z=ee.call(this.ctx,z.name,z.arg,ie.token)}catch(j){Z=Promise.reject(j)}const ne=z.id;Z.then(j=>{this.sendResponse({id:ne,data:j,type:201})},j=>{j instanceof Error?this.sendResponse({id:ne,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:ne,data:j,type:203})}).finally(()=>{K.dispose(),this.activeRequests.delete(z.id)});const K=(0,g.toDisposable)(()=>ie.cancel());this.activeRequests.set(z.id,K)}onEventListen(z){const ee=this.channels.get(z.channelName);if(!ee){this.collectPendingRequest(z);return}const ie=z.id,ne=ee.listen(this.ctx,z.name,z.arg)(K=>this.sendResponse({id:ie,data:K,type:204}));this.activeRequests.set(z.id,ne)}disposeActiveRequest(z){const ee=this.activeRequests.get(z.id);ee&&(ee.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let ee=this.pendingRequests.get(z.channelName);ee||(ee=[],this.pendingRequests.set(z.channelName,ee));const ie=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ee.push({request:z,timeoutTimer:ie})}flushPendingRequests(z){const ee=this.pendingRequests.get(z);if(ee){for(const ie of ee)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=w;var p;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class l{constructor(z,ee=null){this.protocol=z,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=ee}getChannel(z){const ee=this;return{call(ie,Z,ne){return ee.isDisposed?Promise.reject(new R.CancellationError):ee.requestPromise(z,ie,Z,ne)},listen(ie,Z){return ee.isDisposed?I.Event.None:ee.requestEvent(z,ie,Z)}}}requestPromise(z,ee,ie,Z=O.CancellationToken.None){const ne=this.lastRequestId++,j={id:ne,type:100,channelName:z,name:ee,arg:ie};if(Z.isCancellationRequested)return Promise.reject(new R.CancellationError);let D;return new Promise((M,F)=>{if(Z.isCancellationRequested)return F(new R.CancellationError);const V=()=>{const he=ue=>{switch(ue.type){case 201:this.handlers.delete(ne),M(ue.data);break;case 202:{this.handlers.delete(ne);const me=new Error(ue.data.message);me.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,me.name=ue.data.name,F(me);break}case 203:this.handlers.delete(ne),F(ue.data);break}};this.handlers.set(ne,he),this.sendRequest(j)};let H=null;this.state===u.Idle?V():(H=(0,U.createCancelablePromise)(he=>this.whenInitialized()),H.then(()=>{H=null,V()}));const re=()=>{H?(H.cancel(),H=null):this.sendRequest({id:ne,type:101}),F(new R.CancellationError)},ce=Z.onCancellationRequested(re);D=(0,g.combinedDisposable)((0,g.toDisposable)(re),ce),this.activeRequests.add(D)}).finally(()=>{D.dispose(),this.activeRequests.delete(D)})}requestEvent(z,ee,ie){const Z=this.lastRequestId++,K={id:Z,type:102,channelName:z,name:ee,arg:ie};let j=null;const D=new I.Emitter({onWillAddFirstListener:()=>{j=(0,U.createCancelablePromise)(M=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(D),this.sendRequest(K)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(D),this.sendRequest({id:Z,type:103}))}}),T=M=>D.fire(M.data);return this.handlers.set(Z,T),D.event}sendRequest(z){switch(z.type){case 100:case 102:{const ee=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(ee,z.id,0,`${m(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const ee=this.send([z.type,z.id]);this.logger?.logOutgoing(ee,z.id,0,m(z.type));return}}}send(z,ee=void 0){const ie=new s;return r(ie,z),r(ie,ee),this.sendBuffer(ie.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const ee=new C(z),ie=a(ee),Z=a(ee),ne=ie[0];switch(ne){case 200:return this.logger?.logIncoming(z.byteLength,0,0,y(ne)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(z.byteLength,ie[1],0,y(ne),Z),this.onResponse({type:ie[0],id:ie[1],data:Z})}}onResponse(z){if(z.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=l,ye([L.memoize],l.prototype,"onDidInitializePromise",null);class S{get connections(){const z=[];return this._connections.forEach(ee=>z.push(ee)),z}constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new g.DisposableStore,this.disposables.add(z(({protocol:ee,onDidClientDisconnect:ie})=>{const Z=I.Event.once(ee.onMessage);this.disposables.add(Z(ne=>{const K=new C(ne),j=a(K),D=new w(ee,j),T=new l(ee);this.channels.forEach((F,V)=>D.registerChannel(V,F));const M={channelServer:D,channelClient:T,ctx:j};this._connections.add(M),this._onDidAddConnection.fire(M),this.disposables.add(ie(()=>{D.dispose(),T.dispose(),this._connections.delete(M),this._onDidRemoveConnection.fire(M)}))}))}))}getChannel(z,ee){const ie=this;return{call(Z,ne,K){let j;if((0,v.isFunction)(ee)){const T=(0,k.getRandomElement)(ie.connections.filter(ee));j=T?Promise.resolve(T):I.Event.toPromise(I.Event.filter(ie.onDidAddConnection,ee))}else j=ee.routeCall(ie,Z,ne);const D=j.then(T=>T.channelClient.getChannel(z));return N(D).call(Z,ne,K)},listen(Z,ne){if((0,v.isFunction)(ee))return ie.getMulticastEvent(z,ee,Z,ne);const K=ee.routeEvent(ie,Z,ne).then(j=>j.channelClient.getChannel(z));return N(K).listen(Z,ne)}}}getMulticastEvent(z,ee,ie,Z){const ne=this;let K;const j=new I.Emitter({onWillAddFirstListener:()=>{K=new g.DisposableStore;const D=new I.EventMultiplexer,T=new Map,M=V=>{const re=V.channelClient.getChannel(z).listen(ie,Z),ce=D.add(re);T.set(V,ce)},F=V=>{const H=T.get(V);H&&(H.dispose(),T.delete(V))};ne.connections.filter(ee).forEach(M),I.Event.filter(ne.onDidAddConnection,ee)(M,void 0,K),ne.onDidRemoveConnection(F,void 0,K),D.event(j.fire,j,K),K.add(D)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return j.event}registerChannel(z,ee){this.channels.set(z,ee);for(const ie of this._connections)ie.channelServer.registerChannel(z,ee)}dispose(){this.disposables.dispose();for(const z of this._connections)z.channelClient.dispose(),z.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=S;class _{constructor(z,ee,ie=null){const Z=new s;r(Z,ee),z.send(Z.buffer),this.channelClient=new l(z,ie),this.channelServer=new w(z,ee,ie)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,ee){this.channelServer.registerChannel(z,ee)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function N(B){return{call(z,ee,ie){return B.then(Z=>Z.call(z,ee,ie))},listen(z,ee){const ie=new I.Relay;return B.then(Z=>ie.input=Z.listen(z,ee)),ie.event}}}e.getDelayedChannel=N;function $(B){let z=!1;return{call(ee,ie,Z){return z?B.call(ee,ie,Z):(0,U.timeout)(0).then(()=>z=!0).then(()=>B.call(ee,ie,Z))},listen(ee,ie){if(z)return B.listen(ee,ie);const Z=new I.Relay;return(0,U.timeout)(0).then(()=>z=!0).then(()=>Z.input=B.listen(ee,ie)),Z.event}}}e.getNextTickChannel=$;class W{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const ee of z.connections)if(await Promise.resolve(this.fn(ee.ctx)))return Promise.resolve(ee);return await I.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=W;var q;(function(B){function z(ne,K,j){const D=ne,T=j&&j.disableMarshalling,M=new Map;for(const F in D)ie(F)&&M.set(F,I.Event.buffer(D[F],!0,void 0,K));return new class{listen(F,V,H){const re=M.get(V);if(re)return re;if(Z(V)){const ce=D[V];if(typeof ce=="function")return ce.call(D,H)}throw new R.ErrorNoTelemetry(`Event not found: ${V}`)}call(F,V,H){const re=D[V];if(typeof re=="function"){if(!T&&Array.isArray(H))for(let he=0;he<H.length;he++)H[he]=(0,P.revive)(H[he]);let ce=re.apply(D,H);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new R.ErrorNoTelemetry(`Method not found: ${V}`)}}}B.fromService=z;function ee(ne,K){const j=K&&K.disableMarshalling;return new Proxy({},{get(D,T){if(typeof T=="string")return K?.properties?.has(T)?K.properties.get(T):Z(T)?function(M){return ne.listen(T,M)}:ie(T)?ne.listen(T):async function(...M){let F;K&&!(0,v.isUndefinedOrNull)(K.context)?F=[K.context,...M]:F=M;const V=await ne.call(T,F);return j?V:(0,P.revive)(V)};throw new R.ErrorNoTelemetry(`Property not found: ${String(T)}`)}})}B.toService=ee;function ie(ne){return ne[0]==="o"&&ne[1]==="n"&&b.isUpperAsciiLetter(ne.charCodeAt(2))}function Z(ne){return/^onDynamic/.test(ne)&&b.isUpperAsciiLetter(ne.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const z=B.toString();if(z!=="[object Object]")return z}return B}function X(B){return Array.isArray(B)?B.map(G):G(B)}function x(B,z,ee,ie,Z,ne,K){K=X(K);const j=Q[Z],D=j[ie%j.length];let T=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(ne)?(T=T.concat(K),T.push(")")):T.push(K),console.log.apply(console,T)}class Y{constructor(z,ee){this._outgoingPrefix=z,this._incomingPrefix=ee,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,ee,ie,Z,ne){this._totalOutgoing+=z,x(this._outgoingPrefix,this._totalOutgoing,z,ee,ie,Z,ne)}logIncoming(z,ee,ie,Z,ne){this._totalIncoming+=z,x(this._incomingPrefix,this._totalIncoming,z,ee,ie,Z,ne)}}e.IPCLogger=Y}),define(oe[66],ae([0,1,15,3,2,42]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function a(p,l){if(!t.has(p)){const S=String(++r);t.set(p,S)}return t.get(p)}function w(p,l,S,_){if(!i.enableDiagnostics)return;const N=a(p,l);if(_ instanceof k.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const $=k.VSBuffer.alloc(_.byteLength);$.set(_),i.records.push({timestamp:Date.now(),id:N,label:l,type:S,buff:$})}else i.records.push({timestamp:Date.now(),id:N,label:l,type:S,data:_})}i.traceSocketEvent=w})(R||(e.SocketDiagnostics=R={}));var I;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I||(e.SocketCloseEventType=I={}));let g=null;function P(){return g||(g=k.VSBuffer.alloc(0)),g}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,r){if(t===0)return P();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const l=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=t),l}if(this._chunks[0].byteLength>t){const l=this._chunks[0].slice(0,t);return r&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),l}const a=k.VSBuffer.alloc(t);let w=0,p=0;for(;t>0;){const l=this._chunks[p];if(l.byteLength>t){const S=l.slice(0,t);a.set(S,w),w+=t,r&&(this._chunks[p]=l.slice(t),this._totalLength-=t),t-=t}else a.set(l,w),w+=l.byteLength,r?(this._chunks.shift(),this._totalLength-=l.byteLength):p++,t-=l.byteLength}return a}}e.ChunkStream=b;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class E{constructor(t,r,a,w){this.type=t,this.id=r,this.ack=a,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends A.Disposable{constructor(t){super(),this._onMessage=this._register(new U.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:c(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,w=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new E(a,w,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(t){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=k.VSBuffer.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",t.data),this._writeSoon(r,t.data)}_bufferAdd(t,r){const a=this._totalLength===0;return this._data.push(t,r),this._totalLength+=t.byteLength+r.byteLength,a}_bufferTake(){const t=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,r){this._bufferAdd(t,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const t=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this._socket.write(t)}}class d extends A.Disposable{constructor(t){super(),this._onMessage=new U.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new U.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new E(1,0,0,t))}}e.Protocol=d;class h extends O.IPCClient{static fromSocket(t,r){return new h(new d(t),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.protocol=t}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=h;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new U.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class C{constructor(t){this.data=t,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let t=0,r=this._first;for(;r;)r=r.next,t++;return t}peek(){return this._first?this._first.data:null}toArray(){const t=[];let r=0,a=this._first;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const r=new C(t);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const t=Date.now();for(let r=0;r<o._HISTORY_LENGTH;r++)this.lastRuns[r]=t-1e3*r;setInterval(()=>{for(let r=o._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const t=Date.now(),r=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let w=0;w<o._HISTORY_LENGTH;w++)t-this.lastRuns[w]<=r&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(t){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=t.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=t.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=t.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new y(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),t.initialChunk&&this._socketReader.acceptChunk(t.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new E(5,0,0,P());this._socketWriter.write(t),this._socketWriter.flush()}sendPause(){const t=new E(7,0,0,P());this._socketWriter.write(t)}sendResume(){const t=new E(8,0,0,P());this._socketWriter.write(t)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=t,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new y(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const t=new E(3,0,this._incomingAckId,P());this._socketWriter.write(t);const r=this._outgoingUnackMsg.toArray();for(let a=0,w=r.length;a<w;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new E(6,0,0,P())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data);break}case 2:{this._onControlMessage.fire(t.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let a=0,w=r.length;a<w;a++)this._socketWriter.write(r[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new E(1,r,this._incomingAckId,t);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(t){const r=new E(2,0,0,t);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this._socketReader.lastReadTime,w=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&a>=2e4&&w>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const p=Math.max(2e4-r,2e4-a,2e4-w,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new E(3,0,this._incomingAckId,P());this._socketWriter.write(t)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const t=new E(9,0,this._incomingAckId,P());this._socketWriter.write(t)}}e.PersistentProtocol=n}),define(oe[93],ae([0,1,65,6,15,26,140,7,3,2,30,144,90,42]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends c.ChannelServer{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",d=>A.VSBuffer.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=m;class E{constructor(u,d){this.modulePath=u,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new U.Delayer(h),this.child=null,this._client=null}getChannel(u){const d=this;return{call(h,f,C){return d.requestPromise(u,h,f,C)},listen(h,f){return d.requestEvent(u,h,f)}}}requestPromise(u,d,h,f=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const C=this.getCachedChannel(u),s=(0,U.createCancelablePromise)(i=>C.call(d,h,i)),o=f.onCancellationRequested(()=>s.cancel()),n=(0,g.toDisposable)(()=>s.cancel());return this.activeRequests.add(n),s.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(u,d,h){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let f;const C=new I.Emitter({onWillAddFirstListener:()=>{f=this.getCachedChannel(u).listen(d,h)(C.fire,C),this.activeRequests.add(f)},onDidRemoveLastListener:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return C.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(d.env),this.child=(0,k.fork)(this.modulePath,u,d);const h=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,L.isRemoteConsoleLog)(t)){(0,L.log)(t,`IPC Library: ${this.options.serverName}`);return}h.fire(A.VSBuffer.wrap(Buffer.from(t,"base64")))});const C=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,s=t=>this.child&&this.child.connected&&C.send(t.buffer.toString("base64")),o=h.event,n={send:s,onMessage:o};this._client=new c.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,g.dispose)(a)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(u){let d=this.channels.get(u);return d||(d=this.client.getChannel(u),this.channels.set(u,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(oe[146],ae([0,1,133,15,42,3,12,18]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(v){this.port=v,this.onMessage=O.Event.fromNodeEventEmitter(this.port,"message",c=>U.VSBuffer.wrap(c.data)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}class g extends A.IPCServer{static getOnDidClientConnect(v){(0,L.assertType)((0,k.isUtilityProcess)(process),"Electron Utility Process");const c=new O.Emitter;return process.parentPort.on("message",m=>{if(v?.handledClientConnection(m))return;const E=(0,R.firstOrDefault)(m.ports);E&&c.fire(E)}),O.Event.map(c.event,m=>({protocol:new I(m),onDidClientDisconnect:O.Event.fromNodeEventEmitter(m,"close")}))}constructor(v){super(g.getOnDidClientConnect(v))}}e.Server=g;function P(b,v,c){const m=E=>{E.data===v&&(b.removeListener("message",m),c())};b.on("message",m)}e.once=P}),define(oe[67],ae([0,1,6,3,2,64,12]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function I(v){const c=v;return c?.changed instanceof Map||c?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var g;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(g||(e.StorageState=g={}));class P extends A.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(c,m=Object.create(null)){super(),this.database=c,this.options=m,this._onDidChangeStorage=this._register(new U.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=this._register(new k.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){this._onDidChangeStorage.pause();try{c.changed?.forEach((m,E)=>this.acceptExternal(E,m)),c.deleted?.forEach(m=>this.acceptExternal(m,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(c,m){if(this.state===g.Closed)return;let E=!1;(0,L.isUndefinedOrNull)(m)?E=this.cache.delete(c):this.cache.get(c)!==m&&(this.cache.set(c,m),E=!0),E&&this._onDidChangeStorage.fire({key:c,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,m){const E=this.cache.get(c);return(0,L.isUndefinedOrNull)(E)?m:E}getBoolean(c,m){const E=this.get(c);return(0,L.isUndefinedOrNull)(E)?m:E==="true"}getNumber(c,m){const E=this.get(c);return(0,L.isUndefinedOrNull)(E)?m:parseInt(E,10)}getObject(c,m){const E=this.get(c);return(0,L.isUndefinedOrNull)(E)?m:(0,O.parse)(E)}async set(c,m,E=!1){if(this.state===g.Closed)return;if((0,L.isUndefinedOrNull)(m))return this.delete(c,E);const y=(0,L.isObject)(m)||Array.isArray(m)?(0,O.stringify)(m):String(m);if(this.cache.get(c)!==y)return this.cache.set(c,y),this.pendingInserts.set(c,y),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire({key:c,external:E}),this.doFlush()}async delete(c,m=!1){if(!(this.state===g.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire({key:c,external:m}),this.doFlush()}async optimize(){if(this.state!==g.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(this.hasPending)return this.doFlush(c)}async doFlush(c){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=P;class b{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert?.forEach((m,E)=>this.items.set(E,m)),c.delete?.forEach(m=>this.items.delete(m))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=b}),define(oe[147],ae([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[148],ae([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[149],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[150],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[151],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[152],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[153],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[154],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[155],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[156],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[157],ae([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[158],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[159],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[160],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[161],ae([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[162],ae([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[163],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[164],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[165],ae([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[166],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[167],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[168],ae([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[169],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[170],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[171],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[172],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[173],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[174],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[175],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[176],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[177],ae([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[178],ae([0,1,7,150]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...g){switch(g.length){case 1:return(0,U.localize)(0,null,g[0]);case 2:return(0,U.localize)(1,null,g[0],g[1]);case 3:return(0,U.localize)(2,null,g[0],g[1],g[2]);default:return}}const L=(0,U.localize)(3,null),R=(0,U.localize)(4,null);class I{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,k.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const b=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:b})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const b=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:b})}else this._match(126)?this._addToken(9):this._error(O("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(O("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const b=this._start,v=this._input.substring(this._start,this._current),c={type:19,offset:this._start,lexeme:v};this._errors.push({offset:b,lexeme:v,additionalInfo:P}),this._tokens.push(c)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const b=this._input.substring(this._start,this._current),v=I._keywords.get(b);v?this._addToken(v):this._tokens.push({type:17,lexeme:b,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(L);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,b=!1,v=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(R);return}const m=this._input.charCodeAt(P);if(b)b=!1;else if(m===47&&!v){P++;break}else m===91?v=!0:m===92?b=!0:m===93&&(v=!1);P++}for(;P<this._input.length&&I._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const c=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:c,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=I}),define(oe[179],ae([0,1,63,84,23,16,37,19,10]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,O.dirname)(A.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",c)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(I.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=L.env.VSCODE_PORTABLE;return c?I.URI.file((0,O.join)(c,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,O.resolve)(c):(0,O.normalize)((0,O.join)(A.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?I.URI.file((0,O.resolve)(c)):I.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,O.resolve)(c);const m=L.env.VSCODE_EXTENSIONS;if(m)return m;const E=L.env.VSCODE_PORTABLE;return E?(0,O.join)(E,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(m=>/^[^:/?#]+?:\/\//.test(m)?I.URI.parse(m):I.URI.file((0,O.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?I.URI.parse(c):I.URI.file((0,O.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(c))}get extensionLogLevel(){const c=[];for(const m of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);E&&E[1]&&E[2]&&c.push([E[1],E[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=L.env.VSCODE_PORTABLE;return c?I.URI.file((0,O.join)(c,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this._args}constructor(c,m,E){this._args=c,this.paths=m,this.productService=E,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=g,ye([U.memoize],g.prototype,"appRoot",null),ye([U.memoize],g.prototype,"userHome",null),ye([U.memoize],g.prototype,"userDataPath",null),ye([U.memoize],g.prototype,"appSettingsHome",null),ye([U.memoize],g.prototype,"tmpDir",null),ye([U.memoize],g.prototype,"cacheHome",null),ye([U.memoize],g.prototype,"stateResource",null),ye([U.memoize],g.prototype,"userRoamingDataHome",null),ye([U.memoize],g.prototype,"userDataSyncHome",null),ye([U.memoize],g.prototype,"sync",null),ye([U.memoize],g.prototype,"machineSettingsResource",null),ye([U.memoize],g.prototype,"workspaceStorageHome",null),ye([U.memoize],g.prototype,"localHistoryHome",null),ye([U.memoize],g.prototype,"keyboardLayoutResource",null),ye([U.memoize],g.prototype,"argvResource",null),ye([U.memoize],g.prototype,"isExtensionDevelopment",null),ye([U.memoize],g.prototype,"untitledWorkspacesHome",null),ye([U.memoize],g.prototype,"builtinExtensionsPath",null),ye([U.memoize],g.prototype,"extensionsPath",null),ye([U.memoize],g.prototype,"extensionDevelopmentLocationURI",null),ye([U.memoize],g.prototype,"extensionDevelopmentKind",null),ye([U.memoize],g.prototype,"extensionTestsLocationURI",null),ye([U.memoize],g.prototype,"debugExtensionHost",null),ye([U.memoize],g.prototype,"logLevel",null),ye([U.memoize],g.prototype,"extensionLogLevel",null),ye([U.memoize],g.prototype,"serviceMachineIdResource",null),ye([U.memoize],g.prototype,"disableTelemetry",null),ye([U.memoize],g.prototype,"disableWorkspaceTrust",null),ye([U.memoize],g.prototype,"useInMemorySecretStorage",null),ye([U.memoize],g.prototype,"policyFile",null);function P(v,c){return b(v["inspect-extensions"],v["inspect-brk-extensions"],5870,c,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function b(v,c,m,E,y,u){const h=Number(c||v)||(E?null:m),f=h?!!c:!1;let C;if(u)try{C=JSON.parse(u)}catch{}return{port:h,break:f,debugId:y,env:C}}e.parseDebugParams=b}),function(){"use strict";function te(e,k,U){function A(L,R){const I=O(L,R),g=[I];return e.isAbsolute(I)||g.unshift(U),e.resolve(...g)}function O(L,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const P=L["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(b,"AppData","Roaming")}break;case"darwin":g=e.join(k.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:A}}if(typeof define=="function")define(oe[180],ae([268,36,37]),function(e,k,U){return te(e,k,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=te(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[181],ae([0,1,36,179,180]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class O extends U.AbstractNativeEnvironmentService{constructor(g,P){super(g,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,A.getUserDataPath)(g,P.nameShort)},P)}}e.NativeEnvironmentService=O;function L(I,g){return(0,U.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,g,I.extensionEnvironment)}e.parsePtyHostDebugPort=L;function R(I,g){return(0,U.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,g,I.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(oe[182],ae([0,1,12,153]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function A(L,R,I,g){try{O(L,R,I,g)}catch(P){L.error(P?.message??P)}return R}e.localizeManifest=A;function O(L,R,I,g){const P=(b,v,c)=>{const m=b[v];if((0,k.isString)(m)){const E=m,y=E.length;if(y>1&&E[0]==="%"&&E[y-1]==="%"){const u=E.substr(1,y-2);let d=I[u];d===void 0&&g&&(d=g[u]);const h=typeof d=="string"?d:d?.message,f=g?.[u],C=typeof f=="string"?f:f?.message;if(!h){C||L.warn(`[${R.name}]: ${(0,U.localize)(0,null,u)}`);return}if(c&&(v==="title"||v==="category")&&C&&C!==h){const s={value:h,original:C};b[v]=s}else b[v]=h}}else if((0,k.isObject)(m))for(const E in m)m.hasOwnProperty(E)&&(E==="commands"?P(m,E,!0):P(m,E,c));else if(Array.isArray(m))for(let E=0;E<m.length;E++)P(m,E,c)};for(const b in R)R.hasOwnProperty(b)&&P(R,b)}}),define(oe[183],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(O){this.channel=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O){return this.channel.call("promptImportantExtensionsInstallNotification",[O])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class U{constructor(O){this.service=O}listen(O,L){throw new Error(`Event not found: ${L}`)}call(O,L,R){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(oe[68],ae([0,1,19,89,157,54]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=I;function g(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(L);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=g;function P(u){if(!u)return null;const d=u.majorBase,h=u.majorMustEqual,f=u.minorBase;let C=u.minorMustEqual;const s=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(d===0||(C=!1),o=!1);let n=0;if(u.preRelease){const i=R.exec(u.preRelease);if(i){const[,t,r,a]=i;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:h,minorBase:f,minorMustEqual:C,patchBase:s,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=P;function b(u,d,h){let f;typeof u=="string"?f=P(g(u)):f=u;let C;d instanceof Date?C=d.getTime():typeof d=="string"&&(C=new Date(d).getTime());let s;if(typeof h=="string"?s=P(g(h)):s=h,!f||!s)return!1;const o=f.majorBase,n=f.minorBase,i=f.patchBase;let t=s.majorBase,r=s.minorBase,a=s.patchBase;const w=s.notBefore;let p=s.majorMustEqual,l=s.minorMustEqual,S=s.patchMustEqual;return s.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||C&&C<w?!1:i>=a:(o===1&&t===0&&(!p||!l||!S)&&(t=1,r=0,a=0,p=!0,l=!1,S=!1),o<t?!1:o>t?!p:n<r?!1:n>r?!l:i<a?!1:i>a?!S:!(C&&C<w))}e.isValidVersion=b;function v(u,d,h,f,C){const s=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return s.push([U.default.Error,A.localize(0,null)]),s;if(typeof f.name!="string")return s.push([U.default.Error,A.localize(1,null,"name")]),s;if(typeof f.version!="string")return s.push([U.default.Error,A.localize(2,null,"version")]),s;if(!f.engines)return s.push([U.default.Error,A.localize(3,null,"engines")]),s;if(typeof f.engines.vscode!="string")return s.push([U.default.Error,A.localize(4,null,"engines.vscode")]),s;if(typeof f.extensionDependencies<"u"&&!y(f.extensionDependencies))return s.push([U.default.Error,A.localize(5,null,"extensionDependencies")]),s;if(typeof f.activationEvents<"u"){if(!y(f.activationEvents))return s.push([U.default.Error,A.localize(6,null,"activationEvents")]),s;if(typeof f.main>"u"&&typeof f.browser>"u")return s.push([U.default.Error,A.localize(7,null,"activationEvents","main","browser")]),s}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&s.push([U.default.Warning,A.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return s.push([U.default.Error,A.localize(9,null,"main")]),s;{const i=(0,k.joinPath)(h,f.main);(0,k.isEqualOrParent)(i,h)||s.push([U.default.Warning,A.localize(10,null,i.path,h.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return s.push([U.default.Error,A.localize(11,null,"browser")]),s;{const i=(0,k.joinPath)(h,f.browser);(0,k.isEqualOrParent)(i,h)||s.push([U.default.Warning,A.localize(12,null,i.path,h.path)])}}if(!O.valid(f.version))return s.push([U.default.Error,A.localize(13,null)]),s;const o=[];if(!c(u,d,f,C,o))for(const i of o)s.push([U.default.Error,i]);return s}e.validateExtensionManifest=v;function c(u,d,h,f,C){return f||typeof h.main>"u"&&typeof h.browser>"u"?!0:E(u,d,h.engines.vscode,C)}e.isValidExtensionVersion=c;function m(u,d,h){return u==="*"||E(d,h,u)}e.isEngineValid=m;function E(u,d,h,f=[]){const C=P(g(h));if(!C)return f.push(A.localize(14,null,h)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return f.push(A.localize(15,null,h)),!1}else if(!C.majorMustEqual)return f.push(A.localize(16,null,h)),!1;return b(u,d,C)?!0:(f.push(A.localize(17,null,u,h)),!1)}function y(u){if(!Array.isArray(u))return!1;for(let d=0,h=u.length;d<h;d++)if(typeof u[d]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(O,L,R){let I=R&&R.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await L.readFile(O.serviceMachineIdResource)).value.toString();I=(0,U.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,U.generateUuid)();try{await L.writeFile(O.serviceMachineIdResource,k.VSBuffer.fromString(I))}catch{}}return R?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=A}),define(oe[69],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(A,O=[],L=!1){this.ctor=A,this.staticArguments=O,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=k}),define(oe[184],ae([0,1,69]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const U=[];var A;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function O(R,I,g){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],!!g)),U.push([R,I])}e.registerSingleton=O;function L(){return U}e.getSingletonServiceDescriptors=L}),define(oe[185],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(O,L){this.key=O,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class U{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const L of this._nodes.values())L.outgoing.size===0&&O.push(L);return O}insertEdge(O,L){const R=this.lookupOrInsertNode(O),I=this.lookupOrInsertNode(L);R.outgoing.set(I.key,I),I.incoming.set(R.key,R)}removeNode(O){const L=this._hashFn(O);this._nodes.delete(L);for(const R of this._nodes.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(O){const L=this._hashFn(O);let R=this._nodes.get(L);return R||(R=new k(L,O),this._nodes.set(L,R)),R}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[L,R]of this._nodes)O.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,L]of this._nodes){const R=new Set([O]),I=this._findCycle(L,R);if(I)return I}}_findCycle(O,L){for(const[R,I]of O.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const g=this._findCycle(I,L);if(g)return g;L.delete(R)}}}e.Graph=U}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(I){return I[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(k||(e._util=k={})),e.IInstantiationService=A("instantiationService");function U(L,R,I){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:L,index:I}):(R[k.DI_DEPENDENCIES]=[{id:L,index:I}],R[k.DI_TARGET]=R)}function A(L){if(k.serviceIds.has(L))return k.serviceIds.get(L);const R=function(I,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(R,I,P)};return R.toString=()=>L,k.serviceIds.set(L,R),R}e.createDecorator=A;function O(L){return L}e.refineServiceDecorator=O}),define(oe[186],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[20],ae([0,1,12,10,4]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function O(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof U.URI)}e.isConfigurationOverrides=O;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof U.URI)}e.isConfigurationUpdateOverrides=L;var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function I(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function g(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.isConfigured=g;function P(u,d){const h=Object.create(null);for(const f in u)b(h,f,u[f],d);return h}e.toValuesTree=P;function b(u,d,h,f){const C=d.split("."),s=C.pop();let o=u;for(let n=0;n<C.length;n++){const i=C[n];let t=o[i];switch(typeof t){case"undefined":t=o[i]=Object.create(null);break;case"object":break;default:f(`Ignoring ${d} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[s]=h}catch{f(`Ignoring ${d} as ${C.join(".")} is ${JSON.stringify(o)}`)}else f(`Ignoring ${d} as ${C.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function v(u,d){const h=d.split(".");c(u,h)}e.removeFromValueTree=v;function c(u,d){const h=d.shift();if(d.length===0){delete u[h];return}if(Object.keys(u).indexOf(h)!==-1){const f=u[h];typeof f=="object"&&!Array.isArray(f)&&(c(f,d),Object.keys(f).length===0&&delete u[h])}}function m(u,d,h){function f(o,n){let i=o;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const C=d.split("."),s=f(u,C);return typeof s>"u"?h:s}e.getConfigurationValue=m;function E(u,d,h){Object.keys(d).forEach(f=>{f!=="__proto__"&&(f in u?k.isObject(u[f])&&k.isObject(d[f])?E(u[f],d[f],h):h&&(u[f]=d[f]):u[f]=d[f])})}e.merge=E;function y(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(oe[94],ae([0,1,5,27,178,4,149,7]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",k.isMacintosh),I.set("isLinux",k.isLinux),I.set("isWindows",k.isWindows),I.set("isWeb",k.isWeb),I.set("isMacNative",k.isMacintosh&&!k.isWeb),I.set("isEdge",k.isEdge),I.set("isFirefox",k.isFirefox),I.set("isChrome",k.isChrome),I.set("isSafari",k.isSafari);function g(j,D){if(I.get(j)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set(j,D)}e.setConstant=g;const P=Object.prototype.hasOwnProperty;var b;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const v={regexParsingWithErrorRecovery:!0},c=(0,L.localize)(0,null),m=(0,L.localize)(1,null),E=(0,L.localize)(2,null),y=(0,L.localize)(3,null),u=(0,L.localize)(4,null),d=(0,L.localize)(5,null),h=(0,L.localize)(6,null),f=(0,L.localize)(7,null);class C{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(D=v){this._config=D,this._scanner=new A.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(D){if(D===""){this._parsingErrors.push({message:c,offset:0,lexeme:"",additionalInfo:m});return}this._tokens=this._scanner.reset(D).scan(),this._current=0,this._parsingErrors=[];try{const T=this._expr();if(!this._isAtEnd()){const M=this._peek(),F=M.type===17?d:void 0;throw this._parsingErrors.push({message:u,offset:M.offset,lexeme:A.Scanner.getLexeme(M),additionalInfo:F}),C._parseError}return T}catch(T){if(T!==C._parseError)throw T;return}}_expr(){return this._or()}_or(){const D=[this._and()];for(;this._matchOne(16);){const T=this._and();D.push(T)}return D.length===1?D[0]:s.or(...D)}_and(){const D=[this._term()];for(;this._matchOne(15);){const T=this._term();D.push(T)}return D.length===1?D[0]:s.and(...D)}_term(){if(this._matchOne(2)){const D=this._peek();switch(D.type){case 11:return this._advance(),t.INSTANCE;case 12:return this._advance(),r.INSTANCE;case 0:{this._advance();const T=this._expr();return this._consume(1,y),T?.negate()}case 17:return this._advance(),_.create(D.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",D)}}return this._primary()}_primary(){const D=this._peek();switch(D.type){case 11:return this._advance(),s.true();case 12:return this._advance(),s.false();case 0:{this._advance();const T=this._expr();return this._consume(1,y),T}case 17:{const T=D.lexeme;if(this._advance(),this._matchOne(9)){const F=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),F.type!==10)throw this._errExpectedButGot("REGEX",F);const V=F.lexeme,H=V.lastIndexOf("/"),re=H===V.length-1?void 0:this._removeFlagsGY(V.substring(H+1));let ce;try{ce=new RegExp(V.substring(1,H),re)}catch{throw this._errExpectedButGot("REGEX",F)}return G.create(T,ce)}switch(F.type){case 10:case 19:{const V=[F.lexeme];this._advance();let H=this._peek(),re=0;for(let fe=0;fe<F.lexeme.length;fe++)F.lexeme.charCodeAt(fe)===40?re++:F.lexeme.charCodeAt(fe)===41&&re--;for(;!this._isAtEnd()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?re++:F.lexeme.charCodeAt(fe)===41&&re--}if(re<0)break;V.push(A.Scanner.getLexeme(H)),this._advance(),H=this._peek()}const ce=V.join(""),he=ce.lastIndexOf("/"),ue=he===ce.length-1?void 0:this._removeFlagsGY(ce.substring(he+1));let me;try{me=new RegExp(ce.substring(1,he),ue)}catch{throw this._errExpectedButGot("REGEX",F)}return s.regex(T,me)}case 18:{const V=F.lexeme;this._advance();let H=null;if(!(0,U.isFalsyOrWhitespace)(V)){const re=V.indexOf("/"),ce=V.lastIndexOf("/");if(re!==ce&&re>=0){const he=V.slice(re+1,ce),ue=V[ce+1]==="i"?"i":"";try{H=new RegExp(he,ue)}catch{throw this._errExpectedButGot("REGEX",F)}}}if(H===null)throw this._errExpectedButGot("REGEX",F);return G.create(T,H)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,E);const F=this._value();return s.notIn(T,F)}switch(this._peek().type){case 3:{this._advance();const F=this._value();if(this._previous().type===18)return s.equals(T,F);switch(F){case"true":return s.has(T);case"false":return s.not(T);default:return s.equals(T,F)}}case 4:{this._advance();const F=this._value();if(this._previous().type===18)return s.notEquals(T,F);switch(F){case"true":return s.not(T);case"false":return s.has(T);default:return s.notEquals(T,F)}}case 5:return this._advance(),q.create(T,this._value());case 6:return this._advance(),Q.create(T,this._value());case 7:return this._advance(),$.create(T,this._value());case 8:return this._advance(),W.create(T,this._value());case 13:return this._advance(),s.in(T,this._value());default:return s.has(T)}}case 20:throw this._parsingErrors.push({message:h,offset:D.offset,lexeme:"",additionalInfo:f}),C._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const D=this._peek();switch(D.type){case 17:case 18:return this._advance(),D.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(D){return D.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(D){return this._check(D)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(D,T){if(this._check(D))return this._advance();throw this._errExpectedButGot(T,this._peek())}_errExpectedButGot(D,T,M){const F=(0,L.localize)(8,null,D,A.Scanner.getLexeme(T)),V=T.offset,H=A.Scanner.getLexeme(T);return this._parsingErrors.push({message:F,offset:V,lexeme:H,additionalInfo:M}),C._parseError}_check(D){return this._peek().type===D}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=C;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(D){return a.create(D)}static equals(D,T){return w.create(D,T)}static notEquals(D,T){return S.create(D,T)}static regex(D,T){return G.create(D,T)}static in(D,T){return p.create(D,T)}static notIn(D,T){return l.create(D,T)}static not(D){return _.create(D)}static and(...D){return Y.create(D,null,!0)}static or(...D){return B.create(D,null,!0)}static greater(D,T){return $.create(D,T)}static greaterEquals(D,T){return W.create(D,T)}static smaller(D,T){return q.create(D,T)}static smallerEquals(D,T){return Q.create(D,T)}static{this._parser=new C({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this._parser.parse(D)}}e.ContextKeyExpr=s;function o(j){const D=new C({regexParsingWithErrorRecovery:!1});return j.map(T=>(D.parse(T),D.lexingErrors.length>0?D.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,L.localize)(9,null,M.additionalInfo):(0,L.localize)(10,null),offset:M.offset,length:M.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.validateWhenClauses=o;function n(j,D){const T=j?j.substituteConstants():void 0,M=D?D.substituteConstants():void 0;return!T&&!M?!0:!T||!M?!1:T.equals(M)}e.expressionsAreEqualWithConstantSubstitution=n;function i(j,D){return j.cmp(D)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return t.INSTANCE}}e.ContextKeyTrueExpr=r;class a{static create(D,T=null){const M=I.get(D);return typeof M=="boolean"?M?r.INSTANCE:t.INSTANCE:new a(D,T)}constructor(D,T){this.key=D,this.negated=T,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:ee(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=I.get(this.key);return typeof D=="boolean"?D?r.INSTANCE:t.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class w{static create(D,T,M=null){if(typeof T=="boolean")return T?a.create(D,M):_.create(D,M);const F=I.get(D);return typeof F=="boolean"?T===(F?"true":"false")?r.INSTANCE:t.INSTANCE:new w(D,T,M)}constructor(D,T,M){this.key=D,this.value=T,this.negated=M,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=I.get(this.key);if(typeof D=="boolean"){const T=D?"true":"false";return this.value===T?r.INSTANCE:t.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class p{static create(D,T){return new p(D,T)}constructor(D,T){this.key=D,this.valueKey=T,this.type=10,this.negated=null}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.valueKey),M=D.getValue(this.key);return Array.isArray(T)?T.includes(M):typeof M=="string"&&typeof T=="object"&&T!==null?P.call(T,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=l.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class l{static create(D,T){return new l(D,T)}constructor(D,T){this.key=D,this.valueKey=T,this.type=11,this._negated=p.create(D,T)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=l;class S{static create(D,T,M=null){if(typeof T=="boolean")return T?_.create(D,M):a.create(D,M);const F=I.get(D);return typeof F=="boolean"?T===(F?"true":"false")?t.INSTANCE:r.INSTANCE:new S(D,T,M)}constructor(D,T,M){this.key=D,this.value=T,this.negated=M,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=I.get(this.key);if(typeof D=="boolean"){const T=D?"true":"false";return this.value===T?t.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class _{static create(D,T=null){const M=I.get(D);return typeof M=="boolean"?M?t.INSTANCE:r.INSTANCE:new _(D,T)}constructor(D,T){this.key=D,this.negated=T,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:ee(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=I.get(this.key);return typeof D=="boolean"?D?t.INSTANCE:r.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function N(j,D){if(typeof j=="string"){const T=parseFloat(j);isNaN(T)||(j=T)}return typeof j=="string"||typeof j=="number"?D(j):t.INSTANCE}class ${static create(D,T,M=null){return N(T,F=>new $(D,F,M))}constructor(D,T,M){this.key=D,this.value=T,this.negated=M,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=Q.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=$;class W{static create(D,T,M=null){return N(T,F=>new W(D,F,M))}constructor(D,T,M){this.key=D,this.value=T,this.negated=M,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=W;class q{static create(D,T,M=null){return N(T,F=>new q(D,F,M))}constructor(D,T,M){this.key=D,this.value=T,this.negated=M,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=q;class Q{static create(D,T,M=null){return N(T,F=>new Q(D,F,M))}constructor(D,T,M){this.key=D,this.value=T,this.negated=M,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=Q;class G{static create(D,T){return new G(D,T)}constructor(D,T){this.key=D,this.regexp=T,this.type=7,this.negated=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const T=this.regexp?this.regexp.source:"",M=D.regexp?D.regexp.source:"";return T<M?-1:T>M?1:0}equals(D){if(D.type===this.type){const T=this.regexp?this.regexp.source:"",M=D.regexp?D.regexp.source:"";return this.key===D.key&&T===M}return!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=X.create(this)),this.negated}}e.ContextKeyRegexExpr=G;class X{static create(D){return new X(D)}constructor(D){this._actual=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(D){return new X(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=X;function x(j){let D=null;for(let T=0,M=j.length;T<M;T++){const F=j[T].substituteConstants();if(j[T]!==F&&D===null){D=[];for(let V=0;V<T;V++)D[V]=j[V]}D!==null&&(D[T]=F)}return D===null?j:D}class Y{static create(D,T,M){return Y._normalizeArr(D,T,M)}constructor(D,T){this.expr=D,this.negated=T,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,M=this.expr.length;T<M;T++){const F=i(this.expr[T],D.expr[T]);if(F!==0)return F}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,M=this.expr.length;T<M;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=x(this.expr);return D===this.expr?this:Y.create(D,this.negated,!1)}evaluate(D){for(let T=0,M=this.expr.length;T<M;T++)if(!this.expr[T].evaluate(D))return!1;return!0}static _normalizeArr(D,T,M){const F=[];let V=!1;for(const H of D)if(H){if(H.type===1){V=!0;continue}if(H.type===0)return t.INSTANCE;if(H.type===6){F.push(...H.expr);continue}F.push(H)}if(F.length===0&&V)return r.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];for(;F.length>1;){const H=F[F.length-1];if(H.type!==9)break;F.pop();const re=F.pop(),ce=F.length===0,he=B.create(H.expr.map(ue=>Y.create([ue,re],null,M)),null,ce);he&&(F.push(he),F.sort(i))}if(F.length===1)return F[0];if(M){for(let H=0;H<F.length;H++)for(let re=H+1;re<F.length;re++)if(F[H].negate().equals(F[re]))return t.INSTANCE;if(F.length===1)return F[0]}return new Y(F,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new Y(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.negated){const D=[];for(const T of this.expr)D.push(T.negate());this.negated=B.create(D,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class B{static create(D,T,M){return B._normalizeArr(D,T,M)}constructor(D,T){this.expr=D,this.negated=T,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,M=this.expr.length;T<M;T++){const F=i(this.expr[T],D.expr[T]);if(F!==0)return F}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,M=this.expr.length;T<M;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=x(this.expr);return D===this.expr?this:B.create(D,this.negated,!1)}evaluate(D){for(let T=0,M=this.expr.length;T<M;T++)if(this.expr[T].evaluate(D))return!0;return!1}static _normalizeArr(D,T,M){let F=[],V=!1;if(D){for(let H=0,re=D.length;H<re;H++){const ce=D[H];if(ce){if(ce.type===0){V=!0;continue}if(ce.type===1)return r.INSTANCE;if(ce.type===9){F=F.concat(ce.expr);continue}F.push(ce)}}if(F.length===0&&V)return t.INSTANCE;F.sort(i)}if(F.length!==0){if(F.length===1)return F[0];for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];if(M){for(let H=0;H<F.length;H++)for(let re=H+1;re<F.length;re++)if(F[H].negate().equals(F[re]))return r.INSTANCE;if(F.length===1)return F[0]}return new B(F,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new B(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.negated){const D=[];for(const T of this.expr)D.push(T.negate());for(;D.length>1;){const T=D.shift(),M=D.shift(),F=[];for(const V of K(T))for(const H of K(M))F.push(Y.create([V,H],null,!1));D.unshift(B.create(F,null,!1))}this.negated=B.create(D,this,!0)}return this.negated}}e.ContextKeyOrExpr=B;class z extends a{static{this._info=[]}static all(){return z._info.values()}constructor(D,T,M){super(D,null),this._defaultValue=T,typeof M=="object"?z._info.push({...M,key:D}):M!==!0&&z._info.push({key:D,description:M,type:T!=null?typeof T:void 0})}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return w.create(this.key,D)}notEqualsTo(D){return S.create(this.key,D)}}e.RawContextKey=z,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function ee(j,D){return j<D?-1:j>D?1:0}function ie(j,D,T,M){return j<T?-1:j>T?1:D<M?-1:D>M?1:0}function Z(j,D){if(j.type===0||D.type===1)return!0;if(j.type===9)return D.type===9?ne(j.expr,D.expr):!1;if(D.type===9){for(const T of D.expr)if(Z(j,T))return!0;return!1}if(j.type===6){if(D.type===6)return ne(D.expr,j.expr);for(const T of j.expr)if(Z(T,D))return!0;return!1}return j.equals(D)}e.implies=Z;function ne(j,D){let T=0,M=0;for(;T<j.length&&M<D.length;){const F=j[T].cmp(D[M]);if(F<0)return!1;F===0&&T++,M++}return T===j.length}function K(j){return j.type===9?j.expr:[j]}}),define(oe[95],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function U(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=U;class A{async getPerformanceInfo(L,R){return{}}async getSystemInfo(L,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,R){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=A}),define(oe[96],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,152,4]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function A(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function O(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function L(u,d){switch(u){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":d==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function R(u,d){return d==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function I(u,d,h){return R(d,h)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===h}e.isTargetPlatformCompatible=I;function g(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=g;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var v;(function(u){u.Install="install",u.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var c;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService");var m;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var E;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(E||(e.ExtensionSignaturetErrorCode=E={}));class y extends Error{constructor(d,h){super(d),this.code=h,this.name=h}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,k.localize)(1,null),original:"Preferences"}}),define(oe[187],ae([0,1,3,2,30,10,92,29]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(y,u){return y?O.URI.revive(u?u.transformIncoming(y):y):void 0}function g(y,u){return u?u.transformOutgoingURI(y):y}function P(y,u){u=u||L.DefaultURITransformer;const d=y.manifest;return{...(0,L.transformAndReviveIncomingURIs)({...y,manifest:void 0},u),manifest:d}}function b(y,u){return y?.profileLocation?(0,L.transformAndReviveIncomingURIs)(y,u??L.DefaultURITransformer):y}function v(y,u){return u?(0,A.cloneAndChange)(y,d=>d instanceof O.URI?u.transformOutgoingURI(d):void 0):y}class c{constructor(u,d){this.service=u,this.getUriTransformer=d,this.onInstallExtension=k.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const h=this.getUriTransformer(u);switch(d){case"onInstallExtension":return k.Event.map(this.onInstallExtension,f=>({...f,profileLocation:f.profileLocation?g(f.profileLocation,h):f.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,f=>f.map(C=>({...C,local:C.local?v(C.local,h):C.local,profileLocation:C.profileLocation?g(C.profileLocation,h):C.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,f=>({...f,profileLocation:f.profileLocation?g(f.profileLocation,h):f.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,f=>({...f,profileLocation:f.profileLocation?g(f.profileLocation,h):f.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,f=>v(f,h))}throw new Error("Invalid listen")}async call(u,d,h){const f=this.getUriTransformer(u);switch(d){case"zip":{const C=P(h[0],f),s=await this.service.zip(C);return g(s,f)}case"unzip":return this.service.unzip(I(h[0],f));case"install":return this.service.install(I(h[0],f),b(h[1],f));case"installFromLocation":return this.service.installFromLocation(I(h[0],f),I(h[1],f));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(h[0],I(h[1],f),I(h[2],f));case"getManifest":return this.service.getManifest(I(h[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(h[0]);case"installFromGallery":return this.service.installFromGallery(h[0],b(h[1],f));case"installGalleryExtensions":{const C=h[0];return this.service.installGalleryExtensions(C.map(({extension:s,options:o})=>({extension:s,options:b(o,f)??{}})))}case"uninstall":return this.service.uninstall(P(h[0],f),b(h[1],f));case"reinstallFromGallery":return this.service.reinstallFromGallery(P(h[0],f));case"getInstalled":return(await this.service.getInstalled(h[0],I(h[1],f))).map(s=>v(s,f));case"toggleAppliationScope":{const C=await this.service.toggleAppliationScope(P(h[0],f),I(h[1],f));return v(C,f)}case"copyExtensions":return this.service.copyExtensions(I(h[0],f),I(h[1],f));case"updateMetadata":{const C=await this.service.updateMetadata(P(h[0],f),h[1],I(h[2],f));return v(C,f)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(h[0],h[1],h[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=c;class m extends U.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this._register(this.channel.listen("onInstallExtension")(d=>this.fireEvent(this._onInstallExtension,{...d,source:this.isUriComponents(d.source)?O.URI.revive(d.source):d.source,profileLocation:O.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(d=>this.fireEvent(this._onDidInstallExtensions,d.map(h=>({...h,local:h.local?P(h.local,null):h.local,source:this.isUriComponents(h.source)?O.URI.revive(h.source):h.source,profileLocation:O.URI.revive(h.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(d=>this.fireEvent(this._onUninstallExtension,{...d,profileLocation:O.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(d=>this.fireEvent(this._onDidUninstallExtension,{...d,profileLocation:O.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(d=>this._onDidUpdateExtensionMetadata.fire(P(d,null))))}fireEvent(u,d){u.fire(d)}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(h=>(0,R.isTargetPlatformCompatible)(h,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(d=>O.URI.revive(d)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,d){return Promise.resolve(this.channel.call("install",[u,d])).then(h=>P(h,null))}installFromLocation(u,d){return Promise.resolve(this.channel.call("installFromLocation",[u,d])).then(h=>P(h,null))}async installExtensionsFromProfile(u,d,h){return(await this.channel.call("installExtensionsFromProfile",[u,d,h])).map(C=>P(C,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.channel.call("installFromGallery",[u,d])).then(h=>P(h,null))}async installGalleryExtensions(u){return(await this.channel.call("installGalleryExtensions",[u])).map(h=>({...h,local:h.local?P(h.local,null):h.local,source:this.isUriComponents(h.source)?O.URI.revive(h.source):h.source,profileLocation:O.URI.revive(h.profileLocation)}))}uninstall(u,d){return Promise.resolve(this.channel.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u])).then(d=>P(d,null))}getInstalled(u=null,d){return Promise.resolve(this.channel.call("getInstalled",[u,d])).then(h=>h.map(f=>P(f,null)))}updateMetadata(u,d,h){return Promise.resolve(this.channel.call("updateMetadata",[u,d,h])).then(f=>P(f,null))}toggleAppliationScope(u,d){return this.channel.call("toggleAppliationScope",[u,d]).then(h=>P(h,null))}copyExtensions(u,d){return this.channel.call("copyExtensions",[u,d])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,d,h){const f=await this.channel.call("download",[u,d,h]);return O.URI.revive(f)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class E{constructor(u){this.service=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,h){switch(d){case"getConfigBasedTips":return this.service.getConfigBasedTips(O.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(oe[97],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class U{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((O,L)=>te(["node-vsce-sign"],async R=>O(R),L))),this.moduleLoadingPromise}async verify(O,L,R){let I;try{I=await this.vsceSign()}catch{return!1}return I.verify(O,L,R)}}e.ExtensionSignatureVerificationService=U}),define(oe[98],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var U;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(U||(e.RecommendationSource=U={}));function A(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var O;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(O||(e.RecommendationsNotificationResult=O={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,10,159,4,5,23,60]),function(te,e,k,U,A,O,L,R,I,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function v(Z){return Z.create===!0}e.isFileOpenForWriteOptions=v;var c;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var m;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function E(Z){const ne=Z;return!!ne&&typeof ne.onDidChange=="function"}e.isFileSystemWatcher=E;var y;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function u(Z){return!!(Z.capabilities&2)}e.hasReadWriteCapability=u;function d(Z){return!!(Z.capabilities&8)}e.hasFileFolderCopyCapability=d;function h(Z){return!!(Z.capabilities&131072)}e.hasFileCloneCapability=h;function f(Z){return!!(Z.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function C(Z){return!!(Z.capabilities&16)}e.hasFileReadStreamCapability=C;function s(Z){return u(Z)?!!(Z.capabilities&16384):!1}e.hasFileAtomicReadCapability=s;function o(Z){return u(Z)?!!(Z.capabilities&32768):!1}e.hasFileAtomicWriteCapability=o;function n(Z){return!!(Z.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;function i(Z){return!!(Z.capabilities&2048)}e.hasReadonlyCapability=i;var t;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ne,K){const j=new r(ne.toString(),K);return p(j,K),j}constructor(ne,K){super(ne),this.code=K}}e.FileSystemProviderError=r;function a(Z,ne){return r.create(Z,ne)}e.createFileSystemProviderError=a;function w(Z){return Z||a((0,R.localize)(0,null),t.Unknown)}e.ensureFileSystemProviderError=w;function p(Z,ne){return Z.name=ne?`${ne} (FileSystemError)`:"FileSystemError",Z}e.markAsFileSystemProviderError=p;function l(Z){if(!Z)return t.Unknown;if(Z instanceof r)return Z.code;const ne=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!ne)return t.Unknown;switch(ne[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.toFileSystemProviderErrorCode=l;function S(Z){if(Z instanceof Q)return Z.fileOperationResult;switch(l(Z)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=S;var _;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(_||(e.FileOperation=_={}));class N{constructor(ne,K,j){this.resource=ne,this.operation=K,this.target=j}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=N;var $;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})($||(e.FileChangeType=$={}));class W{static{this.MIXED_CORRELATION=null}constructor(ne,K){this.ignorePathCasing=K,this.correlationId=void 0,this.added=new b.Lazy(()=>{const j=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawAdded.map(D=>[D,!0])),j}),this.updated=new b.Lazy(()=>{const j=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawUpdated.map(D=>[D,!0])),j}),this.deleted=new b.Lazy(()=>{const j=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawDeleted.map(D=>[D,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of ne){switch(j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}this.correlationId!==W.MIXED_CORRELATION&&(typeof j.cId=="number"?this.correlationId===void 0?this.correlationId=j.cId:this.correlationId!==j.cId&&(this.correlationId=W.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=W.MIXED_CORRELATION))}}contains(ne,...K){return this.doContains(ne,{includeChildren:!1},...K)}affects(ne,...K){return this.doContains(ne,{includeChildren:!0},...K)}doContains(ne,K,...j){if(!ne)return!1;const D=j.length>0;return!!((!D||j.includes(1))&&(this.added.value.get(ne)||K.includeChildren&&this.added.value.findSuperstr(ne))||(!D||j.includes(0))&&(this.updated.value.get(ne)||K.includeChildren&&this.updated.value.findSuperstr(ne))||(!D||j.includes(2))&&(this.deleted.value.findSubstr(ne)||K.includeChildren&&this.deleted.value.findSuperstr(ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ne){return this.correlationId===ne}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=W;function q(Z,ne,K){return!Z||!ne||Z===ne||ne.length>Z.length?!1:(ne.charAt(ne.length-1)!==U.sep&&(ne+=U.sep),K?(0,A.startsWithIgnoreCase)(Z,ne):Z.indexOf(ne)===0)}e.isParent=q;class Q extends Error{constructor(ne,K,j){super(ne),this.fileOperationResult=K,this.options=j}}e.FileOperationError=Q;class G extends Q{constructor(ne,K,j,D){super(ne,K,D),this.fileOperationResult=K,this.size=j}}e.TooLargeFileOperationError=G;class X extends Q{constructor(ne,K,j){super(ne,2,j),this.stat=K}}e.NotModifiedSinceFileOperationError=X;var x;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Y;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.ETAG_DISABLED="";function B(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.etag=B;async function z(Z,ne){if(!ne.hasProvider(L.URI.from({scheme:Z.scheme})))return new Promise(K=>{const j=ne.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===Z.scheme&&D.added&&(j.dispose(),K())})})}e.whenProviderRegistered=z;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ne){return(0,O.isNumber)(ne)||(ne=0),ne<ee.KB?(0,R.localize)(1,null,ne.toFixed(0)):ne<ee.MB?(0,R.localize)(2,null,(ne/ee.KB).toFixed(2)):ne<ee.GB?(0,R.localize)(3,null,(ne/ee.MB).toFixed(2)):ne<ee.TB?(0,R.localize)(4,null,(ne/ee.GB).toFixed(2)):(0,R.localize)(5,null,(ne/ee.TB).toFixed(2))}}e.ByteSize=ee;function ie(Z){const ne=typeof Z=="string"||Z?.scheme===P.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===P.Schemas.file?1024*ee.MB:ne?10*ee.MB:g.isWeb?50*ee.MB:1024*ee.MB}e.getLargeFileConfirmationLimit=ie});var J=this&&this.__param||function(te,e){return function(k,U){e(k,U,te)}};define(oe[188],ae([0,1,70,46,11]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let O=class{constructor(R){this.fileService=R}async checksum(R){const I=(await this.fileService.readFileStream(R)).value;return new Promise((g,P)=>{const b=(0,k.createHash)("md5");(0,U.listenStream)(I,{onData:v=>b.update(v.buffer),onError:v=>P(v),onEnd:()=>g(b.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=O,e.ChecksumService=O=ye([J(0,A.IFileService)],O)}),define(oe[99],ae([0,1,15,7,160,11]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(P,b,v,c,m,E){let y;try{await R(P,b,v,c,m,E)}catch(u){y=u}finally{y&&m.errorTransformer&&(y=m.errorTransformer(y)),typeof y<"u"&&v.error(y),v.end()}}e.readFileIntoStream=L;async function R(P,b,v,c,m,E){I(E);const y=await P.open(b,{create:!1});try{I(E);let u=0,d=0,h=m&&typeof m.length=="number"?m.length:void 0,f=k.VSBuffer.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),C=m&&typeof m.position=="number"?m.position:0,s=0;do d=await P.read(y,C,f.buffer,s,f.byteLength-s),C+=d,s+=d,u+=d,typeof h=="number"&&(h-=d),s===f.byteLength&&(await v.write(c(f)),f=k.VSBuffer.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),s=0);while(d>0&&(typeof h!="number"||h>0)&&I(E)&&g(u,m));if(s>0){let o=s;typeof h=="number"&&(o=Math.min(s,h)),v.write(c(f.slice(0,o)))}}catch(u){throw(0,O.ensureFileSystemProviderError)(u)}finally{await P.close(y)}}function I(P){if(P.isCancellationRequested)throw(0,U.canceled)();return!0}function g(P,b){if(typeof b?.limits?.size=="number"&&P>b.limits.size)throw(0,O.createFileSystemProviderError)((0,A.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[49],ae([0,1,91,2,16,5,10,11]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class g extends U.Disposable{static{this.MAX_RESTARTS=5}constructor(d,h,f,C){super(),this.onFileChanges=d,this.onLogMessage=h,this.verboseLogging=f,this.options=C,this.watcherDisposables=this._register(new U.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new U.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),d.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),d.add(this.watcher.onDidError(h=>this.onError(h)))}onError(d){this.options.restartOnError?this.restartCounter<g.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=g;class P extends g{constructor(d,h,f){super(d,h,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class b extends g{constructor(d,h,f){super(d,h,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function v(u){return u.map(d=>({type:d.type,resource:L.URI.revive(d.resource),cId:d.cId}))}e.reviveFileChanges=v;function c(u){const d=new y;for(const h of u)d.processEvent(h);return d.coalesce()}e.coalesceEvents=c;function m(u,d){return typeof d=="string"&&!d.startsWith(k.GLOBSTAR)&&!(0,A.isAbsolute)(d)?{base:u,pattern:d}:d}e.normalizeWatcherPattern=m;function E(u,d){const h=[];for(const f of d)h.push((0,k.parse)(m(u,f)));return h}e.parseWatcherPatterns=E;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return O.isLinux?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const h=this.mapPathToChange.get(this.toKey(d));let f=!1;if(h){const C=h.type,s=d.type;h.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?f=!0:C===1&&s===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(h)):C===2&&s===1?h.type=0:C===1&&s===0||(h.type=s)}else f=!0;f&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],h=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(d.push(f),!1):!0).sort((f,C)=>f.resource.fsPath.length-C.resource.fsPath.length).filter(f=>h.some(C=>(0,R.isParent)(f.resource.fsPath,C,!O.isLinux))?!1:(h.push(f.resource.fsPath),!0)).concat(d)}}}),define(oe[189],ae([0,1,15,38,7,3,2,46,32,11,49]),function(te,e,k,U,A,O,L,R,I,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends L.Disposable{constructor(c,m){super(),this.channel=c,this.extraCapabilities=m,this.onDidChangeCapabilities=O.Event.None,this._onDidChange=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(c){return this.channel.call("stat",[c])}readdir(c){return this.channel.call("readdir",[c])}async readFile(c,m){const{buffer:E}=await this.channel.call("readFile",[c,m]);return E}readFileStream(c,m,E){const y=(0,R.newWriteableStream)(d=>k.VSBuffer.concat(d.map(h=>k.VSBuffer.wrap(h))).buffer),u=new L.DisposableStore;return u.add(this.channel.listen("readFileStream",[c,m])(d=>{if(d instanceof k.VSBuffer)y.write(d.buffer);else{if(d==="end")y.end();else{let h;if(d instanceof Error)h=d;else{const f=d;h=(0,g.createFileSystemProviderError)(f.message??(0,U.toErrorMessage)(f),f.code??g.FileSystemProviderErrorCode.Unknown)}y.error(h),y.end()}u.dispose()}})),u.add(E.onCancellationRequested(()=>{y.error((0,A.canceled)()),y.end(),u.dispose()})),y}writeFile(c,m,E){return this.channel.call("writeFile",[c,k.VSBuffer.wrap(m),E])}open(c,m){return this.channel.call("open",[c,m])}close(c){return this.channel.call("close",[c])}async read(c,m,E,y,u){const[d,h]=await this.channel.call("read",[c,m,u]);return E.set(d.buffer.slice(0,h),y),h}write(c,m,E,y,u){return this.channel.call("write",[c,m,k.VSBuffer.wrap(E),y,u])}mkdir(c){return this.channel.call("mkdir",[c])}delete(c,m){return this.channel.call("delete",[c,m])}rename(c,m,E){return this.channel.call("rename",[c,m,E])}copy(c,m,E){return this.channel.call("copy",[c,m,E])}cloneFile(c,m){return this.channel.call("cloneFile",[c,m])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(c=>{if(Array.isArray(c)){const m=c;this._onDidChange.fire((0,P.reviveFileChanges)(m))}else{const m=c;this._onDidWatchError.fire(m)}}))}watch(c,m){const E=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,E,c,m]),(0,L.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,E]))}}e.DiskFileSystemProviderClient=b}),define(oe[190],ae([0,1,53,6,26,48,2,88,16,5,19,10,143,31,49]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class E extends L.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(d,h,f,C){super(),this.request=d,this.onDidFilesChange=h,this.onLogMessage=f,this.verboseLogging=C,this.throttledFileChangesEmitter=this._register(new U.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.onDidFilesChange(s))),this.fileChangesAggregator=this._register(new U.RunOnceWorker(s=>this.handleFileChanges(s),E.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new A.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const h=await c.Promises.stat(d);this._register(await this.doWatch(d,h.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(d)}}async normalizePath(d){let h=d.path;try{h=await c.Promises.realpath(d.path),d.path===h&&(h=await(0,v.realcase)(d.path)??d.path),d.path!==h&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${h})`)}catch{}return h}async doWatch(d,h){if(g.isMacintosh&&(0,O.isEqualOrParent)(d,"/Volumes/",!0))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const f=new A.CancellationTokenSource(this.cts.token),C=new L.DisposableStore;try{const s=b.URI.file(this.request.path),o=(0,I.basename)(d),n=(0,k.watch)(d);C.add((0,L.toDisposable)(()=>{n.removeAllListeners(),n.close()})),this.trace(`Started watching: '${d}'`);const i=new Set;if(h)try{for(const r of await c.Promises.readdir(d))i.add(r)}catch(r){this.error(r)}const t=new Map;C.add((0,L.toDisposable)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(f.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${a}`);let w="";if(a&&(w=a.toString(),g.isMacintosh&&(w=(0,R.normalizeNFC)(w))),!(!w||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(w)?.dispose();const p=setTimeout(async()=>{if(t.delete(w),w===o&&!await c.Promises.exists(d)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,I.join)(d,w));if(f.token.isCancellationRequested)return;let S;l?i.has(w)?S=0:(S=1,i.add(w)):(i.delete(w),S=2),this.onFileChange({resource:(0,P.joinPath)(s,w),type:S,cId:this.request.correlationId})},E.FILE_DELETE_HANDLER_DELAY);t.set(w,(0,L.toDisposable)(()=>clearTimeout(p)))}else{let p;i.has(w)?p=0:(p=1,i.add(w)),this.onFileChange({resource:(0,P.joinPath)(s,w),type:p,cId:this.request.correlationId})}else if(r==="rename"||w!==o){const p=setTimeout(async()=>{const l=await c.Promises.exists(d);f.token.isCancellationRequested||(l?(this.onFileChange({resource:s,type:0,cId:this.request.correlationId},!0),C.add(await this.doWatch(d,!1))):(this.onFileChange({resource:s,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},E.FILE_DELETE_HANDLER_DELAY);C.clear(),C.add((0,L.toDisposable)(()=>clearTimeout(p)))}else this.onFileChange({resource:s,type:0,cId:this.request.correlationId},!0)})}catch(s){await c.Promises.exists(d)&&!f.token.isCancellationRequested&&this.error(`Failed to watch ${d} for changes using fs.watch() (${s.toString()})`)}return(0,L.toDisposable)(()=>{f.dispose(!0),C.dispose()})}onFileChange(d,h=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!h&&this.excludes.some(f=>f(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${d.resource.fsPath}`):!h&&this.includes&&this.includes.length>0&&!this.includes.some(f=>f(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${d.resource.fsPath}`):this.fileChangesAggregator.work(d))}handleFileChanges(d){const h=(0,m.coalesceEvents)(d);if(h.length>0){if(this.verboseLogging)for(const C of h)this.trace(` >> normalized ${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.resource.fsPath}`);this.throttledFileChangesEmitter.work(h)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(d){if(g.isLinux)return c.Promises.exists(d);try{const h=(0,I.basename)(d);return(await c.Promises.readdir((0,I.dirname)(d))).some(C=>C===h)}catch(h){return this.trace(h),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=E;async function y(u,d,h,f,C=512){const s=await c.Promises.open(u,"r"),o=Buffer.allocUnsafe(C),n=new A.CancellationTokenSource(f);let i,t=!1;const r={path:u,excludes:[],recursive:!1},a=new E(r,w=>{(async()=>{for(const{type:p}of w)if(p===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:l}=await c.Promises.read(s,o,0,C,null);if(!l||n.token.isCancellationRequested)break;d(o.slice(0,l))}}catch(l){i=new Error(l),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,h(),new Promise((w,p)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await c.Promises.close(s)}catch(l){i=new Error(l)}i?p(i):w()})})}e.watchFileContents=y}),define(oe[191],ae([0,1,3,91,2,5,190]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends A.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(g){const P=this.normalizeRequests(g),b=P.filter(c=>{const m=this.watchers.get(c.path);return m?!(0,U.patternsEquals)(m.request.excludes,c.excludes)||!(0,U.patternsEquals)(m.request.includes,c.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:c})=>!P.find(m=>m.path===c.path&&(0,U.patternsEquals)(m.excludes,c.excludes)&&(0,U.patternsEquals)(m.includes,c.includes))).map(({request:c})=>c.path);b.length&&this.trace(`Request to start watching: ${b.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const c of v)this.stopWatching(c);for(const c of b)this.startWatching(c)}startWatching(g){const P=new L.NodeJSFileWatcherLibrary(g,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),b={request:g,instance:P};this.watchers.set(g.path,b)}async stop(){for(const[g]of this.watchers)this.stopWatching(g);this.watchers.clear()}stopWatching(g){const P=this.watchers.get(g);P&&(this.watchers.delete(g),P.instance.dispose())}normalizeRequests(g){const P=new Map;for(const b of g){const v=O.isLinux?b.path:b.path.toLowerCase();let c=P.get(b.correlationId);c||(c=new Map,P.set(b.correlationId,c)),c.set(v,b)}return Array.from(P.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(g){this.verboseLogging=g;for(const[,P]of this.watchers)P.instance.setVerboseLogging(g)}trace(g){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(g)})}toMessage(g,P){return P?`[File Watcher (node.js)] ${g} (path: ${P.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=R}),define(oe[192],ae([0,1,49,191]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class A extends k.AbstractNonRecursiveWatcherClient{constructor(L,R,I){super(L,R,I),this.init()}createWatcher(L){return L.add(new U.NodeJSWatcher)}}e.NodeJSWatcherClient=A}),define(oe[193],ae([0,1,23,42,93,49]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends O.AbstractUniversalWatcherClient{constructor(I,g,P){super(I,g,P),this.init()}createWatcher(I){const g=I.add(new A.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(g.onDidProcessExit(({code:P,signal:b})=>this.onError(`terminated by itself with code ${P}, signal: ${b}`))),U.ProxyChannel.toService((0,U.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(oe[71],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...A){this._entries=new Map;for(const[O,L]of A)this.set(O,L)}set(A,O){const L=this._entries.get(A);return this._entries.set(A,O),L}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=k}),define(oe[194],ae([0,1,6,7,2,69,185,4,71,87]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class b extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class v{constructor(y=new I.ServiceCollection,u=!1,d,h=P){this._services=y,this._strict=u,this._parent=d,this._enableTracing=h,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=h?d?._globalGraph??new L.Graph(f=>f):void 0}createChild(y){return new v(y,this._strict,this,this._enableTracing)}invokeFunction(y,...u){const d=m.traceInvocation(this._enableTracing,y);let h=!1;try{return y({get:C=>{if(h)throw(0,U.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(C,d);if(!s)throw new Error(`[invokeFunction] unknown service '${C}'`);return s}},...u)}finally{h=!0,d.stop()}}createInstance(y,...u){let d,h;return y instanceof O.SyncDescriptor?(d=m.traceCreation(this._enableTracing,y.ctor),h=this._createInstance(y.ctor,y.staticArguments.concat(u),d)):(d=m.traceCreation(this._enableTracing,y),h=this._createInstance(y,u,d)),d.stop(),h}_createInstance(y,u=[],d){const h=R._util.getServiceDependencies(y).sort((s,o)=>s.index-o.index),f=[];for(const s of h){const o=this._getOrCreateServiceInstance(s.id,d);o||this._throwIfStrict(`[createInstance] ${y.name} depends on UNKNOWN service ${s.id}.`,!1),f.push(o)}const C=h.length>0?h[0].index:u.length;if(u.length!==C){console.trace(`[createInstance] First service dependency of ${y.name} at position ${C+1} conflicts with ${u.length} static arguments`);const s=C-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,C)}return Reflect.construct(y,u.concat(f))}_setServiceInstance(y,u){if(this._services.get(y)instanceof O.SyncDescriptor)this._services.set(y,u);else if(this._parent)this._parent._setServiceInstance(y,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){const u=this._services.get(y);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):u}_getOrCreateServiceInstance(y,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(y));const d=this._getServiceInstanceOrDescriptor(y);return d instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,d,u.branch(y,!0)):(u.branch(y,!1),d)}_safeCreateAndCacheServiceInstance(y,u,d){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,u,d)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,u,d){const h=new L.Graph(s=>s.id.toString());let f=0;const C=[{id:y,desc:u,_trace:d}];for(;C.length;){const s=C.pop();if(h.lookupOrInsertNode(s),f++>1e3)throw new b(h);for(const o of R._util.getServiceDependencies(s.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),n instanceof O.SyncDescriptor){const i={id:o.id,desc:n,_trace:s._trace.branch(o.id,!0)};h.insertEdge(s,i),C.push(i)}}}for(;;){const s=h.roots();if(s.length===0){if(!h.isEmpty())throw new b(h);break}for(const{data:o}of s){if(this._getServiceInstanceOrDescriptor(o.id)instanceof O.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}h.removeNode(o)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,u,d=[],h,f){if(this._services.get(y)instanceof O.SyncDescriptor)return this._createServiceInstance(y,u,d,h,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,u,d,h,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(y,u,d=[],h,f){if(h){const C=new v(void 0,this._strict,this,this._enableTracing);C._globalGraphImplicitDependency=String(y);const s=new Map,o=new k.IdleValue(()=>{const n=C._createInstance(u,d,f);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const a of t)r.apply(n,a)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=s.get(i);return a||(a=new g.LinkedList,s.set(i,a)),(p,l,S)=>{const _=a.push([p,l,S]);return(0,A.toDisposable)(_)}}if(i in n)return n[i];const t=o.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return o.value[i]=t,!0},getPrototypeOf(n){return u.prototype}})}else return this._createInstance(u,d,f)}_throwIfStrict(y,u){if(u&&console.warn(y),this._strict)throw new Error(y)}}e.InstantiationService=v;var c;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(c||(c={}));class m{static{this.all=new Set}static{this._None=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(y,u){return y?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(y,u){return y?new m(1,u.name):m._None}static{this._totals=0}constructor(y,u){this.type=y,this.name=u,this._start=Date.now(),this._dep=[]}branch(y,u){const d=new m(3,y.toString());return this._dep.push([y,u,d]),d}stop(){const y=Date.now()-this._start;m._totals+=y;let u=!1;function d(f,C){const s=[],o=new Array(f+1).join("	");for(const[n,i,t]of C._dep)if(i&&t){u=!0,s.push(`${o}CREATES -> ${n}`);const r=d(f+1,t);r&&s.push(r)}else s.push(`${o}uses -> ${n}`);return s.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(y>2||u)&&m.all.add(h.join(`
`))}}e.Trace=m}),define(oe[72],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,k.createDecorator)("mainProcessService");class U{constructor(O,L){this.server=O,this.router=L}getChannel(O){return this.server.getChannel(O,this.router)}registerChannel(O,L){this.server.registerChannel(O,L)}}e.MainProcessService=U}),define(oe[73],ae([0,1,26,2,5,162,29,4]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let g=class extends U.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new k.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let v;try{v=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const m=v.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(y=>y.startsWith("lp-"))).map(E=>{const y=E.properties.localizedLanguages?.[0],u=I(E);return{...this.createQuickPickItem(u,y,E),extensionId:E.identifier.id,galleryExtension:E}});return m.push(this.createQuickPickItem("en","English")),m}createQuickPickItem(b,v,c){const m=v??b;let E;if(m!==b&&(E=`(${b})`),b.toLowerCase()===A.language.toLowerCase()&&(E??="",E+=(0,O.localize)(0,null)),c?.installCount){E??="";const y=c.installCount;let u;y>1e6?u=`${Math.floor(y/1e5)/10}M`:y>1e3?u=`${Math.floor(y/1e3)}K`:u=String(y),E+=` $(cloud-download) ${u}`}return{id:b,label:m,description:E}}};e.LanguagePackBaseService=g,e.LanguagePackBaseService=g=ye([J(0,L.IExtensionGalleryService)],g)}),define(oe[195],ae([0,1,2,73]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends k.Disposable{constructor(L){super(),this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=A,e.LocalizationsUpdater=A=ye([J(0,U.ILanguagePackService)],A)}),define(oe[8],ae([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(te,e,k,U,A,O,L,R,I,g,P,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function c(){return new Date().toISOString()}function m(p){return(0,g.isNumber)(p)}e.isLogLevel=m;var E;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function y(p,l,S){switch(l){case E.Trace:p.trace(S);break;case E.Debug:p.debug(S);break;case E.Info:p.info(S);break;case E.Warning:p.warn(S);break;case E.Error:p.error(S);break;case E.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=y;function u(p,l=!1){let S="";for(let _=0;_<p.length;_++){let N=p[_];if(N instanceof Error&&(N=(0,k.toErrorMessage)(N,l)),typeof N=="object")try{N=JSON.stringify(N)}catch{}S+=(_>0?" ":"")+N}return S}class d extends O.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new U.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(l){this.level!==l&&(this.level=l,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(l){return this.level!==E.Off&&this.level<=l}}e.AbstractLogger=d;class h extends d{constructor(l){super(),this.logAlways=l}checkLogLevel(l){return this.logAlways||super.checkLogLevel(l)}trace(l,...S){this.checkLogLevel(E.Trace)&&this.log(E.Trace,u([l,...S],!0))}debug(l,...S){this.checkLogLevel(E.Debug)&&this.log(E.Debug,u([l,...S]))}info(l,...S){this.checkLogLevel(E.Info)&&this.log(E.Info,u([l,...S]))}warn(l,...S){this.checkLogLevel(E.Warning)&&this.log(E.Warning,u([l,...S]))}error(l,...S){if(this.checkLogLevel(E.Error))if(l instanceof Error){const _=Array.prototype.slice.call(arguments);_[0]=l.stack,this.log(E.Error,u(_))}else this.log(E.Error,u([l,...S]))}flush(){}}e.AbstractMessageLogger=h;class f extends d{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.useColors=!R.isWindows}trace(l,...S){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...S):console.log(`[main ${c()}]`,l,...S))}debug(l,...S){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...S):console.log(`[main ${c()}]`,l,...S))}info(l,...S){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...S):console.log(`[main ${c()}]`,l,...S))}warn(l,...S){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,l,...S):console.warn(`[main ${c()}]`,l,...S))}error(l,...S){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,l,...S):console.error(`[main ${c()}]`,l,...S))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class C extends d{constructor(l=e.DEFAULT_LOG_LEVEL,S=!0){super(),this.useColors=S,this.setLevel(l)}trace(l,...S){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",l,...S):console.log(l,...S))}debug(l,...S){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",l,...S):console.log(l,...S))}info(l,...S){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",l,...S):console.log(l,...S))}warn(l,...S){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",l,...S):console.log(l,...S))}error(l,...S){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",l,...S):console.error(l,...S))}dispose(){}flush(){}}e.ConsoleLogger=C;class s extends d{constructor(l,S=e.DEFAULT_LOG_LEVEL){super(),this.adapter=l,this.setLevel(S)}trace(l,...S){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(l),...S])}debug(l,...S){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(l),...S])}info(l,...S){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(l),...S])}warn(l,...S){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(l),...S])}error(l,...S){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(l),...S])}extractMessage(l){return typeof l=="string"?l:(0,k.toErrorMessage)(l,this.checkLogLevel(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=s;class o extends d{constructor(l){super(),this.loggers=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const S of this.loggers)S.setLevel(l);super.setLevel(l)}trace(l,...S){for(const _ of this.loggers)_.trace(l,...S)}debug(l,...S){for(const _ of this.loggers)_.debug(l,...S)}info(l,...S){for(const _ of this.loggers)_.info(l,...S)}warn(l,...S){for(const _ of this.loggers)_.warn(l,...S)}error(l,...S){for(const _ of this.loggers)_.error(l,...S)}flush(){for(const l of this.loggers)l.flush()}dispose(){for(const l of this.loggers)l.dispose()}}e.MultiplexLogger=o;class n extends O.Disposable{constructor(l,S,_){if(super(),this.logLevel=l,this.logsHome=S,this._loggers=new L.ResourceMap,this._onDidChangeLoggers=this._register(new U.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new U.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new U.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,_)for(const N of _)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(l){return(0,g.isString)(l)?[...this._loggers.values()].find(S=>S.info.id===l):this._loggers.get(l)}getLogger(l){return this.getLoggerEntry(l)?.logger}createLogger(l,S){const _=this.toResource(l),N=(0,g.isString)(l)?l:S?.id??(0,A.hash)(_.toString()).toString(16);let $=this._loggers.get(_)?.logger;const W=S?.logLevel==="always"?E.Trace:S?.logLevel;$||($=this.doCreateLogger(_,W??this.getLogLevel(_)??this.logLevel,{...S,id:N}));const q={logger:$,info:{resource:_,id:N,logLevel:W,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(q.info),this._loggers.set(_,q),$}toResource(l){return(0,g.isString)(l)?(0,I.joinPath)(this.logsHome,`${l}.log`):l}setLogLevel(l,S){if(P.URI.isUri(l)){const _=l,N=S,$=this._loggers.get(_);$&&N!==$.info.logLevel&&($.info.logLevel=N===this.logLevel?void 0:N,$.logger?.setLevel(N),this._loggers.set($.info.resource,$),this._onDidChangeLogLevel.fire([_,N]))}else{this.logLevel=l;for(const[_,N]of this._loggers.entries())this._loggers.get(_)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(l,S){const _=this.getLoggerEntry(l);_&&S!==!_.info.hidden&&(_.info.hidden=!S,this._loggers.set(_.info.resource,_),this._onDidChangeVisibility.fire([_.info.resource,S]))}getLogLevel(l){let S;return l&&(S=this._loggers.get(l)?.info.logLevel),S??this.logLevel}registerLogger(l){const S=this._loggers.get(l.resource);S?S.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this._loggers.set(l.resource,{info:l,logger:void 0}),this._onDidChangeLoggers.fire({added:[l],removed:[]}))}deregisterLogger(l){const S=this._loggers.get(l);S&&(S.logger&&S.logger.dispose(),this._loggers.delete(l),this._onDidChangeLoggers.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const l of this._loggers.values())yield l.info}getRegisteredLogger(l){return this._loggers.get(l)?.info}dispose(){this._loggers.forEach(l=>l.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new U.Emitter().event}setLevel(l){}getLevel(){return E.Info}trace(l,...S){}debug(l,...S){}info(l,...S){}warn(l,...S){}error(l,...S){}critical(l,...S){}dispose(){}flush(){}}e.NullLogger=i;class t extends i{}e.NullLogService=t;function r(p){if(p.verbose)return E.Trace;if(typeof p.logLevel=="string"){const l=w(p.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(p){switch(p){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=a;function w(p){switch(p){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=w,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",a(E.Info))}),define(oe[196],ae([0,1,6,7,2,23,16,19,31,14,8]),function(te,e,k,U,A,O,L,R,I,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends A.Disposable{constructor(c,m){super(),this.environmentService=c,this.logService=m,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,R.basename)(this.environmentService.logsHome),m=(0,R.dirname)(this.environmentService.logsHome.with({scheme:O.Schemas.file})).fsPath,u=(await I.Promises.readdir(m)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==c),d=u.slice(0,Math.max(0,u.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(h=>I.Promises.rm((0,L.join)(m,h)))))}catch(c){(0,U.onUnexpectedError)(c)}}};e.LogsDataCleaner=b,e.LogsDataCleaner=b=ye([J(0,g.IEnvironmentService),J(1,P.ILogService)],b)}),define(oe[197],ae([0,1,18,6,7,3,2,16,49,8]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends L.Disposable{constructor(v,c){super(),this.logService=v,this.options=c,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new U.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new U.ThrottledDelayer(0))}watch(v,c){return c.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,c):this.watchNonRecursive(v,c)}watchUniversal(v,c){const m={path:this.toFilePath(v),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},E=(0,k.insert)(this.universalPathsToWatch,m);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,A.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(c=>this._onDidChangeFile.fire((0,I.reviveFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const c of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(c)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const c of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(c)&&v.includes(c.path)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,c){const m={path:this.toFilePath(v),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},E=(0,k.insert)(this.nonRecursivePathsToWatch,m);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,A.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,I.reviveFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,R.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(oe[198],ae([0,1,18,6,15,26,3,52,59,2,47,23,100,19,46,158,11,99,8,7]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class extends g.Disposable{static{f=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new L.Emitter),this._onDidUncorrelatedFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new U.ResourceQueue)}registerProvider(o,n){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${o}`);const i=new g.DisposableStore;return this.provider.set(o,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new y.FileChangesEvent(t,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(r),r.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:o}))),(0,g.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:n}),this.provider.delete(o),(0,g.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){n.push(i)}}),!this.provider.has(o)&&await U.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,n){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return I.Iterable.map(this.provider,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async withProvider(o){if(!(0,c.isAbsolutePath)(o))throw new y.FileOperationError((0,E.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const n=this.provider.get(o.scheme);if(!n){const i=new h.ErrorNoTelemetry;throw i.message=(0,E.localize)(1,null,o.toString()),i}return n}async withReadProvider(o){const n=await this.withProvider(o);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)||(0,y.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const n=await this.withProvider(o);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.doResolveFile(o,n)}catch(i){throw(0,y.toFileSystemProviderErrorCode)(i)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,E.localize)(2,null,this.resourceForError(o)),1):(0,y.ensureFileSystemProviderError)(i)}}async doResolveFile(o,n){const i=await this.withProvider(o),t=this.isPathCaseSensitive(i),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,w=n?.resolveMetadata,p=await i.stat(o);let l;return this.toFileStat(i,o,p,void 0,!!w,(S,_)=>(l||(l=P.TernarySearchTree.forUris(()=>!t),l.set(o,!0),r&&l.fill(!0,r)),l.get(S.resource)||l.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?_===1:!1))}async toFileStat(o,n,i,t,r,a){const{providerExtUri:w}=this.getExtUri(o),p={resource:n,name:w.basename(n),isFile:(i.type&y.FileType.File)!==0,isDirectory:(i.type&y.FileType.Directory)!==0,isSymbolicLink:(i.type&y.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&y.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&y.FilePermission.Locked),etag:(0,y.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(p.isDirectory&&a(p,t)){try{const l=await o.readdir(n),S=await U.Promises.settled(l.map(async([_,N])=>{try{const $=w.joinPath(n,_),W=r?await o.stat($):{type:N};return await this.toFileStat(o,$,W,l.length,r,a)}catch($){return this.logService.trace($),null}}));p.children=(0,k.coalesce)(S)}catch(l){this.logService.trace(l),p.children=[]}return p}return p}async resolveAll(o){return U.Promises.settled(o.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.withProvider(o),i=await n.stat(o);return this.toFileStat(n,o,i,void 0,!0,()=>!1)}async exists(o){const n=await this.withProvider(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.doValidateCreateFile(o,n)}catch(i){return i}return!0}async doValidateCreateFile(o,n){if(!n?.overwrite&&await this.exists(o))throw new y.FileOperationError((0,E.localize)(3,null,this.resourceForError(o)),3,n)}async createFile(o,n=A.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const t=await this.writeFile(o,n);return this._onDidRunOperation.fire(new y.FileOperationEvent(o,0,t)),t}async writeFile(o,n,i){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(t);let a=i;if((0,y.hasFileAtomicWriteCapability)(t)&&!a?.atomic){const w=t.enforceAtomicWriteFile?.(o);w&&(a={...i,atomic:w})}try{await this.validateWriteFile(t,o,a)||await this.mkdirp(t,r.dirname(o));let p;if((0,y.hasReadWriteCapability)(t)&&!(n instanceof A.VSBuffer))if((0,m.isReadableStream)(n)){const l=await(0,m.peekStream)(n,3);l.ended?p=A.VSBuffer.concat(l.buffer):p=l}else p=(0,m.peekReadable)(n,l=>A.VSBuffer.concat(l),3);else p=n;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&p instanceof A.VSBuffer||(0,y.hasReadWriteCapability)(t)&&(0,y.hasFileAtomicWriteCapability)(t)&&a?.atomic?await this.doWriteUnbuffered(t,o,a,p):await this.doWriteBuffered(t,o,a,p instanceof A.VSBuffer?(0,A.bufferToReadable)(p):p),this._onDidRunOperation.fire(new y.FileOperationEvent(o,4))}catch(w){throw new y.FileOperationError((0,E.localize)(4,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(w).toString()),(0,y.toFileOperationResult)(w),a)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,n,i){const t=!!i?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(n)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,E.localize)(6,null,this.resourceForError(n)));if(!(o.capabilities&2))throw new Error((0,E.localize)(7,null,this.resourceForError(n)));if(t)throw new Error((0,E.localize)(8,null,this.resourceForError(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&y.FileType.Directory)throw new y.FileOperationError((0,E.localize)(9,null,this.resourceForError(n)),0,i);if(this.throwIfFileIsReadonly(n,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==y.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,y.etag)({mtime:i.mtime,size:a.size}))throw new y.FileOperationError((0,E.localize)(10,null),3,i);return a}async readFile(o,n,i){const t=await this.withReadProvider(o);return n?.atomic?this.doReadFileAtomic(t,o,n,i):this.doReadFile(t,o,n,i)}async doReadFileAtomic(o,n,i,t){return new Promise((r,a)=>{this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(async()=>{try{const w=await this.doReadFile(o,n,i,t);r(w)}catch(w){a(w)}})})}async doReadFile(o,n,i,t){const r=await this.doReadFileStream(o,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,A.streamToBuffer)(r.value)}}async readFileStream(o,n,i){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,n,i)}async doReadFileStream(o,n,i,t){const r=new O.CancellationTokenSource(t);let a=i;(0,y.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...i,atomic:!0});const w=this.validateReadFile(n,a).then(l=>l,l=>{throw r.dispose(!0),l});let p;try{return typeof a?.etag=="string"&&a.etag!==y.ETAG_DISABLED&&await w,a?.atomic&&(0,y.hasFileAtomicReadCapability)(o)||!((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasFileReadStreamCapability)(o))||(0,y.hasReadWriteCapability)(o)&&a?.preferUnbuffered?p=this.readFileUnbuffered(o,n,a):(0,y.hasFileReadStreamCapability)(o)?p=this.readFileStreamed(o,n,r.token,a):p=this.readFileBuffered(o,n,r.token,a),p.on("end",()=>r.dispose()),p.on("error",()=>r.dispose()),{...await w,value:p}}catch(l){throw p&&await(0,m.consumeStream)(p),this.restoreReadError(l,n,a)}}restoreReadError(o,n,i){const t=(0,E.localize)(11,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(o).toString());return o instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(t,o.stat,i):o instanceof y.TooLargeFileOperationError?new y.TooLargeFileOperationError(t,o.fileOperationResult,o.size,o.options):new y.FileOperationError(t,(0,y.toFileOperationResult)(o),i)}readFileStreamed(o,n,i,t=Object.create(null)){const r=o.readFileStream(n,t,i);return(0,m.transform)(r,{data:a=>a instanceof A.VSBuffer?a:A.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,n,t)},a=>A.VSBuffer.concat(a))}readFileBuffered(o,n,i,t=Object.create(null)){const r=(0,A.newWriteableBufferStream)();return(0,u.readFileIntoStream)(o,n,r,a=>a,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,n,t)},i),r}readFileUnbuffered(o,n,i){const t=(0,m.newWriteableStream)(r=>A.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,y.hasFileAtomicReadCapability)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(n,r.byteLength,i),t.end(A.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(o,n){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new y.FileOperationError((0,E.localize)(12,null,this.resourceForError(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&n.etag===i.etag)throw new y.NotModifiedSinceFileOperationError((0,E.localize)(13,null),i,n);return this.validateReadFileLimits(o,i.size,n),i}validateReadFileLimits(o,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new y.TooLargeFileOperationError((0,E.localize)(14,null,this.resourceForError(o)),7,n,i)}async canMove(o,n,i){return this.doCanMoveCopy(o,n,"move",i)}async canCopy(o,n,i){return this.doCanMoveCopy(o,n,"copy",i)}async doCanMoveCopy(o,n,i,t){if(o.toString()!==n.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,o,a,n,i,t)}catch(r){return r}return!0}async move(o,n,i){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"move",!!i),w=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,a==="move"?2:3,w)),w}async copy(o,n,i){const t=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"copy",!!i),w=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,a==="copy"?3:2,w)),w}async doMoveCopy(o,n,i,t,r,a){if(n.toString()===t.toString())return r;const{exists:w,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(o,n,i,t,r,a);if(w&&!p&&a&&await this.del(t,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(t)),r==="copy"){if(o===i&&(0,y.hasFileFolderCopyCapability)(o))await o.copy(n,t,{overwrite:a});else{const l=await this.resolve(n);l.isDirectory?await this.doCopyFolder(o,l,i,t):await this.doCopyFile(o,n,i,t)}return r}else return o===i?(await o.rename(n,t,{overwrite:a}),r):(await this.doMoveCopy(o,n,i,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(o,n,i,t){if((0,y.hasOpenReadWriteCloseCapability)(o)&&(0,y.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,n,i,t);if((0,y.hasOpenReadWriteCloseCapability)(o)&&(0,y.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,n,i,t);if((0,y.hasReadWriteCapability)(o)&&(0,y.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,n,i,t);if((0,y.hasReadWriteCapability)(o)&&(0,y.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,n,i,t)}async doCopyFolder(o,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await U.Promises.settled(n.children.map(async r=>{const a=this.getExtUri(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),i,a):this.doCopyFile(o,r.resource,i,a)}))}async doValidateMoveCopy(o,n,i,t,r,a){let w=!1;if(o===i){const{providerExtUri:l,isPathCaseSensitive:S}=this.getExtUri(o);if(S||(w=l.isEqual(n,t)),w&&r==="copy")throw new Error((0,E.localize)(15,null,this.resourceForError(n),this.resourceForError(t)));if(!w&&l.isEqualOrParent(t,n))throw new Error((0,E.localize)(16,null,this.resourceForError(n),this.resourceForError(t)))}const p=await this.exists(t);if(p&&!w){if(!a)throw new y.FileOperationError((0,E.localize)(17,null,this.resourceForError(n),this.resourceForError(t)),4);if(o===i){const{providerExtUri:l}=this.getExtUri(o);if(l.isEqualOrParent(n,t))throw new Error((0,E.localize)(18,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:p,isSameResourceWithDifferentPathCase:w}}getExtUri(o){const n=this.isPathCaseSensitive(o);return{providerExtUri:n?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(n,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,0,i)),i}async mkdirp(o,n){const i=[],{providerExtUri:t}=this.getExtUri(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&y.FileType.Directory))throw new Error((0,E.localize)(19,null,this.resourceForError(n)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await o.mkdir(n)}catch(a){if((0,y.toFileSystemProviderErrorCode)(a)!==y.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.doValidateDelete(o,n)}catch(i){return i}return!0}async doValidateDelete(o,n){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,E.localize)(20,null,this.resourceForError(o)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,E.localize)(21,null,this.resourceForError(o)));if(t&&r)throw new Error((0,E.localize)(22,null,this.resourceForError(o)));let a;try{a=await i.stat(o)}catch{}if(a)this.throwIfFileIsReadonly(o,a);else throw new y.FileOperationError((0,E.localize)(23,null,this.resourceForError(o)),1);if(!!!n?.recursive){const p=await this.resolve(o);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,E.localize)(24,null,this.resourceForError(o)))}return i}async del(o,n){const i=await this.doValidateDelete(o,n);let t=n;if((0,y.hasFileAtomicDeleteCapability)(i)&&!t?.atomic){const p=i.enforceAtomicDelete?.(o);p&&(t={...n,atomic:p})}const r=!!t?.useTrash,a=!!t?.recursive,w=t?.atomic??!1;await i.delete(o,{recursive:a,useTrash:r,atomic:w}),this._onDidRunOperation.fire(new y.FileOperationEvent(o,1))}async cloneFile(o,n){const i=await this.withProvider(o),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(i===t&&this.getExtUri(i).providerExtUri.isEqual(o,n))return;if(i===t&&(0,y.hasFileCloneCapability)(i))return i.cloneFile(o,n);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n));const r=this.writeQueue.queueFor(o,this.getExtUri(i).providerExtUri);return i===t&&(0,y.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(o,n,{overwrite:!0})):r.queue(()=>this.doCopyFile(i,o,t,n))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:f.WATCHER_CORRELATION_IDS++})}watch(o,n={recursive:!1,excludes:[]}){const i=new g.DisposableStore;let t=!1,r=()=>{t=!0};i.add((0,g.toDisposable)(()=>r())),(async()=>{try{const w=await this.doWatch(o,n);t?(0,g.dispose)(w):r=()=>(0,g.dispose)(w)}catch(w){this.logService.error(w)}})();const a=n.correlationId;if(typeof a=="number"){const w=i.add(new L.Emitter);return i.add(this.internalOnDidFilesChange.event(l=>{l.correlates(a)&&w.fire(l)})),{onDidChange:w.event,dispose:()=>i.dispose()}}return i}async doWatch(o,n){const i=await this.withProvider(o),t=(0,R.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(o),n]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:i.watch(o,n)},this.activeWatchers.set(t,r)),r.count+=1,(0,g.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,g.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,g.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,n,i,t){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(t)||(0,m.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(o,r,t):await this.doWriteReadableBufferedQueued(o,r,t)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,n,i){let t=0,r;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=A.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,w)=>{(0,m.listenStream)(r,{onData:async p=>{r.pause();try{await this.doWriteBuffer(o,n,p,p.byteLength,t,0)}catch(l){return w(l)}t+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>w(p),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(o,n,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(o,n,i,t,r,a){let w=0;for(;w<t;){const p=await o.write(n,r+w,i.buffer,a+w,t-w);w+=p}}async doWriteUnbuffered(o,n,i,t){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,n,i,t))}async doWriteUnbufferedQueued(o,n,i,t){let r;t instanceof A.VSBuffer?r=t:(0,m.isReadableStream)(t)?r=await(0,A.streamToBuffer)(t):(0,m.isReadableBufferedStream)(t)?r=await(0,A.bufferedStreamToBuffer)(t):r=(0,A.readableToBuffer)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(o,n,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,n,i,t))}async doPipeBufferedQueued(o,n,i,t){let r,a;try{r=await o.open(n,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const w=A.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,l=0,S=0;do S=await o.read(r,p,w.buffer,l,w.byteLength-l),await this.doWriteBuffer(i,a,w,S,p,l),p+=S,l+=S,l===w.byteLength&&(l=0);while(S>0)}catch(w){throw(0,y.ensureFileSystemProviderError)(w)}finally{await U.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,n,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,n,i,t))}async doPipeUnbufferedQueued(o,n,i,t){return i.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,n,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,n,i,t))}async doPipeUnbufferedToBufferedQueued(o,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.doWriteBuffer(i,r,A.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(o,n,i,t){const r=await(0,A.streamToBuffer)(this.readFileBuffered(o,n,O.CancellationToken.None));await this.doWriteUnbuffered(i,t,void 0,r)}throwIfFileSystemIsReadonly(o,n){if(o.capabilities&2048)throw new y.FileOperationError((0,E.localize)(25,null,this.resourceForError(n)),6);return o}throwIfFileIsReadonly(o,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,E.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=C,e.FileService=C=f=ye([J(0,d.ILogService)],C)}),define(oe[199],ae([0,1,53,269,6,34,15,3,48,2,16,5,19,46,31,161,11,99,197,38,193,192]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,U.gracefulify)(k)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.toErrorMessage)(o)}`)}})();class s extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new O.ResourceMap(t=>v.extUriBiasedIgnorePathCase.getComparisonKey(t)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:t}=await m.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:y.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await m.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,v.joinPath)(n,r.name))).type:a=this.toType(r),t.push([r.name,a])}catch(a){this.logService.trace(a)}})),t}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let t;return i?.dangling?t=y.FileType.Unknown:n.isFile()?t=y.FileType.File:n.isDirectory()?t=y.FileType.Directory:t=y.FileType.Unknown,i&&(t|=y.FileType.SymbolicLink),t}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new A.Barrier;return this.resourceLocks.set(n,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),t=await this.createResourceLock(n));const r=this.toFilePath(n);return await m.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{t?.dispose()}}traceLock(n){s.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,t){const r=(0,c.newWriteableStream)(a=>L.VSBuffer.concat(a.map(w=>L.VSBuffer.wrap(w))).buffer);return(0,u.readFileIntoStream)(this,n,r,a=>a.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.canWriteFileAtomic(n)?this.doWriteFileAtomic(n,(0,v.joinPath)((0,v.dirname)(n),`${(0,v.basename)(n)}${t.atomic.postfix}`),i,t):this.doWriteFile(n,i,t)}async canWriteFileAtomic(n){try{const i=this.toFilePath(n),{symbolicLink:t}=await m.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async doWriteFileAtomic(n,i,t,r){const a=new g.DisposableStore;try{a.add(await this.createResourceLock(n)),a.add(await this.createResourceLock(i)),await this.doWriteFile(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(w){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{a.dispose()}}async doWriteFile(n,i,t,r){let a;try{const w=this.toFilePath(n);if(!t.create||!t.overwrite){if(await m.Promises.exists(w)){if(!t.overwrite)throw(0,y.createFileSystemProviderError)((0,E.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,y.createFileSystemProviderError)((0,E.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,i,0,i.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(n,w)}finally{typeof a=="number"&&await this.close(a)}}static{this.canFlush=!0}static configureFlushOnWrite(n){s.canFlush=n}async open(n,i,t){const r=this.toFilePath(n);let a;(0,y.isFileOpenForWriteOptions)(i)&&!t&&(a=await this.createResourceLock(n));let w;try{if((0,y.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:l}=await m.SymlinkSupport.stat(r);l.mode&128||await m.Promises.chmod(r,l.mode|128)}catch(l){l.code!=="ENOENT"&&this.logService.trace(l)}let p;if((0,y.isFileOpenForWriteOptions)(i)){if(b.isWindows)try{await m.Promises.truncate(r,0),p="r+"}catch(l){l.code!=="ENOENT"&&this.logService.trace(l)}p||(p="w")}else p="r";w=await m.Promises.open(r,p)}catch(p){throw a?.dispose(),(0,y.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,p):this.toFileSystemProviderError(p)}if(this.mapHandleToPos.set(w,0),(0,y.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(w,n),a){const p=this.mapHandleToLock.get(w);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${r})`),this.mapHandleToLock.set(w,a),p&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${r})`),p.dispose())}return w}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&s.canFlush)try{await m.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.logService.error(t)}return await m.Promises.close(n)}catch(t){throw this.toFileSystemProviderError(t)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,a){const w=this.normalizePos(n,i);let p=null;try{p=(await m.Promises.read(n,t,r,a,w)).bytesRead}catch(l){throw this.toFileSystemProviderError(l)}finally{this.updatePos(n,w,p)}return p}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,t){const r=this.mapHandleToPos.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.mapHandleToPos.set(n,r+t):this.mapHandleToPos.delete(n)))}async write(n,i,t,r,a){return(0,A.retry)(()=>this.doWrite(n,i,t,r,a),100,3)}async doWrite(n,i,t,r,a){const w=this.normalizePos(n,i);let p=null;try{p=(await m.Promises.write(n,t,r,a,w)).bytesWritten}catch(l){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),l)}finally{this.updatePos(n,w,p)}return p}async mkdir(n){try{await m.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const t=this.toFilePath(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.join)((0,P.dirname)(t),`${(0,P.basename)(t)}${i.atomic.postfix}`)),await m.Promises.rm(t,m.RimRafMode.MOVE,r)}else try{await m.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:p}=await m.SymlinkSupport.stat(t);a=w.isDirectory()&&!p}catch{}if(a)await m.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.toFileSystemProviderError(t)}}async rename(n,i,t){const r=this.toFilePath(n),a=this.toFilePath(i);if(r!==a)try{await this.validateMoveCopy(n,i,"move",t.overwrite),await m.Promises.rename(r,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,E.localize)(2,null,(0,P.basename)(r),(0,P.basename)((0,P.dirname)(a)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(n,i,t){const r=this.toFilePath(n),a=this.toFilePath(i);if(r!==a)try{await this.validateMoveCopy(n,i,"copy",t.overwrite),await m.Promises.copy(r,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,E.localize)(3,null,(0,P.basename)(r),(0,P.basename)((0,P.dirname)(a)),w.toString()))),this.toFileSystemProviderError(w)}}async validateMoveCopy(n,i,t,r){const a=this.toFilePath(n),w=this.toFilePath(i);let p=!1;if(!!(this.capabilities&1024)||(p=(0,I.isEqual)(a,w,!0)),p){if(t==="copy")throw(0,y.createFileSystemProviderError)((0,E.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const S=await this.statIgnoreError(n);if(!S)throw(0,y.createFileSystemProviderError)((0,E.localize)(5,null),y.FileSystemProviderErrorCode.FileNotFound);const _=await this.statIgnoreError(i);if(_){if(!r)throw(0,y.createFileSystemProviderError)((0,E.localize)(6,null),y.FileSystemProviderErrorCode.FileExists);S.type&y.FileType.File&&_.type&y.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,t){const r=this.toFilePath(n),a=this.toFilePath(i),w=!!(this.capabilities&1024);if((0,I.isEqual)(r,a,!w))return;const p=new g.DisposableStore;try{p.add(await this.createResourceLock(n)),p.add(await this.createResourceLock(i)),t&&await m.Promises.mkdir((0,P.dirname)(a),{recursive:!0}),await m.Promises.copyFile(r,a)}catch(l){if(l.code==="ENOENT"&&!t)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(l)}finally{p.dispose()}}createUniversalWatcher(n,i,t){return new f.UniversalWatcherClient(r=>n(r),r=>i(r),t)}createNonRecursiveWatcher(n,i,t){return new C.NodeJSWatcherClient(r=>n(r),r=>i(r),t)}toFileSystemProviderError(n){if(n instanceof y.FileSystemProviderError)return n;let i=n,t;switch(n.code){case"ENOENT":t=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=y.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=y.FileSystemProviderErrorCode.Unknown;break;default:t=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(n,i){let t=this.toFileSystemProviderError(i);if(n&&t.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await m.SymlinkSupport.stat(this.toFilePath(n));r.mode&128||(t=(0,y.createFileSystemProviderError)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return t}}e.DiskFileSystemProvider=s}),define(oe[101],ae([0,1,3,2,4,8]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("sharedProcessLifecycleService");let L=class extends U.Disposable{constructor(I){super(),this.logService=I,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=L,e.SharedProcessLifecycleService=L=ye([J(0,O.ILogService)],L)}),define(oe[200],ae([0,1,10,3,8,2]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class L extends A.AbstractLoggerService{constructor(b,v,c,m,E){super(v,c,m),this.windowId=b,this.channel=E,this._register(E.listen("onDidChangeLogLevel",b)(y=>{(0,A.isLogLevel)(y)?super.setLogLevel(y):super.setLogLevel(k.URI.revive(y[0]),y[1])})),this._register(E.listen("onDidChangeVisibility",b)(([y,u])=>super.setVisibility(k.URI.revive(y),u))),this._register(E.listen("onDidChangeLoggers",b)(({added:y,removed:u})=>{for(const d of y)super.registerLogger({...d,resource:k.URI.revive(d.resource)});for(const d of u)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new A.AdapterLogger({log:(b,v)=>{this.channel.call("consoleLog",[b,v])}})}registerLogger(b){super.registerLogger(b),this.channel.call("registerLogger",[b,this.windowId])}deregisterLogger(b){super.deregisterLogger(b),this.channel.call("deregisterLogger",[b,this.windowId])}setLogLevel(b,v){super.setLogLevel(b,v),this.channel.call("setLogLevel",[b,v])}setVisibility(b,v){super.setVisibility(b,v),this.channel.call("setVisibility",[this.toResource(b),v])}doCreateLogger(b,v,c){return new R(this.channel,b,v,c,this.windowId)}static setLogLevel(b,v,c){return b.call("setLogLevel",[v,c])}}e.LoggerChannelClient=L;class R extends A.AbstractMessageLogger{constructor(b,v,c,m,E){super(m?.logLevel==="always"),this.channel=b,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[v,m,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,v){const c=[[b,v]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(b){this.channel.call("log",[this.file,b])}}class I{constructor(b,v){this.loggerService=b,this.getUriTransformer=v}listen(b,v){const c=this.getUriTransformer(b);switch(v){case"onDidChangeLoggers":return U.Event.map(this.loggerService.onDidChangeLoggers,m=>({added:[...m.added].map(E=>this.transformLogger(E,c)),removed:[...m.removed].map(E=>this.transformLogger(E,c))}));case"onDidChangeVisibility":return U.Event.map(this.loggerService.onDidChangeVisibility,m=>[c.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return U.Event.map(this.loggerService.onDidChangeLogLevel,m=>(0,A.isLogLevel)(m)?m:[c.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${v}`)}async call(b,v,c){const m=this.getUriTransformer(b);switch(v){case"setLogLevel":return(0,A.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(k.URI.revive(m.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(E=>this.transformLogger(E,m)))}throw new Error(`Call not found: ${v}`)}transformLogger(b,v){return{...b,resource:v.transformOutgoingURI(b.resource)}}}e.LoggerChannel=I;class g extends O.Disposable{constructor(b,v){super(),v.call("setLogLevel",[b.getLogLevel()]),this._register(b.onDidChangeLogLevel(c=>v.call("setLogLevel",[c]))),v.call("getRegisteredLoggers").then(c=>{for(const m of c)b.registerLogger({...m,resource:k.URI.revive(m.resource)})}),this._register(v.listen("onDidChangeVisibility")(([c,m])=>b.setVisibility(k.URI.revive(c),m))),this._register(v.listen("onDidChangeLoggers")(({added:c,removed:m})=>{for(const E of c)b.registerLogger({...E,resource:k.URI.revive(E.resource)});for(const E of m)b.deregisterLogger(E.resource)}))}}e.RemoteLoggerChannelClient=g}),define(oe[201],ae([0,1,2,8]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class A extends k.Disposable{constructor(L,R=[]){super(),this.logger=new U.MultiplexLogger([L,...R]),this._register(L.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...R){this.logger.trace(L,...R)}debug(L,...R){this.logger.debug(L,...R)}info(L,...R){this.logger.info(L,...R)}warn(L,...R){this.logger.warn(L,...R)}error(L,...R){this.logger.error(L,...R)}flush(){this.logger.flush()}}e.LogService=A}),define(oe[55],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class L extends A.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(g){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...g,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(g),U.Iterable.reduce(this.policies.entries(),(b,[v,c])=>({...b,[v]:c}),{})}getPolicyValue(g){return this.policies.get(g)}serialize(){return U.Iterable.reduce(Object.entries(this.policyDefinitions),(g,[P,b])=>({...g,[P]:{definition:b,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=L;class R{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(oe[202],ae([0,1,3,2,56]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(I){this.service=I,this.disposables=new U.DisposableStore}listen(I,g){switch(g){case"onDidChange":return k.Event.map(this.service.onDidChange,P=>P.reduce((b,v)=>({...b,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${g}`)}call(I,g,P){switch(g){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${g}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=O;class L extends A.AbstractPolicyService{constructor(I,g){super(),this.channel=g;for(const P in I){const{definition:b,value:v}=I[P];this.policyDefinitions[P]=b,v!==void 0&&this.policies.set(P,v)}this.channel.listen("onDidChange")(P=>{for(const b in P){const v=P[b];v===null?this.policies.delete(b):this.policies.set(b,v)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(I){const g=await this.channel.call("updatePolicyDefinitions",I);for(const P in g)this.policies.set(P,g[P])}}e.PolicyChannelClient=L}),define(oe[102],ae([0,1,5,37]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const O=k.globals.vscode.context.configuration();if(O)A=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){A=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:O,searchUrl:L,itemUrl:R,controlUrl:I}=A.extensionsGallery||{};Object.assign(A,{extensionsGallery:{serviceUrl:U.env.VSCODE_GALLERY_SERVICE_URL||O,searchUrl:U.env.VSCODE_GALLERY_SEARCH_URL||L,itemUrl:U.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:U.env.VSCODE_GALLERY_CONTROL_URL||I}});try{const g=(...b)=>b.reduce((v,c)=>(Object.keys(c).forEach(m=>{Array.isArray(v[m])&&Array.isArray(c[m])?v[m]=c[m]:typeof v[m]=="object"&&typeof c[m]=="object"?v[m]=g(v[m],c[m]):v[m]=c[m]}),v),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};A=g(A,P)}catch{}if(U.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const g=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:g.version,release:g.release})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(oe[25],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[203],ae([0,1,6,7,2,16,31,8,25]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let g=class extends A.Disposable{constructor(b,v,c){super(),this.productService=v,this.logService=c,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},3e4)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),c=(0,O.dirname)(b),m=(0,O.basename)(b),E=await L.Promises.readdir(c);await Promise.all(E.map(async y=>{if(y===m)return;const u=(0,O.join)(c,y),d=await L.Promises.stat(u);if(d.isDirectory()&&v-d.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),L.Promises.rm(u)}))}catch(v){(0,U.onUnexpectedError)(v)}}};e.CodeCacheCleaner=g,e.CodeCacheCleaner=g=ye([J(1,I.IProductService),J(2,R.ILogService)],g)}),define(oe[204],ae([0,1,6,7,2,16,31,14,8,25]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends A.Disposable{constructor(v,c,m){super(),this.environmentService=v,this.logService=c,this.productService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),c=JSON.parse(await L.Promises.readFile((0,O.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(c)){const h=c[d];v[`${h.hash}.${d}`]=!0}const m=(0,O.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(m))return;const y=await L.Promises.readdir(m);for(const d of y){if(v[d]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await L.Promises.rm((0,O.join)(m,d))}const u=Date.now();for(const d of Object.keys(v)){const h=(0,O.join)(m,d),f=await L.Promises.readdir(h);for(const C of f){if(C==="tcf.json")continue;const s=(0,O.join)(h,C),o=await L.Promises.stat(s);o.isDirectory()&&u-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.join)(d,C)}`),await L.Promises.rm(s))}}}catch(v){(0,U.onUnexpectedError)(v)}}};e.LanguagePackCachedDataCleaner=P,e.LanguagePackCachedDataCleaner=P=ye([J(0,R.INativeEnvironmentService),J(1,I.ILogService),J(2,g.IProductService)],P)}),define(oe[205],ae([0,1,16,4]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,U.createDecorator)("IV8InspectProfilingService");var A;(function(O){function L(I){return!!(I.samples&&I.timeDeltas)}O.isValidProfile=L;function R(I,g="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,k.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,k.join)(g,(0,k.basename)(P.callFrame.url)));return I}O.rewriteAbsolutePaths=R})(A||(e.Utils=A={}))}),define(oe[206],ae([0,1,32]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class U{constructor(){this._sessions=new Map}async startProfiling(O){const R=await(await new Promise((g,P)=>{te(["v8-inspect-profiler"],g,P)})).startProfiling({port:O.port,checkForPaused:!0}),I=(0,k.generateUuid)();return this._sessions.set(I,R),I}async stopProfiling(O){const L=this._sessions.get(O);if(!L)throw new Error(`UNKNOWN session '${O}'`);const R=await L.stop();return this._sessions.delete(O),R.profile}}e.InspectProfilingService=U}),define(oe[40],ae([0,1,126,12]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(L,R){k.ok(U.isString(L)),k.ok(U.isObject(R)),k.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,R)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new A}),define(oe[103],ae([0,1,3,40]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class O{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,g){this.schemasById[A(I)]=g,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new O;U.Registry.add(e.Extensions.JSONContribution,L)}),define(oe[50],ae([0,1,18,3,12,148,20,103,40]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(R.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new U.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new U.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const n=new Set;this.doRegisterConfigurations(s,o,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const o=new Set;this.doDeregisterConfigurations(s,o),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:s,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(s,!1,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(s){const o=new Set;this.doRegisterDefaultConfigurations(s,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(s,o){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(o.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.configurationDefaultsOverrides.get(r),w=a?.valuesSources??new Map;if(t)for(const _ of Object.keys(i[r]))w.set(_,t);const p={...a?.value||{},...i[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:p,valuesSources:w});const l=(0,L.getLanguageTagSettingPlainKey)(r),S={type:"object",default:p,description:O.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:A.isString(t)?void 0:t,defaultValueSource:t};n.push(...E(r)),this.configurationProperties[r]=S,this.defaultLanguageConfigurationOverridesNode.properties[r]=S}else{this.configurationDefaultsOverrides.set(r,{value:i[r],source:t});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(s){const o=new Set;this.doDeregisterDefaultConfigurations(s,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(s,o){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.configurationDefaultsOverrides.get(t),a=A.isString(i)?i:i?.id,w=A.isString(r?.source)?r?.source:r?.source?.id;if(a===w)if(o.add(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const p=this.configurationProperties[t];p&&(this.updatePropertyDefaultValue(t,p),this.updateSchema(t,p))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(s){let o=!1;const n=new Set;s.removedDefaults&&(this.doDeregisterDefaultConfigurations(s.removedDefaults,n),o=!0),s.addedDefaults&&(this.doRegisterDefaultConfigurations(s.addedDefaults,n),o=!0),s.removedConfigurations&&this.doDeregisterConfigurations(s.removedConfigurations,n),s.addedConfigurations&&this.doRegisterConfigurations(s.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){this.doRegisterOverrideIdentifiers(s),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(s){for(const o of s)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,o,n){s.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(s,o){const n=i=>{if(i.properties)for(const t in i.properties){o.add(t);const r=this.configurationProperties[t];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}}validateAndRegisterProperties(s,o=!0,n,i,t=3,r){t=A.isUndefinedOrNull(s.scope)?t:s.scope;const a=s.properties;if(a)for(const p in a){const l=a[p];if(o&&h(p,l)){delete a[p];continue}if(l.source=n,l.defaultDefaultValue=a[p].default,this.updatePropertyDefaultValue(p,l),e.OVERRIDE_PROPERTY_REGEX.test(p)?l.scope=void 0:(l.scope=A.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=A.isUndefinedOrNull(l.restricted)?!!i?.includes(p):l.restricted),a[p].hasOwnProperty("included")&&!a[p].included){this.excludedConfigurationProperties[p]=a[p],delete a[p];continue}else this.configurationProperties[p]=a[p],a[p].policy?.name&&this.policyConfigurations.set(a[p].policy.name,p);!a[p].deprecationMessage&&a[p].markdownDeprecationMessage&&(a[p].deprecationMessage=a[p].markdownDeprecationMessage),r.add(p)}const w=s.allOf;if(w)for(const p of w)this.validateAndRegisterProperties(p,o,n,i,t,r)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const o=n=>{const i=n.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);n.allOf?.forEach(o)};o(s)}updateSchema(s,o){switch(e.allSettings.properties[s]=o,o.scope){case 1:e.applicationSettings.properties[s]=o;break;case 2:e.machineSettings.properties[s]=o;break;case 6:e.machineOverridableSettings.properties[s]=o;break;case 3:e.windowSettings.properties[s]=o;break;case 4:e.resourceSettings.properties[s]=o;break;case 5:e.resourceSettings.properties[s]=o,this.resourceLanguageSettingsSchema.properties[s]=o;break}}removeFromSchema(s,o){switch(delete e.allSettings.properties[s],o.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const o=`[${s}]`,n={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const s={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,o){const n=this.configurationDefaultsOverrides.get(s);let i=n?.value,t=n?.source;A.isUndefined(i)&&(i=o.defaultDefaultValue,t=void 0),A.isUndefined(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",m=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(C){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let o=m.exec(C);for(;o?.length;){const n=o[1].trim();n&&s.push(n),o=m.exec(C)}}return(0,k.distinct)(s)}e.overrideIdentifiersFromKey=E;function y(C){return C.reduce((s,o)=>`${s}[${o}]`,"")}e.keyFromOverrideIdentifiers=y;function u(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const d=new v;I.Registry.add(e.Extensions.Configuration,d);function h(C,s){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?O.localize(7,null,C):d.getConfigurationProperties()[C]!==void 0?O.localize(8,null,C):s.policy?.name&&d.getPolicyConfigurations().get(s.policy?.name)!==void 0?O.localize(9,null,C,s.policy?.name,d.getPolicyConfigurations().get(s.policy?.name)):null:O.localize(6,null)}e.validateProperty=h;function f(){const C=[],s=d.getConfigurationProperties();for(const o of Object.keys(s))C.push([o,s[o].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=f}),define(oe[74],ae([0,1,18,3,35,2,34,30,12,10,20,50,40]),function(te,e,k,U,A,O,L,R,I,g,P,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function c(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class m{constructor(n={},i=[],t=[],r){this._contents=n,this._keys=i,this._overrides=t,this.raw=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof m)return i;const t=new E("");return t.parseRaw(i),t.configurationModel});this._rawConfiguration=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,a=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,i){const t=this.getContentsForOverrideIdentifer(i);return t?n?(0,P.getConfigurationValue)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return k.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return k.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=R.deepClone(this.contents),t=R.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const w of n)if(a.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.mergeContents(i,w.contents);for(const p of w.overrides){const[l]=t.filter(S=>k.equals(S.identifiers,p.identifiers));l?(this.mergeContents(l.contents,p.contents),l.keys.push(...p.keys),l.keys=k.distinct(l.keys)):t.push(R.deepClone(p))}for(const p of w.keys)r.indexOf(p)===-1&&r.push(p)}return new m(i,r,t,a.every(w=>w instanceof m)?void 0:a)}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of k.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r];const w=i[r];w&&(typeof a=="object"&&typeof w=="object"?(a=R.deepClone(a),this.mergeContents(a,w)):a=w),t[r]=a}return new m(t,this.keys,this.overrides)}mergeContents(n,i){for(const t of Object.keys(i)){if(t in n&&I.isObject(n[t])&&I.isObject(i[t])){this.mergeContents(n[t],i[t]);continue}n[t]=R.deepClone(i[t])}}getContentsForOverrideIdentifer(n){let i=null,t=null;const r=a=>{a&&(t?this.mergeContents(t,a):t=R.deepClone(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?i=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.updateValue(n,i,!0)}setValue(n,i){this.updateValue(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>k.equals(t.identifiers,(0,b.overrideIdentifiersFromKey)(n))),1))}updateValue(n,i,t){(0,P.addToValueTree)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,P.toValuesTree)(this.contents[n],r=>console.error(r))})}}e.ConfigurationModel=m;class E{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!I.isUndefinedOrNull(n)){const t=this.doParseContent(n);this.parseRaw(t,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:t,keys:r,overrides:a,restricted:w,hasExcludedProperties:p}=this.doParseRaw(n,i);this._configurationModel=new m(t,r,a,p?[n]:void 0),this._restrictedConfigurations=w||[]}doParseContent(n){let i={},t=null,r=[];const a=[],w=[];function p(S){Array.isArray(r)?r.push(S):t!==null&&(r[t]=S)}const l={onObjectBegin:()=>{const S={};p(S),a.push(r),r=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const S=[];p(S),a.push(r),r=S,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:p,onError:(S,_,N)=>{w.push({error:S,offset:_,length:N})}};if(n)try{A.visit(n,l),i=r[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return i}doParseRaw(n,i){const t=v.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,t,!0,i);n=r.raw;const a=(0,P.toValuesTree)(n,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),w=Object.keys(n),p=this.toOverrides(n,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:a,keys:w,overrides:p,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(n,i,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const w={},p=[];for(const l in n)if(b.OVERRIDE_PROPERTY_REGEX.test(l)&&t){const S=this.filter(n[l],i,!1,r);w[l]=S.raw,a=a||S.hasExcludedProperties,p.push(...S.restricted)}else{const S=i[l],_=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&p.push(l),!r.exclude?.includes(l)&&(r.include?.includes(l)||(_===void 0||r.scopes===void 0||r.scopes.includes(_))&&!(r.skipRestricted&&S?.restricted))?w[l]=n[l]:a=!0}return{raw:w,restricted:p,hasExcludedProperties:a}}toOverrides(n,i){const t=[];for(const r of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const w in n[r])a[w]=n[r][w];t.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,i)})}return t}}e.ConfigurationModelParser=E;class y extends O.Disposable{constructor(n,i,t,r){super(),this.userSettingsResource=n,this.parseOptions=i,this.fileService=r,this._onDidChange=this._register(new U.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(U.Event.any(U.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),U.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class u{constructor(n,i,t,r,a,w,p,l,S,_,N,$,W){this.key=n,this.overrides=i,this._value=t,this.overrideIdentifiers=r,this.defaultConfiguration=a,this.policyConfiguration=w,this.applicationConfiguration=p,this.userConfiguration=l,this.localUserConfiguration=S,this.remoteUserConfiguration=_,this.workspaceConfiguration=N,this.folderConfigurationModel=$,this.memoryConfigurationModel=W}get value(){return c(this._value)}inspect(n,i,t){const r=n.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(n,i,t,r,a=new m,w=new m,p=new L.ResourceMap,l=new m,S=new L.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=w,this._folderConfigurations=p,this._memoryConfiguration=l,this._memoryConfigurationByResource=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(n,i,t){return this.getConsolidatedConfigurationModel(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new m,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,t){const r=this.getConsolidatedConfigurationModel(n,i,t),a=this.getFolderConfigurationModelForResource(i.resource,t),w=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=new Set;for(const l of r.overrides)for(const S of l.identifiers)r.getOverrideValue(n,S)!==void 0&&p.add(S);return new u(n,i,r.getValue(n),p.size?[...p]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this._workspaceConfiguration:void 0,a||void 0,w)}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:a,removed:w}=C(this._defaultConfiguration,n);i=[...r,...a,...w]}for(const r of i)for(const a of(0,b.overrideIdentifiersFromKey)(r)){const w=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=n.getKeysForOverrideIdentifier(a),l=[...p.filter(S=>w.indexOf(S)===-1),...w.filter(S=>p.indexOf(S)===-1),...w.filter(S=>!R.equals(this._defaultConfiguration.override(a).getValue(S),n.override(a).getValue(S)))];t.push([a,l])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=C(this._policyConfiguration,n),a=[...i,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=C(this.applicationConfiguration,n),w=[...i,...t,...r];return w.length&&this.updateApplicationConfiguration(n),{keys:w,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=C(this.localUserConfiguration,n),w=[...i,...t,...r];return w.length&&this.updateLocalUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=C(this.remoteUserConfiguration,n),w=[...i,...t,...r];return w.length&&this.updateRemoteUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=C(this.workspaceConfiguration,n),w=[...i,...t,...r];return w.length&&this.updateWorkspaceConfiguration(n),{keys:w,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:w,overrides:p}=C(t,i),l=[...r,...a,...w];return(l.length||!t)&&this.updateFolderConfiguration(n,i),{keys:l,overrides:p}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:w}=C(i,void 0);return{keys:[...t,...r,...a],overrides:w}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,t){let r=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},i){let t=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const r=i.getFolder(n);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const a=this._memoryConfigurationByResource.get(n);a&&(t=t.merge(a))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(i=t.merge(r),this._foldersConsolidatedConfigurations.set(n,i)):i=t}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:a}=this._folderConfigurations.get(i);return n.push([i,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this._workspaceConfiguration.keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),t=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),a=this.parseConfigurationModel(n.user),w=this.parseConfigurationModel(n.workspace),p=n.folders.reduce((l,S)=>(l.set(g.URI.revive(S[0]),this.parseConfigurationModel(S[1])),l),new L.ResourceMap);return new d(i,t,r,a,new m,w,p,new m,new L.ResourceMap)}static parseConfigurationModel(n){return new m(n.contents,n.keys,n.overrides)}}e.Configuration=d;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,w])=>{const p=(0,L.getOrSet)(i,a,new Set);w.forEach(l=>p.add(l))});const t=[];return i.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.mergeChanges=h;class f{constructor(n,i,t,r){this.change=n,this.previous=i,this.currentConfiguraiton=t,this.currentWorkspace=r,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const w of a)this.affectedKeys.add(w);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){const t=this._marker+n,r=this._affectsConfigStr.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this._affectsConfigStr.length)return!1;const w=this._affectsConfigStr.charCodeAt(a);if(w!==this._markerCode1&&w!==this._markerCode2)return!1;if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!R.equals(p,l)}return!0}}e.ConfigurationChangeEvent=f;function C(o,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,o?.rawConfiguration),a=[],w=o?.getAllOverrideIdentifiers()||[],p=n?.getAllOverrideIdentifiers()||[];if(n){const l=p.filter(S=>!w.includes(S));for(const S of l)a.push([S,n.getKeysForOverrideIdentifier(S)])}if(o){const l=w.filter(S=>!p.includes(S));for(const S of l)a.push([S,o.getKeysForOverrideIdentifier(S)])}if(n&&o){for(const l of w)if(p.includes(l)){const S=s({contents:o.getOverrideValue(void 0,l)||{},keys:o.getKeysForOverrideIdentifier(l)},{contents:n.getOverrideValue(void 0,l)||{},keys:n.getKeysForOverrideIdentifier(l)});a.push([l,[...S.added,...S.removed,...S.updated]])}}return{added:i,removed:t,updated:r,overrides:a}}function s(o,n){const i=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const w=(0,P.getConfigurationValue)(n.contents,a),p=(0,P.getConfigurationValue)(o.contents,a);R.equals(w,p)||r.push(a)}}return{added:i,removed:t,updated:r}}}),define(oe[207],ae([0,1,18,3,2,30,12,74,50,8,56,40]),function(te,e,k,U,A,O,L,R,I,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends A.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(b.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:u})=>this.onDidUpdateConfiguration(Array.from(y),u))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(y,u){this.updateConfigurationModel(y,b.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:y})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new R.ConfigurationModel;const y=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(y),y)}updateConfigurationModel(y,u){const d=this.getConfigurationDefaultOverrides();for(const h of y){const f=d[h],C=u[h];f!==void 0?this._configurationModel.addValue(h,f):C?this._configurationModel.addValue(h,C.default):this._configurationModel.removeValue(h)}}}e.DefaultConfiguration=v;class c{constructor(){this.onDidChangeConfiguration=U.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=c;let m=class extends A.Disposable{get configurationModel(){return this._configurationModel}constructor(y,u,d){super(),this.defaultConfiguration=y,this.policyService=u,this.logService=d,this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(y=>this.onDidChangePolicies(y))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:y})=>this.update(await this.updatePolicyDefinitions(y),!0))),this._configurationModel}async updatePolicyDefinitions(y){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",y);const u={},d=[],h=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const f of y){const C=h[f];if(!C){d.push(f);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.logService.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}d.push(f),u[C.policy.name]={type:C.type}}}return(0,L.isEmptyObject)(u)||await this.policyService.updatePolicyDefinitions(u),d}onDidChangePolicies(y){this.logService.trace("PolicyConfiguration#onDidChangePolicies",y);const u=b.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),d=(0,k.coalesce)(y.map(h=>u.get(h)));this.update(d,!0)}update(y,u){this.logService.trace("PolicyConfiguration#update",y);const d=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),h=[],f=this._configurationModel.isEmpty();for(const C of y){const s=d[C]?.policy?.name;if(s){const o=this.policyService.getPolicyValue(s);(f?o!==void 0:!(0,O.equals)(this._configurationModel.getValue(C),o))&&h.push([C,o])}else this._configurationModel.getValue(C)!==void 0&&h.push([C,void 0])}if(h.length){this.logService.trace("PolicyConfiguration#changed",h);const C=this._configurationModel;this._configurationModel=new R.ConfigurationModel;for(const s of C.keys)this._configurationModel.setValue(s,C.getValue(s));for(const[s,o]of h)o===void 0?this._configurationModel.removeValue(s):this._configurationModel.setValue(s,o);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=m,e.PolicyConfiguration=m=ye([J(1,P.IPolicyService),J(2,g.ILogService)],m)}),define(oe[208],ae([0,1,6,3,2,19,20,74,207,56]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends A.Disposable{constructor(v,c,m,E){super(),this.settingsResource=v,this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=m instanceof g.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,m,E)),this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,{},O.extUriBiasedIgnorePathCase,c)),this.configuration=new R.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:u})=>this.onDidDefaultConfigurationChange(y,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,c,m]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new R.Configuration(v,c,new R.ConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(v,c){const m=typeof v=="string"?v:void 0,E=(0,L.isConfigurationOverrides)(v)?v:(0,L.isConfigurationOverrides)(c)?c:{};return this.configuration.getValue(m,E,void 0)}updateValue(v,c,m,E){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const c=this.configuration.toData(),m=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(m,c,2)}onDidDefaultConfigurationChange(v,c){const m=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(v,c);this.trigger(E,m,7)}onDidPolicyConfigurationChange(v){const c=this.configuration.toData(),m=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(m,c,7)}trigger(v,c,m){const E=new R.ConfigurationChangeEvent(v,{data:c},this.configuration);E.source=m,E.sourceConfig=this.getTargetConfiguration(m),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(oe[209],ae([0,1,15,3,2,66]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const L=(g,P,b)=>{const v=new Uint8Array(16);for(let E=0;E<16;E++)v[E]=Math.round(Math.random()*256);const c=(0,k.encodeBase64)(k.VSBuffer.wrap(v));return[`GET ws://localhost${g}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=L,e.socketRawEndHeaderSequence=k.VSBuffer.fromString(`\r
\r
`);async function R(g,P,b,v,c){g.write(k.VSBuffer.fromString((0,e.makeRawSocketHeaders)(P,b,v)));const m=new A.DisposableStore;try{return await new Promise((E,y)=>{let u;m.add(g.onData(d=>{u?u=k.VSBuffer.concat([u,d],u.byteLength+d.byteLength):u=d;const h=u.indexOf(e.socketRawEndHeaderSequence);if(h===-1)return;E(g),g.pauseData();const f=u.slice(h+e.socketRawEndHeaderSequence.byteLength);f.byteLength&&c.onData.fire(f)})),m.add(g.onClose(d=>y(d??new Error("socket closed")))),m.add(g.onEnd(()=>y(new Error("socket ended"))))})}catch(E){throw g.dispose(),E}finally{m.dispose()}}e.connectManagedSocket=R;class I extends A.Disposable{constructor(P,b){super(),this.debugLabel=P,this.pausableDataEmitter=this._register(new U.PauseableEmitter),this.onData=(...v)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...v)),this.didDisposeEmitter=this._register(new U.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(b.onData),this._register(b.onData.event(v=>this.pausableDataEmitter.fire(v))),this.onClose=this._register(b.onClose).event,this.onEnd=this._register(b.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(P,b){O.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,P,b)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=I}),define(oe[210],ae([0,1,7,4]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,U.createDecorator)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class O{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class L{constructor(b,v){this.host=b,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=L;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class I extends k.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof I&&b._code===R.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof I&&b._code===R.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof I&&b._code===R.NoResolverFound}static isInvalidAuthority(b){return b instanceof I&&b._code===R.InvalidAuthority}static isHandled(b){return b instanceof I&&b.isHandled}constructor(b,v=R.Unknown,c){super(b),this._message=b,this._code=v,this._detail=c,this.isHandled=v===R.NotAvailable&&c===!0,Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I;function g(P){const b=P.indexOf("+");return b===-1?P:P.substring(0,b)}e.getRemoteAuthorityPrefix=g}),define(oe[75],ae([0,1,23]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function U(g){return g.scheme===k.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=U;function A(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.getRemoteName=A;function O(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=O;function L(g){const{host:P,port:b}=I(g);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:b}}e.parseAuthorityWithPort=L;function R(g,P){let{host:b,port:v}=I(g);return typeof v>"u"&&(v=P),{host:b,port:v}}e.parseAuthorityWithOptionalPort=R;function I(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const b=g.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const v=g.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:g,port:void 0}}}),define(oe[44],ae([0,1,27,4,75]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(E){E.WIN32_X64="win32-x64",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.LINUX_PPC64LE="linux-ppc64le",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class I{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,u){if(typeof y>"u"||y===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof y=="string"||typeof u=="string"){const d=typeof y=="string"?y:y.value,h=typeof u=="string"?u:u.value;return k.equalsIgnoreCase(d,h)}return y._lower===u._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=I;class g{get size(){return this._set.size}constructor(y){if(this._set=new Set,y)for(const u of y)this.add(u)}add(y){this._set.add(I.toKey(y))}delete(y){return this._set.delete(I.toKey(y))}has(y){return this._set.has(I.toKey(y))}}e.ExtensionIdentifierSet=g;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(y){this._map.delete(I.toKey(y))}get(y){return this._map.get(I.toKey(y))}has(y){return this._map.has(I.toKey(y))}set(y,u){this._map.set(I.toKey(y),u)}values(){return this._map.values()}forEach(y){this._map.forEach(y)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function b(E){return v(E)}e.isApplicationScopedExtension=b;function v(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function c(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=c;function m(E,y){if(y){const u=`onResolveRemoteAuthority:${(0,A.getRemoteName)(y)}`;return!!E.activationEvents?.includes(u)}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[211],ae([0,1,2,44,11]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends k.Disposable{constructor(R,I,g,P,b){super(),this.userDataProfilesService=R,this.fileService=I,this.uriIdentityService=g,this.logService=b,this._register(P.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(P.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(R){for(const I of R)I.local&&this.invalidate(I.profileLocation)}onDidUnInstallExtension(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const I of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(I.extensionsResource,R)&&await this.deleteUserCacheFile(I);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(R){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(R.cacheHome,U.USER_MANIFEST_CACHE_FILE))}catch(I){(0,A.toFileOperationResult)(I)!==1&&this.logService.error(I)}}}e.ExtensionsManifestCache=O}),define(oe[212],ae([0,1,6,15,26,7,3,2,100,61,32,66,210,75]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var E;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(E||(e.ConnectionType=E={}));function y(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(j){const D=new A.CancellationTokenSource;return setTimeout(()=>D.cancel(),j),D.token}function d(j,D){if(j.isCancellationRequested||D.isCancellationRequested)return A.CancellationToken.Cancelled;const T=new A.CancellationTokenSource;return j.onCancellationRequested(()=>T.cancel()),D.onCancellationRequested(()=>T.cancel()),T.token}class h{get didTimeout(){return this._state==="timedout"}constructor(D){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((T,M)=>{this._resolvePromise=T,this._rejectPromise=M}),D.isCancellationRequested?this._timeout():this._disposables.add(D.onCancellationRequested(()=>this._timeout()))}registerDisposable(D){this._state==="pending"?this._disposables.add(D):D.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(D))}reject(D){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(D))}}function f(j,D){const T=new h(D);return T.registerDisposable(j.onControlMessage(M=>{const F=JSON.parse(M.toString()),V=z(F);V?T.reject(V):T.resolve(F)})),T.promise}function C(j,D,T,M,F,V,H,re){const ce=new h(re),he=g.StopWatch.create(!1);return j.info(`Creating a socket (${H})...`),I.mark(`code/willCreateSocket/${V}`),D.connect(T,M,F,H).then(ue=>{ce.didTimeout?(I.mark(`code/didCreateSocketError/${V}`),j.info(`Creating a socket (${H}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(I.mark(`code/didCreateSocketOK/${V}`),j.info(`Creating a socket (${H}) was successful after ${he.elapsed()} ms.`),ce.resolve(ue))},ue=>{I.mark(`code/didCreateSocketError/${V}`),j.info(`Creating a socket (${H}) returned an error after ${he.elapsed()} ms.`),j.error(ue),ce.reject(ue)}),ce.promise}function s(j,D){const T=new h(D);return j.then(M=>{T.didTimeout||T.resolve(M)},M=>{T.didTimeout||T.reject(M)}),T.promise}async function o(j,D,T,M){const F=ne(j,D);j.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let V;try{V=await C(j.logService,j.remoteSocketFactoryService,j.connectTo,(0,c.getRemoteServerRootPath)(j),`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,y(D),`renderer-${y(D)}-${j.reconnectionToken}`,M)}catch(ue){throw j.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),j.logService.error(ue),ue}j.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let H,re;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(V,null),H=j.reconnectionProtocol,re=!1):(H=new b.PersistentProtocol({socket:V}),re=!0),j.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const ce=await s(j.signService.createNewMessage((0,P.generateUuid)()),M),he={type:"auth",auth:j.connectionToken||"00000000000000000000",data:ce.data};H.sendControl(U.VSBuffer.fromString(JSON.stringify(he)));try{const ue=await f(H,d(M,u(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(j.logService.trace(`${F} 4/6. received SignRequest control message.`),!await s(j.signService.validate(ce,ue.signedData),M)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const fe=await s(j.signService.sign(ue.data),M),pe={type:"connectionType",commit:j.commit,signedData:fe,desiredConnectionType:D};return T&&(pe.args=T),j.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(U.VSBuffer.fromString(JSON.stringify(pe))),{protocol:H,ownsProtocol:re}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(j.logService.error(`${F} the handshake timed out. Error:`),j.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${F} received error control message when negotiating connection. Error:`),j.logService.error(ue)),re&&B(H),ue}}async function n(j,D,T,M){const F=Date.now(),V=ne(j,D),{protocol:H,ownsProtocol:re}=await o(j,D,T,M),ce=new h(M);return ce.registerDisposable(H.onControlMessage(he=>{const ue=JSON.parse(he.toString()),me=z(ue);me?(j.logService.error(`${V} received error control message when negotiating connection. Error:`),j.logService.error(me),re&&B(H),ce.reject(me)):(j.reconnectionProtocol?.endAcceptReconnection(),j.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${K(F)}!`),ce.resolve({protocol:H,firstMessage:ue}))})),ce.promise}async function i(j,D){const{protocol:T}=await n(j,1,void 0,D);return{protocol:T}}async function t(j,D,T){const{protocol:M,firstMessage:F}=await n(j,2,D,T),V=F&&F.debugPort;return{protocol:M,debugPort:V}}async function r(j,D,T){const M=Date.now(),F=ne(j,3),{protocol:V}=await o(j,3,D,T);return j.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${K(M)}!`),V}async function a(j,D,T){const{connectTo:M,connectionToken:F}=await j.addressProvider.getAddress();return{commit:j.commit,quality:j.quality,connectTo:M,connectionToken:F,reconnectionToken:D,reconnectionProtocol:T,remoteSocketFactoryService:j.remoteSocketFactoryService,signService:j.signService,logService:j.logService}}async function w(j,D,T){return l(j,async M=>{const{protocol:F}=await i(M,A.CancellationToken.None);return new x(j,D,T,M.reconnectionToken,F)})}e.connectRemoteAgentManagement=w;async function p(j,D){return l(j,async T=>{const{protocol:M,debugPort:F}=await t(T,D,A.CancellationToken.None);return new Y(j,D,T.reconnectionToken,M,F)})}e.connectRemoteAgentExtensionHost=p;async function l(j,D){for(let M=1;;M++)try{const F=(0,P.generateUuid)(),V=await a(j,F,null);return await D(V)}catch(F){if(M<5)j.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),j.logService.error(F);else throw j.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),j.logService.error(F),X.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(F)),F}}async function S(j,D,T){const M=await a(j,(0,P.generateUuid)(),null);return await r(M,{host:D,port:T},A.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function _(j){return(0,k.createCancelablePromise)(D=>new Promise((T,M)=>{const F=setTimeout(T,j*1e3);D.onCancellationRequested(()=>{clearTimeout(F),T()})}))}var N;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class ${constructor(D,T){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=$;class W{constructor(D,T,M,F){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.durationSeconds=M,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class q{constructor(D,T,M){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=q;class Q{constructor(D,T,M){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=M,this.type=4}}e.ConnectionGainEvent=Q;class G{constructor(D,T,M,F){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=M,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=G;class X extends R.Disposable{static triggerPermanentFailure(D,T,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=D,this._permanentFailureAttempt=T,this._permanentFailureHandled=M,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(D=>D._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(D=>D._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||X._permanentFailure}constructor(D,T,M,F,V){super(),this._connectionType=D,this._options=T,this.reconnectionToken=M,this.protocol=F,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(F.onSocketClose(H=>{const re=Z(this._connectionType,this.reconnectionToken,!0);H?H.type===0?(this._options.logService.info(`${re} received socket close event (hadError: ${H.hadError}).`),H.error&&this._options.logService.error(H.error)):(this._options.logService.info(`${re} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this._options.logService.error(H.event)):this._options.logService.info(`${re} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(H=>{const re=Z(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),X._instances.push(this),this._register((0,R.toDisposable)(()=>{const H=X._instances.indexOf(this);H>=0&&X._instances.splice(H,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const D=Z(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const F=M<T.length?T[M]:T[T.length-1];try{if(F>0){const H=_(F);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,H)),this._options.logService.info(`${D} waiting for ${F} seconds before reconnecting...`);try{await H}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${D} resolving connection...`);const V=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${D} connecting to ${V.connectTo}...`),await this._reconnect(V,u(m)),this._options.logService.info(`${D} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,O.isCancellationError)(V)){this._options.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,v.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(D,T,M){this._reconnectionFailureIsFatal?X.triggerPermanentFailure(D,T,M):this._gotoPermanentFailure(D,T,M)}_gotoPermanentFailure(D,T,M){this._onDidStateChange.fire(new G(this.reconnectionToken,D,T,M)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X;class x extends X{constructor(D,T,M,F,V){super(1,D,F,V,!0),this.client=this._register(new b.Client(V,{remoteAuthority:T,clientId:M},D.ipcLogger))}async _reconnect(D,T){await i(D,T)}}e.ManagementPersistentConnection=x;class Y extends X{constructor(D,T,M,F,V){super(2,D,M,F,!1),this._startArguments=T,this.debugPort=V}async _reconnect(D,T){await t(D,this._startArguments,T)}}e.ExtensionHostPersistentConnection=Y;function B(j){try{j.acceptDisconnect();const D=j.getSocket();j.dispose(),D.dispose()}catch(D){(0,O.onUnexpectedError)(D)}}function z(j){if(j&&j.type==="error"){const D=new Error(`Connection error: ${j.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function ee(j,D){for(;j.length<D;)j+=" ";return j}function ie(j,D){return`[remote-connection][${ee(y(j),13)}][${D.substr(0,5)}\u2026]`}function Z(j,D,T){return`${ie(j,D)}[${T?"reconnect":"initial"}]`}function ne(j,D){return`${Z(D,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.connectTo}]`}function K(j){return`${Date.now()-j} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,U.createDecorator)("remoteSocketFactoryService");class A{constructor(){this.factories={}}register(L,R){return this.factories[L]??=[],this.factories[L].push(R),(0,k.toDisposable)(()=>{const I=this.factories[L]?.indexOf(R);typeof I=="number"&&I>=0&&this.factories[L]?.splice(I,1)})}getSocketFactory(L){return(this.factories[L.type]||[]).find(I=>I.supports(L))}connect(L,R,I,g){const P=this.getSocketFactory(L);if(!P)throw new Error(`No socket factory found for ${L}`);return P.connect(L,R,I,g)}}e.RemoteSocketFactoryService=A}),define(oe[213],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,163]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var A;(function(O){O.disconnected=L=>({type:"disconnected",onTokenFailed:L}),O.connected=(L,R)=>({type:"connected",info:L,serviceInstallFailed:R}),O.connecting=L=>({type:"connecting",progress:L}),O.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,U.localize)(0,null)}),define(oe[57],ae([0,1,15,7,2,165,50,4,8,40]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class P{constructor(C){this.original=C}toJSON(){if(!this.headers){const C=Object.create(null);for(const s in this.original)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?C[s]="*****":C[s]=this.original[s];this.headers=C}return this.headers}}class b extends A.Disposable{constructor(C){super(),this.counter=0,this.logger=C.createLogger("network",{name:(0,O.localize)(0,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async logAndRequest(C,s,o){const n=`${C} #${++this.counter}: ${s.url}`;this.logger.trace(`${n} - begin`,s.type,new P(s.headers??{}));try{const i=await o();return this.logger.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${n} - error`,s.type,(0,U.getErrorMessage)(i)),i}}}e.AbstractRequestService=b;function v(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=v;function c(f){return f.res.statusCode===204}e.hasNoContent=c;async function m(f){return c(f)?null:(await(0,k.streamToBuffer)(f.stream)).toString()}e.asText=m;async function E(f){if(!v(f))throw new Error("Server returned "+f.res.statusCode);return m(f)}e.asTextOrError=E;async function y(f){if(!v(f))throw new Error("Server returned "+f.res.statusCode);if(c(f))return null;const s=(await(0,k.streamToBuffer)(f.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.asJson=y;function u(f){h(f)}e.updateProxyConfigurationsScope=u;let d;function h(f){const C=g.Registry.as(L.Extensions.Configuration),s=d;d={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},C.updateConfigurations({add:[d],remove:s?[s]:[]})}h(1)}),define(oe[214],ae([0,1,26,23,11,57]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(I,g){this.requestService=I,this.fileService=g}async download(I,g,P=k.CancellationToken.None){if(I.scheme===U.Schemas.file||I.scheme===U.Schemas.vscodeRemote){await this.fileService.copy(I,g);return}const b={type:"GET",url:I.toString(!0)},v=await this.requestService.request(b,P);if(v.res.statusCode===200)await this.fileService.writeFile(g,v.stream);else{const c=await(0,O.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${c}`)}}};e.DownloadService=L,e.DownloadService=L=ye([J(0,O.IRequestService),J(1,A.IFileService)],L)}),define(oe[215],ae([0,1,15,26]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class A{constructor(R){this.service=R}listen(R,I){throw new Error("Invalid listen")}call(R,I,g,P=U.CancellationToken.None){switch(I){case"request":return this.service.request(g[0],P).then(async({res:b,stream:v})=>{const c=await(0,k.streamToBuffer)(v);return[{statusCode:b.statusCode,headers:b.headers},c]});case"resolveProxy":return this.service.resolveProxy(g[0])}throw new Error("Invalid call")}}e.RequestChannel=A;class O{constructor(R){this.channel=R}async request(R,I){const[g,P]=await this.channel.call("request",[R],I);return{res:g,stream:(0,k.bufferToStream)(P)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}}e.RequestChannelClient=O}),define(oe[216],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class k{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(A){try{const O=await this.getValidator();if(O){const L=String(k._nextId++);return this.validators.set(L,O),{id:L,data:O.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,O){if(!A.id)return!0;const L=this.validators.get(A.id);if(!L)return!1;this.validators.delete(A.id);try{return L.validate(O)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(A){try{return await this.signValue(A)}catch{}return A}}e.AbstractSignService=k}),define(oe[106],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[218],ae([0,1,217]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class U extends k.AbstractSignService{getValidator(){return this.vsda().then(O=>new O.validator)}signValue(O){return this.vsda().then(L=>new L.signer().sign(O))}vsda(){return new Promise((O,L)=>te(["vsda"],O,L))}}e.SignService=U}),define(oe[76],ae([0,1,3,2]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class A extends U.Disposable{constructor(b,v,c){super(),this.channel=b,this.profile=v,this.workspace=c}async getItems(){const b={profile:this.profile,workspace:this.workspace},v=await this.channel.call("getItems",b);return new Map(v)}updateItems(b){const v={profile:this.profile,workspace:this.workspace};return b.insert&&(v.insert=Array.from(b.insert.entries())),b.delete&&(v.delete=Array.from(b.delete.values())),this.channel.call("updateItems",v)}optimize(){const b={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",b)}}class O extends A{constructor(b,v){super(b,v,void 0),this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(b=>this.onDidChangeStorage(b)))}onDidChangeStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class L extends O{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class R extends O{constructor(b,v){super(b,v)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class I extends A{constructor(b,v){super(b,void 0,v),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class g{constructor(b){this.channel=b}isUsed(b){const v={payload:b,profile:void 0,workspace:void 0};return this.channel.call("isUsed",v)}}e.StorageClient=g}),define(oe[107],ae([0,1,5,37,32]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(I){if(k.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function L(I,g,P,b,v,c,m,E,y){const u=Object.create(null);u["common.machineId"]=c,u["common.sqmId"]=m,u.sessionID=(0,A.generateUuid)()+Date.now(),u.commitHash=b,u.version=v,u["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,k.PlatformToString)(k.platform),u["common.nodePlatform"]=U.platform,u["common.nodeArch"]=P,u["common.product"]=y||"desktop",E&&(u["common.msftInternal"]=E);let d=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),k.isLinuxSnap&&(u["common.snap"]="true");const f=O(g);return f&&(u["common.platformDetail"]=f),u}e.resolveCommonProperties=L;function R(I){const g=U.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return I.some(b=>P===b)}e.verifyMicrosoftInternalDomain=R}),define(oe[22],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var U;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(U||(e.TelemetryLevel=U={}));var A;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(oe[219],ae([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const y=new Map;async function u(s,o){const n=`${s}::${o.join(":")}`,i=y.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,w=2e4;function p(S,_,N,$){const W=_.substring(S.length+1);return U.Promises.withAsyncBody(async q=>{let Q;try{Q=await P.Promises.readdir(_,{withFileTypes:!0})}catch{q();return}if($.count>=w){$.count+=Q.length,$.maxReached=!0,q();return}let G=Q.length;if(G===0){q();return}let X=Q;$.count+Q.length>w&&($.maxReached=!0,G=w-$.count,X=Q.slice(0,G)),$.count+=Q.length;for(const x of X)if(x.isDirectory()){if(N.includes(x.name)||await p(S,(0,L.join)(_,x.name),N,$),--G===0){q();return}}else{const Y=x.name.lastIndexOf(".");if(Y>=0){const B=x.name.substring(Y+1);B&&r.set(B,(r.get(B)??0)+1)}for(const B of t)B.relativePathPattern?.test(W)!==!1&&B.filePattern.test(x.name)&&a.set(B.tag,(a.get(B.tag)??0)+1);if(--G===0){q();return}}})}const l=U.Promises.withAsyncBody(async S=>{const _={count:0,maxReached:!1};await p(s,s,o,_);const N=await f(s);S({configFiles:d(a),fileTypes:d(r),fileCount:_.count,maxFilesReached:_.maxReached,launchConfigFiles:N})});return y.set(n,l),l}e.collectWorkspaceStats=u;function d(s){return Array.from(s.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function h(){const s={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.virtualMachineHint.value()*100)}%`},o=k.cpus();return o&&o.length>0&&(s.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),s}e.getMachineInfo=h;async function f(s){try{const o=new Map,n=(0,L.join)(s,".vscode","launch.json"),i=await P.Promises.readFile(n),t=[],r=(0,A.parse)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,A.getNodeType)(r)==="object"&&r.configurations)for(const a of r.configurations){const w=a.type;w&&(o.has(w)?o.set(w,o.get(w)+1):o.set(w,1))}return d(o)}catch{return[]}}e.collectLaunchConfigs=f;let C=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const i=k.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(k.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${k.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,b.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async i=>{let[t,r]=i,a=this.formatProcessList(o,t);return n.forEach(w=>{if((0,v.isRemoteDiagnosticError)(w))a+=`
${w.errorMessage}`,r+=`
${w.errorMessage}`;else if(a+=`

Remote: ${w.hostName}`,w.processes&&(a+=`
${this.formatProcessList(o,w.processes)}`),w.workspaceMetadata){r+=`
|  Remote: ${w.hostName}`;for(const p of Object.keys(w.workspaceMetadata)){const l=w.workspaceMetadata[p];let S=`${l.fileCount} files`;l.maxFilesReached&&(S=`more than ${S}`),r+=`|    Folder (${p}): ${S}`,r+=this.formatWorkspaceStats(l)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:i,vmHint:t,os:r,cpus:a}=h(),w={os:r,memory:i,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(w.load=`${k.loadavg().map(p=>Math.round(p)).join(", ")}`),R.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(o,n){const i=[];return(0,b.listProcesses)(o.mainPID).then(async t=>(i.push(""),i.push(this.formatEnvironment(o)),i.push(""),i.push(this.formatProcessList(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(o))),n.forEach(r=>{if((0,v.isRemoteDiagnosticError)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.formatMachineInfo(r.machineInfo)),r.processes&&i.push(this.formatProcessList(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const w=r.workspaceMetadata[a];let p=`${w.fileCount} files`;w.maxFilesReached&&(p=`more than ${p}`),i.push(`Folder (${a}): ${p}`),i.push(this.formatWorkspaceStats(w))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(o){const n=[];let t=0;const r=(l,S)=>{const _=` ${l}(${S})`;t+_.length>60?(n.push(a),a="|                 ",t=a.length):t+=_.length,a+=_};let a="|      File types:";const w=10,p=o.fileTypes.length>w?w:o.fileTypes.length;for(let l=0;l<p;l++){const S=o.fileTypes[l];r(S.name,S.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(l=>{r(l.name,l.count)}),n.push(a)),o.launchConfigFiles.length>0){let l="|      Launch Configs:";o.launchConfigFiles.forEach(S=>{const _=S.count>1?` ${S.name}(${S.count})`:` ${S.name}`;l+=_}),n.push(l)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${o[i]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],i=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=I.URI.revive(r);if(a.scheme===O.Schemas.file){const w=a.fsPath;i.push(u(w,["node_modules",".git"]).then(p=>{let l=`${p.fileCount} files`;p.maxFilesReached&&(l=`more than ${l}`),n.push(`|    Folder (${(0,L.basename)(w)}): ${l}`),n.push(this.formatWorkspaceStats(p))}).catch(p=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${p.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}formatProcessList(o,n){const i=new Map;o.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>i.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,i,t,n,0),t.join(`
`)}formatProcessItem(o,n,i,t,r){const a=r===0;let w;a?w=t.pid===o?`${this.productService.applicationName} main`:"remote agent":n.has(t.pid)?w=n.get(t.pid):w=`${"  ".repeat(r)} ${t.name}`;const p=process.platform==="win32"?t.mem:k.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(p/c.ByteSize.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(t.children)&&t.children.forEach(l=>this.formatProcessItem(o,n,i,l,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:i}of o.folders){const t=I.URI.revive(i);if(t.scheme!==O.Schemas.file)continue;const r=t.fsPath;try{(await u(r,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const i=I.URI.revive(n);if(i.scheme!==O.Schemas.file)continue;const t=i.fsPath;try{const r=await u(t,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.DiagnosticsService=C,e.DiagnosticsService=C=ye([J(0,E.ITelemetryService),J(1,m.IProductService)],C)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(O){this.appenders=O}listen(O,L){throw new Error(`Event not found: ${L}`)}call(O,L,{eventName:R,data:I}){return this.appenders.forEach(g=>g.log(R,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class U{constructor(O){this.channel=O}log(O,L){return this.channel.call("log",{eventName:O,data:L}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(oe[45],ae([0,1,30,12,3,20,75,107,22]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class b{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.NullEndpointTelemetryService=b,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,t){return A.Event.debounce(t.onDidChangeConfiguration,(a,w)=>{const p=a?new Set([...a.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:p}},1e3,!0)(a=>{a.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.configurationTelemetry=v;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=c;function m(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=m;function E(i){const t=i.getValue(I.TELEMETRY_SETTING_ID),r=i.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function y(i){const t={},r={},a={};h(i,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const p=a[w];typeof p=="number"?r[w]=p:typeof p=="boolean"?r[w]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${p.length}`),t[w]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(t[w]=p)}return{properties:t,measurements:r}}e.validateTelemetryData=y;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(i){if(!i)return"none";const t=(0,L.getRemoteName)(i);return u.has(t)?t:"other"}e.cleanRemoteAuthority=d;function h(i,t,r=0,a){if(i)for(const w of Object.getOwnPropertyNames(i)){const p=i[w],l=a?a+w:w;Array.isArray(p)?t[l]=(0,k.safeStringify)(p):p instanceof Date?t[l]=p.toISOString():(0,U.isObject)(p)?r<2?h(p,t,r+1,l+"."):t[l]=(0,k.safeStringify)(p):t[l]=p}}function f(i,t){const r=i.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(r)||a}e.isInternalTelemetry=f;function C(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=C;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const a=[];for(const S of t)for(;;){const _=S.exec(i);if(!_)break;a.push([_.index,S.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const S=p.exec(i);if(!S)break;const _=a.some(([N,$])=>S.index<$&&N<p.lastIndex);!w.test(S[0])&&!_&&(r+=i.substring(l,S.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<i.length&&(r+=i.substr(l)),r}function o(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,k.cloneAndChange)(i,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=s(a,t);for(const w of t)a=a.replace(w,"");return a=o(a),a}})}e.cleanData=n}),define(oe[33],ae([0,1,27,29,44,5,10,7,37,45]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,k.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=P;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,t,r)}static parse(i){const t=b.exec(i);return t&&t[1]&&t[2]?new v({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(n){const i=c.exec(n);return i&&i[1]?[y(i[1]),i[2]]:[y(n),void 0]}e.getIdAndVersion=m;function E(n,i){return`${n}.${i}`}e.getExtensionId=E;function y(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=y;function u(n,i){return y(E(n??A.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=u;function d(n,i){const t=[],r=a=>{for(const w of t)if(w.some(p=>P(i(p),i(a))))return w;return null};for(const a of n){const w=r(a);w?w.push(a):t.push([a])}return t}e.groupByExtension=d;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=h;function f(n){return{id:new g.TelemetryTrustedValue(n.identifier.id),name:new g.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function C(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(w=>!P(w.identifier,{id:a}))){const w=n.filter(p=>P(p.identifier,{id:a}));w.length===1&&(t.push(w[0]),r.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.getExtensionDependencies=C;async function s(n,i){if(!O.isLinux)return!1;let t;try{t=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const t=await s(n,i),r=(0,U.getTargetPlatform)(t?"alpine":O.platform,I.arch);return i.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=o}),define(oe[220],ae([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let m=class extends U.Disposable{constructor(h,f){super(),this.fileService=h,this.productService=f,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,C])=>this.allConfigBasedTips.set(C.configPath,C))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const f=[];for(const[C,s]of this.allConfigBasedTips)if(!(s.configScheme&&s.configScheme!==h.scheme))try{const o=(await this.fileService.readFile((0,A.joinPath)(h,C))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(o))&&f.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return f}};e.ExtensionTipsService=m,e.ExtensionTipsService=m=ye([J(0,L.IFileService),J(1,R.IProductService)],m);const E="extensionTips/promptedExecutableTips",y="extensionTips/lastPromptedMediumImpExeTime";class u extends m{constructor(h,f,C,s,o,n,i,t){super(i,t),this.userHome=h,this.windowEvents=f,this.telemetryService=C,this.extensionManagementService=s,this.storageService=o,this.extensionRecommendationNotificationService=n,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const w=[],p=[],l=[];Object.entries(a.recommendations).forEach(([S,_])=>{_.important?a.important?w.push({extensionId:S,extensionName:_.name,isExtensionPack:!!_.isExtensionPack}):p.push({extensionId:S,extensionName:_.name,isExtensionPack:!!_.isExtensionPack}):l.push({extensionId:S,extensionName:_.name,isExtensionPack:!!_.isExtensionPack})}),w.length&&this.highImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),p.length&&this.mediumImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:p}),l.length&&this.allOtherExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:l})}),(0,I.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const h=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),f=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...h,...f]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const h=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),f=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),C=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(h,C),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(f,C)}groupImportantTipsByExe(h,f){const C=new Map;h.forEach(t=>C.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:o}=this.groupByInstalled([...C.keys()],f);for(const t of s){const r=C.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=C.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.getPromptedExecutableTips(),i=new Map;for(const t of o){const r=C.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=i.get(r.exeName);a||(a=[],i.set(r.exeName,a)),a.push(r)}}return i}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[h,f]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(f).then(C=>{switch(C){case"reacted":this.addToRecommendedExecutables(f[0].exeName,f);break;case"ignored":this.highImportanceTipsByExe.delete(h);break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(s(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const s=this._register(new U.MutableDisposable);s.value=(0,I.disposableTimeout)(()=>{s.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const h=this.getLastPromptedMediumExeTime(),f=Date.now()-h,C=7*24*60*60*1e3;if(f<C){const n=this._register(new U.MutableDisposable);n.value=(0,I.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},C-f);return}const[s,o]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(n=>{switch(n){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(s),this.addToRecommendedExecutables(o[0].exeName,o);const i=this._register(new U.MutableDisposable);i.value=(0,I.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},C);break}case"ignored":this.mediumImportanceTipsByExe.delete(s),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(i(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const i=this._register(new U.MutableDisposable);i.value=(0,I.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(h){const f=await this.extensionManagementService.getInstalled(1),C=h.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(o=>f.every(n=>!(0,c.areSameExtensions)(n.identifier,{id:o})))).map(({extensionId:s})=>s.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:C,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}getLastPromptedMediumExeTime(){let h=this.storageService.getNumber(y,-1);return h||(h=Date.now(),this.updateLastPromptedMediumExeTime(h)),h}updateLastPromptedMediumExeTime(h){this.storageService.store(y,h,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(E,-1,"{}"))}addToRecommendedExecutables(h,f){const C=this.getPromptedExecutableTips();C[h]=f.map(({extensionId:s})=>s.toLowerCase()),this.storageService.store(E,JSON.stringify(C),-1,0)}groupByInstalled(h,f){const C=[],s=[],o=f.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{o.has(n.toLowerCase())?C.push(n):s.push(n)}),{installed:C,uninstalled:s}}async getValidExecutableBasedExtensionTips(h){const f=[],C=new Map;for(const s of h.keys()){const o=h.get(s);if(!o||!(0,k.isNonEmptyArray)(o.recommendations))continue;const n=[];b.isWindows?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>v.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>v.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>v.env.ProgramFiles).replace("%APPDATA%",()=>v.env.APPDATA).replace("%WINDIR%",()=>v.env.WINDIR)):(n.push((0,P.join)("/usr/local/bin",s)),n.push((0,P.join)("/usr/bin",s)),n.push((0,P.join)(this.userHome.fsPath,s)));for(const i of n){let t=C.get(i);if(t===void 0&&(t=await this.fileService.exists(O.URI.file(i)),C.set(i,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:w,whenNotInstalled:p}of o.recommendations)f.push({extensionId:r,extensionName:a,isExtensionPack:w,exeName:s,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:p})}}return f}}e.AbstractNativeExtensionTipsService=u}),define(oe[221],ae([0,1,26,33]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function A(O,L,R,I,g){try{const P=await O.getExtensionsControlManifest();if(!P.deprecated)return;const b=await O.getInstalled(1);for(const[v,c]of Object.entries(P.deprecated)){if(!c?.extension)continue;const{id:m,autoMigrate:E,preRelease:y}=c.extension;if(!E)continue;const u=b.find(h=>(0,U.areSameExtensions)(h.identifier,{id:v}));if(!u)continue;const d=(await L.getExtensions([{id:m,preRelease:y}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!d){g.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${m}' extension is not found`);continue}try{g.info(`Migrating '${u.identifier.id}' extension to '${m}' extension...`);const h=!I.getDisabledExtensions().some(C=>(0,U.areSameExtensions)(C,u.identifier));await O.uninstall(u),g.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let f=b.find(C=>(0,U.areSameExtensions)(C.identifier,{id:m}));(!f||!f.isPreReleaseVersion&&h)&&(f=await O.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${f.identifier.id}'`),h||(await I.disableExtension(f.identifier),g.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),E.storage&&(R.addToMigrationList((0,U.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,U.getExtensionId)(f.manifest.publisher,f.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${u.identifier.id}' extension to '${m}' extension.`)}catch(h){g.error(h)}}}catch(P){g.error(P)}}e.migrateUnsupportedExtensions=A}),define(oe[222],ae([0,1,3,2,34,33,44]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends U.Disposable{constructor(g,P,b,v,c,m,E){super(),this.extensionManagementService=g,this.extensionsScannerService=P,this.userDataProfilesService=b,this.extensionsProfileScannerService=v,this.uriIdentityService=c,this.fileService=m,this.logService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new U.DisposableMap),this.initialize().then(null,y=>E.error(y))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(g=>this.onDidChangeProfiles(g.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(g=>this.onAddExtensions(g))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(g=>this.onDidAddExtensions(g))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(g=>this.onRemoveExtensions(g))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(g=>this.onDidRemoveExtensions(g))),this._register(this.fileService.onDidFilesChange(g=>this.onDidFilesChange(g)))}async onDidChangeProfiles(g){try{g.length&&await Promise.all(g.map(P=>(this.extensionsProfileWatchDisposables.set(P.id,(0,U.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(P.extensionsResource)),this.fileService.watch(P.extensionsResource))),this.populateExtensionsFromProfile(P.extensionsResource))))}catch(P){throw this.logService.error(P),P}}async onAddExtensions(g){for(const P of g.extensions)this.addExtensionWithKey(this.getKey(P.identifier,P.version),g.profileLocation)}async onDidAddExtensions(g){for(const P of g.extensions){const b=this.getKey(P.identifier,P.version);g.error?this.removeExtensionWithKey(b,g.profileLocation):this.addExtensionWithKey(b,g.profileLocation)}}async onRemoveExtensions(g){for(const P of g.extensions)this.removeExtensionWithKey(this.getKey(P.identifier,P.version),g.profileLocation)}async onDidRemoveExtensions(g){const P=[],b=[];for(const v of g.extensions){const c=this.getKey(v.identifier,v.version);g.error?this.addExtensionWithKey(c,g.profileLocation):(this.removeExtensionWithKey(c,g.profileLocation),this.allExtensions.has(c)||(this.logService.debug("Extension is removed from all profiles",v.identifier.id,v.version),b.push(this.extensionManagementService.scanInstalledExtensionAtLocation(v.location).then(m=>{m?P.push(m):this.logService.info("Extension not found at the location",v.location.toString())},m=>this.logService.error(m)))))}try{await Promise.all(b),P.length&&await this.uninstallExtensionsNotInProfiles(P)}catch(v){this.logService.error(v)}}onDidFilesChange(g){for(const P of this.userDataProfilesService.profiles)g.contains(P.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(P.extensionsResource)}async onDidExtensionsProfileChange(g){const P=[],b=[],v=await this.extensionsProfileScannerService.scanProfileExtensions(g),c=new Set,m=new Set;for(const[E,y]of this.allExtensions)y.has(g)&&m.add(E);for(const E of v){const y=this.getKey(E.identifier,E.version);c.add(y),m.has(y)||(P.push(E.identifier),this.addExtensionWithKey(y,g))}for(const E of m)if(!c.has(E)){const y=this.fromKey(E);y&&(b.push(y.identifier),this.removeExtensionWithKey(E,g))}(P.length||b.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P.length?{extensions:P,profileLocation:g}:void 0,removed:b.length?{extensions:b,profileLocation:g}:void 0})}async populateExtensionsFromProfile(g){const P=await this.extensionsProfileScannerService.scanProfileExtensions(g);for(const b of P)this.addExtensionWithKey(this.getKey(b.identifier,b.version),g)}async uninstallExtensionsNotInProfiles(g){g||(g=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(b=>!this.allExtensions.has(this.getKey(b.identifier,b.manifest.version)))),g.length&&await this.extensionManagementService.markAsUninstalled(...g)}addExtensionWithKey(g,P){let b=this.allExtensions.get(g);b||this.allExtensions.set(g,b=new A.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(v))),b.add(P)}removeExtensionWithKey(g,P){const b=this.allExtensions.get(g);b&&b.delete(P),b?.size||this.allExtensions.delete(g)}getKey(g,P){return`${L.ExtensionIdentifier.toKey(g.id)}@${P}`}fromKey(g){const[P,b]=(0,O.getIdAndVersion)(g);return b?{identifier:{id:P},version:b}:void 0}}e.ExtensionsWatcher=R}),define(oe[223],ae([0,1,43,45]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function A(O,L,R,I,g,P,b){const v={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${L.nameShort})`};if((0,U.supportsTelemetry)(L,R)&&(0,U.getTelemetryLevel)(I)===3){const c=await(0,k.getServiceMachineId)(R,g,P);v["X-Market-User-Id"]=c,v["VSCode-SessionId"]=b.machineId||c}return v}e.resolveMarketplaceHeaders=A}),define(oe[224],ae([0,1,70,18,6,2,23,16,31,14,29,33,8,73,10]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends c.LanguagePackBaseService{constructor(h,f,C,s){super(C),this.extensionManagementService=h,this.logService=s,this.cache=this._register(new y(f,s)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(h,f){const s=(await this.cache.getLanguagePacks())[f];if(!s){this.logService.warn(`No language pack found for ${f}`);return}const o=s.translations[h];return o?m.URI.file(o):void 0}async getInstalledLanguages(){const h=await this.cache.getLanguagePacks(),f=Object.keys(h).map(C=>{const s=h[C];return{...this.createQuickPickItem(C,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return f.push(this.createQuickPickItem("en","English")),f.sort((C,s)=>C.label.localeCompare(s.label)),f}async postInstallExtension(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",h.identifier.id),await this.update())}async postUninstallExtension(h){const f=await this.cache.getLanguagePacks();Object.keys(f).some(C=>f[C]&&f[C].extensions.some(s=>(0,b.areSameExtensions)(s.extensionIdentifier,h.identifier)))&&(this.logService.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),C=await this.cache.update(f);return!(0,U.equals)(Object.keys(h),Object.keys(C))}};e.NativeLanguagePackService=E,e.NativeLanguagePackService=E=ye([J(0,P.IExtensionManagementService),J(1,g.INativeEnvironmentService),J(2,P.IExtensionGalleryService),J(3,v.ILogService)],E);let y=class extends O.Disposable{constructor(h,f){super(),this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(h.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new A.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(h){return this.withLanguagePacks(f=>{Object.keys(f).forEach(C=>delete f[C]),this.createLanguagePacksFromExtensions(f,...h)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(h,...f){for(const C of f)C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(h,C);Object.keys(h).forEach(C=>this.updateHash(h[C]))}createLanguagePacksFromExtension(h,f){const C=f.identifier,s=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const o of s)if(f.location.scheme===L.Schemas.file&&u(o)){let n=h[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},h[o.languageId]=n);const i=n.extensions.filter(t=>(0,b.areSameExtensions)(t.extensionIdentifier,C))[0];i?i.version=f.manifest.version:n.extensions.push({extensionIdentifier:C,version:f.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.join)(f.location.fsPath,t.path)}}updateHash(h){if(h){const f=(0,k.createHash)("md5");for(const C of h.extensions)f.update(C.extensionIdentifier.uuid||C.extensionIdentifier.id).update(C.version);h.hash=f.digest("hex")}}withLanguagePacks(h=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,C=>C.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(C)).then(C=>{try{return JSON.parse(C)}catch{return{}}}).then(C=>(f=h(C),C)).then(C=>{for(const o of Object.keys(C))C[o]||delete C[o];this.languagePacks=C,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),I.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>f,C=>this.logService.error(C))})}};y=ye([J(0,g.INativeEnvironmentService),J(1,v.ILogService)],y);function u(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const h of d.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(oe[225],ae([0,1,141,7,30,45]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function I(P,b,v){const c=await(0,k.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),m=await(0,k.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),E=new c.AppInsightsCore,y=new m.PostChannel,u={instrumentationKey:P,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(v){u.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:v};u.extensionConfig[y.identifier]=d}return E.initialize(u,[]),E.addTelemetryInitializer(d=>{b&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),E}class g{constructor(b,v,c,m,E){this._isInternalTelemetry=b,this._eventPrefix=v,this._defaultData=c,this._xhrOverride=E,this.endPointUrl=L,this.endPointHealthUrl=R,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(b){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=I(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(v=>{b(v)},v=>{(0,U.onUnexpectedError)(v),console.error(v)})}}log(b,v){if(!this._aiCoreOrKey)return;v=(0,A.mixin)(v,this._defaultData),v=(0,O.validateTelemetryData)(v);const c=this._eventPrefix+"/"+b;try{this._withAIClient(m=>{m.pluginVersionString=v?.properties.version??"Unknown",m.track({name:c,baseData:{name:c,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(v=>{v.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(oe[109],ae([0,1,2,166,14,8,25,45]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends k.Disposable{constructor(P,b,v,c,m=""){super(),this.prefix=m;const E=b.getLogger(R.telemetryLogId);if(E)this.logger=this._register(E);else{const u=(0,R.isLoggingOnly)(c,v)?" (Not Sent)":"",d=()=>(0,R.supportsTelemetry)(c,v)&&P.getLevel()===O.LogLevel.Trace;this.logger=this._register(b.createLogger(R.telemetryLogId,{name:(0,U.localize)(0,null,u),hidden:!d()})),this._register(P.onDidChangeLogLevel(()=>b.setVisibility(R.telemetryLogId,d()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,b){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,R.validateTelemetryData)(b))}};e.TelemetryLogAppender=I,e.TelemetryLogAppender=I=ye([J(0,O.ILogService),J(1,O.ILoggerService),J(2,A.IEnvironmentService),J(3,L.IProductService)],I)}),define(oe[110],ae([0,1,2,30,5,27,167,20,50,102,25,40,22,45]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,d,h){this._configurationService=d,this._productService=h,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(f=>{(f.affectsConfiguration(v.TELEMETRY_SETTING_ID)||f.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||f.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(u,d){this._experimentProperties[u]=d}_updateTelemetryLevel(){let u=(0,c.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const h=d.usage?3:d.error?2:0;u=Math.min(u,h)}this._telemetryLevel=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(u,d,h){this._telemetryLevel<d||(h=(0,U.mixin)(h,this._experimentProperties),h=(0,c.cleanData)(h,this._cleanupPatterns),h=(0,U.mixin)(h,this._commonProperties),this._appenders.forEach(f=>f.log(u,h)))}publicLog(u,d){this._log(u,3,d)}publicLog2(u,d){this.publicLog(u,d)}publicLogError(u,d){this._sendErrorTelemetry&&this._log(u,2,d)}publicLogError2(u,d){this.publicLogError(u,d)}};e.TelemetryService=m,e.TelemetryService=m=ye([J(1,R.IConfigurationService),J(2,P.IProductService)],m);function E(){const y=(0,L.localize)(0,null,g.default.nameLong),u=g.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=A.isWeb?"":(0,L.localize)(3,null),h=(0,L.localize)(4,null),f=(0,L.localize)(5,null),C=(0,L.localize)(6,null),s=(0,L.localize)(7,null),o=`
|       | ${h} | ${f} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,L.localize)(8,null);return`
${y} ${u} ${d}

&nbsp;

${s}
${o}

&nbsp;

${n}
`}b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:E(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,L.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,L.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[226],ae([0,1,15,26,270,225]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function L(P,b){const v=await b.request(P,U.CancellationToken.None),c=(await(0,k.streamToBuffer)(v.stream)).toString(),m=v.res.statusCode??200;return{headers:v.res.headers,statusCode:m,responseData:c}}async function R(P){const b={method:P.type,headers:P.headers};return new Promise((c,m)=>{const E=A.request(P.url??"",b,y=>{y.on("data",function(u){c({headers:y.headers,statusCode:y.statusCode??200,responseData:u.toString()})}),y.on("error",function(u){m(u)})});E.write(P.data,y=>{y&&m(y)}),E.end()})}async function I(P,b,v){const c=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),m={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:c};try{const E=P?await L(m,P):await R(m);v(E.statusCode,E.headers,E.responseData)}catch{v(0,{})}}class g extends O.AbstractOneDataSystemAppender{constructor(b,v,c,m,E){const y={sendPOST:(u,d)=>{I(b,u,d)}};super(v,c,m,E,y)}}e.OneDataSystemAppender=g}),define(oe[227],ae([0,1,23,93,20,14,8,25,22,108,109,110]),function(te,e,k,U,A,O,L,R,I,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(m,E,y,u,d,h){this.configurationService=m,this.telemetryService=E,this.logService=y,this.loggerService=u,this.environmentService=d,this.productService=h,this.customTelemetryServices=new Map}getCustomTelemetryService(m){if(!this.customTelemetryServices.has(m.id)){const E=Object.create(null);E["common.vscodemachineid"]=this.telemetryService.machineId,E["common.vscodesessionid"]=this.telemetryService.sessionId;const y=[m.id,JSON.stringify(E),m.aiKey],d=new U.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new g.TelemetryAppenderClient(d),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${m.id}] `)];this.customTelemetryServices.set(m.id,new b.TelemetryService({appenders:h,sendErrorTelemetry:m.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(m.id)}publicLog(m,E,y){this.getCustomTelemetryService(m).publicLog(E,y)}publicLogError(m,E,y){this.getCustomTelemetryService(m).publicLogError(E,y)}};e.CustomEndpointTelemetryService=v,e.CustomEndpointTelemetryService=v=ye([J(0,A.IConfigurationService),J(1,I.ITelemetryService),J(2,L.ILogService),J(3,L.ILoggerService),J(4,O.IEnvironmentService),J(5,R.IProductService)],v)}),define(oe[77],ae([0,1,3,20,4,8]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var L;(function(y){y.Http="http",y.Https="https"})(L||(e.TunnelProtocol=L={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R||(e.TunnelPrivacyId=R={}));function I(y){return!!y.forwardPort}e.isTunnelProvider=I;var g;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=v;function c(y,u,d,h){if(d===1)return!1;if(d===2&&v(u)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(f?.length===4&&parseInt(f[1])>=18)return!1}return y<1024}e.isPortPrivileged=c;class m{constructor(u,d,h){this.remoteAddress=u,this.localAddress=d,this._dispose=h,this._onDispose=new k.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=m;let E=class{constructor(u,d){this.logService=u,this.configurationService=d,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(const h of d){const f=Array.from(h.values());for(const C of f){const s=await C.value;s&&typeof s!="string"&&u.push(s)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(h=>typeof h!="string"?h?.dispose():void 0);u.clear()}this._tunnels.clear()}setEnvironmentTunnel(u,d,h,f,C){this.addTunnelToMap(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:h,privacy:f,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,d){(v(u)||b(u))&&(u=e.LOCALHOST_ADDRESSES[0]);const h=this.getTunnelFromMap(u,d);if(h)return++h.refcount,h.value}openTunnel(u,d,h,f,C,s=!1,o,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${h} on local port ${C}.`);const i=this._tunnelProvider??u;if(!i)return;if(d||(d="localhost"),f||(f=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(h)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(i,d,h,f,C,s,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(d,h),r}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(d,h);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(r);return(r.tunnelRemoteHost!==d||r.tunnelRemotePort!==h)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const h=d.get(u.tunnelRemotePort);h&&(h.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,h))}}}}async tryDisposeTunnel(u,d,h){if(h.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const f=h.value.then(async C=>{C&&typeof C!="string"&&(await C.dispose(!0),this._onTunnelClosed.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),f}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const h=this._tunnels.get(u);if(h&&h.has(d)){const f=h.get(d);f.refcount=0,await this.tryDisposeTunnel(u,d,f)}}addTunnelToMap(u,d,h){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:h})}async removeEmptyOrErrorTunnelFromMap(u,d){const h=this._tunnels.get(u);if(h){const f=h.get(d),C=f?await f.value:void 0;(!C||typeof C=="string")&&h.delete(d),h.size===0&&this._tunnels.delete(u)}}getTunnelFromMap(u,d){const h=[u];b(u)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):v(u)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const f=h.map(C=>this._tunnels.get(C));for(const C of f){const s=C?.get(d);if(s)return s}}canTunnel(u){return!!P(u)}createWithProvider(u,d,h,f,C,s,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${h} on local port ${f}.`);const n=h;this._factoryInProgress.add(n);const i=f===void 0?h:f,t={elevationRequired:C?this.isPortPrivileged(i):!1},r={remoteAddress:{host:d,port:h},localAddressPort:f,privacy:s,public:s?s!==R.Private:void 0,protocol:o},a=u.forwardPort(r,t);return a?(this.addTunnelToMap(d,h,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),a}};e.AbstractTunnelService=E,e.AbstractTunnelService=E=ye([J(0,O.ILogService),J(1,U.IConfigurationService)],E)}),define(oe[228],ae([0,1,8,77,2,7,6]),function(te,e,k,U,A,O,L){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends A.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new L.DeferredPromise),this._addressPromise.p)}setAddress(b){this._address=b,this._addressPromise&&(this._addressPromise.complete(b),this._addressPromise=null)}setTunnel(b){this._register(b)}}let g=class extends A.Disposable{static{R=this}static{this._lastId=0}constructor(b,v){super(),this._tunnelService=b,this._logService=v,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++R._lastId)}}async startTunnel(b,v,c,m,E,y,u){const d=new I,h=await Promise.resolve(this._tunnelService.openTunnel(b,d,c,m,E,y,u));if(!h||typeof h=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${m} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(v))throw this._disposedTunnels.delete(v),d.dispose(),await h.dispose(),(0,O.canceled)();return d.setTunnel(h),this._tunnels.set(v,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${v}: ${h.localAddress} (local) to ${c}:${m} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(b,v){const c=this._tunnels.get(b);c&&c.setAddress(v)}async destroyTunnel(b){const v=this._tunnels.get(b);if(v){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this._tunnels.delete(b),await v.dispose();return}this._disposedTunnels.add(b)}};e.SharedProcessTunnelService=g,e.SharedProcessTunnelService=g=R=ye([J(0,U.ISharedTunnelsService),J(1,k.ILogService)],g)}),define(oe[28],ae([0,1,4]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[229],ae([0,1,28,184,11,19,127,3,2]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class g{static{this._clock=0}constructor(v){this.uri=v,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let P=class{constructor(v){this._fileService=v,this._dispooables=new I.DisposableStore,this._limit=2**16;const c=new Map,m=E=>{let y=c.get(E.scheme);return y===void 0&&(y=v.hasProvider(E)&&!this._fileService.hasCapability(E,1024),c.set(E.scheme,y)),y};this._dispooables.add(R.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(E=>{c.delete(E.scheme)})),this.extUri=new O.ExtUri(m),this._canonicalUris=new L.SkipList((E,y)=>this.extUri.compare(E,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,O.normalizePath)(v));const c=this._canonicalUris.get(v);return c?c.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new g(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((m,E)=>m[1].time<E[1].time?1:m[1].time>E[1].time?-1:0);g._clock=0,this._canonicalUris.clear();const c=this._limit*.5;for(let m=0;m<c;m++)this._canonicalUris.set(v[m][0],v[m][1].touch())}};e.UriIdentityService=P,e.UriIdentityService=P=ye([J(0,A.IFileService)],P),(0,U.registerSingleton)(k.IUriIdentityService,P,1)}),define(oe[230],ae([0,1,3,2,11,47,34]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends U.Disposable{constructor(g,P,b,v,c,m){super(),this.fileSystemScheme=g,this.fileSystemProvider=P,this.userDataScheme=b,this.userDataProfilesService=v,this.uriIdentityService=c,this.logService=m,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new L.ResourceSet(E=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(E))),this.updateAtomicReadWritesResources(),this._register(v.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(E=>this.handleFileChanges(E)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const g of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(g.settingsResource),this.atomicReadWriteResources.add(g.keybindingsResource),this.atomicReadWriteResources.add(g.tasksResource),this.atomicReadWriteResources.add(g.extensionsResource)}open(g,P){return this.fileSystemProvider.open(this.toFileSystemResource(g),P)}close(g){return this.fileSystemProvider.close(g)}read(g,P,b,v,c){return this.fileSystemProvider.read(g,P,b,v,c)}write(g,P,b,v,c){return this.fileSystemProvider.write(g,P,b,v,c)}watch(g,P){this.watchResources.set(g,g);const b=this.fileSystemProvider.watch(this.toFileSystemResource(g),P);return(0,U.toDisposable)(()=>{this.watchResources.delete(g),b.dispose()})}stat(g){return this.fileSystemProvider.stat(this.toFileSystemResource(g))}mkdir(g){return this.fileSystemProvider.mkdir(this.toFileSystemResource(g))}rename(g,P,b){return this.fileSystemProvider.rename(this.toFileSystemResource(g),this.toFileSystemResource(P),b)}readFile(g,P){return this.fileSystemProvider.readFile(this.toFileSystemResource(g),P)}readFileStream(g,P,b){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(g),P,b)}readdir(g){return this.fileSystemProvider.readdir(this.toFileSystemResource(g))}enforceAtomicReadFile(g){return this.atomicReadWriteResources.has(g)}writeFile(g,P,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(g),P,b)}enforceAtomicWriteFile(g){return this.atomicReadWriteResources.has(g)?{postfix:".vsctmp"}:!1}delete(g,P){return this.fileSystemProvider.delete(this.toFileSystemResource(g),P)}copy(g,P,b){if((0,A.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(g),this.toFileSystemResource(P),b);throw new Error("copy not supported")}cloneFile(g,P){if((0,A.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(g),this.toFileSystemResource(P));throw new Error("clone not supported")}handleFileChanges(g){const P=[];for(const b of g){if(b.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(b.resource);this.watchResources.findSubstr(v)&&P.push({resource:v,type:b.type,cId:b.cId})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(g){return g.with({scheme:this.fileSystemScheme})}toUserDataResource(g){return g.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(oe[78],ae([0,1,86]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function U(L,R,I,g){const P=(0,k.setProperty)(L,R,I,g)[0];return P&&(L=L.substring(0,P.offset)+P.content+L.substring(P.offset+P.length)),L}e.edit=U;function A(L,R,I){let g=I;for(;g>=0;){if(L.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&L.charAt(g)===R.charAt(0))return g+2}return 0}e.getLineStartOffset=A;function O(L,R,I){let g=I;for(;g>=0;)if(L.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&L.charAt(g)===R.charAt(1)))return g;return L.length-1}e.getLineEndOffset=O}),define(oe[231],ae([0,1,30,54,12]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(c,m,E,y,u,d){const h=[],f=[],C=[];if(!m){const q=c.filter(({identifier:Q})=>u.every(G=>G.toLowerCase()!==Q.id.toLowerCase()));return{local:{added:h,removed:f,updated:C},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}c=c.map(b),m=m.map(b),E=E?E.map(b):null;const s=new Map,o=q=>{q.uuid&&s.set(q.id.toLowerCase(),q.uuid)};c.forEach(({identifier:q})=>o(q)),m.forEach(({identifier:q})=>o(q)),E?.forEach(({identifier:q})=>o(q)),y?.forEach(({identifier:q})=>o(q)),d?.forEach(q=>o(q));const n=q=>{const Q=q.identifier.uuid||s.get(q.identifier.id.toLowerCase());return Q?`uuid:${Q}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,Q)=>(q.set(n(Q),Q),q),t=c.reduce(i,new Map),r=m.reduce(i,new Map),a=m.reduce((q,Q)=>i(q,(0,k.deepClone)(Q)),new Map),w=E?E.reduce(i,new Map):null,p=y.reduce(i,new Map),l=u.reduce((q,Q)=>{const G=s.get(Q.toLowerCase());return q.add(G?`uuid:${G}`:`id:${Q.toLowerCase()}`)},new Set),S=d?d.reduce((q,{id:Q,uuid:G})=>(G=G??s.get(Q.toLowerCase()),q.add(G?`uuid:${G}`:`id:${Q.toLowerCase()}`)),new Set):null,_=L(t,r,l,!1);if(_.added.size>0||_.removed.size>0||_.updated.size>0){const q=L(w,t,l,!1),Q=L(w,r,l,!0),G=(X,x,Y,B)=>{let z,ee,ie;return x.installed?(z=B.pinned,ie=B.preRelease,z&&(ee=B.version)):(z=Y.pinned,ie=Y.preRelease,z&&(ee=Y.version)),z===void 0&&(z=x.pinned,z&&(ee=x.version)),ie===void 0&&(ie=x.preRelease),{...B,installed:x.installed||Y.installed,pinned:z,preRelease:ie,version:ee??(Y.version&&(!x.installed||U.gt(Y.version,x.version))?Y.version:x.version),state:I(x,Y,w?.get(X))}};for(const X of Q.removed.values()){const x=t.get(X);if(!x)continue;const Y=(0,A.assertIsDefined)(w?.get(X)),B=S&&!S.has(X)&&Y.installed;x.installed&&B?f.push(x.identifier):a.set(X,x)}for(const X of Q.added.values()){const x=(0,A.assertIsDefined)(r.get(X)),Y=t.get(X);if(Y){if(_.updated.has(X)){const B=G(X,Y,x,x);R(Y,x,!1,!1)||C.push(v(B,X)),a.set(X,B)}}else x.installed&&h.push(v(x,X))}for(const X of Q.updated.values()){const x=(0,A.assertIsDefined)(r.get(X)),Y=(0,A.assertIsDefined)(w?.get(X)),B=t.get(X);if(B)if(S&&!S.has(X)&&Y.installed&&B.installed&&!x.installed)f.push(B.identifier);else{const ee=G(X,B,x,x);C.push(v(ee,X)),a.set(X,ee)}else x.installed&&h.push(v(x,X))}for(const X of q.added.values())Q.added.has(X)||a.set(X,(0,A.assertIsDefined)(t.get(X)));for(const X of q.updated.values()){if(Q.removed.has(X)||Q.updated.has(X))continue;const x=(0,A.assertIsDefined)(t.get(X)),Y=(0,A.assertIsDefined)(r.get(X));a.set(X,G(X,x,Y,x))}for(const X of q.removed.values())Q.updated.has(X)||Q.removed.has(X)||p.has(X)||(0,A.assertIsDefined)(r.get(X)).installed&&S&&(S.has(X)||!(0,A.assertIsDefined)(w?.get(X)).installed||a.delete(X))}const N=[],$=L(r,a,new Set,!0),W=$.added.size>0||$.updated.size>0||$.removed.size>0;return W&&a.forEach((q,Q)=>N.push(v(q,Q))),{local:{added:h,removed:f,updated:C},remote:W?{added:[...$.added].map(q=>a.get(q)),updated:[...$.updated].map(q=>a.get(q)),removed:[...$.removed].map(q=>r.get(q)),all:N}:null}}e.merge=O;function L(c,m,E,y){const u=c?[...c.keys()].filter(s=>!E.has(s)):[],d=[...m.keys()].filter(s=>!E.has(s)),h=d.filter(s=>!u.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),f=u.filter(s=>!d.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),C=new Set;for(const s of u){if(f.has(s))continue;const o=c.get(s),n=m.get(s);(!n||!R(o,n,y,!0))&&C.add(s)}return{added:h,removed:f,updated:C}}function R(c,m,E,y){return!(c.disabled!==m.disabled||!!c.isApplicationScoped!=!!m.isApplicationScoped||y&&c.installed!==m.installed||c.installed&&m.installed&&(c.preRelease!==m.preRelease||c.pinned!==m.pinned||m.pinned&&c.version!==m.version)||!P(c.state,m.state)||E&&c.version!==m.version)}function I(c,m,E){const y=c.state,u=m.state,d=E?.state;if(!m.version||y&&U.gt(c.version,m.version))return y;if(u&&U.gt(m.version,c.version)||!y)return u;if(!u)return y;const h=(0,k.deepClone)(y),f=d?g(d,u):{added:Object.keys(u).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set},C=d?g(d,y):{added:Object.keys(y).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set};for(const s of[...f.added.values(),...f.updated.values()])h[s]=u[s];for(const s of f.removed.values())C.updated.has(s)||delete h[s];return h}function g(c,m){const E=Object.keys(c),y=Object.keys(m),u=y.filter(f=>!E.includes(f)).reduce((f,C)=>(f.add(C),f),new Set),d=E.filter(f=>!y.includes(f)).reduce((f,C)=>(f.add(C),f),new Set),h=new Set;for(const f of E){if(d.has(f))continue;const C=c[f],s=m[f];(0,k.equals)(C,s)||h.add(f)}return{added:u,removed:d,updated:h}}function P(c={},m={}){const{added:E,removed:y,updated:u}=g(c,m);return E.size===0&&y.size===0&&u.size===0}function b(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function v(c,m){const E={...c,identifier:{id:c.identifier.id,uuid:m.startsWith("uuid:")?m.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete E.disabled,c.installed||delete E.installed,c.state||delete E.state,c.isApplicationScoped||delete E.isApplicationScoped,E}}),define(oe[111],ae([0,1,18,20,4]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let O=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,I){let g=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return g=g.filter(P=>P!==R&&P!==`-${R}`),I&&g.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,I){let g=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return g=g.filter(P=>P!==R&&P!==`-${R}`),I&&g.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const I=R.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),g=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),P=[],b=[];if(Array.isArray(g))for(const v of g)v.startsWith("-")?b.push(v.substring(1)):P.push(v);return(0,k.distinct)([...I,...P].filter(v=>!b.includes(v)))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};e.IgnoredExtensionsManagementService=O,e.IgnoredExtensionsManagementService=O=ye([J(0,U.IConfigurationService)],O)}),define(oe[232],ae([0,1,18,35,30,94,78]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(f){return(0,U.parse)(f)||[]}async function I(f,C,s,o,n){const i=R(f),t=R(C),r=s?R(s):null,a=[...i,...t,...r||[]].map(G=>G.key),w=await n.resolveUserBindings(a),p=P(i,t,r,w);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:C,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const l=v(i),S=v(t),_=r?v(r):null,N=m(l,S,w),$=_?m(_,l,w):{added:[...l.keys()].reduce((G,X)=>(G.add(X),G),new Set),removed:new Set,updated:new Set},W=_?m(_,S,w):{added:[...S.keys()].reduce((G,X)=>(G.add(X),G),new Set),removed:new Set,updated:new Set},q=g(N,$,W);let Q=f;for(const G of q.removed.values())q.conflicts.has(G)||(Q=d(Q,G,o));for(const G of q.added.values()){if(q.conflicts.has(G))continue;const X=S.get(G);if(X.some(x=>x.command!==`-${G}`&&p.conflicts.has(w[x.key]))){q.conflicts.add(G);continue}Q=u(Q,X,o)}for(const G of q.updated.values()){if(q.conflicts.has(G))continue;const X=S.get(G);if(X.some(x=>x.command!==`-${G}`&&p.conflicts.has(w[x.key]))){q.conflicts.add(G);continue}Q=h(Q,G,X,o)}return{mergeContent:Q,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=I;function g(f,C,s){const o=new Set,n=new Set,i=new Set,t=new Set;for(const r of C.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(C.updated.has(r)?t.add(r):n.add(r));for(const r of C.added.values())t.has(r)||s.added.has(r)&&f.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(C.added.has(r)?f.updated.has(r)&&t.add(r):o.add(r));for(const r of C.updated.values())t.has(r)||s.updated.has(r)&&f.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(C.updated.has(r)?f.updated.has(r)&&t.add(r):i.add(r));return{added:o,removed:n,updated:i,conflicts:t}}function P(f,C,s,o){const n=new Set,i=b(f,o),t=b(C,o),r=s?b(s,o):null,a=c(i,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const w=r?c(r,i):{added:[...i.keys()].reduce(($,W)=>($.add(W),$),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=r?c(r,t):{added:[...t.keys()].reduce(($,W)=>($.add(W),$),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:l,removed:S,updated:_,conflicts:N}=g(a,w,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:l,removed:S,updated:_,conflicts:N}}function b(f,C){const s=new Map;for(const o of f){const n=C[o.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(o)}return s}function v(f){const C=new Map;for(const s of f){const o=s.command[0]==="-"?s.command.substring(1):s.command;let n=C.get(o);n||(n=[],C.set(o,n)),n.push(s)}return C}function c(f,C){const s=[...f.keys()],o=[...C.keys()],n=o.filter(r=>!s.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=s.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const a=f.get(r).map(p=>({...p,key:r})),w=C.get(r).map(p=>({...p,key:r}));(0,k.equals)(a,w,(p,l)=>y(p,l))||t.add(r)}return{added:n,removed:i,updated:t}}function m(f,C,s){const o=[...f.keys()],n=[...C.keys()],i=n.filter(a=>!o.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const w=f.get(a).map(l=>({...l,key:s[l.key]})),p=C.get(a).map(l=>({...l,key:s[l.key]}));E(w,p)||r.add(a)}return{added:i,removed:t,updated:r}}function E(f,C){return!(!(0,k.equals)(f.filter(({command:s})=>s[0]!=="-"),C.filter(({command:s})=>s[0]!=="-"),(s,o)=>y(s,o))||!(0,k.equals)(f.filter(({command:s})=>s[0]==="-"),C.filter(({command:s})=>s[0]==="-"),(s,o)=>y(s,o)))}function y(f,C){if(f.command!==C.command||f.key!==C.key)return!1;const s=O.ContextKeyExpr.deserialize(f.when),o=O.ContextKeyExpr.deserialize(C.when);return!(s&&!o||!s&&o||s&&o&&!s.equals(o)||!A.equals(f.args,C.args))}function u(f,C,s){for(const o of C)f=L.edit(f,[-1],o,s);return f}function d(f,C,s){const o=R(f);for(let n=o.length-1;n>=0;n--)(o[n].command===C||o[n].command===`-${C}`)&&(f=L.edit(f,[n],void 0,s));return f}function h(f,C,s,o){const n=R(f),i=n.findIndex(t=>t.command===C||t.command===`-${C}`);for(let t=n.length-1;t>=0;t--)(n[t].command===C||n[t].command===`-${C}`)&&(f=L.edit(f,[t],void 0,o));for(let t=s.length-1;t>=0;t--)f=L.edit(f,[i],s[t],o);return f}}),define(oe[233],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(O,L,R){const I={},g={},P=new Set;if(!L)return{local:{added:I,updated:g,removed:[...P.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const b=U(O,L);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:g,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=U(R,O),c=U(R,L),m={},E={},y=new Set,u=new Set;for(const d of v.removed.values())c.updated.has(d)?I[d]=L[d]:y.add(d);for(const d of c.removed.values())u.has(d)||(v.updated.has(d)?u.add(d):P.add(d));for(const d of v.updated.values())u.has(d)||(c.updated.has(d)?b.updated.has(d)&&u.add(d):E[d]=O[d]);for(const d of c.updated.values())u.has(d)||(v.updated.has(d)?b.updated.has(d)&&u.add(d):O[d]!==void 0&&(g[d]=L[d]));for(const d of v.added.values())u.has(d)||(c.added.has(d)?b.updated.has(d)&&u.add(d):m[d]=O[d]);for(const d of c.added.values())u.has(d)||(v.added.has(d)?b.updated.has(d)&&u.add(d):I[d]=L[d]);return{local:{added:I,removed:[...P.values()],updated:g},remote:{added:m,removed:[...y.values()],updated:E},conflicts:[...u.values()]}}e.merge=k;function U(O,L){const R=O?Object.keys(O):[],I=L?Object.keys(L):[],g=I.filter(v=>!R.includes(v)).reduce((v,c)=>(v.add(c),v),new Set),P=R.filter(v=>!I.includes(v)).reduce((v,c)=>(v.add(c),v),new Set),b=new Set;for(const v of R){if(P.has(v))continue;const c=O[v],m=L[v];c!==m&&b.add(v)}return{added:g,removed:P,updated:b}}function A(O,L){const{added:R,removed:I,updated:g}=U(O,L);return R.size===0&&I.size===0&&g.size===0}e.areSame=A}),define(oe[234],ae([0,1,30]),function(te,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function U(O,L,R,I){const g={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!L){const v=O.filter(({id:c})=>!I.includes(c));return v.length?P.added=v:P=null,{local:g,remote:P}}const b=A(O,L,I);if(b.added.length>0||b.removed.length>0||b.updated.length>0){const v=A(R,O,I),c=A(R,L,I);for(const m of c.removed){const E=O.find(y=>y.id===m);E&&g.removed.push(E)}for(const m of c.added){const E=L.find(y=>y.id===m);v.added.includes(m)?b.updated.includes(m)&&g.updated.push(E):g.added.push(E)}for(const m of c.updated)g.updated.push(L.find(E=>E.id===m));for(const m of v.added)c.added.includes(m)||P.added.push(O.find(E=>E.id===m));for(const m of v.updated)c.removed.includes(m)||c.updated.includes(m)||P.updated.push(O.find(E=>E.id===m));for(const m of v.removed){const E=L.find(y=>y.id===m);E&&P.removed.push(E)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:g,remote:P}}e.merge=U;function A(O,L,R){O=O?O.filter(({id:c})=>!R.includes(c)):[],L=L.filter(({id:c})=>!R.includes(c));const I=O.map(({id:c})=>c),g=L.map(({id:c})=>c),P=g.filter(c=>!I.includes(c)),b=I.filter(c=>!g.includes(c)),v=[];for(const{id:c,name:m,shortName:E,icon:y,useDefaultFlags:u}of O){if(b.includes(c))continue;const d=L.find(h=>h.id===c);(!d||d.name!==m||d.shortName!==E||d.icon!==y||!(0,k.equals)(d.useDefaultFlags,u))&&v.push(c)}return{added:P,removed:b,updated:v}}}),define(oe[24],ae([0,1,18,12,173,50,29,4,103,40]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=void 0;function P(){const t=g.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function b(){const t=g.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(p=>!!t[p].ignoreSync),a=Object.keys(t).filter(p=>t[p].scope===2||t[p].scope===6),w=P();return(0,k.distinct)([...r,...a,...w])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function v(){const t="vscode://schemas/ignoredSettings",r=g.Registry.as(O.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.Registry.as(I.Extensions.JSONContribution),w=()=>{const p=P(),l=b(),S=Object.keys(O.allSettings.properties).filter($=>!l.includes($)),_=l.filter($=>!p.includes($)),N={items:{type:"string",enum:[...S,..._.map($=>`-${$}`)]}};a.registerSchema(t,N)};return r.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=v;function c(t){return t&&(0,U.isObject)(t)&&(0,U.isString)(t.id)&&Array.isArray(t.scopes)}e.isAuthenticationProvider=c;var m;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(m||(e.SyncResource=m={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function E(t,...r){return t?[t,...r]:r}e.getPathSegments=E;function y(t,r,a,w){return w.joinPath(a.userDataSyncHome,...E(t,r,`lastSync${r}.json`))}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,R.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(t){const r={};return r[e.HEADER_EXECUTION_ID]=t,r}e.createSyncHeaders=u;var d;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class h extends Error{constructor(r,a,w,p){super(r),this.code=a,this.resource=w,this.operationId=p,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=h;class f extends h{constructor(r,a,w,p,l){super(r,w,void 0,l),this.url=a,this.serverCode=p}}e.UserDataSyncStoreError=f;class C extends h{constructor(r,a){super(r,a)}}e.UserDataAutoSyncError=C,function(t){function r(a){if(a instanceof t)return a;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(w&&w[1]){const p=w[2]==="unknown"?void 0:w[2],l=w[3]==="unknown"?void 0:w[3];return new t(a.message,w[1],p,l)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.UserDataSyncError=h={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[235],ae([0,1,30,24]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(L,R,I,g,P){if(!R)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const b=O(L,R);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const v=I?O(I,R):{added:Object.keys(R).reduce((d,h)=>(d.add(h),d),new Set),removed:new Set,updated:new Set},c=I?O(I,L):{added:Object.keys(L).reduce((d,h)=>(d.add(h),d),new Set),removed:new Set,updated:new Set},m={added:{},removed:[],updated:{}},E=k.deepClone(R),y=!I;for(const d of c.added.values())d!==U.SYNC_SERVICE_URL_TYPE&&y&&v.added.has(d)||(E[d]=L[d]);for(const d of c.updated.values())E[d]=L[d];for(const d of c.removed.values())g.unregistered.includes(d)||delete E[d];for(const d of v.added.values()){const h=R[d];if(g.machine.includes(d)){P.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(I&&c.added.has(d))continue;const f=L[d];f&&f.value===h.value||d===U.SYNC_SERVICE_URL_TYPE&&y&&c.added.has(d)||(f?m.updated[d]=h:m.added[d]=h)}for(const d of v.updated.values()){const h=R[d];if(g.machine.includes(d)){P.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(d)||c.removed.has(d))continue;const f=L[d];f&&f.value===h.value||(m.updated[d]=h)}for(const d of v.removed.values()){if(g.machine.includes(d)){P.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}c.updated.has(d)||c.removed.has(d)||m.removed.push(d)}const u=O(R,E);return{local:m,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:E}}}e.merge=A;function O(L,R){const I=Object.keys(L),g=Object.keys(R),P=g.filter(c=>!I.includes(c)).reduce((c,m)=>(c.add(m),c),new Set),b=I.filter(c=>!g.includes(c)).reduce((c,m)=>(c.add(m),c),new Set),v=new Set;for(const c of I){if(b.has(c))continue;const m=L[c],E=R[c];k.equals(m,E)||v.add(c)}return{added:P,removed:b,updated:v}}}),define(oe[236],ae([0,1,18,35,86,41,30,78,24]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function g(a,w,p){let l=[];p?l=b(p):l=P(w);const S=[],_=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(l))for(const N of l)N.startsWith("-")?_.push(N.substring(1)):S.push(N);return(0,k.distinct)([...a,...S].filter(N=>!_.includes(N)))}e.getIgnoredSettings=g;function P(a){let w=a.inspect("settingsSync.ignoredSettings").userValue;return w!==void 0||(w=a.inspect("sync.ignoredSettings").userValue,w!==void 0)?w:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const w=(0,U.parse)(a);return w?w["settingsSync.ignoredSettings"]||w["sync.ignoredSettings"]||[]:[]}function v(a,w){const p=(0,U.parse)(a)||{};let l="{}";for(const S of Object.keys(p)){const _=(0,A.setProperty)(l,[S],p[S],w);l=(0,A.applyEdits)(l,_)}return l}e.removeComments=v;function c(a,w,p,l){if(p.length){const S=r(w),_=(0,U.parse)(w)||{},N=(0,U.parse)(a);if(!N)return a;const $=[];for(const W of p){const q=_[W],Q=N[W];q===void 0?a=R.edit(a,[W],void 0,l):Q!==void 0?a=R.edit(a,[W],q,l):$.push(s(W,S))}$.sort((W,q)=>W.startOffset-q.startOffset),$.forEach(W=>a=d(W.setting.key,w,a,l))}return a}e.updateIgnoredSettings=c;function m(a,w,p,l,S,_){const N=c(a,w,l,_),$=p!==N,W=p!==w;if(!$&&!W)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!W)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(W&&!$)return{conflictsSettings:[],localContent:c(w,a,l,_),remoteContent:null,hasConflicts:!1};if(p===null&&y(a)){const T=E(a,w,l)?null:c(w,a,l,_);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let q=a,Q=w;const G=(0,U.parse)(a),X=(0,U.parse)(w),x=p?(0,U.parse)(p):null,Y=l.reduce((T,M)=>(T.add(M),T),new Set),B=u(G,X,Y),z=u(x,G,Y),ee=u(x,X,Y),ie=new Map,Z=new Set,ne=T=>{Z.add(T);const M=S.filter(({key:F})=>F===T)[0];M?(q=R.edit(q,[T],M.value,_),Q=R.edit(Q,[T],M.value,_)):ie.set(T,{key:T,localValue:G[T],remoteValue:X[T]})};for(const T of z.removed.values())ee.updated.has(T)?ne(T):Q=R.edit(Q,[T],void 0,_);for(const T of ee.removed.values())Z.has(T)||(z.updated.has(T)?ne(T):q=R.edit(q,[T],void 0,_));for(const T of z.updated.values())Z.has(T)||(ee.updated.has(T)?B.updated.has(T)&&ne(T):Q=R.edit(Q,[T],G[T],_));for(const T of ee.updated.values())Z.has(T)||(z.updated.has(T)?B.updated.has(T)&&ne(T):q=R.edit(q,[T],X[T],_));for(const T of z.added.values())Z.has(T)||(ee.added.has(T)?B.updated.has(T)&&ne(T):Q=d(T,q,Q,_));for(const T of ee.added.values())Z.has(T)||(z.added.has(T)?B.updated.has(T)&&ne(T):q=d(T,Q,q,_));const K=ie.size>0||!E(q,Q,l),j=K||!E(q,a,[]),D=K||!E(Q,w,[]);return{localContent:j?q:null,remoteContent:D?Q:null,conflictsSettings:[...ie.values()],hasConflicts:K}}e.merge=m;function E(a,w,p){if(a===w)return!0;const l=(0,U.parse)(a),S=(0,U.parse)(w),_=p.reduce((W,q)=>(W.add(q),W),new Set),N=r(a).filter(W=>!(W.setting&&_.has(W.setting.key))),$=r(w).filter(W=>!(W.setting&&_.has(W.setting.key)));if(N.length!==$.length)return!1;for(let W=0;W<N.length;W++){const q=N[W],Q=$[W];if(q.setting&&Q.setting){if(q.setting.key!==Q.setting.key||!L.equals(l[q.setting.key],S[q.setting.key]))return!1}else if(!q.setting&&!Q.setting){if(q.value!==Q.value)return!1}else return!1}return!0}function y(a){return a?r(a).length===0:!0}e.isEmpty=y;function u(a,w,p){const l=a?Object.keys(a).filter(W=>!p.has(W)):[],S=Object.keys(w).filter(W=>!p.has(W)),_=S.filter(W=>!l.includes(W)).reduce((W,q)=>(W.add(q),W),new Set),N=l.filter(W=>!S.includes(W)).reduce((W,q)=>(W.add(q),W),new Set),$=new Set;if(a)for(const W of l){if(N.has(W))continue;const q=a[W],Q=w[W];L.equals(q,Q)||$.add(W)}return{added:_,removed:N,updated:$}}function d(a,w,p,l){const S=(0,U.parse)(w),_=r(w),N=r(p),$=h(a,_,N);return f(p,a,S[a],$,N,l)}e.addSetting=d;function h(a,w,p){const l=w.findIndex(_=>_.setting?.key===a),S=w[l-1];if(S){if(S.setting){const N=s(S.setting.key,p);if(N)return{index:p.indexOf(N),insertAfter:!0}}else{const N=o(l,w);if(N){const $=s(N.setting.key,p);if($){const W=n(p.indexOf($),p),q=i(w,N,w[l]);if(W){const Q=i(p,$,W),G=t(q,Q);return G?{index:p.indexOf(G),insertAfter:!0}:{index:p.indexOf(W),insertAfter:!1}}else{const Q=i(p,$,p[p.length-1]),G=t(q,Q);return G?{index:p.indexOf(G),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const _=w[l+1];if(_)if(_.setting){const N=s(_.setting.key,p);if(N)return{index:p.indexOf(N),insertAfter:!1}}else{const N=n(l,w);if(N){const $=s(N.setting.key,p);if($){const W=o(p.indexOf($),p),q=i(w,w[l],N);if(W){const Q=i(p,W,$),G=t(q.reverse(),Q.reverse());return G?{index:p.indexOf(G),insertAfter:!1}:{index:p.indexOf(W),insertAfter:!0}}else{const Q=i(p,p[0],$),G=t(q.reverse(),Q.reverse());return G?{index:p.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function f(a,w,p,l,S,_){let N;return l.index===-1?N=(0,A.setProperty)(a,[w],p,_):N=C(a,w,p,l,S,_).map($=>(0,A.withFormatting)(a,$,_)[0]),(0,A.applyEdits)(a,N)}function C(a,w,p,l,S,_){const N=`${JSON.stringify(w)}: ${JSON.stringify(p)}`,$=(0,O.getEOL)(_,a),W=S[l.index];if(l.insertAfter){const q=[];if(W.setting)q.push({offset:W.endOffset,length:0,content:","+N});else{const Q=n(l.index,S),G=o(l.index,S),X=G?.setting?.commaOffset;G&&X===void 0&&q.push({offset:G.endOffset,length:0,content:","});const x=X!==void 0&&X>W.endOffset;q.push({offset:x?X+1:W.endOffset,length:0,content:Q?$+N+",":$+N})}return q}else{if(W.setting)return[{offset:W.startOffset,length:0,content:N+","}];const q=(S[l.index-1]&&!S[l.index-1].setting?$:"")+N+(n(l.index,S)?",":"")+$;return[{offset:W.startOffset,length:0,content:q}]}}function s(a,w){return w.filter(p=>p.setting?.key===a)[0]}function o(a,w){for(let p=a-1;p>=0;p--)if(w[p].setting)return w[p]}function n(a,w){for(let p=a+1;p<w.length;p++)if(w[p].setting)return w[p]}function i(a,w,p){const l=a.indexOf(w),S=a.indexOf(p);return a.filter((_,N)=>l<N&&N<S)}function t(a,w){if(a.length&&w.length){let p=0;for(;p<w.length&&p<a.length;p++)if(a[p].value!==w[p].value)return w[p-1];return w[p-1]}}function r(a){const w=[];let p=-1,l,S;const _={onObjectBegin:N=>{p++},onObjectProperty:(N,$,W)=>{p===0&&(l=$,S=N)},onObjectEnd:(N,$)=>{p--,p===0&&w.push({startOffset:l,endOffset:N+$,value:a.substring(l,N+$),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(N,$)=>{p++},onArrayEnd:(N,$)=>{p--,p===0&&w.push({startOffset:l,endOffset:N+$,value:a.substring(l,N+$),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(N,$,W)=>{p===0&&w.push({startOffset:l,endOffset:$+W,value:a.substring(l,$+W),setting:{key:S,commaOffset:void 0}})},onSeparator:(N,$,W)=>{if(p===0&&N===","){let q=w.length-1;for(;q>=0&&!w[q].setting;q--);const Q=w[q];Q&&w.splice(q,1,{startOffset:Q.startOffset,endOffset:Q.endOffset,value:Q.value,setting:{key:Q.setting.key,commaOffset:$}})}},onComment:(N,$)=>{p===0&&w.push({startOffset:N,endOffset:N+$,value:a.substring(N,N+$)})}};return(0,U.visit)(a,_),w}}),define(oe[79],ae([0,1,3,2,4,24]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,A.createDecorator)("IUserDataSyncAccountService");let L=class extends U.Disposable{get account(){return this._account}constructor(I,g){super(),this.userDataSyncStoreService=I,this.logService=g,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(P=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,P),this.updateAccount(void 0),P==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};e.UserDataSyncAccountService=L,e.UserDataSyncAccountService=L=ye([J(0,O.IUserDataSyncStoreService),J(1,O.IUserDataSyncLogService)],L)}),define(oe[237],ae([0,1,2,10]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(v){this.service=v}listen(v,c){switch(c){case"onError":return this.service.onError}throw new Error(`Event not found: ${c}`)}call(v,c,m){switch(c){case"triggerSync":return this.service.triggerSync(m[0],m[1],m[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(m[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class O{constructor(v){this.service=v}listen(v,c){throw new Error(`Event not found: ${c}`)}call(v,c,m){switch(c){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(m[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(U.URI.revive(m[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=O;class L{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=L;class R{constructor(v){this.service=v}listen(v,c){switch(c){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${c}`)}async call(v,c,m){switch(c){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(m[0],m[1]);case"setEnablements":return this.service.setEnablements(m)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class I{constructor(v){this.service=v}listen(v,c){switch(c){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${c}`)}call(v,c,m){switch(c){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(m)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class g{constructor(v){this.service=v}listen(v,c){switch(c){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call(v,c,m){switch(c){case"switch":return this.service.switch(m[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=g;class P extends k.Disposable{constructor(v){super(),this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:U.URI.revive(v.url),type:v.type,defaultUrl:U.URI.revive(v.defaultUrl),insidersUrl:U.URI.revive(v.insidersUrl),stableUrl:U.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(oe[238],ae([0,1,19,174,14,8,24]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends O.AbstractLogger{constructor(g,P){super(),this.logger=this._register(g.createLogger((0,k.joinPath)(P.logsHome,`${L.USER_DATA_SYNC_LOG_ID}.log`),{id:L.USER_DATA_SYNC_LOG_ID,name:(0,U.localize)(0,null)}))}trace(g,...P){this.logger.trace(g,...P)}debug(g,...P){this.logger.debug(g,...P)}info(g,...P){this.logger.info(g,...P)}warn(g,...P){this.logger.warn(g,...P)}error(g,...P){this.logger.error(g,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=R,e.UserDataSyncLogService=R=ye([J(0,O.ILoggerService),J(1,A.IEnvironmentService)],R)}),define(oe[239],ae([0,1,6,3,2]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends A.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:I,getActiveWindowId:g}){super(),this.disposables=this._register(new A.DisposableStore),U.Event.latch(U.Event.any(R,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>g()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=O}),define(oe[112],ae([0,1,177,16,47,19,10,4,23]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function g(i){const t=i;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=g;function P(i){return typeof i?.id=="string"&&!g(i)&&!v(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,U.basename)(i)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=b;function v(i){const t=i;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=v;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=c;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function E(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=E;function y(i){const t=i;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=y;class u{constructor(t,r,a,w,p){this._id=t,this._transient=a,this._configuration=w,this._ignorePathCasing=p,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,O.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function h(i){return new d({uri:i,index:0,name:(0,O.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=h,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(i,t){return O.extUriBiasedIgnorePathCase.isEqualOrParent(i,t.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function C(i){let t;return L.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=C,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=s;function o(i,t){return!f(i,t)&&!C(i)}e.isSavedWorkspace=o;function n(i){return(typeof i=="string"?(0,U.extname)(i):(0,O.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(oe[17],ae([0,1,52,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function f(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&L.URI.isUri(t.location)&&L.URI.isUri(t.globalStorageHome)&&L.URI.isUri(t.settingsResource)&&L.URI.isUri(t.keybindingsResource)&&L.URI.isUri(t.tasksResource)&&L.URI.isUri(t.snippetsHome)&&L.URI.isUri(t.extensionsResource))}e.isUserDataProfile=f,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function C(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:L.URI.revive(i.location).with({scheme:t}),globalStorageHome:L.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:L.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:L.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:L.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:L.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:L.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:L.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=C;function s(i,t,r,a,w,p){return{id:i,name:t,location:r,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:p&&w?.useDefaultFlags?.globalState?p.globalStorageHome:(0,O.joinPath)(r,"globalStorage"),settingsResource:p&&w?.useDefaultFlags?.settings?p.settingsResource:(0,O.joinPath)(r,"settings.json"),keybindingsResource:p&&w?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,O.joinPath)(r,"keybindings.json"),tasksResource:p&&w?.useDefaultFlags?.tasks?p.tasksResource:(0,O.joinPath)(r,"tasks.json"),snippetsHome:p&&w?.useDefaultFlags?.snippets?p.snippetsHome:(0,O.joinPath)(r,"snippets"),extensionsResource:p&&w?.useDefaultFlags?.extensions?p.extensionsResource:(0,O.joinPath)(r,"extensions.json"),cacheHome:(0,O.joinPath)(a,i),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}e.toUserDataProfile=s;let o=class extends A.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,a,w){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=a,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new U.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new U.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new U.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new U.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new c.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.createDefaultProfile(),r=[t];if(this.enabled)try{for(const p of this.getStoredProfiles()){if(!p.name||!(0,d.isString)(p.name)||!p.location){this.logService.warn("Skipping the invalid stored profile",p.location||p.name);continue}r.push(s((0,O.basename)(p.location),p.name,p.location,this.profilesCacheHome,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},t))}}catch(p){this.logService.error(p)}const a=new c.ResourceMap,w=new Map;if(r.length)try{const p=this.getStoredProfileAssociations();if(p.workspaces)for(const[l,S]of Object.entries(p.workspaces)){const _=L.URI.parse(l),N=r.find($=>$.id===S);N&&a.set(_,N)}if(p.emptyWindows)for(const[l,S]of Object.entries(p.emptyWindows)){const _=r.find(N=>N.id===S);_&&w.set(l,_)}}catch(p){this.logService.error(p)}this._profilesObject={profiles:r,workspaces:a,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const t=s("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...t,extensionsResource:this.getDefaultProfileExtensionsLocation()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let w=0;for(const l of this.profiles){const S=a.exec(l.name),_=S?parseInt(S[1]):0;w=_>w?_:w}const p=`${r} ${w+1}`;return this.createProfile((0,k.hash)((0,y.generateUuid)()).toString(16),p,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,k.hash)((0,y.generateUuid)()).toString(16),t,r,a)}async createProfile(t,r,a,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const p=await this.doCreateProfile(t,r,a);return w&&await this.setProfileForWorkspace(w,p),p}async doCreateProfile(t,r,a){if(!(0,d.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(r);return w||(w=(async()=>{try{const p=this.profiles.find(_=>_.name===r||_.id===t);if(p)return p;const l=s(t,r,(0,O.joinPath)(this.profilesHome,t),this.profilesCacheHome,a,this.defaultProfile);await this.fileService.createFolder(l.location);const S=[];return this._onWillCreateProfile.fire({profile:l,join(_){S.push(_)}}),await E.Promises.settled(S),this.updateProfiles([l],[],[]),l}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,w)),w}async updateProfile(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(w=>w.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=s(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[a]),a}async removeProfile(t){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(w=>w.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(w){a.push(w)}});try{await Promise.allSettled(a)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(w){(0,g.toFileOperationResult)(w)!==1&&this.logService.error(w)}}async setProfileForWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(w=>w.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,a)}unsetWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return L.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(t){return(0,v.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,v.isWorkspaceIdentifier)(t)?t.configPath:t.id}isProfileAssociatedToWorkspace(t){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,a){const w=[...this.profiles,...t],p=[];this.transientProfilesObject.profiles=[];for(let l of w)l.isDefault||r.some(S=>l.id===S.id)||(l=a.find(S=>l.id===S.id)??l,l.isTransient?this.transientProfilesObject.profiles.push(l):p.push({location:l.location,name:l.name,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags}));this.saveStoredProfiles(p),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,a)}triggerProfilesChanges(t,r,a){this._onDidChangeProfiles.fire({added:t,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(t,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(t,void 0,!0);const w=this.getWorkspace(t),p=a?this.transientProfilesObject:this.profilesObject;L.URI.isUri(w)?(p.workspaces.delete(w),r&&p.workspaces.set(w,r)):(p.emptyWindows.delete(w),r&&p.emptyWindows.set(w,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[a,w]of this.profilesObject.workspaces.entries())t[a.toString()]=w.id;const r={};for(const[a,w]of this.profilesObject.emptyWindows.entries())r[a.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:t,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(t){const r={},a=this.createDefaultProfile();if(t.workspaces)for(const[p,l]of Object.entries(t.workspaces)){const S=L.URI.parse(l);r[p]=this.uriIdentityService.extUri.isEqual(S,a.location)?a.id:this.uriIdentityService.extUri.basename(S)}const w={};if(t.emptyWindows)for(const[p,l]of Object.entries(t.emptyWindows)){const S=L.URI.parse(l);w[p]=this.uriIdentityService.extUri.isEqual(S,a.location)?a.id:this.uriIdentityService.extUri.basename(S)}return{workspaces:r,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=ye([J(0,I.IEnvironmentService),J(1,g.IFileService),J(2,m.IUriIdentityService),J(3,b.ILogService)],o);class n extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=n}),define(oe[240],ae([0,1,6,2,17]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let O=class extends U.Disposable{constructor(R){super(),this._register(new k.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=O,e.UserDataProfilesCleaner=O=ye([J(0,A.IUserDataProfilesService)],O)}),define(oe[241],ae([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends R.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(t,r,a,w,p,l){super(),this.galleryService=t,this.telemetryService=r,this.uriIdentityService=a,this.logService=w,this.productService=p,this.userDataProfilesService=l,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(({task:S})=>S.cancel()),this.uninstallingExtensions.forEach(S=>S.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,v.isTargetPlatformCompatible)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const w=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:p})=>(0,c.areSameExtensions)(p,t.identifier));if(w?.local)return w?.local;throw w?.error?w.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw s(a)}}async installGalleryExtensions(t){if(!this.galleryService.isEnabled())throw new v.ExtensionManagementError(b.localize(0,null),v.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:w,options:p})=>{try{const l=await this.checkAndGetCompatibleVersion(w,!!p?.installGivenVersion,!!p?.installPreReleaseVersion);a.push({...l,options:p})}catch(l){r.push({identifier:w.identifier,operation:2,source:w,error:l})}})),a.length&&r.push(...await this.installExtensions(a));for(const w of r)w.error&&(this.logService.error("Failed to install extension.",w.identifier.id),this.logService.error(w.error),w.source&&!P.URI.isUri(w.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(w.source),error:w.error}));return r}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async toggleAppliationScope(t,r){if((0,m.isApplicationScopedExtension)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(a=await this.copyExtension(t,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const w of this.userDataProfilesService.profiles){const p=(await this.getInstalled(1,w.extensionsResource)).find(l=>(0,c.areSameExtensions)(l.identifier,t.identifier));p?this._onDidUpdateExtensionMetadata.fire(p):this._onDidUninstallExtension.fire({identifier:t.identifier,profileLocation:w.extensionsResource})}return a}else{const a=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(t,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtensions(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const w=await this.installExtension(a,(p,l)=>t.some(S=>(0,c.adoptToGalleryExtensionId)(l.identifier.id)===(0,c.getGalleryExtensionId)(S.manifest.publisher,S.manifest.name))?!1:this.canWaitForTask(p,l));r.push(...w)}catch(w){r.push({identifier:{id:(0,c.getGalleryExtensionId)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:w})}})),this._onDidInstallExtensions.fire(r),r}async installExtension({manifest:t,extension:r,options:a},w){const p=a.isApplicationScoped||a.isBuiltin||(0,m.isApplicationScopedExtension)(t),l={...a,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:p,profileLocation:p?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},S=Q=>`${c.ExtensionKey.create(Q).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const Q=this.installingExtensions.get(S(r));if(Q)return this.logService.info("Extensions is already requested to install",r.identifier.id),await Q.task.waitUntilTaskIsFinished(),[]}const _=[],N=[],$=[],W=this.createInstallExtensionTask(t,r,l);P.URI.isUri(r)||this.installingExtensions.set(S(r),{task:W,waitingTasks:[]}),this._onInstallExtension.fire({identifier:W.identifier,source:r,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",W.identifier.id),_.push({task:W,manifest:t});let q=!1;try{if(l.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",W.identifier.id);else try{const G=await this.getAllDepsAndPackExtensions(W.identifier,t,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),X=await this.getInstalled(void 0,l.profileLocation),x={...l,donotIncludePackAndDependencies:!0,context:{...l.context,[v.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:Y,manifest:B}of(0,k.distinct)(G,({gallery:z})=>z.identifier.id)){q=q||!!B.extensionDependencies?.some(ie=>(0,c.areSameExtensions)({id:ie},W.identifier));const z=S(Y),ee=this.installingExtensions.get(z);if(ee){if(w(W,ee.task)){const ie=ee.task.identifier;this.logService.info("Waiting for already requested installing extension",ie.id,W.identifier.id),ee.waitingTasks.push(W),N.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,Z=>Z.some(ne=>(0,c.areSameExtensions)(ne.identifier,ie)))).then(Z=>{if(this.logService.info("Finished waiting for already requested installing extension",ie.id,W.identifier.id),!Z.find(K=>(0,c.areSameExtensions)(K.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!X.some(({identifier:ie})=>(0,c.areSameExtensions)(ie,Y.identifier))){const ie=this.createInstallExtensionTask(B,Y,x);this.installingExtensions.set(z,{task:ie,waitingTasks:[W]}),this._onInstallExtension.fire({identifier:ie.identifier,source:Y,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,W.identifier.id),_.push({task:ie,manifest:B})}}}catch(G){if(P.URI.isUri(W.source))(0,k.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",W.identifier.id,G.message),(0,k.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",W.identifier.id,G.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",W.identifier.id),G}const Q=_.reduce((G,{task:X,manifest:x})=>(G.set(X.identifier.id.toLowerCase(),{task:X,manifest:x}),G),new Map);for(;Q.size;){let G;const X=[...Q.values()].filter(({manifest:x})=>!x.extensionDependencies?.some(Y=>Q.has(Y.toLowerCase())));X.length?G=Q.size===1?X:X.filter(({task:x})=>!(x===W&&!q)):(this.logService.info("Found extensions with circular dependencies",X.map(({task:x})=>x.identifier.id)),G=[...Q.values()]),await this.joinAllSettled(G.map(async({task:x})=>{const Y=new Date().getTime();try{const B=await x.run();if(await this.joinAllSettled(this.participants.map(z=>z.postInstall(B,x.source,l,A.CancellationToken.None))),!P.URI.isUri(x.source)){const z=x.operation===3,ee=z?void 0:(new Date().getTime()-x.source.lastUpdated)/1e3;if(o(this.telemetryService,z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-Y,durationSinceUpdate:ee}),I.isWeb&&x.operation!==3)try{await this.galleryService.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}$.push({local:B,identifier:x.identifier,operation:x.operation,source:x.source,context:x.options.context,profileLocation:x.profileLocation,applicationScoped:B.isApplicationScoped})}catch(B){throw P.URI.isUri(x.source)||o(this.telemetryService,x.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-Y,error:B}),this.logService.error("Error while installing the extension:",x.identifier.id),B}finally{Q.delete(x.identifier.id.toLowerCase())}}))}return N.length&&await this.joinAllSettled(N),$.forEach(({identifier:G})=>this.logService.info("Extension installed successfully:",G.id)),$}catch(Q){if(_.forEach(({task:G})=>G.cancel()),$.length)try{const G=await Promise.allSettled($.map(({local:X})=>this.createUninstallExtensionTask(X,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let X=0;X<G.length;X++){const x=G[X],{identifier:Y}=$[X];x.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Y.id):this.logService.warn("Rollback: Error while uninstalling extension",Y.id,(0,O.getErrorMessage)(x.reason))}}catch(G){this.logService.warn("Error while rolling back extensions",(0,O.getErrorMessage)(G),$.map(({identifier:X})=>X.id))}return _.map(({task:G})=>({identifier:G.identifier,operation:2,source:G.source,context:l.context,profileLocation:l.profileLocation,error:Q}))}finally{for(const{task:Q}of _)Q.source&&!P.URI.isUri(Q.source)&&this.installingExtensions.delete(S(Q.source))}}canWaitForTask(t,r){for(const[,{task:a,waitingTasks:w}]of this.installingExtensions.entries())if(a===t&&(w.includes(r)||w.some(p=>this.canWaitForTask(p,r)))||a===r&&w[0]&&!this.canWaitForTask(t,w[0]))return!1;return!0}async joinAllSettled(t){const r=[],a=[],w=await Promise.allSettled(t);for(const p of w)p.status==="fulfilled"?r.push(p.value):a.push(p.reason);if(a.length)throw C(a);return r}async getAllDepsAndPackExtensions(t,r,a,w,p){if(!this.galleryService.isEnabled())return[];const l=await this.getInstalled(void 0,p),S=[],_=[],N=async($,W)=>{S.push($);const q=W.extensionDependencies||[],Q=[...q];if(W.extensionPack){const G=a?l.find(X=>(0,c.areSameExtensions)(X.identifier,$)):void 0;for(const X of W.extensionPack)G&&G.manifest.extensionPack&&G.manifest.extensionPack.some(x=>(0,c.areSameExtensions)({id:x},{id:X}))||Q.every(x=>!(0,c.areSameExtensions)({id:x},{id:X}))&&Q.push(X)}if(Q.length){const G=Q.filter(X=>S.every(x=>!(0,c.areSameExtensions)(x,{id:X})));if(G.length){const X=await this.galleryService.getExtensions(G.map(x=>({id:x,preRelease:w})),A.CancellationToken.None);for(const x of X){if(S.find(z=>(0,c.areSameExtensions)(z,x.identifier)))continue;const Y=q.some(z=>(0,c.areSameExtensions)({id:z},x.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(x,!1,w)}catch(z){if(Y)throw z;this.logService.info("Skipping the packed extension as it cannot be installed",x.identifier.id,(0,O.getErrorMessage)(z));continue}_.push({gallery:B.extension,manifest:B.manifest}),await N(B.extension.identifier,B.manifest)}}}};return await N(t,r),_}async checkAndGetCompatibleVersion(t,r,a){let w;const p=await this.getExtensionsControlManifest();if(p.malicious.some(_=>(0,c.areSameExtensions)(t.identifier,_)))throw new v.ExtensionManagementError(b.localize(1,null,t.identifier.id),v.ExtensionManagementErrorCode.Malicious);const l=p.deprecated[t.identifier.id.toLowerCase()];if(l?.extension?.autoMigrate){if(this.logService.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${l.extension.id}' extension instead.`),w=(await this.galleryService.getExtensions([{id:l.extension.id,preRelease:l.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!w)throw new v.ExtensionManagementError(b.localize(2,null,t.identifier.id,l.extension.id),v.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const _=await this.getTargetPlatform();throw new v.ExtensionManagementError(b.localize(3,null,t.identifier.id,this.productService.nameLong,(0,v.TargetPlatformToString)(_)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(w=await this.getCompatibleVersion(t,r,a),!w)throw!a&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],A.CancellationToken.None))[0]?new v.ExtensionManagementError(b.localize(4,null,t.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),v.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",w.identifier.id);const S=await this.galleryService.getManifest(w,A.CancellationToken.None);if(S===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${w.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(S.version!==w.version)throw new v.ExtensionManagementError(`Cannot install '${w.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:w,manifest:S}}async getCompatibleVersion(t,r,a){const w=await this.getTargetPlatform();let p=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(p=(await this.galleryService.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:w,compatible:!0},A.CancellationToken.None))[0]||null),!p&&await this.galleryService.isExtensionCompatible(t,a,w)&&(p=t),p||(r?p=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:w,compatible:!0},A.CancellationToken.None))[0]||null:p=await this.galleryService.getCompatibleExtension(t,a,w)),p}async uninstallExtension(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},w=$=>`${$.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,p=this.uninstallingExtensions.get(w(t.identifier));if(p)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),p.waitUntilTaskIsFinished();const l=$=>{const W=this.createUninstallExtensionTask($,a);return this.uninstallingExtensions.set(w(W.extension.identifier),W),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this._onUninstallExtension.fire({identifier:$.identifier,profileLocation:a.profileLocation,applicationScoped:$.isApplicationScoped}),W},S=($,W)=>{W?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,a.profileLocation.toString(),W.message):this.logService.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,W.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,c.getLocalExtensionTelemetryData)($),error:W}),this._onDidUninstallExtension.fire({identifier:$.identifier,error:W?.code,profileLocation:a.profileLocation,applicationScoped:$.isApplicationScoped})},_=[],N=[];try{_.push(l(t));const $=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const W=this.getAllPackExtensionsToUninstall(t,$);for(const q of W)this.uninstallingExtensions.has(w(q.identifier))?this.logService.info("Extensions is already requested to uninstall",q.identifier.id):_.push(l(q))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(_.map(W=>W.extension),$,t),await this.joinAllSettled(_.map(async W=>{try{if(await W.run(),await this.joinAllSettled(this.participants.map(q=>q.postUninstall(W.extension,a,A.CancellationToken.None))),W.extension.identifier.uuid)try{await this.galleryService.reportStatistic(W.extension.manifest.publisher,W.extension.manifest.name,W.extension.manifest.version,"uninstall")}catch{}S(W.extension)}catch(q){const Q=q instanceof v.ExtensionManagementError?q:new v.ExtensionManagementError((0,O.getErrorMessage)(q),v.ExtensionManagementErrorCode.Internal);throw S(W.extension,Q),Q}finally{N.push(W)}}))}catch($){const W=$ instanceof v.ExtensionManagementError?$:new v.ExtensionManagementError((0,O.getErrorMessage)($),v.ExtensionManagementErrorCode.Internal);for(const q of _){try{q.cancel()}catch{}N.includes(q)||S(q.extension,W)}throw W}finally{for(const $ of _)this.uninstallingExtensions.delete(w($.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}checkForDependents(t,r,a){for(const w of t){const p=this.getDependents(w,r);if(p.length){const l=p.filter(S=>!t.some(_=>(0,c.areSameExtensions)(_.identifier,S.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(w,l,a))}}}getDependentsErrorMessage(t,r,a){return a===t?r.length===1?b.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const w=t.manifest.extensionPack?t.manifest.extensionPack:[];if(w.length){const p=r.filter(S=>!S.isBuiltin&&w.some(_=>(0,c.areSameExtensions)({id:_},S.identifier))),l=[];for(const S of p)l.push(...this.getAllPackExtensionsToUninstall(S,r,a));return[...p,...l]}return[]}getDependents(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(w=>(0,c.areSameExtensions)({id:w},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=f,e.AbstractExtensionManagementService=f=ye([J(0,v.IExtensionGalleryService),J(1,u.ITelemetryService),J(2,d.IUriIdentityService),J(3,E.ILogService),J(4,y.IProductService),J(5,h.IUserDataProfilesService)],f);function C(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=C;function s(i){if(i instanceof v.ExtensionManagementError)return i;const t=new v.ExtensionManagementError(i.message,v.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.toExtensionManagementError=s;function o(i,t,{extensionData:r,verificationStatus:a,duration:w,error:p,durationSinceUpdate:l}){let S,_;(0,g.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(S=v.ExtensionManagementErrorCode.Signature,_=a),a="Unverified")),p&&(p instanceof v.ExtensionManagementError?(S=p.code,p.code===v.ExtensionManagementErrorCode.Signature&&(_=p.message)):S=v.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:a,success:!p,duration:w,errorcode:S,errorcodeDetail:_,durationSinceUpdate:l})}class n{constructor(){this.barrier=new U.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,U.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,U.createCancelablePromise)(t=>new Promise((r,a)=>{const w=t.onCancellationRequested(()=>{w.dispose(),a(new O.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(oe[51],ae([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class h extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=h,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let f=class extends A.Disposable{constructor(n,i,t,r,a,w){super(),this.extensionsLocation=n,this.fileService=i,this.userDataProfilesService=t,this.uriIdentityService=r,this.telemetryService=a,this.logService=w,this._onAddExtensions=this._register(new O.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new O.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new O.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new O.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(n,i){return this.withProfileExtensions(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.withProfileExtensions(i,a=>{const w=[];for(const p of a)n.some(([l])=>(0,g.areSameExtensions)(l.identifier,p.identifier)&&l.manifest.version!==p.version)?t.push(p):w.push(p);for(const[p,l]of n){const S=w.findIndex(N=>(0,g.areSameExtensions)(N.identifier,p.identifier)&&N.version===p.manifest.version),_={identifier:p.identifier,version:p.manifest.version,location:p.location,metadata:l};S===-1?(r.push(_),w.push(_)):w.splice(S,1,_)}return r.length&&this._onAddExtensions.fire({extensions:r,profileLocation:i}),t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:i}),w}),r.length&&this._onDidAddExtensions.fire({extensions:r,profileLocation:i}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:i}),r}catch(a){throw r.length&&this._onDidAddExtensions.fire({extensions:r,error:a,profileLocation:i}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:a,profileLocation:i}),a}}async updateMetadata(n,i){const t=[];return await this.withProfileExtensions(i,r=>{const a=[];for(const w of r){const p=n.find(([l])=>(0,g.areSameExtensions)(l.identifier,w.identifier)&&l.manifest.version===w.version);p&&(w.metadata={...w.metadata,...p[1]},t.push(w)),a.push(w)}return a}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.withProfileExtensions(i,r=>{const a=[];for(const w of r)(0,g.areSameExtensions)(w.identifier,n.identifier)?t.push(w):a.push(w);return t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:i}),a}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:r,profileLocation:i}),r}}async withProfileExtensions(n,i,t){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],a;try{const w=await this.fileService.readFile(n);a=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,P.toFileOperationResult)(w)!==1)throw w;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&t?.bailOutWhenFileNotFound)throw new h((0,y.getErrorMessage)(w),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(n);let w=!1;for(const p of a){C(p)||this.reportAndThrowInvalidConentError(n);let l;if((0,E.isString)(p.relativeLocation)&&p.relativeLocation)l=this.resolveExtensionLocation(p.relativeLocation);else if((0,E.isString)(p.location))l=this.resolveExtensionLocation(p.location),w=!0,p.relativeLocation=p.location,p.location=l.toJSON();else{l=R.URI.revive(p.location);const S=this.toRelativePath(l);S&&(w=!0,p.relativeLocation=S)}r.push({identifier:p.identifier,location:l,version:p.version,metadata:p.metadata})}w&&await this.fileService.writeFile(n,U.VSBuffer.fromString(JSON.stringify(a)))}if(i){r=i(r);const w=r.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),relativeLocation:this.toRelativePath(p.location),metadata:p.metadata}));await this.fileService.writeFile(n,U.VSBuffer.fromString(JSON.stringify(w)))}return r})}reportAndThrowInvalidConentError(n){const i=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let t;try{t=(await this.fileService.readFile(n)).value.toString()}catch(a){if((0,P.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(w=>C(w))?r=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(n)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(i)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.logService.error(a)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let i=this.resourcesAccessQueueMap.get(n);return i||(i=new k.Queue,this.resourcesAccessQueueMap.set(n,i)),i}};e.AbstractExtensionsProfileScannerService=f,e.AbstractExtensionsProfileScannerService=f=ye([J(1,P.IFileService),J(2,c.IUserDataProfilesService),J(3,m.IUriIdentityService),J(4,u.ITelemetryService),J(5,v.ILogService)],f);function C(o){return(0,E.isObject)(o)&&(0,I.isIExtensionIdentifier)(o.identifier)&&(s(o.location)||(0,E.isString)(o.location)&&o.location)&&((0,E.isUndefined)(o.relativeLocation)||(0,E.isString)(o.relativeLocation))&&o.version&&(0,E.isString)(o.version)}function s(o){return o?(0,E.isString)(o.path)&&(0,E.isString)(o.scheme):!1}}),define(oe[80],ae([0,1,18,6,30,15,7,35,137,2,23,16,5,19,54,89,12,10,154,14,33,44,68,11,4,8,25,3,64,51,17,28,182]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C,s,o,n,i,t,r,a,w,p,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(X){function x(Y,B){if(Y===B)return!0;const z=Object.keys(Y),ee=new Set;for(const ie of Object.keys(B))ee.add(ie);if(z.length!==ee.size)return!1;for(const ie of z){if(Y[ie]!==B[ie])return!1;ee.delete(ie)}return ee.size===0}X.equals=x})(_||(e.Translations=_={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let N=class extends g.Disposable{constructor(x,Y,B,z,ee,ie,Z,ne,K,j,D,T){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=Y,this.extensionsControlLocation=B,this.currentProfile=z,this.userDataProfilesService=ee,this.extensionsProfileScannerService=ie,this.fileService=Z,this.logService=ne,this.environmentService=K,this.productService=j,this.uriIdentityService=D,this.instantiationService=T,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,c.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(q,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(q,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(W,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(x,Y,B){const[z,ee]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(Y)]),ie=B?await this.scanExtensionsUnderDevelopment(x,[...z,...ee]):[];return this.dedupExtensions(z,ee,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!x.useCache,x.language)),Y.push(this.scanDevSystemExtensions(x.language,!!x.checkControlFile));const[B,z]=await Promise.all(Y);return this.applyScanOptions([...B,...z],0,x,!1)}async scanUserExtensions(x){const Y=x.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const B=this.uriIdentityService.extUri.isEqual(x.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.createExtensionScannerInput(Y,!!x.profileLocation,1,!x.includeUninstalled,x.language,!0,B),ee=x.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ie;try{ie=await ee.scanExtensions(z)}catch(Z){if(Z instanceof w.ExtensionsProfileScanningError&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ie=await ee.scanExtensions(z);else throw Z}return ie=await this.applyScanOptions(ie,1,x,!0),this.logService.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(x,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const B=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===P.Schemas.file).map(async z=>{const ee=await this.createExtensionScannerInput(z,!1,1,!0,x.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ee)).map(Z=>(Z.type=Y.find(ne=>(0,f.areSameExtensions)(ne.identifier,Z.identifier))?.type??Z.type,this.extensionsScanner.validate(Z,ee)))}))).flat();return this.applyScanOptions(B,"development",x,!0)}return[]}async scanExistingExtension(x,Y,B){const z=await this.createExtensionScannerInput(x,!1,Y,!0,B.language,!0,void 0),ee=await this.extensionsScanner.scanExtension(z);return!ee||!B.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(x,Y,B){const z=await this.createExtensionScannerInput(x,!1,Y,!0,B.language,!0,void 0),ee=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions(ee,Y,B,!0)}async scanMetadata(x){const Y=(0,c.joinPath)(x,"package.json"),B=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(x,Y){const B=(0,c.joinPath)(x,"package.json"),z=(await this.fileService.readFile(B)).value.toString(),ee=JSON.parse(z);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,ee.__metadata={...ee.__metadata,...Y},await this.fileService.writeFile((0,c.joinPath)(x,"package.json"),O.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof w.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw x}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.extensionsProfileScannerService.addExtensionsToProfile(x.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,o.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.logService.error(x)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(x,Y,B,z){return B.includeAllVersions||(x=this.dedupExtensions(Y===0?x:void 0,Y===1?x:void 0,Y==="development"?x:void 0,await this.getTargetPlatform(),z)),B.includeInvalid||(x=x.filter(ee=>ee.isValid)),x.sort((ee,ie)=>{const Z=b.basename(ee.location.fsPath),ne=b.basename(ie.location.fsPath);return Z<ne?-1:Z>ne?1:0})}dedupExtensions(x,Y,B,z,ee){const ie=(ne,K,j)=>{if(ne.isValid&&!K.isValid)return!1;if(ne.isValid===K.isValid){if(ee&&m.gt(ne.manifest.version,K.manifest.version))return this.logService.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if(m.eq(ne.manifest.version,K.manifest.version)){if(ne.type===0)return this.logService.debug(`Skipping extension ${K.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===z)return this.logService.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return j?this.logService.warn(`Overwriting user extension ${ne.location.path} with ${K.location.path}.`):this.logService.debug(`Overwriting user extension ${ne.location.path} with ${K.location.path}.`),!0},Z=new C.ExtensionIdentifierMap;return x?.forEach(ne=>{const K=Z.get(ne.identifier.id);(!K||ie(K,ne,!1))&&Z.set(ne.identifier.id,ne)}),Y?.forEach(ne=>{const K=Z.get(ne.identifier.id);if(!K&&x&&ne.type===0){this.logService.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!K||ie(K,ne,!1))&&Z.set(ne.identifier.id,ne)}),B?.forEach(ne=>{const K=Z.get(ne.identifier.id);(!K||ie(K,ne,!0))&&Z.set(ne.identifier.id,ne),Z.set(ne.identifier.id,ne)}),[...Z.values()]}async scanDefaultSystemExtensions(x,Y){this.logService.trace("Started scanning system extensions");const B=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),ee=await(x&&!B.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return this.logService.trace("Scanned system extensions:",ee.length),ee}async scanDevSystemExtensions(x,Y){const B=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!B?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=Y?await this.getBuiltInExtensionControl():{},ee=[],ie=u.URI.file(b.normalize(b.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of B){const K=z[ne.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":ee.push((0,c.joinPath)(ie,ne.name));break;default:ee.push(u.URI.file(K));break}}const Z=await Promise.all(ee.map(async ne=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ne,!1,0,!0,x,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",Z.length),(0,k.coalesce)(Z)}async getBuiltInExtensionControl(){try{const x=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(x.value.toString())}catch{return{}}}async createExtensionScannerInput(x,Y,B,z,ee,ie,Z){const ne=await this.getTranslations(ee??v.language),K=await this.getMtime(x),j=Y&&!this.uriIdentityService.extUri.isEqual(x,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,D=j?await this.getMtime(j):void 0;return new $(x,K,j,D,Y,Z,B,z,ie,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ee,ne)}async getMtime(x){try{const Y=await this.fileService.stat(x);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.AbstractExtensionsScannerService=N,e.AbstractExtensionsScannerService=N=ye([J(4,p.IUserDataProfilesService),J(5,w.IExtensionsProfileScannerService),J(6,o.IFileService),J(7,i.ILogService),J(8,h.IEnvironmentService),J(9,t.IProductService),J(10,l.IUriIdentityService),J(11,n.IInstantiationService)],N);class ${constructor(x,Y,B,z,ee,ie,Z,ne,K,j,D,T,M,F,V){this.location=x,this.mtime=Y,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=z,this.profile=ee,this.profileScanOptions=ie,this.type=Z,this.excludeObsolete=ne,this.validate=K,this.productVersion=j,this.productDate=D,this.productCommit=T,this.devMode=M,this.language=F,this.translations=V}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,Y){return(0,c.isEqual)(x.location,Y.location)&&x.mtime===Y.mtime&&(0,c.isEqual)(x.applicationExtensionslocation,Y.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&x.profile===Y.profile&&A.equals(x.profileScanOptions,Y.profileScanOptions)&&x.type===Y.type&&x.excludeObsolete===Y.excludeObsolete&&x.validate===Y.validate&&x.productVersion===Y.productVersion&&x.productDate===Y.productDate&&x.productCommit===Y.productCommit&&x.devMode===Y.devMode&&x.language===Y.language&&_.equals(x.translations,Y.translations)}}e.ExtensionScannerInput=$;let W=class extends g.Disposable{constructor(x,Y,B,z,ee){super(),this.obsoleteFile=x,this.extensionsProfileScannerService=Y,this.uriIdentityService=B,this.fileService=z,this.logService=ee}async scanExtensions(x){const Y=x.profile?await this.scanExtensionsFromProfile(x):await this.scanExtensionsFromLocation(x);let B={};if(x.excludeObsolete&&x.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();B=JSON.parse(z)}catch{}return(0,y.isEmptyObject)(B)?Y:Y.filter(z=>!B[f.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(x){const Y=await this.fileService.resolve(x.location);if(!Y.children?.length)return[];const B=await Promise.all(Y.children.map(async z=>{if(!z.isDirectory||x.type===1&&(0,c.basename)(z.resource).indexOf(".")===0)return null;const ee=new $(z.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(ee)}));return(0,k.coalesce)(B).sort((z,ee)=>z.location.path<ee.location.path?-1:1)}async scanExtensionsFromProfile(x){let Y=await this.scanExtensionsFromProfileResource(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(x.location,x.applicationExtensionslocation)){Y=Y.filter(z=>!z.metadata?.isApplicationScoped);const B=await this.scanExtensionsFromProfileResource(x.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,x);Y.push(...B)}return Y}async scanExtensionsFromProfileResource(x,Y,B){const z=await this.extensionsProfileScannerService.scanProfileExtensions(x,B.profileScanOptions);if(!z.length)return[];const ee=await Promise.all(z.map(async ie=>{if(Y(ie)){const Z=new $(ie.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Z,ie.metadata)}return null}));return(0,k.coalesce)(ee)}async scanOneOrMultipleExtensions(x){try{if(await this.fileService.exists((0,c.joinPath)(x.location,"package.json"))){const Y=await this.scanExtension(x);return Y?[Y]:[]}else return await this.scanExtensions(x)}catch(Y){return this.logService.error(`Error scanning extensions at ${x.location.path}:`,(0,L.getErrorMessage)(Y)),[]}}async scanExtension(x,Y){try{let B=await this.scanExtensionManifest(x.location);if(B){B.publisher||(B.publisher=C.UNDEFINED_PUBLISHER),Y=Y??B.__metadata,delete B.__metadata;const z=(0,f.getGalleryExtensionId)(B.publisher,B.name),ee=Y?.id?{id:z,uuid:Y.id}:{id:z},ie=Y?.isSystem?0:x.type,Z=ie===0||!!Y?.isBuiltin;B=await this.translateManifest(x.location,B,$.createNlsConfiguration(x));const ne={type:ie,identifier:ee,manifest:B,location:x.location,isBuiltin:Z,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return x.validate?this.validate(ne,x):ne}}catch(B){x.type!==0&&this.logService.error(B)}return null}validate(x,Y){let B=!0;const z=(0,s.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,x.manifest,x.isBuiltin);for(const[ee,ie]of z)ee===E.default.Error&&(B=!1,this.logService.error(this.formatMessage(Y.location,ie)));return x.isValid=B,x.validations=z,x}async scanExtensionManifest(x){const Y=(0,c.joinPath)(x,"package.json");let B;try{B=(await this.fileService.readFile(Y)).value.toString()}catch(ee){return(0,o.toFileOperationResult)(ee)!==1&&this.logService.error(this.formatMessage(x,(0,d.localize)(0,null,Y.path,ee.message))),null}let z;try{z=JSON.parse(B)}catch{const ie=[];(0,R.parse)(B,ie);for(const Z of ie)this.logService.error(this.formatMessage(x,(0,d.localize)(1,null,Y.path,Z.offset,Z.length,(0,I.getParseErrorMessage)(Z.error))));return null}return(0,R.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(x,(0,d.localize)(2,null,Y.path))),null):z}async translateManifest(x,Y,B){const z=await this.getLocalizedMessages(x,Y,B);if(z)try{const ee=[],ie=await this.resolveOriginalMessageBundle(z.default,ee);if(ee.length>0)return ee.forEach(ne=>{this.logService.error(this.formatMessage(x,(0,d.localize)(3,null,z.default?.path,(0,I.getParseErrorMessage)(ne.error))))}),Y;if((0,R.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(x,(0,d.localize)(4,null,z.default?.path))),Y;const Z=z.values||Object.create(null);return(0,S.localizeManifest)(this.logService,Y,Z,ie)}catch{}return Y}async getLocalizedMessages(x,Y,B){const z=(0,c.joinPath)(x,"package.nls.json"),ee=(K,j)=>{j.forEach(D=>{this.logService.error(this.formatMessage(x,(0,d.localize)(5,null,K?.path,(0,I.getParseErrorMessage)(D.error))))})},ie=K=>{this.logService.error(this.formatMessage(x,(0,d.localize)(6,null,K?.path)))},Z=`${Y.publisher}.${Y.name}`,ne=B.translations[Z];if(ne)try{const K=u.URI.file(ne),j=(await this.fileService.readFile(K)).value.toString(),D=[],T=(0,R.parse)(j,D);return D.length>0?(ee(K,D),{values:void 0,default:z}):(0,R.getNodeType)(T)!=="object"?(ie(K),{values:void 0,default:z}):{values:T.contents?T.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let j;try{j=await this.findMessageBundles(x,B)}catch{return}if(!j.localized)return{values:void 0,default:j.original};try{const D=(await this.fileService.readFile(j.localized)).value.toString(),T=[],M=(0,R.parse)(D,T);return T.length>0?(ee(j.localized,T),{values:void 0,default:j.original}):(0,R.getNodeType)(M)!=="object"?(ie(j.localized),{values:void 0,default:j.original}):{values:M,default:j.original}}catch{return{values:void 0,default:j.original}}}}async resolveOriginalMessageBundle(x,Y){if(x)try{const B=(await this.fileService.readFile(x)).value.toString();return(0,R.parse)(B,Y)}catch{}}findMessageBundles(x,Y){return new Promise((B,z)=>{const ee=ie=>{const Z=(0,c.joinPath)(x,`package.nls.${ie}.json`);this.fileService.exists(Z).then(ne=>{ne&&B({localized:Z,original:(0,c.joinPath)(x,"package.nls.json")});const K=ie.lastIndexOf("-");K===-1?B({localized:(0,c.joinPath)(x,"package.nls.json"),original:null}):(ie=ie.substring(0,K),ee(ie))})};if(Y.devMode||Y.pseudo||!Y.language)return B({localized:(0,c.joinPath)(x,"package.nls.json"),original:null});ee(Y.language)})}formatMessage(x,Y){return`[${x.path}]: ${Y}`}};W=ye([J(1,w.IExtensionsProfileScannerService),J(2,l.IUriIdentityService),J(3,o.IFileService),J(4,i.ILogService)],W);let q=class extends W{constructor(x,Y,B,z,ee,ie,Z){super(Y,z,ee,ie,Z),this.currentProfile=x,this.userDataProfilesService=B,this.cacheValidatorThrottler=this._register(new U.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(x){const Y=this.getCacheFile(x),B=await this.readExtensionCache(Y);if(this.input=x,B&&B.input&&$.equals(B.input,this.input))return this.logService.debug("Using cached extensions scan result",x.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(ee=>(ee.location=u.URI.revive(ee.location),ee));const z=await super.scanExtensions(x);return await this.writeExtensionCache(Y,{input:x,result:z}),z}async readExtensionCache(x){try{const Y=await this.fileService.readFile(x),B=JSON.parse(Y.value.toString());return{result:B.result,input:(0,a.revive)(B.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",x.path,(0,L.getErrorMessage)(Y))}return null}async writeExtensionCache(x,Y){try{await this.fileService.writeFile(x,O.VSBuffer.fromString(JSON.stringify(Y)))}catch(B){this.logService.debug("Error while writing the extension cache file:",x.path,(0,L.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const x=this.getCacheFile(this.input),Y=await this.readExtensionCache(x);if(!Y)return;const B=Y.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!A.equals(z,B))try{this.logService.info("Invalidating Cache",B,z),await this.fileService.del(x),this._onDidChangeCache.fire()}catch(ee){this.logService.error(ee)}}getCacheFile(x){const Y=this.getProfile(x);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,x.type===0?C.BUILTIN_MANIFEST_CACHE_FILE:C.USER_MANIFEST_CACHE_FILE)}getProfile(x){return x.type===0?this.userDataProfilesService.defaultProfile:x.profile?this.uriIdentityService.extUri.isEqual(x.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(x.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};q=ye([J(2,p.IUserDataProfilesService),J(3,w.IExtensionsProfileScannerService),J(4,l.IUriIdentityService),J(5,o.IFileService),J(6,i.ILogService)],q);function Q(X,x){const Y=(0,f.getExtensionId)(X.manifest.publisher,X.manifest.name);return{id:Y,identifier:new C.ExtensionIdentifier(Y),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:x,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,...X.manifest}}e.toExtensionDescription=Q;class G extends N{constructor(x,Y,B,z,ee,ie,Z,ne,K,j,D,T){super(x,Y,(0,c.joinPath)(B,".vscode-oss-dev","extensions","control.json"),z,ee,ie,Z,ne,K,j,D,T),this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const M=await this.fileService.readFile(u.URI.file(v.translationsConfigFile));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}getTranslations(x){return this.translationsPromise}}e.NativeExtensionsScannerService=G}),define(oe[242],ae([0,1,65,6,38,3,2,23,16,31,8,17]),function(te,e,k,U,A,O,L,R,I,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends L.Disposable{constructor(m,E){super(),this.userDataProfilesService=m,this.logService=E,this.processesLimiter=new U.Limiter(5)}async postUninstall(m){const E=this.parseScript(m,"uninstall");E&&(this.logService.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(E.script,"uninstall",E.args,!0,m),this.logService.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(y){this.logService.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.logService.error(y)}}));try{await g.Promises.rm(this.getExtensionStoragePath(m))}catch(y){this.logService.error("Error while removing extension storage path",m.identifier.id),this.logService.error(y)}}parseScript(m,E){const y=`vscode:${E}`;if(m.location.scheme===R.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[y]=="string"){const u=m.manifest.scripts[y].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(m.identifier.id,m.manifest.version,`${y} should be a node script`),null):{script:(0,I.join)(m.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(m,E,y,u,d){return new Promise((h,f)=>{const C=this.start(m,E,y,d);let s;const o=n=>{s&&(clearTimeout(s),s=null),n?f(n):h(void 0)};C.on("error",n=>{o((0,A.toErrorMessage)(n)||"Unknown")}),C.on("exit",(n,i)=>{o(n?`post-${E} process exited with code ${n}`:void 0)}),u&&(s=setTimeout(()=>{s=null,C.kill(),f("timed out")},5e3))})}start(m,E,y,u){const d={silent:!0,execArgv:void 0},h=(0,k.fork)(m,[`--type=extension-post-${E}`,...y],d);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const f=O.Event.fromNodeEventEmitter(h.stdout,"data"),C=O.Event.fromNodeEventEmitter(h.stderr,"data");f(n=>this.logService.info(u.identifier.id,u.manifest.version,`post-${E}`,n)),C(n=>this.logService.error(u.identifier.id,u.manifest.version,`post-${E}`,n));const s=O.Event.any(O.Event.map(f,n=>({data:`%c${n}`,format:[""]})),O.Event.map(C,n=>({data:`%c${n}`,format:["color: red"]})));return O.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(u.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}getExtensionStoragePath(m){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=v,e.ExtensionsLifecycle=v=ye([J(0,b.IUserDataProfilesService),J(1,P.ILogService)],v)}),define(oe[243],ae([0,1,8,17,28,22,51,11,14,10]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends L.AbstractExtensionsProfileScannerService{constructor(v,c,m,E,y,u){super(g.URI.file(v.extensionsPath),c,m,E,y,u)}};e.ExtensionsProfileScannerService=P,e.ExtensionsProfileScannerService=P=ye([J(0,I.INativeEnvironmentService),J(1,R.IFileService),J(2,U.IUserDataProfilesService),J(3,A.IUriIdentityService),J(4,O.ITelemetryService),J(5,k.ILogService)],P)}),define(oe[244],ae([0,1,10,14,51,80,11,4,8,25,28,17]),function(te,e,k,U,A,O,L,R,I,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=class extends O.NativeExtensionsScannerService{constructor(m,E,y,u,d,h,f,C){super(k.URI.file(d.builtinExtensionsPath),k.URI.file(d.extensionsPath),d.userHome,m.defaultProfile,m,E,y,u,d,h,f,C)}};e.ExtensionsScannerService=v,e.ExtensionsScannerService=v=ye([J(0,b.IUserDataProfilesService),J(1,A.IExtensionsProfileScannerService),J(2,L.IFileService),J(3,I.ILogService),J(4,U.INativeEnvironmentService),J(5,g.IProductService),J(6,P.IUriIdentityService),J(7,R.IInstantiationService)],v)}),define(oe[21],ae([0,1,6,3,2,100,12,67,4,17]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var v;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function c(d){const h=d.get(e.TARGET_KEY);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.loadKeyTargets=c;class m extends A.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(h={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super(),this.options=h,this._onDidChangeValue=this._register(new U.PauseableEmitter),this._onDidChangeTarget=this._register(new U.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new U.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(h,f,C){return U.Event.filter(this._onDidChangeValue.event,s=>s.scope===h&&(f===void 0||s.key===f),C)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(h,f){const{key:C,external:s}=f;if(C===e.TARGET_KEY){switch(h){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:h})}else this._onDidChangeValue.fire({scope:h,key:C,target:this.getKeyTargets(h)[C],external:s})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}get(h,f,C){return this.getStorage(f)?.get(h,C)}getBoolean(h,f,C){return this.getStorage(f)?.getBoolean(h,C)}getNumber(h,f,C){return this.getStorage(f)?.getNumber(h,C)}getObject(h,f,C){return this.getStorage(f)?.getObject(h,C)}storeAll(h,f){this.withPausedEmitters(()=>{for(const C of h)this.store(C.key,C.value,C.scope,C.target,f)})}store(h,f,C,s,o=!1){if((0,L.isUndefinedOrNull)(f)){this.remove(h,C,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,C,s),this.getStorage(C)?.set(h,f,o)})}remove(h,f,C=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(h,f,void 0),this.getStorage(f)?.delete(h,C)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,f){const C=[],s=this.getKeyTargets(h);for(const o of Object.keys(s))s[o]===f&&C.push(o);return C}updateKeyTarget(h,f,C,s=!1){const o=this.getKeyTargets(f);typeof C=="number"?o[h]!==C&&(o[h]=C,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(o),s)):typeof o[h]=="number"&&(delete o[h],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(o),s))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(h){switch(h){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(h){const f=this.getStorage(h);return f?c(f):Object.create(null)}isNew(h){return this.getBoolean(e.IS_NEW_KEY,h)===!0}async flush(h=P.NONE){this._onWillSaveState.fire({reason:h});const f=this.getStorage(-1),C=this.getStorage(0),s=this.getStorage(1);switch(h){case P.NONE:await k.Promises.settled([f?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await k.Promises.settled([f?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return u(h,f,C,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(h){return await this.flush(),this.getStorage(h)?.optimize()}async switch(h,f){return this.emitWillSaveState(P.NONE),(0,g.isUserDataProfile)(h)?this.switchToProfile(h,f):this.switchToWorkspace(h,f)}canSwitchProfile(h,f){return!(h.id===f.id||E(f)&&E(h))}switchData(h,f,C){this.withPausedEmitters(()=>{const s=new Set;for(const[o,n]of h)s.add(o),f.get(o)!==n&&this.emitDidChangeValue(C,{key:o,external:!0});for(const[o]of f.items)s.has(o)||this.emitDidChangeValue(C,{key:o,external:!0})})}}e.AbstractStorageService=m;function E(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=E;class y extends m{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(h=>this.emitDidChangeValue(1,h))),this._register(this.profileStorage.onDidChangeStorage(h=>this.emitDidChangeValue(0,h))),this._register(this.applicationStorage.onDidChangeStorage(h=>this.emitDidChangeValue(-1,h)))}getStorage(h){switch(h){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(h){return!1}}e.InMemoryStorageService=y;async function u(d,h,f,C,s,o){const n=_=>{try{return JSON.parse(_)}catch{return _}},i=new Map,t=new Map;d.forEach((_,N)=>{i.set(N,_),t.set(N,n(_))});const r=new Map,a=new Map;h.forEach((_,N)=>{r.set(N,_),a.set(N,n(_))});const w=new Map,p=new Map;f.forEach((_,N)=>{w.set(N,_),p.set(N,n(_))}),console.group(C!==s?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const l=[];if(i.forEach((_,N)=>{l.push({key:N,value:_})}),console.table(l),console.groupEnd(),console.log(t),C!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const _=[];r.forEach((N,$)=>{_.push({key:$,value:N})}),console.table(_),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const S=[];w.forEach((_,N)=>{S.push({key:N,value:_})}),console.table(S),console.groupEnd(),console.log(p)}e.logStorage=u}),define(oe[113],ae([0,1,3,2,12,29,33,21]),function(te,e,k,U,A,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends U.Disposable{constructor(b,v){super(),this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new g(b)),this._register(this.storageManger.onDidChange(c=>this._onDidChangeEnablement.fire({extensions:c,source:"storage"}))),this._register(v.onDidInstallExtensions(c=>c.forEach(({local:m,operation:E})=>{m&&E===4&&this._removeFromDisabledExtensions(m.identifier)})))}async enableExtension(b,v){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:v}),!0):!1}async disableExtension(b,v){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(O.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){const v=this.getDisabledExtensions();return v.every(c=>!(0,L.areSameExtensions)(c,b))?(v.push(b),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(b){const v=this.getDisabledExtensions();for(let c=0;c<v.length;c++){const m=v[c];if((0,L.areSameExtensions)(m,b))return v.splice(c,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(b){this._setExtensions(O.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,v){this.storageManger.set(b,v,0)}};e.GlobalExtensionEnablementService=I,e.GlobalExtensionEnablementService=I=ye([J(0,R.IStorageService),J(1,O.IExtensionManagementService)],I);class g extends U.Disposable{constructor(b){super(),this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(0,void 0,this._register(new U.DisposableStore))(v=>this.onDidStorageChange(v)))}get(b,v){let c;return v===0?((0,A.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,v)),c=this.storage[b]):c=this._get(b,v),JSON.parse(c)}set(b,v,c){const m=JSON.stringify(v.map(({id:y,uuid:u})=>({id:y,uuid:u})));this._get(b,c)!==m&&(c===0&&(v.length?this.storage[b]=m:delete this.storage[b]),this._set(b,v.length?m:void 0,c))}onDidStorageChange(b){if(!(0,A.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const c=this.get(b.key,b.scope);delete this.storage[b.key];const m=this.get(b.key,b.scope),E=c.filter(u=>!m.some(d=>(0,L.areSameExtensions)(u,d))),y=m.filter(u=>!c.some(d=>(0,L.areSameExtensions)(d,u)));(E.length||y.length)&&this._onDidChange.fire([...E,...y])}}_get(b,v){return this.storageService.get(b,v,"[]")}_set(b,v,c){v?this.storageService.store(b,v,c,1):this.storageService.remove(b,c)}}e.StorageManager=g}),define(oe[245],ae([0,1,18,26,7,5,37,12,10,20,14,29,33,68,11,8,25,57,223,21,22,61]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=O.isWeb?"web":(0,b.getTargetPlatform)(O.platform,L.arch),o="X-Market-Search-Activity-Id";var n;(function(D){D[D.None=0]="None",D[D.IncludeVersions=1]="IncludeVersions",D[D.IncludeFiles=2]="IncludeFiles",D[D.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",D[D.IncludeSharedAccounts=8]="IncludeSharedAccounts",D[D.IncludeVersionProperties=16]="IncludeVersionProperties",D[D.ExcludeNonValidated=32]="ExcludeNonValidated",D[D.IncludeInstallationTargets=64]="IncludeInstallationTargets",D[D.IncludeAssetUri=128]="IncludeAssetUri",D[D.IncludeStatistics=256]="IncludeStatistics",D[D.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",D[D.Unpublished=4096]="Unpublished",D[D.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...D){return String(D.reduce((T,M)=>T|M,0))}var t;(function(D){D[D.Tag=1]="Tag",D[D.ExtensionId=4]="ExtensionId",D[D.Category=5]="Category",D[D.ExtensionName=7]="ExtensionName",D[D.Target=8]="Target",D[D.Featured=9]="Featured",D[D.SearchText=10]="SearchText",D[D.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class l{constructor(T=p){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(T,M=this.state.pageSize){return new l({...this.state,pageNumber:T,pageSize:M})}withFilter(T,...M){const F=[...this.state.criteria,...M.length?M.map(V=>({filterType:T,value:V})):[{filterType:T}]];return new l({...this.state,criteria:F})}withSortBy(T){return new l({...this.state,sortBy:T})}withSortOrder(T){return new l({...this.state,sortOrder:T})}withFlags(...T){return new l({...this.state,flags:T.reduce((M,F)=>M|F,0)})}withAssetTypes(...T){return new l({...this.state,assetTypes:T})}withSource(T){return new l({...this.state,source:T})}get raw(){const{criteria:T,pageNumber:M,pageSize:F,sortBy:V,sortOrder:H,flags:re,assetTypes:ce}=this.state;return{filters:[{criteria:T,pageNumber:M,pageSize:F,sortBy:V,sortOrder:H}],assetTypes:ce,flags:re}}get searchText(){const T=this.state.criteria.filter(M=>M.filterType===t.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function S(D,T){const M=(D||[]).filter(F=>F.statisticName===T)[0];return M?M.value:0}function _(D){const T="Microsoft.VisualStudio.Code.Translation.";return D.files.filter(F=>F.assetType.indexOf(T)===0).reduce((F,V)=>{const H=W(D,V.assetType);return H&&F.push([V.assetType.substring(T.length),H]),F},[])}function N(D){if(D.properties){const T=D.properties.filter(V=>V.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=T.filter(V=>M.test(V.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return W(D,r.Repository)}function $(D){return{uri:`${D.fallbackAssetUri}/${r.VSIX}?redirect=true${D.targetPlatform?`&targetPlatform=${D.targetPlatform}`:""}`,fallbackUri:`${D.fallbackAssetUri}/${r.VSIX}${D.targetPlatform?`?targetPlatform=${D.targetPlatform}`:""}`}}function W(D,T){return D.files.filter(F=>F.assetType===T)[0]?{uri:`${D.assetUri}/${T}${D.targetPlatform?`?targetPlatform=${D.targetPlatform}`:""}`,fallbackUri:`${D.fallbackAssetUri}/${T}${D.targetPlatform?`?targetPlatform=${D.targetPlatform}`:""}`}:null}function q(D,T){const M=D.properties?D.properties.filter(V=>V.key===T):[],F=M.length>0&&M[0].value;return F?F.split(",").map(V=>(0,v.adoptToGalleryExtensionId)(V)):[]}function Q(D){const T=D.properties?D.properties.filter(M=>M.key===a.Engine):[];return T.length>0&&T[0].value||""}function G(D){const T=D.properties?D.properties.filter(M=>M.key===a.PreRelease):[];return T.length>0&&T[0].value==="true"}function X(D){const T=D.properties?D.properties.filter(F=>F.key===a.LocalizedLanguages):[],M=T.length>0&&T[0].value||"";return M?M.split(","):[]}function x(D){return D.properties?.find(T=>T.key===a.SponsorLink)?.value}function Y(D){return D.indexOf("preview")!==-1}function B(D){return D.targetPlatform?(0,b.toTargetPlatform)(D.targetPlatform):"undefined"}function z(D){const T=(0,k.distinct)(D.versions.map(B)),M=!!D.tags?.includes(b.WEB_EXTENSION_TAG),F=T.indexOf("web");return M?F===-1&&T.push("web"):F!==-1&&T.splice(F,1),T}function ee(D,T){for(let M=0;M<D.length;M++){const F=D[M];if(F.version===D[M-1]?.version){let V=M;if(B(F)===T)for(;V>0&&D[V-1].version===F.version;)V--;V!==M&&(D.splice(M,1),D.splice(V,0,F))}}return D}e.sortExtensionVersions=ee;function ie(D,T,M){D.telemetryData={index:T,querySource:M,queryActivityId:D.queryContext?.[o]}}function Z(D,T,M,F){const V=D.versions[0],H={manifest:W(T,r.Manifest),readme:W(T,r.Details),changelog:W(T,r.Changelog),license:W(T,r.License),repository:N(T),download:$(T),icon:W(T,r.Icon),signature:W(T,r.Signature),coreTranslations:_(T)};return{identifier:{id:(0,v.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},name:D.extensionName,version:T.version,displayName:D.displayName,publisherId:D.publisher.publisherId,publisher:D.publisher.publisherName,publisherDisplayName:D.publisher.displayName,publisherDomain:D.publisher.domain?{link:D.publisher.domain,verified:!!D.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(V),description:D.shortDescription||"",installCount:S(D.statistics,"install"),rating:S(D.statistics,"averagerating"),ratingCount:S(D.statistics,"ratingcount"),categories:D.categories||[],tags:D.tags||[],releaseDate:Date.parse(D.releaseDate),lastUpdated:Date.parse(D.lastUpdated),allTargetPlatforms:M,assets:H,properties:{dependencies:q(T,a.Dependency),extensionPack:q(T,a.ExtensionPack),engine:Q(T),localizedLanguages:X(T),targetPlatform:B(T),isPreReleaseVersion:G(T)},hasPreReleaseVersion:G(V),hasReleaseVersion:!0,preview:Y(D.flags),isSigned:!!H.signature,queryContext:F}}let ne=class{constructor(T,M,F,V,H,re,ce,he){this.requestService=M,this.logService=F,this.environmentService=V,this.telemetryService=H,this.fileService=re,this.productService=ce,this.configurationService=he;const ue=ce.extensionsGallery,me=ue?.servicePPEUrl&&he.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=me?ue.servicePPEUrl:ue?.serviceUrl,this.extensionsGallerySearchUrl=me?void 0:ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,d.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,T,this.telemetryService)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,M,F){const V=U.CancellationToken.isCancellationToken(M)?{}:M,H=U.CancellationToken.isCancellationToken(M)?M:F,re=[],ce=[],he=[],ue=[];let me=!0;for(const we of T){we.uuid?ce.push(we.uuid):re.push(we.id);const Le=!!(we.version||we.preRelease);he.push({id:we.id,uuid:we.uuid,includePreRelease:Le}),we.version&&ue.push({id:we.id,uuid:we.uuid,version:we.version}),me=me&&!!we.hasPreRelease&&!Le}if(!ce.length&&!re.length)return[];let fe=new l().withPage(1,T.length);ce.length&&(fe=fe.withFilter(t.ExtensionId,...ce)),re.length&&(fe=fe.withFilter(t.ExtensionName,...re)),(V.queryAllVersions||me)&&(fe=fe.withFlags(fe.flags,n.IncludeVersions)),V.source&&(fe=fe.withSource(V.source));const{extensions:pe}=await this.queryGalleryExtensions(fe,{targetPlatform:V.targetPlatform??s,includePreRelease:he,versions:ue,compatible:!!V.compatible},H);return V.source&&pe.forEach((we,Le)=>ie(we,Le,V.source)),pe}async getCompatibleExtension(T,M,F){if((0,b.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(T,M,F))return T;const V=new l().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,T.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(V,{targetPlatform:F,compatible:!0,includePreRelease:M},U.CancellationToken.None);return H[0]||null}async isExtensionCompatible(T,M,F){if(!(0,b.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,F)||!M&&T.properties.isPreReleaseVersion)return!1;let V=T.properties.engine;if(!V){const H=await this.getManifest(T,U.CancellationToken.None);if(!H)throw new Error("Manifest was not found");V=H.engines.vscode}return(0,c.isEngineValid)(V,this.productService.version,this.productService.date)}async isValidVersion(T,M,F,V,H){if(!(0,b.isTargetPlatformCompatible)(B(T),V,H)||M!=="any"&&G(T)!==(M==="prerelease"))return!1;if(F)try{const re=await this.getEngine(T);if(!(0,c.isEngineValid)(re,this.productService.version,this.productService.date))return!1}catch(re){return this.logService.error(`Error while getting the engine for the version ${T.version}.`,(0,A.getErrorMessage)(re)),!1}return!0}async query(T,M){let F=T.text||"";const V=T.pageSize??50;let H=new l().withPage(1,V);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,pe)=>(H=H.withFilter(t.Category,pe||fe),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,pe)=>(H=H.withFilter(t.Tag,pe||fe),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(t.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),H=H.withFilter(t.SearchText,F)),H=H.withSortBy(0)):T.ids?H=H.withFilter(t.ExtensionId,...T.ids):T.names?H=H.withFilter(t.ExtensionName,...T.names):H=H.withSortBy(4),typeof T.sortBy=="number"&&(H=H.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(H=H.withSortOrder(T.sortOrder)),T.source&&(H=H.withSource(T.source));const re=async(me,fe)=>{const{extensions:pe,total:we}=await this.queryGalleryExtensions(me,{targetPlatform:s,compatible:!1,includePreRelease:!!T.includePreRelease},fe);return pe.forEach((Le,Ue)=>ie(Le,(me.pageNumber-1)*me.pageSize+Ue,T.source)),{extensions:pe,total:we}},{extensions:ce,total:he}=await re(H,M),ue=async(me,fe)=>{if(fe.isCancellationRequested)throw new A.CancellationError;const{extensions:pe}=await re(H.withPage(me+1),fe);return pe};return{firstPage:ce,total:he,pageSize:H.pageSize,getPage:ue}}async queryGalleryExtensions(T,M,F){const V=T.flags;T.flags&n.IncludeLatestVersionOnly&&T.flags&n.IncludeVersions&&(T=T.withFlags(T.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(T.flags&n.IncludeLatestVersionOnly)&&!(T.flags&n.IncludeVersions)&&(T=T.withFlags(T.flags,n.IncludeLatestVersionOnly)),M.versions?.length&&(T=T.withFlags(T.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),T=T.withFlags(T.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:H,total:re,context:ce}=await this.queryRawGalleryExtensions(T,F);if(!(T.flags&n.IncludeLatestVersionOnly)){const fe=[];for(const pe of H){const we=await this.toGalleryExtensionWithCriteria(pe,M,ce);we&&fe.push(we)}return{extensions:fe,total:re}}const ue=[],me=new Map;for(let fe=0;fe<H.length;fe++){const pe=H[fe],we={id:(0,v.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Le=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Me=>(0,v.areSameExtensions)(Me,we))?.includePreRelease;if(M.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(z(pe),M.targetPlatform))continue;const Ue=await this.toGalleryExtensionWithCriteria(pe,M,ce);!Ue||Ue.properties.isPreReleaseVersion&&(!Le||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==M.targetPlatform&&Ue.hasPreReleaseVersion?me.set(pe.extensionId,fe):ue.push([fe,Ue])}if(me.size){const fe=new C.StopWatch,pe=new l().withFlags(V&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,me.size).withFilter(t.ExtensionId,...me.keys()),{extensions:we}=await this.queryGalleryExtensions(pe,M,F);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:me.size});for(const Le of we){const Ue=me.get(Le.identifier.uuid);ue.push([Ue,Le])}}return{extensions:ue.sort((fe,pe)=>fe[0]-pe[0]).map(([,fe])=>fe),total:re}}async toGalleryExtensionWithCriteria(T,M,F){const V={id:(0,v.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},H=M.versions?.find(ue=>(0,v.areSameExtensions)(ue,V))?.version,re=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ue=>(0,v.areSameExtensions)(ue,V))?.includePreRelease,ce=z(T),he=ee(T.versions,M.targetPlatform);if(M.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(ce,M.targetPlatform))return null;for(let ue=0;ue<he.length;ue++){const me=he[ue];if(!(H&&me.version!==H)){if(await this.isValidVersion(me,re?"any":"release",M.compatible,ce,M.targetPlatform))return Z(T,me,ce,F);if(H&&me.version===H)return null}}return H||M.compatible?null:Z(T,T.versions[0],ce)}async queryRawGalleryExtensions(T,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const F=await this.commonHeadersPromise,V=JSON.stringify(T.raw),H={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},re=new C.StopWatch;let ce,he,ue=0;try{if(ce=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&T.criteria.some(fe=>fe.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:V,headers:H},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:ue};const me=await(0,u.asJson)(ce);if(me){const fe=me.results[0],pe=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return ue=we&&we.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:ue,context:{[o]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(me){throw he=me,me}finally{this.telemetryService.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(V.length),duration:re.elapsed(),success:!!ce&&(0,u.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:he?(0,A.isCancellationError)(he)?"canceled":(0,A.getErrorMessage)(he).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(T,M,F,V){if(!this.isEnabled())return;const H=O.isWeb?this.api(`/itemName/${T}.${M}/version/${F}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${T}/extensions/${M}/${F}/stats?statType=${V}`),re=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:H,headers:he},U.CancellationToken.None)}catch{}}async download(T,M,F){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const V=(0,v.getGalleryExtensionTelemetryData)(T),H=new Date().getTime(),re=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...V,duration:fe}),ce=F===2?"install":F===3?"update":"",he=ce?{uri:`${T.assets.download.uri}${I.URI.parse(T.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${T.assets.download.fallbackUri}${I.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:T.assets.download,ue=T.queryContext?.[o]?{[o]:T.queryContext[o]}:void 0,me=await this.getAsset(he,ue?{headers:ue}:void 0);await this.fileService.writeFile(M,me.stream),re(new Date().getTime()-H)}async downloadSignatureArchive(T,M){if(!T.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const F=await this.getAsset(T.assets.signature);await this.fileService.writeFile(M,F.stream)}async getReadme(T,M){if(T.assets.readme){const F=await this.getAsset(T.assets.readme,{},M);return await(0,u.asTextOrError)(F)||""}return""}async getManifest(T,M){if(T.assets.manifest){const F=await this.getAsset(T.assets.manifest,{},M),V=await(0,u.asTextOrError)(F);return V?JSON.parse(V):null}return null}async getManifestFromRawExtensionVersion(T,M){const F=W(T,r.Manifest);if(!F)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},H=await this.getAsset(F,{headers:V});return await(0,u.asJson)(H)}async getCoreTranslation(T,M){const F=T.assets.coreTranslations.filter(V=>V[0]===M.toUpperCase())[0];if(F){const V=await this.getAsset(F[1]),H=await(0,u.asTextOrError)(V);return H?JSON.parse(H):null}return null}async getChangelog(T,M){if(T.assets.changelog){const F=await this.getAsset(T.assets.changelog,{},M);return await(0,u.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(T,M,F){let V=new l().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?V=V.withFilter(t.ExtensionId,T.identifier.uuid):V=V.withFilter(t.ExtensionName,T.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(V,U.CancellationToken.None);if(!H.length)return[];const re=z(H[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(re,F))return[];const ce=[];await Promise.all(H[0].versions.map(async me=>{try{await this.isValidVersion(me,M?"any":"release",!0,re,F)&&ce.push(me)}catch{}}));const he=[],ue=new Set;for(const me of ee(ce,F))ue.has(me.version)||(ue.add(me.version),he.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:G(me)}));return he}async getAsset(T,M={},F=U.CancellationToken.None){const V=await this.commonHeadersPromise,H={type:"GET"},re={...V,...M.headers||{}};M={...M,...H,headers:re};const ce=T.uri,he=T.fallbackUri,ue={...M,url:ce};try{const me=await this.requestService.request(ue,F);if(me.res.statusCode===200)return me;const fe=await(0,u.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${fe}`)}catch(me){if((0,A.isCancellationError)(me))throw me;const fe=(0,A.getErrorMessage)(me);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:fe});const pe={...M,url:he};return this.requestService.request(pe,F)}}async getEngine(T){let M=Q(T);if(!M){const F=await this.getManifestFromRawExtensionVersion(T,U.CancellationToken.None);if(!F)throw new Error("Manifest was not found");M=F.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},U.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,u.asJson)(T),F=[],V={},H=[];if(M){for(const re of M.malicious)F.push({id:re});if(M.migrateToPreRelease)for(const[re,ce]of Object.entries(M.migrateToPreRelease))(!ce.engine||(0,c.isEngineValid)(ce.engine,this.productService.version,this.productService.date))&&(V[re.toLowerCase()]={disallowInstall:!0,extension:{id:ce.id,displayName:ce.displayName,autoMigrate:{storage:!!ce.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[re,ce]of Object.entries(M.deprecated))ce&&(V[re.toLowerCase()]=(0,R.isBoolean)(ce)?{}:ce);if(M.search)for(const re of M.search)H.push(re)}return{malicious:F,deprecated:V,search:H}}};ne=ye([J(1,u.IRequestService),J(2,E.ILogService),J(3,P.IEnvironmentService),J(4,f.ITelemetryService),J(5,m.IFileService),J(6,y.IProductService),J(7,g.IConfigurationService)],ne);let K=class extends ne{constructor(T,M,F,V,H,re,ce,he){super(T,M,F,V,H,re,ce,he)}};e.ExtensionGalleryService=K,e.ExtensionGalleryService=K=ye([J(0,h.IStorageService),J(1,u.IRequestService),J(2,E.ILogService),J(3,P.IEnvironmentService),J(4,f.ITelemetryService),J(5,m.IFileService),J(6,y.IProductService),J(7,g.IConfigurationService)],K);let j=class extends ne{constructor(T,M,F,V,H,re,ce){super(void 0,T,M,F,V,H,re,ce)}};e.ExtensionGalleryServiceWithNoStorageService=j,e.ExtensionGalleryServiceWithNoStorageService=j=ye([J(0,u.IRequestService),J(1,E.ILogService),J(2,P.IEnvironmentService),J(3,f.ITelemetryService),J(4,m.IFileService),J(5,y.IProductService),J(6,g.IConfigurationService)],j)}),define(oe[81],ae([0,1,4,3,2,21,33,25,18,8,12]),function(te,e,k,U,A,O,L,R,I,g,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends A.Disposable{static{b=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(E){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(E.id)}@${E.version}`}static fromKey(E){const y=v.exec(E);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(E,y){const u=await E.getInstalled(),d=[];for(const[h,f]of b.readAllExtensionsWithKeysForSync(y)){const C=u.find(s=>(0,L.areSameExtensions)(s.identifier,{id:h}))?.manifest.version;for(const s of f)C!==s&&d.push(b.toKey({id:h,version:s}))}for(const h of d)y.remove(h,0)}static readAllExtensionsWithKeysForSync(E){const y=new Map,u=E.keys(0,1);for(const d of u){const h=b.fromKey(d);if(h){let f=y.get(h.id.toLowerCase());f||y.set(h.id.toLowerCase(),f=[]),f.push(h.version)}}return y}constructor(E,y,u){super(),this.storageService=E,this.productService=y,this.logService=u,this._onDidChangeExtensionStorageToSync=this._register(new U.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=b.readAllExtensionsWithKeysForSync(E),this._register(this.storageService.onDidChangeValue(0,void 0,this._register(new A.DisposableStore))(d=>this.onDidChangeStorageValue(d)))}onDidChangeStorageValue(E){if(this.extensionsWithKeysForSync.has(E.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const y=b.fromKey(E.key);if(y){if(this.storageService.get(E.key,0)===void 0)this.extensionsWithKeysForSync.delete(y.id.toLowerCase());else{let u=this.extensionsWithKeysForSync.get(y.id.toLowerCase());u||this.extensionsWithKeysForSync.set(y.id.toLowerCase(),u=[]),u.push(y.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(E){if((0,P.isString)(E))return E;const y=E.manifest?E.manifest.publisher:E.publisher,u=E.manifest?E.manifest.name:E.name;return(0,L.getExtensionId)(y,u)}getExtensionState(E,y){const u=this.getExtensionId(E),d=this.getExtensionStateRaw(E,y);if(d)try{return JSON.parse(d)}catch(h){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${y}): ${h}`)}}getExtensionStateRaw(E,y){const u=this.getExtensionId(E),d=this.storageService.get(u,y?0:1);return d&&d?.length>b.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${y}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(E,y,u){const d=this.getExtensionId(E);y===void 0?this.storageService.remove(d,u?0:1):this.storageService.store(d,JSON.stringify(y),u?0:1,1)}setKeysForSync(E,y){this.storageService.store(b.toKey(E),JSON.stringify(y),0,1)}getKeysForSync(E){const y=this.productService.extensionSyncedKeys?.[E.id.toLowerCase()],u=this.storageService.get(b.toKey(E),0),d=u?JSON.parse(u):void 0;return d&&y?(0,I.distinct)([...d,...y]):d||y}addToMigrationList(E,y){if(E!==y){const u=this.migrationList.filter(d=>!d.includes(E)&&!d.includes(y));u.push([E,y]),this.migrationList=u}}getSourceExtensionToMigrate(E){const y=this.migrationList.find(([,u])=>E===u);return y?y[0]:void 0}get migrationList(){const E=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(E);if(Array.isArray(y))return y}catch{}return[]}set migrationList(E){E.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(E),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=c,e.ExtensionStorageService=c=b=ye([J(0,O.IStorageService),J(1,R.IProductService),J(2,g.ILogService)],c)}),define(oe[246],ae([0,1,29,11,25,14,98,55,21,22,220]),function(te,e,k,U,A,O,L,R,I,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends P.AbstractNativeExtensionTipsService{constructor(c,m,E,y,u,d,h,f){super(c.userHome,u,m,E,y,d,h,f)}};e.ExtensionTipsService=b,e.ExtensionTipsService=b=ye([J(0,O.INativeEnvironmentService),J(1,g.ITelemetryService),J(2,k.IExtensionManagementService),J(3,I.IStorageService),J(4,R.INativeHostService),J(5,L.IExtensionRecommendationNotificationService),J(6,U.IFileService),J(7,A.IProductService)],b)}),define(oe[247],ae([0,1,105,3,22,14,2,8,16,65,25,5,6,101,20,164,36,21,12,131,19]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const C=[k.CONFIGURATION_KEY_HOST_NAME,k.CONFIGURATION_KEY_PREVENT_SLEEP],s="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends L.Disposable{constructor(a,w,p,l,S,_,N){super(),this.telemetryService=a,this.productService=w,this.environmentService=p,this.configurationService=_,this.storageService=N,this._onDidTokenFailedEmitter=new U.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new U.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new U.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=k.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=($,W)=>{W?this._logger.error($):this._logger.info($)},this._logger=this._register(l.createLogger((0,f.joinPath)(p.logsHome,`${k.LOG_ID}.log`),{id:k.LOG_ID,name:k.LOGGER_NAME})),this._startTunnelProcessDelayer=new v.Delayer(100),this._register(this._logger.onDidChangeLogLevel($=>this._logger.info("Log level changed to "+(0,R.LogLevelToString)($)))),this._register(S.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(_.onDidChangeConfiguration($=>{C.some(W=>$.affectsConfiguration(W))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=k.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(a){this._tunnelStatus=a,this._onDidChangeTunnelStatusEmitter.fire(a)}setMode(a){t(this._mode,a)||(this._mode=a,this._storeMode(a),this._onDidChangeModeEmitter.fire(this._mode),a.active?(this._logger.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this._logger.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(a){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(w){this._logger.error(w)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let a;b.isMacintosh?a=this.environmentService.appRoot:a=(0,I.dirname)((0,I.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,I.join)(a,"bin",`${this.productService.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(a){if(t(this._mode,a)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(w){this._logger.error(w)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._mode.active)return;const a=this._mode.asService;this.setMode(k.INACTIVE_TUNNEL_MODE);try{a&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(w){this._logger.error(w)}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(w){this._logger.error(w)}this.setTunnelStatus(k.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let a="",w=!1;const p=(W,q)=>{q?this._logger.error(W):a+=W,!this.environmentService.isBuilt&&W.startsWith("   Compiling")&&this.setTunnelStatus(k.TunnelStates.connecting((0,E.localize)(0,null)))},l=this.runCodeTunnelCommand("status",["status"],p);this._tunnelProcess=l;try{if(await l,this._tunnelProcess!==l)return;const W=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")));if(w=W.service_installed,this._logger.info(W.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!W.tunnel&&!this._mode.active){this.setTunnelStatus(k.TunnelStates.disconnected());return}}catch(W){this._logger.error(W),this.setTunnelStatus(k.TunnelStates.disconnected());return}finally{this._tunnelProcess===l&&(this._tunnelProcess=void 0)}const S=this._mode.active?this._mode.session:void 0;if(S&&S.token){const W=S.token;this.setTunnelStatus(k.TunnelStates.connecting((0,E.localize)(1,null,S.accountLabel,S.providerId)));const q=(G,X)=>{G=G.replaceAll(W,"*".repeat(4)),p(G,X)},Q=this.runCodeTunnelCommand("login",["user","login","--provider",S.providerId,"--access-token",W,"--log",(0,R.LogLevelToString)(this._logger.getLevel())],q);this._tunnelProcess=Q;try{if(await Q,this._tunnelProcess!==Q)return}catch(G){this._logger.error(G),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(S),this.setTunnelStatus(k.TunnelStates.disconnected(S));return}}const _=this._getTunnelName();_?this.setTunnelStatus(k.TunnelStates.connecting((0,E.localize)(2,null,_))):this.setTunnelStatus(k.TunnelStates.connecting((0,E.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,R.LogLevelToString)(this._logger.getLevel())];_?N.push("--name",_):N.push("--random-name");let $=!1;return this._mode.active&&this._mode.asService&&!w&&($=await this.installTunnelService(N)===!1),this.serverOrAttachTunnel(S,N,$)}async installTunnelService(a){let w;try{w=await this.runCodeTunnelCommand("serviceInstall",["service","install",...a])}catch(p){this._logger.error(p),w=1}if(w!==0){const p=(0,E.localize)(4,null);return this._logger.warn(p),this.setTunnelStatus(k.TunnelStates.connecting(p)),!1}return!0}async serverOrAttachTunnel(a,w,p){w.push("--parent-process-id",String(process.pid)),this._preventSleep()&&w.push("--no-sleep");let l=!1;const S=this.runCodeTunnelCommand("tunnel",w,(_,N)=>{N?this._logger.error(_):this._logger.info(_),_.includes("Connected to an existing tunnel process")&&(l=!0);const $=_.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if($){const W={link:$[1],domain:$[2],tunnelName:$[4],isAttached:l};this.setTunnelStatus(k.TunnelStates.connected(W,p))}else _.match(/error refreshing token/)&&(S.cancel(),this._onDidTokenFailedEmitter.fire(a),this.setTunnelStatus(k.TunnelStates.disconnected(a)))});this._tunnelProcess=S,S.finally(()=>{S===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=k.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(k.TunnelStates.disconnected()))})}runCodeTunnelCommand(a,w,p=this.defaultOnOutput){return(0,v.createCancelablePromise)(l=>new Promise((S,_)=>{l.isCancellationRequested&&S(-1);let N;const $=["ignore","pipe","pipe"];if(l.onCancellationRequested(()=>{N&&(this._logger.info(`${a} terminating(${N.pid})`),N.kill())}),!this.environmentService.isBuilt)p(`Building tunnel CLI from sources and run
`,!1),p(`${a} Spawning: cargo run -- tunnel ${w.join(" ")}
`,!1),N=(0,g.spawn)("cargo",["run","--","tunnel",...w],{cwd:(0,I.join)(this.environmentService.appRoot,"cli"),stdio:$});else{p(`Running tunnel CLI
`,!1);const W=this.getTunnelCommandLocation();p(`${a} Spawning: ${W} tunnel ${w.join(" ")}
`,!1),N=(0,g.spawn)(W,["tunnel",...w],{cwd:(0,y.homedir)(),stdio:$})}N.stdout.pipe(new h.StreamSplitter(`
`)).on("data",W=>{if(N){const q=W.toString();p(q,!1)}}),N.stderr.pipe(new h.StreamSplitter(`
`)).on("data",W=>{if(N){const q=W.toString();p(q,!0)}}),N.on("exit",W=>{N&&(p(`${a} exit(${N.pid}): + ${W} `,!1),N=void 0,S(W||0))}),N.on("error",W=>{N&&(p(`${a} error(${N.pid}): + ${W} `,!0),N=void 0,_())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(k.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let a=this.configurationService.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,y.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}_restoreMode(){try{const a=this.storageService.get(s,-1),w=this.storageService.getBoolean(o,-1,!1);if(a){const p=JSON.parse(a);if(p&&(0,d.isString)(p.accountLabel)&&(0,d.isString)(p.sessionId)&&(0,d.isString)(p.providerId))return{active:!0,session:p,asService:w};this._logger.error("Problems restoring session from storage, invalid format",p)}}catch(a){this._logger.error("Problems restoring session from storage",a)}return k.INACTIVE_TUNNEL_MODE}_storeMode(a){if(a.active){const w={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.storageService.store(s,JSON.stringify(w),-1,1),this.storageService.store(o,a.asService,-1,1)}else this.storageService.remove(s,-1),this.storageService.remove(o,-1)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=ye([J(0,A.ITelemetryService),J(1,P.IProductService),J(2,O.INativeEnvironmentService),J(3,R.ILoggerService),J(4,c.ISharedProcessLifecycleService),J(5,m.IConfigurationService),J(6,u.IStorageService)],n);function i(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&i(r.session,a.session):!0}),define(oe[248],ae([0,1,6,2,23,19,67,21,76,17]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class P extends R.AbstractStorageService{constructor(v,c,m,E){super(),this.initialWorkspace=v,this.initialProfiles=c,this.remoteService=m,this.environmentService=E,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new U.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new U.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const v=this._register(new I.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),c=this._register(new L.Storage(v));return this._register(c.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m))),c}createProfileStorage(v){this.profileStorageDisposables.clear(),this.profileStorageProfile=v;let c;if((0,R.isProfileUsingDefaultStorage)(v))c=this.applicationStorage;else{const m=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),v));c=this.profileStorageDisposables.add(new L.Storage(m))}return this.profileStorageDisposables.add(c.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),c}createWorkspaceStorage(v){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=v?.id;let c;if(v){const m=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),v));c=this.workspaceStorageDisposables.add(new L.Storage(m)),this.workspaceStorageDisposables.add(c.onDidChangeStorage(E=>this.emitDidChangeValue(1,E)))}return c}async doInitialize(){await k.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return this.applicationStorageProfile.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,O.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(v){if(!this.canSwitchProfile(this.profileStorageProfile,v))return;const c=this.profileStorage,m=c.items;c!==this.applicationStorage&&await c.close(),this.profileStorage=this.createProfileStorage(v),await this.profileStorage.init(),this.switchData(m,this.profileStorage,0)}async switchToWorkspace(v,c){const m=this.workspaceStorage,E=m?.items??new Map;await m?.close(),this.workspaceStorage=this.createWorkspaceStorage(v),await this.workspaceStorage.init(),this.switchData(E,this.workspaceStorage,1)}hasScope(v){return(0,g.isUserDataProfile)(v)?this.profileStorageProfile.id===v.id:this.workspaceStorageId===v.id}}e.RemoteStorageService=P}),define(oe[249],ae([0,1,3,2,17,92]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class L{constructor(g,P){this.service=g,this.getUriTransformer=P}listen(g,P){const b=this.getUriTransformer(g);switch(P){case"onDidChangeProfiles":return k.Event.map(this.service.onDidChangeProfiles,v=>({all:v.all.map(c=>(0,O.transformOutgoingURIs)({...c},b)),added:v.added.map(c=>(0,O.transformOutgoingURIs)({...c},b)),removed:v.removed.map(c=>(0,O.transformOutgoingURIs)({...c},b)),updated:v.updated.map(c=>(0,O.transformOutgoingURIs)({...c},b))}))}throw new Error(`Invalid listen ${P}`)}async call(g,P,b){const v=this.getUriTransformer(g);switch(P){case"createProfile":{const c=await this.service.createProfile(b[0],b[1],b[2]);return(0,O.transformOutgoingURIs)({...c},v)}case"updateProfile":{let c=(0,A.reviveProfile)((0,O.transformIncomingURIs)(b[0],v),this.service.profilesHome.scheme);return c=await this.service.updateProfile(c,b[1]),(0,O.transformOutgoingURIs)({...c},v)}case"removeProfile":{const c=(0,A.reviveProfile)((0,O.transformIncomingURIs)(b[0],v),this.service.profilesHome.scheme);return this.service.removeProfile(c)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=L;class R extends U.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(g,P,b){super(),this.profilesHome=P,this.channel=b,this._profiles=[],this._onDidChangeProfiles=this._register(new k.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=g.map(v=>(0,A.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const c=v.added.map(y=>(0,A.reviveProfile)(y,this.profilesHome.scheme)),m=v.removed.map(y=>(0,A.reviveProfile)(y,this.profilesHome.scheme)),E=v.updated.map(y=>(0,A.reviveProfile)(y,this.profilesHome.scheme));this._profiles=v.all.map(y=>(0,A.reviveProfile)(y,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:c,removed:m,updated:E,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(g){this.enabled=g}isEnabled(){return this.enabled}async createNamedProfile(g,P,b){const v=await this.channel.call("createNamedProfile",[g,P,b]);return(0,A.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(g,P,b,v){const c=await this.channel.call("createProfile",[g,P,b,v]);return(0,A.reviveProfile)(c,this.profilesHome.scheme)}async createTransientProfile(g){const P=await this.channel.call("createTransientProfile",[g]);return(0,A.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(g,P){await this.channel.call("setProfileForWorkspace",[g,P])}removeProfile(g){return this.channel.call("removeProfile",[g])}async updateProfile(g,P){const b=await this.channel.call("updateProfile",[g,P]);return(0,A.reviveProfile)(b,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(oe[58],ae([0,1,2,67,4,21,3,76,17]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,A.createDecorator)("IUserDataProfileStorageService");let g=class extends k.Disposable{constructor(c){super(),this.storageService=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async m=>this.getItems(m))}async updateStorageData(c,m,E){return this.withProfileScopedStorageService(c,async y=>this.writeItems(y,m,E))}async withProfileScopedStorageService(c,m){if(this.storageService.hasScope(c))return m(this.storageService);const E=await this.createStorageDatabase(c),y=new b(E);try{await y.initialize();const u=await m(y);return await y.flush(),u}finally{y.dispose(),await this.closeAndDispose(E)}}getItems(c){const m=new Map,E=y=>{for(const u of c.keys(0,y))m.set(u,{value:c.get(u,0),target:y})};return E(0),E(1),m}writeItems(c,m,E){c.storeAll(Array.from(m.entries()).map(([y,u])=>({key:y,value:u,scope:0,target:E})),!0)}async closeAndDispose(c){try{await c.close()}finally{(0,k.isDisposable)(c)&&c.dispose()}}};e.AbstractUserDataProfileStorageService=g,e.AbstractUserDataProfileStorageService=g=ye([J(0,O.IStorageService)],g);class P extends g{constructor(c,m,E,y){super(E),this.remoteService=c;const u=c.getChannel("profileStorageListener"),d=this._register(new k.MutableDisposable);this._onDidChange=this._register(new L.Emitter({onWillAddFirstListener:()=>{d.value=u.listen("onDidChange")(h=>{y.trace("profile storage changes",h),this._onDidChange.fire({targetChanges:h.targetChanges.map(f=>(0,I.reviveProfile)(f,m.profilesHome.scheme)),valueChanges:h.valueChanges.map(f=>({...f,profile:(0,I.reviveProfile)(f.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(c){const m=this.remoteService.getChannel("storage");return(0,O.isProfileUsingDefaultStorage)(c)?new R.ApplicationStorageDatabaseClient(m):new R.ProfileStorageDatabaseClient(m,c)}}e.RemoteUserDataProfileStorageService=P;class b extends O.AbstractStorageService{constructor(c){super({flushInterval:100}),this.profileStorage=this._register(new U.Storage(c))}doInitialize(){return this.profileStorage.init()}getStorage(c){return c===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(oe[250],ae([0,1,21,8,17,72,58]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends L.RemoteUserDataProfileStorageService{constructor(g,P,b,v){super(g,P,b,v)}};e.NativeUserDataProfileStorageService=R,e.NativeUserDataProfileStorageService=R=ye([J(0,O.IMainProcessService),J(1,A.IUserDataProfilesService),J(2,k.IStorageService),J(3,U.ILogService)],R)}),define(oe[39],ae([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function s(w){return!!(w&&w.ref!==void 0&&typeof w.ref=="string"&&w.ref!==""&&w.syncData!==void 0&&(w.syncData===null||o(w.syncData)))}e.isRemoteUserData=s;function o(w){return!!(w&&w.version!==void 0&&typeof w.version=="number"&&w.content!==void 0&&typeof w.content=="string"&&(Object.keys(w).length===2||Object.keys(w).length===3&&w.machineId!==void 0&&typeof w.machineId=="string"))}e.isSyncData=o;function n(w,p){return`${(0,g.uppercaseFirstLetter)(w)}${p.isDefault?"":` (${p.name})`}`}e.getSyncResourceLogLabel=n;let i=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(p,l,S,_,N,$,W,q,Q,G,X,x){super(),this.syncResource=p,this.collection=l,this.fileService=S,this.environmentService=_,this.storageService=N,this.userDataSyncStoreService=$,this.userDataSyncLocalStoreService=W,this.userDataSyncEnablementService=q,this.telemetryService=Q,this.logService=G,this.configurationService=X,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new U.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(p.syncResource,p.profile),this.extUri=x.extUri,this.syncFolder=this.extUri.joinPath(_.userDataSyncHome,...(0,f.getPathSegments)(p.profile.isDefault?void 0:p.profile.id,p.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,f.PREVIEW_DIR_NAME),this.lastSyncResource=(0,f.getLastSyncResourceUri)(p.profile.isDefault?void 0:p.profile.id,p.syncResource,_,this.extUri),this.currentMachineIdPromise=(0,y.getServiceMachineId)(_,S,N)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const p=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(p.remoteUserData,p.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const p=await this.getLastSyncUserData();(p?await this.hasRemoteChanged(p):!0)&&this._onDidChangeLocal.fire()}}setStatus(p){this._status!==p&&(this._status=p,this._onDidChangStatus.fire(p))}async sync(p,l={}){await this._sync(p,!0,this.getUserDataSyncConfiguration(),l)}async preview(p,l,S={}){return this._sync(p,!1,l,S)}async apply(p,l={}){try{this.syncHeaders={...l};const S=await this.doApply(p);return this.setStatus(S),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(p,l,S,_){try{if(this.syncHeaders={..._},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let N="idle";try{const $=await this.getLastSyncUserData(),W=await this.getLatestRemoteUserData(p,$);return N=await this.performSync(W,$,l,S),N==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(N)}}finally{this.syncHeaders={}}}async replace(p){const l=this.parseSyncData(p);if(!l)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const S=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,S),N=await this.isRemoteDataFromCurrentMachine(_),$=await this.generateSyncPreview({ref:_.ref,syncData:l},S,N,this.getUserDataSyncConfiguration(),O.CancellationToken.None),W=[];for(const q of $){const Q=await this.getAcceptResult(q,q.remoteResource,void 0,O.CancellationToken.None),{remoteChange:G}=await this.getAcceptResult(q,q.previewResource,q.remoteContent,O.CancellationToken.None);W.push([q,{...Q,remoteChange:G!==0?G:2}])}await this.applyResult(_,S,W,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(p){const l=await this.currentMachineIdPromise;return!!p.syncData?.machineId&&p.syncData.machineId===l}async getLatestRemoteUserData(p,l){if(l){const S=p?p[this.resource]:void 0;if(l.ref===S||S===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(p,l,S,_){if(p.syncData&&p.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new f.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,p.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(p,l,S,_)}catch(N){if(N instanceof f.UserDataSyncError)switch(N.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(p,l,S,_);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),p=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(p,l,S,_)}throw N}}async doSync(p,l,S,_){try{const N=await this.isRemoteDataFromCurrentMachine(p),$=!N&&l===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,W=S&&!$;this.syncPreviewPromise||(this.syncPreviewPromise=(0,U.createCancelablePromise)(Q=>this.doGenerateSyncResourcePreview(p,l,N,W,_,Q)));let q=await this.syncPreviewPromise;if(S&&$){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Q of q.resourcePreviews)q=await this.accept(Q.remoteResource)||q}return this.updateConflicts(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Q})=>Q==="conflict")?"hasConflicts":S?await this.doApply(!1):"syncing"}catch(N){throw this.syncPreviewPromise=null,N}}async merge(p){return await this.updateSyncResourcePreview(p,async l=>{const S=await this.getMergeResult(l,O.CancellationToken.None);await this.fileService.writeFile(l.previewResource,A.VSBuffer.fromString(S?.content||""));const _=S&&!S.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,O.CancellationToken.None):void 0;return l.acceptResult=_,l.mergeState=S.hasConflicts?"conflict":_?"accepted":"preview",l.localChange=_?_.localChange:S.localChange,l.remoteChange=_?_.remoteChange:S.remoteChange,l}),this.syncPreviewPromise}async accept(p,l){return await this.updateSyncResourcePreview(p,async S=>{const _=await this.getAcceptResult(S,p,l,O.CancellationToken.None);return S.acceptResult=_,S.mergeState="accepted",S.localChange=_.localChange,S.remoteChange=_.remoteChange,S}),this.syncPreviewPromise}async discard(p){return await this.updateSyncResourcePreview(p,async l=>{const S=await this.getMergeResult(l,O.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,A.VSBuffer.fromString(S.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=S.localChange,l.remoteChange=S.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(p,l){if(!this.syncPreviewPromise)return;let S=await this.syncPreviewPromise;const _=S.resourcePreviews.findIndex(({localResource:N,remoteResource:$,previewResource:W})=>this.extUri.isEqual(N,p)||this.extUri.isEqual($,p)||this.extUri.isEqual(W,p));_!==-1&&(this.syncPreviewPromise=(0,U.createCancelablePromise)(async N=>{const $=[...S.resourcePreviews];return $[_]=await l($[_]),{...S,resourcePreviews:$}}),S=await this.syncPreviewPromise,this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(p){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(S=>[S,S.acceptResult]),p),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(p){const l=p.filter(({mergeState:S})=>S==="conflict");(0,k.equals)(this._conflicts,l,(S,_)=>this.extUri.isEqual(S.previewResource,_.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const p=await this.getLastSyncUserData();return!!p&&p.syncData!==null}async resolvePreviewContent(p){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const S of l.resourcePreviews){if(this.extUri.isEqual(S.acceptedResource,p))return S.acceptResult?S.acceptResult.content:null;if(this.extUri.isEqual(S.remoteResource,p))return S.remoteContent;if(this.extUri.isEqual(S.localResource,p))return S.localContent;if(this.extUri.isEqual(S.baseResource,p))return S.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(p){(0,m.toFileOperationResult)(p)!==1&&this.logService.error(p)}}async doGenerateSyncResourcePreview(p,l,S,_,N,$){const W=await this.generateSyncPreview(p,l,S,N,$),q=[];for(const Q of W){const G=Q.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(Q.localChange===0&&Q.remoteChange===0)q.push({...Q,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=_?await this.getMergeResult(Q,$):void 0;if($.isCancellationRequested)break;await this.fileService.writeFile(Q.previewResource,A.VSBuffer.fromString(X?.content||""));const x=X&&!X.hasConflicts?await this.getAcceptResult(Q,Q.previewResource,void 0,$):void 0;q.push({...Q,acceptResult:x,mergeState:X?.hasConflicts?"conflict":x?"accepted":"preview",localChange:x?x.localChange:X?X.localChange:Q.localChange,remoteChange:x?x.remoteChange:X?X.remoteChange:Q.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:p,lastSyncUserData:l,resourcePreviews:q,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let p=this.getStoredLastSyncUserDataStateContent();if(p||(p=await this.migrateLastSyncUserData()),!p)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const l=JSON.parse(p),S=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!l.version&&!!S&&l.version!==S,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let _,N=1;for(;_===void 0&&N++<6;)try{const $=await this.readLastSyncStoredRemoteUserData();$&&($.ref===l.ref?_=$.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch($){if($ instanceof m.FileOperationError&&$.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if($ instanceof f.UserDataSyncError)throw $;this.logService.error($,N)}}if(_===void 0)try{const $=await this.userDataSyncStoreService.resolveResourceContent(this.resource,l.ref,this.collection,this.syncHeaders);_=$===null?null:this.parseSyncData($),await this.writeLastSyncStoredRemoteUserData({ref:l.ref,syncData:_})}catch($){if($ instanceof f.UserDataSyncError&&$.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw $}return _===void 0?null:{...l,syncData:_}}async updateLastSyncUserData(p,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const S=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),_={ref:p.ref,version:S,...l};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(_),-1,1),await this.writeLastSyncStoredRemoteUserData(p)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const p=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const l=p?JSON.parse(p):void 0;if(s(l))return l}catch(l){this.logService.error(l)}}async writeLastSyncStoredRemoteUserData(p){await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(p)))}async migrateLastSyncUserData(){try{const p=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(p.value.toString());await this.fileService.del(this.lastSyncResource),l.ref&&l.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...l,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:l.ref,syncData:l.content===null?null:JSON.parse(l.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,l)}catch(p){p instanceof m.FileOperationError&&p.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(p)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(p){const{ref:l,content:S}=await this.getUserData(p);let _=null;return S!==null&&(_=this.parseSyncData(S)),{ref:l,syncData:_}}parseSyncData(p){try{const l=JSON.parse(p);if(o(l))return l}catch(l){this.logService.error(l)}throw new f.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(p){const l=p?{ref:p.ref,content:p.syncData?JSON.stringify(p.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,l,this.collection,this.syncHeaders)}async updateRemoteUserData(p,l){const S=await this.currentMachineIdPromise,_={version:this.version,machineId:S,content:p};try{return l=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(_),l,this.collection,this.syncHeaders),{ref:l,syncData:_}}catch(N){throw N instanceof f.UserDataSyncError&&N.code==="TooLarge"&&(N=new f.UserDataSyncError(N.message,N.code,this.resource)),N}}async backupLocal(p){const l={version:this.version,content:p};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(l),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=i,e.AbstractSynchroniser=i=ye([J(2,m.IFileService),J(3,c.IEnvironmentService),J(4,u.IStorageService),J(5,f.IUserDataSyncStoreService),J(6,f.IUserDataSyncLocalStoreService),J(7,f.IUserDataSyncEnablementService),J(8,d.ITelemetryService),J(9,f.IUserDataSyncLogService),J(10,v.IConfigurationService),J(11,h.IUriIdentityService)],i);let t=class extends i{constructor(p,l,S,_,N,$,W,q,Q,G,X,x,Y){super(l,S,_,N,$,W,q,Q,G,X,x,Y),this.file=p,this._register(this.fileService.watch(this.extUri.dirname(p))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(p,l,S){try{l?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(p),S?void 0:l):await this.fileService.createFile(this.file,A.VSBuffer.fromString(p),{overwrite:S})}catch(_){throw _ instanceof m.FileOperationError&&_.fileOperationResult===1||_ instanceof m.FileOperationError&&_.fileOperationResult===3?new f.UserDataSyncError(_.message,"LocalPreconditionFailed"):_}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(p){if(!(p instanceof m.FileOperationError&&p.fileOperationResult===1))throw p}}onFileChanges(p){p.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=t,e.AbstractFileSynchroniser=t=ye([J(3,m.IFileService),J(4,c.IEnvironmentService),J(5,u.IStorageService),J(6,f.IUserDataSyncStoreService),J(7,f.IUserDataSyncLocalStoreService),J(8,f.IUserDataSyncEnablementService),J(9,d.ITelemetryService),J(10,f.IUserDataSyncLogService),J(11,v.IConfigurationService),J(12,h.IUriIdentityService)],t);let r=class extends t{constructor(p,l,S,_,N,$,W,q,Q,G,X,x,Y,B){super(p,l,S,_,N,$,W,q,Q,G,X,Y,B),this.userDataSyncUtilService=x,this._formattingOptions=void 0}hasErrors(p,l){const S=[],_=(0,R.parse)(p,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,P.isUndefined)(_)&&l!==Array.isArray(_)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=ye([J(3,m.IFileService),J(4,c.IEnvironmentService),J(5,u.IStorageService),J(6,f.IUserDataSyncStoreService),J(7,f.IUserDataSyncLocalStoreService),J(8,f.IUserDataSyncEnablementService),J(9,d.ITelemetryService),J(10,f.IUserDataSyncLogService),J(11,f.IUserDataSyncUtilService),J(12,v.IConfigurationService),J(13,h.IUriIdentityService)],r);let a=class{constructor(p,l,S,_,N,$,W){this.resource=p,this.userDataProfilesService=l,this.environmentService=S,this.logService=_,this.fileService=N,this.storageService=$,this.extUri=W.extUri,this.lastSyncResource=(0,f.getLastSyncResourceUri)(void 0,this.resource,S,this.extUri)}async initialize({ref:p,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const S=this.parseSyncData(l);if(S)try{await this.doInitialize({ref:p,syncData:S})}catch(_){this.logService.error(_)}}parseSyncData(p){try{const l=JSON.parse(p);if(o(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(p,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const S={ref:p.ref,version:void 0,...l};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),-1,1),await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(p)))}};e.AbstractInitializer=a,e.AbstractInitializer=a=ye([J(1,C.IUserDataProfilesService),J(2,c.IEnvironmentService),J(3,E.ILogService),J(4,m.IFileService),J(5,u.IStorageService),J(6,h.IUriIdentityService)],a)}),define(oe[114],ae([0,1,6,26,7,3,41,2,27,20,14,113,29,33,81,44,11,4,71,8,21,22,28,17,39,231,111,24,58]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C,s,o,n,i,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function w($,W){const q=JSON.parse($.content);if($.version===1||$.version===2){const Q=(await W.getInstalled(0)).filter(G=>G.isBuiltin);for(const G of q)$.version===1&&(G.enabled===!1&&(G.disabled=!0),delete G.enabled),$.version===2&&Q.every(X=>!(0,c.areSameExtensions)(X.identifier,G.identifier))&&(G.installed=!0)}return q}function p($){return JSON.parse($.content)}e.parseExtensions=p;function l($,W){return $.sort((q,Q)=>!q.identifier.uuid&&Q.identifier.uuid?-1:q.identifier.uuid&&!Q.identifier.uuid?1:(0,I.compare)(q.identifier.id,Q.identifier.id)),W?(0,L.toFormattedString)($,{}):JSON.stringify($)}e.stringify=l;let S=class extends n.AbstractSynchroniser{constructor(W,q,Q,G,X,x,Y,B,z,ee,ie,Z,ne,K,j,D,T){super({syncResource:"extensions",profile:W},q,G,Q,X,x,Y,Z,ne,ee,ie,j),this.extensionManagementService=B,this.ignoredExtensionsManagementService=z,this.instantiationService=T,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(_),this._register(O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,M=>M.some(({local:F})=>!!F)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,M=>!M.error),O.Event.filter(D.onDidChange,M=>M.valueChanges.some(({profile:F,changes:V})=>this.syncResource.profile.id===F.id&&V.some(H=>H.key===v.DISABLED_EXTENSIONS_STORAGE_PATH))),K.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(W,q){const Q=W.syncData?await w(W.syncData,this.extensionManagementService):null,G=q?.skippedExtensions??[],X=q?.builtinExtensions??null,x=q?.syncData?await w(q.syncData,this.extensionManagementService):null,{localExtensions:Y,ignoredExtensions:B}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);Q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:ee}=(0,i.merge)(Y,Q,x,G,B,X),ie={local:z,remote:ee,content:this.getPreviewContent(Y,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:ee!==null?2:0},Z=this.stringify(Y,!1);return[{skippedExtensions:G,builtinExtensions:X,baseResource:this.baseResource,baseContent:x?this.stringify(x,!1):Z,localResource:this.localResource,localContent:Z,localExtensions:Y,remoteResource:this.remoteResource,remoteExtensions:Q,remoteContent:Q?this.stringify(Q,!1):null,previewResource:this.previewResource,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(W){const q=W.syncData?await w(W.syncData,this.extensionManagementService):null,{localExtensions:Q,ignoredExtensions:G}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,i.merge)(Q,q,q,W.skippedExtensions||[],G,W.builtinExtensions||[]);return X!==null}getPreviewContent(W,q,Q,G){const X=[...q,...Q],x=new Set,Y=B=>{x.add(B.id.toLowerCase()),B.uuid&&x.add(B.uuid)};X.forEach(({identifier:B})=>Y(B)),G.forEach(Y);for(const B of W)x.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&x.has(B.identifier.uuid)||X.push(B);return this.stringify(X,!1)}async getMergeResult(W,q){return{...W.previewResult,hasConflicts:!1}}async getAcceptResult(W,q,Q,G){if(this.extUri.isEqual(q,this.localResource))return this.acceptLocal(W);if(this.extUri.isEqual(q,this.remoteResource))return this.acceptRemote(W);if(this.extUri.isEqual(q,this.previewResource))return W.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async acceptLocal(W){const q=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(q),G=(0,i.merge)(W.localExtensions,null,null,W.skippedExtensions,Q,W.builtinExtensions),{local:X,remote:x}=G;return{content:W.localContent,local:X,remote:x,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:x!==null?2:0}}async acceptRemote(W){const q=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(q),G=W.remoteContent?JSON.parse(W.remoteContent):null;if(G!==null){const X=(0,i.merge)(W.localExtensions,G,W.localExtensions,[],Q,W.builtinExtensions),{local:x,remote:Y}=X;return{content:W.remoteContent,local:x,remote:Y,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:W.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(W,q,Q,G){let{skippedExtensions:X,builtinExtensions:x,localExtensions:Y}=Q[0][0];const{local:B,remote:z,localChange:ee,remoteChange:ie}=Q[0][1];if(ee===0&&ie===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),ee!==0&&(await this.backupLocal(JSON.stringify(Y)),X=await this.localExtensionsProvider.updateLocalExtensions(B.added,B.removed,B.updated,X,this.syncResource.profile)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const Z=JSON.stringify(z.all);W=await this.updateRemoteUserData(Z,G?null:W.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(ne=>ne.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(ne=>ne.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(ne=>ne.identifier.id))}.`:""}`)}q?.ref!==W.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),x=this.computeBuiltinExtensions(Y,x),await this.updateLastSyncUserData(W,{skippedExtensions:X,builtinExtensions:x}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(Z=>Z.identifier.id))}.`:""}`))}computeBuiltinExtensions(W,q){const Q=new Set,G=[];for(const X of W)Q.add(X.identifier.id.toLowerCase()),X.installed||G.push(X.identifier);if(q)for(const X of q)Q.has(X.id.toLowerCase())||G.push(X);return G}async resolveContent(W){if(this.extUri.isEqual(this.remoteResource,W)||this.extUri.isEqual(this.baseResource,W)||this.extUri.isEqual(this.localResource,W)||this.extUri.isEqual(this.acceptedResource,W)){const q=await this.resolvePreviewContent(W);return q&&this.stringify(JSON.parse(q),!0)}return null}stringify(W,q){return l(W,q)}async hasLocalData(){try{const{localExtensions:W}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(W.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=S,e.ExtensionsSynchroniser=S=ye([J(2,P.IEnvironmentService),J(3,y.IFileService),J(4,f.IStorageService),J(5,r.IUserDataSyncStoreService),J(6,r.IUserDataSyncLocalStoreService),J(7,v.IExtensionManagementService),J(8,t.IIgnoredExtensionsManagementService),J(9,r.IUserDataSyncLogService),J(10,g.IConfigurationService),J(11,r.IUserDataSyncEnablementService),J(12,C.ITelemetryService),J(13,m.IExtensionStorageService),J(14,s.IUriIdentityService),J(15,a.IUserDataProfileStorageService),J(16,u.IInstantiationService)],S);let _=class{constructor(W,q,Q,G,X,x){this.extensionManagementService=W,this.userDataProfileStorageService=q,this.extensionGalleryService=Q,this.ignoredExtensionsManagementService=G,this.instantiationService=X,this.logService=x}async getLocalExtensions(W){const q=await this.extensionManagementService.getInstalled(void 0,W.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(q);return{localExtensions:await this.withProfileScopedServices(W,async(X,x)=>{const Y=X.getDisabledExtensions();return q.map(B=>{const{identifier:z,isBuiltin:ee,manifest:ie,preRelease:Z,pinned:ne,isApplicationScoped:K}=B,j={identifier:z,preRelease:Z,version:ie.version,pinned:!!ne};K&&!(0,E.isApplicationScopedExtension)(ie)&&(j.isApplicationScoped=K),Y.some(D=>(0,c.areSameExtensions)(D,z))&&(j.disabled=!0),ee||(j.installed=!0);try{const D=x.getKeysForSync({id:z.id,version:ie.version});if(D){const T=x.getExtensionState(B,!0)||{};j.state=Object.keys(T).reduce((M,F)=>(D.includes(F)&&(M[F]=T[F]),M),{})}}catch(D){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",W)}: Error while parsing extension state`,(0,A.getErrorMessage)(D))}return j})}),ignoredExtensions:Q}}async updateLocalExtensions(W,q,Q,G,X){const x=(0,n.getSyncResourceLogLabel)("extensions",X),Y=[],B=new Map,z=[],ee=[],ie=await this.extensionManagementService.getInstalled(void 0,X.extensionsResource);if((W.length||Q.length)&&await this.withProfileScopedServices(X,async(K,j)=>{await k.Promises.settled([...W,...Q].map(async D=>{const T=ie.find(V=>(0,c.areSameExtensions)(V.identifier,D.identifier));if(T&&T.isBuiltin){D.state&&T.manifest.version===D.version&&this.updateExtensionState(D.state,T,T.manifest.version,j),K.getDisabledExtensions().some(H=>(0,c.areSameExtensions)(H,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${x}: Disabling extension...`,D.identifier.id),await K.disableExtension(D.identifier),this.logService.info(`${x}: Disabled extension`,D.identifier.id)):(this.logService.trace(`${x}: Enabling extension...`,D.identifier.id),await K.enableExtension(D.identifier),this.logService.info(`${x}: Enabled extension`,D.identifier.id))),z.push(D.identifier);return}const M=D.pinned?D.version:void 0,F=(await this.extensionGalleryService.getExtensions([{...D.identifier,version:M,preRelease:M?void 0:D.preRelease}],U.CancellationToken.None))[0];if(D.state&&(T?T.manifest.version===D.version:F)&&this.updateExtensionState(D.state,T||F,T?.manifest.version,j),F)try{K.getDisabledExtensions().some(H=>(0,c.areSameExtensions)(H,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${x}: Disabling extension...`,D.identifier.id,F.version),await K.disableExtension(F.identifier),this.logService.info(`${x}: Disabled extension`,D.identifier.id,F.version)):(this.logService.trace(`${x}: Enabling extension...`,D.identifier.id,F.version),await K.enableExtension(F.identifier),this.logService.info(`${x}: Enabled extension`,D.identifier.id,F.version))),(!T||T.preRelease!==D.preRelease||T.pinned!==D.pinned||M&&T.manifest.version!==M)&&(await this.extensionManagementService.canInstall(F)?(Y.push({extension:F,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:D.pinned&&!!D.version,installPreReleaseVersion:D.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:D.isApplicationScoped,context:{[v.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[v.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),B.set(F.identifier.id.toLowerCase(),D)):(this.logService.info(`${x}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),ee.push(D)))}catch(V){ee.push(D),this.logService.error(V),this.logService.info(`${x}: Skipped synchronizing extension`,F.displayName||F.identifier.id)}else ee.push(D),this.logService.info(`${x}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}))}),q.length){const K=ie.filter(({identifier:j,isBuiltin:D})=>!D&&q.some(T=>(0,c.areSameExtensions)(j,T)));await k.Promises.settled(K.map(async j=>{this.logService.trace(`${x}: Uninstalling local extension...`,j.identifier.id),await this.extensionManagementService.uninstall(j,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.logService.info(`${x}: Uninstalled local extension.`,j.identifier.id),z.push(j.identifier)}))}const Z=await this.extensionManagementService.installGalleryExtensions(Y);for(const{identifier:K,local:j,error:D,source:T}of Z){const M=T;if(j)this.logService.info(`${x}: Installed extension.`,K.id,M.version),z.push(K);else{const F=B.get(K.id.toLowerCase());F&&(ee.push(F),this.logService.info(`${x}: Skipped synchronizing extension`,M.displayName||M.identifier.id)),D instanceof v.ExtensionManagementError&&[v.ExtensionManagementErrorCode.Incompatible,v.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(D.code)?this.logService.info(`${x}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):D&&this.logService.error(D)}}const ne=[];for(const K of G)z.some(j=>(0,c.areSameExtensions)(j,K.identifier))||ne.push(K);for(const K of ee)ne.some(j=>(0,c.areSameExtensions)(j.identifier,K.identifier))||ne.push(K);return ne}updateExtensionState(W,q,Q,G){const X=G.getExtensionState(q,!0)||{},x=Q?G.getKeysForSync({id:q.identifier.id,version:Q}):void 0;x?x.forEach(Y=>{X[Y]=W[Y]}):Object.keys(W).forEach(Y=>X[Y]=W[Y]),G.setExtensionState(q,X,!0)}async withProfileScopedServices(W,q){return this.userDataProfileStorageService.withProfileScopedStorageService(W,async Q=>{const G=new R.DisposableStore,X=this.instantiationService.createChild(new d.ServiceCollection([f.IStorageService,Q])),x=G.add(X.createInstance(b.GlobalExtensionEnablementService)),Y=G.add(X.createInstance(m.ExtensionStorageService));try{return await q(x,Y)}finally{G.dispose()}})}};e.LocalExtensionsProvider=_,e.LocalExtensionsProvider=_=ye([J(0,v.IExtensionManagementService),J(1,a.IUserDataProfileStorageService),J(2,v.IExtensionGalleryService),J(3,t.IIgnoredExtensionsManagementService),J(4,u.IInstantiationService),J(5,r.IUserDataSyncLogService)],_);let N=class extends n.AbstractInitializer{constructor(W,q,Q,G,X,x,Y,B){super("extensions",G,X,x,Q,Y,B),this.extensionManagementService=W,this.ignoredExtensionsManagementService=q}async parseExtensions(W){return W.syncData?await w(W.syncData,this.extensionManagementService):null}generatePreview(W,q){const Q=[],G=[],X=[];for(const x of W){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(x.identifier.id))continue;const Y=q.find(B=>(0,c.areSameExtensions)(B.identifier,x.identifier));Y?(Q.push(Y),x.disabled&&X.push(x.identifier)):x.installed&&(G.push({...x.identifier,preRelease:!!x.preRelease}),x.disabled&&X.push(x.identifier))}return{installedExtensions:Q,newExtensions:G,disabledExtensions:X,remoteExtensions:W}}};e.AbstractExtensionsInitializer=N,e.AbstractExtensionsInitializer=N=ye([J(0,v.IExtensionManagementService),J(1,t.IIgnoredExtensionsManagementService),J(2,y.IFileService),J(3,o.IUserDataProfilesService),J(4,P.IEnvironmentService),J(5,h.ILogService),J(6,f.IStorageService),J(7,s.IUriIdentityService)],N)}),define(oe[115],ae([0,1,15,7,3,35,41,5,32,20,14,11,8,43,21,22,28,39,78,235,24,17,58,4]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const n="globalState.argv.",i=["locale"];function t(S,_){const N=S.storage?Object.keys(S.storage).sort():[],$={};return N.forEach(W=>$[W]=S.storage[W]),S.storage=$,_?(0,L.toFormattedString)(S,{}):JSON.stringify(S)}e.stringify=t;const r=1;let a=class extends u.AbstractSynchroniser{constructor(_,N,$,W,q,Q,G,X,x,Y,B,z,ee,ie){super({syncResource:"globalState",profile:_},N,W,X,z,q,Q,x,Y,G,B,ee),this.userDataProfileStorageService=$,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ie.createInstance(w),this._register(W.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(W.onDidFilesChange,Z=>Z.contains(this.environmentService.argvResource)),A.Event.filter($.onDidChange,Z=>!!(Z.targetChanges.some(ne=>this.syncResource.profile.id===ne.id)||Z.valueChanges.some(({profile:ne,changes:K})=>this.syncResource.profile.id===ne.id&&K.some(j=>j.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(_,N,$){const W=_.syncData?JSON.parse(_.syncData.content):null;N=N===null&&$?_:N;const q=N&&N.syncData?JSON.parse(N.syncData.content):null,Q=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);W?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.getStorageKeys(q),{local:X,remote:x}=(0,h.merge)(Q.storage,W?W.storage:null,q?q.storage:null,G,this.logService),Y={content:null,local:X,remote:x,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:x.all!==null?2:0},B=t(Q,!1);return[{baseResource:this.baseResource,baseContent:q?t(q,!1):B,localResource:this.localResource,localContent:B,localUserData:Q,remoteResource:this.remoteResource,remoteContent:W?t(W,!1):null,previewResource:this.previewResource,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.acceptedResource,storageKeys:G}]}async hasRemoteChanged(_){const N=_.syncData?JSON.parse(_.syncData.content):null;if(N===null)return!0;const $=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),W=await this.getStorageKeys(N),{remote:q}=(0,h.merge)($.storage,N.storage,N.storage,W,this.logService);return q.all!==null}async getMergeResult(_,N){return{..._.previewResult,hasConflicts:!1}}async getAcceptResult(_,N,$,W){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(_);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(_);if(this.extUri.isEqual(N,this.previewResource))return _.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(_){return{content:_.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(_.localUserData.storage),removed:[],updated:[],all:_.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(_){if(_.remoteContent!==null){const N=JSON.parse(_.remoteContent),{local:$,remote:W}=(0,h.merge)(_.localUserData.storage,N.storage,null,_.storageKeys,this.logService);return{content:_.remoteContent,local:$,remote:W,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:_.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(_,N,$,W){const{localUserData:q}=$[0][0],{local:Q,remote:G,localChange:X,remoteChange:x}=$[0][1];if(X===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),X!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(q)),await this.localGlobalStateProvider.writeLocalGlobalState(Q,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),x!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const Y=JSON.stringify({storage:G.all});_=await this.updateRemoteUserData(Y,W?null:_.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}N?.ref!==_.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(_),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(_){if(this.extUri.isEqual(this.remoteResource,_)||this.extUri.isEqual(this.baseResource,_)||this.extUri.isEqual(this.localResource,_)||this.extUri.isEqual(this.acceptedResource,_)){const N=await this.resolvePreviewContent(_);return N&&t(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:_}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(_).length>1||_[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(_){const N=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),$=[],W=[];for(const[G,X]of N)X.target===0?$.push(G):X.target===1&&W.push(G);const q=[...$,...W],Q=_?.storage?Object.keys(_.storage).filter(G=>!G.startsWith(n)&&!q.includes(G)&&N.get(G)!==void 0):[];if(!R.isWeb){const G=[...f.ALL_SYNC_RESOURCES.map(X=>(0,f.getEnablementKey)(X)),f.SYNC_SERVICE_URL_TYPE];Q.push(...G),W.push(...G)}return{user:$,machine:W,unregistered:Q}}};e.GlobalStateSynchroniser=a,e.GlobalStateSynchroniser=a=ye([J(2,s.IUserDataProfileStorageService),J(3,b.IFileService),J(4,f.IUserDataSyncStoreService),J(5,f.IUserDataSyncLocalStoreService),J(6,f.IUserDataSyncLogService),J(7,P.IEnvironmentService),J(8,f.IUserDataSyncEnablementService),J(9,E.ITelemetryService),J(10,g.IConfigurationService),J(11,m.IStorageService),J(12,y.IUriIdentityService),J(13,o.IInstantiationService)],a);let w=class{constructor(_,N,$,W){this.fileService=_,this.environmentService=N,this.userDataProfileStorageService=$,this.logService=W}async getLocalGlobalState(_){const N={};if(_.isDefault){const W=await this.getLocalArgvContent(),q=(0,O.parse)(W);for(const Q of i)q[Q]!==void 0&&(N[`${n}${Q}`]={version:1,value:q[Q]})}const $=await this.userDataProfileStorageService.readStorageData(_);for(const[W,q]of $)q.value&&q.target===0&&(N[W]={version:1,value:q.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const _=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),_.value.toString()}catch(_){this.logService.debug((0,U.getErrorMessage)(_))}return"{}"}async writeLocalGlobalState({added:_,removed:N,updated:$},W){const q=(0,u.getSyncResourceLogLabel)("globalState",W),Q={},G=new Map,X=await this.userDataProfileStorageService.readStorageData(W),x=(Y,B)=>{for(const z of Y){if(z.startsWith(n)){Q[z.substring(n.length)]=B?B[z].value:void 0;continue}if(B){const ee=B[z];ee.value!==X.get(z)?.value&&G.set(z,ee.value)}else X.get(z)!==void 0&&G.set(z,void 0)}};if(x(Object.keys(_),_),x(Object.keys($),$),x(N),Object.keys(Q).length){this.logService.trace(`${q}: Updating locale...`);const Y=await this.getLocalArgvContent();let B=Y;for(const z of Object.keys(Q))B=(0,d.edit)(B,[z],Q[z],{});Y!==B&&(this.logService.trace(`${q}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(B)),this.logService.info(`${q}: Updated locale.`)),this.logService.info(`${q}: Updated locale`)}G.size&&(this.logService.trace(`${q}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(W,G,0),this.logService.info(`${q}: Updated global state`,[...G.keys()]))}};e.LocalGlobalStateProvider=w,e.LocalGlobalStateProvider=w=ye([J(0,b.IFileService),J(1,P.IEnvironmentService),J(2,s.IUserDataProfileStorageService),J(3,f.IUserDataSyncLogService)],w);let p=class extends u.AbstractInitializer{constructor(_,N,$,W,q,Q){super("globalState",$,W,q,N,_,Q)}async doInitialize(_){const N=_.syncData?JSON.parse(_.syncData.content):null;if(!N){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const $={},W={};for(const q of Object.keys(N.storage))q.startsWith(n)?$[q.substring(n.length)]=N.storage[q].value:this.storageService.get(q,0)===void 0&&(W[q]=N.storage[q].value);if(Object.keys($).length){let q="{}";try{q=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const Q of Object.keys($))q=(0,d.edit)(q,[Q],$[Q],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(q))}if(Object.keys(W).length){const q=[];for(const Q of Object.keys(W))q.push({key:Q,value:W[Q],scope:0,target:0});this.storageService.storeAll(q,!0)}}};e.GlobalStateInitializer=p,e.GlobalStateInitializer=p=ye([J(0,m.IStorageService),J(1,b.IFileService),J(2,C.IUserDataProfilesService),J(3,P.IEnvironmentService),J(4,f.IUserDataSyncLogService),J(5,y.IUriIdentityService)],p);let l=class{constructor(_,N,$,W,q){this.userDataSyncStoreClient=_,this.storageService=N,this.environmentService=$,this.fileService=W,this.logService=q}getSyncStoreType(_){return this.parseGlobalState(_)?.storage[f.SYNC_SERVICE_URL_TYPE]?.value}async sync(_){const N=(0,f.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(_,N)}catch($){if($ instanceof f.UserDataSyncError)switch($.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(_,N)}throw $}}async doSync(_,N){const $=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,N),W=this.parseGlobalState($)||{storage:{}};W.storage[f.SYNC_SERVICE_URL_TYPE]={value:_,version:r};const q=await(0,c.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),Q={version:r,machineId:q,content:t(W,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(Q),$.ref,void 0,N)}parseGlobalState({content:_}){if(!_)return null;const N=JSON.parse(_);if((0,u.isSyncData)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=l,e.UserDataSyncStoreTypeSynchronizer=l=ye([J(1,m.IStorageService),J(2,P.IEnvironmentService),J(3,b.IFileService),J(4,v.ILogService)],l)}),define(oe[116],ae([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,232,24]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function h(s,o,n){try{const i=JSON.parse(s);if(!o)return(0,R.isUndefined)(i.all)?null:i.all;switch(L.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.getKeybindingsContentFromSyncContent=h;let f=class extends y.AbstractJsonFileSynchroniser{constructor(o,n,i,t,r,a,w,p,l,S,_,N,$){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,p,l,S,i,t,w,N,r,_,a,$),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.filter(a.onDidChangeConfiguration,W=>W.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,n,i,t){const r=o.syncData?h(o.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&i?o:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,w=await this.getLocalFileContent(),p=await this.getFormattingOptions();let l=null,S=!1,_=!1,N=!1;if(r){let q=w?w.value.toString():"[]";if(q=q||"[]",this.hasErrors(q,!0))throw new d.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const Q=await(0,u.merge)(q,r,a,p,this.userDataSyncUtilService);Q.hasChanges&&(l=Q.mergeContent,N=Q.hasConflicts,S=N||Q.mergeContent!==q,_=N||Q.mergeContent!==r)}}else w&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=w.value.toString(),_=!0);const $={content:N?a:l,localChange:S?w?2:1:0,remoteChange:_?2:0,hasConflicts:N},W=w?w.value.toString():null;return[{fileContent:w,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:W,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const n=this.getKeybindingsContentFromLastSyncUserData(o);if(n===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",r=await this.getFormattingOptions(),a=await(0,u.merge)(t||"[]",n,n,r,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(o,n){return o.previewResult}async getAcceptResult(o,n,i,t){if(this.extUri.isEqual(n,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(o,n,i,t){const{fileContent:r}=i[0][0];let{content:a,localChange:w,remoteChange:p}=i[0][1];if(w===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new d.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(w!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),p!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const l=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(l,t?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const n=(0,O.parse)(o.value.toString());if((0,k.isNonEmptyArray)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:h(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=o,L.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=f,e.KeybindingsSynchroniser=f=ye([J(2,d.IUserDataSyncStoreService),J(3,d.IUserDataSyncLocalStoreService),J(4,d.IUserDataSyncLogService),J(5,g.IConfigurationService),J(6,d.IUserDataSyncEnablementService),J(7,b.IFileService),J(8,P.IEnvironmentService),J(9,v.IStorageService),J(10,d.IUserDataSyncUtilService),J(11,c.ITelemetryService),J(12,m.IUriIdentityService)],f);let C=class extends y.AbstractInitializer{constructor(o,n,i,t,r,a){super("keybindings",n,i,t,o,r,a)}async doInitialize(o){const n=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,U.VSBuffer.fromString(n)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,O.parse)(o.value.toString());return!(0,k.isNonEmptyArray)(n)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return h(o,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=C,e.KeybindingsInitializer=C=ye([J(0,b.IFileService),J(1,E.IUserDataProfilesService),J(2,P.IEnvironmentService),J(3,d.IUserDataSyncLogService),J(4,v.IStorageService),J(5,m.IUriIdentityService)],C)}),define(oe[117],ae([0,1,15,3,171,20,74,14,29,11,21,22,28,17,39,236,24]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(C){return C&&C.settings&&typeof C.settings=="string"&&Object.keys(C).length===1}function d(C){const s=JSON.parse(C);return u(s)?s:{settings:C}}e.parseSettingsSyncContent=d;let h=class extends m.AbstractJsonFileSynchroniser{constructor(s,o,n,i,t,r,a,w,p,l,S,_,N,$){super(s.settingsResource,{syncResource:"settings",profile:s},o,n,i,t,r,a,S,_,w,p,l,$),this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const o=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(s,o),i=this.getSettingsSyncContent(n),t=new L.ConfigurationModelParser(y.USER_DATA_SYNC_CONFIGURATION_SCOPE);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,o,n){const i=await this.getLocalFileContent(),t=await this.getFormattingOptions(),r=this.getSettingsSyncContent(s);o=o===null&&n?s:o;const a=o?this.getSettingsSyncContent(o):null,w=await this.getIgnoredSettings();let p=null,l=!1,S=!1,_=!1;if(r){let q=i?i.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Q=(0,E.merge)(q,r.settings,a?a.settings:null,w,[],t);p=Q.localContent||Q.remoteContent,l=Q.localContent!==null,S=Q.remoteContent!==null,_=Q.hasConflicts}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),p=i.value.toString().trim()||"{}",this.validateContent(p),S=!0);const N=i?i.value.toString():null,$=a?.settings??null,W={content:_?$:p,localChange:l?2:0,remoteChange:S?2:0,hasConflicts:_};return[{fileContent:i,baseResource:this.baseResource,baseContent:$,localResource:this.localResource,localContent:N,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const o=this.getSettingsSyncContent(s);if(o===null)return!0;const n=await this.getLocalFileContent(),i=n?n.value.toString().trim():"",t=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,E.merge)(i||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async getMergeResult(s,o){const n=await this.getFormattingOptions(),i=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,E.updateIgnoredSettings)(s.previewResult.content,"{}",i,n):null}}async getAcceptResult(s,o,n,i){const t=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:s.fileContent?(0,E.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:s.remoteContent!==null?(0,E.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,E.updateIgnoredSettings)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(s,o,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:w}=n[0][1];if(a===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),t&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(t.value.toString()))),await this.updateLocalFileContent(r,t,i),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const p=await this.getFormattingOptions(),l=this.getSettingsSyncContent(s),S=await this.getIgnoredSettings(r);r=(0,E.updateIgnoredSettings)(r,l?l.settings:"{}",S,p),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),i?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}o?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s)return!(0,E.isEmpty)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s)?this.resolvePreviewContent(s):null}async resolvePreviewContent(s){let o=await super.resolvePreviewContent(s);if(o){const n=await this.getFormattingOptions(),i=await this.getIgnoredSettings();o=(0,E.updateIgnoredSettings)(o,"{}",i,n)}return o}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return d(s)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=this._register(U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0}))}const o=await this._defaultIgnoredSettings;return(0,E.getIgnoredSettings)(o,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new y.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=h,e.SettingsSynchroniser=h=ye([J(2,g.IFileService),J(3,R.IEnvironmentService),J(4,P.IStorageService),J(5,y.IUserDataSyncStoreService),J(6,y.IUserDataSyncLocalStoreService),J(7,y.IUserDataSyncLogService),J(8,y.IUserDataSyncUtilService),J(9,O.IConfigurationService),J(10,y.IUserDataSyncEnablementService),J(11,b.ITelemetryService),J(12,I.IExtensionManagementService),J(13,v.IUriIdentityService)],h);let f=class extends m.AbstractInitializer{constructor(s,o,n,i,t,r){super("settings",o,n,i,s,t,r)}async doInitialize(s){const o=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,k.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,E.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return d(s)}catch(o){this.logService.error(o)}return null}};e.SettingsInitializer=f,e.SettingsInitializer=f=ye([J(0,g.IFileService),J(1,c.IUserDataProfilesService),J(2,R.IEnvironmentService),J(3,y.IUserDataSyncLogService),J(4,P.IStorageService),J(5,v.IUriIdentityService)],f)}),define(oe[118],ae([0,1,15,3,30,20,14,11,21,22,28,17,39,233,24]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function E(d){return JSON.parse(d.content)}e.parseSnippets=E;let y=class extends v.AbstractSynchroniser{constructor(h,f,C,s,o,n,i,t,r,a,w,p){super({syncResource:"snippets",profile:h},f,s,C,o,n,i,a,w,t,r,p),this.version=1,this.snippetsFolder=h.snippetsHome,this._register(this.fileService.watch(C.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(U.Event.filter(this.fileService.onDidFilesChange,l=>l.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(h,f,C){const s=await this.getSnippetsFileContents(),o=this.toSnippetsContents(s),n=h.syncData?this.parseSnippets(h.syncData):null;f=f===null&&C?h:f;const i=f&&f.syncData?this.parseSnippets(f.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.merge)(o,n,i);return this.getResourcePreviews(t,s,n||{},i||{})}async hasRemoteChanged(h){const f=h.syncData?this.parseSnippets(h.syncData):null;if(f===null)return!0;const C=await this.getSnippetsFileContents(),s=this.toSnippetsContents(C),o=(0,c.merge)(s,f,f);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(h,f){return h.previewResult}async getAcceptResult(h,f,C,s){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder))return C===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:C,localChange:C===null?h.fileContent!==null?3:0:2,remoteChange:C===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async applyResult(h,f,C,s){const o=C.map(([n,i])=>({...n,acceptResult:i}));o.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,s)),o.some(({remoteChange:n})=>n!==0)&&(h=await this.updateRemoteSnippets(o,h,s)),f?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.fileService.del(n)}catch{}}getResourcePreviews(h,f,C,s){const o=new Map;for(const n of Object.keys(h.local.added)){const i={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const i={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=f[n]?f[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of h.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=f[n]?f[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const i={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=f[n]?f[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const i={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=f[n]?f[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of h.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of h.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:f[n]?2:1,remoteChange:C[n]?2:1},t=f[n]?f[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(f))if(!o.has(n)){const i={content:f[n]?f[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=f[n]?f[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(h){return this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(h):null}async hasLocalData(){try{const h=await this.getSnippetsFileContents();if(Object.keys(h).length)return!0}catch{}return!1}async updateLocalBackup(h){const f={};for(const C of h)C.fileContent&&(f[this.extUri.basename(C.localResource)]=C.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(f)))}async updateLocalSnippets(h,f){for(const{fileContent:C,acceptResult:s,localResource:o,remoteResource:n,localChange:i}of h)if(i!==0){const t=n?this.extUri.basename(n):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,t);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,k.VSBuffer.fromString(s.content),{overwrite:f}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,k.VSBuffer.fromString(s.content),f?void 0:C),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(h,f,C){const s=f.syncData?this.parseSnippets(f.syncData):{},o=(0,A.deepClone)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of h)if(r!==0){const a=i?this.extUri.basename(i):this.extUri.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,c.areSame)(s,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),f=await this.updateRemoteUserData(JSON.stringify(o),C?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),f}parseSnippets(h){return E(h)}toSnippetsContents(h){const f={};for(const C of Object.keys(h))f[C]=h[C].value.toString();return f}async getSnippetsFileContents(){const h={};let f;try{f=await this.fileService.resolve(this.snippetsFolder)}catch(C){if(C instanceof R.FileOperationError&&C.fileOperationResult===1)return h;throw C}for(const C of f.children||[]){const s=C.resource,o=this.extUri.extname(s);if(o===".json"||o===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,s),i=await this.fileService.readFile(s);h[n]=i}}return h}};e.SnippetsSynchroniser=y,e.SnippetsSynchroniser=y=ye([J(2,L.IEnvironmentService),J(3,R.IFileService),J(4,I.IStorageService),J(5,m.IUserDataSyncStoreService),J(6,m.IUserDataSyncLocalStoreService),J(7,m.IUserDataSyncLogService),J(8,O.IConfigurationService),J(9,m.IUserDataSyncEnablementService),J(10,g.ITelemetryService),J(11,P.IUriIdentityService)],y);let u=class extends v.AbstractInitializer{constructor(h,f,C,s,o,n){super("snippets",f,C,s,h,o,n)}async doInitialize(h){const f=h.syncData?JSON.parse(h.syncData.content):null;if(!f){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(f)){const o=f[s];if(o){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,s);await this.fileService.createFile(n,k.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(h)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.SnippetsInitializer=u,e.SnippetsInitializer=u=ye([J(0,R.IFileService),J(1,b.IUserDataProfilesService),J(2,L.IEnvironmentService),J(3,m.IUserDataSyncLogService),J(4,I.IStorageService),J(5,P.IUriIdentityService)],u)}),define(oe[119],ae([0,1,15,20,14,11,21,22,28,17,39,24]),function(te,e,k,U,A,O,L,R,I,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function v(y,u){try{return JSON.parse(y).tasks??null}catch(d){return u.error(d),null}}e.getTasksContentFromSyncContent=v;let c=class extends P.AbstractFileSynchroniser{constructor(u,d,h,f,C,s,o,n,i,t,r,a){super(u.tasksResource,{syncResource:"tasks",profile:u},d,n,i,t,h,f,o,r,C,s,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,d,h,f){const C=u.syncData?v(u.syncData.content,this.logService):null;d=d===null&&h?u:d;const s=d?.syncData?v(d.syncData.content,this.logService):null,o=await this.getLocalFileContent();let n=null,i=!1,t=!1,r=!1;if(u.syncData){const p=o?o.value.toString():null;if(!s||s!==p||s!==C){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const l=E(p,C,s);n=l.content,r=l.hasConflicts,i=l.hasLocalChanged,t=l.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?s:n,localChange:i?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},w=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:s,localResource:this.localResource,localContent:w,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:C,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const d=u?.syncData?v(u.syncData.content,this.logService):null;if(d===null)return!0;const h=await this.getLocalFileContent(),f=h?h.value.toString():null,C=E(f,d,d);return C.hasLocalChanged||C.hasRemoteChanged}async getMergeResult(u,d){return u.previewResult}async getAcceptResult(u,d,h,f){if(this.extUri.isEqual(d,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(d,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(d,this.previewResource))return h===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async applyResult(u,d,h,f){const{fileContent:C}=h[0][0],{content:s,localChange:o,remoteChange:n}=h[0][1];if(o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),C&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(C.value.toString()))),s?await this.updateLocalFileContent(s,C,f):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(s));u=await this.updateRemoteUserData(i,f?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};e.TasksSynchroniser=c,e.TasksSynchroniser=c=ye([J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncLocalStoreService),J(4,b.IUserDataSyncLogService),J(5,U.IConfigurationService),J(6,b.IUserDataSyncEnablementService),J(7,O.IFileService),J(8,A.IEnvironmentService),J(9,L.IStorageService),J(10,R.ITelemetryService),J(11,I.IUriIdentityService)],c);let m=class extends P.AbstractInitializer{constructor(u,d,h,f,C,s){super("tasks",d,h,f,u,C,s),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const d=u.syncData?v(u.syncData.content,this.logService):null;if(!d){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(d)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=m,e.TasksInitializer=m=ye([J(0,O.IFileService),J(1,g.IUserDataProfilesService),J(2,A.IEnvironmentService),J(3,b.IUserDataSyncLogService),J(4,L.IStorageService),J(5,I.IUriIdentityService)],m);function E(y,u,d){if(y===null&&u===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=d!==y,f=d!==u;return!h&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!f?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!h?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[120],ae([0,1,41,20,14,11,21,22,28,17,39,234,24]),function(te,e,k,U,A,O,L,R,I,g,P,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let c=class extends P.AbstractSynchroniser{constructor(u,d,h,f,C,s,o,n,i,t,r,a,w){super({syncResource:"profiles",profile:u},d,f,C,s,o,n,r,a,i,t,w),this.userDataProfilesService=h,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(h.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?E(u.syncData):null}async getRemoteSyncedProfiles(u){const d=await this.getLastSyncUserData(),h=await this.getLatestRemoteUserData(u,d);return h?.syncData?E(h.syncData):null}async generateSyncPreview(u,d,h){if(!this.userDataProfilesService.isEnabled())throw new v.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const f=u.syncData?E(u.syncData):null,C=d?.syncData?E(d.syncData):null,s=this.getLocalUserDataProfiles(),{local:o,remote:n}=(0,b.merge)(s,f,C,[]),i={local:o,remote:n,content:C?this.stringifyRemoteProfiles(C):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=m(s,!1);return[{baseResource:this.baseResource,baseContent:C?this.stringifyRemoteProfiles(C):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:f?this.stringifyRemoteProfiles(f):null,remoteProfiles:f,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const d=u?.syncData?E(u.syncData):null,h=this.getLocalUserDataProfiles(),{remote:f}=(0,b.merge)(h,d,d,[]);return!!f?.added.length||!!f?.removed.length||!!f?.updated.length}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,h,f){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=this.getLocalUserDataProfiles(),h=(0,b.merge)(d,null,null,[]),{local:f,remote:C}=h;return{content:u.localContent,local:f,remote:C,localChange:f.added.length>0||f.removed.length>0||f.updated.length>0?2:0,remoteChange:C!==null?2:0}}async acceptRemote(u){const d=u.remoteContent?JSON.parse(u.remoteContent):null,h=[],f=[];for(const C of this.getLocalUserDataProfiles()){const s=d?.find(o=>o.id===C.id);s&&(h.push({id:C.id,name:C.name,collection:s.collection}),f.push(C))}if(d!==null){const C=(0,b.merge)(f,d,h,[]),{local:s,remote:o}=C;return{content:u.remoteContent,local:s,remote:o,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,h,f){const{local:C,remote:s,localChange:o,remoteChange:n}=h[0][1];o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const i=h[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new v.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(m(this.getLocalUserDataProfiles(),!1));const t=[];for(const r of C.added)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of C.removed)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)})());for(const r of C.updated){const a=this.userDataProfilesService.profiles.find(w=>w.id===r.id);a?t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const a of s?.added||[]){const w=await this.userDataSyncStoreService.createCollection(this.syncHeaders);t.push(w),i.push({id:a.id,name:a.name,collection:w,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of s?.removed||[])i.splice(i.findIndex(({id:w})=>a.id===w),1);for(const a of s?.updated||[]){const w=i.find(({id:p})=>a.id===p);w&&i.splice(i.indexOf(w),1,{...w,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{u=await this.updateRemoteProfiles(i,f?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(a=>a.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(a=>a.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const w of t)await this.userDataSyncStoreService.deleteCollection(w,this.syncHeaders)}throw a}for(const a of s?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,d){return this.updateRemoteUserData(this.stringifyRemoteProfiles(u),d)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const d=await this.resolvePreviewContent(u);return d&&(0,k.toFormattedString)(JSON.parse(d),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((d,h)=>d.name.localeCompare(h.name)))}};e.UserDataProfilesManifestSynchroniser=c,e.UserDataProfilesManifestSynchroniser=c=ye([J(2,g.IUserDataProfilesService),J(3,O.IFileService),J(4,A.IEnvironmentService),J(5,L.IStorageService),J(6,v.IUserDataSyncStoreService),J(7,v.IUserDataSyncLocalStoreService),J(8,v.IUserDataSyncLogService),J(9,U.IConfigurationService),J(10,v.IUserDataSyncEnablementService),J(11,R.ITelemetryService),J(12,I.IUriIdentityService)],c);function m(y,u){const d=[...y].sort((h,f)=>h.name.localeCompare(f.name)).map(h=>({id:h.id,name:h.name}));return u?(0,k.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=m;function E(y){return JSON.parse(y.content)}e.parseUserDataProfilesManifest=E}),define(oe[251],ae([0,1,3,2,5,14,21,22,24]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const g="sync.enable";let P=class extends U.Disposable{constructor(v,c,m,E){super(),this.storageService=v,this.telemetryService=c,this.environmentService=m,this.userDataSyncStoreManagementService=E,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(-1,void 0,this._register(new U.DisposableStore))(y=>this.onDidStorageChange(y)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(g,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(g,{enabled:v}),this.storageService.store(g,v,-1,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,I.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,c){if(this.isResourceEnabled(v)!==c){const m=(0,I.getEnablementKey)(v);this.storeResourceEnablement(m,c)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,c){this.storageService.store(v,c,-1,A.isWeb?0:1)}onDidStorageChange(v){if(g===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const c=I.ALL_SYNC_RESOURCES.filter(m=>(0,I.getEnablementKey)(m)===v.key)[0];if(c){this._onDidChangeResourceEnablement.fire([c,this.isResourceEnabled(c)]);return}}};e.UserDataSyncEnablementService=P,e.UserDataSyncEnablementService=P=ye([J(0,L.IStorageService),J(1,R.ITelemetryService),J(2,O.IEnvironmentService),J(3,I.IUserDataSyncStoreManagementService)],P)}),define(oe[252],ae([0,1,6,15,63,2,19,20,14,11,17,24]),function(te,e,k,U,A,O,L,R,I,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let v=class extends O.Disposable{constructor(m,E,y,u,d){super(),this.environmentService=m,this.fileService=E,this.configurationService=y,this.logService=u,this.userDataProfilesService=d,this.cleanUp()}async cleanUp(){for(const E of this.userDataProfilesService.profiles)for(const y of b.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(y,E.isDefault?void 0:E.id))}catch(u){this.logService.error(u)}let m;try{m=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(E){(0,g.toFileOperationResult)(E)!==1&&this.logService.error(E);return}if(m.children){for(const E of m.children)if(E.isDirectory&&!this.userDataProfilesService.profiles.some(y=>y.id===E.name))try{this.logService.info("Deleting non existing profile from backup",E.resource.path),await this.fileService.del(E.resource,{recursive:!0})}catch(y){this.logService.error(y)}}}async getAllResourceRefs(m,E,y){const u=this.getResourceBackupHome(m,E,y);try{const d=await this.fileService.resolve(u);if(d.children)return d.children.filter(f=>f.isFile&&!f.name.startsWith("lastSync")).sort().reverse().map(f=>({ref:f.name,created:this.getCreationTime(f)}))}catch(d){if((0,g.toFileOperationResult)(d)!==1)throw d}return[]}async resolveResourceContent(m,E,y,u){const d=this.getResourceBackupHome(m,y,u),h=(0,L.joinPath)(d,E);try{return(await this.fileService.readFile(h)).value.toString()}catch(f){return this.logService.error(f),null}}async writeResource(m,E,y,u,d){const h=this.getResourceBackupHome(m,u,d),f=(0,L.joinPath)(h,`${(0,A.toLocalISOString)(y).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,U.VSBuffer.fromString(E))}catch(C){this.logService.error(C)}}getResourceBackupHome(m,E,y=this.environmentService.userDataSyncHome){return(0,L.joinPath)(y,...E?[E,m]:[m])}async cleanUpBackup(m){try{try{if(!await this.fileService.exists(m))return}catch{return}const E=await this.fileService.resolve(m);if(E.children){const y=E.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let d=y.filter(f=>Date.now()-this.getCreationTime(f)>u);const h=y.length-d.length;h<10&&(d=d.slice(10-h)),await k.Promises.settled(d.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(m){return new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=v,e.UserDataSyncLocalStoreService=v=ye([J(0,I.IEnvironmentService),J(1,g.IFileService),J(2,R.IConfigurationService),J(3,b.IUserDataSyncLogService),J(4,P.IUserDataProfilesService)],v)}),define(oe[82],ae([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,g.createDecorator)("IUserDataSyncMachinesService");const E="sync.currentMachineName",y="Safari",u="Chrome",d="Edge",h="Firefox",f="Android";function C(n){switch(n){case y:case u:case d:case h:case f:case(0,A.PlatformToString)(0):return!0}return!1}e.isWebPlatform=C;function s(){return A.isSafari?y:A.isChrome?u:A.isEdge?d:A.isFirefox?h:A.isAndroid?f:(0,A.PlatformToString)(A.isWeb?0:A.platform)}let o=class extends U.Disposable{static{m=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(i,t,r,a,w,p){super(),this.storageService=r,this.userDataSyncStoreService=a,this.logService=w,this.productService=p,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(i,t,r)}async getMachines(i){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(i);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.computeCurrentMachineName(r.machines),platform:s()}),await this.writeMachinesData(r))}async removeCurrentMachine(i){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(i),a=r.machines.filter(({id:w})=>w!==t);a.length!==r.machines.length&&(r.machines=a,await this.writeMachinesData(r))}async renameMachine(i,t,r){const a=await this.readMachinesData(r),w=a.machines.find(({id:p})=>p===i);if(w){w.name=t,await this.writeMachinesData(a);const p=await this.currentMachineIdPromise;i===p&&this.storageService.store(E,t,-1,1)}}async setEnablements(i){const t=await this.readMachinesData();for(const[r,a]of i){const w=t.machines.find(p=>p.id===r);w&&(w.disabled=a?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(i){const t=this.storageService.get(E,-1);if(t)return t;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${s()} (${this.productService.nameShort})`,a=new RegExp(`${(0,O.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let w=0;for(const p of i){const l=a.exec(p.name),S=l?parseInt(l[1]):0;w=S>w?S:w}return`${r} #${w+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const t=this.parse(this.userData);if(t.version!==m.VERSION)throw new Error((0,L.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(i){const t=JSON.stringify(i),r=await this.userDataSyncStoreService.writeResource(m.RESOURCE,t,this.userData?.ref||null);this.userData={ref:r,content:t},this._onDidChange.fire()}async readUserData(i){if(this.userData){const t=i&&i.latest?i.latest[m.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(m.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.logService.error(t)}return{version:m.VERSION,machines:[]}}};e.UserDataSyncMachinesService=o,e.UserDataSyncMachinesService=o=m=ye([J(0,R.IEnvironmentService),J(1,I.IFileService),J(2,v.IStorageService),J(3,c.IUserDataSyncStoreService),J(4,c.IUserDataSyncLogService),J(5,P.IProductService)],o)}),define(oe[253],ae([0,1,6,63,38,7,3,2,5,19,10,172,25,21,22,24,79,82]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",h="sync.sessionId",f="sync.storeUrl",C="sync.productQuality";let s=class extends R.Disposable{get syncUrl(){const i=this.storageService.get(f,-1);return i?P.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(f,i.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(C,-1)}set productQuality(i){i?this.storageService.store(C,i,-1,1):this.storageService.remove(C,-1)}constructor(i,t,r,a,w,p,l,S,_,N){super(),this.userDataSyncStoreManagementService=t,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=a,this.userDataSyncService=w,this.logService=p,this.userDataSyncAccountService=l,this.telemetryService=S,this.userDataSyncMachinesService=_,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(t.onDidChangeUserDataSyncStore(()=>{(0,g.isEqual)(this.syncUrl,t.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(l.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(w.onDidChangeLocal($=>this.triggerSync([$],!1,!1))),this._register(L.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:t}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(t&&this.logService.info(t),this.autoSync.clear()):t&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(t))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,U.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,t,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(h,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),t)this.updateEnablement(!1);else throw a}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const t=E.UserDataSyncError.toUserDataSyncError(i);t instanceof E.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:t.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?I.isWeb&&t.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(t),this.successiveFailures++),this._onError.fire(t)}async disableMachineEventually(){this.storageService.store(d,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(d,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(d,-1)}async triggerSync(i,t,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(t&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=s,e.UserDataAutoSyncService=s=ye([J(0,v.IProductService),J(1,E.IUserDataSyncStoreManagementService),J(2,E.IUserDataSyncStoreService),J(3,E.IUserDataSyncEnablementService),J(4,E.IUserDataSyncService),J(5,E.IUserDataSyncLogService),J(6,y.IUserDataSyncAccountService),J(7,m.ITelemetryService),J(8,u.IUserDataSyncMachinesService),J(9,c.IStorageService)],s);class o extends R.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(i,t,r,a,w,p,l,S,_){super(),this.lastSyncUrl=i,this.interval=t,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncService=w,this.userDataSyncMachinesService=p,this.logService=l,this.telemetryService=S,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>{this.sync(o.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(i,t){const r=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(w){if((0,O.isCancellationError)(w))return}return this.doSync(i,t,a)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,g.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),t=this.userDataSyncStoreManagementService.userDataSyncStore;return!!t&&!!i&&(!(0,g.isEqual)(t.defaultUrl,i.defaultUrl)||!(0,g.isEqual)(t.insidersUrl,i.insidersUrl)||!(0,g.isEqual)(t.stableUrl,i.stableUrl))}async doSync(i,t,r){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(t,r)}catch(w){if(this.logService.error(w),a=w,E.UserDataSyncError.toUserDataSyncError(w).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(t,r),a=void 0}catch(p){this.logService.error(p),a=p}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(i,t){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,i),t.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new E.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const r=this.storageService.get(h,-1);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new E.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(t.isCancellationRequested)return;const w=a.find(l=>l.isCurrent);if(w?.disabled)throw new E.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");const p=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-p}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(l){throw new E.UserDataAutoSyncError((0,A.toErrorMessage)(l),l instanceof E.UserDataSyncError?l.code:"Unknown")}this.manifest&&this.manifest.session!==r&&this.storageService.store(h,this.manifest.session,-1,1),!t.isCancellationRequested&&(w||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(i){return super._register(i)}}}),define(oe[254],ae([0,1,10,176,14,11,43,21,28,24,17,39,118,117,116,20,119,114,115,4,120,41,27]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{o=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(t,r,a,w,p,l,S,_,N,$){this.userDataSyncStoreService=t,this.userDataSyncLocalStoreService=r,this.logService=a,this.environmentService=p,this.storageService=l,this.fileService=S,this.userDataProfilesService=_,this.configurationService=N,this.instantiationService=$,this.extUri=w.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const r=this.parseSyncData(t.content,"profiles");return(0,f.parseUserDataProfilesManifest)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const w=this.parseSyncData(a,"profiles");return(0,f.parseUserDataProfilesManifest)(w)}}return[]}async getLocalSyncedMachines(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(p=>({...p,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.userDataSyncStoreService.getAllResourceRefs(t,r?.collection)).map(({created:w,ref:p})=>({created:w,uri:this.toUri({remote:!0,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:r?.collection,ref:p,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(t,r?.collection,a)).map(({created:p,ref:l})=>({created:p,uri:this.toUri({remote:!1,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:l,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.resolveUri(t),a=r?this.userDataProfilesService.profiles.find(w=>w.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.resolveUri(t);if(!r)return[];const a=this.userDataProfilesService.profiles.find(w=>w.id===r.profile);switch(r.syncResource){case"settings":return this.getSettingsAssociatedResources(t,a);case"keybindings":return this.getKeybindingsAssociatedResources(t,a);case"tasks":return this.getTasksAssociatedResources(t,a);case"snippets":return this.getSnippetsAssociatedResources(t,a);case"globalState":return this.getGlobalStateAssociatedResources(t,a);case"extensions":return this.getExtensionsAssociatedResources(t,a);case"profiles":return this.getProfilesAssociatedResources(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.resolveUri(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.getUserData(r.syncResource,r.ref,r.collection);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.userDataSyncLocalStoreService.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}return(0,L.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const r=this.resolveUri(t);if(!r||r.node===o.NOT_EXISTING_RESOURCE)return null;if(r.ref){const a=await this.getContentFromStore(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.resolveNodeContent(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(t,r,a,w,p){if(t){const{content:l}=await this.getUserData(r,w,a);return l}return this.userDataSyncLocalStoreService.resolveResourceContent(r,w,a,p)}resolveNodeContent(t,r,a){const w=this.parseSyncData(r,t);switch(t){case"settings":return this.resolveSettingsNodeContent(w,a);case"keybindings":return this.resolveKeybindingsNodeContent(w,a);case"tasks":return this.resolveTasksNodeContent(w,a);case"snippets":return this.resolveSnippetsNodeContent(w,a);case"globalState":return this.resolveGlobalStateNodeContent(w,a);case"extensions":return this.resolveExtensionsNodeContent(w,a);case"profiles":return this.resolveProfileNodeContent(w,a);case"workspaceState":return null}}async resolveLatestContent(t,r){const a=this.userDataProfilesService.profiles.find(w=>w.id===r);if(!a)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(a);case"extensions":return this.resolveLatestExtensionsContent(a);case"profiles":return this.resolveLatestProfilesContent(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"settings.json"),w=r?r.settingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveSettingsNodeContent(t,r){switch(r){case"settings.json":return(0,c.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"keybindings.json"),w=r?r.keybindingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveKeybindingsNodeContent(t,r){switch(r){case"keybindings.json":return(0,m.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(g.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,r){const a=this.extUri.joinPath(t,"tasks.json"),w=r?r.tasksResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveTasksNodeContent(t,r){switch(r){case"tasks.json":return(0,y.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,r){const a=await this.resolveContent(t);if(a){const w=this.parseSyncData(a,"snippets");if(w){const p=(0,v.parseSnippets)(w),l=[];for(const S of Object.keys(p)){const _=this.extUri.joinPath(t,S),N=r?this.extUri.joinPath(r.snippetsHome,S):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);l.push({resource:_,comparableResource:N})}return l}}return[]}resolveSnippetsNodeContent(t,r){return(0,v.parseSnippets)(t)[r]||null}getExtensionsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"extensions.json"),w=r?this.toUri({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveExtensionsNodeContent(t,r){switch(r){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:r}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(r,!0)}getGlobalStateAssociatedResources(t,r){const a=this.extUri.joinPath(t,"globalState.json"),w=r?this.toUri({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveGlobalStateNodeContent(t,r){switch(r){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const r=await this.instantiationService.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(r,!0)}getProfilesAssociatedResources(t,r){const a=this.extUri.joinPath(t,"profiles.json"),w=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:w}]}resolveProfileNodeContent(t,r){switch(r){case"profiles.json":return(0,C.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,f.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(t){const r=t.remote?o.REMOTE_BACKUP_AUTHORITY:o.LOCAL_BACKUP_AUTHORITY,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,s.trim)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.extUri.joinPath(k.URI.from({scheme:g.USER_DATA_SYNC_SCHEME,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}resolveUri(t){if(t.scheme!==g.USER_DATA_SYNC_SCHEME)return;const r=[];for(;t.path!=="/";)r.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(r.length<2)return;const a=t.authority===o.REMOTE_BACKUP_AUTHORITY;let w,p;const l=[];let S,_,N,$,W;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?w=q.substring(7):q.startsWith("authority:")?p=q.substring(10):q.startsWith("syncResource:")?S=q.substring(13):q.startsWith("profile:")?_=q.substring(8):q.startsWith("collection:")?N=q.substring(11):q.startsWith("ref:")?$=q.substring(4):S?W=q:l.push(q)}return{remote:a,syncResource:S,profile:_,collection:N,ref:$,node:W,location:w&&p!==void 0?this.extUri.joinPath(k.URI.from({scheme:w,authority:p,query:t.query,fragment:t.fragment,path:"/"}),...l):void 0}}parseSyncData(t,r){try{const a=JSON.parse(t);if((0,b.isSyncData)(a))return a}catch(a){this.logService.error(a)}throw new g.UserDataSyncError((0,U.localize)(0,null),"IncompatibleRemoteContent",r)}async getUserData(t,r,a){const w=await this.userDataSyncStoreService.resolveResourceContent(t,r,a);return{ref:r,content:w}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=o=ye([J(0,g.IUserDataSyncStoreService),J(1,g.IUserDataSyncLocalStoreService),J(2,g.IUserDataSyncLogService),J(3,I.IUriIdentityService),J(4,A.IEnvironmentService),J(5,R.IStorageService),J(6,O.IFileService),J(7,P.IUserDataProfilesService),J(8,E.IConfigurationService),J(9,h.IInstantiationService)],n)}),define(oe[255],ae([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,114,115,116,117,118,119,120,24]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let r=class extends R.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(S,_,N,$,W,q,Q,G,X,x,Y){super(),this.fileService=S,this.userDataSyncStoreService=_,this.userDataSyncStoreManagementService=N,this.instantiationService=$,this.logService=W,this.telemetryService=q,this.storageService=Q,this.userDataSyncEnablementService=G,this.userDataProfilesService=X,this.userDataSyncResourceProviderService=x,this.userDataSyncLocalStoreService=Y,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=N.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(t,-1,void 0),this._register((0,R.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(S,_){this.checkEnablement(),this.logService.info("Sync started.");const N=new Date().getTime(),$=(0,P.generateUuid)();try{const G=(0,i.createSyncHeaders)($);_&&(G["Cache-Control"]="no-cache"),S=await this.userDataSyncStoreService.manifest(S,G)}catch(G){const X=i.UserDataSyncError.toUserDataSyncError(G);throw p(X,$,this.userDataSyncStoreManagementService,this.telemetryService),X}const W=!1,q=this;let Q;return{manifest:S,async run(){if(W)throw new Error("Can run a task only once");Q=(0,U.createCancelablePromise)(G=>q.sync(S,!1,$,G)),await Q.finally(()=>Q=void 0),q.logService.info(`Sync done. Took ${new Date().getTime()-N}ms`),q.updateLastSyncTime()},stop(){return Q?.cancel(),q.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const S=new Date().getTime(),_=(0,P.generateUuid)(),N=(0,i.createSyncHeaders)(_);let $;try{$=await this.userDataSyncStoreService.manifest(null,N)}catch(Q){const G=i.UserDataSyncError.toUserDataSyncError(Q);throw p(G,_,this.userDataSyncStoreManagementService,this.telemetryService),G}await this.resetLocal();const W=this,q=new A.CancellationTokenSource;return{id:_,async merge(){return W.sync($,!0,_,q.token)},async apply(){try{try{await W.applyManualSync($,_,q.token)}catch(Q){if(i.UserDataSyncError.toUserDataSyncError(Q).code==="MethodNotFound")W.logService.info("Client is making invalid requests. Cleaning up data..."),await W.cleanUpRemoteData(),W.logService.info("Applying manual sync again..."),await W.applyManualSync($,_,q.token);else throw Q}}catch(Q){throw W.logService.error(Q),Q}W.logService.info(`Sync done. Took ${new Date().getTime()-S}ms`),W.updateLastSyncTime()},async stop(){q.cancel(),await W.stop(),await W.resetLocal()}}}async sync(S,_,N,$){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const W=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(W,S,_,N,$));const q=W.enabled.find(Q=>Q.resource==="profiles");if(q){const Q=await q.getLastSyncedProfiles()||[];if($.isCancellationRequested)return;await this.syncRemoteProfiles(Q,S,_,N,$)}}finally{this.status!=="hasConflicts"&&this.setStatus("idle"),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(S,_,N,$,W){for(const q of S){if(W.isCancellationRequested)return;const Q=this.userDataProfilesService.profiles.find(X=>X.id===q.id);if(!Q){this.logService.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",q.name);const G=this.getOrCreateActiveProfileSynchronizer(Q,q);this._syncErrors.push(...await this.syncProfile(G,_,N,$,W))}for(const[q,Q]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(G=>G.id===Q[0].profile.id)||(Q[1].dispose(),this.activeProfileSynchronizers.delete(q))}async applyManualSync(S,_,N){const $=this.getActiveProfileSynchronizers();for(const X of $){if(N.isCancellationRequested)return;await X.apply(_,N)}const W=$.find(X=>X.profile.isDefault);if(!W)return;const q=W.enabled.find(X=>X.resource==="profiles");if(!q)return;const G=(await q.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(X=>$.every(x=>x.profile.id!==X.id));G.length&&await this.syncRemoteProfiles(G,S,!1,_,N)}async syncProfile(S,_,N,$,W){return(await S.sync(_,N,$,W)).map(([Q,G])=>({profile:S.profile,syncResource:Q,error:G}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(S=>S.stop()))}async resolveContent(S){const _=await this.userDataSyncResourceProviderService.resolveContent(S);if(_)return _;for(const N of this.getActiveProfileSynchronizers())for(const $ of N.enabled){const W=await $.resolveContent(S);if(W)return W}return null}async replace(S){this.checkEnablement();const _=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(S);if(!_)return;const N=await this.resolveContent(S.uri);N&&await this.performAction(_.profile,async $=>{if(_.syncResource===$.resource)return await $.replace(N),!0})}async accept(S,_,N,$){this.checkEnablement(),await this.performAction(S.profile,async W=>{if(S.syncResource===W.resource)return await W.accept(_,N),$&&await W.apply((0,g.isBoolean)($)?!1:$.force,(0,i.createSyncHeaders)((0,P.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async _=>{if(_.resource!=="globalState"&&await _.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async _=>{if(await _.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(S){this.logService.error(S)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(t,-1);for(const[S]of this.activeProfileSynchronizers.values())try{await S.resetLocal()}catch(_){this.logService.error(_)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const S=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),_=S.map(q=>q.collection),N=await this.userDataSyncStoreService.getAllCollections(),$=N.filter(q=>!_.includes(q));$.length&&(this.logService.info(`Deleting ${$.length} redundant collections on server`),await Promise.allSettled($.map(q=>this.userDataSyncStoreService.deleteCollection(q))),this.logService.info("Deleted redundant collections on server"));const W=S.filter(q=>N.includes(q.collection));if(W.length!==S.length){const q=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(W,null),this.logService.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(S){this.checkEnablement();const _=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(S,_)}async extractActivityData(S,_){const N=(await this.fileService.readFile(S)).value.toString(),$=JSON.parse(N);if($.resources)for(const W in $.resources)for(const q of $.resources[W])await this.userDataSyncLocalStoreService.writeResource(W,q.content,new Date(q.created*1e3),void 0,_);if($.collections)for(const W in $.collections)for(const q in $.collections[W].resources)for(const Q of $.collections[W].resources?.[q]??[])await this.userDataSyncLocalStoreService.writeResource(q,Q.content,new Date(Q.created*1e3),W,_)}async performAction(S,_){const N=new R.DisposableStore;try{const $=this.activeProfileSynchronizers.get(S.id);if($){const X=await this.performActionWithProfileSynchronizer($[0],_,N);return(0,g.isUndefined)(X)?null:X}if(S.isDefault){const X=N.add(this.instantiationService.createInstance(a,S,void 0)),x=await this.performActionWithProfileSynchronizer(X,_,N);return(0,g.isUndefined)(x)?null:x}if(this.userDataProfilesService.isEnabled())return null;const W=N.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,S,void 0)),q=await this.userDataSyncStoreService.manifest(null),G=(await W.getRemoteSyncedProfiles(q?.latest??null)||[]).find(X=>X.id===S.id);if(G){const X=N.add(this.instantiationService.createInstance(a,S,G.collection)),x=await this.performActionWithProfileSynchronizer(X,_,N);return(0,g.isUndefined)(x)?null:x}return null}finally{N.dispose()}}async performActionWithProfileSynchronizer(S,_,N){const $=[...S.enabled,...S.disabled.reduce((W,q)=>(q!=="workspaceState"&&W.push(N.add(S.createSynchronizer(q))),W),[])];for(const W of $){const q=await _(W);if(!(0,g.isUndefined)(q))return q}}setStatus(S){const _=this._status;this._status!==S&&(this._status=S,this._onDidChangeStatus.fire(S),_==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const S=this.getActiveProfileSynchronizers().map(_=>_.conflicts).flat();(0,k.equals)(this._conflicts,S,(_,N)=>_.profile.id===N.profile.id&&_.syncResource===N.syncResource&&(0,k.equals)(_.conflicts,N.conflicts,($,W)=>(0,I.isEqual)($.previewResource,W.previewResource)))||(this._conflicts=S,this._onDidChangeConflicts.fire(S))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(S,_){let N=this.activeProfileSynchronizers.get(S.id);if(N&&N[0].collection!==_?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.activeProfileSynchronizers.delete(S.id)),!N){const $=new R.DisposableStore,W=$.add(this.instantiationService.createInstance(a,S,_?.collection));$.add(W.onDidChangeStatus(q=>this.setStatus(q))),$.add(W.onDidChangeConflicts(q=>this.updateConflicts())),$.add(W.onDidChangeLocal(q=>this._onDidChangeLocal.fire(q))),this.activeProfileSynchronizers.set(S.id,N=[W,$])}return N[0]}getActiveProfileSynchronizers(){const S=[];for(const[_]of this.activeProfileSynchronizers.values())S.push(_);return S}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,S])=>S.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=ye([J(0,c.IFileService),J(1,i.IUserDataSyncStoreService),J(2,i.IUserDataSyncStoreManagementService),J(3,m.IInstantiationService),J(4,i.IUserDataSyncLogService),J(5,y.ITelemetryService),J(6,E.IStorageService),J(7,i.IUserDataSyncEnablementService),J(8,u.IUserDataProfilesService),J(9,i.IUserDataSyncResourceProviderService),J(10,i.IUserDataSyncLocalStoreService)],r);let a=class extends R.Disposable{get enabled(){return this._enabled.sort((S,_)=>S[1]-_[1]).map(([S])=>S)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(S=>!this.userDataSyncEnablementService.isResourceEnabled(S))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(S,_,N,$,W,q,Q,G,X,x){super(),this.profile=S,this.collection=_,this.userDataSyncEnablementService=N,this.instantiationService=$,this.extensionGalleryService=W,this.userDataSyncStoreManagementService=q,this.telemetryService=Q,this.logService=G,this.userDataProfilesService=X,this.configurationService=x,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(N.onDidChangeResourceEnablement(([Y,B])=>this.onDidChangeResourceEnablement(Y,B))),this._register((0,R.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,Y])=>Y.dispose())));for(const Y of i.ALL_SYNC_RESOURCES)N.isResourceEnabled(Y)&&this.registerSynchronizer(Y)}onDidChangeResourceEnablement(S,_){_?this.registerSynchronizer(S):this.deRegisterSynchronizer(S)}registerSynchronizer(S){if(this._enabled.some(([W])=>W.resource===S))return;if(S==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(S==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||S==="workspaceState")return;if(S!=="profiles"&&this.profile.useDefaultFlags?.[S]){this.logService.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const _=new R.DisposableStore,N=_.add(this.createSynchronizer(S));_.add(N.onDidChangeStatus(()=>this.updateStatus())),_.add(N.onDidChangeConflicts(()=>this.updateConflicts())),_.add(N.onDidChangeLocal(()=>this._onDidChangeLocal.fire(S)));const $=this.getOrder(S);this._enabled.push([N,$,_])}deRegisterSynchronizer(S){const _=this._enabled.findIndex(([N])=>N.resource===S);if(_!==-1){const[[N,,$]]=this._enabled.splice(_,1);$.dispose(),this.updateStatus(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,W=>this.logService.error(W))}}createSynchronizer(S){switch(S){case"settings":return this.instantiationService.createInstance(C.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(f.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(s.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(o.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(h.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(d.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(S,_,N,$){if($.isCancellationRequested)return[];const W=this.enabled;if(!W.length)return[];try{const q=[],Q=(0,i.createSyncHeaders)(N),G=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,X=_?await this.getUserDataSyncConfiguration(G):{};for(const x of W){if($.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(x.resource))return[];try{if(_){const Y=await x.preview(G,X,Q);if(Y)for(const B of Y.resourcePreviews)(B.localChange!==0||B.remoteChange!==0)&&B.mergeState==="preview"&&await x.merge(B.previewResource)}else await x.sync(G,Q)}catch(Y){const B=i.UserDataSyncError.toUserDataSyncError(Y);if(p(B,N,this.userDataSyncStoreManagementService,this.telemetryService),w(Y))throw B;this.logService.error(Y),this.logService.error(`${x.resource}: ${(0,O.toErrorMessage)(Y)}`),q.push([x.resource,B])}}return q}finally{this.updateStatus()}}async apply(S,_){const N=(0,i.createSyncHeaders)(S);for(const $ of this.enabled){if(_.isCancellationRequested)return;try{await $.apply(!1,N)}catch(W){const q=i.UserDataSyncError.toUserDataSyncError(W);if(p(q,S,this.userDataSyncStoreManagementService,this.telemetryService),w(W))throw q;this.logService.error(W),this.logService.error(`${$.resource}: ${(0,O.toErrorMessage)(W)}`)}}}async stop(){for(const S of this.enabled)try{S.status!=="idle"&&await S.stop()}catch(_){this.logService.error(_)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(_){this.logService.error(`${S.resource}: ${(0,O.toErrorMessage)(_)}`),this.logService.error(_)}}async getUserDataSyncConfiguration(S){if(!this.profile.isDefault)return{};const _=this.configurationService.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find($=>$ instanceof C.SettingsSynchroniser);if(N){const $=await N.getRemoteUserDataSyncConfiguration(S);return{..._,...$}}return _}setStatus(S){this._status!==S&&(this._status=S,this._onDidChangeStatus.fire(S))}updateStatus(){return this.updateConflicts(),this.enabled.some(S=>S.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(S=>S.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const S=this.enabled.filter(_=>_.status==="hasConflicts").filter(_=>_.conflicts.conflicts.length>0).map(_=>_.conflicts);(0,k.equals)(this._conflicts,S,(_,N)=>_.syncResource===N.syncResource&&(0,k.equals)(_.conflicts,N.conflicts,($,W)=>(0,I.isEqual)($.previewResource,W.previewResource)))||(this._conflicts=S,this._onDidChangeConflicts.fire(S))}getOrder(S){switch(S){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([J(2,i.IUserDataSyncEnablementService),J(3,m.IInstantiationService),J(4,v.IExtensionGalleryService),J(5,i.IUserDataSyncStoreManagementService),J(6,y.ITelemetryService),J(7,i.IUserDataSyncLogService),J(8,u.IUserDataProfilesService),J(9,b.IConfigurationService)],a);function w(l){if(l instanceof i.UserDataSyncError)switch(l.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function p(l,S,_,N){N.publicLog2("sync/error",{code:l.code,serverCode:l instanceof i.UserDataSyncStoreError?String(l.serverCode):void 0,url:l instanceof i.UserDataSyncStoreError?l.url:void 0,resource:l.resource,executionId:S,service:_.userDataSyncStore.url.toString()})}}),define(oe[256],ae([0,1,3,2,10,17,24]),function(te,e,k,U,A,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(v,c){return{...v,profile:(0,O.reviveProfile)(v.profile,c.profilesHome.scheme)}}function I(v){return{created:v.created,uri:A.URI.revive(v.uri)}}class g{constructor(c,m,E){this.service=c,this.userDataProfilesService=m,this.logService=E,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(c,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(c,m,E){try{return await this._call(c,m,E)}catch(y){throw this.logService.error(y),y}}async _call(c,m,E){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(A.URI.revive(E[0]));case"accept":return this.service.accept(R(E[0],this.userDataProfilesService),A.URI.revive(E[1]),E[2],E[3]);case"replace":return this.service.replace(I(E[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(A.URI.revive(E[0]));case"extractActivityData":return this.service.extractActivityData(A.URI.revive(E[0]),A.URI.revive(E[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const y=m.substring(11),u=E[0],d=this.getManualSyncTask(u);switch(E=E.slice(1),y){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.manualSyncTasks.delete(this.createKey(d.id)));case"stop":return d.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(d.id)))}}throw new Error("Invalid call")}getManualSyncTask(c){const m=this.manualSyncTasks.get(this.createKey(c));if(!m)throw new Error(`Manual sync taks not found: ${c}`);return m}async createManualSyncTask(){const c=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(c.id),c),c.id}createKey(c){return`manualSyncTask-${c}`}}e.UserDataSyncChannel=g;let P=class extends U.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(c,m){super(),this.userDataProfilesService=m,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(E,y,u){return c.call(E,y,u).then(null,d=>{throw L.UserDataSyncError.toUserDataSyncError(d)})},listen(E,y){return c.listen(E,y)}},this.channel.call("_getInitialData").then(([E,y,u])=>{this.updateStatus(E),this.updateConflicts(y),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(E=>this.updateConflicts(E))),this._register(this.channel.listen("onSyncErrors")(E=>this._onSyncErrors.fire(E.map(y=>({...y,error:L.UserDataSyncError.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.channel.call("createManualSyncTask"),m=this;return new b(c,{async call(y,u,d){return m.channel.call(`manualSync/${y}`,[c,...Array.isArray(u)?u:[u]],d)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(c,m,E,y){return this.channel.call("accept",[c,m,E,y])}resolveContent(c){return this.channel.call("resolveContent",[c])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(c){return this.channel.call("replace",[c])}saveRemoteActivityData(c){return this.channel.call("getRemoteActivityData",[c])}extractActivityData(c,m){return this.channel.call("extractActivityData",[c,m])}async updateStatus(c){this._status=c,this._onDidChangeStatus.fire(c)}async updateConflicts(c){this._conflicts=c.map(m=>({syncResource:m.syncResource,profile:(0,O.reviveProfile)(m.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:m.conflicts.map(E=>({...E,baseResource:A.URI.revive(E.baseResource),localResource:A.URI.revive(E.localResource),remoteResource:A.URI.revive(E.remoteResource),previewResource:A.URI.revive(E.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(c){this._lastSyncTime!==c&&(this._lastSyncTime=c,this._onDidChangeLastSyncTime.fire(c))}};e.UserDataSyncChannelClient=P,e.UserDataSyncChannelClient=P=ye([J(1,O.IUserDataProfilesService)],P);class b extends U.Disposable{constructor(c,m){super(),this.id=c,this.channel=m}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(oe[257],ae([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,57,43,21,24]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const C="configurationSync.store",s="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends L.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(N){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,$,W){super(),this.productService=N,this.configurationService=$,this.storageService=W,this._onDidChangeUserDataSyncStore=this._register(new O.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const q=this._register(new L.DisposableStore);this._register(O.Event.filter(W.onDidChangeValue(-1,f.SYNC_SERVICE_URL_TYPE,q),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,q)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[C]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(N){if(N&&(N=I.isWeb&&N.web?{...N,...N.web}:N,(0,P.isString)(N.url)&&(0,P.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every($=>Array.isArray(N.authenticationProviders[$].scopes)))){const $=N,W=!!$.canSwitch,q=$.url===$.insidersUrl?"insiders":"stable",Q=(W?this.userDataSyncStoreType:void 0)||q,G=Q==="insiders"?$.insidersUrl:Q==="stable"?$.stableUrl:$.url;return{url:b.URI.parse(G),type:Q,defaultType:q,defaultUrl:b.URI.parse($.url),stableUrl:b.URI.parse($.stableUrl),insidersUrl:b.URI.parse($.insidersUrl),canSwitch:W,authenticationProviders:Object.keys($.authenticationProviders).reduce((X,x)=>(X.push({id:x,scopes:$.authenticationProviders[x].scopes}),X),[])}}}};e.AbstractUserDataSyncStoreManagementService=a,e.AbstractUserDataSyncStoreManagementService=a=ye([J(0,y.IProductService),J(1,c.IConfigurationService),J(2,h.IStorageService)],a);let w=class extends a{constructor(N,$,W){super(N,$,W);const q=this.storageService.get(s,-1);q&&(this.previousConfigurationSyncStore=JSON.parse(q));const Q=this.productService[C];Q?this.storageService.store(s,JSON.stringify(Q),-1,1):this.storageService.remove(s,-1)}async switch(N){N!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=N,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=w,e.UserDataSyncStoreManagementService=w=ye([J(0,y.IProductService),J(1,c.IConfigurationService),J(2,h.IStorageService)],w);let p=class extends L.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(N,$,W,q,Q,G,X){super(),this.requestService=W,this.logService=q,this.storageService=X,this._onTokenFailed=this._register(new O.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new O.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new O.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(N),this.commonHeadersPromise=(0,d.getServiceMachineId)(Q,G,X).then(x=>{const Y={"X-Client-Name":`${$.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":$.version};return $.commit&&(Y["X-Client-Commit"]=$.commit),Y}),this.session=new S(t,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,L.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(N,$){this.authToken={token:N,type:$}}updateUserDataSyncStoreUrl(N){this.userDataSyncStoreUrl=N?(0,g.joinPath)(N,"v1"):void 0}initDonotMakeRequestsUntil(){const N=this.storageService.getNumber(o,-1);N&&Date.now()<N&&this.setDonotMakeRequestsUntil(new Date(N))}setDonotMakeRequestsUntil(N){this._donotMakeRequestsUntil?.getTime()!==N?.getTime()&&(this._donotMakeRequestsUntil=N,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(o,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)($=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),$).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,$=>null)):this.storageService.remove(o,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,g.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},N["Content-Type"]="application/json";const W=await this.request($,{type:"GET",headers:N},[],U.CancellationToken.None);return(await(0,u.asJson)(W))?.map(({id:q})=>q)||[]}async createCollection(N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,g.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const W=await this.request($,{type:"POST",headers:N},[],U.CancellationToken.None),q=await(0,u.asTextOrError)(W);if(!q)throw new f.UserDataSyncStoreError("Server did not return the collection id",$,"NoCollection",W.res.statusCode,W.res.headers[f.HEADER_OPERATION_ID]);return q}async deleteCollection(N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=N?(0,g.joinPath)(this.userDataSyncStoreUrl,"collection",N).toString():(0,g.joinPath)(this.userDataSyncStoreUrl,"collection").toString();$={...$},await this.request(W,{type:"DELETE",headers:$},[],U.CancellationToken.None)}async getAllResourceRefs(N,$){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=this.getResourceUrl(this.userDataSyncStoreUrl,$,N),q={},Q=await this.request(W.toString(),{type:"GET",headers:q},[],U.CancellationToken.None);return(await(0,u.asJson)(Q)||[]).map(({url:X,created:x})=>({ref:(0,g.relativePath)(W,W.with({path:X})),created:x*1e3}))}async resolveResourceContent(N,$,W,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Q=(0,g.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,N),$).toString();q={...q},q["Cache-Control"]="no-cache";const G=await this.request(Q,{type:"GET",headers:q},[],U.CancellationToken.None);return await(0,u.asTextOrError)(G)}async deleteResource(N,$,W){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=$!==null?(0,g.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,N),$).toString():this.getResourceUrl(this.userDataSyncStoreUrl,W,N).toString(),Q={};await this.request(q,{type:"DELETE",headers:Q},[],U.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,g.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),$={"Content-Type":R.Mimes.text};await this.request(N,{type:"DELETE",headers:$},[],U.CancellationToken.None)}async readResource(N,$,W,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Q=(0,g.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,N),"latest").toString();q={...q},q["Cache-Control"]="no-cache",$&&(q["If-None-Match"]=$.ref);const G=await this.request(Q,{type:"GET",headers:q},[304],U.CancellationToken.None);let X=null;if(G.res.statusCode===304&&(X=$),X===null){const x=G.res.headers.etag;if(!x)throw new f.UserDataSyncStoreError("Server did not return the ref",Q,"NoRef",G.res.statusCode,G.res.headers[f.HEADER_OPERATION_ID]);const Y=await(0,u.asTextOrError)(G);if(!Y&&G.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",Q,"EmptyResponse",G.res.statusCode,G.res.headers[f.HEADER_OPERATION_ID]);X={ref:x,content:Y}}return X}async writeResource(N,$,W,q,Q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const G=this.getResourceUrl(this.userDataSyncStoreUrl,q,N).toString();Q={...Q},Q["Content-Type"]=R.Mimes.text,W&&(Q["If-Match"]=W);const X=await this.request(G,{type:"POST",data:$,headers:Q},[],U.CancellationToken.None),x=X.res.headers.etag;if(!x)throw new f.UserDataSyncStoreError("Server did not return the ref",G,"NoRef",X.res.statusCode,X.res.headers[f.HEADER_OPERATION_ID]);return x}async manifest(N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,g.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();$={...$},$["Content-Type"]="application/json",N&&($["If-None-Match"]=N.ref);const q=await this.request(W,{type:"GET",headers:$},[304],U.CancellationToken.None);let Q=null;if(q.res.statusCode===304&&(Q=N),!Q){const X=q.res.headers.etag;if(!X)throw new f.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",q.res.statusCode,q.res.headers[f.HEADER_OPERATION_ID]);const x=await(0,u.asTextOrError)(q);if(!x&&q.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",W,"EmptyResponse",q.res.statusCode,q.res.headers[f.HEADER_OPERATION_ID]);x&&(Q={...JSON.parse(x),ref:X})}const G=this.storageService.get(n,-1);return G&&Q&&G!==Q.session&&this.clearSession(),Q===null&&G&&this.clearSession(),Q&&this.storageService.store(n,Q.session,-1,1),Q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,g.joinPath)(this.userDataSyncStoreUrl,"download").toString(),$={},W=await this.request(N,{type:"GET",headers:$},[],U.CancellationToken.None);if(!(0,u.isSuccess)(W))throw new f.UserDataSyncStoreError("Server returned "+W.res.statusCode,N,"EmptyResponse",W.res.statusCode,W.res.headers[f.HEADER_OPERATION_ID]);if((0,u.hasNoContent)(W))throw new f.UserDataSyncStoreError("Empty response",N,"EmptyResponse",W.res.statusCode,W.res.headers[f.HEADER_OPERATION_ID]);return W.stream}getResourceUrl(N,$,W){return $?(0,g.joinPath)(N,"collection",$,"resource",W):(0,g.joinPath)(N,"resource",W)}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(i,-1)}async request(N,$,W,q){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const Q=await this.commonHeadersPromise;$.headers={...$.headers||{},...Q,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders($.headers),this.logService.trace("Sending request to server",{url:N,type:$.type,headers:{...$.headers,authorization:void 0}});let G;try{G=await this.session.request(N,$,q)}catch(z){if(!(z instanceof f.UserDataSyncStoreError)){let ee="RequestFailed";const ie=(0,A.getErrorMessage)(z).toLowerCase();ie.includes("xhr timeout")?ee="RequestTimeout":ie.includes("protocol")&&ie.includes("not supported")?ee="RequestProtocolNotSupported":ie.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ie.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,A.isCancellationError)(z)&&(ee="RequestCanceled"),z=new f.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,ee,void 0,void 0)}throw this.logService.info("Request failed",N),z}const X=G.res.headers[f.HEADER_OPERATION_ID],x={url:N,status:G.res.statusCode,"execution-id":$.headers[f.HEADER_EXECUTION_ID],"operation-id":X},Y=(0,u.isSuccess)(G)||G.res.statusCode&&W.includes(G.res.statusCode);let B="";if(Y?this.logService.trace("Request succeeded",x):(B=await(0,u.asText)(G)||"",this.logService.info("Request failed",x,B)),G.res.statusCode===401||G.res.statusCode===403){if(this.authToken=void 0,G.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",G.res.statusCode,X);if(G.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",G.res.statusCode,X)}if(this._onTokenSucceed.fire(),G.res.statusCode===404)throw new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",G.res.statusCode,X);if(G.res.statusCode===405)throw new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested endpoint is not found (405). ${B}`,N,"MethodNotFound",G.res.statusCode,X);if(G.res.statusCode===409)throw new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",G.res.statusCode,X);if(G.res.statusCode===410)throw new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",G.res.statusCode,X);if(G.res.statusCode===412)throw new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",G.res.statusCode,X);if(G.res.statusCode===413)throw new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",G.res.statusCode,X);if(G.res.statusCode===426)throw new f.UserDataSyncStoreError(`${$.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",G.res.statusCode,X);if(G.res.statusCode===429){const z=G.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",G.res.statusCode,X)):new f.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",G.res.statusCode,X)}if(!Y)throw new f.UserDataSyncStoreError("Server returned "+G.res.statusCode,N,"Unknown",G.res.statusCode,X);return G}addSessionHeaders(N){let $=this.storageService.get(i,-1);$===void 0&&($=(0,v.generateUuid)(),this.storageService.store(i,$,-1,1)),N["X-Machine-Session-Id"]=$;const W=this.storageService.get(n,-1);W!==void 0&&(N["X-User-Session-Id"]=W)}};e.UserDataSyncStoreClient=p,e.UserDataSyncStoreClient=p=ye([J(1,y.IProductService),J(2,u.IRequestService),J(3,f.IUserDataSyncLogService),J(4,m.IEnvironmentService),J(5,E.IFileService),J(6,h.IStorageService)],p);let l=class extends p{constructor(N,$,W,q,Q,G,X){super(N.userDataSyncStore?.url,$,W,q,Q,G,X),this._register(N.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(N.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=l,e.UserDataSyncStoreService=l=ye([J(0,f.IUserDataSyncStoreManagementService),J(1,y.IProductService),J(2,u.IRequestService),J(3,f.IUserDataSyncLogService),J(4,m.IEnvironmentService),J(5,E.IFileService),J(6,h.IStorageService)],l);class S{constructor(N,$,W,q){this.limit=N,this.interval=$,this.requestService=W,this.logService=q,this.requests=[],this.startTime=void 0}request(N,$,W){if(this.isExpired()&&this.reset(),$.url=N,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(N),this.requestService.request($,W)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=S}),define(oe[258],ae([0,1,3,55,25,21,22,253,24,79,82]),function(te,e,k,U,A,O,L,R,I,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends R.UserDataAutoSyncService{constructor(c,m,E,y,u,d,h,f,C,s,o){super(c,m,E,y,u,h,f,C,s,o),this._register(k.Event.debounce(k.Event.any(k.Event.map(d.onDidFocusWindow,()=>"windowFocus"),k.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=b,e.UserDataAutoSyncService=b=ye([J(0,A.IProductService),J(1,I.IUserDataSyncStoreManagementService),J(2,I.IUserDataSyncStoreService),J(3,I.IUserDataSyncEnablementService),J(4,I.IUserDataSyncService),J(5,U.INativeHostService),J(6,I.IUserDataSyncLogService),J(7,g.IUserDataSyncAccountService),J(8,L.ITelemetryService),J(9,P.IUserDataSyncMachinesService),J(10,O.IStorageService)],b)}),define(oe[259],ae([0,1,70,23,5,19]),function(te,e,k,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(g){function P(){let b=g.scheme===U.Schemas.file?(0,O.originalFSPath)(g):g.toString();return A.isLinux||(b=b.toLowerCase()),(0,k.createHash)("md5").update(b).digest("hex")}return{id:P(),configPath:g}}e.getWorkspaceIdentifier=L;function R(g,P){function b(){if(g.scheme!==U.Schemas.file)return(0,k.createHash)("md5").update(g.toString()).digest("hex");if(!P)return;let c;return A.isLinux?c=P.ino:A.isMacintosh?c=P.birthtime.getTime():A.isWindows&&(typeof P.birthtimeMs=="number"?c=Math.floor(P.birthtimeMs):c=P.birthtime.getTime()),(0,k.createHash)("md5").update(g.fsPath).update(c?String(c):"").digest("hex")}const v=b();if(typeof v=="string")return{id:v,uri:g}}e.getSingleFolderWorkspaceIdentifier=R;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[260],ae([0,1,6,7,2,16,31,14,8,76,112,259,55,72,23]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let E=class extends A.Disposable{constructor(u,d,h,f){super(),this.environmentService=u,this.logService=d,this.nativeHostService=h,this.mainProcessService=f,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const u=this.environmentService.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,d=await L.Promises.readdir(u),h=new g.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(d.map(async f=>{const C=(0,O.join)(u,f);f.length===b.NON_EMPTY_WORKSPACE_ID_LENGTH||f===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===f)||await h.isUsed(C)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${f} as it seems to be an unused empty workspace.`),await L.Promises.rm(C))}))}catch(u){(0,U.onUnexpectedError)(u)}}};e.UnusedWorkspaceStorageDataCleaner=E,e.UnusedWorkspaceStorageDataCleaner=E=ye([J(0,R.INativeEnvironmentService),J(1,I.ILogService),J(2,v.INativeHostService),J(3,c.IMainProcessService)],E)}),define(oe[83],ae([0,1,53,6,16,12,31,147,271,272]),function(te,e,k,U,A,O,L,R,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class b extends Error{constructor(o,n){let i=n.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=n}}e.ExtractError=b;function v(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,i)=>n+i,o&61440)}function c(s){if(s instanceof b)return s;let o;return P.test(s.message)&&(o="CorruptZip"),new b(o,s)}function m(s,o,n,i,t,r){const a=A.dirname(o),w=A.join(i,a);if(!w.startsWith(i))return Promise.reject(new Error(R.localize(0,null,o)));const p=A.join(i,o);let l;return r.onCancellationRequested(()=>{l?.destroy()}),Promise.resolve(L.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((S,_)=>{if(!r.isCancellationRequested)try{l=(0,k.createWriteStream)(p,{mode:n}),l.once("close",()=>S()),l.once("error",_),s.once("error",_),s.pipe(l)}catch(N){_(N)}}))}function E(s,o,n,i){let t=(0,U.createCancelablePromise)(()=>Promise.resolve()),r=0;const a=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((w,p)=>{const l=new U.Sequencer,S=_=>{_.isCancellationRequested||(r++,s.readEntry())};s.once("error",p),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?w():p(new b("Incomplete",new Error(R.localize(1,null,r,s.entryCount))))},p)),s.readEntry(),s.on("entry",_=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(_.fileName)){S(i);return}const N=_.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(N)){const q=A.join(o,N);t=(0,U.createCancelablePromise)(Q=>L.Promises.mkdir(q,{recursive:!0}).then(()=>S(Q)).then(void 0,p));return}const $=u(s,_),W=v(_);t=(0,U.createCancelablePromise)(q=>l.queue(()=>$.then(Q=>m(Q,N,W,o,n,q).then(()=>S(q)))).then(null,p))})}).finally(()=>a.dispose())}function y(s,o=!1){return new Promise((n,i)=>{(0,I.open)(s,o?{lazyEntries:!0}:void 0,(t,r)=>{t?i(c(t)):n((0,O.assertIsDefined)(r))})})}function u(s,o){return new Promise((n,i)=>{s.openReadStream(o,(t,r)=>{t?i(c(t)):n((0,O.assertIsDefined)(r))})})}function d(s,o){return new Promise((n,i)=>{const t=new g.ZipFile;o.forEach(a=>{a.contents?t.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&t.addFile(a.localPath,a.path)}),t.end();const r=(0,k.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=d;function h(s,o,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=y(s,!0);return n.overwrite&&(r=r.then(a=>L.Promises.rm(o).then(()=>a))),r.then(a=>E(a,o,{sourcePathRegex:t},i))}e.extract=h;function f(s,o){return y(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===o&&u(n,r).then(a=>i(a),a=>t(a))}),n.once("close",()=>t(new Error(R.localize(2,null,o))))}))}function C(s,o){return f(s,o).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",a=>r.push(a)),n.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=C}),define(oe[261],ae([0,1,6,7,2,23,19,54,12,32,31,83,20,14,29,33,97,11,8]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends A.Disposable{static{h=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(s,o,n,i,t,r){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=i,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(s,o,n){await this.cleanUpPromise;const i=(0,L.joinPath)(this.extensionsDownloadDir,this.getName(s));try{await this.downloadFile(s,i,r=>this.extensionGalleryService.download(s,r,o))}catch(r){throw new m.ExtensionManagementError(r.message,m.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.shouldVerifySignature(s)){const r=await this.downloadSignatureArchive(s);try{t=await this.extensionSignatureVerificationService.verify(i.fsPath,r.fsPath,this.logService.getLevel()===d.LogLevel.Trace)}catch(a){const w=a;if(t=w.code,w.output&&this.logService.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${w.output}`),t===m.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===m.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new m.ExtensionManagementError(b.CorruptZipMessage,m.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.logService.error(a)}}}return t===!0?this.logService.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.logService.info(`Extension signature verification is not done: ${s.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}shouldVerifySignature(s){if(!s.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,I.isBoolean)(o)?o:!0}async downloadSignatureArchive(s){await this.cleanUpPromise;const o=(0,L.joinPath)(this.extensionsDownloadDir,`${this.getName(s)}${h.SignatureArchiveExtension}`);return await this.downloadFile(s,o,n=>this.extensionGalleryService.downloadSignatureArchive(s,n)),o}async downloadFile(s,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==O.Schemas.file){await n(o);return}const i=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(i)||await n(i);try{await P.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.fileService.del(i)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,U.getErrorMessage)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.cleanUpPromise,await this.fileService.del(s)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],n=[],i=[];for(const a of s.children)if(a.name.endsWith(h.SignatureArchiveExtension))i.push(a.resource);else{const w=E.ExtensionKey.parse(a.name);w&&n.push([w,a])}const t=(0,E.groupByExtension)(n,([a])=>a),r=[];for(const a of t)a.sort((w,p)=>R.rcompare(w[0].version,p[0].version)),o.push(...a.slice(1).map(w=>w[1].resource)),r.push(a[0][1]);r.sort((a,w)=>a.mtime-w.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(a=>a.resource)),o.push(...i),await k.Promises.settled(o.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(s){this.logService.error(s)}}getName(s){return this.cache?E.ExtensionKey.create(s).toString().toLowerCase():(0,g.generateUuid)()}};e.ExtensionsDownloader=f,e.ExtensionsDownloader=f=h=ye([J(0,c.INativeEnvironmentService),J(1,u.IFileService),J(2,m.IExtensionGalleryService),J(3,v.IConfigurationService),J(4,y.IExtensionSignatureVerificationService),J(5,d.ILogService)],f)}),define(oe[262],ae([0,1,83,156]),function(te,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(O){return(0,k.buffer)(O,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,U.localize)(0,null))}})}e.getManifest=A}),define(oe[121],ae([0,1,6,15,26,38,7,3,52,2,34,23,16,19,54,12,10,32,31,83,155,96,14,241,29,33,51,80,261,242,262,211,222,68,11,4,8,25,22,28,17]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C,s,o,n,i,t,r,a,w,p,l,S,_,N,$,W,q,Q,G,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,$.refineServiceDecorator)(n.IExtensionManagementService);const x=".vsctmp";let Y=class extends o.AbstractExtensionManagementService{constructor(K,j,D,T,M,F,V,H,re,ce,he,ue){super(K,j,he,D,ce,ue),this.extensionsScannerService=M,this.extensionsProfileScannerService=F,this.downloadService=V,this.fileService=re,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new P.ResourceSet;const me=this._register(H.createInstance(w.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(B,pe=>me.postUninstall(pe))),this.manifestCache=this._register(new l.ExtensionsManifestCache(ue,re,he,this,this.logService)),this.extensionsDownloader=this._register(H.createInstance(a.ExtensionsDownloader));const fe=this._register(new S.ExtensionsWatcher(this,this.extensionsScannerService,ue,F,he,re,D));this._register(fe.onDidChangeExtensionsByAnotherSource(pe=>this.onDidChangeExtensionsFromAnotherSource(pe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(K){this.logService.trace("ExtensionManagementService#zip",K.identifier.id);const j=await this.collectFiles(K),D=await(0,h.zip)((0,c.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,j);return y.URI.file(D)}async unzip(K){return this.logService.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:j,cleanup:D}=await this.downloadVsix(K),T=v.resolve(j.fsPath);try{return await(0,p.getManifest)(T)}finally{await D()}}getInstalled(K,j=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(K??null,j)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.extensionsScanner.scanUserExtensionAtLocation(K)}async install(K,j={}){this.logService.trace("ExtensionManagementService#install",K.toString());const{location:D,cleanup:T}=await this.downloadVsix(K);try{const M=await(0,p.getManifest)(v.resolve(D.fsPath)),F=(0,i.getGalleryExtensionId)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,_.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,F,this.productService.version));const H=(await this.installExtensions([{manifest:M,extension:D,options:j}])).find(({identifier:re})=>(0,i.areSameExtensions)(re,{id:F}));if(H?.local)return H.local;throw H?.error?H.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${F}`))}finally{await T()}}async installFromLocation(K,j){this.logService.trace("ExtensionManagementService#installFromLocation",K.toString());const D=await this.extensionsScanner.scanUserExtensionAtLocation(K);if(!D)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.addExtensionsToProfile([[D,void 0]],j),this.logService.info("Successfully installed extension",D.identifier.id,j.toString()),D}async installExtensionsFromProfile(K,j,D){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",K,j.toString(),D.toString());const T=(await this.extensionsScanner.scanExtensions(1,j)).filter(M=>K.some(F=>(0,i.areSameExtensions)(F,M.identifier)));if(T.length){const M=await Promise.all(T.map(F=>this.extensionsScanner.scanMetadata(F,j)));await this.addExtensionsToProfile(T.map((F,V)=>[F,M[V]]),D),this.logService.info("Successfully installed extensions",T.map(F=>F.identifier.id),D.toString())}return T}async updateMetadata(K,j,D=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",K.identifier.id),j.isPreReleaseVersion&&(j.preRelease=!0),j.isMachineScoped===!1&&(j.isMachineScoped=void 0),j.isBuiltin===!1&&(j.isBuiltin=void 0),j.pinned===!1&&(j.pinned=void 0),K=await this.extensionsScanner.updateMetadata(K,j,D),this.manifestCache.invalidate(D),this._onDidUpdateExtensionMetadata.fire(K),K}async reinstallFromGallery(K){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.galleryService.isEnabled())throw new Error(f.localize(1,null));const j=await this.getTargetPlatform(),[D]=await this.galleryService.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:j,compatible:!0},A.CancellationToken.None);if(!D)throw new Error(f.localize(2,null));await this.extensionsScanner.setUninstalled(K);try{await this.extensionsScanner.removeUninstalledExtension(K)}catch(T){throw new Error(f.localize(3,null,(0,O.toErrorMessage)(T)))}return this.installFromGallery(D)}copyExtension(K,j,D,T){return this.extensionsScanner.copyExtension(K,j,D,T)}copyExtensions(K,j){return this.extensionsScanner.copyExtensions(K,j)}markAsUninstalled(...K){return this.extensionsScanner.setUninstalled(...K)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(K){this.logService.error(K)}}async download(K,j,D){const{location:T}=await this.extensionsDownloader.download(K,j,!D);return T}async downloadVsix(K){if(K.scheme===b.Schemas.file)return{location:K,async cleanup(){}};this.logService.trace("Downloading extension from",K.toString());const j=(0,c.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)());return await this.downloadService.download(K,j),this.logService.info("Downloaded extension to",j.toString()),{location:j,cleanup:async()=>{try{await this.fileService.del(j)}catch(T){this.logService.error(T)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(K,j,D){if(y.URI.isUri(j))return new ie(K,j,D,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const T=i.ExtensionKey.create(j).toString();let M=this.installGalleryExtensionsTasks.get(T);return M||(this.installGalleryExtensionsTasks.set(T,M=new ee(K,j,D,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),M.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(T))),M}createUninstallExtensionTask(K,j){return new Z(K,j.profileLocation,this.extensionsProfileScannerService)}async collectFiles(K){const j=async T=>{let M=await d.Promises.readdir(T);M=M.map(H=>v.join(T,H));const F=await Promise.all(M.map(H=>d.Promises.stat(H)));let V=Promise.resolve([]);return F.forEach((H,re)=>{const ce=M[re];H.isFile()&&(V=V.then(he=>[...he,ce])),H.isDirectory()&&(V=V.then(he=>j(ce).then(ue=>[...he,...ue])))}),V};return(await j(K.location.fsPath)).map(T=>({path:`extension/${v.relative(K.location.fsPath,T)}`,localPath:T}))}async onDidChangeExtensionsFromAnotherSource({added:K,removed:j}){if(j){const D=K&&this.uriIdentityService.extUri.isEqual(j.profileLocation,K.profileLocation)?j.extensions.filter(T=>K.extensions.every(M=>!(0,i.areSameExtensions)(M,T))):j.extensions;for(const T of D)this.logService.info("Extensions removed from another source",T.id,j.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:T,profileLocation:j.profileLocation})}if(K){const T=(await this.extensionsScanner.scanExtensions(1,K.profileLocation)).filter(M=>K.extensions.some(F=>(0,i.areSameExtensions)(F,M.identifier)));this._onDidInstallExtensions.fire(T.map(M=>(this.logService.info("Extensions added from another source",M.identifier.id,K.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:K.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(j=>this.knownDirectories.add(j)));const K=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const j of K.children??[])j.isDirectory&&this.knownDirectories.add(j.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(j=>this.onDidFilesChange(j)))}async onDidFilesChange(K){if(!K.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const j=[];for(const D of K.rawAdded){if(this.knownDirectories.has(D)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(D),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(D,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(D).startsWith(".")||!(await this.fileService.stat(D)).isDirectory)continue;const T=await this.extensionsScanner.scanUserExtensionAtLocation(D);T&&T.installedTimestamp===void 0&&(this.knownDirectories.add(D),j.push(T))}j.length&&(await this.addExtensionsToProfile(j.map(D=>[D,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",j.map(D=>D.identifier.id)))}async addExtensionsToProfile(K,j){const D=K.map(T=>T[0]);await this.setInstalled(D),await this.extensionsProfileScannerService.addExtensionsToProfile(K,j),this._onDidInstallExtensions.fire(D.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:j})))}async setInstalled(K){const j=await this.extensionsScanner.getUninstalledExtensions();for(const D of K){const T=i.ExtensionKey.create(D);j[T.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",T.id),await this.extensionsScanner.setInstalled(T),this.logService.info("Removed the extension from uninstalled list:",T.id))}}};e.ExtensionManagementService=Y,e.ExtensionManagementService=Y=ye([J(0,n.IExtensionGalleryService),J(1,Q.ITelemetryService),J(2,W.ILogService),J(3,s.INativeEnvironmentService),J(4,r.IExtensionsScannerService),J(5,t.IExtensionsProfileScannerService),J(6,C.IDownloadService),J(7,$.IInstantiationService),J(8,N.IFileService),J(9,q.IProductService),J(10,G.IUriIdentityService),J(11,X.IUserDataProfilesService)],Y);let B=class extends g.Disposable{constructor(K,j,D,T,M,F){super(),this.beforeRemovingExtension=K,this.fileService=j,this.extensionsScannerService=D,this.extensionsProfileScannerService=T,this.uriIdentityService=M,this.logService=F,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,c.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(K,j){const D={includeInvalid:!0,profileLocation:j};let T=[];return K===null||K===0?T.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},D,!1)):K===1&&T.push(...await this.extensionsScannerService.scanUserExtensions(D)),T=K!==null?T.filter(M=>M.type===K):T,Promise.all(T.map(M=>this.toLocalExtension(M)))}async scanAllUserExtensions(K){const j=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(j.map(D=>this.toLocalExtension(D)))}async scanUserExtensionAtLocation(K){try{const j=await this.extensionsScannerService.scanExistingExtension(K,1,{includeInvalid:!0});if(j)return await this.toLocalExtension(j)}catch(j){this.logService.error(j)}return null}async extractUserExtension(K,j,D,T,M){const F=K.toString(),V=y.URI.file(v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`)),H=y.URI.file(v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,F));let re=await this.fileService.exists(H);if(re&&T){try{await this.deleteExtensionFromLocation(K.id,H,"removeExisting")}catch{throw new n.ExtensionManagementError(f.localize(4,null,H.fsPath,K.id),n.ExtensionManagementErrorCode.Delete)}re=!1}if(!re)try{try{this.logService.trace(`Started extracting the extension from ${j} to ${H.fsPath}`),await(0,h.extract)(j,V.fsPath,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${H}:`,K.id)}catch(ce){let he=n.ExtensionManagementErrorCode.Extract;throw ce instanceof h.ExtractError&&(ce.type==="CorruptZip"?he=n.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(he=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(ce.message,he)}await this.extensionsScannerService.updateMetadata(V,D);try{this.logService.trace(`Started renaming the extension from ${V.fsPath} to ${H.fsPath}`),await this.rename(V.fsPath,H.fsPath),this.logService.info("Renamed to",H.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(ce)}. Deleted from extracted location`,V),ce}this._onExtract.fire(H)}catch(ce){try{await this.fileService.del(V,{recursive:!0})}catch{}throw ce}return this.scanLocalExtension(H,1)}async scanMetadata(K,j){return j?(await this.getScannedExtension(K,j))?.metadata:this.extensionsScannerService.scanMetadata(K.location)}async getScannedExtension(K,j){return(await this.extensionsProfileScannerService.scanProfileExtensions(j)).find(T=>(0,i.areSameExtensions)(T.identifier,K.identifier))}async updateMetadata(K,j,D){return D?await this.extensionsProfileScannerService.updateMetadata([[K,j]],D):await this.extensionsScannerService.updateMetadata(K.location,j),this.scanLocalExtension(K.location,K.type,D)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...K){const j=K.map(D=>i.ExtensionKey.create(D));await this.withUninstalledExtensions(D=>j.forEach(T=>{D[T.toString()]=!0,this.logService.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(K){await this.withUninstalledExtensions(j=>delete j[K.toString()])}async removeExtension(K,j){if(this.uriIdentityService.extUri.isEqualOrParent(K.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(K.identifier.id,K.location,j)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[i.ExtensionKey.create(K).toString()])}async copyExtension(K,j,D,T){const M=await this.getScannedExtension(K,j),F=await this.getScannedExtension(K,D);return T={...M?.metadata,...T},F?await this.extensionsProfileScannerService.updateMetadata([[K,{...F.metadata,...T}]],D):await this.extensionsProfileScannerService.addExtensionsToProfile([[K,T]],D),this.scanLocalExtension(K.location,K.type,D)}async copyExtensions(K,j){const D=await this.scanExtensions(1,K),T=await Promise.all(D.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,K)]));await this.extensionsProfileScannerService.addExtensionsToProfile(T,j)}async deleteExtensionFromLocation(K,j,D){this.logService.trace(`Deleting ${D} extension from disk`,K,j.fsPath);const T=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(j),`${this.uriIdentityService.extUri.basename(j)}.${(0,I.hash)((0,u.generateUuid)()).toString(16)}${x}`);await this.rename(j.fsPath,T.fsPath),await this.fileService.del(T,{recursive:!0}),this.logService.info(`Deleted ${D} extension from disk`,K,j.fsPath)}async withUninstalledExtensions(K){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(T){if((0,N.toFileOperationResult)(T)!==1)throw T}let D={};if(j)try{D=JSON.parse(j)}catch{}return K&&(K(D),Object.keys(D).length?await this.fileService.writeFile(this.uninstalledResource,U.VSBuffer.fromString(JSON.stringify(D))):await this.fileService.del(this.uninstalledResource)),D})}async rename(K,j){try{await d.Promises.rename(K,j,2*60*1e3)}catch(D){throw new n.ExtensionManagementError(D.message||f.localize(5,null,K,j),D.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(K,j,D){if(D){const M=(await this.extensionsScannerService.scanUserExtensions({profileLocation:D})).find(F=>this.uriIdentityService.extUri.isEqual(F.location,K));if(M)return this.toLocalExtension(M)}else{const T=await this.extensionsScannerService.scanExistingExtension(K,j,{includeInvalid:!0});if(T)return this.toLocalExtension(T)}throw new Error(f.localize(6,null,K.path))}async toLocalExtension(K){const j=await this.fileService.resolve(K.location);let D,T;return j.children&&(D=j.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,T=j.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:D,changelogUrl:T,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async removeUninstalledExtensions(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(K));const j=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),D=new Set;for(const M of j)K[i.ExtensionKey.create(M).toString()]||D.add(M.identifier.id.toLowerCase());try{const M=(0,i.groupByExtension)(j,F=>F.identifier);await k.Promises.settled(M.map(async F=>{const V=F.sort((H,re)=>m.rcompare(H.manifest.version,re.manifest.version))[0];D.has(V.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(V))}))}catch(M){this.logService.error(M)}const T=j.filter(M=>M.metadata&&K[i.ExtensionKey.create(M).toString()]);await Promise.allSettled(T.map(M=>this.removeUninstalledExtension(M)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(j){(0,N.toFileOperationResult)(j)!==1&&this.logService.error(j);return}if(K?.children)try{await Promise.allSettled(K.children.map(async j=>{if(!(!j.isDirectory||!j.name.endsWith(x))){this.logService.trace("Deleting the temporarily deleted folder",j.resource.toString());try{await this.fileService.del(j.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",j.resource.toString())}catch(D){(0,N.toFileOperationResult)(D)!==1&&this.logService.error(D)}}}))}catch{}}};e.ExtensionsScanner=B,e.ExtensionsScanner=B=ye([J(1,N.IFileService),J(2,r.IExtensionsScannerService),J(3,t.IExtensionsProfileScannerService),J(4,G.IUriIdentityService),J(5,W.ILogService)],B);class z extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(K,j,D,T,M,F,V,H,re){super(),this.identifier=K,this.source=j,this.options=D,this.extensionsScanner=T,this.uriIdentityService=M,this.userDataProfilesService=F,this.extensionsScannerService=V,this.extensionsProfileScannerService=H,this.logService=re,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(K){const[j,D]=await this.install(K);return this._profileLocation=j.isBuiltin||j.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[j,D]],this._profileLocation),j}async extractExtension({zipPath:K,key:j,metadata:D},T,M){let F=await this.unsetIfUninstalled(j);return F||(this.logService.trace("Extracting extension...",j.id),F=await this.extensionsScanner.extractUserExtension(j,K,D,T,M),this.logService.info("Extracting extension completed.",j.id)),F}async unsetIfUninstalled(K){return await this.isUninstalled(K)?(this.logService.trace("Removing the extension from uninstalled list:",K.id),await this.extensionsScanner.setInstalled(K),this.logService.info("Removed the extension from uninstalled list:",K.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(T=>i.ExtensionKey.create(T).equals(K))):void 0}async isUninstalled(K){return!!(await this.extensionsScanner.getUninstalledExtensions())[K.toString()]}}class ee extends z{constructor(K,j,D,T,M,F,V,H,re,ce){super(j.identifier,j,D,M,F,V,H,re,ce),this.gallery=j,this.extensionsDownloader=T}async install(K){const D=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(V=>(0,i.areSameExtensions)(V.identifier,this.gallery.identifier));D&&(this._operation=3);const T={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||D?.isMachineScoped,isBuiltin:this.options.isBuiltin||D?.isBuiltin,isSystem:D?.type===0?!0:void 0,updated:!!D,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:D?.preRelease)};if(D?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(D,T),T];const{location:M,verificationStatus:F}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=F,this.validateManifest(M.fsPath),[await this.extractExtension({zipPath:M.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:T},!1,K),T]}catch(V){try{await this.extensionsDownloader.delete(M)}catch(H){this.logService.warn("Error while deleting the downloaded file",M.toString(),(0,L.getErrorMessage)(H))}throw V}}async validateManifest(K){try{await(0,p.getManifest)(K)}catch(j){throw new n.ExtensionManagementError((0,o.joinErrors)(j).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=ee;class ie extends z{constructor(K,j,D,T,M,F,V,H,re,ce){super({id:(0,i.getGalleryExtensionId)(K.publisher,K.name)},j,D,M,F,V,H,re,ce),this.manifest=K,this.location=j,this.galleryService=T}async doRun(K){const j=await super.doRun(K);return this.updateMetadata(j,K),j}async install(K){const j=new i.ExtensionKey(this.identifier,this.manifest.version),T=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(V=>(0,i.areSameExtensions)(this.identifier,V.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(T)if(this._operation=3,j.equals(new i.ExtensionKey(T.identifier,T.manifest.version)))try{await this.extensionsScanner.removeExtension(T,"existing")}catch{throw new Error(f.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&m.gt(T.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(T);else{const V=await this.unsetIfUninstalled(j);if(V)try{await this.extensionsScanner.removeExtension(V,"existing")}catch{throw new Error(f.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:v.resolve(this.location.fsPath),key:j,metadata:M},!0,K),M]}async updateMetadata(K,j){try{let[D]=await this.galleryService.getExtensions([{id:K.identifier.id,version:K.manifest.version}],j);if(D||([D]=await this.galleryService.getExtensions([{id:K.identifier.id}],j)),D){const T={id:D.identifier.uuid,publisherDisplayName:D.publisherDisplayName,publisherId:D.publisherId,isPreReleaseVersion:D.properties.isPreReleaseVersion,preRelease:D.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(K,T,this.options.profileLocation)}}catch{}}}class Z extends o.AbstractExtensionTask{constructor(K,j,D){super(),this.extension=K,this.profileLocation=j,this.extensionsProfileScannerService=D}async doRun(K){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(oe[263],ae([0,1,2,29,81,221,121,8,21]),function(te,e,k,U,A,O,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let g=class extends k.Disposable{constructor(b,v,c,m,E,y){super(),b.cleanUp(),(0,O.migrateUnsupportedExtensions)(b,v,c,m,y),A.ExtensionStorageService.removeOutdatedExtensionVersions(b,E)}};e.ExtensionsContributions=g,e.ExtensionsContributions=g=ye([J(0,L.INativeServerExtensionManagementService),J(1,U.IExtensionGalleryService),J(2,A.IExtensionStorageService),J(3,U.IGlobalExtensionEnablementService),J(4,I.IStorageService),J(5,R.ILogService)],g)}),define(oe[122],ae([0,1,70,62,36,273,15,7,3,2,16,5,32,42,66]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{traceSocketEvent(l,S){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,S)}constructor(l,S=""){this._canWrite=!0,this.debugLabel=S,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,R.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener),this._closeListener=_=>{this.traceSocketEvent("close",{hadError:_}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(l){const S=_=>{this.traceSocketEvent("read",_),l(L.VSBuffer.wrap(_))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(l){const S=_=>{l({type:0,hadError:_,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(l){const S=()=>{l()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(l){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,R.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,R.onUnexpectedError)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=E;var y;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(y||(y={}));var u;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(u||(u={}));class d extends g.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,S){this.socket.traceSocketEvent(l,S)}constructor(l,S,_,N){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:_?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new h(this,S,_,N,this._onData,($,W)=>this._write($,W))),this._register(this._flowManager.onError($=>{console.error($),(0,R.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new m.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose(async $=>{this._flowManager.isProcessingReadQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire($)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let S=0;for(;S<l.byteLength;)this._flowManager.writeMessage(l.slice(S,Math.min(S+262144,l.byteLength)),{compressed:!0,opcode:2}),S+=262144}_write(l,{compressed:S,opcode:_}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let N=2;l.byteLength<126?N+=0:l.byteLength<2**16?N+=2:N+=8;const $=L.VSBuffer.alloc(N),W=S?64:0,q=_&15;if($.writeUInt8(128|W|q,0),l.byteLength<126)$.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){$.writeUInt8(126,1);let Q=1;$.writeUInt8(l.byteLength>>>8&255,++Q),$.writeUInt8(l.byteLength>>>0&255,++Q)}else{$.writeUInt8(127,1);let Q=1;$.writeUInt8(0,++Q),$.writeUInt8(0,++Q),$.writeUInt8(0,++Q),$.writeUInt8(0,++Q),$.writeUInt8(l.byteLength>>>24&255,++Q),$.writeUInt8(l.byteLength>>>16&255,++Q),$.writeUInt8(l.byteLength>>>8&255,++Q),$.writeUInt8(l.byteLength>>>0&255,++Q)}this.socket.write(L.VSBuffer.concat([$,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),_=S.readUInt8(0),N=(_&128)>>>7,$=(_&64)>>>6,W=_&15,q=S.readUInt8(1),Q=(q&128)>>>7,G=q&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(G===126?2:0)+(G===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!$),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this._state.opcode=W,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),_=S.readUInt8(1),N=(_&128)>>>7;let $=_&127,W=1;$===126?$=S.readUInt8(++W)*2**8+S.readUInt8(++W):$===127&&($=S.readUInt8(++W)*0+S.readUInt8(++W)*0+S.readUInt8(++W)*0+S.readUInt8(++W)*0+S.readUInt8(++W)*2**24+S.readUInt8(++W)*2**16+S.readUInt8(++W)*2**8+S.readUInt8(++W));let q=0;N&&(q=S.readUInt8(++W)*2**24+S.readUInt8(++W)*2**16+S.readUInt8(++W)*2**8+S.readUInt8(++W)),this._state.state=3,this._state.readLen=$,this._state.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),s(S,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(S,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class h extends g.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(l,S,_,N,$,W){super(),this._tracer=l,this._onData=$,this._writeFn=W,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new I.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,S?(this._zlibInflateStream=this._register(new f(this._tracer,N,_,{windowBits:15})),this._zlibDeflateStream=this._register(new C(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(q=>this._onError.fire(q))),this._register(this._zlibDeflateStream.onError(q=>this._onError.fire(q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(l,S){this._writeQueue.push({data:l,options:S}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:l,options:S}=this._writeQueue.shift();if(this._zlibDeflateStream&&S.compressed){const _=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(_,S)}else this._writeFn(l,{...S,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,S){return new Promise((_,N)=>{l.write(S),l.flush($=>_($))})}acceptFrame(l,S,_){this._readQueue.push({data:l,isCompressed:S,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const S=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(S)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(l,S,_){return new Promise((N,$)=>{l.write(S),_&&l.write(L.VSBuffer.fromByteArray([0,0,255,255])),l.flush(W=>N(W))})}}class f extends g.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(l,S,_,N){super(),this._tracer=l,this._recordInflateBytes=S,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,O.createInflateRaw)(N),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(L.VSBuffer.wrap($))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const S=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(S)})}}class C extends g.Disposable{constructor(l,S){super(),this._tracer=l,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,O.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(L.VSBuffer.wrap(_))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let S=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.byteLength-4),l(S)})}}function s(p,l){if(l===0)return;const S=p.byteLength>>>2;for(let Q=0;Q<S;Q++){const G=p.readUInt32BE(Q*4);p.writeUInt32BE(G^l,Q*4)}const _=S*4,N=p.byteLength-_,$=l>>>24&255,W=l>>>16&255,q=l>>>8&255;N>=1&&p.writeUInt8(p.readUInt8(_)^$,_),N>=2&&p.writeUInt8(p.readUInt8(_+1)^W,_+1),N>=3&&p.writeUInt8(p.readUInt8(_+2)^q,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const p=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const l=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,A.tmpdir)(),S=(0,P.join)(l,`vscode-ipc-${p}.sock`);return t(S),S}e.createRandomIPCHandle=n;function i(p,l,S){const _=(0,k.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${S}-${l}-sock`;const N=S.substr(0,4),$=l.substr(0,6),W=_.substr(0,8);let q;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?q=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${W}-${N}-${$}.sock`):q=(0,P.join)(p,`${N}-${$}.sock`),t(q),q}e.createStaticIPCHandle=i;function t(p){const l=o[b.platform];typeof l=="number"&&p.length>=l&&console.warn(`WARNING: IPC handle "${p}" is longer than ${l} chars, try a shorter --user-data-dir`)}class r extends c.IPCServer{static toClientConnectionEvent(l){const S=I.Event.fromNodeEventEmitter(l,"connection");return I.Event.map(S,_=>({protocol:new m.Protocol(new E(_,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(_,"close"))}))}constructor(l){super(r.toClientConnectionEvent(l)),this.server=l}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(p){return new Promise((l,S)=>{const _=(0,U.createServer)();_.on("error",S),_.listen(p,()=>{_.removeListener("error",S),l(new r(_))})})}e.serve=a;function w(p,l){return new Promise((S,_)=>{const N=(0,U.createConnection)(p,()=>{N.removeListener("error",_),S(m.Client.fromSocket(new E(N,`ipc-client${l}`),l))});N.once("error",_)})}e.connect=w}),define(oe[264],ae([0,1,62,122,209]),function(te,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(O){return!0}connect({host:O,port:L},R,I,g){return new Promise((P,b)=>{const v=k.createConnection({host:O,port:L},()=>{v.removeListener("error",b),v.write((0,A.makeRawSocketHeaders)(R,I,g));const c=m=>{m.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",c),P(new U.NodeSocket(v,g)))};v.on("data",c)});v.setNoDelay(!0),v.once("error",b)})}}}),define(oe[265],ae([0,1,62,36,132,122,6,2,5,20,8,25,212,104,106,77,15]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function u(s,o,n,i,t){let r;for(let a=3;a&&(r?.dispose(),r=await new d(s,o,n,i,t).waitForReady(),!(t&&A.BROWSER_RESTRICTED_PORTS[t]||!A.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));a--);return r}class d extends R.Disposable{constructor(o,n,i,t,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=k.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,E.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,A.findFreePortFaster)(o,2,1e3,n),t=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(o){o.pause();const n=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t instanceof O.NodeSocket?t.socket.destroy():t.end()}),t instanceof O.NodeSocket?this._mirrorNodeSocket(o,t):this._mirrorGenericSocket(o,t),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),t.end()})}_mirrorGenericSocket(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(i=>o.write(i.buffer)),o.on("data",i=>n.write(y.VSBuffer.wrap(i))),o.resume()}_mirrorNodeSocket(o,n){const i=n.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.NodeRemoteTunnel=d;let h=class extends E.AbstractTunnelService{constructor(o,n,i,t,r){super(n,r),this.remoteSocketFactoryService=o,this.signService=i,this.productService=t}isPortPrivileged(o){return(0,E.isPortPrivileged)(o,this.defaultTunnelHost,I.OS,U.release())}retainOrCreateTunnel(o,n,i,t,r,a,w,p){const l=this.getTunnelFromMap(n,i);if(l)return++l.refcount,l.value;if((0,E.isTunnelProvider)(o))return this.createWithProvider(o,n,i,r,a,w,p);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const S={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},_=u(S,t,n,i,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,i,_),_}}};e.BaseTunnelService=h,e.BaseTunnelService=h=ye([J(0,c.IRemoteSocketFactoryService),J(1,P.ILogService),J(2,m.ISignService),J(3,b.IProductService),J(4,g.IConfigurationService)],h);let f=class extends h{constructor(o,n,i,t,r){super(o,n,i,t,r)}};e.TunnelService=f,e.TunnelService=f=ye([J(0,c.IRemoteSocketFactoryService),J(1,P.ILogService),J(2,m.ISignService),J(3,b.IProductService),J(4,g.IConfigurationService)],f);let C=class extends R.Disposable{constructor(o,n,i,t,r){super(),this.remoteSocketFactoryService=o,this.logService=n,this.productService=i,this.signService=t,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(o,n,i,t,r,a,w,p,l){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${a}.`),!this._tunnelServices.has(o)){const S=new f(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(S),this._tunnelServices.set(o,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(n,i,t,r,a,w,p,l)}};e.SharedTunnelsService=C,e.SharedTunnelsService=C=ye([J(0,c.IRemoteSocketFactoryService),J(1,P.ILogService),J(2,b.IProductService),J(3,m.ISignService),J(4,g.IConfigurationService)],C)}),define(oe[274],ae([0,1,36,38,7,2,23,10,18,3,42,146,203,204,195,196,260,186,188,20,208,95,219,96,214,14,113,245,29,97,187,121,98,11,198,199,69,4,194,71,73,224,8,200,102,25,57,21,107,22,108,109,110,45,227,81,111,24,79,252,237,238,82,251,255,256,257,58,250,239,106,218,77,265,213,228,28,229,5,230,189,206,205,80,244,17,51,202,56,249,226,240,105,254,263,9,201,101,247,243,215,183,55,258,246,72,248,104,264,181,216]),function(te,e,k,U,A,O,L,R,I,g,P,b,v,c,m,E,y,u,d,h,f,C,s,o,n,i,t,r,a,w,p,l,S,_,N,$,W,q,Q,G,X,x,Y,B,z,ee,ie,Z,ne,K,j,D,T,M,F,V,H,re,ce,he,ue,me,fe,pe,we,Le,Ue,Me,le,ge,ve,Ie,De,$e,Te,We,Fe,se,de,Se,Ee,be,Re,Pe,ke,_e,Oe,Ne,qe,je,xe,Ze,ht,Et,wt,Ct,bt,dt,It,Pt,Dt,Rt,Lt,kt,_t,ft,Tt,gt,At,Ot,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ut extends O.Disposable{constructor(Ce){super(),this.configuration=Ce,this.server=this._register(new b.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new g.Emitter),this.registerListeners()}registerListeners(){let Ce=!1;const Ae=()=>{Ce||(Ce=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,b.once)(process.parentPort,it.SharedProcessLifecycle.exit,Ae)}async init(){const Ce=await this.initServices();(0,re.registerConfiguration)(),Ce.invokeFunction(Ae=>{const Ge=Ae.get(Y.ILogService),ze=Ae.get(K.ITelemetryService),Ke=Ae.get(_e.IUserDataProfilesService);Ge.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ae),this.registerErrorHandler(Ge),this.reportProfilesInfo(ze,Ke),this._register(Ke.onDidChangeProfiles(()=>this.reportProfilesInfo(ze,Ke)))}),this._register((0,O.combinedDisposable)(Ce.createInstance(v.CodeCacheCleaner,this.configuration.codeCachePath),Ce.createInstance(c.LanguagePackCachedDataCleaner),Ce.createInstance(y.UnusedWorkspaceStorageDataCleaner),Ce.createInstance(E.LogsDataCleaner),Ce.createInstance(m.LocalizationsUpdater),Ce.createInstance(wt.ExtensionsContributions),Ce.createInstance(Ze.UserDataProfilesCleaner)))}async initServices(){const Ce=new G.ServiceCollection,Ae={_serviceBrand:void 0,...z.default};Ce.set(ee.IProductService,Ae);const Ge=new P.StaticRouter(Ve=>Ve==="main"),ze=new ft.MainProcessService(this.server,Ge);Ce.set(ft.IMainProcessService,ze);const Ke=this.configuration.policiesData?new Ne.PolicyChannelClient(this.configuration.policiesData,ze.getChannel("policy")):new qe.NullPolicyService;Ce.set(qe.IPolicyService,Ke);const Be=new Ot.NativeEnvironmentService(this.configuration.args,Ae);Ce.set(i.INativeEnvironmentService,Be);const Xe=new B.LoggerChannelClient(void 0,this.configuration.logLevel,Be.logsHome,this.configuration.loggers.map(Ve=>({...Ve,resource:R.URI.revive(Ve.resource)})),ze.getChannel("logger"));Ce.set(Y.ILoggerService,Xe);const st=this._register(Xe.createLogger("sharedprocess",{name:(0,Ct.localize)(0,null)})),ct=this._register(new Y.ConsoleLogger(st.getLevel())),He=this._register(new bt.LogService(st,[ct]));Ce.set(Y.ILogService,He),this.lifecycleService=this._register(new dt.SharedProcessLifecycleService(He)),Ce.set(dt.ISharedProcessLifecycleService,this.lifecycleService);const Ye=this._register(new N.FileService(He));Ce.set(_.IFileService,Ye);const lt=this._register(new $.DiskFileSystemProvider(He));Ye.registerProvider(L.Schemas.file,lt);const rt=new se.UriIdentityService(Ye);Ce.set(Fe.IUriIdentityService,rt);const Je=this._register(new je.UserDataProfilesService(this.configuration.profiles.all,R.URI.revive(this.configuration.profiles.home).with({scheme:Be.userRoamingDataHome.scheme}),ze.getChannel("userDataProfiles")));Ce.set(_e.IUserDataProfilesService,Je);const ut=this._register(new Se.FileUserDataProvider(L.Schemas.file,this._register(new Ee.DiskFileSystemProviderClient(ze.getChannel(Ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:de.isLinux})),L.Schemas.vscodeUserData,Je,rt,He));Ye.registerProvider(L.Schemas.vscodeUserData,ut);const Qe=this._register(new f.ConfigurationService(Je.defaultProfile.settingsResource,Ye,Ke,He));Ce.set(h.IConfigurationService,Qe);const et=new Tt.RemoteStorageService(void 0,{defaultProfile:Je.defaultProfile,currentProfile:Je.defaultProfile},ze,Be);Ce.set(Z.IStorageService,et),this._register((0,O.toDisposable)(()=>et.flush())),await Promise.all([Qe.initialize(),et.initialize()]);const St=new Dt.RequestChannelClient(ze.getChannel("request"));Ce.set(ie.IRequestService,St),Ce.set(u.IChecksumService,new W.SyncDescriptor(d.ChecksumService,void 0,!1)),Ce.set(Re.IV8InspectProfilingService,new W.SyncDescriptor(be.InspectProfilingService,void 0,!1));const vt=P.ProxyChannel.toService(ze.getChannel("nativeHost"));Ce.set(Lt.INativeHostService,vt),Ce.set(o.IDownloadService,new W.SyncDescriptor(n.DownloadService,void 0,!0));const Nt=this._register(new ge.ActiveWindowManager(vt)),Ft=new P.StaticRouter(Ve=>Nt.getActiveClientId().then(at=>Ve===at));Ce.set(S.IExtensionRecommendationNotificationService,new Rt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ft)));let ot;const tt=[],pt=(0,M.isInternalTelemetry)(Ae,Qe);if((0,M.supportsTelemetry)(Ae,Be)){const Ve=new D.TelemetryLogAppender(He,Xe,Be,Ae);if(tt.push(Ve),!(0,M.isLoggingOnly)(Ae,Be)&&Ae.aiConfig?.ariaKey){const at=new xe.OneDataSystemAppender(St,pt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this._register((0,O.toDisposable)(()=>at.flush())),tt.push(at)}ot=new T.TelemetryService({appenders:tt,commonProperties:(0,ne.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,Ae.commit,Ae.version,this.configuration.machineId,this.configuration.sqmId,pt),sendErrorTelemetry:!0,piiPaths:(0,M.getPiiPathsFromEnvironment)(Be)},Qe,Ae)}else{ot=M.NullTelemetryService;const Ve=M.NullAppender;tt.push(Ve)}this.server.registerChannel("telemetryAppender",new j.TelemetryAppenderChannel(tt)),Ce.set(K.ITelemetryService,ot);const Mt=new F.CustomEndpointTelemetryService(Qe,ot,He,Xe,Be,Ae);Ce.set(K.ICustomEndpointTelemetryService,Mt),Ce.set(Oe.IExtensionsProfileScannerService,new W.SyncDescriptor(Pt.ExtensionsProfileScannerService,void 0,!0)),Ce.set(Pe.IExtensionsScannerService,new W.SyncDescriptor(ke.ExtensionsScannerService,void 0,!0)),Ce.set(w.IExtensionSignatureVerificationService,new W.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),Ce.set(l.INativeServerExtensionManagementService,new W.SyncDescriptor(l.ExtensionManagementService,void 0,!0)),Ce.set(a.IExtensionGalleryService,new W.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),Ce.set(a.IExtensionTipsService,new W.SyncDescriptor(_t.ExtensionTipsService,void 0,!1)),Ce.set(X.ILanguagePackService,new W.SyncDescriptor(x.NativeLanguagePackService,void 0,!1)),Ce.set(C.IDiagnosticsService,new W.SyncDescriptor(s.DiagnosticsService,void 0,!1)),Ce.set(ce.IUserDataSyncAccountService,new W.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),Ce.set(re.IUserDataSyncLogService,new W.SyncDescriptor(me.UserDataSyncLogService,void 0,!0)),Ce.set(re.IUserDataSyncUtilService,new ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),Ce.set(a.IGlobalExtensionEnablementService,new W.SyncDescriptor(t.GlobalExtensionEnablementService,void 0,!1)),Ce.set(H.IIgnoredExtensionsManagementService,new W.SyncDescriptor(H.IgnoredExtensionsManagementService,void 0,!0)),Ce.set(V.IExtensionStorageService,new W.SyncDescriptor(V.ExtensionStorageService)),Ce.set(re.IUserDataSyncStoreManagementService,new W.SyncDescriptor(Ue.UserDataSyncStoreManagementService,void 0,!0)),Ce.set(re.IUserDataSyncStoreService,new W.SyncDescriptor(Ue.UserDataSyncStoreService,void 0,!0)),Ce.set(fe.IUserDataSyncMachinesService,new W.SyncDescriptor(fe.UserDataSyncMachinesService,void 0,!0)),Ce.set(re.IUserDataSyncLocalStoreService,new W.SyncDescriptor(he.UserDataSyncLocalStoreService,void 0,!1)),Ce.set(re.IUserDataSyncEnablementService,new W.SyncDescriptor(pe.UserDataSyncEnablementService,void 0,!0)),Ce.set(re.IUserDataSyncService,new W.SyncDescriptor(we.UserDataSyncService,void 0,!1)),Ce.set(Me.IUserDataProfileStorageService,new W.SyncDescriptor(le.NativeUserDataProfileStorageService,void 0,!0)),Ce.set(re.IUserDataSyncResourceProviderService,new W.SyncDescriptor(Et.UserDataSyncResourceProviderService,void 0,!0)),Ce.set(ve.ISignService,new W.SyncDescriptor(Ie.SignService,void 0,!1));const yt=new gt.RemoteSocketFactoryService;return Ce.set(gt.IRemoteSocketFactoryService,yt),yt.register(0,At.nodeSocketFactory),Ce.set(De.ISharedTunnelsService,new W.SyncDescriptor($e.SharedTunnelsService)),Ce.set(Te.ISharedProcessTunnelService,new W.SyncDescriptor(We.SharedProcessTunnelService)),Ce.set(ht.IRemoteTunnelService,new W.SyncDescriptor(It.RemoteTunnelService)),new Q.InstantiationService(Ce)}initChannels(Ce){const Ae=this._register(new O.DisposableStore),Ge=new p.ExtensionManagementChannel(Ce.get(a.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ge);const ze=P.ProxyChannel.fromService(Ce.get(X.ILanguagePackService),Ae);this.server.registerChannel("languagePacks",ze);const Ke=P.ProxyChannel.fromService(Ce.get(C.IDiagnosticsService),Ae);this.server.registerChannel("diagnostics",Ke);const Be=new p.ExtensionTipsChannel(Ce.get(a.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Be);const Xe=P.ProxyChannel.fromService(Ce.get(u.IChecksumService),Ae);this.server.registerChannel("checksum",Xe);const st=P.ProxyChannel.fromService(Ce.get(Re.IV8InspectProfilingService),Ae);this.server.registerChannel("v8InspectProfiling",st);const ct=new ue.UserDataSyncMachinesServiceChannel(Ce.get(fe.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const He=P.ProxyChannel.fromService(Ce.get(K.ICustomEndpointTelemetryService),Ae);this.server.registerChannel("customEndpointTelemetry",He);const Ye=new ue.UserDataSyncAccountServiceChannel(Ce.get(ce.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ye);const lt=new ue.UserDataSyncStoreManagementServiceChannel(Ce.get(re.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",lt);const rt=new Le.UserDataSyncChannel(Ce.get(re.IUserDataSyncService),Ce.get(_e.IUserDataProfilesService),Ce.get(Y.ILogService));this.server.registerChannel("userDataSync",rt);const Je=this._register(Ce.get(q.IInstantiationService).createInstance(kt.UserDataAutoSyncService)),ut=new ue.UserDataAutoSyncChannel(Je);this.server.registerChannel("userDataAutoSync",ut),this.server.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Ce.get(re.IUserDataSyncResourceProviderService),Ae));const Qe=P.ProxyChannel.fromService(Ce.get(Te.ISharedProcessTunnelService),Ae);this.server.registerChannel(Te.ipcSharedProcessTunnelChannelName,Qe);const et=P.ProxyChannel.fromService(Ce.get(ht.IRemoteTunnelService),Ae);this.server.registerChannel("remoteTunnel",et)}registerErrorHandler(Ce){process.on("uncaughtException",Ae=>(0,A.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,A.onUnexpectedError)(Ae)),(0,A.setUnexpectedErrorHandler)(Ae=>{const Ge=(0,U.toErrorMessage)(Ae,!0);Ge&&Ce.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}reportProfilesInfo(Ce,Ae){Ce.publicLog2("profilesInfo",{count:Ae.profiles.length})}handledClientConnection(Ce){if(Ce.data!==it.SharedProcessRawConnection.response)return!1;const Ae=(0,I.firstOrDefault)(Ce.ports);return Ae?(this.onDidWindowConnectRaw.fire(Ae),!0):!1}}async function mt(nt){const Ce=new Ut(nt);process.parentPort.postMessage(it.SharedProcessLifecycle.ipcReady),await Ce.init(),process.parentPort.postMessage(it.SharedProcessLifecycle.initDone)}e.main=mt,process.parentPort.once("message",nt=>{mt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dd29bdcb71634f9cd7c1792bb2bdfde5b18ee8e8/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
