/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/base/common/stopwatch","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(pe){for(var e=[],I=0,O=pe.length;I<O;I++)e[I]=De[pe[I]];return e};define(De[156],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class I{static get(){const f=new Map,A=new Map,T=new Map,g=new Map;function y(S,_){S.has(_.detail)||S.set(_.detail,-_.timestamp)}function v(S,_){const w=S.get(_.detail);w&&(w>=0||S.set(_.detail,w+_.timestamp))}let R=[];typeof pe=="function"&&typeof pe.getStats=="function"&&(R=pe.getStats().slice(0).sort((S,_)=>S.timestamp-_.timestamp));for(const S of R)switch(S.type){case 10:y(f,S);break;case 11:case 12:v(f,S);break;case 21:y(A,S);break;case 22:v(A,S);break;case 33:y(T,S);break;case 34:v(T,S);break;case 31:y(g,S);break;case 32:v(g,S);break}let P=0;T.forEach(S=>P+=S);function E(S){const _=[];return S.forEach((w,d)=>_.push([d,w])),_}return{amdLoad:E(f),amdInvoke:E(A),nodeRequire:E(T),nodeEval:E(g),nodeRequireTotal:P}}static toMarkdownTable(f,A){let T="";const g=[];return f.forEach((y,v)=>{g[v]=y.length}),A.forEach(y=>{y.forEach((v,R)=>{typeof v>"u"&&(v=y[R]="-");const P=v.toString().length;g[R]=Math.max(P,g[R])})}),f.forEach((y,v)=>{T+=`| ${y+" ".repeat(g[v]-y.toString().length)} `}),T+=`|
`,f.forEach((y,v)=>{T+=`| ${"-".repeat(g[v])} `}),T+=`|
`,A.forEach(y=>{y.forEach((v,R)=>{typeof v<"u"&&(T+=`| ${v+" ".repeat(g[R]-v.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=I}),define(De[118],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function I(w,d,o){const u=O(w,d);if(u!==-1)return w[u]}e.findLast=I;function O(w,d,o=w.length-1){for(let u=o;u>=0;u--){const c=w[u];if(d(c))return u}return-1}e.findLastIdx=O;function f(w,d){const o=A(w,d);return o===-1?void 0:w[o]}e.findLastMonotonous=f;function A(w,d,o=0,u=w.length){let c=o,h=u;for(;c<h;){const a=Math.floor((c+h)/2);d(w[a])?c=a+1:h=a}return c-1}e.findLastIdxMonotonous=A;function T(w,d){const o=g(w,d);return o===w.length?void 0:w[o]}e.findFirstMonotonous=T;function g(w,d,o=0,u=w.length){let c=o,h=u;for(;c<h;){const a=Math.floor((c+h)/2);d(w[a])?h=a:c=a+1}return c}e.findFirstIdxMonotonousOrArrLen=g;function y(w,d,o=0,u=w.length){const c=g(w,d,o,u);return c===w.length?-1:c}e.findFirstIdxMonotonous=y;class v{static{this.assertInvariants=!1}constructor(d){this._array=d,this._findLastMonotonousLastIdx=0}findLastMonotonous(d){if(v.assertInvariants){if(this._prevFindLastPredicate){for(const u of this._array)if(this._prevFindLastPredicate(u)&&!d(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=d}const o=A(this._array,d,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=o+1,o===-1?void 0:this._array[o]}}e.MonotonousArray=v;function R(w,d){if(w.length===0)return;let o=w[0];for(let u=1;u<w.length;u++){const c=w[u];d(c,o)>0&&(o=c)}return o}e.findFirstMaxBy=R;function P(w,d){if(w.length===0)return;let o=w[0];for(let u=1;u<w.length;u++){const c=w[u];d(c,o)>=0&&(o=c)}return o}e.findLastMaxBy=P;function E(w,d){return R(w,(o,u)=>-d(o,u))}e.findFirstMinBy=E;function S(w,d){if(w.length===0)return-1;let o=0;for(let u=1;u<w.length;u++){const c=w[u];d(c,w[o])>0&&(o=u)}return o}e.findMaxIdxBy=S;function _(w,d){for(const o of w){const u=d(o);if(u!==void 0)return u}}e.mapFindFirst=_}),define(De[74],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function I(T,g){const y=Object.create(null);for(const v of T){const R=g(v);let P=y[R];P||(P=y[R]=[]),P.push(v)}return y}e.groupBy=I;function O(T,g){const y=[],v=[];for(const R of T)g.has(R)||y.push(R);for(const R of g)T.has(R)||v.push(R);return{removed:y,added:v}}e.diffSets=O;function f(T,g){const y=[],v=[];for(const[R,P]of T)g.has(R)||y.push(P);for(const[R,P]of g)T.has(R)||v.push(P);return{removed:y,added:v}}e.diffMaps=f;function A(T,g){const y=new Set;for(const v of g)T.has(v)&&y.add(v);return y}e.intersection=A}),define(De[57],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(T){return(g,y,v)=>{let R=null,P=null;if(typeof v.value=="function"?(R="value",P=v.value):typeof v.get=="function"&&(R="get",P=v.get),!P)throw new Error("not supported");v[R]=T(P,y)}}function O(T,g,y){let v=null,R=null;if(typeof y.value=="function"?(v="value",R=y.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(v="get",R=y.get),!R)throw new Error("not supported");const P=`$memoize$${g}`;y[v]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,E)}),this[P]}}e.memoize=O;function f(T,g,y){return I((v,R)=>{const P=`$debounce$${R}`,E=`$debounce$result$${R}`;return function(...S){this[E]||(this[E]=y?y():void 0),clearTimeout(this[P]),g&&(this[E]=g(this[E],...S),S=[this[E]]),this[P]=setTimeout(()=>{v.apply(this,S),this[E]=y?y():void 0},T)}})}e.debounce=f;function A(T,g,y){return I((v,R)=>{const P=`$throttle$timer$${R}`,E=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,_=`$throttle$pending$${R}`;return function(...w){if(this[E]||(this[E]=y?y():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),g&&(this[E]=g(this[E],...w)),this[_])return;const d=this[S]+T;d<=Date.now()?(this[S]=Date.now(),v.apply(this,[this[E]]),this[E]=y?y():void 0):(this[_]=!0,this[P]=setTimeout(()=>{this[_]=!1,this[S]=Date.now(),v.apply(this,[this[E]]),this[E]=y?y():void 0},d-Date.now()))}})}e.throttle=A}),define(De[9],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=I,e.errorHandler=new I;function O(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=O;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=f;function A(a){v(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=A;function T(a){v(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=T;function g(a){if(a instanceof Error){const{name:t,message:i}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:i,stack:s,noTelemetry:c.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=g;const y="Canceled";function v(a){return a instanceof R?!0:a instanceof Error&&a.name===y&&a.message===y}e.isCancellationError=v;class R extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=R;function P(){const a=new Error(y);return a.name=a.message,a}e.canceled=P;function E(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=E;function S(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=S;class _ extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=_;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=w;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=d;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=o;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=u;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const i=new c;return i.message=t.message,i.stack=t.stack,i}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class h extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}e.BugIndicatingError=h}),define(De[19],Ie([1,0,9,118]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function f(Q,Z=0){return Q[Q.length-(1+Z)]}e.tail=f;function A(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}e.tail2=A;function T(Q,Z,J=(be,ae)=>be===ae){if(Q===Z)return!0;if(!Q||!Z||Q.length!==Z.length)return!1;for(let be=0,ae=Q.length;be<ae;be++)if(!J(Q[be],Z[be]))return!1;return!0}e.equals=T;function g(Q,Z){const J=Q.length-1;Z<J&&(Q[Z]=Q[J]),Q.pop()}e.removeFastWithoutKeepingOrder=g;function y(Q,Z,J){return v(Q.length,be=>J(Q[be],Z))}e.binarySearch=y;function v(Q,Z){let J=0,be=Q-1;for(;J<=be;){const ae=(J+be)/2|0,fe=Z(ae);if(fe<0)J=ae+1;else if(fe>0)be=ae-1;else return ae}return-(J+1)}e.binarySearch2=v;function R(Q,Z,J){if(Q=Q|0,Q>=Z.length)throw new TypeError("invalid index");const be=Z[Math.floor(Z.length*Math.random())],ae=[],fe=[],ee=[];for(const he of Z){const ve=J(he,be);ve<0?ae.push(he):ve>0?fe.push(he):ee.push(he)}return Q<ae.length?R(Q,ae,J):Q<ae.length+ee.length?ee[0]:R(Q-(ae.length+ee.length),fe,J)}e.quickSelect=R;function P(Q,Z){const J=[];let be;for(const ae of Q.slice(0).sort(Z))!be||Z(be[0],ae)!==0?(be=[ae],J.push(be)):be.push(ae);return J}e.groupBy=P;function*E(Q,Z){let J,be;for(const ae of Q)be!==void 0&&Z(be,ae)?J.push(ae):(J&&(yield J),J=[ae]),be=ae;J&&(yield J)}e.groupAdjacentBy=E;function S(Q,Z){for(let J=0;J<=Q.length;J++)Z(J===0?void 0:Q[J-1],J===Q.length?void 0:Q[J])}e.forEachAdjacent=S;function _(Q,Z){for(let J=0;J<Q.length;J++)Z(J===0?void 0:Q[J-1],Q[J],J+1===Q.length?void 0:Q[J+1])}e.forEachWithNeighbors=_;function w(Q,Z,J){const be=[];function ae(he,ve,Pe){if(ve===0&&Pe.length===0)return;const B=be[be.length-1];B&&B.start+B.deleteCount===he?(B.deleteCount+=ve,B.toInsert.push(...Pe)):be.push({start:he,deleteCount:ve,toInsert:Pe})}let fe=0,ee=0;for(;;){if(fe===Q.length){ae(fe,0,Z.slice(ee));break}if(ee===Z.length){ae(fe,Q.length-fe,[]);break}const he=Q[fe],ve=Z[ee],Pe=J(he,ve);Pe===0?(fe+=1,ee+=1):Pe<0?(ae(fe,1,[]),fe+=1):Pe>0&&(ae(fe,0,[ve]),ee+=1)}return be}e.sortedDiff=w;function d(Q,Z,J){const be=w(Q,Z,J),ae=[],fe=[];for(const ee of be)ae.push(...Q.slice(ee.start,ee.start+ee.deleteCount)),fe.push(...ee.toInsert);return{removed:ae,added:fe}}e.delta=d;function o(Q,Z,J){if(J===0)return[];const be=Q.slice(0,J).sort(Z);return c(Q,Z,be,J,Q.length),be}e.top=o;function u(Q,Z,J,be,ae){return J===0?Promise.resolve([]):new Promise((fe,ee)=>{(async()=>{const he=Q.length,ve=Q.slice(0,J).sort(Z);for(let Pe=J,B=Math.min(J+be,he);Pe<he;Pe=B,B=Math.min(B+be,he)){if(Pe>J&&await new Promise(G=>setTimeout(G)),ae&&ae.isCancellationRequested)throw new I.CancellationError;c(Q,Z,ve,Pe,B)}return ve})().then(fe,ee)})}e.topAsync=u;function c(Q,Z,J,be,ae){for(const fe=J.length;be<ae;be++){const ee=Q[be];if(Z(ee,J[fe-1])<0){J.pop();const he=(0,O.findFirstIdxMonotonousOrArrLen)(J,ve=>Z(ee,ve)<0);J.splice(he,0,ee)}}}function h(Q){return Q.filter(Z=>!!Z)}e.coalesce=h;function a(Q){let Z=0;for(let J=0;J<Q.length;J++)Q[J]&&(Q[Z]=Q[J],Z+=1);Q.length=Z}e.coalesceInPlace=a;function t(Q,Z,J){Q.splice(J,0,Q.splice(Z,1)[0])}e.move=t;function i(Q){return!Array.isArray(Q)||Q.length===0}e.isFalsyOrEmpty=i;function s(Q){return Array.isArray(Q)&&Q.length>0}e.isNonEmptyArray=s;function n(Q,Z=J=>J){const J=new Set;return Q.filter(be=>{const ae=Z(be);return J.has(ae)?!1:(J.add(ae),!0)})}e.distinct=n;function r(Q){const Z=new Set;return J=>{const be=Q(J);return Z.has(be)?!1:(Z.add(be),!0)}}e.uniqueFilter=r;function l(Q,Z){return Q.length>0?Q[0]:Z}e.firstOrDefault=l;function k(Q,Z){return Q.length>0?Q[Q.length-1]:Z}e.lastOrDefault=k;function C(Q,Z,J=(be,ae)=>be===ae){let be=0;for(let ae=0,fe=Math.min(Q.length,Z.length);ae<fe&&J(Q[ae],Z[ae]);ae++)be++;return be}e.commonPrefixLength=C;function p(Q){return[].concat(...Q)}e.flatten=p;function m(Q,Z){let J=typeof Z=="number"?Q:0;typeof Z=="number"?J=Q:(J=0,Z=Q);const be=[];if(J<=Z)for(let ae=J;ae<Z;ae++)be.push(ae);else for(let ae=J;ae>Z;ae--)be.push(ae);return be}e.range=m;function b(Q,Z,J){return Q.reduce((be,ae)=>(be[Z(ae)]=J?J(ae):ae,be),Object.create(null))}e.index=b;function D(Q,Z){return Q.push(Z),()=>M(Q,Z)}e.insert=D;function M(Q,Z){const J=Q.indexOf(Z);if(J>-1)return Q.splice(J,1),Z}e.remove=M;function L(Q,Z,J){const be=Q.slice(0,Z),ae=Q.slice(Z);return be.concat(J,ae)}e.arrayInsert=L;function F(Q,Z){let J;if(typeof Z=="number"){let be=Z;J=()=>{const ae=Math.sin(be++)*179426549;return ae-Math.floor(ae)}}else J=Math.random;for(let be=Q.length-1;be>0;be-=1){const ae=Math.floor(J()*(be+1)),fe=Q[be];Q[be]=Q[ae],Q[ae]=fe}}e.shuffle=F;function x(Q,Z){const J=Q.indexOf(Z);J>-1&&(Q.splice(J,1),Q.unshift(Z))}e.pushToStart=x;function U(Q,Z){const J=Q.indexOf(Z);J>-1&&(Q.splice(J,1),Q.push(Z))}e.pushToEnd=U;function N(Q,Z){for(const J of Z)Q.push(J)}e.pushMany=N;function z(Q,Z){return Array.isArray(Q)?Q.map(Z):Z(Q)}e.mapArrayOrNot=z;function V(Q){return Array.isArray(Q)?Q:[Q]}e.asArray=V;function ge(Q){return Q[Math.floor(Math.random()*Q.length)]}e.getRandomElement=ge;function te(Q,Z,J){const be=K(Q,Z),ae=Q.length,fe=J.length;Q.length=ae+fe;for(let ee=ae-1;ee>=be;ee--)Q[ee+fe]=Q[ee];for(let ee=0;ee<fe;ee++)Q[ee+be]=J[ee]}e.insertInto=te;function q(Q,Z,J,be){const ae=K(Q,Z);let fe=Q.splice(ae,J);return fe===void 0&&(fe=[]),te(Q,ae,be),fe}e.splice=q;function K(Q,Z){return Z<0?Math.max(Z+Q.length,0):Math.min(Z,Q.length)}var ue;(function(Q){function Z(fe){return fe<0}Q.isLessThan=Z;function J(fe){return fe<=0}Q.isLessThanOrEqual=J;function be(fe){return fe>0}Q.isGreaterThan=be;function ae(fe){return fe===0}Q.isNeitherLessOrGreaterThan=ae,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function ie(Q,Z){return(J,be)=>Z(Q(J),Q(be))}e.compareBy=ie;function ce(...Q){return(Z,J)=>{for(const be of Q){const ae=be(Z,J);if(!ue.isNeitherLessOrGreaterThan(ae))return ae}return ue.neitherLessOrGreaterThan}}e.tieBreakComparators=ce;const Se=(Q,Z)=>Q-Z;e.numberComparator=Se;const j=(Q,Z)=>(0,e.numberComparator)(Q?1:0,Z?1:0);e.booleanComparator=j;function $(Q){return(Z,J)=>-Q(Z,J)}e.reverseOrder=$;class X{constructor(Z){this.items=Z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Z){let J=this.firstIdx;for(;J<this.items.length&&Z(this.items[J]);)J++;const be=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,be}takeFromEndWhile(Z){let J=this.lastIdx;for(;J>=0&&Z(this.items[J]);)J--;const be=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,be}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Z=this.items[this.firstIdx];return this.firstIdx++,Z}removeLast(){const Z=this.items[this.lastIdx];return this.lastIdx--,Z}takeCount(Z){const J=this.items.slice(this.firstIdx,this.firstIdx+Z);return this.firstIdx+=Z,J}}e.ArrayQueue=X;class re{static{this.empty=new re(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(J=>(Z(J),!0))}toArray(){const Z=[];return this.iterate(J=>(Z.push(J),!0)),Z}filter(Z){return new re(J=>this.iterate(be=>Z(be)?J(be):!0))}map(Z){return new re(J=>this.iterate(be=>J(Z(be))))}some(Z){let J=!1;return this.iterate(be=>(J=Z(be),!J)),J}findFirst(Z){let J;return this.iterate(be=>Z(be)?(J=be,!1):!0),J}findLast(Z){let J;return this.iterate(be=>(Z(be)&&(J=be),!0)),J}findLastMaxBy(Z){let J,be=!0;return this.iterate(ae=>((be||ue.isGreaterThan(Z(ae,J)))&&(be=!1,J=ae),!0)),J}}e.CallbackIterable=re}),define(De[58],Ie([1,0,9]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(y,v){if(!y)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=O;function f(y,v="Unreachable"){throw new Error(v)}e.assertNever=f;function A(y){if(!y)throw new I.BugIndicatingError("Assertion Failed")}e.assert=A;function T(y){if(!y()){debugger;y(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function g(y,v){let R=0;for(;R<y.length-1;){const P=y[R],E=y[R+1];if(!v(P,E))return!1;R++}return!0}e.checkAdjacentItems=g}),define(De[75],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function I(O){const f=this;let A=!1,T;return function(){return A||(A=!0,T=O.apply(f,arguments)),T}}e.createSingleCallFunction=I}),define(De[119],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class I{constructor(f){this._prefix=f,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=I,e.defaultGenerator=new I("id#")}),define(De[51],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(O){function f(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}O.is=f;const A=Object.freeze([]);function T(){return A}O.empty=T;function*g(a){yield a}O.single=g;function y(a){return f(a)?a:g(a)}O.wrap=y;function v(a){return a||A}O.from=v;function*R(a){for(let t=a.length-1;t>=0;t--)yield a[t]}O.reverse=R;function P(a){return!a||a[Symbol.iterator]().next().done===!0}O.isEmpty=P;function E(a){return a[Symbol.iterator]().next().value}O.first=E;function S(a,t){for(const i of a)if(t(i))return!0;return!1}O.some=S;function _(a,t){for(const i of a)if(t(i))return i}O.find=_;function*w(a,t){for(const i of a)t(i)&&(yield i)}O.filter=w;function*d(a,t){let i=0;for(const s of a)yield t(s,i++)}O.map=d;function*o(...a){for(const t of a)for(const i of t)yield i}O.concat=o;function u(a,t,i){let s=i;for(const n of a)s=t(s,n);return s}O.reduce=u;function*c(a,t,i=a.length){for(t<0&&(t+=a.length),i<0?i+=a.length:i>a.length&&(i=a.length);t<i;t++)yield a[t]}O.slice=c;function h(a,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,a];const s=a[Symbol.iterator]();for(let n=0;n<t;n++){const r=s.next();if(r.done)return[i,O.empty()];i.push(r.value)}return[i,{[Symbol.iterator](){return s}}]}O.consume=h})(I||(e.Iterable=I={}))}),define(De[157],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(t,i=!1){let s=0;const n=t.length;let r="",l=0,k=16,C=0;function p(x){let U=0,N=0;for(;U<x;){const z=t.charCodeAt(s);if(z>=48&&z<=57)N=N*16+z-48;else if(z>=65&&z<=70)N=N*16+z-65+10;else if(z>=97&&z<=102)N=N*16+z-97+10;else break;s++,U++}return U<x&&(N=-1),N}function m(x){s=x,r="",l=0,k=16,C=0}function b(){const x=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&v(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&v(t.charCodeAt(s)))for(s++;s<t.length&&v(t.charCodeAt(s));)s++;else return C=3,t.substring(x,s);let U=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&v(t.charCodeAt(s))){for(s++;s<t.length&&v(t.charCodeAt(s));)s++;U=s}else C=3;return t.substring(x,U)}function D(){let x="",U=s;for(;;){if(s>=n){x+=t.substring(U,s),C=2;break}const N=t.charCodeAt(s);if(N===34){x+=t.substring(U,s),s++;break}if(N===92){if(x+=t.substring(U,s),s++,s>=n){C=2;break}switch(t.charCodeAt(s++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const V=p(4);V>=0?x+=String.fromCharCode(V):C=4;break}default:C=5}U=s;continue}if(N>=0&&N<=31)if(y(N)){x+=t.substring(U,s),C=2;break}else C=6;s++}return x}function M(){if(r="",C=0,l=s,s>=n)return l=n,k=17;let x=t.charCodeAt(s);if(g(x)){do s++,r+=String.fromCharCode(x),x=t.charCodeAt(s);while(g(x));return k=15}if(y(x))return s++,r+=String.fromCharCode(x),x===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),k=14;switch(x){case 123:return s++,k=1;case 125:return s++,k=2;case 91:return s++,k=3;case 93:return s++,k=4;case 58:return s++,k=6;case 44:return s++,k=5;case 34:return s++,r=D(),k=10;case 47:{const U=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!y(t.charCodeAt(s));)s++;return r=t.substring(U,s),k=12}if(t.charCodeAt(s+1)===42){s+=2;const N=n-1;let z=!1;for(;s<N;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,C=1),r=t.substring(U,s),k=13}return r+=String.fromCharCode(x),s++,k=16}case 45:if(r+=String.fromCharCode(x),s++,s===n||!v(t.charCodeAt(s)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=b(),k=11;default:for(;s<n&&L(x);)s++,x=t.charCodeAt(s);if(l!==s){switch(r=t.substring(l,s),r){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return r+=String.fromCharCode(x),s++,k=16}}function L(x){if(g(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let x;do x=M();while(x>=12&&x<=15);return x}return{setPosition:m,getPosition:()=>s,scan:i?F:M,getToken:()=>k,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>C}}e.createScanner=T;function g(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function P(t,i){const s=[],n=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function C(p,m,b,D){l.value=p,l.offset=m,l.length=b,l.type=D,l.colonOffset=void 0,r=l}try{c(t,{onObjectBegin:(p,m)=>{if(i<=p)throw n;r=void 0,k=i>p,s.push("")},onObjectProperty:(p,m,b)=>{if(i<m||(C(p,m,b,"property"),s[s.length-1]=p,i<=m+b))throw n},onObjectEnd:(p,m)=>{if(i<=p)throw n;r=void 0,s.pop()},onArrayBegin:(p,m)=>{if(i<=p)throw n;r=void 0,s.push(0)},onArrayEnd:(p,m)=>{if(i<=p)throw n;r=void 0,s.pop()},onLiteralValue:(p,m,b)=>{if(i<m||(C(p,m,b,a(p)),i<=m+b))throw n},onSeparator:(p,m,b)=>{if(i<=m)throw n;if(p===":"&&r&&r.type==="property")r.colonOffset=m,k=!1,r=void 0;else if(p===","){const D=s[s.length-1];typeof D=="number"?s[s.length-1]=D+1:(k=!0,s[s.length-1]=""),r=void 0}}})}catch(p){if(p!==n)throw p}return{path:s,previousNode:r,isAtPropertyKey:k,matches:p=>{let m=0;for(let b=0;m<p.length&&b<s.length;b++)if(p[m]===s[b]||p[m]==="*")m++;else if(p[m]!=="**")return!1;return m===p.length}}}e.getLocation=P;function E(t,i=[],s=A.DEFAULT){let n=null,r=[];const l=[];function k(p){Array.isArray(r)?r.push(p):n!==null&&(r[n]=p)}return c(t,{onObjectBegin:()=>{const p={};k(p),l.push(r),r=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const p=[];k(p),l.push(r),r=p,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:k,onError:(p,m,b)=>{i.push({error:p,offset:m,length:b})}},s),r[0]}e.parse=E;function S(t,i=[],s=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function l(p){return n.children.push(p),p}c(t,{onObjectBegin:p=>{n=l({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,m,b)=>{n=l({type:"property",offset:m,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:m,length:b,parent:n})},onObjectEnd:(p,m)=>{n.length=p+m-n.offset,n=n.parent,r(p+m)},onArrayBegin:(p,m)=>{n=l({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,m)=>{n.length=p+m-n.offset,n=n.parent,r(p+m)},onLiteralValue:(p,m,b)=>{l({type:a(p),offset:m,length:b,parent:n,value:p}),r(m+b)},onSeparator:(p,m,b)=>{n.type==="property"&&(p===":"?n.colonOffset=m:p===","&&r(m))},onError:(p,m,b)=>{i.push({error:p,offset:m,length:b})}},s);const C=n.children[0];return C&&delete C.parent,C}e.parseTree=S;function _(t,i){if(!t)return;let s=t;for(const n of i)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===n){s=l.children[1],r=!0;break}if(!r)return}else{const r=n;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=_;function w(t){if(!t.parent||!t.parent.children)return[];const i=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=w;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const i=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(i[s.children[0].value]=d(n))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=d;function o(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=o;function u(t,i,s=!1){if(o(t,i,s)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=i;r++){const l=u(n[r],i,s);if(l)return l}return t}}e.findNodeAtOffset=u;function c(t,i,s=A.DEFAULT){const n=T(t,!1);function r(ie){return ie?()=>ie(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(ie){return ie?ce=>ie(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const k=r(i.onObjectBegin),C=l(i.onObjectProperty),p=r(i.onObjectEnd),m=r(i.onArrayBegin),b=r(i.onArrayEnd),D=l(i.onLiteralValue),M=l(i.onSeparator),L=r(i.onComment),F=l(i.onError),x=s&&s.disallowComments,U=s&&s.allowTrailingComma;function N(){for(;;){const ie=n.scan();switch(n.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:x||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ie){case 12:case 13:x?z(10):L();break;case 16:z(1);break;case 15:case 14:break;default:return ie}}}function z(ie,ce=[],Se=[]){if(F(ie),ce.length+Se.length>0){let j=n.getToken();for(;j!==17;){if(ce.indexOf(j)!==-1){N();break}else if(Se.indexOf(j)!==-1)break;j=N()}}}function V(ie){const ce=n.getTokenValue();return ie?D(ce):C(ce),N(),!0}function ge(){switch(n.getToken()){case 11:{let ie=0;try{ie=JSON.parse(n.getTokenValue()),typeof ie!="number"&&(z(2),ie=0)}catch{z(2)}D(ie);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return N(),!0}function te(){return n.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(M(":"),N(),ue()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function q(){k(),N();let ie=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ie||z(4,[],[]),M(","),N(),n.getToken()===2&&U)break}else ie&&z(6,[],[]);te()||z(4,[],[2,5]),ie=!0}return p(),n.getToken()!==2?z(7,[2],[]):N(),!0}function K(){m(),N();let ie=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ie||z(4,[],[]),M(","),N(),n.getToken()===4&&U)break}else ie&&z(6,[],[]);ue()||z(4,[],[4,5]),ie=!0}return b(),n.getToken()!==4?z(8,[4],[]):N(),!0}function ue(){switch(n.getToken()){case 3:return K();case 1:return q();case 10:return V(!0);default:return ge()}}return N(),n.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):ue()?(n.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=c;function h(t,i){const s=T(t),n=[];let r,l=0,k;do switch(k=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:l!==k&&n.push(t.substring(l,k)),i!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,i)),l=s.getPosition();break}while(r!==17);return n.join("")}e.stripComments=h;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(De[47],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(f){this.executor=f,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(f){this._error=f}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=I}),define(De[76],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{static{this.Undefined=new I(void 0)}constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}class O{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let A=this._first;for(;A!==I.Undefined;){const T=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=T}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const g=new I(A);if(this._first===I.Undefined)this._first=g,this._last=g;else if(T){const v=this._last;this._last=g,g.prev=v,v.next=g}else{const v=this._first;this._first=g,g.next=v,v.prev=g}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(g))}}shift(){if(this._first!==I.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==I.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===I.Undefined&&A.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):A.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):A.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.LinkedList=O}),define(De[28],Ie([1,0]),function(pe,e){"use strict";var I,O,f;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(u,c,h){let a=u.get(c);return a===void 0&&(a=h,u.set(c,a)),a}e.getOrSet=A;function T(u){const c=[];return u.forEach((h,a)=>{c.push(`${a} => ${h}`)}),`Map(${u.size}) {${c.join(", ")}}`}e.mapToString=T;function g(u){const c=[];return u.forEach(h=>{c.push(h)}),`Set(${u.size}) {${c.join(", ")}}`}e.setToString=g;class y{constructor(c,h){this.uri=c,this.value=h}}function v(u){return Array.isArray(u)}class R{static{this.defaultToKey=c=>c.toString()}constructor(c,h){if(this[I]="ResourceMap",c instanceof R)this.map=new Map(c.map),this.toKey=h??R.defaultToKey;else if(v(c)){this.map=new Map,this.toKey=h??R.defaultToKey;for(const[a,t]of c)this.set(a,t)}else this.map=new Map,this.toKey=c??R.defaultToKey}set(c,h){return this.map.set(this.toKey(c),new y(c,h)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,h){typeof h<"u"&&(c=c.bind(h));for(const[a,t]of this.map)c(t.value,t.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=R;class P{constructor(c,h){this[O]="ResourceSet",!c||typeof c=="function"?this._map=new R(c):(this._map=new R(h),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,h){this._map.forEach((a,t)=>c.call(h,t,t,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var E;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class S{constructor(){this[f]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,h=0){const a=this._map.get(c);if(a)return h!==0&&this.touch(a,h),a.value}set(c,h,a=0){let t=this._map.get(c);if(t)t.value=h,a!==0&&this.touch(t,a);else{switch(t={key:c,value:h,next:void 0,previous:void 0},a){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(c,t),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const h=this._map.get(c);if(h)return this._map.delete(c),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,h){const a=this._state;let t=this._head;for(;t;){if(h?c.bind(h)(t.value,t.key,this):c(t.value,t.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,h=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==h)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:a.key,done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}values(){const c=this,h=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==h)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:a.value,done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}entries(){const c=this,h=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(c._state!==h)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:[a.key,a.value],done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let h=this._head,a=this.size;for(;h&&a>c;)this._map.delete(h.key),h=h.next,a--;this._head=h,this._size=a,h&&(h.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const h=c.next,a=c.previous;if(!h||!a)throw new Error("Invalid list");h.previous=a,a.next=h}c.next=void 0,c.previous=void 0,this._state++}touch(c,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(c===this._head)return;const a=c.next,t=c.previous;c===this._tail?(t.next=void 0,this._tail=t):(a.previous=t,t.next=a),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(h===2){if(c===this._tail)return;const a=c.next,t=c.previous;c===this._head?(a.previous=void 0,this._head=a):(a.previous=t,t.next=a),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((h,a)=>{c.push([a,h])}),c}fromJSON(c){this.clear();for(const[h,a]of c)this.set(h,a)}}e.LinkedMap=S;class _ extends S{constructor(c,h=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,h=2){return super.get(c,h)}peek(c){return super.get(c,0)}set(c,h){return super.set(c,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_;class w{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let h=this.map.get(c)||0;return h===0?!1:(h--,h===0?this.map.delete(c):this.map.set(c,h),!0)}has(c){return this.map.has(c)}}e.CounterSet=w;class d{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[h,a]of c)this.set(h,a)}clear(){this._m1.clear(),this._m2.clear()}set(c,h){this._m1.set(c,h),this._m2.set(h,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const h=this._m1.get(c);return h===void 0?!1:(this._m1.delete(c),this._m2.delete(h),!0)}forEach(c,h){this._m1.forEach((a,t)=>{c.call(h,a,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=d;class o{constructor(){this.map=new Map}add(c,h){let a=this.map.get(c);a||(a=new Set,this.map.set(c,a)),a.add(h)}delete(c,h){const a=this.map.get(c);a&&(a.delete(h),a.size===0&&this.map.delete(c))}forEach(c,h){const a=this.map.get(c);a&&a.forEach(h)}get(c){const h=this.map.get(c);return h||new Set}}e.SetMap=o}),define(De[3],Ie([1,0,19,74,28,75,51]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const g=!1;let y=null;class v{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(b){let D=this.livingDisposables.get(b);return D||(D={parent:null,source:null,isSingleton:!1,value:b,idx:v.idx++},this.livingDisposables.set(b,D)),D}trackDisposable(b){const D=this.getDisposableData(b);D.source||(D.source=new Error().stack)}setParent(b,D){const M=this.getDisposableData(b);M.parent=D}markAsDisposed(b){this.livingDisposables.delete(b)}markAsSingleton(b){this.getDisposableData(b).isSingleton=!0}getRootParent(b,D){const M=D.get(b);if(M)return M;const L=b.parent?this.getRootParent(this.getDisposableData(b.parent),D):b;return D.set(b,L),L}getTrackedDisposables(){const b=new Map;return[...this.livingDisposables.entries()].filter(([,M])=>M.source!==null&&!this.getRootParent(M,b).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(b=10,D){let M;if(D)M=D;else{const N=new Map,z=[...this.livingDisposables.values()].filter(ge=>ge.source!==null&&!this.getRootParent(ge,N).isSingleton);if(z.length===0)return;const V=new Set(z.map(ge=>ge.value));if(M=z.filter(ge=>!(ge.parent&&V.has(ge.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function L(N){function z(ge,te){for(;ge.length>0&&te.some(q=>typeof q=="string"?q===ge[0]:ge[0].match(q));)ge.shift()}const V=N.source.split(`
`).map(ge=>ge.trim().replace("at ","")).filter(ge=>ge!=="");return z(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const F=new f.SetMap;for(const N of M){const z=L(N);for(let V=0;V<=z.length;V++)F.add(z.slice(0,V).join(`
`),N)}M.sort((0,I.compareBy)(N=>N.idx,I.numberComparator));let x="",U=0;for(const N of M.slice(0,b)){U++;const z=L(N),V=[];for(let ge=0;ge<z.length;ge++){let te=z[ge];te=`(shared with ${F.get(z.slice(0,ge+1).join(`
`)).size}/${M.length} leaks) at ${te}`;const K=F.get(z.slice(0,ge).join(`
`)),ue=(0,O.groupBy)([...K].map(ie=>L(ie)[ge]),ie=>ie);delete ue[z[ge]];for(const[ie,ce]of Object.entries(ue))V.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${ie}`);V.unshift(te)}x+=`


==================== Leaking disposable ${U}/${M.length}: ${N.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return M.length>b&&(x+=`


... and ${M.length-b} more leaking disposables

`),{leaks:M,details:x}}}e.DisposableTracker=v;function R(m){y=m}if(e.setDisposableTracker=R,g){const m="__is_disposable_tracked__";R(new class{trackDisposable(b){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[m]||console.log(D)},3e3)}setParent(b,D){if(b&&b!==t.None)try{b[m]=!0}catch{}}markAsDisposed(b){if(b&&b!==t.None)try{b[m]=!0}catch{}}markAsSingleton(b){}})}function P(m){return y?.trackDisposable(m),m}e.trackDisposable=P;function E(m){y?.markAsDisposed(m)}e.markAsDisposed=E;function S(m,b){y?.setParent(m,b)}function _(m,b){if(y)for(const D of m)y.setParent(D,b)}function w(m){return y?.markAsSingleton(m),m}e.markAsSingleton=w;function d(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=d;function o(m){if(T.Iterable.is(m)){const b=[];for(const D of m)if(D)try{D.dispose()}catch(M){b.push(M)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=o;function u(m){for(const b of m)d(b)&&b.dispose();return[]}e.disposeIfDisposable=u;function c(...m){const b=h(()=>o(m));return _(m,b),b}e.combinedDisposable=c;function h(m){const b=P({dispose:(0,A.createSingleCallFunction)(()=>{E(b),m()})});return b}e.toDisposable=h;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return S(b,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(b),b}delete(b){if(b){if(b===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(b),b.dispose()}}deleteAndLeak(b){b&&this._toDispose.has(b)&&(this._toDispose.delete(b),S(b,null))}}e.DisposableStore=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,P(this),S(this._store,this)}dispose(){E(this),this._store.dispose()}_register(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(b)}}e.Disposable=t;class i{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(b){this._isDisposed||b===this._value||(this._value?.dispose(),b&&S(b,this),this._value=b)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const b=this._value;return this._value=void 0,b&&S(b,null),b}}e.MutableDisposable=i;class s{constructor(b){this._disposable=b,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(b){let D=b;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,E(this))},this}}e.SafeDisposable=n;class r{constructor(){this.references=new Map}acquire(b,...D){let M=this.references.get(b);M||(M={counter:0,object:this.createReferencedObject(b,...D)},this.references.set(b,M));const{object:L}=M,F=(0,A.createSingleCallFunction)(()=>{--M.counter===0&&(this.destroyReferencedObject(b,M.object),this.references.delete(b))});return M.counter++,{object:L,dispose:F}}}e.ReferenceCollection=r;class l{constructor(b){this.referenceCollection=b}async acquire(b,...D){const M=this.referenceCollection.acquire(b,...D);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(L){throw M.dispose(),L}}}e.AsyncReferenceCollection=l;class k{constructor(b){this.object=b}dispose(){}}e.ImmortalReference=k;function C(m){const b=new a;try{m(b)}finally{b.dispose()}}e.disposeOnReturn=C;class p{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){E(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}has(b){return this._store.has(b)}get size(){return this._store.size}get(b){return this._store.get(b)}set(b,D,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(b)?.dispose(),this._store.set(b,D)}deleteAndDispose(b){this._store.get(b)?.dispose(),this._store.delete(b)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=p}),function(pe,e){typeof define=="function"&&define.amd?define(De[158],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(Z,J){for(var be=0;be<J.length;be++){var ae=J[be];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Z,ae.key,ae)}}function I(Z,J,be){return J&&e(Z.prototype,J),be&&e(Z,be),Object.defineProperty(Z,"prototype",{writable:!1}),Z}function O(Z,J){if(Z){if(typeof Z=="string")return f(Z,J);var be=Object.prototype.toString.call(Z).slice(8,-1);if(be==="Object"&&Z.constructor&&(be=Z.constructor.name),be==="Map"||be==="Set")return Array.from(Z);if(be==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(be))return f(Z,J)}}function f(Z,J){(J==null||J>Z.length)&&(J=Z.length);for(var be=0,ae=new Array(J);be<J;be++)ae[be]=Z[be];return ae}function A(Z,J){var be=typeof Symbol<"u"&&Z[Symbol.iterator]||Z["@@iterator"];if(be)return(be=be.call(Z)).next.bind(be);if(Array.isArray(Z)||(be=O(Z))||J&&Z&&typeof Z.length=="number"){be&&(Z=be);var ae=0;return function(){return ae>=Z.length?{done:!0}:{done:!1,value:Z[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=T();function g(Z){pe.defaults=Z}var y=/[&<>"']/,v=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(J){return E[J]};function _(Z,J){if(J){if(y.test(Z))return Z.replace(v,S)}else if(R.test(Z))return Z.replace(P,S);return Z}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Z){return Z.replace(w,function(J,be){return be=be.toLowerCase(),be==="colon"?":":be.charAt(0)==="#"?be.charAt(1)==="x"?String.fromCharCode(parseInt(be.substring(2),16)):String.fromCharCode(+be.substring(1)):""})}var o=/(^|[^\[])\^/g;function u(Z,J){Z=typeof Z=="string"?Z:Z.source,J=J||"";var be={replace:function(fe,ee){return ee=ee.source||ee,ee=ee.replace(o,"$1"),Z=Z.replace(fe,ee),be},getRegex:function(){return new RegExp(Z,J)}};return be}var c=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(Z,J,be){if(Z){var ae;try{ae=decodeURIComponent(d(be)).replace(c,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}J&&!h.test(be)&&(be=r(J,be));try{be=encodeURI(be).replace(/%25/g,"%")}catch{return null}return be}var t={},i=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Z,J){t[" "+Z]||(i.test(Z)?t[" "+Z]=Z+"/":t[" "+Z]=p(Z,"/",!0)),Z=t[" "+Z];var be=Z.indexOf(":")===-1;return J.substring(0,2)==="//"?be?J:Z.replace(s,"$1")+J:J.charAt(0)==="/"?be?J:Z.replace(n,"$1")+J:Z+J}var l={exec:function(){}};function k(Z){for(var J=1,be,ae;J<arguments.length;J++){be=arguments[J];for(ae in be)Object.prototype.hasOwnProperty.call(be,ae)&&(Z[ae]=be[ae])}return Z}function C(Z,J){var be=Z.replace(/\|/g,function(ee,he,ve){for(var Pe=!1,B=he;--B>=0&&ve[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ae=be.split(/ \|/),fe=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>J)ae.splice(J);else for(;ae.length<J;)ae.push("");for(;fe<ae.length;fe++)ae[fe]=ae[fe].trim().replace(/\\\|/g,"|");return ae}function p(Z,J,be){var ae=Z.length;if(ae===0)return"";for(var fe=0;fe<ae;){var ee=Z.charAt(ae-fe-1);if(ee===J&&!be)fe++;else if(ee!==J&&be)fe++;else break}return Z.slice(0,ae-fe)}function m(Z,J){if(Z.indexOf(J[1])===-1)return-1;for(var be=Z.length,ae=0,fe=0;fe<be;fe++)if(Z[fe]==="\\")fe++;else if(Z[fe]===J[0])ae++;else if(Z[fe]===J[1]&&(ae--,ae<0))return fe;return-1}function b(Z){Z&&Z.sanitize&&!Z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(Z,J){if(J<1)return"";for(var be="";J>1;)J&1&&(be+=Z),J>>=1,Z+=Z;return be+Z}function M(Z,J,be,ae){var fe=J.href,ee=J.title?_(J.title):null,he=Z[1].replace(/\\([\[\]])/g,"$1");if(Z[0].charAt(0)!=="!"){ae.state.inLink=!0;var ve={type:"link",raw:be,href:fe,title:ee,text:he,tokens:ae.inlineTokens(he)};return ae.state.inLink=!1,ve}return{type:"image",raw:be,href:fe,title:ee,text:_(he)}}function L(Z,J){var be=Z.match(/^(\s+)(?:```)/);if(be===null)return J;var ae=be[1];return J.split(`
`).map(function(fe){var ee=fe.match(/^\s+/);if(ee===null)return fe;var he=ee[0];return he.length>=ae.length?fe.slice(ae.length):fe}).join(`
`)}var F=function(){function Z(be){this.options=be||pe.defaults}var J=Z.prototype;return J.space=function(ae){var fe=this.rules.block.newline.exec(ae);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},J.code=function(ae){var fe=this.rules.block.code.exec(ae);if(fe){var ee=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:p(ee,`
`)}}},J.fences=function(ae){var fe=this.rules.block.fences.exec(ae);if(fe){var ee=fe[0],he=L(ee,fe[3]||"");return{type:"code",raw:ee,lang:fe[2]?fe[2].trim():fe[2],text:he}}},J.heading=function(ae){var fe=this.rules.block.heading.exec(ae);if(fe){var ee=fe[2].trim();if(/#$/.test(ee)){var he=p(ee,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ee=he.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ee,tokens:this.lexer.inline(ee)}}},J.hr=function(ae){var fe=this.rules.block.hr.exec(ae);if(fe)return{type:"hr",raw:fe[0]}},J.blockquote=function(ae){var fe=this.rules.block.blockquote.exec(ae);if(fe){var ee=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},J.list=function(ae){var fe=this.rules.block.list.exec(ae);if(fe){var ee,he,ve,Pe,B,G,se,oe,Y,me,ye,xe,We=fe[1].trim(),Ze=We.length>1,Xe={type:"list",raw:"",ordered:Ze,start:Ze?+We.slice(0,-1):"",loose:!1,items:[]};We=Ze?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=Ze?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(xe=!1,!(!(fe=it.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=fe[0],ae=ae.substring(ee.length),oe=fe[2].split(`
`,1)[0],Y=ae.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=oe.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=oe.slice(Pe),Pe+=fe[1].length),G=!1,!oe&&/^ *$/.test(Y)&&(ee+=Y+`
`,ae=ae.substring(Y.length+1),xe=!0),!xe)for(var tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Te=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),ze=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ae&&(me=ae.split(`
`,1)[0],oe=me,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(oe)||ze.test(oe)||tt.test(oe)||Te.test(ae)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())ye+=`
`+oe.slice(Pe);else if(!G)ye+=`
`+oe;else break;!G&&!oe.trim()&&(G=!0),ee+=me+`
`,ae=ae.substring(me.length+1)}Xe.loose||(se?Xe.loose=!0:/\n *\n *$/.test(ee)&&(se=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(ye),he&&(ve=he[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:ee,task:!!he,checked:ve,loose:!1,text:ye}),Xe.raw+=ee}Xe.items[Xe.items.length-1].raw=ee.trimRight(),Xe.items[Xe.items.length-1].text=ye.trimRight(),Xe.raw=Xe.raw.trimRight();var Re=Xe.items.length;for(B=0;B<Re;B++){this.lexer.state.top=!1,Xe.items[B].tokens=this.lexer.blockTokens(Xe.items[B].text,[]);var Qe=Xe.items[B].tokens.filter(function(le){return le.type==="space"}),de=Qe.every(function(le){for(var ke=le.raw.split(""),Ve=0,Be=A(ke),Ye;!(Ye=Be()).done;){var nt=Ye.value;if(nt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Xe.loose&&Qe.length&&de&&(Xe.loose=!0,Xe.items[B].loose=!0)}return Xe}},J.html=function(ae){var fe=this.rules.block.html.exec(ae);if(fe){var ee={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(fe[0]):_(fe[0]);ee.type="paragraph",ee.text=he,ee.tokens=this.lexer.inline(he)}return ee}},J.def=function(ae){var fe=this.rules.block.def.exec(ae);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ee=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:fe[0],href:fe[2],title:fe[3]}}},J.table=function(ae){var fe=this.rules.block.table.exec(ae);if(fe){var ee={type:"table",header:C(fe[1]).map(function(se){return{text:se}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=fe[0];var he=ee.align.length,ve,Pe,B,G;for(ve=0;ve<he;ve++)/^ *-+: *$/.test(ee.align[ve])?ee.align[ve]="right":/^ *:-+: *$/.test(ee.align[ve])?ee.align[ve]="center":/^ *:-+ *$/.test(ee.align[ve])?ee.align[ve]="left":ee.align[ve]=null;for(he=ee.rows.length,ve=0;ve<he;ve++)ee.rows[ve]=C(ee.rows[ve],ee.header.length).map(function(se){return{text:se}});for(he=ee.header.length,Pe=0;Pe<he;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(he=ee.rows.length,Pe=0;Pe<he;Pe++)for(G=ee.rows[Pe],B=0;B<G.length;B++)G[B].tokens=this.lexer.inline(G[B].text);return ee}}},J.lheading=function(ae){var fe=this.rules.block.lheading.exec(ae);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},J.paragraph=function(ae){var fe=this.rules.block.paragraph.exec(ae);if(fe){var ee=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ee,tokens:this.lexer.inline(ee)}}},J.text=function(ae){var fe=this.rules.block.text.exec(ae);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},J.escape=function(ae){var fe=this.rules.inline.escape.exec(ae);if(fe)return{type:"escape",raw:fe[0],text:_(fe[1])}},J.tag=function(ae){var fe=this.rules.inline.tag.exec(ae);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):_(fe[0]):fe[0]}},J.link=function(ae){var fe=this.rules.inline.link.exec(ae);if(fe){var ee=fe[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var he=p(ee.slice(0,-1),"\\");if((ee.length-he.length)%2===0)return}else{var ve=m(fe[2],"()");if(ve>-1){var Pe=fe[0].indexOf("!")===0?5:4,B=Pe+fe[1].length+ve;fe[2]=fe[2].substring(0,ve),fe[0]=fe[0].substring(0,B).trim(),fe[3]=""}}var G=fe[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);oe&&(G=oe[1],se=oe[3])}else se=fe[3]?fe[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(ee)?G=G.slice(1):G=G.slice(1,-1)),M(fe,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},J.reflink=function(ae,fe){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var he=(ee[2]||ee[1]).replace(/\s+/g," ");if(he=fe[he.toLowerCase()],!he||!he.href){var ve=ee[0].charAt(0);return{type:"text",raw:ve,text:ve}}return M(ee,he,ee[0],this.lexer)}},J.emStrong=function(ae,fe,ee){ee===void 0&&(ee="");var he=this.rules.inline.emStrong.lDelim.exec(ae);if(he&&!(he[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ve=he[1]||he[2]||"";if(!ve||ve&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=he[0].length-1,B,G,se=Pe,oe=0,Y=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,fe=fe.slice(-1*ae.length+Pe);(he=Y.exec(fe))!=null;)if(B=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!B){if(G=B.length,he[3]||he[4]){se+=G;continue}else if((he[5]||he[6])&&Pe%3&&!((Pe+G)%3)){oe+=G;continue}if(se-=G,!(se>0)){if(G=Math.min(G,G+se+oe),Math.min(Pe,G)%2){var me=ae.slice(1,Pe+he.index+G);return{type:"em",raw:ae.slice(0,Pe+he.index+G+1),text:me,tokens:this.lexer.inlineTokens(me)}}var ye=ae.slice(2,Pe+he.index+G-1);return{type:"strong",raw:ae.slice(0,Pe+he.index+G+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},J.codespan=function(ae){var fe=this.rules.inline.code.exec(ae);if(fe){var ee=fe[2].replace(/\n/g," "),he=/[^ ]/.test(ee),ve=/^ /.test(ee)&&/ $/.test(ee);return he&&ve&&(ee=ee.substring(1,ee.length-1)),ee=_(ee,!0),{type:"codespan",raw:fe[0],text:ee}}},J.br=function(ae){var fe=this.rules.inline.br.exec(ae);if(fe)return{type:"br",raw:fe[0]}},J.del=function(ae){var fe=this.rules.inline.del.exec(ae);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},J.autolink=function(ae,fe){var ee=this.rules.inline.autolink.exec(ae);if(ee){var he,ve;return ee[2]==="@"?(he=_(this.options.mangle?fe(ee[1]):ee[1]),ve="mailto:"+he):(he=_(ee[1]),ve=he),{type:"link",raw:ee[0],text:he,href:ve,tokens:[{type:"text",raw:he,text:he}]}}},J.url=function(ae,fe){var ee;if(ee=this.rules.inline.url.exec(ae)){var he,ve;if(ee[2]==="@")he=_(this.options.mangle?fe(ee[0]):ee[0]),ve="mailto:"+he;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);he=_(ee[0]),ee[1]==="www."?ve="http://"+he:ve=he}return{type:"link",raw:ee[0],text:he,href:ve,tokens:[{type:"text",raw:he,text:he}]}}},J.inlineText=function(ae,fe){var ee=this.rules.inline.text.exec(ae);if(ee){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):_(ee[0]):ee[0]:he=_(this.options.smartypants?fe(ee[0]):ee[0]),{type:"text",raw:ee[0],text:he}}},Z}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=u(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=u(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=u(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=u(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=u(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=u(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=k({},x),x.gfm=k({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=u(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=u(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=k({},x.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:u(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=u(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=u(x._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=u(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=u(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=u(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=u(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=u(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=u(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=u(U.reflink).replace("label",U._label).replace("ref",x._label).getRegex(),U.nolink=u(U.nolink).replace("ref",x._label).getRegex(),U.reflinkSearch=u(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=k({},U),U.pedantic=k({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=k({},U.normal,{escape:u(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=u(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=k({},U.gfm,{br:u(U.br).replace("{2,}","*").getRegex(),text:u(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(Z){return Z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Z){var J="",be,ae,fe=Z.length;for(be=0;be<fe;be++)ae=Z.charCodeAt(be),Math.random()>.5&&(ae="x"+ae.toString(16)),J+="&#"+ae+";";return J}var V=function(){function Z(be){this.tokens=[],this.tokens.links=Object.create(null),this.options=be||pe.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:x.normal,inline:U.normal};this.options.pedantic?(ae.block=x.pedantic,ae.inline=U.pedantic):this.options.gfm&&(ae.block=x.gfm,this.options.breaks?ae.inline=U.breaks:ae.inline=U.gfm),this.tokenizer.rules=ae}Z.lex=function(ae,fe){var ee=new Z(fe);return ee.lex(ae)},Z.lexInline=function(ae,fe){var ee=new Z(fe);return ee.inlineTokens(ae)};var J=Z.prototype;return J.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},J.blockTokens=function(ae,fe){var ee=this;fe===void 0&&(fe=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,oe,Y){return oe+"    ".repeat(Y.length)});for(var he,ve,Pe,B;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(he=se.call({lexer:ee},ae,fe))?(ae=ae.substring(he.raw.length),fe.push(he),!0):!1}))){if(he=this.tokenizer.space(ae)){ae=ae.substring(he.raw.length),he.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(he);continue}if(he=this.tokenizer.code(ae)){ae=ae.substring(he.raw.length),ve=fe[fe.length-1],ve&&(ve.type==="paragraph"||ve.type==="text")?(ve.raw+=`
`+he.raw,ve.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=ve.text):fe.push(he);continue}if(he=this.tokenizer.fences(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.heading(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.hr(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.blockquote(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.list(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.html(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.def(ae)){ae=ae.substring(he.raw.length),ve=fe[fe.length-1],ve&&(ve.type==="paragraph"||ve.type==="text")?(ve.raw+=`
`+he.raw,ve.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=ve.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.lheading(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(Pe=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=ae.slice(1),Y=void 0;ee.options.extensions.startBlock.forEach(function(me){Y=me.call({lexer:this},oe),typeof Y=="number"&&Y>=0&&(se=Math.min(se,Y))}),se<1/0&&se>=0&&(Pe=ae.substring(0,se+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Pe))){ve=fe[fe.length-1],B&&ve.type==="paragraph"?(ve.raw+=`
`+he.raw,ve.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ve.text):fe.push(he),B=Pe.length!==ae.length,ae=ae.substring(he.raw.length);continue}if(he=this.tokenizer.text(ae)){ae=ae.substring(he.raw.length),ve=fe[fe.length-1],ve&&ve.type==="text"?(ve.raw+=`
`+he.raw,ve.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ve.text):fe.push(he);continue}if(ae){var G="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,fe},J.inline=function(ae,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ae,tokens:fe}),fe},J.inlineTokens=function(ae,fe){var ee=this;fe===void 0&&(fe=[]);var he,ve,Pe,B=ae,G,se,oe;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Y.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,G.index)+"["+D("a",G[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,G.index)+"["+D("a",G[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,G.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(he=ye.call({lexer:ee},ae,fe))?(ae=ae.substring(he.raw.length),fe.push(he),!0):!1}))){if(he=this.tokenizer.escape(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.tag(ae)){ae=ae.substring(he.raw.length),ve=fe[fe.length-1],ve&&he.type==="text"&&ve.type==="text"?(ve.raw+=he.raw,ve.text+=he.text):fe.push(he);continue}if(he=this.tokenizer.link(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(he.raw.length),ve=fe[fe.length-1],ve&&he.type==="text"&&ve.type==="text"?(ve.raw+=he.raw,ve.text+=he.text):fe.push(he);continue}if(he=this.tokenizer.emStrong(ae,B,oe)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.codespan(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.br(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.del(ae)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.autolink(ae,z)){ae=ae.substring(he.raw.length),fe.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(ae,z))){ae=ae.substring(he.raw.length),fe.push(he);continue}if(Pe=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,xe=ae.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(Ze){We=Ze.call({lexer:this},xe),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=ae.substring(0,ye+1))}(),he=this.tokenizer.inlineText(Pe,N)){ae=ae.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(oe=he.raw.slice(-1)),se=!0,ve=fe[fe.length-1],ve&&ve.type==="text"?(ve.raw+=he.raw,ve.text+=he.text):fe.push(he);continue}if(ae){var me="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return fe},I(Z,null,[{key:"rules",get:function(){return{block:x,inline:U}}}]),Z}(),ge=function(){function Z(be){this.options=be||pe.defaults}var J=Z.prototype;return J.code=function(ae,fe,ee){var he=(fe||"").match(/\S*/)[0];if(this.options.highlight){var ve=this.options.highlight(ae,he);ve!=null&&ve!==ae&&(ee=!0,ae=ve)}return ae=ae.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+_(he,!0)+'">'+(ee?ae:_(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:_(ae,!0))+`</code></pre>
`},J.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},J.html=function(ae){return ae},J.heading=function(ae,fe,ee,he){if(this.options.headerIds){var ve=this.options.headerPrefix+he.slug(ee);return"<h"+fe+' id="'+ve+'">'+ae+"</h"+fe+`>
`}return"<h"+fe+">"+ae+"</h"+fe+`>
`},J.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},J.list=function(ae,fe,ee){var he=fe?"ol":"ul",ve=fe&&ee!==1?' start="'+ee+'"':"";return"<"+he+ve+`>
`+ae+"</"+he+`>
`},J.listitem=function(ae){return"<li>"+ae+`</li>
`},J.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},J.paragraph=function(ae){return"<p>"+ae+`</p>
`},J.table=function(ae,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+fe+`</table>
`},J.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},J.tablecell=function(ae,fe){var ee=fe.header?"th":"td",he=fe.align?"<"+ee+' align="'+fe.align+'">':"<"+ee+">";return he+ae+("</"+ee+`>
`)},J.strong=function(ae){return"<strong>"+ae+"</strong>"},J.em=function(ae){return"<em>"+ae+"</em>"},J.codespan=function(ae){return"<code>"+ae+"</code>"},J.br=function(){return this.options.xhtml?"<br/>":"<br>"},J.del=function(ae){return"<del>"+ae+"</del>"},J.link=function(ae,fe,ee){if(ae=a(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var he='<a href="'+_(ae)+'"';return fe&&(he+=' title="'+fe+'"'),he+=">"+ee+"</a>",he},J.image=function(ae,fe,ee){if(ae=a(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var he='<img src="'+ae+'" alt="'+ee+'"';return fe&&(he+=' title="'+fe+'"'),he+=this.options.xhtml?"/>":">",he},J.text=function(ae){return ae},Z}(),te=function(){function Z(){}var J=Z.prototype;return J.strong=function(ae){return ae},J.em=function(ae){return ae},J.codespan=function(ae){return ae},J.del=function(ae){return ae},J.html=function(ae){return ae},J.text=function(ae){return ae},J.link=function(ae,fe,ee){return""+ee},J.image=function(ae,fe,ee){return""+ee},J.br=function(){return""},Z}(),q=function(){function Z(){this.seen={}}var J=Z.prototype;return J.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},J.getNextSafeSlug=function(ae,fe){var ee=ae,he=0;if(this.seen.hasOwnProperty(ee)){he=this.seen[ae];do he++,ee=ae+"-"+he;while(this.seen.hasOwnProperty(ee))}return fe||(this.seen[ae]=he,this.seen[ee]=0),ee},J.slug=function(ae,fe){fe===void 0&&(fe={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,fe.dryrun)},Z}(),K=function(){function Z(be){this.options=be||pe.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new q}Z.parse=function(ae,fe){var ee=new Z(fe);return ee.parse(ae)},Z.parseInline=function(ae,fe){var ee=new Z(fe);return ee.parseInline(ae)};var J=Z.prototype;return J.parse=function(ae,fe){fe===void 0&&(fe=!0);var ee="",he,ve,Pe,B,G,se,oe,Y,me,ye,xe,We,Ze,Xe,it,tt,Te,Me,ze,Re=ae.length;for(he=0;he<Re;he++){if(ye=ae[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(ze=this.options.extensions.renderers[ye.type].call({parser:this},ye),ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=ze||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,d(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Y="",oe="",B=ye.header.length,ve=0;ve<B;ve++)oe+=this.renderer.tablecell(this.parseInline(ye.header[ve].tokens),{header:!0,align:ye.align[ve]});for(Y+=this.renderer.tablerow(oe),me="",B=ye.rows.length,ve=0;ve<B;ve++){for(se=ye.rows[ve],oe="",G=se.length,Pe=0;Pe<G;Pe++)oe+=this.renderer.tablecell(this.parseInline(se[Pe].tokens),{header:!1,align:ye.align[Pe]});me+=this.renderer.tablerow(oe)}ee+=this.renderer.table(Y,me);continue}case"blockquote":{me=this.parse(ye.tokens),ee+=this.renderer.blockquote(me);continue}case"list":{for(xe=ye.ordered,We=ye.start,Ze=ye.loose,B=ye.items.length,me="",ve=0;ve<B;ve++)it=ye.items[ve],tt=it.checked,Te=it.task,Xe="",it.task&&(Me=this.renderer.checkbox(tt),Ze?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Me+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Me+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Me}):Xe+=Me),Xe+=this.parse(it.tokens,Ze),me+=this.renderer.listitem(Xe,Te,tt);ee+=this.renderer.list(me,xe,We);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(me=ye.tokens?this.parseInline(ye.tokens):ye.text;he+1<Re&&ae[he+1].type==="text";)ye=ae[++he],me+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=fe?this.renderer.paragraph(me):me;continue}default:{var Qe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return ee},J.parseInline=function(ae,fe){fe=fe||this.renderer;var ee="",he,ve,Pe,B=ae.length;for(he=0;he<B;he++){if(ve=ae[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Pe=this.options.extensions.renderers[ve.type].call({parser:this},ve),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ve.type))){ee+=Pe||"";continue}switch(ve.type){case"escape":{ee+=fe.text(ve.text);break}case"html":{ee+=fe.html(ve.text);break}case"link":{ee+=fe.link(ve.href,ve.title,this.parseInline(ve.tokens,fe));break}case"image":{ee+=fe.image(ve.href,ve.title,ve.text);break}case"strong":{ee+=fe.strong(this.parseInline(ve.tokens,fe));break}case"em":{ee+=fe.em(this.parseInline(ve.tokens,fe));break}case"codespan":{ee+=fe.codespan(ve.text);break}case"br":{ee+=fe.br();break}case"del":{ee+=fe.del(this.parseInline(ve.tokens,fe));break}case"text":{ee+=fe.text(ve.text);break}default:{var G='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return ee},Z}();function ue(Z,J,be){if(typeof Z>"u"||Z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");if(typeof J=="function"&&(be=J,J=null),J=k({},ue.defaults,J||{}),b(J),be){var ae=J.highlight,fe;try{fe=V.lex(Z,J)}catch(B){return be(B)}var ee=function(G){var se;if(!G)try{J.walkTokens&&ue.walkTokens(fe,J.walkTokens),se=K.parse(fe,J)}catch(oe){G=oe}return J.highlight=ae,G?be(G):be(null,se)};if(!ae||ae.length<3||(delete J.highlight,!fe.length))return ee();var he=0;ue.walkTokens(fe,function(B){B.type==="code"&&(he++,setTimeout(function(){ae(B.text,B.lang,function(G,se){if(G)return ee(G);se!=null&&se!==B.text&&(B.text=se,B.escaped=!0),he--,he===0&&ee()})},0))}),he===0&&ee();return}function ve(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+_(B.message+"",!0)+"</pre>";throw B}try{var Pe=V.lex(Z,J);if(J.walkTokens){if(J.async)return Promise.all(ue.walkTokens(Pe,J.walkTokens)).then(function(){return K.parse(Pe,J)}).catch(ve);ue.walkTokens(Pe,J.walkTokens)}return K.parse(Pe,J)}catch(B){ve(B)}}ue.options=ue.setOptions=function(Z){return k(ue.defaults,Z),g(ue.defaults),ue},ue.getDefaults=T,ue.defaults=pe.defaults,ue.use=function(){for(var Z=arguments.length,J=new Array(Z),be=0;be<Z;be++)J[be]=arguments[be];var ae=k.apply(void 0,[{}].concat(J)),fe=ue.defaults.extensions||{renderers:{},childTokens:{}},ee;J.forEach(function(he){if(he.extensions&&(ee=!0,he.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=fe.renderers?fe.renderers[Pe.name]:null;B?fe.renderers[Pe.name]=function(){for(var G=arguments.length,se=new Array(G),oe=0;oe<G;oe++)se[oe]=arguments[oe];var Y=Pe.renderer.apply(this,se);return Y===!1&&(Y=B.apply(this,se)),Y}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),he.renderer&&function(){var Pe=ue.defaults.renderer||new ge,B=function(oe){var Y=Pe[oe];Pe[oe]=function(){for(var me=arguments.length,ye=new Array(me),xe=0;xe<me;xe++)ye[xe]=arguments[xe];var We=he.renderer[oe].apply(Pe,ye);return We===!1&&(We=Y.apply(Pe,ye)),We}};for(var G in he.renderer)B(G);ae.renderer=Pe}(),he.tokenizer&&function(){var Pe=ue.defaults.tokenizer||new F,B=function(oe){var Y=Pe[oe];Pe[oe]=function(){for(var me=arguments.length,ye=new Array(me),xe=0;xe<me;xe++)ye[xe]=arguments[xe];var We=he.tokenizer[oe].apply(Pe,ye);return We===!1&&(We=Y.apply(Pe,ye)),We}};for(var G in he.tokenizer)B(G);ae.tokenizer=Pe}(),he.walkTokens){var ve=ue.defaults.walkTokens;ae.walkTokens=function(Pe){var B=[];return B.push(he.walkTokens.call(this,Pe)),ve&&(B=B.concat(ve.call(this,Pe))),B}}ee&&(ae.extensions=fe),ue.setOptions(ae)})},ue.walkTokens=function(Z,J){for(var be=[],ae=function(){var ve=ee.value;switch(be=be.concat(J.call(ue,ve)),ve.type){case"table":{for(var Pe=A(ve.header),B;!(B=Pe()).done;){var G=B.value;be=be.concat(ue.walkTokens(G.tokens,J))}for(var se=A(ve.rows),oe;!(oe=se()).done;)for(var Y=oe.value,me=A(Y),ye;!(ye=me()).done;){var xe=ye.value;be=be.concat(ue.walkTokens(xe.tokens,J))}break}case"list":{be=be.concat(ue.walkTokens(ve.items,J));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[ve.type]?ue.defaults.extensions.childTokens[ve.type].forEach(function(We){be=be.concat(ue.walkTokens(ve[We],J))}):ve.tokens&&(be=be.concat(ue.walkTokens(ve.tokens,J)))}},fe=A(Z),ee;!(ee=fe()).done;)ae();return be},ue.parseInline=function(Z,J){if(typeof Z>"u"||Z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");J=k({},ue.defaults,J||{}),b(J);try{var be=V.lexInline(Z,J);return J.walkTokens&&ue.walkTokens(be,J.walkTokens),K.parseInline(be,J)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+_(ae.message+"",!0)+"</pre>";throw ae}},ue.Parser=K,ue.parser=K.parse,ue.Renderer=ge,ue.TextRenderer=te,ue.Lexer=V,ue.lexer=V.lex,ue.Tokenizer=F,ue.Slugger=q,ue.parse=ue;var ie=ue.options,ce=ue.setOptions,Se=ue.use,j=ue.walkTokens,$=ue.parseInline,X=ue,re=K.parse,Q=V.lex;pe.Lexer=V,pe.Parser=K,pe.Renderer=ge,pe.Slugger=q,pe.TextRenderer=te,pe.Tokenizer=F,pe.getDefaults=T,pe.lexer=Q,pe.marked=ue,pe.options=ie,pe.parse=X,pe.parseInline=$,pe.parser=re,pe.setOptions=ce,pe.use=Se,pe.walkTokens=j,Object.defineProperty(pe,"__esModule",{value:!0})}),define(De[77],Ie([1,0,28]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new I.LRUCache(1e4);function f(v){return y(v,"NFC",O)}e.normalizeNFC=f;const A=new I.LRUCache(1e4);function T(v){return y(v,"NFD",A)}e.normalizeNFD=T;const g=/[^\u0000-\u0080]/;function y(v,R,P){if(!v)return v;const E=P.get(v);if(E)return E;let S;return g.test(v)?S=v.normalize(R):S=v,P.set(v,S),S}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(R){return T(R).replace(v,"")}}()}),define(De[120],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(g,y,v){return Math.min(Math.max(g,y),v)}e.clamp=I;function O(g,y){return(y+g%y)%y}e.rot=O;class f{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=f;class A{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const v=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=v,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function pe(f){const A=[];typeof f=="number"&&A.push("code/timeOrigin",f);function T(y){A.push(y,Date.now())}function g(){const y=[];for(let v=0;v<A.length;v+=2)y.push({name:A[v],startTime:A[v+1]});return y}return{mark:T,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(f+T.startTime)});return A}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function I(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=I(O))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var O in I)(typeof exports=="object"?exports:pe)[O]=I[O]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function I(O){if(e[O])return e[O].exports;var f=e[O]={i:O,l:!1,exports:{}};return pe[O].call(f.exports,f,f.exports,I),f.l=!0,f.exports}return I.m=pe,I.c=e,I.d=function(O,f,A){I.o(O,f)||Object.defineProperty(O,f,{enumerable:!0,get:A})},I.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},I.t=function(O,f){if(1&f&&(O=I(O)),8&f||4&f&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&f&&typeof O!="string")for(var T in O)I.d(A,T,function(g){return O[g]}.bind(null,T));return A},I.n=function(O){var f=O&&O.__esModule?function(){return O.default}:function(){return O};return I.d(f,"a",f),f},I.o=function(O,f){return Object.prototype.hasOwnProperty.call(O,f)},I.p="",I(I.s=0)}([function(pe,e,I){(function(O){var f;e=pe.exports=Se,f=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],y=e.src=[],v=0,R=v++;y[R]="0|[1-9]\\d*";var P=v++;y[P]="[0-9]+";var E=v++;y[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=v++;y[S]="("+y[R]+")\\.("+y[R]+")\\.("+y[R]+")";var _=v++;y[_]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var w=v++;y[w]="(?:"+y[R]+"|"+y[E]+")";var d=v++;y[d]="(?:"+y[P]+"|"+y[E]+")";var o=v++;y[o]="(?:-("+y[w]+"(?:\\."+y[w]+")*))";var u=v++;y[u]="(?:-?("+y[d]+"(?:\\."+y[d]+")*))";var c=v++;y[c]="[0-9A-Za-z-]+";var h=v++;y[h]="(?:\\+("+y[c]+"(?:\\."+y[c]+")*))";var a=v++,t="v?"+y[S]+y[o]+"?"+y[h]+"?";y[a]="^"+t+"$";var i="[v=\\s]*"+y[_]+y[u]+"?"+y[h]+"?",s=v++;y[s]="^"+i+"$";var n=v++;y[n]="((?:<|>)?=?)";var r=v++;y[r]=y[P]+"|x|X|\\*";var l=v++;y[l]=y[R]+"|x|X|\\*";var k=v++;y[k]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[o]+")?"+y[h]+"?)?)?";var C=v++;y[C]="[v=\\s]*("+y[r]+")(?:\\.("+y[r]+")(?:\\.("+y[r]+")(?:"+y[u]+")?"+y[h]+"?)?)?";var p=v++;y[p]="^"+y[n]+"\\s*"+y[k]+"$";var m=v++;y[m]="^"+y[n]+"\\s*"+y[C]+"$";var b=v++;y[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=v++;y[D]="(?:~>?)";var M=v++;y[M]="(\\s*)"+y[D]+"\\s+",g[M]=new RegExp(y[M],"g");var L=v++;y[L]="^"+y[D]+y[k]+"$";var F=v++;y[F]="^"+y[D]+y[C]+"$";var x=v++;y[x]="(?:\\^)";var U=v++;y[U]="(\\s*)"+y[x]+"\\s+",g[U]=new RegExp(y[U],"g");var N=v++;y[N]="^"+y[x]+y[k]+"$";var z=v++;y[z]="^"+y[x]+y[C]+"$";var V=v++;y[V]="^"+y[n]+"\\s*("+i+")$|^$";var ge=v++;y[ge]="^"+y[n]+"\\s*("+t+")$|^$";var te=v++;y[te]="(\\s*)"+y[n]+"\\s*("+i+"|"+y[k]+")",g[te]=new RegExp(y[te],"g");var q=v++;y[q]="^\\s*("+y[k]+")\\s+-\\s+("+y[k]+")\\s*$";var K=v++;y[K]="^\\s*("+y[C]+")\\s+-\\s+("+y[C]+")\\s*$";var ue=v++;y[ue]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)f(ie,y[ie]),g[ie]||(g[ie]=new RegExp(y[ie]));function ce(Y,me){if(Y instanceof Se)return Y;if(typeof Y!="string"||Y.length>A||!(me?g[s]:g[a]).test(Y))return null;try{return new Se(Y,me)}catch{return null}}function Se(Y,me){if(Y instanceof Se){if(Y.loose===me)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Se))return new Se(Y,me);f("SemVer",Y,me),this.loose=me;var ye=Y.trim().match(me?g[s]:g[a]);if(!ye)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(xe){if(/^[0-9]+$/.test(xe)){var We=+xe;if(We>=0&&We<T)return We}return xe}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Y,me){var ye=ce(Y,me);return ye?ye.version:null},e.clean=function(Y,me){var ye=ce(Y.trim().replace(/^[=v]+/,""),me);return ye?ye.version:null},e.SemVer=Se,Se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Se.prototype.toString=function(){return this.version},Se.prototype.compare=function(Y){return f("SemVer.compare",this.version,this.loose,Y),Y instanceof Se||(Y=new Se(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},Se.prototype.compareMain=function(Y){return Y instanceof Se||(Y=new Se(Y,this.loose)),$(this.major,Y.major)||$(this.minor,Y.minor)||$(this.patch,Y.patch)},Se.prototype.comparePre=function(Y){if(Y instanceof Se||(Y=new Se(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var me=0;do{var ye=this.prerelease[me],xe=Y.prerelease[me];if(f("prerelease compare",me,ye,xe),ye===void 0&&xe===void 0)return 0;if(xe===void 0)return 1;if(ye===void 0)return-1;if(ye!==xe)return $(ye,xe)}while(++me)},Se.prototype.inc=function(Y,me){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,me,ye,xe){typeof ye=="string"&&(xe=ye,ye=void 0);try{return new Se(Y,ye).inc(me,xe).version}catch{return null}},e.diff=function(Y,me){if(Z(Y,me))return null;var ye=ce(Y),xe=ce(me);if(ye.prerelease.length||xe.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==xe[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==xe[We])return We},e.compareIdentifiers=$;var j=/^[0-9]+$/;function $(Y,me){var ye=j.test(Y),xe=j.test(me);return ye&&xe&&(Y=+Y,me=+me),ye&&!xe?-1:xe&&!ye?1:Y<me?-1:Y>me?1:0}function X(Y,me,ye){return new Se(Y,ye).compare(new Se(me,ye))}function re(Y,me,ye){return X(Y,me,ye)>0}function Q(Y,me,ye){return X(Y,me,ye)<0}function Z(Y,me,ye){return X(Y,me,ye)===0}function J(Y,me,ye){return X(Y,me,ye)!==0}function be(Y,me,ye){return X(Y,me,ye)>=0}function ae(Y,me,ye){return X(Y,me,ye)<=0}function fe(Y,me,ye,xe){var We;switch(me){case"===":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y===ye;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y!==ye;break;case"":case"=":case"==":We=Z(Y,ye,xe);break;case"!=":We=J(Y,ye,xe);break;case">":We=re(Y,ye,xe);break;case">=":We=be(Y,ye,xe);break;case"<":We=Q(Y,ye,xe);break;case"<=":We=ae(Y,ye,xe);break;default:throw new TypeError("Invalid operator: "+me)}return We}function ee(Y,me){if(Y instanceof ee){if(Y.loose===me)return Y;Y=Y.value}if(!(this instanceof ee))return new ee(Y,me);f("comparator",Y,me),this.loose=me,this.parse(Y),this.semver===he?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(Y,me){return $(me,Y)},e.major=function(Y,me){return new Se(Y,me).major},e.minor=function(Y,me){return new Se(Y,me).minor},e.patch=function(Y,me){return new Se(Y,me).patch},e.compare=X,e.compareLoose=function(Y,me){return X(Y,me,!0)},e.rcompare=function(Y,me,ye){return X(me,Y,ye)},e.sort=function(Y,me){return Y.sort(function(ye,xe){return e.compare(ye,xe,me)})},e.rsort=function(Y,me){return Y.sort(function(ye,xe){return e.rcompare(ye,xe,me)})},e.gt=re,e.lt=Q,e.eq=Z,e.neq=J,e.gte=be,e.lte=ae,e.cmp=fe,e.Comparator=ee;var he={};function ve(Y,me){if(Y instanceof ve)return Y.loose===me?Y:new ve(Y.raw,me);if(Y instanceof ee)return new ve(Y.value,me);if(!(this instanceof ve))return new ve(Y,me);if(this.loose=me,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Pe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function B(Y,me,ye,xe,We,Ze,Xe,it,tt,Te,Me,ze,Re){return((me=Pe(ye)?"":Pe(xe)?">="+ye+".0.0":Pe(We)?">="+ye+"."+xe+".0":">="+me)+" "+(it=Pe(tt)?"":Pe(Te)?"<"+(+tt+1)+".0.0":Pe(Me)?"<"+tt+"."+(+Te+1)+".0":ze?"<="+tt+"."+Te+"."+Me+"-"+ze:"<="+it)).trim()}function G(Y,me){for(var ye=0;ye<Y.length;ye++)if(!Y[ye].test(me))return!1;if(me.prerelease.length){for(ye=0;ye<Y.length;ye++)if(f(Y[ye].semver),Y[ye].semver!==he&&Y[ye].semver.prerelease.length>0){var xe=Y[ye].semver;if(xe.major===me.major&&xe.minor===me.minor&&xe.patch===me.patch)return!0}return!1}return!0}function se(Y,me,ye){try{me=new ve(me,ye)}catch{return!1}return me.test(Y)}function oe(Y,me,ye,xe){var We,Ze,Xe,it,tt;switch(Y=new Se(Y,xe),me=new ve(me,xe),ye){case">":We=re,Ze=ae,Xe=Q,it=">",tt=">=";break;case"<":We=Q,Ze=be,Xe=re,it="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Y,me,xe))return!1;for(var Te=0;Te<me.set.length;++Te){var Me=me.set[Te],ze=null,Re=null;if(Me.forEach(function(Qe){Qe.semver===he&&(Qe=new ee(">=0.0.0")),ze=ze||Qe,Re=Re||Qe,We(Qe.semver,ze.semver,xe)?ze=Qe:Xe(Qe.semver,Re.semver,xe)&&(Re=Qe)}),ze.operator===it||ze.operator===tt||(!Re.operator||Re.operator===it)&&Ze(Y,Re.semver)||Re.operator===tt&&Xe(Y,Re.semver))return!1}return!0}ee.prototype.parse=function(Y){var me=this.loose?g[V]:g[ge],ye=Y.match(me);if(!ye)throw new TypeError("Invalid comparator: "+Y);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new Se(ye[2],this.loose):this.semver=he},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Y){return f("Comparator.test",Y,this.loose),this.semver===he||(typeof Y=="string"&&(Y=new Se(Y,this.loose)),fe(Y,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Y,me){if(!(Y instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ve(Y.value,me),se(this.value,ye,me);if(Y.operator==="")return ye=new ve(this.value,me),se(Y.semver,ye,me);var xe=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ze=this.semver.version===Y.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=fe(this.semver,"<",Y.semver,me)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),tt=fe(this.semver,">",Y.semver,me)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return xe||We||Ze&&Xe||it||tt},e.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(Y){var me=this.loose;Y=Y.trim(),f("range",Y,me);var ye=me?g[K]:g[q];Y=Y.replace(ye,B),f("hyphen replace",Y),Y=Y.replace(g[te],"$1$2$3"),f("comparator trim",Y,g[te]),Y=(Y=(Y=Y.replace(g[M],"$1~")).replace(g[U],"$1^")).split(/\s+/).join(" ");var xe=me?g[V]:g[ge],We=Y.split(" ").map(function(Ze){return function(Xe,it){return f("comp",Xe),Xe=function(tt,Te){return tt.trim().split(/\s+/).map(function(Me){return function(ze,Re){f("caret",ze,Re);var Qe=Re?g[z]:g[N];return ze.replace(Qe,function(de,le,ke,Ve,Be){var Ye;return f("caret",ze,de,le,ke,Ve,Be),Pe(le)?Ye="":Pe(ke)?Ye=">="+le+".0.0 <"+(+le+1)+".0.0":Pe(Ve)?Ye=le==="0"?">="+le+"."+ke+".0 <"+le+"."+(+ke+1)+".0":">="+le+"."+ke+".0 <"+(+le+1)+".0.0":Be?(f("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Ye=le==="0"?ke==="0"?">="+le+"."+ke+"."+Ve+Be+" <"+le+"."+ke+"."+(+Ve+1):">="+le+"."+ke+"."+Ve+Be+" <"+le+"."+(+ke+1)+".0":">="+le+"."+ke+"."+Ve+Be+" <"+(+le+1)+".0.0"):(f("no pr"),Ye=le==="0"?ke==="0"?">="+le+"."+ke+"."+Ve+" <"+le+"."+ke+"."+(+Ve+1):">="+le+"."+ke+"."+Ve+" <"+le+"."+(+ke+1)+".0":">="+le+"."+ke+"."+Ve+" <"+(+le+1)+".0.0"),f("caret return",Ye),Ye})}(Me,Te)}).join(" ")}(Xe,it),f("caret",Xe),Xe=function(tt,Te){return tt.trim().split(/\s+/).map(function(Me){return function(ze,Re){var Qe=Re?g[F]:g[L];return ze.replace(Qe,function(de,le,ke,Ve,Be){var Ye;return f("tilde",ze,de,le,ke,Ve,Be),Pe(le)?Ye="":Pe(ke)?Ye=">="+le+".0.0 <"+(+le+1)+".0.0":Pe(Ve)?Ye=">="+le+"."+ke+".0 <"+le+"."+(+ke+1)+".0":Be?(f("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Ye=">="+le+"."+ke+"."+Ve+Be+" <"+le+"."+(+ke+1)+".0"):Ye=">="+le+"."+ke+"."+Ve+" <"+le+"."+(+ke+1)+".0",f("tilde return",Ye),Ye})}(Me,Te)}).join(" ")}(Xe,it),f("tildes",Xe),Xe=function(tt,Te){return f("replaceXRanges",tt,Te),tt.split(/\s+/).map(function(Me){return function(ze,Re){ze=ze.trim();var Qe=Re?g[m]:g[p];return ze.replace(Qe,function(de,le,ke,Ve,Be,Ye){f("xRange",ze,de,le,ke,Ve,Be,Ye);var nt=Pe(ke),ct=nt||Pe(Ve),vt=ct||Pe(Be);return le==="="&&vt&&(le=""),nt?de=le===">"||le==="<"?"<0.0.0":"*":le&&vt?(ct&&(Ve=0),vt&&(Be=0),le===">"?(le=">=",ct?(ke=+ke+1,Ve=0,Be=0):vt&&(Ve=+Ve+1,Be=0)):le==="<="&&(le="<",ct?ke=+ke+1:Ve=+Ve+1),de=le+ke+"."+Ve+"."+Be):ct?de=">="+ke+".0.0 <"+(+ke+1)+".0.0":vt&&(de=">="+ke+"."+Ve+".0 <"+ke+"."+(+Ve+1)+".0"),f("xRange return",de),de})}(Me,Te)}).join(" ")}(Xe,it),f("xrange",Xe),Xe=function(tt,Te){return f("replaceStars",tt,Te),tt.trim().replace(g[ue],"")}(Xe,it),f("stars",Xe),Xe}(Ze,me)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(Ze){return!!Ze.match(xe)})),We=We.map(function(Ze){return new ee(Ze,me)})},ve.prototype.intersects=function(Y,me){if(!(Y instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(xe){return Y.set.some(function(We){return We.every(function(Ze){return xe.intersects(Ze,me)})})})})},e.toComparators=function(Y,me){return new ve(Y,me).set.map(function(ye){return ye.map(function(xe){return xe.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new Se(Y,this.loose));for(var me=0;me<this.set.length;me++)if(G(this.set[me],Y))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Y,me,ye){var xe=null,We=null;try{var Ze=new ve(me,ye)}catch{return null}return Y.forEach(function(Xe){Ze.test(Xe)&&(xe&&We.compare(Xe)!==-1||(We=new Se(xe=Xe,ye)))}),xe},e.minSatisfying=function(Y,me,ye){var xe=null,We=null;try{var Ze=new ve(me,ye)}catch{return null}return Y.forEach(function(Xe){Ze.test(Xe)&&(xe&&We.compare(Xe)!==1||(We=new Se(xe=Xe,ye)))}),xe},e.validRange=function(Y,me){try{return new ve(Y,me).range||"*"}catch{return null}},e.ltr=function(Y,me,ye){return oe(Y,me,"<",ye)},e.gtr=function(Y,me,ye){return oe(Y,me,">",ye)},e.outside=oe,e.prerelease=function(Y,me){var ye=ce(Y,me);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Y,me,ye){return Y=new ve(Y,ye),me=new ve(me,ye),Y.intersects(me)},e.coerce=function(Y){if(Y instanceof Se)return Y;if(typeof Y!="string")return null;var me=Y.match(g[b]);return me==null?null:ce((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,I(1))},function(pe,e){var I,O,f=pe.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function g(d){if(I===setTimeout)return setTimeout(d,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(d,0);try{return I(d,0)}catch{try{return I.call(null,d,0)}catch{return I.call(this,d,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var y,v=[],R=!1,P=-1;function E(){R&&y&&(R=!1,y.length?v=y.concat(v):P=-1,v.length&&S())}function S(){if(!R){var d=g(E);R=!0;for(var o=v.length;o;){for(y=v,v=[];++P<o;)y&&y[P].run();P=-1,o=v.length}y=null,R=!1,function(u){if(O===clearTimeout)return clearTimeout(u);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(u);try{O(u)}catch{try{return O.call(null,u)}catch{return O.call(this,u)}}}(d)}}function _(d,o){this.fun=d,this.array=o}function w(){}f.nextTick=function(d){var o=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)o[u-1]=arguments[u];v.push(new _(d,o)),v.length!==1||R||g(S)},_.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=w,f.addListener=w,f.once=w,f.off=w,f.removeListener=w,f.removeAllListeners=w,f.emit=w,f.prependListener=w,f.prependOnceListener=w,f.listeners=function(d){return[]},f.binding=function(d){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(d){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(De[35],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(A){return new O(A)}constructor(A){this._now=I&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=O}),define(De[4],Ie([1,0,9,75,3,76,35]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const g=!1,y=!1;var v;(function(p){p.None=()=>f.Disposable.None;function m(fe){if(y){const{onDidAddListener:ee}=fe,he=_.create();let ve=0;fe.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),ee?.()}}}function b(fe,ee){return ge(fe,()=>{},0,void 0,!0,void 0,ee)}p.defer=b;function D(fe){return(ee,he=null,ve)=>{let Pe=!1,B;return B=fe(G=>{if(!Pe)return B?B.dispose():Pe=!0,ee.call(he,G)},null,ve),Pe&&B.dispose(),B}}p.once=D;function M(fe,ee,he){return z((ve,Pe=null,B)=>fe(G=>ve.call(Pe,ee(G)),null,B),he)}p.map=M;function L(fe,ee,he){return z((ve,Pe=null,B)=>fe(G=>{ee(G),ve.call(Pe,G)},null,B),he)}p.forEach=L;function F(fe,ee,he){return z((ve,Pe=null,B)=>fe(G=>ee(G)&&ve.call(Pe,G),null,B),he)}p.filter=F;function x(fe){return fe}p.signal=x;function U(...fe){return(ee,he=null,ve)=>{const Pe=(0,f.combinedDisposable)(...fe.map(B=>B(G=>ee.call(he,G))));return V(Pe,ve)}}p.any=U;function N(fe,ee,he,ve){let Pe=he;return M(fe,B=>(Pe=ee(Pe,B),Pe),ve)}p.reduce=N;function z(fe,ee){let he;const ve={onWillAddFirstListener(){he=fe(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};ee||m(ve);const Pe=new c(ve);return ee?.add(Pe),Pe.event}function V(fe,ee){return ee instanceof Array?ee.push(fe):ee&&ee.add(fe),fe}function ge(fe,ee,he=100,ve=!1,Pe=!1,B,G){let se,oe,Y,me=0,ye;const xe={leakWarningThreshold:B,onWillAddFirstListener(){se=fe(Ze=>{me++,oe=ee(oe,Ze),ve&&!Y&&(We.fire(oe),oe=void 0),ye=()=>{const Xe=oe;oe=void 0,Y=void 0,(!ve||me>1)&&We.fire(Xe),me=0},typeof he=="number"?(clearTimeout(Y),Y=setTimeout(ye,he)):Y===void 0&&(Y=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&me>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,se.dispose()}};G||m(xe);const We=new c(xe);return G?.add(We),We.event}p.debounce=ge;function te(fe,ee=0,he){return p.debounce(fe,(ve,Pe)=>ve?(ve.push(Pe),ve):[Pe],ee,void 0,!0,void 0,he)}p.accumulate=te;function q(fe,ee=(ve,Pe)=>ve===Pe,he){let ve=!0,Pe;return F(fe,B=>{const G=ve||!ee(B,Pe);return ve=!1,Pe=B,G},he)}p.latch=q;function K(fe,ee,he){return[p.filter(fe,ee,he),p.filter(fe,ve=>!ee(ve),he)]}p.split=K;function ue(fe,ee=!1,he=[],ve){let Pe=he.slice(),B=fe(oe=>{Pe?Pe.push(oe):se.fire(oe)});ve&&ve.add(B);const G=()=>{Pe?.forEach(oe=>se.fire(oe)),Pe=null},se=new c({onWillAddFirstListener(){B||(B=fe(oe=>se.fire(oe)),ve&&ve.add(B))},onDidAddFirstListener(){Pe&&(ee?setTimeout(G):G())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return ve&&ve.add(se),se.event}p.buffer=ue;function ie(fe,ee){return(ve,Pe,B)=>{const G=ee(new Se);return fe(function(se){const oe=G.evaluate(se);oe!==ce&&ve.call(Pe,oe)},void 0,B)}}p.chain=ie;const ce=Symbol("HaltChainable");class Se{constructor(){this.steps=[]}map(ee){return this.steps.push(ee),this}forEach(ee){return this.steps.push(he=>(ee(he),he)),this}filter(ee){return this.steps.push(he=>ee(he)?he:ce),this}reduce(ee,he){let ve=he;return this.steps.push(Pe=>(ve=ee(ve,Pe),ve)),this}latch(ee=(he,ve)=>he===ve){let he=!0,ve;return this.steps.push(Pe=>{const B=he||!ee(Pe,ve);return he=!1,ve=Pe,B?Pe:ce}),this}evaluate(ee){for(const he of this.steps)if(ee=he(ee),ee===ce)break;return ee}}function j(fe,ee,he=ve=>ve){const ve=(...se)=>G.fire(he(...se)),Pe=()=>fe.on(ee,ve),B=()=>fe.removeListener(ee,ve),G=new c({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return G.event}p.fromNodeEventEmitter=j;function $(fe,ee,he=ve=>ve){const ve=(...se)=>G.fire(he(...se)),Pe=()=>fe.addEventListener(ee,ve),B=()=>fe.removeEventListener(ee,ve),G=new c({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return G.event}p.fromDOMEventEmitter=$;function X(fe){return new Promise(ee=>D(fe)(ee))}p.toPromise=X;function re(fe){const ee=new c;return fe.then(he=>{ee.fire(he)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}p.fromPromise=re;function Q(fe,ee,he){return ee(he),fe(ve=>ee(ve))}p.runAndSubscribe=Q;function Z(fe,ee){let he=null;function ve(B){he?.dispose(),he=new f.DisposableStore,ee(B,he)}ve(void 0);const Pe=fe(B=>ve(B));return(0,f.toDisposable)(()=>{Pe.dispose(),he?.dispose()})}p.runAndSubscribeWithStore=Z;class J{constructor(ee,he){this._observable=ee,this._counter=0,this._hasChanged=!1;const ve={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};he||m(ve),this.emitter=new c(ve),he&&he.add(this.emitter)}beginUpdate(ee){this._counter++}handlePossibleChange(ee){}handleChange(ee,he){this._hasChanged=!0}endUpdate(ee){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function be(fe,ee){return new J(fe,ee).emitter.event}p.fromObservable=be;function ae(fe){return ee=>{let he=0,ve=!1;const Pe={beginUpdate(){he++},endUpdate(){he--,he===0&&(fe.reportChanges(),ve&&(ve=!1,ee()))},handlePossibleChange(){},handleChange(){ve=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}p.fromObservableLight=ae})(v||(e.Event=v={}));class R{static{this.all=new Set}static{this._idPool=0}constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${R._idPool++}`,R.all.add(this)}start(m){this._stopWatch=new T.StopWatch,this.listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=R;let P=-1;function E(p){const m=P;return P=p,{dispose(){P=m}}}e.setGlobalLeakWarningThreshold=E;class S{constructor(m,b=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=b,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(m,b){const D=this.threshold;if(D<=0||b<D)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(m.value)||0;if(this._stacks.set(m.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let L,F=0;for(const[x,U]of this._stacks)(!L||F<U)&&(L=x,F=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${F}):`),console.warn(L)}return()=>{const L=this._stacks.get(m.value)||0;this._stacks.set(m.value,L-1)}}}class _{static create(){return new _(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class d{constructor(m){this.value=m,this.id=w++}}const o=2,u=(p,m)=>{if(p instanceof d)m(p);else for(let b=0;b<p.length;b++){const D=p[b];D&&m(D)}};class c{constructor(m){this._size=0,this._options=m,this._leakageMon=P>0||this._options?.leakWarningThreshold?new S(this._options?.leakWarningThreshold??P):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(g){const m=this._listeners;queueMicrotask(()=>{u(m,b=>b.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(m,b,D)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.Disposable.None;if(this._disposed)return f.Disposable.None;b&&(m=m.bind(b));const M=new d(m);let L,F;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(M.stack=_.create(),L=this._leakageMon.check(M.stack,this._size+1)),g&&(M.stack=F??_.create()),this._listeners?this._listeners instanceof d?(this._deliveryQueue??=new a,this._listeners=[this._listeners,M]):this._listeners.push(M):(this._options?.onWillAddFirstListener?.(this),this._listeners=M,this._options?.onDidAddFirstListener?.(this)),this._size++;const x=(0,f.toDisposable)(()=>{L?.(),this._removeListener(M)});return D instanceof f.DisposableStore?D.add(x):Array.isArray(D)&&D.push(x),x},this._event}_removeListener(m){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const b=this._listeners,D=b.indexOf(m);if(D===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,b[D]=void 0;const M=this._deliveryQueue.current===this;if(this._size*o<=b.length){let L=0;for(let F=0;F<b.length;F++)b[F]?b[L++]=b[F]:M&&(this._deliveryQueue.end--,L<this._deliveryQueue.i&&this._deliveryQueue.i--);b.length=L}}_deliver(m,b){if(!m)return;const D=this._options?.onListenerError||I.onUnexpectedError;if(!D){m.value(b);return}try{m.value(b)}catch(M){D(M)}}_deliverQueue(m){const b=m.current._listeners;for(;m.i<m.end;)this._deliver(b[m.i++],m.value);m.reset()}fire(m){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof d)this._deliver(this._listeners,m);else{const b=this._deliveryQueue;b.enqueue(this,m,this._listeners.length),this._deliverQueue(b)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=c;const h=()=>new a;e.createEventDeliveryQueue=h;class a{constructor(){this.i=-1,this.end=0}enqueue(m,b,D){this.i=0,this.end=D,this.current=m,this.value=b}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(m,b,D){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),u(this._listeners,M=>this._asyncDeliveryQueue.push([M.value,m]));this._asyncDeliveryQueue.size>0&&!b.isCancellationRequested;){const[M,L]=this._asyncDeliveryQueue.shift(),F=[],x={...L,token:b,waitUntil:U=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");D&&(U=D(U,M)),F.push(U)}};try{M(x)}catch(U){(0,I.onUnexpectedError)(U);continue}Object.freeze(F),await Promise.allSettled(F).then(U=>{for(const N of U)N.status==="rejected"&&(0,I.onUnexpectedError)(N.reason)})}}}e.AsyncEmitter=t;class i extends c{get isPaused(){return this._isPaused!==0}constructor(m){super(m),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._size&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=i;class s extends i{constructor(m){super(m),this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=s;class n extends c{constructor(m){super(m),this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this.hasListeners()&&(this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(b=>super.fire(b)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=n;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const b={event:m,listener:null};this.events.push(b),this.hasListeners&&this.hook(b);const D=()=>{this.hasListeners&&this.unhook(b);const M=this.events.indexOf(b);this.events.splice(M,1)};return(0,f.toDisposable)((0,O.createSingleCallFunction)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(b=>this.emitter.fire(b))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class l{constructor(m,b,D,M){this._store=new f.DisposableStore;const L=this._store.add(new r),F=this._store.add(new f.DisposableMap);function x(U){F.set(U,L.add(M(U)))}for(const U of m)x(U);this._store.add(b(U=>{x(U)})),this._store.add(D(U=>{F.deleteAndDispose(U)})),this.event=L.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=l;class k{constructor(){this.buffers=[]}wrapEvent(m){return(b,D,M)=>m(L=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>b.call(D,L)):b.call(D,L)},void 0,M)}bufferEvents(m){const b=[];this.buffers.push(b);const D=m();return this.buffers.pop(),b.forEach(M=>M()),D}}e.EventBufferer=k;class C{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=f.Disposable.None,this.emitter=new c({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(De[21],Ie([1,0,4]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(g,y){const v=setTimeout(g.bind(y),0);return{dispose(){clearTimeout(v)}}});var f;(function(g){function y(v){return v===g.None||v===g.Cancelled||v instanceof A?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}g.isCancellationToken=y,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(f||(e.CancellationToken=f={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=f.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=f.None}}e.CancellationTokenSource=T}),define(De[159],Ie([1,0,21]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(g){this.task=g,this.result=null}get(){if(this.result)return this.result;const g=new I.CancellationTokenSource,y=this.task(g.token);return this.result={promise:y,dispose:()=>{this.result=null,g.cancel(),g.dispose()}},this.result}}e.Cache=O;class f{constructor(g){this.fn=g,this.lastCache=void 0,this.lastArgKey=void 0}get(g){const y=JSON.stringify(g);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this.fn(g)),this.lastCache}}e.LRUCachedFunction=f;class A{get cachedValues(){return this._map}constructor(g){this.fn=g,this._map=new Map}get(g){if(this._map.has(g))return this._map.get(g);const y=this.fn(g);return this._map.set(g,y),y}}e.CachedFunction=A}),define(De[96],Ie([1,0,9,3]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function f(h){const a=h;return a?typeof a.read=="function":!1}e.isReadable=f;function A(h){const a=h;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function T(h){const a=h;return a?A(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=T;function g(h,a){return new y(h,a)}e.newWriteableStream=g;class y{constructor(a,t){this.reducer=a,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(t=>t(a))}emitError(a){this.listeners.error.length===0?(0,I.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(t=>t(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,t){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(a,t){if(this.state.destroyed)return;let i;switch(a){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(t);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(h,a){const t=[];let i;for(;(i=h.read())!==null;)t.push(i);return a(t)}e.consumeReadable=v;function R(h,a,t){const i=[];let s;for(;(s=h.read())!==null&&i.length<t;)i.push(s);return s===null&&i.length>0?a(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return h.read()}}}e.peekReadable=R;function P(h,a){return new Promise((t,i)=>{const s=[];E(h,{onData:n=>{a&&s.push(n)},onError:n=>{a?i(n):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}e.consumeStream=P;function E(h,a,t){h.on("error",i=>{t?.isCancellationRequested||a.onError(i)}),h.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),h.on("data",i=>{t?.isCancellationRequested||a.onData(i)})}e.listenStream=E;function S(h,a){return new Promise((t,i)=>{const s=new O.DisposableStore,n=[],r=C=>{if(n.push(C),n.length>a)return s.dispose(),h.pause(),t({stream:h,buffer:n,ended:!1})},l=C=>(s.dispose(),i(C)),k=()=>(s.dispose(),t({stream:h,buffer:n,ended:!0}));s.add((0,O.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),s.add((0,O.toDisposable)(()=>h.removeListener("end",k))),h.on("end",k),s.add((0,O.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=S;function _(h,a){const t=g(a);return t.end(h),t}e.toStream=_;function w(){const h=g(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=w;function d(h){let a=!1;return{read:()=>a?null:(a=!0,h)}}e.toReadable=d;function o(h,a,t){const i=g(t);return E(h,{onData:s=>i.write(a.data(s)),onError:s=>i.error(a.error?a.error(s):s),onEnd:()=>i.end()}),i}e.transform=o;function u(h,a,t){let i=!1;return{read:()=>{const s=a.read();return i?s:(i=!0,s!==null?t([h,s]):h)}}}e.prefixedReadable=u;function c(h,a,t){let i=!1;const s=g(t);return E(a,{onData:n=>i?s.write(n):(i=!0,s.write(t([h,n]))),onError:n=>s.error(n),onEnd:()=>{i||(i=!0,s.write(h)),s.end()}}),s}e.prefixedStream=c}),define(De[22],Ie([1,0,47,96]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const f=typeof Buffer<"u",A=new I.Lazy(()=>new Uint8Array(256));let T,g;class y{static alloc(b){return f?new y(Buffer.allocUnsafe(b)):new y(new Uint8Array(b))}static wrap(b){return f&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new y(b)}static fromString(b,D){return!(D?.dontUseNodeBuffer||!1)&&f?new y(Buffer.from(b)):(T||(T=new TextEncoder),new y(T.encode(b)))}static fromByteArray(b){const D=y.alloc(b.length);for(let M=0,L=b.length;M<L;M++)D.buffer[M]=b[M];return D}static concat(b,D){if(typeof D>"u"){D=0;for(let F=0,x=b.length;F<x;F++)D+=b[F].byteLength}const M=y.alloc(D);let L=0;for(let F=0,x=b.length;F<x;F++){const U=b[F];M.set(U,L),L+=U.byteLength}return M}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=y.alloc(this.byteLength);return b.set(this),b}toString(){return f?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(b,D){return new y(this.buffer.subarray(b,D))}set(b,D){if(b instanceof y)this.buffer.set(b.buffer,D);else if(b instanceof Uint8Array)this.buffer.set(b,D);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),D);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return E(this.buffer,b)}writeUInt32BE(b,D){S(this.buffer,b,D)}readUInt32LE(b){return _(this.buffer,b)}writeUInt32LE(b,D){w(this.buffer,b,D)}readUInt8(b){return d(this.buffer,b)}writeUInt8(b,D){o(this.buffer,b,D)}indexOf(b,D=0){return v(this.buffer,b instanceof y?b.buffer:b,D)}}e.VSBuffer=y;function v(m,b,D=0){const M=b.byteLength,L=m.byteLength;if(M===0)return 0;if(M===1)return m.indexOf(b[0]);if(M>L-D)return-1;const F=A.value;F.fill(b.length);for(let z=0;z<b.length;z++)F[b[z]]=b.length-z-1;let x=D+b.length-1,U=x,N=-1;for(;x<L;)if(m[x]===b[U]){if(U===0){N=x;break}x--,U--}else x+=Math.max(b.length-U,F[m[x]]),U=b.length-1;return N}e.binaryIndexOf=v;function R(m,b){return m[b+0]<<0>>>0|m[b+1]<<8>>>0}e.readUInt16LE=R;function P(m,b,D){m[D+0]=b&255,b=b>>>8,m[D+1]=b&255}e.writeUInt16LE=P;function E(m,b){return m[b]*2**24+m[b+1]*2**16+m[b+2]*2**8+m[b+3]}e.readUInt32BE=E;function S(m,b,D){m[D+3]=b,b=b>>>8,m[D+2]=b,b=b>>>8,m[D+1]=b,b=b>>>8,m[D]=b}e.writeUInt32BE=S;function _(m,b){return m[b+0]<<0>>>0|m[b+1]<<8>>>0|m[b+2]<<16>>>0|m[b+3]<<24>>>0}e.readUInt32LE=_;function w(m,b,D){m[D+0]=b&255,b=b>>>8,m[D+1]=b&255,b=b>>>8,m[D+2]=b&255,b=b>>>8,m[D+3]=b&255}e.writeUInt32LE=w;function d(m,b){return m[b]}e.readUInt8=d;function o(m,b,D){m[D]=b}e.writeUInt8=o;function u(m){return O.consumeReadable(m,b=>y.concat(b))}e.readableToBuffer=u;function c(m){return O.toReadable(m)}e.bufferToReadable=c;function h(m){return O.consumeStream(m,b=>y.concat(b))}e.streamToBuffer=h;async function a(m){return m.ended?y.concat(m.buffer):y.concat([...m.buffer,await h(m.stream)])}e.bufferedStreamToBuffer=a;function t(m){return O.toStream(m,b=>y.concat(b))}e.bufferToStream=t;function i(m){return O.transform(m,{data:b=>typeof b=="string"?y.fromString(b):y.wrap(b)},b=>y.concat(b))}e.streamToBufferReadableStream=i;function s(m){return O.newWriteableStream(b=>y.concat(b),m)}e.newWriteableBufferStream=s;function n(m,b){return O.prefixedReadable(m,b,D=>y.concat(D))}e.prefixedBufferReadable=n;function r(m,b){return O.prefixedStream(m,b,D=>y.concat(D))}e.prefixedBufferStream=r;function l(m){let b=0,D=0,M=0;const L=new Uint8Array(Math.floor(m.length/4*3)),F=U=>{switch(D){case 3:L[M++]=b|U,D=0;break;case 2:L[M++]=b|U>>>2,b=U<<6,D=3;break;case 1:L[M++]=b|U>>>4,b=U<<4,D=2;break;default:b=U<<2,D=1}};for(let U=0;U<m.length;U++){const N=m.charCodeAt(U);if(N>=65&&N<=90)F(N-65);else if(N>=97&&N<=122)F(N-97+26);else if(N>=48&&N<=57)F(N-48+52);else if(N===43||N===45)F(62);else if(N===47||N===95)F(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${m[U]}`)}}const x=M;for(;D>0;)F(0);return y.wrap(L).slice(0,x)}e.decodeBase64=l;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:m},b=!0,D=!1){const M=D?C:k;let L="";const F=m.byteLength%3;let x=0;for(;x<m.byteLength-F;x+=3){const U=m[x+0],N=m[x+1],z=m[x+2];L+=M[U>>>2],L+=M[(U<<4|N>>>4)&63],L+=M[(N<<2|z>>>6)&63],L+=M[z&63]}if(F===1){const U=m[x+0];L+=M[U>>>2],L+=M[U<<4&63],b&&(L+="==")}else if(F===2){const U=m[x+0],N=m[x+1];L+=M[U>>>2],L+=M[(U<<4|N>>>4)&63],L+=M[N<<2&63],b&&(L+="=")}return L}e.encodeBase64=p}),define(De[15],Ie([1,0,159,47]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function f(Te){return!Te||typeof Te!="string"?!0:Te.trim().length===0}e.isFalsyOrWhitespace=f;const A=/{(\d+)}/g;function T(Te,...Me){return Me.length===0?Te:Te.replace(A,function(ze,Re){const Qe=parseInt(Re,10);return isNaN(Qe)||Qe<0||Qe>=Me.length?ze:Me[Qe]})}e.format=T;const g=/{([^}]+)}/g;function y(Te,Me){return Object.keys(Me).length===0?Te:Te.replace(g,(ze,Re)=>Me[Re]??ze)}e.format2=y;function v(Te){return Te.replace(/[<>&]/g,function(Me){switch(Me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Me}})}e.escape=v;function R(Te){return Te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function P(Te,Me){let ze=0;const Re=Me.charCodeAt(0);for(let Qe=Te.length-1;Qe>=0;Qe--)Te.charCodeAt(Qe)===Re&&ze++;return ze}e.count=P;function E(Te,Me,ze="\u2026"){return Te.length<=Me?Te:`${Te.substr(0,Me)}${ze}`}e.truncate=E;function S(Te,Me=" "){const ze=_(Te,Me);return w(ze,Me)}e.trim=S;function _(Te,Me){if(!Te||!Me)return Te;const ze=Me.length;if(ze===0||Te.length===0)return Te;let Re=0;for(;Te.indexOf(Me,Re)===Re;)Re=Re+ze;return Te.substring(Re)}e.ltrim=_;function w(Te,Me){if(!Te||!Me)return Te;const ze=Me.length,Re=Te.length;if(ze===0||Re===0)return Te;let Qe=Re,de=-1;for(;de=Te.lastIndexOf(Me,Qe-1),!(de===-1||de+ze!==Qe);){if(de===0)return"";Qe=de}return Te.substring(0,Qe)}e.rtrim=w;function d(Te){return Te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function o(Te){return Te.replace(/\*/g,"")}e.stripWildcards=o;function u(Te,Me,ze={}){if(!Te)throw new Error("Cannot create regex from empty string");Me||(Te=R(Te)),ze.wholeWord&&(/\B/.test(Te.charAt(0))||(Te="\\b"+Te),/\B/.test(Te.charAt(Te.length-1))||(Te=Te+"\\b"));let Re="";return ze.global&&(Re+="g"),ze.matchCase||(Re+="i"),ze.multiline&&(Re+="m"),ze.unicode&&(Re+="u"),new RegExp(Te,Re)}e.createRegExp=u;function c(Te){return Te.source==="^"||Te.source==="^$"||Te.source==="$"||Te.source==="^\\s*$"?!1:!!(Te.exec("")&&Te.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function h(Te){return Te.split(/\r\n|\r|\n/)}e.splitLines=h;function a(Te){for(let Me=0,ze=Te.length;Me<ze;Me++){const Re=Te.charCodeAt(Me);if(Re!==32&&Re!==9)return Me}return-1}e.firstNonWhitespaceIndex=a;function t(Te,Me=0,ze=Te.length){for(let Re=Me;Re<ze;Re++){const Qe=Te.charCodeAt(Re);if(Qe!==32&&Qe!==9)return Te.substring(Me,Re)}return Te.substring(Me,ze)}e.getLeadingWhitespace=t;function i(Te,Me=Te.length-1){for(let ze=Me;ze>=0;ze--){const Re=Te.charCodeAt(ze);if(Re!==32&&Re!==9)return ze}return-1}e.lastNonWhitespaceIndex=i;function s(Te,Me,ze){const Re=[];let Qe=0;for(const de of Te.matchAll(Me)){if(Re.push(Te.slice(Qe,de.index)),de.index===void 0)throw new Error("match.index should be defined");Qe=de.index+de[0].length,Re.push(ze(de[0],...de.slice(1),de.index,Te,de.groups))}return Re.push(Te.slice(Qe)),Promise.all(Re).then(de=>de.join(""))}e.replaceAsync=s;function n(Te,Me){return Te<Me?-1:Te>Me?1:0}e.compare=n;function r(Te,Me,ze=0,Re=Te.length,Qe=0,de=Me.length){for(;ze<Re&&Qe<de;ze++,Qe++){const Ve=Te.charCodeAt(ze),Be=Me.charCodeAt(Qe);if(Ve<Be)return-1;if(Ve>Be)return 1}const le=Re-ze,ke=de-Qe;return le<ke?-1:le>ke?1:0}e.compareSubstring=r;function l(Te,Me){return k(Te,Me,0,Te.length,0,Me.length)}e.compareIgnoreCase=l;function k(Te,Me,ze=0,Re=Te.length,Qe=0,de=Me.length){for(;ze<Re&&Qe<de;ze++,Qe++){let Ve=Te.charCodeAt(ze),Be=Me.charCodeAt(Qe);if(Ve===Be)continue;if(Ve>=128||Be>=128)return r(Te.toLowerCase(),Me.toLowerCase(),ze,Re,Qe,de);p(Ve)&&(Ve-=32),p(Be)&&(Be-=32);const Ye=Ve-Be;if(Ye!==0)return Ye}const le=Re-ze,ke=de-Qe;return le<ke?-1:le>ke?1:0}e.compareSubstringIgnoreCase=k;function C(Te){return Te>=48&&Te<=57}e.isAsciiDigit=C;function p(Te){return Te>=97&&Te<=122}e.isLowerAsciiLetter=p;function m(Te){return Te>=65&&Te<=90}e.isUpperAsciiLetter=m;function b(Te,Me){return Te.length===Me.length&&k(Te,Me)===0}e.equalsIgnoreCase=b;function D(Te,Me){const ze=Me.length;return Me.length>Te.length?!1:k(Te,Me,0,ze)===0}e.startsWithIgnoreCase=D;function M(Te,Me){const ze=Math.min(Te.length,Me.length);let Re;for(Re=0;Re<ze;Re++)if(Te.charCodeAt(Re)!==Me.charCodeAt(Re))return Re;return ze}e.commonPrefixLength=M;function L(Te,Me){const ze=Math.min(Te.length,Me.length);let Re;const Qe=Te.length-1,de=Me.length-1;for(Re=0;Re<ze;Re++)if(Te.charCodeAt(Qe-Re)!==Me.charCodeAt(de-Re))return Re;return ze}e.commonSuffixLength=L;function F(Te){return 55296<=Te&&Te<=56319}e.isHighSurrogate=F;function x(Te){return 56320<=Te&&Te<=57343}e.isLowSurrogate=x;function U(Te,Me){return(Te-55296<<10)+(Me-56320)+65536}e.computeCodePoint=U;function N(Te,Me,ze){const Re=Te.charCodeAt(ze);if(F(Re)&&ze+1<Me){const Qe=Te.charCodeAt(ze+1);if(x(Qe))return U(Re,Qe)}return Re}e.getNextCodePoint=N;function z(Te,Me){const ze=Te.charCodeAt(Me-1);if(x(ze)&&Me>1){const Re=Te.charCodeAt(Me-2);if(F(Re))return U(Re,ze)}return ze}class V{get offset(){return this._offset}constructor(Me,ze=0){this._str=Me,this._len=Me.length,this._offset=ze}setOffset(Me){this._offset=Me}prevCodePoint(){const Me=z(this._str,this._offset);return this._offset-=Me>=65536?2:1,Me}nextCodePoint(){const Me=N(this._str,this._len,this._offset);return this._offset+=Me>=65536?2:1,Me}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class ge{get offset(){return this._iterator.offset}constructor(Me,ze=0){this._iterator=new V(Me,ze)}nextGraphemeLength(){const Me=me.getInstance(),ze=this._iterator,Re=ze.offset;let Qe=Me.getGraphemeBreakType(ze.nextCodePoint());for(;!ze.eol();){const de=ze.offset,le=Me.getGraphemeBreakType(ze.nextCodePoint());if(oe(Qe,le)){ze.setOffset(de);break}Qe=le}return ze.offset-Re}prevGraphemeLength(){const Me=me.getInstance(),ze=this._iterator,Re=ze.offset;let Qe=Me.getGraphemeBreakType(ze.prevCodePoint());for(;ze.offset>0;){const de=ze.offset,le=Me.getGraphemeBreakType(ze.prevCodePoint());if(oe(le,Qe)){ze.setOffset(de);break}Qe=le}return Re-ze.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ge;function te(Te,Me){return new ge(Te,Me).nextGraphemeLength()}e.nextCharLength=te;function q(Te,Me){return new ge(Te,Me).prevGraphemeLength()}e.prevCharLength=q;function K(Te,Me){Me>0&&x(Te.charCodeAt(Me))&&Me--;const ze=Me+te(Te,Me);return[ze-q(Te,ze),ze]}e.getCharContainingOffset=K;function ue(Te){const Me=new ge(Te);let ze=0;for(;!Me.eol();)ze++,Me.nextGraphemeLength();return ze}e.charCount=ue;let ie;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(Te){return ie||(ie=ce()),ie.test(Te)}e.containsRTL=Se;const j=/^[\t\n\r\x20-\x7E]*$/;function $(Te){return j.test(Te)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(Te){return e.UNUSUAL_LINE_TERMINATORS.test(Te)}e.containsUnusualLineTerminators=X;function re(Te){return Te>=11904&&Te<=55215||Te>=63744&&Te<=64255||Te>=65281&&Te<=65374}e.isFullWidthCharacter=re;function Q(Te){return Te>=127462&&Te<=127487||Te===8986||Te===8987||Te===9200||Te===9203||Te>=9728&&Te<=10175||Te===11088||Te===11093||Te>=127744&&Te<=128591||Te>=128640&&Te<=128764||Te>=128992&&Te<=129008||Te>=129280&&Te<=129535||Te>=129648&&Te<=129782}e.isEmojiImprecise=Q;function Z(Te,Me){if(Te.length<Me)return Te;const ze=/\b/g;let Re=0;for(;ze.test(Te)&&!(Te.length-ze.lastIndex<Me);)Re=ze.lastIndex,ze.lastIndex+=1;return Te.substring(Re).replace(/^\s/,"")}e.lcut=Z;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,be=/\x1b\].*?\x07/g;function ae(Te){return Te&&(Te=Te.replace(J,"").replace(be,"")),Te}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function fe(Te){return!!(Te&&Te.length>0&&Te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=fe;function ee(Te){return fe(Te)?Te.substr(1):Te}e.stripUTF8BOM=ee;function he(Te,Me){if(!Te||!Me||Te.length<Me.length)return!1;const ze=Me.length,Re=Te.toLowerCase();let Qe=0,de=-1;for(;Qe<ze;){const le=Re.indexOf(Me[Qe],de+1);if(le<0)return!1;de=le,Qe++}return!0}e.fuzzyContains=he;function ve(Te,Me=!1){return Te?(Me&&(Te=Te.replace(/\\./g,"")),Te.toLowerCase()!==Te):!1}e.containsUppercaseCharacter=ve;function Pe(Te){return Te.charAt(0).toUpperCase()+Te.slice(1)}e.uppercaseFirstLetter=Pe;function B(Te,Me=1){if(Me===0)return"";let ze=-1;do ze=Te.indexOf(`
`,ze+1),Me--;while(Me>0&&ze>=0);return ze===-1?Te:(Te[ze-1]==="\r"&&ze--,Te.substr(0,ze))}e.getNLines=B;function G(Te){return Te=Te%(2*26),Te<26?String.fromCharCode(97+Te):String.fromCharCode(65+Te-26)}e.singleLetterHash=G;function se(Te){return me.getInstance().getGraphemeBreakType(Te)}e.getGraphemeBreakType=se;function oe(Te,Me){return Te===0?Me!==5&&Me!==7:Te===2&&Me===3?!1:Te===4||Te===2||Te===3||Me===4||Me===2||Me===3?!0:!(Te===8&&(Me===8||Me===9||Me===11||Me===12)||(Te===11||Te===9)&&(Me===9||Me===10)||(Te===12||Te===10)&&Me===10||Me===5||Me===13||Me===7||Te===1||Te===13&&Me===14||Te===6&&Me===6)}var Y;(function(Te){Te[Te.Other=0]="Other",Te[Te.Prepend=1]="Prepend",Te[Te.CR=2]="CR",Te[Te.LF=3]="LF",Te[Te.Control=4]="Control",Te[Te.Extend=5]="Extend",Te[Te.Regional_Indicator=6]="Regional_Indicator",Te[Te.SpacingMark=7]="SpacingMark",Te[Te.L=8]="L",Te[Te.V=9]="V",Te[Te.T=10]="T",Te[Te.LV=11]="LV",Te[Te.LVT=12]="LVT",Te[Te.ZWJ=13]="ZWJ",Te[Te.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class me{static{this._INSTANCE=null}static getInstance(){return me._INSTANCE||(me._INSTANCE=new me),me._INSTANCE}constructor(){this._data=ye()}getGraphemeBreakType(Me){if(Me<32)return Me===10?3:Me===13?2:4;if(Me<127)return 0;const ze=this._data,Re=ze.length/3;let Qe=1;for(;Qe<=Re;)if(Me<ze[3*Qe])Qe=2*Qe;else if(Me>ze[3*Qe+1])Qe=2*Qe+1;else return ze[3*Qe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(Te,Me){if(Te===0)return 0;const ze=We(Te,Me);if(ze!==void 0)return ze;const Re=new V(Me,Te);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=xe;function We(Te,Me){const ze=new V(Me,Te);let Re=ze.prevCodePoint();for(;Ze(Re)||Re===65039||Re===8419;){if(ze.offset===0)return;Re=ze.prevCodePoint()}if(!Q(Re))return;let Qe=ze.offset;return Qe>0&&ze.prevCodePoint()===8205&&(Qe=ze.offset),Qe}function Ze(Te){return 127995<=Te&&Te<=127999}var Xe;(function(Te){Te[Te.zwj=8205]="zwj",Te[Te.emojiVariantSelector=65039]="emojiVariantSelector",Te[Te.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class it{static{this.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new I.LRUCachedFunction(Me=>{function ze(Ye){const nt=new Map;for(let ct=0;ct<Ye.length;ct+=2)nt.set(Ye[ct],Ye[ct+1]);return nt}function Re(Ye,nt){const ct=new Map(Ye);for(const[vt,yt]of nt)ct.set(vt,yt);return ct}function Qe(Ye,nt){if(!Ye)return nt;const ct=new Map;for(const[vt,yt]of Ye)nt.has(vt)&&ct.set(vt,yt);return ct}const de=this.ambiguousCharacterData.value;let le=Me.filter(Ye=>!Ye.startsWith("_")&&Ye in de);le.length===0&&(le=["_default"]);let ke;for(const Ye of le){const nt=ze(de[Ye]);ke=Qe(ke,nt)}const Ve=ze(de._common),Be=Re(Ve,ke);return new it(Be)})}static getInstance(Me){return it.cache.get(Array.from(Me))}static{this._locales=new O.Lazy(()=>Object.keys(it.ambiguousCharacterData.value).filter(Me=>!Me.startsWith("_")))}static getLocales(){return it._locales.value}constructor(Me){this.confusableDictionary=Me}isAmbiguous(Me){return this.confusableDictionary.has(Me)}getPrimaryConfusable(Me){return this.confusableDictionary.get(Me)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=it;class tt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(tt.getRawData())),this._data}static isInvisibleCharacter(Me){return tt.getData().has(Me)}static get codePoints(){return tt.getData()}}e.InvisibleCharacters=tt}),define(De[121],Ie([1,0,28,15]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function f(...ee){return function(he,ve){for(let Pe=0,B=ee.length;Pe<B;Pe++){const G=ee[Pe](he,ve);if(G)return G}return null}}e.or=f,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ee,he,ve){if(!ve||ve.length<he.length)return null;let Pe;return ee?Pe=O.startsWithIgnoreCase(ve,he):Pe=ve.indexOf(he)===0,Pe?he.length>0?[{start:0,end:he.length}]:[]:null}function T(ee,he){const ve=he.toLowerCase().indexOf(ee.toLowerCase());return ve===-1?null:[{start:ve,end:ve+ee.length}]}e.matchesContiguousSubString=T;function g(ee,he){return y(ee.toLowerCase(),he.toLowerCase(),0,0)}e.matchesSubString=g;function y(ee,he,ve,Pe){if(ve===ee.length)return[];if(Pe===he.length)return null;if(ee[ve]===he[Pe]){let B=null;return(B=y(ee,he,ve+1,Pe+1))?o({start:Pe,end:Pe+1},B):null}return y(ee,he,ve,Pe+1)}function v(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.isUpper=R;function P(ee){return 48<=ee&&ee<=57}function E(ee){return ee===32||ee===9||ee===10||ee===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>S.add(ee.charCodeAt(0)));function _(ee){return E(ee)||S.has(ee)}function w(ee,he){return ee===he||_(ee)&&_(he)}function d(ee){return v(ee)||R(ee)||P(ee)}function o(ee,he){return he.length===0?he=[ee]:ee.end===he[0].start?he[0].start=ee.start:he.unshift(ee),he}function u(ee,he){for(let ve=he;ve<ee.length;ve++){const Pe=ee.charCodeAt(ve);if(R(Pe)||P(Pe)||ve>0&&!d(ee.charCodeAt(ve-1)))return ve}return ee.length}function c(ee,he,ve,Pe){if(ve===ee.length)return[];if(Pe===he.length)return null;if(ee[ve]!==he[Pe].toLowerCase())return null;{let B=null,G=Pe+1;for(B=c(ee,he,ve+1,Pe+1);!B&&(G=u(he,G))<he.length;)B=c(ee,he,ve+1,G),G++;return B===null?null:o({start:Pe,end:Pe+1},B)}}function h(ee){let he=0,ve=0,Pe=0,B=0,G=0;for(let ye=0;ye<ee.length;ye++)G=ee.charCodeAt(ye),R(G)&&he++,v(G)&&ve++,d(G)&&Pe++,P(G)&&B++;const se=he/ee.length,oe=ve/ee.length,Y=Pe/ee.length,me=B/ee.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:Y,numericPercent:me}}function a(ee){const{upperPercent:he,lowerPercent:ve}=ee;return ve===0&&he>.6}function t(ee){const{upperPercent:he,lowerPercent:ve,alphaPercent:Pe,numericPercent:B}=ee;return ve>.2&&he<.8&&Pe>.6&&B<.2}function i(ee){let he=0,ve=0,Pe=0,B=0;for(let G=0;G<ee.length;G++)Pe=ee.charCodeAt(G),R(Pe)&&he++,v(Pe)&&ve++,E(Pe)&&B++;return(he===0||ve===0)&&B===0?ee.length<=30:he<=5}function s(ee,he){if(!he||(he=he.trim(),he.length===0)||!i(ee)||he.length>60)return null;const ve=h(he);if(!t(ve)){if(!a(ve))return null;he=he.toLowerCase()}let Pe=null,B=0;for(ee=ee.toLowerCase();B<he.length&&(Pe=c(ee,he,0,B))===null;)B=u(he,B+1);return Pe}e.matchesCamelCase=s;function n(ee,he,ve=!1){if(!he||he.length===0)return null;let Pe=null,B=0;for(ee=ee.toLowerCase(),he=he.toLowerCase();B<he.length&&(Pe=r(ee,he,0,B,ve))===null;)B=l(he,B+1);return Pe}e.matchesWords=n;function r(ee,he,ve,Pe,B){if(ve===ee.length)return[];if(Pe===he.length)return null;if(w(ee.charCodeAt(ve),he.charCodeAt(Pe))){let G=null,se=Pe+1;if(G=r(ee,he,ve+1,Pe+1,B),!B)for(;!G&&(se=l(he,se))<he.length;)G=r(ee,he,ve+1,se,B),se++;return G?ee.charCodeAt(ve)!==he.charCodeAt(Pe)?G:o({start:Pe,end:Pe+1},G):null}else return null}function l(ee,he){for(let ve=he;ve<ee.length;ve++)if(_(ee.charCodeAt(ve))||ve>0&&_(ee.charCodeAt(ve-1)))return ve;return ee.length}const k=f(e.matchesPrefix,s,T),C=f(e.matchesPrefix,s,g),p=new I.LRUCache(1e4);function m(ee,he,ve=!1){if(typeof ee!="string"||typeof he!="string")return null;let Pe=p.get(ee);Pe||(Pe=new RegExp(O.convertSimple2RegExpPattern(ee),"i"),p.set(ee,Pe));const B=Pe.exec(he);return B?[{start:B.index,end:B.index+B[0].length}]:ve?C(ee,he):k(ee,he)}e.matchesFuzzy=m;function b(ee,he){const ve=re(ee,ee.toLowerCase(),0,he,he.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ve?M(ve):null}e.matchesFuzzy2=b;function D(ee,he,ve,Pe,B,G){const se=Math.min(13,ee.length);for(;ve<se;ve++){const oe=re(ee,he,ve,Pe,B,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,G]}e.anyScore=D;function M(ee){if(typeof ee>"u")return[];const he=[],ve=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const B=ee[Pe]+ve,G=he[he.length-1];G&&G.end===B?G.end=B+1:he.push({start:B,end:B+1})}return he}e.createMatches=M;const L=128;function F(){const ee=[],he=[];for(let ve=0;ve<=L;ve++)he[ve]=0;for(let ve=0;ve<=L;ve++)ee.push(he.slice(0));return ee}function x(ee){const he=[];for(let ve=0;ve<=ee;ve++)he[ve]=0;return he}const U=x(2*L),N=x(2*L),z=F(),V=F(),ge=F(),te=!1;function q(ee,he,ve,Pe,B){function G(oe,Y,me=" "){for(;oe.length<Y;)oe=me+oe;return oe}let se=` |   |${Pe.split("").map(oe=>G(oe,3)).join("|")}
`;for(let oe=0;oe<=ve;oe++)oe===0?se+=" |":se+=`${he[oe-1]}|`,se+=ee[oe].slice(0,B+1).map(Y=>G(Y.toString(),3)).join("|")+`
`;return se}function K(ee,he,ve,Pe){ee=ee.substr(he),ve=ve.substr(Pe),console.log(q(V,ee,ee.length,ve,ve.length)),console.log(q(ge,ee,ee.length,ve,ve.length)),console.log(q(z,ee,ee.length,ve,ve.length))}function ue(ee,he){if(he<0||he>=ee.length)return!1;const ve=ee.codePointAt(he);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.isEmojiImprecise(ve)}}function ie(ee,he){if(he<0||he>=ee.length)return!1;switch(ee.charCodeAt(he)){case 32:case 9:return!0;default:return!1}}function ce(ee,he,ve){return he[ee]!==ve[ee]}function Se(ee,he,ve,Pe,B,G,se=!1){for(;he<ve&&B<G;)ee[he]===Pe[B]&&(se&&(U[he]=B),he+=1),B+=1;return he===ve}e.isPatternInWord=Se;var j;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(j||(j={}));var $;(function(ee){ee.Default=[-100,0];function he(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}ee.isDefault=he})($||(e.FuzzyScore=$={}));class X{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(he,ve){this.firstMatchCanBeWeak=he,this.boostFullMatch=ve}}e.FuzzyScoreOptions=X;function re(ee,he,ve,Pe,B,G,se=X.default){const oe=ee.length>L?L:ee.length,Y=Pe.length>L?L:Pe.length;if(ve>=oe||G>=Y||oe-ve>Y-G||!Se(he,ve,oe,B,G,Y,!0))return;Q(oe,Y,ve,G,he,B);let me=1,ye=1,xe=ve,We=G;const Ze=[!1];for(me=1,xe=ve;xe<oe;me++,xe++){const Me=U[xe],ze=N[xe],Re=xe+1<oe?N[xe+1]:Y;for(ye=Me-G+1,We=Me;We<Re;ye++,We++){let Qe=Number.MIN_SAFE_INTEGER,de=!1;We<=ze&&(Qe=Z(ee,he,xe,ve,Pe,B,We,Y,G,z[me-1][ye-1]===0,Ze));let le=0;Qe!==Number.MAX_SAFE_INTEGER&&(de=!0,le=Qe+V[me-1][ye-1]);const ke=We>Me,Ve=ke?V[me][ye-1]+(z[me][ye-1]>0?-5:0):0,Be=We>Me+1&&z[me][ye-1]>0,Ye=Be?V[me][ye-2]+(z[me][ye-2]>0?-5:0):0;if(Be&&(!ke||Ye>=Ve)&&(!de||Ye>=le))V[me][ye]=Ye,ge[me][ye]=3,z[me][ye]=0;else if(ke&&(!de||Ve>=le))V[me][ye]=Ve,ge[me][ye]=2,z[me][ye]=0;else if(de)V[me][ye]=le,ge[me][ye]=1,z[me][ye]=z[me-1][ye-1]+1;else throw new Error("not possible")}}if(te&&K(ee,ve,Pe,G),!Ze[0]&&!se.firstMatchCanBeWeak)return;me--,ye--;const Xe=[V[me][ye],G];let it=0,tt=0;for(;me>=1;){let Me=ye;do{const ze=ge[me][Me];if(ze===3)Me=Me-2;else if(ze===2)Me=Me-1;else break}while(Me>=1);it>1&&he[ve+me-1]===B[G+ye-1]&&!ce(Me+G-1,Pe,B)&&it+1>z[me][Me]&&(Me=ye),Me===ye?it++:it=1,tt||(tt=Me),me--,ye=Me-1,Xe.push(ye)}Y===oe&&se.boostFullMatch&&(Xe[0]+=2);const Te=tt-oe;return Xe[0]-=Te,Xe}e.fuzzyScore=re;function Q(ee,he,ve,Pe,B,G){let se=ee-1,oe=he-1;for(;se>=ve&&oe>=Pe;)B[se]===G[oe]&&(N[se]=oe,se--),oe--}function Z(ee,he,ve,Pe,B,G,se,oe,Y,me,ye){if(he[ve]!==G[se])return Number.MIN_SAFE_INTEGER;let xe=1,We=!1;return se===ve-Pe?xe=ee[ve]===B[se]?7:5:ce(se,B,G)&&(se===0||!ce(se-1,B,G))?(xe=ee[ve]===B[se]?7:5,We=!0):ue(G,se)&&(se===0||!ue(G,se-1))?xe=5:(ue(G,se-1)||ie(G,se-1))&&(xe=5,We=!0),xe>1&&ve===Pe&&(ye[0]=!0),We||(We=ce(se,B,G)||ue(G,se-1)||ie(G,se-1)),ve===Pe?se>Y&&(xe-=We?3:5):me?xe+=We?2:0:xe+=We?0:1,se+1===oe&&(xe-=We?3:5),xe}function J(ee,he,ve,Pe,B,G,se){return ae(ee,he,ve,Pe,B,G,!0,se)}e.fuzzyScoreGracefulAggressive=J;function be(ee,he,ve,Pe,B,G,se){return ae(ee,he,ve,Pe,B,G,!1,se)}e.fuzzyScoreGraceful=be;function ae(ee,he,ve,Pe,B,G,se,oe){let Y=re(ee,he,ve,Pe,B,G,oe);if(Y&&!se)return Y;if(ee.length>=3){const me=Math.min(7,ee.length-1);for(let ye=ve+1;ye<me;ye++){const xe=fe(ee,ye);if(xe){const We=re(xe,xe.toLowerCase(),ve,Pe,B,G,oe);We&&(We[0]-=3,(!Y||We[0]>Y[0])&&(Y=We))}}}return Y}function fe(ee,he){if(he+1>=ee.length)return;const ve=ee[he],Pe=ee[he+1];if(ve!==Pe)return ee.slice(0,he)+Pe+ve+ee.slice(he+2)}}),define(De[52],Ie([1,0,15]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(o){return f(o,0)}e.hash=O;function f(o,u){switch(typeof o){case"object":return o===null?A(349,u):Array.isArray(o)?y(o,u):v(o,u);case"string":return g(o,u);case"boolean":return T(o,u);case"number":return A(o,u);case"undefined":return A(937,u);default:return A(617,u)}}e.doHash=f;function A(o,u){return(u<<5)-u+o|0}e.numberHash=A;function T(o,u){return A(o?433:863,u)}function g(o,u){u=A(149417,u);for(let c=0,h=o.length;c<h;c++)u=A(o.charCodeAt(c),u);return u}e.stringHash=g;function y(o,u){return u=A(104579,u),o.reduce((c,h)=>f(h,c),u)}function v(o,u){return u=A(181387,u),Object.keys(o).sort().reduce((c,h)=>(c=g(h,c),f(o[h],c)),u)}class R{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=f(u,this._value),this._value}}e.Hasher=R;var P;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(o,u,c=32){const h=c-u,a=~((1<<h)-1);return(o<<u|(a&o)>>>h)>>>0}function S(o,u=0,c=o.byteLength,h=0){for(let a=0;a<c;a++)o[u+a]=h}function _(o,u,c="0"){for(;o.length<u;)o=c+o;return o}function w(o,u=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(c=>c.toString(16).padStart(2,"0")).join(""):_((o>>>0).toString(16),u/4)}e.toHexString=w;class d{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const c=u.length;if(c===0)return;const h=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=u.charCodeAt(0),s=0);;){let n=i;if(I.isHighSurrogate(i))if(s+1<c){const r=u.charCodeAt(s+1);I.isLowSurrogate(r)?(s++,n=I.computeCodePoint(i,r)):n=65533}else{t=i;break}else I.isLowSurrogate(i)&&(n=65533);if(a=this._push(h,a,n),s++,s<c)i=u.charCodeAt(s);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(u,c,h){return h<128?u[c++]=h:h<2048?(u[c++]=192|(h&1984)>>>6,u[c++]=128|(h&63)>>>0):h<65536?(u[c++]=224|(h&61440)>>>12,u[c++]=128|(h&4032)>>>6,u[c++]=128|(h&63)>>>0):(u[c++]=240|(h&1835008)>>>18,u[c++]=128|(h&258048)>>>12,u[c++]=128|(h&4032)>>>6,u[c++]=128|(h&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=d._bigBlock32,c=this._buffDV;for(let k=0;k<64;k+=4)u.setUint32(k,c.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)u.setUint32(k,E(u.getUint32(k-12,!1)^u.getUint32(k-32,!1)^u.getUint32(k-56,!1)^u.getUint32(k-64,!1),1),!1);let h=this._h0,a=this._h1,t=this._h2,i=this._h3,s=this._h4,n,r,l;for(let k=0;k<80;k++)k<20?(n=a&t|~a&i,r=1518500249):k<40?(n=a^t^i,r=1859775393):k<60?(n=a&t|a&i|t&i,r=2400959708):(n=a^t^i,r=3395469782),l=E(h,5)+n+s+r+u.getUint32(k*4,!1)&4294967295,s=i,i=t,t=E(a,30),a=h,h=l;this._h0=this._h0+h&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=d}),define(De[38],Ie([1,0,15]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(O||(O={})),function(f){const A="error",T="warning",g="warn",y="info",v="ignore";function R(E){return E?I.equalsIgnoreCase(A,E)?f.Error:I.equalsIgnoreCase(T,E)||I.equalsIgnoreCase(g,E)?f.Warning:I.equalsIgnoreCase(y,E)?f.Info:f.Ignore:f.Ignore}f.fromValue=R;function P(E){switch(E){case f.Error:return A;case f.Warning:return T;case f.Info:return y;default:return v}}f.toString=P}(O||(O={})),e.default=O}),define(De[160],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[78],Ie([1,0,19,15]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class f{constructor(){this._value="",this._pos=0}reset(S){return this._value=S,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(S){const _=S.charCodeAt(0),w=this._value.charCodeAt(this._pos);return _-w}value(){return this._value[this._pos]}}e.StringIterator=f;class A{constructor(S=!0){this._caseSensitive=S}reset(S){return this._value=S,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let S=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(S)this._from++;else break;else S=!1;return this}cmp(S){return this._caseSensitive?(0,O.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class T{constructor(S=!0,_=!0){this._splitOnBackslash=S,this._caseSensitive=_}reset(S){this._from=0,this._to=0,this._value=S,this._valueLen=S.length;for(let _=S.length-1;_>=0;_--,this._valueLen--){const w=this._value.charCodeAt(_);if(!(w===47||this._splitOnBackslash&&w===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let S=!0;for(;this._to<this._valueLen;this._to++){const _=this._value.charCodeAt(this._to);if(_===47||this._splitOnBackslash&&_===92)if(S)this._from++;else break;else S=!1}return this}cmp(S){return this._caseSensitive?(0,O.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var g;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(g||(g={}));class y{constructor(S,_){this._ignorePathCasing=S,this._ignoreQueryAndFragment=_,this._states=[],this._stateIdx=0}reset(S){return this._value=S,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(S)),this._pathIterator.reset(S.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(S)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(S){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(S,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(S,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(S);if(this._states[this._stateIdx]===4)return(0,O.compare)(S,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(S,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(R||(R={}));class P{static forUris(S=()=>!1,_=()=>!1){return new P(new y(S,_))}static forPaths(S=!1){return new P(new T(void 0,!S))}static forStrings(){return new P(new f)}static forConfigKeys(){return new P(new A)}constructor(S){this._iter=S}clear(){this._root=void 0}fill(S,_){if(_){const w=_.slice(0);(0,I.shuffle)(w);for(const d of w)this.set(d,S)}else{const w=S.slice(0);(0,I.shuffle)(w);for(const d of w)this.set(d[0],d[1])}}set(S,_){const w=this._iter.reset(S);let d;this._root||(this._root=new v,this._root.segment=w.value());const o=[];for(d=this._root;;){const c=w.cmp(d.segment);if(c>0)d.left||(d.left=new v,d.left.segment=w.value()),o.push([-1,d]),d=d.left;else if(c<0)d.right||(d.right=new v,d.right.segment=w.value()),o.push([1,d]),d=d.right;else if(w.hasNext())w.next(),d.mid||(d.mid=new v,d.mid.segment=w.value()),o.push([0,d]),d=d.mid;else break}const u=d.value;d.value=_,d.key=S;for(let c=o.length-1;c>=0;c--){const h=o[c][1];h.updateHeight();const a=h.balanceFactor();if(a<-1||a>1){const t=o[c][0],i=o[c+1][0];if(t===1&&i===1)o[c][1]=h.rotateLeft();else if(t===-1&&i===-1)o[c][1]=h.rotateRight();else if(t===1&&i===-1)h.right=o[c+1][1]=o[c+1][1].rotateRight(),o[c][1]=h.rotateLeft();else if(t===-1&&i===1)h.left=o[c+1][1]=o[c+1][1].rotateLeft(),o[c][1]=h.rotateRight();else throw new Error;if(c>0)switch(o[c-1][0]){case-1:o[c-1][1].left=o[c][1];break;case 1:o[c-1][1].right=o[c][1];break;case 0:o[c-1][1].mid=o[c][1];break}else this._root=o[0][1]}}return u}get(S){return this._getNode(S)?.value}_getNode(S){const _=this._iter.reset(S);let w=this._root;for(;w;){const d=_.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(_.hasNext())_.next(),w=w.mid;else break}return w}has(S){const _=this._getNode(S);return!(_?.value===void 0&&_?.mid===void 0)}delete(S){return this._delete(S,!1)}deleteSuperstr(S){return this._delete(S,!0)}_delete(S,_){const w=this._iter.reset(S),d=[];let o=this._root;for(;o;){const u=w.cmp(o.segment);if(u>0)d.push([-1,o]),o=o.left;else if(u<0)d.push([1,o]),o=o.right;else if(w.hasNext())w.next(),d.push([0,o]),o=o.mid;else break}if(o){if(_?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const u=this._min(o.right);if(u.key){const{key:c,value:h,segment:a}=u;this._delete(u.key,!1),o.key=c,o.value=h,o.segment=a}}else{const u=o.left??o.right;if(d.length>0){const[c,h]=d[d.length-1];switch(c){case-1:h.left=u;break;case 0:h.mid=u;break;case 1:h.right=u;break}}else this._root=u}for(let u=d.length-1;u>=0;u--){const c=d[u][1];c.updateHeight();const h=c.balanceFactor();if(h>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),d[u][1]=c.rotateLeft()):h<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),d[u][1]=c.rotateRight()),u>0)switch(d[u-1][0]){case-1:d[u-1][1].left=d[u][1];break;case 1:d[u-1][1].right=d[u][1];break;case 0:d[u-1][1].mid=d[u][1];break}else this._root=d[0][1]}}}_min(S){for(;S.left;)S=S.left;return S}findSubstr(S){const _=this._iter.reset(S);let w=this._root,d;for(;w;){const o=_.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(_.hasNext())_.next(),d=w.value||d,w=w.mid;else break}return w&&w.value||d}findSuperstr(S){return this._findSuperstrOrElement(S,!1)}_findSuperstrOrElement(S,_){const w=this._iter.reset(S);let d=this._root;for(;d;){const o=w.cmp(d.segment);if(o>0)d=d.left;else if(o<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else return d.mid?this._entries(d.mid):_?d.value:void 0}}hasElementOrSubtree(S){return this._findSuperstrOrElement(S,!0)!==void 0}forEach(S){for(const[_,w]of this)S(w,_)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(S){const _=[];return this._dfsEntries(S,_),_[Symbol.iterator]()}_dfsEntries(S,_){S&&(S.left&&this._dfsEntries(S.left,_),S.value&&_.push([S.key,S.value]),S.mid&&this._dfsEntries(S.mid,_),S.right&&this._dfsEntries(S.right,_))}_isBalanced(){const S=_=>{if(!_)return!0;const w=_.balanceFactor();return w<-1||w>1?!1:S(_.left)&&S(_.right)};return S(this._root)}}e.TernarySearchTree=P}),define(De[17],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(a){return typeof a=="string"}e.isString=I;function O(a){return Array.isArray(a)&&a.every(t=>I(t))}e.isStringArray=O;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=f;function A(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.isTypedArray=A;function T(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=T;function g(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=g;function y(a){return a===!0||a===!1}e.isBoolean=y;function v(a){return typeof a>"u"}e.isUndefined=v;function R(a){return!P(a)}e.isDefined=R;function P(a){return v(a)||a===null}e.isUndefinedOrNull=P;function E(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=E;function S(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=S;function _(...a){const t=[];for(let i=0;i<a.length;i++){const s=a[i];if(P(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.assertAllDefined=_;const w=Object.prototype.hasOwnProperty;function d(a){if(!f(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.isEmptyObject=d;function o(a){return typeof a=="function"}e.isFunction=o;function u(...a){return a.length>0&&a.every(o)}e.areFunctions=u;function c(a,t){const i=Math.min(a.length,t.length);for(let s=0;s<i;s++)h(a[s],t[s])}e.validateConstraints=c;function h(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!P(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h}),define(De[79],Ie([1,0,17]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const O=Object.create(null);function f(g,y){if((0,I.isString)(y)){const v=O[y];if(v===void 0)throw new Error(`${g} references an unknown codicon: ${y}`);y=v}return O[g]=y,{id:g}}function A(){return O}e.getCodiconFontCharacters=A;function T(){return Object.values(e.Codicon)}e.getAllCodicons=T,e.Codicon={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(De[24],Ie([1,0,17]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ensureOptionalStringValue=e.ensureOptionalNumberValue=e.ensureOptionalBooleanValue=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const a=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([t,i])=>{a[t]=i&&typeof i=="object"?O(i):i}),a}e.deepClone=O;function f(h){if(!h||typeof h!="object")return h;const a=[h];for(;a.length>0;){const t=a.shift();Object.freeze(t);for(const i in t)if(A.call(t,i)){const s=t[i];typeof s=="object"&&!Object.isFrozen(s)&&!(0,I.isTypedArray)(s)&&a.push(s)}}return h}e.deepFreeze=f;const A=Object.prototype.hasOwnProperty;function T(h,a){return g(h,a,new Set)}e.cloneAndChange=T;function g(h,a,t){if((0,I.isUndefinedOrNull)(h))return h;const i=a(h);if(typeof i<"u")return i;if(Array.isArray(h)){const s=[];for(const n of h)s.push(g(n,a,t));return s}if((0,I.isObject)(h)){if(t.has(h))throw new Error("Cannot clone recursive data-structure");t.add(h);const s={};for(const n in h)A.call(h,n)&&(s[n]=g(h[n],a,t));return t.delete(h),s}return h}function y(h,a,t=!0){return(0,I.isObject)(h)?((0,I.isObject)(a)&&Object.keys(a).forEach(i=>{i in h?t&&((0,I.isObject)(h[i])&&(0,I.isObject)(a[i])?y(h[i],a[i],t):h[i]=a[i]):h[i]=a[i]}),h):a}e.mixin=y;function v(h,a){if(h===a)return!0;if(h==null||a===null||a===void 0||typeof h!=typeof a||typeof h!="object"||Array.isArray(h)!==Array.isArray(a))return!1;let t,i;if(Array.isArray(h)){if(h.length!==a.length)return!1;for(t=0;t<h.length;t++)if(!v(h[t],a[t]))return!1}else{const s=[];for(i in h)s.push(i);s.sort();const n=[];for(i in a)n.push(i);if(n.sort(),!v(s,n))return!1;for(t=0;t<s.length;t++)if(!v(h[s[t]],a[s[t]]))return!1}return!0}e.equals=v;function R(h){const a=new Set;return JSON.stringify(h,(t,i)=>{if((0,I.isObject)(i)||Array.isArray(i)){if(a.has(i))return"[Circular]";a.add(i)}return i})}e.safeStringify=R;function P(h,a){const t=Object.create(null);return!h||!a||Object.keys(a).forEach(s=>{const n=h[s],r=a[s];v(n,r)||(t[s]=r)}),t}e.distinct=P;function E(h,a){const t=a.toLowerCase(),i=Object.keys(h).find(s=>s.toLowerCase()===t);return i?h[i]:h[a]}e.getCaseInsensitive=E;function S(h,a){const t=Object.create(null);for(const[i,s]of Object.entries(h))a(i,s)&&(t[i]=s);return t}e.filter=S;function _(h){let a=[];for(;Object.prototype!==h;)a=a.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return a}e.getAllPropertyNames=_;function w(h){const a=[];for(const t of _(h))typeof h[t]=="function"&&a.push(t);return a}e.getAllMethodNames=w;function d(h,a){const t=s=>function(){const n=Array.prototype.slice.call(arguments,0);return a(s,n)},i={};for(const s of h)i[s]=t(s);return i}e.createProxyObject=d;function o(h,a,t){typeof a=="string"&&h[a]!==void 0&&typeof h[a]!="boolean"&&(h[a]=t)}e.ensureOptionalBooleanValue=o;function u(h,a,t){typeof a=="string"&&h[a]!==void 0&&typeof h[a]!="number"&&(h[a]=t)}e.ensureOptionalNumberValue=u;function c(h,a,t,i){if(typeof a!="string")return;const s=h[a];s!==void 0&&(typeof s!="string"||!t.includes(s))&&(h[a]=i)}e.ensureOptionalStringValue=c}),define(De[59],Ie([1,0,79]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var O;(function(T){function g(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=g})(O||(e.ThemeColor=O={}));function f(T){return{id:T}}e.themeColorFromId=f;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(u){const c=g.exec(u.id);if(!c)return y(I.Codicon.error);const[,h,a]=c,t=["codicon","codicon-"+h];return a&&t.push("codicon-modifier-"+a.substring(1)),t}T.asClassNameArray=y;function v(u){return y(u).join(" ")}T.asClassName=v;function R(u){return"."+y(u).join(".")}T.asCSSSelector=R;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||O.isThemeColor(u.color))}T.isThemeIcon=P;const E=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function S(u){const c=E.exec(u);if(!c)return;const[,h]=c;return{id:h}}T.fromString=S;function _(u){return{id:u}}T.fromId=_;function w(u,c){let h=u.id;const a=h.lastIndexOf("~");return a!==-1&&(h=h.substring(0,a)),c&&(h=`${h}~${c}`),{id:h}}T.modify=w;function d(u){const c=u.id.lastIndexOf("~");if(c!==-1)return u.id.substring(c+1)}T.getModifier=d;function o(u,c){return u.id===c.id&&u.color?.id===c.color?.id}T.isEqual=o})(A||(e.ThemeIcon=A={}))}),define(De[161],Ie([1,0,121,15,59]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",T=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${T.source}`,"g");function y(o){return o.replace(g,(u,c)=>c?u:`\\${u}`)}e.escapeIcons=y;const v=new RegExp(`\\\\${T.source}`,"g");function R(o){return o.replace(v,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=R;const P=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function E(o){return o.indexOf(A)===-1?o:o.replace(P,(u,c,h,a)=>h?u:c||a||"")}e.stripIcons=E;function S(o){return o?o.replace(/\$\((.*?)\)/g,(u,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=S;const _=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(o){_.lastIndex=0;let u="";const c=[];let h=0;for(;;){const a=_.lastIndex,t=_.exec(o),i=o.substring(a,t?.index);if(i.length>0){u+=i;for(let s=0;s<i.length;s++)c.push(h)}if(!t)break;h+=t[0].length}return{text:u,iconOffsets:c}}e.parseLabelWithIcons=w;function d(o,u,c=!1){const{text:h,iconOffsets:a}=u;if(!a||a.length===0)return(0,I.matchesFuzzy)(o,h,c);const t=(0,O.ltrim)(h," "),i=h.length-t.length,s=(0,I.matchesFuzzy)(o,t,c);if(s)for(const n of s){const r=a[n.start+i]+i;n.start+=r,n.end+=r}return s}e.matchesFuzzyIconAware=d}),define(De[122],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var I;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function O(A){return A<0?0:A>255?255:A|0}e.toUint8=O;function f(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=f}),define(De[31],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(f){return I.test(f)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(g){for(let y=0;y<g.length;y++)g[y]=Math.floor(Math.random()*256);return g};const A=new Uint8Array(16),T=[];for(let g=0;g<256;g++)T.push(g.toString(16).padStart(2,"0"));return function(){f(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let y=0,v="";return v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v}}()}),define(De[162],Ie([1,0,19,51,31]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function A(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=A;function T(P,E,S){const _={id:(0,f.generateUuid)(),name:P,uri:E,data:S};return{asString:async()=>"",asFile:()=>_,value:void 0}}e.createFileDataTransferItem=T;class g{constructor(){this._entries=new Map}get size(){let E=0;for(const S of this._entries)E++;return E}has(E){return this._entries.has(this.toKey(E))}matches(E){const S=[...this._entries.keys()];return O.Iterable.some(this,([_,w])=>w.asFile())&&S.push("files"),R(y(E),S)}get(E){return this._entries.get(this.toKey(E))?.[0]}append(E,S){const _=this._entries.get(E);_?_.push(S):this._entries.set(this.toKey(E),[S])}replace(E,S){this._entries.set(this.toKey(E),[S])}delete(E){this._entries.delete(this.toKey(E))}*[Symbol.iterator](){for(const[E,S]of this._entries)for(const _ of S)yield[E,_]}toKey(E){return y(E)}}e.VSDataTransfer=g;function y(P){return P.toLowerCase()}function v(P,E){return R(y(P),E.map(y))}e.matchesMimeType=v;function R(P,E){if(P==="*/*")return E.length>0;if(E.includes(P))return!0;const S=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[_,w,d]=S;return d==="*"?E.some(o=>o.startsWith(w+"/")):!1}e.UriList=Object.freeze({create:P=>(0,I.distinct)(P.map(E=>E.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(E=>!E.startsWith("#"))})}),define(De[163],Ie([1,0,60]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(g,y,v,R=1){let P=!1;return new Promise(E=>{const S=setTimeout(()=>{if(!P)return P=!0,E(0)},v);f(g,y,R,_=>{if(!P)return P=!0,clearTimeout(S),E(_)})})}e.findFreePort=O;function f(g,y,v,R){if(y===0)return R(0);const P=new I.Socket;P.once("connect",()=>(T(P),f(g+v,y-1,v,R))),P.once("data",()=>{}),P.once("error",E=>(T(P),E.code!=="ECONNREFUSED"?f(g+v,y-1,v,R):R(g))),P.connect(g,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(g,y,v,R="127.0.0.1"){let P=!1,E,S=1;const _=I.createServer({pauseOnConnect:!0});function w(d,o){P||(P=!0,_.removeAllListeners(),_.close(),E&&clearTimeout(E),o(d))}return new Promise(d=>{E=setTimeout(()=>{w(0,d)},v),_.on("listening",()=>{w(g,d)}),_.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&S<y?(g++,S++,_.listen(g,R)):w(0,d)}),_.on("close",()=>{w(0,d)}),_.listen(g,R)})}e.findFreePortFaster=A;function T(g){try{g.removeAllListeners("connect"),g.removeAllListeners("error"),g.end(),g.destroy(),g.unref()}catch(y){console.error(y)}}}),define(De[123],Ie([1,0,122]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class O{constructor(g){const y=(0,I.toUint8)(g);this._defaultValue=y,this._asciiMap=O._createAsciiMap(y),this._map=new Map}static _createAsciiMap(g){const y=new Uint8Array(256);return y.fill(g),y}set(g,y){const v=(0,I.toUint8)(y);g>=0&&g<256?this._asciiMap[g]=v:this._map.set(g,v)}get(g){return g>=0&&g<256?this._asciiMap[g]:this._map.get(g)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=O;var f;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(f||(f={}));class A{constructor(){this._actual=new O(0)}add(g){this._actual.set(g,1)}has(g){return this._actual.get(g)===1}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(De[61],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class I{constructor(f,A){this.lineNumber=f,this.column=A}with(f=this.lineNumber,A=this.column){return f===this.lineNumber&&A===this.column?this:new I(f,A)}delta(f=0,A=0){return this.with(this.lineNumber+f,this.column+A)}equals(f){return I.equals(this,f)}static equals(f,A){return!f&&!A?!0:!!f&&!!A&&f.lineNumber===A.lineNumber&&f.column===A.column}isBefore(f){return I.isBefore(this,f)}static isBefore(f,A){return f.lineNumber<A.lineNumber?!0:A.lineNumber<f.lineNumber?!1:f.column<A.column}isBeforeOrEqual(f){return I.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,A){return f.lineNumber<A.lineNumber?!0:A.lineNumber<f.lineNumber?!1:f.column<=A.column}static compare(f,A){const T=f.lineNumber|0,g=A.lineNumber|0;if(T===g){const y=f.column|0,v=A.column|0;return y-v}return T-g}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new I(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.Position=I}),define(De[32],Ie([1,0,61]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class O{constructor(A,T,g,y){A>g||A===g&&T>y?(this.startLineNumber=g,this.startColumn=y,this.endLineNumber=A,this.endColumn=T):(this.startLineNumber=A,this.startColumn=T,this.endLineNumber=g,this.endColumn=y)}isEmpty(){return O.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return O.containsPosition(this,A)}static containsPosition(A,T){return!(T.lineNumber<A.startLineNumber||T.lineNumber>A.endLineNumber||T.lineNumber===A.startLineNumber&&T.column<A.startColumn||T.lineNumber===A.endLineNumber&&T.column>A.endColumn)}static strictContainsPosition(A,T){return!(T.lineNumber<A.startLineNumber||T.lineNumber>A.endLineNumber||T.lineNumber===A.startLineNumber&&T.column<=A.startColumn||T.lineNumber===A.endLineNumber&&T.column>=A.endColumn)}containsRange(A){return O.containsRange(this,A)}static containsRange(A,T){return!(T.startLineNumber<A.startLineNumber||T.endLineNumber<A.startLineNumber||T.startLineNumber>A.endLineNumber||T.endLineNumber>A.endLineNumber||T.startLineNumber===A.startLineNumber&&T.startColumn<A.startColumn||T.endLineNumber===A.endLineNumber&&T.endColumn>A.endColumn)}strictContainsRange(A){return O.strictContainsRange(this,A)}static strictContainsRange(A,T){return!(T.startLineNumber<A.startLineNumber||T.endLineNumber<A.startLineNumber||T.startLineNumber>A.endLineNumber||T.endLineNumber>A.endLineNumber||T.startLineNumber===A.startLineNumber&&T.startColumn<=A.startColumn||T.endLineNumber===A.endLineNumber&&T.endColumn>=A.endColumn)}plusRange(A){return O.plusRange(this,A)}static plusRange(A,T){let g,y,v,R;return T.startLineNumber<A.startLineNumber?(g=T.startLineNumber,y=T.startColumn):T.startLineNumber===A.startLineNumber?(g=T.startLineNumber,y=Math.min(T.startColumn,A.startColumn)):(g=A.startLineNumber,y=A.startColumn),T.endLineNumber>A.endLineNumber?(v=T.endLineNumber,R=T.endColumn):T.endLineNumber===A.endLineNumber?(v=T.endLineNumber,R=Math.max(T.endColumn,A.endColumn)):(v=A.endLineNumber,R=A.endColumn),new O(g,y,v,R)}intersectRanges(A){return O.intersectRanges(this,A)}static intersectRanges(A,T){let g=A.startLineNumber,y=A.startColumn,v=A.endLineNumber,R=A.endColumn;const P=T.startLineNumber,E=T.startColumn,S=T.endLineNumber,_=T.endColumn;return g<P?(g=P,y=E):g===P&&(y=Math.max(y,E)),v>S?(v=S,R=_):v===S&&(R=Math.min(R,_)),g>v||g===v&&y>R?null:new O(g,y,v,R)}equalsRange(A){return O.equalsRange(this,A)}static equalsRange(A,T){return!A&&!T?!0:!!A&&!!T&&A.startLineNumber===T.startLineNumber&&A.startColumn===T.startColumn&&A.endLineNumber===T.endLineNumber&&A.endColumn===T.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(A){return new I.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(A){return new I.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,T){return new O(this.startLineNumber,this.startColumn,A,T)}setStartPosition(A,T){return new O(A,T,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(A){return new O(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(A){return new O(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new O(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,T=A){return new O(A.lineNumber,A.column,T.lineNumber,T.column)}static lift(A){return A?new O(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,T){return!(A.endLineNumber<T.startLineNumber||A.endLineNumber===T.startLineNumber&&A.endColumn<T.startColumn||T.endLineNumber<A.startLineNumber||T.endLineNumber===A.startLineNumber&&T.endColumn<A.startColumn)}static areIntersecting(A,T){return!(A.endLineNumber<T.startLineNumber||A.endLineNumber===T.startLineNumber&&A.endColumn<=T.startColumn||T.endLineNumber<A.startLineNumber||T.endLineNumber===A.startLineNumber&&T.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,T){if(A&&T){const v=A.startLineNumber|0,R=T.startLineNumber|0;if(v===R){const P=A.startColumn|0,E=T.startColumn|0;if(P===E){const S=A.endLineNumber|0,_=T.endLineNumber|0;if(S===_){const w=A.endColumn|0,d=T.endColumn|0;return w-d}return S-_}return P-E}return v-R}return(A?1:0)-(T?1:0)}static compareRangesUsingEnds(A,T){return A.endLineNumber===T.endLineNumber?A.endColumn===T.endColumn?A.startLineNumber===T.startLineNumber?A.startColumn-T.startColumn:A.startLineNumber-T.startLineNumber:A.endColumn-T.endColumn:A.endLineNumber-T.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=O}),define(De[164],Ie([1,0,32]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class O{static insert(A,T){return{range:new I.Range(A.lineNumber,A.column,A.lineNumber,A.column),text:T,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,T){return{range:A,text:T}}static replaceMove(A,T){return{range:A,text:T,forceMoveMarkers:!0}}}e.EditOperation=O}),define(De[165],Ie([1,0,61,32]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var f;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class A extends O.Range{constructor(g,y,v,R){super(g,y,v,R),this.selectionStartLineNumber=g,this.selectionStartColumn=y,this.positionLineNumber=v,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return A.selectionsEqual(this,g)}static selectionsEqual(g,y){return g.selectionStartLineNumber===y.selectionStartLineNumber&&g.selectionStartColumn===y.selectionStartColumn&&g.positionLineNumber===y.positionLineNumber&&g.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,g,y):new A(g,y,this.startLineNumber,this.startColumn)}getPosition(){return new I.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,y){return this.getDirection()===0?new A(g,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,g,y)}static fromPositions(g,y=g){return new A(g.lineNumber,g.column,y.lineNumber,y.column)}static fromRange(g,y){return y===0?new A(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new A(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new A(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,y){if(g&&!y||!g&&y)return!1;if(!g&&!y)return!0;if(g.length!==y.length)return!1;for(let v=0,R=g.length;v<R;v++)if(!this.selectionsEqual(g[v],y[v]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,y,v,R,P){return P===0?new A(g,y,v,R):new A(v,R,g,y)}}e.Selection=A}),define(De[166],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ie([1,0,123]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var O;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class f extends I.CharacterClassifier{constructor(g){super(0);for(let y=0,v=g.length;y<v;y++)this.set(g.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=f;function A(T){const g={};return y=>(g.hasOwnProperty(y)||(g[y]=T(y)),g[y])}e.getMapForWordSeparators=A(T=>new f(T))}),define(De[124],Ie([1,0,51,3,76]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.USUAL_WORD_SEPARATORS)P.indexOf(S)>=0||(E+="\\"+S);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=A();function T(P){let E=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)E=P;else{let S="g";P.ignoreCase&&(S+="i"),P.multiline&&(S+="m"),P.unicode&&(S+="u"),E=new RegExp(P.source,S)}return E.lastIndex=0,E}e.ensureValidWordDefinition=T;const g=new f.LinkedList;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const E=g.unshift(P);return(0,O.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=y;function v(P,E,S,_,w){if(w||(w=I.Iterable.first(g)),S.length>w.maxLen){let h=P-w.maxLen/2;return h<0?h=0:_+=h,S=S.substring(h,P+w.maxLen/2),v(P,E,S,_,w)}const d=Date.now(),o=P-1-_;let u=-1,c=null;for(let h=1;!(Date.now()-d>=w.timeBudget);h++){const a=o-w.windowSize*h;E.lastIndex=Math.max(0,a);const t=R(E,S,o,u);if(!t&&c||(c=t,a<=0))break;u=a}if(c){const h={word:c[0],startColumn:_+1+c.index,endColumn:_+1+c.index+c[0].length};return E.lastIndex=0,h}return null}e.getWordAtText=v;function R(P,E,S,_){let w;for(;w=P.exec(E);){const d=w.index||0;if(d<=S&&P.lastIndex>=S)return w;if(_>0&&d>_)return null}return null}}),define(De[168],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var I;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class O{constructor(g){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=g.open,this.close=g.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(g.notIn))for(let y=0,v=g.notIn.length;y<v;y++)switch(g.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(g,y){if(g.getTokenCount()===0)return!0;const v=g.findTokenIndexAtOffset(y-2),R=g.getStandardTokenType(v);return this.isOK(R)}_findNeutralCharacterInRange(g,y){for(let v=g;v<=y;v++){const R=String.fromCharCode(v);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class f{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of g)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=f;function A(T,g,y){T.has(g)?T.get(g).push(y):T.set(g,[y])}}),define(De[169],Ie([1,0,123]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var O;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class f{constructor(_,w,d){const o=new Uint8Array(_*w);for(let u=0,c=_*w;u<c;u++)o[u]=d;this._data=o,this.rows=_,this.cols=w}get(_,w){return this._data[_*this.cols+w]}set(_,w,d){this._data[_*this.cols+w]=d}}class A{constructor(_){let w=0,d=0;for(let u=0,c=_.length;u<c;u++){const[h,a,t]=_[u];a>w&&(w=a),h>d&&(d=h),t>d&&(d=t)}w++,d++;const o=new f(d,w,0);for(let u=0,c=_.length;u<c;u++){const[h,a,t]=_[u];o.set(h,a,t)}this._states=o,this._maxCharCode=w}nextState(_,w){return w<0||w>=this._maxCharCode?0:this._states.get(_,w)}}e.StateMachine=A;let T=null;function g(){return T===null&&(T=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var y;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let v=null;function R(){if(v===null){v=new I.CharacterClassifier(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<S.length;w++)v.set(S.charCodeAt(w),1);const _=".,;:";for(let w=0;w<_.length;w++)v.set(_.charCodeAt(w),2)}return v}class P{static _createLink(_,w,d,o,u){let c=u-1;do{const h=w.charCodeAt(c);if(_.get(h)!==2)break;c--}while(c>o);if(o>0){const h=w.charCodeAt(o-1),a=w.charCodeAt(c);(h===40&&a===41||h===91&&a===93||h===123&&a===125)&&c--}return{range:{startLineNumber:d,startColumn:o+1,endLineNumber:d,endColumn:c+2},url:w.substring(o,c+1)}}static computeLinks(_,w=g()){const d=R(),o=[];for(let u=1,c=_.getLineCount();u<=c;u++){const h=_.getLineContent(u),a=h.length;let t=0,i=0,s=0,n=1,r=!1,l=!1,k=!1,C=!1;for(;t<a;){let p=!1;const m=h.charCodeAt(t);if(n===13){let b;switch(m){case 40:r=!0,b=0;break;case 41:b=r?0:1;break;case 91:k=!0,l=!0,b=0;break;case 93:k=!1,b=l?0:1;break;case 123:C=!0,b=0;break;case 125:b=C?0:1;break;case 39:case 34:case 96:s===m?b=1:s===39||s===34||s===96?b=0:b=1;break;case 42:b=s===42?1:0;break;case 124:b=s===124?1:0;break;case 32:b=k?0:1;break;default:b=d.get(m)}b===1&&(o.push(P._createLink(d,h,u,i,t)),p=!0)}else if(n===12){let b;m===91?(l=!0,b=0):b=d.get(m),b===1?p=!0:n=13}else n=w.nextState(n,m),n===0&&(p=!0);p&&(n=1,r=!1,l=!1,C=!1,i=t+1,s=m),t++}n===13&&o.push(P._createLink(d,h,u,i,a))}return o}}e.LinkComputer=P;function E(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:P.computeLinks(S)}e.computeLinks=E}),define(De[125],Ie([1,0,24]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var O;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var f;(function(h){h[h.Left=1]="Left",h[h.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var A;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var T;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var g;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(g||(e.EndOfLinePreference=g={}));var y;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var v;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(v||(e.EndOfLineSequence=v={}));class R{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,a.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this._indentSizeIsTabSize===a._indentSizeIsTabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,I.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=R;class P{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.FindMatch=P;var E;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(e.TrackedRangeStickiness=E={}));function S(h){return h&&typeof h.read=="function"}e.isITextSnapshot=S;var _;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(_||(e.PositionAffinity=_={}));var w;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class d{constructor(a,t,i,s,n,r){this.identifier=a,this.range=t,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=n,this._isTracked=r}}e.ValidAnnotatedEditOperation=d;class o{constructor(a,t,i){this.regex=a,this.wordSeparators=t,this.simpleSearch=i}}e.SearchData=o;class u{constructor(a,t,i){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=u;function c(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}e.shouldSynchronizeModel=c}),define(De[170],Ie([1,0,19,122]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class f{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,v){y=(0,O.toUint32)(y);const R=this.values,P=this.prefixSum,E=v.length;return E===0?!1:(this.values=new Uint32Array(R.length+E),this.values.set(R.subarray(0,y),0),this.values.set(R.subarray(y),y+E),this.values.set(v,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,v){return y=(0,O.toUint32)(y),v=(0,O.toUint32)(v),this.values[y]===v?!1:(this.values[y]=v,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,v){y=(0,O.toUint32)(y),v=(0,O.toUint32)(v);const R=this.values,P=this.prefixSum;if(y>=R.length)return!1;const E=R.length-y;return v>=E&&(v=E),v===0?!1:(this.values=new Uint32Array(R.length-v),this.values.set(R.subarray(0,y),0),this.values.set(R.subarray(y+v),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,O.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let v=this.prefixSumValidIndex[0]+1;v===0&&(this.prefixSum[0]=this.values[0],v++),y>=this.values.length&&(y=this.values.length-1);for(let R=v;R<=y;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let v=0,R=this.values.length-1,P=0,E=0,S=0;for(;v<=R;)if(P=v+(R-v)/2|0,E=this.prefixSum[P],S=E-this.values[P],y<S)R=P-1;else if(y>=E)v=P+1;else break;return new T(P,y-S)}}e.PrefixSumComputer=f;class A{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const v=this._indexBySum[y],R=v>0?this._prefixSum[v-1]:0;return new T(v,y-R)}removeValues(y,v){this._values.splice(y,v),this._invalidate(y)}insertValues(y,v){this._values=(0,I.arrayInsert)(this._values,y,v),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,v=this._values.length;y<v;y++){const R=this._values[y],P=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=P+R;for(let E=0;E<R;E++)this._indexBySum[P+E]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,v){this._values[y]!==v&&(this._values[y]=v,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=A;class T{constructor(y,v){this.index=y,this.remainder=v,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=v}}e.PrefixSumIndexOfResult=T}),define(De[171],Ie([1,0,15,61,170]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(g,y,v,R){this._uri=g,this._lines=y,this._eol=v,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(g){g.eol&&g.eol!==this._eol&&(this._eol=g.eol,this._lineStarts=null);const y=g.changes;for(const v of y)this._acceptDeleteRange(v.range),this._acceptInsertText(new O.Position(v.range.startLineNumber,v.range.startColumn),v.text);this._versionId=g.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const g=this._eol.length,y=this._lines.length,v=new Uint32Array(y);for(let R=0;R<y;R++)v[R]=this._lines[R].length+g;this._lineStarts=new f.PrefixSumComputer(v)}}_setLineText(g,y){this._lines[g]=y,this._lineStarts&&this._lineStarts.setValue(g,this._lines[g].length+this._eol.length)}_acceptDeleteRange(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.startLineNumber-1].substring(g.endColumn-1));return}this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.endLineNumber-1].substring(g.endColumn-1)),this._lines.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}_acceptInsertText(g,y){if(y.length===0)return;const v=(0,I.splitLines)(y);if(v.length===1){this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+v[0]+this._lines[g.lineNumber-1].substring(g.column-1));return}v[v.length-1]+=this._lines[g.lineNumber-1].substring(g.column-1),this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+v[0]);const R=new Uint32Array(v.length-1);for(let P=1;P<v.length;P++)this._lines.splice(g.lineNumber+P-1,0,v[P]),R[P-1]=v[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(g.lineNumber,R)}}e.MirrorTextModel=A}),define(De[172],Ie([1,0,15,167,61,32,125]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const g=999;class y{constructor(u,c,h,a){this.searchString=u,this.isRegex=c,this.matchCase=h,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=v(this.searchString):u=this.searchString.indexOf(`
`)>=0;let c=null;try{c=I.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch{return null}if(!c)return null;let h=!this.isRegex&&!u;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new T.SearchData(c,this.wordSeparators?(0,O.getMapForWordSeparators)(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=y;function v(o){if(!o||o.length===0)return!1;for(let u=0,c=o.length;u<c;u++){const h=o.charCodeAt(u);if(h===10)return!0;if(h===92){if(u++,u>=c)break;const a=o.charCodeAt(u);if(a===110||a===114||a===87)return!0}}return!1}e.isMultilineRegexSource=v;function R(o,u,c){if(!c)return new T.FindMatch(o,null);const h=[];for(let a=0,t=u.length;a<t;a++)h[a]=u[a];return new T.FindMatch(o,h)}e.createFindMatch=R;class P{constructor(u){const c=[];let h=0;for(let a=0,t=u.length;a<t;a++)u.charCodeAt(a)===10&&(c[h++]=a);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(u){const c=this._lineFeedsOffsets;let h=0,a=c.length-1;if(a===-1||u<=c[0])return 0;for(;h<a;){const t=h+((a-h)/2>>0);c[t]>=u?a=t-1:c[t+1]>=u?(h=t,a=t):h=t+1}return h+1}}class E{static findMatches(u,c,h,a,t){const i=c.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(u,h,new d(i.wordSeparators,i.regex),a,t):this._doFindMatchesLineByLine(u,h,i,a,t):[]}static _getMultilineMatchRange(u,c,h,a,t,i){let s,n=0;a?(n=a.findLineFeedCountBeforeOffset(t),s=c+t+n):s=c+t;let r;if(a){const p=a.findLineFeedCountBeforeOffset(t+i.length)-n;r=s+i.length+p}else r=s+i.length;const l=u.getPositionAt(s),k=u.getPositionAt(r);return new A.Range(l.lineNumber,l.column,k.lineNumber,k.column)}static _doFindMatchesMultiline(u,c,h,a,t){const i=u.getOffsetAt(c.getStartPosition()),s=u.getValueInRange(c,1),n=u.getEOL()===`\r
`?new P(s):null,r=[];let l=0,k;for(h.reset(0);k=h.next(s);)if(r[l++]=R(this._getMultilineMatchRange(u,i,s,n,k.index,k[0]),k,a),l>=t)return r;return r}static _doFindMatchesLineByLine(u,c,h,a,t){const i=[];let s=0;if(c.startLineNumber===c.endLineNumber){const r=u.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return s=this._findMatchesInLine(h,r,c.startLineNumber,c.startColumn-1,s,i,a,t),i}const n=u.getLineContent(c.startLineNumber).substring(c.startColumn-1);s=this._findMatchesInLine(h,n,c.startLineNumber,c.startColumn-1,s,i,a,t);for(let r=c.startLineNumber+1;r<c.endLineNumber&&s<t;r++)s=this._findMatchesInLine(h,u.getLineContent(r),r,0,s,i,a,t);if(s<t){const r=u.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);s=this._findMatchesInLine(h,r,c.endLineNumber,0,s,i,a,t)}return i}static _findMatchesInLine(u,c,h,a,t,i,s,n){const r=u.wordSeparators;if(!s&&u.simpleSearch){const C=u.simpleSearch,p=C.length,m=c.length;let b=-p;for(;(b=c.indexOf(C,b+p))!==-1;)if((!r||w(r,c,m,b,p))&&(i[t++]=new T.FindMatch(new A.Range(h,b+1+a,h,b+1+p+a),null),t>=n))return t;return t}const l=new d(u.wordSeparators,u.regex);let k;l.reset(0);do if(k=l.next(c),k&&(i[t++]=R(new A.Range(h,k.index+1+a,h,k.index+1+k[0].length+a),k,s),t>=n))return t;while(k);return t}static findNextMatch(u,c,h,a){const t=c.parseSearchRequest();if(!t)return null;const i=new d(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(u,h,i,a):this._doFindNextMatchLineByLine(u,h,i,a)}static _doFindNextMatchMultiline(u,c,h,a){const t=new f.Position(c.lineNumber,1),i=u.getOffsetAt(t),s=u.getLineCount(),n=u.getValueInRange(new A.Range(t.lineNumber,t.column,s,u.getLineMaxColumn(s)),1),r=u.getEOL()===`\r
`?new P(n):null;h.reset(c.column-1);const l=h.next(n);return l?R(this._getMultilineMatchRange(u,i,n,r,l.index,l[0]),l,a):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(u,new f.Position(1,1),h,a):null}static _doFindNextMatchLineByLine(u,c,h,a){const t=u.getLineCount(),i=c.lineNumber,s=u.getLineContent(i),n=this._findFirstMatchInLine(h,s,i,c.column,a);if(n)return n;for(let r=1;r<=t;r++){const l=(i+r-1)%t,k=u.getLineContent(l+1),C=this._findFirstMatchInLine(h,k,l+1,1,a);if(C)return C}return null}static _findFirstMatchInLine(u,c,h,a,t){u.reset(a-1);const i=u.next(c);return i?R(new A.Range(h,i.index+1,h,i.index+1+i[0].length),i,t):null}static findPreviousMatch(u,c,h,a){const t=c.parseSearchRequest();if(!t)return null;const i=new d(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(u,h,i,a):this._doFindPreviousMatchLineByLine(u,h,i,a)}static _doFindPreviousMatchMultiline(u,c,h,a){const t=this._doFindMatchesMultiline(u,new A.Range(1,1,c.lineNumber,c.column),h,a,10*g);if(t.length>0)return t[t.length-1];const i=u.getLineCount();return c.lineNumber!==i||c.column!==u.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(u,new f.Position(i,u.getLineMaxColumn(i)),h,a):null}static _doFindPreviousMatchLineByLine(u,c,h,a){const t=u.getLineCount(),i=c.lineNumber,s=u.getLineContent(i).substring(0,c.column-1),n=this._findLastMatchInLine(h,s,i,a);if(n)return n;for(let r=1;r<=t;r++){const l=(t+i-r-1)%t,k=u.getLineContent(l+1),C=this._findLastMatchInLine(h,k,l+1,a);if(C)return C}return null}static _findLastMatchInLine(u,c,h,a){let t=null,i;for(u.reset(0);i=u.next(c);)t=R(new A.Range(h,i.index+1,h,i.index+1+i[0].length),i,a);return t}}e.TextModelSearch=E;function S(o,u,c,h,a){if(h===0)return!0;const t=u.charCodeAt(h-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const i=u.charCodeAt(h);if(o.get(i)!==0)return!0}return!1}function _(o,u,c,h,a){if(h+a===c)return!0;const t=u.charCodeAt(h+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const i=u.charCodeAt(h+a-1);if(o.get(i)!==0)return!0}return!1}function w(o,u,c,h,a){return S(o,u,c,h,a)&&_(o,u,c,h,a)}e.isValidMatch=w;class d{constructor(u,c){this._wordSeparators=u,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const c=u.length;let h;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(h=this._searchRegex.exec(u),!h))return null;const a=h.index,t=h[0].length;if(a===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){I.getNextCodePoint(u,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=t,!this._wordSeparators||w(this._wordSeparators,u,c,a,t))return h}while(h);return null}}e.Searcher=d}),define(De[173],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const T=this._dragOperations.get(A);return this._dragOperations.delete(A),T}}addDragOperationTransfer(A,T){this._dragOperations.set(A,T)}}e.TreeViewsDnDService=I;class O{constructor(A){this.identifier=A}}e.DraggedTreeItemsIdentifier=O}),define(De[174],Ie([1,0,4,3]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class f{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(g){this._onDidChange.fire({changedLanguages:g,changedColorMap:!1})}register(g,y){return this._tokenizationSupports.set(g,y),this.handleChange([g]),(0,O.toDisposable)(()=>{this._tokenizationSupports.get(g)===y&&(this._tokenizationSupports.delete(g),this.handleChange([g]))})}get(g){return this._tokenizationSupports.get(g)||null}registerFactory(g,y){this._factories.get(g)?.dispose();const v=new A(this,g,y);return this._factories.set(g,v),(0,O.toDisposable)(()=>{const R=this._factories.get(g);!R||R!==v||(this._factories.delete(g),R.dispose())})}async getOrCreate(g){const y=this.get(g);if(y)return y;const v=this._factories.get(g);return!v||v.isResolved?null:(await v.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const v=this._factories.get(g);return!!(!v||v.isResolved)}setColorMap(g){this._colorMap=g,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=f;class A extends O.Disposable{get isResolved(){return this._isResolved}constructor(g,y,v){super(),this._registry=g,this._languageId=y,this._factory=v,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const g=await this._factory.tokenizationSupport;this._isResolved=!0,g&&!this._isDisposed&&this._register(this._registry.register(this._languageId,g))}}}),define(De[175],Ie([10,11]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(De[176],Ie([1,0,4,3,175]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends O.Disposable{constructor(E,S="",_="",w=!0,d){super(),this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=E,this._label=S,this._cssClass=_,this._enabled=w,this._actionCallback=d}get id(){return this._id}get label(){return this._label}set label(E){this._setLabel(E)}_setLabel(E){this._label!==E&&(this._label=E,this._onDidChange.fire({label:E}))}get tooltip(){return this._tooltip||""}set tooltip(E){this._setTooltip(E)}_setTooltip(E){this._tooltip!==E&&(this._tooltip=E,this._onDidChange.fire({tooltip:E}))}get class(){return this._cssClass}set class(E){this._setClass(E)}_setClass(E){this._cssClass!==E&&(this._cssClass=E,this._onDidChange.fire({class:E}))}get enabled(){return this._enabled}set enabled(E){this._setEnabled(E)}_setEnabled(E){this._enabled!==E&&(this._enabled=E,this._onDidChange.fire({enabled:E}))}get checked(){return this._checked}set checked(E){this._setChecked(E)}_setChecked(E){this._checked!==E&&(this._checked=E,this._onDidChange.fire({checked:E}))}async run(E,S){this._actionCallback&&await this._actionCallback(E)}}e.Action=A;class T extends O.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new I.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new I.Emitter),this.onDidRun=this._onDidRun.event}async run(E,S){if(!E.enabled)return;this._onWillRun.fire({action:E});let _;try{await this.runAction(E,S)}catch(w){_=w}this._onDidRun.fire({action:E,error:_})}async runAction(E,S){await E.run(S)}}e.ActionRunner=T;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...E){let S=[];for(const _ of E)_.length&&(S.length?S=[...S,new g,..._]:S=_);return S}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=g;class y{get actions(){return this._actions}constructor(E,S,_,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=E,this.label=S,this.class=w,this._actions=_}async run(){}}e.SubmenuAction=y;class v extends A{static{this.ID="vs.actions.empty"}constructor(){super(v.ID,f.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=v;function R(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...E)=>P.run(...E),tooltip:P.label}}e.toAction=R}),define(De[177],Ie([10,11]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(De[178],Ie([1,0,177]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,f=O*60,A=f*24,T=A*7,g=A*30,y=A*365;function v(P,E,S,_){typeof P!="number"&&(P=P.getTime());const w=Math.round((new Date().getTime()-P)/1e3);if(w<-30)return(0,I.localize)(0,null,v(new Date().getTime()+w*1e3,!1));if(!_&&w<30)return(0,I.localize)(1,null);let d;return w<O?(d=w,E?d===1?S?(0,I.localize)(2,null,d):(0,I.localize)(3,null,d):S?(0,I.localize)(4,null,d):(0,I.localize)(5,null,d):d===1?S?(0,I.localize)(6,null,d):(0,I.localize)(7,null,d):S?(0,I.localize)(8,null,d):(0,I.localize)(9,null,d)):w<f?(d=Math.floor(w/O),E?d===1?S?(0,I.localize)(10,null,d):(0,I.localize)(11,null,d):S?(0,I.localize)(12,null,d):(0,I.localize)(13,null,d):d===1?S?(0,I.localize)(14,null,d):(0,I.localize)(15,null,d):S?(0,I.localize)(16,null,d):(0,I.localize)(17,null,d)):w<A?(d=Math.floor(w/f),E?d===1?S?(0,I.localize)(18,null,d):(0,I.localize)(19,null,d):S?(0,I.localize)(20,null,d):(0,I.localize)(21,null,d):d===1?S?(0,I.localize)(22,null,d):(0,I.localize)(23,null,d):S?(0,I.localize)(24,null,d):(0,I.localize)(25,null,d)):w<T?(d=Math.floor(w/A),E?d===1?(0,I.localize)(26,null,d):(0,I.localize)(27,null,d):d===1?(0,I.localize)(28,null,d):(0,I.localize)(29,null,d)):w<g?(d=Math.floor(w/T),E?d===1?S?(0,I.localize)(30,null,d):(0,I.localize)(31,null,d):S?(0,I.localize)(32,null,d):(0,I.localize)(33,null,d):d===1?S?(0,I.localize)(34,null,d):(0,I.localize)(35,null,d):S?(0,I.localize)(36,null,d):(0,I.localize)(37,null,d)):w<y?(d=Math.floor(w/g),E?d===1?S?(0,I.localize)(38,null,d):(0,I.localize)(39,null,d):S?(0,I.localize)(40,null,d):(0,I.localize)(41,null,d):d===1?S?(0,I.localize)(42,null,d):(0,I.localize)(43,null,d):S?(0,I.localize)(44,null,d):(0,I.localize)(45,null,d)):(d=Math.floor(w/y),E?d===1?S?(0,I.localize)(46,null,d):(0,I.localize)(47,null,d):S?(0,I.localize)(48,null,d):(0,I.localize)(49,null,d):d===1?S?(0,I.localize)(50,null,d):(0,I.localize)(51,null,d):S?(0,I.localize)(52,null,d):(0,I.localize)(53,null,d))}e.fromNow=v;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(De[179],Ie([10,11]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(De[41],Ie([1,0,19,17,179]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,E){return E&&(P.stack||P.stacktrace)?f.localize(0,null,g(P),T(P.stack)||T(P.stacktrace)):g(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function g(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?f.localize(1,null,P.message):P.message||f.localize(2,null)}function y(P=null,E=!1){if(!P)return f.localize(3,null);if(Array.isArray(P)){const S=I.coalesce(P),_=y(S[0],E);return S.length>1?f.localize(4,null,_,S.length):_}if(O.isString(P))return P;if(P.detail){const S=P.detail;if(S.error)return A(S.error,E);if(S.exception)return A(S.exception,E)}return P.stack?A(P,E):P.message?P.message:f.localize(5,null)}e.toErrorMessage=y;function v(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=v;function R(P,E){let S;return typeof P=="string"?S=new Error(P):S=P,S.actions=E,S}e.createErrorWithActions=R}),define(De[180],Ie([10,11]),function(pe,e){return pe.create("vs/base/common/platform",e)}),define(De[12],Ie([1,0,180]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,f=!1,A=!1,T=!1,g=!1,y=!1,v=!1,R=!1,P=!1,E=!1,S,_=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,d,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const c=typeof u?.versions?.electron=="string",h=c&&u?.type==="renderer";if(typeof navigator=="object"&&!h)o=navigator.userAgent,O=o.indexOf("Windows")>=0,f=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=o.indexOf("Linux")>=0,E=o?.indexOf("Mobi")>=0,y=!0,S=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,_=S,w=navigator.language;else if(typeof u=="object"){O=u.platform==="win32",f=u.platform==="darwin",A=u.platform==="linux",T=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,v=c,P=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.LANGUAGE_DEFAULT,_=e.LANGUAGE_DEFAULT;const C=u.env.VSCODE_NLS_CONFIG;if(C)try{const p=JSON.parse(C),m=p.availableLanguages["*"];S=p.locale,w=p.osLocale,_=m||e.LANGUAGE_DEFAULT,d=p._translationsConfigFile}catch{}g=!0}else console.error("Unable to resolve platform.");var a;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(a||(e.Platform=a={}));function t(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let i=0;f?i=1:O?i=3:A&&(i=2),e.isWindows=O,e.isMacintosh=f,e.isLinux=A,e.isLinuxSnap=T,e.isNative=g,e.isElectron=v,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=E,e.isCI=P,e.platform=i,e.userAgent=o,e.language=_;var s;(function(C){function p(){return e.language}C.value=p;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}C.isDefaultVariant=m;function b(){return e.language==="en"}C.isDefault=b})(s||(e.Language=s={})),e.locale=S,e.platformLocale=w,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const C=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let b=0,D=C.length;b<D;b++){const M=C[b];if(M.id===m.data.vscodeScheduleAsyncWork){C.splice(b,1),M.callback();return}}});let p=0;return m=>{const b=++p;C.push({id:b,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return C=>setTimeout(C)})();var n;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=f||R?2:O?1:3;let r=!0,l=!1;function k(){if(!l){l=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,r=new Uint16Array(C.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=k,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[48],Ie([1,0,12]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const f=I.globals.vscode.process;O={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(De[16],Ie([1,0,48]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,f=97,A=90,T=122,g=46,y=47,v=92,R=58,P=63;class E extends Error{constructor(i,s,n){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const l=i.indexOf(".")!==-1?"property":"argument";let k=`The "${i}" ${l} ${r} of type ${s}`;k+=`. Received type ${typeof n}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,i){if(t===null||typeof t!="object")throw new E(i,"Object",t)}function _(t,i){if(typeof t!="string")throw new E(i,"string",t)}const w=I.platform==="win32";function d(t){return t===y||t===v}function o(t){return t===y}function u(t){return t>=O&&t<=A||t>=f&&t<=T}function c(t,i,s,n){let r="",l=0,k=-1,C=0,p=0;for(let m=0;m<=t.length;++m){if(m<t.length)p=t.charCodeAt(m);else{if(n(p))break;p=y}if(n(p)){if(!(k===m-1||C===1))if(C===2){if(r.length<2||l!==2||r.charCodeAt(r.length-1)!==g||r.charCodeAt(r.length-2)!==g){if(r.length>2){const b=r.lastIndexOf(s);b===-1?(r="",l=0):(r=r.slice(0,b),l=r.length-1-r.lastIndexOf(s)),k=m,C=0;continue}else if(r.length!==0){r="",l=0,k=m,C=0;continue}}i&&(r+=r.length>0?`${s}..`:"..",l=2)}else r.length>0?r+=`${s}${t.slice(k+1,m)}`:r=t.slice(k+1,m),l=m-k-1;k=m,C=0}else p===g&&C!==-1?++C:C=-1}return r}function h(t,i){S(i,"pathObject");const s=i.dir||i.root,n=i.base||`${i.name||""}${i.ext||""}`;return s?s===i.root?`${s}${n}`:`${s}${t}${n}`:n}e.win32={resolve(...t){let i="",s="",n=!1;for(let r=t.length-1;r>=-1;r--){let l;if(r>=0){if(l=t[r],_(l,"path"),l.length===0)continue}else i.length===0?l=I.cwd():(l=I.env[`=${i}`]||I.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==i.toLowerCase()&&l.charCodeAt(2)===v)&&(l=`${i}\\`));const k=l.length;let C=0,p="",m=!1;const b=l.charCodeAt(0);if(k===1)d(b)&&(C=1,m=!0);else if(d(b))if(m=!0,d(l.charCodeAt(1))){let D=2,M=D;for(;D<k&&!d(l.charCodeAt(D));)D++;if(D<k&&D!==M){const L=l.slice(M,D);for(M=D;D<k&&d(l.charCodeAt(D));)D++;if(D<k&&D!==M){for(M=D;D<k&&!d(l.charCodeAt(D));)D++;(D===k||D!==M)&&(p=`\\\\${L}\\${l.slice(M,D)}`,C=D)}}}else C=1;else u(b)&&l.charCodeAt(1)===R&&(p=l.slice(0,2),C=2,k>2&&d(l.charCodeAt(2))&&(m=!0,C=3));if(p.length>0)if(i.length>0){if(p.toLowerCase()!==i.toLowerCase())continue}else i=p;if(n){if(i.length>0)break}else if(s=`${l.slice(C)}\\${s}`,n=m,m&&i.length>0)break}return s=c(s,!n,"\\",d),n?`${i}\\${s}`:`${i}${s}`||"."},normalize(t){_(t,"path");const i=t.length;if(i===0)return".";let s=0,n,r=!1;const l=t.charCodeAt(0);if(i===1)return o(l)?"\\":t;if(d(l))if(r=!0,d(t.charCodeAt(1))){let C=2,p=C;for(;C<i&&!d(t.charCodeAt(C));)C++;if(C<i&&C!==p){const m=t.slice(p,C);for(p=C;C<i&&d(t.charCodeAt(C));)C++;if(C<i&&C!==p){for(p=C;C<i&&!d(t.charCodeAt(C));)C++;if(C===i)return`\\\\${m}\\${t.slice(p)}\\`;C!==p&&(n=`\\\\${m}\\${t.slice(p,C)}`,s=C)}}}else s=1;else u(l)&&t.charCodeAt(1)===R&&(n=t.slice(0,2),s=2,i>2&&d(t.charCodeAt(2))&&(r=!0,s=3));let k=s<i?c(t.slice(s),!r,"\\",d):"";return k.length===0&&!r&&(k="."),k.length>0&&d(t.charCodeAt(i-1))&&(k+="\\"),n===void 0?r?`\\${k}`:k:r?`${n}\\${k}`:`${n}${k}`},isAbsolute(t){_(t,"path");const i=t.length;if(i===0)return!1;const s=t.charCodeAt(0);return d(s)||i>2&&u(s)&&t.charCodeAt(1)===R&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let i,s;for(let l=0;l<t.length;++l){const k=t[l];_(k,"path"),k.length>0&&(i===void 0?i=s=k:i+=`\\${k}`)}if(i===void 0)return".";let n=!0,r=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++r;const l=s.length;l>1&&d(s.charCodeAt(1))&&(++r,l>2&&(d(s.charCodeAt(2))?++r:n=!1))}if(n){for(;r<i.length&&d(i.charCodeAt(r));)r++;r>=2&&(i=`\\${i.slice(r)}`)}return e.win32.normalize(i)},relative(t,i){if(_(t,"from"),_(i,"to"),t===i)return"";const s=e.win32.resolve(t),n=e.win32.resolve(i);if(s===n||(t=s.toLowerCase(),i=n.toLowerCase(),t===i))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===v;)r++;let l=t.length;for(;l-1>r&&t.charCodeAt(l-1)===v;)l--;const k=l-r;let C=0;for(;C<i.length&&i.charCodeAt(C)===v;)C++;let p=i.length;for(;p-1>C&&i.charCodeAt(p-1)===v;)p--;const m=p-C,b=k<m?k:m;let D=-1,M=0;for(;M<b;M++){const F=t.charCodeAt(r+M);if(F!==i.charCodeAt(C+M))break;F===v&&(D=M)}if(M!==b){if(D===-1)return n}else{if(m>b){if(i.charCodeAt(C+M)===v)return n.slice(C+M+1);if(M===2)return n.slice(C+M)}k>b&&(t.charCodeAt(r+M)===v?D=M:M===2&&(D=3)),D===-1&&(D=0)}let L="";for(M=r+D+1;M<=l;++M)(M===l||t.charCodeAt(M)===v)&&(L+=L.length===0?"..":"\\..");return C+=D,L.length>0?`${L}${n.slice(C,p)}`:(n.charCodeAt(C)===v&&++C,n.slice(C,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const i=e.win32.resolve(t);if(i.length<=2)return t;if(i.charCodeAt(0)===v){if(i.charCodeAt(1)===v){const s=i.charCodeAt(2);if(s!==P&&s!==g)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(u(i.charCodeAt(0))&&i.charCodeAt(1)===R&&i.charCodeAt(2)===v)return`\\\\?\\${i}`;return t},dirname(t){_(t,"path");const i=t.length;if(i===0)return".";let s=-1,n=0;const r=t.charCodeAt(0);if(i===1)return d(r)?t:".";if(d(r)){if(s=n=1,d(t.charCodeAt(1))){let C=2,p=C;for(;C<i&&!d(t.charCodeAt(C));)C++;if(C<i&&C!==p){for(p=C;C<i&&d(t.charCodeAt(C));)C++;if(C<i&&C!==p){for(p=C;C<i&&!d(t.charCodeAt(C));)C++;if(C===i)return t;C!==p&&(s=n=C+1)}}}}else u(r)&&t.charCodeAt(1)===R&&(s=i>2&&d(t.charCodeAt(2))?3:2,n=s);let l=-1,k=!0;for(let C=i-1;C>=n;--C)if(d(t.charCodeAt(C))){if(!k){l=C;break}}else k=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,i){i!==void 0&&_(i,"ext"),_(t,"path");let s=0,n=-1,r=!0,l;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let k=i.length-1,C=-1;for(l=t.length-1;l>=s;--l){const p=t.charCodeAt(l);if(d(p)){if(!r){s=l+1;break}}else C===-1&&(r=!1,C=l+1),k>=0&&(p===i.charCodeAt(k)?--k===-1&&(n=l):(k=-1,n=C))}return s===n?n=C:n===-1&&(n=t.length),t.slice(s,n)}for(l=t.length-1;l>=s;--l)if(d(t.charCodeAt(l))){if(!r){s=l+1;break}}else n===-1&&(r=!1,n=l+1);return n===-1?"":t.slice(s,n)},extname(t){_(t,"path");let i=0,s=-1,n=0,r=-1,l=!0,k=0;t.length>=2&&t.charCodeAt(1)===R&&u(t.charCodeAt(0))&&(i=n=2);for(let C=t.length-1;C>=i;--C){const p=t.charCodeAt(C);if(d(p)){if(!l){n=C+1;break}continue}r===-1&&(l=!1,r=C+1),p===g?s===-1?s=C:k!==1&&(k=1):s!==-1&&(k=-1)}return s===-1||r===-1||k===0||k===1&&s===r-1&&s===n+1?"":t.slice(s,r)},format:h.bind(null,"\\"),parse(t){_(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const s=t.length;let n=0,r=t.charCodeAt(0);if(s===1)return d(r)?(i.root=i.dir=t,i):(i.base=i.name=t,i);if(d(r)){if(n=1,d(t.charCodeAt(1))){let D=2,M=D;for(;D<s&&!d(t.charCodeAt(D));)D++;if(D<s&&D!==M){for(M=D;D<s&&d(t.charCodeAt(D));)D++;if(D<s&&D!==M){for(M=D;D<s&&!d(t.charCodeAt(D));)D++;D===s?n=D:D!==M&&(n=D+1)}}}}else if(u(r)&&t.charCodeAt(1)===R){if(s<=2)return i.root=i.dir=t,i;if(n=2,d(t.charCodeAt(2))){if(s===3)return i.root=i.dir=t,i;n=3}}n>0&&(i.root=t.slice(0,n));let l=-1,k=n,C=-1,p=!0,m=t.length-1,b=0;for(;m>=n;--m){if(r=t.charCodeAt(m),d(r)){if(!p){k=m+1;break}continue}C===-1&&(p=!1,C=m+1),r===g?l===-1?l=m:b!==1&&(b=1):l!==-1&&(b=-1)}return C!==-1&&(l===-1||b===0||b===1&&l===C-1&&l===k+1?i.base=i.name=t.slice(k,C):(i.name=t.slice(k,l),i.base=t.slice(k,C),i.ext=t.slice(l,C))),k>0&&k!==n?i.dir=t.slice(0,k-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const i=I.cwd().replace(t,"/");return i.slice(i.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let i="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const r=n>=0?t[n]:a();_(r,"path"),r.length!==0&&(i=`${r}/${i}`,s=r.charCodeAt(0)===y)}return i=c(i,!s,"/",o),s?`/${i}`:i.length>0?i:"."},normalize(t){if(_(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===y,s=t.charCodeAt(t.length-1)===y;return t=c(t,!i,"/",o),t.length===0?i?"/":s?"./":".":(s&&(t+="/"),i?`/${t}`:t)},isAbsolute(t){return _(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let i;for(let s=0;s<t.length;++s){const n=t[s];_(n,"path"),n.length>0&&(i===void 0?i=n:i+=`/${n}`)}return i===void 0?".":e.posix.normalize(i)},relative(t,i){if(_(t,"from"),_(i,"to"),t===i||(t=e.posix.resolve(t),i=e.posix.resolve(i),t===i))return"";const s=1,n=t.length,r=n-s,l=1,k=i.length-l,C=r<k?r:k;let p=-1,m=0;for(;m<C;m++){const D=t.charCodeAt(s+m);if(D!==i.charCodeAt(l+m))break;D===y&&(p=m)}if(m===C)if(k>C){if(i.charCodeAt(l+m)===y)return i.slice(l+m+1);if(m===0)return i.slice(l+m)}else r>C&&(t.charCodeAt(s+m)===y?p=m:m===0&&(p=0));let b="";for(m=s+p+1;m<=n;++m)(m===n||t.charCodeAt(m)===y)&&(b+=b.length===0?"..":"/..");return`${b}${i.slice(l+p)}`},toNamespacedPath(t){return t},dirname(t){if(_(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===y;let s=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===y){if(!n){s=r;break}}else n=!1;return s===-1?i?"/":".":i&&s===1?"//":t.slice(0,s)},basename(t,i){i!==void 0&&_(i,"ext"),_(t,"path");let s=0,n=-1,r=!0,l;if(i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let k=i.length-1,C=-1;for(l=t.length-1;l>=0;--l){const p=t.charCodeAt(l);if(p===y){if(!r){s=l+1;break}}else C===-1&&(r=!1,C=l+1),k>=0&&(p===i.charCodeAt(k)?--k===-1&&(n=l):(k=-1,n=C))}return s===n?n=C:n===-1&&(n=t.length),t.slice(s,n)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===y){if(!r){s=l+1;break}}else n===-1&&(r=!1,n=l+1);return n===-1?"":t.slice(s,n)},extname(t){_(t,"path");let i=-1,s=0,n=-1,r=!0,l=0;for(let k=t.length-1;k>=0;--k){const C=t.charCodeAt(k);if(C===y){if(!r){s=k+1;break}continue}n===-1&&(r=!1,n=k+1),C===g?i===-1?i=k:l!==1&&(l=1):i!==-1&&(l=-1)}return i===-1||n===-1||l===0||l===1&&i===n-1&&i===s+1?"":t.slice(i,n)},format:h.bind(null,"/"),parse(t){_(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const s=t.charCodeAt(0)===y;let n;s?(i.root="/",n=1):n=0;let r=-1,l=0,k=-1,C=!0,p=t.length-1,m=0;for(;p>=n;--p){const b=t.charCodeAt(p);if(b===y){if(!C){l=p+1;break}continue}k===-1&&(C=!1,k=p+1),b===g?r===-1?r=p:m!==1&&(m=1):r!==-1&&(m=-1)}if(k!==-1){const b=l===0&&s?1:l;r===-1||m===0||m===1&&r===k-1&&r===l+1?i.base=i.name=t.slice(b,k):(i.name=t.slice(b,r),i.base=t.slice(b,k),i.ext=t.slice(r,k))}return l>0?i.dir=t.slice(0,l-1):s&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(De[126],Ie([1,0,47,16]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const f=new I.Lazy(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),A=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(C,p,m=!1){const b=C||"",D=p||"",M=f.value.collator.compare(b,D);return f.value.collatorIsNumeric&&M===0&&b!==D?b<D?-1:1:M}e.compareFileNames=g;function y(C,p){const m=A.value.collator;return C=C||"",p=p||"",h(m,C,p)}e.compareFileNamesDefault=y;function v(C,p){const m=A.value.collator;return C=C||"",p=p||"",s(C,p)||h(m,C,p)}e.compareFileNamesUpper=v;function R(C,p){const m=A.value.collator;return C=C||"",p=p||"",i(C,p)||h(m,C,p)}e.compareFileNamesLower=R;function P(C,p){return C=C||"",p=p||"",C===p?0:C<p?-1:1}e.compareFileNamesUnicode=P;function E(C,p){const[m,b]=u(C),[D,M]=u(p);let L=f.value.collator.compare(b,M);if(L===0){if(f.value.collatorIsNumeric&&b!==M)return b<M?-1:1;if(L=f.value.collator.compare(m,D),f.value.collatorIsNumeric&&L===0&&m!==D)return m<D?-1:1}return L}e.compareFileExtensions=E;function S(C,p){C=C||"",p=p||"";const m=c(C),b=c(p),D=A.value.collator,M=T.value.collator;return h(M,m,b)||h(D,C,p)}e.compareFileExtensionsDefault=S;function _(C,p){C=C||"",p=p||"";const m=c(C),b=c(p),D=A.value.collator,M=T.value.collator;return h(M,m,b)||s(C,p)||h(D,C,p)}e.compareFileExtensionsUpper=_;function w(C,p){C=C||"",p=p||"";const m=c(C),b=c(p),D=A.value.collator,M=T.value.collator;return h(M,m,b)||i(C,p)||h(D,C,p)}e.compareFileExtensionsLower=w;function d(C,p){C=C||"",p=p||"";const m=c(C).toLowerCase(),b=c(p).toLowerCase();return m!==b?m<b?-1:1:C!==p?C<p?-1:1:0}e.compareFileExtensionsUnicode=d;const o=/^(.*?)(\.([^.]*))?$/;function u(C,p=!1){const m=C?o.exec(C):[];let b=[m&&m[1]||"",m&&m[3]||""];return p&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function c(C){const p=C?o.exec(C):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function h(C,p,m){const b=C.compare(p,m);return b!==0?b:p.length!==m.length?p.length<m.length?-1:1:0}function a(C){const p=C.charAt(0);return p.toLocaleUpperCase()!==p}function t(C){const p=C.charAt(0);return p.toLocaleLowerCase()!==p}function i(C,p){return a(C)&&t(p)?-1:t(C)&&a(p)?1:0}function s(C,p){return t(C)&&a(p)?-1:a(C)&&t(p)?1:0}function n(C,p,m=!1){return m||(C=C&&C.toLowerCase(),p=p&&p.toLowerCase()),C===p?0:C<p?-1:1}function r(C,p,m=!1){const b=C.split(O.sep),D=p.split(O.sep),M=b.length-1,L=D.length-1;let F,x;for(let U=0;;U++){if(F=M===U,x=L===U,F&&x)return g(b[U],D[U],m);if(F)return-1;if(x)return 1;const N=n(b[U],D[U],m);if(N!==0)return N}}e.comparePaths=r;function l(C,p,m){const b=C.toLowerCase(),D=p.toLowerCase(),M=k(C,p,m);if(M)return M;const L=b.endsWith(m),F=D.endsWith(m);if(L!==F)return L?-1:1;const x=g(b,D);return x!==0?x:b.localeCompare(D)}e.compareAnything=l;function k(C,p,m){const b=C.toLowerCase(),D=p.toLowerCase(),M=b.startsWith(m),L=D.startsWith(m);if(M!==L)return M?-1:1;if(M&&L){if(b.length<D.length)return-1;if(b.length>D.length)return 1}return 0}e.compareByPrefix=k}),define(De[33],Ie([1,0,16,12,15,17]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(l){return l===47||l===92}e.isPathSeparator=T;function g(l){return l.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=g;function y(l){return l.indexOf("/")===-1&&(l=g(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function v(l,k=I.posix.sep){if(!l)return"";const C=l.length,p=l.charCodeAt(0);if(T(p)){if(T(l.charCodeAt(1))&&!T(l.charCodeAt(2))){let b=3;const D=b;for(;b<C&&!T(l.charCodeAt(b));b++);if(D!==b&&!T(l.charCodeAt(b+1))){for(b+=1;b<C;b++)if(T(l.charCodeAt(b)))return l.slice(0,b+1).replace(/[\\/]/g,k)}}return k}else if(o(p)&&l.charCodeAt(1)===58)return T(l.charCodeAt(2))?l.slice(0,2)+k:l.slice(0,2);let m=l.indexOf("://");if(m!==-1){for(m+=3;m<C;m++)if(T(l.charCodeAt(m)))return l.slice(0,m+1)}return""}e.getRoot=v;function R(l){if(!O.isWindows||!l||l.length<5)return!1;let k=l.charCodeAt(0);if(k!==92||(k=l.charCodeAt(1),k!==92))return!1;let C=2;const p=C;for(;C<l.length&&(k=l.charCodeAt(C),k!==92);C++);return!(p===C||(k=l.charCodeAt(C+1),isNaN(k)||k===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function _(l,k=O.isWindows){const C=k?P:E;return!(!l||l.length===0||/^\s+$/.test(l)||(C.lastIndex=0,C.test(l))||k&&S.test(l)||l==="."||l===".."||k&&l[l.length-1]==="."||k&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=_;function w(l,k,C){const p=l===k;return!C||p?p:!l||!k?!1:(0,f.equalsIgnoreCase)(l,k)}e.isEqual=w;function d(l,k,C,p=I.sep){if(l===k)return!0;if(!l||!k||k.length>l.length)return!1;if(C){if(!(0,f.startsWithIgnoreCase)(l,k))return!1;if(k.length===l.length)return!0;let b=k.length;return k.charAt(k.length-1)===p&&b--,l.charAt(b)===p}return k.charAt(k.length-1)!==p&&(k+=p),l.indexOf(k)===0}e.isEqualOrParent=d;function o(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=o;function u(l,k){return O.isWindows&&l.endsWith(":")&&(l+=I.sep),(0,I.isAbsolute)(l)||(l=(0,I.join)(k,l)),l=(0,I.normalize)(l),O.isWindows?(l=(0,f.rtrim)(l,I.sep),l.endsWith(":")&&(l+=I.sep)):(l=(0,f.rtrim)(l,I.sep),l||(l=I.sep)),l}e.sanitizeFilePath=u;function c(l){const k=(0,I.normalize)(l);return O.isWindows?l.length>3?!1:h(k)&&(l.length===2||k.charCodeAt(2)===92):k===I.posix.sep}e.isRootOrDriveLetter=c;function h(l,k=O.isWindows){return k?o(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function a(l,k=O.isWindows){return h(l,k)?l[0]:void 0}e.getDriveLetter=a;function t(l,k,C){return k.length>l.length?-1:l===k?0:(C&&(l=l.toLowerCase(),k=k.toLowerCase()),l.indexOf(k))}e.indexOfPath=t;function i(l){const k=l.split(":");let C,p,m;for(const b of k){const D=Number(b);(0,A.isNumber)(D)?p===void 0?p=D:m===void 0&&(m=D):C=C?[C,b].join(":"):b}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:p!==void 0?p:void 0,column:m!==void 0?m:p!==void 0?1:void 0}}e.parseLineAndColumnAware=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(l,k,C=8){let p="";for(let b=0;b<C;b++){let D;b===0&&O.isWindows&&!k&&(C===3||C===4)?D=n:D=s,p+=D.charAt(Math.floor(Math.random()*D.length))}let m;return k?m=`${k}-${p}`:m=p,l?(0,I.join)(l,m):m}e.randomPath=r}),define(De[127],Ie([1,0,126,121,52,16,12,15]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,v=[y,[]];function R(z,V,ge,te){if(!z||!V)return v;const q=z.length,K=V.length;if(q<K)return v;const ue=z.toLowerCase();return P(V,ge,K,z,ue,q,te)}e.scoreFuzzy=R;function P(z,V,ge,te,q,K,ue){const ie=[],ce=[];for(let X=0;X<ge;X++){const re=X*K,Q=re-K,Z=X>0,J=z[X],be=V[X];for(let ae=0;ae<K;ae++){const fe=ae>0,ee=re+ae,he=ee-1,ve=Q+ae-1,Pe=fe?ie[he]:0,B=Z&&fe?ie[ve]:0,G=Z&&fe?ce[ve]:0;let se;!B&&Z?se=0:se=E(J,be,te,q,ae,G),se&&B+se>=Pe&&(ue||Z||q.startsWith(V,ae))?(ce[ee]=G+1,ie[ee]=B+se):(ce[ee]=y,ie[ee]=Pe)}}const Se=[];let j=ge-1,$=K-1;for(;j>=0&&$>=0;){const X=j*K+$;ce[X]===y||(Se.push($),j--),$--}return[ie[ge*K-1],Se.reverse()]}function E(z,V,ge,te,q,K){let ue=0;if(!S(V,te[q]))return ue;if(ue+=1,K>0&&(ue+=K*5),z===ge[q]&&(ue+=1),q===0)ue+=8;else{const ie=_(ge.charCodeAt(q-1));ie?ue+=ie:(0,O.isUpper)(ge.charCodeAt(q))&&K===0&&(ue+=2)}return ue}function S(z,V){return z===V?!0:z==="/"||z==="\\"?V==="/"||V==="\\":!1}function _(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function d(z,V,ge=0,te=0){const q=V;return q.values&&q.values.length>1?o(z,q.values,ge,te):u(z,V,ge,te)}e.scoreFuzzy2=d;function o(z,V,ge,te){let q=0;const K=[];for(const ue of V){const[ie,ce]=u(z,ue,ge,te);if(typeof ie!="number")return w;q+=ie,K.push(...ce)}return[q,C(K)]}function u(z,V,ge,te){const q=(0,O.fuzzyScore)(V.original,V.originalLowercase,ge,z,z.toLowerCase(),te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,O.createMatches)(q)]:w}const c=Object.freeze({score:0}),h=1<<18,a=1<<17,t=1<<16;function i(z,V,ge,te){const q=te.values?te.values:[te];return(0,f.hash)({[te.normalized]:{values:q.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:z,description:V,allowNonContiguousMatches:ge}})}function s(z,V,ge,te,q){if(!z||!V.normalized)return c;const K=te.getItemLabel(z);if(!K)return c;const ue=te.getItemDescription(z),ie=i(K,ue,ge,V),ce=q[ie];if(ce)return ce;const Se=n(K,ue,te.getItemPath(z),V,ge);return q[ie]=Se,Se}e.scoreItemFuzzy=s;function n(z,V,ge,te,q){const K=!ge||!te.containsPathSeparator;return ge&&(T.isLinux?te.pathNormalized===ge:(0,g.equalsIgnoreCase)(te.pathNormalized,ge))?{score:h,labelMatch:[{start:0,end:z.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:te.values&&te.values.length>1?r(z,V,ge,te.values,K,q):l(z,V,ge,te,K,q)}function r(z,V,ge,te,q,K){let ue=0;const ie=[],ce=[];for(const Se of te){const{score:j,labelMatch:$,descriptionMatch:X}=l(z,V,ge,Se,q,K);if(j===y)return c;ue+=j,$&&ie.push(...$),X&&ce.push(...X)}return{score:ue,labelMatch:C(ie),descriptionMatch:C(ce)}}function l(z,V,ge,te,q,K){if(q||!V){const[ue,ie]=R(z,te.normalized,te.normalizedLowercase,K&&!te.expectContiguousMatch);if(ue){const ce=(0,O.matchesPrefix)(te.normalized,z);let Se;if(ce){Se=a;const j=Math.round(te.normalized.length/z.length*100);Se+=j}else Se=t;return{score:Se+ue,labelMatch:ce||k(ie)}}}if(V){let ue=V;ge&&(ue=`${V}${A.sep}`);const ie=ue.length,ce=`${ue}${z}`,[Se,j]=R(ce,te.normalized,te.normalizedLowercase,K&&!te.expectContiguousMatch);if(Se){const $=k(j),X=[],re=[];return $.forEach(Q=>{Q.start<ie&&Q.end>ie?(X.push({start:0,end:Q.end-ie}),re.push({start:Q.start,end:ie})):Q.start>=ie?X.push({start:Q.start-ie,end:Q.end-ie}):re.push(Q)}),{score:Se,labelMatch:X,descriptionMatch:re}}}return c}function k(z){const V=[];if(!z)return V;let ge;for(const te of z)ge&&ge.end===te?ge.end+=1:(ge={start:te,end:te+1},V.push(ge));return V}function C(z){const V=z.sort((q,K)=>q.start-K.start),ge=[];let te;for(const q of V)!te||!p(te,q)?(te=q,ge.push(q)):(te.start=Math.min(te.start,q.start),te.end=Math.max(te.end,q.end));return ge}function p(z,V){return!(z.end<V.start||V.end<z.start)}function m(z,V,ge,te,q,K){const ue=s(z,ge,te,q,K),ie=s(V,ge,te,q,K),ce=ue.score,Se=ie.score;if((ce===h||Se===h)&&ce!==Se)return ce===h?-1:1;if(ce>t||Se>t){if(ce!==Se)return ce>Se?-1:1;if(ce<a&&Se<a){const J=D(ue.labelMatch,ie.labelMatch);if(J!==0)return J}const Q=q.getItemLabel(z)||"",Z=q.getItemLabel(V)||"";if(Q.length!==Z.length)return Q.length-Z.length}if(ce!==Se)return ce>Se?-1:1;const j=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,$=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(j&&!$)return-1;if($&&!j)return 1;const X=b(z,ue,q),re=b(V,ie,q);return X&&re&&X!==re?re>X?-1:1:M(z,V,ge,q)}e.compareItemsByFuzzyScore=m;function b(z,V,ge){let te=-1,q=-1;if(V.descriptionMatch&&V.descriptionMatch.length?te=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(te=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(q=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const K=ge.getItemDescription(z);K&&(q+=K.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(q=V.descriptionMatch[V.descriptionMatch.length-1].end);return q-te}function D(z,V){if(!z&&!V||(!z||!z.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!z||!z.length)return 1;const ge=z[0].start,q=z[z.length-1].end-ge,K=V[0].start,ie=V[V.length-1].end-K;return q===ie?0:ie<q?1:-1}function M(z,V,ge,te){const q=te.getItemLabel(z)||"",K=te.getItemLabel(V)||"",ue=te.getItemDescription(z),ie=te.getItemDescription(V),ce=q.length+(ue?ue.length:0),Se=K.length+(ie?ie.length:0);if(ce!==Se)return ce-Se;const j=te.getItemPath(z),$=te.getItemPath(V);return j&&$&&j.length!==$.length?j.length-$.length:q!==K?(0,I.compareAnything)(q,K,ge.normalized):ue&&ie&&ue!==ie?(0,I.compareAnything)(ue,ie,ge.normalized):j&&$&&j!==$?(0,I.compareAnything)(j,$,ge.normalized):0}function L(z){return z.startsWith('"')&&z.endsWith('"')}const F=" ";function x(z){typeof z!="string"&&(z="");const V=z.toLowerCase(),{pathNormalized:ge,normalized:te,normalizedLowercase:q}=U(z),K=ge.indexOf(A.sep)>=0,ue=L(z);let ie;const ce=z.split(F);if(ce.length>1)for(const Se of ce){const j=L(Se),{pathNormalized:$,normalized:X,normalizedLowercase:re}=U(Se);X&&(ie||(ie=[]),ie.push({original:Se,originalLowercase:Se.toLowerCase(),pathNormalized:$,normalized:X,normalizedLowercase:re,expectContiguousMatch:j}))}return{original:z,originalLowercase:V,pathNormalized:ge,normalized:te,normalizedLowercase:q,values:ie,containsPathSeparator:K,expectContiguousMatch:ue}}e.prepareQuery=x;function U(z){let V;T.isWindows?V=z.replace(/\//g,A.sep):V=z.replace(/\\/g,A.sep);const ge=(0,g.stripWildcards)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:ge,normalizedLowercase:ge.toLowerCase()}}function N(z){return Array.isArray(z)?x(z.map(V=>V.original).join(F)):x(z.original)}e.pieceToQuery=N}),define(De[97],Ie([1,0,16]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const P=(0,I.extname)(R),E=O[P.toLowerCase()];return E!==void 0?E:T(R)}e.getMediaOrTextMime=A;function T(R){const P=(0,I.extname)(R);return f[P.toLowerCase()]}e.getMediaMime=T;function g(R){for(const P in f)if(f[P]===R)return P}e.getExtensionForMimeType=g;const y=/^(.+)\/(.+?)(;.+)?$/;function v(R,P){const E=y.exec(R);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:P?void 0:R}e.normalizeMimeType=v}),define(De[98],Ie([1,0,12]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(g){g[g.stdout=0]="stdout",g[g.stderr=1]="stderr"})(O||(e.Source=O={}));var f;(function(g){g[g.Success=0]="Success",g[g.Unknown=1]="Unknown",g[g.AccessDenied=2]="AccessDenied",g[g.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function A(g,...y){const v=y.reduce((E,S)=>(E[S]=!0,E),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(g).filter(E=>!v[E]).forEach(E=>{for(let S=0;S<R.length;S++)if(E.search(R[S])!==-1){delete g[E];break}})}e.sanitizeProcessEnvironment=A;function T(g){g&&(delete g.DEBUG,I.isMacintosh&&delete g.DYLD_LIBRARY_PATH,I.isLinux&&delete g.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(De[2],Ie([1,0,16,12]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function g(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!f.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(n,r){return!n&&!r?"file":n}function v(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const R="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(r){return r instanceof S?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,l,k,C,p,m=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=y(r,m),this.authority=l||R,this.path=v(this.scheme,k||R),this.query=C||R,this.fragment=p||R,g(this,m))}get fsPath(){return h(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:k,path:C,query:p,fragment:m}=r;return l===void 0?l=this.scheme:l===null&&(l=R),k===void 0?k=this.authority:k===null&&(k=R),C===void 0?C=this.path:C===null&&(C=R),p===void 0?p=this.query:p===null&&(p=R),m===void 0?m=this.fragment:m===null&&(m=R),l===this.scheme&&k===this.authority&&C===this.path&&p===this.query&&m===this.fragment?this:new d(l,k,C,p,m)}static parse(r,l=!1){const k=E.exec(r);return k?new d(k[2]||R,s(k[4]||R),s(k[5]||R),s(k[7]||R),s(k[9]||R),l):new d(R,R,R,R,R)}static file(r){let l=R;if(O.isWindows&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const k=r.indexOf(P,2);k===-1?(l=r.substring(2),r=P):(l=r.substring(2,k),r=r.substring(k)||P)}return new d("file",l,r,R,R)}static from(r,l){return new d(r.scheme,r.authority,r.path,r.query,r.fragment,l)}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return O.isWindows&&r.scheme==="file"?k=S.file(I.win32.join(h(r,!0),...l)).path:k=I.posix.join(r.path,...l),r.with({path:k})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof S)return r;{const l=new d(r);return l._formatted=r.external??null,l._fsPath=r._sep===w?r.fsPath??null:null,l}}else return r}}e.URI=S;function _(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.isUriComponents=_;const w=O.isWindows?1:void 0;class d extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=w),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(n,r,l){let k,C=-1;for(let p=0;p<n.length;p++){const m=n.charCodeAt(p);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||r&&m===47||l&&m===91||l&&m===93||l&&m===58)C!==-1&&(k+=encodeURIComponent(n.substring(C,p)),C=-1),k!==void 0&&(k+=n.charAt(p));else{k===void 0&&(k=n.substr(0,p));const b=o[m];b!==void 0?(C!==-1&&(k+=encodeURIComponent(n.substring(C,p)),C=-1),k+=b):C===-1&&(C=p)}}return C!==-1&&(k+=encodeURIComponent(n.substring(C))),k!==void 0?k:n}function c(n){let r;for(let l=0;l<n.length;l++){const k=n.charCodeAt(l);k===35||k===63?(r===void 0&&(r=n.substr(0,l)),r+=o[k]):r!==void 0&&(r+=n[l])}return r!==void 0?r:n}function h(n,r){let l;return n.authority&&n.path.length>1&&n.scheme==="file"?l=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?l=n.path.substr(1):l=n.path[1].toLowerCase()+n.path.substr(2):l=n.path,O.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=h;function a(n,r){const l=r?c:u;let k="",{scheme:C,authority:p,path:m,query:b,fragment:D}=n;if(C&&(k+=C,k+=":"),(p||C==="file")&&(k+=P,k+=P),p){let M=p.indexOf("@");if(M!==-1){const L=p.substr(0,M);p=p.substr(M+1),M=L.lastIndexOf(":"),M===-1?k+=l(L,!1,!1):(k+=l(L.substr(0,M),!1,!1),k+=":",k+=l(L.substr(M+1),!1,!0)),k+="@"}p=p.toLowerCase(),M=p.lastIndexOf(":"),M===-1?k+=l(p,!1,!0):(k+=l(p.substr(0,M),!1,!0),k+=p.substr(M))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const M=m.charCodeAt(1);M>=65&&M<=90&&(m=`/${String.fromCharCode(M+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const M=m.charCodeAt(0);M>=65&&M<=90&&(m=`${String.fromCharCode(M+32)}:${m.substr(2)}`)}k+=l(m,!0,!1)}return b&&(k+="?",k+=l(b,!1,!1)),D&&(k+="#",k+=r?D:u(D,!1,!1)),k}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(i)?n.replace(i,r=>t(r)):n}}),define(De[181],Ie([1,0,2]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=O;function f(v){const R=[];let P;try{const E=JSON.parse(v.arguments),S=E[E.length-1];S&&S.__$stack&&(E.pop(),P=S.__$stack),R.push(...E)}catch{R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:P}}e.parse=f;function A(v){if(typeof v!="string")return A(f(v).stack);const R=v;if(R){const P=T(R),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(E&&E.length===4)return{uri:I.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=A;function T(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function g(v,R){const{args:P,stack:E}=f(v),S=typeof P[0]=="string"&&P.length===1;let _=T(E);_&&(_=`(${_.trim()})`);let w=[];if(typeof P[0]=="string"?_&&S?w=[`%c[${R}] %c${P[0]} %c${_}`,y("blue"),y(""),y("grey")]:w=[`%c[${R}] %c${P[0]}`,y("blue"),y(""),...P.slice(1)]:w=[`%c[${R}]%`,y("blue"),...P],_&&!S&&w.push(_),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,w)}e.log=g;function y(v){return`color: ${v}`}}),define(De[62],Ie([1,0,22,2]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function f(y){return JSON.stringify(y,T)}e.stringify=f;function A(y){let v=JSON.parse(y);return v=g(v),v}e.parse=A;function T(y,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:v.flags}:v}function g(y,v=0){if(!y||v>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return O.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 17:return new Date(y.source)}if(y instanceof I.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let R=0;R<y.length;++R)y[R]=g(y[R],v+1);else for(const R in y)Object.hasOwnProperty.call(y,R)&&(y[R]=g(y[R],v+1))}return y}e.revive=g}),define(De[18],Ie([1,0,9,12,2]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(R){this._preferredWebSchema=R}setDelegate(R){this._delegate=R}setServerRootPath(R){this._remoteResourcesPath=`${R}/${A.vscodeRemoteResource}`}set(R,P,E){this._hosts[R]=P,this._ports[R]=E}setConnectionToken(R,P){this._connectionTokens[R]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(R){if(this._delegate)try{return this._delegate(R)}catch(d){return I.onUnexpectedError(d),R}const P=R.authority;let E=this._hosts[P];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const S=this._ports[P],_=this._connectionTokens[P];let w=`path=${encodeURIComponent(R.path)}`;return typeof _=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),f.URI.from({scheme:O.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${E}:${S}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class g{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(R){const P=this.toUri(R,pe);return this.uriToBrowserUri(P)}uriToBrowserUri(R){return R.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===A.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${A.vscodeFileResource}://${g.FALLBACK_AUTHORITY}`)?R.with({scheme:A.vscodeFileResource,authority:R.authority||g.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(R){const P=this.toUri(R,pe);return this.uriToFileUri(P)}uriToFileUri(R){return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==g.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(R,P){return f.URI.isUri(R)?R:f.URI.parse(P.toUrl(R))}}e.FileAccess=new g;var y;(function(v){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(R.get("3"));const P="vscode-coi";function E(_){let w;typeof _=="string"?w=new URL(_).searchParams:_ instanceof URL?w=_.searchParams:f.URI.isUri(_)&&(w=new URL(_.toString(!0)).searchParams);const d=w?.get(P);if(d)return R.get(d)}v.getHeadersFromQuery=E;function S(_,w,d){if(!globalThis.crossOriginIsolated)return;const o=w&&d?"3":d?"2":"1";_ instanceof URLSearchParams?_.set(P,o):_[P]=o}v.addSearchParam=S})(y||(e.COI=y={}))}),define(De[182],Ie([1,0,156,18,12,2]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(E,S,_){this.id=E,this.dependencies=S,this.callback=_}}class g{static{this.INSTANCE=new g}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(E,S,_)=>{typeof E!="string"&&(_=S,S=E,E=null),(typeof S!="object"||!Array.isArray(S))&&(_=S,S=null),this._defineCalls.push(new T(E,S,_))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(E){if(E.startsWith(window.location.origin)||E.startsWith("vscode-file://vscode-app"))return E;throw new Error(`[trusted_script_src] Invalid script url: ${E}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(E){return E}})))}async load(E){this._initialize();const S=await(this._isWebWorker?this._workerLoadScript(E):this._isRenderer?this._rendererLoadScript(E):this._nodeJSLoadScript(E));if(!S)throw new Error(`Did not receive a define call from script ${E}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${E}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}_rendererLoadScript(E){return new Promise((S,_)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const d=()=>{w.removeEventListener("load",o),w.removeEventListener("error",u)},o=c=>{d(),S(this._defineCalls.pop())},u=c=>{d(),_(c)};w.addEventListener("load",o),w.addEventListener("error",u),this._amdPolicy&&(E=this._amdPolicy.createScriptURL(E)),w.setAttribute("src",E),document.getElementsByTagName("head")[0].appendChild(w)})}_workerLoadScript(E){return new Promise((S,_)=>{try{this._amdPolicy&&(E=this._amdPolicy.createScriptURL(E)),importScripts(E),S(this._defineCalls.pop())}catch(w){_(w)}})}async _nodeJSLoadScript(E){try{const S=globalThis._VSCODE_NODE_MODULES.fs,_=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,d=A.URI.parse(E).fsPath,o=S.readFileSync(d).toString(),u=w.wrap(o.replace(/^#!.*/,""));return new _.Script(u).runInThisContext().apply(),this._defineCalls.pop()}catch(S){throw S}}}const y=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function R(P,E,S){if(I.isESM){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[P]&&(P=v[P]);const _=`${P}/${E}`;if(y.has(_))return y.get(_);let w;if(/^\w[\w\d+.-]*:\/\//.test(_))w=_;else{const c=`${S&&!f.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${_}`;w=O.FileAccess.asBrowserUri(c).toString(!0)}const d=g.INSTANCE.load(w);return y.set(_,d),d}else return await new Promise((_,w)=>{pe([P],_,w)})}e.importAMDNodeModule=R}),define(De[23],Ie([1,0,33,18,16,12,15,2]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(S){return(0,g.uriToFsPath)(S,!0)}e.originalFSPath=y;class v{constructor(_){this._ignorePathCasing=_}compare(_,w,d=!1){return _===w?0:(0,T.compare)(this.getComparisonKey(_,d),this.getComparisonKey(w,d))}isEqual(_,w,d=!1){return _===w?!0:!_||!w?!1:this.getComparisonKey(_,d)===this.getComparisonKey(w,d)}getComparisonKey(_,w=!1){return _.with({path:this._ignorePathCasing(_)?_.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(_){return this._ignorePathCasing(_)}isEqualOrParent(_,w,d=!1){if(_.scheme===w.scheme){if(_.scheme===O.Schemas.file)return I.isEqualOrParent(y(_),y(w),this._ignorePathCasing(_))&&_.query===w.query&&(d||_.fragment===w.fragment);if((0,e.isEqualAuthority)(_.authority,w.authority))return I.isEqualOrParent(_.path,w.path,this._ignorePathCasing(_),"/")&&_.query===w.query&&(d||_.fragment===w.fragment)}return!1}joinPath(_,...w){return g.URI.joinPath(_,...w)}basenameOrAuthority(_){return(0,e.basename)(_)||_.authority}basename(_){return f.posix.basename(_.path)}extname(_){return f.posix.extname(_.path)}dirname(_){if(_.path.length===0)return _;let w;return _.scheme===O.Schemas.file?w=g.URI.file(f.dirname(y(_))).path:(w=f.posix.dirname(_.path),_.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${_.toString})) resulted in a relative path`),w="/")),_.with({path:w})}normalizePath(_){if(!_.path.length)return _;let w;return _.scheme===O.Schemas.file?w=g.URI.file(f.normalize(y(_))).path:w=f.posix.normalize(_.path),_.with({path:w})}relativePath(_,w){if(_.scheme!==w.scheme||!(0,e.isEqualAuthority)(_.authority,w.authority))return;if(_.scheme===O.Schemas.file){const u=f.relative(y(_),y(w));return A.isWindows?I.toSlashes(u):u}let d=_.path||"/";const o=w.path||"/";if(this._ignorePathCasing(_)){let u=0;for(const c=Math.min(d.length,o.length);u<c&&!(d.charCodeAt(u)!==o.charCodeAt(u)&&d.charAt(u).toLowerCase()!==o.charAt(u).toLowerCase());u++);d=o.substr(0,u)+d.substr(u)}return f.posix.relative(d,o)}resolvePath(_,w){if(_.scheme===O.Schemas.file){const d=g.URI.file(f.resolve(y(_),w));return _.with({authority:d.authority,path:d.path})}return w=I.toPosixPath(w),_.with({path:f.posix.resolve(_.path,w)})}isAbsolutePath(_){return!!_.path&&_.path[0]==="/"}isEqualAuthority(_,w){return _===w||_!==void 0&&w!==void 0&&(0,T.equalsIgnoreCase)(_,w)}hasTrailingPathSeparator(_,w=f.sep){if(_.scheme===O.Schemas.file){const d=y(_);return d.length>I.getRoot(d).length&&d[d.length-1]===w}else{const d=_.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(_.fsPath)}}removeTrailingPathSeparator(_,w=f.sep){return(0,e.hasTrailingPathSeparator)(_,w)?_.with({path:_.path.substr(0,_.path.length-1)}):_}addTrailingPathSeparator(_,w=f.sep){let d=!1;if(_.scheme===O.Schemas.file){const o=y(_);d=o!==void 0&&o.length===I.getRoot(o).length&&o[o.length-1]===w}else{w="/";const o=_.path;d=o.length===1&&o.charCodeAt(o.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(_,w)?_.with({path:_.path+"/"}):_}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(S=>S.scheme===O.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new v(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(S,_){const w=[];for(let d=0;d<S.length;d++){const o=_(S[d]);S.some((u,c)=>c===d?!1:(0,e.isEqualOrParent)(o,_(u)))||w.push(S[d])}return w}e.distinctParents=R;var P;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function _(w){const d=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[h,a]=c.split(":");h&&a&&d.set(h,a)});const u=w.path.substring(0,w.path.indexOf(";"));return u&&d.set(S.META_DATA_MIME,u),d}S.parseMetaData=_})(P||(e.DataUri=P={}));function E(S,_,w){if(_){let d=S.path;return d&&d[0]!==f.posix.sep&&(d=f.posix.sep+d),S.with({scheme:w,authority:_,path:d})}return S.with({scheme:w})}e.toLocalResource=E}),define(De[8],Ie([1,0,21,9,4,3,23,12,160]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(X){return!!X&&typeof X.then=="function"}e.isThenable=v;function R(X){const re=new I.CancellationTokenSource,Q=X(re.token),Z=new Promise((J,be)=>{const ae=re.token.onCancellationRequested(()=>{ae.dispose(),re.dispose(),be(new O.CancellationError)});Promise.resolve(Q).then(fe=>{ae.dispose(),re.dispose(),J(fe)},fe=>{ae.dispose(),re.dispose(),be(fe)})});return new class{cancel(){re.cancel()}then(J,be){return Z.then(J,be)}catch(J){return this.then(void 0,J)}finally(J){return Z.finally(J)}}}e.createCancelablePromise=R;function P(X,re,Q){return new Promise((Z,J)=>{const be=re.onCancellationRequested(()=>{be.dispose(),Z(Q)});X.then(Z,J).finally(()=>be.dispose())})}e.raceCancellation=P;function E(X,re){return new Promise((Q,Z)=>{const J=re.onCancellationRequested(()=>{J.dispose(),Z(new O.CancellationError)});X.then(Q,Z).finally(()=>J.dispose())})}e.raceCancellationError=E;async function S(X){let re=-1;const Q=X.map((Z,J)=>Z.then(be=>(re=J,be)));try{return await Promise.race(Q)}finally{X.forEach((Z,J)=>{J!==re&&Z.cancel()})}}e.raceCancellablePromises=S;function _(X,re,Q){let Z;const J=setTimeout(()=>{Z?.(void 0),Q?.()},re);return Promise.race([X.finally(()=>clearTimeout(J)),new Promise(be=>Z=be)])}e.raceTimeout=_;function w(X){return new Promise((re,Q)=>{const Z=X();v(Z)?Z.then(re,Q):re(Z)})}e.asPromise=w;class d{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(re){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=re,!this.queuedPromise){const Q=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(Q,Q).then(Z)})}return new Promise((Q,Z)=>{this.queuedPromise.then(Q,Z)})}return this.activePromise=re(),new Promise((Q,Z)=>{this.activePromise.then(J=>{this.activePromise=null,Q(J)},J=>{this.activePromise=null,Z(J)})})}dispose(){this.isDisposed=!0}}e.Throttler=d;class o{constructor(){this.current=Promise.resolve(null)}queue(re){return this.current=this.current.then(()=>re(),()=>re())}}e.Sequencer=o;class u{constructor(){this.promiseMap=new Map}queue(re,Q){const J=(this.promiseMap.get(re)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.promiseMap.get(re)===J&&this.promiseMap.delete(re)});return this.promiseMap.set(re,J),J}}e.SequencerByKey=u;const c=(X,re)=>{let Q=!0;const Z=setTimeout(()=>{Q=!1,re()},X);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(Z),Q=!1}}},h=X=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,X())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class a{constructor(re){this.defaultDelay=re,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(re,Q=this.defaultDelay){this.task=re,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((J,be)=>{this.doResolve=J,this.doReject=be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const J=this.task;return this.task=null,J()}}));const Z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Q===y.MicrotaskDelay?h(Z):c(Q,Z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class t{constructor(re){this.delayer=new a(re),this.throttler=new d}trigger(re,Q){return this.delayer.trigger(()=>this.throttler.queue(re),Q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=t;class i{constructor(){this._isOpen=!1,this._promise=new Promise((re,Q)=>{this._completePromise=re})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class s extends i{constructor(re){super(),this._timeout=setTimeout(()=>this.open(),re)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function n(X,re){return re?new Promise((Q,Z)=>{const J=setTimeout(()=>{be.dispose(),Q()},X),be=re.onCancellationRequested(()=>{clearTimeout(J),be.dispose(),Z(new O.CancellationError)})}):R(Q=>n(X,Q))}e.timeout=n;function r(X,re=0,Q){const Z=setTimeout(()=>{X(),Q&&J.dispose()},re),J=(0,A.toDisposable)(()=>{clearTimeout(Z),Q?.deleteAndLeak(J)});return Q?.add(J),J}e.disposableTimeout=r;function l(X){const re=[];let Q=0;const Z=X.length;function J(){return Q<Z?X[Q++]():null}function be(ae){ae!=null&&re.push(ae);const fe=J();return fe?fe.then(be):Promise.resolve(re)}return Promise.resolve(null).then(be)}e.sequence=l;function k(X,re=Z=>!!Z,Q=null){let Z=0;const J=X.length,be=()=>{if(Z>=J)return Promise.resolve(Q);const ae=X[Z++];return Promise.resolve(ae()).then(ee=>re(ee)?Promise.resolve(ee):be())};return be()}e.first=k;function C(X,re=Z=>!!Z,Q=null){if(X.length===0)return Promise.resolve(Q);let Z=X.length;const J=()=>{Z=-1;for(const be of X)be.cancel?.()};return new Promise((be,ae)=>{for(const fe of X)fe.then(ee=>{--Z>=0&&re(ee)?(J(),be(ee)):Z===0&&be(Q)}).catch(ee=>{--Z>=0&&(J(),ae(ee))})})}e.firstParallel=C;class p{constructor(re){this._size=0,this.maxDegreeOfParalellism=re,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new f.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(re){return this._size++,new Promise((Q,Z)=>{this.outstandingPromises.push({factory:re,c:Q,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const re=this.outstandingPromises.shift();this.runningPromises++;const Q=re.factory();Q.then(re.c,re.e),Q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=p;class m extends p{constructor(){super(1)}}e.Queue=m;class b{constructor(){this.sequentializer=new ge,this.tasks=0}queue(re){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,re())):this.sequentializer.run(this.tasks++,re())}}e.LimitedQueue=b;class D{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const re=new K;return this.drainers.add(re),re.p}isDrained(){for(const[,re]of this.queues)if(re.size>0)return!1;return!0}queueFor(re,Q=T.extUri){const Z=Q.getComparisonKey(re);let J=this.queues.get(Z);if(!J){J=new m;const be=this.drainListenerCount++,ae=f.Event.once(J.onDrained)(()=>{J?.dispose(),this.queues.delete(Z),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(be),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(be,ae),this.queues.set(Z,J)}return J}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const re of this.drainers)re.complete();this.drainers.clear()}dispose(){for(const[,re]of this.queues)re.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=D;class M{constructor(re,Q){this._token=-1,typeof re=="function"&&typeof Q=="number"&&this.setIfNotSet(re,Q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(re,Q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,re()},Q)}setIfNotSet(re,Q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,re()},Q))}}e.TimeoutTimer=M;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(re,Q){this.cancel(),this._token=setInterval(()=>{re()},Q)}}e.IntervalTimer=L;class F{constructor(re,Q){this.timeoutToken=-1,this.runner=re,this.timeout=Q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(re=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,re)}get delay(){return this.timeout}set delay(re){this.timeout=re}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class x{constructor(re,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.runner=re,this.timeout=Q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(re=this.timeout){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(re/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=x;class U extends F{constructor(re,Q){super(re,Q),this.units=[]}work(re){this.units.push(re),this.isScheduled()||this.schedule()}doRun(){const re=this.units;this.units=[],this.runner?.(re)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class N extends A.Disposable{constructor(re,Q){super(),this.options=re,this.handler=Q,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(re){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+re.length>this.options.maxBufferedWork)return!1}else if(this.pending+re.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const Q of re)this.pendingWork.push(Q);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,g.setTimeout0)(()=>{if(re)return;const Q=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.runWhenIdle=(X,re)=>{const Q=requestIdleCallback(X,typeof re=="number"?{timeout:re}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(Q))}}}}();class z{constructor(re){this._didRun=!1,this._executor=()=>{try{this._value=re()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=z;async function V(X,re,Q){let Z;for(let J=0;J<Q;J++)try{return await X()}catch(be){Z=be,await n(re)}throw Z}e.retry=V;class ge{isRunning(re){return typeof re=="number"?this._running?.taskId===re:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(re,Q,Z){return this._running={taskId:re,cancel:()=>Z?.(),promise:Q},Q.then(()=>this.doneRunning(re),()=>this.doneRunning(re)),Q}doneRunning(re){this._running&&re===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const re=this._queued;this._queued=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this._queued)this._queued.run=re;else{let Q,Z;const J=new Promise((be,ae)=>{Q=be,Z=ae});this._queued={run:re,promise:J,promiseResolve:Q,promiseReject:Z}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ge;class te{constructor(re,Q=()=>Date.now()){this.interval=re,this.nowFn=Q,this.lastIncrementTime=0,this.value=0}increment(){const re=this.nowFn();return re-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=re,this.value=0),this.value++,this.value}}e.IntervalCounter=te;var q;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(q||(q={}));class K{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((re,Q)=>{this.completeCallback=re,this.errorCallback=Q})}complete(re){return new Promise(Q=>{this.completeCallback(re),this.outcome={outcome:0,value:re},Q()})}error(re){return new Promise(Q=>{this.errorCallback(re),this.outcome={outcome:1,value:re},Q()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=K;var ue;(function(X){async function re(Z){let J;const be=await Promise.all(Z.map(ae=>ae.then(fe=>fe,fe=>{J||(J=fe)})));if(typeof J<"u")throw J;return be}X.settled=re;function Q(Z){return new Promise(async(J,be)=>{try{await Z(J,be)}catch(ae){be(ae)}})}X.withAsyncBody=Q})(ue||(e.Promises=ue={}));var ie;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(ie||(ie={}));class ce{static fromArray(re){return new ce(Q=>{Q.emitMany(re)})}static fromPromise(re){return new ce(async Q=>{Q.emitMany(await re)})}static fromPromises(re){return new ce(async Q=>{await Promise.all(re.map(async Z=>Q.emitOne(await Z)))})}static merge(re){return new ce(async Q=>{await Promise.all(re.map(async Z=>{for await(const J of Z)Q.emitOne(J)}))})}static{this.EMPTY=ce.fromArray([])}constructor(re){this._state=0,this._results=[],this._error=null,this._onStateChanged=new f.Emitter,queueMicrotask(async()=>{const Q={emitOne:Z=>this.emitOne(Z),emitMany:Z=>this.emitMany(Z),reject:Z=>this.reject(Z)};try{await Promise.resolve(re(Q)),this.resolve()}catch(Z){this.reject(Z)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(re<this._results.length)return{done:!1,value:this._results[re++]};if(this._state===1)return{done:!0,value:void 0};await f.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(re,Q){return new ce(async Z=>{for await(const J of re)Z.emitOne(Q(J))})}map(re){return ce.map(this,re)}static filter(re,Q){return new ce(async Z=>{for await(const J of re)Q(J)&&Z.emitOne(J)})}filter(re){return ce.filter(this,re)}static coalesce(re){return ce.filter(re,Q=>!!Q)}coalesce(){return ce.coalesce(this)}static async toPromise(re){const Q=[];for await(const Z of re)Q.push(Z);return Q}toPromise(){return ce.toPromise(this)}emitOne(re){this._state===0&&(this._results.push(re),this._onStateChanged.fire())}emitMany(re){this._state===0&&(this._results=this._results.concat(re),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(re){this._state===0&&(this._state=2,this._error=re,this._onStateChanged.fire())}}e.AsyncIterableObject=ce;class Se extends ce{constructor(re,Q){super(Q),this._source=re}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Se;function j(X){const re=new I.CancellationTokenSource,Q=X(re.token);return new Se(re,async Z=>{const J=re.token.onCancellationRequested(()=>{J.dispose(),re.dispose(),Z.reject(new O.CancellationError)});try{for await(const be of Q){if(re.token.isCancellationRequested)return;Z.emitOne(be)}J.dispose(),re.dispose()}catch(be){J.dispose(),re.dispose(),Z.reject(be)}})}e.createCancelableAsyncIterable=j;class ${constructor(){this._deferred=new K,this._asyncIterable=new ce(Z=>{if(re){Z.reject(re);return}return Q&&Z.emitMany(Q),this._errorFn=J=>Z.reject(J),this._emitFn=J=>Z.emitOne(J),this._deferred.p});let re,Q;this._emitFn=Z=>{Q||(Q=[]),Q.push(Z)},this._errorFn=Z=>{re||(re=Z)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(re){this._errorFn(re),this._deferred.complete()}emitOne(re){this._emitFn(re)}}e.AsyncIterableSource=$}),define(De[36],Ie([1,0,19,8,33,28,16,12,15]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",P="[^/\\\\]",E=/\//g;function S(ge,te){switch(ge){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}${te?`|${R}${P}+`:""})*?`}}function _(ge,te){if(!ge)return[];const q=[];let K=!1,ue=!1,ie="";for(const ce of ge){switch(ce){case te:if(!K&&!ue){q.push(ie),ie="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ie+=ce}return ie&&q.push(ie),q}e.splitGlobAware=_;function w(ge){if(!ge)return"";let te="";const q=_(ge,e.GLOB_SPLIT);if(q.every(K=>K===e.GLOBSTAR))te=".*";else{let K=!1;q.forEach((ue,ie)=>{if(ue===e.GLOBSTAR){if(K)return;te+=S(2,ie===q.length-1)}else{let ce=!1,Se="",j=!1,$="";for(const X of ue){if(X!=="}"&&ce){Se+=X;continue}if(j&&(X!=="]"||!$)){let re;X==="-"?re=X:(X==="^"||X==="!")&&!$?re="^":X===e.GLOB_SPLIT?re="":re=(0,y.escapeRegExpCharacters)(X),$+=re;continue}switch(X){case"{":ce=!0;continue;case"[":j=!0;continue;case"}":{const Q=`(?:${_(Se,",").map(Z=>w(Z)).join("|")})`;te+=Q,ce=!1,Se="";break}case"]":{te+="["+$+"]",j=!1,$="";break}case"?":te+=P;continue;case"*":te+=S(1);continue;default:te+=(0,y.escapeRegExpCharacters)(X)}}ie<q.length-1&&(q[ie+1]!==e.GLOBSTAR||ie+2<q.length)&&(te+=R)}K=ue===e.GLOBSTAR})}return te}const d=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),i=function(){return!1},s=function(){return null};function n(ge,te){if(!ge)return s;let q;typeof ge!="string"?q=ge.pattern:q=ge,q=q.trim();const K=`${q}_${!!te.trimForExclusions}`;let ue=t.get(K);if(ue)return r(ue,ge);let ie;return d.test(q)?ue=k(q.substr(4),q):(ie=o.exec(l(q,te)))?ue=C(ie[1],q):(te.trimForExclusions?c:u).test(q)?ue=p(q,te):(ie=h.exec(l(q,te)))?ue=m(ie[1].substr(1),q,!0):(ie=a.exec(l(q,te)))?ue=m(ie[1],q,!1):ue=b(q),t.set(K,ue),r(ue,ge)}function r(ge,te){if(typeof te=="string")return ge;const q=function(K,ue){return(0,f.isEqualOrParent)(K,te.base,!g.isLinux)?ge((0,y.ltrim)(K.substr(te.base.length),T.sep),ue):null};return q.allBasenames=ge.allBasenames,q.allPaths=ge.allPaths,q.basenames=ge.basenames,q.patterns=ge.patterns,q}function l(ge,te){return te.trimForExclusions&&ge.endsWith("/**")?ge.substr(0,ge.length-2):ge}function k(ge,te){return function(q,K){return typeof q=="string"&&q.endsWith(ge)?te:null}}function C(ge,te){const q=`/${ge}`,K=`\\${ge}`,ue=function(ce,Se){return typeof ce!="string"?null:Se?Se===ge?te:null:ce===ge||ce.endsWith(q)||ce.endsWith(K)?te:null},ie=[ge];return ue.basenames=ie,ue.patterns=[te],ue.allBasenames=ie,ue}function p(ge,te){const q=z(ge.slice(1,-1).split(",").map(Se=>n(Se,te)).filter(Se=>Se!==s),ge),K=q.length;if(!K)return s;if(K===1)return q[0];const ue=function(Se,j){for(let $=0,X=q.length;$<X;$++)if(q[$](Se,j))return ge;return null},ie=q.find(Se=>!!Se.allBasenames);ie&&(ue.allBasenames=ie.allBasenames);const ce=q.reduce((Se,j)=>j.allPaths?Se.concat(j.allPaths):Se,[]);return ce.length&&(ue.allPaths=ce),ue}function m(ge,te,q){const K=T.sep===T.posix.sep,ue=K?ge:ge.replace(E,T.sep),ie=T.sep+ue,ce=T.posix.sep+ge;let Se;return q?Se=function(j,$){return typeof j=="string"&&(j===ue||j.endsWith(ie)||!K&&(j===ge||j.endsWith(ce)))?te:null}:Se=function(j,$){return typeof j=="string"&&(j===ue||!K&&j===ge)?te:null},Se.allPaths=[(q?"*/":"./")+ge],Se}function b(ge){try{const te=new RegExp(`^${w(ge)}$`);return function(q){return te.lastIndex=0,typeof q=="string"&&te.test(q)?ge:null}}catch{return s}}function D(ge,te,q){return!ge||typeof te!="string"?!1:M(ge)(te,void 0,q)}e.match=D;function M(ge,te={}){if(!ge)return i;if(typeof ge=="string"||L(ge)){const q=n(ge,te);if(q===s)return i;const K=function(ue,ie){return!!q(ue,ie)};return q.allBasenames&&(K.allBasenames=q.allBasenames),q.allPaths&&(K.allPaths=q.allPaths),K}return U(ge,te)}e.parse=M;function L(ge){const te=ge;return te?typeof te.base=="string"&&typeof te.pattern=="string":!1}e.isRelativePattern=L;function F(ge){return ge.allBasenames||[]}e.getBasenameTerms=F;function x(ge){return ge.allPaths||[]}e.getPathTerms=x;function U(ge,te){const q=z(Object.getOwnPropertyNames(ge).map(Se=>N(Se,ge[Se],te)).filter(Se=>Se!==s)),K=q.length;if(!K)return s;if(!q.some(Se=>!!Se.requiresSiblings)){if(K===1)return q[0];const Se=function(X,re){let Q;for(let Z=0,J=q.length;Z<J;Z++){const be=q[Z](X,re);if(typeof be=="string")return be;(0,O.isThenable)(be)&&(Q||(Q=[]),Q.push(be))}return Q?(async()=>{for(const Z of Q){const J=await Z;if(typeof J=="string")return J}return null})():null},j=q.find(X=>!!X.allBasenames);j&&(Se.allBasenames=j.allBasenames);const $=q.reduce((X,re)=>re.allPaths?X.concat(re.allPaths):X,[]);return $.length&&(Se.allPaths=$),Se}const ue=function(Se,j,$){let X,re;for(let Q=0,Z=q.length;Q<Z;Q++){const J=q[Q];J.requiresSiblings&&$&&(j||(j=(0,T.basename)(Se)),X||(X=j.substr(0,j.length-(0,T.extname)(Se).length)));const be=J(Se,j,X,$);if(typeof be=="string")return be;(0,O.isThenable)(be)&&(re||(re=[]),re.push(be))}return re?(async()=>{for(const Q of re){const Z=await Q;if(typeof Z=="string")return Z}return null})():null},ie=q.find(Se=>!!Se.allBasenames);ie&&(ue.allBasenames=ie.allBasenames);const ce=q.reduce((Se,j)=>j.allPaths?Se.concat(j.allPaths):Se,[]);return ce.length&&(ue.allPaths=ce),ue}function N(ge,te,q){if(te===!1)return s;const K=n(ge,q);if(K===s)return s;if(typeof te=="boolean")return K;if(te){const ue=te.when;if(typeof ue=="string"){const ie=(ce,Se,j,$)=>{if(!$||!K(ce,Se))return null;const X=ue.replace("$(basename)",()=>j),re=$(X);return(0,O.isThenable)(re)?re.then(Q=>Q?ge:null):re?ge:null};return ie.requiresSiblings=!0,ie}}return K}function z(ge,te){const q=ge.filter(Se=>!!Se.basenames);if(q.length<2)return ge;const K=q.reduce((Se,j)=>{const $=j.basenames;return $?Se.concat($):Se},[]);let ue;if(te){ue=[];for(let Se=0,j=K.length;Se<j;Se++)ue.push(te)}else ue=q.reduce((Se,j)=>{const $=j.patterns;return $?Se.concat($):Se},[]);const ie=function(Se,j){if(typeof Se!="string")return null;if(!j){let X;for(X=Se.length;X>0;X--){const re=Se.charCodeAt(X-1);if(re===47||re===92)break}j=Se.substr(X)}const $=K.indexOf(j);return $!==-1?ue[$]:null};ie.basenames=K,ie.patterns=ue,ie.allBasenames=K;const ce=ge.filter(Se=>!Se.basenames);return ce.push(ie),ce}function V(ge,te){return(0,I.equals)(ge,te,(q,K)=>typeof q=="string"&&typeof K=="string"?q===K:typeof q!="string"&&typeof K!="string"?q.base===K.base&&q.pattern===K.pattern:!1)}e.patternsEquals=V}),define(De[80],Ie([1,0,9,161,23,15,2]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class y{constructor(o="",u=!1){if(this.value=o,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(o,u=0){return this.value+=E(this.supportThemeIcons?(0,O.escapeIcons)(o):o).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,u){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(o,u,c){return this.value+="[",this.value+=this._escape(u,"]"),this.value+="](",this.value+=this._escape(String(o),")"),c&&(this.value+=` "${this._escape(this._escape(c,'"'),")")}"`),this.value+=")",this}_escape(o,u){const c=new RegExp((0,A.escapeRegExpCharacters)(u),"g");return o.replace(c,(h,a)=>o.charAt(a-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=y;function v(d){return R(d)?!d.value:Array.isArray(d)?d.every(v):!0}e.isEmptyMarkdownString=v;function R(d){return d instanceof y?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function P(d,o){return d===o?!0:!d||!o?!1:d.value===o.value&&d.isTrusted===o.isTrusted&&d.supportThemeIcons===o.supportThemeIcons&&d.supportHtml===o.supportHtml&&(d.baseUri===o.baseUri||!!d.baseUri&&!!o.baseUri&&(0,f.isEqual)(T.URI.from(d.baseUri),T.URI.from(o.baseUri)))}e.markdownStringEqual=P;function E(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function S(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=S;function _(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=_;function w(d){const o=[],u=d.split("|").map(h=>h.trim());d=u[0];const c=u[1];if(c){const h=/height=(\d+)/.exec(c),a=/width=(\d+)/.exec(c),t=h?h[1]:"",i=a?a[1]:"",s=isFinite(parseInt(i)),n=isFinite(parseInt(t));s&&o.push(`width="${i}"`),n&&o.push(`height="${t}"`)}return{href:d,dimensions:o}}e.parseHrefAndDimensions=w}),define(De[99],Ie([1,0,19,33,16,12,23,15]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(n,r){const{os:l,tildify:k,relative:C}=r;if(C){const b=v(n,C,l);if(typeof b=="string")return b}let p=n.fsPath;if(l===1&&!A.isWindows?p=p.replace(/\//g,"\\"):l!==1&&A.isWindows&&(p=p.replace(/\\/g,"/")),l!==1&&k?.userHome){const b=k.userHome.fsPath;let D;n.scheme!==k.userHome.scheme&&n.path.startsWith(f.posix.sep)?D=k.userHome.with({path:n.path}).fsPath:D=n.fsPath,p=E(D,b,l)}return(l===1?f.win32:f.posix).normalize(R(p,l===1))}e.getPathLabel=y;function v(n,r,l){const k=l===1?f.win32:f.posix,C=l===3?T.extUri:T.extUriIgnorePathCase,p=r.getWorkspace(),m=(0,I.firstOrDefault)(p.folders);if(!m)return;n.scheme!==m.uri.scheme&&n.path.startsWith(f.posix.sep)&&(n=m.uri.with({path:n.path}));const b=r.getWorkspaceFolder(n);if(!b)return;let D;if(C.isEqual(b.uri,n)?D="":D=C.relativePath(b.uri,n)??"",D&&(D=k.normalize(D)),p.folders.length>1&&!r.noPrefix){const M=b.name?b.name:C.basenameOrAuthority(b.uri);D=D?`${M} \u2022 ${D}`:M}return D}function R(n,r=A.isWindows){return(0,O.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let P=Object.create(null);function E(n,r,l=A.OS){if(l===1||!n||!r)return n;let k=P.original===r?P.normalized:void 0;k||(k=r,A.isWindows&&(k=(0,O.toSlashes)(k)),k=`${(0,g.rtrim)(k,f.posix.sep)}${f.posix.sep}`,P={original:r,normalized:k});let C=n;return A.isWindows&&(C=(0,O.toSlashes)(C)),(l===3?C.startsWith(k):(0,g.startsWithIgnoreCase)(C,k))?`~/${C.substr(k.length)}`:n}e.tildify=E;function S(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=S;const _="\u2026",w="\\\\",d="~";function o(n,r=f.sep){const l=new Array(n.length);let k=!1;for(let C=0;C<n.length;C++){const p=n[C];if(p===""){l[C]=`.${r}`;continue}if(!p){l[C]=p;continue}k=!0;let m="",b=p;b.indexOf(w)===0?(m=b.substr(0,b.indexOf(w)+w.length),b=b.substr(b.indexOf(w)+w.length)):b.indexOf(r)===0?(m=b.substr(0,b.indexOf(r)+r.length),b=b.substr(b.indexOf(r)+r.length)):b.indexOf(d)===0&&(m=b.substr(0,b.indexOf(d)+d.length),b=b.substr(b.indexOf(d)+d.length));const D=b.split(r);for(let M=1;k&&M<=D.length;M++)for(let L=D.length-M;k&&L>=0;L--){k=!1;let F=D.slice(L,L+M).join(r);for(let x=0;!k&&x<n.length;x++)if(x!==C&&n[x]&&n[x].indexOf(F)>-1){const U=L+M===D.length,N=L>0&&n[x].indexOf(r)>-1?r+F:F,z=n[x].endsWith(N);k=!U||z}if(!k){let x="";(D[0].endsWith(":")||m!=="")&&(L===1&&(L=0,M++,F=D[0]+r+F),L>0&&(x=D[0]+r),x=m+x),L>0&&(x=x+_+r),x=x+F,L+M<D.length&&(x=x+r+_),l[C]=x}}k&&(l[C]=p)}return l}e.shorten=o;var u;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(n,r=Object.create(null)){const l=[];let k=!1,C="";for(const p of n)if(p==="$"||k&&p==="{")C&&l.push({value:C,type:u.TEXT}),C="",k=!0;else if(p==="}"&&k){const m=r[C];if(typeof m=="string")m.length&&l.push({value:m,type:u.VARIABLE});else if(m){const b=l[l.length-1];(!b||b.type!==u.SEPARATOR)&&l.push({value:m.label,type:u.SEPARATOR})}C="",k=!1}else C+=p;return C&&!k&&l.push({value:C,type:u.TEXT}),l.filter((p,m)=>{if(p.type===u.SEPARATOR){const b=l[m-1],D=l[m+1];return[b,D].every(M=>M&&(M.type===u.VARIABLE||M.type===u.TEXT)&&M.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=c;function h(n,r){return A.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function a(n,r){return A.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function t(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=t;function i(n){if(n.endsWith("]")){const r=n.lastIndexOf(" [",n.length-2);if(r!==-1){const l=s(n.substring(0,r));return{name:l.name,parentPath:l.parentPath+n.substring(r)}}}return s(n)}e.splitRecentLabel=i;function s(n){const r=n.indexOf("/")!==-1?f.posix:f.win32,l=r.basename(n),k=r.dirname(n);return l.length?{name:l,parentPath:k}:{name:k,parentPath:""}}}),define(De[128],Ie([1,0,22,2]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function f(P){return P.toJSON()}class A{constructor(E){this._uriTransformer=E}transformIncoming(E){const S=this._uriTransformer.transformIncoming(E);return S===E?E:f(O.URI.from(S))}transformOutgoing(E){const S=this._uriTransformer.transformOutgoing(E);return S===E?E:f(O.URI.from(S))}transformOutgoingURI(E){const S=this._uriTransformer.transformOutgoing(E);return S===E?E:O.URI.from(S)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function T(P,E,S){if(!P||S>200)return null;if(typeof P=="object"){if(P instanceof O.URI)return E.transformOutgoing(P);for(const _ in P)if(Object.hasOwnProperty.call(P,_)){const w=T(P[_],E,S+1);w!==null&&(P[_]=w)}}return null}function g(P,E){const S=T(P,E,0);return S===null?P:S}e.transformOutgoingURIs=g;function y(P,E,S,_){if(!P||_>200)return null;if(typeof P=="object"){if(P.$mid===1)return S?O.URI.revive(E.transformIncoming(P)):E.transformIncoming(P);if(P instanceof I.VSBuffer)return null;for(const w in P)if(Object.hasOwnProperty.call(P,w)){const d=y(P[w],E,S,_+1);d!==null&&(P[w]=d)}}return null}function v(P,E){const S=y(P,E,!1,0);return S===null?P:S}e.transformIncomingURIs=v;function R(P,E){const S=y(P,E,!0,0);return S===null?P:S}e.transformAndReviveIncomingURIs=R}),define(De[29],Ie([1,0,53,63,374,8,33,77,16,12,23,2]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function S(N,z=E.UNLINK,V){if((0,T.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return z===E.UNLINK?w(N):_(N,V)}async function _(N,z=(0,T.randomPath)((0,O.tmpdir)())){try{try{await I.promises.rename(N,z)}catch(V){return V.code==="ENOENT"?void 0:w(N)}w(z).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function w(N){return(0,f.promisify)(I.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function d(N){if((0,T.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function o(N,z){return h(await(z?u(N):(0,f.promisify)(I.readdir)(N)))}async function u(N){try{return await(0,f.promisify)(I.readdir)(N,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const z=[],V=await o(N);for(const ge of V){let te=!1,q=!1,K=!1;try{const ue=await e.Promises.lstat((0,y.join)(N,ge));te=ue.isFile(),q=ue.isDirectory(),K=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}z.push({name:ge,isFile:()=>te,isDirectory:()=>q,isSymbolicLink:()=>K})}return z}function c(N){return h(I.readdirSync(N))}e.readdirSync=c;function h(N){return N.map(z=>typeof z=="string"?v.isMacintosh?(0,g.normalizeNFC)(z):z:(z.name=v.isMacintosh?(0,g.normalizeNFC)(z.name):z.name,z))}async function a(N){const z=await o(N),V=[];for(const ge of z)await i.existsDirectory((0,y.join)(N,ge))&&V.push(ge);return V}function t(N,z=1e3){return new Promise(V=>{let ge=!1;const te=setInterval(()=>{ge||(ge=!0,I.access(N,q=>{ge=!1,q&&(clearInterval(te),V(void 0))}))},z)})}e.whenDeleted=t;var i;(function(N){async function z(te){let q;try{if(q=await e.Promises.lstat(te),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(v.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw ue}throw K}}N.stat=z;async function V(te){try{const{stat:q,symbolicLink:K}=await N.stat(te);return q.isFile()&&K?.dangling!==!0}catch{}return!1}N.existsFile=V;async function ge(te){try{const{stat:q,symbolicLink:K}=await N.stat(te);return q.isDirectory()&&K?.dangling!==!0}catch{}return!1}N.existsDirectory=ge})(i||(e.SymlinkSupport=i={}));const s=new A.ResourceQueue;function n(N,z,V){return s.queueFor(P.URI.file(N),R.extUriBiasedIgnorePathCase).queue(()=>{const ge=p(V);return new Promise((te,q)=>k(N,z,ge,K=>K?q(K):te()))})}let r=!0;function l(N){r=N}e.configureFlushOnWrite=l;function k(N,z,V,ge){if(!r)return I.writeFile(N,z,{mode:V.mode,flag:V.flag},ge);I.open(N,V.flag,V.mode,(te,q)=>{if(te)return ge(te);I.writeFile(q,z,K=>{if(K)return I.close(q,()=>ge(K));I.fdatasync(q,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),l(!1)),I.close(q,ie=>ge(ie))))})})}function C(N,z,V){const ge=p(V);if(!r)return I.writeFileSync(N,z,{mode:ge.mode,flag:ge.flag});const te=I.openSync(N,ge.flag,ge.mode);try{I.writeFileSync(te,z);try{I.fdatasyncSync(te)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{I.closeSync(te)}}e.writeFileSync=C;function p(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function m(N,z,V=6e4){if(N!==z)try{v.isWindows&&typeof V=="number"?await b(N,z,Date.now(),V):await(0,f.promisify)(I.rename)(N,z)}catch(ge){if(N.toLowerCase()!==z.toLowerCase()&&ge.code==="EXDEV"||N.endsWith("."))await D(N,z,{preserveSymlinks:!1}),await S(N,E.MOVE);else throw ge}}async function b(N,z,V,ge,te=0){try{return await(0,f.promisify)(I.rename)(N,z)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-V>=ge)throw console.error(`[node.js fs] rename failed after ${te} retries with error: ${q}`),q;if(te===0){let K=!1;try{const{stat:ue}=await i.stat(z);ue.isFile()||(K=!0)}catch{}if(K)throw q}return await(0,A.timeout)(Math.min(100,te*10)),b(N,z,V,ge,te+1)}}async function D(N,z,V){return L(N,z,{root:{source:N,target:z},options:V,handledSourcePaths:new Set})}const M=511;async function L(N,z,V){if(V.handledSourcePaths.has(N))return;V.handledSourcePaths.add(N);const{stat:ge,symbolicLink:te}=await i.stat(N);if(te){if(V.options.preserveSymlinks)try{return await U(N,z,V)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(te.dangling)return}return ge.isDirectory()?F(N,z,ge.mode&M,V):x(N,z,ge.mode&M)}async function F(N,z,V,ge){await e.Promises.mkdir(z,{recursive:!0,mode:V});const te=await o(N);for(const q of te)await L((0,y.join)(N,q),(0,y.join)(z,q),ge)}async function x(N,z,V){await e.Promises.copyFile(N,z),await e.Promises.chmod(z,V)}async function U(N,z,V){let ge=await e.Promises.readlink(N);(0,T.isEqualOrParent)(ge,V.root.source,!v.isLinux)&&(ge=(0,y.join)(V.root.target,ge.substr(V.root.source.length+1))),await e.Promises.symlink(ge,z)}e.Promises=new class{get access(){return(0,f.promisify)(I.access)}get stat(){return(0,f.promisify)(I.stat)}get lstat(){return(0,f.promisify)(I.lstat)}get utimes(){return(0,f.promisify)(I.utimes)}get read(){return(N,z,V,ge,te)=>new Promise((q,K)=>{I.read(N,z,V,ge,te,(ue,ie,ce)=>ue?K(ue):q({bytesRead:ie,buffer:ce}))})}get readFile(){return(0,f.promisify)(I.readFile)}get write(){return(N,z,V,ge,te)=>new Promise((q,K)=>{I.write(N,z,V,ge,te,(ue,ie,ce)=>ue?K(ue):q({bytesWritten:ie,buffer:ce}))})}get appendFile(){return(0,f.promisify)(I.appendFile)}get fdatasync(){return(0,f.promisify)(I.fdatasync)}get truncate(){return(0,f.promisify)(I.truncate)}get copyFile(){return(0,f.promisify)(I.copyFile)}get open(){return(0,f.promisify)(I.open)}get close(){return(0,f.promisify)(I.close)}get symlink(){return(0,f.promisify)(I.symlink)}get readlink(){return(0,f.promisify)(I.readlink)}get chmod(){return(0,f.promisify)(I.chmod)}get mkdir(){return(0,f.promisify)(I.mkdir)}get unlink(){return(0,f.promisify)(I.unlink)}get rmdir(){return(0,f.promisify)(I.rmdir)}get realpath(){return(0,f.promisify)(I.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return n}get rm(){return S}get rename(){return m}get copy(){return D}}}),define(De[100],Ie([1,0,53,16,12,15,29]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function g(E){if(f.isLinux)return E;const S=(0,O.dirname)(E);if(E===S)return E;const _=((0,O.basename)(E)||E).toLowerCase();try{const d=(0,T.readdirSync)(S).filter(o=>o.toLowerCase()===_);if(d.length===1){const o=g(S);if(o)return(0,O.join)(o,d[0])}else if(d.length>1){const o=d.indexOf(_);if(o>=0){const u=g(S);if(u)return(0,O.join)(u,d[o])}}}catch{}return null}e.realcaseSync=g;async function y(E){if(f.isLinux)return E;const S=(0,O.dirname)(E);if(E===S)return E;const _=((0,O.basename)(E)||E).toLowerCase();try{const d=(await T.Promises.readdir(S)).filter(o=>o.toLowerCase()===_);if(d.length===1){const o=await y(S);if(o)return(0,O.join)(o,d[0])}else if(d.length>1){const o=d.indexOf(_);if(o>=0){const u=await y(S);if(u)return(0,O.join)(u,d[o])}}}catch{}return null}e.realcase=y;async function v(E){try{return await T.Promises.realpath(E)}catch{const _=P(E);return await T.Promises.access(_,I.constants.R_OK),_}}e.realpath=v;function R(E){try{return I.realpathSync(E)}catch{const _=P(E);return I.accessSync(_,I.constants.R_OK),_}}e.realpathSync=R;function P(E){return(0,A.rtrim)((0,O.normalize)(E),O.sep)}}),define(De[101],Ie([1,0,16,12,48,98,17,29]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function y(P=f.env){return P.comspec||"cmd.exe"}e.getWindowsShell=y;function v(P){let E=[],S=!1;const _=function(w){if(S){E.push(w);return}(!P.send(w,o=>{if(o&&console.error(o),S=!1,E.length>0){const u=E.slice(0);E=[],u.forEach(c=>_(c))}})||O.isWindows)&&(S=!0)};return{send:_}}e.createQueuedSender=v;var R;(function(P){async function E(S,_,w){if(I.isAbsolute(S))return S;if(_===void 0&&(_=f.cwd()),I.dirname(S)!=="."||(w===void 0&&T.isString(f.env.PATH)&&(w=f.env.PATH.split(I.delimiter)),w===void 0||w.length===0))return I.join(_,S);async function o(u){if(await g.Promises.exists(u)){let c;try{c=await g.Promises.stat(u)}catch(h){h.message.startsWith("EACCES")&&(c=await g.Promises.lstat(u))}return c?!c.isDirectory():!1}return!1}for(const u of w){let c;if(I.isAbsolute(u)?c=I.join(u,S):c=I.join(_,u,S),await o(c))return c;let h=c+".com";if(await o(h)||(h=c+".exe",await o(h)))return h}return I.join(_,S)}P.findExecutable=E})(R||(e.win32=R={}))});var je=this&&this.__decorate||function(pe,e,I,O){var f=arguments.length,A=f<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,I):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(pe,e,I,O);else for(var g=pe.length-1;g>=0;g--)(T=pe[g])&&(A=(f<3?T(A):f>3?T(e,I,A):T(e,I))||A);return f>3&&A&&Object.defineProperty(e,I,A),A};define(De[81],Ie([1,0,19,8,22,21,57,9,4,3,62,15,17]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var S;(function(te){te[te.Promise=100]="Promise",te[te.PromiseCancel=101]="PromiseCancel",te[te.EventListen=102]="EventListen",te[te.EventDispose=103]="EventDispose"})(S||(S={}));function _(te){switch(te){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(te){te[te.Initialize=200]="Initialize",te[te.PromiseSuccess=201]="PromiseSuccess",te[te.PromiseError=202]="PromiseError",te[te.PromiseErrorObj=203]="PromiseErrorObj",te[te.EventFire=204]="EventFire"})(w||(w={}));function d(te){switch(te){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(te){te[te.Uninitialized=0]="Uninitialized",te[te.Idle=1]="Idle"})(o||(o={}));function u(te){let q=0;for(let K=0;;K+=7){const ue=te.read(1);if(q|=(ue.buffer[0]&127)<<K,!(ue.buffer[0]&128))return q}}const c=s(0);function h(te,q){if(q===0){te.write(c);return}let K=0;for(let ie=q;ie!==0;ie=ie>>>7)K++;const ue=f.VSBuffer.alloc(K);for(let ie=0;q!==0;ie++)ue.buffer[ie]=q&127,q=q>>>7,q>0&&(ue.buffer[ie]|=128);te.write(ue)}class a{constructor(q){this.buffer=q,this.pos=0}read(q){const K=this.buffer.slice(this.pos,this.pos+q);return this.pos+=K.byteLength,K}}e.BufferReader=a;class t{constructor(){this.buffers=[]}get buffer(){return f.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=t;var i;(function(te){te[te.Undefined=0]="Undefined",te[te.String=1]="String",te[te.Buffer=2]="Buffer",te[te.VSBuffer=3]="VSBuffer",te[te.Array=4]="Array",te[te.Object=5]="Object",te[te.Int=6]="Int"})(i||(i={}));function s(te){const q=f.VSBuffer.alloc(1);return q.writeUInt8(te,0),q}const n={Undefined:s(i.Undefined),String:s(i.String),Buffer:s(i.Buffer),VSBuffer:s(i.VSBuffer),Array:s(i.Array),Object:s(i.Object),Uint:s(i.Int)},r=typeof Buffer<"u";function l(te,q){if(typeof q>"u")te.write(n.Undefined);else if(typeof q=="string"){const K=f.VSBuffer.fromString(q);te.write(n.String),h(te,K.byteLength),te.write(K)}else if(r&&Buffer.isBuffer(q)){const K=f.VSBuffer.wrap(q);te.write(n.Buffer),h(te,K.byteLength),te.write(K)}else if(q instanceof f.VSBuffer)te.write(n.VSBuffer),h(te,q.byteLength),te.write(q);else if(Array.isArray(q)){te.write(n.Array),h(te,q.length);for(const K of q)l(te,K)}else if(typeof q=="number"&&(q|0)===q)te.write(n.Uint),h(te,q);else{const K=f.VSBuffer.fromString(JSON.stringify(q));te.write(n.Object),h(te,K.byteLength),te.write(K)}}e.serialize=l;function k(te){switch(te.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return te.read(u(te)).toString();case i.Buffer:return te.read(u(te)).buffer;case i.VSBuffer:return te.read(u(te));case i.Array:{const K=u(te),ue=[];for(let ie=0;ie<K;ie++)ue.push(k(te));return ue}case i.Object:return JSON.parse(te.read(u(te)).toString());case i.Int:return u(te)}}e.deserialize=k;class C{constructor(q,K,ue=null,ie=1e3){this.protocol=q,this.ctx=K,this.logger=ue,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ce=>this.onRawMessage(ce)),this.sendResponse({type:200})}registerChannel(q,K){this.channels.set(q,K),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const K=this.send([q.type]);this.logger?.logOutgoing(K,0,1,d(q.type));return}case 201:case 202:case 204:case 203:{const K=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(K,q.id,1,d(q.type),q.data);return}}}send(q,K=void 0){const ue=new t;return l(ue,q),l(ue,K),this.sendBuffer(ue.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const K=new a(q),ue=k(K),ie=k(K),ce=ue[0];switch(ce){case 100:return this.logger?.logIncoming(q.byteLength,ue[1],1,`${_(ce)}: ${ue[2]}.${ue[3]}`,ie),this.onPromise({type:ce,id:ue[1],channelName:ue[2],name:ue[3],arg:ie});case 102:return this.logger?.logIncoming(q.byteLength,ue[1],1,`${_(ce)}: ${ue[2]}.${ue[3]}`,ie),this.onEventListen({type:ce,id:ue[1],channelName:ue[2],name:ue[3],arg:ie});case 101:return this.logger?.logIncoming(q.byteLength,ue[1],1,`${_(ce)}`),this.disposeActiveRequest({type:ce,id:ue[1]});case 103:return this.logger?.logIncoming(q.byteLength,ue[1],1,`${_(ce)}`),this.disposeActiveRequest({type:ce,id:ue[1]})}}onPromise(q){const K=this.channels.get(q.channelName);if(!K){this.collectPendingRequest(q);return}const ue=new A.CancellationTokenSource;let ie;try{ie=K.call(this.ctx,q.name,q.arg,ue.token)}catch(j){ie=Promise.reject(j)}const ce=q.id;ie.then(j=>{this.sendResponse({id:ce,data:j,type:201})},j=>{j instanceof Error?this.sendResponse({id:ce,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:ce,data:j,type:203})}).finally(()=>{Se.dispose(),this.activeRequests.delete(q.id)});const Se=(0,v.toDisposable)(()=>ue.cancel());this.activeRequests.set(q.id,Se)}onEventListen(q){const K=this.channels.get(q.channelName);if(!K){this.collectPendingRequest(q);return}const ue=q.id,ce=K.listen(this.ctx,q.name,q.arg)(Se=>this.sendResponse({id:ue,data:Se,type:204}));this.activeRequests.set(q.id,ce)}disposeActiveRequest(q){const K=this.activeRequests.get(q.id);K&&(K.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let K=this.pendingRequests.get(q.channelName);K||(K=[],this.pendingRequests.set(q.channelName,K));const ue=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:q,timeoutTimer:ue})}flushPendingRequests(q){const K=this.pendingRequests.get(q);if(K){for(const ue of K)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.onPromise(ue.request);break;case 102:this.onEventListen(ue.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var p;(function(te){te[te.LocalSide=0]="LocalSide",te[te.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class m{constructor(q,K=null){this.protocol=q,this.isDisposed=!1,this.state=o.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ue=>this.onBuffer(ue)),this.logger=K}getChannel(q){const K=this;return{call(ue,ie,ce){return K.isDisposed?Promise.reject(new g.CancellationError):K.requestPromise(q,ue,ie,ce)},listen(ue,ie){return K.isDisposed?y.Event.None:K.requestEvent(q,ue,ie)}}}requestPromise(q,K,ue,ie=A.CancellationToken.None){const ce=this.lastRequestId++,j={id:ce,type:100,channelName:q,name:K,arg:ue};if(ie.isCancellationRequested)return Promise.reject(new g.CancellationError);let $;return new Promise((re,Q)=>{if(ie.isCancellationRequested)return Q(new g.CancellationError);const Z=()=>{const fe=ee=>{switch(ee.type){case 201:this.handlers.delete(ce),re(ee.data);break;case 202:{this.handlers.delete(ce);const he=new Error(ee.data.message);he.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,he.name=ee.data.name,Q(he);break}case 203:this.handlers.delete(ce),Q(ee.data);break}};this.handlers.set(ce,fe),this.sendRequest(j)};let J=null;this.state===o.Idle?Z():(J=(0,O.createCancelablePromise)(fe=>this.whenInitialized()),J.then(()=>{J=null,Z()}));const be=()=>{J?(J.cancel(),J=null):this.sendRequest({id:ce,type:101}),Q(new g.CancellationError)},ae=ie.onCancellationRequested(be);$=(0,v.combinedDisposable)((0,v.toDisposable)(be),ae),this.activeRequests.add($)}).finally(()=>{$.dispose(),this.activeRequests.delete($)})}requestEvent(q,K,ue){const ie=this.lastRequestId++,Se={id:ie,type:102,channelName:q,name:K,arg:ue};let j=null;const $=new y.Emitter({onWillAddFirstListener:()=>{j=(0,O.createCancelablePromise)(re=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add($),this.sendRequest(Se)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete($),this.sendRequest({id:ie,type:103}))}}),X=re=>$.fire(re.data);return this.handlers.set(ie,X),$.event}sendRequest(q){switch(q.type){case 100:case 102:{const K=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(K,q.id,0,`${_(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const K=this.send([q.type,q.id]);this.logger?.logOutgoing(K,q.id,0,_(q.type));return}}}send(q,K=void 0){const ue=new t;return l(ue,q),l(ue,K),this.sendBuffer(ue.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const K=new a(q),ue=k(K),ie=k(K),ce=ue[0];switch(ce){case 200:return this.logger?.logIncoming(q.byteLength,0,0,d(ce)),this.onResponse({type:ue[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,ue[1],0,d(ce),ie),this.onResponse({type:ue[0],id:ue[1],data:ie})}}onResponse(q){if(q.type===200){this.state=o.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=m,je([T.memoize],m.prototype,"onDidInitializePromise",null);class b{get connections(){const q=[];return this._connections.forEach(K=>q.push(K)),q}constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new v.DisposableStore,this.disposables.add(q(({protocol:K,onDidClientDisconnect:ue})=>{const ie=y.Event.once(K.onMessage);this.disposables.add(ie(ce=>{const Se=new a(ce),j=k(Se),$=new C(K,j),X=new m(K);this.channels.forEach((Q,Z)=>$.registerChannel(Z,Q));const re={channelServer:$,channelClient:X,ctx:j};this._connections.add(re),this._onDidAddConnection.fire(re),this.disposables.add(ue(()=>{$.dispose(),X.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)}))}))}))}getChannel(q,K){const ue=this;return{call(ie,ce,Se){let j;if((0,E.isFunction)(K)){const X=(0,I.getRandomElement)(ue.connections.filter(K));j=X?Promise.resolve(X):y.Event.toPromise(y.Event.filter(ue.onDidAddConnection,K))}else j=K.routeCall(ue,ie,ce);const $=j.then(X=>X.channelClient.getChannel(q));return M($).call(ie,ce,Se)},listen(ie,ce){if((0,E.isFunction)(K))return ue.getMulticastEvent(q,K,ie,ce);const Se=K.routeEvent(ue,ie,ce).then(j=>j.channelClient.getChannel(q));return M(Se).listen(ie,ce)}}}getMulticastEvent(q,K,ue,ie){const ce=this;let Se;const j=new y.Emitter({onWillAddFirstListener:()=>{Se=new v.DisposableStore;const $=new y.EventMultiplexer,X=new Map,re=Z=>{const be=Z.channelClient.getChannel(q).listen(ue,ie),ae=$.add(be);X.set(Z,ae)},Q=Z=>{const J=X.get(Z);J&&(J.dispose(),X.delete(Z))};ce.connections.filter(K).forEach(re),y.Event.filter(ce.onDidAddConnection,K)(re,void 0,Se),ce.onDidRemoveConnection(Q,void 0,Se),$.event(j.fire,j,Se),Se.add($)},onDidRemoveLastListener:()=>{Se?.dispose(),Se=void 0}});return j.event}registerChannel(q,K){this.channels.set(q,K);for(const ue of this._connections)ue.channelServer.registerChannel(q,K)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class D{constructor(q,K,ue=null){const ie=new t;l(ie,K),q.send(ie.buffer),this.channelClient=new m(q,ue),this.channelServer=new C(q,K,ue)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,K){this.channelServer.registerChannel(q,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function M(te){return{call(q,K,ue){return te.then(ie=>ie.call(q,K,ue))},listen(q,K){const ue=new y.Relay;return te.then(ie=>ue.input=ie.listen(q,K)),ue.event}}}e.getDelayedChannel=M;function L(te){let q=!1;return{call(K,ue,ie){return q?te.call(K,ue,ie):(0,O.timeout)(0).then(()=>q=!0).then(()=>te.call(K,ue,ie))},listen(K,ue){if(q)return te.listen(K,ue);const ie=new y.Relay;return(0,O.timeout)(0).then(()=>q=!0).then(()=>ie.input=te.listen(K,ue)),ie.event}}}e.getNextTickChannel=L;class F{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const K of q.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await y.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=F;var x;(function(te){function q(ce,Se,j){const $=ce,X=j&&j.disableMarshalling,re=new Map;for(const Q in $)ue(Q)&&re.set(Q,y.Event.buffer($[Q],!0,void 0,Se));return new class{listen(Q,Z,J){const be=re.get(Z);if(be)return be;if(ie(Z)){const ae=$[Z];if(typeof ae=="function")return ae.call($,J)}throw new g.ErrorNoTelemetry(`Event not found: ${Z}`)}call(Q,Z,J){const be=$[Z];if(typeof be=="function"){if(!X&&Array.isArray(J))for(let fe=0;fe<J.length;fe++)J[fe]=(0,R.revive)(J[fe]);let ae=be.apply($,J);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new g.ErrorNoTelemetry(`Method not found: ${Z}`)}}}te.fromService=q;function K(ce,Se){const j=Se&&Se.disableMarshalling;return new Proxy({},{get($,X){if(typeof X=="string")return Se?.properties?.has(X)?Se.properties.get(X):ie(X)?function(re){return ce.listen(X,re)}:ue(X)?ce.listen(X):async function(...re){let Q;Se&&!(0,E.isUndefinedOrNull)(Se.context)?Q=[Se.context,...re]:Q=re;const Z=await ce.call(X,Q);return j?Z:(0,R.revive)(Z)};throw new g.ErrorNoTelemetry(`Property not found: ${String(X)}`)}})}te.toService=K;function ue(ce){return ce[0]==="o"&&ce[1]==="n"&&P.isUpperAsciiLetter(ce.charCodeAt(2))}function ie(ce){return/^onDynamic/.test(ce)&&P.isUpperAsciiLetter(ce.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(te){if(Array.isArray(te))return te;if(te&&typeof te=="object"&&typeof te.toString=="function"){const q=te.toString();if(q!=="[object Object]")return q}return te}function z(te){return Array.isArray(te)?te.map(N):N(te)}function V(te,q,K,ue,ie,ce,Se){Se=z(Se);const j=U[ie],$=j[ue%j.length];let X=[`%c[${te}]%c[${String(q).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(ce)?(X=X.concat(Se),X.push(")")):X.push(Se),console.log.apply(console,X)}class ge{constructor(q,K){this._outgoingPrefix=q,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,K,ue,ie,ce){this._totalOutgoing+=q,V(this._outgoingPrefix,this._totalOutgoing,q,K,ue,ie,ce)}logIncoming(q,K,ue,ie,ce){this._totalIncoming+=q,V(this._incomingPrefix,this._totalIncoming,q,K,ue,ie,ce)}}e.IPCLogger=ge}),define(De[82],Ie([1,0,22,4,3,81]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var g;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let l=0;function k(p,m){if(!r.has(p)){const b=String(++l);r.set(p,b)}return r.get(p)}function C(p,m,b,D){if(!n.enableDiagnostics)return;const M=k(p,m);if(D instanceof I.VSBuffer||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const L=I.VSBuffer.alloc(D.byteLength);L.set(D),n.records.push({timestamp:Date.now(),id:M,label:m,type:b,buff:L})}else n.records.push({timestamp:Date.now(),id:M,label:m,type:b,data:D})}n.traceSocketEvent=C})(g||(e.SocketDiagnostics=g={}));var y;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let v=null;function R(){return v||(v=I.VSBuffer.alloc(0)),v}class P{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return R();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const m=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),m}if(this._chunks[0].byteLength>r){const m=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),m}const k=I.VSBuffer.alloc(r);let C=0,p=0;for(;r>0;){const m=this._chunks[p];if(m.byteLength>r){const b=m.slice(0,r);k.set(b,C),C+=r,l&&(this._chunks[p]=m.slice(r),this._totalLength-=r),r-=r}else k.set(m,C),C+=m.byteLength,l?(this._chunks.shift(),this._totalLength-=m.byteLength):p++,r-=m.byteLength}return k}}e.ChunkStream=P;var E;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(E||(E={}));function S(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var _;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(_||(e.ProtocolConstants=_={}));class w{constructor(r,l,k,C){this.type=r,this.id=l,this.ack=k,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends f.Disposable{constructor(r){super(),this._onMessage=this._register(new O.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const k=this._state.messageType,C=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new w(k,C,p,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class o{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=I.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(l,r.data)}_bufferAdd(r,l){const k=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,k}_bufferTake(){const r=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class u extends f.Disposable{constructor(r){super(),this._onMessage=new O.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new o(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new w(1,0,0,r))}}e.Protocol=u;class c extends A.IPCClient{static fromSocket(r,l){return new c(new u(r),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(r,l,k=null){super(r,l,k),this.protocol=r}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new O.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class a{constructor(r){this.data=r,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let r=0,l=this._first;for(;l;)l=l.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let l=0,k=this._first;for(;k;)r[l++]=k.data,k=k.next;return r}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new a(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const r=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let k=0;for(let C=0;C<i._HISTORY_LENGTH;C++)r-this.lastRuns[C]<=l&&k++;return 1-k/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(r){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=r.loadEstimator??i.getInstance(),this._shouldSendKeepAlive=r.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new f.DisposableStore,this._socket=r.socket,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.add(this._socket.onClose(l=>this._onSocketClose.fire(l))),r.initialChunk&&this._socketReader.acceptChunk(r.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new w(5,0,0,R());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new w(7,0,0,R());this._socketWriter.write(r)}sendResume(){const r=new w(8,0,0,R());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new f.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(k=>this._receiveMessage(k))),this._socketDisposables.add(this._socket.onClose(k=>this._onSocketClose.fire(k))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new w(3,0,this._incomingAckId,R());this._socketWriter.write(r);const l=this._outgoingUnackMsg.toArray();for(let k=0,C=l.length;k<C;k++)this._socketWriter.write(l[k]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new w(6,0,0,R())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let k=0,C=l.length;k<C;k++)this._socketWriter.write(l[k]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const k=new w(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(k),this._isReconnecting||(this._socketWriter.write(k),this._recvAckCheck())}sendControl(r){const l=new w(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime,k=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&k>=2e4&&C>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:k});return}const p=Math.max(2e4-l,2e4-k,2e4-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new w(3,0,this._incomingAckId,R());this._socketWriter.write(r)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const r=new w(9,0,this._incomingAckId,R());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(De[183],Ie([1,0,49,8,22,21,181,9,4,3,24,101,98,81]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class _ extends S.ChannelServer{constructor(o){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",u=>f.VSBuffer.wrap(Buffer.from(u,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.Server=_;class w{constructor(o,u){this.modulePath=o,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new O.Delayer(c),this.child=null,this._client=null}getChannel(o){const u=this;return{call(c,h,a){return u.requestPromise(o,c,h,a)},listen(c,h){return u.requestEvent(o,c,h)}}}requestPromise(o,u,c,h=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(o),t=(0,O.createCancelablePromise)(n=>a.call(u,c,n)),i=h.onCancellationRequested(()=>t.cancel()),s=(0,v.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(o,u,c){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let h;const a=new y.Emitter({onWillAddFirstListener:()=>{h=this.getCachedChannel(o).listen(u,c)(a.fire,a),this.activeRequests.add(h)},onDidRemoveLastListener:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const o=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,E.removeDangerousEnvVariables)(u.env),this.child=(0,I.fork)(this.modulePath,o,u);const c=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.options.serverName}`);return}c.fire(f.VSBuffer.wrap(Buffer.from(r,"base64")))});const a=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,t=r=>this.child&&this.child.connected&&a.send(r.buffer.toString("base64")),i=c.event,s={send:t,onMessage:i};this._client=new S.ChannelClient(s);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",n),this.activeRequests.forEach(k=>(0,v.dispose)(k)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(o){let u=this.channels.get(o);return u||(u=this.client.getChannel(o),this.channels.set(o,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(De[184],Ie([1,0,8,4,3,62,17]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var g;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(g||(e.StorageHint=g={}));function y(E){const S=E;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var v;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(v||(e.StorageState=v={}));class R extends f.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(S,_=Object.create(null)){super(),this.database=S,this.options=_,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=this._register(new I.ThrottledDelayer(R.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){this._onDidChangeStorage.pause();try{S.changed?.forEach((_,w)=>this.acceptExternal(w,_)),S.deleted?.forEach(_=>this.acceptExternal(_,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(S,_){if(this.state===v.Closed)return;let w=!1;(0,T.isUndefinedOrNull)(_)?w=this.cache.delete(S):this.cache.get(S)!==_&&(this.cache.set(S,_),w=!0),w&&this._onDidChangeStorage.fire({key:S,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==g.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,_){const w=this.cache.get(S);return(0,T.isUndefinedOrNull)(w)?_:w}getBoolean(S,_){const w=this.get(S);return(0,T.isUndefinedOrNull)(w)?_:w==="true"}getNumber(S,_){const w=this.get(S);return(0,T.isUndefinedOrNull)(w)?_:parseInt(w,10)}getObject(S,_){const w=this.get(S);return(0,T.isUndefinedOrNull)(w)?_:(0,A.parse)(w)}async set(S,_,w=!1){if(this.state===v.Closed)return;if((0,T.isUndefinedOrNull)(_))return this.delete(S,w);const d=(0,T.isObject)(_)||Array.isArray(_)?(0,A.stringify)(_):String(_);if(this.cache.get(S)!==d)return this.cache.set(S,d),this.pendingInserts.set(S,d),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire({key:S,external:w}),this.doFlush()}async delete(S,_=!1){if(!(this.state===v.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire({key:S,external:_}),this.doFlush()}async optimize(){if(this.state!==v.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(this.hasPending)return this.doFlush(S)}async doFlush(S){return this.options.hint===g.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}isInMemory(){return this.options.hint===g.STORAGE_IN_MEMORY}}e.Storage=R;class P{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((_,w)=>this.items.set(w,_)),S.delete?.forEach(_=>this.items.delete(_))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=P}),define(De[185],Ie([1,0,36,16]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function f(A,T,g,y,v,R){if(Array.isArray(A)){let P=0;for(const E of A){const S=f(E,T,g,y,v,R);if(S===10)return S;S>P&&(P=S)}return P}else{if(typeof A=="string")return y?A==="*"?5:A===g?10:0:0;if(A){const{language:P,pattern:E,scheme:S,hasAccessToAllModels:_,notebookType:w}=A;if(!y&&!_)return 0;w&&v&&(T=v);let d=0;if(S)if(S===T.scheme)d=10;else if(S==="*")d=5;else return 0;if(P)if(P===g)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(w)if(w===R)d=10;else if(w==="*"&&R!==void 0)d=Math.max(d,5);else return 0;if(E){let o;if(typeof E=="string"?o=E:o={...E,base:(0,O.normalize)(E.base)},o===T.fsPath||(0,I.match)(o,T.fsPath))d=10;else return 0}return d}else return 0}}e.score=f}),define(De[129],Ie([1,0,22,12]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var f;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(f||(f={}));function A(P){for(let E=0,S=P.length;E<S;E+=4){const _=P[E+0],w=P[E+1],d=P[E+2],o=P[E+3];P[E+0]=o,P[E+1]=d,P[E+2]=w,P[E+3]=_}}function T(P){const E=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return O.isLittleEndian()||A(E),I.VSBuffer.wrap(E)}function g(P){const E=P.buffer;if(O.isLittleEndian()||A(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const S=new Uint8Array(E.byteLength);return S.set(E),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function y(P){const E=new Uint32Array(v(P));let S=0;if(E[S++]=P.id,P.type==="full")E[S++]=1,E[S++]=P.data.length,E.set(P.data,S),S+=P.data.length;else{E[S++]=2,E[S++]=P.deltas.length;for(const _ of P.deltas)E[S++]=_.start,E[S++]=_.deleteCount,_.data?(E[S++]=_.data.length,E.set(_.data,S),S+=_.data.length):E[S++]=0}return T(E)}e.encodeSemanticTokensDto=y;function v(P){let E=0;if(E+=1+1,P.type==="full")E+=1+P.data.length;else{E+=1,E+=(1+1+1)*P.deltas.length;for(const S of P.deltas)S.data&&(E+=S.data.length)}return E}function R(P){const E=g(P);let S=0;const _=E[S++];if(E[S++]===1){const u=E[S++],c=E.subarray(S,S+u);return S+=u,{id:_,type:"full",data:c}}const d=E[S++],o=[];for(let u=0;u<d;u++){const c=E[S++],h=E[S++],a=E[S++];let t;a>0&&(t=E.subarray(S,S+a),S+=a),o[u]={start:c,deleteCount:h,data:t}}return{id:_,type:"delta",deltas:o}}e.decodeSemanticTokensDto=R}),define(De[186],Ie([10,11]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ie([1,0,19,24,12,166,124,186]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(de){de[de.None=0]="None",de[de.Keep=1]="Keep",de[de.Brackets=2]="Brackets",de[de.Advanced=3]="Advanced",de[de.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class v{constructor(le){this._values=le}hasChanged(le){return this._values[le]}}e.ConfigurationChangedEvent=v;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class P{constructor(le,ke,Ve,Be){this.id=le,this.name=ke,this.defaultValue=Ve,this.schema=Be}applyUpdate(le,ke){return S(le,ke)}compute(le,ke,Ve){return Ve}}class E{constructor(le,ke){this.newValue=le,this.didChange=ke}}e.ApplyUpdateResult=E;function S(de,le){if(typeof de!="object"||typeof le!="object"||!de||!le)return new E(le,de!==le);if(Array.isArray(de)||Array.isArray(le)){const Ve=Array.isArray(de)&&Array.isArray(le)&&I.equals(de,le);return new E(le,!Ve)}let ke=!1;for(const Ve in le)if(le.hasOwnProperty(Ve)){const Be=S(de[Ve],le[Ve]);Be.didChange&&(de[Ve]=Be.newValue,ke=!0)}return new E(de,ke)}class _{constructor(le){this.schema=void 0,this.id=le,this.name="_never_",this.defaultValue=void 0}applyUpdate(le,ke){return S(le,ke)}validate(le){return this.defaultValue}}class w{constructor(le,ke,Ve,Be){this.id=le,this.name=ke,this.defaultValue=Ve,this.schema=Be}applyUpdate(le,ke){return S(le,ke)}validate(le){return typeof le>"u"?this.defaultValue:le}compute(le,ke,Ve){return Ve}}function d(de,le){return typeof de>"u"?le:de==="false"?!1:!!de}e.boolean=d;class o extends w{constructor(le,ke,Ve,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=Ve),super(le,ke,Ve,Be)}validate(le){return d(le,this.defaultValue)}}function u(de,le,ke,Ve){if(typeof de>"u")return le;let Be=parseInt(de,10);return isNaN(Be)?le:(Be=Math.max(ke,Be),Be=Math.min(Ve,Be),Be|0)}e.clampedInt=u;class c extends w{static clampedInt(le,ke,Ve,Be){return u(le,ke,Ve,Be)}constructor(le,ke,Ve,Be,Ye,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ve,nt.minimum=Be,nt.maximum=Ye),super(le,ke,Ve,nt),this.minimum=Be,this.maximum=Ye}validate(le){return c.clampedInt(le,this.defaultValue,this.minimum,this.maximum)}}function h(de,le,ke,Ve){if(typeof de>"u")return le;const Be=a.float(de,le);return a.clamp(Be,ke,Ve)}e.clampedFloat=h;class a extends w{static clamp(le,ke,Ve){return le<ke?ke:le>Ve?Ve:le}static float(le,ke){if(typeof le=="number")return le;if(typeof le>"u")return ke;const Ve=parseFloat(le);return isNaN(Ve)?ke:Ve}constructor(le,ke,Ve,Be,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Ve),super(le,ke,Ve,Ye),this.validationFn=Be}validate(le){return this.validationFn(a.float(le,this.defaultValue))}}class t extends w{static string(le,ke){return typeof le!="string"?ke:le}constructor(le,ke,Ve,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=Ve),super(le,ke,Ve,Be)}validate(le){return t.string(le,this.defaultValue)}}function i(de,le,ke,Ve){return typeof de!="string"?le:Ve&&de in Ve?Ve[de]:ke.indexOf(de)===-1?le:de}e.stringSet=i;class s extends w{constructor(le,ke,Ve,Be,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Be,Ye.default=Ve),super(le,ke,Ve,Ye),this._allowedValues=Be}validate(le){return i(le,this.defaultValue,this._allowedValues)}}class n extends P{constructor(le,ke,Ve,Be,Ye,nt,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=Ye,ct.default=Be),super(le,ke,Ve,ct),this._allowedValues=Ye,this._convert=nt}validate(le){return typeof le!="string"?this.defaultValue:this._allowedValues.indexOf(le)===-1?this.defaultValue:this._convert(le)}}function r(de){switch(de){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(le){switch(le){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(le,ke,Ve){return Ve===0?le.accessibilitySupport:Ve}}class k extends P{constructor(){const le={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",le,{"editor.comments.insertSpace":{type:"boolean",default:le.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:le.ignoreEmptyLines,description:g.localize(5,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{insertSpace:d(ke.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ke.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(de){de[de.Hidden=0]="Hidden",de[de.Blink=1]="Blink",de[de.Smooth=2]="Smooth",de[de.Phase=3]="Phase",de[de.Expand=4]="Expand",de[de.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function p(de){switch(de){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(de){de[de.Line=1]="Line",de[de.Block=2]="Block",de[de.Underline=3]="Underline",de[de.LineThin=4]="LineThin",de[de.BlockOutline=5]="BlockOutline",de[de.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function b(de){switch(de){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function D(de){switch(de){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class M extends _{constructor(){super(141)}compute(le,ke,Ve){const Be=["monaco-editor"];return ke.get(39)&&Be.push(ke.get(39)),le.extraEditorClassName&&Be.push(le.extraEditorClassName),ke.get(73)==="default"?Be.push("mouse-default"):ke.get(73)==="copy"&&Be.push("mouse-copy"),ke.get(111)&&Be.push("showUnused"),ke.get(139)&&Be.push("showDeprecated"),Be.join(" ")}}class L extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(le,ke,Ve){return Ve&&le.emptySelectionClipboard}}class F extends P{constructor(){const le={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",le,{"editor.find.cursorMoveOnType":{type:"boolean",default:le.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:le.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:le.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:le.globalFindClipboard,description:g.localize(16,null),included:f.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:le.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:le.loop,description:g.localize(18,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{cursorMoveOnType:d(ke.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof le.seedSearchStringFromSelection=="boolean"?le.seedSearchStringFromSelection?"always":"never":i(ke.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof le.autoFindInSelection=="boolean"?le.autoFindInSelection?"always":"never":i(ke.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ke.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ke.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ke.loop,this.defaultValue.loop)}}}class x extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?x.OFF:le==="true"?x.ON:le:le?x.ON:x.OFF}}e.EditorFontLigatures=x;class U extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?U.OFF:le==="true"?U.TRANSLATE:le:le?U.TRANSLATE:U.OFF}compute(le,ke,Ve){return le.fontInfo.fontVariationSettings}}e.EditorFontVariations=U;class N extends _{constructor(){super(50)}compute(le,ke,Ve){return le.fontInfo}}class z extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(le){const ke=a.float(le,this.defaultValue);return ke===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(ke,6,100)}compute(le,ke,Ve){return le.fontInfo.fontSize}}class V extends P{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(le){return le==="normal"||le==="bold"?le:String(c.clampedInt(le,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}class ge extends P{constructor(){const le={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ke={type:"string",enum:["peek","gotoAndPeek","goto"],default:le.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",le,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...ke},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...ke},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...ke},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...ke},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...ke},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:le.alternativeDefinitionCommand,enum:Ve,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:le.alternativeTypeDefinitionCommand,enum:Ve,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:le.alternativeDeclarationCommand,enum:Ve,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:le.alternativeImplementationCommand,enum:Ve,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:le.alternativeReferenceCommand,enum:Ve,description:g.localize(41,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{multiple:i(ke.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ke.multipleDefinitions??i(ke.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ke.multipleTypeDefinitions??i(ke.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ke.multipleDeclarations??i(ke.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ke.multipleImplementations??i(ke.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ke.multipleReferences??i(ke.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ke.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ke.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ke.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ke.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ke.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class te extends P{constructor(){const le={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",le,{"editor.hover.enabled":{type:"boolean",default:le.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:le.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:le.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:le.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:le.above,description:g.localize(46,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:d(ke.enabled,this.defaultValue.enabled),delay:c.clampedInt(ke.delay,this.defaultValue.delay,0,1e4),sticky:d(ke.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(ke.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d(ke.above,this.defaultValue.above)}}}var q;(function(de){de[de.None=0]="None",de[de.Text=1]="Text",de[de.Blocks=2]="Blocks"})(q||(e.RenderMinimap=q={}));class K extends _{constructor(){super(144)}compute(le,ke,Ve){return K.computeLayout(ke,{memory:le.memory,outerWidth:le.outerWidth,outerHeight:le.outerHeight,isDominatedByLongLines:le.isDominatedByLongLines,lineHeight:le.fontInfo.lineHeight,viewLineCount:le.viewLineCount,lineNumbersDigitCount:le.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:le.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:le.fontInfo.maxDigitWidth,pixelRatio:le.pixelRatio,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(le){const ke=le.height/le.lineHeight,Ve=Math.floor(le.paddingTop/le.lineHeight);let Be=Math.floor(le.paddingBottom/le.lineHeight);le.scrollBeyondLastLine&&(Be=Math.max(Be,ke-1));const Ye=(Ve+le.viewLineCount+Be)/(le.pixelRatio*le.height),nt=Math.floor(le.viewLineCount/Ye);return{typicalViewportLineCount:ke,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Be,desiredRatio:Ye,minimapLineCount:nt}}static _computeMinimapLayout(le,ke){const Ve=le.outerWidth,Be=le.outerHeight,Ye=le.pixelRatio;if(!le.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const nt=ke.stableMinimapLayoutInput,ct=nt&&le.outerHeight===nt.outerHeight&&le.lineHeight===nt.lineHeight&&le.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&le.pixelRatio===nt.pixelRatio&&le.scrollBeyondLastLine===nt.scrollBeyondLastLine&&le.paddingTop===nt.paddingTop&&le.paddingBottom===nt.paddingBottom&&le.minimap.enabled===nt.minimap.enabled&&le.minimap.side===nt.minimap.side&&le.minimap.size===nt.minimap.size&&le.minimap.showSlider===nt.minimap.showSlider&&le.minimap.renderCharacters===nt.minimap.renderCharacters&&le.minimap.maxColumn===nt.minimap.maxColumn&&le.minimap.scale===nt.minimap.scale&&le.verticalScrollbarWidth===nt.verticalScrollbarWidth&&le.isViewportWrapping===nt.isViewportWrapping,vt=le.lineHeight,yt=le.typicalHalfwidthCharacterWidth,Vt=le.scrollBeyondLastLine,jt=le.minimap.renderCharacters;let bt=Ye>=2?Math.round(le.minimap.scale*2):le.minimap.scale;const xt=le.minimap.maxColumn,Mt=le.minimap.size,qt=le.minimap.side,Bt=le.verticalScrollbarWidth,Dt=le.viewLineCount,Ft=le.remainingWidth,$t=le.isViewportWrapping,Gt=jt?2:3;let Wt=Math.floor(Ye*Be);const zt=Wt/Ye;let Nt=!1,lt=!1,ft=Gt*bt,Tt=bt/Ye,Ht=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:Kt,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Oe,desiredRatio:Ce,minimapLineCount:ne}=K.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Vt,paddingTop:le.paddingTop,paddingBottom:le.paddingBottom,height:Be,lineHeight:vt,pixelRatio:Ye});if(Dt/ne>1)Nt=!0,lt=!0,bt=1,ft=1,Tt=bt/Ye;else{let He=!1,Je=bt+1;if(Mt==="fit"){const Ge=Math.ceil((Le+Dt+Oe)*ft);$t&&ct&&Ft<=ke.stableFitRemainingWidth?(He=!0,Je=ke.stableFitMaxMinimapScale):He=Ge>Wt}if(Mt==="fill"||He){Nt=!0;const Ge=bt;ft=Math.min(vt*Ye,Math.max(1,Math.floor(1/Ce))),$t&&ct&&Ft<=ke.stableFitRemainingWidth&&(Je=ke.stableFitMaxMinimapScale),bt=Math.min(Je,Math.max(1,Math.floor(ft/Gt))),bt>Ge&&(Ht=Math.min(2,bt/Ge)),Tt=bt/Ye/Ht,Wt=Math.ceil(Math.max(Kt,Le+Dt+Oe)*ft),$t?(ke.stableMinimapLayoutInput=le,ke.stableFitRemainingWidth=Ft,ke.stableFitMaxMinimapScale=bt):(ke.stableMinimapLayoutInput=null,ke.stableFitRemainingWidth=0)}}}const At=Math.floor(xt*Tt),at=Math.min(At,Math.max(0,Math.floor((Ft-Bt-2)*Tt/(yt+Tt)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Ye*at);const Ot=wt/Ye;wt=Math.floor(wt*Ht);const Pt=jt?1:2,qe=qt==="left"?0:Ve-at-Bt;return{renderMinimap:Pt,minimapLeft:qe,minimapWidth:at,minimapHeightIsEditorHeight:Nt,minimapIsSampling:lt,minimapScale:bt,minimapLineHeight:ft,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ot,minimapCanvasOuterHeight:zt}}static computeLayout(le,ke){const Ve=ke.outerWidth|0,Be=ke.outerHeight|0,Ye=ke.lineHeight|0,nt=ke.lineNumbersDigitCount|0,ct=ke.typicalHalfwidthCharacterWidth,vt=ke.maxDigitWidth,yt=ke.pixelRatio,Vt=ke.viewLineCount,jt=le.get(136),bt=jt==="inherit"?le.get(135):jt,xt=bt==="inherit"?le.get(131):bt,Mt=le.get(134),qt=ke.isDominatedByLongLines,Bt=le.get(57),Dt=le.get(67).renderType!==0,Ft=le.get(68),$t=le.get(105),Gt=le.get(84),Wt=le.get(72),zt=le.get(103),Nt=zt.verticalScrollbarSize,lt=zt.verticalHasArrows,ft=zt.arrowSize,Tt=zt.horizontalScrollbarSize,Ht=le.get(43),At=le.get(110)!=="never";let at=le.get(65);Ht&&At&&(at+=16);let wt=0;if(Dt){const _t=Math.max(nt,Ft);wt=Math.round(_t*vt)}let Ot=0;Bt&&(Ot=Ye*ke.glyphMarginDecorationLaneCount);let Pt=0,qe=Pt+Ot,Kt=qe+wt,Le=Kt+at;const Oe=Ve-Ot-wt-at;let Ce=!1,ne=!1,Fe=-1;bt==="inherit"&&qt?(Ce=!0,ne=!0):xt==="on"||xt==="bounded"?ne=!0:xt==="wordWrapColumn"&&(Fe=Mt);const He=K._computeMinimapLayout({outerWidth:Ve,outerHeight:Be,lineHeight:Ye,typicalHalfwidthCharacterWidth:ct,pixelRatio:yt,scrollBeyondLastLine:$t,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:Wt,verticalScrollbarWidth:Nt,viewLineCount:Vt,remainingWidth:Oe,isViewportWrapping:ne},ke.memory||new R);He.renderMinimap!==0&&He.minimapLeft===0&&(Pt+=He.minimapWidth,qe+=He.minimapWidth,Kt+=He.minimapWidth,Le+=He.minimapWidth);const Je=Oe-He.minimapWidth,Ge=Math.max(1,Math.floor((Je-Nt-2)/ct)),rt=lt?ft:0;return ne&&(Fe=Math.max(1,Ge),xt==="bounded"&&(Fe=Math.min(Fe,Mt))),{width:Ve,height:Be,glyphMarginLeft:Pt,glyphMarginWidth:Ot,glyphMarginDecorationLaneCount:ke.glyphMarginDecorationLaneCount,lineNumbersLeft:qe,lineNumbersWidth:wt,decorationsLeft:Kt,decorationsWidth:at,contentLeft:Le,contentWidth:Je,minimap:He,viewportColumn:Ge,isWordWrapMinified:Ce,isViewportWrapping:ne,wrappingColumn:Fe,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:Tt,overviewRuler:{top:rt,width:Nt,height:Be-2*rt,right:0}}}}e.EditorLayoutInfoComputer=K;class ue extends P{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(le){return i(le,"simple",["simple","advanced"])}compute(le,ke,Ve){return ke.get(2)===2?"advanced":Ve}}class ie extends P{constructor(){const le={enabled:!0};super(64,"lightbulb",le,{"editor.lightbulb.enabled":{type:"boolean",default:le.enabled,description:g.localize(50,null)}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{enabled:d(le.enabled,this.defaultValue.enabled)}}}class ce extends P{constructor(){const le={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",le,{"editor.stickyScroll.enabled":{type:"boolean",default:le.enabled,description:g.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:le.maxLineCount,minimum:1,maximum:10,description:g.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:le.defaultModel,description:g.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:le.scrollWithEditor,description:g.localize(54,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:d(ke.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(ke.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:i(ke.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d(ke.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Se extends P{constructor(){const le={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",le,{"editor.inlayHints.enabled":{type:"string",default:le.enabled,description:g.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(56,null),g.localize(57,null,f.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),g.localize(58,null,f.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),g.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:le.fontSize,markdownDescription:g.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:le.fontFamily,markdownDescription:g.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:le.padding,description:g.localize(62,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return typeof ke.enabled=="boolean"&&(ke.enabled=ke.enabled?"on":"off"),{enabled:i(ke.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(ke.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily),padding:d(ke.padding,this.defaultValue.padding)}}}class j extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(le){return typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)?-parseFloat(le.substring(0,le.length-2)):c.clampedInt(le,this.defaultValue,0,1e3)}compute(le,ke,Ve){return Ve<0?c.clampedInt(-Ve*le.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class $ extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,le=>a.clamp(le,0,150),{markdownDescription:g.localize(63,null)})}compute(le,ke,Ve){return le.fontInfo.lineHeight}}class X extends P{constructor(){const le={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",le,{"editor.minimap.enabled":{type:"boolean",default:le.enabled,description:g.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:le.autohide,description:g.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:le.size,description:g.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:le.side,description:g.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:le.showSlider,description:g.localize(71,null)},"editor.minimap.scale":{type:"number",default:le.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:le.renderCharacters,description:g.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:le.maxColumn,description:g.localize(74,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:d(ke.enabled,this.defaultValue.enabled),autohide:d(ke.autohide,this.defaultValue.autohide),size:i(ke.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ke.side,this.defaultValue.side,["right","left"]),showSlider:i(ke.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ke.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ke.scale,1,1,3),maxColumn:c.clampedInt(ke.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(de){return de==="ctrlCmd"?f.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(76,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{top:c.clampedInt(ke.top,0,0,1e3),bottom:c.clampedInt(ke.bottom,0,0,1e3)}}}class Z extends P{constructor(){const le={enabled:!0,cycle:!0};super(86,"parameterHints",le,{"editor.parameterHints.enabled":{type:"boolean",default:le.enabled,description:g.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:le.cycle,description:g.localize(78,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:d(ke.enabled,this.defaultValue.enabled),cycle:d(ke.cycle,this.defaultValue.cycle)}}}class J extends _{constructor(){super(142)}compute(le,ke,Ve){return le.pixelRatio}}class be extends P{constructor(){const le={other:"on",comments:"off",strings:"off"},ke=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(79,null),g.localize(80,null),g.localize(81,null)]}];super(89,"quickSuggestions",le,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ke,default:le.strings,description:g.localize(82,null)},comments:{anyOf:ke,default:le.comments,description:g.localize(83,null)},other:{anyOf:ke,default:le.other,description:g.localize(84,null)}},default:le,markdownDescription:g.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=le}validate(le){if(typeof le=="boolean"){const yt=le?"on":"off";return{comments:yt,strings:yt,other:yt}}if(!le||typeof le!="object")return this.defaultValue;const{other:ke,comments:Ve,strings:Be}=le,Ye=["on","inline","off"];let nt,ct,vt;return typeof ke=="boolean"?nt=ke?"on":"off":nt=i(ke,this.defaultValue.other,Ye),typeof Ve=="boolean"?ct=Ve?"on":"off":ct=i(Ve,this.defaultValue.comments,Ye),typeof Be=="boolean"?vt=Be?"on":"off":vt=i(Be,this.defaultValue.strings,Ye),{other:nt,comments:ct,strings:vt}}}var ae;(function(de){de[de.Off=0]="Off",de[de.On=1]="On",de[de.Relative=2]="Relative",de[de.Interval=3]="Interval",de[de.Custom=4]="Custom"})(ae||(e.RenderLineNumbersType=ae={}));class fe extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(86,null),g.localize(87,null),g.localize(88,null),g.localize(89,null)],default:"on",description:g.localize(90,null)})}validate(le){let ke=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof le<"u"&&(typeof le=="function"?(ke=4,Ve=le):le==="interval"?ke=3:le==="relative"?ke=2:le==="on"?ke=1:ke=0),{renderType:ke,renderFn:Ve}}}function ee(de){const le=de.get(98);return le==="editable"?de.get(91):le!=="on"}e.filterValidationDecorations=ee;class he extends P{constructor(){const le=[],ke={type:"number",description:g.localize(91,null)};super(102,"rulers",le,{type:"array",items:{anyOf:[ke,{type:["object"],properties:{column:ke,color:{type:"string",description:g.localize(92,null),format:"color-hex"}}}]},default:le,description:g.localize(93,null)})}validate(le){if(Array.isArray(le)){const ke=[];for(const Ve of le)if(typeof Ve=="number")ke.push({column:c.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Be=Ve;ke.push({column:c.clampedInt(Be.column,0,0,1e4),color:Be.color})}return ke.sort((Ve,Be)=>Ve.column-Be.column),ke}return this.defaultValue}}class ve extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(le){return!le||typeof le!="object"?this.defaultValue:le}}function Pe(de,le){if(typeof de!="string")return le;switch(de){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends P{constructor(){const le={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",le,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(94,null),g.localize(95,null),g.localize(96,null)],default:"auto",description:g.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(98,null),g.localize(99,null),g.localize(100,null)],default:"auto",description:g.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:le.verticalScrollbarSize,description:g.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:le.horizontalScrollbarSize,description:g.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:le.scrollByPage,description:g.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:le.ignoreHorizontalScrollbarInContentHeight,description:g.localize(105,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le,Ve=c.clampedInt(ke.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=c.clampedInt(ke.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ke.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(ke.vertical,this.defaultValue.vertical),horizontal:Pe(ke.horizontal,this.defaultValue.horizontal),useShadows:d(ke.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ke.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ke.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ke.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ke.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:c.clampedInt(ke.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:c.clampedInt(ke.verticalSliderSize,Be,0,1e3),scrollByPage:d(ke.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d(ke.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends P{constructor(){const le={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",le,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.nonBasicASCII,description:g.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:le.invisibleCharacters,description:g.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:le.ambiguousCharacters,description:g.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeComments,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeStrings,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:le.allowedCharacters,description:g.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:le.allowedLocales,description:g.localize(112,null)}})}applyUpdate(le,ke){let Ve=!1;ke.allowedCharacters&&le&&(O.equals(le.allowedCharacters,ke.allowedCharacters)||(le={...le,allowedCharacters:ke.allowedCharacters},Ve=!0)),ke.allowedLocales&&le&&(O.equals(le.allowedLocales,ke.allowedLocales)||(le={...le,allowedLocales:ke.allowedLocales},Ve=!0));const Be=super.applyUpdate(le,ke);return Ve?new E(Be.newValue,!0):Be}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{nonBasicASCII:me(ke.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ke.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ke.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(ke.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(ke.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(le.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(le.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(le,ke){if(typeof le!="object"||!le)return ke;const Ve={};for(const[Be,Ye]of Object.entries(le))Ye===!0&&(Ve[Be]=!0);return Ve}}class se extends P{constructor(){const le={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",le,{"editor.inlineSuggest.enabled":{type:"boolean",default:le.enabled,description:g.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:le.showToolbar,enum:["always","onHover"],enumDescriptions:[g.localize(114,null),g.localize(115,null)],description:g.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:le.suppressSuggestions,description:g.localize(117,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:d(ke.enabled,this.defaultValue.enabled),mode:i(ke.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(ke.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:d(ke.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d(ke.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends P{constructor(){const le={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",le,{"editor.bracketPairColorization.enabled":{type:"boolean",default:le.enabled,markdownDescription:g.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:le.independentColorPoolPerBracketType,description:g.localize(119,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:d(ke.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(ke.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends P{constructor(){const le={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",le,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(120,null),g.localize(121,null),g.localize(122,null)],default:le.bracketPairs,description:g.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(124,null),g.localize(125,null),g.localize(126,null)],default:le.bracketPairsHorizontal,description:g.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:le.highlightActiveBracketPair,description:g.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:le.indentation,description:g.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(130,null),g.localize(131,null),g.localize(132,null)],default:le.highlightActiveIndentation,description:g.localize(133,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{bracketPairs:me(ke.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(ke.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ke.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ke.indentation,this.defaultValue.indentation),highlightActiveIndentation:me(ke.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function me(de,le,ke){const Ve=ke.indexOf(de);return Ve===-1?le:ke[Ve]}class ye extends P{constructor(){const le={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",le,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(134,null),g.localize(135,null)],default:le.insertMode,description:g.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:le.filterGraceful,description:g.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:le.localityBonus,description:g.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:le.shareSuggestSelections,markdownDescription:g.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(140,null),g.localize(141,null),g.localize(142,null),g.localize(143,null)],default:le.selectionMode,markdownDescription:g.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:le.snippetsPreventQuickSuggestions,description:g.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:le.showIcons,description:g.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:le.showStatusBar,description:g.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:le.preview,description:g.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:le.showInlineDetails,description:g.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{insertMode:i(ke.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ke.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ke.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ke.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ke.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(ke.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(ke.showIcons,this.defaultValue.showIcons),showStatusBar:d(ke.showStatusBar,this.defaultValue.showStatusBar),preview:d(ke.preview,this.defaultValue.preview),previewMode:i(ke.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ke.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ke.showMethods,this.defaultValue.showMethods),showFunctions:d(ke.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ke.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ke.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(ke.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(ke.showFields,this.defaultValue.showFields),showVariables:d(ke.showVariables,this.defaultValue.showVariables),showClasses:d(ke.showClasses,this.defaultValue.showClasses),showStructs:d(ke.showStructs,this.defaultValue.showStructs),showInterfaces:d(ke.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ke.showModules,this.defaultValue.showModules),showProperties:d(ke.showProperties,this.defaultValue.showProperties),showEvents:d(ke.showEvents,this.defaultValue.showEvents),showOperators:d(ke.showOperators,this.defaultValue.showOperators),showUnits:d(ke.showUnits,this.defaultValue.showUnits),showValues:d(ke.showValues,this.defaultValue.showValues),showConstants:d(ke.showConstants,this.defaultValue.showConstants),showEnums:d(ke.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ke.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ke.showKeywords,this.defaultValue.showKeywords),showWords:d(ke.showWords,this.defaultValue.showWords),showColors:d(ke.showColors,this.defaultValue.showColors),showFiles:d(ke.showFiles,this.defaultValue.showFiles),showReferences:d(ke.showReferences,this.defaultValue.showReferences),showFolders:d(ke.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ke.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ke.showSnippets,this.defaultValue.showSnippets),showUsers:d(ke.showUsers,this.defaultValue.showUsers),showIssues:d(ke.showIssues,this.defaultValue.showIssues)}}}class xe extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(183,null),default:!0,type:"boolean"}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(le.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(le.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(de){de[de.None=0]="None",de[de.Same=1]="Same",de[de.Indent=2]="Indent",de[de.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Ze extends P{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(184,null),g.localize(185,null),g.localize(186,null),g.localize(187,null)],description:g.localize(188,null),default:"same"}})}validate(le){switch(le){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(le,ke,Ve){return ke.get(2)===2?0:Ve}}class Xe extends _{constructor(){super(145)}compute(le,ke,Ve){const Be=ke.get(144);return{isDominatedByLongLines:le.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class it extends P{constructor(){const le={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",le,{"editor.dropIntoEditor.enabled":{type:"boolean",default:le.enabled,markdownDescription:g.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(191,null),g.localize(192,null)],default:"afterDrop"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:d(ke.enabled,this.defaultValue.enabled),showDropSelector:i(ke.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends P{constructor(){const le={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",le,{"editor.pasteAs.enabled":{type:"boolean",default:le.enabled,markdownDescription:g.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(195,null),g.localize(196,null)],default:"afterPaste"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:d(ke.enabled,this.defaultValue.enabled),showPasteSelector:i(ke.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Te="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.isMacintosh?Me:f.isLinux?ze:Te,fontWeight:"normal",fontSize:f.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(de){return e.editorOptionsRegistry[de.id]=de,de}var Qe;(function(de){de[de.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",de[de.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",de[de.accessibilitySupport=2]="accessibilitySupport",de[de.accessibilityPageSize=3]="accessibilityPageSize",de[de.ariaLabel=4]="ariaLabel",de[de.ariaRequired=5]="ariaRequired",de[de.autoClosingBrackets=6]="autoClosingBrackets",de[de.autoClosingComments=7]="autoClosingComments",de[de.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",de[de.autoClosingDelete=9]="autoClosingDelete",de[de.autoClosingOvertype=10]="autoClosingOvertype",de[de.autoClosingQuotes=11]="autoClosingQuotes",de[de.autoIndent=12]="autoIndent",de[de.automaticLayout=13]="automaticLayout",de[de.autoSurround=14]="autoSurround",de[de.bracketPairColorization=15]="bracketPairColorization",de[de.guides=16]="guides",de[de.codeLens=17]="codeLens",de[de.codeLensFontFamily=18]="codeLensFontFamily",de[de.codeLensFontSize=19]="codeLensFontSize",de[de.colorDecorators=20]="colorDecorators",de[de.colorDecoratorsLimit=21]="colorDecoratorsLimit",de[de.columnSelection=22]="columnSelection",de[de.comments=23]="comments",de[de.contextmenu=24]="contextmenu",de[de.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",de[de.cursorBlinking=26]="cursorBlinking",de[de.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",de[de.cursorStyle=28]="cursorStyle",de[de.cursorSurroundingLines=29]="cursorSurroundingLines",de[de.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",de[de.cursorWidth=31]="cursorWidth",de[de.disableLayerHinting=32]="disableLayerHinting",de[de.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",de[de.domReadOnly=34]="domReadOnly",de[de.dragAndDrop=35]="dragAndDrop",de[de.dropIntoEditor=36]="dropIntoEditor",de[de.emptySelectionClipboard=37]="emptySelectionClipboard",de[de.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",de[de.extraEditorClassName=39]="extraEditorClassName",de[de.fastScrollSensitivity=40]="fastScrollSensitivity",de[de.find=41]="find",de[de.fixedOverflowWidgets=42]="fixedOverflowWidgets",de[de.folding=43]="folding",de[de.foldingStrategy=44]="foldingStrategy",de[de.foldingHighlight=45]="foldingHighlight",de[de.foldingImportsByDefault=46]="foldingImportsByDefault",de[de.foldingMaximumRegions=47]="foldingMaximumRegions",de[de.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",de[de.fontFamily=49]="fontFamily",de[de.fontInfo=50]="fontInfo",de[de.fontLigatures=51]="fontLigatures",de[de.fontSize=52]="fontSize",de[de.fontWeight=53]="fontWeight",de[de.fontVariations=54]="fontVariations",de[de.formatOnPaste=55]="formatOnPaste",de[de.formatOnType=56]="formatOnType",de[de.glyphMargin=57]="glyphMargin",de[de.gotoLocation=58]="gotoLocation",de[de.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",de[de.hover=60]="hover",de[de.inDiffEditor=61]="inDiffEditor",de[de.inlineSuggest=62]="inlineSuggest",de[de.letterSpacing=63]="letterSpacing",de[de.lightbulb=64]="lightbulb",de[de.lineDecorationsWidth=65]="lineDecorationsWidth",de[de.lineHeight=66]="lineHeight",de[de.lineNumbers=67]="lineNumbers",de[de.lineNumbersMinChars=68]="lineNumbersMinChars",de[de.linkedEditing=69]="linkedEditing",de[de.links=70]="links",de[de.matchBrackets=71]="matchBrackets",de[de.minimap=72]="minimap",de[de.mouseStyle=73]="mouseStyle",de[de.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",de[de.mouseWheelZoom=75]="mouseWheelZoom",de[de.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",de[de.multiCursorModifier=77]="multiCursorModifier",de[de.multiCursorPaste=78]="multiCursorPaste",de[de.multiCursorLimit=79]="multiCursorLimit",de[de.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",de[de.occurrencesHighlight=81]="occurrencesHighlight",de[de.overviewRulerBorder=82]="overviewRulerBorder",de[de.overviewRulerLanes=83]="overviewRulerLanes",de[de.padding=84]="padding",de[de.pasteAs=85]="pasteAs",de[de.parameterHints=86]="parameterHints",de[de.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",de[de.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",de[de.quickSuggestions=89]="quickSuggestions",de[de.quickSuggestionsDelay=90]="quickSuggestionsDelay",de[de.readOnly=91]="readOnly",de[de.readOnlyMessage=92]="readOnlyMessage",de[de.renameOnType=93]="renameOnType",de[de.renderControlCharacters=94]="renderControlCharacters",de[de.renderFinalNewline=95]="renderFinalNewline",de[de.renderLineHighlight=96]="renderLineHighlight",de[de.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",de[de.renderValidationDecorations=98]="renderValidationDecorations",de[de.renderWhitespace=99]="renderWhitespace",de[de.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",de[de.roundedSelection=101]="roundedSelection",de[de.rulers=102]="rulers",de[de.scrollbar=103]="scrollbar",de[de.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",de[de.scrollBeyondLastLine=105]="scrollBeyondLastLine",de[de.scrollPredominantAxis=106]="scrollPredominantAxis",de[de.selectionClipboard=107]="selectionClipboard",de[de.selectionHighlight=108]="selectionHighlight",de[de.selectOnLineNumbers=109]="selectOnLineNumbers",de[de.showFoldingControls=110]="showFoldingControls",de[de.showUnused=111]="showUnused",de[de.snippetSuggestions=112]="snippetSuggestions",de[de.smartSelect=113]="smartSelect",de[de.smoothScrolling=114]="smoothScrolling",de[de.stickyScroll=115]="stickyScroll",de[de.stickyTabStops=116]="stickyTabStops",de[de.stopRenderingLineAfter=117]="stopRenderingLineAfter",de[de.suggest=118]="suggest",de[de.suggestFontSize=119]="suggestFontSize",de[de.suggestLineHeight=120]="suggestLineHeight",de[de.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",de[de.suggestSelection=122]="suggestSelection",de[de.tabCompletion=123]="tabCompletion",de[de.tabIndex=124]="tabIndex",de[de.unicodeHighlighting=125]="unicodeHighlighting",de[de.unusualLineTerminators=126]="unusualLineTerminators",de[de.useShadowDOM=127]="useShadowDOM",de[de.useTabStops=128]="useTabStops",de[de.wordBreak=129]="wordBreak",de[de.wordSeparators=130]="wordSeparators",de[de.wordWrap=131]="wordWrap",de[de.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",de[de.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",de[de.wordWrapColumn=134]="wordWrapColumn",de[de.wordWrapOverride1=135]="wordWrapOverride1",de[de.wordWrapOverride2=136]="wordWrapOverride2",de[de.wrappingIndent=137]="wrappingIndent",de[de.wrappingStrategy=138]="wrappingStrategy",de[de.showDeprecated=139]="showDeprecated",de[de.inlayHints=140]="inlayHints",de[de.editorClassName=141]="editorClassName",de[de.pixelRatio=142]="pixelRatio",de[de.tabFocusMode=143]="tabFocusMode",de[de.layoutInfo=144]="layoutInfo",de[de.wrappingInfo=145]="wrappingInfo",de[de.defaultColorDecorators=146]="defaultColorDecorators",de[de.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",de[de.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(197,null)})),acceptSuggestionOnEnter:Re(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(198,null),""],markdownDescription:g.localize(199,null)})),accessibilitySupport:Re(new l),accessibilityPageSize:Re(new c(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(200,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",g.localize(201,null))),ariaRequired:Re(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Re(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(203,null),g.localize(204,null),""],description:g.localize(205,null)})),autoClosingComments:Re(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(206,null),g.localize(207,null),""],description:g.localize(208,null)})),autoClosingDelete:Re(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(209,null),""],description:g.localize(210,null)})),autoClosingOvertype:Re(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(211,null),""],description:g.localize(212,null)})),autoClosingQuotes:Re(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(213,null),g.localize(214,null),""],description:g.localize(215,null)})),autoIndent:Re(new n(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[g.localize(216,null),g.localize(217,null),g.localize(218,null),g.localize(219,null),g.localize(220,null)],description:g.localize(221,null)})),automaticLayout:Re(new o(13,"automaticLayout",!1)),autoSurround:Re(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(222,null),g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),bracketPairColorization:Re(new oe),bracketPairGuides:Re(new Y),stickyTabStops:Re(new o(116,"stickyTabStops",!1,{description:g.localize(226,null)})),codeLens:Re(new o(17,"codeLens",!0,{description:g.localize(227,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:g.localize(228,null)})),codeLensFontSize:Re(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(229,null)})),colorDecorators:Re(new o(20,"colorDecorators",!0,{description:g.localize(230,null)})),colorDecoratorActivatedOn:Re(new s(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(231,null),g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),colorDecoratorsLimit:Re(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(235,null)})),columnSelection:Re(new o(22,"columnSelection",!1,{description:g.localize(236,null)})),comments:Re(new k),contextmenu:Re(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new o(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(237,null)})),cursorBlinking:Re(new n(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:g.localize(238,null)})),cursorSmoothCaretAnimation:Re(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(239,null),g.localize(240,null),g.localize(241,null)],description:g.localize(242,null)})),cursorStyle:Re(new n(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:g.localize(243,null)})),cursorSurroundingLines:Re(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(244,null)})),cursorSurroundingLinesStyle:Re(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(245,null),g.localize(246,null)],markdownDescription:g.localize(247,null)})),cursorWidth:Re(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(248,null)})),disableLayerHinting:Re(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new o(34,"domReadOnly",!1)),dragAndDrop:Re(new o(35,"dragAndDrop",!0,{description:g.localize(249,null)})),emptySelectionClipboard:Re(new L),dropIntoEditor:Re(new it),stickyScroll:Re(new ce),experimentalWhitespaceRendering:Re(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new a(40,"fastScrollSensitivity",5,de=>de<=0?5:de,{markdownDescription:g.localize(254,null)})),find:Re(new F),fixedOverflowWidgets:Re(new o(42,"fixedOverflowWidgets",!1)),folding:Re(new o(43,"folding",!0,{description:g.localize(255,null)})),foldingStrategy:Re(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),foldingHighlight:Re(new o(45,"foldingHighlight",!0,{description:g.localize(259,null)})),foldingImportsByDefault:Re(new o(46,"foldingImportsByDefault",!1,{description:g.localize(260,null)})),foldingMaximumRegions:Re(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(261,null)})),unfoldOnClickAfterEndOfLine:Re(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(262,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(263,null)})),fontInfo:Re(new N),fontLigatures2:Re(new x),fontSize:Re(new z),fontWeight:Re(new V),fontVariations:Re(new U),formatOnPaste:Re(new o(55,"formatOnPaste",!1,{description:g.localize(264,null)})),formatOnType:Re(new o(56,"formatOnType",!1,{description:g.localize(265,null)})),glyphMargin:Re(new o(57,"glyphMargin",!0,{description:g.localize(266,null)})),gotoLocation:Re(new ge),hideCursorInOverviewRuler:Re(new o(59,"hideCursorInOverviewRuler",!1,{description:g.localize(267,null)})),hover:Re(new te),inDiffEditor:Re(new o(61,"inDiffEditor",!1)),letterSpacing:Re(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,de=>a.clamp(de,-5,20),{description:g.localize(268,null)})),lightbulb:Re(new ie),lineDecorationsWidth:Re(new j),lineHeight:Re(new $),lineNumbers:Re(new fe),lineNumbersMinChars:Re(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new o(69,"linkedEditing",!1,{description:g.localize(269,null)})),links:Re(new o(70,"links",!0,{description:g.localize(270,null)})),matchBrackets:Re(new s(71,"matchBrackets","always",["always","near","never"],{description:g.localize(271,null)})),minimap:Re(new X),mouseStyle:Re(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new a(74,"mouseWheelScrollSensitivity",1,de=>de===0?1:de,{markdownDescription:g.localize(272,null)})),mouseWheelZoom:Re(new o(75,"mouseWheelZoom",!1,{markdownDescription:g.localize(273,null)})),multiCursorMergeOverlapping:Re(new o(76,"multiCursorMergeOverlapping",!0,{description:g.localize(274,null)})),multiCursorModifier:Re(new n(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[g.localize(275,null),g.localize(276,null)],markdownDescription:g.localize(277,null)})),multiCursorPaste:Re(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(278,null),g.localize(279,null)],markdownDescription:g.localize(280,null)})),multiCursorLimit:Re(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(281,null)})),occurrencesHighlight:Re(new o(81,"occurrencesHighlight",!0,{description:g.localize(282,null)})),multiDocumentOccurrencesHighlight:Re(new o(80,"multiDocumentOccurrencesHighlight",!1,{description:g.localize(283,null)})),overviewRulerBorder:Re(new o(82,"overviewRulerBorder",!0,{description:g.localize(284,null)})),overviewRulerLanes:Re(new c(83,"overviewRulerLanes",3,0,3)),padding:Re(new Q),pasteAs:Re(new tt),parameterHints:Re(new Z),peekWidgetDefaultFocus:Re(new s(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(285,null),g.localize(286,null)],description:g.localize(287,null)})),definitionLinkOpensInPeek:Re(new o(88,"definitionLinkOpensInPeek",!1,{description:g.localize(288,null)})),quickSuggestions:Re(new be),quickSuggestionsDelay:Re(new c(90,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(289,null)})),readOnly:Re(new o(91,"readOnly",!1)),readOnlyMessage:Re(new ve),renameOnType:Re(new o(93,"renameOnType",!1,{description:g.localize(290,null),markdownDeprecationMessage:g.localize(291,null)})),renderControlCharacters:Re(new o(94,"renderControlCharacters",!0,{description:g.localize(292,null),restricted:!0})),renderFinalNewline:Re(new s(95,"renderFinalNewline",f.isLinux?"dimmed":"on",["off","on","dimmed"],{description:g.localize(293,null)})),renderLineHighlight:Re(new s(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(294,null)],description:g.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Re(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(296,null)})),renderValidationDecorations:Re(new s(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new s(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(297,null),g.localize(298,null),g.localize(299,null),""],description:g.localize(300,null)})),revealHorizontalRightPadding:Re(new c(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new o(101,"roundedSelection",!0,{description:g.localize(301,null)})),rulers:Re(new he),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new c(104,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(302,null)})),scrollBeyondLastLine:Re(new o(105,"scrollBeyondLastLine",!0,{description:g.localize(303,null)})),scrollPredominantAxis:Re(new o(106,"scrollPredominantAxis",!0,{description:g.localize(304,null)})),selectionClipboard:Re(new o(107,"selectionClipboard",!0,{description:g.localize(305,null),included:f.isLinux})),selectionHighlight:Re(new o(108,"selectionHighlight",!0,{description:g.localize(306,null)})),selectOnLineNumbers:Re(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Re(new s(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(307,null),g.localize(308,null),g.localize(309,null)],description:g.localize(310,null)})),showUnused:Re(new o(111,"showUnused",!0,{description:g.localize(311,null)})),showDeprecated:Re(new o(139,"showDeprecated",!0,{description:g.localize(312,null)})),inlayHints:Re(new Se),snippetSuggestions:Re(new s(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(313,null),g.localize(314,null),g.localize(315,null),g.localize(316,null)],description:g.localize(317,null)})),smartSelect:Re(new xe),smoothScrolling:Re(new o(114,"smoothScrolling",!1,{description:g.localize(318,null)})),stopRenderingLineAfter:Re(new c(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new ye),inlineSuggest:Re(new se),inlineCompletionsAccessibilityVerbose:Re(new o(148,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(319,null)})),suggestFontSize:Re(new c(119,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new c(120,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new o(121,"suggestOnTriggerCharacters",!0,{description:g.localize(322,null)})),suggestSelection:Re(new s(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(323,null),g.localize(324,null),g.localize(325,null)],description:g.localize(326,null)})),tabCompletion:Re(new s(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(327,null),g.localize(328,null),g.localize(329,null)],description:g.localize(330,null)})),tabIndex:Re(new c(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new G),unusualLineTerminators:Re(new s(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(331,null),g.localize(332,null),g.localize(333,null)],description:g.localize(334,null)})),useShadowDOM:Re(new o(127,"useShadowDOM",!0)),useTabStops:Re(new o(128,"useTabStops",!0,{description:g.localize(335,null)})),wordBreak:Re(new s(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(336,null),g.localize(337,null)],description:g.localize(338,null)})),wordSeparators:Re(new t(130,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:g.localize(339,null)})),wordWrap:Re(new s(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(340,null),g.localize(341,null),g.localize(342,null),g.localize(343,null)],description:g.localize(344,null)})),wordWrapBreakAfterCharacters:Re(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new c(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(345,null)})),wordWrapOverride1:Re(new s(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new s(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new M),defaultColorDecorators:Re(new o(146,"defaultColorDecorators",!1,{markdownDescription:g.localize(346,null)})),pixelRatio:Re(new J),tabFocusMode:Re(new o(143,"tabFocusMode",!1,{markdownDescription:g.localize(347,null)})),layoutInfo:Re(new K),wrappingInfo:Re(new Xe),wrappingIndent:Re(new Ze),wrappingStrategy:Re(new ue)}}),define(De[187],Ie([10,11]),function(pe,e){return pe.create("vs/editor/common/languages",e)}),define(De[83],Ie([1,0,79,2,164,32,174,187]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.getAriaLabelForSymbol=e.symbolKindNames=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(x,U,N){this.offset=x,this.type=U,this.language=N,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class v{constructor(x,U){this.tokens=x,this.endState=U,this._tokenizationResultBrand=void 0}}e.TokenizationResult=v;class R{constructor(x,U){this.tokens=x,this.endState=U,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=R;var P;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var E;(function(F){const x=new Map;x.set(0,I.Codicon.symbolMethod),x.set(1,I.Codicon.symbolFunction),x.set(2,I.Codicon.symbolConstructor),x.set(3,I.Codicon.symbolField),x.set(4,I.Codicon.symbolVariable),x.set(5,I.Codicon.symbolClass),x.set(6,I.Codicon.symbolStruct),x.set(7,I.Codicon.symbolInterface),x.set(8,I.Codicon.symbolModule),x.set(9,I.Codicon.symbolProperty),x.set(10,I.Codicon.symbolEvent),x.set(11,I.Codicon.symbolOperator),x.set(12,I.Codicon.symbolUnit),x.set(13,I.Codicon.symbolValue),x.set(15,I.Codicon.symbolEnum),x.set(14,I.Codicon.symbolConstant),x.set(15,I.Codicon.symbolEnum),x.set(16,I.Codicon.symbolEnumMember),x.set(17,I.Codicon.symbolKeyword),x.set(27,I.Codicon.symbolSnippet),x.set(18,I.Codicon.symbolText),x.set(19,I.Codicon.symbolColor),x.set(20,I.Codicon.symbolFile),x.set(21,I.Codicon.symbolReference),x.set(22,I.Codicon.symbolCustomColor),x.set(23,I.Codicon.symbolFolder),x.set(24,I.Codicon.symbolTypeParameter),x.set(25,I.Codicon.account),x.set(26,I.Codicon.issues);function U(V){let ge=x.get(V);return ge||(console.info("No codicon found for CompletionItemKind "+V),ge=I.Codicon.symbolProperty),ge}F.toIcon=U;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function z(V,ge){let te=N.get(V);return typeof te>"u"&&!ge&&(te=9),te}F.fromString=z})(E||(e.CompletionItemKinds=E={}));var S;(function(F){F[F.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var _;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(_||(e.CompletionItemInsertTextRule=_={}));var w;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var d;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(d||(e.InlineCompletionTriggerKind=d={}));class o{constructor(x,U,N,z){this.range=x,this.text=U,this.completionKind=N,this.isSnippetText=z}equals(x){return A.Range.lift(this.range).equalsRange(x.range)&&this.text===x.text&&this.completionKind===x.completionKind&&this.isSnippetText===x.isSnippetText}}e.SelectedSuggestionInfo=o;var u;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(u||(e.CodeActionTriggerType=u={}));var c;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var h;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(h||(e.DocumentHighlightKind=h={}));function a(F){return F&&O.URI.isUri(F.uri)&&A.Range.isIRange(F.range)&&(A.Range.isIRange(F.originSelectionRange)||A.Range.isIRange(F.targetSelectionRange))}e.isLocationLink=a;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.symbolKindNames={[17]:(0,g.localize)(0,null),[16]:(0,g.localize)(1,null),[4]:(0,g.localize)(2,null),[13]:(0,g.localize)(3,null),[8]:(0,g.localize)(4,null),[9]:(0,g.localize)(5,null),[21]:(0,g.localize)(6,null),[23]:(0,g.localize)(7,null),[7]:(0,g.localize)(8,null),[0]:(0,g.localize)(9,null),[11]:(0,g.localize)(10,null),[10]:(0,g.localize)(11,null),[19]:(0,g.localize)(12,null),[5]:(0,g.localize)(13,null),[1]:(0,g.localize)(14,null),[2]:(0,g.localize)(15,null),[20]:(0,g.localize)(16,null),[15]:(0,g.localize)(17,null),[18]:(0,g.localize)(18,null),[24]:(0,g.localize)(19,null),[3]:(0,g.localize)(20,null),[6]:(0,g.localize)(21,null),[14]:(0,g.localize)(22,null),[22]:(0,g.localize)(23,null),[25]:(0,g.localize)(24,null),[12]:(0,g.localize)(25,null)};function i(F,x){return(0,g.localize)(26,null,F,e.symbolKindNames[x])}e.getAriaLabelForSymbol=i;var s;(function(F){F[F.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var n;(function(F){const x=new Map;x.set(0,I.Codicon.symbolFile),x.set(1,I.Codicon.symbolModule),x.set(2,I.Codicon.symbolNamespace),x.set(3,I.Codicon.symbolPackage),x.set(4,I.Codicon.symbolClass),x.set(5,I.Codicon.symbolMethod),x.set(6,I.Codicon.symbolProperty),x.set(7,I.Codicon.symbolField),x.set(8,I.Codicon.symbolConstructor),x.set(9,I.Codicon.symbolEnum),x.set(10,I.Codicon.symbolInterface),x.set(11,I.Codicon.symbolFunction),x.set(12,I.Codicon.symbolVariable),x.set(13,I.Codicon.symbolConstant),x.set(14,I.Codicon.symbolString),x.set(15,I.Codicon.symbolNumber),x.set(16,I.Codicon.symbolBoolean),x.set(17,I.Codicon.symbolArray),x.set(18,I.Codicon.symbolObject),x.set(19,I.Codicon.symbolKey),x.set(20,I.Codicon.symbolNull),x.set(21,I.Codicon.symbolEnumMember),x.set(22,I.Codicon.symbolStruct),x.set(23,I.Codicon.symbolEvent),x.set(24,I.Codicon.symbolOperator),x.set(25,I.Codicon.symbolTypeParameter);function U(N){let z=x.get(N);return z||(console.info("No codicon found for SymbolKind "+N),z=I.Codicon.symbolProperty),z}F.toIcon=U})(n||(e.SymbolKinds=n={}));class r{static asEditOperation(x){return f.EditOperation.replace(A.Range.lift(x.range),x.text)}}e.TextEdit=r;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(x){switch(x){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(x)}constructor(x){this.value=x}}e.FoldingRangeKind=l;var k;(function(F){function x(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}F.is=x})(k||(e.Command=k={}));var C;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var p;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(p||(e.CommentThreadState=p={}));var m;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(m||(e.CommentMode=m={}));var b;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(b||(e.CommentState=b={}));var D;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(D||(e.InlayHintKind=D={}));class M{constructor(x){this.createSupport=x,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(x=>{x&&x.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=M,e.TokenizationRegistry=new T.TokenizationRegistry;var L;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(L||(e.ExternalUriOpenerPriority=L={}))}),define(De[188],Ie([10,11]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ie([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ie([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ie([10,11]),function(pe,e){return pe.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ie([10,11]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ie([10,11]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ie([10,11]),function(pe,e){return pe.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ie([10,11]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(De[196],Ie([10,11]),function(pe,e){return pe.create("vs/platform/files/common/io",e)}),define(De[197],Ie([10,11]),function(pe,e){return pe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ie([10,11]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(De[199],Ie([10,11]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ie([10,11]),function(pe,e){return pe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ie([10,11]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(De[204],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[205],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[206],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[207],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(De[208],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[209],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(De[210],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[211],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[212],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[213],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[214],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[215],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[216],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[217],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(De[218],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(De[219],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[220],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[221],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[222],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[223],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[224],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[225],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[226],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[227],Ie([10,11]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[228],Ie([1,0,9,190]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var f;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(f||(e.TokenType=f={}));function A(...v){switch(v.length){case 1:return(0,O.localize)(0,null,v[0]);case 2:return(0,O.localize)(1,null,v[0],v[1]);case 3:return(0,O.localize)(2,null,v[0],v[1],v[2]);default:return}}const T=(0,O.localize)(3,null),g=(0,O.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const P=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:P})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const P=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:P})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const P=this._start,E=this._input.substring(this._start,this._current),S={type:19,offset:this._start,lexeme:E};this._errors.push({offset:P,lexeme:E,additionalInfo:R}),this._tokens.push(S)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const P=this._input.substring(this._start,this._current),E=y._keywords.get(P);E?this._addToken(E):this._tokens.push({type:17,lexeme:P,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,P=!1,E=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(g);return}const _=this._input.charCodeAt(R);if(P)P=!1;else if(_===47&&!E){R++;break}else _===91?E=!0:_===92?P=!0:_===93&&(E=!1);R++}for(;R<this._input.length&&y._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const S=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(De[229],Ie([1,0,23,38,193,375]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function y(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=y;function v(o){if(!y(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=o.match(T);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=v;function R(o){if(!o)return null;const u=o.majorBase,c=o.majorMustEqual,h=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let i=o.patchMustEqual;o.hasCaret&&(u===0||(a=!1),i=!1);let s=0;if(o.preRelease){const n=g.exec(o.preRelease);if(n){const[,r,l,k]=n;s=Date.UTC(Number(r),Number(l)-1,Number(k))}}return{majorBase:u,majorMustEqual:c,minorBase:h,minorMustEqual:a,patchBase:t,patchMustEqual:i,isMinimum:o.hasGreaterEquals,notBefore:s}}e.normalizeVersion=R;function P(o,u,c){let h;typeof o=="string"?h=R(v(o)):h=o;let a;u instanceof Date?a=u.getTime():typeof u=="string"&&(a=new Date(u).getTime());let t;if(typeof c=="string"?t=R(v(c)):t=c,!h||!t)return!1;const i=h.majorBase,s=h.minorBase,n=h.patchBase;let r=t.majorBase,l=t.minorBase,k=t.patchBase;const C=t.notBefore;let p=t.majorMustEqual,m=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?i>r?!0:i<r?!1:s>l?!0:s<l||a&&a<C?!1:n>=k:(i===1&&r===0&&(!p||!m||!b)&&(r=1,l=0,k=0,p=!0,m=!1,b=!1),i<r?!1:i>r?!p:s<l?!1:s>l?!m:n<k?!1:n>k?!b:!(a&&a<C))}e.isValidVersion=P;function E(o,u,c,h,a){const t=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return t.push([O.default.Error,f.localize(0,null)]),t;if(typeof h.name!="string")return t.push([O.default.Error,f.localize(1,null,"name")]),t;if(typeof h.version!="string")return t.push([O.default.Error,f.localize(2,null,"version")]),t;if(!h.engines)return t.push([O.default.Error,f.localize(3,null,"engines")]),t;if(typeof h.engines.vscode!="string")return t.push([O.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof h.extensionDependencies<"u"&&!d(h.extensionDependencies))return t.push([O.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof h.activationEvents<"u"){if(!d(h.activationEvents))return t.push([O.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof h.main>"u"&&typeof h.browser>"u")return t.push([O.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&t.push([O.default.Warning,f.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return t.push([O.default.Error,f.localize(9,null,"main")]),t;{const n=(0,I.joinPath)(c,h.main);(0,I.isEqualOrParent)(n,c)||t.push([O.default.Warning,f.localize(10,null,n.path,c.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return t.push([O.default.Error,f.localize(11,null,"browser")]),t;{const n=(0,I.joinPath)(c,h.browser);(0,I.isEqualOrParent)(n,c)||t.push([O.default.Warning,f.localize(12,null,n.path,c.path)])}}if(!A.valid(h.version))return t.push([O.default.Error,f.localize(13,null)]),t;const i=[];if(!S(o,u,h,a,i))for(const n of i)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=E;function S(o,u,c,h,a){return h||typeof c.main>"u"&&typeof c.browser>"u"?!0:w(o,u,c.engines.vscode,a)}e.isValidExtensionVersion=S;function _(o,u,c){return o==="*"||w(u,c,o)}e.isEngineValid=_;function w(o,u,c,h=[]){const a=R(v(c));if(!a)return h.push(f.localize(14,null,c)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return h.push(f.localize(15,null,c)),!1}else if(!a.majorMustEqual)return h.push(f.localize(16,null,c)),!1;return P(o,u,a)?!0:(h.push(f.localize(17,null,o,c)),!1)}function d(o){if(!Array.isArray(o))return!1;for(let u=0,c=o.length;u<c;u++)if(typeof o[u]!="string")return!1;return!0}}),define(De[102],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(f,A=[],T=!1){this.ctor=f,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=I}),define(De[103],Ie([1,0,102]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var f;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function A(g,y,v){y instanceof I.SyncDescriptor||(y=new I.SyncDescriptor(y,[],!!v)),O.push([g,y])}e.registerSingleton=A;function T(){return O}e.getSingletonServiceDescriptors=T}),define(De[230],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const g=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(T);g.outgoing.set(y.key,y),y.incoming.set(g.key,g)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const g of this._nodes.values())g.outgoing.delete(T),g.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let g=this._nodes.get(T);return g||(g=new I(T,A),this._nodes.set(T,g)),g}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,g]of this._nodes)A.push(`${T}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const g=new Set([A]),y=this._findCycle(T,g);if(y)return y}}_findCycle(A,T){for(const[g,y]of A.outgoing){if(T.has(g))return[...T,g].join(" -> ");T.add(g);const v=this._findCycle(y,T);if(v)return v;T.delete(g)}}}e.Graph=O}),define(De[5],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function g(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=g})(I||(e._util=I={})),e.IInstantiationService=f("instantiationService");function O(T,g,y){g[I.DI_TARGET]===g?g[I.DI_DEPENDENCIES].push({id:T,index:y}):(g[I.DI_DEPENDENCIES]=[{id:T,index:y}],g[I.DI_TARGET]=g)}function f(T){if(I.serviceIds.has(T))return I.serviceIds.get(T);const g=function(y,v,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(g,y,R)};return g.toString=()=>T,I.serviceIds.set(T,g),g}e.createDecorator=f;function A(T){return T}e.refineServiceDecorator=A}),define(De[50],Ie([1,0,17,2,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,f.createDecorator)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}e.isConfigurationOverrides=A;function T(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var g;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function y(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function v(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.isConfigured=v;function R(o,u){const c=Object.create(null);for(const h in o)P(c,h,o[h],u);return c}e.toValuesTree=R;function P(o,u,c,h){const a=u.split("."),t=a.pop();let i=o;for(let s=0;s<a.length;s++){const n=a[s];let r=i[n];switch(typeof r){case"undefined":r=i[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${u} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}i=r}if(typeof i=="object"&&i!==null)try{i[t]=c}catch{h(`Ignoring ${u} as ${a.join(".")} is ${JSON.stringify(i)}`)}else h(`Ignoring ${u} as ${a.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=P;function E(o,u){const c=u.split(".");S(o,c)}e.removeFromValueTree=E;function S(o,u){const c=u.shift();if(u.length===0){delete o[c];return}if(Object.keys(o).indexOf(c)!==-1){const h=o[c];typeof h=="object"&&!Array.isArray(h)&&(S(h,u),Object.keys(h).length===0&&delete o[c])}}function _(o,u,c){function h(i,s){let n=i;for(const r of s){if(typeof n!="object"||n===null)return;n=n[r]}return n}const a=u.split("."),t=h(o,a);return typeof t>"u"?c:t}e.getConfigurationValue=_;function w(o,u,c){Object.keys(u).forEach(h=>{h!=="__proto__"&&(h in o?I.isObject(o[h])&&I.isObject(u[h])?w(o[h],u[h],c):c&&(o[h]=u[h]):o[h]=u[h])})}e.merge=w;function d(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(De[42],Ie([1,0,12,15,228,5,189,9]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",I.isMacintosh),y.set("isLinux",I.isLinux),y.set("isWindows",I.isWindows),y.set("isWeb",I.isWeb),y.set("isMacNative",I.isMacintosh&&!I.isWeb),y.set("isEdge",I.isEdge),y.set("isFirefox",I.isFirefox),y.set("isChrome",I.isChrome),y.set("isSafari",I.isSafari);function v(j,$){if(y.get(j)!==void 0)throw(0,g.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(j,$)}e.setConstant=v;const R=Object.prototype.hasOwnProperty;var P;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const E={regexParsingWithErrorRecovery:!0},S=(0,T.localize)(0,null),_=(0,T.localize)(1,null),w=(0,T.localize)(2,null),d=(0,T.localize)(3,null),o=(0,T.localize)(4,null),u=(0,T.localize)(5,null),c=(0,T.localize)(6,null),h=(0,T.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor($=E){this._config=$,this._scanner=new f.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse($){if($===""){this._parsingErrors.push({message:S,offset:0,lexeme:"",additionalInfo:_});return}this._tokens=this._scanner.reset($).scan(),this._current=0,this._parsingErrors=[];try{const X=this._expr();if(!this._isAtEnd()){const re=this._peek(),Q=re.type===17?u:void 0;throw this._parsingErrors.push({message:o,offset:re.offset,lexeme:f.Scanner.getLexeme(re),additionalInfo:Q}),a._parseError}return X}catch(X){if(X!==a._parseError)throw X;return}}_expr(){return this._or()}_or(){const $=[this._and()];for(;this._matchOne(16);){const X=this._and();$.push(X)}return $.length===1?$[0]:t.or(...$)}_and(){const $=[this._term()];for(;this._matchOne(15);){const X=this._term();$.push(X)}return $.length===1?$[0]:t.and(...$)}_term(){if(this._matchOne(2)){const $=this._peek();switch($.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),l.INSTANCE;case 0:{this._advance();const X=this._expr();return this._consume(1,d),X?.negate()}case 17:return this._advance(),D.create($.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",$)}}return this._primary()}_primary(){const $=this._peek();switch($.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const X=this._expr();return this._consume(1,d),X}case 17:{const X=$.lexeme;if(this._advance(),this._matchOne(9)){const Q=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Q.type!==10)throw this._errExpectedButGot("REGEX",Q);const Z=Q.lexeme,J=Z.lastIndexOf("/"),be=J===Z.length-1?void 0:this._removeFlagsGY(Z.substring(J+1));let ae;try{ae=new RegExp(Z.substring(1,J),be)}catch{throw this._errExpectedButGot("REGEX",Q)}return N.create(X,ae)}switch(Q.type){case 10:case 19:{const Z=[Q.lexeme];this._advance();let J=this._peek(),be=0;for(let ve=0;ve<Q.lexeme.length;ve++)Q.lexeme.charCodeAt(ve)===40?be++:Q.lexeme.charCodeAt(ve)===41&&be--;for(;!this._isAtEnd()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:be++;break;case 1:be--;break;case 10:case 18:for(let ve=0;ve<J.lexeme.length;ve++)J.lexeme.charCodeAt(ve)===40?be++:Q.lexeme.charCodeAt(ve)===41&&be--}if(be<0)break;Z.push(f.Scanner.getLexeme(J)),this._advance(),J=this._peek()}const ae=Z.join(""),fe=ae.lastIndexOf("/"),ee=fe===ae.length-1?void 0:this._removeFlagsGY(ae.substring(fe+1));let he;try{he=new RegExp(ae.substring(1,fe),ee)}catch{throw this._errExpectedButGot("REGEX",Q)}return t.regex(X,he)}case 18:{const Z=Q.lexeme;this._advance();let J=null;if(!(0,O.isFalsyOrWhitespace)(Z)){const be=Z.indexOf("/"),ae=Z.lastIndexOf("/");if(be!==ae&&be>=0){const fe=Z.slice(be+1,ae),ee=Z[ae+1]==="i"?"i":"";try{J=new RegExp(fe,ee)}catch{throw this._errExpectedButGot("REGEX",Q)}}}if(J===null)throw this._errExpectedButGot("REGEX",Q);return N.create(X,J)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,w);const Q=this._value();return t.notIn(X,Q)}switch(this._peek().type){case 3:{this._advance();const Q=this._value();if(this._previous().type===18)return t.equals(X,Q);switch(Q){case"true":return t.has(X);case"false":return t.not(X);default:return t.equals(X,Q)}}case 4:{this._advance();const Q=this._value();if(this._previous().type===18)return t.notEquals(X,Q);switch(Q){case"true":return t.not(X);case"false":return t.has(X);default:return t.notEquals(X,Q)}}case 5:return this._advance(),x.create(X,this._value());case 6:return this._advance(),U.create(X,this._value());case 7:return this._advance(),L.create(X,this._value());case 8:return this._advance(),F.create(X,this._value());case 13:return this._advance(),t.in(X,this._value());default:return t.has(X)}}case 20:throw this._parsingErrors.push({message:c,offset:$.offset,lexeme:"",additionalInfo:h}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const $=this._peek();switch($.type){case 17:case 18:return this._advance(),$.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY($){return $.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne($){return this._check($)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume($,X){if(this._check($))return this._advance();throw this._errExpectedButGot(X,this._peek())}_errExpectedButGot($,X,re){const Q=(0,T.localize)(8,null,$,f.Scanner.getLexeme(X)),Z=X.offset,J=f.Scanner.getLexeme(X);return this._parsingErrors.push({message:Q,offset:Z,lexeme:J,additionalInfo:re}),a._parseError}_check($){return this._peek().type===$}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=a;class t{static false(){return r.INSTANCE}static true(){return l.INSTANCE}static has($){return k.create($)}static equals($,X){return C.create($,X)}static notEquals($,X){return b.create($,X)}static regex($,X){return N.create($,X)}static in($,X){return p.create($,X)}static notIn($,X){return m.create($,X)}static not($){return D.create($)}static and(...$){return ge.create($,null,!0)}static or(...$){return te.create($,null,!0)}static greater($,X){return L.create($,X)}static greaterEquals($,X){return F.create($,X)}static smaller($,X){return x.create($,X)}static smallerEquals($,X){return U.create($,X)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize($){return $==null?void 0:this._parser.parse($)}}e.ContextKeyExpr=t;function i(j){const $=new a({regexParsingWithErrorRecovery:!1});return j.map(X=>($.parse(X),$.lexingErrors.length>0?$.lexingErrors.map(re=>({errorMessage:re.additionalInfo?(0,T.localize)(9,null,re.additionalInfo):(0,T.localize)(10,null),offset:re.offset,length:re.lexeme.length})):$.parsingErrors.length>0?$.parsingErrors.map(re=>({errorMessage:re.additionalInfo?`${re.message}. ${re.additionalInfo}`:re.message,offset:re.offset,length:re.lexeme.length})):[]))}e.validateWhenClauses=i;function s(j,$){const X=j?j.substituteConstants():void 0,re=$?$.substituteConstants():void 0;return!X&&!re?!0:!X||!re?!1:X.equals(re)}e.expressionsAreEqualWithConstantSubstitution=s;function n(j,$){return j.cmp($)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp($){return this.type-$.type}equals($){return $.type===this.type}substituteConstants(){return this}evaluate($){return!1}serialize(){return"false"}keys(){return[]}map($){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=r;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp($){return this.type-$.type}equals($){return $.type===this.type}substituteConstants(){return this}evaluate($){return!0}serialize(){return"true"}keys(){return[]}map($){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=l;class k{static create($,X=null){const re=y.get($);return typeof re=="boolean"?re?l.INSTANCE:r.INSTANCE:new k($,X)}constructor($,X){this.key=$,this.negated=X,this.type=2}cmp($){return $.type!==this.type?this.type-$.type:K(this.key,$.key)}equals($){return $.type===this.type?this.key===$.key:!1}substituteConstants(){const $=y.get(this.key);return typeof $=="boolean"?$?l.INSTANCE:r.INSTANCE:this}evaluate($){return!!$.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map($){return $.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class C{static create($,X,re=null){if(typeof X=="boolean")return X?k.create($,re):D.create($,re);const Q=y.get($);return typeof Q=="boolean"?X===(Q?"true":"false")?l.INSTANCE:r.INSTANCE:new C($,X,re)}constructor($,X,re){this.key=$,this.value=X,this.negated=re,this.type=4}cmp($){return $.type!==this.type?this.type-$.type:ue(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){const $=y.get(this.key);if(typeof $=="boolean"){const X=$?"true":"false";return this.value===X?l.INSTANCE:r.INSTANCE}return this}evaluate($){return $.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map($){return $.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class p{static create($,X){return new p($,X)}constructor($,X){this.key=$,this.valueKey=X,this.type=10,this.negated=null}cmp($){return $.type!==this.type?this.type-$.type:ue(this.key,this.valueKey,$.key,$.valueKey)}equals($){return $.type===this.type?this.key===$.key&&this.valueKey===$.valueKey:!1}substituteConstants(){return this}evaluate($){const X=$.getValue(this.valueKey),re=$.getValue(this.key);return Array.isArray(X)?X.includes(re):typeof re=="string"&&typeof X=="object"&&X!==null?R.call(X,re):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map($){return $.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class m{static create($,X){return new m($,X)}constructor($,X){this.key=$,this.valueKey=X,this.type=11,this._negated=p.create($,X)}cmp($){return $.type!==this.type?this.type-$.type:this._negated.cmp($._negated)}equals($){return $.type===this.type?this._negated.equals($._negated):!1}substituteConstants(){return this}evaluate($){return!this._negated.evaluate($)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map($){return $.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=m;class b{static create($,X,re=null){if(typeof X=="boolean")return X?D.create($,re):k.create($,re);const Q=y.get($);return typeof Q=="boolean"?X===(Q?"true":"false")?r.INSTANCE:l.INSTANCE:new b($,X,re)}constructor($,X,re){this.key=$,this.value=X,this.negated=re,this.type=5}cmp($){return $.type!==this.type?this.type-$.type:ue(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){const $=y.get(this.key);if(typeof $=="boolean"){const X=$?"true":"false";return this.value===X?r.INSTANCE:l.INSTANCE}return this}evaluate($){return $.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map($){return $.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class D{static create($,X=null){const re=y.get($);return typeof re=="boolean"?re?r.INSTANCE:l.INSTANCE:new D($,X)}constructor($,X){this.key=$,this.negated=X,this.type=3}cmp($){return $.type!==this.type?this.type-$.type:K(this.key,$.key)}equals($){return $.type===this.type?this.key===$.key:!1}substituteConstants(){const $=y.get(this.key);return typeof $=="boolean"?$?r.INSTANCE:l.INSTANCE:this}evaluate($){return!$.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map($){return $.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function M(j,$){if(typeof j=="string"){const X=parseFloat(j);isNaN(X)||(j=X)}return typeof j=="string"||typeof j=="number"?$(j):r.INSTANCE}class L{static create($,X,re=null){return M(X,Q=>new L($,Q,re))}constructor($,X,re){this.key=$,this.value=X,this.negated=re,this.type=12}cmp($){return $.type!==this.type?this.type-$.type:ue(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map($){return $.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=L;class F{static create($,X,re=null){return M(X,Q=>new F($,Q,re))}constructor($,X,re){this.key=$,this.value=X,this.negated=re,this.type=13}cmp($){return $.type!==this.type?this.type-$.type:ue(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map($){return $.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=F;class x{static create($,X,re=null){return M(X,Q=>new x($,Q,re))}constructor($,X,re){this.key=$,this.value=X,this.negated=re,this.type=14}cmp($){return $.type!==this.type?this.type-$.type:ue(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map($){return $.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class U{static create($,X,re=null){return M(X,Q=>new U($,Q,re))}constructor($,X,re){this.key=$,this.value=X,this.negated=re,this.type=15}cmp($){return $.type!==this.type?this.type-$.type:ue(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map($){return $.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=U;class N{static create($,X){return new N($,X)}constructor($,X){this.key=$,this.regexp=X,this.type=7,this.negated=null}cmp($){if($.type!==this.type)return this.type-$.type;if(this.key<$.key)return-1;if(this.key>$.key)return 1;const X=this.regexp?this.regexp.source:"",re=$.regexp?$.regexp.source:"";return X<re?-1:X>re?1:0}equals($){if($.type===this.type){const X=this.regexp?this.regexp.source:"",re=$.regexp?$.regexp.source:"";return this.key===$.key&&X===re}return!1}substituteConstants(){return this}evaluate($){const X=$.getValue(this.key);return this.regexp?this.regexp.test(X):!1}serialize(){const $=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${$}`}keys(){return[this.key]}map($){return $.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=z.create(this)),this.negated}}e.ContextKeyRegexExpr=N;class z{static create($){return new z($)}constructor($){this._actual=$,this.type=8}cmp($){return $.type!==this.type?this.type-$.type:this._actual.cmp($._actual)}equals($){return $.type===this.type?this._actual.equals($._actual):!1}substituteConstants(){return this}evaluate($){return!this._actual.evaluate($)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map($){return new z(this._actual.map($))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=z;function V(j){let $=null;for(let X=0,re=j.length;X<re;X++){const Q=j[X].substituteConstants();if(j[X]!==Q&&$===null){$=[];for(let Z=0;Z<X;Z++)$[Z]=j[Z]}$!==null&&($[X]=Q)}return $===null?j:$}class ge{static create($,X,re){return ge._normalizeArr($,X,re)}constructor($,X){this.expr=$,this.negated=X,this.type=6}cmp($){if($.type!==this.type)return this.type-$.type;if(this.expr.length<$.expr.length)return-1;if(this.expr.length>$.expr.length)return 1;for(let X=0,re=this.expr.length;X<re;X++){const Q=n(this.expr[X],$.expr[X]);if(Q!==0)return Q}return 0}equals($){if($.type===this.type){if(this.expr.length!==$.expr.length)return!1;for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].equals($.expr[X]))return!1;return!0}return!1}substituteConstants(){const $=V(this.expr);return $===this.expr?this:ge.create($,this.negated,!1)}evaluate($){for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].evaluate($))return!1;return!0}static _normalizeArr($,X,re){const Q=[];let Z=!1;for(const J of $)if(J){if(J.type===1){Z=!0;continue}if(J.type===0)return r.INSTANCE;if(J.type===6){Q.push(...J.expr);continue}Q.push(J)}if(Q.length===0&&Z)return l.INSTANCE;if(Q.length!==0){if(Q.length===1)return Q[0];Q.sort(n);for(let J=1;J<Q.length;J++)Q[J-1].equals(Q[J])&&(Q.splice(J,1),J--);if(Q.length===1)return Q[0];for(;Q.length>1;){const J=Q[Q.length-1];if(J.type!==9)break;Q.pop();const be=Q.pop(),ae=Q.length===0,fe=te.create(J.expr.map(ee=>ge.create([ee,be],null,re)),null,ae);fe&&(Q.push(fe),Q.sort(n))}if(Q.length===1)return Q[0];if(re){for(let J=0;J<Q.length;J++)for(let be=J+1;be<Q.length;be++)if(Q[J].negate().equals(Q[be]))return r.INSTANCE;if(Q.length===1)return Q[0]}return new ge(Q,X)}}serialize(){return this.expr.map($=>$.serialize()).join(" && ")}keys(){const $=[];for(const X of this.expr)$.push(...X.keys());return $}map($){return new ge(this.expr.map(X=>X.map($)),null)}negate(){if(!this.negated){const $=[];for(const X of this.expr)$.push(X.negate());this.negated=te.create($,this,!0)}return this.negated}}e.ContextKeyAndExpr=ge;class te{static create($,X,re){return te._normalizeArr($,X,re)}constructor($,X){this.expr=$,this.negated=X,this.type=9}cmp($){if($.type!==this.type)return this.type-$.type;if(this.expr.length<$.expr.length)return-1;if(this.expr.length>$.expr.length)return 1;for(let X=0,re=this.expr.length;X<re;X++){const Q=n(this.expr[X],$.expr[X]);if(Q!==0)return Q}return 0}equals($){if($.type===this.type){if(this.expr.length!==$.expr.length)return!1;for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].equals($.expr[X]))return!1;return!0}return!1}substituteConstants(){const $=V(this.expr);return $===this.expr?this:te.create($,this.negated,!1)}evaluate($){for(let X=0,re=this.expr.length;X<re;X++)if(this.expr[X].evaluate($))return!0;return!1}static _normalizeArr($,X,re){let Q=[],Z=!1;if($){for(let J=0,be=$.length;J<be;J++){const ae=$[J];if(ae){if(ae.type===0){Z=!0;continue}if(ae.type===1)return l.INSTANCE;if(ae.type===9){Q=Q.concat(ae.expr);continue}Q.push(ae)}}if(Q.length===0&&Z)return r.INSTANCE;Q.sort(n)}if(Q.length!==0){if(Q.length===1)return Q[0];for(let J=1;J<Q.length;J++)Q[J-1].equals(Q[J])&&(Q.splice(J,1),J--);if(Q.length===1)return Q[0];if(re){for(let J=0;J<Q.length;J++)for(let be=J+1;be<Q.length;be++)if(Q[J].negate().equals(Q[be]))return l.INSTANCE;if(Q.length===1)return Q[0]}return new te(Q,X)}}serialize(){return this.expr.map($=>$.serialize()).join(" || ")}keys(){const $=[];for(const X of this.expr)$.push(...X.keys());return $}map($){return new te(this.expr.map(X=>X.map($)),null)}negate(){if(!this.negated){const $=[];for(const X of this.expr)$.push(X.negate());for(;$.length>1;){const X=$.shift(),re=$.shift(),Q=[];for(const Z of Se(X))for(const J of Se(re))Q.push(ge.create([Z,J],null,!1));$.unshift(te.create(Q,null,!1))}this.negated=te.create($,this,!0)}return this.negated}}e.ContextKeyOrExpr=te;class q extends k{static{this._info=[]}static all(){return q._info.values()}constructor($,X,re){super($,null),this._defaultValue=X,typeof re=="object"?q._info.push({...re,key:$}):re!==!0&&q._info.push({key:$,description:re,type:X!=null?typeof X:void 0})}bindTo($){return $.createKey(this.key,this._defaultValue)}getValue($){return $.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo($){return C.create(this.key,$)}notEqualsTo($){return b.create(this.key,$)}}e.RawContextKey=q,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function K(j,$){return j<$?-1:j>$?1:0}function ue(j,$,X,re){return j<X?-1:j>X?1:$<re?-1:$>re?1:0}function ie(j,$){if(j.type===0||$.type===1)return!0;if(j.type===9)return $.type===9?ce(j.expr,$.expr):!1;if($.type===9){for(const X of $.expr)if(ie(j,X))return!0;return!1}if(j.type===6){if($.type===6)return ce($.expr,j.expr);for(const X of j.expr)if(ie(X,$))return!0;return!1}return j.equals($)}e.implies=ie;function ce(j,$){let X=0,re=0;for(;X<j.length&&re<$.length;){const Q=j[X].cmp($[re]);if(Q<0)return!1;Q===0&&X++,re++}return X===j.length}function Se(j){return j.type===9?j.expr:[j]}}),define(De[231],Ie([1,0,23,38,191,5,99,12,24]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,A.createDecorator)("dialogService");var v;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(v||(v={}));class R{getConfirmationButtons(d){return this.getButtons(d,v.Confirmation)}getPromptButtons(d){return this.getButtons(d,v.Prompt)}getInputButtons(d){return this.getButtons(d,v.Input)}getButtons(d,o){const u=[];switch(o){case v.Confirmation:{const c=d;c.primaryButton?u.push(c.primaryButton):u.push((0,f.localize)(0,null)),c.cancelButton?u.push(c.cancelButton):u.push((0,f.localize)(1,null));break}case v.Prompt:{const c=d;Array.isArray(c.buttons)&&c.buttons.length>0&&u.push(...c.buttons.map(h=>h.label)),c.cancelButton&&(c.cancelButton===!0?u.push((0,f.localize)(2,null)):typeof c.cancelButton=="string"?u.push(c.cancelButton):c.cancelButton.label?u.push(c.cancelButton.label):u.push((0,f.localize)(3,null))),u.length===0&&u.push((0,f.localize)(4,null));break}case v.Input:{const c=d;c.primaryButton?u.push(c.primaryButton):u.push((0,f.localize)(5,null)),c.cancelButton?u.push(c.cancelButton):u.push((0,f.localize)(6,null));break}}return u}getDialogType(d){if(typeof d=="string")return d;if(typeof d=="number")return d===O.default.Info?"info":d===O.default.Error?"error":d===O.default.Warning?"warning":"none"}getPromptResult(d,o,u){const c=[...d.buttons??[]];d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&c.push(d.cancelButton);let h=c[o]?.run({checkboxChecked:u});return h instanceof Promise||(h=Promise.resolve(h)),{result:h,checkboxChecked:u}}}e.AbstractDialogHandler=R,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var P;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const E=10;function S(w){const d=[];return d.push(...w.slice(0,E).map(o=>typeof o=="string"?o:(0,I.basename)(o))),w.length>E&&(w.length-E===1?d.push((0,f.localize)(7,null)):d.push((0,f.localize)(8,null,w.length-E))),d.push(""),d.join(`
`)}e.getFileNamesMessage=S;function _(w,d){const o=(0,y.deepClone)(w);let u=(o.buttons??[]).map(t=>(0,T.mnemonicButtonLabel)(t)),c=(w.buttons||[]).map((t,i)=>i),h=0,a=o.cancelId??u.length-1;if(u.length>1){const t=typeof a=="number"?u[a]:void 0;if(g.isLinux||g.isMacintosh){if(typeof t=="string"&&u.length>1&&a!==1){u.splice(a,1),u.splice(1,0,t);const i=c[a];c.splice(a,1),c.splice(1,0,i),a=1}g.isLinux&&u.length>1&&(u=u.reverse(),c=c.reverse(),h=u.length-1,typeof t=="string"&&(a=h-1))}else if(g.isWindows&&typeof t=="string"&&u.length>1&&a!==u.length-1){u.splice(a,1),u.push(t);const i=c[a];c.splice(a,1),c.push(i),a=u.length-1}}return o.buttons=u,o.defaultId=h,o.cancelId=a,o.noLink=!0,o.title=o.title||d.nameLong,{options:o,buttonIndeces:c}}e.massageMessageBoxOptions=_}),define(De[131],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(De[132],Ie([1,0,192,5]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function f(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=f;function A(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(o,u){switch(o){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":u==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function g(o,u){return u==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function y(o,u,c){return g(u,c)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===c}e.isTargetPlatformCompatible=y;function v(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=v;var R;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var P;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var E;(function(o){o.Install="install",o.Uninstall="uninstall"})(E||(e.StatisticType=E={}));var S;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var _;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(_||(e.ExtensionManagementErrorCode=_={}));var w;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class d extends Error{constructor(u,c){super(u),this.code=c,this.name=c}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,I.localize)(1,null),original:"Preferences"}}),define(De[232],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(De[233],Ie([1,0,49,18,16,12,98,29,101,194,232]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=v.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends E{static{this.CMD="cmd.exe"}openTerminal(h,a){return this.spawnTerminal(I,h,y.getWindowsShell(),a)}spawnTerminal(h,a,t,i){const s=a.windowsExec||S.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const n=f.basename(s,".exe").toLowerCase();if(n==="cmder")return h.spawn(s,i?[i]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),n==="wt"&&r.push("-d ."),new Promise((l,k)=>{const C=d(process),p=h.spawn(t,r,{cwd:i,env:C});p.on("error",k),p.on("exit",()=>l())})}runInTerminal(h,a,t,i,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:S.getDefaultTerminalWindows();return new Promise((r,l)=>{const k=`"${a} - ${P}"`,C=`""${t.join('" "')}" & pause"`,p=Object.assign({},d(process),i);Object.keys(p).filter(L=>p[L]===null).forEach(L=>delete p[L]);const m={cwd:a,env:p,windowsVerbatimArguments:!0};let b,D;f.basename(n,".exe")==="wt"?(b=n,D=["-d",".",S.CMD,"/c",C]):(b=S.CMD,D=["/c","start",k,"/wait",n,"/c",C]),I.spawn(b,D,m).on("error",L=>{l(o(L))}),r(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=S;class _ extends E{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(h,a){return this.spawnTerminal(I,h,a)}runInTerminal(h,a,t,i,s){const n=s.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(n===R.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const k=n===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[O.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",h||P,"-w",a];for(const D of t)p.push("-a"),p.push(D);if(i){const D=Object.assign({},d(process),i);for(const M in D){const L=D[M];L===null?(p.push("-u"),p.push(M)):(p.push("-e"),p.push(`${M}=${L}`))}}let m="";const b=I.spawn(_.OSASCRIPT,p);b.on("error",D=>{l(o(D))}),b.stderr.on("data",D=>{m+=D.toString()}),b.on("exit",D=>{if(D===0)r(void 0);else if(m){const M=m.split(`
`,1);l(new Error(M[0]))}else l(new Error(v.localize(1,null,k,D)))})}else l(new Error(v.localize(2,null,n)))})}spawnTerminal(h,a,t){const i=a.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const r=["-a",i];t&&r.push(t);const l=d(process),k=h.spawn("/usr/bin/open",r,{cwd:t,env:l});k.on("error",n),k.on("exit",()=>s())})}}e.MacExternalTerminalService=_;class w extends E{static{this.WAIT_MESSAGE=v.localize(3,null)}openTerminal(h,a){return this.spawnTerminal(I,h,a)}runInTerminal(h,a,t,i,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{const k=[];n.then(C=>{C.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const p=`${u(t)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;k.push(`''${p}''`);const m=Object.assign({},d(process),i);Object.keys(m).filter(L=>m[L]===null).forEach(L=>delete m[L]);const b={cwd:a,env:m};let D="";const M=I.spawn(C,k,b);M.on("error",L=>{l(o(L))}),M.stderr.on("data",L=>{D+=L.toString()}),M.on("exit",L=>{if(L===0)r(void 0);else if(D){const F=D.split(`
`,1);l(new Error(F[0]))}else l(new Error(v.localize(4,null,C,L)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await g.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(a=>{h?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,a,t){const i=a.linuxExec?Promise.resolve(a.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{i.then(r=>{const l=d(process),k=h.spawn(r,[],{cwd:t,env:l});k.on("error",n),k.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=w;function d(c){const h={...c.env};return(0,T.sanitizeProcessEnvironment)(h),h}function o(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(v.localize(5,null,c.path)):c}function u(c){let h="";for(const a of c)a.indexOf(" ")>=0?h+='"'+a+'"':h+=a,h+=" ";return h}}),define(De[30],Ie([1,0,78,16,15,17,2,195,5,12,18,47]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function E(ie){return ie.create===!0}e.isFileOpenForWriteOptions=E;var S;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var _;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(_||(e.FilePermission=_={}));function w(ie){const ce=ie;return!!ce&&typeof ce.onDidChange=="function"}e.isFileSystemWatcher=w;var d;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function o(ie){return!!(ie.capabilities&2)}e.hasReadWriteCapability=o;function u(ie){return!!(ie.capabilities&8)}e.hasFileFolderCopyCapability=u;function c(ie){return!!(ie.capabilities&131072)}e.hasFileCloneCapability=c;function h(ie){return!!(ie.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function a(ie){return!!(ie.capabilities&16)}e.hasFileReadStreamCapability=a;function t(ie){return o(ie)?!!(ie.capabilities&16384):!1}e.hasFileAtomicReadCapability=t;function i(ie){return o(ie)?!!(ie.capabilities&32768):!1}e.hasFileAtomicWriteCapability=i;function s(ie){return!!(ie.capabilities&65536)}e.hasFileAtomicDeleteCapability=s;function n(ie){return!!(ie.capabilities&2048)}e.hasReadonlyCapability=n;var r;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class l extends Error{static create(ce,Se){const j=new l(ce.toString(),Se);return p(j,Se),j}constructor(ce,Se){super(ce),this.code=Se}}e.FileSystemProviderError=l;function k(ie,ce){return l.create(ie,ce)}e.createFileSystemProviderError=k;function C(ie){return ie||k((0,g.localize)(0,null),r.Unknown)}e.ensureFileSystemProviderError=C;function p(ie,ce){return ie.name=ce?`${ce} (FileSystemError)`:"FileSystemError",ie}e.markAsFileSystemProviderError=p;function m(ie){if(!ie)return r.Unknown;if(ie instanceof l)return ie.code;const ce=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ce)return r.Unknown;switch(ce[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.toFileSystemProviderErrorCode=m;function b(ie){if(ie instanceof U)return ie.fileOperationResult;switch(m(ie)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=b;var D;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class M{constructor(ce,Se,j){this.resource=ce,this.operation=Se,this.target=j}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=M;var L;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class F{static{this.MIXED_CORRELATION=null}constructor(ce,Se){this.ignorePathCasing=Se,this.correlationId=void 0,this.added=new P.Lazy(()=>{const j=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawAdded.map($=>[$,!0])),j}),this.updated=new P.Lazy(()=>{const j=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawUpdated.map($=>[$,!0])),j}),this.deleted=new P.Lazy(()=>{const j=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawDeleted.map($=>[$,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of ce){switch(j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}this.correlationId!==F.MIXED_CORRELATION&&(typeof j.cId=="number"?this.correlationId===void 0?this.correlationId=j.cId:this.correlationId!==j.cId&&(this.correlationId=F.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=F.MIXED_CORRELATION))}}contains(ce,...Se){return this.doContains(ce,{includeChildren:!1},...Se)}affects(ce,...Se){return this.doContains(ce,{includeChildren:!0},...Se)}doContains(ce,Se,...j){if(!ce)return!1;const $=j.length>0;return!!((!$||j.includes(1))&&(this.added.value.get(ce)||Se.includeChildren&&this.added.value.findSuperstr(ce))||(!$||j.includes(0))&&(this.updated.value.get(ce)||Se.includeChildren&&this.updated.value.findSuperstr(ce))||(!$||j.includes(2))&&(this.deleted.value.findSubstr(ce)||Se.includeChildren&&this.deleted.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.correlationId===ce}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=F;function x(ie,ce,Se){return!ie||!ce||ie===ce||ce.length>ie.length?!1:(ce.charAt(ce.length-1)!==O.sep&&(ce+=O.sep),Se?(0,f.startsWithIgnoreCase)(ie,ce):ie.indexOf(ce)===0)}e.isParent=x;class U extends Error{constructor(ce,Se,j){super(ce),this.fileOperationResult=Se,this.options=j}}e.FileOperationError=U;class N extends U{constructor(ce,Se,j,$){super(ce,Se,$),this.fileOperationResult=Se,this.size=j}}e.TooLargeFileOperationError=N;class z extends U{constructor(ce,Se,j){super(ce,2,j),this.stat=Se}}e.NotModifiedSinceFileOperationError=z;var V;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ge;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge||(e.FileKind=ge={})),e.ETAG_DISABLED="";function te(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.etag=te;async function q(ie,ce){if(!ce.hasProvider(T.URI.from({scheme:ie.scheme})))return new Promise(Se=>{const j=ce.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===ie.scheme&&$.added&&(j.dispose(),Se())})})}e.whenProviderRegistered=q;class K{static{this.KB=1024}static{this.MB=K.KB*K.KB}static{this.GB=K.MB*K.KB}static{this.TB=K.GB*K.KB}static formatSize(ce){return(0,A.isNumber)(ce)||(ce=0),ce<K.KB?(0,g.localize)(1,null,ce.toFixed(0)):ce<K.MB?(0,g.localize)(2,null,(ce/K.KB).toFixed(2)):ce<K.GB?(0,g.localize)(3,null,(ce/K.MB).toFixed(2)):ce<K.TB?(0,g.localize)(4,null,(ce/K.GB).toFixed(2)):(0,g.localize)(5,null,(ce/K.TB).toFixed(2))}}e.ByteSize=K;function ue(ie){const ce=typeof ie=="string"||ie?.scheme===R.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===R.Schemas.file?1024*K.MB:ce?10*K.MB:v.isWeb?50*K.MB:1024*K.MB}e.getLargeFileConfirmationLimit=ue}),define(De[234],Ie([1,0,22,9,196,30]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(R,P,E,S,_,w){let d;try{await g(R,P,E,S,_,w)}catch(o){d=o}finally{d&&_.errorTransformer&&(d=_.errorTransformer(d)),typeof d<"u"&&E.error(d),E.end()}}e.readFileIntoStream=T;async function g(R,P,E,S,_,w){y(w);const d=await R.open(P,{create:!1});try{y(w);let o=0,u=0,c=_&&typeof _.length=="number"?_.length:void 0,h=I.VSBuffer.alloc(Math.min(_.bufferSize,typeof c=="number"?c:_.bufferSize)),a=_&&typeof _.position=="number"?_.position:0,t=0;do u=await R.read(d,a,h.buffer,t,h.byteLength-t),a+=u,t+=u,o+=u,typeof c=="number"&&(c-=u),t===h.byteLength&&(await E.write(S(h)),h=I.VSBuffer.alloc(Math.min(_.bufferSize,typeof c=="number"?c:_.bufferSize)),t=0);while(u>0&&(typeof c!="number"||c>0)&&y(w)&&v(o,_));if(t>0){let i=t;typeof c=="number"&&(i=Math.min(t,c)),E.write(S(h.slice(0,i)))}}catch(o){throw(0,A.ensureFileSystemProviderError)(o)}finally{await R.close(d)}}function y(R){if(R.isCancellationRequested)throw(0,O.canceled)();return!0}function v(R,P){if(typeof P?.limits?.size=="number"&&R>P.limits.size)throw(0,A.createFileSystemProviderError)((0,f.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[84],Ie([1,0,36,3,16,12,2,30]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function y(o){return o.recursive===!0}e.isRecursiveWatchRequest=y;class v extends O.Disposable{static{this.MAX_RESTARTS=5}constructor(u,c,h,a){super(),this.onFileChanges=u,this.onLogMessage=c,this.verboseLogging=h,this.options=a,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new O.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),u.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),u.add(this.watcher.onDidError(c=>this.onError(c)))}onError(u){this.options.restartOnError?this.restartCounter<v.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}trace(u){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=v;class R extends v{constructor(u,c,h){super(u,c,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class P extends v{constructor(u,c,h){super(u,c,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function E(o){return o.map(u=>({type:u.type,resource:T.URI.revive(u.resource),cId:u.cId}))}e.reviveFileChanges=E;function S(o){const u=new d;for(const c of o)u.processEvent(c);return u.coalesce()}e.coalesceEvents=S;function _(o,u){return typeof u=="string"&&!u.startsWith(I.GLOBSTAR)&&!(0,f.isAbsolute)(u)?{base:o,pattern:u}:u}e.normalizeWatcherPattern=_;function w(o,u){const c=[];for(const h of u)c.push((0,I.parse)(_(o,h)));return c}e.parseWatcherPatterns=w;class d{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return A.isLinux?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const c=this.mapPathToChange.get(this.toKey(u));let h=!1;if(c){const a=c.type,t=u.type;c.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?h=!0:a===1&&t===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(c)):a===2&&t===1?c.type=0:a===1&&t===0||(c.type=t)}else h=!0;h&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],c=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(u.push(h),!1):!0).sort((h,a)=>h.resource.fsPath.length-a.resource.fsPath.length).filter(h=>c.some(a=>(0,g.isParent)(h.resource.fsPath,a,!A.isLinux))?!1:(c.push(h.resource.fsPath),!0)).concat(u)}}}),define(De[235],Ie([1,0,53,8,21,33,3,77,16,12,23,2,100,29,84]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class w extends T.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(u,c,h,a){super(),this.request=u,this.onDidFilesChange=c,this.onLogMessage=h,this.verboseLogging=a,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.onDidFilesChange(t))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(t=>this.handleFileChanges(t),w.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,_.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,_.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new f.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const u=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const c=await S.Promises.stat(u);this._register(await this.doWatch(u,c.isDirectory()))}catch(u){u.code!=="ENOENT"?this.error(u):this.trace(u)}}async normalizePath(u){let c=u.path;try{c=await S.Promises.realpath(u.path),u.path===c&&(c=await(0,E.realcase)(u.path)??u.path),u.path!==c&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${c})`)}catch{}return c}async doWatch(u,c){if(v.isMacintosh&&(0,A.isEqualOrParent)(u,"/Volumes/",!0))return this.error(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const h=new f.CancellationTokenSource(this.cts.token),a=new T.DisposableStore;try{const t=P.URI.file(this.request.path),i=(0,y.basename)(u),s=(0,I.watch)(u);a.add((0,T.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${u}'`);const n=new Set;if(c)try{for(const l of await S.Promises.readdir(u))n.add(l)}catch(l){this.error(l)}const r=new Map;a.add((0,T.toDisposable)(()=>{for(const[,l]of r)l.dispose();r.clear()})),s.on("error",(l,k)=>{this.error(`Failed to watch ${u} for changes using fs.watch() (${l}, ${k})`),this.dispose()}),s.on("change",(l,k)=>{if(h.token.isCancellationRequested)return;this.trace(`[raw] ["${l}"] ${k}`);let C="";if(k&&(C=k.toString(),v.isMacintosh&&(C=(0,g.normalizeNFC)(C))),!(!C||l!=="change"&&l!=="rename"))if(c)if(l==="rename"){r.get(C)?.dispose();const p=setTimeout(async()=>{if(r.delete(C),C===i&&!await S.Promises.exists(u)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.existsChildStrictCase((0,y.join)(u,C));if(h.token.isCancellationRequested)return;let b;m?n.has(C)?b=0:(b=1,n.add(C)):(n.delete(C),b=2),this.onFileChange({resource:(0,R.joinPath)(t,C),type:b,cId:this.request.correlationId})},w.FILE_DELETE_HANDLER_DELAY);r.set(C,(0,T.toDisposable)(()=>clearTimeout(p)))}else{let p;n.has(C)?p=0:(p=1,n.add(C)),this.onFileChange({resource:(0,R.joinPath)(t,C),type:p,cId:this.request.correlationId})}else if(l==="rename"||C!==i){const p=setTimeout(async()=>{const m=await S.Promises.exists(u);h.token.isCancellationRequested||(m?(this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0),a.add(await this.doWatch(u,!1))):(this.onFileChange({resource:t,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},w.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,T.toDisposable)(()=>clearTimeout(p)))}else this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0)})}catch(t){await S.Promises.exists(u)&&!h.token.isCancellationRequested&&this.error(`Failed to watch ${u} for changes using fs.watch() (${t.toString()})`)}return(0,T.toDisposable)(()=>{h.dispose(!0),a.dispose()})}onFileChange(u,c=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!c&&this.excludes.some(h=>h(u.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${u.resource.fsPath}`):!c&&this.includes&&this.includes.length>0&&!this.includes.some(h=>h(u.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${u.resource.fsPath}`):this.fileChangesAggregator.work(u))}handleFileChanges(u){const c=(0,_.coalesceEvents)(u);if(c.length>0){if(this.verboseLogging)for(const a of c)this.trace(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.throttledFileChangesEmitter.work(c)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(u){if(v.isLinux)return S.Promises.exists(u);try{const c=(0,y.basename)(u);return(await S.Promises.readdir((0,y.dirname)(u))).some(a=>a===c)}catch(c){return this.trace(c),!1}}setVerboseLogging(u){this.verboseLogging=u}error(u){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}warn(u){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}trace(u){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=w;async function d(o,u,c,h,a=512){const t=await S.Promises.open(o,"r"),i=Buffer.allocUnsafe(a),s=new f.CancellationTokenSource(h);let n,r=!1;const l={path:o,excludes:[],recursive:!1},k=new w(l,C=>{(async()=>{for(const{type:p}of C)if(p===0){if(r)return;r=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:m}=await S.Promises.read(t,i,0,a,null);if(!m||s.token.isCancellationRequested)break;u(i.slice(0,m))}}catch(m){n=new Error(m),s.dispose(!0)}finally{r=!1}}})()});return await k.ready,c(),new Promise((C,p)=>{s.token.onCancellationRequested(async()=>{k.dispose();try{await S.Promises.close(t)}catch(m){n=new Error(m)}n?p(n):C()})})}e.watchFileContents=d}),define(De[236],Ie([1,0,4,36,3,12,235]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class g extends f.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(v){const R=this.normalizeRequests(v),P=R.filter(S=>{const _=this.watchers.get(S.path);return _?!(0,O.patternsEquals)(_.request.excludes,S.excludes)||!(0,O.patternsEquals)(_.request.includes,S.includes):!0}),E=Array.from(this.watchers.values()).filter(({request:S})=>!R.find(_=>_.path===S.path&&(0,O.patternsEquals)(_.excludes,S.excludes)&&(0,O.patternsEquals)(_.includes,S.includes))).map(({request:S})=>S.path);P.length&&this.trace(`Request to start watching: ${P.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const S of E)this.stopWatching(S);for(const S of P)this.startWatching(S)}startWatching(v){const R=new T.NodeJSFileWatcherLibrary(v,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),P={request:v,instance:R};this.watchers.set(v.path,P)}async stop(){for(const[v]of this.watchers)this.stopWatching(v);this.watchers.clear()}stopWatching(v){const R=this.watchers.get(v);R&&(this.watchers.delete(v),R.instance.dispose())}normalizeRequests(v){const R=new Map;for(const P of v){const E=A.isLinux?P.path:P.path.toLowerCase();let S=R.get(P.correlationId);S||(S=new Map,R.set(P.correlationId,S)),S.set(E,P)}return Array.from(R.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(v){this.verboseLogging=v;for(const[,R]of this.watchers)R.instance.setVerboseLogging(v)}trace(v){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(v)})}toMessage(v,R){return R?`[File Watcher (node.js)] ${v} (path: ${R.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=g}),define(De[237],Ie([1,0,84,236]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class f extends I.AbstractNonRecursiveWatcherClient{constructor(T,g,y){super(T,g,y),this.init()}createWatcher(T){return T.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=f}),define(De[238],Ie([1,0,18,81,183,84]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(y,v,R){super(y,v,R),this.init()}createWatcher(y){const v=y.add(new f.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(v.onDidProcessExit(({code:R,signal:P})=>this.onError(`terminated by itself with code ${R}, signal: ${P}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(De[104],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...f){this._entries=new Map;for(const[A,T]of f)this.set(A,T)}set(f,A){const T=this._entries.get(f);return this._entries.set(f,A),T}has(f){return this._entries.has(f)}get(f){return this._entries.get(f)}}e.ServiceCollection=I}),define(De[239],Ie([1,0,8,9,3,102,230,5,104,76]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class P extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class E{constructor(d=new y.ServiceCollection,o=!1,u,c=R){this._services=d,this._strict=o,this._parent=u,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(g.IInstantiationService,this),this._globalGraph=c?u?._globalGraph??new T.Graph(h=>h):void 0}createChild(d){return new E(d,this._strict,this,this._enableTracing)}invokeFunction(d,...o){const u=_.traceInvocation(this._enableTracing,d);let c=!1;try{return d({get:a=>{if(c)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(a,u);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{c=!0,u.stop()}}createInstance(d,...o){let u,c;return d instanceof A.SyncDescriptor?(u=_.traceCreation(this._enableTracing,d.ctor),c=this._createInstance(d.ctor,d.staticArguments.concat(o),u)):(u=_.traceCreation(this._enableTracing,d),c=this._createInstance(d,o,u)),u.stop(),c}_createInstance(d,o=[],u){const c=g._util.getServiceDependencies(d).sort((t,i)=>t.index-i.index),h=[];for(const t of c){const i=this._getOrCreateServiceInstance(t.id,u);i||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),h.push(i)}const a=c.length>0?c[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${d.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(d,o.concat(h))}_setServiceInstance(d,o){if(this._services.get(d)instanceof A.SyncDescriptor)this._services.set(d,o);else if(this._parent)this._parent._setServiceInstance(d,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const o=this._services.get(d);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):o}_getOrCreateServiceInstance(d,o){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(d));const u=this._getServiceInstanceOrDescriptor(d);return u instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,u,o.branch(d,!0)):(o.branch(d,!1),u)}_safeCreateAndCacheServiceInstance(d,o,u){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,o,u)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,o,u){const c=new T.Graph(t=>t.id.toString());let h=0;const a=[{id:d,desc:o,_trace:u}];for(;a.length;){const t=a.pop();if(c.lookupOrInsertNode(t),h++>1e3)throw new P(c);for(const i of g._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(i.id);if(s||this._throwIfStrict(`[createInstance] ${d} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(i.id)),s instanceof A.SyncDescriptor){const n={id:i.id,desc:s,_trace:t._trace.branch(i.id,!0)};c.insertEdge(t,n),a.push(n)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new P(c);break}for(const{data:i}of t){if(this._getServiceInstanceOrDescriptor(i.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}c.removeNode(i)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,o,u=[],c,h){if(this._services.get(d)instanceof A.SyncDescriptor)return this._createServiceInstance(d,o,u,c,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,o,u,c,h);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(d,o,u=[],c,h){if(c){const a=new E(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(d);const t=new Map,i=new I.IdleValue(()=>{const s=a._createInstance(o,u,h);for(const[n,r]of t){const l=s[n];if(typeof l=="function")for(const k of r)l.apply(s,k)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!i.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let k=t.get(n);return k||(k=new v.LinkedList,t.set(n,k)),(p,m,b)=>{const D=k.push([p,m,b]);return(0,f.toDisposable)(D)}}if(n in s)return s[n];const r=i.value;let l=r[n];return typeof l!="function"||(l=l.bind(r),s[n]=l),l},set(s,n,r){return i.value[n]=r,!0},getPrototypeOf(s){return o.prototype}})}else return this._createInstance(o,u,h)}_throwIfStrict(d,o){if(o&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=E;var S;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(S||(S={}));class _{static{this.all=new Set}static{this._None=new class extends _{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,o){return d?new _(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):_._None}static traceCreation(d,o){return d?new _(1,o.name):_._None}static{this._totals=0}constructor(d,o){this.type=d,this.name=o,this._start=Date.now(),this._dep=[]}branch(d,o){const u=new _(3,d.toString());return this._dep.push([d,o,u]),u}stop(){const d=Date.now()-this._start;_._totals+=d;let o=!1;function u(h,a){const t=[],i=new Array(h+1).join("	");for(const[s,n,r]of a._dep)if(n&&r){o=!0,t.push(`${i}CREATES -> ${s}`);const l=u(h+1,r);l&&t.push(l)}else t.push(`${i}uses -> ${s}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(d>2||o)&&_.all.add(c.join(`
`))}}e.Trace=_}),define(De[14],Ie([1,0,41,4,52,3,28,12,23,17,2,42,5]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function S(){return new Date().toISOString()}function _(p){return(0,v.isNumber)(p)}e.isLogLevel=_;var w;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function d(p,m,b){switch(m){case w.Trace:p.trace(b);break;case w.Debug:p.debug(b);break;case w.Info:p.info(b);break;case w.Warning:p.warn(b);break;case w.Error:p.error(b);break;case w.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=d;function o(p,m=!1){let b="";for(let D=0;D<p.length;D++){let M=p[D];if(M instanceof Error&&(M=(0,I.toErrorMessage)(M,m)),typeof M=="object")try{M=JSON.stringify(M)}catch{}b+=(D>0?" ":"")+M}return b}class u extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(m){this.level!==m&&(this.level=m,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(m){return this.level!==w.Off&&this.level<=m}}e.AbstractLogger=u;class c extends u{constructor(m){super(),this.logAlways=m}checkLogLevel(m){return this.logAlways||super.checkLogLevel(m)}trace(m,...b){this.checkLogLevel(w.Trace)&&this.log(w.Trace,o([m,...b],!0))}debug(m,...b){this.checkLogLevel(w.Debug)&&this.log(w.Debug,o([m,...b]))}info(m,...b){this.checkLogLevel(w.Info)&&this.log(w.Info,o([m,...b]))}warn(m,...b){this.checkLogLevel(w.Warning)&&this.log(w.Warning,o([m,...b]))}error(m,...b){if(this.checkLogLevel(w.Error))if(m instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=m.stack,this.log(w.Error,o(D))}else this.log(w.Error,o([m,...b]))}flush(){}}e.AbstractMessageLogger=c;class h extends u{constructor(m=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(m),this.useColors=!g.isWindows}trace(m,...b){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...b):console.log(`[main ${S()}]`,m,...b))}debug(m,...b){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...b):console.log(`[main ${S()}]`,m,...b))}info(m,...b){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...b):console.log(`[main ${S()}]`,m,...b))}warn(m,...b){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,m,...b):console.warn(`[main ${S()}]`,m,...b))}error(m,...b){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,m,...b):console.error(`[main ${S()}]`,m,...b))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class a extends u{constructor(m=e.DEFAULT_LOG_LEVEL,b=!0){super(),this.useColors=b,this.setLevel(m)}trace(m,...b){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",m,...b):console.log(m,...b))}debug(m,...b){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",m,...b):console.log(m,...b))}info(m,...b){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",m,...b):console.log(m,...b))}warn(m,...b){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",m,...b):console.log(m,...b))}error(m,...b){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",m,...b):console.error(m,...b))}dispose(){}flush(){}}e.ConsoleLogger=a;class t extends u{constructor(m,b=e.DEFAULT_LOG_LEVEL){super(),this.adapter=m,this.setLevel(b)}trace(m,...b){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(m),...b])}debug(m,...b){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(m),...b])}info(m,...b){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(m),...b])}warn(m,...b){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(m),...b])}error(m,...b){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(m),...b])}extractMessage(m){return typeof m=="string"?m:(0,I.toErrorMessage)(m,this.checkLogLevel(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class i extends u{constructor(m){super(),this.loggers=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const b of this.loggers)b.setLevel(m);super.setLevel(m)}trace(m,...b){for(const D of this.loggers)D.trace(m,...b)}debug(m,...b){for(const D of this.loggers)D.debug(m,...b)}info(m,...b){for(const D of this.loggers)D.info(m,...b)}warn(m,...b){for(const D of this.loggers)D.warn(m,...b)}error(m,...b){for(const D of this.loggers)D.error(m,...b)}flush(){for(const m of this.loggers)m.flush()}dispose(){for(const m of this.loggers)m.dispose()}}e.MultiplexLogger=i;class s extends A.Disposable{constructor(m,b,D){if(super(),this.logLevel=m,this.logsHome=b,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,D)for(const M of D)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(m){return(0,v.isString)(m)?[...this._loggers.values()].find(b=>b.info.id===m):this._loggers.get(m)}getLogger(m){return this.getLoggerEntry(m)?.logger}createLogger(m,b){const D=this.toResource(m),M=(0,v.isString)(m)?m:b?.id??(0,f.hash)(D.toString()).toString(16);let L=this._loggers.get(D)?.logger;const F=b?.logLevel==="always"?w.Trace:b?.logLevel;L||(L=this.doCreateLogger(D,F??this.getLogLevel(D)??this.logLevel,{...b,id:M}));const x={logger:L,info:{resource:D,id:M,logLevel:F,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(x.info),this._loggers.set(D,x),L}toResource(m){return(0,v.isString)(m)?(0,y.joinPath)(this.logsHome,`${m}.log`):m}setLogLevel(m,b){if(R.URI.isUri(m)){const D=m,M=b,L=this._loggers.get(D);L&&M!==L.info.logLevel&&(L.info.logLevel=M===this.logLevel?void 0:M,L.logger?.setLevel(M),this._loggers.set(L.info.resource,L),this._onDidChangeLogLevel.fire([D,M]))}else{this.logLevel=m;for(const[D,M]of this._loggers.entries())this._loggers.get(D)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(m,b){const D=this.getLoggerEntry(m);D&&b!==!D.info.hidden&&(D.info.hidden=!b,this._loggers.set(D.info.resource,D),this._onDidChangeVisibility.fire([D.info.resource,b]))}getLogLevel(m){let b;return m&&(b=this._loggers.get(m)?.info.logLevel),b??this.logLevel}registerLogger(m){const b=this._loggers.get(m.resource);b?b.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this._loggers.set(m.resource,{info:m,logger:void 0}),this._onDidChangeLoggers.fire({added:[m],removed:[]}))}deregisterLogger(m){const b=this._loggers.get(m);b&&(b.logger&&b.logger.dispose(),this._loggers.delete(m),this._onDidChangeLoggers.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const m of this._loggers.values())yield m.info}getRegisteredLogger(m){return this._loggers.get(m)?.info}dispose(){this._loggers.forEach(m=>m.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class n{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(m){}getLevel(){return w.Info}trace(m,...b){}debug(m,...b){}info(m,...b){}warn(m,...b){}error(m,...b){}critical(m,...b){}dispose(){}flush(){}}e.NullLogger=n;class r extends n{}e.NullLogService=r;function l(p){if(p.verbose)return w.Trace;if(typeof p.logLevel=="string"){const m=C(p.logLevel.toLowerCase());if(m!==void 0)return m}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function k(p){switch(p){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=k;function C(p){switch(p){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new P.RawContextKey("logLevel",k(w.Info))}),define(De[240],Ie([1,0,19,8,9,4,3,16,84,14]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends T.Disposable{constructor(E,S){super(),this.logService=E,this.options=S,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(E,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,S):this.watchNonRecursive(E,S)}watchUniversal(E,S){const _={path:this.toFilePath(E),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},w=(0,I.insert)(this.universalPathsToWatch,_);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,f.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,y.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const S of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const S of this.universalPathsToWatch)(0,y.isRecursiveWatchRequest)(S)&&E.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,S){const _={path:this.toFilePath(E),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},w=(0,I.insert)(this.nonRecursivePathsToWatch,_);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,f.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,y.reviveFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,g.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(De[241],Ie([1,0,53,376,8,28,22,4,33,3,16,12,23,96,29,197,30,234,240,41,238,237]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(I)}catch(i){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(i)}`)}})();class t extends u.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=g.Event.None,this.resourceLocks=new A.ResourceMap(r=>E.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:n,symbolicLink:r}=await _.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:d.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await _.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async l=>{try{let k;l.isSymbolicLink()?k=(await this.stat((0,E.joinPath)(s,l.name))).type:k=this.toType(l),r.push([l.name,k])}catch(k){this.logService.trace(k)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(s,n){let r;return n?.dangling?r=d.FileType.Unknown:s.isFile()?r=d.FileType.File:s.isDirectory()?r=d.FileType.Directory:r=d.FileType.Unknown,n&&(r|=d.FileType.SymbolicLink),r}async createResourceLock(s){const n=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const l=new f.Barrier;return this.resourceLocks.set(s,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,v.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(s)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(s,n){let r;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const l=this.toFilePath(s);return await _.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{r?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,n,r){const l=(0,S.newWriteableStream)(k=>T.VSBuffer.concat(k.map(C=>T.VSBuffer.wrap(C))).buffer);return(0,o.readFileIntoStream)(this,s,l,k=>k.buffer,{...n,bufferSize:256*1024},r),l}async writeFile(s,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,E.joinPath)((0,E.dirname)(s),`${(0,E.basename)(s)}${r.atomic.postfix}`),n,r):this.doWriteFile(s,n,r)}async canWriteFileAtomic(s){try{const n=this.toFilePath(s),{symbolicLink:r}=await _.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async doWriteFileAtomic(s,n,r,l){const k=new v.DisposableStore;try{k.add(await this.createResourceLock(s)),k.add(await this.createResourceLock(n)),await this.doWriteFile(n,r,l,!0);try{await this.rename(n,s,{overwrite:!0})}catch(C){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{k.dispose()}}async doWriteFile(s,n,r,l){let k;try{const C=this.toFilePath(s);if(!r.create||!r.overwrite){if(await _.Promises.exists(C)){if(!r.overwrite)throw(0,d.createFileSystemProviderError)((0,w.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,d.createFileSystemProviderError)((0,w.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(s,{create:!0,unlock:r.unlock},l),await this.write(k,0,n,0,n.byteLength)}catch(C){throw await this.toFileSystemProviderWriteError(s,C)}finally{typeof k=="number"&&await this.close(k)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,n,r){const l=this.toFilePath(s);let k;(0,d.isFileOpenForWriteOptions)(n)&&!r&&(k=await this.createResourceLock(s));let C;try{if((0,d.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:m}=await _.SymlinkSupport.stat(l);m.mode&128||await _.Promises.chmod(l,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}let p;if((0,d.isFileOpenForWriteOptions)(n)){if(P.isWindows)try{await _.Promises.truncate(l,0),p="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}p||(p="w")}else p="r";C=await _.Promises.open(l,p)}catch(p){throw k?.dispose(),(0,d.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(s,p):this.toFileSystemProviderError(p)}if(this.mapHandleToPos.set(C,0),(0,d.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(C,s),k){const p=this.mapHandleToLock.get(C);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${l})`),this.mapHandleToLock.set(C,k),p&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${l})`),p.dispose())}return C}async close(s){const n=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await _.Promises.fdatasync(s)}catch(r){t.configureFlushOnWrite(!1),this.logService.error(r)}return await _.Promises.close(s)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(s)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,r,l,k){const C=this.normalizePos(s,n);let p=null;try{p=(await _.Promises.read(s,r,l,k,C)).bytesRead}catch(m){throw this.toFileSystemProviderError(m)}finally{this.updatePos(s,C,p)}return p}normalizePos(s,n){return n===this.mapHandleToPos.get(s)?null:n}updatePos(s,n,r){const l=this.mapHandleToPos.get(s);typeof l=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,l+r):this.mapHandleToPos.delete(s)))}async write(s,n,r,l,k){return(0,f.retry)(()=>this.doWrite(s,n,r,l,k),100,3)}async doWrite(s,n,r,l,k){const C=this.normalizePos(s,n);let p=null;try{p=(await _.Promises.write(s,r,l,k,C)).bytesWritten}catch(m){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),m)}finally{this.updatePos(s,C,p)}return p}async mkdir(s){try{await _.Promises.mkdir(this.toFilePath(s))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(s,n){try{const r=this.toFilePath(s);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,R.join)((0,R.dirname)(r),`${(0,R.basename)(r)}${n.atomic.postfix}`)),await _.Promises.rm(r,_.RimRafMode.MOVE,l)}else try{await _.Promises.unlink(r)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let k=!1;try{const{stat:C,symbolicLink:p}=await _.SymlinkSupport.stat(r);k=C.isDirectory()&&!p}catch{}if(k)await _.Promises.rmdir(r);else throw l}else throw l}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,n,r){const l=this.toFilePath(s),k=this.toFilePath(n);if(l!==k)try{await this.validateMoveCopy(s,n,"move",r.overwrite),await _.Promises.rename(l,k)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,w.localize)(2,null,(0,R.basename)(l),(0,R.basename)((0,R.dirname)(k)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(s,n,r){const l=this.toFilePath(s),k=this.toFilePath(n);if(l!==k)try{await this.validateMoveCopy(s,n,"copy",r.overwrite),await _.Promises.copy(l,k,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,w.localize)(3,null,(0,R.basename)(l),(0,R.basename)((0,R.dirname)(k)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(s,n,r,l){const k=this.toFilePath(s),C=this.toFilePath(n);let p=!1;if(!!(this.capabilities&1024)||(p=(0,y.isEqual)(k,C,!0)),p){if(r==="copy")throw(0,d.createFileSystemProviderError)((0,w.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const b=await this.statIgnoreError(s);if(!b)throw(0,d.createFileSystemProviderError)((0,w.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const D=await this.statIgnoreError(n);if(D){if(!l)throw(0,d.createFileSystemProviderError)((0,w.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);b.type&d.FileType.File&&D.type&d.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.doCloneFile(s,n,!1)}async doCloneFile(s,n,r){const l=this.toFilePath(s),k=this.toFilePath(n),C=!!(this.capabilities&1024);if((0,y.isEqual)(l,k,!C))return;const p=new v.DisposableStore;try{p.add(await this.createResourceLock(s)),p.add(await this.createResourceLock(n)),r&&await _.Promises.mkdir((0,R.dirname)(k),{recursive:!0}),await _.Promises.copyFile(l,k)}catch(m){if(m.code==="ENOENT"&&!r)return this.doCloneFile(s,n,!0);throw this.toFileSystemProviderError(m)}finally{p.dispose()}}createUniversalWatcher(s,n,r){return new h.UniversalWatcherClient(l=>s(l),l=>n(l),r)}createNonRecursiveWatcher(s,n,r){return new a.NodeJSWatcherClient(l=>s(l),l=>n(l),r)}toFileSystemProviderError(s){if(s instanceof d.FileSystemProviderError)return s;let n=s,r;switch(s.code){case"ENOENT":r=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=d.FileSystemProviderErrorCode.Unknown;break;default:r=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(s,n){let r=this.toFileSystemProviderError(n);if(s&&r.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await _.SymlinkSupport.stat(this.toFilePath(s));l.mode&128||(r=(0,d.createFileSystemProviderError)(n,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return r}}e.DiskFileSystemProvider=t}),define(De[242],Ie([1,0,3,14]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class f extends I.Disposable{constructor(T,g=[]){super(),this.logger=new O.MultiplexLogger([T,...g]),this._register(T.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...g){this.logger.trace(T,...g)}debug(T,...g){this.logger.debug(T,...g)}info(T,...g){this.logger.info(T,...g)}warn(T,...g){this.logger.warn(T,...g)}error(T,...g){this.logger.error(T,...g)}flush(){this.logger.flush()}}e.LogService=f}),define(De[243],Ie([1,0,30,14]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var f;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(f||(f={}));async function A(v,R,P,E,S){try{const _=await new Promise((d,o)=>{pe(["@vscode/spdlog"],d,o)});_.setFlushOn(f.Trace);const w=await _.createAsyncRotatingLogger(v,R,P,E);return S?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(_){console.error(_)}return null}function T(v,R,P){switch(R){case O.LogLevel.Trace:v.trace(P);break;case O.LogLevel.Debug:v.debug(P);break;case O.LogLevel.Info:v.info(P);break;case O.LogLevel.Warning:v.warn(P);break;case O.LogLevel.Error:v.error(P);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function g(v,R){switch(R){case O.LogLevel.Trace:v.setLevel(f.Trace);break;case O.LogLevel.Debug:v.setLevel(f.Debug);break;case O.LogLevel.Info:v.setLevel(f.Info);break;case O.LogLevel.Warning:v.setLevel(f.Warning);break;case O.LogLevel.Error:v.setLevel(f.Error);break;case O.LogLevel.Off:v.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class y extends O.AbstractMessageLogger{constructor(R,P,E,S,_){super(),this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(R,P,E,S),this._register(this.onDidChangeLogLevel(w=>{this._logger&&g(this._logger,w)}))}async _createSpdLogLogger(R,P,E,S){const _=E?6:1,w=30/_*I.ByteSize.MB,d=await A(R,P,w,_,S);if(d){this._logger=d,g(this._logger,this.getLevel());for(const{level:o,message:u}of this.buffer)T(this._logger,o,u);this.buffer=[]}}log(R,P){this._logger?T(this._logger,R,P):this.getLevel()<=R&&this.buffer.push({level:R,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[133],Ie([1,0,38,198,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(y){function v(_,w){return w-_}y.compare=v;const R=Object.create(null);R[y.Error]=(0,O.localize)(0,null),R[y.Warning]=(0,O.localize)(1,null),R[y.Info]=(0,O.localize)(2,null);function P(_){return R[_]||""}y.toString=P;function E(_){switch(_){case I.default.Error:return y.Error;case I.default.Warning:return y.Warning;case I.default.Info:return y.Info;case I.default.Ignore:return y.Hint}}y.fromSeverity=E;function S(_){switch(_){case y.Error:return I.default.Error;case y.Warning:return I.default.Warning;case y.Info:return I.default.Info;case y.Hint:return I.default.Ignore}}y.toSeverity=S}(T||(e.MarkerSeverity=T={}));var g;(function(y){const v="";function R(E){return P(E,!0)}y.makeKey=R;function P(E,S){const _=[v];return E.source?_.push(E.source.replace("\xA6","\\\xA6")):_.push(v),E.code?typeof E.code=="string"?_.push(E.code.replace("\xA6","\\\xA6")):_.push(E.code.value.replace("\xA6","\\\xA6")):_.push(v),E.severity!==void 0&&E.severity!==null?_.push(T.toString(E.severity)):_.push(v),E.message&&S?_.push(E.message.replace("\xA6","\\\xA6")):_.push(v),E.startLineNumber!==void 0&&E.startLineNumber!==null?_.push(E.startLineNumber.toString()):_.push(v),E.startColumn!==void 0&&E.startColumn!==null?_.push(E.startColumn.toString()):_.push(v),E.endLineNumber!==void 0&&E.endLineNumber!==null?_.push(E.endLineNumber.toString()):_.push(v),E.endColumn!==void 0&&E.endColumn!==null?_.push(E.endColumn.toString()):_.push(v),_.push(v),_.join("\xA6")}y.makeKeyOptionalMessage=P})(g||(e.IMarkerData=g={})),e.IMarkerService=(0,f.createDecorator)("markerService")}),define(De[244],Ie([1,0,4,38,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=O.default,e.INotificationService=(0,f.createDecorator)("notificationService");var A;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var T;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var g;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(g||(e.NotificationsFilter=g={}));class y{constructor(){this.progress=new v,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.NoOpNotification=y;class v{infinite(){}done(){}total(P){}worked(P){}}e.NoOpProgress=v}),define(De[134],Ie([1,0,15,2,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,f.createDecorator)("openerService");function A(v,R){return O.URI.isUri(v)?(0,I.equalsIgnoreCase)(v.scheme,R):(0,I.startsWithIgnoreCase)(v,R+":")}e.matchesScheme=A;function T(v,...R){return R.some(P=>A(v,P))}e.matchesSomeScheme=T;function g(v,R){return v.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=g;function y(v){let R;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(v.fragment);return P&&(R={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},v=v.with({fragment:""})),{selection:R,uri:v}}e.extractSelection=y}),define(De[245],Ie([1,0,12,48]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let f;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const A=I.globals.vscode.context.configuration();if(A)f=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){f=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:T,itemUrl:g,controlUrl:y}=f.extensionsGallery||{};Object.assign(f,{extensionsGallery:{serviceUrl:O.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:O.env.VSCODE_GALLERY_SEARCH_URL||T,itemUrl:O.env.VSCODE_GALLERY_ITEM_URL||g,controlUrl:O.env.VSCODE_GALLERY_CONTROL_URL||y}});try{const v=(...P)=>P.reduce((E,S)=>(Object.keys(S).forEach(_=>{Array.isArray(E[_])&&Array.isArray(S[_])?E[_]=S[_]:typeof E[_]=="object"&&typeof S[_]=="object"?E[_]=v(E[_],S[_]):E[_]=S[_]}),E),{}),R=globalThis._VSCODE_USER_PRODUCT_JSON||{};f=v(f,R)}catch{}if(O.env.VSCODE_DEV&&Object.assign(f,{nameShort:`${f.nameShort} Dev`,nameLong:`${f.nameLong} Dev`,dataFolderName:`${f.dataFolderName}-dev`,serverDataFolderName:f.serverDataFolderName?`${f.serverDataFolderName}-dev`:void 0}),!f.version){const v=globalThis._VSCODE_PACKAGE_JSON;Object.assign(f,{version:v.version,release:v.release})}}else f={},Object.keys(f).length===0&&Object.assign(f,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=f}),define(De[135],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(pe,e){return function(I,O){e(I,O,pe)}};define(De[64],Ie([1,0,8,21,3,5]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var T;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(E){this.callback=E}report(E){this._value=E,this.callback(this._value)}}e.Progress=g;class y{get value(){return this._value}constructor(E){this.callback=E}report(E){this._asyncQueue?this._asyncQueue.push(E):this._asyncQueue=[E],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const E=this._asyncQueue.shift();this._value=E,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const E=this._drainListener;this._drainListener=void 0,E?.()}}drain(){return this._processingAsyncQueue?new Promise(E=>{const S=this._drainListener;this._drainListener=()=>{S?.(),E()}}):Promise.resolve()}}e.AsyncProgress=y;let v=class extends f.Disposable{constructor(E,S){super(),this.deferred=new I.DeferredPromise,S.withProgress(E,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,f.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};e.UnmanagedProgress=v,e.UnmanagedProgress=v=je([$e(1,e.IProgressService)],v);class R extends f.Disposable{constructor(E){super(),this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new f.DisposableStore)}start(E){this.stop();const S=++this.currentOperationId,_=new O.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,f.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,f.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,f.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:_.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,58,17]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class f{constructor(){this.data=new Map}add(T,g){I.ok(O.isString(T)),I.ok(O.isObject(g)),I.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,g)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new f}),define(De[105],Ie([1,0,4,43]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function f(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,v){this.schemasById[f(y)]=v,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;O.Registry.add(e.Extensions.JSONContribution,T)}),define(De[136],Ie([1,0,19,4,17,188,50,105,43]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=y.Registry.as(g.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,i=!0){this.registerConfigurations([t],i)}registerConfigurations(t,i=!0){const s=new Set;this.doRegisterConfigurations(t,i,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const i=new Set;this.doDeregisterConfigurations(t,i),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:t,remove:i}){const s=new Set;this.doDeregisterConfigurations(i,s),this.doRegisterConfigurations(t,!1,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const i=new Set;this.doRegisterDefaultConfigurations(t,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,i){const s=[];for(const{overrides:n,source:r}of t)for(const l in n)if(i.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const k=this.configurationDefaultsOverrides.get(l),C=k?.valuesSources??new Map;if(r)for(const D of Object.keys(n[l]))C.set(D,r);const p={...k?.value||{},...n[l]};this.configurationDefaultsOverrides.set(l,{source:r,value:p,valuesSources:C});const m=(0,T.getLanguageTagSettingPlainKey)(l),b={type:"object",default:p,description:A.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:f.isString(r)?void 0:r,defaultValueSource:r};s.push(...w(l)),this.configurationProperties[l]=b,this.defaultLanguageConfigurationOverridesNode.properties[l]=b}else{this.configurationDefaultsOverrides.set(l,{value:n[l],source:r});const k=this.configurationProperties[l];k&&(this.updatePropertyDefaultValue(l,k),this.updateSchema(l,k))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const i=new Set;this.doDeregisterDefaultConfigurations(t,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,i){for(const{overrides:s,source:n}of t)for(const r in s){const l=this.configurationDefaultsOverrides.get(r),k=f.isString(n)?n:n?.id,C=f.isString(l?.source)?l?.source:l?.source?.id;if(k===C)if(i.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const p=this.configurationProperties[r];p&&(this.updatePropertyDefaultValue(r,p),this.updateSchema(r,p))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let i=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),i=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),i=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const i of t)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,i,s){t.forEach(n=>{this.validateAndRegisterProperties(n,i,n.extensionInfo,n.restrictedProperties,void 0,s),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,i){const s=n=>{if(n.properties)for(const r in n.properties){i.add(r);const l=this.configurationProperties[r];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,n.properties[r])}n.allOf?.forEach(r=>s(r))};for(const n of t){s(n);const r=this.configurationContributors.indexOf(n);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(t,i=!0,s,n,r=3,l){r=f.isUndefinedOrNull(t.scope)?r:t.scope;const k=t.properties;if(k)for(const p in k){const m=k[p];if(i&&c(p,m)){delete k[p];continue}if(m.source=s,m.defaultDefaultValue=k[p].default,this.updatePropertyDefaultValue(p,m),e.OVERRIDE_PROPERTY_REGEX.test(p)?m.scope=void 0:(m.scope=f.isUndefinedOrNull(m.scope)?r:m.scope,m.restricted=f.isUndefinedOrNull(m.restricted)?!!n?.includes(p):m.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.excludedConfigurationProperties[p]=k[p],delete k[p];continue}else this.configurationProperties[p]=k[p],k[p].policy?.name&&this.policyConfigurations.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),l.add(p)}const C=t.allOf;if(C)for(const p of C)this.validateAndRegisterProperties(p,i,s,n,r,l)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const i=s=>{const n=s.properties;if(n)for(const l in n)this.updateSchema(l,n[l]);s.allOf?.forEach(i)};i(t)}updateSchema(t,i){switch(e.allSettings.properties[t]=i,i.scope){case 1:e.applicationSettings.properties[t]=i;break;case 2:e.machineSettings.properties[t]=i;break;case 6:e.machineOverridableSettings.properties[t]=i;break;case 3:e.windowSettings.properties[t]=i;break;case 4:e.resourceSettings.properties[t]=i;break;case 5:e.resourceSettings.properties[t]=i,this.resourceLanguageSettingsSchema.properties[t]=i;break}}removeFromSchema(t,i){switch(delete e.allSettings.properties[t],i.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const i=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,s),e.allSettings.properties[i]=s,e.applicationSettings.properties[i]=s,e.machineSettings.properties[i]=s,e.machineOverridableSettings.properties[i]=s,e.windowSettings.properties[i]=s,e.resourceSettings.properties[i]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,i){const s=this.configurationDefaultsOverrides.get(t);let n=s?.value,r=s?.source;f.isUndefined(n)&&(n=i.defaultDefaultValue,r=void 0),f.isUndefined(n)&&(n=o(i.type)),i.default=n,i.defaultValueSource=r}}const S="\\[([^\\]]+)\\]",_=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(a){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let i=_.exec(a);for(;i?.length;){const s=i[1].trim();s&&t.push(s),i=_.exec(a)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=w;function d(a){return a.reduce((t,i)=>`${t}[${i}]`,"")}e.keyFromOverrideIdentifiers=d;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const u=new E;y.Registry.add(e.Extensions.Configuration,u);function c(a,t){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?A.localize(7,null,a):u.getConfigurationProperties()[a]!==void 0?A.localize(8,null,a):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,a,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=c;function h(){const a=[],t=u.getConfigurationProperties();for(const i of Object.keys(t))a.push([i,t[i].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=h}),define(De[246],Ie([1,0,19,4,157,3,28,24,17,2,50,136,43]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function S(i){return Object.isFrozen(i)?i:g.deepFreeze(i)}class _{constructor(s={},n=[],r=[],l){this._contents=s,this._keys=n,this._overrides=r,this.raw=l,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof _)return n;const r=new w("");return r.parseRaw(n),r.configurationModel});this._rawConfiguration=s.reduce((n,r)=>r===n?r:n.merge(r),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,R.getConfigurationValue)(this.contents,s):this.contents}inspect(s,n){const r=this.rawConfiguration.getValue(s),l=n?this.rawConfiguration.getOverrideValue(s,n):void 0,k=n?this.rawConfiguration.override(n).getValue(s):r;return{value:r,override:l,merged:k}}getOverrideValue(s,n){const r=this.getContentsForOverrideIdentifer(n);return r?s?(0,R.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const r of this.overrides)r.identifiers.includes(s)&&n.push(...r.keys);return I.distinct(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return I.distinct(s)}override(s){let n=this.overrideConfigurations.get(s);return n||(n=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,n)),n}merge(...s){const n=g.deepClone(this.contents),r=g.deepClone(this.overrides),l=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const C of s)if(k.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(n,C.contents);for(const p of C.overrides){const[m]=r.filter(b=>I.equals(b.identifiers,p.identifiers));m?(this.mergeContents(m.contents,p.contents),m.keys.push(...p.keys),m.keys=I.distinct(m.keys)):r.push(g.deepClone(p))}for(const p of C.keys)l.indexOf(p)===-1&&l.push(p)}return new _(n,l,r,k.every(C=>C instanceof _)?void 0:k)}createOverrideConfigurationModel(s){const n=this.getContentsForOverrideIdentifer(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const l of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let k=this.contents[l];const C=n[l];C&&(typeof k=="object"&&typeof C=="object"?(k=g.deepClone(k),this.mergeContents(k,C)):k=C),r[l]=k}return new _(r,this.keys,this.overrides)}mergeContents(s,n){for(const r of Object.keys(n)){if(r in s&&y.isObject(s[r])&&y.isObject(n[r])){this.mergeContents(s[r],n[r]);continue}s[r]=g.deepClone(n[r])}}getContentsForOverrideIdentifer(s){let n=null,r=null;const l=k=>{k&&(r?this.mergeContents(r,k):r=g.deepClone(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===s?n=k.contents:k.identifiers.includes(s)&&l(k.contents);return l(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.updateValue(s,n,!0)}setValue(s,n){this.updateValue(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,R.removeFromValueTree)(this.contents,s),P.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>I.equals(r.identifiers,(0,P.overrideIdentifiersFromKey)(s))),1))}updateValue(s,n,r){(0,R.addToValueTree)(this.contents,s,n,l=>console.error(l)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),P.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,P.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,R.toValuesTree)(this.contents[s],l=>console.error(l))})}}e.ConfigurationModel=_;class w{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,n){if(!y.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,n)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,n){this._raw=s;const{contents:r,keys:l,overrides:k,restricted:C,hasExcludedProperties:p}=this.doParseRaw(s,n);this._configurationModel=new _(r,l,k,p?[s]:void 0),this._restrictedConfigurations=C||[]}doParseContent(s){let n={},r=null,l=[];const k=[],C=[];function p(b){Array.isArray(l)?l.push(b):r!==null&&(l[r]=b)}const m={onObjectBegin:()=>{const b={};p(b),k.push(l),l=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{l=k.pop()},onArrayBegin:()=>{const b=[];p(b),k.push(l),l=b,r=null},onArrayEnd:()=>{l=k.pop()},onLiteralValue:p,onError:(b,D,M)=>{C.push({error:b,offset:D,length:M})}};if(s)try{f.visit(s,m),n=l[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return n}doParseRaw(s,n){const r=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),l=this.filter(s,r,!0,n);s=l.raw;const k=(0,R.toValuesTree)(s,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),C=Object.keys(s),p=this.toOverrides(s,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:k,keys:C,overrides:p,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(s,n,r,l){let k=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:k};const C={},p=[];for(const m in s)if(P.OVERRIDE_PROPERTY_REGEX.test(m)&&r){const b=this.filter(s[m],n,!1,l);C[m]=b.raw,k=k||b.hasExcludedProperties,p.push(...b.restricted)}else{const b=n[m],D=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&p.push(m),!l.exclude?.includes(m)&&(l.include?.includes(m)||(D===void 0||l.scopes===void 0||l.scopes.includes(D))&&!(l.skipRestricted&&b?.restricted))?C[m]=s[m]:k=!0}return{raw:C,restricted:p,hasExcludedProperties:k}}toOverrides(s,n){const r=[];for(const l of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(l)){const k={};for(const C in s[l])k[C]=s[l][C];r.push({identifiers:(0,P.overrideIdentifiersFromKey)(l),keys:Object.keys(k),contents:(0,R.toValuesTree)(k,n)})}return r}}e.ConfigurationModelParser=w;class d extends A.Disposable{constructor(s,n,r,l){super(),this.userSettingsResource=s,this.parseOptions=n,this.fileService=l,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,k=>k.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&r.isEqual(k.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class o{constructor(s,n,r,l,k,C,p,m,b,D,M,L,F){this.key=s,this.overrides=n,this._value=r,this.overrideIdentifiers=l,this.defaultConfiguration=k,this.policyConfiguration=C,this.applicationConfiguration=p,this.userConfiguration=m,this.localUserConfiguration=b,this.remoteUserConfiguration=D,this.workspaceConfiguration=M,this.folderConfigurationModel=L,this.memoryConfigurationModel=F}get value(){return S(this._value)}inspect(s,n,r){const l=s.inspect(n,r);return{get value(){return S(l.value)},get override(){return S(l.override)},get merged(){return S(l.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(s,n,r,l,k=new _,C=new _,p=new T.ResourceMap,m=new _,b=new T.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=n,this._applicationConfiguration=r,this._localUserConfiguration=l,this._remoteUserConfiguration=k,this._workspaceConfiguration=C,this._folderConfigurations=p,this._memoryConfiguration=m,this._memoryConfigurationByResource=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(s,n,r){return this.getConsolidatedConfigurationModel(s,n,r).getValue(s)}updateValue(s,n,r={}){let l;r.resource?(l=this._memoryConfigurationByResource.get(r.resource),l||(l=new _,this._memoryConfigurationByResource.set(r.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(s):l.setValue(s,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,n,r){const l=this.getConsolidatedConfigurationModel(s,n,r),k=this.getFolderConfigurationModelForResource(n.resource,r),C=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,p=new Set;for(const m of l.overrides)for(const b of m.identifiers)l.getOverrideValue(s,b)!==void 0&&p.add(b);return new o(s,n,l.getValue(s),p.size?[...p]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,k||void 0,C)}keys(s){const n=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,n){this._folderConfigurations.set(s,n),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const r=[];if(!n){const{added:l,updated:k,removed:C}=a(this._defaultConfiguration,s);n=[...l,...k,...C]}for(const l of n)for(const k of(0,P.overrideIdentifiersFromKey)(l)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(k),p=s.getKeysForOverrideIdentifier(k),m=[...p.filter(b=>C.indexOf(b)===-1),...C.filter(b=>p.indexOf(b)===-1),...C.filter(b=>!g.equals(this._defaultConfiguration.override(k).getValue(b),s.override(k).getValue(b)))];r.push([k,m])}return this.updateDefaultConfiguration(s),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:r,removed:l}=a(this._policyConfiguration,s),k=[...n,...r,...l];return k.length&&this.updatePolicyConfiguration(s),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:r,removed:l,overrides:k}=a(this.applicationConfiguration,s),C=[...n,...r,...l];return C.length&&this.updateApplicationConfiguration(s),{keys:C,overrides:k}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:r,removed:l,overrides:k}=a(this.localUserConfiguration,s),C=[...n,...r,...l];return C.length&&this.updateLocalUserConfiguration(s),{keys:C,overrides:k}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:r,removed:l,overrides:k}=a(this.remoteUserConfiguration,s),C=[...n,...r,...l];return C.length&&this.updateRemoteUserConfiguration(s),{keys:C,overrides:k}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:r,removed:l,overrides:k}=a(this.workspaceConfiguration,s),C=[...n,...r,...l];return C.length&&this.updateWorkspaceConfiguration(s),{keys:C,overrides:k}}compareAndUpdateFolderConfiguration(s,n){const r=this.folderConfigurations.get(s),{added:l,updated:k,removed:C,overrides:p}=a(r,n),m=[...l,...k,...C];return(m.length||!r)&&this.updateFolderConfiguration(s,n),{keys:m,overrides:p}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:l,removed:k,overrides:C}=a(n,void 0);return{keys:[...r,...l,...k],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,n,r){let l=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:s},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&s){const l=n.getFolder(s);l&&(r=this.getFolderConsolidatedConfiguration(l.uri)||r);const k=this._memoryConfigurationByResource.get(s);k&&(r=r.merge(k))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let n=this._foldersConsolidatedConfigurations.get(s);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(s);l?(n=r.merge(l),this._foldersConsolidatedConfigurations.set(s,n)):n=r}return n}getFolderConfigurationModelForResource(s,n){if(n&&s){const r=n.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,n)=>{const{contents:r,overrides:l,keys:k}=this._folderConfigurations.get(n);return s.push([n,{contents:r,overrides:l,keys:k}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this._workspaceConfiguration.keys.forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(l=>n.add(l))),[...n.values()]}static parse(s){const n=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.policy),l=this.parseConfigurationModel(s.application),k=this.parseConfigurationModel(s.user),C=this.parseConfigurationModel(s.workspace),p=s.folders.reduce((m,b)=>(m.set(v.URI.revive(b[0]),this.parseConfigurationModel(b[1])),m),new T.ResourceMap);return new u(n,r,l,k,new _,C,p,new _,new T.ResourceMap)}static parseConfigurationModel(s){return new _(s.contents,s.keys,s.overrides)}}e.Configuration=u;function c(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,n=new Map;for(const l of i)l.keys.forEach(k=>s.add(k)),l.overrides.forEach(([k,C])=>{const p=(0,T.getOrSet)(n,k,new Set);C.forEach(m=>p.add(m))});const r=[];return n.forEach((l,k)=>r.push([k,[...l.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=c;class h{constructor(s,n,r,l){this.change=s,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=l,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const k of s.keys)this.affectedKeys.add(k);for(const[,k]of s.overrides)for(const C of k)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const k of this.affectedKeys)this._affectsConfigStr+=k+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,n){const r=this._marker+s,l=this._affectsConfigStr.indexOf(r);if(l<0)return!1;const k=l+r.length;if(k>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(k);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(n){const p=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.previous?.workspace):void 0,m=this.currentConfiguraiton.getValue(s,n,this.currentWorkspace);return!g.equals(p,m)}return!0}}e.ConfigurationChangeEvent=h;function a(i,s){const{added:n,removed:r,updated:l}=t(s?.rawConfiguration,i?.rawConfiguration),k=[],C=i?.getAllOverrideIdentifiers()||[],p=s?.getAllOverrideIdentifiers()||[];if(s){const m=p.filter(b=>!C.includes(b));for(const b of m)k.push([b,s.getKeysForOverrideIdentifier(b)])}if(i){const m=C.filter(b=>!p.includes(b));for(const b of m)k.push([b,i.getKeysForOverrideIdentifier(b)])}if(s&&i){for(const m of C)if(p.includes(m)){const b=t({contents:i.getOverrideValue(void 0,m)||{},keys:i.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});k.push([m,[...b.added,...b.removed,...b.updated]])}}return{added:n,removed:r,updated:l,overrides:k}}function t(i,s){const n=i?s?i.keys.filter(k=>s.keys.indexOf(k)===-1):[...i.keys]:[],r=s?i?s.keys.filter(k=>i.keys.indexOf(k)===-1):[...s.keys]:[],l=[];if(i&&s){for(const k of s.keys)if(i.keys.indexOf(k)!==-1){const C=(0,R.getConfigurationValue)(s.contents,k),p=(0,R.getConfigurationValue)(i.contents,k);g.equals(C,p)||l.push(k)}}return{added:n,removed:r,updated:l}}}),define(De[247],Ie([1,0,22,4,3,82]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const T=(v,R,P)=>{const E=new Uint8Array(16);for(let w=0;w<16;w++)E[w]=Math.round(Math.random()*256);const S=(0,I.encodeBase64)(I.VSBuffer.wrap(E));return[`GET ws://localhost${v}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=T,e.socketRawEndHeaderSequence=I.VSBuffer.fromString(`\r
\r
`);async function g(v,R,P,E,S){v.write(I.VSBuffer.fromString((0,e.makeRawSocketHeaders)(R,P,E)));const _=new f.DisposableStore;try{return await new Promise((w,d)=>{let o;_.add(v.onData(u=>{o?o=I.VSBuffer.concat([o,u],o.byteLength+u.byteLength):o=u;const c=o.indexOf(e.socketRawEndHeaderSequence);if(c===-1)return;w(v),v.pauseData();const h=o.slice(c+e.socketRawEndHeaderSequence.byteLength);h.byteLength&&S.onData.fire(h)})),_.add(v.onClose(u=>d(u??new Error("socket closed")))),_.add(v.onEnd(()=>d(new Error("socket ended"))))})}catch(w){throw v.dispose(),w}finally{_.dispose()}}e.connectManagedSocket=g;class y extends f.Disposable{constructor(R,P){super(),this.debugLabel=R,this.pausableDataEmitter=this._register(new O.PauseableEmitter),this.onData=(...E)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...E)),this.didDisposeEmitter=this._register(new O.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(P.onData),this._register(P.onData.event(E=>this.pausableDataEmitter.fire(E))),this.onClose=this._register(P.onClose).event,this.onEnd=this._register(P.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(R,P){A.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,R,P)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=y}),define(De[65],Ie([1,0,9,5]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var f;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class A{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class T{constructor(P,E){this.host=P,this.port=E,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var g;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class y extends I.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof y&&P._code===g.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof y&&P._code===g.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof y&&P._code===g.NoResolverFound}static isInvalidAuthority(P){return P instanceof y&&P._code===g.InvalidAuthority}static isHandled(P){return P instanceof y&&P.isHandled}constructor(P,E=g.Unknown,S){super(P),this._message=P,this._code=E,this._detail=S,this.isHandled=E===g.NotAvailable&&S===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function v(R){const P=R.indexOf("+");return P===-1?R:R.substring(0,P)}e.getRemoteAuthorityPrefix=v}),define(De[66],Ie([1,0,18]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(v){return v.scheme===I.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=O;function f(v){if(!v)return;const R=v.indexOf("+");return R<0?v:v.substr(0,R)}e.getRemoteName=f;function A(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(v){const{host:R,port:P}=y(v);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:P}}e.parseAuthorityWithPort=T;function g(v,R){let{host:P,port:E}=y(v);return typeof E>"u"&&(E=R),{host:P,port:E}}e.parseAuthorityWithOptionalPort=g;function y(v){const R=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const P=v.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=v.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:v,port:void 0}}}),define(De[25],Ie([1,0,15,5,66]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T||(e.ExtensionType=T={}));var g;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.LINUX_PPC64LE="linux-ppc64le",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class y{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,o){if(typeof d>"u"||d===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof d=="string"||typeof o=="string"){const u=typeof d=="string"?d:d.value,c=typeof o=="string"?o:o.value;return I.equalsIgnoreCase(u,c)}return d._lower===o._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=y;class v{get size(){return this._set.size}constructor(d){if(this._set=new Set,d)for(const o of d)this.add(o)}add(d){this._set.add(y.toKey(d))}delete(d){return this._set.delete(y.toKey(d))}has(d){return this._set.has(y.toKey(d))}}e.ExtensionIdentifierSet=v;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(d){this._map.delete(y.toKey(d))}get(d){return this._map.get(y.toKey(d))}has(d){return this._map.has(y.toKey(d))}set(d,o){this._map.set(y.toKey(d),o)}values(){return this._map.values()}forEach(d){this._map.forEach(d)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function P(w){return E(w)}e.isApplicationScopedExtension=P;function E(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function S(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function _(w,d){if(d){const o=`onResolveRemoteAuthority:${(0,f.getRemoteName)(d)}`;return!!w.activationEvents?.includes(o)}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[137],Ie([1,0,9,25]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class f{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,g){this._generators.set(T,g)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const g=Object.create(null);for(const y of T){const v=this.readActivationEvents(y);v.length>0&&(g[O.ExtensionIdentifier.toKey(y.identifier)]=v)}return g}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const g=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return g;for(const y in T.contributes){const v=this._generators.get(y);if(!v)continue;const R=T.contributes[y],P=Array.isArray(R)?R:[R];try{v(P,g)}catch(E){(0,I.onUnexpectedError)(E)}}return g}}e.ImplicitActivationEventsImpl=f,e.ImplicitActivationEvents=new f}),define(De[248],Ie([1,0,8,22,21,9,4,3,54,35,31,82,65,66]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const _=30*1e3;var w;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function d(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(j){const $=new f.CancellationTokenSource;return setTimeout(()=>$.cancel(),j),$.token}function u(j,$){if(j.isCancellationRequested||$.isCancellationRequested)return f.CancellationToken.Cancelled;const X=new f.CancellationTokenSource;return j.onCancellationRequested(()=>X.cancel()),$.onCancellationRequested(()=>X.cancel()),X.token}class c{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new g.DisposableStore,this.promise=new Promise((X,re)=>{this._resolvePromise=X,this._rejectPromise=re}),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function h(j,$){const X=new c($);return X.registerDisposable(j.onControlMessage(re=>{const Q=JSON.parse(re.toString()),Z=q(Q);Z?X.reject(Z):X.resolve(Q)})),X.promise}function a(j,$,X,re,Q,Z,J,be){const ae=new c(be),fe=v.StopWatch.create(!1);return j.info(`Creating a socket (${J})...`),y.mark(`code/willCreateSocket/${Z}`),$.connect(X,re,Q,J).then(ee=>{ae.didTimeout?(y.mark(`code/didCreateSocketError/${Z}`),j.info(`Creating a socket (${J}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(y.mark(`code/didCreateSocketOK/${Z}`),j.info(`Creating a socket (${J}) was successful after ${fe.elapsed()} ms.`),ae.resolve(ee))},ee=>{y.mark(`code/didCreateSocketError/${Z}`),j.info(`Creating a socket (${J}) returned an error after ${fe.elapsed()} ms.`),j.error(ee),ae.reject(ee)}),ae.promise}function t(j,$){const X=new c($);return j.then(re=>{X.didTimeout||X.resolve(re)},re=>{X.didTimeout||X.reject(re)}),X.promise}async function i(j,$,X,re){const Q=ce(j,$);j.logService.trace(`${Q} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await a(j.logService,j.remoteSocketFactoryService,j.connectTo,(0,S.getRemoteServerRootPath)(j),`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,d($),`renderer-${d($)}-${j.reconnectionToken}`,re)}catch(ee){throw j.logService.error(`${Q} socketFactory.connect() failed or timed out. Error:`),j.logService.error(ee),ee}j.logService.trace(`${Q} 2/6. socketFactory.connect() was successful.`);let J,be;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(Z,null),J=j.reconnectionProtocol,be=!1):(J=new P.PersistentProtocol({socket:Z}),be=!0),j.logService.trace(`${Q} 3/6. sending AuthRequest control message.`);const ae=await t(j.signService.createNewMessage((0,R.generateUuid)()),re),fe={type:"auth",auth:j.connectionToken||"00000000000000000000",data:ae.data};J.sendControl(O.VSBuffer.fromString(JSON.stringify(fe)));try{const ee=await h(J,u(re,o(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(j.logService.trace(`${Q} 4/6. received SignRequest control message.`),!await t(j.signService.validate(ae,ee.signedData),re)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const ve=await t(j.signService.sign(ee.data),re),Pe={type:"connectionType",commit:j.commit,signedData:ve,desiredConnectionType:$};return X&&(Pe.args=X),j.logService.trace(`${Q} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(O.VSBuffer.fromString(JSON.stringify(Pe))),{protocol:J,ownsProtocol:be}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(j.logService.error(`${Q} the handshake timed out. Error:`),j.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${Q} received error control message when negotiating connection. Error:`),j.logService.error(ee)),be&&te(J),ee}}async function s(j,$,X,re){const Q=Date.now(),Z=ce(j,$),{protocol:J,ownsProtocol:be}=await i(j,$,X,re),ae=new c(re);return ae.registerDisposable(J.onControlMessage(fe=>{const ee=JSON.parse(fe.toString()),he=q(ee);he?(j.logService.error(`${Z} received error control message when negotiating connection. Error:`),j.logService.error(he),be&&te(J),ae.reject(he)):(j.reconnectionProtocol?.endAcceptReconnection(),j.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${Se(Q)}!`),ae.resolve({protocol:J,firstMessage:ee}))})),ae.promise}async function n(j,$){const{protocol:X}=await s(j,1,void 0,$);return{protocol:X}}async function r(j,$,X){const{protocol:re,firstMessage:Q}=await s(j,2,$,X),Z=Q&&Q.debugPort;return{protocol:re,debugPort:Z}}async function l(j,$,X){const re=Date.now(),Q=ce(j,3),{protocol:Z}=await i(j,3,$,X);return j.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${Se(re)}!`),Z}async function k(j,$,X){const{connectTo:re,connectionToken:Q}=await j.addressProvider.getAddress();return{commit:j.commit,quality:j.quality,connectTo:re,connectionToken:Q,reconnectionToken:$,reconnectionProtocol:X,remoteSocketFactoryService:j.remoteSocketFactoryService,signService:j.signService,logService:j.logService}}async function C(j,$,X){return m(j,async re=>{const{protocol:Q}=await n(re,f.CancellationToken.None);return new V(j,$,X,re.reconnectionToken,Q)})}e.connectRemoteAgentManagement=C;async function p(j,$){return m(j,async X=>{const{protocol:re,debugPort:Q}=await r(X,$,f.CancellationToken.None);return new ge(j,$,X.reconnectionToken,re,Q)})}e.connectRemoteAgentExtensionHost=p;async function m(j,$){for(let re=1;;re++)try{const Q=(0,R.generateUuid)(),Z=await k(j,Q,null);return await $(Z)}catch(Q){if(re<5)j.logService.error(`[remote-connection][attempt ${re}] An error occurred in initial connection! Will retry... Error:`),j.logService.error(Q);else throw j.logService.error(`[remote-connection][attempt ${re}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),j.logService.error(Q),z.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(Q)),Q}}async function b(j,$,X){const re=await k(j,(0,R.generateUuid)(),null);return await l(re,{host:$,port:X},f.CancellationToken.None)}e.connectRemoteAgentTunnel=b;function D(j){return(0,I.createCancelablePromise)($=>new Promise((X,re)=>{const Q=setTimeout(X,j*1e3);$.onCancellationRequested(()=>{clearTimeout(Q),X()})}))}var M;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class L{constructor($,X){this.reconnectionToken=$,this.millisSinceLastIncomingData=X,this.type=0}}e.ConnectionLostEvent=L;class F{constructor($,X,re,Q){this.reconnectionToken=$,this.millisSinceLastIncomingData=X,this.durationSeconds=re,this.cancellableTimer=Q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class x{constructor($,X,re){this.reconnectionToken=$,this.millisSinceLastIncomingData=X,this.attempt=re,this.type=2}}e.ReconnectionRunningEvent=x;class U{constructor($,X,re){this.reconnectionToken=$,this.millisSinceLastIncomingData=X,this.attempt=re,this.type=4}}e.ConnectionGainEvent=U;class N{constructor($,X,re,Q){this.reconnectionToken=$,this.millisSinceLastIncomingData=X,this.attempt=re,this.handled=Q,this.type=3}}e.ReconnectionPermanentFailureEvent=N;class z extends g.Disposable{static triggerPermanentFailure($,X,re){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=X,this._permanentFailureHandled=re,this._instances.forEach(Q=>Q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||z._permanentFailure}constructor($,X,re,Q,Z){super(),this._connectionType=$,this._options=X,this.reconnectionToken=re,this.protocol=Q,this._reconnectionFailureIsFatal=Z,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new U(this.reconnectionToken,0,0)),this._register(Q.onSocketClose(J=>{const be=ie(this._connectionType,this.reconnectionToken,!0);J?J.type===0?(this._options.logService.info(`${be} received socket close event (hadError: ${J.hadError}).`),J.error&&this._options.logService.error(J.error)):(this._options.logService.info(`${be} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this._options.logService.error(J.event)):this._options.logService.info(`${be} received socket close event.`),this._beginReconnecting()})),this._register(Q.onSocketTimeout(J=>{const be=ie(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${be} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),z._instances.push(this),this._register((0,g.toDisposable)(()=>{const J=z._instances.indexOf(this);J>=0&&z._instances.splice(J,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(z._permanentFailureMillisSinceLastIncomingData,z._permanentFailureAttempt,z._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const $=ie(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const X=[0,5,5,10,10,10,10,10,30];let re=-1;do{re++;const Q=re<X.length?X[re]:X[X.length-1];try{if(Q>0){const J=D(Q);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q,J)),this._options.logService.info(`${$} waiting for ${Q} seconds before reconnecting...`);try{await J}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1)),this._options.logService.info(`${$} resolving connection...`);const Z=await k(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${Z.connectTo}...`),await this._reconnect(Z,o(_)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(re>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,A.isCancellationError)(Z)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),re+1,E.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure($,X,re){this._reconnectionFailureIsFatal?z.triggerPermanentFailure($,X,re):this._gotoPermanentFailure($,X,re)}_gotoPermanentFailure($,X,re){this._onDidStateChange.fire(new N(this.reconnectionToken,$,X,re)),te(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=z;class V extends z{constructor($,X,re,Q,Z){super(1,$,Q,Z,!0),this.client=this._register(new P.Client(Z,{remoteAuthority:X,clientId:re},$.ipcLogger))}async _reconnect($,X){await n($,X)}}e.ManagementPersistentConnection=V;class ge extends z{constructor($,X,re,Q,Z){super(2,$,re,Q,!1),this._startArguments=X,this.debugPort=Z}async _reconnect($,X){await r($,this._startArguments,X)}}e.ExtensionHostPersistentConnection=ge;function te(j){try{j.acceptDisconnect();const $=j.getSocket();j.dispose(),$.dispose()}catch($){(0,A.onUnexpectedError)($)}}function q(j){if(j&&j.type==="error"){const $=new Error(`Connection error: ${j.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function K(j,$){for(;j.length<$;)j+=" ";return j}function ue(j,$){return`[remote-connection][${K(d(j),13)}][${$.substr(0,5)}\u2026]`}function ie(j,$,X){return`${ue(j,$)}[${X?"reconnect":"initial"}]`}function ce(j,$){return`${ie($,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.connectTo}]`}function Se(j){return`${Date.now()-j} ms`}}),define(De[249],Ie([1,0,3,5]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,O.createDecorator)("remoteSocketFactoryService");class f{constructor(){this.factories={}}register(T,g){return this.factories[T]??=[],this.factories[T].push(g),(0,I.toDisposable)(()=>{const y=this.factories[T]?.indexOf(g);typeof y=="number"&&y>=0&&this.factories[T]?.splice(y,1)})}getSocketFactory(T){return(this.factories[T.type]||[]).find(y=>y.supports(T))}connect(T,g,y,v){const R=this.getSocketFactory(T);if(!R)throw new Error(`No socket factory found for ${T}`);return R.connect(T,g,y,v)}}e.RemoteSocketFactoryService=f}),define(De[250],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class I{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(f){try{const A=await this.getValidator();if(A){const T=String(I._nextId++);return this.validators.set(T,A),{id:T,data:A.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,A){if(!f.id)return!0;const T=this.validators.get(f.id);if(!T)return!1;this.validators.delete(f.id);try{return T.validate(A)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(f){try{return await this.signValue(f)}catch{}return f}}e.AbstractSignService=I}),define(De[106],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(De[138],Ie([1,0,250]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O extends I.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(T=>new T.signer().sign(A))}vsda(){return new Promise((A,T)=>pe(["vsda"],A,T))}}e.SignService=O}),define(De[251],Ie([1,0,12,48,31]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(y){if(I.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function T(y,v,R,P,E,S,_,w,d){const o=Object.create(null);o["common.machineId"]=S,o["common.sqmId"]=_,o.sessionID=(0,f.generateUuid)()+Date.now(),o.commitHash=P,o.version=E,o["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,I.PlatformToString)(I.platform),o["common.nodePlatform"]=O.platform,o["common.nodeArch"]=R,o["common.product"]=d||"desktop",w&&(o["common.msftInternal"]=w);let u=0;const c=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),I.isLinuxSnap&&(o["common.snap"]="true");const h=A(v);return h&&(o["common.platformDetail"]=h),o}e.resolveCommonProperties=T;function g(y){const v=O.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return y.some(P=>R===P)}e.verifyMicrosoftInternalDomain=g}),define(De[252],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var f;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(De[85],Ie([1,0,24,17,4,50,66,251,252]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class v{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=v;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class P{async publicLog(r,l,k){}async publicLogError(r,l,k){}}e.NullEndpointTelemetryService=P,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(n,r){return f.Event.debounce(r.onDidChangeConfiguration,(k,C)=>{const p=k?new Set([...k.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:p}},1e3,!0)(k=>{k.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.configurationTelemetry=E;function S(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}e.supportsTelemetry=S;function _(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=_;function w(n){const r=n.getValue(y.TELEMETRY_SETTING_ID),l=n.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function d(n){const r={},l={},k={};c(n,k);for(let C in k){C=C.length>150?C.substr(C.length-149):C;const p=k[C];typeof p=="number"?l[C]=p:typeof p=="boolean"?l[C]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${p.length}`),r[C]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(r[C]=p)}return{properties:r,measurements:l}}e.validateTelemetryData=d;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(n){if(!n)return"none";const r=(0,T.getRemoteName)(n);return o.has(r)?r:"other"}e.cleanRemoteAuthority=u;function c(n,r,l=0,k){if(n)for(const C of Object.getOwnPropertyNames(n)){const p=n[C],m=k?k+C:C;Array.isArray(p)?r[m]=(0,I.safeStringify)(p):p instanceof Date?r[m]=p.toISOString():(0,O.isObject)(p)?l<2?c(p,r,l+1,m+"."):r[m]=(0,I.safeStringify)(p):r[m]=p}}function h(n,r){const l=n.msftInternalDomains||[],k=r.getValue("telemetry.internalTesting");return(0,g.verifyMicrosoftInternalDomain)(l)||k}e.isInternalTelemetry=h;function a(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=a;function t(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let l=n;const k=[];for(const b of r)for(;;){const D=b.exec(n);if(!D)break;k.push([D.index,b.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(l="";;){const b=p.exec(n);if(!b)break;const D=k.some(([M,L])=>b.index<L&&M<p.lastIndex);!C.test(b[0])&&!D&&(l+=n.substring(m,b.index)+"<REDACTED: user-file-path>",m=p.lastIndex)}return m<n.length&&(l+=n.substr(m)),l}function i(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of r)if(l.regex.test(n))return`<REDACTED: ${l.label}>`;return n}function s(n,r){return(0,I.cloneAndChange)(n,l=>{if(l instanceof v||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let k=l.replaceAll("%20"," ");k=t(k,r);for(const C of r)k=k.replace(C,"");return k=i(k),k}})}e.cleanData=s}),define(De[253],Ie([1,0,15,132,25,12,2,9,48,85]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,I.compareIgnoreCase)(s.id,n.id)===0}e.areSameExtensions=R;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(n){const r=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new E(n.identifier,r,l)}static parse(n){const r=P.exec(n);return r&&r[1]&&r[2]?new E({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,l="undefined"){this.version=r,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof E?R(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=E;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function _(s){const n=S.exec(s);return n&&n[1]?[d(n[1]),n[2]]:[d(s),void 0]}e.getIdAndVersion=_;function w(s,n){return`${s}.${n}`}e.getExtensionId=w;function d(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=d;function o(s,n){return d(w(s??f.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=o;function u(s,n){const r=[],l=k=>{for(const C of r)if(C.some(p=>R(n(p),n(k))))return C;return null};for(const k of s){const C=l(k);C?C.push(k):r.push([k])}return r}e.groupByExtension=u;function c(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=c;function h(s){return{id:new v.TelemetryTrustedValue(s.identifier.id),name:new v.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new f.ExtensionIdentifier("pprice.better-merge");function a(s,n){const r=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const k=l.shift();if(k&&r.every(C=>!R(C.identifier,{id:k}))){const C=s.filter(p=>R(p.identifier,{id:k}));C.length===1&&(r.push(C[0]),l.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=a;async function t(s,n){if(!A.isLinux)return!1;let r;try{r=(await s.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){n.debug("Error while getting the os-release file.",(0,g.getErrorMessage)(k))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(s,n){const r=await t(s,n),l=(0,O.getTargetPlatform)(r?"alpine":A.platform,y.arch);return n.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=i}),define(De[254],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function I(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=I;function O(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=O;function f(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=f;function A(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=A;function T(y){return Array.from(y.entries()).map(v=>[v[0],I(v[1].map),O(v[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function g(y){return new Map(y.map(v=>[v[0],{map:f(v[1]),descriptionMap:A(v[2])}]))}e.deserializeEnvironmentVariableCollections=g}),define(De[255],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class I{constructor(f){this._callback=f,this._terminalBufferMap=new Map}dispose(){for(const f of this._terminalBufferMap.values())f.dispose()}startBuffering(f,A,T=5){const g=A(y=>{const v=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(f);if(R){R.data.push(v);return}const P=setTimeout(()=>this.flushBuffer(f),T);R={data:[v],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(f),g.dispose()}},this._terminalBufferMap.set(f,R)});return g}stopBuffering(f){this._terminalBufferMap.get(f)?.dispose()}flushBuffer(f){const A=this._terminalBufferMap.get(f);A&&(this._terminalBufferMap.delete(f),this._callback(f,A.data.join("")))}}e.TerminalDataBufferer=I}),define(De[256],Ie([1,0,8,79,59,4,17,2,199,105,43]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var P;(function(h){function a(t,i){let s=t.defaults;for(;f.ThemeIcon.isThemeIcon(s);){const n=_.getIcon(s.id);if(!n)return;s=n.defaults}return s}h.getDefinition=a})(P||(e.IconContribution=P={}));var E;(function(h){function a(i){return{weight:i.weight,style:i.style,src:i.src.map(s=>({format:s.format,location:s.location.toString()}))}}h.toJSONObject=a;function t(i){const s=n=>(0,T.isString)(n)?n:void 0;if(i&&Array.isArray(i.src)&&i.src.every(n=>(0,T.isString)(n.format)&&(0,T.isString)(n.location)))return{weight:s(i.weight),style:s(i.style),src:i.src.map(n=>({format:n.format,location:g.URI.parse(n.location)}))}}h.fromJSONObject=t})(E||(e.IconFontDefinition=E={}));class S{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(a,t,i,s){const n=this.iconsById[a];if(n){if(i&&!n.description){n.description=i,this.iconSchema.properties[a].markdownDescription=`${i} $(${a})`;const k=this.iconReferenceSchema.enum.indexOf(a);k!==-1&&(this.iconReferenceSchema.enumDescriptions[k]=i),this._onDidChange.fire()}return n}const r={id:a,description:i,defaults:t,deprecationMessage:s};this.iconsById[a]=r;const l={$ref:"#/definitions/icons"};return s&&(l.deprecationMessage=s),i&&(l.markdownDescription=`${i}: $(${a})`),this.iconSchema.properties[a]=l,this.iconReferenceSchema.enum.push(a),this.iconReferenceSchema.enumDescriptions.push(i||""),this._onDidChange.fire(),{id:a}}deregisterIcon(a){delete this.iconsById[a],delete this.iconSchema.properties[a];const t=this.iconReferenceSchema.enum.indexOf(a);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(a=>this.iconsById[a])}getIcon(a){return this.iconsById[a]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(a,t){const i=this.iconFontsById[a];return i||(this.iconFontsById[a]=t,this._onDidChange.fire(),t)}deregisterIconFont(a){delete this.iconFontsById[a]}getIconFont(a){return this.iconFontsById[a]}toString(){const a=(n,r)=>n.id.localeCompare(r.id),t=n=>{for(;f.ThemeIcon.isThemeIcon(n.defaults);)n=this.iconsById[n.defaults.id];return`codicon codicon-${n?n.id:""}`},i=[];i.push("| preview     | identifier                        | default codicon ID                | description"),i.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(n=>this.iconsById[n]);for(const n of s.filter(r=>!!r.description).sort(a))i.push(`|<i class="${t(n)}"></i>|${n.id}|${f.ThemeIcon.isThemeIcon(n.defaults)?n.defaults.id:n.id}|${n.description||""}|`);i.push("| preview     | identifier                        "),i.push("| ----------- | --------------------------------- |");for(const n of s.filter(r=>!f.ThemeIcon.isThemeIcon(r.defaults)).sort(a))i.push(`|<i class="${t(n)}"></i>|${n.id}|`);return i.join(`
`)}}const _=new S;R.Registry.add(e.Extensions.IconContribution,_);function w(h,a,t,i){return _.registerIcon(h,a,t,i)}e.registerIcon=w;function d(){return _}e.getIconRegistry=d;function o(){const h=(0,O.getCodiconFontCharacters)();for(const a in h){const t="\\"+h[a].toString(16);_.registerIcon(a,{fontCharacter:t})}}o(),e.iconsSchemaId="vscode://schemas/icons";const u=R.Registry.as(v.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,_.getIconSchema());const c=new I.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);_.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.widgetClose=w("widget-close",O.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=w("goto-previous-location",O.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=w("goto-next-location",O.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=f.ThemeIcon.modify(O.Codicon.sync,"spin"),e.spinningLoading=f.ThemeIcon.modify(O.Codicon.loading,"spin")}),define(De[86],Ie([1,0,4,50,5,14]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,f.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,f.createDecorator)("sharedTunnelsService");var T;(function(d){d.Http="http",d.Https="https"})(T||(e.TunnelProtocol=T={}));var g;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(g||(e.TunnelPrivacyId=g={}));function y(d){return!!d.forwardPort}e.isTunnelProvider=y;var v;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(v||(e.ProvidedOnAutoForward=v={}));function R(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=E;function S(d,o,u,c){if(u===1)return!1;if(u===2&&E(o)){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(h?.length===4&&parseInt(h[1])>=18)return!1}return d<1024}e.isPortPrivileged=S;class _{constructor(o,u,c){this.remoteAddress=o,this.localAddress=u,this._dispose=c,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=_;let w=class{constructor(o,u){this.logService=o,this.configurationService=u,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],u=Array.from(this._tunnels.values());for(const c of u){const h=Array.from(c.values());for(const a of h){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:u}of o.values())await u.then(c=>typeof c!="string"?c?.dispose():void 0);o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,u,c,h,a){this.addTunnelToMap(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:c,privacy:h,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(E(o)||P(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const c=this.getTunnelFromMap(o,u);if(c)return++c.refcount,c.value}openTunnel(o,u,c,h,a,t=!1,i,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${c} on local port ${a}.`);const n=this._tunnelProvider??o;if(!n)return;if(u||(u="localhost"),h||(h=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(n,u,c,h,a,t,i,s);return r?r.then(l=>{if(l){if(typeof l=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(u,c),l}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(u,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.makeTunnel(l);return(l.tunnelRemoteHost!==u||l.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&l.privacy!==i&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(k),k}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this._tunnels.get(o.tunnelRemoteHost);if(u){const c=u.get(o.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,c))}}}}async tryDisposeTunnel(o,u,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const h=c.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(u),h}}async closeTunnel(o,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const c=this._tunnels.get(o);if(c&&c.has(u)){const h=c.get(u);h.refcount=0,await this.tryDisposeTunnel(o,u,h)}}addTunnelToMap(o,u,c){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(u,{refcount:1,value:c})}async removeEmptyOrErrorTunnelFromMap(o,u){const c=this._tunnels.get(o);if(c){const h=c.get(u),a=h?await h.value:void 0;(!a||typeof a=="string")&&c.delete(u),c.size===0&&this._tunnels.delete(o)}}getTunnelFromMap(o,u){const c=[o];P(o)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):E(o)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const h=c.map(a=>this._tunnels.get(a));for(const a of h){const t=a?.get(u);if(t)return t}}canTunnel(o){return!!R(o)}createWithProvider(o,u,c,h,a,t,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${c} on local port ${h}.`);const s=c;this._factoryInProgress.add(s);const n=h===void 0?c:h,r={elevationRequired:a?this.isPortPrivileged(n):!1},l={remoteAddress:{host:u,port:c},localAddressPort:h,privacy:t,public:t?t!==g.Private:void 0,protocol:i},k=o.forwardPort(l,r);return k?(this.addTunnelToMap(u,c,k),k.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),k}};e.AbstractTunnelService=w,e.AbstractTunnelService=w=je([$e(0,A.ILogService),$e(1,O.IConfigurationService)],w)}),define(De[257],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(De[258],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,I.createDecorator)("editSessionIdentityService");var O;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(De[259],Ie([1,0,18]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function O(y){return y.scheme!==I.Schemas.file&&y.scheme!==I.Schemas.vscodeRemote}e.isVirtualResource=O;function f(y){if(y.folders.length)return y.folders.every(v=>O(v.uri))?y.folders[0].uri:void 0;if(y.configuration&&O(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=f;function A(y){return f(y)?.scheme}e.getVirtualWorkspaceScheme=A;function T(y){return f(y)?.authority}e.getVirtualWorkspaceAuthority=T;function g(y){return f(y)!==void 0}e.isVirtualWorkspace=g}),define(De[44],Ie([1,0,201,16,78,23,2,5,18]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,g.createDecorator)("contextService");function v(n){const r=n;return typeof r?.id=="string"&&T.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=v;function R(n){return typeof n?.id=="string"&&!v(n)&&!E(n)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=n;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=P;function E(n){const r=n;return typeof r?.id=="string"&&T.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=E;function S(n){const r=n;if(r?.uri)return{id:r.id,uri:T.URI.revive(r.uri)};const l=n;if(l?.configPath)return{id:l.id,configPath:T.URI.revive(l.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=S;var _;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(_||(e.WorkbenchState=_={}));function w(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=w;function d(n){const r=n;return!!(r&&typeof r=="object"&&T.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=d;class o{constructor(r,l,k,C,p){this._id=r,this._transient=k,this._configuration=C,this._ignorePathCasing=p,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class u{constructor(r,l){this.raw=l,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function c(n){return new u({uri:n,index:0,name:(0,A.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=c,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(n,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function a(n){let r;return T.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=a,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function i(n,r){return!h(n,r)&&!a(n)}e.isSavedWorkspace=i;function s(n){return(typeof n=="string"?(0,O.extname)(n):(0,A.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[260],Ie([1,0,52,4,3,23,2,200,131,30,5,14,44,28,257,8,31,15,17]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var c;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function h(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&T.URI.isUri(r.location)&&T.URI.isUri(r.globalStorageHome)&&T.URI.isUri(r.settingsResource)&&T.URI.isUri(r.keybindingsResource)&&T.URI.isUri(r.tasksResource)&&T.URI.isUri(r.snippetsHome)&&T.URI.isUri(r.extensionsResource))}e.isUserDataProfile=h,e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function a(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:T.URI.revive(n.location).with({scheme:r}),globalStorageHome:T.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:T.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:T.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:T.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:T.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:T.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:T.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=a;function t(n,r,l,k,C,p){return{id:n,name:r,location:l,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:p&&C?.useDefaultFlags?.globalState?p.globalStorageHome:(0,A.joinPath)(l,"globalStorage"),settingsResource:p&&C?.useDefaultFlags?.settings?p.settingsResource:(0,A.joinPath)(l,"settings.json"),keybindingsResource:p&&C?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,A.joinPath)(l,"keybindings.json"),tasksResource:p&&C?.useDefaultFlags?.tasks?p.tasksResource:(0,A.joinPath)(l,"tasks.json"),snippetsHome:p&&C?.useDefaultFlags?.snippets?p.snippetsHome:(0,A.joinPath)(l,"snippets"),extensionsResource:p&&C?.useDefaultFlags?.extensions?p.extensionsResource:(0,A.joinPath)(l,"extensions.json"),cacheHome:(0,A.joinPath)(k,n),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.toUserDataProfile=t;let i=class extends f.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,l,k,C){super(),this.environmentService=r,this.fileService=l,this.uriIdentityService=k,this.logService=C,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new S.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.createDefaultProfile(),l=[r];if(this.enabled)try{for(const p of this.getStoredProfiles()){if(!p.name||!(0,u.isString)(p.name)||!p.location){this.logService.warn("Skipping the invalid stored profile",p.location||p.name);continue}l.push(t((0,A.basename)(p.location),p.name,p.location,this.profilesCacheHome,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},r))}}catch(p){this.logService.error(p)}const k=new S.ResourceMap,C=new Map;if(l.length)try{const p=this.getStoredProfileAssociations();if(p.workspaces)for(const[m,b]of Object.entries(p.workspaces)){const D=T.URI.parse(m),M=l.find(L=>L.id===b);M&&k.set(D,M)}if(p.emptyWindows)for(const[m,b]of Object.entries(p.emptyWindows)){const D=l.find(M=>M.id===b);D&&C.set(m,D)}}catch(p){this.logService.error(p)}this._profilesObject={profiles:l,workspaces:k,emptyWindows:C}}return this._profilesObject}createDefaultProfile(){const r=t("__default__profile__",(0,g.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const l="Temp",k=new RegExp(`${(0,o.escapeRegExpCharacters)(l)}\\s(\\d+)`);let C=0;for(const m of this.profiles){const b=k.exec(m.name),D=b?parseInt(b[1]):0;C=D>C?D:C}const p=`${l} ${C+1}`;return this.createProfile((0,I.hash)((0,d.generateUuid)()).toString(16),p,{transient:!0},r)}async createNamedProfile(r,l,k){return this.createProfile((0,I.hash)((0,d.generateUuid)()).toString(16),r,l,k)}async createProfile(r,l,k,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const p=await this.doCreateProfile(r,l,k);return C&&await this.setProfileForWorkspace(C,p),p}async doCreateProfile(r,l,k){if(!(0,u.isString)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.profileCreationPromises.get(l);return C||(C=(async()=>{try{const p=this.profiles.find(D=>D.name===l||D.id===r);if(p)return p;const m=t(r,l,(0,A.joinPath)(this.profilesHome,r),this.profilesCacheHome,k,this.defaultProfile);await this.fileService.createFolder(m.location);const b=[];return this._onWillCreateProfile.fire({profile:m,join(D){b.push(D)}}),await w.Promises.settled(b),this.updateProfiles([m],[],[]),m}finally{this.profileCreationPromises.delete(l)}})(),this.profileCreationPromises.set(l,C)),C}async updateProfile(r,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(C=>C.id===r.id);if(!k)throw new Error(`Profile '${r.name}' does not exist`);return k=t(k.id,l.name??k.name,k.location,this.profilesCacheHome,{shortName:l.shortName??k.shortName,icon:l.icon===null?void 0:l.icon??k.icon,transient:l.transient??k.isTransient,useDefaultFlags:l.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[k]),k}async removeProfile(r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(C=>C.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);const k=[];this._onWillRemoveProfile.fire({profile:l,join(C){k.push(C)}});try{await Promise.allSettled(k)}catch(C){this.logService.error(C)}for(const C of[...this.profilesObject.emptyWindows.keys()])l.id===this.profilesObject.emptyWindows.get(C)?.id&&this.profilesObject.emptyWindows.delete(C);for(const C of[...this.profilesObject.workspaces.keys()])l.id===this.profilesObject.workspaces.get(C)?.id&&this.profilesObject.workspaces.delete(C);this.updateStoredProfileAssociations(),this.updateProfiles([],[l],[]);try{await this.fileService.del(l.cacheHome,{recursive:!0})}catch(C){(0,v.toFileOperationResult)(C)!==1&&this.logService.error(C)}}async setProfileForWorkspace(r,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(C=>C.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);this.updateWorkspaceAssociation(r,k)}unsetWorkspace(r,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(r,void 0,l)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(l=>l.isDirectory&&this.profiles.every(k=>!this.uriIdentityService.extUri.isEqual(k.location,l.resource))).map(l=>this.fileService.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(l=>!this.isProfileAssociatedToWorkspace(l));await Promise.allSettled(r.map(l=>this.removeProfile(l)))}getProfileForWorkspace(r){const l=this.getWorkspace(r);return T.URI.isUri(l)?this.transientProfilesObject.workspaces.get(l)??this.profilesObject.workspaces.get(l):this.transientProfilesObject.emptyWindows.get(l)??this.profilesObject.emptyWindows.get(l)}getWorkspace(r){return(0,E.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,E.isWorkspaceIdentifier)(r)?r.configPath:r.id}isProfileAssociatedToWorkspace(r){return!!([...this.transientProfilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,r.location))||[...this.transientProfilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,r.location))||[...this.profilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,r.location))||[...this.profilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,r.location)))}updateProfiles(r,l,k){const C=[...this.profiles,...r],p=[];this.transientProfilesObject.profiles=[];for(let m of C)m.isDefault||l.some(b=>m.id===b.id)||(m=k.find(b=>m.id===b.id)??m,m.isTransient?this.transientProfilesObject.profiles.push(m):p.push({location:m.location,name:m.name,shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags}));this.saveStoredProfiles(p),this._profilesObject=void 0,this.triggerProfilesChanges(r,l,k)}triggerProfilesChanges(r,l,k){this._onDidChangeProfiles.fire({added:r,removed:l,updated:k,all:this.profiles})}updateWorkspaceAssociation(r,l,k){k=l?.isTransient?!0:k,k||this.updateWorkspaceAssociation(r,void 0,!0);const C=this.getWorkspace(r),p=k?this.transientProfilesObject:this.profilesObject;T.URI.isUri(C)?(p.workspaces.delete(C),l&&p.workspaces.set(C,l)):(p.emptyWindows.delete(C),l&&p.emptyWindows.set(C,l)),k||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[k,C]of this.profilesObject.workspaces.entries())r[k.toString()]=C.id;const l={};for(const[k,C]of this.profilesObject.emptyWindows.entries())l[k.toString()]=C.id;this.saveStoredProfileAssociations({workspaces:r,emptyWindows:l}),this._profilesObject=void 0}migrateStoredProfileAssociations(r){const l={},k=this.createDefaultProfile();if(r.workspaces)for(const[p,m]of Object.entries(r.workspaces)){const b=T.URI.parse(m);l[p]=this.uriIdentityService.extUri.isEqual(b,k.location)?k.id:this.uriIdentityService.extUri.basename(b)}const C={};if(r.emptyWindows)for(const[p,m]of Object.entries(r.emptyWindows)){const b=T.URI.parse(m);C[p]=this.uriIdentityService.extUri.isEqual(b,k.location)?k.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:l,emptyWindows:C}}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=i,e.UserDataProfilesService=i=je([$e(0,y.IEnvironmentService),$e(1,v.IFileService),$e(2,_.IUriIdentityService),$e(3,P.ILogService)],i);class s extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=s}),define(De[261],Ie([1,0,8,4,3,54,17,184,5,260]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,y.createDecorator)("storageService");var R;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var P;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var E;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(E||(e.StorageTarget=E={}));function S(u){const c=u.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=S;class _ extends f.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(c={flushInterval:_.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new f.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(c,h,a){return O.Event.filter(this._onDidChangeValue.event,t=>t.scope===c&&(h===void 0||t.key===h),a)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,f.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,h){const{key:a,external:t}=h;if(a===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:a,target:this.getKeyTargets(c)[a],external:t})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,h,a){return this.getStorage(h)?.get(c,a)}getBoolean(c,h,a){return this.getStorage(h)?.getBoolean(c,a)}getNumber(c,h,a){return this.getStorage(h)?.getNumber(c,a)}getObject(c,h,a){return this.getStorage(h)?.getObject(c,a)}storeAll(c,h){this.withPausedEmitters(()=>{for(const a of c)this.store(a.key,a.value,a.scope,a.target,h)})}store(c,h,a,t,i=!1){if((0,T.isUndefinedOrNull)(h)){this.remove(c,a,i);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,a,t),this.getStorage(a)?.set(c,h,i)})}remove(c,h,a=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(c,h,void 0),this.getStorage(h)?.delete(c,a)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,h){const a=[],t=this.getKeyTargets(c);for(const i of Object.keys(t))t[i]===h&&a.push(i);return a}updateKeyTarget(c,h,a,t=!1){const i=this.getKeyTargets(h);typeof a=="number"?i[c]!==a&&(i[c]=a,this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(i),t)):typeof i[c]=="number"&&(delete i[c],this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(i),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const h=this.getStorage(c);return h?S(h):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=R.NONE){this._onWillSaveState.fire({reason:c});const h=this.getStorage(-1),a=this.getStorage(0),t=this.getStorage(1);switch(c){case R.NONE:await I.Promises.settled([h?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await I.Promises.settled([h?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return o(c,h,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(c){return await this.flush(),this.getStorage(c)?.optimize()}async switch(c,h){return this.emitWillSaveState(R.NONE),(0,v.isUserDataProfile)(c)?this.switchToProfile(c,h):this.switchToWorkspace(c,h)}canSwitchProfile(c,h){return!(c.id===h.id||w(h)&&w(c))}switchData(c,h,a){this.withPausedEmitters(()=>{const t=new Set;for(const[i,s]of c)t.add(i),h.get(i)!==s&&this.emitDidChangeValue(a,{key:i,external:!0});for(const[i]of h.items)t.has(i)||this.emitDidChangeValue(a,{key:i,external:!0})})}}e.AbstractStorageService=_;function w(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=w;class d extends _{constructor(){super(),this.applicationStorage=this._register(new g.Storage(new g.InMemoryStorageDatabase,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new g.Storage(new g.InMemoryStorageDatabase,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new g.Storage(new g.InMemoryStorageDatabase,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(c){return!1}}e.InMemoryStorageService=d;async function o(u,c,h,a,t,i){const s=D=>{try{return JSON.parse(D)}catch{return D}},n=new Map,r=new Map;u.forEach((D,M)=>{n.set(M,D),r.set(M,s(D))});const l=new Map,k=new Map;c.forEach((D,M)=>{l.set(M,D),k.set(M,s(D))});const C=new Map,p=new Map;h.forEach((D,M)=>{C.set(M,D),p.set(M,s(D))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const m=[];if(n.forEach((D,M)=>{m.push({key:M,value:D})}),console.table(m),console.groupEnd(),console.log(r),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];l.forEach((M,L)=>{D.push({key:L,value:M})}),console.table(D),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${i})`);const b=[];C.forEach((D,M)=>{b.push({key:M,value:D})}),console.table(b),console.groupEnd(),console.log(p)}e.logStorage=o}),define(De[107],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class I{static{this.enableDebugLogging=!1}constructor(f){this.id=f,this._data=new Map,this._idPool=1}add(f){const A=this._idPool++;return this._data.set(A,f),this.logDebugInfo(),A}get(f,A){return this._data.has(f)?this._data.get(f)[A]:void 0}delete(f){this._data.delete(f),this.logDebugInfo()}logDebugInfo(){I.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=I}),define(De[55],Ie([1,0,18,23,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(I.Schemas)),this._providerInfo=new Map,this.extUri=new O.ExtUri(g=>{const y=this._providerInfo.get(g.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(g,y){y===null?this._providerInfo.delete(g.scheme):this._providerInfo.set(g.scheme,y)}isFreeScheme(g){return!this._providerInfo.has(g)&&!this._systemSchemes.has(g)}getCapabilities(g){return this._providerInfo.get(g)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,f.createDecorator)("IExtHostFileSystemInfo")}),define(De[27],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,I.createDecorator)("IExtHostInitDataService")}),define(De[262],Ie([1,0,207,14,242,27]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends f.LogService{constructor(y,v,R){const P=R.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",E=R.remote.isRemote?(0,I.localize)(0,null):y?(0,I.localize)(1,null):(0,I.localize)(2,null);super(v.createLogger(P,{name:E}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=je([$e(1,O.ILoggerService),$e(2,A.IExtHostInitDataService)],T)}),define(De[263],Ie([1,0,8]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class O{constructor(T,g,y){this._deferredPromises=new Map,this._id=T,this._shared=g,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(v=>(this._value=v,this)),this._storageListener=this._storage.onDidChangeStorage(v=>{v.shared===this._shared&&v.key===this._id&&(this._value=v.value)}),this._scheduler=new I.RunOnceScheduler(()=>{const v=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of v.values())R.complete()}catch(R){for(const P of v.values())P.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,g){let y=this._value[T];return typeof y>"u"&&(y=g),y}update(T,g){this._value[T]=g;const y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const v=new I.DeferredPromise;return this._deferredPromises.set(T,v),this._scheduler.isScheduled()||this._scheduler.schedule(),v.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=O;class f extends O{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,g){super(T.identifier.value,!0,g),this._extension=T}}e.ExtensionGlobalMemento=f}),define(De[264],Ie([1,0,4,2]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class f{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new I.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,g,y,v){const P=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(T)).acceptModelChanged(g.value,y,v);this._onDidChangeNotebookDocument.fire(P)}$acceptDirtyStateChanged(T,g){this._notebooksAndEditors.getNotebookDocument(O.URI.revive(T)).acceptDirty(g)}$acceptModelSaved(T){const g=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(T));this._onDidSaveNotebookDocument.fire(g.apiNotebook)}}e.ExtHostNotebookDocuments=f}),define(De[20],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class O{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=O}),define(De[265],Ie([1,0,25,4]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class f{#e;constructor(T,g){this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._id=I.ExtensionIdentifier.toKey(T.identifier),this.#e=g,this.#e.onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(T){return this.#e.get(this._id,T)}store(T,g){return this.#e.store(this._id,T,g)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=f}),define(De[67],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,I.createDecorator)("IURITransformerService");class O{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=O}),define(De[266],Ie([1,0,22]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class O{constructor(){this.buffers=[]}add(y){let v=this.buffers.indexOf(y);return v<0&&(v=this.buffers.length,this.buffers.push(y)),v}}function f(g,y){if(y.serializeBuffersForPostMessage){const v=new O,P=JSON.stringify(g,(S,_)=>{if(_ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:v.add(_)};if(ArrayBuffer.isView(_)){const w=A(_);if(w)return{$$vscode_array_buffer_reference$$:!0,index:v.add(_.buffer),view:{type:w,byteLength:_.byteLength,byteOffset:_.byteOffset}}}return _}),E=v.buffers.map(S=>{const _=new Uint8Array(S);return I.VSBuffer.wrap(_)});return{message:P,buffers:E}}else return{message:JSON.stringify(g),buffers:[]}}e.serializeWebviewMessage=f;function A(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(g,y){const v=y.map(E=>{const S=new ArrayBuffer(E.byteLength);return new Uint8Array(S).set(E.buffer),S}),R=y.length?(E,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const _=S,{index:w}=_,d=v[w];if(_.view)switch(_.view.type){case 1:return new Int8Array(d,_.view.byteOffset,_.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,_.view.byteOffset,_.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,_.view.byteOffset,_.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,_.view.byteOffset,_.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,_.view.byteOffset,_.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,_.view.byteOffset,_.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,_.view.byteOffset,_.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,_.view.byteOffset,_.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,_.view.byteOffset,_.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,_.view.byteOffset,_.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,_.view.byteOffset,_.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return S}:void 0;return{message:JSON.parse(g,R),arrayBuffers:v}}e.deserializeWebviewMessage=T}),define(De[267],Ie([1,0,268,377,378,60,2,14,379]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;const v=!1;function R(c,h,a,t,i,s){const n=s.environment.useHostProxy,r=typeof n=="boolean"?n:!s.remote.isRemote,l={resolveProxy:p=>c.resolveProxy(p),lookupProxyAuthorization:d.bind(void 0,t,i,h,{},s.remote.isRemote),getProxyURL:()=>h.getConfiguration("http").get("proxy"),getProxySupport:()=>h.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>E(h),getSystemCertificatesV2:()=>S(h),log:(p,m,...b)=>{switch(p){case y.LogLevel.Trace:t.trace(m,...b);break;case y.LogLevel.Debug:t.debug(m,...b);break;case y.LogLevel.Info:t.info(m,...b);break;case y.LogLevel.Warning:t.warn(m,...b);break;case y.LogLevel.Error:t.error(m,...b);break;case y.LogLevel.Critical:t.error(m,...b);break;case y.LogLevel.Off:break;default:D(p,m,b);break}function D(M,L,...F){t.error("Unknown log level",M),t.error(L,...F)}},getLogLevel:()=>{const p=t.getLevel();switch(p){case g.LogLevel.Trace:return y.LogLevel.Trace;case g.LogLevel.Debug:return y.LogLevel.Debug;case g.LogLevel.Info:return y.LogLevel.Info;case g.LogLevel.Warning:return y.LogLevel.Warning;case g.LogLevel.Error:return y.LogLevel.Error;case g.LogLevel.Off:return y.LogLevel.Off;default:return m(p)}function m(b){return t.error("Unknown log level",b),y.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:r,addCertificates:[],env:process.env},k=(0,y.createProxyResolver)(l),C=P(l,k);return w(a,C)}e.connectProxyResolver=R;function P(c,h){return{http:Object.assign(I,(0,y.createHttpPatch)(c,I,h)),https:Object.assign(O,(0,y.createHttpPatch)(c,O,h)),net:Object.assign(A,(0,y.createNetPatch)(c,A)),tls:Object.assign(f,(0,y.createTlsPatch)(c,f))}}function E(c){const h=c.getConfiguration("http");return!h.get("experimental.systemCertificatesV2",v)&&!!h.get("systemCertificates")}function S(c){const h=c.getConfiguration("http");return!!h.get("experimental.systemCertificatesV2",v)&&!!h.get("systemCertificates")}const _=new Map;function w(c,h){return c.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,i=t._load;t._load=function(n,r,l){if(n==="net")return h.net;if(n==="tls")return h.tls;if(n!=="http"&&n!=="https")return i.apply(this,arguments);const k=a.findSubstr(T.URI.file(r.filename));let C=_.get(k);if(C||_.set(k,C={}),!C[n]){const p=h[n];C[n]={...p}}return C[n]}})}async function d(c,h,a,t,i,s,n,r){const l=t[s];n&&(t[s]=n),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${n}`,`proxyAuthenticateCache:${l}`);const k=n||l,C=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(u(h,C,i),C.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!r.kerberosRequested)try{r.kerberosRequested=!0;const p=await new Promise((L,F)=>{pe(["kerberos"],L,F)}),m=new URL(s),b=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${m.hostname}`:`HTTP@${m.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${b}`),"Negotiate "+await(await p.initializeClient(b)).step("")}catch(p){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let o=!1;function u(c,h,a){o||!h.length||(o=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:h.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(De[269],Ie([1,0,128]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function O(A){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:A,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function f(A){return new I.URITransformer(O(A))}e.createURITransformer=f}),define(De[139],Ie([1,0,217,17,2,3,5,43,30,18,41,176,38]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var _;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(_||(e.EditorPaneSelectionCompareResult=_={}));function w(ce){const Se=ce;return!!Se&&typeof Se.getSelection=="function"&&!!Se.onDidChangeSelection}e.isEditorPaneWithSelection=w;function d(ce,Se,j){for(const $ of j.visibleEditorPanes)if($.group.id===Se&&ce.matches($.input))return $.getViewState()}e.findViewStateForEditor=d;function o(ce){if(l(ce))return!1;const Se=ce;return f.URI.isUri(Se?.resource)}e.isResourceEditorInput=o;function u(ce){if(l(ce))return!1;const Se=ce;return Se?.original!==void 0&&Se.modified!==void 0}e.isResourceDiffEditorInput=u;function c(ce){if(l(ce)||u(ce))return!1;const Se=ce;return Se?.primary!==void 0&&Se.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function h(ce){if(l(ce))return!1;const Se=ce;return Se?Se.resource===void 0||Se.resource.scheme===v.Schemas.untitled||Se.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;function a(ce){if(l(ce))return!1;const Se=ce;return f.URI.isUri(Se?.base?.resource)&&f.URI.isUri(Se?.input1?.resource)&&f.URI.isUri(Se?.input2?.resource)&&f.URI.isUri(Se?.result?.resource)}e.isResourceMergeEditorInput=a;var t;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var i;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(Se,j){let $=this.mapIdToSaveSource.get(Se);return $||($={source:Se,label:j},this.mapIdToSaveSource.set(Se,$)),$.source}getSourceLabel(Se){return this.mapIdToSaveSource.get(Se)?.label??Se}}e.SaveSourceRegistry=new s;var n;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(n||(e.EditorInputCapabilities=n={}));class r extends A.Disposable{}e.AbstractEditorInput=r;function l(ce){return ce instanceof r}e.isEditorInput=l;function k(ce){const Se=ce;return f.URI.isUri(Se?.preferredResource)}function C(ce){const Se=ce;return l(Se?.primary)&&l(Se?.secondary)}e.isSideBySideEditorInput=C;function p(ce){const Se=ce;return l(Se?.modified)&&l(Se?.original)}e.isDiffEditorInput=p;function m(ce,Se,j,$,X){return ie($,[(0,P.toAction)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const re={...j,limits:{size:Number.MAX_VALUE}};ce.openEditor(Se,re)}}),(0,P.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>X.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:E.default.Warning})}e.createTooLargeFileError=m;function b(ce){return l(ce?.editor)}e.isEditorInputWithOptions=b;function D(ce){const Se=ce;return b(ce)&&Se?.group!==void 0}e.isEditorInputWithOptionsAndGroup=D;function M(ce){const Se=ce;return typeof Se?.groupId=="number"&&l(Se.editor)}e.isEditorIdentifier=M;var L;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(L||(e.EditorCloseContext=L={}));var F;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var x;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(x||(e.SideBySideEditor=x={}));class U{getOriginalUri(Se,j){if(!Se)return;if(a(Se))return e.EditorResourceAccessor.getOriginalUri(Se.result,j);if(j?.supportSideBySide){const{primary:X,secondary:re}=this.getSideEditors(Se);if(X&&re){if(j?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(X,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===x.ANY)return this.getOriginalUri(X,{filterByScheme:j.filterByScheme})??this.getOriginalUri(re,{filterByScheme:j.filterByScheme});Se=j.supportSideBySide===x.PRIMARY?X:re}}if(u(Se)||c(Se)||a(Se))return;const $=k(Se)?Se.preferredResource:Se.resource;return!$||!j||!j.filterByScheme?$:this.filterUri($,j.filterByScheme)}getSideEditors(Se){return C(Se)||c(Se)?{primary:Se.primary,secondary:Se.secondary}:p(Se)||u(Se)?{primary:Se.modified,secondary:Se.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Se,j){if(!Se)return;if(a(Se))return e.EditorResourceAccessor.getCanonicalUri(Se.result,j);if(j?.supportSideBySide){const{primary:X,secondary:re}=this.getSideEditors(Se);if(X&&re){if(j?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(X,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===x.ANY)return this.getCanonicalUri(X,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:j.filterByScheme});Se=j.supportSideBySide===x.PRIMARY?X:re}}if(u(Se)||c(Se)||a(Se))return;const $=Se.resource;return!$||!j||!j.filterByScheme?$:this.filterUri($,j.filterByScheme)}filterUri(Se,j){if(Array.isArray(j)){if(j.some($=>Se.scheme===$))return Se}else if(j===Se.scheme)return Se}}var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function z(ce,Se,j,$){if(!ce.isSticky(Se))return!1;switch($.preventPinnedEditorClose){case"keyboardAndMouse":return j===N.MOUSE||j===N.KEYBOARD;case"mouse":return j===N.MOUSE;case"keyboard":return j===N.KEYBOARD}return!1}e.preventEditorClose=z,e.EditorResourceAccessor=new U;var V;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class ge{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Se){const j=this.instantiationService=Se.get(T.IInstantiationService);for(const[$,X]of this.editorSerializerConstructors)this.createEditorSerializer($,X,j);this.editorSerializerConstructors.clear()}createEditorSerializer(Se,j,$){const X=$.createInstance(j);this.editorSerializerInstances.set(Se,X)}registerFileEditorFactory(Se){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Se}getFileEditorFactory(){return(0,O.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Se,j){if(this.editorSerializerConstructors.has(Se)||this.editorSerializerInstances.has(Se))throw new Error(`A editor serializer with type ID '${Se}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Se,j,this.instantiationService):this.editorSerializerConstructors.set(Se,j),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(Se),this.editorSerializerInstances.delete(Se)})}getEditorSerializer(Se){return this.editorSerializerInstances.get(typeof Se=="string"?Se:Se.typeId)}}g.Registry.add(e.EditorExtensions.EditorFactory,new ge);async function te(ce,Se,j){return!ce||!ce.length?[]:await Promise.all(ce.map(async $=>{const X=f.URI.revive($.fileUri);if(!X){j.info("Cannot resolve the path because it is not valid.",$);return}if(!await Se.canHandleResource(X)){j.info("Cannot resolve the path because it cannot be handled",$);return}let Q=$.exists,Z=$.type;if(typeof Q!="boolean"||typeof Z!="number")try{Z=(await Se.stat(X)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Q=!0}catch(be){j.error(be),Q=!1}if(!Q&&$.openOnlyIfExists){j.info("Cannot resolve the path because it does not exist",$);return}if(Z===y.FileType.Directory){j.info("Cannot resolve the path because it is a directory",$);return}const J={...$.options,pinned:!0};return Q?{resource:X,options:J}:{resource:X,options:J,forceUntitled:!0}}))}e.pathsToEditors=te;var q;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(q||(e.EditorsOrder=q={}));function K(ce){const Se=ce;if(!Se)return!1;const j=Se;if(j.modified)return K(j.modified);const $=Se;return!!($.contributionsState&&$.viewState&&Array.isArray($.cursorState))}e.isTextEditorViewState=K;function ue(ce){return(0,R.isErrorWithActions)(ce)}e.isEditorOpenError=ue;function ie(ce,Se,j){const $=(0,R.createErrorWithActions)(ce,Se);return $.forceMessage=j?.forceMessage,$.forceSeverity=j?.forceSeverity,$.allowDialog=j?.allowDialog,$}e.createEditorOpenError=ie}),define(De[270],Ie([1,0,4,218,5,3,28,43,19,24,79,256]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,O.localize)(0,null),e.defaultViewIcon=(0,P.registerIcon)("default-view-icon",R.Codicon.window,(0,O.localize)(1,null));var E;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var S;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.ViewContainerLocations=[0,1,2];function _(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=_;class w extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new I.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new I.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(s,n,r){const l=this.get(s.id);if(l)return l;const k=s;return k.openCommandActionDescriptor=r?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,T.getOrSet)(this.viewContainers,n,[]).push(k),r?.isDefault&&this.defaultViewContainers.push(k),this._onDidRegister.fire({viewContainer:k,viewContainerLocation:n}),k}deregisterViewContainer(s){for(const n of this.viewContainers.keys()){const r=this.viewContainers.get(n),l=r?.indexOf(s);if(l!==-1){r?.splice(l,1),r.length===0&&this.viewContainers.delete(n),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:n});return}}}get(s){return this.all.filter(n=>n.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(n=>this.getViewContainers(n).filter(r=>r?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(n=>this.getViewContainerLocation(n)===s)}}g.Registry.add(E.ViewContainersRegistry,new w);var d;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(d||(e.ViewContentGroups=d={}));function o(i,s){const n=i.group??d.More,r=s.group??d.More;return n!==r?n.localeCompare(r):(i.order??5)-(s.order??5)}class u extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new I.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new I.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new I.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new I.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(s,n){this.registerViews2([{views:s,viewContainer:n}])}registerViews2(s){s.forEach(({views:n,viewContainer:r})=>this.addViews(n,r)),this._onViewsRegistered.fire(s)}deregisterViews(s,n){const r=this.removeViews(s,n);r.length&&this._onViewsDeregistered.fire({views:r,viewContainer:n})}moveViews(s,n){for(const r of this._views.keys())if(r!==n){const l=this.removeViews(s,r);l.length&&(this.addViews(l,n),this._onDidChangeContainer.fire({views:l,from:r,to:n}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const n of this._viewContainers){const r=(this._views.get(n)||[]).filter(l=>l.id===s)[0];if(r)return r}return null}getViewContainer(s){for(const n of this._viewContainers)if((this._views.get(n)||[]).filter(l=>l.id===s)[0])return n;return null}registerViewWelcomeContent(s,n){return this._viewWelcomeContents.add(s,n),this._onDidChangeViewWelcomeContent.fire(s),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(s,n),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,n){const r=new Map;for(const[l,k]of n)this._viewWelcomeContents.add(s,k),r.set(l,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(s,k),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),r}getViewWelcomeContent(s){const n=[];return this._viewWelcomeContents.forEach(s,r=>n.push(r)),n.sort(o)}addViews(s,n){let r=this._views.get(n);r||(r=[],this._views.set(n,r),this._viewContainers.push(n));for(const l of s){if(this.getView(l.id)!==null)throw new Error((0,O.localize)(2,null,l.id));r.push(l)}}removeViews(s,n){const r=this._views.get(n);if(!r)return[];const l=[],k=[];for(const C of r)s.includes(C)?l.push(C):k.push(C);return l.length&&(k.length?this._views.set(n,k):(this._views.delete(n),this._viewContainers.splice(this._viewContainers.indexOf(n),1))),l}}g.Registry.add(E.ViewsRegistry,new u),e.IViewsService=(0,f.createDecorator)("viewsService"),e.IViewDescriptorService=(0,f.createDecorator)("viewDescriptorService");var c;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var h;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(h||(e.TreeItemCollapsibleState=h={}));class a{constructor(s,n){this.resolved=!1,this._hasResolve=!1,(0,v.mixin)(this,s),this._hasResolve=!!n,this.resolve=async r=>{if(n&&!this.resolved){const l=await n(r);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}r.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a;class t extends Error{constructor(s){super((0,O.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(De[271],Ie([1,0,2,32,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChatService=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.isIUsedContext=e.isIDocumentContext=void 0;function A(v){return!!v&&typeof v=="object"&&"uri"in v&&v.uri instanceof I.URI&&"version"in v&&typeof v.version=="number"&&"ranges"in v&&Array.isArray(v.ranges)&&v.ranges.every(O.Range.isIRange)}e.isIDocumentContext=A;function T(v){return!!v&&typeof v=="object"&&"documents"in v&&Array.isArray(v.documents)&&v.documents.every(A)}e.isIUsedContext=T;var g;(function(v){v[v.Down=0]="Down",v[v.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var y;(function(v){v[v.Action=1]="Action",v[v.Toolbar=2]="Toolbar"})(y||(e.InteractiveSessionCopyKind=y={})),e.IChatService=(0,f.createDecorator)("IChatService")}),define(De[140],Ie([1,0,4,8,219]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new I.Emitter,this._onExit=new I.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(g){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=g}onEvent(g){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=g}onRequest(g){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=g}sendResponse(g){g.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.internalSend("response",g)}sendRequest(g,y,v,R){const P={command:g};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.internalSend("request",P),typeof R=="number"){const E=setTimeout(()=>{clearTimeout(E);const S=this.pendingRequests.get(P.seq);if(S){this.pendingRequests.delete(P.seq);const _={type:"response",seq:0,request_seq:P.seq,success:!1,command:g,message:(0,f.localize)(0,null,R,g)};S(_)}},R)}return v&&this.pendingRequests.set(P.seq,v),P.seq}acceptMessage(g){this.messageCallback?this.messageCallback(g):(this.queue.push(g),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(g,y){return g.type!=="event"||y.type!=="event"}async processQueue(){let g;for(;this.queue.length;){if((!g||this.needsTaskBoundaryBetween(this.queue[0],g))&&await(0,O.timeout)(0),g=this.queue.shift(),!g)return;switch(g.type){case"event":this.eventCallback?.(g);break;case"request":this.requestCallback?.(g);break;case"response":{const y=g,v=this.pendingRequests.get(y.request_seq);v&&(this.pendingRequests.delete(y.request_seq),v(y));break}}}}internalSend(g,y){y.type=g,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const g=new Map;this.pendingRequests.forEach((y,v)=>g.set(v,y)),await(0,O.timeout)(500),g.forEach((y,v)=>{y({type:"response",seq:0,request_seq:v,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(v)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(De[272],Ie([1,0,220,42,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new O.RawContextKey("debugType",void 0,{type:"string",description:I.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new O.RawContextKey("debugConfigurationType",void 0,{type:"string",description:I.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new O.RawContextKey("debugState","inactive",{type:"string",description:I.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new O.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:I.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new O.RawContextKey("hasDebugged",!1,{type:"boolean",description:I.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new O.RawContextKey("inDebugMode",!1,{type:"boolean",description:I.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new O.RawContextKey("inDebugRepl",!1,{type:"boolean",description:I.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new O.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new O.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:I.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new O.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:I.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new O.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new O.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:I.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new O.RawContextKey("variablesFocused",!0,{type:"boolean",description:I.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new O.RawContextKey("expressionSelected",!1,{type:"boolean",description:I.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new O.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:I.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new O.RawContextKey("callStackItemType",void 0,{type:"string",description:I.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new O.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new O.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:I.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new O.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new O.RawContextKey("watchItemType",void 0,{type:"string",description:I.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new O.RawContextKey("canViewMemory",void 0,{type:"boolean",description:I.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new O.RawContextKey("breakpointItemType",void 0,{type:"string",description:I.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new O.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new O.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new O.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:I.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new O.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new O.RawContextKey("stepBackSupported",!1,{type:"boolean",description:I.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new O.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:I.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new O.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new O.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new O.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new O.RawContextKey("breakpointsExist",!1,{type:"boolean",description:I.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new O.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:I.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new O.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new O.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new O.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new O.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new O.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new O.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new O.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new O.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new O.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new O.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new O.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:I.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new O.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new O.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:I.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new O.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:I.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new O.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new O.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new O.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new O.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(50,null)});const A=E=>I.localize(51,null,E);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(52,null)};var T;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(T||(e.State=T={}));function g(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=g;var y;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var v;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(v||(e.DebugConfigurationProviderTriggerKind=v={}));var R;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.IDebugService=(0,f.createDecorator)("debugService");var P;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(De[273],Ie([1,0,15,2,16,24,18,32,21,19]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function P(C,p,m){return C.replace(R,function(b,D){return p&&D.length>0&&D[0]!=="_"?b:m&&m.hasOwnProperty(D)?m[D]:b})}e.formatPII=P;function E(C){const p={};for(const m of Object.keys(C))m.startsWith("!")||(p[m]=C[m]);return p}e.filterExceptionsFromTelemetry=E;function S(C){return C.configuration.request==="attach"&&!_(C)&&(!C.parentSession||S(C.parentSession))}e.isSessionAttach=S;function _(C){let p=C.configuration.type;if(p)return p==="vslsShare"&&(p=C.configuration.adapterProxy.configuration.type),(0,I.equalsIgnoreCase)(p,"extensionhost")||(0,I.equalsIgnoreCase)(p,"pwa-extensionhost")?C:C.parentSession?_(C.parentSession):void 0}e.getExtensionHostDebugSession=_;function w(C){return C.type&&(C.label||C.program||C.runtime)}e.isDebuggerMainContribution=w;function d(C,p,m){let b,D=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=M.exec(C);){const F=L.index+1,x=F+L[0].length;if(F<=p&&x>=m){b=L[0],D=F;break}}if(b){const F=/\w+/g;let x=null;for(;(x=F.exec(b))&&!(x.index+1+D+x[0].length>=m););x&&(b=b.substring(0,F.lastIndex))}return b?{start:D,end:D+b.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;async function o(C,p,m,b){if(C.evaluatableExpressionProvider.has(p)){const D=C.evaluatableExpressionProvider.ordered(p),M=(0,v.coalesce)(await Promise.all(D.map(async L=>{try{return await L.provideEvaluatableExpression(p,m,b??y.CancellationToken.None)}catch{return}})));if(M.length>0){let L=M[0].expression;const F=M[0].range;return L||(L=p.getLineContent(m.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:L}}}else{const D=p.getLineContent(m.lineNumber),{start:M,end:L}=d(D,m.column,m.column),F=D.substring(M-1,L);return{matchingExpression:F,range:new g.Range(m.lineNumber,M,m.lineNumber,M+F.length)}}return null}e.getEvaluatableExpressionAtPosition=o;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(C){return!!(C&&C.match(u))}e.isUri=c;function h(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(c(C.path))return O.URI.parse(C.path);if((0,f.isAbsolute)(C.path))return O.URI.file(C.path)}return C.path}function a(C){if(typeof C.path=="object"){const p=O.URI.revive(C.path);if(p)return p.scheme===T.Schemas.file?p.fsPath:p.toString()}return C.path}function t(C,p){const m=p?h:a,b=(0,A.deepClone)(C);return s(b,(D,M)=>{D&&M&&(M.path=m(M))}),b}e.convertToDAPaths=t;function i(C,p){const m=p?h:a,b=(0,A.deepClone)(C);return s(b,(D,M)=>{!D&&M&&(M.path=m(M))}),b}e.convertToVSCPaths=i;function s(C,p){switch(C.type){case"event":{const m=C;switch(m.event){case"output":p(!1,m.body.source);break;case"loadedSource":p(!1,m.body.source);break;case"breakpoint":p(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=C;switch(m.command){case"setBreakpoints":p(!0,m.arguments.source);break;case"breakpointLocations":p(!0,m.arguments.source);break;case"source":p(!0,m.arguments.source);break;case"gotoTargets":p(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(b=>p(!1,b));break;default:break}break}case"response":{const m=C;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(b=>p(!1,b.source));break;case"loadedSources":m.body.sources.forEach(b=>p(!1,b));break;case"scopes":m.body.scopes.forEach(b=>p(!1,b.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(b=>p(!1,b.source));break;case"setBreakpoints":m.body.breakpoints.forEach(b=>p(!1,b.source));break;case"disassemble":m.body?.instructions.forEach(D=>p(!1,D.location));break;default:break}break}}}function n(C){return C.filter(p=>!p.presentation?.hidden).sort((p,m)=>p.presentation?m.presentation?p.presentation.group?m.presentation.group?p.presentation.group!==m.presentation.group?p.presentation.group.localeCompare(m.presentation.group):r(p.presentation.order,m.presentation.order):-1:m.presentation.group?1:r(p.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=n;function r(C,p){return typeof C!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:C-p}async function l(C,p){const m=C.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(m!=="none"&&(await p.saveAll(),m==="allEditorsInActiveGroup")){const b=p.activeEditorPane;b&&b.input.resource?.scheme===T.Schemas.untitled&&await p.save({editor:b.input,groupId:b.group.id})}await C.reloadConfiguration()}e.saveAllBeforeDebugStart=l;const k=(C,p)=>!C||!p?C===p:C.name===p.name&&C.path===p.path&&C.sourceReference===p.sourceReference;e.sourcesEqual=k}),define(De[274],Ie([1,0,49,60,24,16,12,15,29,221,140]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends R.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(o,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,o.on("data",c=>this.handleData(c))}sendMessage(o){if(this.outputStream){const u=JSON.stringify(o);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${P.TWO_CRLF}${u}`,"utf8")}}handleData(o){for(this.rawData=Buffer.concat([this.rawData,o]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+u))}continue}}else{const u=this.rawData.indexOf(P.TWO_CRLF);if(u!==-1){const h=this.rawData.toString("utf8",0,u).split(P.HEADER_LINESEPARATOR);for(const a of h){const t=a.split(P.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(u+P.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=P;class E extends P{startSession(){return new Promise((o,u)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),o(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",h=>{c?this._onError.fire(h):u(h)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class S extends E{constructor(o){super(),this.adapterServer=o}createConnection(o){return O.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",o)}}e.SocketDebugAdapter=S;class _ extends E{constructor(o){super(),this.adapterServer=o}createConnection(o){return O.createConnection(this.adapterServer.path,o)}}e.NamedPipeDebugAdapter=_;class w extends P{constructor(o,u){super(),this.adapterExecutable=o,this.debugType=u}async startSession(){const o=this.adapterExecutable.command,u=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(o)if(A.isAbsolute(o)){if(!await y.Promises.exists(o))throw new Error(v.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(v.localize(1,null,this.debugType));let h=process.env;if(c.env&&Object.keys(c.env).length>0&&(h=f.mixin(f.deepClone(process.env),c.env)),o==="node")if(Array.isArray(u)&&u.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:h,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(t.cwd=c.cwd);const i=I.fork(u[0],u.slice(1),t);if(!i.pid)throw new Error(v.localize(2,null,u[0]));this.serverProcess=i}else throw new Error(v.localize(3,null));else{const a={env:h};c.cwd&&(a.cwd=c.cwd),this.serverProcess=I.spawn(o,u,a)}this.serverProcess.on("error",a=>{this._onError.fire(a)}),this.serverProcess.on("exit",(a,t)=>{this._onExit.fire(a)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stdin.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(h){this._onError.fire(h)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((o,u)=>{const c=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(h,a,t){if(h)return u(h)});c.on("exit",o),c.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(o,u){if(!o)return;const c=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?c.runtime=A.join(u,o.runtime):c.runtime=o.runtime),o.runtimeArgs&&(c.runtimeArgs=o.runtimeArgs),o.program&&(A.isAbsolute(o.program)?c.program=o.program:c.program=A.join(u,o.program)),o.args&&(c.args=o.args);const h=o;return h.win&&(c.win=w.extract(h.win,u)),h.winx86&&(c.winx86=w.extract(h.winx86,u)),h.windows&&(c.windows=w.extract(h.windows,u)),h.osx&&(c.osx=w.extract(h.osx,u)),h.linux&&(c.linux=w.extract(h.linux,u)),c}static platformAdapterExecutable(o,u){let c=Object.create(null);u=u.toLowerCase();for(const n of o)if(n.contributes){const r=n.contributes.debuggers;r&&r.length>0&&r.filter(l=>typeof l.type=="string"&&g.equalsIgnoreCase(l.type,u)).forEach(l=>{const k=w.extract(l,n.extensionLocation.fsPath);c=f.mixin(c,k,n.isBuiltin)})}let h;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=c.winx86||c.win||c.windows:T.isWindows?h=c.win||c.windows:T.isMacintosh?h=c.osx:T.isLinux&&(h=c.linux),h=h||c;const a=h.program||c.program,t=h.args||c.args,i=h.runtime||c.runtime,s=h.runtimeArgs||c.runtimeArgs;if(i)return{type:"executable",command:i,args:(s||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.ExecutableDebugAdapter=w}),define(De[275],Ie([1,0,49,33,12]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(v,R){return new Promise((P,E)=>{let S="";const _=I.spawn(v,R);_.pid&&_.stdout.on("data",w=>{S+=w.toString()}),_.on("error",w=>{E(w)}),_.on("close",w=>{P(S)})})}async function T(v){if(v)if(f.isWindows){const R=await new Promise((P,E)=>{pe(["@vscode/windows-process-tree"],P,E)});return new Promise(P=>{R.getProcessTree(v,E=>{P(!!E&&E.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(v)]).then(R=>{const P=R.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=T;var g;(function(v){v[v.cmd=0]="cmd",v[v.powershell=1]="powershell",v[v.bash=2]="bash"})(g||(g={}));function y(v,R,P,E,S){v=v.trim().toLowerCase();let _;v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0?_=1:v.indexOf("cmd.exe")>=0?_=0:v.indexOf("bash")>=0?_=2:f.isWindows?_=0:_=2;let w,d=" ";switch(_){case 1:if(w=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),E){const o=(0,O.getDriveLetter)(E);o&&(d+=`${o}:; `),d+=`cd ${w(E)}; `}if(S)for(const o in S){const u=S[o];u===null?d+=`Remove-Item env:${o}; `:d+=`\${env:${o}}='${u}'; `}if(R.length>0){const o=R.shift(),u=P?o:w(o);d+=u[0]==="'"?`& ${u} `:`${u} `;for(const c of R)d+=c==="<"||c===">"||P?c:w(c),d+=" "}break;case 0:if(w=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(u=>o.includes(u))||o.length===0?`"${o}"`:o),E){const o=(0,O.getDriveLetter)(E);o&&(d+=`${o}: && `),d+=`cd ${w(E)} && `}if(S){d+='cmd /C "';for(const o in S){let u=S[o];u===null?d+=`set "${o}=" && `:(u=u.replace(/[&^|<>]/g,c=>`^${c}`),d+=`set "${o}=${u}" && `)}}for(const o of R)d+=o==="<"||o===">"||P?o:w(o),d+=" ";S&&(d+='"');break;case 2:{w=u=>(u=u.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),u.length===0?'""':u);const o=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(E&&(d+=`cd ${w(E)} ; `),S){d+="/usr/bin/env";for(const u in S){const c=S[u];c===null?d+=` -u ${o(u)}`:d+=` ${o(`${u}=${c}`)}`}d+=" "}for(const u of R)d+=u==="<"||u===">"||P?u:w(u),d+=" ";break}}return d}e.prepareCommand=y}),define(De[108],Ie([1,0,22,36,51,97,18,16,12,42]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(R||(e.CellKind=R={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var E;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var S;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var _;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(_||(e.NotebookRendererMatch=_={}));var w;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var d;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var o;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var u;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var c;(function(N){N.scheme=T.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${z.join("")}]+`),ge=7;function te(Se,j){const $=j.toString(ge),re=`${$.length<z.length?z[$.length-1]:"z"}${$}s${(0,I.encodeBase64)(I.VSBuffer.fromString(Se.scheme),!0,!0)}`;return Se.with({scheme:N.scheme,fragment:re})}N.generate=te;function q(Se){if(Se.scheme!==N.scheme)return;const j=Se.fragment.indexOf("s");if(j<0)return;const $=parseInt(Se.fragment.substring(0,j).replace(V,""),ge),X=(0,I.decodeBase64)(Se.fragment.substring(j+1)).toString();if(!isNaN($))return{handle:$,notebook:Se.with({scheme:X,fragment:null})}}N.parse=q;function K(Se,j){return Se.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${j??""},${Se.scheme!==T.Schemas.file?Se.scheme:""}`})}N.generateCellOutputUri=K;function ue(Se){if(Se.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const j=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Se.fragment);if(!j)return;const $=j[1]&&j[1]!==""?j[1]:void 0,X=j[2];return{outputId:$,notebook:Se.with({scheme:X||T.Schemas.file,fragment:null})}}N.parseCellOutputUri=ue;function ie(Se,j,$){return N.generate(Se,j).with({scheme:$})}N.generateCellPropertyUri=ie;function ce(Se,j){if(Se.scheme===j)return N.parse(Se.with({scheme:N.scheme}))}N.parseCellPropertyUri=ce})(c||(e.CellUri=c={}));const h=N=>y.isWindows?N.replace(/\//g,"\\"):N;class a{constructor(z=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=V,this.order=[...new Set(z)].map(ge=>({pattern:ge,matches:O.parse(h(ge))}))}sort(z){const V=new Map(f.Iterable.map(z,te=>[te,h(te)]));let ge=[];for(const{matches:te}of this.order)for(const[q,K]of V)if(te(K)){ge.push(q),V.delete(q);break}return V.size&&(ge=ge.concat([...V.keys()].sort((te,q)=>this.defaultOrder.indexOf(te)-this.defaultOrder.indexOf(q)))),ge}prioritize(z,V){const ge=this.findIndex(z);if(ge===-1){this.order.unshift({pattern:z,matches:O.parse(h(z))});return}const te=new Set(V.map(K=>this.findIndex(K,ge)));te.delete(-1);const q=Array.from(te).sort();this.order.splice(ge+1,0,...q.map(K=>this.order[K]));for(let K=q.length-1;K>=0;K--)this.order.splice(q[K],1)}toArray(){return this.order.map(z=>z.pattern)}findIndex(z,V=this.order.length){const ge=h(z);for(let te=0;te<V;te++)if(this.order[te].matches(ge))return te;return-1}}e.MimeTypeDisplayOrder=a;function t(N,z,V,ge=(te,q)=>te===q){const te=[];function q(ie,ce,Se){if(ce===0&&Se.length===0)return;const j=te[te.length-1];j&&j.start+j.deleteCount===ie?(j.deleteCount+=ce,j.toInsert.push(...Se)):te.push({start:ie,deleteCount:ce,toInsert:Se})}let K=0,ue=0;for(;;){if(K===N.length){q(K,0,z.slice(ue));break}if(ue===z.length){q(K,N.length-K,[]);break}const ie=N[K],ce=z[ue];if(ge(ie,ce)){K+=1,ue+=1;continue}V(ce)?(q(K,1,[]),K+=1):(q(K,0,[ce]),ue+=1)}return te}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtLineBoundary","none");var i;(function(N){N.default="default",N.option="option"})(i||(e.NotebookEditorPriority=i={}));function s(N){const z=N;return!!((typeof z.include=="string"||O.isRelativePattern(z.include))&&(typeof z.exclude=="string"||O.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=s;function n(N,z,V){if(Array.isArray(N.viewType)&&N.viewType.indexOf(z)>=0||N.viewType===z)return!0;if(N.filenamePattern){const ge=s(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,te=s(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(O.match(ge,(0,g.basename)(V.fsPath).toLowerCase()))return!(te&&O.match(te,(0,g.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var r;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(r||(e.CellStatusbarAlignment=r={}));class l{static{this._prefix="notebook/"}static create(z){return`${l._prefix}${z}`}static parse(z){if(z.startsWith(l._prefix))return z.substring(l._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=l;function k(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.isTextStreamMime=k;const C=new TextDecoder;function p(N){const z=[];let V=!1;for(const K of N)(z.length===0||V)&&(z.push(K),V=!0);let ge=D(z);const te=I.VSBuffer.concat(z.map(K=>I.VSBuffer.wrap(K))),q=U(te);return ge=ge||q.byteLength!==te.byteLength,{data:q,didCompression:ge}}e.compressOutputItemStreams=p,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const m=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(N=>N.charCodeAt(0)),b=10;function D(N){let z=!1;return N.forEach((V,ge)=>{if(ge===0||V.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const te=N[ge-1],q=V.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(q[0]===m[0]&&q[1]===m[1]&&q[2]===m[2]){const K=te.lastIndexOf(b);if(K===-1)return;z=!0,N[ge-1]=te.subarray(0,K),N[ge]=V.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),z}function M(N){let z=N;do N=z,z=N.replace(/[^\n]\x08/gm,"");while(z.length<N.length);return N}function L(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const z=N.match(/^(.*)\r+/m)[1];let V=N.match(/\r+(.*)$/m)[1];V=V+z.slice(V.length,z.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return N}const F="\b".charCodeAt(0),x="\r".charCodeAt(0);function U(N){return!N.buffer.includes(F)&&!N.buffer.includes(x)?N:I.VSBuffer.fromString(L(M(C.decode(N.buffer))))}}),define(De[7],Ie([1,0,19,9,80,28,97,15,17,2,31,25,30,65,108]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_){"use strict";var w,d,o,u,c,h,a,t,i,s,n,r,l,k,C,p,m,b;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.ChatMessage=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(H){return Object.assign(H,{apply:function(...we){if(we.length===0)return Reflect.construct(H,[]);{const Ae=we.length===1?[]:we[1];return Reflect.construct(H,Ae,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(H,[]);{const[Ae,...Ke]=we;return Reflect.construct(H,Ke,Ae.constructor)}}})}var M;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var L;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let F=w=class{static from(...W){let we=W;return new w(function(){if(we){for(const Ae of we)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();we=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=F,e.Disposable=F=w=je([D],F);let x=d=class{static Min(...W){if(W.length===0)throw new TypeError;let we=W[0];for(let Ae=1;Ae<W.length;Ae++){const Ke=W[Ae];Ke.isBefore(we)&&(we=Ke)}return we}static Max(...W){if(W.length===0)throw new TypeError;let we=W[0];for(let Ae=1;Ae<W.length;Ae++){const Ke=W[Ae];Ke.isAfter(we)&&(we=Ke)}return we}static isPosition(W){if(!W)return!1;if(W instanceof d)return!0;const{line:we,character:Ae}=W;return typeof we=="number"&&typeof Ae=="number"}static of(W){if(W instanceof d)return W;if(this.isPosition(W))return new d(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,we){if(W<0)throw(0,O.illegalArgument)("line must be non-negative");if(we<0)throw(0,O.illegalArgument)("character must be non-negative");this._line=W,this._character=we}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,we=0){if(W===null||we===null)throw(0,O.illegalArgument)();let Ae;return typeof W>"u"?Ae=0:typeof W=="number"?Ae=W:(Ae=typeof W.lineDelta=="number"?W.lineDelta:0,we=typeof W.characterDelta=="number"?W.characterDelta:0),Ae===0&&we===0?this:new d(this.line+Ae,this.character+we)}with(W,we=this.character){if(W===null||we===null)throw(0,O.illegalArgument)();let Ae;return typeof W>"u"?Ae=this.line:typeof W=="number"?Ae=W:(Ae=typeof W.line=="number"?W.line:this.line,we=typeof W.character=="number"?W.character:this.character),Ae===this.line&&we===this.character?this:new d(Ae,we)}toJSON(){return{line:this.line,character:this.character}}};e.Position=x,e.Position=x=d=je([D],x);let U=o=class{static isRange(W){return W instanceof o?!0:W?x.isPosition(W.start)&&x.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,we,Ae,Ke){let et,ot;if(typeof W=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(et=new x(W,we),ot=new x(Ae,Ke)):x.isPosition(W)&&x.isPosition(we)&&(et=x.of(W),ot=x.of(we)),!et||!ot)throw new Error("Invalid arguments");et.isBefore(ot)?(this._start=et,this._end=ot):(this._start=ot,this._end=et)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):x.isPosition(W)?!(x.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const we=x.Max(W.start,this._start),Ae=x.Min(W.end,this._end);if(!we.isAfter(Ae))return new o(we,Ae)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const we=x.Min(W.start,this._start),Ae=x.Max(W.end,this.end);return new o(we,Ae)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,we=this.end){if(W===null||we===null)throw(0,O.illegalArgument)();let Ae;return W?x.isPosition(W)?Ae=W:(Ae=W.start||this.start,we=W.end||this.end):Ae=this.start,Ae.isEqual(this._start)&&we.isEqual(this.end)?this:new o(Ae,we)}toJSON(){return[this.start,this.end]}};e.Range=U,e.Range=U=o=je([D],U);let N=u=class extends U{static isSelection(W){return W instanceof u?!0:W?U.isRange(W)&&x.isPosition(W.anchor)&&x.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,we,Ae,Ke){let et,ot;if(typeof W=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(et=new x(W,we),ot=new x(Ae,Ke)):x.isPosition(W)&&x.isPosition(we)&&(et=x.of(W),ot=x.of(we)),!et||!ot)throw new Error("Invalid arguments");super(et,ot),this._anchor=et,this._active=ot}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=N,e.Selection=N=u=je([D],N);const z=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,O.illegalArgument)("connectionToken")};class V{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,we,Ae){if(typeof W!="string"||W.length===0)throw(0,O.illegalArgument)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,O.illegalArgument)("port");typeof Ae<"u"&&z(Ae),this.host=W,this.port=Math.round(we),this.connectionToken=Ae}}e.ResolvedAuthority=V;class ge{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,we){this.makeConnection=W,this.connectionToken=we,typeof we<"u"&&z(we)}}e.ManagedResolvedAuthority=ge;class te extends Error{static NotAvailable(W,we){return new te(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(W){return new te(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,we=S.RemoteAuthorityResolverErrorCode.Unknown,Ae){super(W),this._message=W,this._code=we,this._detail=Ae,Object.setPrototypeOf(this,te.prototype)}}e.RemoteAuthorityResolverError=te;var q;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(q||(e.EndOfLine=q={}));var K;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(K||(e.EnvironmentVariableMutatorType=K={}));let ue=c=class{static isTextEdit(W){return W instanceof c?!0:W?U.isRange(W)&&typeof W.newText=="string":!1}static replace(W,we){return new c(W,we)}static insert(W,we){return c.replace(new U(W,W),we)}static delete(W){return c.replace(W,"")}static setEndOfLine(W){const we=new c(new U(new x(0,0),new x(0,0)),"");return we.newEol=W,we}get range(){return this._range}set range(W){if(W&&!U.isRange(W))throw(0,O.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,O.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,O.illegalArgument)("newEol");this._newEol=W}constructor(W,we){this._range=W,this._newText=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=ue,e.TextEdit=ue=c=je([D],ue);let ie=h=class{static isNotebookCellEdit(W){return W instanceof h?!0:W?Jt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,we){return new h(W,we)}static insertCells(W,we){return new h(new Jt(W,W),we)}static deleteCells(W){return new h(W,[])}static updateCellMetadata(W,we){const Ae=new h(new Jt(W,W),[]);return Ae.newCellMetadata=we,Ae}static updateNotebookMetadata(W){const we=new h(new Jt(0,0),[]);return we.newNotebookMetadata=W,we}constructor(W,we){this.range=W,this.newCells=we}};e.NotebookEdit=ie,e.NotebookEdit=ie=h=je([D],ie);class ce{static isSnippetTextEdit(W){return W instanceof ce?!0:W?U.isRange(W.range)&&$.isSnippetString(W.snippet):!1}static replace(W,we){return new ce(W,we)}static insert(W,we){return ce.replace(new U(W,W),we)}constructor(W,we){this.range=W,this.snippet=we}}e.SnippetTextEdit=ce;var Se;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,we,Ae,Ke){this._edits.push({_type:1,from:W,to:we,options:Ae,metadata:Ke})}createFile(W,we,Ae){this._edits.push({_type:1,from:void 0,to:W,options:we,metadata:Ae})}deleteFile(W,we,Ae){this._edits.push({_type:1,from:W,to:void 0,options:we,metadata:Ae})}replaceNotebookMetadata(W,we,Ae){this._edits.push({_type:3,metadata:Ae,uri:W,edit:{editType:5,metadata:we},notebookMetadata:we})}replaceNotebookCells(W,we,Ae,Ke){const et=we.start,ot=we.end;(et!==ot||Ae.length>0)&&this._edits.push({_type:5,uri:W,index:et,count:ot-et,cells:Ae,metadata:Ke})}replaceNotebookCellMetadata(W,we,Ae,Ke){this._edits.push({_type:3,metadata:Ke,uri:W,edit:{editType:3,index:we,metadata:Ae}})}replace(W,we,Ae,Ke){this._edits.push({_type:2,uri:W,edit:new ue(we,Ae),metadata:Ke})}insert(W,we,Ae,Ke){this.replace(W,new U(we,we),Ae,Ke)}delete(W,we,Ae){this.replace(W,we,"",Ae)}has(W){return this._edits.some(we=>we._type===2&&we.uri.toString()===W.toString())}set(W,we){if(we)for(const Ae of we){if(!Ae)continue;let Ke,et;Array.isArray(Ae)?(Ke=Ae[0],et=Ae[1]):Ke=Ae,ie.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(W,Ke.range.start,Ke.newCellMetadata,et):Ke.newNotebookMetadata?this.replaceNotebookMetadata(W,Ke.newNotebookMetadata,et):this.replaceNotebookCells(W,Ke.range,Ke.newCells,et):ce.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:et}):this._edits.push({_type:2,uri:W,edit:Ke,metadata:et})}else{for(let Ae=0;Ae<this._edits.length;Ae++){const Ke=this._edits[Ae];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this._edits[Ae]=void 0);break}}(0,I.coalesceInPlace)(this._edits)}}get(W){const we=[];for(const Ae of this._edits)Ae._type===2&&Ae.uri.toString()===W.toString()&&we.push(Ae.edit);return we}entries(){const W=new A.ResourceMap;for(const we of this._edits)if(we._type===2){let Ae=W.get(we.uri);Ae||(Ae=[we.uri,[]],W.set(we.uri,Ae)),Ae[1].push(we.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=j,e.WorkspaceEdit=j=je([D],j);let $=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=a._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,we=this._tabstop++){if(typeof W=="function"){const Ae=new a;Ae._tabstop=this._tabstop,W(Ae),this._tabstop=Ae._tabstop,W=Ae.value}else W=a._escape(W);return this.value+="${",this.value+=we,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,we=this._tabstop++){const Ae=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable(W,we){if(typeof we=="function"){const Ae=new a;Ae._tabstop=this._tabstop,we(Ae),this._tabstop=Ae._tabstop,we=Ae.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.SnippetString=$,e.SnippetString=$=a=je([D],$);var X;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var re;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let Q=t=class{static isLocation(W){return W instanceof t?!0:W?U.isRange(W.range)&&v.URI.isUri(W.uri):!1}constructor(W,we){if(this.uri=W,we)if(U.isRange(we))this.range=U.of(we);else if(x.isPosition(we))this.range=new U(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Q,e.Location=Q=t=je([D],Q);let Z=class{static is(W){return W?typeof W.message=="string"&&W.location&&U.isRange(W.location.range)&&v.URI.isUri(W.location.uri):!1}constructor(W,we){this.location=W,this.message=we}static isEqual(W,we){return W===we?!0:!W||!we?!1:W.message===we.message&&W.location.range.isEqual(we.location.range)&&W.location.uri.toString()===we.location.uri.toString()}};e.DiagnosticRelatedInformation=Z,e.DiagnosticRelatedInformation=Z=je([D],Z);let J=class{constructor(W,we,Ae=re.Error){if(!U.isRange(W))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=W,this.message=we,this.severity=Ae}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,we){return W===we?!0:!W||!we?!1:W.message===we.message&&W.severity===we.severity&&W.code===we.code&&W.severity===we.severity&&W.source===we.source&&W.range.isEqual(we.range)&&(0,I.equals)(W.tags,we.tags)&&(0,I.equals)(W.relatedInformation,we.relatedInformation,Z.isEqual)}};e.Diagnostic=J,e.Diagnostic=J=je([D],J);let be=class{constructor(W,we){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=we}};e.Hover=be,e.Hover=be=je([D],be);var ae;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let fe=class{constructor(W,we=ae.Text){this.range=W,this.kind=we}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.DocumentHighlight=fe,e.DocumentHighlight=fe=je([D],fe);var ee;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var he;(function(H){H[H.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let ve=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,we,Ae,Ke,et){this.name=W,this.kind=we,this.containerName=et,typeof Ae=="string"&&(this.containerName=Ae),Ke instanceof Q?this.location=Ke:Ae instanceof U&&(this.location=new Q(Ke,Ae)),i.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ve,e.SymbolInformation=ve=i=je([D],ve);let Pe=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(s.validate)}constructor(W,we,Ae,Ke,et){this.name=W,this.detail=we,this.kind=Ae,this.range=Ke,this.selectionRange=et,this.children=[],s.validate(this)}};e.DocumentSymbol=Pe,e.DocumentSymbol=Pe=s=je([D],Pe);var B;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let G=class{constructor(W,we){this.title=W,this.kind=we}};e.CodeAction=G,e.CodeAction=G=je([D],G);let se=class{static{n=this}static{this.sep="."}constructor(W){this.value=W}append(W){return new n(this.value?this.value+n.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+n.sep)}};e.CodeActionKind=se,e.CodeActionKind=se=n=je([D],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(W,we){if(this.range=W,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=oe,e.SelectionRange=oe=je([D],oe);class Y{constructor(W,we,Ae,Ke,et,ot){this.kind=W,this.name=we,this.detail=Ae,this.uri=Ke,this.range=et,this.selectionRange=ot}}e.CallHierarchyItem=Y;class me{constructor(W,we){this.fromRanges=we,this.from=W}}e.CallHierarchyIncomingCall=me;class ye{constructor(W,we){this.fromRanges=we,this.to=W}}e.CallHierarchyOutgoingCall=ye;var xe;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(xe||(e.LanguageStatusSeverity=xe={}));let We=class{constructor(W,we){this.range=W,this.command=we}get isResolved(){return!!this.command}};e.CodeLens=We,e.CodeLens=We=je([D],We);let Ze=r=class{#e;static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,we=!1){this.#e=new f.MarkdownString(W,{supportThemeIcons:we})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,we){return this.#e.appendCodeblock(we??"",W),this}};e.MarkdownString=Ze,e.MarkdownString=Ze=r=je([D],Ze);let Xe=class{constructor(W,we){this.label=W,this.documentation=we}};e.ParameterInformation=Xe,e.ParameterInformation=Xe=je([D],Xe);let it=class{constructor(W,we){this.label=W,this.documentation=we,this.parameters=[]}};e.SignatureInformation=it,e.SignatureInformation=it=je([D],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=tt,e.SignatureHelp=tt=je([D],tt);var Te;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Te||(e.SignatureHelpTriggerKind=Te={}));var Me;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Me||(e.InlayHintKind=Me={}));let ze=class{constructor(W){this.value=W}};e.InlayHintLabelPart=ze,e.InlayHintLabelPart=ze=je([D],ze);let Re=class{constructor(W,we,Ae){this.position=W,this.label=we,this.kind=Ae}};e.InlayHint=Re,e.InlayHint=Re=je([D],Re);var Qe;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe||(e.CompletionTriggerKind=Qe={}));var de;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(de||(e.CompletionItemKind=de={}));var le;(function(H){H[H.Deprecated=1]="Deprecated"})(le||(e.CompletionItemTag=le={}));let ke=class{constructor(W,we){this.label=W,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&de[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ke,e.CompletionItem=ke=je([D],ke);let Ve=class{constructor(W=[],we=!1){this.items=W,this.isIncomplete=we}};e.CompletionList=Ve,e.CompletionList=Ve=je([D],Ve);let Be=class{constructor(W,we,Ae){this.insertText=W,this.range=we,this.command=Ae}};e.InlineSuggestion=Be,e.InlineSuggestion=Be=je([D],Be);let Ye=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.InlineSuggestionList=Ye,e.InlineSuggestionList=Ye=je([D],Ye);var nt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ct;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));function vt(H,W){return`${P.ExtensionIdentifier.toKey(H)}.${W}`}e.asStatusBarItemIdentifier=vt;var yt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Vt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var jt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var bt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(bt||(e.TextEditorSelectionChangeKind=bt={}));var xt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var Mt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Mt||(e.DecorationRangeBehavior=Mt={})),function(H){function W(we){switch(we){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(bt||(e.TextEditorSelectionChangeKind=bt={}));var qt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(qt||(e.SyntaxTokenType=qt={})),function(H){function W(we){switch(we){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=W}(qt||(e.SyntaxTokenType=qt={}));let Bt=class{constructor(W,we){if(we&&!v.URI.isUri(we))throw(0,O.illegalArgument)("target");if(!U.isRange(W)||W.isEmpty)throw(0,O.illegalArgument)("range");this.range=W,this.target=we}};e.DocumentLink=Bt,e.DocumentLink=Bt=je([D],Bt);let Dt=class{constructor(W,we,Ae,Ke){this.red=W,this.green=we,this.blue=Ae,this.alpha=Ke}};e.Color=Dt,e.Color=Dt=je([D],Dt);let Ft=class{constructor(W,we){if(we&&!(we instanceof Dt))throw(0,O.illegalArgument)("color");if(!U.isRange(W)||W.isEmpty)throw(0,O.illegalArgument)("range");this.range=W,this.color=we}};e.ColorInformation=Ft,e.ColorInformation=Ft=je([D],Ft);let $t=class{constructor(W){if(!W||typeof W!="string")throw(0,O.illegalArgument)("label");this.label=W}};e.ColorPresentation=$t,e.ColorPresentation=$t=je([D],$t);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Wt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var zt;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(zt||(e.TerminalExitReason=zt={}));class Nt{constructor(W,we,Ae){if(this.startIndex=W,this.length=we,this.tooltip=Ae,typeof W!="number"||W<0)throw(0,O.illegalArgument)("startIndex");if(typeof we!="number"||we<1)throw(0,O.illegalArgument)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,O.illegalArgument)("tooltip")}}e.TerminalLink=Nt;class lt{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=lt;class ft{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=ft;var Tt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Tt||(e.TerminalLocation=Tt={}));class Ht{constructor(W){if(this.options=W,typeof W!="object")throw(0,O.illegalArgument)("options")}}e.TerminalProfile=Ht;var At;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var at;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(at||(e.TaskPanelKind=at={}));let wt=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(W,we){if(this.label=we,typeof W!="string"||typeof we!="string")throw(0,O.illegalArgument)("name");this._id=W}get id(){return this._id}};e.TaskGroup=wt,e.TaskGroup=wt=l=je([D],wt);function Ot(H){let W="";for(let we=0;we<H.length;we++)W+=H[we].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,we,Ae){if(typeof W!="string")throw(0,O.illegalArgument)("process");this._args=[],this._process=W,we!==void 0&&(Array.isArray(we)?(this._args=we,this._options=Ae):this._options=we)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,O.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const we of this._args)W.push(we);return Ot(W)}};e.ProcessExecution=Pt,e.ProcessExecution=Pt=je([D],Pt);let qe=class{constructor(W,we,Ae){if(this._args=[],Array.isArray(we)){if(!W)throw(0,O.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,O.illegalArgument)("command");this._command=W,this._args=we,this._options=Ae}else{if(typeof W!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=W,this._options=we}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,O.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const we of this._args)W.push(typeof we=="string"?we:we.value);return Ot(W)}};e.ShellExecution=qe,e.ShellExecution=qe=je([D],qe);var Kt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Kt||(e.ShellQuoting=Kt={}));var Le;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Le||(e.TaskScope=Le={}));class Oe{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Oe;let Ce=class{static{k=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(W,we,Ae,Ke,et,ot){this.__deprecated=!1,this._definition=this.definition=W;let dt;typeof we=="string"?(this._name=this.name=we,this._source=this.source=Ae,this.execution=Ke,dt=et,this.__deprecated=!0):we===Le.Global||we===Le.Workspace?(this.target=we,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=et,dt=ot):(this.target=we,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=et,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Pt?this._definition={type:k.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:k.ShellType,id:this._execution.computeId()}:this._execution instanceof Oe?this._definition={type:k.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:k.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,O.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,O.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const we=this._definition.type;(k.EmptyType===we||k.ProcessType===we||k.ShellType===we||k.ExtensionCallbackType===we)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,O.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};e.Task=Ce,e.Task=Ce=k=je([D],Ce);var ne;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(ne||(e.ProgressLocation=ne={}));var Fe;(function(H){function W(we){const Ae=we;return(0,y.isNumber)(Ae.value)?Ae.tooltip&&!(0,y.isString)(Ae.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ae.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ae.value),!1)}H.isViewBadge=W})(Fe||(e.ViewBadge=Fe={}));let He=C=class{static isTreeItem(W,we){const Ae=W;if(Ae.checkboxState!==void 0){const Ke=(0,y.isNumber)(Ae.checkboxState)?Ae.checkboxState:(0,y.isObject)(Ae.checkboxState)&&(0,y.isNumber)(Ae.checkboxState.state)?Ae.checkboxState.state:void 0,et=!(0,y.isNumber)(Ae.checkboxState)&&(0,y.isObject)(Ae.checkboxState)?Ae.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Ge.Checked&&Ke!==Ge.Unchecked||et!==void 0&&!(0,y.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Ae.checkboxState),!1}if(W instanceof C)return!0;if(Ae.label!==void 0&&!(0,y.isString)(Ae.label)&&!Ae.label?.label)return console.log("INVALID tree item, invalid label",Ae.label),!1;if(Ae.id!==void 0&&!(0,y.isString)(Ae.id))return console.log("INVALID tree item, invalid id",Ae.id),!1;if(Ae.iconPath!==void 0&&!(0,y.isString)(Ae.iconPath)&&!v.URI.isUri(Ae.iconPath)&&(!Ae.iconPath||!(0,y.isString)(Ae.iconPath.id))){const Ke=Ae.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!v.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!v.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ae.iconPath),!1}return Ae.description!==void 0&&!(0,y.isString)(Ae.description)&&typeof Ae.description!="boolean"?(console.log("INVALID tree item, invalid description",Ae.description),!1):Ae.resourceUri!==void 0&&!v.URI.isUri(Ae.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ae.resourceUri),!1):Ae.tooltip!==void 0&&!(0,y.isString)(Ae.tooltip)&&!(Ae.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",Ae.tooltip),!1):Ae.command!==void 0&&!Ae.command.command?(console.log("INVALID tree item, invalid command",Ae.command),!1):Ae.collapsibleState!==void 0&&Ae.collapsibleState<Je.None&&Ae.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ae.collapsibleState),!1):Ae.contextValue!==void 0&&!(0,y.isString)(Ae.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ae.contextValue),!1):Ae.accessibilityInformation!==void 0&&!Ae.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ae.accessibilityInformation),!1):!0}constructor(W,we=Je.None){this.collapsibleState=we,v.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.TreeItem=He,e.TreeItem=He=C=je([D],He);var Je;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var Ge;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(Ge||(e.TreeItemCheckboxState=Ge={}));let rt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.DataTransferItem=rt,e.DataTransferItem=rt=je([D],rt);class _t extends rt{}e.InternalDataTransferItem=_t;class Ct extends _t{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.InternalFileDataTransferItem=Ct;class gt{constructor(W,we,Ae,Ke){this.name=W,this.uri=we,this._itemId=Ae,this._getData=Ke}data(){return this._getData()}}e.DataTransferFile=gt;let ht=class{#e=new Map;constructor(W){for(const[we,Ae]of W??[]){const Ke=this.#e.get(this.#t(we));Ke?Ke.push(Ae):this.#e.set(this.#t(we),[Ae])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,we){this.#e.set(this.#t(W),[we])}forEach(W,we){for(const[Ae,Ke]of this.#e)for(const et of Ke)W.call(we,et,Ae,this)}*[Symbol.iterator](){for(const[W,we]of this.#e)for(const Ae of we)yield[W,Ae]}#t(W){return W.toLowerCase()}};e.DataTransfer=ht,e.DataTransfer=ht=je([D],ht);let mt=class{constructor(W){this.insertText=W}};e.DocumentDropEdit=mt,e.DocumentDropEdit=mt=je([D],mt);let gi=class{constructor(W,we){this.label=we,this.insertText=W}};e.DocumentPasteEdit=gi,e.DocumentPasteEdit=gi=je([D],gi);let It=class{constructor(W,we){this.id=W,this.color=we}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.ThemeIcon=It,e.ThemeIcon=It=je([D],It),It.File=new It("file"),It.Folder=new It("folder");let Di=class{constructor(W){this.id=W}};e.ThemeColor=Di,e.ThemeColor=Di=je([D],Di);var li;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let pi=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=v.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,we){if(typeof W!="string"&&(!W||!v.URI.isUri(W)&&!v.URI.isUri(W.uri)))throw(0,O.illegalArgument)("base");if(typeof we!="string")throw(0,O.illegalArgument)("pattern");typeof W=="string"?this.baseUri=v.URI.file(W):v.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=pi,e.RelativePattern=pi=je([D],pi);const kt=new WeakMap;function mn(H,W){kt.set(H,W)}e.setBreakpointId=mn;let ri=class{constructor(W,we,Ae,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof we=="string"&&(this.condition=we),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=kt.get(this)??(0,R.generateUuid)()),this._id}};e.Breakpoint=ri,e.Breakpoint=ri=je([D],ri);let St=class extends ri{constructor(W,we,Ae,Ke,et){if(super(we,Ae,Ke,et),W===null)throw(0,O.illegalArgument)("location");this.location=W}};e.SourceBreakpoint=St,e.SourceBreakpoint=St=je([D],St);let vi=class extends ri{constructor(W,we,Ae,Ke,et){super(we,Ae,Ke,et),this.functionName=W}};e.FunctionBreakpoint=vi,e.FunctionBreakpoint=vi=je([D],vi);let Ei=class extends ri{constructor(W,we,Ae,Ke,et,ot,dt){if(super(Ke,et,ot,dt),!we)throw(0,O.illegalArgument)("dataId");this.label=W,this.dataId=we,this.canPersist=Ae}};e.DataBreakpoint=Ei,e.DataBreakpoint=Ei=je([D],Ei);let si=class{constructor(W,we,Ae){this.command=W,this.args=we||[],this.options=Ae}};e.DebugAdapterExecutable=si,e.DebugAdapterExecutable=si=je([D],si);let Ii=class{constructor(W,we){this.port=W,this.host=we}};e.DebugAdapterServer=Ii,e.DebugAdapterServer=Ii=je([D],Ii);let ki=class{constructor(W){this.path=W}};e.DebugAdapterNamedPipeServer=ki,e.DebugAdapterNamedPipeServer=ki=je([D],ki);let Rt=class{constructor(W){this.implementation=W}};e.DebugAdapterInlineImplementation=Rt,e.DebugAdapterInlineImplementation=Rt=je([D],Rt);let bi=class{constructor(W,we,Ae){this.session=W,this.threadId=we,this.frameId=Ae}};e.StackFrameFocus=bi,e.StackFrameFocus=bi=je([D],bi);let Pi=class{constructor(W,we){this.session=W,this.threadId=we}};e.ThreadFocus=Pi,e.ThreadFocus=Pi=je([D],Pi);let oi=class{constructor(W,we){this.range=W,this.expression=we}};e.EvaluatableExpression=oi,e.EvaluatableExpression=oi=je([D],oi);var ui;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(ui||(e.InlineCompletionTriggerKind=ui={}));let ut=class{constructor(W,we){this.range=W,this.text=we}};e.InlineValueText=ut,e.InlineValueText=ut=je([D],ut);let Ti=class{constructor(W,we,Ae=!0){this.range=W,this.variableName=we,this.caseSensitiveLookup=Ae}};e.InlineValueVariableLookup=Ti,e.InlineValueVariableLookup=Ti=je([D],Ti);let Yt=class{constructor(W,we){this.range=W,this.expression=we}};e.InlineValueEvaluatableExpression=Yt,e.InlineValueEvaluatableExpression=Yt=je([D],Yt);let ii=class{constructor(W,we){this.frameId=W,this.stoppedLocation=we}};e.InlineValueContext=ii,e.InlineValueContext=ii=je([D],ii);var Ai;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Ai||(e.FileChangeType=Ai={}));let Ri=p=class extends Error{static FileExists(W){return new p(W,E.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(W){return new p(W,E.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(W){return new p(W,E.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(W){return new p(W,E.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(W){return new p(W,E.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(W){return new p(W,E.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(W,we=E.FileSystemProviderErrorCode.Unknown,Ae){super(v.URI.isUri(W)?W.toString(!0):W),this.code=Ae?.name??"Unknown",(0,E.markAsFileSystemProviderError)(this,we),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}};e.FileSystemError=Ri,e.FileSystemError=Ri=p=je([D],Ri);let Li=class{constructor(W,we,Ae){this.start=W,this.end=we,this.kind=Ae}};e.FoldingRange=Li,e.FoldingRange=Li=je([D],Li);var Xi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Qi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Qi||(e.CommentMode=Qi={}));var Oi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Oi||(e.CommentState=Oi={}));var ai;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(W,we=[]){this.tokenTypes=W,this.tokenModifiers=we}}e.SemanticTokensLegend=gn;function Mi(H){return typeof H>"u"||(0,y.isStringArray)(H)}class di{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let we=0,Ae=W.tokenTypes.length;we<Ae;we++)this._tokenTypeStrToInt.set(W.tokenTypes[we],we);for(let we=0,Ae=W.tokenModifiers.length;we<Ae;we++)this._tokenModifierStrToInt.set(W.tokenModifiers[we],we)}}push(W,we,Ae,Ke,et){if(typeof W=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(W,we,Ae,Ke,et);if(U.isRange(W)&&typeof we=="string"&&Mi(Ae))return this._push(W,we,Ae);throw(0,O.illegalArgument)()}_push(W,we,Ae){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(we))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,et=W.start.character,ot=W.end.character-W.start.character,dt=this._tokenTypeStrToInt.get(we);let Ut=0;if(Ae)for(const Qt of Ae){if(!this._tokenModifierStrToInt.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this._tokenModifierStrToInt.get(Qt);Ut|=1<<ei>>>0}this._pushEncoded(Ke,et,ot,dt,Ut)}_pushEncoded(W,we,Ae,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&we<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ut=this._data.length/5|0;let Qt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this._data[5*ti],Gi=this._data[5*ti+1];ni===0?(ni=Qt,Gi+=ei):ni+=Qt,this._data[5*ti]=ni,this._data[5*ti+1]=Gi,Qt=ni,ei=Gi}}let ot=W,dt=we;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ae,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=W,this._prevChar=we}static _sortAndDeltaEncode(W){const we=[],Ae=W.length/5|0;for(let dt=0;dt<Ae;dt++)we[dt]=dt;we.sort((dt,Ut)=>{const Qt=W[5*dt],ei=W[5*Ut];if(Qt===ei){const ti=W[5*dt+1],ni=W[5*Ut+1];return ti-ni}return Qt-ei});const Ke=new Uint32Array(W.length);let et=0,ot=0;for(let dt=0;dt<Ae;dt++){const Ut=5*we[dt],Qt=W[Ut+0],ei=W[Ut+1],ti=W[Ut+2],ni=W[Ut+3],Gi=W[Ut+4],kn=Qt-et,Fn=kn===0?ei-ot:ei,Ki=5*dt;Ke[Ki+0]=kn,Ke[Ki+1]=Fn,Ke[Ki+2]=ti,Ke[Ki+3]=ni,Ke[Ki+4]=Gi,et=Qt,ot=ei}return Ke}build(W){return this._dataIsSortedAndDeltaEncoded?new Ni(new Uint32Array(this._data),W):new Ni(di._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=di;class Ni{constructor(W,we){this.resultId=we,this.data=W}}e.SemanticTokens=Ni;class pn{constructor(W,we,Ae){this.start=W,this.deleteCount=we,this.data=Ae}}e.SemanticTokensEdit=pn;class hi{constructor(W,we){this.resultId=we,this.edits=W}}e.SemanticTokensEdits=hi;var Yi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let Ui=class{static{this.Back={iconPath:new It("arrow-left")}}constructor(){}};e.QuickInputButtons=Ui,e.QuickInputButtons=Ui=je([D],Ui);var Ji;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Ji||(e.QuickPickItemKind=Ji={}));var fi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var Zi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Zi||(e.ExtensionKind=Zi={}));class vn{static validate(W){if(typeof W.badge=="string"){let we=(0,g.nextCharLength)(W.badge,0);if(we<W.badge.length&&(we+=(0,g.nextCharLength)(W.badge,we)),W.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!It.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,we,Ae){this.badge=W,this.tooltip=we,this.color=Ae}}e.FileDecoration=vn;let xi=class{constructor(W){this.kind=W}};e.ColorTheme=xi,e.ColorTheme=xi=je([D],xi);var mi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class Jt{static isNotebookRange(W){return W instanceof Jt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,we){if(W<0)throw(0,O.illegalArgument)("start must be positive");if(we<0)throw(0,O.illegalArgument)("end must be positive");W<=we?(this._start=W,this._end=we):(this._start=we,this._end=W)}with(W){let we=this._start,Ae=this._end;return W.start!==void 0&&(we=W.start),W.end!==void 0&&(Ae=W.end),we===this._start&&Ae===this._end?this:new Jt(we,Ae)}}e.NotebookRange=Jt;class wi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(we=>wi.isNotebookCellData(we))}static isNotebookCellData(W){return!0}constructor(W,we,Ae,Ke,et,ot,dt){this.kind=W,this.value=we,this.languageId=Ae,this.mime=Ke,this.outputs=et??[],this.metadata=ot,this.executionSummary=dt,wi.validate(this)}}e.NotebookCellData=wi;class en{constructor(W){this.cells=W}}e.NotebookData=en;class Xt{static isNotebookCellOutputItem(W){return W instanceof Xt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const we={name:W.name,message:W.message,stack:W.stack};return Xt.json(we,"application/vnd.code.notebook.error")}static stdout(W){return Xt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Xt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,we="application/octet-stream"){return new Xt(W,we)}static#e=new TextEncoder;static text(W,we=T.Mimes.text){const Ae=Xt.#e.encode(String(W));return new Xt(Ae,we)}static json(W,we="text/x-json"){const Ae=JSON.stringify(W,void 0,"	");return Xt.text(Ae,we)}constructor(W,we){this.data=W,this.mime=we;const Ae=(0,T.normalizeMimeType)(we,!0);if(!Ae)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}}e.NotebookCellOutputItem=Xt;class Si{static isNotebookCellOutput(W){return W instanceof Si?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,we=!1){const Ae=new Set,Ke=new Set;for(let et=0;et<W.length;et++){const ot=W[et],dt=(0,T.normalizeMimeType)(ot.mime);if(!Ae.has(dt)||(0,_.isTextStreamMime)(dt)){Ae.add(dt);continue}Ke.add(et),we&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?W:W.filter((et,ot)=>!Ke.has(ot))}constructor(W,we,Ae){this.items=Si.ensureUniqueMimeTypes(W,!0),typeof we=="string"?(this.id=we,this.metadata=Ae):(this.id=(0,R.generateUuid)(),this.metadata=we??Ae)}}e.NotebookCellOutput=Si;var tn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var yi;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(yi||(e.NotebookEditorRevealType=yi={}));class sn{constructor(W,we){this.text=W,this.alignment=we}}e.NotebookCellStatusBarItem=sn;var Ue;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(Ue||(e.NotebookControllerAffinity=Ue={}));var Zt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(Zt||(e.NotebookControllerAffinity2=Zt={}));class on{constructor(W,we=[]){this.uri=W,this.provides=(0,I.asArray)(we)}}e.NotebookRendererScript=on;class pt{constructor(W){this.label=W}}e.NotebookKernelSourceAction=pt;let Bi=class{constructor(W,we){this.label=W,this.timestamp=we}};e.TimelineItem=Bi,e.TimelineItem=Bi=je([D],Bi);var an;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var $i;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})($i||(e.ExtensionRuntime=$i={}));var cn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class _i{constructor(W,we){this.ranges=W,this.wordPattern=we}}e.LinkedEditingRanges=_i;class En{constructor(W){this._autoForwardAction=W}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=En;var ln;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(ln||(e.TestResultState=ln={}));var un;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Ci=class{constructor(W=void 0,we=void 0,Ae=void 0,Ke=!1){this.include=W,this.exclude=we,this.profile=Ae,this.continuous=Ke}};e.TestRunRequest=Ci,e.TestRunRequest=Ci=je([D],Ci);let Wi=m=class{static diff(W,we,Ae){const Ke=new m(W);return Ke.expectedOutput=we,Ke.actualOutput=Ae,Ke}constructor(W){this.message=W}};e.TestMessage=Wi,e.TestMessage=Wi=m=je([D],Wi);let zi=class{constructor(W){this.id=W}};e.TestTag=zi,e.TestTag=zi=je([D],zi);let ci=class{constructor(W,we){this.covered=W,this.total=we}};e.CoveredCount=ci,e.CoveredCount=ci=je([D],ci);let Hi=b=class{static fromDetails(W,we){const Ae=new ci(0,0),Ke=new ci(0,0),et=new ci(0,0);for(const dt of we)if("branches"in dt){Ae.total+=1,Ae.covered+=dt.executionCount>0?1:0;for(const Ut of dt.branches)Ke.total+=1,Ke.covered+=Ut.executionCount>0?1:0}else et.total+=1,et.covered+=dt.executionCount>0?1:0;const ot=new b(W,Ae,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return ot.detailedCoverage=we,ot}constructor(W,we,Ae,Ke){this.uri=W,this.statementCoverage=we,this.branchCoverage=Ae,this.functionCoverage=Ke}};e.FileCoverage=Hi,e.FileCoverage=Hi=b=je([D],Hi);let Vi=class{constructor(W,we,Ae=[]){this.executionCount=W,this.location=we,this.branches=Ae}};e.StatementCoverage=Vi,e.StatementCoverage=Vi=je([D],Vi);let ji=class{constructor(W,we){this.executionCount=W,this.location=we}};e.BranchCoverage=ji,e.BranchCoverage=ji=je([D],ji);let qi=class{constructor(W,we){this.executionCount=W,this.location=we}};e.FunctionCoverage=qi,e.FunctionCoverage=qi=je([D],qi);var dn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(dn||(e.ExternalUriOpenerPriority=dn={}));var hn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var fn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class Ee{constructor(W,we,Ae,Ke,et,ot){this.kind=W,this.name=we,this.detail=Ae,this.uri=Ke,this.range=et,this.selectionRange=ot}}e.TypeHierarchyItem=Ee;class _e{constructor(W){this.uri=W}}e.TextTabInput=_e;class Ne{constructor(W,we){this.original=W,this.modified=we}}e.TextDiffTabInput=Ne;class st{constructor(W,we,Ae,Ke){this.base=W,this.input1=we,this.input2=Ae,this.result=Ke}}e.TextMergeTabInput=st;class Et{constructor(W,we){this.uri=W,this.viewType=we}}e.CustomEditorTabInput=Et;class Lt{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Lt;class Pn{constructor(W,we){this.uri=W,this.notebookType=we}}e.NotebookEditorTabInput=Pn;class Tn{constructor(W,we,Ae){this.original=W,this.modified=we,this.notebookType=Ae}}e.NotebookDiffEditorTabInput=Tn;class An{constructor(){}}e.TerminalEditorTabInput=An;class Rn{constructor(W,we){this.uri=W,this.inputBoxUri=we}}e.InteractiveWindowInput=Rn;var bn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var Sn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var yn;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(yn||(e.ChatMessageRole=yn={}));var _n;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(_n||(e.ChatVariableLevel=_n={}));class Ln{constructor(W,we){this.role=W,this.content=we}}e.ChatMessage=Ln;var Cn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Cn||(e.ChatAgentResultFeedbackKind=Cn={}));var Dn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var In;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(De[141],Ie([1,0,58,18,15,171,124,7,19]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const v=new Map;function R(_,w){w?v.set(_,w):v.delete(_)}e.setWordDefinitionFor=R;function P(_){return v.get(_)}class E extends A.MirrorTextModel{constructor(w,d,o,u,c,h,a,t){super(d,o,u,c),this._proxy=w,this._languageId=h,this._isDirty=a,this.notebook=t,this._isDisposed=!1}dispose(){(0,I.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,y.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===O.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},save(){return w._save()},getText(d){return d?w._getTextInRange(d):w.getText()},get eol(){return w._eol===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(d){return w._lineAt(d)},offsetAt(d){return w._offsetAt(d)},positionAt(d){return w._positionAt(d)},validateRange(d){return w._validateRange(d)},validatePosition(d){return w._validatePosition(d)},getWordRangeAtPosition(d,o){return w._getWordRangeAtPosition(d,o)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,I.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,I.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const d=this._validateRange(w);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const o=this._eol,u=d.start.line,c=d.end.line,h=[];h.push(this._lines[u].substring(d.start.character));for(let a=u+1;a<c;a++)h.push(this._lines[a]);return h.push(this._lines[c].substring(0,d.end.character)),h.join(o)}_lineAt(w){let d;if(w instanceof g.Position?d=w.line:typeof w=="number"&&(d=w),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new S(d,this._lines[d],d===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(w),o=this._lines[d.index].length;return new g.Position(d.index,Math.min(d.remainder,o))}_validateRange(w){if(!(w instanceof g.Range))throw new Error("Invalid argument");const d=this._validatePosition(w.start),o=this._validatePosition(w.end);return d===w.start&&o===w.end?w:new g.Range(d.line,d.character,o.line,o.character)}_validatePosition(w){if(!(w instanceof g.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:d,character:o}=w,u=!1;if(d<0)d=0,o=0,u=!0;else if(d>=this._lines.length)d=this._lines.length-1,o=this._lines[d].length,u=!0;else{const c=this._lines[d].length;o<0?(o=0,u=!0):o>c&&(o=c,u=!0)}return u?new g.Position(d,o):w}_getWordRangeAtPosition(w,d){const o=this._validatePosition(w);if(!d)d=P(this._languageId);else if((0,f.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const u=(0,T.getWordAtText)(o.character+1,(0,T.ensureValidWordDefinition)(d),this._lines[o.line],0);if(u)return new g.Range(o.line,u.startColumn-1,o.line,u.endColumn-1)}}e.ExtHostDocumentData=E;class S{constructor(w,d,o){this._line=w,this._text=d,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new g.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new g.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=S}),define(De[276],Ie([1,0,7,20,4]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(g){this._actual=new I.ColorTheme(I.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new f.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(g){let y;switch(g){case"light":y=I.ColorThemeKind.Light;break;case"hcDark":y=I.ColorThemeKind.HighContrast;break;case"hcLight":y=I.ColorThemeKind.HighContrastLight;break;default:y=I.ColorThemeKind.Dark}this._actual=new I.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=A,e.ExtHostTheming=A=je([$e(0,O.IExtHostRpcService)],A)}),define(De[277],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var O;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.INotebookExecutionService=(0,I.createDecorator)("INotebookExecutionService")}),define(De[68],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(A){A.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var O;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class f{static fromExtHostTestItem(T,g,y=T.parent){if(T._isRoot)return new f([g]);const v=[T.id];for(let R=y;R&&R.id!==g;R=R.parent)v.push(R.id);return v.push(g),new f(v.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const g=T.indexOf("\0");return g===-1?T:T.slice(0,g)}static fromString(T){return new f(T.split("\0"))}static join(T,g){return new f([...T.path,g])}static joinToString(T,g){return T.toString()+"\0"+g}static parentId(T){const g=T.lastIndexOf("\0");return g===-1?void 0:T.slice(0,g)}static localId(T){const g=T.lastIndexOf("\0");return g===-1?T:T.slice(g+1)}static isChild(T,g){return g.startsWith(T)&&g[T.length]==="\0"}static compare(T,g){return T===g?0:f.isChild(T,g)?2:f.isChild(g,T)?3:1}constructor(T,g=T.length){if(this.path=T,this.viewEnd=g,T.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.viewEnd>1?new f(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new f(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new f(this.path,T)}compare(T){if(typeof T=="string")return f.compare(this.toString(),T);for(let g=0;g<T.viewEnd&&g<this.viewEnd;g++)if(T.path[g]!==this.path[g])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=f}),define(De[87],Ie([1,0,2,32,68]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var T;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var g;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=C=>"runId"in C;e.isStartControllerTests=y;var v;(function(C){C.serialize=p=>({range:p.range.toJSON(),uri:p.uri.toJSON()}),C.deserialize=p=>({range:O.Range.lift(p.range),uri:I.URI.revive(p.uri)})})(v||(e.IRichLocation=v={}));var R;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(R||(e.TestMessageType=R={}));var P;(function(C){C.serialize=p=>({message:p.message,type:0,expected:p.expected,actual:p.actual,contextValue:p.contextValue,location:p.location&&v.serialize(p.location)}),C.deserialize=p=>({message:p.message,type:0,expected:p.expected,actual:p.actual,contextValue:p.contextValue,location:p.location&&v.deserialize(p.location)})})(P||(e.ITestErrorMessage=P={}));const E=(C,p)=>`${p?"s":"e"}${C}`;e.getMarkId=E;var S;(function(C){C.serialize=p=>({message:p.message,type:1,offset:p.offset,length:p.length,location:p.location&&v.serialize(p.location)}),C.deserialize=p=>({message:p.message,type:1,offset:p.offset,length:p.length,location:p.location&&v.deserialize(p.location)})})(S||(e.ITestOutputMessage=S={}));var _;(function(C){C.serialize=p=>p.type===0?P.serialize(p):S.serialize(p),C.deserialize=p=>p.type===0?P.deserialize(p):S.deserialize(p)})(_||(e.ITestMessage=_={}));var w;(function(C){C.serializeWithoutMessages=p=>({state:p.state,duration:p.duration,messages:[]}),C.serialize=p=>({state:p.state,duration:p.duration,messages:p.messages.map(_.serialize)}),C.deserialize=p=>({state:p.state,duration:p.duration,messages:p.messages.map(_.deserialize)})})(w||(e.ITestTaskState=w={}));const d="\0",o=(C,p)=>C+d+p;e.namespaceTestTag=o;const u=C=>{const p=C.indexOf(d);return{ctrlId:C.slice(0,p),tagId:C.slice(p+1)}};e.denamespaceTestTag=u;var c;(function(C){C.serialize=p=>({extId:p.extId,label:p.label,tags:p.tags,busy:p.busy,children:void 0,uri:p.uri?.toJSON(),range:p.range?.toJSON()||null,description:p.description,error:p.error,sortText:p.sortText}),C.deserialize=p=>({extId:p.extId,label:p.label,tags:p.tags,busy:p.busy,children:void 0,uri:p.uri?I.URI.revive(p.uri):void 0,range:p.range?O.Range.lift(p.range):null,description:p.description,error:p.error,sortText:p.sortText})})(c||(e.ITestItem=c={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var a;(function(C){C.serialize=p=>({expand:p.expand,item:c.serialize(p.item)}),C.deserialize=p=>({controllerId:f.TestId.root(p.item.extId),expand:p.expand,item:c.deserialize(p.item)})})(a||(e.InternalTestItem=a={}));var t;(function(C){C.serialize=p=>{let m;return p.item&&(m={},p.item.label!==void 0&&(m.label=p.item.label),p.item.tags!==void 0&&(m.tags=p.item.tags),p.item.busy!==void 0&&(m.busy=p.item.busy),p.item.uri!==void 0&&(m.uri=p.item.uri?.toJSON()),p.item.range!==void 0&&(m.range=p.item.range?.toJSON()),p.item.description!==void 0&&(m.description=p.item.description),p.item.error!==void 0&&(m.error=p.item.error),p.item.sortText!==void 0&&(m.sortText=p.item.sortText)),{extId:p.extId,expand:p.expand,item:m}},C.deserialize=p=>{let m;return p.item&&(m={},p.item.label!==void 0&&(m.label=p.item.label),p.item.tags!==void 0&&(m.tags=p.item.tags),p.item.busy!==void 0&&(m.busy=p.item.busy),p.item.range!==void 0&&(m.range=p.item.range?O.Range.lift(p.item.range):null),p.item.description!==void 0&&(m.description=p.item.description),p.item.error!==void 0&&(m.error=p.item.error),p.item.sortText!==void 0&&(m.sortText=p.item.sortText)),{extId:p.extId,expand:p.expand,item:m}}})(t||(e.ITestItemUpdate=t={}));const i=(C,p)=>{p.expand!==void 0&&(C.expand=p.expand),p.item!==void 0&&(C.item=C.item?Object.assign(C.item,p.item):p.item)};e.applyTestItemUpdate=i;var s;(function(C){C.serializeWithoutMessages=p=>({...a.serialize(p),ownComputedState:p.ownComputedState,computedState:p.computedState,tasks:p.tasks.map(w.serializeWithoutMessages)}),C.serialize=p=>({...a.serialize(p),ownComputedState:p.ownComputedState,computedState:p.computedState,tasks:p.tasks.map(w.serialize)}),C.deserialize=p=>({...a.deserialize(p),ownComputedState:p.ownComputedState,computedState:p.computedState,tasks:p.tasks.map(w.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var n;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(n||(e.DetailType=n={}));var r;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(r||(e.TestDiffOpType=r={}));var l;(function(C){C.deserialize=p=>p.op===0?{op:p.op,item:a.deserialize(p.item)}:p.op===1?{op:p.op,item:t.deserialize(p.item)}:p.op===2?{op:p.op,uri:I.URI.revive(p.uri),docv:p.docv}:p,C.serialize=p=>p.op===0?{op:p.op,item:a.serialize(p.item)}:p.op===1?{op:p.op,item:t.serialize(p.item)}:p})(l||(e.TestsDiffOp=l={}));class k{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(p){const m=this.createChangeCollector();for(const b of p)switch(b.op){case 0:this.add(a.deserialize(b.item),m);break;case 1:this.update(t.deserialize(b.item),m);break;case 3:this.remove(b.itemId,m);break;case 5:this.retireTest(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this._tags.set(b.tag.id,b.tag);break;case 7:this._tags.delete(b.id);break}m.complete?.()}add(p,m){const b=f.TestId.parentId(p.item.extId)?.toString();let D;if(!b)D=this.createItem(p),this.roots.add(D),this.items.set(p.item.extId,D);else if(this.items.has(b)){const M=this.items.get(b);M.children.add(p.item.extId),D=this.createItem(p,M),this.items.set(p.item.extId,D)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(p)}`);return}return m.add?.(D),p.expand===2&&this.busyControllerCount++,D}update(p,m){const b=this.items.get(p.extId);if(b)return p.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,p),m.update?.(b),b}remove(p,m){const b=this.items.get(p);if(!b)return;const D=f.TestId.parentId(b.item.extId)?.toString();D?this.items.get(D).children.delete(b.item.extId):this.roots.delete(b);const M=[[p]];for(;M.length;)for(const L of M.pop()){const F=this.items.get(L);F&&(M.push(F.children),this.items.delete(L),m.remove?.(F,F!==b),F.expand===2&&this.busyControllerCount--)}}retireTest(p){}updatePendingRoots(p){this.pendingRootCount+=p}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=k}),define(De[109],Ie([1,0,8,4,3,58,87,68]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const v=(u,c)=>u===c,P=Object.entries({range:(u,c)=>u===c?!0:!u||!c?!1:u.equalsRange(c),busy:v,label:v,description:v,error:v,sortText:v,tags:(u,c)=>!(u.length!==c.length||u.some(h=>!c.includes(h)))}),E=(u,c)=>{let h;for(const[a,t]of P)t(u[a],c[a])||(h?h[a]=c[a]:h={[a]:c[a]});return h};class S extends f.Disposable{get root(){return this.options.root}constructor(c){super(),this.options=c,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new O.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const h of this.tree.values())this.updateExpandability(h)}get resolveHandler(){return this._resolveHandler}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){switch(c.op){case 2:{for(const h of this.diff)if(h.op===2&&h.uri===c.uri){h.docv=c.docv;return}break}case 1:{const h=this.diff[this.diff.length-1];if(h){if(h.op===1&&h.item.extId===c.item.extId){(0,T.applyTestItemUpdate)(h.item,c.item);return}if(h.op===0&&h.item.item.extId===c.item.extId){(0,T.applyTestItemUpdate)(h.item,c.item);return}}break}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,h){const a=this.tree.get(c);if(a){if((a.expandLevels===void 0||h>a.expandLevels)&&(a.expandLevels=h),a.expand===1){const t=this.resolveChildren(a);return t.isOpen()?this.expandChildren(a,h-1):t.wait().then(()=>this.expandChildren(a,h-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,h-1)):this.expandChildren(a,h-1)}}dispose(){for(const c of this.tree.values())this.options.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,h){switch(h.op){case 3:this.removeItem(g.TestId.joinToString(c.fullId,h.id));break;case 0:this.upsertItem(h.item,c);break;case 5:for(const a of h.ops)this.onTestItemEvent(c,a);break;case 1:this.diffTagRefs(h.new,h.old,c.fullId.toString());break;case 2:this.updateExpandability(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:h.update}});break;case 6:this.documentSynced(c.actual.uri);break;default:(0,A.assertNever)(h)}}documentSynced(c){c&&this.pushDiff({op:2,uri:c,docv:this.options.getDocumentVersion(c)})}upsertItem(c,h){const a=g.TestId.fromExtHostTestItem(c,this.root.id,h?.actual),t=this.options.getApiFor(c);t.parent&&t.parent!==h?.actual&&this.options.getChildren(t.parent).delete(c.id);let i=this.tree.get(a.toString());if(!i){i={fullId:a,actual:c,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(c,h),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(c)}}),this.connectItemAndChildren(c,i,h);return}if(i.actual===c){this.connectItem(c,i,h);return}if(i.actual.uri?.toString()!==c.uri?.toString())return this.removeItem(a.toString()),this.upsertItem(c,h);const s=this.options.getChildren(i.actual),n=i.actual,r=E(this.options.toITestItem(n),this.options.toITestItem(c));this.options.getApiFor(n).listener=void 0,i.actual=c,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.diffTagRefs(c.tags,n.tags,a.toString()),delete r.tags),this.onTestItemEvent(i,{op:4,update:r})),this.connectItemAndChildren(c,i,h);for(const[l,k]of s)this.options.getChildren(c).get(k.id)||this.removeItem(g.TestId.joinToString(a,k.id));this.documentSynced(i.actual.uri)}diffTagRefs(c,h,a){const t=new Set(h.map(i=>i.id));for(const i of c)t.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:a,item:{tags:c.map(i=>(0,T.namespaceTestTag)(this.options.controllerId,i.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const h=this.tags.get(c.id);h?h.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,c.id)}}))}decrementTagRefs(c){const h=this.tags.get(c);h&&!--h.refCount&&(this.tags.delete(c),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,c)}))}setItemParent(c,h){this.options.getApiFor(c).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(c,h,a){this.setItemParent(c,a);const t=this.options.getApiFor(c);t.parent=a?.actual,t.listener=i=>this.onTestItemEvent(h,i),this.updateExpandability(h)}connectItemAndChildren(c,h,a){this.connectItem(c,h,a);for(const[t,i]of this.options.getChildren(c))this.upsertItem(i,h)}updateExpandability(c){let h;this._resolveHandler?c.resolveBarrier?h=c.resolveBarrier.isOpen()?3:2:h=c.actual.canResolveChildren?1:0:h=0,h!==c.expand&&(c.expand=h,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:h}}),h===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,h){if(h<0)return;const a=[];for(const[t,i]of this.options.getChildren(c.actual)){const s=this.expand(g.TestId.joinToString(c.fullId,i.id),h);(0,I.isThenable)(s)&&a.push(s)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const i=new I.Barrier;return i.open(),i}c.expand=2,this.pushExpandStateUpdate(c);const h=c.resolveBarrier=new I.Barrier,a=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let t;try{t=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(i){a(i)}return(0,I.isThenable)(t)?t.catch(a).then(()=>{h.open(),this.updateExpandability(c)}):(h.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}removeItem(c){const h=this.tree.get(c);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const a=[h];for(;a.length;){const t=a.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const i of t.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(t.fullId.toString());for(const[i,s]of this.options.getChildren(t.actual))a.push(this.tree.get(g.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.TestItemCollection=S;class _ extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=_;class w extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class d extends Error{constructor(c,h,a){super(`TestItem with ID "${c}" is from controller "${h}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=d;const o=(u,c,h)=>{let a=new Map;return{get size(){return a.size},forEach(t,i){for(const s of a.values())t.call(i,s,this)},[Symbol.iterator](){return a.entries()},replace(t){const i=new Map,s=new Set(a.keys()),n={op:5,ops:[]};for(const r of t){if(!(r instanceof h))throw new w(r.id);const l=c(r).controllerId;if(l!==u.controllerId)throw new d(r.id,l,u.controllerId);if(i.has(r.id))throw new _(r.id);i.set(r.id,r),s.delete(r.id),n.ops.push({op:0,item:r})}for(const r of s.keys())n.ops.push({op:3,id:r});u.listener?.(n),a=i},add(t){if(!(t instanceof h))throw new w(t.id);a.set(t.id,t),u.listener?.({op:0,item:t})},delete(t){a.delete(t)&&u.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=o}),define(De[142],Ie([1,0,109]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const O=new WeakMap,f=(T,g)=>{const y={controllerId:g};return O.set(T,y),y};e.createPrivateApiFor=f;const A=T=>{const g=O.get(T);if(!g)throw new I.InvalidTestItemError(T?.id||"<unknown>");return g};e.getPrivateApiFor=A}),define(De[110],Ie([1,0,18,2]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function f(g,y){return g.scheme===I.Schemas.http||g.scheme===I.Schemas.https?g:(y&&y.authority&&y.isRemote&&g.scheme===I.Schemas.file&&(g=O.URI.from({scheme:I.Schemas.vscodeRemote,authority:y.authority,path:g.path})),O.URI.from({scheme:I.Schemas.https,authority:`${g.scheme}+${A(g.authority)}.${e.webviewRootResourceAuthority}`,path:g.path,fragment:g.fragment,query:g.query}))}e.asWebviewUri=f;function A(g){return g.replace(/./g,y=>{const v=y.charCodeAt(0);return v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57?y:"-"+v.toString(16).padStart(4,"0")})}function T(g){return g.replace(/-([0-9a-f]{4})/g,(y,v)=>String.fromCharCode(parseInt(v,16)))}e.decodeAuthority=T}),define(De[278],Ie([1,0,4,3,110]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(g,y,v){this._proxy=g,this._editors=y,this._remoteInfo=v,this._handlePool=0,this._disposables=new O.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const R=y.getVisibleTextEditors();for(const P of this._insets.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(g=>g.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(g,y,v,R,P){let E;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===g){E=c;break}if(!E)throw new Error("not a visible editor");const S=this,_=this._handlePool++,w=new I.Emitter,d=new I.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,f.asWebviewUri)(c,S._remoteInfo)}get cspSource(){return f.webviewGenericCspSource}set options(c){this._options=c,S._proxy.$setOptions(_,c)}get options(){return this._options}set html(c){this._html=c,S._proxy.$setHtml(_,c)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(c){return S._proxy.$postMessage(_,c)}},u=new class{constructor(){this.editor=g,this.line=y,this.height=v,this.webview=o,this.onDidDispose=d.event}dispose(){S._insets.has(_)&&(S._insets.delete(_),S._proxy.$disposeEditorInset(_),d.fire(),d.dispose(),w.dispose())}};return this._proxy.$createEditorInset(_,E.id,E.value.document.uri,y+1,v,R||{},P.identifier,P.extensionLocation),this._insets.set(_,{editor:g,inset:u,onDidReceiveMessage:w}),u}$onDidDispose(g){const y=this._insets.get(g);y&&y.inset.dispose()}$onDidReceiveMessage(g,y){this._insets.get(g)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=A}),define(De[279],Ie([1,0,5]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService");var O;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(O||(e.VariableKind=O={}));class f extends Error{constructor(T,g){super(g),this.variable=T}}e.VariableError=f}),define(De[280],Ie([1,0,16,48,17,24,12,99,224,279,15]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,_,w,d){this._contributedVariables=new Map,this._context=S,this._labelService=_,this._userHomePromise=w,d&&(this._envVariablesPromise=d.then(o=>this.prepareEnv(o)))}prepareEnv(S){if(T.isWindows){const _=Object.create(null);return Object.keys(S).forEach(w=>{_[w.toLowerCase()]=S[w]}),_}return S}resolveWithEnvironment(S,_,w){return this.recursiveResolve({env:this.prepareEnv(S),userHome:void 0},_?_.uri:void 0,w)}async resolveAsync(S,_){const w={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(w,S?S.uri:void 0,_)}async resolveAnyBase(S,_,w,d){const o=A.deepClone(_);T.isWindows&&o.windows?Object.keys(o.windows).forEach(c=>o[c]=o.windows[c]):T.isMacintosh&&o.osx?Object.keys(o.osx).forEach(c=>o[c]=o.osx[c]):T.isLinux&&o.linux&&Object.keys(o.linux).forEach(c=>o[c]=o.linux[c]),delete o.windows,delete o.osx,delete o.linux;const u={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(u,S?S.uri:void 0,o,w,d)}async resolveAnyAsync(S,_,w){return this.resolveAnyBase(S,_,w)}async resolveAnyMap(S,_,w){const d=new Map;return{newConfig:await this.resolveAnyBase(S,_,w,d),resolvedVariables:d}}resolveWithInteractionReplace(S,_,w,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,_,w,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,_){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,_)}async recursiveResolve(S,_,w,d,o){if(f.isString(w))return this.resolveString(S,_,w,d,o);if(Array.isArray(w))return Promise.all(w.map(u=>this.recursiveResolve(S,_,u,d,o)));if(f.isObject(w)){const u=Object.create(null),c=await Promise.all(Object.keys(w).map(async h=>[await this.resolveString(S,_,h,d,o),await this.recursiveResolve(S,_,w[h],d,o)]));for(const[h,a]of c)u[h]=a;return u}return w}resolveString(S,_,w,d,o){return(0,R.replaceAsync)(w,P.VARIABLE_REGEXP,async(u,c)=>{if(c.includes(P.VARIABLE_LHS))return u;let h=await this.evaluateSingleVariable(S,u,c,_,d);return o?.set(c,h),h!==u&&f.isString(h)&&h.match(P.VARIABLE_REGEXP)&&(h=await this.resolveString(S,_,h,d,o)),h})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}async evaluateSingleVariable(S,_,w,d,o){let u;const c=w.split(":");c.length>1&&(w=c[0],u=c[1]);const h=i=>{const s=this._context.getFilePath();if(s)return(0,g.normalizeDriveLetter)(s);throw new v.VariableError(i,(0,y.localize)(0,null,_))},a=i=>{const s=h(i);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return(0,g.normalizeDriveLetter)(n)}throw new v.VariableError(i,(0,y.localize)(1,null,_,I.basename(s)))},t=i=>{if(u){const s=this._context.getFolderUri(u);if(s)return s;throw new v.VariableError(i,(0,y.localize)(2,null,_,u))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new v.VariableError(i,(0,y.localize)(3,null,_)):new v.VariableError(i,(0,y.localize)(4,null,_))};switch(w){case"env":if(u){if(S.env){const i=S.env[T.isWindows?u.toLowerCase():u];if(f.isString(i))return i}return""}throw new v.VariableError(v.VariableKind.Env,(0,y.localize)(5,null,_));case"config":if(u){const i=this._context.getConfigurationValue(d,u);if(f.isUndefinedOrNull(i))throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(6,null,_,u));if(f.isObject(i))throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(7,null,_,u));return i}throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(8,null,_));case"command":return this.resolveFromMap(v.VariableKind.Command,_,u,o,"command");case"input":return this.resolveFromMap(v.VariableKind.Input,_,u,o,"input");case"extensionInstallFolder":if(u){const i=await this._context.getExtension(u);if(!i)throw new v.VariableError(v.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,_,u));return this.fsPath(i.extensionLocation)}throw new v.VariableError(v.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,_));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,g.normalizeDriveLetter)(this.fsPath(t(v.VariableKind.WorkspaceFolder)));case"cwd":return d||u?(0,g.normalizeDriveLetter)(this.fsPath(t(v.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.normalizeDriveLetter)(I.basename(this.fsPath(t(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new v.VariableError(v.VariableKind.UserHome,(0,y.localize)(11,null,_))}case"lineNumber":{const i=this._context.getLineNumber();if(i)return i;throw new v.VariableError(v.VariableKind.LineNumber,(0,y.localize)(12,null,_))}case"selectedText":{const i=this._context.getSelectedText();if(i)return i;throw new v.VariableError(v.VariableKind.SelectedText,(0,y.localize)(13,null,_))}case"file":return h(v.VariableKind.File);case"fileWorkspaceFolder":return a(v.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||u?I.relative(this.fsPath(t(v.VariableKind.RelativeFile)),h(v.VariableKind.RelativeFile)):h(v.VariableKind.RelativeFile);case"relativeFileDirname":{const i=I.dirname(h(v.VariableKind.RelativeFileDirname));if(d||u){const s=I.relative(this.fsPath(t(v.VariableKind.RelativeFileDirname)),i);return s.length===0?".":s}return i}case"fileDirname":return I.dirname(h(v.VariableKind.FileDirname));case"fileExtname":return I.extname(h(v.VariableKind.FileExtname));case"fileBasename":return I.basename(h(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=I.basename(h(v.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-I.extname(i).length)}case"fileDirnameBasename":return I.basename(I.dirname(h(v.VariableKind.FileDirnameBasename)));case"execPath":{const i=this._context.getExecPath();return i||_}case"execInstallFolder":{const i=this._context.getAppRoot();return i||_}case"pathSeparator":return I.sep;default:try{const i=u?`${w}:${u}`:w;return this.resolveFromMap(v.VariableKind.Unknown,_,i,o,void 0)}catch{return _}}}}resolveFromMap(S,_,w,d,o){if(w&&d){const u=o===void 0?d[w]:d[o+":"+w];if(typeof u=="string")return u;throw new v.VariableError(S,(0,y.localize)(14,null,_))}return _}}e.AbstractVariableResolverService=P}),define(De[143],Ie([1,0,5,139]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var f;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var A;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var T;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var g;(function(_){_[_.MAXIMIZE=0]="MAXIMIZE",_[_.EXPAND=1]="EXPAND",_[_.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var y;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function v(_){const w=_;return(0,O.isEditorInput)(w?.editor)&&(0,O.isEditorInput)(w?.replacement)}e.isEditorReplacement=v;var R;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var P;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function E(_){const w=_;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=E;function S(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(De[281],Ie([1,0,5,143]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function f(A){const T=A;return typeof A=="number"||(0,O.isEditorGroup)(T)}e.isPreferredGroup=f}),define(De[144],Ie([1,0,5,131]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,I.refineServiceDecorator)(O.IEnvironmentService)}),define(De[145],Ie([1,0,25,4,16,3]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(o,u){this.versionId=o,this.removedDueToLooping=u}}e.DeltaExtensionsResult=T;class g{static isHostExtension(o,u,c){if(u.getExtensionDescription(o))return!1;const h=c.getExtensionDescription(o);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(o,u){this._activationEventsReader=o,this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=u,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new I.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const o of this._extensionDescriptions){if(this._extensionsMap.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this._extensionsMap.set(o.identifier,o),this._extensionsArr.push(o);const u=this._activationEventsReader.readActivationEvents(o);if(Array.isArray(u))for(let c of u)c==="onUri"&&(c=`onUri:${I.ExtensionIdentifier.toKey(o.identifier)}`),this._activationMap.has(c)||this._activationMap.set(c,[]),this._activationMap.get(c).push(o)}}set(o){return this._extensionDescriptions=o,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(o,u){this._extensionDescriptions=w(this._extensionDescriptions,u),this._extensionDescriptions=this._extensionDescriptions.concat(o);const c=g._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=w(this._extensionDescriptions,c.map(h=>h.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new T(this._versionId,c)}static _findLoopingExtensions(o){const u=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(i){this._nodesSet.has(i)||(this._nodesSet.add(i),this._nodesArr.push(i))}addArc(i,s){this.addNode(i),this.addNode(s),this._arcs.has(i)?this._arcs.get(i).push(s):this._arcs.set(i,[s])}getArcs(i){return this._arcs.has(i)?this._arcs.get(i):[]}hasOnlyGoodArcs(i,s){const n=u.getArcs(i);for(let r=0;r<n.length;r++)if(!s.has(n[r]))return!1;return!0}getNodes(){return this._nodesArr}},c=new I.ExtensionIdentifierMap;for(const i of o)if(c.set(i.identifier,i),i.extensionDependencies)for(const s of i.extensionDependencies)u.addArc(I.ExtensionIdentifier.toKey(i.identifier),I.ExtensionIdentifier.toKey(s));const h=new Set;u.getNodes().filter(i=>u.getArcs(i).length===0).forEach(i=>h.add(i));const a=u.getNodes().filter(i=>!h.has(i));let t;do{t=!1;for(let i=0;i<a.length;i++){const s=a[i];u.hasOnlyGoodArcs(s,h)&&(a.splice(i,1),i--,h.add(s),t=!0)}}while(t);return a.map(i=>c.get(i))}containsActivationEvent(o){return this._activationMap.has(o)}containsExtension(o){return this._extensionsMap.has(o)}getExtensionDescriptionsForActivationEvent(o){const u=this._activationMap.get(o);return u?u.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new y(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(o){const u=this._extensionsMap.get(o);return u||void 0}getExtensionDescriptionByUUID(o){for(const u of this._extensionsArr)if(u.uuid===o)return u}getExtensionDescriptionByIdOrUUID(o,u){return this.getExtensionDescription(o)??(u?this.getExtensionDescriptionByUUID(u):void 0)}}e.ExtensionDescriptionRegistry=g;class y{constructor(o,u){this.versionId=o,this.extensions=u}}e.ExtensionDescriptionRegistrySnapshot=y,e.basicActivationEventsReader={readActivationEvents:d=>d.activationEvents};class v{constructor(o){this._lock=new E,this._actual=new g(o,[])}async acquireLock(o){const u=await this._lock.acquire(o);return new R(this,u)}deltaExtensions(o,u,c){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(u,c)}containsActivationEvent(o){return this._actual.containsActivationEvent(o)}containsExtension(o){return this._actual.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this._actual.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(o){return this._actual.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this._actual.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,u){return this._actual.getExtensionDescriptionByIdOrUUID(o,u)}}e.LockableExtensionDescriptionRegistry=v;class R extends A.Disposable{constructor(o,u){super(),this._registry=o,this._isDisposed=!1,this._register(u)}isAcquiredFor(o){return!this._isDisposed&&this._registry===o}}e.ExtensionDescriptionRegistryLock=R;class P{constructor(o){this.name=o,this.promise=new Promise((u,c)=>{this._resolve=u})}resolve(o){this._resolve(o)}}class E{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(o){const u=new P(o);return this._pendingCustomers.push(u),this._advance(),u.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const o=this._pendingCustomers.shift();this._isLocked=!0;let u=!0;const c=setTimeout(()=>{u&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{u&&(clearTimeout(c),u=!1,this._isLocked=!1,this._advance())};o.resolve((0,A.toDisposable)(h))}}var S;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(S||(S={}));function _(d,o){const u=d.isBuiltin?0:d.isUnderDevelopment?2:1,c=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(u!==c)return u-c;const h=f.posix.basename(d.extensionLocation.path),a=f.posix.basename(o.extensionLocation.path);return h<a?-1:h>a?1:0}function w(d,o){const u=new I.ExtensionIdentifierSet(o);return d.filter(c=>!u.has(c.identifier))}}),define(De[282],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var I;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[O.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=O;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[f.ENV_KEY]="1"}}e.SocketExtHostConnection=f;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A;function T(R){delete R[O.ENV_KEY],delete R[f.ENV_KEY],delete R[A.ENV_KEY]}function g(R,P){T(P),R.serialize(P)}e.writeExtHostConnection=g;function y(R){if(R[O.ENV_KEY])return v(R,new O(R[O.ENV_KEY]));if(R[f.ENV_KEY])return v(R,new f);if(R[A.ENV_KEY])return v(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function v(R,P){return T(R),P}}),define(De[111],Ie([1,0,22]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(O||(e.UIKind=O={}));var f;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var A;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function T(v){const R=I.VSBuffer.alloc(1);switch(v){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=T;function g(v,R){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=g;var y;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(De[88],Ie([1,0,5,4,14,27,111,66,85,24,2,3,211]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let S=class extends P.Disposable{constructor(o,u){super(),this.initData=o,this.loggerService=u,this._onDidChangeTelemetryEnabled=this._register(new O.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new O.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=u.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,E.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(u.onDidChangeLogLevel(c=>{(0,f.isLogLevel)(c)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(o,u,c){const h=this.getTelemetryDetails(),a=new _(u,c,o,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(o),{isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}),t=this._telemetryLoggers.get(o.identifier.value)??[];return this._telemetryLoggers.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,u,c){this._level=o,this._telemetryIsSupported=u,this._productConfig=c??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(o){const u=Object.create(null);switch(u["common.extname"]=`${o.publisher}.${o.name}`,u["common.extversion"]=o.version,u["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,u["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,u["common.vscodeversion"]=this.initData.version,u["common.isnewappinstall"]=w(this.initData.telemetryInfo.firstSessionDate),u["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:u["common.uikind"]="web";break;case T.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,g.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),u}$onDidChangeTelemetryLevel(o){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=o;const u=this.getTelemetryDetails();this._telemetryLoggers.forEach((c,h)=>{const a=c.filter(t=>!t.isDisposed);a.length===0?this._telemetryLoggers.delete(h):this._telemetryLoggers.set(h,a)}),this._telemetryLoggers.forEach(c=>{for(const h of c)h.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(o,u){const h=this._telemetryLoggers.get(o.value)?.filter(t=>!t.isDisposed);if(!h)return this._telemetryLoggers.delete(o.value),!1;let a=!1;for(const t of h)t.ignoreUnhandledExtHostErrors||(t.logError(u),a=!0);return a}};e.ExtHostTelemetry=S,e.ExtHostTelemetry=S=je([$e(0,A.IExtHostInitDataService),$e(1,f.ILoggerService)],S);class _{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,u,c,h,a,t,i){this._extension=c,this._logger=h,this._inLoggingOnlyMode=a,this._commonProperties=t,this._onDidChangeEnableStates=new O.Emitter,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=u?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=u?.additionalCommonProperties,this._sender=o,this._telemetryEnablements={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(o,u){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:o,isErrorsEnabled:u},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(o){let u="properties"in o?o.properties??{}:o;return u=(0,y.cleanData)(u,[]),this._additionalCommonProperties&&(u=(0,v.mixin)(u,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(u=(0,v.mixin)(u,this._commonProperties)),"properties"in o?o.properties=u:o=u,o}logEvent(o,u){this._sender&&(this._extension.publisher==="vscode"?o=this._extension.name+"/"+o:o=this._extension.identifier.value+"/"+o,u=this.mixInCommonPropsAndCleanData(u||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(o,u),this._logger.trace(o,u))}logUsage(o,u){this._telemetryEnablements.isUsageEnabled&&this.logEvent(o,u)}logError(o,u){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof o=="string")this.logEvent(o,u);else{const c={name:o.name,message:o.message,stack:o.stack,cause:o.cause},h=(0,y.cleanData)(c,[]),a=new Error(h.message,{cause:h.cause});a.stack=h.stack,a.name=h.name,u=this.mixInCommonPropsAndCleanData(u||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(a,u),this._logger.trace("exception",u)}}get apiTelemetryLogger(){if(!this._apiObject){const o=this,u={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return o._telemetryEnablements.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o._onDidChangeEnableStates.event.bind(o)};this._apiObject=Object.freeze(u)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let o=this._sender;this._sender=void 0,Promise.resolve(o.flush()).then(o=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=_;function w(d){const o=Date.now()-new Date(d).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.isNewAppInstall=w,e.IExtHostTelemetry=(0,I.createDecorator)("IExtHostTelemetry")}),define(De[26],Ie([1,0,4,2,253,137,25,5]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,g.createDecorator)("extensionService");class y{constructor(a){this.dependency=a}}e.MissingExtensionDependency=y;var v;(function(h){h[h.EagerAutoStart=1]="EagerAutoStart",h[h.EagerManualStart=2]="EagerManualStart",h[h.Lazy=3]="Lazy"})(v||(e.ExtensionHostStartup=v={}));class R{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(a,t,i){this._versionId=a,this._allExtensions=t.slice(0),this._myExtensions=i.slice(0)}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(a,t,i){if(this._versionId>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this._versionId})`);const s=[],n=[],r=[],l=[],k=P(this._allExtensions),C=P(t),p=(L,F)=>L.extensionLocation.toString()===F.extensionLocation.toString()||L.isBuiltin===F.isBuiltin||L.isUserBuiltin===F.isUserBuiltin||L.isUnderDevelopment===F.isUnderDevelopment;for(const L of this._allExtensions){const F=C.get(L.identifier);if(!F){s.push(L.identifier),k.delete(L.identifier);continue}if(!p(L,F)){s.push(L.identifier),k.delete(L.identifier);continue}}for(const L of t){const F=k.get(L.identifier);if(!F){n.push(L);continue}if(!p(F,L)){s.push(F.identifier),k.delete(F.identifier);continue}}const m=new T.ExtensionIdentifierSet(this._myExtensions),b=new T.ExtensionIdentifierSet(i);for(const L of this._myExtensions)b.has(L)||r.push(L);for(const L of i)m.has(L)||l.push(L);const D=A.ImplicitActivationEvents.createActivationEventsMap(n),M={versionId:a,toRemove:s,toAdd:n,addActivationEvents:D,myToRemove:r,myToAdd:l};return this.delta(M),M}delta(a){if(this._versionId>=a.versionId)return null;const{toRemove:t,toAdd:i,myToRemove:s,myToAdd:n}=a,r=new T.ExtensionIdentifierSet(t),l=new T.ExtensionIdentifierSet(s);for(let k=0;k<this._allExtensions.length;k++)r.has(this._allExtensions[k].identifier)&&(this._allExtensions.splice(k,1),k--);for(let k=0;k<this._myExtensions.length;k++)l.has(this._myExtensions[k])&&(this._myExtensions.splice(k,1),k--);for(const k of i)this._allExtensions.push(k);for(const k of n)this._myExtensions.push(k);return a}containsExtension(a){for(const t of this._myExtensions)if(T.ExtensionIdentifier.equals(t,a))return!0;return!1}}e.ExtensionHostExtensions=R;function P(h){const a=new T.ExtensionIdentifierMap;for(const t of h)a.set(t.identifier,t);return a}function E(h,a){return h.enabledApiProposals?h.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=E;function S(h,a){if(!E(h,a))throw new Error(`Extension '${h.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${h.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.checkProposedApiEnabled=S;class _{constructor(a,t,i,s){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=i,this.activationReason=s}}e.ActivationTimes=_;class w{constructor(a,t){this.description=a,this.value=t}}e.ExtensionPointContribution=w;var d;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function o(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,f.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation,targetPlatform:h.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function u(h,a){return{identifier:new T.ExtensionIdentifier((0,f.getExtensionId)(h.manifest.publisher,h.manifest.name)),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!a,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid,targetPlatform:h.targetPlatform}}e.toExtensionDescription=u;class c{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=c}),define(De[283],Ie([1,0,9,145,25,26,14,8]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(o,u,c,h){this.startup=o,this.codeLoadingTime=u,this.activateCallTime=c,this.activateResolvedTime=h}}e.ExtensionActivationTimes=y;class v{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,u){return o===-1||u===-1?-1:u-o}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=v;class R{constructor(o,u,c,h,a,t){this.activationFailed=o,this.activationFailedError=u,this.activationTimes=c,this.module=h,this.exports=a,this.subscriptions=t}}e.ActivatedExtension=R;class P extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class E extends R{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=E;class S extends R{constructor(o){super(!0,o,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let _=class{constructor(o,u,c,h){this._logService=h,this._registry=o,this._globalRegistry=u,this._host=c,this._operations=new f.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,u]of this._operations)u.dispose()}async waitForActivatingExtensions(){const o=[];for(const[u,c]of this._operations)o.push(c.wait());await Promise.all(o)}isActivated(o){const u=this._operations.get(o);return!!(u&&u.value)}getActivatedExtension(o){const u=this._operations.get(o);if(!u||!u.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return u.value}async activateByEvent(o,u){if(this._alreadyActivatedEvents[o])return;const c=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(c.map(h=>({id:h.identifier,reason:{startup:u,extensionId:h.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,u){const c=this._registry.getExtensionDescription(o);if(!c)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:c.identifier,reason:u}])}async _activateExtensions(o){const u=o.filter(c=>!this.isActivated(c.id)).map(c=>this._handleActivationRequest(c));await Promise.all(u.map(c=>c.wait()))}_handleActivationRequest(o){if(this._operations.has(o.id))return this._operations.get(o.id);if(this._isHostExtension(o.id))return this._createAndSaveOperation(o,null,[],null);const u=this._registry.getExtensionDescription(o.id);if(!u){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this._createAndSaveOperation(o,null,[],new S(a));return this._host.onExtensionActivationError(o.id,a,new A.MissingExtensionDependency(o.id.value)),t}const c=[],h=typeof u.extensionDependencies>"u"?[]:u.extensionDependencies;for(const a of h){if(this._isResolvedExtension(a))continue;const t=this._operations.get(a);if(t){c.push(t);continue}if(this._isHostExtension(a)){c.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(a).identifier,reason:o.reason}));continue}const i=this._registry.getExtensionDescription(a);if(i){if(!i.main&&!i.browser)continue;c.push(this._handleActivationRequest({id:i.identifier,reason:o.reason}));continue}const s=u.displayName||u.identifier.value,n=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${a}'`),r=this._createAndSaveOperation(o,u.displayName,[],new S(n));return this._host.onExtensionActivationError(u.identifier,n,new A.MissingExtensionDependency(a)),r}return this._createAndSaveOperation(o,u.displayName,c,null)}_createAndSaveOperation(o,u,c,h){const a=new w(o.id,u,o.reason,c,h,this._host,this._logService);return this._operations.set(o.id,a),a}_isHostExtension(o){return O.ExtensionDescriptionRegistry.isHostExtension(o,this._registry,this._globalRegistry)}_isResolvedExtension(o){const u=this._globalRegistry.getExtensionDescription(o);return u?!u.main&&!u.browser:!1}};e.ExtensionsActivator=_,e.ExtensionsActivator=_=je([$e(3,T.ILogService)],_);let w=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,u,c,h,a,t,i){this._id=o,this._displayName=u,this._reason=c,this._deps=h,this._value=a,this._host=t,this._logService=i,this._barrier=new g.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const u=this._deps[o];if(u.value&&!u.value.activationFailed){this._deps.splice(o,1),o--;continue}if(u.value&&u.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);c.detail=u.value.activationFailedError,this._value=new S(c),this._host.onExtensionActivationError(this._id,c,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const u=new Error;if(o&&o.name&&(u.name=o.name),o&&o.message?u.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:u.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(u.stack=o.stack),this._value=new S(u),this._isDisposed&&I.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,u,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};w=je([$e(6,T.ILogService)],w)}),define(De[13],Ie([1,0,19,22,162,75,80,28,158,62,97,24,17,2,32,83,133,142,139,108,68,87,281,7,26]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Le){function Oe(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:Je,positionColumn:Ge}=ne,rt=new i.Position(Fe-1,He-1),_t=new i.Position(Je-1,Ge-1);return new i.Selection(rt,_t)}Le.to=Oe;function Ce(ne){const{anchor:Fe,active:He}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Le.from=Ce})(n||(e.Selection=n={}));var r;(function(Le){function Oe(ne){if(!ne)return;const{start:Fe,end:He}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Le.from=Oe;function Ce(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:Je,endColumn:Ge}=ne;return new i.Range(Fe-1,He-1,Je-1,Ge-1)}Le.to=Ce})(r||(e.Range=r={}));var l;(function(Le){function Oe(Ce){switch(Ce){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Le.to=Oe})(l||(e.TokenType=l={}));var k;(function(Le){function Oe(ne){return new i.Position(ne.lineNumber-1,ne.column-1)}Le.to=Oe;function Ce(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Le.from=Ce})(k||(e.Position=k={}));var C;(function(Le){function Oe(Fe,He,Je){return(0,I.coalesce)((0,I.asArray)(Fe).map(Ge=>Ce(Ge,He,Je)))}Le.from=Oe;function Ce(Fe,He,Je){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Je?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,He),pattern:de.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Je?.isBuiltin}}function ne(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(C||(e.DocumentSelector=C={}));var p;(function(Le){function Oe(ne){switch(ne){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Le.from=Oe;function Ce(ne){switch(ne){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Le.to=Ce})(p||(e.DiagnosticTag=p={}));var m;(function(Le){function Oe(ne){let Fe;return ne.code&&((0,E.isString)(ne.code)||(0,E.isNumber)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...r.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:D.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(b.from),tags:Array.isArray(ne.tags)?(0,I.coalesce)(ne.tags.map(p.from)):void 0}}Le.from=Oe;function Ce(ne){const Fe=new i.Diagnostic(r.to(ne),ne.message,D.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,E.isString)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(b.to),Fe.tags=ne.tags&&(0,I.coalesce)(ne.tags.map(p.to)),Fe}Le.to=Ce})(m||(e.Diagnostic=m={}));var b;(function(Le){function Oe(ne){return{...r.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Le.from=Oe;function Ce(ne){return new i.DiagnosticRelatedInformation(new i.Location(ne.resource,r.to(ne)),ne.message)}Le.to=Ce})(b||(e.DiagnosticRelatedInformation=b={}));var D;(function(Le){function Oe(ne){switch(ne){case i.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Le.from=Oe;function Ce(ne){switch(ne){case d.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Le.to=Ce})(D||(e.DiagnosticSeverity=D={}));var M;(function(Le){function Oe(ne){return typeof ne=="number"&&ne>=i.ViewColumn.One?ne-1:ne===i.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Le.from=Oe;function Ce(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Ce})(M||(e.ViewColumn=M={}));function L(Le){return typeof Le.range<"u"}function F(Le){return Le.length===0?!0:!!L(Le[0])}e.isDecorationOptionsArr=F;var x;(function(Le){function Oe(Ge){return Ge.map(Le.from)}Le.fromMany=Oe;function Ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ne(Ge){let rt;if(Ce(Ge)){const{language:ht,value:mt}=Ge;rt={value:"```"+ht+`
`+mt+"\n```\n"}}else i.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const _t=Object.create(null);rt.uris=_t;const Ct=ht=>{try{let mt=S.URI.parse(ht,!0);mt=mt.with({query:Fe(mt.query,_t)}),_t[ht]=mt}catch{}return""},gt=new y.marked.Renderer;return gt.link=Ct,gt.image=ht=>typeof ht=="string"?Ct(T.parseHrefAndDimensions(ht).href):"",(0,y.marked)(rt.value,{renderer:gt}),rt}Le.from=ne;function Fe(Ge,rt){if(!Ge)return Ge;let _t;try{_t=(0,v.parse)(Ge)}catch{}if(!_t)return Ge;let Ct=!1;return _t=(0,P.cloneAndChange)(_t,gt=>{if(S.URI.isUri(gt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[ht]=gt,Ct=!0,ht}else return}),Ct?JSON.stringify(_t):Ge}function He(Ge){const rt=new i.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt.supportHtml=Ge.supportHtml,rt.baseUri=Ge.baseUri?S.URI.from(Ge.baseUri):void 0,rt}Le.to=He;function Je(Ge){if(Ge)return typeof Ge=="string"?Ge:Le.from(Ge)}Le.fromStrict=Je})(x||(e.MarkdownString=x={}));function U(Le){return F(Le)?Le.map(Oe=>({range:r.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?x.fromMany(Oe.hoverMessage):Oe.hoverMessage?x.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Le.map(Oe=>({range:r.from(Oe)}))}e.fromRangeOrRangeWithMessage=U;function N(Le){return typeof Le>"u"?Le:typeof Le=="string"?S.URI.file(Le):Le}e.pathOrURIToURI=N;var z;(function(Le){function Oe(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?N(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Le.from=Oe})(z||(e.ThemableDecorationAttachmentRenderOptions=z={}));var V;(function(Le){function Oe(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?N(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?z.from(Ce.before):void 0,after:Ce.after?z.from(Ce.after):void 0}}Le.from=Oe})(V||(e.ThemableDecorationRenderOptions=V={}));var ge;(function(Le){function Oe(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Oe})(ge||(e.DecorationRangeBehavior=ge={}));var te;(function(Le){function Oe(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ge.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?V.from(Ce.light):void 0,dark:Ce.dark?V.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?N(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?z.from(Ce.before):void 0,after:Ce.after?z.from(Ce.after):void 0}}Le.from=Oe})(te||(e.DecorationRenderOptions=te={}));var q;(function(Le){function Oe(ne){return{text:ne.newText,eol:ne.newEol&&Te.from(ne.newEol),range:r.from(ne.range)}}Le.from=Oe;function Ce(ne){const Fe=new i.TextEdit(r.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:Te.to(ne.eol),Fe}Le.to=Ce})(q||(e.TextEdit=q={}));var K;(function(Le){function Oe(ne,Fe){const He={edits:[]};if(ne instanceof i.WorkspaceEdit){const Je=new g.ResourceSet;for(const Ge of ne._allEntries())Ge._type===1&&S.URI.isUri(Ge.to)&&Ge.from===void 0&&Je.add(Ge.to);for(const Ge of ne._allEntries())if(Ge._type===1){let rt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?rt={type:"base64",value:(0,O.encodeBase64)(O.VSBuffer.wrap(Ge.options.contents))}:rt={type:"dataTransferItem",id:Ge.options.contents._itemId}),He.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:rt},metadata:Ge.metadata})}else Ge._type===2?He.edits.push({resource:Ge.uri,textEdit:q.from(Ge.edit),versionId:Je.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?He.edits.push({resource:Ge.uri,textEdit:{range:r.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Je.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?He.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&He.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(vt.from)}})}return He}Le.from=Oe;function Ce(ne){const Fe=new i.WorkspaceEdit,He=new g.ResourceMap;for(const Je of ne.edits)if(Je.textEdit){const Ge=Je,rt=S.URI.revive(Ge.resource),_t=r.to(Ge.textEdit.range),Ct=Ge.textEdit.text,gt=Ge.textEdit.insertAsSnippet;let ht;gt?ht=i.SnippetTextEdit.replace(_t,new i.SnippetString(Ct)):ht=i.TextEdit.replace(_t,Ct);const mt=He.get(rt);mt?mt.push(ht):He.set(rt,[ht])}else Fe.renameFile(S.URI.revive(Je.oldResource),S.URI.revive(Je.newResource),Je.options);for(const[Je,Ge]of He)Fe.set(Je,Ge);return Fe}Le.to=Ce})(K||(e.WorkspaceEdit=K={}));var ue;(function(Le){const Oe=Object.create(null);Oe[i.SymbolKind.File]=0,Oe[i.SymbolKind.Module]=1,Oe[i.SymbolKind.Namespace]=2,Oe[i.SymbolKind.Package]=3,Oe[i.SymbolKind.Class]=4,Oe[i.SymbolKind.Method]=5,Oe[i.SymbolKind.Property]=6,Oe[i.SymbolKind.Field]=7,Oe[i.SymbolKind.Constructor]=8,Oe[i.SymbolKind.Enum]=9,Oe[i.SymbolKind.Interface]=10,Oe[i.SymbolKind.Function]=11,Oe[i.SymbolKind.Variable]=12,Oe[i.SymbolKind.Constant]=13,Oe[i.SymbolKind.String]=14,Oe[i.SymbolKind.Number]=15,Oe[i.SymbolKind.Boolean]=16,Oe[i.SymbolKind.Array]=17,Oe[i.SymbolKind.Object]=18,Oe[i.SymbolKind.Key]=19,Oe[i.SymbolKind.Null]=20,Oe[i.SymbolKind.EnumMember]=21,Oe[i.SymbolKind.Struct]=22,Oe[i.SymbolKind.Event]=23,Oe[i.SymbolKind.Operator]=24,Oe[i.SymbolKind.TypeParameter]=25;function Ce(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Le.from=Ce;function ne(Fe){for(const He in Oe)if(Oe[He]===Fe)return Number(He);return i.SymbolKind.Property}Le.to=ne})(ue||(e.SymbolKind=ue={}));var ie;(function(Le){function Oe(ne){switch(ne){case i.SymbolTag.Deprecated:return 1}}Le.from=Oe;function Ce(ne){switch(ne){case 1:return i.SymbolTag.Deprecated}}Le.to=Ce})(ie||(e.SymbolTag=ie={}));var ce;(function(Le){function Oe(ne){return{name:ne.name,kind:ue.from(ne.kind),tags:ne.tags&&ne.tags.map(ie.from),containerName:ne.containerName,location:re.from(ne.location)}}Le.from=Oe;function Ce(ne){const Fe=new i.SymbolInformation(ne.name,ue.to(ne.kind),ne.containerName,re.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(ie.to),Fe}Le.to=Ce})(ce||(e.WorkspaceSymbol=ce={}));var Se;(function(Le){function Oe(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),kind:ue.from(ne.kind),tags:ne.tags?.map(ie.from)??[]};return ne.children&&(Fe.children=ne.children.map(Oe)),Fe}Le.from=Oe;function Ce(ne){const Fe=new i.DocumentSymbol(ne.name,ne.detail,ue.to(ne.kind),r.to(ne.range),r.to(ne.selectionRange));return(0,I.isNonEmptyArray)(ne.tags)&&(Fe.tags=ne.tags.map(ie.to)),ne.children&&(Fe.children=ne.children.map(Ce)),Fe}Le.to=Ce})(Se||(e.DocumentSymbol=Se={}));var j;(function(Le){function Oe(ne){const Fe=new i.CallHierarchyItem(ue.to(ne.kind),ne.name,ne.detail||"",S.URI.revive(ne.uri),r.to(ne.range),r.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Le.to=Oe;function Ce(ne,Fe,He){if(Fe=Fe??ne._sessionId,He=He??ne._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:ne.name,detail:ne.detail,kind:ue.from(ne.kind),uri:ne.uri,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),tags:ne.tags?.map(ie.from)}}Le.from=Ce})(j||(e.CallHierarchyItem=j={}));var $;(function(Le){function Oe(Ce){return new i.CallHierarchyIncomingCall(j.to(Ce.from),Ce.fromRanges.map(ne=>r.to(ne)))}Le.to=Oe})($||(e.CallHierarchyIncomingCall=$={}));var X;(function(Le){function Oe(Ce){return new i.CallHierarchyOutgoingCall(j.to(Ce.to),Ce.fromRanges.map(ne=>r.to(ne)))}Le.to=Oe})(X||(e.CallHierarchyOutgoingCall=X={}));var re;(function(Le){function Oe(ne){return{range:ne.range&&r.from(ne.range),uri:ne.uri}}Le.from=Oe;function Ce(ne){return new i.Location(S.URI.revive(ne.uri),r.to(ne.range))}Le.to=Ce})(re||(e.location=re={}));var Q;(function(Le){function Oe(ne){const Fe=ne,He=ne;return{originSelectionRange:Fe.originSelectionRange?r.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:r.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?r.from(Fe.targetSelectionRange):void 0}}Le.from=Oe;function Ce(ne){return{targetUri:S.URI.revive(ne.uri),targetRange:r.to(ne.range),targetSelectionRange:ne.targetSelectionRange?r.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?r.to(ne.originSelectionRange):void 0}}Le.to=Ce})(Q||(e.DefinitionLink=Q={}));var Z;(function(Le){function Oe(ne){return{range:r.from(ne.range),contents:x.fromMany(ne.contents)}}Le.from=Oe;function Ce(ne){return new i.Hover(ne.contents.map(x.to),r.to(ne.range))}Le.to=Ce})(Z||(e.Hover=Z={}));var J;(function(Le){function Oe(ne){return{range:r.from(ne.range),expression:ne.expression}}Le.from=Oe;function Ce(ne){return new i.EvaluatableExpression(r.to(ne.range),ne.expression)}Le.to=Ce})(J||(e.EvaluatableExpression=J={}));var be;(function(Le){function Oe(ne){if(ne instanceof i.InlineValueText)return{type:"text",range:r.from(ne.range),text:ne.text};if(ne instanceof i.InlineValueVariableLookup)return{type:"variable",range:r.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof i.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Oe;function Ce(ne){switch(ne.type){case"text":return{range:r.to(ne.range),text:ne.text};case"variable":return{range:r.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:r.to(ne.range),expression:ne.expression}}}Le.to=Ce})(be||(e.InlineValue=be={}));var ae;(function(Le){function Oe(ne){return{frameId:ne.frameId,stoppedLocation:r.from(ne.stoppedLocation)}}Le.from=Oe;function Ce(ne){return new i.InlineValueContext(ne.frameId,r.to(ne.stoppedLocation))}Le.to=Ce})(ae||(e.InlineValueContext=ae={}));var fe;(function(Le){function Oe(ne){return{range:r.from(ne.range),kind:ne.kind}}Le.from=Oe;function Ce(ne){return new i.DocumentHighlight(r.to(ne.range),ne.kind)}Le.to=Ce})(fe||(e.DocumentHighlight=fe={}));var ee;(function(Le){function Oe(Ce){switch(Ce){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Le.to=Oe})(ee||(e.CompletionTriggerKind=ee={}));var he;(function(Le){function Oe(Ce){return{triggerKind:ee.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Le.to=Oe})(he||(e.CompletionContext=he={}));var ve;(function(Le){function Oe(ne){switch(ne){case i.CompletionItemTag.Deprecated:return 1}}Le.from=Oe;function Ce(ne){switch(ne){case 1:return i.CompletionItemTag.Deprecated}}Le.to=Ce})(ve||(e.CompletionItemTag=ve={}));var Pe;(function(Le){const Oe=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function Ce(He){return Oe.get(He)??9}Le.from=Ce;const ne=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Fe(He){return ne.get(He)??i.CompletionItemKind.Property}Le.to=Fe})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Le){function Oe(Ce,ne){const Fe=new i.CompletionItem(Ce.label);return Fe.insertText=Ce.insertText,Fe.kind=Pe.to(Ce.kind),Fe.tags=Ce.tags?.map(ve.to),Fe.detail=Ce.detail,Fe.documentation=T.isMarkdownString(Ce.documentation)?x.to(Ce.documentation):Ce.documentation,Fe.sortText=Ce.sortText,Fe.filterText=Ce.filterText,Fe.preselect=Ce.preselect,Fe.commitCharacters=Ce.commitCharacters,_.Range.isIRange(Ce.range)?Fe.range=r.to(Ce.range):typeof Ce.range=="object"&&(Fe.range={inserting:r.to(Ce.range.insert),replacing:r.to(Ce.range.replace)}),Fe.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Fe.insertText=new i.SnippetString(Ce.insertText):(Fe.insertText=Ce.insertText,Fe.textEdit=Fe.range instanceof i.Range?new i.TextEdit(Fe.range,Fe.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ce.additionalTextEdits.map(He=>q.to(He))),Fe.command=ne&&Ce.command?ne.fromInternal(Ce.command):void 0,Fe}Le.to=Oe})(B||(e.CompletionItem=B={}));var G;(function(Le){function Oe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:x.fromStrict(ne.documentation)}}Le.from=Oe;function Ce(ne){return{label:ne.label,documentation:T.isMarkdownString(ne.documentation)?x.to(ne.documentation):ne.documentation}}Le.to=Ce})(G||(e.ParameterInformation=G={}));var se;(function(Le){function Oe(ne){return{label:ne.label,documentation:x.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(G.from):[],activeParameter:ne.activeParameter}}Le.from=Oe;function Ce(ne){return{label:ne.label,documentation:T.isMarkdownString(ne.documentation)?x.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(G.to):[],activeParameter:ne.activeParameter}}Le.to=Ce})(se||(e.SignatureInformation=se={}));var oe;(function(Le){function Oe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.from):[]}}Le.from=Oe;function Ce(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.to):[]}}Le.to=Ce})(oe||(e.SignatureHelp=oe={}));var Y;(function(Le){function Oe(Ce,ne){const Fe=new i.InlayHint(k.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(me.to.bind(void 0,Ce)),ne.kind&&ye.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(q.to),Fe.tooltip=T.isMarkdownString(ne.tooltip)?x.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Le.to=Oe})(Y||(e.InlayHint=Y={}));var me;(function(Le){function Oe(Ce,ne){const Fe=new i.InlayHintLabelPart(ne.label);return Fe.tooltip=T.isMarkdownString(ne.tooltip)?x.to(ne.tooltip):ne.tooltip,w.Command.is(ne.command)&&(Fe.command=Ce.fromInternal(ne.command)),ne.location&&(Fe.location=re.to(ne.location)),Fe}Le.to=Oe})(me||(e.InlayHintLabelPart=me={}));var ye;(function(Le){function Oe(ne){return ne}Le.from=Oe;function Ce(ne){return ne}Le.to=Ce})(ye||(e.InlayHintKind=ye={}));var xe;(function(Le){function Oe(ne){return{range:r.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Le.from=Oe;function Ce(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?S.URI.parse(ne.url,!0):S.URI.revive(ne.url)}catch{}return new i.DocumentLink(r.to(ne.range),Fe)}Le.to=Ce})(xe||(e.DocumentLink=xe={}));var We;(function(Le){function Oe(ne){const Fe=new i.ColorPresentation(ne.label);return ne.textEdit&&(Fe.textEdit=q.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(He=>q.to(He))),Fe}Le.to=Oe;function Ce(ne){return{label:ne.label,textEdit:ne.textEdit?q.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>q.from(Fe)):void 0}}Le.from=Ce})(We||(e.ColorPresentation=We={}));var Ze;(function(Le){function Oe(ne){return new i.Color(ne[0],ne[1],ne[2],ne[3])}Le.to=Oe;function Ce(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Le.from=Ce})(Ze||(e.Color=Ze={}));var Xe;(function(Le){function Oe(ne){return{range:r.from(ne.range)}}Le.from=Oe;function Ce(ne){return new i.SelectionRange(r.to(ne.range))}Le.to=Ce})(Xe||(e.SelectionRange=Xe={}));var it;(function(Le){function Oe(Ce){switch(Ce){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Le.to=Oe})(it||(e.TextDocumentSaveReason=it={}));var tt;(function(Le){function Oe(ne){switch(ne){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Oe;function Ce(ne){switch(ne){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Le.to=Ce})(tt||(e.TextEditorLineNumbersStyle=tt={}));var Te;(function(Le){function Oe(ne){if(ne===i.EndOfLine.CRLF)return 1;if(ne===i.EndOfLine.LF)return 0}Le.from=Oe;function Ce(ne){if(ne===1)return i.EndOfLine.CRLF;if(ne===0)return i.EndOfLine.LF}Le.to=Ce})(Te||(e.EndOfLine=Te={}));var Me;(function(Le){function Oe(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Oe})(Me||(e.ProgressLocation=Me={}));var ze;(function(Le){function Oe(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=Re.from(ne.kind)),Fe}Le.from=Oe;function Ce(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=Re.to(ne.kind)),Fe}Le.to=Ce})(ze||(e.FoldingRange=ze={}));var Re;(function(Le){function Oe(ne){if(ne)switch(ne){case i.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case i.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case i.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}Le.from=Oe;function Ce(ne){if(ne)switch(ne.value){case w.FoldingRangeKind.Comment.value:return i.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports.value:return i.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region.value:return i.FoldingRangeKind.Region}}Le.to=Ce})(Re||(e.FoldingRangeKind=Re={}));var Qe;(function(Le){function Oe(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?r.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?u.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Oe})(Qe||(e.TextEditorOpenOptions=Qe={}));var de;(function(Le){function Oe(He){return He instanceof i.RelativePattern?He.toJSON():typeof He=="string"?He:Ce(He)||ne(He)?new i.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Le.from=Oe;function Ce(He){const Je=He;return Je?S.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function ne(He){const Je=He;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new i.RelativePattern(S.URI.revive(He.baseUri),He.pattern)}Le.to=Fe})(de||(e.GlobPattern=de={}));var le;(function(Le){function Oe(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Oe);if(typeof Ce=="string")return Ce;{const ne=Ce;return{language:ne.language,scheme:ne.scheme,pattern:de.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Le.from=Oe})(le||(e.LanguageSelector=le={}));var ke;(function(Le){function Oe(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(He=>He&&typeof He=="object"&&"uri"in He&&S.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(Je=>Je instanceof i.Range)))}Le.is=Oe;function Ce(ne){return{documents:ne.documents.map(Fe=>Fe.map(He=>({uri:S.URI.from(He.uri),version:He.version,ranges:He.ranges.map(Je=>r.from(Je))})))}}Le.from=Ce})(ke||(e.MappedEditsContext=ke={}));var Ve;(function(Le){function Oe(ne){return{start:ne.start,end:ne.end}}Le.from=Oe;function Ce(ne){return new i.NotebookRange(ne.start,ne.end)}Le.to=Ce})(Ve||(e.NotebookRange=Ve={}));var Be;(function(Le){function Oe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Le.to=Oe;function Ce(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Le.from=Ce})(Be||(e.NotebookCellExecutionSummary=Be={}));var Ye;(function(Le){function Oe(Ce){if(Ce===c.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(Ce===c.NotebookCellExecutionState.Pending)return;if(Ce===c.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Le.to=Oe})(Ye||(e.NotebookCellExecutionState=Ye={}));var nt;(function(Le){function Oe(ne){switch(ne){case i.NotebookCellKind.Markup:return c.CellKind.Markup;case i.NotebookCellKind.Code:default:return c.CellKind.Code}}Le.from=Oe;function Ce(ne){switch(ne){case c.CellKind.Markup:return i.NotebookCellKind.Markup;case c.CellKind.Code:default:return i.NotebookCellKind.Code}}Le.to=Ce})(nt||(e.NotebookCellKind=nt={}));var ct;(function(Le){function Oe(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const He of ne.cells)i.NotebookCellData.validate(He),Fe.cells.push(vt.from(He));return Fe}Le.from=Oe;function Ce(ne){const Fe=new i.NotebookData(ne.cells.map(vt.to));return(0,E.isEmptyObject)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Le.to=Ce})(ct||(e.NotebookData=ct={}));var vt;(function(Le){function Oe(ne){return{cellKind:nt.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Be.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Vt.from):[]}}Le.from=Oe;function Ce(ne){return new i.NotebookCellData(nt.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Vt.to):void 0,ne.metadata,ne.internalMetadata?Be.to(ne.internalMetadata):void 0)}Le.to=Ce})(vt||(e.NotebookCellData=vt={}));var yt;(function(Le){function Oe(ne){return{mime:ne.mime,valueBytes:O.VSBuffer.wrap(ne.data)}}Le.from=Oe;function Ce(ne){return new i.NotebookCellOutputItem(ne.valueBytes.buffer,ne.mime)}Le.to=Ce})(yt||(e.NotebookCellOutputItem=yt={}));var Vt;(function(Le){function Oe(ne){return{outputId:ne.id,items:ne.items.map(yt.from),metadata:ne.metadata}}Le.from=Oe;function Ce(ne){const Fe=ne.items.map(yt.to);return new i.NotebookCellOutput(Fe,ne.outputId,ne.metadata)}Le.to=Ce})(Vt||(e.NotebookCellOutput=Vt={}));var jt;(function(Le){function Oe(Fe){return ne(Fe)?{include:de.from(Fe.include)??void 0,exclude:de.from(Fe.exclude)??void 0}:de.from(Fe)??void 0}Le.from=Oe;function Ce(Fe){return ne(Fe)?{include:de.to(Fe.include),exclude:de.to(Fe.exclude)}:de.to(Fe)}Le.to=Ce;function ne(Fe){const He=Fe;return He?!(0,E.isUndefinedOrNull)(He.include)&&!(0,E.isUndefinedOrNull)(He.exclude):!1}})(jt||(e.NotebookExclusiveDocumentPattern=jt={}));var bt;(function(Le){function Oe(Ce,ne,Fe){const He=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(He,Fe),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Le.from=Oe})(bt||(e.NotebookStatusBarItem=bt={}));var xt;(function(Le){function Oe(Ce,ne,Fe){const He=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:ne.toInternal(He,Fe),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Le.from=Oe})(xt||(e.NotebookKernelSourceAction=xt={}));var Mt;(function(Le){function Oe(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Le.from=Oe})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var qt;(function(Le){function Oe(ne){return{uri:ne.uri,provides:ne.provides}}Le.from=Oe;function Ce(ne){return new i.NotebookRendererScript(S.URI.revive(ne.uri),ne.provides)}Le.to=Ce})(qt||(e.NotebookRendererScript=qt={}));var Bt;(function(Le){function Oe(ne){return{message:x.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:r.from(ne.location.range),uri:ne.location.uri}}}Le.from=Oe;function Ce(ne){const Fe=new i.TestMessage(typeof ne.message=="string"?ne.message:x.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.contextValue=ne.contextValue,Fe.location=ne.location?re.to(ne.location):void 0,Fe}Le.to=Ce})(Bt||(e.TestMessage=Bt={}));var Dt;(function(Le){Le.namespace=a.namespaceTestTag,Le.denamespace=a.denamespaceTestTag})(Dt||(e.TestTag=Dt={}));var Ft;(function(Le){function Oe(ne){const Fe=(0,o.getPrivateApiFor)(ne).controllerId;return{extId:h.TestId.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:S.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(He=>Dt.namespace(Fe,He.id)),range:_.Range.lift(r.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&x.fromStrict(ne.error)||null}}Le.from=Oe;function Ce(ne){return{parent:void 0,error:void 0,id:h.TestId.fromString(ne.extId).localId,label:ne.label,uri:S.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:He}=Dt.denamespace(Fe);return new i.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:r.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Le.toPlain=Ce})(Ft||(e.TestItem=Ft={})),function(Le){function Oe(ne){return{id:ne.id}}Le.from=Oe;function Ce(ne){return new i.TestTag(ne.id)}Le.to=Ce}(Dt||(e.TestTag=Dt={}));var $t;(function(Le){const Oe=(ne,Fe)=>{const He=[];for(const[Ge,rt]of Fe)h.TestId.compare(rt.item.extId,Ge)===2&&(Fe.delete(Ge),He.push(rt));const Je={...Ft.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(rt=>rt.type===0).map(Bt.to)})),children:He.map(Ge=>Oe(Ge,Fe))};for(const Ge of Je.children)Ge.parent=Je;return Je};function Ce(ne){const Fe=[],He=new Map;for(const Je of ne.items){He.set(Je.item.extId,Je);const Ge=h.TestId.root(Je.item.extId);ne.request.targets.some(rt=>rt.controllerId===Ge&&rt.testIds.includes(Je.item.extId))&&Fe.push(Je)}return{completedAt:ne.completedAt,results:Fe.map(Je=>Oe(Je,He))}}Le.to=Ce})($t||(e.TestResults=$t={}));var Gt;(function(Le){function Oe(He){return{covered:He.covered,total:He.covered}}function Ce(He){return"line"in He?k.from(He):r.from(He)}function ne(He){return"branches"in He?{count:He.executionCount,location:Ce(He.location),type:1,branches:He.branches.length?He.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Ce(Je.location)})):void 0}:{type:0,count:He.executionCount,location:Ce(He.location)}}Le.fromDetailed=ne;function Fe(He){return{uri:He.uri,statement:Oe(He.statementCoverage),branch:He.branchCoverage&&Oe(He.branchCoverage),function:He.functionCoverage&&Oe(He.functionCoverage),details:He.detailedCoverage?.map(ne)}}Le.fromFile=Fe})(Gt||(e.TestCoverage=Gt={}));var Wt;(function(Le){function Oe(Ce){switch(Ce){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Le.to=Oe})(Wt||(e.CodeActionTriggerKind=Wt={}));var zt;(function(Le){function Oe(ne){const Fe=new i.TypeHierarchyItem(ue.to(ne.kind),ne.name,ne.detail||"",S.URI.revive(ne.uri),r.to(ne.range),r.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Le.to=Oe;function Ce(ne,Fe,He){if(Fe=Fe??ne._sessionId,He=He??ne._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:ue.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),tags:ne.tags?.map(ie.from)}}Le.from=Ce})(zt||(e.TypeHierarchyItem=zt={}));var Nt;(function(Le){function Oe(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Le.from=Oe})(Nt||(e.ViewBadge=Nt={}));var lt;(function(Le){function Oe(He,Je,Ge){const rt=Je.fileData;return rt?new i.InternalFileDataTransferItem(new i.DataTransferFile(rt.name,S.URI.revive(rt.uri),rt.id,(0,A.createSingleCallFunction)(()=>Ge(rt.id)))):He===R.Mimes.uriList&&Je.uriListData?new i.InternalDataTransferItem(Fe(Je.uriListData)):new i.InternalDataTransferItem(Je.asString)}Le.to=Oe;async function Ce(He,Je){const Ge=await Je.asString();if(He===R.Mimes.uriList)return{asString:Ge,fileData:void 0,uriListData:ne(Ge)};const rt=Je.asFile();return{asString:Ge,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Le.from=Ce;function ne(He){return f.UriList.split(He).map(Je=>{if(Je.startsWith("#"))return Je;try{return S.URI.parse(Je)}catch{}return Je})}function Fe(He){return f.UriList.create(He.map(Je=>typeof Je=="string"?Je:S.URI.revive(Je)))}})(lt||(e.DataTransferItem=lt={}));var ft;(function(Le){function Oe(ne,Fe){const He=ne.items.map(([Je,Ge])=>[Je,lt.to(Je,Ge,Fe)]);return new i.DataTransfer(He)}Le.toDataTransfer=Oe;async function Ce(ne){const Fe={items:[]},He=[];for(const[Je,Ge]of ne)He.push((async()=>{Fe.items.push([Je,await lt.from(Je,Ge)])})());return await Promise.all(He),Fe}Le.from=Ce})(ft||(e.DataTransfer=ft={}));var Tt;(function(Le){function Oe(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Le.to=Oe;function Ce(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Le.from=Ce})(Tt||(e.ChatReplyFollowup=Tt={}));var Ht;(function(Le){function Oe(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:Tt.from(Ce)}Le.from=Oe})(Ht||(e.ChatFollowup=Ht={}));var At;(function(Le){function Oe(ne){const Fe=new i.ChatMessage(at.to(ne.role),ne.content);return Fe.name=ne.name,Fe}Le.to=Oe;function Ce(ne){return{role:at.from(ne.role),content:ne.content,name:ne.name}}Le.from=Ce})(At||(e.ChatMessage=At={}));var at;(function(Le){function Oe(ne){switch(ne){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}Le.to=Oe;function Ce(ne){switch(ne){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}Le.from=Ce})(at||(e.ChatMessageRole=at={}));var wt;(function(Le){function Oe(Fe){const He={};for(const Je of Object.keys(Fe))He[Je]=Fe[Je].map(Le.to);return He}Le.objectTo=Oe;function Ce(Fe){return{level:Ot.to(Fe.level),value:Fe.value,description:Fe.description}}Le.to=Ce;function ne(Fe){return{level:Ot.from(Fe.level),value:Fe.value,description:Fe.description}}Le.from=ne})(wt||(e.ChatVariable=wt={}));var Ot;(function(Le){function Oe(ne){switch(ne){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}Le.to=Oe;function Ce(ne){switch(ne){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}Le.from=Ce})(Ot||(e.ChatVariableLevel=Ot={}));var Pt;(function(Le){function Oe(Ce){switch(Ce){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted}}Le.to=Oe})(Pt||(e.InteractiveEditorResponseFeedbackKind=Pt={}));var qe;(function(Le){function Oe(Ce,ne){return"placeholder"in ne&&"resolvedContent"in ne?{placeholder:ne.placeholder}:"responseId"in ne?{requestId:ne.responseId}:"markdownContent"in ne?((0,s.checkProposedApiEnabled)(Ce,"chatAgents2Additions"),{content:x.from(ne.markdownContent)}):"content"in ne?typeof ne.content=="string"?ne:((0,s.checkProposedApiEnabled)(Ce,"chatAgents2Additions"),{content:x.from(ne.content)}):"documents"in ne?{documents:ne.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(He=>r.from(He))}))}:"reference"in ne?{reference:"uri"in ne.reference?{uri:ne.reference.uri,range:r.from(ne.reference.range)}:ne.reference}:"inlineReference"in ne?{inlineReference:"uri"in ne.inlineReference?{uri:ne.inlineReference.uri,range:r.from(ne.inlineReference.range)}:ne.inlineReference,title:ne.title}:("agentName"in ne&&(0,s.checkProposedApiEnabled)(Ce,"chatAgents2Additions"),ne)}Le.from=Oe})(qe||(e.ChatResponseProgress=qe={}));var Kt;(function(Le){function Oe(Ce,ne,Fe){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:ne.toInternal(Ce,Fe)}Le.from=Oe})(Kt||(e.TerminalQuickFix=Kt={}))}),define(De[284],Ie([1,0,2,9,7,13,76]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class g{constructor(v,R,P,E={timeout:1500,errors:3}){this._logService=v,this._documents=R,this._mainThreadBulkEdits=P,this._thresholds=E,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(v){return(R,P,E)=>{const _={dispose:this._callbacks.push([R,P,v])};return Array.isArray(E)&&E.push(_),_}}async $participateInSave(v,R){const P=I.URI.revive(v);let E=!1;const S=setTimeout(()=>E=!0,this._thresholds.timeout),_=[];try{for(const w of[...this._callbacks]){if(E)break;const d=this._documents.getDocument(P),o=await this._deliverEventAsyncAndBlameBadListeners(w,{document:d,reason:A.TextDocumentSaveReason.to(R)});_.push(o)}}finally{clearTimeout(S)}return _}_deliverEventAsyncAndBlameBadListeners([v,R,P],E){const S=this._badListeners.get(v);return typeof S=="number"&&S>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,v,R,E).then(()=>!0,_=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(_),!(_ instanceof Error)||_.message!=="concurrent_edits"){const w=this._badListeners.get(v);this._badListeners.set(v,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(v,R,P,E){const S=[],_=Date.now(),{document:w,reason:d}=E,{version:o}=w,u=Object.freeze({document:w,reason:d,waitUntil(c){if(Object.isFrozen(S))throw(0,O.illegalState)("waitUntil can not be called async");S.push(Promise.resolve(c))}});try{R.apply(P,[u])}catch(c){return Promise.reject(c)}return Object.freeze(S),new Promise((c,h)=>{const a=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(S).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' finished after ${Date.now()-_}ms`),clearTimeout(a),c(t)}).catch(t=>{clearTimeout(a),h(t)})}).then(c=>{const h={edits:[]};for(const a of c)if(Array.isArray(a)&&a.every(t=>t instanceof f.TextEdit))for(const{newText:t,newEol:i,range:s}of a)h.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:s&&A.Range.from(s),text:t,eol:i&&A.EndOfLine.from(i)}});if(h.edits.length!==0)return o===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=g}),define(De[285],Ie([1,0,18,2,13,7,108]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class g{constructor(P,E,S,_){this.start=P,this.deletedCount=E,this.deletedItems=S,this.items=_}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,E,S){this.notebook=P,this._extHostDocument=E,this._cellData=S,this.handle=S.handle,this.uri=O.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(f.NotebookCellOutput.to),this._internalMetadata=S.internalMetadata??{},this._metadata=Object.freeze(S.metadata??{}),this._previousResult=Object.freeze(f.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const P=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:f.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return P._mime},set mime(_){P._mime=_},get outputs(){return P._outputs.slice(0)},get metadata(){return P._metadata},get executionSummary(){return P._previousResult}};this._apiCell=Object.freeze(S)}return this._apiCell}setOutputs(P){this._outputs=P.map(f.NotebookCellOutput.to)}setOutputItems(P,E,S){const _=S.map(f.NotebookCellOutputItem.to),w=this._outputs.find(d=>d.id===P);if(w&&(E||(w.items.length=0),w.items.push(..._),w.items.length>1&&w.items.every(d=>T.isTextStreamMime(d.mime)))){const d=new Map,o=[];w.items.forEach(u=>{let c;d.has(u.mime)?c=d.get(u.mime):(c=[],d.set(u.mime,c),o.push(u.mime)),c.push(u.data)}),w.items.length=0,o.forEach(u=>{const c=T.compressOutputItemStreams(d.get(u));w.items.push({mime:u,data:c.data.buffer})})}}setMetadata(P){this._metadata=Object.freeze(P)}setInternalMetadata(P){this._internalMetadata=P,this._previousResult=Object.freeze(f.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=y;class v{static{this._handlePool=0}constructor(P,E,S,_,w){this._proxy=P,this._textDocumentsAndEditors=E,this._textDocuments=S,this.uri=_,this.handle=v._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0,void 0),this._versionId=w.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const P=this,E={get uri(){return P.uri},get version(){return P._versionId},get notebookType(){return P._notebookType},get isDirty(){return P._isDirty},get isUntitled(){return P.uri.scheme===I.Schemas.untitled},get isClosed(){return P._disposed},get metadata(){return P._metadata},get cellCount(){return P._cells.length},cellAt(S){return S=P._validateIndex(S),P._cells[S].apiCell},getCells(S){return(S?P._getCells(S):P._cells).map(w=>w.apiCell)},save(){return P._save()}};this._notebook=Object.freeze(E)}return this._notebook}acceptDocumentPropertiesChanged(P){P.metadata&&(this._metadata=Object.freeze({...this._metadata,...P.metadata}))}acceptDirty(P){this._isDirty=P}acceptModelChanged(P,E,S){this._versionId=P.versionId,this._isDirty=E,this.acceptDocumentPropertiesChanged({metadata:S});const _={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},w=[];for(const o of P.rawEvents)o.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,_.contentChanges):o.kind===T.NotebookCellsChangeType.Move?this._moveCells(o.index,o.length,o.newIdx,_.contentChanges):o.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),w.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),w.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),w.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===T.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),w.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),w.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const d=new Map;for(let o=0;o<w.length;o++){const u=w[o],c=d.get(u.cell);if(c===void 0){const h=_.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});d.set(u.cell,h-1)}else _.cellChanges[c]={..._.cellChanges[c],...u}}return Object.freeze(_),Object.freeze(_.cellChanges),Object.freeze(_.contentChanges),_}_validateIndex(P){return P=P|0,P<0?0:P>=this._cells.length?this._cells.length-1:P}_validateRange(P){let E=P.start|0,S=P.end|0;return E<0&&(E=0),S>this._cells.length&&(S=this._cells.length),P.with({start:E,end:S})}_getCells(P){P=this._validateRange(P);const E=[];for(let S=P.start;S<P.end;S++)E.push(this._cells[S]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(P,E,S){if(this._disposed)return;const _=[],w=[],d=[];if(P.reverse().forEach(o=>{const c=o[2].map(t=>{const i=new y(this,this._textDocumentsAndEditors,t);return E||w.push(y.asModelAddData(this.apiNotebook,t)),i}),h=new g(o[0],o[1],[],c),a=this._cells.splice(o[0],o[1],...c);for(const t of a)d.push(t.uri),h.deletedItems.push(t.apiCell);_.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:d}),S)for(const o of _)S.push(o.asApiEvent())}_moveCells(P,E,S,_){const w=this._cells.splice(P,E);this._cells.splice(S,0,...w);const d=[new g(P,E,w.map(o=>o.apiCell),[]),new g(S,0,[],w)];for(const o of d)_.push(o.asApiEvent())}_setCellOutputs(P,E){this._cells[P].setOutputs(E)}_setCellOutputItems(P,E,S,_){this._cells[P].setOutputItems(E,S,_)}_changeCellLanguage(P,E){const S=this._cells[P];S.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelLanguageChanged(S.uri,E)}_changeCellMime(P,E){const S=this._cells[P];S.apiCell.mime=E}_changeCellMetadata(P,E){this._cells[P].setMetadata(E)}_changeCellInternalMetadata(P,E){this._cells[P].setInternalMetadata(E)}getCellFromApiCell(P){return this._cells.find(E=>E.apiCell===P)}getCellFromIndex(P){return this._cells[P]}getCell(P){return this._cells.find(E=>E.handle===P)}getCellIndex(P){return this._cells.indexOf(P)}}e.ExtHostNotebookDocument=v}),define(De[286],Ie([1,0,4,2,13,7]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(y,v,R,P={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=v,this._mainThreadBulkEdits=R,this._thresholds=P,this._onWillSaveNotebookDocumentEvent=new I.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(v,R,P)=>{const E=function(_){v.call(R,_)};return E.extension=y,this._onWillSaveNotebookDocumentEvent.event(E,void 0,P)}}async $participateInSave(y,v,R){const P=O.URI.revive(y),E=this._notebooksAndEditors.getNotebookDocument(P);if(!E)throw new Error("Unable to resolve notebook document");const S=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:E.apiNotebook,reason:f.TextDocumentSaveReason.to(v)},R,async(w,d)=>{const o=Date.now(),u=await await Promise.resolve(w);Date.now()-o>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!R.isCancellationRequested&&u&&(u instanceof A.WorkspaceEdit?S.push(u):this._logService.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(S.length===0)return!0;const _={edits:[]};for(const w of S){const{edits:d}=f.WorkspaceEdit.from(w);_.edits=_.edits.concat(d)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(_)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(De[146],Ie([1,0,9,13,7]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,y,v,R,P,E){this.id=g,this._proxy=y,this.notebookData=v,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=P,this._visibleRanges=R,this._viewColumn=E}get apiEditor(){if(!this._editor){const g=this;this._editor={get notebook(){return g.notebookData.apiNotebook},get selection(){return g._selections[0]},set selection(y){this.selections=[y]},get selections(){return g._selections},set selections(y){if(!Array.isArray(y)||!y.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");g._selections=y,g._trySetSelections(y)},get visibleRanges(){return g._visibleRanges},revealRange(y,v){g._proxy.$tryRevealRange(g.id,O.NotebookRange.from(y),v??f.NotebookEditorRevealType.Default)},get viewColumn(){return g._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(g){this._visible=g}_acceptVisibleRanges(g){this._visibleRanges=g}_acceptSelections(g){this._selections=g}_trySetSelections(g){this._proxy.$trySetSelections(this.id,g.map(O.NotebookRange.from))}_acceptViewColumn(g){this._viewColumn=g}}e.ExtHostNotebookEditor=A}),define(De[287],Ie([1,0,9,4,14,13]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(y,v){this._logService=y,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new O.Emitter({onListenerError:I.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new O.Emitter({onListenerError:I.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,v);const R=this._notebooksAndEditors.getEditorById(y);v.visibleRanges&&R._acceptVisibleRanges(v.visibleRanges.ranges.map(A.NotebookRange.to)),v.selections&&R._acceptSelections(v.selections.selections.map(A.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const v in y)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(A.ViewColumn.to(y[v]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=je([$e(0,f.ILogService)],T)}),define(De[288],Ie([1,0,13,64,209,21,57,9]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}async withProgress(E,S,_){const w=this._handles++,{title:d,location:o,cancellable:u}=S,c={label:(0,f.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(w,{location:I.ProgressLocation.from(o),title:d,source:c,cancellable:u},E.isUnderDevelopment?void 0:E.identifier.value).catch(g.onUnexpectedExternalError),this._withProgress(w,_,!!u)}_withProgress(E,S,_){let w;_&&(w=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,w));const d=u=>{this._proxy.$progressEnd(u),this._mapHandleToCancellationSource.delete(u),w?.dispose()};let o;try{o=S(new R(this._proxy,E),_&&w?w.token:A.CancellationToken.None)}catch(u){throw d(E),u}return o.then(u=>d(E),u=>d(E)),o}$acceptProgressCanceled(E){const S=this._mapHandleToCancellationSource.get(E);S&&(S.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=y;function v(P,E){return P.message=E.message,typeof E.increment=="number"&&(typeof P.increment=="number"?P.increment+=E.increment:P.increment=E.increment),P}class R extends O.Progress{constructor(E,S){super(_=>this.throttledReport(_)),this._proxy=E,this._handle=S}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}je([(0,T.throttle)(100,(P,E)=>v(P,E),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[147],Ie([1,0,32,142,68,109,87,13,2]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const v=(c,h,a,t)=>{let i=h;return{enumerable:!0,configurable:!1,get(){return i},set(s){if(!a(i,s)){const n=i;i=s,c.listener?.(t(s,n))}}}},R=(c,h)=>c===h,P={range:(c,h)=>c===h?!0:!c||!h?!1:c.isEqual(h),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(c,h)=>!(c.length!==h.length||c.some(a=>!h.find(t=>a.id===t.id)))},E=c=>h=>({op:4,update:c(h)}),S=(c,h)=>({range:(()=>{let a;const t=E(i=>({range:I.Range.lift(g.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return a},set(i){c.listener?.({op:6}),P.range(a,i)||(a=i,c.listener?.(t(i)))}}})(),label:v(c,h,P.label,E(a=>({label:a}))),description:v(c,void 0,P.description,E(a=>({description:a}))),sortText:v(c,void 0,P.sortText,E(a=>({sortText:a}))),canResolveChildren:v(c,!1,P.canResolveChildren,a=>({op:2,state:a})),busy:v(c,!1,P.busy,E(a=>({busy:a}))),error:v(c,void 0,P.error,E(a=>({error:g.MarkdownString.fromStrict(a)||null}))),tags:v(c,[],P.tags,(a,t)=>({op:1,new:a.map(g.TestTag.from),old:t.map(g.TestTag.from)}))}),_=c=>{const h=f.TestId.fromString(c.extId),a=new d(h.controllerId,h.localId,c.label,y.URI.revive(c.uri)||void 0);return a.range=g.Range.to(c.range||void 0),a.description=c.description||void 0,a.sortText=c.sortText||void 0,a.tags=c.tags.map(t=>g.TestTag.to({id:(0,T.denamespaceTestTag)(t).tagId})),a},w=c=>{let h;for(const a of c.tests){const t=_(a.item);(0,O.getPrivateApiFor)(t).parent=h,h=t}return h};e.toItemFromContext=w;class d{constructor(h,a,t,i){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const s=(0,O.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,A.createTestItemChildren)(s,O.getPrivateApiFor,d),enumerable:!0,writable:!1},...S(s,t)})}}e.TestItemImpl=d;class o extends d{constructor(h,a){super(h,h,a,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class u extends A.TestItemCollection{constructor(h,a,t){super({controllerId:h,getDocumentVersion:i=>i&&t.getDocument(i)?.version,getApiFor:O.getPrivateApiFor,getChildren:i=>i.children,root:new o(h,a),toITestItem:g.TestItem.from})}}e.ExtHostTestItemCollection=u}),define(De[148],Ie([1,0,58,9,119,13,7]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class g{static{this._Keys=new f.IdGenerator("TextEditorDecorationType")}constructor(E,S,_){const w=g._Keys.nextId();E.$registerTextEditorDecorationType(S.identifier,w,A.DecorationRenderOptions.from(_)),this.value=Object.freeze({key:w,dispose(){E.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=g;class y{constructor(E,S){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=E,this._documentVersionId=E.version,this._undoStopBefore=S.undoStopBefore,this._undoStopAfter=S.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(E,S){this._throwIfFinalized();let _=null;if(E instanceof T.Position)_=new T.Range(E,E);else if(E instanceof T.Range)_=E;else throw new Error("Unrecognized location");this._pushEdit(_,S,!1)}insert(E,S){this._throwIfFinalized(),this._pushEdit(new T.Range(E,E),S,!0)}delete(E){this._throwIfFinalized();let S=null;if(E instanceof T.Range)S=E;else throw new Error("Unrecognized location");this._pushEdit(S,null,!0)}_pushEdit(E,S,_){const w=this._document.validateRange(E);this._collectedEdits.push({range:w,text:S,forceMoveMarkers:_})}setEndOfLine(E){if(this._throwIfFinalized(),E!==T.EndOfLine.LF&&E!==T.EndOfLine.CRLF)throw(0,O.illegalArgument)("endOfLine");this._setEndOfLine=E}}class v{constructor(E,S,_,w){this._proxy=E,this._id=S,this._accept(_),this._logService=w;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(o){d._setTabSize(o)},get indentSize(){return d._indentSize},set indentSize(o){d._setIndentSize(o)},get insertSpaces(){return d._insertSpaces},set insertSpaces(o){d._setInsertSpaces(o)},get cursorStyle(){return d._cursorStyle},set cursorStyle(o){d._setCursorStyle(o)},get lineNumbers(){return d._lineNumbers},set lineNumbers(o){d._setLineNumbers(o)}}}_accept(E){this._tabSize=E.tabSize,this._indentSize=E.indentSize,this._insertSpaces=E.insertSpaces,this._cursorStyle=E.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(E.lineNumbers)}_validateTabSize(E){if(E==="auto")return"auto";if(typeof E=="number"){const S=Math.floor(E);return S>0?S:null}if(typeof E=="string"){const S=parseInt(E,10);return isNaN(S)?null:S>0?S:null}return null}_setTabSize(E){const S=this._validateTabSize(E);if(S!==null){if(typeof S=="number"){if(this._tabSize===S)return;this._tabSize=S}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:S}))}}_validateIndentSize(E){if(E==="tabSize")return"tabSize";if(typeof E=="number"){const S=Math.floor(E);return S>0?S:null}if(typeof E=="string"){const S=parseInt(E,10);return isNaN(S)?null:S>0?S:null}return null}_setIndentSize(E){const S=this._validateIndentSize(E);if(S!==null){if(typeof S=="number"){if(this._indentSize===S)return;this._indentSize=S}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:S}))}}_validateInsertSpaces(E){return E==="auto"?"auto":E==="false"?!1:!!E}_setInsertSpaces(E){const S=this._validateInsertSpaces(E);if(typeof S=="boolean"){if(this._insertSpaces===S)return;this._insertSpaces=S}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:S}))}_setCursorStyle(E){this._cursorStyle!==E&&(this._cursorStyle=E,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:E})))}_setLineNumbers(E){this._lineNumbers!==E&&(this._lineNumbers=E,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(E)})))}assign(E){const S={};let _=!1;if(typeof E.tabSize<"u"){const w=this._validateTabSize(E.tabSize);w==="auto"?(_=!0,S.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,_=!0,S.tabSize=w)}if(typeof E.indentSize<"u"){const w=this._validateIndentSize(E.indentSize);w==="tabSize"?(_=!0,S.indentSize=w):typeof w=="number"&&this._indentSize!==w&&(this._indentSize=w,_=!0,S.indentSize=w)}if(typeof E.insertSpaces<"u"){const w=this._validateInsertSpaces(E.insertSpaces);w==="auto"?(_=!0,S.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,_=!0,S.insertSpaces=w)}typeof E.cursorStyle<"u"&&this._cursorStyle!==E.cursorStyle&&(this._cursorStyle=E.cursorStyle,_=!0,S.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this._lineNumbers!==E.lineNumbers&&(this._lineNumbers=E.lineNumbers,_=!0,S.lineNumbers=A.TextEditorLineNumbersStyle.from(E.lineNumbers)),_&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,S))}_warnOnError(E,S){S.catch(_=>{this._logService.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this._logService.warn(_)})}}e.ExtHostTextEditorOptions=v;class R{constructor(E,S,_,w,d,o,u,c){this.id=E,this._proxy=S,this._logService=_,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new v(this._proxy,this.id,o,_),this._visibleRanges=u,this._viewColumn=c;const h=this;this.value=Object.freeze({get document(){return w.value},set document(a){throw new O.ReadonlyError("document")},get selection(){return h._selections&&h._selections[0]},set selection(a){if(!(a instanceof T.Selection))throw(0,O.illegalArgument)("selection");h._selections=[a],h._trySetSelection()},get selections(){return h._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof T.Selection)))throw(0,O.illegalArgument)("selections");h._selections=a,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(a){throw new O.ReadonlyError("visibleRanges")},get options(){return h._options.value},set options(a){h._disposed||h._options.assign(a)},get viewColumn(){return h._viewColumn},set viewColumn(a){throw new O.ReadonlyError("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(w.value,t);return a(i),h._applyEdit(i)},insertSnippet(a,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(n=>A.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:r}=A.Position.from(t);s=[{startLineNumber:n,startColumn:r,endLineNumber:n,endColumn:r}]}else if(t instanceof T.Range)s=[A.Range.from(t)];else{s=[];for(const n of t)if(n instanceof T.Range)s.push(A.Range.from(n));else{const{lineNumber:r,column:l}=A.Position.from(n);s.push({startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l})}}return S.$tryInsertSnippet(E,w.value.version,a.value,s,i)},setDecorations(a,t){const i=t.length===0;i&&!h._hasDecorationsForKey.has(a.key)||(i?h._hasDecorationsForKey.delete(a.key):h._hasDecorationsForKey.add(a.key),h._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return S.$trySetDecorations(E,a.key,A.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,r=t.length;n<r;n++){const l=t[n];s[4*n]=l.start.line+1,s[4*n+1]=l.start.character+1,s[4*n+2]=l.end.line+1,s[4*n+3]=l.end.character+1}return S.$trySetDecorationsFast(E,a.key,s)}}))},revealRange(a,t){h._runOnProxy(()=>S.$tryRevealRange(E,A.Range.from(a),t||T.TextEditorRevealType.Default))},show(a){S.$tryShowEditor(E,A.ViewColumn.from(a))},hide(){S.$tryHideEditor(E)}})}dispose(){(0,I.ok)(!this._disposed),this._disposed=!0}_acceptOptions(E){(0,I.ok)(!this._disposed),this._options._accept(E)}_acceptVisibleRanges(E){(0,I.ok)(!this._disposed),this._visibleRanges=E}_acceptViewColumn(E){(0,I.ok)(!this._disposed),this._viewColumn=E}_acceptSelections(E){(0,I.ok)(!this._disposed),this._selections=E}async _trySetSelection(){const E=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,E)),this.value}_applyEdit(E){const S=E.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const _=S.edits.map(d=>d.range);_.sort((d,o)=>d.end.line===o.end.line?d.end.character===o.end.character?d.start.line===o.start.line?d.start.character-o.start.character:d.start.line-o.start.line:d.end.character-o.end.character:d.end.line-o.end.line);for(let d=0,o=_.length-1;d<o;d++){const u=_[d].end;if(_[d+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=S.edits.map(d=>({range:A.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,w,{setEndOfLine:typeof S.setEndOfLine=="number"?A.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}_runOnProxy(E){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this._logService.warn(S),null))}}e.ExtHostTextEditor=R}),define(De[289],Ie([1,0,213,23,2,4,3,270,8,7,17,19,13,80,21,173,26]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(h,a){if((0,R.isString)(h))return{label:h};if(h&&typeof h=="object"&&typeof h.label=="string"){let t;return Array.isArray(h.highlights)&&(t=h.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),t=t.length?t:void 0),{label:h.label,highlights:t}}}class u extends T.Disposable{constructor(a,t,i){super(),this._proxy=a,this.commands=t,this.logService=i,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeViewsDnDService;function s(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:n=>s(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(r=>s(r)?this.convertArgument(r):r):n})}registerTreeDataProvider(a,t,i){const s=this.createTreeView(a,{treeDataProvider:t},i);return{dispose:()=>s.dispose()}}createTreeView(a,t,i){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],n=t.dragAndDropController?.dragMimeTypes??[],r=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,k=this.createExtHostTreeView(a,t,i),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:n,hasHandleDrag:r,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this._proxy.$registerTreeViewDataProvider(a,C),m={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,d.checkProposedApiEnabled)(i,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,d.checkProposedApiEnabled)(i,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(b){(0,S.isMarkdownString)(b)&&(0,d.checkProposedApiEnabled)(i,"treeViewMarkdownMessage"),k.message=b},get title(){return k.title},set title(b){k.title=b},get description(){return k.description},set description(b){k.description=b},get badge(){return k.badge},set badge(b){b!==void 0&&v.ViewBadge.isViewBadge(b)?k.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(k.badge=void 0)},reveal:(b,D)=>k.reveal(b,D),dispose:async()=>{await p,this.treeViews.delete(a),k.dispose()}};return this._register(m),m}$getChildren(a,t){const i=this.treeViews.get(a);return i?i.getChildren(t):Promise.reject(new g.NoTreeViewError(a))}async $handleDrop(a,t,i,s,n,r,l,k){const C=this.treeViews.get(a);if(!C)return Promise.reject(new g.NoTreeViewError(a));const p=E.DataTransfer.toDataTransfer(i,async m=>(await this._proxy.$resolveDropFileData(a,t,m)).buffer);return l===a&&k&&await this.addAdditionalTransferItems(p,C,k,n,r),C.onDrop(p,s,n)}async addAdditionalTransferItems(a,t,i,s,n){const r=this.treeDragAndDropService.removeDragOperationTransfer(n);if(r)(await r)?.forEach((l,k)=>{l&&a.set(k,l)});else if(n&&t.handleDrag){const l=t.handleDrag(i,a,s);this.treeDragAndDropService.addDragOperationTransfer(n,l),await l}return a}async $handleDrag(a,t,i,s){const n=this.treeViews.get(a);if(!n)return Promise.reject(new g.NoTreeViewError(a));const r=await this.addAdditionalTransferItems(new v.DataTransfer,n,t,s,i);if(!(!r||s.isCancellationRequested))return E.DataTransfer.from(r)}async $hasResolve(a){const t=this.treeViews.get(a);if(!t)throw new g.NoTreeViewError(a);return t.hasResolve}$resolve(a,t,i){const s=this.treeViews.get(a);if(!s)throw new g.NoTreeViewError(a);return s.resolveTreeItem(t,i)}$setExpanded(a,t,i){const s=this.treeViews.get(a);if(!s)throw new g.NoTreeViewError(a);s.setExpanded(t,i)}$setSelectionAndFocus(a,t,i){const s=this.treeViews.get(a);if(!s)throw new g.NoTreeViewError(a);s.setSelectionAndFocus(t,i)}$setVisible(a,t){const i=this.treeViews.get(a);if(!i){if(!t)return;throw new g.NoTreeViewError(a)}i.setVisible(t)}$changeCheckboxState(a,t){const i=this.treeViews.get(a);if(!i)throw new g.NoTreeViewError(a);i.setCheckboxState(t)}createExtHostTreeView(a,t,i){const s=this._register(new c(a,t,this._proxy,this.commands.converter,this.logService,i));return this.treeViews.set(a,s),s}convertArgument(a){const t=this.treeViews.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=u;class c extends T.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.isUndefinedOrNull)(a))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(a,t,i,s,n,r){if(super(),this.viewId=a,this.proxy=i,this.commands=s,this.logService=n,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new A.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new A.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,r.contributes&&r.contributes.views)for(const p in r.contributes.views)for(const m of r.contributes.views[p])m.id===a&&(this._title=m.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let l,k;const C=A.Event.debounce(this._onDidChangeData.event,(p,m)=>(p||(p={message:!1,elements:[]}),m.element!==!1&&(l||(l=new Promise(b=>k=b),this.refreshPromise=this.refreshPromise.then(()=>l)),Array.isArray(m.element)?p.elements.push(...m.element):p.elements.push(m.element)),m.message&&(p.message=!0),p),200,!0);this._register(C(({message:p,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=k;return l=null,this.refresh(m).then(()=>b())})),p&&this.proxy.$setMessage(this.viewId,E.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let i=this.getChildrenNodes(a);return i||(i=await this.fetchChildrenNodes(t)),i?i.map(s=>s.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const i=(0,R.isUndefinedOrNull)(t.select)?!0:t.select,s=(0,R.isUndefinedOrNull)(t.focus)?!1:t.focus,n=(0,R.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(l=>this.proxy.$reveal(this.viewId,{item:l.item,parentChain:r.map(k=>k.item)},{select:i,focus:s,expand:n})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:i,focus:s,expand:n})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=E.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,t){const i=this.getExtensionElement(a);i&&(t?this._onDidExpandElement.fire(Object.freeze({element:i})):this._onDidCollapseElement.fire(Object.freeze({element:i})))}setSelectionAndFocus(a,t){const i=!(0,P.equals)(this._selectedHandles,a);this._selectedHandles=a;const s=this._focusedHandle!==t;this._focusedHandle=t,i&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),s&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async i=>{const s=this.getExtensionElement(i.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:i.newState?v.TreeItemCheckboxState.Checked:v.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);t.forEach(i=>{i.treeItem.checkboxState=i.newState?v.TreeItemCheckboxState.Checked:v.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(i=>[i.extensionItem,i.newState])})}async handleDrag(a,t,i){const s=[];for(const n of a){const r=this.getExtensionElement(n);r&&s.push(r)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,t,i),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,t,i){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,a,i):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,t){if(!this.dataProvider.resolveTreeItem)return;const i=this.elements.get(a);if(i){const s=this.nodes.get(i);if(s){const n=await this.dataProvider.resolveTreeItem(s.extensionItem,i,t)??s.extensionItem;return this.validateTreeItem(n),s.item.tooltip=this.getTooltip(n.tooltip),s.item.command=this.getCommand(s.disposableStore,n.command),s.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(t=>t?this.resolveUnknownParentChain(t).then(i=>this.resolveTreeNode(t,i[i.length-1]).then(s=>(i.push(s),i))):Promise.resolve([]))}resolveParent(a){const t=this.nodes.get(a);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,t){const i=this.nodes.get(a);return i?Promise.resolve(i):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(s=>this.createHandle(a,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const n=this.getExtensionElement(s);if(n){const r=this.nodes.get(n);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(a){if(a){let t;if(typeof a=="string"){const i=this.getExtensionElement(a);t=i?this.nodes.get(i):void 0}else t=a;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const t=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const i=a?this.nodes.get(a):void 0,s=await this.dataProvider.getChildren(a);if(t.token.isCancellationRequested)return;const n=await Promise.all((0,P.coalesce)(s||[]).map(async r=>{const l=await this.dataProvider.getTreeItem(r);return l&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(r,l,i):null}));return t.token.isCancellationRequested?void 0:(0,P.coalesce)(n)}finally{t.dispose()}}refresh(a){if(a.some(i=>!i))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const i=this.getHandlesToRefresh(a);if(i.length)return this.refreshHandles(i)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const t=new Set,i=a.map(n=>this.nodes.get(n));for(const n of i)if(n&&!t.has(n.item.handle)){let r=n;for(;r&&r.parent&&i.findIndex(l=>r&&r.parent&&l&&l.item.handle===r.parent.item.handle)===-1;){const l=this.elements.get(r.parent.item.handle);r=l?this.nodes.get(l):void 0}r&&!r.parent&&t.add(n.item.handle)}const s=[];return t.forEach(n=>{const r=this.elements.get(n);if(r){const l=this.nodes.get(r);l&&(!l.parent||!t.has(l.parent.item.handle))&&s.push(n)}}),s}refreshHandles(a){const t={};return Promise.all(a.map(i=>this.refreshNode(i).then(s=>{s&&(t[i]=s.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(a){const t=this.getExtensionElement(a);if(t){const i=this.nodes.get(t);if(i)return this.clearChildren(t),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(s=>{if(s){const n=this.createTreeNode(t,s,i.parent);return this.updateNodeCache(t,n,i,i.parent),i.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,t,i){const s=this.createTreeNode(a,t,i);if(t.id&&this.elements.has(s.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.addNodeToCache(a,s),this.addNodeToParentCache(s,i),s}getTooltip(a){return v.MarkdownString.isMarkdownString(a)?E.MarkdownString.from(a):a}getCommand(a,t){return t?{...this.commands.toInternal(t,a),originalId:t.command}:void 0}getCheckbox(a){if(a.checkboxState===void 0)return;let t,i,s;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,i=a.checkboxState.tooltip,s=a.checkboxState.accessibilityInformation),{isChecked:t===v.TreeItemCheckboxState.Checked,tooltip:i,accessibilityInformation:s}}validateTreeItem(a){if(!v.TreeItem.isTreeItem(a,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(a,t,i){this.validateTreeItem(t);const s=this._register(new T.DisposableStore),n=this.createHandle(a,t,i),r=this.getLightIconPath(t);return{item:{handle:n,parentHandle:i?i.item.handle:void 0,label:o(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(s,t.command),contextValue:t.contextValue,icon:r,iconDark:this.getDarkIconPath(t)||r,themeIcon:this.getThemeIcon(t),collapsibleState:(0,R.isUndefinedOrNull)(t.collapsibleState)?v.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:i,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(a){return a.iconPath instanceof v.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:t,label:i,resourceUri:s},n,r){if(t)return`${c.ID_HANDLE_PREFIX}/${t}`;const l=o(i,this.extension),k=n?n.item.handle:c.LABEL_HANDLE_PREFIX;let C=l?l.label:s?(0,O.basename)(s):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const p=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,m=this.getChildrenNodes(n)||[];let b,D=0;do{if(b=`${k}/${D}:${C}`,r||!this.elements.has(b)||p===b)break;D++}while(D<=m.length);return b}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof v.ThemeIcon))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof v.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return f.URI.isUri(a)?a:f.URI.file(a)}addNodeToCache(a,t){this.elements.set(t.item.handle,a),this.nodes.set(a,t)}updateNodeCache(a,t,i,s){this.elements.delete(t.item.handle),this.nodes.delete(a),t.item.handle!==i.item.handle&&this.elements.delete(i.item.handle),this.addNodeToCache(a,t);const n=this.getChildrenNodes(s)||[],r=n.filter(l=>l.item.handle===i.item.handle)[0];r&&n.splice(n.indexOf(r),1,t)}addNodeToParentCache(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const t=this.nodes.get(a);if(t){if(t.children)for(const i of t.children){const s=this.elements.get(i.item.handle);s&&this.clear(s)}t.children=void 0}}else this.clearAll()}clear(a){const t=this.nodes.get(a);if(t){if(t.children)for(const i of t.children){const s=this.elements.get(i.item.handle);s&&this.clear(s)}this.nodes.delete(a),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(De[290],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[291],Ie([1,0,225,9,38,132,105,43,25,290,135,137]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=g.Registry.as(T.Extensions.JSONContribution);class S{constructor(a,t,i){this._messageHandler=a,this._extension=t,this._extensionPointId=i}_msg(a,t){this._messageHandler({type:a,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(f.default.Error,a)}warn(a){this._msg(f.default.Warning,a)}info(a){this._msg(f.default.Info,a)}}e.ExtensionMessageCollector=S;class _{static _toSet(a){const t=new y.ExtensionIdentifierSet;for(let i=0,s=a.length;i<s;i++)t.add(a[i].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new _(t,[]);if(!t||!t.length)return new _([],a);const i=this._toSet(a),s=this._toSet(t),n=t.filter(l=>!i.has(l.description.identifier)),r=a.filter(l=>!s.has(l.description.identifier));return new _(n,r)}constructor(a,t){this.added=a,this.removed=t}}e.ExtensionPointUserDelta=_;class w{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=_.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,O.onUnexpectedError)(a)}}}e.ExtensionPoint=w;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"*",description:I.localize(42,null),body:"*"}]}},badges:{type:"array",description:I.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(44,null)},href:{type:"string",description:I.localize(45,null)},description:{type:"string",description:I.localize(46,null)}}}},markdown:{type:"string",description:I.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:I.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(52,null)},{body:["workspace"],description:I.localize(53,null)},{body:["ui","workspace"],description:I.localize(54,null)},{body:["workspace","ui"],description:I.localize(55,null)},{body:[],description:I.localize(56,null)}]},capabilities:{description:I.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(60,null),I.localize(61,null),I.localize(62,null)]},description:{type:"string",markdownDescription:I.localize(63,null)}}},untrustedWorkspaces:{description:I.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(66,null),I.localize(67,null),I.localize(68,null)]},restrictedConfigurations:{description:I.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(70,null)}}}}},sponsor:{description:I.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(73,null),type:"string"},"vscode:uninstall":{description:I.localize(74,null),type:"string"}}},icon:{type:"string",description:I.localize(75,null)},l10n:{type:"string",description:I.localize(76,null)},pricing:{type:"string",markdownDescription:I.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class u{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new w(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,t),a.activationEventsGenerator&&P.ImplicitActivationEvents.register(a.extensionPoint,a.activationEventsGenerator),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,E.registerSchema(o,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=u;const c={ExtensionsRegistry:"ExtensionsRegistry"};g.Registry.add(c.ExtensionsRegistry,new u),e.ExtensionsRegistry=g.Registry.as(c.ExtensionsRegistry),E.registerSchema(o,e.schema),E.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:I.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}}]}}}})}),define(De[292],Ie([1,0,222,17,24,291,42,4]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var v;(function(E){function S(_,w,d){if(!_)return;const o=O.isString(_.type)?_.type:void 0;if(!o||o.length===0){d.error(I.localize(3,null));return}const u=[];if(Array.isArray(_.required))for(const c of _.required)O.isString(c)&&u.push(c);return{extensionId:w.value,taskType:o,required:u,properties:_.properties?f.deepClone(_.properties):{},when:_.when?T.ContextKeyExpr.deserialize(_.when):void 0}}E.from=S})(v||(v={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(E,S)=>{for(const _ of E)_.type&&S.push(`onTaskType:${_.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:y}});class P{constructor(){this._onDefinitionsChanged=new g.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((S,_)=>{R.setHandler((w,d)=>{this._schema=void 0;try{for(const o of d.removed){const u=o.value;for(const c of u)this.taskTypes&&c.type&&this.taskTypes[c.type]&&delete this.taskTypes[c.type]}for(const o of d.added){const u=o.value;for(const c of u){const h=v.from(c,o.description.identifier,o.collector);h&&(this.taskTypes[h.taskType]=h)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}S(void 0)})})}onReady(){return this.readyPromise}get(S){return this.taskTypes[S]}all(){return Object.keys(this.taskTypes).map(S=>this.taskTypes[S])}getJsonSchema(){if(this._schema===void 0){const S=[];for(const _ of this.all()){const w={type:"object",additionalProperties:!1};_.required.length>0&&(w.required=_.required.slice(0)),_.properties!==void 0?w.properties=f.deepClone(_.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[_.taskType]},S.push(w)}this._schema={oneOf:S}}return this._schema}}e.TaskDefinitionRegistry=new P}),define(De[293],Ie([1,0,223,17,23,24,42,292]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,I.localize(0,null)),e.TASKS_CATEGORY={value:I.localize(1,null),original:"Tasks"};var y;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function N(z){if(!z)return U.Strong;switch(z.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=N}(y||(e.ShellQuoting=y={}));var v;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(v||(e.CommandOptions=v={}));var R;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(R||(e.RevealKind=R={})),function(U){function N(z){switch(z.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=N}(R||(e.RevealKind=R={}));var P;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(U){function N(z){switch(z.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=N}(P||(e.RevealProblemKind=P={}));var E;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(E||(e.PanelKind=E={})),function(U){function N(z){switch(z.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=N}(E||(e.PanelKind=E={}));var S;(function(U){U.defaults={echo:!0,reveal:R.Always,revealProblems:P.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var _;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(_||(e.RuntimeType=_={})),function(U){function N(V){switch(V.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=N;function z(V){switch(V){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=z}(_||(e.RuntimeType=_={}));var w;(function(U){function N(z){return O.isString(z)?z:z.value}U.value=N})(w||(e.CommandString=w={}));var d;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function N(V){return V===U.Clean._id||V===U.Build._id||V===U.Rebuild._id||V===U.Test._id}U.is=N;function z(V){if(V!==void 0)return O.isString(V)?N(V)?{_id:V,isDefault:!1}:void 0:V}U.from=z})(d||(e.TaskGroup=d={}));var o;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var u;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function N(z){switch(z){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=N})(u||(e.TaskSourceKind=u={}));var c;(function(U){U.parallel="parallel",U.sequence="sequence"})(c||(e.DependsOrder=c={}));var h;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(h||(e.RunOnOptions=h={}));var a;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:h.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(N,z,V,ge,te,q){this._label="",this._id=N,z&&(this._label=z),V&&(this.type=V),this.runOptions=ge,this.configurationProperties=te,this._source=q}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.getFolderId(),id:this._id};return JSON.stringify(N)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,z=!1){if(N===void 0)return!1;if(O.isString(N))return N===this._label||N===this.configurationProperties.identifier||z&&N===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),N&&(this._taskLoadMessages=this._taskLoadMessages.concat(N))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class i extends t{constructor(N,z,V,ge,te,q,K,ue){super(N,V,void 0,K,ue,z),this.command={},this._source=z,this.hasDefinedMatchers=q,te&&(this.command=te)}clone(){return new i(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case _.Shell:z="shell";break;case _.Process:z="process";break;case _.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(N){return N instanceof i}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===u.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.getFolderId();if(!N)return;let z=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:z};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(N){return new i(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.CustomTask=i;class s extends t{constructor(N,z,V,ge,te,q,K){super(N,V,ge,q,K,z),this._source=z,this.configures=te}static is(N){return N instanceof s}fromObject(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===u.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.getFolderId();if(!N)return;let z=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:z};return JSON.stringify(V)}}e.ConfiguringTask=s;class n extends t{constructor(N,z,V,ge,te,q,K,ue,ie){super(N,V,ge,ue,ie,z),this.defines=te,this.hasDefinedMatchers=K,this.command=q,this.icon=ie.icon,this.hide=ie.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof n}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.getFolderId(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(N){return new n(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.ContributedTask=n;class r extends t{constructor(N,z,V,ge,te,q){super(N,V,ge,te,q,z),this._source=z}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(N){return new r(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.InMemoryTask=r;var l;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(U){U._default=U.Terminal}(l||(e.ExecutionEngine=l={}));var k;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class C{constructor(N){this._order=new Map;for(let z=0;z<N.length;z++)this._order.set(N[z].uri.toString(),z)}compare(N,z){const V=N.getWorkspaceFolder(),ge=z.getWorkspaceFolder();if(V&&ge){let te=this._order.get(V.uri.toString());te=te===void 0?0:te+1;let q=this._order.get(ge.uri.toString());return q=q===void 0?0:q+1,te===q?N._label.localeCompare(z._label):te-q}else return!V&&ge?-1:V&&!ge?1:0}}e.TaskSorter=C;var p;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(p||(e.TaskEventKind=p={}));var m;(function(U){U.SingleRun="singleRun",U.Background="background"})(m||(e.TaskRunType=m={}));var b;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var D;(function(U){function N(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function z(ue,ie,ce){return{...N(ue),kind:"start",terminalId:ie,resolvedVariables:ce}}U.start=z;function V(ue,ie,ce){return{...N(ue),kind:"processStarted",terminalId:ie,processId:ce}}U.processStarted=V;function ge(ue,ie,ce){return{...N(ue),kind:"processEnded",terminalId:ie,exitCode:ce}}U.processEnded=ge;function te(ue,ie,ce){return{...N(ue),kind:"terminated",exitReason:ce,terminalId:ie}}U.terminated=te;function q(ue,ie,ce){return{...N(ie),kind:ue,terminalId:ce}}U.general=q;function K(){return{kind:"changed"}}U.changed=K})(D||(e.TaskEvent=D={}));var M;(function(U){function N(V){const ge=Object.keys(V).sort();let te="";for(const q of ge){let K=V[q];K instanceof Object?K=N(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),te+=q+","+K+","}return te}function z(V){const te={_key:N(V),type:V.taskType};return Object.assign(te,V),te}U.create=z})(M||(e.KeyedTaskIdentifier=M={}));var L;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(L||(e.TaskSettingId=L={}));var F;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var x;(function(U){function N(z,V){const ge=g.TaskDefinitionRegistry.get(z.type);if(ge===void 0){const ue=A.deepClone(z);return delete ue._key,M.create(ue)}const te=Object.create(null);te.type=ge.taskType;const q=new Set;ge.required.forEach(ue=>q.add(ue));const K=ge.properties;for(const ue of Object.keys(K)){const ie=z[ue];if(ie!=null)te[ue]=ie;else if(q.has(ue)){const ce=K[ue];if(ce.default!==void 0)te[ue]=A.deepClone(ce.default);else switch(ce.type){case"boolean":te[ue]=!1;break;case"number":case"integer":te[ue]=0;break;case"string":te[ue]="";break;default:V.error(I.localize(2,null,JSON.stringify(z,void 0,0),ue));return}}}return M.create(te)}U.createTaskIdentifier=N})(x||(e.TaskDefinition=x={}))}),define(De[294],Ie([1,0,9]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class O{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,g)=>{this._actualOk=T,this._actualErr=g,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,I.onUnexpectedError)(T))}then(T,g){return this._ensureActual().then(T,g)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=O;class f extends O{constructor(){super(),this._hasErr=!0,this._err=new I.CancellationError}}e.CanceledLazyPromise=f}),define(De[69],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class I{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++I.count}}e.ProxyIdentifier=I;const O=[];function f(g){const y=new I(g);return O[y.nid]=y,y}e.createProxyIdentifier=f;function A(g){return O[g].sid}e.getStringIdentifierForProxy=A;class T{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=T}),define(De[6],Ie([1,0,69]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var f;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput"})(f||(e.TabInputKind=f={}));var A;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var T;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var g;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var y;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var v;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(v||(e.NotebookEditorRevealType=v={}));var R;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class P{static{this._n=0}static mixin(d){return d._id=P._n++,d}}e.IdObject=P;var E;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})(E||(e.ISuggestDataDtoField=E={}));var S;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var _;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(_||(e.ExtHostTestingResource=_={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents:(0,I.createProxyIdentifier)("MainThreadChatAgents"),MainThreadChatAgents2:(0,I.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,I.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,I.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,I.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,I.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,I.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,I.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,I.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,I.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,I.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents:(0,I.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatAgents2:(0,I.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,I.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,I.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.createProxyIdentifier)("ExtHostIssueReporter")}}),define(De[295],Ie([1,0,6,7]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class f{constructor(T){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(I.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,g,y){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const v=this._relatedInformationProviders.get(T);if(!v)throw new Error("related information provider not found");return await v.provideRelatedInformation(g,y)??[]}getRelatedInformation(T,g,y){return this._proxy.$getAiRelatedInformation(g,y)}registerRelatedInformationProvider(T,g,y){const v=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(v,y),this._proxy.$registerAiRelatedInformationProvider(v,g),new O.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(v),this._relatedInformationProviders.delete(v)})}}e.ExtHostRelatedInformation=f}),define(De[89],Ie([1,0,5,14,6,20]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,I.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,v){this._extHostLogService=v,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(f.MainContext.MainThreadTelemetry)}report(y,v,R){const P=this.getUsageKey(y,v);this._reportedUsages.has(P)||(this._reportedUsages.add(P),v.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:v.identifier.value,apiId:y}))}getUsageKey(y,v){return`${y}-${v.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=je([$e(0,A.IExtHostRpcService),$e(1,O.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(g,y,v){}})}),define(De[296],Ie([1,0,4,6,7,25]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(v){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new I.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new g,this._getSessionsTaskSingler=new g,this._proxy=v.getProxy(O.MainContext.MainThreadAuthentication)}$setProviders(v){return this._providers=v,Promise.resolve()}async getSession(v,R,P,E={}){const S=A.ExtensionIdentifier.toKey(v.identifier),_=[...P].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${S} ${R} ${_}`,async()=>{await this._proxy.$ensureProvider(R);const w=v.displayName||v.name;return this._proxy.$getSession(R,P,S,w,E)})}async getSessions(v,R,P){const E=A.ExtensionIdentifier.toKey(v.identifier),S=[...P].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${E} ${S}`,async()=>{await this._proxy.$ensureProvider(R);const _=v.displayName||v.name;return this._proxy.$getSessions(R,P,E,_)})}async removeSession(v,R){const P=this._authenticationProviders.get(v);return P?P.provider.removeSession(R):this._proxy.$removeSession(v,R)}registerAuthenticationProvider(v,R,P,E){if(this._authenticationProviders.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this._authenticationProviders.set(v,{label:R,provider:P,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(_=>_.id===v)||this._providers.push({id:v,label:R});const S=P.onDidChangeSessions(_=>{this._proxy.$sendDidChangeSessions(v,{added:_.added??[],changed:_.changed??[],removed:_.removed??[]})});return this._proxy.$registerAuthenticationProvider(v,R,E?.supportsMultipleAccounts??!1),new f.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(v);const _=this._providers.findIndex(w=>w.id===v);_>-1&&this._providers.splice(_),this._proxy.$unregisterAuthenticationProvider(v)})}$createSession(v,R,P){const E=this._authenticationProviders.get(v);if(E)return Promise.resolve(E.provider.createSession(R,P));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,R){const P=this._authenticationProviders.get(v);if(P)return Promise.resolve(P.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,R){const P=this._authenticationProviders.get(v);if(P)return Promise.resolve(P.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,R){return this._onDidChangeSessions.fire({provider:{id:v,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=T;class g{constructor(){this._inFlightPromises=new Map}getOrCreate(v,R){const P=this._inFlightPromises.get(v);if(P)return P;const E=R().finally(()=>this._inFlightPromises.delete(v));return this._inFlightPromises.set(v,E),E}}}),define(De[297],Ie([1,0,6,20,13]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(g,y){this._proxy=g.getProxy(I.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:v=>y.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,y,v){const R=f.WorkspaceEdit.from(g,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,v?.isRefactoring??!1)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=je([$e(0,O.IExtHostRpcService)],A)}),define(De[298],Ie([1,0,8,4,51,3,35,202,6,13]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class R{static{this._pool=0}constructor(S,_){this.extension=S,this.provider=_,this.handle=R._pool++}}class P{static{this._nextId=0}constructor(S,_){this.logService=_,this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new O.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=S.getProxy(y.MainContext.MainThreadChat)}registerChatProvider(S,_,w){const d=new R(S,w);return this._chatProvider.set(d.handle,d),this._proxy.$registerChatProvider(d.handle,_),(0,A.toDisposable)(()=>{this._proxy.$unregisterChatProvider(d.handle),this._chatProvider.delete(d.handle)})}transferChatSession(S,_){const w=f.Iterable.find(this._chatSessions.keys(),d=>this._chatSessions.get(d)===S)??0;typeof w=="number"&&this._proxy.$transferChatSession(w,_)}sendInteractiveRequestToProvider(S,_){this._proxy.$sendRequestToProvider(S,_)}async $prepareChat(S,_,w){const d=this._chatProvider.get(S);if(!d)return;const o=await d.provider.prepareSession(_,w);if(!o)return;const u=P._nextId++;return this._chatSessions.set(u,o),{id:u,requesterUsername:o.requester?.name,requesterAvatarIconUri:o.requester?.icon,responderUsername:o.responder?.name,responderAvatarIconUri:o.responder?.icon,inputPlaceholder:o.inputPlaceholder}}async $provideWelcomeMessage(S,_){const w=this._chatProvider.get(S);if(!w||!w.provider.provideWelcomeMessage)return;const d=await w.provider.provideWelcomeMessage(_);if(d)return d.map(o=>typeof o=="string"?o:Array.isArray(o)?o.map(u=>v.ChatReplyFollowup.from(u)):v.MarkdownString.from(o))}async $provideFollowups(S,_,w){const d=this._chatProvider.get(S);if(!d)return;const o=this._chatSessions.get(_);return!o||!d.provider.provideFollowups?void 0:(await d.provider.provideFollowups(o,w))?.map(c=>v.ChatFollowup.from(c))}async $provideSampleQuestions(S,_){const w=this._chatProvider.get(S);if(!w||!w.provider.provideSampleQuestions)return;const d=await w.provider.provideSampleQuestions(_);if(d)return d?.map(o=>v.ChatReplyFollowup.from(o))}$removeRequest(S,_,w){const d=this._chatProvider.get(S);if(!d)return;const o=this._chatSessions.get(_);o&&d.provider.removeRequest&&d.provider.removeRequest(o,w)}async $provideReply(S,_,w,d){const o=this._chatProvider.get(S);if(!o)return;const u=this._chatSessions.get(_);if(!u)return;const c={session:u,message:w.message,variables:{}};if(w.variables)for(const n of Object.keys(w.variables))c.variables[n]=w.variables[n].map(v.ChatVariable.to);const h=T.StopWatch.create(!1);let a;const t={report:n=>{if(d.isCancellationRequested)return;typeof a>"u"&&(a=h.elapsed());const r=v.ChatResponseProgress.from(o.extension,n);if("placeholder"in n&&"resolvedContent"in n){const l=Promise.all([this._proxy.$acceptResponseProgress(S,_,r),n.resolvedContent]);(0,I.raceCancellation)(l,d).then(k=>{if(!k)return;const[C,p]=k;this._proxy.$acceptResponseProgress(S,_,p,C??void 0)})}else this._proxy.$acceptResponseProgress(S,_,r)}};let i;try{i=await o.provider.provideResponseWithProgress(c,t,d),i||(i={errorDetails:{message:(0,g.localize)(0,null)}})}catch(n){i={errorDetails:{message:(0,g.localize)(1,null,n.message),responseIsIncomplete:!0}},this.logService.error(n)}try{if(u.saveState&&this._chatSessions.has(_)){const n=u.saveState();this._proxy.$acceptChatState(_,n)}}catch(n){this.logService.warn(n)}const s={firstProgress:a??0,totalElapsed:h.elapsed()};return{errorDetails:i.errorDetails,timings:s}}async $provideSlashCommands(S,_,w){const d=this._chatProvider.get(S);if(!d)return;const o=this._chatSessions.get(_);return!o||!d.provider.provideSlashCommands?void 0:(await d.provider.provideSlashCommands(o,w))?.map(c=>({...c,kind:v.CompletionItemKind.from(c.kind)}))}$releaseSession(S){this._chatSessions.delete(S)}async $onDidPerformUserAction(S){this._onDidPerformUserAction.fire(S)}}e.ExtHostChat=P}),define(De[299],Ie([1,0,8,3,64,6,13,7]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents=void 0;class y{static{this._idPool=0}constructor(P,E,S){this._extHostChatProvider=E,this._logService=S,this._agents=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadChatAgents)}registerAgent(P,E,S,_){const w=y._idPool++;return this._agents.set(w,{extension:P,agent:S}),this._proxy.$registerAgent(w,E,_),(0,O.toDisposable)(()=>{this._proxy.$unregisterAgent(w),this._agents.delete(w)})}async $invokeAgent(P,E,S,_,w){const d=this._agents.get(P);if(!d){this._logService.warn(`[CHAT](${P}) CANNOT invoke agent because the agent is not registered`);return}let o=!1;function u(){if(o)throw new Error("Only valid while executing the command")}const c=new I.DeferredPromise;w.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),10*1e3),this._extHostChatProvider.allowListExtensionWhile(d.extension,c.p);const h=d.agent({role:g.ChatMessageRole.User,content:S},{history:_.history.map(T.ChatMessage.to)},new f.Progress(a=>{u(),this._proxy.$handleProgressChunk(E,{content:v(a.message)?a.message:a.message.value})}),w);try{return await(0,I.raceCancellation)(Promise.resolve(h).then(a=>{if(a&&"followUp"in a)return{followUp:a?.followUp?.map(i=>T.ChatFollowup.from(i))}}),w)}finally{o=!0,c.complete()}}}e.ExtHostChatAgents=y;function v(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(De[300],Ie([1,0,8,21,41,4,35,17,2,203,64,6,13,7,271,26]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class d{static{this._idPool=0}constructor(c,h,a){this._extHostChatProvider=h,this._logService=a,this._agents=new Map,this._previousResultMap=new Map,this._resultsBySessionAndRequestId=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadChatAgents2)}createChatAgent(c,h,a){const t=d._idPool++,i=new o(c,h,this._proxy,t,a);return this._agents.set(t,i),this._proxy.$registerAgent(t,h,{}),i.apiAgent}async $invokeAgent(c,h,a,t,i,s){this._previousResultMap.delete(h);const n=this._agents.get(c);if(!n)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let r=!1;function l(){if(r)throw new Error("Only valid while executing the command")}const k=new I.DeferredPromise;s.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this._extHostChatProvider.allowListExtensionWhile(n.extension.identifier,k.p);const C=t.command?await n.validateSlashCommand(t.command):void 0,p=T.StopWatch.create(!1);let m;try{const b=n.invoke({prompt:t.message,variables:E.ChatVariable.objectTo(t.variables),slashCommand:C},{history:i.history.map(E.ChatMessage.to)},new R.Progress(D=>{l(),typeof m>"u"&&"content"in D&&(m=p.elapsed());const M=E.ChatResponseProgress.from(n.extension,D);if("placeholder"in D&&"resolvedContent"in D){const L=Promise.all([this._proxy.$handleProgressChunk(a,M),D.resolvedContent]);(0,I.raceCancellation)(L,s).then(F=>{if(!F)return;const[x,U]=F;this._proxy.$handleProgressChunk(a,U,x??void 0)})}else this._proxy.$handleProgressChunk(a,M)}),s);return await(0,I.raceCancellation)(Promise.resolve(b).then(D=>{if(D){this._previousResultMap.set(h,D);let M=this._resultsBySessionAndRequestId.get(h);M||(M=new Map,this._resultsBySessionAndRequestId.set(h,M)),M.set(a,D);const L={firstProgress:m,totalElapsed:p.elapsed()};return{errorDetails:D.errorDetails,timings:L}}else this._previousResultMap.delete(h)}),s)}catch(b){return this._logService.error(b,n.extension),{errorDetails:{message:(0,v.localize)(0,null,(0,f.toErrorMessage)(b)),responseIsIncomplete:!0}}}finally{r=!0,k.complete()}}$releaseSession(c){this._previousResultMap.delete(c),this._resultsBySessionAndRequestId.delete(c)}async $provideSlashCommands(c,h){const a=this._agents.get(c);return a?a.provideSlashCommand(h):[]}$provideFollowups(c,h,a){const t=this._agents.get(c);if(!t)return Promise.resolve([]);const i=this._previousResultMap.get(h);return i?t.provideFollowups(i,a):Promise.resolve([])}$acceptFeedback(c,h,a,t){const i=this._agents.get(c);if(!i)return;const s=this._resultsBySessionAndRequestId.get(h)?.get(a);if(!s)return;let n;switch(t){case _.InteractiveSessionVoteDirection.Down:n=S.ChatAgentResultFeedbackKind.Unhelpful;break;case _.InteractiveSessionVoteDirection.Up:n=S.ChatAgentResultFeedbackKind.Helpful;break}i.acceptFeedback(Object.freeze({result:s,kind:n}))}$acceptAction(c,h,a,t){const i=this._agents.get(c);if(!i)return;const s=this._resultsBySessionAndRequestId.get(h)?.get(a);s&&t.action.kind!=="vote"&&i.acceptAction(Object.freeze({action:t.action,result:s}))}}e.ExtHostChatAgents2=d;class o{constructor(c,h,a,t,i){this.extension=c,this._id=h,this._proxy=a,this._handle=t,this._callback=i,this._onDidReceiveFeedback=new A.Emitter,this._onDidPerformAction=new A.Emitter}acceptFeedback(c){this._onDidReceiveFeedback.fire(c)}acceptAction(c){this._onDidPerformAction.fire(c)}async validateSlashCommand(c){this._lastSlashCommands||(await this.provideSlashCommand(O.CancellationToken.None),(0,g.assertType)(this._lastSlashCommands));const h=this._lastSlashCommands.find(a=>a.name===c);if(!h)throw new Error(`Unknown slashCommand: ${c}`);return h}async provideSlashCommand(c){if(!this._slashCommandProvider)return[];const h=await this._slashCommandProvider.provideSlashCommands(c);return h?(this._lastSlashCommands=h,h.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate}))):[]}async provideFollowups(c,h){if(!this._followupProvider)return[];const a=await this._followupProvider.provideFollowups(c,h);return a?a.map(t=>E.ChatFollowup.from(t)):[]}get apiAgent(){let c=!1,h=!1;const a=()=>{c||h||(h=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{description:this._description??"",fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof y.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof S.ThemeIcon?this._iconPath:void 0,hasSlashCommands:this._slashCommandProvider!==void 0,hasFollowup:this._followupProvider!==void 0,isDefault:this._isDefault,isSecondary:this._isSecondary}),h=!1}))},t=this;return{get name(){return t._id},get description(){return t._description??""},set description(i){t._description=i,a()},get fullName(){return t._fullName??t.extension.displayName??t.extension.name},set fullName(i){t._fullName=i,a()},get iconPath(){return t._iconPath},set iconPath(i){t._iconPath=i,a()},get slashCommandProvider(){return t._slashCommandProvider},set slashCommandProvider(i){t._slashCommandProvider=i,a()},get followupProvider(){return t._followupProvider},set followupProvider(i){t._followupProvider=i,a()},get isDefault(){return(0,w.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._isDefault},set isDefault(i){(0,w.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._isDefault=i,a()},get isSecondary(){return(0,w.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._isSecondary},set isSecondary(i){(0,w.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._isSecondary=i,a()},get onDidReceiveFeedback(){return t._onDidReceiveFeedback.event},onDidPerformAction:(0,w.isProposedApiEnabled)(this.extension,"chatAgents2Additions")?this._onDidPerformAction.event:void 0,dispose(){c=!0,t._slashCommandProvider=void 0,t._followupProvider=void 0,t._onDidReceiveFeedback.dispose(),t._proxy.$unregisterAgent(t._handle)}}}invoke(c,h,a,t){return this._callback(c,h,a,t)}}}),define(De[301],Ie([1,0,21,3,6,13,64,25,8,4]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class R{constructor(_,w){this.stream=new y.AsyncIterableSource,this.stream=w??new y.AsyncIterableSource;const d=this;this.apiObj={option:_,response:d.stream.asyncIterable}}}class P{constructor(_,w){this._onDidStart=new v.Emitter,this._responseStreams=new Map,this._defaultStream=new y.AsyncIterableSource,this._isDone=!1;const d=this;this.apiObject={result:_,response:d._defaultStream.asyncIterable,onDidStartResponseStream:d._onDidStart.event,cancel(){w.cancel()}},_.finally(()=>{if(this._isDone=!0,this._responseStreams.size>0)for(const[,o]of this._responseStreams)o.stream.resolve();else this._defaultStream.resolve()})}handleFragment(_){if(this._isDone)return;let w=this._responseStreams.get(_.index);w||(this._responseStreams.size===0?w=new R(_.index,this._defaultStream):w=new R(_.index),this._responseStreams.set(_.index,w),this._onDidStart.fire(w.apiObj)),w.stream.emitOne(_.part)}}class E{static{this._idPool=1}constructor(_,w){this._logService=w,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new g.ExtensionIdentifierMap,this._proxy=_.getProxy(f.MainContext.MainThreadChatProvider)}registerProvider(_,w,d,o){const u=E._idPool++;return this._providers.set(u,{extension:_,provider:d}),this._proxy.$registerProvider(u,w,{extension:_,displayName:o.name??_.value}),(0,O.toDisposable)(()=>{this._proxy.$unregisterProvider(u),this._providers.delete(u)})}async $provideChatResponse(_,w,d,o,u){const c=this._providers.get(_);if(!c)return;const h=new T.Progress(async a=>{if(u.isCancellationRequested){this._logService.warn(`[CHAT](${c.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(w,{index:a.index,part:a.part})});return c.provider.provideChatResponse(d.map(A.ChatMessage.to),o,h,u)}allowListExtensionWhile(_,w){this._chatAccessAllowList.set(_,w),w.finally(()=>this._chatAccessAllowList.delete(_))}async requestChatResponseProvider(_,w){if(!this._chatAccessAllowList.has(_))throw new Error("Extension is NOT allowed to make chat requests");const d=this;return{get isRevoked(){return!d._chatAccessAllowList.has(_)},makeRequest(o,u,c){if(!d._chatAccessAllowList.has(_))throw new Error("Access to chat has been revoked");const h=new I.CancellationTokenSource(c),a=Math.random()*1e6|0,t=d._proxy.$fetchResponse(_,w,a,o.map(A.ChatMessage.from),u??{},h.token),i=new P(t,h);return d._pendingRequest.set(a,{res:i}),t.finally(()=>{d._pendingRequest.delete(a)}),i.apiObject}}}async $handleResponseFragment(_,w){const d=this._pendingRequest.get(_);d&&d.res.handleFragment(w)}}e.ExtHostChatProvider=E}),define(De[302],Ie([1,0,3,6,9,13]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class T{static{this._idPool=0}constructor(y){this._resolver=new Map,this._proxy=y.getProxy(O.MainContext.MainThreadChatVariables)}async $resolveVariable(y,v,R){const P=this._resolver.get(y);if(P)try{const E=await P.resolver.resolve(P.data.name,{message:v},R);if(E)return E.map(A.ChatVariable.from)}catch(E){(0,f.onUnexpectedExternalError)(E)}}registerVariableResolver(y,v,R,P){const E=T._idPool++;return this._resolver.set(E,{extension:y.identifier,data:{name:v,description:R},resolver:P}),this._proxy.$registerVariable(E,{name:v,description:R}),(0,I.toDisposable)(()=>{this._resolver.delete(E),this._proxy.$unregisterVariable(E)})}}e.ExtHostChatVariables=T}),define(De[303],Ie([1,0,6]),function(pe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class O{constructor(A){const T=A.getProxy(I.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(g){return T.$writeText(g)}})}}e.ExtHostClipboard=O}),define(De[34],Ie([1,0,17,7,13,24,6,19,14,62,32,61,2,3,5,20,147,22,69,41,35,85,88]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{#e;#t;#i;constructor(C,p,m){this._commands=new Map,this._apiCommands=new Map,this.#e=C.getProxy(T.MainContext.MainThreadCommands),this._logService=p,this.#i=m,this.#t=C.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new s(this,b=>{const D=this._apiCommands.get(b);return D?.result===r.Void?D:void 0},p),this._argumentProcessors=[{processArgument(b){return(0,v.revive)(b)}},{processArgument(b){return(0,A.cloneAndChange)(b,function(D){if(R.Range.isIRange(D))return f.Range.to(D);if(P.Position.isIPosition(D))return f.Position.to(D);if(R.Range.isIRange(D.range)&&E.URI.isUri(D.uri))return f.location.to(D);if(D instanceof o.VSBuffer)return D.buffer.buffer;if(!Array.isArray(D))return D})}}]}registerArgumentProcessor(C){this._argumentProcessors.push(C)}registerApiCommand(C){const p=this.registerCommand(!1,C.id,async(...m)=>{const b=C.args.map((M,L)=>{if(!M.validate(m[L]))throw new Error(`Invalid argument '${M.name}' when running '${C.id}', received: ${typeof m[L]=="object"?JSON.stringify(m[L],null,"	"):m[L]} `);return M.convert(m[L])}),D=await this.executeCommand(C.internalId,...b);return C.result.convert(D,m,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this._apiCommands.set(C.id,C),new O.Disposable(()=>{p.dispose(),this._apiCommands.delete(C.id)})}registerCommand(C,p,m,b,D,M){if(this._logService.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this._commands.has(p))throw new Error(`command '${p}' already exists`);return this._commands.set(p,{callback:m,thisArg:b,metadata:D,extension:M}),C&&this.#e.$registerCommand(p),new O.Disposable(()=>{this._commands.delete(p)&&C&&this.#e.$unregisterCommand(p)})}executeCommand(C,...p){return this._logService.trace("ExtHostCommands#executeCommand",C),this._doExecuteCommand(C,p,!0)}async _doExecuteCommand(C,p,m){if(this._commands.has(C))return this.#e.$fireCommandActivationEvent(C),this._executeContributedCommand(C,p,!1);{let b=!1;const D=(0,A.cloneAndChange)(p,function(M){if(M instanceof O.Position)return f.Position.from(M);if(M instanceof O.Range)return f.Range.from(M);if(M instanceof O.Location)return f.location.from(M);if(O.NotebookRange.isNotebookRange(M))return f.NotebookRange.from(M);if(M instanceof ArrayBuffer)return b=!0,o.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return b=!0,o.VSBuffer.wrap(M);if(M instanceof o.VSBuffer)return b=!0,M;if(!Array.isArray(M))return M});try{const M=await this.#e.$executeCommand(C,b?new u.SerializableObjectWithBuffers(D):D,m);return(0,v.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(C,p,!1);throw M}}}async _executeContributedCommand(C,p,m){const b=this._commands.get(C);if(!b)throw new Error("Unknown command");const{callback:D,thisArg:M,metadata:L}=b;if(L?.args)for(let x=0;x<L.args.length;x++)try{(0,I.validateConstraint)(p[x],L.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${L.args[x].name}' - ${L.args[x].description}`)}const F=h.StopWatch.create();try{return await D.apply(M,p)}catch(x){if(C===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...p);U&&(C=U.command)}if(this._logService.error(x,C,b.extension?.identifier),!m)throw x;if(b.extension?.identifier){const U=this.#i.onExtensionError(b.extension.identifier,x);this._logService.trace("forwarded error to extension?",U,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.toErrorMessage)(x)),this.id=C,this.source=b.extension?.displayName??b.extension?.name}}}finally{this._reportTelemetry(b,C,F.elapsed())}}_reportTelemetry(C,p,m){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new a.TelemetryTrustedValue(p),duration:m})}$executeContributedCommand(C,...p){this._logService.trace("ExtHostCommands#$executeContributedCommand",C);const m=this._commands.get(C);return m?(p=p.map(b=>this._argumentProcessors.reduce((D,M)=>M.processArgument(D,m.extension?.identifier),b)),this._executeContributedCommand(C,p,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this._logService.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(p=>(C&&(p=p.filter(m=>m[0]!=="_")),p))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[p,m]of this._commands){const{metadata:b}=m;b&&(C[p]=b)}return Promise.resolve(C)}};e.ExtHostCommands=i,e.ExtHostCommands=i=je([$e(0,w.IExtHostRpcService),$e(1,y.ILogService),$e(2,t.IExtHostTelemetry)],i),e.IExtHostCommands=(0,_.createDecorator)("IExtHostCommands");class s{constructor(C,p,m){this._commands=C,this._lookupApiCommand=p,this._logService=m,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(C,p){if(!C)return;const m={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return m;const b=this._lookupApiCommand(C.command);if(b)m.id=b.internalId,m.arguments=b.args.map((D,M)=>D.convert(C.arguments&&C.arguments[M]));else if((0,g.isNonEmptyArray)(C.arguments)){const D=`${C.command} /${++this._cachIdPool}`;this._cache.set(D,C),p.add((0,S.toDisposable)(()=>{this._cache.delete(D),this._logService.trace("CommandsConverter#DISPOSE",D)})),m.$ident=D,m.id=this.delegatingCommandId,m.arguments=[D],this._logService.trace("CommandsConverter#CREATE",C.command,D)}return m}fromInternal(C){return typeof C.$ident=="string"?this._cache.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this._cache.get(C[0])}_executeConvertedCommand(...C){const p=this.getActualCommand(...C);return this._logService.trace("CommandsConverter#EXECUTE",C[0],p?p.command:"MISSING"),p?this._commands.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.CommandsConverter=s;class n{static{this.Uri=new n("uri","Uri of a text document",C=>E.URI.isUri(C),C=>C)}static{this.Position=new n("position","A position in a text document",C=>O.Position.isPosition(C),f.Position.from)}static{this.Range=new n("range","A range in a text document",C=>O.Range.isRange(C),f.Range.from)}static{this.Selection=new n("selection","A selection in a text document",C=>O.Selection.isSelection(C),f.Selection.from)}static{this.Number=new n("number","",C=>typeof C=="number",C=>C)}static{this.String=new n("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=n.Arr(n.String)}static Arr(C){return new n(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,p=>Array.isArray(p)&&p.every(m=>C.validate(m)),p=>p.map(m=>C.convert(m)))}static{this.CallHierarchyItem=new n("item","A call hierarchy item",C=>C instanceof O.CallHierarchyItem,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new n("item","A type hierarchy item",C=>C instanceof O.TypeHierarchyItem,f.TypeHierarchyItem.from)}static{this.TestItem=new n("testItem","A VSCodium TestItem",C=>C instanceof d.TestItemImpl,f.TestItem.from)}constructor(C,p,m,b){this.name=C,this.description=p,this.validate=m,this.convert=b}optional(){return new n(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,p){return new n(C??this.name,p??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n;class r{static{this.Void=new r("no result",C=>C)}constructor(C,p){this.description=C,this.convert=p}}e.ApiCommandResult=r;class l{constructor(C,p,m,b,D){this.id=C,this.internalId=p,this.description=m,this.args=b,this.result=D}}e.ApiCommand=l}),define(De[304],Ie([1,0,19,18,2,83,129,42,134,34,13,7]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(R.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,o)=>{if((0,I.isFalsyOrEmpty)(d))return;class u extends P.SymbolInformation{static to(h){const a=new u(h.name,R.SymbolKind.to(h.kind),h.containerName||"",new P.Location(o[0],R.Range.to(h.range)));return a.detail=h.detail,a.range=a.location.range,a.selectionRange=R.Range.to(h.selectionRange),a.children=h.children?h.children.map(u.to):[],a}}return d.map(u.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(R.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(R.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new v.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(R.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(R.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(R.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(o=>P.Position.isPosition(o)),d=>d.map(R.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(o=>{let u;for(const c of o.reverse())u=new P.SelectionRange(R.Range.to(c),u);return u}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(R.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(R.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(R.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(R.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(d)return{range:R.Range.to(d.range),placeholder:d.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(d){if(d.rejectReason)throw new Error(d.rejectReason);return R.WorkspaceEdit.to(d)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(R.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new P.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const o=(0,T.decodeSemanticTokensDto)(d);if(o.type==="full")return new P.SemanticTokens(o.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new P.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const o=(0,T.decodeSemanticTokensDto)(d);if(o.type==="full")return new P.SemanticTokens(o.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,o,u)=>{if(!d)return new P.CompletionList([]);const c=d.suggestions.map(h=>R.CompletionItem.to(h,u));return new P.CompletionList(c,d.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return R.SignatureHelp.to(d)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,o,u)=>_(c=>new P.CodeLens(R.Range.to(c.range),c.command&&u.fromInternal(c.command)))(d))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>P.Range.isRange(d),d=>P.Selection.isSelection(d)?R.Selection.from(d):R.Range.from(d)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,o,u)=>_(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(c.command)}else{const h=new P.CodeAction(c.title,c.kind?new P.CodeActionKind(c.kind):void 0);return c.edit&&(h.edit=R.WorkspaceEdit.to(c.edit)),c.command&&(h.command=u.fromInternal(c.command)),h.isPreferred=c.isPreferred,h}})(d))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(o=>new P.ColorInformation(R.Range.to(o.range),R.Color.to(o.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",d=>d instanceof P.Color,R.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:R.Range.from(d.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(R.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,o,u)=>d.map(R.InlayHint.to.bind(void 0,u)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(d,o)=>{if(d)return d.map(R.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(o=>R.NotebookExclusiveDocumentPattern.to(o))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("context","An InlineValueContext",d=>d&&typeof d.frameId=="number"&&d.stoppedLocation instanceof P.Range,d=>R.InlineValueContext.from(d))],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(R.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>f.URI.isUri(d)||typeof d=="string"&&(0,y.matchesSomeScheme)(d,O.Schemas.http,O.Schemas.https),d=>d),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[R.ViewColumn.from(d),void 0]:[R.ViewColumn.from(d.viewColumn),R.TextEditorOpenOptions.from(d)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[R.ViewColumn.from(d),void 0]:[R.ViewColumn.from(d.viewColumn),R.TextEditorOpenOptions.from(d)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[R.ViewColumn.from(d.viewColumn),R.TextEditorOpenOptions.from(d)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,d=>d)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.StringArray,new v.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",d=>R.MappedEditsContext.is(d),d=>R.MappedEditsContext.from(d))],new v.ApiCommandResult("A promise that resolves to a workspace edit or null",d=>d?R.WorkspaceEdit.to(d):null))];class S{static register(o){E.forEach(o.registerApiCommand,o),this._registerValidateWhenClausesCommand(o)}static _registerValidateWhenClausesCommand(o){o.registerCommand(!1,"_validateWhenClauses",g.validateWhenClauses)}}e.ExtHostApiCommands=S;function _(d){return o=>{if(Array.isArray(o))return o.map(d)}}function w(d){if(!Array.isArray(d))return;const o=[];for(const u of d)A.isLocationLink(u)?o.push(R.DefinitionLink.to(u)):o.push(R.location.to(u));return o}}),define(De[305],Ie([1,0,8,57,4,3,2,83,25,13,7,6,26]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function S(_,w,d){const o=_.getProxy(P.MainContext.MainThreadComments);class u{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,w.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const k=this._commentControllers.get(l.handle);return k?k.value:l}else if(l&&l.$mid===7){const k=this._commentControllers.get(l.commentControlHandle);if(!k)return l;const C=k.getCommentThread(l.commentThreadHandle);return C?C.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const k=this._commentControllers.get(l.thread.commentControlHandle);if(!k)return l;const C=k.getCommentThread(l.thread.commentThreadHandle);return C?l.$mid===8?C.value:{thread:C.value,text:l.text}:l}else if(l&&l.$mid===10){const k=this._commentControllers.get(l.thread.commentControlHandle);if(!k)return l;const C=k.getCommentThread(l.thread.commentThreadHandle);if(!C)return l;const p=l.commentUniqueId,m=C.getCommentByUniqueId(p);return m||l}else if(l&&l.$mid===11){const k=this._commentControllers.get(l.thread.commentControlHandle);if(!k)return l;const C=k.getCommentThread(l.thread.commentThreadHandle);if(!C)return l;const p=l.text,m=l.commentUniqueId,b=C.getCommentByUniqueId(m);return b?(typeof b.body=="string"?b.body=p:b.body=new R.MarkdownString(p),b):l}return l}})}createCommentController(l,k,C){const p=u.handlePool++,m=new h(l,p,k,C);this._commentControllers.set(m.handle,m);const b=this._commentControllersByExtension.get(l.identifier)||[];return b.push(m),this._commentControllersByExtension.set(l.identifier,b),m.value}async $createCommentThreadTemplate(l,k,C){const p=this._commentControllers.get(l);p&&p.$createCommentThreadTemplate(k,C)}async $updateCommentThreadTemplate(l,k,C){const p=this._commentControllers.get(l);p&&p.$updateCommentThreadTemplate(k,C)}$deleteCommentThread(l,k){this._commentControllers.get(l)?.$deleteCommentThread(k)}$provideCommentingRanges(l,k,C){const p=this._commentControllers.get(l);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const m=d.getDocument(T.URI.revive(k));return(0,I.asPromise)(async()=>{const b=await p.commentingRangeProvider.provideCommentingRanges(m,C);let D;return Array.isArray(b)?D={ranges:b,fileComments:!1}:b?D={ranges:b.ranges||[],fileComments:b.fileComments||!1}:D=b??void 0,D}).then(b=>{let D;return b&&(D={ranges:b.ranges.map(M=>v.Range.from(M)),fileComments:b.fileComments}),D})}$toggleReaction(l,k,C,p,m){const b=this._commentControllers.get(l);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,I.asPromise)(()=>{const D=b.getCommentThread(k);if(D){const M=D.getCommentByUniqueId(p.uniqueIdInThread);if(b!==void 0&&M&&b.reactionHandler)return b.reactionHandler(M,i(m))}return Promise.resolve(void 0)})}}class c{static{this._handlePool=0}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){(l===void 0!=(this._range===void 0)||!l||!this._range||!l.isEqual(this._range))&&(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(l){this._state=l,this.modifications.state=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(l,k,C,p,m,b,D,M){this._commentControllerHandle=k,this._id=C,this._uri=p,this._range=m,this._comments=b,this.extensionDescription=D,this._isTemplate=M,this.handle=c._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new f.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${l}.${this.handle}`),o.$createCommentThread(k,this.handle,this._id,this._uri,v.Range.from(this._range),D.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(k,this.handle)}});const L=this;this.value={get uri(){return L.uri},get range(){return L.range},set range(F){L.range=F},get comments(){return L.comments},set comments(F){L.comments=F},get collapsibleState(){return L.collapsibleState},set collapsibleState(F){L.collapsibleState=F},get canReply(){return L.canReply},set canReply(F){L.canReply=F},get contextValue(){return L.contextValue},set contextValue(F){L.contextValue=F},get label(){return L.label},set label(F){L.label=F},get state(){return L.state},set state(F){L.state=F},dispose:()=>{L.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const l=C=>Object.prototype.hasOwnProperty.call(this.modifications,C),k={};l("range")&&(k.range=v.Range.from(this._range)),l("label")&&(k.label=this.label),l("contextValue")&&(k.contextValue=this.contextValue??null),l("comments")&&(k.comments=this._comments.map(C=>a(this,C,this._commentsMap,this.extensionDescription))),l("collapsibleState")&&(k.collapseState=s(this._collapseState)),l("canReply")&&(k.canReply=this.canReply),l("state")&&(k.state=n(this._state)),l("isTemplate")&&(k.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,k)}getCommentByUniqueId(l){for(const k of this._commentsMap){const C=k[0],p=k[1];if(l===p)return C}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose())}}je([(0,O.debounce)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class h{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(l){this._commentingRangeProvider=l,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(l,k,C,p){this._extension=l,this._handle=k,this._id=C,this._label=p,this._threads=new Map,o.$registerCommentController(this.handle,C,p,this._extension.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(b){m.options=b},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(b){m.commentingRangeProvider=b},get reactionHandler(){return m.reactionHandler},set reactionHandler(b){m.reactionHandler=b},createCommentThread(b,D,M){return m.createCommentThread(b,D,M).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(l,k,C){k===void 0&&(0,E.checkProposedApiEnabled)(this._extension,"fileComments");const p=new c(this.id,this.handle,void 0,l,k,C,this._extension,!1);return this._threads.set(p.handle,p),p}$createCommentThreadTemplate(l,k){const C=new c(this.id,this.handle,void 0,T.URI.revive(l),v.Range.to(k),[],this._extension,!0);return C.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this._threads.set(C.handle,C),C}$updateCommentThreadTemplate(l,k){const C=this._threads.get(l);C&&(C.range=v.Range.to(k))}$deleteCommentThread(l){this._threads.get(l)?.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._localDisposables.forEach(l=>l.dispose())}}function a(r,l,k,C){let p=k.get(l);return p||(p=++r.commentHandle,k.set(l,p)),l.state!==void 0&&(0,E.checkProposedApiEnabled)(C,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:p,body:typeof l.body=="string"?l.body:v.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(m=>t(m)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(r){return{label:r.label,iconPath:r.iconPath?v.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?T.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function n(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new u}e.createExtHostComments=S}),define(De[306],Ie([1,0,24,6,27,20]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(R,P){this._mainThreadConsole=R.getProxy(O.MainContext.MainThreadConsole),this._includeStack=P.consoleForward.includeStack,this._logNative=P.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,P){const E=this,S=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){E._handleConsoleCall(R,P,S,arguments)}})}_handleConsoleCall(R,P,E,S){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(S,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,E,S)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=je([$e(0,A.IExtHostRpcService),$e(1,f.IExtHostInitDataService)],T);const g=1e5;function y(v,R){const P=[];if(v.length)for(let E=0;E<v.length;E++){let S=v[E];if(typeof S>"u")S="undefined";else if(S instanceof Error){const _=S;_.stack?S=_.stack:S=_.toString()}P.push(S)}if(R){const E=new Error().stack;E&&P.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,I.safeStringify)(P);return E.length>g?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(De[149],Ie([1,0,2,6,7,5,20,14,19,15,16,26]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class{static{E=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(w,d){this._logService=d,this._provider=new Map,this._proxy=w.getProxy(O.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,d){const o=E._handlePool++;this._provider.set(o,{provider:w,extensionDescription:d}),this._proxy.$registerDecorationProvider(o,d.identifier.value);const u=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(c=>{if(!c){this._proxy.$onDidChange(o,null);return}const h=(0,y.asArray)(c);if(h.length<=E._maxEventSize){this._proxy.$onDidChange(o,h);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,h.length);const a=h.map(s=>({uri:s,rank:(0,v.count)(s.path,"/")})),t=(0,y.groupBy)(a,(s,n)=>s.rank-n.rank||(0,v.compare)(s.uri.path,n.uri.path)),i=[];e:for(const s of t){let n;for(const r of s){const l=(0,R.dirname)(r.uri.path);if(n!==l&&(n=l,i.push(r.uri)>=E._maxEventSize))break e}}this._proxy.$onDidChange(o,i)});return new f.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(w,d,o){if(!this._provider.has(w))return Object.create(null);const u=Object.create(null),{provider:c,extensionDescription:h}=this._provider.get(w);return await Promise.all(d.map(async a=>{try{const{uri:t,id:i}=a,s=await Promise.resolve(c.provideFileDecoration(I.URI.revive(t),o));if(!s)return;try{f.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.checkProposedApiEnabled)(h,"codiconDecoration"),u[i]=[s.propagate,s.tooltip,s.badge,s.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${h.identifier.value}': ${n}`)}}catch(t){this._logService.error(t)}})),u}};e.ExtHostDecorations=S,e.ExtHostDecorations=S=E=je([$e(0,T.IExtHostRpcService),$e(1,g.ILogService)],S),e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(De[307],Ie([1,0,204,133,2,6,7,13,4,14,28,55]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class S{#e;#t;#i;constructor(d,o,u,c,h,a,t,i){this._name=d,this._owner=o,this._maxDiagnosticsTotal=u,this._maxDiagnosticsPerFile=c,this._modelVersionIdProvider=h,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(c,u),this.#i=new R.ResourceMap(s=>a.getComparisonKey(s)),this.#e=t,this.#t=i}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(d,o){if(!d){this.clear();return}this._checkDisposed();let u=[];if(f.URI.isUri(d)){if(!o){this.delete(d);return}this.#i.set(d,o.slice()),u=[d]}else if(Array.isArray(d)){u=[];let a;d=[...d].sort(S._compareIndexedTuplesByUri);for(const t of d){const[i,s]=t;if((!a||i.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=i,u.push(i),this.#i.set(i,[])),s)this.#i.get(i)?.push(...s);else{const n=this.#i.get(i);n&&(n.length=0)}}}if(this.#t.fire(u),!this.#e)return;const c=[];let h=0;for(const a of u){let t=[];const i=this.#i.get(a);if(i)if(i.length>this._maxDiagnosticsPerFile){t=[];const s=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const r of i)if(r.severity===s[n]&&t.push({...g.Diagnostic.from(r),modelVersionId:this._modelVersionIdProvider(a)})===this._maxDiagnosticsPerFile)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,I.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=i.map(s=>({...g.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(a)}));if(c.push([a,t]),h+=t.length,h>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,c)}delete(d){this._checkDisposed(),this.#t.fire([d]),this.#i.delete(d),this.#e?.$changeMany(this._owner,[[d,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(d,o){this._checkDisposed();for(const[u,c]of this)d.call(o,u,c,this)}*[Symbol.iterator](){this._checkDisposed();for(const d of this.#i.keys())yield[d,this.get(d)]}get(d){this._checkDisposed();const o=this.#i.get(d);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(d){return this._checkDisposed(),Array.isArray(this.#i.get(d))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(d,o){return d[0].toString()<o[0].toString()?-1:d[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=S;let _=class{static{E=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*E._maxDiagnosticsPerFile}static _mapper(d){const o=new R.ResourceMap;for(const u of d)o.set(u,u);return{uris:Object.freeze(Array.from(o.values()))}}constructor(d,o,u,c){this._logService=o,this._fileSystemInfoService=u,this._extHostDocumentsAndEditors=c,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:h=>h.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,E._mapper),this._proxy=d.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(d,o){const{_collections:u,_proxy:c,_onDidChangeDiagnostics:h,_logService:a,_fileSystemInfoService:t,_extHostDocumentsAndEditors:i}=this,s=new class{$changeMany(l,k){c.$changeMany(l,k),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,l,k.length===0?"CLEARING":k)}$clear(l){c.$clear(l),a.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,l)}dispose(){c.dispose()}};let n;if(!o)o="_generated_diagnostic_collection_name_#"+E._idPool++,n=o;else if(!u.has(o))n=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do n=o+E._idPool++;while(u.has(n))}return new class extends S{constructor(){super(o,n,E._maxDiagnosticsTotal,E._maxDiagnosticsPerFile,l=>i.getDocument(l)?.version,t.extUri,s,h),u.set(n,this)}dispose(){super.dispose(),u.delete(n)}}}getDiagnostics(d){if(d)return this._getDiagnostics(d);{const o=new Map,u=[];for(const c of this._collections.values())c.forEach((h,a)=>{let t=o.get(h.toString());typeof t>"u"&&(t=u.length,o.set(h.toString(),t),u.push([h,[]])),u[t][1]=u[t][1].concat(...a)});return u}}_getDiagnostics(d){let o=[];for(const u of this._collections.values())u.has(d)&&(o=o.concat(u.get(d)));return o}$acceptMarkersChange(d){if(!this._mirrorCollection){const o="_generated_mirror",u=new S(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,u),this._mirrorCollection=u}for(const[o,u]of d)this._mirrorCollection.set(f.URI.revive(o),u.map(g.Diagnostic.to))}};e.ExtHostDiagnostics=_,e.ExtHostDiagnostics=_=E=je([$e(1,v.ILogService),$e(2,P.IExtHostFileSystemInfo)],_)}),define(De[308],Ie([1,0,2,6,26]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(g){this._proxy=g.getProxy(O.MainContext.MainThreadDialogs)}showOpenDialog(g,y){return y?.allowUIResources&&(0,f.checkProposedApiEnabled)(g,"showLocal"),this._proxy.$showOpenDialog(y).then(v=>v?v.map(R=>I.URI.revive(R)):void 0)}showSaveDialog(g){return this._proxy.$showSaveDialog(g).then(y=>y?I.URI.revive(y):void 0)}}e.ExtHostDialogs=A}),define(De[309],Ie([1,0,9,2,7,6,18,21,15]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class v{static{this._handlePool=0}constructor(P,E,S){this._documentsAndEditors=E,this._logService=S,this._documentContentProviders=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,E){if(Object.keys(T.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const S=v._handlePool++;this._documentContentProviders.set(S,E),this._proxy.$registerTextContentProvider(S,P);let _;return typeof E.onDidChange=="function"&&(_=E.onDidChange(w=>{if(w.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(S,w).then(d=>{if(!d&&typeof d!="string")return;const o=this._documentsAndEditors.getDocument(w);if(!o)return;const u=(0,y.splitLines)(d);if(!o.equalLines(u))return this._proxy.$onVirtualDocumentChange(w,d)},I.onUnexpectedError)})),new f.Disposable(()=>{this._documentContentProviders.delete(S)&&this._proxy.$unregisterTextContentProvider(S),_&&(_.dispose(),_=void 0)})}$provideTextDocumentContent(P,E){const S=this._documentContentProviders.get(P);return S?Promise.resolve(S.provideTextDocumentContent(O.URI.revive(E),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=v}),define(De[310],Ie([1,0,4,3,2,6,141,13,17,24,7,9]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(_,w){this._onDidAddDocument=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this._onDidRemoveDocument=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this._onDidChangeDocument=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this._onDidSaveDocument=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new O.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const o of d)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const o of d)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const w=this._documentsAndEditors.getDocument(_);if(w)return w}getDocument(_){const w=this.getDocumentData(_);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return w.document}ensureDocumentData(_){const w=this._documentsAndEditors.getDocument(_);if(w)return Promise.resolve(w);let d=this._documentLoader.get(_.toString());return d||(d=this._proxy.$tryOpenDocument(_).then(o=>{this._documentLoader.delete(_.toString());const u=f.URI.revive(o);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(u))},o=>(this._documentLoader.delete(_.toString()),Promise.reject(o))),this._documentLoader.set(_.toString(),d)),d}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(w=>f.URI.revive(w))}$acceptModelLanguageChanged(_,w){const d=f.URI.revive(_),o=this._documentsAndEditors.getDocument(d);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(w),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(_){const w=f.URI.revive(_),d=this._documentsAndEditors.getDocument(w);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(_,w){const d=f.URI.revive(_),o=this._documentsAndEditors.getDocument(d);if(!o)throw new Error("unknown document");o._acceptIsDirty(w),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,w,d){const o=f.URI.revive(_),u=this._documentsAndEditors.getDocument(o);if(!u)throw new Error("unknown document");u._acceptIsDirty(d),u.onEvents(w);let c;w.isUndoing?c=R.TextDocumentChangeReason.Undo:w.isRedoing&&(c=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,v.deepFreeze)({document:u.document,contentChanges:w.changes.map(h=>({range:g.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:c}))}setWordDefinitionFor(_,w){(0,T.setWordDefinitionFor)(_,w)}}e.ExtHostDocuments=E}),define(De[70],Ie([1,0,58,4,3,2,5,6,141,20,148,13,14,28,18,51,47]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let u=class{constructor(h,a){this._extHostRpc=h,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new S.ResourceMap,this._onDidAddDocuments=new O.Emitter,this._onDidRemoveDocuments=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const a=[],t=[],i=[];if(h.removedDocuments)for(const s of h.removedDocuments){const n=A.URI.revive(s),r=this._documents.get(n);r?.unref()&&(this._documents.delete(n),a.push(r.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const n=A.URI.revive(s.uri);let r=this._documents.get(n);if(r&&n.scheme!==_.Schemas.vscodeNotebookCell&&n.scheme!==_.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);r||(r=new o(new y.ExtHostDocumentData(this._extHostRpc.getProxy(g.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(n,r),t.push(r.value)),r.ref()}if(h.removedEditors)for(const s of h.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&i.push(n)}if(h.addedEditors)for(const s of h.addedEditors){const n=A.URI.revive(s.documentUri);I.ok(this._documents.has(n),`document '${n}' does not exist`),I.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(n).value,l=new R.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(g.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>r.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(k=>P.Range.to(k)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,l)}h.newActiveEditor!==void 0&&(I.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,f.dispose)(a),(0,f.dispose)(i),h.removedDocuments&&this._onDidRemoveDocuments.fire(a),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const a=this._editors.get(this._activeEditorId);return h?a:a?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=u,e.ExtHostDocumentsAndEditors=u=je([$e(0,v.IExtHostRpcService),$e(1,E.ILogService)],u),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[71],Ie([1,0,13,6,2,4,5,7,20,17,74]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class P{constructor(d,o,u){this._activeTabIdGetter=u,this._parentGroup=o,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,o={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new g.TextTabInput(f.URI.revive(this._dto.input.uri));case 2:return new g.TextDiffTabInput(f.URI.revive(this._dto.input.original),f.URI.revive(this._dto.input.modified));case 3:return new g.TextMergeTabInput(f.URI.revive(this._dto.input.base),f.URI.revive(this._dto.input.input1),f.URI.revive(this._dto.input.input2),f.URI.revive(this._dto.input.result));case 6:return new g.CustomEditorTabInput(f.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new g.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new g.NotebookEditorTabInput(f.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new g.NotebookDiffEditorTabInput(f.URI.revive(this._dto.input.original),f.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new g.TerminalEditorTabInput;case 9:return new g.InteractiveWindowInput(f.URI.revive(this._dto.input.uri),f.URI.revive(this._dto.input.inputBoxUri));default:return}}}class E{constructor(d,o){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=o;for(const u of d.tabs)u.isActive&&(this._activeTabId=u.id),this._tabs.push(new P(u,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,o={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return I.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(u=>u.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(u=>u.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const u=new P(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,u),d.tabDto.isActive&&(this._activeTabId=u.tabId),u}else if(d.kind===1){const u=this._tabs.splice(d.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return u.tabId===this._activeTabId&&(this._activeTabId=""),u}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this._tabs.splice(d.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,u),u}const o=this._tabs.find(u=>u.tabId===d.tabDto.id);if(!o)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(d.tabDto),o}activeTabId(){return this._activeTabId}}let S=class{constructor(d){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(O.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,o={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(u=>u.apiObject))},get activeTabGroup(){const u=d._activeGroupId;return(0,v.assertIsDefined)(d._extHostTabGroups.find(h=>h.groupId===u)?.apiObject)},close:async(u,c)=>{const h=Array.isArray(u)?u:[u];return h.length?_(h[0])?this._closeGroups(h,c):this._closeTabs(h,c):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(d){const o=new Set(this._extHostTabGroups.map(s=>s.groupId)),u=new Set(d.map(s=>s.groupId)),c=(0,R.diffSets)(o,u),h=this._extHostTabGroups.filter(s=>c.removed.includes(s.groupId)).map(s=>s.apiObject),a=[],t=[];this._extHostTabGroups=d.map(s=>{const n=new E(s,()=>this._activeGroupId);return c.added.includes(n.groupId)?a.push(n.apiObject):t.push(n.apiObject),n});const i=(0,v.assertIsDefined)(d.find(s=>s.isActive===!0)?.groupId);i!==void 0&&this._activeGroupId!==i&&(this._activeGroupId=i),this._onDidChangeTabGroups.fire(Object.freeze({opened:a,closed:h,changed:t}))}$acceptTabGroupUpdate(d){const o=this._extHostTabGroups.find(u=>u.groupId===d.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const o=this._extHostTabGroups.find(c=>c.groupId===d.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const u=o.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}_findExtHostTabFromApi(d){for(const o of this._extHostTabGroups)for(const u of o.tabs)if(u.apiObject===d)return u}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(o=>o.apiObject===d)}async _closeTabs(d,o){const u=[];for(const c of d){const h=this._findExtHostTabFromApi(c);if(!h)throw new Error("Tab close: Invalid tab not found!");u.push(h.tabId)}return this._proxy.$closeTab(u,o)}async _closeGroups(d,o){const u=[];for(const c of d){const h=this._findExtHostTabGroupFromApi(c);if(!h)throw new Error("Group close: Invalid group not found!");u.push(h.groupId)}return this._proxy.$closeGroup(u,o)}};e.ExtHostEditorTabs=S,e.ExtHostEditorTabs=S=je([$e(0,y.IExtHostRpcService)],S);function _(w){return w.tabs!==void 0}}),define(De[311],Ie([1,0,6,7]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class f{constructor(T){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(I.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,g,y){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const v=this._AiEmbeddingVectorProviders.get(T);if(!v)throw new Error("Embedding vector provider not found");const R=await v.provideEmbeddingVector(g,y);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(T,g,y){const v=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(v,y),this._proxy.$registerAiEmbeddingVectorProvider(g,v),new O.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(v),this._AiEmbeddingVectorProviders.delete(v)})}}e.ExtHostAiEmbeddingVector=f}),define(De[312],Ie([1,0,2,6,3,7,13,169,15,22,26,80]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class E{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const d=this._schemes.indexOf(w);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),d=[];let o,u,c=14,h=14;for(const a of w){let t=o?(0,y.commonPrefixLength)(o,a):0;for(t===0?u=1:u=h;t<a.length;t++)t+1===a.length?(c=h,h=9):h+=1,d.push([u,a.toUpperCase().charCodeAt(t),h]),d.push([u,a.toLowerCase().charCodeAt(t),h]),u=h;o=a,h=c}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new g.StateMachine(d)}}provideDocumentLinks(w){this._initStateMachine();const d=[],o=g.LinkComputer.computeLinks({getLineContent(u){return w.lineAt(u-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const u of o){const c=T.DocumentLink.to(u);c.target&&d.push(c)}return d}}class S{constructor(w,d){this._extHostLanguageFeatures=d,this._linkProvider=new E,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(O.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,d,o,u={}){if(S._validateFileSystemProvider(o),this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const c=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(c,o);let h=2;u.isCaseSensitive&&(h+=1024),u.isReadonly&&(h+=2048),typeof o.copy=="function"&&(h+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,R.checkProposedApiEnabled)(w,"fsChunks"),h+=4);let a;u.isReadonly&&(0,P.isMarkdownString)(u.isReadonly)&&((0,R.checkProposedApiEnabled)(w,"readonlyMessage"),a={value:u.isReadonly.value,isTrusted:u.isReadonly.isTrusted,supportThemeIcons:u.isReadonly.supportThemeIcons,supportHtml:u.isReadonly.supportHtml,baseUri:u.isReadonly.baseUri,uris:u.isReadonly.uris}),this._proxy.$registerFileSystemProvider(c,d,h,a).catch(i=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${d}`),console.error(i)});const t=o.onDidChangeFile(i=>{const s=[];for(const n of i){const{uri:r,type:l}=n;if(r.scheme!==d)continue;let k;switch(l){case A.FileChangeType.Changed:k=0;break;case A.FileChangeType.Created:k=1;break;case A.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:r,type:k})}this._proxy.$onFileSystemChange(c,s)});return(0,f.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(c),this._proxy.$unregisterProvider(c)})}static _validateFileSystemProvider(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(w){const{type:d,ctime:o,mtime:u,size:c,permissions:h}=w;return{type:d,ctime:o,mtime:u,size:c,permissions:h}}$stat(w,d){return Promise.resolve(this._getFsProvider(w).stat(I.URI.revive(d))).then(o=>S._asIStat(o))}$readdir(w,d){return Promise.resolve(this._getFsProvider(w).readDirectory(I.URI.revive(d)))}$readFile(w,d){return Promise.resolve(this._getFsProvider(w).readFile(I.URI.revive(d))).then(o=>v.VSBuffer.wrap(o))}$writeFile(w,d,o,u){return Promise.resolve(this._getFsProvider(w).writeFile(I.URI.revive(d),o.buffer,u))}$delete(w,d,o){return Promise.resolve(this._getFsProvider(w).delete(I.URI.revive(d),o))}$rename(w,d,o,u){return Promise.resolve(this._getFsProvider(w).rename(I.URI.revive(d),I.URI.revive(o),u))}$copy(w,d,o,u){const c=this._getFsProvider(w);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(I.URI.revive(d),I.URI.revive(o),u))}$mkdir(w,d){return Promise.resolve(this._getFsProvider(w).createDirectory(I.URI.revive(d)))}$watch(w,d,o,u){const c=this._getFsProvider(w).watch(I.URI.revive(o),u);this._watches.set(d,c)}$unwatch(w,d){const o=this._watches.get(d);o&&(o.dispose(),this._watches.delete(d))}$open(w,d,o){const u=this._getFsProvider(w);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(I.URI.revive(d),o))}$close(w,d){const o=this._getFsProvider(w);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(d))}$read(w,d,o,u){const c=this._getFsProvider(w);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const h=v.VSBuffer.alloc(u);return Promise.resolve(c.read(d,o,h.buffer,0,u)).then(a=>h.slice(0,a))}$write(w,d,o,u){const c=this._getFsProvider(w);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(d,o,u.buffer,0,u.byteLength))}_getFsProvider(w){const d=this._fsProvider.get(w);if(!d){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return d}}e.ExtHostFileSystem=S}),define(De[72],Ie([1,0,6,30,7,22,5,20,55,3,8,23,18]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let _=S=class{constructor(d,o){this._fileSystemProvider=new Map,this._writeQueue=new R.ResourceQueue,this._proxy=d.getProxy(I.MainContext.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(c){try{let h;const a=u._fileSystemProvider.get(c.scheme);return a?(await u._proxy.$ensureActivation(c.scheme),h=await a.impl.stat(c)):h=await u._proxy.$stat(c),{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions===O.FilePermission.Readonly?1:void 0}}catch(h){S._handleError(h)}},async readDirectory(c){try{const h=u._fileSystemProvider.get(c.scheme);return h?(await u._proxy.$ensureActivation(c.scheme),(await h.impl.readDirectory(c)).slice()):await u._proxy.$readdir(c)}catch(h){return S._handleError(h)}},async createDirectory(c){try{const h=u._fileSystemProvider.get(c.scheme);return h&&!h.isReadonly?(await u._proxy.$ensureActivation(c.scheme),await u.mkdirp(h.impl,h.extUri,c)):await u._proxy.$mkdir(c)}catch(h){return S._handleError(h)}},async readFile(c){try{const h=u._fileSystemProvider.get(c.scheme);return h?(await u._proxy.$ensureActivation(c.scheme),(await h.impl.readFile(c)).slice()):(await u._proxy.$readFile(c)).buffer}catch(h){return S._handleError(h)}},async writeFile(c,h){try{const a=u._fileSystemProvider.get(c.scheme);return a&&!a.isReadonly?(await u._proxy.$ensureActivation(c.scheme),await u.mkdirp(a.impl,a.extUri,a.extUri.dirname(c)),await u._writeQueue.queueFor(c).queue(()=>Promise.resolve(a.impl.writeFile(c,h,{create:!0,overwrite:!0})))):await u._proxy.$writeFile(c,A.VSBuffer.wrap(h))}catch(a){return S._handleError(a)}},async delete(c,h){try{const a=u._fileSystemProvider.get(c.scheme);return a&&!a.isReadonly?(await u._proxy.$ensureActivation(c.scheme),await a.impl.delete(c,{recursive:!1,...h})):await u._proxy.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...h})}catch(a){return S._handleError(a)}},async rename(c,h,a){try{return await u._proxy.$rename(c,h,{overwrite:!1,...a})}catch(t){return S._handleError(t)}},async copy(c,h,a){try{return await u._proxy.$copy(c,h,{overwrite:!1,...a})}catch(t){return S._handleError(t)}},isWritableFileSystem(c){const h=o.getCapabilities(c);if(typeof h=="number")return!(h&2048)}})}async mkdirp(d,o,u){const c=[];for(;!o.isEqual(u,o.dirname(u));)try{if(!((await d.stat(u)).type&O.FileType.Directory))throw f.FileSystemError.FileExists(`Unable to create folder '${u.scheme===E.Schemas.file?u.fsPath:u.toString(!0)}' that already exists but is not a directory`);break}catch(h){if(O.toFileSystemProviderErrorCode(h)!==O.FileSystemProviderErrorCode.FileNotFound)throw h;c.push(o.basename(u)),u=o.dirname(u)}for(let h=c.length-1;h>=0;h--){u=o.joinPath(u,c[h]);try{await d.createDirectory(u)}catch(a){if(O.toFileSystemProviderErrorCode(a)!==O.FileSystemProviderErrorCode.FileExists)throw a}}}static _handleError(d){if(d instanceof f.FileSystemError)throw d;if(d instanceof O.FileSystemProviderError)switch(d.code){case O.FileSystemProviderErrorCode.FileExists:throw f.FileSystemError.FileExists(d.message);case O.FileSystemProviderErrorCode.FileNotFound:throw f.FileSystemError.FileNotFound(d.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw f.FileSystemError.FileNotADirectory(d.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw f.FileSystemError.FileIsADirectory(d.message);case O.FileSystemProviderErrorCode.NoPermissions:throw f.FileSystemError.NoPermissions(d.message);case O.FileSystemProviderErrorCode.Unavailable:throw f.FileSystemError.Unavailable(d.message);default:throw new f.FileSystemError(d.message,d.name)}if(!(d instanceof Error))throw new f.FileSystemError(String(d));if(d.name==="ENOPRO"||d.message.includes("ENOPRO"))throw f.FileSystemError.Unavailable(d.message);switch(d.name){case O.FileSystemProviderErrorCode.FileExists:throw f.FileSystemError.FileExists(d.message);case O.FileSystemProviderErrorCode.FileNotFound:throw f.FileSystemError.FileNotFound(d.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw f.FileSystemError.FileNotADirectory(d.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw f.FileSystemError.FileIsADirectory(d.message);case O.FileSystemProviderErrorCode.NoPermissions:throw f.FileSystemError.NoPermissions(d.message);case O.FileSystemProviderErrorCode.Unavailable:throw f.FileSystemError.Unavailable(d.message);default:throw new f.FileSystemError(d.message,d.name)}}addFileSystemProvider(d,o,u){return this._fileSystemProvider.set(d,{impl:o,extUri:u?.isCaseSensitive?P.extUri:P.extUriIgnorePathCase,isReadonly:!!u?.isReadonly}),(0,v.toDisposable)(()=>this._fileSystemProvider.delete(d))}getFileSystemProviderExtUri(d){return this._fileSystemProvider.get(d)?.extUri??P.extUri}};e.ExtHostConsumerFileSystem=_,e.ExtHostConsumerFileSystem=_=S=je([$e(0,g.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],_),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(De[313],Ie([1,0,4,36,2,6,13,7,47]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class v{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(S,_,w,d,o,u){this.session=Math.random(),this._onDidCreate=new I.Emitter,this._onDidChange=new I.Emitter,this._onDidDelete=new I.Emitter,this._config=0,u?.ignoreCreateEvents&&(this._config+=1),u?.ignoreChangeEvents&&(this._config+=2),u?.ignoreDeleteEvents&&(this._config+=4);const c=(0,O.parse)(o),h=typeof o=="string",a=u?.correlate,t=d(i=>{if(!(typeof i.session=="number"&&i.session!==this.session)&&!(a&&typeof i.session>"u")){if(!u?.ignoreCreateEvents)for(const s of i.created){const n=f.URI.revive(s);c(n.fsPath)&&(!h||_.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!u?.ignoreChangeEvents)for(const s of i.changed){const n=f.URI.revive(s);c(n.fsPath)&&(!h||_.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!u?.ignoreDeleteEvents)for(const s of i.deleted){const n=f.URI.revive(s);c(n.fsPath)&&(!h||_.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}}});this._disposable=g.Disposable.from(this.ensureWatching(S,w,o,u,u?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(S,_,w,d,o){const u=g.Disposable.from();if(typeof w=="string")return u;const c=S.getProxy(A.MainContext.MainThreadFileSystemEventService);let h=!1;return(w.pattern.includes(O.GLOBSTAR)||w.pattern.includes(O.GLOB_SPLIT))&&(h=!0),c.$watch(_.identifier.value,this.session,w.baseUri,{recursive:h,excludes:d?.excludes??[]},!!o),g.Disposable.from({dispose:()=>c.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(S){this._events=S,this.session=this._events.session,this._created=new y.Lazy(()=>this._events.created.map(f.URI.revive)),this._changed=new y.Lazy(()=>this._events.changed.map(f.URI.revive)),this._deleted=new y.Lazy(()=>this._events.deleted.map(f.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class P{constructor(S,_,w){this._mainContext=S,this._logService=_,this._extHostDocumentsAndEditors=w,this._onFileSystemEvent=new I.Emitter,this._onDidRenameFile=new I.Emitter,this._onDidCreateFile=new I.Emitter,this._onDidDeleteFile=new I.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,_,w,d){return new v(this._mainContext,S,_,this._onFileSystemEvent.event,T.GlobPattern.from(w),d)}$onFileEvent(S){this._onFileSystemEvent.fire(new R(S))}$onDidRunFileOperation(S,_){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(w=>({oldUri:f.URI.revive(w.source),newUri:f.URI.revive(w.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(w=>f.URI.revive(w.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:_.map(w=>f.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,_){return(w,d,o)=>{const u=function(h){w.call(d,h)};return u.extension=S,_.event(u,void 0,o)}}async $onWillRunFileOperation(S,_,w,d){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},w,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(o=>f.URI.revive(o.target))},w,d);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(o=>f.URI.revive(o.target))},w,d)}}async _fireWillEvent(S,_,w,d){const o=new Set,u=[];if(await S.fireAsync(_,d,async(h,a)=>{const t=Date.now(),i=await Promise.resolve(h);i instanceof g.WorkspaceEdit&&(u.push([a.extension,i]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>w&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),d.isCancellationRequested||u.length===0)return;const c={edits:[]};for(const[,h]of u){const{edits:a}=T.WorkspaceEdit.from(h,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(a)}return{edit:c,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=P}),define(De[314],Ie([1,0,3,2,6,13,7,34,8]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class v{static{this._pool=0}constructor(S,_){this.extension=S,this.provider=_,this.handle=v._pool++}}class R{constructor(S){this.session=S,this.responses=[]}}class P{static{this._nextId=0}constructor(S,_,w,d){this._documents=w,this._logService=d,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=S.getProxy(f.MainContext.MainThreadInlineChat),_.registerApiCommand(new g.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.ApiCommandArgument("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?A.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?A.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?A.Position.from(o.position):void 0}})],g.ApiCommandResult.Void))}registerProvider(S,_,w){const d=new v(S,_);return this._inputProvider.set(d.handle,d),this._proxy.$registerInteractiveEditorProvider(d.handle,w.label,S.identifier.value,typeof _.handleInteractiveEditorResponseFeedback=="function"),(0,I.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(d.handle),this._inputProvider.delete(d.handle)})}async $prepareSession(S,_,w,d){const o=this._inputProvider.get(S);if(!o){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const u=this._documents.getDocument(O.URI.revive(_)),c=A.Selection.to(w),h=await o.provider.prepareInteractiveEditorSession({document:u,selection:c},d);if(!h)return;if(h.wholeRange&&!h.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=P._nextId++;return this._inputSessions.set(a,new R(h)),{id:a,placeholder:h.placeholder,input:h.input,slashCommands:h.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:A.Range.from(h.wholeRange),message:h.message}}async $provideResponse(S,_,w,d){const o=this._inputProvider.get(S);if(!o)return;const u=this._inputSessions.get(_.id);if(!u)return;const c={prompt:w.prompt,selection:A.Selection.to(w.selection),wholeRange:A.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let h=!1;const a={report:async l=>{if(!w.live&&l.edits?.length)throw new Error("Progress reporting is only supported for live sessions");h||d.isCancellationRequested||await this._proxy.$handleProgressChunk(w.requestId,{message:l.message,edits:l.edits?.map(A.TextEdit.from),editsShouldBeInstant:l.editsShouldBeInstant,slashCommand:l.slashCommand?.command,markdownFragment:T.MarkdownString.isMarkdownString(l.content)?l.content.value:l.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(u.session,c,a,d));let i;try{i=await(0,y.raceCancellation)(t,d)}finally{h=!0}if(!i)return;const s=u.responses.push(i)-1,n={wholeRange:A.Range.from(i.wholeRange),placeholder:i.placeholder};if(P._isMessageResponse(i))return{...n,id:s,type:"message",message:A.MarkdownString.from(i.contents)};const{edits:r}=i;return r instanceof T.WorkspaceEdit?{...n,id:s,type:"bulkEdit",edits:A.WorkspaceEdit.from(r)}:{...n,id:s,type:"editorEdit",edits:r.map(A.TextEdit.from)}}$handleFeedback(S,_,w,d){const o=this._inputProvider.get(S),u=this._inputSessions.get(_),c=u?.responses[w];if(o&&c){const h=A.InteractiveEditorResponseFeedbackKind.to(d);o.provider.handleInteractiveEditorResponseFeedback?.(u.session,c,h)}}$releaseSession(S,_){}static _isMessageResponse(S){return typeof S=="object"&&typeof S.contents=="object"}}e.ExtHostInteractiveEditor=P}),define(De[315],Ie([1,0,2,34]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class f{constructor(T,g,y,v,R){this._extHostNotebooks=g,this._textDocumentsAndEditors=y,this._commands=v;const P=new O.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new O.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new O.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new O.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new O.ApiCommandResult("Notebook and input URI",E=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const S=this._extHostNotebooks.getEditorById(E.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:I.URI.revive(E.notebookUri),inputUri:I.URI.revive(E.inputUri),notebookEditor:S.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:I.URI.revive(E.notebookUri),inputUri:I.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(P)}$willAddInteractiveDocument(T,g,y,v){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(I.URI.revive(v))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,g){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=f}),define(De[316],Ie([1,0,6,7]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class f{constructor(T){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=T.getProxy(I.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,g){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(T);if(!y)throw new Error("Issue request handler not found");const v=await y.handleIssueUrlRequest();if(!v)throw new Error("Issue request handler returned no result");return v}async $getIssueReporterData(T,g){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const y=this._IssueDataProviders.get(T);if(!y)throw new Error("Issue data provider not found");const v=await y.provideIssueData(g);if(!v)throw new Error("Issue data provider returned no result");return v}async $getIssueReporterTemplate(T,g){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const y=this._IssueDataProviders.get(T);if(!y)throw new Error("Issue data provider not found");const v=await y.provideIssueTemplate(g);if(!v)throw new Error("Issue template provider returned no result");return v}registerIssueUriRequestHandler(T,g){const y=T.identifier.value;return this._IssueUriRequestHandlers.set(y,g),this._proxy.$registerIssueUriRequestHandler(y),new O.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}registerIssueDataProvider(T,g){const y=T.identifier.value;return this._IssueDataProviders.set(y,g),this._proxy.$registerIssueDataProvider(y),new O.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(y),this._IssueDataProviders.delete(y)})}}e.ExtHostIssueReporter=f}),define(De[317],Ie([1,0,3,6]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class f{constructor(T){this._handlePool=0,this._proxy=T.getProxy(O.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const g=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(g,T),(0,I.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(g)})}}e.ExtHostLabelService=f}),define(De[318],Ie([1,0,2,24,13,7,83,6,15,32,19,17,165,21,25,3,129,119,107,35,9,8,26,206]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentSymbols(B,G){const se=this._documents.getDocument(B),oe=await this._provider.provideDocumentSymbols(se,G);if(!(0,R.isFalsyOrEmpty)(oe))return oe[0]instanceof A.DocumentSymbol?oe.map(f.DocumentSymbol.from):s._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((oe,Y)=>{let me=oe.location.range.start.compareTo(Y.location.range.start);return me===0&&(me=Y.location.range.end.compareTo(oe.location.range.end)),me});const G=[],se=[];for(const oe of B){const Y={name:oe.name||"!!MISSING: name!!",kind:f.SymbolKind.from(oe.kind),tags:oe.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:f.Range.from(oe.location.range),selectionRange:f.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(Y),G.push(Y);break}const me=se[se.length-1];if(v.Range.containsRange(me.range,Y.range)&&!v.Range.equalsRange(me.range,Y.range)){me.children?.push(Y),se.push(Y);break}se.pop()}}return G}}class n{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(B,G,se){this._documents=B,this._commands=G,this._provider=se,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,G){const se=this._documents.getDocument(B),oe=await this._provider.provideCodeLenses(se,G);if(!oe||G.isCancellationRequested)return;const Y=this._cache.add(oe),me=new w.DisposableStore;this._disposables.set(Y,me);const ye={cacheId:Y,lenses:[]};for(let xe=0;xe<oe.length;xe++)ye.lenses.push({cacheId:[Y,xe],range:f.Range.from(oe[xe].range),command:this._commands.toInternal(oe[xe].command,me)});return ye}async resolveCodeLens(B,G){const se=B.cacheId&&this._cache.get(...B.cacheId);if(!se)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this._provider.resolveCodeLens(se,G),oe||(oe=se),G.isCancellationRequested)return;const Y=B.cacheId&&this._disposables.get(B.cacheId[0]);if(Y)return B.command=this._commands.toInternal(oe.command??n._badCmd,Y),B}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}function r(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class l{constructor(B,G){this._documents=B,this._provider=G}async provideDefinition(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.provideDefinition(oe,Y,se);return r(me)}}class k{constructor(B,G){this._documents=B,this._provider=G}async provideDeclaration(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.provideDeclaration(oe,Y,se);return r(me)}}class C{constructor(B,G){this._documents=B,this._provider=G}async provideImplementation(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.provideImplementation(oe,Y,se);return r(me)}}class p{constructor(B,G){this._documents=B,this._provider=G}async provideTypeDefinition(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.provideTypeDefinition(oe,Y,se);return r(me)}}class m{constructor(B,G){this._documents=B,this._provider=G}async provideHover(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.provideHover(oe,Y,se);if(!(!me||(0,R.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=oe.getWordRangeAtPosition(Y)),me.range||(me.range=new A.Range(Y,Y)),f.Hover.from(me)}}class b{constructor(B,G){this._documents=B,this._provider=G}async provideEvaluatableExpression(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.provideEvaluatableExpression(oe,Y,se);if(me)return f.EvaluatableExpression.from(me)}}class D{constructor(B,G){this._documents=B,this._provider=G}async provideInlineValues(B,G,se,oe){const Y=this._documents.getDocument(B),me=await this._provider.provideInlineValues(Y,f.Range.to(G),f.InlineValueContext.to(se),oe);if(Array.isArray(me))return me.map(ye=>f.InlineValue.from(ye))}}class M{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentHighlights(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.provideDocumentHighlights(oe,Y,se);if(Array.isArray(me))return me.map(f.DocumentHighlight.from)}}class L{constructor(B,G){this._documents=B,this._provider=G}async provideLinkedEditingRanges(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.provideLinkedEditingRanges(oe,Y,se);if(me&&Array.isArray(me.ranges))return{ranges:(0,R.coalesce)(me.ranges.map(f.Range.from)),wordPattern:me.wordPattern}}}class F{constructor(B,G){this._documents=B,this._provider=G}async provideReferences(B,G,se,oe){const Y=this._documents.getDocument(B),me=f.Position.to(G),ye=await this._provider.provideReferences(Y,me,se,oe);if(Array.isArray(ye))return ye.map(f.location.from)}}class x{static{this._maxCodeActionsPerFile=1e3}constructor(B,G,se,oe,Y,me,ye){this._documents=B,this._commands=G,this._diagnostics=se,this._provider=oe,this._logService=Y,this._extension=me,this._apiDeprecation=ye,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,G,se,oe){const Y=this._documents.getDocument(B),me=E.Selection.isISelection(G)?f.Selection.to(G):f.Range.to(G),ye=[];for(const tt of this._diagnostics.getDiagnostics(B))if(me.intersection(tt.range)&&ye.push(tt)>x._maxCodeActionsPerFile)break;const xe={diagnostics:ye,only:se.only?new A.CodeActionKind(se.only):void 0,triggerKind:f.CodeActionTriggerKind.to(se.trigger)},We=await this._provider.provideCodeActions(Y,me,xe,oe);if(!(0,R.isNonEmptyArray)(We)||oe.isCancellationRequested)return;const Ze=this._cache.add(We),Xe=new w.DisposableStore;this._disposables.set(Ze,Xe);const it=[];for(let tt=0;tt<We.length;tt++){const Te=We[tt];Te&&(x._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,Xe)})):(xe.only&&(Te.kind?xe.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Ze,tt],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,Xe),diagnostics:Te.diagnostics&&Te.diagnostics.map(f.Diagnostic.from),edit:Te.edit&&f.WorkspaceEdit.from(Te.edit,void 0),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?Te.isAI:!1,disabled:Te.disabled?.reason})))}return{cacheId:Ze,actions:it}}async resolveCodeAction(B,G){const[se,oe]=B,Y=this._cache.get(se,oe);if(!Y||x._isCommand(Y))return{};if(!this._provider.resolveCodeAction)return{};const me=await this._provider.resolveCodeAction(Y,G)??Y;let ye;me.edit&&(ye=f.WorkspaceEdit.from(me.edit,void 0));let xe;if(me.command){const We=this._disposables.get(se);We&&(xe=this._commands.toInternal(me.command,We))}return{edit:ye,command:xe}}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}class U{static toInternalProviderId(B,G){return B+"."+G}constructor(B,G,se,oe,Y){this._proxy=B,this._documents=G,this._provider=se,this._handle=oe,this._extension=Y}async prepareDocumentPaste(B,G,se,oe){if(!this._provider.prepareDocumentPaste)return;const Y=this._documents.getDocument(B),me=G.map(We=>f.Range.to(We)),ye=f.DataTransfer.toDataTransfer(se,()=>{throw new h.NotImplementedError});if(await this._provider.prepareDocumentPaste(Y,me,ye,oe),oe.isCancellationRequested)return;const xe=Array.from(ye).filter(([,We])=>!(We instanceof A.InternalDataTransferItem));return f.DataTransfer.from(xe)}async providePasteEdits(B,G,se,oe,Y){if(!this._provider.provideDocumentPasteEdits)return;const me=this._documents.getDocument(G),ye=se.map(Ze=>f.Range.to(Ze)),xe=f.DataTransfer.toDataTransfer(oe,async Ze=>(await this._proxy.$resolvePasteFileData(this._handle,B,Ze)).buffer),We=await this._provider.provideDocumentPasteEdits(me,ye,xe,Y);if(We)return{label:We.label??(0,i.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:U.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class N{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentFormattingEdits(B,G,se){const oe=this._documents.getDocument(B),Y=await this._provider.provideDocumentFormattingEdits(oe,G,se);if(Array.isArray(Y))return Y.map(f.TextEdit.from)}}class z{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentRangeFormattingEdits(B,G,se,oe){const Y=this._documents.getDocument(B),me=f.Range.to(G),ye=await this._provider.provideDocumentRangeFormattingEdits(Y,me,se,oe);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,G,se,oe){(0,P.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this._documents.getDocument(B),me=G.map(f.Range.to),ye=await this._provider.provideDocumentRangesFormattingEdits(Y,me,se,oe);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}}class V{constructor(B,G){this._documents=B,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,G,se,oe,Y){const me=this._documents.getDocument(B),ye=f.Position.to(G),xe=await this._provider.provideOnTypeFormattingEdits(me,ye,se,oe,Y);if(Array.isArray(xe))return xe.map(f.TextEdit.from)}}class ge{constructor(B,G){this._provider=B,this._logService=G,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,G){const se=await this._provider.provideWorkspaceSymbols(B,G);if(!(0,R.isNonEmptyArray)(se))return{symbols:[]};const oe=this._cache.add(se),Y={cacheId:oe,symbols:[]};for(let me=0;me<se.length;me++){const ye=se[me];if(!ye||!ye.name){this._logService.warn("INVALID SymbolInformation",ye);continue}Y.symbols.push({...f.WorkspaceSymbol.from(ye),cacheId:[oe,me]})}return Y}async resolveWorkspaceSymbol(B,G){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const se=this._cache.get(...B.cacheId);if(se){const oe=await this._provider.resolveWorkspaceSymbol(se,G);return oe&&(0,O.mixin)(B,f.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class te{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,G,se){this._documents=B,this._provider=G,this._logService=se}async provideRenameEdits(B,G,se,oe){const Y=this._documents.getDocument(B),me=f.Position.to(G);try{const ye=await this._provider.provideRenameEdits(Y,me,se,oe);return ye?f.WorkspaceEdit.from(ye):void 0}catch(ye){const xe=te._asMessage(ye);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,G,se){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(B),Y=f.Position.to(G);try{const me=await this._provider.prepareRename(oe,Y,se);let ye,xe;if(A.Range.isRange(me)?(ye=me,xe=oe.getText(me)):(0,P.isObject)(me)&&(ye=me.range,xe=me.placeholder),!ye||!xe)return;if(ye.start.line>Y.line||ye.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(ye),text:xe}}catch(me){const ye=te._asMessage(me);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(me)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class q{constructor(B,G){this.resultId=B,this.tokens=G}}class K{constructor(B,G){this._documents=B,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,G,se){const oe=this._documents.getDocument(B),Y=G!==0?this._previousResults.get(G):null;let me=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,Y.resultId,se):await this._provider.provideDocumentSemanticTokens(oe,se);return Y&&this._previousResults.delete(G),me?(me=K._fixProvidedSemanticTokens(me),this._send(K._convertToEdits(Y,me),me)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return K._isSemanticTokens(B)?K._isCorrectSemanticTokens(B)?B:new A.SemanticTokens(new Uint32Array(B.data),B.resultId):K._isSemanticTokensEdits(B)?K._isCorrectSemanticTokensEdits(B)?B:new A.SemanticTokensEdits(B.edits.map(G=>new A.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const G of B.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,G){if(!K._isSemanticTokens(G)||!B||!B.tokens)return G;const se=B.tokens,oe=se.length,Y=G.data,me=Y.length;let ye=0;const xe=Math.min(oe,me);for(;ye<xe&&se[ye]===Y[ye];)ye++;if(ye===oe&&ye===me)return new A.SemanticTokensEdits([],G.resultId);let We=0;const Ze=xe-ye;for(;We<Ze&&se[oe-We-1]===Y[me-We-1];)We++;return new A.SemanticTokensEdits([{start:ye,deleteCount:oe-ye-We,data:Y.subarray(ye,me-We)}],G.resultId)}_send(B,G){if(K._isSemanticTokens(B)){const se=this._nextResultId++;return this._previousResults.set(se,new q(B.resultId,B.data)),(0,d.encodeSemanticTokensDto)({id:se,type:"full",data:B.data})}if(K._isSemanticTokensEdits(B)){const se=this._nextResultId++;return K._isSemanticTokens(G)?this._previousResults.set(se,new q(G.resultId,G.data)):this._previousResults.set(se,new q(B.resultId)),(0,d.encodeSemanticTokensDto)({id:se,type:"delta",deltas:(B.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class ue{constructor(B,G){this._documents=B,this._provider=G}async provideDocumentRangeSemanticTokens(B,G,se){const oe=this._documents.getDocument(B),Y=await this._provider.provideDocumentRangeSemanticTokens(oe,f.Range.to(G),se);return Y?this._send(Y):null}_send(B){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}class ie{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,G,se,oe,Y){this._documents=B,this._commands=G,this._provider=se,this._apiDeprecation=oe,this._extension=Y,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(B,G,se,oe){const Y=this._documents.getDocument(B),me=f.Position.to(G),ye=Y.getWordRangeAtPosition(me)||new A.Range(me,me),xe=ye.with({end:me}),We=new c.StopWatch,Ze=await this._provider.provideCompletionItems(Y,me,oe,f.CompletionContext.to(se));if(!Ze||oe.isCancellationRequested)return;const Xe=Array.isArray(Ze)?new A.CompletionList(Ze):Ze,it=ie.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),tt=new w.DisposableStore;this._disposables.set(it,tt);const Te=[],Me={x:it,b:Te,a:{replace:f.Range.from(ye),insert:f.Range.from(xe)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let ze=0;ze<Xe.items.length;ze++){const Re=Xe.items[ze],Qe=this._convertCompletionItem(Re,[it,ze],xe,ye);Te.push(Qe)}return Me}async resolveCompletionItem(B,G){if(typeof this._provider.resolveCompletionItem!="function")return;const se=this._cache.get(...B);if(!se)return;const oe=this._convertCompletionItem(se,B),Y=await this._provider.resolveCompletionItem(se,G);if(!Y)return;const me=this._convertCompletionItem(Y,B);return(oe.h!==me.h||oe.i!==me.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==me.n||oe.o!==me.o||!(0,O.equals)(oe.p,me.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:me.d,c:me.c,l:me.l,h:me.h,i:me.i,n:me.n,o:me.o,p:me.p}}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,G,se,oe){const Y=this._disposables.get(G[0]);if(!Y)throw Error("DisposableStore is missing...");const me=this._commands.toInternal(B.command,Y),ye={x:G,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:me?.$ident,o:me?.id,p:me?.$ident?void 0:me?.arguments};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof A.SnippetString&&(ye.h=B.insertText.value,ye.i|=4);let xe;return B.textEdit?xe=B.textEdit.range:B.range&&(xe=B.range),A.Range.isRange(xe)?ye.j=f.Range.from(xe):xe&&(!se?.isEqual(xe.inserting)||!oe?.isEqual(xe.replacing))&&(ye.j={insert:f.Range.from(xe.inserting),replace:f.Range.from(xe.replacing)}),ye}}class ce{async provideInlineCompletions(B,G,se,oe){}disposeCompletions(B){}handleDidShowCompletionItem(B,G,se){}handlePartialAccept(B,G,se){}}class Se extends ce{constructor(B,G,se,oe){super(),this._extension=B,this._documents=G,this._provider=se,this._commands=oe,this._references=new j,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,G,se,oe){const Y=this._documents.getDocument(B),me=f.Position.to(G),ye=await this._provider.provideInlineCompletionItems(Y,me,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:f.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[se.triggerKind]},oe);if(!ye||oe.isCancellationRequested)return;const xe=Array.isArray(ye)?ye:ye.items,We=this._isAdditionsProposedApiEnabled?Array.isArray(ye)?[]:ye.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Xe;return{pid:this._references.createReferenceId({dispose(){Xe?.dispose()},items:xe}),items:xe.map((tt,Te)=>{let Me;tt.command&&(Xe||(Xe=new w.DisposableStore),Me=this._commands.toInternal(tt.command,Xe));const ze=tt.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:tt.filterText,range:tt.range?f.Range.from(tt.range):void 0,command:Me,idx:Te,completeBracketPairs:this._isAdditionsProposedApiEnabled?tt.completeBracketPairs:!1}}),commands:We.map(tt=>(Xe||(Xe=new w.DisposableStore),this._commands.toInternal(tt,Xe))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(B){this._references.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,G,se){const oe=this._references.get(B)?.items[G];oe&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(oe,se)}handlePartialAccept(B,G,se){const oe=this._references.get(B)?.items[G];oe&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(oe,se)}}class j{constructor(){this._references=new Map,this._idPool=1}createReferenceId(B){const G=this._idPool++;return this._references.set(G,B),G}disposeReferenceId(B){const G=this._references.get(B);return this._references.delete(B),G}get(B){return this._references.get(B)}}class ${constructor(B,G){this._documents=B,this._provider=G,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(B,G,se,oe){const Y=this._documents.getDocument(B),me=f.Position.to(G),ye=this.reviveContext(se),xe=await this._provider.provideSignatureHelp(Y,me,oe,ye);if(xe){const We=this._cache.add([xe]);return{...f.SignatureHelp.from(xe),id:We}}}reviveContext(B){let G;if(B.activeSignatureHelp){const se=f.SignatureHelp.to(B.activeSignatureHelp),oe=this._cache.get(B.activeSignatureHelp.id,0);oe?(G=oe,G.activeSignature=se.activeSignature,G.activeParameter=se.activeParameter):G=se}return{...B,activeSignatureHelp:G}}releaseSignatureHelp(B){this._cache.delete(B)}}class X{constructor(B,G,se,oe,Y){this._documents=B,this._commands=G,this._provider=se,this._logService=oe,this._extension=Y,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,G,se){const oe=this._documents.getDocument(B),Y=f.Range.to(G),me=await this._provider.provideInlayHints(oe,Y,se);if(!Array.isArray(me)||me.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${G}`);return}if(se.isCancellationRequested)return;const ye=this._cache.add(me);this._disposables.set(ye,new w.DisposableStore);const xe={hints:[],cacheId:ye};for(let We=0;We<me.length;We++)this._isValidInlayHint(me[We],Y)&&xe.hints.push(this._convertInlayHint(me[We],[ye,We]));return this._logService.trace(`[InlayHints] ${xe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${G}`),xe}async resolveInlayHint(B,G){if(typeof this._provider.resolveInlayHint!="function")return;const se=this._cache.get(...B);if(!se)return;const oe=await this._provider.resolveInlayHint(se,G);if(oe&&this._isValidInlayHint(oe))return this._convertInlayHint(oe,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,G){return B.label.length===0||Array.isArray(B.label)&&B.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(G&&!G.contains(B.position))}_convertInlayHint(B,G){const se=this._disposables.get(G[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:G,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?oe.label=B.label:oe.label=B.label.map(Y=>{const me={label:Y.value};return me.tooltip=f.MarkdownString.fromStrict(Y.tooltip),A.Location.isLocation(Y.location)&&(me.location=f.location.from(Y.location)),Y.command&&(me.command=this._commands.toInternal(Y.command,se)),me}),oe}}class re{constructor(B,G){this._documents=B,this._provider=G,this._cache=new u.Cache("DocumentLink")}async provideLinks(B,G){const se=this._documents.getDocument(B),oe=await this._provider.provideDocumentLinks(se,G);if(!(!Array.isArray(oe)||oe.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(re._validateLink).map(f.DocumentLink.from)};{const Y=this._cache.add(oe),me={links:[],cacheId:Y};for(let ye=0;ye<oe.length;ye++){if(!re._validateLink(oe[ye]))continue;const xe=f.DocumentLink.from(oe[ye]);xe.cacheId=[Y,ye],me.links.push(xe)}return me}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,G){if(typeof this._provider.resolveDocumentLink!="function")return;const se=this._cache.get(...B);if(!se)return;const oe=await this._provider.resolveDocumentLink(se,G);if(!(!oe||!re._validateLink(oe)))return f.DocumentLink.from(oe)}releaseLinks(B){this._cache.delete(B)}}class Q{constructor(B,G){this._documents=B,this._provider=G}async provideColors(B,G){const se=this._documents.getDocument(B),oe=await this._provider.provideDocumentColors(se,G);return Array.isArray(oe)?oe.map(me=>({color:f.Color.from(me.color),range:f.Range.from(me.range)})):[]}async provideColorPresentations(B,G,se){const oe=this._documents.getDocument(B),Y=f.Range.to(G.range),me=f.Color.to(G.color),ye=await this._provider.provideColorPresentations(me,{document:oe,range:Y},se);if(Array.isArray(ye))return ye.map(f.ColorPresentation.from)}}class Z{constructor(B,G){this._documents=B,this._provider=G}async provideFoldingRanges(B,G,se){const oe=this._documents.getDocument(B),Y=await this._provider.provideFoldingRanges(oe,G,se);if(Array.isArray(Y))return Y.map(f.FoldingRange.from)}}class J{constructor(B,G,se){this._documents=B,this._provider=G,this._logService=se}async provideSelectionRanges(B,G,se){const oe=this._documents.getDocument(B),Y=G.map(f.Position.to),me=await this._provider.provideSelectionRanges(oe,Y,se);if(!(0,R.isNonEmptyArray)(me))return[];if(me.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let xe=0;xe<Y.length;xe++){const We=[];ye.push(We);let Ze=Y[xe],Xe=me[xe];for(;;){if(!Xe.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Xe)),!Xe.parent)break;Ze=Xe.range,Xe=Xe.parent}}return ye}}class be{constructor(B,G){this._documents=B,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.prepareCallHierarchy(oe,Y,se);if(!me)return;const ye=this._idPool.nextId();return this._cache.set(ye,new Map),Array.isArray(me)?me.map(xe=>this._cacheAndConvertItem(ye,xe)):[this._cacheAndConvertItem(ye,me)]}async provideCallsTo(B,G,se){const oe=this._itemFromCache(B,G);if(!oe)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(oe,se);if(Y)return Y.map(me=>({from:this._cacheAndConvertItem(B,me.from),fromRanges:me.fromRanges.map(ye=>f.Range.from(ye))}))}async provideCallsFrom(B,G,se){const oe=this._itemFromCache(B,G);if(!oe)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(oe,se);if(Y)return Y.map(me=>({to:this._cacheAndConvertItem(B,me.to),fromRanges:me.fromRanges.map(ye=>f.Range.from(ye))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,G){const se=this._cache.get(B),oe=f.CallHierarchyItem.from(G,B,se.size.toString(36));return se.set(oe._itemId,G),oe}_itemFromCache(B,G){return this._cache.get(B)?.get(G)}}class ae{constructor(B,G){this._documents=B,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(B,G,se){const oe=this._documents.getDocument(B),Y=f.Position.to(G),me=await this._provider.prepareTypeHierarchy(oe,Y,se);if(!me)return;const ye=this._idPool.nextId();return this._cache.set(ye,new Map),Array.isArray(me)?me.map(xe=>this._cacheAndConvertItem(ye,xe)):[this._cacheAndConvertItem(ye,me)]}async provideSupertypes(B,G,se){const oe=this._itemFromCache(B,G);if(!oe)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(oe,se);if(Y)return Y.map(me=>this._cacheAndConvertItem(B,me))}async provideSubtypes(B,G,se){const oe=this._itemFromCache(B,G);if(!oe)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(oe,se);if(Y)return Y.map(me=>this._cacheAndConvertItem(B,me))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,G){const se=this._cache.get(B),oe=f.TypeHierarchyItem.from(G,B,se.size.toString(36));return se.set(oe._itemId,G),oe}_itemFromCache(B,G){return this._cache.get(B)?.get(G)}}class fe{static toInternalProviderId(B,G){return B+"."+G}constructor(B,G,se,oe,Y){this._proxy=B,this._documents=G,this._provider=se,this._handle=oe,this._extension=Y}async provideDocumentOnDropEdits(B,G,se,oe,Y){const me=this._documents.getDocument(G),ye=f.Position.to(se),xe=f.DataTransfer.toDataTransfer(oe,async Ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,B,Ze)).buffer),We=await this._provider.provideDocumentDropEdits(me,ye,xe,Y);if(We)return{label:We.label??(0,i.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:fe.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(B,G){this._documents=B,this._provider=G}async provideMappedEdits(B,G,se,oe){const Y=I.URI.revive(B),me=this._documents.getDocument(Y),ye=se.documents.map(Ze=>Ze.map(Xe=>({uri:I.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(it=>f.Range.to(it))}))),xe={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this._provider.provideMappedEdits(me,G,xe,oe);return We?f.WorkspaceEdit.from(We):null}}class he{constructor(B,G){this.adapter=B,this.extension=G}}class ve{static{this._handlePool=0}constructor(B,G,se,oe,Y,me,ye,xe){this._uriTransformer=G,this._documents=se,this._commands=oe,this._diagnostics=Y,this._logService=me,this._apiDeprecation=ye,this._extensionTelemetry=xe,this._adapter=new Map,this._proxy=B.getProxy(g.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(B,G){return f.DocumentSelector.from(B,this._uriTransformer,G)}_createDisposable(B){return new A.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return ve._handlePool++}async _withAdapter(B,G,se,oe,Y,me=!1){const ye=this._adapter.get(B);if(!ye||!(ye.adapter instanceof G))return oe;const xe=Date.now();me||this._logService.trace(`[${ye.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(ye.adapter,ye.extension);return Promise.resolve(We).catch(Ze=>{(0,h.isCancellationError)(Ze)||(this._logService.error(`[${ye.extension.identifier.value}] provider FAILED`),this._logService.error(Ze),this._extensionTelemetry.onExtensionError(ye.extension.identifier,Ze))}).finally(()=>{me||this._logService.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-xe}ms`)}),S.CancellationToken.isCancellationToken(Y)?(0,a.raceCancellationError)(We,Y):We}_addNewAdapter(B,G){const se=this._nextHandle();return this._adapter.set(se,new he(B,G)),se}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,G,se,oe){const Y=this._addNewAdapter(new s(this._documents,se),B),me=oe&&oe.label||ve._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(G,B),me),this._createDisposable(Y)}$provideDocumentSymbols(B,G,se){return this._withAdapter(B,s,oe=>oe.provideDocumentSymbols(I.URI.revive(G),se),void 0,se)}registerCodeLensProvider(B,G,se){const oe=this._nextHandle(),Y=typeof se.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new he(new n(this._documents,this._commands.converter,se),B)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(G,B),Y);let me=this._createDisposable(oe);if(Y!==void 0){const ye=se.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(Y));me=A.Disposable.from(me,ye)}return me}$provideCodeLenses(B,G,se){return this._withAdapter(B,n,oe=>oe.provideCodeLenses(I.URI.revive(G),se),void 0,se)}$resolveCodeLens(B,G,se){return this._withAdapter(B,n,oe=>oe.resolveCodeLens(G,se),void 0,void 0)}$releaseCodeLenses(B,G){this._withAdapter(B,n,se=>Promise.resolve(se.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(B,G,se){const oe=this._addNewAdapter(new l(this._documents,se),B);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideDefinition(B,G,se,oe){return this._withAdapter(B,l,Y=>Y.provideDefinition(I.URI.revive(G),se,oe),[],oe)}registerDeclarationProvider(B,G,se){const oe=this._addNewAdapter(new k(this._documents,se),B);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideDeclaration(B,G,se,oe){return this._withAdapter(B,k,Y=>Y.provideDeclaration(I.URI.revive(G),se,oe),[],oe)}registerImplementationProvider(B,G,se){const oe=this._addNewAdapter(new C(this._documents,se),B);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideImplementation(B,G,se,oe){return this._withAdapter(B,C,Y=>Y.provideImplementation(I.URI.revive(G),se,oe),[],oe)}registerTypeDefinitionProvider(B,G,se){const oe=this._addNewAdapter(new p(this._documents,se),B);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideTypeDefinition(B,G,se,oe){return this._withAdapter(B,p,Y=>Y.provideTypeDefinition(I.URI.revive(G),se,oe),[],oe)}registerHoverProvider(B,G,se,oe){const Y=this._addNewAdapter(new m(this._documents,se),B);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(G,B)),this._createDisposable(Y)}$provideHover(B,G,se,oe){return this._withAdapter(B,m,Y=>Y.provideHover(I.URI.revive(G),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(B,G,se,oe){const Y=this._addNewAdapter(new b(this._documents,se),B);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(G,B)),this._createDisposable(Y)}$provideEvaluatableExpression(B,G,se,oe){return this._withAdapter(B,b,Y=>Y.provideEvaluatableExpression(I.URI.revive(G),se,oe),void 0,oe)}registerInlineValuesProvider(B,G,se,oe){const Y=typeof se.onDidChangeInlineValues=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new D(this._documents,se),B);this._proxy.$registerInlineValuesProvider(me,this._transformDocumentSelector(G,B),Y);let ye=this._createDisposable(me);if(Y!==void 0){const xe=se.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(Y));ye=A.Disposable.from(ye,xe)}return ye}$provideInlineValues(B,G,se,oe,Y){return this._withAdapter(B,D,me=>me.provideInlineValues(I.URI.revive(G),se,oe,Y),void 0,Y)}registerDocumentHighlightProvider(B,G,se){const oe=this._addNewAdapter(new M(this._documents,se),B);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideDocumentHighlights(B,G,se,oe){return this._withAdapter(B,M,Y=>Y.provideDocumentHighlights(I.URI.revive(G),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(B,G,se){const oe=this._addNewAdapter(new L(this._documents,se),B);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideLinkedEditingRanges(B,G,se,oe){return this._withAdapter(B,L,async Y=>{const me=await Y.provideLinkedEditingRanges(I.URI.revive(G),se,oe);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?ve._serializeRegExp(me.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(B,G,se){const oe=this._addNewAdapter(new F(this._documents,se),B);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideReferences(B,G,se,oe,Y){return this._withAdapter(B,F,me=>me.provideReferences(I.URI.revive(G),se,oe,Y),void 0,Y)}registerCodeActionProvider(B,G,se,oe){const Y=new w.DisposableStore,me=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,se,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(G,B),{providedKinds:oe?.providedCodeActionKinds?.map(ye=>ye.value),documentation:oe?.documentation?.map(ye=>({kind:ye.kind.value,command:this._commands.converter.toInternal(ye.command,Y)}))},ve._extLabel(B),!!se.resolveCodeAction),Y.add(this._createDisposable(me)),Y}$provideCodeActions(B,G,se,oe,Y){return this._withAdapter(B,x,me=>me.provideCodeActions(I.URI.revive(G),se,oe,Y),void 0,Y)}$resolveCodeAction(B,G,se){return this._withAdapter(B,x,oe=>oe.resolveCodeAction(G,se),{},void 0)}$releaseCodeActions(B,G){this._withAdapter(B,x,se=>Promise.resolve(se.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(B,G,se){const oe=this._addNewAdapter(new N(this._documents,se),B);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(G,B),B.identifier,B.displayName||B.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(B,G,se,oe){return this._withAdapter(B,N,Y=>Y.provideDocumentFormattingEdits(I.URI.revive(G),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(B,G,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",Y=this._addNewAdapter(new z(this._documents,se),B);return this._proxy.$registerRangeFormattingSupport(Y,this._transformDocumentSelector(G,B),B.identifier,B.displayName||B.name,oe),this._createDisposable(Y)}$provideDocumentRangeFormattingEdits(B,G,se,oe,Y){return this._withAdapter(B,z,me=>me.provideDocumentRangeFormattingEdits(I.URI.revive(G),se,oe,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(B,G,se,oe,Y){return this._withAdapter(B,z,me=>me.provideDocumentRangesFormattingEdits(I.URI.revive(G),se,oe,Y),void 0,Y)}registerOnTypeFormattingEditProvider(B,G,se,oe){const Y=this._addNewAdapter(new V(this._documents,se),B);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(G,B),oe,B.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(B,G,se,oe,Y,me){return this._withAdapter(B,V,ye=>ye.provideOnTypeFormattingEdits(I.URI.revive(G),se,oe,Y,me),void 0,me)}registerWorkspaceSymbolProvider(B,G){const se=this._addNewAdapter(new ge(G,this._logService),B);return this._proxy.$registerNavigateTypeSupport(se,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(se)}$provideWorkspaceSymbols(B,G,se){return this._withAdapter(B,ge,oe=>oe.provideWorkspaceSymbols(G,se),{symbols:[]},se)}$resolveWorkspaceSymbol(B,G,se){return this._withAdapter(B,ge,oe=>oe.resolveWorkspaceSymbol(G,se),void 0,void 0)}$releaseWorkspaceSymbols(B,G){this._withAdapter(B,ge,se=>se.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(B,G,se){const oe=this._addNewAdapter(new te(this._documents,se,this._logService),B);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(G,B),te.supportsResolving(se)),this._createDisposable(oe)}$provideRenameEdits(B,G,se,oe,Y){return this._withAdapter(B,te,me=>me.provideRenameEdits(I.URI.revive(G),se,oe,Y),void 0,Y)}$resolveRenameLocation(B,G,se,oe){return this._withAdapter(B,te,Y=>Y.resolveRenameLocation(I.URI.revive(G),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(B,G,se,oe){const Y=this._addNewAdapter(new K(this._documents,se),B),me=typeof se.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(G,B),oe,me);let ye=this._createDisposable(Y);if(me){const xe=se.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(me));ye=A.Disposable.from(ye,xe)}return ye}$provideDocumentSemanticTokens(B,G,se,oe){return this._withAdapter(B,K,Y=>Y.provideDocumentSemanticTokens(I.URI.revive(G),se,oe),null,oe)}$releaseDocumentSemanticTokens(B,G){this._withAdapter(B,K,se=>se.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,G,se,oe){const Y=this._addNewAdapter(new ue(this._documents,se),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(G,B),oe),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(B,G,se,oe){return this._withAdapter(B,ue,Y=>Y.provideDocumentRangeSemanticTokens(I.URI.revive(G),se,oe),null,oe)}registerCompletionItemProvider(B,G,se,oe){const Y=this._addNewAdapter(new ie(this._documents,this._commands.converter,se,this._apiDeprecation,B),B);return this._proxy.$registerCompletionsProvider(Y,this._transformDocumentSelector(G,B),oe,ie.supportsResolving(se),B.identifier),this._createDisposable(Y)}$provideCompletionItems(B,G,se,oe,Y){return this._withAdapter(B,ie,me=>me.provideCompletionItems(I.URI.revive(G),se,oe,Y),void 0,Y)}$resolveCompletionItem(B,G,se){return this._withAdapter(B,ie,oe=>oe.resolveCompletionItem(G,se),void 0,se)}$releaseCompletionItems(B,G){this._withAdapter(B,ie,se=>se.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(B,G,se,oe){const Y=new Se(B,this._documents,se,this._commands.converter),me=this._addNewAdapter(Y,B);return this._proxy.$registerInlineCompletionsSupport(me,this._transformDocumentSelector(G,B),Y.supportsHandleEvents,_.ExtensionIdentifier.toKey(B.identifier.value),oe?.yieldTo?.map(ye=>_.ExtensionIdentifier.toKey(ye))||[]),this._createDisposable(me)}$provideInlineCompletions(B,G,se,oe,Y){return this._withAdapter(B,ce,me=>me.provideInlineCompletions(I.URI.revive(G),se,oe,Y),void 0,Y)}$handleInlineCompletionDidShow(B,G,se,oe){this._withAdapter(B,ce,async Y=>{Y.handleDidShowCompletionItem(G,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,G,se,oe){this._withAdapter(B,ce,async Y=>{Y.handlePartialAccept(G,se,oe)},void 0,void 0)}$freeInlineCompletionsList(B,G){this._withAdapter(B,ce,async se=>{se.disposeCompletions(G)},void 0,void 0)}registerSignatureHelpProvider(B,G,se,oe){const Y=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,me=this._addNewAdapter(new $(this._documents,se),B);return this._proxy.$registerSignatureHelpProvider(me,this._transformDocumentSelector(G,B),Y),this._createDisposable(me)}$provideSignatureHelp(B,G,se,oe,Y){return this._withAdapter(B,$,me=>me.provideSignatureHelp(I.URI.revive(G),se,oe,Y),void 0,Y)}$releaseSignatureHelp(B,G){this._withAdapter(B,$,se=>se.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(B,G,se){const oe=typeof se.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new X(this._documents,this._commands.converter,se,this._logService,B),B);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(G,B),typeof se.resolveInlayHint=="function",oe,ve._extLabel(B));let me=this._createDisposable(Y);if(oe!==void 0){const ye=se.onDidChangeInlayHints(xe=>this._proxy.$emitInlayHintsEvent(oe));me=A.Disposable.from(me,ye)}return me}$provideInlayHints(B,G,se,oe){return this._withAdapter(B,X,Y=>Y.provideInlayHints(I.URI.revive(G),se,oe),void 0,oe)}$resolveInlayHint(B,G,se){return this._withAdapter(B,X,oe=>oe.resolveInlayHint(G,se),void 0,se)}$releaseInlayHints(B,G){this._withAdapter(B,X,se=>se.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(B,G,se){const oe=this._addNewAdapter(new re(this._documents,se),B);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(G,B),typeof se.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(B,G,se){return this._withAdapter(B,re,oe=>oe.provideLinks(I.URI.revive(G),se),void 0,se,G.scheme==="output")}$resolveDocumentLink(B,G,se){return this._withAdapter(B,re,oe=>oe.resolveLink(G,se),void 0,void 0,!0)}$releaseDocumentLinks(B,G){this._withAdapter(B,re,se=>se.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(B,G,se){const oe=this._addNewAdapter(new Q(this._documents,se),B);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideDocumentColors(B,G,se){return this._withAdapter(B,Q,oe=>oe.provideColors(I.URI.revive(G),se),[],se)}$provideColorPresentations(B,G,se,oe){return this._withAdapter(B,Q,Y=>Y.provideColorPresentations(I.URI.revive(G),se,oe),void 0,oe)}registerFoldingRangeProvider(B,G,se){const oe=this._nextHandle(),Y=typeof se.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new he(new Z(this._documents,se),B)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(G,B),B.identifier,Y);let me=this._createDisposable(oe);if(Y!==void 0){const ye=se.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));me=A.Disposable.from(me,ye)}return me}$provideFoldingRanges(B,G,se,oe){return this._withAdapter(B,Z,Y=>Y.provideFoldingRanges(I.URI.revive(G),se,oe),void 0,oe)}registerSelectionRangeProvider(B,G,se){const oe=this._addNewAdapter(new J(this._documents,se,this._logService),B);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideSelectionRanges(B,G,se,oe){return this._withAdapter(B,J,Y=>Y.provideSelectionRanges(I.URI.revive(G),se,oe),[],oe)}registerCallHierarchyProvider(B,G,se){const oe=this._addNewAdapter(new be(this._documents,se),B);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$prepareCallHierarchy(B,G,se,oe){return this._withAdapter(B,be,Y=>Promise.resolve(Y.prepareSession(I.URI.revive(G),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(B,G,se,oe){return this._withAdapter(B,be,Y=>Y.provideCallsTo(G,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(B,G,se,oe){return this._withAdapter(B,be,Y=>Y.provideCallsFrom(G,se,oe),void 0,oe)}$releaseCallHierarchy(B,G){this._withAdapter(B,be,se=>Promise.resolve(se.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(B,G,se){const oe=this._addNewAdapter(new ae(this._documents,se),B);return this._proxy.$registerTypeHierarchyProvider(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$prepareTypeHierarchy(B,G,se,oe){return this._withAdapter(B,ae,Y=>Promise.resolve(Y.prepareSession(I.URI.revive(G),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(B,G,se,oe){return this._withAdapter(B,ae,Y=>Y.provideSupertypes(G,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(B,G,se,oe){return this._withAdapter(B,ae,Y=>Y.provideSubtypes(G,se,oe),void 0,oe)}$releaseTypeHierarchy(B,G){this._withAdapter(B,ae,se=>Promise.resolve(se.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(B,G,se,oe){const Y=this._nextHandle();this._adapter.set(Y,new he(new fe(this._proxy,this._documents,se,Y,B),B));const me=(0,t.isProposedApiEnabled)(B,"dropMetadata")&&oe?fe.toInternalProviderId(B.identifier.value,oe.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(Y,this._transformDocumentSelector(G,B),me,(0,t.isProposedApiEnabled)(B,"dropMetadata")?oe:void 0),this._createDisposable(Y)}$provideDocumentOnDropEdits(B,G,se,oe,Y,me){return this._withAdapter(B,fe,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(G,I.URI.revive(se),oe,Y,me)),void 0,void 0)}registerMappedEditsProvider(B,G,se){const oe=this._addNewAdapter(new ee(this._documents,se),B);return this._proxy.$registerMappedEditsProvider(oe,this._transformDocumentSelector(G,B)),this._createDisposable(oe)}$provideMappedEdits(B,G,se,oe,Y){return this._withAdapter(B,ee,me=>Promise.resolve(me.provideMappedEdits(G,se,oe,Y)),null,Y)}registerDocumentPasteEditProvider(B,G,se,oe){const Y=this._nextHandle();this._adapter.set(Y,new he(new U(this._proxy,this._documents,se,Y,B),B));const me=U.toInternalProviderId(B.identifier.value,oe.id);return this._proxy.$registerPasteEditProvider(Y,this._transformDocumentSelector(G,B),me,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this._createDisposable(Y)}$prepareDocumentPaste(B,G,se,oe,Y){return this._withAdapter(B,U,me=>me.prepareDocumentPaste(I.URI.revive(G),se,oe,Y),void 0,Y)}$providePasteEdits(B,G,se,oe,Y,me){return this._withAdapter(B,U,ye=>ye.providePasteEdits(G,I.URI.revive(se),oe,Y,me),void 0,me)}static _serializeRegExp(B){return{pattern:B.source,flags:B.flags}}static _serializeIndentationRule(B){return{decreaseIndentPattern:ve._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:ve._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ve._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ve._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:ve._serializeRegExp(B.beforeText),afterText:B.afterText?ve._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?ve._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(ve._serializeOnEnterRule)}static _serializeAutoClosingPair(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(G=>A.SyntaxTokenType.toString(G)):void 0}}static _serializeAutoClosingPairs(B){return B.map(ve._serializeAutoClosingPair)}setLanguageConfiguration(B,G,se){const{wordPattern:oe}=se;if(oe&&(0,y.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(G,oe):this._documents.setWordDefinitionFor(G,void 0),se.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),se.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const Y=this._nextHandle(),me={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?ve._serializeRegExp(se.wordPattern):void 0,indentationRules:se.indentationRules?ve._serializeIndentationRule(se.indentationRules):void 0,onEnterRules:se.onEnterRules?ve._serializeOnEnterRules(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?ve._serializeAutoClosingPairs(se.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(Y,G,me),this._createDisposable(Y)}$setWordDefinitions(B){for(const G of B)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=ve}),define(De[319],Ie([1,0,6,13,7,38,8,3,26]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class v{constructor(P,E,S,_){this._documents=E,this._commands=S,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=P.getProxy(I.MainContext.MainThreadLanguages)}$acceptLanguageIds(P){this._languageIds=P}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(P,E){await this._proxy.$changeLanguage(P,E);const S=this._documents.getDocumentData(P);if(!S)throw new Error(`document '${P.toString()}' NOT found`);return S.document}async tokenAtPosition(P,E){const S=P.version,_=O.Position.from(E),w=await this._proxy.$tokensAtPosition(P.uri,_),d={type:f.StandardTokenType.Other,range:P.getWordRangeAtPosition(E)??new f.Range(E.line,E.character,E.line,E.character)};if(!w)return d;const o={range:O.Range.to(w.range),type:O.TokenType.to(w.type)};return!o.range.contains(E)||S!==P.version?d:o}createLanguageStatusItem(P,E,S){const _=this._handlePool++,w=this._proxy,d=this._ids,o=`${P.identifier.value}/${E}`;if(d.has(o))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);d.add(o);const u={selector:S,id:E,name:P.displayName??P.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const h=new g.DisposableStore,a=()=>{if(c?.dispose(),!d.has(o)){console.warn(`LanguageStatusItem (${E}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,T.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(_,{id:o,name:u.name??P.displayName??P.name,source:P.displayName??P.name,selector:O.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===f.LanguageStatusSeverity.Error?A.default.Error:u.severity===f.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:u.command&&this._commands.toInternal(u.command,h),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},t={dispose(){h.dispose(),c?.dispose(),w.$removeLanguageStatus(_),d.delete(o)},get id(){return u.id},get name(){return u.name},set name(i){u.name=i,a()},get selector(){return u.selector},set selector(i){u.selector=i,a()},get text(){return u.text},set text(i){u.text=i,a()},set text2(i){(0,y.checkProposedApiEnabled)(P,"languageStatusText"),u.text=i,a()},get text2(){return(0,y.checkProposedApiEnabled)(P,"languageStatusText"),u.text},get detail(){return u.detail},set detail(i){u.detail=i,a()},get severity(){return u.severity},set severity(i){u.severity=i,a()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(i){u.accessibilityInformation=i,a()},get command(){return u.command},set command(i){u.command=i,a()},get busy(){return u.busy},set busy(i){u.busy=i,a()}};return a(),t}}e.ExtHostLanguages=v}),define(De[112],Ie([1,0,12,15,2,5,14,6,27,20]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(E,S,_){this.logService=_,this.bundleCache=new Map,this._proxy=S.getProxy(g.MainContext.MainThreadLocalization),this.currentLanguage=E.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===I.LANGUAGE_DEFAULT}getMessage(E,S){const{message:_,args:w,comment:d}=S;if(this.isDefaultLanguage)return(0,O.format2)(_,w??{});let o=_;d&&d.length>0&&(o+=`/${Array.isArray(d)?d.join(""):d}`);const u=this.bundleCache.get(E)?.contents[o];return u||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.format2)(u??_,w??{})}getBundle(E){return this.bundleCache.get(E)?.contents}getBundleUri(E){return this.bundleCache.get(E)?.uri}async initializeLocalizedMessages(E){if(this.isDefaultLanguage||!E.l10n&&!E.isBuiltin||this.bundleCache.has(E.identifier.value))return;let S;const _=await this.getBundleLocation(E);if(!_){this.logService.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const w=await this._proxy.$fetchBundleContents(_),d=JSON.parse(w);S=E.isBuiltin?d.contents?.bundle:d}catch(w){this.logService.error(`Failed to load translations for ${E.identifier.value} from ${_}: ${w.message}`);return}S&&this.bundleCache.set(E.identifier.value,{contents:S,uri:_})}async getBundleLocation(E){if(E.isBuiltin){const S=await this._proxy.$fetchBuiltInBundleUri(E.identifier.value,this.currentLanguage);return f.URI.revive(S)}return E.l10n?f.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=R,e.ExtHostLocalizationService=R=je([$e(0,y.IExtHostInitDataService),$e(1,v.IExtHostRpcService),$e(2,T.ILogService)],R),e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(De[150],Ie([1,0,14,6,27,20,2,62]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends I.AbstractLoggerService{constructor(P,E){super(E.logLevel,E.logsLocation,E.loggers.map(S=>(0,g.revive)(S))),this._proxy=P.getProxy(O.MainContext.MainThreadLogger)}$setLogLevel(P,E){E?this.setLogLevel(T.URI.revive(E),P):this.setLogLevel(P)}setVisibility(P,E){super.setVisibility(P,E),this._proxy.$setVisibility(P,E)}doCreateLogger(P,E,S){return new v(this._proxy,P,E,S)}};e.ExtHostLoggerService=y,e.ExtHostLoggerService=y=je([$e(0,A.IExtHostRpcService),$e(1,f.IExtHostInitDataService)],y);class v extends I.AbstractMessageLogger{constructor(P,E,S,_){super(_?.logLevel==="always"),this.proxy=P,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(E,_).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(P,E){const S=[[P,E]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(P){this.proxy.$log(this.file,P)}flush(){this.proxy.$flush(this.file)}}}),define(De[113],Ie([1,0,6,5,3,20,22]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,O.createDecorator)("IExtHostManagedSockets");let g=class{constructor(P){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=P.getProxy(I.MainContext.MainThreadManagedSockets)}setFactory(P,E){for(const S of this._managedRemoteSockets.values())S.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(P,E),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(P){if(!this._factory||this._factory.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const E=++this._remoteSocketIdCounter,S=await this._factory.makeConnection(),_=new f.DisposableStore;return this._managedRemoteSockets.set(E,new v(E,S,_)),_.add((0,f.toDisposable)(()=>this._managedRemoteSockets.delete(E))),_.add(S.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(E),_.dispose()})),_.add(S.onDidClose(w=>{this._proxy.$onDidManagedSocketClose(E,w?.stack??w?.message),_.dispose()})),_.add(S.onDidReceiveMessage(w=>this._proxy.$onDidManagedSocketHaveData(E,T.VSBuffer.wrap(w)))),E}$remoteSocketWrite(P,E){this._managedRemoteSockets.get(P)?.actual.send(E.buffer)}$remoteSocketEnd(P){const E=this._managedRemoteSockets.get(P);E&&(E.actual.end(),E.dispose())}async $remoteSocketDrain(P){await this._managedRemoteSockets.get(P)?.actual.drain?.()}};e.ExtHostManagedSockets=g,e.ExtHostManagedSockets=g=je([$e(0,A.IExtHostRpcService)],g);class y{constructor(P,E){this.socketFactoryId=P,this.makeConnection=E}}class v extends f.Disposable{constructor(P,E,S){super(),this.socketId=P,this.actual=E,this._register(S)}}}),define(De[320],Ie([1,0,6,14,26]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(g){return g&&g.title}let T=class{constructor(y,v){this._logService=v,this._proxy=y.getProxy(I.MainContext.MainThreadMessageService)}showMessage(y,v,R,P,E){const S={source:{identifier:y.identifier,label:y.displayName||y.name}};let _;typeof P=="string"||A(P)?_=[P,...E]:(S.modal=P?.modal,S.useCustom=P?.useCustom,S.detail=P?.detail,_=E),S.useCustom&&(0,f.checkProposedApiEnabled)(y,"resolvers");const w=[];for(let d=0;d<_.length;d++){const o=_[d];if(typeof o=="string")w.push({title:o,handle:d,isCloseAffordance:!1});else if(typeof o=="object"){const{title:u,isCloseAffordance:c}=o;w.push({title:u,isCloseAffordance:!!c,handle:d})}else this._logService.warn("Invalid message item:",o)}return this._proxy.$showMessage(v,R,S,w).then(d=>{if(typeof d=="number")return _[d]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=je([$e(1,O.ILogService)],T)}),define(De[321],Ie([1,0,208,22,4,3,28,15,17,2,30,107,6,34,13,7,69,285,146,9,24,18]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class t{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}constructor(s,n,r,l,k){this._textDocumentsAndEditors=r,this._textDocuments=l,this._extHostFileSystem=k,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new f.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new f.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new f.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new f.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=s.getProxy(E.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(E.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(E.MainContext.MainThreadNotebookEditors),this._commandsConverter=n.converter,n.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const p=C.notebookEditor?.notebookUri,m=C.cell.handle,D=this._documents.get(p)?.getCell(m);if(D)return D.apiCell}if(C&&C.$mid===14){const p=C.uri,m=this._documents.get(p);if(m)return m.apiNotebook}return C}}),t._registerApiCommands(n)}getEditorById(s){const n=this._editors.get(s);if(!n)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return n}getIdByEditor(s){for(const[n,r]of this._editors)if(r.apiEditor===s)return n}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,n){const r=this._documents.get(s);if(!r&&!n)throw new Error(`NO notebook document for '${s}'`);return r}static _convertNotebookRegistrationData(s,n){if(!n)return;const r=n.filenamePattern.map(l=>_.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(n.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:n.displayName,filenamePattern:r,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,n,r){const l=t._notebookStatusBarItemProviderHandlePool++,k=typeof r.onDidChangeCellStatusBarItems=="function"?t._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,k,n);let C;return k!==void 0&&(C=r.onDidChangeCellStatusBarItems(p=>this._notebookProxy.$emitCellStatusBarEvent(k))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,k),C?.dispose()})}async createNotebookDocument(s){const n=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&_.NotebookData.from(s.content)});return v.URI.revive(n)}async openNotebookDocument(s){const n=this._documents.get(s);if(n)return n.apiNotebook;const r=await this._notebookDocumentsProxy.$tryOpenNotebook(s),l=this._documents.get(v.URI.revive(r));return(0,y.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(s,n){v.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let r;typeof n=="object"?r={position:_.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(_.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:r={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,r),k=l&&this._editors.get(l)?.apiEditor;if(k)return k;throw l?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,n,r,l){const k=this._notebookStatusBarItemProviders.get(s),C=v.URI.revive(n),p=this._documents.get(C);if(!p||!k)return;const m=p.getCellFromIndex(r);if(!m)return;const b=await k.provideCellStatusBarItems(m.apiCell,l);if(!b)return;const D=new A.DisposableStore,M=this._statusBarCache.add([D]),F=(Array.isArray(b)?b:[b]).map(x=>_.NotebookStatusBarItem.from(x,this._commandsConverter,D));return{cacheId:M,items:F}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,n,r,l,k){if((0,g.isFalsyOrWhitespace)(n))throw new Error("viewType cannot be empty or just whitespace");const C=this._handlePool++;return this._notebookSerializer.set(C,{viewType:n,serializer:r,options:l}),this._notebookProxy.$registerNotebookSerializer(C,{id:s.identifier,location:s.extensionLocation},n,_.NotebookDocumentContentOptions.from(l),t._convertNotebookRegistrationData(s,k)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(C)})}async $dataToNotebook(s,n,r){const l=this._notebookSerializer.get(s);if(!l)throw new Error("NO serializer found");const k=await l.serializer.deserializeNotebook(n.buffer,r);return new d.SerializableObjectWithBuffers(_.NotebookData.from(k))}async $notebookToData(s,n,r){const l=this._notebookSerializer.get(s);if(!l)throw new Error("NO serializer found");const k=await l.serializer.serializeNotebook(_.NotebookData.to(n.value),r);return O.VSBuffer.wrap(k)}async $saveNotebook(s,n,r,l,k){const C=v.URI.revive(n),p=this._notebookSerializer.get(s);if(!p)throw new Error("NO serializer found");const m=this._documents.get(C);if(!m)throw new Error("Document NOT found");if(m.versionId!==r)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(C.scheme))throw new R.FileOperationError((0,I.localize)(0,null,this._resourceForError(C)),6);await this._validateWriteFile(C,l);const b={metadata:(0,h.filter)(m.apiNotebook.metadata,x=>!(p.options?.transientDocumentMetadata??{})[x]),cells:[]};for(const x of m.apiNotebook.getCells()){const U=new w.NotebookCellData(x.kind,x.document.getText(),x.document.languageId,x.mime,p.options?.transientOutputs?[]:[...x.outputs],x.metadata,x.executionSummary);U.metadata=(0,h.filter)(x.metadata,N=>!(p.options?.transientCellMetadata??{})[N]),b.cells.push(U)}const D=await p.serializer.serializeNotebook(b,k);await this._extHostFileSystem.value.writeFile(C,D);const M=this._extHostFileSystem.getFileSystemProviderExtUri(C.scheme),L=await this._extHostFileSystem.value.stat(C);return{name:M.basename(C),isFile:(L.type&R.FileType.File)!==0,isDirectory:(L.type&R.FileType.Directory)!==0,isSymbolicLink:(L.type&R.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&R.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(C.scheme),locked:!!((L.permissions??0)&R.FilePermission.Locked),etag:R.etag({mtime:L.mtime,size:L.size}),children:void 0}}async _validateWriteFile(s,n){const r=await this._extHostFileSystem.value.stat(s);if(typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==R.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==R.etag({mtime:n.mtime,size:r.size}))throw new R.FileOperationError((0,I.localize)(1,null),3,n)}_resourceForError(s){return s.scheme===a.Schemas.file?s.fsPath:s.toString()}_createExtHostEditor(s,n,r){if(this._editors.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const l=new u.ExtHostNotebookEditor(n,this._notebookEditorsProxy,s,r.visibleRanges.map(_.NotebookRange.to),r.selections.map(_.NotebookRange.to),typeof r.viewColumn=="number"?_.ViewColumn.to(r.viewColumn):void 0);this._editors.set(n,l)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const r of s.value.removedDocuments){const l=v.URI.revive(r),k=this._documents.get(l);k&&(k.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:k.apiNotebook.getCells().map(C=>C.document.uri)}),this._onDidCloseNotebookDocument.fire(k.apiNotebook));for(const C of this._editors.values())C.notebookData.uri.toString()===l.toString()&&this._editors.delete(C.id)}if(s.value.addedDocuments){const r=[];for(const l of s.value.addedDocuments){const k=v.URI.revive(l.uri);if(this._documents.has(k))throw new Error(`adding EXISTING notebook ${k} `);const C=new o.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,k,l);r.push(...l.cells.map(p=>o.ExtHostCell.asModelAddData(C.apiNotebook,p))),this._documents.get(k)?.dispose(),this._documents.set(k,C),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this._onDidOpenNotebookDocument.fire(C.apiNotebook)}}if(s.value.addedEditors)for(const r of s.value.addedEditors){if(this._editors.has(r.id))return;const l=v.URI.revive(r.documentUri),k=this._documents.get(l);k&&this._createExtHostEditor(k,r.id,r)}const n=[];if(s.value.removedEditors)for(const r of s.value.removedEditors){const l=this._editors.get(r);l&&(this._editors.delete(r),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),n.push(l))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const r=new Set;this._visibleNotebookEditors.forEach(l=>r.add(l.id));for(const l of this._editors.values()){const k=r.has(l.id);l._acceptVisibility(k)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._editors.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(s){const n=S.ApiCommandArgument.String.with("notebookType","A notebook type"),r=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new S.ApiCommandArgument("data","Bytes to convert to data",k=>k instanceof Uint8Array,k=>O.VSBuffer.wrap(k))],new S.ApiCommandResult("Notebook Data",k=>_.NotebookData.to(k.value))),l=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",k=>!0,k=>new d.SerializableObjectWithBuffers(_.NotebookData.from(k)))],new S.ApiCommandResult("Bytes",k=>k.buffer));s.registerApiCommand(r),s.registerApiCommand(l)}}e.ExtHostNotebookController=t}),define(De[322],Ie([1,0,19,8,21,4,3,28,2,25,14,6,34,13,7,110,277,26,69]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let c=class{constructor(l,k,C,p,m){this._initData=k,this._extHostNotebook=C,this._commands=p,this._logService=m,this._activeExecutions=new g.ResourceMap,this._activeNotebookExecutions=new g.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=l.getProxy(P.MainContext.MainThreadNotebookKernels);const b=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",D=>!0,D=>{if(D&&"notebookEditor"in D&&"id"in D){const M=this._extHostNotebook.getIdByEditor(D.notebookEditor);return{id:D.id,extension:D.extension,notebookEditorId:M}}else if(D&&"notebookEditor"in D){const M=this._extHostNotebook.getIdByEditor(D.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${D.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return D})],E.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(l,k,C,p,m,b){for(const ue of this._kernelData.values())if(ue.controller.id===k&&v.ExtensionIdentifier.equals(l.identifier,ue.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const D=this._handlePool++,M=this;this._logService.trace(`NotebookController[${D}], CREATED by ${l.identifier.value}, ${k}`);const L=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${l.identifier}'`);let F=!1;const x=new A.Emitter,U=new A.Emitter,N={id:n(l.identifier,k),notebookType:C,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:p||l.identifier.value,preloads:b?b.map(S.NotebookRendererScript.from):[]};let z=m??L,V;this._proxy.$addKernel(D,N).catch(ue=>{console.log(ue),F=!0});let ge=0;const te=()=>{if(F)return;const ue=++ge;Promise.resolve().then(()=>{ue===ge&&this._proxy.$updateKernel(D,N)})},q=new g.ResourceMap,K={get id(){return k},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return N.label},set label(ue){N.label=ue??l.displayName??l.name,te()},get detail(){return N.detail??""},set detail(ue){N.detail=ue,te()},get description(){return N.description??""},set description(ue){N.description=ue,te()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(ue){N.supportedLanguages=ue,te()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){N.supportsExecutionOrder=ue,te()},get rendererScripts(){return N.preloads?N.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ue){z=ue??L},get interruptHandler(){return V},set interruptHandler(ue){V=ue,N.supportsInterrupt=!!ue,te()},createNotebookCellExecution(ue){if(F)throw new Error("notebook controller is DISPOSED");if(!q.has(ue.notebook.uri))throw M._logService.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return M._createNotebookCellExecution(ue,n(l.identifier,this.id))},createNotebookExecution(ue){if((0,o.checkProposedApiEnabled)(l,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!q.has(ue.uri))throw M._logService.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.uri.toString()}`);return M._createNotebookExecution(ue,n(l.identifier,this.id))},dispose:()=>{F||(this._logService.trace(`NotebookController[${D}], DISPOSED`),F=!0,this._kernelData.delete(D),x.dispose(),U.dispose(),this._proxy.$removeKernel(D))},updateNotebookAffinity(ue,ie){ie===_.NotebookControllerAffinity2.Hidden&&(0,o.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),M._proxy.$updateNotebookPriority(D,ue.uri,ie)},onDidReceiveMessage:U.event,postMessage(ue,ie){return(0,o.checkProposedApiEnabled)(l,"notebookMessaging"),M._proxy.$postMessage(D,ie&&M._extHostNotebook.getIdByEditor(ie),ue)},asWebviewUri(ue){return(0,o.checkProposedApiEnabled)(l,"notebookMessaging"),(0,w.asWebviewUri)(ue,M._initData.remote)}};return this._kernelData.set(D,{extensionId:l.identifier,controller:K,onDidReceiveMessage:U,onDidChangeSelection:x,associatedNotebooks:q}),K}getIdByController(l){for(const[k,C]of this._kernelData)if(C.controller===l)return n(C.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,k){const C=this._kernelDetectionTaskHandlePool++,p=this;this._logService.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${l.identifier.value}`),this._proxy.$addKernelDetectionTask(C,k);const m={dispose:()=>{this._kernelDetectionTask.delete(C),p._proxy.$removeKernelDetectionTask(C)}};return this._kernelDetectionTask.set(C,m),m}registerKernelSourceActionProvider(l,k,C){const p=this._kernelSourceActionProviderHandlePool++,m=typeof C.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,b=this;this._kernelSourceActionProviders.set(p,C),this._logService.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${l.identifier.value}`),this._proxy.$addKernelSourceActionProvider(p,p,k);let D;return m!==void 0&&(D=C.onDidChangeNotebookKernelSourceActions(M=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this._kernelSourceActionProviders.delete(p),b._proxy.$removeKernelSourceActionProvider(p,p),D?.dispose()}}}async $provideKernelSourceActions(l,k){const C=this._kernelSourceActionProviders.get(l);if(C){const p=new T.DisposableStore;return(await C.provideNotebookKernelSourceActions(k)??[]).map(b=>S.NotebookKernelSourceAction.from(b,this._commands.converter,p))}return[]}$acceptNotebookAssociation(l,k,C){const p=this._kernelData.get(l);if(p){const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(k));C?p.associatedNotebooks.set(m.uri,!0):p.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,m.uri.toString(),C),p.onDidChangeSelection.fire({selected:C,notebook:m.apiNotebook})}}async $executeCells(l,k,C){const p=this._kernelData.get(l);if(!p)return;const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(k)),b=[];for(const D of C){const M=m.getCell(D);M&&b.push(M.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,m.uri.toString(),b.length),await p.controller.executeHandler.call(p.controller,b,m.apiNotebook,p.controller)}catch(D){this._logService.error(`NotebookController[${l}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(l,k,C){const p=this._kernelData.get(l);if(!p)return;const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(k));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,m.apiNotebook);else for(const b of C){const D=m.getCell(b);D&&this._activeExecutions.get(D.uri)?.cancel()}if(p.controller.interruptHandler){const b=this._activeNotebookExecutions.get(m.uri);C.length&&Array.isArray(b)&&b.length&&b.forEach(D=>D.dispose())}}$acceptKernelMessageFromRenderer(l,k,C){const p=this._kernelData.get(l);if(!p)return;const m=this._extHostNotebook.getEditorById(k);p.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:C}))}$cellExecutionChanged(l,k,C){const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(l)).getCell(k);if(m){const b=C?S.NotebookCellExecutionState.to(C):_.NotebookCellExecutionState.Idle;b!==void 0&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:b})}}_createNotebookCellExecution(l,k){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!p)throw new Error("invalid cell");if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const m=new a(k,p,this._proxy);this._activeExecutions.set(p.uri,m);const b=m.onDidChangeState(()=>{m.state===h.Resolved&&(m.dispose(),b.dispose(),this._activeExecutions.delete(p.uri))});return m.asApiObject()}_createNotebookExecution(l,k){const C=this._extHostNotebook.getNotebookDocument(l.uri),p=l.getCells().find(D=>{const M=C.getCellFromApiCell(D);return M&&this._activeExecutions.has(M.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this._activeNotebookExecutions.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const m=new i(k,C,this._proxy),b=m.onDidChangeState(()=>{m.state===t.Resolved&&(m.dispose(),b.dispose(),this._activeNotebookExecutions.delete(C.uri))});return this._activeNotebookExecutions.set(C.uri,[m,b]),m.asApiObject()}};e.ExtHostNotebookKernels=c,e.ExtHostNotebookKernels=c=je([$e(4,R.ILogService)],c);var h;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(h||(h={}));class a extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(l,k,C){super(),this._cell=k,this._proxy=C,this._handle=a.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new f.CancellationTokenSource),this._collector=new s(10,p=>this.update(p)),this._executionOrder=k.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,l,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const k=Array.isArray(l)?l:[l];return this._proxy.$updateExecution(this._handle,new u.SerializableObjectWithBuffers(k))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let k=this._cell;if(l&&(k=this._cell.notebook.getCellFromApiCell(l)),!k)throw new Error("INVALID cell");return k.handle}validateAndConvertOutputs(l){return l.map(k=>{const C=_.NotebookCellOutput.ensureUniqueMimeTypes(k.items,!0);return C===k.items?S.NotebookCellOutput.from(k):S.NotebookCellOutput.from({items:C,id:k.id,metadata:k.metadata})})}async updateOutputs(l,k,C){const p=this.cellIndexToHandle(k),m=this.validateAndConvertOutputs((0,I.asArray)(l));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,cellHandle:p,append:C,outputs:m})}async updateOutputItems(l,k,C){return l=_.NotebookCellOutput.ensureUniqueMimeTypes((0,I.asArray)(l),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:l.map(S.NotebookCellOutputItem.from),outputId:k.id,append:C})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(C){l._executionOrder=C,l.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:l._executionOrder}])},start(C){if(l._state===h.Resolved||l._state===h.Started)throw new Error("Cannot call start again");l._state=h.Started,l._onDidChangeState.fire(),l.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,p){if(l._state===h.Resolved)throw new Error("Cannot call resolve twice");l._state=h.Resolved,l._onDidChangeState.fire(),l._collector.flush(),l._proxy.$completeExecution(l._handle,new u.SerializableObjectWithBuffers({runEndTime:p,lastRunSuccess:C}))},clearOutput(C){return l.verifyStateForOutput(),l.updateOutputs([],C,!1)},appendOutput(C,p){return l.verifyStateForOutput(),l.updateOutputs(C,p,!0)},replaceOutput(C,p){return l.verifyStateForOutput(),l.updateOutputs(C,p,!1)},appendOutputItems(C,p){return l.verifyStateForOutput(),l.updateOutputItems(C,p,!0)},replaceOutputItems(C,p){return l.verifyStateForOutput(),l.updateOutputItems(C,p,!1)}})}}var t;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(t||(t={}));class i extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(l,k,C){super(),this._notebook=k,this._proxy=C,this._handle=i.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new f.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,l,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===t.Resolved||this._state===t.Started)throw new Error("Cannot call start again");this._state=t.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===t.Resolved)throw new Error("Cannot call resolve twice");this._state=t.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class s{constructor(l,k){this.delay=l,this.callback=k,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new O.DeferredPromise,this.startedTimer=Date.now(),(0,O.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const k=this.batch;return this.batch=[],this.callback(k).finally(()=>l.complete())}}function n(r,l){return`${r.value}/${l}`}e.createKernelId=n}),define(De[323],Ie([1,0,4,6,146]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(g,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=g.getProxy(O.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(g,y,v){const R=this._extHostNotebook.getEditorById(g);this._rendererMessageEmitters.get(y)?.fire({editor:R.apiEditor,message:v})}createRendererMessaging(g,y){if(!g.contributes?.notebookRenderer?.some(R=>R.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(R,P,E)=>this.getOrCreateEmitterFor(y).event(R,P,E),postMessage:(R,P)=>{f.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,P]=[P,R]);const E=P&&f.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.proxy.$postMessage(E?.id,y,R)}}}getOrCreateEmitterFor(g){let y=this._rendererMessageEmitters.get(g);return y||(y=new I.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(g)}}),this._rendererMessageEmitters.set(g,y),y)}}e.ExtHostNotebookRenderers=A}),define(De[324],Ie([1,0,3,17,2,26,6]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class g{constructor(v){this.handlers=new Map,this.proxy=v.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(v,R,P){if((0,A.checkProposedApiEnabled)(v,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,P),this.proxy.$registerProfileContentHandler(R,P.name,P.description,v.identifier.value),(0,I.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(v,R,P,E){const S=this.handlers.get(v);if(!S)throw new Error(`Unknown handler with id: ${v}`);return S.saveProfile(R,P,E)}async $readProfile(v,R,P){const E=this.handlers.get(v);if(!E)throw new Error(`Unknown handler with id: ${v}`);return E.readProfile((0,O.isString)(R)?R:f.URI.revive(R),P)}}e.ExtHostProfileContentHandlers=g}),define(De[325],Ie([1,0,2,6,8,13]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(y,v){this.uriTransformer=v,this.providers=new Map,this.proxy=y.getProxy(O.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,v,R){const P=I.URI.revive(v),E=this.providers.get(y);return E?(0,f.asPromise)(()=>E.provideOriginalResource(P,R)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(y,v,R,P){const E=T.handlePool++;return this.providers.set(E,v),this.proxy.$registerQuickDiffProvider(E,A.DocumentSelector.from(y,this.uriTransformer),R,P),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(E),this.providers.delete(E)}}}}e.ExtHostQuickDiff=T}),define(De[326],Ie([1,0,21,4,3,6,2,7,9,19,38,59,26,13]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(w,d,o){const u=w.getProxy(A.MainContext.MainThreadQuickOpen);class c{constructor(k,C){this._sessions=new Map,this._instances=0,this._workspace=k,this._commands=C}showQuickPick(k,C,p,m=I.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(C),D=++this._instances,M=u.$show(D,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},m),L={},F=M.then(()=>L);return Promise.race([F,b]).then(x=>{if(x===L)return;const U=(0,E.isProposedApiEnabled)(k,"quickPickItemTooltip");return b.then(N=>{const z=[];for(let V=0;V<N.length;V++){const ge=N[V];if(typeof ge=="string")z.push({label:ge,handle:V});else if(ge.kind===g.QuickPickItemKind.Separator)z.push({type:"separator",label:ge.label});else{ge.tooltip&&!U&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const te=ge.iconPath?s(ge.iconPath):void 0;z.push({label:ge.label,iconPath:te?.iconPath,iconClass:te?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:U?S.MarkdownString.fromStrict(ge.tooltip):void 0,handle:V})}}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{p.onDidSelectItem(N[V])}),u.$setItems(D,z),M.then(V=>{if(typeof V=="number")return N[V];if(Array.isArray(V))return V.map(ge=>N[ge])})})}).then(void 0,x=>{if(!(0,y.isCancellationError)(x))return u.$setError(D,x),Promise.reject(x)})}$onItemSelected(k){this._onDidSelectItem?.(k)}showInput(k,C=I.CancellationToken.None){return this._validateInput=k?.validateInput,u.$input(k,typeof this._validateInput=="function",C).then(void 0,p=>{if(!(0,y.isCancellationError)(p))return Promise.reject(p)})}async $validateInput(k){if(!this._validateInput)return;const C=await this._validateInput(k);if(!C||typeof C=="string")return C;let p;switch(C.severity){case g.InputBoxValidationSeverity.Info:p=R.default.Info;break;case g.InputBoxValidationSeverity.Warning:p=R.default.Warning;break;case g.InputBoxValidationSeverity.Error:p=R.default.Error;break;default:p=C.message?R.default.Error:R.default.Ignore;break}return{content:C.message,severity:p}}async showWorkspaceFolderPick(k,C=I.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!p)return;const m=await this._workspace.getWorkspaceFolders2();if(m)return m.find(b=>b.uri.toString()===p.uri.toString())}createQuickPick(k){const C=new n(k,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(k){const C=new r(k,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}$onDidChangeValue(k,C){this._sessions.get(k)?._fireDidChangeValue(C)}$onDidAccept(k){this._sessions.get(k)?._fireDidAccept()}$onDidChangeActive(k,C){const p=this._sessions.get(k);p instanceof n&&p._fireDidChangeActive(C)}$onDidChangeSelection(k,C){const p=this._sessions.get(k);p instanceof n&&p._fireDidChangeSelection(C)}$onDidTriggerButton(k,C){this._sessions.get(k)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(k,C,p){const m=this._sessions.get(k);m instanceof n&&m._fireDidTriggerItemButton(C,p)}$onDidHide(k){this._sessions.get(k)?._fireDidHide()}}class h{static{this._nextId=1}constructor(k,C){this._extensionId=k,this._onDidDispose=C,this._id=n._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new O.Emitter,this._onDidChangeValueEmitter=new O.Emitter,this._onDidTriggerButtonEmitter=new O.Emitter,this._onDidHideEmitter=new O.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(k){this._title=k,this.update({title:k})}get step(){return this._steps}set step(k){this._steps=k,this.update({step:k})}get totalSteps(){return this._totalSteps}set totalSteps(k){this._totalSteps=k,this.update({totalSteps:k})}get enabled(){return this._enabled}set enabled(k){this._enabled=k,this.update({enabled:k})}get busy(){return this._busy}set busy(k){this._busy=k,this.update({busy:k})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(k){this._ignoreFocusOut=k,this.update({ignoreFocusOut:k})}get value(){return this._value}set value(k){this._value=k,this.update({value:k})}get placeholder(){return this._placeholder}set placeholder(k){this._placeholder=k,this.update({placeholder:k})}get buttons(){return this._buttons}set buttons(k){this._buttons=k.slice(),this._handlesToButtons.clear(),k.forEach((C,p)=>{const m=C===g.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(m,C)}),this.update({buttons:k.map((C,p)=>({...s(C.iconPath),tooltip:C.tooltip,handle:C===g.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(k){this._value=k,this._onDidChangeValueEmitter.fire(k)}_fireDidTriggerButton(k){const C=this._handlesToButtons.get(k);C&&this._onDidTriggerButtonEmitter.fire(C)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,f.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),u.$dispose(this._id))}update(k){if(!this._disposed){for(const C of Object.keys(k)){const p=k[C];this._pendingUpdate[C]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){u.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function a(l){if(l instanceof g.ThemeIcon)return{id:l.id};const k=i(l),C=t(l);return{dark:typeof k=="string"?T.URI.file(k):k,light:typeof C=="string"?T.URI.file(C):C}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function i(l){return typeof l=="object"&&"dark"in l?l.dark:l}function s(l){const k=a(l);let C,p;return"id"in k?p=P.ThemeIcon.asClassName(k):C=k,{iconPath:C,iconClass:p}}class n extends h{constructor(k,C){super(k.identifier,C),this.extension=k,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new O.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new O.Emitter,this._onDidTriggerItemButtonEmitter=new O.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(k){this._items=k.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),k.forEach((m,b)=>{this._handlesToItems.set(b,m),this._itemsToHandles.set(m,b)});const C=(0,E.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),p=[];for(let m=0;m<k.length;m++){const b=k[m];if(b.kind===g.QuickPickItemKind.Separator)p.push({type:"separator",label:b.label});else{b.tooltip&&!C&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const D=b.iconPath?s(b.iconPath):void 0;p.push({handle:m,label:b.label,iconPath:D?.iconPath,iconClass:D?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:C?S.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((M,L)=>({...s(M.iconPath),tooltip:M.tooltip,handle:L}))})}}this.update({items:p})}get canSelectMany(){return this._canSelectMany}set canSelectMany(k){this._canSelectMany=k,this.update({canSelectMany:k})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(k){this._matchOnDescription=k,this.update({matchOnDescription:k})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(k){this._matchOnDetail=k,this.update({matchOnDetail:k})}get sortByLabel(){return this._sortByLabel}set sortByLabel(k){this._sortByLabel=k,this.update({sortByLabel:k})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(k){this._keepScrollPosition=k,this.update({keepScrollPosition:k})}get activeItems(){return this._activeItems}set activeItems(k){this._activeItems=k.filter(C=>this._itemsToHandles.has(C)),this.update({activeItems:this._activeItems.map(C=>this._itemsToHandles.get(C))})}get selectedItems(){return this._selectedItems}set selectedItems(k){this._selectedItems=k.filter(C=>this._itemsToHandles.has(C)),this.update({selectedItems:this._selectedItems.map(C=>this._itemsToHandles.get(C))})}_fireDidChangeActive(k){const C=(0,v.coalesce)(k.map(p=>this._handlesToItems.get(p)));this._activeItems=C,this._onDidChangeActiveEmitter.fire(C)}_fireDidChangeSelection(k){const C=(0,v.coalesce)(k.map(p=>this._handlesToItems.get(p)));this._selectedItems=C,this._onDidChangeSelectionEmitter.fire(C)}_fireDidTriggerItemButton(k,C){const p=this._handlesToItems.get(k);if(!p||!p.buttons||!p.buttons.length)return;const m=p.buttons[C];m&&this._onDidTriggerItemButtonEmitter.fire({button:m,item:p})}}class r extends h{constructor(k,C){super(k.identifier,C),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(k){this._password=k,this.update({password:k})}get prompt(){return this._prompt}set prompt(k){this._prompt=k,this.update({prompt:k})}get valueSelection(){return this._valueSelection}set valueSelection(k){this._valueSelection=k,this.update({valueSelection:k})}get validationMessage(){return this._validationMessage}set validationMessage(k){this._validationMessage=k,k?typeof k=="string"?this.update({validationMessage:k,severity:R.default.Error}):this.update({validationMessage:k.message,severity:k.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new c(d,o)}e.createExtHostQuickOpen=_}),define(De[327],Ie([1,0,2,4,57,3,8,6,19,126,14,25,59,13,26,18]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function o(b){if(b)return typeof b.iconPath=="string"?I.URI.file(b.iconPath):I.URI.isUri(b.iconPath)||E.ThemeIcon.isThemeIcon(b.iconPath)?b.iconPath:void 0}function u(b){if(b?.icon){if(I.URI.isUri(b.icon))return b.icon;if(E.ThemeIcon.isThemeIcon(b.icon))return b.icon;{const D=b.icon;return{light:D.light,dark:D.dark}}}else return}function c(b){if(b.icon){if(I.URI.isUri(b.icon))return b.icon;if(E.ThemeIcon.isThemeIcon(b.icon))return b.icon;{const D=b.icon;return{light:D.light,dark:D.dark}}}else return}function h(b,D){if(!b.iconPath&&!D.iconPath)return 0;if(b.iconPath){if(!D.iconPath)return 1}else return-1;const M=typeof b.iconPath=="string"?b.iconPath:I.URI.isUri(b.iconPath)?b.iconPath.fsPath:b.iconPath.id,L=typeof D.iconPath=="string"?D.iconPath:I.URI.isUri(D.iconPath)?D.iconPath.fsPath:D.iconPath.id;return(0,v.comparePaths)(M,L)}function a(b,D){let M=0;if(b.strikeThrough!==D.strikeThrough)return b.strikeThrough?1:-1;if(b.faded!==D.faded)return b.faded?1:-1;if(b.tooltip!==D.tooltip)return(b.tooltip||"").localeCompare(D.tooltip||"");if(M=h(b,D),M!==0)return M;if(b.light&&D.light)M=h(b.light,D.light);else{if(b.light)return 1;if(D.light)return-1}if(M!==0)return M;if(b.dark&&D.dark)M=h(b.dark,D.dark);else{if(b.dark)return 1;if(D.dark)return-1}return M}function t(b,D){if(b.command!==D.command)return b.command<D.command?-1:1;if(b.title!==D.title)return b.title<D.title?-1:1;if(b.tooltip!==D.tooltip){if(b.tooltip!==void 0&&D.tooltip!==void 0)return b.tooltip<D.tooltip?-1:1;if(b.tooltip!==void 0)return 1;if(D.tooltip!==void 0)return-1}if(b.arguments===D.arguments)return 0;if(b.arguments)if(D.arguments){if(b.arguments.length!==D.arguments.length)return b.arguments.length-D.arguments.length}else return 1;else return-1;for(let M=0;M<b.arguments.length;M++){const L=b.arguments[M],F=D.arguments[M];if(L!==F)return L<F?-1:1}return 0}function i(b,D){let M=(0,v.comparePaths)(b.resourceUri.fsPath,D.resourceUri.fsPath,!0);if(M!==0)return M;if(b.command&&D.command)M=t(b.command,D.command);else{if(b.command)return 1;if(D.command)return-1}if(M!==0)return M;if(b.decorations&&D.decorations)M=a(b.decorations,D.decorations);else{if(b.decorations)return 1;if(D.decorations)return-1}return M}function s(b,D){for(let M=0;M<b.length;M++)if(b[M]!==D[M])return!1;return!0}function n(b,D){return b.command===D.command&&b.title===D.title&&b.tooltip===D.tooltip&&(b.arguments&&D.arguments?s(b.arguments,D.arguments):b.arguments===D.arguments)}function r(b,D){return(0,y.equals)(b,D,n)}function l(b,D){return b===D?!0:!b||!D?!1:b.id===D.id&&b.label===D.label&&b.upstream?.id===D.upstream?.id&&b.upstream?.label===D.upstream?.label}class k{#e;#t;get value(){return this._value}set value(D){D=D??"",this.#e.$setInputBoxValue(this._sourceControlHandle,D),this.updateValue(D)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(D){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,D),this._placeholder=D}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(D){if((0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),D&&typeof D!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=D,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!D)}get enabled(){return this._enabled}set enabled(D){D=!!D,this._enabled!==D&&(this._enabled=D,this.#e.$setInputBoxEnablement(this._sourceControlHandle,D))}get visible(){return this._visible}set visible(D){D=!!D,this._visible!==D&&(this._visible=D,this.#e.$setInputBoxVisibility(this._sourceControlHandle,D))}get actionButton(){return(0,_.checkProposedApiEnabled)(this._extension,"scmInputBoxActionButton"),this._actionButton}set actionButton(D){(0,_.checkProposedApiEnabled)(this._extension,"scmInputBoxActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=D;const M=D!==void 0?{command:this._commands.converter.toInternal(D.command,this._actionButtonDisposables.value),icon:u(D),enabled:D.enabled}:void 0;this.#e.$setInputBoxActionButton(this._sourceControlHandle,M??null)}get document(){return(0,_.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(D,M,L,F,x,U){this._extension=D,this._commands=M,this._sourceControlHandle=x,this._documentUri=U,this._value="",this._onDidChange=new O.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this._actionButtonDisposables=new A.MutableDisposable,this.#t=L,this.#e=F}showValidationMessage(D,M){(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,D,M)}$onInputBoxValueChange(D){this.updateValue(D)}updateValue(D){this._value=D,this._onDidChange.fire(D)}}e.ExtHostSCMInputBox=k;class C{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(D){this._label=D,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,D)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(D){this._hideWhenEmpty=D,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(D){this._resourceStates=[...D],this._onDidUpdateResourceStates.fire()}constructor(D,M,L,F,x){this._proxy=D,this._commands=M,this._sourceControlHandle=L,this._id=F,this._label=x,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new O.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=C._handlePool++}getResourceState(D){return this._resourceStatesMap.get(D)}$executeResourceCommand(D,M){const L=this._resourceStatesCommandsMap.get(D);return L?(0,T.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],M)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const D=[...this._resourceStates].sort(i),L=(0,y.sortedDiff)(this._resourceSnapshot,D,i).map(U=>{const N=U.toInsert.map(z=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,z);const ge=z.resourceUri;let te;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const re=new A.DisposableStore;te=this._commands.converter.toInternal(z.command,re),this._resourceStatesDisposablesMap.set(V,re)}else this._resourceStatesCommandsMap.set(V,z.command);const q=o(z.decorations),K=z.decorations&&o(z.decorations.light)||q,ue=z.decorations&&o(z.decorations.dark)||q,ie=[K,ue],ce=z.decorations&&z.decorations.tooltip||"",Se=z.decorations&&!!z.decorations.strikeThrough,j=z.decorations&&!!z.decorations.faded,$=z.contextValue||"";return{rawResource:[V,ge,ie,ce,Se,j,$,te],handle:V}});return{start:U.start,deleteCount:U.deleteCount,toInsert:N}}),F=L.map(({start:U,deleteCount:N,toInsert:z})=>[U,N,z.map(V=>V.rawResource)]),x=L.reverse();for(const{start:U,deleteCount:N,toInsert:z}of x){const V=z.map(te=>te.handle),ge=this._handlesSnapshot.splice(U,N,...V);for(const te of ge)this._resourceStatesMap.delete(te),this._resourceStatesCommandsMap.delete(te),this._resourceStatesDisposablesMap.get(te)?.dispose(),this._resourceStatesDisposablesMap.delete(te)}return this._resourceSnapshot=D,F}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class p{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(D){this._count!==D&&(this._count=D,this.#e.$updateSourceControl(this.handle,{count:D}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(D){this._quickDiffProvider=D;let M;(0,_.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(M=D?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!D,quickDiffLabel:M})}get historyProvider(){return(0,_.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(D){(0,_.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=D,this._historyProviderDisposable.value=new A.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!D}),D&&(this._historyProviderDisposable.value.add(D.onDidChangeCurrentHistoryItemGroup(()=>{l(this._historyProviderCurrentHistoryItemGroup,D?.currentHistoryItemGroup)||(this._historyProviderCurrentHistoryItemGroup=D?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup))})),this._historyProviderDisposable.value.add(D.onDidChangeActionButton(()=>{(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._historyProviderActionButtonDisposable.value=new A.DisposableStore;const M=D.actionButton!==void 0?{command:this._commands.converter.toInternal(D.actionButton.command,this._historyProviderActionButtonDisposable.value),description:D.actionButton.description,enabled:D.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.handle,M??null)})))}get commitTemplate(){return this._commitTemplate}set commitTemplate(D){D!==this._commitTemplate&&(this._commitTemplate=D,this.#e.$updateSourceControl(this.handle,{commitTemplate:D}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(D){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=D;const M=this._commands.converter.toInternal(D,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:M})}get actionButton(){return(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(D){(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=D;const M=D!==void 0?{command:this._commands.converter.toInternal(D.command,this._actionButtonDisposables.value),secondaryCommands:D.secondaryCommands?.map(L=>L.map(F=>this._commands.converter.toInternal(F,this._actionButtonDisposables.value))),description:D.description,enabled:D.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:M??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(D){if(this._statusBarCommands&&D&&r(this._statusBarCommands,D))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=D;const M=(D||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:M})}get selected(){return this._selected}constructor(D,M,L,F,x,U,N){this._extension=D,this._commands=F,this._id=x,this._label=U,this._rootUri=N,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new A.MutableDisposable,this._historyProviderActionButtonDisposable=new A.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new O.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=p._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=L;const z=I.URI.from({scheme:w.Schemas.vscodeSourceControl,path:`${x}/scm${this.handle}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this._inputBox=new k(D,F,M,this.#e,this.handle,z),this.#e.$registerSourceControl(this.handle,x,U,N,z)}createResourceGroup(D,M){const L=new C(this.#e,this._commands,this.handle,D,M),F=O.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,F),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const D=[],M=[];for(const[L,F]of this.createdResourceGroups){F.dispose();const x=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});O.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),x.dispose(),this._groups.delete(L.handle),this.#e.$unregisterGroup(this.handle,L.handle)}),D.push([L.handle,L.id,L.label,L.features]);const U=L._takeResourceStateSnapshot();U.length>0&&M.push([L.handle,U]),this._groups.set(L.handle,L)}this.#e.$registerGroups(this.handle,D,M),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const D=[];this.updatedResourceGroups.forEach(M=>{const L=M._takeResourceStateSnapshot();L.length!==0&&D.push([M.handle,L])}),D.length>0&&this.#e.$spliceResourceStates(this.handle,D),this.updatedResourceGroups.clear()}getResourceGroup(D){return this._groups.get(D)}setSelectionState(D){this._selected=D,this._onDidChangeSelection.fire(D)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(D=>D.dispose()),this.#e.$unregisterSourceControl(this.handle)}}je([(0,f.debounce)(100)],p.prototype,"eventuallyAddResourceGroups",null),je([(0,f.debounce)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let m=class{static{d=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(D,M,L,F){this._commands=M,this._extHostDocuments=L,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new P.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new O.Emitter,this._proxy=D.getProxy(g.MainContext.MainThreadSCM),this._telemetry=D.getProxy(g.MainContext.MainThreadTelemetry),M.registerArgumentProcessor({processArgument:x=>{if(x&&x.$mid===3){const U=this._sourceControls.get(x.sourceControlHandle);if(!U)return x;const N=U.getResourceGroup(x.groupHandle);return N?N.getResourceState(x.handle):x}else if(x&&x.$mid===4){const U=this._sourceControls.get(x.sourceControlHandle);return U?U.getResourceGroup(x.groupHandle):x}else if(x&&x.$mid===5){const U=this._sourceControls.get(x.handle);return U||x}return x}})}createSourceControl(D,M,L,F){this.logService.trace("ExtHostSCM#createSourceControl",D.identifier.value,M,L,F),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:D.identifier.value});const x=d._handlePool++,U=new p(D,this._extHostDocuments,this._proxy,this._commands,M,L,F);this._sourceControls.set(x,U);const N=this._sourceControlsByExtension.get(D.identifier)||[];return N.push(U),this._sourceControlsByExtension.set(D.identifier,N),U}getLastInputBox(D){this.logService.trace("ExtHostSCM#getLastInputBox",D.identifier.value);const M=this._sourceControlsByExtension.get(D.identifier),L=M&&M[M.length-1];return L&&L.inputBox}$provideOriginalResource(D,M,L){const F=I.URI.revive(M);this.logService.trace("ExtHostSCM#$provideOriginalResource",D,F.toString());const x=this._sourceControls.get(D);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(F,L)).then(U=>U||null)}$onInputBoxValueChange(D,M){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",D);const L=this._sourceControls.get(D);return L&&L.inputBox.$onInputBoxValueChange(M),Promise.resolve(void 0)}$executeResourceCommand(D,M,L,F){this.logService.trace("ExtHostSCM#$executeResourceCommand",D,M,L);const x=this._sourceControls.get(D);if(!x)return Promise.resolve(void 0);const U=x.getResourceGroup(M);return U?U.$executeResourceCommand(L,F):Promise.resolve(void 0)}$validateInput(D,M,L){this.logService.trace("ExtHostSCM#$validateInput",D);const F=this._sourceControls.get(D);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>F.inputBox.validateInput(M,L)).then(x=>{if(!x)return Promise.resolve(void 0);const U=S.MarkdownString.fromStrict(x.message);return U?Promise.resolve([U,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(D){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",D),D!==void 0&&this._sourceControls.get(D)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=D,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(D,M,L){return await this._sourceControls.get(D)?.historyProvider?.resolveHistoryItemGroupBase(M,L)??void 0}async $resolveHistoryItemGroupCommonAncestor(D,M,L,F){return await this._sourceControls.get(D)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(M,L,F)??void 0}async $provideHistoryItems(D,M,L,F){return(await this._sourceControls.get(D)?.historyProvider?.provideHistoryItems(M,L,F))?.map(N=>({id:N.id,parentIds:N.parentIds,label:N.label,description:N.description,icon:c(N),timestamp:N.timestamp}))??void 0}async $provideHistoryItemChanges(D,M,L){return await this._sourceControls.get(D)?.historyProvider?.provideHistoryItemChanges(M,L)??void 0}};e.ExtHostSCM=m,e.ExtHostSCM=m=d=je([$e(3,R.ILogService)],m)}),define(De[114],Ie([1,0,6,4,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(g){this._onDidChangePassword=new O.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=g.getProxy(I.MainContext.MainThreadSecretState)}async $onDidChangePassword(g){this._onDidChangePassword.fire(g)}get(g,y){return this._proxy.$getPassword(g,y)}store(g,y,v){return this._proxy.$setPassword(g,y,v)}delete(g,y){return this._proxy.$deletePassword(g,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,f.createDecorator)("IExtHostSecretState")}),define(De[328],Ie([1,0,6,13,2]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class A{static{this.handlePool=0}constructor(g,y){this.uriTransformer=y,this.providers=new Map,this.proxy=g.getProxy(I.MainContext.MainThreadShare)}async $provideShare(g,y,v){return await this.providers.get(g)?.provideShare({selection:O.Range.to(y.selection),resourceUri:f.URI.revive(y.resourceUri)},v)??void 0}registerShareProvider(g,y){const v=A.handlePool++;return this.providers.set(v,y),this.proxy.$registerShareProvider(v,O.DocumentSelector.from(g,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(v),this.providers.delete(v)}}}}e.ExtHostShare=A}),define(De[329],Ie([1,0,21,3,6]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class A{static{this.ID_POOL=1}constructor(g){this.providers=new Map,this.sessions=new Map,this.proxy=g.getProxy(f.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(g,y){const v=this.providers.get(g);if(!v)return;const R=new O.DisposableStore,P=new I.CancellationTokenSource;this.sessions.set(y,P);const E=R.add(v.provideSpeechToTextSession(P.token));R.add(E.onDidChange(S=>{P.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(y,S)})),R.add(P.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(g){this.sessions.get(g)?.dispose(!0),this.sessions.delete(g)}registerProvider(g,y,v){const R=A.ID_POOL++;return this.providers.set(R,v),this.proxy.$registerProvider(R,y,{extension:g,displayName:g.value}),(0,O.toDisposable)(()=>{this.proxy.$unregisterProvider(R),this.providers.delete(R)})}}e.ExtHostSpeech=A}),define(De[330],Ie([1,0,7,6,210,3,13,17]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new I.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(E,S,_,w,d,o=I.StatusBarAlignment.Left,u){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,this.#e=E,this.#t=S,d&&w){this._entryId=(0,I.asStatusBarItemIdentifier)(w.identifier,d);const c=_.get(this._entryId);c&&(o=c.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,u=c.priority,this._visible=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this._entryId=String(y.ID_GEN++);this._extension=w,this._id=d,this._alignment=o,this._priority=this.validatePriority(u)}validatePriority(E){if((0,g.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(E){this._text=E,this.update()}set name(E){this._name=E,this.update()}set tooltip(E){this._tooltip=E,this.update()}set color(E){this._color=E,this.update()}set backgroundColor(E){E&&!y.ALLOWED_BACKGROUND_COLORS.has(E.id)&&(E=void 0),this._backgroundColor=E,this.update()}set command(E){this._command?.fromApi!==E&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof E=="string"?this._command={fromApi:E,internal:this.#t.toInternal({title:"",command:E},this._latestCommandRegistration)}:E?this._command={fromApi:E,internal:this.#t.toInternal(E,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(E){this._accessibilityInformation=E,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let E;this._extension?this._id?E=`${this._extension.identifier.value}.${this._id}`:E=this._extension.identifier.value:E=this._id;let S;this._name?S=this._name:S=(0,f.localize)(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,E,this._extension?.identifier.value,S,this._text,w,this._command?.internal,_,this._backgroundColor,this._alignment===I.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y;class v{constructor(E){this._messages=[],this._item=E.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,f.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(E){const S={message:E};return this._messages.unshift(S),this._update(),new I.Disposable(()=>{const _=this._messages.indexOf(S);_>=0&&(this._messages.splice(_,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(E,S){this._existingItems=new Map,this._proxy=E.getProxy(O.MainContext.MainThreadStatusBar),this._commands=S,this._statusMessage=new v(this)}$acceptStaticEntries(E){for(const S of E)this._existingItems.set(S.entryId,S)}createStatusBarEntry(E,S,_,w){return new y(this._proxy,this._commands,this._existingItems,E,S,_,w)}setStatusBarMessage(E,S){const _=this._statusMessage.setMessage(E);let w;return typeof S=="number"?w=setTimeout(()=>_.dispose(),S):typeof S<"u"&&S.then(()=>_.dispose(),()=>_.dispose()),new I.Disposable(()=>{_.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=R}),define(De[115],Ie([1,0,6,4,5]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(g,y){this._logService=y,this._onDidChangeStorage=new O.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=g.getProxy(I.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(g,y){this._proxy.$registerExtensionStorageKeysToSync(g,y)}async initializeExtensionStorage(g,y,v){const R=await this._proxy.$initializeExtensionStorage(g,y);let P;return R&&(P=this.safeParseValue(g,y,R)),P||v}setValue(g,y,v){return this._proxy.$setValue(g,y,v)}$acceptValue(g,y,v){const R=this.safeParseValue(g,y,v);R&&this._onDidChangeStorage.fire({shared:g,key:y,value:R})}safeParseValue(g,y,v){try{return JSON.parse(v)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${g}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,f.createDecorator)("IExtHostStorage")}),define(De[90],Ie([1,0,5,27,14,72,2]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,I.createDecorator)("IExtensionStoragePaths");let g=class{constructor(v,R,P){this._logService=R,this._extHostFileSystem=P,this._workspace=v.workspace??void 0,this._environment=v.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(E=>this._value=E)}async _getWorkspaceStorageURI(v){return T.URI.joinPath(this._environment.workspaceStorageHome,v)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const v=this._workspace.id,R=await this._getWorkspaceStorageURI(v);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(v){if(this._value)return T.URI.joinPath(this._value,v.identifier.value)}globalValue(v){return T.URI.joinPath(this._environment.globalStorageHome,v.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=g,e.ExtensionStoragePaths=g=je([$e(0,O.IExtHostInitDataService),$e(1,f.ILogService),$e(2,A.IExtHostConsumerFileSystem)],g)}),define(De[45],Ie([1,0,4,6,5,2,20,3,7,212,9,254,21,31,255,59,8,13,34]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,f.createDecorator)("IExtHostTerminalService");class c{constructor(p,m,b,D){this._proxy=p,this._id=m,this._creationOptions=b,this._name=D,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(L=>this._pidPromiseComplete=L);const M=this;this.value={get name(){return M._name||""},get processId(){return M._pidPromise},get creationOptions(){return M._creationOptions},get exitStatus(){return M._exitStatus},get state(){return M._state},get selection(){return M._selection},sendText(L,F=!0){M._checkDisposed(),M._proxy.$sendText(M._id,L,F)},show(L){M._checkDisposed(),M._proxy.$show(M._id,L)},hide(){M._checkDisposed(),M._proxy.$hide(M._id)},dispose(){M._disposed||(M._disposed=!0,M._proxy.$dispose(M._id))},get dimensions(){if(!(M._cols===void 0||M._rows===void 0))return{columns:M._cols,rows:M._rows}}}}async create(p,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??void 0,env:p.env??void 0,icon:r(p.iconPath)??void 0,color:w.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this._serializeParentTerminal(p.location,m?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,m,b,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:w.ThemeColor.isThemeColor(D)?D.id:void 0,location:this._serializeParentTerminal(p,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(p,m){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in p?{viewColumn:o.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(p){this._name=p}setExitStatus(p,m){this._exitStatus=Object.freeze({code:p,reason:m})}setDimensions(p,m){return p===this._cols&&m===this._rows||p===0||m===0?!1:(this._cols=p,this._rows=m,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(p){this._selection=p}_setProcessId(p){this._pidPromiseComplete?(this._pidPromiseComplete(p),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==p&&(this._pidPromise=Promise.resolve(p))})}}e.ExtHostTerminal=c;class h{get onProcessReady(){return this._onProcessReady.event}constructor(p){this._pty=p,this.id=0,this.shouldPersist=!1,this._onProcessData=new I.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new I.Emitter,this._onDidChangeProperty=new I.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new I.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${m}`)}async start(){}shutdown(){this._pty.close()}input(p){this._pty.handleInput?.(p)}resize(p,m){this._pty.setDimensions?.({columns:p,rows:m})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose?.((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions?.(m=>{m&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this._pty.onDidChangeName?.(m=>{this._onDidChangeProperty.fire({type:"title",value:m})}),this._pty.open(p||void 0),p&&this._pty.setDimensions?.(p),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends g.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(p=>p.value)}constructor(p,m,b){super(),this._extHostCommands=m,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new g.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new I.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new I.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new I.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new I.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new I.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new I.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=b.getProxy(O.MainContext.MainThreadTerminalService),this._bufferer=new _.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(p),this._extHostCommands.registerArgumentProcessor({processArgument:D=>{const M=L=>{const F=L;return this._getTerminalById(F.instanceId)?.value};switch(D?.$mid){case 15:return M(D);default:{if(Array.isArray(D))for(let L=0;L<D.length&&D[L].$mid===15;L++)D[L]=M(D[L]);return D}}}}),this._register({dispose:()=>{for(const[D,M]of this._terminalProcesses)M.shutdown(!0)}})}getDefaultShell(p){return(p?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(p){return(p?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(p,m){const b=new c(this._proxy,(0,S.generateUuid)(),p,p.name),D=new h(p.pty);return b.createExtensionTerminal(p.location,this._serializeParentTerminal(p,m).resolvedExtHostIdentifier,r(p.iconPath),l(p.color)).then(M=>{const L=this._setupExtHostProcessListeners(M,D);this._terminalProcessDisposables[M]=L}),this._terminals.push(b),b.value}_serializeParentTerminal(p,m){if(m=m||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const b=p.location.parentTerminal;if(b){const D=this._terminals.find(M=>M.value===b);D&&(m.resolvedExtHostIdentifier=D._id)}}else p.location&&typeof p.location!="object"?m.location=p.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(p,m){if(!this._getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const D=new h(m),M=this._setupExtHostProcessListeners(p,D);this._terminalProcessDisposables[p]=M}async $acceptActiveTerminalChanged(p){const m=this._activeTerminal;if(p===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(p);b&&(this._activeTerminal=b,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(p,m){const b=this._getTerminalById(p);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:m})}async $acceptTerminalDimensions(p,m,b){const D=this._getTerminalById(p);D&&D.setDimensions(m,b)&&this._onDidChangeTerminalDimensions.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptDidExecuteCommand(p,m){const b=this._getTerminalById(p);b&&this._onDidExecuteCommand.fire({terminal:b.value,...m})}async $acceptTerminalMaximumDimensions(p,m,b){this._terminalProcesses.get(p)?.resize(m,b)}async $acceptTerminalTitleChange(p,m){const b=this._getTerminalById(p);b&&(b.name=m)}async $acceptTerminalClosed(p,m,b){const D=this._getTerminalObjectIndexById(this._terminals,p);if(D!==null){const M=this._terminals.splice(D,1)[0];M.setExitStatus(m,b),this._onDidCloseTerminal.fire(M.value)}}$acceptTerminalOpened(p,m,b,D){if(m){const F=this._getTerminalObjectIndexById(this._terminals,m);if(F!==null){this._terminals[F]._id=p,this._onDidOpenTerminal.fire(this.terminals[F]),this._terminals[F].isOpen=!0;return}}const M={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:A.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},L=new c(this._proxy,p,M,b);this._terminals.push(L),this._onDidOpenTerminal.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(p,m){this._getTerminalById(p)?._setProcessId(m)}async $startExtensionTerminal(p,m){const b=this._getTerminalById(p);if(!b)return{message:(0,v.localize)(0,null,p)};b.isOpen||await new Promise(M=>{const L=this.onDidOpenTerminal(async F=>{F===b.value&&(L.dispose(),M())})});const D=this._terminalProcesses.get(p);D?D.startSendingEvents(m):this._extensionTerminalAwaitingStart[p]={initialDimensions:m}}_setupExtHostProcessListeners(p,m){const b=new g.DisposableStore;b.add(m.onProcessReady(M=>this._proxy.$sendProcessReady(p,M.pid,M.cwd,M.windowsPty))),b.add(m.onDidChangeProperty(M=>this._proxy.$sendProcessProperty(p,M))),this._bufferer.startBuffering(p,m.onProcessData),b.add(m.onProcessExit(M=>this._onProcessExit(p,M))),this._terminalProcesses.set(p,m);const D=this._extensionTerminalAwaitingStart[p];return D&&m instanceof h&&(m.startSendingEvents(D.initialDimensions),delete this._extensionTerminalAwaitingStart[p]),b}$acceptProcessAckDataEvent(p,m){this._terminalProcesses.get(p)?.acknowledgeDataEvent(m)}$acceptProcessInput(p,m){this._terminalProcesses.get(p)?.input(m)}$acceptTerminalInteraction(p){const m=this._getTerminalById(p);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire(m.value)}$acceptTerminalSelection(p,m){this._getTerminalById(p)?.setSelection(m)}$acceptProcessResize(p,m,b){try{this._terminalProcesses.get(p)?.resize(m,b)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(p,m){this._terminalProcesses.get(p)?.shutdown(m)}$acceptProcessRequestInitialCwd(p){this._terminalProcesses.get(p)?.getInitialCwd().then(m=>this._proxy.$sendProcessProperty(p,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(p){this._terminalProcesses.get(p)?.getCwd().then(m=>this._proxy.$sendProcessProperty(p,{type:"cwd",value:m}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this._linkProviders.add(p),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(p),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(p,m,b){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,b),this._proxy.$registerProfileProvider(m,p.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(p,m,b){if(this._quickFixProviders.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this._quickFixProviders.set(p,b),this._proxy.$registerQuickFixProvider(p,m),new y.Disposable(()=>{this._quickFixProviders.delete(p),this._proxy.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,m){const b=new E.CancellationTokenSource().token;if(b.isCancellationRequested)return;const D=this._quickFixProviders.get(p);if(!D)return;const M=await D.provideTerminalQuickFixes(m,b);if(M===null||Array.isArray(M)&&M.length===0)return;const L=new g.DisposableStore;if(this._lastQuickFixCommands.value=L,!Array.isArray(M))return M?o.TerminalQuickFix.from(M,this._extHostCommands.converter,L):void 0;const F=[];for(const x of M){const U=o.TerminalQuickFix.from(x,this._extHostCommands.converter,L);U&&F.push(U)}return F}async $createContributedProfileTerminal(p,m){const b=new E.CancellationTokenSource().token;let D=await this._profileProviders.get(p)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,m);return}this.createTerminalFromOptions(D.options,m)}}async $provideLinks(p,m){const b=this._getTerminalById(p);if(!b)return[];this._terminalLinkCache.delete(p),this._terminalLinkCancellationSource.get(p)?.dispose(!0);const M=new E.CancellationTokenSource;this._terminalLinkCancellationSource.set(p,M);const L=[],F={terminal:b.value,line:m},x=[];for(const z of this._linkProviders)x.push(d.Promises.withAsyncBody(async V=>{M.token.onCancellationRequested(()=>V({provider:z,links:[]}));const ge=await z.provideTerminalLinks(F,M.token)||[];M.token.isCancellationRequested||V({provider:z,links:ge})}));const U=await Promise.all(x);if(M.token.isCancellationRequested)return[];const N=new Map;for(const z of U)z&&z.links.length>0&&L.push(...z.links.map(V=>{const ge={id:a++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return N.set(ge.id,{provider:z.provider,link:V}),ge}));return this._terminalLinkCache.set(p,N),L}$activateLink(p,m){const b=this._terminalLinkCache.get(p)?.get(m);b&&b.provider.handleTerminalLink(b.link)}_onProcessExit(p,m){this._bufferer.stopBuffering(p),this._terminalProcesses.delete(p),delete this._extensionTerminalAwaitingStart[p];const b=this._terminalProcessDisposables[p];b&&(b.dispose(),delete this._terminalProcessDisposables[p]),this._proxy.$sendProcessExit(p,m)}_getTerminalById(p){return this._getTerminalObjectById(this._terminals,p)}_getTerminalObjectById(p,m){const b=this._getTerminalObjectIndexById(p,m);return b!==null?p[b]:null}_getTerminalObjectIndexById(p,m){const b=p.findIndex(D=>D._id===m);return b===-1?null:b}getEnvironmentVariableCollection(p){let m=this._environmentVariableCollections.get(p.identifier.value);return m||(m=new i,this._setEnvironmentVariableCollection(p.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(p,m){const b=(0,P.serializeEnvironmentVariableCollection)(m.map),D=(0,P.serializeEnvironmentDescriptionMap)(m.descriptionMap);this._proxy.$setEnvironmentVariableCollection(p,m.persistent,b.length===0?void 0:b,D)}$initEnvironmentVariableCollections(p){p.forEach(m=>{const b=m[0],D=new i(m[1]);this._setEnvironmentVariableCollection(b,D)})}$acceptDefaultProfile(p,m){const b=this._defaultProfile;this._defaultProfile=p,this._defaultAutomationProfile=m,b?.path!==p.path&&this._onDidChangeShell.fire(p.path)}_setEnvironmentVariableCollection(p,m){this._environmentVariableCollections.set(p,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(p,m)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=je([$e(1,u.IExtHostCommands),$e(2,T.IExtHostRpcService)],t);class i{get persistent(){return this._persistent}set persistent(p){this._persistent=p,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(p){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new I.Emitter,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const m=this.getScopeKey(p);let b=this.scopedCollections.get(m);return b||(b=new s(this,p),this.scopedCollections.set(m,b),b.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),b}replace(p,m,b,D){this._setIfDiffers(p,{value:m,type:y.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:D})}append(p,m,b,D){this._setIfDiffers(p,{value:m,type:y.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:D})}prepend(p,m,b,D){this._setIfDiffers(p,{value:m,type:y.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:D})}_setIfDiffers(p,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.getKey(p,m.scope),D=this.map.get(b),M=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!D||D.value!==m.value||D.type!==m.type||D.options?.applyAtProcessCreation!==M.applyAtProcessCreation||D.options?.applyAtShellIntegration!==M.applyAtShellIntegration||D.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const L=this.getKey(p,m.scope),F={variable:p,...m,options:M};this.map.set(L,F),this._onDidChangeCollection.fire()}}get(p,m){const b=this.getKey(p,m),D=this.map.get(b);return D?k(D):void 0}getKey(p,m){const b=this.getScopeKey(m);return b.length?`${p}:::${b}`:p}getScopeKey(p){return this.getWorkspaceKey(p?.workspaceFolder)??""}getWorkspaceKey(p){return p?p.uri.toString():void 0}getVariableMap(p){const m=new Map;for(const[b,D]of this.map)this.getScopeKey(D.scope)===this.getScopeKey(p)&&m.set(D.variable,k(D));return m}delete(p,m){const b=this.getKey(p,m);this.map.delete(b),this._onDidChangeCollection.fire()}clear(p){if(p?.workspaceFolder){for(const[m,b]of this.map)b.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(m);this.clearDescription(p)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(p,m){const b=this.getScopeKey(m),D=this.descriptionMap.get(b);if(!D||D.description!==p){let M;typeof p=="string"?M=p:M=p?.value.split(`

`)[0];const L={description:M,scope:m};this.descriptionMap.set(b,L),this._onDidChangeCollection.fire()}}getDescription(p){const m=this.getScopeKey(p);return this.descriptionMap.get(m)?.description}clearDescription(p){const m=this.getScopeKey(p);this.descriptionMap.delete(m)}}class s{get persistent(){return this.collection.persistent}set persistent(p){this.collection.persistent=p}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(p,m){this.collection=p,this.scope=m,this._onDidChangeCollection=new I.Emitter}getScoped(p){return this.collection.getScopedEnvironmentVariableCollection(p)}replace(p,m,b){this.collection.replace(p,m,b,this.scope)}append(p,m,b){this.collection.append(p,m,b,this.scope)}prepend(p,m,b){this.collection.prepend(p,m,b,this.scope)}get(p){return this.collection.get(p,this.scope)}forEach(p,m){this.collection.getVariableMap(this.scope).forEach((b,D)=>p.call(m,D,b,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(p){this.collection.delete(p,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(p){this.collection.setDescription(p,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let n=class extends t{constructor(p,m){super(!1,p,m)}createTerminal(p,m,b){throw new R.NotSupportedError}createTerminalFromOptions(p,m){throw new R.NotSupportedError}};e.WorkerExtHostTerminalService=n,e.WorkerExtHostTerminalService=n=je([$e(0,u.IExtHostCommands),$e(1,T.IExtHostRpcService)],n);function r(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function l(C){return w.ThemeColor.isThemeColor(C)?C:void 0}function k(C){const p={...C};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(De[331],Ie([1,0,118,8,22,21,4,75,52,3,24,17,31,6,20,147,13,7,68,109,87]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(L,F,x){this.editors=x,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(S.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new n(this.proxy),F.registerArgumentProcessor({processArgument:U=>{switch(U?.$mid){case 16:{const N=U,z=N.tests[N.tests.length-1].item.extId;return this.controllers.get(u.TestId.root(z))?.collection.tree.get(z)?.actual??(0,w.toItemFromContext)(U)}case 18:{const{extId:N,message:z}=U;return{test:this.controllers.get(u.TestId.root(N))?.collection.tree.get(N)?.actual,message:d.TestMessage.to(z)}}default:return U}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const U=await F.executeCommand("_testing.getExplorerSelection"),N=z=>{const V=this.controllers.get(u.TestId.root(z));if(V)return u.TestId.isRoot(z)?V.controller:V.collection.tree.get(z)?.actual};return{include:U?.include.map(N).filter(P.isDefined)||[],exclude:U?.exclude.map(N).filter(P.isDefined)||[]}})}createTestController(L,F,x,U){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const N=new v.DisposableStore,z=N.add(new w.ExtHostTestItemCollection(F,x,this.editors));z.root.label=x;const V=new Map,ge=this.proxy,te={items:z.root.children,get label(){return x},set label(K){x=K,z.root.label=K,ge.$updateController(F,{label:x})},get refreshHandler(){return U},set refreshHandler(K){U=K,ge.$updateController(F,{canRefresh:!!K})},get id(){return F},createRunProfile:(K,ue,ie,ce,Se,j)=>{let $=(0,y.hash)(K);for(;V.has($);)$++;return new b(this.proxy,V,F,$,K,ue,ie,ce,Se,j)},createTestItem(K,ue,ie){return new w.TestItemImpl(F,K,ue,ie)},createTestRun:(K,ue,ie=!0)=>this.runTracker.createTestRun(L,F,z,K,ue,ie),invalidateTestResults:K=>{if(K===void 0)this.proxy.$markTestRetired(void 0);else{const ue=K instanceof Array?K:[K];this.proxy.$markTestRetired(ue.map(ie=>u.TestId.fromExtHostTestItem(ie,F).toString()))}},set resolveHandler(K){z.resolveHandler=K},get resolveHandler(){return z.resolveHandler},dispose:()=>{N.dispose()}};ge.$registerTestController(F,x,!!U),N.add((0,v.toDisposable)(()=>ge.$unregisterTestController(F)));const q={controller:te,collection:z,profiles:V,extension:L};return this.controllers.set(F,q),N.add((0,v.toDisposable)(()=>this.controllers.delete(F))),N.add(z.onDidGenerateDiff(K=>ge.$publishDiff(F,K.map(h.TestsDiffOp.serialize)))),te}createTestObserver(){return this.observer.checkout()}async runTests(L,F=A.CancellationToken.None){const x=r(L);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(x.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(N=>u.TestId.fromExtHostTestItem(N,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:D[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:L.exclude?.map(N=>N.id)},F)}$syncTests(){for(const{collection:L}of this.controllers.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,F,x){return(0,I.mapFindFirst)(this.runTracker.trackers,N=>N.id===L?N.getCoverage(F):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(L,F,x,U){return(0,I.mapFindFirst)(this.runTracker.trackers,z=>z.id===L?z.getCoverage(F):void 0)?.resolveFileCoverage(x,U)??Promise.resolve([])}$configureRunProfile(L,F){this.controllers.get(L)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(L,F){await this.controllers.get(L)?.controller.refreshHandler?.(F)}$publishTestResults(L){this.results=Object.freeze(L.map(F=>(0,R.deepFreeze)(d.TestResults.to(F))).concat(this.results).sort((F,x)=>x.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,F){const x=this.controllers.get(u.TestId.fromString(L).controllerId)?.collection;x&&(await x.expand(L,F<0?1/0:F),x.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(h.TestsDiffOp.deserialize))}async $runControllerTests(L,F){return Promise.all(L.map(x=>this.runControllerTestRequest(x,!1,F)))}async $startContinuousRun(L,F){const x=new A.CancellationTokenSource(F),U=await Promise.all(L.map(N=>this.runControllerTestRequest(N,!0,x.token)));return!F.isCancellationRequested&&!U.some(N=>N.error)&&await new Promise(N=>F.onCancellationRequested(N)),x.dispose(!0),U}async runControllerTestRequest(L,F,x){const U=this.controllers.get(L.controllerId);if(!U)return{};const{collection:N,profiles:z,extension:V}=U,ge=z.get(L.profileId);if(!ge)return{};const te=L.testIds.map(ie=>N.tree.get(ie)).filter(P.isDefined),q=L.excludeExtIds.map(ie=>U.collection.tree.get(ie)).filter(P.isDefined).filter(ie=>te.some(ce=>ce.fullId.compare(ie.fullId)===2));if(!te.length)return{};const K=new o.TestRunRequest(te.some(ie=>ie.actual instanceof w.TestItemRootImpl)?void 0:te.map(ie=>ie.actual),q.map(ie=>ie.actual),ge,F),ue=(0,h.isStartControllerTests)(L)&&this.runTracker.prepareForMainThreadTestRun(K,l.fromInternal(L,U.collection),V,x);try{return await ge.runHandler(K,x),{}}catch(ie){return{error:String(ie)}}finally{ue&&(ue.hasRunningTasks&&!x.isCancellationRequested&&await T.Event.toPromise(ue.onEnd),ue.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};e.ExtHostTesting=a,e.ExtHostTesting=a=je([$e(0,_.IExtHostRpcService)],a);const t=1e4;var i;(function(M){M[M.Running=0]="Running",M[M.Cancelling=1]="Cancelling",M[M.Ended=2]="Ended"})(i||(i={}));class s extends v.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(L,F,x){super(),this.dto=L,this.proxy=F,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new A.CancellationTokenSource(x));const U=this._register(new O.RunOnceScheduler(()=>this.forciblyEndTasks(),t));this._register(this.cts.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const F=this.dto.id,x=this.dto.controllerId,U=(0,E.generateUuid)(),N=new k(this.proxy,F,U),z=q=>(K,...ue)=>{if(ge){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(K)&&(this.ensureTestIsKnown(K),q(K,...ue))},V=(q,K)=>{const ue=K instanceof Array?K.map(d.TestMessage.from):[d.TestMessage.from(K)];if(q.uri&&q.range){const ie={range:d.Range.from(q.range),uri:q.uri};for(const ce of ue)ce.location=ce.location||ie}this.proxy.$appendTestMessagesInRun(F,U,u.TestId.fromExtHostTestItem(q,x).toString(),ue)};let ge=!1;const te={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return N.coverageProvider},set coverageProvider(q){N.coverageProvider=q},enqueued:z(q=>{this.proxy.$updateTestStateInRun(F,U,u.TestId.fromExtHostTestItem(q,x).toString(),1)}),skipped:z(q=>{this.proxy.$updateTestStateInRun(F,U,u.TestId.fromExtHostTestItem(q,x).toString(),5)}),started:z(q=>{this.proxy.$updateTestStateInRun(F,U,u.TestId.fromExtHostTestItem(q,x).toString(),2)}),errored:z((q,K,ue)=>{V(q,K),this.proxy.$updateTestStateInRun(F,U,u.TestId.fromExtHostTestItem(q,x).toString(),6,ue)}),failed:z((q,K,ue)=>{V(q,K),this.proxy.$updateTestStateInRun(F,U,u.TestId.fromExtHostTestItem(q,x).toString(),4,ue)}),passed:z((q,K)=>{this.proxy.$updateTestStateInRun(F,U,u.TestId.fromExtHostTestItem(q,this.dto.controllerId).toString(),3,K)}),appendOutput:(q,K,ue)=>{ge||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(F,U,f.VSBuffer.fromString(q),K&&d.location.from(K),ue&&u.TestId.fromExtHostTestItem(ue,x).toString()))},end:()=>{ge||(ge=!0,this.proxy.$finishedTestRunTask(F,U),this.tasks.delete(U),this.tasks.size||this.markEnded())}};return this.tasks.set(U,{run:te,coverage:N}),this.proxy.$startedTestRunTask(F,{id:U,name:L,running:!0}),te}forciblyEndTasks(){for(const{run:L}of this.tasks.values())L.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(L){if(!(L instanceof w.TestItemImpl))throw new c.InvalidTestItemError(L.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const F=[],x=this.dto.colllection.root;for(;;){const U=d.TestItem.from(L);if(F.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),L===x))break;L=L.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}dispose(){this.markEnded(),super.dispose()}}class n{get trackers(){return this.tracked.values()}constructor(L){this.proxy=L,this.tracked=new Map}prepareForMainThreadTestRun(L,F,x,U){return this.getTracker(L,F,x,U)}cancelRunById(L){for(const F of this.tracked.values())if(F.id===L){F.cancel();return}}cancelAllRuns(){for(const L of this.tracked.values())L.cancel()}createTestRun(L,F,x,U,N,z){const V=this.tracked.get(U);if(V)return V.createRun(N);const ge=l.fromPublic(F,x,U,z),te=r(U);this.proxy.$startedExtensionTestRun({controllerId:F,continuous:!!U.continuous,profile:te&&{group:D[te.kind],id:te.profileId},exclude:U.exclude?.map(K=>u.TestId.fromExtHostTestItem(K,x.root.id).toString())??[],id:ge.id,include:U.include?.map(K=>u.TestId.fromExtHostTestItem(K,x.root.id).toString())??[x.root.id],persist:z});const q=this.getTracker(U,ge,L);return T.Event.once(q.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(ge.id),q.dispose()}),q.createRun(N)}getTracker(L,F,x,U){const N=new s(F,this.proxy,U);return this.tracked.set(L,N),T.Event.once(N.onEnd)(()=>this.tracked.delete(L)),N}}e.TestRunCoordinator=n;const r=M=>{if(M.profile){if(!(M.profile instanceof b))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class l{static fromPublic(L,F,x,U){return new l(L,(0,E.generateUuid)(),x.include?.map(N=>u.TestId.fromExtHostTestItem(N,L).toString())??[L],x.exclude?.map(N=>u.TestId.fromExtHostTestItem(N,L).toString())??[],U,F)}static fromInternal(L,F){return new l(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,F)}constructor(L,F,x,U,N,z){this.controllerId=L,this.id=F,this.isPersisted=N,this.colllection=z,this.includePrefix=x.map(V=>V+"\0"),this.excludePrefix=U.map(V=>V+"\0")}isIncluded(L){const F=u.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(F===x||F.startsWith(x))return!1;for(const x of this.includePrefix)if(F===x||F.startsWith(x))return!0;return!1}}e.TestRunDto=l;class k{set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");L&&(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(L,F,x){this.proxy=L,this.runId=F,this.taskId=x}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(L,F){const x=await this.fileCoverage;let U=x?.[L];return!this._coverageProvider||!x||!U?[]:(U.detailedCoverage||(U=x[L]=await this._coverageProvider.resolveFileCoverage?.(U,F)??U),U.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class C{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(L){this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(L){this.added.add(L)}update(L){Object.assign(L.revived,d.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}this.updated.delete(L);const F=u.TestId.parentId(L.item.extId);if(F&&this.alreadyRemoved.has(F.toString())){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:F,removed:x}=this;return{get added(){return[...L].map(U=>U.revived)},get updated(){return[...F].map(U=>U.revived)},get removed(){return[...x].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class p extends h.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,F){return{...L,revived:d.TestItem.toPlain(L.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new C(this.changeEmitter)}}class m{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(F=>F.revived)},dispose:(0,g.createSingleCallFunction)(()=>{--L.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new p;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class b{#e;#t;get label(){return this._label}set label(L){L!==this._label&&(this._label=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(L){L!==this._supportsContinuousRun&&(this._supportsContinuousRun=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?d.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,F,x,U,N,z,V,ge=!1,te=void 0,q=!1){this.controllerId=x,this.profileId=U,this._label=N,this.kind=z,this.runHandler=V,this._isDefault=ge,this._tag=te,this._supportsContinuousRun=q,this.#e=L,this.#t=F,F.set(U,this);const K=D[z];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);this.#e.$publishTestRunProfile({profileId:U,controllerId:x,tag:te?d.TestTag.namespace(this.controllerId,te.id):null,label:N,group:K,isDefault:ge,hasConfigurationHandler:!1,supportsContinuousRun:q})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=b;const D={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(De[332],Ie([1,0,19,9,4,6,148,13,7]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class v{constructor(P,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new f.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new f.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new f.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new f.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new f.Emitter({onListenerError:O.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new f.Emitter({onListenerError:O.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=P.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(P){const E=this._extHostDocumentsAndEditors.allEditors();return P?E:E.map(S=>S.value)}async showTextDocument(P,E,S){let _;typeof E=="number"?_={position:g.ViewColumn.from(E),preserveFocus:S}:typeof E=="object"?_={position:g.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?g.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:_={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(P.uri,_),d=w&&this._extHostDocumentsAndEditors.getEditor(w);if(d)return d.value;throw w?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,E){return new T.TextEditorDecorationType(this._proxy,P,E).value}$acceptEditorPropertiesChanged(P,E){const S=this._extHostDocumentsAndEditors.getEditor(P);if(!S)throw new Error("unknown text editor");if(E.options&&S._acceptOptions(E.options),E.selections){const _=E.selections.selections.map(g.Selection.to);S._acceptSelections(_)}if(E.visibleRanges){const _=I.coalesce(E.visibleRanges.map(g.Range.to));S._acceptVisibleRanges(_)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...E.options,lineNumbers:g.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const _=y.TextEditorSelectionChangeKind.fromValue(E.selections.source),w=E.selections.selections.map(g.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:w,kind:_})}if(E.visibleRanges){const _=I.coalesce(E.visibleRanges.map(g.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:_})}}$acceptEditorPositionData(P){for(const E in P){const S=this._extHostDocumentsAndEditors.getEditor(E);if(!S)throw new Error("Unknown text editor");const _=g.ViewColumn.to(P[E]);S.value.viewColumn!==_&&(S._acceptViewColumn(_),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:_}))}}getDiffInformation(P){return Promise.resolve(this._proxy.$getDiffInformation(P))}}e.ExtHostEditors=v}),define(De[333],Ie([1,0,2,5,6,3,7,13,25,17]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,O.createDecorator)("IExtHostTimeline");class R{constructor(S,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(f.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:(w,d)=>{if(w&&w.$mid===12)if(this._providers.get(w.source)&&y.ExtensionIdentifier.equals(d,this._providers.get(w.source)?.extension)){const o=w.uri===void 0?void 0:I.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(P(o))?.get(w.handle)}else return;return w}})}async $getTimeline(S,_,w,d){return this._providers.get(S)?.provider.provideTimeline(I.URI.revive(_),w,d)}registerTimelineProvider(S,_,w,d){const o=new A.DisposableStore,u=this.convertTimelineItem(_.id,d,o).bind(this);let c;_.onDidChange&&(c=_.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:_.id}),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:S,onDidChange:void 0,async provideTimeline(a,t,i){t?.resetCache&&(o.clear(),h.get(_.id)?.clear());const s=await _.provideTimeline(a,t,i);if(s==null)return;const n=u(a,t);return{...s,source:_.id,items:s.items.map(n)}},dispose(){for(const a of h.values())a.get(_.id)?.clear();c?.dispose(),o.dispose()}},w)}convertTimelineItem(S,_,w){return(d,o)=>{let u;if(o?.cacheResults){let c=this._itemsBySourceAndUriMap.get(S);c===void 0&&(c=new Map,this._itemsBySourceAndUriMap.set(S,c));const h=P(d);u=c.get(h),u===void 0&&(u=new Map,c.set(h,u))}return c=>{const{iconPath:h,...a}=c,t=`${S}|${c.id??c.timestamp}`;u?.set(t,c);let i,s,n;c.iconPath&&(h instanceof T.ThemeIcon?n={id:h.id,color:h.color}:I.URI.isUri(h)?(i=h,s=h):{light:i,dark:s}=h);let r;return T.MarkdownString.isMarkdownString(a.tooltip)?r=g.MarkdownString.from(a.tooltip):(0,v.isString)(a.tooltip)?r=a.tooltip:T.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=g.MarkdownString.from(a.detail)):(0,v.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=a.detail),{...a,id:a.id??void 0,handle:t,source:S,command:c.command?_.toInternal(c.command,w):void 0,icon:i,iconDark:s,themeIcon:n,tooltip:r,accessibilityInformation:c.accessibilityInformation}}}}registerTimelineProviderCore(S,_){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,{provider:S,extension:_}),(0,A.toDisposable)(()=>{for(const d of this._itemsBySourceAndUriMap.values())d.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=R;function P(E){return E?.toString()}}),define(De[73],Ie([1,0,21,4,3,214,5,14,86,6,27,20,7]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class S extends y.DisposableTunnel{}var _;(function(d){function o(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:c.protocol}}d.fromApiTunnel=o;function u(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==y.TunnelPrivacyId.ConstantPrivate&&c.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}d.fromServiceTunnel=u})(_||(e.TunnelDtoConverter=_={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let w=class extends f.Disposable{constructor(o,u,c){super(),this.logService=c,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new O.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=o.getProxy(v.MainContext.MainThreadTunnelService)}async openTunnel(o,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const c=await this._proxy.$openTunnel(u,o.displayName);if(c){const h=new S(c.remoteAddress,c.localAddress,()=>this._proxy.$closeTunnel(c.remoteAddress));return this._register(h),h}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(o,u){const c=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(c,{selector:o,provider:u}),this._proxy.$registerPortsAttributesProvider(o,c),new E.Disposable(()=>{this._portAttributesProviders.delete(c),this._proxy.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(o,u,c,h,a){const t=[];for(const s of o){const n=this._portAttributesProviders.get(s);if(!n)return[];t.push(...await Promise.all(u.map(async r=>{let l;try{l=await n.provider.providePortAttributes({port:r,pid:c,commandLine:h},a)}catch{l=await n.provider.providePortAttributes(r,c,h,a)}return{providedAttributes:l,port:r}})))}const i=t.filter(s=>!!s.providedAttributes);return i.length>0?i.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,u){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(h,a)=>await o.provideTunnel(h,a,new I.CancellationTokenSource().token)??void 0;const c=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,privacyOptions:u.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(c),Promise.resolve((0,f.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,u){if(o){o.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this._showCandidatePort=o.showCandidatePort,this._proxy.$setCandidateFilter());const c=o.tunnelFactory??(u?this.makeManagedTunnelFactory(u):void 0);if(c){this._forwardPortProvider=c;let h=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(a)}}else this._forwardPortProvider=void 0;return(0,f.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(o){}async $closeTunnel(o,u){if(this._extensionTunnels.has(o.host)){const c=this._extensionTunnels.get(o.host);c.has(o.port)&&(u&&c.get(o.port).disposeListener.dispose(),await c.get(o.port).tunnel.dispose(),c.delete(o.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(o,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this._forwardPortProvider(o,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const h=await c;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),h===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(o.remoteAddress.host)||this._extensionTunnels.set(o.remoteAddress.host,new Map);const a=this._register(h.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(h.remoteAddress))));return this._extensionTunnels.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:h,disposeListener:a}),_.fromApiTunnel(h)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(o){const u=await Promise.all(o.map(h=>this._showCandidatePort(h.host,h.port,h.detail??""))),c=o.filter((h,a)=>u[a]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(h=>h.port).join(", ")} to ${c.map(h=>h.port).join(", ")}`),c}};e.ExtHostTunnelService=w,e.ExtHostTunnelService=w=je([$e(0,P.IExtHostRpcService),$e(1,R.IExtHostInitDataService),$e(2,g.ILogService)],w)}),define(De[334],Ie([1,0,3,18,2,6]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([O.Schemas.http,O.Schemas.https])}constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,v,R,P){if(this._openers.has(v))throw new Error(`Opener with id '${v}' already registered`);const E=P.schemes.find(S=>!T.supportedSchemes.has(S));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this._openers.set(v,R),this._proxy.$registerUriOpener(v,P.schemes,y,P.label),(0,I.toDisposable)(()=>{this._openers.delete(v),this._proxy.$unregisterUriOpener(v)})}async $canOpenUri(y,v,R){const P=this._openers.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const E=f.URI.revive(v);return P.canOpenExternalUri(E,R)}async $openUri(y,v,R){const P=this._openers.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(f.URI.revive(v.resolvedUri),{sourceUri:f.URI.revive(v.sourceUri)},R)}}e.ExtHostUriOpeners=T}),define(De[335],Ie([1,0,6,2,3,9,25]),function(pe,e,I,O,f,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class g{static{this.HandlePool=0}constructor(v){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=v.getProxy(I.MainContext.MainThreadUrls)}registerUriHandler(v,R){const P=v.identifier;if(this.handles.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const E=g.HandlePool++;return this.handles.add(P),this.handlers.set(E,R),this._proxy.$registerUriHandler(E,P,v.displayName||v.name),(0,f.toDisposable)(()=>{this.handles.delete(P),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(v,R){const P=this.handlers.get(v);if(!P)return Promise.resolve(void 0);try{P.handleUri(O.URI.revive(R))}catch(E){(0,A.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(v){return O.URI.revive(await this._proxy.$createAppUri(v))}}e.ExtHostUrls=g}),define(De[91],Ie([1,0,4,3,18,24,2,229,266,110,6]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class P{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(h,a,t,i,s,n,r){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new I.Emitter,this._onDidDispose=this.#d.event,this.#e=h,this.#t=a,this.#r=t,this.#u=i,this.#l=s,this.#n=n,this.#c=E(n),this.#h=S(n),this.#i=r}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return this.#a=!0,(0,v.asWebviewUri)(h,this.#u)}get cspSource(){const h=this.#n.extensionLocation;if(h.scheme===f.Schemas.https||h.scheme===f.Schemas.http){let a=h.toString();return a.endsWith("/")||(a+="/"),a+" "+v.webviewGenericCspSource}return v.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(h){this.assertNotDisposed(),this.#s!==h&&(this.#s=h,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(h)))}get options(){return this.assertNotDisposed(),this.#r}set options(h){this.assertNotDisposed(),A.equals(this.#r,h)||this.#t.$setOptions(this.#e,d(this.#n,this.#l,h)),this.#r=h}async postMessage(h){if(this.#o)return!1;const a=(0,y.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(h){if(!this.#h)return h;const a=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return h.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,s,n,r,l,k)=>{const C=T.URI.from({scheme:r||"file",path:decodeURIComponent(l)}),p=(0,v.asWebviewUri)(C,{isRemote:a,authority:t}).toString();return`${s}${p}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,s,n,r,l,k)=>{const C=T.URI.from({scheme:r||"file",path:decodeURIComponent(l)}),p=(0,v.asWebviewUri)(C,{isRemote:a,authority:t}).toString();return`${s}${p}${k}`})}}e.ExtHostWebview=P;function E(c){try{const h=(0,g.normalizeVersion)((0,g.parseVersion)(c.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=E;function S(c){try{const h=(0,g.normalizeVersion)((0,g.parseVersion)(c.engines.vscode));return h?h.majorBase<1||h.majorBase===1&&h.minorBase<60:!1}catch{return!1}}class _ extends O.Disposable{constructor(h,a,t,i,s){super(),this.remoteInfo=a,this.workspace=t,this._logService=i,this._deprecationService=s,this._webviews=new Map,this._webviewProxy=h.getProxy(R.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const h of this._webviews.values())h.dispose();this._webviews.clear()}$onMessage(h,a,t){const i=this.getWebview(h);if(i){const{message:s}=(0,y.deserializeWebviewMessage)(a,t.value);i._onMessageEmitter.fire(s)}}$onMissingCsp(h,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,a,t){const i=new P(h,this._webviewProxy,o(a),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(h,i);const s=i._onDidDispose(()=>{s.dispose(),this.deleteWebview(h)});return i}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=_;function w(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=w;function d(c,h,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||u(c,h)}}e.serializeWebviewOptions=d;function o(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(h=>T.URI.from(h))}}function u(c,h){return[...(h?.getWorkspaceFolders()||[]).map(a=>a.uri),c.extensionLocation]}}),define(De[336],Ie([1,0,21,52,3,18,23,2,13,91,107,6,7]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class S{constructor(i,s){this.document=i,this._storagePath=s,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,s){await this.getEdit(i).undo(),s||this.disposeBackup()}async redo(i,s){await this.getEdit(i).redo(),s||this.disposeBackup()}disposeEdits(i){for(const s of i)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=a(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const s=this._edits.get(i,0);if(!s)throw new Error("No edit found");return s}}class _{constructor(){this._documents=new Map}get(i,s){return this._documents.get(this.key(i,s))}add(i,s,n){const r=this.key(i,s.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${s.uri}`);const l=new S(s,n);return this._documents.set(r,l),l}delete(i,s){const n=this.key(i,s.uri);this._documents.delete(n)}key(i,s){return`${i}@@@${s}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class d{constructor(){this._providers=new Map}addTextProvider(i,s,n){return this.add(0,i,s,n)}addCustomProvider(i,s,n){return this.add(1,i,s,n)}get(i){return this._providers.get(i)}add(i,s,n,r){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:i,extension:n,provider:r}),new E.Disposable(()=>this._providers.delete(s))}}class o{constructor(i,s,n,r,l){this._extHostDocuments=s,this._extensionStoragePaths=n,this._extHostWebview=r,this._extHostWebviewPanels=l,this._editorProviders=new d,this._documents=new _,this._proxy=i.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,s,n,r){const l=new f.DisposableStore;return c(n)?(l.add(this._editorProviders.addTextProvider(s,i,n)),this._proxy.$registerTextEditorProvider((0,v.toExtensionData)(i),s,r.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,v.shouldSerializeBuffersForPostMessage)(i))):(l.add(this._editorProviders.addCustomProvider(s,i,n)),u(n)&&l.add(n.onDidChangeCustomDocument(k=>{const C=this.getCustomDocumentEntry(s,k.document.uri);if(h(k)){const p=C.addEdit(k);this._proxy.$onDidEdit(k.document.uri,s,p,k.label)}else this._proxy.$onContentChange(k.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,v.toExtensionData)(i),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,v.shouldSerializeBuffersForPostMessage)(i))),E.Disposable.from(l,new E.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(i,s,n,r,l){const k=this._editorProviders.get(s);if(!k)throw new Error(`No provider found for '${s}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${s}'`);const C=g.URI.revive(i),p=await k.provider.openCustomDocument(C,{backupId:n,untitledDocumentData:r?.buffer},l);let m;return u(k.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(k.extension)??this._extensionStoragePaths.globalValue(k.extension)),this._documents.add(s,p,m),{editable:u(k.provider)}}async $disposeCustomDocument(i,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=g.URI.revive(i),{document:l}=this.getCustomDocumentEntry(s,r);this._documents.delete(s,l),l.dispose()}async $resolveCustomEditor(i,s,n,r,l,k){const C=this._editorProviders.get(n);if(!C)throw new Error(`No provider found for '${n}'`);const p=y.ViewColumn.to(l),m=this._extHostWebview.createNewWebview(s,r.contentOptions,C.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(s,n,r.title,p,r.options,m,r.active),D=g.URI.revive(i);switch(C.type){case 1:{const{document:M}=this.getCustomDocumentEntry(n,D);return C.provider.resolveCustomEditor(M,b,k)}case 0:{const M=this._extHostDocuments.getDocument(D);return C.provider.resolveCustomTextEditor(M,b,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,s,n){this.getCustomDocumentEntry(s,i).disposeEdits(n)}async $onMoveCustomEditor(i,s,n){const r=this._editorProviders.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const l=this._extHostWebviewPanels.getWebviewPanel(i);if(!l)throw new Error("No webview found");const k=g.URI.revive(s),C=this._extHostDocuments.getDocument(k);await r.provider.moveCustomTextEditor(C,l,I.CancellationToken.None)}async $undo(i,s,n,r){return this.getCustomDocumentEntry(s,i).undo(n,r)}async $redo(i,s,n,r){return this.getCustomDocumentEntry(s,i).redo(n,r)}async $revert(i,s,n){const r=this.getCustomDocumentEntry(s,i);await this.getCustomEditorProvider(s).revertCustomDocument(r.document,n),r.disposeBackup()}async $onSave(i,s,n){const r=this.getCustomDocumentEntry(s,i);await this.getCustomEditorProvider(s).saveCustomDocument(r.document,n),r.disposeBackup()}async $onSaveAs(i,s,n,r){const l=this.getCustomDocumentEntry(s,i);return this.getCustomEditorProvider(s).saveCustomDocumentAs(l.document,g.URI.revive(n),r)}async $backup(i,s,n){const r=this.getCustomDocumentEntry(s,i),k=await this.getCustomEditorProvider(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},n);return r.updateBackup(k),k.id}getCustomDocumentEntry(i,s){const n=this._documents.get(i,g.URI.revive(s));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(i){const n=this._editorProviders.get(i)?.provider;if(!n||!u(n))throw new Error("Custom document is not editable");return n}}e.ExtHostCustomEditors=o;function u(t){return!!t.onDidChangeCustomDocument}function c(t){return typeof t.resolveCustomTextEditor=="function"}function h(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const i=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,O.hash)(i)+""}}),define(De[337],Ie([1,0,4,3,2,31,13,91,6,7]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class R extends O.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(_,w,d,o){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new I.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new I.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=_,this.#t=w,this.#u=d,this.#i=o.viewType,this.#l=o.panelOptions,this.#r=o.viewColumn,this.#n=o.title,this.#a=o.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(_){this.assertNotDisposed(),this.#n!==_&&(this.#n=_,this.#t.$setTitle(this.#e,_))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(_){this.assertNotDisposed(),this.#s!==_&&(this.#s=_,this.#t.$setIconPath(this.#e,f.URI.isUri(_)?{light:_,dark:_}:_))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(_){this.#c||(this.active!==_.active||this.visible!==_.visible||this.viewColumn!==_.viewColumn)&&(this.#a=_.active,this.#o=_.visible,this.#r=_.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(_,w){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof _>"u"?void 0:T.ViewColumn.from(_),preserveFocus:!!w})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class P extends O.Disposable{static newHandle(){return(0,A.generateUuid)()}constructor(_,w,d){super(),this.webviews=w,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(_=>_.dispose()),this._webviewPanels.clear()}createWebviewPanel(_,w,d,o,u={}){const c=typeof o=="object"?o.viewColumn:o,h={viewColumn:T.ViewColumn.from(c),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,g.shouldSerializeBuffersForPostMessage)(_),t=P.newHandle();this._proxy.$createWebviewPanel((0,g.toExtensionData)(_),t,w,{title:d,panelOptions:E(u),webviewOptions:(0,g.serializeWebviewOptions)(_,this.workspace,u),serializeBuffersForPostMessage:a},h);const i=this.webviews.createNewWebview(t,u,_);return this.createNewWebviewPanel(t,w,d,c,u,i,!0)}$onDidChangeWebviewPanelViewStates(_){const w=Object.keys(_);w.sort((d,o)=>{const u=_[d],c=_[o];return u.active?1:c.active?-1:+u.visible-+c.visible});for(const d of w){const o=this.getWebviewPanel(d);if(!o)continue;const u=_[d];o._updateViewState({active:u.active,visible:u.visible,viewColumn:T.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(_){this.getWebviewPanel(_)?.dispose(),this._webviewPanels.delete(_),this.webviews.deleteWebview(_)}registerWebviewPanelSerializer(_,w,d){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:d,extension:_}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,g.shouldSerializeBuffersForPostMessage)(_)}),new v.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(_,w,d,o){const u=this._serializers.get(w);if(!u)throw new Error(`No serializer found for '${w}'`);const{serializer:c,extension:h}=u,a=this.webviews.createNewWebview(_,d.webviewOptions,h),t=this.createNewWebviewPanel(_,w,d.title,o,d.panelOptions,a,d.active);await c.deserializeWebviewPanel(t,d.state)}createNewWebviewPanel(_,w,d,o,u,c,h){const a=new R(_,this._proxy,c,{viewType:w,title:d,viewColumn:o,panelOptions:u,active:h});return this._webviewPanels.set(_,a),a}getWebviewPanel(_){return this._webviewPanels.get(_)}}e.ExtHostWebviewPanels=P;function E(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(De[338],Ie([1,0,4,3,91,13,6,7]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends O.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(P,E,S,_,w,d){super(),this.#l=!1,this.#a=this._register(new I.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new I.Emitter),this.onDidDispose=this.#c.event,this.#i=S,this.#s=_,this.#e=P,this.#t=E,this.#u=w,this.#n=d}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(P){this.assertNotDisposed(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.assertNotDisposed(),this.#r}set description(P){this.assertNotDisposed(),this.#r!==P&&(this.#r=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#l||(this.#n=P,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(P){this.assertNotDisposed(),!(P?.value===this.#o?.value&&P?.tooltip===this.#o?.tooltip)&&(this.#o=A.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.assertNotDisposed(),this.#t.$show(this.#e,!!P)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class v{constructor(P,E){this._extHostWebview=E,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(P,E,S,_){if(this._viewProviders.has(E))throw new Error(`View provider for '${E}' already registered`);return this._viewProviders.set(E,{provider:S,extension:P}),this._proxy.$registerWebviewViewProvider((0,f.toExtensionData)(P),E,{retainContextWhenHidden:_?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.shouldSerializeBuffersForPostMessage)(P)}),new g.Disposable(()=>{this._viewProviders.delete(E),this._proxy.$unregisterWebviewViewProvider(E)})}async $resolveWebviewView(P,E,S,_,w){const d=this._viewProviders.get(E);if(!d)throw new Error(`No view provider found for '${E}'`);const{provider:o,extension:u}=d,c=this._extHostWebview.createNewWebview(P,{},u),h=new y(P,this._proxy,E,S,c,!0);this._webviewViews.set(P,h),await o.resolveWebviewView(h,{state:_},w)}async $onDidChangeWebviewViewVisibility(P,E){this.getWebviewView(P)._setVisible(E)}async $disposeWebviewView(P){const E=this.getWebviewView(P);this._webviewViews.delete(P),E.dispose(),this._extHostWebview.deleteWebview(P)}getWebviewView(P){const E=this._webviewViews.get(P);if(!E)throw new Error("No webview found");return E}}e.ExtHostWebviewViews=v}),define(De[151],Ie([1,0,4,6,2,18,15,5,20,26]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class{static{R=this}static{this.InitialState={focused:!0,active:!0}}getState(S){const _=this._state;return{get focused(){return _.focused},get active(){return(0,v.checkProposedApiEnabled)(S,"windowActivity"),_.active}}}constructor(S){this._onDidChangeWindowState=new I.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=R.InitialState,this._proxy=S.getProxy(O.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:_,isActive:w})=>{this.onDidChangeWindowProperty("focused",_),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,_){_!==this._state[S]&&(this._state={...this._state,[S]:_},this._onDidChangeWindowState.fire(this._state))}openUri(S,_){let w;if(typeof S=="string"){w=S;try{S=f.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,T.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,w,_)}async asExternalUri(S,_){if((0,T.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this._proxy.$asExternalUri(S,_);return f.URI.from(w)}};e.ExtHostWindow=P,e.ExtHostWindow=P=R=je([$e(0,y.IExtHostRpcService)],P),e.IExtHostWindow=(0,g.createDecorator)("IExtHostWindow")}),define(De[339],Ie([1,0,306,27,20]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let T=class extends I.AbstractExtHostConsoleForwarder{constructor(y,v){super(y,v),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(y,v,R){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,P.write(`
START_NATIVE_LOG
`),v.apply(console,R),P.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(y,v){const R=process[y],P=R.write;let E="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(S,_,w)=>{if(!this._isMakingConsoleCall){E+=S.toString(_);const d=E.length>A?E.length:E.lastIndexOf(`
`);d!==-1&&(console[v](E.slice(0,d)),E=E.slice(d+1))}P.call(R,S,_,w)}})}};e.ExtHostConsoleForwarder=T,e.ExtHostConsoleForwarder=T=je([$e(0,f.IExtHostRpcService),$e(1,O.IExtHostInitDataService)],T)}),define(De[340],Ie([1,0,72,18,14,241,30,12]),function(pe,e,I,O,f,A,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let y=class{constructor(P,E){P.addFileSystemProvider(O.Schemas.file,new v(E),{isCaseSensitive:g.isLinux})}};e.ExtHostDiskFileSystemProvider=y,e.ExtHostDiskFileSystemProvider=y=je([$e(0,I.IExtHostConsumerFileSystem),$e(1,f.ILogService)],y);class v{constructor(P){this.logService=P,this.impl=new A.DiskFileSystemProvider(this.logService)}async stat(P){const E=await this.impl.stat(P);return{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.impl.readdir(P)}createDirectory(P){return this.impl.mkdir(P)}readFile(P){return this.impl.readFile(P)}writeFile(P,E,S){return this.impl.writeFile(P,E,{...S,unlock:!1,atomic:!1})}delete(P,E){return this.impl.delete(P,{...E,useTrash:!1,atomic:!1})}rename(P,E,S){return this.impl.rename(P,E,S)}copy(P,E,S){return this.impl.copy(P,E,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,E){throw new Error("Method not implemented.")}}}),define(De[341],Ie([1,0,16,63,31,34,3,6,2,20]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends T.Disposable{constructor(E,S){super();const _=E.getProxy(g.MainContext.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async w=>{const d=y.URI.file((0,I.join)((0,O.tmpdir)(),(0,f.generateUuid)()));return await _.$download(w,d),d})}};e.ExtHostDownloadService=R,e.ExtHostDownloadService=R=je([$e(0,v.IExtHostRpcService),$e(1,A.IExtHostCommands)],R)}),define(De[342],Ie([1,0,150,18,243,31]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends I.ExtHostLoggerService{doCreateLogger(y,v,R){return y.scheme===O.Schemas.file?new f.SpdLogLogger(R?.name||(0,A.generateUuid)(),y.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,v):super.doCreateLogger(y,v,R)}registerLogger(y){super.registerLogger(y),this._proxy.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this._proxy.$deregisterLogger(y)}}e.ExtHostLoggerService=T}),define(De[343],Ie([1,0,53,16,2,90,3,18,8,29]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const i=await super._getWorkspaceStorageURI(t);if(i.scheme!==g.Schemas.file)return i;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${i.fsPath}.`),i;const s=i.fsPath;let n=0;do{let r;n===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${n}`:`${s}-${n}`,await P(r);const l=O.join(r,"vscode.lock"),k=await w(this._logService,l,!1);if(k)return this._workspaceStorageLock=k,process.on("exit",()=>{k.dispose()}),f.URI.file(r);n++}while(n<10);return i}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function P(a){try{await v.Promises.stat(a);return}catch{}try{await v.Promises.mkdir(a,{recursive:!0})}catch{}}const E=1e3,S=10*60*1e3;class _ extends T.Disposable{constructor(t,i){super(),this.logService=t,this.filename=i,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await d(t,i);(!s||s.pid!==process.pid)&&(t.info(`Lock '${i}': The lock was lost unexpectedly.`),this._timer.cancel());try{await v.Promises.utimes(i,new Date,new Date)}catch(n){t.error(n),t.info(`Lock '${i}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{I.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const i={pid:process.pid,willReleaseAt:Date.now()+t};await v.Promises.writeFile(this.filename,JSON.stringify(i),{flag:"w"})}catch(i){this.logService.error(i)}}}async function w(a,t,i){try{const n={pid:process.pid,willReleaseAt:0};await v.Promises.writeFile(t,JSON.stringify(n),{flag:"wx"})}catch(n){a.error(n)}const s=await d(a,t);return!s||s.pid!==process.pid?i?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),c(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new _(a,t))}async function d(a,t){let i;try{i=await v.Promises.readFile(t)}catch(s){return a.error(s),null}try{return JSON.parse(String(i))}catch(s){return a.error(s),null}}async function o(a,t){let i;try{i=await v.Promises.stat(t)}catch(s){return a.error(s),0}return i.mtime.getTime()}function u(a){try{return process.kill(a,0),!0}catch{return!1}}async function c(a,t){const i=await d(a,t);if(!i)return a.info(`Lock '${t}': Could not read pid of lock holder.`),h(a,t);if(i.willReleaseAt){let k=i.willReleaseAt-Date.now();if(k<5e3){for(k>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,y.timeout)(Math.min(100,k)),await o(a,t)===0)return h(a,t);k=i.willReleaseAt-Date.now()}return h(a,t)}}if(!u(i.pid))return a.info(`Lock '${t}': The pid ${i.pid} appears to be gone.`),h(a,t);const s=await o(a,t),n=Date.now()-s;if(n<=S)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const r=await o(a,t),l=Date.now()-r;return l<=S?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),h(a,t))}async function h(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await v.Promises.unlink(t)}catch{}return w(a,t,!0)}}),define(De[344],Ie([1,0,31,20,45,34]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let T=class extends f.BaseExtHostTerminalService{constructor(y,v){super(!0,y,v)}createTerminal(y,v,R){return this.createTerminalFromOptions({name:y,shellPath:v,shellArgs:R})}createTerminalFromOptions(y,v){const R=new f.ExtHostTerminal(this._proxy,(0,I.generateUuid)(),y,y.name);return this._terminals.push(R),R.create(y,this._serializeParentTerminal(y,v)),R.value}};e.ExtHostTerminalService=T,e.ExtHostTerminalService=T=je([$e(0,A.IExtHostCommands),$e(1,O.IExtHostRpcService)],T)}),define(De[345],Ie([1,0,8,22,21,9,4,3,128,294,69]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(b,D){try{return JSON.stringify(b,D)}catch{return"null"}}const S="$$ref$$",_={[S]:-1};class w{constructor(D,M){this.jsonString=D,this.referencedBuffers=M}}function d(b,D=null,M=!1){const L=[];return{jsonString:(M?E:JSON.stringify)(b,(x,U)=>{if(typeof U>"u")return _;if(typeof U=="object"){if(U instanceof O.VSBuffer){const N=L.push(U)-1;return{[S]:N}}if(D)return D(x,U)}return U}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=d;function o(b,D,M){return JSON.parse(b,(L,F)=>{if(F){const x=F[S];if(typeof x=="number")return D[x];if(M&&F.$mid===1)return M.transformIncoming(F)}return F})}e.parseJsonAndRestoreBufferRefs=o;function u(b,D){return JSON.stringify(b,D)}function c(b){return b?(D,M)=>M&&M.$mid===1?b.transformOutgoing(M):M:null}var h;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(h||(e.RequestInitiator=h={}));var a;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},i=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class n extends g.Disposable{static{P=i}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(D,M=null,L=null){super(),this[P]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=D,this._logger=M,this._uriTransformer=L,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let F=0,x=R.ProxyIdentifier.count;F<x;F++)this._locals[F]=null,this._proxies[F]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new I.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(F=>this._receiveOneMessage(F))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(D=>{const M=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],M.resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(D){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(D){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(D){this._responsiveState!==D&&(this._responsiveState=D,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(D){return this._uriTransformer?(0,y.transformIncomingURIs)(D,this._uriTransformer):D}getProxy(D){const{nid:M,sid:L}=D;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,L)),this._proxies[M]}_createProxy(D,M){const L={get:(F,x)=>(typeof x=="string"&&!F[x]&&x.charCodeAt(0)===36&&(F[x]=(...U)=>this._remoteCall(D,x,U)),x===s?M:F[x])};return new Proxy(Object.create(null),L)}set(D,M){return this._locals[D.nid]=M,M}assertRegistered(D){for(let M=0,L=D.length;M<L;M++){const F=D[M];if(!this._locals[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}_receiveOneMessage(D){if(this._isDisposed)return;const M=D.byteLength,L=l.read(D,0),F=L.readUInt8(),x=L.readUInt32();switch(F){case 1:case 2:{let{rpcId:U,method:N,args:z}=C.deserializeRequestJSONArgs(L);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(M,x,U,N,z,F===2);break}case 3:case 4:{let{rpcId:U,method:N,args:z}=C.deserializeRequestMixedArgs(L);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(M,x,U,N,z,F===4);break}case 5:{this._logger?.logIncoming(M,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(M,x);break}case 7:{this._receiveReply(M,x,void 0);break}case 9:{let U=C.deserializeReplyOKJSON(L);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(M,x,U);break}case 10:{const U=C.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(M,x,U);break}case 8:{const U=C.deserializeReplyOKVSBuffer(L);this._receiveReply(M,x,U);break}case 11:{let U=C.deserializeReplyErrError(L);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(M,x,U);break}case 12:{this._receiveReplyErr(M,x,void 0);break}default:console.error("received unexpected message"),console.error(D)}}_receiveRequest(D,M,L,F,x,U){this._logger?.logIncoming(D,M,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(L)}.${F}(`,x);const N=String(M);let z,V;if(U){const te=new f.CancellationTokenSource;x.push(te.token),z=this._invokeHandler(L,F,x),V=()=>te.cancel()}else z=this._invokeHandler(L,F,x),V=t;this._cancelInvokedHandlers[N]=V;const ge=C.serializeAcknowledged(M);this._logger?.logOutgoing(ge.byteLength,M,1,"ack"),this._protocol.send(ge),z.then(te=>{delete this._cancelInvokedHandlers[N];const q=C.serializeReplyOK(M,te,this._uriReplacer);this._logger?.logOutgoing(q.byteLength,M,1,"reply:",te),this._protocol.send(q)},te=>{delete this._cancelInvokedHandlers[N];const q=C.serializeReplyErr(M,te);this._logger?.logOutgoing(q.byteLength,M,1,"replyErr:",te),this._protocol.send(q)})}_receiveCancel(D,M){this._logger?.logIncoming(D,M,1,"receiveCancel");const L=String(M);this._cancelInvokedHandlers[L]?.()}_receiveReply(D,M,L){this._logger?.logIncoming(D,M,0,"receiveReply:",L);const F=String(M);if(!this._pendingRPCReplies.hasOwnProperty(F))return;const x=this._pendingRPCReplies[F];delete this._pendingRPCReplies[F],x.resolveOk(L)}_receiveReplyErr(D,M,L){this._logger?.logIncoming(D,M,0,"receiveReplyErr:",L);const F=String(M);if(!this._pendingRPCReplies.hasOwnProperty(F))return;const x=this._pendingRPCReplies[F];delete this._pendingRPCReplies[F];let U;L&&(L.$isError?(U=new Error,U.name=L.name,U.message=L.message,U.stack=L.stack):U=L),x.resolveErr(U)}_invokeHandler(D,M,L){try{return Promise.resolve(this._doInvokeHandler(D,M,L))}catch(F){return Promise.reject(F)}}_doInvokeHandler(D,M,L){const F=this._locals[D];if(!F)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(D));const x=F[M];if(typeof x!="function")throw new Error("Unknown method "+M+" on actor "+(0,R.getStringIdentifierForProxy)(D));return x.apply(F,L)}_remoteCall(D,M,L){if(this._isDisposed)return new v.CanceledLazyPromise;let F=null;if(L.length>0&&f.CancellationToken.isCancellationToken(L[L.length-1])&&(F=L.pop()),F&&F.isCancellationRequested)return Promise.reject(A.canceled());const x=C.serializeRequestArguments(L,this._uriReplacer),U=++this._lastMessageId,N=String(U),z=new v.LazyPromise,V=new g.DisposableStore;F&&V.add(F.onCancellationRequested(()=>{const te=C.serializeCancel(U);this._logger?.logOutgoing(te.byteLength,U,0,"cancel"),this._protocol.send(C.serializeCancel(U))})),this._pendingRPCReplies[N]=new r(z,V),this._onWillSendRequest(U);const ge=C.serializeRequest(U,D,M,x,!!F);return this._logger?.logOutgoing(ge.byteLength,U,0,`request: ${(0,R.getStringIdentifierForProxy)(D)}.${M}(`,L),this._protocol.send(ge),z}}e.RPCProtocol=n;class r{constructor(D,M){this._promise=D,this._disposable=M}resolveOk(D){this._promise.resolveOk(D),this._disposable.dispose()}resolveErr(D){this._promise.resolveErr(D),this._disposable.dispose()}}class l{static alloc(D,M,L){const F=new l(O.VSBuffer.alloc(L+1+4),0);return F.writeUInt8(D),F.writeUInt32(M),F}static read(D,M){return new l(D,M)}get buffer(){return this._buff}constructor(D,M){this._buff=D,this._offset=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(D){this._buff.writeUInt8(D,this._offset),this._offset+=1}readUInt8(){const D=this._buff.readUInt8(this._offset);return this._offset+=1,D}writeUInt32(D){this._buff.writeUInt32BE(D,this._offset),this._offset+=4}readUInt32(){const D=this._buff.readUInt32BE(this._offset);return this._offset+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this._buff.writeUInt8(D.byteLength,this._offset),this._offset+=1,this._buff.set(D,this._offset),this._offset+=D.byteLength}readShortString(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,L}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readLongString(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,L}writeBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readVSBuffer(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+D);return this._offset+=D,M}static sizeMixedArray(D){let M=0;M+=1;for(let L=0,F=D.length;L<F;L++){const x=D[L];switch(M+=1,x.type){case 1:M+=this.sizeLongString(x.value);break;case 2:M+=this.sizeVSBuffer(x.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(x.value);for(let U=0;U<x.buffers.length;++U)M+=this.sizeVSBuffer(x.buffers[U]);break;case 4:break}}return M}writeMixedArray(D){this._buff.writeUInt8(D.length,this._offset),this._offset+=1;for(let M=0,L=D.length;M<L;M++){const F=D[M];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let x=0;x<F.buffers.length;++x)this.writeBuffer(F.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(D);for(let L=0;L<D;L++)switch(this.readUInt8()){case 1:M[L]=this.readLongString();break;case 2:M[L]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),U=this.readLongString(),N=[];for(let z=0;z<x;++z)N.push(this.readVSBuffer());M[L]=new R.SerializableObjectWithBuffers(o(U,N,null));break}case 4:M[L]=void 0;break}return M}}var k;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(k||(k={}));class C{static _useMixedArgSerialization(D){for(let M=0,L=D.length;M<L;M++)if(D[M]instanceof O.VSBuffer||D[M]instanceof R.SerializableObjectWithBuffers||typeof D[M]>"u")return!0;return!1}static serializeRequestArguments(D,M){if(this._useMixedArgSerialization(D)){const L=[];for(let F=0,x=D.length;F<x;F++){const U=D[F];if(U instanceof O.VSBuffer)L[F]={type:2,value:U};else if(typeof U>"u")L[F]={type:4};else if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:z}=d(U.value,M);L[F]={type:3,value:O.VSBuffer.fromString(N),buffers:z}}else L[F]={type:1,value:O.VSBuffer.fromString(u(U,M))}}return{type:1,args:L}}return{type:0,args:u(D,M)}}static serializeRequest(D,M,L,F,x){switch(F.type){case 0:return this._requestJSONArgs(D,M,L,F.args,x);case 1:return this._requestMixedArgs(D,M,L,F.args,x)}}static _requestJSONArgs(D,M,L,F,x){const U=O.VSBuffer.fromString(L),N=O.VSBuffer.fromString(F);let z=0;z+=l.sizeUInt8(),z+=l.sizeShortString(U),z+=l.sizeLongString(N);const V=l.alloc(x?2:1,D,z);return V.writeUInt8(M),V.writeShortString(U),V.writeLongString(N),V.buffer}static deserializeRequestJSONArgs(D){const M=D.readUInt8(),L=D.readShortString(),F=D.readLongString();return{rpcId:M,method:L,args:JSON.parse(F)}}static _requestMixedArgs(D,M,L,F,x){const U=O.VSBuffer.fromString(L);let N=0;N+=l.sizeUInt8(),N+=l.sizeShortString(U),N+=l.sizeMixedArray(F);const z=l.alloc(x?4:3,D,N);return z.writeUInt8(M),z.writeShortString(U),z.writeMixedArray(F),z.buffer}static deserializeRequestMixedArgs(D){const M=D.readUInt8(),L=D.readShortString(),F=D.readMixedArray(),x=new Array(F.length);for(let U=0,N=F.length;U<N;U++){const z=F[U];typeof z=="string"?x[U]=JSON.parse(z):x[U]=z}return{rpcId:M,method:L,args:x}}static serializeAcknowledged(D){return l.alloc(5,D,0).buffer}static serializeCancel(D){return l.alloc(6,D,0).buffer}static serializeReplyOK(D,M,L){if(typeof M>"u")return this._serializeReplyOKEmpty(D);if(M instanceof O.VSBuffer)return this._serializeReplyOKVSBuffer(D,M);if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:x}=d(M.value,L,!0);return this._serializeReplyOKJSONWithBuffers(D,F,x)}else return this._serializeReplyOKJSON(D,E(M,L))}static _serializeReplyOKEmpty(D){return l.alloc(7,D,0).buffer}static _serializeReplyOKVSBuffer(D,M){let L=0;L+=l.sizeVSBuffer(M);const F=l.alloc(8,D,L);return F.writeVSBuffer(M),F.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static _serializeReplyOKJSON(D,M){const L=O.VSBuffer.fromString(M);let F=0;F+=l.sizeLongString(L);const x=l.alloc(9,D,F);return x.writeLongString(L),x.buffer}static _serializeReplyOKJSONWithBuffers(D,M,L){const F=O.VSBuffer.fromString(M);let x=0;x+=l.sizeUInt32,x+=l.sizeLongString(F);for(const N of L)x+=l.sizeVSBuffer(N);const U=l.alloc(10,D,x);U.writeUInt32(L.length),U.writeLongString(F);for(const N of L)U.writeBuffer(N);return U.buffer}static deserializeReplyOKJSON(D){const M=D.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(D,M){const L=D.readUInt32(),F=D.readLongString(),x=[];for(let U=0;U<L;++U)x.push(D.readVSBuffer());return new R.SerializableObjectWithBuffers(o(F,x,M))}static serializeReplyErr(D,M){const L=M?E(A.transformErrorForSerialization(M),null):void 0;if(typeof L!="string")return this._serializeReplyErrEmpty(D);const F=O.VSBuffer.fromString(L);let x=0;x+=l.sizeLongString(F);const U=l.alloc(11,D,x);return U.writeLongString(F),U.buffer}static deserializeReplyErrError(D){const M=D.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(D){return l.alloc(12,D,0).buffer}}var p;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var m;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(m||(m={}))}),define(De[346],Ie([1,0,4,43,42,5]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new f.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new f.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new f.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var T;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.channels=new Map,this._onDidRegisterChannel=new I.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new I.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(v){this.channels.has(v.id)||(this.channels.set(v.id,v),this._onDidRegisterChannel.fire(v.id))}getChannels(){const v=[];return this.channels.forEach(R=>v.push(R)),v}getChannel(v){return this.channels.get(v)}removeChannel(v){this.channels.delete(v),this._onDidRemoveChannel.fire(v)}}O.Registry.add(e.Extensions.OutputChannels,new g),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new f.RawContextKey("activeOutputChannel","")}),define(De[152],Ie([1,0,6,5,20,25,14,346,72,27,55,178,22,17,30,4,3]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(a,t,i,s,n){super(),this.id=a,this.name=t,this.logger=i,this.proxy=s,this.extension=n,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(i.getLevel()),this._register(i.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.offset;this.logger.flush(),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.offset;this.info(a),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(a,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.proxy.$close(this.id)}log(a,t){this.offset+=E.VSBuffer.fromString(t).byteLength,(0,T.log)(this.logger,a,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class u extends o{appendLine(a){this.append(a)}}let c=class{constructor(a,t,i,s,n,r){this.initData=t,this.extHostFileSystem=i,this.extHostFileSystemInfo=s,this.loggerService=n,this.logService=r,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=a.getProxy(I.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.visibleChannelId=a;for(const[t,i]of this.channels)i.visible=t===this.visibleChannelId}createOutputChannel(a,t,i){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,n=(0,S.isString)(t)?t:void 0;if((0,S.isString)(n)&&!n.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const l=this.initData.environment.extensionLogLevel?.find(([C])=>A.ExtensionIdentifier.equals(i.identifier,C))?.[1];l&&(r=(0,T.parseLogLevel)(l));const k=s?this.doCreateLogOutputChannel(a,r,i):this.doCreateOutputChannel(a,n,i);return k.then(C=>{this.channels.set(C.id,C),C.visible=C.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(a,r??this.logService.getLevel(),k):this.createExtHostOutputChannel(a,k)}async doCreateOutputChannel(a,t,i){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,n=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(n,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.proxy.$register(a,n,t,i.identifier.value);return new o(l,a,r,this.proxy,i)}async doCreateLogOutputChannel(a,t,i){const s=await this.createExtensionLogDirectory(i),n=a.replace(/[\\/:\*\?"<>\|]/g,""),r=this.extHostFileSystemInfo.extUri.joinPath(s,`${n}.log`),l=`${i.identifier.value}.${n}`,k=this.loggerService.createLogger(r,{id:l,name:a,logLevel:t,extensionId:i.identifier.value});return new u(l,a,k,this.proxy,i)}createExtensionLogDirectory(a){let t=this.extensionLogDirectoryPromise.get(a.identifier.value);if(!t){const i=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,a.identifier.value);this.extensionLogDirectoryPromise.set(a.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(i)}catch(s){if((0,_.toFileSystemProviderErrorCode)(s)!==_.FileSystemProviderErrorCode.FileExists)throw s}return i})())}return t}createExtHostOutputChannel(a,t){let i=!1;const s=()=>{if(i)throw new Error("Channel has been closed")};return{get name(){return a},append(n){s(),t.then(r=>r.append(n))},appendLine(n){s(),t.then(r=>r.appendLine(n))},clear(){s(),t.then(n=>n.clear())},replace(n){s(),t.then(r=>r.replace(n))},show(n,r){s(),t.then(l=>l.show(n,r))},hide(){s(),t.then(n=>n.hide())},dispose(){i=!0,t.then(n=>n.dispose())}}}createExtHostLogOutputChannel(a,t,i){const s=new d.DisposableStore,n=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},r=s.add(new w.Emitter);function l(k){t=k,r.fire(k)}return i.then(k=>{s.add(k),k.logLevel!==t&&l(k.logLevel),s.add(k.onDidChangeLogLevel(C=>l(C)))}),{...this.createExtHostOutputChannel(a,i),get logLevel(){return t},onDidChangeLogLevel:r.event,trace(k,...C){n(),i.then(p=>p.trace(k,...C))},debug(k,...C){n(),i.then(p=>p.debug(k,...C))},info(k,...C){n(),i.then(p=>p.info(k,...C))},warn(k,...C){n(),i.then(p=>p.warn(k,...C))},error(k,...C){n(),i.then(p=>p.error(k,...C))},dispose(){s.dispose()}}}};e.ExtHostOutputService=c,e.ExtHostOutputService=c=je([$e(0,f.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,y.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,T.ILoggerService),$e(5,T.ILogService)],c),e.IExtHostOutputService=(0,O.createDecorator)("IExtHostOutputService")}),define(De[347],Ie([1,0,5,8]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let A=1/0;for(let g=0;g<this.maxSampleCount;g++){const y=await f.getRoundTripTime();if(y===void 0)return;A=Math.min(A,y/2),await(0,O.timeout)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(A):T=this.initial.reduce((g,y)=>g+y,0)/this.initial.length,this.lastMeasurement={initial:T,current:A,average:this.average.reduce((g,y)=>g+y,0)/this.average.length,high:(()=>typeof T>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[348],Ie([1,0,33,18,16,12,23,2,5,259,44,144,347]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let _=S=class{constructor(d,o,u,c){this.localUserHome=d,this.remoteAgentService=o,this.environmentService=u,this.contextService=c,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=h?.userHome??d})()}hasValidBasename(d,o,u){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(c=>this.doHasValidBasename(d,c,o)):this.doHasValidBasename(d,o,u)}doHasValidBasename(d,o,u){return d.scheme===O.Schemas.file||d.scheme===O.Schemas.vscodeRemote?(0,I.isValidBasename)(u??(0,T.basename)(d),o===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,o){if(d.remoteAuthority)return O.Schemas.vscodeRemote;const u=(0,v.getVirtualWorkspaceScheme)(o.getWorkspace());if(u)return u;const c=o.getWorkspace().folders[0];if(c)return c.uri.scheme;const h=o.getWorkspace().configuration;return h?h.scheme:O.Schemas.file}userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?f.win32:f.posix)}async fileURI(d){let o="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const c=d.indexOf("/",2);c===-1?(o=d.substring(2),d="/"):(o=d.substring(2,c),d=d.substring(c)||"/")}return g.URI.from({scheme:O.Schemas.file,authority:o,path:d,query:"",fragment:""})}};e.AbstractPathService=_,e.AbstractPathService=_=S=je([$e(1,E.IRemoteAgentService),$e(2,P.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],_)}),define(De[349],Ie([1,0,226,19,57,4,52,3,2,50,231,14,65,261,86,44,144,26,21,17,24,42]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.isCandidatePort=e.OnPortForward=e.makeAddress=e.mapHasAddressLocalhostOrAllInterfaces=e.mapHasAddress=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.parseAddress=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0;const t=10*1e3,i="remote.tunnels.toRestore";e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new a.RawContextKey("forwardedPortsViewEnabled",!1,I.localize(0,null));function s(M){const L=M.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(L)return{host:L[1]?.substring(0,L[1].length-1)||"localhost",port:Number(L[2])}}e.parseAddress=s;var n;(function(M){M.Other="Other",M.User="User",M.AutoForwardEnd="AutoForwardEnd"})(n||(e.TunnelCloseReason=n={}));var r;(function(M){M[M.User=0]="User",M[M.Auto=1]="Auto",M[M.Extension=2]="Extension"})(r||(e.TunnelSource=r={})),e.UserTunnelSource={source:r.User,description:I.localize(1,null)},e.AutoTunnelSource={source:r.Auto,description:I.localize(2,null)};function l(M,L,F){const x=M.get(C(L,F));if(x)return x;if((0,_.isLocalhost)(L))for(const U of _.LOCALHOST_ADDRESSES){const N=C(U,F);if(M.has(N))return M.get(N)}else if((0,_.isAllInterfaces)(L))for(const U of _.ALL_INTERFACES_ADDRESSES){const N=C(U,F);if(M.has(N))return M.get(N)}}e.mapHasAddress=l;function k(M,L,F){const x=l(M,L,F);if(x)return x;const U=(0,_.isAllInterfaces)(L)?"localhost":(0,_.isLocalhost)(L)?"0.0.0.0":void 0;if(U)return l(M,U,F)}e.mapHasAddressLocalhostOrAllInterfaces=k;function C(M,L){return M+":"+L}e.makeAddress=C;var p;(function(M){M.Notify="notify",M.OpenBrowser="openBrowser",M.OpenBrowserOnce="openBrowserOnce",M.OpenPreview="openPreview",M.Silent="silent",M.Ignore="ignore"})(p||(e.OnPortForward=p={}));function m(M){return M&&"host"in M&&typeof M.host=="string"&&"port"in M&&typeof M.port=="number"&&(!("detail"in M)||typeof M.detail=="string")&&(!("pid"in M)||typeof M.pid=="string")}e.isCandidatePort=m;class b extends g.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(L){super(),this.configurationService=L,this.portsAttributes=[],this._onDidChangeAttributes=new A.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(L.onDidChangeConfiguration(F=>{(F.affectsConfiguration(b.SETTING)||F.affectsConfiguration(b.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(L,F,x){let U=this.findNextIndex(L,F,x,this.portsAttributes,0);const N={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;U>=0;){const z=this.portsAttributes[U];z.key===L?(N.onAutoForward=z.onAutoForward??N.onAutoForward,N.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:N.elevateIfNeeded,N.label=z.label??N.label,N.requireLocalPort=z.requireLocalPort,N.protocol=z.protocol):(N.onAutoForward=N.onAutoForward??z.onAutoForward,N.elevateIfNeeded=N.elevateIfNeeded!==void 0?N.elevateIfNeeded:z.elevateIfNeeded,N.label=N.label??z.label,N.requireLocalPort=N.requireLocalPort!==void 0?N.requireLocalPort:void 0,N.protocol=N.protocol??z.protocol),U=this.findNextIndex(L,F,x,this.portsAttributes,U+1)}return N.onAutoForward!==void 0||N.elevateIfNeeded!==void 0||N.label!==void 0||N.requireLocalPort!==void 0||N.protocol!==void 0?N:this.getOtherAttributes()}hasStartEnd(L){return L.start!==void 0&&L.end!==void 0}hasHostAndPort(L){return L.host!==void 0&&L.port!==void 0&&(0,c.isString)(L.host)&&(0,c.isNumber)(L.port)}findNextIndex(L,F,x,U,N){if(N>=U.length)return-1;const z=!(0,_.isLocalhost)(F)&&!(0,_.isAllInterfaces)(F),ge=U.slice(N).findIndex(te=>(0,c.isNumber)(te.key)?z?!1:te.key===L:this.hasStartEnd(te.key)?z?!1:L>=te.key.start&&L<=te.key.end:this.hasHostAndPort(te.key)?L===te.key.port&&F===te.key.host:x?te.key.test(x):!1);return ge>=0?ge+N:-1}readSetting(){const L=this.configurationService.getValue(b.SETTING);if(!L||!(0,c.isObject)(L))return[];const F=[];for(const U in L){if(U===void 0)continue;const N=L[U];let z;if(Number(U))z=Number(U);else if((0,c.isString)(U))if(b.RANGE.test(U)){const V=U.match(b.RANGE);z={start:Number(V[1]),end:Number(V[2])}}else if(b.HOST_AND_PORT.test(U)){const V=U.match(b.HOST_AND_PORT);z={host:V[1],port:Number(V[2])}}else{let V;try{V=RegExp(U)}catch{}V&&(z=V)}z&&F.push({key:z,elevateIfNeeded:N.elevateIfNeeded,onAutoForward:N.onAutoForward,label:N.label,requireLocalPort:N.requireLocalPort,protocol:N.protocol})}const x=this.configurationService.getValue(b.DEFAULTS);return x&&(this.defaultPortAttributes={elevateIfNeeded:x.elevateIfNeeded,label:x.label,onAutoForward:x.onAutoForward,requireLocalPort:x.requireLocalPort,protocol:x.protocol}),this.sortAttributes(F)}sortAttributes(L){function F(x,U){return(0,c.isNumber)(x.key)?x.key:U.hasStartEnd(x.key)?x.key.start:U.hasHostAndPort(x.key)?x.key.port:Number.MAX_VALUE}return L.sort((x,U)=>F(x,this)-F(U,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(L){switch(L){case _.ProvidedOnAutoForward.Notify:return p.Notify;case _.ProvidedOnAutoForward.OpenBrowser:return p.OpenBrowser;case _.ProvidedOnAutoForward.OpenBrowserOnce:return p.OpenBrowserOnce;case _.ProvidedOnAutoForward.OpenPreview:return p.OpenPreview;case _.ProvidedOnAutoForward.Silent:return p.Silent;case _.ProvidedOnAutoForward.Ignore:return p.Ignore;default:return}}async addAttributes(L,F,x){const N=this.configurationService.inspect(b.SETTING).userRemoteValue;let z;!N||!(0,c.isObject)(N)?z={}:z=(0,h.deepClone)(N),z[`${L}`]||(z[`${L}`]={});for(const V in F)z[`${L}`][V]=F[V];return this.configurationService.updateValue(b.SETTING,z,x)}}e.PortsAttributes=b;let D=class extends g.Disposable{constructor(L,F,x,U,N,z,V,ge,te,q){super(),this.tunnelService=L,this.storageService=F,this.configurationService=x,this.environmentService=U,this.remoteAuthorityResolverService=N,this.workspaceContextService=z,this.logService=V,this.dialogService=ge,this.extensionService=te,this.contextKeyService=q,this.inProgress=new Map,this._onForwardPort=new A.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new A.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new A.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new A.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new A.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new A.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new b(x),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async K=>{const ue=await this.getAttributes(K.map(ie=>({port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost})));for(const ie of K)if(ie.localAddress){const ce=C(ie.tunnelRemoteHost,ie.tunnelRemotePort),Se=k(this._candidates??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort);this.forwarded.set(ce,{remotePort:ie.tunnelRemotePort,remoteHost:ie.tunnelRemoteHost,localAddress:ie.localAddress,protocol:ue?.get(ie.tunnelRemotePort)?.protocol??_.TunnelProtocol.Http,localUri:await this.makeLocalUri(ie.localAddress,ue?.get(ie.tunnelRemotePort)),localPort:ie.tunnelLocalPort,runningProcess:Se?.detail,hasRunningProcess:!!Se,pid:Se?.pid,privacy:ie.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(ce,ie)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async K=>{const ue=C(K.tunnelRemoteHost,K.tunnelRemotePort);if(!k(this.forwarded,K.tunnelRemoteHost,K.tunnelRemotePort)&&!k(this.detected,K.tunnelRemoteHost,K.tunnelRemotePort)&&!k(this.inProgress,K.tunnelRemoteHost,K.tunnelRemotePort)&&K.localAddress){const ie=k(this._candidates??new Map,K.tunnelRemoteHost,K.tunnelRemotePort),ce=(await this.getAttributes([{port:K.tunnelRemotePort,host:K.tunnelRemoteHost}]))?.get(K.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:K.tunnelRemoteHost,remotePort:K.tunnelRemotePort,localAddress:K.localAddress,protocol:ce?.protocol??_.TunnelProtocol.Http,localUri:await this.makeLocalUri(K.localAddress,ce),localPort:K.tunnelLocalPort,closeable:!0,runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,privacy:K.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(ue,K),this._onForwardPort.fire(this.forwarded.get(ue))})),this._register(this.tunnelService.onTunnelClosed(K=>this.onTunnelClosed(K,n.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(L=>L.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const L=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&L.dispose()}))}async onTunnelClosed(L,F){const x=C(L.host,L.port);this.forwarded.has(x)&&(this.forwarded.delete(x),await this.storeForwarded(),this._onClosePort.fire(L))}makeLocalUri(L,F){if(L.startsWith("http"))return y.URI.parse(L);const x=F?.protocol??"http";return y.URI.parse(`${x}://${L}`)}async getStorageKey(){const L=this.workspaceContextService.getWorkspace(),F=L.configuration?(0,T.hash)(L.configuration.path):L.folders.length>0?(0,T.hash)(L.folders[0].uri.path):void 0;if(F===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${i}.${this.environmentService.remoteAuthority}.${F}`}async getTunnelRestoreValue(){const L=this.storageService.get(i,1);if(L)return this.storageService.remove(i,1),await this.storeForwarded(),L;const F=await this.getStorageKey();if(F)return this.storageService.get(F,0)}async restoreForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const L=await this.tunnelRestoreValue;if(L&&L!==this.knownPortsRestoreValue){const F=JSON.parse(L)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(x=>x.remotePort).join(", ")}`);for(const x of F){const U=k(this.detected,x.remoteHost,x.remotePort);x.source.source!==r.Extension&&!U||x.source.source===r.Extension&&U?await this.doForward({remote:{host:x.remoteHost,port:x.remotePort},local:x.localPort,name:x.name,privacy:x.privacy,elevateIfNeeded:!0,source:x.source}):x.source.source===r.Extension&&!U&&this.unrestoredExtensionTunnels.set(C(x.remoteHost,x.remotePort),x)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const L=await this.getStorageKey();this.restoreListener=this._register(new g.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(0,void 0,this.restoreListener)(async F=>{F.key===L&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(L,0)),await this.restoreForwarded())}))}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const L=JSON.stringify(Array.from(this.forwarded.values()));if(L!==this.knownPortsRestoreValue){this.knownPortsRestoreValue=L;const F=await this.getStorageKey();F&&this.storageService.store(F,this.knownPortsRestoreValue,0,0)}}}async showPortMismatchModalIfNeeded(L,F,x){if(!L.tunnelLocalPort||!x?.requireLocalPort||L.tunnelLocalPort===F)return;const U=new Date;if(this.mismatchCooldown.getTime()+t>U.getTime())return;this.mismatchCooldown=U;const N=I.localize(3,null,F,L.tunnelRemotePort,L.tunnelLocalPort);return this.dialogService.info(N)}async forward(L,F){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await A.Event.toPromise(this.onRestoreComplete.event),this.doForward(L,F)}async doForward(L,F){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const x=k(this.forwarded,L.remote.host,L.remote.port);F=F??(F!==null?(await this.getAttributes([L.remote]))?.get(L.remote.port):void 0);const U=L.local!==void 0?L.local:L.remote.port;let N;if(x)return this.mergeAttributesIntoExistingTunnel(x,L,F);{const z=this.environmentService.remoteAuthority,V=z?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(z)).authority}:void 0,ge=C(L.remote.host,L.remote.port);this.inProgress.set(ge,!0),L=this.mergeCachedAndUnrestoredProperties(ge,L);const te=await this.tunnelService.openTunnel(V,L.remote.host,L.remote.port,void 0,U,L.elevateIfNeeded?L.elevateIfNeeded:F?.elevateIfNeeded,L.privacy,F?.protocol);if(typeof te=="string")N=te;else if(te&&te.localAddress){const q=k(this._candidates??new Map,L.remote.host,L.remote.port),K=te.protocol?te.protocol===_.TunnelProtocol.Https?_.TunnelProtocol.Https:_.TunnelProtocol.Http:F?.protocol??_.TunnelProtocol.Http,ue={remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localPort:te.tunnelLocalPort,name:F?.label??L.name,closeable:!0,localAddress:te.localAddress,protocol:K,localUri:await this.makeLocalUri(te.localAddress,F),runningProcess:q?.detail,hasRunningProcess:!!q,pid:q?.pid,source:L.source??e.UserTunnelSource,privacy:te.privacy};return this.forwarded.set(ge,ue),this.remoteTunnels.set(ge,te),this.inProgress.delete(ge),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(te,U,F),this._onForwardPort.fire(ue),te}this.inProgress.delete(ge)}return N}mergeCachedAndUnrestoredProperties(L,F){const x=this.unrestoredExtensionTunnels.has(L)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(L)?this.sessionCachedProperties:void 0;if(x){const U=x.get(L);x.delete(L),U&&(F.name=U.name??F.name,F.local=("local"in U?U.local:"localPort"in U?U.localPort:void 0)??F.local,F.privacy=U.privacy??F.privacy)}return F}async mergeAttributesIntoExistingTunnel(L,F,x){const U=x?.label??F.name;let N;(function(V){V[V.None=0]="None",V[V.Fire=1]="Fire",V[V.Reopen=2]="Reopen"})(N||(N={}));let z=N.None;switch(U!==L.name&&(L.name=U,z=N.Fire),(x?.protocol||L.protocol!==_.TunnelProtocol.Http)&&x?.protocol!==L.protocol&&(F.source=L.source,z=N.Reopen),F.privacy&&L.privacy!==F.privacy&&(z=N.Reopen),z){case N.Fire:{this._onForwardPort.fire();break}case N.Reopen:await this.close(L.remoteHost,L.remotePort,n.User),await this.doForward(F,x)}return k(this.remoteTunnels,F.remote.host,F.remote.port)}async name(L,F,x){const U=k(this.forwarded,L,F),N=C(L,F);if(U){U.name=x,await this.storeForwarded(),this._onPortName.fire({host:L,port:F});return}else this.detected.has(N)&&(this.detected.get(N).name=x,this._onPortName.fire({host:L,port:F}))}async close(L,F,x){const U=C(L,F),N=this.forwarded.get(U);return x===n.AutoForwardEnd&&N&&N.source.source===r.Auto&&this.sessionCachedProperties.set(U,{local:N.localPort,name:N.name,privacy:N.privacy}),await this.tunnelService.closeTunnel(L,F),this.onTunnelClosed({host:L,port:F},x)}address(L,F){const x=C(L,F);return(this.forwarded.get(x)||this.detected.get(x))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(L){if(L)for(const F of L){const x=k(this._candidates??new Map,F.remoteAddress.host,F.remoteAddress.port),U=typeof F.localAddress=="string"?F.localAddress:C(F.localAddress.host,F.localAddress.port);this.detected.set(C(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:U,protocol:_.TunnelProtocol.Http,localUri:this.makeLocalUri(U),closeable:!1,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:_.TunnelPrivacyId.ConstantPrivate,source:{source:r.Extension,description:I.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,U,_.TunnelPrivacyId.ConstantPrivate,_.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(L){this._candidateFilter=L}async setCandidates(L){let F=L;this._candidateFilter&&(F=await this._candidateFilter(L));const x=this.updateInResponseToCandidates(F);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(x.values()).map(U=>U.port).join(", ")}`),this._onCandidatesChanged.fire(x)}updateInResponseToCandidates(L){const F=this._candidates??new Map,x=new Map;return this._candidates=x,L.forEach(U=>{const N=C(U.host,U.port);x.set(N,{host:U.host,port:U.port,detail:U.detail,pid:U.pid}),F.has(N)&&F.delete(N);const z=k(this.forwarded,U.host,U.port);z&&(z.runningProcess=U.detail,z.hasRunningProcess=!0,z.pid=U.pid)}),F.forEach((U,N)=>{const z=s(N);if(!z)return;const V=k(this.forwarded,z.host,z.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0);const ge=k(this.detected,z.host,z.port);ge&&(ge.runningProcess=void 0,ge.hasRunningProcess=!1,ge.pid=void 0)}),F}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const L=Array.from(this.forwarded.values()),F=await this.getAttributes(L.map(x=>({port:x.remotePort,host:x.remoteHost})),!1);if(F)for(const x of L){const U=F.get(x.remotePort);(U?.protocol||x.protocol!==_.TunnelProtocol.Http)&&U?.protocol!==x.protocol&&await this.doForward({remote:{host:x.remoteHost,port:x.remotePort},local:x.localPort,name:x.name,source:x.source},U),U&&U.label&&U.label!==x.name&&await this.name(x.remoteHost,x.remotePort,U.label)}}async getAttributes(L,F=!0){const x=new Map,U=new Map;L.forEach(te=>{const q=k(this._candidates??new Map,_.LOCALHOST_ADDRESSES[0],te.port)??te;if(q){x.set(te.port,q);const K=m(q)?q.pid:void 0;U.has(K)||U.set(K,[]),U.get(K)?.push(te.port)}});const N=new Map;if(L.forEach(te=>{const q=this.configPortsAttributes.getAttributes(te.port,te.host,x.get(te.port)?.detail);q&&N.set(te.port,q)}),this.portAttributesProviders.length===0||!F)return N.size>0?N:void 0;const z=await Promise.all((0,O.flatten)(this.portAttributesProviders.map(te=>Array.from(U.entries()).map(q=>{const K=q[1],ue=x.get(K[0]);return te.providePortAttributes(K,ue?.pid,ue?.detail,new u.CancellationTokenSource().token)})))),V=new Map;if(z.forEach(te=>te.forEach(q=>{q&&V.set(q.port,q)})),!N&&!V)return;const ge=new Map;return L.forEach(te=>{const q=N.get(te.port),K=V.get(te.port);ge.set(te.port,{elevateIfNeeded:q?.elevateIfNeeded,label:q?.label,onAutoForward:q?.onAutoForward??b.providedActionToAction(K?.autoForwardAction),requireLocalPort:q?.requireLocalPort,protocol:q?.protocol})}),ge}addAttributesProvider(L){this.portAttributesProviders.push(L)}};e.TunnelModel=D,je([(0,f.debounce)(1e3)],D.prototype,"storeForwarded",null),e.TunnelModel=D=je([$e(0,_.ITunnelService),$e(1,S.IStorageService),$e(2,v.IConfigurationService),$e(3,d.IWorkbenchEnvironmentService),$e(4,E.IRemoteAuthorityResolverService),$e(5,w.IWorkspaceContextService),$e(6,P.ILogService),$e(7,R.IDialogService),$e(8,o.IExtensionService),$e(9,a.IContextKeyService)],D)}),define(De[92],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class I{constructor(T,g){this.line=T,this.character=g}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,g){return new I(0,0)}with(T){return new I(0,0)}}e.Position=I;class O{constructor(T,g,y,v){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(T,g),this.end=new I(y,v)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new O(0,0,0,0)}with(T){return new O(0,0,0,0)}}e.Range=O;var f;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(De[37],Ie([1,0,19,36,24,33,15,5,16,9,92,8]),function(pe,e,I,O,f,A,T,g,y,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",S=" characters skipped \u27EB",_=(E.length+S.length+5)*2;e.ISearchService=(0,g.createDecorator)("searchService");var w;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(w||(e.SearchProviderType=w={}));var d;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(d||(e.QueryType=d={}));function o(K){return!!K.preview}e.resultIsMatch=o;function u(K){return!!K.resource}e.isFileMatch=u;function c(K){return!!K.message}e.isProgressMessage=c;var h;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(h||(e.SearchCompletionExitCode=h={}));class a{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=a;class t{constructor(ue,ie,ce,Se){this.ranges=ie,this.webviewIndex=Se;const j=Array.isArray(ie)?ie:[ie];if(ce&&ce.matchLines===1&&i(j)){ue=(0,T.getNLines)(ue,ce.matchLines);let $="",X=0,re=0;const Q=Math.floor(ce.charsPerLine/5),Z=[];for(const J of j){const be=Math.max(J.startColumn-Q,0),ae=J.startColumn+ce.charsPerLine;if(be>re+Q+_){const fe=E+(be-re)+S;$+=fe+ue.slice(be,ae),X+=be-(re+fe.length)}else $+=ue.slice(re,ae);Z.push(new n(0,J.startColumn-X,J.endColumn-X)),re=ae}this.preview={text:$,matches:Array.isArray(this.ranges)?Z:Z[0]}}else{const $=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:ue,matches:(0,I.mapArrayOrNot)(ie,X=>new s(X.startLineNumber-$,X.startColumn,X.endLineNumber-$,X.endColumn))}}}}e.TextSearchMatch=t;function i(K){const ue=K[0].startLineNumber;for(const ie of K)if(ie.startLineNumber!==ue||ie.endLineNumber!==ue)return!1;return!0}class s{constructor(ue,ie,ce,Se){this.startLineNumber=ue,this.startColumn=ie,this.endLineNumber=ce,this.endColumn=Se}}e.SearchRange=s;class n extends s{constructor(ue,ie,ce){super(ue,ie,ue,ce)}}e.OneLineRange=n;var r;(function(K){K.List="list",K.Tree="tree"})(r||(e.ViewMode=r={}));var l;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function k(K,ue=!0){const ie=K&&K.files&&K.files.exclude,ce=ue&&K&&K.search&&K.search.exclude;if(!ie&&!ce)return;if(!ie||!ce)return ie||ce;let Se=Object.create(null);return Se=f.mixin(Se,f.deepClone(ie)),Se=f.mixin(Se,f.deepClone(ce),!0),Se}e.getExcludes=k;function C(K,ue){return K.excludePattern&&O.match(K.excludePattern,ue)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&O.match(K.includePattern,ue)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(ie=>{const ce=ie.folder.fsPath;if(A.isEqualOrParent(ue,ce)){const Se=y.relative(ce,ue);return!ie.includePattern||!!O.match(ie.includePattern,Se)}else return!1}):!1:!0}e.pathIncludedInQuery=C;var p;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class m extends Error{constructor(ue,ie){super(ue),this.code=ie}}e.SearchError=m;function b(K){const ue=K.message;if((0,v.isCancellationError)(K))return new m(ue,p.canceled);try{const ie=JSON.parse(ue);return new m(ie.message,ie.code)}catch{return new m(ue,p.other)}}e.deserializeSearchError=b;function D(K){const ue={message:K.message,code:K.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=D;function M(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=M;function L(K){return K.type==="success"}e.isSerializedSearchSuccess=L;function F(K){return!!K.path}e.isSerializedFileMatch=F;function x(K,ue){const ie=K.searchPath?K.searchPath:K.relativePath;return(0,T.fuzzyContains)(ie,ue)}e.isFilePatternMatch=x;class U{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function N(K,ue){const ie={...K||{},...ue||{}};return Object.keys(ie).filter(ce=>{const Se=ie[ce];return typeof Se=="boolean"&&Se})}e.resolvePatternsForProvider=N;class z{constructor(ue,ie){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...ie.excludePattern||{}},this._parsedExcludeExpression=O.parse(this._excludeExpression);let ce=ue.includePattern;ie.includePattern&&(ce?ce={...ce,...ie.includePattern}:ce=ie.includePattern),ce&&(this._parsedIncludeExpression=O.parse(ce))}matchesExcludesSync(ue,ie,ce){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,ie,ce))}includedInQuerySync(ue,ie,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,ie,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,ie,ce))}includedInQuery(ue,ie,ce){const Se=this._parsedExcludeExpression(ue,ie,ce),j=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,ie,ce):!0;return(0,P.isThenable)(Se)?Se.then($=>$?!1:j()):j()}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=z;function V(K){for(const ue in K)if(typeof K[ue]!="boolean")return!0;return!1}function ge(K){if(!K)return;let ue;return ie=>(ue||(ue=(K()||Promise.resolve([])).then(ce=>ce?q(ce):{})),ue.then(ce=>!!ce[ie]))}e.hasSiblingPromiseFn=ge;function te(K){if(!K)return;let ue;return ie=>{if(!ue){const ce=K();ue=ce?q(ce):{}}return!!ue[ie]}}e.hasSiblingFn=te;function q(K){const ue={};for(const ie of K)ue[ie]=!0;return ue}}),define(De[39],Ie([1,0,19,8,21,4,3,78,18,120,23,15,2,215,5,14,244,44,55,27,20,13,7,67,37,6]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a,t,i,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(M,L,F){return new R.ExtUri(x=>p(x,F)).isEqual(M,L)}function l(M,L,F){return r(M.uri,L.uri,F)?0:(0,P.compare)(M.uri.toString(),L.uri.toString())}function k(M,L,F){return M.index!==L.index?M.index<L.index?-1:1:r(M.uri,L.uri,F)?(0,P.compare)(M.name,L.name):(0,P.compare)(M.uri.toString(),L.uri.toString())}function C(M,L,F,x){const U=M.slice(0).sort((z,V)=>F(z,V,x)),N=L.slice(0).sort((z,V)=>F(z,V,x));return(0,I.delta)(U,N,(z,V)=>F(z,V,x))}function p(M,L){const F=L.getCapabilities(M.scheme);return!(F&&F&1024)}class m extends o.Workspace{static toExtHostWorkspace(L,F,x,U){if(!L)return{workspace:null,added:[],removed:[]};const{id:N,name:z,folders:V,configuration:ge,transient:te,isUntitled:q}=L,K=[],ue=F;F?V.forEach((j,$)=>{const X=E.URI.revive(j.uri),re=m._findFolder(x||F,X,U);re?(re.name=j.name,re.index=j.index,K.push(re)):K.push({uri:X,name:j.name,index:$})}):K.push(...V.map(({uri:j,name:$,index:X})=>({uri:E.URI.revive(j),name:$,index:X}))),K.sort((j,$)=>j.index<$.index?-1:1);const ie=new m(N,z,K,!!te,ge?E.URI.revive(ge):null,!!q,j=>p(j,U)),{added:ce,removed:Se}=C(ue?ue.workspaceFolders:[],ie.workspaceFolders,l,U);return{workspace:ie,added:ce,removed:Se}}static _findFolder(L,F,x){for(let U=0;U<L.folders.length;U++){const N=L.workspaceFolders[U];if(r(N.uri,F,x))return N}}constructor(L,F,x,U,N,z,V){super(L,x.map(ge=>new o.WorkspaceFolder(ge)),U,N,V),this._name=F,this._isUntitled=z,this._workspaceFolders=[],this._structure=g.TernarySearchTree.forUris(V),x.forEach(ge=>{this._workspaceFolders.push(ge),this._structure.set(ge.uri,ge)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,F){return F&&this._structure.get(L)&&(L=(0,R.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let b=class{constructor(L,F,x,U,N){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=U,this._extHostFileSystemInfo=x,this._uriTransformerService=N,this._requestIdProvider=new v.Counter,this._barrier=new O.Barrier,this._proxy=L.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(n.MainContext.MainThreadMessageService);const z=F.workspace;this._confirmedWorkspace=z?new m(z.id,z.name,[],!!z.transient,z.configuration?E.URI.revive(z.configuration):null,!!z.isUntitled,V=>p(V,x)):void 0}$initializeWorkspace(L,F){this._trusted=F,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:y.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,F,x,...U){const N=[];if(Array.isArray(U)&&U.forEach(q=>{E.URI.isUri(q.uri)&&!N.some(K=>r(K.uri,q.uri,this._extHostFileSystemInfo))&&N.push({uri:q.uri,name:q.name||(0,R.basenameOrAuthority)(q.uri)})}),this._unconfirmedWorkspace||[F,x].some(q=>typeof q!="number"||q<0)||x===0&&N.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+x>z.length)return!1;const V=z.slice(0);V.splice(F,x,...N.map(q=>({uri:q.uri,name:q.name||(0,R.basenameOrAuthority)(q.uri),index:void 0})));for(let q=0;q<V.length;q++){const K=V[q];if(V.some((ue,ie)=>ie!==q&&r(K.uri,ue.uri,this._extHostFileSystemInfo)))return!1}V.forEach((q,K)=>q.index=K);const{added:ge,removed:te}=C(z,V,k,this._extHostFileSystemInfo);if(ge.length===0&&te.length===0)return!1;if(this._proxy){const q=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(q,F,x,N).then(void 0,K=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(d.Severity.Error,(0,S.localize)(0,null,q,K.toString()),ue,[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,F){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,F)}async getWorkspaceFolder2(L,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,F)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,F){let x,U="";if(typeof L=="string"?(x=E.URI.file(L),U=L):typeof L<"u"&&(x=L,U=L.fsPath),!x)return U;const N=this.getWorkspaceFolder(x,!0);if(!N)return U;typeof F>"u"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let z=(0,R.relativePath)(N.uri,x);return F&&N.name&&(z=`${N.name}/${z}`),z}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:F,added:x,removed:U}=m.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:U}))}findFiles(L,F,x,U,N=f.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let z;if(F===null?z=!1:F&&(typeof F=="string"?z=F:z=F.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:ge}=D(a.GlobPattern.from(L));return this._proxy.$startFileSearch(V??null,ge??null,z??null,x??null,N).then(te=>Array.isArray(te)?te.map(q=>E.URI.revive(q)):[])}async findTextInFiles(L,F,x,U,N=f.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),V=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:ge,folder:te}=D(a.GlobPattern.from(F.include)),q=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,K={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:V,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:ge,excludePattern:q},ue=!1;if(this._activeSearchCallbacks[z]=ie=>{if(ue)return;const ce=E.URI.revive(ie.resource);ie.results.forEach(Se=>{(0,s.resultIsMatch)(Se)?x({uri:ce,preview:{text:Se.preview.text,matches:(0,I.mapArrayOrNot)(Se.preview.matches,j=>new t.Range(j.startLineNumber,j.startColumn,j.endLineNumber,j.endColumn))},ranges:(0,I.mapArrayOrNot)(Se.ranges,j=>new t.Range(j.startLineNumber,j.startColumn,j.endLineNumber,j.endColumn))}):x({uri:ce,text:Se.text,lineNumber:Se.lineNumber})})},N.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(L,te??null,K,z,N);return delete this._activeSearchCallbacks[z],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[z],ie}}$handleTextSearchResult(L,F){this._activeSearchCallbacks[F]?.(L)}async save(L){const F=await this._proxy.$save(L,{saveAs:!1});return E.URI.revive(F)}async saveAs(L){const F=await this._proxy.$save(L,{saveAs:!0});return E.URI.revive(F)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(L,F){if(this._editSessionIdentityProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._editSessionIdentityProviders.set(L,F);const x=this._uriTransformerService.transformOutgoingScheme(L),U=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(U,x),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(L),this._proxy.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(L,F){this._logService.info("Getting edit session identifier for workspaceFolder",L);const x=await this.resolveWorkspaceFolder(E.URI.revive(L));if(!x){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const U=this._editSessionIdentityProviders.get(x.uri.scheme);if(this._logService.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!U),!U)return;const N=await U.provideEditSessionIdentity(x,F);if(this._logService.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(L,F,x,U){this._logService.info("Getting edit session identifier for workspaceFolder",L);const N=await this.resolveWorkspaceFolder(E.URI.revive(L));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const z=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!z),!z)return;const V=await z.provideEditSessionIdentityMatch?.(F,x,U);if(this._logService.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(L){return(F,x,U)=>{const N=function(V){F.call(x,V)};return N.extension=L,this._onWillCreateEditSessionIdentityEvent.event(N,void 0,U)}}async $onWillCreateEditSessionIdentity(L,F,x){const U=await this.resolveWorkspaceFolder(E.URI.revive(L));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:U},F,async(N,z)=>{const V=Date.now();await Promise.resolve(N),Date.now()-V>x&&this._logService.warn("SLOW edit session create-participant",z.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(L,F){if(this._canonicalUriProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._canonicalUriProviders.set(L,F);const x=this._uriTransformerService.transformOutgoingScheme(L),U=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(U,x),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(L),this._proxy.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(L,F,x){const U=this._canonicalUriProviders.get(L.scheme);if(!U)return;const N=await U.provideCanonicalUri?.(E.URI.revive(L),F,x);if(N)return N}async $provideCanonicalUri(L,F,x){return this.provideCanonicalUri(E.URI.revive(L),{targetScheme:F},x)}};e.ExtHostWorkspace=b,e.ExtHostWorkspace=b=je([$e(0,h.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,u.IExtHostFileSystemInfo),$e(3,w.ILogService),$e(4,i.IURITransformerService)],b),e.IExtHostWorkspace=(0,_.createDecorator)("IExtHostWorkspace");function D(M){let L,F;return M&&(typeof M=="string"?L=M:(L=M.pattern,F=E.URI.revive(M.baseUri))),{includePattern:L,folder:F}}}),define(De[40],Ie([1,0,24,4,39,6,7,246,136,17,8,5,20,14,2]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(i,s){if(s){const n=s.split(".");let r=i;for(let l=0;r&&l<n.length;l++)r=r[n[l]];return r}}function d(i){return i instanceof _.URI}function o(i){return i&&i.uri instanceof _.URI&&i.languageId&&typeof i.languageId=="string"}function u(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function c(i){return i&&i.uri instanceof _.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function h(i){if(d(i))return{resource:i};if(o(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(u(i))return{overrideIdentifier:i.languageId};if(c(i))return{resource:i.uri};if(i===null)return{resource:null}}let a=class{constructor(s,n,r){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=r,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,n))}};e.ExtHostConfiguration=a,e.ExtHostConfiguration=a=je([$e(0,E.IExtHostRpcService),$e(1,f.IExtHostWorkspace),$e(2,S.ILogService)],a);class t{constructor(s,n,r,l){this._onDidChangeConfiguration=new O.Emitter,this._proxy=s,this._logService=l,this._extHostWorkspace=n,this._configuration=g.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=g.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,r))}getConfiguration(s,n,r){const l=h(n)||{},k=this._toReadonlyValue(s?w(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,l,r?.identifier);function C(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(m){return typeof w(k,m)<"u"},get:(m,b)=>{this._validateConfigurationAccess(s?`${s}.${m}`:m,l,r?.identifier);let D=w(k,m);if(typeof D>"u")D=b;else{let M;const L=(F,x)=>{if((0,v.isObject)(F)){let U;const N=()=>{M=M||(0,I.deepClone)(k),U=U||w(M,x)};return new Proxy(F,{get:(z,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return N(),()=>U;if(M)return U=U||w(M,x),U[V];const ge=z[V];return typeof V=="string"?L(ge,`${x}.${V}`):ge},set:(z,V,ge)=>(N(),U&&(U[V]=ge),!0),deleteProperty:(z,V)=>(N(),U&&delete U[V],!0),defineProperty:(z,V,ge)=>(N(),U&&Object.defineProperty(U,V,ge),!0)})}return Array.isArray(F)?(0,I.deepClone)(F):F};D=L(D,m)}return D},update:(m,b,D,M)=>{m=s?`${s}.${m}`:m;const L=C(D);return b!==void 0?this._proxy.$updateConfigurationOption(L,m,b,l,M):this._proxy.$removeConfigurationOption(L,m,l,M)},inspect:m=>{m=s?`${s}.${m}`:m;const b=this._configuration.inspect(m,l,this._extHostWorkspace.workspace);if(b)return{key:m,defaultValue:(0,I.deepClone)(b.policy?.value??b.default?.value),globalValue:(0,I.deepClone)(b.user?.value??b.application?.value),workspaceValue:(0,I.deepClone)(b.workspace?.value),workspaceFolderValue:(0,I.deepClone)(b.workspaceFolder?.value),defaultLanguageValue:(0,I.deepClone)(b.default?.override),globalLanguageValue:(0,I.deepClone)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,I.deepClone)(b.workspace?.override),workspaceFolderLanguageValue:(0,I.deepClone)(b.workspaceFolder?.override),languageIds:(0,I.deepClone)(b.overrideIdentifiers)}}};return typeof k=="object"&&(0,I.mixin)(p,k,!1),Object.freeze(p)}_toReadonlyValue(s){const n=r=>(0,v.isObject)(r)?new Proxy(r,{get:(l,k)=>n(l[k]),set:(l,k,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(l,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(l,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return n(s)}_validateConfigurationAccess(s,n,r){const l=y.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),k=r?`[${r.value}] `:"";if(l===4){typeof n?.resource>"u"&&this._logService.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){n?.resource&&this._logService.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const r=new g.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,k)=>r.affectsConfiguration(l,h(k))})}_toMap(s){return s.reduce((n,r)=>(n.set(r[0],r[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")}),define(De[93],Ie([1,0,2,8,4,6,7,39,70,40,21,45,20,27,5,18,12,14,89,293,9]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(L){function F(U){if(U!=null)return U}L.from=F;function x(U){if(U!=null)return U}L.to=x})(a||(a={}));var t;(function(L){function F(U){if(U!=null)return U}L.from=F;function x(U){if(U!=null)return U}L.to=x})(t||(t={}));var i;(function(L){function F(U){if(U!=null)return U}L.from=F;function x(U){if(U!=null)return U}L.to=x})(i||(i={}));var s;(function(L){function F(N){if(N){const z=N;return z&&!!z.process}else return!1}L.is=F;function x(N){if(N==null)return;const z={process:N.process,args:N.args};return N.options&&(z.options=i.from(N.options)),z}L.from=x;function U(N){if(N!=null)return new T.ProcessExecution(N.process,N.args,N.options)}L.to=U})(s||(s={}));var n;(function(L){function F(U){if(U!=null)return U}L.from=F;function x(U){if(U!=null)return U}L.to=x})(n||(n={}));var r;(function(L){function F(N){if(N){const z=N;return z&&(!!z.commandLine||!!z.command)}else return!1}L.is=F;function x(N){if(N==null)return;const z={};return N.commandLine!==void 0?z.commandLine=N.commandLine:(z.command=N.command,z.args=N.args),N.options&&(z.options=n.from(N.options)),z}L.from=x;function U(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new T.ShellExecution(N.commandLine,N.options):new T.ShellExecution(N.command,N.args?N.args:[],N.options)}L.to=U})(r||(r={}));var l;(function(L){function F(N){if(N){const z=N;return z&&z.customExecution==="customExecution"}else return!1}L.is=F;function x(N){return{customExecution:"customExecution"}}L.from=x;function U(N,z){return z.get(N)}L.to=U})(l||(e.CustomExecutionDTO=l={}));var k;(function(L){function F(x,U){let N;return x.scope!==void 0&&typeof x.scope!="number"?N=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===T.TaskScope.Workspace&&U&&U.workspaceFile?N=U.workspaceFile:N=c.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:N}}L.from=F})(k||(e.TaskHandleDTO=k={}));var C;(function(L){function F(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}L.from=F})(C||(C={}));var p;(function(L){function F(N,z){if(N==null)return[];const V=[];for(const ge of N){const te=x(ge,z);te&&V.push(te)}return V}L.fromMany=F;function x(N,z){if(N==null)return;let V;N.execution instanceof T.ProcessExecution?V=s.from(N.execution):N.execution instanceof T.ShellExecution?V=r.from(N.execution):N.execution&&N.execution instanceof T.CustomExecution&&(V=l.from(N.execution));const ge=a.from(N.definition);let te;return N.scope?typeof N.scope=="number"?te=N.scope:te=N.scope.uri:te=T.TaskScope.Workspace,!ge||!te?void 0:{_id:N._id,definition:ge,name:N.name,source:{extensionId:z.identifier.value,label:N.source,scope:te},execution:V,isBackground:N.isBackground,group:C.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}L.from=x;async function U(N,z,V){if(N==null)return;let ge;s.is(N.execution)?ge=s.to(N.execution):r.is(N.execution)?ge=r.to(N.execution):l.is(N.execution)&&(ge=l.to(N._id,V));const te=a.to(N.definition);let q;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?q=N.source.scope:q=await z.resolveWorkspaceFolder(I.URI.revive(N.source.scope)):q=T.TaskScope.Workspace),!te||!q)return;const K=new T.Task(te,q,N.name,N.source.label,ge,N.problemMatchers);return N.isBackground!==void 0&&(K.isBackground=N.isBackground),N.group!==void 0&&(K.group=T.TaskGroup.from(N.group._id),K.group&&N.group.isDefault&&(K.group=new T.TaskGroup(K.group.id,K.group.label),N.group.isDefault===!0&&(K.group.isDefault=N.group.isDefault))),N.presentationOptions&&(K.presentationOptions=t.to(N.presentationOptions)),N._id&&(K._id=N._id),N.detail&&(K.detail=N.detail),K}L.to=U})(p||(e.TaskDTO=p={}));var m;(function(L){function F(U){return U}L.from=F;function x(U){if(U)return Object.assign(Object.create(null),U)}L.to=x})(m||(m={}));class b{#e;constructor(F,x,U){this._id=x,this._task=U,this.#e=F}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let D=class{constructor(F,x,U,N,z,V,ge,te){this._onDidExecuteTask=new f.Emitter,this._onDidTerminateTask=new f.Emitter,this._onDidTaskProcessStarted=new f.Emitter,this._onDidTaskProcessEnded=new f.Emitter,this._proxy=F.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=N,this._configurationService=z,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ge,this._deprecationService=te,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,x,U){if(!U)return new T.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:x,provider:U,extension:F}),this._proxy.$registerTaskProvider(N,x),new T.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(F,x){this._proxy.$registerTaskSystem(F,x)}fetchTasks(F){return this._proxy.$fetchTasks(m.from(F)).then(async x=>{const U=[];for(const N of x){const z=await p.to(N,this._workspaceProvider,this._providedCustomExecutions2);z&&U.push(z)}return U})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(x=>F.push(x)),F}terminateTask(F){if(!(F instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,x,U){const N=this._providedCustomExecutions2.get(F.id);N&&(this._activeCustomExecutions2.set(F.id,N),this._terminalService.attachPtyToTerminal(x,await N.callback(U))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const x=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const x=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:x,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const x=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:F.exitCode})}$provideTasks(F,x){const U=this._handlers.get(F);if(!U)return Promise.reject(new Error("no handler found"));const N=[],z=(0,O.asPromise)(()=>U.provider.provideTasks(R.CancellationToken.None)).then(V=>this.provideTasksInternal(x,N,U,V));return new Promise(V=>{z.then(ge=>{Promise.all(N).then(()=>{V(ge)})})})}async $resolveTask(F,x){const U=this._handlers.get(F);if(!U)return Promise.reject(new Error("no handler found"));if(x.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${U.type}].`);const N=await p.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const z=await U.provider.resolveTask(N,R.CancellationToken.None);if(!z)return;this.checkDeprecation(z,U);const V=p.from(z,U.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(V.execution)&&await this.addCustomExecution(V,z,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,x,U){const N=await this._proxy.$createTaskId(F);!U&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,x.execution)),this._providedCustomExecutions2.set(N,x.execution)}async getTaskExecution(F,x){if(typeof F=="string"){const z=this._taskExecutionPromises.get(F);if(!z)throw new h.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const U=this._taskExecutionPromises.get(F.id);if(U)return U;const N=new Promise((z,V)=>{function ge(te,q,K){K?z(new b(te,q.id,K)):V("Unexpected: Task does not exist.")}x?ge(this,F,x):p.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(te=>ge(this,F,te))});return this._taskExecutionPromises.set(F.id,N),N.then(z=>(this._taskExecutions.set(F.id,z),z),z=>Promise.reject(z))}checkDeprecation(F,x){F._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const U=this._notProvidedCustomExecutions.values();let N=U.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=U.next()}};e.ExtHostTaskBase=D,e.ExtHostTaskBase=D=je([$e(0,E.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,g.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,o.ILogService),$e(7,u.IExtHostApiDeprecationService)],D);let M=class extends D{constructor(F,x,U,N,z,V,ge,te){super(F,x,U,N,z,V,ge,te),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(F,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const U=p.from(x,F);if(U===void 0)throw new Error("Task is not valid");if(l.is(U.execution))await this.addCustomExecution(U,x,!1);else throw new h.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),x);return this._proxy.$executeTask(U).catch(z=>{throw new Error(z)}),N}provideTasksInternal(F,x,U,N){const z=[];if(N)for(const V of N){this.checkDeprecation(V,U),(!V.definition||!F[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const ge=p.from(V,U.extension);ge&&l.is(ge.execution)?(z.push(ge),x.push(this.addCustomExecution(ge,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:U.extension}}async resolveTaskInternal(F){if(l.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,x,U){}};e.WorkerExtHostTask=M,e.WorkerExtHostTask=M=je([$e(0,E.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,g.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,o.ILogService),$e(7,u.IExtHostApiDeprecationService)],M),e.IExtHostTask=(0,_.createDecorator)("IExtHostTask")}),define(De[350],Ie([1,0,16,21,41,36,23,35,37]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class v{constructor(E,S,_){this.config=E,this.provider=S,this.sessionToken=_,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=E.filePattern,this.includePattern=E.includePattern&&A.parse(E.includePattern),this.maxResults=E.maxResults||void 0,this.exists=E.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=E.excludePattern&&A.parse(E.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(E=>E.cancel()),this.activeCancellationTokens=new Set}search(E){const S=this.config.folderQueries||[];return new Promise((_,w)=>{const d=o=>{this.resultCount++,E(o)};if(this.isCanceled)return _({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const u=o.toString(),c=I.basename(u);this.globalExcludePattern&&this.globalExcludePattern(u,c)||this.matchFile(d,{base:o,basename:c})}),Promise.all(S.map(o=>this.searchInFolder(o,d))).then(o=>{_({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{w(new Error((0,f.toErrorMessage)(o)))})})}async searchInFolder(E,S){const _=new O.CancellationTokenSource,w=this.getSearchOptionsForFolder(E),d=this.initDirectoryTree(),o=new y.QueryGlobTester(this.config,E),u=!o.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(_),c=g.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,_.token),a=c.elapsed(),t=g.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(i=>{const s=I.posix.relative(E.folder.path,i.path);if(u){const n=I.basename(i.path);this.matchFile(S,{base:E.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(d,E.folder,s,S)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,o,S),{providerTime:a,postProcessTime:t.elapsed()})}finally{_.dispose(),this.activeCancellationTokens.delete(_)}}getSearchOptionsForFolder(E){const S=(0,y.resolvePatternsForProvider)(this.config.includePattern,E.includePattern),_=(0,y.resolvePatternsForProvider)(this.config.excludePattern,E.excludePattern);return{folder:E.folder,excludes:_,includes:S,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}addDirectoryEntries({pathToEntries:E},S,_,w){if(_===this.filePattern){const o=I.basename(this.filePattern);this.matchFile(w,{base:S,relativePath:this.filePattern,basename:o})}function d(o){const u=I.basename(o),c=I.dirname(o);let h=E[c];h||(h=E[c]=[],d(c)),h.push({base:S,relativePath:o,basename:u})}d(_)}matchDirectoryTree({rootEntries:E,pathToEntries:S},_,w){const d=this,o=this.filePattern;function u(c){const h=(0,y.hasSiblingFn)(()=>c.map(a=>a.basename));for(let a=0,t=c.length;a<t;a++){const i=c[a],{relativePath:s,basename:n}=i;if(_.matchesExcludesSync(s,n,o!==n?h:void 0))continue;const r=S[s];if(r)u(r);else{if(s===o)continue;d.matchFile(w,i)}if(d.isLimitHit)break}}u(E)}matchFile(E,S){(!this.includePattern||S.relativePath&&this.includePattern(S.relativePath,S.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||E(S))}}class R{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(E,S,_,w){const d=this.getSessionTokenSource(E.cacheKey),o=new v(E,S,d&&d.token);let u=0;const c=h=>{u+=h.length,_(h.map(a=>this.rawMatchToSearchItem(a)))};return this.doSearch(o,R.BATCH_SIZE,c,w).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:u,detailStats:h.stats}}))}clearCache(E){this.getSessionTokenSource(E)?.cancel()}getSessionTokenSource(E){if(E)return this.sessions.has(E)||this.sessions.set(E,new O.CancellationTokenSource),this.sessions.get(E)}rawMatchToSearchItem(E){return E.relativePath?{resource:T.joinPath(E.base,E.relativePath)}:{resource:E.base}}doSearch(E,S,_,w){const d=w.onCancellationRequested(()=>{E.cancel()}),o=c=>{c&&(u.push(c),S>0&&u.length>=S&&(_(u),u=[]))};let u=[];return E.search(o).then(c=>(u.length&&_(u),d.dispose(),c),c=>(u.length&&_(u),d.dispose(),Promise.reject(c)))}}e.FileSearchManager=R}),define(De[351],Ie([1,0,19,74,36,99,28,18,16,23,15,17,2,172,227,50,14,44,143,348,37]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(m,b,D,M,L){this.configurationService=m,this.workspaceContextService=b,this.editorGroupsService=D,this.logService=M,this.pathService=L}text(m,b,D={}){m=this.getContentPattern(m,D);const M=this.configurationService.getValue(),L=b&&b.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(b?.map(o.toWorkspaceFolder),D),type:2,contentPattern:m,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:M.search.usePCRE2||L||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}getContentPattern(m,b){const D=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const M={...m,wordSeparators:D.editor.wordSeparators};return this.isCaseSensitive(m,b)&&(M.isCaseSensitive=!0),this.isMultiline(m)&&(M.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),M}file(m,b={}){return{...this.commonQuery(m,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}handleIncludeExclude(m,b){return m?(m=Array.isArray(m)?m.map(r):r(m),b?this.parseSearchPaths(m):{pattern:i(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],b={}){const D=this.handleIncludeExclude(b.includePattern,b.expandPatterns),M=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),L=m.length>1,F=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,b,M)):m.map(N=>this.getFolderQueryForRoot(N,b,M,L))).filter(N=>!!N),x={_reason:b._reason,folderQueries:F,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:M.pattern,includePattern:D.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const N=I.coalesce(I.flatten(this.editorGroupsService.groups.map(ge=>ge.editors.map(te=>te.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const z=N.filter(ge=>(0,h.pathIncludedInQuery)(x,ge.fsPath)),V=this.commonQueryFromFileList(z);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...x,...V}}const U=b.extraFileResources&&b.extraFileResources.filter(N=>(0,h.pathIncludedInQuery)(x,N.fsPath));return x.extraFileResources=U&&U.length?U:void 0,x}commonQueryFromFileList(m){const b=[],D=new T.ResourceMap,M={};let L=!1;return m.forEach(F=>{if(F.scheme===g.Schemas.walkThrough)return;if((0,v.isAbsolutePath)(F)){const U=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:y.dirname(F.fsPath)});let N=D.get(U);N||(L=!0,N={folder:U,includePattern:{}},b.push(N),D.set(U,N));const z=y.relative(U.fsPath,F.fsPath);(0,P.assertIsDefined)(N.includePattern)[z.replace(/\\/g,"/")]=!0}else F.fsPath&&(L=!0,M[F.fsPath]=!0)}),{folderQueries:b,includePattern:M,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(m,b){if(b.isSmartCase){if(m.isRegExp){if(R.containsUppercaseCharacter(m.pattern,!0))return!0}else if(R.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,S.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const b=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),M=(Array.isArray(m)?m:s(m)).map(V=>{const ge=this.pathService.resolvedUserHome;return ge?(0,A.untildify)(V,ge.scheme===g.Schemas.file?ge.fsPath:ge.path):V}),L=O.groupBy(M,V=>b(V)?"searchPaths":"exprSegments"),F=(L.exprSegments||[]).map(V=>R.rtrim(V,"/")).map(V=>R.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),n(V))),x={},U=this.expandSearchPathPatterns(L.searchPaths||[]);U&&U.length&&(x.searchPaths=U);const N=I.flatten(F),z=i(...N);return z&&(x.pattern=z),x}getExcludesForFolder(m,b){return b.disregardExcludeSettings?void 0:(0,h.getExcludes)(m,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const b=m.flatMap(M=>{let{pathPortion:L,globPortion:F}=t(M);return F&&(F=l(F)),this.expandOneSearchPath(L).flatMap(U=>this.resolveOneSearchPathPattern(U,F))}),D=new Map;return b.forEach(M=>{const L=M.searchPath.toString(),F=D.get(L);F?M.pattern&&(F.pattern=F.pattern||{},F.pattern[M.pattern]=!0):D.set(L,{searchPath:M.searchPath,pattern:M.pattern?i(M.pattern):void 0})}),Array.from(D.values())}expandOneSearchPath(m){if(y.isAbsolute(m)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==g.Schemas.file?[{searchPath:b[0].uri.with({path:m})}]:[{searchPath:E.URI.file(y.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=r(m),m.startsWith("../")||m===".."){const M=y.posix.resolve(b.path,m);return[{searchPath:b.with({path:M})}]}const D=l(m);return[{searchPath:b,pattern:D}]}else{if(m==="./"||m===".\\")return[];{const b=m.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(L=>{const F=b.match(new RegExp(`^${R.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return F?{match:F,folder:L}:null}).filter(P.isDefined);if(M.length)return M.map(L=>{const F=L.match[1];return{searchPath:L.folder.uri,pattern:F&&l(F)}});{const L=m.match(/\.[\/\\](.+)[\/\\]?/),F=L?L[1]:m,x=_.localize(0,null,F);throw new Error(x)}}}}resolveOneSearchPathPattern(m,b){const D=m.pattern&&b?`${m.pattern}/${b}`:m.pattern||b,M=[{searchPath:m.searchPath,pattern:D}];return D&&!D.endsWith("**")&&M.push({searchPath:m.searchPath,pattern:D+"/**"}),M}getFolderQueryForSearchPath(m,b,D){const M=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(m.searchPath),b,D,!1);return M?{...M,includePattern:m.pattern}:null}getFolderQueryForRoot(m,b,D,M){let L;const F=E.URI.isUri(m)?m:m.uri;if(D.searchPaths){const V=D.searchPaths.filter(ge=>(0,v.isEqual)(ge.searchPath,F))[0];if(V&&!V.pattern)return null;V&&(L=V.pattern)}const x=this.configurationService.getValue({resource:F}),N={...this.getExcludesForFolder(x,b)||{},...L||{}},z=E.URI.isUri(m)?(0,v.basename)(m):m.name;return{folder:F,folderName:M?z:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!x.search.followSymlinks}}};e.QueryBuilder=a,e.QueryBuilder=a=je([$e(0,w.IConfigurationService),$e(1,o.IWorkspaceContextService),$e(2,u.IEditorGroupsService),$e(3,d.ILogService),$e(4,c.IPathService)],a);function t(p){const m=p.match(/[\*\{\}\(\)\[\]\?]/);if(m){const b=m.index,D=p.substr(0,b).match(/[/|\\][^/\\]*$/);if(D){let M=p.substr(0,D.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:p.substr((D.index||0)+1)}}}return{pathPortion:p}}function i(...p){return p.length?p.reduce((m,b)=>(m[b]=!0,m),Object.create(null)):void 0}function s(p){return f.splitGlobAware(p,",").map(m=>m.trim()).filter(m=>!!m.length)}function n(p){return[`**/${p}/**`,`**/${p}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function l(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(p){return p.replace(/([?*[\]])/g,"[$1]")}function C(p,m){p=I.distinct(p,M=>M.toString());const b=[],D=m.getWorkspace();return p&&p.forEach(M=>{let L;if(m.getWorkbenchState()===2)L=(0,v.relativePath)(D.folders[0].uri,M),L&&L!=="."&&(L="./"+L);else{const F=m.getWorkspaceFolder(M);if(F){const x=F.name;if(D.folders.filter(N=>N.name===x).length===1){const N=(0,v.relativePath)(F.uri,M);N===""?L=`./${F.name}`:L=`./${F.name}/${N}`}else L=M.fsPath}}L&&b.push(k(L))}),b}e.resolveResourcesForSearchIncludes=C}),define(De[352],Ie([1,0,23,2,21,9,5,351,37,44]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function P(w,d){const o=d.activationEvents;if(!o)return Promise.resolve(void 0);const u=[],c=[];for(const n of o)if(/^workspaceContains:/.test(n)){const r=n.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||w.forceUsingSearch?c.push(r):u.push(r)}if(u.length===0&&c.length===0)return Promise.resolve(void 0);let h;const a=new Promise((n,r)=>{h=n}),t=n=>h({activationEvent:n}),i=Promise.all(u.map(n=>E(w,n,t))).then(()=>{}),s=S(w,d.identifier,c,t);return Promise.all([i,s]).then(()=>{h(void 0)}),a}e.checkActivateWorkspaceContainsExtension=P;async function E(w,d,o){for(const u of w.folders)if(await w.exists(I.joinPath(O.URI.revive(u),d))){o(`workspaceContains:${d}`);return}}async function S(w,d,o,u){if(o.length===0)return Promise.resolve(void 0);const c=new f.CancellationTokenSource,h=w.checkExists(w.folders,o,c.token),a=setTimeout(async()=>{c.cancel(),w.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},R);let t=!1;try{t=await h}catch(i){A.isCancellationError(i)||A.onUnexpectedError(i)}c.dispose(),clearTimeout(a),t&&u(`workspaceContains:${o.join(",")}`)}function _(w,d,o,u){const c=w.get(T.IInstantiationService),h=w.get(y.ISearchService),t=c.createInstance(g.QueryBuilder).file(d.map(i=>(0,v.toWorkspaceFolder)(O.URI.revive(i))),{_reason:"checkExists",includePattern:o,exists:!0});return h.fileSearch(t,u).then(i=>!!i.limitHit,i=>A.isCancellationError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=_}),define(De[46],Ie([1,0,205,16,54,23,8,3,78,2,14,6,40,283,115,39,26,145,9,25,22,263,7,65,5,27,90,20,104,73,45,4,352,114,265,18,112,35,12,113]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a,t,i,s,n,r,l,k,C,p,m,b,D,M,L,F,x,U,N){"use strict";var z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let V=z=class extends g.Disposable{constructor(j,$,X,re,Q,Z,J,be,ae,fe,ee,he){super(),this._extHostManagedSockets=he,this._onDidChangeRemoteConnectionData=this._register(new m.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=$,this._extHostContext=X,this._initData=J,this._extHostWorkspace=re,this._extHostConfiguration=Q,this._logService=Z,this._extHostTunnelService=ae,this._extHostTerminalService=fe,this._extHostLocalizationService=ee,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new ce(this._initData.extensions.activationEvents),this._globalRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const ve=new c.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,ue(this._globalRegistry,ve)),U.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${q(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${q(this._myRegistry)}`)),this._storage=new _.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new D.ExtHostSecretState(this._extHostContext),this._storagePath=be,this._instaService=j.createChild(new k.ServiceCollection([_.IExtHostStorage,this._storage],[D.IExtHostSecretState,this._secretState])),this._activator=this._register(new S.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Pe,B,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Pe,u.transformErrorForSerialization(B),G)},actualActivateExtension:async(Pe,B)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(Pe,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Pe,B),new S.HostExtension;const G=this._myRegistry.getExtensionDescription(Pe);return this._activateExtension(G,B)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),f.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){u.onUnexpectedError(j)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._myRegistry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch{}await Promise.all(j)}terminate(j,$=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${j}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),u.setUnexpectedErrorHandler(re=>{this._logService.error(re)}),this._extHostContext.dispose();const X=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),X]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${$}`):this._logService.info(`Extension host exiting with code ${$}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit($)})}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}async getExtension(j){const $=await this._mainThreadExtensionsProxy.$getExtension(j);return $&&{...$,identifier:new c.ExtensionIdentifier($.identifier.value),extensionLocation:v.URI.revive($.extensionLocation)}}_activateByEvent(j,$){return this._activator.activateByEvent(j,$)}_activateById(j,$){return this._activator.activateById(j,$)}activateByIdWithErrors(j,$){return this._activateById(j,$).then(()=>{const X=this._activator.getActivatedExtension(j);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._myRegistry)}getExtensionExports(j){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(j).exports;try{return this._activator.getActivatedExtension(j).exports}catch{return null}}async _realPathExtensionUri(j){if(j.scheme===L.Schemas.file&&this._hostUtils.fsRealpath){const $=await this._hostUtils.fsRealpath(j.fsPath);return v.URI.file($)}return j}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(j=>new ie(j))),this._extensionPathIndex}async _createExtensionPathIndex(j){const $=y.TernarySearchTree.forUris(X=>A.extUriBiasedIgnorePathCase.ignorePathCasing(X));return await Promise.all(j.map(async X=>{if(this._getEntryPoint(X)){const re=await this._realPathExtensionUri(X.extensionLocation);$.set(re,X)}})),$}_deactivate(j){let $=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return $;const X=this._activator.getActivatedExtension(j);if(!X)return $;try{typeof X.module.deactivate=="function"&&($=Promise.resolve(X.module.deactivate()).then(void 0,re=>(this._logService.error(re),Promise.resolve(void 0))))}catch(re){this._logService.error(`An error occurred when deactivating the extension '${j.value}':`),this._logService.error(re)}try{(0,g.dispose)(X.subscriptions)}catch(re){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this._logService.error(re)}return $}async _activateExtension(j,$){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,$).then(X=>{const re=X.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,$),this._logExtensionActivationTimes(j,$,"success",re),X},X=>{throw this._logExtensionActivationTimes(j,$,"failure"),X})}_logExtensionActivationTimes(j,$,X,re){const Q=te(j,$);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...re||{},outcome:X})}_doActivateExtension(j,$){const X=te(j,$);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",X);const re=this._getEntryPoint(j);if(!re)return Promise.resolve(new S.EmptyExtension(S.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${$.startup}, activationEvent: '${$.activationEvent}'${j.identifier.value!==$.extensionId.value?`, root cause: ${$.extensionId.value}`:""}`),this._logService.flush();const Q=new S.ExtensionActivationTimesBuilder($.startup);return Promise.all([this._loadCommonJSModule(j,(0,A.joinPath)(j.extensionLocation,re),Q),this._loadExtensionContext(j)]).then(Z=>(f.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),z._callActivate(this._logService,j.identifier,Z[0],Z[1],Q))).then(Z=>(f.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),Z))}_loadExtensionContext(j){const $=new a.ExtensionGlobalMemento(j,this._storage),X=new a.ExtensionMemento(j.identifier.value,!1,this._storage),re=new M.ExtensionSecrets(j,this._secretState),Q=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Z=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([$.whenReady,X.whenReady,this._storagePath.whenReady]).then(()=>{const J=this;let be,ae;const fe=(0,d.isProposedApiEnabled)(j,"ipc")?this._initData.messagePorts?.get(c.ExtensionIdentifier.toKey(j.identifier)):void 0;return Object.freeze({globalState:$,workspaceState:X,secrets:re,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(ee){return O.join(j.extensionLocation.fsPath,ee)},get storagePath(){return J._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return J._storagePath.globalValue(j).fsPath},get logPath(){return O.join(J._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return v.URI.joinPath(J._initData.logsLocation,j.identifier.value)},get storageUri(){return J._storagePath.workspaceValue(j)},get globalStorageUri(){return J._storagePath.globalValue(j)},get extensionMode(){return Q},get extension(){return be===void 0&&(be=new K(J,j.identifier,j,Z,!1)),be},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(j,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J._extHostTerminalService.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!ae){if(!fe)return;const ee=m.Event.buffer(m.Event.fromDOMEventEmitter(fe,"message",he=>he.data));fe.start(),ae={onDidReceiveMessage:ee,postMessage:fe.postMessage.bind(fe)}}return ae}})})}static _callActivate(j,$,X,re,Q){return X=X||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,$,X,re,Q).then(Z=>new S.ActivatedExtension(!1,null,Q.build(),X,Z,re.subscriptions))}static _callActivateOptional(j,$,X,re,Q){if(typeof X.activate=="function")try{Q.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${$.value}`);const Z=typeof global=="object"?global:self,J=X.activate.apply(Z,[re]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(J).then(be=>(Q.activateResolveStop(),be))}catch(Z){return Promise.reject(Z)}else return Promise.resolve(X)}_activateOneStartupFinished(j,$){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:$}).then(void 0,X=>{this._logService.error(X)})}_activateAllStartupFinishedDeferred(j,$=0){const re=Date.now();(0,U.setTimeout0)(()=>{for(let Q=$;Q<j.length;Q+=1){const Z=j[Q];for(const J of Z.activationEvents??[])if(J==="onStartupFinished")if(Date.now()-re>50){this._activateAllStartupFinishedDeferred(j,Q);break}else this._activateOneStartupFinished(Z,J)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(f.getMarks()),this._extHostConfiguration.getConfigProvider().then(j=>{const $=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),X=this._myRegistry.getAllExtensionDescriptions();if($)this._activateAllStartupFinishedDeferred(X);else for(const re of X)if(re.activationEvents)for(const Q of re.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(re,Q)})}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const $=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],X=this._handleWorkspaceContainsEagerExtensions($),re=this._handleRemoteResolverEagerExtensions(),Q=Promise.all([re,j,X]).then(()=>{});return Promise.race([Q,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map($=>this._handleWorkspaceContainsEagerExtension(j,$))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,$){if(this.isActivated($.identifier))return;const X=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={logService:this._logService,folders:j.map(Z=>Z.uri),forceUsingSearch:X||!this._hostUtils.fsExists,exists:Z=>this._hostUtils.fsExists(Z.fsPath),checkExists:(Z,J,be)=>this._mainThreadWorkspaceProxy.$checkExists(Z,J,be)},Q=await(0,b.checkActivateWorkspaceContainsExtension)(re,$);if(Q)return this._activateById($.identifier,{startup:!0,extensionId:$.identifier,activationEvent:Q.activationEvent}).then(void 0,Z=>this._logService.error(Z))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:$}=this._initData.environment;if(!j||!$)throw new Error(I.localize(0,null));const X=await this._loadCommonJSModule(null,$,new S.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(I.localize(1,null,$.toString()));return new Promise((re,Q)=>{const Z=(ae,fe)=>{ae?(U.isCI&&this._logService.error("Test runner called back with error",ae),Q(ae)):(U.isCI&&(fe?this._logService.info(`Test runner called back with ${fe} failures.`):this._logService.info("Test runner called back with successful outcome.")),re(typeof fe=="number"&&fe>0?1:0))},J=(0,A.originalFSPath)($),be=X.run(J,Z);be&&be.then&&be.then(()=>{U.isCI&&this._logService.info("Test runner finished successfully."),re(0)}).catch(ae=>{U.isCI&&this._logService.error("Test runner finished with error",ae),Q(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,$){return this._resolvers[j]=$,(0,g.toDisposable)(()=>{delete this._resolvers[j]})}async getRemoteExecServer(j){const{resolver:$}=await this._activateAndGetResolver(j);return $?.resolveExecServer?.(j,{resolveAttempt:0})}async _activateAndGetResolver(j){const $=j.indexOf("+");if($===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",i.RemoteAuthorityResolverErrorCode.InvalidAuthority);const X=j.substr(0,$);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this._resolvers[X]}}async $resolveAuthority(j,$){const X=x.StopWatch.create(!1),re=()=>`[resolveAuthority(${(0,i.getRemoteAuthorityPrefix)(j)},${$})][${X.elapsed()}ms] `,Q=oe=>this._logService.info(`${re()}${oe}`),Z=oe=>this._logService.warn(`${re()}${oe}`),J=(oe,Y=void 0)=>this._logService.error(`${re()}${oe}`,Y),be=oe=>{if(oe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},ae=async oe=>{Q(`activating resolver for ${oe}...`);const{resolver:Y,authorityPrefix:me}=await this._activateAndGetResolver(oe);if(!Y)throw J(`no resolver for ${me}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${me}.`,i.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:me,remoteAuthority:oe}},fe=j.split(/@|%40/g).reverse();Q(`activating remote resolvers ${fe.join(" -> ")}`);let ee;try{ee=await Promise.all(fe.map(ae)).catch(async oe=>{if(!(oe instanceof t.RemoteAuthorityResolverError)||oe._code!==i.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return Z(`resolving nested authorities failed: ${oe.message}`),[await ae(j)]})}catch(oe){return be(oe)}const he=new T.IntervalTimer;he.cancelAndSet(()=>Q("waiting..."),1e3);let ve,Pe;for(const[oe,{authorityPrefix:Y,resolver:me,remoteAuthority:ye}]of ee.entries())try{if(oe===ee.length-1)Q("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${Y}`),ve=await me.resolve(ye,{resolveAttempt:$,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${Y}`),Q("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(me,t.ManagedResolvedAuthority.isManagedResolvedAuthority(ve)?ve:void 0));else{if(Q(`invoking resolveExecServer() for ${ye}`),f.mark(`code/extHost/willResolveExecServer/${Y}`),Pe=await me.resolveExecServer?.(ye,{resolveAttempt:$,execServer:Pe}),!Pe)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${ye}`,i.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(xe){return f.mark(`code/extHost/didResolveAuthorityError/${Y}`),J("returned an error",xe),he.dispose(),be(xe)}he.dispose();const B={environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures},G={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};Q(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(ve)?"managed authority":`${ve.host}:${ve.port}`}`);let se;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(ve)){const oe=$;this._extHostManagedSockets.setFactory(oe,ve.makeConnection),se={authority:j,connectTo:new i.ManagedRemoteConnection(oe),connectionToken:ve.connectionToken}}else se={authority:j,connectTo:new i.WebSocketRemoteConnection(ve.host,ve.port),connectionToken:ve.connectionToken};return{type:"ok",value:{authority:se,options:G,tunnelInformation:B}}}async $getCanonicalURI(j,$){this._logService.info(`$getCanonicalURI invoked for authority (${(0,i.getRemoteAuthorityPrefix)(j)})`);const{resolver:X}=await this._activateAndGetResolver(j);if(!X)return null;const re=v.URI.revive($);if(typeof X.getCanonicalURI>"u")return re;const Q=await(0,T.asPromise)(()=>X.getCanonicalURI(re));return Q||re}$startExtensionHost(j){j.toAdd.forEach(re=>re.extensionLocation=v.URI.revive(re.extensionLocation));const{globalRegistry:$,myExtensions:X}=ge(this._activationEventsReader,this._globalRegistry,this._myRegistry,j);return this._globalRegistry.set($.getAllExtensionDescriptions()),this._myRegistry.set(X),U.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${q(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${q(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(j,$){return $===1?this._almostReadyToRunExtensions.wait().then(X=>this._activateByEvent(j,!1)):this._readyToRunExtensions.wait().then(X=>this._activateByEvent(j,!1))}async $activate(j,$){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(j)?(await this._activateById(j,$),!0):!1}async $deltaExtensions(j){j.toAdd.forEach(Z=>Z.extensionLocation=v.URI.revive(Z.extensionLocation));const{globalRegistry:$,myExtensions:X}=ge(this._activationEventsReader,this._globalRegistry,this._myRegistry,j),re=await this._createExtensionPathIndex(X);return(await this.getExtensionPathIndex()).setSearchTree(re),this._globalRegistry.set($.getAllExtensionDescriptions()),this._myRegistry.set(X),U.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${q(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${q(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const $=h.VSBuffer.alloc(j),X=Math.random()%256;for(let re=0;re<j;re++)$.writeUInt8(X,re);return $}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=V,e.AbstractExtHostExtensionService=V=z=je([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,l.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,E.IExtHostConfiguration),$e(5,R.ILogService),$e(6,n.IExtHostInitDataService),$e(7,r.IExtensionStoragePaths),$e(8,C.IExtHostTunnelService),$e(9,p.IExtHostTerminalService),$e(10,F.IExtHostLocalizationService),$e(11,N.IExtHostManagedSockets)],V);function ge(Se,j,$,X){Se.addActivationEvents(X.addActivationEvents);const re=new o.ExtensionDescriptionRegistry(Se,j.getAllExtensionDescriptions());re.deltaExtensions(X.toAdd,X.toRemove);const Q=new c.ExtensionIdentifierSet($.getAllExtensionDescriptions().map(J=>J.identifier));for(const J of X.myToRemove)Q.delete(J);for(const J of X.myToAdd)Q.add(J);const Z=ue(re,Q);return{globalRegistry:re,myExtensions:Z}}function te(Se,j){return{id:Se.identifier.value,name:Se.name,extensionVersion:Se.version,publisherDisplayName:Se.publisher,activationEvents:Se.activationEvents?Se.activationEvents.join(","):null,isBuiltin:Se.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}function q(Se){return Se.getAllExtensionDescriptions().map(j=>j.identifier.value).join(",")}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class K{#e;#t;#i;constructor(j,$,X,re,Q){this.#e=j,this.#t=$,this.#i=X.identifier,this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=O.normalize((0,A.originalFSPath)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=re,this.isFromDifferentExtensionHost=Q}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=K;function ue(Se,j){return Se.getAllExtensionDescriptions().filter($=>j.has($.identifier))}class ie{constructor(j){this._searchTree=j}setSearchTree(j){this._searchTree=j}findSubstr(j){return this._searchTree.findSubstr(j)}forEach(j){return this._searchTree.forEach(j)}}e.ExtensionPaths=ie;class ce{constructor(j){this._map=new c.ExtensionIdentifierMap,this.addActivationEvents(j)}readActivationEvents(j){return this._map.get(j.identifier)}addActivationEvents(j){for(const $ of Object.keys(j))this._map.set($,j[$])}}}),define(De[353],Ie([1,0,54,2,6,40,26,25,20,27,5,46,14,15]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let w=class{constructor(h,a,t,i,s,n,r){this._apiFactory=h,this._extensionRegistry=a,this._instaService=t,this._extHostConfiguration=i,this._extHostExtensionService=s,this._initData=n,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),I.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,a,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(u,a,this._initData.environment.appUriScheme))}register(h){if("nodeModuleName"in h)if(Array.isArray(h.nodeModuleName))for(const a of h.nodeModuleName)this._factories.set(a,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(a=>h.alternativeModuleName(a))}};e.RequireInterceptor=w,e.RequireInterceptor=w=je([$e(2,R.IInstantiationService),$e(3,A.IExtHostConfiguration),$e(4,P.IExtHostExtensionService),$e(5,v.IExtHostInitDataService),$e(6,E.ILogService)],w);let d=class{static{_=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(h){if(h.environment.appRoot&&_.aliased.size){const a=(0,S.escapeRegExpCharacters)(this.forceForwardSlashes(h.environment.appRoot.fsPath)),t="[a-z0-9_.-]",i=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${s}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(h){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(h));if(!a)return;const[,t,i,s]=a,n=_.aliased.get(i);if(n!==void 0)return console.warn(`${i} as been renamed to ${n}, please update your imports`),t+n+s}forceForwardSlashes(h){return h.replace(/\\/g,"/")}};d=_=je([$e(0,v.IExtHostInitDataService)],d);class o{constructor(h,a,t,i,s){this._apiFactory=h,this._extensionPaths=a,this._extensionRegistry=t,this._configProvider=i,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new g.ExtensionIdentifierMap}load(h,a){const t=this._extensionPaths.findSubstr(a);if(t){let i=this._extApiImpl.get(t.identifier);return i||(i=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((s,n)=>i+=`	${n} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let u=class{constructor(h,a,t){this._extensionPaths=h,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(f.MainContext.MainThreadTelemetry);const i=t.getProxy(f.MainContext.MainThreadWindow);this._impl=(s,n)=>{const r=O.URI.parse(s);return n?this.callOriginal(s,n):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,s,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?i.$openUri(r,s,{}):this.callOriginal(s,n)}}load(h,a,t){const i=this._extensionPaths.findSubstr(a);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=t(h),this._impl}callOriginal(h,a){return this.sendNoForwardTelemetry(),this._original(h,a)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};u=je([$e(2,y.IExtHostRpcService)],u)}),define(De[56],Ie([1,0,47,3,16,48,5,70,71,46,7,39,280,40]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class _ extends E.AbstractVariableResolverService{constructor(o,u,c,h,a,t,i){function s(){if(c){const n=c.activeEditor();if(n)return n.document.uri;const r=h.tabGroups.all.find(l=>l.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:n=>{const r=t.folders.filter(l=>l.name===n);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,r)=>a.getConfiguration(void 0,n).get(r),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=s();if(n)return f.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const n=s();if(n){const r=u.getWorkspaceFolder(n);if(r)return f.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(c){const n=c.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(c){const n=c.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>o.getExtension(n)},void 0,i?Promise.resolve(i):void 0,Promise.resolve(A.env))}}let w=class extends O.Disposable{constructor(o,u,c,h,a){super(),this.extensionService=o,this.workspaceService=u,this.editorService=c,this.configurationService=h,this.editorTabs=a,this._resolver=new I.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new _(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=w,e.ExtHostVariableResolverProviderService=w=je([$e(0,v.IExtHostExtensionService),$e(1,P.IExtHostWorkspace),$e(2,g.IExtHostDocumentsAndEditors),$e(3,S.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs)],w)}),define(De[94],Ie([1,0,8,4,2,5,6,71,46,20,7,39,140,273,40,56]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(i,s,n,r,l,k){this._workspaceService=s,this._extensionService=n,this._configurationService=r,this._editorTabs=l,this._variableResolver=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new O.Emitter,this._onDidTerminateDebugSession=new O.Emitter,this._onDidChangeActiveDebugSession=new O.Emitter,this._onDidReceiveDebugSessionCustomEvent=new O.Emitter,this._debugServiceProxy=i.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new O.Emitter,this._onDidChangeStackFrameFocus=new O.Emitter,this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(C=>{C.onDidChange(p=>{this.registerAllDebugTypes(C)}),this.registerAllDebugTypes(C)})}asDebugSourceUri(i,s){const n=i;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let r=`debug:${encodeURIComponent(n.path||"")}`,l="?";return s&&(r+=`${l}session=${encodeURIComponent(s.id)}`,l="&"),r+=`${l}ref=${n.sourceReference}`,f.URI.parse(r)}else{if(n.path)return f.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const s=[];for(const n of i.getAllExtensionDescriptions())if(n.contributes){const r=n.contributes.debuggers;if(r&&r.length>0)for(const l of r)(0,S.isDebuggerMainContribution)(l)&&s.push(l.type)}this._debugServiceProxy.$registerDebugTypes(s)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const i=[];return this._breakpoints.forEach(s=>i.push(s)),i}addBreakpoints(i){const s=i.filter(l=>{const k=l.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,l),!0)});this.fireBreakpointChanges(s,[],[]);const n=[],r=new Map;for(const l of s)if(l instanceof R.SourceBreakpoint){let k=r.get(l.location.uri.toString());k||(k={type:"sourceMulti",uri:l.location.uri,lines:[]},r.set(l.location.uri.toString(),k),n.push(k)),k.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof R.FunctionBreakpoint&&n.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(i){const s=i.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],s,[]);const n=s.filter(k=>k instanceof R.SourceBreakpoint).map(k=>k.id),r=s.filter(k=>k instanceof R.FunctionBreakpoint).map(k=>k.id),l=s.filter(k=>k instanceof R.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(n,r,l)}startDebugging(i,s,n){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,s,n){if(!s)return new R.Disposable(()=>{});const r=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:r,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,r),new R.Disposable(()=>{this._configProviders=this._configProviders.filter(l=>l.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(r)})}registerDebugAdapterDescriptorFactory(i,s,n){if(!n)return new R.Disposable(()=>{});if(!this.definesDebugType(i,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const r=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:r,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,r),new R.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(l=>l.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(r)})}registerDebugAdapterTrackerFactory(i,s){if(!s)return new R.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:n,factory:s}),new R.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(r=>r.factory!==s)})}async $runInTerminal(i,s){return Promise.resolve(void 0)}async $substituteVariables(i,s){let n;const r=await this.getFolder(i);return r&&(n={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,s)}createDebugAdapter(i,s){if(i.type==="implementation")return new h(i.implementation)}createSignService(){}async $startDASession(i,s){const n=this,r=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(r.type),r).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}' (extension might have failed to activate)`);const k=this.convertToDto(l),C=this.createDebugAdapter(k,r);if(!C)throw new Error(`Couldn't create a debug adapter for type '${r.type}'.`);const p=C;return this._debugAdapters.set(i,p),this.getDebugAdapterTrackers(r).then(m=>(m&&this._debugAdaptersTrackers.set(i,m),p.onMessage(async b=>{if(b.type==="request"&&b.command==="handshake"){const D=b,M={type:"response",seq:0,command:D.command,request_seq:D.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(D.arguments.value);M.body={signature:L},p.sendResponse(M)}else throw new Error("no signer")}catch(L){M.success=!1,M.message=L.message,p.sendResponse(M)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(b),b=(0,S.convertToVSCPaths)(b,!0),n._debugServiceProxy.$acceptDAMessage(i,b)}),p.onError(b=>{m&&m.onError&&m.onError(b),this._debugServiceProxy.$acceptDAError(i,b.name,b.message,b.stack)}),p.onExit(b=>{m&&m.onExit&&m.onExit(b??void 0,void 0),this._debugServiceProxy.$acceptDAExit(i,b??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),p.startSession()))})}$sendDAMessage(i,s){s=(0,S.convertToDAPaths)(s,!1);const n=this._debugAdaptersTrackers.get(i);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s),this._debugAdapters.get(i)?.sendMessage(s)}$stopDASession(i){const s=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),s&&s.onWillStopSession&&s.onWillStopSession();const n=this._debugAdapters.get(i);return this._debugAdapters.delete(i),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const s=[],n=[],r=[];if(i.added)for(const l of i.added){const k=l.id;if(k&&!this._breakpoints.has(k)){let C;if(l.type==="function")C=new R.FunctionBreakpoint(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")C=new R.DataBreakpoint(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const p=f.URI.revive(l.uri);C=new R.SourceBreakpoint(new R.Location(p,new R.Position(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,R.setBreakpointId)(C,k),this._breakpoints.set(k,C),s.push(C)}}if(i.removed)for(const l of i.removed){const k=this._breakpoints.get(l);k&&(this._breakpoints.delete(l),n.push(k))}if(i.changed){for(const l of i.changed)if(l.id){const k=this._breakpoints.get(l.id);if(k){if(k instanceof R.FunctionBreakpoint&&l.type==="function"){const C=k;C.enabled=l.enabled,C.condition=l.condition,C.hitCondition=l.hitCondition,C.logMessage=l.logMessage,C.functionName=l.functionName}else if(k instanceof R.SourceBreakpoint&&l.type==="source"){const C=k;C.enabled=l.enabled,C.condition=l.condition,C.hitCondition=l.hitCondition,C.logMessage=l.logMessage,C.location=new R.Location(f.URI.revive(l.uri),new R.Position(l.line,l.character))}r.push(k)}}}this.fireBreakpointChanges(s,n,r)}async $acceptStackFrameFocus(i){let s;const n=i.sessionId?await this.getSession(i.sessionId):void 0;if(!n)throw new Error("no DebugSession found for debug focus context");i.kind==="thread"?s=new R.ThreadFocus(n,i.threadId):s=new R.StackFrameFocus(n,i.threadId,i.frameId),this._stackFrameFocus=s,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(i,s,n){return(0,I.asPromise)(async()=>{const r=this.getConfigProviderByHandle(i);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.getFolder(s);return r.provideDebugConfigurations(l,n)}).then(r=>{if(!r)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return r})}$resolveDebugConfiguration(i,s,n,r){return(0,I.asPromise)(async()=>{const l=this.getConfigProviderByHandle(i);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(s);return l.resolveDebugConfiguration(k,n,r)})}$resolveDebugConfigurationWithSubstitutedVariables(i,s,n,r){return(0,I.asPromise)(async()=>{const l=this.getConfigProviderByHandle(i);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(s);return l.resolveDebugConfigurationWithSubstitutedVariables(k,n,r)})}async $provideDebugAdapter(i,s){const n=this.getAdapterDescriptorFactoryByHandle(i);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const r=await this.getSession(s);return this.getAdapterDescriptor(n,r).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}'`);return this.convertToDto(l)})}async $acceptDebugSessionStarted(i){const s=await this.getSession(i);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(i){const s=await this.getSession(i);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,s){(await this.getSession(i))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(i,s){const r={session:await this.getSession(i),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(r)}convertToDto(i){if(i instanceof R.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof R.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof R.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof R.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const s=this._adapterFactories.filter(n=>n.type===i);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(i){const s=this._adapterFactories.filter(n=>n.handle===i);if(s.length>0)return s[0].factory}getConfigProviderByHandle(i){const s=this._configProviders.filter(n=>n.handle===i);if(s.length>0)return s[0].provider}definesDebugType(i,s){if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0){for(const r of n)if(r.label&&r.type&&r.type===s)return!0}}return!1}getDebugAdapterTrackers(i){const n=i.configuration.type,r=this._trackerFactories.filter(l=>l.type===n||l.type==="*").map(l=>(0,I.asPromise)(()=>l.factory.createDebugAdapterTracker(i)).then(k=>k,k=>null));return Promise.race([Promise.all(r).then(l=>{const k=l.filter(C=>!!C);if(k.length>0)return new c(k)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async getAdapterDescriptor(i,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new R.DebugAdapterServer(n));if(i){const l=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>i.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,l))).then(k=>{if(k)return k})}const r=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,r))}daExecutableFromPackage(i,s){}fireBreakpointChanges(i,s,n){(i.length>0||s.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:s,changed:n}))}async getSession(i){if(i)if(typeof i=="string"){const s=this._debugSessions.get(i);if(s)return s}else{let s=this._debugSessions.get(i.id);if(!s){const n=await this.getFolder(i.folderUri),r=i.parent?this._debugSessions.get(i.parent):void 0;s=new o(this._debugServiceProxy,i.id,i.type,i.name,n,i.configuration,r),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(i){if(i){const s=f.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=d,e.ExtHostDebugServiceBase=d=je([$e(0,v.IExtHostRpcService),$e(1,P.IExtHostWorkspace),$e(2,y.IExtHostExtensionService),$e(3,_.IExtHostConfiguration),$e(4,g.IExtHostEditorTabs),$e(5,w.IExtHostVariableResolverProvider)],d);class o{constructor(i,s,n,r,l,k,C){this._debugServiceProxy=i,this._id=s,this._type=n,this._name=r,this._workspaceFolder=l,this._configuration=k,this._parentSession=C}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,s)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=o;class u{constructor(i){this.value=Object.freeze({append(s){i.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=u;class c{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(s=>s.onError?s.onError(i):void 0)}onExit(i,s){this.trackers.forEach(n=>n.onExit?n.onExit(i,s):void 0)}}class h extends E.AbstractDebugAdapter{constructor(i){super(),this.implementation=i,i.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends d{constructor(i,s,n,r,l,k){super(i,s,n,r,l,k)}};e.WorkerExtHostDebugService=a,e.WorkerExtHostDebugService=a=je([$e(0,v.IExtHostRpcService),$e(1,P.IExtHostWorkspace),$e(2,y.IExtHostExtensionService),$e(3,_.IExtHostConfiguration),$e(4,g.IExtHostEditorTabs),$e(5,w.IExtHostVariableResolverProvider)],a)}),define(De[354],Ie([1,0,9,54,2,6,345,14,103,104,27,239,20,67,46,88]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class d{static async installEarlyHandler(c){Error.stackTraceLimit=100;const h=c.get(g.ILogService),t=c.get(E.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(i=>{h.error(i);const s=I.transformErrorForSerialization(i);t.$onUnexpectedError(s)})}static async installFullHandler(c){const h=c.get(g.ILogService),a=c.get(E.IExtHostRpcService),t=c.get(_.IExtHostExtensionService),i=c.get(w.IExtHostTelemetry),s=a.getProxy(A.MainContext.MainThreadExtensionService),n=a.getProxy(A.MainContext.MainThreadErrors),r=await t.getExtensionPathIndex(),l=new WeakMap;function k(m,b){if(l.has(m))return l.get(m).stack;let D="",M,L;for(const x of b)D+=`
	at ${x.toString()}`,L=x.getFileName(),!M&&L&&(M=r.findSubstr(f.URI.file(L)));const F=`${m.name||"Error"}: ${m.message||""}${D}`;return l.set(m,{extensionIdentifier:M?.identifier,stack:F}),F}const C=Symbol("prepareStackTrace wrapped");let p=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(m){if(m===k||!m||m[C]){p=m||k;return}p=function(b,D){return k(b,D),m.call(Error,b,D)},Object.assign(p,{[C]:!0})}}),I.setUnexpectedErrorHandler(m=>{h.error(m);const b=I.transformErrorForSerialization(m),D=l.get(m);if(!D?.extensionIdentifier){n.$onUnexpectedError(b);return}s.$onExtensionRuntimeError(D.extensionIdentifier,b);const M=i.onExtensionError(D.extensionIdentifier,m);h.trace("forwarded error to extension?",M,D)})}}e.ErrorHandler=d;class o{constructor(c,h,a,t,i){this._hostUtils=a,this._rpcProtocol=new T.RPCProtocol(c,null,t),h=o._transform(h,this._rpcProtocol);const s=new v.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());s.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...h,messagePorts:i}),s.set(E.IExtHostRpcService,new E.ExtHostRpcService(this._rpcProtocol)),s.set(S.IURITransformerService,new S.URITransformerService(t)),s.set(_.IHostUtils,a);const n=new P.InstantiationService(s,!0);n.invokeFunction(d.installEarlyHandler),this._logService=n.invokeFunction(r=>r.get(g.ILogService)),O.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",h),this._extensionService=n.invokeFunction(r=>r.get(_.IExtHostExtensionService)),this._extensionService.initialize(),n.invokeFunction(d.installFullHandler)}async asBrowserUri(c){const h=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return f.URI.revive(await h.$asBrowserUri(c))}terminate(c){this._extensionService.terminate(c)}static _transform(c,h){c.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(h.transformIncomingURIs(t.extensionLocation))}),c.environment.appRoot=f.URI.revive(h.transformIncomingURIs(c.environment.appRoot));const a=c.environment.extensionDevelopmentLocationURI;return a&&(c.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(h.transformIncomingURIs(t)))),c.environment.extensionTestsLocationURI=f.URI.revive(h.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=f.URI.revive(h.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=f.URI.revive(h.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=f.URI.revive(h.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=f.URI.revive(h.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=f.URI.revive(h.transformIncomingURIs(c.logsLocation)),c.workspace=h.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=o}),define(De[355],Ie([1,0,8,12,216,233,138,94,71,46,20,45,7,56,39,274,275,40]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let u=class extends g.ExtHostDebugServiceBase{constructor(i,s,n,r,l,k,C){super(i,s,n,r,k,C),this._terminalService=l,this._integratedTerminalInstances=new a}createDebugAdapter(i,s){switch(i.type){case"server":return new w.SocketDebugAdapter(i);case"pipeServer":return new w.NamedPipeDebugAdapter(i);case"executable":return new w.ExecutableDebugAdapter(i,s.type)}return super.createDebugAdapter(i,s)}daExecutableFromPackage(i,s){const n=w.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),i.type);if(n)return new E.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new T.SignService}async $runInTerminal(i,s){if(i.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(F=>{this._integratedTerminalInstances.onTerminalClosed(F)}));const n=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),l=this._terminalService.getDefaultShellArgs(!0),k=i.title||f.localize(0,null),C=JSON.stringify({shell:r,shellArgs:l});let p=await this._integratedTerminalInstances.checkout(C,k),m,b=!1;if(p)m=i.cwd;else{const F={shellPath:r,shellArgs:l,cwd:i.cwd,name:k,iconPath:new E.ThemeIcon("debug")};b=!0,p=this._terminalService.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(p,C)}p.show(!0);const D=await p.processId;b?await new Promise(F=>setTimeout(F,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?p.sendText("cls"):r.indexOf("bash")>=0?p.sendText("clear"):O.isWindows?p.sendText("cls"):p.sendText("clear"));const M=(0,d.prepareCommand)(r,i.args,!!i.argsCanBeInterpretedByShell,m,i.env);p.sendText(M);const L=this.onDidTerminateDebugSession(F=>{F.id===s&&(this._integratedTerminalInstances.free(p),L.dispose())});return D}else if(i.kind==="external")return h(i,await this._configurationService.getConfigProvider());return super.$runInTerminal(i,s)}};e.ExtHostDebugService=u,e.ExtHostDebugService=u=je([$e(0,R.IExtHostRpcService),$e(1,_.IExtHostWorkspace),$e(2,v.IExtHostExtensionService),$e(3,o.IExtHostConfiguration),$e(4,P.IExtHostTerminalService),$e(5,y.IExtHostEditorTabs),$e(6,S.IExtHostVariableResolverProvider)],u);let c;function h(t,i){if(!c)if(O.isWindows)c=new A.WindowsExternalTerminalService;else if(O.isMacintosh)c=new A.MacExternalTerminalService;else if(O.isLinux)c=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=i.getConfiguration("terminal");return c.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class a{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(i,s){const r=[...this._terminalInstances.entries()].map(([l,k])=>(0,I.createCancelablePromise)(async C=>{if(l.name!==s||k.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await l.processId))return null;const p=Date.now();return k.lastUsedAt+a.minUseDelay>p||C.isCancellationRequested||k.config!==i?null:(k.lastUsedAt=p,l)}));return await(0,I.firstParallel)(r,l=>!!l)}insert(i,s){this._terminalInstances.set(i,{lastUsedAt:Date.now(),config:s})}free(i){const s=this._terminalInstances.get(i);s&&(s.lastUsedAt=-1)}onTerminalClosed(i){this._terminalInstances.delete(i)}}}),define(De[356],Ie([1,0,16,2,101,39,70,40,44,45,20,27,93,18,14,89,23,63,56]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let c=class extends E.ExtHostTaskBase{constructor(a,t,i,s,n,r,l,k,C){super(a,t,i,s,n,r,l,k),this.workspaceService=i,this.variableResolver=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const i=t;if(!t.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const s=E.TaskHandleDTO.from(i,this.workspaceService),n=await this._proxy.$getTaskExecution(s);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(n,t);return this._proxy.$executeTask(s).catch(()=>{}),r}else{const s=E.TaskDTO.from(t,a);if(s===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,t,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),t);return this._proxy.$executeTask(s).catch(()=>{}),n}}provideTasksInternal(a,t,i,s){const n=[];if(s)for(const r of s){this.checkDeprecation(r,i),(!r.definition||!a[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const l=E.TaskDTO.from(r,i.extension);l&&(n.push(l),E.CustomExecutionDTO.is(l.execution)&&t.push(this.addCustomExecution(l,r,!0)))}return{tasks:n,extension:i.extension}}async resolveTaskInternal(a){return a}async getAFolder(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const i=O.URI.file((0,o.homedir)());t=new y.WorkspaceFolder({uri:i,name:d.basename(i),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const i=O.URI.revive(a),s={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(i),r=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.variableResolver.getResolver(),k=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(r);for(const C of t.variables)s.variables[C]=await l.resolveAsync(k,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(I.delimiter);for(let p=0;p<C.length;p++)C[p]=await l.resolveAsync(k,C[p])}s.process=await f.win32.findExecutable(await l.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(k,t.process.cwd):void 0,C)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,i){return f.win32.findExecutable(a,t,i)}};e.ExtHostTask=c,e.ExtHostTask=c=je([$e(0,R.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,T.IExtHostDocumentsAndEditors),$e(4,g.IExtHostConfiguration),$e(5,v.IExtHostTerminalService),$e(6,_.ILogService),$e(7,w.IExtHostApiDeprecationService),$e(8,u.IExtHostVariableResolverProvider)],c)}),define(De[357],Ie([1,0,63,56]),function(pe,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class f extends O.ExtHostVariableResolverProviderService{homeDir(){return(0,I.homedir)()}}e.NodeExtHostVariableResolverProviderService=f}),define(De[153],Ie([1,0,19,8,21,41,18,16,23,2,37]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(u,c,h,a){this.query=u,this.provider=c,this.fileUtils=h,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,c){const h=this.query.folderQueries||[],a=new f.CancellationTokenSource(c);return new Promise((t,i)=>{this.collector=new S(u);let s=!1;const n=(r,l)=>{if(!s&&!this.isLimitHit){const k=this.resultSize(r);w(r)&&typeof this.query.maxResults=="number"&&this.resultCount+k>this.query.maxResults&&(this.isLimitHit=!0,s=!0,a.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const C=this.resultSize(r);this.resultCount+=C,(C>0||!w(r))&&this.collector.add(r,l)}};Promise.all(h.map((r,l)=>this.searchInFolder(r,k=>n(k,l),a.token))).then(r=>{a.dispose(),this.collector.flush();const l=r.some(k=>!!k&&!!k.limitHit);t({limitHit:this.isLimitHit||l,messages:(0,I.flatten)(r.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.processType}})},r=>{a.dispose();const l=(0,A.toErrorMessage)(r);i(new Error(l))})})}resultSize(u){return w(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,c){const h=Array.isArray(u.ranges)?u.ranges:[u.ranges],a=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:h.slice(0,c),preview:{matches:a.slice(0,c),text:u.preview.text},uri:u.uri}}async searchInFolder(u,c,h){const a=new R.QueryGlobTester(this.query,u),t=[],i={report:r=>{if(!this.validateProviderResult(r))return;const l=u.folder.scheme===T.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(r.uri))):void 0,k=y.relativePath(u.folder,r.uri);if(k){const C=a.includedInQuery(k,g.basename(k),l);(0,O.isThenable)(C)?t.push(C.then(p=>{p&&c(r)})):C&&c(r)}}},s=this.getSearchOptionsForFolder(u),n=await this.provider.provideTextSearchResults(E(this.query.contentPattern),s,i,h);return t.length&&await Promise.all(t),n}validateProviderResult(u){if(w(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const c=(0,R.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),h=(0,R.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),a={folder:v.URI.from(u.folder),excludes:h,includes:c,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=P;function E(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class S{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new d(512,c=>this.sendItems(c))}add(u,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(_(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=S;function _(o){return w(o)?{preview:{matches:(0,I.mapArrayOrNot)(o.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:o.preview.text},ranges:(0,I.mapArrayOrNot)(o.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function w(o){return!!o.preview}e.extensionResultIsMatch=w;class d{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(u,c){this.maxBatchSize=u,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,c){u&&this.addItemToBatch(u,c)}addItems(u,c){u&&this.addItemsToBatch(u,c)}addItemToBatch(u,c){this.batch.push(u),this.batchSize+=c,this.onUpdate()}addItemsToBatch(u,c){this.batch=this.batch.concat(u),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<d.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},d.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=d}),define(De[95],Ie([1,0,3,6,5,350,20,67,14,2,153]),function(pe,e,I,O,f,A,T,g,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,f.createDecorator)("IExtHostSearch");let P=class{constructor(w,d,o){this.extHostRpc=w,this._uriTransformer=d,this._logService=o,this._proxy=this.extHostRpc.getProxy(O.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,d){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const o=this._handlePool++;return this._textSearchProvider.set(o,d),this._proxy.$registerTextSearchProvider(o,this._transformScheme(w)),(0,I.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(w,d){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const o=this._handlePool++;return this._fileSearchProvider.set(o,d),this._proxy.$registerFileSearchProvider(o,this._transformScheme(w)),(0,I.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(w,d,o,u){const c=E(o),h=this._fileSearchProvider.get(w);if(h)return this._fileSearchManager.fileSearch(c,h,a=>{this._proxy.$handleFileMatch(w,d,a.map(t=>t.resource))},u);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,d,o,u){const c=this._textSearchProvider.get(w);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const h=E(o);return this.createTextSearchManager(h,c).search(t=>this._proxy.$handleTextMatch(w,d,t),u)}$enableExtensionHostSearch(){}createTextSearchManager(w,d){return new R.TextSearchManager(w,d,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.ExtHostSearch=P,e.ExtHostSearch=P=je([$e(0,T.IExtHostRpcService),$e(1,g.IURITransformerService),$e(2,y.ILogService)],P);function E(_){return{..._,folderQueries:_.folderQueries&&_.folderQueries.map(S),extraFileResources:_.extraFileResources&&_.extraFileResources.map(w=>v.URI.revive(w))}}e.reviveQuery=E;function S(_){return{..._,folder:v.URI.revive(_.folder)}}}),define(De[358],Ie([1,0,21,9,4,38,2,130,125,168,185,30,6,111,304,303,34,305,40,307,308,309,284,310,70,46,312,313,318,319,320,152,288,326,327,330,115,45,332,289,13,7,85,335,91,151,39,25,278,317,66,149,93,94,95,14,67,20,27,321,276,73,89,296,333,90,72,338,336,337,297,55,331,334,114,71,88,322,92,323,18,134,287,264,315,3,26,272,112,258,324,325,298,314,286,316,113,328,301,329,302,295,311,299,300]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a,t,i,s,n,r,l,k,C,p,m,b,D,M,L,F,x,U,N,z,V,ge,te,q,K,ue,ie,ce,Se,j,$,X,re,Q,Z,J,be,ae,fe,ee,he,ve,Pe,B,G,se,oe,Y,me,ye,xe,We,Ze,Xe,it,tt,Te,Me,ze,Re,Qe,de,le,ke,Ve,Be,Ye,nt,ct,vt,yt,Vt,jt,bt,xt,Mt,qt,Bt,Dt,Ft,$t,Gt,Wt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(lt){const ft=lt.get(ae.IExtHostInitDataService),Tt=lt.get(xe.IExtHostFileSystemInfo),Ht=lt.get(se.IExtHostConsumerFileSystem),At=lt.get(n.IExtHostExtensionService),at=lt.get(ue.IExtHostWorkspace),wt=lt.get(tt.IExtHostTelemetry),Ot=lt.get(u.IExtHostConfiguration),Pt=lt.get(J.IURITransformerService),qe=lt.get(be.IExtHostRpcService),Kt=lt.get(F.IExtHostStorage),Le=lt.get(G.IExtensionStoragePaths),Oe=lt.get(Z.ILoggerService),Ce=lt.get(Z.ILogService),ne=lt.get(he.IExtHostTunnelService),Fe=lt.get(ve.IExtHostApiDeprecationService),He=lt.get(K.IExtHostWindow),Je=lt.get(Xe.IExtHostSecretState),Ge=lt.get(it.IExtHostEditorTabs),rt=lt.get(Mt.IExtHostManagedSockets);qe.set(E.ExtHostContext.ExtHostFileSystemInfo,Tt),qe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Oe),qe.set(E.ExtHostContext.ExtHostWorkspace,at),qe.set(E.ExtHostContext.ExtHostConfiguration,Ot),qe.set(E.ExtHostContext.ExtHostExtensionService,At),qe.set(E.ExtHostContext.ExtHostStorage,Kt),qe.set(E.ExtHostContext.ExtHostTunnelService,ne),qe.set(E.ExtHostContext.ExtHostWindow,He),qe.set(E.ExtHostContext.ExtHostSecretState,Je),qe.set(E.ExtHostContext.ExtHostTelemetry,wt),qe.set(E.ExtHostContext.ExtHostEditorTabs,Ge),qe.set(E.ExtHostContext.ExtHostManagedSockets,rt);const _t=qe.set(E.ExtHostContext.ExtHostDecorations,lt.get($.IExtHostDecorations)),Ct=qe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(s.IExtHostDocumentsAndEditors)),gt=qe.set(E.ExtHostContext.ExtHostCommands,lt.get(d.IExtHostCommands)),ht=qe.set(E.ExtHostContext.ExtHostTerminalService,lt.get(x.IExtHostTerminalService)),mt=qe.set(E.ExtHostContext.ExtHostDebugService,lt.get(re.IExtHostDebugService)),gi=qe.set(E.ExtHostContext.ExtHostSearch,lt.get(Q.IExtHostSearch)),It=qe.set(E.ExtHostContext.ExtHostTask,lt.get(X.IExtHostTask)),Di=qe.set(E.ExtHostContext.ExtHostOutputService,lt.get(m.IExtHostOutputService)),li=qe.set(E.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),pi=qe.set(E.ExtHostContext.ExtHostUrls,new te.ExtHostUrls(qe)),kt=qe.set(E.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(qe,Ct)),mn=qe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(qe,Ct,Ce)),ri=qe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ce,kt,qe.getProxy(E.MainContext.MainThreadBulkEdits))),St=qe.set(E.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(qe,gt,Ct,kt,Ht)),vi=qe.set(E.ExtHostContext.ExtHostNotebookDocuments,new le.ExtHostNotebookDocuments(St)),Ei=qe.set(E.ExtHostContext.ExtHostNotebookEditors,new de.ExtHostNotebookEditors(Ce,St)),si=qe.set(E.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(qe,ft,St,gt,Ce)),Ii=qe.set(E.ExtHostContext.ExtHostNotebookRenderers,new ze.ExtHostNotebookRenderers(qe,St)),ki=qe.set(E.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new bt.ExtHostNotebookDocumentSaveParticipant(Ce,St,qe.getProxy(E.MainContext.MainThreadBulkEdits))),Rt=qe.set(E.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(qe,Ct)),bi=qe.set(E.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(qe.getProxy(E.MainContext.MainThreadTreeViews),gt,Ce)),Pi=qe.set(E.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(qe.getProxy(E.MainContext.MainThreadEditorInsets),Rt,ft.remote)),oi=qe.set(E.ExtHostContext.ExtHostDiagnostics,new c.ExtHostDiagnostics(qe,Ce,Tt,Ct)),ui=qe.set(E.ExtHostContext.ExtHostLanguages,new C.ExtHostLanguages(qe,kt,gt.converter,Pt)),ut=qe.set(E.ExtHostContext.ExtHostLanguageFeatures,new k.ExtHostLanguageFeatures(qe,Pt,kt,gt,oi,Ce,Fe,wt)),Ti=qe.set(E.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(qe,ut)),Yt=qe.set(E.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(qe,Ce,Ct)),ii=qe.set(E.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(qe,at,gt)),Ai=qe.set(E.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(qe,gt,kt,Ce)),Ri=qe.set(E.ExtHostContext.ExtHostQuickDiff,new yt.ExtHostQuickDiff(qe,Pt)),Li=qe.set(E.ExtHostContext.ExtHostShare,new qt.ExtHostShare(qe,Pt)),Xi=qe.set(E.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(qe,gt,kt)),Fi=qe.set(E.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(qe.getProxy(E.MainContext.MainThreadProgress))),Qi=qe.set(E.ExtHostContext.ExtHosLabelService,new Se.ExtHostLabelService(qe)),Oi=qe.set(E.ExtHostContext.ExtHostTheming,new ee.ExtHostTheming(qe)),ai=qe.set(E.ExtHostContext.ExtHostAuthentication,new Pe.ExtHostAuthentication(qe)),gn=qe.set(E.ExtHostContext.ExtHostTimeline,new B.ExtHostTimeline(qe,gt)),Mi=qe.set(E.ExtHostContext.ExtHostWebviews,new q.ExtHostWebviews(qe,ft.remote,at,Ce,Fe)),di=qe.set(E.ExtHostContext.ExtHostWebviewPanels,new me.ExtHostWebviewPanels(qe,Mi,at)),Ni=qe.set(E.ExtHostContext.ExtHostCustomEditors,new Y.ExtHostCustomEditors(qe,kt,Le,Mi,di)),pn=qe.set(E.ExtHostContext.ExtHostWebviewViews,new oe.ExtHostWebviewViews(qe,Mi)),hi=qe.set(E.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(qe,gt,Ct)),Yi=qe.set(E.ExtHostContext.ExtHostUriOpeners,new Ze.ExtHostUriOpeners(qe)),Ui=qe.set(E.ExtHostContext.ExtHostProfileContentHandlers,new vt.ExtHostProfileContentHandlers(qe));qe.set(E.ExtHostContext.ExtHostInteractive,new ke.ExtHostInteractive(qe,St,Ct,gt,Ce));const Ji=qe.set(E.ExtHostContext.ExtHostInlineChat,new jt.ExtHostInteractiveEditor(qe,gt,kt,Ce)),fi=qe.set(E.ExtHostContext.ExtHostChatProvider,new Bt.ExtHostChatProvider(qe,Ce)),Zi=qe.set(E.ExtHostContext.ExtHostChatAgents,new Wt.ExtHostChatAgents(qe,fi,Ce)),vn=qe.set(E.ExtHostContext.ExtHostChatAgents2,new zt.ExtHostChatAgents2(qe,fi,Ce)),xi=qe.set(E.ExtHostContext.ExtHostChatVariables,new Ft.ExtHostChatVariables(qe)),mi=qe.set(E.ExtHostContext.ExtHostChat,new Vt.ExtHostChat(qe,Ce)),Jt=qe.set(E.ExtHostContext.ExtHostAiRelatedInformation,new $t.ExtHostRelatedInformation(qe)),wi=qe.set(E.ExtHostContext.ExtHostAiEmbeddingVector,new Gt.ExtHostAiEmbeddingVector(qe)),en=qe.set(E.ExtHostContext.ExtHostIssueReporter,new xt.ExtHostIssueReporter(qe)),Xt=qe.set(E.ExtHostContext.ExtHostStatusBar,new L.ExtHostStatusBar(qe,gt.converter)),Si=qe.set(E.ExtHostContext.ExtHostSpeech,new Dt.ExtHostSpeech(qe)),tn=Object.values(E.ExtHostContext);qe.assertRegistered(tn);const nn=new ye.ExtHostBulkEdits(qe,Ct),rn=new w.ExtHostClipboard(qe),yi=new p.ExtHostMessageService(qe,Ce),sn=new h.ExtHostDialogs(qe);return _.ExtHostApiCommands.register(gt),function(Ue,Zt,on){const pt=function(){let Ee=!Ue.isUnderDevelopment;function _e(){Ee||(Ce.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Ee=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")_e();else{const Et=st;typeof Et.scheme>"u"&&_e(),typeof Et.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return st}}(),Bi={getSession(Ee,_e,Ne){return ai.getSession(Ue,Ee,_e,Ne)},getSessions(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"authGetSessions"),ai.getSessions(Ue,Ee,_e)},async hasSession(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"authSession"),!!await ai.getSession(Ue,Ee,_e,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(Ee,_e,Ne,st){return ai.registerAuthenticationProvider(Ee,_e,Ne,st)}},an={registerCommand(Ee,_e,Ne){return gt.registerCommand(!0,Ee,_e,Ne,void 0,Ue)},registerTextEditorCommand(Ee,_e,Ne){return gt.registerCommand(!0,Ee,(...st)=>{const Et=Rt.getActiveTextEditor();if(!Et){Ce.warn("Cannot execute "+Ee+" because there is no active text editor.");return}return Et.edit(Lt=>{_e.apply(Ne,[Et,Lt,...st])}).then(Lt=>{Lt||Ce.warn("Edits from command "+Ee+" were not applied.")},Lt=>{Ce.warn("An error occurred while running command "+Ee,Lt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(Ee,_e,Ne)=>((0,Be.checkProposedApiEnabled)(Ue,"diffCommand"),gt.registerCommand(!0,Ee,async(...st)=>{const Et=Ct.activeEditor(!0);if(!Et){Ce.warn("Cannot execute "+Ee+" because there is no active text editor.");return}const Lt=await Rt.getDiffInformation(Et.id);_e.apply(Ne,[Lt,...st])},void 0,void 0,Ue)),executeCommand(Ee,..._e){return gt.executeCommand(Ee,..._e)},getCommands(Ee=!1){return gt.getCommands(Ee)}},$i={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return ht.getDefaultShell(!1)},get onDidChangeShell(){return ht.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(Ue,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(Ue,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(Ee,_e){return tt.ExtHostTelemetryLogger.validateSender(Ee),wt.instantiateLogger(Ue,Ee,_e)},openExternal(Ee,_e){return He.openUri(Ee,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(Ee){if(Ee.scheme===ft.environment.appUriScheme)return pi.createAppUri(Ee);try{return await He.asExternalUri(Ee,{allowTunneling:!!ft.remote.authority})}catch(_e){if((0,Qe.matchesScheme)(Ee,Re.Schemas.http)||(0,Qe.matchesScheme)(Ee,Re.Schemas.https))return Ee;throw _e}},get remoteName(){return(0,j.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(Ue,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Ce.getLevel()},get onDidChangeLogLevel(){return Ce.onDidChangeLogLevel},registerIssueUriRequestHandler(Ee){return(0,Be.checkProposedApiEnabled)(Ue,"handleIssueUri"),en.registerIssueUriRequestHandler(Ue,Ee)},registerIssueDataProvider(Ee){return(0,Be.checkProposedApiEnabled)(Ue,"handleIssueUri"),en.registerIssueDataProvider(Ue,Ee)},get appQuality(){return(0,Be.checkProposedApiEnabled)(Ue,"resolvers"),ft.quality},get appCommit(){return(0,Be.checkProposedApiEnabled)(Ue,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze($i);const cn={createTestController(Ee,_e,Ne){return hi.createTestController(Ue,Ee,_e,Ne)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(Ue,"testObserver"),hi.createTestObserver()},runTests(Ee){return(0,Be.checkProposedApiEnabled)(Ue,"testObserver"),hi.runTests(Ee)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(Ue,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(Ue,"testObserver"),hi.results}},_i=ft.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,En={getExtension(Ee,_e){(0,Be.isProposedApiEnabled)(Ue,"extensionsAny")||(_e=!1);const Ne=Zt.mine.getExtensionDescription(Ee);if(Ne)return new n.Extension(At,Ue.identifier,Ne,_i,!1);if(_e){const st=Zt.all.getExtensionDescription(Ee);if(st)return new n.Extension(At,Ue.identifier,st,_i,!0)}},get all(){const Ee=[];for(const _e of Zt.mine.getAllExtensionDescriptions())Ee.push(new n.Extension(At,Ue.identifier,_e,_i,!1));return Ee},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(Ue,"extensionsAny");const Ee=new ie.ExtensionIdentifierSet(Zt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),_e=[];for(const Ne of Zt.all.getAllExtensionDescriptions()){const st=!Ee.has(Ne.identifier);_e.push(new n.Extension(At,Ue.identifier,Ne,_i,st))}return _e},get onDidChange(){return(0,Be.isProposedApiEnabled)(Ue,"extensionsAny")?f.Event.any(Zt.mine.onDidChange,Zt.all.onDidChange):Zt.mine.onDidChange}},ln={createDiagnosticCollection(Ee){return oi.createDiagnosticCollection(Ue.identifier,Ee)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:Ee=>oi.getDiagnostics(Ee),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(Ee,_e){return ui.changeLanguage(Ee.uri,_e)},match(Ee,_e){const Ne=kt.getDocumentData(_e.uri)?.notebook;return(0,R.score)(z.LanguageSelector.from(Ee),_e.uri,_e.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(Ee,_e,Ne){return ut.registerCodeActionProvider(Ue,pt(Ee),_e,Ne)},registerDocumentPasteEditProvider(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,pt(Ee),_e,Ne)},registerCodeLensProvider(Ee,_e){return ut.registerCodeLensProvider(Ue,pt(Ee),_e)},registerDefinitionProvider(Ee,_e){return ut.registerDefinitionProvider(Ue,pt(Ee),_e)},registerDeclarationProvider(Ee,_e){return ut.registerDeclarationProvider(Ue,pt(Ee),_e)},registerImplementationProvider(Ee,_e){return ut.registerImplementationProvider(Ue,pt(Ee),_e)},registerTypeDefinitionProvider(Ee,_e){return ut.registerTypeDefinitionProvider(Ue,pt(Ee),_e)},registerHoverProvider(Ee,_e){return ut.registerHoverProvider(Ue,pt(Ee),_e,Ue.identifier)},registerEvaluatableExpressionProvider(Ee,_e){return ut.registerEvaluatableExpressionProvider(Ue,pt(Ee),_e,Ue.identifier)},registerInlineValuesProvider(Ee,_e){return ut.registerInlineValuesProvider(Ue,pt(Ee),_e,Ue.identifier)},registerDocumentHighlightProvider(Ee,_e){return ut.registerDocumentHighlightProvider(Ue,pt(Ee),_e)},registerLinkedEditingRangeProvider(Ee,_e){return ut.registerLinkedEditingRangeProvider(Ue,pt(Ee),_e)},registerReferenceProvider(Ee,_e){return ut.registerReferenceProvider(Ue,pt(Ee),_e)},registerRenameProvider(Ee,_e){return ut.registerRenameProvider(Ue,pt(Ee),_e)},registerDocumentSymbolProvider(Ee,_e,Ne){return ut.registerDocumentSymbolProvider(Ue,pt(Ee),_e,Ne)},registerWorkspaceSymbolProvider(Ee){return ut.registerWorkspaceSymbolProvider(Ue,Ee)},registerDocumentFormattingEditProvider(Ee,_e){return ut.registerDocumentFormattingEditProvider(Ue,pt(Ee),_e)},registerDocumentRangeFormattingEditProvider(Ee,_e){return ut.registerDocumentRangeFormattingEditProvider(Ue,pt(Ee),_e)},registerOnTypeFormattingEditProvider(Ee,_e,Ne,...st){return ut.registerOnTypeFormattingEditProvider(Ue,pt(Ee),_e,[Ne].concat(st))},registerDocumentSemanticTokensProvider(Ee,_e,Ne){return ut.registerDocumentSemanticTokensProvider(Ue,pt(Ee),_e,Ne)},registerDocumentRangeSemanticTokensProvider(Ee,_e,Ne){return ut.registerDocumentRangeSemanticTokensProvider(Ue,pt(Ee),_e,Ne)},registerSignatureHelpProvider(Ee,_e,Ne,...st){return typeof Ne=="object"?ut.registerSignatureHelpProvider(Ue,pt(Ee),_e,Ne):ut.registerSignatureHelpProvider(Ue,pt(Ee),_e,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(Ee,_e,...Ne){return ut.registerCompletionItemProvider(Ue,pt(Ee),_e,Ne)},registerInlineCompletionItemProvider(Ee,_e,Ne){return _e.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,Be.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),Ne&&(0,Be.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,pt(Ee),_e,Ne)},registerDocumentLinkProvider(Ee,_e){return ut.registerDocumentLinkProvider(Ue,pt(Ee),_e)},registerColorProvider(Ee,_e){return ut.registerColorProvider(Ue,pt(Ee),_e)},registerFoldingRangeProvider(Ee,_e){return ut.registerFoldingRangeProvider(Ue,pt(Ee),_e)},registerSelectionRangeProvider(Ee,_e){return ut.registerSelectionRangeProvider(Ue,Ee,_e)},registerCallHierarchyProvider(Ee,_e){return ut.registerCallHierarchyProvider(Ue,Ee,_e)},registerTypeHierarchyProvider(Ee,_e){return ut.registerTypeHierarchyProvider(Ue,Ee,_e)},setLanguageConfiguration:(Ee,_e)=>ut.setLanguageConfiguration(Ue,Ee,_e),getTokenInformationAtPosition(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"tokenInformation"),ui.tokenAtPosition(Ee,_e)},registerInlayHintsProvider(Ee,_e){return ut.registerInlayHintsProvider(Ue,Ee,_e)},createLanguageStatusItem(Ee,_e){return ui.createLanguageStatusItem(Ue,Ee,_e)},registerDocumentDropEditProvider(Ee,_e,Ne){return ut.registerDocumentOnDropEditProvider(Ue,Ee,_e,(0,Be.isProposedApiEnabled)(Ue,"dropMetadata")?Ne:void 0)}},un={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(Ee,_e,Ne){const st=await(T.URI.isUri(Ee)?Promise.resolve(Ci.openTextDocument(Ee)):Promise.resolve(Ee));return Rt.showTextDocument(st,_e,Ne)},createTextEditorDecorationType(Ee){return Rt.createTextEditorDecorationType(Ue,Ee)},onDidChangeActiveTextEditor(Ee,_e,Ne){return Rt.onDidChangeActiveTextEditor(Ee,_e,Ne)},onDidChangeVisibleTextEditors(Ee,_e,Ne){return Rt.onDidChangeVisibleTextEditors(Ee,_e,Ne)},onDidChangeTextEditorSelection(Ee,_e,Ne){return Rt.onDidChangeTextEditorSelection(Ee,_e,Ne)},onDidChangeTextEditorOptions(Ee,_e,Ne){return Rt.onDidChangeTextEditorOptions(Ee,_e,Ne)},onDidChangeTextEditorVisibleRanges(Ee,_e,Ne){return Rt.onDidChangeTextEditorVisibleRanges(Ee,_e,Ne)},onDidChangeTextEditorViewColumn(Ee,_e,Ne){return Rt.onDidChangeTextEditorViewColumn(Ee,_e,Ne)},onDidCloseTerminal(Ee,_e,Ne){return ht.onDidCloseTerminal(Ee,_e,Ne)},onDidOpenTerminal(Ee,_e,Ne){return ht.onDidOpenTerminal(Ee,_e,Ne)},onDidChangeActiveTerminal(Ee,_e,Ne){return ht.onDidChangeActiveTerminal(Ee,_e,Ne)},onDidChangeTerminalDimensions(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"terminalDimensions"),ht.onDidChangeTerminalDimensions(Ee,_e,Ne)},onDidChangeTerminalState(Ee,_e,Ne){return ht.onDidChangeTerminalState(Ee,_e,Ne)},onDidWriteTerminalData(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ht.onDidWriteTerminalData(Ee,_e,Ne)},onDidExecuteTerminalCommand(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"terminalExecuteCommandEvent"),ht.onDidExecuteTerminalCommand(Ee,_e,Ne)},get state(){return He.getState(Ue)},onDidChangeWindowState(Ee,_e,Ne){return He.onDidChangeWindowState(Ee,_e,Ne)},showInformationMessage(Ee,..._e){return yi.showMessage(Ue,A.default.Info,Ee,_e[0],_e.slice(1))},showWarningMessage(Ee,..._e){return yi.showMessage(Ue,A.default.Warning,Ee,_e[0],_e.slice(1))},showErrorMessage(Ee,..._e){return yi.showMessage(Ue,A.default.Error,Ee,_e[0],_e.slice(1))},showQuickPick(Ee,_e,Ne){return ii.showQuickPick(Ue,Ee,_e,Ne)},showWorkspaceFolderPick(Ee){return ii.showWorkspaceFolderPick(Ee)},showInputBox(Ee,_e){return ii.showInput(Ee,_e)},showOpenDialog(Ee){return sn.showOpenDialog(Ue,Ee)},showSaveDialog(Ee){return sn.showSaveDialog(Ee)},createStatusBarItem(Ee,_e,Ne){let st,Et,Lt;return typeof Ee=="string"?(st=Ee,Et=_e,Lt=Ne):(Et=Ee,Lt=_e),Xt.createStatusBarEntry(Ue,st,Et,Lt)},setStatusBarMessage(Ee,_e){return Xt.setStatusBarMessage(Ee,_e)},withScmProgress(Ee){return Fe.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Fi.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(_e,Ne)=>Ee({report(st){}}))},withProgress(Ee,_e){return Fi.withProgress(Ue,Ee,_e)},createOutputChannel(Ee,_e){return Di.createOutputChannel(Ee,_e,Ue)},createWebviewPanel(Ee,_e,Ne,st){return di.createWebviewPanel(Ue,Ee,_e,Ne,st)},createWebviewTextEditorInset(Ee,_e,Ne,st){return(0,Be.checkProposedApiEnabled)(Ue,"editorInsets"),Pi.createWebviewEditorInset(Ee,_e,Ne,st,Ue)},createTerminal(Ee,_e,Ne){return typeof Ee=="object"?"pty"in Ee?ht.createExtensionTerminal(Ee):ht.createTerminalFromOptions(Ee):ht.createTerminal(Ee,_e,Ne)},registerTerminalLinkProvider(Ee){return ht.registerLinkProvider(Ee)},registerTerminalProfileProvider(Ee,_e){return ht.registerProfileProvider(Ue,Ee,_e)},registerTerminalQuickFixProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ht.registerTerminalQuickFixProvider(Ee,Ue.identifier.value,_e)},registerTreeDataProvider(Ee,_e){return bi.registerTreeDataProvider(Ee,_e,Ue)},createTreeView(Ee,_e){return bi.createTreeView(Ee,_e,Ue)},registerWebviewPanelSerializer:(Ee,_e)=>di.registerWebviewPanelSerializer(Ue,Ee,_e),registerCustomEditorProvider:(Ee,_e,Ne={})=>Ni.registerCustomEditorProvider(Ue,Ee,_e,Ne),registerFileDecorationProvider(Ee){return _t.registerFileDecorationProvider(Ee,Ue)},registerUriHandler(Ee){return pi.registerUriHandler(Ue,Ee)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(Ee,_e,Ne){return Oi.onDidChangeActiveColorTheme(Ee,_e,Ne)},registerWebviewViewProvider(Ee,_e,Ne){return pn.registerWebviewViewProvider(Ue,Ee,_e,Ne?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(Ee,_e,Ne){return St.onDidChangeActiveNotebookEditor(Ee,_e,Ne)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Ee,_e,Ne){return Ei.onDidChangeNotebookEditorSelection(Ee,_e,Ne)},onDidChangeNotebookEditorVisibleRanges(Ee,_e,Ne){return Ei.onDidChangeNotebookEditorVisibleRanges(Ee,_e,Ne)},showNotebookDocument(Ee,_e){return St.showNotebookDocument(Ee,_e)},registerExternalUriOpener(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"externalUriOpener"),Yi.registerExternalUriOpener(Ue.identifier,Ee,_e,Ne)},registerProfileContentHandler(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ui.registrProfileContentHandler(Ue,Ee,_e)},registerQuickDiffProvider(Ee,_e,Ne,st){return(0,Be.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(Ee),_e,Ne,st)},get tabGroups(){return Ge.tabGroups},registerShareProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"shareProvider"),Li.registerShareProvider(pt(Ee),_e)}},Ci={get rootPath(){return Fe.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(Ee){throw new O.ReadonlyError("rootPath")},getWorkspaceFolder(Ee){return at.getWorkspaceFolder(Ee)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(Ee){throw new O.ReadonlyError("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(Ee){throw new O.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(Ee,_e,...Ne)=>at.updateWorkspaceFolders(Ue,Ee,_e||0,...Ne),onDidChangeWorkspaceFolders:function(Ee,_e,Ne){return at.onDidChangeWorkspace(Ee,_e,Ne)},asRelativePath:(Ee,_e)=>at.getRelativePath(Ee,_e),findFiles:(Ee,_e,Ne,st)=>at.findFiles(Ee,_e,Ne,Ue.identifier,st),findTextInFiles:(Ee,_e,Ne,st)=>{(0,Be.checkProposedApiEnabled)(Ue,"findTextInFiles");let Et,Lt;return typeof _e=="object"?(Et=_e,Lt=Ne):(Et={},Lt=_e,st=Ne),at.findTextInFiles(Ee,Et||{},Lt,Ue.identifier,st)},save:Ee=>((0,Be.checkProposedApiEnabled)(Ue,"saveEditor"),at.save(Ee)),saveAs:Ee=>((0,Be.checkProposedApiEnabled)(Ue,"saveEditor"),at.saveAs(Ee)),saveAll:Ee=>at.saveAll(Ee),applyEdit(Ee,_e){return nn.applyWorkspaceEdit(Ee,Ue,_e)},createFileSystemWatcher:(Ee,_e,Ne,st)=>{let Et;return typeof _e=="boolean"?Et={ignoreCreateEvents:!!_e,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!st,correlate:!1}:_e&&((0,Be.checkProposedApiEnabled)(Ue,"createFileSystemWatcher"),Et={..._e,correlate:!0}),Yt.createFileSystemWatcher(at,Ue,Ee,Et)},get textDocuments(){return kt.getAllDocumentData().map(Ee=>Ee.document)},set textDocuments(Ee){throw new O.ReadonlyError("textDocuments")},openTextDocument(Ee){let _e;const Ne=Ee;if(typeof Ee=="string")_e=Promise.resolve(T.URI.file(Ee));else if(T.URI.isUri(Ee))_e=Promise.resolve(Ee);else if(!Ne||typeof Ne=="object")_e=kt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(st=>kt.ensureDocumentData(st).then(Et=>Et.document))},onDidOpenTextDocument:(Ee,_e,Ne)=>kt.onDidAddDocument(Ee,_e,Ne),onDidCloseTextDocument:(Ee,_e,Ne)=>kt.onDidRemoveDocument(Ee,_e,Ne),onDidChangeTextDocument:(Ee,_e,Ne)=>kt.onDidChangeDocument(Ee,_e,Ne),onDidSaveTextDocument:(Ee,_e,Ne)=>kt.onDidSaveDocument(Ee,_e,Ne),onWillSaveTextDocument:(Ee,_e,Ne)=>ri.getOnWillSaveTextDocumentEvent(Ue)(Ee,_e,Ne),get notebookDocuments(){return St.notebookDocuments.map(Ee=>Ee.apiNotebook)},async openNotebookDocument(Ee,_e){let Ne;if(T.URI.isUri(Ee))Ne=Ee,await St.openNotebookDocument(Ee);else if(typeof Ee=="string")Ne=T.URI.revive(await St.createNotebookDocument({viewType:Ee,content:_e}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(Ee,_e,Ne){return vi.onDidSaveNotebookDocument(Ee,_e,Ne)},onDidChangeNotebookDocument(Ee,_e,Ne){return vi.onDidChangeNotebookDocument(Ee,_e,Ne)},onWillSaveNotebookDocument(Ee,_e,Ne){return ki.getOnWillSaveNotebookDocumentEvent(Ue)(Ee,_e,Ne)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(Ee,_e,Ne,st){return St.registerNotebookSerializer(Ue,Ee,_e,Ne,(0,Be.isProposedApiEnabled)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(Ee,_e,Ne)=>on.onDidChangeConfiguration(Ee,_e,Ne),getConfiguration(Ee,_e){return _e=arguments.length===1?void 0:_e,on.getConfiguration(Ee,_e,Ue)},registerTextDocumentContentProvider(Ee,_e){return mn.registerTextDocumentContentProvider(Ee,_e)},registerTaskProvider:(Ee,_e)=>(Fe.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Ue,Ee,_e)),registerFileSystemProvider(Ee,_e,Ne){return(0,Ve.combinedDisposable)(Ti.registerFileSystemProvider(Ue,Ee,_e,Ne),Ht.addFileSystemProvider(Ee,_e,Ne))},get fs(){return Ht.value},registerFileSearchProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(Ue,"fileSearchProvider"),gi.registerFileSearchProvider(Ee,_e)),registerTextSearchProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(Ue,"textSearchProvider"),gi.registerTextSearchProvider(Ee,_e)),registerRemoteAuthorityResolver:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(Ue,"resolvers"),At.registerRemoteAuthorityResolver(Ee,_e)),registerResourceLabelFormatter:Ee=>((0,Be.checkProposedApiEnabled)(Ue,"resolvers"),Qi.$registerResourceLabelFormatter(Ee)),getRemoteExecServer:Ee=>((0,Be.checkProposedApiEnabled)(Ue,"resolvers"),At.getRemoteExecServer(Ee)),onDidCreateFiles:(Ee,_e,Ne)=>Yt.onDidCreateFile(Ee,_e,Ne),onDidDeleteFiles:(Ee,_e,Ne)=>Yt.onDidDeleteFile(Ee,_e,Ne),onDidRenameFiles:(Ee,_e,Ne)=>Yt.onDidRenameFile(Ee,_e,Ne),onWillCreateFiles:(Ee,_e,Ne)=>Yt.getOnWillCreateFileEvent(Ue)(Ee,_e,Ne),onWillDeleteFiles:(Ee,_e,Ne)=>Yt.getOnWillDeleteFileEvent(Ue)(Ee,_e,Ne),onWillRenameFiles:(Ee,_e,Ne)=>Yt.getOnWillRenameFileEvent(Ue)(Ee,_e,Ne),openTunnel:Ee=>((0,Be.checkProposedApiEnabled)(Ue,"tunnels"),ne.openTunnel(Ue,Ee).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,Be.checkProposedApiEnabled)(Ue,"tunnels"),ne.getTunnels()},onDidChangeTunnels:(Ee,_e,Ne)=>((0,Be.checkProposedApiEnabled)(Ue,"tunnels"),ne.onDidChangeTunnels(Ee,_e,Ne)),registerPortAttributesProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(Ue,"portsAttributes"),ne.registerPortsAttributesProvider(Ee,_e)),registerTunnelProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(Ue,"tunnelFactory"),ne.registerTunnelProvider(Ee,_e)),registerTimelineProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(Ue,"timeline"),gn.registerTimelineProvider(Ee,_e,Ue.identifier,gt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:Ee=>((0,Be.checkProposedApiEnabled)(Ue,"workspaceTrust"),at.requestWorkspaceTrust(Ee)),onDidGrantWorkspaceTrust:(Ee,_e,Ne)=>at.onDidGrantWorkspaceTrust(Ee,_e,Ne),registerEditSessionIdentityProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(Ee,_e)),onWillCreateEditSessionIdentity:(Ee,_e,Ne)=>((0,Be.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(Ue)(Ee,_e,Ne)),registerCanonicalUriProvider:(Ee,_e)=>((0,Be.checkProposedApiEnabled)(Ue,"canonicalUriProvider"),at.registerCanonicalUriProvider(Ee,_e)),getCanonicalUri:(Ee,_e,Ne)=>((0,Be.checkProposedApiEnabled)(Ue,"canonicalUriProvider"),at.provideCanonicalUri(Ee,_e,Ne))},Wi={get inputBox(){return Fe.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Ai.getLastInputBox(Ue)},createSourceControl(Ee,_e,Ne){return Ai.createSourceControl(Ue,Ee,_e,Ne)}},zi={createCommentController(Ee,_e){return Xi.createCommentController(Ue,Ee,_e)}},ci={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(Ee,_e,Ne){return mt.onDidStartDebugSession(Ee,_e,Ne)},onDidTerminateDebugSession(Ee,_e,Ne){return mt.onDidTerminateDebugSession(Ee,_e,Ne)},onDidChangeActiveDebugSession(Ee,_e,Ne){return mt.onDidChangeActiveDebugSession(Ee,_e,Ne)},onDidReceiveDebugSessionCustomEvent(Ee,_e,Ne){return mt.onDidReceiveDebugSessionCustomEvent(Ee,_e,Ne)},onDidChangeBreakpoints(Ee,_e,Ne){return mt.onDidChangeBreakpoints(Ee,_e,Ne)},onDidChangeStackFrameFocus(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"debugFocus"),mt.onDidChangeStackFrameFocus(Ee,_e,Ne)},registerDebugConfigurationProvider(Ee,_e,Ne){return mt.registerDebugConfigurationProvider(Ee,_e,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Ee,_e){return mt.registerDebugAdapterDescriptorFactory(Ue,Ee,_e)},registerDebugAdapterTrackerFactory(Ee,_e){return mt.registerDebugAdapterTrackerFactory(Ee,_e)},startDebugging(Ee,_e,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?mt.startDebugging(Ee,_e,{parentSession:Ne}):mt.startDebugging(Ee,_e,Ne||{})},stopDebugging(Ee){return mt.stopDebugging(Ee)},addBreakpoints(Ee){return mt.addBreakpoints(Ee)},removeBreakpoints(Ee){return mt.removeBreakpoints(Ee)},asDebugSourceUri(Ee,_e){return mt.asDebugSourceUri(Ee,_e)}},Hi={registerTaskProvider:(Ee,_e)=>It.registerTaskProvider(Ue,Ee,_e),fetchTasks:Ee=>It.fetchTasks(Ee),executeTask:Ee=>It.executeTask(Ue,Ee),get taskExecutions(){return It.taskExecutions},onDidStartTask:(Ee,_e,Ne)=>It.onDidStartTask(Ee,_e,Ne),onDidEndTask:(Ee,_e,Ne)=>It.onDidEndTask(Ee,_e,Ne),onDidStartTaskProcess:(Ee,_e,Ne)=>It.onDidStartTaskProcess(Ee,_e,Ne),onDidEndTaskProcess:(Ee,_e,Ne)=>It.onDidEndTaskProcess(Ee,_e,Ne)},Vi={createNotebookController(Ee,_e,Ne,st,Et){return si.createNotebookController(Ue,Ee,_e,Ne,st,(0,Be.isProposedApiEnabled)(Ue,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(Ee,_e)=>St.registerNotebookCellStatusBarItemProvider(Ue,Ee,_e),createRendererMessaging(Ee){return Ii.createRendererMessaging(Ue,Ee)},createNotebookControllerDetectionTask(Ee){return(0,Be.checkProposedApiEnabled)(Ue,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ue,Ee)},registerKernelSourceActionProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ue,Ee,_e)},onDidChangeNotebookCellExecutionState(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(Ee,_e,Ne)}},ji={t(...Ee){if(typeof Ee[0]=="string"){const _e=Ee.shift(),Ne=!Ee||typeof Ee[0]!="object"?Ee:Ee[0];return li.getMessage(Ue.identifier.value,{message:_e,args:Ne})}return li.getMessage(Ue.identifier.value,Ee[0])},get bundle(){return li.getBundle(Ue.identifier.value)},get uri(){return li.getBundleUri(Ue.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"interactive"),Ji.registerProvider(Ue,Ee,_e={label:_e?.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"interactive"),mi.registerChatProvider(Ue,Ee,_e)},sendInteractiveRequestToProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"interactive"),mi.sendInteractiveRequestToProvider(Ee,_e)},get onDidPerformUserAction(){return(0,Be.checkProposedApiEnabled)(Ue,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"interactive"),mi.transferChatSession(Ee,_e)}},dn={getRelatedInformation(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"aiRelatedInformation"),Jt.getRelatedInformation(Ue,Ee,_e)},registerRelatedInformationProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"aiRelatedInformation"),Jt.registerRelatedInformationProvider(Ue,Ee,_e)},registerEmbeddingVectorProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Ue,Ee,_e)}},hn={registerChatResponseProvider(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,Ee,_e,Ne)},requestChatAccess(Ee){return(0,Be.checkProposedApiEnabled)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,Ee)},registerVariable(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"chatVariables"),xi.registerVariableResolver(Ue,Ee,_e,Ne)},registerMappedEditsProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,Ee,_e)},createChatAgent(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"chatAgents2"),vn.createChatAgent(Ue,Ee,_e)},registerAgent(Ee,_e,Ne){return(0,Be.checkProposedApiEnabled)(Ue,"chatAgents"),Zi.registerAgent(Ue.identifier,Ee,_e,Ne)}},fn={registerSpeechProvider(Ee,_e){return(0,Be.checkProposedApiEnabled)(Ue,"speech"),Si.registerProvider(Ue.identifier,Ee,_e)}};return{version:ft.version,ai:dn,authentication:Bi,commands:an,comments:zi,chat:hn,debug:ci,env:$i,extensions:En,interactive:qi,l10n:ji,languages:ln,notebooks:Vi,scm:Wi,speech:fn,tasks:Hi,tests:cn,window:un,workspace:Ci,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,ChatAgentResultFeedbackKind:V.ChatAgentResultFeedbackKind,ChatMessage:V.ChatMessage,ChatMessageRole:V.ChatMessageRole,ChatVariableLevel:V.ChatVariableLevel,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:O.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:f.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:v.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalQuickFixExecuteTerminalCommand:V.TerminalQuickFixCommand,TerminalQuickFixOpener:V.TerminalQuickFixOpener,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:g.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,SyntaxTokenType:V.SyntaxTokenType,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:S.UIKind,Uri:T.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,ManagedResolvedAuthority:V.ManagedResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestMessage2:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Me.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TelemetryTrustedValue:ge.TelemetryTrustedValue,LogLevel:Z.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.StackFrameFocus,ThreadFocus:V.ThreadFocus,RelatedInformationType:V.RelatedInformationType,SpeechToTextStatus:V.SpeechToTextStatus}}}e.createApiFactoryAndRegisterActors=Nt}),define(De[359],Ie([1,0,103,152,39,149,40,34,70,45,93,94,95,115,73,89,151,72,55,114,88,71,150,14,56,112,113]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a,t,i,s,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(n.IExtHostLocalizationService,n.ExtHostLocalizationService,1),(0,I.registerSingleton)(i.ILoggerService,t.ExtHostLoggerService,1),(0,I.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService,1),(0,I.registerSingleton)(g.IExtHostCommands,g.ExtHostCommands,0),(0,I.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,I.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,0),(0,I.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,I.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,I.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,I.registerSingleton)(r.IExtHostManagedSockets,r.ExtHostManagedSockets,0),(0,I.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo,0),(0,I.registerSingleton)(O.IExtHostOutputService,O.ExtHostOutputService,1),(0,I.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,I.registerSingleton)(S.IExtHostStorage,S.ExtHostStorage,0),(0,I.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,I.registerSingleton)(v.IExtHostTerminalService,v.WorkerExtHostTerminalService,0),(0,I.registerSingleton)(_.IExtHostTunnelService,_.ExtHostTunnelService,0),(0,I.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,I.registerSingleton)(f.IExtHostWorkspace,f.ExtHostWorkspace,0),(0,I.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState,0),(0,I.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry,0),(0,I.registerSingleton)(a.IExtHostEditorTabs,a.ExtHostEditorTabs,0),(0,I.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(De[116],Ie([1,0,19,14,37,92]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=T;function g(P,E,S,_){const w=(0,I.mapArrayOrNot)(S,y),d=new f.TextSearchMatch(E,w,_),o=d.preview.matches;return{ranges:(0,I.mapArrayOrNot)(w,v),uri:P,preview:{text:d.preview.text,matches:(0,I.mapArrayOrNot)(o,v)}}}e.createTextSearchResult=g;function y(P){return new f.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function v(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(E,S){this.prefix=E,this.logService=S}appendLine(E){this.logService.debug(`${this.prefix}#search`,E)}};e.OutputChannel=R,e.OutputChannel=R=je([$e(1,O.ILogService)],R)}),define(De[360],Ie([1,0,49,16,77,33,12,15,116,361]),function(pe,e,I,O,f,A,T,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const R=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(c,h,a,t){const i=E(c,h,a,t),s=h.folder.fsPath;return{cmd:I.spawn(R,i.args,{cwd:s}),rgDiskPath:R,siblingClauses:i.siblingClauses,rgArgs:i,cwd:s}}e.spawnRipgrepCmd=P;function E(c,h,a,t){const i=["--files","--hidden","--case-sensitive","--no-require-git"];_([h],a,!1).forEach(n=>{const r=(0,y.anchorGlob)(n);if(i.push("-g",r),T.isMacintosh){const l=(0,f.normalizeNFD)(r);l!==r&&i.push("-g",l)}});const s=S([h],t,void 0,!1);return s.globArgs.forEach(n=>{const r=`!${(0,y.anchorGlob)(n)}`;if(i.push("-g",r),T.isMacintosh){const l=(0,f.normalizeNFD)(r);l!==r&&i.push("-g",l)}}),h.disregardIgnoreFiles!==!1?i.push("--no-ignore"):h.disregardParentIgnoreFiles!==!1&&i.push("--no-ignore-parent"),h.ignoreSymlinks||i.push("--follow"),c.exists&&i.push("--quiet"),i.push("--no-config"),h.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:s.siblingClauses}}function S(c,h,a,t=!0){const i=[];let s={};return c.forEach(n=>{const r=Object.assign({},n.excludePattern||{},h||{}),l=w(r,t?n.folder.fsPath:void 0,a);i.push(...l.globArgs),l.siblingClauses&&(s=Object.assign(s,l.siblingClauses))}),{globArgs:i,siblingClauses:s}}function _(c,h,a=!0){const t=[];return c.forEach(i=>{const s=Object.assign({},h||{},i.includePattern||{}),n=w(s,a?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}function w(c,h,a){const t=[],i={};return Object.keys(c).forEach(s=>{if(a&&a.has(s)||!s)return;const n=c[s];s=o(h?d(h,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(u(s))):n&&n.when&&(i[s]=n)}),{globArgs:t,siblingClauses:i}}function d(c,h){return O.isAbsolute(h)?h:O.join(c,h)}e.getAbsoluteGlob=d;function o(c){return c=g.rtrim(c,"\\"),g.rtrim(c,"/")}function u(c){return A.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=u}),define(De[362],Ie([1,0,49,53,16,363,19,41,36,77,33,12,35,15,17,29,37,360,127]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(s=>s())});class h{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&y.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,u.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&y.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(r=>{const l=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),k=r.folder.fsPath;n.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==k).forEach(C=>{(0,R.isEqualOrParent)(C,k)&&(l[f.relative(k,C)]=!0)}),this.folderExcludePatterns.set(k,new t(l,k))})}cancel(){this.isCanceled=!0,c.forEach(n=>n())}walk(n,r,l,k,C){if(this.fileWalkSW=E.StopWatch.create(!1),this.isCanceled)return C(null,this.isLimitHit);r.forEach(p=>{const m=f.basename(p.fsPath);this.globalExcludePattern&&this.globalExcludePattern(p.fsPath,m)||this.matchFile(l,{relativePath:p.fsPath,searchPath:void 0})}),this.cmdSW=E.StopWatch.create(!1),this.parallel(n,(p,m)=>{this.call(this.cmdTraversal,this,p,l,k,b=>{if(b){const D=(0,g.toErrorMessage)(b);console.error(D),this.errors.push(D),m(b,void 0)}else m(null,void 0)})},(p,m)=>{this.fileWalkSW.stop();const b=p?T.coalesce(p)[0]:null;C(b,this.isLimitHit)})}parallel(n,r,l){const k=new Array(n.length),C=new Array(n.length);let p=!1,m=0;if(n.length===0)return l(null,[]);n.forEach((b,D)=>{r(b,(M,L)=>{if(M?(p=!0,k[D]=null,C[D]=M):(k[D]=L,C[D]=null),++m===n.length)return l(p?C:null,k)})})}call(n,r,...l){try{n.apply(r,l)}catch(k){l[l.length-1](k)}}cmdTraversal(n,r,l,k){const C=n.folder.fsPath,p=P.isMacintosh,m=()=>F&&F.kill();c.add(m);let b=z=>{c.delete(m),b=()=>{},k(z)},D="";const M=this.initDirectoryTree(),L=(0,o.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression),F=L.cmd,x=!Object.keys(L.siblingClauses).length,U=L.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let N=`${L.rgDiskPath} ${U}
 - cwd: ${L.cwd}`;L.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(L.rgArgs.siblingClauses)}`),l({message:N}),this.cmdResultCount=0,this.collectStdout(F,"utf8",l,(z,V,ge)=>{if(z){b(z);return}if(this.isLimitHit){b();return}const q=(D+(p?v.normalizeNFC(V||""):V)).split(`
`);if(ge){const K=q.length;q[K-1]=q[K-1].trim(),q[K-1]||q.pop()}else D=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,x){for(const K of q)if(this.matchFile(r,{base:C,relativePath:K,searchPath:this.getSearchPath(n,K)}),this.isLimitHit){m();break}(ge||this.isLimitHit)&&b();return}this.addDirectoryEntries(n,M,C,q,r),ge&&(this.matchDirectoryTree(M,C,r),b())})}spawnFindCmd(n){const r=this.folderExcludePatterns.get(n.folder.fsPath),l=r.getBasenameTerms(),k=r.getPathTerms(),C=["-L","."];if(l.length||k.length){C.push("-not","(","(");for(const p of l)C.push("-name",p),C.push("-o");for(const p of k)C.push("-path",p),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),I.spawn("find",C,{cwd:n.folder.fsPath})}readStdout(n,r,l){let k="";this.collectStdout(n,r,()=>{},(C,p,m)=>{if(C){l(C);return}k+=p,m&&l(null,k)})}collectStdout(n,r,l,k){let C=(b,D,M)=>{(b||M)&&(C=()=>{},this.cmdSW?.stop()),k(b,D,M)},p=!1;n.stdout?(this.forwardData(n.stdout,r,C),n.stdout.once("data",()=>p=!0)):l({message:"stdout is null"});let m;n.stderr?m=this.collectData(n.stderr):l({message:"stderr is null"}),n.on("error",b=>{C(b)}),n.on("close",b=>{let D;!p&&(D=this.decodeData(m,r))&&i(D)?C(new Error(`command failed with error code ${b}: ${this.decodeData(m,r)}`)):(this.exists&&b===0&&(this.isLimitHit=!0),C(null,"",!0))})}forwardData(n,r,l){const k=new A.StringDecoder(r);return n.on("data",C=>{l(null,k.write(C))}),k}collectData(n){const r=[];return n.on("data",l=>{r.push(l)}),r}decodeData(n,r){const l=new A.StringDecoder(r);return n.map(k=>l.write(k)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:r},l,k,C){k.indexOf(this.filePattern)!==-1&&this.matchFile(C,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const p=m=>{const b=f.basename(m),D=f.dirname(m);let M=r[D];M||(M=r[D]=[],p(D)),M.push({base:l,relativePath:m,basename:b,searchPath:this.getSearchPath(n,m)})};k.forEach(p)}matchDirectoryTree({rootEntries:n,pathToEntries:r},l,k){const C=this,p=this.folderExcludePatterns.get(l),m=this.filePattern;function b(D){C.directoriesWalked++;const M=(0,d.hasSiblingFn)(()=>D.map(L=>L.basename));for(let L=0,F=D.length;L<F;L++){const x=D[L],{relativePath:U,basename:N}=x;if(p.test(U,N,m!==N?M:void 0))continue;const z=r[U];if(z)b(z);else{if(C.filesWalked++,U===m)continue;C.matchFile(k,x)}if(C.isLimitHit)break}}b(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,r,l,k,C){const p=n.folder,m=(0,d.hasSiblingFn)(()=>l);this.parallel(l,(b,D)=>{if(this.isCanceled||this.isLimitHit)return D(null);const M=r?[r,b].join(f.sep):b;if(this.folderExcludePatterns.get(n.folder.fsPath).test(M,b,this.config.filePattern!==b?m:void 0))return D(null);const L=[p.fsPath,M].join(f.sep);O.lstat(L,(F,x)=>{if(F||this.isCanceled||this.isLimitHit)return D(null);this.statLinkIfNeeded(L,x,(U,N)=>U||this.isCanceled||this.isLimitHit?D(null):N.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(L,x,(z,V)=>z||this.isCanceled||this.isLimitHit||(V=V||"",this.walkedPaths[V])?D(null):(this.walkedPaths[V]=!0,w.Promises.readdir(L).then(ge=>{if(this.isCanceled||this.isLimitHit)return D(null);this.doWalk(n,M,ge,k,te=>D(te||null))},ge=>{D(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&_.isNumber(N.size)&&N.size>this.maxFilesize||this.matchFile(k,{base:p.fsPath,relativePath:M,searchPath:this.getSearchPath(n,M)}),D(null,void 0)))})},b=>{const D=b&&T.coalesce(b);return C(D&&D.length>0?D[0]:void 0)})}matchFile(n,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,f.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(r))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,d.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,r,l){return r.isSymbolicLink()?O.stat(n,l):l(null,r)}realPathIfNeeded(n,r,l){return r.isSymbolicLink()?O.realpath(n,(k,C)=>k?l(k):l(null,C)):l(null,n)}getSearchPath(n,r){return n.folderName?f.join(n.folderName,r):r}}e.FileWalker=h;class a{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new h(n)}search(n,r,l){this.walker.walk(this.folderQueries,this.extraFiles,n,r,(k,C)=>{l(k,{limitHit:C,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=a;class t{constructor(n,r){this.expression=n,this.root=r,this.init(n)}init(n){let r,l;Object.keys(n).filter(k=>n[k]).forEach(k=>{f.isAbsolute(k)?(r=r||y.getEmptyExpression(),r[k]=n[k]):(l=l||y.getEmptyExpression(),l[k]=n[k])}),this.absoluteParsedExpr=r&&y.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=l&&y.parse(l,{trimForExclusions:!0})}test(n,r,l){return this.relativeParsedExpr&&this.relativeParsedExpr(n,r,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(f.join(this.root,n),r,l)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...y.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...y.getPathTerms(this.relativeParsedExpr)),n}}function i(s){const n=s.trim().split(`
`),r=n[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return S.uppercaseFirstLetter(n[n.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(De[364],Ie([1,0,96,22,182,21]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===r)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const g=512,y=512,v=512*8,R=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class E extends Error{constructor(l,k){super(l),this.decodeStreamErrorKind=k}}e.DecodeStreamError=E;class S{static async create(l){let k;if(l!==e.UTF8)k=(await(0,f.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(l));else{const C=new TextDecoder;k={write(p){return C.decode(p,{stream:!0})},end(){return C.decode()}}}return new S(k)}constructor(l){this.iconvLiteDecoder=l}write(l){return this.iconvLiteDecoder.write(l)}end(){return this.iconvLiteDecoder.end()}}function _(r,l){const k=l.minBytesRequiredForDetection??l.guessEncoding?v:y;return new Promise((C,p)=>{const m=(0,I.newWriteableStream)(x=>x.join("")),b=[];let D=0,M;const L=new A.CancellationTokenSource,F=async()=>{try{const x=await n({buffer:O.VSBuffer.concat(b),bytesRead:D},l.guessEncoding);if(x.seemsBinary&&l.acceptTextOnly)throw new E("Stream is binary but only text is accepted for decoding",1);x.encoding=await l.overwriteEncoding(x.encoding),M=await S.create(x.encoding);const U=M.write(O.VSBuffer.concat(b).buffer);m.write(U),b.length=0,D=0,C({stream:m,detected:x})}catch(x){L.cancel(),m.destroy(),p(x)}};(0,I.listenStream)(r,{onData:async x=>{M?m.write(M.write(x.buffer)):(b.push(x),D+=x.byteLength,D>=k&&(r.pause(),await F(),setTimeout(()=>r.resume())))},onError:x=>m.error(x),onEnd:async()=>{M||await F(),m.end(M?.end())}},L.token)})}e.toDecodeStream=_;async function w(r,l,k){const p=(await(0,f.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(l),k);let m=!1,b=!1;return{read(){if(b)return null;const D=r.read();if(typeof D!="string"){if(b=!0,!m&&k?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return O.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return O.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return O.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const M=p.end();return M&&M.length>0?(m=!0,O.VSBuffer.wrap(M)):null}return m=!0,O.VSBuffer.wrap(p.write(D))}}}e.toEncodeReadable=w;async function d(r){return(await(0,f.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(r))}e.encodingExists=d;function o(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=o;function u(r,l){if(!r||l<e.UTF16be_BOM.length)return null;const k=r.readUInt8(0),C=r.readUInt8(1);if(k===e.UTF16be_BOM[0]&&C===e.UTF16be_BOM[1])return e.UTF16be;if(k===e.UTF16le_BOM[0]&&C===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const p=r.readUInt8(2);return k===e.UTF8_BOM[0]&&C===e.UTF8_BOM[1]&&p===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=u;const c=["ascii","utf-16","utf-32"];async function h(r){const l=await(0,f.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),k=r.slice(0,R),C=i(k.buffer),p=l.detect(C);if(!p||!p.encoding)return null;const m=p.encoding.toLowerCase();return 0<=c.indexOf(m)?null:t(p.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(r){const l=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[l]||l}function i(r){let l="";for(let k=0;k<r.length;k++)l+=String.fromCharCode(r[k]);return l}function s(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=r.match(/windows(\d+)/);return l?"windows-"+l[1]:r}}}e.toCanonicalName=s;function n({buffer:r,bytesRead:l},k){let C=u(r,l),p=!1;if(C!==e.UTF16be&&C!==e.UTF16le&&r){let m=!0,b=!0,D=!1;for(let M=0;M<l&&M<g;M++){const L=M%2===1,F=r.readUInt8(M)===0;if(F&&(D=!0),m&&(L&&!F||!L&&F)&&(m=!1),b&&(L&&F||!L&&!F)&&(b=!1),F&&!m&&!b)break}D&&(m?C=e.UTF16le:b?C=e.UTF16be:p=!0)}return k&&!p&&!C&&r?h(r.slice(0,l)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:p,encoding:C}}e.detectEncodingFromBuffer=n,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ie([1,0,364,29,153]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends f.TextSearchManager{constructor(g,y,v=O,R="searchProcess"){super(g,y,{readdir:P=>v.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,I.toCanonicalName)(P)},R)}}e.NativeTextSearchManager=A}),define(De[155],Ie([1,0,49,380,363,19,74,36,16,15,2,37,92,381,361,116]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=_.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(b){this.outputChannel=b}provideTextSearchResults(b,D,M,L){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((F,x)=>{L.onCancellationRequested(()=>K());const U=i(b,D),N=D.folder.fsPath,z=U.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");this.outputChannel.appendLine(`${d} ${z}
 - cwd: ${N}`);let V=I.spawn(d,U,{cwd:N});V.on("error",j=>{console.error(j),this.outputChannel.appendLine("Error: "+(j&&j.message)),x((0,P.serializeSearchError)(new P.SearchError(j&&j.message,P.SearchErrorCode.rgProcessError)))});let ge=!1;const te=new h(D.maxResults,N,D.previewOptions);te.on("result",j=>{ge=!0,ie="",M.report(j)});let q=!1;const K=()=>{q=!0,V?.kill(),te?.cancel()};let ue=!1;te.on("hitLimit",()=>{ue=!0,K()});let ie="";V.stdout.on("data",j=>{te.handleData(j),ge||(ie+=j)});let ce=!1;V.stdout.once("data",()=>ce=!0);let Se="";V.stderr.on("data",j=>{const $=j.toString();this.outputChannel.appendLine($),Se.length+$.length<1e6&&(Se+=$)}),V.on("close",()=>{if(this.outputChannel.appendLine(ce?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(ge?"Got result from parser":"No result from parser"),ie&&this.outputChannel.appendLine(`Got data without result: ${ie}`),this.outputChannel.appendLine(""),q)F({limitHit:ue});else{te.flush(),V=null;let j;Se&&!ce&&(j=u(Se))?x((0,P.serializeSearchError)(new P.SearchError(j.message,j.code))):F({limitHit:ue})}})})}}e.RipgrepTextSearchEngine=o;function u(m){const b=m.split(`
`),D=b[0].trim();if(b.some(L=>L.startsWith("regex parse error")))return new P.SearchError(c(b),P.SearchErrorCode.regexParseError);const M=D.match(/grep config error: unknown encoding: (.*)/);if(M)return new P.SearchError(`Unknown encoding: ${M[1]}`,P.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new P.SearchError(D.charAt(0).toUpperCase()+D.substr(1),P.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new P.SearchError(D.charAt(0).toUpperCase()+D.substr(1),P.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(D,P.SearchErrorCode.regexParseError)}function c(m){const b=["Regex parse error"],D=m.filter(M=>M.startsWith("PCRE2:"));if(D.length>=1){const M=D[0].replace("PCRE2:","");if(M.indexOf(":")!==-1&&M.split(":").length>=2){const L=M.split(":")[1];b.push(":"+L)}}return b.join("")}class h extends O.EventEmitter{constructor(b,D,M){super(),this.maxResults=b,this.rootFolder=D,this.previewOptions=M,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new f.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,D){return super.on(b,D),this}handleData(b){if(this.isDone)return;const D=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(D)}handleDecodedData(b){let D=b.indexOf(`
`);const M=this.remainder+b;if(D>=0)D+=this.remainder.length;else{this.remainder=M;return}let L=0;for(;D>=0;)this.handleLine(M.substring(L,D).trim()),L=D+1,D=M.indexOf(`
`,L);this.remainder=M.substring(L)}handleLine(b){if(this.isDone||!b)return;let D;try{D=JSON.parse(b)}catch{throw new Error(`malformed line from rg: ${b}`)}if(D.type==="match"){const M=a(D.data.path),L=R.URI.file(y.join(this.rootFolder,M)),F=this.createTextSearchMatch(D.data,L);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const M=a(D.data.path),L=R.URI.file(y.join(this.rootFolder,M));this.createTextSearchContext(D.data,L).forEach(x=>this.onResult(x))}}createTextSearchMatch(b,D){const M=b.line_number-1,L=a(b.lines),F=Buffer.from(L);let x=0,U=0,N=M;b.submatches.length===0&&b.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const z=(0,A.coalesce)(b.submatches.map((V,ge)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const te=a(V.match),q=F.slice(x,V.start).toString(),K=t(q),ue=K.numLines>0?K.lastLineLength:K.lastLineLength+U,ie=t(te),ce=K.numLines+N,Se=ie.numLines+ce,j=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+ue;return x=V.end,U=j,N=Se,new E.Range(ce,ue,Se,j)}));return(0,w.createTextSearchResult)(D,L,z,this.previewOptions)}createTextSearchContext(b,D){const M=a(b.lines),L=b.line_number;return M.replace(/\r?\n$/,"").split(`
`).map((F,x)=>({text:F,uri:D,lineNumber:L+x}))}onResult(b){this.emit("result",b)}}e.RipgrepParser=h;function a(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function t(m){const b=/\n/g;let D=0,M=-1,L;for(;L=b.exec(m);)D++,M=L.index;const F=M>=0?m.length-M-1:m.length;return{numLines:D,lastLineLength:F}}function i(m,b){const D=["--hidden","--no-require-git"];D.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:M,otherIncludes:L}=(0,T.groupBy)(b.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const x=new Set;L.forEach(U=>{x.add(U)}),D.push("-g","!*"),x.forEach(U=>{s(U).map(w.anchorGlob).forEach(N=>{D.push("-g",N)})})}M&&M.length&&M.forEach(x=>{D.push("-g",x)}),b.excludes.map(w.anchorGlob).forEach(x=>D.push("-g",`!${x}`)),b.maxFileSize&&D.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?b.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),b.followSymlinks&&D.push("--follow"),b.encoding&&b.encoding!=="utf8"&&D.push("--encoding",b.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,v.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),b.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),m.isRegExp&&(m.pattern=n(m.pattern),D.push("--engine","auto"));let F;if(m.isWordMatch){const U=(0,v.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",U)}else if(m.isRegExp){let x=l(m.pattern);x=k(x),D.push("--regexp",x)}else F=m.pattern,D.push("--fixed-strings");return D.push("--no-config"),b.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),m.isMultiline&&D.push("--multiline"),b.beforeContext&&D.push("--before-context",b.beforeContext+""),b.afterContext&&D.push("--after-context",b.afterContext+""),D.push("--"),F&&D.push(F),D.push("."),D}e.getRgArgs=i;function s(m){return p(m).flatMap(D=>{const M=(0,g.splitGlobAware)(D,"/");return M.map((L,F)=>M.slice(0,F+1).join("/"))})}function n(m){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(b);)m=m.replace(b,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(D);)m=m.replace(D,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=n;const r=m=>m.type==="Assertion"&&m.kind==="lookbehind";function l(m){let b;try{b=new S.RegExpParser().parsePattern(m)}catch{return m}let D="",M=0;const L=(U,N,z)=>{D+=m.slice(M,U)+z,M=N},F=[];return new S.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const N=F[0];if(!N)L(U.start,U.end,"\\r?\\n");else if(!F.some(r))if(N.type==="CharacterClass")if(N.negate){const z=m.slice(N.start+2,U.start)+m.slice(U.end,N.end-1);N.parent?.type==="Quantifier"?L(N.start,N.end,z?`[^${z}]`:"."):L(N.start,N.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=m.slice(N.start+1,U.start)+m.slice(U.end,N.end-1);L(N.start,N.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else N.type==="Quantifier"&&L(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){F.unshift(U)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(U){F.unshift(U)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(U){F.unshift(U)},onCharacterClassLeave(){F.shift()},onAssertionEnter(U){r(U)&&F.push(U)},onAssertionLeave(U){F[0]===U&&F.shift()}}).visit(b),D+=m.slice(M),D}e.fixRegexNewline=l;function k(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=k;function C(m){let b=!1,D=!1,M="",L="";for(let F=0;F<m.length;F++){const x=m[F];switch(x){case"\\":D?(b?L+="\\"+x:M+="\\"+x,D=!1):D=!0;break;case"{":if(D)b?L+=x:M+=x,D=!1;else{if(b)return{strInBraces:M+"{"+L+"{"+m.substring(F+1)};b=!0}break;case"}":if(D)b?L+=x:M+=x,D=!1;else{if(b)return{fixedStart:M,strInBraces:L,fixedEnd:m.substring(F+1)};M+=x}break;default:b?L+=(D?"\\":"")+x:M+=(D?"\\":"")+x,D=!1;break}}return{strInBraces:M+(b?"{"+L:"")}}function p(m){const{fixedStart:b,strInBraces:D,fixedEnd:M}=C(m);if(b===void 0||M===void 0)return[D];let L=(0,g.splitGlobAware)(D,",");L.length||(L=[""]);const F=p(M);return L.flatMap(x=>{const U=b+x;return F.map(N=>U+N)})}e.performBraceExpansionForRipgrep=p}),define(De[365],Ie([1,0,21,155,64,18]),function(pe,e,I,O,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(v){this.outputChannel=v,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(v,R,P,E){const S=new O.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===A.Schemas.vscodeUserData){const _={...R,folder:R.folder.with({scheme:A.Schemas.file})},w=new f.Progress(d=>P.report({...d,uri:d.uri.with({scheme:R.folder.scheme})}));return this.withToken(E,d=>S.provideTextSearchResults(v,_,w,d))}else return this.withToken(E,_=>S.provideTextSearchResults(v,R,P,_))}async withToken(v,R){const P=g(v);this.inProgress.add(P);const E=await R(P.token);return this.inProgress.delete(P),E}dispose(){this.inProgress.forEach(v=>v.cancel())}}e.RipgrepSearchProvider=T;function g(y){const v=new I.CancellationTokenSource;return y.onCancellationRequested(()=>v.cancel()),v}}),define(De[366],Ie([1,0,29,155,154]),function(pe,e,I,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(y){this.query=y}search(y,v,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(S){R({message:S})}},E=new f.NativeTextSearchManager(this.query,new O.RipgrepTextSearchEngine(P),I);return new Promise((S,_)=>E.search(w=>{v(w.map(T))},y).then(w=>S({limitHit:w.limitHit,type:"success",stats:w.stats}),_))}}e.TextSearchEngineAdapter=A;function T(g){return{path:g.resource&&g.resource.fsPath,results:g.results,numMatches:(g.results||[]).reduce((y,v)=>{if(v.ranges){const R=v;return y+(Array.isArray(R.ranges)?R.ranges.length:1)}else return y+1},0)}}}),define(De[367],Ie([1,0,19,8,9,4,127,16,35,2,30,37,362,366]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class _{static{this.BATCH_SIZE=512}constructor(h="searchProcess"){this.processType=h,this.caches=Object.create(null)}fileSearch(h){let a;const t=o(h),i=new A.Emitter({onDidAddFirstListener:()=>{a=(0,O.createCancelablePromise)(s=>this.doFileSearchWithEngine(E.Engine,t,n=>i.fire(n),s)),a.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return i.event}textSearch(h){let a;const t=o(h),i=new A.Emitter({onDidAddFirstListener:()=>{a=(0,O.createCancelablePromise)(s=>this.ripgrepTextSearch(t,n=>i.fire(n),s)),a.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return i.event}ripgrepTextSearch(h,a,t){return h.maxFileSize=this.getPlatformFileLimits().maxFileSize,new S.TextSearchEngineAdapter(h).search(t,a,a)}getPlatformFileLimits(){return{maxFileSize:16*R.ByteSize.GB}}doFileSearch(h,a,t){return this.doFileSearchWithEngine(E.Engine,h,a,t)}doFileSearchWithEngine(h,a,t,i,s=_.BATCH_SIZE){let n=0;const r=k=>{Array.isArray(k)?(n+=k.length,t(k.map(C=>this.rawMatchToSearchItem(C)))):k.relativePath?(n++,t(this.rawMatchToSearchItem(k))):t(k)};if(a.sortByScore){let k=this.trySortedSearchFromCache(a,r,i);if(!k){const C=a.maxResults?Object.assign({},a,{maxResults:null}):a,p=new h(C);k=this.doSortedSearch(p,a,t,r,i)}return new Promise((C,p)=>{k.then(([m,b])=>{const D=b.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(D,t,s),C(m)},p)})}const l=new h(a);return this.doSearch(l,r,s,i).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.processType,fromCache:!1,resultCount:n,sortingTime:void 0}}))}rawMatchToSearchItem(h){return{path:h.base?(0,g.join)(h.base,h.relativePath):h.relativePath}}doSortedSearch(h,a,t,i,s){const n=new A.Emitter;let r=(0,O.createCancelablePromise)(k=>{let C=[];const p=m=>{Array.isArray(m)?C=m:(i(m),n.fire(m))};return this.doSearch(h,p,-1,k).then(m=>[m,C])}),l;if(a.cacheKey){l=this.getOrCreateCache(a.cacheKey);const k={promise:r,event:n.event,resolved:!1};l.resultsToSearchCache[a.filePattern||""]=k,r.then(()=>{k.resolved=!0},C=>{delete l.resultsToSearchCache[a.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([k,C])=>{const p=l?l.scorerCache:Object.create(null),m=(typeof a.maxResults!="number"||a.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(a,C,p,s).then(b=>{const D=m?m.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:D,fromCache:!1,type:this.processType,workspaceFolderCount:a.folderQueries.length,resultCount:b.length},messages:k.messages,limitHit:k.limitHit||typeof a.maxResults=="number"&&C.length>a.maxResults},b]})})}getOrCreateCache(h){const a=this.caches[h];return a||(this.caches[h]=new w)}trySortedSearchFromCache(h,a,t){const i=h.cacheKey&&this.caches[h.cacheKey];if(!i)return;const s=this.getResultsFromCache(i,h.filePattern||"",a,t);if(s)return s.then(([n,r,l])=>{const k=y.StopWatch.create(!1);return this.sortResults(h,r,i.scorerCache,t).then(C=>{const p=k.elapsed(),m={fromCache:!0,detailStats:l,type:this.processType,resultCount:r.length,sortingTime:p};return[{type:"success",limitHit:n.limitHit||typeof h.maxResults=="number"&&r.length>h.maxResults,stats:m},C]})})}sortResults(h,a,t,i){const s=(0,T.prepareQuery)(h.filePattern||""),n=(l,k)=>(0,T.compareItemsByFuzzyScore)(l,k,s,!0,d,t),r=typeof h.maxResults=="number"?h.maxResults:Number.MAX_VALUE;return I.topAsync(a,n,r,1e4,i)}sendProgress(h,a,t){if(t&&t>0)for(let i=0;i<h.length;i+=t)a(h.slice(i,i+t));else a(h)}getResultsFromCache(h,a,t,i){const s=y.StopWatch.create(!1),n=a.indexOf(g.sep)>=0;let r;for(const p in h.resultsToSearchCache)if(a.startsWith(p)){if(n&&p.indexOf(g.sep)<0&&p!=="")continue;const m=h.resultsToSearchCache[p];r={promise:this.preventCancellation(m.promise),event:m.event,resolved:m.resolved};break}if(!r)return null;const l=s.elapsed(),k=y.StopWatch.create(!1),C=r.event(t);return i&&i.onCancellationRequested(()=>{C.dispose()}),r.promise.then(([p,m])=>{if(i&&i.isCancellationRequested)throw(0,f.canceled)();const b=[],D=(0,T.prepareQuery)(a).normalizedLowercase;for(const M of m)(0,P.isFilePatternMatch)(M,D)&&b.push(M);return[p,b,{cacheWasResolved:r.resolved,cacheLookupTime:l,cacheFilterTime:k.elapsed(),cacheEntryCount:m.length}]})}doSearch(h,a,t,i){return new Promise((s,n)=>{let r=[];i?.onCancellationRequested(()=>h.cancel()),h.search(l=>{l&&(t?(r.push(l),t>0&&r.length>=t&&(a(r),r=[])):a(l))},l=>{a(l)},(l,k)=>{r.length&&a(r),l?n(l):s(k)})})}clearCache(h){return delete this.caches[h],Promise.resolve(void 0)}preventCancellation(h){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return h.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return h.finally(a)}}}}e.SearchService=_;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(c){return(0,g.basename)(c.relativePath)}getItemDescription(c){return(0,g.dirname)(c.relativePath)}getItemPath(c){return c.relativePath}};function o(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(u),extraFileResources:c.extraFileResources&&c.extraFileResources.map(h=>v.URI.revive(h))}}function u(c){return{...c,folder:v.URI.revive(c.folder)}}}),define(De[368],Ie([1,0,3,18,2,29,14,27,20,95,67,37,367,365,116,154]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends v.ExtHostSearch{constructor(u,c,h,a){super(u,h,a),this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new I.DisposableStore;const t=new _.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new S.RipgrepSearchProvider(t))),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const u=new _.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(O.Schemas.file,new S.RipgrepSearchProvider(u))),this._disposables.add(this.registerInternalFileSearchProvider(O.Schemas.file,new E.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(u,c){const h=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=h,this._proxy.$registerFileSearchProvider(h,this._transformScheme(u)),(0,I.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(u,c,h,a){const t=(0,v.reviveQuery)(h);return u===this._internalFileSearchHandle?this.doInternalFileSearch(u,c,t,a):super.$provideFileSearchResults(u,c,h,a)}doInternalFileSearch(u,c,h,a){const t=i=>{if((0,P.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(u,c,i.map(s=>f.URI.file(s.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(h,t,a)}$clearCache(u){return this._internalFileSearchProvider?.clearCache(u),super.$clearCache(u)}createTextSearchManager(u,c){return new w.NativeTextSearchManager(u,c,void 0,"textSearchProvider")}};e.NativeExtHostSearch=d,e.NativeExtHostSearch=d=je([$e(0,y.IExtHostRpcService),$e(1,g.IExtHostInitDataService),$e(2,R.IURITransformerService),$e(3,T.ILogService)],d)}),define(De[117],Ie([1,0,382,60,63,383,22,9,4,3,16,12,31,81,82]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(m,b){_.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,m,b)}constructor(m,b=""){this._canWrite=!0,this.debugLabel=b,this.socket=m,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,g.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener),this._closeListener=D=>{this.traceSocketEvent("close",{hadError:D}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(m){const b=D=>{this.traceSocketEvent("read",D),m(T.VSBuffer.wrap(D))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(m){const b=D=>{m({type:0,hadError:D,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(m){const b=()=>{m()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(m){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",m),this.socket.write(m.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,g.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,g.onUnexpectedError)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((m,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),m();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),m()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=w;var d;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var o;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(o||(o={}));class u extends v.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(m,b){this.socket.traceSocketEvent(m,b)}constructor(m,b,D,M){super(),this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=m,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:D?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new c(this,b,D,M,this._onData,(L,F)=>this._write(L,F))),this._register(this._flowManager.onError(L=>{console.error(L),(0,g.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new _.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(async L=>{this._flowManager.isProcessingReadQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(L)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){let b=0;for(;b<m.byteLength;)this._flowManager.writeMessage(m.slice(b,Math.min(b+262144,m.byteLength)),{compressed:!0,opcode:2}),b+=262144}_write(m,{compressed:b,opcode:D}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",m);let M=2;m.byteLength<126?M+=0:m.byteLength<2**16?M+=2:M+=8;const L=T.VSBuffer.alloc(M),F=b?64:0,x=D&15;if(L.writeUInt8(128|F|x,0),m.byteLength<126)L.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){L.writeUInt8(126,1);let U=1;L.writeUInt8(m.byteLength>>>8&255,++U),L.writeUInt8(m.byteLength>>>0&255,++U)}else{L.writeUInt8(127,1);let U=1;L.writeUInt8(0,++U),L.writeUInt8(0,++U),L.writeUInt8(0,++U),L.writeUInt8(0,++U),L.writeUInt8(m.byteLength>>>24&255,++U),L.writeUInt8(m.byteLength>>>16&255,++U),L.writeUInt8(m.byteLength>>>8&255,++U),L.writeUInt8(m.byteLength>>>0&255,++U)}this.socket.write(T.VSBuffer.concat([L,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),D=b.readUInt8(0),M=(D&128)>>>7,L=(D&64)>>>6,F=D&15,x=b.readUInt8(1),U=(x&128)>>>7,N=x&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=!!L),this._state.firstFrameOfMessage=!!M,this._state.mask=0,this._state.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),D=b.readUInt8(1),M=(D&128)>>>7;let L=D&127,F=1;L===126?L=b.readUInt8(++F)*2**8+b.readUInt8(++F):L===127&&(L=b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F));let x=0;M&&(x=b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F)),this._state.state=3,this._state.readLen=L,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),t(b,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(b,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=u;class c extends v.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}constructor(m,b,D,M,L,F){super(),this._tracer=m,this._onData=L,this._writeFn=F,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new y.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,b?(this._zlibInflateStream=this._register(new h(this._tracer,M,D,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(m,b){this._writeQueue.push({data:m,options:b}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:m,options:b}=this._writeQueue.shift();if(this._zlibDeflateStream&&b.compressed){const D=await this._deflateMessage(this._zlibDeflateStream,m);this._writeFn(D,b)}else this._writeFn(m,{...b,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(m,b){return new Promise((D,M)=>{m.write(b),m.flush(L=>D(L))})}acceptFrame(m,b,D){this._readQueue.push({data:m,isCompressed:b,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const m=this._readQueue.shift();if(this._zlibInflateStream&&m.isCompressed){const b=await this._inflateFrame(this._zlibInflateStream,m.data,m.isLastFrameOfMessage);this._onData.fire(b)}else this._onData.fire(m.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(m,b,D){return new Promise((M,L)=>{m.write(b),D&&m.write(T.VSBuffer.fromByteArray([0,0,255,255])),m.flush(F=>M(F))})}}class h extends v.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}constructor(m,b,D,M){super(),this._tracer=m,this._recordInflateBytes=b,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(M),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(T.VSBuffer.wrap(L))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(m){this._recordInflateBytes&&this._recordedInflateBytes.push(m.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",m),this._zlibInflate.write(m.buffer)}flush(m){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const b=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,m(b)})}}class a extends v.Disposable{constructor(m,b){super(),this._tracer=m,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(T.VSBuffer.wrap(D))})}write(m){this._tracer.traceSocketEvent("zlibDeflateWrite",m.buffer),this._zlibDeflate.write(m.buffer)}flush(m){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let b=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.byteLength-4),m(b)})}}function t(p,m){if(m===0)return;const b=p.byteLength>>>2;for(let U=0;U<b;U++){const N=p.readUInt32BE(U*4);p.writeUInt32BE(N^m,U*4)}const D=b*4,M=p.byteLength-D,L=m>>>24&255,F=m>>>16&255,x=m>>>8&255;M>=1&&p.writeUInt8(p.readUInt8(D)^L,D),M>=2&&p.writeUInt8(p.readUInt8(D+1)^F,D+1),M>=3&&p.writeUInt8(p.readUInt8(D+2)^x,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function s(){const p=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const m=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,f.tmpdir)(),b=(0,R.join)(m,`vscode-ipc-${p}.sock`);return r(b),b}e.createRandomIPCHandle=s;function n(p,m,b){const D=(0,I.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${b}-${m}-sock`;const M=b.substr(0,4),L=m.substr(0,6),F=D.substr(0,8);let x;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${F}-${M}-${L}.sock`):x=(0,R.join)(p,`${M}-${L}.sock`),r(x),x}e.createStaticIPCHandle=n;function r(p){const m=i[P.platform];typeof m=="number"&&p.length>=m&&console.warn(`WARNING: IPC handle "${p}" is longer than ${m} chars, try a shorter --user-data-dir`)}class l extends S.IPCServer{static toClientConnectionEvent(m){const b=y.Event.fromNodeEventEmitter(m,"connection");return y.Event.map(b,D=>({protocol:new _.Protocol(new w(D,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(D,"close"))}))}constructor(m){super(l.toClientConnectionEvent(m)),this.server=m}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=l;function k(p){return new Promise((m,b)=>{const D=(0,O.createServer)();D.on("error",b),D.listen(p,()=>{D.removeListener("error",b),m(new l(D))})})}e.serve=k;function C(p,m){return new Promise((b,D)=>{const M=(0,O.createConnection)(p,()=>{M.removeListener("error",D),b(_.Client.fromSocket(new w(M,`ipc-client${m}`),m))});M.once("error",D)})}e.connect=C}),define(De[369],Ie([1,0,60,63,163,117,8,3,12,50,14,135,248,249,106,86,22]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function o(t,i,s,n,r){let l;for(let k=3;k&&(l?.dispose(),l=await new u(t,i,s,n,r).waitForReady(),!(r&&f.BROWSER_RESTRICTED_PORTS[r]||!f.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));k--);return l}class u extends g.Disposable{constructor(i,s,n,r,l){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=l,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=i,this._server=I.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=k=>this._onConnection(k),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const i=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,w.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let n=await(0,f.findFreePortFaster)(i,2,1e3,s),r=null;return this._server.listen(n,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address(),r||(n=0,this._server.listen(n,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async _onConnection(i){i.pause();const s=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,E.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),r=n.getSocket(),l=n.readEntireBuffer();n.dispose(),l.byteLength>0&&i.write(l.buffer),i.on("end",()=>{i.localAddress&&this._socketsDispose.delete(i.localAddress),r.end()}),i.on("close",()=>r.end()),i.on("error",()=>{i.localAddress&&this._socketsDispose.delete(i.localAddress),r instanceof A.NodeSocket?r.socket.destroy():r.end()}),r instanceof A.NodeSocket?this._mirrorNodeSocket(i,r):this._mirrorGenericSocket(i,r),i.localAddress&&this._socketsDispose.set(i.localAddress,()=>{i.end(),r.end()})}_mirrorGenericSocket(i,s){s.onClose(()=>i.destroy()),s.onEnd(()=>i.end()),s.onData(n=>i.write(n.buffer)),i.on("data",n=>s.write(d.VSBuffer.wrap(n))),i.resume()}_mirrorNodeSocket(i,s){const n=s.socket;n.on("end",()=>i.end()),n.on("close",()=>i.end()),n.on("error",()=>{i.destroy()}),n.pipe(i),i.pipe(n)}}e.NodeRemoteTunnel=u;let c=class extends w.AbstractTunnelService{constructor(i,s,n,r,l){super(s,l),this.remoteSocketFactoryService=i,this.signService=n,this.productService=r}isPortPrivileged(i){return(0,w.isPortPrivileged)(i,this.defaultTunnelHost,y.OS,O.release())}retainOrCreateTunnel(i,s,n,r,l,k,C,p){const m=this.getTunnelFromMap(s,n);if(m)return++m.refcount,m.value;if((0,w.isTunnelProvider)(i))return this.createWithProvider(i,s,n,l,k,C,p);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${l}.`);const b={commit:this.productService.commit,quality:this.productService.quality,addressProvider:i,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},D=o(b,r,s,n,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,n,D),D}}};e.BaseTunnelService=c,e.BaseTunnelService=c=je([$e(0,S.IRemoteSocketFactoryService),$e(1,R.ILogService),$e(2,_.ISignService),$e(3,P.IProductService),$e(4,v.IConfigurationService)],c);let h=class extends c{constructor(i,s,n,r,l){super(i,s,n,r,l)}};e.TunnelService=h,e.TunnelService=h=je([$e(0,S.IRemoteSocketFactoryService),$e(1,R.ILogService),$e(2,_.ISignService),$e(3,P.IProductService),$e(4,v.IConfigurationService)],h);let a=class extends g.Disposable{constructor(i,s,n,r,l){super(),this.remoteSocketFactoryService=i,this.logService=s,this.productService=n,this.signService=r,this.configurationService=l,this._tunnelServices=new Map}async openTunnel(i,s,n,r,l,k,C,p,m){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${r} on local port ${k}.`),!this._tunnelServices.has(i)){const b=new h(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(b),this._tunnelServices.set(i,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this._tunnelServices.delete(i))})}return this._tunnelServices.get(i).openTunnel(s,n,r,l,k,C,p,m)}};e.SharedTunnelsService=a,e.SharedTunnelsService=a=je([$e(0,S.IRemoteSocketFactoryService),$e(1,R.ILogService),$e(2,P.IProductService),$e(3,_.ISignService),$e(4,v.IConfigurationService)],a)}),define(De[370],Ie([1,0,117,268,53,34,2,14,44]),function(pe,e,I,O,f,A,T,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class v{constructor(E,S,_){this._commands=E,this.logService=S,this._ipcHandlePath=_,this._server=O.createServer((w,d)=>this.onRequest(w,d)),this.setup().catch(w=>(S.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,S){const _=(d,o)=>{S.writeHead(d,{"content-type":"application/json"}),S.end(JSON.stringify(o||null),u=>u&&this.logService.error(u))},w=[];E.setEncoding("utf8"),E.on("data",d=>w.push(d)),E.on("end",async()=>{try{const d=JSON.parse(w.join(""));let o;switch(d.type){case"open":o=await this.open(d);break;case"openExternal":o=await this.openExternal(d);break;case"status":o=await this.getStatus(d);break;case"extensionManagement":o=await this.manageExtensions(d);break;default:_(404,`Unknown message type: ${d.type}`);break}_(200,o)}catch(d){const o=d instanceof Error?d.message:JSON.stringify(d);_(500,o),this.logService.error("Error while processing pipe request",d)}})}async open(E){const{fileURIs:S,folderURIs:_,forceNewWindow:w,diffMode:d,mergeMode:o,addMode:u,forceReuseWindow:c,gotoLineMode:h,waitMarkerFilePath:a,remoteAuthority:t}=E,i=[];if(Array.isArray(_))for(const l of _)try{i.push({folderUri:T.URI.parse(l)})}catch{}if(Array.isArray(S))for(const l of S)try{(0,y.hasWorkspaceFileExtension)(l)?i.push({workspaceUri:T.URI.parse(l)}):i.push({fileUri:T.URI.parse(l)})}catch{}const s=a?T.URI.file(a):void 0,r={forceNewWindow:w,diffMode:d,mergeMode:o,addMode:u,gotoLineMode:h,forceReuseWindow:c,preferNewWindow:!c&&!s&&!u,waitMarkerFileURI:s,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",i,r)}async openExternal(E){for(const S of E.uris){const _=T.URI.parse(S),w=_.scheme==="file"?_:S;await this._commands.executeCommand("_remoteCLI.openExternal",w)}}async manageExtensions(E){const S=w=>w?.map(d=>/\.vsix$/i.test(d)?T.URI.parse(d):d),_={list:E.list,install:S(E.install),uninstall:S(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",_)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&f.existsSync(this._ipcHandlePath)&&f.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=v;let R=class extends v{constructor(E,S){super(E,S,(0,I.createRandomIPCHandle)())}};e.CLIServer=R,e.CLIServer=R=je([$e(0,A.IExtHostCommands),$e(1,g.ILogService)],R)}),define(De[371],Ie([1,0,54,358,353,267,46,341,2,18,7,370,100,339,340]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends f.RequireInterceptor{_installInterceptor(){const u=this,c=globalThis._VSCODE_NODE_MODULES.module,h=c._load;c._load=function(s,n,r){return s=t(s),u._factories.has(s)?u._factories.get(s).load(s,y.URI.file((0,E.realpathSync)(n.filename)),l=>h.apply(this,[l,n,r])):h.apply(this,arguments)};const a=c._resolveLookupPaths;c._resolveLookupPaths=(i,s)=>a.call(this,t(i),s);const t=i=>{for(const s of u._alternatives){const n=s(i);if(n){i=n;break}}return i}}}class d extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(S.ExtHostConsoleForwarder);const u=this._instaService.invokeFunction(O.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(g.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this._instaService.createInstance(_.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(w,u,{mine:this._myRegistry,all:this._globalRegistry}).install(),I.mark("code/extHost/didInitAPI");const h=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,h,this,this._logService,this._mainThreadTelemetryProxy,this._initData),I.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(u){return u.main}async _loadCommonJSModule(u,c,h){if(c.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${c}', must be of file-scheme`);let a=null;h.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${c.toString(!0)}`),this._logService.flush();const t=u?.identifier.value;u&&await this._extHostLocalizationService.initializeLocalizedMessages(u);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),a=pe.__$__nodeRequire(c.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),h.codeLoadingStop()}return a}async $setRemoteEnvironment(u){if(this._initData.remote.isRemote)for(const c in u){const h=u[c];h===null?delete process.env[c]:process.env[c]=h}}}e.ExtHostExtensionService=d}),define(De[372],Ie([1,0,49,22,4,3,120,12,23,2,29,14,247,65,106,86,369,27,20,73,349]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;function a(m){const b=m.trim().split(`
`),D=[];return b.forEach(L=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);F&&F.length>=3&&D.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),D.reduce((L,F)=>(L[F.socket]=F,L),{})}e.getSockets=a;function t(...m){const b=[].concat(...m.map(s));return[...new Map(b.filter(D=>D.st==="0A").map(D=>{const M=D.local_address.split(":");return{socket:parseInt(D.inode,10),ip:i(M[0]),port:parseInt(M[1],16)}}).map(D=>[D.ip+":"+D.port,D])).values()]}e.loadListeningPorts=t;function i(m){let b="";if(m.length===8)for(let D=m.length-2;D>=0;D-=2)b+=parseInt(m.substr(D,2),16),D!==0&&(b+=".");else for(let D=0;D<m.length;D+=8){const M=m.substring(D,D+8);let L="";for(let F=8;F>=2;F-=2)L+=M.substring(F-2,F),(F===6||F===2)&&(L=parseInt(L,16).toString(16),b+=`${L}`,L="",D+F!==m.length-6&&(b+=":"))}return b}e.parseIpAddress=i;function s(m){const b=m.trim().split(`
`),D=b.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return b.map(L=>L.trim().split(/\s+/).reduce((F,x,U)=>(F[D[U]||U]=x,F),{}))}e.loadConnectionTable=s;function n(m){return!!m.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||m.indexOf("out/server-main.js")!==-1||m.indexOf("_productName=VSCode")!==-1}function r(m){const b=m.trim().split(`
`),D=[];return b.forEach(M=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(M);L&&L.length>=4&&D.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),D}e.getRootProcesses=r;async function l(m,b,D){const M=D.reduce((F,x)=>(F[x.pid]=x,F),{}),L=[];return m.forEach(({socket:F,ip:x,port:U})=>{const N=b[F]?b[F].pid:void 0,z=N?M[N]?.cmd:void 0;N&&z&&!n(z)&&L.push({host:x,port:U,detail:z,pid:N})}),L}e.findPorts=l;function k(m,b,D){const M=new Map,L=r(b);for(const F of m){const x=D.get(F.port);if(x){M.set(F.port,x);continue}const U=L.find(N=>N.cmd.includes(`${F.port}`));if(U){let N=U,z;do z=L.find(V=>V.ppid===N.pid),z&&(N=z);while(z);M.set(F.port,{host:F.ip,port:F.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else M.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return M}e.tryFindRootPorts=k;let C=class extends c.ExtHostTunnelService{constructor(b,D,M,L){super(b,D,M),this.initData=D,this.signService=L,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,g.isLinux&&D.remote.isRemote&&D.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(b){if(b&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=b;let D;this._initialCandidates&&(D=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const M=new T.MovingAverage;let L=0;for(;this._candidateFindingEnabled;){const F=new Date().getTime(),x=(await this.findCandidatePorts()).filter(z=>(0,w.isLocalhost)(z.host)||(0,w.isAllInterfaces)(z.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${x.map(z=>z.port).join(", ")}`);const U=new Date().getTime()-F;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),L++>3&&M.update(U),(!D||JSON.stringify(D)!==JSON.stringify(x))&&(D=x,await this._proxy.$onFoundNewCandidates(D));const N=this.calculateDelay(M.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${N} ms.`),await new Promise(z=>setTimeout(()=>z(),N))}}calculateDelay(b){return Math.max(b*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(b=>b.port).join(", ")}`)}async findCandidatePorts(){let b="",D="";try{b=await R.Promises.readFile("/proc/net/tcp","utf8"),D=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const M=t(b,D),L=await new Promise(te=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(q,K,ue)=>{te(K)})}),F=a(L),x=await R.Promises.readdir("/proc"),U=[];for(const te of x)try{const q=Number(te),K=y.joinPath(v.URI.file("/proc"),te);if((await R.Promises.stat(K.fsPath)).isDirectory()&&!isNaN(q)){const ie=await R.Promises.readlink(y.joinPath(K,"cwd").fsPath),ce=await R.Promises.readFile(y.joinPath(K,"cmdline").fsPath,"utf8");U.push({pid:q,cwd:ie,cmd:ce})}}catch{}const N=[],z=M.filter(te=>{const q=F[te.socket];return q||N.push(te),q}),V=l(z,F,U);let ge;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const te=await new Promise(q=>{(0,I.exec)("ps -F -A -l | grep root",(K,ue,ie)=>{q(ue)})});this._foundRootPorts=k(N,te,this._foundRootPorts),ge=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ge.map(q=>q.port).join(", ")}`)}return V.then(te=>ge?te.concat(ge):te)}makeManagedTunnelFactory(b){return async D=>{const M=new d.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,x,U,N){const z=await b.makeConnection();return p.connect(z,x,U,N)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.ManagedRemoteConnection(0),connectionToken:b.connectionToken})}},signService:this.signService},"localhost",D.remoteAddress.host||"localhost",D.remoteAddress.port,D.localAddressPort);await M.waitForReady();const L=new f.Emitter;return{localAddress:(0,h.parseAddress)(M.localAddress)??M.localAddress,remoteAddress:{port:M.tunnelRemotePort,host:M.tunnelRemoteHost},onDidDispose:L.event,dispose:()=>{M.dispose(),L.fire(),L.dispose()}}}}};e.NodeExtHostTunnelService=C,e.NodeExtHostTunnelService=C=je([$e(0,u.IExtHostRpcService),$e(1,o.IExtHostInitDataService),$e(2,P.ILogService),$e(3,_.ISignService)],C);class p extends E.ManagedSocket{static connect(b,D,M,L){const F=new A.DisposableStore,x={onClose:F.add(new f.Emitter),onData:F.add(new f.Emitter),onEnd:F.add(new f.Emitter)};F.add(b.onDidReceiveMessage(N=>x.onData.fire(O.VSBuffer.wrap(N)))),F.add(b.onDidEnd(()=>x.onEnd.fire())),F.add(b.onDidClose(N=>x.onClose.fire({type:0,error:N,hadError:!!N})));const U=new p(b,L,x);return U._register(F),(0,E.connectManagedSocket)(U,D,M,L,x)}constructor(b,D,M){super(D,M),this.passing=b}write(b){this.passing.send(b.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(De[373],Ie([1,0,103,344,356,355,368,371,372,94,46,95,93,45,73,90,343,342,14,357,56,262,102,106,138]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o,u,c,h,a,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(R.IExtHostExtensionService,g.ExtHostExtensionService,0),(0,I.registerSingleton)(u.ILoggerService,o.ExtHostLoggerService,1),(0,I.registerSingleton)(u.ILogService,new t.SyncDescriptor(a.ExtHostLogService,[!1],!0)),(0,I.registerSingleton)(i.ISignService,s.SignService,1),(0,I.registerSingleton)(w.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,I.registerSingleton)(v.IExtHostDebugService,A.ExtHostDebugService,0),(0,I.registerSingleton)(P.IExtHostSearch,T.NativeExtHostSearch,0),(0,I.registerSingleton)(E.IExtHostTask,f.ExtHostTask,0),(0,I.registerSingleton)(S.IExtHostTerminalService,O.ExtHostTerminalService,0),(0,I.registerSingleton)(_.IExtHostTunnelService,y.NodeExtHostTunnelService,0),(0,I.registerSingleton)(h.IExtHostVariableResolverProvider,c.NodeExtHostVariableResolverProviderService,0)}),define(De[384],Ie([1,0,60,385,54,9,82,117,245,111,354,22,29,100,8,130,269,282,359,373]),function(pe,e,I,O,f,A,T,g,y,v,R,P,E,S,_,w,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const u=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,l=r._load;r._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const c=process.exit.bind(process);function h(r){process.exit=function(l){if(r)c(l);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(r){c()};function t(){const r=(0,o.readExtHostConnection)(process.env);if(r.type===3)return new Promise((l,k)=>{const C=p=>{const m=p[0],b=new T.BufferedEmitter;m.on("message",D=>b.fire(P.VSBuffer.wrap(D.data))),m.on("close",()=>{a("renderer closed the MessagePort")}),m.start(),l({onMessage:b.event,send:D=>m.postMessage(D.buffer)})};process.parentPort.on("message",p=>C(p.ports))});if(r.type===2)return new Promise((l,k)=>{let C=null;const p=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),m=108e5,b=3e5,D=new _.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (1)"),m),M=new _.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (2)"),b);process.on("message",(F,x)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const U=P.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let N;if(F.skipWebSocketFrames)N=new g.NodeSocket(x,"extHost-socket");else{const z=P.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));N=new g.WebSocketNodeSocket(new g.NodeSocket(x,"extHost-socket"),F.permessageDeflate,z,!1)}C?(D.cancel(),M.cancel(),C.beginAcceptReconnection(N,U),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(p),C=new T.PersistentProtocol({socket:N,initialChunk:U}),C.sendResume(),C.onDidDispose(()=>a("renderer disconnected")),l(C),C.onSocketClose(()=>{D.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;D.isScheduled()&&M.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(L)});{const l=r.pipeName;return new Promise((k,C)=>{const p=I.createConnection(l,()=>{p.removeListener("error",C);const m=new T.PersistentProtocol({socket:new g.NodeSocket(p,"extHost-renderer")});m.sendResume(),k(m)});p.once("error",C),p.on("close",()=>{a("renderer closed the socket")})})}}async function i(){const r=await t();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(l=>{(0,v.isMessageOfType)(l,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||r.send(l)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(l=>{const k=r.onMessage(C=>{k.dispose();const p=JSON.parse(C.toString()),m=p.commit,b=y.default.commit;if(m&&b&&m!==b&&c(55),p.parentPid){let D=0;setInterval(function(){try{process.kill(p.parentPid,0),D=0}catch(L){L&&L.code==="EPERM"?(D++,D>=3&&a(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${L.message} (code: ${L.code}) (errno: ${L.errno})`)):a(`parent process ${p.parentPid} does not exist anymore: ${L.message} (code: ${L.code}) (errno: ${L.errno})`)}},1e3);let M;try{M=globalThis._VSCODE_NODE_MODULES["native-watchdog"],M.start(p.parentPid)}catch(L){(0,A.onUnexpectedError)(L)}}r.send((0,v.createMessageOfType)(0)),l({protocol:r,initData:p})});r.send((0,v.createMessageOfType)(1))})}async function n(){const r=[];process.on("unhandledRejection",(D,M)=>{r.push(M),setTimeout(()=>{const L=r.indexOf(M);L>=0&&M.catch(F=>{r.splice(L,1),(0,A.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),D&&(0,A.onUnexpectedError)(D))})},1e3)}),process.on("rejectionHandled",D=>{const M=r.indexOf(D);M>=0&&r.splice(M,1)}),process.on("uncaughtException",function(D){(0,A.isSigPipeError)(D)||(0,A.onUnexpectedError)(D)}),f.mark("code/extHost/willConnectToRenderer");const l=await i();f.mark("code/extHost/didConnectToRenderer");const k=await s(l);f.mark("code/extHost/didWaitForInitData");const{initData:C}=k;h(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=u.useHostProxy!==void 0?u.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,w.boolean)(u.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(M){c(M)}fsExists(M){return E.Promises.exists(M)}fsRealpath(M){return(0,S.realpath)(M)}};let m=null;C.remote.authority&&u.transformURIs&&(m=(0,d.createURITransformer)(C.remote.authority));const b=new R.ExtensionHostMain(k.protocol,C,p,m);a=D=>b.terminate(D)}n().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dd29bdcb71634f9cd7c1792bb2bdfde5b18ee8e8/core/vs/workbench/api/node/extensionHostProcess.js.map
