/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Te=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/core/range","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/stopwatch","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(be){for(var e=[],w=0,R=be.length;w<R;w++)e[w]=Te[be[w]];return e};define(Te[65],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function w(T){return(l,y,f)=>{let A=null,D=null;if(typeof f.value=="function"?(A="value",D=f.value):typeof f.get=="function"&&(A="get",D=f.get),!D)throw new Error("not supported");f[A]=T(D,y)}}function R(T,l,y){let f=null,A=null;if(typeof y.value=="function"?(f="value",A=y.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(f="get",A=y.get),!A)throw new Error("not supported");const D=`$memoize$${l}`;y[f]=function(...a){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,a)}),this[D]}}e.memoize=R;function P(T,l,y){return w((f,A)=>{const D=`$debounce$${A}`,a=`$debounce$result$${A}`;return function(...E){this[a]||(this[a]=y?y():void 0),clearTimeout(this[D]),l&&(this[a]=l(this[a],...E),E=[this[a]]),this[D]=setTimeout(()=>{f.apply(this,E),this[a]=y?y():void 0},T)}})}e.debounce=P;function F(T,l,y){return w((f,A)=>{const D=`$throttle$timer$${A}`,a=`$throttle$result$${A}`,E=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...h){if(this[a]||(this[a]=y?y():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),l&&(this[a]=l(this[a],...h)),this[p])return;const t=this[E]+T;t<=Date.now()?(this[E]=Date.now(),f.apply(this,[this[a]]),this[a]=y?y():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[E]=Date.now(),f.apply(this,[this[a]]),this[a]=y?y():void 0},t-Date.now()))}})}e.throttle=F}),define(Te[88],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(Te[115],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var F;(function(n){n.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function T(n,r=!1){let s=0;const o=n.length;let g="",d=0,k=16,I=0;function c(B){let L=0,U=0;for(;L<B;){const ie=n.charCodeAt(s);if(ie>=48&&ie<=57)U=U*16+ie-48;else if(ie>=65&&ie<=70)U=U*16+ie-65+10;else if(ie>=97&&ie<=102)U=U*16+ie-97+10;else break;s++,L++}return L<B&&(U=-1),U}function S(B){s=B,g="",d=0,k=16,I=0}function b(){const B=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&f(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&f(n.charCodeAt(s)))for(s++;s<n.length&&f(n.charCodeAt(s));)s++;else return I=3,n.substring(B,s);let L=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&f(n.charCodeAt(s))){for(s++;s<n.length&&f(n.charCodeAt(s));)s++;L=s}else I=3;return n.substring(B,L)}function C(){let B="",L=s;for(;;){if(s>=o){B+=n.substring(L,s),I=2;break}const U=n.charCodeAt(s);if(U===34){B+=n.substring(L,s),s++;break}if(U===92){if(B+=n.substring(L,s),s++,s>=o){I=2;break}switch(n.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const X=c(4);X>=0?B+=String.fromCharCode(X):I=4;break}default:I=5}L=s;continue}if(U>=0&&U<=31)if(y(U)){B+=n.substring(L,s),I=2;break}else I=6;s++}return B}function $(){if(g="",I=0,d=s,s>=o)return d=o,k=17;let B=n.charCodeAt(s);if(l(B)){do s++,g+=String.fromCharCode(B),B=n.charCodeAt(s);while(l(B));return k=15}if(y(B))return s++,g+=String.fromCharCode(B),B===13&&n.charCodeAt(s)===10&&(s++,g+=`
`),k=14;switch(B){case 123:return s++,k=1;case 125:return s++,k=2;case 91:return s++,k=3;case 93:return s++,k=4;case 58:return s++,k=6;case 44:return s++,k=5;case 34:return s++,g=C(),k=10;case 47:{const L=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!y(n.charCodeAt(s));)s++;return g=n.substring(L,s),k=12}if(n.charCodeAt(s+1)===42){s+=2;const U=o-1;let ie=!1;for(;s<U;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,ie=!0;break}s++}return ie||(s++,I=1),g=n.substring(L,s),k=13}return g+=String.fromCharCode(B),s++,k=16}case 45:if(g+=String.fromCharCode(B),s++,s===o||!f(n.charCodeAt(s)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=b(),k=11;default:for(;s<o&&N(B);)s++,B=n.charCodeAt(s);if(d!==s){switch(g=n.substring(d,s),g){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return g+=String.fromCharCode(B),s++,k=16}}function N(B){if(l(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let B;do B=$();while(B>=12&&B<=15);return B}return{setPosition:S,getPosition:()=>s,scan:r?H:$,getToken:()=>k,getTokenValue:()=>g,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>I}}e.createScanner=T;function l(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var A;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(A||(A={}));function D(n,r){const s=[],o=new Object;let g;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function I(c,S,b,C){d.value=c,d.offset=S,d.length=b,d.type=C,d.colonOffset=void 0,g=d}try{v(n,{onObjectBegin:(c,S)=>{if(r<=c)throw o;g=void 0,k=r>c,s.push("")},onObjectProperty:(c,S,b)=>{if(r<S||(I(c,S,b,"property"),s[s.length-1]=c,r<=S+b))throw o},onObjectEnd:(c,S)=>{if(r<=c)throw o;g=void 0,s.pop()},onArrayBegin:(c,S)=>{if(r<=c)throw o;g=void 0,s.push(0)},onArrayEnd:(c,S)=>{if(r<=c)throw o;g=void 0,s.pop()},onLiteralValue:(c,S,b)=>{if(r<S||(I(c,S,b,m(c)),r<=S+b))throw o},onSeparator:(c,S,b)=>{if(r<=S)throw o;if(c===":"&&g&&g.type==="property")g.colonOffset=S,k=!1,g=void 0;else if(c===","){const C=s[s.length-1];typeof C=="number"?s[s.length-1]=C+1:(k=!0,s[s.length-1]=""),g=void 0}}})}catch(c){if(c!==o)throw c}return{path:s,previousNode:g,isAtPropertyKey:k,matches:c=>{let S=0;for(let b=0;S<c.length&&b<s.length;b++)if(c[S]===s[b]||c[S]==="*")S++;else if(c[S]!=="**")return!1;return S===c.length}}}e.getLocation=D;function a(n,r=[],s=F.DEFAULT){let o=null,g=[];const d=[];function k(c){Array.isArray(g)?g.push(c):o!==null&&(g[o]=c)}return v(n,{onObjectBegin:()=>{const c={};k(c),d.push(g),g=c,o=null},onObjectProperty:c=>{o=c},onObjectEnd:()=>{g=d.pop()},onArrayBegin:()=>{const c=[];k(c),d.push(g),g=c,o=null},onArrayEnd:()=>{g=d.pop()},onLiteralValue:k,onError:(c,S,b)=>{r.push({error:c,offset:S,length:b})}},s),g[0]}e.parse=a;function E(n,r=[],s=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(c){o.type==="property"&&(o.length=c-o.offset,o=o.parent)}function d(c){return o.children.push(c),c}v(n,{onObjectBegin:c=>{o=d({type:"object",offset:c,length:-1,parent:o,children:[]})},onObjectProperty:(c,S,b)=>{o=d({type:"property",offset:S,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:c,offset:S,length:b,parent:o})},onObjectEnd:(c,S)=>{o.length=c+S-o.offset,o=o.parent,g(c+S)},onArrayBegin:(c,S)=>{o=d({type:"array",offset:c,length:-1,parent:o,children:[]})},onArrayEnd:(c,S)=>{o.length=c+S-o.offset,o=o.parent,g(c+S)},onLiteralValue:(c,S,b)=>{d({type:m(c),offset:S,length:b,parent:o,value:c}),g(S+b)},onSeparator:(c,S,b)=>{o.type==="property"&&(c===":"?o.colonOffset=S:c===","&&g(S))},onError:(c,S,b)=>{r.push({error:c,offset:S,length:b})}},s);const I=o.children[0];return I&&delete I.parent,I}e.parseTree=E;function p(n,r){if(!n)return;let s=n;for(const o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let g=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===o){s=d.children[1],g=!0;break}if(!g)return}else{const g=o;if(s.type!=="array"||g<0||!Array.isArray(s.children)||g>=s.children.length)return;s=s.children[g]}return s}e.findNodeAtLocation=p;function h(n){if(!n.parent||!n.parent.children)return[];const r=h(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;r.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&r.push(s)}return r}e.getNodePath=h;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const r=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(r[s.children[0].value]=t(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=t;function i(n,r,s=!1){return r>=n.offset&&r<n.offset+n.length||s&&r===n.offset+n.length}e.contains=i;function u(n,r,s=!1){if(i(n,r,s)){const o=n.children;if(Array.isArray(o))for(let g=0;g<o.length&&o[g].offset<=r;g++){const d=u(o[g],r,s);if(d)return d}return n}}e.findNodeAtOffset=u;function v(n,r,s=F.DEFAULT){const o=T(n,!1);function g(le){return le?()=>le(o.getTokenOffset(),o.getTokenLength()):()=>!0}function d(le){return le?ae=>le(ae,o.getTokenOffset(),o.getTokenLength()):()=>!0}const k=g(r.onObjectBegin),I=d(r.onObjectProperty),c=g(r.onObjectEnd),S=g(r.onArrayBegin),b=g(r.onArrayEnd),C=d(r.onLiteralValue),$=d(r.onSeparator),N=g(r.onComment),H=d(r.onError),B=s&&s.disallowComments,L=s&&s.allowTrailingComma;function U(){for(;;){const le=o.scan();switch(o.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:B||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(le){case 12:case 13:B?ie(10):N();break;case 16:ie(1);break;case 15:case 14:break;default:return le}}}function ie(le,ae=[],we=[]){if(H(le),ae.length+we.length>0){let Z=o.getToken();for(;Z!==17;){if(ae.indexOf(Z)!==-1){U();break}else if(we.indexOf(Z)!==-1)break;Z=U()}}}function X(le){const ae=o.getTokenValue();return le?C(ae):I(ae),U(),!0}function ye(){switch(o.getToken()){case 11:{let le=0;try{le=JSON.parse(o.getTokenValue()),typeof le!="number"&&(ie(2),le=0)}catch{ie(2)}C(le);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return U(),!0}function Pe(){return o.getToken()!==10?(ie(3,[],[2,5]),!1):(X(!1),o.getToken()===6?($(":"),U(),Se()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function De(){k(),U();let le=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(le||ie(4,[],[]),$(","),U(),o.getToken()===2&&L)break}else le&&ie(6,[],[]);Pe()||ie(4,[],[2,5]),le=!0}return c(),o.getToken()!==2?ie(7,[2],[]):U(),!0}function pe(){S(),U();let le=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(le||ie(4,[],[]),$(","),U(),o.getToken()===4&&L)break}else le&&ie(6,[],[]);Se()||ie(4,[],[4,5]),le=!0}return b(),o.getToken()!==4?ie(8,[4],[]):U(),!0}function Se(){switch(o.getToken()){case 3:return pe();case 1:return De();case 10:return X(!0);default:return ye()}}return U(),o.getToken()===17?s.allowEmptyContent?!0:(ie(4,[],[]),!1):Se()?(o.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.visit=v;function _(n,r){const s=T(n),o=[];let g,d=0,k;do switch(k=s.getPosition(),g=s.scan(),g){case 12:case 13:case 17:d!==k&&o.push(n.substring(d,k)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),d=s.getPosition();break}while(g!==17);return o.join("")}e.stripComments=_;function m(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),function(be,e){typeof define=="function"&&define.amd?define(Te[116],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ge,de){for(var _e=0;_e<de.length;_e++){var re=de[_e];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ge,re.key,re)}}function w(ge,de,_e){return de&&e(ge.prototype,de),_e&&e(ge,_e),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function R(ge,de){if(ge){if(typeof ge=="string")return P(ge,de);var _e=Object.prototype.toString.call(ge).slice(8,-1);if(_e==="Object"&&ge.constructor&&(_e=ge.constructor.name),_e==="Map"||_e==="Set")return Array.from(ge);if(_e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_e))return P(ge,de)}}function P(ge,de){(de==null||de>ge.length)&&(de=ge.length);for(var _e=0,re=new Array(de);_e<de;_e++)re[_e]=ge[_e];return re}function F(ge,de){var _e=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(_e)return(_e=_e.call(ge)).next.bind(_e);if(Array.isArray(ge)||(_e=R(ge))||de&&ge&&typeof ge.length=="number"){_e&&(ge=_e);var re=0;return function(){return re>=ge.length?{done:!0}:{done:!1,value:ge[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=T();function l(ge){be.defaults=ge}var y=/[&<>"']/,f=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(de){return a[de]};function p(ge,de){if(de){if(y.test(ge))return ge.replace(f,E)}else if(A.test(ge))return ge.replace(D,E);return ge}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ge){return ge.replace(h,function(de,_e){return _e=_e.toLowerCase(),_e==="colon"?":":_e.charAt(0)==="#"?_e.charAt(1)==="x"?String.fromCharCode(parseInt(_e.substring(2),16)):String.fromCharCode(+_e.substring(1)):""})}var i=/(^|[^\[])\^/g;function u(ge,de){ge=typeof ge=="string"?ge:ge.source,de=de||"";var _e={replace:function(ue,ne){return ne=ne.source||ne,ne=ne.replace(i,"$1"),ge=ge.replace(ue,ne),_e},getRegex:function(){return new RegExp(ge,de)}};return _e}var v=/[^\w:]/g,_=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(ge,de,_e){if(ge){var re;try{re=decodeURIComponent(t(_e)).replace(v,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}de&&!_.test(_e)&&(_e=g(de,_e));try{_e=encodeURI(_e).replace(/%25/g,"%")}catch{return null}return _e}var n={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(ge,de){n[" "+ge]||(r.test(ge)?n[" "+ge]=ge+"/":n[" "+ge]=c(ge,"/",!0)),ge=n[" "+ge];var _e=ge.indexOf(":")===-1;return de.substring(0,2)==="//"?_e?de:ge.replace(s,"$1")+de:de.charAt(0)==="/"?_e?de:ge.replace(o,"$1")+de:ge+de}var d={exec:function(){}};function k(ge){for(var de=1,_e,re;de<arguments.length;de++){_e=arguments[de];for(re in _e)Object.prototype.hasOwnProperty.call(_e,re)&&(ge[re]=_e[re])}return ge}function I(ge,de){var _e=ge.replace(/\|/g,function(ne,oe,fe){for(var ke=!1,O=oe;--O>=0&&fe[O]==="\\";)ke=!ke;return ke?"|":" |"}),re=_e.split(/ \|/),ue=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>de)re.splice(de);else for(;re.length<de;)re.push("");for(;ue<re.length;ue++)re[ue]=re[ue].trim().replace(/\\\|/g,"|");return re}function c(ge,de,_e){var re=ge.length;if(re===0)return"";for(var ue=0;ue<re;){var ne=ge.charAt(re-ue-1);if(ne===de&&!_e)ue++;else if(ne!==de&&_e)ue++;else break}return ge.slice(0,re-ue)}function S(ge,de){if(ge.indexOf(de[1])===-1)return-1;for(var _e=ge.length,re=0,ue=0;ue<_e;ue++)if(ge[ue]==="\\")ue++;else if(ge[ue]===de[0])re++;else if(ge[ue]===de[1]&&(re--,re<0))return ue;return-1}function b(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ge,de){if(de<1)return"";for(var _e="";de>1;)de&1&&(_e+=ge),de>>=1,ge+=ge;return _e+ge}function $(ge,de,_e,re){var ue=de.href,ne=de.title?p(de.title):null,oe=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){re.state.inLink=!0;var fe={type:"link",raw:_e,href:ue,title:ne,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,fe}return{type:"image",raw:_e,href:ue,title:ne,text:p(oe)}}function N(ge,de){var _e=ge.match(/^(\s+)(?:```)/);if(_e===null)return de;var re=_e[1];return de.split(`
`).map(function(ue){var ne=ue.match(/^\s+/);if(ne===null)return ue;var oe=ne[0];return oe.length>=re.length?ue.slice(re.length):ue}).join(`
`)}var H=function(){function ge(_e){this.options=_e||be.defaults}var de=ge.prototype;return de.space=function(re){var ue=this.rules.block.newline.exec(re);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},de.code=function(re){var ue=this.rules.block.code.exec(re);if(ue){var ne=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:c(ne,`
`)}}},de.fences=function(re){var ue=this.rules.block.fences.exec(re);if(ue){var ne=ue[0],oe=N(ne,ue[3]||"");return{type:"code",raw:ne,lang:ue[2]?ue[2].trim():ue[2],text:oe}}},de.heading=function(re){var ue=this.rules.block.heading.exec(re);if(ue){var ne=ue[2].trim();if(/#$/.test(ne)){var oe=c(ne,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(ne=oe.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:ne,tokens:this.lexer.inline(ne)}}},de.hr=function(re){var ue=this.rules.block.hr.exec(re);if(ue)return{type:"hr",raw:ue[0]}},de.blockquote=function(re){var ue=this.rules.block.blockquote.exec(re);if(ue){var ne=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},de.list=function(re){var ue=this.rules.block.list.exec(re);if(ue){var ne,oe,fe,ke,O,W,j,K,V,J,ce,Me,$e=ue[1].trim(),Ge=$e.length>1,je={type:"list",raw:"",ordered:Ge,start:Ge?+$e.slice(0,-1):"",loose:!1,items:[]};$e=Ge?"\\d{1,9}\\"+$e.slice(-1):"\\"+$e,this.options.pedantic&&($e=Ge?$e:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+$e+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Me=!1,!(!(ue=Ze.exec(re))||this.rules.block.hr.test(re)));){if(ne=ue[0],re=re.substring(ne.length),K=ue[2].split(`
`,1)[0],V=re.split(`
`,1)[0],this.options.pedantic?(ke=2,ce=K.trimLeft()):(ke=ue[2].search(/[^ ]/),ke=ke>4?1:ke,ce=K.slice(ke),ke+=ue[1].length),W=!1,!K&&/^ *$/.test(V)&&(ne+=V+`
`,re=re.substring(V.length+1),Me=!0),!Me)for(var Ye=new RegExp("^ {0,"+Math.min(3,ke-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Je=new RegExp("^ {0,"+Math.min(3,ke-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,ke-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,ke-1)+"}#");re&&(J=re.split(`
`,1)[0],K=J,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(K)||tt.test(K)||Ye.test(K)||Je.test(re)));){if(K.search(/[^ ]/)>=ke||!K.trim())ce+=`
`+K.slice(ke);else if(!W)ce+=`
`+K;else break;!W&&!K.trim()&&(W=!0),ne+=J+`
`,re=re.substring(J.length+1)}je.loose||(j?je.loose=!0:/\n *\n *$/.test(ne)&&(j=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ce),oe&&(fe=oe[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:ne,task:!!oe,checked:fe,loose:!1,text:ce}),je.raw+=ne}je.items[je.items.length-1].raw=ne.trimRight(),je.items[je.items.length-1].text=ce.trimRight(),je.raw=je.raw.trimRight();var Ue=je.items.length;for(O=0;O<Ue;O++){this.lexer.state.top=!1,je.items[O].tokens=this.lexer.blockTokens(je.items[O].text,[]);var lt=je.items[O].tokens.filter(function(G){return G.type==="space"}),Q=lt.every(function(G){for(var Ee=G.raw.split(""),Be=0,Ne=F(Ee),Xe;!(Xe=Ne()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!je.loose&&lt.length&&Q&&(je.loose=!0,je.items[O].loose=!0)}return je}},de.html=function(re){var ue=this.rules.block.html.exec(re);if(ue){var ne={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]);ne.type="paragraph",ne.text=oe,ne.tokens=this.lexer.inline(oe)}return ne}},de.def=function(re){var ue=this.rules.block.def.exec(re);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ne=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ue[0],href:ue[2],title:ue[3]}}},de.table=function(re){var ue=this.rules.block.table.exec(re);if(ue){var ne={type:"table",header:I(ue[1]).map(function(j){return{text:j}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ue[0];var oe=ne.align.length,fe,ke,O,W;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(ne.align[fe])?ne.align[fe]="right":/^ *:-+: *$/.test(ne.align[fe])?ne.align[fe]="center":/^ *:-+ *$/.test(ne.align[fe])?ne.align[fe]="left":ne.align[fe]=null;for(oe=ne.rows.length,fe=0;fe<oe;fe++)ne.rows[fe]=I(ne.rows[fe],ne.header.length).map(function(j){return{text:j}});for(oe=ne.header.length,ke=0;ke<oe;ke++)ne.header[ke].tokens=this.lexer.inline(ne.header[ke].text);for(oe=ne.rows.length,ke=0;ke<oe;ke++)for(W=ne.rows[ke],O=0;O<W.length;O++)W[O].tokens=this.lexer.inline(W[O].text);return ne}}},de.lheading=function(re){var ue=this.rules.block.lheading.exec(re);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},de.paragraph=function(re){var ue=this.rules.block.paragraph.exec(re);if(ue){var ne=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:ne,tokens:this.lexer.inline(ne)}}},de.text=function(re){var ue=this.rules.block.text.exec(re);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},de.escape=function(re){var ue=this.rules.inline.escape.exec(re);if(ue)return{type:"escape",raw:ue[0],text:p(ue[1])}},de.tag=function(re){var ue=this.rules.inline.tag.exec(re);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]):ue[0]}},de.link=function(re){var ue=this.rules.inline.link.exec(re);if(ue){var ne=ue[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var oe=c(ne.slice(0,-1),"\\");if((ne.length-oe.length)%2===0)return}else{var fe=S(ue[2],"()");if(fe>-1){var ke=ue[0].indexOf("!")===0?5:4,O=ke+ue[1].length+fe;ue[2]=ue[2].substring(0,fe),ue[0]=ue[0].substring(0,O).trim(),ue[3]=""}}var W=ue[2],j="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(W);K&&(W=K[1],j=K[3])}else j=ue[3]?ue[3].slice(1,-1):"";return W=W.trim(),/^</.test(W)&&(this.options.pedantic&&!/>$/.test(ne)?W=W.slice(1):W=W.slice(1,-1)),$(ue,{href:W&&W.replace(this.rules.inline._escapes,"$1"),title:j&&j.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},de.reflink=function(re,ue){var ne;if((ne=this.rules.inline.reflink.exec(re))||(ne=this.rules.inline.nolink.exec(re))){var oe=(ne[2]||ne[1]).replace(/\s+/g," ");if(oe=ue[oe.toLowerCase()],!oe||!oe.href){var fe=ne[0].charAt(0);return{type:"text",raw:fe,text:fe}}return $(ne,oe,ne[0],this.lexer)}},de.emStrong=function(re,ue,ne){ne===void 0&&(ne="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(ne===""||this.rules.inline.punctuation.exec(ne))){var ke=oe[0].length-1,O,W,j=ke,K=0,V=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,ue=ue.slice(-1*re.length+ke);(oe=V.exec(ue))!=null;)if(O=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!O){if(W=O.length,oe[3]||oe[4]){j+=W;continue}else if((oe[5]||oe[6])&&ke%3&&!((ke+W)%3)){K+=W;continue}if(j-=W,!(j>0)){if(W=Math.min(W,W+j+K),Math.min(ke,W)%2){var J=re.slice(1,ke+oe.index+W);return{type:"em",raw:re.slice(0,ke+oe.index+W+1),text:J,tokens:this.lexer.inlineTokens(J)}}var ce=re.slice(2,ke+oe.index+W-1);return{type:"strong",raw:re.slice(0,ke+oe.index+W+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},de.codespan=function(re){var ue=this.rules.inline.code.exec(re);if(ue){var ne=ue[2].replace(/\n/g," "),oe=/[^ ]/.test(ne),fe=/^ /.test(ne)&&/ $/.test(ne);return oe&&fe&&(ne=ne.substring(1,ne.length-1)),ne=p(ne,!0),{type:"codespan",raw:ue[0],text:ne}}},de.br=function(re){var ue=this.rules.inline.br.exec(re);if(ue)return{type:"br",raw:ue[0]}},de.del=function(re){var ue=this.rules.inline.del.exec(re);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},de.autolink=function(re,ue){var ne=this.rules.inline.autolink.exec(re);if(ne){var oe,fe;return ne[2]==="@"?(oe=p(this.options.mangle?ue(ne[1]):ne[1]),fe="mailto:"+oe):(oe=p(ne[1]),fe=oe),{type:"link",raw:ne[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},de.url=function(re,ue){var ne;if(ne=this.rules.inline.url.exec(re)){var oe,fe;if(ne[2]==="@")oe=p(this.options.mangle?ue(ne[0]):ne[0]),fe="mailto:"+oe;else{var ke;do ke=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(ke!==ne[0]);oe=p(ne[0]),ne[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:ne[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},de.inlineText=function(re,ue){var ne=this.rules.inline.text.exec(re);if(ne){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):p(ne[0]):ne[0]:oe=p(this.options.smartypants?ue(ne[0]):ne[0]),{type:"text",raw:ne[0],text:oe}}},ge}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=u(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=u(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=u(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=u(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=u(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=u(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=k({},B),B.gfm=k({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=u(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=u(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=k({},B.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:u(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=u(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=u(B._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=u(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=u(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=u(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=u(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=u(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=u(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=u(L.reflink).replace("label",L._label).replace("ref",B._label).getRegex(),L.nolink=u(L.nolink).replace("ref",B._label).getRegex(),L.reflinkSearch=u(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=k({},L),L.pedantic=k({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=k({},L.normal,{escape:u(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=u(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=k({},L.gfm,{br:u(L.br).replace("{2,}","*").getRegex(),text:u(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ie(ge){var de="",_e,re,ue=ge.length;for(_e=0;_e<ue;_e++)re=ge.charCodeAt(_e),Math.random()>.5&&(re="x"+re.toString(16)),de+="&#"+re+";";return de}var X=function(){function ge(_e){this.tokens=[],this.tokens.links=Object.create(null),this.options=_e||be.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:B.normal,inline:L.normal};this.options.pedantic?(re.block=B.pedantic,re.inline=L.pedantic):this.options.gfm&&(re.block=B.gfm,this.options.breaks?re.inline=L.breaks:re.inline=L.gfm),this.tokenizer.rules=re}ge.lex=function(re,ue){var ne=new ge(ue);return ne.lex(re)},ge.lexInline=function(re,ue){var ne=new ge(ue);return ne.inlineTokens(re)};var de=ge.prototype;return de.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},de.blockTokens=function(re,ue){var ne=this;ue===void 0&&(ue=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(j,K,V){return K+"    ".repeat(V.length)});for(var oe,fe,ke,O;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(j){return(oe=j.call({lexer:ne},re,ue))?(re=re.substring(oe.raw.length),ue.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),fe=ue[ue.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):ue.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),fe=ue[ue.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(ke=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var j=1/0,K=re.slice(1),V=void 0;ne.options.extensions.startBlock.forEach(function(J){V=J.call({lexer:this},K),typeof V=="number"&&V>=0&&(j=Math.min(j,V))}),j<1/0&&j>=0&&(ke=re.substring(0,j+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(ke))){fe=ue[ue.length-1],O&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):ue.push(oe),O=ke.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),fe=ue[ue.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):ue.push(oe);continue}if(re){var W="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,ue},de.inline=function(re,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:re,tokens:ue}),ue},de.inlineTokens=function(re,ue){var ne=this;ue===void 0&&(ue=[]);var oe,fe,ke,O=re,W,j,K;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(O))!=null;)V.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(O=O.slice(0,W.index)+"["+C("a",W[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(O))!=null;)O=O.slice(0,W.index)+"["+C("a",W[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.escapedEmSt.exec(O))!=null;)O=O.slice(0,W.index)+"++"+O.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(j||(K=""),j=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(oe=ce.call({lexer:ne},re,ue))?(re=re.substring(oe.raw.length),ue.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),fe=ue[ue.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):ue.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),fe=ue[ue.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):ue.push(oe);continue}if(oe=this.tokenizer.emStrong(re,O,K)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.autolink(re,ie)){re=re.substring(oe.raw.length),ue.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,ie))){re=re.substring(oe.raw.length),ue.push(oe);continue}if(ke=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Me=re.slice(1),$e=void 0;ne.options.extensions.startInline.forEach(function(Ge){$e=Ge.call({lexer:this},Me),typeof $e=="number"&&$e>=0&&(ce=Math.min(ce,$e))}),ce<1/0&&ce>=0&&(ke=re.substring(0,ce+1))}(),oe=this.tokenizer.inlineText(ke,U)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(K=oe.raw.slice(-1)),j=!0,fe=ue[ue.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):ue.push(oe);continue}if(re){var J="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ue},w(ge,null,[{key:"rules",get:function(){return{block:B,inline:L}}}]),ge}(),ye=function(){function ge(_e){this.options=_e||be.defaults}var de=ge.prototype;return de.code=function(re,ue,ne){var oe=(ue||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(re,oe);fe!=null&&fe!==re&&(ne=!0,re=fe)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+p(oe,!0)+'">'+(ne?re:p(re,!0))+`</code></pre>
`:"<pre><code>"+(ne?re:p(re,!0))+`</code></pre>
`},de.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},de.html=function(re){return re},de.heading=function(re,ue,ne,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(ne);return"<h"+ue+' id="'+fe+'">'+re+"</h"+ue+`>
`}return"<h"+ue+">"+re+"</h"+ue+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(re,ue,ne){var oe=ue?"ol":"ul",fe=ue&&ne!==1?' start="'+ne+'"':"";return"<"+oe+fe+`>
`+re+"</"+oe+`>
`},de.listitem=function(re){return"<li>"+re+`</li>
`},de.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(re){return"<p>"+re+`</p>
`},de.table=function(re,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ue+`</table>
`},de.tablerow=function(re){return`<tr>
`+re+`</tr>
`},de.tablecell=function(re,ue){var ne=ue.header?"th":"td",oe=ue.align?"<"+ne+' align="'+ue.align+'">':"<"+ne+">";return oe+re+("</"+ne+`>
`)},de.strong=function(re){return"<strong>"+re+"</strong>"},de.em=function(re){return"<em>"+re+"</em>"},de.codespan=function(re){return"<code>"+re+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(re){return"<del>"+re+"</del>"},de.link=function(re,ue,ne){if(re=m(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var oe='<a href="'+p(re)+'"';return ue&&(oe+=' title="'+ue+'"'),oe+=">"+ne+"</a>",oe},de.image=function(re,ue,ne){if(re=m(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var oe='<img src="'+re+'" alt="'+ne+'"';return ue&&(oe+=' title="'+ue+'"'),oe+=this.options.xhtml?"/>":">",oe},de.text=function(re){return re},ge}(),Pe=function(){function ge(){}var de=ge.prototype;return de.strong=function(re){return re},de.em=function(re){return re},de.codespan=function(re){return re},de.del=function(re){return re},de.html=function(re){return re},de.text=function(re){return re},de.link=function(re,ue,ne){return""+ne},de.image=function(re,ue,ne){return""+ne},de.br=function(){return""},ge}(),De=function(){function ge(){this.seen={}}var de=ge.prototype;return de.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(re,ue){var ne=re,oe=0;if(this.seen.hasOwnProperty(ne)){oe=this.seen[re];do oe++,ne=re+"-"+oe;while(this.seen.hasOwnProperty(ne))}return ue||(this.seen[re]=oe,this.seen[ne]=0),ne},de.slug=function(re,ue){ue===void 0&&(ue={});var ne=this.serialize(re);return this.getNextSafeSlug(ne,ue.dryrun)},ge}(),pe=function(){function ge(_e){this.options=_e||be.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Pe,this.slugger=new De}ge.parse=function(re,ue){var ne=new ge(ue);return ne.parse(re)},ge.parseInline=function(re,ue){var ne=new ge(ue);return ne.parseInline(re)};var de=ge.prototype;return de.parse=function(re,ue){ue===void 0&&(ue=!0);var ne="",oe,fe,ke,O,W,j,K,V,J,ce,Me,$e,Ge,je,Ze,Ye,Je,it,tt,Ue=re.length;for(oe=0;oe<Ue;oe++){if(ce=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){ne+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(V="",K="",O=ce.header.length,fe=0;fe<O;fe++)K+=this.renderer.tablecell(this.parseInline(ce.header[fe].tokens),{header:!0,align:ce.align[fe]});for(V+=this.renderer.tablerow(K),J="",O=ce.rows.length,fe=0;fe<O;fe++){for(j=ce.rows[fe],K="",W=j.length,ke=0;ke<W;ke++)K+=this.renderer.tablecell(this.parseInline(j[ke].tokens),{header:!1,align:ce.align[ke]});J+=this.renderer.tablerow(K)}ne+=this.renderer.table(V,J);continue}case"blockquote":{J=this.parse(ce.tokens),ne+=this.renderer.blockquote(J);continue}case"list":{for(Me=ce.ordered,$e=ce.start,Ge=ce.loose,O=ce.items.length,J="",fe=0;fe<O;fe++)Ze=ce.items[fe],Ye=Ze.checked,Je=Ze.task,je="",Ze.task&&(it=this.renderer.checkbox(Ye),Ge?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=it+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=it+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:it}):je+=it),je+=this.parse(Ze.tokens,Ge),J+=this.renderer.listitem(je,Je,Ye);ne+=this.renderer.list(J,Me,$e);continue}case"html":{ne+=this.renderer.html(ce.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(J=ce.tokens?this.parseInline(ce.tokens):ce.text;oe+1<Ue&&re[oe+1].type==="text";)ce=re[++oe],J+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);ne+=ue?this.renderer.paragraph(J):J;continue}default:{var lt='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(lt);return}else throw new Error(lt)}}}return ne},de.parseInline=function(re,ue){ue=ue||this.renderer;var ne="",oe,fe,ke,O=re.length;for(oe=0;oe<O;oe++){if(fe=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(ke=this.options.extensions.renderers[fe.type].call({parser:this},fe),ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){ne+=ke||"";continue}switch(fe.type){case"escape":{ne+=ue.text(fe.text);break}case"html":{ne+=ue.html(fe.text);break}case"link":{ne+=ue.link(fe.href,fe.title,this.parseInline(fe.tokens,ue));break}case"image":{ne+=ue.image(fe.href,fe.title,fe.text);break}case"strong":{ne+=ue.strong(this.parseInline(fe.tokens,ue));break}case"em":{ne+=ue.em(this.parseInline(fe.tokens,ue));break}case"codespan":{ne+=ue.codespan(fe.text);break}case"br":{ne+=ue.br();break}case"del":{ne+=ue.del(this.parseInline(fe.tokens,ue));break}case"text":{ne+=ue.text(fe.text);break}default:{var W='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return ne},ge}();function Se(ge,de,_e){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof de=="function"&&(_e=de,de=null),de=k({},Se.defaults,de||{}),b(de),_e){var re=de.highlight,ue;try{ue=X.lex(ge,de)}catch(O){return _e(O)}var ne=function(W){var j;if(!W)try{de.walkTokens&&Se.walkTokens(ue,de.walkTokens),j=pe.parse(ue,de)}catch(K){W=K}return de.highlight=re,W?_e(W):_e(null,j)};if(!re||re.length<3||(delete de.highlight,!ue.length))return ne();var oe=0;Se.walkTokens(ue,function(O){O.type==="code"&&(oe++,setTimeout(function(){re(O.text,O.lang,function(W,j){if(W)return ne(W);j!=null&&j!==O.text&&(O.text=j,O.escaped=!0),oe--,oe===0&&ne()})},0))}),oe===0&&ne();return}function fe(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+p(O.message+"",!0)+"</pre>";throw O}try{var ke=X.lex(ge,de);if(de.walkTokens){if(de.async)return Promise.all(Se.walkTokens(ke,de.walkTokens)).then(function(){return pe.parse(ke,de)}).catch(fe);Se.walkTokens(ke,de.walkTokens)}return pe.parse(ke,de)}catch(O){fe(O)}}Se.options=Se.setOptions=function(ge){return k(Se.defaults,ge),l(Se.defaults),Se},Se.getDefaults=T,Se.defaults=be.defaults,Se.use=function(){for(var ge=arguments.length,de=new Array(ge),_e=0;_e<ge;_e++)de[_e]=arguments[_e];var re=k.apply(void 0,[{}].concat(de)),ue=Se.defaults.extensions||{renderers:{},childTokens:{}},ne;de.forEach(function(oe){if(oe.extensions&&(ne=!0,oe.extensions.forEach(function(ke){if(!ke.name)throw new Error("extension name required");if(ke.renderer){var O=ue.renderers?ue.renderers[ke.name]:null;O?ue.renderers[ke.name]=function(){for(var W=arguments.length,j=new Array(W),K=0;K<W;K++)j[K]=arguments[K];var V=ke.renderer.apply(this,j);return V===!1&&(V=O.apply(this,j)),V}:ue.renderers[ke.name]=ke.renderer}if(ke.tokenizer){if(!ke.level||ke.level!=="block"&&ke.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[ke.level]?ue[ke.level].unshift(ke.tokenizer):ue[ke.level]=[ke.tokenizer],ke.start&&(ke.level==="block"?ue.startBlock?ue.startBlock.push(ke.start):ue.startBlock=[ke.start]:ke.level==="inline"&&(ue.startInline?ue.startInline.push(ke.start):ue.startInline=[ke.start]))}ke.childTokens&&(ue.childTokens[ke.name]=ke.childTokens)})),oe.renderer&&function(){var ke=Se.defaults.renderer||new ye,O=function(K){var V=ke[K];ke[K]=function(){for(var J=arguments.length,ce=new Array(J),Me=0;Me<J;Me++)ce[Me]=arguments[Me];var $e=oe.renderer[K].apply(ke,ce);return $e===!1&&($e=V.apply(ke,ce)),$e}};for(var W in oe.renderer)O(W);re.renderer=ke}(),oe.tokenizer&&function(){var ke=Se.defaults.tokenizer||new H,O=function(K){var V=ke[K];ke[K]=function(){for(var J=arguments.length,ce=new Array(J),Me=0;Me<J;Me++)ce[Me]=arguments[Me];var $e=oe.tokenizer[K].apply(ke,ce);return $e===!1&&($e=V.apply(ke,ce)),$e}};for(var W in oe.tokenizer)O(W);re.tokenizer=ke}(),oe.walkTokens){var fe=Se.defaults.walkTokens;re.walkTokens=function(ke){var O=[];return O.push(oe.walkTokens.call(this,ke)),fe&&(O=O.concat(fe.call(this,ke))),O}}ne&&(re.extensions=ue),Se.setOptions(re)})},Se.walkTokens=function(ge,de){for(var _e=[],re=function(){var fe=ne.value;switch(_e=_e.concat(de.call(Se,fe)),fe.type){case"table":{for(var ke=F(fe.header),O;!(O=ke()).done;){var W=O.value;_e=_e.concat(Se.walkTokens(W.tokens,de))}for(var j=F(fe.rows),K;!(K=j()).done;)for(var V=K.value,J=F(V),ce;!(ce=J()).done;){var Me=ce.value;_e=_e.concat(Se.walkTokens(Me.tokens,de))}break}case"list":{_e=_e.concat(Se.walkTokens(fe.items,de));break}default:Se.defaults.extensions&&Se.defaults.extensions.childTokens&&Se.defaults.extensions.childTokens[fe.type]?Se.defaults.extensions.childTokens[fe.type].forEach(function($e){_e=_e.concat(Se.walkTokens(fe[$e],de))}):fe.tokens&&(_e=_e.concat(Se.walkTokens(fe.tokens,de)))}},ue=F(ge),ne;!(ne=ue()).done;)re();return _e},Se.parseInline=function(ge,de){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");de=k({},Se.defaults,de||{}),b(de);try{var _e=X.lexInline(ge,de);return de.walkTokens&&Se.walkTokens(_e,de.walkTokens),pe.parseInline(_e,de)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+p(re.message+"",!0)+"</pre>";throw re}},Se.Parser=pe,Se.parser=pe.parse,Se.Renderer=ye,Se.TextRenderer=Pe,Se.Lexer=X,Se.lexer=X.lex,Se.Tokenizer=H,Se.Slugger=De,Se.parse=Se;var le=Se.options,ae=Se.setOptions,we=Se.use,Z=Se.walkTokens,z=Se.parseInline,Y=Se,ee=pe.parse,ve=X.lex;be.Lexer=X,be.Parser=pe,be.Renderer=ye,be.Slugger=De,be.TextRenderer=Pe,be.Tokenizer=H,be.getDefaults=T,be.lexer=ve,be.marked=Se,be.options=le,be.parse=Y,be.parseInline=z,be.parser=ee,be.setOptions=ae,be.use=we,be.walkTokens=Z,Object.defineProperty(be,"__esModule",{value:!0})}),define(Te[117],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(l,y,f){return Math.min(Math.max(l,y),f)}e.clamp=w;function R(l,y){return(y+l%y)%y}e.rot=R;class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class F{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=F;class T{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const f=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=f,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function be(P){const F=[];typeof P=="number"&&F.push("code/timeOrigin",P);function T(y){F.push(y,Date.now())}function l(){const y=[];for(let f=0;f<F.length;f+=2)y.push({name:F[f],startTime:F[f+1]});return y}return{mark:T,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))F.push({name:T.name,startTime:Math.round(P+T.startTime)});return F}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=w(R))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var R in w)(typeof exports=="object"?exports:be)[R]=w[R]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return be[R].call(P.exports,P,P.exports,w),P.l=!0,P.exports}return w.m=be,w.c=e,w.d=function(R,P,F){w.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:F})},w.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},w.t=function(R,P){if(1&P&&(R=w(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var F=Object.create(null);if(w.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var T in R)w.d(F,T,function(l){return R[l]}.bind(null,T));return F},w.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return w.d(P,"a",P),P},w.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},w.p="",w(w.s=0)}([function(be,e,w){(function(R){var P;e=be.exports=we,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],y=e.src=[],f=0,A=f++;y[A]="0|[1-9]\\d*";var D=f++;y[D]="[0-9]+";var a=f++;y[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=f++;y[E]="("+y[A]+")\\.("+y[A]+")\\.("+y[A]+")";var p=f++;y[p]="("+y[D]+")\\.("+y[D]+")\\.("+y[D]+")";var h=f++;y[h]="(?:"+y[A]+"|"+y[a]+")";var t=f++;y[t]="(?:"+y[D]+"|"+y[a]+")";var i=f++;y[i]="(?:-("+y[h]+"(?:\\."+y[h]+")*))";var u=f++;y[u]="(?:-?("+y[t]+"(?:\\."+y[t]+")*))";var v=f++;y[v]="[0-9A-Za-z-]+";var _=f++;y[_]="(?:\\+("+y[v]+"(?:\\."+y[v]+")*))";var m=f++,n="v?"+y[E]+y[i]+"?"+y[_]+"?";y[m]="^"+n+"$";var r="[v=\\s]*"+y[p]+y[u]+"?"+y[_]+"?",s=f++;y[s]="^"+r+"$";var o=f++;y[o]="((?:<|>)?=?)";var g=f++;y[g]=y[D]+"|x|X|\\*";var d=f++;y[d]=y[A]+"|x|X|\\*";var k=f++;y[k]="[v=\\s]*("+y[d]+")(?:\\.("+y[d]+")(?:\\.("+y[d]+")(?:"+y[i]+")?"+y[_]+"?)?)?";var I=f++;y[I]="[v=\\s]*("+y[g]+")(?:\\.("+y[g]+")(?:\\.("+y[g]+")(?:"+y[u]+")?"+y[_]+"?)?)?";var c=f++;y[c]="^"+y[o]+"\\s*"+y[k]+"$";var S=f++;y[S]="^"+y[o]+"\\s*"+y[I]+"$";var b=f++;y[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=f++;y[C]="(?:~>?)";var $=f++;y[$]="(\\s*)"+y[C]+"\\s+",l[$]=new RegExp(y[$],"g");var N=f++;y[N]="^"+y[C]+y[k]+"$";var H=f++;y[H]="^"+y[C]+y[I]+"$";var B=f++;y[B]="(?:\\^)";var L=f++;y[L]="(\\s*)"+y[B]+"\\s+",l[L]=new RegExp(y[L],"g");var U=f++;y[U]="^"+y[B]+y[k]+"$";var ie=f++;y[ie]="^"+y[B]+y[I]+"$";var X=f++;y[X]="^"+y[o]+"\\s*("+r+")$|^$";var ye=f++;y[ye]="^"+y[o]+"\\s*("+n+")$|^$";var Pe=f++;y[Pe]="(\\s*)"+y[o]+"\\s*("+r+"|"+y[k]+")",l[Pe]=new RegExp(y[Pe],"g");var De=f++;y[De]="^\\s*("+y[k]+")\\s+-\\s+("+y[k]+")\\s*$";var pe=f++;y[pe]="^\\s*("+y[I]+")\\s+-\\s+("+y[I]+")\\s*$";var Se=f++;y[Se]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)P(le,y[le]),l[le]||(l[le]=new RegExp(y[le]));function ae(V,J){if(V instanceof we)return V;if(typeof V!="string"||V.length>F||!(J?l[s]:l[m]).test(V))return null;try{return new we(V,J)}catch{return null}}function we(V,J){if(V instanceof we){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof we))return new we(V,J);P("SemVer",V,J),this.loose=J;var ce=V.trim().match(J?l[s]:l[m]);if(!ce)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var $e=+Me;if($e>=0&&$e<T)return $e}return Me}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ae,e.valid=function(V,J){var ce=ae(V,J);return ce?ce.version:null},e.clean=function(V,J){var ce=ae(V.trim().replace(/^[=v]+/,""),J);return ce?ce.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(V){return P("SemVer.compare",this.version,this.loose,V),V instanceof we||(V=new we(V,this.loose)),this.compareMain(V)||this.comparePre(V)},we.prototype.compareMain=function(V){return V instanceof we||(V=new we(V,this.loose)),z(this.major,V.major)||z(this.minor,V.minor)||z(this.patch,V.patch)},we.prototype.comparePre=function(V){if(V instanceof we||(V=new we(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var ce=this.prerelease[J],Me=V.prerelease[J];if(P("prerelease compare",J,ce,Me),ce===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ce===void 0)return-1;if(ce!==Me)return z(ce,Me)}while(++J)},we.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,ce,Me){typeof ce=="string"&&(Me=ce,ce=void 0);try{return new we(V,ce).inc(J,Me).version}catch{return null}},e.diff=function(V,J){if(ge(V,J))return null;var ce=ae(V),Me=ae(J);if(ce.prerelease.length||Me.prerelease.length){for(var $e in ce)if(($e==="major"||$e==="minor"||$e==="patch")&&ce[$e]!==Me[$e])return"pre"+$e;return"prerelease"}for(var $e in ce)if(($e==="major"||$e==="minor"||$e==="patch")&&ce[$e]!==Me[$e])return $e},e.compareIdentifiers=z;var Z=/^[0-9]+$/;function z(V,J){var ce=Z.test(V),Me=Z.test(J);return ce&&Me&&(V=+V,J=+J),ce&&!Me?-1:Me&&!ce?1:V<J?-1:V>J?1:0}function Y(V,J,ce){return new we(V,ce).compare(new we(J,ce))}function ee(V,J,ce){return Y(V,J,ce)>0}function ve(V,J,ce){return Y(V,J,ce)<0}function ge(V,J,ce){return Y(V,J,ce)===0}function de(V,J,ce){return Y(V,J,ce)!==0}function _e(V,J,ce){return Y(V,J,ce)>=0}function re(V,J,ce){return Y(V,J,ce)<=0}function ue(V,J,ce,Me){var $e;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof ce=="object"&&(ce=ce.version),$e=V===ce;break;case"!==":typeof V=="object"&&(V=V.version),typeof ce=="object"&&(ce=ce.version),$e=V!==ce;break;case"":case"=":case"==":$e=ge(V,ce,Me);break;case"!=":$e=de(V,ce,Me);break;case">":$e=ee(V,ce,Me);break;case">=":$e=_e(V,ce,Me);break;case"<":$e=ve(V,ce,Me);break;case"<=":$e=re(V,ce,Me);break;default:throw new TypeError("Invalid operator: "+J)}return $e}function ne(V,J){if(V instanceof ne){if(V.loose===J)return V;V=V.value}if(!(this instanceof ne))return new ne(V,J);P("comparator",V,J),this.loose=J,this.parse(V),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(V,J){return z(J,V)},e.major=function(V,J){return new we(V,J).major},e.minor=function(V,J){return new we(V,J).minor},e.patch=function(V,J){return new we(V,J).patch},e.compare=Y,e.compareLoose=function(V,J){return Y(V,J,!0)},e.rcompare=function(V,J,ce){return Y(J,V,ce)},e.sort=function(V,J){return V.sort(function(ce,Me){return e.compare(ce,Me,J)})},e.rsort=function(V,J){return V.sort(function(ce,Me){return e.rcompare(ce,Me,J)})},e.gt=ee,e.lt=ve,e.eq=ge,e.neq=de,e.gte=_e,e.lte=re,e.cmp=ue,e.Comparator=ne;var oe={};function fe(V,J){if(V instanceof fe)return V.loose===J?V:new fe(V.raw,J);if(V instanceof ne)return new fe(V.value,J);if(!(this instanceof fe))return new fe(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ke(V){return!V||V.toLowerCase()==="x"||V==="*"}function O(V,J,ce,Me,$e,Ge,je,Ze,Ye,Je,it,tt,Ue){return((J=ke(ce)?"":ke(Me)?">="+ce+".0.0":ke($e)?">="+ce+"."+Me+".0":">="+J)+" "+(Ze=ke(Ye)?"":ke(Je)?"<"+(+Ye+1)+".0.0":ke(it)?"<"+Ye+"."+(+Je+1)+".0":tt?"<="+Ye+"."+Je+"."+it+"-"+tt:"<="+Ze)).trim()}function W(V,J){for(var ce=0;ce<V.length;ce++)if(!V[ce].test(J))return!1;if(J.prerelease.length){for(ce=0;ce<V.length;ce++)if(P(V[ce].semver),V[ce].semver!==oe&&V[ce].semver.prerelease.length>0){var Me=V[ce].semver;if(Me.major===J.major&&Me.minor===J.minor&&Me.patch===J.patch)return!0}return!1}return!0}function j(V,J,ce){try{J=new fe(J,ce)}catch{return!1}return J.test(V)}function K(V,J,ce,Me){var $e,Ge,je,Ze,Ye;switch(V=new we(V,Me),J=new fe(J,Me),ce){case">":$e=ee,Ge=re,je=ve,Ze=">",Ye=">=";break;case"<":$e=ve,Ge=_e,je=ee,Ze="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(j(V,J,Me))return!1;for(var Je=0;Je<J.set.length;++Je){var it=J.set[Je],tt=null,Ue=null;if(it.forEach(function(lt){lt.semver===oe&&(lt=new ne(">=0.0.0")),tt=tt||lt,Ue=Ue||lt,$e(lt.semver,tt.semver,Me)?tt=lt:je(lt.semver,Ue.semver,Me)&&(Ue=lt)}),tt.operator===Ze||tt.operator===Ye||(!Ue.operator||Ue.operator===Ze)&&Ge(V,Ue.semver)||Ue.operator===Ye&&je(V,Ue.semver))return!1}return!0}ne.prototype.parse=function(V){var J=this.loose?l[X]:l[ye],ce=V.match(J);if(!ce)throw new TypeError("Invalid comparator: "+V);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new we(ce[2],this.loose):this.semver=oe},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(V){return P("Comparator.test",V,this.loose),this.semver===oe||(typeof V=="string"&&(V=new we(V,this.loose)),ue(V,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(V,J){if(!(V instanceof ne))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new fe(V.value,J),j(this.value,ce,J);if(V.operator==="")return ce=new fe(this.value,J),j(V.semver,ce,J);var Me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),$e=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ge=this.semver.version===V.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ze=ue(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ye=ue(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return Me||$e||Ge&&je||Ze||Ye},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),P("range",V,J);var ce=J?l[pe]:l[De];V=V.replace(ce,O),P("hyphen replace",V),V=V.replace(l[Pe],"$1$2$3"),P("comparator trim",V,l[Pe]),V=(V=(V=V.replace(l[$],"$1~")).replace(l[L],"$1^")).split(/\s+/).join(" ");var Me=J?l[X]:l[ye],$e=V.split(" ").map(function(Ge){return function(je,Ze){return P("comp",je),je=function(Ye,Je){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ue){P("caret",tt,Ue);var lt=Ue?l[ie]:l[U];return tt.replace(lt,function(Q,G,Ee,Be,Ne){var Xe;return P("caret",tt,Q,G,Ee,Be,Ne),ke(G)?Xe="":ke(Ee)?Xe=">="+G+".0.0 <"+(+G+1)+".0.0":ke(Be)?Xe=G==="0"?">="+G+"."+Ee+".0 <"+G+"."+(+Ee+1)+".0":">="+G+"."+Ee+".0 <"+(+G+1)+".0.0":Ne?(P("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=G==="0"?Ee==="0"?">="+G+"."+Ee+"."+Be+Ne+" <"+G+"."+Ee+"."+(+Be+1):">="+G+"."+Ee+"."+Be+Ne+" <"+G+"."+(+Ee+1)+".0":">="+G+"."+Ee+"."+Be+Ne+" <"+(+G+1)+".0.0"):(P("no pr"),Xe=G==="0"?Ee==="0"?">="+G+"."+Ee+"."+Be+" <"+G+"."+Ee+"."+(+Be+1):">="+G+"."+Ee+"."+Be+" <"+G+"."+(+Ee+1)+".0":">="+G+"."+Ee+"."+Be+" <"+(+G+1)+".0.0"),P("caret return",Xe),Xe})}(it,Je)}).join(" ")}(je,Ze),P("caret",je),je=function(Ye,Je){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ue){var lt=Ue?l[H]:l[N];return tt.replace(lt,function(Q,G,Ee,Be,Ne){var Xe;return P("tilde",tt,Q,G,Ee,Be,Ne),ke(G)?Xe="":ke(Ee)?Xe=">="+G+".0.0 <"+(+G+1)+".0.0":ke(Be)?Xe=">="+G+"."+Ee+".0 <"+G+"."+(+Ee+1)+".0":Ne?(P("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=">="+G+"."+Ee+"."+Be+Ne+" <"+G+"."+(+Ee+1)+".0"):Xe=">="+G+"."+Ee+"."+Be+" <"+G+"."+(+Ee+1)+".0",P("tilde return",Xe),Xe})}(it,Je)}).join(" ")}(je,Ze),P("tildes",je),je=function(Ye,Je){return P("replaceXRanges",Ye,Je),Ye.split(/\s+/).map(function(it){return function(tt,Ue){tt=tt.trim();var lt=Ue?l[S]:l[c];return tt.replace(lt,function(Q,G,Ee,Be,Ne,Xe){P("xRange",tt,Q,G,Ee,Be,Ne,Xe);var nt=ke(Ee),pt=nt||ke(Be),bt=pt||ke(Ne);return G==="="&&bt&&(G=""),nt?Q=G===">"||G==="<"?"<0.0.0":"*":G&&bt?(pt&&(Be=0),bt&&(Ne=0),G===">"?(G=">=",pt?(Ee=+Ee+1,Be=0,Ne=0):bt&&(Be=+Be+1,Ne=0)):G==="<="&&(G="<",pt?Ee=+Ee+1:Be=+Be+1),Q=G+Ee+"."+Be+"."+Ne):pt?Q=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":bt&&(Q=">="+Ee+"."+Be+".0 <"+Ee+"."+(+Be+1)+".0"),P("xRange return",Q),Q})}(it,Je)}).join(" ")}(je,Ze),P("xrange",je),je=function(Ye,Je){return P("replaceStars",Ye,Je),Ye.trim().replace(l[Se],"")}(je,Ze),P("stars",je),je}(Ge,J)}).join(" ").split(/\s+/);return this.loose&&($e=$e.filter(function(Ge){return!!Ge.match(Me)})),$e=$e.map(function(Ge){return new ne(Ge,J)})},fe.prototype.intersects=function(V,J){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Me){return V.set.some(function($e){return $e.every(function(Ge){return Me.intersects(Ge,J)})})})})},e.toComparators=function(V,J){return new fe(V,J).set.map(function(ce){return ce.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new we(V,this.loose));for(var J=0;J<this.set.length;J++)if(W(this.set[J],V))return!0;return!1},e.satisfies=j,e.maxSatisfying=function(V,J,ce){var Me=null,$e=null;try{var Ge=new fe(J,ce)}catch{return null}return V.forEach(function(je){Ge.test(je)&&(Me&&$e.compare(je)!==-1||($e=new we(Me=je,ce)))}),Me},e.minSatisfying=function(V,J,ce){var Me=null,$e=null;try{var Ge=new fe(J,ce)}catch{return null}return V.forEach(function(je){Ge.test(je)&&(Me&&$e.compare(je)!==1||($e=new we(Me=je,ce)))}),Me},e.validRange=function(V,J){try{return new fe(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,ce){return K(V,J,"<",ce)},e.gtr=function(V,J,ce){return K(V,J,">",ce)},e.outside=K,e.prerelease=function(V,J){var ce=ae(V,J);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(V,J,ce){return V=new fe(V,ce),J=new fe(J,ce),V.intersects(J)},e.coerce=function(V){if(V instanceof we)return V;if(typeof V!="string")return null;var J=V.match(l[b]);return J==null?null:ae((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,w(1))},function(be,e){var w,R,P=be.exports={};function F(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function l(t){if(w===setTimeout)return setTimeout(t,0);if((w===F||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:F}catch{w=F}try{R=typeof clearTimeout=="function"?clearTimeout:T}catch{R=T}})();var y,f=[],A=!1,D=-1;function a(){A&&y&&(A=!1,y.length?f=y.concat(f):D=-1,f.length&&E())}function E(){if(!A){var t=l(a);A=!0;for(var i=f.length;i;){for(y=f,f=[];++D<i;)y&&y[D].run();D=-1,i=f.length}y=null,A=!1,function(u){if(R===clearTimeout)return clearTimeout(u);if((R===T||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(u);try{R(u)}catch{try{return R.call(null,u)}catch{return R.call(this,u)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function h(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)i[u-1]=arguments[u];f.push(new p(t,i)),f.length!==1||A||l(E)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=h,P.addListener=h,P.once=h,P.off=h,P.removeListener=h,P.removeAllListeners=h,P.emit=h,P.prependListener=h,P.prependOnceListener=h,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Te[118],Ae([1,0,11,6]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(_){const m=_;return m?typeof m.read=="function":!1}e.isReadable=P;function F(_){const m=_;return m?[m.on,m.pause,m.resume,m.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=F;function T(_){const m=_;return m?F(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=T;function l(_,m){return new y(_,m)}e.newWriteableStream=l;class y{constructor(m,n){this.reducer=m,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m<"u"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(n=>n(m))}emitError(m){this.listeners.error.length===0?(0,w.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(n=>n(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,n){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(m,n){if(this.state.destroyed)return;let r;switch(m){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const s=r.indexOf(n);s>=0&&r.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(_,m){const n=[];let r;for(;(r=_.read())!==null;)n.push(r);return m(n)}e.consumeReadable=f;function A(_,m,n){const r=[];let s;for(;(s=_.read())!==null&&r.length<n;)r.push(s);return s===null&&r.length>0?m(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return _.read()}}}e.peekReadable=A;function D(_,m){return new Promise((n,r)=>{const s=[];a(_,{onData:o=>{m&&s.push(o)},onError:o=>{m?r(o):n(void 0)},onEnd:()=>{n(m?m(s):void 0)}})})}e.consumeStream=D;function a(_,m,n){_.on("error",r=>{n?.isCancellationRequested||m.onError(r)}),_.on("end",()=>{n?.isCancellationRequested||m.onEnd()}),_.on("data",r=>{n?.isCancellationRequested||m.onData(r)})}e.listenStream=a;function E(_,m){return new Promise((n,r)=>{const s=new R.DisposableStore,o=[],g=I=>{if(o.push(I),o.length>m)return s.dispose(),_.pause(),n({stream:_,buffer:o,ended:!1})},d=I=>(s.dispose(),r(I)),k=()=>(s.dispose(),n({stream:_,buffer:o,ended:!0}));s.add((0,R.toDisposable)(()=>_.removeListener("error",d))),_.on("error",d),s.add((0,R.toDisposable)(()=>_.removeListener("end",k))),_.on("end",k),s.add((0,R.toDisposable)(()=>_.removeListener("data",g))),_.on("data",g)})}e.peekStream=E;function p(_,m){const n=l(m);return n.end(_),n}e.toStream=p;function h(){const _=l(()=>{throw new Error("not supported")});return _.end(),_}e.emptyStream=h;function t(_){let m=!1;return{read:()=>m?null:(m=!0,_)}}e.toReadable=t;function i(_,m,n){const r=l(n);return a(_,{onData:s=>r.write(m.data(s)),onError:s=>r.error(m.error?m.error(s):s),onEnd:()=>r.end()}),r}e.transform=i;function u(_,m,n){let r=!1;return{read:()=>{const s=m.read();return r?s:(r=!0,s!==null?n([_,s]):_)}}}e.prefixedReadable=u;function v(_,m,n){let r=!1;const s=l(n);return a(m,{onData:o=>r?s.write(o):(r=!0,s.write(n([_,o]))),onError:o=>s.error(o),onEnd:()=>{r||(r=!0,s.write(_)),s.end()}}),s}e.prefixedStream=v}),define(Te[26],Ae([1,0,42,118]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const P=typeof Buffer<"u",F=new w.Lazy(()=>new Uint8Array(256));let T,l;class y{static alloc(b){return P?new y(Buffer.allocUnsafe(b)):new y(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new y(b)}static fromString(b,C){return!(C?.dontUseNodeBuffer||!1)&&P?new y(Buffer.from(b)):(T||(T=new TextEncoder),new y(T.encode(b)))}static fromByteArray(b){const C=y.alloc(b.length);for(let $=0,N=b.length;$<N;$++)C.buffer[$]=b[$];return C}static concat(b,C){if(typeof C>"u"){C=0;for(let H=0,B=b.length;H<B;H++)C+=b[H].byteLength}const $=y.alloc(C);let N=0;for(let H=0,B=b.length;H<B;H++){const L=b[H];$.set(L,N),N+=L.byteLength}return $}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=y.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(b,C){return new y(this.buffer.subarray(b,C))}set(b,C){if(b instanceof y)this.buffer.set(b.buffer,C);else if(b instanceof Uint8Array)this.buffer.set(b,C);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),C);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return a(this.buffer,b)}writeUInt32BE(b,C){E(this.buffer,b,C)}readUInt32LE(b){return p(this.buffer,b)}writeUInt32LE(b,C){h(this.buffer,b,C)}readUInt8(b){return t(this.buffer,b)}writeUInt8(b,C){i(this.buffer,b,C)}indexOf(b,C=0){return f(this.buffer,b instanceof y?b.buffer:b,C)}}e.VSBuffer=y;function f(S,b,C=0){const $=b.byteLength,N=S.byteLength;if($===0)return 0;if($===1)return S.indexOf(b[0]);if($>N-C)return-1;const H=F.value;H.fill(b.length);for(let ie=0;ie<b.length;ie++)H[b[ie]]=b.length-ie-1;let B=C+b.length-1,L=B,U=-1;for(;B<N;)if(S[B]===b[L]){if(L===0){U=B;break}B--,L--}else B+=Math.max(b.length-L,H[S[B]]),L=b.length-1;return U}e.binaryIndexOf=f;function A(S,b){return S[b+0]<<0>>>0|S[b+1]<<8>>>0}e.readUInt16LE=A;function D(S,b,C){S[C+0]=b&255,b=b>>>8,S[C+1]=b&255}e.writeUInt16LE=D;function a(S,b){return S[b]*2**24+S[b+1]*2**16+S[b+2]*2**8+S[b+3]}e.readUInt32BE=a;function E(S,b,C){S[C+3]=b,b=b>>>8,S[C+2]=b,b=b>>>8,S[C+1]=b,b=b>>>8,S[C]=b}e.writeUInt32BE=E;function p(S,b){return S[b+0]<<0>>>0|S[b+1]<<8>>>0|S[b+2]<<16>>>0|S[b+3]<<24>>>0}e.readUInt32LE=p;function h(S,b,C){S[C+0]=b&255,b=b>>>8,S[C+1]=b&255,b=b>>>8,S[C+2]=b&255,b=b>>>8,S[C+3]=b&255}e.writeUInt32LE=h;function t(S,b){return S[b]}e.readUInt8=t;function i(S,b,C){S[C]=b}e.writeUInt8=i;function u(S){return R.consumeReadable(S,b=>y.concat(b))}e.readableToBuffer=u;function v(S){return R.toReadable(S)}e.bufferToReadable=v;function _(S){return R.consumeStream(S,b=>y.concat(b))}e.streamToBuffer=_;async function m(S){return S.ended?y.concat(S.buffer):y.concat([...S.buffer,await _(S.stream)])}e.bufferedStreamToBuffer=m;function n(S){return R.toStream(S,b=>y.concat(b))}e.bufferToStream=n;function r(S){return R.transform(S,{data:b=>typeof b=="string"?y.fromString(b):y.wrap(b)},b=>y.concat(b))}e.streamToBufferReadableStream=r;function s(S){return R.newWriteableStream(b=>y.concat(b),S)}e.newWriteableBufferStream=s;function o(S,b){return R.prefixedReadable(S,b,C=>y.concat(C))}e.prefixedBufferReadable=o;function g(S,b){return R.prefixedStream(S,b,C=>y.concat(C))}e.prefixedBufferStream=g;function d(S){let b=0,C=0,$=0;const N=new Uint8Array(Math.floor(S.length/4*3)),H=L=>{switch(C){case 3:N[$++]=b|L,C=0;break;case 2:N[$++]=b|L>>>2,b=L<<6,C=3;break;case 1:N[$++]=b|L>>>4,b=L<<4,C=2;break;default:b=L<<2,C=1}};for(let L=0;L<S.length;L++){const U=S.charCodeAt(L);if(U>=65&&U<=90)H(U-65);else if(U>=97&&U<=122)H(U-97+26);else if(U>=48&&U<=57)H(U-48+52);else if(U===43||U===45)H(62);else if(U===47||U===95)H(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${S[L]}`)}}const B=$;for(;C>0;)H(0);return y.wrap(N).slice(0,B)}e.decodeBase64=d;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:S},b=!0,C=!1){const $=C?I:k;let N="";const H=S.byteLength%3;let B=0;for(;B<S.byteLength-H;B+=3){const L=S[B+0],U=S[B+1],ie=S[B+2];N+=$[L>>>2],N+=$[(L<<4|U>>>4)&63],N+=$[(U<<2|ie>>>6)&63],N+=$[ie&63]}if(H===1){const L=S[B+0];N+=$[L>>>2],N+=$[L<<4&63],b&&(N+="==")}else if(H===2){const L=S[B+0],U=S[B+1];N+=$[L>>>2],N+=$[(L<<4|U>>>4)&63],N+=$[U<<2&63],b&&(N+="=")}return N}e.encodeBase64=c}),define(Te[119],Ae([1,0,28,16]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...ne){return function(oe,fe){for(let ke=0,O=ne.length;ke<O;ke++){const W=ne[ke](oe,fe);if(W)return W}return null}}e.or=P,e.matchesStrictPrefix=F.bind(void 0,!1),e.matchesPrefix=F.bind(void 0,!0);function F(ne,oe,fe){if(!fe||fe.length<oe.length)return null;let ke;return ne?ke=R.startsWithIgnoreCase(fe,oe):ke=fe.indexOf(oe)===0,ke?oe.length>0?[{start:0,end:oe.length}]:[]:null}function T(ne,oe){const fe=oe.toLowerCase().indexOf(ne.toLowerCase());return fe===-1?null:[{start:fe,end:fe+ne.length}]}e.matchesContiguousSubString=T;function l(ne,oe){return y(ne.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=l;function y(ne,oe,fe,ke){if(fe===ne.length)return[];if(ke===oe.length)return null;if(ne[fe]===oe[ke]){let O=null;return(O=y(ne,oe,fe+1,ke+1))?i({start:ke,end:ke+1},O):null}return y(ne,oe,fe,ke+1)}function f(ne){return 97<=ne&&ne<=122}function A(ne){return 65<=ne&&ne<=90}e.isUpper=A;function D(ne){return 48<=ne&&ne<=57}function a(ne){return ne===32||ne===9||ne===10||ne===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>E.add(ne.charCodeAt(0)));function p(ne){return a(ne)||E.has(ne)}function h(ne,oe){return ne===oe||p(ne)&&p(oe)}function t(ne){return f(ne)||A(ne)||D(ne)}function i(ne,oe){return oe.length===0?oe=[ne]:ne.end===oe[0].start?oe[0].start=ne.start:oe.unshift(ne),oe}function u(ne,oe){for(let fe=oe;fe<ne.length;fe++){const ke=ne.charCodeAt(fe);if(A(ke)||D(ke)||fe>0&&!t(ne.charCodeAt(fe-1)))return fe}return ne.length}function v(ne,oe,fe,ke){if(fe===ne.length)return[];if(ke===oe.length)return null;if(ne[fe]!==oe[ke].toLowerCase())return null;{let O=null,W=ke+1;for(O=v(ne,oe,fe+1,ke+1);!O&&(W=u(oe,W))<oe.length;)O=v(ne,oe,fe+1,W),W++;return O===null?null:i({start:ke,end:ke+1},O)}}function _(ne){let oe=0,fe=0,ke=0,O=0,W=0;for(let ce=0;ce<ne.length;ce++)W=ne.charCodeAt(ce),A(W)&&oe++,f(W)&&fe++,t(W)&&ke++,D(W)&&O++;const j=oe/ne.length,K=fe/ne.length,V=ke/ne.length,J=O/ne.length;return{upperPercent:j,lowerPercent:K,alphaPercent:V,numericPercent:J}}function m(ne){const{upperPercent:oe,lowerPercent:fe}=ne;return fe===0&&oe>.6}function n(ne){const{upperPercent:oe,lowerPercent:fe,alphaPercent:ke,numericPercent:O}=ne;return fe>.2&&oe<.8&&ke>.6&&O<.2}function r(ne){let oe=0,fe=0,ke=0,O=0;for(let W=0;W<ne.length;W++)ke=ne.charCodeAt(W),A(ke)&&oe++,f(ke)&&fe++,a(ke)&&O++;return(oe===0||fe===0)&&O===0?ne.length<=30:oe<=5}function s(ne,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(ne)||oe.length>60)return null;const fe=_(oe);if(!n(fe)){if(!m(fe))return null;oe=oe.toLowerCase()}let ke=null,O=0;for(ne=ne.toLowerCase();O<oe.length&&(ke=v(ne,oe,0,O))===null;)O=u(oe,O+1);return ke}e.matchesCamelCase=s;function o(ne,oe,fe=!1){if(!oe||oe.length===0)return null;let ke=null,O=0;for(ne=ne.toLowerCase(),oe=oe.toLowerCase();O<oe.length&&(ke=g(ne,oe,0,O,fe))===null;)O=d(oe,O+1);return ke}e.matchesWords=o;function g(ne,oe,fe,ke,O){if(fe===ne.length)return[];if(ke===oe.length)return null;if(h(ne.charCodeAt(fe),oe.charCodeAt(ke))){let W=null,j=ke+1;if(W=g(ne,oe,fe+1,ke+1,O),!O)for(;!W&&(j=d(oe,j))<oe.length;)W=g(ne,oe,fe+1,j,O),j++;return W?ne.charCodeAt(fe)!==oe.charCodeAt(ke)?W:i({start:ke,end:ke+1},W):null}else return null}function d(ne,oe){for(let fe=oe;fe<ne.length;fe++)if(p(ne.charCodeAt(fe))||fe>0&&p(ne.charCodeAt(fe-1)))return fe;return ne.length}const k=P(e.matchesPrefix,s,T),I=P(e.matchesPrefix,s,l),c=new w.LRUCache(1e4);function S(ne,oe,fe=!1){if(typeof ne!="string"||typeof oe!="string")return null;let ke=c.get(ne);ke||(ke=new RegExp(R.convertSimple2RegExpPattern(ne),"i"),c.set(ne,ke));const O=ke.exec(oe);return O?[{start:O.index,end:O.index+O[0].length}]:fe?I(ne,oe):k(ne,oe)}e.matchesFuzzy=S;function b(ne,oe){const fe=ee(ne,ne.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?$(fe):null}e.matchesFuzzy2=b;function C(ne,oe,fe,ke,O,W){const j=Math.min(13,ne.length);for(;fe<j;fe++){const K=ee(ne,oe,fe,ke,O,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return K}return[0,W]}e.anyScore=C;function $(ne){if(typeof ne>"u")return[];const oe=[],fe=ne[1];for(let ke=ne.length-1;ke>1;ke--){const O=ne[ke]+fe,W=oe[oe.length-1];W&&W.end===O?W.end=O+1:oe.push({start:O,end:O+1})}return oe}e.createMatches=$;const N=128;function H(){const ne=[],oe=[];for(let fe=0;fe<=N;fe++)oe[fe]=0;for(let fe=0;fe<=N;fe++)ne.push(oe.slice(0));return ne}function B(ne){const oe=[];for(let fe=0;fe<=ne;fe++)oe[fe]=0;return oe}const L=B(2*N),U=B(2*N),ie=H(),X=H(),ye=H(),Pe=!1;function De(ne,oe,fe,ke,O){function W(K,V,J=" "){for(;K.length<V;)K=J+K;return K}let j=` |   |${ke.split("").map(K=>W(K,3)).join("|")}
`;for(let K=0;K<=fe;K++)K===0?j+=" |":j+=`${oe[K-1]}|`,j+=ne[K].slice(0,O+1).map(V=>W(V.toString(),3)).join("|")+`
`;return j}function pe(ne,oe,fe,ke){ne=ne.substr(oe),fe=fe.substr(ke),console.log(De(X,ne,ne.length,fe,fe.length)),console.log(De(ye,ne,ne.length,fe,fe.length)),console.log(De(ie,ne,ne.length,fe,fe.length))}function Se(ne,oe){if(oe<0||oe>=ne.length)return!1;const fe=ne.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(fe)}}function le(ne,oe){if(oe<0||oe>=ne.length)return!1;switch(ne.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ae(ne,oe,fe){return oe[ne]!==fe[ne]}function we(ne,oe,fe,ke,O,W,j=!1){for(;oe<fe&&O<W;)ne[oe]===ke[O]&&(j&&(L[oe]=O),oe+=1),O+=1;return oe===fe}e.isPatternInWord=we;var Z;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var z;(function(ne){ne.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}ne.isDefault=oe})(z||(e.FuzzyScore=z={}));class Y{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.FuzzyScoreOptions=Y;function ee(ne,oe,fe,ke,O,W,j=Y.default){const K=ne.length>N?N:ne.length,V=ke.length>N?N:ke.length;if(fe>=K||W>=V||K-fe>V-W||!we(oe,fe,K,O,W,V,!0))return;ve(K,V,fe,W,oe,O);let J=1,ce=1,Me=fe,$e=W;const Ge=[!1];for(J=1,Me=fe;Me<K;J++,Me++){const it=L[Me],tt=U[Me],Ue=Me+1<K?U[Me+1]:V;for(ce=it-W+1,$e=it;$e<Ue;ce++,$e++){let lt=Number.MIN_SAFE_INTEGER,Q=!1;$e<=tt&&(lt=ge(ne,oe,Me,fe,ke,O,$e,V,W,ie[J-1][ce-1]===0,Ge));let G=0;lt!==Number.MAX_SAFE_INTEGER&&(Q=!0,G=lt+X[J-1][ce-1]);const Ee=$e>it,Be=Ee?X[J][ce-1]+(ie[J][ce-1]>0?-5:0):0,Ne=$e>it+1&&ie[J][ce-1]>0,Xe=Ne?X[J][ce-2]+(ie[J][ce-2]>0?-5:0):0;if(Ne&&(!Ee||Xe>=Be)&&(!Q||Xe>=G))X[J][ce]=Xe,ye[J][ce]=3,ie[J][ce]=0;else if(Ee&&(!Q||Be>=G))X[J][ce]=Be,ye[J][ce]=2,ie[J][ce]=0;else if(Q)X[J][ce]=G,ye[J][ce]=1,ie[J][ce]=ie[J-1][ce-1]+1;else throw new Error("not possible")}}if(Pe&&pe(ne,fe,ke,W),!Ge[0]&&!j.firstMatchCanBeWeak)return;J--,ce--;const je=[X[J][ce],W];let Ze=0,Ye=0;for(;J>=1;){let it=ce;do{const tt=ye[J][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);Ze>1&&oe[fe+J-1]===O[W+ce-1]&&!ae(it+W-1,ke,O)&&Ze+1>ie[J][it]&&(it=ce),it===ce?Ze++:Ze=1,Ye||(Ye=it),J--,ce=it-1,je.push(ce)}V===K&&j.boostFullMatch&&(je[0]+=2);const Je=Ye-K;return je[0]-=Je,je}e.fuzzyScore=ee;function ve(ne,oe,fe,ke,O,W){let j=ne-1,K=oe-1;for(;j>=fe&&K>=ke;)O[j]===W[K]&&(U[j]=K,j--),K--}function ge(ne,oe,fe,ke,O,W,j,K,V,J,ce){if(oe[fe]!==W[j])return Number.MIN_SAFE_INTEGER;let Me=1,$e=!1;return j===fe-ke?Me=ne[fe]===O[j]?7:5:ae(j,O,W)&&(j===0||!ae(j-1,O,W))?(Me=ne[fe]===O[j]?7:5,$e=!0):Se(W,j)&&(j===0||!Se(W,j-1))?Me=5:(Se(W,j-1)||le(W,j-1))&&(Me=5,$e=!0),Me>1&&fe===ke&&(ce[0]=!0),$e||($e=ae(j,O,W)||Se(W,j-1)||le(W,j-1)),fe===ke?j>V&&(Me-=$e?3:5):J?Me+=$e?2:0:Me+=$e?0:1,j+1===K&&(Me-=$e?3:5),Me}function de(ne,oe,fe,ke,O,W,j){return re(ne,oe,fe,ke,O,W,!0,j)}e.fuzzyScoreGracefulAggressive=de;function _e(ne,oe,fe,ke,O,W,j){return re(ne,oe,fe,ke,O,W,!1,j)}e.fuzzyScoreGraceful=_e;function re(ne,oe,fe,ke,O,W,j,K){let V=ee(ne,oe,fe,ke,O,W,K);if(V&&!j)return V;if(ne.length>=3){const J=Math.min(7,ne.length-1);for(let ce=fe+1;ce<J;ce++){const Me=ue(ne,ce);if(Me){const $e=ee(Me,Me.toLowerCase(),fe,ke,O,W,K);$e&&($e[0]-=3,(!V||$e[0]>V[0])&&(V=$e))}}}return V}function ue(ne,oe){if(oe+1>=ne.length)return;const fe=ne[oe],ke=ne[oe+1];if(fe!==ke)return ne.slice(0,oe)+ke+fe+ne.slice(oe+2)}}),define(Te[29],Ae([1,0,16]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const F="error",T="warning",l="warn",y="info",f="ignore";function A(a){return a?w.equalsIgnoreCase(F,a)?P.Error:w.equalsIgnoreCase(T,a)||w.equalsIgnoreCase(l,a)?P.Warning:w.equalsIgnoreCase(y,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function D(a){switch(a){case P.Error:return F;case P.Warning:return T;case P.Info:return y;default:return f}}P.toString=D}(R||(R={})),e.default=R}),define(Te[120],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Te[50],Ae([1,0,18,16]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class P{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const p=E.charCodeAt(0),h=this._value.charCodeAt(this._pos);return p-h}value(){return this._value[this._pos]}}e.StringIterator=P;class F{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,R.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=F;class T{constructor(E=!0,p=!0){this._splitOnBackslash=E,this._caseSensitive=p}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let p=E.length-1;p>=0;p--,this._valueLen--){const h=this._value.charCodeAt(p);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,R.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var l;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(l||(l={}));class y{constructor(E,p){this._ignorePathCasing=E,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,R.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(A||(A={}));class D{static forUris(E=()=>!1,p=()=>!1){return new D(new y(E,p))}static forPaths(E=!1){return new D(new T(void 0,!E))}static forStrings(){return new D(new P)}static forConfigKeys(){return new D(new F)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,p){if(p){const h=p.slice(0);(0,w.shuffle)(h);for(const t of h)this.set(t,E)}else{const h=E.slice(0);(0,w.shuffle)(h);for(const t of h)this.set(t[0],t[1])}}set(E,p){const h=this._iter.reset(E);let t;this._root||(this._root=new f,this._root.segment=h.value());const i=[];for(t=this._root;;){const v=h.cmp(t.segment);if(v>0)t.left||(t.left=new f,t.left.segment=h.value()),i.push([-1,t]),t=t.left;else if(v<0)t.right||(t.right=new f,t.right.segment=h.value()),i.push([1,t]),t=t.right;else if(h.hasNext())h.next(),t.mid||(t.mid=new f,t.mid.segment=h.value()),i.push([0,t]),t=t.mid;else break}const u=t.value;t.value=p,t.key=E;for(let v=i.length-1;v>=0;v--){const _=i[v][1];_.updateHeight();const m=_.balanceFactor();if(m<-1||m>1){const n=i[v][0],r=i[v+1][0];if(n===1&&r===1)i[v][1]=_.rotateLeft();else if(n===-1&&r===-1)i[v][1]=_.rotateRight();else if(n===1&&r===-1)_.right=i[v+1][1]=i[v+1][1].rotateRight(),i[v][1]=_.rotateLeft();else if(n===-1&&r===1)_.left=i[v+1][1]=i[v+1][1].rotateLeft(),i[v][1]=_.rotateRight();else throw new Error;if(v>0)switch(i[v-1][0]){case-1:i[v-1][1].left=i[v][1];break;case 1:i[v-1][1].right=i[v][1];break;case 0:i[v-1][1].mid=i[v][1];break}else this._root=i[0][1]}}return u}get(E){return this._getNode(E)?.value}_getNode(E){const p=this._iter.reset(E);let h=this._root;for(;h;){const t=p.cmp(h.segment);if(t>0)h=h.left;else if(t<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else break}return h}has(E){const p=this._getNode(E);return!(p?.value===void 0&&p?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,p){const h=this._iter.reset(E),t=[];let i=this._root;for(;i;){const u=h.cmp(i.segment);if(u>0)t.push([-1,i]),i=i.left;else if(u<0)t.push([1,i]),i=i.right;else if(h.hasNext())h.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const u=this._min(i.right);if(u.key){const{key:v,value:_,segment:m}=u;this._delete(u.key,!1),i.key=v,i.value=_,i.segment=m}}else{const u=i.left??i.right;if(t.length>0){const[v,_]=t[t.length-1];switch(v){case-1:_.left=u;break;case 0:_.mid=u;break;case 1:_.right=u;break}}else this._root=u}for(let u=t.length-1;u>=0;u--){const v=t[u][1];v.updateHeight();const _=v.balanceFactor();if(_>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),t[u][1]=v.rotateLeft()):_<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),t[u][1]=v.rotateRight()),u>0)switch(t[u-1][0]){case-1:t[u-1][1].left=t[u][1];break;case 1:t[u-1][1].right=t[u][1];break;case 0:t[u-1][1].mid=t[u][1];break}else this._root=t[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const p=this._iter.reset(E);let h=this._root,t;for(;h;){const i=p.cmp(h.segment);if(i>0)h=h.left;else if(i<0)h=h.right;else if(p.hasNext())p.next(),t=h.value||t,h=h.mid;else break}return h&&h.value||t}findSuperstr(E){return this._findSuperstrOrElement(E,!1)}_findSuperstrOrElement(E,p){const h=this._iter.reset(E);let t=this._root;for(;t;){const i=h.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(h.hasNext())h.next(),t=t.mid;else return t.mid?this._entries(t.mid):p?t.value:void 0}}hasElementOrSubtree(E){return this._findSuperstrOrElement(E,!0)!==void 0}forEach(E){for(const[p,h]of this)E(h,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const p=[];return this._dfsEntries(E,p),p[Symbol.iterator]()}_dfsEntries(E,p){E&&(E.left&&this._dfsEntries(E.left,p),E.value&&p.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,p),E.right&&this._dfsEntries(E.right,p))}_isBalanced(){const E=p=>{if(!p)return!0;const h=p.balanceFactor();return h<-1||h>1?!1:E(p.left)&&E(p.right)};return E(this._root)}}e.TernarySearchTree=D}),define(Te[43],Ae([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(T){function l(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=l})(R||(e.ThemeColor=R={}));function P(T){return{id:T}}e.themeColorFromId=P;var F;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(u){const v=l.exec(u.id);if(!v)return y(w.Codicon.error);const[,_,m]=v,n=["codicon","codicon-"+_];return m&&n.push("codicon-modifier-"+m.substring(1)),n}T.asClassNameArray=y;function f(u){return y(u).join(" ")}T.asClassName=f;function A(u){return"."+y(u).join(".")}T.asCSSSelector=A;function D(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||R.isThemeColor(u.color))}T.isThemeIcon=D;const a=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function E(u){const v=a.exec(u);if(!v)return;const[,_]=v;return{id:_}}T.fromString=E;function p(u){return{id:u}}T.fromId=p;function h(u,v){let _=u.id;const m=_.lastIndexOf("~");return m!==-1&&(_=_.substring(0,m)),v&&(_=`${_}~${v}`),{id:_}}T.modify=h;function t(u){const v=u.id.lastIndexOf("~");if(v!==-1)return u.id.substring(v+1)}T.getModifier=t;function i(u,v){return u.id===v.id&&u.color?.id===v.color?.id}T.isEqual=i})(F||(e.ThemeIcon=F={}))}),define(Te[121],Ae([1,0,119,16,43]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const F="$(",T=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${T.source}`,"g");function y(i){return i.replace(l,(u,v)=>v?u:`\\${u}`)}e.escapeIcons=y;const f=new RegExp(`\\\\${T.source}`,"g");function A(i){return i.replace(f,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=A;const D=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function a(i){return i.indexOf(F)===-1?i:i.replace(D,(u,v,_,m)=>_?u:v||m||"")}e.stripIcons=a;function E(i){return i?i.replace(/\$\((.*?)\)/g,(u,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=E;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(i){p.lastIndex=0;let u="";const v=[];let _=0;for(;;){const m=p.lastIndex,n=p.exec(i),r=i.substring(m,n?.index);if(r.length>0){u+=r;for(let s=0;s<r.length;s++)v.push(_)}if(!n)break;_+=n[0].length}return{text:u,iconOffsets:v}}e.parseLabelWithIcons=h;function t(i,u,v=!1){const{text:_,iconOffsets:m}=u;if(!m||m.length===0)return(0,w.matchesFuzzy)(i,_,v);const n=(0,R.ltrim)(_," "),r=_.length-n.length,s=(0,w.matchesFuzzy)(i,n,v);if(s)for(const o of s){const g=m[o.start+r]+r;o.start+=g,o.end+=g}return s}e.matchesFuzzyIconAware=t}),define(Te[36],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return w.test(P)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(l){for(let y=0;y<l.length;y++)l[y]=Math.floor(Math.random()*256);return l};const F=new Uint8Array(16),T=[];for(let l=0;l<256;l++)T.push(l.toString(16).padStart(2,"0"));return function(){P(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let y=0,f="";return f+=T[F[y++]],f+=T[F[y++]],f+=T[F[y++]],f+=T[F[y++]],f+="-",f+=T[F[y++]],f+=T[F[y++]],f+="-",f+=T[F[y++]],f+=T[F[y++]],f+="-",f+=T[F[y++]],f+=T[F[y++]],f+="-",f+=T[F[y++]],f+=T[F[y++]],f+=T[F[y++]],f+=T[F[y++]],f+=T[F[y++]],f+=T[F[y++]],f}}()}),define(Te[122],Ae([1,0,18,66,36]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function F(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.createStringDataTransferItem=F;function T(D,a,E){const p={id:(0,P.generateUuid)(),name:D,uri:a,data:E};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.createFileDataTransferItem=T;class l{constructor(){this._entries=new Map}get size(){let a=0;for(const E of this._entries)a++;return a}has(a){return this._entries.has(this.toKey(a))}matches(a){const E=[...this._entries.keys()];return R.Iterable.some(this,([p,h])=>h.asFile())&&E.push("files"),A(y(a),E)}get(a){return this._entries.get(this.toKey(a))?.[0]}append(a,E){const p=this._entries.get(a);p?p.push(E):this._entries.set(this.toKey(a),[E])}replace(a,E){this._entries.set(this.toKey(a),[E])}delete(a){this._entries.delete(this.toKey(a))}*[Symbol.iterator](){for(const[a,E]of this._entries)for(const p of E)yield[a,p]}toKey(a){return y(a)}}e.VSDataTransfer=l;function y(D){return D.toLowerCase()}function f(D,a){return A(y(D),a.map(y))}e.matchesMimeType=f;function A(D,a){if(D==="*/*")return a.length>0;if(a.includes(D))return!0;const E=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[p,h,t]=E;return t==="*"?a.some(i=>i.startsWith(h+"/")):!1}e.UriList=Object.freeze({create:D=>(0,w.distinct)(D.map(a=>a.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.UriList.split(D).filter(a=>!a.startsWith("#"))})}),define(Te[123],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Te[124],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class R{constructor(l){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=l.open,this.close=l.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(l.notIn))for(let y=0,f=l.notIn.length;y<f;y++)switch(l.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(l,y){if(l.getTokenCount()===0)return!0;const f=l.findTokenIndexAtOffset(y-2),A=l.getStandardTokenType(f);return this.isOK(A)}_findNeutralCharacterInRange(l,y){for(let f=l;f<=y;f++){const A=String.fromCharCode(f);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=R;class P{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of l)F(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),F(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),F(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),F(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&F(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=P;function F(T,l,y){T.has(l)?T.get(l).push(y):T.set(l,[y])}}),define(Te[125],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class w{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(F){if(F&&this._dragOperations.has(F)){const T=this._dragOperations.get(F);return this._dragOperations.delete(F),T}}addDragOperationTransfer(F,T){this._dragOperations.set(F,T)}}e.TreeViewsDnDService=w;class R{constructor(F){this.identifier=F}}e.DraggedTreeItemsIdentifier=R}),define(Te[126],Ae([9,10]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Te[127],Ae([1,0,5,6,126]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class F extends R.Disposable{constructor(a,E="",p="",h=!0,t){super(),this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=a,this._label=E,this._cssClass=p,this._enabled=h,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(a){this._setLabel(a)}_setLabel(a){this._label!==a&&(this._label=a,this._onDidChange.fire({label:a}))}get tooltip(){return this._tooltip||""}set tooltip(a){this._setTooltip(a)}_setTooltip(a){this._tooltip!==a&&(this._tooltip=a,this._onDidChange.fire({tooltip:a}))}get class(){return this._cssClass}set class(a){this._setClass(a)}_setClass(a){this._cssClass!==a&&(this._cssClass=a,this._onDidChange.fire({class:a}))}get enabled(){return this._enabled}set enabled(a){this._setEnabled(a)}_setEnabled(a){this._enabled!==a&&(this._enabled=a,this._onDidChange.fire({enabled:a}))}get checked(){return this._checked}set checked(a){this._setChecked(a)}_setChecked(a){this._checked!==a&&(this._checked=a,this._onDidChange.fire({checked:a}))}async run(a,E){this._actionCallback&&await this._actionCallback(a)}}e.Action=F;class T extends R.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event}async run(a,E){if(!a.enabled)return;this._onWillRun.fire({action:a});let p;try{await this.runAction(a,E)}catch(h){p=h}this._onDidRun.fire({action:a,error:p})}async runAction(a,E){await a.run(E)}}e.ActionRunner=T;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let E=[];for(const p of a)p.length&&(E.length?E=[...E,new l,...p]:E=p);return E}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=l;class y{get actions(){return this._actions}constructor(a,E,p,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=E,this.class=h,this._actions=p}async run(){}}e.SubmenuAction=y;class f extends F{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,P.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=f;function A(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...a)=>D.run(...a),tooltip:D.label}}e.toAction=A}),define(Te[128],Ae([9,10]),function(be,e){return be.create("vs/base/common/date",e)}),define(Te[129],Ae([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,P=R*60,F=P*24,T=F*7,l=F*30,y=F*365;function f(D,a,E,p){typeof D!="number"&&(D=D.getTime());const h=Math.round((new Date().getTime()-D)/1e3);if(h<-30)return(0,w.localize)(0,null,f(new Date().getTime()+h*1e3,!1));if(!p&&h<30)return(0,w.localize)(1,null);let t;return h<R?(t=h,a?t===1?E?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):E?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?E?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):E?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):h<P?(t=Math.floor(h/R),a?t===1?E?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):E?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?E?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):E?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):h<F?(t=Math.floor(h/P),a?t===1?E?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):E?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?E?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):E?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):h<T?(t=Math.floor(h/F),a?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):h<l?(t=Math.floor(h/T),a?t===1?E?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):E?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?E?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):E?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):h<y?(t=Math.floor(h/l),a?t===1?E?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):E?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?E?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):E?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(h/y),a?t===1?E?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):E?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?E?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):E?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.fromNow=f;function A(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(Te[130],Ae([9,10]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Te[37],Ae([1,0,18,15,130]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function F(D,a){return a&&(D.stack||D.stacktrace)?P.localize(0,null,l(D),T(D.stack)||T(D.stacktrace)):l(D)}function T(D){return Array.isArray(D)?D.join(`
`):D}function l(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function y(D=null,a=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const E=w.coalesce(D),p=y(E[0],a);return E.length>1?P.localize(4,null,p,E.length):p}if(R.isString(D))return D;if(D.detail){const E=D.detail;if(E.error)return F(E.error,a);if(E.exception)return F(E.exception,a)}return D.stack?F(D,a):D.message?D.message:P.localize(5,null)}e.toErrorMessage=y;function f(D){const a=D;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=f;function A(D,a){let E;return typeof D=="string"?E=new Error(D):E=D,E.actions=a,E}e.createErrorWithActions=A}),define(Te[131],Ae([1,0,42,20]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const P=new w.Lazy(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),F=new w.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new w.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(I,c,S=!1){const b=I||"",C=c||"",$=P.value.collator.compare(b,C);return P.value.collatorIsNumeric&&$===0&&b!==C?b<C?-1:1:$}e.compareFileNames=l;function y(I,c){const S=F.value.collator;return I=I||"",c=c||"",_(S,I,c)}e.compareFileNamesDefault=y;function f(I,c){const S=F.value.collator;return I=I||"",c=c||"",s(I,c)||_(S,I,c)}e.compareFileNamesUpper=f;function A(I,c){const S=F.value.collator;return I=I||"",c=c||"",r(I,c)||_(S,I,c)}e.compareFileNamesLower=A;function D(I,c){return I=I||"",c=c||"",I===c?0:I<c?-1:1}e.compareFileNamesUnicode=D;function a(I,c){const[S,b]=u(I),[C,$]=u(c);let N=P.value.collator.compare(b,$);if(N===0){if(P.value.collatorIsNumeric&&b!==$)return b<$?-1:1;if(N=P.value.collator.compare(S,C),P.value.collatorIsNumeric&&N===0&&S!==C)return S<C?-1:1}return N}e.compareFileExtensions=a;function E(I,c){I=I||"",c=c||"";const S=v(I),b=v(c),C=F.value.collator,$=T.value.collator;return _($,S,b)||_(C,I,c)}e.compareFileExtensionsDefault=E;function p(I,c){I=I||"",c=c||"";const S=v(I),b=v(c),C=F.value.collator,$=T.value.collator;return _($,S,b)||s(I,c)||_(C,I,c)}e.compareFileExtensionsUpper=p;function h(I,c){I=I||"",c=c||"";const S=v(I),b=v(c),C=F.value.collator,$=T.value.collator;return _($,S,b)||r(I,c)||_(C,I,c)}e.compareFileExtensionsLower=h;function t(I,c){I=I||"",c=c||"";const S=v(I).toLowerCase(),b=v(c).toLowerCase();return S!==b?S<b?-1:1:I!==c?I<c?-1:1:0}e.compareFileExtensionsUnicode=t;const i=/^(.*?)(\.([^.]*))?$/;function u(I,c=!1){const S=I?i.exec(I):[];let b=[S&&S[1]||"",S&&S[3]||""];return c&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function v(I){const c=I?i.exec(I):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function _(I,c,S){const b=I.compare(c,S);return b!==0?b:c.length!==S.length?c.length<S.length?-1:1:0}function m(I){const c=I.charAt(0);return c.toLocaleUpperCase()!==c}function n(I){const c=I.charAt(0);return c.toLocaleLowerCase()!==c}function r(I,c){return m(I)&&n(c)?-1:n(I)&&m(c)?1:0}function s(I,c){return n(I)&&m(c)?-1:m(I)&&n(c)?1:0}function o(I,c,S=!1){return S||(I=I&&I.toLowerCase(),c=c&&c.toLowerCase()),I===c?0:I<c?-1:1}function g(I,c,S=!1){const b=I.split(R.sep),C=c.split(R.sep),$=b.length-1,N=C.length-1;let H,B;for(let L=0;;L++){if(H=$===L,B=N===L,H&&B)return l(b[L],C[L],S);if(H)return-1;if(B)return 1;const U=o(b[L],C[L],S);if(U!==0)return U}}e.comparePaths=g;function d(I,c,S){const b=I.toLowerCase(),C=c.toLowerCase(),$=k(I,c,S);if($)return $;const N=b.endsWith(S),H=C.endsWith(S);if(N!==H)return N?-1:1;const B=l(b,C);return B!==0?B:b.localeCompare(C)}e.compareAnything=d;function k(I,c,S){const b=I.toLowerCase(),C=c.toLowerCase(),$=b.startsWith(S),N=C.startsWith(S);if($!==N)return $?-1:1;if($&&N){if(b.length<C.length)return-1;if(b.length>C.length)return 1}return 0}e.compareByPrefix=k}),define(Te[44],Ae([1,0,20,23,16,15]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(d){return d===47||d===92}e.isPathSeparator=T;function l(d){return d.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=l;function y(d){return d.indexOf("/")===-1&&(d=l(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=y;function f(d,k=w.posix.sep){if(!d)return"";const I=d.length,c=d.charCodeAt(0);if(T(c)){if(T(d.charCodeAt(1))&&!T(d.charCodeAt(2))){let b=3;const C=b;for(;b<I&&!T(d.charCodeAt(b));b++);if(C!==b&&!T(d.charCodeAt(b+1))){for(b+=1;b<I;b++)if(T(d.charCodeAt(b)))return d.slice(0,b+1).replace(/[\\/]/g,k)}}return k}else if(i(c)&&d.charCodeAt(1)===58)return T(d.charCodeAt(2))?d.slice(0,2)+k:d.slice(0,2);let S=d.indexOf("://");if(S!==-1){for(S+=3;S<I;S++)if(T(d.charCodeAt(S)))return d.slice(0,S+1)}return""}e.getRoot=f;function A(d){if(!R.isWindows||!d||d.length<5)return!1;let k=d.charCodeAt(0);if(k!==92||(k=d.charCodeAt(1),k!==92))return!1;let I=2;const c=I;for(;I<d.length&&(k=d.charCodeAt(I),k!==92);I++);return!(c===I||(k=d.charCodeAt(I+1),isNaN(k)||k===92))}e.isUNC=A;const D=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(d,k=R.isWindows){const I=k?D:a;return!(!d||d.length===0||/^\s+$/.test(d)||(I.lastIndex=0,I.test(d))||k&&E.test(d)||d==="."||d===".."||k&&d[d.length-1]==="."||k&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=p;function h(d,k,I){const c=d===k;return!I||c?c:!d||!k?!1:(0,P.equalsIgnoreCase)(d,k)}e.isEqual=h;function t(d,k,I,c=w.sep){if(d===k)return!0;if(!d||!k||k.length>d.length)return!1;if(I){if(!(0,P.startsWithIgnoreCase)(d,k))return!1;if(k.length===d.length)return!0;let b=k.length;return k.charAt(k.length-1)===c&&b--,d.charAt(b)===c}return k.charAt(k.length-1)!==c&&(k+=c),d.indexOf(k)===0}e.isEqualOrParent=t;function i(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=i;function u(d,k){return R.isWindows&&d.endsWith(":")&&(d+=w.sep),(0,w.isAbsolute)(d)||(d=(0,w.join)(k,d)),d=(0,w.normalize)(d),R.isWindows?(d=(0,P.rtrim)(d,w.sep),d.endsWith(":")&&(d+=w.sep)):(d=(0,P.rtrim)(d,w.sep),d||(d=w.sep)),d}e.sanitizeFilePath=u;function v(d){const k=(0,w.normalize)(d);return R.isWindows?d.length>3?!1:_(k)&&(d.length===2||k.charCodeAt(2)===92):k===w.posix.sep}e.isRootOrDriveLetter=v;function _(d,k=R.isWindows){return k?i(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=_;function m(d,k=R.isWindows){return _(d,k)?d[0]:void 0}e.getDriveLetter=m;function n(d,k,I){return k.length>d.length?-1:d===k?0:(I&&(d=d.toLowerCase(),k=k.toLowerCase()),d.indexOf(k))}e.indexOfPath=n;function r(d){const k=d.split(":");let I,c,S;for(const b of k){const C=Number(b);(0,F.isNumber)(C)?c===void 0?c=C:S===void 0&&(S=C):I=I?[I,b].join(":"):b}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:c!==void 0?c:void 0,column:S!==void 0?S:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(d,k,I=8){let c="";for(let b=0;b<I;b++){let C;b===0&&R.isWindows&&!k&&(I===3||I===4)?C=o:C=s,c+=C.charAt(Math.floor(Math.random()*C.length))}let S;return k?S=`${k}-${c}`:S=c,d?(0,w.join)(d,S):S}e.randomPath=g}),define(Te[67],Ae([1,0,20]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(A){const D=(0,w.extname)(A),a=R[D.toLowerCase()];return a!==void 0?a:T(A)}e.getMediaOrTextMime=F;function T(A){const D=(0,w.extname)(A);return P[D.toLowerCase()]}e.getMediaMime=T;function l(A){for(const D in P)if(P[D]===A)return D}e.getExtensionForMimeType=l;const y=/^(.+)\/(.+?)(;.+)?$/;function f(A,D){const a=y.exec(A);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:D?void 0:A}e.normalizeMimeType=f}),define(Te[68],Ae([1,0,26,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(y){return JSON.stringify(y,T)}e.stringify=P;function F(y){let f=JSON.parse(y);return f=l(f),f}e.parse=F;function T(y,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function l(y,f=0){if(!y||f>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return R.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 17:return new Date(y.source)}if(y instanceof w.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let A=0;A<y.length;++A)y[A]=l(y[A],f+1);else for(const A in y)Object.hasOwnProperty.call(y,A)&&(y[A]=l(y[A],f+1))}return y}e.revive=l}),define(Te[13],Ae([1,0,11,23,2]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var F;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(A){this._preferredWebSchema=A}setDelegate(A){this._delegate=A}setServerRootPath(A){this._remoteResourcesPath=`${A}/${F.vscodeRemoteResource}`}set(A,D,a){this._hosts[A]=D,this._ports[A]=a}setConnectionToken(A,D){this._connectionTokens[A]=D}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(A){if(this._delegate)try{return this._delegate(A)}catch(t){return w.onUnexpectedError(t),A}const D=A.authority;let a=this._hosts[D];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const E=this._ports[D],p=this._connectionTokens[D];let h=`path=${encodeURIComponent(A.path)}`;return typeof p=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),P.URI.from({scheme:R.isWeb?this._preferredWebSchema:F.vscodeRemoteResource,authority:`${a}:${E}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class l{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(A){const D=this.toUri(A,be);return this.uriToBrowserUri(D)}uriToBrowserUri(A){return A.scheme===F.vscodeRemote?e.RemoteAuthorities.rewrite(A):A.scheme===F.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${F.vscodeFileResource}://${l.FALLBACK_AUTHORITY}`)?A.with({scheme:F.vscodeFileResource,authority:A.authority||l.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(A){const D=this.toUri(A,be);return this.uriToFileUri(D)}uriToFileUri(A){return A.scheme===F.vscodeFileResource?A.with({scheme:F.file,authority:A.authority!==l.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(A,D){return P.URI.isUri(A)?A:P.URI.parse(D.toUrl(A))}}e.FileAccess=new l;var y;(function(f){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(A.get("3"));const D="vscode-coi";function a(p){let h;typeof p=="string"?h=new URL(p).searchParams:p instanceof URL?h=p.searchParams:P.URI.isUri(p)&&(h=new URL(p.toString(!0)).searchParams);const t=h?.get(D);if(t)return A.get(t)}f.getHeadersFromQuery=a;function E(p,h,t){if(!globalThis.crossOriginIsolated)return;const i=h&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(D,i):p[D]=i}f.addSearchParam=E})(y||(e.COI=y={}))}),define(Te[24],Ae([1,0,44,13,20,23,16,2]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(E){return(0,l.uriToFsPath)(E,!0)}e.originalFSPath=y;class f{constructor(p){this._ignorePathCasing=p}compare(p,h,t=!1){return p===h?0:(0,T.compare)(this.getComparisonKey(p,t),this.getComparisonKey(h,t))}isEqual(p,h,t=!1){return p===h?!0:!p||!h?!1:this.getComparisonKey(p,t)===this.getComparisonKey(h,t)}getComparisonKey(p,h=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,h,t=!1){if(p.scheme===h.scheme){if(p.scheme===R.Schemas.file)return w.isEqualOrParent(y(p),y(h),this._ignorePathCasing(p))&&p.query===h.query&&(t||p.fragment===h.fragment);if((0,e.isEqualAuthority)(p.authority,h.authority))return w.isEqualOrParent(p.path,h.path,this._ignorePathCasing(p),"/")&&p.query===h.query&&(t||p.fragment===h.fragment)}return!1}joinPath(p,...h){return l.URI.joinPath(p,...h)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return P.posix.basename(p.path)}extname(p){return P.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let h;return p.scheme===R.Schemas.file?h=l.URI.file(P.dirname(y(p))).path:(h=P.posix.dirname(p.path),p.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),h="/")),p.with({path:h})}normalizePath(p){if(!p.path.length)return p;let h;return p.scheme===R.Schemas.file?h=l.URI.file(P.normalize(y(p))).path:h=P.posix.normalize(p.path),p.with({path:h})}relativePath(p,h){if(p.scheme!==h.scheme||!(0,e.isEqualAuthority)(p.authority,h.authority))return;if(p.scheme===R.Schemas.file){const u=P.relative(y(p),y(h));return F.isWindows?w.toSlashes(u):u}let t=p.path||"/";const i=h.path||"/";if(this._ignorePathCasing(p)){let u=0;for(const v=Math.min(t.length,i.length);u<v&&!(t.charCodeAt(u)!==i.charCodeAt(u)&&t.charAt(u).toLowerCase()!==i.charAt(u).toLowerCase());u++);t=i.substr(0,u)+t.substr(u)}return P.posix.relative(t,i)}resolvePath(p,h){if(p.scheme===R.Schemas.file){const t=l.URI.file(P.resolve(y(p),h));return p.with({authority:t.authority,path:t.path})}return h=w.toPosixPath(h),p.with({path:P.posix.resolve(p.path,h)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,h){return p===h||p!==void 0&&h!==void 0&&(0,T.equalsIgnoreCase)(p,h)}hasTrailingPathSeparator(p,h=P.sep){if(p.scheme===R.Schemas.file){const t=y(p);return t.length>w.getRoot(t).length&&t[t.length-1]===h}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,h=P.sep){return(0,e.hasTrailingPathSeparator)(p,h)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,h=P.sep){let t=!1;if(p.scheme===R.Schemas.file){const i=y(p);t=i!==void 0&&i.length===w.getRoot(i).length&&i[i.length-1]===h}else{h="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(p,h)?p.with({path:p.path+"/"}):p}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(E=>E.scheme===R.Schemas.file?!F.isLinux:!0),e.extUriIgnorePathCase=new f(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(E,p){const h=[];for(let t=0;t<E.length;t++){const i=p(E[t]);E.some((u,v)=>v===t?!1:(0,e.isEqualOrParent)(i,p(u)))||h.push(E[t])}return h}e.distinctParents=A;var D;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function p(h){const t=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(v=>{const[_,m]=v.split(":");_&&m&&t.set(_,m)});const u=h.path.substring(0,h.path.indexOf(";"));return u&&t.set(E.META_DATA_MIME,u),t}E.parseMetaData=p})(D||(e.DataUri=D={}));function a(E,p,h){if(p){let t=E.path;return t&&t[0]!==P.posix.sep&&(t=P.posix.sep+t),E.with({scheme:h,authority:p,path:t})}return E.with({scheme:h})}e.toLocalResource=a}),define(Te[12],Ae([1,0,19,11,5,6,24,23,120]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(Y){return!!Y&&typeof Y.then=="function"}e.isThenable=f;function A(Y){const ee=new w.CancellationTokenSource,ve=Y(ee.token),ge=new Promise((de,_e)=>{const re=ee.token.onCancellationRequested(()=>{re.dispose(),ee.dispose(),_e(new R.CancellationError)});Promise.resolve(ve).then(ue=>{re.dispose(),ee.dispose(),de(ue)},ue=>{re.dispose(),ee.dispose(),_e(ue)})});return new class{cancel(){ee.cancel()}then(de,_e){return ge.then(de,_e)}catch(de){return this.then(void 0,de)}finally(de){return ge.finally(de)}}}e.createCancelablePromise=A;function D(Y,ee,ve){return new Promise((ge,de)=>{const _e=ee.onCancellationRequested(()=>{_e.dispose(),ge(ve)});Y.then(ge,de).finally(()=>_e.dispose())})}e.raceCancellation=D;function a(Y,ee){return new Promise((ve,ge)=>{const de=ee.onCancellationRequested(()=>{de.dispose(),ge(new R.CancellationError)});Y.then(ve,ge).finally(()=>de.dispose())})}e.raceCancellationError=a;async function E(Y){let ee=-1;const ve=Y.map((ge,de)=>ge.then(_e=>(ee=de,_e)));try{return await Promise.race(ve)}finally{Y.forEach((ge,de)=>{de!==ee&&ge.cancel()})}}e.raceCancellablePromises=E;function p(Y,ee,ve){let ge;const de=setTimeout(()=>{ge?.(void 0),ve?.()},ee);return Promise.race([Y.finally(()=>clearTimeout(de)),new Promise(_e=>ge=_e)])}e.raceTimeout=p;function h(Y){return new Promise((ee,ve)=>{const ge=Y();f(ge)?ge.then(ee,ve):ee(ge)})}e.asPromise=h;class t{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const ve=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ge=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ge};this.queuedPromise=new Promise(ge=>{this.activePromise.then(ve,ve).then(ge)})}return new Promise((ve,ge)=>{this.queuedPromise.then(ve,ge)})}return this.activePromise=ee(),new Promise((ve,ge)=>{this.activePromise.then(de=>{this.activePromise=null,ve(de)},de=>{this.activePromise=null,ge(de)})})}dispose(){this.isDisposed=!0}}e.Throttler=t;class i{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=i;class u{constructor(){this.promiseMap=new Map}queue(ee,ve){const de=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(ee)===de&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,de),de}}e.SequencerByKey=u;const v=(Y,ee)=>{let ve=!0;const ge=setTimeout(()=>{ve=!1,ee()},Y);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(ge),ve=!1}}},_=Y=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,Y())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class m{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,ve=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((de,_e)=>{this.doResolve=de,this.doReject=_e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const de=this.task;return this.task=null,de()}}));const ge=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===y.MicrotaskDelay?_(ge):v(ve,ge),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new R.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=m;class n{constructor(ee){this.delayer=new m(ee),this.throttler=new t}trigger(ee,ve){return this.delayer.trigger(()=>this.throttler.queue(ee),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=n;class r{constructor(){this._isOpen=!1,this._promise=new Promise((ee,ve)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class s extends r{constructor(ee){super(),this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function o(Y,ee){return ee?new Promise((ve,ge)=>{const de=setTimeout(()=>{_e.dispose(),ve()},Y),_e=ee.onCancellationRequested(()=>{clearTimeout(de),_e.dispose(),ge(new R.CancellationError)})}):A(ve=>o(Y,ve))}e.timeout=o;function g(Y,ee=0,ve){const ge=setTimeout(()=>{Y(),ve&&de.dispose()},ee),de=(0,F.toDisposable)(()=>{clearTimeout(ge),ve?.deleteAndLeak(de)});return ve?.add(de),de}e.disposableTimeout=g;function d(Y){const ee=[];let ve=0;const ge=Y.length;function de(){return ve<ge?Y[ve++]():null}function _e(re){re!=null&&ee.push(re);const ue=de();return ue?ue.then(_e):Promise.resolve(ee)}return Promise.resolve(null).then(_e)}e.sequence=d;function k(Y,ee=ge=>!!ge,ve=null){let ge=0;const de=Y.length,_e=()=>{if(ge>=de)return Promise.resolve(ve);const re=Y[ge++];return Promise.resolve(re()).then(ne=>ee(ne)?Promise.resolve(ne):_e())};return _e()}e.first=k;function I(Y,ee=ge=>!!ge,ve=null){if(Y.length===0)return Promise.resolve(ve);let ge=Y.length;const de=()=>{ge=-1;for(const _e of Y)_e.cancel?.()};return new Promise((_e,re)=>{for(const ue of Y)ue.then(ne=>{--ge>=0&&ee(ne)?(de(),_e(ne)):ge===0&&_e(ve)}).catch(ne=>{--ge>=0&&(de(),re(ne))})})}e.firstParallel=I;class c{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((ve,ge)=>{this.outstandingPromises.push({factory:ee,c:ve,e:ge}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const ve=ee.factory();ve.then(ee.c,ee.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=c;class S extends c{constructor(){super(1)}}e.Queue=S;class b{constructor(){this.sequentializer=new ye,this.tasks=0}queue(ee){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,ee())):this.sequentializer.run(this.tasks++,ee())}}e.LimitedQueue=b;class C{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const ee=new pe;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,ve=T.extUri){const ge=ve.getComparisonKey(ee);let de=this.queues.get(ge);if(!de){de=new S;const _e=this.drainListenerCount++,re=P.Event.once(de.onDrained)(()=>{de?.dispose(),this.queues.delete(ge),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(_e),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new F.DisposableMap),this.drainListeners.set(_e,re),this.queues.set(ge,de)}return de}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=C;class ${constructor(ee,ve){this._token=-1,typeof ee=="function"&&typeof ve=="number"&&this.setIfNotSet(ee,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},ve)}setIfNotSet(ee,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},ve))}}e.TimeoutTimer=$;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setInterval(()=>{ee()},ve)}}e.IntervalTimer=N;class H{constructor(ee,ve){this.timeoutToken=-1,this.runner=ee,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class B{constructor(ee,ve){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=B;class L extends H{constructor(ee,ve){super(ee,ve),this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class U extends F.Disposable{constructor(ee,ve){super(),this.options=ee,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new F.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ve of ee)this.pendingWork.push(ve);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Y=>{(0,l.setTimeout0)(()=>{if(ee)return;const ve=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(Y,ee)=>{const ve=requestIdleCallback(Y,typeof ee=="number"?{timeout:ee}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,cancelIdleCallback(ve))}}}}();class ie{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ie;async function X(Y,ee,ve){let ge;for(let de=0;de<ve;de++)try{return await Y()}catch(_e){ge=_e,await o(ee)}throw ge}e.retry=X;class ye{isRunning(ee){return typeof ee=="number"?this._running?.taskId===ee:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(ee,ve,ge){return this._running={taskId:ee,cancel:()=>ge?.(),promise:ve},ve.then(()=>this.doneRunning(ee),()=>this.doneRunning(ee)),ve}doneRunning(ee){this._running&&ee===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const ee=this._queued;this._queued=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this._queued)this._queued.run=ee;else{let ve,ge;const de=new Promise((_e,re)=>{ve=_e,ge=re});this._queued={run:ee,promise:de,promiseResolve:ve,promiseReject:ge}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ye;class Pe{constructor(ee,ve=()=>Date.now()){this.interval=ee,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=Pe;var De;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(De||(De={}));class pe{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((ee,ve)=>{this.completeCallback=ee,this.errorCallback=ve})}complete(ee){return new Promise(ve=>{this.completeCallback(ee),this.outcome={outcome:0,value:ee},ve()})}error(ee){return new Promise(ve=>{this.errorCallback(ee),this.outcome={outcome:1,value:ee},ve()})}cancel(){return this.error(new R.CancellationError)}}e.DeferredPromise=pe;var Se;(function(Y){async function ee(ge){let de;const _e=await Promise.all(ge.map(re=>re.then(ue=>ue,ue=>{de||(de=ue)})));if(typeof de<"u")throw de;return _e}Y.settled=ee;function ve(ge){return new Promise(async(de,_e)=>{try{await ge(de,_e)}catch(re){_e(re)}})}Y.withAsyncBody=ve})(Se||(e.Promises=Se={}));var le;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(le||(le={}));class ae{static fromArray(ee){return new ae(ve=>{ve.emitMany(ee)})}static fromPromise(ee){return new ae(async ve=>{ve.emitMany(await ee)})}static fromPromises(ee){return new ae(async ve=>{await Promise.all(ee.map(async ge=>ve.emitOne(await ge)))})}static merge(ee){return new ae(async ve=>{await Promise.all(ee.map(async ge=>{for await(const de of ge)ve.emitOne(de)}))})}static{this.EMPTY=ae.fromArray([])}constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const ve={emitOne:ge=>this.emitOne(ge),emitMany:ge=>this.emitMany(ge),reject:ge=>this.reject(ge)};try{await Promise.resolve(ee(ve)),this.resolve()}catch(ge){this.reject(ge)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,ve){return new ae(async ge=>{for await(const de of ee)ge.emitOne(ve(de))})}map(ee){return ae.map(this,ee)}static filter(ee,ve){return new ae(async ge=>{for await(const de of ee)ve(de)&&ge.emitOne(de)})}filter(ee){return ae.filter(this,ee)}static coalesce(ee){return ae.filter(ee,ve=>!!ve)}coalesce(){return ae.coalesce(this)}static async toPromise(ee){const ve=[];for await(const ge of ee)ve.push(ge);return ve}toPromise(){return ae.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=ae;class we extends ae{constructor(ee,ve){super(ve),this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function Z(Y){const ee=new w.CancellationTokenSource,ve=Y(ee.token);return new we(ee,async ge=>{const de=ee.token.onCancellationRequested(()=>{de.dispose(),ee.dispose(),ge.reject(new R.CancellationError)});try{for await(const _e of ve){if(ee.token.isCancellationRequested)return;ge.emitOne(_e)}de.dispose(),ee.dispose()}catch(_e){de.dispose(),ee.dispose(),ge.reject(_e)}})}e.createCancelableAsyncIterable=Z;class z{constructor(){this._deferred=new pe,this._asyncIterable=new ae(ge=>{if(ee){ge.reject(ee);return}return ve&&ge.emitMany(ve),this._errorFn=de=>ge.reject(de),this._emitFn=de=>ge.emitOne(de),this._deferred.p});let ee,ve;this._emitFn=ge=>{ve||(ve=[]),ve.push(ge)},this._errorFn=ge=>{ee||(ee=ge)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(ee){this._errorFn(ee),this._deferred.complete()}emitOne(ee){this._emitFn(ee)}}e.AsyncIterableSource=z}),define(Te[38],Ae([1,0,18,12,44,28,20,23,16]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function f(){return Object.create(null)}e.getEmptyExpression=f,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",D="[^/\\\\]",a=/\//g;function E(ye,Pe){switch(ye){case 0:return"";case 1:return`${D}*?`;default:return`(?:${A}|${D}+${A}${Pe?`|${A}${D}+`:""})*?`}}function p(ye,Pe){if(!ye)return[];const De=[];let pe=!1,Se=!1,le="";for(const ae of ye){switch(ae){case Pe:if(!pe&&!Se){De.push(le),le="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":Se=!0;break;case"]":Se=!1;break}le+=ae}return le&&De.push(le),De}e.splitGlobAware=p;function h(ye){if(!ye)return"";let Pe="";const De=p(ye,e.GLOB_SPLIT);if(De.every(pe=>pe===e.GLOBSTAR))Pe=".*";else{let pe=!1;De.forEach((Se,le)=>{if(Se===e.GLOBSTAR){if(pe)return;Pe+=E(2,le===De.length-1)}else{let ae=!1,we="",Z=!1,z="";for(const Y of Se){if(Y!=="}"&&ae){we+=Y;continue}if(Z&&(Y!=="]"||!z)){let ee;Y==="-"?ee=Y:(Y==="^"||Y==="!")&&!z?ee="^":Y===e.GLOB_SPLIT?ee="":ee=(0,y.escapeRegExpCharacters)(Y),z+=ee;continue}switch(Y){case"{":ae=!0;continue;case"[":Z=!0;continue;case"}":{const ve=`(?:${p(we,",").map(ge=>h(ge)).join("|")})`;Pe+=ve,ae=!1,we="";break}case"]":{Pe+="["+z+"]",Z=!1,z="";break}case"?":Pe+=D;continue;case"*":Pe+=E(1);continue;default:Pe+=(0,y.escapeRegExpCharacters)(Y)}}le<De.length-1&&(De[le+1]!==e.GLOBSTAR||le+2<De.length)&&(Pe+=A)}pe=Se===e.GLOBSTAR})}return Pe}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,_=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new F.LRUCache(1e4),r=function(){return!1},s=function(){return null};function o(ye,Pe){if(!ye)return s;let De;typeof ye!="string"?De=ye.pattern:De=ye,De=De.trim();const pe=`${De}_${!!Pe.trimForExclusions}`;let Se=n.get(pe);if(Se)return g(Se,ye);let le;return t.test(De)?Se=k(De.substr(4),De):(le=i.exec(d(De,Pe)))?Se=I(le[1],De):(Pe.trimForExclusions?v:u).test(De)?Se=c(De,Pe):(le=_.exec(d(De,Pe)))?Se=S(le[1].substr(1),De,!0):(le=m.exec(d(De,Pe)))?Se=S(le[1],De,!1):Se=b(De),n.set(pe,Se),g(Se,ye)}function g(ye,Pe){if(typeof Pe=="string")return ye;const De=function(pe,Se){return(0,P.isEqualOrParent)(pe,Pe.base,!l.isLinux)?ye((0,y.ltrim)(pe.substr(Pe.base.length),T.sep),Se):null};return De.allBasenames=ye.allBasenames,De.allPaths=ye.allPaths,De.basenames=ye.basenames,De.patterns=ye.patterns,De}function d(ye,Pe){return Pe.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function k(ye,Pe){return function(De,pe){return typeof De=="string"&&De.endsWith(ye)?Pe:null}}function I(ye,Pe){const De=`/${ye}`,pe=`\\${ye}`,Se=function(ae,we){return typeof ae!="string"?null:we?we===ye?Pe:null:ae===ye||ae.endsWith(De)||ae.endsWith(pe)?Pe:null},le=[ye];return Se.basenames=le,Se.patterns=[Pe],Se.allBasenames=le,Se}function c(ye,Pe){const De=ie(ye.slice(1,-1).split(",").map(we=>o(we,Pe)).filter(we=>we!==s),ye),pe=De.length;if(!pe)return s;if(pe===1)return De[0];const Se=function(we,Z){for(let z=0,Y=De.length;z<Y;z++)if(De[z](we,Z))return ye;return null},le=De.find(we=>!!we.allBasenames);le&&(Se.allBasenames=le.allBasenames);const ae=De.reduce((we,Z)=>Z.allPaths?we.concat(Z.allPaths):we,[]);return ae.length&&(Se.allPaths=ae),Se}function S(ye,Pe,De){const pe=T.sep===T.posix.sep,Se=pe?ye:ye.replace(a,T.sep),le=T.sep+Se,ae=T.posix.sep+ye;let we;return De?we=function(Z,z){return typeof Z=="string"&&(Z===Se||Z.endsWith(le)||!pe&&(Z===ye||Z.endsWith(ae)))?Pe:null}:we=function(Z,z){return typeof Z=="string"&&(Z===Se||!pe&&Z===ye)?Pe:null},we.allPaths=[(De?"*/":"./")+ye],we}function b(ye){try{const Pe=new RegExp(`^${h(ye)}$`);return function(De){return Pe.lastIndex=0,typeof De=="string"&&Pe.test(De)?ye:null}}catch{return s}}function C(ye,Pe,De){return!ye||typeof Pe!="string"?!1:$(ye)(Pe,void 0,De)}e.match=C;function $(ye,Pe={}){if(!ye)return r;if(typeof ye=="string"||N(ye)){const De=o(ye,Pe);if(De===s)return r;const pe=function(Se,le){return!!De(Se,le)};return De.allBasenames&&(pe.allBasenames=De.allBasenames),De.allPaths&&(pe.allPaths=De.allPaths),pe}return L(ye,Pe)}e.parse=$;function N(ye){const Pe=ye;return Pe?typeof Pe.base=="string"&&typeof Pe.pattern=="string":!1}e.isRelativePattern=N;function H(ye){return ye.allBasenames||[]}e.getBasenameTerms=H;function B(ye){return ye.allPaths||[]}e.getPathTerms=B;function L(ye,Pe){const De=ie(Object.getOwnPropertyNames(ye).map(we=>U(we,ye[we],Pe)).filter(we=>we!==s)),pe=De.length;if(!pe)return s;if(!De.some(we=>!!we.requiresSiblings)){if(pe===1)return De[0];const we=function(Y,ee){let ve;for(let ge=0,de=De.length;ge<de;ge++){const _e=De[ge](Y,ee);if(typeof _e=="string")return _e;(0,R.isThenable)(_e)&&(ve||(ve=[]),ve.push(_e))}return ve?(async()=>{for(const ge of ve){const de=await ge;if(typeof de=="string")return de}return null})():null},Z=De.find(Y=>!!Y.allBasenames);Z&&(we.allBasenames=Z.allBasenames);const z=De.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return z.length&&(we.allPaths=z),we}const Se=function(we,Z,z){let Y,ee;for(let ve=0,ge=De.length;ve<ge;ve++){const de=De[ve];de.requiresSiblings&&z&&(Z||(Z=(0,T.basename)(we)),Y||(Y=Z.substr(0,Z.length-(0,T.extname)(we).length)));const _e=de(we,Z,Y,z);if(typeof _e=="string")return _e;(0,R.isThenable)(_e)&&(ee||(ee=[]),ee.push(_e))}return ee?(async()=>{for(const ve of ee){const ge=await ve;if(typeof ge=="string")return ge}return null})():null},le=De.find(we=>!!we.allBasenames);le&&(Se.allBasenames=le.allBasenames);const ae=De.reduce((we,Z)=>Z.allPaths?we.concat(Z.allPaths):we,[]);return ae.length&&(Se.allPaths=ae),Se}function U(ye,Pe,De){if(Pe===!1)return s;const pe=o(ye,De);if(pe===s)return s;if(typeof Pe=="boolean")return pe;if(Pe){const Se=Pe.when;if(typeof Se=="string"){const le=(ae,we,Z,z)=>{if(!z||!pe(ae,we))return null;const Y=Se.replace("$(basename)",()=>Z),ee=z(Y);return(0,R.isThenable)(ee)?ee.then(ve=>ve?ye:null):ee?ye:null};return le.requiresSiblings=!0,le}}return pe}function ie(ye,Pe){const De=ye.filter(we=>!!we.basenames);if(De.length<2)return ye;const pe=De.reduce((we,Z)=>{const z=Z.basenames;return z?we.concat(z):we},[]);let Se;if(Pe){Se=[];for(let we=0,Z=pe.length;we<Z;we++)Se.push(Pe)}else Se=De.reduce((we,Z)=>{const z=Z.patterns;return z?we.concat(z):we},[]);const le=function(we,Z){if(typeof we!="string")return null;if(!Z){let Y;for(Y=we.length;Y>0;Y--){const ee=we.charCodeAt(Y-1);if(ee===47||ee===92)break}Z=we.substr(Y)}const z=pe.indexOf(Z);return z!==-1?Se[z]:null};le.basenames=pe,le.patterns=Se,le.allBasenames=pe;const ae=ye.filter(we=>!we.basenames);return ae.push(le),ae}function X(ye,Pe){return(0,w.equals)(ye,Pe,(De,pe)=>typeof De=="string"&&typeof pe=="string"?De===pe:typeof De!="string"&&typeof pe!="string"?De.base===pe.base&&De.pattern===pe.pattern:!1)}e.patternsEquals=X}),define(Te[51],Ae([1,0,11,121,24,16,2]),function(be,e,w,R,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class y{constructor(i="",u=!1){if(this.value=i,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(i,u=0){return this.value+=a(this.supportThemeIcons?(0,R.escapeIcons)(i):i).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,u){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(i,u,v){return this.value+="[",this.value+=this._escape(u,"]"),this.value+="](",this.value+=this._escape(String(i),")"),v&&(this.value+=` "${this._escape(this._escape(v,'"'),")")}"`),this.value+=")",this}_escape(i,u){const v=new RegExp((0,F.escapeRegExpCharacters)(u),"g");return i.replace(v,(_,m)=>i.charAt(m-1)!=="\\"?`\\${_}`:_)}}e.MarkdownString=y;function f(t){return A(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.isEmptyMarkdownString=f;function A(t){return t instanceof y?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.isEqual)(T.URI.from(t.baseUri),T.URI.from(i.baseUri)))}e.markdownStringEqual=D;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=a;function E(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function h(t){const i=[],u=t.split("|").map(_=>_.trim());t=u[0];const v=u[1];if(v){const _=/height=(\d+)/.exec(v),m=/width=(\d+)/.exec(v),n=_?_[1]:"",r=m?m[1]:"",s=isFinite(parseInt(r)),o=isFinite(parseInt(n));s&&i.push(`width="${r}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.parseHrefAndDimensions=h}),define(Te[90],Ae([1,0,18,44,20,23,24,16]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(o,g){const{os:d,tildify:k,relative:I}=g;if(I){const b=f(o,I,d);if(typeof b=="string")return b}let c=o.fsPath;if(d===1&&!F.isWindows?c=c.replace(/\//g,"\\"):d!==1&&F.isWindows&&(c=c.replace(/\\/g,"/")),d!==1&&k?.userHome){const b=k.userHome.fsPath;let C;o.scheme!==k.userHome.scheme&&o.path.startsWith(P.posix.sep)?C=k.userHome.with({path:o.path}).fsPath:C=o.fsPath,c=a(C,b,d)}return(d===1?P.win32:P.posix).normalize(A(c,d===1))}e.getPathLabel=y;function f(o,g,d){const k=d===1?P.win32:P.posix,I=d===3?T.extUri:T.extUriIgnorePathCase,c=g.getWorkspace(),S=(0,w.firstOrDefault)(c.folders);if(!S)return;o.scheme!==S.uri.scheme&&o.path.startsWith(P.posix.sep)&&(o=S.uri.with({path:o.path}));const b=g.getWorkspaceFolder(o);if(!b)return;let C;if(I.isEqual(b.uri,o)?C="":C=I.relativePath(b.uri,o)??"",C&&(C=k.normalize(C)),c.folders.length>1&&!g.noPrefix){const $=b.name?b.name:I.basenameOrAuthority(b.uri);C=C?`${$} \u2022 ${C}`:$}return C}function A(o,g=F.isWindows){return(0,R.hasDriveLetter)(o,g)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=A;let D=Object.create(null);function a(o,g,d=F.OS){if(d===1||!o||!g)return o;let k=D.original===g?D.normalized:void 0;k||(k=g,F.isWindows&&(k=(0,R.toSlashes)(k)),k=`${(0,l.rtrim)(k,P.posix.sep)}${P.posix.sep}`,D={original:g,normalized:k});let I=o;return F.isWindows&&(I=(0,R.toSlashes)(I)),(d===3?I.startsWith(k):(0,l.startsWithIgnoreCase)(I,k))?`~/${I.substr(k.length)}`:o}e.tildify=a;function E(o,g){return o.replace(/^~($|\/|\\)/,`${g}$1`)}e.untildify=E;const p="\u2026",h="\\\\",t="~";function i(o,g=P.sep){const d=new Array(o.length);let k=!1;for(let I=0;I<o.length;I++){const c=o[I];if(c===""){d[I]=`.${g}`;continue}if(!c){d[I]=c;continue}k=!0;let S="",b=c;b.indexOf(h)===0?(S=b.substr(0,b.indexOf(h)+h.length),b=b.substr(b.indexOf(h)+h.length)):b.indexOf(g)===0?(S=b.substr(0,b.indexOf(g)+g.length),b=b.substr(b.indexOf(g)+g.length)):b.indexOf(t)===0&&(S=b.substr(0,b.indexOf(t)+t.length),b=b.substr(b.indexOf(t)+t.length));const C=b.split(g);for(let $=1;k&&$<=C.length;$++)for(let N=C.length-$;k&&N>=0;N--){k=!1;let H=C.slice(N,N+$).join(g);for(let B=0;!k&&B<o.length;B++)if(B!==I&&o[B]&&o[B].indexOf(H)>-1){const L=N+$===C.length,U=N>0&&o[B].indexOf(g)>-1?g+H:H,ie=o[B].endsWith(U);k=!L||ie}if(!k){let B="";(C[0].endsWith(":")||S!=="")&&(N===1&&(N=0,$++,H=C[0]+g+H),N>0&&(B=C[0]+g),B=S+B),N>0&&(B=B+p+g),B=B+H,N+$<C.length&&(B=B+g+p),d[I]=B}}k&&(d[I]=c)}return d}e.shorten=i;var u;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function v(o,g=Object.create(null)){const d=[];let k=!1,I="";for(const c of o)if(c==="$"||k&&c==="{")I&&d.push({value:I,type:u.TEXT}),I="",k=!0;else if(c==="}"&&k){const S=g[I];if(typeof S=="string")S.length&&d.push({value:S,type:u.VARIABLE});else if(S){const b=d[d.length-1];(!b||b.type!==u.SEPARATOR)&&d.push({value:S.label,type:u.SEPARATOR})}I="",k=!1}else I+=c;return I&&!k&&d.push({value:I,type:u.TEXT}),d.filter((c,S)=>{if(c.type===u.SEPARATOR){const b=d[S-1],C=d[S+1];return[b,C].every($=>$&&($.type===u.VARIABLE||$.type===u.TEXT)&&$.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=v;function _(o,g){return F.isMacintosh||g?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):o.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=_;function m(o,g){return F.isMacintosh||g?o.replace(/\(&&\w\)|&&/g,""):F.isWindows?o.replace(/&&|&/g,d=>d==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function n(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(o){if(o.endsWith("]")){const g=o.lastIndexOf(" [",o.length-2);if(g!==-1){const d=s(o.substring(0,g));return{name:d.name,parentPath:d.parentPath+o.substring(g)}}}return s(o)}e.splitRecentLabel=r;function s(o){const g=o.indexOf("/")!==-1?P.posix:P.win32,d=g.basename(o),k=g.dirname(o);return d.length?{name:d,parentPath:k}:{name:k,parentPath:""}}}),define(Te[132],Ae([1,0,26,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(D){return D.toJSON()}class F{constructor(a){this._uriTransformer=a}transformIncoming(a){const E=this._uriTransformer.transformIncoming(a);return E===a?a:P(R.URI.from(E))}transformOutgoing(a){const E=this._uriTransformer.transformOutgoing(a);return E===a?a:P(R.URI.from(E))}transformOutgoingURI(a){const E=this._uriTransformer.transformOutgoing(a);return E===a?a:R.URI.from(E)}transformOutgoingScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}}e.URITransformer=F,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function T(D,a,E){if(!D||E>200)return null;if(typeof D=="object"){if(D instanceof R.URI)return a.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const h=T(D[p],a,E+1);h!==null&&(D[p]=h)}}return null}function l(D,a){const E=T(D,a,0);return E===null?D:E}e.transformOutgoingURIs=l;function y(D,a,E,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return E?R.URI.revive(a.transformIncoming(D)):a.transformIncoming(D);if(D instanceof w.VSBuffer)return null;for(const h in D)if(Object.hasOwnProperty.call(D,h)){const t=y(D[h],a,E,p+1);t!==null&&(D[h]=t)}}return null}function f(D,a){const E=y(D,a,!1,0);return E===null?D:E}e.transformIncomingURIs=f;function A(D,a){const E=y(D,a,!0,0);return E===null?D:E}e.transformAndReviveIncomingURIs=A}),define(Te[133],Ae([1,0,38,20]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function P(F,T,l,y,f,A){if(Array.isArray(F)){let D=0;for(const a of F){const E=P(a,T,l,y,f,A);if(E===10)return E;E>D&&(D=E)}return D}else{if(typeof F=="string")return y?F==="*"?5:F===l?10:0:0;if(F){const{language:D,pattern:a,scheme:E,hasAccessToAllModels:p,notebookType:h}=F;if(!y&&!p)return 0;h&&f&&(T=f);let t=0;if(E)if(E===T.scheme)t=10;else if(E==="*")t=5;else return 0;if(D)if(D===l)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(h)if(h===A)t=10;else if(h==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(a){let i;if(typeof a=="string"?i=a:i={...a,base:(0,R.normalize)(a.base)},i===T.fsPath||(0,w.match)(i,T.fsPath))t=10;else return 0}return t}else return 0}}e.score=P}),define(Te[91],Ae([1,0,26,23]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var P;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(P||(P={}));function F(D){for(let a=0,E=D.length;a<E;a+=4){const p=D[a+0],h=D[a+1],t=D[a+2],i=D[a+3];D[a+0]=i,D[a+1]=t,D[a+2]=h,D[a+3]=p}}function T(D){const a=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return R.isLittleEndian()||F(a),w.VSBuffer.wrap(a)}function l(D){const a=D.buffer;if(R.isLittleEndian()||F(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const E=new Uint8Array(a.byteLength);return E.set(a),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function y(D){const a=new Uint32Array(f(D));let E=0;if(a[E++]=D.id,D.type==="full")a[E++]=1,a[E++]=D.data.length,a.set(D.data,E),E+=D.data.length;else{a[E++]=2,a[E++]=D.deltas.length;for(const p of D.deltas)a[E++]=p.start,a[E++]=p.deleteCount,p.data?(a[E++]=p.data.length,a.set(p.data,E),E+=p.data.length):a[E++]=0}return T(a)}e.encodeSemanticTokensDto=y;function f(D){let a=0;if(a+=1+1,D.type==="full")a+=1+D.data.length;else{a+=1,a+=(1+1+1)*D.deltas.length;for(const E of D.deltas)E.data&&(a+=E.data.length)}return a}function A(D){const a=l(D);let E=0;const p=a[E++];if(a[E++]===1){const u=a[E++],v=a.subarray(E,E+u);return E+=u,{id:p,type:"full",data:v}}const t=a[E++],i=[];for(let u=0;u<t;u++){const v=a[E++],_=a[E++],m=a[E++];let n;m>0&&(n=a.subarray(E,E+m),E+=m),i[u]={start:v,deleteCount:_,data:n}}return{id:p,type:"delta",deltas:i}}e.decodeSemanticTokensDto=A}),define(Te[134],Ae([9,10]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Te[135],Ae([1,0,18,25,23,123,136,134]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(G){this._values=G}hasChanged(G){return this._values[G]}}e.ConfigurationChangedEvent=f;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class D{constructor(G,Ee,Be,Ne){this.id=G,this.name=Ee,this.defaultValue=Be,this.schema=Ne}applyUpdate(G,Ee){return E(G,Ee)}compute(G,Ee,Be){return Be}}class a{constructor(G,Ee){this.newValue=G,this.didChange=Ee}}e.ApplyUpdateResult=a;function E(Q,G){if(typeof Q!="object"||typeof G!="object"||!Q||!G)return new a(G,Q!==G);if(Array.isArray(Q)||Array.isArray(G)){const Be=Array.isArray(Q)&&Array.isArray(G)&&w.equals(Q,G);return new a(G,!Be)}let Ee=!1;for(const Be in G)if(G.hasOwnProperty(Be)){const Ne=E(Q[Be],G[Be]);Ne.didChange&&(Q[Be]=Ne.newValue,Ee=!0)}return new a(Q,Ee)}class p{constructor(G){this.schema=void 0,this.id=G,this.name="_never_",this.defaultValue=void 0}applyUpdate(G,Ee){return E(G,Ee)}validate(G){return this.defaultValue}}class h{constructor(G,Ee,Be,Ne){this.id=G,this.name=Ee,this.defaultValue=Be,this.schema=Ne}applyUpdate(G,Ee){return E(G,Ee)}validate(G){return typeof G>"u"?this.defaultValue:G}compute(G,Ee,Be){return Be}}function t(Q,G){return typeof Q>"u"?G:Q==="false"?!1:!!Q}e.boolean=t;class i extends h{constructor(G,Ee,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(G,Ee,Be,Ne)}validate(G){return t(G,this.defaultValue)}}function u(Q,G,Ee,Be){if(typeof Q>"u")return G;let Ne=parseInt(Q,10);return isNaN(Ne)?G:(Ne=Math.max(Ee,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=u;class v extends h{static clampedInt(G,Ee,Be,Ne){return u(G,Ee,Be,Ne)}constructor(G,Ee,Be,Ne,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Ne,nt.maximum=Xe),super(G,Ee,Be,nt),this.minimum=Ne,this.maximum=Xe}validate(G){return v.clampedInt(G,this.defaultValue,this.minimum,this.maximum)}}function _(Q,G,Ee,Be){if(typeof Q>"u")return G;const Ne=m.float(Q,G);return m.clamp(Ne,Ee,Be)}e.clampedFloat=_;class m extends h{static clamp(G,Ee,Be){return G<Ee?Ee:G>Be?Be:G}static float(G,Ee){if(typeof G=="number")return G;if(typeof G>"u")return Ee;const Be=parseFloat(G);return isNaN(Be)?Ee:Be}constructor(G,Ee,Be,Ne,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(G,Ee,Be,Xe),this.validationFn=Ne}validate(G){return this.validationFn(m.float(G,this.defaultValue))}}class n extends h{static string(G,Ee){return typeof G!="string"?Ee:G}constructor(G,Ee,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(G,Ee,Be,Ne)}validate(G){return n.string(G,this.defaultValue)}}function r(Q,G,Ee,Be){return typeof Q!="string"?G:Be&&Q in Be?Be[Q]:Ee.indexOf(Q)===-1?G:Q}e.stringSet=r;class s extends h{constructor(G,Ee,Be,Ne,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ne,Xe.default=Be),super(G,Ee,Be,Xe),this._allowedValues=Ne}validate(G){return r(G,this.defaultValue,this._allowedValues)}}class o extends D{constructor(G,Ee,Be,Ne,Xe,nt,pt=void 0){typeof pt<"u"&&(pt.type="string",pt.enum=Xe,pt.default=Ne),super(G,Ee,Be,pt),this._allowedValues=Xe,this._convert=nt}validate(G){return typeof G!="string"?this.defaultValue:this._allowedValues.indexOf(G)===-1?this.defaultValue:this._convert(G)}}function g(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(G){switch(G){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(G,Ee,Be){return Be===0?G.accessibilitySupport:Be}}class k extends D{constructor(){const G={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",G,{"editor.comments.insertSpace":{type:"boolean",default:G.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:G.ignoreEmptyLines,description:l.localize(5,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function c(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function b(Q){switch(Q){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function C(Q){switch(Q){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class $ extends p{constructor(){super(141)}compute(G,Ee,Be){const Ne=["monaco-editor"];return Ee.get(39)&&Ne.push(Ee.get(39)),G.extraEditorClassName&&Ne.push(G.extraEditorClassName),Ee.get(73)==="default"?Ne.push("mouse-default"):Ee.get(73)==="copy"&&Ne.push("mouse-copy"),Ee.get(111)&&Ne.push("showUnused"),Ee.get(139)&&Ne.push("showDeprecated"),Ne.join(" ")}}class N extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(G,Ee,Be){return Be&&G.emptySelectionClipboard}}class H extends D{constructor(){const G={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",G,{"editor.find.cursorMoveOnType":{type:"boolean",default:G.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:G.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:G.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:G.globalFindClipboard,description:l.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:G.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:G.loop,description:l.localize(18,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof G.seedSearchStringFromSelection=="boolean"?G.seedSearchStringFromSelection?"always":"never":r(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof G.autoFindInSelection=="boolean"?G.autoFindInSelection?"always":"never":r(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class B extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(G){return typeof G>"u"?this.defaultValue:typeof G=="string"?G==="false"?B.OFF:G==="true"?B.ON:G:G?B.ON:B.OFF}}e.EditorFontLigatures=B;class L extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(G){return typeof G>"u"?this.defaultValue:typeof G=="string"?G==="false"?L.OFF:G==="true"?L.TRANSLATE:G:G?L.TRANSLATE:L.OFF}compute(G,Ee,Be){return G.fontInfo.fontVariationSettings}}e.EditorFontVariations=L;class U extends p{constructor(){super(50)}compute(G,Ee,Be){return G.fontInfo}}class ie extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(G){const Ee=m.float(G,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(Ee,6,100)}compute(G,Ee,Be){return G.fontInfo.fontSize}}class X extends D{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.MINIMUM_VALUE,maximum:X.MAXIMUM_VALUE,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(G){return G==="normal"||G==="bold"?G:String(v.clampedInt(G,e.EDITOR_FONT_DEFAULTS.fontWeight,X.MINIMUM_VALUE,X.MAXIMUM_VALUE))}}class ye extends D{constructor(){const G={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:G.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",G,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:G.alternativeDefinitionCommand,enum:Be,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:G.alternativeTypeDefinitionCommand,enum:Be,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:G.alternativeDeclarationCommand,enum:Be,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:G.alternativeImplementationCommand,enum:Be,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:G.alternativeReferenceCommand,enum:Be,description:l.localize(41,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{multiple:r(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??r(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??r(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??r(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??r(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??r(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Pe extends D{constructor(){const G={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",G,{"editor.hover.enabled":{type:"boolean",default:G.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:G.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:G.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:G.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:G.above,description:l.localize(46,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:v.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:v.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var De;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class pe extends p{constructor(){super(144)}compute(G,Ee,Be){return pe.computeLayout(Ee,{memory:G.memory,outerWidth:G.outerWidth,outerHeight:G.outerHeight,isDominatedByLongLines:G.isDominatedByLongLines,lineHeight:G.fontInfo.lineHeight,viewLineCount:G.viewLineCount,lineNumbersDigitCount:G.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:G.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:G.fontInfo.maxDigitWidth,pixelRatio:G.pixelRatio,glyphMarginDecorationLaneCount:G.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(G){const Ee=G.height/G.lineHeight,Be=Math.floor(G.paddingTop/G.lineHeight);let Ne=Math.floor(G.paddingBottom/G.lineHeight);G.scrollBeyondLastLine&&(Ne=Math.max(Ne,Ee-1));const Xe=(Be+G.viewLineCount+Ne)/(G.pixelRatio*G.height),nt=Math.floor(G.viewLineCount/Xe);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Xe,minimapLineCount:nt}}static _computeMinimapLayout(G,Ee){const Be=G.outerWidth,Ne=G.outerHeight,Xe=G.pixelRatio;if(!G.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=Ee.stableMinimapLayoutInput,pt=nt&&G.outerHeight===nt.outerHeight&&G.lineHeight===nt.lineHeight&&G.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&G.pixelRatio===nt.pixelRatio&&G.scrollBeyondLastLine===nt.scrollBeyondLastLine&&G.paddingTop===nt.paddingTop&&G.paddingBottom===nt.paddingBottom&&G.minimap.enabled===nt.minimap.enabled&&G.minimap.side===nt.minimap.side&&G.minimap.size===nt.minimap.size&&G.minimap.showSlider===nt.minimap.showSlider&&G.minimap.renderCharacters===nt.minimap.renderCharacters&&G.minimap.maxColumn===nt.minimap.maxColumn&&G.minimap.scale===nt.minimap.scale&&G.verticalScrollbarWidth===nt.verticalScrollbarWidth&&G.isViewportWrapping===nt.isViewportWrapping,bt=G.lineHeight,Pt=G.typicalHalfwidthCharacterWidth,Vt=G.scrollBeyondLastLine,qt=G.minimap.renderCharacters;let Et=Xe>=2?Math.round(G.minimap.scale*2):G.minimap.scale;const xt=G.minimap.maxColumn,Mt=G.minimap.size,jt=G.minimap.side,$t=G.verticalScrollbarWidth,Dt=G.viewLineCount,Ft=G.remainingWidth,Bt=G.isViewportWrapping,Kt=qt?2:3;let zt=Math.floor(Xe*Ne);const Ht=zt/Xe;let Nt=!1,at=!1,ht=Kt*Et,Tt=Et/Xe,Wt=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:Gt,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Oe,desiredRatio:me,minimapLineCount:q}=pe.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Vt,paddingTop:G.paddingTop,paddingBottom:G.paddingBottom,height:Ne,lineHeight:bt,pixelRatio:Xe});if(Dt/q>1)Nt=!0,at=!0,Et=1,ht=1,Tt=Et/Xe;else{let xe=!1,Ke=Et+1;if(Mt==="fit"){const We=Math.ceil((Ie+Dt+Oe)*ht);Bt&&pt&&Ft<=Ee.stableFitRemainingWidth?(xe=!0,Ke=Ee.stableFitMaxMinimapScale):xe=We>zt}if(Mt==="fill"||xe){Nt=!0;const We=Et;ht=Math.min(bt*Xe,Math.max(1,Math.floor(1/me))),Bt&&pt&&Ft<=Ee.stableFitRemainingWidth&&(Ke=Ee.stableFitMaxMinimapScale),Et=Math.min(Ke,Math.max(1,Math.floor(ht/Kt))),Et>We&&(Wt=Math.min(2,Et/We)),Tt=Et/Xe/Wt,zt=Math.ceil(Math.max(Gt,Ie+Dt+Oe)*ht),Bt?(Ee.stableMinimapLayoutInput=G,Ee.stableFitRemainingWidth=Ft,Ee.stableFitMaxMinimapScale=Et):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const At=Math.floor(xt*Tt),ot=Math.min(At,Math.max(0,Math.floor((Ft-$t-2)*Tt/(Pt+Tt)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Xe*ot);const Lt=wt/Xe;wt=Math.floor(wt*Wt);const kt=qt?1:2,ze=jt==="left"?0:Be-ot-$t;return{renderMinimap:kt,minimapLeft:ze,minimapWidth:ot,minimapHeightIsEditorHeight:Nt,minimapIsSampling:at,minimapScale:Et,minimapLineHeight:ht,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:Lt,minimapCanvasOuterHeight:Ht}}static computeLayout(G,Ee){const Be=Ee.outerWidth|0,Ne=Ee.outerHeight|0,Xe=Ee.lineHeight|0,nt=Ee.lineNumbersDigitCount|0,pt=Ee.typicalHalfwidthCharacterWidth,bt=Ee.maxDigitWidth,Pt=Ee.pixelRatio,Vt=Ee.viewLineCount,qt=G.get(136),Et=qt==="inherit"?G.get(135):qt,xt=Et==="inherit"?G.get(131):Et,Mt=G.get(134),jt=Ee.isDominatedByLongLines,$t=G.get(57),Dt=G.get(67).renderType!==0,Ft=G.get(68),Bt=G.get(105),Kt=G.get(84),zt=G.get(72),Ht=G.get(103),Nt=Ht.verticalScrollbarSize,at=Ht.verticalHasArrows,ht=Ht.arrowSize,Tt=Ht.horizontalScrollbarSize,Wt=G.get(43),At=G.get(110)!=="never";let ot=G.get(65);Wt&&At&&(ot+=16);let wt=0;if(Dt){const _t=Math.max(nt,Ft);wt=Math.round(_t*bt)}let Lt=0;$t&&(Lt=Xe*Ee.glyphMarginDecorationLaneCount);let kt=0,ze=kt+Lt,Gt=ze+wt,Ie=Gt+ot;const Oe=Be-Lt-wt-ot;let me=!1,q=!1,Re=-1;Et==="inherit"&&jt?(me=!0,q=!0):xt==="on"||xt==="bounded"?q=!0:xt==="wordWrapColumn"&&(Re=Mt);const xe=pe._computeMinimapLayout({outerWidth:Be,outerHeight:Ne,lineHeight:Xe,typicalHalfwidthCharacterWidth:pt,pixelRatio:Pt,scrollBeyondLastLine:Bt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:zt,verticalScrollbarWidth:Nt,viewLineCount:Vt,remainingWidth:Oe,isViewportWrapping:q},Ee.memory||new A);xe.renderMinimap!==0&&xe.minimapLeft===0&&(kt+=xe.minimapWidth,ze+=xe.minimapWidth,Gt+=xe.minimapWidth,Ie+=xe.minimapWidth);const Ke=Oe-xe.minimapWidth,We=Math.max(1,Math.floor((Ke-Nt-2)/pt)),et=at?ht:0;return q&&(Re=Math.max(1,We),xt==="bounded"&&(Re=Math.min(Re,Mt))),{width:Be,height:Ne,glyphMarginLeft:kt,glyphMarginWidth:Lt,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:ze,lineNumbersWidth:wt,decorationsLeft:Gt,decorationsWidth:ot,contentLeft:Ie,contentWidth:Ke,minimap:xe,viewportColumn:We,isWordWrapMinified:me,isViewportWrapping:q,wrappingColumn:Re,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:Tt,overviewRuler:{top:et,width:Nt,height:Ne-2*et,right:0}}}}e.EditorLayoutInfoComputer=pe;class Se extends D{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(G){return r(G,"simple",["simple","advanced"])}compute(G,Ee,Be){return Ee.get(2)===2?"advanced":Be}}class le extends D{constructor(){const G={enabled:!0};super(64,"lightbulb",G,{"editor.lightbulb.enabled":{type:"boolean",default:G.enabled,description:l.localize(50,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:t(G.enabled,this.defaultValue.enabled)}}}class ae extends D{constructor(){const G={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",G,{"editor.stickyScroll.enabled":{type:"boolean",default:G.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:G.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:G.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:G.scrollWithEditor,description:l.localize(54,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends D{constructor(){const G={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",G,{"editor.inlayHints.enabled":{type:"string",default:G.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:G.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:G.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:G.padding,description:l.localize(62,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:r(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class Z extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(G){return typeof G=="string"&&/^\d+(\.\d+)?ch$/.test(G)?-parseFloat(G.substring(0,G.length-2)):v.clampedInt(G,this.defaultValue,0,1e3)}compute(G,Ee,Be){return Be<0?v.clampedInt(-Be*G.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class z extends m{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,G=>m.clamp(G,0,150),{markdownDescription:l.localize(63,null)})}compute(G,Ee,Be){return G.fontInfo.lineHeight}}class Y extends D{constructor(){const G={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",G,{"editor.minimap.enabled":{type:"boolean",default:G.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:G.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:G.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:G.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:G.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:G.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:G.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:G.maxColumn,description:l.localize(74,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:r(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ee.side,this.defaultValue.side,["right","left"]),showSlider:r(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(Ee.scale,1,1,3),maxColumn:v.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(Q){return Q==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{top:v.clampedInt(Ee.top,0,0,1e3),bottom:v.clampedInt(Ee.bottom,0,0,1e3)}}}class ge extends D{constructor(){const G={enabled:!0,cycle:!0};super(86,"parameterHints",G,{"editor.parameterHints.enabled":{type:"boolean",default:G.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:G.cycle,description:l.localize(78,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class de extends p{constructor(){super(142)}compute(G,Ee,Be){return G.pixelRatio}}class _e extends D{constructor(){const G={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(89,"quickSuggestions",G,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:G.strings,description:l.localize(82,null)},comments:{anyOf:Ee,default:G.comments,description:l.localize(83,null)},other:{anyOf:Ee,default:G.other,description:l.localize(84,null)}},default:G,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=G}validate(G){if(typeof G=="boolean"){const Pt=G?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!G||typeof G!="object")return this.defaultValue;const{other:Ee,comments:Be,strings:Ne}=G,Xe=["on","inline","off"];let nt,pt,bt;return typeof Ee=="boolean"?nt=Ee?"on":"off":nt=r(Ee,this.defaultValue.other,Xe),typeof Be=="boolean"?pt=Be?"on":"off":pt=r(Be,this.defaultValue.comments,Xe),typeof Ne=="boolean"?bt=Ne?"on":"off":bt=r(Ne,this.defaultValue.strings,Xe),{other:nt,comments:pt,strings:bt}}}var re;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class ue extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(G){let Ee=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof G<"u"&&(typeof G=="function"?(Ee=4,Be=G):G==="interval"?Ee=3:G==="relative"?Ee=2:G==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Be}}}function ne(Q){const G=Q.get(98);return G==="editable"?Q.get(91):G!=="on"}e.filterValidationDecorations=ne;class oe extends D{constructor(){const G=[],Ee={type:"number",description:l.localize(91,null)};super(102,"rulers",G,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:G,description:l.localize(93,null)})}validate(G){if(Array.isArray(G)){const Ee=[];for(const Be of G)if(typeof Be=="number")Ee.push({column:v.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;Ee.push({column:v.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return Ee.sort((Be,Ne)=>Be.column-Ne.column),Ee}return this.defaultValue}}class fe extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(G){return!G||typeof G!="object"?this.defaultValue:G}}function ke(Q,G){if(typeof Q!="string")return G;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class O extends D{constructor(){const G={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",G,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:G.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:G.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:G.scrollByPage,description:l.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:G.ignoreHorizontalScrollbarInContentHeight,description:l.localize(105,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G,Be=v.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=v.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ke(Ee.vertical,this.defaultValue.vertical),horizontal:ke(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:v.clampedInt(Ee.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:v.clampedInt(Ee.verticalSliderSize,Ne,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends D{constructor(){const G={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",G,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.nonBasicASCII,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:G.invisibleCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:G.ambiguousCharacters,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.includeComments,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.includeStrings,description:l.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:G.allowedCharacters,description:l.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:G.allowedLocales,description:l.localize(112,null)}})}applyUpdate(G,Ee){let Be=!1;Ee.allowedCharacters&&G&&(R.equals(G.allowedCharacters,Ee.allowedCharacters)||(G={...G,allowedCharacters:Ee.allowedCharacters},Be=!0)),Ee.allowedLocales&&G&&(R.equals(G.allowedLocales,Ee.allowedLocales)||(G={...G,allowedLocales:Ee.allowedLocales},Be=!0));const Ne=super.applyUpdate(G,Ee);return Be?new a(Ne.newValue,!0):Ne}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{nonBasicASCII:J(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:J(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:J(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(G.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(G.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(G,Ee){if(typeof G!="object"||!G)return Ee;const Be={};for(const[Ne,Xe]of Object.entries(G))Xe===!0&&(Be[Ne]=!0);return Be}}class j extends D{constructor(){const G={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",G,{"editor.inlineSuggest.enabled":{type:"boolean",default:G.enabled,description:l.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:G.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(114,null),l.localize(115,null)],description:l.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:G.suppressSuggestions,description:l.localize(117,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:r(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class K extends D{constructor(){const G={enabled:F.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",G,{"editor.bracketPairColorization.enabled":{type:"boolean",default:G.enabled,markdownDescription:l.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:G.independentColorPoolPerBracketType,description:l.localize(119,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class V extends D{constructor(){const G={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",G,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(120,null),l.localize(121,null),l.localize(122,null)],default:G.bracketPairs,description:l.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(124,null),l.localize(125,null),l.localize(126,null)],default:G.bracketPairsHorizontal,description:l.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:G.highlightActiveBracketPair,description:l.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:G.indentation,description:l.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(130,null),l.localize(131,null),l.localize(132,null)],default:G.highlightActiveIndentation,description:l.localize(133,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{bracketPairs:J(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:J(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:J(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function J(Q,G,Ee){const Be=Ee.indexOf(Q);return Be===-1?G:Ee[Be]}class ce extends D{constructor(){const G={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",G,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(134,null),l.localize(135,null)],default:G.insertMode,description:l.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:G.filterGraceful,description:l.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:G.localityBonus,description:l.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:G.shareSuggestSelections,markdownDescription:l.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(140,null),l.localize(141,null),l.localize(142,null),l.localize(143,null)],default:G.selectionMode,markdownDescription:l.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:G.snippetsPreventQuickSuggestions,description:l.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:G.showIcons,description:l.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:G.showStatusBar,description:l.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:G.preview,description:l.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:G.showInlineDetails,description:l.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(181,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{insertMode:r(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:r(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Me extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(183,null),default:!0,type:"boolean"}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(G.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(G.selectSubwords,this.defaultValue.selectSubwords)}}}var $e;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})($e||(e.WrappingIndent=$e={}));class Ge extends D{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(184,null),l.localize(185,null),l.localize(186,null),l.localize(187,null)],description:l.localize(188,null),default:"same"}})}validate(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(G,Ee,Be){return Ee.get(2)===2?0:Be}}class je extends p{constructor(){super(145)}compute(G,Ee,Be){const Ne=Ee.get(144);return{isDominatedByLongLines:G.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class Ze extends D{constructor(){const G={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",G,{"editor.dropIntoEditor.enabled":{type:"boolean",default:G.enabled,markdownDescription:l.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(191,null),l.localize(192,null)],default:"afterDrop"}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:r(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends D{constructor(){const G={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",G,{"editor.pasteAs.enabled":{type:"boolean",default:G.enabled,markdownDescription:l.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(195,null),l.localize(196,null)],default:"afterPaste"}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const Ee=G;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:r(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Je="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?it:P.isLinux?tt:Je,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var lt;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.letterSpacing=63]="letterSpacing",Q[Q.lightbulb=64]="lightbulb",Q[Q.lineDecorationsWidth=65]="lineDecorationsWidth",Q[Q.lineHeight=66]="lineHeight",Q[Q.lineNumbers=67]="lineNumbers",Q[Q.lineNumbersMinChars=68]="lineNumbersMinChars",Q[Q.linkedEditing=69]="linkedEditing",Q[Q.links=70]="links",Q[Q.matchBrackets=71]="matchBrackets",Q[Q.minimap=72]="minimap",Q[Q.mouseStyle=73]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=75]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=77]="multiCursorModifier",Q[Q.multiCursorPaste=78]="multiCursorPaste",Q[Q.multiCursorLimit=79]="multiCursorLimit",Q[Q.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=89]="quickSuggestions",Q[Q.quickSuggestionsDelay=90]="quickSuggestionsDelay",Q[Q.readOnly=91]="readOnly",Q[Q.readOnlyMessage=92]="readOnlyMessage",Q[Q.renameOnType=93]="renameOnType",Q[Q.renderControlCharacters=94]="renderControlCharacters",Q[Q.renderFinalNewline=95]="renderFinalNewline",Q[Q.renderLineHighlight=96]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=98]="renderValidationDecorations",Q[Q.renderWhitespace=99]="renderWhitespace",Q[Q.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Q[Q.roundedSelection=101]="roundedSelection",Q[Q.rulers=102]="rulers",Q[Q.scrollbar=103]="scrollbar",Q[Q.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=105]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=106]="scrollPredominantAxis",Q[Q.selectionClipboard=107]="selectionClipboard",Q[Q.selectionHighlight=108]="selectionHighlight",Q[Q.selectOnLineNumbers=109]="selectOnLineNumbers",Q[Q.showFoldingControls=110]="showFoldingControls",Q[Q.showUnused=111]="showUnused",Q[Q.snippetSuggestions=112]="snippetSuggestions",Q[Q.smartSelect=113]="smartSelect",Q[Q.smoothScrolling=114]="smoothScrolling",Q[Q.stickyScroll=115]="stickyScroll",Q[Q.stickyTabStops=116]="stickyTabStops",Q[Q.stopRenderingLineAfter=117]="stopRenderingLineAfter",Q[Q.suggest=118]="suggest",Q[Q.suggestFontSize=119]="suggestFontSize",Q[Q.suggestLineHeight=120]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Q[Q.suggestSelection=122]="suggestSelection",Q[Q.tabCompletion=123]="tabCompletion",Q[Q.tabIndex=124]="tabIndex",Q[Q.unicodeHighlighting=125]="unicodeHighlighting",Q[Q.unusualLineTerminators=126]="unusualLineTerminators",Q[Q.useShadowDOM=127]="useShadowDOM",Q[Q.useTabStops=128]="useTabStops",Q[Q.wordBreak=129]="wordBreak",Q[Q.wordSeparators=130]="wordSeparators",Q[Q.wordWrap=131]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=134]="wordWrapColumn",Q[Q.wordWrapOverride1=135]="wordWrapOverride1",Q[Q.wordWrapOverride2=136]="wordWrapOverride2",Q[Q.wrappingIndent=137]="wrappingIndent",Q[Q.wrappingStrategy=138]="wrappingStrategy",Q[Q.showDeprecated=139]="showDeprecated",Q[Q.inlayHints=140]="inlayHints",Q[Q.editorClassName=141]="editorClassName",Q[Q.pixelRatio=142]="pixelRatio",Q[Q.tabFocusMode=143]="tabFocusMode",Q[Q.layoutInfo=144]="layoutInfo",Q[Q.wrappingInfo=145]="wrappingInfo",Q[Q.defaultColorDecorators=146]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(lt||(e.EditorOption=lt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(197,null)})),acceptSuggestionOnEnter:Ue(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(198,null),""],markdownDescription:l.localize(199,null)})),accessibilitySupport:Ue(new d),accessibilityPageSize:Ue(new v(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(200,null),tags:["accessibility"]})),ariaLabel:Ue(new n(4,"ariaLabel",l.localize(201,null))),ariaRequired:Ue(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(203,null),l.localize(204,null),""],description:l.localize(205,null)})),autoClosingComments:Ue(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(206,null),l.localize(207,null),""],description:l.localize(208,null)})),autoClosingDelete:Ue(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(209,null),""],description:l.localize(210,null)})),autoClosingOvertype:Ue(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(211,null),""],description:l.localize(212,null)})),autoClosingQuotes:Ue(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(213,null),l.localize(214,null),""],description:l.localize(215,null)})),autoIndent:Ue(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null),l.localize(220,null)],description:l.localize(221,null)})),automaticLayout:Ue(new i(13,"automaticLayout",!1)),autoSurround:Ue(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(222,null),l.localize(223,null),l.localize(224,null),""],description:l.localize(225,null)})),bracketPairColorization:Ue(new K),bracketPairGuides:Ue(new V),stickyTabStops:Ue(new i(116,"stickyTabStops",!1,{description:l.localize(226,null)})),codeLens:Ue(new i(17,"codeLens",!0,{description:l.localize(227,null)})),codeLensFontFamily:Ue(new n(18,"codeLensFontFamily","",{description:l.localize(228,null)})),codeLensFontSize:Ue(new v(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(229,null)})),colorDecorators:Ue(new i(20,"colorDecorators",!0,{description:l.localize(230,null)})),colorDecoratorActivatedOn:Ue(new s(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(231,null),l.localize(232,null),l.localize(233,null)],description:l.localize(234,null)})),colorDecoratorsLimit:Ue(new v(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(235,null)})),columnSelection:Ue(new i(22,"columnSelection",!1,{description:l.localize(236,null)})),comments:Ue(new k),contextmenu:Ue(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(237,null)})),cursorBlinking:Ue(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:l.localize(238,null)})),cursorSmoothCaretAnimation:Ue(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(239,null),l.localize(240,null),l.localize(241,null)],description:l.localize(242,null)})),cursorStyle:Ue(new o(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:l.localize(243,null)})),cursorSurroundingLines:Ue(new v(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(244,null)})),cursorSurroundingLinesStyle:Ue(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(245,null),l.localize(246,null)],markdownDescription:l.localize(247,null)})),cursorWidth:Ue(new v(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(248,null)})),disableLayerHinting:Ue(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new i(34,"domReadOnly",!1)),dragAndDrop:Ue(new i(35,"dragAndDrop",!0,{description:l.localize(249,null)})),emptySelectionClipboard:Ue(new N),dropIntoEditor:Ue(new Ze),stickyScroll:Ue(new ae),experimentalWhitespaceRendering:Ue(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(250,null),l.localize(251,null),l.localize(252,null)],description:l.localize(253,null)})),extraEditorClassName:Ue(new n(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new m(40,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:l.localize(254,null)})),find:Ue(new H),fixedOverflowWidgets:Ue(new i(42,"fixedOverflowWidgets",!1)),folding:Ue(new i(43,"folding",!0,{description:l.localize(255,null)})),foldingStrategy:Ue(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(256,null),l.localize(257,null)],description:l.localize(258,null)})),foldingHighlight:Ue(new i(45,"foldingHighlight",!0,{description:l.localize(259,null)})),foldingImportsByDefault:Ue(new i(46,"foldingImportsByDefault",!1,{description:l.localize(260,null)})),foldingMaximumRegions:Ue(new v(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(261,null)})),unfoldOnClickAfterEndOfLine:Ue(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(262,null)})),fontFamily:Ue(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(263,null)})),fontInfo:Ue(new U),fontLigatures2:Ue(new B),fontSize:Ue(new ie),fontWeight:Ue(new X),fontVariations:Ue(new L),formatOnPaste:Ue(new i(55,"formatOnPaste",!1,{description:l.localize(264,null)})),formatOnType:Ue(new i(56,"formatOnType",!1,{description:l.localize(265,null)})),glyphMargin:Ue(new i(57,"glyphMargin",!0,{description:l.localize(266,null)})),gotoLocation:Ue(new ye),hideCursorInOverviewRuler:Ue(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(267,null)})),hover:Ue(new Pe),inDiffEditor:Ue(new i(61,"inDiffEditor",!1)),letterSpacing:Ue(new m(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>m.clamp(Q,-5,20),{description:l.localize(268,null)})),lightbulb:Ue(new le),lineDecorationsWidth:Ue(new Z),lineHeight:Ue(new z),lineNumbers:Ue(new ue),lineNumbersMinChars:Ue(new v(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new i(69,"linkedEditing",!1,{description:l.localize(269,null)})),links:Ue(new i(70,"links",!0,{description:l.localize(270,null)})),matchBrackets:Ue(new s(71,"matchBrackets","always",["always","near","never"],{description:l.localize(271,null)})),minimap:Ue(new Y),mouseStyle:Ue(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new m(74,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:l.localize(272,null)})),mouseWheelZoom:Ue(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(273,null)})),multiCursorMergeOverlapping:Ue(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(274,null)})),multiCursorModifier:Ue(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[l.localize(275,null),l.localize(276,null)],markdownDescription:l.localize(277,null)})),multiCursorPaste:Ue(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(278,null),l.localize(279,null)],markdownDescription:l.localize(280,null)})),multiCursorLimit:Ue(new v(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(281,null)})),occurrencesHighlight:Ue(new i(81,"occurrencesHighlight",!0,{description:l.localize(282,null)})),multiDocumentOccurrencesHighlight:Ue(new i(80,"multiDocumentOccurrencesHighlight",!1,{description:l.localize(283,null)})),overviewRulerBorder:Ue(new i(82,"overviewRulerBorder",!0,{description:l.localize(284,null)})),overviewRulerLanes:Ue(new v(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ve),pasteAs:Ue(new Ye),parameterHints:Ue(new ge),peekWidgetDefaultFocus:Ue(new s(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(285,null),l.localize(286,null)],description:l.localize(287,null)})),definitionLinkOpensInPeek:Ue(new i(88,"definitionLinkOpensInPeek",!1,{description:l.localize(288,null)})),quickSuggestions:Ue(new _e),quickSuggestionsDelay:Ue(new v(90,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(289,null)})),readOnly:Ue(new i(91,"readOnly",!1)),readOnlyMessage:Ue(new fe),renameOnType:Ue(new i(93,"renameOnType",!1,{description:l.localize(290,null),markdownDeprecationMessage:l.localize(291,null)})),renderControlCharacters:Ue(new i(94,"renderControlCharacters",!0,{description:l.localize(292,null),restricted:!0})),renderFinalNewline:Ue(new s(95,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:l.localize(293,null)})),renderLineHighlight:Ue(new s(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(294,null)],description:l.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Ue(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(296,null)})),renderValidationDecorations:Ue(new s(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new s(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(297,null),l.localize(298,null),l.localize(299,null),""],description:l.localize(300,null)})),revealHorizontalRightPadding:Ue(new v(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new i(101,"roundedSelection",!0,{description:l.localize(301,null)})),rulers:Ue(new oe),scrollbar:Ue(new O),scrollBeyondLastColumn:Ue(new v(104,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(302,null)})),scrollBeyondLastLine:Ue(new i(105,"scrollBeyondLastLine",!0,{description:l.localize(303,null)})),scrollPredominantAxis:Ue(new i(106,"scrollPredominantAxis",!0,{description:l.localize(304,null)})),selectionClipboard:Ue(new i(107,"selectionClipboard",!0,{description:l.localize(305,null),included:P.isLinux})),selectionHighlight:Ue(new i(108,"selectionHighlight",!0,{description:l.localize(306,null)})),selectOnLineNumbers:Ue(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new s(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(307,null),l.localize(308,null),l.localize(309,null)],description:l.localize(310,null)})),showUnused:Ue(new i(111,"showUnused",!0,{description:l.localize(311,null)})),showDeprecated:Ue(new i(139,"showDeprecated",!0,{description:l.localize(312,null)})),inlayHints:Ue(new we),snippetSuggestions:Ue(new s(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(313,null),l.localize(314,null),l.localize(315,null),l.localize(316,null)],description:l.localize(317,null)})),smartSelect:Ue(new Me),smoothScrolling:Ue(new i(114,"smoothScrolling",!1,{description:l.localize(318,null)})),stopRenderingLineAfter:Ue(new v(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ce),inlineSuggest:Ue(new j),inlineCompletionsAccessibilityVerbose:Ue(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(319,null)})),suggestFontSize:Ue(new v(119,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new v(120,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new i(121,"suggestOnTriggerCharacters",!0,{description:l.localize(322,null)})),suggestSelection:Ue(new s(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(323,null),l.localize(324,null),l.localize(325,null)],description:l.localize(326,null)})),tabCompletion:Ue(new s(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(327,null),l.localize(328,null),l.localize(329,null)],description:l.localize(330,null)})),tabIndex:Ue(new v(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new W),unusualLineTerminators:Ue(new s(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(331,null),l.localize(332,null),l.localize(333,null)],description:l.localize(334,null)})),useShadowDOM:Ue(new i(127,"useShadowDOM",!0)),useTabStops:Ue(new i(128,"useTabStops",!0,{description:l.localize(335,null)})),wordBreak:Ue(new s(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(336,null),l.localize(337,null)],description:l.localize(338,null)})),wordSeparators:Ue(new n(130,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:l.localize(339,null)})),wordWrap:Ue(new s(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(340,null),l.localize(341,null),l.localize(342,null),l.localize(343,null)],description:l.localize(344,null)})),wordWrapBreakAfterCharacters:Ue(new n(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new n(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new v(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(345,null)})),wordWrapOverride1:Ue(new s(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new s(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new $),defaultColorDecorators:Ue(new i(146,"defaultColorDecorators",!1,{markdownDescription:l.localize(346,null)})),pixelRatio:Ue(new de),tabFocusMode:Ue(new i(143,"tabFocusMode",!1,{markdownDescription:l.localize(347,null)})),layoutInfo:Ue(new pe),wrappingInfo:Ue(new je),wrappingIndent:Ue(new Ge),wrappingStrategy:Ue(new Se)}}),define(Te[137],Ae([9,10]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Te[138],Ae([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Te[139],Ae([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Te[140],Ae([9,10]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Te[141],Ae([9,10]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Te[142],Ae([9,10]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Te[143],Ae([9,10]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Te[144],Ae([9,10]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Te[145],Ae([9,10]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Te[146],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Te[147],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Te[148],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Te[149],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Te[150],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Te[151],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Te[152],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Te[153],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Te[154],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Te[155],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Te[156],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Te[157],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Te[158],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Te[159],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Te[160],Ae([9,10]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Te[161],Ae([9,10]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Te[162],Ae([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Te[163],Ae([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Te[164],Ae([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Te[165],Ae([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Te[166],Ae([9,10]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Te[167],Ae([9,10]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Te[168],Ae([9,10]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Te[169],Ae([1,0,11,139]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var P;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(P||(e.TokenType=P={}));function F(...f){switch(f.length){case 1:return(0,R.localize)(0,null,f[0]);case 2:return(0,R.localize)(1,null,f[0],f[1]);case 3:return(0,R.localize)(2,null,f[0],f[1],f[2]);default:return}}const T=(0,R.localize)(3,null),l=(0,R.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,w.illegalState)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(A){return this._input=A,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const D=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:D})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const D=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:D})}else this._match(126)?this._addToken(9):this._error(F("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(F("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(A){return this._isAtEnd()||this._input.charCodeAt(this._current)!==A?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(A){this._tokens.push({type:A,offset:this._start})}_error(A){const D=this._start,a=this._input.substring(this._start,this._current),E={type:19,offset:this._start,lexeme:a};this._errors.push({offset:D,lexeme:a,additionalInfo:A}),this._tokens.push(E)}_string(){this.stringRe.lastIndex=this._start;const A=this.stringRe.exec(this._input);if(A){this._current=this._start+A[0].length;const D=this._input.substring(this._start,this._current),a=y._keywords.get(D);a?this._addToken(a):this._tokens.push({type:17,lexeme:D,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let A=this._current,D=!1,a=!1;for(;;){if(A>=this._input.length){this._current=A,this._error(l);return}const p=this._input.charCodeAt(A);if(D)D=!1;else if(p===47&&!a){A++;break}else p===91?a=!0:p===92?D=!0:p===93&&(a=!1);A++}for(;A<this._input.length&&y._regexFlags.has(this._input.charCodeAt(A));)A++;this._current=A;const E=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:E,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y}),define(Te[170],Ae([1,0,24,29,141,280]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function y(i){return i=i.trim(),i==="*"||T.test(i)}e.isValidVersionStr=y;function f(i){if(!y(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=i.match(T);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=f;function A(i){if(!i)return null;const u=i.majorBase,v=i.majorMustEqual,_=i.minorBase;let m=i.minorMustEqual;const n=i.patchBase;let r=i.patchMustEqual;i.hasCaret&&(u===0||(m=!1),r=!1);let s=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,g,d,k]=o;s=Date.UTC(Number(g),Number(d)-1,Number(k))}}return{majorBase:u,majorMustEqual:v,minorBase:_,minorMustEqual:m,patchBase:n,patchMustEqual:r,isMinimum:i.hasGreaterEquals,notBefore:s}}e.normalizeVersion=A;function D(i,u,v){let _;typeof i=="string"?_=A(f(i)):_=i;let m;u instanceof Date?m=u.getTime():typeof u=="string"&&(m=new Date(u).getTime());let n;if(typeof v=="string"?n=A(f(v)):n=v,!_||!n)return!1;const r=_.majorBase,s=_.minorBase,o=_.patchBase;let g=n.majorBase,d=n.minorBase,k=n.patchBase;const I=n.notBefore;let c=n.majorMustEqual,S=n.minorMustEqual,b=n.patchMustEqual;return n.isMinimum?r>g?!0:r<g?!1:s>d?!0:s<d||m&&m<I?!1:o>=k:(r===1&&g===0&&(!c||!S||!b)&&(g=1,d=0,k=0,c=!0,S=!1,b=!1),r<g?!1:r>g?!c:s<d?!1:s>d?!S:o<k?!1:o>k?!b:!(m&&m<I))}e.isValidVersion=D;function a(i,u,v,_,m){const n=[];if(typeof _.publisher<"u"&&typeof _.publisher!="string")return n.push([R.default.Error,P.localize(0,null)]),n;if(typeof _.name!="string")return n.push([R.default.Error,P.localize(1,null,"name")]),n;if(typeof _.version!="string")return n.push([R.default.Error,P.localize(2,null,"version")]),n;if(!_.engines)return n.push([R.default.Error,P.localize(3,null,"engines")]),n;if(typeof _.engines.vscode!="string")return n.push([R.default.Error,P.localize(4,null,"engines.vscode")]),n;if(typeof _.extensionDependencies<"u"&&!t(_.extensionDependencies))return n.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),n;if(typeof _.activationEvents<"u"){if(!t(_.activationEvents))return n.push([R.default.Error,P.localize(6,null,"activationEvents")]),n;if(typeof _.main>"u"&&typeof _.browser>"u")return n.push([R.default.Error,P.localize(7,null,"activationEvents","main","browser")]),n}if(typeof _.extensionKind<"u"&&typeof _.main>"u"&&n.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof _.main<"u"){if(typeof _.main!="string")return n.push([R.default.Error,P.localize(9,null,"main")]),n;{const o=(0,w.joinPath)(v,_.main);(0,w.isEqualOrParent)(o,v)||n.push([R.default.Warning,P.localize(10,null,o.path,v.path)])}}if(typeof _.browser<"u"){if(typeof _.browser!="string")return n.push([R.default.Error,P.localize(11,null,"browser")]),n;{const o=(0,w.joinPath)(v,_.browser);(0,w.isEqualOrParent)(o,v)||n.push([R.default.Warning,P.localize(12,null,o.path,v.path)])}}if(!F.valid(_.version))return n.push([R.default.Error,P.localize(13,null)]),n;const r=[];if(!E(i,u,_,m,r))for(const o of r)n.push([R.default.Error,o]);return n}e.validateExtensionManifest=a;function E(i,u,v,_,m){return _||typeof v.main>"u"&&typeof v.browser>"u"?!0:h(i,u,v.engines.vscode,m)}e.isValidExtensionVersion=E;function p(i,u,v){return i==="*"||h(u,v,i)}e.isEngineValid=p;function h(i,u,v,_=[]){const m=A(f(v));if(!m)return _.push(P.localize(14,null,v)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return _.push(P.localize(15,null,v)),!1}else if(!m.majorMustEqual)return _.push(P.localize(16,null,v)),!1;return D(i,u,m)?!0:(_.push(P.localize(17,null,i,v)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let u=0,v=i.length;u<v;u++)if(typeof i[u]!="string")return!1;return!0}}),define(Te[69],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(P,F=[],T=!1){this.ctor=P,this.staticArguments=F,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=w}),define(Te[70],Ae([1,0,69]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var P;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function F(l,y,f){y instanceof w.SyncDescriptor||(y=new w.SyncDescriptor(y,[],!!f)),R.push([l,y])}e.registerSingleton=F;function T(){return R}e.getSingletonServiceDescriptors=T}),define(Te[171],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(F,T){this.key=F,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class R{constructor(F){this._hashFn=F,this._nodes=new Map}roots(){const F=[];for(const T of this._nodes.values())T.outgoing.size===0&&F.push(T);return F}insertEdge(F,T){const l=this.lookupOrInsertNode(F),y=this.lookupOrInsertNode(T);l.outgoing.set(y.key,y),y.incoming.set(l.key,l)}removeNode(F){const T=this._hashFn(F);this._nodes.delete(T);for(const l of this._nodes.values())l.outgoing.delete(T),l.incoming.delete(T)}lookupOrInsertNode(F){const T=this._hashFn(F);let l=this._nodes.get(T);return l||(l=new w(T,F),this._nodes.set(T,l)),l}lookup(F){return this._nodes.get(this._hashFn(F))}isEmpty(){return this._nodes.size===0}toString(){const F=[];for(const[T,l]of this._nodes)F.push(`${T}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,T]of this._nodes){const l=new Set([F]),y=this._findCycle(T,l);if(y)return y}}_findCycle(F,T){for(const[l,y]of F.outgoing){if(T.has(l))return[...T,l].join(" -> ");T.add(l);const f=this._findCycle(y,T);if(f)return f;T.delete(l)}}}e.Graph=R}),define(Te[4],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function l(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=l})(w||(e._util=w={})),e.IInstantiationService=P("instantiationService");function R(T,l,y){l[w.DI_TARGET]===l?l[w.DI_DEPENDENCIES].push({id:T,index:y}):(l[w.DI_DEPENDENCIES]=[{id:T,index:y}],l[w.DI_TARGET]=l)}function P(T){if(w.serviceIds.has(T))return w.serviceIds.get(T);const l=function(y,f,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(l,y,A)};return l.toString=()=>T,w.serviceIds.set(T,l),l}e.createDecorator=P;function F(T){return T}e.refineServiceDecorator=F}),define(Te[45],Ae([1,0,15,2,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function F(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationOverrides=F;function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=T;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function y(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.isConfigured=f;function A(i,u){const v=Object.create(null);for(const _ in i)D(v,_,i[_],u);return v}e.toValuesTree=A;function D(i,u,v,_){const m=u.split("."),n=m.pop();let r=i;for(let s=0;s<m.length;s++){const o=m[s];let g=r[o];switch(typeof g){case"undefined":g=r[o]=Object.create(null);break;case"object":break;default:_(`Ignoring ${u} as ${m.slice(0,s+1).join(".")} is ${JSON.stringify(g)}`);return}r=g}if(typeof r=="object"&&r!==null)try{r[n]=v}catch{_(`Ignoring ${u} as ${m.join(".")} is ${JSON.stringify(r)}`)}else _(`Ignoring ${u} as ${m.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=D;function a(i,u){const v=u.split(".");E(i,v)}e.removeFromValueTree=a;function E(i,u){const v=u.shift();if(u.length===0){delete i[v];return}if(Object.keys(i).indexOf(v)!==-1){const _=i[v];typeof _=="object"&&!Array.isArray(_)&&(E(_,u),Object.keys(_).length===0&&delete i[v])}}function p(i,u,v){function _(r,s){let o=r;for(const g of s){if(typeof o!="object"||o===null)return;o=o[g]}return o}const m=u.split("."),n=_(i,m);return typeof n>"u"?v:n}e.getConfigurationValue=p;function h(i,u,v){Object.keys(u).forEach(_=>{_!=="__proto__"&&(_ in i?w.isObject(i[_])&&w.isObject(u[_])?h(i[_],u[_],v):v&&(i[_]=u[_]):i[_]=u[_])})}e.merge=h;function t(i){return i.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=t}),define(Te[32],Ae([1,0,23,16,169,4,138,11]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",w.isMacintosh),y.set("isLinux",w.isLinux),y.set("isWindows",w.isWindows),y.set("isWeb",w.isWeb),y.set("isMacNative",w.isMacintosh&&!w.isWeb),y.set("isEdge",w.isEdge),y.set("isFirefox",w.isFirefox),y.set("isChrome",w.isChrome),y.set("isSafari",w.isSafari);function f(Z,z){if(y.get(Z)!==void 0)throw(0,l.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(Z,z)}e.setConstant=f;const A=Object.prototype.hasOwnProperty;var D;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const a={regexParsingWithErrorRecovery:!0},E=(0,T.localize)(0,null),p=(0,T.localize)(1,null),h=(0,T.localize)(2,null),t=(0,T.localize)(3,null),i=(0,T.localize)(4,null),u=(0,T.localize)(5,null),v=(0,T.localize)(6,null),_=(0,T.localize)(7,null);class m{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(z=a){this._config=z,this._scanner=new P.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(z){if(z===""){this._parsingErrors.push({message:E,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(z).scan(),this._current=0,this._parsingErrors=[];try{const Y=this._expr();if(!this._isAtEnd()){const ee=this._peek(),ve=ee.type===17?u:void 0;throw this._parsingErrors.push({message:i,offset:ee.offset,lexeme:P.Scanner.getLexeme(ee),additionalInfo:ve}),m._parseError}return Y}catch(Y){if(Y!==m._parseError)throw Y;return}}_expr(){return this._or()}_or(){const z=[this._and()];for(;this._matchOne(16);){const Y=this._and();z.push(Y)}return z.length===1?z[0]:n.or(...z)}_and(){const z=[this._term()];for(;this._matchOne(15);){const Y=this._term();z.push(Y)}return z.length===1?z[0]:n.and(...z)}_term(){if(this._matchOne(2)){const z=this._peek();switch(z.type){case 11:return this._advance(),g.INSTANCE;case 12:return this._advance(),d.INSTANCE;case 0:{this._advance();const Y=this._expr();return this._consume(1,t),Y?.negate()}case 17:return this._advance(),C.create(z.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",z)}}return this._primary()}_primary(){const z=this._peek();switch(z.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const Y=this._expr();return this._consume(1,t),Y}case 17:{const Y=z.lexeme;if(this._advance(),this._matchOne(9)){const ve=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ve.type!==10)throw this._errExpectedButGot("REGEX",ve);const ge=ve.lexeme,de=ge.lastIndexOf("/"),_e=de===ge.length-1?void 0:this._removeFlagsGY(ge.substring(de+1));let re;try{re=new RegExp(ge.substring(1,de),_e)}catch{throw this._errExpectedButGot("REGEX",ve)}return U.create(Y,re)}switch(ve.type){case 10:case 19:{const ge=[ve.lexeme];this._advance();let de=this._peek(),_e=0;for(let fe=0;fe<ve.lexeme.length;fe++)ve.lexeme.charCodeAt(fe)===40?_e++:ve.lexeme.charCodeAt(fe)===41&&_e--;for(;!this._isAtEnd()&&de.type!==15&&de.type!==16;){switch(de.type){case 0:_e++;break;case 1:_e--;break;case 10:case 18:for(let fe=0;fe<de.lexeme.length;fe++)de.lexeme.charCodeAt(fe)===40?_e++:ve.lexeme.charCodeAt(fe)===41&&_e--}if(_e<0)break;ge.push(P.Scanner.getLexeme(de)),this._advance(),de=this._peek()}const re=ge.join(""),ue=re.lastIndexOf("/"),ne=ue===re.length-1?void 0:this._removeFlagsGY(re.substring(ue+1));let oe;try{oe=new RegExp(re.substring(1,ue),ne)}catch{throw this._errExpectedButGot("REGEX",ve)}return n.regex(Y,oe)}case 18:{const ge=ve.lexeme;this._advance();let de=null;if(!(0,R.isFalsyOrWhitespace)(ge)){const _e=ge.indexOf("/"),re=ge.lastIndexOf("/");if(_e!==re&&_e>=0){const ue=ge.slice(_e+1,re),ne=ge[re+1]==="i"?"i":"";try{de=new RegExp(ue,ne)}catch{throw this._errExpectedButGot("REGEX",ve)}}}if(de===null)throw this._errExpectedButGot("REGEX",ve);return U.create(Y,de)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,h);const ve=this._value();return n.notIn(Y,ve)}switch(this._peek().type){case 3:{this._advance();const ve=this._value();if(this._previous().type===18)return n.equals(Y,ve);switch(ve){case"true":return n.has(Y);case"false":return n.not(Y);default:return n.equals(Y,ve)}}case 4:{this._advance();const ve=this._value();if(this._previous().type===18)return n.notEquals(Y,ve);switch(ve){case"true":return n.not(Y);case"false":return n.has(Y);default:return n.notEquals(Y,ve)}}case 5:return this._advance(),B.create(Y,this._value());case 6:return this._advance(),L.create(Y,this._value());case 7:return this._advance(),N.create(Y,this._value());case 8:return this._advance(),H.create(Y,this._value());case 13:return this._advance(),n.in(Y,this._value());default:return n.has(Y)}}case 20:throw this._parsingErrors.push({message:v,offset:z.offset,lexeme:"",additionalInfo:_}),m._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const z=this._peek();switch(z.type){case 17:case 18:return this._advance(),z.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(z){return z.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(z){return this._check(z)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(z,Y){if(this._check(z))return this._advance();throw this._errExpectedButGot(Y,this._peek())}_errExpectedButGot(z,Y,ee){const ve=(0,T.localize)(8,null,z,P.Scanner.getLexeme(Y)),ge=Y.offset,de=P.Scanner.getLexeme(Y);return this._parsingErrors.push({message:ve,offset:ge,lexeme:de,additionalInfo:ee}),m._parseError}_check(z){return this._peek().type===z}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=m;class n{static false(){return g.INSTANCE}static true(){return d.INSTANCE}static has(z){return k.create(z)}static equals(z,Y){return I.create(z,Y)}static notEquals(z,Y){return b.create(z,Y)}static regex(z,Y){return U.create(z,Y)}static in(z,Y){return c.create(z,Y)}static notIn(z,Y){return S.create(z,Y)}static not(z){return C.create(z)}static and(...z){return ye.create(z,null,!0)}static or(...z){return Pe.create(z,null,!0)}static greater(z,Y){return N.create(z,Y)}static greaterEquals(z,Y){return H.create(z,Y)}static smaller(z,Y){return B.create(z,Y)}static smallerEquals(z,Y){return L.create(z,Y)}static{this._parser=new m({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this._parser.parse(z)}}e.ContextKeyExpr=n;function r(Z){const z=new m({regexParsingWithErrorRecovery:!1});return Z.map(Y=>(z.parse(Y),z.lexingErrors.length>0?z.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,T.localize)(9,null,ee.additionalInfo):(0,T.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.validateWhenClauses=r;function s(Z,z){const Y=Z?Z.substituteConstants():void 0,ee=z?z.substituteConstants():void 0;return!Y&&!ee?!0:!Y||!ee?!1:Y.equals(ee)}e.expressionsAreEqualWithConstantSubstitution=s;function o(Z,z){return Z.cmp(z)}class g{static{this.INSTANCE=new g}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=g;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return g.INSTANCE}}e.ContextKeyTrueExpr=d;class k{static create(z,Y=null){const ee=y.get(z);return typeof ee=="boolean"?ee?d.INSTANCE:g.INSTANCE:new k(z,Y)}constructor(z,Y){this.key=z,this.negated=Y,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=y.get(this.key);return typeof z=="boolean"?z?d.INSTANCE:g.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class I{static create(z,Y,ee=null){if(typeof Y=="boolean")return Y?k.create(z,ee):C.create(z,ee);const ve=y.get(z);return typeof ve=="boolean"?Y===(ve?"true":"false")?d.INSTANCE:g.INSTANCE:new I(z,Y,ee)}constructor(z,Y,ee){this.key=z,this.value=Y,this.negated=ee,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:Se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=y.get(this.key);if(typeof z=="boolean"){const Y=z?"true":"false";return this.value===Y?d.INSTANCE:g.INSTANCE}return this}evaluate(z){return z.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(z){return z.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=I;class c{static create(z,Y){return new c(z,Y)}constructor(z,Y){this.key=z,this.valueKey=Y,this.type=10,this.negated=null}cmp(z){return z.type!==this.type?this.type-z.type:Se(this.key,this.valueKey,z.key,z.valueKey)}equals(z){return z.type===this.type?this.key===z.key&&this.valueKey===z.valueKey:!1}substituteConstants(){return this}evaluate(z){const Y=z.getValue(this.valueKey),ee=z.getValue(this.key);return Array.isArray(Y)?Y.includes(ee):typeof ee=="string"&&typeof Y=="object"&&Y!==null?A.call(Y,ee):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(z){return z.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=c;class S{static create(z,Y){return new S(z,Y)}constructor(z,Y){this.key=z,this.valueKey=Y,this.type=11,this._negated=c.create(z,Y)}cmp(z){return z.type!==this.type?this.type-z.type:this._negated.cmp(z._negated)}equals(z){return z.type===this.type?this._negated.equals(z._negated):!1}substituteConstants(){return this}evaluate(z){return!this._negated.evaluate(z)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(z){return z.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=S;class b{static create(z,Y,ee=null){if(typeof Y=="boolean")return Y?C.create(z,ee):k.create(z,ee);const ve=y.get(z);return typeof ve=="boolean"?Y===(ve?"true":"false")?g.INSTANCE:d.INSTANCE:new b(z,Y,ee)}constructor(z,Y,ee){this.key=z,this.value=Y,this.negated=ee,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:Se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=y.get(this.key);if(typeof z=="boolean"){const Y=z?"true":"false";return this.value===Y?g.INSTANCE:d.INSTANCE}return this}evaluate(z){return z.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(z){return z.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class C{static create(z,Y=null){const ee=y.get(z);return typeof ee=="boolean"?ee?g.INSTANCE:d.INSTANCE:new C(z,Y)}constructor(z,Y){this.key=z,this.negated=Y,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:pe(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=y.get(this.key);return typeof z=="boolean"?z?g.INSTANCE:d.INSTANCE:this}evaluate(z){return!z.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(z){return z.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=C;function $(Z,z){if(typeof Z=="string"){const Y=parseFloat(Z);isNaN(Y)||(Z=Y)}return typeof Z=="string"||typeof Z=="number"?z(Z):g.INSTANCE}class N{static create(z,Y,ee=null){return $(Y,ve=>new N(z,ve,ee))}constructor(z,Y,ee){this.key=z,this.value=Y,this.negated=ee,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:Se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class H{static create(z,Y,ee=null){return $(Y,ve=>new H(z,ve,ee))}constructor(z,Y,ee){this.key=z,this.value=Y,this.negated=ee,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:Se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=H;class B{static create(z,Y,ee=null){return $(Y,ve=>new B(z,ve,ee))}constructor(z,Y,ee){this.key=z,this.value=Y,this.negated=ee,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:Se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=B;class L{static create(z,Y,ee=null){return $(Y,ve=>new L(z,ve,ee))}constructor(z,Y,ee){this.key=z,this.value=Y,this.negated=ee,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:Se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=L;class U{static create(z,Y){return new U(z,Y)}constructor(z,Y){this.key=z,this.regexp=Y,this.type=7,this.negated=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.key<z.key)return-1;if(this.key>z.key)return 1;const Y=this.regexp?this.regexp.source:"",ee=z.regexp?z.regexp.source:"";return Y<ee?-1:Y>ee?1:0}equals(z){if(z.type===this.type){const Y=this.regexp?this.regexp.source:"",ee=z.regexp?z.regexp.source:"";return this.key===z.key&&Y===ee}return!1}substituteConstants(){return this}evaluate(z){const Y=z.getValue(this.key);return this.regexp?this.regexp.test(Y):!1}serialize(){const z=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${z}`}keys(){return[this.key]}map(z){return z.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ie.create(this)),this.negated}}e.ContextKeyRegexExpr=U;class ie{static create(z){return new ie(z)}constructor(z){this._actual=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this._actual.cmp(z._actual)}equals(z){return z.type===this.type?this._actual.equals(z._actual):!1}substituteConstants(){return this}evaluate(z){return!this._actual.evaluate(z)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(z){return new ie(this._actual.map(z))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ie;function X(Z){let z=null;for(let Y=0,ee=Z.length;Y<ee;Y++){const ve=Z[Y].substituteConstants();if(Z[Y]!==ve&&z===null){z=[];for(let ge=0;ge<Y;ge++)z[ge]=Z[ge]}z!==null&&(z[Y]=ve)}return z===null?Z:z}class ye{static create(z,Y,ee){return ye._normalizeArr(z,Y,ee)}constructor(z,Y){this.expr=z,this.negated=Y,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let Y=0,ee=this.expr.length;Y<ee;Y++){const ve=o(this.expr[Y],z.expr[Y]);if(ve!==0)return ve}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let Y=0,ee=this.expr.length;Y<ee;Y++)if(!this.expr[Y].equals(z.expr[Y]))return!1;return!0}return!1}substituteConstants(){const z=X(this.expr);return z===this.expr?this:ye.create(z,this.negated,!1)}evaluate(z){for(let Y=0,ee=this.expr.length;Y<ee;Y++)if(!this.expr[Y].evaluate(z))return!1;return!0}static _normalizeArr(z,Y,ee){const ve=[];let ge=!1;for(const de of z)if(de){if(de.type===1){ge=!0;continue}if(de.type===0)return g.INSTANCE;if(de.type===6){ve.push(...de.expr);continue}ve.push(de)}if(ve.length===0&&ge)return d.INSTANCE;if(ve.length!==0){if(ve.length===1)return ve[0];ve.sort(o);for(let de=1;de<ve.length;de++)ve[de-1].equals(ve[de])&&(ve.splice(de,1),de--);if(ve.length===1)return ve[0];for(;ve.length>1;){const de=ve[ve.length-1];if(de.type!==9)break;ve.pop();const _e=ve.pop(),re=ve.length===0,ue=Pe.create(de.expr.map(ne=>ye.create([ne,_e],null,ee)),null,re);ue&&(ve.push(ue),ve.sort(o))}if(ve.length===1)return ve[0];if(ee){for(let de=0;de<ve.length;de++)for(let _e=de+1;_e<ve.length;_e++)if(ve[de].negate().equals(ve[_e]))return g.INSTANCE;if(ve.length===1)return ve[0]}return new ye(ve,Y)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const Y of this.expr)z.push(...Y.keys());return z}map(z){return new ye(this.expr.map(Y=>Y.map(z)),null)}negate(){if(!this.negated){const z=[];for(const Y of this.expr)z.push(Y.negate());this.negated=Pe.create(z,this,!0)}return this.negated}}e.ContextKeyAndExpr=ye;class Pe{static create(z,Y,ee){return Pe._normalizeArr(z,Y,ee)}constructor(z,Y){this.expr=z,this.negated=Y,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let Y=0,ee=this.expr.length;Y<ee;Y++){const ve=o(this.expr[Y],z.expr[Y]);if(ve!==0)return ve}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let Y=0,ee=this.expr.length;Y<ee;Y++)if(!this.expr[Y].equals(z.expr[Y]))return!1;return!0}return!1}substituteConstants(){const z=X(this.expr);return z===this.expr?this:Pe.create(z,this.negated,!1)}evaluate(z){for(let Y=0,ee=this.expr.length;Y<ee;Y++)if(this.expr[Y].evaluate(z))return!0;return!1}static _normalizeArr(z,Y,ee){let ve=[],ge=!1;if(z){for(let de=0,_e=z.length;de<_e;de++){const re=z[de];if(re){if(re.type===0){ge=!0;continue}if(re.type===1)return d.INSTANCE;if(re.type===9){ve=ve.concat(re.expr);continue}ve.push(re)}}if(ve.length===0&&ge)return g.INSTANCE;ve.sort(o)}if(ve.length!==0){if(ve.length===1)return ve[0];for(let de=1;de<ve.length;de++)ve[de-1].equals(ve[de])&&(ve.splice(de,1),de--);if(ve.length===1)return ve[0];if(ee){for(let de=0;de<ve.length;de++)for(let _e=de+1;_e<ve.length;_e++)if(ve[de].negate().equals(ve[_e]))return d.INSTANCE;if(ve.length===1)return ve[0]}return new Pe(ve,Y)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const Y of this.expr)z.push(...Y.keys());return z}map(z){return new Pe(this.expr.map(Y=>Y.map(z)),null)}negate(){if(!this.negated){const z=[];for(const Y of this.expr)z.push(Y.negate());for(;z.length>1;){const Y=z.shift(),ee=z.shift(),ve=[];for(const ge of we(Y))for(const de of we(ee))ve.push(ye.create([ge,de],null,!1));z.unshift(Pe.create(ve,null,!1))}this.negated=Pe.create(z,this,!0)}return this.negated}}e.ContextKeyOrExpr=Pe;class De extends k{static{this._info=[]}static all(){return De._info.values()}constructor(z,Y,ee){super(z,null),this._defaultValue=Y,typeof ee=="object"?De._info.push({...ee,key:z}):ee!==!0&&De._info.push({key:z,description:ee,type:Y!=null?typeof Y:void 0})}bindTo(z){return z.createKey(this.key,this._defaultValue)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return I.create(this.key,z)}notEqualsTo(z){return b.create(this.key,z)}}e.RawContextKey=De,e.IContextKeyService=(0,F.createDecorator)("contextKeyService");function pe(Z,z){return Z<z?-1:Z>z?1:0}function Se(Z,z,Y,ee){return Z<Y?-1:Z>Y?1:z<ee?-1:z>ee?1:0}function le(Z,z){if(Z.type===0||z.type===1)return!0;if(Z.type===9)return z.type===9?ae(Z.expr,z.expr):!1;if(z.type===9){for(const Y of z.expr)if(le(Z,Y))return!0;return!1}if(Z.type===6){if(z.type===6)return ae(z.expr,Z.expr);for(const Y of Z.expr)if(le(Y,z))return!0;return!1}return Z.equals(z)}e.implies=le;function ae(Z,z){let Y=0,ee=0;for(;Y<Z.length&&ee<z.length;){const ve=Z[Y].cmp(z[ee]);if(ve<0)return!1;ve===0&&Y++,ee++}return Y===Z.length}function we(Z){return Z.type===9?Z.expr:[Z]}}),define(Te[172],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Te[92],Ae([1,0,140,4]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function F(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function T(i,u){switch(i){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":u==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function l(i,u){return u==="web"&&!i.includes("web")}e.isNotWebExtensionInWebTargetPlatform=l;function y(i,u,v){return l(u,v)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===v}e.isTargetPlatformCompatible=y;function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=f;var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var a;(function(i){i.Install="install",i.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var h;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(h||(e.ExtensionSignaturetErrorCode=h={}));class t extends Error{constructor(u,v){super(u),this.code=v,this.name=v}}e.ExtensionManagementError=t,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Te[39],Ae([1,0,50,20,16,15,2,142,4,23,13,42]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function a(le){return le.create===!0}e.isFileOpenForWriteOptions=a;var E;(function(le){le[le.Unknown=0]="Unknown",le[le.File=1]="File",le[le.Directory=2]="Directory",le[le.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var p;(function(le){le[le.Readonly=1]="Readonly",le[le.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function h(le){const ae=le;return!!ae&&typeof ae.onDidChange=="function"}e.isFileSystemWatcher=h;var t;(function(le){le[le.None=0]="None",le[le.FileReadWrite=2]="FileReadWrite",le[le.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",le[le.FileReadStream=16]="FileReadStream",le[le.FileFolderCopy=8]="FileFolderCopy",le[le.PathCaseSensitive=1024]="PathCaseSensitive",le[le.Readonly=2048]="Readonly",le[le.Trash=4096]="Trash",le[le.FileWriteUnlock=8192]="FileWriteUnlock",le[le.FileAtomicRead=16384]="FileAtomicRead",le[le.FileAtomicWrite=32768]="FileAtomicWrite",le[le.FileAtomicDelete=65536]="FileAtomicDelete",le[le.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(le){return!!(le.capabilities&2)}e.hasReadWriteCapability=i;function u(le){return!!(le.capabilities&8)}e.hasFileFolderCopyCapability=u;function v(le){return!!(le.capabilities&131072)}e.hasFileCloneCapability=v;function _(le){return!!(le.capabilities&4)}e.hasOpenReadWriteCloseCapability=_;function m(le){return!!(le.capabilities&16)}e.hasFileReadStreamCapability=m;function n(le){return i(le)?!!(le.capabilities&16384):!1}e.hasFileAtomicReadCapability=n;function r(le){return i(le)?!!(le.capabilities&32768):!1}e.hasFileAtomicWriteCapability=r;function s(le){return!!(le.capabilities&65536)}e.hasFileAtomicDeleteCapability=s;function o(le){return!!(le.capabilities&2048)}e.hasReadonlyCapability=o;var g;(function(le){le.FileExists="EntryExists",le.FileNotFound="EntryNotFound",le.FileNotADirectory="EntryNotADirectory",le.FileIsADirectory="EntryIsADirectory",le.FileExceedsStorageQuota="EntryExceedsStorageQuota",le.FileTooLarge="EntryTooLarge",le.FileWriteLocked="EntryWriteLocked",le.NoPermissions="NoPermissions",le.Unavailable="Unavailable",le.Unknown="Unknown"})(g||(e.FileSystemProviderErrorCode=g={}));class d extends Error{static create(ae,we){const Z=new d(ae.toString(),we);return c(Z,we),Z}constructor(ae,we){super(ae),this.code=we}}e.FileSystemProviderError=d;function k(le,ae){return d.create(le,ae)}e.createFileSystemProviderError=k;function I(le){return le||k((0,l.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=I;function c(le,ae){return le.name=ae?`${ae} (FileSystemError)`:"FileSystemError",le}e.markAsFileSystemProviderError=c;function S(le){if(!le)return g.Unknown;if(le instanceof d)return le.code;const ae=/^(.+) \(FileSystemError\)$/.exec(le.name);if(!ae)return g.Unknown;switch(ae[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=S;function b(le){if(le instanceof L)return le.fileOperationResult;switch(S(le)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=b;var C;(function(le){le[le.CREATE=0]="CREATE",le[le.DELETE=1]="DELETE",le[le.MOVE=2]="MOVE",le[le.COPY=3]="COPY",le[le.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class ${constructor(ae,we,Z){this.resource=ae,this.operation=we,this.target=Z}isOperation(ae){return this.operation===ae}}e.FileOperationEvent=$;var N;(function(le){le[le.UPDATED=0]="UPDATED",le[le.ADDED=1]="ADDED",le[le.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class H{static{this.MIXED_CORRELATION=null}constructor(ae,we){this.ignorePathCasing=we,this.correlationId=void 0,this.added=new D.Lazy(()=>{const Z=w.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawAdded.map(z=>[z,!0])),Z}),this.updated=new D.Lazy(()=>{const Z=w.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawUpdated.map(z=>[z,!0])),Z}),this.deleted=new D.Lazy(()=>{const Z=w.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawDeleted.map(z=>[z,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of ae){switch(Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}this.correlationId!==H.MIXED_CORRELATION&&(typeof Z.cId=="number"?this.correlationId===void 0?this.correlationId=Z.cId:this.correlationId!==Z.cId&&(this.correlationId=H.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=H.MIXED_CORRELATION))}}contains(ae,...we){return this.doContains(ae,{includeChildren:!1},...we)}affects(ae,...we){return this.doContains(ae,{includeChildren:!0},...we)}doContains(ae,we,...Z){if(!ae)return!1;const z=Z.length>0;return!!((!z||Z.includes(1))&&(this.added.value.get(ae)||we.includeChildren&&this.added.value.findSuperstr(ae))||(!z||Z.includes(0))&&(this.updated.value.get(ae)||we.includeChildren&&this.updated.value.findSuperstr(ae))||(!z||Z.includes(2))&&(this.deleted.value.findSubstr(ae)||we.includeChildren&&this.deleted.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.correlationId===ae}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=H;function B(le,ae,we){return!le||!ae||le===ae||ae.length>le.length?!1:(ae.charAt(ae.length-1)!==R.sep&&(ae+=R.sep),we?(0,P.startsWithIgnoreCase)(le,ae):le.indexOf(ae)===0)}e.isParent=B;class L extends Error{constructor(ae,we,Z){super(ae),this.fileOperationResult=we,this.options=Z}}e.FileOperationError=L;class U extends L{constructor(ae,we,Z,z){super(ae,we,z),this.fileOperationResult=we,this.size=Z}}e.TooLargeFileOperationError=U;class ie extends L{constructor(ae,we,Z){super(ae,2,Z),this.stat=we}}e.NotModifiedSinceFileOperationError=ie;var X;(function(le){le[le.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",le[le.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",le[le.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",le[le.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",le[le.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",le[le.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",le[le.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",le[le.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",le[le.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",le[le.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",le[le.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ye;(function(le){le[le.FILE=0]="FILE",le[le.FOLDER=1]="FOLDER",le[le.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.ETAG_DISABLED="";function Pe(le){if(!(typeof le.size!="number"||typeof le.mtime!="number"))return le.mtime.toString(29)+le.size.toString(31)}e.etag=Pe;async function De(le,ae){if(!ae.hasProvider(T.URI.from({scheme:le.scheme})))return new Promise(we=>{const Z=ae.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===le.scheme&&z.added&&(Z.dispose(),we())})})}e.whenProviderRegistered=De;class pe{static{this.KB=1024}static{this.MB=pe.KB*pe.KB}static{this.GB=pe.MB*pe.KB}static{this.TB=pe.GB*pe.KB}static formatSize(ae){return(0,F.isNumber)(ae)||(ae=0),ae<pe.KB?(0,l.localize)(1,null,ae.toFixed(0)):ae<pe.MB?(0,l.localize)(2,null,(ae/pe.KB).toFixed(2)):ae<pe.GB?(0,l.localize)(3,null,(ae/pe.MB).toFixed(2)):ae<pe.TB?(0,l.localize)(4,null,(ae/pe.GB).toFixed(2)):(0,l.localize)(5,null,(ae/pe.TB).toFixed(2))}}e.ByteSize=pe;function Se(le){const ae=typeof le=="string"||le?.scheme===A.Schemas.vscodeRemote;return typeof le!="string"&&le?.scheme===A.Schemas.file?1024*pe.MB:ae?10*pe.MB:f.isWeb?50*pe.MB:1024*pe.MB}e.getLargeFileConfirmationLimit=Se}),define(Te[71],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...P){this._entries=new Map;for(const[F,T]of P)this.set(F,T)}set(P,F){const T=this._entries.get(P);return this._entries.set(P,F),T}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=w}),define(Te[173],Ae([1,0,12,11,6,69,171,4,71,174]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new y.ServiceCollection,i=!1,u,v=A){this._services=t,this._strict=i,this._parent=u,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(l.IInstantiationService,this),this._globalGraph=v?u?._globalGraph??new T.Graph(_=>_):void 0}createChild(t){return new a(t,this._strict,this,this._enableTracing)}invokeFunction(t,...i){const u=p.traceInvocation(this._enableTracing,t);let v=!1;try{return t({get:m=>{if(v)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(m,u);if(!n)throw new Error(`[invokeFunction] unknown service '${m}'`);return n}},...i)}finally{v=!0,u.stop()}}createInstance(t,...i){let u,v;return t instanceof F.SyncDescriptor?(u=p.traceCreation(this._enableTracing,t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(i),u)):(u=p.traceCreation(this._enableTracing,t),v=this._createInstance(t,i,u)),u.stop(),v}_createInstance(t,i=[],u){const v=l._util.getServiceDependencies(t).sort((n,r)=>n.index-r.index),_=[];for(const n of v){const r=this._getOrCreateServiceInstance(n.id,u);r||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),_.push(r)}const m=v.length>0?v[0].index:i.length;if(i.length!==m){console.trace(`[createInstance] First service dependency of ${t.name} at position ${m+1} conflicts with ${i.length} static arguments`);const n=m-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,m)}return Reflect.construct(t,i.concat(_))}_setServiceInstance(t,i){if(this._services.get(t)instanceof F.SyncDescriptor)this._services.set(t,i);else if(this._parent)this._parent._setServiceInstance(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const i=this._services.get(t);return!i&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):i}_getOrCreateServiceInstance(t,i){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const u=this._getServiceInstanceOrDescriptor(t);return u instanceof F.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,u,i.branch(t,!0)):(i.branch(t,!1),u)}_safeCreateAndCacheServiceInstance(t,i,u){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,i,u)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,i,u){const v=new T.Graph(n=>n.id.toString());let _=0;const m=[{id:t,desc:i,_trace:u}];for(;m.length;){const n=m.pop();if(v.lookupOrInsertNode(n),_++>1e3)throw new D(v);for(const r of l._util.getServiceDependencies(n.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(r.id);if(s||this._throwIfStrict(`[createInstance] ${t} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),s instanceof F.SyncDescriptor){const o={id:r.id,desc:s,_trace:n._trace.branch(r.id,!0)};v.insertEdge(n,o),m.push(o)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new D(v);break}for(const{data:r}of n){if(this._getServiceInstanceOrDescriptor(r.id)instanceof F.SyncDescriptor){const o=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,o)}v.removeNode(r)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,i,u=[],v,_){if(this._services.get(t)instanceof F.SyncDescriptor)return this._createServiceInstance(t,i,u,v,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,i,u,v,_);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}_createServiceInstance(t,i,u=[],v,_){if(v){const m=new a(void 0,this._strict,this,this._enableTracing);m._globalGraphImplicitDependency=String(t);const n=new Map,r=new w.IdleValue(()=>{const s=m._createInstance(i,u,_);for(const[o,g]of n){const d=s[o];if(typeof d=="function")for(const k of g)d.apply(s,k)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let k=n.get(o);return k||(k=new f.LinkedList,n.set(o,k)),(c,S,b)=>{const C=k.push([c,S,b]);return(0,P.toDisposable)(C)}}if(o in s)return s[o];const g=r.value;let d=g[o];return typeof d!="function"||(d=d.bind(g),s[o]=d),d},set(s,o,g){return r.value[o]=g,!0},getPrototypeOf(s){return i.prototype}})}else return this._createInstance(i,u,_)}_throwIfStrict(t,i){if(i&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=a;var E;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(E||(E={}));class p{static{this.all=new Set}static{this._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(t,i){return t?new p(1,i.name):p._None}static{this._totals=0}constructor(t,i){this.type=t,this.name=i,this._start=Date.now(),this._dep=[]}branch(t,i){const u=new p(3,t.toString());return this._dep.push([t,i,u]),u}stop(){const t=Date.now()-this._start;p._totals+=t;let i=!1;function u(_,m){const n=[],r=new Array(_+1).join("	");for(const[s,o,g]of m._dep)if(o&&g){i=!0,n.push(`${r}CREATES -> ${s}`);const d=u(_+1,g);d&&n.push(d)}else n.push(`${r}uses -> ${s}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(t>2||i)&&p.all.add(v.join(`
`))}}e.Trace=p}),define(Te[14],Ae([1,0,37,5,93,6,28,23,24,15,2,32,4]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,a.createDecorator)("logService"),e.ILoggerService=(0,a.createDecorator)("loggerService");function E(){return new Date().toISOString()}function p(c){return(0,f.isNumber)(c)}e.isLogLevel=p;var h;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(h||(e.LogLevel=h={})),e.DEFAULT_LOG_LEVEL=h.Info;function t(c,S,b){switch(S){case h.Trace:c.trace(b);break;case h.Debug:c.debug(b);break;case h.Info:c.info(b);break;case h.Warning:c.warn(b);break;case h.Error:c.error(b);break;case h.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=t;function i(c,S=!1){let b="";for(let C=0;C<c.length;C++){let $=c[C];if($ instanceof Error&&($=(0,w.toErrorMessage)($,S)),typeof $=="object")try{$=JSON.stringify($)}catch{}b+=(C>0?" ":"")+$}return b}class u extends F.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(S){this.level!==S&&(this.level=S,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(S){return this.level!==h.Off&&this.level<=S}}e.AbstractLogger=u;class v extends u{constructor(S){super(),this.logAlways=S}checkLogLevel(S){return this.logAlways||super.checkLogLevel(S)}trace(S,...b){this.checkLogLevel(h.Trace)&&this.log(h.Trace,i([S,...b],!0))}debug(S,...b){this.checkLogLevel(h.Debug)&&this.log(h.Debug,i([S,...b]))}info(S,...b){this.checkLogLevel(h.Info)&&this.log(h.Info,i([S,...b]))}warn(S,...b){this.checkLogLevel(h.Warning)&&this.log(h.Warning,i([S,...b]))}error(S,...b){if(this.checkLogLevel(h.Error))if(S instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=S.stack,this.log(h.Error,i(C))}else this.log(h.Error,i([S,...b]))}flush(){}}e.AbstractMessageLogger=v;class _ extends u{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.useColors=!l.isWindows}trace(S,...b){this.checkLogLevel(h.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,S,...b):console.log(`[main ${E()}]`,S,...b))}debug(S,...b){this.checkLogLevel(h.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,S,...b):console.log(`[main ${E()}]`,S,...b))}info(S,...b){this.checkLogLevel(h.Info)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,S,...b):console.log(`[main ${E()}]`,S,...b))}warn(S,...b){this.checkLogLevel(h.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,S,...b):console.warn(`[main ${E()}]`,S,...b))}error(S,...b){this.checkLogLevel(h.Error)&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,S,...b):console.error(`[main ${E()}]`,S,...b))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class m extends u{constructor(S=e.DEFAULT_LOG_LEVEL,b=!0){super(),this.useColors=b,this.setLevel(S)}trace(S,...b){this.checkLogLevel(h.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",S,...b):console.log(S,...b))}debug(S,...b){this.checkLogLevel(h.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",S,...b):console.log(S,...b))}info(S,...b){this.checkLogLevel(h.Info)&&(this.useColors?console.log("%c INFO","color: #33f",S,...b):console.log(S,...b))}warn(S,...b){this.checkLogLevel(h.Warning)&&(this.useColors?console.log("%c WARN","color: #993",S,...b):console.log(S,...b))}error(S,...b){this.checkLogLevel(h.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",S,...b):console.error(S,...b))}dispose(){}flush(){}}e.ConsoleLogger=m;class n extends u{constructor(S,b=e.DEFAULT_LOG_LEVEL){super(),this.adapter=S,this.setLevel(b)}trace(S,...b){this.checkLogLevel(h.Trace)&&this.adapter.log(h.Trace,[this.extractMessage(S),...b])}debug(S,...b){this.checkLogLevel(h.Debug)&&this.adapter.log(h.Debug,[this.extractMessage(S),...b])}info(S,...b){this.checkLogLevel(h.Info)&&this.adapter.log(h.Info,[this.extractMessage(S),...b])}warn(S,...b){this.checkLogLevel(h.Warning)&&this.adapter.log(h.Warning,[this.extractMessage(S),...b])}error(S,...b){this.checkLogLevel(h.Error)&&this.adapter.log(h.Error,[this.extractMessage(S),...b])}extractMessage(S){return typeof S=="string"?S:(0,w.toErrorMessage)(S,this.checkLogLevel(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class r extends u{constructor(S){super(),this.loggers=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const b of this.loggers)b.setLevel(S);super.setLevel(S)}trace(S,...b){for(const C of this.loggers)C.trace(S,...b)}debug(S,...b){for(const C of this.loggers)C.debug(S,...b)}info(S,...b){for(const C of this.loggers)C.info(S,...b)}warn(S,...b){for(const C of this.loggers)C.warn(S,...b)}error(S,...b){for(const C of this.loggers)C.error(S,...b)}flush(){for(const S of this.loggers)S.flush()}dispose(){for(const S of this.loggers)S.dispose()}}e.MultiplexLogger=r;class s extends F.Disposable{constructor(S,b,C){if(super(),this.logLevel=S,this.logsHome=b,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new R.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,C)for(const $ of C)this._loggers.set($.resource,{logger:void 0,info:$})}getLoggerEntry(S){return(0,f.isString)(S)?[...this._loggers.values()].find(b=>b.info.id===S):this._loggers.get(S)}getLogger(S){return this.getLoggerEntry(S)?.logger}createLogger(S,b){const C=this.toResource(S),$=(0,f.isString)(S)?S:b?.id??(0,P.hash)(C.toString()).toString(16);let N=this._loggers.get(C)?.logger;const H=b?.logLevel==="always"?h.Trace:b?.logLevel;N||(N=this.doCreateLogger(C,H??this.getLogLevel(C)??this.logLevel,{...b,id:$}));const B={logger:N,info:{resource:C,id:$,logLevel:H,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(B.info),this._loggers.set(C,B),N}toResource(S){return(0,f.isString)(S)?(0,y.joinPath)(this.logsHome,`${S}.log`):S}setLogLevel(S,b){if(A.URI.isUri(S)){const C=S,$=b,N=this._loggers.get(C);N&&$!==N.info.logLevel&&(N.info.logLevel=$===this.logLevel?void 0:$,N.logger?.setLevel($),this._loggers.set(N.info.resource,N),this._onDidChangeLogLevel.fire([C,$]))}else{this.logLevel=S;for(const[C,$]of this._loggers.entries())this._loggers.get(C)?.info.logLevel===void 0&&$.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(S,b){const C=this.getLoggerEntry(S);C&&b!==!C.info.hidden&&(C.info.hidden=!b,this._loggers.set(C.info.resource,C),this._onDidChangeVisibility.fire([C.info.resource,b]))}getLogLevel(S){let b;return S&&(b=this._loggers.get(S)?.info.logLevel),b??this.logLevel}registerLogger(S){const b=this._loggers.get(S.resource);b?b.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this._loggers.set(S.resource,{info:S,logger:void 0}),this._onDidChangeLoggers.fire({added:[S],removed:[]}))}deregisterLogger(S){const b=this._loggers.get(S);b&&(b.logger&&b.logger.dispose(),this._loggers.delete(S),this._onDidChangeLoggers.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const S of this._loggers.values())yield S.info}getRegisteredLogger(S){return this._loggers.get(S)?.info}dispose(){this._loggers.forEach(S=>S.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class o{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(S){}getLevel(){return h.Info}trace(S,...b){}debug(S,...b){}info(S,...b){}warn(S,...b){}error(S,...b){}critical(S,...b){}dispose(){}flush(){}}e.NullLogger=o;class g extends o{}e.NullLogService=g;function d(c){if(c.verbose)return h.Trace;if(typeof c.logLevel=="string"){const S=I(c.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function k(c){switch(c){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=k;function I(c){switch(c){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=I,e.CONTEXT_LOG_LEVEL=new D.RawContextKey("logLevel",k(h.Info))}),define(Te[175],Ae([1,0,6,14]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends w.Disposable{constructor(T,l=[]){super(),this.logger=new R.MultiplexLogger([T,...l]),this._register(T.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...l){this.logger.trace(T,...l)}debug(T,...l){this.logger.debug(T,...l)}info(T,...l){this.logger.info(T,...l)}warn(T,...l){this.logger.warn(T,...l)}error(T,...l){this.logger.error(T,...l)}flush(){this.logger.flush()}}e.LogService=P}),define(Te[94],Ae([1,0,29,143,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(y){function f(p,h){return h-p}y.compare=f;const A=Object.create(null);A[y.Error]=(0,R.localize)(0,null),A[y.Warning]=(0,R.localize)(1,null),A[y.Info]=(0,R.localize)(2,null);function D(p){return A[p]||""}y.toString=D;function a(p){switch(p){case w.default.Error:return y.Error;case w.default.Warning:return y.Warning;case w.default.Info:return y.Info;case w.default.Ignore:return y.Hint}}y.fromSeverity=a;function E(p){switch(p){case y.Error:return w.default.Error;case y.Warning:return w.default.Warning;case y.Info:return w.default.Info;case y.Hint:return w.default.Ignore}}y.toSeverity=E}(T||(e.MarkerSeverity=T={}));var l;(function(y){const f="";function A(a){return D(a,!0)}y.makeKey=A;function D(a,E){const p=[f];return a.source?p.push(a.source.replace("\xA6","\\\xA6")):p.push(f),a.code?typeof a.code=="string"?p.push(a.code.replace("\xA6","\\\xA6")):p.push(a.code.value.replace("\xA6","\\\xA6")):p.push(f),a.severity!==void 0&&a.severity!==null?p.push(T.toString(a.severity)):p.push(f),a.message&&E?p.push(a.message.replace("\xA6","\\\xA6")):p.push(f),a.startLineNumber!==void 0&&a.startLineNumber!==null?p.push(a.startLineNumber.toString()):p.push(f),a.startColumn!==void 0&&a.startColumn!==null?p.push(a.startColumn.toString()):p.push(f),a.endLineNumber!==void 0&&a.endLineNumber!==null?p.push(a.endLineNumber.toString()):p.push(f),a.endColumn!==void 0&&a.endColumn!==null?p.push(a.endColumn.toString()):p.push(f),p.push(f),p.join("\xA6")}y.makeKeyOptionalMessage=D})(l||(e.IMarkerData=l={})),e.IMarkerService=(0,P.createDecorator)("markerService")}),define(Te[176],Ae([1,0,5,29,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,P.createDecorator)("notificationService");var F;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var T;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var l;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class y{constructor(){this.progress=new f,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.NoOpNotification=y;class f{infinite(){}done(){}total(D){}worked(D){}}e.NoOpProgress=f}),define(Te[95],Ae([1,0,16,2,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService");function F(f,A){return R.URI.isUri(f)?(0,w.equalsIgnoreCase)(f.scheme,A):(0,w.startsWithIgnoreCase)(f,A+":")}e.matchesScheme=F;function T(f,...A){return A.some(D=>F(f,D))}e.matchesSomeScheme=T;function l(f,A){return f.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.withSelection=l;function y(f){let A;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return D&&(A={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},f=f.with({fragment:""})),{selection:A,uri:f}}e.extractSelection=y}),define(Te[177],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(be,e,w,R){var P=arguments.length,F=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(be,e,w,R);else for(var l=be.length-1;l>=0;l--)(T=be[l])&&(F=(P<3?T(F):P>3?T(e,w,F):T(e,w))||F);return P>3&&F&&Object.defineProperty(e,w,F),F},He=this&&this.__param||function(be,e){return function(w,R){e(w,R,be)}};define(Te[52],Ae([1,0,12,19,6,4]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,F.createDecorator)("progressService");var T;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(a){this.callback=a}report(a){this._value=a,this.callback(this._value)}}e.Progress=l;class y{get value(){return this._value}constructor(a){this.callback=a}report(a){this._asyncQueue?this._asyncQueue.push(a):this._asyncQueue=[a],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const a=this._asyncQueue.shift();this._value=a,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const a=this._drainListener;this._drainListener=void 0,a?.()}}drain(){return this._processingAsyncQueue?new Promise(a=>{const E=this._drainListener;this._drainListener=()=>{E?.(),a()}}):Promise.resolve()}}e.AsyncProgress=y;let f=class extends P.Disposable{constructor(a,E){super(),this.deferred=new w.DeferredPromise,E.withProgress(a,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(a){this.reporter?this.reporter.report(a):this.lastStep=a}};e.UnmanagedProgress=f,e.UnmanagedProgress=f=Ve([He(1,e.IProgressService)],f);class A extends P.Disposable{constructor(a){super(),this.progressIndicator=a,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(a){this.stop();const E=++this.currentOperationId,p=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},a),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:p.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(a){this.currentOperationId===a&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,F.createDecorator)("editorProgressService")}),define(Te[30],Ae([1,0,53,15]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(T,l){w.ok(R.isString(T)),w.ok(R.isObject(l)),w.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,l)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new P}),define(Te[72],Ae([1,0,5,30]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class F{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,f){this.schemasById[P(y)]=f,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new F;R.Registry.add(e.Extensions.JSONContribution,T)}),define(Te[96],Ae([1,0,18,5,15,137,45,72,30]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=y.Registry.as(l.Extensions.JSONContribution);class a{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const s=new Set;this.doRegisterConfigurations(n,r,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const r=new Set;this.doDeregisterConfigurations(n,r),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const s=new Set;this.doDeregisterConfigurations(r,s),this.doRegisterConfigurations(n,!1,s),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(n){const r=new Set;this.doRegisterDefaultConfigurations(n,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,r){const s=[];for(const{overrides:o,source:g}of n)for(const d in o)if(r.add(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const k=this.configurationDefaultsOverrides.get(d),I=k?.valuesSources??new Map;if(g)for(const C of Object.keys(o[d]))I.set(C,g);const c={...k?.value||{},...o[d]};this.configurationDefaultsOverrides.set(d,{source:g,value:c,valuesSources:I});const S=(0,T.getLanguageTagSettingPlainKey)(d),b={type:"object",default:c,description:F.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:P.isString(g)?void 0:g,defaultValueSource:g};s.push(...h(d)),this.configurationProperties[d]=b,this.defaultLanguageConfigurationOverridesNode.properties[d]=b}else{this.configurationDefaultsOverrides.set(d,{value:o[d],source:g});const k=this.configurationProperties[d];k&&(this.updatePropertyDefaultValue(d,k),this.updateSchema(d,k))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(n){const r=new Set;this.doDeregisterDefaultConfigurations(n,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,r){for(const{overrides:s,source:o}of n)for(const g in s){const d=this.configurationDefaultsOverrides.get(g),k=P.isString(o)?o:o?.id,I=P.isString(d?.source)?d?.source:d?.source?.id;if(k===I)if(r.add(g),this.configurationDefaultsOverrides.delete(g),e.OVERRIDE_PROPERTY_REGEX.test(g))delete this.configurationProperties[g],delete this.defaultLanguageConfigurationOverridesNode.properties[g];else{const c=this.configurationProperties[g];c&&(this.updatePropertyDefaultValue(g,c),this.updateSchema(g,c))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let r=!1;const s=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,s),r=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,s),r=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,s),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r,s){n.forEach(o=>{this.validateAndRegisterProperties(o,r,o.extensionInfo,o.restrictedProperties,void 0,s),this.configurationContributors.push(o),this.registerJSONConfiguration(o)})}doDeregisterConfigurations(n,r){const s=o=>{if(o.properties)for(const g in o.properties){r.add(g);const d=this.configurationProperties[g];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[g],this.removeFromSchema(g,o.properties[g])}o.allOf?.forEach(g=>s(g))};for(const o of n){s(o);const g=this.configurationContributors.indexOf(o);g!==-1&&this.configurationContributors.splice(g,1)}}validateAndRegisterProperties(n,r=!0,s,o,g=3,d){g=P.isUndefinedOrNull(n.scope)?g:n.scope;const k=n.properties;if(k)for(const c in k){const S=k[c];if(r&&v(c,S)){delete k[c];continue}if(S.source=s,S.defaultDefaultValue=k[c].default,this.updatePropertyDefaultValue(c,S),e.OVERRIDE_PROPERTY_REGEX.test(c)?S.scope=void 0:(S.scope=P.isUndefinedOrNull(S.scope)?g:S.scope,S.restricted=P.isUndefinedOrNull(S.restricted)?!!o?.includes(c):S.restricted),k[c].hasOwnProperty("included")&&!k[c].included){this.excludedConfigurationProperties[c]=k[c],delete k[c];continue}else this.configurationProperties[c]=k[c],k[c].policy?.name&&this.policyConfigurations.set(k[c].policy.name,c);!k[c].deprecationMessage&&k[c].markdownDeprecationMessage&&(k[c].deprecationMessage=k[c].markdownDeprecationMessage),d.add(c)}const I=n.allOf;if(I)for(const c of I)this.validateAndRegisterProperties(c,r,s,o,g,d)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=s=>{const o=s.properties;if(o)for(const d in o)this.updateSchema(d,o[d]);s.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,s={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,s),e.allSettings.properties[r]=s,e.applicationSettings.properties[r]=s,e.machineSettings.properties[r]=s,e.machineOverridableSettings.properties[r]=s,e.windowSettings.properties[r]=s,e.resourceSettings.properties[r]=s}}registerOverridePropertyPatternKey(){const n={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const s=this.configurationDefaultsOverrides.get(n);let o=s?.value,g=s?.source;P.isUndefined(o)&&(o=r.defaultDefaultValue,g=void 0),P.isUndefined(o)&&(o=i(r.type)),r.default=o,r.defaultValueSource=g}}const E="\\[([^\\]]+)\\]",p=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(m){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let r=p.exec(m);for(;r?.length;){const s=r[1].trim();s&&n.push(s),r=p.exec(m)}}return(0,w.distinct)(n)}e.overrideIdentifiersFromKey=h;function t(m){return m.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=t;function i(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=i;const u=new a;y.Registry.add(e.Extensions.Configuration,u);function v(m,n){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?F.localize(7,null,m):u.getConfigurationProperties()[m]!==void 0?F.localize(8,null,m):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?F.localize(9,null,m,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:F.localize(6,null)}e.validateProperty=v;function _(){const m=[],n=u.getConfigurationProperties();for(const r of Object.keys(n))m.push([r,n[r].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=_}),define(Te[178],Ae([1,0,18,5,115,6,28,25,15,2,45,96,30]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function E(r){return Object.isFrozen(r)?r:l.deepFreeze(r)}class p{constructor(s={},o=[],g=[],d){this._contents=s,this._keys=o,this._overrides=g,this.raw=d,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof p)return o;const g=new h("");return g.parseRaw(o),g.configurationModel});this._rawConfiguration=s.reduce((o,g)=>g===o?g:o.merge(g),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,A.getConfigurationValue)(this.contents,s):this.contents}inspect(s,o){const g=this.rawConfiguration.getValue(s),d=o?this.rawConfiguration.getOverrideValue(s,o):void 0,k=o?this.rawConfiguration.override(o).getValue(s):g;return{value:g,override:d,merged:k}}getOverrideValue(s,o){const g=this.getContentsForOverrideIdentifer(o);return g?s?(0,A.getConfigurationValue)(g,s):g:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const g of this.overrides)g.identifiers.includes(s)&&o.push(...g.keys);return w.distinct(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return w.distinct(s)}override(s){let o=this.overrideConfigurations.get(s);return o||(o=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,o)),o}merge(...s){const o=l.deepClone(this.contents),g=l.deepClone(this.overrides),d=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const I of s)if(k.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.mergeContents(o,I.contents);for(const c of I.overrides){const[S]=g.filter(b=>w.equals(b.identifiers,c.identifiers));S?(this.mergeContents(S.contents,c.contents),S.keys.push(...c.keys),S.keys=w.distinct(S.keys)):g.push(l.deepClone(c))}for(const c of I.keys)d.indexOf(c)===-1&&d.push(c)}return new p(o,d,g,k.every(I=>I instanceof p)?void 0:k)}createOverrideConfigurationModel(s){const o=this.getContentsForOverrideIdentifer(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const g={};for(const d of w.distinct([...Object.keys(this.contents),...Object.keys(o)])){let k=this.contents[d];const I=o[d];I&&(typeof k=="object"&&typeof I=="object"?(k=l.deepClone(k),this.mergeContents(k,I)):k=I),g[d]=k}return new p(g,this.keys,this.overrides)}mergeContents(s,o){for(const g of Object.keys(o)){if(g in s&&y.isObject(s[g])&&y.isObject(o[g])){this.mergeContents(s[g],o[g]);continue}s[g]=l.deepClone(o[g])}}getContentsForOverrideIdentifer(s){let o=null,g=null;const d=k=>{k&&(g?this.mergeContents(g,k):g=l.deepClone(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===s?o=k.contents:k.identifiers.includes(s)&&d(k.contents);return d(o),g}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.updateValue(s,o,!0)}setValue(s,o){this.updateValue(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,A.removeFromValueTree)(this.contents,s),D.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(g=>w.equals(g.identifiers,(0,D.overrideIdentifiersFromKey)(s))),1))}updateValue(s,o,g){(0,A.addToValueTree)(this.contents,s,o,d=>console.error(d)),g=g||this.keys.indexOf(s)===-1,g&&this.keys.push(s),D.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,D.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,A.toValuesTree)(this.contents[s],d=>console.error(d))})}}e.ConfigurationModel=p;class h{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,o){if(!y.isUndefinedOrNull(s)){const g=this.doParseContent(s);this.parseRaw(g,o)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,o){this._raw=s;const{contents:g,keys:d,overrides:k,restricted:I,hasExcludedProperties:c}=this.doParseRaw(s,o);this._configurationModel=new p(g,d,k,c?[s]:void 0),this._restrictedConfigurations=I||[]}doParseContent(s){let o={},g=null,d=[];const k=[],I=[];function c(b){Array.isArray(d)?d.push(b):g!==null&&(d[g]=b)}const S={onObjectBegin:()=>{const b={};c(b),k.push(d),d=b,g=null},onObjectProperty:b=>{g=b},onObjectEnd:()=>{d=k.pop()},onArrayBegin:()=>{const b=[];c(b),k.push(d),d=b,g=null},onArrayEnd:()=>{d=k.pop()},onLiteralValue:c,onError:(b,C,$)=>{I.push({error:b,offset:C,length:$})}};if(s)try{P.visit(s,S),o=d[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return o}doParseRaw(s,o){const g=a.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),d=this.filter(s,g,!0,o);s=d.raw;const k=(0,A.toValuesTree)(s,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),I=Object.keys(s),c=this.toOverrides(s,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:k,keys:I,overrides:c,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}filter(s,o,g,d){let k=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:k};const I={},c=[];for(const S in s)if(D.OVERRIDE_PROPERTY_REGEX.test(S)&&g){const b=this.filter(s[S],o,!1,d);I[S]=b.raw,k=k||b.hasExcludedProperties,c.push(...b.restricted)}else{const b=o[S],C=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&c.push(S),!d.exclude?.includes(S)&&(d.include?.includes(S)||(C===void 0||d.scopes===void 0||d.scopes.includes(C))&&!(d.skipRestricted&&b?.restricted))?I[S]=s[S]:k=!0}return{raw:I,restricted:c,hasExcludedProperties:k}}toOverrides(s,o){const g=[];for(const d of Object.keys(s))if(D.OVERRIDE_PROPERTY_REGEX.test(d)){const k={};for(const I in s[d])k[I]=s[d][I];g.push({identifiers:(0,D.overrideIdentifiersFromKey)(d),keys:Object.keys(k),contents:(0,A.toValuesTree)(k,o)})}return g}}e.ConfigurationModelParser=h;class t extends F.Disposable{constructor(s,o,g,d){super(),this.userSettingsResource=s,this.parseOptions=o,this.fileService=d,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this._register(this.fileService.watch(g.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,k=>k.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&g.isEqual(k.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class i{constructor(s,o,g,d,k,I,c,S,b,C,$,N,H){this.key=s,this.overrides=o,this._value=g,this.overrideIdentifiers=d,this.defaultConfiguration=k,this.policyConfiguration=I,this.applicationConfiguration=c,this.userConfiguration=S,this.localUserConfiguration=b,this.remoteUserConfiguration=C,this.workspaceConfiguration=$,this.folderConfigurationModel=N,this.memoryConfigurationModel=H}get value(){return E(this._value)}inspect(s,o,g){const d=s.inspect(o,g);return{get value(){return E(d.value)},get override(){return E(d.override)},get merged(){return E(d.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(s,o,g,d,k=new p,I=new p,c=new T.ResourceMap,S=new p,b=new T.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=o,this._applicationConfiguration=g,this._localUserConfiguration=d,this._remoteUserConfiguration=k,this._workspaceConfiguration=I,this._folderConfigurations=c,this._memoryConfiguration=S,this._memoryConfigurationByResource=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(s,o,g){return this.getConsolidatedConfigurationModel(s,o,g).getValue(s)}updateValue(s,o,g={}){let d;g.resource?(d=this._memoryConfigurationByResource.get(g.resource),d||(d=new p,this._memoryConfigurationByResource.set(g.resource,d))):d=this._memoryConfiguration,o===void 0?d.removeValue(s):d.setValue(s,o),g.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,o,g){const d=this.getConsolidatedConfigurationModel(s,o,g),k=this.getFolderConfigurationModelForResource(o.resource,g),I=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,c=new Set;for(const S of d.overrides)for(const b of S.identifiers)d.getOverrideValue(s,b)!==void 0&&c.add(b);return new i(s,o,d.getValue(s),c.size?[...c]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,g?this._workspaceConfiguration:void 0,k||void 0,I)}keys(s){const o=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,o){this._folderConfigurations.set(s,o),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const g=[];if(!o){const{added:d,updated:k,removed:I}=m(this._defaultConfiguration,s);o=[...d,...k,...I]}for(const d of o)for(const k of(0,D.overrideIdentifiersFromKey)(d)){const I=this._defaultConfiguration.getKeysForOverrideIdentifier(k),c=s.getKeysForOverrideIdentifier(k),S=[...c.filter(b=>I.indexOf(b)===-1),...I.filter(b=>c.indexOf(b)===-1),...I.filter(b=>!l.equals(this._defaultConfiguration.override(k).getValue(b),s.override(k).getValue(b)))];g.push([k,S])}return this.updateDefaultConfiguration(s),{keys:o,overrides:g}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:g,removed:d}=m(this._policyConfiguration,s),k=[...o,...g,...d];return k.length&&this.updatePolicyConfiguration(s),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:g,removed:d,overrides:k}=m(this.applicationConfiguration,s),I=[...o,...g,...d];return I.length&&this.updateApplicationConfiguration(s),{keys:I,overrides:k}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:g,removed:d,overrides:k}=m(this.localUserConfiguration,s),I=[...o,...g,...d];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:k}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:g,removed:d,overrides:k}=m(this.remoteUserConfiguration,s),I=[...o,...g,...d];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:k}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:g,removed:d,overrides:k}=m(this.workspaceConfiguration,s),I=[...o,...g,...d];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:k}}compareAndUpdateFolderConfiguration(s,o){const g=this.folderConfigurations.get(s),{added:d,updated:k,removed:I,overrides:c}=m(g,o),S=[...d,...k,...I];return(S.length||!g)&&this.updateFolderConfiguration(s,o),{keys:S,overrides:c}}compareAndDeleteFolderConfiguration(s){const o=this.folderConfigurations.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:g,updated:d,removed:k,overrides:I}=m(o,void 0);return{keys:[...g,...d,...k],overrides:I}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,o,g){let d=this.getConsolidatedConfigurationModelForResource(o,g);return o.overrideIdentifier&&(d=d.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(d=d.merge(this._policyConfiguration)),d}getConsolidatedConfigurationModelForResource({resource:s},o){let g=this.getWorkspaceConsolidatedConfiguration();if(o&&s){const d=o.getFolder(s);d&&(g=this.getFolderConsolidatedConfiguration(d.uri)||g);const k=this._memoryConfigurationByResource.get(s);k&&(g=g.merge(k))}return g}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let o=this._foldersConsolidatedConfigurations.get(s);if(!o){const g=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(s);d?(o=g.merge(d),this._foldersConsolidatedConfigurations.set(s,o)):o=g}return o}getFolderConfigurationModelForResource(s,o){if(o&&s){const g=o.getFolder(s);if(g)return this._folderConfigurations.get(g.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,o)=>{const{contents:g,overrides:d,keys:k}=this._folderConfigurations.get(o);return s.push([o,{contents:g,overrides:d,keys:k}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this._workspaceConfiguration.keys.forEach(o=>s.add(o)),this._folderConfigurations.forEach(o=>o.keys.forEach(g=>s.add(g))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this._folderConfigurations.forEach(o=>o.getAllOverrideIdentifiers().forEach(g=>s.add(g))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(g=>o.add(g)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(g=>o.add(g)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(g=>o.add(g)),this._folderConfigurations.forEach(g=>g.getKeysForOverrideIdentifier(s).forEach(d=>o.add(d))),[...o.values()]}static parse(s){const o=this.parseConfigurationModel(s.defaults),g=this.parseConfigurationModel(s.policy),d=this.parseConfigurationModel(s.application),k=this.parseConfigurationModel(s.user),I=this.parseConfigurationModel(s.workspace),c=s.folders.reduce((S,b)=>(S.set(f.URI.revive(b[0]),this.parseConfigurationModel(b[1])),S),new T.ResourceMap);return new u(o,g,d,k,new p,I,c,new p,new T.ResourceMap)}static parseConfigurationModel(s){return new p(s.contents,s.keys,s.overrides)}}e.Configuration=u;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,o=new Map;for(const d of r)d.keys.forEach(k=>s.add(k)),d.overrides.forEach(([k,I])=>{const c=(0,T.getOrSet)(o,k,new Set);I.forEach(S=>c.add(S))});const g=[];return o.forEach((d,k)=>g.push([k,[...d.values()]])),{keys:[...s.values()],overrides:g}}e.mergeChanges=v;class _{constructor(s,o,g,d){this.change=s,this.previous=o,this.currentConfiguraiton=g,this.currentWorkspace=d,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const k of s.keys)this.affectedKeys.add(k);for(const[,k]of s.overrides)for(const I of k)this.affectedKeys.add(I);this._affectsConfigStr=this._marker;for(const k of this.affectedKeys)this._affectsConfigStr+=k+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,o){const g=this._marker+s,d=this._affectsConfigStr.indexOf(g);if(d<0)return!1;const k=d+g.length;if(k>=this._affectsConfigStr.length)return!1;const I=this._affectsConfigStr.charCodeAt(k);if(I!==this._markerCode1&&I!==this._markerCode2)return!1;if(o){const c=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.previous?.workspace):void 0,S=this.currentConfiguraiton.getValue(s,o,this.currentWorkspace);return!l.equals(c,S)}return!0}}e.ConfigurationChangeEvent=_;function m(r,s){const{added:o,removed:g,updated:d}=n(s?.rawConfiguration,r?.rawConfiguration),k=[],I=r?.getAllOverrideIdentifiers()||[],c=s?.getAllOverrideIdentifiers()||[];if(s){const S=c.filter(b=>!I.includes(b));for(const b of S)k.push([b,s.getKeysForOverrideIdentifier(b)])}if(r){const S=I.filter(b=>!c.includes(b));for(const b of S)k.push([b,r.getKeysForOverrideIdentifier(b)])}if(s&&r){for(const S of I)if(c.includes(S)){const b=n({contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)},{contents:s.getOverrideValue(void 0,S)||{},keys:s.getKeysForOverrideIdentifier(S)});k.push([S,[...b.added,...b.removed,...b.updated]])}}return{added:o,removed:g,updated:d,overrides:k}}function n(r,s){const o=r?s?r.keys.filter(k=>s.keys.indexOf(k)===-1):[...r.keys]:[],g=s?r?s.keys.filter(k=>r.keys.indexOf(k)===-1):[...s.keys]:[],d=[];if(r&&s){for(const k of s.keys)if(r.keys.indexOf(k)!==-1){const I=(0,A.getConfigurationValue)(s.contents,k),c=(0,A.getConfigurationValue)(r.contents,k);l.equals(I,c)||d.push(k)}}return{added:o,removed:g,updated:d}}}),define(Te[97],Ae([1,0,11,4]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class F{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=F;class T{constructor(D,a){this.host=D,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var l;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class y extends w.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof y&&D._code===l.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof y&&D._code===l.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof y&&D._code===l.NoResolverFound}static isInvalidAuthority(D){return D instanceof y&&D._code===l.InvalidAuthority}static isHandled(D){return D instanceof y&&D.isHandled}constructor(D,a=l.Unknown,E){super(D),this._message=D,this._code=a,this._detail=E,this.isHandled=a===l.NotAvailable&&E===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function f(A){const D=A.indexOf("+");return D===-1?A:A.substring(0,D)}e.getRemoteAuthorityPrefix=f}),define(Te[54],Ae([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(f){return f.scheme===w.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=R;function P(f){if(!f)return;const A=f.indexOf("+");return A<0?f:f.substr(0,A)}e.getRemoteName=P;function F(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.getRemoteServerRootPath=F;function T(f){const{host:A,port:D}=y(f);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:D}}e.parseAuthorityWithPort=T;function l(f,A){let{host:D,port:a}=y(f);return typeof a>"u"&&(a=A),{host:D,port:a}}e.parseAuthorityWithOptionalPort=l;function y(f){const A=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const D=f.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const a=f.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:f,port:void 0}}}),define(Te[21],Ae([1,0,16,4,54]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function F(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(T||(e.ExtensionType=T={}));var l;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.LINUX_PPC64LE="linux-ppc64le",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class y{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const u=typeof t=="string"?t:t.value,v=typeof i=="string"?i:i.value;return w.equalsIgnoreCase(u,v)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=y;class f{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const i of t)this.add(i)}add(t){this._set.add(y.toKey(t))}delete(t){return this._set.delete(y.toKey(t))}has(t){return this._set.has(y.toKey(t))}}e.ExtensionIdentifierSet=f;class A{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(y.toKey(t))}get(t){return this._map.get(y.toKey(t))}has(t){return this._map.has(y.toKey(t))}set(t,i){this._map.set(y.toKey(t),i)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=A;function D(h){return a(h)}e.isApplicationScopedExtension=D;function a(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=a;function E(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function p(h,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.getRemoteName)(t)}`;return!!h.activationEvents?.includes(i)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Te[98],Ae([1,0,11,21]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class P{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,l){this._generators.set(T,l)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const l=Object.create(null);for(const y of T){const f=this.readActivationEvents(y);f.length>0&&(l[R.ExtensionIdentifier.toKey(y.identifier)]=f)}return l}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const l=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return l;for(const y in T.contributes){const f=this._generators.get(y);if(!f)continue;const A=T.contributes[y],D=Array.isArray(A)?A:[A];try{f(D,l)}catch(a){(0,w.onUnexpectedError)(a)}}return l}}e.ImplicitActivationEventsImpl=P,e.ImplicitActivationEvents=new P}),define(Te[179],Ae([1,0,23,73,36]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function F(y){if(w.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function T(y,f,A,D,a,E,p,h,t){const i=Object.create(null);i["common.machineId"]=E,i["common.sqmId"]=p,i.sessionID=(0,P.generateUuid)()+Date.now(),i.commitHash=D,i.version=a,i["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,w.PlatformToString)(w.platform),i["common.nodePlatform"]=R.platform,i["common.nodeArch"]=A,i["common.product"]=t||"desktop",h&&(i["common.msftInternal"]=h);let u=0;const v=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),w.isLinuxSnap&&(i["common.snap"]="true");const _=F(f);return _&&(i["common.platformDetail"]=_),i}e.resolveCommonProperties=T;function l(y){const f=R.env.USERDNSDOMAIN;if(!f)return!1;const A=f.toLowerCase();return y.some(D=>A===D)}e.verifyMicrosoftInternalDomain=l}),define(Te[180],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var P;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Te[55],Ae([1,0,25,15,5,45,54,179,180]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class f{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=f;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class D{async publicLog(g,d,k){}async publicLogError(g,d,k){}}e.NullEndpointTelemetryService=D,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,g){return P.Event.debounce(g.onDidChangeConfiguration,(k,I)=>{const c=k?new Set([...k.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:c}},1e3,!0)(k=>{k.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.configurationTelemetry=a;function E(o,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!o.enableTelemetry)}e.supportsTelemetry=E;function p(o,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=p;function h(o){const g=o.getValue(y.TELEMETRY_SETTING_ID),d=o.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=h;function t(o){const g={},d={},k={};v(o,k);for(let I in k){I=I.length>150?I.substr(I.length-149):I;const c=k[I];typeof c=="number"?d[I]=c:typeof c=="boolean"?d[I]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${c.length}`),g[I]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(g[I]=c)}return{properties:g,measurements:d}}e.validateTelemetryData=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(o){if(!o)return"none";const g=(0,T.getRemoteName)(o);return i.has(g)?g:"other"}e.cleanRemoteAuthority=u;function v(o,g,d=0,k){if(o)for(const I of Object.getOwnPropertyNames(o)){const c=o[I],S=k?k+I:I;Array.isArray(c)?g[S]=(0,w.safeStringify)(c):c instanceof Date?g[S]=c.toISOString():(0,R.isObject)(c)?d<2?v(c,g,d+1,S+"."):g[S]=(0,w.safeStringify)(c):g[S]=c}}function _(o,g){const d=o.msftInternalDomains||[],k=g.getValue("telemetry.internalTesting");return(0,l.verifyMicrosoftInternalDomain)(d)||k}e.isInternalTelemetry=_;function m(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=m;function n(o,g){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const k=[];for(const b of g)for(;;){const C=b.exec(o);if(!C)break;k.push([C.index,b.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(d="";;){const b=c.exec(o);if(!b)break;const C=k.some(([$,N])=>b.index<N&&$<c.lastIndex);!I.test(b[0])&&!C&&(d+=o.substring(S,b.index)+"<REDACTED: user-file-path>",S=c.lastIndex)}return S<o.length&&(d+=o.substr(S)),d}function r(o){if(!o)return o;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of g)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function s(o,g){return(0,w.cloneAndChange)(o,d=>{if(d instanceof f||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let k=d.replaceAll("%20"," ");k=n(k,g);for(const I of g)k=k.replace(I,"");return k=r(k),k}})}e.cleanData=s}),define(Te[181],Ae([1,0,16,92,21,23,2,11,73,55]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,w.compareIgnoreCase)(s.id,o.id)===0}e.areSameExtensions=A;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const g=o.manifest?o.manifest.version:o.version,d=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,g,d)}static parse(o){const g=D.exec(o);return g&&g[1]&&g[2]?new a({id:g[1]},g[2],g[4]||void 0):null}constructor(o,g,d="undefined"){this.version=g,this.targetPlatform=d,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?A(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=a;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(s){const o=E.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.getIdAndVersion=p;function h(s,o){return`${s}.${o}`}e.getExtensionId=h;function t(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=t;function i(s,o){return t(h(s??P.UNDEFINED_PUBLISHER,o))}e.getGalleryExtensionId=i;function u(s,o){const g=[],d=k=>{for(const I of g)if(I.some(c=>A(o(c),o(k))))return I;return null};for(const k of s){const I=d(k);I?I.push(k):g.push([k])}return g}e.groupByExtension=u;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function _(s){return{id:new f.TelemetryTrustedValue(s.identifier.id),name:new f.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function m(s,o){const g=[],d=o.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const k=d.shift();if(k&&g.every(I=>!A(I.identifier,{id:k}))){const I=s.filter(c=>A(c.identifier,{id:k}));I.length===1&&(g.push(I[0]),d.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=m;async function n(s,o){if(!F.isLinux)return!1;let g;try{g=(await s.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await s.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){o.debug("Error while getting the os-release file.",(0,l.getErrorMessage)(k))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,o){const g=await n(s,o),d=(0,R.getTargetPlatform)(g?"alpine":F.platform,y.arch);return o.debug("ComputeTargetPlatform:",d),d}e.computeTargetPlatform=r}),define(Te[182],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function w(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=w;function R(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=R;function P(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=P;function F(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=F;function T(y){return Array.from(y.entries()).map(f=>[f[0],w(f[1].map),R(f[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function l(y){return new Map(y.map(f=>[f[0],{map:P(f[1]),descriptionMap:F(f[2])}]))}e.deserializeEnvironmentVariableCollections=l}),define(Te[183],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,F,T=5){const l=F(y=>{const f=typeof y=="string"?y:y.data;let A=this._terminalBufferMap.get(P);if(A){A.data.push(f);return}const D=setTimeout(()=>this.flushBuffer(P),T);A={data:[f],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(P),l.dispose()}},this._terminalBufferMap.set(P,A)});return l}stopBuffering(P){this._terminalBufferMap.get(P)?.dispose()}flushBuffer(P){const F=this._terminalBufferMap.get(P);F&&(this._terminalBufferMap.delete(P),this._callback(P,F.data.join("")))}}e.TerminalDataBufferer=w}),define(Te[184],Ae([1,0,12,89,43,5,15,2,144,72,30]),function(be,e,w,R,P,F,T,l,y,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var D;(function(_){function m(n,r){let s=n.defaults;for(;P.ThemeIcon.isThemeIcon(s);){const o=p.getIcon(s.id);if(!o)return;s=o.defaults}return s}_.getDefinition=m})(D||(e.IconContribution=D={}));var a;(function(_){function m(r){return{weight:r.weight,style:r.style,src:r.src.map(s=>({format:s.format,location:s.location.toString()}))}}_.toJSONObject=m;function n(r){const s=o=>(0,T.isString)(o)?o:void 0;if(r&&Array.isArray(r.src)&&r.src.every(o=>(0,T.isString)(o.format)&&(0,T.isString)(o.location)))return{weight:s(r.weight),style:s(r.style),src:r.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}_.fromJSONObject=n})(a||(e.IconFontDefinition=a={}));class E{constructor(){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,n,r,s){const o=this.iconsById[m];if(o){if(r&&!o.description){o.description=r,this.iconSchema.properties[m].markdownDescription=`${r} $(${m})`;const k=this.iconReferenceSchema.enum.indexOf(m);k!==-1&&(this.iconReferenceSchema.enumDescriptions[k]=r),this._onDidChange.fire()}return o}const g={id:m,description:r,defaults:n,deprecationMessage:s};this.iconsById[m]=g;const d={$ref:"#/definitions/icons"};return s&&(d.deprecationMessage=s),r&&(d.markdownDescription=`${r}: $(${m})`),this.iconSchema.properties[m]=d,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(r||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const n=this.iconReferenceSchema.enum.indexOf(m);n!==-1&&(this.iconReferenceSchema.enum.splice(n,1),this.iconReferenceSchema.enumDescriptions.splice(n,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,n){const r=this.iconFontsById[m];return r||(this.iconFontsById[m]=n,this._onDidChange.fire(),n)}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(o,g)=>o.id.localeCompare(g.id),n=o=>{for(;P.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of s.filter(g=>!!g.description).sort(m))r.push(`|<i class="${n(o)}"></i>|${o.id}|${P.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const o of s.filter(g=>!P.ThemeIcon.isThemeIcon(g.defaults)).sort(m))r.push(`|<i class="${n(o)}"></i>|${o.id}|`);return r.join(`
`)}}const p=new E;A.Registry.add(e.Extensions.IconContribution,p);function h(_,m,n,r){return p.registerIcon(_,m,n,r)}e.registerIcon=h;function t(){return p}e.getIconRegistry=t;function i(){const _=(0,R.getCodiconFontCharacters)();for(const m in _){const n="\\"+_[m].toString(16);p.registerIcon(m,{fontCharacter:n})}}i(),e.iconsSchemaId="vscode://schemas/icons";const u=A.Registry.as(f.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,p.getIconSchema());const v=new w.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);p.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=h("widget-close",R.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=h("goto-previous-location",R.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=h("goto-next-location",R.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=P.ThemeIcon.modify(R.Codicon.sync,"spin"),e.spinningLoading=P.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(Te[185],Ae([1,0,5,45,4,14]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var T;(function(t){t.Http="http",t.Https="https"})(T||(e.TunnelProtocol=T={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function y(t){return!!t.forwardPort}e.isTunnelProvider=y;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=a;function E(t,i,u,v){if(u===1)return!1;if(u===2&&a(i)){const _=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(_?.length===4&&parseInt(_[1])>=18)return!1}return t<1024}e.isPortPrivileged=E;class p{constructor(i,u,v){this.remoteAddress=i,this.localAddress=u,this._dispose=v,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=p;let h=class{constructor(i,u){this.logService=i,this.configurationService=u,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],u=Array.from(this._tunnels.values());for(const v of u){const _=Array.from(v.values());for(const m of _){const n=await m.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:u}of i.values())await u.then(v=>typeof v!="string"?v?.dispose():void 0);i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,u,v,_,m){this.addTunnelToMap(i,u,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:u,localAddress:v,privacy:_,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,u){(a(i)||D(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const v=this.getTunnelFromMap(i,u);if(v)return++v.refcount,v.value}openTunnel(i,u,v,_,m,n=!1,r,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${v} on local port ${m}.`);const o=this._tunnelProvider??i;if(!o)return;if(u||(u="localhost"),_||(_=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.retainOrCreateTunnel(o,u,v,_,m,n,r,s);return g?g.then(d=>{if(d){if(typeof d=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(u,v),d}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(u,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.makeTunnel(d);return(d.tunnelRemoteHost!==u||d.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&d.privacy!==r&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(k),k}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const u=this._tunnels.get(i.tunnelRemoteHost);if(u){const v=u.get(i.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,v))}}}}async tryDisposeTunnel(i,u,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${u}.`);const _=v.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(u),_}}async closeTunnel(i,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${u} `);const v=this._tunnels.get(i);if(v&&v.has(u)){const _=v.get(u);_.refcount=0,await this.tryDisposeTunnel(i,u,_)}}addTunnelToMap(i,u,v){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(u,{refcount:1,value:v})}async removeEmptyOrErrorTunnelFromMap(i,u){const v=this._tunnels.get(i);if(v){const _=v.get(u),m=_?await _.value:void 0;(!m||typeof m=="string")&&v.delete(u),v.size===0&&this._tunnels.delete(i)}}getTunnelFromMap(i,u){const v=[i];D(i)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):a(i)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const _=v.map(m=>this._tunnels.get(m));for(const m of _){const n=m?.get(u);if(n)return n}}canTunnel(i){return!!A(i)}createWithProvider(i,u,v,_,m,n,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${v} on local port ${_}.`);const s=v;this._factoryInProgress.add(s);const o=_===void 0?v:_,g={elevationRequired:m?this.isPortPrivileged(o):!1},d={remoteAddress:{host:u,port:v},localAddressPort:_,privacy:n,public:n?n!==l.Private:void 0,protocol:r},k=i.forwardPort(d,g);return k?(this.addTunnelToMap(u,v,k),k.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),k}};e.AbstractTunnelService=h,e.AbstractTunnelService=h=Ve([He(0,F.ILogService),He(1,R.IConfigurationService)],h)}),define(Te[186],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,w.createDecorator)("editSessionIdentityService");var R;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Te[187],Ae([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function R(y){return y.scheme!==w.Schemas.file&&y.scheme!==w.Schemas.vscodeRemote}e.isVirtualResource=R;function P(y){if(y.folders.length)return y.folders.every(f=>R(f.uri))?y.folders[0].uri:void 0;if(y.configuration&&R(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=P;function F(y){return P(y)?.scheme}e.getVirtualWorkspaceScheme=F;function T(y){return P(y)?.authority}e.getVirtualWorkspaceAuthority=T;function l(y){return P(y)!==void 0}e.isVirtualWorkspace=l}),define(Te[56],Ae([1,0,145,20,50,24,2,4,13]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,l.createDecorator)("contextService");function f(o){const g=o;return typeof g?.id=="string"&&T.URI.isUri(g.uri)}e.isSingleFolderWorkspaceIdentifier=f;function A(o){return typeof o?.id=="string"&&!f(o)&&!a(o)}e.isEmptyWorkspaceIdentifier=A,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(o,g){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,R.basename)(o)}:g?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const d=o;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.toWorkspaceIdentifier=D;function a(o){const g=o;return typeof g?.id=="string"&&T.URI.isUri(g.configPath)}e.isWorkspaceIdentifier=a;function E(o){const g=o;if(g?.uri)return{id:g.id,uri:T.URI.revive(g.uri)};const d=o;if(d?.configPath)return{id:d.id,configPath:T.URI.revive(d.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=E;var p;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function h(o){const g=o;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=h;function t(o){const g=o;return!!(g&&typeof g=="object"&&T.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=t;class i{constructor(g,d,k,I,c){this._id=g,this._transient=k,this._configuration=I,this._ignorePathCasing=c,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(g){this._id=g.id,this._configuration=g.configuration,this._transient=g.transient,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=i;class u{constructor(g,d){this.raw=d,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,F.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function v(o){return new u({uri:o,index:0,name:(0,F.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(o,g){return F.extUriBiasedIgnorePathCase.isEqualOrParent(o,g.untitledWorkspacesHome)}e.isUntitledWorkspace=_;function m(o){let g;return T.URI.isUri(o)?g=o:g=o.configuration,g?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=m,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function r(o,g){return!_(o,g)&&!m(o)}e.isSavedWorkspace=r;function s(o){return(typeof o=="string"?(0,R.extname)(o):(0,F.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Te[74],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{static{this.enableDebugLogging=!1}constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const F=this._idPool++;return this._data.set(F,P),this.logDebugInfo(),F}get(P,F){return this._data.has(P)?this._data.get(P)[F]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){w.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=w}),define(Te[40],Ae([1,0,13,24,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class F{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map,this.extUri=new R.ExtUri(l=>{const y=this._providerInfo.get(l.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(l,y){y===null?this._providerInfo.delete(l.scheme):this._providerInfo.set(l.scheme,y)}isFreeScheme(l){return!this._providerInfo.has(l)&&!this._systemSchemes.has(l)}getCapabilities(l){return this._providerInfo.get(l)}}e.ExtHostFileSystemInfo=F,e.IExtHostFileSystemInfo=(0,P.createDecorator)("IExtHostFileSystemInfo")}),define(Te[27],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(Te[188],Ae([1,0,151,14,175,27]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends P.LogService{constructor(y,f,A){const D=A.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",a=A.remote.isRemote?(0,w.localize)(0,null):y?(0,w.localize)(1,null):(0,w.localize)(2,null);super(f.createLogger(D,{name:a}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=Ve([He(1,R.ILoggerService),He(2,F.IExtHostInitDataService)],T)}),define(Te[189],Ae([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(T,l,y){this._deferredPromises=new Map,this._id=T,this._shared=l,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(f=>(this._value=f,this)),this._storageListener=this._storage.onDidChangeStorage(f=>{f.shared===this._shared&&f.key===this._id&&(this._value=f.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const f=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of f.values())A.complete()}catch(A){for(const D of f.values())D.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,l){let y=this._value[T];return typeof y>"u"&&(y=l),y}update(T,l){this._value[T]=l;const y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const f=new w.DeferredPromise;return this._deferredPromises.set(T,f),this._scheduler.isScheduled()||this._scheduler.schedule(),f.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class P extends R{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,l){super(T.identifier.value,!0,l),this._extension=T}}e.ExtensionGlobalMemento=P}),define(Te[190],Ae([1,0,5,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class P{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new w.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new w.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,l,y,f){const D=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(T)).acceptModelChanged(l.value,y,f);this._onDidChangeNotebookDocument.fire(D)}$acceptDirtyStateChanged(T,l){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(T)).acceptDirty(l)}$acceptModelSaved(T){const l=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(T));this._onDidSaveNotebookDocument.fire(l.apiNotebook)}}e.ExtHostNotebookDocuments=P}),define(Te[17],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class R{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.ExtHostRpcService=R}),define(Te[191],Ae([1,0,21,5]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{#e;constructor(T,l){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(T.identifier),this.#e=l,this.#e.onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(T){return this.#e.get(this._id,T)}store(T,l){return this.#e.store(this._id,T,l)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=P}),define(Te[57],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class R{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=R}),define(Te[192],Ae([1,0,26]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let f=this.buffers.indexOf(y);return f<0&&(f=this.buffers.length,this.buffers.push(y)),f}}function P(l,y){if(y.serializeBuffersForPostMessage){const f=new R,D=JSON.stringify(l,(E,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add(p)};if(ArrayBuffer.isView(p)){const h=F(p);if(h)return{$$vscode_array_buffer_reference$$:!0,index:f.add(p.buffer),view:{type:h,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),a=f.buffers.map(E=>{const p=new Uint8Array(E);return w.VSBuffer.wrap(p)});return{message:D,buffers:a}}else return{message:JSON.stringify(l),buffers:[]}}e.serializeWebviewMessage=P;function F(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(l,y){const f=y.map(a=>{const E=new ArrayBuffer(a.byteLength);return new Uint8Array(E).set(a.buffer),E}),A=y.length?(a,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const p=E,{index:h}=p,t=f[h];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return E}:void 0;return{message:JSON.parse(l,A),arrayBuffers:f}}e.deserializeWebviewMessage=T}),define(Te[99],Ae([1,0,160,15,2,6,4,30,39,13,37,127,29]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var p;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function h(ae){const we=ae;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.isEditorPaneWithSelection=h;function t(ae,we,Z){for(const z of Z.visibleEditorPanes)if(z.group.id===we&&ae.matches(z.input))return z.getViewState()}e.findViewStateForEditor=t;function i(ae){if(d(ae))return!1;const we=ae;return P.URI.isUri(we?.resource)}e.isResourceEditorInput=i;function u(ae){if(d(ae))return!1;const we=ae;return we?.original!==void 0&&we.modified!==void 0}e.isResourceDiffEditorInput=u;function v(ae){if(d(ae)||u(ae))return!1;const we=ae;return we?.primary!==void 0&&we.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function _(ae){if(d(ae))return!1;const we=ae;return we?we.resource===void 0||we.resource.scheme===f.Schemas.untitled||we.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;function m(ae){if(d(ae))return!1;const we=ae;return P.URI.isUri(we?.base?.resource)&&P.URI.isUri(we?.input1?.resource)&&P.URI.isUri(we?.input2?.resource)&&P.URI.isUri(we?.result?.resource)}e.isResourceMergeEditorInput=m;var n;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var r;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(we,Z){let z=this.mapIdToSaveSource.get(we);return z||(z={source:we,label:Z},this.mapIdToSaveSource.set(we,z)),z.source}getSourceLabel(we){return this.mapIdToSaveSource.get(we)?.label??we}}e.SaveSourceRegistry=new s;var o;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad",ae[ae.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(o||(e.EditorInputCapabilities=o={}));class g extends F.Disposable{}e.AbstractEditorInput=g;function d(ae){return ae instanceof g}e.isEditorInput=d;function k(ae){const we=ae;return P.URI.isUri(we?.preferredResource)}function I(ae){const we=ae;return d(we?.primary)&&d(we?.secondary)}e.isSideBySideEditorInput=I;function c(ae){const we=ae;return d(we?.modified)&&d(we?.original)}e.isDiffEditorInput=c;function S(ae,we,Z,z,Y){return le(z,[(0,D.toAction)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ee={...Z,limits:{size:Number.MAX_VALUE}};ae.openEditor(we,ee)}}),(0,D.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>Y.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.createTooLargeFileError=S;function b(ae){return d(ae?.editor)}e.isEditorInputWithOptions=b;function C(ae){const we=ae;return b(ae)&&we?.group!==void 0}e.isEditorInputWithOptionsAndGroup=C;function $(ae){const we=ae;return typeof we?.groupId=="number"&&d(we.editor)}e.isEditorIdentifier=$;var N;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var H;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LABEL=2]="GROUP_LABEL",ae[ae.GROUP_LOCKED=3]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=4]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=5]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=6]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=8]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=10]="EDITOR_PIN",ae[ae.EDITOR_STICKY=11]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=12]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(H||(e.GroupModelChangeKind=H={}));var B;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class L{getOriginalUri(we,Z){if(!we)return;if(m(we))return e.EditorResourceAccessor.getOriginalUri(we.result,Z);if(Z?.supportSideBySide){const{primary:Y,secondary:ee}=this.getSideEditors(we);if(Y&&ee){if(Z?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Y,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===B.ANY)return this.getOriginalUri(Y,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:Z.filterByScheme});we=Z.supportSideBySide===B.PRIMARY?Y:ee}}if(u(we)||v(we)||m(we))return;const z=k(we)?we.preferredResource:we.resource;return!z||!Z||!Z.filterByScheme?z:this.filterUri(z,Z.filterByScheme)}getSideEditors(we){return I(we)||v(we)?{primary:we.primary,secondary:we.secondary}:c(we)||u(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,Z){if(!we)return;if(m(we))return e.EditorResourceAccessor.getCanonicalUri(we.result,Z);if(Z?.supportSideBySide){const{primary:Y,secondary:ee}=this.getSideEditors(we);if(Y&&ee){if(Z?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Y,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===B.ANY)return this.getCanonicalUri(Y,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:Z.filterByScheme});we=Z.supportSideBySide===B.PRIMARY?Y:ee}}if(u(we)||v(we)||m(we))return;const z=we.resource;return!z||!Z||!Z.filterByScheme?z:this.filterUri(z,Z.filterByScheme)}filterUri(we,Z){if(Array.isArray(Z)){if(Z.some(z=>we.scheme===z))return we}else if(Z===we.scheme)return we}}var U;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(U||(e.EditorCloseMethod=U={}));function ie(ae,we,Z,z){if(!ae.isSticky(we))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return Z===U.MOUSE||Z===U.KEYBOARD;case"mouse":return Z===U.MOUSE;case"keyboard":return Z===U.KEYBOARD}return!1}e.preventEditorClose=ie,e.EditorResourceAccessor=new L;var X;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class ye{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(we){const Z=this.instantiationService=we.get(T.IInstantiationService);for(const[z,Y]of this.editorSerializerConstructors)this.createEditorSerializer(z,Y,Z);this.editorSerializerConstructors.clear()}createEditorSerializer(we,Z,z){const Y=z.createInstance(Z);this.editorSerializerInstances.set(we,Y)}registerFileEditorFactory(we){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=we}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(we,Z){if(this.editorSerializerConstructors.has(we)||this.editorSerializerInstances.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.instantiationService?this.createEditorSerializer(we,Z,this.instantiationService):this.editorSerializerConstructors.set(we,Z),(0,F.toDisposable)(()=>{this.editorSerializerConstructors.delete(we),this.editorSerializerInstances.delete(we)})}getEditorSerializer(we){return this.editorSerializerInstances.get(typeof we=="string"?we:we.typeId)}}l.Registry.add(e.EditorExtensions.EditorFactory,new ye);async function Pe(ae,we,Z){return!ae||!ae.length?[]:await Promise.all(ae.map(async z=>{const Y=P.URI.revive(z.fileUri);if(!Y){Z.info("Cannot resolve the path because it is not valid.",z);return}if(!await we.canHandleResource(Y)){Z.info("Cannot resolve the path because it cannot be handled",z);return}let ve=z.exists,ge=z.type;if(typeof ve!="boolean"||typeof ge!="number")try{ge=(await we.stat(Y)).isDirectory?y.FileType.Directory:y.FileType.Unknown,ve=!0}catch(_e){Z.error(_e),ve=!1}if(!ve&&z.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",z);return}if(ge===y.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",z);return}const de={...z.options,pinned:!0};return ve?{resource:Y,options:de}:{resource:Y,options:de,forceUntitled:!0}}))}e.pathsToEditors=Pe;var De;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(De||(e.EditorsOrder=De={}));function pe(ae){const we=ae;if(!we)return!1;const Z=we;if(Z.modified)return pe(Z.modified);const z=we;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.isTextEditorViewState=pe;function Se(ae){return(0,A.isErrorWithActions)(ae)}e.isEditorOpenError=Se;function le(ae,we,Z){const z=(0,A.createErrorWithActions)(ae,we);return z.forceMessage=Z?.forceMessage,z.forceSeverity=Z?.forceSeverity,z.allowDialog=Z?.allowDialog,z}e.createEditorOpenError=le}),define(Te[193],Ae([1,0,5,161,4,6,28,30,18,25,89,184]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,R.localize)(0,null),e.defaultViewIcon=(0,D.registerIcon)("default-view-icon",A.Codicon.window,(0,R.localize)(1,null));var a;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var E;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.ViewContainerLocations=[0,1,2];function p(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;class h extends F.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(s,o,g){const d=this.get(s.id);if(d)return d;const k=s;return k.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,T.getOrSet)(this.viewContainers,o,[]).push(k),g?.isDefault&&this.defaultViewContainers.push(k),this._onDidRegister.fire({viewContainer:k,viewContainerLocation:o}),k}deregisterViewContainer(s){for(const o of this.viewContainers.keys()){const g=this.viewContainers.get(o),d=g?.indexOf(s);if(d!==-1){g?.splice(d,1),g.length===0&&this.viewContainers.delete(o),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:o});return}}}get(s){return this.all.filter(o=>o.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(o=>this.getViewContainers(o).filter(g=>g?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(o=>this.getViewContainerLocation(o)===s)}}l.Registry.add(a.ViewContainersRegistry,new h);var t;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(r,s){const o=r.group??t.More,g=s.group??t.More;return o!==g?o.localeCompare(g):(r.order??5)-(s.order??5)}class u extends F.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(s,o){this.registerViews2([{views:s,viewContainer:o}])}registerViews2(s){s.forEach(({views:o,viewContainer:g})=>this.addViews(o,g)),this._onViewsRegistered.fire(s)}deregisterViews(s,o){const g=this.removeViews(s,o);g.length&&this._onViewsDeregistered.fire({views:g,viewContainer:o})}moveViews(s,o){for(const g of this._views.keys())if(g!==o){const d=this.removeViews(s,g);d.length&&(this.addViews(d,o),this._onDidChangeContainer.fire({views:d,from:g,to:o}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const o of this._viewContainers){const g=(this._views.get(o)||[]).filter(d=>d.id===s)[0];if(g)return g}return null}getViewContainer(s){for(const o of this._viewContainers)if((this._views.get(o)||[]).filter(d=>d.id===s)[0])return o;return null}registerViewWelcomeContent(s,o){return this._viewWelcomeContents.add(s,o),this._onDidChangeViewWelcomeContent.fire(s),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(s,o),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,o){const g=new Map;for(const[d,k]of o)this._viewWelcomeContents.add(s,k),g.set(d,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(s,k),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),g}getViewWelcomeContent(s){const o=[];return this._viewWelcomeContents.forEach(s,g=>o.push(g)),o.sort(i)}addViews(s,o){let g=this._views.get(o);g||(g=[],this._views.set(o,g),this._viewContainers.push(o));for(const d of s){if(this.getView(d.id)!==null)throw new Error((0,R.localize)(2,null,d.id));g.push(d)}}removeViews(s,o){const g=this._views.get(o);if(!g)return[];const d=[],k=[];for(const I of g)s.includes(I)?d.push(I):k.push(I);return d.length&&(k.length?this._views.set(o,k):(this._views.delete(o),this._viewContainers.splice(this._viewContainers.indexOf(o),1))),d}}l.Registry.add(a.ViewsRegistry,new u),e.IViewsService=(0,P.createDecorator)("viewsService"),e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var v;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(v||(e.ViewVisibilityState=v={}));var _;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(_||(e.TreeItemCollapsibleState=_={}));class m{constructor(s,o){this.resolved=!1,this._hasResolve=!1,(0,f.mixin)(this,s),this._hasResolve=!!o,this.resolve=async g=>{if(o&&!this.resolved){const d=await o(g);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}g.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=m;class n extends Error{constructor(s){super((0,R.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=n}),define(Te[194],Ae([1,0,2,41,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChatService=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.isIUsedContext=e.isIDocumentContext=void 0;function F(f){return!!f&&typeof f=="object"&&"uri"in f&&f.uri instanceof w.URI&&"version"in f&&typeof f.version=="number"&&"ranges"in f&&Array.isArray(f.ranges)&&f.ranges.every(R.Range.isIRange)}e.isIDocumentContext=F;function T(f){return!!f&&typeof f=="object"&&"documents"in f&&Array.isArray(f.documents)&&f.documents.every(F)}e.isIUsedContext=T;var l;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(l||(e.InteractiveSessionVoteDirection=l={}));var y;(function(f){f[f.Action=1]="Action",f[f.Toolbar=2]="Toolbar"})(y||(e.InteractiveSessionCopyKind=y={})),e.IChatService=(0,P.createDecorator)("IChatService")}),define(Te[195],Ae([1,0,5,12,162]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class F{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(l){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=l}onEvent(l){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=l}onRequest(l){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=l}sendResponse(l){l.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.internalSend("response",l)}sendRequest(l,y,f,A){const D={command:l};if(y&&Object.keys(y).length>0&&(D.arguments=y),this.internalSend("request",D),typeof A=="number"){const a=setTimeout(()=>{clearTimeout(a);const E=this.pendingRequests.get(D.seq);if(E){this.pendingRequests.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:l,message:(0,P.localize)(0,null,A,l)};E(p)}},A)}return f&&this.pendingRequests.set(D.seq,f),D.seq}acceptMessage(l){this.messageCallback?this.messageCallback(l):(this.queue.push(l),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(l,y){return l.type!=="event"||y.type!=="event"}async processQueue(){let l;for(;this.queue.length;){if((!l||this.needsTaskBoundaryBetween(this.queue[0],l))&&await(0,R.timeout)(0),l=this.queue.shift(),!l)return;switch(l.type){case"event":this.eventCallback?.(l);break;case"request":this.requestCallback?.(l);break;case"response":{const y=l,f=this.pendingRequests.get(y.request_seq);f&&(this.pendingRequests.delete(y.request_seq),f(y));break}}}}internalSend(l,y){y.type=l,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const l=new Map;this.pendingRequests.forEach((y,f)=>l.set(f,y)),await(0,R.timeout)(500),l.forEach((y,f)=>{y({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(f)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=F}),define(Te[196],Ae([1,0,163,32,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new R.RawContextKey("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new R.RawContextKey("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new R.RawContextKey("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new R.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:w.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new R.RawContextKey("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new R.RawContextKey("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new R.RawContextKey("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new R.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new R.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new R.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new R.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new R.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new R.RawContextKey("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new R.RawContextKey("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new R.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new R.RawContextKey("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new R.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new R.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new R.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new R.RawContextKey("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new R.RawContextKey("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new R.RawContextKey("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new R.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new R.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new R.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new R.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new R.RawContextKey("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new R.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new R.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new R.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new R.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new R.RawContextKey("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new R.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new R.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new R.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new R.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new R.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new R.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new R.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new R.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new R.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new R.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new R.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new R.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new R.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new R.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new R.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new R.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new R.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new R.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new R.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const F=a=>w.localize(51,null,a);e.debuggerDisabledMessage=F,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var T;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(T||(e.State=T={}));function l(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=l;var y;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var f;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var A;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.IDebugService=(0,P.createDecorator)("debugService");var D;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Te[197],Ae([1,0,16,2,20,25,13,41,19,18]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function D(I,c,S){return I.replace(A,function(b,C){return c&&C.length>0&&C[0]!=="_"?b:S&&S.hasOwnProperty(C)?S[C]:b})}e.formatPII=D;function a(I){const c={};for(const S of Object.keys(I))S.startsWith("!")||(c[S]=I[S]);return c}e.filterExceptionsFromTelemetry=a;function E(I){return I.configuration.request==="attach"&&!p(I)&&(!I.parentSession||E(I.parentSession))}e.isSessionAttach=E;function p(I){let c=I.configuration.type;if(c)return c==="vslsShare"&&(c=I.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(c,"extensionhost")||(0,w.equalsIgnoreCase)(c,"pwa-extensionhost")?I:I.parentSession?p(I.parentSession):void 0}e.getExtensionHostDebugSession=p;function h(I){return I.type&&(I.label||I.program||I.runtime)}e.isDebuggerMainContribution=h;function t(I,c,S){let b,C=0;const $=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=$.exec(I);){const H=N.index+1,B=H+N[0].length;if(H<=c&&B>=S){b=N[0],C=H;break}}if(b){const H=/\w+/g;let B=null;for(;(B=H.exec(b))&&!(B.index+1+C+B[0].length>=S););B&&(b=b.substring(0,H.lastIndex))}return b?{start:C,end:C+b.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function i(I,c,S,b){if(I.evaluatableExpressionProvider.has(c)){const C=I.evaluatableExpressionProvider.ordered(c),$=(0,f.coalesce)(await Promise.all(C.map(async N=>{try{return await N.provideEvaluatableExpression(c,S,b??y.CancellationToken.None)}catch{return}})));if($.length>0){let N=$[0].expression;const H=$[0].range;return N||(N=c.getLineContent(S.lineNumber).substring(H.startColumn-1,H.endColumn-1)),{range:H,matchingExpression:N}}}else{const C=c.getLineContent(S.lineNumber),{start:$,end:N}=t(C,S.column,S.column),H=C.substring($-1,N);return{matchingExpression:H,range:new l.Range(S.lineNumber,$,S.lineNumber,$+H.length)}}return null}e.getEvaluatableExpressionAtPosition=i;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(I){return!!(I&&I.match(u))}e.isUri=v;function _(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(v(I.path))return R.URI.parse(I.path);if((0,P.isAbsolute)(I.path))return R.URI.file(I.path)}return I.path}function m(I){if(typeof I.path=="object"){const c=R.URI.revive(I.path);if(c)return c.scheme===T.Schemas.file?c.fsPath:c.toString()}return I.path}function n(I,c){const S=c?_:m,b=(0,F.deepClone)(I);return s(b,(C,$)=>{C&&$&&($.path=S($))}),b}e.convertToDAPaths=n;function r(I,c){const S=c?_:m,b=(0,F.deepClone)(I);return s(b,(C,$)=>{!C&&$&&($.path=S($))}),b}e.convertToVSCPaths=r;function s(I,c){switch(I.type){case"event":{const S=I;switch(S.event){case"output":c(!1,S.body.source);break;case"loadedSource":c(!1,S.body.source);break;case"breakpoint":c(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=I;switch(S.command){case"setBreakpoints":c(!0,S.arguments.source);break;case"breakpointLocations":c(!0,S.arguments.source);break;case"source":c(!0,S.arguments.source);break;case"gotoTargets":c(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(b=>c(!1,b));break;default:break}break}case"response":{const S=I;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(b=>c(!1,b.source));break;case"loadedSources":S.body.sources.forEach(b=>c(!1,b));break;case"scopes":S.body.scopes.forEach(b=>c(!1,b.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(b=>c(!1,b.source));break;case"setBreakpoints":S.body.breakpoints.forEach(b=>c(!1,b.source));break;case"disassemble":S.body?.instructions.forEach(C=>c(!1,C.location));break;default:break}break}}}function o(I){return I.filter(c=>!c.presentation?.hidden).sort((c,S)=>c.presentation?S.presentation?c.presentation.group?S.presentation.group?c.presentation.group!==S.presentation.group?c.presentation.group.localeCompare(S.presentation.group):g(c.presentation.order,S.presentation.order):-1:S.presentation.group?1:g(c.presentation.order,S.presentation.order):-1:S.presentation?1:0)}e.getVisibleAndSorted=o;function g(I,c){return typeof I!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:I-c}async function d(I,c){const S=I.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(S!=="none"&&(await c.saveAll(),S==="allEditorsInActiveGroup")){const b=c.activeEditorPane;b&&b.input.resource?.scheme===T.Schemas.untitled&&await c.save({editor:b.input,groupId:b.group.id})}await I.reloadConfiguration()}e.saveAllBeforeDebugStart=d;const k=(I,c)=>!I||!c?I===c:I.name===c.name&&I.path===c.path&&I.sourceReference===c.sourceReference;e.sourcesEqual=k}),define(Te[75],Ae([1,0,26,38,66,67,13,20,23,32]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var A;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(A||(e.CellKind=A={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var a;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var E;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(E||(e.NotebookExecutionState=E={}));var p;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var h;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(h||(e.RendererMessagingSpec=h={}));var t;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var u;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var v;(function(U){U.scheme=T.Schemas.vscodeNotebookCell;const ie=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ie.join("")}]+`),ye=7;function Pe(we,Z){const z=Z.toString(ye),ee=`${z.length<ie.length?ie[z.length-1]:"z"}${z}s${(0,w.encodeBase64)(w.VSBuffer.fromString(we.scheme),!0,!0)}`;return we.with({scheme:U.scheme,fragment:ee})}U.generate=Pe;function De(we){if(we.scheme!==U.scheme)return;const Z=we.fragment.indexOf("s");if(Z<0)return;const z=parseInt(we.fragment.substring(0,Z).replace(X,""),ye),Y=(0,w.decodeBase64)(we.fragment.substring(Z+1)).toString();if(!isNaN(z))return{handle:z,notebook:we.with({scheme:Y,fragment:null})}}U.parse=De;function pe(we,Z){return we.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${we.scheme!==T.Schemas.file?we.scheme:""}`})}U.generateCellOutputUri=pe;function Se(we){if(we.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!Z)return;const z=Z[1]&&Z[1]!==""?Z[1]:void 0,Y=Z[2];return{outputId:z,notebook:we.with({scheme:Y||T.Schemas.file,fragment:null})}}U.parseCellOutputUri=Se;function le(we,Z,z){return U.generate(we,Z).with({scheme:z})}U.generateCellPropertyUri=le;function ae(we,Z){if(we.scheme===Z)return U.parse(we.with({scheme:U.scheme}))}U.parseCellPropertyUri=ae})(v||(e.CellUri=v={}));const _=U=>y.isWindows?U.replace(/\//g,"\\"):U;class m{constructor(ie=[],X=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=X,this.order=[...new Set(ie)].map(ye=>({pattern:ye,matches:R.parse(_(ye))}))}sort(ie){const X=new Map(P.Iterable.map(ie,Pe=>[Pe,_(Pe)]));let ye=[];for(const{matches:Pe}of this.order)for(const[De,pe]of X)if(Pe(pe)){ye.push(De),X.delete(De);break}return X.size&&(ye=ye.concat([...X.keys()].sort((Pe,De)=>this.defaultOrder.indexOf(Pe)-this.defaultOrder.indexOf(De)))),ye}prioritize(ie,X){const ye=this.findIndex(ie);if(ye===-1){this.order.unshift({pattern:ie,matches:R.parse(_(ie))});return}const Pe=new Set(X.map(pe=>this.findIndex(pe,ye)));Pe.delete(-1);const De=Array.from(Pe).sort();this.order.splice(ye+1,0,...De.map(pe=>this.order[pe]));for(let pe=De.length-1;pe>=0;pe--)this.order.splice(De[pe],1)}toArray(){return this.order.map(ie=>ie.pattern)}findIndex(ie,X=this.order.length){const ye=_(ie);for(let Pe=0;Pe<X;Pe++)if(this.order[Pe].matches(ye))return Pe;return-1}}e.MimeTypeDisplayOrder=m;function n(U,ie,X,ye=(Pe,De)=>Pe===De){const Pe=[];function De(le,ae,we){if(ae===0&&we.length===0)return;const Z=Pe[Pe.length-1];Z&&Z.start+Z.deleteCount===le?(Z.deleteCount+=ae,Z.toInsert.push(...we)):Pe.push({start:le,deleteCount:ae,toInsert:we})}let pe=0,Se=0;for(;;){if(pe===U.length){De(pe,0,ie.slice(Se));break}if(Se===ie.length){De(pe,U.length-pe,[]);break}const le=U[pe],ae=ie[Se];if(ye(le,ae)){pe+=1,Se+=1;continue}X(ae)?(De(pe,1,[]),pe+=1):(De(pe,0,[ae]),Se+=1)}return Pe}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new f.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new f.RawContextKey("notebookEditorCursorAtLineBoundary","none");var r;(function(U){U.default="default",U.option="option"})(r||(e.NotebookEditorPriority=r={}));function s(U){const ie=U;return!!((typeof ie.include=="string"||R.isRelativePattern(ie.include))&&(typeof ie.exclude=="string"||R.isRelativePattern(ie.exclude)))}e.isDocumentExcludePattern=s;function o(U,ie,X){if(Array.isArray(U.viewType)&&U.viewType.indexOf(ie)>=0||U.viewType===ie)return!0;if(U.filenamePattern){const ye=s(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,Pe=s(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(R.match(ye,(0,l.basename)(X.fsPath).toLowerCase()))return!(Pe&&R.match(Pe,(0,l.basename)(X.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var g;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(g||(e.CellStatusbarAlignment=g={}));class d{static{this._prefix="notebook/"}static create(ie){return`${d._prefix}${ie}`}static parse(ie){if(ie.startsWith(d._prefix))return ie.substring(d._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=d;function k(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=k;const I=new TextDecoder;function c(U){const ie=[];let X=!1;for(const pe of U)(ie.length===0||X)&&(ie.push(pe),X=!0);let ye=C(ie);const Pe=w.VSBuffer.concat(ie.map(pe=>w.VSBuffer.wrap(pe))),De=L(Pe);return ye=ye||De.byteLength!==Pe.byteLength,{data:De,didCompression:ye}}e.compressOutputItemStreams=c,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const S=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(U=>U.charCodeAt(0)),b=10;function C(U){let ie=!1;return U.forEach((X,ye)=>{if(ye===0||X.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const Pe=U[ye-1],De=X.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(De[0]===S[0]&&De[1]===S[1]&&De[2]===S[2]){const pe=Pe.lastIndexOf(b);if(pe===-1)return;ie=!0,U[ye-1]=Pe.subarray(0,pe),U[ye]=X.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ie}function $(U){let ie=U;do U=ie,ie=U.replace(/[^\n]\x08/gm,"");while(ie.length<U.length);return U}function N(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const ie=U.match(/^(.*)\r+/m)[1];let X=U.match(/\r+(.*)$/m)[1];X=X+ie.slice(X.length,ie.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return U}const H="\b".charCodeAt(0),B="\r".charCodeAt(0);function L(U){return!U.buffer.includes(H)&&!U.buffer.includes(B)?U:w.VSBuffer.fromString(N($(I.decode(U.buffer))))}}),define(Te[7],Ae([1,0,18,11,51,28,67,16,15,2,36,21,39,97,75]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p){"use strict";var h,t,i,u,v,_,m,n,r,s,o,g,d,k,I,c,S,b;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.ChatMessage=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(x){return Object.assign(x,{apply:function(...se){if(se.length===0)return Reflect.construct(x,[]);{const Ce=se.length===1?[]:se[1];return Reflect.construct(x,Ce,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(x,[]);{const[Ce,...qe]=se;return Reflect.construct(x,qe,Ce.constructor)}}})}var $;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})($||(e.TerminalOutputAnchor=$={}));var N;(function(x){x[x.TerminalCommand=0]="TerminalCommand",x[x.Opener=1]="Opener",x[x.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let H=h=class{static from(...M){let se=M;return new h(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=H,e.Disposable=H=h=Ve([C],H);let B=t=class{static Min(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let Ce=1;Ce<M.length;Ce++){const qe=M[Ce];qe.isBefore(se)&&(se=qe)}return se}static Max(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let Ce=1;Ce<M.length;Ce++){const qe=M[Ce];qe.isAfter(se)&&(se=qe)}return se}static isPosition(M){if(!M)return!1;if(M instanceof t)return!0;const{line:se,character:Ce}=M;return typeof se=="number"&&typeof Ce=="number"}static of(M){if(M instanceof t)return M;if(this.isPosition(M))return new t(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(M,se){if(M<0)throw(0,R.illegalArgument)("line must be non-negative");if(se<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=M,this._character=se}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,se=0){if(M===null||se===null)throw(0,R.illegalArgument)();let Ce;return typeof M>"u"?Ce=0:typeof M=="number"?Ce=M:(Ce=typeof M.lineDelta=="number"?M.lineDelta:0,se=typeof M.characterDelta=="number"?M.characterDelta:0),Ce===0&&se===0?this:new t(this.line+Ce,this.character+se)}with(M,se=this.character){if(M===null||se===null)throw(0,R.illegalArgument)();let Ce;return typeof M>"u"?Ce=this.line:typeof M=="number"?Ce=M:(Ce=typeof M.line=="number"?M.line:this.line,se=typeof M.character=="number"?M.character:this.character),Ce===this.line&&se===this.character?this:new t(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=B,e.Position=B=t=Ve([C],B);let L=i=class{static isRange(M){return M instanceof i?!0:M?B.isPosition(M.start)&&B.isPosition(M.end):!1}static of(M){if(M instanceof i)return M;if(this.isRange(M))return new i(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(M,se,Ce,qe){let Qe,st;if(typeof M=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof qe=="number"?(Qe=new B(M,se),st=new B(Ce,qe)):B.isPosition(M)&&B.isPosition(se)&&(Qe=B.of(M),st=B.of(se)),!Qe||!st)throw new Error("Invalid arguments");Qe.isBefore(st)?(this._start=Qe,this._end=st):(this._start=st,this._end=Qe)}contains(M){return i.isRange(M)?this.contains(M.start)&&this.contains(M.end):B.isPosition(M)?!(B.of(M).isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const se=B.Max(M.start,this._start),Ce=B.Min(M.end,this._end);if(!se.isAfter(Ce))return new i(se,Ce)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const se=B.Min(M.start,this._start),Ce=B.Max(M.end,this.end);return new i(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,se=this.end){if(M===null||se===null)throw(0,R.illegalArgument)();let Ce;return M?B.isPosition(M)?Ce=M:(Ce=M.start||this.start,se=M.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new i(Ce,se)}toJSON(){return[this.start,this.end]}};e.Range=L,e.Range=L=i=Ve([C],L);let U=u=class extends L{static isSelection(M){return M instanceof u?!0:M?L.isRange(M)&&B.isPosition(M.anchor)&&B.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(M,se,Ce,qe){let Qe,st;if(typeof M=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof qe=="number"?(Qe=new B(M,se),st=new B(Ce,qe)):B.isPosition(M)&&B.isPosition(se)&&(Qe=B.of(M),st=B.of(se)),!Qe||!st)throw new Error("Invalid arguments");super(Qe,st),this._anchor=Qe,this._active=st}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=U,e.Selection=U=u=Ve([C],U);const ie=x=>{if(typeof x!="string"||x.length===0||!/^[0-9A-Za-z_\-]+$/.test(x))throw(0,R.illegalArgument)("connectionToken")};class X{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,se,Ce){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,R.illegalArgument)("port");typeof Ce<"u"&&ie(Ce),this.host=M,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=X;class ye{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,se){this.makeConnection=M,this.connectionToken=se,typeof se<"u"&&ie(se)}}e.ManagedResolvedAuthority=ye;class Pe extends Error{static NotAvailable(M,se){return new Pe(M,E.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(M){return new Pe(M,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,se=E.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(M),this._message=M,this._code=se,this._detail=Ce,Object.setPrototypeOf(this,Pe.prototype)}}e.RemoteAuthorityResolverError=Pe;var De;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(De||(e.EndOfLine=De={}));var pe;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(pe||(e.EnvironmentVariableMutatorType=pe={}));let Se=v=class{static isTextEdit(M){return M instanceof v?!0:M?L.isRange(M)&&typeof M.newText=="string":!1}static replace(M,se){return new v(M,se)}static insert(M,se){return v.replace(new L(M,M),se)}static delete(M){return v.replace(M,"")}static setEndOfLine(M){const se=new v(new L(new B(0,0),new B(0,0)),"");return se.newEol=M,se}get range(){return this._range}set range(M){if(M&&!L.isRange(M))throw(0,R.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,R.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,R.illegalArgument)("newEol");this._newEol=M}constructor(M,se){this._range=M,this._newText=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Se,e.TextEdit=Se=v=Ve([C],Se);let le=_=class{static isNotebookCellEdit(M){return M instanceof _?!0:M?Jt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,se){return new _(M,se)}static insertCells(M,se){return new _(new Jt(M,M),se)}static deleteCells(M){return new _(M,[])}static updateCellMetadata(M,se){const Ce=new _(new Jt(M,M),[]);return Ce.newCellMetadata=se,Ce}static updateNotebookMetadata(M){const se=new _(new Jt(0,0),[]);return se.newNotebookMetadata=M,se}constructor(M,se){this.range=M,this.newCells=se}};e.NotebookEdit=le,e.NotebookEdit=le=_=Ve([C],le);class ae{static isSnippetTextEdit(M){return M instanceof ae?!0:M?L.isRange(M.range)&&z.isSnippetString(M.snippet):!1}static replace(M,se){return new ae(M,se)}static insert(M,se){return ae.replace(new L(M,M),se)}constructor(M,se){this.range=M,this.snippet=se}}e.SnippetTextEdit=ae;var we;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let Z=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,se,Ce,qe){this._edits.push({_type:1,from:M,to:se,options:Ce,metadata:qe})}createFile(M,se,Ce){this._edits.push({_type:1,from:void 0,to:M,options:se,metadata:Ce})}deleteFile(M,se,Ce){this._edits.push({_type:1,from:M,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata(M,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:M,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(M,se,Ce,qe){const Qe=se.start,st=se.end;(Qe!==st||Ce.length>0)&&this._edits.push({_type:5,uri:M,index:Qe,count:st-Qe,cells:Ce,metadata:qe})}replaceNotebookCellMetadata(M,se,Ce,qe){this._edits.push({_type:3,metadata:qe,uri:M,edit:{editType:3,index:se,metadata:Ce}})}replace(M,se,Ce,qe){this._edits.push({_type:2,uri:M,edit:new Se(se,Ce),metadata:qe})}insert(M,se,Ce,qe){this.replace(M,new L(se,se),Ce,qe)}delete(M,se,Ce){this.replace(M,se,"",Ce)}has(M){return this._edits.some(se=>se._type===2&&se.uri.toString()===M.toString())}set(M,se){if(se)for(const Ce of se){if(!Ce)continue;let qe,Qe;Array.isArray(Ce)?(qe=Ce[0],Qe=Ce[1]):qe=Ce,le.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(M,qe.range.start,qe.newCellMetadata,Qe):qe.newNotebookMetadata?this.replaceNotebookMetadata(M,qe.newNotebookMetadata,Qe):this.replaceNotebookCells(M,qe.range,qe.newCells,Qe):ae.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:M,range:qe.range,edit:qe.snippet,metadata:Qe}):this._edits.push({_type:2,uri:M,edit:qe,metadata:Qe})}else{for(let Ce=0;Ce<this._edits.length;Ce++){const qe=this._edits[Ce];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===M.toString()&&(this._edits[Ce]=void 0);break}}(0,w.coalesceInPlace)(this._edits)}}get(M){const se=[];for(const Ce of this._edits)Ce._type===2&&Ce.uri.toString()===M.toString()&&se.push(Ce.edit);return se}entries(){const M=new F.ResourceMap;for(const se of this._edits)if(se._type===2){let Ce=M.get(se.uri);Ce||(Ce=[se.uri,[]],M.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Z,e.WorkspaceEdit=Z=Ve([C],Z);let z=m=class{static isSnippetString(M){return M instanceof m?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this._tabstop=1,this.value=M||""}appendText(M){return this.value+=m._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,se=this._tabstop++){if(typeof M=="function"){const Ce=new m;Ce._tabstop=this._tabstop,M(Ce),this._tabstop=Ce._tabstop,M=Ce.value}else M=m._escape(M);return this.value+="${",this.value+=se,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,se=this._tabstop++){const Ce=M.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(M,se){if(typeof se=="function"){const Ce=new m;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=z,e.SnippetString=z=m=Ve([C],z);var Y;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var ee;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let ve=n=class{static isLocation(M){return M instanceof n?!0:M?L.isRange(M.range)&&f.URI.isUri(M.uri):!1}constructor(M,se){if(this.uri=M,se)if(L.isRange(se))this.range=L.of(se);else if(B.isPosition(se))this.range=new L(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ve,e.Location=ve=n=Ve([C],ve);let ge=class{static is(M){return M?typeof M.message=="string"&&M.location&&L.isRange(M.location.range)&&f.URI.isUri(M.location.uri):!1}constructor(M,se){this.location=M,this.message=se}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.location.range.isEqual(se.location.range)&&M.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=ge,e.DiagnosticRelatedInformation=ge=Ve([C],ge);let de=class{constructor(M,se,Ce=ee.Error){if(!L.isRange(M))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=M,this.message=se,this.severity=Ce}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.severity===se.severity&&M.code===se.code&&M.severity===se.severity&&M.source===se.source&&M.range.isEqual(se.range)&&(0,w.equals)(M.tags,se.tags)&&(0,w.equals)(M.relatedInformation,se.relatedInformation,ge.isEqual)}};e.Diagnostic=de,e.Diagnostic=de=Ve([C],de);let _e=class{constructor(M,se){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=se}};e.Hover=_e,e.Hover=_e=Ve([C],_e);var re;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let ue=class{constructor(M,se=re.Text){this.range=M,this.kind=se}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.DocumentHighlight=ue,e.DocumentHighlight=ue=Ve([C],ue);var ne;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(ne||(e.SymbolKind=ne={}));var oe;(function(x){x[x.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=r=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,se,Ce,qe,Qe){this.name=M,this.kind=se,this.containerName=Qe,typeof Ce=="string"&&(this.containerName=Ce),qe instanceof ve?this.location=qe:Ce instanceof L&&(this.location=new ve(qe,Ce)),r.validate(this)}toJSON(){return{name:this.name,kind:ne[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=fe,e.SymbolInformation=fe=r=Ve([C],fe);let ke=s=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(s.validate)}constructor(M,se,Ce,qe,Qe){this.name=M,this.detail=se,this.kind=Ce,this.range=qe,this.selectionRange=Qe,this.children=[],s.validate(this)}};e.DocumentSymbol=ke,e.DocumentSymbol=ke=s=Ve([C],ke);var O;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(O||(e.CodeActionTriggerKind=O={}));let W=class{constructor(M,se){this.title=M,this.kind=se}};e.CodeAction=W,e.CodeAction=W=Ve([C],W);let j=class{static{o=this}static{this.sep="."}constructor(M){this.value=M}append(M){return new o(this.value?this.value+o.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+o.sep)}};e.CodeActionKind=j,e.CodeActionKind=j=o=Ve([C],j),j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorMove=j.Refactor.append("move"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll"),j.Notebook=j.Empty.append("notebook");let K=class{constructor(M,se){if(this.range=M,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=K,e.SelectionRange=K=Ve([C],K);class V{constructor(M,se,Ce,qe,Qe,st){this.kind=M,this.name=se,this.detail=Ce,this.uri=qe,this.range=Qe,this.selectionRange=st}}e.CallHierarchyItem=V;class J{constructor(M,se){this.fromRanges=se,this.from=M}}e.CallHierarchyIncomingCall=J;class ce{constructor(M,se){this.fromRanges=se,this.to=M}}e.CallHierarchyOutgoingCall=ce;var Me;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Me||(e.LanguageStatusSeverity=Me={}));let $e=class{constructor(M,se){this.range=M,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=$e,e.CodeLens=$e=Ve([C],$e);let Ge=g=class{#e;static isMarkdownString(M){return M instanceof g?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,se=!1){this.#e=new P.MarkdownString(M,{supportThemeIcons:se})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,se){return this.#e.appendCodeblock(se??"",M),this}};e.MarkdownString=Ge,e.MarkdownString=Ge=g=Ve([C],Ge);let je=class{constructor(M,se){this.label=M,this.documentation=se}};e.ParameterInformation=je,e.ParameterInformation=je=Ve([C],je);let Ze=class{constructor(M,se){this.label=M,this.documentation=se,this.parameters=[]}};e.SignatureInformation=Ze,e.SignatureInformation=Ze=Ve([C],Ze);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ye,e.SignatureHelp=Ye=Ve([C],Ye);var Je;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Je||(e.SignatureHelpTriggerKind=Je={}));var it;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(M){this.value=M}};e.InlayHintLabelPart=tt,e.InlayHintLabelPart=tt=Ve([C],tt);let Ue=class{constructor(M,se,Ce){this.position=M,this.label=se,this.kind=Ce}};e.InlayHint=Ue,e.InlayHint=Ue=Ve([C],Ue);var lt;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(lt||(e.CompletionTriggerKind=lt={}));var Q;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Q||(e.CompletionItemKind=Q={}));var G;(function(x){x[x.Deprecated=1]="Deprecated"})(G||(e.CompletionItemTag=G={}));let Ee=class{constructor(M,se){this.label=M,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Ee,e.CompletionItem=Ee=Ve([C],Ee);let Be=class{constructor(M=[],se=!1){this.items=M,this.isIncomplete=se}};e.CompletionList=Be,e.CompletionList=Be=Ve([C],Be);let Ne=class{constructor(M,se,Ce){this.insertText=M,this.range=se,this.command=Ce}};e.InlineSuggestion=Ne,e.InlineSuggestion=Ne=Ve([C],Ne);let Xe=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.InlineSuggestionList=Xe,e.InlineSuggestionList=Xe=Ve([C],Xe);var nt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var pt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(pt||(e.StatusBarAlignment=pt={}));function bt(x,M){return`${D.ExtensionIdentifier.toKey(x)}.${M}`}e.asStatusBarItemIdentifier=bt;var Pt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Vt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var qt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(qt||(e.TextEditorRevealType=qt={}));var Et;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var xt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var Mt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Mt||(e.DecorationRangeBehavior=Mt={})),function(x){function M(se){switch(se){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=M}(Et||(e.TextEditorSelectionChangeKind=Et={}));var jt;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(jt||(e.SyntaxTokenType=jt={})),function(x){function M(se){switch(se){case x.Other:return"other";case x.Comment:return"comment";case x.String:return"string";case x.RegEx:return"regex"}return"other"}x.toString=M}(jt||(e.SyntaxTokenType=jt={}));let $t=class{constructor(M,se){if(se&&!f.URI.isUri(se))throw(0,R.illegalArgument)("target");if(!L.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.target=se}};e.DocumentLink=$t,e.DocumentLink=$t=Ve([C],$t);let Dt=class{constructor(M,se,Ce,qe){this.red=M,this.green=se,this.blue=Ce,this.alpha=qe}};e.Color=Dt,e.Color=Dt=Ve([C],Dt);let Ft=class{constructor(M,se){if(se&&!(se instanceof Dt))throw(0,R.illegalArgument)("color");if(!L.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.color=se}};e.ColorInformation=Ft,e.ColorInformation=Ft=Ve([C],Ft);let Bt=class{constructor(M){if(!M||typeof M!="string")throw(0,R.illegalArgument)("label");this.label=M}};e.ColorPresentation=Bt,e.ColorPresentation=Bt=Ve([C],Bt);var Kt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var zt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(zt||(e.SourceControlInputBoxValidationType=zt={}));var Ht;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(Ht||(e.TerminalExitReason=Ht={}));class Nt{constructor(M,se,Ce){if(this.startIndex=M,this.length=se,this.tooltip=Ce,typeof M!="number"||M<0)throw(0,R.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,R.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Nt;class at{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=at;class ht{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=ht;var Tt;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Tt||(e.TerminalLocation=Tt={}));class Wt{constructor(M){if(this.options=M,typeof M!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=Wt;var At;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var ot;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(ot||(e.TaskPanelKind=ot={}));let wt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(M){switch(M){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(M,se){if(this.label=se,typeof M!="string"||typeof se!="string")throw(0,R.illegalArgument)("name");this._id=M}get id(){return this._id}};e.TaskGroup=wt,e.TaskGroup=wt=d=Ve([C],wt);function Lt(x){let M="";for(let se=0;se<x.length;se++)M+=x[se].replace(/,/g,",,")+",";return M}let kt=class{constructor(M,se,Ce){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=M,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(const se of this._args)M.push(se);return Lt(M)}};e.ProcessExecution=kt,e.ProcessExecution=kt=Ve([C],kt);let ze=class{constructor(M,se,Ce){if(this._args=[],Array.isArray(se)){if(!M)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M,this._args=se,this._options=Ce}else{if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M,this._options=se}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)M.push(typeof se=="string"?se:se.value);return Lt(M)}};e.ShellExecution=ze,e.ShellExecution=ze=Ve([C],ze);var Gt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Gt||(e.ShellQuoting=Gt={}));var Ie;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Ie||(e.TaskScope=Ie={}));class Oe{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Oe;let me=class{static{k=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(M,se,Ce,qe,Qe,st){this.__deprecated=!1,this._definition=this.definition=M;let ut;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=qe,ut=Qe,this.__deprecated=!0):se===Ie.Global||se===Ie.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=qe,this.execution=Qe,ut=st):(this.target=se,this._name=this.name=Ce,this._source=this.source=qe,this.execution=Qe,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof kt?this._definition={type:k.ProcessType,id:this._execution.computeId()}:this._execution instanceof ze?this._definition={type:k.ShellType,id:this._execution.computeId()}:this._execution instanceof Oe?this._definition={type:k.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:k.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const se=this._definition.type;(k.EmptyType===se||k.ProcessType===se||k.ShellType===se||k.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};e.Task=me,e.Task=me=k=Ve([C],me);var q;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(q||(e.ProgressLocation=q={}));var Re;(function(x){function M(se){const Ce=se;return(0,y.isNumber)(Ce.value)?Ce.tooltip&&!(0,y.isString)(Ce.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ce.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ce.value),!1)}x.isViewBadge=M})(Re||(e.ViewBadge=Re={}));let xe=I=class{static isTreeItem(M,se){const Ce=M;if(Ce.checkboxState!==void 0){const qe=(0,y.isNumber)(Ce.checkboxState)?Ce.checkboxState:(0,y.isObject)(Ce.checkboxState)&&(0,y.isNumber)(Ce.checkboxState.state)?Ce.checkboxState.state:void 0,Qe=!(0,y.isNumber)(Ce.checkboxState)&&(0,y.isObject)(Ce.checkboxState)?Ce.checkboxState.tooltip:void 0;if(qe===void 0||qe!==We.Checked&&qe!==We.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",Ce.checkboxState),!1}if(M instanceof I)return!0;if(Ce.label!==void 0&&!(0,y.isString)(Ce.label)&&!Ce.label?.label)return console.log("INVALID tree item, invalid label",Ce.label),!1;if(Ce.id!==void 0&&!(0,y.isString)(Ce.id))return console.log("INVALID tree item, invalid id",Ce.id),!1;if(Ce.iconPath!==void 0&&!(0,y.isString)(Ce.iconPath)&&!f.URI.isUri(Ce.iconPath)&&(!Ce.iconPath||!(0,y.isString)(Ce.iconPath.id))){const qe=Ce.iconPath;if(!qe||!(0,y.isString)(qe.light)&&!f.URI.isUri(qe.light)&&!(0,y.isString)(qe.dark)&&!f.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Ce.iconPath),!1}return Ce.description!==void 0&&!(0,y.isString)(Ce.description)&&typeof Ce.description!="boolean"?(console.log("INVALID tree item, invalid description",Ce.description),!1):Ce.resourceUri!==void 0&&!f.URI.isUri(Ce.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ce.resourceUri),!1):Ce.tooltip!==void 0&&!(0,y.isString)(Ce.tooltip)&&!(Ce.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Ce.tooltip),!1):Ce.command!==void 0&&!Ce.command.command?(console.log("INVALID tree item, invalid command",Ce.command),!1):Ce.collapsibleState!==void 0&&Ce.collapsibleState<Ke.None&&Ce.collapsibleState>Ke.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ce.collapsibleState),!1):Ce.contextValue!==void 0&&!(0,y.isString)(Ce.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ce.contextValue),!1):Ce.accessibilityInformation!==void 0&&!Ce.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ce.accessibilityInformation),!1):!0}constructor(M,se=Ke.None){this.collapsibleState=se,f.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.TreeItem=xe,e.TreeItem=xe=I=Ve([C],xe);var Ke;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Ke||(e.TreeItemCollapsibleState=Ke={}));var We;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(We||(e.TreeItemCheckboxState=We={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.DataTransferItem=et,e.DataTransferItem=et=Ve([C],et);class _t extends et{}e.InternalDataTransferItem=_t;class yt extends _t{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.InternalFileDataTransferItem=yt;class mt{constructor(M,se,Ce,qe){this.name=M,this.uri=se,this._itemId=Ce,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=mt;let dt=class{#e=new Map;constructor(M){for(const[se,Ce]of M??[]){const qe=this.#e.get(this.#t(se));qe?qe.push(Ce):this.#e.set(this.#t(se),[Ce])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,se){this.#e.set(this.#t(M),[se])}forEach(M,se){for(const[Ce,qe]of this.#e)for(const Qe of qe)M.call(se,Qe,Ce,this)}*[Symbol.iterator](){for(const[M,se]of this.#e)for(const Ce of se)yield[M,Ce]}#t(M){return M.toLowerCase()}};e.DataTransfer=dt,e.DataTransfer=dt=Ve([C],dt);let ft=class{constructor(M){this.insertText=M}};e.DocumentDropEdit=ft,e.DocumentDropEdit=ft=Ve([C],ft);let gi=class{constructor(M,se){this.label=se,this.insertText=M}};e.DocumentPasteEdit=gi,e.DocumentPasteEdit=gi=Ve([C],gi);let Ct=class{constructor(M,se){this.id=M,this.color=se}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.ThemeIcon=Ct,e.ThemeIcon=Ct=Ve([C],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Ci=class{constructor(M){this.id=M}};e.ThemeColor=Ci,e.ThemeColor=Ci=Ve([C],Ci);var li;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let pi=class{get base(){return this._base}set base(M){this._base=M,this._baseUri=f.URI.file(M)}get baseUri(){return this._baseUri}set baseUri(M){this._baseUri=M,this._base=M.fsPath}constructor(M,se){if(typeof M!="string"&&(!M||!f.URI.isUri(M)&&!f.URI.isUri(M.uri)))throw(0,R.illegalArgument)("base");if(typeof se!="string")throw(0,R.illegalArgument)("pattern");typeof M=="string"?this.baseUri=f.URI.file(M):f.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=pi,e.RelativePattern=pi=Ve([C],pi);const It=new WeakMap;function mn(x,M){It.set(x,M)}e.setBreakpointId=mn;let ri=class{constructor(M,se,Ce,qe){this.enabled=typeof M=="boolean"?M:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=It.get(this)??(0,A.generateUuid)()),this._id}};e.Breakpoint=ri,e.Breakpoint=ri=Ve([C],ri);let St=class extends ri{constructor(M,se,Ce,qe,Qe){if(super(se,Ce,qe,Qe),M===null)throw(0,R.illegalArgument)("location");this.location=M}};e.SourceBreakpoint=St,e.SourceBreakpoint=St=Ve([C],St);let vi=class extends ri{constructor(M,se,Ce,qe,Qe){super(se,Ce,qe,Qe),this.functionName=M}};e.FunctionBreakpoint=vi,e.FunctionBreakpoint=vi=Ve([C],vi);let Ei=class extends ri{constructor(M,se,Ce,qe,Qe,st,ut){if(super(qe,Qe,st,ut),!se)throw(0,R.illegalArgument)("dataId");this.label=M,this.dataId=se,this.canPersist=Ce}};e.DataBreakpoint=Ei,e.DataBreakpoint=Ei=Ve([C],Ei);let si=class{constructor(M,se,Ce){this.command=M,this.args=se||[],this.options=Ce}};e.DebugAdapterExecutable=si,e.DebugAdapterExecutable=si=Ve([C],si);let Ii=class{constructor(M,se){this.port=M,this.host=se}};e.DebugAdapterServer=Ii,e.DebugAdapterServer=Ii=Ve([C],Ii);let ki=class{constructor(M){this.path=M}};e.DebugAdapterNamedPipeServer=ki,e.DebugAdapterNamedPipeServer=ki=Ve([C],ki);let Rt=class{constructor(M){this.implementation=M}};e.DebugAdapterInlineImplementation=Rt,e.DebugAdapterInlineImplementation=Rt=Ve([C],Rt);let bi=class{constructor(M,se,Ce){this.session=M,this.threadId=se,this.frameId=Ce}};e.StackFrameFocus=bi,e.StackFrameFocus=bi=Ve([C],bi);let Pi=class{constructor(M,se){this.session=M,this.threadId=se}};e.ThreadFocus=Pi,e.ThreadFocus=Pi=Ve([C],Pi);let oi=class{constructor(M,se){this.range=M,this.expression=se}};e.EvaluatableExpression=oi,e.EvaluatableExpression=oi=Ve([C],oi);var ui;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(ui||(e.InlineCompletionTriggerKind=ui={}));let ct=class{constructor(M,se){this.range=M,this.text=se}};e.InlineValueText=ct,e.InlineValueText=ct=Ve([C],ct);let Ti=class{constructor(M,se,Ce=!0){this.range=M,this.variableName=se,this.caseSensitiveLookup=Ce}};e.InlineValueVariableLookup=Ti,e.InlineValueVariableLookup=Ti=Ve([C],Ti);let Yt=class{constructor(M,se){this.range=M,this.expression=se}};e.InlineValueEvaluatableExpression=Yt,e.InlineValueEvaluatableExpression=Yt=Ve([C],Yt);let ii=class{constructor(M,se){this.frameId=M,this.stoppedLocation=se}};e.InlineValueContext=ii,e.InlineValueContext=ii=Ve([C],ii);var Ai;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Ai||(e.FileChangeType=Ai={}));let Ri=c=class extends Error{static FileExists(M){return new c(M,a.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(M){return new c(M,a.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(M){return new c(M,a.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(M){return new c(M,a.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(M){return new c(M,a.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(M){return new c(M,a.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}constructor(M,se=a.FileSystemProviderErrorCode.Unknown,Ce){super(f.URI.isUri(M)?M.toString(!0):M),this.code=Ce?.name??"Unknown",(0,a.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}};e.FileSystemError=Ri,e.FileSystemError=Ri=c=Ve([C],Ri);let Oi=class{constructor(M,se,Ce){this.start=M,this.end=se,this.kind=Ce}};e.FoldingRange=Oi,e.FoldingRange=Oi=Ve([C],Oi);var Xi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Qi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Qi||(e.CommentMode=Qi={}));var Li;(function(x){x[x.Published=0]="Published",x[x.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var ai;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(M,se=[]){this.tokenTypes=M,this.tokenModifiers=se}}e.SemanticTokensLegend=gn;function Mi(x){return typeof x>"u"||(0,y.isStringArray)(x)}class di{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let se=0,Ce=M.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set(M.tokenTypes[se],se);for(let se=0,Ce=M.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set(M.tokenModifiers[se],se)}}push(M,se,Ce,qe,Qe){if(typeof M=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof qe=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(M,se,Ce,qe,Qe);if(L.isRange(M)&&typeof se=="string"&&Mi(Ce))return this._push(M,se,Ce);throw(0,R.illegalArgument)()}_push(M,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const qe=M.start.line,Qe=M.start.character,st=M.end.character-M.start.character,ut=this._tokenTypeStrToInt.get(se);let Ut=0;if(Ce)for(const Qt of Ce){if(!this._tokenModifierStrToInt.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this._tokenModifierStrToInt.get(Qt);Ut|=1<<ei>>>0}this._pushEncoded(qe,Qe,st,ut,Ut)}_pushEncoded(M,se,Ce,qe,Qe){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ut=this._data.length/5|0;let Qt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this._data[5*ti],Ki=this._data[5*ti+1];ni===0?(ni=Qt,Ki+=ei):ni+=Qt,this._data[5*ti]=ni,this._data[5*ti+1]=Ki,Qt=ni,ei=Ki}}let st=M,ut=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Qe,this._prevLine=M,this._prevChar=se}static _sortAndDeltaEncode(M){const se=[],Ce=M.length/5|0;for(let ut=0;ut<Ce;ut++)se[ut]=ut;se.sort((ut,Ut)=>{const Qt=M[5*ut],ei=M[5*Ut];if(Qt===ei){const ti=M[5*ut+1],ni=M[5*Ut+1];return ti-ni}return Qt-ei});const qe=new Uint32Array(M.length);let Qe=0,st=0;for(let ut=0;ut<Ce;ut++){const Ut=5*se[ut],Qt=M[Ut+0],ei=M[Ut+1],ti=M[Ut+2],ni=M[Ut+3],Ki=M[Ut+4],kn=Qt-Qe,Fn=kn===0?ei-st:ei,Gi=5*ut;qe[Gi+0]=kn,qe[Gi+1]=Fn,qe[Gi+2]=ti,qe[Gi+3]=ni,qe[Gi+4]=Ki,Qe=Qt,st=ei}return qe}build(M){return this._dataIsSortedAndDeltaEncoded?new Ni(new Uint32Array(this._data),M):new Ni(di._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=di;class Ni{constructor(M,se){this.resultId=se,this.data=M}}e.SemanticTokens=Ni;class pn{constructor(M,se,Ce){this.start=M,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=pn;class hi{constructor(M,se){this.resultId=se,this.edits=M}}e.SemanticTokensEdits=hi;var Yi;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let Ui=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.QuickInputButtons=Ui,e.QuickInputButtons=Ui=Ve([C],Ui);var Ji;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Ji||(e.QuickPickItemKind=Ji={}));var fi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var Zi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Zi||(e.ExtensionKind=Zi={}));class vn{static validate(M){if(typeof M.badge=="string"){let se=(0,l.nextCharLength)(M.badge,0);if(se<M.badge.length&&(se+=(0,l.nextCharLength)(M.badge,se)),M.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Ct.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,se,Ce){this.badge=M,this.tooltip=se,this.color=Ce}}e.FileDecoration=vn;let xi=class{constructor(M){this.kind=M}};e.ColorTheme=xi,e.ColorTheme=xi=Ve([C],xi);var mi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class Jt{static isNotebookRange(M){return M instanceof Jt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(M,se){if(M<0)throw(0,R.illegalArgument)("start must be positive");if(se<0)throw(0,R.illegalArgument)("end must be positive");M<=se?(this._start=M,this._end=se):(this._start=se,this._end=M)}with(M){let se=this._start,Ce=this._end;return M.start!==void 0&&(se=M.start),M.end!==void 0&&(Ce=M.end),se===this._start&&Ce===this._end?this:new Jt(se,Ce)}}e.NotebookRange=Jt;class wi{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(M){return!0}constructor(M,se,Ce,qe,Qe,st,ut){this.kind=M,this.value=se,this.languageId=Ce,this.mime=qe,this.outputs=Qe??[],this.metadata=st,this.executionSummary=ut,wi.validate(this)}}e.NotebookCellData=wi;class en{constructor(M){this.cells=M}}e.NotebookData=en;class Xt{static isNotebookCellOutputItem(M){return M instanceof Xt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const se={name:M.name,message:M.message,stack:M.stack};return Xt.json(se,"application/vnd.code.notebook.error")}static stdout(M){return Xt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Xt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,se="application/octet-stream"){return new Xt(M,se)}static#e=new TextEncoder;static text(M,se=T.Mimes.text){const Ce=Xt.#e.encode(String(M));return new Xt(Ce,se)}static json(M,se="text/x-json"){const Ce=JSON.stringify(M,void 0,"	");return Xt.text(Ce,se)}constructor(M,se){this.data=M,this.mime=se;const Ce=(0,T.normalizeMimeType)(se,!0);if(!Ce)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}}e.NotebookCellOutputItem=Xt;class Si{static isNotebookCellOutput(M){return M instanceof Si?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,se=!1){const Ce=new Set,qe=new Set;for(let Qe=0;Qe<M.length;Qe++){const st=M[Qe],ut=(0,T.normalizeMimeType)(st.mime);if(!Ce.has(ut)||(0,p.isTextStreamMime)(ut)){Ce.add(ut);continue}qe.add(Qe),se&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return qe.size===0?M:M.filter((Qe,st)=>!qe.has(st))}constructor(M,se,Ce){this.items=Si.ensureUniqueMimeTypes(M,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,A.generateUuid)(),this.metadata=se??Ce)}}e.NotebookCellOutput=Si;var tn;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var _i;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(_i||(e.NotebookEditorRevealType=_i={}));class sn{constructor(M,se){this.text=M,this.alignment=se}}e.NotebookCellStatusBarItem=sn;var Le;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Le||(e.NotebookControllerAffinity=Le={}));var Zt;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(Zt||(e.NotebookControllerAffinity2=Zt={}));class on{constructor(M,se=[]){this.uri=M,this.provides=(0,w.asArray)(se)}}e.NotebookRendererScript=on;class gt{constructor(M){this.label=M}}e.NotebookKernelSourceAction=gt;let $i=class{constructor(M,se){this.label=M,this.timestamp=se}};e.TimelineItem=$i,e.TimelineItem=$i=Ve([C],$i);var an;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class yi{constructor(M,se){this.ranges=M,this.wordPattern=se}}e.LinkedEditingRanges=yi;class En{constructor(M){this._autoForwardAction=M}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=En;var ln;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(ln||(e.TestResultState=ln={}));var un;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Di=class{constructor(M=void 0,se=void 0,Ce=void 0,qe=!1){this.include=M,this.exclude=se,this.profile=Ce,this.continuous=qe}};e.TestRunRequest=Di,e.TestRunRequest=Di=Ve([C],Di);let zi=S=class{static diff(M,se,Ce){const qe=new S(M);return qe.expectedOutput=se,qe.actualOutput=Ce,qe}constructor(M){this.message=M}};e.TestMessage=zi,e.TestMessage=zi=S=Ve([C],zi);let Hi=class{constructor(M){this.id=M}};e.TestTag=Hi,e.TestTag=Hi=Ve([C],Hi);let ci=class{constructor(M,se){this.covered=M,this.total=se}};e.CoveredCount=ci,e.CoveredCount=ci=Ve([C],ci);let Wi=b=class{static fromDetails(M,se){const Ce=new ci(0,0),qe=new ci(0,0),Qe=new ci(0,0);for(const ut of se)if("branches"in ut){Ce.total+=1,Ce.covered+=ut.executionCount>0?1:0;for(const Ut of ut.branches)qe.total+=1,qe.covered+=Ut.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ut.executionCount>0?1:0;const st=new b(M,Ce,qe.total>0?qe:void 0,Qe.total>0?Qe:void 0);return st.detailedCoverage=se,st}constructor(M,se,Ce,qe){this.uri=M,this.statementCoverage=se,this.branchCoverage=Ce,this.functionCoverage=qe}};e.FileCoverage=Wi,e.FileCoverage=Wi=b=Ve([C],Wi);let Vi=class{constructor(M,se,Ce=[]){this.executionCount=M,this.location=se,this.branches=Ce}};e.StatementCoverage=Vi,e.StatementCoverage=Vi=Ve([C],Vi);let qi=class{constructor(M,se){this.executionCount=M,this.location=se}};e.BranchCoverage=qi,e.BranchCoverage=qi=Ve([C],qi);let ji=class{constructor(M,se){this.executionCount=M,this.location=se}};e.FunctionCoverage=ji,e.FunctionCoverage=ji=Ve([C],ji);var dn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(dn||(e.ExternalUriOpenerPriority=dn={}));var hn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var fn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class te{constructor(M,se,Ce,qe,Qe,st){this.kind=M,this.name=se,this.detail=Ce,this.uri=qe,this.range=Qe,this.selectionRange=st}}e.TypeHierarchyItem=te;class he{constructor(M){this.uri=M}}e.TextTabInput=he;class Fe{constructor(M,se){this.original=M,this.modified=se}}e.TextDiffTabInput=Fe;class rt{constructor(M,se,Ce,qe){this.base=M,this.input1=se,this.input2=Ce,this.result=qe}}e.TextMergeTabInput=rt;class vt{constructor(M,se){this.uri=M,this.viewType=se}}e.CustomEditorTabInput=vt;class Ot{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=Ot;class Pn{constructor(M,se){this.uri=M,this.notebookType=se}}e.NotebookEditorTabInput=Pn;class Tn{constructor(M,se,Ce){this.original=M,this.modified=se,this.notebookType=Ce}}e.NotebookDiffEditorTabInput=Tn;class An{constructor(){}}e.TerminalEditorTabInput=An;class Rn{constructor(M,se){this.uri=M,this.inputBoxUri=se}}e.InteractiveWindowInput=Rn;var bn;(function(x){x[x.Down=0]="Down",x[x.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(x){x[x.Action=1]="Action",x[x.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var Sn;(function(x){x[x.Unhelpful=0]="Unhelpful",x[x.Helpful=1]="Helpful",x[x.Undone=2]="Undone",x[x.Accepted=3]="Accepted"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var _n;(function(x){x[x.System=0]="System",x[x.User=1]="User",x[x.Assistant=2]="Assistant",x[x.Function=3]="Function"})(_n||(e.ChatMessageRole=_n={}));var yn;(function(x){x[x.Short=1]="Short",x[x.Medium=2]="Medium",x[x.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class On{constructor(M,se){this.role=M,this.content=se}}e.ChatMessage=On;var Dn;(function(x){x[x.Unhelpful=0]="Unhelpful",x[x.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));var Cn;(function(x){x[x.SymbolInformation=1]="SymbolInformation",x[x.CommandInformation=2]="CommandInformation",x[x.SearchInformation=3]="SearchInformation",x[x.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var In;(function(x){x[x.Started=1]="Started",x[x.Recognizing=2]="Recognizing",x[x.Recognized=3]="Recognized",x[x.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Te[100],Ae([1,0,53,13,16,281,136,7,18]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const f=new Map;function A(p,h){h?f.set(p,h):f.delete(p)}e.setWordDefinitionFor=A;function D(p){return f.get(p)}class a extends F.MirrorTextModel{constructor(h,t,i,u,v,_,m,n){super(t,i,u,v),this._proxy=h,this._languageId=_,this._isDirty=m,this.notebook=n,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,y.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===R.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(t){return t?h._getTextInRange(t):h.getText()},get eol(){return h._eol===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(t){return h._lineAt(t)},offsetAt(t){return h._offsetAt(t)},positionAt(t){return h._positionAt(t)},validateRange(t){return h._validateRange(t)},validatePosition(t){return h._validatePosition(t)},getWordRangeAtPosition(t,i){return h._getWordRangeAtPosition(t,i)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,w.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,w.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const t=this._validateRange(h);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const i=this._eol,u=t.start.line,v=t.end.line,_=[];_.push(this._lines[u].substring(t.start.character));for(let m=u+1;m<v;m++)_.push(this._lines[m]);return _.push(this._lines[v].substring(0,t.end.character)),_.join(i)}_lineAt(h){let t;if(h instanceof l.Position?t=h.line:typeof h=="number"&&(t=h),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new E(t,this._lines[t],t===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(h),i=this._lines[t.index].length;return new l.Position(t.index,Math.min(t.remainder,i))}_validateRange(h){if(!(h instanceof l.Range))throw new Error("Invalid argument");const t=this._validatePosition(h.start),i=this._validatePosition(h.end);return t===h.start&&i===h.end?h:new l.Range(t.line,t.character,i.line,i.character)}_validatePosition(h){if(!(h instanceof l.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:t,character:i}=h,u=!1;if(t<0)t=0,i=0,u=!0;else if(t>=this._lines.length)t=this._lines.length-1,i=this._lines[t].length,u=!0;else{const v=this._lines[t].length;i<0?(i=0,u=!0):i>v&&(i=v,u=!0)}return u?new l.Position(t,i):h}_getWordRangeAtPosition(h,t){const i=this._validatePosition(h);if(!t)t=D(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const u=(0,T.getWordAtText)(i.character+1,(0,T.ensureValidWordDefinition)(t),this._lines[i.line],0);if(u)return new l.Range(i.line,u.startColumn-1,i.line,u.endColumn-1)}}e.ExtHostDocumentData=a;class E{constructor(h,t,i){this._line=h,this._text=t,this._isLastLine=i}get lineNumber(){return this._line}get text(){return this._text}get range(){return new l.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new l.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(Te[198],Ae([1,0,7,17,5]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let F=class{constructor(l){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(l){let y;switch(l){case"light":y=w.ColorThemeKind.Light;break;case"hcDark":y=w.ColorThemeKind.HighContrast;break;case"hcLight":y=w.ColorThemeKind.HighContrastLight;break;default:y=w.ColorThemeKind.Dark}this._actual=new w.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=F,e.ExtHostTheming=F=Ve([He(0,R.IExtHostRpcService)],F)}),define(Te[199],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.INotebookExecutionService=(0,w.createDecorator)("INotebookExecutionService")}),define(Te[46],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(F){F.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var R;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class P{static fromExtHostTestItem(T,l,y=T.parent){if(T._isRoot)return new P([l]);const f=[T.id];for(let A=y;A&&A.id!==l;A=A.parent)f.push(A.id);return f.push(l),new P(f.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const l=T.indexOf("\0");return l===-1?T:T.slice(0,l)}static fromString(T){return new P(T.split("\0"))}static join(T,l){return new P([...T.path,l])}static joinToString(T,l){return T.toString()+"\0"+l}static parentId(T){const l=T.lastIndexOf("\0");return l===-1?void 0:T.slice(0,l)}static localId(T){const l=T.lastIndexOf("\0");return l===-1?T:T.slice(l+1)}static isChild(T,l){return l.startsWith(T)&&l[T.length]==="\0"}static compare(T,l){return T===l?0:P.isChild(T,l)?2:P.isChild(l,T)?3:1}constructor(T,l=T.length){if(this.path=T,this.viewEnd=l,T.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.viewEnd>1?new P(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new P(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new P(this.path,T)}compare(T){if(typeof T=="string")return P.compare(this.toString(),T);for(let l=0;l<T.viewEnd&&l<this.viewEnd;l++)if(T.path[l]!==this.path[l])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=P}),define(Te[58],Ae([1,0,2,41,46]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var T;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var l;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=I=>"runId"in I;e.isStartControllerTests=y;var f;(function(I){I.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),I.deserialize=c=>({range:R.Range.lift(c.range),uri:w.URI.revive(c.uri)})})(f||(e.IRichLocation=f={}));var A;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(A||(e.TestMessageType=A={}));var D;(function(I){I.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,contextValue:c.contextValue,location:c.location&&f.serialize(c.location)}),I.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,contextValue:c.contextValue,location:c.location&&f.deserialize(c.location)})})(D||(e.ITestErrorMessage=D={}));const a=(I,c)=>`${c?"s":"e"}${I}`;e.getMarkId=a;var E;(function(I){I.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&f.serialize(c.location)}),I.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&f.deserialize(c.location)})})(E||(e.ITestOutputMessage=E={}));var p;(function(I){I.serialize=c=>c.type===0?D.serialize(c):E.serialize(c),I.deserialize=c=>c.type===0?D.deserialize(c):E.deserialize(c)})(p||(e.ITestMessage=p={}));var h;(function(I){I.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),I.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(p.serialize)}),I.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(p.deserialize)})})(h||(e.ITestTaskState=h={}));const t="\0",i=(I,c)=>I+t+c;e.namespaceTestTag=i;const u=I=>{const c=I.indexOf(t);return{ctrlId:I.slice(0,c),tagId:I.slice(c+1)}};e.denamespaceTestTag=u;var v;(function(I){I.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),I.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?w.URI.revive(c.uri):void 0,range:c.range?R.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(v||(e.ITestItem=v={}));var _;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(_||(e.TestItemExpandState=_={}));var m;(function(I){I.serialize=c=>({expand:c.expand,item:v.serialize(c.item)}),I.deserialize=c=>({controllerId:P.TestId.root(c.item.extId),expand:c.expand,item:v.deserialize(c.item)})})(m||(e.InternalTestItem=m={}));var n;(function(I){I.serialize=c=>{let S;return c.item&&(S={},c.item.label!==void 0&&(S.label=c.item.label),c.item.tags!==void 0&&(S.tags=c.item.tags),c.item.busy!==void 0&&(S.busy=c.item.busy),c.item.uri!==void 0&&(S.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(S.range=c.item.range?.toJSON()),c.item.description!==void 0&&(S.description=c.item.description),c.item.error!==void 0&&(S.error=c.item.error),c.item.sortText!==void 0&&(S.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:S}},I.deserialize=c=>{let S;return c.item&&(S={},c.item.label!==void 0&&(S.label=c.item.label),c.item.tags!==void 0&&(S.tags=c.item.tags),c.item.busy!==void 0&&(S.busy=c.item.busy),c.item.range!==void 0&&(S.range=c.item.range?R.Range.lift(c.item.range):null),c.item.description!==void 0&&(S.description=c.item.description),c.item.error!==void 0&&(S.error=c.item.error),c.item.sortText!==void 0&&(S.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:S}}})(n||(e.ITestItemUpdate=n={}));const r=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.applyTestItemUpdate=r;var s;(function(I){I.serializeWithoutMessages=c=>({...m.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(h.serializeWithoutMessages)}),I.serialize=c=>({...m.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(h.serialize)}),I.deserialize=c=>({...m.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(h.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(o||(e.DetailType=o={}));var g;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(g||(e.TestDiffOpType=g={}));var d;(function(I){I.deserialize=c=>c.op===0?{op:c.op,item:m.deserialize(c.item)}:c.op===1?{op:c.op,item:n.deserialize(c.item)}:c.op===2?{op:c.op,uri:w.URI.revive(c.uri),docv:c.docv}:c,I.serialize=c=>c.op===0?{op:c.op,item:m.serialize(c.item)}:c.op===1?{op:c.op,item:n.serialize(c.item)}:c})(d||(e.TestsDiffOp=d={}));class k{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const S=this.createChangeCollector();for(const b of c)switch(b.op){case 0:this.add(m.deserialize(b.item),S);break;case 1:this.update(n.deserialize(b.item),S);break;case 3:this.remove(b.itemId,S);break;case 5:this.retireTest(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this._tags.set(b.tag.id,b.tag);break;case 7:this._tags.delete(b.id);break}S.complete?.()}add(c,S){const b=P.TestId.parentId(c.item.extId)?.toString();let C;if(!b)C=this.createItem(c),this.roots.add(C),this.items.set(c.item.extId,C);else if(this.items.has(b)){const $=this.items.get(b);$.children.add(c.item.extId),C=this.createItem(c,$),this.items.set(c.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return S.add?.(C),c.expand===2&&this.busyControllerCount++,C}update(c,S){const b=this.items.get(c.extId);if(b)return c.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,c),S.update?.(b),b}remove(c,S){const b=this.items.get(c);if(!b)return;const C=P.TestId.parentId(b.item.extId)?.toString();C?this.items.get(C).children.delete(b.item.extId):this.roots.delete(b);const $=[[c]];for(;$.length;)for(const N of $.pop()){const H=this.items.get(N);H&&($.push(H.children),this.items.delete(N),S.remove?.(H,H!==b),H.expand===2&&this.busyControllerCount--)}}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=k}),define(Te[76],Ae([1,0,12,5,6,53,58,46]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const f=(u,v)=>u===v,D=Object.entries({range:(u,v)=>u===v?!0:!u||!v?!1:u.equalsRange(v),busy:f,label:f,description:f,error:f,sortText:f,tags:(u,v)=>!(u.length!==v.length||u.some(_=>!v.includes(_)))}),a=(u,v)=>{let _;for(const[m,n]of D)n(u[m],v[m])||(_?_[m]=v[m]:_={[m]:v[m]});return _};class E extends P.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new w.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const _ of this.tree.values())this.updateExpandability(_)}get resolveHandler(){return this._resolveHandler}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const _ of this.diff)if(_.op===2&&_.uri===v.uri){_.docv=v.docv;return}break}case 1:{const _=this.diff[this.diff.length-1];if(_){if(_.op===1&&_.item.extId===v.item.extId){(0,T.applyTestItemUpdate)(_.item,v.item);return}if(_.op===0&&_.item.item.extId===v.item.extId){(0,T.applyTestItemUpdate)(_.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,_){const m=this.tree.get(v);if(m){if((m.expandLevels===void 0||_>m.expandLevels)&&(m.expandLevels=_),m.expand===1){const n=this.resolveChildren(m);return n.isOpen()?this.expandChildren(m,_-1):n.wait().then(()=>this.expandChildren(m,_-1))}else if(m.expand===3)return m.resolveBarrier?.isOpen()===!1?m.resolveBarrier.wait().then(()=>this.expandChildren(m,_-1)):this.expandChildren(m,_-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,_){switch(_.op){case 3:this.removeItem(l.TestId.joinToString(v.fullId,_.id));break;case 0:this.upsertItem(_.item,v);break;case 5:for(const m of _.ops)this.onTestItemEvent(v,m);break;case 1:this.diffTagRefs(_.new,_.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:_.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,F.assertNever)(_)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,_){const m=l.TestId.fromExtHostTestItem(v,this.root.id,_?.actual),n=this.options.getApiFor(v);n.parent&&n.parent!==_?.actual&&this.options.getChildren(n.parent).delete(v.id);let r=this.tree.get(m.toString());if(!r){r={fullId:m,actual:v,expandLevels:_?.expandLevels?_.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(v,_),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,r,_);return}if(r.actual===v){this.connectItem(v,r,_);return}if(r.actual.uri?.toString()!==v.uri?.toString())return this.removeItem(m.toString()),this.upsertItem(v,_);const s=this.options.getChildren(r.actual),o=r.actual,g=a(this.options.toITestItem(o),this.options.toITestItem(v));this.options.getApiFor(o).listener=void 0,r.actual=v,r.expand=0,g&&(g.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,o.tags,m.toString()),delete g.tags),this.onTestItemEvent(r,{op:4,update:g})),this.connectItemAndChildren(v,r,_);for(const[d,k]of s)this.options.getChildren(v).get(k.id)||this.removeItem(l.TestId.joinToString(m,k.id));this.documentSynced(r.actual.uri)}diffTagRefs(v,_,m){const n=new Set(_.map(r=>r.id));for(const r of v)n.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:m,item:{tags:v.map(r=>(0,T.namespaceTestTag)(this.options.controllerId,r.id))}}}),n.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const _=this.tags.get(v.id);_?_.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const _=this.tags.get(v);_&&!--_.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,_){this.options.getApiFor(v).parent=_&&_.actual!==this.root?_.actual:void 0}connectItem(v,_,m){this.setItemParent(v,m);const n=this.options.getApiFor(v);n.parent=m?.actual,n.listener=r=>this.onTestItemEvent(_,r),this.updateExpandability(_)}connectItemAndChildren(v,_,m){this.connectItem(v,_,m);for(const[n,r]of this.options.getChildren(v))this.upsertItem(r,_)}updateExpandability(v){let _;this._resolveHandler?v.resolveBarrier?_=v.resolveBarrier.isOpen()?3:2:_=v.actual.canResolveChildren?1:0:_=0,_!==v.expand&&(v.expand=_,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:_}}),_===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,_){if(_<0)return;const m=[];for(const[n,r]of this.options.getChildren(v.actual)){const s=this.expand(l.TestId.joinToString(v.fullId,r.id),_);(0,w.isThenable)(s)&&m.push(s)}if(m.length)return Promise.all(m).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const r=new w.Barrier;return r.open(),r}v.expand=2,this.pushExpandStateUpdate(v);const _=v.resolveBarrier=new w.Barrier,m=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let n;try{n=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(r){m(r)}return(0,w.isThenable)(n)?n.catch(m).then(()=>{_.open(),this.updateExpandability(v)}):(_.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const _=this.tree.get(v);if(!_)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const m=[_];for(;m.length;){const n=m.pop();if(n){this.options.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(n.fullId.toString());for(const[r,s]of this.options.getChildren(n.actual))m.push(this.tree.get(l.TestId.joinToString(n.fullId,s.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=E;class p extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=p;class h extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class t extends Error{constructor(v,_,m){super(`TestItem with ID "${v}" is from controller "${_}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=t;const i=(u,v,_)=>{let m=new Map;return{get size(){return m.size},forEach(n,r){for(const s of m.values())n.call(r,s,this)},[Symbol.iterator](){return m.entries()},replace(n){const r=new Map,s=new Set(m.keys()),o={op:5,ops:[]};for(const g of n){if(!(g instanceof _))throw new h(g.id);const d=v(g).controllerId;if(d!==u.controllerId)throw new t(g.id,d,u.controllerId);if(r.has(g.id))throw new p(g.id);r.set(g.id,g),s.delete(g.id),o.ops.push({op:0,item:g})}for(const g of s.keys())o.ops.push({op:3,id:g});u.listener?.(o),m=r},add(n){if(!(n instanceof _))throw new h(n.id);m.set(n.id,n),u.listener?.({op:0,item:n})},delete(n){m.delete(n)&&u.listener?.({op:3,id:n})},get(n){return m.get(n)},toJSON(){return Array.from(m.values())}}};e.createTestItemChildren=i}),define(Te[101],Ae([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,P=(T,l)=>{const y={controllerId:l};return R.set(T,y),y};e.createPrivateApiFor=P;const F=T=>{const l=R.get(T);if(!l)throw new w.InvalidTestItemError(T?.id||"<unknown>");return l};e.getPrivateApiFor=F}),define(Te[77],Ae([1,0,13,2]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function P(l,y){return l.scheme===w.Schemas.http||l.scheme===w.Schemas.https?l:(y&&y.authority&&y.isRemote&&l.scheme===w.Schemas.file&&(l=R.URI.from({scheme:w.Schemas.vscodeRemote,authority:y.authority,path:l.path})),R.URI.from({scheme:w.Schemas.https,authority:`${l.scheme}+${F(l.authority)}.${e.webviewRootResourceAuthority}`,path:l.path,fragment:l.fragment,query:l.query}))}e.asWebviewUri=P;function F(l){return l.replace(/./g,y=>{const f=y.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?y:"-"+f.toString(16).padStart(4,"0")})}function T(l){return l.replace(/-([0-9a-f]{4})/g,(y,f)=>String.fromCharCode(parseInt(f,16)))}e.decodeAuthority=T}),define(Te[200],Ae([1,0,5,6,77]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class F{constructor(l,y,f){this._proxy=l,this._editors=y,this._remoteInfo=f,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const A=y.getVisibleTextEditors();for(const D of this._insets.values())A.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(l=>l.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(l,y,f,A,D){let a;for(const v of this._editors.getVisibleTextEditors(!0))if(v.value===l){a=v;break}if(!a)throw new Error("not a visible editor");const E=this,p=this._handlePool++,h=new w.Emitter,t=new w.Emitter,i=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(v){return(0,P.asWebviewUri)(v,E._remoteInfo)}get cspSource(){return P.webviewGenericCspSource}set options(v){this._options=v,E._proxy.$setOptions(p,v)}get options(){return this._options}set html(v){this._html=v,E._proxy.$setHtml(p,v)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(v){return E._proxy.$postMessage(p,v)}},u=new class{constructor(){this.editor=l,this.line=y,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){E._insets.has(p)&&(E._insets.delete(p),E._proxy.$disposeEditorInset(p),t.fire(),t.dispose(),h.dispose())}};return this._proxy.$createEditorInset(p,a.id,a.value.document.uri,y+1,f,A||{},D.identifier,D.extensionLocation),this._insets.set(p,{editor:l,inset:u,onDidReceiveMessage:h}),u}$onDidDispose(l){const y=this._insets.get(l);y&&y.inset.dispose()}$onDidReceiveMessage(l,y){this._insets.get(l)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=F}),define(Te[201],Ae([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,w.createDecorator)("configurationResolverService");var R;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class P extends Error{constructor(T,l){super(l),this.variable=T}}e.VariableError=P}),define(Te[202],Ae([1,0,20,73,15,25,23,90,166,201,16]),function(be,e,w,R,P,F,T,l,y,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,p,h,t){this._contributedVariables=new Map,this._context=E,this._labelService=p,this._userHomePromise=h,t&&(this._envVariablesPromise=t.then(i=>this.prepareEnv(i)))}prepareEnv(E){if(T.isWindows){const p=Object.create(null);return Object.keys(E).forEach(h=>{p[h.toLowerCase()]=E[h]}),p}return E}resolveWithEnvironment(E,p,h){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},p?p.uri:void 0,h)}async resolveAsync(E,p){const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,E?E.uri:void 0,p)}async resolveAnyBase(E,p,h,t){const i=F.deepClone(p);T.isWindows&&i.windows?Object.keys(i.windows).forEach(v=>i[v]=i.windows[v]):T.isMacintosh&&i.osx?Object.keys(i.osx).forEach(v=>i[v]=i.osx[v]):T.isLinux&&i.linux&&Object.keys(i.linux).forEach(v=>i[v]=i.linux[v]),delete i.windows,delete i.osx,delete i.linux;const u={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(u,E?E.uri:void 0,i,h,t)}async resolveAnyAsync(E,p,h){return this.resolveAnyBase(E,p,h)}async resolveAnyMap(E,p,h){const t=new Map;return{newConfig:await this.resolveAnyBase(E,p,h,t),resolvedVariables:t}}resolveWithInteractionReplace(E,p,h,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,p,h,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,p){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,p)}async recursiveResolve(E,p,h,t,i){if(P.isString(h))return this.resolveString(E,p,h,t,i);if(Array.isArray(h))return Promise.all(h.map(u=>this.recursiveResolve(E,p,u,t,i)));if(P.isObject(h)){const u=Object.create(null),v=await Promise.all(Object.keys(h).map(async _=>[await this.resolveString(E,p,_,t,i),await this.recursiveResolve(E,p,h[_],t,i)]));for(const[_,m]of v)u[_]=m;return u}return h}resolveString(E,p,h,t,i){return(0,A.replaceAsync)(h,D.VARIABLE_REGEXP,async(u,v)=>{if(v.includes(D.VARIABLE_LHS))return u;let _=await this.evaluateSingleVariable(E,u,v,p,t);return i?.set(v,_),_!==u&&P.isString(_)&&_.match(D.VARIABLE_REGEXP)&&(_=await this.resolveString(E,p,_,t,i)),_})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,p,h,t,i){let u;const v=h.split(":");v.length>1&&(h=v[0],u=v[1]);const _=r=>{const s=this._context.getFilePath();if(s)return(0,l.normalizeDriveLetter)(s);throw new f.VariableError(r,(0,y.localize)(0,null,p))},m=r=>{const s=_(r);if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return(0,l.normalizeDriveLetter)(o)}throw new f.VariableError(r,(0,y.localize)(1,null,p,w.basename(s)))},n=r=>{if(u){const s=this._context.getFolderUri(u);if(s)return s;throw new f.VariableError(r,(0,y.localize)(2,null,p,u))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new f.VariableError(r,(0,y.localize)(3,null,p)):new f.VariableError(r,(0,y.localize)(4,null,p))};switch(h){case"env":if(u){if(E.env){const r=E.env[T.isWindows?u.toLowerCase():u];if(P.isString(r))return r}return""}throw new f.VariableError(f.VariableKind.Env,(0,y.localize)(5,null,p));case"config":if(u){const r=this._context.getConfigurationValue(t,u);if(P.isUndefinedOrNull(r))throw new f.VariableError(f.VariableKind.Config,(0,y.localize)(6,null,p,u));if(P.isObject(r))throw new f.VariableError(f.VariableKind.Config,(0,y.localize)(7,null,p,u));return r}throw new f.VariableError(f.VariableKind.Config,(0,y.localize)(8,null,p));case"command":return this.resolveFromMap(f.VariableKind.Command,p,u,i,"command");case"input":return this.resolveFromMap(f.VariableKind.Input,p,u,i,"input");case"extensionInstallFolder":if(u){const r=await this._context.getExtension(u);if(!r)throw new f.VariableError(f.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,p,u));return this.fsPath(r.extensionLocation)}throw new f.VariableError(f.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,p));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,l.normalizeDriveLetter)(this.fsPath(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||u?(0,l.normalizeDriveLetter)(this.fsPath(n(f.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.normalizeDriveLetter)(w.basename(this.fsPath(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new f.VariableError(f.VariableKind.UserHome,(0,y.localize)(11,null,p))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new f.VariableError(f.VariableKind.LineNumber,(0,y.localize)(12,null,p))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new f.VariableError(f.VariableKind.SelectedText,(0,y.localize)(13,null,p))}case"file":return _(f.VariableKind.File);case"fileWorkspaceFolder":return m(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||u?w.relative(this.fsPath(n(f.VariableKind.RelativeFile)),_(f.VariableKind.RelativeFile)):_(f.VariableKind.RelativeFile);case"relativeFileDirname":{const r=w.dirname(_(f.VariableKind.RelativeFileDirname));if(t||u){const s=w.relative(this.fsPath(n(f.VariableKind.RelativeFileDirname)),r);return s.length===0?".":s}return r}case"fileDirname":return w.dirname(_(f.VariableKind.FileDirname));case"fileExtname":return w.extname(_(f.VariableKind.FileExtname));case"fileBasename":return w.basename(_(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=w.basename(_(f.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-w.extname(r).length)}case"fileDirnameBasename":return w.basename(w.dirname(_(f.VariableKind.FileDirnameBasename)));case"execPath":{const r=this._context.getExecPath();return r||p}case"execInstallFolder":{const r=this._context.getAppRoot();return r||p}case"pathSeparator":return w.sep;default:try{const r=u?`${h}:${u}`:h;return this.resolveFromMap(f.VariableKind.Unknown,p,r,i,void 0)}catch{return p}}}}resolveFromMap(E,p,h,t,i){if(h&&t){const u=i===void 0?t[h]:t[i+":"+h];if(typeof u=="string")return u;throw new f.VariableError(E,(0,y.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=D}),define(Te[102],Ae([1,0,4,99]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var F;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var l;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(l||(e.GroupsArrangement=l={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function f(p){const h=p;return(0,R.isEditorInput)(h?.editor)&&(0,R.isEditorInput)(h?.replacement)}e.isEditorReplacement=f;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function a(p){const h=p;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=a;function E(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Te[203],Ae([1,0,4,102]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function P(F){const T=F;return typeof F=="number"||(0,R.isEditorGroup)(T)}e.isPreferredGroup=P}),define(Te[204],Ae([1,0,4,172]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,w.refineServiceDecorator)(R.IEnvironmentService)}),define(Te[103],Ae([1,0,21,5,20,6]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i,u){this.versionId=i,this.removedDueToLooping=u}}e.DeltaExtensionsResult=T;class l{static isHostExtension(i,u,v){if(u.getExtensionDescription(i))return!1;const _=v.getExtensionDescription(i);return _?!!((_.main||_.browser)&&_.api==="none"):!1}constructor(i,u){this._activationEventsReader=i,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=u,this._initialize()}_initialize(){this._extensionDescriptions.sort(p),this._extensionsMap=new w.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this._extensionsMap.set(i.identifier,i),this._extensionsArr.push(i);const u=this._activationEventsReader.readActivationEvents(i);if(Array.isArray(u))for(let v of u)v==="onUri"&&(v=`onUri:${w.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(v)||this._activationMap.set(v,[]),this._activationMap.get(v).push(i)}}set(i){return this._extensionDescriptions=i,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(i,u){this._extensionDescriptions=h(this._extensionDescriptions,u),this._extensionDescriptions=this._extensionDescriptions.concat(i);const v=l._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=h(this._extensionDescriptions,v.map(_=>_.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new T(this._versionId,v)}static _findLoopingExtensions(i){const u=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(r){this._nodesSet.has(r)||(this._nodesSet.add(r),this._nodesArr.push(r))}addArc(r,s){this.addNode(r),this.addNode(s),this._arcs.has(r)?this._arcs.get(r).push(s):this._arcs.set(r,[s])}getArcs(r){return this._arcs.has(r)?this._arcs.get(r):[]}hasOnlyGoodArcs(r,s){const o=u.getArcs(r);for(let g=0;g<o.length;g++)if(!s.has(o[g]))return!1;return!0}getNodes(){return this._nodesArr}},v=new w.ExtensionIdentifierMap;for(const r of i)if(v.set(r.identifier,r),r.extensionDependencies)for(const s of r.extensionDependencies)u.addArc(w.ExtensionIdentifier.toKey(r.identifier),w.ExtensionIdentifier.toKey(s));const _=new Set;u.getNodes().filter(r=>u.getArcs(r).length===0).forEach(r=>_.add(r));const m=u.getNodes().filter(r=>!_.has(r));let n;do{n=!1;for(let r=0;r<m.length;r++){const s=m[r];u.hasOnlyGoodArcs(s,_)&&(m.splice(r,1),r--,_.add(s),n=!0)}}while(n);return m.map(r=>v.get(r))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(i)}getExtensionDescriptionsForActivationEvent(i){const u=this._activationMap.get(i);return u?u.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new y(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(i){const u=this._extensionsMap.get(i);return u||void 0}getExtensionDescriptionByUUID(i){for(const u of this._extensionsArr)if(u.uuid===i)return u}getExtensionDescriptionByIdOrUUID(i,u){return this.getExtensionDescription(i)??(u?this.getExtensionDescriptionByUUID(u):void 0)}}e.ExtensionDescriptionRegistry=l;class y{constructor(i,u){this.versionId=i,this.extensions=u}}e.ExtensionDescriptionRegistrySnapshot=y,e.basicActivationEventsReader={readActivationEvents:t=>t.activationEvents};class f{constructor(i){this._lock=new a,this._actual=new l(i,[])}async acquireLock(i){const u=await this._lock.acquire(i);return new A(this,u)}deltaExtensions(i,u,v){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(u,v)}containsActivationEvent(i){return this._actual.containsActivationEvent(i)}containsExtension(i){return this._actual.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this._actual.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(i){return this._actual.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this._actual.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,u){return this._actual.getExtensionDescriptionByIdOrUUID(i,u)}}e.LockableExtensionDescriptionRegistry=f;class A extends F.Disposable{constructor(i,u){super(),this._registry=i,this._isDisposed=!1,this._register(u)}isAcquiredFor(i){return!this._isDisposed&&this._registry===i}}e.ExtensionDescriptionRegistryLock=A;class D{constructor(i){this.name=i,this.promise=new Promise((u,v)=>{this._resolve=u})}resolve(i){this._resolve(i)}}class a{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(i){const u=new D(i);return this._pendingCustomers.push(u),this._advance(),u.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const i=this._pendingCustomers.shift();this._isLocked=!0;let u=!0;const v=setTimeout(()=>{u&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),_=()=>{u&&(clearTimeout(v),u=!1,this._isLocked=!1,this._advance())};i.resolve((0,F.toDisposable)(_))}}var E;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(E||(E={}));function p(t,i){const u=t.isBuiltin?0:t.isUnderDevelopment?2:1,v=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(u!==v)return u-v;const _=P.posix.basename(t.extensionLocation.path),m=P.posix.basename(i.extensionLocation.path);return _<m?-1:_>m?1:0}function h(t,i){const u=new w.ExtensionIdentifierSet(i);return t.filter(v=>!u.has(v.identifier))}}),define(Te[78],Ae([1,0,26]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(R||(e.UIKind=R={}));var P;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var F;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function T(f){const A=w.VSBuffer.alloc(1);switch(f){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=T;function l(f,A){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=l;var y;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Te[59],Ae([1,0,4,5,14,27,78,54,55,25,2,6,155]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class extends D.Disposable{constructor(i,u){super(),this.initData=i,this.loggerService=u,this._onDidChangeTelemetryEnabled=this._register(new R.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new R.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=A.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=u.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,a.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(u.onDidChangeLogLevel(v=>{(0,P.isLogLevel)(v)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(i,u,v){const _=this.getTelemetryDetails(),m=new p(u,v,i,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(i),{isUsageEnabled:_.isUsageEnabled,isErrorsEnabled:_.isErrorsEnabled}),n=this._telemetryLoggers.get(i.identifier.value)??[];return this._telemetryLoggers.set(i.identifier.value,[...n,m]),m.apiTelemetryLogger}$initializeTelemetryLevel(i,u,v){this._level=i,this._telemetryIsSupported=u,this._productConfig=v??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(i){const u=Object.create(null);switch(u["common.extname"]=`${i.publisher}.${i.name}`,u["common.extversion"]=i.version,u["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,u["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,u["common.vscodeversion"]=this.initData.version,u["common.isnewappinstall"]=h(this.initData.telemetryInfo.firstSessionDate),u["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:u["common.uikind"]="web";break;case T.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,l.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),u}$onDidChangeTelemetryLevel(i){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=i;const u=this.getTelemetryDetails();this._telemetryLoggers.forEach((v,_)=>{const m=v.filter(n=>!n.isDisposed);m.length===0?this._telemetryLoggers.delete(_):this._telemetryLoggers.set(_,m)}),this._telemetryLoggers.forEach(v=>{for(const _ of v)_.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(i,u){const _=this._telemetryLoggers.get(i.value)?.filter(n=>!n.isDisposed);if(!_)return this._telemetryLoggers.delete(i.value),!1;let m=!1;for(const n of _)n.ignoreUnhandledExtHostErrors||(n.logError(u),m=!0);return m}};e.ExtHostTelemetry=E,e.ExtHostTelemetry=E=Ve([He(0,F.IExtHostInitDataService),He(1,P.ILoggerService)],E);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,u,v,_,m,n,r){this._extension=v,this._logger=_,this._inLoggingOnlyMode=m,this._commonProperties=n,this._onDidChangeEnableStates=new R.Emitter,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=u?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=u?.additionalCommonProperties,this._sender=i,this._telemetryEnablements={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(i,u){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:i,isErrorsEnabled:u},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(i){let u="properties"in i?i.properties??{}:i;return u=(0,y.cleanData)(u,[]),this._additionalCommonProperties&&(u=(0,f.mixin)(u,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(u=(0,f.mixin)(u,this._commonProperties)),"properties"in i?i.properties=u:i=u,i}logEvent(i,u){this._sender&&(this._extension.publisher==="vscode"?i=this._extension.name+"/"+i:i=this._extension.identifier.value+"/"+i,u=this.mixInCommonPropsAndCleanData(u||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(i,u),this._logger.trace(i,u))}logUsage(i,u){this._telemetryEnablements.isUsageEnabled&&this.logEvent(i,u)}logError(i,u){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof i=="string")this.logEvent(i,u);else{const v={name:i.name,message:i.message,stack:i.stack,cause:i.cause},_=(0,y.cleanData)(v,[]),m=new Error(_.message,{cause:_.cause});m.stack=_.stack,m.name=_.name,u=this.mixInCommonPropsAndCleanData(u||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(m,u),this._logger.trace("exception",u)}}get apiTelemetryLogger(){if(!this._apiObject){const i=this,u={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return i._telemetryEnablements.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i._onDidChangeEnableStates.event.bind(i)};this._apiObject=Object.freeze(u)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let i=this._sender;this._sender=void 0,Promise.resolve(i.flush()).then(i=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=p;function h(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.isNewAppInstall=h,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(Te[22],Ae([1,0,5,2,181,98,21,4]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,l.createDecorator)("extensionService");class y{constructor(m){this.dependency=m}}e.MissingExtensionDependency=y;var f;(function(_){_[_.EagerAutoStart=1]="EagerAutoStart",_[_.EagerManualStart=2]="EagerManualStart",_[_.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class A{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(m,n,r){this._versionId=m,this._allExtensions=n.slice(0),this._myExtensions=r.slice(0)}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:F.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(m,n,r){if(this._versionId>m)throw new Error(`ExtensionHostExtensions: invalid versionId ${m} (current: ${this._versionId})`);const s=[],o=[],g=[],d=[],k=D(this._allExtensions),I=D(n),c=(N,H)=>N.extensionLocation.toString()===H.extensionLocation.toString()||N.isBuiltin===H.isBuiltin||N.isUserBuiltin===H.isUserBuiltin||N.isUnderDevelopment===H.isUnderDevelopment;for(const N of this._allExtensions){const H=I.get(N.identifier);if(!H){s.push(N.identifier),k.delete(N.identifier);continue}if(!c(N,H)){s.push(N.identifier),k.delete(N.identifier);continue}}for(const N of n){const H=k.get(N.identifier);if(!H){o.push(N);continue}if(!c(H,N)){s.push(H.identifier),k.delete(H.identifier);continue}}const S=new T.ExtensionIdentifierSet(this._myExtensions),b=new T.ExtensionIdentifierSet(r);for(const N of this._myExtensions)b.has(N)||g.push(N);for(const N of r)S.has(N)||d.push(N);const C=F.ImplicitActivationEvents.createActivationEventsMap(o),$={versionId:m,toRemove:s,toAdd:o,addActivationEvents:C,myToRemove:g,myToAdd:d};return this.delta($),$}delta(m){if(this._versionId>=m.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:s,myToAdd:o}=m,g=new T.ExtensionIdentifierSet(n),d=new T.ExtensionIdentifierSet(s);for(let k=0;k<this._allExtensions.length;k++)g.has(this._allExtensions[k].identifier)&&(this._allExtensions.splice(k,1),k--);for(let k=0;k<this._myExtensions.length;k++)d.has(this._myExtensions[k])&&(this._myExtensions.splice(k,1),k--);for(const k of r)this._allExtensions.push(k);for(const k of o)this._myExtensions.push(k);return m}containsExtension(m){for(const n of this._myExtensions)if(T.ExtensionIdentifier.equals(n,m))return!0;return!1}}e.ExtensionHostExtensions=A;function D(_){const m=new T.ExtensionIdentifierMap;for(const n of _)m.set(n.identifier,n);return m}function a(_,m){return _.enabledApiProposals?_.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=a;function E(_,m){if(!a(_,m))throw new Error(`Extension '${_.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${_.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${_.identifier.value}`)}e.checkProposedApiEnabled=E;class p{constructor(m,n,r,s){this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=s}}e.ActivationTimes=p;class h{constructor(m,n){this.description=m,this.value=n}}e.ExtensionPointContribution=h;var t;(function(_){_[_.Normal=0]="Normal",_[_.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(_){return{type:_.isBuiltin?0:1,isBuiltin:_.isBuiltin||_.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(_.publisher,_.name),uuid:_.uuid},manifest:_,location:_.extensionLocation,targetPlatform:_.targetPlatform,validations:[],isValid:!0}}e.toExtension=i;function u(_,m){return{identifier:new T.ExtensionIdentifier((0,P.getExtensionId)(_.manifest.publisher,_.manifest.name)),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:!!m,extensionLocation:_.location,..._.manifest,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform}}e.toExtensionDescription=u;class v{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(m,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=v}),define(Te[205],Ae([1,0,11,103,21,22,14,12]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(i,u,v,_){this.startup=i,this.codeLoadingTime=u,this.activateCallTime=v,this.activateResolvedTime=_}}e.ExtensionActivationTimes=y;class f{constructor(i){this._startup=i,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(i,u){return i===-1||u===-1?-1:u-i}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=f;class A{constructor(i,u,v,_,m,n){this.activationFailed=i,this.activationFailedError=u,this.activationTimes=v,this.module=_,this.exports=m,this.subscriptions=n}}e.ActivatedExtension=A;class D extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class a extends A{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=a;class E extends A{constructor(i){super(!0,i,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,u,v,_){this._logService=_,this._registry=i,this._globalRegistry=u,this._host=v,this._operations=new P.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[i,u]of this._operations)u.dispose()}async waitForActivatingExtensions(){const i=[];for(const[u,v]of this._operations)i.push(v.wait());await Promise.all(i)}isActivated(i){const u=this._operations.get(i);return!!(u&&u.value)}getActivatedExtension(i){const u=this._operations.get(i);if(!u||!u.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return u.value}async activateByEvent(i,u){if(this._alreadyActivatedEvents[i])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(i);await this._activateExtensions(v.map(_=>({id:_.identifier,reason:{startup:u,extensionId:_.identifier,activationEvent:i}}))),this._alreadyActivatedEvents[i]=!0}activateById(i,u){const v=this._registry.getExtensionDescription(i);if(!v)throw new Error(`Extension '${i}' is not known`);return this._activateExtensions([{id:v.identifier,reason:u}])}async _activateExtensions(i){const u=i.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(u.map(v=>v.wait()))}_handleActivationRequest(i){if(this._operations.has(i.id))return this._operations.get(i.id);if(this._isHostExtension(i.id))return this._createAndSaveOperation(i,null,[],null);const u=this._registry.getExtensionDescription(i.id);if(!u){const m=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this._createAndSaveOperation(i,null,[],new E(m));return this._host.onExtensionActivationError(i.id,m,new F.MissingExtensionDependency(i.id.value)),n}const v=[],_=typeof u.extensionDependencies>"u"?[]:u.extensionDependencies;for(const m of _){if(this._isResolvedExtension(m))continue;const n=this._operations.get(m);if(n){v.push(n);continue}if(this._isHostExtension(m)){v.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(m).identifier,reason:i.reason}));continue}const r=this._registry.getExtensionDescription(m);if(r){if(!r.main&&!r.browser)continue;v.push(this._handleActivationRequest({id:r.identifier,reason:i.reason}));continue}const s=u.displayName||u.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${m}'`),g=this._createAndSaveOperation(i,u.displayName,[],new E(o));return this._host.onExtensionActivationError(u.identifier,o,new F.MissingExtensionDependency(m)),g}return this._createAndSaveOperation(i,u.displayName,v,null)}_createAndSaveOperation(i,u,v,_){const m=new h(i.id,u,i.reason,v,_,this._host,this._logService);return this._operations.set(i.id,m),m}_isHostExtension(i){return R.ExtensionDescriptionRegistry.isHostExtension(i,this._registry,this._globalRegistry)}_isResolvedExtension(i){const u=this._globalRegistry.getExtensionDescription(i);return u?!u.main&&!u.browser:!1}};e.ExtensionsActivator=p,e.ExtensionsActivator=p=Ve([He(3,T.ILogService)],p);let h=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(i,u,v,_,m,n,r){this._id=i,this._displayName=u,this._reason=v,this._deps=_,this._value=m,this._host=n,this._logService=r,this._barrier=new l.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let i=0;i<this._deps.length;i++){const u=this._deps[i];if(u.value&&!u.value.activationFailed){this._deps.splice(i,1),i--;continue}if(u.value&&u.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);v.detail=u.value.activationFailedError,this._value=new E(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(i=>i.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(i){const u=new Error;if(i&&i.name&&(u.name=i.name),i&&i.message?u.message=`Activating extension '${this._id.value}' failed: ${i.message}.`:u.message=`Activating extension '${this._id.value}' failed: ${i}.`,i&&i.stack&&(u.stack=i.stack),this._value=new E(u),this._isDisposed&&w.isCancellationError(i))return;this._host.onExtensionActivationError(this._id,u,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(i)}}};h=Ve([He(6,T.ILogService)],h)}),define(Te[8],Ae([1,0,18,26,122,206,51,28,116,68,67,25,15,2,41,79,94,101,99,75,46,58,203,7,22]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_,m,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Ie){function Oe(q){const{selectionStartLineNumber:Re,selectionStartColumn:xe,positionLineNumber:Ke,positionColumn:We}=q,et=new r.Position(Re-1,xe-1),_t=new r.Position(Ke-1,We-1);return new r.Selection(et,_t)}Ie.to=Oe;function me(q){const{anchor:Re,active:xe}=q;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Ie.from=me})(o||(e.Selection=o={}));var g;(function(Ie){function Oe(q){if(!q)return;const{start:Re,end:xe}=q;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Ie.from=Oe;function me(q){if(!q)return;const{startLineNumber:Re,startColumn:xe,endLineNumber:Ke,endColumn:We}=q;return new r.Range(Re-1,xe-1,Ke-1,We-1)}Ie.to=me})(g||(e.Range=g={}));var d;(function(Ie){function Oe(me){switch(me){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ie.to=Oe})(d||(e.TokenType=d={}));var k;(function(Ie){function Oe(q){return new r.Position(q.lineNumber-1,q.column-1)}Ie.to=Oe;function me(q){return{lineNumber:q.line+1,column:q.character+1}}Ie.from=me})(k||(e.Position=k={}));var I;(function(Ie){function Oe(Re,xe,Ke){return(0,w.coalesce)((0,w.asArray)(Re).map(We=>me(We,xe,Ke)))}Ie.from=Oe;function me(Re,xe,Ke){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:Ke?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:q(Re.scheme,xe),pattern:Q.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:Ke?.isBuiltin}}function q(Re,xe){return xe&&typeof Re=="string"?xe.transformOutgoingScheme(Re):Re}})(I||(e.DocumentSelector=I={}));var c;(function(Ie){function Oe(q){switch(q){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ie.from=Oe;function me(q){switch(q){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ie.to=me})(c||(e.DiagnosticTag=c={}));var S;(function(Ie){function Oe(q){let Re;return q.code&&((0,a.isString)(q.code)||(0,a.isNumber)(q.code)?Re=String(q.code):Re={value:String(q.code.value),target:q.code.target}),{...g.from(q.range),message:q.message,source:q.source,code:Re,severity:C.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(b.from),tags:Array.isArray(q.tags)?(0,w.coalesce)(q.tags.map(c.from)):void 0}}Ie.from=Oe;function me(q){const Re=new r.Diagnostic(g.to(q),q.message,C.to(q.severity));return Re.source=q.source,Re.code=(0,a.isString)(q.code)?q.code:q.code?.value,Re.relatedInformation=q.relatedInformation&&q.relatedInformation.map(b.to),Re.tags=q.tags&&(0,w.coalesce)(q.tags.map(c.to)),Re}Ie.to=me})(S||(e.Diagnostic=S={}));var b;(function(Ie){function Oe(q){return{...g.from(q.location.range),message:q.message,resource:q.location.uri}}Ie.from=Oe;function me(q){return new r.DiagnosticRelatedInformation(new r.Location(q.resource,g.to(q)),q.message)}Ie.to=me})(b||(e.DiagnosticRelatedInformation=b={}));var C;(function(Ie){function Oe(q){switch(q){case r.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Oe;function me(q){switch(q){case t.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ie.to=me})(C||(e.DiagnosticSeverity=C={}));var $;(function(Ie){function Oe(q){return typeof q=="number"&&q>=r.ViewColumn.One?q-1:q===r.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}Ie.from=Oe;function me(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=me})($||(e.ViewColumn=$={}));function N(Ie){return typeof Ie.range<"u"}function H(Ie){return Ie.length===0?!0:!!N(Ie[0])}e.isDecorationOptionsArr=H;var B;(function(Ie){function Oe(We){return We.map(Ie.from)}Ie.fromMany=Oe;function me(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function q(We){let et;if(me(We)){const{language:dt,value:ft}=We;et={value:"```"+dt+`
`+ft+"\n```\n"}}else r.MarkdownString.isMarkdownString(We)?et={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?et={value:We}:et={value:""};const _t=Object.create(null);et.uris=_t;const yt=dt=>{try{let ft=E.URI.parse(dt,!0);ft=ft.with({query:Re(ft.query,_t)}),_t[dt]=ft}catch{}return""},mt=new y.marked.Renderer;return mt.link=yt,mt.image=dt=>typeof dt=="string"?yt(T.parseHrefAndDimensions(dt).href):"",(0,y.marked)(et.value,{renderer:mt}),et}Ie.from=q;function Re(We,et){if(!We)return We;let _t;try{_t=(0,f.parse)(We)}catch{}if(!_t)return We;let yt=!1;return _t=(0,D.cloneAndChange)(_t,mt=>{if(E.URI.isUri(mt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[dt]=mt,yt=!0,dt}else return}),yt?JSON.stringify(_t):We}function xe(We){const et=new r.MarkdownString(We.value,We.supportThemeIcons);return et.isTrusted=We.isTrusted,et.supportHtml=We.supportHtml,et.baseUri=We.baseUri?E.URI.from(We.baseUri):void 0,et}Ie.to=xe;function Ke(We){if(We)return typeof We=="string"?We:Ie.from(We)}Ie.fromStrict=Ke})(B||(e.MarkdownString=B={}));function L(Ie){return H(Ie)?Ie.map(Oe=>({range:g.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?B.fromMany(Oe.hoverMessage):Oe.hoverMessage?B.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ie.map(Oe=>({range:g.from(Oe)}))}e.fromRangeOrRangeWithMessage=L;function U(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?E.URI.file(Ie):Ie}e.pathOrURIToURI=U;var ie;(function(Ie){function Oe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?U(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ie.from=Oe})(ie||(e.ThemableDecorationAttachmentRenderOptions=ie={}));var X;(function(Ie){function Oe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?U(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?ie.from(me.before):void 0,after:me.after?ie.from(me.after):void 0}}Ie.from=Oe})(X||(e.ThemableDecorationRenderOptions=X={}));var ye;(function(Ie){function Oe(me){if(typeof me>"u")return me;switch(me){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Oe})(ye||(e.DecorationRangeBehavior=ye={}));var Pe;(function(Ie){function Oe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?ye.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?X.from(me.light):void 0,dark:me.dark?X.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?U(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?ie.from(me.before):void 0,after:me.after?ie.from(me.after):void 0}}Ie.from=Oe})(Pe||(e.DecorationRenderOptions=Pe={}));var De;(function(Ie){function Oe(q){return{text:q.newText,eol:q.newEol&&Je.from(q.newEol),range:g.from(q.range)}}Ie.from=Oe;function me(q){const Re=new r.TextEdit(g.to(q.range),q.text);return Re.newEol=typeof q.eol>"u"?void 0:Je.to(q.eol),Re}Ie.to=me})(De||(e.TextEdit=De={}));var pe;(function(Ie){function Oe(q,Re){const xe={edits:[]};if(q instanceof r.WorkspaceEdit){const Ke=new l.ResourceSet;for(const We of q._allEntries())We._type===1&&E.URI.isUri(We.to)&&We.from===void 0&&Ke.add(We.to);for(const We of q._allEntries())if(We._type===1){let et;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?et={type:"base64",value:(0,R.encodeBase64)(R.VSBuffer.wrap(We.options.contents))}:et={type:"dataTransferItem",id:We.options.contents._itemId}),xe.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:et},metadata:We.metadata})}else We._type===2?xe.edits.push({resource:We.uri,textEdit:De.from(We.edit),versionId:Ke.has(We.uri)?void 0:Re?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?xe.edits.push({resource:We.uri,textEdit:{range:g.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ke.has(We.uri)?void 0:Re?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?xe.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(We.uri)}):We._type===5&&xe.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Re?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(bt.from)}})}return xe}Ie.from=Oe;function me(q){const Re=new r.WorkspaceEdit,xe=new l.ResourceMap;for(const Ke of q.edits)if(Ke.textEdit){const We=Ke,et=E.URI.revive(We.resource),_t=g.to(We.textEdit.range),yt=We.textEdit.text,mt=We.textEdit.insertAsSnippet;let dt;mt?dt=r.SnippetTextEdit.replace(_t,new r.SnippetString(yt)):dt=r.TextEdit.replace(_t,yt);const ft=xe.get(et);ft?ft.push(dt):xe.set(et,[dt])}else Re.renameFile(E.URI.revive(Ke.oldResource),E.URI.revive(Ke.newResource),Ke.options);for(const[Ke,We]of xe)Re.set(Ke,We);return Re}Ie.to=me})(pe||(e.WorkspaceEdit=pe={}));var Se;(function(Ie){const Oe=Object.create(null);Oe[r.SymbolKind.File]=0,Oe[r.SymbolKind.Module]=1,Oe[r.SymbolKind.Namespace]=2,Oe[r.SymbolKind.Package]=3,Oe[r.SymbolKind.Class]=4,Oe[r.SymbolKind.Method]=5,Oe[r.SymbolKind.Property]=6,Oe[r.SymbolKind.Field]=7,Oe[r.SymbolKind.Constructor]=8,Oe[r.SymbolKind.Enum]=9,Oe[r.SymbolKind.Interface]=10,Oe[r.SymbolKind.Function]=11,Oe[r.SymbolKind.Variable]=12,Oe[r.SymbolKind.Constant]=13,Oe[r.SymbolKind.String]=14,Oe[r.SymbolKind.Number]=15,Oe[r.SymbolKind.Boolean]=16,Oe[r.SymbolKind.Array]=17,Oe[r.SymbolKind.Object]=18,Oe[r.SymbolKind.Key]=19,Oe[r.SymbolKind.Null]=20,Oe[r.SymbolKind.EnumMember]=21,Oe[r.SymbolKind.Struct]=22,Oe[r.SymbolKind.Event]=23,Oe[r.SymbolKind.Operator]=24,Oe[r.SymbolKind.TypeParameter]=25;function me(Re){return typeof Oe[Re]=="number"?Oe[Re]:6}Ie.from=me;function q(Re){for(const xe in Oe)if(Oe[xe]===Re)return Number(xe);return r.SymbolKind.Property}Ie.to=q})(Se||(e.SymbolKind=Se={}));var le;(function(Ie){function Oe(q){switch(q){case r.SymbolTag.Deprecated:return 1}}Ie.from=Oe;function me(q){switch(q){case 1:return r.SymbolTag.Deprecated}}Ie.to=me})(le||(e.SymbolTag=le={}));var ae;(function(Ie){function Oe(q){return{name:q.name,kind:Se.from(q.kind),tags:q.tags&&q.tags.map(le.from),containerName:q.containerName,location:ee.from(q.location)}}Ie.from=Oe;function me(q){const Re=new r.SymbolInformation(q.name,Se.to(q.kind),q.containerName,ee.to(q.location));return Re.tags=q.tags&&q.tags.map(le.to),Re}Ie.to=me})(ae||(e.WorkspaceSymbol=ae={}));var we;(function(Ie){function Oe(q){const Re={name:q.name||"!!MISSING: name!!",detail:q.detail,range:g.from(q.range),selectionRange:g.from(q.selectionRange),kind:Se.from(q.kind),tags:q.tags?.map(le.from)??[]};return q.children&&(Re.children=q.children.map(Oe)),Re}Ie.from=Oe;function me(q){const Re=new r.DocumentSymbol(q.name,q.detail,Se.to(q.kind),g.to(q.range),g.to(q.selectionRange));return(0,w.isNonEmptyArray)(q.tags)&&(Re.tags=q.tags.map(le.to)),q.children&&(Re.children=q.children.map(me)),Re}Ie.to=me})(we||(e.DocumentSymbol=we={}));var Z;(function(Ie){function Oe(q){const Re=new r.CallHierarchyItem(Se.to(q.kind),q.name,q.detail||"",E.URI.revive(q.uri),g.to(q.range),g.to(q.selectionRange));return Re._sessionId=q._sessionId,Re._itemId=q._itemId,Re}Ie.to=Oe;function me(q,Re,xe){if(Re=Re??q._sessionId,xe=xe??q._itemId,Re===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:xe,name:q.name,detail:q.detail,kind:Se.from(q.kind),uri:q.uri,range:g.from(q.range),selectionRange:g.from(q.selectionRange),tags:q.tags?.map(le.from)}}Ie.from=me})(Z||(e.CallHierarchyItem=Z={}));var z;(function(Ie){function Oe(me){return new r.CallHierarchyIncomingCall(Z.to(me.from),me.fromRanges.map(q=>g.to(q)))}Ie.to=Oe})(z||(e.CallHierarchyIncomingCall=z={}));var Y;(function(Ie){function Oe(me){return new r.CallHierarchyOutgoingCall(Z.to(me.to),me.fromRanges.map(q=>g.to(q)))}Ie.to=Oe})(Y||(e.CallHierarchyOutgoingCall=Y={}));var ee;(function(Ie){function Oe(q){return{range:q.range&&g.from(q.range),uri:q.uri}}Ie.from=Oe;function me(q){return new r.Location(E.URI.revive(q.uri),g.to(q.range))}Ie.to=me})(ee||(e.location=ee={}));var ve;(function(Ie){function Oe(q){const Re=q,xe=q;return{originSelectionRange:Re.originSelectionRange?g.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:xe.uri,range:g.from(Re.targetRange?Re.targetRange:xe.range),targetSelectionRange:Re.targetSelectionRange?g.from(Re.targetSelectionRange):void 0}}Ie.from=Oe;function me(q){return{targetUri:E.URI.revive(q.uri),targetRange:g.to(q.range),targetSelectionRange:q.targetSelectionRange?g.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?g.to(q.originSelectionRange):void 0}}Ie.to=me})(ve||(e.DefinitionLink=ve={}));var ge;(function(Ie){function Oe(q){return{range:g.from(q.range),contents:B.fromMany(q.contents)}}Ie.from=Oe;function me(q){return new r.Hover(q.contents.map(B.to),g.to(q.range))}Ie.to=me})(ge||(e.Hover=ge={}));var de;(function(Ie){function Oe(q){return{range:g.from(q.range),expression:q.expression}}Ie.from=Oe;function me(q){return new r.EvaluatableExpression(g.to(q.range),q.expression)}Ie.to=me})(de||(e.EvaluatableExpression=de={}));var _e;(function(Ie){function Oe(q){if(q instanceof r.InlineValueText)return{type:"text",range:g.from(q.range),text:q.text};if(q instanceof r.InlineValueVariableLookup)return{type:"variable",range:g.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Oe;function me(q){switch(q.type){case"text":return{range:g.to(q.range),text:q.text};case"variable":return{range:g.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:g.to(q.range),expression:q.expression}}}Ie.to=me})(_e||(e.InlineValue=_e={}));var re;(function(Ie){function Oe(q){return{frameId:q.frameId,stoppedLocation:g.from(q.stoppedLocation)}}Ie.from=Oe;function me(q){return new r.InlineValueContext(q.frameId,g.to(q.stoppedLocation))}Ie.to=me})(re||(e.InlineValueContext=re={}));var ue;(function(Ie){function Oe(q){return{range:g.from(q.range),kind:q.kind}}Ie.from=Oe;function me(q){return new r.DocumentHighlight(g.to(q.range),q.kind)}Ie.to=me})(ue||(e.DocumentHighlight=ue={}));var ne;(function(Ie){function Oe(me){switch(me){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ie.to=Oe})(ne||(e.CompletionTriggerKind=ne={}));var oe;(function(Ie){function Oe(me){return{triggerKind:ne.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ie.to=Oe})(oe||(e.CompletionContext=oe={}));var fe;(function(Ie){function Oe(q){switch(q){case r.CompletionItemTag.Deprecated:return 1}}Ie.from=Oe;function me(q){switch(q){case 1:return r.CompletionItemTag.Deprecated}}Ie.to=me})(fe||(e.CompletionItemTag=fe={}));var ke;(function(Ie){const Oe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function me(xe){return Oe.get(xe)??9}Ie.from=me;const q=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Re(xe){return q.get(xe)??r.CompletionItemKind.Property}Ie.to=Re})(ke||(e.CompletionItemKind=ke={}));var O;(function(Ie){function Oe(me,q){const Re=new r.CompletionItem(me.label);return Re.insertText=me.insertText,Re.kind=ke.to(me.kind),Re.tags=me.tags?.map(fe.to),Re.detail=me.detail,Re.documentation=T.isMarkdownString(me.documentation)?B.to(me.documentation):me.documentation,Re.sortText=me.sortText,Re.filterText=me.filterText,Re.preselect=me.preselect,Re.commitCharacters=me.commitCharacters,p.Range.isIRange(me.range)?Re.range=g.to(me.range):typeof me.range=="object"&&(Re.range={inserting:g.to(me.range.insert),replacing:g.to(me.range.replace)}),Re.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Re.insertText=new r.SnippetString(me.insertText):(Re.insertText=me.insertText,Re.textEdit=Re.range instanceof r.Range?new r.TextEdit(Re.range,Re.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Re.additionalTextEdits=me.additionalTextEdits.map(xe=>De.to(xe))),Re.command=q&&me.command?q.fromInternal(me.command):void 0,Re}Ie.to=Oe})(O||(e.CompletionItem=O={}));var W;(function(Ie){function Oe(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:B.fromStrict(q.documentation)}}Ie.from=Oe;function me(q){return{label:q.label,documentation:T.isMarkdownString(q.documentation)?B.to(q.documentation):q.documentation}}Ie.to=me})(W||(e.ParameterInformation=W={}));var j;(function(Ie){function Oe(q){return{label:q.label,documentation:B.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(W.from):[],activeParameter:q.activeParameter}}Ie.from=Oe;function me(q){return{label:q.label,documentation:T.isMarkdownString(q.documentation)?B.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(W.to):[],activeParameter:q.activeParameter}}Ie.to=me})(j||(e.SignatureInformation=j={}));var K;(function(Ie){function Oe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(j.from):[]}}Ie.from=Oe;function me(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(j.to):[]}}Ie.to=me})(K||(e.SignatureHelp=K={}));var V;(function(Ie){function Oe(me,q){const Re=new r.InlayHint(k.to(q.position),typeof q.label=="string"?q.label:q.label.map(J.to.bind(void 0,me)),q.kind&&ce.to(q.kind));return Re.textEdits=q.textEdits&&q.textEdits.map(De.to),Re.tooltip=T.isMarkdownString(q.tooltip)?B.to(q.tooltip):q.tooltip,Re.paddingLeft=q.paddingLeft,Re.paddingRight=q.paddingRight,Re}Ie.to=Oe})(V||(e.InlayHint=V={}));var J;(function(Ie){function Oe(me,q){const Re=new r.InlayHintLabelPart(q.label);return Re.tooltip=T.isMarkdownString(q.tooltip)?B.to(q.tooltip):q.tooltip,h.Command.is(q.command)&&(Re.command=me.fromInternal(q.command)),q.location&&(Re.location=ee.to(q.location)),Re}Ie.to=Oe})(J||(e.InlayHintLabelPart=J={}));var ce;(function(Ie){function Oe(q){return q}Ie.from=Oe;function me(q){return q}Ie.to=me})(ce||(e.InlayHintKind=ce={}));var Me;(function(Ie){function Oe(q){return{range:g.from(q.range),url:q.target,tooltip:q.tooltip}}Ie.from=Oe;function me(q){let Re;if(q.url)try{Re=typeof q.url=="string"?E.URI.parse(q.url,!0):E.URI.revive(q.url)}catch{}return new r.DocumentLink(g.to(q.range),Re)}Ie.to=me})(Me||(e.DocumentLink=Me={}));var $e;(function(Ie){function Oe(q){const Re=new r.ColorPresentation(q.label);return q.textEdit&&(Re.textEdit=De.to(q.textEdit)),q.additionalTextEdits&&(Re.additionalTextEdits=q.additionalTextEdits.map(xe=>De.to(xe))),Re}Ie.to=Oe;function me(q){return{label:q.label,textEdit:q.textEdit?De.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Re=>De.from(Re)):void 0}}Ie.from=me})($e||(e.ColorPresentation=$e={}));var Ge;(function(Ie){function Oe(q){return new r.Color(q[0],q[1],q[2],q[3])}Ie.to=Oe;function me(q){return[q.red,q.green,q.blue,q.alpha]}Ie.from=me})(Ge||(e.Color=Ge={}));var je;(function(Ie){function Oe(q){return{range:g.from(q.range)}}Ie.from=Oe;function me(q){return new r.SelectionRange(g.to(q.range))}Ie.to=me})(je||(e.SelectionRange=je={}));var Ze;(function(Ie){function Oe(me){switch(me){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ie.to=Oe})(Ze||(e.TextDocumentSaveReason=Ze={}));var Ye;(function(Ie){function Oe(q){switch(q){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Oe;function me(q){switch(q){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ie.to=me})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var Je;(function(Ie){function Oe(q){if(q===r.EndOfLine.CRLF)return 1;if(q===r.EndOfLine.LF)return 0}Ie.from=Oe;function me(q){if(q===1)return r.EndOfLine.CRLF;if(q===0)return r.EndOfLine.LF}Ie.to=me})(Je||(e.EndOfLine=Je={}));var it;(function(Ie){function Oe(me){if(typeof me=="object")return me.viewId;switch(me){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Oe})(it||(e.ProgressLocation=it={}));var tt;(function(Ie){function Oe(q){const Re={start:q.start+1,end:q.end+1};return q.kind&&(Re.kind=Ue.from(q.kind)),Re}Ie.from=Oe;function me(q){const Re={start:q.start-1,end:q.end-1};return q.kind&&(Re.kind=Ue.to(q.kind)),Re}Ie.to=me})(tt||(e.FoldingRange=tt={}));var Ue;(function(Ie){function Oe(q){if(q)switch(q){case r.FoldingRangeKind.Comment:return h.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return h.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return h.FoldingRangeKind.Region}}Ie.from=Oe;function me(q){if(q)switch(q.value){case h.FoldingRangeKind.Comment.value:return r.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports.value:return r.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region.value:return r.FoldingRangeKind.Region}}Ie.to=me})(Ue||(e.FoldingRangeKind=Ue={}));var lt;(function(Ie){function Oe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?g.from(me.selection):void 0,override:typeof me.override=="boolean"?u.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ie.from=Oe})(lt||(e.TextEditorOpenOptions=lt={}));var Q;(function(Ie){function Oe(xe){return xe instanceof r.RelativePattern?xe.toJSON():typeof xe=="string"?xe:me(xe)||q(xe)?new r.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Ie.from=Oe;function me(xe){const Ke=xe;return Ke?E.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function q(xe){const Ke=xe;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Re(xe){return typeof xe=="string"?xe:new r.RelativePattern(E.URI.revive(xe.baseUri),xe.pattern)}Ie.to=Re})(Q||(e.GlobPattern=Q={}));var G;(function(Ie){function Oe(me){if(me){if(Array.isArray(me))return me.map(Oe);if(typeof me=="string")return me;{const q=me;return{language:q.language,scheme:q.scheme,pattern:Q.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Ie.from=Oe})(G||(e.LanguageSelector=G={}));var Ee;(function(Ie){function Oe(q){return!!q&&typeof q=="object"&&"documents"in q&&Array.isArray(q.documents)&&q.documents.every(Re=>Array.isArray(Re)&&Re.every(xe=>xe&&typeof xe=="object"&&"uri"in xe&&E.URI.isUri(xe.uri)&&"version"in xe&&typeof xe.version=="number"&&"ranges"in xe&&Array.isArray(xe.ranges)&&xe.ranges.every(Ke=>Ke instanceof r.Range)))}Ie.is=Oe;function me(q){return{documents:q.documents.map(Re=>Re.map(xe=>({uri:E.URI.from(xe.uri),version:xe.version,ranges:xe.ranges.map(Ke=>g.from(Ke))})))}}Ie.from=me})(Ee||(e.MappedEditsContext=Ee={}));var Be;(function(Ie){function Oe(q){return{start:q.start,end:q.end}}Ie.from=Oe;function me(q){return new r.NotebookRange(q.start,q.end)}Ie.to=me})(Be||(e.NotebookRange=Be={}));var Ne;(function(Ie){function Oe(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Ie.to=Oe;function me(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Ie.from=me})(Ne||(e.NotebookCellExecutionSummary=Ne={}));var Xe;(function(Ie){function Oe(me){if(me===v.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(me===v.NotebookCellExecutionState.Pending)return;if(me===v.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ie.to=Oe})(Xe||(e.NotebookCellExecutionState=Xe={}));var nt;(function(Ie){function Oe(q){switch(q){case r.NotebookCellKind.Markup:return v.CellKind.Markup;case r.NotebookCellKind.Code:default:return v.CellKind.Code}}Ie.from=Oe;function me(q){switch(q){case v.CellKind.Markup:return r.NotebookCellKind.Markup;case v.CellKind.Code:default:return r.NotebookCellKind.Code}}Ie.to=me})(nt||(e.NotebookCellKind=nt={}));var pt;(function(Ie){function Oe(q){const Re={metadata:q.metadata??Object.create(null),cells:[]};for(const xe of q.cells)r.NotebookCellData.validate(xe),Re.cells.push(bt.from(xe));return Re}Ie.from=Oe;function me(q){const Re=new r.NotebookData(q.cells.map(bt.to));return(0,a.isEmptyObject)(q.metadata)||(Re.metadata=q.metadata),Re}Ie.to=me})(pt||(e.NotebookData=pt={}));var bt;(function(Ie){function Oe(q){return{cellKind:nt.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Ne.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(Vt.from):[]}}Ie.from=Oe;function me(q){return new r.NotebookCellData(nt.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(Vt.to):void 0,q.metadata,q.internalMetadata?Ne.to(q.internalMetadata):void 0)}Ie.to=me})(bt||(e.NotebookCellData=bt={}));var Pt;(function(Ie){function Oe(q){return{mime:q.mime,valueBytes:R.VSBuffer.wrap(q.data)}}Ie.from=Oe;function me(q){return new r.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}Ie.to=me})(Pt||(e.NotebookCellOutputItem=Pt={}));var Vt;(function(Ie){function Oe(q){return{outputId:q.id,items:q.items.map(Pt.from),metadata:q.metadata}}Ie.from=Oe;function me(q){const Re=q.items.map(Pt.to);return new r.NotebookCellOutput(Re,q.outputId,q.metadata)}Ie.to=me})(Vt||(e.NotebookCellOutput=Vt={}));var qt;(function(Ie){function Oe(Re){return q(Re)?{include:Q.from(Re.include)??void 0,exclude:Q.from(Re.exclude)??void 0}:Q.from(Re)??void 0}Ie.from=Oe;function me(Re){return q(Re)?{include:Q.to(Re.include),exclude:Q.to(Re.exclude)}:Q.to(Re)}Ie.to=me;function q(Re){const xe=Re;return xe?!(0,a.isUndefinedOrNull)(xe.include)&&!(0,a.isUndefinedOrNull)(xe.exclude):!1}})(qt||(e.NotebookExclusiveDocumentPattern=qt={}));var Et;(function(Ie){function Oe(me,q,Re){const xe=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(xe,Re),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ie.from=Oe})(Et||(e.NotebookStatusBarItem=Et={}));var xt;(function(Ie){function Oe(me,q,Re){const xe=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:q.toInternal(xe,Re),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ie.from=Oe})(xt||(e.NotebookKernelSourceAction=xt={}));var Mt;(function(Ie){function Oe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ie.from=Oe})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var jt;(function(Ie){function Oe(q){return{uri:q.uri,provides:q.provides}}Ie.from=Oe;function me(q){return new r.NotebookRendererScript(E.URI.revive(q.uri),q.provides)}Ie.to=me})(jt||(e.NotebookRendererScript=jt={}));var $t;(function(Ie){function Oe(q){return{message:B.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,contextValue:q.contextValue,location:q.location&&{range:g.from(q.location.range),uri:q.location.uri}}}Ie.from=Oe;function me(q){const Re=new r.TestMessage(typeof q.message=="string"?q.message:B.to(q.message));return Re.actualOutput=q.actual,Re.expectedOutput=q.expected,Re.contextValue=q.contextValue,Re.location=q.location?ee.to(q.location):void 0,Re}Ie.to=me})($t||(e.TestMessage=$t={}));var Dt;(function(Ie){Ie.namespace=m.namespaceTestTag,Ie.denamespace=m.denamespaceTestTag})(Dt||(e.TestTag=Dt={}));var Ft;(function(Ie){function Oe(q){const Re=(0,i.getPrivateApiFor)(q).controllerId;return{extId:_.TestId.fromExtHostTestItem(q,Re).toString(),label:q.label,uri:E.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(xe=>Dt.namespace(Re,xe.id)),range:p.Range.lift(g.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&B.fromStrict(q.error)||null}}Ie.from=Oe;function me(q){return{parent:void 0,error:void 0,id:_.TestId.fromString(q.extId).localId,label:q.label,uri:E.URI.revive(q.uri),tags:(q.tags||[]).map(Re=>{const{tagId:xe}=Dt.denamespace(Re);return new r.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:g.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}Ie.toPlain=me})(Ft||(e.TestItem=Ft={})),function(Ie){function Oe(q){return{id:q.id}}Ie.from=Oe;function me(q){return new r.TestTag(q.id)}Ie.to=me}(Dt||(e.TestTag=Dt={}));var Bt;(function(Ie){const Oe=(q,Re)=>{const xe=[];for(const[We,et]of Re)_.TestId.compare(et.item.extId,We)===2&&(Re.delete(We),xe.push(et));const Ke={...Ft.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(et=>et.type===0).map($t.to)})),children:xe.map(We=>Oe(We,Re))};for(const We of Ke.children)We.parent=Ke;return Ke};function me(q){const Re=[],xe=new Map;for(const Ke of q.items){xe.set(Ke.item.extId,Ke);const We=_.TestId.root(Ke.item.extId);q.request.targets.some(et=>et.controllerId===We&&et.testIds.includes(Ke.item.extId))&&Re.push(Ke)}return{completedAt:q.completedAt,results:Re.map(Ke=>Oe(Ke,xe))}}Ie.to=me})(Bt||(e.TestResults=Bt={}));var Kt;(function(Ie){function Oe(xe){return{covered:xe.covered,total:xe.covered}}function me(xe){return"line"in xe?k.from(xe):g.from(xe)}function q(xe){return"branches"in xe?{count:xe.executionCount,location:me(xe.location),type:1,branches:xe.branches.length?xe.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&me(Ke.location)})):void 0}:{type:0,count:xe.executionCount,location:me(xe.location)}}Ie.fromDetailed=q;function Re(xe){return{uri:xe.uri,statement:Oe(xe.statementCoverage),branch:xe.branchCoverage&&Oe(xe.branchCoverage),function:xe.functionCoverage&&Oe(xe.functionCoverage),details:xe.detailedCoverage?.map(q)}}Ie.fromFile=Re})(Kt||(e.TestCoverage=Kt={}));var zt;(function(Ie){function Oe(me){switch(me){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ie.to=Oe})(zt||(e.CodeActionTriggerKind=zt={}));var Ht;(function(Ie){function Oe(q){const Re=new r.TypeHierarchyItem(Se.to(q.kind),q.name,q.detail||"",E.URI.revive(q.uri),g.to(q.range),g.to(q.selectionRange));return Re._sessionId=q._sessionId,Re._itemId=q._itemId,Re}Ie.to=Oe;function me(q,Re,xe){if(Re=Re??q._sessionId,xe=xe??q._itemId,Re===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:xe,kind:Se.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:g.from(q.range),selectionRange:g.from(q.selectionRange),tags:q.tags?.map(le.from)}}Ie.from=me})(Ht||(e.TypeHierarchyItem=Ht={}));var Nt;(function(Ie){function Oe(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ie.from=Oe})(Nt||(e.ViewBadge=Nt={}));var at;(function(Ie){function Oe(xe,Ke,We){const et=Ke.fileData;return et?new r.InternalFileDataTransferItem(new r.DataTransferFile(et.name,E.URI.revive(et.uri),et.id,(0,F.createSingleCallFunction)(()=>We(et.id)))):xe===A.Mimes.uriList&&Ke.uriListData?new r.InternalDataTransferItem(Re(Ke.uriListData)):new r.InternalDataTransferItem(Ke.asString)}Ie.to=Oe;async function me(xe,Ke){const We=await Ke.asString();if(xe===A.Mimes.uriList)return{asString:We,fileData:void 0,uriListData:q(We)};const et=Ke.asFile();return{asString:We,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ie.from=me;function q(xe){return P.UriList.split(xe).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return E.URI.parse(Ke)}catch{}return Ke})}function Re(xe){return P.UriList.create(xe.map(Ke=>typeof Ke=="string"?Ke:E.URI.revive(Ke)))}})(at||(e.DataTransferItem=at={}));var ht;(function(Ie){function Oe(q,Re){const xe=q.items.map(([Ke,We])=>[Ke,at.to(Ke,We,Re)]);return new r.DataTransfer(xe)}Ie.toDataTransfer=Oe;async function me(q){const Re={items:[]},xe=[];for(const[Ke,We]of q)xe.push((async()=>{Re.items.push([Ke,await at.from(Ke,We)])})());return await Promise.all(xe),Re}Ie.from=me})(ht||(e.DataTransfer=ht={}));var Tt;(function(Ie){function Oe(q){return{message:q.message,metadata:q.metadata,title:q.title,tooltip:q.tooltip}}Ie.to=Oe;function me(q){return{kind:"reply",message:q.message,metadata:q.metadata,title:q.title,tooltip:q.tooltip}}Ie.from=me})(Tt||(e.ChatReplyFollowup=Tt={}));var Wt;(function(Ie){function Oe(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:Tt.from(me)}Ie.from=Oe})(Wt||(e.ChatFollowup=Wt={}));var At;(function(Ie){function Oe(q){const Re=new r.ChatMessage(ot.to(q.role),q.content);return Re.name=q.name,Re}Ie.to=Oe;function me(q){return{role:ot.from(q.role),content:q.content,name:q.name}}Ie.from=me})(At||(e.ChatMessage=At={}));var ot;(function(Ie){function Oe(q){switch(q){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ie.to=Oe;function me(q){switch(q){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ie.from=me})(ot||(e.ChatMessageRole=ot={}));var wt;(function(Ie){function Oe(Re){const xe={};for(const Ke of Object.keys(Re))xe[Ke]=Re[Ke].map(Ie.to);return xe}Ie.objectTo=Oe;function me(Re){return{level:Lt.to(Re.level),value:Re.value,description:Re.description}}Ie.to=me;function q(Re){return{level:Lt.from(Re.level),value:Re.value,description:Re.description}}Ie.from=q})(wt||(e.ChatVariable=wt={}));var Lt;(function(Ie){function Oe(q){switch(q){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ie.to=Oe;function me(q){switch(q){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ie.from=me})(Lt||(e.ChatVariableLevel=Lt={}));var kt;(function(Ie){function Oe(me){switch(me){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Ie.to=Oe})(kt||(e.InteractiveEditorResponseFeedbackKind=kt={}));var ze;(function(Ie){function Oe(me,q){return"placeholder"in q&&"resolvedContent"in q?{placeholder:q.placeholder}:"responseId"in q?{requestId:q.responseId}:"markdownContent"in q?((0,s.checkProposedApiEnabled)(me,"chatAgents2Additions"),{content:B.from(q.markdownContent)}):"content"in q?typeof q.content=="string"?q:((0,s.checkProposedApiEnabled)(me,"chatAgents2Additions"),{content:B.from(q.content)}):"documents"in q?{documents:q.documents.map(Re=>({uri:Re.uri,version:Re.version,ranges:Re.ranges.map(xe=>g.from(xe))}))}:"reference"in q?{reference:"uri"in q.reference?{uri:q.reference.uri,range:g.from(q.reference.range)}:q.reference}:"inlineReference"in q?{inlineReference:"uri"in q.inlineReference?{uri:q.inlineReference.uri,range:g.from(q.inlineReference.range)}:q.inlineReference,title:q.title}:("agentName"in q&&(0,s.checkProposedApiEnabled)(me,"chatAgents2Additions"),q)}Ie.from=Oe})(ze||(e.ChatResponseProgress=ze={}));var Gt;(function(Ie){function Oe(me,q,Re){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:q.toInternal(me,Re)}Ie.from=Oe})(Gt||(e.TerminalQuickFix=Gt={}))}),define(Te[207],Ae([1,0,2,11,7,8,174]),function(be,e,w,R,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class l{constructor(f,A,D,a={timeout:1500,errors:3}){this._logService=f,this._documents=A,this._mainThreadBulkEdits=D,this._thresholds=a,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(f){return(A,D,a)=>{const p={dispose:this._callbacks.push([A,D,f])};return Array.isArray(a)&&a.push(p),p}}async $participateInSave(f,A){const D=w.URI.revive(f);let a=!1;const E=setTimeout(()=>a=!0,this._thresholds.timeout),p=[];try{for(const h of[...this._callbacks]){if(a)break;const t=this._documents.getDocument(D),i=await this._deliverEventAsyncAndBlameBadListeners(h,{document:t,reason:F.TextDocumentSaveReason.to(A)});p.push(i)}}finally{clearTimeout(E)}return p}_deliverEventAsyncAndBlameBadListeners([f,A,D],a){const E=this._badListeners.get(f);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,f,A,a).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const h=this._badListeners.get(f);this._badListeners.set(f,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(f,A,D,a){const E=[],p=Date.now(),{document:h,reason:t}=a,{version:i}=h,u=Object.freeze({document:h,reason:t,waitUntil(v){if(Object.isFrozen(E))throw(0,R.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(v))}});try{A.apply(D,[u])}catch(v){return Promise.reject(v)}return Object.freeze(E),new Promise((v,_)=>{const m=setTimeout(()=>_(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(m),v(n)}).catch(n=>{clearTimeout(m),_(n)})}).then(v=>{const _={edits:[]};for(const m of v)if(Array.isArray(m)&&m.every(n=>n instanceof P.TextEdit))for(const{newText:n,newEol:r,range:s}of m)_.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:s&&F.Range.from(s),text:n,eol:r&&F.EndOfLine.from(r)}});if(_.edits.length!==0)return i===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(_):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=l}),define(Te[208],Ae([1,0,13,2,8,7,75]),function(be,e,w,R,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class l{constructor(D,a,E,p){this.start=D,this.deletedCount=a,this.deletedItems=E,this.items=p}asApiEvent(){return{range:new F.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(D,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,a,E){this.notebook=D,this._extHostDocument=a,this._cellData=E,this.handle=E.handle,this.uri=R.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,a=this._extHostDocument.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:a.document,get mime(){return D._mime},set mime(p){D._mime=p},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(D){this._outputs=D.map(P.NotebookCellOutput.to)}setOutputItems(D,a,E){const p=E.map(P.NotebookCellOutputItem.to),h=this._outputs.find(t=>t.id===D);if(h&&(a||(h.items.length=0),h.items.push(...p),h.items.length>1&&h.items.every(t=>T.isTextStreamMime(t.mime)))){const t=new Map,i=[];h.items.forEach(u=>{let v;t.has(u.mime)?v=t.get(u.mime):(v=[],t.set(u.mime,v),i.push(u.mime)),v.push(u.data)}),h.items.length=0,i.forEach(u=>{const v=T.compressOutputItemStreams(t.get(u));h.items.push({mime:u,data:v.data.buffer})})}}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=y;class f{static{this._handlePool=0}constructor(D,a,E,p,h){this._proxy=D,this._textDocumentsAndEditors=a,this._textDocuments=E,this.uri=p,this.handle=f._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const D=this,a={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===w.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(E){return E=D._validateIndex(E),D._cells[E].apiCell},getCells(E){return(E?D._getCells(E):D._cells).map(h=>h.apiCell)},save(){return D._save()}};this._notebook=Object.freeze(a)}return this._notebook}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,a,E){this._versionId=D.versionId,this._isDirty=a,this.acceptDocumentPropertiesChanged({metadata:E});const p={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},h=[];for(const i of D.rawEvents)i.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(i.changes,!1,p.contentChanges):i.kind===T.NotebookCellsChangeType.Move?this._moveCells(i.index,i.length,i.newIdx,p.contentChanges):i.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(i.index,i.outputs),h.push({cell:this._cells[i.index].apiCell,outputs:this._cells[i.index].apiCell.outputs})):i.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(i.index,i.outputId,i.append,i.outputItems),h.push({cell:this._cells[i.index].apiCell,outputs:this._cells[i.index].apiCell.outputs})):i.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(i.index,i.language),h.push({cell:this._cells[i.index].apiCell,document:this._cells[i.index].apiCell.document})):i.kind===T.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[i.index].apiCell,document:this._cells[i.index].apiCell.document}):i.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(i.index,i.mime):i.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(i.index,i.metadata),h.push({cell:this._cells[i.index].apiCell,metadata:this._cells[i.index].apiCell.metadata})):i.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(i.index,i.internalMetadata),h.push({cell:this._cells[i.index].apiCell,executionSummary:this._cells[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<h.length;i++){const u=h[i],v=t.get(u.cell);if(v===void 0){const _=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});t.set(u.cell,_-1)}else p.cellChanges[v]={...p.cellChanges[v],...u}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let a=D.start|0,E=D.end|0;return a<0&&(a=0),E>this._cells.length&&(E=this._cells.length),D.with({start:a,end:E})}_getCells(D){D=this._validateRange(D);const a=[];for(let E=D.start;E<D.end;E++)a.push(this._cells[E]);return a}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,a,E){if(this._disposed)return;const p=[],h=[],t=[];if(D.reverse().forEach(i=>{const v=i[2].map(n=>{const r=new y(this,this._textDocumentsAndEditors,n);return a||h.push(y.asModelAddData(this.apiNotebook,n)),r}),_=new l(i[0],i[1],[],v),m=this._cells.splice(i[0],i[1],...v);for(const n of m)t.push(n.uri),_.deletedItems.push(n.apiCell);p.push(_)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:t}),E)for(const i of p)E.push(i.asApiEvent())}_moveCells(D,a,E,p){const h=this._cells.splice(D,a);this._cells.splice(E,0,...h);const t=[new l(D,a,h.map(i=>i.apiCell),[]),new l(E,0,[],h)];for(const i of t)p.push(i.asApiEvent())}_setCellOutputs(D,a){this._cells[D].setOutputs(a)}_setCellOutputItems(D,a,E,p){this._cells[D].setOutputItems(a,E,p)}_changeCellLanguage(D,a){const E=this._cells[D];E.apiCell.document.languageId!==a&&this._textDocuments.$acceptModelLanguageChanged(E.uri,a)}_changeCellMime(D,a){const E=this._cells[D];E.apiCell.mime=a}_changeCellMetadata(D,a){this._cells[D].setMetadata(a)}_changeCellInternalMetadata(D,a){this._cells[D].setInternalMetadata(a)}getCellFromApiCell(D){return this._cells.find(a=>a.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(a=>a.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=f}),define(Te[209],Ae([1,0,5,2,8,7]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(y,f,A,D={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=f,this._mainThreadBulkEdits=A,this._thresholds=D,this._onWillSaveNotebookDocumentEvent=new w.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(f,A,D)=>{const a=function(p){f.call(A,p)};return a.extension=y,this._onWillSaveNotebookDocumentEvent.event(a,void 0,D)}}async $participateInSave(y,f,A){const D=R.URI.revive(y),a=this._notebooksAndEditors.getNotebookDocument(D);if(!a)throw new Error("Unable to resolve notebook document");const E=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:a.apiNotebook,reason:P.TextDocumentSaveReason.to(f)},A,async(h,t)=>{const i=Date.now(),u=await await Promise.resolve(h);Date.now()-i>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&u&&(u instanceof F.WorkspaceEdit?E.push(u):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(E.length===0)return!0;const p={edits:[]};for(const h of E){const{edits:t}=P.WorkspaceEdit.from(h);p.edits=p.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Te[104],Ae([1,0,11,8,7]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,y,f,A,D,a){this.id=l,this._proxy=y,this.notebookData=f,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=D,this._visibleRanges=A,this._viewColumn=a}get apiEditor(){if(!this._editor){const l=this;this._editor={get notebook(){return l.notebookData.apiNotebook},get selection(){return l._selections[0]},set selection(y){this.selections=[y]},get selections(){return l._selections},set selections(y){if(!Array.isArray(y)||!y.every(P.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");l._selections=y,l._trySetSelections(y)},get visibleRanges(){return l._visibleRanges},revealRange(y,f){l._proxy.$tryRevealRange(l.id,R.NotebookRange.from(y),f??P.NotebookEditorRevealType.Default)},get viewColumn(){return l._viewColumn}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(l){this._visible=l}_acceptVisibleRanges(l){this._visibleRanges=l}_acceptSelections(l){this._selections=l}_trySetSelections(l){this._proxy.$trySetSelections(this.id,l.map(R.NotebookRange.from))}_acceptViewColumn(l){this._viewColumn=l}}e.ExtHostNotebookEditor=F}),define(Te[210],Ae([1,0,11,5,14,8]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(y,f){this._logService=y,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new R.Emitter({onListenerError:w.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter({onListenerError:w.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,f){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,f);const A=this._notebooksAndEditors.getEditorById(y);f.visibleRanges&&A._acceptVisibleRanges(f.visibleRanges.ranges.map(F.NotebookRange.to)),f.selections&&A._acceptSelections(f.selections.selections.map(F.NotebookRange.to)),f.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),f.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const f in y)this._notebooksAndEditors.getEditorById(f)._acceptViewColumn(F.ViewColumn.to(y[f]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=Ve([He(0,P.ILogService)],T)}),define(Te[211],Ae([1,0,8,52,153,19,65,11]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,E,p){const h=this._handles++,{title:t,location:i,cancellable:u}=E,v={label:(0,P.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(h,{location:w.ProgressLocation.from(i),title:t,source:v,cancellable:u},a.isUnderDevelopment?void 0:a.identifier.value).catch(l.onUnexpectedExternalError),this._withProgress(h,p,!!u)}_withProgress(a,E,p){let h;p&&(h=new F.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,h));const t=u=>{this._proxy.$progressEnd(u),this._mapHandleToCancellationSource.delete(u),h?.dispose()};let i;try{i=E(new A(this._proxy,a),p&&h?h.token:F.CancellationToken.None)}catch(u){throw t(a),u}return i.then(u=>t(a),u=>t(a)),i}$acceptProgressCanceled(a){const E=this._mapHandleToCancellationSource.get(a);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=y;function f(D,a){return D.message=a.message,typeof a.increment=="number"&&(typeof D.increment=="number"?D.increment+=a.increment:D.increment=a.increment),D}class A extends R.Progress{constructor(a,E){super(p=>this.throttledReport(p)),this._proxy=a,this._handle=E}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,T.throttle)(100,(D,a)=>f(D,a),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Te[105],Ae([1,0,41,101,46,76,58,8,2]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const f=(v,_,m,n)=>{let r=_;return{enumerable:!0,configurable:!1,get(){return r},set(s){if(!m(r,s)){const o=r;r=s,v.listener?.(n(s,o))}}}},A=(v,_)=>v===_,D={range:(v,_)=>v===_?!0:!v||!_?!1:v.isEqual(_),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(v,_)=>!(v.length!==_.length||v.some(m=>!_.find(n=>m.id===n.id)))},a=v=>_=>({op:4,update:v(_)}),E=(v,_)=>({range:(()=>{let m;const n=a(r=>({range:w.Range.lift(l.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return m},set(r){v.listener?.({op:6}),D.range(m,r)||(m=r,v.listener?.(n(r)))}}})(),label:f(v,_,D.label,a(m=>({label:m}))),description:f(v,void 0,D.description,a(m=>({description:m}))),sortText:f(v,void 0,D.sortText,a(m=>({sortText:m}))),canResolveChildren:f(v,!1,D.canResolveChildren,m=>({op:2,state:m})),busy:f(v,!1,D.busy,a(m=>({busy:m}))),error:f(v,void 0,D.error,a(m=>({error:l.MarkdownString.fromStrict(m)||null}))),tags:f(v,[],D.tags,(m,n)=>({op:1,new:m.map(l.TestTag.from),old:n.map(l.TestTag.from)}))}),p=v=>{const _=P.TestId.fromString(v.extId),m=new t(_.controllerId,_.localId,v.label,y.URI.revive(v.uri)||void 0);return m.range=l.Range.to(v.range||void 0),m.description=v.description||void 0,m.sortText=v.sortText||void 0,m.tags=v.tags.map(n=>l.TestTag.to({id:(0,T.denamespaceTestTag)(n).tagId})),m},h=v=>{let _;for(const m of v.tests){const n=p(m.item);(0,R.getPrivateApiFor)(n).parent=_,_=n}return _};e.toItemFromContext=h;class t{constructor(_,m,n,r){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const s=(0,R.createPrivateApiFor)(this,_);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,F.createTestItemChildren)(s,R.getPrivateApiFor,t),enumerable:!0,writable:!1},...E(s,n)})}}e.TestItemImpl=t;class i extends t{constructor(_,m){super(_,_,m,void 0),this._isRoot=!0}}e.TestItemRootImpl=i;class u extends F.TestItemCollection{constructor(_,m,n){super({controllerId:_,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:R.getPrivateApiFor,getChildren:r=>r.children,root:new i(_,m),toITestItem:l.TestItem.from})}}e.ExtHostTestItemCollection=u}),define(Te[106],Ae([1,0,53,11,88,8,7]),function(be,e,w,R,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class l{static{this._Keys=new P.IdGenerator("TextEditorDecorationType")}constructor(a,E,p){const h=l._Keys.nextId();a.$registerTextEditorDecorationType(E.identifier,h,F.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:h,dispose(){a.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=l;class y{constructor(a,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,E){this._throwIfFinalized();let p=null;if(a instanceof T.Position)p=new T.Range(a,a);else if(a instanceof T.Range)p=a;else throw new Error("Unrecognized location");this._pushEdit(p,E,!1)}insert(a,E){this._throwIfFinalized(),this._pushEdit(new T.Range(a,a),E,!0)}delete(a){this._throwIfFinalized();let E=null;if(a instanceof T.Range)E=a;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(a,E,p){const h=this._document.validateRange(a);this._collectedEdits.push({range:h,text:E,forceMoveMarkers:p})}setEndOfLine(a){if(this._throwIfFinalized(),a!==T.EndOfLine.LF&&a!==T.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=a}}class f{constructor(a,E,p,h){this._proxy=a,this._id=E,this._accept(p),this._logService=h;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(i){t._setTabSize(i)},get indentSize(){return t._indentSize},set indentSize(i){t._setIndentSize(i)},get insertSpaces(){return t._insertSpaces},set insertSpaces(i){t._setInsertSpaces(i)},get cursorStyle(){return t._cursorStyle},set cursorStyle(i){t._setCursorStyle(i)},get lineNumbers(){return t._lineNumbers},set lineNumbers(i){t._setLineNumbers(i)}}}_accept(a){this._tabSize=a.tabSize,this._indentSize=a.indentSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=F.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const E=Math.floor(a);return E>0?E:null}if(typeof a=="string"){const E=parseInt(a,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(a){const E=this._validateTabSize(a);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateIndentSize(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const E=Math.floor(a);return E>0?E:null}if(typeof a=="string"){const E=parseInt(a,10);return isNaN(E)?null:E>0?E:null}return null}_setIndentSize(a){const E=this._validateIndentSize(a);if(E!==null){if(typeof E=="number"){if(this._indentSize===E)return;this._indentSize=E}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:E}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:!!a}_setInsertSpaces(a){const E=this._validateInsertSpaces(a);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:F.TextEditorLineNumbersStyle.from(a)})))}assign(a){const E={};let p=!1;if(typeof a.tabSize<"u"){const h=this._validateTabSize(a.tabSize);h==="auto"?(p=!0,E.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,p=!0,E.tabSize=h)}if(typeof a.indentSize<"u"){const h=this._validateIndentSize(a.indentSize);h==="tabSize"?(p=!0,E.indentSize=h):typeof h=="number"&&this._indentSize!==h&&(this._indentSize=h,p=!0,E.indentSize=h)}if(typeof a.insertSpaces<"u"){const h=this._validateInsertSpaces(a.insertSpaces);h==="auto"?(p=!0,E.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,p=!0,E.insertSpaces=h)}typeof a.cursorStyle<"u"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,p=!0,E.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,p=!0,E.lineNumbers=F.TextEditorLineNumbersStyle.from(a.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(a,E){E.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=f;class A{constructor(a,E,p,h,t,i,u,v){this.id=a,this._proxy=E,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new f(this._proxy,this.id,i,p),this._visibleRanges=u,this._viewColumn=v;const _=this;this.value=Object.freeze({get document(){return h.value},set document(m){throw new R.ReadonlyError("document")},get selection(){return _._selections&&_._selections[0]},set selection(m){if(!(m instanceof T.Selection))throw(0,R.illegalArgument)("selection");_._selections=[m],_._trySetSelection()},get selections(){return _._selections},set selections(m){if(!Array.isArray(m)||m.some(n=>!(n instanceof T.Selection)))throw(0,R.illegalArgument)("selections");_._selections=m,_._trySetSelection()},get visibleRanges(){return _._visibleRanges},set visibleRanges(m){throw new R.ReadonlyError("visibleRanges")},get options(){return _._options.value},set options(m){_._disposed||_._options.assign(m)},get viewColumn(){return _._viewColumn},set viewColumn(m){throw new R.ReadonlyError("viewColumn")},edit(m,n={undoStopBefore:!0,undoStopAfter:!0}){if(_._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(h.value,n);return m(r),_._applyEdit(r)},insertSnippet(m,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(_._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=_._selections.map(o=>F.Range.from(o));else if(n instanceof T.Position){const{lineNumber:o,column:g}=F.Position.from(n);s=[{startLineNumber:o,startColumn:g,endLineNumber:o,endColumn:g}]}else if(n instanceof T.Range)s=[F.Range.from(n)];else{s=[];for(const o of n)if(o instanceof T.Range)s.push(F.Range.from(o));else{const{lineNumber:g,column:d}=F.Position.from(o);s.push({startLineNumber:g,startColumn:d,endLineNumber:g,endColumn:d})}}return E.$tryInsertSnippet(a,h.value.version,m.value,s,r)},setDecorations(m,n){const r=n.length===0;r&&!_._hasDecorationsForKey.has(m.key)||(r?_._hasDecorationsForKey.delete(m.key):_._hasDecorationsForKey.add(m.key),_._runOnProxy(()=>{if(F.isDecorationOptionsArr(n))return E.$trySetDecorations(a,m.key,F.fromRangeOrRangeWithMessage(n));{const s=new Array(4*n.length);for(let o=0,g=n.length;o<g;o++){const d=n[o];s[4*o]=d.start.line+1,s[4*o+1]=d.start.character+1,s[4*o+2]=d.end.line+1,s[4*o+3]=d.end.character+1}return E.$trySetDecorationsFast(a,m.key,s)}}))},revealRange(m,n){_._runOnProxy(()=>E.$tryRevealRange(a,F.Range.from(m),n||T.TextEditorRevealType.Default))},show(m){E.$tryShowEditor(a,F.ViewColumn.from(m))},hide(){E.$tryHideEditor(a)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,w.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,w.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,w.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,w.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(F.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const E=a.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const p=E.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const u=p[t].end;if(p[t+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=E.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,h,{setEndOfLine:typeof E.setEndOfLine=="number"?F.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=A}),define(Te[212],Ae([1,0,157,24,2,5,6,193,12,7,15,18,8,51,19,125,22]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function i(_,m){if((0,A.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let n;return Array.isArray(_.highlights)&&(n=_.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:_.label,highlights:n}}}class u extends T.Disposable{constructor(m,n,r){super(),this._proxy=m,this.commands=n,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new h.TreeViewsDnDService;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(g=>s(g)?this.convertArgument(g):g):o})}registerTreeDataProvider(m,n,r){const s=this.createTreeView(m,{treeDataProvider:n},r);return{dispose:()=>s.dispose()}}createTreeView(m,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],g=!!n.dragAndDropController?.handleDrag,d=!!n.dragAndDropController?.handleDrop,k=this.createExtHostTreeView(m,n,r),I={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:g,hasHandleDrop:d,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},c=this._proxy.$registerTreeViewDataProvider(m,I),S={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,t.checkProposedApiEnabled)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,t.checkProposedApiEnabled)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(b){(0,E.isMarkdownString)(b)&&(0,t.checkProposedApiEnabled)(r,"treeViewMarkdownMessage"),k.message=b},get title(){return k.title},set title(b){k.title=b},get description(){return k.description},set description(b){k.description=b},get badge(){return k.badge},set badge(b){b!==void 0&&f.ViewBadge.isViewBadge(b)?k.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(k.badge=void 0)},reveal:(b,C)=>k.reveal(b,C),dispose:async()=>{await c,this.treeViews.delete(m),k.dispose()}};return this._register(S),S}$getChildren(m,n){const r=this.treeViews.get(m);return r?r.getChildren(n):Promise.reject(new l.NoTreeViewError(m))}async $handleDrop(m,n,r,s,o,g,d,k){const I=this.treeViews.get(m);if(!I)return Promise.reject(new l.NoTreeViewError(m));const c=a.DataTransfer.toDataTransfer(r,async S=>(await this._proxy.$resolveDropFileData(m,n,S)).buffer);return d===m&&k&&await this.addAdditionalTransferItems(c,I,k,o,g),I.onDrop(c,s,o)}async addAdditionalTransferItems(m,n,r,s,o){const g=this.treeDragAndDropService.removeDragOperationTransfer(o);if(g)(await g)?.forEach((d,k)=>{d&&m.set(k,d)});else if(o&&n.handleDrag){const d=n.handleDrag(r,m,s);this.treeDragAndDropService.addDragOperationTransfer(o,d),await d}return m}async $handleDrag(m,n,r,s){const o=this.treeViews.get(m);if(!o)return Promise.reject(new l.NoTreeViewError(m));const g=await this.addAdditionalTransferItems(new f.DataTransfer,o,n,s,r);if(!(!g||s.isCancellationRequested))return a.DataTransfer.from(g)}async $hasResolve(m){const n=this.treeViews.get(m);if(!n)throw new l.NoTreeViewError(m);return n.hasResolve}$resolve(m,n,r){const s=this.treeViews.get(m);if(!s)throw new l.NoTreeViewError(m);return s.resolveTreeItem(n,r)}$setExpanded(m,n,r){const s=this.treeViews.get(m);if(!s)throw new l.NoTreeViewError(m);s.setExpanded(n,r)}$setSelectionAndFocus(m,n,r){const s=this.treeViews.get(m);if(!s)throw new l.NoTreeViewError(m);s.setSelectionAndFocus(n,r)}$setVisible(m,n){const r=this.treeViews.get(m);if(!r){if(!n)return;throw new l.NoTreeViewError(m)}r.setVisible(n)}$changeCheckboxState(m,n){const r=this.treeViews.get(m);if(!r)throw new l.NoTreeViewError(m);r.setCheckboxState(n)}createExtHostTreeView(m,n,r){const s=this._register(new v(m,n,this._proxy,this.commands.converter,this.logService,r));return this.treeViews.set(m,s),s}convertArgument(m){const n=this.treeViews.get(m.$treeViewId);return n&&"$treeItemHandle"in m?n.getExtensionElement(m.$treeItemHandle):n&&"$focusedTreeItem"in m&&m.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=u;class v extends T.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,A.isUndefinedOrNull)(m))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(m,n,r,s,o,g){if(super(),this.viewId=m,this.proxy=r,this.commands=s,this.logService=o,this.extension=g,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new F.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new F.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new F.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new F.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new F.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new F.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new F.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,g.contributes&&g.contributes.views)for(const c in g.contributes.views)for(const S of g.contributes.views[c])S.id===m&&(this._title=S.name);this.dataProvider=n.treeDataProvider,this.dndController=n.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let d,k;const I=F.Event.debounce(this._onDidChangeData.event,(c,S)=>(c||(c={message:!1,elements:[]}),S.element!==!1&&(d||(d=new Promise(b=>k=b),this.refreshPromise=this.refreshPromise.then(()=>d)),Array.isArray(S.element)?c.elements.push(...S.element):c.elements.push(S.element)),S.message&&(c.message=!0),c),200,!0);this._register(I(({message:c,elements:S})=>{S.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=k;return d=null,this.refresh(S).then(()=>b())})),c&&this.proxy.$setMessage(this.viewId,a.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(m){const n=m?this.getExtensionElement(m):void 0;if(m&&!n)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(m);return r||(r=await this.fetchChildrenNodes(n)),r?r.map(s=>s.item):void 0}getExtensionElement(m){return this.elements.get(m)}reveal(m,n){n=n||{select:!0,focus:!1};const r=(0,A.isUndefinedOrNull)(n.select)?!0:n.select,s=(0,A.isUndefinedOrNull)(n.focus)?!1:n.focus,o=(0,A.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(g=>this.resolveTreeNode(m,g[g.length-1]).then(d=>this.proxy.$reveal(this.viewId,{item:d.item,parentChain:g.map(k=>k.item)},{select:r,focus:s,expand:o})),g=>this.logService.error(g)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:s,expand:o})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}get badge(){return this._badge}set badge(m){this._badge?.value===m?.value&&this._badge?.tooltip===m?.tooltip||(this._badge=a.ViewBadge.from(m),this.proxy.$setBadge(this.viewId,m))}setExpanded(m,n){const r=this.getExtensionElement(m);r&&(n?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelectionAndFocus(m,n){const r=!(0,D.equals)(this._selectedHandles,m);this._selectedHandles=m;const s=this._focusedHandle!==n;this._focusedHandle=n,r&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),s&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(m){const n=(await Promise.all(m.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:r.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(m,n,r){const s=[];for(const o of m){const g=this.getExtensionElement(o);g&&s.push(g)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,n,r),n}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(m,n,r){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,m,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,n){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(m);if(r){const s=this.nodes.get(r);if(s){const o=await this.dataProvider.resolveTreeItem(s.extensionItem,r,n)??s.extensionItem;return this.validateTreeItem(o),s.item.tooltip=this.getTooltip(o.tooltip),s.item.command=this.getCommand(s.disposableStore,o.command),s.item}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(n=>n?this.resolveUnknownParentChain(n).then(r=>this.resolveTreeNode(n,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}resolveParent(m){const n=this.nodes.get(m);return n?Promise.resolve(n.parent?this.elements.get(n.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,n){const r=this.nodes.get(m);return r?Promise.resolve(r):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(s=>this.createHandle(m,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const g=this.nodes.get(o);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(m){if(m){let n;if(typeof m=="string"){const r=this.getExtensionElement(m);n=r?this.nodes.get(r):void 0}else n=m;return n&&n.children||void 0}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const n=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=m?this.nodes.get(m):void 0,s=await this.dataProvider.getChildren(m);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,D.coalesce)(s||[]).map(async g=>{const d=await this.dataProvider.getTreeItem(g);return d&&!n.token.isCancellationRequested?this.createAndRegisterTreeNode(g,d,r):null}));return n.token.isCancellationRequested?void 0:(0,D.coalesce)(o)}finally{n.dispose()}}refresh(m){if(m.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(m);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const n=new Set,r=m.map(o=>this.nodes.get(o));for(const o of r)if(o&&!n.has(o.item.handle)){let g=o;for(;g&&g.parent&&r.findIndex(d=>g&&g.parent&&d&&d.item.handle===g.parent.item.handle)===-1;){const d=this.elements.get(g.parent.item.handle);g=d?this.nodes.get(d):void 0}g&&!g.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const g=this.elements.get(o);if(g){const d=this.nodes.get(g);d&&(!d.parent||!n.has(d.parent.item.handle))&&s.push(o)}}),s}refreshHandles(m){const n={};return Promise.all(m.map(r=>this.refreshNode(r).then(s=>{s&&(n[r]=s.item)}))).then(()=>Object.keys(n).length?this.proxy.$refresh(this.viewId,n):void 0)}refreshNode(m){const n=this.getExtensionElement(m);if(n){const r=this.nodes.get(n);if(r)return this.clearChildren(n),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(n)).then(s=>{if(s){const o=this.createTreeNode(n,s,r.parent);return this.updateNodeCache(n,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,n,r){const s=this.createTreeNode(m,n,r);if(n.id&&this.elements.has(s.item.handle))throw new Error((0,w.localize)(0,null,n.id));return this.addNodeToCache(m,s),this.addNodeToParentCache(s,r),s}getTooltip(m){return f.MarkdownString.isMarkdownString(m)?a.MarkdownString.from(m):m}getCommand(m,n){return n?{...this.commands.toInternal(n,m),originalId:n.command}:void 0}getCheckbox(m){if(m.checkboxState===void 0)return;let n,r,s;return typeof m.checkboxState=="number"?n=m.checkboxState:(n=m.checkboxState.state,r=m.checkboxState.tooltip,s=m.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:s}}validateTreeItem(m){if(!f.TreeItem.isTreeItem(m,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(m,n,r){this.validateTreeItem(n);const s=this._register(new T.DisposableStore),o=this.createHandle(m,n,r),g=this.getLightIconPath(n);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:i(n.label,this.extension),description:n.description,resourceUri:n.resourceUri,tooltip:this.getTooltip(n.tooltip),command:this.getCommand(s,n.command),contextValue:n.contextValue,icon:g,iconDark:this.getDarkIconPath(n)||g,themeIcon:this.getThemeIcon(n),collapsibleState:(0,A.isUndefinedOrNull)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.getCheckbox(n)},extensionItem:n,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(m){return m.iconPath instanceof f.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:n,label:r,resourceUri:s},o,g){if(n)return`${v.ID_HANDLE_PREFIX}/${n}`;const d=i(r,this.extension),k=o?o.item.handle:v.LABEL_HANDLE_PREFIX;let I=d?d.label:s?(0,R.basename)(s):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const c=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,S=this.getChildrenNodes(o)||[];let b,C=0;do{if(b=`${k}/${C}:${I}`,g||!this.elements.has(b)||c===b)break;C++}while(C<=S.length);return b}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof f.ThemeIcon))return typeof m.iconPath=="string"||P.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof f.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return P.URI.isUri(m)?m:P.URI.file(m)}addNodeToCache(m,n){this.elements.set(n.item.handle,m),this.nodes.set(m,n)}updateNodeCache(m,n,r,s){this.elements.delete(n.item.handle),this.nodes.delete(m),n.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(m,n);const o=this.getChildrenNodes(s)||[],g=o.filter(d=>d.item.handle===r.item.handle)[0];g&&o.splice(o.indexOf(g),1,n)}addNodeToParentCache(m,n){n?(n.children||(n.children=[]),n.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const n=this.nodes.get(m);if(n){if(n.children)for(const r of n.children){const s=this.elements.get(r.item.handle);s&&this.clear(s)}n.children=void 0}}else this.clearAll()}clear(m){const n=this.nodes.get(m);if(n){if(n.children)for(const r of n.children){const s=this.elements.get(r.item.handle);s&&this.clear(s)}this.nodes.delete(m),this.elements.delete(n.item.handle),n.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Te[213],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Te[214],Ae([1,0,167,11,29,92,72,30,21,213,177,98]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const a=l.Registry.as(T.Extensions.JSONContribution);class E{constructor(m,n,r){this._messageHandler=m,this._extension=n,this._extensionPointId=r}_msg(m,n){this._messageHandler({type:m,message:n,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(m){this._msg(P.default.Error,m)}warn(m){this._msg(P.default.Warning,m)}info(m){this._msg(P.default.Info,m)}}e.ExtensionMessageCollector=E;class p{static _toSet(m){const n=new y.ExtensionIdentifierSet;for(let r=0,s=m.length;r<s;r++)n.add(m[r].description.identifier);return n}static compute(m,n){if(!m||!m.length)return new p(n,[]);if(!n||!n.length)return new p([],m);const r=this._toSet(m),s=this._toSet(n),o=n.filter(d=>!r.has(d.description.identifier)),g=m.filter(d=>!s.has(d.description.identifier));return new p(o,g)}constructor(m,n){this.added=m,this.removed=n}}e.ExtensionPointUserDelta=p;class h{constructor(m,n){this.name=m,this.defaultExtensionKind=n,this._handler=null,this._users=null,this._delta=null}setHandler(m){if(this._handler!==null)throw new Error("Handler already set!");this._handler=m,this._handle()}acceptUsers(m){this._delta=p.compute(this._users,m),this._users=m,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(m){(0,R.onUnexpectedError)(m)}}}e.ExtensionPoint=h;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class u{constructor(){this._extensionPoints=new Map}registerExtensionPoint(m){if(this._extensionPoints.has(m.extensionPoint))throw new Error("Duplicate extension point: "+m.extensionPoint);const n=new h(m.extensionPoint,m.defaultExtensionKind);return this._extensionPoints.set(m.extensionPoint,n),m.activationEventsGenerator&&D.ImplicitActivationEvents.register(m.extensionPoint,m.activationEventsGenerator),e.schema.properties.contributes.properties[m.extensionPoint]=m.jsonSchema,a.registerSchema(i,e.schema),n}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=u;const v={ExtensionsRegistry:"ExtensionsRegistry"};l.Registry.add(v.ExtensionsRegistry,new u),e.ExtensionsRegistry=l.Registry.as(v.ExtensionsRegistry),a.registerSchema(i,e.schema),a.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Te[215],Ae([1,0,164,15,25,214,32,5]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var f;(function(a){function E(p,h,t){if(!p)return;const i=R.isString(p.type)?p.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const u=[];if(Array.isArray(p.required))for(const v of p.required)R.isString(v)&&u.push(v);return{extensionId:h.value,taskType:i,required:u,properties:p.properties?P.deepClone(p.properties):{},when:p.when?T.ContextKeyExpr.deserialize(p.when):void 0}}a.from=E})(f||(f={}));const A=F.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,E)=>{for(const p of a)p.type&&E.push(`onTaskType:${p.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:y}});class D{constructor(){this._onDefinitionsChanged=new l.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,p)=>{A.setHandler((h,t)=>{this._schema=void 0;try{for(const i of t.removed){const u=i.value;for(const v of u)this.taskTypes&&v.type&&this.taskTypes[v.type]&&delete this.taskTypes[v.type]}for(const i of t.added){const u=i.value;for(const v of u){const _=f.from(v,i.description.identifier,i.collector);_&&(this.taskTypes[_.taskType]=_)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const p of this.all()){const h={type:"object",additionalProperties:!1};p.required.length>0&&(h.required=p.required.slice(0)),p.properties!==void 0?h.properties=P.deepClone(p.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[p.taskType]},E.push(h)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new D}),define(Te[216],Ae([1,0,165,15,24,25,32,215]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,w.localize(0,null)),e.TASKS_CATEGORY={value:w.localize(1,null),original:"Tasks"};var y;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(L){function U(ie){if(!ie)return L.Strong;switch(ie.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=U}(y||(e.ShellQuoting=y={}));var f;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var A;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(A||(e.RevealKind=A={})),function(L){function U(ie){switch(ie.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=U}(A||(e.RevealKind=A={}));var D;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(L){function U(ie){switch(ie.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=U}(D||(e.RevealProblemKind=D={}));var a;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(a||(e.PanelKind=a={})),function(L){function U(ie){switch(ie.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=U}(a||(e.PanelKind=a={}));var E;(function(L){L.defaults={echo:!0,reveal:A.Always,revealProblems:D.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var p;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(L){function U(X){switch(X.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=U;function ie(X){switch(X){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=ie}(p||(e.RuntimeType=p={}));var h;(function(L){function U(ie){return R.isString(ie)?ie:ie.value}L.value=U})(h||(e.CommandString=h={}));var t;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function U(X){return X===L.Clean._id||X===L.Build._id||X===L.Rebuild._id||X===L.Test._id}L.is=U;function ie(X){if(X!==void 0)return R.isString(X)?U(X)?{_id:X,isDefault:!1}:void 0:X}L.from=ie})(t||(e.TaskGroup=t={}));var i;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var u;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function U(ie){switch(ie){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=U})(u||(e.TaskSourceKind=u={}));var v;(function(L){L.parallel="parallel",L.sequence="sequence"})(v||(e.DependsOrder=v={}));var _;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(_||(e.RunOnOptions=_={}));var m;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:_.default,instanceLimit:1}})(m||(e.RunOptions=m={}));class n{constructor(U,ie,X,ye,Pe,De){this._label="",this._id=U,ie&&(this._label=ie),X&&(this.type=X),this.runOptions=ye,this.configurationProperties=Pe,this._source=De}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.getFolderId(),id:this._id};return JSON.stringify(U)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,ie=!1){if(U===void 0)return!1;if(R.isString(U))return U===this._label||U===this.configurationProperties.identifier||ie&&U===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),U&&(this._taskLoadMessages=this._taskLoadMessages.concat(U))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class r extends n{constructor(U,ie,X,ye,Pe,De,pe,Se){super(U,X,void 0,pe,Se,ie),this.command={},this._source=ie,this.hasDefinedMatchers=De,Pe&&(this.command=Pe)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case p.Shell:ie="shell";break;case p.Process:ie="process";break;case p.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(U){return U instanceof r}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===u.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.getFolderId();if(!U)return;let ie=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(ie+=this._source.kind);const X={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:ie};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(U){return new r(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=r;class s extends n{constructor(U,ie,X,ye,Pe,De,pe){super(U,X,ye,De,pe,ie),this._source=ie,this.configures=Pe}static is(U){return U instanceof s}fromObject(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===u.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.getFolderId();if(!U)return;let ie=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(ie+=this._source.kind);const X={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:ie};return JSON.stringify(X)}}e.ConfiguringTask=s;class o extends n{constructor(U,ie,X,ye,Pe,De,pe,Se,le){super(U,X,ye,Se,le,ie),this.defines=Pe,this.hasDefinedMatchers=pe,this.command=De,this.icon=le.icon,this.hide=le.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof o}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.getFolderId(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(U){return new o(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=o;class g extends n{constructor(U,ie,X,ye,Pe,De){super(U,X,ye,Pe,De,ie),this._source=ie}clone(){return new g(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof g}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(U){return new g(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=g;var d;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(L){L._default=L.Terminal}(d||(e.ExecutionEngine=d={}));var k;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class I{constructor(U){this._order=new Map;for(let ie=0;ie<U.length;ie++)this._order.set(U[ie].uri.toString(),ie)}compare(U,ie){const X=U.getWorkspaceFolder(),ye=ie.getWorkspaceFolder();if(X&&ye){let Pe=this._order.get(X.uri.toString());Pe=Pe===void 0?0:Pe+1;let De=this._order.get(ye.uri.toString());return De=De===void 0?0:De+1,Pe===De?U._label.localeCompare(ie._label):Pe-De}else return!X&&ye?-1:X&&!ye?1:0}}e.TaskSorter=I;var c;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(c||(e.TaskEventKind=c={}));var S;(function(L){L.SingleRun="singleRun",L.Background="background"})(S||(e.TaskRunType=S={}));var b;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var C;(function(L){function U(Se){return{taskId:Se._id,taskName:Se.configurationProperties.name,runType:Se.configurationProperties.isBackground?"background":"singleRun",group:Se.configurationProperties.group,__task:Se}}function ie(Se,le,ae){return{...U(Se),kind:"start",terminalId:le,resolvedVariables:ae}}L.start=ie;function X(Se,le,ae){return{...U(Se),kind:"processStarted",terminalId:le,processId:ae}}L.processStarted=X;function ye(Se,le,ae){return{...U(Se),kind:"processEnded",terminalId:le,exitCode:ae}}L.processEnded=ye;function Pe(Se,le,ae){return{...U(Se),kind:"terminated",exitReason:ae,terminalId:le}}L.terminated=Pe;function De(Se,le,ae){return{...U(le),kind:Se,terminalId:ae}}L.general=De;function pe(){return{kind:"changed"}}L.changed=pe})(C||(e.TaskEvent=C={}));var $;(function(L){function U(X){const ye=Object.keys(X).sort();let Pe="";for(const De of ye){let pe=X[De];pe instanceof Object?pe=U(pe):typeof pe=="string"&&(pe=pe.replace(/,/g,",,")),Pe+=De+","+pe+","}return Pe}function ie(X){const Pe={_key:U(X),type:X.taskType};return Object.assign(Pe,X),Pe}L.create=ie})($||(e.KeyedTaskIdentifier=$={}));var N;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var H;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(H||(e.TasksSchemaProperties=H={}));var B;(function(L){function U(ie,X){const ye=l.TaskDefinitionRegistry.get(ie.type);if(ye===void 0){const Se=F.deepClone(ie);return delete Se._key,$.create(Se)}const Pe=Object.create(null);Pe.type=ye.taskType;const De=new Set;ye.required.forEach(Se=>De.add(Se));const pe=ye.properties;for(const Se of Object.keys(pe)){const le=ie[Se];if(le!=null)Pe[Se]=le;else if(De.has(Se)){const ae=pe[Se];if(ae.default!==void 0)Pe[Se]=F.deepClone(ae.default);else switch(ae.type){case"boolean":Pe[Se]=!1;break;case"number":case"integer":Pe[Se]=0;break;case"string":Pe[Se]="";break;default:X.error(w.localize(2,null,JSON.stringify(ie,void 0,0),Se));return}}}return $.create(Pe)}L.createTaskIdentifier=U})(B||(e.TaskDefinition=B={}))}),define(Te[217],Ae([1,0,11]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,l)=>{this._actualOk=T,this._actualErr=l,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,l){return this._ensureActual().then(T,l)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R;class P extends R{constructor(){super(),this._hasErr=!0,this._err=new w.CancellationError}}e.CanceledLazyPromise=P}),define(Te[47],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class w{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++w.count}}e.ProxyIdentifier=w;const R=[];function P(l){const y=new w(l);return R[y.nid]=y,y}e.createProxyIdentifier=P;function F(l){return R[l].sid}e.getStringIdentifierForProxy=F;class T{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=T}),define(Te[3],Ae([1,0,47]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var P;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(P||(e.TabInputKind=P={}));var F;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var T;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var l;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var y;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var f;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class D{static{this._n=0}static mixin(t){return t._id=D._n++,t}}e.IdObject=D;var a;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var E;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var p;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents:(0,w.createProxyIdentifier)("MainThreadChatAgents"),MainThreadChatAgents2:(0,w.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,w.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,w.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,w.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,w.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,w.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,w.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,w.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,w.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,w.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,w.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,w.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents:(0,w.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatAgents2:(0,w.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,w.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,w.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,w.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Te[218],Ae([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class P{constructor(T){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(w.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,l,y){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const f=this._relatedInformationProviders.get(T);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(l,y)??[]}getRelatedInformation(T,l,y){return this._proxy.$getAiRelatedInformation(l,y)}registerRelatedInformationProvider(T,l,y){const f=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(f,y),this._proxy.$registerAiRelatedInformationProvider(f,l),new R.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(f),this._relatedInformationProviders.delete(f)})}}e.ExtHostRelatedInformation=P}),define(Te[80],Ae([1,0,4,14,3,17]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,f){this._extHostLogService=f,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(P.MainContext.MainThreadTelemetry)}report(y,f,A){const D=this.getUsageKey(y,f);this._reportedUsages.has(D)||(this._reportedUsages.add(D),f.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:y}))}getUsageKey(y,f){return`${y}-${f.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=Ve([He(0,F.IExtHostRpcService),He(1,R.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(l,y,f){}})}),define(Te[219],Ae([1,0,5,3,7,21]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(f){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new l,this._getSessionsTaskSingler=new l,this._proxy=f.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(f){return this._providers=f,Promise.resolve()}async getSession(f,A,D,a={}){const E=F.ExtensionIdentifier.toKey(f.identifier),p=[...D].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${E} ${A} ${p}`,async()=>{await this._proxy.$ensureProvider(A);const h=f.displayName||f.name;return this._proxy.$getSession(A,D,E,h,a)})}async getSessions(f,A,D){const a=F.ExtensionIdentifier.toKey(f.identifier),E=[...D].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${a} ${E}`,async()=>{await this._proxy.$ensureProvider(A);const p=f.displayName||f.name;return this._proxy.$getSessions(A,D,a,p)})}async removeSession(f,A){const D=this._authenticationProviders.get(f);return D?D.provider.removeSession(A):this._proxy.$removeSession(f,A)}registerAuthenticationProvider(f,A,D,a){if(this._authenticationProviders.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this._authenticationProviders.set(f,{label:A,provider:D,options:a??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===f)||this._providers.push({id:f,label:A});const E=D.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(f,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(f,A,a?.supportsMultipleAccounts??!1),new P.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(f);const p=this._providers.findIndex(h=>h.id===f);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(f)})}$createSession(f,A,D){const a=this._authenticationProviders.get(f);if(a)return Promise.resolve(a.provider.createSession(A,D));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,A){const D=this._authenticationProviders.get(f);if(D)return Promise.resolve(D.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,A){const D=this._authenticationProviders.get(f);if(D)return Promise.resolve(D.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,A){return this._onDidChangeSessions.fire({provider:{id:f,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T;class l{constructor(){this._inFlightPromises=new Map}getOrCreate(f,A){const D=this._inFlightPromises.get(f);if(D)return D;const a=A().finally(()=>this._inFlightPromises.delete(f));return this._inFlightPromises.set(f,a),a}}}),define(Te[220],Ae([1,0,3,17,8]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let F=class{constructor(l,y){this._proxy=l.getProxy(w.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:f=>y.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,y,f){const A=P.WorkspaceEdit.from(l,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,f?.isRefactoring??!1)}};e.ExtHostBulkEdits=F,e.ExtHostBulkEdits=F=Ve([He(0,R.IExtHostRpcService)],F)}),define(Te[221],Ae([1,0,12,5,66,6,48,146,3,8]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class A{static{this._pool=0}constructor(E,p){this.extension=E,this.provider=p,this.handle=A._pool++}}class D{static{this._nextId=0}constructor(E,p){this.logService=p,this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new R.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=E.getProxy(y.MainContext.MainThreadChat)}registerChatProvider(E,p,h){const t=new A(E,h);return this._chatProvider.set(t.handle,t),this._proxy.$registerChatProvider(t.handle,p),(0,F.toDisposable)(()=>{this._proxy.$unregisterChatProvider(t.handle),this._chatProvider.delete(t.handle)})}transferChatSession(E,p){const h=P.Iterable.find(this._chatSessions.keys(),t=>this._chatSessions.get(t)===E)??0;typeof h=="number"&&this._proxy.$transferChatSession(h,p)}sendInteractiveRequestToProvider(E,p){this._proxy.$sendRequestToProvider(E,p)}async $prepareChat(E,p,h){const t=this._chatProvider.get(E);if(!t)return;const i=await t.provider.prepareSession(p,h);if(!i)return;const u=D._nextId++;return this._chatSessions.set(u,i),{id:u,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(E,p){const h=this._chatProvider.get(E);if(!h||!h.provider.provideWelcomeMessage)return;const t=await h.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:Array.isArray(i)?i.map(u=>f.ChatReplyFollowup.from(u)):f.MarkdownString.from(i))}async $provideFollowups(E,p,h){const t=this._chatProvider.get(E);if(!t)return;const i=this._chatSessions.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,h))?.map(v=>f.ChatFollowup.from(v))}async $provideSampleQuestions(E,p){const h=this._chatProvider.get(E);if(!h||!h.provider.provideSampleQuestions)return;const t=await h.provider.provideSampleQuestions(p);if(t)return t?.map(i=>f.ChatReplyFollowup.from(i))}$removeRequest(E,p,h){const t=this._chatProvider.get(E);if(!t)return;const i=this._chatSessions.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,h)}async $provideReply(E,p,h,t){const i=this._chatProvider.get(E);if(!i)return;const u=this._chatSessions.get(p);if(!u)return;const v={session:u,message:h.message,variables:{}};if(h.variables)for(const o of Object.keys(h.variables))v.variables[o]=h.variables[o].map(f.ChatVariable.to);const _=T.StopWatch.create(!1);let m;const n={report:o=>{if(t.isCancellationRequested)return;typeof m>"u"&&(m=_.elapsed());const g=f.ChatResponseProgress.from(i.extension,o);if("placeholder"in o&&"resolvedContent"in o){const d=Promise.all([this._proxy.$acceptResponseProgress(E,p,g),o.resolvedContent]);(0,w.raceCancellation)(d,t).then(k=>{if(!k)return;const[I,c]=k;this._proxy.$acceptResponseProgress(E,p,c,I??void 0)})}else this._proxy.$acceptResponseProgress(E,p,g)}};let r;try{r=await i.provider.provideResponseWithProgress(v,n,t),r||(r={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){r={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.logService.error(o)}try{if(u.saveState&&this._chatSessions.has(p)){const o=u.saveState();this._proxy.$acceptChatState(p,o)}}catch(o){this.logService.warn(o)}const s={firstProgress:m??0,totalElapsed:_.elapsed()};return{errorDetails:r.errorDetails,timings:s}}async $provideSlashCommands(E,p,h){const t=this._chatProvider.get(E);if(!t)return;const i=this._chatSessions.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,h))?.map(v=>({...v,kind:f.CompletionItemKind.from(v.kind)}))}$releaseSession(E){this._chatSessions.delete(E)}async $onDidPerformUserAction(E){this._onDidPerformUserAction.fire(E)}}e.ExtHostChat=D}),define(Te[222],Ae([1,0,12,6,52,3,8,7]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents=void 0;class y{static{this._idPool=0}constructor(D,a,E){this._extHostChatProvider=a,this._logService=E,this._agents=new Map,this._proxy=D.getProxy(F.MainContext.MainThreadChatAgents)}registerAgent(D,a,E,p){const h=y._idPool++;return this._agents.set(h,{extension:D,agent:E}),this._proxy.$registerAgent(h,a,p),(0,R.toDisposable)(()=>{this._proxy.$unregisterAgent(h),this._agents.delete(h)})}async $invokeAgent(D,a,E,p,h){const t=this._agents.get(D);if(!t){this._logService.warn(`[CHAT](${D}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function u(){if(i)throw new Error("Only valid while executing the command")}const v=new w.DeferredPromise;h.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),10*1e3),this._extHostChatProvider.allowListExtensionWhile(t.extension,v.p);const _=t.agent({role:l.ChatMessageRole.User,content:E},{history:p.history.map(T.ChatMessage.to)},new P.Progress(m=>{u(),this._proxy.$handleProgressChunk(a,{content:f(m.message)?m.message:m.message.value})}),h);try{return await(0,w.raceCancellation)(Promise.resolve(_).then(m=>{if(m&&"followUp"in m)return{followUp:m?.followUp?.map(r=>T.ChatFollowup.from(r))}}),h)}finally{i=!0,v.complete()}}}e.ExtHostChatAgents=y;function f(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Te[223],Ae([1,0,12,19,37,5,48,15,2,147,52,3,8,7,194,22]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class t{static{this._idPool=0}constructor(v,_,m){this._extHostChatProvider=_,this._logService=m,this._agents=new Map,this._previousResultMap=new Map,this._resultsBySessionAndRequestId=new Map,this._proxy=v.getProxy(D.MainContext.MainThreadChatAgents2)}createChatAgent(v,_,m){const n=t._idPool++,r=new i(v,_,this._proxy,n,m);return this._agents.set(n,r),this._proxy.$registerAgent(n,_,{}),r.apiAgent}async $invokeAgent(v,_,m,n,r,s){this._previousResultMap.delete(_);const o=this._agents.get(v);if(!o)throw new Error(`[CHAT](${v}) CANNOT invoke agent because the agent is not registered`);let g=!1;function d(){if(g)throw new Error("Only valid while executing the command")}const k=new w.DeferredPromise;s.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this._extHostChatProvider.allowListExtensionWhile(o.extension.identifier,k.p);const I=n.command?await o.validateSlashCommand(n.command):void 0,c=T.StopWatch.create(!1);let S;try{const b=o.invoke({prompt:n.message,variables:a.ChatVariable.objectTo(n.variables),slashCommand:I},{history:r.history.map(a.ChatMessage.to)},new A.Progress(C=>{d(),typeof S>"u"&&"content"in C&&(S=c.elapsed());const $=a.ChatResponseProgress.from(o.extension,C);if("placeholder"in C&&"resolvedContent"in C){const N=Promise.all([this._proxy.$handleProgressChunk(m,$),C.resolvedContent]);(0,w.raceCancellation)(N,s).then(H=>{if(!H)return;const[B,L]=H;this._proxy.$handleProgressChunk(m,L,B??void 0)})}else this._proxy.$handleProgressChunk(m,$)}),s);return await(0,w.raceCancellation)(Promise.resolve(b).then(C=>{if(C){this._previousResultMap.set(_,C);let $=this._resultsBySessionAndRequestId.get(_);$||($=new Map,this._resultsBySessionAndRequestId.set(_,$)),$.set(m,C);const N={firstProgress:S,totalElapsed:c.elapsed()};return{errorDetails:C.errorDetails,timings:N}}else this._previousResultMap.delete(_)}),s)}catch(b){return this._logService.error(b,o.extension),{errorDetails:{message:(0,f.localize)(0,null,(0,P.toErrorMessage)(b)),responseIsIncomplete:!0}}}finally{g=!0,k.complete()}}$releaseSession(v){this._previousResultMap.delete(v),this._resultsBySessionAndRequestId.delete(v)}async $provideSlashCommands(v,_){const m=this._agents.get(v);return m?m.provideSlashCommand(_):[]}$provideFollowups(v,_,m){const n=this._agents.get(v);if(!n)return Promise.resolve([]);const r=this._previousResultMap.get(_);return r?n.provideFollowups(r,m):Promise.resolve([])}$acceptFeedback(v,_,m,n){const r=this._agents.get(v);if(!r)return;const s=this._resultsBySessionAndRequestId.get(_)?.get(m);if(!s)return;let o;switch(n){case p.InteractiveSessionVoteDirection.Down:o=E.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:o=E.ChatAgentResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze({result:s,kind:o}))}$acceptAction(v,_,m,n){const r=this._agents.get(v);if(!r)return;const s=this._resultsBySessionAndRequestId.get(_)?.get(m);s&&n.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:n.action,result:s}))}}e.ExtHostChatAgents2=t;class i{constructor(v,_,m,n,r){this.extension=v,this._id=_,this._proxy=m,this._handle=n,this._callback=r,this._onDidReceiveFeedback=new F.Emitter,this._onDidPerformAction=new F.Emitter}acceptFeedback(v){this._onDidReceiveFeedback.fire(v)}acceptAction(v){this._onDidPerformAction.fire(v)}async validateSlashCommand(v){this._lastSlashCommands||(await this.provideSlashCommand(R.CancellationToken.None),(0,l.assertType)(this._lastSlashCommands));const _=this._lastSlashCommands.find(m=>m.name===v);if(!_)throw new Error(`Unknown slashCommand: ${v}`);return _}async provideSlashCommand(v){if(!this._slashCommandProvider)return[];const _=await this._slashCommandProvider.provideSlashCommands(v);return _?(this._lastSlashCommands=_,_.map(m=>({name:m.name,description:m.description,followupPlaceholder:m.followupPlaceholder,shouldRepopulate:m.shouldRepopulate}))):[]}async provideFollowups(v,_){if(!this._followupProvider)return[];const m=await this._followupProvider.provideFollowups(v,_);return m?m.map(n=>a.ChatFollowup.from(n)):[]}get apiAgent(){let v=!1,_=!1;const m=()=>{v||_||(_=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{description:this._description??"",fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof y.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof E.ThemeIcon?this._iconPath:void 0,hasSlashCommands:this._slashCommandProvider!==void 0,hasFollowup:this._followupProvider!==void 0,isDefault:this._isDefault,isSecondary:this._isSecondary}),_=!1}))},n=this;return{get name(){return n._id},get description(){return n._description??""},set description(r){n._description=r,m()},get fullName(){return n._fullName??n.extension.displayName??n.extension.name},set fullName(r){n._fullName=r,m()},get iconPath(){return n._iconPath},set iconPath(r){n._iconPath=r,m()},get slashCommandProvider(){return n._slashCommandProvider},set slashCommandProvider(r){n._slashCommandProvider=r,m()},get followupProvider(){return n._followupProvider},set followupProvider(r){n._followupProvider=r,m()},get isDefault(){return(0,h.checkProposedApiEnabled)(n.extension,"defaultChatAgent"),n._isDefault},set isDefault(r){(0,h.checkProposedApiEnabled)(n.extension,"defaultChatAgent"),n._isDefault=r,m()},get isSecondary(){return(0,h.checkProposedApiEnabled)(n.extension,"defaultChatAgent"),n._isSecondary},set isSecondary(r){(0,h.checkProposedApiEnabled)(n.extension,"defaultChatAgent"),n._isSecondary=r,m()},get onDidReceiveFeedback(){return n._onDidReceiveFeedback.event},onDidPerformAction:(0,h.isProposedApiEnabled)(this.extension,"chatAgents2Additions")?this._onDidPerformAction.event:void 0,dispose(){v=!0,n._slashCommandProvider=void 0,n._followupProvider=void 0,n._onDidReceiveFeedback.dispose(),n._proxy.$unregisterAgent(n._handle)}}}invoke(v,_,m,n){return this._callback(v,_,m,n)}}}),define(Te[224],Ae([1,0,19,6,3,8,52,21,12,5]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class A{constructor(p,h){this.stream=new y.AsyncIterableSource,this.stream=h??new y.AsyncIterableSource;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class D{constructor(p,h){this._onDidStart=new f.Emitter,this._responseStreams=new Map,this._defaultStream=new y.AsyncIterableSource,this._isDone=!1;const t=this;this.apiObject={result:p,response:t._defaultStream.asyncIterable,onDidStartResponseStream:t._onDidStart.event,cancel(){h.cancel()}},p.finally(()=>{if(this._isDone=!0,this._responseStreams.size>0)for(const[,i]of this._responseStreams)i.stream.resolve();else this._defaultStream.resolve()})}handleFragment(p){if(this._isDone)return;let h=this._responseStreams.get(p.index);h||(this._responseStreams.size===0?h=new A(p.index,this._defaultStream):h=new A(p.index),this._responseStreams.set(p.index,h),this._onDidStart.fire(h.apiObj)),h.stream.emitOne(p.part)}}class a{static{this._idPool=1}constructor(p,h){this._logService=h,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new l.ExtensionIdentifierMap,this._proxy=p.getProxy(P.MainContext.MainThreadChatProvider)}registerProvider(p,h,t,i){const u=a._idPool++;return this._providers.set(u,{extension:p,provider:t}),this._proxy.$registerProvider(u,h,{extension:p,displayName:i.name??p.value}),(0,R.toDisposable)(()=>{this._proxy.$unregisterProvider(u),this._providers.delete(u)})}async $provideChatResponse(p,h,t,i,u){const v=this._providers.get(p);if(!v)return;const _=new T.Progress(async m=>{if(u.isCancellationRequested){this._logService.warn(`[CHAT](${v.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(h,{index:m.index,part:m.part})});return v.provider.provideChatResponse(t.map(F.ChatMessage.to),i,_,u)}allowListExtensionWhile(p,h){this._chatAccessAllowList.set(p,h),h.finally(()=>this._chatAccessAllowList.delete(p))}async requestChatResponseProvider(p,h){if(!this._chatAccessAllowList.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t._chatAccessAllowList.has(p)},makeRequest(i,u,v){if(!t._chatAccessAllowList.has(p))throw new Error("Access to chat has been revoked");const _=new w.CancellationTokenSource(v),m=Math.random()*1e6|0,n=t._proxy.$fetchResponse(p,h,m,i.map(F.ChatMessage.from),u??{},_.token),r=new D(n,_);return t._pendingRequest.set(m,{res:r}),n.finally(()=>{t._pendingRequest.delete(m)}),r.apiObject}}}async $handleResponseFragment(p,h){const t=this._pendingRequest.get(p);t&&t.res.handleFragment(h)}}e.ExtHostChatProvider=a}),define(Te[225],Ae([1,0,6,3,11,8]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class T{static{this._idPool=0}constructor(y){this._resolver=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadChatVariables)}async $resolveVariable(y,f,A){const D=this._resolver.get(y);if(D)try{const a=await D.resolver.resolve(D.data.name,{message:f},A);if(a)return a.map(F.ChatVariable.from)}catch(a){(0,P.onUnexpectedExternalError)(a)}}registerVariableResolver(y,f,A,D){const a=T._idPool++;return this._resolver.set(a,{extension:y.identifier,data:{name:f,description:A},resolver:D}),this._proxy.$registerVariable(a,{name:f,description:A}),(0,w.toDisposable)(()=>{this._resolver.delete(a),this._proxy.$unregisterVariable(a)})}}e.ExtHostChatVariables=T}),define(Te[226],Ae([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(F){const T=F.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(l){return T.$writeText(l)}})}}e.ExtHostClipboard=R}),define(Te[31],Ae([1,0,15,7,8,25,3,18,14,68,41,282,2,6,4,17,105,26,47,37,48,55,59]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{#e;#t;#i;constructor(I,c,S){this._commands=new Map,this._apiCommands=new Map,this.#e=I.getProxy(T.MainContext.MainThreadCommands),this._logService=c,this.#i=S,this.#t=I.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new s(this,b=>{const C=this._apiCommands.get(b);return C?.result===g.Void?C:void 0},c),this._argumentProcessors=[{processArgument(b){return(0,f.revive)(b)}},{processArgument(b){return(0,F.cloneAndChange)(b,function(C){if(A.Range.isIRange(C))return P.Range.to(C);if(D.Position.isIPosition(C))return P.Position.to(C);if(A.Range.isIRange(C.range)&&a.URI.isUri(C.uri))return P.location.to(C);if(C instanceof i.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(I){this._argumentProcessors.push(I)}registerApiCommand(I){const c=this.registerCommand(!1,I.id,async(...S)=>{const b=I.args.map(($,N)=>{if(!$.validate(S[N]))throw new Error(`Invalid argument '${$.name}' when running '${I.id}', received: ${typeof S[N]=="object"?JSON.stringify(S[N],null,"	"):S[N]} `);return $.convert(S[N])}),C=await this.executeCommand(I.internalId,...b);return I.result.convert(C,S,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this._apiCommands.set(I.id,I),new R.Disposable(()=>{c.dispose(),this._apiCommands.delete(I.id)})}registerCommand(I,c,S,b,C,$){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:S,thisArg:b,metadata:C,extension:$}),I&&this.#e.$registerCommand(c),new R.Disposable(()=>{this._commands.delete(c)&&I&&this.#e.$unregisterCommand(c)})}executeCommand(I,...c){return this._logService.trace("ExtHostCommands#executeCommand",I),this._doExecuteCommand(I,c,!0)}async _doExecuteCommand(I,c,S){if(this._commands.has(I))return this.#e.$fireCommandActivationEvent(I),this._executeContributedCommand(I,c,!1);{let b=!1;const C=(0,F.cloneAndChange)(c,function($){if($ instanceof R.Position)return P.Position.from($);if($ instanceof R.Range)return P.Range.from($);if($ instanceof R.Location)return P.location.from($);if(R.NotebookRange.isNotebookRange($))return P.NotebookRange.from($);if($ instanceof ArrayBuffer)return b=!0,i.VSBuffer.wrap(new Uint8Array($));if($ instanceof Uint8Array)return b=!0,i.VSBuffer.wrap($);if($ instanceof i.VSBuffer)return b=!0,$;if(!Array.isArray($))return $});try{const $=await this.#e.$executeCommand(I,b?new u.SerializableObjectWithBuffers(C):C,S);return(0,f.revive)($)}catch($){if($ instanceof Error&&$.message==="$executeCommand:retry")return this._doExecuteCommand(I,c,!1);throw $}}}async _executeContributedCommand(I,c,S){const b=this._commands.get(I);if(!b)throw new Error("Unknown command");const{callback:C,thisArg:$,metadata:N}=b;if(N?.args)for(let B=0;B<N.args.length;B++)try{(0,w.validateConstraint)(c[B],N.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${N.args[B].name}' - ${N.args[B].description}`)}const H=_.StopWatch.create();try{return await C.apply($,c)}catch(B){if(I===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...c);L&&(I=L.command)}if(this._logService.error(B,I,b.extension?.identifier),!S)throw B;if(b.extension?.identifier){const L=this.#i.onExtensionError(b.extension.identifier,B);this._logService.trace("forwarded error to extension?",L,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.toErrorMessage)(B)),this.id=I,this.source=b.extension?.displayName??b.extension?.name}}}finally{this._reportTelemetry(b,I,H.elapsed())}}_reportTelemetry(I,c,S){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new m.TelemetryTrustedValue(c),duration:S})}$executeContributedCommand(I,...c){this._logService.trace("ExtHostCommands#$executeContributedCommand",I);const S=this._commands.get(I);return S?(c=c.map(b=>this._argumentProcessors.reduce((C,$)=>$.processArgument(C,S.extension?.identifier),b)),this._executeContributedCommand(I,c,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this._logService.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(c=>(I&&(c=c.filter(S=>S[0]!=="_")),c))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[c,S]of this._commands){const{metadata:b}=S;b&&(I[c]=b)}return Promise.resolve(I)}};e.ExtHostCommands=r,e.ExtHostCommands=r=Ve([He(0,h.IExtHostRpcService),He(1,y.ILogService),He(2,n.IExtHostTelemetry)],r),e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class s{constructor(I,c,S){this._commands=I,this._lookupApiCommand=c,this._logService=S,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(I,c){if(!I)return;const S={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return S;const b=this._lookupApiCommand(I.command);if(b)S.id=b.internalId,S.arguments=b.args.map((C,$)=>C.convert(I.arguments&&I.arguments[$]));else if((0,l.isNonEmptyArray)(I.arguments)){const C=`${I.command} /${++this._cachIdPool}`;this._cache.set(C,I),c.add((0,E.toDisposable)(()=>{this._cache.delete(C),this._logService.trace("CommandsConverter#DISPOSE",C)})),S.$ident=C,S.id=this.delegatingCommandId,S.arguments=[C],this._logService.trace("CommandsConverter#CREATE",I.command,C)}return S}fromInternal(I){return typeof I.$ident=="string"?this._cache.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this._cache.get(I[0])}_executeConvertedCommand(...I){const c=this.getActualCommand(...I);return this._logService.trace("CommandsConverter#EXECUTE",I[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.CommandsConverter=s;class o{static{this.Uri=new o("uri","Uri of a text document",I=>a.URI.isUri(I),I=>I)}static{this.Position=new o("position","A position in a text document",I=>R.Position.isPosition(I),P.Position.from)}static{this.Range=new o("range","A range in a text document",I=>R.Range.isRange(I),P.Range.from)}static{this.Selection=new o("selection","A selection in a text document",I=>R.Selection.isSelection(I),P.Selection.from)}static{this.Number=new o("number","",I=>typeof I=="number",I=>I)}static{this.String=new o("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=o.Arr(o.String)}static Arr(I){return new o(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,c=>Array.isArray(c)&&c.every(S=>I.validate(S)),c=>c.map(S=>I.convert(S)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",I=>I instanceof R.CallHierarchyItem,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",I=>I instanceof R.TypeHierarchyItem,P.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VSCodium TestItem",I=>I instanceof t.TestItemImpl,P.TestItem.from)}constructor(I,c,S,b){this.name=I,this.description=c,this.validate=S,this.convert=b}optional(){return new o(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,c){return new o(I??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o;class g{static{this.Void=new g("no result",I=>I)}constructor(I,c){this.description=I,this.convert=c}}e.ApiCommandResult=g;class d{constructor(I,c,S,b,C){this.id=I,this.internalId=c,this.description=S,this.args=b,this.result=C}}e.ApiCommand=d}),define(Te[227],Ae([1,0,18,13,2,79,91,32,95,31,8,7]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const a=[new f.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(A.DocumentHighlight.to))),new f.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.isFalsyOrEmpty)(t))return;class u extends D.SymbolInformation{static to(_){const m=new u(_.name,A.SymbolKind.to(_.kind),_.containerName||"",new D.Location(i[0],A.Range.to(_.range)));return m.detail=_.detail,m.range=m.location.range,m.selectionRange=A.Range.to(_.selectionRange),m.children=_.children?_.children.map(u.to):[],m}}return t.map(u.to)})),new f.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.ApiCommandArgument.Uri,new f.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new f.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new f.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range,new f.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new f.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new f.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position,new f.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new f.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new f.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new f.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(A.location.to))),new f.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(A.Hover.to))),new f.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.ApiCommandArgument.Uri,new f.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.Position.isPosition(i)),t=>t.map(A.Position.from))],new f.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(i=>{let u;for(const v of i.reverse())u=new D.SelectionRange(A.Range.to(v),u);return u}))),new f.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.ApiCommandArgument.String.with("query","Search string")],new f.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new f.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new f.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.ApiCommandArgument.CallHierarchyItem],new f.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new f.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.ApiCommandArgument.CallHierarchyItem],new f.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new f.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new f.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position,f.ApiCommandArgument.String.with("newName","The new symbol name")],new f.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new f.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new f.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new f.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,T.decodeSemanticTokensDto)(t);if(i.type==="full")return new D.SemanticTokens(i.data,void 0)})),new f.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range.optional()],new f.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new f.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range],new f.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,T.decodeSemanticTokensDto)(t);if(i.type==="full")return new D.SemanticTokens(i.data,void 0)})),new f.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position,f.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,i,u)=>{if(!t)return new D.CompletionList([]);const v=t.suggestions.map(_=>A.CompletionItem.to(_,u));return new D.CompletionList(v,t.incomplete)})),new f.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position,f.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new f.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,i,u)=>p(v=>new D.CodeLens(A.Range.to(v.range),v.command&&u.fromInternal(v.command)))(t))),new f.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.ApiCommandArgument.Uri,new f.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.Range.isRange(t),t=>D.Selection.isSelection(t)?A.Selection.from(t):A.Range.from(t)),f.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),f.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,i,u)=>p(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(v.command)}else{const _=new D.CodeAction(v.title,v.kind?new D.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=A.WorkspaceEdit.to(v.edit)),v.command&&(_.command=u.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(t))),new f.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.ColorInformation(A.Range.to(i.range),A.Color.to(i.color))):[])),new f.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.ApiCommandArgument("color","The color to show and insert",t=>t instanceof D.Color,A.Color.from),new f.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new f.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new f.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range],new f.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,i,u)=>t.map(A.InlayHint.to.bind(void 0,u)))),new f.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(A.FoldingRange.to)})),new f.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>A.NotebookExclusiveDocumentPattern.to(i))})))),new f.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range,new f.ApiCommandArgument("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.Range,t=>A.InlineValueContext.from(t))],new f.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new f.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,y.matchesSomeScheme)(t,R.Schemas.http,R.Schemas.https),t=>t),new f.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),f.ApiCommandArgument.String.with("label","").optional()],f.ApiCommandResult.Void),new f.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.ApiCommandArgument.Uri.with("resource","Resource to open"),f.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new f.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],f.ApiCommandResult.Void),new f.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),f.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),f.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new f.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],f.ApiCommandResult.Void),new f.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new f.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.ApiCommandArgument.TypeHierarchyItem],new f.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new f.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.ApiCommandArgument.TypeHierarchyItem],new f.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new f.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.ApiCommandArgument.TestItem],f.ApiCommandResult.Void),new f.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.ApiCommandResult.Void),new f.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.ApiCommandArgument.String.with("name","The context key name"),new f.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],f.ApiCommandResult.Void),new f.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.StringArray,new f.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",t=>A.MappedEditsContext.is(t),t=>A.MappedEditsContext.from(t))],new f.ApiCommandResult("A promise that resolves to a workspace edit or null",t=>t?A.WorkspaceEdit.to(t):null))];class E{static register(i){a.forEach(i.registerApiCommand,i),this._registerValidateWhenClausesCommand(i)}static _registerValidateWhenClausesCommand(i){i.registerCommand(!1,"_validateWhenClauses",l.validateWhenClauses)}}e.ExtHostApiCommands=E;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function h(t){if(!Array.isArray(t))return;const i=[];for(const u of t)F.isLocationLink(u)?i.push(A.DefinitionLink.to(u)):i.push(A.location.to(u));return i}}),define(Te[228],Ae([1,0,12,65,5,6,2,79,21,8,7,3,22]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(p,h,t){const i=p.getProxy(D.MainContext.MainThreadComments);class u{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,h.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const k=this._commentControllers.get(d.handle);return k?k.value:d}else if(d&&d.$mid===7){const k=this._commentControllers.get(d.commentControlHandle);if(!k)return d;const I=k.getCommentThread(d.commentThreadHandle);return I?I.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const k=this._commentControllers.get(d.thread.commentControlHandle);if(!k)return d;const I=k.getCommentThread(d.thread.commentThreadHandle);return I?d.$mid===8?I.value:{thread:I.value,text:d.text}:d}else if(d&&d.$mid===10){const k=this._commentControllers.get(d.thread.commentControlHandle);if(!k)return d;const I=k.getCommentThread(d.thread.commentThreadHandle);if(!I)return d;const c=d.commentUniqueId,S=I.getCommentByUniqueId(c);return S||d}else if(d&&d.$mid===11){const k=this._commentControllers.get(d.thread.commentControlHandle);if(!k)return d;const I=k.getCommentThread(d.thread.commentThreadHandle);if(!I)return d;const c=d.text,S=d.commentUniqueId,b=I.getCommentByUniqueId(S);return b?(typeof b.body=="string"?b.body=c:b.body=new A.MarkdownString(c),b):d}return d}})}createCommentController(d,k,I){const c=u.handlePool++,S=new _(d,c,k,I);this._commentControllers.set(S.handle,S);const b=this._commentControllersByExtension.get(d.identifier)||[];return b.push(S),this._commentControllersByExtension.set(d.identifier,b),S.value}async $createCommentThreadTemplate(d,k,I){const c=this._commentControllers.get(d);c&&c.$createCommentThreadTemplate(k,I)}async $updateCommentThreadTemplate(d,k,I){const c=this._commentControllers.get(d);c&&c.$updateCommentThreadTemplate(k,I)}$deleteCommentThread(d,k){this._commentControllers.get(d)?.$deleteCommentThread(k)}$provideCommentingRanges(d,k,I){const c=this._commentControllers.get(d);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const S=t.getDocument(T.URI.revive(k));return(0,w.asPromise)(async()=>{const b=await c.commentingRangeProvider.provideCommentingRanges(S,I);let C;return Array.isArray(b)?C={ranges:b,fileComments:!1}:b?C={ranges:b.ranges||[],fileComments:b.fileComments||!1}:C=b??void 0,C}).then(b=>{let C;return b&&(C={ranges:b.ranges.map($=>f.Range.from($)),fileComments:b.fileComments}),C})}$toggleReaction(d,k,I,c,S){const b=this._commentControllers.get(d);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const C=b.getCommentThread(k);if(C){const $=C.getCommentByUniqueId(c.uniqueIdInThread);if(b!==void 0&&$&&b.reactionHandler)return b.reactionHandler($,r(S))}return Promise.resolve(void 0)})}}class v{static{this._handlePool=0}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){(d===void 0!=(this._range===void 0)||!d||!this._range||!d.isEqual(this._range))&&(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(d){this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,k,I,c,S,b,C,$){this._commentControllerHandle=k,this._id=I,this._uri=c,this._range=S,this._comments=b,this.extensionDescription=C,this._isTemplate=$,this.handle=v._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputDisposables.value=new F.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),i.$createCommentThread(k,this.handle,this._id,this._uri,f.Range.from(this._range),C.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{i.$deleteCommentThread(k,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(H){N.range=H},get comments(){return N.comments},set comments(H){N.comments=H},get collapsibleState(){return N.collapsibleState},set collapsibleState(H){N.collapsibleState=H},get canReply(){return N.canReply},set canReply(H){N.canReply=H},get contextValue(){return N.contextValue},set contextValue(H){N.contextValue=H},get label(){return N.label},set label(H){N.label=H},get state(){return N.state},set state(H){N.state=H},dispose:()=>{N.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new F.DisposableStore);const d=I=>Object.prototype.hasOwnProperty.call(this.modifications,I),k={};d("range")&&(k.range=f.Range.from(this._range)),d("label")&&(k.label=this.label),d("contextValue")&&(k.contextValue=this.contextValue??null),d("comments")&&(k.comments=this._comments.map(I=>m(this,I,this._commentsMap,this.extensionDescription))),d("collapsibleState")&&(k.collapseState=s(this._collapseState)),d("canReply")&&(k.canReply=this.canReply),d("state")&&(k.state=o(this._state)),d("isTemplate")&&(k.isTemplate=this._isTemplate),this.modifications={},i.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,k)}getCommentByUniqueId(d){for(const k of this._commentsMap){const I=k[0],c=k[1];if(d===c)return I}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}Ve([(0,R.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class _{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,i.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(d,k,I,c){this._extension=d,this._handle=k,this._id=I,this._label=c,this._threads=new Map,i.$registerCommentController(this.handle,I,c,this._extension.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(b){S.options=b},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(b){S.commentingRangeProvider=b},get reactionHandler(){return S.reactionHandler},set reactionHandler(b){S.reactionHandler=b},createCommentThread(b,C,$){return S.createCommentThread(b,C,$).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(d,k,I){k===void 0&&(0,a.checkProposedApiEnabled)(this._extension,"fileComments");const c=new v(this.id,this.handle,void 0,d,k,I,this._extension,!1);return this._threads.set(c.handle,c),c}$createCommentThreadTemplate(d,k){const I=new v(this.id,this.handle,void 0,T.URI.revive(d),f.Range.to(k),[],this._extension,!0);return I.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this._threads.set(I.handle,I),I}$updateCommentThreadTemplate(d,k){const I=this._threads.get(d);I&&(I.range=f.Range.to(k))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function m(g,d,k,I){let c=k.get(d);return c||(c=++g.commentHandle,k.set(d,c)),d.state!==void 0&&(0,a.checkProposedApiEnabled)(I,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:c,body:typeof d.body=="string"?d.body:f.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(S=>n(S)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function n(g){return{label:g.label,iconPath:g.iconPath?f.pathOrURIToURI(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function r(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?T.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function s(g){if(g!==void 0)switch(g){case A.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(g){if(g!==void 0)switch(g){case A.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new u}e.createExtHostComments=E}),define(Te[229],Ae([1,0,25,3,27,17]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(A,D){this._mainThreadConsole=A.getProxy(R.MainContext.MainThreadConsole),this._includeStack=D.consoleForward.includeStack,this._logNative=D.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,D){const a=this,E=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){a._handleConsoleCall(A,D,E,arguments)}})}_handleConsoleCall(A,D,a,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:D,arguments:y(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,a,E)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=Ve([He(0,F.IExtHostRpcService),He(1,P.IExtHostInitDataService)],T);const l=1e5;function y(f,A){const D=[];if(f.length)for(let a=0;a<f.length;a++){let E=f[a];if(typeof E>"u")E="undefined";else if(E instanceof Error){const p=E;p.stack?E=p.stack:E=p.toString()}D.push(E)}if(A){const a=new Error().stack;a&&D.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,w.safeStringify)(D);return a.length>l?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Te[107],Ae([1,0,2,3,7,4,17,14,18,16,20,22]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class{static{a=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(h,t){this._logService=t,this._provider=new Map,this._proxy=h.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,t){const i=a._handlePool++;this._provider.set(i,{provider:h,extensionDescription:t}),this._proxy.$registerDecorationProvider(i,t.identifier.value);const u=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(i,null);return}const _=(0,y.asArray)(v);if(_.length<=a._maxEventSize){this._proxy.$onDidChange(i,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,_.length);const m=_.map(s=>({uri:s,rank:(0,f.count)(s.path,"/")})),n=(0,y.groupBy)(m,(s,o)=>s.rank-o.rank||(0,f.compare)(s.uri.path,o.uri.path)),r=[];e:for(const s of n){let o;for(const g of s){const d=(0,A.dirname)(g.uri.path);if(o!==d&&(o=d,r.push(g.uri)>=a._maxEventSize))break e}}this._proxy.$onDidChange(i,r)});return new P.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(i),this._provider.delete(i)})}async $provideDecorations(h,t,i){if(!this._provider.has(h))return Object.create(null);const u=Object.create(null),{provider:v,extensionDescription:_}=this._provider.get(h);return await Promise.all(t.map(async m=>{try{const{uri:n,id:r}=m,s=await Promise.resolve(v.provideFileDecoration(w.URI.revive(n),i));if(!s)return;try{P.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,D.checkProposedApiEnabled)(_,"codiconDecoration"),u[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this._logService.warn(`INVALID decoration from extension '${_.identifier.value}': ${o}`)}}catch(n){this._logService.error(n)}})),u}};e.ExtHostDecorations=E,e.ExtHostDecorations=E=a=Ve([He(0,T.IExtHostRpcService),He(1,l.ILogService)],E),e.IExtHostDecorations=(0,F.createDecorator)("IExtHostDecorations")}),define(Te[230],Ae([1,0,148,94,2,3,7,8,5,14,28,40]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class E{#e;#t;#i;constructor(t,i,u,v,_,m,n,r){this._name=t,this._owner=i,this._maxDiagnosticsTotal=u,this._maxDiagnosticsPerFile=v,this._modelVersionIdProvider=_,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(v,u),this.#i=new A.ResourceMap(s=>m.getComparisonKey(s)),this.#e=n,this.#t=r}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(t,i){if(!t){this.clear();return}this._checkDisposed();let u=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),u=[t]}else if(Array.isArray(t)){u=[];let m;t=[...t].sort(E._compareIndexedTuplesByUri);for(const n of t){const[r,s]=n;if((!m||r.toString()!==m.toString())&&(m&&this.#i.get(m).length===0&&this.#i.delete(m),m=r,u.push(r),this.#i.set(r,[])),s)this.#i.get(r)?.push(...s);else{const o=this.#i.get(r);o&&(o.length=0)}}}if(this.#t.fire(u),!this.#e)return;const v=[];let _=0;for(const m of u){let n=[];const r=this.#i.get(m);if(r)if(r.length>this._maxDiagnosticsPerFile){n=[];const s=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const g of r)if(g.severity===s[o]&&n.push({...l.Diagnostic.from(g),modelVersionId:this._modelVersionIdProvider(m)})===this._maxDiagnosticsPerFile)break e;n.push({severity:R.MarkerSeverity.Info,message:(0,w.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=r.map(s=>({...l.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(m)}));if(v.push([m,n]),_+=n.length,_>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,v)}delete(t){this._checkDisposed(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this._owner,[[t,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(t,i){this._checkDisposed();for(const[u,v]of this)t.call(i,u,v,this)}*[Symbol.iterator](){this._checkDisposed();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this._checkDisposed();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this._checkDisposed(),Array.isArray(this.#i.get(t))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.DiagnosticCollection=E;let p=class{static{a=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*a._maxDiagnosticsPerFile}static _mapper(t){const i=new A.ResourceMap;for(const u of t)i.set(u,u);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,u,v){this._logService=i,this._fileSystemInfoService=u,this._extHostDocumentsAndEditors=v,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,a._mapper),this._proxy=t.getProxy(F.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{_collections:u,_proxy:v,_onDidChangeDiagnostics:_,_logService:m,_fileSystemInfoService:n,_extHostDocumentsAndEditors:r}=this,s=new class{$changeMany(d,k){v.$changeMany(d,k),m.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,d,k.length===0?"CLEARING":k)}$clear(d){v.$clear(d),m.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,d)}dispose(){v.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+a._idPool++,o=i;else if(!u.has(i))o=i;else{this._logService.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+a._idPool++;while(u.has(o))}return new class extends E{constructor(){super(i,o,a._maxDiagnosticsTotal,a._maxDiagnosticsPerFile,d=>r.getDocument(d)?.version,n.extUri,s,_),u.set(o,this)}dispose(){super.dispose(),u.delete(o)}}}getDiagnostics(t){if(t)return this._getDiagnostics(t);{const i=new Map,u=[];for(const v of this._collections.values())v.forEach((_,m)=>{let n=i.get(_.toString());typeof n>"u"&&(n=u.length,i.set(_.toString(),n),u.push([_,[]])),u[n][1]=u[n][1].concat(...m)});return u}}_getDiagnostics(t){let i=[];for(const u of this._collections.values())u.has(t)&&(i=i.concat(u.get(t)));return i}$acceptMarkersChange(t){if(!this._mirrorCollection){const i="_generated_mirror",u=new E(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,v=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(i,u),this._mirrorCollection=u}for(const[i,u]of t)this._mirrorCollection.set(P.URI.revive(i),u.map(l.Diagnostic.to))}};e.ExtHostDiagnostics=p,e.ExtHostDiagnostics=p=a=Ve([He(1,f.ILogService),He(2,D.IExtHostFileSystemInfo)],p)}),define(Te[231],Ae([1,0,2,3,22]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class F{constructor(l){this._proxy=l.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(l,y){return y?.allowUIResources&&(0,P.checkProposedApiEnabled)(l,"showLocal"),this._proxy.$showOpenDialog(y).then(f=>f?f.map(A=>w.URI.revive(A)):void 0)}showSaveDialog(l){return this._proxy.$showSaveDialog(l).then(y=>y?w.URI.revive(y):void 0)}}e.ExtHostDialogs=F}),define(Te[232],Ae([1,0,11,2,7,3,13,19,16]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class f{static{this._handlePool=0}constructor(D,a,E){this._documentsAndEditors=a,this._logService=E,this._documentContentProviders=new Map,this._proxy=D.getProxy(F.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,a){if(Object.keys(T.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const E=f._handlePool++;this._documentContentProviders.set(E,a),this._proxy.$registerTextContentProvider(E,D);let p;return typeof a.onDidChange=="function"&&(p=a.onDidChange(h=>{if(h.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(E,h).then(t=>{if(!t&&typeof t!="string")return;const i=this._documentsAndEditors.getDocument(h);if(!i)return;const u=(0,y.splitLines)(t);if(!i.equalLines(u))return this._proxy.$onVirtualDocumentChange(h,t)},w.onUnexpectedError)})),new P.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,a){const E=this._documentContentProviders.get(D);return E?Promise.resolve(E.provideTextDocumentContent(R.URI.revive(a),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=f}),define(Te[233],Ae([1,0,5,6,2,3,100,8,15,25,7,11]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class a{constructor(p,h){this._onDidAddDocument=new w.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidRemoveDocument=new w.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidChangeDocument=new w.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidSaveDocument=new w.Emitter({onListenerError:D.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(F.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const i of t)this._onDidRemoveDocument.fire(i.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const i of t)this._onDidAddDocument.fire(i.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const h=this._documentsAndEditors.getDocument(p);if(h)return h}getDocument(p){const h=this.getDocumentData(p);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return h.document}ensureDocumentData(p){const h=this._documentsAndEditors.getDocument(p);if(h)return Promise.resolve(h);let t=this._documentLoader.get(p.toString());return t||(t=this._proxy.$tryOpenDocument(p).then(i=>{this._documentLoader.delete(p.toString());const u=P.URI.revive(i);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(u))},i=>(this._documentLoader.delete(p.toString()),Promise.reject(i))),this._documentLoader.set(p.toString(),t)),t}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(h=>P.URI.revive(h))}$acceptModelLanguageChanged(p,h){const t=P.URI.revive(p),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");this._onDidRemoveDocument.fire(i.document),i._acceptLanguageId(h),this._onDidAddDocument.fire(i.document)}$acceptModelSaved(p){const h=P.URI.revive(p),t=this._documentsAndEditors.getDocument(h);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(p,h){const t=P.URI.revive(p),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(h),this._onDidChangeDocument.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,h,t){const i=P.URI.revive(p),u=this._documentsAndEditors.getDocument(i);if(!u)throw new Error("unknown document");u._acceptIsDirty(t),u.onEvents(h);let v;h.isUndoing?v=A.TextDocumentChangeReason.Undo:h.isRedoing&&(v=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,f.deepFreeze)({document:u.document,contentChanges:h.changes.map(_=>({range:l.Range.to(_.range),rangeOffset:_.rangeOffset,rangeLength:_.rangeLength,text:_.text})),reason:v}))}setWordDefinitionFor(p,h){(0,T.setWordDefinitionFor)(p,h)}}e.ExtHostDocuments=a}),define(Te[60],Ae([1,0,53,5,6,2,4,3,100,17,106,8,14,28,13,66,42]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class i{constructor(_){this.value=_,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let u=class{constructor(_,m){this._extHostRpc=_,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(_){this.acceptDocumentsAndEditorsDelta(_)}acceptDocumentsAndEditorsDelta(_){const m=[],n=[],r=[];if(_.removedDocuments)for(const s of _.removedDocuments){const o=F.URI.revive(s),g=this._documents.get(o);g?.unref()&&(this._documents.delete(o),m.push(g.value))}if(_.addedDocuments)for(const s of _.addedDocuments){const o=F.URI.revive(s.uri);let g=this._documents.get(o);if(g&&o.scheme!==p.Schemas.vscodeNotebookCell&&o.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);g||(g=new i(new y.ExtHostDocumentData(this._extHostRpc.getProxy(l.MainContext.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(o,g),n.push(g.value)),g.ref()}if(_.removedEditors)for(const s of _.removedEditors){const o=this._editors.get(s);this._editors.delete(s),o&&r.push(o)}if(_.addedEditors)for(const s of _.addedEditors){const o=F.URI.revive(s.documentUri);w.ok(this._documents.has(o),`document '${o}' does not exist`),w.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const g=this._documents.get(o).value,d=new A.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(l.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>g.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(k=>D.Range.to(k)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,d)}_.newActiveEditor!==void 0&&(w.ok(_.newActiveEditor===null||this._editors.has(_.newActiveEditor),`active editor '${_.newActiveEditor}' does not exist`),this._activeEditorId=_.newActiveEditor),(0,P.dispose)(m),(0,P.dispose)(r),_.removedDocuments&&this._onDidRemoveDocuments.fire(m),_.addedDocuments&&this._onDidAddDocuments.fire(n),(_.removedEditors||_.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),_.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(_){return this._documents.get(_)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),_=>_.value)}getEditor(_){return this._editors.get(_)}activeEditor(_){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return _?m:m?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=u,e.ExtHostDocumentsAndEditors=u=Ve([He(0,f.IExtHostRpcService),He(1,a.ILogService)],u),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Te[61],Ae([1,0,8,3,2,5,4,7,17,15,234]),function(be,e,w,R,P,F,T,l,y,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class D{constructor(t,i,u){this._activeTabIdGetter=u,this._parentGroup=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,i={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(i)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new l.TextTabInput(P.URI.revive(this._dto.input.uri));case 2:return new l.TextDiffTabInput(P.URI.revive(this._dto.input.original),P.URI.revive(this._dto.input.modified));case 3:return new l.TextMergeTabInput(P.URI.revive(this._dto.input.base),P.URI.revive(this._dto.input.input1),P.URI.revive(this._dto.input.input2),P.URI.revive(this._dto.input.result));case 6:return new l.CustomEditorTabInput(P.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new l.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new l.NotebookEditorTabInput(P.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new l.NotebookDiffEditorTabInput(P.URI.revive(this._dto.input.original),P.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new l.TerminalEditorTabInput;case 9:return new l.InteractiveWindowInput(P.URI.revive(this._dto.input.uri),P.URI.revive(this._dto.input.inputBoxUri));default:return}}}class a{constructor(t,i){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=i;for(const u of t.tabs)u.isActive&&(this._activeTabId=u.id),this._tabs.push(new D(u,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,i={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return w.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(u=>u.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(u=>u.apiObject))}};this._apiObject=Object.freeze(i)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const u=new D(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,u),t.tabDto.isActive&&(this._activeTabId=u.tabId),u}else if(t.kind===1){const u=this._tabs.splice(t.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return u.tabId===this._activeTabId&&(this._activeTabId=""),u}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this._tabs.splice(t.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,u),u}const i=this._tabs.find(u=>u.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this._activeTabId}}let E=class{constructor(t){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,i={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(u=>u.apiObject))},get activeTabGroup(){const u=t._activeGroupId;return(0,f.assertIsDefined)(t._extHostTabGroups.find(_=>_.groupId===u)?.apiObject)},close:async(u,v)=>{const _=Array.isArray(u)?u:[u];return _.length?p(_[0])?this._closeGroups(_,v):this._closeTabs(_,v):!0}};this._apiObject=Object.freeze(i)}return this._apiObject}$acceptEditorTabModel(t){const i=new Set(this._extHostTabGroups.map(s=>s.groupId)),u=new Set(t.map(s=>s.groupId)),v=(0,A.diffSets)(i,u),_=this._extHostTabGroups.filter(s=>v.removed.includes(s.groupId)).map(s=>s.apiObject),m=[],n=[];this._extHostTabGroups=t.map(s=>{const o=new a(s,()=>this._activeGroupId);return v.added.includes(o.groupId)?m.push(o.apiObject):n.push(o.apiObject),o});const r=(0,f.assertIsDefined)(t.find(s=>s.isActive===!0)?.groupId);r!==void 0&&this._activeGroupId!==r&&(this._activeGroupId=r),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:_,changed:n}))}$acceptTabGroupUpdate(t){const i=this._extHostTabGroups.find(u=>u.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this._extHostTabGroups.find(v=>v.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const u=i.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}_findExtHostTabFromApi(t){for(const i of this._extHostTabGroups)for(const u of i.tabs)if(u.apiObject===t)return u}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(i=>i.apiObject===t)}async _closeTabs(t,i){const u=[];for(const v of t){const _=this._findExtHostTabFromApi(v);if(!_)throw new Error("Tab close: Invalid tab not found!");u.push(_.tabId)}return this._proxy.$closeTab(u,i)}async _closeGroups(t,i){const u=[];for(const v of t){const _=this._findExtHostTabGroupFromApi(v);if(!_)throw new Error("Group close: Invalid group not found!");u.push(_.groupId)}return this._proxy.$closeGroup(u,i)}};e.ExtHostEditorTabs=E,e.ExtHostEditorTabs=E=Ve([He(0,y.IExtHostRpcService)],E);function p(h){return h.tabs!==void 0}}),define(Te[235],Ae([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class P{constructor(T){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(w.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,l,y){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const f=this._AiEmbeddingVectorProviders.get(T);if(!f)throw new Error("Embedding vector provider not found");const A=await f.provideEmbeddingVector(l,y);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(T,l,y){const f=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(f,y),this._proxy.$registerAiEmbeddingVectorProvider(l,f),new R.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(f),this._AiEmbeddingVectorProviders.delete(f)})}}e.ExtHostAiEmbeddingVector=P}),define(Te[236],Ae([1,0,2,3,6,7,8,283,16,26,22,51]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class a{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const t=this._schemes.indexOf(h);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),t=[];let i,u,v=14,_=14;for(const m of h){let n=i?(0,y.commonPrefixLength)(i,m):0;for(n===0?u=1:u=_;n<m.length;n++)n+1===m.length?(v=_,_=9):_+=1,t.push([u,m.toUpperCase().charCodeAt(n),_]),t.push([u,m.toLowerCase().charCodeAt(n),_]),u=_;i=m,_=v}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new l.StateMachine(t)}}provideDocumentLinks(h){this._initStateMachine();const t=[],i=l.LinkComputer.computeLinks({getLineContent(u){return h.lineAt(u-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const u of i){const v=T.DocumentLink.to(u);v.target&&t.push(v)}return t}}class E{constructor(h,t){this._extHostLanguageFeatures=t,this._linkProvider=new a,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(h,t,i,u={}){if(E._validateFileSystemProvider(i),this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(h,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(v,i);let _=2;u.isCaseSensitive&&(_+=1024),u.isReadonly&&(_+=2048),typeof i.copy=="function"&&(_+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.checkProposedApiEnabled)(h,"fsChunks"),_+=4);let m;u.isReadonly&&(0,D.isMarkdownString)(u.isReadonly)&&((0,A.checkProposedApiEnabled)(h,"readonlyMessage"),m={value:u.isReadonly.value,isTrusted:u.isReadonly.isTrusted,supportThemeIcons:u.isReadonly.supportThemeIcons,supportHtml:u.isReadonly.supportHtml,baseUri:u.isReadonly.baseUri,uris:u.isReadonly.uris}),this._proxy.$registerFileSystemProvider(v,t,_,m).catch(r=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${t}`),console.error(r)});const n=i.onDidChangeFile(r=>{const s=[];for(const o of r){const{uri:g,type:d}=o;if(g.scheme!==t)continue;let k;switch(d){case F.FileChangeType.Changed:k=0;break;case F.FileChangeType.Created:k=1;break;case F.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:g,type:k})}this._proxy.$onFileSystemChange(v,s)});return(0,P.toDisposable)(()=>{n.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _validateFileSystemProvider(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(h){const{type:t,ctime:i,mtime:u,size:v,permissions:_}=h;return{type:t,ctime:i,mtime:u,size:v,permissions:_}}$stat(h,t){return Promise.resolve(this._getFsProvider(h).stat(w.URI.revive(t))).then(i=>E._asIStat(i))}$readdir(h,t){return Promise.resolve(this._getFsProvider(h).readDirectory(w.URI.revive(t)))}$readFile(h,t){return Promise.resolve(this._getFsProvider(h).readFile(w.URI.revive(t))).then(i=>f.VSBuffer.wrap(i))}$writeFile(h,t,i,u){return Promise.resolve(this._getFsProvider(h).writeFile(w.URI.revive(t),i.buffer,u))}$delete(h,t,i){return Promise.resolve(this._getFsProvider(h).delete(w.URI.revive(t),i))}$rename(h,t,i,u){return Promise.resolve(this._getFsProvider(h).rename(w.URI.revive(t),w.URI.revive(i),u))}$copy(h,t,i,u){const v=this._getFsProvider(h);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(w.URI.revive(t),w.URI.revive(i),u))}$mkdir(h,t){return Promise.resolve(this._getFsProvider(h).createDirectory(w.URI.revive(t)))}$watch(h,t,i,u){const v=this._getFsProvider(h).watch(w.URI.revive(i),u);this._watches.set(t,v)}$unwatch(h,t){const i=this._watches.get(t);i&&(i.dispose(),this._watches.delete(t))}$open(h,t,i){const u=this._getFsProvider(h);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(w.URI.revive(t),i))}$close(h,t){const i=this._getFsProvider(h);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(h,t,i,u){const v=this._getFsProvider(h);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const _=f.VSBuffer.alloc(u);return Promise.resolve(v.read(t,i,_.buffer,0,u)).then(m=>_.slice(0,m))}$write(h,t,i,u){const v=this._getFsProvider(h);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,i,u.buffer,0,u.byteLength))}_getFsProvider(h){const t=this._fsProvider.get(h);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.ExtHostFileSystem=E}),define(Te[62],Ae([1,0,3,39,7,26,4,17,40,6,12,24,13]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let p=E=class{constructor(t,i){this._fileSystemProvider=new Map,this._writeQueue=new A.ResourceQueue,this._proxy=t.getProxy(w.MainContext.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(v){try{let _;const m=u._fileSystemProvider.get(v.scheme);return m?(await u._proxy.$ensureActivation(v.scheme),_=await m.impl.stat(v)):_=await u._proxy.$stat(v),{type:_.type,ctime:_.ctime,mtime:_.mtime,size:_.size,permissions:_.permissions===R.FilePermission.Readonly?1:void 0}}catch(_){E._handleError(_)}},async readDirectory(v){try{const _=u._fileSystemProvider.get(v.scheme);return _?(await u._proxy.$ensureActivation(v.scheme),(await _.impl.readDirectory(v)).slice()):await u._proxy.$readdir(v)}catch(_){return E._handleError(_)}},async createDirectory(v){try{const _=u._fileSystemProvider.get(v.scheme);return _&&!_.isReadonly?(await u._proxy.$ensureActivation(v.scheme),await u.mkdirp(_.impl,_.extUri,v)):await u._proxy.$mkdir(v)}catch(_){return E._handleError(_)}},async readFile(v){try{const _=u._fileSystemProvider.get(v.scheme);return _?(await u._proxy.$ensureActivation(v.scheme),(await _.impl.readFile(v)).slice()):(await u._proxy.$readFile(v)).buffer}catch(_){return E._handleError(_)}},async writeFile(v,_){try{const m=u._fileSystemProvider.get(v.scheme);return m&&!m.isReadonly?(await u._proxy.$ensureActivation(v.scheme),await u.mkdirp(m.impl,m.extUri,m.extUri.dirname(v)),await u._writeQueue.queueFor(v).queue(()=>Promise.resolve(m.impl.writeFile(v,_,{create:!0,overwrite:!0})))):await u._proxy.$writeFile(v,F.VSBuffer.wrap(_))}catch(m){return E._handleError(m)}},async delete(v,_){try{const m=u._fileSystemProvider.get(v.scheme);return m&&!m.isReadonly?(await u._proxy.$ensureActivation(v.scheme),await m.impl.delete(v,{recursive:!1,..._})):await u._proxy.$delete(v,{recursive:!1,useTrash:!1,atomic:!1,..._})}catch(m){return E._handleError(m)}},async rename(v,_,m){try{return await u._proxy.$rename(v,_,{overwrite:!1,...m})}catch(n){return E._handleError(n)}},async copy(v,_,m){try{return await u._proxy.$copy(v,_,{overwrite:!1,...m})}catch(n){return E._handleError(n)}},isWritableFileSystem(v){const _=i.getCapabilities(v);if(typeof _=="number")return!(_&2048)}})}async mkdirp(t,i,u){const v=[];for(;!i.isEqual(u,i.dirname(u));)try{if(!((await t.stat(u)).type&R.FileType.Directory))throw P.FileSystemError.FileExists(`Unable to create folder '${u.scheme===a.Schemas.file?u.fsPath:u.toString(!0)}' that already exists but is not a directory`);break}catch(_){if(R.toFileSystemProviderErrorCode(_)!==R.FileSystemProviderErrorCode.FileNotFound)throw _;v.push(i.basename(u)),u=i.dirname(u)}for(let _=v.length-1;_>=0;_--){u=i.joinPath(u,v[_]);try{await t.createDirectory(u)}catch(m){if(R.toFileSystemProviderErrorCode(m)!==R.FileSystemProviderErrorCode.FileExists)throw m}}}static _handleError(t){if(t instanceof P.FileSystemError)throw t;if(t instanceof R.FileSystemProviderError)switch(t.code){case R.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(t.message);default:throw new P.FileSystemError(t.message,t.name)}if(!(t instanceof Error))throw new P.FileSystemError(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.FileSystemError.Unavailable(t.message);switch(t.name){case R.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(t.message);default:throw new P.FileSystemError(t.message,t.name)}}addFileSystemProvider(t,i,u){return this._fileSystemProvider.set(t,{impl:i,extUri:u?.isCaseSensitive?D.extUri:D.extUriIgnorePathCase,isReadonly:!!u?.isReadonly}),(0,f.toDisposable)(()=>this._fileSystemProvider.delete(t))}getFileSystemProviderExtUri(t){return this._fileSystemProvider.get(t)?.extUri??D.extUri}};e.ExtHostConsumerFileSystem=p,e.ExtHostConsumerFileSystem=p=E=Ve([He(0,l.IExtHostRpcService),He(1,y.IExtHostFileSystemInfo)],p),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Te[237],Ae([1,0,5,38,2,3,8,7,42]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class f{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(E,p,h,t,i,u){this.session=Math.random(),this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,u?.ignoreCreateEvents&&(this._config+=1),u?.ignoreChangeEvents&&(this._config+=2),u?.ignoreDeleteEvents&&(this._config+=4);const v=(0,R.parse)(i),_=typeof i=="string",m=u?.correlate,n=t(r=>{if(!(typeof r.session=="number"&&r.session!==this.session)&&!(m&&typeof r.session>"u")){if(!u?.ignoreCreateEvents)for(const s of r.created){const o=P.URI.revive(s);v(o.fsPath)&&(!_||p.getWorkspaceFolder(o))&&this._onDidCreate.fire(o)}if(!u?.ignoreChangeEvents)for(const s of r.changed){const o=P.URI.revive(s);v(o.fsPath)&&(!_||p.getWorkspaceFolder(o))&&this._onDidChange.fire(o)}if(!u?.ignoreDeleteEvents)for(const s of r.deleted){const o=P.URI.revive(s);v(o.fsPath)&&(!_||p.getWorkspaceFolder(o))&&this._onDidDelete.fire(o)}}});this._disposable=l.Disposable.from(this.ensureWatching(E,h,i,u,u?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(E,p,h,t,i){const u=l.Disposable.from();if(typeof h=="string")return u;const v=E.getProxy(F.MainContext.MainThreadFileSystemEventService);let _=!1;return(h.pattern.includes(R.GLOBSTAR)||h.pattern.includes(R.GLOB_SPLIT))&&(_=!0),v.$watch(p.identifier.value,this.session,h.baseUri,{recursive:_,excludes:t?.excludes??[]},!!i),l.Disposable.from({dispose:()=>v.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(E){this._events=E,this.session=this._events.session,this._created=new y.Lazy(()=>this._events.created.map(P.URI.revive)),this._changed=new y.Lazy(()=>this._events.changed.map(P.URI.revive)),this._deleted=new y.Lazy(()=>this._events.deleted.map(P.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class D{constructor(E,p,h){this._mainContext=E,this._logService=p,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new w.AsyncEmitter,this._onWillCreateFile=new w.AsyncEmitter,this._onWillDeleteFile=new w.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(E,p,h,t){return new f(this._mainContext,E,p,this._onFileSystemEvent.event,T.GlobPattern.from(h),t)}$onFileEvent(E){this._onFileSystemEvent.fire(new A(E))}$onDidRunFileOperation(E,p){switch(E){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(h=>P.URI.revive(h.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:p.map(h=>P.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(E){return this._createWillExecuteEvent(E,this._onWillRenameFile)}getOnWillCreateFileEvent(E){return this._createWillExecuteEvent(E,this._onWillCreateFile)}getOnWillDeleteFileEvent(E){return this._createWillExecuteEvent(E,this._onWillDeleteFile)}_createWillExecuteEvent(E,p){return(h,t,i)=>{const u=function(_){h.call(t,_)};return u.extension=E,p.event(u,void 0,i)}}async $onWillRunFileOperation(E,p,h,t){switch(E){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},h,t);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(i=>P.URI.revive(i.target))},h,t);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(i=>P.URI.revive(i.target))},h,t)}}async _fireWillEvent(E,p,h,t){const i=new Set,u=[];if(await E.fireAsync(p,t,async(_,m)=>{const n=Date.now(),r=await Promise.resolve(_);r instanceof l.WorkspaceEdit&&(u.push([m.extension,r]),i.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-n>h&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),t.isCancellationRequested||u.length===0)return;const v={edits:[]};for(const[,_]of u){const{edits:m}=T.WorkspaceEdit.from(_,{getTextDocumentVersion:n=>this._extHostDocumentsAndEditors.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});v.edits=v.edits.concat(m)}return{edit:v,extensionNames:Array.from(i)}}}e.ExtHostFileSystemEventService=D}),define(Te[238],Ae([1,0,6,2,3,8,7,31,12]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class f{static{this._pool=0}constructor(E,p){this.extension=E,this.provider=p,this.handle=f._pool++}}class A{constructor(E){this.session=E,this.responses=[]}}class D{static{this._nextId=0}constructor(E,p,h,t){this._documents=h,this._logService=t,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadInlineChat),p.registerApiCommand(new l.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.ApiCommandArgument("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?F.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?F.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?F.Position.from(i.position):void 0}})],l.ApiCommandResult.Void))}registerProvider(E,p,h){const t=new f(E,p);return this._inputProvider.set(t.handle,t),this._proxy.$registerInteractiveEditorProvider(t.handle,h.label,E.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,w.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(t.handle),this._inputProvider.delete(t.handle)})}async $prepareSession(E,p,h,t){const i=this._inputProvider.get(E);if(!i){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const u=this._documents.getDocument(R.URI.revive(p)),v=F.Selection.to(h),_=await i.provider.prepareInteractiveEditorSession({document:u,selection:v},t);if(!_)return;if(_.wholeRange&&!_.wholeRange.contains(v))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const m=D._nextId++;return this._inputSessions.set(m,new A(_)),{id:m,placeholder:_.placeholder,input:_.input,slashCommands:_.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:F.Range.from(_.wholeRange),message:_.message}}async $provideResponse(E,p,h,t){const i=this._inputProvider.get(E);if(!i)return;const u=this._inputSessions.get(p.id);if(!u)return;const v={prompt:h.prompt,selection:F.Selection.to(h.selection),wholeRange:F.Range.to(h.wholeRange),attempt:h.attempt,live:h.live};let _=!1;const m={report:async d=>{if(!h.live&&d.edits?.length)throw new Error("Progress reporting is only supported for live sessions");_||t.isCancellationRequested||await this._proxy.$handleProgressChunk(h.requestId,{message:d.message,edits:d.edits?.map(F.TextEdit.from),editsShouldBeInstant:d.editsShouldBeInstant,slashCommand:d.slashCommand?.command,markdownFragment:T.MarkdownString.isMarkdownString(d.content)?d.content.value:d.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(u.session,v,m,t));let r;try{r=await(0,y.raceCancellation)(n,t)}finally{_=!0}if(!r)return;const s=u.responses.push(r)-1,o={wholeRange:F.Range.from(r.wholeRange),placeholder:r.placeholder};if(D._isMessageResponse(r))return{...o,id:s,type:"message",message:F.MarkdownString.from(r.contents)};const{edits:g}=r;return g instanceof T.WorkspaceEdit?{...o,id:s,type:"bulkEdit",edits:F.WorkspaceEdit.from(g)}:{...o,id:s,type:"editorEdit",edits:g.map(F.TextEdit.from)}}$handleFeedback(E,p,h,t){const i=this._inputProvider.get(E),u=this._inputSessions.get(p),v=u?.responses[h];if(i&&v){const _=F.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(u.session,v,_)}}$releaseSession(E,p){}static _isMessageResponse(E){return typeof E=="object"&&typeof E.contents=="object"}}e.ExtHostInteractiveEditor=D}),define(Te[239],Ae([1,0,2,31]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class P{constructor(T,l,y,f,A){this._extHostNotebooks=l,this._textDocumentsAndEditors=y,this._commands=f;const D=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",a=>!0,a=>a),new R.ApiCommandArgument("resource","Interactive resource Uri",a=>!0,a=>a),new R.ApiCommandArgument("controllerId","Notebook controller Id",a=>!0,a=>a),new R.ApiCommandArgument("title","Interactive editor title",a=>!0,a=>a)],new R.ApiCommandResult("Notebook and input URI",a=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(a.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri),notebookEditor:E.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri)}}));this._commands.registerApiCommand(D)}$willAddInteractiveDocument(T,l,y,f){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(w.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,l){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=P}),define(Te[240],Ae([1,0,3,7]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class P{constructor(T){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=T.getProxy(w.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,l){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(T);if(!y)throw new Error("Issue request handler not found");const f=await y.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}async $getIssueReporterData(T,l){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const y=this._IssueDataProviders.get(T);if(!y)throw new Error("Issue data provider not found");const f=await y.provideIssueData(l);if(!f)throw new Error("Issue data provider returned no result");return f}async $getIssueReporterTemplate(T,l){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const y=this._IssueDataProviders.get(T);if(!y)throw new Error("Issue data provider not found");const f=await y.provideIssueTemplate(l);if(!f)throw new Error("Issue template provider returned no result");return f}registerIssueUriRequestHandler(T,l){const y=T.identifier.value;return this._IssueUriRequestHandlers.set(y,l),this._proxy.$registerIssueUriRequestHandler(y),new R.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}registerIssueDataProvider(T,l){const y=T.identifier.value;return this._IssueDataProviders.set(y,l),this._proxy.$registerIssueDataProvider(y),new R.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(y),this._IssueDataProviders.delete(y)})}}e.ExtHostIssueReporter=P}),define(Te[241],Ae([1,0,6,3]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(T){this._handlePool=0,this._proxy=T.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const l=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(l,T),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(l)})}}e.ExtHostLabelService=P}),define(Te[242],Ae([1,0,2,25,8,7,79,3,16,41,18,15,284,19,21,6,91,88,74,48,11,12,22,150]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_,m,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentSymbols(O,W){const j=this._documents.getDocument(O),K=await this._provider.provideDocumentSymbols(j,W);if(!(0,A.isFalsyOrEmpty)(K))return K[0]instanceof F.DocumentSymbol?K.map(P.DocumentSymbol.from):s._asDocumentSymbolTree(K)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((K,V)=>{let J=K.location.range.start.compareTo(V.location.range.start);return J===0&&(J=V.location.range.end.compareTo(K.location.range.end)),J});const W=[],j=[];for(const K of O){const V={name:K.name||"!!MISSING: name!!",kind:P.SymbolKind.from(K.kind),tags:K.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:P.Range.from(K.location.range),selectionRange:P.Range.from(K.location.range),children:[]};for(;;){if(j.length===0){j.push(V),W.push(V);break}const J=j[j.length-1];if(f.Range.containsRange(J.range,V.range)&&!f.Range.equalsRange(J.range,V.range)){J.children?.push(V),j.push(V);break}j.pop()}}return W}}class o{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(O,W,j){this._documents=O,this._commands=W,this._provider=j,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,W){const j=this._documents.getDocument(O),K=await this._provider.provideCodeLenses(j,W);if(!K||W.isCancellationRequested)return;const V=this._cache.add(K),J=new h.DisposableStore;this._disposables.set(V,J);const ce={cacheId:V,lenses:[]};for(let Me=0;Me<K.length;Me++)ce.lenses.push({cacheId:[V,Me],range:P.Range.from(K[Me].range),command:this._commands.toInternal(K[Me].command,J)});return ce}async resolveCodeLens(O,W){const j=O.cacheId&&this._cache.get(...O.cacheId);if(!j)return;let K;if(typeof this._provider.resolveCodeLens!="function"||j.isResolved?K=j:K=await this._provider.resolveCodeLens(j,W),K||(K=j),W.isCancellationRequested)return;const V=O.cacheId&&this._disposables.get(O.cacheId[0]);if(V)return O.command=this._commands.toInternal(K.command??o._badCmd,V),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}function g(ke){return Array.isArray(ke)?ke.map(P.DefinitionLink.from):ke?[P.DefinitionLink.from(ke)]:[]}class d{constructor(O,W){this._documents=O,this._provider=W}async provideDefinition(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.provideDefinition(K,V,j);return g(J)}}class k{constructor(O,W){this._documents=O,this._provider=W}async provideDeclaration(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.provideDeclaration(K,V,j);return g(J)}}class I{constructor(O,W){this._documents=O,this._provider=W}async provideImplementation(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.provideImplementation(K,V,j);return g(J)}}class c{constructor(O,W){this._documents=O,this._provider=W}async provideTypeDefinition(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.provideTypeDefinition(K,V,j);return g(J)}}class S{constructor(O,W){this._documents=O,this._provider=W}async provideHover(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.provideHover(K,V,j);if(!(!J||(0,A.isFalsyOrEmpty)(J.contents)))return J.range||(J.range=K.getWordRangeAtPosition(V)),J.range||(J.range=new F.Range(V,V)),P.Hover.from(J)}}class b{constructor(O,W){this._documents=O,this._provider=W}async provideEvaluatableExpression(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.provideEvaluatableExpression(K,V,j);if(J)return P.EvaluatableExpression.from(J)}}class C{constructor(O,W){this._documents=O,this._provider=W}async provideInlineValues(O,W,j,K){const V=this._documents.getDocument(O),J=await this._provider.provideInlineValues(V,P.Range.to(W),P.InlineValueContext.to(j),K);if(Array.isArray(J))return J.map(ce=>P.InlineValue.from(ce))}}class ${constructor(O,W){this._documents=O,this._provider=W}async provideDocumentHighlights(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.provideDocumentHighlights(K,V,j);if(Array.isArray(J))return J.map(P.DocumentHighlight.from)}}class N{constructor(O,W){this._documents=O,this._provider=W}async provideLinkedEditingRanges(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.provideLinkedEditingRanges(K,V,j);if(J&&Array.isArray(J.ranges))return{ranges:(0,A.coalesce)(J.ranges.map(P.Range.from)),wordPattern:J.wordPattern}}}class H{constructor(O,W){this._documents=O,this._provider=W}async provideReferences(O,W,j,K){const V=this._documents.getDocument(O),J=P.Position.to(W),ce=await this._provider.provideReferences(V,J,j,K);if(Array.isArray(ce))return ce.map(P.location.from)}}class B{static{this._maxCodeActionsPerFile=1e3}constructor(O,W,j,K,V,J,ce){this._documents=O,this._commands=W,this._diagnostics=j,this._provider=K,this._logService=V,this._extension=J,this._apiDeprecation=ce,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,W,j,K){const V=this._documents.getDocument(O),J=a.Selection.isISelection(W)?P.Selection.to(W):P.Range.to(W),ce=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(J.intersection(Ye.range)&&ce.push(Ye)>B._maxCodeActionsPerFile)break;const Me={diagnostics:ce,only:j.only?new F.CodeActionKind(j.only):void 0,triggerKind:P.CodeActionTriggerKind.to(j.trigger)},$e=await this._provider.provideCodeActions(V,J,Me,K);if(!(0,A.isNonEmptyArray)($e)||K.isCancellationRequested)return;const Ge=this._cache.add($e),je=new h.DisposableStore;this._disposables.set(Ge,je);const Ze=[];for(let Ye=0;Ye<$e.length;Ye++){const Je=$e[Ye];Je&&(B._isCommand(Je)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Je.title,command:this._commands.toInternal(Je,je)})):(Me.only&&(Je.kind?Me.only.contains(Je.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${Je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[Ge,Ye],title:Je.title,command:Je.command&&this._commands.toInternal(Je.command,je),diagnostics:Je.diagnostics&&Je.diagnostics.map(P.Diagnostic.from),edit:Je.edit&&P.WorkspaceEdit.from(Je.edit,void 0),kind:Je.kind&&Je.kind.value,isPreferred:Je.isPreferred,isAI:(0,n.isProposedApiEnabled)(this._extension,"codeActionAI")?Je.isAI:!1,disabled:Je.disabled?.reason})))}return{cacheId:Ge,actions:Ze}}async resolveCodeAction(O,W){const[j,K]=O,V=this._cache.get(j,K);if(!V||B._isCommand(V))return{};if(!this._provider.resolveCodeAction)return{};const J=await this._provider.resolveCodeAction(V,W)??V;let ce;J.edit&&(ce=P.WorkspaceEdit.from(J.edit,void 0));let Me;if(J.command){const $e=this._disposables.get(j);$e&&(Me=this._commands.toInternal(J.command,$e))}return{edit:ce,command:Me}}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}class L{static toInternalProviderId(O,W){return O+"."+W}constructor(O,W,j,K,V){this._proxy=O,this._documents=W,this._provider=j,this._handle=K,this._extension=V}async prepareDocumentPaste(O,W,j,K){if(!this._provider.prepareDocumentPaste)return;const V=this._documents.getDocument(O),J=W.map($e=>P.Range.to($e)),ce=P.DataTransfer.toDataTransfer(j,()=>{throw new _.NotImplementedError});if(await this._provider.prepareDocumentPaste(V,J,ce,K),K.isCancellationRequested)return;const Me=Array.from(ce).filter(([,$e])=>!($e instanceof F.InternalDataTransferItem));return P.DataTransfer.from(Me)}async providePasteEdits(O,W,j,K,V){if(!this._provider.provideDocumentPasteEdits)return;const J=this._documents.getDocument(W),ce=j.map(Ge=>P.Range.to(Ge)),Me=P.DataTransfer.toDataTransfer(K,async Ge=>(await this._proxy.$resolvePasteFileData(this._handle,O,Ge)).buffer),$e=await this._provider.provideDocumentPasteEdits(J,ce,Me,V);if($e)return{label:$e.label??(0,r.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:$e.yieldTo?.map(Ge=>"mimeType"in Ge?Ge:{providerId:L.toInternalProviderId(Ge.extensionId,Ge.providerId)}),insertText:typeof $e.insertText=="string"?$e.insertText:{snippet:$e.insertText.value},additionalEdit:$e.additionalEdit?P.WorkspaceEdit.from($e.additionalEdit,void 0):void 0}}}class U{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentFormattingEdits(O,W,j){const K=this._documents.getDocument(O),V=await this._provider.provideDocumentFormattingEdits(K,W,j);if(Array.isArray(V))return V.map(P.TextEdit.from)}}class ie{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentRangeFormattingEdits(O,W,j,K){const V=this._documents.getDocument(O),J=P.Range.to(W),ce=await this._provider.provideDocumentRangeFormattingEdits(V,J,j,K);if(Array.isArray(ce))return ce.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,W,j,K){(0,D.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const V=this._documents.getDocument(O),J=W.map(P.Range.to),ce=await this._provider.provideDocumentRangesFormattingEdits(V,J,j,K);if(Array.isArray(ce))return ce.map(P.TextEdit.from)}}class X{constructor(O,W){this._documents=O,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,W,j,K,V){const J=this._documents.getDocument(O),ce=P.Position.to(W),Me=await this._provider.provideOnTypeFormattingEdits(J,ce,j,K,V);if(Array.isArray(Me))return Me.map(P.TextEdit.from)}}class ye{constructor(O,W){this._provider=O,this._logService=W,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,W){const j=await this._provider.provideWorkspaceSymbols(O,W);if(!(0,A.isNonEmptyArray)(j))return{symbols:[]};const K=this._cache.add(j),V={cacheId:K,symbols:[]};for(let J=0;J<j.length;J++){const ce=j[J];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}V.symbols.push({...P.WorkspaceSymbol.from(ce),cacheId:[K,J]})}return V}async resolveWorkspaceSymbol(O,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const j=this._cache.get(...O.cacheId);if(j){const K=await this._provider.resolveWorkspaceSymbol(j,W);return K&&(0,R.mixin)(O,P.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class Pe{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,W,j){this._documents=O,this._provider=W,this._logService=j}async provideRenameEdits(O,W,j,K){const V=this._documents.getDocument(O),J=P.Position.to(W);try{const ce=await this._provider.provideRenameEdits(V,J,j,K);return ce?P.WorkspaceEdit.from(ce):void 0}catch(ce){const Me=Pe._asMessage(ce);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(O,W,j){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const K=this._documents.getDocument(O),V=P.Position.to(W);try{const J=await this._provider.prepareRename(K,V,j);let ce,Me;if(F.Range.isRange(J)?(ce=J,Me=K.getText(J)):(0,D.isObject)(J)&&(ce=J.range,Me=J.placeholder),!ce||!Me)return;if(ce.start.line>V.line||ce.end.line<V.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(ce),text:Me}}catch(J){const ce=Pe._asMessage(J);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(J)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class De{constructor(O,W){this.resultId=O,this.tokens=W}}class pe{constructor(O,W){this._documents=O,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,W,j){const K=this._documents.getDocument(O),V=W!==0?this._previousResults.get(W):null;let J=typeof V?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(K,V.resultId,j):await this._provider.provideDocumentSemanticTokens(K,j);return V&&this._previousResults.delete(W),J?(J=pe._fixProvidedSemanticTokens(J),this._send(pe._convertToEdits(V,J),J)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return pe._isSemanticTokens(O)?pe._isCorrectSemanticTokens(O)?O:new F.SemanticTokens(new Uint32Array(O.data),O.resultId):pe._isSemanticTokensEdits(O)?pe._isCorrectSemanticTokensEdits(O)?O:new F.SemanticTokensEdits(O.edits.map(W=>new F.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const W of O.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,W){if(!pe._isSemanticTokens(W)||!O||!O.tokens)return W;const j=O.tokens,K=j.length,V=W.data,J=V.length;let ce=0;const Me=Math.min(K,J);for(;ce<Me&&j[ce]===V[ce];)ce++;if(ce===K&&ce===J)return new F.SemanticTokensEdits([],W.resultId);let $e=0;const Ge=Me-ce;for(;$e<Ge&&j[K-$e-1]===V[J-$e-1];)$e++;return new F.SemanticTokensEdits([{start:ce,deleteCount:K-ce-$e,data:V.subarray(ce,J-$e)}],W.resultId)}_send(O,W){if(pe._isSemanticTokens(O)){const j=this._nextResultId++;return this._previousResults.set(j,new De(O.resultId,O.data)),(0,t.encodeSemanticTokensDto)({id:j,type:"full",data:O.data})}if(pe._isSemanticTokensEdits(O)){const j=this._nextResultId++;return pe._isSemanticTokens(W)?this._previousResults.set(j,new De(W.resultId,W.data)):this._previousResults.set(j,new De(O.resultId)),(0,t.encodeSemanticTokensDto)({id:j,type:"delta",deltas:(O.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class Se{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentRangeSemanticTokens(O,W,j){const K=this._documents.getDocument(O),V=await this._provider.provideDocumentRangeSemanticTokens(K,P.Range.to(W),j);return V?this._send(V):null}_send(O){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class le{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,W,j,K,V){this._documents=O,this._commands=W,this._provider=j,this._apiDeprecation=K,this._extension=V,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,W,j,K){const V=this._documents.getDocument(O),J=P.Position.to(W),ce=V.getWordRangeAtPosition(J)||new F.Range(J,J),Me=ce.with({end:J}),$e=new v.StopWatch,Ge=await this._provider.provideCompletionItems(V,J,K,P.CompletionContext.to(j));if(!Ge||K.isCancellationRequested)return;const je=Array.isArray(Ge)?new F.CompletionList(Ge):Ge,Ze=le.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),Ye=new h.DisposableStore;this._disposables.set(Ze,Ye);const Je=[],it={x:Ze,b:Je,a:{replace:P.Range.from(ce),insert:P.Range.from(Me)},c:je.isIncomplete||void 0,d:$e.elapsed()};for(let tt=0;tt<je.items.length;tt++){const Ue=je.items[tt],lt=this._convertCompletionItem(Ue,[Ze,tt],Me,ce);Je.push(lt)}return it}async resolveCompletionItem(O,W){if(typeof this._provider.resolveCompletionItem!="function")return;const j=this._cache.get(...O);if(!j)return;const K=this._convertCompletionItem(j,O),V=await this._provider.resolveCompletionItem(j,W);if(!V)return;const J=this._convertCompletionItem(V,O);return(K.h!==J.h||K.i!==J.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==J.n||K.o!==J.o||!(0,R.equals)(K.p,J.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:J.d,c:J.c,l:J.l,h:J.h,i:J.i,n:J.n,o:J.o,p:J.p}}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,W,j,K){const V=this._disposables.get(W[0]);if(!V)throw Error("DisposableStore is missing...");const J=this._commands.toInternal(O.command,V),ce={x:W,a:O.label,b:O.kind!==void 0?P.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(P.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:P.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(P.TextEdit.from),n:J?.$ident,o:J?.id,p:J?.$ident?void 0:J?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=O.textEdit.newText):typeof O.insertText=="string"?ce.h=O.insertText:O.insertText instanceof F.SnippetString&&(ce.h=O.insertText.value,ce.i|=4);let Me;return O.textEdit?Me=O.textEdit.range:O.range&&(Me=O.range),F.Range.isRange(Me)?ce.j=P.Range.from(Me):Me&&(!j?.isEqual(Me.inserting)||!K?.isEqual(Me.replacing))&&(ce.j={insert:P.Range.from(Me.inserting),replace:P.Range.from(Me.replacing)}),ce}}class ae{async provideInlineCompletions(O,W,j,K){}disposeCompletions(O){}handleDidShowCompletionItem(O,W,j){}handlePartialAccept(O,W,j){}}class we extends ae{constructor(O,W,j,K){super(),this._extension=O,this._documents=W,this._provider=j,this._commands=K,this._references=new Z,this._isAdditionsProposedApiEnabled=(0,n.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,W,j,K){const V=this._documents.getDocument(O),J=P.Position.to(W),ce=await this._provider.provideInlineCompletionItems(V,J,{selectedCompletionInfo:j.selectedSuggestionInfo?{range:P.Range.to(j.selectedSuggestionInfo.range),text:j.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[j.triggerKind]},K);if(!ce||K.isCancellationRequested)return;const Me=Array.isArray(ce)?ce:ce.items,$e=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[],Ge=this._isAdditionsProposedApiEnabled&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let je;return{pid:this._references.createReferenceId({dispose(){je?.dispose()},items:Me}),items:Me.map((Ye,Je)=>{let it;Ye.command&&(je||(je=new h.DisposableStore),it=this._commands.toInternal(Ye.command,je));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?P.Range.from(Ye.range):void 0,command:it,idx:Je,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:$e.map(Ye=>(je||(je=new h.DisposableStore),this._commands.toInternal(Ye,je))),suppressSuggestions:!1,enableForwardStability:Ge}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,W,j){const K=this._references.get(O)?.items[W];K&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K,j)}handlePartialAccept(O,W,j){const K=this._references.get(O)?.items[W];K&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(K,j)}}class Z{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const W=this._idPool++;return this._references.set(W,O),W}disposeReferenceId(O){const W=this._references.get(O);return this._references.delete(O),W}get(O){return this._references.get(O)}}class z{constructor(O,W){this._documents=O,this._provider=W,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(O,W,j,K){const V=this._documents.getDocument(O),J=P.Position.to(W),ce=this.reviveContext(j),Me=await this._provider.provideSignatureHelp(V,J,K,ce);if(Me){const $e=this._cache.add([Me]);return{...P.SignatureHelp.from(Me),id:$e}}}reviveContext(O){let W;if(O.activeSignatureHelp){const j=P.SignatureHelp.to(O.activeSignatureHelp),K=this._cache.get(O.activeSignatureHelp.id,0);K?(W=K,W.activeSignature=j.activeSignature,W.activeParameter=j.activeParameter):W=j}return{...O,activeSignatureHelp:W}}releaseSignatureHelp(O){this._cache.delete(O)}}class Y{constructor(O,W,j,K,V){this._documents=O,this._commands=W,this._provider=j,this._logService=K,this._extension=V,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,W,j){const K=this._documents.getDocument(O),V=P.Range.to(W),J=await this._provider.provideInlayHints(K,V,j);if(!Array.isArray(J)||J.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(j.isCancellationRequested)return;const ce=this._cache.add(J);this._disposables.set(ce,new h.DisposableStore);const Me={hints:[],cacheId:ce};for(let $e=0;$e<J.length;$e++)this._isValidInlayHint(J[$e],V)&&Me.hints.push(this._convertInlayHint(J[$e],[ce,$e]));return this._logService.trace(`[InlayHints] ${Me.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),Me}async resolveInlayHint(O,W){if(typeof this._provider.resolveInlayHint!="function")return;const j=this._cache.get(...O);if(!j)return;const K=await this._provider.resolveInlayHint(j,W);if(K&&this._isValidInlayHint(K))return this._convertInlayHint(K,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,W){return O.label.length===0||Array.isArray(O.label)&&O.label.every(j=>j.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(W&&!W.contains(O.position))}_convertInlayHint(O,W){const j=this._disposables.get(W[0]);if(!j)throw Error("DisposableStore is missing...");const K={label:"",cacheId:W,tooltip:P.MarkdownString.fromStrict(O.tooltip),position:P.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(P.TextEdit.from),kind:O.kind&&P.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?K.label=O.label:K.label=O.label.map(V=>{const J={label:V.value};return J.tooltip=P.MarkdownString.fromStrict(V.tooltip),F.Location.isLocation(V.location)&&(J.location=P.location.from(V.location)),V.command&&(J.command=this._commands.toInternal(V.command,j)),J}),K}}class ee{constructor(O,W){this._documents=O,this._provider=W,this._cache=new u.Cache("DocumentLink")}async provideLinks(O,W){const j=this._documents.getDocument(O),K=await this._provider.provideDocumentLinks(j,W);if(!(!Array.isArray(K)||K.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:K.filter(ee._validateLink).map(P.DocumentLink.from)};{const V=this._cache.add(K),J={links:[],cacheId:V};for(let ce=0;ce<K.length;ce++){if(!ee._validateLink(K[ce]))continue;const Me=P.DocumentLink.from(K[ce]);Me.cacheId=[V,ce],J.links.push(Me)}return J}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,W){if(typeof this._provider.resolveDocumentLink!="function")return;const j=this._cache.get(...O);if(!j)return;const K=await this._provider.resolveDocumentLink(j,W);if(!(!K||!ee._validateLink(K)))return P.DocumentLink.from(K)}releaseLinks(O){this._cache.delete(O)}}class ve{constructor(O,W){this._documents=O,this._provider=W}async provideColors(O,W){const j=this._documents.getDocument(O),K=await this._provider.provideDocumentColors(j,W);return Array.isArray(K)?K.map(J=>({color:P.Color.from(J.color),range:P.Range.from(J.range)})):[]}async provideColorPresentations(O,W,j){const K=this._documents.getDocument(O),V=P.Range.to(W.range),J=P.Color.to(W.color),ce=await this._provider.provideColorPresentations(J,{document:K,range:V},j);if(Array.isArray(ce))return ce.map(P.ColorPresentation.from)}}class ge{constructor(O,W){this._documents=O,this._provider=W}async provideFoldingRanges(O,W,j){const K=this._documents.getDocument(O),V=await this._provider.provideFoldingRanges(K,W,j);if(Array.isArray(V))return V.map(P.FoldingRange.from)}}class de{constructor(O,W,j){this._documents=O,this._provider=W,this._logService=j}async provideSelectionRanges(O,W,j){const K=this._documents.getDocument(O),V=W.map(P.Position.to),J=await this._provider.provideSelectionRanges(K,V,j);if(!(0,A.isNonEmptyArray)(J))return[];if(J.length!==V.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Me=0;Me<V.length;Me++){const $e=[];ce.push($e);let Ge=V[Me],je=J[Me];for(;;){if(!je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if($e.push(P.SelectionRange.from(je)),!je.parent)break;Ge=je.range,je=je.parent}}return ce}}class _e{constructor(O,W){this._documents=O,this._provider=W,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.prepareCallHierarchy(K,V,j);if(!J)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(J)?J.map(Me=>this._cacheAndConvertItem(ce,Me)):[this._cacheAndConvertItem(ce,J)]}async provideCallsTo(O,W,j){const K=this._itemFromCache(O,W);if(!K)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyIncomingCalls(K,j);if(V)return V.map(J=>({from:this._cacheAndConvertItem(O,J.from),fromRanges:J.fromRanges.map(ce=>P.Range.from(ce))}))}async provideCallsFrom(O,W,j){const K=this._itemFromCache(O,W);if(!K)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyOutgoingCalls(K,j);if(V)return V.map(J=>({to:this._cacheAndConvertItem(O,J.to),fromRanges:J.fromRanges.map(ce=>P.Range.from(ce))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,W){const j=this._cache.get(O),K=P.CallHierarchyItem.from(W,O,j.size.toString(36));return j.set(K._itemId,W),K}_itemFromCache(O,W){return this._cache.get(O)?.get(W)}}class re{constructor(O,W){this._documents=O,this._provider=W,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(O,W,j){const K=this._documents.getDocument(O),V=P.Position.to(W),J=await this._provider.prepareTypeHierarchy(K,V,j);if(!J)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(J)?J.map(Me=>this._cacheAndConvertItem(ce,Me)):[this._cacheAndConvertItem(ce,J)]}async provideSupertypes(O,W,j){const K=this._itemFromCache(O,W);if(!K)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySupertypes(K,j);if(V)return V.map(J=>this._cacheAndConvertItem(O,J))}async provideSubtypes(O,W,j){const K=this._itemFromCache(O,W);if(!K)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySubtypes(K,j);if(V)return V.map(J=>this._cacheAndConvertItem(O,J))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,W){const j=this._cache.get(O),K=P.TypeHierarchyItem.from(W,O,j.size.toString(36));return j.set(K._itemId,W),K}_itemFromCache(O,W){return this._cache.get(O)?.get(W)}}class ue{static toInternalProviderId(O,W){return O+"."+W}constructor(O,W,j,K,V){this._proxy=O,this._documents=W,this._provider=j,this._handle=K,this._extension=V}async provideDocumentOnDropEdits(O,W,j,K,V){const J=this._documents.getDocument(W),ce=P.Position.to(j),Me=P.DataTransfer.toDataTransfer(K,async Ge=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,Ge)).buffer),$e=await this._provider.provideDocumentDropEdits(J,ce,Me,V);if($e)return{label:$e.label??(0,r.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:$e.yieldTo?.map(Ge=>"mimeType"in Ge?Ge:{providerId:ue.toInternalProviderId(Ge.extensionId,Ge.providerId)}),insertText:typeof $e.insertText=="string"?$e.insertText:{snippet:$e.insertText.value},additionalEdit:$e.additionalEdit?P.WorkspaceEdit.from($e.additionalEdit,void 0):void 0}}}class ne{constructor(O,W){this._documents=O,this._provider=W}async provideMappedEdits(O,W,j,K){const V=w.URI.revive(O),J=this._documents.getDocument(V),ce=j.documents.map(Ge=>Ge.map(je=>({uri:w.URI.revive(je.uri),version:je.version,ranges:je.ranges.map(Ze=>P.Range.to(Ze))}))),Me={documents:ce,selections:ce[0]?.[0]?.ranges??[]},$e=await this._provider.provideMappedEdits(J,W,Me,K);return $e?P.WorkspaceEdit.from($e):null}}class oe{constructor(O,W){this.adapter=O,this.extension=W}}class fe{static{this._handlePool=0}constructor(O,W,j,K,V,J,ce,Me){this._uriTransformer=W,this._documents=j,this._commands=K,this._diagnostics=V,this._logService=J,this._apiDeprecation=ce,this._extensionTelemetry=Me,this._adapter=new Map,this._proxy=O.getProxy(l.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O,W){return P.DocumentSelector.from(O,this._uriTransformer,W)}_createDisposable(O){return new F.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return fe._handlePool++}async _withAdapter(O,W,j,K,V,J=!1){const ce=this._adapter.get(O);if(!ce||!(ce.adapter instanceof W))return K;const Me=Date.now();J||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${j.toString().replace(/[\r\n]/g,"")}'`);const $e=j(ce.adapter,ce.extension);return Promise.resolve($e).catch(Ge=>{(0,_.isCancellationError)(Ge)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(Ge),this._extensionTelemetry.onExtensionError(ce.extension.identifier,Ge))}).finally(()=>{J||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Me}ms`)}),E.CancellationToken.isCancellationToken(V)?(0,m.raceCancellationError)($e,V):$e}_addNewAdapter(O,W){const j=this._nextHandle();return this._adapter.set(j,new oe(O,W)),j}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,W,j,K){const V=this._addNewAdapter(new s(this._documents,j),O),J=K&&K.label||fe._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(V,this._transformDocumentSelector(W,O),J),this._createDisposable(V)}$provideDocumentSymbols(O,W,j){return this._withAdapter(O,s,K=>K.provideDocumentSymbols(w.URI.revive(W),j),void 0,j)}registerCodeLensProvider(O,W,j){const K=this._nextHandle(),V=typeof j.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(K,new oe(new o(this._documents,this._commands.converter,j),O)),this._proxy.$registerCodeLensSupport(K,this._transformDocumentSelector(W,O),V);let J=this._createDisposable(K);if(V!==void 0){const ce=j.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(V));J=F.Disposable.from(J,ce)}return J}$provideCodeLenses(O,W,j){return this._withAdapter(O,o,K=>K.provideCodeLenses(w.URI.revive(W),j),void 0,j)}$resolveCodeLens(O,W,j){return this._withAdapter(O,o,K=>K.resolveCodeLens(W,j),void 0,void 0)}$releaseCodeLenses(O,W){this._withAdapter(O,o,j=>Promise.resolve(j.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(O,W,j){const K=this._addNewAdapter(new d(this._documents,j),O);return this._proxy.$registerDefinitionSupport(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideDefinition(O,W,j,K){return this._withAdapter(O,d,V=>V.provideDefinition(w.URI.revive(W),j,K),[],K)}registerDeclarationProvider(O,W,j){const K=this._addNewAdapter(new k(this._documents,j),O);return this._proxy.$registerDeclarationSupport(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideDeclaration(O,W,j,K){return this._withAdapter(O,k,V=>V.provideDeclaration(w.URI.revive(W),j,K),[],K)}registerImplementationProvider(O,W,j){const K=this._addNewAdapter(new I(this._documents,j),O);return this._proxy.$registerImplementationSupport(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideImplementation(O,W,j,K){return this._withAdapter(O,I,V=>V.provideImplementation(w.URI.revive(W),j,K),[],K)}registerTypeDefinitionProvider(O,W,j){const K=this._addNewAdapter(new c(this._documents,j),O);return this._proxy.$registerTypeDefinitionSupport(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideTypeDefinition(O,W,j,K){return this._withAdapter(O,c,V=>V.provideTypeDefinition(w.URI.revive(W),j,K),[],K)}registerHoverProvider(O,W,j,K){const V=this._addNewAdapter(new S(this._documents,j),O);return this._proxy.$registerHoverProvider(V,this._transformDocumentSelector(W,O)),this._createDisposable(V)}$provideHover(O,W,j,K){return this._withAdapter(O,S,V=>V.provideHover(w.URI.revive(W),j,K),void 0,K)}registerEvaluatableExpressionProvider(O,W,j,K){const V=this._addNewAdapter(new b(this._documents,j),O);return this._proxy.$registerEvaluatableExpressionProvider(V,this._transformDocumentSelector(W,O)),this._createDisposable(V)}$provideEvaluatableExpression(O,W,j,K){return this._withAdapter(O,b,V=>V.provideEvaluatableExpression(w.URI.revive(W),j,K),void 0,K)}registerInlineValuesProvider(O,W,j,K){const V=typeof j.onDidChangeInlineValues=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new C(this._documents,j),O);this._proxy.$registerInlineValuesProvider(J,this._transformDocumentSelector(W,O),V);let ce=this._createDisposable(J);if(V!==void 0){const Me=j.onDidChangeInlineValues($e=>this._proxy.$emitInlineValuesEvent(V));ce=F.Disposable.from(ce,Me)}return ce}$provideInlineValues(O,W,j,K,V){return this._withAdapter(O,C,J=>J.provideInlineValues(w.URI.revive(W),j,K,V),void 0,V)}registerDocumentHighlightProvider(O,W,j){const K=this._addNewAdapter(new $(this._documents,j),O);return this._proxy.$registerDocumentHighlightProvider(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideDocumentHighlights(O,W,j,K){return this._withAdapter(O,$,V=>V.provideDocumentHighlights(w.URI.revive(W),j,K),void 0,K)}registerLinkedEditingRangeProvider(O,W,j){const K=this._addNewAdapter(new N(this._documents,j),O);return this._proxy.$registerLinkedEditingRangeProvider(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideLinkedEditingRanges(O,W,j,K){return this._withAdapter(O,N,async V=>{const J=await V.provideLinkedEditingRanges(w.URI.revive(W),j,K);if(J)return{ranges:J.ranges,wordPattern:J.wordPattern?fe._serializeRegExp(J.wordPattern):void 0}},void 0,K)}registerReferenceProvider(O,W,j){const K=this._addNewAdapter(new H(this._documents,j),O);return this._proxy.$registerReferenceSupport(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideReferences(O,W,j,K,V){return this._withAdapter(O,H,J=>J.provideReferences(w.URI.revive(W),j,K,V),void 0,V)}registerCodeActionProvider(O,W,j,K){const V=new h.DisposableStore,J=this._addNewAdapter(new B(this._documents,this._commands.converter,this._diagnostics,j,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(J,this._transformDocumentSelector(W,O),{providedKinds:K?.providedCodeActionKinds?.map(ce=>ce.value),documentation:K?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,V)}))},fe._extLabel(O),!!j.resolveCodeAction),V.add(this._createDisposable(J)),V}$provideCodeActions(O,W,j,K,V){return this._withAdapter(O,B,J=>J.provideCodeActions(w.URI.revive(W),j,K,V),void 0,V)}$resolveCodeAction(O,W,j){return this._withAdapter(O,B,K=>K.resolveCodeAction(W,j),{},void 0)}$releaseCodeActions(O,W){this._withAdapter(O,B,j=>Promise.resolve(j.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(O,W,j){const K=this._addNewAdapter(new U(this._documents,j),O);return this._proxy.$registerDocumentFormattingSupport(K,this._transformDocumentSelector(W,O),O.identifier,O.displayName||O.name),this._createDisposable(K)}$provideDocumentFormattingEdits(O,W,j,K){return this._withAdapter(O,U,V=>V.provideDocumentFormattingEdits(w.URI.revive(W),j,K),void 0,K)}registerDocumentRangeFormattingEditProvider(O,W,j){const K=typeof j.provideDocumentRangesFormattingEdits=="function",V=this._addNewAdapter(new ie(this._documents,j),O);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(W,O),O.identifier,O.displayName||O.name,K),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(O,W,j,K,V){return this._withAdapter(O,ie,J=>J.provideDocumentRangeFormattingEdits(w.URI.revive(W),j,K,V),void 0,V)}$provideDocumentRangesFormattingEdits(O,W,j,K,V){return this._withAdapter(O,ie,J=>J.provideDocumentRangesFormattingEdits(w.URI.revive(W),j,K,V),void 0,V)}registerOnTypeFormattingEditProvider(O,W,j,K){const V=this._addNewAdapter(new X(this._documents,j),O);return this._proxy.$registerOnTypeFormattingSupport(V,this._transformDocumentSelector(W,O),K,O.identifier),this._createDisposable(V)}$provideOnTypeFormattingEdits(O,W,j,K,V,J){return this._withAdapter(O,X,ce=>ce.provideOnTypeFormattingEdits(w.URI.revive(W),j,K,V,J),void 0,J)}registerWorkspaceSymbolProvider(O,W){const j=this._addNewAdapter(new ye(W,this._logService),O);return this._proxy.$registerNavigateTypeSupport(j,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(j)}$provideWorkspaceSymbols(O,W,j){return this._withAdapter(O,ye,K=>K.provideWorkspaceSymbols(W,j),{symbols:[]},j)}$resolveWorkspaceSymbol(O,W,j){return this._withAdapter(O,ye,K=>K.resolveWorkspaceSymbol(W,j),void 0,void 0)}$releaseWorkspaceSymbols(O,W){this._withAdapter(O,ye,j=>j.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(O,W,j){const K=this._addNewAdapter(new Pe(this._documents,j,this._logService),O);return this._proxy.$registerRenameSupport(K,this._transformDocumentSelector(W,O),Pe.supportsResolving(j)),this._createDisposable(K)}$provideRenameEdits(O,W,j,K,V){return this._withAdapter(O,Pe,J=>J.provideRenameEdits(w.URI.revive(W),j,K,V),void 0,V)}$resolveRenameLocation(O,W,j,K){return this._withAdapter(O,Pe,V=>V.resolveRenameLocation(w.URI.revive(W),j,K),void 0,K)}registerDocumentSemanticTokensProvider(O,W,j,K){const V=this._addNewAdapter(new pe(this._documents,j),O),J=typeof j.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(V,this._transformDocumentSelector(W,O),K,J);let ce=this._createDisposable(V);if(J){const Me=j.onDidChangeSemanticTokens($e=>this._proxy.$emitDocumentSemanticTokensEvent(J));ce=F.Disposable.from(ce,Me)}return ce}$provideDocumentSemanticTokens(O,W,j,K){return this._withAdapter(O,pe,V=>V.provideDocumentSemanticTokens(w.URI.revive(W),j,K),null,K)}$releaseDocumentSemanticTokens(O,W){this._withAdapter(O,pe,j=>j.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,W,j,K){const V=this._addNewAdapter(new Se(this._documents,j),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(V,this._transformDocumentSelector(W,O),K),this._createDisposable(V)}$provideDocumentRangeSemanticTokens(O,W,j,K){return this._withAdapter(O,Se,V=>V.provideDocumentRangeSemanticTokens(w.URI.revive(W),j,K),null,K)}registerCompletionItemProvider(O,W,j,K){const V=this._addNewAdapter(new le(this._documents,this._commands.converter,j,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(V,this._transformDocumentSelector(W,O),K,le.supportsResolving(j),O.identifier),this._createDisposable(V)}$provideCompletionItems(O,W,j,K,V){return this._withAdapter(O,le,J=>J.provideCompletionItems(w.URI.revive(W),j,K,V),void 0,V)}$resolveCompletionItem(O,W,j){return this._withAdapter(O,le,K=>K.resolveCompletionItem(W,j),void 0,j)}$releaseCompletionItems(O,W){this._withAdapter(O,le,j=>j.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(O,W,j,K){const V=new we(O,this._documents,j,this._commands.converter),J=this._addNewAdapter(V,O);return this._proxy.$registerInlineCompletionsSupport(J,this._transformDocumentSelector(W,O),V.supportsHandleEvents,p.ExtensionIdentifier.toKey(O.identifier.value),K?.yieldTo?.map(ce=>p.ExtensionIdentifier.toKey(ce))||[]),this._createDisposable(J)}$provideInlineCompletions(O,W,j,K,V){return this._withAdapter(O,ae,J=>J.provideInlineCompletions(w.URI.revive(W),j,K,V),void 0,V)}$handleInlineCompletionDidShow(O,W,j,K){this._withAdapter(O,ae,async V=>{V.handleDidShowCompletionItem(W,j,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,W,j,K){this._withAdapter(O,ae,async V=>{V.handlePartialAccept(W,j,K)},void 0,void 0)}$freeInlineCompletionsList(O,W){this._withAdapter(O,ae,async j=>{j.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(O,W,j,K){const V=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,J=this._addNewAdapter(new z(this._documents,j),O);return this._proxy.$registerSignatureHelpProvider(J,this._transformDocumentSelector(W,O),V),this._createDisposable(J)}$provideSignatureHelp(O,W,j,K,V){return this._withAdapter(O,z,J=>J.provideSignatureHelp(w.URI.revive(W),j,K,V),void 0,V)}$releaseSignatureHelp(O,W){this._withAdapter(O,z,j=>j.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(O,W,j){const K=typeof j.onDidChangeInlayHints=="function"?this._nextHandle():void 0,V=this._addNewAdapter(new Y(this._documents,this._commands.converter,j,this._logService,O),O);this._proxy.$registerInlayHintsProvider(V,this._transformDocumentSelector(W,O),typeof j.resolveInlayHint=="function",K,fe._extLabel(O));let J=this._createDisposable(V);if(K!==void 0){const ce=j.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(K));J=F.Disposable.from(J,ce)}return J}$provideInlayHints(O,W,j,K){return this._withAdapter(O,Y,V=>V.provideInlayHints(w.URI.revive(W),j,K),void 0,K)}$resolveInlayHint(O,W,j){return this._withAdapter(O,Y,K=>K.resolveInlayHint(W,j),void 0,j)}$releaseInlayHints(O,W){this._withAdapter(O,Y,j=>j.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(O,W,j){const K=this._addNewAdapter(new ee(this._documents,j),O);return this._proxy.$registerDocumentLinkProvider(K,this._transformDocumentSelector(W,O),typeof j.resolveDocumentLink=="function"),this._createDisposable(K)}$provideDocumentLinks(O,W,j){return this._withAdapter(O,ee,K=>K.provideLinks(w.URI.revive(W),j),void 0,j,W.scheme==="output")}$resolveDocumentLink(O,W,j){return this._withAdapter(O,ee,K=>K.resolveLink(W,j),void 0,void 0,!0)}$releaseDocumentLinks(O,W){this._withAdapter(O,ee,j=>j.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(O,W,j){const K=this._addNewAdapter(new ve(this._documents,j),O);return this._proxy.$registerDocumentColorProvider(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideDocumentColors(O,W,j){return this._withAdapter(O,ve,K=>K.provideColors(w.URI.revive(W),j),[],j)}$provideColorPresentations(O,W,j,K){return this._withAdapter(O,ve,V=>V.provideColorPresentations(w.URI.revive(W),j,K),void 0,K)}registerFoldingRangeProvider(O,W,j){const K=this._nextHandle(),V=typeof j.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(K,new oe(new ge(this._documents,j),O)),this._proxy.$registerFoldingRangeProvider(K,this._transformDocumentSelector(W,O),O.identifier,V);let J=this._createDisposable(K);if(V!==void 0){const ce=j.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(V));J=F.Disposable.from(J,ce)}return J}$provideFoldingRanges(O,W,j,K){return this._withAdapter(O,ge,V=>V.provideFoldingRanges(w.URI.revive(W),j,K),void 0,K)}registerSelectionRangeProvider(O,W,j){const K=this._addNewAdapter(new de(this._documents,j,this._logService),O);return this._proxy.$registerSelectionRangeProvider(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideSelectionRanges(O,W,j,K){return this._withAdapter(O,de,V=>V.provideSelectionRanges(w.URI.revive(W),j,K),[],K)}registerCallHierarchyProvider(O,W,j){const K=this._addNewAdapter(new _e(this._documents,j),O);return this._proxy.$registerCallHierarchyProvider(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$prepareCallHierarchy(O,W,j,K){return this._withAdapter(O,_e,V=>Promise.resolve(V.prepareSession(w.URI.revive(W),j,K)),void 0,K)}$provideCallHierarchyIncomingCalls(O,W,j,K){return this._withAdapter(O,_e,V=>V.provideCallsTo(W,j,K),void 0,K)}$provideCallHierarchyOutgoingCalls(O,W,j,K){return this._withAdapter(O,_e,V=>V.provideCallsFrom(W,j,K),void 0,K)}$releaseCallHierarchy(O,W){this._withAdapter(O,_e,j=>Promise.resolve(j.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(O,W,j){const K=this._addNewAdapter(new re(this._documents,j),O);return this._proxy.$registerTypeHierarchyProvider(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$prepareTypeHierarchy(O,W,j,K){return this._withAdapter(O,re,V=>Promise.resolve(V.prepareSession(w.URI.revive(W),j,K)),void 0,K)}$provideTypeHierarchySupertypes(O,W,j,K){return this._withAdapter(O,re,V=>V.provideSupertypes(W,j,K),void 0,K)}$provideTypeHierarchySubtypes(O,W,j,K){return this._withAdapter(O,re,V=>V.provideSubtypes(W,j,K),void 0,K)}$releaseTypeHierarchy(O,W){this._withAdapter(O,re,j=>Promise.resolve(j.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(O,W,j,K){const V=this._nextHandle();this._adapter.set(V,new oe(new ue(this._proxy,this._documents,j,V,O),O));const J=(0,n.isProposedApiEnabled)(O,"dropMetadata")&&K?ue.toInternalProviderId(O.identifier.value,K.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(W,O),J,(0,n.isProposedApiEnabled)(O,"dropMetadata")?K:void 0),this._createDisposable(V)}$provideDocumentOnDropEdits(O,W,j,K,V,J){return this._withAdapter(O,ue,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(W,w.URI.revive(j),K,V,J)),void 0,void 0)}registerMappedEditsProvider(O,W,j){const K=this._addNewAdapter(new ne(this._documents,j),O);return this._proxy.$registerMappedEditsProvider(K,this._transformDocumentSelector(W,O)),this._createDisposable(K)}$provideMappedEdits(O,W,j,K,V){return this._withAdapter(O,ne,J=>Promise.resolve(J.provideMappedEdits(W,j,K,V)),null,V)}registerDocumentPasteEditProvider(O,W,j,K){const V=this._nextHandle();this._adapter.set(V,new oe(new L(this._proxy,this._documents,j,V,O),O));const J=L.toInternalProviderId(O.identifier.value,K.id);return this._proxy.$registerPasteEditProvider(V,this._transformDocumentSelector(W,O),J,{supportsCopy:!!j.prepareDocumentPaste,supportsPaste:!!j.provideDocumentPasteEdits,copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this._createDisposable(V)}$prepareDocumentPaste(O,W,j,K,V){return this._withAdapter(O,L,J=>J.prepareDocumentPaste(w.URI.revive(W),j,K,V),void 0,V)}$providePasteEdits(O,W,j,K,V,J){return this._withAdapter(O,L,ce=>ce.providePasteEdits(W,w.URI.revive(j),K,V,J),void 0,J)}static _serializeRegExp(O){return{pattern:O.source,flags:O.flags}}static _serializeIndentationRule(O){return{decreaseIndentPattern:fe._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:fe._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?fe._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?fe._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:fe._serializeRegExp(O.beforeText),afterText:O.afterText?fe._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?fe._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(fe._serializeOnEnterRule)}static _serializeAutoClosingPair(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(W=>F.SyntaxTokenType.toString(W)):void 0}}static _serializeAutoClosingPairs(O){return O.map(fe._serializeAutoClosingPair)}setLanguageConfiguration(O,W,j){const{wordPattern:K}=j;if(K&&(0,y.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this._documents.setWordDefinitionFor(W,K):this._documents.setWordDefinitionFor(W,void 0),j.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),j.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const V=this._nextHandle(),J={comments:j.comments,brackets:j.brackets,wordPattern:j.wordPattern?fe._serializeRegExp(j.wordPattern):void 0,indentationRules:j.indentationRules?fe._serializeIndentationRule(j.indentationRules):void 0,onEnterRules:j.onEnterRules?fe._serializeOnEnterRules(j.onEnterRules):void 0,__electricCharacterSupport:j.__electricCharacterSupport,__characterPairSupport:j.__characterPairSupport,autoClosingPairs:j.autoClosingPairs?fe._serializeAutoClosingPairs(j.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(V,W,J),this._createDisposable(V)}$setWordDefinitions(O){for(const W of O)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=fe}),define(Te[243],Ae([1,0,3,8,7,29,12,6,22]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class f{constructor(D,a,E,p){this._documents=a,this._commands=E,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=D.getProxy(w.MainContext.MainThreadLanguages)}$acceptLanguageIds(D){this._languageIds=D}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(D,a){await this._proxy.$changeLanguage(D,a);const E=this._documents.getDocumentData(D);if(!E)throw new Error(`document '${D.toString()}' NOT found`);return E.document}async tokenAtPosition(D,a){const E=D.version,p=R.Position.from(a),h=await this._proxy.$tokensAtPosition(D.uri,p),t={type:P.StandardTokenType.Other,range:D.getWordRangeAtPosition(a)??new P.Range(a.line,a.character,a.line,a.character)};if(!h)return t;const i={range:R.Range.to(h.range),type:R.TokenType.to(h.type)};return!i.range.contains(a)||E!==D.version?t:i}createLanguageStatusItem(D,a,E){const p=this._handlePool++,h=this._proxy,t=this._ids,i=`${D.identifier.value}/${a}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);t.add(i);const u={selector:E,id:a,name:D.displayName??D.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const _=new l.DisposableStore,m=()=>{if(v?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${a}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}v=(0,T.disposableTimeout)(()=>{_.clear(),this._proxy.$setLanguageStatus(p,{id:i,name:u.name??D.displayName??D.name,source:D.displayName??D.name,selector:R.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===P.LanguageStatusSeverity.Error?F.default.Error:u.severity===P.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:u.command&&this._commands.toInternal(u.command,_),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},n={dispose(){_.dispose(),v?.dispose(),h.$removeLanguageStatus(p),t.delete(i)},get id(){return u.id},get name(){return u.name},set name(r){u.name=r,m()},get selector(){return u.selector},set selector(r){u.selector=r,m()},get text(){return u.text},set text(r){u.text=r,m()},set text2(r){(0,y.checkProposedApiEnabled)(D,"languageStatusText"),u.text=r,m()},get text2(){return(0,y.checkProposedApiEnabled)(D,"languageStatusText"),u.text},get detail(){return u.detail},set detail(r){u.detail=r,m()},get severity(){return u.severity},set severity(r){u.severity=r,m()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(r){u.accessibilityInformation=r,m()},get command(){return u.command},set command(r){u.command=r,m()},get busy(){return u.busy},set busy(r){u.busy=r,m()}};return m(),n}}e.ExtHostLanguages=f}),define(Te[81],Ae([1,0,23,16,2,4,14,3,27,17]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(a,E,p){this.logService=p,this.bundleCache=new Map,this._proxy=E.getProxy(l.MainContext.MainThreadLocalization),this.currentLanguage=a.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===w.LANGUAGE_DEFAULT}getMessage(a,E){const{message:p,args:h,comment:t}=E;if(this.isDefaultLanguage)return(0,R.format2)(p,h??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const u=this.bundleCache.get(a)?.contents[i];return u||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,R.format2)(u??p,h??{})}getBundle(a){return this.bundleCache.get(a)?.contents}getBundleUri(a){return this.bundleCache.get(a)?.uri}async initializeLocalizedMessages(a){if(this.isDefaultLanguage||!a.l10n&&!a.isBuiltin||this.bundleCache.has(a.identifier.value))return;let E;const p=await this.getBundleLocation(a);if(!p){this.logService.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const h=await this._proxy.$fetchBundleContents(p),t=JSON.parse(h);E=a.isBuiltin?t.contents?.bundle:t}catch(h){this.logService.error(`Failed to load translations for ${a.identifier.value} from ${p}: ${h.message}`);return}E&&this.bundleCache.set(a.identifier.value,{contents:E,uri:p})}async getBundleLocation(a){if(a.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(a.identifier.value,this.currentLanguage);return P.URI.revive(E)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=A,e.ExtHostLocalizationService=A=Ve([He(0,y.IExtHostInitDataService),He(1,f.IExtHostRpcService),He(2,T.ILogService)],A),e.IExtHostLocalizationService=(0,F.createDecorator)("IExtHostLocalizationService")}),define(Te[244],Ae([1,0,14,3,27,17,2,68]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends w.AbstractLoggerService{constructor(D,a){super(a.logLevel,a.logsLocation,a.loggers.map(E=>(0,l.revive)(E))),this._proxy=D.getProxy(R.MainContext.MainThreadLogger)}$setLogLevel(D,a){a?this.setLogLevel(T.URI.revive(a),D):this.setLogLevel(D)}setVisibility(D,a){super.setVisibility(D,a),this._proxy.$setVisibility(D,a)}doCreateLogger(D,a,E){return new f(this._proxy,D,a,E)}};e.ExtHostLoggerService=y,e.ExtHostLoggerService=y=Ve([He(0,F.IExtHostRpcService),He(1,P.IExtHostInitDataService)],y);class f extends w.AbstractMessageLogger{constructor(D,a,E,p){super(p?.logLevel==="always"),this.proxy=D,this.file=a,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(E),this.proxy.$createLogger(a,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(D,a){const E=[[D,a]];this.isLoggerCreated?this.doLog(E):this.buffer.push(...E)}doLog(D){this.proxy.$log(this.file,D)}flush(){this.proxy.$flush(this.file)}}}),define(Te[82],Ae([1,0,3,4,6,17,26]),function(be,e,w,R,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,R.createDecorator)("IExtHostManagedSockets");let l=class{constructor(D){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=D.getProxy(w.MainContext.MainThreadManagedSockets)}setFactory(D,a){for(const E of this._managedRemoteSockets.values())E.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new y(D,a),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(D){if(!this._factory||this._factory.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const a=++this._remoteSocketIdCounter,E=await this._factory.makeConnection(),p=new P.DisposableStore;return this._managedRemoteSockets.set(a,new f(a,E,p)),p.add((0,P.toDisposable)(()=>this._managedRemoteSockets.delete(a))),p.add(E.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(a),p.dispose()})),p.add(E.onDidClose(h=>{this._proxy.$onDidManagedSocketClose(a,h?.stack??h?.message),p.dispose()})),p.add(E.onDidReceiveMessage(h=>this._proxy.$onDidManagedSocketHaveData(a,T.VSBuffer.wrap(h)))),a}$remoteSocketWrite(D,a){this._managedRemoteSockets.get(D)?.actual.send(a.buffer)}$remoteSocketEnd(D){const a=this._managedRemoteSockets.get(D);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(D){await this._managedRemoteSockets.get(D)?.actual.drain?.()}};e.ExtHostManagedSockets=l,e.ExtHostManagedSockets=l=Ve([He(0,F.IExtHostRpcService)],l);class y{constructor(D,a){this.socketFactoryId=D,this.makeConnection=a}}class f extends P.Disposable{constructor(D,a,E){super(),this.socketId=D,this.actual=a,this._register(E)}}}),define(Te[245],Ae([1,0,3,14,22]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function F(l){return l&&l.title}let T=class{constructor(y,f){this._logService=f,this._proxy=y.getProxy(w.MainContext.MainThreadMessageService)}showMessage(y,f,A,D,a){const E={source:{identifier:y.identifier,label:y.displayName||y.name}};let p;typeof D=="string"||F(D)?p=[D,...a]:(E.modal=D?.modal,E.useCustom=D?.useCustom,E.detail=D?.detail,p=a),E.useCustom&&(0,P.checkProposedApiEnabled)(y,"resolvers");const h=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")h.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:u,isCloseAffordance:v}=i;h.push({title:u,isCloseAffordance:!!v,handle:t})}else this._logService.warn("Invalid message item:",i)}return this._proxy.$showMessage(f,A,E,h).then(t=>{if(typeof t=="number")return p[t]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=Ve([He(1,R.ILogService)],T)}),define(Te[246],Ae([1,0,152,26,5,6,28,16,15,2,39,74,3,31,8,7,47,208,104,11,25,13]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class n{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}constructor(s,o,g,d,k){this._textDocumentsAndEditors=g,this._textDocuments=d,this._extHostFileSystem=k,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new P.Emitter({onListenerError:v.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter({onListenerError:v.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter({onListenerError:v.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter({onListenerError:v.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=s.getProxy(a.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(a.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(a.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const c=I.notebookEditor?.notebookUri,S=I.cell.handle,C=this._documents.get(c)?.getCell(S);if(C)return C.apiCell}if(I&&I.$mid===14){const c=I.uri,S=this._documents.get(c);if(S)return S.apiNotebook}return I}}),n._registerApiCommands(o)}getEditorById(s){const o=this._editors.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(s){for(const[o,g]of this._editors)if(g.apiEditor===s)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,o){const g=this._documents.get(s);if(!g&&!o)throw new Error(`NO notebook document for '${s}'`);return g}static _convertNotebookRegistrationData(s,o){if(!o)return;const g=o.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(o.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:g,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,g){const d=n._notebookStatusBarItemProviderHandlePool++,k=typeof g.onDidChangeCellStatusBarItems=="function"?n._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(d,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(d,k,o);let I;return k!==void 0&&(I=g.onDidChangeCellStatusBarItems(c=>this._notebookProxy.$emitCellStatusBarEvent(k))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(d),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(d,k),I?.dispose()})}async createNotebookDocument(s){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&p.NotebookData.from(s.content)});return f.URI.revive(o)}async openNotebookDocument(s){const o=this._documents.get(s);if(o)return o.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(s),d=this._documents.get(f.URI.revive(g));return(0,y.assertIsDefined)(d?.apiNotebook)}async showNotebookDocument(s,o){f.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let g;typeof o=="object"?g={position:p.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(p.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:g={preserveFocus:!1};const d=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,g),k=d&&this._editors.get(d)?.apiEditor;if(k)return k;throw d?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,g,d){const k=this._notebookStatusBarItemProviders.get(s),I=f.URI.revive(o),c=this._documents.get(I);if(!c||!k)return;const S=c.getCellFromIndex(g);if(!S)return;const b=await k.provideCellStatusBarItems(S.apiCell,d);if(!b)return;const C=new F.DisposableStore,$=this._statusBarCache.add([C]),H=(Array.isArray(b)?b:[b]).map(B=>p.NotebookStatusBarItem.from(B,this._commandsConverter,C));return{cacheId:$,items:H}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,o,g,d,k){if((0,l.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const I=this._handlePool++;return this._notebookSerializer.set(I,{viewType:o,serializer:g,options:d}),this._notebookProxy.$registerNotebookSerializer(I,{id:s.identifier,location:s.extensionLocation},o,p.NotebookDocumentContentOptions.from(d),n._convertNotebookRegistrationData(s,k)),(0,F.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(I)})}async $dataToNotebook(s,o,g){const d=this._notebookSerializer.get(s);if(!d)throw new Error("NO serializer found");const k=await d.serializer.deserializeNotebook(o.buffer,g);return new t.SerializableObjectWithBuffers(p.NotebookData.from(k))}async $notebookToData(s,o,g){const d=this._notebookSerializer.get(s);if(!d)throw new Error("NO serializer found");const k=await d.serializer.serializeNotebook(p.NotebookData.to(o.value),g);return R.VSBuffer.wrap(k)}async $saveNotebook(s,o,g,d,k){const I=f.URI.revive(o),c=this._notebookSerializer.get(s);if(!c)throw new Error("NO serializer found");const S=this._documents.get(I);if(!S)throw new Error("Document NOT found");if(S.versionId!==g)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(I.scheme))throw new A.FileOperationError((0,w.localize)(0,null,this._resourceForError(I)),6);await this._validateWriteFile(I,d);const b={metadata:(0,_.filter)(S.apiNotebook.metadata,B=>!(c.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of S.apiNotebook.getCells()){const L=new h.NotebookCellData(B.kind,B.document.getText(),B.document.languageId,B.mime,c.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);L.metadata=(0,_.filter)(B.metadata,U=>!(c.options?.transientCellMetadata??{})[U]),b.cells.push(L)}const C=await c.serializer.serializeNotebook(b,k);await this._extHostFileSystem.value.writeFile(I,C);const $=this._extHostFileSystem.getFileSystemProviderExtUri(I.scheme),N=await this._extHostFileSystem.value.stat(I);return{name:$.basename(I),isFile:(N.type&A.FileType.File)!==0,isDirectory:(N.type&A.FileType.Directory)!==0,isSymbolicLink:(N.type&A.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&A.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(I.scheme),locked:!!((N.permissions??0)&A.FilePermission.Locked),etag:A.etag({mtime:N.mtime,size:N.size}),children:void 0}}async _validateWriteFile(s,o){const g=await this._extHostFileSystem.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==A.ETAG_DISABLED&&typeof g.mtime=="number"&&typeof g.size=="number"&&o.mtime<g.mtime&&o.etag!==A.etag({mtime:o.mtime,size:g.size}))throw new A.FileOperationError((0,w.localize)(1,null),3,o)}_resourceForError(s){return s.scheme===m.Schemas.file?s.fsPath:s.toString()}_createExtHostEditor(s,o,g){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const d=new u.ExtHostNotebookEditor(o,this._notebookEditorsProxy,s,g.visibleRanges.map(p.NotebookRange.to),g.selections.map(p.NotebookRange.to),typeof g.viewColumn=="number"?p.ViewColumn.to(g.viewColumn):void 0);this._editors.set(o,d)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const g of s.value.removedDocuments){const d=f.URI.revive(g),k=this._documents.get(d);k&&(k.dispose(),this._documents.delete(d),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:k.apiNotebook.getCells().map(I=>I.document.uri)}),this._onDidCloseNotebookDocument.fire(k.apiNotebook));for(const I of this._editors.values())I.notebookData.uri.toString()===d.toString()&&this._editors.delete(I.id)}if(s.value.addedDocuments){const g=[];for(const d of s.value.addedDocuments){const k=f.URI.revive(d.uri);if(this._documents.has(k))throw new Error(`adding EXISTING notebook ${k} `);const I=new i.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,k,d);g.push(...d.cells.map(c=>i.ExtHostCell.asModelAddData(I.apiNotebook,c))),this._documents.get(k)?.dispose(),this._documents.set(k,I),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(I.apiNotebook)}}if(s.value.addedEditors)for(const g of s.value.addedEditors){if(this._editors.has(g.id))return;const d=f.URI.revive(g.documentUri),k=this._documents.get(d);k&&this._createExtHostEditor(k,g.id,g)}const o=[];if(s.value.removedEditors)for(const g of s.value.removedEditors){const d=this._editors.get(g);d&&(this._editors.delete(g),this._activeNotebookEditor?.id===d.id&&(this._activeNotebookEditor=void 0),o.push(d))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(d=>this._editors.get(d)).filter(d=>!!d);const g=new Set;this._visibleNotebookEditors.forEach(d=>g.add(d.id));for(const d of this._editors.values()){const k=g.has(d.id);d._acceptVisibility(k)}this._visibleNotebookEditors=[...this._editors.values()].map(d=>d).filter(d=>d.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._editors.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(s){const o=E.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new E.ApiCommandArgument("data","Bytes to convert to data",k=>k instanceof Uint8Array,k=>R.VSBuffer.wrap(k))],new E.ApiCommandResult("Notebook Data",k=>p.NotebookData.to(k.value))),d=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",k=>!0,k=>new t.SerializableObjectWithBuffers(p.NotebookData.from(k)))],new E.ApiCommandResult("Bytes",k=>k.buffer));s.registerApiCommand(g),s.registerApiCommand(d)}}e.ExtHostNotebookController=n}),define(Te[247],Ae([1,0,18,12,19,5,6,28,2,21,14,3,31,8,7,77,199,22,47]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let v=class{constructor(d,k,I,c,S){this._initData=k,this._extHostNotebook=I,this._commands=c,this._logService=S,this._activeExecutions=new l.ResourceMap,this._activeNotebookExecutions=new l.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=d.getProxy(D.MainContext.MainThreadNotebookKernels);const b=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const $=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:$}}else if(C&&"notebookEditor"in C){const $=this._extHostNotebook.getIdByEditor(C.notebookEditor);if($===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:$}}return C})],a.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(d,k,I,c,S,b){for(const Se of this._kernelData.values())if(Se.controller.id===k&&f.ExtensionIdentifier.equals(d.identifier,Se.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const C=this._handlePool++,$=this;this._logService.trace(`NotebookController[${C}], CREATED by ${d.identifier.value}, ${k}`);const N=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${d.identifier}'`);let H=!1;const B=new F.Emitter,L=new F.Emitter,U={id:o(d.identifier,k),notebookType:I,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:c||d.identifier.value,preloads:b?b.map(E.NotebookRendererScript.from):[]};let ie=S??N,X;this._proxy.$addKernel(C,U).catch(Se=>{console.log(Se),H=!0});let ye=0;const Pe=()=>{if(H)return;const Se=++ye;Promise.resolve().then(()=>{Se===ye&&this._proxy.$updateKernel(C,U)})},De=new l.ResourceMap,pe={get id(){return k},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(Se){U.label=Se??d.displayName??d.name,Pe()},get detail(){return U.detail??""},set detail(Se){U.detail=Se,Pe()},get description(){return U.description??""},set description(Se){U.description=Se,Pe()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(Se){U.supportedLanguages=Se,Pe()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(Se){U.supportsExecutionOrder=Se,Pe()},get rendererScripts(){return U.preloads?U.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(Se){ie=Se??N},get interruptHandler(){return X},set interruptHandler(Se){X=Se,U.supportsInterrupt=!!Se,Pe()},createNotebookCellExecution(Se){if(H)throw new Error("notebook controller is DISPOSED");if(!De.has(Se.notebook.uri))throw $._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(De.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.notebook.uri.toString()}`);return $._createNotebookCellExecution(Se,o(d.identifier,this.id))},createNotebookExecution(Se){if((0,i.checkProposedApiEnabled)(d,"notebookExecution"),H)throw new Error("notebook controller is DISPOSED");if(!De.has(Se.uri))throw $._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(De.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.uri.toString()}`);return $._createNotebookExecution(Se,o(d.identifier,this.id))},dispose:()=>{H||(this._logService.trace(`NotebookController[${C}], DISPOSED`),H=!0,this._kernelData.delete(C),B.dispose(),L.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(Se,le){le===p.NotebookControllerAffinity2.Hidden&&(0,i.checkProposedApiEnabled)(d,"notebookControllerAffinityHidden"),$._proxy.$updateNotebookPriority(C,Se.uri,le)},onDidReceiveMessage:L.event,postMessage(Se,le){return(0,i.checkProposedApiEnabled)(d,"notebookMessaging"),$._proxy.$postMessage(C,le&&$._extHostNotebook.getIdByEditor(le),Se)},asWebviewUri(Se){return(0,i.checkProposedApiEnabled)(d,"notebookMessaging"),(0,h.asWebviewUri)(Se,$._initData.remote)}};return this._kernelData.set(C,{extensionId:d.identifier,controller:pe,onDidReceiveMessage:L,onDidChangeSelection:B,associatedNotebooks:De}),pe}getIdByController(d){for(const[k,I]of this._kernelData)if(I.controller===d)return o(I.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,k){const I=this._kernelDetectionTaskHandlePool++,c=this;this._logService.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${d.identifier.value}`),this._proxy.$addKernelDetectionTask(I,k);const S={dispose:()=>{this._kernelDetectionTask.delete(I),c._proxy.$removeKernelDetectionTask(I)}};return this._kernelDetectionTask.set(I,S),S}registerKernelSourceActionProvider(d,k,I){const c=this._kernelSourceActionProviderHandlePool++,S=typeof I.onDidChangeNotebookKernelSourceActions=="function"?c:void 0,b=this;this._kernelSourceActionProviders.set(c,I),this._logService.trace(`NotebookKernelSourceActionProvider[${c}], CREATED by ${d.identifier.value}`),this._proxy.$addKernelSourceActionProvider(c,c,k);let C;return S!==void 0&&(C=I.onDidChangeNotebookKernelSourceActions($=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(S))),{dispose:()=>{this._kernelSourceActionProviders.delete(c),b._proxy.$removeKernelSourceActionProvider(c,c),C?.dispose()}}}async $provideKernelSourceActions(d,k){const I=this._kernelSourceActionProviders.get(d);if(I){const c=new T.DisposableStore;return(await I.provideNotebookKernelSourceActions(k)??[]).map(b=>E.NotebookKernelSourceAction.from(b,this._commands.converter,c))}return[]}$acceptNotebookAssociation(d,k,I){const c=this._kernelData.get(d);if(c){const S=this._extHostNotebook.getNotebookDocument(y.URI.revive(k));I?c.associatedNotebooks.set(S.uri,!0):c.associatedNotebooks.delete(S.uri),this._logService.trace(`NotebookController[${d}] ASSOCIATE notebook`,S.uri.toString(),I),c.onDidChangeSelection.fire({selected:I,notebook:S.apiNotebook})}}async $executeCells(d,k,I){const c=this._kernelData.get(d);if(!c)return;const S=this._extHostNotebook.getNotebookDocument(y.URI.revive(k)),b=[];for(const C of I){const $=S.getCell(C);$&&b.push($.apiCell)}try{this._logService.trace(`NotebookController[${d}] EXECUTE cells`,S.uri.toString(),b.length),await c.controller.executeHandler.call(c.controller,b,S.apiNotebook,c.controller)}catch(C){this._logService.error(`NotebookController[${d}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(d,k,I){const c=this._kernelData.get(d);if(!c)return;const S=this._extHostNotebook.getNotebookDocument(y.URI.revive(k));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,S.apiNotebook);else for(const b of I){const C=S.getCell(b);C&&this._activeExecutions.get(C.uri)?.cancel()}if(c.controller.interruptHandler){const b=this._activeNotebookExecutions.get(S.uri);I.length&&Array.isArray(b)&&b.length&&b.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(d,k,I){const c=this._kernelData.get(d);if(!c)return;const S=this._extHostNotebook.getEditorById(k);c.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:I}))}$cellExecutionChanged(d,k,I){const S=this._extHostNotebook.getNotebookDocument(y.URI.revive(d)).getCell(k);if(S){const b=I?E.NotebookCellExecutionState.to(I):p.NotebookCellExecutionState.Idle;b!==void 0&&this._onDidChangeCellExecutionState.fire({cell:S.apiCell,state:b})}}_createNotebookCellExecution(d,k){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const S=new m(k,c,this._proxy);this._activeExecutions.set(c.uri,S);const b=S.onDidChangeState(()=>{S.state===_.Resolved&&(S.dispose(),b.dispose(),this._activeExecutions.delete(c.uri))});return S.asApiObject()}_createNotebookExecution(d,k){const I=this._extHostNotebook.getNotebookDocument(d.uri),c=d.getCells().find(C=>{const $=I.getCellFromApiCell(C);return $&&this._activeExecutions.has($.uri)});if(c)throw new Error(`duplicate cell execution for ${c.document.uri}`);if(this._activeNotebookExecutions.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const S=new r(k,I,this._proxy),b=S.onDidChangeState(()=>{S.state===n.Resolved&&(S.dispose(),b.dispose(),this._activeNotebookExecutions.delete(I.uri))});return this._activeNotebookExecutions.set(I.uri,[S,b]),S.asApiObject()}};e.ExtHostNotebookKernels=v,e.ExtHostNotebookKernels=v=Ve([He(4,A.ILogService)],v);var _;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(_||(_={}));class m extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(d,k,I){super(),this._cell=k,this._proxy=I,this._handle=m.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=_.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._collector=new s(10,c=>this.update(c)),this._executionOrder=k.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,d,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(d){await this._collector.addItem(d)}async update(d){const k=Array.isArray(d)?d:[d];return this._proxy.$updateExecution(this._handle,new u.SerializableObjectWithBuffers(k))}verifyStateForOutput(){if(this._state===_.Init)throw new Error("Must call start before modifying cell output");if(this._state===_.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(d){let k=this._cell;if(d&&(k=this._cell.notebook.getCellFromApiCell(d)),!k)throw new Error("INVALID cell");return k.handle}validateAndConvertOutputs(d){return d.map(k=>{const I=p.NotebookCellOutput.ensureUniqueMimeTypes(k.items,!0);return I===k.items?E.NotebookCellOutput.from(k):E.NotebookCellOutput.from({items:I,id:k.id,metadata:k.metadata})})}async updateOutputs(d,k,I){const c=this.cellIndexToHandle(k),S=this.validateAndConvertOutputs((0,w.asArray)(d));return this.updateSoon({editType:t.CellExecutionUpdateType.Output,cellHandle:c,append:I,outputs:S})}async updateOutputItems(d,k,I){return d=p.NotebookCellOutput.ensureUniqueMimeTypes((0,w.asArray)(d),!0),this.updateSoon({editType:t.CellExecutionUpdateType.OutputItems,items:d.map(E.NotebookCellOutputItem.from),outputId:k.id,append:I})}asApiObject(){const d=this;return Object.freeze({get token(){return d._tokenSource.token},get cell(){return d._cell.apiCell},get executionOrder(){return d._executionOrder},set executionOrder(I){d._executionOrder=I,d.update([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:d._executionOrder}])},start(I){if(d._state===_.Resolved||d._state===_.Started)throw new Error("Cannot call start again");d._state=_.Started,d._onDidChangeState.fire(),d.update({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,c){if(d._state===_.Resolved)throw new Error("Cannot call resolve twice");d._state=_.Resolved,d._onDidChangeState.fire(),d._collector.flush(),d._proxy.$completeExecution(d._handle,new u.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:I}))},clearOutput(I){return d.verifyStateForOutput(),d.updateOutputs([],I,!1)},appendOutput(I,c){return d.verifyStateForOutput(),d.updateOutputs(I,c,!0)},replaceOutput(I,c){return d.verifyStateForOutput(),d.updateOutputs(I,c,!1)},appendOutputItems(I,c){return d.verifyStateForOutput(),d.updateOutputItems(I,c,!0)},replaceOutputItems(I,c){return d.verifyStateForOutput(),d.updateOutputItems(I,c,!1)}})}}var n;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(n||(n={}));class r extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(d,k,I){super(),this._notebook=k,this._proxy=I,this._handle=r.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=n.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,d,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===n.Resolved||this._state===n.Started)throw new Error("Cannot call start again");this._state=n.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===n.Resolved)throw new Error("Cannot call resolve twice");this._state=n.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class s{constructor(d,k){this.delay=d,this.callback=k,this.batch=[],this.startedTimer=Date.now()}addItem(d){return this.batch.push(d),this.currentDeferred||(this.currentDeferred=new R.DeferredPromise,this.startedTimer=Date.now(),(0,R.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const d=this.currentDeferred;this.currentDeferred=void 0;const k=this.batch;return this.batch=[],this.callback(k).finally(()=>d.complete())}}function o(g,d){return`${g.value}/${d}`}e.createKernelId=o}),define(Te[248],Ae([1,0,5,3,104]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(l,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=l.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(l,y,f){const A=this._extHostNotebook.getEditorById(l);this._rendererMessageEmitters.get(y)?.fire({editor:A.apiEditor,message:f})}createRendererMessaging(l,y){if(!l.contributes?.notebookRenderer?.some(A=>A.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(A,D,a)=>this.getOrCreateEmitterFor(y).event(A,D,a),postMessage:(A,D)=>{P.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,D]=[D,A]);const a=D&&P.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.proxy.$postMessage(a?.id,y,A)}}}getOrCreateEmitterFor(l){let y=this._rendererMessageEmitters.get(l);return y||(y=new w.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(l)}}),this._rendererMessageEmitters.set(l,y),y)}}e.ExtHostNotebookRenderers=F}),define(Te[249],Ae([1,0,6,15,2,22,3]),function(be,e,w,R,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class l{constructor(f){this.handlers=new Map,this.proxy=f.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,A,D){if((0,F.checkProposedApiEnabled)(f,"profileContentHandlers"),this.handlers.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.handlers.set(A,D),this.proxy.$registerProfileContentHandler(A,D.name,D.description,f.identifier.value),(0,w.toDisposable)(()=>{this.handlers.delete(A),this.proxy.$unregisterProfileContentHandler(A)})}async $saveProfile(f,A,D,a){const E=this.handlers.get(f);if(!E)throw new Error(`Unknown handler with id: ${f}`);return E.saveProfile(A,D,a)}async $readProfile(f,A,D){const a=this.handlers.get(f);if(!a)throw new Error(`Unknown handler with id: ${f}`);return a.readProfile((0,R.isString)(A)?A:P.URI.revive(A),D)}}e.ExtHostProfileContentHandlers=l}),define(Te[250],Ae([1,0,2,3,12,8]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(y,f){this.uriTransformer=f,this.providers=new Map,this.proxy=y.getProxy(R.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,f,A){const D=w.URI.revive(f),a=this.providers.get(y);return a?(0,P.asPromise)(()=>a.provideOriginalResource(D,A)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(y,f,A,D){const a=T.handlePool++;return this.providers.set(a,f),this.proxy.$registerQuickDiffProvider(a,F.DocumentSelector.from(y,this.uriTransformer),A,D),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(a),this.providers.delete(a)}}}}e.ExtHostQuickDiff=T}),define(Te[251],Ae([1,0,19,5,6,3,2,7,11,18,29,43,22,8]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(h,t,i){const u=h.getProxy(F.MainContext.MainThreadQuickOpen);class v{constructor(k,I){this._sessions=new Map,this._instances=0,this._workspace=k,this._commands=I}showQuickPick(k,I,c,S=w.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(I),C=++this._instances,$=u.$show(C,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},S),N={},H=$.then(()=>N);return Promise.race([H,b]).then(B=>{if(B===N)return;const L=(0,a.isProposedApiEnabled)(k,"quickPickItemTooltip");return b.then(U=>{const ie=[];for(let X=0;X<U.length;X++){const ye=U[X];if(typeof ye=="string")ie.push({label:ye,handle:X});else if(ye.kind===l.QuickPickItemKind.Separator)ie.push({type:"separator",label:ye.label});else{ye.tooltip&&!L&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const Pe=ye.iconPath?s(ye.iconPath):void 0;ie.push({label:ye.label,iconPath:Pe?.iconPath,iconClass:Pe?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:L?E.MarkdownString.fromStrict(ye.tooltip):void 0,handle:X})}}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=X=>{c.onDidSelectItem(U[X])}),u.$setItems(C,ie),$.then(X=>{if(typeof X=="number")return U[X];if(Array.isArray(X))return X.map(ye=>U[ye])})})}).then(void 0,B=>{if(!(0,y.isCancellationError)(B))return u.$setError(C,B),Promise.reject(B)})}$onItemSelected(k){this._onDidSelectItem?.(k)}showInput(k,I=w.CancellationToken.None){return this._validateInput=k?.validateInput,u.$input(k,typeof this._validateInput=="function",I).then(void 0,c=>{if(!(0,y.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(k){if(!this._validateInput)return;const I=await this._validateInput(k);if(!I||typeof I=="string")return I;let c;switch(I.severity){case l.InputBoxValidationSeverity.Info:c=A.default.Info;break;case l.InputBoxValidationSeverity.Warning:c=A.default.Warning;break;case l.InputBoxValidationSeverity.Error:c=A.default.Error;break;default:c=I.message?A.default.Error:A.default.Ignore;break}return{content:I.message,severity:c}}async showWorkspaceFolderPick(k,I=w.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!c)return;const S=await this._workspace.getWorkspaceFolders2();if(S)return S.find(b=>b.uri.toString()===c.uri.toString())}createQuickPick(k){const I=new o(k,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}createInputBox(k){const I=new g(k,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}$onDidChangeValue(k,I){this._sessions.get(k)?._fireDidChangeValue(I)}$onDidAccept(k){this._sessions.get(k)?._fireDidAccept()}$onDidChangeActive(k,I){const c=this._sessions.get(k);c instanceof o&&c._fireDidChangeActive(I)}$onDidChangeSelection(k,I){const c=this._sessions.get(k);c instanceof o&&c._fireDidChangeSelection(I)}$onDidTriggerButton(k,I){this._sessions.get(k)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(k,I,c){const S=this._sessions.get(k);S instanceof o&&S._fireDidTriggerItemButton(I,c)}$onDidHide(k){this._sessions.get(k)?._fireDidHide()}}class _{static{this._nextId=1}constructor(k,I){this._extensionId=k,this._onDidDispose=I,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(k){this._title=k,this.update({title:k})}get step(){return this._steps}set step(k){this._steps=k,this.update({step:k})}get totalSteps(){return this._totalSteps}set totalSteps(k){this._totalSteps=k,this.update({totalSteps:k})}get enabled(){return this._enabled}set enabled(k){this._enabled=k,this.update({enabled:k})}get busy(){return this._busy}set busy(k){this._busy=k,this.update({busy:k})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(k){this._ignoreFocusOut=k,this.update({ignoreFocusOut:k})}get value(){return this._value}set value(k){this._value=k,this.update({value:k})}get placeholder(){return this._placeholder}set placeholder(k){this._placeholder=k,this.update({placeholder:k})}get buttons(){return this._buttons}set buttons(k){this._buttons=k.slice(),this._handlesToButtons.clear(),k.forEach((I,c)=>{const S=I===l.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(S,I)}),this.update({buttons:k.map((I,c)=>({...s(I.iconPath),tooltip:I.tooltip,handle:I===l.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(k){this._value=k,this._onDidChangeValueEmitter.fire(k)}_fireDidTriggerButton(k){const I=this._handlesToButtons.get(k);I&&this._onDidTriggerButtonEmitter.fire(I)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),u.$dispose(this._id))}update(k){if(!this._disposed){for(const I of Object.keys(k)){const c=k[I];this._pendingUpdate[I]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){u.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function m(d){if(d instanceof l.ThemeIcon)return{id:d.id};const k=r(d),I=n(d);return{dark:typeof k=="string"?T.URI.file(k):k,light:typeof I=="string"?T.URI.file(I):I}}function n(d){return typeof d=="object"&&"light"in d?d.light:d}function r(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const k=m(d);let I,c;return"id"in k?c=D.ThemeIcon.asClassName(k):I=k,{iconPath:I,iconClass:c}}class o extends _{constructor(k,I){super(k.identifier,I),this.extension=k,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this._onDidTriggerItemButtonEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(k){this._items=k.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),k.forEach((S,b)=>{this._handlesToItems.set(b,S),this._itemsToHandles.set(S,b)});const I=(0,a.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),c=[];for(let S=0;S<k.length;S++){const b=k[S];if(b.kind===l.QuickPickItemKind.Separator)c.push({type:"separator",label:b.label});else{b.tooltip&&!I&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const C=b.iconPath?s(b.iconPath):void 0;c.push({handle:S,label:b.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:I?E.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map(($,N)=>({...s($.iconPath),tooltip:$.tooltip,handle:N}))})}}this.update({items:c})}get canSelectMany(){return this._canSelectMany}set canSelectMany(k){this._canSelectMany=k,this.update({canSelectMany:k})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(k){this._matchOnDescription=k,this.update({matchOnDescription:k})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(k){this._matchOnDetail=k,this.update({matchOnDetail:k})}get sortByLabel(){return this._sortByLabel}set sortByLabel(k){this._sortByLabel=k,this.update({sortByLabel:k})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(k){this._keepScrollPosition=k,this.update({keepScrollPosition:k})}get activeItems(){return this._activeItems}set activeItems(k){this._activeItems=k.filter(I=>this._itemsToHandles.has(I)),this.update({activeItems:this._activeItems.map(I=>this._itemsToHandles.get(I))})}get selectedItems(){return this._selectedItems}set selectedItems(k){this._selectedItems=k.filter(I=>this._itemsToHandles.has(I)),this.update({selectedItems:this._selectedItems.map(I=>this._itemsToHandles.get(I))})}_fireDidChangeActive(k){const I=(0,f.coalesce)(k.map(c=>this._handlesToItems.get(c)));this._activeItems=I,this._onDidChangeActiveEmitter.fire(I)}_fireDidChangeSelection(k){const I=(0,f.coalesce)(k.map(c=>this._handlesToItems.get(c)));this._selectedItems=I,this._onDidChangeSelectionEmitter.fire(I)}_fireDidTriggerItemButton(k,I){const c=this._handlesToItems.get(k);if(!c||!c.buttons||!c.buttons.length)return;const S=c.buttons[I];S&&this._onDidTriggerItemButtonEmitter.fire({button:S,item:c})}}class g extends _{constructor(k,I){super(k.identifier,I),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(k){this._password=k,this.update({password:k})}get prompt(){return this._prompt}set prompt(k){this._prompt=k,this.update({prompt:k})}get valueSelection(){return this._valueSelection}set valueSelection(k){this._valueSelection=k,this.update({valueSelection:k})}get validationMessage(){return this._validationMessage}set validationMessage(k){this._validationMessage=k,k?typeof k=="string"?this.update({validationMessage:k,severity:A.default.Error}):this.update({validationMessage:k.message,severity:k.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new v(t,i)}e.createExtHostQuickOpen=p}),define(Te[252],Ae([1,0,2,5,65,6,12,3,18,131,14,21,43,8,22,13]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(b){if(b)return typeof b.iconPath=="string"?w.URI.file(b.iconPath):w.URI.isUri(b.iconPath)||a.ThemeIcon.isThemeIcon(b.iconPath)?b.iconPath:void 0}function u(b){if(b?.icon){if(w.URI.isUri(b.icon))return b.icon;if(a.ThemeIcon.isThemeIcon(b.icon))return b.icon;{const C=b.icon;return{light:C.light,dark:C.dark}}}else return}function v(b){if(b.icon){if(w.URI.isUri(b.icon))return b.icon;if(a.ThemeIcon.isThemeIcon(b.icon))return b.icon;{const C=b.icon;return{light:C.light,dark:C.dark}}}else return}function _(b,C){if(!b.iconPath&&!C.iconPath)return 0;if(b.iconPath){if(!C.iconPath)return 1}else return-1;const $=typeof b.iconPath=="string"?b.iconPath:w.URI.isUri(b.iconPath)?b.iconPath.fsPath:b.iconPath.id,N=typeof C.iconPath=="string"?C.iconPath:w.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,f.comparePaths)($,N)}function m(b,C){let $=0;if(b.strikeThrough!==C.strikeThrough)return b.strikeThrough?1:-1;if(b.faded!==C.faded)return b.faded?1:-1;if(b.tooltip!==C.tooltip)return(b.tooltip||"").localeCompare(C.tooltip||"");if($=_(b,C),$!==0)return $;if(b.light&&C.light)$=_(b.light,C.light);else{if(b.light)return 1;if(C.light)return-1}if($!==0)return $;if(b.dark&&C.dark)$=_(b.dark,C.dark);else{if(b.dark)return 1;if(C.dark)return-1}return $}function n(b,C){if(b.command!==C.command)return b.command<C.command?-1:1;if(b.title!==C.title)return b.title<C.title?-1:1;if(b.tooltip!==C.tooltip){if(b.tooltip!==void 0&&C.tooltip!==void 0)return b.tooltip<C.tooltip?-1:1;if(b.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(b.arguments===C.arguments)return 0;if(b.arguments)if(C.arguments){if(b.arguments.length!==C.arguments.length)return b.arguments.length-C.arguments.length}else return 1;else return-1;for(let $=0;$<b.arguments.length;$++){const N=b.arguments[$],H=C.arguments[$];if(N!==H)return N<H?-1:1}return 0}function r(b,C){let $=(0,f.comparePaths)(b.resourceUri.fsPath,C.resourceUri.fsPath,!0);if($!==0)return $;if(b.command&&C.command)$=n(b.command,C.command);else{if(b.command)return 1;if(C.command)return-1}if($!==0)return $;if(b.decorations&&C.decorations)$=m(b.decorations,C.decorations);else{if(b.decorations)return 1;if(C.decorations)return-1}return $}function s(b,C){for(let $=0;$<b.length;$++)if(b[$]!==C[$])return!1;return!0}function o(b,C){return b.command===C.command&&b.title===C.title&&b.tooltip===C.tooltip&&(b.arguments&&C.arguments?s(b.arguments,C.arguments):b.arguments===C.arguments)}function g(b,C){return(0,y.equals)(b,C,o)}function d(b,C){return b===C?!0:!b||!C?!1:b.id===C.id&&b.label===C.label&&b.upstream?.id===C.upstream?.id&&b.upstream?.label===C.upstream?.label}class k{#e;#t;get value(){return this._value}set value(C){C=C??"",this.#e.$setInputBoxValue(this._sourceControlHandle,C),this.updateValue(C)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(C){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,C),this._placeholder=C}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(C){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=C,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!C)}get enabled(){return this._enabled}set enabled(C){C=!!C,this._enabled!==C&&(this._enabled=C,this.#e.$setInputBoxEnablement(this._sourceControlHandle,C))}get visible(){return this._visible}set visible(C){C=!!C,this._visible!==C&&(this._visible=C,this.#e.$setInputBoxVisibility(this._sourceControlHandle,C))}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmInputBoxActionButton"),this._actionButton}set actionButton(C){(0,p.checkProposedApiEnabled)(this._extension,"scmInputBoxActionButton"),this._actionButtonDisposables.value=new F.DisposableStore,this._actionButton=C;const $=C!==void 0?{command:this._commands.converter.toInternal(C.command,this._actionButtonDisposables.value),icon:u(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this._sourceControlHandle,$??null)}get document(){return(0,p.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(C,$,N,H,B,L){this._extension=C,this._commands=$,this._sourceControlHandle=B,this._documentUri=L,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this._actionButtonDisposables=new F.MutableDisposable,this.#t=N,this.#e=H}showValidationMessage(C,$){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,C,$)}$onInputBoxValueChange(C){this.updateValue(C)}updateValue(C){this._value=C,this._onDidChange.fire(C)}}e.ExtHostSCMInputBox=k;class I{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(C){this._label=C,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,C)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(C){this._hideWhenEmpty=C,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(C){this._resourceStates=[...C],this._onDidUpdateResourceStates.fire()}constructor(C,$,N,H,B){this._proxy=C,this._commands=$,this._sourceControlHandle=N,this._id=H,this._label=B,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=I._handlePool++}getResourceState(C){return this._resourceStatesMap.get(C)}$executeResourceCommand(C,$){const N=this._resourceStatesCommandsMap.get(C);return N?(0,T.asPromise)(()=>this._commands.executeCommand(N.command,...N.arguments||[],$)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this._resourceStates].sort(r),N=(0,y.sortedDiff)(this._resourceSnapshot,C,r).map(L=>{const U=L.toInsert.map(ie=>{const X=this._resourceHandlePool++;this._resourceStatesMap.set(X,ie);const ye=ie.resourceUri;let Pe;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"){const ee=new F.DisposableStore;Pe=this._commands.converter.toInternal(ie.command,ee),this._resourceStatesDisposablesMap.set(X,ee)}else this._resourceStatesCommandsMap.set(X,ie.command);const De=i(ie.decorations),pe=ie.decorations&&i(ie.decorations.light)||De,Se=ie.decorations&&i(ie.decorations.dark)||De,le=[pe,Se],ae=ie.decorations&&ie.decorations.tooltip||"",we=ie.decorations&&!!ie.decorations.strikeThrough,Z=ie.decorations&&!!ie.decorations.faded,z=ie.contextValue||"";return{rawResource:[X,ye,le,ae,we,Z,z,Pe],handle:X}});return{start:L.start,deleteCount:L.deleteCount,toInsert:U}}),H=N.map(({start:L,deleteCount:U,toInsert:ie})=>[L,U,ie.map(X=>X.rawResource)]),B=N.reverse();for(const{start:L,deleteCount:U,toInsert:ie}of B){const X=ie.map(Pe=>Pe.handle),ye=this._handlesSnapshot.splice(L,U,...X);for(const Pe of ye)this._resourceStatesMap.delete(Pe),this._resourceStatesCommandsMap.delete(Pe),this._resourceStatesDisposablesMap.get(Pe)?.dispose(),this._resourceStatesDisposablesMap.delete(Pe)}return this._resourceSnapshot=C,H}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class c{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(C){this._count!==C&&(this._count=C,this.#e.$updateSourceControl(this.handle,{count:C}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(C){this._quickDiffProvider=C;let $;(0,p.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&($=C?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!C,quickDiffLabel:$})}get historyProvider(){return(0,p.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(C){(0,p.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=C,this._historyProviderDisposable.value=new F.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!C}),C&&(this._historyProviderDisposable.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{d(this._historyProviderCurrentHistoryItemGroup,C?.currentHistoryItemGroup)||(this._historyProviderCurrentHistoryItemGroup=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup))})),this._historyProviderDisposable.value.add(C.onDidChangeActionButton(()=>{(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._historyProviderActionButtonDisposable.value=new F.DisposableStore;const $=C.actionButton!==void 0?{command:this._commands.converter.toInternal(C.actionButton.command,this._historyProviderActionButtonDisposable.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.handle,$??null)})))}get commitTemplate(){return this._commitTemplate}set commitTemplate(C){C!==this._commitTemplate&&(this._commitTemplate=C,this.#e.$updateSourceControl(this.handle,{commitTemplate:C}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(C){this._acceptInputDisposables.value=new F.DisposableStore,this._acceptInputCommand=C;const $=this._commands.converter.toInternal(C,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:$})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(C){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new F.DisposableStore,this._actionButton=C;const $=C!==void 0?{command:this._commands.converter.toInternal(C.command,this._actionButtonDisposables.value),secondaryCommands:C.secondaryCommands?.map(N=>N.map(H=>this._commands.converter.toInternal(H,this._actionButtonDisposables.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:$??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(C){if(this._statusBarCommands&&C&&g(this._statusBarCommands,C))return;this._statusBarDisposables.value=new F.DisposableStore,this._statusBarCommands=C;const $=(C||[]).map(N=>this._commands.converter.toInternal(N,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:$})}get selected(){return this._selected}constructor(C,$,N,H,B,L,U){this._extension=C,this._commands=H,this._id=B,this._label=L,this._rootUri=U,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new F.MutableDisposable,this._historyProviderActionButtonDisposable=new F.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new F.MutableDisposable,this._statusBarDisposables=new F.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=c._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=N;const ie=w.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${B}/scm${this.handle}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this._inputBox=new k(C,H,$,this.#e,this.handle,ie),this.#e.$registerSourceControl(this.handle,B,L,U,ie)}createResourceGroup(C,$){const N=new I(this.#e,this._commands,this.handle,C,$),H=R.Event.once(N.onDidDispose)(()=>this.createdResourceGroups.delete(N));return this.createdResourceGroups.set(N,H),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const C=[],$=[];for(const[N,H]of this.createdResourceGroups){H.dispose();const B=N.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(N),this.eventuallyUpdateResourceStates()});R.Event.once(N.onDidDispose)(()=>{this.updatedResourceGroups.delete(N),B.dispose(),this._groups.delete(N.handle),this.#e.$unregisterGroup(this.handle,N.handle)}),C.push([N.handle,N.id,N.label,N.features]);const L=N._takeResourceStateSnapshot();L.length>0&&$.push([N.handle,L]),this._groups.set(N.handle,N)}this.#e.$registerGroups(this.handle,C,$),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const C=[];this.updatedResourceGroups.forEach($=>{const N=$._takeResourceStateSnapshot();N.length!==0&&C.push([$.handle,N])}),C.length>0&&this.#e.$spliceResourceStates(this.handle,C),this.updatedResourceGroups.clear()}getResourceGroup(C){return this._groups.get(C)}setSelectionState(C){this._selected=C,this._onDidChangeSelection.fire(C)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ve([(0,P.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),Ve([(0,P.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let S=class{static{t=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(C,$,N,H){this._commands=$,this._extHostDocuments=N,this.logService=H,this._sourceControls=new Map,this._sourceControlsByExtension=new D.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=C.getProxy(l.MainContext.MainThreadSCM),this._telemetry=C.getProxy(l.MainContext.MainThreadTelemetry),$.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===3){const L=this._sourceControls.get(B.sourceControlHandle);if(!L)return B;const U=L.getResourceGroup(B.groupHandle);return U?U.getResourceState(B.handle):B}else if(B&&B.$mid===4){const L=this._sourceControls.get(B.sourceControlHandle);return L?L.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===5){const L=this._sourceControls.get(B.handle);return L||B}return B}})}createSourceControl(C,$,N,H){this.logService.trace("ExtHostSCM#createSourceControl",C.identifier.value,$,N,H),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const B=t._handlePool++,L=new c(C,this._extHostDocuments,this._proxy,this._commands,$,N,H);this._sourceControls.set(B,L);const U=this._sourceControlsByExtension.get(C.identifier)||[];return U.push(L),this._sourceControlsByExtension.set(C.identifier,U),L}getLastInputBox(C){this.logService.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const $=this._sourceControlsByExtension.get(C.identifier),N=$&&$[$.length-1];return N&&N.inputBox}$provideOriginalResource(C,$,N){const H=w.URI.revive($);this.logService.trace("ExtHostSCM#$provideOriginalResource",C,H.toString());const B=this._sourceControls.get(C);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>B.quickDiffProvider.provideOriginalResource(H,N)).then(L=>L||null)}$onInputBoxValueChange(C,$){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",C);const N=this._sourceControls.get(C);return N&&N.inputBox.$onInputBoxValueChange($),Promise.resolve(void 0)}$executeResourceCommand(C,$,N,H){this.logService.trace("ExtHostSCM#$executeResourceCommand",C,$,N);const B=this._sourceControls.get(C);if(!B)return Promise.resolve(void 0);const L=B.getResourceGroup($);return L?L.$executeResourceCommand(N,H):Promise.resolve(void 0)}$validateInput(C,$,N){this.logService.trace("ExtHostSCM#$validateInput",C);const H=this._sourceControls.get(C);return!H||!H.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>H.inputBox.validateInput($,N)).then(B=>{if(!B)return Promise.resolve(void 0);const L=E.MarkdownString.fromStrict(B.message);return L?Promise.resolve([L,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this._sourceControls.get(C)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,$,N){return await this._sourceControls.get(C)?.historyProvider?.resolveHistoryItemGroupBase($,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,$,N,H){return await this._sourceControls.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor($,N,H)??void 0}async $provideHistoryItems(C,$,N,H){return(await this._sourceControls.get(C)?.historyProvider?.provideHistoryItems($,N,H))?.map(U=>({id:U.id,parentIds:U.parentIds,label:U.label,description:U.description,icon:v(U),timestamp:U.timestamp}))??void 0}async $provideHistoryItemChanges(C,$,N){return await this._sourceControls.get(C)?.historyProvider?.provideHistoryItemChanges($,N)??void 0}};e.ExtHostSCM=S,e.ExtHostSCM=S=t=Ve([He(3,A.ILogService)],S)}),define(Te[83],Ae([1,0,3,5,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class F{constructor(l){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=l.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(l){this._onDidChangePassword.fire(l)}get(l,y){return this._proxy.$getPassword(l,y)}store(l,y,f){return this._proxy.$setPassword(l,y,f)}delete(l,y){return this._proxy.$deletePassword(l,y)}}e.ExtHostSecretState=F,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(Te[253],Ae([1,0,3,8,2]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class F{static{this.handlePool=0}constructor(l,y){this.uriTransformer=y,this.providers=new Map,this.proxy=l.getProxy(w.MainContext.MainThreadShare)}async $provideShare(l,y,f){return await this.providers.get(l)?.provideShare({selection:R.Range.to(y.selection),resourceUri:P.URI.revive(y.resourceUri)},f)??void 0}registerShareProvider(l,y){const f=F.handlePool++;return this.providers.set(f,y),this.proxy.$registerShareProvider(f,R.DocumentSelector.from(l,this.uriTransformer),y.id,y.label,y.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(f),this.providers.delete(f)}}}}e.ExtHostShare=F}),define(Te[254],Ae([1,0,19,6,3]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class F{static{this.ID_POOL=1}constructor(l){this.providers=new Map,this.sessions=new Map,this.proxy=l.getProxy(P.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(l,y){const f=this.providers.get(l);if(!f)return;const A=new R.DisposableStore,D=new w.CancellationTokenSource;this.sessions.set(y,D);const a=A.add(f.provideSpeechToTextSession(D.token));A.add(a.onDidChange(E=>{D.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(y,E)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(l){this.sessions.get(l)?.dispose(!0),this.sessions.delete(l)}registerProvider(l,y,f){const A=F.ID_POOL++;return this.providers.set(A,f),this.proxy.$registerProvider(A,y,{extension:l,displayName:l.value}),(0,R.toDisposable)(()=>{this.proxy.$unregisterProvider(A),this.providers.delete(A)})}}e.ExtHostSpeech=F}),define(Te[255],Ae([1,0,7,3,154,6,8,15]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(a,E,p,h,t,i=w.StatusBarAlignment.Left,u){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new F.DisposableStore,this.#e=a,this.#t=E,t&&h){this._entryId=(0,w.asStatusBarItemIdentifier)(h.identifier,t);const v=p.get(this._entryId);v&&(i=v.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,u=v.priority,this._visible=!0,this.name=v.name,this.text=v.text,this.tooltip=v.tooltip,this.command=v.command,this.accessibilityInformation=v.accessibilityInformation)}else this._entryId=String(y.ID_GEN++);this._extension=h,this._id=t,this._alignment=i,this._priority=this.validatePriority(u)}validatePriority(a){if((0,l.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!y.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new F.DisposableStore,typeof a=="string"?this._command={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this._latestCommandRegistration)}:a?this._command={fromApi:a,internal:this.#t.toInternal(a,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let E;this._name?E=this._name:E=(0,P.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const h=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,a,this._extension?.identifier.value,E,this._text,h,this._command?.internal,p,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y;class f{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,P.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const E={message:a};return this._messages.unshift(E),this._update(),new w.Disposable(()=>{const p=this._messages.indexOf(E);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(a,E){this._existingItems=new Map,this._proxy=a.getProxy(R.MainContext.MainThreadStatusBar),this._commands=E,this._statusMessage=new f(this)}$acceptStaticEntries(a){for(const E of a)this._existingItems.set(E.entryId,E)}createStatusBarEntry(a,E,p,h){return new y(this._proxy,this._commands,this._existingItems,a,E,p,h)}setStatusBarMessage(a,E){const p=this._statusMessage.setMessage(a);let h;return typeof E=="number"?h=setTimeout(()=>p.dispose(),E):typeof E<"u"&&E.then(()=>p.dispose(),()=>p.dispose()),new w.Disposable(()=>{p.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=A}),define(Te[84],Ae([1,0,3,5,4]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class F{constructor(l,y){this._logService=y,this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=l.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(l,y){this._proxy.$registerExtensionStorageKeysToSync(l,y)}async initializeExtensionStorage(l,y,f){const A=await this._proxy.$initializeExtensionStorage(l,y);let D;return A&&(D=this.safeParseValue(l,y,A)),D||f}setValue(l,y,f){return this._proxy.$setValue(l,y,f)}$acceptValue(l,y,f){const A=this.safeParseValue(l,y,f);A&&this._onDidChangeStorage.fire({shared:l,key:y,value:A})}safeParseValue(l,y,f){try{return JSON.parse(f)}catch(A){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${l}): ${A}`)}}}e.ExtHostStorage=F,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(Te[85],Ae([1,0,4,27,14,62,2]),function(be,e,w,R,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let l=class{constructor(f,A,D){this._logService=A,this._extHostFileSystem=D,this._workspace=f.workspace??void 0,this._environment=f.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(f){return T.URI.joinPath(this._environment.workspaceStorageHome,f)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const f=this._workspace.id,A=await this._getWorkspaceStorageURI(f);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(f){if(this._value)return T.URI.joinPath(this._value,f.identifier.value)}globalValue(f){return T.URI.joinPath(this._environment.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=l,e.ExtensionStoragePaths=l=Ve([He(0,R.IExtHostInitDataService),He(1,P.ILogService),He(2,F.IExtHostConsumerFileSystem)],l)}),define(Te[63],Ae([1,0,5,3,4,2,17,6,7,156,11,182,19,36,183,43,12,8,31]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class v{constructor(c,S,b,C){this._proxy=c,this._id=S,this._creationOptions=b,this._name=C,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(N=>this._pidPromiseComplete=N);const $=this;this.value={get name(){return $._name||""},get processId(){return $._pidPromise},get creationOptions(){return $._creationOptions},get exitStatus(){return $._exitStatus},get state(){return $._state},get selection(){return $._selection},sendText(N,H=!0){$._checkDisposed(),$._proxy.$sendText($._id,N,H)},show(N){$._checkDisposed(),$._proxy.$show($._id,N)},hide(){$._checkDisposed(),$._proxy.$hide($._id)},dispose(){$._disposed||($._disposed=!0,$._proxy.$dispose($._id))},get dimensions(){if(!($._cols===void 0||$._rows===void 0))return{columns:$._cols,rows:$._rows}}}}async create(c,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:c.shellPath??void 0,shellArgs:c.shellArgs??void 0,cwd:c.cwd??void 0,env:c.env??void 0,icon:g(c.iconPath)??void 0,color:h.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:c.message??void 0,strictEnv:c.strictEnv??void 0,hideFromUser:c.hideFromUser??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this._serializeParentTerminal(c.location,S?.resolvedExtHostIdentifier),isTransient:c.isTransient??void 0})}async createExtensionTerminal(c,S,b,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:h.ThemeColor.isThemeColor(C)?C.id:void 0,location:this._serializeParentTerminal(c,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,S){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in c?{viewColumn:i.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitStatus(c,S){this._exitStatus=Object.freeze({code:c,reason:S})}setDimensions(c,S){return c===this._cols&&S===this._rows||c===0||S===0?!1:(this._cols=c,this._rows=S,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(c){this._selection=c}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(S=>{S!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=v;class _{get onProcessReady(){return this._onProcessReady.event}constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new w.Emitter,this._onDidChangeProperty=new w.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${S}`)}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput?.(c)}resize(c,S){this._pty.setDimensions?.({columns:c,rows:S})}clearBuffer(){}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(c){this._pty.onDidWrite(S=>this._onProcessData.fire(S)),this._pty.onDidClose?.((S=void 0)=>{this._onProcessExit.fire(S===void 0?void 0:S)}),this._pty.onDidOverrideDimensions?.(S=>{S&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this._pty.onDidChangeName?.(S=>{this._onDidChangeProperty.fire({type:"title",value:S})}),this._pty.open(c||void 0),c&&this._pty.setDimensions?.(c),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let m=1,n=class extends l.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}constructor(c,S,b){super(),this._extHostCommands=S,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new l.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new w.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new w.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new w.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new w.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new w.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new w.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new w.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=b.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(c),this._extHostCommands.registerArgumentProcessor({processArgument:C=>{const $=N=>{const H=N;return this._getTerminalById(H.instanceId)?.value};switch(C?.$mid){case 15:return $(C);default:{if(Array.isArray(C))for(let N=0;N<C.length&&C[N].$mid===15;N++)C[N]=$(C[N]);return C}}}}),this._register({dispose:()=>{for(const[C,$]of this._terminalProcesses)$.shutdown(!0)}})}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,S){const b=new v(this._proxy,(0,E.generateUuid)(),c,c.name),C=new _(c.pty);return b.createExtensionTerminal(c.location,this._serializeParentTerminal(c,S).resolvedExtHostIdentifier,g(c.iconPath),d(c.color)).then($=>{const N=this._setupExtHostProcessListeners($,C);this._terminalProcessDisposables[$]=N}),this._terminals.push(b),b.value}_serializeParentTerminal(c,S){if(S=S||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const b=c.location.parentTerminal;if(b){const C=this._terminals.find($=>$.value===b);C&&(S.resolvedExtHostIdentifier=C._id)}}else c.location&&typeof c.location!="object"?S.location=c.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(c,S){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const C=new _(S),$=this._setupExtHostProcessListeners(c,C);this._terminalProcessDisposables[c]=$}async $acceptActiveTerminalChanged(c){const S=this._activeTerminal;if(c===null){this._activeTerminal=void 0,S!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(c);b&&(this._activeTerminal=b,S!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,S){const b=this._getTerminalById(c);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:S})}async $acceptTerminalDimensions(c,S,b){const C=this._getTerminalById(c);C&&C.setDimensions(S,b)&&this._onDidChangeTerminalDimensions.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(c,S){const b=this._getTerminalById(c);b&&this._onDidExecuteCommand.fire({terminal:b.value,...S})}async $acceptTerminalMaximumDimensions(c,S,b){this._terminalProcesses.get(c)?.resize(S,b)}async $acceptTerminalTitleChange(c,S){const b=this._getTerminalById(c);b&&(b.name=S)}async $acceptTerminalClosed(c,S,b){const C=this._getTerminalObjectIndexById(this._terminals,c);if(C!==null){const $=this._terminals.splice(C,1)[0];$.setExitStatus(S,b),this._onDidCloseTerminal.fire($.value)}}$acceptTerminalOpened(c,S,b,C){if(S){const H=this._getTerminalObjectIndexById(this._terminals,S);if(H!==null){this._terminals[H]._id=c,this._onDidOpenTerminal.fire(this.terminals[H]),this._terminals[H].isOpen=!0;return}}const $={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:F.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},N=new v(this._proxy,c,$,b);this._terminals.push(N),this._onDidOpenTerminal.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(c,S){this._getTerminalById(c)?._setProcessId(S)}async $startExtensionTerminal(c,S){const b=this._getTerminalById(c);if(!b)return{message:(0,f.localize)(0,null,c)};b.isOpen||await new Promise($=>{const N=this.onDidOpenTerminal(async H=>{H===b.value&&(N.dispose(),$())})});const C=this._terminalProcesses.get(c);C?C.startSendingEvents(S):this._extensionTerminalAwaitingStart[c]={initialDimensions:S}}_setupExtHostProcessListeners(c,S){const b=new l.DisposableStore;b.add(S.onProcessReady($=>this._proxy.$sendProcessReady(c,$.pid,$.cwd,$.windowsPty))),b.add(S.onDidChangeProperty($=>this._proxy.$sendProcessProperty(c,$))),this._bufferer.startBuffering(c,S.onProcessData),b.add(S.onProcessExit($=>this._onProcessExit(c,$))),this._terminalProcesses.set(c,S);const C=this._extensionTerminalAwaitingStart[c];return C&&S instanceof _&&(S.startSendingEvents(C.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),b}$acceptProcessAckDataEvent(c,S){this._terminalProcesses.get(c)?.acknowledgeDataEvent(S)}$acceptProcessInput(c,S){this._terminalProcesses.get(c)?.input(S)}$acceptTerminalInteraction(c){const S=this._getTerminalById(c);S?.setInteractedWith()&&this._onDidChangeTerminalState.fire(S.value)}$acceptTerminalSelection(c,S){this._getTerminalById(c)?.setSelection(S)}$acceptProcessResize(c,S,b){try{this._terminalProcesses.get(c)?.resize(S,b)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(c,S){this._terminalProcesses.get(c)?.shutdown(S)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(S=>this._proxy.$sendProcessProperty(c,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(S=>this._proxy.$sendProcessProperty(c,{type:"cwd",value:S}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,S,b){if(this._profileProviders.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this._profileProviders.set(S,b),this._proxy.$registerProfileProvider(S,c.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(S),this._proxy.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(c,S,b){if(this._quickFixProviders.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this._quickFixProviders.set(c,b),this._proxy.$registerQuickFixProvider(c,S),new y.Disposable(()=>{this._quickFixProviders.delete(c),this._proxy.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,S){const b=new a.CancellationTokenSource().token;if(b.isCancellationRequested)return;const C=this._quickFixProviders.get(c);if(!C)return;const $=await C.provideTerminalQuickFixes(S,b);if($===null||Array.isArray($)&&$.length===0)return;const N=new l.DisposableStore;if(this._lastQuickFixCommands.value=N,!Array.isArray($))return $?i.TerminalQuickFix.from($,this._extHostCommands.converter,N):void 0;const H=[];for(const B of $){const L=i.TerminalQuickFix.from(B,this._extHostCommands.converter,N);L&&H.push(L)}return H}async $createContributedProfileTerminal(c,S){const b=new a.CancellationTokenSource().token;let C=await this._profileProviders.get(c)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,S);return}this.createTerminalFromOptions(C.options,S)}}async $provideLinks(c,S){const b=this._getTerminalById(c);if(!b)return[];this._terminalLinkCache.delete(c),this._terminalLinkCancellationSource.get(c)?.dispose(!0);const $=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,$);const N=[],H={terminal:b.value,line:S},B=[];for(const ie of this._linkProviders)B.push(t.Promises.withAsyncBody(async X=>{$.token.onCancellationRequested(()=>X({provider:ie,links:[]}));const ye=await ie.provideTerminalLinks(H,$.token)||[];$.token.isCancellationRequested||X({provider:ie,links:ye})}));const L=await Promise.all(B);if($.token.isCancellationRequested)return[];const U=new Map;for(const ie of L)ie&&ie.links.length>0&&N.push(...ie.links.map(X=>{const ye={id:m++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return U.set(ye.id,{provider:ie.provider,link:X}),ye}));return this._terminalLinkCache.set(c,U),N}$activateLink(c,S){const b=this._terminalLinkCache.get(c)?.get(S);b&&b.provider.handleTerminalLink(b.link)}_onProcessExit(c,S){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const b=this._terminalProcessDisposables[c];b&&(b.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,S)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,S){const b=this._getTerminalObjectIndexById(c,S);return b!==null?c[b]:null}_getTerminalObjectIndexById(c,S){const b=c.findIndex(C=>C._id===S);return b===-1?null:b}getEnvironmentVariableCollection(c){let S=this._environmentVariableCollections.get(c.identifier.value);return S||(S=new r,this._setEnvironmentVariableCollection(c.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(c,S){const b=(0,D.serializeEnvironmentVariableCollection)(S.map),C=(0,D.serializeEnvironmentDescriptionMap)(S.descriptionMap);this._proxy.$setEnvironmentVariableCollection(c,S.persistent,b.length===0?void 0:b,C)}$initEnvironmentVariableCollections(c){c.forEach(S=>{const b=S[0],C=new r(S[1]);this._setEnvironmentVariableCollection(b,C)})}$acceptDefaultProfile(c,S){const b=this._defaultProfile;this._defaultProfile=c,this._defaultAutomationProfile=S,b?.path!==c.path&&this._onDidChangeShell.fire(c.path)}_setEnvironmentVariableCollection(c,S){this._environmentVariableCollections.set(c,S),S.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,S)})}};e.BaseExtHostTerminalService=n,e.BaseExtHostTerminalService=n=Ve([He(1,u.IExtHostCommands),He(2,T.IExtHostRpcService)],n);class r{get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(c){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(c)}getScopedEnvironmentVariableCollection(c){const S=this.getScopeKey(c);let b=this.scopedCollections.get(S);return b||(b=new s(this,c),this.scopedCollections.set(S,b),b.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),b}replace(c,S,b,C){this._setIfDiffers(c,{value:S,type:y.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:C})}append(c,S,b,C){this._setIfDiffers(c,{value:S,type:y.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:C})}prepend(c,S,b,C){this._setIfDiffers(c,{value:S,type:y.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:C})}_setIfDiffers(c,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.getKey(c,S.scope),C=this.map.get(b),$=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==S.value||C.type!==S.type||C.options?.applyAtProcessCreation!==$.applyAtProcessCreation||C.options?.applyAtShellIntegration!==$.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const N=this.getKey(c,S.scope),H={variable:c,...S,options:$};this.map.set(N,H),this._onDidChangeCollection.fire()}}get(c,S){const b=this.getKey(c,S),C=this.map.get(b);return C?k(C):void 0}getKey(c,S){const b=this.getScopeKey(S);return b.length?`${c}:::${b}`:c}getScopeKey(c){return this.getWorkspaceKey(c?.workspaceFolder)??""}getWorkspaceKey(c){return c?c.uri.toString():void 0}getVariableMap(c){const S=new Map;for(const[b,C]of this.map)this.getScopeKey(C.scope)===this.getScopeKey(c)&&S.set(C.variable,k(C));return S}delete(c,S){const b=this.getKey(c,S);this.map.delete(b),this._onDidChangeCollection.fire()}clear(c){if(c?.workspaceFolder){for(const[S,b]of this.map)b.scope?.workspaceFolder?.index===c.workspaceFolder.index&&this.map.delete(S);this.clearDescription(c)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(c,S){const b=this.getScopeKey(S),C=this.descriptionMap.get(b);if(!C||C.description!==c){let $;typeof c=="string"?$=c:$=c?.value.split(`

`)[0];const N={description:$,scope:S};this.descriptionMap.set(b,N),this._onDidChangeCollection.fire()}}getDescription(c){const S=this.getScopeKey(c);return this.descriptionMap.get(S)?.description}clearDescription(c){const S=this.getScopeKey(c);this.descriptionMap.delete(S)}}class s{get persistent(){return this.collection.persistent}set persistent(c){this.collection.persistent=c}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(c,S){this.collection=c,this.scope=S,this._onDidChangeCollection=new w.Emitter}getScoped(c){return this.collection.getScopedEnvironmentVariableCollection(c)}replace(c,S,b){this.collection.replace(c,S,b,this.scope)}append(c,S,b){this.collection.append(c,S,b,this.scope)}prepend(c,S,b){this.collection.prepend(c,S,b,this.scope)}get(c){return this.collection.get(c,this.scope)}forEach(c,S){this.collection.getVariableMap(this.scope).forEach((b,C)=>c.call(S,C,b,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(c){this.collection.delete(c,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(c){this.collection.setDescription(c,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let o=class extends n{constructor(c,S){super(!1,c,S)}createTerminal(c,S,b){throw new A.NotSupportedError}createTerminalFromOptions(c,S){throw new A.NotSupportedError}};e.WorkerExtHostTerminalService=o,e.WorkerExtHostTerminalService=o=Ve([He(0,u.IExtHostCommands),He(1,T.IExtHostRpcService)],o);function g(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function d(I){return h.ThemeColor.isThemeColor(I)?I:void 0}function k(I){const c={...I};return delete c.scope,c.options=c.options??void 0,delete c.variable,c}}),define(Te[256],Ae([1,0,285,12,26,19,5,206,93,6,25,15,36,3,17,105,8,7,46,76,58]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let m=class{constructor(N,H,B){this.editors=B,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(E.MainContext.MainThreadTesting),this.observer=new S(this.proxy),this.runTracker=new o(this.proxy),H.registerArgumentProcessor({processArgument:L=>{switch(L?.$mid){case 16:{const U=L,ie=U.tests[U.tests.length-1].item.extId;return this.controllers.get(u.TestId.root(ie))?.collection.tree.get(ie)?.actual??(0,h.toItemFromContext)(L)}case 18:{const{extId:U,message:ie}=L;return{test:this.controllers.get(u.TestId.root(U))?.collection.tree.get(U)?.actual,message:t.TestMessage.to(ie)}}default:return L}}}),H.registerCommand(!1,"testing.getExplorerSelection",async()=>{const L=await H.executeCommand("_testing.getExplorerSelection"),U=ie=>{const X=this.controllers.get(u.TestId.root(ie));if(X)return u.TestId.isRoot(ie)?X.controller:X.collection.tree.get(ie)?.actual};return{include:L?.include.map(U).filter(D.isDefined)||[],exclude:L?.exclude.map(U).filter(D.isDefined)||[]}})}createTestController(N,H,B,L){if(this.controllers.has(H))throw new Error(`Attempt to insert a duplicate controller with ID "${H}"`);const U=new f.DisposableStore,ie=U.add(new h.ExtHostTestItemCollection(H,B,this.editors));ie.root.label=B;const X=new Map,ye=this.proxy,Pe={items:ie.root.children,get label(){return B},set label(pe){B=pe,ie.root.label=pe,ye.$updateController(H,{label:B})},get refreshHandler(){return L},set refreshHandler(pe){L=pe,ye.$updateController(H,{canRefresh:!!pe})},get id(){return H},createRunProfile:(pe,Se,le,ae,we,Z)=>{let z=(0,y.hash)(pe);for(;X.has(z);)z++;return new b(this.proxy,X,H,z,pe,Se,le,ae,we,Z)},createTestItem(pe,Se,le){return new h.TestItemImpl(H,pe,Se,le)},createTestRun:(pe,Se,le=!0)=>this.runTracker.createTestRun(N,H,ie,pe,Se,le),invalidateTestResults:pe=>{if(pe===void 0)this.proxy.$markTestRetired(void 0);else{const Se=pe instanceof Array?pe:[pe];this.proxy.$markTestRetired(Se.map(le=>u.TestId.fromExtHostTestItem(le,H).toString()))}},set resolveHandler(pe){ie.resolveHandler=pe},get resolveHandler(){return ie.resolveHandler},dispose:()=>{U.dispose()}};ye.$registerTestController(H,B,!!L),U.add((0,f.toDisposable)(()=>ye.$unregisterTestController(H)));const De={controller:Pe,collection:ie,profiles:X,extension:N};return this.controllers.set(H,De),U.add((0,f.toDisposable)(()=>this.controllers.delete(H))),U.add(ie.onDidGenerateDiff(pe=>ye.$publishDiff(H,pe.map(_.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.observer.checkout()}async runTests(N,H=F.CancellationToken.None){const B=g(N);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.controllers.get(B.controllerId);if(!L)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(U=>u.TestId.fromExtHostTestItem(U,L.collection.root.id).toString())??[L.collection.root.id],profileGroup:C[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:N.exclude?.map(U=>U.id)},H)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,H,B){return(0,w.mapFindFirst)(this.runTracker.trackers,U=>U.id===N?U.getCoverage(H):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(N,H,B,L){return(0,w.mapFindFirst)(this.runTracker.trackers,ie=>ie.id===N?ie.getCoverage(H):void 0)?.resolveFileCoverage(B,L)??Promise.resolve([])}$configureRunProfile(N,H){this.controllers.get(N)?.profiles.get(H)?.configureHandler?.()}async $refreshTests(N,H){await this.controllers.get(N)?.controller.refreshHandler?.(H)}$publishTestResults(N){this.results=Object.freeze(N.map(H=>(0,A.deepFreeze)(t.TestResults.to(H))).concat(this.results).sort((H,B)=>B.completedAt-H.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,H){const B=this.controllers.get(u.TestId.fromString(N).controllerId)?.collection;B&&(await B.expand(N,H<0?1/0:H),B.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(_.TestsDiffOp.deserialize))}async $runControllerTests(N,H){return Promise.all(N.map(B=>this.runControllerTestRequest(B,!1,H)))}async $startContinuousRun(N,H){const B=new F.CancellationTokenSource(H),L=await Promise.all(N.map(U=>this.runControllerTestRequest(U,!0,B.token)));return!H.isCancellationRequested&&!L.some(U=>U.error)&&await new Promise(U=>H.onCancellationRequested(U)),B.dispose(!0),L}async runControllerTestRequest(N,H,B){const L=this.controllers.get(N.controllerId);if(!L)return{};const{collection:U,profiles:ie,extension:X}=L,ye=ie.get(N.profileId);if(!ye)return{};const Pe=N.testIds.map(le=>U.tree.get(le)).filter(D.isDefined),De=N.excludeExtIds.map(le=>L.collection.tree.get(le)).filter(D.isDefined).filter(le=>Pe.some(ae=>ae.fullId.compare(le.fullId)===2));if(!Pe.length)return{};const pe=new i.TestRunRequest(Pe.some(le=>le.actual instanceof h.TestItemRootImpl)?void 0:Pe.map(le=>le.actual),De.map(le=>le.actual),ye,H),Se=(0,_.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(pe,d.fromInternal(N,L.collection),X,B);try{return await ye.runHandler(pe,B),{}}catch(le){return{error:String(le)}}finally{Se&&(Se.hasRunningTasks&&!B.isCancellationRequested&&await T.Event.toPromise(Se.onEnd),Se.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};e.ExtHostTesting=m,e.ExtHostTesting=m=Ve([He(0,p.IExtHostRpcService)],m);const n=1e4;var r;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(r||(r={}));class s extends f.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,H,B){super(),this.dto=N,this.proxy=H,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource(B));const L=this._register(new R.RunOnceScheduler(()=>this.forciblyEndTasks(),n));this._register(this.cts.token.onCancellationRequested(()=>L.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const H=this.dto.id,B=this.dto.controllerId,L=(0,a.generateUuid)(),U=new k(this.proxy,H,L),ie=De=>(pe,...Se)=>{if(ye){console.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(pe)&&(this.ensureTestIsKnown(pe),De(pe,...Se))},X=(De,pe)=>{const Se=pe instanceof Array?pe.map(t.TestMessage.from):[t.TestMessage.from(pe)];if(De.uri&&De.range){const le={range:t.Range.from(De.range),uri:De.uri};for(const ae of Se)ae.location=ae.location||le}this.proxy.$appendTestMessagesInRun(H,L,u.TestId.fromExtHostTestItem(De,B).toString(),Se)};let ye=!1;const Pe={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return U.coverageProvider},set coverageProvider(De){U.coverageProvider=De},enqueued:ie(De=>{this.proxy.$updateTestStateInRun(H,L,u.TestId.fromExtHostTestItem(De,B).toString(),1)}),skipped:ie(De=>{this.proxy.$updateTestStateInRun(H,L,u.TestId.fromExtHostTestItem(De,B).toString(),5)}),started:ie(De=>{this.proxy.$updateTestStateInRun(H,L,u.TestId.fromExtHostTestItem(De,B).toString(),2)}),errored:ie((De,pe,Se)=>{X(De,pe),this.proxy.$updateTestStateInRun(H,L,u.TestId.fromExtHostTestItem(De,B).toString(),6,Se)}),failed:ie((De,pe,Se)=>{X(De,pe),this.proxy.$updateTestStateInRun(H,L,u.TestId.fromExtHostTestItem(De,B).toString(),4,Se)}),passed:ie((De,pe)=>{this.proxy.$updateTestStateInRun(H,L,u.TestId.fromExtHostTestItem(De,this.dto.controllerId).toString(),3,pe)}),appendOutput:(De,pe,Se)=>{ye||(Se&&(this.dto.isIncluded(Se)?this.ensureTestIsKnown(Se):Se=void 0),this.proxy.$appendOutputToRun(H,L,P.VSBuffer.fromString(De),pe&&t.location.from(pe),Se&&u.TestId.fromExtHostTestItem(Se,B).toString()))},end:()=>{ye||(ye=!0,this.proxy.$finishedTestRunTask(H,L),this.tasks.delete(L),this.tasks.size||this.markEnded())}};return this.tasks.set(L,{run:Pe,coverage:U}),this.proxy.$startedTestRunTask(H,{id:L,name:N,running:!0}),Pe}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof h.TestItemImpl))throw new v.InvalidTestItemError(N.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const H=[],B=this.dto.colllection.root;for(;;){const L=t.TestItem.from(N);if(H.unshift(L),this.sharedTestIds.has(L.extId)||(this.sharedTestIds.add(L.extId),N===B))break;N=N.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,H)}dispose(){this.markEnded(),super.dispose()}}class o{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,H,B,L){return this.getTracker(N,H,B,L)}cancelRunById(N){for(const H of this.tracked.values())if(H.id===N){H.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,H,B,L,U,ie){const X=this.tracked.get(L);if(X)return X.createRun(U);const ye=d.fromPublic(H,B,L,ie),Pe=g(L);this.proxy.$startedExtensionTestRun({controllerId:H,continuous:!!L.continuous,profile:Pe&&{group:C[Pe.kind],id:Pe.profileId},exclude:L.exclude?.map(pe=>u.TestId.fromExtHostTestItem(pe,B.root.id).toString())??[],id:ye.id,include:L.include?.map(pe=>u.TestId.fromExtHostTestItem(pe,B.root.id).toString())??[B.root.id],persist:ie});const De=this.getTracker(L,ye,N);return T.Event.once(De.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(ye.id),De.dispose()}),De.createRun(U)}getTracker(N,H,B,L){const U=new s(H,this.proxy,L);return this.tracked.set(N,U),T.Event.once(U.onEnd)(()=>this.tracked.delete(N)),U}}e.TestRunCoordinator=o;const g=$=>{if($.profile){if(!($.profile instanceof b))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class d{static fromPublic(N,H,B,L){return new d(N,(0,a.generateUuid)(),B.include?.map(U=>u.TestId.fromExtHostTestItem(U,N).toString())??[N],B.exclude?.map(U=>u.TestId.fromExtHostTestItem(U,N).toString())??[],L,H)}static fromInternal(N,H){return new d(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,H)}constructor(N,H,B,L,U,ie){this.controllerId=N,this.id=H,this.isPersisted=U,this.colllection=ie,this.includePrefix=B.map(X=>X+"\0"),this.excludePrefix=L.map(X=>X+"\0")}isIncluded(N){const H=u.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(H===B||H.startsWith(B))return!1;for(const B of this.includePrefix)if(H===B||H.startsWith(B))return!0;return!1}}e.TestRunDto=d;class k{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,H,B){this.proxy=N,this.runId=H,this.taskId=B}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(H){throw this.fileCoverage=void 0,H}}async resolveFileCoverage(N,H){const B=await this.fileCoverage;let L=B?.[N];return!this._coverageProvider||!B||!L?[]:(L.detailedCoverage||(L=B[N]=await this._coverageProvider.resolveFileCoverage?.(L,H)??L),L.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class I{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,t.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const H=u.TestId.parentId(N.item.extId);if(H&&this.alreadyRemoved.has(H.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:H,removed:B}=this;return{get added(){return[...N].map(L=>L.revived)},get updated(){return[...H].map(L=>L.revived)},get removed(){return[...B].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,H){return{...N,revived:t.TestItem.toPlain(N.item),depth:H?H.depth+1:0,children:new Set}}createChangeCollector(){return new I(this.changeEmitter)}}class S{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(H=>H.revived)},dispose:(0,l.createSingleCallFunction)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class b{#e;#t;get label(){return this._label}set label(N){N!==this._label&&(this._label=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?t.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,H,B,L,U,ie,X,ye=!1,Pe=void 0,De=!1){this.controllerId=B,this.profileId=L,this._label=U,this.kind=ie,this.runHandler=X,this._isDefault=ye,this._tag=Pe,this._supportsContinuousRun=De,this.#e=N,this.#t=H,H.set(L,this);const pe=C[ie];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);this.#e.$publishTestRunProfile({profileId:L,controllerId:B,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:U,group:pe,isDefault:ye,hasConfigurationHandler:!1,supportsContinuousRun:De})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=b;const C={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Te[257],Ae([1,0,18,11,5,3,106,8,7]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class f{constructor(D,a){this._extHostDocumentsAndEditors=a,this._onDidChangeTextEditorSelection=new P.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new P.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new P.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new P.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new P.Emitter({onListenerError:R.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new P.Emitter({onListenerError:R.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=D.getProxy(F.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(D){const a=this._extHostDocumentsAndEditors.allEditors();return D?a:a.map(E=>E.value)}async showTextDocument(D,a,E){let p;typeof a=="number"?p={position:l.ViewColumn.from(a),preserveFocus:E}:typeof a=="object"?p={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?l.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:p={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(D.uri,p),t=h&&this._extHostDocumentsAndEditors.getEditor(h);if(t)return t.value;throw h?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,a){return new T.TextEditorDecorationType(this._proxy,D,a).value}$acceptEditorPropertiesChanged(D,a){const E=this._extHostDocumentsAndEditors.getEditor(D);if(!E)throw new Error("unknown text editor");if(a.options&&E._acceptOptions(a.options),a.selections){const p=a.selections.selections.map(l.Selection.to);E._acceptSelections(p)}if(a.visibleRanges){const p=w.coalesce(a.visibleRanges.map(l.Range.to));E._acceptVisibleRanges(p)}if(a.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...a.options,lineNumbers:l.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const p=y.TextEditorSelectionChangeKind.fromValue(a.selections.source),h=a.selections.selections.map(l.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:h,kind:p})}if(a.visibleRanges){const p=w.coalesce(a.visibleRanges.map(l.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:p})}}$acceptEditorPositionData(D){for(const a in D){const E=this._extHostDocumentsAndEditors.getEditor(a);if(!E)throw new Error("Unknown text editor");const p=l.ViewColumn.to(D[a]);E.value.viewColumn!==p&&(E._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:p}))}}getDiffInformation(D){return Promise.resolve(this._proxy.$getDiffInformation(D))}}e.ExtHostEditors=f}),define(Te[258],Ae([1,0,2,4,3,6,7,8,21,15]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class A{constructor(E,p){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(h,t)=>{if(h&&h.$mid===12)if(this._providers.get(h.source)&&y.ExtensionIdentifier.equals(t,this._providers.get(h.source)?.extension)){const i=h.uri===void 0?void 0:w.URI.revive(h.uri);return this._itemsBySourceAndUriMap.get(h.source)?.get(D(i))?.get(h.handle)}else return;return h}})}async $getTimeline(E,p,h,t){return this._providers.get(E)?.provider.provideTimeline(w.URI.revive(p),h,t)}registerTimelineProvider(E,p,h,t){const i=new F.DisposableStore,u=this.convertTimelineItem(p.id,t,i).bind(this);let v;p.onDidChange&&(v=p.onDidChange(m=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...m,id:p.id}),this));const _=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...p,scheme:E,onDidChange:void 0,async provideTimeline(m,n,r){n?.resetCache&&(i.clear(),_.get(p.id)?.clear());const s=await p.provideTimeline(m,n,r);if(s==null)return;const o=u(m,n);return{...s,source:p.id,items:s.items.map(o)}},dispose(){for(const m of _.values())m.get(p.id)?.clear();v?.dispose(),i.dispose()}},h)}convertTimelineItem(E,p,h){return(t,i)=>{let u;if(i?.cacheResults){let v=this._itemsBySourceAndUriMap.get(E);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(E,v));const _=D(t);u=v.get(_),u===void 0&&(u=new Map,v.set(_,u))}return v=>{const{iconPath:_,...m}=v,n=`${E}|${v.id??v.timestamp}`;u?.set(n,v);let r,s,o;v.iconPath&&(_ instanceof T.ThemeIcon?o={id:_.id,color:_.color}:w.URI.isUri(_)?(r=_,s=_):{light:r,dark:s}=_);let g;return T.MarkdownString.isMarkdownString(m.tooltip)?g=l.MarkdownString.from(m.tooltip):(0,f.isString)(m.tooltip)?g=m.tooltip:T.MarkdownString.isMarkdownString(m.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),g=l.MarkdownString.from(m.detail)):(0,f.isString)(m.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),g=m.detail),{...m,id:m.id??void 0,handle:n,source:E,command:v.command?p.toInternal(v.command,h):void 0,icon:r,iconDark:s,themeIcon:o,tooltip:g,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(E,p){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,{provider:E,extension:p}),(0,F.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=A;function D(a){return a?.toString()}}),define(Te[86],Ae([1,0,19,5,6,158,4,14,185,3,27,17,7]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class E extends y.DisposableTunnel{}var p;(function(t){function i(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:v.protocol}}t.fromApiTunnel=i;function u(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==y.TunnelPrivacyId.ConstantPrivate&&v.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}t.fromServiceTunnel=u})(p||(e.TunnelDtoConverter=p={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let h=class extends P.Disposable{constructor(i,u,v){super(),this.logService=v,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new R.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=i.getProxy(f.MainContext.MainThreadTunnelService)}async openTunnel(i,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const v=await this._proxy.$openTunnel(u,i.displayName);if(v){const _=new E(v.remoteAddress,v.localAddress,()=>this._proxy.$closeTunnel(v.remoteAddress));return this._register(_),_}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(i,u){const v=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(v,{selector:i,provider:u}),this._proxy.$registerPortsAttributesProvider(i,v),new a.Disposable(()=>{this._portAttributesProviders.delete(v),this._proxy.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(i,u,v,_,m){const n=[];for(const s of i){const o=this._portAttributesProviders.get(s);if(!o)return[];n.push(...await Promise.all(u.map(async g=>{let d;try{d=await o.provider.providePortAttributes({port:g,pid:v,commandLine:_},m)}catch{d=await o.provider.providePortAttributes(g,v,_,m)}return{providedAttributes:d,port:g}})))}const r=n.filter(s=>!!s.providedAttributes);return r.length>0?r.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,u){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(_,m)=>await i.provideTunnel(_,m,new w.CancellationTokenSource().token)??void 0;const v=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,privacyOptions:u.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(v),Promise.resolve((0,P.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,u){if(i){i.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,this._proxy.$setCandidateFilter());const v=i.tunnelFactory??(u?this.makeManagedTunnelFactory(u):void 0);if(v){this._forwardPortProvider=v;let _=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&_.length===0&&(_=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const m=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:_}:void 0;this._proxy.$setTunnelProvider(m)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(i){}async $closeTunnel(i,u){if(this._extensionTunnels.has(i.host)){const v=this._extensionTunnels.get(i.host);v.has(i.port)&&(u&&v.get(i.port).disposeListener.dispose(),await v.get(i.port).tunnel.dispose(),v.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this._forwardPortProvider(i,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const _=await v;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),_===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const m=this._register(_.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(_.remoteAddress))));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:_,disposeListener:m}),p.fromApiTunnel(_)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(v){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),v instanceof Error)return v.message}}async $applyCandidateFilter(i){const u=await Promise.all(i.map(_=>this._showCandidatePort(_.host,_.port,_.detail??""))),v=i.filter((_,m)=>u[m]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(_=>_.port).join(", ")} to ${v.map(_=>_.port).join(", ")}`),v}};e.ExtHostTunnelService=h,e.ExtHostTunnelService=h=Ve([He(0,D.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,l.ILogService)],h)}),define(Te[259],Ae([1,0,6,13,2,3]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}constructor(y){this._openers=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,f,A,D){if(this._openers.has(f))throw new Error(`Opener with id '${f}' already registered`);const a=D.schemes.find(E=>!T.supportedSchemes.has(E));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(f,A),this._proxy.$registerUriOpener(f,D.schemes,y,D.label),(0,w.toDisposable)(()=>{this._openers.delete(f),this._proxy.$unregisterUriOpener(f)})}async $canOpenUri(y,f,A){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener with id: ${y}`);const a=P.URI.revive(f);return D.canOpenExternalUri(a,A)}async $openUri(y,f,A){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener id: '${y}'`);return D.openExternalUri(P.URI.revive(f.resolvedUri),{sourceUri:P.URI.revive(f.sourceUri)},A)}}e.ExtHostUriOpeners=T}),define(Te[260],Ae([1,0,3,2,6,11,21]),function(be,e,w,R,P,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class l{static{this.HandlePool=0}constructor(f){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=f.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(f,A){const D=f.identifier;if(this.handles.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const a=l.HandlePool++;return this.handles.add(D),this.handlers.set(a,A),this._proxy.$registerUriHandler(a,D,f.displayName||f.name),(0,P.toDisposable)(()=>{this.handles.delete(D),this.handlers.delete(a),this._proxy.$unregisterUriHandler(a)})}$handleExternalUri(f,A){const D=this.handlers.get(f);if(!D)return Promise.resolve(void 0);try{D.handleUri(R.URI.revive(A))}catch(a){(0,F.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(f){return R.URI.revive(await this._proxy.$createAppUri(f))}}e.ExtHostUrls=l}),define(Te[64],Ae([1,0,5,6,13,25,2,170,192,77,3]),function(be,e,w,R,P,F,T,l,y,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;constructor(_,m,n,r,s,o,g){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new w.Emitter,this._onDidDispose=this.#d.event,this.#e=_,this.#t=m,this.#r=n,this.#u=r,this.#l=s,this.#n=o,this.#c=a(o),this.#h=E(o),this.#i=g}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return this.#a=!0,(0,f.asWebviewUri)(_,this.#u)}get cspSource(){const _=this.#n.extensionLocation;if(_.scheme===P.Schemas.https||_.scheme===P.Schemas.http){let m=_.toString();return m.endsWith("/")||(m+="/"),m+" "+f.webviewGenericCspSource}return f.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#s}set html(_){this.assertNotDisposed(),this.#s!==_&&(this.#s=_,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(_)))}get options(){return this.assertNotDisposed(),this.#r}set options(_){this.assertNotDisposed(),F.equals(this.#r,_)||this.#t.$setOptions(this.#e,t(this.#n,this.#l,_)),this.#r=_}async postMessage(_){if(this.#o)return!1;const m=(0,y.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,m.message,...m.buffers)}assertNotDisposed(){if(this.#o)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(_){if(!this.#h)return _;const m=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return _.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,g,d,k)=>{const I=T.URI.from({scheme:g||"file",path:decodeURIComponent(d)}),c=(0,f.asWebviewUri)(I,{isRemote:m,authority:n}).toString();return`${s}${c}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,g,d,k)=>{const I=T.URI.from({scheme:g||"file",path:decodeURIComponent(d)}),c=(0,f.asWebviewUri)(I,{isRemote:m,authority:n}).toString();return`${s}${c}${k}`})}}e.ExtHostWebview=D;function a(v){try{const _=(0,l.normalizeVersion)((0,l.parseVersion)(v.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function E(v){try{const _=(0,l.normalizeVersion)((0,l.parseVersion)(v.engines.vscode));return _?_.majorBase<1||_.majorBase===1&&_.minorBase<60:!1}catch{return!1}}class p extends R.Disposable{constructor(_,m,n,r,s){super(),this.remoteInfo=m,this.workspace=n,this._logService=r,this._deprecationService=s,this._webviews=new Map,this._webviewProxy=_.getProxy(A.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const _ of this._webviews.values())_.dispose();this._webviews.clear()}$onMessage(_,m,n){const r=this.getWebview(_);if(r){const{message:s}=(0,y.deserializeWebviewMessage)(m,n.value);r._onMessageEmitter.fire(s)}}$onMissingCsp(_,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,m,n){const r=new D(_,this._webviewProxy,i(m),this.remoteInfo,this.workspace,n,this._deprecationService);this._webviews.set(_,r);const s=r._onDidDispose(()=>{s.dispose(),this.deleteWebview(_)});return r}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=p;function h(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=h;function t(v,_,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||u(v,_)}}e.serializeWebviewOptions=t;function i(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(_=>T.URI.from(_))}}function u(v,_){return[...(_?.getWorkspaceFolders()||[]).map(m=>m.uri),v.extensionLocation]}}),define(Te[261],Ae([1,0,19,93,6,13,24,2,8,64,74,3,7]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(r,s){this.document=r,this._storagePath=s,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,s){await this.getEdit(r).undo(),s||this.disposeBackup()}async redo(r,s){await this.getEdit(r).redo(),s||this.disposeBackup()}disposeEdits(r){for(const s of r)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=m(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const s=this._edits.get(r,0);if(!s)throw new Error("No edit found");return s}}class p{constructor(){this._documents=new Map}get(r,s){return this._documents.get(this.key(r,s))}add(r,s,o){const g=this.key(r,s.uri);if(this._documents.has(g))throw new Error(`Document already exists for viewType:${r} resource:${s.uri}`);const d=new E(s,o);return this._documents.set(g,d),d}delete(r,s){const o=this.key(r,s.uri);this._documents.delete(o)}key(r,s){return`${r}@@@${s}`}}var h;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(h||(h={}));class t{constructor(){this._providers=new Map}addTextProvider(r,s,o){return this.add(0,r,s,o)}addCustomProvider(r,s,o){return this.add(1,r,s,o)}get(r){return this._providers.get(r)}add(r,s,o,g){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:r,extension:o,provider:g}),new a.Disposable(()=>this._providers.delete(s))}}class i{constructor(r,s,o,g,d){this._extHostDocuments=s,this._extensionStoragePaths=o,this._extHostWebview=g,this._extHostWebviewPanels=d,this._editorProviders=new t,this._documents=new p,this._proxy=r.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,s,o,g){const d=new P.DisposableStore;return v(o)?(d.add(this._editorProviders.addTextProvider(s,r,o)),this._proxy.$registerTextEditorProvider((0,f.toExtensionData)(r),s,g.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,f.shouldSerializeBuffersForPostMessage)(r))):(d.add(this._editorProviders.addCustomProvider(s,r,o)),u(o)&&d.add(o.onDidChangeCustomDocument(k=>{const I=this.getCustomDocumentEntry(s,k.document.uri);if(_(k)){const c=I.addEdit(k);this._proxy.$onDidEdit(k.document.uri,s,c,k.label)}else this._proxy.$onContentChange(k.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,f.toExtensionData)(r),s,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,f.shouldSerializeBuffersForPostMessage)(r))),a.Disposable.from(d,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(r,s,o,g,d){const k=this._editorProviders.get(s);if(!k)throw new Error(`No provider found for '${s}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${s}'`);const I=l.URI.revive(r),c=await k.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:g?.buffer},d);let S;return u(k.provider)&&this._extensionStoragePaths&&(S=this._extensionStoragePaths.workspaceValue(k.extension)??this._extensionStoragePaths.globalValue(k.extension)),this._documents.add(s,c,S),{editable:u(k.provider)}}async $disposeCustomDocument(r,s){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const g=l.URI.revive(r),{document:d}=this.getCustomDocumentEntry(s,g);this._documents.delete(s,d),d.dispose()}async $resolveCustomEditor(r,s,o,g,d,k){const I=this._editorProviders.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const c=y.ViewColumn.to(d),S=this._extHostWebview.createNewWebview(s,g.contentOptions,I.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(s,o,g.title,c,g.options,S,g.active),C=l.URI.revive(r);switch(I.type){case 1:{const{document:$}=this.getCustomDocumentEntry(o,C);return I.provider.resolveCustomEditor($,b,k)}case 0:{const $=this._extHostDocuments.getDocument(C);return I.provider.resolveCustomTextEditor($,b,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,s,o){this.getCustomDocumentEntry(s,r).disposeEdits(o)}async $onMoveCustomEditor(r,s,o){const g=this._editorProviders.get(o);if(!g)throw new Error(`No provider found for '${o}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const d=this._extHostWebviewPanels.getWebviewPanel(r);if(!d)throw new Error("No webview found");const k=l.URI.revive(s),I=this._extHostDocuments.getDocument(k);await g.provider.moveCustomTextEditor(I,d,w.CancellationToken.None)}async $undo(r,s,o,g){return this.getCustomDocumentEntry(s,r).undo(o,g)}async $redo(r,s,o,g){return this.getCustomDocumentEntry(s,r).redo(o,g)}async $revert(r,s,o){const g=this.getCustomDocumentEntry(s,r);await this.getCustomEditorProvider(s).revertCustomDocument(g.document,o),g.disposeBackup()}async $onSave(r,s,o){const g=this.getCustomDocumentEntry(s,r);await this.getCustomEditorProvider(s).saveCustomDocument(g.document,o),g.disposeBackup()}async $onSaveAs(r,s,o,g){const d=this.getCustomDocumentEntry(s,r);return this.getCustomEditorProvider(s).saveCustomDocumentAs(d.document,l.URI.revive(o),g)}async $backup(r,s,o){const g=this.getCustomDocumentEntry(s,r),k=await this.getCustomEditorProvider(s).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},o);return g.updateBackup(k),k.id}getCustomDocumentEntry(r,s){const o=this._documents.get(r,l.URI.revive(s));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(r){const o=this._editorProviders.get(r)?.provider;if(!o||!u(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=i;function u(n){return!!n.onDidChangeCustomDocument}function v(n){return typeof n.resolveCustomTextEditor=="function"}function _(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function m(n){const r=n.scheme===F.Schemas.file||n.scheme===F.Schemas.untitled?n.fsPath:n.toString();return(0,R.hash)(r)+""}}),define(Te[262],Ae([1,0,5,6,2,36,8,64,3,7]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class A extends R.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;#a;#c;#h;#d;constructor(p,h,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this._register(new w.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new w.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=p,this.#t=h,this.#u=t,this.#i=i.viewType,this.#l=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#u.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#u}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(p){this.assertNotDisposed(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.assertNotDisposed(),this.#s}set iconPath(p){this.assertNotDisposed(),this.#s!==p&&(this.#s=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#l}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.assertNotDisposed(),this.#a}get visible(){return this.assertNotDisposed(),this.#o}_updateViewState(p){this.#c||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#a=p.active,this.#o=p.visible,this.#r=p.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(p,h){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:T.ViewColumn.from(p),preserveFocus:!!h})}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}}class D extends R.Disposable{static newHandle(){return(0,F.generateUuid)()}constructor(p,h,t){super(),this.webviews=h,this.workspace=t,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(y.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(p=>p.dispose()),this._webviewPanels.clear()}createWebviewPanel(p,h,t,i,u={}){const v=typeof i=="object"?i.viewColumn:i,_={viewColumn:T.ViewColumn.from(v),preserveFocus:typeof i=="object"&&!!i.preserveFocus},m=(0,l.shouldSerializeBuffersForPostMessage)(p),n=D.newHandle();this._proxy.$createWebviewPanel((0,l.toExtensionData)(p),n,h,{title:t,panelOptions:a(u),webviewOptions:(0,l.serializeWebviewOptions)(p,this.workspace,u),serializeBuffersForPostMessage:m},_);const r=this.webviews.createNewWebview(n,u,p);return this.createNewWebviewPanel(n,h,t,v,u,r,!0)}$onDidChangeWebviewPanelViewStates(p){const h=Object.keys(p);h.sort((t,i)=>{const u=p[t],v=p[i];return u.active?1:v.active?-1:+u.visible-+v.visible});for(const t of h){const i=this.getWebviewPanel(t);if(!i)continue;const u=p[t];i._updateViewState({active:u.active,visible:u.visible,viewColumn:T.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,h,t){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:t,extension:p}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(p)}),new f.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(p,h,t,i){const u=this._serializers.get(h);if(!u)throw new Error(`No serializer found for '${h}'`);const{serializer:v,extension:_}=u,m=this.webviews.createNewWebview(p,t.webviewOptions,_),n=this.createNewWebviewPanel(p,h,t.title,i,t.panelOptions,m,t.active);await v.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(p,h,t,i,u,v,_){const m=new A(p,this._proxy,v,{viewType:h,title:t,viewColumn:i,panelOptions:u,active:_});return this._webviewPanels.set(p,m),m}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=D;function a(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Te[263],Ae([1,0,5,6,64,8,3,7]),function(be,e,w,R,P,F,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends R.Disposable{#e;#t;#i;#u;#l;#n;#s;#r;#o;constructor(D,a,E,p,h,t){super(),this.#l=!1,this.#a=this._register(new w.Emitter),this.onDidChangeVisibility=this.#a.event,this.#c=this._register(new w.Emitter),this.onDidDispose=this.#c.event,this.#i=E,this.#s=p,this.#e=D,this.#t=a,this.#u=h,this.#n=t}dispose(){this.#l||(this.#l=!0,this.#c.fire(),this.#u.dispose(),super.dispose())}#a;#c;get title(){return this.assertNotDisposed(),this.#s}set title(D){this.assertNotDisposed(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.assertNotDisposed(),this.#r}set description(D){this.assertNotDisposed(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#u}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#l||(this.#n=D,this.#a.fire())}get badge(){return this.assertNotDisposed(),this.#o}set badge(D){this.assertNotDisposed(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=F.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.assertNotDisposed(),this.#t.$show(this.#e,!!D)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}}class f{constructor(D,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(D,a,E,p){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:E,extension:D}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(D),a,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(D)}),new l.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(D,a,E,p,h){const t=this._viewProviders.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:u}=t,v=this._extHostWebview.createNewWebview(D,{},u),_=new y(D,this._proxy,a,E,v,!0);this._webviewViews.set(D,_),await i.resolveWebviewView(_,{state:p},h)}async $onDidChangeWebviewViewVisibility(D,a){this.getWebviewView(D)._setVisible(a)}async $disposeWebviewView(D){const a=this.getWebviewView(D);this._webviewViews.delete(D),a.dispose(),this._extHostWebview.deleteWebview(D)}getWebviewView(D){const a=this._webviewViews.get(D);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=f}),define(Te[108],Ae([1,0,5,3,2,13,16,4,17,22]),function(be,e,w,R,P,F,T,l,y,f){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class{static{A=this}static{this.InitialState={focused:!0,active:!0}}getState(E){const p=this._state;return{get focused(){return p.focused},get active(){return(0,f.checkProposedApiEnabled)(E,"windowActivity"),p.active}}}constructor(E){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=A.InitialState,this._proxy=E.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:p,isActive:h})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,p){p!==this._state[E]&&(this._state={...this._state,[E]:p},this._onDidChangeWindowState.fire(this._state))}openUri(E,p){let h;if(typeof E=="string"){h=E;try{E=P.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,T.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,h,p)}async asExternalUri(E,p){if((0,T.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(E,p);return P.URI.from(h)}};e.ExtHostWindow=D,e.ExtHostWindow=D=A=Ve([He(0,y.IExtHostRpcService)],D),e.IExtHostWindow=(0,l.createDecorator)("IExtHostWindow")}),define(Te[264],Ae([1,0,229,27,17]),function(be,e,w,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let F=class extends w.AbstractExtHostConsoleForwarder{constructor(l,y){super(l,y)}_nativeConsoleLogMessage(l,y,f){y.apply(console,f)}};e.ExtHostConsoleForwarder=F,e.ExtHostConsoleForwarder=F=Ve([He(0,P.IExtHostRpcService),He(1,R.IExtHostInitDataService)],F)}),define(Te[265],Ae([1,0,12,26,19,11,5,6,132,217,47]),function(be,e,w,R,P,F,T,l,y,f,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(b,C){try{return JSON.stringify(b,C)}catch{return"null"}}const E="$$ref$$",p={[E]:-1};class h{constructor(C,$){this.jsonString=C,this.referencedBuffers=$}}function t(b,C=null,$=!1){const N=[];return{jsonString:($?a:JSON.stringify)(b,(B,L)=>{if(typeof L>"u")return p;if(typeof L=="object"){if(L instanceof R.VSBuffer){const U=N.push(L)-1;return{[E]:U}}if(C)return C(B,L)}return L}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=t;function i(b,C,$){return JSON.parse(b,(N,H)=>{if(H){const B=H[E];if(typeof B=="number")return C[B];if($&&H.$mid===1)return $.transformIncoming(H)}return H})}e.parseJsonAndRestoreBufferRefs=i;function u(b,C){return JSON.stringify(b,C)}function v(b){return b?(C,$)=>$&&$.$mid===1?b.transformOutgoing($):$:null}var _;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(_||(e.RequestInitiator=_={}));var m;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(m||(e.ResponsiveState=m={}));const n=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends l.Disposable{static{D=r}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(C,$=null,N=null){super(),this[D]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=C,this._logger=$,this._uriTransformer=N,this._uriReplacer=v(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let H=0,B=A.ProxyIdentifier.count;H<B;H++)this._locals[H]=null,this._proxies[H]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(H=>this._receiveOneMessage(H))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(C=>{const $=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C],$.resolveErr(F.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(C){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(C){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(C){this._responsiveState!==C&&(this._responsiveState=C,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(C){return this._uriTransformer?(0,y.transformIncomingURIs)(C,this._uriTransformer):C}getProxy(C){const{nid:$,sid:N}=C;return this._proxies[$]||(this._proxies[$]=this._createProxy($,N)),this._proxies[$]}_createProxy(C,$){const N={get:(H,B)=>(typeof B=="string"&&!H[B]&&B.charCodeAt(0)===36&&(H[B]=(...L)=>this._remoteCall(C,B,L)),B===s?$:H[B])};return new Proxy(Object.create(null),N)}set(C,$){return this._locals[C.nid]=$,$}assertRegistered(C){for(let $=0,N=C.length;$<N;$++){const H=C[$];if(!this._locals[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}_receiveOneMessage(C){if(this._isDisposed)return;const $=C.byteLength,N=d.read(C,0),H=N.readUInt8(),B=N.readUInt32();switch(H){case 1:case 2:{let{rpcId:L,method:U,args:ie}=I.deserializeRequestJSONArgs(N);this._uriTransformer&&(ie=(0,y.transformIncomingURIs)(ie,this._uriTransformer)),this._receiveRequest($,B,L,U,ie,H===2);break}case 3:case 4:{let{rpcId:L,method:U,args:ie}=I.deserializeRequestMixedArgs(N);this._uriTransformer&&(ie=(0,y.transformIncomingURIs)(ie,this._uriTransformer)),this._receiveRequest($,B,L,U,ie,H===4);break}case 5:{this._logger?.logIncoming($,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel($,B);break}case 7:{this._receiveReply($,B,void 0);break}case 9:{let L=I.deserializeReplyOKJSON(N);this._uriTransformer&&(L=(0,y.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply($,B,L);break}case 10:{const L=I.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply($,B,L);break}case 8:{const L=I.deserializeReplyOKVSBuffer(N);this._receiveReply($,B,L);break}case 11:{let L=I.deserializeReplyErrError(N);this._uriTransformer&&(L=(0,y.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr($,B,L);break}case 12:{this._receiveReplyErr($,B,void 0);break}default:console.error("received unexpected message"),console.error(C)}}_receiveRequest(C,$,N,H,B,L){this._logger?.logIncoming(C,$,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(N)}.${H}(`,B);const U=String($);let ie,X;if(L){const Pe=new P.CancellationTokenSource;B.push(Pe.token),ie=this._invokeHandler(N,H,B),X=()=>Pe.cancel()}else ie=this._invokeHandler(N,H,B),X=n;this._cancelInvokedHandlers[U]=X;const ye=I.serializeAcknowledged($);this._logger?.logOutgoing(ye.byteLength,$,1,"ack"),this._protocol.send(ye),ie.then(Pe=>{delete this._cancelInvokedHandlers[U];const De=I.serializeReplyOK($,Pe,this._uriReplacer);this._logger?.logOutgoing(De.byteLength,$,1,"reply:",Pe),this._protocol.send(De)},Pe=>{delete this._cancelInvokedHandlers[U];const De=I.serializeReplyErr($,Pe);this._logger?.logOutgoing(De.byteLength,$,1,"replyErr:",Pe),this._protocol.send(De)})}_receiveCancel(C,$){this._logger?.logIncoming(C,$,1,"receiveCancel");const N=String($);this._cancelInvokedHandlers[N]?.()}_receiveReply(C,$,N){this._logger?.logIncoming(C,$,0,"receiveReply:",N);const H=String($);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const B=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H],B.resolveOk(N)}_receiveReplyErr(C,$,N){this._logger?.logIncoming(C,$,0,"receiveReplyErr:",N);const H=String($);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const B=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H];let L;N&&(N.$isError?(L=new Error,L.name=N.name,L.message=N.message,L.stack=N.stack):L=N),B.resolveErr(L)}_invokeHandler(C,$,N){try{return Promise.resolve(this._doInvokeHandler(C,$,N))}catch(H){return Promise.reject(H)}}_doInvokeHandler(C,$,N){const H=this._locals[C];if(!H)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(C));const B=H[$];if(typeof B!="function")throw new Error("Unknown method "+$+" on actor "+(0,A.getStringIdentifierForProxy)(C));return B.apply(H,N)}_remoteCall(C,$,N){if(this._isDisposed)return new f.CanceledLazyPromise;let H=null;if(N.length>0&&P.CancellationToken.isCancellationToken(N[N.length-1])&&(H=N.pop()),H&&H.isCancellationRequested)return Promise.reject(F.canceled());const B=I.serializeRequestArguments(N,this._uriReplacer),L=++this._lastMessageId,U=String(L),ie=new f.LazyPromise,X=new l.DisposableStore;H&&X.add(H.onCancellationRequested(()=>{const Pe=I.serializeCancel(L);this._logger?.logOutgoing(Pe.byteLength,L,0,"cancel"),this._protocol.send(I.serializeCancel(L))})),this._pendingRPCReplies[U]=new g(ie,X),this._onWillSendRequest(L);const ye=I.serializeRequest(L,C,$,B,!!H);return this._logger?.logOutgoing(ye.byteLength,L,0,`request: ${(0,A.getStringIdentifierForProxy)(C)}.${$}(`,N),this._protocol.send(ye),ie}}e.RPCProtocol=o;class g{constructor(C,$){this._promise=C,this._disposable=$}resolveOk(C){this._promise.resolveOk(C),this._disposable.dispose()}resolveErr(C){this._promise.resolveErr(C),this._disposable.dispose()}}class d{static alloc(C,$,N){const H=new d(R.VSBuffer.alloc(N+1+4),0);return H.writeUInt8(C),H.writeUInt32($),H}static read(C,$){return new d(C,$)}get buffer(){return this._buff}constructor(C,$){this._buff=C,this._offset=$}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this._buff.writeUInt8(C,this._offset),this._offset+=1}readUInt8(){const C=this._buff.readUInt8(this._offset);return this._offset+=1,C}writeUInt32(C){this._buff.writeUInt32BE(C,this._offset),this._offset+=4}readUInt32(){const C=this._buff.readUInt32BE(this._offset);return this._offset+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this._buff.writeUInt8(C.byteLength,this._offset),this._offset+=1,this._buff.set(C,this._offset),this._offset+=C.byteLength}readShortString(){const C=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+C).toString();return this._offset+=C,N}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}readLongString(){const C=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+C).toString();return this._offset+=C,N}writeBuffer(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}readVSBuffer(){const C=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+C);return this._offset+=C,$}static sizeMixedArray(C){let $=0;$+=1;for(let N=0,H=C.length;N<H;N++){const B=C[N];switch($+=1,B.type){case 1:$+=this.sizeLongString(B.value);break;case 2:$+=this.sizeVSBuffer(B.value);break;case 3:$+=this.sizeUInt32,$+=this.sizeLongString(B.value);for(let L=0;L<B.buffers.length;++L)$+=this.sizeVSBuffer(B.buffers[L]);break;case 4:break}}return $}writeMixedArray(C){this._buff.writeUInt8(C.length,this._offset),this._offset+=1;for(let $=0,N=C.length;$<N;$++){const H=C[$];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let B=0;B<H.buffers.length;++B)this.writeBuffer(H.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this._buff.readUInt8(this._offset);this._offset+=1;const $=new Array(C);for(let N=0;N<C;N++)switch(this.readUInt8()){case 1:$[N]=this.readLongString();break;case 2:$[N]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),L=this.readLongString(),U=[];for(let ie=0;ie<B;++ie)U.push(this.readVSBuffer());$[N]=new A.SerializableObjectWithBuffers(i(L,U,null));break}case 4:$[N]=void 0;break}return $}}var k;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(k||(k={}));class I{static _useMixedArgSerialization(C){for(let $=0,N=C.length;$<N;$++)if(C[$]instanceof R.VSBuffer||C[$]instanceof A.SerializableObjectWithBuffers||typeof C[$]>"u")return!0;return!1}static serializeRequestArguments(C,$){if(this._useMixedArgSerialization(C)){const N=[];for(let H=0,B=C.length;H<B;H++){const L=C[H];if(L instanceof R.VSBuffer)N[H]={type:2,value:L};else if(typeof L>"u")N[H]={type:4};else if(L instanceof A.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:ie}=t(L.value,$);N[H]={type:3,value:R.VSBuffer.fromString(U),buffers:ie}}else N[H]={type:1,value:R.VSBuffer.fromString(u(L,$))}}return{type:1,args:N}}return{type:0,args:u(C,$)}}static serializeRequest(C,$,N,H,B){switch(H.type){case 0:return this._requestJSONArgs(C,$,N,H.args,B);case 1:return this._requestMixedArgs(C,$,N,H.args,B)}}static _requestJSONArgs(C,$,N,H,B){const L=R.VSBuffer.fromString(N),U=R.VSBuffer.fromString(H);let ie=0;ie+=d.sizeUInt8(),ie+=d.sizeShortString(L),ie+=d.sizeLongString(U);const X=d.alloc(B?2:1,C,ie);return X.writeUInt8($),X.writeShortString(L),X.writeLongString(U),X.buffer}static deserializeRequestJSONArgs(C){const $=C.readUInt8(),N=C.readShortString(),H=C.readLongString();return{rpcId:$,method:N,args:JSON.parse(H)}}static _requestMixedArgs(C,$,N,H,B){const L=R.VSBuffer.fromString(N);let U=0;U+=d.sizeUInt8(),U+=d.sizeShortString(L),U+=d.sizeMixedArray(H);const ie=d.alloc(B?4:3,C,U);return ie.writeUInt8($),ie.writeShortString(L),ie.writeMixedArray(H),ie.buffer}static deserializeRequestMixedArgs(C){const $=C.readUInt8(),N=C.readShortString(),H=C.readMixedArray(),B=new Array(H.length);for(let L=0,U=H.length;L<U;L++){const ie=H[L];typeof ie=="string"?B[L]=JSON.parse(ie):B[L]=ie}return{rpcId:$,method:N,args:B}}static serializeAcknowledged(C){return d.alloc(5,C,0).buffer}static serializeCancel(C){return d.alloc(6,C,0).buffer}static serializeReplyOK(C,$,N){if(typeof $>"u")return this._serializeReplyOKEmpty(C);if($ instanceof R.VSBuffer)return this._serializeReplyOKVSBuffer(C,$);if($ instanceof A.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:B}=t($.value,N,!0);return this._serializeReplyOKJSONWithBuffers(C,H,B)}else return this._serializeReplyOKJSON(C,a($,N))}static _serializeReplyOKEmpty(C){return d.alloc(7,C,0).buffer}static _serializeReplyOKVSBuffer(C,$){let N=0;N+=d.sizeVSBuffer($);const H=d.alloc(8,C,N);return H.writeVSBuffer($),H.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static _serializeReplyOKJSON(C,$){const N=R.VSBuffer.fromString($);let H=0;H+=d.sizeLongString(N);const B=d.alloc(9,C,H);return B.writeLongString(N),B.buffer}static _serializeReplyOKJSONWithBuffers(C,$,N){const H=R.VSBuffer.fromString($);let B=0;B+=d.sizeUInt32,B+=d.sizeLongString(H);for(const U of N)B+=d.sizeVSBuffer(U);const L=d.alloc(10,C,B);L.writeUInt32(N.length),L.writeLongString(H);for(const U of N)L.writeBuffer(U);return L.buffer}static deserializeReplyOKJSON(C){const $=C.readLongString();return JSON.parse($)}static deserializeReplyOKJSONWithBuffers(C,$){const N=C.readUInt32(),H=C.readLongString(),B=[];for(let L=0;L<N;++L)B.push(C.readVSBuffer());return new A.SerializableObjectWithBuffers(i(H,B,$))}static serializeReplyErr(C,$){const N=$?a(F.transformErrorForSerialization($),null):void 0;if(typeof N!="string")return this._serializeReplyErrEmpty(C);const H=R.VSBuffer.fromString(N);let B=0;B+=d.sizeLongString(H);const L=d.alloc(11,C,B);return L.writeLongString(H),L.buffer}static deserializeReplyErrError(C){const $=C.readLongString();return JSON.parse($)}static _serializeReplyErrEmpty(C){return d.alloc(12,C,0).buffer}}var c;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var S;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(S||(S={}))}),define(Te[266],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(F){const T=l=>{globalThis.removeEventListener("message",T);const y=l.data;Object.defineProperties(globalThis,{postMessage:{value(f,A){y.postMessage(f,A)}},onmessage:{get(){return y.onmessage},set(f){y.onmessage=f}}}),y.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),y.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",T)}.toString();class R extends EventTarget{constructor(F,T,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${w})('${T}'))`,f=new Blob([y],{type:"application/javascript"}),A=URL.createObjectURL(f),D=new MessageChannel,a=A,E={type:"_newWorker",id:a,port:D.port2,url:A,options:l};F(E,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:a}),URL.revokeObjectURL(A),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const h=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(h)}),D.port1.addEventListener("message",p=>{const h=new MessageEvent("message",{data:p.data});this.dispatchEvent(h)}),D.port1.start()}}e.NestedWorker=R}),define(Te[267],Ae([1,0,5,30,32,4]),function(be,e,w,R,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new P.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new P.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new P.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,F.createDecorator)("outputService");var T;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.channels=new Map,this._onDidRegisterChannel=new w.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new w.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(A=>f.push(A)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}R.Registry.add(e.Extensions.OutputChannels,new l),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new P.RawContextKey("activeOutputChannel","")}),define(Te[109],Ae([1,0,3,4,17,21,14,267,62,27,40,129,26,15,39,5,6]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class i extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(m,n,r,s,o){super(),this.id=m,this.name=n,this.logger=r,this.proxy=s,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(r.getLevel()),this._register(r.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(m){this.append(m+`
`)}append(m){this.info(m)}clear(){const m=this.offset;this.logger.flush(),this.proxy.$update(this.id,l.OutputChannelUpdateMode.Clear,m)}replace(m){const n=this.offset;this.info(m),this.proxy.$update(this.id,l.OutputChannelUpdateMode.Replace,n),this.visible&&this.logger.flush()}show(m,n){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof m=="boolean"?m:n))}hide(){this.proxy.$close(this.id)}log(m,n){this.offset+=a.VSBuffer.fromString(n).byteLength,(0,T.log)(this.logger,m,n),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class u extends i{appendLine(m){this.append(m)}}let v=class{constructor(m,n,r,s,o,g){this.initData=n,this.extHostFileSystem=r,this.extHostFileSystemInfo=s,this.loggerService=o,this.logService=g,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=m.getProxy(w.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.visibleChannelId=m;for(const[n,r]of this.channels)r.visible=n===this.visibleChannelId}createOutputChannel(m,n,r){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,E.isString)(n)?n:void 0;if((0,E.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const d=this.initData.environment.extensionLogLevel?.find(([I])=>F.ExtensionIdentifier.equals(r.identifier,I))?.[1];d&&(g=(0,T.parseLogLevel)(d));const k=s?this.doCreateLogOutputChannel(m,g,r):this.doCreateOutputChannel(m,o,r);return k.then(I=>{this.channels.set(I.id,I),I.visible=I.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(m,g??this.logService.getLevel(),k):this.createExtHostOutputChannel(m,k)}async doCreateOutputChannel(m,n,r){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.loggerService.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.proxy.$register(m,o,n,r.identifier.value);return new i(d,m,g,this.proxy,r)}async doCreateLogOutputChannel(m,n,r){const s=await this.createExtensionLogDirectory(r),o=m.replace(/[\\/:\*\?"<>\|]/g,""),g=this.extHostFileSystemInfo.extUri.joinPath(s,`${o}.log`),d=`${r.identifier.value}.${o}`,k=this.loggerService.createLogger(g,{id:d,name:m,logLevel:n,extensionId:r.identifier.value});return new u(d,m,k,this.proxy,r)}createExtensionLogDirectory(m){let n=this.extensionLogDirectoryPromise.get(m.identifier.value);if(!n){const r=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,m.identifier.value);this.extensionLogDirectoryPromise.set(m.identifier.value,n=(async()=>{try{await this.extHostFileSystem.value.createDirectory(r)}catch(s){if((0,p.toFileSystemProviderErrorCode)(s)!==p.FileSystemProviderErrorCode.FileExists)throw s}return r})())}return n}createExtHostOutputChannel(m,n){let r=!1;const s=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return m},append(o){s(),n.then(g=>g.append(o))},appendLine(o){s(),n.then(g=>g.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then(g=>g.replace(o))},show(o,g){s(),n.then(d=>d.show(o,g))},hide(){s(),n.then(o=>o.hide())},dispose(){r=!0,n.then(o=>o.dispose())}}}createExtHostLogOutputChannel(m,n,r){const s=new t.DisposableStore,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},g=s.add(new h.Emitter);function d(k){n=k,g.fire(k)}return r.then(k=>{s.add(k),k.logLevel!==n&&d(k.logLevel),s.add(k.onDidChangeLogLevel(I=>d(I)))}),{...this.createExtHostOutputChannel(m,r),get logLevel(){return n},onDidChangeLogLevel:g.event,trace(k,...I){o(),r.then(c=>c.trace(k,...I))},debug(k,...I){o(),r.then(c=>c.debug(k,...I))},info(k,...I){o(),r.then(c=>c.info(k,...I))},warn(k,...I){o(),r.then(c=>c.warn(k,...I))},error(k,...I){o(),r.then(c=>c.error(k,...I))},dispose(){s.dispose()}}}};e.ExtHostOutputService=v,e.ExtHostOutputService=v=Ve([He(0,P.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,y.IExtHostConsumerFileSystem),He(3,A.IExtHostFileSystemInfo),He(4,T.ILoggerService),He(5,T.ILogService)],v),e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(Te[268],Ae([1,0,4,12]),function(be,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let F=1/0;for(let l=0;l<this.maxSampleCount;l++){const y=await P.getRoundTripTime();if(y===void 0)return;F=Math.min(F,y/2),await(0,R.timeout)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(F):T=this.initial.reduce((l,y)=>l+y,0)/this.initial.length,this.lastMeasurement={initial:T,current:F,average:this.average.reduce((l,y)=>l+y,0)/this.average.length,high:(()=>typeof T>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Te[269],Ae([1,0,44,13,20,23,24,2,4,187,56,204,268]),function(be,e,w,R,P,F,T,l,y,f,A,D,a){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let p=E=class{constructor(t,i,u,v){this.localUserHome=t,this.remoteAgentService=i,this.environmentService=u,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||F.OS)(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=_?.userHome??t})()}hasValidBasename(t,i,u){return typeof i=="string"||typeof i>"u"?this.resolveOS.then(v=>this.doHasValidBasename(t,v,i)):this.doHasValidBasename(t,i,u)}doHasValidBasename(t,i,u){return t.scheme===R.Schemas.file||t.scheme===R.Schemas.vscodeRemote?(0,w.isValidBasename)(u??(0,T.basename)(t),i===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return R.Schemas.vscodeRemote;const u=(0,f.getVirtualWorkspaceScheme)(i.getWorkspace());if(u)return u;const v=i.getWorkspace().folders[0];if(v)return v.uri.scheme;const _=i.getWorkspace().configuration;return _?_.scheme:R.Schemas.file}userHome(t){return t?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(t=>t===1?P.win32:P.posix)}async fileURI(t){let i="";if(await this.resolveOS===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(i=t.substring(2),t="/"):(i=t.substring(2,v),t=t.substring(v)||"/")}return l.URI.from({scheme:R.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.AbstractPathService=p,e.AbstractPathService=p=E=Ve([He(1,a.IRemoteAgentService),He(2,D.IWorkbenchEnvironmentService),He(3,A.IWorkspaceContextService)],p)}),define(Te[110],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(T,l){this.line=T,this.character=l}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,l){return new w(0,0)}with(T){return new w(0,0)}}e.Position=w;class R{constructor(T,l,y,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(T,l),this.end=new w(y,f)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new R(0,0,0,0)}with(T){return new R(0,0,0,0)}}e.Range=R;var P;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Te[49],Ae([1,0,18,38,25,44,16,4,20,11,110,12]),function(be,e,w,R,P,F,T,l,y,f,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",E=" characters skipped \u27EB",p=(a.length+E.length+5)*2;e.ISearchService=(0,l.createDecorator)("searchService");var h;(function(pe){pe[pe.file=0]="file",pe[pe.text=1]="text"})(h||(e.SearchProviderType=h={}));var t;(function(pe){pe[pe.File=1]="File",pe[pe.Text=2]="Text"})(t||(e.QueryType=t={}));function i(pe){return!!pe.preview}e.resultIsMatch=i;function u(pe){return!!pe.resource}e.isFileMatch=u;function v(pe){return!!pe.message}e.isProgressMessage=v;var _;(function(pe){pe[pe.Normal=0]="Normal",pe[pe.NewSearchStarted=1]="NewSearchStarted"})(_||(e.SearchCompletionExitCode=_={}));class m{constructor(Se){this.resource=Se,this.results=[]}}e.FileMatch=m;class n{constructor(Se,le,ae,we){this.ranges=le,this.webviewIndex=we;const Z=Array.isArray(le)?le:[le];if(ae&&ae.matchLines===1&&r(Z)){Se=(0,T.getNLines)(Se,ae.matchLines);let z="",Y=0,ee=0;const ve=Math.floor(ae.charsPerLine/5),ge=[];for(const de of Z){const _e=Math.max(de.startColumn-ve,0),re=de.startColumn+ae.charsPerLine;if(_e>ee+ve+p){const ue=a+(_e-ee)+E;z+=ue+Se.slice(_e,re),Y+=_e-(ee+ue.length)}else z+=Se.slice(ee,re);ge.push(new o(0,de.startColumn-Y,de.endColumn-Y)),ee=re}this.preview={text:z,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const z=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:Se,matches:(0,w.mapArrayOrNot)(le,Y=>new s(Y.startLineNumber-z,Y.startColumn,Y.endLineNumber-z,Y.endColumn))}}}}e.TextSearchMatch=n;function r(pe){const Se=pe[0].startLineNumber;for(const le of pe)if(le.startLineNumber!==Se||le.endLineNumber!==Se)return!1;return!0}class s{constructor(Se,le,ae,we){this.startLineNumber=Se,this.startColumn=le,this.endLineNumber=ae,this.endColumn=we}}e.SearchRange=s;class o extends s{constructor(Se,le,ae){super(Se,le,Se,ae)}}e.OneLineRange=o;var g;(function(pe){pe.List="list",pe.Tree="tree"})(g||(e.ViewMode=g={}));var d;(function(pe){pe.Default="default",pe.FileNames="fileNames",pe.Type="type",pe.Modified="modified",pe.CountDescending="countDescending",pe.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function k(pe,Se=!0){const le=pe&&pe.files&&pe.files.exclude,ae=Se&&pe&&pe.search&&pe.search.exclude;if(!le&&!ae)return;if(!le||!ae)return le||ae;let we=Object.create(null);return we=P.mixin(we,P.deepClone(le)),we=P.mixin(we,P.deepClone(ae),!0),we}e.getExcludes=k;function I(pe,Se){return pe.excludePattern&&R.match(pe.excludePattern,Se)?!1:pe.includePattern||pe.usingSearchPaths?pe.includePattern&&R.match(pe.includePattern,Se)?!0:pe.usingSearchPaths?!!pe.folderQueries&&pe.folderQueries.some(le=>{const ae=le.folder.fsPath;if(F.isEqualOrParent(Se,ae)){const we=y.relative(ae,Se);return!le.includePattern||!!R.match(le.includePattern,we)}else return!1}):!1:!0}e.pathIncludedInQuery=I;var c;(function(pe){pe[pe.unknownEncoding=1]="unknownEncoding",pe[pe.regexParseError=2]="regexParseError",pe[pe.globParseError=3]="globParseError",pe[pe.invalidLiteral=4]="invalidLiteral",pe[pe.rgProcessError=5]="rgProcessError",pe[pe.other=6]="other",pe[pe.canceled=7]="canceled"})(c||(e.SearchErrorCode=c={}));class S extends Error{constructor(Se,le){super(Se),this.code=le}}e.SearchError=S;function b(pe){const Se=pe.message;if((0,f.isCancellationError)(pe))return new S(Se,c.canceled);try{const le=JSON.parse(Se);return new S(le.message,le.code)}catch{return new S(Se,c.other)}}e.deserializeSearchError=b;function C(pe){const Se={message:pe.message,code:pe.code};return new Error(JSON.stringify(Se))}e.serializeSearchError=C;function $(pe){return pe.type==="error"?!0:pe.type==="success"}e.isSerializedSearchComplete=$;function N(pe){return pe.type==="success"}e.isSerializedSearchSuccess=N;function H(pe){return!!pe.path}e.isSerializedFileMatch=H;function B(pe,Se){const le=pe.searchPath?pe.searchPath:pe.relativePath;return(0,T.fuzzyContains)(le,Se)}e.isFilePatternMatch=B;class L{constructor(Se){this.path=Se,this.results=[]}addMatch(Se){this.results.push(Se)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function U(pe,Se){const le={...pe||{},...Se||{}};return Object.keys(le).filter(ae=>{const we=le[ae];return typeof we=="boolean"&&we})}e.resolvePatternsForProvider=U;class ie{constructor(Se,le){this._parsedIncludeExpression=null,this._excludeExpression={...Se.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let ae=Se.includePattern;le.includePattern&&(ae?ae={...ae,...le.includePattern}:ae=le.includePattern),ae&&(this._parsedIncludeExpression=R.parse(ae))}matchesExcludesSync(Se,le,ae){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Se,le,ae))}includedInQuerySync(Se,le,ae){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Se,le,ae)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Se,le,ae))}includedInQuery(Se,le,ae){const we=this._parsedExcludeExpression(Se,le,ae),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Se,le,ae):!0;return(0,D.isThenable)(we)?we.then(z=>z?!1:Z()):Z()}hasSiblingExcludeClauses(){return X(this._excludeExpression)}}e.QueryGlobTester=ie;function X(pe){for(const Se in pe)if(typeof pe[Se]!="boolean")return!0;return!1}function ye(pe){if(!pe)return;let Se;return le=>(Se||(Se=(pe()||Promise.resolve([])).then(ae=>ae?De(ae):{})),Se.then(ae=>!!ae[le]))}e.hasSiblingPromiseFn=ye;function Pe(pe){if(!pe)return;let Se;return le=>{if(!Se){const ae=pe();Se=ae?De(ae):{}}return!!Se[le]}}e.hasSiblingFn=Pe;function De(pe){const Se={};for(const le of pe)Se[le]=!0;return Se}}),define(Te[33],Ae([1,0,18,12,19,5,6,50,13,117,24,16,2,159,4,14,176,56,40,27,17,8,7,57,49,3]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_,m,n,r,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function g($,N,H){return new A.ExtUri(B=>c(B,H)).isEqual($,N)}function d($,N,H){return g($.uri,N.uri,H)?0:(0,D.compare)($.uri.toString(),N.uri.toString())}function k($,N,H){return $.index!==N.index?$.index<N.index?-1:1:g($.uri,N.uri,H)?(0,D.compare)($.name,N.name):(0,D.compare)($.uri.toString(),N.uri.toString())}function I($,N,H,B){const L=$.slice(0).sort((ie,X)=>H(ie,X,B)),U=N.slice(0).sort((ie,X)=>H(ie,X,B));return(0,w.delta)(L,U,(ie,X)=>H(ie,X,B))}function c($,N){const H=N.getCapabilities($.scheme);return!(H&&H&1024)}class S extends i.Workspace{static toExtHostWorkspace(N,H,B,L){if(!N)return{workspace:null,added:[],removed:[]};const{id:U,name:ie,folders:X,configuration:ye,transient:Pe,isUntitled:De}=N,pe=[],Se=H;H?X.forEach((Z,z)=>{const Y=a.URI.revive(Z.uri),ee=S._findFolder(B||H,Y,L);ee?(ee.name=Z.name,ee.index=Z.index,pe.push(ee)):pe.push({uri:Y,name:Z.name,index:z})}):pe.push(...X.map(({uri:Z,name:z,index:Y})=>({uri:a.URI.revive(Z),name:z,index:Y}))),pe.sort((Z,z)=>Z.index<z.index?-1:1);const le=new S(U,ie,pe,!!Pe,ye?a.URI.revive(ye):null,!!De,Z=>c(Z,L)),{added:ae,removed:we}=I(Se?Se.workspaceFolders:[],le.workspaceFolders,d,L);return{workspace:le,added:ae,removed:we}}static _findFolder(N,H,B){for(let L=0;L<N.folders.length;L++){const U=N.workspaceFolders[L];if(g(U.uri,H,B))return U}}constructor(N,H,B,L,U,ie,X){super(N,B.map(ye=>new i.WorkspaceFolder(ye)),L,U,X),this._name=H,this._isUntitled=ie,this._workspaceFolders=[],this._structure=l.TernarySearchTree.forUris(X),B.forEach(ye=>{this._workspaceFolders.push(ye),this._structure.set(ye.uri,ye)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,H){return H&&this._structure.get(N)&&(N=(0,A.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let b=class{constructor(N,H,B,L,U){this._onDidChangeWorkspace=new F.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new F.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new F.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=L,this._extHostFileSystemInfo=B,this._uriTransformerService=U,this._requestIdProvider=new f.Counter,this._barrier=new R.Barrier,this._proxy=N.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(o.MainContext.MainThreadMessageService);const ie=H.workspace;this._confirmedWorkspace=ie?new S(ie.id,ie.name,[],!!ie.transient,ie.configuration?a.URI.revive(ie.configuration):null,!!ie.isUntitled,X=>c(X,B)):void 0}$initializeWorkspace(N,H){this._trusted=H,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:y.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,H,B,...L){const U=[];if(Array.isArray(L)&&L.forEach(De=>{a.URI.isUri(De.uri)&&!U.some(pe=>g(pe.uri,De.uri,this._extHostFileSystemInfo))&&U.push({uri:De.uri,name:De.name||(0,A.basenameOrAuthority)(De.uri)})}),this._unconfirmedWorkspace||[H,B].some(De=>typeof De!="number"||De<0)||B===0&&U.length===0)return!1;const ie=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+B>ie.length)return!1;const X=ie.slice(0);X.splice(H,B,...U.map(De=>({uri:De.uri,name:De.name||(0,A.basenameOrAuthority)(De.uri),index:void 0})));for(let De=0;De<X.length;De++){const pe=X[De];if(X.some((Se,le)=>le!==De&&g(pe.uri,Se.uri,this._extHostFileSystemInfo)))return!1}X.forEach((De,pe)=>De.index=pe);const{added:ye,removed:Pe}=I(ie,X,k,this._extHostFileSystemInfo);if(ye.length===0&&Pe.length===0)return!1;if(this._proxy){const De=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(De,H,B,U).then(void 0,pe=>{this._unconfirmedWorkspace=void 0;const Se={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(t.Severity.Error,(0,E.localize)(0,null,De,pe.toString()),Se,[])})}return this.trySetWorkspaceFolders(X),!0}getWorkspaceFolder(N,H){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,H)}async getWorkspaceFolder2(N,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,H)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,H){let B,L="";if(typeof N=="string"?(B=a.URI.file(N),L=N):typeof N<"u"&&(B=N,L=N.fsPath),!B)return L;const U=this.getWorkspaceFolder(B,!0);if(!U)return L;typeof H>"u"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let ie=(0,A.relativePath)(U.uri,B);return H&&U.name&&(ie=`${U.name}/${ie}`),ie}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:H,added:B,removed:L}=S.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:L}))}findFiles(N,H,B,L,U=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let ie;if(H===null?ie=!1:H&&(typeof H=="string"?ie=H:ie=H.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:ye}=C(m.GlobPattern.from(N));return this._proxy.$startFileSearch(X??null,ye??null,ie??null,B??null,U).then(Pe=>Array.isArray(Pe)?Pe.map(De=>a.URI.revive(De)):[])}async findTextInFiles(N,H,B,L,U=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const ie=this._requestIdProvider.getNext(),X=typeof H.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:ye,folder:Pe}=C(m.GlobPattern.from(H.include)),De=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,pe={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof H.useParentIgnoreFiles=="boolean"?!H.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:X,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:ye,excludePattern:De},Se=!1;if(this._activeSearchCallbacks[ie]=le=>{if(Se)return;const ae=a.URI.revive(le.resource);le.results.forEach(we=>{(0,s.resultIsMatch)(we)?B({uri:ae,preview:{text:we.preview.text,matches:(0,w.mapArrayOrNot)(we.preview.matches,Z=>new n.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))},ranges:(0,w.mapArrayOrNot)(we.ranges,Z=>new n.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))}):B({uri:ae,text:we.text,lineNumber:we.lineNumber})})},U.isCancellationRequested)return{};try{const le=await this._proxy.$startTextSearch(N,Pe??null,pe,ie,U);return delete this._activeSearchCallbacks[ie],le||{}}catch(le){throw delete this._activeSearchCallbacks[ie],le}}$handleTextSearchResult(N,H){this._activeSearchCallbacks[H]?.(N)}async save(N){const H=await this._proxy.$save(N,{saveAs:!1});return a.URI.revive(H)}async saveAs(N){const H=await this._proxy.$save(N,{saveAs:!0});return a.URI.revive(H)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(N,H){if(this._editSessionIdentityProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._editSessionIdentityProviders.set(N,H);const B=this._uriTransformerService.transformOutgoingScheme(N),L=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(L,B),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(N),this._proxy.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(N,H){this._logService.info("Getting edit session identifier for workspaceFolder",N);const B=await this.resolveWorkspaceFolder(a.URI.revive(N));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const L=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!L),!L)return;const U=await L.provideEditSessionIdentity(B,H);if(this._logService.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(N,H,B,L){this._logService.info("Getting edit session identifier for workspaceFolder",N);const U=await this.resolveWorkspaceFolder(a.URI.revive(N));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const ie=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!ie),!ie)return;const X=await ie.provideEditSessionIdentityMatch?.(H,B,L);if(this._logService.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(N){return(H,B,L)=>{const U=function(X){H.call(B,X)};return U.extension=N,this._onWillCreateEditSessionIdentityEvent.event(U,void 0,L)}}async $onWillCreateEditSessionIdentity(N,H,B){const L=await this.resolveWorkspaceFolder(a.URI.revive(N));if(L===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:L},H,async(U,ie)=>{const X=Date.now();await Promise.resolve(U),Date.now()-X>B&&this._logService.warn("SLOW edit session create-participant",ie.extension.identifier)}),H.isCancellationRequested}registerCanonicalUriProvider(N,H){if(this._canonicalUriProviders.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this._canonicalUriProviders.set(N,H);const B=this._uriTransformerService.transformOutgoingScheme(N),L=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(L,B),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(N),this._proxy.$unregisterCanonicalUriProvider(L)})}async provideCanonicalUri(N,H,B){const L=this._canonicalUriProviders.get(N.scheme);if(!L)return;const U=await L.provideCanonicalUri?.(a.URI.revive(N),H,B);if(U)return U}async $provideCanonicalUri(N,H,B){return this.provideCanonicalUri(a.URI.revive(N),{targetScheme:H},B)}};e.ExtHostWorkspace=b,e.ExtHostWorkspace=b=Ve([He(0,_.IExtHostRpcService),He(1,v.IExtHostInitDataService),He(2,u.IExtHostFileSystemInfo),He(3,h.ILogService),He(4,r.IURITransformerService)],b),e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function C($){let N,H;return $&&(typeof $=="string"?N=$:(N=$.pattern,H=a.URI.revive($.baseUri))),{includePattern:N,folder:H}}}),define(Te[34],Ae([1,0,25,5,33,3,7,178,96,15,12,4,17,14,2]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(r,s){if(s){const o=s.split(".");let g=r;for(let d=0;g&&d<o.length;d++)g=g[o[d]];return g}}function t(r){return r instanceof p.URI}function i(r){return r&&r.uri instanceof p.URI&&r.languageId&&typeof r.languageId=="string"}function u(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function v(r){return r&&r.uri instanceof p.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function _(r){if(t(r))return{resource:r};if(i(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(u(r))return{overrideIdentifier:r.languageId};if(v(r))return{resource:r.uri};if(r===null)return{resource:null}}let m=class{constructor(s,o,g){this._proxy=s.getProxy(F.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=g,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new n(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(g=>g.$acceptConfigurationChanged(s,o))}};e.ExtHostConfiguration=m,e.ExtHostConfiguration=m=Ve([He(0,a.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,E.ILogService)],m);class n{constructor(s,o,g,d){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=d,this._extHostWorkspace=o,this._configuration=l.Configuration.parse(g),this._configurationScopes=this._toMap(g.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,o){const g={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=l.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,g))}getConfiguration(s,o,g){const d=_(o)||{},k=this._toReadonlyValue(s?h(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,d,g?.identifier);function I(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const c={has(S){return typeof h(k,S)<"u"},get:(S,b)=>{this._validateConfigurationAccess(s?`${s}.${S}`:S,d,g?.identifier);let C=h(k,S);if(typeof C>"u")C=b;else{let $;const N=(H,B)=>{if((0,f.isObject)(H)){let L;const U=()=>{$=$||(0,w.deepClone)(k),L=L||h($,B)};return new Proxy(H,{get:(ie,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return U(),()=>L;if($)return L=L||h($,B),L[X];const ye=ie[X];return typeof X=="string"?N(ye,`${B}.${X}`):ye},set:(ie,X,ye)=>(U(),L&&(L[X]=ye),!0),deleteProperty:(ie,X)=>(U(),L&&delete L[X],!0),defineProperty:(ie,X,ye)=>(U(),L&&Object.defineProperty(L,X,ye),!0)})}return Array.isArray(H)?(0,w.deepClone)(H):H};C=N(C,S)}return C},update:(S,b,C,$)=>{S=s?`${s}.${S}`:S;const N=I(C);return b!==void 0?this._proxy.$updateConfigurationOption(N,S,b,d,$):this._proxy.$removeConfigurationOption(N,S,d,$)},inspect:S=>{S=s?`${s}.${S}`:S;const b=this._configuration.inspect(S,d,this._extHostWorkspace.workspace);if(b)return{key:S,defaultValue:(0,w.deepClone)(b.policy?.value??b.default?.value),globalValue:(0,w.deepClone)(b.user?.value??b.application?.value),workspaceValue:(0,w.deepClone)(b.workspace?.value),workspaceFolderValue:(0,w.deepClone)(b.workspaceFolder?.value),defaultLanguageValue:(0,w.deepClone)(b.default?.override),globalLanguageValue:(0,w.deepClone)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,w.deepClone)(b.workspace?.override),workspaceFolderLanguageValue:(0,w.deepClone)(b.workspaceFolder?.override),languageIds:(0,w.deepClone)(b.overrideIdentifiers)}}};return typeof k=="object"&&(0,w.mixin)(c,k,!1),Object.freeze(c)}_toReadonlyValue(s){const o=g=>(0,f.isObject)(g)?new Proxy(g,{get:(d,k)=>o(d[k]),set:(d,k,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(d,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(d,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):g;return o(s)}_validateConfigurationAccess(s,o,g){const d=y.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),k=g?`[${g.value}] `:"";if(d===4){typeof o?.resource>"u"&&this._logService.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){o?.resource&&this._logService.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,o){const g=new l.ConfigurationChangeEvent(s,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,k)=>g.affectsConfiguration(d,_(k))})}_toMap(s){return s.reduce((o,g)=>(o.set(g[0],g[1]),o),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")}),define(Te[111],Ae([1,0,2,12,5,3,7,33,60,34,19,63,17,27,4,13,23,14,80,216,11]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var m;(function(N){function H(L){if(L!=null)return L}N.from=H;function B(L){if(L!=null)return L}N.to=B})(m||(m={}));var n;(function(N){function H(L){if(L!=null)return L}N.from=H;function B(L){if(L!=null)return L}N.to=B})(n||(n={}));var r;(function(N){function H(L){if(L!=null)return L}N.from=H;function B(L){if(L!=null)return L}N.to=B})(r||(r={}));var s;(function(N){function H(U){if(U){const ie=U;return ie&&!!ie.process}else return!1}N.is=H;function B(U){if(U==null)return;const ie={process:U.process,args:U.args};return U.options&&(ie.options=r.from(U.options)),ie}N.from=B;function L(U){if(U!=null)return new T.ProcessExecution(U.process,U.args,U.options)}N.to=L})(s||(s={}));var o;(function(N){function H(L){if(L!=null)return L}N.from=H;function B(L){if(L!=null)return L}N.to=B})(o||(o={}));var g;(function(N){function H(U){if(U){const ie=U;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}N.is=H;function B(U){if(U==null)return;const ie={};return U.commandLine!==void 0?ie.commandLine=U.commandLine:(ie.command=U.command,ie.args=U.args),U.options&&(ie.options=o.from(U.options)),ie}N.from=B;function L(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new T.ShellExecution(U.commandLine,U.options):new T.ShellExecution(U.command,U.args?U.args:[],U.options)}N.to=L})(g||(g={}));var d;(function(N){function H(U){if(U){const ie=U;return ie&&ie.customExecution==="customExecution"}else return!1}N.is=H;function B(U){return{customExecution:"customExecution"}}N.from=B;function L(U,ie){return ie.get(U)}N.to=L})(d||(e.CustomExecutionDTO=d={}));var k;(function(N){function H(B,L){let U;return B.scope!==void 0&&typeof B.scope!="number"?U=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===T.TaskScope.Workspace&&L&&L.workspaceFile?U=L.workspaceFile:U=v.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:U}}N.from=H})(k||(e.TaskHandleDTO=k={}));var I;(function(N){function H(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}N.from=H})(I||(I={}));var c;(function(N){function H(U,ie){if(U==null)return[];const X=[];for(const ye of U){const Pe=B(ye,ie);Pe&&X.push(Pe)}return X}N.fromMany=H;function B(U,ie){if(U==null)return;let X;U.execution instanceof T.ProcessExecution?X=s.from(U.execution):U.execution instanceof T.ShellExecution?X=g.from(U.execution):U.execution&&U.execution instanceof T.CustomExecution&&(X=d.from(U.execution));const ye=m.from(U.definition);let Pe;return U.scope?typeof U.scope=="number"?Pe=U.scope:Pe=U.scope.uri:Pe=T.TaskScope.Workspace,!ye||!Pe?void 0:{_id:U._id,definition:ye,name:U.name,source:{extensionId:ie.identifier.value,label:U.source,scope:Pe},execution:X,isBackground:U.isBackground,group:I.from(U.group),presentationOptions:n.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}N.from=B;async function L(U,ie,X){if(U==null)return;let ye;s.is(U.execution)?ye=s.to(U.execution):g.is(U.execution)?ye=g.to(U.execution):d.is(U.execution)&&(ye=d.to(U._id,X));const Pe=m.to(U.definition);let De;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?De=U.source.scope:De=await ie.resolveWorkspaceFolder(w.URI.revive(U.source.scope)):De=T.TaskScope.Workspace),!Pe||!De)return;const pe=new T.Task(Pe,De,U.name,U.source.label,ye,U.problemMatchers);return U.isBackground!==void 0&&(pe.isBackground=U.isBackground),U.group!==void 0&&(pe.group=T.TaskGroup.from(U.group._id),pe.group&&U.group.isDefault&&(pe.group=new T.TaskGroup(pe.group.id,pe.group.label),U.group.isDefault===!0&&(pe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(pe.presentationOptions=n.to(U.presentationOptions)),U._id&&(pe._id=U._id),U.detail&&(pe.detail=U.detail),pe}N.to=L})(c||(e.TaskDTO=c={}));var S;(function(N){function H(L){return L}N.from=H;function B(L){if(L)return Object.assign(Object.create(null),L)}N.to=B})(S||(S={}));class b{#e;constructor(H,B,L){this._id=B,this._task=L,this.#e=H}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}let C=class{constructor(H,B,L,U,ie,X,ye,Pe){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=H.getProxy(F.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=U,this._configurationService=ie,this._terminalService=X,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ye,this._deprecationService=Pe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,B,L){if(!L)return new T.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:B,provider:L,extension:H}),this._proxy.$registerTaskProvider(U,B),new T.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(H,B){this._proxy.$registerTaskSystem(H,B)}fetchTasks(H){return this._proxy.$fetchTasks(S.from(H)).then(async B=>{const L=[];for(const U of B){const ie=await c.to(U,this._workspaceProvider,this._providedCustomExecutions2);ie&&L.push(ie)}return L})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(B=>H.push(B)),H}terminateTask(H){if(!(H instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,B,L){const U=this._providedCustomExecutions2.get(H.id);U&&(this._activeCustomExecutions2.set(H.id,U),this._terminalService.attachPtyToTerminal(B,await U.callback(L))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const B=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const B=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:B,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const B=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:H.exitCode})}$provideTasks(H,B){const L=this._handlers.get(H);if(!L)return Promise.reject(new Error("no handler found"));const U=[],ie=(0,R.asPromise)(()=>L.provider.provideTasks(A.CancellationToken.None)).then(X=>this.provideTasksInternal(B,U,L,X));return new Promise(X=>{ie.then(ye=>{Promise.all(U).then(()=>{X(ye)})})})}async $resolveTask(H,B){const L=this._handlers.get(H);if(!L)return Promise.reject(new Error("no handler found"));if(B.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${L.type}].`);const U=await c.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const ie=await L.provider.resolveTask(U,A.CancellationToken.None);if(!ie)return;this.checkDeprecation(ie,L);const X=c.from(ie,L.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(X.execution)&&await this.addCustomExecution(X,ie,!0),await this.resolveTaskInternal(X)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,B,L){const U=await this._proxy.$createTaskId(H);!L&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,B.execution)),this._providedCustomExecutions2.set(U,B.execution)}async getTaskExecution(H,B){if(typeof H=="string"){const ie=this._taskExecutionPromises.get(H);if(!ie)throw new _.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return ie}const L=this._taskExecutionPromises.get(H.id);if(L)return L;const U=new Promise((ie,X)=>{function ye(Pe,De,pe){pe?ie(new b(Pe,De.id,pe)):X("Unexpected: Task does not exist.")}B?ye(this,H,B):c.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(Pe=>ye(this,H,Pe))});return this._taskExecutionPromises.set(H.id,U),U.then(ie=>(this._taskExecutions.set(H.id,ie),ie),ie=>Promise.reject(ie))}checkDeprecation(H,B){H._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));const L=this._notProvidedCustomExecutions.values();let U=L.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=L.next()}};e.ExtHostTaskBase=C,e.ExtHostTaskBase=C=Ve([He(0,a.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,l.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,f.IExtHostConfiguration),He(5,D.IExtHostTerminalService),He(6,i.ILogService),He(7,u.IExtHostApiDeprecationService)],C);let $=class extends C{constructor(H,B,L,U,ie,X,ye,Pe){super(H,B,L,U,ie,X,ye,Pe),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(H,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const L=c.from(B,H);if(L===void 0)throw new Error("Task is not valid");if(d.is(L.execution))await this.addCustomExecution(L,B,!1);else throw new _.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),B);return this._proxy.$executeTask(L).catch(ie=>{throw new Error(ie)}),U}provideTasksInternal(H,B,L,U){const ie=[];if(U)for(const X of U){this.checkDeprecation(X,L),(!X.definition||!H[X.definition.type])&&this._logService.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=c.from(X,L.extension);ye&&d.is(ye.execution)?(ie.push(ye),B.push(this.addCustomExecution(ye,X,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:L.extension}}async resolveTaskInternal(H){if(d.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,B,L){}};e.WorkerExtHostTask=$,e.WorkerExtHostTask=$=Ve([He(0,a.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,l.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,f.IExtHostConfiguration),He(5,D.IExtHostTerminalService),He(6,i.ILogService),He(7,u.IExtHostApiDeprecationService)],$),e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Te[270],Ae([1,0,20,19,37,38,24,48,49]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class f{constructor(a,E,p){this.config=a,this.provider=E,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&F.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&F.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const E=this.config.folderQueries||[];return new Promise((p,h)=>{const t=i=>{this.resultCount++,a(i)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(i=>{const u=i.toString(),v=w.basename(u);this.globalExcludePattern&&this.globalExcludePattern(u,v)||this.matchFile(t,{base:i,basename:v})}),Promise.all(E.map(i=>this.searchInFolder(i,t))).then(i=>{p({limitHit:this.isLimitHit,stats:i[0]||void 0})},i=>{h(new Error((0,P.toErrorMessage)(i)))})})}async searchInFolder(a,E){const p=new R.CancellationTokenSource,h=this.getSearchOptionsForFolder(a),t=this.initDirectoryTree(),i=new y.QueryGlobTester(this.config,a),u=!i.hasSiblingExcludeClauses();let v;try{this.activeCancellationTokens.add(p),v=l.StopWatch.create();const _=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,p.token),m=v.elapsed(),n=l.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(_&&_.forEach(r=>{const s=w.posix.relative(a.folder.path,r.path);if(u){const o=w.basename(r.path);this.matchFile(E,{base:a.folder,relativePath:s,basename:o});return}this.addDirectoryEntries(t,a.folder,s,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,i,E),{providerTime:m,postProcessTime:n.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(a){const E=(0,y.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),p=(0,y.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:p,includes:E,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},E,p,h){if(p===this.filePattern){const i=w.basename(this.filePattern);this.matchFile(h,{base:E,relativePath:this.filePattern,basename:i})}function t(i){const u=w.basename(i),v=w.dirname(i);let _=a[v];_||(_=a[v]=[],t(v)),_.push({base:E,relativePath:i,basename:u})}t(p)}matchDirectoryTree({rootEntries:a,pathToEntries:E},p,h){const t=this,i=this.filePattern;function u(v){const _=(0,y.hasSiblingFn)(()=>v.map(m=>m.basename));for(let m=0,n=v.length;m<n;m++){const r=v[m],{relativePath:s,basename:o}=r;if(p.matchesExcludesSync(s,o,i!==o?_:void 0))continue;const g=E[s];if(g)u(g);else{if(s===i)continue;t.matchFile(h,r)}if(t.isLimitHit)break}}u(a)}matchFile(a,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(E))}}class A{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(a,E,p,h){const t=this.getSessionTokenSource(a.cacheKey),i=new f(a,E,t&&t.token);let u=0;const v=_=>{u+=_.length,p(_.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(i,A.BATCH_SIZE,v,h).then(_=>({limitHit:_.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:u,detailStats:_.stats}}))}clearCache(a){this.getSessionTokenSource(a)?.cancel()}getSessionTokenSource(a){if(a)return this.sessions.has(a)||this.sessions.set(a,new R.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:T.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,E,p,h){const t=h.onCancellationRequested(()=>{a.cancel()}),i=v=>{v&&(u.push(v),E>0&&u.length>=E&&(p(u),u=[]))};let u=[];return a.search(i).then(v=>(u.length&&p(u),t.dispose(),v),v=>(u.length&&p(u),t.dispose(),Promise.reject(v)))}}e.FileSearchManager=A}),define(Te[271],Ae([1,0,18,234,38,90,28,13,20,24,16,15,2,286,168,45,14,56,102,269,49]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(S,b,C,$,N){this.configurationService=S,this.workspaceContextService=b,this.editorGroupsService=C,this.logService=$,this.pathService=N}text(S,b,C={}){S=this.getContentPattern(S,C);const $=this.configurationService.getValue(),N=b&&b.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(b?.map(i.toWorkspaceFolder),C),type:2,contentPattern:S,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:$.search.usePCRE2||N||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}getContentPattern(S,b){const C=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const $={...S,wordSeparators:C.editor.wordSeparators};return this.isCaseSensitive(S,b)&&($.isCaseSensitive=!0),this.isMultiline(S)&&($.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&($.notebookInfo||($.notebookInfo={}),$.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&($.notebookInfo||($.notebookInfo={}),$.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&($.notebookInfo||($.notebookInfo={}),$.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&($.notebookInfo||($.notebookInfo={}),$.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),$}file(S,b={}){return{...this.commonQuery(S,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}handleIncludeExclude(S,b){return S?(S=Array.isArray(S)?S.map(g):g(S),b?this.parseSearchPaths(S):{pattern:r(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],b={}){const C=this.handleIncludeExclude(b.includePattern,b.expandPatterns),$=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),N=S.length>1,H=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,b,$)):S.map(U=>this.getFolderQueryForRoot(U,b,$,N))).filter(U=>!!U),B={_reason:b._reason,folderQueries:H,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:$.pattern,includePattern:C.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const U=w.coalesce(w.flatten(this.editorGroupsService.groups.map(ye=>ye.editors.map(Pe=>Pe.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const ie=U.filter(ye=>(0,_.pathIncludedInQuery)(B,ye.fsPath)),X=this.commonQueryFromFileList(ie);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...B,...X}}const L=b.extraFileResources&&b.extraFileResources.filter(U=>(0,_.pathIncludedInQuery)(B,U.fsPath));return B.extraFileResources=L&&L.length?L:void 0,B}commonQueryFromFileList(S){const b=[],C=new T.ResourceMap,$={};let N=!1;return S.forEach(H=>{if(H.scheme===l.Schemas.walkThrough)return;if((0,f.isAbsolutePath)(H)){const L=this.workspaceContextService.getWorkspaceFolder(H)?.uri??H.with({path:y.dirname(H.fsPath)});let U=C.get(L);U||(N=!0,U={folder:L,includePattern:{}},b.push(U),C.set(L,U));const ie=y.relative(L.fsPath,H.fsPath);(0,D.assertIsDefined)(U.includePattern)[ie.replace(/\\/g,"/")]=!0}else H.fsPath&&(N=!0,$[H.fsPath]=!0)}),{folderQueries:b,includePattern:$,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(S,b){if(b.isSmartCase){if(S.isRegExp){if(A.containsUppercaseCharacter(S.pattern,!0))return!0}else if(A.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,E.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const b=X=>y.isAbsolute(X)||/^\.\.?([\/\\]|$)/.test(X),$=(Array.isArray(S)?S:s(S)).map(X=>{const ye=this.pathService.resolvedUserHome;return ye?(0,F.untildify)(X,ye.scheme===l.Schemas.file?ye.fsPath:ye.path):X}),N=R.groupBy($,X=>b(X)?"searchPaths":"exprSegments"),H=(N.exprSegments||[]).map(X=>A.rtrim(X,"/")).map(X=>A.rtrim(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),B={},L=this.expandSearchPathPatterns(N.searchPaths||[]);L&&L.length&&(B.searchPaths=L);const U=w.flatten(H),ie=r(...U);return ie&&(B.pattern=ie),B}getExcludesForFolder(S,b){return b.disregardExcludeSettings?void 0:(0,_.getExcludes)(S,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const b=S.flatMap($=>{let{pathPortion:N,globPortion:H}=n($);return H&&(H=d(H)),this.expandOneSearchPath(N).flatMap(L=>this.resolveOneSearchPathPattern(L,H))}),C=new Map;return b.forEach($=>{const N=$.searchPath.toString(),H=C.get(N);H?$.pattern&&(H.pattern=H.pattern||{},H.pattern[$.pattern]=!0):C.set(N,{searchPath:$.searchPath,pattern:$.pattern?r($.pattern):void 0})}),Array.from(C.values())}expandOneSearchPath(S){if(y.isAbsolute(S)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==l.Schemas.file?[{searchPath:b[0].uri.with({path:S})}]:[{searchPath:a.URI.file(y.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=g(S),S.startsWith("../")||S===".."){const $=y.posix.resolve(b.path,S);return[{searchPath:b.with({path:$})}]}const C=d(S);return[{searchPath:b,pattern:C}]}else{if(S==="./"||S===".\\")return[];{const b=S.replace(/^\.[\/\\]/,""),$=this.workspaceContextService.getWorkspace().folders.map(N=>{const H=b.match(new RegExp(`^${A.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return H?{match:H,folder:N}:null}).filter(D.isDefined);if($.length)return $.map(N=>{const H=N.match[1];return{searchPath:N.folder.uri,pattern:H&&d(H)}});{const N=S.match(/\.[\/\\](.+)[\/\\]?/),H=N?N[1]:S,B=p.localize(0,null,H);throw new Error(B)}}}}resolveOneSearchPathPattern(S,b){const C=S.pattern&&b?`${S.pattern}/${b}`:S.pattern||b,$=[{searchPath:S.searchPath,pattern:C}];return C&&!C.endsWith("**")&&$.push({searchPath:S.searchPath,pattern:C+"/**"}),$}getFolderQueryForSearchPath(S,b,C){const $=this.getFolderQueryForRoot((0,i.toWorkspaceFolder)(S.searchPath),b,C,!1);return $?{...$,includePattern:S.pattern}:null}getFolderQueryForRoot(S,b,C,$){let N;const H=a.URI.isUri(S)?S:S.uri;if(C.searchPaths){const X=C.searchPaths.filter(ye=>(0,f.isEqual)(ye.searchPath,H))[0];if(X&&!X.pattern)return null;X&&(N=X.pattern)}const B=this.configurationService.getValue({resource:H}),U={...this.getExcludesForFolder(B,b)||{},...N||{}},ie=a.URI.isUri(S)?(0,f.basename)(S):S.name;return{folder:H,folderName:$?ie:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!B.search.followSymlinks}}};e.QueryBuilder=m,e.QueryBuilder=m=Ve([He(0,h.IConfigurationService),He(1,i.IWorkspaceContextService),He(2,u.IEditorGroupsService),He(3,t.ILogService),He(4,v.IPathService)],m);function n(c){const S=c.match(/[\*\{\}\(\)\[\]\?]/);if(S){const b=S.index,C=c.substr(0,b).match(/[/|\\][^/\\]*$/);if(C){let $=c.substr(0,C.index);return $.match(/[/\\]/)||($+="/"),{pathPortion:$,globPortion:c.substr((C.index||0)+1)}}}return{pathPortion:c}}function r(...c){return c.length?c.reduce((S,b)=>(S[b]=!0,S),Object.create(null)):void 0}function s(c){return P.splitGlobAware(c,",").map(S=>S.trim()).filter(S=>!!S.length)}function o(c){return[`**/${c}/**`,`**/${c}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function g(c){return c.replace(/\\/g,"/")}function d(c){return g(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(c){return c.replace(/([?*[\]])/g,"[$1]")}function I(c,S){c=w.distinct(c,$=>$.toString());const b=[],C=S.getWorkspace();return c&&c.forEach($=>{let N;if(S.getWorkbenchState()===2)N=(0,f.relativePath)(C.folders[0].uri,$),N&&N!=="."&&(N="./"+N);else{const H=S.getWorkspaceFolder($);if(H){const B=H.name;if(C.folders.filter(U=>U.name===B).length===1){const U=(0,f.relativePath)(H.uri,$);U===""?N=`./${H.name}`:N=`./${H.name}/${U}`}else N=$.fsPath}}N&&b.push(k(N))}),b}e.resolveResourcesForSearchIncludes=I}),define(Te[272],Ae([1,0,24,2,19,11,4,271,49,56]),function(be,e,w,R,P,F,T,l,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function D(h,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const u=[],v=[];for(const o of i)if(/^workspaceContains:/.test(o)){const g=o.substr(18);g.indexOf("*")>=0||g.indexOf("?")>=0||h.forceUsingSearch?v.push(g):u.push(g)}if(u.length===0&&v.length===0)return Promise.resolve(void 0);let _;const m=new Promise((o,g)=>{_=o}),n=o=>_({activationEvent:o}),r=Promise.all(u.map(o=>a(h,o,n))).then(()=>{}),s=E(h,t.identifier,v,n);return Promise.all([r,s]).then(()=>{_(void 0)}),m}e.checkActivateWorkspaceContainsExtension=D;async function a(h,t,i){for(const u of h.folders)if(await h.exists(w.joinPath(R.URI.revive(u),t))){i(`workspaceContains:${t}`);return}}async function E(h,t,i,u){if(i.length===0)return Promise.resolve(void 0);const v=new P.CancellationTokenSource,_=h.checkExists(h.folders,i,v.token),m=setTimeout(async()=>{v.cancel(),h.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let n=!1;try{n=await _}catch(r){F.isCancellationError(r)||F.onUnexpectedError(r)}v.dispose(),clearTimeout(m),n&&u(`workspaceContains:${i.join(",")}`)}function p(h,t,i,u){const v=h.get(T.IInstantiationService),_=h.get(y.ISearchService),n=v.createInstance(l.QueryBuilder).file(t.map(r=>(0,f.toWorkspaceFolder)(R.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return _.fileSearch(n,u).then(r=>!!r.limitHit,r=>F.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=p}),define(Te[35],Ae([1,0,149,20,87,24,12,6,50,2,14,3,34,205,84,33,22,103,11,21,26,189,7,97,4,27,85,17,71,86,63,5,272,83,191,13,81,48,23,82]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_,m,n,r,s,o,g,d,k,I,c,S,b,C,$,N,H,B,L,U){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let X=ie=class extends l.Disposable{constructor(Z,z,Y,ee,ve,ge,de,_e,re,ue,ne,oe){super(),this._extHostManagedSockets=oe,this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=z,this._extHostContext=Y,this._initData=de,this._extHostWorkspace=ee,this._extHostConfiguration=ve,this._logService=ge,this._extHostTunnelService=re,this._extHostTerminalService=ue,this._extHostLocalizationService=ne,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new ae(this._initData.extensions.activationEvents),this._globalRegistry=new i.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const fe=new v.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new i.ExtensionDescriptionRegistry(this._activationEventsReader,Se(this._globalRegistry,fe)),L.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${De(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${De(this._myRegistry)}`)),this._storage=new p.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new C.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=Z.createChild(new k.ServiceCollection([p.IExtHostStorage,this._storage],[C.IExtHostSecretState,this._secretState])),this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ke,O,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ke,u.transformErrorForSerialization(O),W)},actualActivateExtension:async(ke,O)=>{if(i.ExtensionDescriptionRegistry.isHostExtension(ke,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ke,O),new E.HostExtension;const W=this._myRegistry.getExtensionDescription(ke);return this._activateExtension(W,O)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Z){u.onUnexpectedError(Z)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Z=[];try{Z=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(Z)}terminate(Z,z=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Z}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),u.setUnexpectedErrorHandler(ee=>{this._logService.error(ee)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${z}`):this._logService.info(`Extension host exiting with code ${z}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(z)})}isActivated(Z){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Z):!1}async getExtension(Z){const z=await this._mainThreadExtensionsProxy.$getExtension(Z);return z&&{...z,identifier:new v.ExtensionIdentifier(z.identifier.value),extensionLocation:f.URI.revive(z.extensionLocation)}}_activateByEvent(Z,z){return this._activator.activateByEvent(Z,z)}_activateById(Z,z){return this._activator.activateById(Z,z)}activateByIdWithErrors(Z,z){return this._activateById(Z,z).then(()=>{const Y=this._activator.getActivatedExtension(Z);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Z=>this._myRegistry)}getExtensionExports(Z){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(Z).exports;try{return this._activator.getActivatedExtension(Z).exports}catch{return null}}async _realPathExtensionUri(Z){if(Z.scheme===N.Schemas.file&&this._hostUtils.fsRealpath){const z=await this._hostUtils.fsRealpath(Z.fsPath);return f.URI.file(z)}return Z}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Z=>new le(Z))),this._extensionPathIndex}async _createExtensionPathIndex(Z){const z=y.TernarySearchTree.forUris(Y=>F.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(Z.map(async Y=>{if(this._getEntryPoint(Y)){const ee=await this._realPathExtensionUri(Y.extensionLocation);z.set(ee,Y)}})),z}_deactivate(Z){let z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Z))return z;const Y=this._activator.getActivatedExtension(Z);if(!Y)return z;try{typeof Y.module.deactivate=="function"&&(z=Promise.resolve(Y.module.deactivate()).then(void 0,ee=>(this._logService.error(ee),Promise.resolve(void 0))))}catch(ee){this._logService.error(`An error occurred when deactivating the extension '${Z.value}':`),this._logService.error(ee)}try{(0,l.dispose)(Y.subscriptions)}catch(ee){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Z.value}':`),this._logService.error(ee)}return z}async _activateExtension(Z,z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Z.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Z.identifier),this._doActivateExtension(Z,z).then(Y=>{const ee=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Z.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,z),this._logExtensionActivationTimes(Z,z,"success",ee),Y},Y=>{throw this._logExtensionActivationTimes(Z,z,"failure"),Y})}_logExtensionActivationTimes(Z,z,Y,ee){const ve=Pe(Z,z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...ee||{},outcome:Y})}_doActivateExtension(Z,z){const Y=Pe(Z,z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const ee=this._getEntryPoint(Z);if(!ee)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${Z.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this._logService.flush();const ve=new E.ExtensionActivationTimesBuilder(z.startup);return Promise.all([this._loadCommonJSModule(Z,(0,F.joinPath)(Z.extensionLocation,ee),ve),this._loadExtensionContext(Z)]).then(ge=>(P.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),ie._callActivate(this._logService,Z.identifier,ge[0],ge[1],ve))).then(ge=>(P.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),ge))}_loadExtensionContext(Z){const z=new m.ExtensionGlobalMemento(Z,this._storage),Y=new m.ExtensionMemento(Z.identifier.value,!1,this._storage),ee=new $.ExtensionSecrets(Z,this._secretState),ve=Z.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ge=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([z.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const de=this;let _e,re;const ue=(0,t.isProposedApiEnabled)(Z,"ipc")?this._initData.messagePorts?.get(v.ExtensionIdentifier.toKey(Z.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:Y,secrets:ee,subscriptions:[],get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(ne){return R.join(Z.extensionLocation.fsPath,ne)},get storagePath(){return de._storagePath.workspaceValue(Z)?.fsPath},get globalStoragePath(){return de._storagePath.globalValue(Z).fsPath},get logPath(){return R.join(de._initData.logsLocation.fsPath,Z.identifier.value)},get logUri(){return f.URI.joinPath(de._initData.logsLocation,Z.identifier.value)},get storageUri(){return de._storagePath.workspaceValue(Z)},get globalStorageUri(){return de._storagePath.globalValue(Z)},get extensionMode(){return ve},get extension(){return _e===void 0&&(_e=new pe(de,Z.identifier,Z,ge,!1)),_e},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(Z,"extensionRuntime"),de.extensionRuntime},get environmentVariableCollection(){return de._extHostTerminalService.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!re){if(!ue)return;const ne=S.Event.buffer(S.Event.fromDOMEventEmitter(ue,"message",oe=>oe.data));ue.start(),re={onDidReceiveMessage:ne,postMessage:ue.postMessage.bind(ue)}}return re}})})}static _callActivate(Z,z,Y,ee,ve){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(Z,z,Y,ee,ve).then(ge=>new E.ActivatedExtension(!1,null,ve.build(),Y,ge,ee.subscriptions))}static _callActivateOptional(Z,z,Y,ee,ve){if(typeof Y.activate=="function")try{ve.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ge=typeof global=="object"?global:self,de=Y.activate.apply(ge,[ee]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(de).then(_e=>(ve.activateResolveStop(),_e))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(Y)}_activateOneStartupFinished(Z,z){this._activateById(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:z}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinishedDeferred(Z,z=0){const ee=Date.now();(0,L.setTimeout0)(()=>{for(let ve=z;ve<Z.length;ve+=1){const ge=Z[ve];for(const de of ge.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-ee>50){this._activateAllStartupFinishedDeferred(Z,ve);break}else this._activateOneStartupFinished(ge,de)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks()),this._extHostConfiguration.getConfigProvider().then(Z=>{const z=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Y=this._myRegistry.getAllExtensionDescriptions();if(z)this._activateAllStartupFinishedDeferred(Y);else for(const ee of Y)if(ee.activationEvents)for(const ve of ee.activationEvents)ve==="onStartupFinished"&&this._activateOneStartupFinished(ee,ve)})}_handleEagerExtensions(){const Z=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(z),ee=this._handleRemoteResolverEagerExtensions(),ve=Promise.all([ee,Z,Y]).then(()=>{});return Promise.race([ve,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ve}_handleWorkspaceContainsEagerExtensions(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(z=>this._handleWorkspaceContainsEagerExtension(Z,z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Z,z){if(this.isActivated(z.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ee={logService:this._logService,folders:Z.map(ge=>ge.uri),forceUsingSearch:Y||!this._hostUtils.fsExists,exists:ge=>this._hostUtils.fsExists(ge.fsPath),checkExists:(ge,de,_e)=>this._mainThreadWorkspaceProxy.$checkExists(ge,de,_e)},ve=await(0,b.checkActivateWorkspaceContainsExtension)(ee,z);if(ve)return this._activateById(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:ve.activationEvent}).then(void 0,ge=>this._logService.error(ge))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Z){throw console.error(Z),Z}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:z}=this._initData.environment;if(!Z||!z)throw new Error(w.localize(0,null));const Y=await this._loadCommonJSModule(null,z,new E.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(w.localize(1,null,z.toString()));return new Promise((ee,ve)=>{const ge=(re,ue)=>{re?(L.isCI&&this._logService.error("Test runner called back with error",re),ve(re)):(L.isCI&&(ue?this._logService.info(`Test runner called back with ${ue} failures.`):this._logService.info("Test runner called back with successful outcome.")),ee(typeof ue=="number"&&ue>0?1:0))},de=(0,F.originalFSPath)(z),_e=Y.run(de,ge);_e&&_e.then&&_e.then(()=>{L.isCI&&this._logService.info("Test runner finished successfully."),ee(0)}).catch(re=>{L.isCI&&this._logService.error("Test runner finished with error",re),ve(re instanceof Error&&re.stack?re.stack:String(re))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,z){return this._resolvers[Z]=z,(0,l.toDisposable)(()=>{delete this._resolvers[Z]})}async getRemoteExecServer(Z){const{resolver:z}=await this._activateAndGetResolver(Z);return z?.resolveExecServer?.(Z,{resolveAttempt:0})}async _activateAndGetResolver(Z){const z=Z.indexOf("+");if(z===-1)throw new n.RemoteAuthorityResolverError("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Y=Z.substr(0,z);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(Z,z){const Y=B.StopWatch.create(!1),ee=()=>`[resolveAuthority(${(0,r.getRemoteAuthorityPrefix)(Z)},${z})][${Y.elapsed()}ms] `,ve=K=>this._logService.info(`${ee()}${K}`),ge=K=>this._logService.warn(`${ee()}${K}`),de=(K,V=void 0)=>this._logService.error(`${ee()}${K}`,V),_e=K=>{if(K instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},re=async K=>{ve(`activating resolver for ${K}...`);const{resolver:V,authorityPrefix:J}=await this._activateAndGetResolver(K);if(!V)throw de(`no resolver for ${J}`),new n.RemoteAuthorityResolverError(`No remote extension installed to resolve ${J}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:V,authorityPrefix:J,remoteAuthority:K}},ue=Z.split(/@|%40/g).reverse();ve(`activating remote resolvers ${ue.join(" -> ")}`);let ne;try{ne=await Promise.all(ue.map(re)).catch(async K=>{if(!(K instanceof n.RemoteAuthorityResolverError)||K._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return ge(`resolving nested authorities failed: ${K.message}`),[await re(Z)]})}catch(K){return _e(K)}const oe=new T.IntervalTimer;oe.cancelAndSet(()=>ve("waiting..."),1e3);let fe,ke;for(const[K,{authorityPrefix:V,resolver:J,remoteAuthority:ce}]of ne.entries())try{if(K===ne.length-1)ve("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${V}`),fe=await J.resolve(ce,{resolveAttempt:z,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${V}`),ve("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(J,n.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)?fe:void 0));else{if(ve(`invoking resolveExecServer() for ${ce}`),P.mark(`code/extHost/willResolveExecServer/${V}`),ke=await J.resolveExecServer?.(ce,{resolveAttempt:z,execServer:ke}),!ke)throw new n.RemoteAuthorityResolverError(`Exec server was not available for ${ce}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${V}`)}}catch(Me){return P.mark(`code/extHost/didResolveAuthorityError/${V}`),de("returned an error",Me),oe.dispose(),_e(Me)}oe.dispose();const O={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},W={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};ve(`returned ${n.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let j;if(n.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)){const K=z;this._extHostManagedSockets.setFactory(K,fe.makeConnection),j={authority:Z,connectTo:new r.ManagedRemoteConnection(K),connectionToken:fe.connectionToken}}else j={authority:Z,connectTo:new r.WebSocketRemoteConnection(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:j,options:W,tunnelInformation:O}}}async $getCanonicalURI(Z,z){this._logService.info(`$getCanonicalURI invoked for authority (${(0,r.getRemoteAuthorityPrefix)(Z)})`);const{resolver:Y}=await this._activateAndGetResolver(Z);if(!Y)return null;const ee=f.URI.revive(z);if(typeof Y.getCanonicalURI>"u")return ee;const ve=await(0,T.asPromise)(()=>Y.getCanonicalURI(ee));return ve||ee}$startExtensionHost(Z){Z.toAdd.forEach(ee=>ee.extensionLocation=f.URI.revive(ee.extensionLocation));const{globalRegistry:z,myExtensions:Y}=ye(this._activationEventsReader,this._globalRegistry,this._myRegistry,Z);return this._globalRegistry.set(z.getAllExtensionDescriptions()),this._myRegistry.set(Y),L.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${De(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${De(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(Z,z){return z===1?this._almostReadyToRunExtensions.wait().then(Y=>this._activateByEvent(Z,!1)):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(Z,!1))}async $activate(Z,z){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Z)?(await this._activateById(Z,z),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(ge=>ge.extensionLocation=f.URI.revive(ge.extensionLocation));const{globalRegistry:z,myExtensions:Y}=ye(this._activationEventsReader,this._globalRegistry,this._myRegistry,Z),ee=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(ee),this._globalRegistry.set(z.getAllExtensionDescriptions()),this._myRegistry.set(Y),L.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${De(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${De(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const z=_.VSBuffer.alloc(Z),Y=Math.random()%256;for(let ee=0;ee<Z;ee++)z.writeUInt8(Y,ee);return z}async $updateRemoteConnectionData(Z){this._remoteConnectionData=Z,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=X,e.AbstractExtHostExtensionService=X=ie=Ve([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,h.IExtHostWorkspace),He(4,a.IExtHostConfiguration),He(5,A.ILogService),He(6,o.IExtHostInitDataService),He(7,g.IExtensionStoragePaths),He(8,I.IExtHostTunnelService),He(9,c.IExtHostTerminalService),He(10,H.IExtHostLocalizationService),He(11,U.IExtHostManagedSockets)],X);function ye(we,Z,z,Y){we.addActivationEvents(Y.addActivationEvents);const ee=new i.ExtensionDescriptionRegistry(we,Z.getAllExtensionDescriptions());ee.deltaExtensions(Y.toAdd,Y.toRemove);const ve=new v.ExtensionIdentifierSet(z.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of Y.myToRemove)ve.delete(de);for(const de of Y.myToAdd)ve.add(de);const ge=Se(ee,ve);return{globalRegistry:ee,myExtensions:ge}}function Pe(we,Z){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function De(we){return we.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(Z,z,Y,ee,ve){this.#e=Z,this.#t=z,this.#i=Y.identifier,this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=R.normalize((0,F.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ee,this.isFromDifferentExtensionHost=ve}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=pe;function Se(we,Z){return we.getAllExtensionDescriptions().filter(z=>Z.has(z.identifier))}class le{constructor(Z){this._searchTree=Z}setSearchTree(Z){this._searchTree=Z}findSubstr(Z){return this._searchTree.findSubstr(Z)}forEach(Z){return this._searchTree.forEach(Z)}}e.ExtensionPaths=le;class ae{constructor(Z){this._map=new v.ExtensionIdentifierMap,this.addActivationEvents(Z)}readActivationEvents(Z){return this._map.get(Z.identifier)}addActivationEvents(Z){for(const z of Object.keys(Z))this._map.set(z,Z[z])}}}),define(Te[273],Ae([1,0,87,2,3,34,22,21,17,27,4,35,14,16]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(_,m,n,r,s,o,g){this._apiFactory=_,this._extensionRegistry=m,this._instaService=n,this._extHostConfiguration=r,this._extHostExtensionService=s,this._initData=o,this._logService=g,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const m=await this._extHostExtensionService.getExtensionPathIndex();this.register(new i(this._apiFactory,m,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(t)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(u,m,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(const m of _.nodeModuleName)this._factories.set(m,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(m=>_.alternativeModuleName(m))}};e.RequireInterceptor=h,e.RequireInterceptor=h=Ve([He(2,A.IInstantiationService),He(3,F.IExtHostConfiguration),He(4,D.IExtHostExtensionService),He(5,f.IExtHostInitDataService),He(6,a.ILogService)],h);let t=class{static{p=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(_){if(_.environment.appRoot&&p.aliased.size){const m=(0,E.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${m}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const m=this.re.exec(this.forceForwardSlashes(_));if(!m)return;const[,n,r,s]=m,o=p.aliased.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),n+o+s}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};t=p=Ve([He(0,f.IExtHostInitDataService)],t);class i{constructor(_,m,n,r,s){this._apiFactory=_,this._extensionPaths=m,this._extensionRegistry=n,this._configProvider=r,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new l.ExtensionIdentifierMap}load(_,m){const n=this._extensionPaths.findSubstr(m);if(n){let r=this._extApiImpl.get(n.identifier);return r||(r=this._apiFactory(n,this._extensionRegistry,this._configProvider),this._extApiImpl.set(n.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((s,o)=>r+=`	${o} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${m}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let u=class{constructor(_,m,n){this._extensionPaths=_,this._appUriScheme=m,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=n.getProxy(P.MainContext.MainThreadTelemetry);const r=n.getProxy(P.MainContext.MainThreadWindow);this._impl=(s,o)=>{const g=R.URI.parse(s);return o?this.callOriginal(s,o):g.scheme==="http"||g.scheme==="https"?r.$openUri(g,s,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this._appUriScheme?r.$openUri(g,s,{}):this.callOriginal(s,o)}}load(_,m,n){const r=this._extensionPaths.findSubstr(m);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=n(_),this._impl}callOriginal(_,m){return this.sendNoForwardTelemetry(),this._original(_,m)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};u=Ve([He(2,y.IExtHostRpcService)],u)}),define(Te[112],Ae([1,0,42,6,20,73,4,60,61,35,7,33,202,34]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class p extends a.AbstractVariableResolverService{constructor(i,u,v,_,m,n,r){function s(){if(v){const o=v.activeEditor();if(o)return o.document.uri;const g=_.tabGroups.all.find(d=>d.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof A.TextDiffTabInput||g.input instanceof A.NotebookDiffEditorTabInput)return g.input.modified;if(g.input instanceof A.TextTabInput||g.input instanceof A.NotebookEditorTabInput||g.input instanceof A.CustomEditorTabInput)return g.input.uri}}}super({getFolderUri:o=>{const g=n.folders.filter(d=>d.name===o);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,g)=>m.getConfiguration(void 0,o).get(g),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return P.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const o=s();if(o){const g=u.getWorkspaceFolder(o);if(g)return P.normalize(g.uri.fsPath)}}},getSelectedText:()=>{if(v){const o=v.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(v){const o=v.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(F.env))}}let h=class extends R.Disposable{constructor(i,u,v,_,m){super(),this.extensionService=i,this.workspaceService=u,this.editorService=v,this.configurationService=_,this.editorTabs=m,this._resolver=new w.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new p(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=h,e.ExtHostVariableResolverProviderService=h=Ve([He(0,f.IExtHostExtensionService),He(1,D.IExtHostWorkspace),He(2,l.IExtHostDocumentsAndEditors),He(3,E.IExtHostConfiguration),He(4,y.IExtHostEditorTabs)],h)}),define(Te[113],Ae([1,0,12,5,2,4,3,61,35,17,7,33,195,197,34,112]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,F.createDecorator)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,s,o,g,d,k){this._workspaceService=s,this._extensionService=o,this._configurationService=g,this._editorTabs=d,this._variableResolver=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=r.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter,this._onDidChangeStackFrameFocus=new R.Emitter,this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(I=>{I.onDidChange(c=>{this.registerAllDebugTypes(I)}),this.registerAllDebugTypes(I)})}asDebugSourceUri(r,s){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let g=`debug:${encodeURIComponent(o.path||"")}`,d="?";return s&&(g+=`${d}session=${encodeURIComponent(s.id)}`,d="&"),g+=`${d}ref=${o.sourceReference}`,P.URI.parse(g)}else{if(o.path)return P.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const g=o.contributes.debuggers;if(g&&g.length>0)for(const d of g)(0,E.isDebuggerMainContribution)(d)&&s.push(d.type)}this._debugServiceProxy.$registerDebugTypes(s)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){const s=r.filter(d=>{const k=d.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,d),!0)});this.fireBreakpointChanges(s,[],[]);const o=[],g=new Map;for(const d of s)if(d instanceof A.SourceBreakpoint){let k=g.get(d.location.uri.toString());k||(k={type:"sourceMulti",uri:d.location.uri,lines:[]},g.set(d.location.uri.toString(),k),o.push(k)),k.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof A.FunctionBreakpoint&&o.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(r){const s=r.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],s,[]);const o=s.filter(k=>k instanceof A.SourceBreakpoint).map(k=>k.id),g=s.filter(k=>k instanceof A.FunctionBreakpoint).map(k=>k.id),d=s.filter(k=>k instanceof A.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(o,g,d)}startDebugging(r,s,o){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,o){if(!s)return new A.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:g,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,g),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(d=>d.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(r,s,o){if(!o)return new A.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:g,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,g),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(d=>d.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new A.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:o,factory:s}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let o;const g=await this.getFolder(r);return g&&(o={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new _(r.implementation)}createSignService(){}async $startDASession(r,s){const o=this,g=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const k=this.convertToDto(d),I=this.createDebugAdapter(k,g);if(!I)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const c=I;return this._debugAdapters.set(r,c),this.getDebugAdapterTrackers(g).then(S=>(S&&this._debugAdaptersTrackers.set(r,S),c.onMessage(async b=>{if(b.type==="request"&&b.command==="handshake"){const C=b,$={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(C.arguments.value);$.body={signature:N},c.sendResponse($)}else throw new Error("no signer")}catch(N){$.success=!1,$.message=N.message,c.sendResponse($)}}else S&&S.onDidSendMessage&&S.onDidSendMessage(b),b=(0,E.convertToVSCPaths)(b,!0),o._debugServiceProxy.$acceptDAMessage(r,b)}),c.onError(b=>{S&&S.onError&&S.onError(b),this._debugServiceProxy.$acceptDAError(r,b.name,b.message,b.stack)}),c.onExit(b=>{S&&S.onExit&&S.onExit(b??void 0,void 0),this._debugServiceProxy.$acceptDAExit(r,b??void 0,void 0)}),S&&S.onWillStartSession&&S.onWillStartSession(),c.startSession()))})}$sendDAMessage(r,s){s=(0,E.convertToDAPaths)(s,!1);const o=this._debugAdaptersTrackers.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this._debugAdapters.get(r)?.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const o=this._debugAdapters.get(r);return this._debugAdapters.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],o=[],g=[];if(r.added)for(const d of r.added){const k=d.id;if(k&&!this._breakpoints.has(k)){let I;if(d.type==="function")I=new A.FunctionBreakpoint(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")I=new A.DataBreakpoint(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const c=P.URI.revive(d.uri);I=new A.SourceBreakpoint(new A.Location(c,new A.Position(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,A.setBreakpointId)(I,k),this._breakpoints.set(k,I),s.push(I)}}if(r.removed)for(const d of r.removed){const k=this._breakpoints.get(d);k&&(this._breakpoints.delete(d),o.push(k))}if(r.changed){for(const d of r.changed)if(d.id){const k=this._breakpoints.get(d.id);if(k){if(k instanceof A.FunctionBreakpoint&&d.type==="function"){const I=k;I.enabled=d.enabled,I.condition=d.condition,I.hitCondition=d.hitCondition,I.logMessage=d.logMessage,I.functionName=d.functionName}else if(k instanceof A.SourceBreakpoint&&d.type==="source"){const I=k;I.enabled=d.enabled,I.condition=d.condition,I.hitCondition=d.hitCondition,I.logMessage=d.logMessage,I.location=new A.Location(P.URI.revive(d.uri),new A.Position(d.line,d.character))}g.push(k)}}}this.fireBreakpointChanges(s,o,g)}async $acceptStackFrameFocus(r){let s;const o=r.sessionId?await this.getSession(r.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new A.ThreadFocus(o,r.threadId):s=new A.StackFrameFocus(o,r.threadId,r.frameId),this._stackFrameFocus=s,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(r,s,o){return(0,w.asPromise)(async()=>{const g=this.getConfigProviderByHandle(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.getFolder(s);return g.provideDebugConfigurations(d,o)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(r,s,o,g){return(0,w.asPromise)(async()=>{const d=this.getConfigProviderByHandle(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(s);return d.resolveDebugConfiguration(k,o,g)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,o,g){return(0,w.asPromise)(async()=>{const d=this.getConfigProviderByHandle(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(s);return d.resolveDebugConfigurationWithSubstitutedVariables(k,o,g)})}async $provideDebugAdapter(r,s){const o=this.getAdapterDescriptorFactoryByHandle(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(s);return this.getAdapterDescriptor(o,g).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(d)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){(await this.getSession(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const g={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(r){if(r instanceof A.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(o=>o.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(o=>o.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(o=>o.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const g of o)if(g.label&&g.type&&g.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const o=r.configuration.type,g=this._trackerFactories.filter(d=>d.type===o||d.type==="*").map(d=>(0,w.asPromise)(()=>d.factory.createDebugAdapterTracker(r)).then(k=>k,k=>null));return Promise.race([Promise.all(g).then(d=>{const k=d.filter(I=>!!I);if(k.length>0)return new v(k)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async getAdapterDescriptor(r,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new A.DebugAdapterServer(o));if(r){const d=await this._extensionService.getExtensionRegistry();return(0,w.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,d))).then(k=>{if(k)return k})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,g))}daExecutableFromPackage(r,s){}fireBreakpointChanges(r,s,o){(r.length>0||s.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:o}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const o=await this.getFolder(r.folderUri),g=r.parent?this._debugSessions.get(r.parent):void 0;s=new i(this._debugServiceProxy,r.id,r.type,r.name,o,r.configuration,g),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=P.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=t,e.ExtHostDebugServiceBase=t=Ve([He(0,f.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,p.IExtHostConfiguration),He(4,l.IExtHostEditorTabs),He(5,h.IExtHostVariableResolverProvider)],t);class i{constructor(r,s,o,g,d,k,I){this._debugServiceProxy=r,this._id=s,this._type=o,this._name=g,this._workspaceFolder=d,this._configuration=k,this._parentSession=I}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=i;class u{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=u;class v{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(o=>o.onExit?o.onExit(r,s):void 0)}}class _ extends a.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let m=class extends t{constructor(r,s,o,g,d,k){super(r,s,o,g,d,k)}};e.WorkerExtHostDebugService=m,e.WorkerExtHostDebugService=m=Ve([He(0,f.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,p.IExtHostConfiguration),He(4,l.IExtHostEditorTabs),He(5,h.IExtHostVariableResolverProvider)],m)}),define(Te[274],Ae([1,0,11,87,2,3,265,14,70,71,27,173,17,57,35,59]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class t{static async installEarlyHandler(v){Error.stackTraceLimit=100;const _=v.get(l.ILogService),n=v.get(a.IExtHostRpcService).getProxy(F.MainContext.MainThreadErrors);w.setUnexpectedErrorHandler(r=>{_.error(r);const s=w.transformErrorForSerialization(r);n.$onUnexpectedError(s)})}static async installFullHandler(v){const _=v.get(l.ILogService),m=v.get(a.IExtHostRpcService),n=v.get(p.IExtHostExtensionService),r=v.get(h.IExtHostTelemetry),s=m.getProxy(F.MainContext.MainThreadExtensionService),o=m.getProxy(F.MainContext.MainThreadErrors),g=await n.getExtensionPathIndex(),d=new WeakMap;function k(S,b){if(d.has(S))return d.get(S).stack;let C="",$,N;for(const B of b)C+=`
	at ${B.toString()}`,N=B.getFileName(),!$&&N&&($=g.findSubstr(P.URI.file(N)));const H=`${S.name||"Error"}: ${S.message||""}${C}`;return d.set(S,{extensionIdentifier:$?.identifier,stack:H}),H}const I=Symbol("prepareStackTrace wrapped");let c=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return c},set(S){if(S===k||!S||S[I]){c=S||k;return}c=function(b,C){return k(b,C),S.call(Error,b,C)},Object.assign(c,{[I]:!0})}}),w.setUnexpectedErrorHandler(S=>{_.error(S);const b=w.transformErrorForSerialization(S),C=d.get(S);if(!C?.extensionIdentifier){o.$onUnexpectedError(b);return}s.$onExtensionRuntimeError(C.extensionIdentifier,b);const $=r.onExtensionError(C.extensionIdentifier,S);_.trace("forwarded error to extension?",$,C)})}}e.ErrorHandler=t;class i{constructor(v,_,m,n,r){this._hostUtils=m,this._rpcProtocol=new T.RPCProtocol(v,null,n),_=i._transform(_,this._rpcProtocol);const s=new f.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());s.set(A.IExtHostInitDataService,{_serviceBrand:void 0,..._,messagePorts:r}),s.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),s.set(E.IURITransformerService,new E.URITransformerService(n)),s.set(p.IHostUtils,m);const o=new D.InstantiationService(s,!0);o.invokeFunction(t.installEarlyHandler),this._logService=o.invokeFunction(g=>g.get(l.ILogService)),R.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",_),this._extensionService=o.invokeFunction(g=>g.get(p.IExtHostExtensionService)),this._extensionService.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(v){const _=this._rpcProtocol.getProxy(F.MainContext.MainThreadExtensionService);return P.URI.revive(await _.$asBrowserUri(v))}terminate(v){this._extensionService.terminate(v)}static _transform(v,_){v.extensions.allExtensions.forEach(n=>{n.extensionLocation=P.URI.revive(_.transformIncomingURIs(n.extensionLocation))}),v.environment.appRoot=P.URI.revive(_.transformIncomingURIs(v.environment.appRoot));const m=v.environment.extensionDevelopmentLocationURI;return m&&(v.environment.extensionDevelopmentLocationURI=m.map(n=>P.URI.revive(_.transformIncomingURIs(n)))),v.environment.extensionTestsLocationURI=P.URI.revive(_.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=P.URI.revive(_.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=P.URI.revive(_.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=P.URI.revive(_.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=P.URI.revive(_.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=P.URI.revive(_.transformIncomingURIs(v.logsLocation)),v.workspace=_.transformIncomingURIs(v.workspace),v}}e.ExtensionHostMain=i}),define(Te[275],Ae([1,0,18,12,19,37,13,20,24,2,49]),function(be,e,w,R,P,F,T,l,y,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(u,v,_,m){this.query=u,this.provider=v,this.fileUtils=_,this.processType=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,v){const _=this.query.folderQueries||[],m=new P.CancellationTokenSource(v);return new Promise((n,r)=>{this.collector=new E(u);let s=!1;const o=(g,d)=>{if(!s&&!this.isLimitHit){const k=this.resultSize(g);h(g)&&typeof this.query.maxResults=="number"&&this.resultCount+k>this.query.maxResults&&(this.isLimitHit=!0,s=!0,m.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const I=this.resultSize(g);this.resultCount+=I,(I>0||!h(g))&&this.collector.add(g,d)}};Promise.all(_.map((g,d)=>this.searchInFolder(g,k=>o(k,d),m.token))).then(g=>{m.dispose(),this.collector.flush();const d=g.some(k=>!!k&&!!k.limitHit);n({limitHit:this.isLimitHit||d,messages:(0,w.flatten)(g.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.processType}})},g=>{m.dispose();const d=(0,F.toErrorMessage)(g);r(new Error(d))})})}resultSize(u){return h(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,v){const _=Array.isArray(u.ranges)?u.ranges:[u.ranges],m=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:_.slice(0,v),preview:{matches:m.slice(0,v),text:u.preview.text},uri:u.uri}}async searchInFolder(u,v,_){const m=new A.QueryGlobTester(this.query,u),n=[],r={report:g=>{if(!this.validateProviderResult(g))return;const d=u.folder.scheme===T.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(g.uri))):void 0,k=y.relativePath(u.folder,g.uri);if(k){const I=m.includedInQuery(k,l.basename(k),d);(0,R.isThenable)(I)?n.push(I.then(c=>{c&&v(g)})):I&&v(g)}}},s=this.getSearchOptionsForFolder(u),o=await this.provider.provideTextSearchResults(a(this.query.contentPattern),s,r,_);return n.length&&await Promise.all(n),o}validateProviderResult(u){if(h(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const v=(0,A.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),_=(0,A.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),m={folder:f.URI.from(u.folder),excludes:_,includes:v,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return m.usePCRE2=this.query.usePCRE2,m}}e.TextSearchManager=D;function a(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class E{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,v=>this.sendItems(v))}add(u,v){this._currentFileMatch&&(this._currentFolderIdx!==v||!y.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=v,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(p(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=E;function p(i){return h(i)?{preview:{matches:(0,w.mapArrayOrNot)(i.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:i.preview.text},ranges:(0,w.mapArrayOrNot)(i.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function h(i){return!!i.preview}e.extensionResultIsMatch=h;class t{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(u,v){this.maxBatchSize=u,this.cb=v,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,v){u&&this.addItemToBatch(u,v)}addItems(u,v){u&&this.addItemsToBatch(u,v)}addItemToBatch(u,v){this.batch.push(u),this.batchSize+=v,this.onUpdate()}addItemsToBatch(u,v){this.batch=this.batch.concat(u),this.batchSize+=v,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=t}),define(Te[114],Ae([1,0,6,3,4,270,17,57,14,2,275]),function(be,e,w,R,P,F,T,l,y,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let D=class{constructor(h,t,i){this.extHostRpc=h,this._uriTransformer=t,this._logService=i,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new F.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,t){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const i=this._handlePool++;return this._textSearchProvider.set(i,t),this._proxy.$registerTextSearchProvider(i,this._transformScheme(h)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}registerFileSearchProvider(h,t){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const i=this._handlePool++;return this._fileSearchProvider.set(i,t),this._proxy.$registerFileSearchProvider(i,this._transformScheme(h)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(i),this._proxy.$unregisterProvider(i)})}$provideFileSearchResults(h,t,i,u){const v=a(i),_=this._fileSearchProvider.get(h);if(_)return this._fileSearchManager.fileSearch(v,_,m=>{this._proxy.$handleFileMatch(h,t,m.map(n=>n.resource))},u);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,t,i,u){const v=this._textSearchProvider.get(h);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const _=a(i);return this.createTextSearchManager(_,v).search(n=>this._proxy.$handleTextMatch(h,t,n),u)}$enableExtensionHostSearch(){}createTextSearchManager(h,t){return new A.TextSearchManager(h,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.ExtHostSearch=D,e.ExtHostSearch=D=Ve([He(0,T.IExtHostRpcService),He(1,l.IURITransformerService),He(2,y.ILogService)],D);function a(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(E),extraFileResources:p.extraFileResources&&p.extraFileResources.map(h=>f.URI.revive(h))}}e.reviveQuery=a;function E(p){return{...p,folder:f.URI.revive(p.folder)}}}),define(Te[276],Ae([1,0,19,11,5,29,2,135,287,124,133,39,3,78,227,226,31,228,34,230,231,232,207,233,60,35,236,237,242,243,245,109,211,251,252,255,84,63,257,212,8,7,55,260,64,108,33,21,200,241,54,107,111,113,114,14,57,17,27,246,198,86,80,219,258,85,62,263,261,262,220,40,256,259,83,61,59,247,110,248,13,95,210,190,239,6,22,196,81,186,249,250,221,238,209,240,82,253,224,254,225,218,235,222,223]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_,m,n,r,s,o,g,d,k,I,c,S,b,C,$,N,H,B,L,U,ie,X,ye,Pe,De,pe,Se,le,ae,we,Z,z,Y,ee,ve,ge,de,_e,re,ue,ne,oe,fe,ke,O,W,j,K,V,J,ce,Me,$e,Ge,je,Ze,Ye,Je,it,tt,Ue,lt,Q,G,Ee,Be,Ne,Xe,nt,pt,bt,Pt,Vt,qt,Et,xt,Mt,jt,$t,Dt,Ft,Bt,Kt,zt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(at){const ht=at.get(re.IExtHostInitDataService),Tt=at.get(Me.IExtHostFileSystemInfo),Wt=at.get(j.IExtHostConsumerFileSystem),At=at.get(o.IExtHostExtensionService),ot=at.get(Se.IExtHostWorkspace),wt=at.get(Ye.IExtHostTelemetry),Lt=at.get(u.IExtHostConfiguration),kt=at.get(de.IURITransformerService),ze=at.get(_e.IExtHostRpcService),Gt=at.get(H.IExtHostStorage),Ie=at.get(W.IExtensionStoragePaths),Oe=at.get(ge.ILoggerService),me=at.get(ge.ILogService),q=at.get(oe.IExtHostTunnelService),Re=at.get(fe.IExtHostApiDeprecationService),xe=at.get(pe.IExtHostWindow),Ke=at.get(je.IExtHostSecretState),We=at.get(Ze.IExtHostEditorTabs),et=at.get(Mt.IExtHostManagedSockets);ze.set(a.ExtHostContext.ExtHostFileSystemInfo,Tt),ze.set(a.ExtHostContext.ExtHostLogLevelServiceShape,Oe),ze.set(a.ExtHostContext.ExtHostWorkspace,ot),ze.set(a.ExtHostContext.ExtHostConfiguration,Lt),ze.set(a.ExtHostContext.ExtHostExtensionService,At),ze.set(a.ExtHostContext.ExtHostStorage,Gt),ze.set(a.ExtHostContext.ExtHostTunnelService,q),ze.set(a.ExtHostContext.ExtHostWindow,xe),ze.set(a.ExtHostContext.ExtHostSecretState,Ke),ze.set(a.ExtHostContext.ExtHostTelemetry,wt),ze.set(a.ExtHostContext.ExtHostEditorTabs,We),ze.set(a.ExtHostContext.ExtHostManagedSockets,et);const _t=ze.set(a.ExtHostContext.ExtHostDecorations,at.get(z.IExtHostDecorations)),yt=ze.set(a.ExtHostContext.ExtHostDocumentsAndEditors,at.get(s.IExtHostDocumentsAndEditors)),mt=ze.set(a.ExtHostContext.ExtHostCommands,at.get(t.IExtHostCommands)),dt=ze.set(a.ExtHostContext.ExtHostTerminalService,at.get(B.IExtHostTerminalService)),ft=ze.set(a.ExtHostContext.ExtHostDebugService,at.get(ee.IExtHostDebugService)),gi=ze.set(a.ExtHostContext.ExtHostSearch,at.get(ve.IExtHostSearch)),Ct=ze.set(a.ExtHostContext.ExtHostTask,at.get(Y.IExtHostTask)),Ci=ze.set(a.ExtHostContext.ExtHostOutputService,at.get(S.IExtHostOutputService)),li=ze.set(a.ExtHostContext.ExtHostLocalization,at.get(nt.IExtHostLocalizationService)),pi=ze.set(a.ExtHostContext.ExtHostUrls,new Pe.ExtHostUrls(ze)),It=ze.set(a.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(ze,yt)),mn=ze.set(a.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(ze,yt,me)),ri=ze.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(me,It,ze.getProxy(a.MainContext.MainThreadBulkEdits))),St=ze.set(a.ExtHostContext.ExtHostNotebook,new ue.ExtHostNotebookController(ze,mt,yt,It,Wt)),vi=ze.set(a.ExtHostContext.ExtHostNotebookDocuments,new G.ExtHostNotebookDocuments(St)),Ei=ze.set(a.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(me,St)),si=ze.set(a.ExtHostContext.ExtHostNotebookKernels,new Je.ExtHostNotebookKernels(ze,ht,St,mt,me)),Ii=ze.set(a.ExtHostContext.ExtHostNotebookRenderers,new tt.ExtHostNotebookRenderers(ze,St)),ki=ze.set(a.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Et.ExtHostNotebookDocumentSaveParticipant(me,St,ze.getProxy(a.MainContext.MainThreadBulkEdits))),Rt=ze.set(a.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(ze,yt)),bi=ze.set(a.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(ze.getProxy(a.MainContext.MainThreadTreeViews),mt,me)),Pi=ze.set(a.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(ze.getProxy(a.MainContext.MainThreadEditorInsets),Rt,ht.remote)),oi=ze.set(a.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(ze,me,Tt,yt)),ui=ze.set(a.ExtHostContext.ExtHostLanguages,new I.ExtHostLanguages(ze,It,mt.converter,kt)),ct=ze.set(a.ExtHostContext.ExtHostLanguageFeatures,new k.ExtHostLanguageFeatures(ze,kt,It,mt,oi,me,Re,wt)),Ti=ze.set(a.ExtHostContext.ExtHostFileSystem,new g.ExtHostFileSystem(ze,ct)),Yt=ze.set(a.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(ze,me,yt)),ii=ze.set(a.ExtHostContext.ExtHostQuickOpen,(0,C.createExtHostQuickOpen)(ze,ot,mt)),Ai=ze.set(a.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(ze,mt,It,me)),Ri=ze.set(a.ExtHostContext.ExtHostQuickDiff,new Pt.ExtHostQuickDiff(ze,kt)),Oi=ze.set(a.ExtHostContext.ExtHostShare,new jt.ExtHostShare(ze,kt)),Xi=ze.set(a.ExtHostContext.ExtHostComments,(0,i.createExtHostComments)(ze,mt,It)),Fi=ze.set(a.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(ze.getProxy(a.MainContext.MainThreadProgress))),Qi=ze.set(a.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(ze)),Li=ze.set(a.ExtHostContext.ExtHostTheming,new ne.ExtHostTheming(ze)),ai=ze.set(a.ExtHostContext.ExtHostAuthentication,new ke.ExtHostAuthentication(ze)),gn=ze.set(a.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(ze,mt)),Mi=ze.set(a.ExtHostContext.ExtHostWebviews,new De.ExtHostWebviews(ze,ht.remote,ot,me,Re)),di=ze.set(a.ExtHostContext.ExtHostWebviewPanels,new J.ExtHostWebviewPanels(ze,Mi,ot)),Ni=ze.set(a.ExtHostContext.ExtHostCustomEditors,new V.ExtHostCustomEditors(ze,It,Ie,Mi,di)),pn=ze.set(a.ExtHostContext.ExtHostWebviewViews,new K.ExtHostWebviewViews(ze,Mi)),hi=ze.set(a.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(ze,mt,yt)),Yi=ze.set(a.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(ze)),Ui=ze.set(a.ExtHostContext.ExtHostProfileContentHandlers,new bt.ExtHostProfileContentHandlers(ze));ze.set(a.ExtHostContext.ExtHostInteractive,new Ee.ExtHostInteractive(ze,St,yt,mt,me));const Ji=ze.set(a.ExtHostContext.ExtHostInlineChat,new qt.ExtHostInteractiveEditor(ze,mt,It,me)),fi=ze.set(a.ExtHostContext.ExtHostChatProvider,new $t.ExtHostChatProvider(ze,me)),Zi=ze.set(a.ExtHostContext.ExtHostChatAgents,new zt.ExtHostChatAgents(ze,fi,me)),vn=ze.set(a.ExtHostContext.ExtHostChatAgents2,new Ht.ExtHostChatAgents2(ze,fi,me)),xi=ze.set(a.ExtHostContext.ExtHostChatVariables,new Ft.ExtHostChatVariables(ze)),mi=ze.set(a.ExtHostContext.ExtHostChat,new Vt.ExtHostChat(ze,me)),Jt=ze.set(a.ExtHostContext.ExtHostAiRelatedInformation,new Bt.ExtHostRelatedInformation(ze)),wi=ze.set(a.ExtHostContext.ExtHostAiEmbeddingVector,new Kt.ExtHostAiEmbeddingVector(ze)),en=ze.set(a.ExtHostContext.ExtHostIssueReporter,new xt.ExtHostIssueReporter(ze)),Xt=ze.set(a.ExtHostContext.ExtHostStatusBar,new N.ExtHostStatusBar(ze,mt.converter)),Si=ze.set(a.ExtHostContext.ExtHostSpeech,new Dt.ExtHostSpeech(ze)),tn=Object.values(a.ExtHostContext);ze.assertRegistered(tn);const nn=new ce.ExtHostBulkEdits(ze,yt),rn=new h.ExtHostClipboard(ze),_i=new c.ExtHostMessageService(ze,me),sn=new _.ExtHostDialogs(ze);return p.ExtHostApiCommands.register(mt),function(Le,Zt,on){const gt=function(){let te=!Le.isUnderDevelopment;function he(){te||(me.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")he();else{const vt=rt;typeof vt.scheme>"u"&&he(),typeof vt.exclusive=="boolean"&&(0,Ne.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return rt}}(),$i={getSession(te,he,Fe){return ai.getSession(Le,te,he,Fe)},getSessions(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"authGetSessions"),ai.getSessions(Le,te,he)},async hasSession(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"authSession"),!!await ai.getSession(Le,te,he,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(te,he,Fe,rt){return ai.registerAuthenticationProvider(te,he,Fe,rt)}},an={registerCommand(te,he,Fe){return mt.registerCommand(!0,te,he,Fe,void 0,Le)},registerTextEditorCommand(te,he,Fe){return mt.registerCommand(!0,te,(...rt)=>{const vt=Rt.getActiveTextEditor();if(!vt){me.warn("Cannot execute "+te+" because there is no active text editor.");return}return vt.edit(Ot=>{he.apply(Fe,[vt,Ot,...rt])}).then(Ot=>{Ot||me.warn("Edits from command "+te+" were not applied.")},Ot=>{me.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,he,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"diffCommand"),mt.registerCommand(!0,te,async(...rt)=>{const vt=yt.activeEditor(!0);if(!vt){me.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await Rt.getDiffInformation(vt.id);he.apply(Fe,[Ot,...rt])},void 0,void 0,Le)),executeCommand(te,...he){return mt.executeCommand(te,...he)},getCommands(te=!1){return mt.getCommands(te)}},Bi={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return dt.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Le,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.checkProposedApiEnabled)(Le,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.isNewAppInstall)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,he){return Ye.ExtHostTelemetryLogger.validateSender(te),wt.instantiateLogger(Le,te,he)},openExternal(te,he){return xe.openUri(te,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ht.environment.appUriScheme)return pi.createAppUri(te);try{return await xe.asExternalUri(te,{allowTunneling:!!ht.remote.authority})}catch(he){if((0,lt.matchesScheme)(te,Ue.Schemas.http)||(0,lt.matchesScheme)(te,Ue.Schemas.https))return te;throw he}},get remoteName(){return(0,Z.getRemoteName)(ht.remote.authority)},get remoteAuthority(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return me.getLevel()},get onDidChangeLogLevel(){return me.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.checkProposedApiEnabled)(Le,"handleIssueUri"),en.registerIssueUriRequestHandler(Le,te)},registerIssueDataProvider(te){return(0,Ne.checkProposedApiEnabled)(Le,"handleIssueUri"),en.registerIssueDataProvider(Le,te)},get appQuality(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ht.quality},get appCommit(){return(0,Ne.checkProposedApiEnabled)(Le,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(te,he,Fe){return hi.createTestController(Le,te,he,Fe)},createTestObserver(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),hi.createTestObserver()},runTests(te){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),hi.runTests(te)},get onDidChangeTestResults(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Ne.checkProposedApiEnabled)(Le,"testObserver"),hi.results}},yi=ht.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,En={getExtension(te,he){(0,Ne.isProposedApiEnabled)(Le,"extensionsAny")||(he=!1);const Fe=Zt.mine.getExtensionDescription(te);if(Fe)return new o.Extension(At,Le.identifier,Fe,yi,!1);if(he){const rt=Zt.all.getExtensionDescription(te);if(rt)return new o.Extension(At,Le.identifier,rt,yi,!0)}},get all(){const te=[];for(const he of Zt.mine.getAllExtensionDescriptions())te.push(new o.Extension(At,Le.identifier,he,yi,!1));return te},get allAcrossExtensionHosts(){(0,Ne.checkProposedApiEnabled)(Le,"extensionsAny");const te=new le.ExtensionIdentifierSet(Zt.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),he=[];for(const Fe of Zt.all.getAllExtensionDescriptions()){const rt=!te.has(Fe.identifier);he.push(new o.Extension(At,Le.identifier,Fe,yi,rt))}return he},get onDidChange(){return(0,Ne.isProposedApiEnabled)(Le,"extensionsAny")?P.Event.any(Zt.mine.onDidChange,Zt.all.onDidChange):Zt.mine.onDidChange}},ln={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(te,he){return ui.changeLanguage(te.uri,he)},match(te,he){const Fe=It.getDocumentData(he.uri)?.notebook;return(0,A.score)(ie.LanguageSelector.from(te),he.uri,he.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,he,Fe){return ct.registerCodeActionProvider(Le,gt(te),he,Fe)},registerDocumentPasteEditProvider(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,gt(te),he,Fe)},registerCodeLensProvider(te,he){return ct.registerCodeLensProvider(Le,gt(te),he)},registerDefinitionProvider(te,he){return ct.registerDefinitionProvider(Le,gt(te),he)},registerDeclarationProvider(te,he){return ct.registerDeclarationProvider(Le,gt(te),he)},registerImplementationProvider(te,he){return ct.registerImplementationProvider(Le,gt(te),he)},registerTypeDefinitionProvider(te,he){return ct.registerTypeDefinitionProvider(Le,gt(te),he)},registerHoverProvider(te,he){return ct.registerHoverProvider(Le,gt(te),he,Le.identifier)},registerEvaluatableExpressionProvider(te,he){return ct.registerEvaluatableExpressionProvider(Le,gt(te),he,Le.identifier)},registerInlineValuesProvider(te,he){return ct.registerInlineValuesProvider(Le,gt(te),he,Le.identifier)},registerDocumentHighlightProvider(te,he){return ct.registerDocumentHighlightProvider(Le,gt(te),he)},registerLinkedEditingRangeProvider(te,he){return ct.registerLinkedEditingRangeProvider(Le,gt(te),he)},registerReferenceProvider(te,he){return ct.registerReferenceProvider(Le,gt(te),he)},registerRenameProvider(te,he){return ct.registerRenameProvider(Le,gt(te),he)},registerDocumentSymbolProvider(te,he,Fe){return ct.registerDocumentSymbolProvider(Le,gt(te),he,Fe)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,he){return ct.registerDocumentFormattingEditProvider(Le,gt(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return ct.registerDocumentRangeFormattingEditProvider(Le,gt(te),he)},registerOnTypeFormattingEditProvider(te,he,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Le,gt(te),he,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(te,he,Fe){return ct.registerDocumentSemanticTokensProvider(Le,gt(te),he,Fe)},registerDocumentRangeSemanticTokensProvider(te,he,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Le,gt(te),he,Fe)},registerSignatureHelpProvider(te,he,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Le,gt(te),he,Fe):ct.registerSignatureHelpProvider(Le,gt(te),he,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(te,he,...Fe){return ct.registerCompletionItemProvider(Le,gt(te),he,Fe)},registerInlineCompletionItemProvider(te,he,Fe){return he.handleDidShowCompletionItem&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),Fe&&(0,Ne.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,gt(te),he,Fe)},registerDocumentLinkProvider(te,he){return ct.registerDocumentLinkProvider(Le,gt(te),he)},registerColorProvider(te,he){return ct.registerColorProvider(Le,gt(te),he)},registerFoldingRangeProvider(te,he){return ct.registerFoldingRangeProvider(Le,gt(te),he)},registerSelectionRangeProvider(te,he){return ct.registerSelectionRangeProvider(Le,te,he)},registerCallHierarchyProvider(te,he){return ct.registerCallHierarchyProvider(Le,te,he)},registerTypeHierarchyProvider(te,he){return ct.registerTypeHierarchyProvider(Le,te,he)},setLanguageConfiguration:(te,he)=>ct.setLanguageConfiguration(Le,te,he),getTokenInformationAtPosition(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"tokenInformation"),ui.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return ct.registerInlayHintsProvider(Le,te,he)},createLanguageStatusItem(te,he){return ui.createLanguageStatusItem(Le,te,he)},registerDocumentDropEditProvider(te,he,Fe){return ct.registerDocumentOnDropEditProvider(Le,te,he,(0,Ne.isProposedApiEnabled)(Le,"dropMetadata")?Fe:void 0)}},un={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(te,he,Fe){const rt=await(T.URI.isUri(te)?Promise.resolve(Di.openTextDocument(te)):Promise.resolve(te));return Rt.showTextDocument(rt,he,Fe)},createTextEditorDecorationType(te){return Rt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,he,Fe){return Rt.onDidChangeActiveTextEditor(te,he,Fe)},onDidChangeVisibleTextEditors(te,he,Fe){return Rt.onDidChangeVisibleTextEditors(te,he,Fe)},onDidChangeTextEditorSelection(te,he,Fe){return Rt.onDidChangeTextEditorSelection(te,he,Fe)},onDidChangeTextEditorOptions(te,he,Fe){return Rt.onDidChangeTextEditorOptions(te,he,Fe)},onDidChangeTextEditorVisibleRanges(te,he,Fe){return Rt.onDidChangeTextEditorVisibleRanges(te,he,Fe)},onDidChangeTextEditorViewColumn(te,he,Fe){return Rt.onDidChangeTextEditorViewColumn(te,he,Fe)},onDidCloseTerminal(te,he,Fe){return dt.onDidCloseTerminal(te,he,Fe)},onDidOpenTerminal(te,he,Fe){return dt.onDidOpenTerminal(te,he,Fe)},onDidChangeActiveTerminal(te,he,Fe){return dt.onDidChangeActiveTerminal(te,he,Fe)},onDidChangeTerminalDimensions(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalDimensions"),dt.onDidChangeTerminalDimensions(te,he,Fe)},onDidChangeTerminalState(te,he,Fe){return dt.onDidChangeTerminalState(te,he,Fe)},onDidWriteTerminalData(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(te,he,Fe)},onDidExecuteTerminalCommand(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"terminalExecuteCommandEvent"),dt.onDidExecuteTerminalCommand(te,he,Fe)},get state(){return xe.getState(Le)},onDidChangeWindowState(te,he,Fe){return xe.onDidChangeWindowState(te,he,Fe)},showInformationMessage(te,...he){return _i.showMessage(Le,F.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return _i.showMessage(Le,F.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return _i.showMessage(Le,F.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Fe){return ii.showQuickPick(Le,te,he,Fe)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,he){return ii.showInput(te,he)},showOpenDialog(te){return sn.showOpenDialog(Le,te)},showSaveDialog(te){return sn.showSaveDialog(te)},createStatusBarItem(te,he,Fe){let rt,vt,Ot;return typeof te=="string"?(rt=te,vt=he,Ot=Fe):(vt=te,Ot=he),Xt.createStatusBarEntry(Le,rt,vt,Ot)},setStatusBarMessage(te,he){return Xt.setStatusBarMessage(te,he)},withScmProgress(te){return Re.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Fi.withProgress(Le,{location:X.ProgressLocation.SourceControl},(he,Fe)=>te({report(rt){}}))},withProgress(te,he){return Fi.withProgress(Le,te,he)},createOutputChannel(te,he){return Ci.createOutputChannel(te,he,Le)},createWebviewPanel(te,he,Fe,rt){return di.createWebviewPanel(Le,te,he,Fe,rt)},createWebviewTextEditorInset(te,he,Fe,rt){return(0,Ne.checkProposedApiEnabled)(Le,"editorInsets"),Pi.createWebviewEditorInset(te,he,Fe,rt,Le)},createTerminal(te,he,Fe){return typeof te=="object"?"pty"in te?dt.createExtensionTerminal(te):dt.createTerminalFromOptions(te):dt.createTerminal(te,he,Fe)},registerTerminalLinkProvider(te){return dt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return dt.registerProfileProvider(Le,te,he)},registerTerminalQuickFixProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(te,Le.identifier.value,he)},registerTreeDataProvider(te,he){return bi.registerTreeDataProvider(te,he,Le)},createTreeView(te,he){return bi.createTreeView(te,he,Le)},registerWebviewPanelSerializer:(te,he)=>di.registerWebviewPanelSerializer(Le,te,he),registerCustomEditorProvider:(te,he,Fe={})=>Ni.registerCustomEditorProvider(Le,te,he,Fe),registerFileDecorationProvider(te){return _t.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return pi.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(te,he,Fe){return Li.onDidChangeActiveColorTheme(te,he,Fe)},registerWebviewViewProvider(te,he,Fe){return pn.registerWebviewViewProvider(Le,te,he,Fe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Fe){return St.onDidChangeActiveNotebookEditor(te,he,Fe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Fe){return Ei.onDidChangeNotebookEditorSelection(te,he,Fe)},onDidChangeNotebookEditorVisibleRanges(te,he,Fe){return Ei.onDidChangeNotebookEditorVisibleRanges(te,he,Fe)},showNotebookDocument(te,he){return St.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"externalUriOpener"),Yi.registerExternalUriOpener(Le.identifier,te,he,Fe)},registerProfileContentHandler(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"profileContentHandlers"),Ui.registrProfileContentHandler(Le,te,he)},registerQuickDiffProvider(te,he,Fe,rt){return(0,Ne.checkProposedApiEnabled)(Le,"quickDiffProvider"),Ri.registerQuickDiffProvider(gt(te),he,Fe,rt)},get tabGroups(){return We.tabGroups},registerShareProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"shareProvider"),Oi.registerShareProvider(gt(te),he)}},Di={get rootPath(){return Re.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw new R.ReadonlyError("rootPath")},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw new R.ReadonlyError("name")},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw new R.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(te,he,...Fe)=>ot.updateWorkspaceFolders(Le,te,he||0,...Fe),onDidChangeWorkspaceFolders:function(te,he,Fe){return ot.onDidChangeWorkspace(te,he,Fe)},asRelativePath:(te,he)=>ot.getRelativePath(te,he),findFiles:(te,he,Fe,rt)=>ot.findFiles(te,he,Fe,Le.identifier,rt),findTextInFiles:(te,he,Fe,rt)=>{(0,Ne.checkProposedApiEnabled)(Le,"findTextInFiles");let vt,Ot;return typeof he=="object"?(vt=he,Ot=Fe):(vt={},Ot=he,rt=Fe),ot.findTextInFiles(te,vt||{},Ot,Le.identifier,rt)},save:te=>((0,Ne.checkProposedApiEnabled)(Le,"saveEditor"),ot.save(te)),saveAs:te=>((0,Ne.checkProposedApiEnabled)(Le,"saveEditor"),ot.saveAs(te)),saveAll:te=>ot.saveAll(te),applyEdit(te,he){return nn.applyWorkspaceEdit(te,Le,he)},createFileSystemWatcher:(te,he,Fe,rt)=>{let vt;return typeof he=="boolean"?vt={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:he&&((0,Ne.checkProposedApiEnabled)(Le,"createFileSystemWatcher"),vt={...he,correlate:!0}),Yt.createFileSystemWatcher(ot,Le,te,vt)},get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new R.ReadonlyError("textDocuments")},openTextDocument(te){let he;const Fe=te;if(typeof te=="string")he=Promise.resolve(T.URI.file(te));else if(T.URI.isUri(te))he=Promise.resolve(te);else if(!Fe||typeof Fe=="object")he=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>It.ensureDocumentData(rt).then(vt=>vt.document))},onDidOpenTextDocument:(te,he,Fe)=>It.onDidAddDocument(te,he,Fe),onDidCloseTextDocument:(te,he,Fe)=>It.onDidRemoveDocument(te,he,Fe),onDidChangeTextDocument:(te,he,Fe)=>It.onDidChangeDocument(te,he,Fe),onDidSaveTextDocument:(te,he,Fe)=>It.onDidSaveDocument(te,he,Fe),onWillSaveTextDocument:(te,he,Fe)=>ri.getOnWillSaveTextDocumentEvent(Le)(te,he,Fe),get notebookDocuments(){return St.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Fe;if(T.URI.isUri(te))Fe=te,await St.openNotebookDocument(te);else if(typeof te=="string")Fe=T.URI.revive(await St.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,he,Fe){return vi.onDidSaveNotebookDocument(te,he,Fe)},onDidChangeNotebookDocument(te,he,Fe){return vi.onDidChangeNotebookDocument(te,he,Fe)},onWillSaveNotebookDocument(te,he,Fe){return ki.getOnWillSaveNotebookDocumentEvent(Le)(te,he,Fe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Fe,rt){return St.registerNotebookSerializer(Le,te,he,Fe,(0,Ne.isProposedApiEnabled)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,he,Fe)=>on.onDidChangeConfiguration(te,he,Fe),getConfiguration(te,he){return he=arguments.length===1?void 0:he,on.getConfiguration(te,he,Le)},registerTextDocumentContentProvider(te,he){return mn.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(Re.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Le,te,he)),registerFileSystemProvider(te,he,Fe){return(0,Be.combinedDisposable)(Ti.registerFileSystemProvider(Le,te,he,Fe),Wt.addFileSystemProvider(te,he,Fe))},get fs(){return Wt.value},registerFileSearchProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"fileSearchProvider"),gi.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"textSearchProvider"),gi.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),At.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),Qi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.checkProposedApiEnabled)(Le,"resolvers"),At.getRemoteExecServer(te)),onDidCreateFiles:(te,he,Fe)=>Yt.onDidCreateFile(te,he,Fe),onDidDeleteFiles:(te,he,Fe)=>Yt.onDidDeleteFile(te,he,Fe),onDidRenameFiles:(te,he,Fe)=>Yt.onDidRenameFile(te,he,Fe),onWillCreateFiles:(te,he,Fe)=>Yt.getOnWillCreateFileEvent(Le)(te,he,Fe),onWillDeleteFiles:(te,he,Fe)=>Yt.getOnWillDeleteFileEvent(Le)(te,he,Fe),onWillRenameFiles:(te,he,Fe)=>Yt.getOnWillRenameFileEvent(Le)(te,he,Fe),openTunnel:te=>((0,Ne.checkProposedApiEnabled)(Le,"tunnels"),q.openTunnel(Le,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ne.checkProposedApiEnabled)(Le,"tunnels"),q.getTunnels()},onDidChangeTunnels:(te,he,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"tunnels"),q.onDidChangeTunnels(te,he,Fe)),registerPortAttributesProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"portsAttributes"),q.registerPortsAttributesProvider(te,he)),registerTunnelProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"tunnelFactory"),q.registerTunnelProvider(te,he)),registerTimelineProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"timeline"),gn.registerTimelineProvider(te,he,Le.identifier,mt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>((0,Ne.checkProposedApiEnabled)(Le,"workspaceTrust"),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Fe)=>ot.onDidGrantWorkspaceTrust(te,he,Fe),registerEditSessionIdentityProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(te,he)),onWillCreateEditSessionIdentity:(te,he,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Le)(te,he,Fe)),registerCanonicalUriProvider:(te,he)=>((0,Ne.checkProposedApiEnabled)(Le,"canonicalUriProvider"),ot.registerCanonicalUriProvider(te,he)),getCanonicalUri:(te,he,Fe)=>((0,Ne.checkProposedApiEnabled)(Le,"canonicalUriProvider"),ot.provideCanonicalUri(te,he,Fe))},zi={get inputBox(){return Re.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ai.getLastInputBox(Le)},createSourceControl(te,he,Fe){return Ai.createSourceControl(Le,te,he,Fe)}},Hi={createCommentController(te,he){return Xi.createCommentController(Le,te,he)}},ci={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(te,he,Fe){return ft.onDidStartDebugSession(te,he,Fe)},onDidTerminateDebugSession(te,he,Fe){return ft.onDidTerminateDebugSession(te,he,Fe)},onDidChangeActiveDebugSession(te,he,Fe){return ft.onDidChangeActiveDebugSession(te,he,Fe)},onDidReceiveDebugSessionCustomEvent(te,he,Fe){return ft.onDidReceiveDebugSessionCustomEvent(te,he,Fe)},onDidChangeBreakpoints(te,he,Fe){return ft.onDidChangeBreakpoints(te,he,Fe)},onDidChangeStackFrameFocus(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"debugFocus"),ft.onDidChangeStackFrameFocus(te,he,Fe)},registerDebugConfigurationProvider(te,he,Fe){return ft.registerDebugConfigurationProvider(te,he,Fe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return ft.registerDebugAdapterDescriptorFactory(Le,te,he)},registerDebugAdapterTrackerFactory(te,he){return ft.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ft.startDebugging(te,he,{parentSession:Fe}):ft.startDebugging(te,he,Fe||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,he){return ft.asDebugSourceUri(te,he)}},Wi={registerTaskProvider:(te,he)=>Ct.registerTaskProvider(Le,te,he),fetchTasks:te=>Ct.fetchTasks(te),executeTask:te=>Ct.executeTask(Le,te),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(te,he,Fe)=>Ct.onDidStartTask(te,he,Fe),onDidEndTask:(te,he,Fe)=>Ct.onDidEndTask(te,he,Fe),onDidStartTaskProcess:(te,he,Fe)=>Ct.onDidStartTaskProcess(te,he,Fe),onDidEndTaskProcess:(te,he,Fe)=>Ct.onDidEndTaskProcess(te,he,Fe)},Vi={createNotebookController(te,he,Fe,rt,vt){return si.createNotebookController(Le,te,he,Fe,rt,(0,Ne.isProposedApiEnabled)(Le,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>St.registerNotebookCellStatusBarItemProvider(Le,te,he),createRendererMessaging(te){return Ii.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Ne.checkProposedApiEnabled)(Le,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"notebookKernelSource"),si.registerKernelSourceActionProvider(Le,te,he)},onDidChangeNotebookCellExecutionState(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,he,Fe)}},qi={t(...te){if(typeof te[0]=="string"){const he=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return li.getMessage(Le.identifier.value,{message:he,args:Fe})}return li.getMessage(Le.identifier.value,te[0])},get bundle(){return li.getBundle(Le.identifier.value)},get uri(){return li.getBundleUri(Le.identifier.value)}},ji={_version:1,registerInteractiveEditorSessionProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),Ji.registerProvider(Le,te,he={label:he?.label??Le.displayName??Le.name})},registerInteractiveSessionProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),mi.registerChatProvider(Le,te,he)},sendInteractiveRequestToProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),mi.sendInteractiveRequestToProvider(te,he)},get onDidPerformUserAction(){return(0,Ne.checkProposedApiEnabled)(Le,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"interactive"),mi.transferChatSession(te,he)}},dn={getRelatedInformation(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),Jt.getRelatedInformation(Le,te,he)},registerRelatedInformationProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),Jt.registerRelatedInformationProvider(Le,te,he)},registerEmbeddingVectorProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Le,te,he)}},hn={registerChatResponseProvider(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatProvider"),fi.registerProvider(Le.identifier,te,he,Fe)},requestChatAccess(te){return(0,Ne.checkProposedApiEnabled)(Le,"chatRequestAccess"),fi.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatVariables"),xi.registerVariableResolver(Le,te,he,Fe)},registerMappedEditsProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,te,he)},createChatAgent(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"chatAgents2"),vn.createChatAgent(Le,te,he)},registerAgent(te,he,Fe){return(0,Ne.checkProposedApiEnabled)(Le,"chatAgents"),Zi.registerAgent(Le.identifier,te,he,Fe)}},fn={registerSpeechProvider(te,he){return(0,Ne.checkProposedApiEnabled)(Le,"speech"),Si.registerProvider(Le.identifier,te,he)}};return{version:ht.version,ai:dn,authentication:$i,commands:an,comments:Hi,chat:hn,debug:ci,env:Bi,extensions:En,interactive:ji,l10n:qi,languages:ln,notebooks:Vi,scm:zi,speech:fn,tasks:Wi,tests:cn,window:un,workspace:Di,Breakpoint:X.Breakpoint,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatAgentResultFeedbackKind:X.ChatAgentResultFeedbackKind,ChatMessage:X.ChatMessage,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.CallHierarchyIncomingCall,CallHierarchyItem:X.CallHierarchyItem,CallHierarchyOutgoingCall:X.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:w.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:X.CodeAction,CodeActionKind:X.CodeActionKind,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.CodeLens,Color:X.Color,ColorInformation:X.ColorInformation,ColorPresentation:X.ColorPresentation,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.CompletionItem,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.CompletionList,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.CustomExecution,DebugAdapterExecutable:X.DebugAdapterExecutable,DebugAdapterInlineImplementation:X.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:X.DebugAdapterNamedPipeServer,DebugAdapterServer:X.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.Diagnostic,DiagnosticRelatedInformation:X.DiagnosticRelatedInformation,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.Disposable,DocumentHighlight:X.DocumentHighlight,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.DocumentLink,DocumentSymbol:X.DocumentSymbol,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.EvaluatableExpression,InlineValueText:X.InlineValueText,InlineValueVariableLookup:X.InlineValueVariableLookup,InlineValueEvaluatableExpression:X.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:P.Emitter,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.FileDecoration,FileDecoration2:X.FileDecoration,FileSystemError:X.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:X.FoldingRange,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.FunctionBreakpoint,InlineCompletionItem:X.InlineSuggestion,InlineCompletionList:X.InlineSuggestionList,Hover:X.Hover,IndentAction:f.IndentAction,Location:X.Location,MarkdownString:X.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:X.ParameterInformation,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.Position,ProcessExecution:X.ProcessExecution,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.QuickInputButtons,Range:X.Range,RelativePattern:X.RelativePattern,Selection:X.Selection,SelectionRange:X.SelectionRange,SemanticTokens:X.SemanticTokens,SemanticTokensBuilder:X.SemanticTokensBuilder,SemanticTokensEdit:X.SemanticTokensEdit,SemanticTokensEdits:X.SemanticTokensEdits,SemanticTokensLegend:X.SemanticTokensLegend,ShellExecution:X.ShellExecution,ShellQuoting:X.ShellQuoting,SignatureHelp:X.SignatureHelp,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.SignatureInformation,SnippetString:X.SnippetString,SourceBreakpoint:X.SourceBreakpoint,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.SymbolInformation,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.Task,TaskGroup:X.TaskGroup,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.TerminalLink,TerminalQuickFixExecuteTerminalCommand:X.TerminalQuickFixCommand,TerminalQuickFixOpener:X.TerminalQuickFixOpener,TerminalLocation:X.TerminalLocation,TerminalProfile:X.TerminalProfile,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.TextEdit,SnippetTextEdit:X.SnippetTextEdit,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.ThemeColor,ThemeIcon:X.ThemeIcon,TreeItem:X.TreeItem,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.TypeHierarchyItem,UIKind:E.UIKind,Uri:T.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.WorkspaceEdit,DocumentDropEdit:X.DocumentDropEdit,DocumentPasteEdit:X.DocumentPasteEdit,InlayHint:X.InlayHint,InlayHintLabelPart:X.InlayHintLabelPart,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.RemoteAuthorityResolverError,ResolvedAuthority:X.ResolvedAuthority,ManagedResolvedAuthority:X.ManagedResolvedAuthority,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.TimelineItem,NotebookRange:X.NotebookRange,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.NotebookCellData,NotebookData:X.NotebookData,NotebookRendererScript:X.NotebookRendererScript,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.NotebookCellOutput,NotebookCellOutputItem:X.NotebookCellOutputItem,NotebookCellStatusBarItem:X.NotebookCellStatusBarItem,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.NotebookEdit,NotebookKernelSourceAction:X.NotebookKernelSourceAction,PortAttributes:X.PortAttributes,LinkedEditingRanges:X.LinkedEditingRanges,TestResultState:X.TestResultState,TestRunRequest:X.TestRunRequest,TestMessage:X.TestMessage,TestMessage2:X.TestMessage,TestTag:X.TestTag,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.DataTransfer,DataTransferItem:X.DataTransferItem,CoveredCount:X.CoveredCount,FileCoverage:X.FileCoverage,StatementCoverage:X.StatementCoverage,BranchCoverage:X.BranchCoverage,FunctionCoverage:X.FunctionCoverage,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.TextTabInput,TabInputTextDiff:X.TextDiffTabInput,TabInputTextMerge:X.TextMergeTabInput,TabInputCustom:X.CustomEditorTabInput,TabInputNotebook:X.NotebookEditorTabInput,TabInputNotebookDiff:X.NotebookDiffEditorTabInput,TabInputWebview:X.WebviewEditorTabInput,TabInputTerminal:X.TerminalEditorTabInput,TabInputInteractiveWindow:X.InteractiveWindowInput,TelemetryTrustedValue:ye.TelemetryTrustedValue,LogLevel:ge.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.StackFrameFocus,ThreadFocus:X.ThreadFocus,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus}}}e.createApiFactoryAndRegisterActors=Nt}),define(Te[277],Ae([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,40,83,59,61,244,14,112,81,82]),function(be,e,w,R,P,F,T,l,y,f,A,D,a,E,p,h,t,i,u,v,_,m,n,r,s,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,w.registerSingleton)(r.ILoggerService,n.ExtHostLoggerService,1),(0,w.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService,1),(0,w.registerSingleton)(l.IExtHostCommands,l.ExtHostCommands,0),(0,w.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,w.registerSingleton)(i.IExtHostConsumerFileSystem,i.ExtHostConsumerFileSystem,0),(0,w.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,w.registerSingleton)(F.IExtHostDecorations,F.ExtHostDecorations,0),(0,w.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,w.registerSingleton)(g.IExtHostManagedSockets,g.ExtHostManagedSockets,0),(0,w.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo,0),(0,w.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService,1),(0,w.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch,0),(0,w.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,w.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,0),(0,w.registerSingleton)(f.IExtHostTerminalService,f.WorkerExtHostTerminalService,0),(0,w.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,0),(0,w.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,w.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace,0),(0,w.registerSingleton)(v.IExtHostSecretState,v.ExtHostSecretState,0),(0,w.registerSingleton)(_.IExtHostTelemetry,_.ExtHostTelemetry,0),(0,w.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs,0),(0,w.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(Te[278],Ae([1,0,276,35,2,273,7,12,264]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends F.RequireInterceptor{_installInterceptor(){}getModule(E,p){for(const h of this._alternatives){const t=h(E);if(t){E=t;break}}if(this._factories.has(E))return this._factories.get(E).load(E,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends R.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(f,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,p,h){p=p.with({path:D(p.path,".js")});const t=E?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(p)),u=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),u.status!==200)throw new Error(u.statusText);const v=await u.text(),_=`${p.toString(!0)}#vscode-extension`,m=`${v}
//# sourceURL=${_}`;let n;try{n=new Function("module","exports","require",m)}catch(g){throw console.error(t?`Loading code for extension ${t} failed: ${g.message}`:`Loading code failed: ${g.message}`),console.error(`${p.toString(!0)}${typeof g.line=="number"?` line ${g.line}`:""}${typeof g.column=="number"?` column ${g.column}`:""}`),console.error(g),g}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const r={},s={exports:r},o=g=>{const d=this._fakeModules.getModule(g,p);if(d===void 0)throw new Error(`Cannot load module '${g}'`);return d};try{return h.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,r,o),s.exports!==r?s.exports:r}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),h.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+E;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,l.timeout)(10)}}e.ExtHostExtensionService=A;function D(a,E){return a.endsWith(E)?a:a+E}}),define(Te[279],Ae([1,0,69,70,14,35,188,85,278]),function(be,e,w,R,P,F,T,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.registerSingleton)(P.ILogService,new w.SyncDescriptor(T.ExtHostLogService,[!0],!0)),(0,R.registerSingleton)(F.IExtHostExtensionService,y.ExtHostExtensionService,0),(0,R.registerSingleton)(l.IExtensionStoragePaths,l.ExtensionStoragePaths,0)}),define(Te[288],Ae([1,0,26,5,78,274,266,20,87,13,2,277,279]),function(be,e,w,R,P,F,T,l,y,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(n){return/^(file|vscode-remote):/i.test(n)}const p=fetch.bind(self);function h(n){self.fetch=async function(r,s){return r instanceof Request||E(String(r))&&(r=(await n(A.URI.parse(String(r)))).toString(!0)),p(r,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,s,o,g,d){(async()=>(E(s.toString())&&(s=(await n(A.URI.parse(s.toString()))).toString(!0)),super.open(r,s,o??!0,g,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(r,s){if(/^file:/i.test(r.toString()))r=f.FileAccess.uriToBrowserUri(A.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const g=`(${function(c){function S($){return typeof $=="string"||$ instanceof URL?String($).replace(/^file:\/\//i,"vscode-file://vscode-app"):$}const b=fetch.bind(self);self.fetch=function($,N){return $ instanceof Request?b($,N):b(S($),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open($,N,H,B,L){return super.open($,S(N),H??!0,B,L)}};const C=importScripts.bind(self);self.importScripts=(...$)=>{C(...$.map(S))},C(c)}.toString()}('${r}'))`;s=s||{},s.name=s.name||l.basename(r.toString());const d=new Blob([g],{type:"application/javascript"}),k=URL.createObjectURL(d);return new n(k,s)}}else self.Worker=class extends T.NestedWorker{constructor(n,r){super(a,n,{name:l.basename(n.toString()),...r})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const r=new MessageChannel,s=new R.Emitter;let o=!1;a(r.port2,[r.port2]),r.port1.onmessage=g=>{const{data:d}=g;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const k=w.VSBuffer.wrap(new Uint8Array(d,0,d.byteLength));if((0,P.isMessageOfType)(k,2)){o=!0,v("received terminate message from renderer");return}s.fire(k)},this.protocol={onMessage:s.event,send:g=>{if(!o){const d=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);r.port1.postMessage(d,[d])}}}}}function u(n){return new Promise(r=>{const s=n.onMessage(o=>{s.dispose();const g=JSON.parse(o.toString());n.send((0,P.createMessageOfType)(0)),r({protocol:n,initData:g})});n.send((0,P.createMessageOfType)(1))})}let v=n=>D();function _(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function m(){y.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(r){_(r)&&u(n.protocol).then(s=>{y.mark("code/extHost/didWaitForInitData");const o=new F.ExtensionHostMain(s.protocol,s.initData,t,null,r.data);h(g=>o.asBrowserUri(g)),v=g=>o.terminate(g)})}}}e.create=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dd29bdcb71634f9cd7c1792bb2bdfde5b18ee8e8/core/vs/workbench/api/worker/extensionHostWorker.js.map
