/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],j=function(B){for(var e=[],P=0,y=B.length;P<y;P++)e[P]=W[B[P]];return e};define(W[21],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class P{static get(){const k=new Map,L=new Map,r=new Map,h=new Map;function t(d,n){d.has(n.detail)||d.set(n.detail,-n.timestamp)}function s(d,n){const i=d.get(n.detail);i&&(i>=0||d.set(n.detail,i+n.timestamp))}let o=[];typeof B=="function"&&typeof B.getStats=="function"&&(o=B.getStats().slice(0).sort((d,n)=>d.timestamp-n.timestamp));for(const d of o)switch(d.type){case 10:t(k,d);break;case 11:case 12:s(k,d);break;case 21:t(L,d);break;case 22:s(L,d);break;case 33:t(r,d);break;case 34:s(r,d);break;case 31:t(h,d);break;case 32:s(h,d);break}let u=0;r.forEach(d=>u+=d);function g(d){const n=[];return d.forEach((i,a)=>n.push([a,i])),n}return{amdLoad:g(k),amdInvoke:g(L),nodeRequire:g(r),nodeEval:g(h),nodeRequireTotal:u}}static toMarkdownTable(k,L){let r="";const h=[];return k.forEach((t,s)=>{h[s]=t.length}),L.forEach(t=>{t.forEach((s,o)=>{typeof s>"u"&&(s=t[o]="-");const u=s.toString().length;h[o]=Math.max(u,h[o])})}),k.forEach((t,s)=>{r+=`| ${t+" ".repeat(h[s]-t.toString().length)} `}),r+=`|
`,k.forEach((t,s)=>{r+=`| ${"-".repeat(h[s])} `}),r+=`|
`,L.forEach(t=>{t.forEach((s,o)=>{typeof s<"u"&&(r+=`| ${s+" ".repeat(h[o]-s.toString().length)} `)}),r+=`|
`}),r}}e.LoaderStats=P}),define(W[4],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let P;function y(i){P=i}e.setLogger=y;function k(){return P}e.getLogger=k;class L{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(a){return r([h(d("|  ",this.indentation)),a])}formatInfo(a){return a.hadValue?a.didChange?[h(" "),s(o(a.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),s(o(a.newValue,60),{color:"green"})]:[h(" (unchanged)")]:[h(" "),s(o(a.newValue,60),{color:"green"}),h(" (initial)")]}handleObservableChanged(a,v){console.log(...this.textToConsoleArgs([t("observable value changed"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(v)]))}formatChanges(a){if(a.size!==0)return s(" (changed deps: "+[...a].map(v=>v.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const v=a.handleChange;this.changedObservablesSets.set(a,new Set),a.handleChange=(C,D)=>(this.changedObservablesSets.get(a).add(C),v.apply(a,[C,D]))}handleDerivedRecomputed(a,v){const C=this.changedObservablesSets.get(a);console.log(...this.textToConsoleArgs([t("derived recomputed"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(v),this.formatChanges(C),{data:[{fn:a._computeFn}]}])),C.clear()}handleFromEventObservableTriggered(a,v){console.log(...this.textToConsoleArgs([t("observable from event triggered"),s(a.debugName,{color:"BlueViolet"}),...this.formatInfo(v),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const v=a.handleChange;this.changedObservablesSets.set(a,new Set),a.handleChange=(C,D)=>(this.changedObservablesSets.get(a).add(C),v.apply(a,[C,D]))}handleAutorunTriggered(a){const v=this.changedObservablesSets.get(a);console.log(...this.textToConsoleArgs([t("autorun"),s(a.debugName,{color:"BlueViolet"}),this.formatChanges(v),{data:[{fn:a._runFn}]}])),v.clear(),this.indentation++}handleAutorunFinished(a){this.indentation--}handleBeginTransaction(a){let v=a.getDebugName();v===void 0&&(v=""),console.log(...this.textToConsoleArgs([t("transaction"),s(v,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=L;function r(i){const a=new Array,v=[];let C="";function D(w){if("length"in w)for(const m of w)m&&D(m);else"text"in w?(C+=`%c${w.text}`,a.push(w.style),w.data&&v.push(...w.data)):"data"in w&&v.push(...w.data)}D(i);const A=[C,...a];return A.push(...v),A}function h(i){return s(i,{color:"black"})}function t(i){return s(n(`${i}: `,10),{color:"black",bold:!0})}function s(i,a={color:"black"}){function v(D){return Object.entries(D).reduce((A,[w,m])=>`${A}${w}:${m};`,"")}const C={color:a.color};return a.strikeThrough&&(C["text-decoration"]="line-through"),a.bold&&(C["font-weight"]="bold"),{text:i,style:v(C)}}function o(i,a){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=a?`"${i}"`:`"${i.substr(0,a-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?u(i,a):g(i,a);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function u(i,a){let v="[ ",C=!0;for(const D of i){if(C||(v+=", "),v.length-5>a){v+="...";break}C=!1,v+=`${o(D,a-v.length)}`}return v+=" ]",v}function g(i,a){let v="{ ",C=!0;for(const[D,A]of Object.entries(i)){if(C||(v+=", "),v.length-5>a){v+="...";break}C=!1,v+=`${D}: ${o(A,a-v.length)}`}return v+=" }",v}function d(i,a){let v="";for(let C=1;C<=a;C++)v+=i;return v}function n(i,a){for(;i.length<a;)i+=" ";return i}}),define(W[5],j([0,1,4]),function(B,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.getDebugName=e.TransactionImpl=e.subtransaction=e.asyncTransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerivedOpts=void 0;let y;function k(f){y=f}e._setDerivedOpts=k;class L{get TChange(){return null}reportChanges(){this.get()}read(_){return _?_.readObservable(this):this.get()}map(_,I){const c=I===void 0?void 0:_,E=I===void 0?_:I;return y({owner:c,debugName:()=>{const R=D(E);if(R!==void 0)return R;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(O)return`${this.debugName}.${O[2]}`;if(!c)return`${this.debugName} (mapped)`}},R=>E(this.read(R),R))}}e.ConvenientObservable=L;class r extends L{constructor(){super(...arguments),this.observers=new Set}addObserver(_){const I=this.observers.size;this.observers.add(_),I===0&&this.onFirstObserverAdded()}removeObserver(_){this.observers.delete(_)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=r;function h(f,_){const I=new o(f,_);try{f(I)}finally{I.finish()}}e.transaction=h;async function t(f,_){const I=new o(f,_);try{await f(I)}finally{I.finish()}}e.asyncTransaction=t;function s(f,_,I){f?_(f):h(_,I)}e.subtransaction=s;class o{constructor(_,I){this._fn=_,this._getDebugName=I,this.updatingObservers=[],(0,P.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():D(this._fn)}updateObserver(_,I){this.updatingObservers.push({observer:_,observable:I}),_.beginUpdate(I)}finish(){const _=this.updatingObservers;this.updatingObservers=null;for(const{observer:I,observable:c}of _)I.endUpdate(c);(0,P.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=o;const u=new Map,g=new WeakMap;function d(f,_,I,c,E){const R=g.get(f);if(R)return R;const U=n(f,_,I,c,E);if(U){let O=u.get(U)??0;O++,u.set(U,O);const b=O===1?U:`${U}#${O}`;return g.set(f,b),b}}e.getDebugName=d;function n(f,_,I,c,E){const R=g.get(f);if(R)return R;const U=c?v(c)+".":"";let O;if(_!==void 0)if(typeof _=="function"){if(O=_(),O!==void 0)return U+O}else return U+_;if(I!==void 0&&(O=D(I),O!==void 0))return U+O;if(c!==void 0){for(const b in c)if(c[b]===E)return U+b}}const i=new Map,a=new WeakMap;function v(f){const _=a.get(f);if(_)return _;const I=C(f);let c=i.get(I)??0;c++,i.set(I,c);const E=c===1?I:`${I}#${c}`;return a.set(f,E),E}function C(f){const _=f.constructor;return _?_.name:"Object"}function D(f){const _=f.toString(),c=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(_);return(c?c[1]:void 0)?.trim()}e.getFunctionName=D;function A(f,_){return typeof f=="string"?new w(void 0,f,_):new w(f,void 0,_)}e.observableValue=A;class w extends r{get debugName(){return d(this,this._debugName,void 0,this._owner,this)??"ObservableValue"}constructor(_,I,c){super(),this._owner=_,this._debugName=I,this._value=c}get(){return this._value}set(_,I,c){if(this._value===_)return;let E;I||(I=E=new o(()=>{},()=>`Setting ${this.debugName}`));try{const R=this._value;this._setValue(_),(0,P.getLogger)()?.handleObservableChanged(this,{oldValue:R,newValue:_,change:c,didChange:!0,hadValue:!0});for(const U of this.observers)I.updateObserver(U,this),U.handleChange(this,c)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(_){this._value=_}}e.ObservableValue=w;function m(f,_){return typeof f=="string"?new T(void 0,f,_):new T(f,void 0,_)}e.disposableObservableValue=m;class T extends w{_setValue(_){this._value!==_&&(this._value&&this._value.dispose(),this._value=_)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=T}),define(W[9],j([0,1,42,2,5,4]),function(B,e,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunHandleChanges=e.autorun=e.autorunOpts=void 0;function r(n,i){return new g(n.debugName,i,void 0,void 0)}e.autorunOpts=r;function h(n){return new g(void 0,n,void 0,void 0)}e.autorun=h;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.autorunHandleChanges=t;function s(n,i){const a=new y.DisposableStore,v=t({debugName:n.debugName??(()=>(0,k.getFunctionName)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(C,D)=>{a.clear(),i(C,D,a)});return(0,y.toDisposable)(()=>{v.dispose(),a.dispose()})}e.autorunWithStoreHandleChanges=s;function o(n){const i=new y.DisposableStore,a=r({debugName:()=>(0,k.getFunctionName)(n)||"(anonymous)"},v=>{i.clear(),n(v,i)});return(0,y.toDisposable)(()=>{a.dispose(),i.dispose()})}e.autorunWithStore=o;var u;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(u||(u={}));class g{get debugName(){if(typeof this._debugName=="string")return this._debugName;if(typeof this._debugName=="function"){const a=this._debugName();if(a!==void 0)return a}const i=(0,k.getFunctionName)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,a,v,C){this._debugName=i,this._runFn=a,this.createChangeSummary=v,this._handleChange=C,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,L.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,y.trackDisposable)(this)}dispose(){this.disposed=!0;for(const i of this.dependencies)i.removeObserver(this);this.dependencies.clear(),(0,y.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const i=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=i,this.state=3;try{if(!this.disposed){(0,L.getLogger)()?.handleAutorunTriggered(this);const a=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,a)}}finally{(0,L.getLogger)()?.handleAutorunFinished(this);for(const a of this.dependenciesToBeRemoved)a.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const i of this.dependencies)if(i.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,P.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(i){this.state===3&&this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(this.state=1)}handleChange(i,a){this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(!this._handleChange||this._handleChange({changedObservable:i,change:a,didChange:C=>C===i},this.changeSummary))&&(this.state=2)}readObservable(i){if(this.disposed)return i.get();i.addObserver(this);const a=i.get();return this.dependencies.add(i),this.dependenciesToBeRemoved.delete(i),a}}e.AutorunObserver=g,function(n){n.Observer=g}(h||(e.autorun=h={}));function d(n,i){let a;return r({debugName:()=>(0,k.getFunctionName)(i)},v=>{const C=n.read(v),D=a;a=C,i({lastValue:D,newValue:C})})}e.autorunDelta=d}),define(W[10],j([0,1,6,2,5,4]),function(B,e,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=void 0;const r=(d,n)=>d===n;function h(d,n){return n!==void 0?new g(d,void 0,n,void 0,void 0,void 0,r):new g(void 0,void 0,d,void 0,void 0,void 0,r)}e.derived=h;function t(d,n){return new g(d.owner,d.debugName,n,void 0,void 0,void 0,d.equalityComparer??r)}e.derivedOpts=t;function s(d,n){return new g(d.owner,d.debugName,n,d.createEmptyChangeSummary,d.handleChange,void 0,d.equalityComparer??r)}e.derivedHandleChanges=s;function o(d,n){let i,a;n===void 0?(i=d,a=void 0):(a=d,i=n);const v=new y.DisposableStore;return new g(a,()=>(0,k.getFunctionName)(i)??"(anonymous)",C=>(v.clear(),i(C,v)),void 0,void 0,()=>v.dispose(),r)}e.derivedWithStore=o,(0,k._setDerivedOpts)(t);var u;(function(d){d[d.initial=0]="initial",d[d.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",d[d.stale=2]="stale",d[d.upToDate=3]="upToDate"})(u||(u={}));class g extends k.BaseObservable{get debugName(){return(0,k.getDebugName)(this,this._debugName,this._computeFn,this._owner,this)??"(anonymous)"}constructor(n,i,a,v,C,D=void 0,A){super(),this._owner=n,this._debugName=i,this._computeFn=a,this.createChangeSummary=v,this._handleChange=C,this._handleLastObserverRemoved=D,this._equalityComparator=A,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,L.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const n=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),n}else{do{if(this.state===1){for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n;const i=this.state!==0,a=this.value;this.state=3;const v=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,v)}finally{for(const D of this.dependenciesToBeRemoved)D.removeObserver(this);this.dependenciesToBeRemoved.clear()}const C=i&&!this._equalityComparator(a,this.value);if((0,L.getLogger)()?.handleDerivedRecomputed(this,{oldValue:a,newValue:this.value,change:void 0,didChange:C,hadValue:i}),C)for(const D of this.observers)D.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.updateCount++;const i=this.updateCount===1;if(this.state===3&&(this.state=1,!i))for(const a of this.observers)a.handlePossibleChange(this);if(i)for(const a of this.observers)a.beginUpdate(this)}endUpdate(n){if(this.updateCount--,this.updateCount===0){const i=[...this.observers];for(const a of i)a.endUpdate(this)}if(this.updateCount<0)throw new P.BugIndicatingError}handlePossibleChange(n){if(this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){this.state=1;for(const i of this.observers)i.handlePossibleChange(this)}}handleChange(n,i){if(this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){const a=this._handleChange?this._handleChange({changedObservable:n,change:i,didChange:C=>C===n},this.changeSummary):!0,v=this.state===3;if(a&&(this.state===1||v)&&(this.state=2,v))for(const C of this.observers)C.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),i}addObserver(n){const i=!this.observers.has(n)&&this.updateCount>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.observers.has(n)&&this.updateCount>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.Derived=g}),define(W[22],j([0,1,2,9,5,10,4]),function(B,e,P,y,k,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.recomputeInitiallyAndOnChange=e.keepObserved=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function h(f){return new t(f)}e.constObservable=h;class t extends k.ConvenientObservable{constructor(_){super(),this.value=_}get debugName(){return this.toString()}get(){return this.value}addObserver(_){}removeObserver(_){}toString(){return`Const: ${this.value}`}}function s(f){const _=(0,k.observableValue)("promiseValue",{});return f.then(I=>{_.set({value:I},void 0)}),_}e.observableFromPromise=s;function o(f,_){return new Promise(I=>{let c=!1,E=!1;const R=(0,y.autorun)(U=>{const O=f.read(U);_(O)&&(c?R.dispose():E=!0,I(O))});c=!0,E&&R.dispose()})}e.waitForState=o;function u(f,_){return new g(f,_)}e.observableFromEvent=u;class g extends k.BaseObservable{constructor(_,I){super(),this.event=_,this._getValue=I,this.hasValue=!1,this.handleEvent=c=>{const E=this._getValue(c),R=!this.hasValue||this.value!==E;(0,r.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:E,change:void 0,didChange:R,hadValue:this.hasValue}),R&&(this.value=E,this.hasValue&&(0,k.transaction)(U=>{for(const O of this.observers)U.updateObserver(O,this),O.handleChange(this,void 0)},()=>{const U=this.getDebugName();return"Event fired"+(U?`: ${U}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,k.getFunctionName)(this._getValue)}get debugName(){const _=this.getDebugName();return"From Event"+(_?`: ${_}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}e.FromEventObservable=g,function(f){f.Observer=g}(u||(e.observableFromEvent=u={}));function d(f,_){return new n(f,_)}e.observableSignalFromEvent=d;class n extends k.BaseObservable{constructor(_,I){super(),this.debugName=_,this.event=I,this.handleEvent=()=>{(0,k.transaction)(c=>{for(const E of this.observers)c.updateObserver(E,this),E.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function i(f){return typeof f=="string"?new a(f):new a(void 0,f)}e.observableSignal=i;class a extends k.BaseObservable{get debugName(){return(0,k.getDebugName)(this,this._debugName,void 0,this._owner,this)??"Observable Signal"}constructor(_,I){super(),this._debugName=_,this._owner=I}trigger(_,I){if(!_){(0,k.transaction)(c=>{this.trigger(c,I)},()=>`Trigger signal ${this.debugName}`);return}for(const c of this.observers)_.updateObserver(c,this),c.handleChange(this,I)}get(){}}function v(f,_,I){const c=(0,k.observableValue)("debounced",void 0);let E;return I.add((0,y.autorun)(R=>{const U=f.read(R);E&&clearTimeout(E),E=setTimeout(()=>{(0,k.transaction)(O=>{c.set(U,O)})},_)})),c}e.debouncedObservable=v;function C(f,_,I){const c=(0,k.observableValue)("triggeredRecently",!1);let E;return I.add(f(()=>{c.set(!0,void 0),E&&clearTimeout(E),E=setTimeout(()=>{c.set(!1,void 0)},_)})),c}e.wasEventTriggeredRecently=C;function D(f){const _=new w(!1);return f.addObserver(_),(0,P.toDisposable)(()=>{f.removeObserver(_)})}e.keepObserved=D;function A(f){const _=new w(!0);return f.addObserver(_),f.reportChanges(),(0,P.toDisposable)(()=>{f.removeObserver(_)})}e.recomputeInitiallyAndOnChange=A;class w{constructor(_){this.forceRecompute=_,this.counter=0}beginUpdate(_){this.counter++}endUpdate(_){this.counter--,this.counter===0&&this.forceRecompute&&_.reportChanges()}handlePossibleChange(_){}handleChange(_,I){}}function m(f){let _;return(0,L.derived)(c=>(_=f(c,_),_))}e.derivedObservableWithCache=m;function T(f,_){let I;const c=(0,k.observableValue)("derivedObservableWithWritableCache.counter",0),E=(0,L.derived)(f,R=>(c.read(R),I=_(R,I),I));return Object.assign(E,{clearCache:R=>{I=void 0,c.set(c.get()+1,R)}})}e.derivedObservableWithWritableCache=T}),define(W[11],j([0,1,5,10,9,22,4]),function(B,e,P,y,k,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.observableValue}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.disposableObservableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.transaction}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.subtransaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return y.derived}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return y.derivedOpts}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return y.derivedHandleChanges}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return y.derivedWithStore}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.autorunOpts}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.autorunWithStoreHandleChanges}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return L.constObservable}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return L.debouncedObservable}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return L.derivedObservableWithCache}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return L.derivedObservableWithWritableCache}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return L.keepObserved}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return L.recomputeInitiallyAndOnChange}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return L.observableFromEvent}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return L.observableFromPromise}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return L.observableSignal}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return L.observableSignalFromEvent}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return L.waitForState}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return L.wasEventTriggeredRecently}}),!1&&(0,r.setLogger)(new r.ConsoleObservableLogger)}),define(W[23],j([0,1,6,2]),function(B,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(A){const w=A;return w?typeof w.read=="function":!1}e.isReadable=k;function L(A){const w=A;return w?[w.on,w.pause,w.resume,w.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=L;function r(A){const w=A;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=r;function h(A,w){return new t(A,w)}e.newWriteableStream=h;class t{constructor(w,m){this.reducer=w,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(m=>m(w))}emitError(w){this.listeners.error.length===0?(0,P.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(m=>m(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,m){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(w,m){if(this.state.destroyed)return;let T;switch(w){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const f=T.indexOf(m);f>=0&&T.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function s(A,w){const m=[];let T;for(;(T=A.read())!==null;)m.push(T);return w(m)}e.consumeReadable=s;function o(A,w,m){const T=[];let f;for(;(f=A.read())!==null&&T.length<m;)T.push(f);return f===null&&T.length>0?w(T):{read:()=>{if(T.length>0)return T.shift();if(typeof f<"u"){const _=f;return f=void 0,_}return A.read()}}}e.peekReadable=o;function u(A,w){return new Promise((m,T)=>{const f=[];g(A,{onData:_=>{w&&f.push(_)},onError:_=>{w?T(_):m(void 0)},onEnd:()=>{m(w?w(f):void 0)}})})}e.consumeStream=u;function g(A,w,m){A.on("error",T=>{m?.isCancellationRequested||w.onError(T)}),A.on("end",()=>{m?.isCancellationRequested||w.onEnd()}),A.on("data",T=>{m?.isCancellationRequested||w.onData(T)})}e.listenStream=g;function d(A,w){return new Promise((m,T)=>{const f=new y.DisposableStore,_=[],I=R=>{if(_.push(R),_.length>w)return f.dispose(),A.pause(),m({stream:A,buffer:_,ended:!1})},c=R=>(f.dispose(),T(R)),E=()=>(f.dispose(),m({stream:A,buffer:_,ended:!0}));f.add((0,y.toDisposable)(()=>A.removeListener("error",c))),A.on("error",c),f.add((0,y.toDisposable)(()=>A.removeListener("end",E))),A.on("end",E),f.add((0,y.toDisposable)(()=>A.removeListener("data",I))),A.on("data",I)})}e.peekStream=d;function n(A,w){const m=h(w);return m.end(A),m}e.toStream=n;function i(){const A=h(()=>{throw new Error("not supported")});return A.end(),A}e.emptyStream=i;function a(A){let w=!1;return{read:()=>w?null:(w=!0,A)}}e.toReadable=a;function v(A,w,m){const T=h(m);return g(A,{onData:f=>T.write(w.data(f)),onError:f=>T.error(w.error?w.error(f):f),onEnd:()=>T.end()}),T}e.transform=v;function C(A,w,m){let T=!1;return{read:()=>{const f=w.read();return T?f:(T=!0,f!==null?m([A,f]):A)}}}e.prefixedReadable=C;function D(A,w,m){let T=!1;const f=h(m);return g(w,{onData:_=>T?f.write(_):(T=!0,f.write(m([A,_]))),onError:_=>f.error(_),onEnd:()=>{T||(T=!0,f.write(A)),f.end()}}),f}e.prefixedStream=D}),define(W[12],j([0,1,43,23]),function(B,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",L=new P.Lazy(()=>new Uint8Array(256));let r,h;class t{static alloc(b){return k?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return k&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,z){return!(z?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const z=t.alloc(b.length);for(let V=0,$=b.length;V<$;V++)z.buffer[V]=b[V];return z}static concat(b,z){if(typeof z>"u"){z=0;for(let K=0,G=b.length;K<G;K++)z+=b[K].byteLength}const V=t.alloc(z);let $=0;for(let K=0,G=b.length;K<G;K++){const q=b[K];V.set(q,$),$+=q.byteLength}return V}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return k?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(b,z){return new t(this.buffer.subarray(b,z))}set(b,z){if(b instanceof t)this.buffer.set(b.buffer,z);else if(b instanceof Uint8Array)this.buffer.set(b,z);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),z);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,z){d(this.buffer,b,z)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,z){i(this.buffer,b,z)}readUInt8(b){return a(this.buffer,b)}writeUInt8(b,z){v(this.buffer,b,z)}indexOf(b,z=0){return s(this.buffer,b instanceof t?b.buffer:b,z)}}e.VSBuffer=t;function s(O,b,z=0){const V=b.byteLength,$=O.byteLength;if(V===0)return 0;if(V===1)return O.indexOf(b[0]);if(V>$-z)return-1;const K=L.value;K.fill(b.length);for(let J=0;J<b.length;J++)K[b[J]]=b.length-J-1;let G=z+b.length-1,q=G,H=-1;for(;G<$;)if(O[G]===b[q]){if(q===0){H=G;break}G--,q--}else G+=Math.max(b.length-q,K[O[G]]),q=b.length-1;return H}e.binaryIndexOf=s;function o(O,b){return O[b+0]<<0>>>0|O[b+1]<<8>>>0}e.readUInt16LE=o;function u(O,b,z){O[z+0]=b&255,b=b>>>8,O[z+1]=b&255}e.writeUInt16LE=u;function g(O,b){return O[b]*2**24+O[b+1]*2**16+O[b+2]*2**8+O[b+3]}e.readUInt32BE=g;function d(O,b,z){O[z+3]=b,b=b>>>8,O[z+2]=b,b=b>>>8,O[z+1]=b,b=b>>>8,O[z]=b}e.writeUInt32BE=d;function n(O,b){return O[b+0]<<0>>>0|O[b+1]<<8>>>0|O[b+2]<<16>>>0|O[b+3]<<24>>>0}e.readUInt32LE=n;function i(O,b,z){O[z+0]=b&255,b=b>>>8,O[z+1]=b&255,b=b>>>8,O[z+2]=b&255,b=b>>>8,O[z+3]=b&255}e.writeUInt32LE=i;function a(O,b){return O[b]}e.readUInt8=a;function v(O,b,z){O[z]=b}e.writeUInt8=v;function C(O){return y.consumeReadable(O,b=>t.concat(b))}e.readableToBuffer=C;function D(O){return y.toReadable(O)}e.bufferToReadable=D;function A(O){return y.consumeStream(O,b=>t.concat(b))}e.streamToBuffer=A;async function w(O){return O.ended?t.concat(O.buffer):t.concat([...O.buffer,await A(O.stream)])}e.bufferedStreamToBuffer=w;function m(O){return y.toStream(O,b=>t.concat(b))}e.bufferToStream=m;function T(O){return y.transform(O,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.streamToBufferReadableStream=T;function f(O){return y.newWriteableStream(b=>t.concat(b),O)}e.newWriteableBufferStream=f;function _(O,b){return y.prefixedReadable(O,b,z=>t.concat(z))}e.prefixedBufferReadable=_;function I(O,b){return y.prefixedStream(O,b,z=>t.concat(z))}e.prefixedBufferStream=I;function c(O){let b=0,z=0,V=0;const $=new Uint8Array(Math.floor(O.length/4*3)),K=q=>{switch(z){case 3:$[V++]=b|q,z=0;break;case 2:$[V++]=b|q>>>2,b=q<<6,z=3;break;case 1:$[V++]=b|q>>>4,b=q<<4,z=2;break;default:b=q<<2,z=1}};for(let q=0;q<O.length;q++){const H=O.charCodeAt(q);if(H>=65&&H<=90)K(H-65);else if(H>=97&&H<=122)K(H-97+26);else if(H>=48&&H<=57)K(H-48+52);else if(H===43||H===45)K(62);else if(H===47||H===95)K(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${O[q]}`)}}const G=V;for(;z>0;)K(0);return t.wrap($).slice(0,G)}e.decodeBase64=c;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:O},b=!0,z=!1){const V=z?R:E;let $="";const K=O.byteLength%3;let G=0;for(;G<O.byteLength-K;G+=3){const q=O[G+0],H=O[G+1],J=O[G+2];$+=V[q>>>2],$+=V[(q<<4|H>>>4)&63],$+=V[(H<<2|J>>>6)&63],$+=V[J&63]}if(K===1){const q=O[G+0];$+=V[q>>>2],$+=V[q<<4&63],b&&($+="==")}else if(K===2){const q=O[G+0],H=O[G+1];$+=V[q>>>2],$+=V[(q<<4|H>>>4)&63],$+=V[H<<2&63],b&&($+="=")}return $}e.encodeBase64=U}),define(W[24],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[13],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var P;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function y(k){let L=0,r=0,h=0,t=0;for(let s=0,o=k.length;s<o;s++){const u=k.charCodeAt(s);u===13?(L===0&&(r=s),L++,s+1<o&&k.charCodeAt(s+1)===10?(t|=2,s++):t|=3,h=s+1):u===10&&(t|=1,L===0&&(r=s),L++,h=s+1)}return L===0&&(r=k.length),[L,r,k.length-h,t]}e.countEOL=y}),define(W[14],j([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var y;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(y||(e.FontStyle=y={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var L;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(L||(e.StandardTokenType=L={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class h{static getLanguageId(s){return(s&255)>>>0}static getTokenType(s){return(s&768)>>>8}static containsBalancedBrackets(s){return(s&1024)!==0}static getFontStyle(s){return(s&30720)>>>11}static getForeground(s){return(s&16744448)>>>15}static getBackground(s){return(s&4278190080)>>>24}static getClassNameFromMetadata(s){let u="mtk"+this.getForeground(s);const g=this.getFontStyle(s);return g&1&&(u+=" mtki"),g&2&&(u+=" mtkb"),g&4&&(u+=" mtku"),g&8&&(u+=" mtks"),u}static getInlineStyleFromMetadata(s,o){const u=this.getForeground(s),g=this.getFontStyle(s);let d=`color: ${o[u]};`;g&1&&(d+="font-style: italic;"),g&2&&(d+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(d+=`text-decoration:${n};`),d}static getPresentationFromMetadata(s){const o=this.getForeground(s),u=this.getFontStyle(s);return{foreground:o,italic:!!(u&1),bold:!!(u&2),underline:!!(u&4),strikethrough:!!(u&8)}}}e.TokenMetadata=h}),define(W[25],j([0,1,26]),function(B,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class y{constructor(r){this._default=r,this._store=[]}get(r){return r<this._store.length?this._store[r]:this._default}set(r,h){for(;r>=this._store.length;)this._store[this._store.length]=this._default;this._store[r]=h}replace(r,h,t){if(r>=this._store.length)return;if(h===0){this.insert(r,t);return}else if(t===0){this.delete(r,h);return}const s=this._store.slice(0,r),o=this._store.slice(r+h),u=k(t,this._default);this._store=s.concat(u,o)}delete(r,h){h===0||r>=this._store.length||this._store.splice(r,h)}insert(r,h){if(h===0||r>=this._store.length)return;const t=[];for(let s=0;s<h;s++)t[s]=this._default;this._store=(0,P.arrayInsert)(this._store,r,t)}}e.FixedArray=y;function k(L,r){const h=[];for(let t=0;t<L;t++)h[t]=r;return h}}),define(W[7],j([0,1,14]),function(B,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class y{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,h){const t=y.defaultTokenMetadata,s=new Uint32Array(2);return s[0]=r.length,s[1]=t,new y(s,r,h)}constructor(r,h,t){this._lineTokensBrand=void 0,this._tokens=r,this._tokensCount=this._tokens.length>>>1,this._text=h,this._languageIdCodec=t}equals(r){return r instanceof y?this.slicedEquals(r,0,this._tokensCount):!1}slicedEquals(r,h,t){if(this._text!==r._text||this._tokensCount!==r._tokensCount)return!1;const s=h<<1,o=s+(t<<1);for(let u=s;u<o;u++)if(this._tokens[u]!==r._tokens[u])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(r){return r>0?this._tokens[r-1<<1]:0}getMetadata(r){return this._tokens[(r<<1)+1]}getLanguageId(r){const h=this._tokens[(r<<1)+1],t=P.TokenMetadata.getLanguageId(h);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(r){const h=this._tokens[(r<<1)+1];return P.TokenMetadata.getTokenType(h)}getForeground(r){const h=this._tokens[(r<<1)+1];return P.TokenMetadata.getForeground(h)}getClassName(r){const h=this._tokens[(r<<1)+1];return P.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(r,h){const t=this._tokens[(r<<1)+1];return P.TokenMetadata.getInlineStyleFromMetadata(t,h)}getPresentation(r){const h=this._tokens[(r<<1)+1];return P.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(r){return this._tokens[r<<1]}findTokenIndexAtOffset(r){return y.findIndexInTokensArray(this._tokens,r)}inflate(){return this}sliceAndInflate(r,h,t){return new k(this,r,h,t)}static convertToEndOffset(r,h){const s=(r.length>>>1)-1;for(let o=0;o<s;o++)r[o<<1]=r[o+1<<1];r[s<<1]=h}static findIndexInTokensArray(r,h){if(r.length<=2)return 0;let t=0,s=(r.length>>>1)-1;for(;t<s;){const o=t+Math.floor((s-t)/2),u=r[o<<1];if(u===h)return o+1;u<h?t=o+1:u>h&&(s=o)}return t}withInserted(r){if(r.length===0)return this;let h=0,t=0,s="";const o=new Array;let u=0;for(;;){const g=h<this._tokensCount?this._tokens[h<<1]:-1,d=t<r.length?r[t]:null;if(g!==-1&&(d===null||g<=d.offset)){s+=this._text.substring(u,g);const n=this._tokens[(h<<1)+1];o.push(s.length,n),h++,u=g}else if(d){if(d.offset>u){s+=this._text.substring(u,d.offset);const n=this._tokens[(h<<1)+1];o.push(s.length,n),u=d.offset}s+=d.text,o.push(s.length,d.tokenMetadata),t++}else break}return new y(new Uint32Array(o),s,this._languageIdCodec)}}e.LineTokens=y;class k{constructor(r,h,t,s){this._source=r,this._startOffset=h,this._endOffset=t,this._deltaOffset=s,this._firstTokenIndex=r.findTokenIndexAtOffset(h),this._tokensCount=0;for(let o=this._firstTokenIndex,u=r.getCount();o<u&&!(r.getStartOffset(o)>=t);o++)this._tokensCount++}getMetadata(r){return this._source.getMetadata(this._firstTokenIndex+r)}getLanguageId(r){return this._source.getLanguageId(this._firstTokenIndex+r)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(r){return r instanceof k?this._startOffset===r._startOffset&&this._endOffset===r._endOffset&&this._deltaOffset===r._deltaOffset&&this._source.slicedEquals(r._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(r){return this._source.getForeground(this._firstTokenIndex+r)}getEndOffset(r){const h=this._source.getEndOffset(this._firstTokenIndex+r);return Math.min(this._endOffset,h)-this._startOffset+this._deltaOffset}getClassName(r){return this._source.getClassName(this._firstTokenIndex+r)}getInlineStyle(r,h){return this._source.getInlineStyle(this._firstTokenIndex+r,h)}getPresentation(r){return this._source.getPresentation(this._firstTokenIndex+r)}findTokenIndexAtOffset(r){return this._source.findTokenIndexAtOffset(r+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(W[27],j([0,1,7]),function(B,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class y{static deleteBeginning(r,h){return r===null||r===e.EMPTY_LINE_TOKENS?r:y.delete(r,0,h)}static deleteEnding(r,h){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const t=k(r),s=t[t.length-2];return y.delete(r,h,s)}static delete(r,h,t){if(r===null||r===e.EMPTY_LINE_TOKENS||h===t)return r;const s=k(r),o=s.length>>>1;if(h===0&&s[s.length-2]===t)return e.EMPTY_LINE_TOKENS;const u=P.LineTokens.findIndexInTokensArray(s,h),g=u>0?s[u-1<<1]:0,d=s[u<<1];if(t<d){const C=t-h;for(let D=u;D<o;D++)s[D<<1]-=C;return r}let n,i;g!==h?(s[u<<1]=h,n=u+1<<1,i=h):(n=u<<1,i=g);const a=t-h;for(let C=u+1;C<o;C++){const D=s[C<<1]-a;D>i&&(s[n++]=D,s[n++]=s[(C<<1)+1],i=D)}if(n===s.length)return r;const v=new Uint32Array(n);return v.set(s.subarray(0,n),0),v.buffer}static append(r,h){if(h===e.EMPTY_LINE_TOKENS)return r;if(r===e.EMPTY_LINE_TOKENS)return h;if(r===null)return r;if(h===null)return null;const t=k(r),s=k(h),o=s.length>>>1,u=new Uint32Array(t.length+s.length);u.set(t,0);let g=t.length;const d=t[t.length-2];for(let n=0;n<o;n++)u[g++]=s[n<<1]+d,u[g++]=s[(n<<1)+1];return u.buffer}static insert(r,h,t){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const s=k(r),o=s.length>>>1;let u=P.LineTokens.findIndexInTokensArray(s,h);u>0&&s[u-1<<1]===h&&u--;for(let g=u;g<o;g++)s[g<<1]+=t;return r}}e.ContiguousTokensEditing=y;function k(L){return L instanceof Uint32Array?L:new Uint32Array(L)}e.toUint32Array=k}),define(W[28],j([0,1,26,12,44,13,27,15]),function(B,e,P,y,k,L,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(o,u,g){const d=new Uint32Array(o.buffer),n=(0,y.readUInt32BE)(o,u);u+=4;const i=(0,y.readUInt32BE)(o,u);u+=4;const a=[];for(let v=0;v<i;v++){const C=(0,y.readUInt32BE)(o,u);u+=4,a.push(d.subarray(u/4,u/4+C/4)),u+=C}return g.push(new t(n,a)),u}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(o,u){this._startLineNumber=o,this._tokens=u}getLineRange(){return new h.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(o){return this._tokens[o-this._startLineNumber]}appendLineTokens(o){this._tokens.push(o)}serializeSize(){let o=0;o+=4,o+=4;for(let u=0;u<this._tokens.length;u++){const g=this._tokens[u];if(!(g instanceof Uint32Array))throw new Error("Not supported!");o+=4,o+=g.byteLength}return o}serialize(o,u){(0,y.writeUInt32BE)(o,this._startLineNumber,u),u+=4,(0,y.writeUInt32BE)(o,this._tokens.length,u),u+=4;for(let g=0;g<this._tokens.length;g++){const d=this._tokens[g];if(!(d instanceof Uint32Array))throw new Error("Not supported!");(0,y.writeUInt32BE)(o,d.byteLength,u),u+=4,o.set(new Uint8Array(d.buffer),u),u+=d.byteLength}return u}applyEdit(o,u){const[g,d]=(0,L.countEOL)(u);this._acceptDeleteRange(o),this._acceptInsertText(new k.Position(o.startLineNumber,o.startColumn),g,d)}_acceptDeleteRange(o){if(o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn)return;const u=o.startLineNumber-this._startLineNumber,g=o.endLineNumber-this._startLineNumber;if(g<0){const d=g-u;this._startLineNumber-=d;return}if(!(u>=this._tokens.length)){if(u<0&&g>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(u===g){this._tokens[u]=r.ContiguousTokensEditing.delete(this._tokens[u],o.startColumn-1,o.endColumn-1);return}if(u>=0)if(this._tokens[u]=r.ContiguousTokensEditing.deleteEnding(this._tokens[u],o.startColumn-1),g<this._tokens.length){const d=r.ContiguousTokensEditing.deleteBeginning(this._tokens[g],o.endColumn-1);this._tokens[u]=r.ContiguousTokensEditing.append(this._tokens[u],d),this._tokens.splice(u+1,g-u)}else this._tokens[u]=r.ContiguousTokensEditing.append(this._tokens[u],null),this._tokens=this._tokens.slice(0,u+1);else{const d=-u;this._startLineNumber-=d,this._tokens[g]=r.ContiguousTokensEditing.deleteBeginning(this._tokens[g],o.endColumn-1),this._tokens=this._tokens.slice(g)}}}_acceptInsertText(o,u,g){if(u===0&&g===0)return;const d=o.lineNumber-this._startLineNumber;if(d<0){this._startLineNumber+=u;return}if(!(d>=this._tokens.length)){if(u===0){this._tokens[d]=r.ContiguousTokensEditing.insert(this._tokens[d],o.column-1,g);return}this._tokens[d]=r.ContiguousTokensEditing.deleteEnding(this._tokens[d],o.column-1),this._tokens[d]=r.ContiguousTokensEditing.insert(this._tokens[d],o.column-1,g),this._insertLines(o.lineNumber,u)}}_insertLines(o,u){if(u===0)return;const g=[];for(let d=0;d<u;d++)g[d]=null;this._tokens=P.arrayInsert(this._tokens,o,g)}}e.ContiguousMultilineTokens=t}),define(W[16],j([0,1,12,28]),function(B,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class k{static deserialize(r){let h=0;const t=(0,P.readUInt32BE)(r,h);h+=4;const s=[];for(let o=0;o<t;o++)h=y.ContiguousMultilineTokens.deserialize(r,h,s);return s}constructor(){this._tokens=[]}add(r,h){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(h);return}}this._tokens.push(new y.ContiguousMultilineTokens(r,[h]))}finalize(){return this._tokens}serialize(){const r=this._serializeSize(),h=new Uint8Array(r);return this._serialize(h),h}_serializeSize(){let r=0;r+=4;for(let h=0;h<this._tokens.length;h++)r+=this._tokens[h].serializeSize();return r}_serialize(r){let h=0;(0,P.writeUInt32BE)(r,this._tokens.length,h),h+=4;for(let t=0;t<this._tokens.length;t++)h=this._tokens[t].serialize(r,h)}}e.ContiguousMultilineTokensBuilder=k}),define(W[29],j([0,1,30,3,31,45]),function(B,e,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function r(c){return c===47||c===92}e.isPathSeparator=r;function h(c){return c.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=h;function t(c){return c.indexOf("/")===-1&&(c=h(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=t;function s(c,E=P.posix.sep){if(!c)return"";const R=c.length,U=c.charCodeAt(0);if(r(U)){if(r(c.charCodeAt(1))&&!r(c.charCodeAt(2))){let b=3;const z=b;for(;b<R&&!r(c.charCodeAt(b));b++);if(z!==b&&!r(c.charCodeAt(b+1))){for(b+=1;b<R;b++)if(r(c.charCodeAt(b)))return c.slice(0,b+1).replace(/[\\/]/g,E)}}return E}else if(v(U)&&c.charCodeAt(1)===58)return r(c.charCodeAt(2))?c.slice(0,2)+E:c.slice(0,2);let O=c.indexOf("://");if(O!==-1){for(O+=3;O<R;O++)if(r(c.charCodeAt(O)))return c.slice(0,O+1)}return""}e.getRoot=s;function o(c){if(!y.isWindows||!c||c.length<5)return!1;let E=c.charCodeAt(0);if(E!==92||(E=c.charCodeAt(1),E!==92))return!1;let R=2;const U=R;for(;R<c.length&&(E=c.charCodeAt(R),E!==92);R++);return!(U===R||(E=c.charCodeAt(R+1),isNaN(E)||E===92))}e.isUNC=o;const u=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(c,E=y.isWindows){const R=E?u:g;return!(!c||c.length===0||/^\s+$/.test(c)||(R.lastIndex=0,R.test(c))||E&&d.test(c)||c==="."||c===".."||E&&c[c.length-1]==="."||E&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=n;function i(c,E,R){const U=c===E;return!R||U?U:!c||!E?!1:(0,k.equalsIgnoreCase)(c,E)}e.isEqual=i;function a(c,E,R,U=P.sep){if(c===E)return!0;if(!c||!E||E.length>c.length)return!1;if(R){if(!(0,k.startsWithIgnoreCase)(c,E))return!1;if(E.length===c.length)return!0;let b=E.length;return E.charAt(E.length-1)===U&&b--,c.charAt(b)===U}return E.charAt(E.length-1)!==U&&(E+=U),c.indexOf(E)===0}e.isEqualOrParent=a;function v(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=v;function C(c,E){return y.isWindows&&c.endsWith(":")&&(c+=P.sep),(0,P.isAbsolute)(c)||(c=(0,P.join)(E,c)),c=(0,P.normalize)(c),y.isWindows?(c=(0,k.rtrim)(c,P.sep),c.endsWith(":")&&(c+=P.sep)):(c=(0,k.rtrim)(c,P.sep),c||(c=P.sep)),c}e.sanitizeFilePath=C;function D(c){const E=(0,P.normalize)(c);return y.isWindows?c.length>3?!1:A(E)&&(c.length===2||E.charCodeAt(2)===92):E===P.posix.sep}e.isRootOrDriveLetter=D;function A(c,E=y.isWindows){return E?v(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=A;function w(c,E=y.isWindows){return A(c,E)?c[0]:void 0}e.getDriveLetter=w;function m(c,E,R){return E.length>c.length?-1:c===E?0:(R&&(c=c.toLowerCase(),E=E.toLowerCase()),c.indexOf(E))}e.indexOfPath=m;function T(c){const E=c.split(":");let R,U,O;for(const b of E){const z=Number(b);(0,L.isNumber)(z)?U===void 0?U=z:O===void 0&&(O=z):R=R?[R,b].join(":"):b}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:U!==void 0?U:void 0,column:O!==void 0?O:U!==void 0?1:void 0}}e.parseLineAndColumnAware=T;const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",_="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function I(c,E,R=8){let U="";for(let b=0;b<R;b++){let z;b===0&&y.isWindows&&!E&&(R===3||R===4)?z=_:z=f,U+=z.charAt(Math.floor(Math.random()*z.length))}let O;return E?O=`${E}-${U}`:O=U,c?(0,P.join)(c,O):O}e.randomPath=I}),define(W[17],j([0,1,6,3,8]),function(B,e,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(s){s.inMemory="inmemory",s.vscode="vscode",s.internal="private",s.walkThrough="walkThrough",s.walkThroughSnippet="walkThroughSnippet",s.http="http",s.https="https",s.file="file",s.mailto="mailto",s.untitled="untitled",s.data="data",s.command="command",s.vscodeRemote="vscode-remote",s.vscodeRemoteResource="vscode-remote-resource",s.vscodeManagedRemoteResource="vscode-managed-remote-resource",s.vscodeUserData="vscode-userdata",s.vscodeCustomEditor="vscode-custom-editor",s.vscodeNotebookCell="vscode-notebook-cell",s.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",s.vscodeNotebookCellOutput="vscode-notebook-cell-output",s.vscodeInteractiveInput="vscode-interactive-input",s.vscodeSettings="vscode-settings",s.vscodeWorkspaceTrust="vscode-workspace-trust",s.vscodeTerminal="vscode-terminal",s.vscodeChatSesssion="vscode-chat-editor",s.webviewPanel="webview-panel",s.vscodeWebview="vscode-webview",s.extension="extension",s.vscodeFileResource="vscode-file",s.tmp="tmp",s.vsls="vsls",s.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class r{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(o){this._preferredWebSchema=o}setDelegate(o){this._delegate=o}setServerRootPath(o){this._remoteResourcesPath=`${o}/${L.vscodeRemoteResource}`}set(o,u,g){this._hosts[o]=u,this._ports[o]=g}setConnectionToken(o,u){this._connectionTokens[o]=u}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(o){if(this._delegate)try{return this._delegate(o)}catch(a){return P.onUnexpectedError(a),o}const u=o.authority;let g=this._hosts[u];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const d=this._ports[u],n=this._connectionTokens[u];let i=`path=${encodeURIComponent(o.path)}`;return typeof n=="string"&&(i+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),k.URI.from({scheme:y.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${g}:${d}`,path:this._remoteResourcesPath,query:i})}}e.RemoteAuthorities=new r,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class h{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(o){const u=this.toUri(o,B);return this.uriToBrowserUri(u)}uriToBrowserUri(o){return o.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(o):o.scheme===L.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${L.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?o.with({scheme:L.vscodeFileResource,authority:o.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):o}asFileUri(o){const u=this.toUri(o,B);return this.uriToFileUri(u)}uriToFileUri(o){return o.scheme===L.vscodeFileResource?o.with({scheme:L.file,authority:o.authority!==h.FALLBACK_AUTHORITY?o.authority:null,query:null,fragment:null}):o}toUri(o,u){return k.URI.isUri(o)?o:k.URI.parse(u.toUrl(o))}}e.FileAccess=new h;var t;(function(s){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);s.CoopAndCoep=Object.freeze(o.get("3"));const u="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:k.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const a=i?.get(u);if(a)return o.get(a)}s.getHeadersFromQuery=g;function d(n,i,a){if(!globalThis.crossOriginIsolated)return;const v=i&&a?"3":a?"2":"1";n instanceof URLSearchParams?n.set(u,v):n[u]=v}s.addSearchParam=d})(t||(e.COI=t={}))}),define(W[32],j([0,1,21,17,3,8]),function(B,e,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class r{constructor(g,d,n){this.id=g,this.dependencies=d,this.callback=n}}class h{static{this.INSTANCE=new h}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,d,n)=>{typeof g!="string"&&(n=d,d=g,g=null),(typeof d!="object"||!Array.isArray(d))&&(n=d,d=null),this._defineCalls.push(new r(g,d,n))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const d=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!d)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}_rendererLoadScript(g){return new Promise((d,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const a=()=>{i.removeEventListener("load",v),i.removeEventListener("error",C)},v=D=>{a(),d(this._defineCalls.pop())},C=D=>{a(),n(D)};i.addEventListener("load",v),i.addEventListener("error",C),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}_workerLoadScript(g){return new Promise((d,n)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),d(this._defineCalls.pop())}catch(i){n(i)}})}async _nodeJSLoadScript(g){try{const d=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,a=L.URI.parse(g).fsPath,v=d.readFileSync(a).toString(),C=i.wrap(v.replace(/^#!.*/,""));return new n.Script(C).runInThisContext().apply(),this._defineCalls.pop()}catch(d){throw d}}}const t=new Map;let s={};typeof globalThis.require=="object"&&(s=globalThis.require.paths??{});async function o(u,g,d){if(P.isESM){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),s[u]&&(u=s[u]);const n=`${u}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const D=`${d&&!k.isWeb?y.nodeModulesAsarPath:y.nodeModulesPath}/${n}`;i=y.FileAccess.asBrowserUri(D).toString(!0)}const a=h.INSTANCE.load(i);return t.set(n,a),a}else return await new Promise((n,i)=>{B([u],n,i)})}e.importAMDNodeModule=o}),define(W[18],j([0,1,29,17,30,3,31,8]),function(B,e,P,y,k,L,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(d){return(0,h.uriToFsPath)(d,!0)}e.originalFSPath=t;class s{constructor(n){this._ignorePathCasing=n}compare(n,i,a=!1){return n===i?0:(0,r.compare)(this.getComparisonKey(n,a),this.getComparisonKey(i,a))}isEqual(n,i,a=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,a)===this.getComparisonKey(i,a)}getComparisonKey(n,i=!1){return n.with({path:this._ignorePathCasing(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this._ignorePathCasing(n)}isEqualOrParent(n,i,a=!1){if(n.scheme===i.scheme){if(n.scheme===y.Schemas.file)return P.isEqualOrParent(t(n),t(i),this._ignorePathCasing(n))&&n.query===i.query&&(a||n.fragment===i.fragment);if((0,e.isEqualAuthority)(n.authority,i.authority))return P.isEqualOrParent(n.path,i.path,this._ignorePathCasing(n),"/")&&n.query===i.query&&(a||n.fragment===i.fragment)}return!1}joinPath(n,...i){return h.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.basename)(n)||n.authority}basename(n){return k.posix.basename(n.path)}extname(n){return k.posix.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===y.Schemas.file?i=h.URI.file(k.dirname(t(n))).path:(i=k.posix.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===y.Schemas.file?i=h.URI.file(k.normalize(t(n))).path:i=k.posix.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.isEqualAuthority)(n.authority,i.authority))return;if(n.scheme===y.Schemas.file){const C=k.relative(t(n),t(i));return L.isWindows?P.toSlashes(C):C}let a=n.path||"/";const v=i.path||"/";if(this._ignorePathCasing(n)){let C=0;for(const D=Math.min(a.length,v.length);C<D&&!(a.charCodeAt(C)!==v.charCodeAt(C)&&a.charAt(C).toLowerCase()!==v.charAt(C).toLowerCase());C++);a=v.substr(0,C)+a.substr(C)}return k.posix.relative(a,v)}resolvePath(n,i){if(n.scheme===y.Schemas.file){const a=h.URI.file(k.resolve(t(n),i));return n.with({authority:a.authority,path:a.path})}return i=P.toPosixPath(i),n.with({path:k.posix.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.equalsIgnoreCase)(n,i)}hasTrailingPathSeparator(n,i=k.sep){if(n.scheme===y.Schemas.file){const a=t(n);return a.length>P.getRoot(a).length&&a[a.length-1]===i}else{const a=n.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=k.sep){return(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=k.sep){let a=!1;if(n.scheme===y.Schemas.file){const v=t(n);a=v!==void 0&&v.length===P.getRoot(v).length&&v[v.length-1]===i}else{i="/";const v=n.path;a=v.length===1&&v.charCodeAt(v.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path+"/"}):n}}e.ExtUri=s,e.extUri=new s(()=>!1),e.extUriBiasedIgnorePathCase=new s(d=>d.scheme===y.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new s(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function o(d,n){const i=[];for(let a=0;a<d.length;a++){const v=n(d[a]);d.some((C,D)=>D===a?!1:(0,e.isEqualOrParent)(v,n(C)))||i.push(d[a])}return i}e.distinctParents=o;var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function n(i){const a=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(D=>{const[A,w]=D.split(":");A&&w&&a.set(A,w)});const C=i.path.substring(0,i.path.indexOf(";"));return C&&a.set(d.META_DATA_MIME,C),a}d.parseMetaData=n})(u||(e.DataUri=u={}));function g(d,n,i){if(n){let a=d.path;return a&&a[0]!==k.posix.sep&&(a=k.posix.sep+a),d.with({scheme:i,authority:n,path:a})}return d.with({scheme:i})}e.toLocalResource=g}),define(W[19],j([0,1,46,6,33,2,18,3,24]),function(B,e,P,y,k,L,r,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function s(N){return!!N&&typeof N.then=="function"}e.isThenable=s;function o(N){const l=new P.CancellationTokenSource,S=N(l.token),p=new Promise((M,F)=>{const Y=l.token.onCancellationRequested(()=>{Y.dispose(),l.dispose(),F(new y.CancellationError)});Promise.resolve(S).then(Z=>{Y.dispose(),l.dispose(),M(Z)},Z=>{Y.dispose(),l.dispose(),F(Z)})});return new class{cancel(){l.cancel()}then(M,F){return p.then(M,F)}catch(M){return this.then(void 0,M)}finally(M){return p.finally(M)}}}e.createCancelablePromise=o;function u(N,l,S){return new Promise((p,M)=>{const F=l.onCancellationRequested(()=>{F.dispose(),p(S)});N.then(p,M).finally(()=>F.dispose())})}e.raceCancellation=u;function g(N,l){return new Promise((S,p)=>{const M=l.onCancellationRequested(()=>{M.dispose(),p(new y.CancellationError)});N.then(S,p).finally(()=>M.dispose())})}e.raceCancellationError=g;async function d(N){let l=-1;const S=N.map((p,M)=>p.then(F=>(l=M,F)));try{return await Promise.race(S)}finally{N.forEach((p,M)=>{M!==l&&p.cancel()})}}e.raceCancellablePromises=d;function n(N,l,S){let p;const M=setTimeout(()=>{p?.(void 0),S?.()},l);return Promise.race([N.finally(()=>clearTimeout(M)),new Promise(F=>p=F)])}e.raceTimeout=n;function i(N){return new Promise((l,S)=>{const p=N();s(p)?p.then(l,S):l(p)})}e.asPromise=i;class a{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(l){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=l,!this.queuedPromise){const S=()=>{if(this.queuedPromise=null,this.isDisposed)return;const p=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,p};this.queuedPromise=new Promise(p=>{this.activePromise.then(S,S).then(p)})}return new Promise((S,p)=>{this.queuedPromise.then(S,p)})}return this.activePromise=l(),new Promise((S,p)=>{this.activePromise.then(M=>{this.activePromise=null,S(M)},M=>{this.activePromise=null,p(M)})})}dispose(){this.isDisposed=!0}}e.Throttler=a;class v{constructor(){this.current=Promise.resolve(null)}queue(l){return this.current=this.current.then(()=>l(),()=>l())}}e.Sequencer=v;class C{constructor(){this.promiseMap=new Map}queue(l,S){const M=(this.promiseMap.get(l)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.promiseMap.get(l)===M&&this.promiseMap.delete(l)});return this.promiseMap.set(l,M),M}}e.SequencerByKey=C;const D=(N,l)=>{let S=!0;const p=setTimeout(()=>{S=!1,l()},N);return{isTriggered:()=>S,dispose:()=>{clearTimeout(p),S=!1}}},A=N=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,N())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class w{constructor(l){this.defaultDelay=l,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(l,S=this.defaultDelay){this.task=l,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,F)=>{this.doResolve=M,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}}));const p=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=S===t.MicrotaskDelay?A(p):D(S,p),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new y.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=w;class m{constructor(l){this.delayer=new w(l),this.throttler=new a}trigger(l,S){return this.delayer.trigger(()=>this.throttler.queue(l),S)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=m;class T{constructor(){this._isOpen=!1,this._promise=new Promise((l,S)=>{this._completePromise=l})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=T;class f extends T{constructor(l){super(),this._timeout=setTimeout(()=>this.open(),l)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function _(N,l){return l?new Promise((S,p)=>{const M=setTimeout(()=>{F.dispose(),S()},N),F=l.onCancellationRequested(()=>{clearTimeout(M),F.dispose(),p(new y.CancellationError)})}):o(S=>_(N,S))}e.timeout=_;function I(N,l=0,S){const p=setTimeout(()=>{N(),S&&M.dispose()},l),M=(0,L.toDisposable)(()=>{clearTimeout(p),S?.deleteAndLeak(M)});return S?.add(M),M}e.disposableTimeout=I;function c(N){const l=[];let S=0;const p=N.length;function M(){return S<p?N[S++]():null}function F(Y){Y!=null&&l.push(Y);const Z=M();return Z?Z.then(F):Promise.resolve(l)}return Promise.resolve(null).then(F)}e.sequence=c;function E(N,l=p=>!!p,S=null){let p=0;const M=N.length,F=()=>{if(p>=M)return Promise.resolve(S);const Y=N[p++];return Promise.resolve(Y()).then(X=>l(X)?Promise.resolve(X):F())};return F()}e.first=E;function R(N,l=p=>!!p,S=null){if(N.length===0)return Promise.resolve(S);let p=N.length;const M=()=>{p=-1;for(const F of N)F.cancel?.()};return new Promise((F,Y)=>{for(const Z of N)Z.then(X=>{--p>=0&&l(X)?(M(),F(X)):p===0&&F(S)}).catch(X=>{--p>=0&&(M(),Y(X))})})}e.firstParallel=R;class U{constructor(l){this._size=0,this.maxDegreeOfParalellism=l,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(l){return this._size++,new Promise((S,p)=>{this.outstandingPromises.push({factory:l,c:S,e:p}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const l=this.outstandingPromises.shift();this.runningPromises++;const S=l.factory();S.then(l.c,l.e),S.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=U;class O extends U{constructor(){super(1)}}e.Queue=O;class b{constructor(){this.sequentializer=new ee,this.tasks=0}queue(l){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,l())):this.sequentializer.run(this.tasks++,l())}}e.LimitedQueue=b;class z{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const l=new x;return this.drainers.add(l),l.p}isDrained(){for(const[,l]of this.queues)if(l.size>0)return!1;return!0}queueFor(l,S=r.extUri){const p=S.getComparisonKey(l);let M=this.queues.get(p);if(!M){M=new O;const F=this.drainListenerCount++,Y=k.Event.once(M.onDrained)(()=>{M?.dispose(),this.queues.delete(p),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(F),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new L.DisposableMap),this.drainListeners.set(F,Y),this.queues.set(p,M)}return M}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const l of this.drainers)l.complete();this.drainers.clear()}dispose(){for(const[,l]of this.queues)l.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=z;class V{constructor(l,S){this._token=-1,typeof l=="function"&&typeof S=="number"&&this.setIfNotSet(l,S)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(l,S){this.cancel(),this._token=setTimeout(()=>{this._token=-1,l()},S)}setIfNotSet(l,S){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,l()},S))}}e.TimeoutTimer=V;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(l,S){this.cancel(),this._token=setInterval(()=>{l()},S)}}e.IntervalTimer=$;class K{constructor(l,S){this.timeoutToken=-1,this.runner=l,this.timeout=S,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(l=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,l)}get delay(){return this.timeout}set delay(l){this.timeout=l}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=K;class G{constructor(l,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.runner=l,this.timeout=S,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(l=this.timeout){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(l/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class q extends K{constructor(l,S){super(l,S),this.units=[]}work(l){this.units.push(l),this.isScheduled()||this.schedule()}doRun(){const l=this.units;this.units=[],this.runner?.(l)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=q;class H extends L.Disposable{constructor(l,S){super(),this.options=l,this.handler=S,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(l){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+l.length>this.options.maxBufferedWork)return!1}else if(this.pending+l.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const S of l)this.pendingWork.push(S);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new K(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,h.setTimeout0)(()=>{if(l)return;const S=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let l=!1;return{dispose(){l||(l=!0)}}}:e.runWhenIdle=(N,l)=>{const S=requestIdleCallback(N,typeof l=="number"?{timeout:l}:void 0);let p=!1;return{dispose(){p||(p=!0,cancelIdleCallback(S))}}}}();class J{constructor(l){this._didRun=!1,this._executor=()=>{try{this._value=l()}catch(S){this._error=S}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=J;async function se(N,l,S){let p;for(let M=0;M<S;M++)try{return await N()}catch(F){p=F,await _(l)}throw p}e.retry=se;class ee{isRunning(l){return typeof l=="number"?this._running?.taskId===l:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(l,S,p){return this._running={taskId:l,cancel:()=>p?.(),promise:S},S.then(()=>this.doneRunning(l),()=>this.doneRunning(l)),S}doneRunning(l){this._running&&l===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const l=this._queued;this._queued=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this._queued)this._queued.run=l;else{let S,p;const M=new Promise((F,Y)=>{S=F,p=Y});this._queued={run:l,promise:M,promiseResolve:S,promiseReject:p}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ee;class ae{constructor(l,S=()=>Date.now()){this.interval=l,this.nowFn=S,this.lastIncrementTime=0,this.value=0}increment(){const l=this.nowFn();return l-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=l,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;var te;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(te||(te={}));class x{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((l,S)=>{this.completeCallback=l,this.errorCallback=S})}complete(l){return new Promise(S=>{this.completeCallback(l),this.outcome={outcome:0,value:l},S()})}error(l){return new Promise(S=>{this.errorCallback(l),this.outcome={outcome:1,value:l},S()})}cancel(){return this.error(new y.CancellationError)}}e.DeferredPromise=x;var ne;(function(N){async function l(p){let M;const F=await Promise.all(p.map(Y=>Y.then(Z=>Z,Z=>{M||(M=Z)})));if(typeof M<"u")throw M;return F}N.settled=l;function S(p){return new Promise(async(M,F)=>{try{await p(M,F)}catch(Y){F(Y)}})}N.withAsyncBody=S})(ne||(e.Promises=ne={}));var ie;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(ie||(ie={}));class Q{static fromArray(l){return new Q(S=>{S.emitMany(l)})}static fromPromise(l){return new Q(async S=>{S.emitMany(await l)})}static fromPromises(l){return new Q(async S=>{await Promise.all(l.map(async p=>S.emitOne(await p)))})}static merge(l){return new Q(async S=>{await Promise.all(l.map(async p=>{for await(const M of p)S.emitOne(M)}))})}static{this.EMPTY=Q.fromArray([])}constructor(l){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const S={emitOne:p=>this.emitOne(p),emitMany:p=>this.emitMany(p),reject:p=>this.reject(p)};try{await Promise.resolve(l(S)),this.resolve()}catch(p){this.reject(p)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(l<this._results.length)return{done:!1,value:this._results[l++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(l,S){return new Q(async p=>{for await(const M of l)p.emitOne(S(M))})}map(l){return Q.map(this,l)}static filter(l,S){return new Q(async p=>{for await(const M of l)S(M)&&p.emitOne(M)})}filter(l){return Q.filter(this,l)}static coalesce(l){return Q.filter(l,S=>!!S)}coalesce(){return Q.coalesce(this)}static async toPromise(l){const S=[];for await(const p of l)S.push(p);return S}toPromise(){return Q.toPromise(this)}emitOne(l){this._state===0&&(this._results.push(l),this._onStateChanged.fire())}emitMany(l){this._state===0&&(this._results=this._results.concat(l),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(l){this._state===0&&(this._state=2,this._error=l,this._onStateChanged.fire())}}e.AsyncIterableObject=Q;class re extends Q{constructor(l,S){super(S),this._source=l}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function oe(N){const l=new P.CancellationTokenSource,S=N(l.token);return new re(l,async p=>{const M=l.token.onCancellationRequested(()=>{M.dispose(),l.dispose(),p.reject(new y.CancellationError)});try{for await(const F of S){if(l.token.isCancellationRequested)return;p.emitOne(F)}M.dispose(),l.dispose()}catch(F){M.dispose(),l.dispose(),p.reject(F)}})}e.createCancelableAsyncIterable=oe;class ue{constructor(){this._deferred=new x,this._asyncIterable=new Q(p=>{if(l){p.reject(l);return}return S&&p.emitMany(S),this._errorFn=M=>p.reject(M),this._emitFn=M=>p.emitOne(M),this._deferred.p});let l,S;this._emitFn=p=>{S||(S=[]),S.push(p)},this._errorFn=p=>{l||(l=p)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(l){this._errorFn(l),this._deferred.complete()}emitOne(l){this._emitFn(l)}}e.AsyncIterableSource=ue}),define(W[20],j([0,1,34]),function(B,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(L){return this===L}};function y(L,r){return new P.TokenizationResult([new P.Token(0,"",L)],r)}e.nullTokenize=y;function k(L,r){const h=new Uint32Array(2);return h[0]=0,h[1]=(L<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new P.EncodedTokenizationResult(h,r===null?e.NullState:r)}e.nullTokenizeEncoded=k}),define(W[35],j([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(B,e,P,y,k,L,r,h,t,s,o,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var d;(function(w){w[w.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(d||(d={}));class n{constructor(m,T){this.tokenizationSupport=T,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new a(m)}getStartState(m){return this.store.getStartState(m,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=n;class i extends n{constructor(m,T,f,_){super(m,T),this._textModel=f,this._languageIdCodec=_}updateTokensUntilLine(m,T){const f=this._textModel.getLanguageId();for(;;){const _=this.getFirstInvalidLine();if(!_||_.lineNumber>T)break;const I=this._textModel.getLineContent(_.lineNumber),c=D(this._languageIdCodec,f,this.tokenizationSupport,I,!0,_.startState);m.add(_.lineNumber,c.tokens),this.store.setEndState(_.lineNumber,c.endState)}}getTokenTypeIfInsertingCharacter(m,T){const f=this.getStartState(m.lineNumber);if(!f)return 0;const _=this._textModel.getLanguageId(),I=this._textModel.getLineContent(m.lineNumber),c=I.substring(0,m.column-1)+T+I.substring(m.column-1),E=D(this._languageIdCodec,_,this.tokenizationSupport,c,!0,f),R=new g.LineTokens(E.tokens,c,this._languageIdCodec);if(R.getCount()===0)return 0;const U=R.findTokenIndexAtOffset(m.column-1);return R.getStandardTokenType(U)}tokenizeLineWithEdit(m,T,f){const _=m.lineNumber,I=m.column,c=this.getStartState(_);if(!c)return null;const E=this._textModel.getLineContent(_),R=E.substring(0,I-1)+f+E.substring(I-1+T),U=this._textModel.getLanguageIdAtPosition(_,0),O=D(this._languageIdCodec,U,this.tokenizationSupport,R,!0,c);return new g.LineTokens(O.tokens,R,this._languageIdCodec)}isCheapToTokenize(m){const T=this.store.getFirstInvalidEndStateLineNumberOrMax();return m<T||m===T&&this._textModel.getLineLength(m)<2048}tokenizeHeuristically(m,T,f){if(f<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(T<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(m,f),{heuristicTokens:!1};let _=this.guessStartState(T);const I=this._textModel.getLanguageId();for(let c=T;c<=f;c++){const E=this._textModel.getLineContent(c),R=D(this._languageIdCodec,I,this.tokenizationSupport,E,!0,_);m.add(c,R.tokens),_=R.endState}return{heuristicTokens:!0}}guessStartState(m){let T=this._textModel.getLineFirstNonWhitespaceColumn(m);const f=[];let _=null;for(let E=m-1;T>1&&E>=1;E--){const R=this._textModel.getLineFirstNonWhitespaceColumn(E);if(R!==0&&R<T&&(f.push(this._textModel.getLineContent(E)),T=R,_=this.getStartState(E),_))break}_||(_=this.tokenizationSupport.getInitialState()),f.reverse();const I=this._textModel.getLanguageId();let c=_;for(const E of f)c=D(this._languageIdCodec,I,this.tokenizationSupport,E,!1,c).endState;return c}}e.TokenizerWithStateStoreAndTextModel=i;class a{constructor(m){this.lineCount=m,this._tokenizationStateStore=new v,this._invalidEndStatesLineNumbers=new C,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,m+1))}getEndState(m){return this._tokenizationStateStore.getEndState(m)}setEndState(m,T){if(!T)throw new y.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(m);const f=this._tokenizationStateStore.setEndState(m,T);return f&&m<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(m+1,m+2)),f}acceptChange(m,T){this.lineCount+=T-m.length,this._tokenizationStateStore.acceptChange(m,T),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(m.startLineNumber,m.endLineNumberExclusive),T)}acceptChanges(m){for(const T of m){const[f]=(0,r.countEOL)(T.text);this.acceptChange(new h.LineRange(T.range.startLineNumber,T.range.endLineNumber+1),f+1)}}invalidateEndStateRange(m){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(m.startLineNumber,m.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(m,T){return m===1?T:this.getEndState(m-1)}getFirstInvalidLine(m){const T=this.getFirstInvalidEndStateLineNumber();if(T===null)return null;const f=this.getStartState(T,m);if(!f)throw new y.BugIndicatingError("Start state must be defined");return{lineNumber:T,startState:f}}}e.TrackingTokenizationStateStore=a;class v{constructor(){this._lineEndStates=new o.FixedArray(null)}getEndState(m){return this._lineEndStates.get(m)}setEndState(m,T){const f=this._lineEndStates.get(m);return f&&f.equals(T)?!1:(this._lineEndStates.set(m,T),!0)}acceptChange(m,T){let f=m.length;T>0&&f>0&&(f--,T--),this._lineEndStates.replace(m.startLineNumber,f,T)}acceptChanges(m){for(const T of m){const[f]=(0,r.countEOL)(T.text);this.acceptChange(new h.LineRange(T.range.startLineNumber,T.range.endLineNumber+1),f+1)}}}e.TokenizationStateStore=v;class C{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const m=this._ranges[0];return m.start+1===m.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(m.start+1,m.endExclusive),m.start}delete(m){const T=this._ranges.findIndex(f=>f.contains(m));if(T!==-1){const f=this._ranges[T];f.start===m?f.endExclusive===m+1?this._ranges.splice(T,1):this._ranges[T]=new t.OffsetRange(m+1,f.endExclusive):f.endExclusive===m+1?this._ranges[T]=new t.OffsetRange(f.start,m):this._ranges.splice(T,1,new t.OffsetRange(f.start,m),new t.OffsetRange(m+1,f.endExclusive))}}addRange(m){t.OffsetRange.addRange(m,this._ranges)}addRangeAndResize(m,T){let f=0;for(;!(f>=this._ranges.length||m.start<=this._ranges[f].endExclusive);)f++;let _=f;for(;!(_>=this._ranges.length||m.endExclusive<this._ranges[_].start);)_++;const I=T-m.length;for(let c=_;c<this._ranges.length;c++)this._ranges[c]=this._ranges[c].delta(I);if(f===_){const c=new t.OffsetRange(m.start,m.start+T);c.isEmpty||this._ranges.splice(f,0,c)}else{const c=Math.min(m.start,this._ranges[f].start),E=Math.max(m.endExclusive,this._ranges[_-1].endExclusive),R=new t.OffsetRange(c,E+I);R.isEmpty?this._ranges.splice(f,_-f):this._ranges.splice(f,_-f,R)}}toString(){return this._ranges.map(m=>m.toString()).join(" + ")}}e.RangePriorityQueueImpl=C;function D(w,m,T,f,_,I){let c=null;if(T)try{c=T.tokenizeEncoded(f,_,I.clone())}catch(E){(0,y.onUnexpectedError)(E)}return c||(c=(0,s.nullTokenizeEncoded)(w.encodeLanguageId(m),I)),g.LineTokens.convertToEndOffset(c.tokens,f.length),c}class A{constructor(m,T){this._tokenizerWithStateStore=m,this._backgroundTokenStore=T,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,P.runWhenIdle)(m=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(m)}))}_backgroundTokenizeWithDeadline(m){const T=Date.now()+m.timeRemaining(),f=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<T?(0,k.setTimeout0)(f):this._beginBackgroundTokenization())};f()}_backgroundTokenizeForAtLeast1ms(){const m=this._tokenizerWithStateStore._textModel.getLineCount(),T=new u.ContiguousMultilineTokensBuilder,f=L.StopWatch.create(!1);do if(f.elapsed()>1||this._tokenizeOneInvalidLine(T)>=m)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(T.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(m){const T=this._tokenizerWithStateStore?.getFirstInvalidLine();return T?(this._tokenizerWithStateStore.updateTokensUntilLine(m,T.lineNumber),T.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(m,T){this._tokenizerWithStateStore.store.invalidateEndStateRange(new h.LineRange(m,T))}}e.DefaultBackgroundTokenizer=A}),define(W[37],j([0,1,33,2,36,14,34]),function(B,e,P,y,k,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class h extends y.Disposable{constructor(s,o,u,g,d,n,i){super(),this._grammar=s,this._initialState=o,this._containsEmbeddedLanguages=u,this._createBackgroundTokenizer=g,this._backgroundTokenizerShouldOnlyVerifyTokens=d,this._reportTokenizationTime=n,this._reportSlowTokenization=i,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new P.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(s,o,u){throw new Error("Not supported!")}createBackgroundTokenizer(s,o){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(s,o)}tokenizeEncoded(s,o,u){const g=Math.random()*1e4<1,d=this._reportSlowTokenization||g,n=d?new k.StopWatch(!0):void 0,i=this._grammar.tokenizeLine2(s,u,500);if(d){const v=n.elapsed();(g||v>32)&&this._reportTokenizationTime(v,s.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${s.substring(0,100)}`),new r.EncodedTokenizationResult(i.tokens,u);if(this._containsEmbeddedLanguages){const v=this._seenLanguages,C=i.tokens;for(let D=0,A=C.length>>>1;D<A;D++){const w=C[(D<<1)+1],m=L.TokenMetadata.getLanguageId(w);v[m]||(v[m]=!0,this._onDidEncounterLanguage.fire(m))}}let a;return u.equals(i.ruleStack)?a=u:a=i.ruleStack,new r.EncodedTokenizationResult(i.tokens,a)}}e.TextMateTokenizationSupport=h}),define(W[38],j([0,1,20,2,11]),function(B,e,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class L extends y.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(h,t,s){super(),this._encodedLanguageId=h,this._actual=t,this._maxTokenizationLineLength=s,this._register((0,k.keepObserved)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(h,t,s){throw new Error("Not supported!")}tokenizeEncoded(h,t,s){return h.length>=this._maxTokenizationLineLength.get()?(0,P.nullTokenizeEncoded)(this._encodedLanguageId,s):this._actual.tokenizeEncoded(h,t,s)}createBackgroundTokenizer(h,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(h,t)}}e.TokenizationSupportWithLineLimit=L}),define(W[39],j([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(B,e,P,y,k,L,r,h,t,s,o,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class d extends h.MirrorTextModel{constructor(a,v,C,D,A,w,m,T){super(a,v,C,D),this._host=A,this._languageId=w,this._encodedLanguageId=m,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,k.observableValue)(this,-1),this._tokenizeDebouncer=new y.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(T,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(a,v){this._languageId=a,this._encodedLanguageId=v,this._resetTokenization()}onEvents(a){super.onEvents(a),this._tokenizerWithStateStore?.store.acceptChanges(a.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(a){this._maxTokenizationLineLength.set(a,void 0)}retokenize(a,v){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new r.LineRange(a,v)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const a=this._languageId,v=this._encodedLanguageId,C=await this._host.getOrCreateGrammar(a,v);if(!(this._isDisposed||a!==this._languageId||v!==this._encodedLanguageId||!C)){if(C.grammar){const D=new g.TokenizationSupportWithLineLimit(this._encodedLanguageId,new u.TextMateTokenizationSupport(C.grammar,C.initialState,!1,void 0,()=>!1,(A,w,m)=>{this._host.reportTokenizationTime(A,a,C.sourceExtensionId,w,m)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new t.TokenizerWithStateStore(this._lines.length,D)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:v}=await(0,P.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=v}const a=new Date().getTime();for(;;){let v=0;const C=new s.ContiguousMultilineTokensBuilder,D=new n;for(;;){const m=this._tokenizerWithStateStore.getFirstInvalidLine();if(m===null||v>200)break;v++;const T=this._lines[m.lineNumber-1],f=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(T,!0,m.startState);if(this._tokenizerWithStateStore.store.setEndState(m.lineNumber,f.endState)){const I=this._diffStateStacksRefEqFn(m.startState,f.endState);D.setState(m.lineNumber,I)}else D.setState(m.lineNumber,null);if(o.LineTokens.convertToEndOffset(f.tokens,T.length),C.add(m.lineNumber,f.tokens),new Date().getTime()-a>20)break}if(v===0)break;const A=D.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,C.serialize(),A),new Date().getTime()-a>20){(0,L.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=d;class n{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(a,v){a===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(v):this._stateDeltas.push({startLineNumber:a,stateDeltas:[v]}),this._lastStartLineNumber=a}getStateDeltas(){return this._stateDeltas}}}),define(W[40],j([0,1,18]),function(B,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class y{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(L){if(this._scopeNameToLanguageRegistration[L.scopeName]){const r=this._scopeNameToLanguageRegistration[L.scopeName];P.isEqual(r.location,L.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${L.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${L.location.toString()}`)}this._scopeNameToLanguageRegistration[L.scopeName]=L}getGrammarDefinition(L){return this._scopeNameToLanguageRegistration[L]||null}}e.TMScopeRegistry=y}),define(W[41],j([0,1,2,40]),function(B,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class k extends P.Disposable{constructor(r,h,t,s){super(),this._host=r,this._initialState=t.INITIAL,this._scopeRegistry=new y.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:s,loadGrammar:async o=>{const u=this._scopeRegistry.getGrammarDefinition(o);if(!u)return this._host.logTrace(`No grammar found for scope ${o}`),null;const g=u.location;try{const d=await this._host.readFile(g);return t.parseRawGrammar(d,g.path)}catch(d){return this._host.logError(`Unable to load and parse grammar for scope ${o} from ${g}`,d),null}},getInjections:o=>{const u=o.split(".");let g=[];for(let d=1;d<=u.length;d++){const n=u.slice(0,d).join(".");g=[...g,...this._injections[n]||[]]}return g}}));for(const o of h){if(this._scopeRegistry.register(o),o.injectTo){for(const u of o.injectTo){let g=this._injections[u];g||(this._injections[u]=g=[]),g.push(o.scopeName)}if(o.embeddedLanguages)for(const u of o.injectTo){let g=this._injectedEmbeddedLanguages[u];g||(this._injectedEmbeddedLanguages[u]=g=[]),g.push(o.embeddedLanguages)}}o.language&&this._languageToScope.set(o.language,o.scopeName)}}has(r){return this._languageToScope.has(r)}setTheme(r,h){this._grammarRegistry.setTheme(r,h)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(r,h){const t=this._languageToScope.get(r);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const s=this._scopeRegistry.getGrammarDefinition(t);if(!s)throw new Error(e.missingTMGrammarErrorMessage);const o=s.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const d=this._injectedEmbeddedLanguages[t];for(const n of d)for(const i of Object.keys(n))o[i]=n[i]}const u=Object.keys(o).length>0;let g;try{g=await this._grammarRegistry.loadGrammarWithConfiguration(t,h,{embeddedLanguages:o,tokenTypes:s.tokenTypes,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors})}catch(d){throw d.message&&d.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):d}return{languageId:r,grammar:g,initialState:this._initialState,containsEmbeddedLanguages:u,sourceExtensionId:s.sourceExtensionId}}}e.TMGrammarFactory=k}),define(W[49],j([0,1,8,41,39]),function(B,e,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function L(h,t){return new r(h,t)}e.create=L;class r{constructor(t,s){this._createData=s,this._models=new Map,this._grammarCache=[],this._host=t.host;const o=s.grammarDefinitions.map(u=>({location:P.URI.revive(u.location),language:u.language,scopeName:u.scopeName,embeddedLanguages:u.embeddedLanguages,tokenTypes:u.tokenTypes,injectTo:u.injectTo,balancedBracketSelectors:u.balancedBracketSelectors,unbalancedBracketSelectors:u.unbalancedBracketSelectors,sourceExtensionId:u.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(o)}async _loadTMGrammarFactory(t){const s=this._createData.textmateMainUri,o=await new Promise((i,a)=>{B([s],i,a)}),u=await new Promise((i,a)=>{B([this._createData.onigurumaMainUri],i,a)}),d=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await u.loadWASM(d);const n=Promise.resolve({createOnigScanner:i=>u.createOnigScanner(i),createOnigString:i=>u.createOnigString(i)});return new y.TMGrammarFactory({logTrace:i=>{},logError:(i,a)=>console.error(i,a),readFile:i=>this._host.readFile(i)},t,o,n)}acceptNewModel(t){const s=P.URI.revive(t.uri),o=this;this._models.set(t.controllerId,new k.TextMateWorkerTokenizer(s,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(u,g){const d=await o._grammarFactory;return d?(o._grammarCache[g]||(o._grammarCache[g]=d.createGrammar(u,g)),o._grammarCache[g]):Promise.resolve(null)},setTokensAndStates(u,g,d){o._host.setTokensAndStates(t.controllerId,u,g,d)},reportTokenizationTime(u,g,d,n,i){o._host.reportTokenizationTime(u,g,d,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,s){this._models.get(t).onEvents(s)}retokenize(t,s,o){this._models.get(t).retokenize(s,o)}acceptModelLanguageChanged(t,s,o){this._models.get(t).onLanguageId(s,o)}acceptRemovedModel(t){const s=this._models.get(t);s&&(s.dispose(),this._models.delete(t))}async acceptTheme(t,s){(await this._grammarFactory)?.setTheme(t,s)}acceptMaxTokenizationLineLength(t,s){this._models.get(t).acceptMaxTokenizationLineLength(s)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dd29bdcb71634f9cd7c1792bb2bdfde5b18ee8e8/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
